#==========================================
#
# 1. Atomic model --> EM map               
#    The model is a monomer. There are 6 monomers in EM map. 
#
# --------------------------------
$MR_TEST/molrep -m ../em/model.pdb -f ../em/pel.map -po out/ -ps scr/ -i <<stop
# --------------------------------
_NMON  6
stop
# --------------------------------
#
# 2. Atomic model --> EM map
#    by Spherically Averaged Phased Translation Function (SAPTF) + 
#       Phased Rotation Function (PRF) + Phased Translation Function (PTF)
#
# --------------------------------
$MR_TEST/molrep -m ../em/model.pdb -f ../em/pel.map -po out/ -ps scr/ -i <<stop
# --------------------------------
_NMON  6
_prf  y
stop
# --------------------------------
#
# 3. Atomic model --> EM map
#    by Spherically Averaged Phased Translation Function (SAPTF) + 
#       Phased Rotation Function (PRF) + Phased Translation Function (PTF)
#       using Non Cryst. Symmetry
#
# --------------------------------
$MR_TEST/molrep -m ../em/model.pdb -f ../em/pel.map -po out/ -ps scr/ -i <<stop
# --------------------------------
_NMON  6
_prf  y
_ncs  322
_centre  0.500 0.490 0.490
_angles  0.0 0.0 90.0  
stop
# --------------------------------
#
cp out/molrep.pdb hexamer.pdb
#
# --------------------------------
#
# 4. Rigid Body Refinement 
#    (with NCS constraints)                 
#    The starting model is hexamer.pdb
#    Information about NCS is stored in hexamer.pdb
#         
# --------------------------------
$MR_TEST/molrep -mx hexamer.pdb -f ../em/pel.map -po out/ -ps scr/ -i <<stop
# --------------------------------
_DOM s
stop
# --------------------------------
#
# 5. EM --> X-ray     
#
# --------------------------------
$MR_TEST/molrep -f ../em/p2.cif  -m ../em/pel.map -po out/ -ps scr/ -i <<stop
# --------------------------------
stop
# --------------------------------
#
# 6. Placing  the model to a particular orientation and position.
#    Operators are stored in ../em/tab; the operator giving the best score
#    will be selected.
#
# --------------------------------
$MR_TEST/molrep -f ../em/p2.cif  -m ../em/pel.map -po out/ -ps scr/ -i <<stop
# --------------------------------
_fun  s
_file_t ../em/tab
stop
#==========================================
