C
C     MOLREP molecular replacement program
C     Copyright (C) 1999-2006 Alexei Vagin
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C --- MOLREP ---
C ------------------------------------------------------------
C
C --- MEMORY - memory for densities, gradients, coordinates, ...
c      INTEGER MEMORY
c      PARAMETER ( MEMORY  = 96 000 000 )
cC-MEM-
cc      REAL      POOL(MEMORY)
cCv-MEM-
c       REAL, ALLOCATABLE :: POOL(:)
cC^-MEM-
cC --- NCRDMAX - maximal number of coordinates
c      INTEGER  NCRDMAX
c      PARAMETER ( NCRDMAX = 160000  )
C --- IPRSYM - maximal number of symmetry operators
      INTEGER IPRSYM
      PARAMETER ( IPRSYM=96    )
      INTEGER*2 ISYM(5,3,IPRSYM)
c
      INTEGER I,II,L1,L2,NARGC,ISTAT,LEN
c      INTEGER MEMORY_IN,NCRDMAX_IN,MEM
c      INTEGER IMEM
      CHARACTER TXT(2)*512
C
      CHARACTER FILE_SEQ*256,FILE_SEQ2*256,FILE_KEY*256
      CHARACTER FILE_F_IN*256,FILE_CRD_IN*256
      CHARACTER FILE_CRD_FX*256,FILE_CRD2_IN*256
      CHARACTER PATH_OUT*256,PATH_SCR*256
      CHARACTER VCCP4*1,KEY_DOC*1
c      CHARACTER MEMORY_TXT*256,NCRDMAX_TXT*256
      CHARACTER VERS*1
      CHARACTER KEY_INF*1,KEY_REST*1,KEY_ITER*1
      CHARACTER COMMAND_STRING*512
c ---------------------------------------------
      COMMAND_STRING = ' '
      KEY_DOC      = ' '
      KEY_INF      = ' '
      KEY_REST     = ' '
      KEY_ITER     = ' '
c      NCRDMAX_TXT  = ' '
c      MEMORY_TXT   = ' '
      FILE_KEY     = ' '
      FILE_SEQ     = ' '
      FILE_SEQ2    = ' '
      FILE_F_IN    = ' '
      FILE_CRD_IN  = ' '
      FILE_CRD_FX  = ' '
      FILE_CRD2_IN = ' '
      PATH_OUT     = ' '
      PATH_SCR     = ' '
      VCCP4        = 'N'
      VERS         = ' '
C -------
C molrep -f <file_sf_or_map> -m <model_crd_or_map> 
c        -mx <fixed model>   -m2 <model_2>  
C        -po <path_out>      -ps <path_scrath>
C        -s <file_sequence>  -s2 <file_sequence_for_m2>
C        -k <file_keywods>   -doc <y/a/n>
C        -h                  -mem <memory> -na <natom_max>
C  only info and clean   
C        -i                  -r 
C   interactive mode      rest some special files
C --------
      CALL GETARG(0,TXT(1))
      CALL LENSTR_BL(TXT(1),LCMD)
      COMMAND_STRING = TXT(1)(1:LCMD)
      
C
C      WRITE(*,'(A,A,A)') 'TXT0:',TXT(1)(1:50),';'
c      WRITE(*,'(A,I8)') 'IARG:',IARGC()
C
      IADD = 0
      II   = 0
      NARGC = IARGC()

      IF(NARGC.GT.0) THEN
        DO I=1,NARGC
          III = I + IADD
          II = MOD(III,2)
          IF(II.EQ.0) II = 2
          CALL GETARG(I,TXT(II))
          CALL LENSTR_BL(TXT(II),L)
          IF(II.EQ.1) L1 = L
          IF(II.EQ.2) L2 = L

c          WRITE(*,'(A,I3,i3,i3,i3)') 'i,ii,ii,iadd:',i,ii,ii,iadd    
c          WRITE(*,'(A,I3,A,A,A)') 'TXTii',II,':',TXT(II)(1:50),';'
          
          IF(II.EQ.2) THEN
            CALL LENSTR_BL(TXT(1),L1)
            CALL LENSTR_BL(TXT(2),L2)
            IF(     TXT(1)(1:L1).EQ.'HKLIN'.OR.
     *              TXT(1)(1:L1).EQ.'-f'      ) THEN
              FILE_F_IN = TXT(2)(1:L2)
              IF(TXT(1)(1:L1).EQ.'HKLIN') VCCP4 = 'Y'
              IF(TXT(1)(1:L1).EQ.'-f') VCCP4 = 'C'
            ELSE IF(TXT(1)(1:L1).EQ.'MAPIN') THEN
              FILE_F_IN = TXT(2)(1:L2)
              IF(TXT(1)(1:L1).EQ.'MAPIN') VCCP4 = 'Y'
            ELSE IF(TXT(1)(1:L1).EQ.'MODEL'.OR.
     *              TXT(1)(1:L1).EQ.'-m'      ) THEN
              FILE_CRD_IN = TXT(2)(1:L2)
              IF(TXT(1)(1:L1).EQ.'MODEL') VCCP4 = 'Y'
              IF(TXT(1)(1:L1).EQ.'-m') VCCP4 = 'C'
            ELSE IF(TXT(1)(1:L1).EQ.'MODEL2'.OR.
     *              TXT(1)(1:L1).EQ.'-mx'      ) THEN
              FILE_CRD_FX = TXT(2)(1:L2)
              IF(TXT(1)(1:L1).EQ.'MODEL2') VCCP4 = 'Y'
              IF(TXT(1)(1:L1).EQ.'-mx') VCCP4 = 'C'
            ELSE IF(TXT(1)(1:L1).EQ.'-m2') THEN
              FILE_CRD2_IN = TXT(2)(1:L2)
              VCCP4 = 'C'
            ELSE IF(TXT(1)(1:L1).EQ.'PATH_OUT'.OR.
     *              TXT(1)(1:L1).EQ.'-po'      ) THEN
              PATH_OUT = TXT(2)(1:L2)
            ELSE IF(TXT(1)(1:L1).EQ.'PATH_SCR'.OR.
     *              TXT(1)(1:L1).EQ.'-ps'      ) THEN
              PATH_SCR = TXT(2)(1:L2)
            ELSE IF(TXT(1)(1:L1).EQ.'-s'       ) THEN
              FILE_SEQ = TXT(2)(1:L2)
              VCCP4 = 'C'
            ELSE IF(TXT(1)(1:L1).EQ.'-s2'      ) THEN
              FILE_SEQ2 = TXT(2)(1:L2)
              VCCP4 = 'C'
c            ELSE IF(TXT(1)(1:L1).EQ.'-mem'     ) THEN
c              MEMORY_TXT = TXT(2)(1:L2)
c              VCCP4 = 'C'
c            ELSE IF(TXT(1)(1:L1).EQ.'-na'      ) THEN
c              NCRDMAX_TXT = TXT(2)(1:L2)
c              VCCP4 = 'C'
            ELSE IF(TXT(1)(1:L1).EQ.'-k'       ) THEN
              FILE_KEY = TXT(2)(1:L2)
              VCCP4 = 'C'
            ELSE IF(TXT(1)(1:L1).EQ.'-doc'     ) THEN
              KEY_DOC = TXT(2)(1:L2)
              VCCP4 = 'C'
            ELSE
              WRITE(*,*) 'input command line error: unknown keyword:'
     *                   //TXT(1)(1:L1)
                GO TO 1000
            ENDIF
            IF(TXT(2)(1:1).EQ.'-') THEN
              WRITE(*,*) 'input command line error: keyword:'
     *                   //TXT(1)(1:L1)//'  without parameter'
                GO TO 1000
            ENDIF
            IF(TXT(1)(1:L1).NE.'-k') THEN
              COMMAND_STRING = COMMAND_STRING(1:LCMD)//' '//
     *                       TXT(1)(1:L1)//' '//TXT(2)(1:L2)
              CALL LENSTR_BL(COMMAND_STRING,LCMD)
            ENDIF
          ELSE IF(TXT(1)(1:L1).EQ.'-i'       ) THEN
            KEY_ITER = 'Y'
            VCCP4 = 'C'
            IADD  = IADD + 1
            II    = 2
C            COMMAND_STRING = COMMAND_STRING(1:LCMD)//' '//
C     *                       TXT(1)(1:L1)
C            CALL LENSTR_BL(COMMAND_STRING,LCMD)
          ELSE IF(TXT(1)(1:L1).EQ.'-h'       ) THEN
            KEY_INF = 'Y'
            VCCP4 = 'C'
            IADD  = IADD + 1
            II    = 2
C            COMMAND_STRING = COMMAND_STRING(1:LCMD)//' '//
C     *                       TXT(1)(1:L1)
C            CALL LENSTR_BL(COMMAND_STRING,LCMD)
          ELSE IF(TXT(1)(1:L1).EQ.'-r'       ) THEN
            KEY_REST = 'Y'
            VCCP4 = 'C'
            IADD  = IADD + 1
            II    = 2
            COMMAND_STRING = COMMAND_STRING(1:LCMD)//' '//
     *                       TXT(1)(1:L1)
            CALL LENSTR_BL(COMMAND_STRING,LCMD)
          ENDIF
        ENDDO
        IF(II.EQ.1.AND.NARGC.GT.1) THEN
          WRITE(*,*) ' wrong input command line'
          GO TO 1000
        ENDIF
      ENDIF

      COMMAND_STRING = COMMAND_STRING(1:LCMD)//' -i'
      CALL LENSTR_BL(COMMAND_STRING,LCMD)

C      WRITE(*,*) '>',COMMAND_STRING(1:LCMD),';'
c      CALL LENSTR_BL(FILE_F_IN,L1)
c      IF(L1.GT.0) WRITE(*,*) 'FILE_F_IN    :',FILE_F_IN(1:L1)
c      CALL LENSTR_BL(FILE_CRD_IN,L1)
c      IF(L1.GT.0) WRITE(*,*) 'FILE_CRD_IN  :',FILE_CRD_IN(1:L1)
c      CALL LENSTR_BL(PATH_OUT,L1)
c      IF(L1.GT.0) WRITE(*,*) 'PATH_OUT     :',PATH_OUT(1:L1)
c      CALL LENSTR_BL(PATH_SCR,L1)
c      IF(L1.GT.0) WRITE(*,*) 'PATH_SCR     :',PATH_SCR(1:L1)

c      CALL LENSTR_BL(NCRDMAX_TXT,LEN)
c      IF(LEN.GT.0) THEN
c        READ(NCRDMAX_TXT(1:LEN),*) NCRDMAX_IN
c        NCRDMAX_IN = NCRDMAX_IN*8
c      ELSE
c        NCRDMAX_IN = NCRDMAX
c      ENDIF

c      IMEM = 0
c      CALL LENSTR_BL(MEMORY_TXT,LEN)
c      IF(LEN.GT.0) THEN
c        READ(MEMORY_TXT(1:LEN),*) MEM
c        MEMORY_IN = MEM * 1 000 000
c        IMEM = 1
c      ELSE
c        MEMORY_IN = MEMORY
c        MEM = MEMORY_IN/1 000 000
c      ENDIF

c      ISTAT = 0
Cv-MEM-
       VERS = 'M'
c      IF(.NOT.ALLOCATED(POOL)) ALLOCATE(POOL(MEMORY_IN),STAT=ISTAT)
C^-MEM-
c      IF(ISTAT.NE.0) THEN
c        WRITE(*,*) 'ERROR: in memory allocation'
c        WRITE(*,*) '       memory :',MEM,'Mb  not available'
c        WRITE(*,*) '       use option -mem N , where N memory in Mb'
c        STOP
c      ENDIF
c      IF(VERS.EQ.' '.AND.IMEM.NE.0) THEN
c        WRITE(*,*) 'WARNING: this option (-mem) for fortran f90 only'
c        MEMORY_IN = MEMORY
c      ENDIF
C ---
      CALL MAIN_MOLREP(IPRSYM,ISYM
     *   ,COMMAND_STRING,FILE_CRD_FX,FILE_CRD2_IN
     *   ,FILE_SEQ,FILE_SEQ2,FILE_KEY
     *   ,KEY_DOC,KEY_INF,KEY_REST,KEY_ITER,VERS
     *   ,FILE_F_IN,FILE_CRD_IN,PATH_OUT,PATH_SCR,VCCP4)
Cv-MEM-
c      DEALLOCATE(POOL)
C^-MEM-
C ---
 1000 CONTINUE
      END

      SUBROUTINE MAIN_MOLREP(IPRSYM,ISYM
     *   ,COMMAND_STRING,FILE_CRD_FX,FILE_CRD2_IN
     *   ,FILE_SEQ ,FILE_SEQ2,FILE_KEY_IN
     *   ,KEY_DOC,KEY_INF,KEY_REST,KEY_ITER,VERS
     *   ,FILE_F_IN,FILE_CRD_IN,PATH_OUT,PATH_SCR,VCCP4)
C ------------------------------------------------------------
c      INTEGER   MEMORY
c      REAL      POOL(MEMORY)
c      INTEGER   NCRDMAX
      INTEGER   IPRSYM
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER FILE_F_IN*(*),FILE_CRD_IN*(*),COMMAND_STRING*(*)
      CHARACTER FILE_CRD_FX*(*),FILE_CRD2_IN*(*)
      CHARACTER PATH_OUT*(*),PATH_SCR*(*),VCCP4*1
      CHARACTER FILE_SEQ*(*),FILE_KEY_IN*(*),KEY_DOC*1,KEY_INF*1
      CHARACTER FILE_SEQ2*(*),KEY_REST*1,KEY_ITER*1,VERS*1
C ----
      CHARACTER NAMEF*256, NAMEM*256,    NAME2*256,NAME_SEQ*256
      CHARACTER NAMEM2*256,NAME_TAB2*256,NAME*256, NAME_TSRF*256
      CHARACTER NAMEPH*256,NAME_TAB*256,NAME_DER*256,FILE_KEY*256
      CHARACTER NAME_SEQ2*256
C     CHARACTER PATH_SCR*256,PATH_OUT*256
      CHARACTER NAMEW*256

      CHARACTER LINE*256,MODE*1,MSG*1,ANISO*1,PACK*1,MTZ*1,FUN*1,LIST*1
      CHARACTER PST*1,SURF*1,TEST*1,INVER*1,PRF*1,PROG*80
      CHARACTER DIFF*1,DYAD*1,STICK*1,LOCK*1,INVER1*1,CCP4*1,ALL*1
      CHARACTER PHASE*1,DOM*1,LINE_CCP4*600,DER*1,P1*1,SEQ*1
      CHARACTER LH*1,DB*1,SCORE_FLAG*1,P1_KEY*1,SPGR_INP*24
      CHARACTER FULL*1,SURFX*1,LAP*1,CHECK_SOL*1,SELF*1
      CHARACTER MOLREP_PARAM*40
      INTEGER   IMOLREP_PARAM(40)
      REAL      RMOLREP_PARAM(40)
      REAL      ANGLES(3),TVECTOR(3),CVECTOR(3)
C ------------------------------------------------------
      CHARACTER LABEL(20)*30
      CHARACTER DEFAULT_F*30,DEFAULT_SIGF*30
      CHARACTER PATH_SCR_KEYWORD*256
C ---
      INCLUDE 'molrep_version.fh'
C --------------------------------------------------------------------
C =============================================================
C-CCP4 
      IF(VCCP4.EQ.'Y') THEN

C---- Initialize ccp4 like file organization
C      CALL CCPFYP
C      ISYSW = 6
C      CALL CCPRCS(ISYSW,'MOLREP(ccp4)'//VERSNO,
C     + '$Date: 2002/01/25 13:29:23 $')
C      WRITE (ISYSW, 6000)
C6000  FORMAT (  
C     +' $TEXT:Reference1: $$ comment $$ '/2x,
C     +' MOLREP: an automated program for molecular replacement'/2x,
C     +' A.Vagin,A.Teplyakov.'/2x,
C     +' J. Appl. Cryst. (1997) 30, 1022-1025.',//,' $$',/,
C     +' $SUMMARY :Reference1:  $$ MOLREP: $$'/
C     +' :TEXT:Reference1: $$'/)

        CALL MOLREP_INIT_CCP4
      ENDIF
C-CCP4 

      CALL MOLREP_CCP4_VERSION_CORRECTION(CCP4)

      M    = 0
c      PROG = 'molrep'
      CALL START(0,M,COMMAND_STRING,PATH_OUT)
C ---------------------------
      LINE = '   +-----------------------------------------+'
      CALL MSGDOC(M,LINE)
      LINE = '   |                                         |'
      CALL MSGDOC(M,LINE)
      LINE = '   |             --- MOLREP ---              |'    
      CALL MSGDOC(M,LINE)
      LINE = VERSION(16:42)
      CALL LENSTR_BL(LINE,LEN)
      LINE = '   |      '//LINE(1:LEN)//'        |'
      CALL MSGDOC(M,LINE)
      LINE = '   |                                         |'
      CALL MSGDOC(M,LINE)
      LINE = '   +-----------------------------------------+'
      CALL MSGDOC(M,LINE)
C -------------------------------------------------------------
      IF(VCCP4.EQ.'C'.AND.KEY_INF.NE.'Y') THEN
        CALL MSGDOC(M,' ')
        LINE =
     *'+------------------------------------------------------------+'
        CALL MSGDOC(M,LINE)
        LINE =
     *'|                                                            |'
        CALL MSGDOC(M,LINE)
        LINE =
     *'| You can use program by command string with options:        |'
        CALL MSGDOC(M,LINE)
        LINE =
     *'|                                                            |'
        CALL MSGDOC(M,LINE)
        LINE =
     *'|  molrep -f <file_sf_or_map> -m <model_crd_or_map>          |' 
        CALL MSGDOC(M,LINE)
        LINE =
     *'|         -mx <fixed model>   -m2 <model_2>                  |'
        CALL MSGDOC(M,LINE)
        LINE =
     *'|         -po <path_out>      -ps <path_scrath>              |'
        CALL MSGDOC(M,LINE)
        LINE =
     *'|         -s <file_sequence>  -s2 <file_seq_for_m2>          |'
        CALL MSGDOC(M,LINE)
        LINE =
     *'|         -k <file_keywords>  -doc <y/a/n>                   |'
        CALL MSGDOC(M,LINE)
        LINE =
     *'|        -h     -i     -r                                    |'
        CALL MSGDOC(M,LINE)
        LINE =
     *'|          h = only keyword and mtz label information, clean |'
        CALL MSGDOC(M,LINE)
        LINE =
     *'|          i = interactive mode                              |'
        CALL MSGDOC(M,LINE)
        LINE =
     *'|          r = rest some special files                       |'
        CALL MSGDOC(M,LINE)
        LINE =
     *'|          file_keywords = simple text file with keywords    |'
        CALL MSGDOC(M,LINE)
        LINE =
     *'|                          (one line - one keyword)          |'
        CALL MSGDOC(M,LINE)
        LINE =
     *'|                                                            |'
        CALL MSGDOC(M,LINE)
        LINE =
     *'|  use  "molrep -h" to get short manual                      |' 
        CALL MSGDOC(M,LINE)
        LINE =
     *'|                                                            |'
        CALL MSGDOC(M,LINE)
        LINE =
     *'+------------------------------------------------------------+'
        CALL MSGDOC(M,LINE)
        CALL MSGDOC(M,' ')
      ENDIF

      IF(VCCP4.NE.'Y') THEN
      IF(VCCP4.NE.'C'.AND.KEY_INF.NE.'Y') THEN
        CALL MSGDOC(M,
     *  ' Do you want to have FILE-DOCUMENT /molrep.doc/ ? /N/<Y>/A :')
        CALL MSGDOC(M,'   N - means without DOC-file')
        CALL MSGDOC(M,'   Y - with new contents')
        CALL MSGDOC(M,
     * '   A - means to keep old contents and add new information')
        CALL MSGDOC(M,
     * '       with DOC-file program creates batch file: molrep.btc')
        CALL DISPL_BL('_DOC:')
      ENDIF
      ENDIF
C ---
      IF(VCCP4.EQ.'C') THEN
        LINE = '_DOC Y'
        IF(KEY_DOC.EQ.'A'.OR.KEY_DOC.EQ.'a') LINE = '_DOC A'      
        IF(KEY_DOC.EQ.'N'.OR.KEY_DOC.EQ.'n') LINE = '_DOC N'     
        GO TO 1110 
      ENDIF
 1120 CONTINUE
      READ(*,'(A)',END=1100) LINE
      GO TO 1110
 1100 CONTINUE
      LINE = '_DOC Y'
 1110 CONTINUE
      IF(LINE(1:1).EQ.'#') GO TO 1120

      IBATCH   = 0
      MSG      = ' '
      LLL      = 0
      IF(LINE(1:4).EQ.'_DOC'.OR.LINE(1:4).EQ.'_doc'.OR.
     *   LINE(1:3).EQ.'DOC' .OR.LINE(1:3).EQ.'doc') THEN
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GE.6) THEN
          DO I=6,LEN
            IF(LINE(I:I).NE.' ') THEN
              MSG = LINE(I:I)
              LLL = I
              GO TO 10
            ENDIF
          ENDDO
        ENDIF
  10    CONTINUE
        IF(KEY_ITER.NE.'Y') IBATCH = 1
        IF(VCCP4.EQ.'Y') IBATCH = 1
      ELSE
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GT.0) THEN
          DO I=1,LEN
            IF(LINE(I:I).NE.' ') THEN
              LLL = I
              MSG = LINE(I:I)
              GO TO 20
            ENDIF
          ENDDO
        ENDIF
  20    CONTINUE
      ENDIF

      IF(LLL.GT.0) THEN
        LINE = LINE(LLL:LEN)
        LEN  = LEN - LLL + 1
        IF(LINE(1:1).NE.'>'.AND.LEN.GT.1) THEN
          LINE = LINE(2:LEN)
          LEN = LEN - 1
        ENDIF
        CALL GET_PATH_OUT(LINE,PATH_OUT)
      ENDIF

      IF(MSG.EQ.'y') MSG='Y'
      IF(MSG.EQ.'n') MSG='N'
      IF(MSG.EQ.'a') MSG='A'
      IF(MSG.NE.'N'.AND.MSG.NE.'A'.AND.MSG.NE.'#') MSG='Y'

      IF(MSG.NE.'N'.OR.MSG.EQ.'#') THEN
        IF(MSG.EQ.'Y') MDOC=999
        IF(MSG.EQ.'A') MDOC=998
        IF(MSG.EQ.'#') MDOC=997
        CALL START(0,MDOC,COMMAND_STRING,PATH_OUT)
      ELSE
        MDOC=0
      ENDIF
      IF(IBATCH.EQ.1) CALL SET_BATCH(IBATCH)
      CALL MSGDOC(M,' ')
C =============================================================
 100  CONTINUE
      IERR    = 0
      MD      = 0
      M       = 99
      RESOL_D = 0.0
      RMAX    = 0.0
      RMAXM   = 0.0
      MTZ     = 'N'
C     CCP4    = 'N'
      PHASE   = 'N'
      DEFAULT_F     = ' '
      DEFAULT_SIGF  = ' '
      IDEFAULT_F    = 0
      IDEFAULT_SIGF = 0
      LINE_CCP4 = ' '
      DER       = 'N'
      DO I=1,20
        LABEL(I)=' '
      ENDDO
C ---
      CALL CORR_NAME_ALL(FILE_F_IN)
      CALL LENSTR_BL(FILE_F_IN,LEN)
      IF(LEN.GT.0) THEN

        CALL CHECK_SF_FILE(MDOC,FILE_F_IN,LINE,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MD,'ERROR: check SF_file')
C          IERR_XML     = IERR
          GO TO 900
        ENDIF

        IF(LEN.GT.4.AND.FILE_F_IN(LEN-3:LEN).EQ.'.mtz') THEN
C         MTZ file 
C ---
          IF(CCP4.NE.'Y') GO TO 910
          MTZ = 'Y'
          CALL GET_DEFAULT_LABEL(MDOC,FILE_F_IN
     *       ,IDEFAULT_F,DEFAULT_F,DEFAULT_SIGF,IDEFAULT_SIGF,IERR)
          IF(IERR.NE.0) GO TO 900
C ---
        ENDIF
      ENDIF
C ---
      IF(VCCP4.EQ.'C') THEN
        IF(KEY_ITER.NE.'Y') THEN
          CALL SET_VCCP4_TO_COMASK(VCCP4,FILE_KEY_IN,KEY_INF)
        ELSE
          CALL SET_VCCP4_TO_COMASK('I',FILE_KEY_IN,KEY_INF)
        ENDIF
      ELSE IF(VCCP4.EQ.'Y') THEN
        CALL SET_VCCP4_TO_COMASK(VCCP4,FILE_KEY_IN,KEY_INF)
      ELSE IF(VCCP4.EQ.'N') THEN
        CALL SET_VCCP4_TO_COMASK(VCCP4,FILE_KEY_IN,KEY_INF)
       ENDIF
C ---
c     for MOLREP_CLEAN
C IDELETE = 0 not delete,i.e. rest LIST = 'L'
C         = 1 delete,i.e. set LIST = 'S'
      IDELETE = 0
      IF(VCCP4.EQ.'Y') IDELETE = 1      
      IF(VCCP4.EQ.'C'.AND.KEY_REST.NE.'Y') IDELETE = 1  

      INCLUDE 'molrep_keywords.fh'

      CALL MSGDOC(MD,' ')
C ---
      CALL LENSTR_BL(FILE_KEY_IN,LEN)
      IF(LEN.GT.0) THEN
        FILE_KEY = FILE_KEY_IN
      ENDIF
      CALL LENSTR_BL(FILE_SEQ,LEN)
      IF(LEN.GT.0) THEN
        NAME_SEQ = FILE_SEQ
      ENDIF
      CALL LENSTR_BL(FILE_F_IN,LEN)
      IF(LEN.GT.0) THEN
        NAMEF = FILE_F_IN
      ENDIF
      LINE = NAMEF
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.1.OR.LINE(1:1).EQ.','.OR.LINE(1:1).EQ.' ') THEN
        NAMEF = ' '
      ELSE
        NAMEF=LINE
        CALL CORR_NAME_ALL(NAMEF)
        CALL CLEAR_LINE(NAMEF)
        NAMEF=LINE

        CALL CHECK_SF_FILE(MDOC,NAMEF,LINE,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: check SF_file')
C          IERR_XML     = IERR
          GO TO 900
        ENDIF

        LINE = NAMEF

        CALL LENSTR_BL(LINE,LENC)
        LLLC = LENC
        IF(LLLC.LT.4) LLLC = 4
        LLLLC = LENC
        IF(LLLLC.LT.5) LLLC = 5
        IF(LENC.GT.4.AND.LINE(LLLC-3:LLLC).EQ.'.mtz') THEN
C-CCP4 
C ---
          IF(CCP4.NE.'Y') GO TO 910

          IF(MTZ.EQ.'Y') THEN
          ELSE
            CALL GET_DEFAULT_LABEL(MDOC,LINE
     *       ,IDEFAULT_F,DEFAULT_F,DEFAULT_SIGF,IDEFAULT_SIGF,IERR)
            IF(IERR.NE.0) GO TO 900
C ---
            MTZ = 'Y'
          ENDIF
          IF(IDEFAULT_F.EQ.1.AND.LABEL(1)(1:1).EQ.',') THEN
            LABEL(1) = DEFAULT_F
          ENDIF
          IF(IDEFAULT_SIGF.EQ.1.AND.LABEL(2)(1:1).EQ.',') THEN
            LABEL(2) = DEFAULT_SIGF
          ENDIF
          IF(IDEFAULT_F.EQ.2.AND.LABEL(7)(1:1).EQ.',') THEN
            LABEL(7) = DEFAULT_F
          ENDIF
          IF(IDEFAULT_SIGF.EQ.1.AND.LABEL(8)(1:1).EQ.','.AND.
     *       IDEFAULT_F.EQ.2                         ) THEN
            LABEL(8) = DEFAULT_SIGF
          ENDIF

          IF(KEY_INF.NE.'Y') THEN
            NAMEF='molrep_mtz.cif'
            CALL ADD_PATH(PATH_OUT,NAMEF)
            CALL MTZ_TO_CIF(MDOC,LINE,LINE_CCP4,LABEL
     *                    ,NAMEF,PHASE,DER,IERR)
            IF(IERR.NE.0) GO TO 900
          ENDIF
          MTZ='Y'
          MOLREP_PARAM(21:21) = PHASE
C-CCP4 
        ELSE IF((LENC.GT.5.AND.LINE(LLLLC-4:LLLLC).EQ.'.ccp4').OR.
     *          (LENC.GT.4.AND.LINE(LLLLC-3:LLLLC).EQ.'.map' )) THEN
C-CCP4 
          MTZ='Y'
          P1   = 'N'
          RMAX = 0.0
c          MEM2 = MEMORY/2
          NAMEW = 'molrep_dns'
          CALL ADD_PATH(PATH_OUT,NAMEW)

          IF(CCP4.NE.'Y') GO TO 910

C         IF(VCCP4.NE.'Y') CALL MOLREP_CCPFYP 

          IF(KEY_INF.NE.'Y') THEN
            CALL CCP42DNS(MDOC,NAMEF,NAMEW,RMAX,RESOL_D,P1
     *      ,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900
            MTZ='D'
            CALL LENSTR_BL(NAMEW,LEN)
            NAMEF = NAMEW(1:LEN)//'.dat'
          ENDIF
C-CCP4 
        ELSE

        ENDIF
      ENDIF
C ----
      CALL LENSTR_BL(FILE_CRD_IN,LEN)
      IF(LEN.GT.0) THEN
        NAMEM = FILE_CRD_IN
      ENDIF
      LINE = NAMEM
      CALL LENSTR_BL(LINE,LEN)

      IF(LEN.LT.1.OR.LINE(1:1).EQ.','.OR.LINE(1:1).EQ.' ') THEN

c        CALL MSGERR(MD,' ERROR: WRONG NAME OF INPUT_FILE_M.')
c        IERR=0
c        GO TO 200

        LINE  = ' '
        LEN   = 1
        NAMEM = ' '
      ELSE

        NAMEM=LINE
        CALL CLEAR_LINE(NAMEM)
        CALL CORR_NAME_ALL(NAMEM)

        CALL CHECK_COORD_FILE(MDOC,NAMEM,LINE,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: check model_coord_file')
C          IERR_XML     = IERR
          GO TO 900
        ENDIF

        LINE = NAMEM
        CALL LENSTR_BL(LINE,LENC)
        LLLC = LENC
        IF(LLLC.LT.5) LLLC = 5
        IF((LENC.GT.5.AND.LINE(LLLC-4:LLLC).EQ.'.ccp4').OR.
     *     (LENC.GT.4.AND.LINE(LLLC-3:LLLC).EQ.'.map' )) THEN
C-CCP4 
          IF(CCP4.NE.'Y') GO TO 910

          MTZ='Y'
          P1    = 'Y'
          RMAXM = 0.0
c          MEM2 = MEMORY/2
          NAMEW = 'molrep_dns_mod'
          CALL ADD_PATH(PATH_OUT,NAMEW)

          IF(MTZ.EQ.'N'.AND.VCCP4.NE.'Y') THEN
            CALL MOLREP_CCPFYP 
          ENDIF

          IF(KEY_INF.NE.'Y') THEN
            CALL CCP42DNS(MDOC,NAMEM,NAMEW,RMAXM,RESOL,P1
     *      ,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900
            CCP4 = 'Y'
            CALL LENSTR_BL(NAMEW,LEN)
            NAMEM = NAMEW(1:LEN)//'.dat'
          ENDIF
C-CCP4 
        ELSE
          NAMEM=LINE(1:LEN)
        ENDIF

      ENDIF
C -------------
      CALL LENSTR_BL(PATH_SCR,LEN)
      IF(LEN.LE.0) THEN
        PATH_SCR = PATH_SCR_KEYWORD
      ENDIF
      CALL LENSTR_BL(FILE_CRD_FX,LEN)
      IF(LEN.GT.0) THEN
C       LINE='MODEL_2'
        NAME2 = FILE_CRD_FX
      ENDIF
      CALL LENSTR_BL(FILE_CRD2_IN,LEN)
      IF(LEN.GT.0) THEN
C       LINE='FILE_M2'
        NAMEM2 = FILE_CRD2_IN
      ENDIF
C -------------
C
C     is it CCP4 version of molrep ?
      IF(CCP4.EQ.'P') CCP4 = 'N'

      MOLREP_PARAM(22:22) = CCP4
c
      IF(DER.EQ.'Y') NAME_DER = NAMEF      
c ----
      CALL CORR_NAME_BL(PATH_SCR)
c ----
      NAME='molrep_stop_signal.xml'
      CALL DELETE_FILE(PATH_SCR,NAME)
C ---------------
      MOLREP_PARAM(20:20) = MTZ
C-CCP4 
      IF(VCCP4.EQ.'Y') THEN
        MOLREP_PARAM(20:20) = VCCP4
        CALL MOLREP_CCP4_UGTENV(FILE_F_IN,FILE_F_IN
     *        ,FILE_CRD_IN,FILE_CRD_FX,PATH_OUT,PATH_SCR)
      ENDIF
C-CCP4 

      IF(KEY_INF.EQ.'Y') THEN
        CALL MSGDOC(MDOC,
     * '  --- This is only information mode ---')        
        GO TO 900
      ENDIF

C -------------
      CALL LENSTR_BL(FILE_SEQ2,LEN)
      IF(LEN.GT.0) THEN
        NAME_SEQ2 = FILE_SEQ2
      ENDIF
C -------------
      CALL MOLREP(MDOC,NAMEF,NAMEM,NAME_DER,NAMEPH,NAME2,NAME_TAB
     * ,NAME_SEQ,NAME_SEQ2,NAMEM2,NAME_TAB2,NAME_TSRF
     * ,MOLREP_PARAM,IMOLREP_PARAM,RMOLREP_PARAM
     * ,ANGLES,CVECTOR,TVECTOR,SPGR_INP,PATH_SCR,PATH_OUT
     * ,ISYM,IPRSYM,IERR)
C -------------
      GO TO 900
  910 CONTINUE
      IF(CCP4.EQ.'P') THEN
        CALL MSGERR(MDOC,
     *  'ERROR: it is not CCP4 version of program,')
        CALL MSGERR(MDOC,
     *  '       please, setup CCP4 and recompile program')
      ELSE
        CALL MSGERR(MD,
     *  'ERROR: Probably you forgot setup CCP4')
      ENDIF
      GO TO 920
  900 CONTINUE

      IF(LIST.EQ.'l') LIST='L'
      IF(LIST.EQ.'t') LIST='T'
      IF(LIST.NE.'L'.AND.LIST.NE.'T') LIST='S'
      IF(LIST.EQ.'S'.OR.LIST.EQ.'s') THEN
        NAME='molrep_mtz.cif'
        CALL DELETE_FILE(PATH_SCR,NAME)
      ENDIF
      IF(KEY_INF.EQ.'Y') THEN
        LIST = 'S'
        CALL MOLREP_CLEAN(LIST,PATH_SCR,PATH_OUT)
        I1 = 100
        I2 =  24
        CALL TRF_MULTI_CLEAN(I1,I1,I2,PATH_SCR)
      ENDIF

  920 CONTINUE

      NAME='molrep_stop_signal.xml'
      CALL DELETE_FILE(PATH_SCR,NAME)

      IF(VCCP4.EQ.'Y') THEN
        CALL FINISH_CCP4(IERR)
      ELSE
        CALL FINISH
      ENDIF

      END

C ======================================================================
C ======================================================================

      SUBROUTINE MOLREP_CCP4_VERSION_CORRECTION(CHAR)
      CHARACTER CHAR*1,NAME*80,LINE*256
C --------------------------
      NAME = 'CLIB'

      CALL UGTENV(NAME,LINE)
      CALL LENSTR_BL(LINE,LEN)

      IF(LEN.LE.0) THEN
        CHAR = 'N'
      ELSE
        IF(LEN.EQ.6.AND.LINE(1:6).EQ.'NOCCP4') THEN
          CHAR = 'P'
        ELSE
          CHAR = 'Y'
        ENDIF
      ENDIF
      RETURN
      END    

C     CCP4 routines

      SUBROUTINE MOLREP_CCP4_UGTENV(FILE_MTZ,FILE_MAP
     *    ,FILE_PDB,FILE_PDB2,PATH_OUT,PATH_SCR)
C ----------------------------
      CHARACTER FILE_MTZ*(*),FILE_MAP*(*),FILE_PDB*(*)
      CHARACTER FILE_PDB2*(*),PATH_OUT*(*),PATH_SCR*(*)
C ----------------------------
      CALL UGTENV('MODEL',FILE_PDB)
      CALL UGTENV('HKLIN',FILE_MTZ)
      CALL UGTENV('MAPIN',FILE_MAP)
      CALL UGTENV('MODEL2',FILE_PDB2)
      CALL UGTENV('PATH_OUT',PATH_OUT)
      CALL UGTENV('PATH_SCR',PATH_SCR)
      CALL LENSTR_BL(PATH_SCR,LEN)
      IF(LEN.LE.0) THEN
        CALL UGTENV('TEMP1',PATH_SCR)
        CALL LENSTR_BL(PATH_SCR,LEN)
        IF(LEN.LE.0) THEN
          CALL UGTENV('CCP4_SCR',PATH_SCR)
        ENDIF
      ELSE
        IF(PATH_SCR(1:1).EQ.'.') PATH_SCR = ' '
      ENDIF
      RETURN
      END

      SUBROUTINE MOLREP_CCPFYP 
C -
      CALL CCPFYP
C -
      RETURN
      END 

      SUBROUTINE MOLREP_INIT_CCP4
C --------------------------------------------------------------------
C ---
      INCLUDE 'molrep_version.fh'
C --------------------------------------------------------------------
C---- Initialize ccp4 like file organization
      CALL CCPFYP
      ISYSW = 6
c     CALL CCPRCS(ISYSW,'MOLREP(ccp4)'//VERSNO,
      call ccp4_prog_version(versno,0)
      CALL CCPRCS(ISYSW,'MOLREP(ccp4)',
     + '$Date: 2002/01/25 13:29:23 $')
      WRITE (ISYSW, 6000)
6000  FORMAT (  
     +' $TEXT:Reference1: $$ comment $$ '/2x,
     +' MOLREP: an automated program for molecular replacement'/2x,
     +' A.Vagin,A.Teplyakov.'/2x,
     +' J. Appl. Cryst. (1997) 30, 1022-1025.',//,' $$',/,
     +' $SUMMARY :Reference1:  $$ MOLREP: $$'/
     +' :TEXT:Reference1: $$'/)
      RETURN
      END

      SUBROUTINE GET_DEFAULT_LABEL(MDOC,FILE_CIF
     *   ,IDEFAULT_F,DEFAULT_F,DEFAULT_SIGF,IDEFAULT_SIGF,IERR)
C ------------------------------------------
      CHARACTER FILE_CIF*(*)
      CHARACTER DEFAULT_F*(*),DEFAULT_SIGF*(*)
      CHARACTER DEFAULT_I*30,DEFAULT_SIGI*30
C ---
      PARAMETER (MCOLS=500)
      INTEGER   NCOL
      CHARACTER CTPRG(MCOLS)*1,LSPRG(MCOLS)*30
C ---
      CHARACTER LINE*80,PATH*1,EXT*1
C ------------------------------------------
      DEFAULT_F     = ' '
      DEFAULT_SIGF  = ' '
      DEFAULT_I     = ' '
      DEFAULT_SIGI  = ' '
      IDEFAULT_F    = 0
      IDEFAULT_SIGF = 0
      IDEFAULT_I    = 0
      IDEFAULT_SIGI = 0

      MD = 0
      M  = 99
      EXT  = ' '
      PATH = ' '
      IN   = 10     
      CALL  OPENFR(IN,MD,PATH,FILE_CIF,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(M,' ERROR: can not open input MTZ file') 
        RETURN
      ENDIF
      CLOSE(IN)
C
c      CALL CCPFYP 
      CALL MTZINI
      IPRNT = 0
      MTZIN = 1
      IFAIL = 0
      CALL LENSTR_BL(FILE_CIF,L)
      CALL LROPEN(MTZIN,FILE_CIF(1:L),IPRNT,IFAIL)
      IF(IFAIL.EQ.1) THEN
        CALL MSGERR(M,' ERROR: can not open input MTZ file') 
        IERR=1
        RETURN
      ENDIF
      CALL LRCLAB(MTZIN,LSPRG,CTPRG,NCOL)
      IF(NCOL.LE.0) THEN
        CALL MSGERR(M,' ERROR: file is empty') 
        CALL LRCLOS(MTZIN)
        IERR=1
        RETURN
      ENDIF
C ---
      CALL MSGDOC(MDOC,' -----------------------------------')
      LL = L
      IF(L.GT.65) LL = 65
      WRITE(LINE,'(A,A)') '--- MTZ file :',FILE_CIF(1:LL)
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC, '  No  Label                       type')
      CALL MSGDOC(MDOC,' ')
      DO I=1,NCOL
        IF(IDEFAULT_F.EQ.0.AND.CTPRG(I).EQ.'F') THEN
          IDEFAULT_F = 1
          DEFAULT_F  = LSPRG(I)
        ENDIF
        IF(IDEFAULT_F.EQ.1.AND.IDEFAULT_SIGF.EQ.0.AND.
     *                                 CTPRG(I).EQ.'Q') THEN
          DEFAULT_SIGF  = LSPRG(I)
          IDEFAULT_SIGF = 1
        ENDIF
        IF(IDEFAULT_I.EQ.0.AND.CTPRG(I).EQ.'J') THEN
          IDEFAULT_I = 1
          DEFAULT_I  = LSPRG(I)
        ENDIF
        IF(IDEFAULT_I.EQ.1.AND.IDEFAULT_SIGI.EQ.0.AND.
     *                                 CTPRG(I).EQ.'Q') THEN
          DEFAULT_SIGI  = LSPRG(I)
          IDEFAULT_SIGI = 1
        ENDIF

        WRITE(LINE,'(I5,2X,A,2X,A)') I,LSPRG(I),CTPRG(I)
        CALL MSGDOC(MDOC,LINE)
      ENDDO
      IF(IDEFAULT_F.EQ.0.AND.IDEFAULT_I.EQ.1) THEN
        DEFAULT_F     = DEFAULT_I
        DEFAULT_SIGF  = DEFAULT_SIGI
        IDEFAULT_SIGF = IDEFAULT_SIGI
        IDEFAULT_F    = 2
      ENDIF
      CALL MSGDOC(MDOC,' -----------------------------------')
      CALL LRCLOS(MTZIN)
      RETURN
      END

      SUBROUTINE MTZ_TO_CIF(MDOC,FILE_MTZ,LINE_CCP4,LABEL
     *            ,FILE_CIF,PHASE,DER,IERR)
C ------------------------------------------------------
      INTEGER*4 MDOC,IERR      
      CHARACTER FILE_MTZ*(*),FILE_CIF*(*)
      CHARACTER LABEL(20)*30
C      1  2   3   4    5  6   7     8    9    10    11   12    13  14    15
C     F  SF F(-) SF(-) DP SDP INTP SINTP INTM SINTM FREE PH   FOM  FD   SIGFD  
C-CCP4 
      PARAMETER (MCOLS=200)
      INTEGER   NCOL
      CHARACTER CTPRG(MCOLS)*1,LSPRG(MCOLS)*30
      CHARACTER DEFAULT_F*30,DEFAULT_SIGF*30
C-CCP4
      CHARACTER LINE*80,PATH*80,EXT*3,PHASE*1,LINE_CCP4*(*),DER*1
C ------------------------------------------------------
      MD = 0
      M  = 99
C ---------------------------
C     FILE_CIF='molrep_mtz.cif'
      CALL SFCH_MTZ(MDOC,FILE_MTZ,FILE_CIF,PHASE,DER
     *    ,LABEL,LINE_CCP4,IERR)
      IF(IERR.NE.0) GO TO 500
C ---------------------------
 500  CONTINUE
      RETURN
      END


C =========================================================
C --- CCP4 ---  read MTZ file

      SUBROUTINE SFCH_MTZ(MDOC,FILE_MTZ,FILE_CIF,PHASE,DER
     *    ,LABEL,LINE_CCP4,IERR)
C -------------------------------------------------------
      PARAMETER (MCOLS=200)
C     
      CHARACTER LINE_CCP4*(*)
      INTEGER   NCOL
C
      CHARACTER CTPRG(MCOLS)*1,LSPRG(MCOLS)*30
C --
      CHARACTER FILE_MTZ*(*),FILE_CIF*(*)
      CHARACTER LINE*80,TYPE*1,PATH*1,EXT*1,MSG*1,PHASE*1,FMINUS*1,DER*1
C --
      CHARACTER LABEL(20)*30
C      1  2   3   4    5  6   7     8    9    10    11    12  13  14  15
C     F  SF F(-) SF(-) DP SDP INTP SINTP INTM SINTM FREE  PH  FOM FD SIGFD 
C -----------------------------------------------------
      IERR = 0
      M    = 0
      MD   =99
C     LINE_CCP4=' ' 

      CALL LENSTR_BL(LINE_CCP4,L)
      IF(L.GT.4.AND.LINE_CCP4(1:5).EQ.'LABIN') THEN
        FMINUS    = 'N'
        DO I=5,L
          IF(LINE_CCP4(I-4:I).EQ.'F(-)='.OR.
     *       LINE_CCP4(I-4:I).EQ.'I(-)=') THEN
            FMINUS = 'Y'
          ENDIF
        ENDDO
        DER = 'N'
        DO I=4,L
          IF(LINE_CCP4(I-3:I).EQ.' FD=') THEN
            DER = 'Y'
          ENDIF
        ENDDO
        PHASE = 'N'
        DO I=6,L
          IF(LINE_CCP4(I-5:I).EQ.' PHIC=') THEN
            PHASE = 'Y'
          ENDIF
        ENDDO
        DO I=4,L
          IF(LINE_CCP4(I-3:I).EQ.' PH=') THEN
            PHASE = 'Y'
          ENDIF
        ENDDO

        GO TO 1000
      ENDIF
C ---------------------
      EXT  = ' '
      PATH = ' '
      IN   = 10     
      CALL  OPENFR(IN,MD,PATH,FILE_MTZ,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(M,' ERROR: can not open input MTZ file') 
        RETURN
      ENDIF
      CLOSE(IN)
C ------------------
C      CALL CCPFYP 
      CALL MTZINI

      IPRNT = 0
      MTZIN = 1
      IFAIL = 0

      CALL LENSTR_BL(FILE_MTZ,L)
      CALL LROPEN(MTZIN,FILE_MTZ(1:L),IPRNT,IFAIL)
      IF(IFAIL.EQ.1) THEN
        CALL MSGERR(M,' ERROR: can not open input MTZ file') 
        IERR=1
        RETURN
      ENDIF
      CALL LRCLAB(MTZIN,LSPRG,CTPRG,NCOL)
      IF(NCOL.LE.0) THEN
        CALL MSGERR(M,' ERROR: MTZ file is empty') 
        CALL LRCLOS(MTZIN)
        IERR=1
        RETURN
      ENDIF
C -------------------
      IFP       = 0
      ISIGFP    = 0
      IFPH      = 0
      ISIGFPH   = 0
      IFREE     = 0
      IINTP     = 0
      ISIGIP    = 0
      IINTM     = 0
      ISIGIM    = 0
      IDP       = 0
      ISDP      = 0            
      IPH       = 0            
      IFOM      = 0            
      IFD       = 0
      ISIGFD    = 0
      FMINUS    = 'N'
      DER       = 'N'
C ------------------------------------------------------
C      CALL MSGDOC(MDOC,' -----------------------------------')
C      WRITE(LINE,*) '--- MTZ file : ',FILE_MTZ(1:L)
C      CALL MSGDOC(MDOC,LINE)
C      CALL MSGDOC(MDOC,' ')
C      CALL MSGDOC(MDOC, '  No  Label                       type')
C      CALL MSGDOC(MDOC,' ')
C      DO I=1,NCOL
C        WRITE(LINE,'(I5,2X,A,2X,A)') I,LSPRG(I),CTPRG(I)
C        CALL MSGDOC(MDOC,LINE)
C      ENDDO
C      CALL MSGDOC(MDOC,' -----------------------------------')
C
      CALL LRCLOS(MTZIN)
C ---------------------------------------------------------
      LINE=LABEL(1)

      CALL CLEAR_LINE(LINE)
      CALL LENSTR_BL(LINE,LFP)
      IF(LFP.GT.0) THEN
        DO I=1,NCOL
          CALL LENSTR_BL(LSPRG(I),L)
          IF(L.EQ.LFP.AND.LINE(1:LFP).EQ.LSPRG(I)(1:L)) THEN
            IFP=I
            GO TO 201
          ENDIF
        ENDDO
        WRITE(LINE,*) ' ERROR: not such label:',LINE(1:LFP) 
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ELSE
        IFP=0
      ENDIF

 201  CONTINUE

c      IF(IFP.LE.3.OR.IFP.GT.NCOL) THEN
c        WRITE(LINE,*) ' ERROR: wrong F label ' 
c        CALL MSGERR(MDOC,LINE)
c        IERR=1
c        RETURN
c      ENDIF
C -------------------------------------------------------------
      LINE=LABEL(2)
      CALL CLEAR_LINE(LINE)
      CALL LENSTR_BL(LINE,LSFP)
      IF(LSFP.GT.0) THEN  
        DO I=1,NCOL
          CALL LENSTR_BL(LSPRG(I),L)
          IF(L.EQ.LSFP.AND.LINE(1:LSFP).EQ.LSPRG(I)(1:L)) THEN
            ISIGFP=I
            GO TO 202
          ENDIF
        ENDDO
        WRITE(LINE,*) ' ERROR: not such label:',LINE(1:LSFP) 
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN

      ELSE

        ISIGFP=0
       
      ENDIF

 202  CONTINUE
C ---------------------------------------------------------
      LINE=LABEL(3)

      CALL CLEAR_LINE(LINE)
      CALL LENSTR_BL(LINE,LL)
      IF(LL.GT.0) THEN
        DO I=1,NCOL
          CALL LENSTR_BL(LSPRG(I),L)
          IF(L.EQ.LL.AND.LINE(1:LL).EQ.LSPRG(I)(1:L)) THEN
            IFPH=I
            FMINUS = 'Y'
            GO TO 203
          ENDIF
        ENDDO
        WRITE(LINE,*) ' ERROR: not such label:',LINE(1:LL) 
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ELSE
        IFPH=0
      ENDIF

 203  CONTINUE
C -------------------------------------------------------------
      LINE=LABEL(4)
      CALL CLEAR_LINE(LINE)
      CALL LENSTR_BL(LINE,LL)
      IF(LL.GT.0) THEN  
        DO I=1,NCOL
          CALL LENSTR_BL(LSPRG(I),L)
          IF(L.EQ.LL.AND.LINE(1:LL).EQ.LSPRG(I)(1:L)) THEN
            ISIGFPH=I
            GO TO 204
          ENDIF
        ENDDO
        WRITE(LINE,*) ' ERROR: not such label:',LINE(1:LL) 
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN

      ELSE

        ISIGFPH=0
       
      ENDIF

 204  CONTINUE
C -------------------------------------------------------------
      LINE=LABEL(5)
      CALL CLEAR_LINE(LINE)
      CALL LENSTR_BL(LINE,LL)
      IF(LL.GT.0) THEN  
        DO I=1,NCOL
          CALL LENSTR_BL(LSPRG(I),L)
          IF(L.EQ.LL.AND.LINE(1:LL).EQ.LSPRG(I)(1:L)) THEN
            IDP=I
            GO TO 205
          ENDIF
        ENDDO
        WRITE(LINE,*) ' ERROR: not such label:',LINE(1:LL) 
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN

      ELSE

        IDP       = 0

      ENDIF

 205  CONTINUE
C -------------------------------------------------------------
      LINE=LABEL(6)
      CALL CLEAR_LINE(LINE)
      CALL LENSTR_BL(LINE,LL)
      IF(LL.GT.0) THEN  
        DO I=1,NCOL
          CALL LENSTR_BL(LSPRG(I),L)
          IF(L.EQ.LL.AND.LINE(1:LL).EQ.LSPRG(I)(1:L)) THEN
            ISDP=I
            GO TO 206
          ENDIF
        ENDDO
        WRITE(LINE,*) ' ERROR: not such label:',LINE(1:LL) 
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN

      ELSE

        ISDP      = 0            
       
      ENDIF

 206  CONTINUE
C -----------------------------------------------------------------
      LINE=LABEL(11)
      CALL CLEAR_LINE(LINE)
      CALL LENSTR_BL(LINE,LL)
      IF(LL.GT.0) THEN
        DO I=1,NCOL
          CALL LENSTR_BL(LSPRG(I),L)
          IF(L.EQ.LL.AND.LINE(1:LL).EQ.LSPRG(I)(1:L)) THEN
            IFREE=I
            GO TO 211
          ENDIF
        ENDDO
        WRITE(LINE,*) ' ERROR: not such label:',LINE(1:LL) 
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ELSE 

        IFREE=0

      ENDIF

 211  CONTINUE
C -------------------------------------------------------------
C      1  2   3   4    5  6   7     8    9    10    11
C     F  SF F(-) SF(-) DP SDP INTP SINTP INTM SINTM FREE   
      LINE=LABEL(7)
      CALL CLEAR_LINE(LINE)
      CALL LENSTR_BL(LINE,LL)
      IF(LL.GT.0) THEN  
        DO I=1,NCOL
          CALL LENSTR_BL(LSPRG(I),L)
          IF(L.EQ.LL.AND.LINE(1:LL).EQ.LSPRG(I)(1:L)) THEN
            IINTP=I
            GO TO 207
          ENDIF
        ENDDO
        WRITE(LINE,*) ' ERROR: not such label:',LINE(1:LL) 
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN

      ELSE

        IINTP=0
       
      ENDIF

 207  CONTINUE
C -------------------------------------------------------------
      LINE=LABEL(8)
      CALL CLEAR_LINE(LINE)
      CALL LENSTR_BL(LINE,LL)
      IF(LL.GT.0) THEN  
        DO I=1,NCOL
          CALL LENSTR_BL(LSPRG(I),L)
          IF(L.EQ.LL.AND.LINE(1:LL).EQ.LSPRG(I)(1:L)) THEN
            ISIGIP=I
            GO TO 208
          ENDIF
        ENDDO
        WRITE(LINE,*) ' ERROR: not such label:',LINE(1:LL) 
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN

      ELSE

        ISIGIP=0
       
      ENDIF

 208  CONTINUE
C -------------------------------------------------------------
      LINE=LABEL(9)
      CALL CLEAR_LINE(LINE)
      CALL LENSTR_BL(LINE,LL)
      IF(LL.GT.0) THEN  
        DO I=1,NCOL
          CALL LENSTR_BL(LSPRG(I),L)
          IF(L.EQ.LL.AND.LINE(1:LL).EQ.LSPRG(I)(1:L)) THEN
            IINTM=I
            FMINUS = 'Y'
            GO TO 209
          ENDIF
        ENDDO
        WRITE(LINE,*) ' ERROR: not such label:',LINE(1:LL) 
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN

      ELSE

        IINTM=0
       
      ENDIF

 209  CONTINUE
C ---------------------------------------------------------
      LINE=LABEL(10)
      CALL CLEAR_LINE(LINE)
      CALL LENSTR_BL(LINE,LL)
      IF(LL.GT.0) THEN  
        DO I=1,NCOL
          CALL LENSTR_BL(LSPRG(I),L)
          IF(L.EQ.LL.AND.LINE(1:LL).EQ.LSPRG(I)(1:L)) THEN
            ISIGIM = I
            GO TO 210
          ENDIF
        ENDDO
        WRITE(LINE,*) ' ERROR: not such label:',LINE(1:LL) 
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN

      ELSE

        ISIGIM = 0
       
      ENDIF

 210  CONTINUE
C -------------------------------------------------------------
      LINE=LABEL(12)
      CALL CLEAR_LINE(LINE)
      CALL LENSTR_BL(LINE,LL)
      IF(LL.GT.0) THEN  
        DO I=1,NCOL
          CALL LENSTR_BL(LSPRG(I),L)
          IF(L.EQ.LL.AND.LINE(1:LL).EQ.LSPRG(I)(1:L)) THEN
            IPH=I
            GO TO 212
          ENDIF
        ENDDO
        WRITE(LINE,*) ' ERROR: not such label:',LINE(1:LL) 
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN

      ELSE

        IPH=0
       
      ENDIF

 212  CONTINUE
C -------------------------------------------------------------
      LINE=LABEL(13)
      CALL CLEAR_LINE(LINE)
      CALL LENSTR_BL(LINE,LL)
      IF(LL.GT.0) THEN  
        DO I=1,NCOL
          CALL LENSTR_BL(LSPRG(I),L)
          IF(L.EQ.LL.AND.LINE(1:LL).EQ.LSPRG(I)(1:L)) THEN
            IFOM=I
            GO TO 213
          ENDIF
        ENDDO
        WRITE(LINE,*) ' ERROR: not such label:',LINE(1:LL) 
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN

      ELSE

        IFOM=0
       
      ENDIF

 213  CONTINUE
C ----------------------------
      LINE=LABEL(14)
      CALL CLEAR_LINE(LINE)
      CALL LENSTR_BL(LINE,LL)
      IF(LL.GT.0) THEN  
        DO I=1,NCOL
          CALL LENSTR_BL(LSPRG(I),L)
          IF(L.EQ.LL.AND.LINE(1:LL).EQ.LSPRG(I)(1:L)) THEN
            IFD=I
            GO TO 214
          ENDIF
        ENDDO
        WRITE(LINE,*) ' ERROR: not such label:',LINE(1:LL) 
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN

      ELSE

        IFD=0
       
      ENDIF

 214  CONTINUE
C ----------------------------
      LINE=LABEL(15)
      CALL CLEAR_LINE(LINE)
      CALL LENSTR_BL(LINE,LL)
      IF(LL.GT.0) THEN  
        DO I=1,NCOL
          CALL LENSTR_BL(LSPRG(I),L)
          IF(L.EQ.LL.AND.LINE(1:LL).EQ.LSPRG(I)(1:L)) THEN
            ISIGFD=I
            GO TO 215
          ENDIF
        ENDDO
        WRITE(LINE,*) ' ERROR: not such label:',LINE(1:LL) 
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN

      ELSE

        ISIGFD=0
       
      ENDIF

 215  CONTINUE
C ----------------------------
      EXT  = ' '
      PATH = ' '
      IN   = 10      
      CALL  OPENFW(IN,M,PATH,FILE_CIF,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: can not open output file') 
        RETURN
      ENDIF
      CLOSE(IN)      
C --------------------------------------

      LINE_CCP4= 'LABIN'

      IF(IFP.GT.0) THEN
        LINE=LSPRG(IFP)
        CALL LENSTR_BL(LINE,LFP)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' F='//LINE(1:LFP)
      ENDIF

      IF(ISIGFP.GT.0) THEN
        LINE=LSPRG(ISIGFP)
        CALL LENSTR_BL(LINE,LSFP)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' SIGF='//LINE(1:LSFP)
      ENDIF

      IF(IFPH.GT.0) THEN
        LINE=LSPRG(IFPH)
        CALL LENSTR_BL(LINE,LL)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' F(-)='//LINE(1:LL)
        FMINUS = 'Y'
      ENDIF

      IF(ISIGFPH.GT.0) THEN
        LINE=LSPRG(ISIGFPH)
        CALL LENSTR_BL(LINE,LL)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' SIGF(-)='//LINE(1:LL)
      ENDIF

      IF(IFREE.GT.0) THEN
        LINE=LSPRG(IFREE)
        CALL LENSTR_BL(LINE,LL)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' FREE='//LINE(1:LL)
      ENDIF

      IF(IDP.GT.0) THEN
        LINE=LSPRG(IDP)
        CALL LENSTR_BL(LINE,LL)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' DP='//LINE(1:LL)
      ENDIF

      IF(ISDP.GT.0) THEN
        LINE=LSPRG(ISDP)
        CALL LENSTR_BL(LINE,LL)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' SIGDP='//LINE(1:LL)
      ENDIF

      IF(IINTP.GT.0) THEN
        LINE=LSPRG(IINTP)
        CALL LENSTR_BL(LINE,LL)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' I='//LINE(1:LL)
      ENDIF

      IF(ISIGIP.GT.0) THEN
        LINE=LSPRG(ISIGIP)
        CALL LENSTR_BL(LINE,LL)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' SIGI='//LINE(1:LL)
      ENDIF

      IF(IINTM.GT.0) THEN
        LINE=LSPRG(IINTM)
        CALL LENSTR_BL(LINE,LL)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' I(-)='//LINE(1:LL)
        FMINUS = 'Y'
      ENDIF

      IF(ISIGIM.GT.0) THEN
        LINE=LSPRG(ISIGIM)
        CALL LENSTR_BL(LINE,LL)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' SIGI(-)='//LINE(1:LL)
      ENDIF

      IF(IPH.GT.0) THEN
        PHASE = 'Y'
        LINE=LSPRG(IPH)
        CALL LENSTR_BL(LINE,LL)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' PH='//LINE(1:LL)
      ENDIF

      IF(IFOM.GT.0) THEN
        LINE=LSPRG(IFOM)
        CALL LENSTR_BL(LINE,LL)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' FOM='//LINE(1:LL)
      ENDIF

      IF(IFD.GT.0) THEN
        LINE=LSPRG(IFD)
        CALL LENSTR_BL(LINE,LL)
        CALL LENSTR_BL(LINE_CCP4,L)
        LINE_CCP4=LINE_CCP4(1:L)//' FD='//LINE(1:LL)
        DER = 'Y'

        IF(ISIGFD.GT.0) THEN
          LINE=LSPRG(ISIGFD)
          CALL LENSTR_BL(LINE,LL)
          CALL LENSTR_BL(LINE_CCP4,L)
          LINE_CCP4=LINE_CCP4(1:L)//' SIGFD='//LINE(1:LL)
        ENDIF

      ENDIF

      CALL LENSTR_BL(LINE_CCP4,L)
      IF(L.GT.79) L = 79
      CALL MSGDOC(MDOC,LINE_CCP4(1:L))
C -----------------

 1000 CONTINUE

C ---------------------------------------------------------
      CALL MTZ2CIF(MDOC,FILE_MTZ,FILE_CIF,LINE_CCP4,FMINUS,IERR)
C ---------------------------------------------------------
      RETURN
      END

      SUBROUTINE MTZ2CIF(MDOC,FILE_MTZ,FILE_CIF,LINE,FMINUS,IERR)
C ---------------------------------------------------------
      PARAMETER (NPARM=200)
      PARAMETER (MCOLS=200)
C     
      INTEGER IN(3),MDOC,MMM
C     
C---- Mtz file variables
C     
      REAL      ADATA(MCOLS),  RSYM(4,4,192)
      INTEGER   LOOKUP(MCOLS), NSYM
      LOGICAL   LOGMSS(MCOLS)
C     
C---- things for parser
C     
      CHARACTER KEY*4,CVALUE(NPARM)*4,LINE*600
      REAL      FVALUE(NPARM)
      LOGICAL   LEND,IPRINT,EOF
      INTEGER   NTOK,IBEG(NPARM),IEND(NPARM),ITYPE(NPARM),IDEC(NPARM)
      CHARACTER CTPRGI(MCOLS)*1,LSPRGI(MCOLS)*30

C      CHARACTER CTPRG_Inf(MCOLS)*1,LSPRG_Inf(MCOLS)*30
C --
      LOGICAL   LANOM

c ___ CIF things
      INTEGER   IUN22
      CHARACTER CODE*8,RSTAT*1
      CHARACTER LINE_CIF*80,CH20*20,PATH*1,EXT*1


      REAL      intens, sigintens, CELL(6)

      INTEGER   nsympx,nspgrx
      CHARACTER ltypex*1, spgrnx*10, pgnamx*10, symchs(196)*80


      CHARACTER*40 CIF_DATA,CIF_ENTRY,CIF_CELL_ID,CIF_SYMM_ID
      CHARACTER*40 CIF_CELL1,CIF_CELL2,CIF_CELL3
      CHARACTER*40 CIF_CELL4,CIF_CELL5,CIF_CELL6
      CHARACTER*40 CIF_ITNUM,CIF_GROUP,CIF_EQUIV_ID,CIF_EQUIV_XYZ
      CHARACTER*40 CIF_INDH,CIF_INDK,CIF_INDL
      CHARACTER*40 CIF_FP,CIF_SIGF,CIF_STAT
      CHARACTER*40 CIF_FC,CIF_PH,CIF_FOM,CIF_SFC
      CHARACTER*40 CIF_INT,CIF_SIGI

C---- External Routines
C
      LOGICAL CCPONL
      EXTERNAL CCPDPN,CCPERR,CCPFYP,CCPLWC,CCPONL,CCPRCS,CCPUPC,CENTR,
     +         CENTRIC,GTPINT,GTPREA,LKYIN,LRASSN,LRINFO,LROPEN,LRREFF,
     +         LRREFM,LRRSOL,LRSORT,LRSYMI,LRSYMM,MTZINI,PARSER,RDRESO
C     
C---- Common Blocks
C     
      COMMON /PINOUT/ LUNIN,LUNOUT
      INTEGER   LUNIN,LUNOUT


      CHARACTER FILE_MTZ*(*),FILE_CIF*(*),FMINUS*1

C     
C---- Data Statements
C     
      DATA NLPRGI/42/,
     +     LSPRGI/'H','K','L','F','SIGF','F(-)','SIGF(-)','FD','PH',
     +     'SIGFD','FPART','PHIPART','PHIB','FOM','FREE','DP','SIGDP',
     +     'ISYM','DUM1','DUM2','DUM3','DUM4','DUM5','DUM6','DUM7',
     +     'DUM8','DUM9','DUM10','IDUM1','IDUM2','IDUM3','IDUM4',
     +     'IDUM5','IDUM6','IDUM7','IDUM8','IDUM9','IDUM10',
     &     'I', 'SIGI', 'I(-)', 'SIGI(-)', 158*' '/
      DATA CTPRGI/'H','H','H','F','Q','G','L','F','P','Q','F','P','P',
     +            'W','I','D','Q','Y',10*'R',10*'I','J','Q','J','Q',
     +            158*' '/

      DATA LOOKUP/-1,-1,-1,0,0,195*0/
C -----------------------------------------------------
      IERR=0
C ----------------
C     CALL CCPFYP 
      CALL MTZINI
      IF(FMINUS.EQ.'Y') THEN
        CTPRGI(4) = 'G'
        CTPRGI(5) = 'L'
        CTPRGI(39) = 'K'
        CTPRGI(40) = 'M'
        CTPRGI(41) = 'K'
        CTPRGI(42) = 'M'
      ENDIF
      IPRNT  = 0
      MTZIN  = 1
      IFAIL  = 0
      LANOM  = .FALSE.
      SMAX   = 0.0
      SMIN   = 0.0
      MTZIN  = 1
      LUNIN  = 5
      LUNOUT = 6
      NRFOUT = 0
      NTOK   = NPARM
      IPRINT = .TRUE.

c      call lenstr_bl(line,l)
c      write(*,*) '<',line(1:l),'>'

C
C             *********************************************
      CALL PARSER (KEY,LINE,IBEG,IEND,ITYPE,FVALUE,CVALUE,IDEC,NTOK,
     +     LEND,IPRINT)
c            
          CALL LKYIN(MTZIN,LSPRGI,NLPRGI,NTOK,LINE,IBEG,IEND)
C             *********************************************
C     Open output ASCII file
C     

C      IUN22 = 22
C      IFAIL = 0
C      CALL LENSTR_BL(FILE_CIF,L)
C      CALL CCPDPN(IUN22,FILE_CIF(1:L),'NEW','F',LL,IFAIL)
C      IF(IFAIL.NE.0) THEN
C        CALL MSGERR(MDOC,'ERROR: can not open output CIFile')
C        IERR=1
C        RETURN
C      ENDIF

      EXT   = ' '
      PATH  = ' '
      IUN22 = 22
      MMM   = 99      
      CALL  OPENFW(IUN22,MMM,PATH,FILE_CIF,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: can not open output CIFile')
        IFAIL = 1
        RETURN
      ENDIF

      MTZIN = 1
      IFAIL = 0
      IPRNT = 0
C          **********************************
C      CALL LROPEN(MTZIN,'HKLIN',IPRNT,IFAIL)
C          **********************************
      CALL LENSTR_BL(FILE_MTZ,L)
      CALL LROPEN(MTZIN,FILE_MTZ(1:L),IPRNT,IFAIL)
      IF(IFAIL.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: can not open output MTZ file')
        IERR=1
        RETURN
      ENDIF
C          **********************************
      CALL LRASSN(MTZIN,LSPRGI,NLPRGI,LOOKUP,CTPRGI)
C          *****************************************
C
C     Column labels              4     5     6        7
C           LSPRGI/'H','K','L','F','SIGF','F(-)','SIGF(-)',
C             8      9   10     11        12     13    14
C           'FC','PHIC','W','FPART','PHIPART','PHIB','FOM',
C              15   16      17     18
C           'FREE','DP','SIGDP','ISYM','DUM1' .. 'DUM10','IDUM1' .. 'IDUM10'
C              39   40     41     42  
C            'I', 'SIGI', 'I(-)', 'SIGI(-)'
C
C ----------------------
      N_F   =  4
      N_SF  =  5
      N_FM  =  6
      N_SFM =  7
      N_FC  =  8
      N_SFC = 10
      N_PH  =  9
      N_FOM = 14
      N_FR  = 15
      N_DP  = 16 
      N_SDP = 17
      N_I   = 39
      N_SI  = 40
      N_IM  = 41
      N_SIM = 42

      IF(LOOKUP(N_F) .EQ.0.AND.LOOKUP(N_FC).EQ.0.AND.
     *   LOOKUP(N_I).EQ.0                       ) THEN
        CALL MSGERR(MDOC,
     *  'ERROR: Missing assignment for F or FC or I')
        IERR=1
        RETURN
      ENDIF

      IF(LOOKUP(N_F).NE.0) THEN

C       with FP
CX       FP
C       FP, SIGFP
C X      FP, FC
C X      FP, SIGFP, FC
C       FP, SIGFP , FC , PHASE, FOM
C     --- DP --
C       FP+, SIGFP+
C       FP-, SIGFP-
C      
        IF(LOOKUP(N_I).NE.0.OR.LOOKUP(N_IM).NE.0) THEN
          CALL MSGERR(MDOC,
     *    'WARNING: I+ and I- can not be used with F')
        ENDIF

        LOOKUP(N_I)   = 0
        LOOKUP(N_SI)  = 0
        LOOKUP(N_IM)  = 0
        LOOKUP(N_SIM) = 0
        IF(LOOKUP(N_DP).NE.0.AND.LOOKUP(N_SDP).EQ.0) LOOKUP(N_SF)=0
        IF(LOOKUP(N_DP).NE.0) THEN
          LOOKUP(N_FM) = 0
          LOOKUP(N_SFM)= 0
          LOOKUP(N_FC) = 0
          LOOKUP(N_SFC)= 0
          LOOKUP(N_PH) = 0
          LOOKUP(N_FOM)= 0
        ENDIF

      ELSE

C       without FP          
C       FC , PHASE, FOM
C       I+ sigI+
C       I- sigI-

        LOOKUP(N_F)  = 0
        LOOKUP(N_SF) = 0
        LOOKUP(N_FM) = 0
        LOOKUP(N_SFM)= 0
        LOOKUP(N_DP) = 0
        LOOKUP(N_SDP)= 0

        IF(LOOKUP(N_FC).NE.0) THEN
C         with FC
          IF(LOOKUP(N_I).NE.0.OR.LOOKUP(N_IM).NE.0) THEN
            CALL MSGERR(MDOC,
     *      'WARNING: I+ and I- can not be used with FC')
          ENDIF

          LOOKUP(N_I) = 0
          LOOKUP(N_SI) = 0
          LOOKUP(N_IM) = 0
          LOOKUP(N_SIM) = 0
        ELSE
C         I+ and I-
          LOOKUP(N_FC) = 0
          LOOKUP(N_SFC)= 0
          LOOKUP(N_PH) = 0
          LOOKUP(N_FOM)= 0
          IF(LOOKUP(N_I).EQ.0.AND.LOOKUP(N_IM).NE.0) THEN
            CALL MSGERR(MDOC,
     *      'ERROR: I+ and I- both must be assigned')
            IERR=1
            RETURN
          ENDIF

        ENDIF
      ENDIF
C -----------------------------
      IF(LOOKUP(N_DP).GT.0.OR.LOOKUP(N_I).GT.0) THEN
        LANOM=.TRUE.
      ENDIF

      IF(LOOKUP(N_FM).GT.0) THEN
        LANOM=.TRUE.
      ENDIF
C -----------------------------
C
C Get symmetry for centric/systematically absent tests and symm. operators.
C Need this for CIF output, whether or not we are converting anomalous data

c        CALL LRSYMM(MTZIN, NSYM, RSYM)
c        CALL CENTRIC(NSYM, RSYM, 0)

        call lrsymi(mtzin,nsympx,ltypex,nspgrx,spgrnx,pgnamx)
c        call epsln(nsym,nsympx,rsym,0)

C -----------------------------
C
C   --- write CIF titles
C
        CODE='XXXX'
        CIF_DATA      = 'data'
        CIF_ENTRY     = '_entry.id'
        CIF_CELL_ID   = '_cell.entry_id'    
        CIF_CELL1     = '_cell.length_a'
        CIF_CELL2     = '_cell.length_b'
        CIF_CELL3     = '_cell.length_c'
        CIF_CELL4     = '_cell.angle_alpha'
        CIF_CELL5     = '_cell.angle_beta'
        CIF_CELL6     = '_cell.angle_gamma'
        CIF_SYMM_ID   = '_symmetry.entry_id'
        CIF_ITNUM     = '_symmetry.Int_Tables_number'
        CIF_GROUP     = '_symmetry.space_group_name_H-M'
        CIF_EQUIV_ID  = '_symmetry_equiv.id'
        CIF_EQUIV_XYZ = '_symmetry_equiv.pos_as_xyz'
        CIF_INDH      = '_refln.index_h'
        CIF_INDK      = '_refln.index_k'
        CIF_INDL      = '_refln.index_l'
C
        CIF_FP        = '_refln.F_meas_au'
        CIF_SIGF      = '_refln.F_meas_sigma_au'
        CIF_STAT      = '_refln.status'

        CIF_FC        = '_refln.F_calc'
        CIF_SFC       = '_refln.F_calc_sigma'
        CIF_PH        = '_refln.phase_calc'
        CIF_FOM       = '_refln.fom'
        CIF_INT       = '_refln.intensity_meas'
        CIF_SIGI      = '_refln.intensity_sigma'
C -------------------------------------------------
C  only mmCIF:
C
C       _refln.F_meas_au         / in arbitrary units /  
C       _refln.F_meas_sigma_au          The standard uncertainty (e.s.d.)
C
C       _refln.F_calc_au
C
C       _refln.fom
C
C   mmCIF and CIF:
C
C       _refln.F_meas          / in electrons / !!!cif_core.dic: _refln_F_sigma
C       _refln.F_meas_sigma'
C
C       _refln.intensity_meas   /in the measured units./ 
C       _refln.intensity_calc
C       _refln.intensity_sigma
C
C       _refln.F_squared_meas    /in electrons squared./
C       _refln.F_squared_calc
C       _refln.F_squared_sigma
C
C       _refln.F_calc
C
C       _refln.phase_calc    / in degrees /
C       _refln.phase_meas
C
C
C
C       _refln.status     !!! cif_core.dic: _refln_observed_status
C
C                                o
C                                   satisfies _refine.ls_d_res_high
C                                   satisfies _refine.ls_d_res_low
C                                   observed by _reflns.observed_criterion
C                                   not flagged as systematically absent
C                                   not flagged as unreliable
C
C                               <
C                                   satisfies _refine.ls_d_res_high
C                                   satisfies _refine.ls_d_res_low
C                                   unobserved by _reflns.observed_criterion
C                                   not flagged as systematically absent
C                                   not flagged as unreliable
C
C                               -  'systematically absent reflection'
C                               x  'unreliable measurement -- not used'
C                               h  'does not satisfy _refine.ls_d_res_high'
C                               l  'does not satisfy _refine.ls_d_res_low'
C                               f
C                                    satisfies _refine.ls_d_res_high
C                                    satisfies _refine.ls_d_res_low
C                                    observed by _reflns.observed_criterion
C                                    not flagged as systematically absent
C                                    not flagged as unreliable
C                                    excluded from refinement so as to be
C                                    included in calculation of "free" R-factor
C -------------------------------------------
C
C       _refln.F_meas_au_(+)
C       _refln.F_meas_au_(+)_sigma
C       _refln.F_meas_au_(-)
C       _refln.F_meas_au_(-)_sigma
C
C       _refln.intensity_(+)_meas
C       _refln.intensity_(+)_meas_sigma
C       _refln.intensity_(-)_meas
C       _refln.intensity_(-)_meas_sigma
C
C       _refln.F_squared_(+)_meas
C       _refln.F_squared_(+)_sigma
C       _refln.F_squared_(-)_meas
C       _refln.F_squared_(-)_sigma
C
C
C       _refln.coef_H_L_a
C       _refln.coef_H_L_b
C       _refln.coef_H_L_c
C       _refln.coef_H_L_d
C
C -----------------------------------------

        CALL LENSTR_BL(CODE,LCD)
C --    data block       
        CALL LENSTR_BL(CIF_DATA,LDB)
        WRITE(IUN22,'(A)')
     *  CIF_DATA(1:LDB)//'_'//CODE(1:LCD)
C ---   cell
        call lrcell(MTZIN,CELL)

         CALL LENSTR_BL(CIF_CELL_ID,LCC)
        WRITE(IUN22,'(A)')
     *  CIF_CELL_ID(1:LCC)//'  '//CODE(1:LCD)
 
        CALL LENSTR_BL(CIF_CELL1,LC1)
        WRITE(IUN22,'(A,5X,F9.3)')
     *  CIF_CELL1(1:LC1),CELL(1)
        CALL LENSTR_BL(CIF_CELL2,LC2)
        WRITE(IUN22,'(A,5X,F9.3)')
     *  CIF_CELL2(1:LC2),CELL(2)
        CALL LENSTR_BL(CIF_CELL3,LC3)
        WRITE(IUN22,'(A,5X,F9.3)')
     *  CIF_CELL3(1:LC3),CELL(3)
        CALL LENSTR_BL(CIF_CELL4,LC4)
        WRITE(IUN22,'(A,2X,F9.3)')
     *  CIF_CELL4(1:LC4),CELL(4)
        CALL LENSTR_BL(CIF_CELL5,LC5)
        WRITE(IUN22,'(A,3X,F9.3)')
     *  CIF_CELL5(1:LC5),CELL(5)
        CALL LENSTR_BL(CIF_CELL6,LC6)
        WRITE(IUN22,'(A,2X,F9.3)')
     *  CIF_CELL6(1:LC6),CELL(6)
C ---   symmetry

        CALL LENSTR_BL(CIF_SYMM_ID,LSD)
        WRITE(IUN22,'(A)')
     *  CIF_SYMM_ID(1:LSD)//'  '//CODE(1:LCD)

        IF(nspgrx.GT.0) THEN
          CALL LENSTR_BL(CIF_ITNUM,LN)
          WRITE(IUN22,'(A,5X,I6)')
     *    CIF_ITNUM(1:LN),nspgrx
        ENDIF

        IF(spgrnx(1:1).NE.' ') THEN
          CALL LENSTR_BL(CIF_GROUP,LG)
          CALL LENSTR_BL(spgrnx,L)
          WRITE(IUN22,'(A,5X,A)')
     *    CIF_GROUP(1:LG),''''//spgrnx(1:L)//''''
         ENDIF 
c
c        IF(nsym.GT.0) THEN
c
c          WRITE(IUN22,'(''loop_'')')
c          CALL LENSTR_BL(CIF_EQUIV_ID,LID)
c          WRITE(IUN22,'(A)') CIF_EQUIV_ID(1:LID)
c          CALL LENSTR_BL(CIF_EQUIV_XYZ,LXYZ)
c          WRITE(IUN22,'(A)') CIF_EQUIV_XYZ(1:LXYZ)
c
c          CALL symtr3(nsym,rsym,symchs,0)
c
c          DO  II = 1,nsym
c            CALL LENSTR_BL(symchs(II),L)
c            IF(L.LE.0) THEN
c              CALL ccperr(1,' ***Blank symop from symtr3!!!')
c            ENDIF
c            WRITE(IUN22,'(I5,3X,A)') II,''''//symchs(II)(1:L)//''''
c          ENDDO
c        ENDIF
C ---        

        WRITE(IUN22,'(''loop_'')')
        CALL LENSTR_BL(CIF_INDH,LH)
        WRITE(IUN22,'(A)') CIF_INDH(1:LH)
        CALL LENSTR_BL(CIF_INDK,LK)
        WRITE(IUN22,'(A)') CIF_INDK(1:LK)
        CALL LENSTR_BL(CIF_INDL,LL)
        WRITE(IUN22,'(A)') CIF_INDL(1:LL)
        IF(LOOKUP(N_FR).GT.0) THEN
          CALL LENSTR_BL(CIF_STAT,LST)
          WRITE(IUN22,'(A)') CIF_STAT(1:LST)
        ENDIF
        IF(LOOKUP(N_F).GT.0.OR.LOOKUP(N_FC).GT.0.OR.
     *     LOOKUP(N_PH).GT.0) THEN
C         FP         
          IF(LOOKUP(N_F).GT.0) THEN
            CALL LENSTR_BL(CIF_FP,LFP)
            WRITE(IUN22,'(A)') CIF_FP(1:LFP)
          ENDIF
C         SIGFP 
          IF(LOOKUP(N_SF).GT.0) THEN         
            CALL LENSTR_BL(CIF_SIGF,LSF)
            WRITE(IUN22,'(A)') CIF_SIGF(1:LSF)
          ENDIF
C         Fc
          IF(LOOKUP(N_FC).GT.0) THEN
            CALL LENSTR_BL(CIF_FC,L)
            WRITE(IUN22,'(A)') CIF_FC(1:L)
C           SFc
            IF(LOOKUP(N_SFC).GT.0) THEN
              CALL LENSTR_BL(CIF_SFC,L)
              WRITE(IUN22,'(A)') CIF_SFC(1:L)
            ENDIF
          ENDIF
C         PH
          IF(LOOKUP(N_PH).GT.0) THEN
            CALL LENSTR_BL(CIF_PH,L)
            WRITE(IUN22,'(A)') CIF_PH(1:L)
          ENDIF
C         FOM
          IF(LOOKUP(N_FOM).GT.0) THEN
            CALL LENSTR_BL(CIF_FOM,L)
            WRITE(IUN22,'(A)') CIF_FOM(1:L)
          ENDIF          
        ELSE
C         I
          CALL LENSTR_BL(CIF_INT,L)
          WRITE(IUN22,'(A)') CIF_INT(1:L)
C         SIGI 
          IF(LOOKUP(N_SI).GT.0) THEN
            CALL LENSTR_BL(CIF_SIGI,L)
            WRITE(IUN22,'(A)') CIF_SIGI(1:L)
          ENDIF
        ENDIF
C==========================================================================
C     Read input reflection file
C     
 410  CONTINUE

      FP    = 0.0
      SIG   = 0.0
      FF    = 0.0
      SDFF  = 0.0
      FC    = 0.0
      SFC   = 0.0
      PHASE = 0.0
      FOM   = 0.0
      IFLAG = 0

      danom     = 0.0
      sigdanom  = 0.0
      intens    = 0.0
      sigintens = 0.0

      CALL LRREFF(MTZIN,S,ADATA,EOF)
      IF(EOF) GO TO 370

      CALL LRREFM(MTZIN,LOGMSS)

      RSTAT = 'o'
      IF(LOOKUP(N_FR).GT.0) THEN
        IF(LOGMSS(N_FR)) THEN
          GO TO 410
        ELSE
          I= ADATA(N_FR)
          IF(I.LE.0) RSTAT='f'
        ENDIF
      ENDIF

      IF(SMIN.GT.0.00001.AND.S.LT.SMIN)  GO TO 410
      IF(SMAX.GT.0.00001.AND.S.GT.SMAX)  GO TO 410

      DO II = 1,3
        IN(II) = NINT(ADATA(II))
      ENDDO
      
      IF(LOOKUP(N_F).GT.0) THEN
        IF(LOGMSS(N_F)) THEN
          GO TO 410
        ELSE
          T    = ADATA(N_F)
          IF(T.GT.0.00001) THEN
            ff    = ADATA(N_F)
            sdff  = ADATA(N_SF)
            IFLAG = 1
          ENDIF
        ENDIF
      ENDIF

      IF(LOOKUP(N_FC).GT.0) THEN
        IF(LOGMSS(N_FC)) THEN
          GO TO 410
        ELSE
          T    = ADATA(N_FC)
          IF(T.GT.0.00001) THEN
            FC    = ADATA(N_FC)
            IFLAG = 1
          ENDIF
        ENDIF
      ENDIF

      IF(LOOKUP(N_SFC).GT.0) THEN
        IF(LOGMSS(N_SFC)) THEN
          GO TO 410
        ELSE
          T    = ADATA(N_SFC)
          IF(T.GT.0.00001) THEN
            SFC   = ADATA(N_SFC)
            IFLAG = 1
          ENDIF
        ENDIF
      ENDIF

      IF(LOOKUP(N_PH).GT.0) THEN
        IF(LOGMSS(N_PH)) THEN
          GO TO 410
        ELSE
          PHASE  = ADATA(N_PH)
          IFLAG  = 1
        ENDIF
      ENDIF

      IF(LOOKUP(N_FOM).GT.0) THEN
        IF(LOGMSS(N_FOM)) THEN
          GO TO 410
        ELSE
          FOM  = ADATA(N_FOM)
        ENDIF
      ENDIF

      IF(LOOKUP(N_I).GT.0) THEN
        IF(LOGMSS(N_I)) THEN
          GO TO 410
        ELSE
          T    = ADATA(N_I)
          IF(T.GT.0.00001) THEN
            intens    = ADATA(N_I)
            sigintens = ADATA(N_SI)
            IFLAG     = 1
          ENDIF
        ENDIF
      ENDIF

      IF(IFLAG.LE.0) THEN
        GO TO 410
      ENDIF
C ----
c      CALL SYSAB(IN,ISYSAB)
c      IF(ISYSAB.EQ.1) THEN
c        GO TO 410
c      ENDIF
C ---     
      fp  = ff
      sig = sdff

      IANOM = 1
      ISYM  = 0

      IF(LANOM) THEN
C
c       ISYM flag (from Truncate, if present):-
c       = 0 if both F+ & F- present
c       = 1 if only F+ (force this for centric reflections)
c       = 2 if only F-

        IF(LOOKUP(18).GT.0) THEN
          IF(LOGMSS(18)) THEN
            GO TO 410
          ELSE
            ISYM = NINT(ADATA(18))
          ENDIF
        ELSE
          ISYM = 0
        ENDIF
c
        IF(LOOKUP(N_DP).GT.0) THEN

          IF(LOGMSS(N_DP)) THEN
            GO TO 410
          ELSE
            T    = ADATA(N_DP)
            IF(T.GT.0.00001) THEN
              danom    = 0.5 * ADATA(N_DP)
              sigdanom = 0.5 * ADATA(N_SDP)
              IFLAG    = 1
            ENDIF
          ENDIF

        ENDIF

        IF(LOOKUP(N_SDP).GT.0.AND.sigdanom .EQ.0.0) THEN
          danom = 0.0
        ENDIF

C       Centric test
c        CALL CENTR(IN,ICEN)
c        IF(ICEN.EQ.1) THEN
c          ISYM = 1
c        ENDIF

        IF(ISYM.EQ.2) THEN
          IANOM = 2
        ENDIF


C          WRITE(*,*) FF,T,isym,LOGMSS(N_DP)

      ENDIF
c
C loop round +h+k+l and -h-k-l
C
 460  IF(LANOM) THEN

        IF(IANOM.EQ.2) THEN

          danom = -danom

          DO II = 1,3
            IN(II) = -IN(II)
          ENDDO

          IF(LOOKUP(N_IM).GT.0) THEN
            IF(LOGMSS(N_IM)) THEN
              GO TO 410
            ELSE
              T    = ADATA(N_IM)
              IF(T.GT.0.00001) THEN
                intens    = ADATA(N_IM)
                sigintens = ADATA(N_SIM)
                IFLAG     = 1
              ENDIF
            ENDIF
          ENDIF

          IF(LOOKUP(N_FM).GT.0) THEN
            IF(LOGMSS(N_FM)) THEN
              GO TO 410
            ELSE
              T    = ADATA(N_FM)
              IF(T.GT.0.00001) THEN
                FP    = ADATA(N_FM)
                SIG   = ADATA(N_SFM)
                IFLAG     = 1
              ENDIF
            ENDIF
          ENDIF

        ENDIF

        IF(LOOKUP(N_DP).GT.0) THEN
          IF(LOGMSS(N_DP)) THEN
            GO TO 410
          ELSE
            T    = ADATA(N_F)
            IF(T.GT.0.00001) THEN
              fp    = ff + danom
              sig   = sqrt(sdff**2 + sigdanom**2)
              IFLAG = 1
            ENDIF
          ENDIF
        ENDIF

        IF(IFLAG.LE.0) THEN
          GO TO 410
        ENDIF

      ENDIF
C ---
      IF(NRFOUT.GT.0.AND.MOD(NRFOUT,5000).EQ.0) THEN     

        IF(LOOKUP(N_IM).GT.0) THEN
          FTEMP   = intens
          SIGTEMP = sigintens
c          WRITE(*,
c     *    '(''N,hkl,I,sig,stat :'',I8,1X,3I5,2X,2G16.4,1X,A1)') 
c     *    NRFOUT,IN(1),IN(2),IN(3),FTEMP,SIGTEMP,RSTAT
        ELSE
          FTEMP   = FP
          SIGTEMP = SIG
c          WRITE(*,
c     *    '(''N,hkl,F,sig,stat :'',I8,1X,3I5,2X,2G16.4,1X,A1)') 
c     *    NRFOUT,IN(1),IN(2),IN(3),FTEMP,SIGTEMP,RSTAT
        ENDIF

      ENDIF
C        
      NRFOUT = NRFOUT+1
C ---
C     write CIF
C
      WRITE(LINE_CIF(1:14),'(I4,1X,I4,1X,I4)')
     * IN(1),IN(2),IN(3)
      LS=14


C     rstat
      IF(LOOKUP(N_FR).GT.0) THEN
        LINE_CIF=LINE_CIF(1:LS)//' '//RSTAT
        LS=LS+2
      ENDIF

      IF(LOOKUP(N_F).GT.0.OR.LOOKUP(N_FC).GT.0.OR.
     *   LOOKUP(N_PH).GT.0) THEN
C       FP         
        IF(LOOKUP(N_F).GT.0) THEN
          WRITE(CH20,'(1X,F15.2,4X)') FP
          CALL LENSTR_BL(CH20,L)
          LINE_CIF=LINE_CIF(1:LS)//CH20(1:L)
          CALL LENSTR_BL(LINE_CIF,LS)
        ENDIF
C       SIGFP 
        IF(LOOKUP(N_SF).GT.0) THEN         
          WRITE(CH20,'(1X,F15.2,4X)') SIG
          CALL LENSTR_BL(CH20,L)
          LINE_CIF=LINE_CIF(1:LS)//CH20(1:L)
          CALL LENSTR_BL(LINE_CIF,LS)
        ENDIF

C       Fc
        IF(LOOKUP(N_FC).GT.0) THEN
          WRITE(CH20,'(1X,F15.2,4X)') FC
          CALL LENSTR_BL(CH20,L)
          LT=LS+L
          IF(LT.GT.80) THEN
            WRITE(IUN22,'(A)') LINE_CIF(1:LS)
            LINE_CIF='  '//CH20(1:L)
            CALL LENSTR_BL(LINE_CIF,LS)            
          ELSE
            LINE_CIF=LINE_CIF(1:LS)//CH20(1:L)
            CALL LENSTR_BL(LINE_CIF,LS)
          ENDIF
C          SFC
          IF(LOOKUP(N_SFC).GT.0) THEN
            WRITE(CH20,'(1X,F15.2,4X)') SFC
            CALL LENSTR_BL(CH20,L)
            LT=LS+L
            IF(LT.GT.80) THEN
              WRITE(IUN22,'(A)') LINE_CIF(1:LS)
              LINE_CIF='  '//CH20(1:L)
              CALL LENSTR_BL(LINE_CIF,LS)            
            ELSE
              LINE_CIF=LINE_CIF(1:LS)//CH20(1:L)
              CALL LENSTR_BL(LINE_CIF,LS)
            ENDIF
          ENDIF
        ENDIF
C       PH
        IF(LOOKUP(N_PH).GT.0) THEN
          WRITE(CH20,'(1X,F8.2,11X)') PHASE
          CALL LENSTR_BL(CH20,L)
          LT=LS+L
          IF(LT.GT.80) THEN
            WRITE(IUN22,'(A)') LINE_CIF(1:LS)
            LINE_CIF='  '//CH20(1:L)
            CALL LENSTR_BL(LINE_CIF,LS)            
          ELSE
            LINE_CIF=LINE_CIF(1:LS)//CH20(1:L)
            CALL LENSTR_BL(LINE_CIF,LS)
          ENDIF
        ENDIF
C       FOM
        IF(LOOKUP(N_FOM).GT.0) THEN
          WRITE(CH20,'(1X,F6.3,13X)') FOM
          CALL LENSTR_BL(CH20,L)
          LT=LS+L
          IF(LT.GT.80) THEN
            WRITE(IUN22,'(A)') LINE_CIF(1:LS)
            LINE_CIF='  '//CH20(1:L)
            CALL LENSTR_BL(LINE_CIF,LS)            
          ELSE
            LINE_CIF=LINE_CIF(1:LS)//CH20(1:L)
            CALL LENSTR_BL(LINE_CIF,LS)
          ENDIF
        ENDIF          
      ELSE
C       I
        WRITE(CH20,'(1X,F15.2,4X)') intens
        CALL LENSTR_BL(CH20,L)
        LINE_CIF=LINE_CIF(1:LS)//CH20(1:L)
        CALL LENSTR_BL(LINE_CIF,LS)
C       SIGI 
        IF(LOOKUP(N_SI).GT.0) THEN
          WRITE(CH20,'(1X,F15.2,4X)') sigintens
          CALL LENSTR_BL(CH20,L)
          LINE_CIF=LINE_CIF(1:LS)//CH20(1:L)
          CALL LENSTR_BL(LINE_CIF,LS)
        ENDIF
      ENDIF

      IF(LS.GT.0) THEN
        WRITE(IUN22,'(A)') LINE_CIF(1:LS)
      ENDIF

      IF(LANOM) THEN
        IF(IANOM.EQ.1.AND.ISYM.NE.1) THEN
          IANOM = 2
          IFLAG = 0
          GO TO 460
        ENDIF
      ENDIF

      GO TO 410
C ------------------------------------------------------------
  370 CONTINUE

C ---
c      WRITE(*,*) ' -----------------------------'
      WRITE(*,'(''Number of reflections :'',I9)') NRFOUT
      END FILE IUN22
      CLOSE(UNIT=IUN22,STATUS='KEEP')
      WRITE(*,*)

      CALL LRCLOS(MTZIN)
C     CALL CCPERR(0,'Normal termination')

      RETURN
      END

      SUBROUTINE FINISH_CCP4(IERR)
C
C     FINISH - close DOC-file and EXIT.
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*80
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ---
C ******
      INTEGER*4 M
      CHARACTER LINE*80
C -------------------------
      M=-1
      CALL LENSTR_BL(PROGRAMM,LEN)
      IF(LEN.LE.0) THEN
        LEN=1
        PROGRAMM(1:1)=' '
      ELSE IF(LEN.GT.20) THEN
        LEN=20
      ENDIF
      WRITE(LINE,10) PROGRAMM(1:LEN)      
  10  FORMAT(' **** END //////// ',A,' ///////// END ****')
      CALL MSGDOC(M,LINE)
      IF(DOC_FILE.GT.0) THEN
        END FILE DOC_FILE
        CLOSE(DOC_FILE)
      ENDIF
      IF(BATCH_FILE.GT.0) THEN
C        WRITE(LINE,20) PROGRAMM(1:LEN)      
C  20    FORMAT('_END   ',A)
C        CALL WRT_BATCH(LINE)
        LINE='stop'
        CALL WRT_BATCH(LINE)
        END FILE BATCH_FILE
        CLOSE(BATCH_FILE)
      ENDIF

      IF(IERR.EQ.0) THEN
        CALL CCPERR(0,'Normal termination')
      ELSE
        CALL CCPERR(1,'Failure')
      ENDIF

C     CALL EXIT
      END          

C -I-
      SUBROUTINE CCP42DNS(MDOC,NAME1,NAMEW,RMAX,RESOL,P1
     *    ,ISYM,IPRSYM,IERR)
C ---------------------------------------------
C -P-
C CCP42DNS converts CCP4 density map to BLANC format 
C -S-
C      Dialogue and Batch:
C
C   FILE_1:       - name of input dens-file.
C   FILE_O:       - output_file 
C
C      SUBROUTINE CCP42DNS(MDOC,NAME1,NAMEW
C     *    ,POOL,MEMORY,IERR)
C
C      Parameters:
C
C      MDOC  - mode of writing messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C      NAME1  - name of input dens-file.
C      NAMEW  - name of output dens-file.
C      POOL   -  real array POOL(MEMORY).
C      MEMORY -  is memory for one Z-section of electron
C                density NX x NY.
C      IERR   - signal of error / =1 -error , =o - OK / 
C -I-
C ----------------------
      INTEGER*2 ISYM(5,3,IPRSYM)

c     REAL      POOL(MEMORY),POOLW(MEMORY)
      real,   allocatable :: POOL(:)
      real,   allocatable :: POOLW(:)

      CHARACTER NAME1*(*),NAMEW*(*)
      CHARACTER TTTW*80,TYPE*4,SGNAME*24
      CHARACTER LINE*80
      CHARACTER CODE*4,STR_TITLE*40,STR_DATE*9,SPGR*24,P1*1
C -------------------------------
      INTEGER    IUVW(3),MXYZ(3)
      REAL       CELL(6)
      CHARACTER  MAPTITLE*80
      INTEGER    IGRID(50)
C              1  2   3   4   5   6   7   8    9  10
      DATA IGRID/  4,  6,  8, 10, 12, 16, 20, 24, 30, 32
     *          , 36, 48, 50, 54, 60, 64, 72, 80, 90, 96
     *          ,100,108,120,128,132,144,150,160,162,180
     *          ,192,200,216,240,250,256,264,270,288,300
     *          ,320,324,360,384,400,432,450,480,500,512/
      DATA NGRID/50/
C ----------------------------------------------------------------------
      PI      = 4.0*ATAN(1.0)
      CONV    = 180./PI
      MD      =-ABS(MDOC)-1
      M       = 99
      M0      = 0
      IERR    = 0
      IF(P1.EQ.'y') P1 = 'Y'
      IF(P1.NE.'Y') P1 = 'N'
c      IF(SCALE.LT.0.0000001) SCALE =1.0
C ----------------------
C INITIALIZE CCP4 ROUTINES
C      CALL CCPFYP
C  Open MAPIN and read map header
      IUN = 10
      CALL CORR_NAME_BL(NAME1)
      CALL LENSTR_BL(NAME1,LEN)
      IPRINT = 0
      IFAIL  = 0
C -------------
      call mrdhds(IUN,NAME1(1:LEN),MAPTITLE,NSEC,IUVW
     * ,mxyz,nw1,nu1,nu2,nv1,nv2,cell,lspgrp,lmode
     * ,RHMIN,RHMAX,RHMEAN,RHRMS,IFAIL,IPRINT)
C --------------
c      write(*,*)  'nsec,iuvw:',NSEC,IUVW(1),IUVW(2),IUVW(3)
c      write(*,*)  'nw1,nu1,nu2,nv1,nv2:',nw1,nu1,nu2,nv1,nv2
c      write(*,*)  'mxyz:',MXYZ(1),MXYZ(2),MXYZ(3)        
c      write(*,*)'cell:',CELL(1),CELL(2),CELL(3),CELL(4),CELL(5),CELL(6)
c      write(*,*)  'gr:',lspgrp,lmode
c      write(*,*)  'title:',MAPTITLE
c      write(*,*)   RHMIN,RHMAX,RHMEAN,RHRMS
C ---------------------
c  IUVW (O)   3 word array with fast, medium, slow axes (1=X, 2=Y, 3=Z)
c  MXYZ (O)   3 word array with sampling intervals along whole cell on X, Y,
c             Z
c   NW1 (O)   No. of first section
c   NU1 (O)   Start of section on fast axis (grid units)
c   NU2 (O)   End of section on fast axis
c   NV1 (O)   Start of section on medium axis
c   NV2 (O)   End of section on medium axis
C LMODE (O)   Map data mode =0, byte
C                           =1, INTEGER*2
C                           =2, REAL
C                           =3, COMPLEX INTEGER*2
C                           =4, COMPLEX REAL
C                           =5, Treated as mode 0
C             Only mode 2 and 0 should occur with CCP4 programs
C IFAIL (I/O)  On input:     =0, stop on error
C                             =1, return on error
C              On output:    unchanged if no error
C                             =-1, error
C  IPRINT (I)                 = 0; silent
C                          .ne. 0; print file name, header info etc
C ---------------------
      MTS       = 11
      TYPE      = 'RI  '
      IPRINT    = 1
      ISETT     = 0
      NSETT     = 0
      IF(LMODE.NE.2) THEN
        IERR = 1
        WRITE(LINE,
     *  '('' ERROR: lmode='',I4,''  Only mode 2 should occur'')')
     *             LMODE
        CALL MSGERR(MDOC,LINE)
        GO TO 900
      ENDIF
C     CALL C_CR_WR
C      C1     = CELL(IUVW(1))
C      C2     = CELL(IUVW(2))
C      C3     = CELL(IUVW(3))
C      C4     = CELL(IUVW(1)+3)
C      C5     = CELL(IUVW(2)+3)
C      C6     = CELL(IUVW(3)+3)
      C1     = CELL(1)
      C2     = CELL(2)
      C3     = CELL(3)
      C4     = CELL(4)
      C5     = CELL(5)
      C6     = CELL(6)
      CELL(4)= C4/CONV
      CELL(5)= C5/CONV
      CELL(6)= C6/CONV
      ALW    = CELL(4)
      BEW    = CELL(5)
      GAW    = CELL(6)
C      DX     = C1/ABS(MXYZ(IUVW(1)))
C      DY     = C2/ABS(MXYZ(IUVW(2)))
C      DZ     = C3/ABS(MXYZ(IUVW(3)))
      DX     = C1/MXYZ(1)
      DY     = C2/MXYZ(2)
      DZ     = C3/MXYZ(3)
      IF(IUVW(3).NE.3) THEN
        LINE = ' WARNING: slow axes must be Z (IUVW(3)=3)'
        CALL MSGERR(MDOC,LINE)
        LINE = '          now 1=Xnew, 2=Ynew, 3=Znew'
        CALL MSGERR(MDOC,LINE)
C        IERR = 1
C        GO TO 900   
        INVERT = 0
        NU1W = NU1
        NU2W = NU2
        NV1W = NV1
        NV2W = NV2
      ELSE IF(IUVW(1).EQ.2) THEN
        INVERT = 1
        NU1W = NV1
        NU2W = NV2
        NV1W = NU1
        NV2W = NU2
      ELSE
        INVERT = 0
        NU1W = NU1
        NU2W = NU2
        NV1W = NV1
        NV2W = NV2
      ENDIF      

      NX     = NU2-NU1+1
      NY     = NV2-NV1+1
      NXW    = NU2W-NU1W+1
      NYW    = NV2W-NV1W+1
      IF(NXW.LT.MXYZ(1).OR.NYW.LT. MXYZ(2)) THEN
        IPART = 1
c        IXADD = NXW/4
c        IYADD = NYW/4
        IXADD  = 0
        IYADD  = 0
        NXW    = NXW + IXADD*2
        NYW    = NYW + IYADD*2
      ELSE
        IPART  = 0
        IXADD  = 0
        IYADD  = 0
        NXW    = MXYZ(1)
        NYW    = MXYZ(2)
      ENDIF

C     NZ     = NSEC
C     NZ     = ABS(MXYZ(IUVW(3)))
      NZ     = MXYZ(3)
      NXY    = NX*NY

      IF(lspgrp.GT.1.AND.P1.NE.'Y') THEN

C        CALL MSGERR(MDOC,
C     *'WARNING: only P1 space group can be managed')
C        CALL MSGERR(MDOC,
C     *'         space group will be changed to P1')
C ---
            NOSPGR = lspgrp
            IF(NOSPGR.GT.1000) THEN

              ISETT  = NOSPGR/1000
              NOSPGR = NOSPGR - ISETT*1000
              ISETT  = ISETT + 1
              NOSG   = NOSPGR

              IF(NOSG.EQ.3.OR.NOSG.EQ.4.OR.NOSG.EQ.146.OR.
     *           NOSG.EQ.155) THEN
                IF(ISETT.EQ.1) THEN
                  ISETT = 2
                ELSE IF(ISETT.EQ.2) THEN  
                  ISETT = 1
c                ELSE IF(ISTT.EQ.4) THEN  
c                  ISTT = 3
                ENDIF
              ELSE IF(NOSG.EQ.  5) THEN
                IF(ISETT.EQ.1) THEN
                  ISETT = 2
                ELSE IF(ISETT.EQ.2) THEN  
                  ISETT = 1
c                ELSE IF(ISETT.EQ.3) THEN  
c                  ISETT = 4
c                ELSE IF(ISETT.EQ.4) THEN  
c                  ISETT = 3
                ENDIF
              ENDIF
            ENDIF

            IF(NOSPGR.LT.1.OR.NOSPGR.GT.230) THEN
              CALL MSGERR(MDOC
     *        ,' WARNING: wrong card "CRYST1" of PDB_file')
              CALL MSGERR(MDOC
     *        ,'          default space group: "P 1"')
              NOSPRG = 1
              ISETT  = 1
            ENDIF
            IF(NOSPRG.EQ.146.OR.NOSPRG.EQ.155) THEN
              ISETT  = 1
              T= (PI*2.0)/3.0
              IF(ABS(CELL(6)-T).LE.0.0001) ISETT = 2
            ENDIF
            IF(NOSPGR.GE.3.AND.NOSPGR.LE.5) THEN
              IF(ISETT.LE.0) ISETT  = 2
              IF(ISETT.EQ.2) THEN
                T = PI/2.0
                IF(ABS(CELL(6)-T).GT.0.0001) ISETT=1
              ELSE IF(ISETT.EQ.1) THEN
                T = PI/2.0
                IF(ABS(CELL(5)-T).GT.0.0001) ISETT=2
              ENDIF
            ENDIF
            IF(ISETT.LE.0) ISETT  = 1
            SGNAME = ' '
            NSETT  = ISETT
            NSG    = NOSPGR 

          CALL GET_SYMM(MDOC,NSG,NSETT,SGNAME,NSYM,ISYM
     *                                            ,IPRSYM,IERR)
C ---
        SPGR   = SGNAME 
        NSETT  = ISETT
        NGROUP = NSG    

      ELSE
        NSYM    = 1
        DO I=1,5
        DO J=1,3
          ISYM(I,J,1) = 0
        ENDDO
        ENDDO
        ISYM(1,1,1) = 1
        ISYM(2,2,1) = 1
        ISYM(3,3,1) = 1
        ISYM(5,1,1) = 1
        ISYM(5,2,1) = 1
        ISYM(5,3,1) = 1
        NGROUP    = 1
        NSETT     = 1
        SPGR      = 'P 1'
      ENDIF

      IZMIN  = 0
      IZMAX  = NSEC-1
C ---
      CELL(1) = NXW*DX 
      CELL(2) = NYW*DY
      CELL(3) = NZ*DZ
      AW      = CELL(1)
      BW      = CELL(2)
      CW      = CELL(3)
c      IX0     = -NU1
c      IY0     = -NV1
c      IZ0     = -NW1
      IX0     = NU1W
      IY0     = NV1W
      IZ0     = NW1
C ---
      DDM     = 0.0
      CODE      = 'XXXX'
      CALL LENSTR_BL(MAPTITLE,LT) 
      L = LT
      IF(L.GT.40) THEN
        IF(L.GT.40) L = 40
        J = 0
        CALL CHECK_LINE(J,MAPTITLE(1:L))
        STR_TITLE = MAPTITLE(1:L)
        CALL LENSTR_BL(STR_TITLE,L) 
        IF(L.LE.0) THEN
          STR_TITLE = '----------------'
          L = 16
        ENDIF
      ELSE           
        STR_TITLE = '----------------'
        L = 16
      ENDIF
      STR_DATE  = 'XX-XXX-XX'
      DO I=1,80
        TTTW(I:I) = ' '
      ENDDO
c                    9012345678
      TTTW(69:78) = '?    ?    '
      TTTW(1:4)   = 'CCP4'
      TTTW(5:8)   = '    '
      TTTW(9:8+L) = STR_TITLE(1:L)      
C ----
C     RESOL  = 3.0
      CR     = 3.0
      CR     = 2.5
      RESOL  = (AW*CR)/NXW
      T      = (BW*CR)/NYW
      IF(T.GT.RESOL) RESOL = T
      T      = (CW*CR)/NZ
      IF(T.GT.RESOL.AND.NZ.GT.1) RESOL = T
      RESOL = RESOL + 0.001
      ITR    = 0
      IF(IPART.NE.0) THEN
        IX0     = 0
        IY0     = 0 
        ITR = 1
      ENDIF
C ----
      WRITE(LINE,
     *  '('' Input Cell  :'',3F8.3,3F8.2)') AW,BW,CW,C4,C5,C6
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Grid        :'',3I5)') NX,NY,NZ
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Origin      :'',3I5)') IX0,IY0,IZ0
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Rmax,Rmin   :'',2G14.4)')   RHMAX,RHMIN
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *  '('' Resolution from grid:'',F8.1)') RESOL
      CALL MSGDOC(MDOC,LINE)
      NX_NEW = 0
      DO   I=1,NGRID
        IF(NX.EQ.IGRID(I)) GO TO 100
        IF(NX.LT.IGRID(I)) THEN
          NX_NEW = IGRID(I)
          GO TO 100
        ENDIF
      ENDDO
  100 CONTINUE
      NY_NEW = 0
      DO   I=1,NGRID
        IF(NY.EQ.IGRID(I)) GO TO 110
        IF(NY.LT.IGRID(I)) THEN
          NY_NEW = IGRID(I)
          GO TO 110
        ENDIF
      ENDDO
  110 CONTINUE
      NZ_NEW = 0
      DO   I=1,NGRID
        IF(NZ.EQ.IGRID(I)) GO TO 120
        IF(NZ.LT.IGRID(I)) THEN
          NZ_NEW = IGRID(I)
          GO TO 120
        ENDIF
      ENDDO
  120 CONTINUE

      IF(NX_NEW.NE.0.OR.NY_NEW.NE.0.OR.NZ_NEW.NE.0) THEN
        IF(NX_NEW.EQ.0) NX_NEW = NX 
        IF(NY_NEW.EQ.0) NY_NEW = NY 
        IF(NZ_NEW.EQ.0) NZ_NEW = NZ 
        CALL MSGDOC(MDOC,' ')
        CALL MSGDOC(MDOC,'ERROR: grid is not suitable for FFT')
        WRITE(LINE,'(''       Correct Grid  :'',3I5)')
     *                                  NX_NEW,NY_NEW,NZ_NEW
        CALL MSGDOC(MDOC,LINE)
        CALL MSGDOC(MDOC,' ')
        CALL MSGDOC(MDOC,'INFO: use "sfcheck -f file.map -map" ')
        CALL MSGDOC(MDOC,'           to get new map with correct grid')
        CALL MSGDOC(MDOC,' ')
      
        IERR = 1
        GO TO 900

      ENDIF
C ---
      CALL SET_CELL(CELL,CODE,STR_TITLE,STR_DATE,TTTW
     *      ,NGROUP,NSETT,SPGR,IERR)

      CALL C_CR_WR
      CALL SET_TITLE(M,AW,BW,CW,ALW,BEW,GAW
     *  ,DDM,DDM,DDM,DDM,NXW,NYW,NZ,IZMIN,IZMAX,TTTW,IERR)

      CALL OWFILE(M,MTS,NAMEW,TYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
      ITR    = 0
C ----
      ICNTZ3 =-999
      NXY    = NX*NY
      NXYW   = NXW*NYW

      IT = 0
      allocate(POOL(1:NXY),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(POOLW(1:NXYW),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      IF(IT.NE.0) THEN
        IERR = 1
        CALL MSGERR(MDOC,
     *    ' ERROR: in  CCP42DNS : problem with memory allocation')
        GO TO 900
      ENDIF

      DO IZ=1,NSEC

        DO I=1,NXYW
          POOLW(I) = 0.0
        ENDDO

        CALL MGULP(IUN,POOL,IERR)
c        CALL MGULPr(IUN,POOL,IERR)

        DO IY=NV1,NV2
          INDY = (IY-NV1)*NX
          DO IX=NU1,NU2
           IND = INDY + IX - NU1 + 1
           IF(INVERT.LE.0) THEN  
              POOLW(IND) = POOL(IND)
           ELSE
             JNDY = (IX-NU1+IYADD)*NXW
             JND = JNDY + IY - NV1 + 1 + IXADD
             POOLW(JND) = POOL(IND)
           ENDIF
         ENDDO
        ENDDO 

        CALL WDENS(MTS,M,ICNTZ3,NXW,NYW,NZ,IZMIN,IZMAX,
     *               RMAX,RMIN,POOLW,RESOL,IX0,IY0,IZ0,ITR)
      ENDDO
C ---------------------
      CLOSE(MTS)

      deallocate(POOL,STAT=ISTAT)
      deallocate(POOLW,STAT=ISTAT)

 900  CONTINUE
      call mrclos(iun)
C ---------------------
      RETURN
      END





