C
C     MOLREP molecular replacement program
C     Copyright (C) 1999-2006 Alexei Vagin
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C

      SUBROUTINE SFFT(MDOC,NX,NY,NZ,IZMIN,IZMAX,F000,NAMEC
     * ,NAMED,ISYM,IH,IK,IL,FA,FB,IPRSYM,IERR)
C ---------------------------------------------
c      COMPLEX   POOL(*)
      complex,  allocatable :: POOL(:)

      INTEGER*2 ISYM(5,3,IPRSYM)

      INTEGER   IH(IPRSYM),IK(IPRSYM),IL(IPRSYM)
      REAL      FA(IPRSYM),FB(IPRSYM)

      INTEGER*4 NX,NY,NZ,IZMIN,IZMAX
      INTEGER*4 MDOC,NCRES2,IPRSYM,IERR
      REAL      F000
      CHARACTER NAMEC*(*),NAMED*(*)
C ---
      COMMON/COMRDF/ A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
     *              ,RN_RD,RX_RD,CF_RD,TF_RD
     *              ,NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
     *              ,NS_RD,IS_RD,IER_RD,IEN_RD
     *              ,TP_RD,T1_RD,T2_RD,TL_RD,DT_RD
     *              ,CD_RD,SG_RD,PT_RD,PD_RD
      REAL A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
      REAL RN_RD,RX_RD,CF_RD,TF_RD
      INTEGER*4 NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
      INTEGER*4 NS_RD,IS_RD,IER_RD,IEN_RD
      CHARACTER TP_RD*4,T1_RD*4,T2_RD*4,TL_RD*80,DT_RD*20     
      CHARACTER CD_RD*4,SG_RD*24,PT_RD*40,PD_RD*9
C ---
      INTEGER*4 NSPGR,NSETT
      CHARACTER CODEPDB*4,NAMEPDB*40
      CHARACTER CODESG*11,DATEPDB*9
C --------------
      INTEGER*4 IDIM(3)
      COMPLEX   CDM,SM
      REAL      RLATT(6)
      REAL      CZL(512),SZL(512)
      CHARACTER TITLE*80,ITP*4,LINE*80,MSG*1,P1*1
C ==============================================================
      P1 = 'N'
      IF(IERR.EQ.1) P1 = 'Y'
      IERR  = 0
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
C --------------------
C      WRITE(*,'(''       INPUT-FILE /COEF/'')')
      MTIN  =25
      ITP   ='COEF'
      MD=-ABS(MDOC)-1
      CALL ORFILE(MD,MTIN,NAMEC,ITP,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: FFT: OPEN FILE-coef')
        RETURN
      ENDIF
      CALL GET_TITLE(MD,RLATT(1),RLATT(2),RLATT(3),RLATT(4),RLATT(5)
     * ,RLATT(6),F1,F2,F3,RX,IDM,IDM,IDM,IDM,IDM,TITLE,IERR)


      IF(TITLE(5: 8).EQ.'TRNS'.OR.TITLE(5: 8).EQ.'REAL'.OR.
     *   TITLE(5: 8).EQ.'MULT'.OR.TITLE(5: 8).EQ.'PACK') THEN  
        NSYM=1
        NS_RD=1
        SG_RD='P 1'
      ENDIF      
      CALL C_RD_CR
C ----
      A    =RLATT(1)
      B    =RLATT(2)
      C    =RLATT(3)
      ALPHA=RLATT(4)
      BETA =RLATT(5)
      GAMMA=RLATT(6)
C ----
C     VOLUME OF CELL
C
      S=(ALPHA+BETA+GAMMA)*0.5
      VOL=2.0*A*B*C*
     *    SQRT(SIN(S)*SIN(S-ALPHA)*SIN(S-BETA)*SIN(S-GAMMA))
C ----
      CALL LIMHKL(RX,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)
C ----
      MD=-ABS(MDOC)-1
      CALL MSGDOC(MD,'Minimal grid spacing for calculation SF:') 
      WRITE(LINE,1000) NXMIN,NYMIN,NZMIN
 1000 FORMAT(' NXmin=',I3,', NYmin=',I3,', NZmin=',I3) 
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,1020) IHMAX,IKMAX,ILMAX
 1020 FORMAT(' Hmax,Kmax,Lmax :',3I4)
      CALL MSGDOC(MD,LINE)
      IF(NX.LE.0) NX=NXMIN
      IF(NY.LE.0) NY=NYMIN
      IF(NZ.LE.0) NZ=NZMIN
      NX   =(NX/2)*2
      NY   =(NY/2)*2
      NZ   =(NZ/2)*2
      IF(NX.LT.2*IHMAX+1) 
     * CALL MSGDOC(MD,' !!! Warning : Nx < 2Hmax+1')
      IF(NY.LT.2*IKMAX+1) 
     * CALL MSGDOC(MD,' !!! Warning : Ny < 2Kmax+1')
      IF(NZ.LT.2*ILMAX+1) 
     * CALL MSGDOC(MD,' !!! Warning : Nz < 2Lmax+1')
      WRITE(LINE,1030) NX,NY,NZ
 1030 FORMAT('GRID: NX=',I3,', NY=',I3,', NZ=',I3) 
      CALL MSGDOC(MD,LINE)
      IF(ILMAX.LT.0)  ILMAX=0

c     IF(ILMAX.GT.99) ILMAX=99

      NX2  =NX/2
      NXY=NX*NY
      NCRES=NCRES2*2
c      IF(NXY.GT.NCRES) THEN
c        WRITE(LINE,
c     * '('' ERR: FFT: not enough memory for one section of dens.'')')
c        CALL MSGERR(MDOC,LINE)
c        WRITE(LINE,'('' NX='',I4,'' NY='',I4,'' MEMORY-SIZE='',I6)')
c     *                  NX,NY,NCRES
c        CALL MSGERR(MDOC,LINE)
c        WRITE(LINE,'('' must by: NX x NY < '',I6)') NCRES
c        CALL MSGERR(MDOC,LINE)
c        IERR=1
c        CLOSE(MTIN)
c        RETURN
c      ENDIF

      NXY=NXY/2
      allocate(POOL(1:NXY),STAT=ISTAT)
      IF(ISTAT.NE.0) THEN
        IERR = 1
        CALL MSGERR(MDOC,
     *    ' ERROR: in FFT : problem with memory allocation')
        CALL MSGERR(MDOC,
     *    '                 try to change resolution')
        CLOSE(MTIN)
        IF(MTF.GT.0) CLOSE(MTF)
        RETURN
      ENDIF

      IIZMIN=0
      IIZMAX=0
      CALL SET_LIMZ(NSYM,ISYM,NZ,IZMAXD)
      IF(IZMIN.EQ.0.AND.IZMAX.LT.0) THEN
        IIZMIN=0
        IIZMAX=IZMAXD
        IF(NSYM.EQ.2) THEN
          IF(ISYM(1,2,2).EQ.0.AND.
     *       ISYM(2,2,2).EQ.1.AND.
     *       ISYM(3,2,2).EQ.0     ) IIZMAX = NZ - 1
        ENDIF
        IF(IZMAX.LT.-1) IIZMAX = NZ/2 
        IF(P1.EQ.'Y') IIZMAX = NZ - 1
      ELSE
        IIZMAX=IZMAX
        IIZMIN=IZMIN
        IF(IIZMAX.LT.IIZMIN) THEN
          T=IIZMAX
          IIZMAX=IIZMIN
          IIZMIN=T
        ENDIF
      ENDIF
      IZMIN=IIZMIN
      IZMAX=IIZMAX

      IF(F000.EQ.0.0) THEN
        MSG='N'
      ELSE IF(F000.GT.0.0) THEN
        MSG='I'
      ELSE
        MSG='Y'
      ENDIF
      IF(TITLE(1:4).EQ.'PATT') THEN
        IPATT=1
        ITP  ='PATT'
      ELSE
        IPATT=0
        ITP  ='FOUR'
      ENDIF
      TITLE(1:4)=ITP
C ----
C     WRITE(*,*) '      OUTPUT-FILE /DENS/'
      MTOUT=0
      CALL LENSTR_BL(NAMED,LEN)
      IF(LEN.GT.0.AND.NAMED(1:1).NE.' '.AND.NAMED(1:1).NE.',') THEN
        MTOUT = 43
        ITP   = 'RI  '
        MD    =-ABS(MDOC)-1
        CALL C_CR_WR
        NSYMW = NSYM
        IF(P1.EQ.'Y') THEN
          NSYMW   = 1
          NSPGR   = 1
          NSETT   = 1
          CODESG  = 'P 1'
          CODEPDB = 'XXXX'
          NAMEPDB = 'XXXXXXXX    ?'
          DATEPDB = 'XX-XXX-XX'
          TITLE(1:4) = 'FOUR'
          CALL SET_WRF(NSPGR,NSETT,CODESG,CODEPDB
     *                  ,NAMEPDB,DATEPDB,TITLE)
        ENDIF

        CALL SET_TITLE(MD,RLATT(1),RLATT(2),RLATT(3),RLATT(4),RLATT(5)
     * ,RLATT(6),F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TITLE,IERR)

c        CALL WTITLE(MTOUT,NAMED,MDOC,ITP,IPRINT,A,B,C,ALPHA,BETA,
c     .  GAMMA,F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TITLE)

        CALL OWFILE(MD,MTOUT,NAMED,ITP,NSYMW,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          deallocate(POOL,STAT=ISTAT)
          CALL MSGERR(MDOC,' ERR: FFT: OPEN FILE-DENS')
          CLOSE(MTIN)
          CLOSE(MTOUT)
          RETURN
        ENDIF
      ELSE
        deallocate(POOL,STAT=ISTAT)
        CALL MSGERR(MDOC,' ERR: FFT: OUTPUT-DENS-FILE')
        IERR=1
        CLOSE(MTIN)
        RETURN
      ENDIF
C ----
c      ICPU=0
c      CALL CPU(ICPU)
C ----
      ZERO  =0.0
      CDM   =CMPLX(ZERO,ZERO)
      ITP   ='    '
      IPRINT=0
      IX0   =0
      IY0   =0
      IZ0   =IZMIN
      ITR   =0
      ICNTZ =-999
      IDIM(1)=NX2
      IDIM(2)=NY
      IDIM(3)=0
      IFIRST=0
C =================================================
      DO     IZ=IZMIN,IZMAX
        Z=FLOAT(IZ)/FLOAT(NZ)
        ANG=TWOPI*Z
        CSZ=COS(ANG)
        SNZ=SIN(ANG)
        CZL(1)=1.0
        SZL(1)=0.0
        DO     I=2,512
          CZL(I)=CZL(I-1)*CSZ-SZL(I-1)*SNZ
          SZL(I)=SZL(I-1)*CSZ+CZL(I-1)*SNZ
        ENDDO
        DO     I=1,NXY
          POOL(I)=CDM
        ENDDO
        IF(MSG.EQ.'I') THEN
          TEMP=F000
          SM=CMPLX(TEMP,ZERO)
          POOL(1)=SM
C ---
          IF(IFIRST.EQ.0) THEN
            WRITE(LINE,'(''input F000 ='',G16.4)') F000
            CALL MSGDOC(MDOC,LINE)
            IFIRST=1
          ENDIF
C -----
        ENDIF
C---------------
        REWIND MTIN
        MD=99
        CALL OPFILE(MD,MTIN,NAMEC,ITP,NSYM,ISYM,IPRSYM,IERR)
C        CALL PTITLE(MTIN,NAMEC,MDOC,ITP,IPRINT,DM,DM,DM,DM,DM,DM,
C     *            F1,F2,F3,F4,IDM,IDM,IDM,IDM,IDM,TITLE)
        IF(IERR.NE.0) THEN
          deallocate(POOL,STAT=ISTAT)
          CALL MSGERR(MDOC,' ERR: FFT: FILE-COEF')
          CLOSE(MTIN)
          IF(MTOUT.GT.0) CLOSE(MTOUT)
          IERR=1
          RETURN
        ENDIF
        IEND=-1
C----------------------------------------------------------------
  300   CONTINUE
        CALL RD1(MTIN,IH(1),IK(1),IL(1),FA(1),FB(1),NUMB,IEND)
        IF(MTIN.LE.0) THEN
          deallocate(POOL,STAT=ISTAT)
          CALL MSGERR(MDOC,' ERR: FFT: FILE-COEF')
          CLOSE(MTIN)
          IF(MTOUT.GT.0) CLOSE(MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(IEND.GT.0) GO TO 200
C ----------------------------------
C       USE F000
C
        IF(IH(1).EQ.0.AND.IK(1).EQ.0.AND.IL(1).EQ.0) THEN

          IF(MSG.EQ.'Y')THEN
            F000=FA(1)/(VOL)
            TEMP=F000
            SM=CMPLX(TEMP,ZERO)
            POOL(1)=SM
C ---
            IF(IFIRST.EQ.0) THEN
              WRITE(LINE,'('' F000 ='',G16.4)') F000
              CALL MSGDOC(MDOC,LINE)
              IFIRST=1
            ENDIF
          ENDIF
          GO TO 300
        ENDIF
C ------------------------
        FA(1)=FA(1)/(VOL)
        FB(1)=FB(1)/(VOL)
C ----------------------
        CALL GENER(IPATT,N,IH,IK,IL,FA,FB,NSYM,ISYM,IPRSYM)
C ------------------------
        DO     I=1,N
          JH =IH(I)
          JK =IK(I)
          JL =IL(I)
          FAA=FA(I)
          FBB=FB(I)
C         WRITE(*,'('' H,K,L,A,B:'',3I5,2F12.4)') JH,JK,JL,FAA,FBB
          IF(IABS(JL).LE.ILMAX.AND.
     *       IABS(JK).LE.IKMAX.AND.
     *       IABS(JH).LT.IHMAX     ) THEN
            IHD=JH+1
            IF(JK.LT.0) JK=NY+JK
            IKD=JK+1
            ILD=IABS(JL)+1
            IF(ILD.LE.512) THEN
              PCOS=CZL(ILD)
              PSIN=SZL(ILD)
              IF(JL.LT.0 ) PSIN=-PSIN
              AP = FAA * PCOS + FBB * PSIN
              BP = FBB * PCOS - FAA * PSIN
              SM=CMPLX(AP,BP)
              IND=(IKD-1)*NX2+IHD
              POOL(IND)=POOL(IND)+SM
            ENDIF
          ENDIF
        ENDDO
        GO TO 300
C--------------------------------------------
  200   CONTINUE
        CALL MDHFT(POOL,IDIM,IERR)
        IF(IERR.NE.0) THEN
          deallocate(POOL,STAT=ISTAT)
          CALL MSGERR(MDOC,' ERR: FFT: IN KERNEL-FFT')
          CLOSE(MTIN)
          CLOSE(MTOUT)
          IERR=1
          RETURN
        ENDIF
C--------------------------------------------------------------
        IF(MTOUT.GT.0) THEN
          CALL WDENS(MTOUT,MDOC,ICNTZ,NX,NY,NZ,IZMIN,IZMAX,RMAX,RMIN
     *             ,POOL,RX,IX0,IY0,IZ0,ITR)
          IF(MTOUT.LE.0) THEN
            deallocate(POOL,STAT=ISTAT)
            CALL MSGERR(MDOC,' ERR: FFT: FILE-DENS')
            CLOSE(MTIN)
            CLOSE(MTOUT)
            IERR=1
            RETURN
          ENDIF
        ENDIF
      ENDDO
C------------------------------------------------------------------
C      ICPU=1
C      CALL CPU(ICPU)
C ------------------------------------
      deallocate(POOL,STAT=ISTAT)
      CLOSE(MTIN)
      IF(MTOUT.GT.0) CLOSE(MTOUT)
      RETURN
      END
C -I-
      SUBROUTINE RFT(MDOC,RESMAX
     * ,NAMED,NAMEF,NAMEPH,PATH_SCR,ISYM,IPRSYM,RESULT,IERR)
C ---------------------------------------------
C -P- RFT  : fast fourie transform: real --> complex.
C            Program transforms contents of DENS-file to F and PH files.
C            For all space groups.
C -S-
C      Dialog and Batch:
C
C      FILE_D:  -  name of input dens-file.
C      FILE_F:  -  name of output file of modules of SF
C      FILE_PH: -  name of output file of phases  of SF
C      RESOL:  MAX <default from DENS-file> resolution
C
C      It possible to use subroutine RFT by program:
C
C      SUBROUTINE RFT(MDOC,POOL,MEMORY,RESMAX
C     * ,NAMED,NAMEF,NAMEPH,ISYM,IPRSYM,RESULT,IERR)
C
C      Parameters:
C
C      MDOC  - mode of writting messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C      NAMED - name of input dens-file.
C              Symmetry operators will be taken from this file.
C      NAMEF - name of output file of modules of SF
C      NAMEPH- name of output file of phases  of SF
C      RESMAX - resolution. Default values from DENS-file.
C      POOL   - real array (MEMORY)
C      MEMORY - is dimension of real array POOL.
C               NCRES= (MEMORY-IPRSYM*9-2)/2 is memory for
C               the one Z-section of electron density NX x NY < NCRES.
C      ISYM  - integer*2 array for cryst.symmetry operators 
C      IPRSYM- dimension of integer*2 array ISYM(5,3,IPRSYM)
C      IERR  - signal of error / =1 -error , =o - OK / 
C
C      RESULT /real RESULT(11)/ - array for output information:
C
C      RESULT(1) - number of refls
C      RESULT(2) - min resolution
C      RESULT(3) - max resolution
C      RESULT(4) - F(0,0,0)
C      RESULT(5) - <!F!> = sqrt(<I>)
C      RESULT(6) - < I > 
C -I-
C ---------------------------------------------
      REAL RESULT(*)
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER NAMED*(*),NAMEF*(*),NAMEPH*(*),NAME*256
      CHARACTER PATH_SCR*(*)

C      REAL      SFA(IPRSYM),SFB(IPRSYM)
C      REAL      SYM(3,IPRSYM)
C      INTEGER   JHS(IPRSYM),JKS(IPRSYM),JLS(IPRSYM),LSYM(IPRSYM)

      real,        allocatable :: POOL(:)
      real,        allocatable :: POOLC(:)
      integer,     allocatable :: IPOOL(:)
      real,        allocatable :: SFA(:)
      real,        allocatable :: SFB(:)
      real,        allocatable :: SYM(:,:)
      integer,     allocatable :: JHS(:)
      integer,     allocatable :: JKS(:)
      integer,     allocatable :: JLS(:)
      integer,     allocatable :: LSYM(:)

      CHARACTER LINE*256,ITYPE*4,TITLE*80
C--------------------------------------------------------------
      IERR = 0
      MD    =-ABS(MDOC)-1
      M     = 99

      NAME='molrp_scratch_rft'
      CALL ADD_PATH(PATH_SCR,NAME)

      MTIN  = 40
      ITYPE = 'RI  '
      CALL ORFILE(M,MTIN,NAMED,ITYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) THEN
        IERR=1
        RETURN
      ENDIF
      CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *        ,F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TITLE,IERR)
      CLOSE(MTIN)
      IF(IERR.GT.0) THEN
        IERR=2
        RETURN
      ENDIF

      NCRES = NX*NY*2
      ITEMP = NCRES + 1000
      IT = 0
      allocate(POOL(1:ITEMP),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(POOLC(1:ITEMP),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(IPOOL(1:ITEMP),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(SFA(1:IPRSYM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(SFB(1:IPRSYM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(SYM(1:3,1:IPRSYM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(JHS(1:IPRSYM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(JKS(1:IPRSYM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(JLS(1:IPRSYM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(LSYM(1:IPRSYM),STAT=ISTAT)
      IF(IT.GT.0) THEN
        IERR = 1
        CALL MSGERR(MDOC,
     *    ' ERROR: in RFT: problem with memory allocation')
        CALL MSGERR(MDOC,
     *    '                try to change resolution')
        RETURN
      ENDIF

      CALL RFT1(MDOC,POOL(2),POOL(1),POOL(2),NCRES,RESMAX
     * ,NAMED,NAMEF,NAMEPH,IPRSYM
     * ,SFA,SFB,SYM,JHS,JKS,JLS,LSYM,ISYM
     * ,RESULT,IERR)
      IF(IERR.EQ.-1) THEN
        IERR=0
        CALL RFT2(MDOC,POOL(2),POOL(1),POOL(2),NCRES,RESMAX
     *  ,NAMED,NAMEF,NAMEPH,NAME,IPRSYM
     *  ,SFA,SFB,SYM,JHS,JKS,JLS,LSYM,ISYM
     *  ,POOLC,IPOOL,NCRES
     *  ,RESULT,IERR)
      ENDIF

      deallocate(POOL,STAT=ISTAT)
      deallocate(POOLC,STAT=ISTAT)
      deallocate(IPOOL,STAT=ISTAT)
      deallocate(SFA,STAT=ISTAT)
      deallocate(SFB,STAT=ISTAT)
      deallocate(SYM,STAT=ISTAT)
      deallocate(JHS,STAT=ISTAT)
      deallocate(JKS,STAT=ISTAT)
      deallocate(JLS,STAT=ISTAT)
      deallocate(LSYM,STAT=ISTAT)

      CALL DELETE_FILE(' ',NAME)

      RETURN
      END

C -I-
      SUBROUTINE REDUCT(MDOC,NAMED,NAMEO,RESULT
     *    ,NXY,MODE,ISYM,IPRSYM,IERR)
C ---------------------------------------------
C -P- REDUCT : check asymmetric part, other part will be equaled to zero.
C              Program reads file type of "RI" (electron density),
C              and writes output file only asymmetric part of input file 
C              and to equal to zero remaining part of informations.
C -S-
C
C  Dialog and Batch: 
C
C      FILE_D: - name of input dens-file.
C      MODE:   - <R> - /default/  reduct for all space groups.
C                 C  -  for C2221
C                 P  -  for P212121
C                 4  -  for P43212
C                 I  -  for I4
C      FILE_O: - name of output dens-file /'' '' - means without this file/.
C
C      Parameters of subroutine REDUCT:
C
C      SUBROUTINE REDUCT(MDOC,NAMED,NAMEO,RESULT
C                       ,NXY,MODE,ISYM,IPRSYM,IERR)
C
C      MDOC   -  mode of writting messages to DOC-file
C                0 - only terminal , < - 0 only file, 0 < < 99 - both
C                >= 99 - don't write  
C      NAMED  -  name of input dens-file .
C      NAMEO  -  name of output dens-file /'' '' - means without this file/.
C      POOL   -  real array POOL(MEMORY).
C      MEMORY -  (MEMORY*2)/3 is memory for one Z-section of electron
C                density NX x NY.
C      MODE   -  <R> - /default/  reduct for all space groups.
C   /character*1/         
C                 C  -  for C2221
C                 P  -  for P212121
C                 4  -  for P43212
C                 I  -  for I4
C      ISYM   - integer*2 array for cryst.symmetry operators 
C      IPRSYM - dimension of integer*2 array ISYM(5,3,IPRSYM)
C               Number of cryst. symm. operators.
C               We need not to define contents of arrays ISYM.
C               Here is only reservation of memory.
C      IERR   - signal of error / =1 -error , =o - OK / 
C
C      RESULT /real RESULT(11)/ - array for output information:
C
C      RESULT(7) - number of points
C      RESULT(8) - number of points of asymm. part
C      RESULT(9) - asymm. part for X : NX / NXasym.part  
C      RESULT(10) - asymm. part for Y : NY / NYasym.part
C      RESULT(11) - asymm. part for Z : NZ / NZasym.part
C
C -I-
C ----------------------
C      INTEGER*2 IPOOLA(NXY)
C      REAL      POOLC(NXY)

      real,      allocatable :: POOLC(:)
      integer*2, allocatable :: IPOOLA(:)

      REAL RESULT(*)
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER   NXY
      CHARACTER NAMED*(*),NAMEO*(*),MODE*1
      CHARACTER LINE*80,TYPE*4
C -------------------------------------------------------------
      IF(MODE.EQ.'c') MODE='C'
      IF(MODE.EQ.'p') MODE='P'
      IF(MODE.EQ.'i') MODE='I'
      IF(MODE.NE.'C'.AND.MODE.NE.'I'.AND.MODE.NE.'P'.AND.MODE.NE.'4')
     *  THEN
        MODE='R'
      ENDIF
      M=-ABS(MDOC)-1
      WRITE(LINE,*) ' REDUCT FOR :',MODE
      CALL MSGDOC(M,LINE)
      IT = 0
      allocate(POOLC(1:NXY),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(IPOOLA(1:NXY),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      IF(IT.NE.0) THEN
        IERR = 1
        CALL MSGERR(MDOC,
     *      ' ERROR: in REDUCT : problem with memory allocation')
        CALL MSGERR(MDOC,
     *      '                    try to change resolution')
        RETURN
      ENDIF

C ------------------------------------------------------------
      CALL REDCT1(MDOC,NAMED,NAMEO,RESULT
     *    ,POOLC,IPOOLA,NXY
     *    ,MODE,ISYM,IPRSYM,IERR)

      deallocate(POOLC,STAT=ISTAT)
      deallocate(IPOOLA,STAT=ISTAT)

      RETURN
      END
C -I-
      SUBROUTINE CFFT(MDOC,LAP,NX,NY,NZ,IZMIN,IZMAX,F000,NAMEF1
     * ,NAMED,NAMEPH,NAMEF2,RESMIN,RESMAX,BADD,BOFF,ASYM,SCALE
     * ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C ---------------------------------------------
C -P- CFFT  : COEF ( without anom. scatt.) + FFT
C -S-
C      Dialog:
C
C   FILE_1:  -   input file-1 of the structure factors.
C   FILE_2:  -   name of FILE-DERIV, if you want it 
C   FILE_PH: -   name of FILE-PHASE, if you want it
C   FILE_O:  -   output file of the coefficients.
C   RESOL:   MIN,MAX , <from files> - resolution
C   SCALE:   <1.0>
C   BOFF     <0> , 240 corresponds to RESmin=10 /aprox./
C                For suppressing low resolutin reflections, kind of 
C                modeling desordered solvent: Fnew=(1-exp(-Boff*s**2))*Fold    
C   BADD:    <0.0>
C                     SCALE and BADD will be applyed:
C                     DEL = (Fder*SCALE-Fnat)*EXP(-Badd*RSQ
C                     or F = ( Fnat*SCALE )*EXP(-Badd*RSQ)
C   LAP:     <N>,Y  - coefficients of the curvature (second derivative)
C                     will be calculated: COEF = 4 * PI**2 * S**2 * F(hkl) 
C   ASYM:    <N>/Y , Y means to calculate only asymm.part of unit cell.
C   LIMZ:  MIN MAX numbers of Z-section /default for SF calculation/
C
C
C      SUBROUTINE CFFT(MDOC,LAP,POOL,NX,NY,NZ,IZMIN,IZMAX,F000,NAMEF1
C     * ,NAMED,NAMEPH,NAMEF2,RESMIN,RESMAX,BADD,BOFF,ASYM,SCALE
C     * ,MEMORY,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C
C      Parameters:
C
C      MDOC  - mode of writting messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C      NAMEF1 - name of input file F_1
C      NAMEF2 - name oF input file F_2 / or " "/
C      NAMEPH - name oF input file PHASE / or " "/
C      NAMED  - name of output dens-file / or " "/.
C      SCALE,BOFF,BADD -  - see above.
C      LAP,ASYM  - see above.
C      NX,NY,NZ - numbers of points of grid corresponding axises X,Y,Z
C                 if NX=NY=NZ=0 program will define minimal values 
C                 suitable for calculation struture factors.
C      IZMIN,IZMAX - serial numbers for first and last Z-section of density.
C                  "0,-1"  mean to get default value for SF calculation.
C      F000:    <0.0>   - value of F(0,0,0)
C               > 0   - use this value
C               < 0   - use value from input coef_file.
C      POOL    - real array POOL(MEMORY) for
C                one Z-section of electron density NX x NY < MEMORY.
C      MEMORY  - dimension of real array POOL.
C      ISYM    - integer*2 array for cryst.symmetry operators 
C      IPRSYM  - dimension of integer*2 array ISYM(5,3,IPRSYM)
C                We need not to define contents of array ISYM
C                Here is only reservation of memory.
C      IERR    - signal of error / =1 -error , =o - OK / 
C
C      Output information:
C
C      RESULT(IPRROW) /real/ :
C
C      RESULT(1,1) = number of points
C      RESULT(2,1) = Dmax
C      RESULT(3,1) = Dmin
C      RESULT(4,1) = RMS
C      RESULT(5,1) = <D>
C      RESULT(6,1) = N_positive points
C      RESULT(7,1) = N_negative points
C      RESULT(8,1) = RMS for positive and =0 density
C      RESULT(9,1) = RMS for negative and =0 density
C      RESULT(10,1) = <D> for positive and =0 density
C      RESULT(11,1) = <D> for negative and =0 density
C      IF(IPRROW.GE.15) THEN
C        RESULT(12,1) = 3-moment of density 
C        RESULT(13,1) = 4-moment of density
C        RESULT(14,1) = P_000 - value of origine Patterson peak.
C        RESULT(15,1) = N points with density = 0
C      ENDIF    
C -I-
C ---------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER*4 MDOC,IPRSYM,IERR
      CHARACTER NAMEF1*(*),NAMEF2*(*),NAMED*(*),NAMEPH*(*)
     *         ,LAP*1,ASYM*1
      REAL      F000
      INTEGER*4 NX,NY,NZ,IZMIN,IZMAX
      REAL      RESULT(IPRROW,51)

c      INTEGER   IH(IPRSYM),IK(IPRSYM),IL(IPRSYM)
c      REAL      FA(IPRSYM),FB(IPRSYM)

      integer,   allocatable :: IH(:)
      integer,   allocatable :: IK(:)
      integer,   allocatable :: IL(:)
      real,      allocatable :: FA(:)
      real,      allocatable :: FB(:)

C --------------
      IERR  = 0
c      NCRES = MEMORY-IPRSYM*5
c      IF(NCRES.LE.1) THEN
c        CALL MSGERR(MDOC,' ERR: CFFT: NOT MEMORY')
c        IERR=1
c      ENDIF
c      I0     = NCRES+1
c      NCRES2 = NCRES/2

      IT = 0
      allocate(IH(1:IPRSYM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(IK(1:IPRSYM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(IL(1:IPRSYM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(FA(1:IPRSYM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(FB(1:IPRSYM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      IF(IT.NE.0) THEN
        IERR = 1
        CALL MSGERR(MDOC,
     *    ' ERROR: in CFFT : problem with memory allocation')
        CALL MSGERR(MDOC,
     *    '                  try to change resolution')
        RETURN
      ENDIF
C -----------
      CALL CFFTS(MDOC,LAP,NX,NY,NZ,IZMIN,IZMAX,F000,NAMEF1
     * ,NAMEF2,NAMED,RESULT,IPRROW,ISYM,IH,IK,IL,FA,FB
     * ,RESMIN,RESMAX,IPRSYM,NAMEPH,BADD,BOFF,ASYM,SCALE,IERR)

      deallocate(IH,STAT=ISTAT)
      deallocate(IK,STAT=ISTAT)
      deallocate(IL,STAT=ISTAT)
      deallocate(FA,STAT=ISTAT)
      deallocate(FB,STAT=ISTAT)

C -----------
      RETURN
      END

C -I-
      SUBROUTINE GENDEN(MDOC,NAMEC,NAMED,TITLE
     * ,RX,NX,NY,NZ,IZMIN,IZMAX,MODE,RAD,H2OBG,BADD,P1,ZFADD
     * ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C ------------------------------------------------------------
C -P- GENDEN  :  generates electron density for the atomic model. 
C                The model may represents atoms as the spheres with inside 
C                density depending on the position of model in the unit cell
C                (usefull to study the packing of the moleculs in the unit).
C                By use the program "modden" you can have the contents of
C                the unit cell with the constant value inside molecules and
C                equal to zero outside. If you want to take into account the
C                surface of area of atoms this value must be written instead
C                of the occupancy ( by the program "surf_pnt" )
C                Program can calculate the distribution of the charges.
C                In this case coordinate's file must have the atomic charge
C                instead of the occupancy. 
C -S-
C
C  Dialog and Batch: 
C
C    FILE_C -  input file of coordinates.
C    FILE_D -  output file of density
C    RESOL  -  <3.0> resolution
C    GRID   -  NX NY NZ /defaults are minimal grid spacing for SF calculation/
C    LIMZ:  -  MIN MAX numbers of Z-section /default are for SF calculation/
C    BADD:  -  <0.0> additional B-factor /default Badd_calc for SF calculation/
C              -1 means Badd_calc will used, 0 means Badd_calc will used (exept
C              case with Bmin > 10 where Badd = - Bmin + 5 )
C    H2O:   -  <0.0> density of solvent
C    P1:    -  calculate density for P1 spase group
C    MODE:  -  <A> - generate atomic density.
C               S  - density for the spheres in the centre of atom with
C                    the radius RAD.
C               C  - distribution of the charges.
C           if MODE = "S" ,value of radii will be used:
C    RAD    -  <0.0>  - radius of sphere. 
C              if RAD > 0 then Radius =  input RAD
C                 RAD = 0 then Radius = Van-der-Waals radius
C                 RAD < 0 then if SURFACE-AREA=0 then Radius =ABS(RAD)
C                                                else Radius =Van-der-Waals_rad
C    TITLE    - title of output file
C
C  Parameters of subroutine GENDEN: 
C
C      SUBROUTINE GENDEN(MDOC,NAMEC,NAMED,TITLE
C     * ,RX,NX,NY,NZ,IZMIN,IZMAX,MODE,RAD,H2OBG,BADD,P1
C     * ,RESULT,IPRROW,POOL,MEMORY,NCRDMAX,ISYM,IPRSYM,IERR)
C
C    MDOC   - mode of writting messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C    MODE   - see above. / character*1 /
C    NAMEC  - name of input file without extention "crd".
C    NAMED  - name of output file of density.
C    RX     -  <3.0> resolution
C    NX,NY,NZ - grid /defaults are minimal grid spacing for SF calculation/
C    BADD    -  <0.0> additional B-factor /default are for SF calculation/
C    H2OBG   -  <0.0> density of solvent
C    P1      -  calculate density for P1 spase group. /character*1/
C    MODE    -  see above. /character*1/
C    RAD     -  <0.0> radius of sphere 
C              if RAD > 0 then Radius = RAD
C                 RAD = 0 then Radius = R-Van-der-Waals
C                 RAD < 0 then if SURFACE-AREA=0 then Radius = ABS(RAD)
C                                                else Radius=R-Van-der-Waals
C    TITLE  -  title of output file, /character*80/
C    IZMIN,IZMAX  -  MIN MAX numbers of Z-section. /if IZMIN=0,IZMAX=-1 
C                    default values for SF calculation will be taken /
C    NCRDMAX - maximal number of atoms.
C    POOL    - real array POOL(MEMORY)
C    MEMORY  - dimension array POOL. 
C              MEMORY = MAPMAX + (NCRDMAX/2)*5 , where MAPMAX - maximal
C                                                size of XY-section ( NX*NY)
C    ISYM   - integer*2 array for cryst.symmetry operators.
C    IPRSYM - dimension of integer*2 array ISYM(5,3,IPRSYM),
C             number of cryst. symm. operators.
C    IERR   - output signal of error / = 1 -error , = 0 - OK / 
C
C        output information 
C
C      real RESULT(IPRROW)
C
C      NEL   = RESULT(1)  number of electrons
C      SUMFI2= RESULT(2)  sum(Nelectrons**2)
C      BAVER = RESULT(3)  <B>   in the file
C      BMAX  = RESULT(4)   Bmax in the file
C      BMIN  = RESULT(5)   Bmin in the file
C      BAVERW= RESULT(6)   B_water in the file
C      BAVERF= RESULT(7)  <B> / including B from atomic scatt. factor /  
C      SUMDEN= RESULT(8)  sum(DENSITY) =  (sum(D)*volume)/(nx*ny*nz)
C      HH2OBG= RESULT(9)  density in the solvent region which was added.
C      SOLV  = RESULT(10) % of the solvent.
C      BADD  = RESULT(11) additional B-factor which was used.
C -I-
C ----------------------------------------------------------
      INTEGER*2        ISYM(5,3,IPRSYM)
C---------------------------------------------------------------
      CHARACTER NAMEC*(*),NAMED*(*),TITLE*(*),MODE*1,P1*1
C==================================================================
      REAL RESULT(IPRROW)
C ----------------------------------------
C ---
      CALL SGENDEN(MDOC,NAMEC,NAMED,TITLE
     * ,RX,NX,NY,NZ,IZMIN,IZMAX,MODE,RAD,H2OBG,BADD,P1,ZFADD
     * ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C ---
      RETURN
      END

      SUBROUTINE TO_BLANC(MDOC,NAME_IN,NAME_OUT
     * ,NAME_C,NAME_F,NAME_I,RESCRD,FORM_I,SETT
     * ,ANOM,ATOP,SD_LIM,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C ---------------------------------------------------

c      INTEGER*4 IARRH(*),IARRS(*)
c      REAL      ARRF(*),ARRS(*)

      integer,   allocatable :: IARRH(:)
      integer,   allocatable :: IARRS(:)
      real,      allocatable :: ARRF(:)
      real,      allocatable :: ARRS(:)

      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW,3)
      REAL      RLATT(6)
      CHARACTER LINE*80
      REAL      ATOP,SD_LIM,RESCRD
      INTEGER*4 MDOC,IERR,NUMBT
      CHARACTER NAME_IN*(*),NAME_OUT*(*),NAME_I*(*)
      CHARACTER NAME_C*(*),NAME_F*(*),FORM_I*1,SETT*1
C -----------------------------------------------------------
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
C ------------------------------------------------------------
      INCLUDE 'mr_crd_com.fh'
C --------------
      CHARACTER ANOM*1,FLAG_C*1,FLAG_S*1,TYPE*4,TITLE*80,FORM*1
      CHARACTER TITLEL*160
      REAL      R4    
      CHARACTER CH4*4
      EQUIVALENCE (R4,CH4)
C ------------------------------------------------------------
      IERR   = 0
      IANOM  = 0
      IF(ANOM.EQ.'y') ANOM='Y'
      IF(ANOM.EQ.'Y') IANOM=1
      TITLEL = ' '

      NSP_GROUP = 0
      SP_GROUP  = ' '
 
      NUMBT= 0
      RESMIN=0.0
      RESMAX=1.0E30

      IF(FORM_I.EQ.'f') FORM_I='F'
      IF(FORM_I.EQ.'c') FORM_I='C'
      IF(FORM_I.EQ.'p') FORM_I='P'
      IF(FORM_I.NE.'C'.AND.FORM_I.NE.'P') FORM_I='F'

      CALL LENSTR_BL(NAME_C,LEN)
      IF(LEN.LE.0.OR.NAME_C(1:1).EQ.' '.OR.
     *               NAME_C(1:1).EQ.',') THEN
        CALL LENSTR_BL(NAME_I,LEN)
        IF(LEN.LE.0.OR.NAME_I(1:1).EQ.' '.OR.
     *                  NAME_I(1:1).EQ.',') THEN
          FLAG_C='N'
        ELSE
          FLAG_C='I'
        ENDIF
      ELSE
        FLAG_C='Y'
      ENDIF
      IF(FLAG_C.EQ.'Y') THEN
        MT  =10
        M   =99
        CALL ORCRD(M,MT,NAME_C,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: TOBLANC: OPEN COORD_FILE')
          RETURN
        ENDIF
        DO I=1,6
          RLATT(I) = CR_CELL(I)
        ENDDO
        CLOSE(MT)
        CALL C_AT_CR
        LINE = USER_TITLE
        TITLEL=USER_TITLE(1:80)//PDB_NAME(1:40)
      ELSE IF(FLAG_C.EQ.'I') THEN

        CALL RD_INF(M,NAME_I,RLATT,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.GT.0) THEN
          CALL MSGERR(MDOC,' ERR: TOBLANC: OPEN FILE_INF')
          RETURN
        ENDIF
        LINE = USER_TITLE
        TITLEL=USER_TITLE(1:80)//PDB_NAME(1:40)

      ELSE

        CALL LENSTR_BL(NAME_F,LEN)
        IF(LEN.LE.0.OR.NAME_F(1:1).EQ.' '.OR.
     *                 NAME_F(1:1).EQ.',') THEN
          FLAG_C='N'
        ELSE
          FLAG_C='Y'
          MT  =10
          M   =99
          TYPE='    '
          CALL ORFILE(M,MT,NAME_F,TYPE,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.GT.0) THEN
            CALL MSGERR(MDOC,' ERR: OPEN FILE_F')
            RETURN
          ENDIF
          CALL GET_TITLE(M,RLATT(1),RLATT(2),RLATT(3),RLATT(4),RLATT(5)
     *    ,RLATT(6),DM,DM,DRN,DRX,IDM,IDM,IDM,IDM,IDM,TITLEL,IERR)
          CLOSE(MT)
          CALL C_RD_CR
          LINE = USER_TITLE
          TITLEL=USER_TITLE(1:80)//PDB_NAME(1:40)

        ENDIF
      ENDIF
C ---
      ITEST  = 1
      NUMBT  = 0
      MAXREF = 10
      allocate(IARRH(1: MAXREF),STAT=ISTAT)
      allocate(IARRS(1: MAXREF),STAT=ISTAT)
      allocate(ARRF(1: MAXREF),STAT=ISTAT)
      allocate(ARRS(1: MAXREF),STAT=ISTAT)

      CALL RDSORT(MDOC,NUMBT,RLATT,LINE,TITLEL,NAME_IN,FORM_I,MAXREF
     * ,IARRH,IARRS,ARRF,ARRS
     * ,RFAC_ST,N_GT_SIG,N_INPUT,SD_LIM,NBAD_SD,NBAD_ABS
     * ,RESMIN,RESMAX,NSYM,ISYM,IPRSYM,FLAG_C,FLAG_S,NBAD,ITEST,IERR)
      deallocate(IARRH,STAT=ISTAT)
      deallocate(IARRS,STAT=ISTAT)
      deallocate(ARRF,STAT=ISTAT)
      deallocate(ARRS,STAT=ISTAT)
      IF(IERR.NE.0) RETURN  
    
      MAXREF = NUMBT
      IT = 0
      allocate(IARRH(1: MAXREF),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(IARRS(1: MAXREF),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(ARRF(1: MAXREF),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(ARRS(1: MAXREF),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      IF(IT.GT.0) THEN
        IERR = 1
        CALL MSGERR(MDOC,
     *    ' ERROR: in TOBLANC: problem with memory allocation')
        CALL MSGERR(MDOC,
     *    '                    try to change resolution')
        RETURN
      ENDIF
      ITEST = 0
      NUMBT  = 0

      CALL RDSORT(MDOC,NUMBT,RLATT,LINE,TITLEL,NAME_IN,FORM_I,MAXREF
     * ,IARRH,IARRS,ARRF,ARRS
     * ,RFAC_ST,N_GT_SIG,N_INPUT,SD_LIM,NBAD_SD,NBAD_ABS
     * ,RESMIN,RESMAX,NSYM,ISYM,IPRSYM,FLAG_C,FLAG_S,NBAD,ITEST,IERR)
      IF(IERR.NE.0) GO TO 900     
      RESULT(2,1)=RESMIN
      RESULT(3,1)=RESMAX
      RESULT(7,1)=NBAD
C ---
      FORM='B'
      IF(FORM_I.NE.'C'.AND.FORM_I.NE.'F') FORM='H'
      IERR=0
      CALL JOINWR(MDOC,NUMBT
     *   ,IARRH,IARRS,ARRF,ARRS
     *   ,MAXREF,RLATT,RESMIN,RESMAX,RESCRD,ISYM,NSYM
     *   ,NAME_OUT,IANOM,ATOP
     *   ,IPRSYM,FORM,TITLEL,FLAG_S
     *   ,RESULT,IPRROW,IERR)

C     *   ,DELRFR,NRFR,NRFRT
C     *   ,NREF,DELF,NSMT,NSMTT,IERR)

      CH4=CR_SPGR(1:4)
      RESULT(8,1)=R4
      CH4=CR_SPGR(5:8)
      RESULT(9,1)=R4
      CH4=CR_SPGR(9:11)//' '
      RESULT(10,1)=R4

C      RESULT(1,1)=NREF
C      RESULT(4,1)=DELF
C      RESULT(5,1)=NSMT
C      RESULT(6,1)=NSMTT
C      RESULT(11,1)=DELRFR
C        RESULT(12,1)=NRFR
C        RESULT(13,1)=NRFRT

      IF(RFAC_ST.LT.0.0015) RFAC_ST=0.0
      IF(IPRROW.GE.20 ) THEN
C        --- R-st(I)---
        RESULT(14,1)=RFAC_ST
        RESULT(15,1)=N_GT_SIG
        RESULT(16,1)=N_INPUT
        RESULT(17,1)=NBAD_SD
        RESULT(18,1)=NSYM
        RESULT(19,1)=NBAD_ABS
        RESULT(20,1)=SD_LIM
      ENDIF
  900 CONTINUE
      deallocate(IARRH,STAT=ISTAT)
      deallocate(IARRS,STAT=ISTAT)
      deallocate(ARRF,STAT=ISTAT)
      deallocate(ARRS,STAT=ISTAT)
      RETURN
      END

C -I-
      SUBROUTINE RFRES_100(MDOC,NAME1,NAME2,NAMEO
     * ,BETMIN,BETMAX,BETDEL
     * ,RF_MAX,LMAXR,LMINR,ISYM,IPRSYM,IERR)
C --------------------------------------------------------------------
C -P- RFRES : calculates Rotation Function map in Euler coordinate system.
C -S-
C             Rotation is 1.) alpha - about Z, 2) beta - about new Y
C                         3.) gamma - about new Z.
C           Solution RFRES corresponds to the rotation of RFROT,TRANS -programs
C           i.e.:   RFRES: (a,b,g) peak for file_1: model1 
C                                           file_2: model2
C             TRANS: model2 --> model1: angle: a,b,g
C             RFROT: model2 --> model1: angle: a,b,g 
C    Dialog and Batch:
C
C   FILE_1 - input ALMN_file /for self-rotation function use one file/
C   FILE_2 - input second ALMN_file for cross-rotation function
C   LIMITS <0,180,5> /grad/ - BETA-min,BETA-max,BETA-del')
C   FILE_O - output file / if you want it/, type of file is "RI  "  
C                          as DENS file, possible to use PRINTD to look result.
C
C      SUBROUTINE RFRES(MDOC,NAME1,NAME2,NAMEO,BETMIN,BETMAX,BETDEL
C     * ,POOL,MEMORY,ISYM,IPRSYM,IERR)
C
C   Parameters:
C
C  MDOC  - mode of writting messages to DOC-file
C          0 - only terminal , < - 0 only file, 0 < < 99 - both
C          >= 99 - don't write  
C  NAME1  - Input ALMN_file
C  NAME1  - input second ALMN_file for cross-rotation function
C  NAMEO  - name of file where you want to save result 
C  BETMIN - min and max section of Rotation function
C  BETMAX
C  BETDEL   delta = 0 means default values: <0,180,5> 
C  POOL   - real array(MEMORY) 
C  MEMORY
C  ISYM   - integer*2 array for cryst.symmetry operators.
C  IPRSYM - dimension of integer*2 array ISYM(5,3,IPRSYM),
C           number of cryst. symm. operators.
C  IERR   - signal of error / =1 -error , =o - OK / 
C -I-
C --------------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RLATT(6),RF_MAX(4)
      CHARACTER NAME1*(*),NAME2*(*),NAMEO*(*),TITLE*80,TYPE*4
c ----
c     POOL(I1)  DLMN8
c     REAL*8    DLMN8(IPRLM1,IPRL21)
      real*8,   allocatable :: DLMN8(:,:)
c     POOL(I2)  CLMM
c     COMPLEX   CLMM(IPRMEM)
      complex,   allocatable :: CLMM(:)
c     POOL(I3)  FMM
c     COMPLEX   FMM(IPRALM,IPRGAM)
      complex,   allocatable :: FMM(:,:)
c     POOL(I4)  FACT
C     REAL*8    FACT(IPRL21)
      real*8,   allocatable :: FACT(:)
c     POOL(I5)  PCOT
C     REAL*8    PCOT(IPRL21)
      real*8,   allocatable :: PCOT(:)
c     POOL(I6)  PSIN
C     REAL*8    PSIN(IPRL21)
      real*8,   allocatable :: PSIN(:)
c     POOL(I7)  DLMM
C     REAL      DLMM (IPRLM1,IPRL21)
      real,     allocatable :: DLMM(:,:)
c     POOL(I8)  AR
C     REAL      AR(IPRLM1,IPRNMX)
      real,     allocatable :: AR(:,:)
c     POOL(I9)  AI
C     REAL      AI(IPRLM1,IPRNMX)
      real,     allocatable :: AI(:,:)
c     POOL(I10) BR
C     REAL      BR(IPRLM1,IPRNMX)
      real,     allocatable :: BR(:,:)
c     POOL(I11) BI
C     REAL      BI(IPRLM1,IPRNMX)
      real,     allocatable :: BI(:,:)
c     POOL(I12) NMAX
C     INTEGER   NMAX(IPRLM1)
      integer,  allocatable :: NMAX(:)
C ----
C -------------------------------------------------------------
      IERR=0
C ----------------
      MT1   = 10
      TYPE  = '    '
      MD    =-ABS(MDOC)-1
      CALL ORFILE(MD,MT1,NAME1,TYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERR: OPEN ALMN_FILE-1')
        RETURN
      ENDIF
      IF(TYPE.NE.'ALMN'.AND.TYPE.NE.'ALMS') THEN
        CALL MSGERR(MD,' ERR: OPEN ALMN_FILE-1: wrong file type')
        IERR = 1
        RETURN
      ENDIF
      CALL GET_TITLE(MD,RLATT(1),RLATT(2),
     . RLATT(3),RLATT(4),RLATT(5),RLATT(6),CF,BT,RN1,RX1,IDM,IDM
     . ,IDM,IDM,IDM,TITLE,IERR)
      CLOSE(MT1)
      READ(TITLE(16:20),'(I3,I2)') IPRLMX,LMAX_RFCOEF
      IF(IPRLMX.NE.30.AND.IPRLMX.NE.60.AND.IPRLMX.NE.100) THEN
C       30 or 60 or 100
        IERR=1
        CALL MSGERR(MD,' ERROR: RFCOEF: LMAX must be 30 or 60 or 100')
        RETURN
      ENDIF
C ----
C      IF(LMAXR.LT.LMINR) THEN
C        L     = LMAXR
C        LMAXR = LMINR
C        LMINR = L
C      ENDIF
      IF(LMINR.LT. 0) LMINR = 0
      IF(LMINR.GT.50) LMINR = 50

      IF(LMAXR.LT. 0) LMAXR = 0
      IF(LMAXR.GT.100) LMAXR = 100
      IF(LMAXR.LE.  0) LMAXR = 100
C ---
      BMAX  = 180.0
      CALL GET_TWOFOLD_PATT(NSYM,ISYM,ITWOX,ITWOY)
      IF(ITWOX.GT.0.OR.ITWOY.GT.0) BMAX=90.0
      IF(BETMAX.GT.180.0) BETMAX=180.
      BETDEL = ABS(BETDEL)
      IF(BETDEL.LT.1.E-7) THEN
c        BETDEL = 5.0
c        IF(ITWOX.GT.0.OR.ITWOY.GT.0) BETDEL=2.5      
c        IF(LMAX_RFCOEF.GT.30) BETDEL=2.5      
        BETDEL = 3.0
        IF(ITWOX.GT.0.OR.ITWOY.GT.0) BETDEL=2.0      
        IF(LMAX_RFCOEF.GT.30) BETDEL=2.0      
      ENDIF
      IF(BETMAX.LT.1.E-7) THEN
        BETMAX = BMAX
      ENDIF
      IF(BETMIN.GT.180.)  BETMIN=180.0
C ----
      IPRLMX = 100
      IPRNMX=IPRLMX/2 
      IPRALM=100
      IPRGAM=IPRALM*2   
      IPRLM1=IPRLMX+1   
      IPRLM2=IPRLMX+2   
      IPRL21=IPRLMX*2+1 
      NBASC = 0
      NMAX1 = 50
      DO L=1,102
        LK      = L+1
        MMAX    = LK
        NN      = NMAX1
        LS1     = L+1
        L1      = L+1
        L21     = 2*L+1
        LMBLOK  = L1*L21
        DO M1=1,L1
          MA = (M1-1)+1
          DO MDASH1=1,L21
            MB   = IABS((MDASH1-LS1))+1
            ISGN = MOD((MB-1),2)
            INDC = NBASC+(M1-1)*L21+MDASH1
          ENDDO
        ENDDO
        NBASC = NBASC+LMBLOK
      ENDDO
      IPRMEM = INDC 
  
      allocate(DLMN8(1:IPRLM1,1:IPRL21),STAT=ISTAT)
      allocate(CLMM(1:IPRMEM),STAT=ISTAT)
      allocate(FMM(1:IPRALM,1:IPRGAM),STAT=ISTAT)
      allocate(FACT(1:IPRL21),STAT=ISTAT)
      allocate(PCOT(1:IPRL21),STAT=ISTAT)
      allocate(PSIN(1:IPRL21),STAT=ISTAT)
      allocate(DLMM(1:IPRLM1,1:IPRL21),STAT=ISTAT)
      allocate(AR(1:IPRLM1,1:IPRNMX),STAT=ISTAT)
      allocate(AI(1:IPRLM1,1:IPRNMX),STAT=ISTAT)
      allocate(BR(1:IPRLM1,1:IPRNMX),STAT=ISTAT)
      allocate(BI(1:IPRLM1,1:IPRNMX),STAT=ISTAT)
      allocate(NMAX(1:IPRLM1),STAT=ISTAT)
C       1        2        3       4        5         6     
C     DLMN8,   CLMM,    FMM,     FACT,    PCOT,    PSIN,
C     POOL(I1),POOL(I2),POOL(I3),POOL(I4),POOL(I5),POOL(I6)
C      7          8       9         10         11      12
C     DLMM,       AR,     AI,      BR,       BI,      NMAX
C     POOL(I7),POOL(I8),POOL(I9),POOL(I10),POOL(I11),POOL(I12)

      CALL SRFRES(MDOC,NAME1,NAME2,NAMEO,BETMIN,BETMAX,BETDEL
     *   ,DLMN8,CLMM,FMM,FACT,PCOT,PSIN
     *   ,DLMM,AR,AI,BR,BI,NMAX
     *   ,IPRLMX,IPRLM1,IPRL21,IPRMEM,IPRALM,IPRGAM,IPRNMX
     *   ,RF_MAX,LMAXR,LMINR,ISYM,IPRSYM,IERR)

      deallocate(DLMN8,STAT=ISTAT)
      deallocate(CLMM,STAT=ISTAT)
      deallocate(FMM,STAT=ISTAT)
      deallocate(FACT,STAT=ISTAT)
      deallocate(PCOT,STAT=ISTAT)
      deallocate(PSIN,STAT=ISTAT)
      deallocate(DLMM,STAT=ISTAT)
      deallocate(AR,STAT=ISTAT)
      deallocate(AI,STAT=ISTAT)
      deallocate(BR,STAT=ISTAT)
      deallocate(BI,STAT=ISTAT)
      deallocate(NMAX,STAT=ISTAT)

      RETURN
      END

C -I-
      SUBROUTINE RFROT(MDOC,NAME1,NAMEO,ALPHA,BETA,GAMMA
     * ,LMINR,LMAXR,ISYM,IPRSYM,IERR)
C --------------------------------------------------------------------
C -P- RFROT : calculates rotated spheric coefficients.
C -S-
C             Rotation is 1.) alpha - about Z, 2) beta - about new Y
C                         3.) gamma - about new Z.
C     
C     Rotation corresponds to solution RFRES and TRANS-program
C     i.e.:   RFRES: (a,b,g) peak for file_1: model1 
C                                     file_2: model2
C             TRANS: model2 --> model1: angle: a,b,g
C             RFROT: model2 --> model1: angle: a,b,g 
C
C    Dialog and Batch:
C
C   FILE_I - input ALMN_file 
C   ANGLE <0,0,0> /grad/ - rotation angles
C   LIML: LMIN,LMAX <0,60> - L_limits for spheric coefficients
C   FILE_O - output file 
C
C      SUBROUTINE RFROT(MDOC,NAME1,NAMEO,ALPHA,BETA,GAMMA
C     * ,LMINR,LMAXR,POOL,MEMORY,ISYM,IPRSYM,IERR)
C
C   Parameters:
C
C  MDOC  - mode of writting messages to DOC-file
C          0 - only terminal , < - 0 only file, 0 < < 99 - both
C          >= 99 - don't write  
C  NAME1  - Input ALMN_file
C  NAMEO  - name of output file 
C  POOL   - real array(MEMORY) 
C  MEMORY
C  ISYM   - integer*2 array for cryst.symmetry operators.
C  IPRSYM - dimension of integer*2 array ISYM(5,3,IPRSYM),
C           number of cryst. symm. operators.
C  IERR   - signal of error / =1 -error , =o - OK / 
C -I-
C --------------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RLATT(6)
      CHARACTER NAME1*(*),NAMEO*(*),TITLE*80,TYPE*4

c     REAL*8    DLMN8(IPRLM1,IPRL21)
      real*8,   allocatable :: DLMN8(:,:)
c     REAL      DLMM (IPRLM1,IPRL21)
      real,     allocatable :: DLMM(:,:)
c     REAL*8    FACT(IPRL21),PCOT(IPRL21),PSIN(IPRL21)
      real*8,   allocatable :: FACT(:)
      real*8,   allocatable :: PCOT(:)
      real*8,   allocatable :: PSIN(:)
c     COMPLEX   CLMM(IPRMEM),FMM(IPRALM,IPRGAM)
      complex,   allocatable :: CLMM(:)
      complex,   allocatable :: FMM(:,:)
c     REAL      AR(IPRLM1,IPRNMX),AI(IPRLM1,IPRNMX)
c     REAL      BR(IPRLM1,IPRNMX),BI(IPRLM1,IPRNMX)
      real,     allocatable :: AR(:,:)
      real,     allocatable :: AI(:,:)
      real,     allocatable :: BR(:,:)
      real,     allocatable :: BI(:,:)
c     INTEGER   NMAX(IPRLM1)
      integer,  allocatable :: NMAX(:)
C ----------------
C -------------------------------------------------------------
      IERR=0
      MT1   =10
      TYPE  ='    '
      MD=-ABS(MDOC)-1
      CALL ORFILE(MD,MT1,NAME1,TYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERR: OPEN ALMN_FILE-1')
        RETURN
      ENDIF
       IF(TYPE.NE.'ALMN'.AND.TYPE.NE.'ALMS') THEN
        CALL MSGERR(MD,' ERR: OPEN ALMN_FILE-1: wrong file type')
        IERR = 1
        RETURN
      ENDIF
      CALL GET_TITLE(MD,RLATT(1),RLATT(2),
     . RLATT(3),RLATT(4),RLATT(5),RLATT(6),CF,BT,RN1,RX1,IDM,IDM
     . ,IDM,IDM,IDM,TITLE,IERR)
      CLOSE(MT1)
      READ(TITLE(16:20),'(I3,I2)') IPRLMX,LMAX_RFCOEF
      IF(IPRLMX.NE.30.AND.IPRLMX.NE.60.AND.IPRLMX.NE.100) THEN
C       30 or 60 or 100
        IERR=1
        CALL MSGERR(MD,' ERROR: RFCOEF: LMAX must be 30 or 60 or 100')
        RETURN
      ENDIF
      IPRLMX = 100
      IPRNMX=IPRLMX/2 
      IPRALM=100
      IPRGAM=IPRALM*2   
      IPRLM1=IPRLMX+1   
      IPRLM2=IPRLMX+2   
      IPRL21=IPRLMX*2+1 
      NBASC = 0
      NMAX1 = 50
      DO L=1,102
        LK      = L+1
        MMAX    = LK
        NN      = NMAX1
        LS1     = L+1
        L1      = L+1
        L21     = 2*L+1
        LMBLOK  = L1*L21
        DO M1=1,L1
          MA = (M1-1)+1
          DO MDASH1=1,L21
            MB   = IABS((MDASH1-LS1))+1
            ISGN = MOD((MB-1),2)
            INDC = NBASC+(M1-1)*L21+MDASH1
          ENDDO
        ENDDO
        NBASC = NBASC+LMBLOK
      ENDDO
      IPRMEM = INDC 
C ----
      allocate(DLMN8(1:IPRLM1,1:IPRL21),STAT=ISTAT)
      allocate(CLMM(1:IPRMEM),STAT=ISTAT)
      allocate(FMM(1:IPRALM,1:IPRGAM),STAT=ISTAT)
      allocate(FACT(1:IPRL21),STAT=ISTAT)
      allocate(PCOT(1:IPRL21),STAT=ISTAT)
      allocate(PSIN(1:IPRL21),STAT=ISTAT)
      allocate(DLMM(1:IPRLM1,1:IPRL21),STAT=ISTAT)
      allocate(AR(1:IPRLM1,1:IPRNMX),STAT=ISTAT)
      allocate(AI(1:IPRLM1,1:IPRNMX),STAT=ISTAT)
      allocate(BR(1:IPRLM1,1:IPRNMX),STAT=ISTAT)
      allocate(BI(1:IPRLM1,1:IPRNMX),STAT=ISTAT)
      allocate(NMAX(1:IPRLM1),STAT=ISTAT)
C       1        2        3       4        5         6     
C     DLMN8,   CLMM,    FMM,     FACT,    PCOT,    PSIN,
C     POOL(I1),POOL(I2),POOL(I3),POOL(I4),POOL(I5),POOL(I6)
C      7          8       9         10         11      12
C     DLMM,       AR,     AI,      BR,       BI,      NMAX
C     POOL(I7),POOL(I8),POOL(I9),POOL(I10),POOL(I11),POOL(I12)

C ----
      CALL SRFROT(MDOC,NAME1,NAMEO,ALPHA,BETA,GAMMA
     * ,DLMN8,CLMM,FMM,FACT,PCOT,PSIN
     * ,DLMM,AR,AI,BR,BI,NMAX
     * ,IPRLMX,IPRLM1,IPRL21,IPRMEM,IPRALM,IPRGAM,IPRNMX
     * ,LMINR,LMAXR
     * ,ISYM,IPRSYM,IERR)

      deallocate(DLMN8,STAT=ISTAT)
      deallocate(CLMM,STAT=ISTAT)
      deallocate(FMM,STAT=ISTAT)
      deallocate(FACT,STAT=ISTAT)
      deallocate(PCOT,STAT=ISTAT)
      deallocate(PSIN,STAT=ISTAT)
      deallocate(DLMM,STAT=ISTAT)
      deallocate(AR,STAT=ISTAT)
      deallocate(AI,STAT=ISTAT)
      deallocate(BR,STAT=ISTAT)
      deallocate(BI,STAT=ISTAT)
      deallocate(NMAX,STAT=ISTAT)

      RETURN
      END

C -I-
      SUBROUTINE RFADD(MDOC,NAME1,NAME2,NAMEO,SCALE
     * ,ISYM,IPRSYM,IERR)
C --------------------------------------------------------------------
C -P- RFADD : adds spheric coefficients. 
C -S-

C    Dialog and Batch:
C
C   FILE_1 - input ALMN_file 
C   FILE_2 - input second ALMN_file 
C   FILE_O - output file
C   SCALE  - <1.0>   ALMN_new = ALMN_1 + SCALE * ALMN_2
C
C      SUBROUTINE RFADD(MDOC,NAME1,NAME2,NAMEO,SCALE
C     * ,POOL,MEMORY,ISYM,IPRSYM,IERR)
C
C   Parameters:
C
C  MDOC  - mode of writting messages to DOC-file
C          0 - only terminal , < - 0 only file, 0 < < 99 - both
C          >= 99 - don't write  
C  NAME1  - input ALMN_file
C  NAME2  - input second ALMN_file
C  NAMEO  - output ALMN_file
C  SCALE
C  POOL   - real array(MEMORY) 
C  MEMORY
C  ISYM   - integer*2 array for cryst.symmetry operators.
C  IPRSYM - dimension of integer*2 array ISYM(5,3,IPRSYM),
C           number of cryst. symm. operators.
C  IERR   - signal of error / =1 -error , =o - OK / 
C -I-
C --------------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RLATT(6)
      CHARACTER NAME1*(*),NAME2*(*),NAMEO*(*),TITLE*80,TYPE*4
C ----
c     REAL*8    DLMN8(IPRLM1,IPRL21)
      real*8,   allocatable :: DLMN8(:,:)
c     REAL      DLMM (IPRLM1,IPRL21)
      real,     allocatable :: DLMM(:,:)
c     REAL*8    FACT(IPRL21),PCOT(IPRL21),PSIN(IPRL21)
      real*8,   allocatable :: FACT(:)
      real*8,   allocatable :: PCOT(:)
      real*8,   allocatable :: PSIN(:)
c     COMPLEX   CLMM(IPRMEM),FMM(IPRALM,IPRGAM)
      complex,   allocatable :: CLMM(:)
      complex,   allocatable :: FMM(:,:)
c     REAL      AR(IPRLM1,IPRNMX),AI(IPRLM1,IPRNMX)
c     REAL      BR(IPRLM1,IPRNMX),BI(IPRLM1,IPRNMX)
      real,     allocatable :: AR(:,:)
      real,     allocatable :: AI(:,:)
      real,     allocatable :: BR(:,:)
      real,     allocatable :: BI(:,:)
c     INTEGER   NMAX(IPRLM1)
      integer,  allocatable :: NMAX(:)
C -------------------------------------------------------------
      IERR=0
C ----------------
      MT1   =10
      TYPE  ='    '
      MD=-ABS(MDOC)-1
      CALL ORFILE(MD,MT1,NAME1,TYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERR: OPEN ALMN_FILE-1')
        RETURN
      ENDIF
      IF(TYPE.NE.'ALMN'.AND.TYPE.NE.'ALMS') THEN
        CALL MSGERR(MD,' ERR: OPEN ALMN_FILE-1: wrong file type')
        IERR = 1
        RETURN
      ENDIF
      CALL GET_TITLE(MD,RLATT(1),RLATT(2),
     . RLATT(3),RLATT(4),RLATT(5),RLATT(6),CF,BT,RN1,RX1,IDM,IDM
     . ,IDM,IDM,IDM,TITLE,IERR)
      CLOSE(MT1)
c      READ(TITLE(16:18),'(I3)') IPRLMX
      READ(TITLE(16:20),'(I3,I2)') IPRLMX,LMAX_RFCOEF
C     write(*,*) ' lmax:',iprlmx,LMAX_RFCOEF
      IF(IPRLMX.NE.30.AND.IPRLMX.NE.60.AND.IPRLMX.NE.100) THEN
C       30 or 60 or 100
        IERR=1
        CALL MSGERR(MD,' ERROR: RFADD: LMAX must be 30 or 60 or 100')
        RETURN
      ENDIF
C ----
      IPRLMX = 100
      IPRNMX=IPRLMX/2 
      IPRALM=100
      IPRGAM=IPRALM*2   
      IPRLM1=IPRLMX+1   
      IPRLM2=IPRLMX+2   
      IPRL21=IPRLMX*2+1 
      NBASC = 0
      NMAX1 = 50
      DO L=1,102
        LK      = L+1
        MMAX    = LK
        NN      = NMAX1
        LS1     = L+1
        L1      = L+1
        L21     = 2*L+1
        LMBLOK  = L1*L21
        DO M1=1,L1
          MA = (M1-1)+1
          DO MDASH1=1,L21
            MB   = IABS((MDASH1-LS1))+1
            ISGN = MOD((MB-1),2)
            INDC = NBASC+(M1-1)*L21+MDASH1
          ENDDO
        ENDDO
        NBASC = NBASC+LMBLOK
      ENDDO
      IPRMEM = INDC 
C ----
  
      allocate(DLMN8(1:IPRLM1,1:IPRL21),STAT=ISTAT)
      allocate(CLMM(1:IPRMEM),STAT=ISTAT)
      allocate(FMM(1:IPRALM,1:IPRGAM),STAT=ISTAT)
      allocate(FACT(1:IPRL21),STAT=ISTAT)
      allocate(PCOT(1:IPRL21),STAT=ISTAT)
      allocate(PSIN(1:IPRL21),STAT=ISTAT)
      allocate(DLMM(1:IPRLM1,1:IPRL21),STAT=ISTAT)
      allocate(AR(1:IPRLM1,1:IPRNMX),STAT=ISTAT)
      allocate(AI(1:IPRLM1,1:IPRNMX),STAT=ISTAT)
      allocate(BR(1:IPRLM1,1:IPRNMX),STAT=ISTAT)
      allocate(BI(1:IPRLM1,1:IPRNMX),STAT=ISTAT)
      allocate(NMAX(1:IPRLM1),STAT=ISTAT)
C       1        2        3       4        5         6     
C     DLMN8,   CLMM,    FMM,     FACT,    PCOT,    PSIN,
C     POOL(I1),POOL(I2),POOL(I3),POOL(I4),POOL(I5),POOL(I6)
C      7          8       9         10         11      12
C     DLMM,       AR,     AI,      BR,       BI,      NMAX
C     POOL(I7),POOL(I8),POOL(I9),POOL(I10),POOL(I11),POOL(I12)
C ----
      CALL SRFADD(MDOC,NAME1,NAME2,NAMEO,SCALE
     * ,DLMN8,CLMM,FMM,FACT,PCOT,PSIN
     * ,DLMM,AR,AI,BR,BI,NMAX
     * ,IPRLMX,IPRLM1,IPRL21,IPRMEM,IPRALM,IPRGAM,IPRNMX
     * ,ISYM,IPRSYM,IERR)

      deallocate(DLMN8,STAT=ISTAT)
      deallocate(CLMM,STAT=ISTAT)
      deallocate(FMM,STAT=ISTAT)
      deallocate(FACT,STAT=ISTAT)
      deallocate(PCOT,STAT=ISTAT)
      deallocate(PSIN,STAT=ISTAT)
      deallocate(DLMM,STAT=ISTAT)
      deallocate(AR,STAT=ISTAT)
      deallocate(AI,STAT=ISTAT)
      deallocate(BR,STAT=ISTAT)
      deallocate(BI,STAT=ISTAT)
      deallocate(NMAX,STAT=ISTAT)

      RETURN
      END

      SUBROUTINE TRPACK(MDOC,MDOC_LIST,LIST,NAME,MODE,MOD2,MOD2P
     * ,PACK,REMOV,INVER
     * ,NX,NY,NZ,IZMIN,IZMAX,PACK_MIN,PACK_MAX,BADD,BOFF,PST,SPST
     * ,RAD1,RAD2,SH2,SH1,GAUSS,PERC,RESMIN,RESMAX
     * ,POOL_SCR,MEMORY_SCR
     * ,RESULT,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
C ---------------------------------------------------------
C  NAME(12)*80
C      NAMEF1     = NAME( 1)  model-1
C      NAMEPH1    = NAME( 2)
C      NAMEF2     = NAME( 3)  model-2
C      NAMEPH2    = NAME( 4)
C      NAMEI      = NAME( 5)  Fobs or Coef-file
C      NAMEF1_PK  = NAME( 6)  model-1 for PF
C      NAMEPH1_PK = NAME( 7)  
C      NAMEF2_PK  = NAME( 8)  model-2 for PF
C      NAMEPH2_PK = NAME( 9)  
C      NAMEI_PK   = NAME(10)  Fobs for PF
C      NAMES      = NAME(11)  scratch file (Fobs,F1,F2,...)
C      NAMED      = NAME(12)  output file of TF
C MODE       - <T>,P,M,D,S
C               T - TRANSLATION FUNCTION FOR PATTERSON
C               P - PACKING FUNCTION
C               D - TRANSLATION FUNCTION FOR DENSITY
C               M - TM FUNCTION 
C               S - create scratch file only
C MOD2       - <N>,Y,2,3,4,5,6,7,8,9
C SH1(3)     - shift 1       
C SH2(3,10)  - shift 2,3,4,5,6,7,8,9       
C PACK       - <Y>,N  ,Y - use trans.function with Packing function
C REMOV      - <N>,Y
C INVER      - <N>,Y    Y - invers_density
C GAUSS      - <N>,Y
C RAD1       - <2.5>    
C RAD2       - <2.5>    
C PERC       - percent of model-2 ( <50> )
C IZMIN,IZMAX - (0,-1  default ) IZMAX = -2 --> IZMAX = NZ-1 
C                  IF(MODE.NE.'D'.AND.IZMAX.NE.-2) THEN
C                    RX=RESMAX/2.0 
C                  ELSE
C                    RX=RESMAX
C                  ENDIF
C    output:
C
C    PACK_MIN
C    PACK_MAX 
C
C    IERR=10 ' WARNING: all values of Packing Function =< 0'
C    IERR=13 ' ERROR: trpack: function for NSYM=1 ?')
C
C ---------------------------------------------------------
      REAL      POOL_SCR(*)
      INTEGER*2 ISYM(5,3,IPRSYM)

      INTEGER   MEMORY_TOT,MEMORY_SCR,IPRSYM

      REAL      RESULT (IPRMAX,IPRROW)

      REAL      RAD1,RAD2,SH1(3),SH2(3,*),PERC1,PERC2,PERC
      REAL      RESMIN,RESMAX,SPST(3)

      INTEGER   NX,NY,NZ,IZMIN,IZMAX,IOP1,IOP2

      CHARACTER NAME(12)*256

      CHARACTER MODE*1,MOD2*1,FUNC*1,REMOV*1,INVER*1,ACCUM*1,GAUSS*1
      CHARACTER PACK*1,MOD2P*1,LIST*1,PST*1
C ---
      COMMON/CMPAR/ TWOPI,RRAD1,RRAD2,COEF,BTMP,RHMIN,RHMAX,FMIN,SCALE
     *            ,IPRINT,INVERS,ISELF
     *            ,MTN,MTIN1,MTIN2,MTIN3,MTIN4,MTOUT
     *            ,IHMAX,IKMAX,LMAX,NNX,NNY,NNZ,IIZMIN,IIZMAX
     *            ,VOL,PPERC1,PPERC2,IIOP1,IIOP2
     *            ,SCALE1,SCALE2,BETMIN,BETMAX,RESMN,RESMX
     *            ,MSG,MSG1,MSGB,MSG2,MSG3
     *            ,MMOD2,FFUNC,RREMOV,IINVER,AACCUM,GGAUSS
      REAL*8 TWOPI
      CHARACTER MSG*1,MSG1*1,MSGB*1,MSG2*1,MSG3*1
      CHARACTER MMOD2*1,FFUNC*1,RREMOV*1,IINVER*1,AACCUM*1,GGAUSS*1
C ---
      COMMON/CNSFAC/ FOBS0,FM01,FM02,SSH1,SSH2
     *       ,NADDM,SSH3,SFOBS2,SFMOD2,SFMODP
      REAL FOBS0,FM01,FM02,SSH1(3),SSH2(3),SSH3(3,10)
     *       ,SFOBS2,SFMOD2,SFMODP
C ---
C =====================================================================
      MSG    = MODE
      RRAD1  = RAD1
      RRAD2  = RAD2
C     PERC1  = 0.0
      PERC2  = PERC
      PERC1  = 100.0 - PERC
      PPERC1 = PERC1/100.0
      PPERC2 = PERC2/100.0
      RESMN  = RESMIN
      RESMX  = RESMAX
      BETMIN = BOFF
      BETMAX = BADD
      FFUNC  = PACK
      RREMOV = REMOV
      IINVER = INVER
      AACCUM = ' '
      GGAUSS = GAUSS
      IOP1   = 0
      IOP2   = 0
      IIOP1  = IOP1
      IIOP2  = IOP2
      NNX    = NX
      NNY    = NY
      NNZ    = NZ
      IIZMIN = IZMIN
      IIZMAX = IZMAX
      DO I=1,3
        SSH1(I) = SH2(I,1)
        SSH2(I) = SH1(I)
      ENDDO
      IF(MOD2.EQ.'y') MOD2='Y'
      IF(MOD2.NE.'Y'.AND.MOD2.NE.'2'.AND.MOD2.NE.'3'.AND.
     *   MOD2.NE.'4'.AND.MOD2.NE.'5'.AND.MOD2.NE.'6'.AND.
     *   MOD2.NE.'7'.AND.MOD2.NE.'8'.AND.MOD2.NE.'9') MOD2='N'
      MMOD2 =MOD2
      IF(MOD2.NE.'N'.AND.MOD2.NE.'Y'.AND.MOD2.NE.'2') THEN
        READ(MOD2,'(I1)') NADDM
        NADDM = NADDM-2
        DO J=1,NADDM
          DO I=1,3
            SSH3(I,J) = SH2(I,J+1)
          ENDDO
        ENDDO
        MMOD2 = '2'
      ELSE
        NADDM = 0
      ENDIF
      IERR = 0
C --- test --      
      ITEST  = 0
      SMOOTH = 0.0
C ------
      CALL STRPACK(MDOC,MDOC_LIST,LIST,MOD2P,PST,SPST
     * ,NAME,ISYM,IPRSYM
     * ,POOL_SCR,MEMORY_SCR
     * ,PACK_MIN,PACK_MAX,RESULT,IPRMAX,IPRROW
     * ,SMOOTH,ITEST,IERR)

      NX    = NNX
      NY    = NNY
      NZ    = NNZ
      IZMIN = IIZMIN
      IZMAX = IIZMAX
C ------

      RETURN
      END

C -I-
      SUBROUTINE MODDEN(MDOC,NAME1,NAME2,NAMEW
     *    ,CONST1,CONST2,MSGF
     *    ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C ---------------------------------------------
C -P- MODDEN : copy, change, modify electron density files.
C -P-          filter /Wangs's procedure/.     
C              This program reads one or two files type of "RI" (electron
C              density), performs on this file necessary operation and creates
C              output file  type of "RI". Program performs on one file: to add
C              to this information any number, to equal to zero if value on
C              this point less than given  number,... Program performs on two
C              input files: to add each other, to apply  filtering using second
C              file as mask,... 
C -S-
C      Dialog and Batch:
C
C FILE_1:   - name of input dens-file_1.
C
C MODE: <A> - add CONST to density. Programm reads from input file
C             value D then value D + CONST will be writen into output file.
C        C  - CUTTING DENS: D=CMIN IF < CMIN ,D=CMAX IF < CMAX
C        U  - CUTTING + ADD:  DENS: D=CMIN IF < CMIN ,D=CMAX IF < CMAX and 
C                             add (-CMIN)
C        T  - sTep function: D=1.0 IF >= CONST , D=0.0 IF < CONST 
C        P  - XY-projection of density / one output Z-section /.
C             IZMIN,IZMAX - numbers of first and
C             last Z-section
C        M  - multiply DENS * CONST
C        3  - DENS ** 3
C        *  - DENS ** 2
C        Q  - SQRT(DENS)
C        L  - LOG(DENS)
C        R  - set DENS=0      : for region: R < CMIN and R > CMAX 
C        B  - soft set DENS=0 : Density of point with distance R will be
C             multiplied by (1-exp(-R^2/2*CMIN)*exp(-R^2/(0.5*CMAX))
C             R is minimal value of four distancies to current point from eight
C             points: 0,0,0; 1,0,0; 0,1,0; 1,1,0; 0,0,1; 1,0,1; 0,1,1; 1,1,1
C             CMIN,CMAX - in angstroms
C
C           If we use two files:
C
C        2  - multiply  DENS-1 * DENS-2
C        N  - multiply  DENS-1 * DENS-2,but if DENS-2 < 0 result = 0
C        I  - multiply  DENS-1 * 1.0   ,but if DENS-2 > 0.5 result = 0
C        D  - division  DENS-1 / DENS-2
C        S  - substract DENS-1 - DENS-2*CONST 
C        E  - sigma=sqrt(2nd central moment), file_1-D, file_2-D^2
C        X  - (<r>^3+3*sigma^2*<r>), file_1-D file_2-sigma
C        F  - filter /Wangs's procedure/
C            If D1 is value of DENS-1 and D2 value of DENS-2 in the same 
C            point, program will write Dnew into output file: 
C                Dnew = D1  if D2 > CONST
C                       0   if D2 < CONST
C                                           DENS-2 is mask-file
C                                     DENS-1 ----------------> DENS-OUT
C                                            if DENS-2 > CONST          
C                                            else DLEV -------> DENS-OUT
C        K  - as "F" with statistcs
C
C   FILE_2:   input_file_2 name
C   FILE_O:   output_file name
C   CONST: <0.0> - for MODE = A - add : DENS + CONST')
C                             M - multiply: DENS * CONST')
C                             S - subtract DENS-1 - DENS-2*CONST')
C                             F - level for mask-file FILE-2')
C   CLIM: CMIN,CMAX <0,0> -   C - cutting ---> CMIN < DENS < CMAX')
C                                 CMAX=0 means without this limit')
C                             R - set DENS=0 : R < CMIN and R > CMAX 
C                             B - soft set DENS=0 
C                                 (1-exp(-R^2/2*CMIN)*exp(-R^2/(0.5*CMAX))
C                                 CMIN,CMAX - in angstroms
C   DLEV: <0.0>     - for MODE = F/K - level of solvent
C   ZLIM: ZMIN,ZMAX - numbers of Z-section for projection (MODE=P)')
C
C      SUBROUTINE MODDEN(MDOC,NAME1,NAME2,NAMEW
C     *    ,POOL,MEMORY,CONST1,CONST2,MSGF
C     *    ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C
C      Parameters:
C
C      MDOC  - mode of writting messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C      NAME1  - name of input dens-file_1.
C      NAME2  - name of input dens-file_2, if you want it, if not = " ".
C      NAMEW  - name of output dens-file.
C      MSGF   = MODE - function of program, see above / character*1/.
C      CONST1 = CONSTANT or = CMIN or = ZMIN  - see above.
C      CONST2               = CMAX or = ZMAX  
C                 or DLEV for MODE=F/K       
C      POOL   -  real array POOL(MEMORY).
C      MEMORY -  MEMORY/2 is memory for one Z-section of electron
C                density NX x NY.
C      ISYM  - integer*2 array for cryst.symmetry operators.
C      IPRSYM- dimension of integer*2 array ISYM(5,3,IPRSYM)
C      IERR  - signal of error / =1 -error , =o - OK / 
C
C      RESULT( 1)=NUMB
C      RESULT( 2)=AVER
C      RESULT( 3)=RMS
C      RESULT( 4)=NNN1
C      RESULT( 5)=DSUMP
C      RESULT( 6)=0.0
C      RESULT( 7)=NNN2
C      RESULT( 8)=DSUMN
C      RESULT( 9)=0.0
C      RESULT(10)=NNNZ
C      RESULT(11)=PERCNT
C
C -I-
C ----------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW)
      REAL      SH(3)
      CHARACTER NAME1*(*),NAME2*(*),NAMEW*(*),MSGF*1
      CHARACTER LINE*80
C -------------------------------------------------------------
      MD=-ABS(MDOC)-1
C --
      RAD   = 0.0
      SH(1) = 0.0
      SH(2) = 0.0
      SH(3) = 0.0
C --
      IFLS=2
      IF(NAME2(1:1).EQ.' ') IFLS=1
      IF(MSGF.EQ.'a') MSGF='A'
      IF(MSGF.EQ.'c') MSGF='C'
      IF(MSGF.EQ.'p') MSGF='P'
      IF(MSGF.EQ.'m') MSGF='M'
      IF(MSGF.EQ.'q') MSGF='Q'
      IF(MSGF.EQ.'d') MSGF='D'
      IF(MSGF.EQ.'s') MSGF='S'
      IF(MSGF.EQ.'f') MSGF='F'
      IF(MSGF.EQ.'r') MSGF='R'
      IF(MSGF.EQ.'b') MSGF='B'
      IF(MSGF.EQ.'u') MSGF='U'
      IF(MSGF.EQ.'e') MSGF='E'
      IF(MSGF.EQ.'t') MSGF='T'
      IF(MSGF.EQ.'x') MSGF='X'
      IF(MSGF.EQ.'l') MSGF='L'
      IF(MSGF.EQ.'k') MSGF='K'
      IF(MSGF.EQ.'i') MSGF='I'
      IF(MSGF.EQ.'n') MSGF='N'
      IF(MSGF.EQ.'h') MSGF='H'
      IF(MSGF.NE.'2'.AND.MSGF.NE.'F'.AND.MSGF.NE.'B'.AND.
     *   MSGF.NE.'A'.AND.MSGF.NE.'D'.AND.MSGF.NE.'Q'.AND.
     *   MSGF.NE.'M'.AND.MSGF.NE.'C'.AND.MSGF.NE.'*'.AND.
     *   MSGF.NE.'T'.AND.MSGF.NE.'U'.AND.MSGF.NE.'E'.AND.
     *   MSGF.NE.'S'.AND.MSGF.NE.'P'.AND.MSGF.NE.'R'.AND.
     *   MSGF.NE.'X'.AND.MSGF.NE.'3'.AND.MSGF.NE.'L'.AND.
     *   MSGF.NE.'K'.AND.MSGF.NE.'N'.AND.MSGF.NE.'I'.AND.
     *   MSGF.NE.'H') THEN
       MSGF='A'
      ENDIF
      WRITE(LINE,*) ' FUNCTION :',MSGF
      CALL MSGDOC(MD,LINE)

      IF(MSGF.EQ.'M') THEN
C       M  - MULTIPLY DENS * CONST
        AMLT=CONST1
        IF(AMLT.EQ.0.0) AMLT=1.0
        WRITE(LINE,*) ' COEF /DENS * COEF/ :',AMLT
        CALL MSGDOC(MD,LINE)
      ELSE IF(MSGF.EQ.'C') THEN
C       C  - CUTTING DENS: D=0 IF < CMIN ,D=CMAX IF > CMAX
        CMIN=CONST1
        CMAX=CONST2
        IF(CMAX.LE.0.0) CMAX=1.E 30
        WRITE(LINE,*) ' CUTTING LEVELS: CMIN,CMAX:',CMIN,CMAX
        CALL MSGDOC(MD,LINE)
      ELSE IF(MSGF.EQ.'U') THEN
C       U  - CUTTING DENS + (-CMIN)
        CMIN=CONST1
        CMAX=CONST2
        IF(CMAX.LE.0.0) CMAX=1.E 30
        WRITE(LINE,*) ' CUTTING LEVELS: CMIN,CMAX:',CMIN,CMAX
        CALL MSGDOC(MD,LINE)
      ELSE IF(MSGF.EQ.'R') THEN
        CMIN=CONST1
        CMAX=CONST2
        IF(CMAX.LE.0.0) CMAX=1.E 30
        WRITE(LINE,*) ' SET ZERO: RADII: RMIN,RMAX:',CMIN,CMAX
        CALL MSGDOC(MD,LINE)
      ELSE IF(MSGF.EQ.'B') THEN
        CMIN=CONST1
        CMAX=CONST2
        WRITE(LINE,*) ' soft SET ZERO: RMIN,RMAX:',CMIN,CMAX
        CALL MSGDOC(MD,LINE)
      ELSE IF(MSGF.EQ.'H') THEN
        RAD   = CONST1
        SH(1) = RESULT(1)
        SH(2) = RESULT(2)
        SH(3) = RESULT(3)
        WRITE(LINE,*) ' SET ZERO (point) : RAD:',RAD
        CALL MSGDOC(MD,LINE)
        WRITE(LINE,*) ' sh :',SH(1),SH(2),SH(3)
        CALL MSGDOC(MD,LINE)
      ELSE IF(MSGF.EQ.'A') THEN
C       A  - ADD : DENS + CONST
        ADD=CONST1
        WRITE(LINE,*) ' ADD-CONST :',ADD
        CALL MSGDOC(MD,LINE)
      ELSE IF(MSGF.EQ.'T') THEN
C       T  - step function : DENS=0 if <CONST; DENS=1.0 if >= CONST
        ADD=CONST1
        WRITE(LINE,*) ' LEVEL-CONST :',ADD
        CALL MSGDOC(MD,LINE)
      ELSE IF(MSGF.EQ.'P') THEN
C       P  - XY-PROJECTION DENS
        IZMINW=CONST1
        IZMAXW=CONST2
        IF(IZMAXW.LT.IZMINW) THEN
          IT=IZMAXW
          IZMAXW=IZMINW
          IZMINW=IT
        ENDIF
        WRITE(LINE,'('' IZMIN,IZMAX :'',2I5)') IZMINW,IZMAXW
        CALL MSGDOC(MD,LINE)
      ELSE IF(MSGF.EQ.'S') THEN
C       S  - SUBTRACT DENS-1 - DENS-2
        DSCALE=CONST1
        IF(DSCALE.EQ.0.0) DSCALE=1.0
        WRITE(LINE,*) ' CONST :',DSCALE
        CALL MSGDOC(MD,LINE)
      ELSE IF(MSGF.EQ.'F') THEN
C       F  - FILTER /WANG''S PROCEDURE/
        ALEVEL=CONST1
        DLEVEL=CONST2
        WRITE(LINE,*) ' CONST,D_level :',ALEVEL,DLEVEL
        CALL MSGDOC(MD,LINE)
      ELSE IF(MSGF.EQ.'K') THEN
C       K  - FILTER /WANG''S PROCEDURE/ AND STATISTICS
        ALEVEL=CONST1
        DLEVEL=CONST2
        WRITE(LINE,*) ' CONST,D_level :',ALEVEL,DLEVEL
        CALL MSGDOC(MD,LINE)
      ENDIF
C ------------------------------------------------------------
      CALL MODDN1(MDOC,NAME1,NAME2,NAMEW
     *    ,DSCALE
     *    ,MSGF,AMLT,IFLS,CMIN,CMAX,ADD,RAD,SH
     *    ,IZMINW,IZMAXW,ALEVEL,DLEVEL
     *    ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
      RETURN
      END


      SUBROUTINE RISOLINE(MDOC,MODE,IPICT,NAME1,NAME2
     * ,THETA,PHI,RMAX_CROSS
     * ,RMAX_IN,DRMS_IN,ARAD_IN,RESMAX_IN,COEF,SCALE_R,IERR)
C ---------------------------------------------------
C    ----   RISOLINE   -----    
C
C
C     IPICT =0 SELF 
C     IPICT =1 CROSS(T,P,C)
C     IPICT =2 CROSS(A,B,G)
C     IPICT =3 TRANS(X,Y,Z)      
C
C ----------------------------------------------------
C      PARAMETER ( MEMORY = 60000           )
C case INTEGER*2 IRR(INDXY),IRM(INDXY4)
C                POOL(1)   ,POOL(INDXY/2+1  )
C      PARAMETER ( INDXY4 = (2*MEMORY)/17   )
C      PARAMETER ( INDXY  = INDXY4*16       )
C case REAL IRR(INDXY) INTEGER*2 IRM(INDXY4)
C           POOL(1)             ,POOL(INDXY+1)
C      PARAMETER ( INDXY  = (MEMORY*32/33)  )
C      PARAMETER ( INDXY4 = (MEMORY/33)     )
C ----
      integer*2,  allocatable :: IPOOLR(:)
      integer*2,  allocatable :: IPOOL(:)
C ----
      CHARACTER NAME1*(*),NAME2*(*)
C --
      COMMON /COM_STEREO/ IZORG,IZO,IZ0,IZDEL,IXCENTR,IYCENTR
     *                ,IBASE,IVIEW,ISIZEP,IZSIZEP2,ISITE,STER
C
C     ISITE - 1= L 2 = R
C     STER    N/P/S
C
      CHARACTER     STER*1,TYPE*4
C -----------------
      PARAMETER ( NSMAX  = 96 )
      INTEGER*2 ISYM(5,3,NSMAX)

      CHARACTER TITLE*80
      CHARACTER LINE *80
C ====================================================================
      IERR   = 0
C -------------------
C     for subroutines MSGDOC and MSGERR
      MD     = -ABS(MDOC)-1
      M      = 99
C ------------------------------------------------
      IF(MODE.LT.0) THEN
        CALL ENDTX
        RETURN
      ENDIF
C ---
      IF(MODE.GE.0.AND.MODE.LE.1) CALL INIT_TX
C ---
      IBOXXI = 650
      IBOXYI = 500
      ISHXI  = 60
      ISHYI  = 10
      CALL SET_BOX_TX(IBOXXI,IBOXYI,ISHXI,ISHYI)
C -------------------------------------------------------------------
C     OPEN AND READ OF TITLE OF FILE-DENS
C
      MT1   = 10
      TYPE  = 'RI  '
      CALL ORFILE(M,MT1,NAME1,TYPE,NSYM,ISYM,NSMAX,IERR)
      IF(IERR.GT.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE-DENS')
        RETURN
      ENDIF
      CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *        ,F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TITLE,IERR)
      CLOSE(MT1)
      IF(IERR.GT.0) RETURN
      NXY=NX*NY
      IT = 0
      allocate(IPOOLR(1:NXY),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(IPOOL (1:NXY),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      IF(IT.GT.0) THEN
        IERR = 1
        CALL MSGERR(MDOC,
     *    ' ERROR: in RSOLINE: problem with memory allocation')
        CALL MSGERR(MDOC,
     *    '                    try to change resolution')
        RETURN
      ENDIF
C ---
      ITYPE  =  0
      MT1    = 10
      CALL IRDENS(MT1,NAME1,M,ITYPE,ICNTZ1,NXR,NYR,NZR,NZX,
     * NZN,RMAX1,RMIN,IPOOLR,SCALE,ACELL,BCELL,CCELL,ALPHA,BETA,GAMMA,
     * DRMS,RAVER,RESOL,NX0,NY0,NZ0,ITR,TITLE
     * ,NSYM,ISYM,NSMAX,IERR)
      IF(IERR.GT.0) THEN
        deallocate(IPOOLR,STAT=ISTAT)
        deallocate(IPOOL,STAT=ISTAT)
        CALL MSGERR(MDOC,' ERR: OPEN FILE-SRF')
        RETURN
      ENDIF

      RMAX_RF=RMAX1
C ------
C      program will use :
C
C      ACELL = 360.0 
C      BCELL = 90.0
C      CCELL = CHI
C      ALPHA = 2pi/4.0  (in rad)
C      TITLE - 40 charaters
C ------
C
C     IPICT =0 SELF 
C     IPICT =1 CROSS(T,P,C)
C     IPICT =2 CROSS(A,B,G)
C     IPICT =3 TRANS(X,Y,Z)      
C
      IF(IPICT.EQ.3) THEN

      ELSE IF(IPICT.EQ.2) THEN

      ELSE
        ANGL  = ALPHA*4.0
        CHI   = CCELL
      ENDIF
C------------------------------
      RMAX_RF = RMAX1
      IF(COEF.LE.0.000001) THEN
        COEF=4.0
      ENDIF
      IF(DRMS_IN.GT.0.00000001) THEN
        DRMS    = DRMS_IN
        RMAX_RF = RMAX_IN
        RESOL   = RESMAX_IN
      ENDIF
      RMAX = DRMS * COEF
C      RMAXR=RMAX1
C input RRMAX
C      IF(RRMAX.GT.1.E-8) RMAX1=RRMAX
C ---------------------------------
      NXYR = NXR*NYR
C -- blanc -- 
      NX = NXR-2
      NY = NYR-2
C ---
      NX1 = NX+1
      NX4 = NX/4+2
      NY1 = NY+1
      NY4 = NY/4+2
      NXY4= NX4*NY4
C ---------------------------------------------------------
      NPAGE =  1
      MT2   = 12

C     NAME2 = 'molrep_rf.ps'
C ---
      IF(MODE.GE.0.AND.MODE.LE.1) CALL OPENTX(NAME2,NPAGE,IERR)

      CALL GET_BOX_TX(IBOXX,IBOXY,ISHX_PS,ISHY_PS,IX0_PS,IY0_PS
     *   ,LIM_XMIN,LIM_XMAX,LIM_YMIN,LIM_YMAX)

      IF(IERR.NE.0) THEN
        deallocate(IPOOLR,STAT=ISTAT)
        deallocate(IPOOL,STAT=ISTAT)
        CALL MSGERR(MDOC,' ERROR: can not open output file')
        RETURN
      ENDIF

      CALL SET_BOX_TX(IBOXXI,IBOXYI,ISHXI,ISHYI)
      CALL GET_BOX_TX(IBOXX,IBOXY,ISHX_PS,ISHY_PS,IX0_PS,IY0_PS
     *   ,LIM_XMIN,LIM_XMAX,LIM_YMIN,LIM_YMAX)

C-------------------------------------------
      ITYPE=1
      IT   =2
      CALL NEWPEN(IT)
C -----------------------------------------
      M=99
      CALL IRDENS(MT1,NAME1,M,ITYPE,ICNTZ1,NXR,NYR,NZR,NZX,
     *NZN,RMAX1,RMIN,IPOOLR,RSCAL,ACELL,BCELL,CCELL,ALPHA,BETA,GAMMA,
     *DRMS,RAVER,RESOL,NX0,NY0,NZ0,ITR,TITLE
     *,NSYM,ISYM,NSMAX,IERR)
      IF(IERR.NE.0) THEN
        deallocate(IPOOLR,STAT=ISTAT)
        deallocate(IPOOL,STAT=ISTAT)
        CALL MSGERR(MDOC,' ERROR: can not open input file')
        RETURN
      ENDIF
C ------------------------------------------
C---------------------------------------------
C --- title ---

      IF(MODE.GE.0.AND.MODE.LE.1) THEN

        IF(IPICT.EQ.0) THEN
          CALL PSCTXT (280.0,730.0, 25.0, 'Self Rotation Function')
        ELSE IF(IPICT.EQ.1) THEN
          CALL PSCTXT (280.0,730.0, 25.0, 'Cross Rotation Function')
        ENDIF

        CALL PSTEXT (440.0 ,760.0 ,10.0 , 'MOLREP')

        IF(MODE.EQ.0) THEN
          WRITE(LINE,'(''coef :'',F8.2,'' Resmax : '',F8.2)') 
     *      COEF,RESOL
          CALL PSTEXT (350.0 ,700.0 ,12.0 , LINE)
        ELSE
          WRITE(LINE,'(''Rad  :'',F8.2,'' Resmax : '',F8.2)') 
     *    ARAD_IN,RESOL
          CALL PSTEXT (350.0 ,700.0 ,12.0 , LINE)
        ENDIF
  
        WRITE(LINE,
     *'(''RF(theta,phi,chi)_max :'',G14.4,''    rms : '',G14.4)') 
     *    RMAX_RF,DRMS
       CALL PSTEXT (50.0 ,700.0 ,12.0 , LINE)

      ENDIF
C --- end title ---

      RMAX=RMAX*RSCAL

C                         INTEGER*2 IRM(NX4,NY4)
C                                       INTEGER*2 IR(NXR,NYR)
C                             NX,NY,IRM,  NX4,NY4,IR,  NXR,NYR   
      CALL PICTURE(MODE,IPICT,NX,NY,IPOOL,NX4,NY4,IPOOLR,NXR,NYR
     * ,THETA,PHI,RMAX_CROSS
     * ,CHI,ACELL,BCELL,ANGL,RMAX,RMAX1,SCALE_R,IERR)

      deallocate(IPOOLR,STAT=ISTAT)
      deallocate(IPOOL,STAT=ISTAT)

      IF(IERR.NE.0) THEN
        CALL ENDTX
        GO TO 999
      ENDIF
C ================================================================
      IF(MODE.EQ.0) CALL ENDTX
C      CALL MSGDOC(MDOC,'    --- VOILA ---   ')
      CLOSE(MT1)
      RETURN
C -----------------------------------------------
 999  CONTINUE
      CALL ENDTX
      IERR=1
      RETURN
      END

C -I-
      SUBROUTINE GRAD_X(MDOC,NAMEC,NAMED,NAMEM,NAMEO,NAMEE
     * ,BADD,SCALEF,BADDF,DISPFR,GRAD,P1
     * ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C ------------------------------------------------------------
C -P- GRAD_X:  calculates the gradients for atomic model from diff. map.
C -S-
C
C  Dialog and Batch: 
C
C    FILE_C -  input file of coordinates.
C    FILE_D -  input file of observed density
C    FILE_M -  input file of density of model
C    FILE_O -  output file of gradients.
C    FILE_E -  output file of some indicators.
C    BADD:  -  <0.0> additional B-factor /default are for SF calculation/
C
C  Parameters of subroutine GRAD_X: 
C
C      SUBROUTINE GRAD_X(MDOC,NAMEC,NAMED,NAMEM,NAMEO,NAMEE
C     * ,BADD,SCALEF,BADDF,DISPFR
C     * ,RESULT,IPRROW,POOL,MEMORY,NCRDMAX,ISYM,IPRSYM,IERR)
C
C    MDOC   - mode of writting messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C    MODE   - see above. / character*1 /
C    NAMEC  - name of input file without extention "crd".
C    NAMED  - name of input file of density.
C    NAMEM  -
C    NAMEO  -
C    NAMEE  -
C    BADD  -  <0.0> additional B-factor /default are for SF calculation/
C    NCRDMAX - maximal number of atoms.
C    POOL    - real array POOL(MEMORY)
C    MEMORY  - dimension array POOL. 
C              MEMORY = MAPMAX + (NCRDMAX/2)*5 , were MAPMAX - maximal
C                                                size of XY-section ( NX*NY)
C    ISYM   - integer*2 array for cryst.symmetry operators.
C    IPRSYM - dimension of integer*2 array ISYM(5,3,IPRSYM),
C             number of cryst. symm. operators.
C    IERR   - output signal of error / = 1 -error , = 0 - OK / 
C
C        output information 
C
C
C      RESULT(1)  =CFVOL
C      RESULT(2)  =COEF
C      RESULT(3)  =SIGMA
C      RESULT(4)  =SIGMAD  
C      RESULT(5)  =SCALEF
C      RESULT(6)  =BADD
C      RESULT(7)  =SHESSX
C      RESULT(8)  =SHESSD
C      RESULT(9)  =DRV_RMS
C      RESULT(10) =SHFT_RMS
C      RESULT(11) =DISPFR
C -I-
C ----------------------------------------------------------
      INTEGER*2        ISYM(5,3,IPRSYM)
C---------------------------------------------------------------
      CHARACTER NAMEC*(*),NAMED*(*),NAMEM*(*),NAMEO*(*),P1*1,POSITIV*1
      CHARACTER MODE*1,GRAD*1,PRINT*1,NAMEE*(*)
C==================================================================
      REAL RESULT(IPRROW)
C ----------------------------------------
C ---
      GRAD=' '
      CALL SGENGRD(MDOC,NAMEC,NAMED,NAMEM,NAMEO,NAMEE
     * ,P1,POSITIV,MODE,GRAD,BADD,SCALEF,BADDF,DISPFR
     * ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C ---
      RETURN
      END
C -I-
      SUBROUTINE SURFACE(MDOC,NAMER,NAMEO,RH2O,DEL,BLIM,NMR,SURF
     * ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C ------------------------------------------------------   
C -P- SURFACE - calculates area on Van-der-Waals surface accessible to solvent.
C               write to file B_iso = SURFACE*10.0 + B_constant
C -S-   
C
C      Dialog:
C
C   FILE_I  - input file-CRD /without extention "crd"/
C   FILE_O: - output file name /without extention "crd"/
C                   default - <surface.crd>
C   RAD: <1.40> - radius H20 /angstroms/
C   DEL: <0.10> - delta between points /angstroms/
C   BLIM: <15>   - program writes to output file:
C                             B_iso = SURFACE*10.0 + BLIM
C
C      It possible to use subroutine SURFACE by program:
C
C      SUBROUTINE SURFACE(MDOC,NAMER,NAMEO,RH2O,DEL,BLIM,POOL,MEMORY
C     * ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C
C  Parameters: 
C
C    MDOC  - mode of writting messages to DOC-file
C            0 - only terminal , < - 0 only file, 0 < < 99 - both
C            >= 99 - don't write  
C    NAMER   - input file-CRD /without extention "crd"/
C    NAMEO   - output file name /without extention "crd"/
C                   default - <surface.crd>
C    RAD: <1.40> - radius H20 /angstroms/
C    DEL: <0.10> - delta between points /angstroms/
C    POOL    - real array POOL(MEMORY)
C    MEMORY  - dimension of array POOL, maximal number of atoms = MEMORY/11
C    ISYM    - integer*2 array for cryst.symmetry operators.
C    IPRSYM  - dimension of integer*2 array ISYM(5,3,IPRSYM),
C              number of cryst. symm. operators.
C    IERR    - output signal of error / =1 -error , =0 - OK / 
C
C    RESULT /real RESULT(IPRROW)/ - array for output information:
C
C      RESULT(1) = 
C -I-
C --------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW)

C      INTEGER   IRESR(NATMX),ICHNR(NATMX)
C      REAL      XR(NATMX),YR(NATMX),ZR(NATMX)
C      REAL      OCCR(NATMX),TEMPR(NATMX),SURFR(NATMX),RADVDW(NATMX)
C      REAL      ELPOT(NATMX)

      integer,   allocatable :: IRESR(:)
      integer,   allocatable :: ICHNR(:)
      real,      allocatable :: XR(:)
      real,      allocatable :: YR(:)
      real,      allocatable :: ZR(:)
      real,      allocatable :: OCCR(:)
      real,      allocatable :: TEMPR(:)
      real,      allocatable :: SURFR(:)
      real,      allocatable :: RADVDW(:)
      real,      allocatable :: ELPOT(:)

      CHARACTER LINE*80,NAMER*(*),NAMEO*(*),SURF*1
C ------------------------------------------------------
      IERR = 0
      ITEST = 1
      NATMX = 10

      allocate(XR(1:NATMX),STAT=ISTAT)
      allocate(YR(1:NATMX),STAT=ISTAT)
      allocate(ZR(1:NATMX),STAT=ISTAT)
      allocate(OCCR(1:NATMX),STAT=ISTAT)
      allocate(TEMPR(1:NATMX),STAT=ISTAT)
      allocate(SURFR(1:NATMX),STAT=ISTAT)
      allocate(RADVDW(1:NATMX),STAT=ISTAT)
      allocate(ELPOT(1:NATMX),STAT=ISTAT)
      allocate(IRESR(1:NATMX),STAT=ISTAT)
      allocate(ICHNR(1:NATMX),STAT=ISTAT)

      ILAST  = 0
      IFIRST = 0
      MOD_FIRST = 1
      MOD_LAST  = 10000 
      NR_MAX = 0

      DO IMODEL=MOD_FIRST,MOD_LAST
        CALL RDCOOR_SR(MDOC,NAMER,NR,XR,YR,ZR,OCCR,TEMPR,SURFR
     *     ,RADVDW,ELPOT,IRESR,ICHNR,NATMX
     *     ,NSYM,ISYM,IPRSYM,IFIRST,ILAST,IMODEL,NMR,ITEST,IERR)
        IF(IERR.NE.0) GO TO 900

        IF(NR.LE.0) THEN
          CALL MSGERR(MDOC,' ERROR: surface: number of atoms = 0')
          IERR=1
          GO TO 900
        ENDIF
        IF(NR.GT.NR_MAX) NR_MAX = NR
        IF(ILAST.NE.0) GO TO 100
      ENDDO
 100  CONTINUE

      IF(NR_MAX.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: surface: number of atoms = 0')
        IERR=1
        GO TO 900
      ENDIF

      deallocate(XR,STAT=ISTAT)
      deallocate(YR,STAT=ISTAT)
      deallocate(ZR,STAT=ISTAT)
      deallocate(OCCR,STAT=ISTAT)
      deallocate(TEMPR,STAT=ISTAT)
      deallocate(SURFR,STAT=ISTAT)
      deallocate(RADVDW,STAT=ISTAT)
      deallocate(ELPOT,STAT=ISTAT)
      deallocate(IRESR,STAT=ISTAT)
      deallocate(ICHNR,STAT=ISTAT)

      NATMX = NR_MAX
      IT = 0
      allocate(XR(1:NATMX),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(YR(1:NATMX),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(ZR(1:NATMX),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(OCCR(1:NATMX),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(TEMPR(1:NATMX),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(SURFR(1:NATMX),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(RADVDW(1:NATMX),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(ELPOT(1:NATMX),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(IRESR(1:NATMX),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(ICHNR(1:NATMX),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      IF(IT.NE.0) THEN
        IERR = 1
        CALL MSGERR(MDOC,
     *    ' ERROR: in SURFACE : problem with memory allocation')
        CALL MSGERR(MDOC,
     *    '                     try to change resolution')
        RETURN
      ENDIF
C
      CALL SURFACE_RUN(MDOC,NAMER,NAMEO,RH2O,DEL,BLIM,NMR
     * ,SURF,NATMX
     * ,XR,YR,ZR,OCCR,TEMPR,SURFR,RADVDW,ELPOT
     * ,IRESR,ICHNR
     * ,RESULT,IPRROW,ISYM,IPRSYM,IERR)

900   CONTINUE

      deallocate(XR,STAT=ISTAT)
      deallocate(YR,STAT=ISTAT)
      deallocate(ZR,STAT=ISTAT)
      deallocate(OCCR,STAT=ISTAT)
      deallocate(TEMPR,STAT=ISTAT)
      deallocate(SURFR,STAT=ISTAT)
      deallocate(RADVDW,STAT=ISTAT)
      deallocate(ELPOT,STAT=ISTAT)
      deallocate(IRESR,STAT=ISTAT)
      deallocate(ICHNR,STAT=ISTAT)

      RETURN
      END

      SUBROUTINE PKSRCH(MDOC,NAME,NAMEO,ALEVEL,DIST_LIM_R,SPEC
     *  ,NPMAX,ISYM,IPRSYM,RESULT,IPRMAX,IPRROW,IERR)
C -------------------------------------------------------
      REAL      RESULT(IPRMAX,IPRROW)

c     INTEGER*2 IPOOL(NCRES,3)
      integer*2,   allocatable :: IPOOL(:,:)

      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER NAME*(*),NAMEO*(*),SPEC*1
      REAL      ALEVEL,DIST_LIM_R
C -------------------------------------------------------------
      COMMON/COM_SRPK/ FRTOCR,CRTOFR,NX,NY,NZ,IZMIN,IZMAX,
     *                 DELA,DELG,DELB,TYPE
      REAL      FRTOCR(3,3),CRTOFR(3,3)
      CHARACTER TYPE*1,TYPE_S*1,TYPE2*1
C --------------------------------------------------------------
      PARAMETER ( IPRORG=24)
      REAL      SOR(3,IPRORG)
C ----------------------
      REAL        SCL (3),XF(3),XC(3),RINDEX
      INTEGER     ISECT(3),INDEX
      CHARACTER   TTT*80,LINE*80,CH4*4
      EQUIVALENCE (RINDEX,INDEX)
C --------------------------------------------------------------
      PI   = 4.0*ATAN(1.0)
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      IF(SPEC.EQ.'n') SPEC='N'
      IF(SPEC.EQ.'p') SPEC='P'
      IF(SPEC.EQ.'a') SPEC='A'
      IF(SPEC.EQ.'s') SPEC='S'
      IF(SPEC.NE.'N'.AND.SPEC.NE.'P'.AND.SPEC.NE.'A'.AND.
     *                                        SPEC.NE.'S') SPEC='Y'
C --------------------------------
      CH4   = 'RI  '
      MT    = 10
      CALL ORFILE(M,MT,NAME,CH4,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) THEN
        IERR=1
        RETURN
      ENDIF
      CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *        ,F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TTT,IERR)
      CLOSE(MT)
      IF(IERR.GT.0) THEN
        IERR=2
        RETURN
      ENDIF

      NXY = NX*NY
      allocate(IPOOL(1:NXY,1:3),STAT=ISTAT)
      IF(ISTAT.GT.0) THEN
        IERR = 1
        CALL MSGERR(MDOC,
     *    ' ERROR: in PEAKSRCH: problem with memory allocation')
        CALL MSGERR(MDOC,
     *    '                     try to change resolution')
        RETURN
      ENDIF

      ITYPE = 0
      MT    = 10
      CALL IRDENS(MT,NAME,MD,ITYPE,ICNTZ,NX,NY,NZ,IZMAX,
     *   IZMIN,RMAX,RMIN,IPOOL(1,1),SCALE,A,B,C,AL,BE,GA,RMS
     *   ,AVER,RESOL,IX0,IY0,IZ0,ITR,TTT
     *   ,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        deallocate(IPOOL,STAT=ISTAT)
        CALL MSGERR(MD,' ERR: OPEN FILE-DENS')
        RETURN
      ENDIF
c      NXY = NX*NY
c      IF(NXY.GT.NCRES) THEN
c        CALL MSGERR(MD,' ERR: NOT MEMORY FOR 3 SECTIONS X-Y ')
c        CLOSE(MT)
c        RETURN
c      ENDIF
C ------------------------------------------------------------
      CALL CALC_ORIG_AV(MDOC,NORIG,SOR,IPRORG
     *   ,NSYM,ISYM,IPRSYM,IERR)
C      CALL CALC_ORIG(MDOC,NORIG,SOR,IPRORG
C    *   ,NSYM,ISYM,IPRSYM,IERR)
C -------------------------------------------------------------
      DIST_LIM = DIST_LIM_R
      IF(TTT(1:4).EQ.'RF: '.AND.TTT(5:8).EQ.'ABG ') THEN
        DELA = (AL*4.0)/NX
        DELG = (BE*4.0)/NY
        DELB = PI/(NZ-1)
C        A=ARAD*10.
C        B=RN  *10.
C        C=RX  *10.
C        AL=PI/(2.*FLOAT(NSYM1))
C        BE=PI/(2.*FLOAT(NSYM2))
C        GA=PI/2.
C        NX=IPRGAM
C        NY=IPRGAM
C        NZ=180./BETDEL+1.
C        DELALP=360.0/NX
C        IZMIN=BETMIN/BETDEL
C        IZMAX=BETMAX/BETDEL
        TYPE  = 'R'
        TYPE2 = 'R'
        IF(DIST_LIM_R.LE.0.00001) THEN
          T = RESOL*1.5
          IF(T.GT.6.0) T=6.0
          DIST_LIM = (PI*T)/180.0
        ELSE
          T        = DIST_LIM_R
          DIST_LIM = (PI*T)/180.0
        ENDIF
      ELSE      
        TYPE = 'D'
        IF(TTT(1:4).EQ.'PATT')  TYPE='P'
        TYPE2 = TYPE
        IF(TTT(5:8).NE.'REAL'.AND.
     *    (TTT(9:12).EQ.'SPHR'.OR.TTT(9:12).EQ.'GAUS')) THEN
          TYPE  = 'H'
          TYPE2 = 'H'
        ENDIF
        IF(TTT(5:8).NE.'REAL'.AND.TTT(9:12).EQ.'TRPC') THEN
          TYPE  = 'T'
          TYPE2 = 'H'
        ENDIF
        IF(TTT(5:8).NE.'REAL'.AND.TTT(9:12).EQ.'TRP2') THEN
          TYPE  = 'T'
          TYPE2 = 'T'
        ENDIF

        CALL FRORTH(A,B,C,AL,BE,GA,FRTOCR,CRTOFR,IERR)

        IF(DIST_LIM_R.LE.0.0) THEN
          DIST_LIM = RESOL
          IF(TTT(5:8).EQ.'TRNS'.OR.TTT(5:8).EQ.'MULT'.OR.
     *       TTT(5:8).EQ.'PACK') DIST_LIM = RESOL
        ENDIF
        CALL C_RD_CR
      ENDIF
      IF(TYPE .EQ.'D') NORIG=1
      IF(TYPE .EQ.'P') NORIG=1
      IF(TYPE2.EQ.'T') NORIG=1
      IF(TTT(5:8).EQ.'PACK') NORIG=1
C ----------------------
      IF(ALEVEL.LE.0.0) ALEVEL=1.0
      DLIM = RMS*ALEVEL
      WRITE(LINE,'('' limit Dens-MIN,D-RMS :'',2G14.4)') DLIM,RMS     
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,'('' SPEC : '',A1)') SPEC     
      CALL MSGDOC(MD,LINE)

      IF(TTT(1:4).EQ.'RF: '.AND.TTT(5:8).EQ.'ABG ') THEN
        T = (180.0*DIST_LIM)/PI
        WRITE(LINE,'('' distance limit :'',G14.4,'' / deg /'')') T     
        CALL MSGDOC(MD,LINE)
      ELSE
        WRITE(LINE,'('' distance limit :'',G14.4,'' / angstrom/'')') 
     *  DIST_LIM     
        CALL MSGDOC(MD,LINE)
      ENDIF

      ITYPE=-1
C -----------------
      JPRMAX = IPRMAX
      IF(NPMAX.GT.0.AND.NPMAX.LT.JPRMAX) JPRMAX = NPMAX
      NPEAK = 0
      IDEL  = 1
      DO I=1,3
      DO J=1,NXY
        IPOOL(J,I)=-32766
      ENDDO
      ENDDO
      ISECT(1) = 1
      ISECT(2) = 2
      ISECT(3) = 3
      SCL(1)   = 1.0
      SCL(2)   = 1.0
      SCL(3)   = 1.0
      CALL IRDENS(MT,NAME,MD,ITYPE,ICNTZ,NX,NY,NZ,IZMAX,
     *   IZMIN,RMAX,RMIN,IPOOL(1,2),SCL(2),A,B,C,AL,BE,GA,RMS
     *   ,AVER,RESOL,IX0,IY0,IZ0,ITR,TTT
     *   ,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        deallocate(IPOOL,STAT=ISTAT)
        CALL MSGERR(MD,' ERR: READ FILE-DENS')
        RETURN
      ENDIF
      IPP = ISECT(1)        
      IP  = ISECT(2)        
      IPN = ISECT(3)
C -------------------------------------------------------------
      NNX = NX
      NNY = NY
C      IF(TYPE.EQ.'H') THEN
C        NNX = NX/2
C        NNY = NY/2
C      ENDIF
      DO     IZ=IZMIN+1,IZMAX+1
        IPP = ISECT(1)        
        IP  = ISECT(2)        
        IPN = ISECT(3)
        IZ1 = IZ-1
        Z   = IZ1/FLOAT(NZ)
        IF(IZ.LE.IZMAX) THEN        
          CALL IRDENS(MT,NAME,MD,ITYPE,ICNTZ,NX,NY,NZ,IZMAX,
     *     IZMIN,RMAX,RMIN,IPOOL(1,IPN),SCL(IPN),A,B,C,AL,BE,GA,RMS
     *     ,AVER,RESOL,IX0,IY0,IZ0,ITR,TTT
     *     ,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            deallocate(IPOOL,STAT=ISTAT)
            CALL MSGERR(MDOC,' ERR: READ FILE-DENS')
            RETURN
          ENDIF
        ELSE
          SCL(IPN)=1.0
          DO J=1,NXY
            IPOOL(J,IPN)=-32766
          ENDDO
        ENDIF

        IXCONST=0
        DO     IY=1,NNY
          IND0 = (IY-1)*NX
          DO     IX=1,NNX
            IND = IND0+IX
            D  = IPOOL(IND,IP )/SCL(IP )
            ID = IPOOL(IND,IP )
            IF(IX.EQ.1) THEN
              DOLD =D
              IDOLD=ID
            ELSE
              IF(ID.NE.IDOLD) THEN
                IXCONST=0
                GO TO 400
              ENDIF
            ENDIF
          ENDDO
          IXCONST=1
        ENDDO
  400   CONTINUE

        IYCONST=0
        DO     IX=1,NNX
          DO     IY=1,NNY
            IND0 = (IY-1)*NX
            IND  = IND0+IX
            D    = IPOOL(IND,IP )/SCL(IP )
            ID   = IPOOL(IND,IP )
            IF(IY.EQ.1) THEN
              DOLD =D
              IDOLD=ID
            ELSE
              IF(ID.NE.IDOLD) THEN
                IYCONST=0
                GO TO 410
              ENDIF
            ENDIF
          ENDDO
          IYCONST=1
        ENDDO
  410   CONTINUE

        NNNY=NNY
        IF(IYCONST.EQ.1) NNNY=1
        DO     IY=1,NNNY
          Y    = (IY-1)/FLOAT(NY)
          IND0 = (IY-1)*NX

          NNNX=NNX
          IF(IXCONST.EQ.1) NNNX=1
          DO     IX=1,NNNX
            X   = (IX-1)/FLOAT(NX)
            IND = IND0+IX

            D  = IPOOL(IND,IP )/SCL(IP )
            ID = IPOOL(IND,IP )
            DP = IPOOL(IND,IPP)/SCL(IPP)
            DN = IPOOL(IND,IPN)/SCL(IPN)

            IF(D.GT.DLIM) THEN
              IF(D.GT.DP) THEN
                IF(D.GE.DN) THEN
                  DO JY=-IDEL,IDEL
                    JYY=IY+JY
                    IF(JYY.LT.1) THEN
                      IF(ITR.EQ.0) THEN
                        JYY=JYY+NY
                      ELSE
                        GO TO 300
                      ENDIF
                    ENDIF
                    IF(JYY.GT.NY) THEN
                      IF(ITR.EQ.0) THEN
                        JYY=JYY-NY
                      ELSE
                        GO TO 300
                      ENDIF
                    ENDIF
                    JND0=(JYY-1)*NX
                    DO JX=-IDEL,IDEL
                      JXX=IX+JX
                      IF(JXX.LT.1) THEN
                        IF(ITR.EQ.0) THEN
                          JXX=JXX+NX
                        ELSE
                          GO TO 200
                        ENDIF
                      ENDIF
                      IF(JXX.GT.NX) THEN
                        IF(ITR.EQ.0) THEN
                          JXX=JXX-NX
                        ELSE
                          GO TO 200
                        ENDIF
                      ENDIF
                      IF(JXX.NE.IX.OR.JYY.NE.IY) THEN
                        IF(TYPE.NE.'R'.OR.
     *                    ((IZ1.NE.0   .OR.JX.NE.-JY).AND.
     *                     (IZ1.NE.NZ-1.OR.JX.NE. JY)     ))THEN 
                        JND=JND0+JXX
                        DD =IPOOL(JND,IP)/SCL(IP)
                        IDD=IPOOL(JND,IP)
                        IF(IDD.GT.ID) GO TO 100
                        ENDIF
                      ENDIF
 200                  CONTINUE
                    ENDDO
 300                CONTINUE
                  ENDDO
                  DRMS = D/RMS
                  IX1  = IX-1
                  IY1  = IY-1

                  TYPE_S = TYPE
                  IF(TYPE_S.EQ.'H') TYPE_S = 'P'
                  IF(SPEC  .EQ.'P') TYPE_S = 'P'

                  IF(SPEC.EQ.'N'.OR.SPEC.EQ.'P') THEN
                    CALL DEF_SPEC_POS(IX1,IY1,IZ1,DIST_LIM
     *              ,TYPE_S,ISPEC,SOR,NORIG,NSYM,ISYM,IPRSYM,IERR)
                    IF(ISPEC.NE.0) GO TO 100
                  ENDIF

                  IF(IX.GT.1.AND.IX.LT.NX) THEN
                    KIND0 = IY1*NX
                    KIND  = KIND0+IX1
                    D1    = IPOOL(KIND,IP)/SCL(IP)
                    D2    = D
                    KIND0 = IY1*NX
                    KIND  = KIND0+(IX+1)
                    D3    = IPOOL(KIND,IP)/SCL(IP)
                    CALL PARAB(D1,D2,D3,X_PR,C_PR,D_PR)
                  ELSE
                    X_PR = 0.0
                    C_PR = 0.0
                    D_PR = D
                  ENDIF
                  FX = FLOAT(IX1)+X_PR

                  IF(IY.GT.1.AND.IY.LT.NY) THEN
                    KIND = (IY1-1)*NX+IX
                    D1   = IPOOL(KIND,IP)/SCL(IP)
                    D2   = D
                    KIND = (IY1+1)*NX+IX
                    D3   = IPOOL(KIND,IP)/SCL(IP)
                    CALL PARAB(D1,D2,D3,X_PR,C_PR,D_PR)
                  ELSE
                    X_PR = 0.0
                    C_PR = 0.0
                    D_PR = D
                  ENDIF
                  FY = FLOAT(IY1)+X_PR


                  IF(IZ1.GT.IZMIN.AND.IZ1.LT.IZMAX) THEN
                    D1 = DP
                    D2 = D
                    D3 = DN
                    CALL PARAB(D1,D2,D3,X_PR,C_PR,D_PR)
                  ELSE
                    X_PR = 0.0
                    C_PR = 0.0
                    D_PR = D
                  ENDIF
                  FZ = FLOAT(IZ1)+X_PR

                  T_DIST_LIM = DIST_LIM
                  IF(SPEC.EQ.'A') THEN
                    FX = FLOAT(IX1)
                    FY = FLOAT(IY1)                  
                    FZ = FLOAT(IZ1)
                    T_DIST_LIM =-1.0
                  ENDIF

                  CALL PSTORE(MDOC,NPEAK,D,DRMS,IX1,IY1,IZ1,T_DIST_LIM
     *            ,FX,FY,FZ
     *            ,RESULT(1,1),RESULT(1,2),RESULT(1,3),RESULT(1,4)       
     *            ,RESULT(1,5),RESULT(1,6),RESULT(1,7),RESULT(1,8)       
     *            ,RESULT(1,9),JPRMAX,IPRROW
     *            ,SOR,NORIG,NSYM,ISYM,IPRSYM,TYPE,IERR)
 100              CONTINUE
                ENDIF
              ENDIF
            ENDIF
          ENDDO
        ENDDO

        ITEMP    = ISECT(1)
        ISECT(1) = ISECT(2)
        ISECT(2) = ISECT(3)
        ISECT(3) = ITEMP

      ENDDO
C ----------------------
      NPMAXW = NPMAX
      NPMAXP = NPMAX
      IF(NPMAXP.LE.0) NPMAX = 20
      CALL RES_PRINT(MDOC,NPEAK,NPMAXP
     *            ,RESULT(1,1),RESULT(1,2),RESULT(1,3),RESULT(1,4)       
     *            ,RESULT(1,5),RESULT(1,6),RESULT(1,7),RESULT(1,8)       
     *            ,RESULT(1,9),RESULT(1,10),RESULT(1,11),RESULT(1,12)    
     *            ,SPEC,IPRMAX,IPRROW
     *            ,NSYM,ISYM,IPRSYM,IERR)
C ----------------------
c                                        1      2     3      4
c      SUBROUTINE RES_PRINT(MDOC,NPEAK,IXPEAK,IYPEAK,IZPEAK,PEAK
c           5    6   7   8   9
c     *  ,SIGPK,DXA,DYB,DZG,INDPK
      IF(NPEAK.GT.0) THEN

        DO I=1,NPEAK
          RINDEX       = RESULT(I,9)
          RESULT(I,10) = RESULT(INDEX,1)
          RESULT(I,11) = RESULT(INDEX,2)
          RESULT(I,12) = RESULT(INDEX,3)
        ENDDO
        DO I=1,NPEAK
          RINDEX      = RESULT(I,10)
          RESULT(I,1) = INDEX
          RINDEX      = RESULT(I,11)
          RESULT(I,2) = INDEX
          RINDEX      = RESULT(I,12)
          RESULT(I,3) = INDEX
        ENDDO

        DO I=1,NPEAK
          RINDEX       = RESULT(I,9)
          RESULT(I,10) = RESULT(INDEX,4)
          RESULT(I,11) = RESULT(INDEX,5)
        ENDDO
        DO I=1,NPEAK
          RESULT(I,4) = RESULT(I,10)
          RESULT(I,5) = RESULT(I,11)
        ENDDO

        DO I=1,NPEAK
          RINDEX       = RESULT(I,9)
          RESULT(I,10) = RESULT(INDEX,6)
          RESULT(I,11) = RESULT(INDEX,7)
          RESULT(I,12) = RESULT(INDEX,8)
        ENDDO
        DO I=1,NPEAK
          RESULT(I,6)  = RESULT(I,10)
          RESULT(I,7)  = RESULT(I,11)
          RESULT(I,8)  = RESULT(I,12)
        ENDDO

        RESULT(1,12) = NPEAK

        IF(TYPE.NE.'R') THEN
          DO I=1,NPEAK
            XF(1)        = RESULT(I,6)
            XF(2)        = RESULT(I,7)
            XF(3)        = RESULT(I,8)
            RESULT(I,9)  = RESULT(I,6)
            RESULT(I,10) = RESULT(I,7)
            RESULT(I,11) = RESULT(I,8)
            CALL MVMULT(FRTOCR,XF,XC)
            RESULT(I,6) = XC(1)
            RESULT(I,7) = XC(2)
            RESULT(I,8) = XC(3)
          ENDDO
        ENDIF
      ELSE
        RESULT(1,12) = 0
        IERR = 0
      ENDIF
      CLOSE(MT)

      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.GT.0.AND.NAMEO(1:1).NE.','.AND.NAMEO(1:1).NE.' ')THEN
      IF(NPEAK.GT.0.AND.TYPE.NE.'R') THEN
        CALL WRT_PEAKS(M,NAMEO,NPEAK,NPMAXW,RESULT,IPRMAX,IPRROW
     *  ,NSYM,ISYM,IPRSYM,IERR)
      ENDIF
      ENDIF

      NPMAX = NPMAXW

      deallocate(IPOOL,STAT=ISTAT)

      RETURN
      END

      SUBROUTINE RFRES_100_3D(MDOC,NAME1,NAME2,NAMEO
     * ,BETMIN,BETMAX,BETDEL
     * ,RF_MAX,LMAXR,LMINR,ISYM,IPRSYM,IERR)
C --------------------------------------------------------------------
C -P- RFRES : calculates Rotation Function map in Euler coordinate system.
C -S-
C             Rotation is 1.) alpha - about Z, 2) beta - about new Y
C                         3.) gamma - about new Z.
C           Solution RFRES corresponds to the rotation of RFROT,TRANS -programs
C           i.e.:   RFRES: (a,b,g) peak for file_1: model1 
C                                           file_2: model2
C             TRANS: model2 --> model1: angle: a,b,g
C             RFROT: model2 --> model1: angle: a,b,g 
C    Dialog and Batch:
C
C   FILE_1 - input ALMN_file /for self-rotation function use one file/
C   FILE_2 - input second ALMN_file for cross-rotation function
C   LIMITS <0,180,5> /grad/ - BETA-min,BETA-max,BETA-del')
C   FILE_O - output file / if you want it/, type of file is "RI  "  
C                          as DENS file, possible to use PRINTD to look result.
C
C      SUBROUTINE RFRES(MDOC,NAME1,NAME2,NAMEO,BETMIN,BETMAX,BETDEL
C     * ,POOL,MEMORY,ISYM,IPRSYM,IERR)
C
C   Parameters:
C
C  MDOC  - mode of writting messages to DOC-file
C          0 - only terminal , < - 0 only file, 0 < < 99 - both
C          >= 99 - don't write  
C  NAME1  - Input ALMN_file
C  NAME1  - input second ALMN_file for cross-rotation function
C  NAMEO  - name of file where you want to save result 
C  BETMIN - min and max section of Rotation function
C  BETMAX
C  BETDEL   delta = 0 means default values: <0,180,5> 
C  POOL   - real array(MEMORY) 
C  MEMORY
C  ISYM   - integer*2 array for cryst.symmetry operators.
C  IPRSYM - dimension of integer*2 array ISYM(5,3,IPRSYM),
C           number of cryst. symm. operators.
C  IERR   - signal of error / =1 -error , =o - OK / 
C -I-
C --------------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RLATT(6),RF_MAX(4)
      CHARACTER NAME1*(*),NAME2*(*),NAMEO*(*),TITLE*80,TYPE*4
c ----
      real*8,   allocatable :: DLMN8(:,:)
      complex,  allocatable :: CLMM(:)
      complex,  allocatable :: CLMM2(:)
      complex,  allocatable :: FMM(:,:)
      real*8,   allocatable :: FACT(:)
      real*8,   allocatable :: PCOT(:)
      real*8,   allocatable :: PSIN(:)
      real,     allocatable :: DLMM(:,:)
      real,     allocatable :: DLMMM(:)
      real,     allocatable :: AR(:,:)
      real,     allocatable :: AI(:,:)
      real,     allocatable :: BR(:,:)
      real,     allocatable :: BI(:,:)
      complex,  allocatable :: FOBS(:)
      integer,  allocatable :: IHH(:)
      integer,  allocatable :: IKK(:)
      integer,  allocatable :: ILL(:)
C -------------------------------------------------------------
      IERR=0
C ----------------
      MT1   = 10
      TYPE  = '    '
      MD    =-ABS(MDOC)-1
      CALL ORFILE(MD,MT1,NAME1,TYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERR: OPEN ALMN_FILE-1')
        RETURN
      ENDIF
      IF(TYPE.NE.'ALMN'.AND.TYPE.NE.'ALMS') THEN
        CALL MSGERR(MD,' ERR: OPEN ALMN_FILE-1: wrong file type')
        IERR = 1
        RETURN
      ENDIF
      CALL GET_TITLE(MD,RLATT(1),RLATT(2),
     . RLATT(3),RLATT(4),RLATT(5),RLATT(6),CF,BT,RN1,RX1,IDM,IDM
     . ,IDM,IDM,IDM,TITLE,IERR)
      CLOSE(MT1)
      READ(TITLE(16:20),'(I3,I2)') IPRLMX,LMAX_RFCOEF
      IF(IPRLMX.NE.30.AND.IPRLMX.NE.60.AND.IPRLMX.NE.100) THEN
C       30 or 60 or 100
        IERR=1
        CALL MSGERR(MD,' ERROR: RFCOEF: LMAX must be 30 or 60 or 100')
        RETURN
      ENDIF
C ----
      IF(LMINR.LT. 0) LMINR = 0
      IF(LMINR.GT.50) LMINR = 50

      IF(LMAXR.LT. 0) LMAXR = 0
      IF(LMAXR.GT.100) LMAXR = 100
      IF(LMAXR.LE.  0) LMAXR = 100
C ---
      BMAX  = 180.0
      CALL GET_TWOFOLD_PATT(NSYM,ISYM,ITWOX,ITWOY)
      IF(ITWOX.GT.0.OR.ITWOY.GT.0) BMAX=90.0
      IF(BETMAX.GT.180.0) BETMAX=180.
      BETDEL = ABS(BETDEL)
      IF(BETDEL.LT.1.E-7) THEN
        BETDEL = 3.0
        IF(ITWOX.GT.0.OR.ITWOY.GT.0) BETDEL=2.0      
        IF(LMAX_RFCOEF.GT.30) BETDEL=2.0      
      ENDIF
      IF(BETMAX.LT.1.E-7) THEN
        BETMAX = BMAX
      ENDIF
      IF(BETMIN.GT.180.)  BETMIN=180.0
C ----
      IPRLMX = 100
      IPRNMX=IPRLMX/2 
      IPRALM=100
      IPRGAM=IPRALM*2   
      IPRLM1=IPRLMX+1   
      IPRLM2=IPRLMX+2   
      IPRL21=IPRLMX*2+1 

      IPRL122=(IPRLMX+1)*(IPRGAM+1)*(IPRGAM+1)

      IND=2
      DO L=1,IPRLM2
        do m1=0,L
          do m2=-l,l
            IND=IND+1
          enddo
        enddo
      ENDDO
      IPRMEM = IND
  
      allocate(DLMN8(1:IPRLM1,1:IPRL21),STAT=ISTAT)
      allocate(CLMM(1:IPRMEM),STAT=ISTAT)
      allocate(CLMM2(1:IPRMEM),STAT=ISTAT)
      allocate(FMM(1:IPRALM,1:IPRGAM),STAT=ISTAT)
      allocate(FACT(1:IPRL21),STAT=ISTAT)
      allocate(PCOT(1:IPRL21),STAT=ISTAT)
      allocate(PSIN(1:IPRL21),STAT=ISTAT)
      allocate(DLMM(1:IPRLM1,1:IPRL21),STAT=ISTAT)
      allocate(DLMMM(1:IPRMEM),STAT=ISTAT)
      allocate(AR(1:IPRLM1,1:IPRNMX),STAT=ISTAT)
      allocate(AI(1:IPRLM1,1:IPRNMX),STAT=ISTAT)
      allocate(BR(1:IPRLM1,1:IPRNMX),STAT=ISTAT)
      allocate(BI(1:IPRLM1,1:IPRNMX),STAT=ISTAT)
      allocate(FOBS(1:IPRL122),STAT=ISTAT)
      allocate(IHH(1:IPRL122),STAT=ISTAT)
      allocate(IKK(1:IPRL122),STAT=ISTAT)
      allocate(ILL(1:IPRL122),STAT=ISTAT)

C       1        2        3       4        5         6     
C     DLMN8,   CLMM,    FMM,     FACT,    PCOT,    PSIN,
C     POOL(I1),POOL(I2),POOL(I3),POOL(I4),POOL(I5),POOL(I6)
C      7          8       9         10         11      12
C     DLMM,       AR,     AI,      BR,       BI,     
C     POOL(I7),POOL(I8),POOL(I9),POOL(I10),POOL(I11)

      CALL SRFRES_3D(MDOC,NAME1,NAME2,NAMEO,BETMIN,BETMAX,BETDEL
     *   ,DLMN8,CLMM,FMM,FACT,PCOT,PSIN
     *   ,DLMM,AR,AI,BR,BI,FOBS,IHH,IKK,ILL,CLMM2,DLMMM
     *   ,IPRLMX,IPRLM1,IPRL21,IPRMEM,IPRALM,IPRGAM,IPRNMX
     *   ,RF_MAX,LMAXR,LMINR,ISYM,IPRSYM,IERR)

      deallocate(DLMN8,STAT=ISTAT)
      deallocate(CLMM,STAT=ISTAT)
      deallocate(CLMM2,STAT=ISTAT)
      deallocate(FMM,STAT=ISTAT)
      deallocate(FACT,STAT=ISTAT)
      deallocate(PCOT,STAT=ISTAT)
      deallocate(PSIN,STAT=ISTAT)
      deallocate(DLMM,STAT=ISTAT)
      deallocate(DLMMM,STAT=ISTAT)
      deallocate(AR,STAT=ISTAT)
      deallocate(AI,STAT=ISTAT)
      deallocate(BR,STAT=ISTAT)
      deallocate(BI,STAT=ISTAT)
      deallocate(FOBS,STAT=ISTAT)
      deallocate(IHH,STAT=ISTAT)
      deallocate(IKK,STAT=ISTAT)
      deallocate(ILL,STAT=ISTAT)

      RETURN
      END

      SUBROUTINE SRFRES_3D(MDOC,NAME1,NAME2,NAMEO
     * ,BETMINR,BETMAXR,BETDELR
     * ,DLMN8,CLMM,FMM,FACT,PCOT,PSIN
     * ,DLMM,AR,AI,BR,BI,FOBS,IHH,IKK,ILL,CLMM2,DLMMM
     * ,IPRLMX,IPRLM1,IPRL21,IPRMEM,IPRALM,IPRGAM,IPRNMX
     * ,RF_MAX,LMAXR,LMINR,ISYM,IPRSYM,IERR)
C --------------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL*8    DLMN8(IPRLM1,IPRL21)
      REAL      DLMM (IPRLM1,IPRL21),DLMMM(*)
      REAL*8    FACT(IPRL21),PCOT(IPRL21),PSIN(IPRL21)
      COMPLEX   CLMM(IPRMEM),FMM(IPRALM,IPRGAM)
      COMPLEX   CLMM2(IPRMEM)

      COMPLEX   FOBS(*)
      INTEGER   IHH(*),IKK(*),ILL(*)

      COMPLEX   CA,CB,CA2,CB2
      REAL*8    ANG,DLCTB2,CTB2,DSANG,CCB,VS,dlca,dlsa
      REAL      AR(IPRLM1,IPRNMX),AI(IPRLM1,IPRNMX)
      REAL      BR(IPRLM1,IPRNMX),BI(IPRLM1,IPRNMX)
      REAL      CZL(512),SZL(512)

      INTEGER   ID(3)
      REAL      RLATT(6),RF_MAX(4)
      CHARACTER NAME1*(*),NAME2*(*),NAMEO*(*)
      CHARACTER TITLE1*80,TYPE*4,TYPE2*4,TITLE2*80
      CHARACTER MSG*1,MSGL*1,LINE*80
C -------------------------------------------------------------
      PI    = 4.0*ATAN(1.0)
      TWOPI = 2.0*PI
      MD     = -ABS(MDOC)-1
      IPRLM2 = IPRLMX+2   
      IERR   = 0
C ----------------
      MSGL = 'Y'

      NBASC = 0
      APT   = 0.0
      BPT   = 0.0

      BETMIN = BETMINR
      BETMAX = BETMAXR
      BETDEL = BETDELR
C ----------------
      MT1   = 10
      MT2   = 0
      TYPE  = '    '
      CALL ORFILE(MD,MT1,NAME1,TYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERR: OPEN ALMN_FILE-1.')
        RETURN
      ENDIF
      IF(TYPE.NE.'ALMN'.AND.TYPE.NE.'ALMS') THEN
        CALL MSGERR(MD,' ERR: OPEN ALMN_FILE-1: wrong file type')
        IERR = 1
        RETURN
      ENDIF
      CALL GET_TITLE(MD,RLATT(1),RLATT(2),
     . RLATT(3),RLATT(4),RLATT(5),RLATT(6),CF,BT,RN1,RX1,IDM,IDM
     . ,IDM,IDM,IDM,TITLE1,IERR)
      CALL C_RD_CR
C -----------------
      ARAD1 = CF
      NSYM1 = BT+.1
      IEND1 = -1
      NUMB1 = 0
      IF(TITLE1(5:8).EQ.' PT ') THEN
        LSTP=2
      ELSE
        LSTP=1
      ENDIF
      ILOLD=-111
      IF(TYPE.EQ.'ALMN') THEN
        CALL RD1(MT1,IN,IM,IL,FA,FB,NUMB1,IEND1)
        SFA = FA*0.04
        SFB = FB*0.04
      ELSE
        CALL RABCD(MT1,IN,IM,IL,FA,FB,SFA,SFB,NUMB1,IEND1)
      ENDIF
      IF(MT1.LE.0) THEN
        CALL MSGERR(MDOC,' ERR : READ ALMN_FILE-1')
        CLOSE(MT1)
        IERR=1
        RETURN
      ENDIF
      IF(IEND1.GT.0) THEN
        CALL MSGERR(MDOC,' ERR : EMPTY ALMN_FILE-1')
        IERR=1
        RETURN
      ENDIF
C -------------------------------------------------------------
      MSG = 'Y'
      CALL LENSTR_BL(NAME2,LEN)
      IF(LEN.GT.0.AND.NAME2(1:1).NE.','.AND.NAME2(1:1).NE.' ') THEN
        IERR  = 0
        MT2   = 11
        TYPE2 = '    '
        CALL ORFILE(MD,MT2,NAME2,TYPE2,NSM2,FMM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MD,' ERR: OPEN ALMN_FILE-2')
          CLOSE(MT1)
          RETURN
        ENDIF
        IF(TYPE2.NE.'ALMN'.AND.TYPE2.NE.'ALMS') THEN
          CALL MSGERR(MD,' ERR: OPEN ALMN_FILE-2: wrong file type')
          IERR = 1
          RETURN
        ENDIF
        MSG = 'N'
        CALL GET_TITLE(MD,RLATT(1),RLATT(2),
     .  RLATT(3),RLATT(4),RLATT(5),RLATT(6),CF,BT,RN2,RX2,IDM,IDM
     .  ,IDM,IDM,IDM,TITLE2,IERR)

        ARAD2 = CF
        IF(ARAD2.NE.ARAD1) THEN
          CALL MSGERR(MDOC,' ERR : RAD-1 # RAD-2')
          IERR=1
          CLOSE(MT1)
          CLOSE(MT2)
          RETURN
        ENDIF
        NSYM2 = BT+.1
        IEND2 = -1
        NUMB2 = 0
        JLOLD = -111
  510   IF(TYPE2.EQ.'ALMN') THEN
          CALL RD2(MT2,JN,JM,JL,GA,GB,NUMB2,IEND2)
          SGA = GA*0.04
          SGB = GB*0.04
        ELSE
          CALL RABCD1(MT2,JN,JM,JL,GA,GB,SGA,SGB,NUMB2,IEND2)
        ENDIF
        IF(MT2.LE.0) THEN
          CALL MSGERR(MDOC,' ERR : READ ALMN_FILE-2')
          CLOSE(MT1)
          CLOSE(MT2)
          IERR=1
          RETURN
        ENDIF
        IF(IEND2.GT.0) THEN
          CALL MSGERR(MDOC,' ERR : EMPTY ALMN_FILE-2')
          CLOSE(MT1)
          RETURN
        ENDIF
        IF(MSGL.EQ.'N'.AND.JL.EQ.0) GO TO 510
      ELSE
        BETMAX = 180.
      ENDIF
C -------------------------------------------------------------
      L_MAX = -1
      L_MIN = IPRLMX + 1
      IF(MSG.NE.'N') NSYM2=NSYM1
C =============================================================
  100 CONTINUE
      IF(IEND1.GT.0) GO TO 200
      IF(IL.NE.ILOLD.AND.ILOLD.NE.-111) THEN
        GO TO 200
      ENDIF
  110 L =IL
      IF(L.GT.IPRLMX.or.l.lt.0) THEN
        WRITE(LINE,*) ' ERR: L >',IPRLMX
        CALL MSGERR(MDOC,LINE)
        CLOSE(MT1)
        IF(MT2.GT.0) CLOSE(MT2)
        IERR=1
        RETURN
      ENDIF
      M =IM
      N =IN
      IF(m.lt.0) THEN
        WRITE(LINE,*) ' ERR: m < 0 '
         CALL MSGERR(MDOC,LINE)
        stop
      endif

      IF(N.GT.IPRNMX.or.n.le.0) THEN
        WRITE(LINE,*) ' ERR: N >',IPRNMX
        CALL MSGERR(MDOC,LINE)
        CLOSE(MT1)
        IF(MT2.GT.0) CLOSE(MT2)
        IERR=1
        RETURN
      ENDIF
      M1       = IM+1
      AR(M1,N) = FA
      AI(M1,N) = FB
      NMAX1    = N
      ILOLD    = IL
      IF(TYPE.EQ.'ALMN') THEN
        CALL RD1(MT1,IN,IM,IL,FA,FB,NUMB1,IEND1)
        SFA = FA*0.04
        SFB = FB*0.04
      ELSE
        CALL RABCD(MT1,IN,IM,IL,FA,FB,SFA,SFB,NUMB1,IEND1)
      ENDIF
      IF(MT1.LE.0) THEN
        CALL MSGERR(MDOC,' ERR : READ ALMN FILE-1')
        IF(MT2.GT.0) CLOSE(MT2)
        IERR=1
        RETURN
      ENDIF
      GO TO 100
C --------------
  200 IF(MSG.EQ.'N') THEN
        JLOLD=L
  300   CONTINUE
        IF(IEND2.GT.0 ) GO TO 400
        IF(JL.NE.JLOLD) THEN
          GO TO 400
        ENDIF
        IF(JL.NE.L) THEN
          WRITE(LINE,*) ' ERR: L - FILE-1 # L - FILE-2 :',L,JL
          CALL MSGERR(MDOC,LINE)
          IF(IEND1.EQ.0) CLOSE(MT1)
          CLOSE(MT2)
          IERR=1
          RETURN
        ENDIF
        M = JM
        N = JN
        IF(m.lt.0) THEN
          WRITE(LINE,*) ' ERR: m < 0 '
           CALL MSGERR(MDOC,LINE)
          stop
        endif

        IF(N.GT.IPRNMX.or.n.le.0) THEN
          WRITE(LINE,*) ' ERR: N >',IPRNMX
          CALL MSGERR(MDOC,LINE)
          IF(IEND1.EQ.0) CLOSE(MT1)
          CLOSE(MT2)
          IERR=1
          RETURN
        ENDIF
        M1       = JM+1
        BR(M1,N) = GA
        BI(M1,N) = GB
        NMAX2    = N
        JLOLD    = JL
        IF(TYPE2.EQ.'ALMN') THEN
          CALL RD2(MT2,JN,JM,JL,GA,GB,NUMB2,IEND2)
          SGA = GA*0.04
          SGB = GB*0.04
        ELSE
          CALL RABCD1(MT2,JN,JM,JL,GA,GB,SGA,SGB,NUMB2,IEND2)
        ENDIF
        IF(MT2.LE.0) THEN
          CALL MSGERR(MDOC,' ERR : READ ALMN FILE-2')
          IF(IEND1.EQ.0) CLOSE(MT1)
          IERR=1
          RETURN
        ENDIF
        GO TO 300
      ENDIF
C --------------------------------------------
  400 CONTINUE
      IF(NMAX1.NE.NMAX2.AND.MSG.EQ.'N') THEN
        WRITE(LINE,*) 
     *  ' ERR: NMAX1 # NMAX2 ;L,NMAX1,NMAX2:',L,NMAX1,NMAX2
        CALL MSGERR(MDOC,LINE)
        IF(IEND1.EQ.0.AND.MT1.GT.0) CLOSE(MT1)
        IF(IEND2.EQ.0.AND.MT2.GT.0) CLOSE(MT2)
        IERR=1
        RETURN
      ENDIF
      LK      = L+1
      NN      = NMAX1

      LS1     = L/NSYM2+1
      L1      = L/NSYM1+1
      L21     = 2*(L/NSYM2)+1
      LMBLOK  = L1*L21
      DO     M1=1,L1
c       m+1 
        MA=NSYM1*(M1-1)+1
        DO     MDASH1=1,L21
c         !m'!+1
          MB   = IABS((MDASH1-LS1)*NSYM2)+1
          ISGN = MOD((MB-1),2)
          INDC = NBASC+(M1-1)*L21+MDASH1
          IF(INDC.GT.IPRMEM.or.INDC.le.0) THEN
            WRITE(LINE,*) ' ERR: ARRAY CLMM : INDEX >',IPRMEM
            CALL MSGERR(MDOC,LINE)
            IF(IEND1.EQ.0.AND.MT1.GT.0) CLOSE(MT1)
            IF(IEND2.EQ.0.AND.MT2.GT.0) CLOSE(MT2)
            IERR=1
            RETURN
          ENDIF
          IF(L.GE.LMINR.AND.L.LE.LMAXR) THEN
            IF(L.LE.L_MIN) L_MIN=L      
            IF(L.GE.L_MAX) L_MAX=L      
            CLMM(INDC) = CMPLX(APT,BPT)
c            CLMM2(INDC)= CMPLX(APT,BPT)
          ELSE
            CLMM(INDC)  = 0.0
c            CLMM2(INDC) = 0.0
          ENDIF
          DO     KN=1,NN
            CA  = CMPLX(AR(MA,KN),-AI(MA,KN))
c            CA2 = CMPLX(AR(MA,KN),-AI(MA,KN))
c            CB2 = CMPLX(AR(MB,KN),AI(MB,KN))
            IF(MSG.NE.'N') THEN
              CB=CMPLX(AR(MB,KN),AI(MB,KN))
            ELSE
              CB=CMPLX(BR(MB,KN),BI(MB,KN))
            ENDIF
            IF((MDASH1-LS1).LT.0) THEN
              CB=CONJG(CB)
              IF(ISGN.EQ.1) CB=-CB
c              CB2=CONJG(CB2)
c              IF(ISGN.EQ.1) CB2=-CB2
            ENDIF
            IF(L.GE.LMINR.AND.L.LE.LMAXR) THEN
              CLMM(INDC)  = CLMM(INDC)  + CA*CB
c              CLMM2(INDC) = CLMM2(INDC) + CA2*CB2
            ELSE
              CLMM(INDC)  = 0.0
c              CLMM2(INDC) = 0.0
            ENDIF

          ENDDO
        ENDDO
      ENDDO
      NBASC=NBASC+LMBLOK

      IF(IEND1.NE.IEND2.AND.MSG.EQ.'N') THEN
        WRITE(LINE,*) ' ERR: EOF FILE-1 OR FILE-2 :',IEND1,IEND2
        CALL MSGERR(MDOC,LINE)
        IF(IEND1.EQ.0.AND.MT1.GT.0) CLOSE(MT1)
        IF(IEND2.EQ.0.AND.MT2.GT.0) CLOSE(MT2)
        IERR=1
        RETURN
      ENDIF

      IF(IEND1.EQ.0) GO TO 110
C =================================================================
      IF(MT1.GT.0) CLOSE(MT1)
      IF(MT2.GT.0) CLOSE(MT2)
      LMAX   = L
      LMAX1  = LMAX+1
      LMAX2  = LMAX*2
      LMAX21 = LMAX*2+1
      IF(LMAX21.GE.IPRGAM) THEN
        WRITE(LINE,*) ' ERR: LMAX*2+1 >',IPRGAM
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF
C ------------------------------------------
      APT = 0.
      BPT = 0.
C -------------------------------------------
      BETA = 90.0
      FACT(1)=0.
      DO     L=1,LMAX2
        FACT(L+1) = FACT(L)+LOG(DFLOAT(L))
      ENDDO
      ANG = (BETA*3.1415926)/180.0
      CCB = COS(ANG)
      VS = -LOG(.5D0*SIN(ANG))
      KS = VS
      VS = MOD(VS,1D0)
      IF (VS.GT.0D0) THEN
        KS = KS+1
        VS = VS-1
      ENDIF
      VS = EXP(VS)
C
      ANG = .5D0*ANG
      DLCA = LOG(COS(ANG))
      DLSA = LOG(SIN(ANG))
      PCOT(1) = 0D0
      PSIN(1) = 0D0
      DO L = 1,LMAX2
        PCOT(L+1) = PCOT(L)+DLCA
        PSIN(L+1) = PSIN(L)+DLSA
      ENDDO
      IND2=2
      DO L=1,LMAX
        IF(MOD(L,LSTP).EQ.0) THEN
          L1  = L/NSYM1+1
          LS1 = L/NSYM2+1
          L21 = 2*(L/NSYM2)+1
          LMBLOK  = L1*L21
          CALL DLMMs(BETA,L,CCB,KS,VS,FACT,PCOT,PSIN
     *                 ,DLMM,DLMN8,DLMM,IPRL21,IPRLM1)
          DO M1=0,L
            DO M2=-l,l
              MM1 = M1 + 1
              MM2 = M2 + L + 1
              DLMMM(IND2) = dlmm(mm1,mm2)
              IND2=IND2+1
            ENDDO
          ENDDO
        ENDIF
      ENDDO

      MT =-1
      NUMBF = 0
      DO  ll=-LMAX,LMAX
C -------------------
        IPRGAM2=IPRGAM
        DO     I=1,IPRALM
        DO     J=1,IPRGAM
          FMM(I,J) =CMPLX(APT,BPT)
c          FMM2(I,J)=CMPLX(APT,BPT)
        ENDDO
        ENDDO
C -------------------
        lla  = IABS(ll)
        ll1  = IABS(ll)+1
        IND=2
        IND2=2
        DO L=1,LMAX
          IF(MOD(L,LSTP).EQ.0) THEN
            L1 =L/NSYM1+1
            LS1=L/NSYM2+1
            L21=2*(L/NSYM2)+1
            do m1=0,L
              do m2=-l,l
                MM1 = M1 + 1
                MM2 = M2 + L + 1
                dlmm(mm1,mm2) =  DLMMM(IND2) 
                IND2=IND2+1
              enddo
            enddo

            do m111=1,L1
              do m222=1,L21
                m1   = (m111-1)*NSYM1
                md11 = (m111-1)+1
                m11  = m1
                mm1  = m1+1
                mmm1 = m1+l+1
                if(lla.le.l) THEN
                  m2  = (m222-LS1)*NSYM2
                  m22 = m2
                  md1 = (m222-LS1) + 1
                  mm2 = m22+l+1
                  mmm2= m22+l+1
                  ISGN1 = 0
                  ISGN2 = 0
                  IF(ll.LT.0) THEN
                    MM = ll + m1
                    ISGN1 = MOD(MM,2)
                    m11 =-m11
                    mmm1=m11+1+L
                    MM = ll + m2
                    ISGN2 = MOD(MM,2)
                    m22 =-m22
                    mmm2=m22+1+L
                  ENDIF
                  d1=dlmm(ll1,mmm1)
                  if(ISGN1.ne.0) d1=-d1                 
                  d2=dlmm(ll1,mmm2)
                  if(ISGN2.ne.0) d2=-d2
                  d12 = d1*d2
                  a = d12
                  b = 0.0
                  t1 = a
                  t2 = b
                  mm = m1 - m2
                  imm = iabs(mm)
                  ISGN2 = MOD(iMM,2)
                  ISGN4 = MOD(iMM,4)
                  if(isgn4.eq.1) then
                    t1=-b
                    t2=a
                  else if(isgn4.eq.3) then
                    t1=b
                    t2=-a              
                  else if(isgn4.eq.2) then
                    t1=-a
                    t2=-b              
                  endif
                  if(mm.lt.0.and.isgn2.ne.0) then
                    t1=-t1
                    t2=-t2             
                  endif
                  cb =  CMPLX(t1,t2)
                  IF(MD1.LE.0)  MD1=IPRGAM2+MD1

                  fmm(md11,md1)  = fmm(md11,md1)  + cb* CLMM(IND)

                endif
                IND=IND+1
              enddo
            enddo
          ENDIF
        ENDDO

        L1 =LMAX/NSYM1+1
        L21=2*(LMAX/NSYM2)+1
        LS1=LMAX/NSYM2+1

        DO  II=1,L1
          I  = II-1
          I1 = I+1
          DO  JJ=1,L21
            J = (JJ-LS1) 
            J1 = J+1
            IF(J1.LE.0) J1=IPRGAM2+J1
            NUMBF = NUMBF + 1
c                         *NSYM1
            IHH(NUMBF) = I
            IKK(NUMBF) = J
            ILL(NUMBF) = ll   
            CA  = FMM(I1,J1)
c            CA2 = FMM2(I1,J1)
c            CB2=CONJG(CA2)
            FOBS(NUMBF)= CA
          ENDDO
        ENDDO
        
      ENDDO
C -------------------
      MT =-1
      RF_MAX(1) = 0.0
      RF_MAX(2) = 0.0
      RF_MAX(3) = 0.0
      RF_MAX(4) =-1.0E30 
      NBETA=0
      IF(BETMAX.LT.BETMIN) THEN
        STOR   = BETMAX
        BETMAX = BETMIN
        BETMIN = STOR
      ENDIF
      IF(BETMAX.GT.180.0) BETMAX = 180.
      BETDEL = ABS(BETDEL)
      IF(BETDEL.LT.1.E-7) BETDEL = 5.0
      IF(BETMAX.LT.1.E-7) THEN
        BETMAX = 180.0
      ENDIF
      IF(BETMIN.GT.180.)  BETMIN=180.0
      WRITE(LINE,'('' BETA MIN,MAX,DELTA:'',3F8.2)')
     .                   BETMIN,BETMAX,BETDEL
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' L-MAX,LMIN :'',2I5)')
     .                   L_MAX,L_MIN
      CALL MSGDOC(MDOC,LINE)
      APT = 0.
      BPT = 0.
      NNB = (BETMAX-BETMIN)/BETDEL+1.1
      CALL MSGDOC(MDOC,' ')
      MT =-1
      BMAX = 360.0
      DO  NB=1,NNB
        BETA = BETMIN+BETDEL*(NB-1)
        Z = BETA/BMAX
        ANG    = TWOPI*Z
        CSZ    = COS(ANG)
        SNZ    = SIN(ANG)
        CZL(1) = 1.0
        SZL(1) = 0.0
        DO  I=2,512
          CZL(I) = CZL(I-1)*CSZ-SZL(I-1)*SNZ
          SZL(I) = SZL(I-1)*CSZ+CZL(I-1)*SNZ
        ENDDO

        DO     I=1,IPRALM
        DO     J=1,IPRGAM
          FMM(I,J)=CMPLX(APT,BPT)
        ENDDO
        ENDDO
c
        DO IMMM=1,NUMBF
          JH = IHH(IMMM)
          JK = IKK(IMMM)
          JL = ILL(IMMM)
          FAA = REAL(FOBS(IMMM))
          FBB = AIMAG(FOBS(IMMM))
          JH1 = JH+1
          JK1 = JK+1
          IF(JK1.LE.0) JK1=IPRGAM2+JK1
          ILD = IABS(JL)+1
          PC = CZL(ILD)
          PS = SZL(ILD)
          IF(JL.LT.0 ) PS = -PS
          A  = FAA * PC + FBB * PS
          B  = FBB * PC - FAA * PS
          FMM(JH1,JK1) = FMM(JH1,JK1) + CMPLX(A,B)
        ENDDO

        ID(1)=IPRALM
        ID(2)=IPRGAM
        ID(3)=0
        CALL MDHFT(FMM,ID,IERR)
        IF(IERR.NE.0) THEN
          WRITE(LINE,*) ' ERR: ERROR IN MDHFT'
          CALL MSGERR(MDOC,LINE)
          IF(MT.GT.0) CLOSE(MT)
          IERR=1
          RETURN
        ENDIF
C -------------------
        CALL RFOUT(MDOC,MT,NAMEO,FMM
     *  ,BETA,BETMIN,BETMAX,BETDEL
     *  ,RF_MAX,NSYM1,NSYM2,MSG,TITLE1,TITLE2,ARAD1,RN1,RX1,IPRGAM
     *  ,IPRGAM2,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.GT.0) RETURN
        NBETA=NBETA+1
      ENDDO
C ---
c        RF_MAX(1) alpha /grad/
c        RF_MAX(2) beta
c        RF_MAX(3) gamma
c        RF_MAX(4) RF 

      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.LE.0.OR.NAMEO(1:1).EQ.','.OR.NAMEO(1:1).EQ.' ')THEN
        RFMAX = RF_MAX(2) 
        BETA    = RFMAX 
        BETMIN  = BETA - BETDEL  
        BETMAX  = BETA + BETDEL 
        BETDEL4 = BETDEL/4 
        RF_MAX(1) = 0.0
        RF_MAX(2) = 0.0
        RF_MAX(3) = 0.0
        RF_MAX(4) =-1.0E30 
        NBETA=0
        IF(BETMIN.LT.  0.0) BETMIN = 0.0
        IF(BETMAX.GT.180.0) BETMAX = 180.0
        WRITE(LINE,'('' BETA MIN,MAX,DELTA:'',3F8.2)')
     .                   BETMIN,BETMAX,BETDEL4
        CALL MSGDOC(MDOC,LINE)
        NNB = (BETMAX-BETMIN)/BETDEL4+1.1

        MT =-1
        BMAX = 360.0
        DO  NB=1,NNB
          BETA = BETMIN+BETDEL4*(NB-1)
          BMAX = 360.0
          Z = BETA/BMAX
          ANG    = TWOPI*Z
          CSZ    = COS(ANG)
          SNZ    = SIN(ANG)
          CZL(1) = 1.0
          SZL(1) = 0.0
          DO  I=2,512
            CZL(I) = CZL(I-1)*CSZ-SZL(I-1)*SNZ
            SZL(I) = SZL(I-1)*CSZ+CZL(I-1)*SNZ
          ENDDO

          DO     I=1,IPRALM
          DO     J=1,IPRGAM
            FMM(I,J)=CMPLX(APT,BPT)
          ENDDO
          ENDDO
c
          DO IMMM=1,NUMBF
            JH = IHH(IMMM)
            JK = IKK(IMMM)
            JL = ILL(IMMM)
            FAA = REAL(FOBS(IMMM))
            FBB = AIMAG(FOBS(IMMM))
            JH1 = JH+1
            JK1 = JK+1
            IF(JK1.LE.0) JK1=IPRGAM2+JK1
            ILD = IABS(JL)+1
            PC = CZL(ILD)
            PS = SZL(ILD)
            IF(JL.LT.0 ) PS = -PS
            A  = FAA * PC + FBB * PS
            B  = FBB * PC - FAA * PS
            FMM(JH1,JK1) = FMM(JH1,JK1) + CMPLX(A,B)
          ENDDO

          ID(1)=IPRALM
          ID(2)=IPRGAM
          ID(3)=0
          CALL MDHFT(FMM,ID,IERR)
          IF(IERR.NE.0) THEN
            WRITE(LINE,*) ' ERR: ERROR IN MDHFT'
            CALL MSGERR(MDOC,LINE)
            IF(MT.GT.0) CLOSE(MT)
            IERR=1
            RETURN
          ENDIF
C -------------------
          CALL RFOUT(MDOC,MT,NAMEO,FMM
     *    ,BETA,BETMIN,BETMAX,BETDEL4
     *    ,RF_MAX,NSYM1,NSYM2,MSG,TITLE1,TITLE2,ARAD1,RN1,RX1,IPRGAM
     *    ,IPRGAM2,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.GT.0) RETURN
          NBETA=NBETA+1
        ENDDO
      ENDIF
C ---
      RETURN
      END
