C ******
C -P-
C -P------   SUBROUTINES DEPENDED ON SYSTEM --------------------
C -P-
C      CVX - for VMS VAX 
C      CDP - for unix system
C      CMS - for MS-DOS
C      CLN - for Linux 
C ******

C ******
      SUBROUTINE DISPL_BL(LINE)
C
C -P- DISPL_BL - write message to terminal and stop cursor at the end of line.
C
C             NOTE : for Linux ( CLN ) cursor will not stop
C                    at the end of line.
C
      CHARACTER LINE*(*)
      INTEGER*4 NL
C ----------------------------
      CALL LENSTR_BL(LINE,NL)
      IF(NL.GT.79) NL=79

CVX   WRITE(*,'(''$'',A)')   LINE(1:NL)
      WRITE(*,'('' '',A,$)') LINE(1:NL)
CMS   WRITE(*,'('' '',A,\)') LINE(1:NL)
CLN   WRITE(*,'('' '',A)')   LINE(1:NL)
      RETURN
      END
C ******

C ******
      SUBROUTINE CLOCK(IH)
C
C -P- CLOCK - get date to --> array IH()
C
C    IH(2),IH(3),IH(4),    IH(5),IH(6),IH(7)
C     sec   min  hour      day   month year
C
      INTEGER*4 IH(7)
C ******
      CHARACTER  cdate*8,ctime*10,czone*5
      INTEGER    ivalues(8)
CMS   INTEGER*2 IHR,IMN,ISEC,I100H,IYR,IMON,IDAY
CVX   CHARACTER STR*8
      INTEGER*4 ID(3)
CLN   INTEGER*4 ID(3)
c --------------------------------
CVX   CALL IDATE(I1,I2,I3)
CVX   IH(5)=I2
CVX   IH(6)=I1
CVX   IT1  =I3+1900
CVX   IH(7)=IT
CVX   CALL TIME(STR)
CVX   READ(STR,'(I2,1X,I2,1X,I2)') IH(4),IH(3),IH(2)
CVX   IH(1)=0
C
CMS   CALL GETTIM(IHR,IMN,ISEC,I100H)
CMS   CALL GETDAT(IYR,IMON,IDAY)
CMS   IH(4)=IHR
CMS   IH(3)=IMN
CMS   IH(2)=ISEC
CMS   IH(5)=IDAY
CMS   IH(6)=IMON
CMS   IH(7)=IYR
CMS   IH(1)=I100H/2

CDP
      ID(1) = 0
      ID(2) = 0
      ID(3) = 0
c     CALL ITIME(ID)
      IH(4)=ID(1)
      IH(3)=ID(2)
      IH(2)=ID(3)
      IDAY = 1
      IMON = 1
      IYR  = 0
cccc    CALL IDATE(IMON,IDAY,IYR)
      IF(IYR.GE.99) THEN
        IYR=IYR+1900
      ELSE
        IYR=IYR+2000
      ENDIF
      IH(5)=IDAY
      IH(6)=IMON
      IH(7)=IYR
      IH(1)=0
CDP 
c ===============================================
      CALL Date_and_Time(CDATE,CTIME,CZONE,IVALUES)
      IH(4)=IVALUES(5)
      IH(3)=IVALUES(6)
      IH(2)=IVALUES(7)
      IH(5)=IVALUES(3)
      IH(6)=IVALUES(2)
      IH(7)=IVALUES(1)
      IH(1)=0
c ================================================

C
C  Dummy routine for Linux
C
CLN   IH(4)=0
CLN   IH(3)=0
CLN   IH(2)=0
CLN   IH(5)=01
CLN   IH(6)=01
CLN   IH(7)=1990
CLN   IH(1)=0

      RETURN
      END

C ===============================================================

      SUBROUTINE GETNOS(CH3)
C
C -P- GETNOS - get name of operating system
C
      CHARACTER CH3*3
C --------------------------------
CMS   CH3='MSD'      
CVX   CH3='VAX'      
      CH3='UNX'      
CLN   CH3='LIN'      
      RETURN
      END

CMS   SUBROUTINE EXIT
CMS   STOP
CMS   END


C ******
      SUBROUTINE OPENFR(IN,MDOC,PATH,FNAME,EXT,IERR)
C
C -P- OPENFR - open formatted file for read /with extention and path/
C
C       input:
C               IN    - unit
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       >= 99 - not write  
C               PATH  - path      / may be = '    ' /
C               FNAME - file name
C               EXT   - extention / may be = '    ' /
C
C        output:
C               IERR = 0 - OK
C                    > 0 - error.
C
      INTEGER*4 IN,MDOC,IERR
      CHARACTER PATH*(*),FNAME*(*),EXT*(*)
C ******
      INTEGER*4 NLE,NLN,NLP,NL
      CHARACTER FILE*256,FILE1*256,LINE*256
      CHARACTER CH1*1,TYPE*1
C -------------------------------------------------------------
      IERR=0

      CALL LENSTR_BL(EXT,NLE)
      CALL LENSTR_BL(PATH,NLP)
      CALL LENSTR_BL(FNAME,NLN)

      CH1=FNAME(1:1)
      CALL CHKSMB(CH1,TYPE)
      IF(TYPE.EQ.'?'.OR.CH1.EQ.' '.OR.CH1.EQ.',') THEN
        FNAME(1:1)=' '
      ENDIF

      IF(NLN.GT.1) THEN
        DO I=2,NLN
          IF(FNAME(I:I).EQ.',') FNAME(I:I)=' '
        ENDDO
      ENDIF
      IF(NLP.GT.1) THEN
        DO I=2,NLP
          IF(PATH(I:I).EQ.',') PATH(I:I)=' '
        ENDDO
      ENDIF
      IF(NLE.GT.1) THEN
        DO I=2,NLE
          IF(EXT(I:I).EQ.',') EXT(I:I)=' '
        ENDDO
      ENDIF

      CALL LENSTR_BL(EXT,NLE)
      CALL LENSTR_BL(PATH,NLP)
      CALL LENSTR_BL(FNAME,NLN)
   


      IF(FNAME(1:1).EQ.' '.OR.NLN.LE.0) GO TO 9100

      IF(NLE.GT.0) THEN
        FILE1=FNAME(1:NLN)//'.'//EXT(1:NLE)
      ELSE
        FILE1=FNAME(1:NLN)
      ENDIF     
      CALL LENSTR_BL(FILE1,NL)
      IF(NLP.GT.0) THEN
        FILE=PATH(1:NLP)//FILE1(1:NL)
      ELSE
        FILE=FILE1(1:NL)
      ENDIF     
      CALL LENSTR_BL(FILE,NL)

      OPEN(IN,FILE=FILE(1:NL),ACCESS='SEQUENTIAL',ERR=9100,
     *  FORM='FORMATTED',STATUS='OLD')

      IF(NL.GT.65) NL=65
      WRITE(LINE,10) FILE(1:NL)
 10   FORMAT(' INPUT FILE :',A,';')
      CALL MSGDOC(MDOC,LINE)
      RETURN
C ----
9100  CONTINUE
      IF(NLE.GT.65) NLE=65
      IF(NLP.GT.65) NLP=65
      IF(NLN.GT.65) NLN=65
      CALL MSGERR(MDOC,' ERR: OPEN FILE /FOR READ/ ')
      IF(NLP.GT.0) THEN
        WRITE(LINE,20) PATH(1:NLP)
 20     FORMAT('        PATH :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IF(NLN.GT.0) THEN
        WRITE(LINE,30) FNAME(1:NLN)
 30     FORMAT('        NAME :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IF(NLE.GT.0) THEN
        WRITE(LINE,40) EXT(1:NLE)
 40     FORMAT('   EXTENTION :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IERR=1
      RETURN
      END

C ******
      SUBROUTINE OPENUR(IN,MDOC,PATH,FNAME,EXT,IERR)
C
C -P- OPENUR - open unformatted file for read /with extentiom and path/
C
C       input:
C               IN    - unit
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       >= 99 - not write  
C               PATH  - path      / may be = '    ' /
C               FNAME - file name
C               EXT   - extention / may be = '    ' /
C
C        output:
C               IERR = 0 - OK
C                    > 0 - error.
C
      INTEGER*4 IN,MDOC,IERR
      CHARACTER PATH*(*),FNAME*(*),EXT*(*)
C ******
      INTEGER*4 NLE,NLN,NLP,NL
      CHARACTER FILE*256,FILE1*256,LINE*256
      CHARACTER CH1*1,TYPE*1
C -------------------------------------------------------------
      IERR=0

      CALL LENSTR_BL(EXT,NLE)
      CALL LENSTR_BL(PATH,NLP)
      CALL LENSTR_BL(FNAME,NLN)

      CH1=FNAME(1:1)
      CALL CHKSMB(CH1,TYPE)
      IF(TYPE.EQ.'?'.OR.CH1.EQ.' '.OR.CH1.EQ.',') THEN
        FNAME(1:1)=' '
      ENDIF


      IF(NLN.GT.1) THEN
        DO I=2,NLN
          IF(FNAME(I:I).EQ.',') FNAME(I:I)=' '
        ENDDO
      ENDIF
      IF(NLP.GT.1) THEN
        DO I=2,NLP
          IF(PATH(I:I).EQ.',') PATH(I:I)=' '
        ENDDO
      ENDIF
      IF(NLE.GT.1) THEN
        DO I=2,NLE
          IF(EXT(I:I).EQ.',') EXT(I:I)=' '
        ENDDO
      ENDIF

      CALL LENSTR_BL(EXT,NLE)
      CALL LENSTR_BL(PATH,NLP)
      CALL LENSTR_BL(FNAME,NLN)
   

      IF(FNAME(1:1).EQ.' '.OR.NLN.LE.0) GO TO 9100

      IF(NLE.GT.0) THEN
        FILE1=FNAME(1:NLN)//'.'//EXT(1:NLE)
      ELSE
        FILE1=FNAME(1:NLN)
      ENDIF     
      CALL LENSTR_BL(FILE1,NL)
      IF(NLP.GT.0) THEN
        FILE=PATH(1:NLP)//FILE1(1:NL)
      ELSE
        FILE=FILE1(1:NL)
      ENDIF     
      CALL LENSTR_BL(FILE,NL)

      OPEN(IN,FILE=FILE(1:NL),ACCESS='SEQUENTIAL',ERR=9100,
     *  FORM='UNFORMATTED',STATUS='OLD')

      IF(NL.GT.65) NL=65
      WRITE(LINE,10) FILE(1:NL)
 10   FORMAT(' INPUT FILE :',A,';')
      CALL MSGDOC(MDOC,LINE)
      RETURN
C ----
9100  CONTINUE
      IF(NLE.GT.65) NLE=65
      IF(NLP.GT.65) NLP=65
      IF(NLN.GT.65) NLN=65
      CALL MSGERR(MDOC,' ERR: OPEN FILE /FOR READ/ ')
      IF(NLP.GT.0) THEN
        WRITE(LINE,20) PATH(1:NLP)
 20     FORMAT('        PATH :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IF(NLN.GT.0) THEN
        WRITE(LINE,30) FNAME(1:NLN)
 30     FORMAT('        NAME :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IF(NLE.GT.0) THEN
        WRITE(LINE,40) EXT(1:NLE)
 40     FORMAT('   EXTENTION :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IERR=1
      RETURN
      END

C ******
      SUBROUTINE OPENFW(IOUT,MDOC,PATH,FNAME,EXT,IERR)
C
C -P- OPENFW - open formatted file for write /with extentiom and path/
C
C       input:
C               IOUT   - unit
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       >= 99 - not write  
C               PATH  - path      / may be = '    ' /
C                       ( example of PATH='blanc/temp/' )
C               FNAME - file name
C               EXT   - extention / may be = '    ' /
C
C        output:
C               IERR = 0 - OK
C                    > 0 - error.
C
      INTEGER*4 IOUT,MDOC,IERR
      CHARACTER PATH*(*),FNAME*(*),EXT*(*)
C ******
      INTEGER*4 NLE,NLN,NLP,NL
      CHARACTER FILE*256,FILE1*256,LINE*256
      CHARACTER CH1*1,TYPE*1
C -------------------------------------------------------------
      IERR=0

      CALL LENSTR_BL(EXT,NLE)
      CALL LENSTR_BL(PATH,NLP)
      CALL LENSTR_BL(FNAME,NLN)

      CH1=FNAME(1:1)
      CALL CHKSMB(CH1,TYPE)
      IF(TYPE.EQ.'?'.OR.CH1.EQ.' '.OR.CH1.EQ.',') THEN
        FNAME(1:1)=' '
      ENDIF


      IF(NLN.GT.1) THEN
        DO I=2,NLN
          IF(FNAME(I:I).EQ.',') FNAME(I:I)=' '
        ENDDO
      ENDIF
      IF(NLP.GT.1) THEN
        DO I=2,NLP
          IF(PATH(I:I).EQ.',') PATH(I:I)=' '
        ENDDO
      ENDIF
      IF(NLE.GT.1) THEN
        DO I=2,NLE
          IF(EXT(I:I).EQ.',') EXT(I:I)=' '
        ENDDO
      ENDIF

      CALL LENSTR_BL(EXT,NLE)
      CALL LENSTR_BL(PATH,NLP)
      CALL LENSTR_BL(FNAME,NLN)

      IF(FNAME(1:1).EQ.' '.OR.NLN.LE.0) GO TO 9100

      IF(NLE.GT.0) THEN
        FILE1=FNAME(1:NLN)//'.'//EXT(1:NLE)
      ELSE
        FILE1=FNAME(1:NLN)
      ENDIF     
      CALL LENSTR_BL(FILE1,NL)
      IF(NLP.GT.0) THEN
        FILE=PATH(1:NLP)//FILE1(1:NL)
      ELSE
        FILE=FILE1(1:NL)
      ENDIF     
      CALL LENSTR_BL(FILE,NL)

      OPEN(IOUT,FILE=FILE(1:NL),ACCESS='SEQUENTIAL',ERR=9100,
     *  FORM='FORMATTED',STATUS='UNKNOWN')

      IF(NL.GT.65) NL=65
      WRITE(LINE,10) FILE(1:NL)
 10   FORMAT(' OUTPUT FILE :',A,';')
      CALL MSGDOC(MDOC,LINE)
      RETURN
C ----
9100  CONTINUE
      IF(NLE.GT.65) NLE=65
      IF(NLP.GT.65) NLP=65
      IF(NLN.GT.65) NLN=65
      CALL MSGERR(MDOC,' ERR: OPEN FILE /FOR WRITE/ ')
      IF(NLP.GT.0) THEN
        WRITE(LINE,20) PATH(1:NLP)
 20     FORMAT('        PATH :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IF(NLN.GT.0) THEN
        WRITE(LINE,30) FNAME(1:NLN)
 30     FORMAT('        NAME :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IF(NLE.GT.0) THEN
        WRITE(LINE,40) EXT(1:NLE)
 40     FORMAT('   EXTENTION :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IERR=1
      RETURN
      END

C ******
      SUBROUTINE OPENUW(IOUT,MDOC,PATH,FNAME,EXT,IERR)
C
C -P- OPENFW - open unformatted file for write /with extentiom and path/
C
C       input:
C               IN    - unit
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       >= 99 - not write  
C               PATH  - path      / may be = '    ' /
C               FNAME - file name
C               EXT   - extention / may be = '    ' /
C
C        output:
C               IERR = 0 - OK
C                    > 0 - error.
C
      INTEGER*4 IOUT,MDOC,IERR
      CHARACTER PATH*(*),FNAME*(*),EXT*(*)
C ******
      INTEGER*4 NLE,NLN,NLP,NL
      CHARACTER FILE*256,FILE1*256,LINE*256
      CHARACTER CH1*1,TYPE*1
C -------------------------------------------------------------
      IERR=0

      CALL LENSTR_BL(EXT,NLE)
      CALL LENSTR_BL(PATH,NLP)
      CALL LENSTR_BL(FNAME,NLN)

      CH1=FNAME(1:1)
      CALL CHKSMB(CH1,TYPE)
      IF(TYPE.EQ.'?'.OR.CH1.EQ.' '.OR.CH1.EQ.',') THEN
        FNAME(1:1)=' '
      ENDIF


      IF(NLN.GT.1) THEN
        DO I=2,NLN
          IF(FNAME(I:I).EQ.',') FNAME(I:I)=' '
        ENDDO
      ENDIF
      IF(NLP.GT.1) THEN
        DO I=2,NLP
          IF(PATH(I:I).EQ.',') PATH(I:I)=' '
        ENDDO
      ENDIF
      IF(NLE.GT.1) THEN
        DO I=2,NLE
          IF(EXT(I:I).EQ.',') EXT(I:I)=' '
        ENDDO
      ENDIF

      CALL LENSTR_BL(EXT,NLE)
      CALL LENSTR_BL(PATH,NLP)
      CALL LENSTR_BL(FNAME,NLN)

      IF(FNAME(1:1).EQ.' '.OR.NLN.LE.0) GO TO 9100

      IF(NLE.GT.0) THEN
        FILE1=FNAME(1:NLN)//'.'//EXT(1:NLE)
      ELSE
        FILE1=FNAME(1:NLN)
      ENDIF     
      CALL LENSTR_BL(FILE1,NL)
      IF(NLP.GT.0) THEN
        FILE=PATH(1:NLP)//FILE1(1:NL)
      ELSE
        FILE=FILE1(1:NL)
      ENDIF     
      CALL LENSTR_BL(FILE,NL)

      OPEN(IOUT,FILE=FILE(1:NL),ACCESS='SEQUENTIAL',ERR=9100,
     *  FORM='UNFORMATTED',STATUS='UNKNOWN')

      IF(NL.GT.65) NL=65
      WRITE(LINE,10) FILE(1:NL)
 10   FORMAT(' OUTPUT FILE :',A,';')
      CALL MSGDOC(MDOC,LINE)
      RETURN
C ----
9100  CONTINUE
      IF(NLE.GT.65) NLE=65
      IF(NLP.GT.65) NLP=65
      IF(NLN.GT.65) NLN=65
      CALL MSGERR(MDOC,' ERR: OPEN FILE /FOR WRITE/ ')
      IF(NLP.GT.0) THEN
        WRITE(LINE,20) PATH(1:NLP)
 20     FORMAT('        PATH :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IF(NLN.GT.0) THEN
        WRITE(LINE,30) FNAME(1:NLN)
 30     FORMAT('        NAME :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IF(NLE.GT.0) THEN
        WRITE(LINE,40) EXT(1:NLE)
 40     FORMAT('   EXTENTION :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IERR=1
      RETURN
      END
C --------------------------------------------
