C
C     MOLREP molecular replacement program
C     Copyright (C) 1999-2006 Alexei Vagin
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C ******
C -P-
C -P------   SUBROUTINES DEPENDED ON SYSTEM --------------------
C -P-
C      CVX - for VMS VAX 
C      CDP - for unix system
C      CMS - for MS-DOS
C      CLN - for Linux 
C ******


C ******
      SUBROUTINE CLOCK(IH)
C
C -P- CLOCK - get date to --> array IH()
C
C    IH(2),IH(3),IH(4),    IH(5),IH(6),IH(7)
C     sec   min  hour      day   month year
C
      INTEGER*4 IH(7)
C ******
      CHARACTER CID*10
c --------------------------------

      CALL UTIME(CID)

c          UTIME - Get current time hh:mm:ss          
c Input:     none
c Output:    TIME - as ASCII string
c Arguments: CHARACTER*(*) CTIME
c Usage:     CALL UTIME(CTIME)
cpjx  CID is a character string which contains the
cpjx  the date as hh:mm:ss

      READ(CID,'(I2,1X,I2,1X,I2,2X)') IH(4),IH(3),IH(2)

      CALL UIDATE(IMON,IDAY,IYR)
      IF(IYR.GE.99) THEN
        IYR=IYR+1900
      ELSE
        IYR=IYR+2000
      ENDIF
      IH(5)=IDAY
      IH(6)=IMON
      IH(7)=IYR
      IH(1)=0
C
C  Dummy routine for Linux
C
CLN   IH(4)=0
CLN   IH(3)=0
CLN   IH(2)=0
CLN   IH(5)=01
CLN   IH(6)=01
CLN   IH(7)=1990
CLN   IH(1)=0

      RETURN
      END

C ===============================================================

      SUBROUTINE GETNOS(CH3)
C
C -P- GETNOS - get name of operating system
C
      CHARACTER CH3*3
C --------------------------------
CMS   CH3='MSD'      
CVX   CH3='VAX'      
      CH3='UNX'      
CLN   CH3='LIN'      
      RETURN
      END

CMS   SUBROUTINE EXIT
CMS   STOP
CMS   END

c ---------------------
C ******
      SUBROUTINE OPENFR(IN,MDOC,PATH,FNAME,EXT,IERR)
C
C -P- OPENFR - open formatted file for read /with extention and path/
C
C       input:
C               IN    - unit
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       >= 99 - not write  
C               PATH  - path      / may be = '    ' /
C               FNAME - file name
C               EXT   - extention / may be = '    ' /
C
C        output:
C               IERR = 0 - OK
C                    > 0 - error.
C
      IMPLICIT NONE
      INTEGER   IN,MDOC,IERR
      CHARACTER PATH*(*),FNAME*(*),EXT*(*)
      INTEGER LENSTR
      INTEGER IFAIL,LL
      integer nfile

      INTEGER   NLE,NLN,NLP,NL
      CHARACTER FILE*256,FILE1*256,LINE*80
C
C -------------------------------------------------------------
      IERR  = 0

      CALL LENSTR_BL(EXT,NLE)
      CALL LENSTR_BL(PATH,NLP)
      CALL LENSTR_BL(FNAME,NLN)

      IF(NLE.GT.0) THEN
        FILE1=FNAME(1:NLN)//'.'//EXT(1:NLE)
      ELSE
        FILE1=FNAME(1:NLN)
      ENDIF     
      CALL LENSTR_BL(FILE1,NL)
      IF(NLP.GT.0) THEN
        FILE=PATH(1:NLP)//FILE1(1:NL)
      ELSE
        FILE = FILE1(1:NL)
      ENDIF     

      IFAIL = -1

      IN    = 0
C      IF(LENSTR(FILE).LE.0) THEN
C        CALL ERRWRT(1,'File lenght is 0. Cannot open for reading')
C      ENDIF
      inquire(file=file, number=nfile)
      if(nfile.gt.6 .and. nfile.lt.100) close(nfile)
      CALL CCPDPN(IN,FILE(1:lenstr(FILE)),'OLD','F',LL,IFAIL)
      IF(IFAIL.GT.0) GO TO 9100
      RETURN
C ----
9100  CONTINUE
      IF(NLE.GT.65) NLE=65
      IF(NLP.GT.65) NLP=65
      IF(NLN.GT.65) NLN=65
      CALL MSGERR(MDOC,' ERR: OPEN FILE /FOR READ/ ')
      IF(NLP.GT.0) THEN
        WRITE(LINE,20) PATH(1:NLP)
 20     FORMAT('        PATH :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IF(NLN.GT.0) THEN
        WRITE(LINE,30) FNAME(1:NLN)
 30     FORMAT('        NAME :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IF(NLE.GT.0) THEN
        WRITE(LINE,40) EXT(1:NLE)
 40     FORMAT('   EXTENTION :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IERR=1
      RETURN
      END

C ******
      SUBROUTINE OPENFW(IOUT,MDOC,PATH,FNAME,EXT,IERR)
C
C -P- OPENFW - open formatted file for write /with extentiom and path/
C
C       input:
C               IOUT   - unit
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       >= 99 - not write  
C               PATH  - path      / may be = '    ' /
C                       ( example of PATH='blanc/temp/' )
C               FNAME - file name
C               EXT   - extention / may be = '    ' /
C
C        output:
C               IERR = 0 - OK
C                    > 0 - error.
C
      IMPLICIT NONE
      INTEGER   IOUT,MDOC,IERR
      CHARACTER PATH*(*),FNAME*(*),EXT*(*)
      INTEGER IFAIL,LL

      INTEGER   NLE,NLN,NLP,NL
      INTEGER LENSTR
      CHARACTER FILE*256,FILE1*256,LINE*80
      integer nfile
      EXTERNAL LENSTR
C ------------------------------
      IERR = 0

      CALL LENSTR_BL(EXT,NLE)
      CALL LENSTR_BL(PATH,NLP)
      CALL LENSTR_BL(FNAME,NLN)

      IF(NLE.GT.0) THEN
        FILE1=FNAME(1:NLN)//'.'//EXT(1:NLE)
      ELSE
        FILE1=FNAME(1:NLN)
      ENDIF     
      CALL LENSTR_BL(FILE1,NL)
      IF(NLP.GT.0) THEN
        FILE=PATH(1:NLP)//FILE1(1:NL)
      ELSE
        FILE = FILE1(1:NL)
      ENDIF     

C
      IFAIL = -1
      IOUT  = 0
      LL    = 0
C      IF(LENSTR(FILE).LE.0) THEN
C        CALL ERRWRT(1,'LENGTH of file is 0. Cannot open UNKNOW file') 
C      ENDIF
 
      inquire(file=file, number=nfile)
      if(nfile.gt.6 .and. nfile.lt.100) close(nfile)      
      CALL CCPDPN(IOUT,FILE(1:LENSTR(FILE)),'UNKNOWN','F',LL,IFAIL)
      IF(IFAIL.GT.0) GO TO 9100
      RETURN
C ----
9100  CONTINUE
      IF(NLE.GT.65) NLE=65
      IF(NLP.GT.65) NLP=65
      IF(NLN.GT.65) NLN=65
      CALL MSGERR(MDOC,' ERR: OPEN FILE /FOR READ/ ')
      IF(NLP.GT.0) THEN
        WRITE(LINE,20) PATH(1:NLP)
 20     FORMAT('        PATH :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IF(NLN.GT.0) THEN
        WRITE(LINE,30) FNAME(1:NLN)
 30     FORMAT('        NAME :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IF(NLE.GT.0) THEN
        WRITE(LINE,40) EXT(1:NLE)
 40     FORMAT('   EXTENTION :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IERR=1
      RETURN
      END
C
      SUBROUTINE OPENUR(IN,MDOC,PATH,FNAME,EXT,IERR)
C
C -P- OPENUR - open unformatted file for read /with extentiom and path/
C
C       input:
C               IN    - unit
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       >= 99 - not write
C               PATH  - path      / may be = '    ' /
C               FNAME - file name
C               EXT   - extention / may be = '    ' /
C
C        output:
C               IERR = 0 - OK
C                    > 0 - error.
C
      IMPLICIT NONE
      INTEGER   IN,MDOC,IERR
      CHARACTER PATH*(*),FNAME*(*),EXT*(*)
C ******
      INTEGER   NLE,NLN,NLP,NL
      CHARACTER FILE*256,FILE1*256,LINE*80
      CHARACTER CH1*1,TYPE*1
      INTEGER LENSTR
      INTEGER IFAIL,LL,I
      integer nfile
C -------------------------------------------------------------
      IERR=0

      NLE = LENSTR(EXT)
      NLP = LENSTR(PATH)
      NLN = LENSTR(FNAME)

      CH1=FNAME(1:1)
      CALL CHKSMB(CH1,TYPE)
      IF(TYPE.EQ.'?'.OR.CH1.EQ.' '.OR.CH1.EQ.',') THEN
        FNAME(1:1)=' '
      ENDIF


      IF(NLN.GT.1) THEN
        DO I=2,NLN
          IF(FNAME(I:I).EQ.',') FNAME(I:I)=' '
        ENDDO
      ENDIF
      IF(NLP.GT.1) THEN
        DO I=2,NLP
          IF(PATH(I:I).EQ.',') PATH(I:I)=' '
        ENDDO
      ENDIF
      IF(NLE.GT.1) THEN
        DO I=2,NLE
          IF(EXT(I:I).EQ.',') EXT(I:I)=' '
        ENDDO
      ENDIF

      NLE = LENSTR(EXT)
      NLP = LENSTR(PATH)
      NLN = LENSTR(FNAME)


      IF(FNAME(1:1).EQ.' '.OR.NLN.LE.0) GO TO 9100

      IF(NLE.GT.0) THEN
        FILE1=FNAME(1:NLN)//'.'//EXT(1:NLE)
      ELSE
        FILE1=FNAME(1:NLN)
      ENDIF
      NL = LENSTR(FILE1)
      IF(NLP.GT.0) THEN
        FILE=PATH(1:NLP)//FILE1(1:NL)
      ELSE
        FILE=FILE1(1:NL)
      ENDIF
      NL = LENSTR(FILE)
      IN    = 0
      IFAIL = -1
C      IF(NL.LE.0) THEN
C        CALL ERRWRT(1,'File length is 0. CANNOT open file. OPENUR')
C      ENDIF
      inquire(file=file, number=nfile)
      if(nfile.gt.6 .and. nfile.lt.100) close(nfile)
      CALL CCPDPN(IN,FILE(1:NL),'OLD','U',LL,IFAIL)
      IF(IFAIL.GT.0) GOTO 9100
      RETURN
C ----
9100  CONTINUE
      IF(NLE.GT.65) NLE=65
      IF(NLP.GT.65) NLP=65
      IF(NLN.GT.65) NLN=65
      CALL MSGERR(MDOC,' ERR: OPEN FILE /FOR READ/ ')
      IF(NLP.GT.0) THEN
        WRITE(LINE,20) PATH(1:NLP)
 20     FORMAT('        PATH :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IF(NLN.GT.0) THEN
        WRITE(LINE,30) FNAME(1:NLN)
 30     FORMAT('        NAME :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IF(NLE.GT.0) THEN
        WRITE(LINE,40) EXT(1:NLE)
 40     FORMAT('   EXTENTION :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IERR=1
      RETURN
      END

      SUBROUTINE OPENUW(IOUT,MDOC,PATH,FNAME,EXT,IERR)
C
C -P- OPENFW - open unformatted file for write /with extentiom and path/
C
C       input:
C               IN    - unit
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       >= 99 - not write
C               PATH  - path      / may be = '    ' /
C               FNAME - file name
C               EXT   - extention / may be = '    ' /
C
C        output:
C               IERR = 0 - OK
C                    > 0 - error.
C
      INTEGER   IOUT,MDOC,IERR
      CHARACTER PATH*(*),FNAME*(*),EXT*(*)
C ******
      INTEGER   NLE,NLN,NLP,NL
      CHARACTER FILE*256,FILE1*256,LINE*80
      CHARACTER CH1*1,TYPE*1
      INTEGER LENSTR,IFAIL,LL,I
      integer nfile
C -------------------------------------------------------------
      IERR=0

      NLE = LENSTR(EXT)
      NLP = LENSTR(PATH)
      NLN = LENSTR(FNAME)

      CH1=FNAME(1:1)
      CALL CHKSMB(CH1,TYPE)
      IF(TYPE.EQ.'?'.OR.CH1.EQ.' '.OR.CH1.EQ.',') THEN
        FNAME(1:1)=' '
      ENDIF


      IF(NLN.GT.1) THEN
        DO I=2,NLN
          IF(FNAME(I:I).EQ.',') FNAME(I:I)=' '
        ENDDO
      ENDIF
      IF(NLP.GT.1) THEN
        DO I=2,NLP
          IF(PATH(I:I).EQ.',') PATH(I:I)=' '
        ENDDO
      ENDIF
      IF(NLE.GT.1) THEN
        DO I=2,NLE
          IF(EXT(I:I).EQ.',') EXT(I:I)=' '
        ENDDO
      ENDIF

      NLE = LENSTR(EXT)
      NLP = LENSTR(PATH)
      NLN = LENSTR(FNAME)


      IF(FNAME(1:1).EQ.' '.OR.NLN.LE.0) GO TO 9100

      IF(NLE.GT.0) THEN
        FILE1=FNAME(1:NLN)//'.'//EXT(1:NLE)
      ELSE
        FILE1=FNAME(1:NLN)
      ENDIF
      NL = LENSTR(FILE1)
      IF(NLP.GT.0) THEN
        FILE=PATH(1:NLP)//FILE1(1:NL)
      ELSE
        FILE=FILE1(1:NL)
      ENDIF
      NL = LENSTR(FILE)
      IOUT  = 0
      IFAIL = -1
C      IF(NL.LE.0) THEN
C        CALL ERRWRT(1,'File length is 0. Cannot open file. OPENUW')
C      ENDIF
      inquire(file=file, number=nfile)
      if(nfile.gt.6 .and. nfile.lt.100) close(nfile)
      CALL CCPDPN(IOUT,FILE(1:NL),'UNKNOWN','U',LL,IFAIL)

C      write(*,*) '--> ccpdpn',iOUT

      IF(IFAIL.GT.0) GOTO 9100
      RETURN
C ----
9100  CONTINUE
      IF(NLE.GT.65) NLE=65
      IF(NLP.GT.65) NLP=65
      IF(NLN.GT.65) NLN=65
      CALL MSGERR(MDOC,' ERR: OPEN FILE /FOR WRITE/ ')
      IF(NLP.GT.0) THEN
        WRITE(LINE,20) PATH(1:NLP)
 20     FORMAT('        PATH :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IF(NLN.GT.0) THEN
        WRITE(LINE,30) FNAME(1:NLN)
 30     FORMAT('        NAME :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IF(NLE.GT.0) THEN
        WRITE(LINE,40) EXT(1:NLE)
 40     FORMAT('   EXTENTION :',A,';')
        CALL MSGERR(MDOC,LINE)

      ENDIF
      IERR=1
      RETURN
      END

      SUBROUTINE DISPL_BL(LINE)
C
C -P- DISPL_BL - dummy routine
C
      CHARACTER LINE*(*)
C ----------------------------
      RETURN
      END


