C
C     MOLREP molecular replacement program
C     Copyright (C) 1999-2006 Alexei Vagin
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
      SUBROUTINE MOLREP(MDOC,NAMEF,NAMEC,NAME_DER,NAME_PH
     * ,NAME2,NAME_TAB   
     * ,NAME_SEQ,NAME_SEQ2,NAMEM_2,NAME_TAB2,NAME_TSRF
     * ,MOLREP_PARAM,IMOLREP_PARAM,RMOLREP_PARAM
     * ,ANGLES,CVECTOR,TVECTOR,SPGR_INP,PATH_SCR,PATH_OUT
     * ,ISYM,IPRSYM,IERR)
C --------------------------------------------------------------------
C      molrep.crd     - molrep solution 
C      crossrot_alo   - spherical coefficients of F_observed 
C      crossrot_alm   - spherical coefficients of F_model
C      crossrot_dns   - rotation function
C      trfun_cf       - coefficients of translation function
C      trfun_dns.dat  - translation function
C      trfun.crd      - trfun solution
C --------------------------------------------------------------------
      COMMON/COM_DPOOL/ IPOOL_MAX,IPOOL_CURR
C --------------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)

      REAL      POOL_SCR(10)
C ----
C     PARAMETER ( IPRMAX = 21      ) 
c      PARAMETER ( IPRROW = 21      )
      PARAMETER ( IPRROW = 51      )

C     PARAMETER ( IPRMAX = 50      )
      PARAMETER ( IPRMAX = 200     )

      REAL      RESULT (IPRMAX,IPRROW)
      REAL      RESULT2(IPRMAX,IPRROW)
      REAL      RESULT3(IPRMAX,IPRROW)
      REAL      RESULTA(IPRMAX,IPRROW)
C ---
      CHARACTER NAMEF*(*),NAMEC*(*),NAME2*(*),NAME_PH*(*),NAME_TAB*(*)
      CHARACTER NAME_SEQ*(*),NAME_SEQ2*(*),NAME_TSRF*(*),NAME_DER*(*)
      CHARACTER NAMEM_2*(*),NAME_TAB2*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)

      CHARACTER MOLREP_PARAM*40
      INTEGER   IMOLREP_PARAM(40)
      REAL      RMOLREP_PARAM(40)
      CHARACTER MODE*1,ANISO*1,PACK*1,MTZ*1,FUN*1,LIST*1,PST*1,DIFF*1
      CHARACTER PST_INPUT*1
      CHARACTER SPGR_INP*(*)
      CHARACTER CH1*1
      CHARACTER DYAD*1,LOCK*1,CCP4*1,VCCP4*1
      REAL      ANGLES(3),TVECTOR(3),CVECTOR(3)
      REAL      SH_O_TO_CELL(3)
      INTEGER   NOSPGR
C ---------------------------
      CHARACTER NAMEM*256,NAMESF*256,NAME*256,NAME1*256,NAME3*256
      CHARACTER NAMEM2*256,NAMEF_DIFF*256,NAMES*256
      CHARACTER NAMESF_INP*256
      CHARACTER PATH*256,EXT*3
      CHARACTER LINE*256

      CHARACTER TEST_SRF*1,TEST_BOFF*1
      CHARACTER TITLE*80,REF*1,SUM*1,PDB*1,PDB_MOD*1
      CHARACTER FORM*1,ANOM*1,SETT*1,CIF*1,TFUN*1,REFP*1,FAST*1
      CHARACTER STR_TITLE*40,STR_DATE*9,LH*1,DB*1,SURFX*1
      CHARACTER ITYPE*4,TTT*80,SELF*1,SURF*1,TEST*1,MOD2*1,MOD1*1
      CHARACTER INVER*1,FOBS*1,PRF*1,FIT*1,PHASE*1,MODE_T*1,MOD2S*1
      CHARACTER STICK*1,DOM*1,FULL*1,LAP*1,CHECK_SOL*1
      CHARACTER CFREE*1,CSIG*1,CFOM*1,P1_KEY*1,STICK_INP*1
C ---
      REAL      RLATT_F(6),RLATT_C(6),SH_MOD2(3),SPST(3)
      INTEGER   NSPGROUP_F,NOSETT_F,NSPGROUP_C,NOSETT_C
      CHARACTER CODE*4,DATE*9,SPGR_F*24,SPGR_C*24,CHAIN*1,CELL*1
      CHARACTER INVER1*1,INVER2*1,POS*1,CHAR1*1,ANISO_CORR*1
      CHARACTER INVER_T*1,PST_T*1,ALL*1,MTZD*1,DER*1,SEQ*1,MAP*1
      CHARACTER SCORE_FLAG*1,ANISO_INPUT*1,DB_INPUT*1
      INTEGER   NSG_CHECK,ISG_CHECK(100)
      CHARACTER SG_CHECK(100)*24
C ---
      REAL      FPAR_MR(30)
      INTEGER   INT_PARAM(30)
      CHARACTER PAR_MR*30
C ---
      CHARACTER TIME_CURRENT*15,TIME_ELAPSED*15,TIME_EXPECTED*15
C ---
      INCLUDE 'molrep_version.fh'
      INCLUDE 'molrep_xml.fh'
C ============================================================

      IF(ABS(MDOC).GE.997) THEN
        MDOC_C=1
        IF(MDOC.LT.0) THEN
          MDOC=0
        ELSE      
C   
C         MDOC=999
C         IF(MSG.EQ.'Y') MDOC=999 do not keep old contents
C         IF(MSG.EQ.'A') MDOC=998 keep old contents
C         IF(MSG.EQ.'#') MDOC=997 batch mode, "_DOC " will be read
C          
C         for subroutine case:
C
C         MDOC=999 do not keep old contents
C         MDOC=998 keep old contents
C
C         MDOC=-999 without DOC-file
C
        ENDIF
        CALL START(0,MDOC,'molrep',PATH_OUT)
      ELSE
        MDOC_C=0
      ENDIF
C =============================================================
      IF(MDOC.GT.0) THEN
        M=-1
        LINE = VERSION
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GT.75) LEN = 75
        LINE = 'Sol_'//LINE(1:LEN)
        CALL MSGDOC(M,'Sol_ ')
        CALL MSGDOC(M,LINE)
        CALL MSGDOC(M,'Sol_ ')
      ENDIF
      CALL CLOSE_BATCH(M)
C -------------
      ITIME_START =-1
      NRUN_TIME   = 0
      CALL EXPECTED_TIME(ITIME_START,NRUN_TIME
     *  ,ITIME_CURR,TIME_CURRENT,TIME_ELAPSED,TIME_EXPECTED)
      WRITE(LINE,*) 'Time:',TIME_CURRENT
      CALL MSGDOC(MDOC,LINE)
C -------------
      M  = 99
      MD = -ABS(MDOC)-1
      IPOOL_MAX = 1
      DO I=1,IPRMAX
      DO J=1,IPRROW
        RESULT (I,J) = 0.0
        RESULT2(I,J) = 0.0
        RESULT3(I,J) = 0.0
        RESULTA(I,J) = 0.0
      ENDDO
      ENDDO
C ------------
      CALL CORR_NAME_BLC(PATH_OUT)
      CALL CORR_NAME_BLC(PATH_SCR)
      CALL CORR_NAME_BLC(SPGR_INP)
      CALL LENSTR_BL(PATH_OUT,LEN)
      IF(LEN.GT.0) THEN
        CALL MSGDOC(MDOC,' ')
        LINE = 'Full doc. in:'//PATH_OUT(LEN1:LEN)//'molrep.doc'
        CALL LENSTR_BL(LINE,L)
        L1 = 1
        IF(L.GT.79) L1 = L - 78
        CALL MSGDOC(MDOC,LINE(L1:L))
        LINE = 'Script file :'//PATH_OUT(LEN1:LEN)//'molrep.btc'
        CALL LENSTR_BL(LINE,L)
        L1 = 1
        IF(L.GT.79) L1 = L - 78
        CALL MSGDOC(MDOC,LINE(L1:L))
      ELSE
        CALL MSGDOC(MDOC,' ')
        LINE = 'Full doc. in: molrep.doc'
        CALL MSGDOC(MDOC,LINE)
        LINE = 'Script file : molrep.btc'
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      CALL MSGDOC(MDOC,' ')

C ------------
      MODE  = MOLREP_PARAM(1:1) 
      ANISO = MOLREP_PARAM(2:2) 
      PACK  = MOLREP_PARAM(3:3) 
      FUN   = MOLREP_PARAM(4:4) 
      LIST  = MOLREP_PARAM(5:5) 
      MTZ   = MOLREP_PARAM(6:6)
      PST   = MOLREP_PARAM(7:7)
      SURF  = MOLREP_PARAM(8:8)
      INVER = MOLREP_PARAM(9:9)
      PRF   = MOLREP_PARAM(10:10)
      DIFF  = MOLREP_PARAM(11:11)
      DYAD  = MOLREP_PARAM(12:12)
      STICK = MOLREP_PARAM(13:13)
      TEST  = MOLREP_PARAM(16:16)
      LOCK  = MOLREP_PARAM(17:17)
      INVER1= MOLREP_PARAM(18:18)
      ALL   = MOLREP_PARAM(19:19)
      CCP4  = MOLREP_PARAM(20:20)
      PHASE = MOLREP_PARAM(21:21)
      VCCP4 = MOLREP_PARAM(22:22)
      DOM   = MOLREP_PARAM(23:23)
      SEQ   = MOLREP_PARAM(24:24)
      LH    = MOLREP_PARAM(25:25)
      DB    = MOLREP_PARAM(26:26)
      SCORE_FLAG = MOLREP_PARAM(27:27)
      P1_KEY = MOLREP_PARAM(28:28)
      FULL   = MOLREP_PARAM(29:29)
      SURFX  = MOLREP_PARAM(30:30)
      LAP    = MOLREP_PARAM(31:31)
      CHECK_SOL = MOLREP_PARAM(32:32)
      SELF   = MOLREP_PARAM(33:33)

      MTZD  = MTZ

      LMIN   = IMOLREP_PARAM(1)
      LMAX   = IMOLREP_PARAM(2)
      NPEAK  = IMOLREP_PARAM(3)
      NPT    = IMOLREP_PARAM(4)
      NMON   = IMOLREP_PARAM(5)
      NOSPGR = IMOLREP_PARAM(6) 
      NP_SRF = IMOLREP_PARAM(7) 
      NPT_DM = IMOLREP_PARAM(8) 
      NMR    = IMOLREP_PARAM(9) 
      NMR_INPUT = NMR  
      NPEAK2 = IMOLREP_PARAM(10) 
      NREF   = IMOLREP_PARAM(11) 
      NREFP  = IMOLREP_PARAM(12) 
      NREFR  = IMOLREP_PARAM(13) 
      NCS    = IMOLREP_PARAM(14) 
      IDELETE = IMOLREP_PARAM(15) 
c
C IDELETE = 0 not delete,i.e. rest LIST = 'L'
C         = 1 delete,i.e. set LIST = 'S'

      NCSM   = IMOLREP_PARAM(16) 
      NMON_EXPECTED = IMOLREP_PARAM(17) 
      NML    = IMOLREP_PARAM(18) 

C
C     1 < ncs < 100 info about ncs_model
c
      NCS_MODEL =  NCSM

      CHI_IN    = RMOLREP_PARAM( 1) 
      COEF_IN   = RMOLREP_PARAM( 2) 
      RESN_R    = RMOLREP_PARAM( 3) 
      RESN_T    = RMOLREP_PARAM( 4) 
      RESX      = RMOLREP_PARAM( 5)
      COMPL     = RMOLREP_PARAM( 6) 
      QUAL      = RMOLREP_PARAM( 7) 
      BADD      = RMOLREP_PARAM( 8) 
      IF(QUAL.LT.0.0) THEN
        QUAL = 0.0
        BADD = 1.0
      ENDIF
      BADD_INPUT = BADD
      QUAL_INPUT = QUAL
      ARAD      = RMOLREP_PARAM( 9) 
      PERCENT_2 = RMOLREP_PARAM(10)
      RESN_SCL  = RMOLREP_PARAM(11)
      DIST_MIN  = RMOLREP_PARAM(12)
      DIST_MAX  = RMOLREP_PARAM(13)
      DIST_DPAR = RMOLREP_PARAM(14)
      DELTA     = RMOLREP_PARAM(15)
      CHI_DYAD  = RMOLREP_PARAM(16)
      DELTA2    = RMOLREP_PARAM(17)
      BADD_SCL  = RMOLREP_PARAM(18)

      DSCALE    = RMOLREP_PARAM(19)
      DSCALE1   = RMOLREP_PARAM(20)
      ROLIM     = RMOLREP_PARAM(21)
      DRAD      = RMOLREP_PARAM(22)
      ORIGX     = RMOLREP_PARAM(23)
      ORIGY     = RMOLREP_PARAM(24)
      ORIGZ     = RMOLREP_PARAM(25)
      RMAX      = RMOLREP_PARAM(26)
      RMAXM     = RMOLREP_PARAM(27)
      RESOL_D   = RMOLREP_PARAM(28)
      RMS_INPUT = RMOLREP_PARAM(29)
      DLIM_RF   = RMOLREP_PARAM(30)
      DLIM      = RMOLREP_PARAM(31)
      RSMAX_RB  = RMOLREP_PARAM(32)
      RBOFF     = RMOLREP_PARAM(33)
      IDZNCS    = RMOLREP_PARAM(34)
      DRAD_PACK_INP = RMOLREP_PARAM(35)
C --------------------------
      PATH = ' '
      EXT  = ' '
c      BOFF = 4.0 * RBOFF * RBOFF
      BOFF = 2.0 * RBOFF * RBOFF
      FIDENT_LIMIT = 20.0
      MAP = 'N'
      VOL_POS = 0.0
      VOL_MAP = 0.0
      DENS_RESOL = 0.0
      N_MODEL  = 0
      NMON_EXP = 0
C ==========
C     F - flat dens for RF ; L long list for RF ; 
C

      SPST(1)   = 0.0
      SPST(2)   = 0.0
      SPST(3)   = 0.0

C     if( list = 'l') molrep1 is corrected model
C 
      IF(SURF.EQ.'n') SURF = 'N'
      IF(SURF.EQ.'o') SURF = 'O'
      IF(SURF.EQ.'a') SURF = 'A'
      IF(SURF.EQ.'c') SURF = 'C'
      IF(SURF.EQ.'d') SURF = 'D'
      IF(SURF.NE.'N'.AND.SURF.NE.'O'.AND.SURF.NE.'A'.AND.
     *   SURF.NE.'2'.AND.SURF.NE.'C'.AND.SURF.NE.'D'   ) SURF = 'Y'

      IF(SURFX.EQ.'n') SURFX = 'N'
      IF(SURFX.EQ.'c') SURFX = 'C'
      IF(SURFX.NE.'N'.AND.SURFX.NE.'C') SURFX = 'Y'

      IF(LAP.EQ.'y') LAP = 'Y'
      IF(LAP.NE.'Y') LAP = 'N'

      IF(SELF.EQ.'a') SELF = 'A'
      IF(SELF.NE.'A') SELF = 'N'

      IF(CHECK_SOL.EQ.'y') CHECK_SOL = 'Y'
      IF(CHECK_SOL.NE.'Y') CHECK_SOL = 'N'

      IF(STICK.EQ.'n') STICK = 'N'
      IF(STICK.EQ.'y') STICK = 'Y'
      STICK_INP = STICK
      IF(STICK.NE.'N') STICK = 'Y'

      IF(LOCK.EQ.'y') LOCK = 'Y'
      IF(LOCK.EQ.'g') LOCK = 'G'
      IF(LOCK.NE.'Y'.AND.LOCK.NE.'G') LOCK = 'N'

      IF(FULL.EQ.'y') FULL = 'Y'
      IF(FULL.NE.'Y') FULL = 'N'

      IF(P1_KEY.EQ.'y') P1_KEY = 'Y'
      IF(P1_KEY.NE.'Y') P1_KEY = 'N'

      IF(SCORE_FLAG.EQ.'y') SCORE_FLAG = 'Y'
      IF(SCORE_FLAG.EQ.'n') SCORE_FLAG = 'N'
      IF(SCORE_FLAG.EQ.'c') SCORE_FLAG = 'C'
      IF(SCORE_FLAG.NE.'N'.AND.SCORE_FLAG.NE.'C') SCORE_FLAG = 'Y'

      IF(SEQ.EQ.'y') SEQ = 'Y'
      IF(SEQ.EQ.'n') SEQ = 'N'
      IF(SEQ.NE.'Y'.AND.SEQ.NE.'N') SEQ = 'D'

      IF(LH.EQ.'y') LH = 'Y'
      IF(LH.EQ.'v') LH = 'V'      
      IF(LH.EQ.'t') LH = 'T'
      IF(LH.EQ.'n') LH = 'N'
      IF(LH.NE.'Y'.AND.LH.NE.'N'.AND.LH.NE.'T'.AND.
     *   LH.NE.'2') LH = 'V'

      IF(DB.EQ.'y') DB = 'Y'
      IF(DB.NE.'Y') DB = 'N'
c ==
      DB_INPUT = DB
      DB = 'N'
c ==

      IF(ALL.EQ.'y') ALL = 'Y'
      IF(ALL.EQ.'n') ALL = 'N'
      IF(ALL.NE.'Y') ALL = 'N'

      IF(MODE.EQ.'s') MODE = 'S'
      IF(MODE.EQ.'m') MODE = 'M'
      IF(MODE.NE.'S'.AND.MODE.NE.'M') MODE = 'F'

      IF(PST .EQ.'y') PST  = 'Y'
      IF(PST .EQ.'a') PST  = 'A'
      IF(PST .EQ.'c') PST  = 'C'
      IF(PST .EQ.'n') PST  = 'N'
      IF(PST .NE.'Y'.AND.PST .NE.'N'.AND.PST .NE.'C') PST  = 'A'
      PST_INPUT = PST
      IF(TEST .EQ.'f') TEST  = 'F'
      IF(TEST .EQ.'l') TEST  = 'L'

      IF(DYAD .EQ.'y') DYAD  = 'Y'
      IF(DYAD .EQ.'m') DYAD  = 'M'
      IF(DYAD .EQ.'d') DYAD  = 'D'
      IF(DYAD .NE.'Y'.AND.DYAD .NE.'D'.AND.DYAD.NE.'M') DYAD = 'N'
C --------
      IF(FUN.EQ.'S'.OR.FUN.EQ.'s') THEN
c          LINE =
c     *'WARNING: with keyword: FUN = S: if SURF = N  --> SURF = O'
c        CALL MSGERR(MDOC,LINE)
c       IF(SURF.EQ.'N') SURF = 'O'
        DYAD = 'N'
        IF(NMR.LT.0) NMR = 0
        STICK = 'N'
        PST   = 'N'
      ENDIF

      IF(NMR.GT.1) THEN
        IF(PST.EQ.'Y'.OR.PST.EQ.'A'.OR.
     *                   DYAD.NE.'N'.OR.STICK.NE.'N') THEN
          LINE =
     *  'WARNING: with keyword: NMR > 1 --> DYAD = STICK = PST = N'//
     *  ' MODE = F'
          CALL MSGERR(MDOC,LINE)
        ENDIF
        MODE  = 'F'
        IF(PST.EQ.'Y'.OR.PST.EQ.'A') PST   = 'N'
        DYAD  = 'N'
        STICK = 'N'
        REF   = 'N'
        REFP  = 'N'
        NREF  = 0
        NREFP = 0
      ENDIF

      TEST_SRF = 'N'
      IF(DYAD.EQ.'Y'.OR.DYAD.EQ.'D') THEN
        IF(MODE.NE.'F'.OR.SURF.EQ.'N') THEN
          LINE =
     *'WARNING: with keyword: DYAD = Y/D --> MODE = F PST = N'
          CALL MSGERR(MDOC,LINE)
          LINE =
     *'                            and if SURF = N  --> SURF = O'
          CALL MSGERR(MDOC,LINE)
        ENDIF
        IF(SURF.EQ.'N') SURF = 'O'
        PST   = 'N'
        MODE  = 'F'
        REF   = 'N'
        REFP  = 'N'
        NREF  = 0
        NREFP = 0
        IF(ABS(NP_SRF).GT.0) TEST_SRF = 'Y'
      ENDIF

      IF(STICK.EQ.'Y'.AND.MODE.EQ.'S') THEN
        LINE =
     *'WARNING with keyword: MODE = S --> STICK = N'
        CALL MSGERR(MDOC,LINE)
        STICK = 'N' 
      ENDIF

      IF(STICK.EQ.'Y'.AND.SURF.EQ.'N') THEN
          LINE =
     *'WARNING with keyword: SURF = N --> STICK = N'
          CALL MSGERR(MDOC,LINE)
        STICK = 'N' 
      ENDIF

C ==========
      PERCENT_1 = 0.0
      BLIM      =15.0
      CHAIN     = ' '
      MODEL     = 0
      DENS_RESOL = 0.0
C -----------------------
C     initialisation COM_XML_INFO
      CALL XML_COM_INIT
      JOB_XML = 'MR_START'
      MESSAGE_XML  = 'normal run'  
      TIME_ELAPSED_XML  = TIME_ELAPSED
      TIME_EXPECTED_XML = TIME_EXPECTED
      CALL WRITE_XML_FILE(IERR,PATH_OUT)
C
      CALL INIT_LH_COM(LH,SCORE_FLAG,DB_INPUT)
      CALL INIT_INERTIA_MATRIX
C -----------------------
      DER = 'N'
      CALL LENSTR_BL(NAME_DER,LEN)
      IF(LEN.GT.0.AND.NAME_DER(1:1).NE.','.AND.NAME_DER(1:1).NE.' ') 
     *  DER = 'Y'
C --
      CALL CORR_NAME_ALL(NAME2)
      CALL LENSTR_BL(NAME2,LEN)
      IF(LEN.GT.0.AND.NAME2(1:1).NE.','.AND.NAME2(1:1).NE.' ') THEN
        MOD2 = 'Y'
        CALL CHECK_COORD_FILE(MDOC,NAME2,LINE,IERR)
        IF(IERR.EQ.0) THEN
          IF(LINE(1:3).EQ.'MAP') THEN
            LINE = ' ERROR: model_2 cannot be a MAP'
            CALL MSGERR(MD,LINE)
            IERR = 1
          ENDIF
        ENDIF
        IF(IERR.NE.0) THEN
          CALL MSGERR(MD,'ERROR: check model_2 (fixed) coord_file')
          IERR_XML     = IERR
          GO TO 900
        ENDIF
      ELSE
        MOD2 = 'N'
      ENDIF
C --  model
      CALL CORR_NAME_ALL(NAMEC)
      CALL LENSTR_BL(NAMEC,LEN)
      IF(LEN.GT.0.AND.NAMEC(1:1).NE.','.AND.NAMEC(1:1).NE.' ') THEN
        MOD1 = 'Y'
        CALL CHECK_COORD_FILE(MDOC,NAMEC,LINE,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MD,'ERROR: check model_coord_file')
          IERR_XML     = IERR
          GO TO 900
        ENDIF
      ELSE
        MOD1 = 'N'
      ENDIF

      IF(MOD1.EQ.'N') THEN
        IF(FUN.EQ.'B'.OR.FUN.EQ.'b') THEN
          IF(MOD2.EQ.'N') THEN
            CALL MSGERR(MDOC,
     *      ' ERROR: there is not model_2 for RB refinement (FUN=B)')
            IERR = 1
            IERR_XML     = IERR
            GO TO 900
          ENDIF
        ELSE  
          IF(DIFF.EQ.'H'.OR.DIFF.EQ.'h') THEN
            IF(MOD2.EQ.'Y') THEN
              FUN = 'D'
            ELSE
              IF(FUN.NE.'T'.AND.FUN.NE.'t') FUN = 'R'            
            ENDIF
          ENDIF
        ENDIF
      ENDIF
C -----------------------
C --
C     INVER = N or Y

      IF(INVER.EQ.'y') INVER = 'Y'
      IF(INVER.NE.'Y') INVER = 'N'

      IF(INVER1.EQ.'y') INVER1 = 'Y'
      IF(INVER1.NE.'Y') INVER1 = 'N'

      FOBS  = 'N'
C --
      MODE_T = 'C'
      IF(PRF .EQ.'y') PRF  = 'Y'
      IF(PRF .EQ.'s') PRF  = 'S'
      IF(PRF .EQ.'p') PRF  = 'P'
      IF(PRF .NE.'Y'.AND.PRF .NE.'S'.AND.PRF .NE.'P') PRF  = 'N'

      IF(PRF .NE.'N') THEN
        LH     = 'N'
        NREFP  = 0     
        NREFR  = 0     
        MODE_T = MODE
        IF(MODE_T.EQ.'c') MODE_T = 'C'
        IF(MODE_T.NE.'C') MODE_T = 'D'
C       MODE   = ' '
      ENDIF

      IF(DOM.EQ.'n') DOM = 'N'
      IF(DOM.EQ.'y') DOM = 'Y'
      IF(DOM.EQ.'i') DOM = 'I'
      IF(DOM.EQ.'c') DOM = 'C'
      IF(DOM.EQ.'s') DOM = 'S'
      IF(DOM.NE.'S'.AND.DOM.NE.'I'.AND.DOM.NE.'C'.AND.DOM.NE.'N')
     *DOM = 'Y'

      IF(DIFF.EQ.'p') DIFF = 'P'
      IF(DIFF.EQ.'d') DIFF = 'D'
      IF(DIFF.EQ.'f') DIFF = 'F'
      IF(DIFF.EQ.'h') DIFF = 'H'
      IF(DIFF.EQ.'m') DIFF = 'M'
      IF(DIFF.NE.'P'.AND.DIFF.NE.'D'.AND.DIFF.NE.'F'.AND.
     *   DIFF.NE.'H'.AND.DIFF.NE.'M') DIFF = 'N'

      IF(FUN .EQ.'r') FUN  = 'R'
      IF(FUN .EQ.'t') FUN  = 'T'
      IF(FUN .EQ.'b') FUN  = 'B'
      IF(FUN .EQ.'s') FUN  = 'S'
      IF(FUN .EQ.'d') FUN  = 'D'
      IF(FUN.NE.'R'.AND.FUN.NE.'S'.AND.FUN.NE.'D'.AND.FUN.NE.'T'.AND.
     * FUN.NE.'B') FUN='A'

      IF(FUN.EQ.'D') THEN
        LH   = 'N'
        DIFF = 'H'
        PRF  = 'N'
        PST  = 'N'
      ENDIF

      IF(FUN.EQ.'B') THEN
c       LH  = 'N'
        PST = 'N'
      ENDIF
      IF(DER.EQ.'Y') THEN
        PST = 'N'
      ENDIF

c      IF(DIFF.NE.'N'.AND.(PST.EQ.'Y'.OR.PST.EQ.'A')) THEN
c         LINE =
c     *  'WARNING: with keyword: DIFF # N: PST = N'
c        CALL MSGERR(MDOC,LINE)
c        PST = 'N'
c      ENDIF

c      IF(MOD1.EQ.'Y'.AND.MOD2.EQ.'Y'.AND.
c     *                        (PST.EQ.'Y'.OR.PST.EQ.'A')) THEN
c        LINE =
c     *  'WARNING: if PST will be used: model_2 must be without PST copy'
c        CALL MSGERR(MDOC,LINE)
c      ENDIF


      IF(LIST.EQ.'s') LIST='S'
      IF(LIST.EQ.'l') LIST='L'
      IF(LIST.EQ.'t') LIST='T'
      IF(LIST.NE.'S'.AND.LIST.NE.'T'.AND.LIST.NE.'L') THEN
        IF(DYAD.NE.'N') THEN
          LIST='S'
        ELSE
          LIST='L'
        ENDIF
      ENDIF
      IF(LIST.EQ.'T') THEN
        CALL MSGDOC(MDoc,' --molrep-test--')
      ENDIF

      FAST = MODE
      IF(FAST.EQ.'s') FAST = 'S'
      IF(FAST.EQ.'m') FAST = 'M'
      IF(FAST.NE.'S'.AND.FAST.NE.'M') FAST = 'F'

      IF(FAST.EQ.'S') THEN
        REF  = 'Y'
        REFP = 'N'
        SUM  = 'Y'

C       TFUN = 'A'
        TFUN = 'S'

      ELSE IF(FAST.EQ.'M') THEN
        REF  = 'N'
        REFP = 'N'
        SUM  = 'N'
        TFUN = 'S'
      ELSE
        REF  = 'N'
        REFP = 'N'
        SUM  = 'N'
        TFUN = 'S'
      ENDIF

      IF(NREFP.GT.0) REFP = 'Y'

      IF(FAST.EQ.'M') THEN
        IF(NREF.GT.0) REF = 'Y'
      ENDIF

      IF(PACK.EQ.'n') PACK='N'
      IF(PACK.EQ.'p') PACK='P'
      IF(PACK.EQ.'s') PACK='S'
      IF(PACK.NE.'N'.AND.PACK.NE.'P'.AND.PACK.NE.'S') PACK='Y'

      IF(ANISO.EQ.'y') ANISO = 'Y'
      IF(ANISO.EQ.'n') ANISO = 'N'
      IF(ANISO.EQ.'c') ANISO = 'C'
      IF(ANISO.EQ.'s') ANISO = 'S'
      IF(ANISO.EQ.'k') ANISO = 'K'
      IF(ANISO.EQ.'y') ANISO = 'Y'
      ANISO_INPUT = ANISO
      IF(ANISO.NE.'N'.AND.ANISO.NE.'C'.AND.ANISO.NE.'S'.AND.
     *                                     ANISO.NE.'K'     ) ANISO='Y'
      ANISO_CORR ='N'
       IF(ANISO.EQ.'C'.OR.ANISO.EQ.'Y') ANISO_CORR ='Y'
c ------------------------
      IF(RMS_INPUT.LT.0.00001) RMS_INPUT = 0.5
c
c      IF(RESX.LT.0.00001) THEN
c        RESX = 3.0
c      ENDIF
C ------------------------
      M   = 99
c     MD  = 0
      MDD =-1
C ----------
      CALL MOLREP_CLEAN(LIST,PATH_SCR,PATH_OUT)
      NAMEM2 = NAME2      
C ----------
      CHAR1 = '2'
      CALL INIT_DENS_FILE(CHAR1)
C ----------
C       check name of file Fobs
      FOBS = 'N'
      CALL CORR_NAME_ALL(NAMEF)
      CALL LENSTR_BL(NAMEF,LEN)
      IF(LEN.GT.0.AND.NAMEF(1:1).NE.','.AND.NAMEF(1:1).NE.' ') THEN
        CALL CHECK_SF_FILE(MDOC,NAMEF,LINE,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MD,'ERROR: check SF_file')
          IERR_XML     = IERR
          GO TO 900
        ENDIF

        FOBS = 'Y'

        CALL LENSTR_BL(NAMEF,LEN)
        LLL = LEN
        IF(LLL.LT.4) LLL=4
        IF(LEN.GT.4.AND.NAMEF(LLL-3:LLL).EQ.'.dat') THEN
C         blanc file Fobs
          NAME  = NAMEF(1:LEN-4)
          MTN   = 10
          ITYPE = '    '
          MMM   = M
          IF(LIST.EQ.'T') MMM = MDOC
          CALL ORFILE(MMM,MTN,NAME,ITYPE,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MD,' ERROR: can not open INPUT_Fobs_FILE..')
            IERR_XML     = IERR
            GO TO 900
          ENDIF
          CLOSE(MTN)
          IF(ITYPE.EQ.'RI  ') THEN
            CALL LENSTR_BL(NAMEF,LEN)
            IF(LEN.GT.60) LEN=60
            WRITE(LINE,'(''Input DENS_file :'',A)') NAMEF(1:LEN)
            CALL MSGDOC(MDoc,LINE)
            CALL MSGDOC(MDoc,'     will convert to: molrep_fob.dat')
            CALL MSGDOC(MDoc,'                      molrep_ph.dat')
C           FOBS    = 'Y'
            FOBS    = 'D'
            MAP     = 'Y'

            IF(LIST.EQ.'L'.OR.LIST.EQ.'T') THEN
              NAMES  = 'molrep_fobs_dns.ps'  
              CALL ADD_PATH(PATH_SCR,NAMES)
              TITLE = '-- MAP for Fobs --'      
              COEF_PS  = 4.0
              NLEV_PS  = 6 
              CALL PRINT_DENS_TO_PS(MDOC,NAMEF,NAMES
     *           ,TITLE,COEF_PS,NLEV_PS,ISYM,IPRSYM,IERR)
              IF(IERR.NE.0) RETURN
            ENDIF

            NAMES   = 'molrep_fob'
            CALL ADD_PATH(PATH_SCR,NAMES)
            NAME_PH = 'molrep_ph'
            CALL ADD_PATH(PATH_SCR,NAME_PH)

C ---
            RS        = RESOL_D
            PST_T     = 'N'
            CSCALE    = 0.0

            ANISO_CORR ='N'
            IF(ANISO.EQ.'C'.OR.ANISO.EQ.'Y') ANISO ='N'

            IF(RMAX.GT.10.0) CSCALE = 10.0/RMAX

c            IF((ABS(DSCALE)    .GT.0.00001.AND.
c     *          ABS(DSCALE-1.0).GT.0.00001     ).OR.
c     *         (ABS(CSCALE)    .GT.0.00001.AND.
c     *          ABS(CSCALE-1.0).GT.0.00001     )) THEN
              RESULT(1,1) = 0.0
              RESULT(2,1) = 0.0
              RESULT(3,1) = 0.0

              RESULT(4,1) = CSCALE

              RESULT(5,1) = 0.0
              RESULT(6,1) = DSCALE
              IERR = 1
c            ELSE
c              IERR = 0
c            ENDIF

c
c           density limit
            IF(DLIM.GT.-1.0E20) THEN
              IERR = IERR + 16
              RESULT(7,1) = DLIM
            ENDIF 
c
c
            MMM   = M
            IF(LIST.EQ.'T') MMM = MDOC

            IF(INVER.EQ.'Y') THEN
              CALL MSGDOC(MDoc,'INFO: Inverted phases will be used')
            ENDIF

            IPOOL_MAX = 0
            CALL RFT_NEW(M,LIST,PATH_SCR
     *      ,RS,INVER,PST_T,SPST
     *      ,NAME,NAMES,NAME_PH,ISYM,IPRSYM,RESULT
     *      ,POOL_SCR,IPOOL_MAX,IERR)
C ---------------------------------------------
c        IERR = 0
c        IF(IAPPL.GT.  0)  IERR = 1
c        IF(P1   .EQ.'Y')  IERR = IERR + 2
C        IF(PACK .EQ.'Y')  IERR = IERR + 4
C        PACK='Y' - 4, P1='Y' - 2 IAPPL>0 - 1
C        IF(ISUM.GT.0) IERR = IERR + 8 (intensity sum)
C        IF(LIM.EQ.'Y')IERR = IERR + 16 (DENSITY limit)
C
C        /IERR/ = 1
C        IAPPL    = 1
C        SHIFT(1) = RESULT(1) 
C        SHIFT(2) = RESULT(2)
C        SHIFT(3) = RESULT(3)
C        CSCALE   = RESULT(4)
C        BSCALE   = RESULT(5)
C        DSCALE   = RESULT(6)
C        /IERR/ = 2 (
C        P1   = 'Y'
C        /IERR/ = 4
C        FPACK = 'Y' 
C
C      RESULT /real RESULT(11)/ - array for output information:
C
C      RESULT(1) - number of refls
C      RESULT(2) - min resolution
C      RESULT(3) - max resolution
C      RESULT(4) - F(0,0,0)
C      RESULT(5) - <!F!> = sqrt(<I>)
C      RESULT(6) - < I > 
C      RESULT(7) = VOL
C      RESULT(8) = VOL_POS
C -I-
C ---------------------------------------------
            IF(IERR.EQ.-1) THEN
              IERR = 0
              RS = 0.0
              CALL RFFT(M,RS
     *          ,NAME,NAMES,NAME_PH,PATH_SCR,ISYM,IPRSYM,RESULT,IERR)
              RESULT(8,1) = 0.0
              RESULT(7,1) = 0.0
            ENDIF
            IF(IERR.NE.0) THEN
              CALL MSGERR(MD,' ERROR: RFT with IN_DENS_FILE')
              IERR_XML     = IERR
              GO TO 900
            ENDIF
            VOL_POS =  RESULT(8,1)
            VOL_MAP =  RESULT(7,1)
C           molrep_fobs molrep_ph
C ---
            CALL LENSTR_BL(NAMES,LEN)
            NAMEF = NAMES(1:LEN)//'.dat'
            INVER = 'N'

            IF(NREFP.GT.0) THEN
              FOBS    = 'Y'
              NAME_PH = ' ' 
              CALL MSGDOC(MDoc,
     *        'WARNING: only Fobs will be used (NREFP # 0)')
            ENDIF

            IF(NSYM.EQ.1) THEN
              PST = 'N'
            ELSE
              MAP = 'N'
            ENDIF

            STICK = 'N'
            IF(STICK_INP.EQ.'Y') STICK = 'Y'

          ENDIF
        ENDIF
      ENDIF
C ----------
C     file of rot. function peaks
      CALL LENSTR_BL(NAME_TAB,LEN)
      IF(LEN.GT.0.AND.NAME_TAB(1:1).NE.','.AND.NAME_TAB(1:1).NE.' ') 
     *  THEN
        NAME = NAME_TAB(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 101
          ENDIF 
        ENDDO
 101    CONTINUE
        NAME_TAB = NAME
      ELSE
c        IF(FUN.NE.'S') THEN
c          NAME_TAB = 'molrep_rf.tab'
c        ELSE
        NAME_TAB = ' '
c        ENDIF
      ENDIF
      CALL LENSTR_BL(NAME_TSRF,LEN)
      IF(LEN.GT.0.AND.NAME_TSRF(1:1).NE.','.AND.NAME_TSRF(1:1).NE.' ') 
     *  THEN
        NAME = NAME_TSRF(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 103
          ENDIF 
        ENDDO
 103    CONTINUE
        NAME_TSRF = NAME
      ELSE
        NAME_TSRF = ' '
      ENDIF
C -----------
      CALL LENSTR_BL(NAME_TAB2,LEN)
      IF(LEN.GT.0.AND.NAME_TAB2(1:1).NE.','.AND.NAME_TAB2(1:1).NE.' ') 
     *  THEN
        NAME = NAME_TAB2(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 102
          ENDIF 
        ENDDO
 102    CONTINUE
        NAME_TAB2 = NAME
      ELSE
        NAME_TAB2 = ' '
      ENDIF
C ---------------
C     model_2 fix
      CALL LENSTR_BL(NAME2,LEN)
      IF(LEN.GT.0.AND.NAME2(1:1).NE.','.AND.NAME2(1:1).NE.' ') THEN
        MOD2 = 'Y'
      ELSE
        MOD2 = 'N'
      ENDIF
C ----------
C     model
      CALL LENSTR_BL(NAMEC,LEN)
      IF(LEN.GT.0.AND.NAMEC(1:1).NE.','.AND.NAMEC(1:1).NE.' ') THEN
        MOD1 = 'Y'
        IF(ABS(NP_SRF).GT.0) TEST_SRF = 'Y'
        IF(NAMEM_2.EQ.NAMEC) THEN
c         IF(DYAD.NE.'D'.AND.DYAD.NE.'M') THEN
          IF(DYAD.NE.'D'.AND.DYAD.NE.'Y') THEN
            DYAD = 'M'
          ENDIF
          NAMEM_2 = ' '
          IF(DYAD.NE.'M') PST = 'N'
        ELSE
          CALL CORR_NAME_ALL(NAMEM_2)
          CALL LENSTR_BL(NAMEM_2,LEN)
          IF(LEN.GT.0.AND.NAMEM_2(1:1).NE.','.AND
     *                  .NAMEM_2(1:1).NE.' ') THEN
            CALL CHECK_COORD_FILE(MDOC,NAMEM_2,LINE,IERR)
            IF(IERR.EQ.0) THEN
              IF(LINE(1:3).EQ.'MAP') THEN
                LINE = ' ERROR: model_M2 cannot be a MAP'
                CALL MSGERR(MD,LINE)
                IERR = 1
              ENDIF
            ENDIF
            IF(IERR.NE.0) THEN
              CALL MSGERR(MD,'ERROR: check model_M2_coord_file')
              IERR_XML     = IERR
              GO TO 900
            ENDIF
            IF(DYAD.NE.'M') PST = 'N'  
c            IF(DYAD.NE.'M') DYAD = 'D'
            IF(DYAD.NE.'D') DYAD = 'M'
          ENDIF
        ENDIF
        CALL LENSTR_BL(NAMEC,LEN)
        NAME = NAMEC(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I) = ' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 110
          ENDIF 
        ENDDO
 110    CONTINUE
        NAMEC = NAME
        CALL LENSTR_BL(NAMEC,LEN)
        LLL = LEN
        IF(LLL.LT.4) LLL=4
        IF(LEN.GT.4.AND.NAMEC(LLL-3:LLL).EQ.'.dat') THEN
          NAMEC   = NAMEC(1:LEN-4) 
          MOD1    = 'D'
          POS     = 'N'
          IMOD    = 1
          CALL CHECK_DENS_FILE(MDOC,LIST,NAMEC,IMOD,INVER1,POS,DSCALE1
     *        ,DRAD,ORIGX,ORIGY,ORIGZ,RMAXM,DENS_RESOL
     *        ,ROLIM,IDZNCS,DRAD_PACK_INP,PATH_SCR
     *        ,RESULT,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            IERR_XML     = IERR
            GO TO 900
          ENDIF
          NMON = 1
          FAST = 'F'
          REF  = 'N'
          DYAD = 'N'
c          PST  = 'N'
          NREFP= 0 
          NREFR= 0 
          REFP = 'N'         
          NMR  = 0
          ANISO_CORR ='N'
          IF(ANISO.EQ.'C'.OR.ANISO.EQ.'Y') ANISO ='N'
        ENDIF

        CALL LENSTR_BL(NAMEC,LEN)
        LEN1 = 1
        IF(LEN.GT.60) LEN1 = LEN - 59
        WRITE(LINE,'(''Input MODEL_file :'',A)') 
     *                         NAMEC(LEN1:LEN)
        CALL MSGDOC(MDoc,LINE)

      ELSE
        MOD1 = 'N'
      ENDIF

      IF(MOD1.EQ.'N'.AND.MOD2.EQ.'Y'.AND.FUN.NE.'D') THEN
        FUN = 'B'
        PST = 'N'
      ENDIF
C -------------
      DER = 'N'
      CALL LENSTR_BL(NAME_DER,LEN)
      IF(LEN.GT.0.AND.NAME_DER(1:1).NE.','.AND.NAME_DER(1:1).NE.' ') 
     *  DER = 'Y'

C -------------

      CELL = 'N'

      IF(PHASE.EQ.'-') THEN
        NAME_PH = ' '
        PHASE   = 'n'
        IF(FOBS.EQ.'D') FOBS = 'Y'
      ENDIF

      CALL LENSTR_BL(NAME_PH,LEN)
      IF((NAME_PH(1:1).NE.','.AND.NAME_PH(1:1).NE.' '.AND.LEN.GT.0)
     *   .OR.(PHASE.NE.'N'.AND.PHASE.NE.'n')) THEN
c        IF(MOD1.EQ.'N'.AND.MOD2.EQ.'N') PRF = 'X'
      ENDIF
 
      IF(MOD1.NE.'N'.OR.MOD2.NE.'N'.OR.FUN.EQ.'S'.OR.PRF.EQ.'X'.OR.
     *   (DIFF.EQ.'H'.AND.FUN.EQ.'T')) THEN 

      ELSE
C
C       self rotation function only
C       start self rotation block
C
        SELF  = 'Y' 
        SURF  = 'N'
c       PST   = 'N'
        FUN   = 'R'
        PHASE = 'N'
        NMR   = 0
        DYAD  = 'N'
        IF(PST.EQ.'Y'.OR.PST.EQ.'A') PST = 'C'
        STICK = 'N'
        MOD1  = 'N'
        MOD2S = 'N'
        MOD2  = 'N'
        NOSPGR = 0
C       
C       can use ANISO,NP,PST,RAD,RESMAX,RESN_T,COMPL,SIM,RESN_SCL
C               BADD,L_MAX,L_MIN  ,CHI,SCALE
C
C       check name of file Fobs
        CALL LENSTR_BL(NAMEF,LEN)
        IF(LEN.GT.0.AND.NAMEF(1:1).NE.','.AND.NAMEF(1:1).NE.' ') THEN
          NAME=NAMEF(1:LEN)
          DO I=LEN,1,-1
            IF(NAME(I:I).EQ.',') THEN
              NAME(I:I)=' '
            ELSE
              IF(NAME(I:I).NE.' ') GO TO 132
            ENDIF 
          ENDDO
 132      CONTINUE
          NAMEF = NAME

          PATH = ' '
          MT   = 10

          CALL LENSTR_BL(NAMEF,LEN)
          LEN1 = 1
          IF(LEN.GT.60) LEN1 = LEN - 59
          WRITE(LINE,'(''Input SF_file    :'',A)') 
     *                             NAMEF(LEN1:LEN)
          CALL MSGDOC(MDoc,LINE)
          CALL LENSTR_BL(NAMEF,LEN)

          LLL = LEN
          IF(LLL.LT.4) LLL=4
          IF(LEN.GT.4.AND.NAMEF(LLL-3:LLL).EQ.'.dat') THEN
C           blanc file Fobs
            NAME = NAMEF(1:LEN-4)
            EXT  = 'dat'
            CALL OPENUR(MT,M,PATH,NAME,EXT,IERR)
            IF(IERR.NE.0) THEN
              CALL MSGERR(MD,' ERROR: can not open INPUT_SF_FILE')
              IERR_XML     = IERR
              GO TO 900
            ENDIF
            CLOSE(MT)
            NAMESF=NAME
          ELSE
C           formatted file
            EXT  = ' '
            CALL OPENFR(MT,M,PATH,NAMEF,EXT,IERR)
            IF(IERR.NE.0) THEN
              CALL MSGERR(MD,' ERROR: can not open INPUT_FOBS_FILE.')
              IERR_XML     = IERR
              GO TO 900
            ENDIF
            CLOSE(MT)

            IF(MTZ.NE.'Y') THEN
C
C             is it CIFile ?
C
              CALL CHECK_CIFILE_IN(MDOC,NAMEF,IERR)
C -----------------------------------------------------------
C     IERR = 0  OK 
C            1  end of file
C            2  reading error
C            3  it is not CIFile
C            4  there is not cell parameters or space group definition
C ------------------------------------------------------------
              IF(IERR.EQ.3) THEN
                CALL MSGERR(MD,
     *  ' ERROR: it is not CIFile (Fobs)')
                IERR_XML     = IERR
                GO TO 900
              ELSE IF(IERR.EQ.4) THEN
                CALL MSGERR(MD,
     *'ERROR: there is not CELL parameters or space group definition in
     *CIFile Fobs')
                IERR_XML     = IERR
                GO TO 900
              ELSE IF(IERR.NE.0) THEN
                ERR_XML     = IERR
                GO TO 900
              ENDIF
            
              MTZ = 'Y'
    
            ENDIF

            NAME   = ' '
            ANOM   = 'N'
            IF(DIFF.EQ.'H'.AND.DER.EQ.'N') ANOM = 'Y'
            IF(FUN .EQ.'D'.AND.DER.EQ.'N') ANOM = 'Y'
            FORM   = 'F'
            CIF    = 'N'
            ATOP   = 0.0
            SD_LIM = 0.0
            RESCRD = 0.0
            NAME1  = ' '
            SETT   = ' '

            NAMESF = 'molrep_fob'
            CALL ADD_PATH(PATH_SCR,NAMESF)

            IF(MTZ.EQ.'Y') THEN

              NAME3 = ' '

            ELSE

C             NAME3 = NAMEM
              NAME3 = ' '
              CALL MSGERR(MDOC,
     *' ATTENTION: Unit cell and space group of Fobs-file must be the sa
     *me as')
              CALL MSGERR(MDOC,
     *'            for model-file')
            ENDIF

C           convert to blanc system

c            CALL MSGDOC(MDOC,'--- read Fobs file. ----')

            CALL TOBLANC(M,NAMEF,NAMESF
     *      ,NAME3,NAME,NAME1,PATH_SCR,RESCRD,FORM,CIF,SETT
     *      ,ANOM,ATOP,SD_LIM,ISYM,IPRSYM,RESULT,IPRROW,IERR)
            IF(IERR.NE.0) THEN
              CALL MSGERR(MD,'   reading input file with Fobs')
              IERR_XML     = IERR
              GO TO 900
            ENDIF
            NRFLS   = RESULT(1,1)
            IF(NRFLS.LE.1) THEN
              CALL MSGERR(MDOC,' ERROR: Fobs: Number of refls =< 1')
              IERR=1
              IERR_XML     = IERR
              GO TO 900
            ENDIF

          ENDIF

          IF(FOBS.NE.'D') FOBS = 'Y'
C         FOBS = 'Y'
                 
          GO TO 800
C
C         end self rotation block
C 
        ELSE

          CALL MSGERR(MD,' ERROR: wrong Fobs file name for self_RF')
          IERR =1
          IERR_XML     = IERR
          GO TO 900

        ENDIF
C
C       self rotation function only
C       end self rotation block
C

      ENDIF

C --------------
C     check name of coord file of model_2 (fixed) 
      CALL LENSTR_BL(NAME2,LEN)
      IF(LEN.GT.0.AND.NAME2(1:1).NE.','.AND.NAME2(1:1).NE.' ') THEN
        NAME = NAME2(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 120
          ENDIF 
        ENDDO
 120    CONTINUE
        NAME2 = NAME

        CALL LENSTR_BL(NAME2,LEN)
        LLL = LEN
        IF(LLL.LT.4) LLL=4
        IF(LEN.GT.4.AND.NAME2(LLL-3:LLL).EQ.'.dat') THEN
          NAME2   = NAME2(1:LEN-4) 
          MOD2    = 'D'
          INVER2  = 'N'
          POS     = 'Y'
          DSCALE2 = 1.0
          IMOD    = 2

C         CHECK_DENS_FILE( 2 )

          NMON = 1
          FAST = 'F'
          REF  = 'N'
          DYAD = 'N'
          PST  = 'N'
          NREFP= 0 
          REFP = 'N'         
        ENDIF

        CALL LENSTR_BL(NAME2,LEN)
        LEN1 = 1
        IF(LEN.GT.60) LEN1 = LEN - 59
        WRITE(LINE,'(''Input MODEL_2(fixed)_file:'',A)') 
     *                                 NAME2(LEN11:LEN)
        CALL MSGDOC(MDoc,LINE)

      ENDIF
C -------------------------------
C     check name of file Fobs
      CALL LENSTR_BL(NAMEF,LEN)
      IF(LEN.GT.0.AND.NAMEF(1:1).NE.','.AND.NAMEF(1:1).NE.' ') THEN
        NAME=NAMEF(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 130
          ENDIF 
        ENDDO
 130    CONTINUE
        NAMEF = NAME

        CALL LENSTR_BL(NAMEF,LEN)
        LEN1 = 1
        IF(LEN.GT.60) LEN1 = LEN - 59
        WRITE(LINE,'(''Input SF_file    :'',A)') 
     *                           NAMEF(LEN1:LEN)
        CALL MSGDOC(MDoc,LINE)

        IF(FOBS.NE.'D') FOBS = 'Y'

      ELSE
        FOBS = 'N'
        IF(MOD1.NE.'Y'.AND.MOD2.NE.'Y') THEN
          CALL MSGERR(MD,' ERROR: wrong Fobs file name')
          IERR =1
          IERR_XML     = IERR
          GO TO 900
        ENDIF
      ENDIF
C ---------------------------
C     model
      IF(MOD1.EQ.'Y') THEN

        CALL LENSTR_BL(NAME_SEQ,LEN)
        IF(LEN.GT.0.AND.NAME_SEQ(1:1).NE.','.AND.
     *         NAME_SEQ(1:1).NE.' '.AND.DB.NE.'Y'.AND.NMR.EQ.0) THEN

          CALL CHECK_SEQ_FILE(MDOC,NAME_SEQ,LINE,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MD,'ERROR: check sequence_file')
            IERR_XML     = IERR
            GO TO 900
          ENDIF

          MMM = -ABS(MDOC)-1
          IF(LIST.EQ.'L'.OR.LIST.EQ.'T') MMM = MDOC
          IF(FOBS.EQ.'N'.AND.MOD2.EQ.'N') MMM = MDOC

          NAME    = NAMEC
          NAME1   = 'align.pdb '
          CALL ADD_PATH(PATH_OUT,NAME1)

          CALL BALBES_ALIGN(MDOC,NAME_SEQ,NAMEC,NAME1
     *    ,PATH_SCR,PATH_OUT
     *    ,RESULT,IPRROW,ISYM,IPRSYM,IERR)

C         RESULT(1) = Nac 1
C         RESULT(2) = Nac 2
C         RESULT(3) = NN aligned
C         RESULT(4) = NHOM identical
C         RESULT(5) = HOM  identity
C         RESULT(6) = SUM_SCORE 
C
          IF(IERR.NE.0) THEN
            CALL MSGERR(MD,'ERROR: in subroutine ALIGN')
            IERR_XML     = IERR
            GO TO 900
          ENDIF
          WRITE(LINE,
     *    '(''     Alignement: identity = '',F8.2)') RESULT(5,1)
          CALL MSGDOC(MDOC,LINE)

          IF(SEQ.EQ.'D') THEN
            IF(RESULT(5,1).LT.FIDENT_LIMIT) THEN
              SEQ = 'N'
            ELSE
              SEQ = 'Y'
            ENDIF
          ENDIF

          IF(FOBS.EQ.'N'.AND.MOD2.EQ.'N') THEN
            CALL MSGDOC(MDOC,
     *      '--- only correction by alignement ---')
            CALL MSGDOC(MDOC,
     *      '    output file: align.pdb')
            GO TO 900
          ENDIF
          IF(SEQ.EQ.'N') THEN
            NAMEC = NAME
            IF(QUAL.LT.0.0001.AND.ABS(BADD).LT.0.1) THEN
              CALL MSGDOC(MDOC,
     *'-- identity will be used as similarity without model corr.--')
              QUAL = RESULT(5,1)/100.0
            ENDIF  
          ELSE
            CALL MSGDOC(MDOC,
     *      '--- model was corrected by alignement ---')
            CALL MSGDOC(MDOC,
     *      '    output file: align.pdb')

            NAMEC = NAME1
            IF(QUAL.LT.0.0001.AND.ABS(BADD).LT.0.1) 
     *      QUAL = RESULT(5,1)/100.0
          ENDIF
        ENDIF

        PDB      = 'Y'
        CALL LENSTR_BL(NAMEC,LEN)
        LLL = LEN
        IF(LLL.LT.4) LLL=4
        IF(LEN.GT.4.AND.NAMEC(LLL-3:LLL).EQ.'.crd') THEN
          PDB   = 'N'
          NAMEM = NAMEC(1:LEN-4)
        ENDIF
        IF(PDB.EQ.'Y') THEN
          PATH = ' '
          EXT  = ' '
          MT   = 10
          CALL OPENFR(MT,M,PATH,NAMEC,EXT,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MD,' ERROR: can not open INPUT_COORD_FILE')
            IERR_XML     = IERR
            GO TO 900
          ENDIF
          CLOSE(MT)
          IERR = MODEL
          CALL READPDB(M,NAMEC,PATH_SCR,ISYM,IPRSYM
     *      ,STR_TITLE,STR_DATE,RESULT,IPRROW,CHAIN,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,' ERROR: read PDB_file of coords')
            IERR_XML     = IERR
            GO TO 900
          ENDIF
          NATOMS = RESULT(2,1)
          IF(NATOMS.LT.1) THEN
            CALL MSGERR(MDOC,' ERROR: Number of atoms = 0')
            CALL MSGERR(MDOC,'        maybe all atoms are H2O')
            IERR=1
            IERR_XML     = IERR
            GO TO 900
          ENDIF
          NAMEM = NAMEC
        ENDIF
        PDB_MOD = PDB
      ELSE IF(MOD1.EQ.'D') THEN
        NAMEM = NAMEC
      ELSE 
        NAMEM = ' '
      ENDIF     
C ------------------------
C     model_2
      IF(MOD2.EQ.'Y') THEN     
        PDB = 'Y'
        CALL LENSTR_BL(NAME2,LEN)
        LLL = LEN
        IF(LLL.LT.4) LLL=4
        IF(LEN.GT.4.AND.NAME2(LLL-3:LLL).EQ.'.crd') THEN
          PDB   = 'N'
          NAMEM2 = NAME2(1:LEN-4)
        ENDIF
        CALL LENSTR_BL(NAME2,LEN)
        IF(PDB.EQ.'Y') THEN
          PATH = ' '
          EXT  = ' '
          MT   = 10
          CALL OPENFR(MT,M,PATH,NAME2,EXT,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MD,' ERROR: can not open INPUT_COORD_FILE_2')
            IERR_XML     = IERR
            GO TO 900
          ENDIF
          CLOSE(MT)
          IERR  = 0
          CHAIN = ' '
          CALL READPDB(M,NAME2,PATH_SCR,ISYM,IPRSYM
     *      ,STR_TITLE,STR_DATE,RESULT,IPRROW,CHAIN,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,' ERROR: read PDB_file_2 of coords')
            IERR_XML     = IERR
            GO TO 900
          ENDIF
          NATOMS = RESULT(2,1)
          IF(NATOMS.LT.1) THEN
            CALL MSGERR(MDOC,' ERROR: Number of atoms (file_2) = 0')
            CALL MSGERR(MDOC,'        maybe all atoms are H2O')
            IERR = 1
            IERR_XML     = IERR
            GO TO 900
          ENDIF
          NAMEM2 = NAME2
        ENDIF
        IF(FUN.EQ.'B') PDB_MOD = PDB
        VOL_M2 = 0.0 
      ELSE IF(MOD1.NE.'D') THEN
        NAMEM2 = ' '
        VOL_M2 = 0.0 
      ENDIF
C --
C ------------------------
C     model_(for_search)_2
      MOD2S = 'N'
      CALL LENSTR_BL(NAMEM_2,LEN)
      IF(LEN.GT.0.AND.NAMEM_2(1:1).NE.','.AND.NAMEM_2(1:1).NE.' ') THEN

        MOD2S = 'Y'

        NAME=NAMEM_2(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 133
          ENDIF 
        ENDDO
 133    CONTINUE
        NAMEM_2 = NAME

        CALL LENSTR_BL(NAMEM_2,LEN)
        LEN1 = 1
        IF(LEN.GT.60) LEN1 = LEN - 59
        WRITE(LINE,'(''Input MODEL2_file:'',A)') 
     *                           NAMEM_2(LEN1:LEN)
        CALL MSGDOC(MDOC,LINE)
c --
c -----     alignment
            CALL LENSTR_BL(NAME_SEQ2,LEN)
            IF(LEN.GT.0.AND.NAME_SEQ2(1:1).NE.','.AND.
     *                      NAME_SEQ2(1:1).NE.' '.AND.
     *                      NMR.EQ.0.AND.SEQ.NE.'N') THEN

              CALL CHECK_SEQ_FILE(MDOC,NAME_SEQ2,LINE,IERR)
              IF(IERR.NE.0) THEN
                CALL MSGERR(MD,'ERROR: check sequence2_file')
                IERR_XML     = IERR
                GO TO 900
              ENDIF
              MMM = -ABS(MDOC)-1
              IF(LIST.EQ.'L'.OR.LIST.EQ.'T') MMM = MDOC

              NAME    = NAMEM_2
              NAME1   = 'align2.pdb'
              CALL ADD_PATH(PATH_OUT,NAME1)

              CALL BALBES_ALIGN(MMM,NAME_SEQ2,NAMEM_2,NAME1
     *        ,PATH_SCR,PATH_OUT
     *        ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C
C              RESULT(1) = Nac 1
C              RESULT(2) = Nac 2
C              RESULT(3) = NN aligned
C              RESULT(4) = NHOM identical
C              RESULT(5) = HOM  identity
C              RESULT(6) = SUM_SCORE 
C
              IF(IERR.NE.0) THEN
                CALL MSGERR(MD,'ERROR: in subroutine ALIGN2')
                IERR_XML     = IERR
                GO TO 900
              ENDIF
              WRITE(LINE,
     *    '(''     Alignement2: identity = '',F8.2)') RESULT(5,1)
              CALL MSGDOC(MDOC,LINE)

C              IF(SEQ.EQ.'D') THEN
C                IF(RESULT(5,1).LT.FIDENT_LIMIT) THEN
C                  SEQ = 'N'
C                ELSE
C                  SEQ = 'Y'
C                ENDIF
C              ENDIF
C              IF(FOBS.EQ.'N'.AND.MOD2.EQ.'N') THEN
C                CALL MSGDOC(MDOC,
C     *      '--- only correction by alignement ---')
C                CALL MSGDOC(MDOC,
C     *      '     output file: align.pdb')
C                GO TO 900
C              ENDIF
              IF(SEQ.EQ.'N') THEN
                NAMEM_2 = NAME
c                IF(QUAL.LT.0.0001) THEN
c                  CALL MSGDOC(MDOC,
c     *'-- identity will be used as similarity without model corr.--')
c                  QUAL = RESULT(5,1)/100.0
c                ENDIF  
              ELSE
                CALL MSGDOC(MDOC,
     *           '--- model_M2 was corrected by alignement ---')
                CALL MSGDOC(MDOC,
     *      '    output file: align2.pdb')
                NAMEM_2 = NAME1
C                IF(QUAL.LT.0.0001) QUAL = RESULT(5,1)/100.0
              ENDIF

            ENDIF

c --
        PDB = 'Y'
        CALL LENSTR_BL(NAMEM_2,LEN)
        LLL = LEN
        IF(LLL.LT.4) LLL=4
        IF(LEN.GT.4.AND.NAMEM_2(LLL-3:LLL).EQ.'.crd') THEN
          PDB   = 'N'
          NAMEM_2 = NAMEM_2(1:LEN-4)
        ENDIF
        CALL LENSTR_BL(NAMEM_2,LEN)
        IF(PDB.EQ.'Y') THEN
          PATH = ' '
          EXT  = ' '
          MT   = 10
          CALL OPENFR(MT,M,PATH,NAMEM_2,EXT,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MD,' ERROR: can not open INPUT_COORD_FILE_M2')
            IERR_XML     = IERR
            GO TO 900
          ENDIF
          CLOSE(MT)
          IERR  = 0
          CHAIN = ' '
          CALL READPDB(M,NAMEM_2,PATH_SCR,ISYM,IPRSYM
     *      ,STR_TITLE,STR_DATE,RESULT,IPRROW,CHAIN,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,' ERROR: read PDB_file_M2 of coords')
            IERR_XML     = IERR
            GO TO 900
          ENDIF
          NATOMS = RESULT(2,1)
          IF(NATOMS.LT.1) THEN
            CALL MSGERR(MDOC,' ERROR: Number of atoms (file_M2) = 0')
            CALL MSGERR(MDOC,'        maybe all atoms are H2O')
            IERR = 1
            IERR_XML     = IERR
            GO TO 900
          ENDIF
        ENDIF
        IF(DYAD.EQ.'Y') DYAD = 'D'
        IF(FOBS.EQ.'N') THEN
          CALL MSGERR(MD,' ERROR: wrong Fobs file name')
          IERR =1
          IERR_XML     = IERR
          GO TO 900
        ENDIF
      ELSE
        NAMEM_2 = ' '
      ENDIF
C -----

      IF(FOBS.EQ.'N') GO TO 800
C ----------------
C     Fobs   
      CALL LENSTR_BL(NAMEF,LEN)
      LLL = LEN
      IF(LLL.LT.4) LLL=4
      IF(LEN.GT.4.AND.NAMEF(LLL-3:LLL).EQ.'.dat') THEN
        NAME = NAMEF(1:LEN-4)
        PATH = ' '
        EXT  = 'dat'
        MT   = 10
        CALL OPENUR(MT,M,PATH,NAME,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MD,' ERROR: can not open file Fobs')
          IERR_XML     = IERR
          GO TO 900
        ENDIF
        CLOSE(MT)
        NAMESF=NAME
            
        MTZ='Y'

      ELSE

        PATH = ' '
        EXT  = ' '
        MT   = 10
        CALL OPENFR(MT,M,PATH,NAMEF,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MD,' ERROR: can not open Fobs file')
          IERR_XML     = IERR
          GO TO 900
        ENDIF
        CLOSE(MT)

        NAME   = ' '
        ANOM   = 'N'
        IF(DIFF.EQ.'H'.AND.DER.EQ.'N') ANOM = 'Y'
        IF(FUN .EQ.'D'.AND.DER.EQ.'N') ANOM = 'Y'
        FORM   = 'F'
        CIF    = 'N'
        ATOP   = 0.0
        SD_LIM = 0.0
        RESCRD = 0.0
        NAME1  = ' '
        SETT   = ' '

        NAMESF = 'molrep_fob'
        CALL ADD_PATH(PATH_SCR,NAMESF)

        NAME3  = ' '

        IF(MTZ.NE.'Y') THEN
C
C         is it CIFile ?
C
          CALL CHECK_CIFILE_IN(MDOC,NAMEF,IERR)
C -----------------------------------------------------------
C     IERR = 0  OK 
C            1  end of file
C            2  reading error
C            3  it is not CIFile
C            4  there is not cell parameters or space group definition
C ------------------------------------------------------------
          IF(IERR.EQ.3) THEN
C            CALL MSGERR(MD,
C     *  ' ERROR: it is not CIFfile (Fobs)')
C            GO TO 900
          ELSE IF(IERR.EQ.4) THEN
            CALL MSGERR(MD,
     *'ERROR: there is not CELL parameters or space group definition in
     * CIFile Fobs')
            IERR = 31
            IERR_XML     = IERR
            GO TO 900
          ELSE IF(IERR.NE.0) THEN
            IERR_XML     = IERR
            GO TO 900
          ELSE
            
            MTZ='Y'
    
          ENDIF

          IERR = 0

        ENDIF
C ---
        IF(MTZ.NE.'Y') THEN

          IF(MOD1.EQ.'Y') THEN
            NAME3=NAMEM
          ELSE IF(MOD2.EQ.'Y') THEN
            NAME3=NAMEM2
          ELSE
            NAME3=' '
          ENDIF

          CALL MSGERR(MDOC,
     *' ATTENTION: Unit cell and space group of Fobs-file must be the sa
     *me')
          CALL MSGERR(MDOC,
     *' INFO: Unit cell and space group of Fobs-file must be the same')
          CALL MSGERR(MDOC,
     *'            as for model-file (for unknown structure)')
          CALL MSGERR(MDOC,
     *'            cell and space group will be taken from model file')
        ENDIF

c       CALL MSGDOC(MDOC,'--- read Fobs file ..---')

        CALL TOBLANC(M,NAMEF,NAMESF
     *  ,NAME3,NAME,NAME1,PATH_SCR,RESCRD,FORM,CIF,SETT
     *  ,ANOM,ATOP,SD_LIM,ISYM,IPRSYM,RESULT,IPRROW,IERR)
        IF(IERR.NE.0) THEN
           CALL MSGERR(MD,' ERROR: reading input file with Fobs')
           IERR_XML     = IERR
           GO TO 900
        ENDIF

        NRFLS   = RESULT(1,1)
        IF(NRFLS.LE.1) THEN
          CALL MSGERR(MDOC,' ERROR: Fobs: Number of refls =< 1')
          IERR=1
          IERR_XML     = IERR
          GO TO 900
        ENDIF

C        CALL LENSTR_BL(NAME_PH,LEN)
C        IF(NAME_PH(1:1).EQ.','.OR.NAME_PH(1:1).EQ.' ') LEN = 0

C        IF((INVER.EQ.'N'.OR.INVER.EQ.'Y').AND.LEN.EQ.0) THEN

        IF(PHASE.EQ.'Y') THEN

          CALL MSGDOC(MDOC,'--- read Phases ---')
          FORM    = 'P'

          NAME_PH = 'molrp_ph'
          CALL ADD_PATH(PATH_SCR,NAME_PH)

          CALL TOBLANC(M,NAMEF,NAME_PH
     *    ,NAME3,NAME,NAME1,PATH_SCR,RESCRD,FORM,CIF,SETT
     *    ,ANOM,ATOP,SD_LIM,ISYM,IPRSYM,RESULT,IPRROW,IERR)
          IF(IERR.NE.0) THEN
             CALL MSGERR(MD,' ERROR: reading input file with Phases')
             GO TO 900
          ENDIF
          NRFLS   = RESULT(1,1)
          IF(NRFLS.LE.1) THEN
            CALL MSGERR(MDOC,' ERROR: Phases: Number of refls =< 1')
            IERR=1
            GO TO 900
          ENDIF

        ENDIF

      ENDIF
C -------------------------------
C     check name of file of phases
      CALL LENSTR_BL(NAME_PH,LEN)
      IF(LEN.GT.0.AND.NAME_PH(1:1).NE.','.AND.NAME_PH(1:1).NE.' '.AND.
     *                NAME_PH(1:1).NE.'+'.AND.NAME_PH(1:1).NE.'-') THEN
        CALL CORR_NAME_BL(NAME_PH)
        CALL LENSTR_BL(NAME_PH,LEN)
        LEN1 = 1
        IF(LEN.GT.60) LEN1 = LEN - 59
        WRITE(LINE,'(''Sol_ infile of ph:'',A)') 
     *                          NAME_PH(LEN1:LEN)
        CALL MSGDOC(MD,LINE)
        PHASE = 'Y'
        DYAD  = 'N'
C       LH    = 'N'
        IF(NMR.GT.1) NMR = 0

        IF(INVER.EQ.'Y') THEN
          THRESH  = 0.0
          TOP     = 0.0
          COEF    = 0.0
          BTEMP   = 0.0 
          SCALER  = 0.0 
          RESMINR = 0.0 
          RESMAXR = 0.0 
          IZMINR  = 0 
          IZMAXR  = 0 
          INVER   = 'I' 
          TTT     = ' '
          NAME    = ' '

          CALL MSGDOC(MDoc,'INFO: Inverted phases will be used')

          NAME1   = 'molrep_ph1'
          CALL ADD_PATH(PATH_SCR,NAME1)
          
          CALL COPYFL(M,NAME_PH,NAME,NAME1,THRESH,TOP,COEF,BTEMP
     *           ,SCALER,RESMINR,RESMAXR,IZMINR,IZMAXR,INVER,TTT
     *           ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900               
          INVER   = 'N'
          NAME_PH = NAME1
        ENDIF

      ELSE
        PRF     = 'N'
        IF(PHASE.EQ.'Y') PHASE  = 'N'
        NAME_PH = ' '
      ENDIF
C ---      
      IF(MOD1.EQ.'Y') THEN
        EXT = 'crd'
        MT  = 10
        CALL OPENFR(MT,M,PATH,NAMEM,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MD,' ERROR: can not open input file of model')
          GO TO 900
        ENDIF
        CLOSE(MT)
      ENDIF
C ---
      IF(MOD2.EQ.'Y') THEN
        MT  = 10
        EXT = 'crd'
        CALL OPENFR(MT,M,PATH,NAMEM2,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MD,' ERROR: can not open input file of model_2')
          GO TO 900
        ENDIF
        CLOSE(MT)
      ENDIF
C ----
C --------------------------------------------------------------
C --- check cell parameters and space group name ---
C
C     -- FOBS --
C     change space group

      CALL LENSTR_BL(SPGR_INP,LEN)
      IF(LEN.GT.0) THEN
        IMODE = 1
        CALL CHECK_LINE(IMODE,SPGR_INP)  
        NOSPGR = 0
      ENDIF
      IF(NOSPGR.GT.0.OR.(LEN.GT.0.AND.SPGR_INP(1:3).NE.'ALL')) THEN
        ISETT   = 0
        NSG     = 0
        NSYMLIB = 0 

        NAMESF_INP = NAMESF
        NAME =  'molrep_fobs_new'
        CALL ADD_PATH(PATH_OUT,NAME)

        CALL CHANGE_GROUP(MDOC,NAMESF,NAME,NOSPGR
     *           ,SPGR_INP,NSG,ISETT,NSYMLIB
     *           ,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.EQ.-2) THEN
          IERR = 0
          CALL MSGERR(MD,
     *    ' WARNING: for keyword NOSG: the same group, no change')
          CALL SEARCH_ALT_SYMM_GROUP(MDOC,NSYM,ISYM,IPRSYM
     *    ,NSG,ISETT,NSG_CHECK,ISG_CHECK,SG_CHECK,IERR)
          IERR = 0      
        ELSE IF(IERR.NE.0) THEN
          CALL MSGERR(MD,
     *    ' WARNING:  for keyword NOSG: can not change space group')
          IERR = 0
        ELSE
          CALL LENSTR_BL(SPGR_INP,L)
          WRITE(LINE,
     *'('' INFO: space group was changed to No ='',I5,'' Sett =''
     *    ,I5,3X,A)')
     *    NOSPGR,ISETT,SPGR_INP(1:L)
          CALL MSGERR(MDOC,LINE)
          WRITE(LINE,'(33X,''No in symlib ='',I5)')
     *    NSYMLIB
          CALL MSGERR(MDOC,LINE)
          NAMESF =  NAME
c          CALL SEARCH_ALT_SYMM_GROUP(MDOC,NSYM,ISYM,IPRSYM
c     *    ,NOSPGR,ISETT,NSG_CHECK,ISG_CHECK,IERR)
          CALL SEARCH_ALT_SYMM_GROUP(MDOC,NSYM,ISYM,IPRSYM
     *    ,NSG,ISETT,NSG_CHECK,ISG_CHECK,SG_CHECK,IERR)
          IERR = 0      
        ENDIF
      ELSE IF(NOSPGR.LT.0.OR.
     *        (LEN.GT.0.AND.SPGR_INP(1:3).EQ.'ALL')) THEN
        CALL MSGDOC(MDOC,' ')
        CALL MSGDOC(MDOC,' --- Space Group Checking ---')
        JOB_XML = 'MR_SG_checking'
        NAMESF_INP = NAMESF
        NAME = ' '
        CALL CHANGE_GROUP(MDOC,NAMESF,NAME,NOSPGR
     *           ,SPGR_INP,NSG,ISETT,NSYMLIB
     *           ,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: for NOSG < 0.')
          IERR_XML     = 1
          MESSAGE_XML  = ' '  
          GO TO 900
        ENDIF

        CALL LENSTR_BL(SPGR_INP,L)
        WRITE(LINE,
     *'('' INFO: Fobs space group No ='',I5,'' Sett ='',I5,3X,A)')
     *  NSG,ISETT,SPGR_INP(1:L)
        CALL MSGERR(MDOC,LINE)
        WRITE(LINE,'(23X,''No in symlib ='',I5)')
     *  NSYMLIB
        CALL MSGERR(MDOC,LINE)

        SPGR_INP = 'ALL'

        CALL SEARCH_ALT_SYMM_GROUP(MDOC,NSYM,ISYM,IPRSYM
     *    ,NSG,ISETT,NSG_CHECK,ISG_CHECK,SG_CHECK,IERR)
        IERR = 0      
        IF(NSG_CHECK.LE.1) THEN
          CALL MSGERR(MDOC,
     *    ' ERROR: for NOSG: no space group need to check.')
          IERR = 1
          IERR_XML     = 2
          MESSAGE_XML  = 'no space group need to check'  
          GO TO 900
        ENDIF
        NMR  = 0
        DYAD = 'N'
      ENDIF
C
C
      IERR  = 0
      MTN   = 10
      ITYPE = 'FF  '
      CALL ORFILE(M,MTN,NAMESF,ITYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: can not open file Fobs..')
        RETURN
      ENDIF

      CALL C_RD_CR
      CALL GET_CELL(RLATT_F,CODE,NAME,DATE,TTT
     *   ,NSPGROUP_F,NOSETT_F,SPGR_F,NSM,IERR)

      CLOSE(MTN)

      IF(MOD1.EQ.'Y') THEN
C       -- Model --
        MTN=10
        CALL ORCRD(M,MTN,NAMEM,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: can not open file of model.')
          RETURN
        ENDIF
        CALL C_AT_CR
        CALL GET_CELL(RLATT_C,CODE,NAME,DATE,TTT
     *     ,NSPGROUP_C,NOSETT_C,SPGR_C,NSM,IERR)

        CLOSE(MTN)

        IF(NSPGROUP_F.NE.NSPGROUP_C.OR.NOSETT_F.NE.NOSETT_C) THEN
          IF(MTZ.EQ.'N') THEN
            CALL MSGERR(MDOC,
     * ' ERROR: Fobs and Model have different space group or setting')
            WRITE(LINE,'(''        Fobs:'',I6,'' Model:'',I6)')
     *      NSPGROUP_F,NSPGROUP_C
            CALL MSGERR(MDOC,LINE)
            WRITE(LINE,'(''        Fobs:'',I6,'' Model:'',I6)')
     *      NOSETT_F,NOSETT_C
            CALL MSGERR(MDOC,LINE)
            WRITE(LINE,'(''        Fobs:'',A,'' Model:'',A)')
     *      SPGR_F,SPGR_C
            CALL MSGERR(MDOC,LINE)
            IERR=1
            RETURN
          ELSE
            CALL MSGDOC(MD,
     *' INFO: Fobs and Model have different space group or setting')
            CALL MSGDOC(MD,
     *'       program will use the space group and cell from Fobs file')
            CALL CHANGE_CELL(MDOC,NAMEM,PATH_SCR,RLATT_F,SPGR_F
     *                                  ,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900
            GO TO 200
          ENDIF
        ENDIF

        DO I=1,6
          T = ABS(RLATT_F(I)-RLATT_C(I))
          IF(T.GT.0.5) THEN
            IF(MTZ.EQ.'N') THEN
              CALL MSGERR(MDOC,
     *      ' ERROR: Fobs and Model have different CELL')
              IERR=1
              RETURN
            ELSE
              LINE = ' INFO: Fobs and Model have different CELL,'//
     *               ' Fobs CELL will be used'
              CALL MSGDOC(MD,LINE)
            ENDIF
            CALL CHANGE_CELL(MDOC,NAMEM,PATH_SCR,RLATT_F,SPGR_F
     *                                  ,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900
            GO TO 200 
          ENDIF
        ENDDO

        CALL CHANGE_CELL(MDOC,NAMEM,PATH_SCR,RLATT_F,SPGR_F
     *                                  ,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900

      ENDIF

 200  CONTINUE
C     -- Model_2  fix --

      IF(MOD2.EQ.'Y') THEN

        MTN=10
        CALL ORCRD(M,MTN,NAMEM2,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: can not open file of model_2.')
          RETURN
        ENDIF
        CALL C_AT_CR
        CALL GET_CELL(RLATT_C,CODE,NAME,DATE,TTT
     *   ,NSPGROUP_C,NOSETT_C,SPGR_C,NSM,IERR)

        CLOSE(MTN)

        IF(NSPGROUP_F.NE.NSPGROUP_C.OR.NOSETT_F.NE.NOSETT_C) THEN
          IF(MTZ.EQ.'N') THEN
            CALL MSGERR(MDOC,
     *' ERROR: Fobs and Model-2 have different space group or setting')
            WRITE(LINE,'(''        Fobs:'',I6,'' Model:'',I6)')
     *      NSPGROUP_F,NSPGROUP_C
            CALL MSGERR(MDOC,LINE)
            WRITE(LINE,'(''        Fobs:'',I6,'' Model:'',I6)')
     *      NOSETT_F,NOSETT_C
            CALL MSGERR(MDOC,LINE)
            WRITE(LINE,'(''        Fobs:'',A,'' Model:'',A)')
     *      SPGR_F,SPGR_C
            CALL MSGERR(MDOC,LINE)
            IERR = 1  
            RETURN
          ELSE
            CALL MSGDOC(MD,
     *' INFO: Fobs and Model-2 have different space group or setting')
            CALL MSGDOC(MD,
     *'       program will use the space group and cell from Fobs file')

          ENDIF
          CALL CHANGE_CELL(MDOC,NAMEM2,PATH_SCR,RLATT_F,SPGR_F
     *                                  ,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
          GO TO 800
        ENDIF

        DO I=1,6
          T=ABS(RLATT_F(I)-RLATT_C(I))
          IF(T.GT.0.5) THEN
            IF(MTZ.EQ.'N') THEN
              CALL MSGERR(MDOC,
     *      ' ERROR: Fobs and Model-2 have different CELL')
              IERR=1
              RETURN
            ELSE
              LINE = ' INFO: Fobs and Model-2 have different CELL,'//
     *               ' Fobs CELL will be used'
              CALL MSGDOC(MD,LINE)
            ENDIF
            CALL CHANGE_CELL(MDOC,NAMEM2,PATH_SCR,RLATT_F,SPGR_F
     *                                  ,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900
            GO TO 800 
          ENDIF
        ENDDO

        CALL CHANGE_CELL(MDOC,NAMEM2,PATH_SCR,RLATT_F,SPGR_F
     *                                  ,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
   
      ENDIF

 800  CONTINUE
C ==============
C     check name of file derivative
      CALL LENSTR_BL(NAME_DER,LEN)
      IF(LEN.GT.0.AND.NAME_DER(1:1).NE.','.AND.
     *                NAME_DER(1:1).NE.' ') THEN
        NAME=NAME_DER(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 135
          ENDIF 
        ENDDO
 135    CONTINUE
        NAME_DER = NAME

        PATH = ' '
        MT   = 10

        CALL LENSTR_BL(NAME_DER,LEN)
        IF(LEN.GT.60) LEN=60
        WRITE(LINE,'(''Sol_ in_file_der :'',A)') NAME_DER(1:LEN)
        CALL MSGDOC(MDD,LINE)
        CALL LENSTR_BL(NAME_DER,LEN)

        LLL = LEN
        IF(LLL.LT.4) LLL=4
        IF(LEN.GT.4.AND.NAME_DER(LLL-3:LLL).EQ.'.dat') THEN
C         blanc file Fobs
          NAME = NAME_DER(1:LEN-4)
          EXT  = 'dat'
          CALL OPENUR(MT,M,PATH,NAME,EXT,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MD,' ERROR: can not open INPUT_FILE_DER')
            GO TO 900
          ENDIF
          CLOSE(MT)
          NAME_DER=NAME
        ELSE
C         formatted file
          EXT = ' '
          CALL OPENFR(MT,M,PATH,NAME_DER,EXT,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MD,' ERROR: can not open INPUT_DER_FILE.')
            GO TO 900
          ENDIF
          CLOSE(MT)

C            IF(MTZ.NE.'Y') THEN
C
C             is it CIFile ?
C
            CALL CHECK_CIFILE_IN(MDOC,NAME_DER,IERR)
C -----------------------------------------------------------
C     IERR = 0  OK 
C            1  end of file
C            2  reading error
C            3  it is not CIFile
C            4  there is not cell parameters or space group definition
C ------------------------------------------------------------
            IF(IERR.EQ.3) THEN
              CALL MSGERR(MD,
     *  ' ERROR: it is not CIFile (F_der)')
              GO TO 900
            ELSE IF(IERR.EQ.4) THEN
              CALL MSGERR(MD,
     *'ERROR: there is not CELL parameters or space group definition in
     *CIFile Fder')
              GO TO 900
            ELSE IF(IERR.NE.0) THEN
              GO TO 900
            ENDIF
            
C              MTZ = 'Y'
    
C            ENDIF

          NAME   = ' '
          ANOM   = 'N'
C         IF(DIFF.EQ.'H'.AND.DER.EQ.'N') ANOM = 'Y'
          FORM   = 'C'
          CIF    = 'N'
          ATOP   = 0.0
          SD_LIM = 0.0
          RESCRD = 0.0
          NAME1  = ' '
          SETT   = ' '

          NAMES = 'molrp_fder'
          CALL ADD_PATH(PATH_SCR,NAMES)

          NAME3 = ' '

C         convert to blanc system

          CALL MSGDOC(MDOC,'--- read Fder file ----')
          CALL TOBLANC(M,NAME_DER,NAMES
     *      ,NAME3,NAME,NAME1,PATH_SCR,RESCRD,FORM,CIF,SETT
     *      ,ANOM,ATOP,SD_LIM,ISYM,IPRSYM,RESULT,IPRROW,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MD,'   reading input file with Fder')
            GO TO 900
          ENDIF
          NRFLS   = RESULT(1,1)
          IF(NRFLS.LE.1) THEN
            CALL MSGERR(MDOC,' ERROR: Fder: Number of refls =< 1')
            IERR=1
            GO TO 900
          ENDIF
          NAME_DER = NAMES 
        ENDIF
      ENDIF
C ==============
      IF(MOD2S.EQ.'Y') THEN
C       -- Model_M2 (for searching) --

        MTN=10
        CALL ORCRD(M,MTN,NAMEM_2,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: can not open file of model.')
          RETURN
        ENDIF
        CALL C_AT_CR
        CALL GET_CELL(RLATT_C,CODE,NAME,DATE,TTT
     *     ,NSPGROUP_C,NOSETT_C,SPGR_C,NSM,IERR)
        CLOSE(MTN)

       
        IF(NSPGROUP_F.NE.NSPGROUP_C.OR.NOSETT_F.NE.NOSETT_C) THEN
          CALL MSGDOC(MD,
     *' INFO: Fobs and Model_M2 have different space group/setting')
          CALL MSGDOC(MD,
     * '      program will use the space group and cell from Fobs file')
          CALL CHANGE_CELL(MDOC,NAMEM_2,PATH_SCR,RLATT_F,SPGR_F
     *                                  ,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
          GO TO 210
        ENDIF

        DO I=1,6
          T = ABS(RLATT_F(I)-RLATT_C(I))
          IF(T.GT.0.5) THEN
            LINE = ' INFO: Fobs and Model_M2 have different CELL,'//
     *             ' Fobs CELL will be used'
            CALL MSGDOC(MD,LINE)
          ENDIF
          CALL CHANGE_CELL(MDOC,NAMEM_2,PATH_SCR,RLATT_F,SPGR_F
     *                                  ,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
          GO TO 210 
        ENDDO

        CALL CHANGE_CELL(MDOC,NAMEM_2,PATH_SCR,RLATT_F,SPGR_F
     *                                  ,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900

      ENDIF

 210  CONTINUE

      FIT = 'N'

      IF(FOBS.EQ.'N'.AND.MOD2.EQ.'Y') THEN

        IF(SURF.EQ.'N') THEN
          SURF  = 'O'
          SURFX = 'N'
        ENDIF

        IF(RESX.LE.0.0001) RESX = 3.0

        CALL PREFOBS(M,NAMEM,NAMEM2,NAMESF,NAME_PH,NAMEC
     * ,PATH_SCR,RESX,RESN_SCL,SH_MOD2,SURF,BLIM,NA_TOT
     * ,SH_O_TO_CELL,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900       
c
        IF(NREF.GT.0) THEN
          FUN    = 'B'
          MOD1   = 'N'
          MOD2   = 'Y'
          LH     = 'N'
          PST    = 'N'
          FIT    = 'B'
          FOBS   = 'Y'
          PHASE  = 'Y'

C         PHASE  = 'N'
c         NAME_PH = ' '

          INVER  = 'N'
          NAMEM2 = NAMEC
          NAMEM  = ' '

          CALL SHIFT_MOD1_TO_MOD2(M,NAMEM2,PATH_SCR
     *         ,SH_O_TO_CELL,SH_MOD2,RESULT,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900       

        ELSE
          NAMEM  = NAMEC
          NAMEM2 = ' '
          FIT    = 'Y'
          LH     = 'N'
          ANISO_CORR ='N'
          IF(ANISO.EQ.'C'.OR.ANISO.EQ.'Y') ANISO ='N'

          CALL MSGDOC(MDOC,' ')
          CALL MSGDOC(MDOC,
     *'INFO:  model_2 was shifted to new origin of coordinate system')
          WRITE(LINE,'(''       shift vector   :'',3F8.2)') 
     *    SH_MOD2(1),SH_MOD2(2),SH_MOD2(3)
          CALL MSGDOC(MDOC,LINE)
          WRITE(LINE,
     *    '(''       Number of atoms:'',I8)') NA_TOT 
          CALL MSGDOC(MDOC,LINE)

          CALL MSGDOC(MDOC,
     *       'INFO:  model_2 --> Structure Factors')
        
c         write(*,*) '--phase:',phase
 
          INVER = 'N'

c         IF(PHASE.EQ.'-'.OR.PHASE.EQ.'n') THEN
c          PRF     = 'N'
c          PHASE   = 'N'
c          NAME_PH = ' '
c        ELSE  
          PHASE = 'Y'
c        ENDIF
        
          MOD2  = 'N'
          DIFF  = 'N'
          FOBS  = 'Y'
          PST   = 'N'
          STICK = 'N'
          DYAD  = 'N'
          IF(NMR.GT.0) NMR = 0
        ENDIF
      ENDIF
   
      IF(FUN.EQ.'D'.OR.FUN.EQ.'B') THEN
        IF(MOD1.NE.'N'.OR.MOD2.EQ.'N') THEN
          CALL MSGERR(MDOC,
     *  ' ERROR: fun= D/B: there is not model_2 or model is defined')
          IERR = 1
          GO TO 900  
        ENDIF
        PRF  = 'N'
        DYAD = 'N'
      ENDIF

      IF(MOD2.NE.'N') THEN
        IF(PHASE.EQ.'Y'.AND.DIFF.EQ.'D') DIFF = 'N' 
      ENDIF

      IF((PHASE.EQ.'N'.OR.PHASE.EQ.'n').AND.
     *   (DIFF.EQ.'F'.OR.DIFF.EQ.'M')       ) DIFF = 'N' 

c      IF(PHASE.EQ.'Y') PST = 'N' 
c      IF(PHASE.EQ.'Y'.AND.PRF.NE.'N') THEN
c      IF(PST.EQ.'Y'.OR.PST.EQ.'A') THEN
c        LINE =
c     *    'WARNING: with keyword: PRF # N: PST = N'
c        CALL MSGERR(MDOC,LINE)
cc        PST = 'N'
c      ENDIF
c      ENDIF

      VOL_M1  = 0.0
      VOL_M2  = 0.0
      VOL_M2S = 0.0
      FSOLV   = 0.75
      RAD_MODEL = 0.0

      IF(MOD1.EQ.'N'.AND.SELF.NE.'Y'.AND.PRF.NE.'X'.AND.
     *   FUN.NE.'B'.AND.FUN.NE.'D'.AND.(DIFF.EQ.'H'.AND.FUN.NE.'T'))THEN
        CALL MSGERR(MDOC,' ERROR: there is not file of model')
        IERR = 1
        GO TO 900  
      ELSE
        INMON = 1
        IF(FIT.EQ.'Y'.OR.DIFF.EQ.'H'.OR.DER.EQ.'Y'.OR.FUN.EQ.'B'.OR.
     *     FUN.EQ.'D'.OR.FUN.EQ.'S') INMON = 0
c     *     FUN.EQ.'D'.OR.FUN.EQ.'S'.OR.PHASE.EQ.'Y') INMON = 0

        IF(MOD2.EQ.'Y'.AND.INMON.GT.0) THEN
          CALL MSGDOC(MDOC,' ')
          CALL MSGDOC(MDOC,' -- Fixed Model  --') 
          CALL CALC_MODEL_VOL(MDOC,NAMEM2,PATH_SCR,VOL_M2
     *    ,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900

          PVOL_M2 = VOL_M2*100.0
          TITLE = 'INFO: V_fixed Model :'
          CALL LENSTR_BL(TITLE,LEN)
          WRITE(LINE,'(A,F7.1,''% (of asymm. part of u.c.)'')')
     *    TITLE(1:LEN),PVOL_M2 
          CALL MSGDOC(MDOC,LINE)

          IF(DIFF.EQ.'M') SURFX = 'N' 
          NAME = 'molrepx'
          CALL ADD_PATH(PATH_SCR,NAME)
          IF(SURFX.NE.'N') THEN
            CALL CORR_FIXED_MODEL(MDOC,NAMEM2,NAME,PATH_SCR
     *      ,SURFX,BLIM,NA_INSIDE_X
     *      ,N_MODEL_X,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900
          ENDIF
        ENDIF

        IF(MOD2S.EQ.'Y'.AND.INMON.GT.0) THEN
          CALL CALC_MODEL_VOL(MDOC,NAMEM_2,PATH_SCR,VOL_M2S
     *    ,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
        ENDIF

        IF(MOD1.EQ.'Y') THEN

C         shift and correction of model
C         output: BLIM,NAMEM,SURF

          CALL MSGDOC(MDOC,' ')
          IF(MOD2S.EQ.'Y') THEN
            CALL MSGDOC(MDOC,' -- Model_M1  --')
          ELSE
            CALL MSGDOC(MDOC,' -- Model  --')
          ENDIF
          NAME = 'molrep1'
          CALL ADD_PATH(PATH_SCR,NAME)
          VOL_M1 = 0.0 
          CALL SHIFT_CORR_MODEL(MDOC,NAMEM,NAME,PATH_SCR
     *    ,DB,SURF,PRF,BLIM,NA1_TOT,NA_INSIDE
     *    ,NMR,N_MODEL,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900

          IF((SURF.EQ.'Y'.OR.SURF.EQ.'C').AND.FUN.NE.'R'.AND.
     *        PACK.NE.'N'.AND.NA_INSIDE.LE.0) THEN
            LINE = ' ERROR: model: Natom_inside = 0'
            CALL MSGERR(MDOC,LINE)
            LINE = ' ERROR: not possible to use Packing function with'
     *           //' keyword SURF = Y or C'  
            CALL MSGERR(MDOC,LINE)    
            IERR = 1
            IF(IERR.NE.0) GO TO 900
          ENDIF

          CALL CALC_MODEL_VOL(MDOC,NAMEM,PATH_SCR,VOL_M1
     *    ,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900

          IF(MOD2S.EQ.'Y') THEN
            NAME = 'molrep3'
            CALL ADD_PATH(PATH_SCR,NAME)

            CALL MSGDOC(MDOC,' ')
            CALL MSGDOC(MDOC,' -- Model_M2 (for searching) --')
c -----
            CALL CALC_MODEL_VOL(MDOC,NAMEM_2,PATH_SCR,VOL_M2S
     *      ,ISYM,IPRSYM,IERR)
            CH1 = 'N'
            CALL SHIFT_CORR_MODEL(MDOC,NAMEM_2,NAME,PATH_SCR
     *      ,CH1,SURF,PRF,BLIM,NA2_TOT,NA2_INSIDE
     *      ,NMR,N_MODEL2,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900

            IF((SURF.EQ.'Y'.OR.SURF.EQ.'C').AND.FUN.NE.'R'.AND.
     *        PACK.NE.'N'.AND.NA2_INSIDE.LE.0) THEN
              LINE = ' ERROR: second model: Natom_inside = 0'
              CALL MSGERR(MDOC,LINE)
              LINE = ' ERROR: not possible to use Packing function with'
     *             //' keyword SURF = Y or C'  
              CALL MSGERR(MDOC,LINE)    
              IERR = 1
              IF(IERR.NE.0) GO TO 900
            ENDIF
          ENDIF

          IF(INMON.GT.0) THEN
            VOL_M12 = VOL_M1           
            IF(MOD2S.EQ.'Y') VOL_M12 = VOL_M12 + VOL_M2S

            FSOLV_MAX = 0.95

c            EMPTY_SPACE = FSOLV_MAX - VOL_M2 - VOL_M2S
            EMPTY_SPACE = FSOLV_MAX - VOL_M2

            IF(EMPTY_SPACE.LT.0.0) EMPTY_SPACE = 0.0
            IF(EMPTY_SPACE.GT.1.0) EMPTY_SPACE = 1.0
            IF(MAP.EQ.'Y') THEN
              IF(VOL_MAP.GT.0.001) THEN
c                EMPTY_SPACE = (VOL_POS/VOL_MAP)*0.6 
c     *                       - VOL_M2 - VOL_M2S
                EMPTY_SPACE = (VOL_POS/VOL_MAP)*0.6 
     *                       - VOL_M2 
c                IF(EMPTY_SPACE.LE.VOL_M1) EMPTY_SPACE = VOL_M1*1.01
                IF(EMPTY_SPACE.LE.VOL_M12) EMPTY_SPACE = VOL_M12*1.01
              ENDIF
            ENDIF
            IF(VOL_M1.GT.0.001) THEN
c              NMON_EXP = EMPTY_SPACE/VOL_M1
              NMON_EXP = EMPTY_SPACE/VOL_M12
              IF(NMON_EXP.LE.0) THEN
                TITLE = 'WARNING: model is very big'
                CALL LENSTR_BL(TITLE,LEN)
                CALL MSGDOC(MDOC,TITLE)
C                IF(DB_INPUT.EQ.'Y') THEN
C                  MESSAGE_XML  = 'model is very big'
C                  IERR = 13
C                  GO TO 900
C                ENDIF 
              ELSE
c                EMPTY_SPACE = FSOLV - VOL_M2 - VOL_M2S 
                EMPTY_SPACE = FSOLV - VOL_M2  
                IF(EMPTY_SPACE.LT.0.0) EMPTY_SPACE = 0.0
                IF(EMPTY_SPACE.GT.1.0) EMPTY_SPACE = 1.0
                IF(MAP.EQ.'Y') THEN
                  IF(VOL_MAP.GT.0.001) THEN
c                   EMPTY_SPACE = (VOL_POS/VOL_MAP)*0.6 
c     *                          - VOL_M2 - VOL_M2S
c                   IF(EMPTY_SPACE.LE.VOL_M1) EMPTY_SPACE = VOL_M1*1.01
                   EMPTY_SPACE = (VOL_POS/VOL_MAP)*0.6 
     *                          - VOL_M2 
                   IF(EMPTY_SPACE.LE.VOL_M12) EMPTY_SPACE = VOL_M12*1.01
                  ENDIF
                ENDIF
c                NMON_EXP = EMPTY_SPACE/VOL_M1
                NMON_EXP = EMPTY_SPACE/VOL_M12
                IF(NMON_EXP.LE.0) NMON_EXP = 1
              ENDIF  
            ELSE
              NMON_EXP = 0
            ENDIF
            PVOL_M1 = VOL_M1*100.0
            TITLE = 'INFO: expected number of models :'
            CALL LENSTR_BL(TITLE,LEN)
            WRITE(LINE,'(A,I5)')
     *      TITLE(1:LEN),NMON_EXP
            CALL MSGDOC(MDOC,LINE)
            IF(MOD2S.EQ.'Y') THEN
              CALL MSGDOC(MDOC,'INFO: model = M1 + M2')
              NMON_EXP = NMON_EXP*2
            ENDIF

            PERC = PVOL_M1
            IF(MOD2S.EQ.'Y') THEN
              PVOL_M2S = VOL_M2S*100.0
              PERC = PVOL_M1 + PVOL_M2S 
            ENDIF

            WRITE(LINE,'(''INFO: V_model:'',F7.1
     *         ,''% (of asymm. part of u.c.)'')') PERC
            CALL MSGDOC(MDOC,LINE)
            NMON_EXP_LIM = 12
            IF(NMON_EXP.GT.NMON_EXP_LIM) THEN
              TITLE = 
     *        'INFO: expected number of models > default_limit :'
              CALL LENSTR_BL(TITLE,LEN)
              WRITE(LINE,'(A,I5)') TITLE(1:LEN),NMON_EXP_LIM
              CALL MSGDOC(MDOC,LINE)
              NMON_EXP = NMON_EXP_LIM
            ENDIF
            IF(NMON_EXP.GT.1.AND.NMON.LE.0) THEN
              NMON = NMON_EXP
              WRITE(LINE,
     *        '(''INFO: program will use NMON ='',I4)')NMON_EXP 
              CALL MSGDOC(MDOC,LINE)
            ELSE IF(NMON.GT.0) THEN
              IF(MOD2S.EQ.'Y') THEN
                NMON = ((NMON+1)/2)*2
              ENDIF
              WRITE(LINE,
     *        '(''INFO: program will use NMON ='',I4)')NMON 
              CALL MSGDOC(MDOC,LINE)
              IF(NMON_EXPECTED.LE.0) NMON_EXPECTED = NMON_EXP
            ENDIF

            IF(NMON.LE.1.AND.PST.EQ.'A') THEN
              PST  = 'N'
            ENDIF

          ENDIF

          IF(NMR.LT.0) NMR = 0

c         WRITE(LINE,'('' Sim,Badd,Badd_scl          :'',3F8.2)') 
c     *   QUAL,BADDR,BADD_SCL
c         CALL MSGDOC(MDOC,LINE)


          IF(FIT.EQ.'Y') THEN
            IF(NA_TOT.GT.0.AND.NA1_TOT.GT.0.AND.
     *         NMON_EXPECTED.LE.0.AND.NCS.LE.1) THEN
              IF(NA_TOT.GE.NA1_TOT) THEN
                NMON_EXPECTED = REAL(NA_TOT)/REAL(NA1_TOT) + 0.3
              ELSE
                IF(NCS_MODEL.LE.0) 
     *          NMON_EXPECTED = REAL(NA1_TOT)/REAL(NA_TOT) + 0.3
              ENDIF
            ENDIF
          ENDIF


        ENDIF               

        IF(FOBS.EQ.'Y'.OR.FOBS.EQ.'D') THEN
C         check Patterson , pseudo-trans, calc Boff , Badd
C         output:  PST, SPST, Boff, Badd

c          IF(MOD1.EQ.'D'.AND.DENS_RESOL.GT.0.001.AND.
c     *                                  RESX.LT.0.001) THEN
c            RESX = DENS_RESOL*0.8
c          ENDIF

          CALL MSGDOC(MDOC,' ')
          CALL MSGDOC(MDOC,' -- Structure Factors --')

          NCS_TEST = 0
          TEST_BOFF = ' '

          IF(N_MODEL.GT.1.AND.QUAL_INPUT.LT.0.0001.AND.
     *         NMR_INPUT.GE.0.AND.ABS(BADD_INPUT).LT.0.1) THEN
            QUAL = 0.5
            BADD = 0.0
          ENDIF

          CALL CHECK_PATT_BOFF_BADD(MDOC,NAMESF,PATH_SCR,TEST_BOFF
     *    ,LH,FIT,LIST,FUN,NCS_TEST,ANISO,ANISO_CORR,ANISO_INPUT
     *    ,FOBS,MOD1,FSOLV,MAP,VOL_POS,DENS_RESOL,PRF,DYAD
     *    ,PST,SPST,TVECTOR,BOFF,BADD,COMPL,QUAL,RESX,RESN_SCL
     *    ,RESN_R,RESN_T,BADD_SCL,NMON,VOL_M1,VOL_M2,VOL_M2S,RAD_MODEL
     *    ,ISYM,IPRSYM,RESULT,IPRMAX,IPRROW,IERR)
          IF(IERR.NE.0) GO TO 900

          IF(PST.EQ.'Y'.OR.PST.EQ.'A') THEN
             SPST(1) = TVECTOR(1)
             SPST(2) = TVECTOR(2)
             SPST(3) = TVECTOR(3)

c            IF(STICK.NE.'N'.OR.FAST.NE.'F') THEN
             IF(FAST.NE.'F') THEN
               LINE =
     *         'WARNING: with keyword: PST --> MODE = F '
c     *        'WARNING: with keyword: PST --> MODE = F , STICK = N'
               CALL MSGERR(MDOC,LINE)
             ENDIF
             MODE  = 'F'
             FAST  = 'F'
c            DYAD  = 'N'
c            STICK = 'N'
             REF   = 'N'
             REFP  = 'N'
c            NREF  = 0
c            NREFP = 0
          ENDIF
c         IF(SELF.EQ.'Y'.AND.ARAD.LT.0.01) ARAD = 1.75*RAD_MODEL
          CALL MSGDOC(MDOC,' ')
        ENDIF

        IF(FUN.EQ.'S') THEN

          IF(MOD1.NE.'Y'.AND.MOD1.NE.'D') THEN
            CALL MSGERR(MDOC,' ERROR: there is not file of model')
            IERR = 1
            GO TO 900
          ENDIF
          DYAD = 'N'
          IF(NMR.LT.0) NMR = 0
          STICK = 'N'
          PST   = 'N'
          MOD2  = 'N'
          MOD2S = 'N'
C
C         in the future: NMR,MODEL2,STICK,PST
C
          DA1 = CHI_DYAD
          DA2 = DELTA
          DA3 = DELTA2
          DX  = DIST_MIN
          DY  = DIST_MAX
          DZ  = DIST_DPAR

          CALL TRFUN_S(MDOC,NAMESF,NAMEM,NAME_TAB,PATH_SCR
     *   ,MOD1,ANGLES,TVECTOR,NREFR
     *   ,RESN_T,RESN_SCL,RESX,BOFF,BADD,BADD_SCL
     *   ,ANISO,SURF,LIST
     *   ,NPEAK,NPT,DA1,DA2,DA3,DX,DY,DZ
     *   ,ISYM,IPRSYM
     *   ,RESULT,RESULT2,RESULT3,IPRMAX,IPRROW,IERR)
          IF(IERR.NE.0) GO TO 900

        ELSE

          NAMEF_DIFF = ' '
          IF((MOD2.EQ.'Y'.AND.DIFF.NE.'N').OR.
     *       (MOD2.EQ.'N'.AND.DIFF.EQ.'H'))  THEN
C           compute coeff for diff Patt or Fourie
C           output: file NAMEF_DIFF = 'molrp_diff'

            IF(PERCENT_2.LT.0.001)  PERCENT_2 = 100.0
            IF(PERCENT_2.GT.100.0)  PERCENT_2 = 100.0

            WRITE(LINE,'(''  Keyword DIFF : '',A)') DIFF
            CALL MSGDOC(MDoc,LINE)
            IF(DIFF.NE.'M') THEN
              WRITE(LINE,*) '  PERCENT_2:',PERCENT_2 
              CALL MSGDOC(MDoc,LINE)
            ENDIF

            MMM = M
            IF(LIST.EQ.'T') MMM = MDOC
            IF(DIFF.EQ.'H') MMM = MDOC
            IF(DIFF.EQ.'H') THEN
              IF(FUN.EQ.'T'.AND.MOD1.EQ.'N') THEN
                NAMEM2 = ' '
                MOD2   = 'N'
              ENDIF
            ENDIF
            LH = 'N'
            CALL CALC_FILE_DIFF(MMM,NAMESF,NAMEM2,NAMEF_DIFF,NAME_DER 
     *      ,NAME_PH,PATH_SCR,BOFF,BADD,BADD_SCL,ANISO
     *      ,MOD2,DIFF,PRF,FUN,LIST,PERCENT_2,INVER,RESN_SCL,RESX
     *      ,ISYM,IPRSYM,RESULT,IPRMAX,IPRROW,IERR)
            IF(IERR.NE.0) GO TO 900

            IF(FUN.EQ.'D') GO TO 900
            IF(DIFF.EQ.'H') THEN
              IF(FUN.EQ.'T'.AND.MOD1.EQ.'N') THEN
C               1ha --> model NAMEM
C               0,0,0, --> molrep_rf.tab NAME_TAB
                NAMEM    = 'molrp_ha'
                NAME_TAB = ' '
                CALL ADD_PATH(PATH_SCR,NAMEM)
                CALL WRT_ONE_HA(M,NAMEM,PATH_SCR,ISYM,IPRSYM,IERR)
                IF(IERR.NE.0) GO TO 900      
                PDB_MOD = 'Y'
                MOD1    = 'Y'
                SURF    = 'N' 
                IF(NPT .LE.0) NPT  = 20
                IF(NPT_DM.LE.0) NPT_DM = 20
                IF(DIST_MIN.LE.0.0) DIST_MIN = 5.0
                NP      = 1                
                NAMEM2 = ' '
                MOD2   = 'N'
              ENDIF
              IF(FUN.NE.'B') THEN
C                NAMEM2 = ' '
C                MOD2   = 'N'
              ENDIF
C             PRF  = 'N'
            ENDIF

            IF(PRF.EQ.'N') THEN
C             IF(DIFF.EQ.'D'.OR.DIFF.EQ.'F'.OR.DIFF.EQ.'M') PRF = 'Y' 
              IF(DIFF.EQ.'D') PRF = 'Y' 
            ENDIF

C            IF(DIFF.EQ.'N') PRF = 'N' 
            IF(DIFF.EQ.'D') INVER = 'N' 

c            write(*,*) '--N_DIFF:',NAMEF_DIFF
c            write(*,*) '--N_PH  :',NAME_PH         

          ENDIF
C ---
          PAR_MR(1:1)   = SUM
          PAR_MR(2:2)   = ANISO
          PAR_MR(3:3)   = PACK
          PAR_MR(4:4)   = FUN
          PAR_MR(5:5)   = TFUN
          PAR_MR(6:6)   = REF
          PAR_MR(7:7)   = REFP
          PAR_MR(8:8)   = LIST
          PAR_MR(9:9)   = SELF
          PAR_MR(10:10) = PST

          IF(DYAD.EQ.'M'.AND.(PST_INPUT.EQ.'Y'.OR.PST_INPUT.EQ.'y')) 
     *    PAR_MR(10:10) = 'Y'

          PAR_MR(11:11) = SURF
          PAR_MR(12:12) = INVER 
          PAR_MR(13:13) = PRF 
          PAR_MR(14:14) = FIT 
          PAR_MR(15:15) = FAST 
          PAR_MR(16:16) = TEST
          PAR_MR(17:17) = DIFF
          PAR_MR(18:18) = MODE_T
          PAR_MR(19:19) = TEST_SRF
          PAR_MR(20:20) = DYAD
          PAR_MR(21:21) = STICK
          PAR_MR(22:22) = MOD1
          PAR_MR(23:23) = MOD2
          PAR_MR(24:24) = MOD2S
          PAR_MR(25:25) = LOCK
          PAR_MR(26:26) = ALL
          PAR_MR(27:27) = CCP4
          PAR_MR(28:28) = ANISO_CORR              
          PAR_MR(29:29) = DB_INPUT              
          PAR_MR(30:30) = SURFX              
C --------

          IF(NMON.LE.0)  NMON=1

          INT_PARAM(1)  = NPEAK
          INT_PARAM(2)  = NPT
          INT_PARAM(3)  = NMON
          INT_PARAM(4)  = LMIN
          INT_PARAM(5)  = LMAX
          INT_PARAM(6)  = 0
          INT_PARAM(7)  = NP_SRF
          INT_PARAM(8)  = NPT_DM
          INT_PARAM(9)  = NMR
          INT_PARAM(10) = N_MODEL
          INT_PARAM(11) = NPEAK2
          INT_PARAM(12) = NREF
          INT_PARAM(13) = NREFP
          INT_PARAM(14) = NREFR
          INT_PARAM(15) = NCS
          INT_PARAM(16) = NCS_MODEL
          INT_PARAM(17) = NOSPGR
          INT_PARAM(18) = NMON_EXPECTED
          INT_PARAM(19) = NML
C ---------

          FPAR_MR( 1) = CHI_IN
          FPAR_MR( 2) = COEF_IN
          FPAR_MR( 3) = RESN_R
          FPAR_MR( 4) = RESN_T
          FPAR_MR( 5) = RESX
          FPAR_MR( 6) = COMPL 
          FPAR_MR( 7) = QUAL
          FPAR_MR( 8) = BOFF
          FPAR_MR( 9) = BADD 
          FPAR_MR(10) = ARAD 
          FPAR_MR(11) = PERCENT_1
          FPAR_MR(12) = PERCENT_2    
          FPAR_MR(13) = BLIM    
          FPAR_MR(14) = RESN_SCL    
          FPAR_MR(15) = DIST_MIN
          FPAR_MR(16) = DIST_MAX
          FPAR_MR(17) = DIST_DPAR
          FPAR_MR(18) = DELTA 
          FPAR_MR(19) = CHI_DYAD
          FPAR_MR(20) = BADD_SCL

          IF(RSMAX_RB.LE.0.0001) RSMAX_RB = 5.0

          FPAR_MR(21) = RSMAX_RB 
          FPAR_MR(22) = RMS_INPUT 
          FPAR_MR(23) = DLIM_RF 
          FPAR_MR(24) = RAD_MODEL 

C ----
          IF(FUN.EQ.'B') THEN    
            CALL RB_REFINEMENT(MDOC,LIST,DOM,ANISO,COEF_IN,FAST
     *        ,DIFF,NREF,RES_T,RESX,BOFF,BADD
     *        ,NCS,ANGLES,CVECTOR,P1_KEY
     *        ,NAMESF,NAMEM2,NAME_PH,NAMEF_DIFF
     *        ,ISYM,IPRSYM
     *        ,PATH_SCR,PATH_OUT,IERR)
            IF(IERR.NE.0) THEN
              GO TO 900
            ENDIF
          ELSE
C ----
            CALL MOLREP_RUN(MDOC,NAMESF,NAMEM
     *      ,NAMEM2,NAME_PH,NAME_TAB,NAMEM_2,NAME_TAB2,NAME_TSRF
     *      ,NAMEF_DIFF
     *      ,FPAR_MR,INT_PARAM,PAR_MR
     *      ,ANGLES,CVECTOR,SPST
     *      ,SPGR_INP
     *      ,ISYM,IPRSYM
     *      ,PATH_SCR,PATH_OUT
     *      ,RESULT,RESULT2,RESULT3,RESULTA,IPRMAX,IPRROW,IERR)
            IF(IERR.NE.0) THEN
              GO TO 900
            ENDIF
          ENDIF

        ENDIF
      ENDIF
C --------------------------------------------------------------
      IF(FIT.EQ.'Y'.OR.FIT.EQ.'B') THEN
        NAME  = 'molrep'
        CALL ADD_PATH(PATH_SCR,NAME)

        CALL SHIFT_BACK(M,NAME,PATH_SCR
     *                 ,SH_MOD2,RESULT,ISYM,IPRSYM,IERR)
      ENDIF
      IF(SELF.NE.'Y'.AND.
     *  (MOD1.EQ.'Y'.OR.(MOD2.EQ.'Y'.AND.FUN.EQ.'B'))) THEN 
        IF(PDB_MOD.EQ.'Y') THEN
          NAME  = 'molrep'
          CALL ADD_PATH(PATH_SCR,NAME)

          NAME1 = 'molrep'
          CALL ADD_PATH(PATH_OUT,NAME1)

          CALL LENSTR_BL(NAME1,LEN)
          FILE_XML = NAME1(1:LEN)//'.pdb'
          CALL LENSTR_BL(JOB_XML,LEN)
          IF(LEN.LE.0) JOB_XML  = 'MR'
          
          CALL MSGDOC(MDOC,
     *     '--- convert "molrep.crd" to "molrep.pdb" ---')
          IERR = 0
          IF(SURF.EQ.'Y') THEN
            IERR = 20
          ENDIF

          IF(N_MODEL.LE.1.OR.FIT.EQ.'Y'.OR.FIT.EQ.'B') THEN
            CALL WRITEPDB(M,NAME,NAME1,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900
          ELSE

CC           only one
CC            CALL WRITEPDB1(M,NAME,NAME1,ISYM,IPRSYM,IERR)
CC            IF(IERR.NE.0) GO TO 900

            CALL WRITEPDB(M,NAME,NAME1,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900

cc          for one IMODEL = 1; IMODEL = 0 rerange and chain_ID correction
            IMODEL = 1
            IF(FULL.EQ.'Y') IMODEL = 0   
            CALL WRITE_NMR_PDB(M,IMODEL
     *                ,NAME1,NMODEL,PATH_SCR,IERR)
            IF(IERR.NE.0) GO TO 900

          ENDIF
        ELSE
          CALL MSGDOC(MDOC,
     *     '--- solution is "molrep.crd" ---')
        ENDIF
      ENDIF
      IF(SELF.NE.'Y'.AND.MOD1.EQ.'D') THEN
C          CALL MSGDOC(MDOC,
C     *     '--- solution are "molrep_fcalc.dat" ---')
C                             "molrep_phcalc.dat"
C                             "molrep_sf.cif"  
C           MTZ  --> IERR = 99 
      ENDIF

      IF(FOBS.EQ.'D'.AND.
     *   DSCALE.GT.0.001.AND.ABS(DSCALE-1.0).GT.0.001) THEN
        NAME1 = 'molrep_map_sf.cif'
        CALL ADD_PATH(PATH_OUT,NAME1)
        CFREE = 'N'
        CSIG  = 'Y'
        CFOM  = 'N'
        NAME = ' '
        RESMIN = 0.0
        RESMAX = 0.0
        CALL F2CIF(M,NAMESF,NAME,NAME_PH,NAME1
     *          ,CFOM,CFREE,CSIG
     *          ,RESMIN,RESMAX,ISYM,IPRSYM,RESULT,IPRROW,IERR)
        IF(IERR.NE.0) GO TO 900
        LINE = '         file "molrep_map_sf.cif" was created'
        CALL MSGDOC(MDOC,LINE)
        LINE = '               with Fobs,Phcalc(new scaled map)'
        CALL MSGDOC(MDOC,LINE)
      ENDIF
 900  CONTINUE
C ---------------------
      IF(JOB_XML.EQ.'MR_SG_checking'.AND.IERR_XML.EQ.99) THEN
        IERR_XML = 0

        ISETT   = 0
        NSG     = 0
        NSYMLIB = 0 
        NOSPGR  = NSG_SYMLIB_XML
        SPGR_INP= ' '
        NAME =  'molrep_fobs_new.dat'
        CALL ADD_PATH(PATH_OUT,NAME)
        FILE_XML = NAME 
        CALL CHANGE_GROUP(MDOC,NAMESF_INP,NAME
     *           ,NOSPGR,SPGR_INP,NSG,ISETT,NSYMLIB
     *           ,NSYM,ISYM,IPRSYM,IERR)

        IF(IERR.EQ.0) THEN
          MTN   = 10
          ITYPE = 'FF  '
          CALL ORFILE(M,MTN,NAME,ITYPE,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.EQ.0) THEN
            CALL C_RD_CR
            CALL GET_CELL(RLATT_F,CODE,NAME,DATE,TTT
     *      ,NSPGROUP_F,NOSETT_F,SPGR_F,NSM,IERR)
            CLOSE(MTN)
            SPACE_GROUP_XML = SPGR_F
          ELSE
            CALL MSGERR(MDOC,' ERROR: can not open file new_Fobs..')
            IERR_XML = 1
            NSG_SYMLIB_XML = 0
            MESSAGE_XML  = ' '  
            FILE_XML = ' ' 
          ENDIF
        ELSE
          IERR_XML = 1
          NSG_SYMLIB_XML = 0
          MESSAGE_XML  = ' '  
          FILE_XML = ' ' 
        ENDIF
      ELSE
        NAME='molrep_fobs_new.dat'
        CALL DELETE_FILE(PATH_OUT,NAME)        
      ENDIF

C ---
      ITIME_START = 1
      NRUN_TIME   = 0
      CALL EXPECTED_TIME(ITIME_START,NRUN_TIME
     *  ,ITIME_CURR,TIME_CURRENT,TIME_ELAPSED,TIME_EXPECTED)
      WRITE(LINE,*) 'Time:',TIME_CURRENT,'  Elapsed:',TIME_ELAPSED
      CALL MSGDOC(MDOC,LINE)
      TIME_ELAPSED_XML  = TIME_ELAPSED
      TIME_EXPECTED_XML = TIME_EXPECTED
C ---
c      IF(DB_INPUT.EQ.'Y') THEN
        CALL WRITE_XML_FILE(IERR,PATH_OUT)
c      ENDIF
C ---------------------
C IDELETE = 0 not delete,i.e. rest LIST = 'L'
C         = 1 delete,i.e. set LIST = 'S'
      IF(IDELETE.GT.0) LIST = 'S'
      CALL MOLREP_CLEAN(LIST,PATH_SCR,PATH_OUT)
      IF(CCP4.EQ.'Y') THEN
        NAME='molrep_dns_mod.dat'
        CALL DELETE_FILE(PATH_OUT,NAME)
      ENDIF
      IF(MTZD.EQ.'D') THEN
        NAME='molrep_dns.dat'
        CALL DELETE_FILE(PATH_OUT,NAME)
      ENDIF
      IF((VCCP4.EQ.'Y'.OR.MOD1.NE.'D').AND.IDELETE.GT.0) THEN
        NAME='molrep_fcalc.dat'
        CALL DELETE_FILE(PATH_SCR,NAME)
        NAME='molrep_fcalc_scl.dat'
        CALL DELETE_FILE(PATH_SCR,NAME)
        NAME='molrep_phcalc.dat'
        CALL DELETE_FILE(PATH_SCR,NAME)
      ENDIF
C ---------------------
      IF(MDOC_C.EQ.1) THEN
        IF(VCCP4.EQ.'Y') THEN
          CALL FINISH_CCP4(IERR)
        ELSE
          CALL FINISH
        ENDIF
      ENDIF
      RETURN
      END

      SUBROUTINE XML_COM_INIT
C -------------------------------------------
C     initialisation COM_XML_INFO
C ---
      INCLUDE 'molrep_xml.fh'
C -------------------------------------------
      CONTRAST_XML = 0.0
      PREV_CONTRAST_XML = 0.0
      IERR_XML     = 0
      NSOL_XML     = 0
      NSG_SYMLIB_XML = 0
      JOB_XML      = ' '
      MESSAGE_XML  = ' '
      FILE_XML     = ' '
      DIMER_XML    = ' '
      SPACE_GROUP_XML = ' '
      TIME_ELAPSED_XML  = '.'
      TIME_EXPECTED_XML = '.'
C -------
      RETURN
      END

      SUBROUTINE WRITE_XML_FILE(IERR,PATH_OUT)
C -------------------------------------------
C ---
      INCLUDE 'molrep_xml.fh'
C ---
      INTEGER   IERR
      CHARACTER PATH_OUT*(*)
      INTEGER   M,IOUT,JERR
      CHARACTER LINE*256,NAME*256,EXT*3,PATH*1,CHAR10*10
      CHARACTER CHAR15*15
C -------------------------------------------
      NAME = 'molrep'
      CALL ADD_PATH(PATH_OUT,NAME)
      M    = 99
      IOUT = 10
      PATH = ' '
      EXT  = 'xml'
      CALL OPENFW(IOUT,M,PATH,NAME,EXT,JERR)
      IF(JERR.NE.0) RETURN
C -------
      IF(IERR.NE.0) THEN
        IERR_XML     = IERR
        CALL LENSTR_BL(MESSAGE_XML,LEN)
        IF(LEN.LE.0) MESSAGE_XML  = 'failed'
        IF(IERR.EQ.31) MESSAGE_XML  = 'no cell parameters'
        IF(IERR.EQ.32) MESSAGE_XML  = 'no symmetry information'
        IF(IERR.EQ.33) MESSAGE_XML  = 'wgong space group name'
        IF(IERR.EQ.34) MESSAGE_XML  = 'number of reflections = 0'
c       IF(IERR.EQ.35) MESSAGE_XML  = 'wrong title of Fobs'
        CONTRAST_XML = 0.0
        NSOL_XML     = 0
      ELSE
C       IERR_XML     = IERR
        CALL LENSTR_BL(MESSAGE_XML,LEN)
        IF(LEN.LE.0) MESSAGE_XML  = 'normal termination'
      ENDIF
C ----------------------------------------------------------
      LINE = '<?xml version="1.0" encoding="ASCII" standalone="yes"?>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)') LINE(1:LEN)
C ---
      CALL LENSTR_BL(JOB_XML,JOB_LEN)
      IF(JOB_LEN.LE.0) THEN
        JOB_XML = 'none'
        JOB_LEN     = 4
      ENDIF
C -
      LINE = '<!-- '//JOB_XML(1:JOB_LEN)//' output  -->'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)') LINE(1:LEN)
c -
      LINE = '<'//JOB_XML(1:JOB_LEN)//'>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)') LINE(1:LEN)
C -
      WRITE(CHAR10,'(I10)') IERR_XML
      LINE = 'Error <err_level>'//CHAR10//'</err_level>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)') LINE(1:LEN)
C -
      CALL LENSTR_BL(MESSAGE_XML,LEN)
      LINE = 'Message <err_message>'//MESSAGE_XML(1:LEN)//
     *       '</err_message>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)') LINE(1:LEN)
c -
      LINE = 'Job <job>'//JOB_XML(1:JOB_LEN)//'</job>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)') LINE(1:LEN)
C ----------------------------------------------------------

      IF(JOB_XML(1:JOB_LEN).NE.'MR_SG_checking') THEN


      WRITE(CHAR10,'(I10)') NSOL_XML
      LINE = 'nmon_solution <n_solution>'//CHAR10//'</n_solution>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)') LINE(1:LEN)
C -
      WRITE(CHAR10,'(F10.4)') CONTRAST_XML
      LINE = 'mr_score <mr_score>'//CHAR10//'</mr_score>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)') LINE(1:LEN)
c -
      WRITE(CHAR10,'(F10.4)') PREV_CONTRAST_XML
      LINE = 'mr_score_previous <mr_score_previous>'//
     *       CHAR10//'</mr_score_previous>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)') LINE(1:LEN)
c -
      CALL LENSTR_BL(FILE_XML,LEN)
      IF(LEN.LE.0) THEN
        FILE_XML= 'none'
        LEN = 4
      ENDIF
      LINE = '<solution sol_file="'//FILE_XML(1:LEN)//'"/>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)') LINE(1:LEN)
c --
      CALL LENSTR_BL(DIMER_XML,LEN)
      IF(LEN.LE.0) THEN
        DIMER_XML= 'none'
        LEN = 4
      ENDIF
      LINE = '<found dimer_file="'//DIMER_XML(1:LEN)//'"/>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)') LINE(1:LEN)

      ELSE

      WRITE(CHAR10,'(I10)') NSG_SYMLIB_XML
      LINE = 'No_sg_symlib <nsg>'//CHAR10//'</nsg>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)') LINE(1:LEN)

      CALL LENSTR_BL(SPACE_GROUP_XML,LEN)
      IF(LEN.LE.0) THEN
        SPACE_GROUP_XML = 'none'
        LEN = 4
      ENDIF
      LINE = 'Space group <sg>'//SPACE_GROUP_XML(1:LEN)//'</sg>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)') LINE(1:LEN)

      CALL LENSTR_BL(FILE_XML,LEN)
      IF(LEN.LE.0) THEN
        FILE_XML= 'none'
        LEN = 4
      ENDIF
      LINE = '<New_fobs fobs_file="'//FILE_XML(1:LEN)//'"/>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)') LINE(1:LEN)
c --

      ENDIF

      CHAR15 = TIME_ELAPSED_XML
      IF(CHAR15(1:1).EQ.'.') CHAR15 = 'null'
      CALL LENSTR_BL(CHAR15,L)
      LINE = 'Time_elapsed <tel>'//CHAR15(1:L)//'</tel>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)') LINE(1:LEN)
      CHAR15 = TIME_EXPECTED_XML
      IF(CHAR15(1:1).EQ.'.') CHAR15 = 'null'
      CALL LENSTR_BL(CHAR15,L)
      LINE = 'Time_remained <trm>'//CHAR15(1:L)//'</trm>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)') LINE(1:LEN)
c -
      LINE = '</'//JOB_XML(1:JOB_LEN)//'>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)') LINE(1:LEN)
C -------
      END FILE IOUT
      CLOSE(IOUT)
      RETURN
      END

      SUBROUTINE INIT_LH_COM(LH_INPUT,SCORE_FLAG_INPUT,DB)
C ---------------------------------
      INCLUDE 'molrep_lh_infor.fh'
C      COMMON/COM_LH_INFOR/ BOFF_LH,BADD_LH,BOFF_FOR_SCAL
C     *   ,CHECK_CONTRAST,CONTRAST_LIM
C     *   ,BCORR_LH,FILE_FOBS_LH,SCORE_FLAG,LH_LH,DB_LH
C ---
C      REAL      CHECK_CONTRAST,CONTRAST_LIM
C      REAL      BOFF_FOR_SCAL,BOFF_LH,BADD_LH,BCORR_LH
C      CHARACTER LH_LH*1,SCORE_FLAG*1,DB_LH*1
C      CHARACTER FILE_FOBS_LH*256
C ----------------------------------
      CHARACTER LH_INPUT*1,SCORE_FLAG_INPUT*1,DB*1
C --------------------------------------------------------------------
      LH_LH         = LH_INPUT
      SCORE_FLAG    = SCORE_FLAG_INPUT
      BOFF_LH       = 0.0
      BADD_LH       = 0.0
      BCORR_LH      = 0.0
      BOFF_FOR_SCAL = 0.0
      FILE_FOBS_LH  = ' '
      DB_LH         = DB

c     CHECK_CONTRAST = 1.5
      CHECK_CONTRAST = 1.29
      IF(DB.EQ.'Y') CHECK_CONTRAST = 1.2

c     CONTRAST_LIM   = 2.5
      CONTRAST_LIM   = 3.1
      PST_LH = 'N'
C ----
      RETURN
      END

      SUBROUTINE INIT_DENS_FILE(MODE)
C ---------------------------------
      COMMON/COM_MLR_DENS/ 
     * D_RAD,D_SCALE,D_RADI,D_ORIGIN_F,D_RESOL,DSUM_EL,D_ROLIM
     *,D_SHIFT_BEST,D_ANGLE_BESR,D_RSCALE,D_RAD_PACK
     *,D_NCS
     *,D_MODE,D_POS,D_INVER,D_MOD,D_NAME,D_FLAG_BEST
C -
      INTEGER   D_NCS(2)
      REAL      D_RAD(2),D_SCALE(2),D_RADI(2),D_ORIGIN_F(3,2)
     *         ,D_RESOL(2),DSUM_EL(2),D_ROLIM(2),D_RSCALE(2)
     *         ,D_SHIFT_BEST(3,2),D_ANGLE_BESR(3,2),D_RAD_PACK(2)

      CHARACTER D_MODE*1,D_POS(2)*1,D_INVER(2)*1,D_MOD(2)*1
     *         ,D_NAME(2)*256,D_FLAG_BEST(2)*1
C ----------------------------------
      CHARACTER MODE*1
C --------------------------------------------------------------------
      D_MODE    = MODE
      D_MOD(1)  = 'N'
      D_MOD(2)  = 'N'
      D_NAME(1) = ' '
      D_NAME(2) = ' '
C --
      RETURN
      END

      SUBROUTINE CHECK_DENS_FILE(MDOC,LIST
     *        ,NAMEC,IMOD,INVER,POSI,DSCALE
     *        ,DRAD,ORIGX,ORIGY,ORIGZ,RMAXM,DENS_RESOL
     *        ,ROLIM,IDZNCS,DRAD_PACK_INP,PATH_SCR
     *        ,RESULT,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
C ---------------------------------
      COMMON/COM_MLR_DENS/ 
     * D_RAD,D_SCALE,D_RADI,D_ORIGIN_F,D_RESOL,DSUM_EL,D_ROLIM
     *,D_SHIFT_BEST,D_ANGLE_BESR,D_RSCALE,D_RAD_PACK
     *,D_NCS
     *,D_MODE,D_POS,D_INVER,D_MOD,D_NAME,D_FLAG_BEST
C -
      INTEGER   D_NCS(2)
      REAL      D_RAD(2),D_SCALE(2),D_RADI(2),D_ORIGIN_F(3,2)
     *         ,D_RESOL(2),DSUM_EL(2),D_ROLIM(2),D_RSCALE(2)
     *         ,D_SHIFT_BEST(3,2),D_ANGLE_BESR(3,2),D_RAD_PACK(2)

      CHARACTER D_MODE*1,D_POS(2)*1,D_INVER(2)*1,D_MOD(2)*1
     *         ,D_NAME(2)*256,D_FLAG_BEST(2)*1
C --------------------------------------------------------------------
      COMMON/COM_DPOOL/ IPOOL_MAX,IPOOL_CURR
C --------------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER PATH_SCR*(*)
C ----
      REAL      RESULT    (IPRMAX,IPRROW)
      REAL      ANGLES(3),CELL(6),ORIG_F(3),SHFT_F(3),SPST(3)
      REAL      TEMP_F(3)
      CHARACTER LINE*256,NAMEC*(*),NAMES*256,NAMES1*256
     *     ,PST*1,PACK*1,MODE*1,POSI*1,POS*1,INVER*1,LIST*1,LLL*1
      CHARACTER TITLE*80
C ---------------------------------
      integer,   allocatable :: IPOOLD(:)
C ---------------------------------
      IERR  = 0
      PI    = 4.0*ATAN(1.0)
      MD    = -ABS(MDOC)-1
      M     = 99

      DENS_RESOL    = 0.0
      RO_SCALE      = 0.0
      IF(RMAXM.GT.10.0) RO_SCALE = 10.0/RMAXM

      IF(IDZNCS.LE.0) IDZNCS = 1
      IF(IDZNCS.GT.30) IDZNCS = 30

      D_NCS(IMOD) = IDZNCS

      D_MOD(IMOD)   = 'Y'
      D_NAME(IMOD)  = NAMEC
      D_SCALE(IMOD) = DSCALE
      D_RSCALE(IMOD)= RO_SCALE
      D_INVER(IMOD) = INVER
      D_POS(IMOD)   = POSI
      D_ROLIM(IMOD) = ROLIM
C      D_RAD(IMOD)   = DRAD
      D_RAD(IMOD)   = 0.0
      D_ORIGIN_F(1,IMOD) = ORIGX
      D_ORIGIN_F(2,IMOD) = ORIGY
      D_ORIGIN_F(3,IMOD) = ORIGZ
      D_RAD_PACK(IMOD)  = DRAD_PACK_INP
C ---
      MODE        = D_MODE
      POS         = D_POS(IMOD)
      PACK        = 'N'
      RAD         = D_RAD(IMOD) 
      RESMAX_CELL = 0.0
      DNS_SCALE   = D_SCALE(IMOD)
      RO_SCALE    = D_RSCALE(IMOD)
      DO I=1,3
        ANGLES(I) = 0.0
        SHFT_F(I) = 0.0
      ENDDO
      ORIG_F(1) =  D_ORIGIN_F(1,IMOD)
      ORIG_F(2) =  D_ORIGIN_F(2,IMOD)
      ORIG_F(3) =  D_ORIGIN_F(3,IMOD)
      DO I=1,6
        CELL(I) = 0.0
      ENDDO
      NXI = 0
      NYI = 0
      NZI = 0    

      NAMES  = ' '
      NAMES1 = ' '

      IPOOL_MAX = 0

      LLL = 'L'
      IF(LIST.EQ.'T') THEN
        LLL = 'T'
        WRITE(LINE,*) ' ---CHECK_DENS_FILE: imod:',imod
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      RESMAXI = RESMAX_CELL

      CALL GET_OUTPUT_MAP_PARAM(M
     *    ,NAMEC,NAMES,RESMAXI,CELL,NXI,NYI,NZI
     *    ,NX_CELL,NY_CELL,NZ_CELL,MEM_POOLD
     *    ,NSM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        RETURN
      ENDIF

      IF(IPOOL_MAX.LE.0) THEN
        MEM_POOLD = 1
      ELSE
        IPOOL_MAX = MEM_POOLD
      ENDIF

      allocate(IPOOLD(1:MEM_POOLD),STAT=ISTAT)
      IF(ISTAT.NE.0) THEN
        IERR = 1
        CALL MSGERR(MDOC,
     *  ' ERROR: in CHECK_DENS_FILE: problem with memory allocation')
        CALL MSGERR(MDOC,
     *  '                            try to change resolution')
        RETURN
      ENDIF

      CALL ROTDNS(MD,LLL,NAMEC,NAMES,NAMES1
     *    ,MODE,POS,PACK,RAD,RESMAX_CELL,DNS_SCALE,ROLIM,RO_SCALE
     *    ,ANGLES,ORIG_F,SHFT_F,CELL,NXI,NYI,NZI,TEMP_F     
     *    ,RESULT,IPOOLD,MEM_POOLD,ISYM,IPRSYM,IERR)
C ------------------------------------------------------
C -P- 
C ROTDNS 
C -S-
C     FILE_O: <rotdns>    - output file
C     RAD:    <0>         - radius
C     SCALE:  <1>         - density scale factor
C     POS: <Y>,N          - Y only positiv density
C     ORIG: <0,0,0>       - origin (fract)
C     ZLIM:  <0,0>        - zcentre_output,zmax_output(fract)
C     ANGLES: <0,0,0>     - polar rotation angles
C     PACK: <N>,Y         - Y density for Packing Function
C     GRID: <0,0,0>       - NX NY NZ
C     CELL: <0,0,0,0,0,0> - output cell
C     RESMAX:  <0>        - max resolution
C     FILE_F: < >         - cell parameter will be taken from this file
C     MODE: <B>,2         -  B - byte 2 - integer2
C
C      RESULT( 1) = SHFT_F(1)      
C      RESULT( 2) = SHFT_F(2)  centre of output (.5 .5 zcenter)
C      RESULT( 3) = SHFT_F(3)     
C      RESULT( 4) = ANGLES(1)     
C      RESULT( 5) = ANGLES(2)     
C      RESULT( 6) = ANGLES(3)     
C      RESULT( 7) = NPOINT     
C      RESULT( 8) = ZMIN      
C      RESULT( 9) = ZMAX      
C      RESULT(10) = ZCENTRE
C      RESULT(11) = RAD_MAX      
C      RESULT(12) = DCORR     DCORR  = R_PROT/<dens>   R_PROT = 0.245
C      RESULT(13) = SUM_EL    SUM_EL = DCORR * VOL_dens 
C      RESULT(14) = NX_CELL     
C      RESULT(15) = NY_CELL     
C      RESULT(16) = NZ_CELL     
C      RESULT(17) = RESMAX_CELL     
C      RESULT(18) = RADI
C ------------------------------------------------------
      IF(IERR.NE.0) THEN
        deallocate(IPOOLD,STAT=ISTAT)
        RETURN
      ENDIF
      D_RESOL(IMOD) = RESULT(17,1)
      DSUM_EL(IMOD) = RESULT(13,1)
C     D_RAD(IMOD)   = RESULT(11,1)
      D_RADI(IMOD)  = RESULT(18,1)
c --------------------------
      MMM   = M
      IF(LIST.EQ.'T') MMM = MDOC
      RS = D_RESOL(IMOD)
      CSCALE    = RO_SCALE
      RESULT(1,1) = 0.0
      RESULT(2,1) = 0.0
      RESULT(3,1) = 0.0
      RESULT(4,1) = CSCALE
      RESULT(5,1) = 0.0
      RESULT(6,1) = D_SCALE(IMOD)
      IERR = 1
c           density limit
      DLIM =  D_ROLIM(IMOD)
      IF(DLIM.GT.-1.0E20) THEN
        IERR = IERR + 16
        RESULT(7,1) = DLIM
      ELSE 
        RESULT(7,1) = 0.0
      ENDIF 
c
      PST = 'N'
      SPST(1) = 0.0
      SPST(2) = 0.0
      SPST(3) = 0.0
      NAMES  = 'trfn_scr.dat'
      CALL ADD_PATH(PATH_SCR,NAMES)
      NAMES1 = 'trfn_scr1.dat'
      CALL ADD_PATH(PATH_SCR,NAMES1)
      CALL RFT_NEW(MMM,LIST,PATH_SCR
     *   ,RS,INVER,PST,SPST
     *   ,NAMEC,NAMES,NAMES1,ISYM,IPRSYM,RESULT
     *   ,IPOOLD,IPOOL_MAX,IERR)
      deallocate(IPOOLD,STAT=ISTAT)
      IF(IERR.NE.0) THEN
        RETURN
      ENDIF

      IPOOL_MAX = 1

      RESMNI = 0.0
      RESMXI = 0.0

c     BOFFF_patt   = 100000

      IF(D_RADI(IMOD).GT.0.1.AND.DRAD_PACK_INP.LT.0.0) THEN
        D_RAD_PACK(IMOD) = D_RADI(IMOD)
      ELSE
        D_RAD_PACK(IMOD) = DRAD_PACK_INP    
      ENDIF
      D_RAD(IMOD)   = DRAD

c       D_RAD_PACK(IMOD) = 43.0       
c       D_RADI(IMOD)     = 56.0


c      IF(D_RADI(IMOD).GT.0.1.AND.DRAD.LT.0.0) THEN
      IF(D_RADI(IMOD).GT.0.1) THEN
        RAD_MODEL = D_RADI(IMOD)
      ELSE
        RAD_MODEL = DRAD       
      ENDIF

      SIGMA_OFF = RAD_MODEL/6.0 
      BOFFF_patt = 8.0*PI*PI*SIGMA_OFF*SIGMA_OFF

      IF(BOFFF_patt.LT.900.0) BOFFF_patt = 900.0

      IF(LIST.EQ.'T') THEN
        WRITE(*,*) '-Rad_M,Boff_patt:',RAD_MODEL,BOFFF_patt
      ENDIF

      BADDD   = 0.0
      NAMES1   = ' '
      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC
      CALL FNORM(MMM,NAMES,NAMES1
     *  ,RESMNI,RESMXI,BOFFF_patt,BADDD,RESULT,IPRROW,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) RETURN
      B_OVER     = RESULT( 8,1)
      RES_EFF    = RESULT( 9,1)
c      NSYM       = RESULT(12,1)
c      VOL        = RESULT(13,1)
c      COMPL_DATA = RESULT(14,1)
      RESMAX_USED = RESULT(15,1)

      CALL MSGDOC(MDOC,'----- Map of model -----')

      WRITE(LINE,'(''Res_opt,Res_used,Bover :'',3F10.3)') 
     * RES_EFF,RESMAX_USED,B_OVER 
      CALL MSGDOC(MDOC,LINE)

      DENS_RESOL = RESMAX_USED 

c --------------------------
c      IF(D_RADI(IMOD).GT.0.1.AND.DRAD.LT.0.0) THEN
c        D_RAD_PACK(IMOD) = D_RADI(IMOD)
c      ELSE
c        D_RAD_PACK(IMOD) = DRAD       
c      ENDIF
c      D_RAD(IMOD)   = DRAD
c
C =====
      D_ORIGIN_F(1,IMOD) = ORIGX
      D_ORIGIN_F(2,IMOD) = ORIGY
      D_ORIGIN_F(3,IMOD) = ORIGZ

      WRITE(LINE,'(''Dorigin (input)      :'',3F10.3)') 
     *  ORIGX,ORIGY,ORIGZ 
      CALL MSGDOC(MDOC,LINE)

      WRITE(LINE,'(''Origin from map      :'',3F10.3)') 
     *  TEMP_F(1),TEMP_F(2),TEMP_F(3)
      CALL MSGDOC(MDOC,LINE)

      IF(ABS(ORIGZ).LE.0.00001) THEN

        WRITE(LINE,'(''Origin (default)     :'',3F10.3)') 
     *  ORIG_F(1),ORIG_F(2),ORIG_F(3)
        CALL MSGDOC(MDOC,LINE)

        D_ORIGIN_F(1,IMOD) = ORIG_F(1)
        D_ORIGIN_F(2,IMOD) = ORIG_F(2)
        D_ORIGIN_F(3,IMOD) = ORIG_F(3)

        IF(IDZNCS.GT.1) THEN
          D_ORIGIN_F(1,IMOD) = TEMP_F(1)
          D_ORIGIN_F(2,IMOD) = TEMP_F(2)
          D_ORIGIN_F(3,IMOD) = TEMP_F(3)
        ENDIF

      ENDIF

      WRITE(LINE,'(''Origin (will be used):'',3F10.3)') 
     *  D_ORIGIN_F(1,IMOD),D_ORIGIN_F(2,IMOD),D_ORIGIN_F(3,IMOD)
      CALL MSGDOC(MDOC,LINE)

      WRITE(LINE,'(''Dscale       :'',F10.3)') D_SCALE(IMOD) 
      CALL MSGDOC(MDOC,LINE)
C     WRITE(LINE,'(''Dscale       :'',F10.3)') D_RSCALE(IMOD)
      WRITE(LINE,'(''Dresol       :'',F10.3)') D_RESOL(IMOD)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(''Dinver       :'',A)')     D_INVER(IMOD) 
      CALL MSGDOC(MDOC,LINE)
c     WRITE(LINE,'(''Dpos         :'',A)')     D_POS(IMOD)   
      WRITE(LINE,'(''Drolim       :'',G12.4)') D_ROLIM(IMOD) 
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(''Drad         :'',G12.4)') D_RAD(IMOD)   
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(''Drad_inertia :'',F10.3)') D_RADI(IMOD)  
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(''Drad_pack    :'',F10.3)') D_RAD_PACK(IMOD) 
      CALL MSGDOC(MDOC,LINE)
C ====
C      DENS_RESOL    = D_RESOL(IMOD)
c ---
      IF(LIST.EQ.'L'.OR.LIST.EQ.'T') THEN
        NAMES  = 'molrep_mod_dns.ps'  
        CALL ADD_PATH(PATH_SCR,NAMES)
        TITLE = '-- MAP of model --'      
C        COEF  = COEF_IN      
C        IF(COEF.LE.0.0001) COEF  = 4.0
        COEF  = 4.0
        NLEV  = 6 
        CALL PRINT_DENS_TO_PS(MDOC,NAMEC,NAMES
     *  ,TITLE,COEF,NLEV,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) RETURN
      ENDIF
      CALL MSGDOC(MDOC,'---------------------')
C -----------------------
      RETURN
      END

      SUBROUTINE PRINT_DENS_TO_PS(MDOC,NAMEC,NAMES
     *  ,TITLE,COEF,NLEV,ISYM,IPRSYM,IERR)
C ---------------------------------
      INTEGER   MDOC,IPRSYM,NLEV
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      COEF
      CHARACTER NAMES*(*),NAMEC*(*),TITLE*(*)
C ----
      integer*2,  allocatable :: IR(:)
      integer*2,  allocatable :: IRM(:)
      real,       allocatable :: R(:)

      CHARACTER TYPE*4,TTT*80
C ---------------------------------
      IERR   = 0
      MD     = -ABS(MDOC)-1
      M      = 99
C ----
      MT    = 10
      TYPE  = 'RI  '
      CALL ORFILE(M,MT,NAMEC,TYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE-DENS')
        RETURN
      ENDIF
      CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *        ,F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TTT,IERR)
      CLOSE(MT)
      IF(IERR.GT.0) RETURN
C ----
      NXY=NX*NY
      IT = 0
      allocate(IR(1:NXY),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(IRM(1:NXY),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(R(1:NXY),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      IF(IT.GT.0) THEN
        IERR = 1
        CALL MSGERR(MDOC,
     *  ' ERROR: in PRINT_DENS_TO_PS: problem with memory allocation')
        CALL MSGERR(MDOC,
     *    '                           try to change resolution')
        RETURN
      ENDIF

      CALL  DENS_PS(MDOC,NAMEC,NAMES,TITLE,COEF,NLEV
     *         ,R,IR,IRM
     *         ,NXY,NXY,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) RETURN   

      deallocate(IR,STAT=ISTAT)
      deallocate(IRM,STAT=ISTAT)
      deallocate(R,STAT=ISTAT)

C -----------------------
      RETURN
      END

      SUBROUTINE MOLREP_CLEAN(LIST,PATH,PATH_OUT)
C --------------------------------------
      CHARACTER NAME*256,LIST*1,PATH*(*),PATH_OUT*(*)
      CHARACTER CH4*4
C --------------------------------------
       NAME='molrep_dimer.crd'
       CALL DELETE_FILE(PATH_OUT,NAME)
       NAME='molrep_nmr_tmp.pdb'
       CALL DELETE_FILE(PATH,NAME)
       NAME='molrp_f2.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='molrp_ph2.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='molrp_scr.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME='molrp_scr.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='molrp_scr.pdb'
       CALL DELETE_FILE(PATH,NAME)
       NAME='molrp_scr1.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='molrp_scr9.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='molrp_tmp.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME='molrp_dns.dat'
       CALL DELETE_FILE(PATH,NAME)
       IF(LIST.EQ.'S') THEN
         NAME='molrep_dns.dat'
         CALL DELETE_FILE(PATH,NAME)
       ENDIF
       NAME='crossrt_al1.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='crossrt_al2.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='crossrt_al3.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='crossrt_al4.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='crossrt_al5.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='scratch.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='crossrt_scr.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME='toblanc.cif'
       CALL DELETE_FILE(PATH,NAME)
       NAME='crossrt_scr1.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME='crossrt_f.dat'
       CALL DELETE_FILE(PATH,NAME)
       IF(LIST.EQ.'S') THEN
         NAME='crossrot_ff.dat'
         CALL DELETE_FILE(PATH,NAME)
         NAME='molrep_fobs_LH.dat'
         CALL DELETE_FILE(PATH,NAME)
         NAME='molrep_model_start.pdb'
         CALL DELETE_FILE(PATH,NAME)
       ENDIF
       NAME='crossrt_fsc.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='crossrt_ph.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn.scr'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_ph.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_ph2.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_f.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_fon.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_f2.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_f2n.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_scr.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_scr1.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_scr2.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_scr2.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='scratch.rft.dat'
       CALL DELETE_FILE(PATH,NAME)
       IF(LIST.EQ.'S') THEN
         NAME='molrep_fob.dat'
         CALL DELETE_FILE(PATH,NAME)
         NAME='molrep_ph.dat'
         CALL DELETE_FILE(PATH,NAME)
       ENDIF
       NAME='molrp_fob.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME= 'molrep_fbadd.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME= 'molrep_fcalc_tmp.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='molrp_ha.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_f_pk.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_f2_pk.dat'
       CALL DELETE_FILE(PATH,NAME)
c       IF(LIST.EQ.'S') THEN
         NAME='trfun_pack.dat'
         CALL DELETE_FILE(PATH,NAME)
         NAME='trfun_trn.dat'
         CALL DELETE_FILE(PATH,NAME)
c       ENDIF
       NAME='trfn_scr9.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_scr9.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_scr3.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_scr3.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_f3.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_ph3.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='crossrt_scr.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='crossrt_scr1.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='crossrt_scr2.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='crossrt_scr3.dat'
       CALL DELETE_FILE(PATH,NAME)
       IF(LIST.EQ.'S') THEN
         NAME='crossrot_alm.dat'
         CALL DELETE_FILE(PATH,NAME)
         NAME='crossrot_alo.dat'
         CALL DELETE_FILE(PATH,NAME)
         NAME='crossrot_dns.dat'
         CALL DELETE_FILE(PATH,NAME)
         NAME='crossrot_dns_model'
         CALL DELETE_FILE(PATH,NAME)
       ENDIF
       NAME='rotfft.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME='rotfft_dm.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='rotfft_do.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='rotfft_f.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='rotfft_grd.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME='rotfft_ph.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='rotfft_scr.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME='rotfft_scr1.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME='rotfft_scr2.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME='rotfft_scr.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='rotfft_scr1.dat'
       CALL DELETE_FILE(PATH,NAME)
       IF(LIST.NE.'T') THEN
         NAME='trfn_ph_pk.dat'
         CALL DELETE_FILE(PATH,NAME)
         NAME='trfn_ph2_pk.dat'
         CALL DELETE_FILE(PATH,NAME)
         NAME='trfn_scr.dat'
         CALL DELETE_FILE(PATH,NAME)
         NAME='trfun.crd'
         CALL DELETE_FILE(PATH,NAME)
         NAME='trfun_cf.dat'
         CALL DELETE_FILE(PATH,NAME)
         NAME='trfun_cf_pk.dat'
         CALL DELETE_FILE(PATH,NAME)
         NAME='trfun_dns.dat'
         CALL DELETE_FILE(PATH,NAME)
         NAME='trfun_pack.dat'
         CALL DELETE_FILE(PATH,NAME)
         NAME='trfun_trn.dat'
         CALL DELETE_FILE(PATH,NAME)
       ENDIF
       IF(LIST.EQ.'S') THEN
         NAME='molrp_diff.dat'
         CALL DELETE_FILE(PATH,NAME)
       ENDIF
       NAME='molrep2.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME='molrep3.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME='molrepx.crd'
       CALL DELETE_FILE(PATH,NAME)
       IF(LIST.EQ.'S') THEN
         NAME='molrep1.crd'
         CALL DELETE_FILE(PATH,NAME)
         NAME='trfun_saptf.dat'
         CALL DELETE_FILE(PATH,NAME)
         NAME = 'molrep_saptf.tab'
         CALL DELETE_FILE(PATH,NAME)
         NAME = 'molrep_saptf.ps'
         CALL DELETE_FILE(PATH,NAME)
         NAME = 'molrep_dns.ps'
         CALL DELETE_FILE(PATH,NAME)
       ENDIF
       NAME='molrp_ph.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='molrep_scr.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='molrep3.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME='molrep4.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME= 'molrep_pst.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME= 'molrep_pst1.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME= 'molrep_pst2.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME='molrp_ph_mod2.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='molrp_fdiff.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_f_p1.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_fc.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_ph_p1.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_phc.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_fo.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_fo_pk.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_pho.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_pho_pk.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_scr1.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_mod1.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_mod2.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_mod12.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME='trfn_best.crd'
       CALL DELETE_FILE(PATH,NAME)
       NAME='molrp_f.dat'
       CALL DELETE_FILE(PATH,NAME)
       NAME='molrp_fder.dat'
       CALL DELETE_FILE(PATH,NAME)
       IF(LIST.EQ.'S') THEN
c         NAME='molrep_fobs_new.dat'
c         CALL DELETE_FILE(PATH,NAME)
         NAME='molrp_Fobs_diff.dat'
         CALL DELETE_FILE(PATH,NAME)
         NAME='selfrot_srf.dat'
         CALL DELETE_FILE(PATH,NAME)
       ENDIF
      NAME='molrep_ph1.dat'
      CALL DELETE_FILE(PATH,NAME)
      NAME='trfn_fn.dat'
      CALL DELETE_FILE(PATH,NAME)
      NAME='trfn_f12.dat'
      CALL DELETE_FILE(PATH,NAME)
      NAME='trfn_ph12.dat'
      CALL DELETE_FILE(PATH,NAME)
      NAME='trfn_f12_pk.dat'
      CALL DELETE_FILE(PATH,NAME)
      NAME='trfn_ph12_pk.dat'
      CALL DELETE_FILE(PATH,NAME)
      NAME='molrp_scratch_rdc.dat'
      CALL DELETE_FILE(PATH,NAME)
      IF(LIST.EQ.'S') THEN
        NAME='molrep_fobs.dat'
        CALL DELETE_FILE(PATH,NAME)
        NAME='molrep_ph.dat'
        CALL DELETE_FILE(PATH,NAME)
      ENDIF
      NAME='molrp_scr.crd'
      CALL DELETE_FILE(PATH,NAME)
      NAME='molrp_scr1.crd'
      CALL DELETE_FILE(PATH,NAME)
      NAME='trfun_dns1.dat'
      CALL DELETE_FILE(PATH,NAME)
      NAME='trfun_dns2.dat'
      CALL DELETE_FILE(PATH,NAME)
      IF(LIST.NE.'T') THEN
        NAME='trfun_dns3.dat'
        CALL DELETE_FILE(PATH,NAME)
      ENDIF
      NAME='molrp_src.crd'
      CALL DELETE_FILE(PATH,NAME)
      NAME='molrep_stop_signal.xml'
      CALL DELETE_FILE(PATH,NAME)

      NAME='molrp_coef_mask.dat'
      CALL DELETE_FILE(PATH,NAME)
      IF(LIST.EQ.'S') THEN
        NAME='molrp_dns_mask.dat'
        CALL DELETE_FILE(PATH,NAME)
      ENDIF
      NAME='molrp_f_mask.dat'
      CALL DELETE_FILE(PATH,NAME)
      NAME='molrp_mask.dat'
      CALL DELETE_FILE(PATH,NAME)
      NAME='molrp_ph_mask.dat'
      CALL DELETE_FILE(PATH,NAME)
      NAME='align.crd'
      CALL DELETE_FILE(PATH,NAME)
      NAME='align_2_scr.pdb'
      CALL DELETE_FILE(PATH,NAME)
      DO I=1,200
        WRITE(CH4,'(I4)') I
        IF(CH4(1:1).EQ.' ') CH4(1:1) = '_'
        IF(CH4(2:2).EQ.' ') CH4(2:2) = '_'
        IF(CH4(3:3).EQ.' ') CH4(3:3) = '_'
        NAME='crossrot_alo'//CH4//'.dat'
        CALL DELETE_FILE(PATH,NAME)
      ENDDO
      DO I=1,200
        WRITE(CH4,'(I4)') I
        IF(CH4(1:1).EQ.' ') CH4(1:1) = '_'
        IF(CH4(2:2).EQ.' ') CH4(2:2) = '_'
        IF(CH4(3:3).EQ.' ') CH4(3:3) = '_'
        NAME='trfn_f'//CH4//'.dat'
        CALL DELETE_FILE(PATH,NAME)
        NAME='trfn_ph'//CH4//'.dat'
        CALL DELETE_FILE(PATH,NAME)
        NAME='trfn_f_pk'//CH4//'.dat'
        CALL DELETE_FILE(PATH,NAME)
        NAME='trfn_ph_pk'//CH4//'.dat'
        CALL DELETE_FILE(PATH,NAME)
      ENDDO
      RETURN
      END

      SUBROUTINE GET_PATH_OUT(LINE,PATH)
C -------------------------------------------------------------
      INTEGER   LEN,LLL
      CHARACTER LINE*(*),PATH*(*)
C -------------------------------------------------------------
      LLL = 0
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.GT.0) THEN
        DO I=1,LEN
          IF(LINE(I:I).NE.' ') THEN
            LLL = I
            GO TO 10
          ENDIF
        ENDDO
      ENDIF
  10  CONTINUE
      IF(LLL.GT.0) THEN
        LINE = LINE(LLL:LEN)
        LEN  = LEN - LLL + 1
        IF(LEN.LE.1) RETURN
        IF(LINE(1:1).NE.'>') RETURN
        LINE = LINE(2:LEN)
        LEN  = LEN - 1
        PATH = LINE(1:LEN)    
        CALL CORR_NAME_BLC(PATH)
        CALL LENSTR_BL(PATH,LEN)
        IF(LEN.LE.0) THEN
          PATH = ' '    
        ENDIF
      ENDIF
      RETURN
      END


      SUBROUTINE DELETE_FILE(PATH,NAME)
C -------------------------------------------------------------
      INTEGER   MT,LEN
      CHARACTER NAME*(*),PATH*(*),FNAME*256
      logical ex
      integer nfile
C -------------------------------------------------------------
      CALL LENSTR_BL(PATH,LEN)
      IF(LEN.GT.0.AND.PATH(1:1).NE.',') THEN
        FNAME = PATH(1:LEN)//NAME
      ELSE
        FNAME = NAME       
      ENDIF
      MT=10
      inquire(file=fname,exist=ex,number=nfile)
      if(nfile.gt.6 .and. nfile.lt.100) close(nfile)
      if(ex) then
        OPEN(UNIT=MT,FILE=FNAME,ACCESS='SEQUENTIAL',ERR=10)
        CLOSE(MT,STATUS='DELETE',ERR=10)
      endif
 10   CONTINUE
      RETURN
      END  

      SUBROUTINE CHECK_STOP_SIGNAL(PATH,ISIGNAL)
C -------------------------------------------------------------
      INTEGER   MT,LEN,ISIGNAL
      CHARACTER NAME*256,PATH*(*),FNAME*256
C -------------------------------------------------------------
      ISIGNAL = 0
      NAME = 'molrep_stop_signal.xml'
      CALL LENSTR_BL(PATH,LEN)
      IF(LEN.GT.0.AND.PATH(1:1).NE.',') THEN
        FNAME = PATH(1:LEN)//NAME
      ELSE
        FNAME = NAME       
      ENDIF
      MT=10
      OPEN(UNIT=MT,FILE=FNAME,ACCESS='SEQUENTIAL',ERR=10
     *  ,FORM='FORMATTED',STATUS='OLD')
      CLOSE(MT,ERR=10)
      ISIGNAL = 1
      RETURN      
 10   CONTINUE
      ISIGNAL = 0
      RETURN
      END  

      SUBROUTINE ADD_PATH(PATH,NAME)
C -------------------------------------------------------------
      INTEGER   LEN
      CHARACTER NAME*(*),PATH*(*),FNAME*256
C -------------------------------------------------------------
      CALL LENSTR_BL(PATH,LEN)
      IF(LEN.GT.0.AND.PATH(1:1).NE.',') THEN
        FNAME = PATH(1:LEN)//NAME
        NAME  = FNAME
      ENDIF
      RETURN
      END  

      SUBROUTINE MOLREP_RUN(MDOC,NAMEF,NAMEM
     * ,NAME2,NAME_PH,NAME_TAB,NAMEM_2,NAME_TAB2,NAME_TSRF
     * ,NAMEF_DIFF
     * ,FPAR_MR,INT_PARAM,PAR_MR
     * ,ANGLES,CVECTOR,SPST
     * ,SPGR_INP
     * ,ISYM,IPRSYM
     * ,PATH_SCR,PATH_OUT
     * ,RESULT,RESULT2,RESULT3,RESULTA,IPRMAX,IPRROW,IERR)
C --------------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
C ----
      REAL      RESULT    (IPRMAX,IPRROW)
      REAL      RESULT2   (IPRMAX,IPRROW)
      REAL      RESULT3   (IPRMAX,IPRROW)
      REAL      RESULTA   (IPRMAX,IPRROW)
c     REAL      RESULTB   (21,21)

C     PARAMETER ( IPRCYCL=10  )
C     PARAMETER ( IPRCYCL=20  )
C     PARAMETER ( IPRCYCL=50  )
      PARAMETER ( IPRCYCL=200 )

      REAL      CORR(IPRCYCL),RFAC(IPRCYCL)
      REAL      TALPHA(IPRCYCL),TGAMMA(IPRCYCL),TBETA(IPRCYCL)
      REAL      TALPHA2(IPRCYCL),TGAMMA2(IPRCYCL),TBETA2(IPRCYCL)
      REAL      TALPHA_NEW(IPRCYCL),TGAMMA_NEW(IPRCYCL)
     *         ,TBETA_NEW(IPRCYCL)
      REAL      TXSH(IPRCYCL),TYSH(IPRCYCL),TZSH(IPRCYCL)
      REAL      TALPHA_BEST,TGAMMA_BEST,TBETA_BEST
      REAL      PRF_SH(3,IPRCYCL)
      REAL      TXSH_BEST,TYSH_BEST,TZSH_BEST
      INTEGER   INDEX_PRF(IPRCYCL) 
      REAL      OXS(3),FXS(3)
      REAL      PEAK_TEST(12,IPRCYCL)
      REAL      FPAR_TR(20)
      INTEGER   IPAR_TR(20)
C ---
      CHARACTER NAMEF_DIFF*(*),NAMEM_2*(*),NAME_TAB2*(*),NAME_TSRF*(*)
      CHARACTER NAMEF*(*),NAMEM*(*),NAME2*(*),NAME_PH*(*),NAME_TAB*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)

      CHARACTER NAMEC*256,NAMEO*256,NAMEF_ROT*256,NAMET_OUT*256
      CHARACTER NAMES*256,NAMED*256,NAMEFM*256,NAMEPH*256
      CHARACTER NAMEFM2*256,NAMEPH2*256,NAME_PS*256
      CHARACTER NAMEC2*256,NAMES1*256,NAMES2*256,NAMET*256
      CHARACTER NAME_FCALC*256,NAME_PHCALC*256,NAME_DIMER*256
      CHARACTER NAME(10)*256

      CHARACTER SPGR_INP*(*)

      CHARACTER SELF*1,MODE_D*1,TTT1*80
      CHARACTER LINE*256,TTT*80,ITYPE*4,P1*1,MODE*1,WAT*1,ALT*1,FUN*1
      CHARACTER MOD2*1,FUNC*1,ACCUM*1,REMOV*1,INVER*1,MISS*1,GAUSS*1
      CHARACTER REST*1,SETT*1,HATM*1,NUM*1,NOCC*1,PACK*1,FIT_MODE*1
      CHARACTER TITLE*80,REF*1,SUM*1,REFP*1,TFUN*1,LIST*1
      CHARACTER REFS*1,REFB*1,REFA*1,REFX*1,DOM*1,RFAC_FLAG*1,CALC2*1
      CHARACTER ANISO*1,SOLV*1,PATT*1,ANISO_R*1,ANISO_T*1,MODE_T*1
      CHARACTER PST*1,SURF*1,REF_TEMP*1,CTEST*1,MOD2_INI*1,DYAD*1
      CHARACTER PRF*1,FITT*1,FAST*1,MSHIFT*1,DIFF*1,TEST_SRF*1,STICK*1
      CHARACTER MOD1*1,MOD2S*1,LOCK*1,ALL*1,CCP4*1,SURFX*1

      CHARACTER PARM_RF*16,PARM_TR*30
      INTEGER   IPARM_RF(20)

      REAL      AM(3,3),SH1(3),SH2(3),ANGLES(3),CVECTOR(3),SPST(3)
C ---
      CHARACTER PAR_MR*30
      INTEGER   INT_PARAM(30)
      REAL      FPAR_MR(30)
C ---
      REAL      RLATT_F(6)
      INTEGER   NSPGROUP_F,NOSETT_F
      CHARACTER CODE*4,DATE*9,SPGR_F*24,NAME_F*256

      CHARACTER MODE_F*1,STOP_T*1,DB_INPUT*1
      CHARACTER LAP*1,MSGA*1,SPEC*1,MODE2*2,ANISO_CORR*1
C --------------------------------------------------------------------
      COMMON/COM_DPOOL/ IPOOL_MAX,IPOOL_CURR
C ------------------------------------------------------------
      COMMON/TRFUN_COM_TMP/ FOBS_000,FMOD1_000,FMOD2_000,NEL2,IERR_PK
     *                     ,SCALEP_STORE,BOVER_STORE,SIGMA_STORE
C -------------------------------------------------------------
C DENS - FAST = 'F',DYAD = 'N',NMR = 0,PST = 'N',SURF = 'O',STICK = 'N'
C                  ,REF = 'N'
C
      PI     = 4.0*ATAN(1.0)
      RTODEG = 180./PI
      DEGTOR = 1.0/RTODEG
      MD     =-ABS(MDOC)-1
      M      = 99
      MD0    = 0
      IERR   = 0
      FOBS_000  = 0.0
      FMOD1_000 = 0.0
      FMOD2_000 = 0.0
      NEL2      = 0
      IERR_PK   = 0
C ---
      CHI_IN    = FPAR_MR( 1) 
      COEF_IN   = FPAR_MR( 2) 
      RESN_R    = FPAR_MR( 3) 
      RESN_T    = FPAR_MR( 4) 
      RESX      = FPAR_MR( 5) 
      COMPL     = FPAR_MR( 6)  
      QUAL      = FPAR_MR( 7) 
      BOFFR     = FPAR_MR( 8) 
      BADDR     = FPAR_MR( 9) 
      ARAD      = FPAR_MR(10)  
      PERCENT_1 = FPAR_MR(11) 
      PERCENT_2 = FPAR_MR(12)   
      BLIM      = FPAR_MR(13)   
      RESN_SCL  = FPAR_MR(14)
      DIST_MIN  = FPAR_MR(15) 
      DIST_MAX  = FPAR_MR(16) 
      DIST_DPAR = FPAR_MR(17) 
      DELTA     = FPAR_MR(18)  
      CHI_DYAD  = FPAR_MR(19)
      BADD_SCL  = FPAR_MR(20)
      RSMAX_RB  = FPAR_MR(21)
      RMS_INPUT = FPAR_MR(22)
      DLIM_RF   = FPAR_MR(23)
      RAD_MODEL = FPAR_MR(24)  

      NPEAK    = INT_PARAM(1) 
      NPT      = INT_PARAM(2) 
      NMON     = INT_PARAM(3) 
      LMIN_INP = INT_PARAM(4)
      LMAX_INP = INT_PARAM(5)
      IDUMMY   = INT_PARAM(6)
      NP_SRF   = INT_PARAM(7) 
      NPT_DM   = INT_PARAM(8)
      NMR      = INT_PARAM(9) 
      N_MODEL  = INT_PARAM(10)
      NPEAK2   = INT_PARAM(11) 
      NREF     = INT_PARAM(12) 
      NREFP    = INT_PARAM(13) 
      NREFR    = INT_PARAM(14) 
      NCS      = INT_PARAM(15) 
      NCS_MODEL= INT_PARAM(16) 
      NOSPGR   = INT_PARAM(17) 
      NMON_EXPECTED = INT_PARAM(18) 
      NML      = INT_PARAM(19) 

      SUM   = PAR_MR(1:1)
      ANISO = PAR_MR(2:2)
      PACK  = PAR_MR(3:3)
      FUN   = PAR_MR(4:4)
      TFUN  = PAR_MR(5:5)
      REF   = PAR_MR(6:6)
      REFP  = PAR_MR(7:7)
      LIST  = PAR_MR(8:8)
      SELF  = PAR_MR(9:9)
      PST   = PAR_MR(10:10)
      SURF  = PAR_MR(11:11)
      INVER = PAR_MR(12:12)
      PRF   = PAR_MR(13:13)
      FITT  = PAR_MR(14:14)
      FAST  = PAR_MR(15:15)
      CTEST = PAR_MR(16:16)
      DIFF  = PAR_MR(17:17)
      MODE_T= PAR_MR(18:18)
      TEST_SRF = PAR_MR(19:19)
      DYAD  = PAR_MR(20:20) 
      STICK = PAR_MR(21:21) 
      MOD1  = PAR_MR(22:22) 
      MOD2  = PAR_MR(23:23) 
      MOD2S = PAR_MR(24:24) 
      LOCK  = PAR_MR(25:25) 
      ALL   = PAR_MR(26:26) 
      CCP4  = PAR_MR(27:27) 
      ANISO_CORR = PAR_MR(28:28) 
      DB_INPUT = PAR_MR(29:29) 
      SURFX = PAR_MR(30:30) 

      NMONR = NMON
      IF(NMON_EXPECTED.LE.0) NMON_EXPECTED = NMONR
C ---
      IF(MDOC.GT.0.AND.MDOC.LT.99) THEN
        MDOC=1
C       IF(LIST.EQ.'S') MDOC=2
      ELSE IF(MDOC.LT.0.AND.MDOC.GT.-99) THEN
        MDOC=-1
C       IF(LIST.EQ.'S') MDOC=-2
      ENDIF
C     IF(ABS(MDOC).EQ.2) MD=99
      IF(LIST.EQ.'S') MD=99
C --------------------------------------------------------------
      MTN   = 10
      ITYPE = 'FF  '
      CALL ORFILE(M,MTN,NAMEF,ITYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: can not open input file: F_obs')
        RETURN
      ENDIF
      CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *  ,F1,F2,RESMIN,RESMAX,IDM,IDM,IDM,IDM,IDM,TTT,IERR)
      CLOSE(MTN)
C ------------------------------------------------------------
      CALL GET_CELL(RLATT_F,CODE,TTT1,DATE,TTT
     *   ,NSPGROUP_F,NOSETT_F,SPGR_F,NSM,IERR)
      LINE = ' Space group : '//SPGR_F
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' No:'',I4,'' Sett:'',I4)') 
     *  NSPGROUP_F,NOSETT_F
      CALL MSGDOC(MDOC,LINE)
      RLATT_F(4) = RLATT_F(4)*RTODEG
      RLATT_F(5) = RLATT_F(5)*RTODEG
      RLATT_F(6) = RLATT_F(6)*RTODEG
      WRITE(LINE,'('' Cell:'',3F8.3,3F8.2)') (RLATT_F(I),I=1,6)
      CALL MSGDOC(MDOC,LINE)
C -------------------------------------------------------------
      MODE_D = 'N'
      CALL LENSTR_BL(NAME_PH,LEN)
      IF(LEN.GT.0.AND.NAME_PH(1:1).NE.' '.AND.NAME_PH(1:1).NE.',') THEN
        MODE_D = 'D'
      ENDIF
C ----
      BOFF = BOFFR
      BADD = BADDR
C ---
      IF(RESX.GT.0.00001) RESMAX=RESX
      IF(RESMIN.LT.RESMAX) THEN
        T      = RESMIN
        RESMIN = RESMAX
        RESMAX = T
      ENDIF
      IF(RESMIN.EQ.RESMAX) THEN
        CALL MSGERR(MDOC,' ERROR: resmin = resmax')
        IERR=1
        RETURN
      ENDIF
c ---------
      CALL RESOLUTION_LIMIT_FOR_TF(RESMAX_FOR_TF)
C ----------
      ISYM_DYAD  = 1
C     IF(NPEAK.LT.0) ISYM_DYAD = 0
      IF(ALL.EQ.'Y') ISYM_DYAD = 0

      NPEAK = ABS(NPEAK)
      NPEAK_INP = NPEAK 
      IF(NPEAK.LE.0) THEN
        IF(DIFF.EQ.'M'.OR.
     *     PRF.EQ.'Y'.OR.PRF.EQ.'S'.OR.PRF.EQ.'P') THEN
c         NPEAK=100
          NPEAK=50
        ELSE
          NPEAK=30
        ENDIF  
      ENDIF  
      IF(NPEAK.GT.IPRCYCL)  NPEAK=IPRCYCL

      NPEAK2_INP = NPEAK2 
      IF(NPEAK2.GT.IPRCYCL) NPEAK2=IPRCYCL
      IF(NPEAK2.LE.0.AND.DYAD.NE.'N') NPEAK2=30

      IF(NPT.LE.0.AND.DYAD.EQ.'N') NPT=15

      ANISO_R = 'N'
      ANISO_T = 'N'
      IF(ANISO.EQ.'Y'.OR.ANISO.EQ.'C') THEN
        ANISO_R = 'Y'
      ELSE IF(ANISO.EQ.'K') THEN
        ANISO_R = 'K'
      ENDIF
      IF(ANISO.EQ.'Y'.OR.ANISO.EQ.'S') THEN
        ANISO_T = 'Y'
      ELSE IF(ANISO.EQ.'K') THEN
        ANISO_T = 'K'
      ENDIF
C -------------------------------------------------
      NAMES   = ' '
      NAMES1  = ' '
      NAMES2  = ' '
      NAME_PS   = 'molrep_rf.ps'
      CALL ADD_PATH(PATH_OUT,NAME_PS)
      NAMEC   = 'molrp_tmp'
      CALL ADD_PATH(PATH_SCR,NAMEC)
      NAMEO   = 'molrep'
      CALL ADD_PATH(PATH_SCR,NAMEO)
      NAMED   = 'molrp_dns'
      CALL ADD_PATH(PATH_SCR,NAMED)
      NAMEFM  = 'molrp_f'
      CALL ADD_PATH(PATH_SCR,NAMEFM)
      NAMEPH  = 'molrp_ph'
      CALL ADD_PATH(PATH_SCR,NAMEPH)
      NAMEFM2 = 'molrp_f2'
      CALL ADD_PATH(PATH_SCR,NAMEFM2)
      NAMEPH2 = 'molrp_ph2'
      CALL ADD_PATH(PATH_SCR,NAMEPH2)
      NAMEC2  = 'molrp_scr'
      CALL ADD_PATH(PATH_SCR,NAMEC2)
      NAME_DIMER  = 'molrep_dimer'
      CALL ADD_PATH(PATH_OUT,NAME_DIMER)
C ----------------------------------
      MOD2_INI = MOD2     
      PEAK_TEST(12,1) = 0       
      IF(STICK.EQ.'Y'.AND.MOD1.EQ.'Y') THEN
        PEAK_TEST(12,1) = 0       
        IF(MOD2_INI.EQ.'Y') THEN
          MODE  = 'E'
          NAMES = ' '
          DO I=1,3
            SH1(I) = 0.0
            SH2(I) = 0.0
            DO J=1,3
              AM(I,J) = 0.0
            ENDDO
          ENDDO
          ALPHA1 = 0.0
          BETA1  = 0.0
          GAMMA1 = 0.0
          CALL TRANS(M,NAME2,NAMES,SH1,SH2
     *      ,MODE,AM,ALPHA1,BETA1,GAMMA1,RESULT,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
          SH1(1) = RESULT( 8,1)
          SH1(2) = RESULT( 9,1)
          SH1(3) = RESULT(10,1)
          CALL OTOF(SH1,SH2,IERR)
          WRITE(LINE,'(''Centre of model2 /fract/   :'',3F8.3)') 
     *    SH2(1),SH2(2),SH2(3)
          CALL MSGDOC(MDOC,LINE)
C          SPST(1) = SH2(1)
C          SPST(2) = SH2(2)
C          SPST(3) = SH2(3)
          PEAK_TEST( 1,1) = 0
          PEAK_TEST( 2,1) = 0
          PEAK_TEST( 3,1) = 0
          PEAK_TEST( 4,1) = 0
          PEAK_TEST( 5,1) = 0
          PEAK_TEST( 6,1) = 0
          PEAK_TEST( 7,1) = 0
          PEAK_TEST( 8,1) = 0
          PEAK_TEST( 9,1) = SH2(1)
          PEAK_TEST(10,1) = SH2(2)
          PEAK_TEST(11,1) = SH2(3)
          PEAK_TEST(12,1) = 1
        ELSE
          PEAK_TEST( 1,1) = 0
          PEAK_TEST( 2,1) = 0
          PEAK_TEST( 3,1) = 0
          PEAK_TEST( 4,1) = 0
          PEAK_TEST( 5,1) = 0
          PEAK_TEST( 6,1) = 0
          PEAK_TEST( 7,1) = 0
          PEAK_TEST( 8,1) = 0
          PEAK_TEST( 9,1) = 0
          PEAK_TEST(10,1) = 0
          PEAK_TEST(11,1) = 0
          PEAK_TEST(12,1) = 0
          IF(DYAD.EQ.'N') PEAK_TEST(12,1) = 1       

c          PEAK_TEST(12,1) = 0       

        ENDIF
C      ELSE IF(CTEST.EQ.'4') THEN
C        PEAK_TEST( 1,1) = 0
C        PEAK_TEST( 2,1) = 0
C        PEAK_TEST( 3,1) = ANGLES(1)
C        PEAK_TEST( 4,1) = ANGLES(2)
C        PEAK_TEST( 5,1) = ANGLES(3)
C        PEAK_TEST( 6,1) = 0
C        PEAK_TEST( 7,1) = 0
C        PEAK_TEST( 8,1) = 0
C        PEAK_TEST( 9,1) = SPST(1)
C        PEAK_TEST(10,1) = SPST(2)
C        PEAK_TEST(11,1) = SPST(3)
C        PEAK_TEST(12,1) = 1
      ENDIF
C -----------------------------------
C ???
      REF_TEMP = 'N'
C      IF(PERCENT_2.GE.200.0) THEN
C        REF_TEMP  = 'Y'
C        PERCENT_2 = 0.0
C      ENDIF
C ???
C -----------------------------------

      IF(RESN_R.GT.0.00001) THEN
c        BOFF_ROT= 4.0 * RESN_R * RESN_R
        BOFF_ROT= 2.0 * RESN_R * RESN_R
      ELSE
        BOFF_ROT = BOFF
      ENDIF
       
      IF(RESN_SCL.GT.0.00001) THEN
c        BOFF_SCL = 4.0 * RESN_SCL * RESN_SCL
        BOFF_SCL = 2.0 * RESN_SCL * RESN_SCL
      ELSE
        BOFF_SCL = 256.0
      ENDIF

      RES_ROT = RESMAX

      IF(PRF.NE.'N') THEN
c        IF(FUN.EQ.'T') FUN = 'A'
c        IF(FUN.EQ.'L') FUN = 'A'
      ENDIF

C -----------------------------------
      IF(SELF.NE.'Y') THEN

        CALL LENSTR_BL(NAME_TAB,LEN)
        IF(LEN.LE.0.OR.NAME_TAB(1:1).EQ.','.OR.
     *                 NAME_TAB(1:1).EQ.' '    ) THEN
c          LINE = ' ERROR: can not open: file_tab (FILE_T)'
c          CALL MSGERR(MDOC,LINE)
c          IERR = 1
c          GO TO 900
          NAME_TAB = 'molrep_rf.tab'
          CALL ADD_PATH(PATH_SCR,NAME_TAB)
          IF(FUN.EQ.'T') THEN
C            FUN = 'T'
            N   = NPEAK
            IF(PRF.EQ.'N') THEN
              IF(NPEAK_INP.LE.0) N = 200
              CALL READ_TAB(MDOC,NAME_TAB,N,RESULT,IPRMAX,IPRROW)
            ELSE
              CALL READ_TAB_PRF(MDOC,NAME_TAB,N,RESULT,IPRMAX,IPRROW)
            ENDIF
            NP_TAB = RESULT(1,12) 
            IF(NP_TAB.LE.0) THEN
              LINE = ' ERROR: N_peaks = 0 : file_tab (molrep_rf.tab)'
              CALL MSGERR(MDOC,LINE)
              IERR = 1
              GO TO 900
            ENDIF
            IF(PRF.EQ.'N') GO TO 100
          ENDIF
        ELSE
          IF(FUN.EQ.'T') THEN
C            FUN = 'T'
            N   = NPEAK
            IF(PRF.EQ.'N') THEN
              IF(NPEAK_INP.LE.0) N = 200
              CALL READ_TAB(MDOC,NAME_TAB,N,RESULT,IPRMAX,IPRROW)
            ELSE
              CALL READ_TAB_PRF(MDOC,NAME_TAB,N,RESULT,IPRMAX,IPRROW)
            ENDIF
            NP_TAB = RESULT(1,12) 
            IF(NP_TAB.LE.0) THEN
              LINE = ' ERROR: N_peaks = 0 : file_tab (FILE_T)'
              CALL MSGERR(MDOC,LINE)
              IERR = 1
              GO TO 900
            ENDIF
C
C          NPEAK = NP_TAB
C
            IF(PRF.EQ.'N') GO TO 100

          ENDIF 
        ENDIF
      ENDIF

      CALL MSGDOC(MDOC,' ')
      NAMEF_ROT = NAMEF
      NAMES     = ' '
      NAMES1    = ' '

      IF(MOD1.NE.'Y'.OR.(MOD2 .NE.'N'.AND.MOD2 .NE.'Y').OR.
     *                  (MOD2S.NE.'N'.AND.MOD2S.NE.'Y')    ) SUM = 'N'  
      PARM_RF( 1: 1) = SUM
      PARM_RF( 2: 2) = ANISO_R
      PARM_RF( 3: 3) = SELF
      PARM_RF( 4: 4) = PST
      PARM_RF( 5: 5) = FUN
      PARM_RF( 6: 6) = CTEST
      PARM_RF( 7: 7) = LIST
      PARM_RF( 8: 8) = DIFF
      PARM_RF( 9: 9) = SURF
      PARM_RF(10:10) = PRF
      PARM_RF(11:11) = MOD1
      PARM_RF(12:12) = INVER
      PARM_RF(13:13) = LOCK
      PARM_RF(14:14) = ANISO_CORR
      PARM_RF(15:15) = DB_INPUT

      IF(SELF.EQ.'Y') THEN       
        IF(DIFF.EQ.'H') THEN
          NAMEF_ROT = NAMEF_DIFF
        ENDIF
        CALL MSGDOC(MDOC,' --- Self Rotation function ---')
        CALL MSGDOC(MDOC,' ')
        CALL SELFROT(MDOC,NAMEF_ROT,NAME_TSRF,NAME_PS,PATH_SCR
     *   ,RESMIN,RES_ROT,PARM_RF,CHI_IN,COEF_IN,NPEAK,BLIM
     *   ,RMS_INPUT,DLIM_RF,RAD_MODEL
     *   ,BOFF_ROT,BADD,BOFF_SCL,BADD_SCL,ARAD,LMIN_INP,LMAX_INP
     *   ,ISYM,IPRSYM
     *   ,RESULT3,IPRMAX,IPRROW,IERR)
        GO TO 900
      ELSE
        IF(DIFF.EQ.'P') THEN
          NAMEF_ROT = NAMEF_DIFF
        ELSE IF(DIFF.EQ.'D') THEN 
          NAMES1 = NAMEF_DIFF
        ELSE IF(DIFF.EQ.'F') THEN 
          NAMES1 = NAMEF_DIFF
        ELSE IF(DIFF.EQ.'M') THEN 
          NAMES1 = NAMEF_DIFF
        ENDIF
        IF(PRF.NE.'N') THEN
          NAMES = NAME_PH
          IF(PRF.EQ.'X') THEN
            CALL MSGDOC(MDOC,
     *        ' --- symmetry search ---')
            CALL MSGDOC(MDOC,'Sol_ ')
            CALL CROSSROT_SRCH(MDOC,NAMEF_ROT,NAMEM,NAMES,NAMES1
     *       ,NAME_TAB,PATH_SCR,NAME_TAB2,NPEAK2,RESMIN
     *       ,RES_ROT,PARM_RF,NPEAK,NPT_DM,CHI_IN,COEF_IN,BLIM
     *       ,BOFF_ROT,BADD,BOFF_SCL,BADD_SCL,ARAD,LMIN_INP,LMAX_INP
     *       ,ISYM,IPRSYM
     *       ,RESULT,RESULT2,RESULT3,IPRMAX,IPRROW,IERR)
            IF(IERR.NE.0) GO TO 900
            GO TO 900
          ENDIF
          IF(PRF.EQ.'Y') THEN
            CALL MSGDOC(MDOC,
     *      ' --- SAPTF and Phased Rotation function ---')
          ELSE IF(PRF.EQ.'P') THEN
            CALL MSGDOC(MDOC,
     *      ' --- Phased Rotation function ---')
          ELSE
            CALL MSGDOC(MDOC,
     *      ' --- SAPTF and Rotation function ---')
          ENDIF
          CALL MSGDOC(MDOC,' ')
          CALL CROSSROT_PH(MDOC,NAMEF_ROT,NAMEM,NAMES,NAMES1,NAME_TAB
     *         ,PATH_SCR,NAME_TAB2,NPEAK2,NCS,ANGLES,CVECTOR
     *    ,RESMIN,RES_ROT,PARM_RF,NPEAK,NPT_DM,CHI_IN,COEF_IN,BLIM
     *    ,BOFF_ROT,BADD,BOFF_SCL,BADD_SCL,ARAD,LMIN_INP,LMAX_INP
     *    ,RMS_INPUT,ISYM,IPRSYM
     *    ,RESULT,RESULT2,RESULT3,IPRMAX,IPRROW,IERR)
          IF(IERR.NE.0) GO TO 900
        ELSE
          IPARM_RF(1) = NPEAK
          IPARM_RF(2) = LMIN_INP
          IPARM_RF(3) = LMAX_INP
          IPARM_RF(4) = NMR
          IPARM_RF(5) = N_MODEL
          IPARM_RF(6) = NP_SRF
          IPARM_RF(7) = NREFR
          IPARM_RF(8) = 0
          IF(LOCK.EQ.'Y') THEN
            CALL MSGDOC(MDOC,' --- Locked Rotation function ---')
          ELSE IF(LOCK.EQ.'G') THEN
            CALL MSGDOC(MDOC,
     *      ' --- General Locked Rotation function ---')
          ELSE
            CALL MSGDOC(MDOC,' --- Rotation function ---')
          ENDIF
          CALL MSGDOC(MDOC,' ')

          IF(NPEAK_INP.LE.0) THEN
            NPEAK_MAX = NPEAK*2.0 
            IF(NPEAK_MAX.GT.IPRCYCL)  NPEAK_MAX=IPRCYCL
            IPARM_RF(8) = NPEAK_MAX
          ENDIF

          CALL CROSSROT(MDOC,NAMEF_ROT,NAMEM,NAMES1,NAME_TAB
     *    ,NAME_TSRF,PATH_OUT,PATH_SCR
     *    ,DELTA,RMS_INPUT,DLIM_RF,NCS_MODEL,NMON_EXPECTED
     *    ,RESMIN,RES_ROT,PARM_RF,IPARM_RF,CHI_IN,COEF_IN,BLIM
     *    ,BOFF_ROT,BADD,BOFF_SCL,BADD_SCL,ARAD
     *    ,ISYM,IPRSYM
     *    ,RESULT,RESULT2,RESULT3,IPRMAX,IPRROW,IERR)
          IF(IERR.NE.0) GO TO 900
        ENDIF
      ENDIF

C     IF(SELF.EQ.'Y') GO TO 900       
C -------------------------------------------------------------
C     RESULT(i,1) IX 
C     RESULT(i,2) IY
C     RESULT(i,3) IZ
C     RESULT(i,4) Dens
C     RESULT(i,5) sigma
C     RESULT(i,6) alpha      
C     RESULT(i,7) beta   
C     RESULT(i,8) gamma      
C
C     RESULT(1,12) N_PEAKS
C             alpha   beta    gamma   theta   phi     chi         Rf   Rf/sigma
C --------------------------------------------
      IF(FUN.EQ.'R') THEN
        NPROT = RESULT(1,12)
        IF(NPROT.LE.0) THEN
          CALL MSGERR(MDOC,
     *    ' ERROR: number of peaks of rotation function = 0')
          IERR=1
          GO TO 900 
        ENDIF
c        IF(MOD1.EQ.'Y'.AND.PRF.EQ.'N') THEN
        IF(MOD1.EQ.'Y') THEN
          MODE2  = 'EF'
          SH2(1) = 0.0
          SH2(2) = 0.0
          SH2(3) = 0.0
          IF(PRF.NE.'N') THEN
            SH2(1) = RESULT(1, 9)
            SH2(2) = RESULT(1,10)
            SH2(3) = RESULT(1,11)
          ENDIF
          ALPHA  = RESULT(1,6)
          BETA   = RESULT(1,7)
          GAMMA  = RESULT(1,8)
          DO I=1,3
c           SH2(I) = 0.0
            SH1(I) = 0.0
            DO J=1,3
              AM(I,J) = 0.0
            ENDDO
          ENDDO

          CALL TRANS(M,NAMEM,NAMEO,SH1,SH2
     *    ,MODE2,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
        ENDIF
        GO TO 900
      ENDIF
 100  CONTINUE

      NPROT = RESULT(1,12)
      IF(NPROT.LE.0) THEN
        CALL MSGERR(MDOC,
     *  ' ERROR: number of peaks of rotation function = 0')
        IERR=1
        GO TO 900 
      ENDIF
c      NPROT = RESULT(1,12)
c      IF(NPROT.LE.0) GO TO 900

c      IF(DYAD.EQ.'Y'.OR.DYAD.EQ.'D'.OR.DYAD.EQ.'M') THEN
      IF(DYAD.EQ.'Y'.OR.DYAD.EQ.'D') THEN
        IF(NPROT.GT.NPEAK) NPROT=NPEAK
      ENDIF

      IF(PRF.NE.'N'.AND.NMON.GT.NPROT) NMON = NPROT
      DO I=1,NPROT
        TALPHA(I) = RESULT(I,6)
        TBETA (I) = RESULT(I,7)
        TGAMMA(I) = RESULT(I,8)
        TALPHA_NEW(I) = RESULT(I,6)
        TBETA_NEW (I) = RESULT(I,7)
        TGAMMA_NEW(I) = RESULT(I,8)
        IF(PRF.NE.'N') THEN
          PRF_SH(1,I) = RESULT(I,9)
          PRF_SH(2,I) = RESULT(I,10)
          PRF_SH(3,I) = RESULT(I,11)

C          WRITE(LINE,'(I3,'' PRF_SH:'',3F8.3)')
C     *     I,PRF_SH(1,I),PRF_SH(2,I),PRF_SH(3,I)
C          CALL MSGDOC(MDOC,LINE)

        ELSE
          PRF_SH(1,I) = 0.0
          PRF_SH(2,I) = 0.0
          PRF_SH(3,I) = 0.0
        ENDIF
        INDEX_PRF(I) = 0 

      ENDDO

      NOUSED_RF = 0

C      IF(FAST.EQ.'F') THEN
C        IF(REF.EQ.'Y') THEN
C          FAST = 'M'
C        ENDIF
C      ENDIF

      IF(RESN_T.GT.0.00001) THEN
c        BOFF = 4.0 * RESN_T * RESN_T
        BOFF = 2.0 * RESN_T * RESN_T
      ENDIF
      IF(BOFF.LE.0.0000001) BOFF = 900

      IPOOL_MAX = 1
 
      IF(DIFF.EQ.'H') THEN
        NAMEF = NAMEF_DIFF
      ENDIF
 
      IF(RESMAX.LT.RESMAX_FOR_TF) RESMAX = RESMAX_FOR_TF
 
      CTEST = 'N'
      IF(DYAD.EQ.'Y'.OR.DYAD.EQ.'D'.OR.DYAD.EQ.'M') GO TO 1000
C  ================================================
      PARM_TR( 1: 1) = TFUN
      PARM_TR( 2: 2) = REFP
      PARM_TR( 3: 3) = REF
      PARM_TR( 4: 4) = PACK
      PARM_TR( 5: 5) = PST
      PARM_TR( 6: 6) = CCP4
      PARM_TR( 7: 7) = ANISO_T
      PARM_TR( 8: 8) = SURF
      PARM_TR( 9: 9) = REF_TEMP
      PARM_TR(10:10) = MOD2_INI
      PARM_TR(11:11) = INVER  
      PARM_TR(12:12) = PRF  
      PARM_TR(13:13) = FAST  
      PARM_TR(14:14) = FITT  
      PARM_TR(15:15) = MODE_T  
      PARM_TR(16:16) = CTEST
      PARM_TR(17:17) = STICK
      PARM_TR(18:18) = MOD1
      PARM_TR(19:19) = MOD2
      PARM_TR(20:20) = LIST
      PARM_TR(21:21) = DIFF
      PARM_TR(22:22) = SURFX

      FPAR_TR( 1) = RESMIN
      FPAR_TR( 2) = RESMAX
C      FPAR_TR( 3) = ALPHA
C      FPAR_TR( 4) = BETA
C      FPAR_TR( 5) = GAMMA
      FPAR_TR( 6) = BOFF
C      FPAR_TR( 7) = BOFFP
      FPAR_TR( 8) = BADD
      FPAR_TR( 9) = BLIM
C      FPAR_TR(10) = RSMIN_RB
C      FPAR_TR(11) = RSMAX_RB
      FPAR_TR(12) = BOFF_SCL
      FPAR_TR(13) = BADD_SCL
      FPAR_TR(14) = RSMAX_RB 
      FPAR_TR(15) = ARAD 
      FPAR_TR(19) = RAD_MODEL 
    
      IF(NMR.LT.2.OR.N_MODEL.LE.1) THEN

        NMR = 0
     
        CALL TRFUN_RUN(MDOC,NAMEF,NAMEM,NAME2,NAME_PH,PATH_SCR
     *  ,PATH_OUT
     *  ,NAME_DIMER,FPAR_TR,PARM_TR
     *  ,PEAK_TEST,PRF_SH,INDEX_PRF,TALPHA,TBETA,TGAMMA
     *  ,TALPHA_NEW,TBETA_NEW,TGAMMA_NEW
     *  ,NPROT,NPT,NMR,N_MODEL,NREF,NREFP,NMONR,NMON_EXPECTED,NSYM
     *  ,SPST,MODE_D,NCS,ANGLES,CVECTOR,NCS_MODEL,NOSPGR
     *  ,SPGR_INP
     *  ,ISYM,IPRSYM
     *  ,RESULT,RESULT2,RESULT3,IPRMAX,IPRROW,IERR)
        IF(IERR.NE.0) GO TO 900

      ELSE

        CALL TRFUN_NMR(MDOC,NAMEF,NAMEM,NAME2,NAME_PH,PATH_SCR
     *  ,PATH_OUT
     *  ,FPAR_TR,PARM_TR
     *  ,PEAK_TEST,PRF_SH,INDEX_PRF,TALPHA,TBETA,TGAMMA
     *  ,TALPHA_NEW,TBETA_NEW,TGAMMA_NEW
     *  ,NPROT,NPT,NMR,N_MODEL,NREF,NREFP,NMONR,NSYM
     *  ,SPST,MODE_D,NCS,ANGLES,CVECTOR
     *  ,ISYM,IPRSYM
     *  ,RESULT,RESULT3,IPRMAX,IPRROW,IERR)
        IF(IERR.NE.0) GO TO 900

      ENDIF
      GO TO 900
C -------------
 1000 CONTINUE
C ---- DYAD ---
C     IF(DYAD.EQ.'Y'.OR.DYAD.EQ.'D') THEN
        FPAR_TR( 1) = RESMIN
        FPAR_TR( 2) = RESMAX
        FPAR_TR( 3) = DIST_MIN 
        FPAR_TR( 4) = DIST_MAX
        FPAR_TR( 5) = DIST_DPAR
        FPAR_TR( 6) = BOFF
        FPAR_TR( 7) = BADD
        FPAR_TR( 8) = BLIM
        FPAR_TR( 9) = CHI_DYAD
        FPAR_TR(10) = DELTA 
        FPAR_TR(11) = BOFF_SCL
        FPAR_TR(12) = BADD_SCL
        FPAR_TR(19) = RAD_MODEL 

        PARM_TR(1:1) = DYAD
        PARM_TR(2:2) = FAST
        PARM_TR(3:3) = REF
        PARM_TR(4:4) = MOD2
        PARM_TR(5:5) = ANISO_T
        PARM_TR(6:6) = PACK
        PARM_TR(7:7) = SURF
        IF(LOCK.EQ.'Y'.OR.LOCK.EQ.'G') TEST_SRF = 'N'
        PARM_TR(8:8) = TEST_SRF
        PARM_TR(9:9) = LIST
        PARM_TR(10:10) = MOD1
        PARM_TR(11:11) = MOD2S
        PARM_TR(12:12) = STICK
        PARM_TR(21:21) = DIFF
        PARM_TR(22:22) = SURFX

        IF(MOD2S.NE.'N') THEN

c          DYAD = 'D'
          IF(DYAD.NE.'D') DYAD = 'M'

c         NMON = 2          

          CALL LENSTR_BL(NAME_TAB2,LEN)
          IF(LEN.LE.0.OR.NAME_TAB2(1:1).EQ.','.OR.
     *      NAME_TAB2(1:1).EQ.' ') THEN
            NAME_TAB2 = 'molrep_rf2.tab'
            CALL ADD_PATH(PATH_SCR,NAME_TAB2)
          ENDIF

          IF(FUN.NE.'T') THEN
            IF(LOCK.EQ.'Y') THEN
              CALL MSGDOC(MDOC,
     *        '  --- Locked Rotation function for model_T2---')
            ELSE IF(LOCK.EQ.'G') THEN
              CALL MSGDOC(MDOC,
     *  ' --- General Locked Rotation function for model_T2---')
            ELSE
              CALL MSGDOC(MDOC,
     *        '  --- Rotation function for model_T2---')
            ENDIF 
            CALL MSGDOC(MDOC,' ')
            ARAD2 = 0.0 

            PARM_RF( 1: 1) = SUM
            PARM_RF( 2: 2) = ANISO_R
            PARM_RF( 3: 3) = SELF
            PARM_RF( 4: 4) = PST
            PARM_RF( 5: 5) = FUN
            PARM_RF( 6: 6) = CTEST
            PARM_RF( 7: 7) = LIST
            PARM_RF( 8: 8) = DIFF
            PARM_RF( 9: 9) = SURF
            PARM_RF(10:10) = PRF
            PARM_RF(11:11) = MOD2S
            PARM_RF(13:13) = LOCK
            PARM_RF(14:14) = ANISO_CORR

            IPARM_RF(1) = NPEAK2
            IPARM_RF(2) = LMIN_INP
            IPARM_RF(3) = LMAX_INP
            IPARM_RF(4) = NMR
            IPARM_RF(5) = N_MODEL
            IPARM_RF(6) = NP_SRF
            IPARM_RF(7) = 0
            IPARM_RF(8) = 0
            IF(NPEAK2_INP.LE.0) THEN
              NPEAK2_MAX = NPEAK2*2.0 
              IF(NPEAK2_MAX.GT.IPRCYCL)  NPEAK2_MAX=IPRCYCL
              IPARM_RF(8) = NPEAK2_MAX
            ENDIF

            NAMEF_ROT   = NAMEF

            NAMES1    = ' '
            IF(DIFF.EQ.'P') THEN
              NAMEF_ROT = NAMEF_DIFF
            ELSE IF(DIFF.EQ.'D') THEN 
              NAMES1 = NAMEF_DIFF
            ELSE IF(DIFF.EQ.'F') THEN 
              NAMES1 = NAMEF_DIFF
            ELSE IF(DIFF.EQ.'M') THEN 
              NAMES1 = NAMEF_DIFF
            ENDIF

            CALL CROSSROT(MDOC,NAMEF_ROT,NAMEM_2,NAMES1,NAME_TAB2
     *      ,NAME_TSRF,PATH_OUT,PATH_SCR
     *      ,DELTA,RMS_INPUT,DLIM_RF,NCS_MODEL2,NMON_EXPECTED
     *      ,RESMIN,RES_ROT,PARM_RF,IPARM_RF,CHI_IN,COEF_IN,BLIM
     *      ,BOFF_ROT,BADD,BOFF_SCL,BADD_SCL,ARAD2
     *      ,ISYM,IPRSYM
     *      ,RESULT,RESULT2,RESULT3,IPRMAX,IPRROW,IERR)
            IF(IERR.NE.0) GO TO 900
            NPROT2 = RESULT(1,12)

c            LINE = ' ERROR: dyad search: file_tab2 (FILE_T2)'//
c     *      ' not defined for Model_M2'
c            CALL MSGDOC(MDOC,LINE)
c            IERR = 1
c            GO TO 900
          ENDIF

          MMM = MDOC
          IF(FUN.NE.'T') MMM = M

          CALL MSGDOC(MMM,
     *  ' --- Rotation Function-2 ---')
          N = NPEAK2
          IF(NPEAK2_INP.LE.0) N = 200

          CALL READ_TAB(MMM,NAME_TAB2,N,RESULT,IPRMAX,IPRROW)
          NP_TAB2 = RESULT(1,12) 
          IF(NP_TAB2.LE.0) THEN
            LINE = ' ERROR: N-peaks = 0 : file_tab2 (FILE_T2)'
            CALL MSGERR(MDOC,LINE)
            IERR = 1
            GO TO 900
          ENDIF
          NPROT2 = RESULT(1,12)
          IF(NPROT2.LE.0) GO TO 900

          IF(NPROT2.GT.NPEAK2_INP.AND.NPEAK2_INP.GT.0) NPROT2=NPEAK2

C         IF(NMON.GT.NPROT2)  NMON = NPROT2

          DO I=1,NPROT2
            TALPHA2(I) = RESULT(I,6)
            TBETA2 (I) = RESULT(I,7)
            TGAMMA2(I) = RESULT(I,8)
          ENDDO
        ELSE
          NPROT2 = NPROT
          DO I=1,NPROT2
            TALPHA2(I) = TALPHA(I)
            TBETA2 (I) = TBETA (I)
            TGAMMA2(I) = TGAMMA(I)
          ENDDO

        ENDIF

        NMR = 0

        IPAR_TR(1) = NPROT
        IPAR_TR(2) = NPROT2
        IPAR_TR(3) = NMON
        IPAR_TR(4) = NMR
        IPAR_TR(5) = NP_SRF  
        IPAR_TR(6) = NPT
        IPAR_TR(7) = NPT_DM
        IPAR_TR(8) = ISYM_DYAD 
        IPAR_TR(9) = NMON_EXPECTED
        IPAR_TR(10) = NML
        IF(DYAD.NE.'M') THEN
          CALL TRF_DIMER(MDOC,NAMEF,NAMEM,NAMEM_2,NAME2,NAME_TSRF
     *    ,PATH_OUT,PATH_SCR
     *    ,TALPHA,TGAMMA,TBETA,TALPHA2,TGAMMA2,TBETA2
     *    ,IPAR_TR,FPAR_TR,PARM_TR,PEAK_TEST
     *    ,ISYM,IPRSYM
     *    ,RESULT,RESULT2,RESULTA,IPRMAX,IPRROW,IPRCYCL,IERR)
        ELSE
          CALL TRF_MULTI(MDOC,NAMEF,NAMEM,NAMEM_2,NAME2,NAME_TSRF
     *    ,NAMEF_DIFF,PATH_OUT,PATH_SCR
     *    ,TALPHA,TGAMMA,TBETA,TALPHA2,TGAMMA2,TBETA2
     *    ,IPAR_TR,FPAR_TR,PARM_TR,PEAK_TEST
     *    ,DIFF,PERCENT_2,PST,SPST
     *    ,ISYM,IPRSYM
     *    ,RESULT,RESULT2,RESULTA,IPRMAX,IPRROW,IPRCYCL,IERR)
        ENDIF
        GO TO 900
C     ENDIF
C --- end DYAD --
C ---------------
 900  CONTINUE

      NAMES='trfun.crd'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='molrp_scr.crd'
      CALL DELETE_FILE(PATH_SCR,NAMES)

      RETURN

      END

      SUBROUTINE EXPECTED_TIME(ISTART,NRUN
     *  ,ITIME_CURR,TIME_CURRENT,TIME_ELAPSED,TIME_EXPECTED)
c ---------------------------------------------
      INTEGER   IHR(7)
      CHARACTER TIME_EXPECTED*(*),TIME_ELAPSED*(*)
      CHARACTER TIME_CURRENT*(*)
      COMMON/COM_EXP_TIME/ ITIME_INIT,ITIME_START,ITIME_PREVIOUS
     *              ,NDELTA,IHR_PREVIOUS,IHR_ADD,SUM_DELTA
      INTEGER ITIME_INIT,ITIME_START,ITIME_PREVIOUS,NDELTA
      INTEGER IHR_PREVIOUS,IHR_ADD
      REAL    SUM_DELTA
c ---------------------------------------------
      M      = 99
      IERR   = 0
C ---
C ========
      CALL CLOCK(IHR)
C     IH(2),IH(3),IH(4),    IH(5),IH(6),IH(7)
C     sec   min  hour      day   month year
      IF(ISTART.LT.0) THEN
        IHR_PREVIOUS = IHR(4) 
        IHR_ADD      = 0
      ENDIF
      IHR4 = IHR(4)
      IF(IHR4.LT.IHR_PREVIOUS)  IHR_ADD = IHR_ADD + 24
      ICLOCK_CURR  = IHR(2)+(IHR(3)+IHR(4)*60)*60 
      IHR_PREVIOUS = IHR(4) 
      IHR4 = IHR4 + IHR_ADD   
      ITIME_CURR = IHR(2)+(IHR(3)+IHR4*60)*60 
      IHR_PREVIOUS = IHR(4) 
C --
      ITM = ICLOCK_CURR/60
      ITIME_S = ICLOCK_CURR - ITM*60
      ITIME_H = ITM/60
      ITIME_M = ITM -ITIME_H*60
      WRITE(TIME_CURRENT,'(I6,''h '',I2,''m '',I2,''s'')')
     *          ITIME_H,ITIME_M,ITIME_S    
      IF(ISTART.GE.0) THEN
        ITELAP = ITIME_CURR - ITIME_INIT
        ITM = ITELAP/60
        ITIME_S = ITELAP - ITM*60
        ITIME_H = ITM/60
        ITIME_M = ITM -ITIME_H*60
        WRITE(TIME_ELAPSED,'(I6,''h '',I2,''m '',I2,''s'')')
     *          ITIME_H,ITIME_M,ITIME_S    
      ENDIF
C ========
      IF(ISTART.LT.0) THEN
        ITIME_INIT     = ITIME_CURR
        ITIME_START    = ITIME_CURR
        ITIME_PREVIOUS = ITIME_CURR
        NDELTA    = 0
        SUM_DELTA = 0.0
        DELTA     = 0.0
        TIME_ELAPSED   = '.'
        TIME_EXPECTED  = '.'
      ELSE IF(ISTART.GT.0) THEN
        ITIME_START    = ITIME_CURR
        ITIME_PREVIOUS = ITIME_CURR
        NDELTA    = 0
        SUM_DELTA = 0.0
        DELTA     = 0.0
        TIME_EXPECTED  = '.'
      ELSE
        D = FLOAT(ITIME_CURR) - FLOAT(ITIME_PREVIOUS)
        IF(D.LT.1.0) D = 0.75
        IF(D.GT.0.01) THEN
          SUM_DELTA = SUM_DELTA + D
          NDELTA    = NDELTA    + 1
          ITIME_PREVIOUS = ITIME_CURR
        ENDIF
        TIME_EXPECTED  = '.'
        ITIME_EXPECTED = 0
        DELTA = 0.0
        IF(NDELTA.GT.0) THEN
          DELTA     = SUM_DELTA/FLOAT(NDELTA)
          ITIME_EXPECTED = DELTA*FLOAT(NRUN)
          ITM = ITIME_EXPECTED/60
          ITIME_S = ITIME_EXPECTED -ITM*60
          ITIME_H = ITM/60
          ITIME_M = ITM -ITIME_H*60
          WRITE(TIME_EXPECTED,'(I6,''h '',I2,''m '',I2,''s'')')
     *          ITIME_H,ITIME_M,ITIME_S    
        ENDIF
 
C       123456h 12m 13s   
C       123456789 12345

      ENDIF
     
C       write(*,*) '--t:',nrun,d,delta,ndelta,ITIME_CURR,ITIME_PREVIOUS
C     *   ,ITIME_EXPECTED,istart,SUM_DELTA
C ---
      RETURN
      END

      SUBROUTINE TRFUN_RUN(MDOC,NAMEF_INP
     * ,NAMEM,NAME2,NAME_PH,PATH_SCR
     * ,PATH_OUT
     * ,NAME_DIMER,FPAR_TR,PARM_TR
     * ,PEAK_TEST,PRF_SH,INDEX_PRF,TALPHA,TBETA,TGAMMA
     * ,TALPHA_NEW,TBETA_NEW,TGAMMA_NEW
     * ,NPROT,NPT,NMR,N_MODEL,NREF,NREFP,NMONR,NMON_EXPECTED,NSYM
     * ,SPST,MODE_D,NCS,ANGLES_NCS,CVECTOR_NCS,NCS_MODEL,NOSPGR
     * ,SPGR_INP
     * ,ISYM,IPRSYM
     * ,RESULT,RESULT2,RESULT3,IPRMAX,IPRROW,IERR)
C --------------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
C ----
      REAL      RESULT    (IPRMAX,IPRROW)
      REAL      RESULT2   (IPRMAX,IPRROW)
      REAL      RESULT3   (IPRMAX,IPRROW)

C     PARAMETER ( IPRCYCL=10  )
C     PARAMETER ( IPRCYCL=20  )
C     PARAMETER ( IPRCYCL=50  )
      PARAMETER ( IPRCYCL=200 )

      INTEGER   IPEAK_NUMBER(IPRCYCL)
      INTEGER   LIST_RF_FOUND(IPRCYCL)
      INTEGER   INDEX_TF(IPRCYCL)

      REAL      CORR(IPRCYCL),RFAC(IPRCYCL),SCORR(IPRCYCL)
      REAL      TXSH(IPRCYCL),TYSH(IPRCYCL),TZSH(IPRCYCL)
      REAL      TALPHA_BEST,TGAMMA_BEST,TBETA_BEST
      REAL      TXSH_BEST,TYSH_BEST,TZSH_BEST
      REAL      OXS(3),FXS(3)

      REAL      TALPHA(*),TGAMMA(*),TBETA(*)
      REAL      TALPHA_NEW(*),TGAMMA_NEW(*),TBETA_NEW(*)
      REAL      PRF_SH(3,*),ANGLES_NCS(3),CVECTOR_NCS(3)

      PARAMETER (IPRDOM = 300)
      REAL      ANGLES_NCS_MON(3,IPRDOM)

      INTEGER   INDEX_PRF(*)
      REAL      PEAK_TEST(12,*)
      REAL      FPAR_TR(*)
C ---
      CHARACTER NAMEF_INP*(*),SPGR_INP*(*)
      CHARACTER SPGR*24
      CHARACTER NAMEF*256
      CHARACTER FILE_FOBS_LH_STOR*256
      CHARACTER NAMEM*(*),NAME2*(*),NAME_PH*(*),PATH_SCR*(*)
      CHARACTER NAME_DIMER*(*),PATH_OUT*(*)
      CHARACTER NAMEO*256,NAMET_OUT*256
      CHARACTER NAMED*256,NAME*256
      CHARACTER NAMEC2*256,NAMET*256,NAMET1*256
      CHARACTER NAME_FCALC*256,NAME_PHCALC*256
      CHARACTER NAME_FCALC_SCL*256

      CHARACTER NAMEC2_PST*256,NAMET_PST*256,NAMEO_PST*256
      CHARACTER NAME2_PST*256,NAME4*256

      CHARACTER MODE_D*1
      CHARACTER LINE*256,MODE*1
      CHARACTER MOD2*1,INVER*1
      CHARACTER PACK*1
      CHARACTER REF*1,REFP*1,TFUN*1,LIST*1
      CHARACTER CALC2*1,ITYPE*4
      CHARACTER ANISO_T*1,MODE_T*1
      CHARACTER PST*1,SURF*1,REF_TEMP*1,CTEST*1,MOD2_INI*1
      CHARACTER PRF*1,FITT*1,FAST*1,STICK*1,ACORR*1,SURFX*1
      CHARACTER MOD1*1,CCP4*1,LH*1
      CHARACTER CFREE*1,CSIG*1,CFOM*1,DIFF*1,CH10*10
      INTEGER   NSG_CHECK,ISG_CHECK(100)
      CHARACTER SG_CHECK(100)*24
      REAL      CORR_CHECK(100),CONTRAST_CHECK(100)
      CHARACTER PARM_TR*30
      PARAMETER ( IPRSML = 200    )
      INTEGER   ISIMILAR_TAB(IPRSML,IPRSML)
      REAL      FRTOCR(3,3),CRTOFR(3,3)

      CHARACTER TIME_CURRENT*15,TIME_ELAPSED*15,TIME_EXPECTED*15
C ------------------------------------------------------------
      PARAMETER ( NSCORE_MAX = 150)
      REAL      SCORE_STOR(NSCORE_MAX)
      REAL      SCORE_AVER(NSCORE_MAX)
      REAL      SCORE_AVER2(NSCORE_MAX)
      INTEGER   ISCORE_NUMB(NSCORE_MAX)

      INTEGER   IPEAK_NUMB_STOR(NSCORE_MAX)
      INTEGER   IPEAK_INDEX_STOR(NSCORE_MAX)
c --------------------------------------------------------
      REAL      AM(3,3),SH1(3),SH2(3),SPST(3)
C ---------------------------------------
      INCLUDE 'molrep_lh_infor.fh'
C      COMMON/COM_LH_INFOR/ BOFF_LH,BADD_LH,BOFF_FOR_SCAL
C     *   ,CHECK_CONTRAST,CONTRAST_LIM
C     *   ,BCORR_LH,FILE_FOBS_LH,SCORE_FLAG,LH_LH,DB_LH
CC ---
C      REAL      CHECK_CONTRAST,CONTRAST_LIM
C      REAL      BOFF_FOR_SCAL,BOFF_LH,BADD_LH,BCORR_LH
C      CHARACTER LH_LH*1,SCORE_FLAG*1,DB_LH*1
C      CHARACTER FILE_FOBS_LH*256
C ----------------------------------
C ----------------------------------
      PARAMETER ( NVMAX = 12 )
      REAL      PST_VECTORS(3,NVMAX)
C ----------------------------------
C --------------------------------------------------------------------
      COMMON/COM_DPOOL/ IPOOL_MAX,IPOOL_CURR
C ---
      INCLUDE 'molrep_xml.fh'
C -------------------------------------------------------------
      PI     = 4.0*ATAN(1.0)
      MD     =-ABS(MDOC)-1
      M      = 99
      MD0    = 0
      IERR   = 0
      ISIGNAL_STOP = 0
C ---
      NAMEF = NAMEF_INP
C -------------------------------------------------
      NAMEO   = 'molrep'
      CALL ADD_PATH(PATH_SCR,NAMEO)
      NAMEC2  = 'molrp_scr'
      CALL ADD_PATH(PATH_SCR,NAMEC2)
      NAMET1  = 'molrp_scr1'
      CALL ADD_PATH(PATH_SCR,NAMET1)
      NAMEO_PST  = 'molrep_pst'
      CALL ADD_PATH(PATH_SCR,NAMEO_PST)
      NAMEC2_PST  = 'molrep_pst2'
      CALL ADD_PATH(PATH_SCR,NAMEC2_PST)
      NAME2_PST  = 'molrep_pst1'
      CALL ADD_PATH(PATH_SCR,NAME2_PST)
      NAMET_PST = ' '
C ----------------------------------
C ---XML--
      JOB_XML = 'MR_TF'
C  ================================================

      IF(NMON_EXPECTED.LT.NMONR) NMON_EXPECTED = NMONR

      TFUN     = PARM_TR( 1: 1) 
      REFP     = PARM_TR( 2: 2)
      REF      = PARM_TR( 3: 3)
      PACK     = PARM_TR( 4: 4)
      PST      = PARM_TR( 5: 5)
      CCP4     = PARM_TR( 6: 6) 
      ANISO_T  = PARM_TR( 7: 7)
      SURF     = PARM_TR( 8: 8)
      REF_TEMP = PARM_TR( 9: 9)
      MOD2_INI = PARM_TR(10:10)
      INVER    = PARM_TR(11:11)  
      PRF      = PARM_TR(12:12)  
      FAST     = PARM_TR(13:13)  
      FITT     = PARM_TR(14:14) 
      MODE_T   = PARM_TR(15:15)  
      CTEST    = PARM_TR(16:16)
      STICK    = PARM_TR(17:17)
      MOD1     = PARM_TR(18:18)
      MOD2     = PARM_TR(19:19)
      LIST     = PARM_TR(20:20)
      DIFF     = PARM_TR(21:21)
      SURFX    = PARM_TR(22:22)

c ////
      CALL CALC_INERTIA_MATRIX(MDOC,MOD1,NAMEM
     *      ,NSYM,ISYM,IPRSYM,IERR)
c ////

      RESMIN   = FPAR_TR( 1)
      RESMAX   = FPAR_TR( 2)
c      FPAR_TR( 3) = ALPHA
c      FPAR_TR( 4) = BETA
c      FPAR_TR( 5) = GAMMA
      BOFF     = FPAR_TR( 6)
c      FPAR_TR( 7) = BOFFP
      BADD     = FPAR_TR( 8)
      BLIM     = FPAR_TR( 9)
c      FPAR_TR(10) = RSMIN_RB
c      FPAR_TR(11) = RSMAX_RB
      BOFF_SCL = FPAR_TR(12)
      BADD_SCL = FPAR_TR(13)
      RSMAX_RB = FPAR_TR(14)
      ARAD     = FPAR_TR(15)
      RAD_MODEL = FPAR_TR(19) 
c ////
      IF(MOD1.EQ.'Y') THEN
        CALL GET_CR_MATRIX(FRTOCR,CRTOFR)

        DO I=1,NPROT
        DO J=1,NPROT
          ISIMILAR_TAB(I,J) = 0
          IF(I.EQ.J) ISIMILAR_TAB(I,J) = 9
        ENDDO
        ENDDO
        RMS_LIM  = 0.7*RESMAX
        DO I=2,NPROT
        DO J=1,I-1
          CALL CALC_ORIENTION_RMS(I,J,FRTOCR,CRTOFR
     *        ,TALPHA,TGAMMA,TBETA,NSYM,ISYM,IPRSYM,RMS)
          IF(RMS.LT.RMS_LIM) THEN
            IS = (RMS/RMS_LIM)*10.0 + 1
            IS = 10 - IS
            IF(IS.GE.10) IS = 9
            IF(IS.LE.0 ) IS = 1
            ISIMILAR_TAB(I,J) = IS
            ISIMILAR_TAB(J,I) = IS
          ENDIF
        ENDDO
        ENDDO
        CALL MSGDOC(MDOC,' ')
        WRITE(LINE,*) '---RF peak similarity ---'
        CALL MSGDOC(MDOC,LINE)
        N = NPROT
        IF(N.GT.36 ) N = 36
        WRITE(LINE,'(''    |'',36A2)') ('--',JJJ=1,N)
        CALL LENSTR_BL(LINE,LEN)
        LINE(5:5) = '+'
        LINE(LEN+1:LEN+1) = '+'
        CALL MSGDOC(MDOC,LINE)
        DO I=1,NPROT
          WRITE(LINE,'(I3,A,36I2)') I,' |'
     *                  ,(ISIMILAR_TAB(I,J),J=1,N)
          DO J=7,80,2
            IF(LINE(J:J).EQ.'0') LINE(J:J) = '.'
          ENDDO
          CALL LENSTR_BL(LINE,LEN)
          LINE(LEN+1:LEN+1) = '|'
          CALL MSGDOC(MDOC,LINE)
        ENDDO
        WRITE(LINE,'(''    |'',36A2)') ('--',JJJ=1,N)
        CALL LENSTR_BL(LINE,LEN)
        LINE(5:5) = '+'
        LINE(LEN+1:LEN+1) = '+'
        CALL MSGDOC(MDOC,LINE)
        CALL MSGDOC(MDOC,' ')
      ENDIF
c ////
      NM_TOTAL = 1
      IF(NCS.GT.100.AND.MODE_D.EQ.'D') THEN
        IF(NCS.EQ.532) THEN
          I = 60
        ELSE IF(NCS.EQ.432) THEN
          I = 24
        ELSE IF(NCS.EQ.230) THEN
          I = 12
        ELSE
          N_MAIN = NCS/100
          N_ADD  = MOD(NCS,100)
          I = N_MAIN
          IF(N_ADD.EQ.20.OR.N_ADD.EQ.22) I = I*2
        ENDIF    
        IF(I.GT.0) NM_TOTAL = I

        IF(PRF.EQ.'N') THEN
          DELTA_ANG = 3.0
          CALL REMOVE_NCS_PEAKS_FROM_RF(MDOC
     *      ,NAMEM,NCS,ANGLES_NCS,CVECTOR_NCS,DELTA_ANG,IPRDOM
     *      ,NPROT,TALPHA,TGAMMA,TBETA,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
        ENDIF

      ENDIF

      NPST = 1

c      write(*,*) '--fast,stick:',fast,stick
c      write(*,*) '--pst,pst_lh:',pst,pst_lh
c      write(*,*) '--v:',SPST(1),SPST(1),SPST(3)

      IF(PST.EQ.'Y') THEN

        NPST = 1
        PST_VECTORS(1,1) = SPST(1)
        PST_VECTORS(2,1) = SPST(2)
        PST_VECTORS(3,1) = SPST(3)

        IF(PST_LH.EQ.'A') THEN          

          MTN   = 10
          ITYPE = 'FF  '
          CALL ORFILE(M,MTN,NAMEF,ITYPE,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,
     *      ' ERROR: TRFUN: can not open input file: F_obs for PST')
            RETURN
          ENDIF

          CALL GET_SYMM_PST_VECTORS(SPST,NV,PST_VECTORS,NVMAX
     *                         ,NSYM,ISYM,IPRSYM,IERR)
          IF(NV.GT.0) THEN
C            DO IV=1,NV
C              WRITE(LINE,'(A,I3,A,3F14.3)') 
C     *        'PST_vector',IV,':',(PST_VECTORS(JJJ,IV),JJJ=1,3)
C              CALL MSGDOC(MDOC,LINE)
C            ENDDO
            NPST = NV

c           PST_VECTORS(1,2) = 0.209      
c           PST_VECTORS(2,2) = 0.000 
c           PST_VECTORS(3,2) = 0.487
c           PST_VECTORS(1,1) = 0.487         
c           PST_VECTORS(2,1) = 0.000 
c           PST_VECTORS(3,1) = 0.209
c           NPST = 2


          ENDIF
        ENDIF

        IF(NMONR.LE.1) NMONR=2
        NMONR = (NMONR/2)*2

        IF(NMON_EXPECTED.LE.1) NMON_EXPECTED=2
        NMON_EXPECTED = (NMON_EXPECTED/2)*2

      ENDIF

      NMON      = NMONR 

      NOUSED_RF = 0
      IDIMER_FIRST = 0

C ---
      CORR_BEST = -1.0
      RFAC_BEST =  0.0
      CONTRAST_BEST = 0.0
C      RSMIN_RB  = 20.0
C      RSMAX_RB = 3.0
C !!!!
C      RSMAX_RB  = 5.0
      RSMIN_RB  = RESMIN
      IF(RSMAX_RB.LT.RESMAX) RSMAX_RB = RESMAX
C !!!!
C !!!!NCYCL_RB  = 5
      NCYCL_RB  = 5
      NCP       = 0
      IF(NREF .GT.0) NCYCL_RB = NREF 
      IF(NREFP.GT.0) NCP      = NREFP
      NC       = NCYCL_RB
C ---
      BOFF_RB  = 1600.0
      BOFFP    = BOFF_RB
      NEL2     = 0
      CALC2    = 'Y'

      NMR = 0
      LH  = LH_LH
C --
      ITIME_START = 1
      NRUN_TIME = 0
      CALL EXPECTED_TIME(ITIME_START,NRUN_TIME
     *  ,ITIME_CURR,TIME_CURRENT,TIME_ELAPSED,TIME_EXPECTED)

      WRITE(LINE,*) 'Time:',TIME_CURRENT,' Elapsed:',TIME_ELAPSED
      CALL MSGDOC(MDOC,LINE)
      TIME_ELAPSED_XML  = TIME_ELAPSED
      CALL WRITE_XML_FILE(IERR,PATH_OUT)


      CALL MSGDOC(MDOC,' ')
      IF(MODE_D.EQ.'D') THEN
        CALL MSGDOC(MDOC,' --- phased translation function ---')
      ELSE
        CALL MSGDOC(MDOC,' --- Translation function ---')
      ENDIF
      CALL MSGDOC(MDOC,' ')
C ----
      WRITE(LINE,'('' Resolution              :'',2F8.2)') 
     * RESMIN,RESMAX
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Boff,Badd               :'',2F8.2)')
     * BOFF,BADD
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,'('' Boff_scl,Badd_scl       :'',2F8.2)')
     * BOFF_SCL,BADD_SCL
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,'('' NCS model               :'',I5)')
     * NCS_MODEL
      CALL MSGDOC(MDOC,LINE)
      IF(MODE_D.EQ.'D'.AND.NCS.GT.100) THEN
        WRITE(LINE,'('' NCS                     :'',I5)')
     *   NCS
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      IF(MODE_D.EQ.'D'.AND.PRF.NE.'N') THEN
        WRITE(LINE,'('' Radius of integration   :'',F8.2)') 
     *  ARAD
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      IF(PST.EQ.'Y'.AND.NPST.GT.0) THEN
        CALL MSGDOC(MDOC,'--- List of pseudo-translation vectors ---')
        DO IV=1,NPST
          WRITE(LINE,'(A,I3,A,3F8.3)') 
     *    'PST_vector',IV,':',(PST_VECTORS(JJJ,IV),JJJ=1,3)
          CALL MSGDOC(MDOC,LINE)
        ENDDO
        CALL MSGDOC(MDOC,'---')
      ENDIF


      NSG_CHECK = 0
      ICHECK_SG = 0
      SPGR      = SPGR_INP

      IF(NOSPGR.LT.0.OR.SPGR_INP(1:3).EQ.'ALL') THEN

        JOB_XML = 'MR_SG_checking'

        NAME =  ' '
        CALL CHANGE_GROUP(M,NAMEF,NAME,NOSPGR
     *           ,SPGR,NSG,ISETT,NSYMLIB
     *           ,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          IERR_XML     = 1
          MESSAGE_XML  = ' '  
          RETURN
        ENDIF

        CALL SEARCH_ALT_SYMM_GROUP(M,NSYM,ISYM,IPRSYM
     * ,NSG,ISETT,NSG_CHECK,ISG_CHECK,SG_CHECK,IERR)
        IF(NSG_CHECK.LE.1) THEN
          CALL MSGERR(MDOC,
     *    ' ERROR: for NOSG: no space group need to check.')
          IERR = 1
          IERR_XML     = 2
          MESSAGE_XML  = 'no space group need to check'  
          RETURN
        ENDIF

C        DO II=1,NSG_CHECK
C          WRITE(*,*) '==',II,ISG_CHECK(II)
C        ENDDO

        IF(LH_LH.NE.'N') THEN 
          FILE_FOBS_LH_STOR = FILE_FOBS_LH
        ENDIF

        ICHECK_SG = 0
        ICHECK_SG_BEST = 0        
        CORR_CHECK_SG_BEST = -1.0
        ICHECK_INIT = 0      
      ENDIF

 210  CONTINUE

      IF(NOSPGR.LT.0.OR.SPGR_INP(1:3).EQ.'ALL') THEN
        IERR    = 0
        ISETT   = 0
        NSG     = 0
        ICHECK_SG = ICHECK_SG + 1
        NSG_LIB = ISG_CHECK(ICHECK_SG) 
        SPGR    = ' '

        NAMEF =  'molrep_fobs_new'
        CALL ADD_PATH(PATH_SCR,NAMEF)

        CALL CHANGE_GROUP(MDOC,NAMEF_INP,NAMEF
     *           ,NSG_LIB,SPGR,NSG,ISETT,NSYMLIB
     *           ,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.EQ.-2) THEN
          IERR = 0
          ICHECK_INIT = ICHECK_SG
          NAMEF = NAMEF_INP
        ELSE IF(IERR.NE.0) THEN
          CALL MSGERR(MD,
     *    ' WARNING:  for keyword NOSG: can not change space group')
          IERR = 1
          IERR_XML     = 3
          MESSAGE_XML  = 'can not change space group'  
          RETURN
        ENDIF

        IF(LH_LH.NE.'N') THEN 
          FILE_FOBS_LH = 'molrep_fobs_LH_new.dat'
          CALL ADD_PATH(PATH_SCR,FILE_FOBS_LH)
          NSG_LIB = ISG_CHECK(ICHECK_SG) 
          SPGR    = ' '
          CALL CHANGE_GROUP(MDOC,FILE_FOBS_LH_STOR
     *           ,FILE_FOBS_LH
     *           ,NSG_LIB,SPGR,NSG,ISETT,NSYMLIB
     *           ,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.EQ.-2) THEN
            IERR = 0
            ICHECK_INIT = ICHECK_SG
            FILE_FOBS_LH = FILE_FOBS_LH_STOR
          ELSE IF(IERR.NE.0) THEN
            CALL MSGERR(MD,
     *      ' WARNING:  for keyword NOSG: can not change space group')
            IERR = 1
            IERR_XML     = 3
            MESSAGE_XML  = 'can not change space group'  
            RETURN
          ENDIF
        ENDIF
        CALL LENSTR_BL(SPGR,L)
        WRITE(LINE,
     *'('' INFO: space group was changed to No ='',I5,'' Sett =''
     *   ,I5,3X,A)')
     *    NSG,ISETT,SPGR(1:L)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(33X,''No in symlib ='',I5)') NSYMLIB
        CALL MSGDOC(MDOC,LINE)


C        IF(LH_LH.NE.'N') THEN 
C          FPAR_TR( 6) = BOFF_LH
C          FPAR_TR( 8) = BADD_LH
C        ENDIF
C        LH_LH = 'N'
      ENDIF

      MMDOC = MDOC
      IRF   = 0

      DO I=1,NPROT
        IPEAK_NUMBER(I) = I
        INDEX_TF(I)     = 0
      ENDDO

      NMON_FOUND = 0

      IFIRST_RUN_TF_FOR_PKMAX_FIRST = 0

c      IF(SCORE_FLAG.EQ.'N'.OR.NSYM.LE.1) 
c     *     IFIRST_RUN_TF_FOR_PKMAX_FIRST = 1


      PKMAX_FIRST =  1.0
      PKMAX_CORR  =  1.0

c      IFIRST_RUN_TF_FOR_PKMAX_FIRST = 1
c      PKMAX_FIRST = 1.0

 200  CONTINUE

      IFIRST_RUN_TF_FOR_PKMAX_FIRST = 0

c      IF(PRF.NE.'N') CORR_BEST = -1.0

      IPEAK          = 0
      IPEAK_COUNT    = 0

      CORR_TOT       =-1.5
      SCORR_TOT      =-1.5
      RFAC_TOT       = 0.0
      IPK_BEST       = 0
      IPK_TRANS      = 0
      IPK_TRANS_BEST = 0
      IFIRST_SCL = 0

      IF(NMON_FOUND.LE.0) IFIRST_SCL =-1
      IF(PST.EQ.'Y'.AND.NPST.GT.1) IFIRST_SCL = 0

      IFIRST_MSG = 0

      IPST_STOR_BEST = 0

C ////////////

      NRUN    = 0
      NR_SYM  = 1
      IF(MODE_D.EQ.'D') NR_SYM = 2
      IF(NCS_MODEL.GT.0) NR_SYM = NCS_MODEL

C     NRUN_LIM = (NMONR+8)*NR_SYM
      NRUN_LIM = (NMON_EXPECTED+8)*NR_SYM

c      write(*,*) '---NRUN_LIM,NMONR:',NRUN_LIM,NMONR

C ////////////
      SCORE_MAX  =-1.5
      NSCORE     = 0
      NSCORE_NEW = 0
      NSCORE OLD = 0
      CONTRAST   = 0.0
      NP_FIN     = 0
      CALL MSGDOC(MMDOC,' ')

C      IF(MODE_D.EQ.'D') THEN
C      LINE =
C     * 'Sol_ RF TF   Tf/sig  TFcntrst'//
C     * '  PKind PKmax  PKmin  wRfac Corr Corr_max Cntrst'
C      ELSE
C      LINE =
C     * 'Sol_ RF TF   Tf/sig  TFcntrst'//
C     * '  PKind PKmax  PKmin  wRfac Corr Corr_max Cntrst'
C      ENDIF
C      CALL MSGDOC(MMDOC,LINE)

 800  CONTINUE

      IPEAK = IPEAK+1

      ITIME_START = 0
      IF(IPEAK.EQ.1.AND.NMON_FOUND.EQ.0.AND.
     *                        ICHECK_SG.LE.1) ITIME_START = 1

      NMMM = NMONR -NMON_FOUND 
      IF(PST.EQ.'Y') THEN
        NMMM = NMMM/2 
      ENDIF
      IF(NCS.GT.100.AND.MODE_D.EQ.'D') THEN
        NMMM = NMMM/NM_TOTAL
        IF(NMMM.LE.0) NMMM = 1
      ENDIF
      IF(NOSPGR.LT.0) THEN
        NMMM = NSG_CHECK - ICHECK_SG + 1
      ENDIF

      NRUN_TIME = NMMM*NPROT - (IPEAK-1) 

      CALL EXPECTED_TIME(ITIME_START,NRUN_TIME
     *  ,ITIME_CURR,TIME_CURRENT,TIME_ELAPSED,TIME_EXPECTED)

      TIME_ELAPSED_XML  = TIME_ELAPSED
      TIME_EXPECTED_XML = TIME_EXPECTED

      IERR_XML     = 0
      MESSAGE_XML  = 'normal run'  
      CALL WRITE_XML_FILE(IERR,PATH_OUT)

      IPK =  IPEAK_NUMBER(IPEAK) 

C     IPK   = IPEAK

      IF(PST_LH.NE.'U'.AND.PST_LH.NE.'Y'.AND.PST_LH.NE.'A'.AND.
     *                       PRF.EQ.'N'.AND.INDEX_TF(IPK).GT.0) THEN
        GO TO 820
      ENDIF

      IF(PRF.NE.'N'.AND.INDEX_PRF(IPK).GT.0) THEN
        GO TO 820
      ENDIF

c      CALL MSGDOC(MD,' ')
      WRITE(LINE,'('' --- peak number of Rotation Function :'',I5)')
     *  IPK
      CALL MSGDOC(MD,LINE)
c      CALL MSGDOC(MD,' ')
C -
      NAMET_OUT = 'trfun' 
      CALL ADD_PATH(PATH_SCR,NAMET_OUT)
C      IF(FAST.EQ.'F'.AND.STICK.NE.'Y') NAMET_OUT = ' '
      IF(FAST.EQ.'F'.AND.NCP.LE.0) NAMET_OUT = ' '
      NAMED       = ' '
      NAME_FCALC  = ' '
      NAME_PHCALC = ' '

      IF(LIST.EQ.'T') THEN
        NAMED = 'trfun_dns3'
        CALL ADD_PATH(PATH_SCR,NAMED)
      ENDIF

c >>PST>>>
      CORR_PST_BEST = -3.0
      IPST_STOR     = 0
      DO IPST=1,NPST

      IF(PST.EQ.'Y') THEN
        SPST(1) = PST_VECTORS(1,IPST)
        SPST(2) = PST_VECTORS(2,IPST)
        SPST(3) = PST_VECTORS(3,IPST)
      ENDIF
C >>PST>>>

      ALPHA = TALPHA(IPK)
      BETA  = TBETA (IPK)
      GAMMA = TGAMMA(IPK)
C --
      IERR = NMONR-(NMON-1)

      PARM_TR( 1: 1) = TFUN
      PARM_TR( 2: 2) = REFP
      PARM_TR( 3: 3) = REF
      PARM_TR( 4: 4) = PACK
      PARM_TR( 5: 5) = PST
      PARM_TR( 6: 6) = CALC2
      PARM_TR( 7: 7) = ANISO_T
      PARM_TR( 8: 8) = SURF
      PARM_TR( 9: 9) = REF_TEMP
      PARM_TR(10:10) = MOD2_INI
      PARM_TR(11:11) = INVER  
      PARM_TR(12:12) = PRF  
      PARM_TR(13:13) = FAST  
      PARM_TR(14:14) = FITT  
      PARM_TR(15:15) = MODE_T  
      PARM_TR(16:16) = CTEST
      PARM_TR(17:17) = STICK
      PARM_TR(18:18) = MOD1
      PARM_TR(19:19) = MOD2
      PARM_TR(20:20) = LIST
      PARM_TR(21:21) = DIFF
      PARM_TR(22:22) = SURFX

      IF(REFP.NE.'N'.OR.REF.NE.'N'.OR.FAST.EQ.'S') STICK = 'N'

      IF(LIST.EQ.'S') MD = 99

      FPAR_TR( 1) = RESMIN
      FPAR_TR( 2) = RESMAX
      FPAR_TR( 3) = ALPHA
      FPAR_TR( 4) = BETA
      FPAR_TR( 5) = GAMMA
      FPAR_TR( 6) = BOFF
      FPAR_TR( 7) = BOFFP
      FPAR_TR( 8) = BADD
      FPAR_TR( 9) = BLIM
      FPAR_TR(10) = RSMIN_RB
      FPAR_TR(11) = RSMAX_RB
      FPAR_TR(12) = BOFF_SCL
      FPAR_TR(13) = BADD_SCL
      FPAR_TR(15) = ARAD
C     resmin_out
      FPAR_TR(17) = 0.0
      FPAR_TR(18) = IFIRST_SCL


c      NAMET_OUT = 'trfun' 
c      CALL ADD_PATH(PATH_SCR,NAMET_OUT)
cC      IF(FAST.EQ.'F'.AND.STICK.NE.'Y') NAMET_OUT = ' '
c      IF(FAST.EQ.'F'.AND.NCP.LE.0) NAMET_OUT = ' '
c      NAMED       = ' '
c      NAME_FCALC  = ' '
c      NAME_PHCALC = ' '
c
c      IF(LIST.EQ.'T') THEN
c        NAMED = 'trfun_dns3'
c        CALL ADD_PATH(PATH_SCR,NAMED)
c      ENDIF

      IF(MODE_D.EQ.'D') THEN
        IF(LH_LH.NE.'N') THEN 
          FPAR_TR( 6) = BOFF_LH
          FPAR_TR( 8) = BADD_LH
        ENDIF
        LH_LH = 'N'
      ENDIF

      MMM = MD
      IF(LIST.EQ.'T') THEN
        MMM = MDOC
      ENDIF

      JERR = 0

      NCS_test = NCS

      CALL TRFUN(MMM,NAMEF,NAMEM,NAME_PH,NAME2,NAMET_OUT
     * ,NAMED,NAME_FCALC,NAME_PHCALC,PATH_SCR
     * ,IPK,PRF_SH(1,IPK),NC,NPT,NMR,N_MODEL,NEL2,NCP,NCS_test
     * ,ANGLES_NCS,CVECTOR_NCS 
     * ,PARM_TR,FPAR_TR,SPST,PEAK_TEST
     * ,ISYM,IPRSYM
     * ,RESULT,RESULT3,IPRMAX,IPRROW,IERR)

      LH_LH = LH

c >>PST>>
      NPTRANS = RESULT(1,12)
      IF(IERR.EQ.0.AND.NPTRANS.GT.0.AND.NPST.GT.1) THEN

        PACK_INDEX = RESULT(1,21)
        T = RESULT(1,2)
        IF(SCORE_FLAG.NE.'C')THEN
          T = (T+1.0)*SQRT(ABS(PACK_INDEX))
          CORR_PST = T-1.0
        ELSE
          CORR_PST = T
        ENDIF

        TF_CONTRAST = RESULT(1,17)
c        write(*,*) '-v:',SPST(1),SPST(2),SPST(3)
c        WRITE(*,*) '-tf_cntr-',IPST,CORR_PST,PACK_INDEX,TF_CONTRAST
c        WRITE(*,*) '--',IPST,FPAR_TR(3),FPAR_TR(4),FPAR_TR(5)
c        WRITE(*,*) '--',IPST,RESULT(1,18),RESULT(1,19),RESULT(1,20)

        IF(CORR_PST.GT.CORR_PST_BEST) THEN

          CORR_PST_BEST = CORR_PST
          IPST_STOR     = IPST
          CALL LENSTR_BL(NAMET_OUT,LEN)
          IF(MOD1.EQ.'Y'.AND.LEN.GT.0) THEN
            MODE   = 'E'
            SH2(1) = 0.0
            SH2(2) = 0.0
            SH2(3) = 0.0
            TA  = 0.0
            TB  = 0.0
            TG  = 0.0
            DO I=1,3
              SH2(I) = 0.0
              SH1(I) = 0.0
              DO J=1,3
                AM(I,J) = 0.0
              ENDDO
            ENDDO
            NAME4='molrep4'
            CALL ADD_PATH(PATH_SCR,NAME4)
            CALL TRANS(M,NAMET_OUT,NAME4,SH1,SH2
     *      ,MODE,AM,TA,TB,TG,RESULT3,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900
          ENDIF

          DO I=1,IPRMAX
          DO J=1,IPRROW
            RESULT2(I,J) = RESULT(I,J)
          ENDDO
          ENDDO

        ENDIF
      ENDIF

      ENDDO
c>>PST>>
      IF(NPST.GT.1.AND.IPST_STOR.GT.0) THEN

        CALL LENSTR_BL(NAMET_OUT,LEN)
        IF(MOD1.EQ.'Y'.AND.LEN.GT.0) THEN
          MODE   = 'E'
          SH2(1) = 0.0
          SH2(2) = 0.0
          SH2(3) = 0.0
          TA  = 0.0
          TB  = 0.0
          TG  = 0.0
          DO I=1,3
            SH2(I) = 0.0
            SH1(I) = 0.0
            DO J=1,3
              AM(I,J) = 0.0
            ENDDO
          ENDDO
          NAME4='molrep4'
          CALL ADD_PATH(PATH_SCR,NAME4)
          CALL TRANS(M,NAME4,NAME_OUT,SH1,SH2
     *      ,MODE,AM,TA,TB,TG,RESULT3,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
        ENDIF

        DO I=1,IPRMAX
        DO J=1,IPRROW
          RESULT(I,J) = RESULT2(I,J)
        ENDDO
        ENDDO

      ENDIF
C>>PST>>
      IF(IPST_STOR.LE.0) IPST_STOR = 1

      FAST  = PARM_TR(13:13)
      CALC2 = PARM_TR( 6: 6) 
      IFIRST_SCL = FPAR_TR(18)

C      RMAX_PK = RESULT(1,14)
C     5.11.2008
      RMAX_PK = RESULT(1,22)

      RMIN_PK = RESULT(1,15)
      SIGMA   = RESULT(1,16)
      PACK_INDEX = RESULT(1,21)
      CORR_FIX = RESULT(2,21)

      IF(IERR.NE.0) THEN
        IF(IERR.EQ.1) GO TO 900
        RESULT(1,12) = 0
        JERR         = IERR
        IERR         = 0
      ENDIF
C ---------------------------------------------
      CALL CHECK_STOP_SIGNAL(PATH_SCR,ISIGNAL_STOP)

      NRUN_TIME = NMMM*NPROT - (IPEAK) 
      ITIME_START = 0
      CALL EXPECTED_TIME(ITIME_START,NRUN_TIME
     *  ,ITIME_CURR,TIME_CURRENT,TIME_ELAPSED,TIME_EXPECTED)

      TIME_ELAPSED_XML  = TIME_ELAPSED
      TIME_EXPECTED_XML = TIME_EXPECTED

      IERR_XML     = 0
      MESSAGE_XML  = 'normal run'  
      CALL WRITE_XML_FILE(IERR,PATH_OUT)

      IF(IPEAK.EQ.1) THEN

c        IF(PRF.EQ.'N') THEN
        IF(MOD2.EQ.'Y'.AND.NMON_FOUND.EQ.0) THEN
          IF(CORR_FIX.GT.-2.0) THEN
            WRITE(LINE,'(A,F6.3)')'Corr_for_fixed_model:',CORR_FIX
            CALL MSGDOC(MDOC,LINE)
            IF(SCORE_FLAG.EQ.'Y') CORR_BEST = CORR_FIX
          ENDIF
        ENDIF
        ENDIF
c      ENDIF

      IPEAK_COUNT = IPEAK_COUNT + 1

      IF(IPEAK_COUNT.EQ.1) THEN
        WRITE(LINE,*) 'Time_elapsed:',TIME_ELAPSED
     *              ,' Remained:',TIME_EXPECTED
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      IF(IFIRST_MSG.EQ.0) THEN
        CALL MSGDOC(MMDOC,' ')

        IF(MODE_D.EQ.'D') THEN
          LINE =
     *    '   RF TF    Tf/sig   TFcntrst'//
     *    '  PFind  PF    PFmin  wRfac  Score Cntrst  (for)'
        ELSE
          LINE =
     *    '   RF TF    Tf/sig   TFcntrst'//
     *    '  PFind  PF    PFmin  wRfac  Score Cntrst  (for)'
        ENDIF
        CALL MSGDOC(MMDOC,LINE)

        IFIRST_MSG = 1
      ENDIF
C ---
      NPTRANS   = RESULT(1,12)

      IF(NPTRANS.LE.0) THEN
        NP_FIN    = IPK
        TXSH(IPK) = 0.0
        TYSH(IPK) = 0.0
        TZSH(IPK) = 0.0
        RFAC(IPK) = 0.0
        CORR(IPK) =-2.0
        SCORR(IPK)=-2.0
        IPK_TRANS = 0

c        IF(PRF.NE.'N') THEN
c          INDEX_PRF(IPK) = 1
c          NOUSED_RF = NOUSED_RF + 1
c        ENDIF

        WRITE(CH10,'('' '',I4,I3)') IPK,IPK_TRANS
c        DO J=1,10
c          IF(CH10(J:J).EQ.' ') CH10(J:J) = '_'
c        ENDDO

        IF(JERR.EQ.10) THEN
          WRITE(LINE,'(A,A)') CH10(1:8),
     *    '   ---- all values of Packing Function =< 0 -----'
          CALL MSGDOC(MDOC,LINE)
        ELSE IF(JERR.EQ.11) THEN
          WRITE(LINE,'(A,A)') CH10(1:8)
     *    ,'   --- No peaks Dlim<Dist  ---'
          CALL MSGDOC(MDOC,LINE)
        ELSE 
          WRITE(LINE,'(A,A)') CH10(1:8),'   ----------'
          CALL MSGDOC(MDOC,LINE)
        ENDIF
      ELSE

        RFAC(IPK) = RESULT(1,1)
        T = RESULT(1,2)
        IF(SCORE_FLAG.NE.'C')THEN
          T = (T+1.0)*SQRT(ABS(PACK_INDEX))
          CORR(IPK) = T-1.0
        ELSE
          CORR(IPK) = T
        ENDIF

        IF(IFIRST_RUN_TF_FOR_PKMAX_FIRST.EQ.0) THEN

        IF(NSYM.LE.1.AND.PACK_INDEX.GE.0.999.AND.
     *                            SCORE_FLAG.NE.'N')THEN
          IF(RMAX_PK.GT.0.0001) THEN
            PKMAX_FIRST = RMAX_PK
            IFIRST_RUN_TF_FOR_PKMAX_FIRST = 1
          ENDIF
        ENDIF 
        ENDIF

        RMAX_PK = RMAX_PK/PKMAX_FIRST

        IF(SCORE_FLAG.NE.'C'.AND.NSYM.GT.1)THEN
          CORR(IPK) = (CORR(IPK)*RMAX_PK)/PKMAX_CORR
        ENDIF

C        IF(IFIRST_RUN_TF_FOR_PKMAX_FIRST.EQ.0) THEN
C          IF(RMAX_PK.GT.0.0001) THEN
C            CORR(IPK) = (CORR(IPK)*RMAX_PK)/PKMAX_CORR
C            IF(PKMAX_FIRST.LT.RMAX_PK) PKMAX_FIRST = RMAX_PK
C          ENDIF
C        ENDIF

C        T = RESULT(1,13)
C        T = (T+1.0)*PACK_INDEX
C        SCORR(IPK)= T

        TF_CONTRAST = RESULT(1,17)
        SCORR(IPK)= TF_CONTRAST
        TXSH(IPK) = RESULT(1,6)
        TYSH(IPK) = RESULT(1,7)
        TZSH(IPK) = RESULT(1,8)
        TFSIG     = RESULT(1,5)  
        TALPHA_NEW(IPK) = FPAR_TR( 3)
        TBETA_NEW (IPK) = FPAR_TR( 4)
        TGAMMA_NEW(IPK) = FPAR_TR( 5)
        IPK_TRANS = RESULT(1,9)

c        WRITE(*,*) '--IPK_TRANS,CORR(IPK),CORR_TOT:'
c     *  ,IPK_TRANS,CORR(IPK),CORR_TOT

        TC_AVER   = RESULT(1,18) 
        TC_AVER2  = RESULT(1,19) 
        NC_NAVER  = RESULT(1,20) 

c        IF(SCORE_FLAG.NE.'C'.AND.NSYM.GT.1)THEN
c          SCL = RMAX_PK/PKMAX_CORR
c          TC = TC_AVER*SCL 
c          T = TC*SQRT(ABS(PACK_INDEX))
c          TC_AVER = T + NC_NAVER * (SQRT(ABS(PACK_INDEX))-1.0)
c          TC2 = TC_AVER2*SCL*SCL
c          T   = TC_AVER2 * ABS(PACK_INDEX)
c          T1  = TC * 2.0 * 
c     *          (ABS(PACK_INDEX) - SQRT(ABS(PACK_INDEX)))
c          T2  =  SQRT(ABS(PACK_INDEX))-1.0
c          TC_AVER2  = T + T1 + NC_NAVER * T2 * T2               
c        ENDIF

        CALL TRFUN_STORE_SCORE(IPK,CORR(IPK),NSCORE,SCORE_STOR
     *       ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
     *       ,IPEAK_NUMB_STOR
     *       ,TC_AVER,TC_AVER2,NC_NAVER
     *       ,SCORE_MAX,NSCORE_MAX)

C        CALL DYAD_STORE_SCORE(CORR(IPK),NSCORE,SCORE_STOR
C     *       ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
C     *       ,TC_AVER,TC_AVER2,NC_NAVER
C     *       ,SCORE_MAX,NSCORE_MAX)

        CORR_B = CORR_TOT
        IF(CORR(IPK).GT.CORR_TOT) CORR_B = CORR(IPK)

c      NM_TOTAL = 1
c      IF(NCS.GT.100.AND.MODE_D.EQ.'D') THEN

        NUM_MON = NMONR-NMON
        NR_SYM  = 1
c       IF(MODE_D.EQ.'D') NR_SYM = 2
        IF(NCS_MODEL.GT.0) NR_SYM = NCS_MODEL

        DIST_LIM = 5.0
        RMS_LIM  = 0.7*RESMAX

c        write(*,*) '--- RMS_LIM',RMS_LIM

        NUM_MON_T = NUM_MON/NM_TOTAL
        NMONR_T   = NMON_EXPECTED/NM_TOTAL
C       NMONR_T   = NMONR/NM_TOTAL

        CALL TRFUN_CONTRAST(M,NUM_MON_T,NMONR_T,NR_SYM,CNTR_NEW
     *          ,CORR_B,CONTRAST,NSCORE,NSCORE_NEW
     *          ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
     *          ,IPEAK_NUMB_STOR,IPEAK_INDEX_STOR
     *          ,SCORE_STOR,NSCORE_MAX
     *          ,DIST_LIM,RMS_LIM
     *          ,TALPHA,TGAMMA,TBETA,NSYM,ISYM,IPRSYM)

C        CALL DYAD_CONTRAST(M,NUM_MON,NMONR,NR_SYM,CNTR_NEW
C     *                     ,CORR_B,CONTRAST,NSCORE
C     *          ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
C     *                     ,SCORE_STOR,NSCORE_MAX)
C         NSCORE_NEW = NSCORE
       

        WRITE(CH10,'('' '',I4,I3)') IPK,IPK_TRANS
c        DO J=1,10
c          IF(CH10(J:J).EQ.' ') CH10(J:J) = '_'
c        ENDDO

        RALPHA  = (TALPHA_NEW(IPK)*PI)/180.0
        RBETA   = (TBETA _NEW(IPK)*PI)/180.0
        RGAMMA  = (TGAMMA_NEW(IPK)*PI)/180.0
        CALL EULERM(RALPHA,RBETA,RGAMMA,AM)
        CALL MTOPOL(AM,THETA,PHI,CHI)
        SH2(1) = TXSH(IPK)
        SH2(2) = TYSH(IPK)
        SH2(3) = TZSH(IPK)
        CALL OTOF(SH2,SH1,IERR)

C        WRITE(LINE,'('' Packing function:'',2G16.4)') 
C     *  RMAX_PK,RMIN_PK
C        CALL MSGDOC(MDOC,LINE)
C        WRITE(LINE,'('' Sigma,Tf/sig :'',2G16.4)') SIGMA,TFSIG
C        CALL MSGDOC(MDOC,LINE)

        WRITE(LINE,300) CH10,TFSIG,TF_CONTRAST
     *    ,PACK_INDEX,RMAX_PK,RMIN_PK
     *    ,RFAC(IPK),CORR(IPK),CONTRAST,CORR_B

C        WRITE(LINE,300) CH10(1:8),TFSIG,SIGMA,TF_CONTRAST,RMAX_PK,RMIN_PK
C     *    ,RFAC(IPK),CORR(IPK),CONTRAST,CORR_B
c 300    FORMAT(A10,G14.4,F10.3,F7.2,F8.2,3F7.3,F7.2)
C 300    FORMAT(A10,G12.4,F7.3,F7.2,F6.2,F7.2,3F7.3,F7.2)

 300    FORMAT(A,G12.4,F7.3,F7.2,F6.2,F7.2,2F7.3,F7.2,' (',F6.3,')')
        CALL MSGDOC(MDOC,LINE)

      ENDIF
      IF(PRF.EQ.'N') THEN
        INDEX_PRF(IPK) = IPK_TRANS
      ENDIF

      IF(CORR(IPK).GT.CORR_TOT) THEN

        IF(MOD1.EQ.'Y') THEN
          CALL LENSTR_BL(NAMET_OUT,LEN)
          IF(LEN.GT.0) THEN
            MODE   = 'E'
            SH2(1) = 0.0
            SH2(2) = 0.0
            SH2(3) = 0.0
            ALPHA  = 0.0
            BETA   = 0.0
            GAMMA  = 0.0
            DO I=1,3
              SH2(I) = 0.0
              SH1(I) = 0.0
              DO J=1,3
                AM(I,J) = 0.0
              ENDDO
            ENDDO
            CALL TRANS(M,NAMET_OUT,NAMEO,SH1,SH2
     *      ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900

            IF(NCS.GT.100.AND.MODE_D.EQ.'D') THEN

              IERR = 0
              CALL COPY_CRD_NCS(M,NAME0,NAMET_OUT,NCS
     *        ,NM_TOTAL,NA_TOTAL
     *        ,ANGLES_NCS,ANGLES_NCS_MON,CVECTOR_NCS
     *        ,IPRDOM,NSYM,ISYM,IPRSYM,IERR)
              IF(IERR.NE.0) GO TO 900
              IM = 0
              CALL COPY_MODEL(NAMET_OUT,NAME0,IM,ISYM,IPRSYM,IERR)
              IF(IERR.NE.0) GO TO 900

            ENDIF

          ENDIF
        ENDIF
        SCORR_TOT      = SCORR(IPK)
        CORR_TOT       = CORR(IPK)
        RFAC_TOT       = RFAC(IPK)
        IPK_BEST       = IPK
        IPK_TRANS_BEST = IPK_TRANS
        IPST_STOR_BEST = IPST_STOR

C        TXSH_BEST      = TXSH(IPK)
C        TYSH_BEST      = TYSH(IPK)
C        TZSH_BEST      = TZSH(IPK)
C        TALPHA_BEST    = TALPHA(IPK)
C        TBETA_BEST     = TBETA (IPK)
C        TGAMMA_BEST    = TGAMMA(IPK)

      ELSE

      ENDIF

      IF(NPTRANS.GE.0) THEN
        NP_FIN    = IPK
        CONTRAST_LIM_TEMP = CONTRAST_LIM
        IF(MODE_D.EQ.'D') CONTRAST_LIM_TEMP = CONTRAST_LIM * 1.5

        IF(NSCORE_NEW.GT.NSCORE_OLD) NRUN = NRUN + 1 
        IF(NRUN.GT.NRUN_LIM.AND.SCORE_FLAG.EQ.'Y'.AND.
     *            CORR_TOT.GT.CORR_BEST.AND.
     *     CONTRAST.GT.CONTRAST_LIM_TEMP) THEN
          LINE = 
     *    'INFO: contrast is good enough. Stop this run'
          CALL MSGDOC(MDOC,LINE)
          GO TO 830
        ENDIF
        NSCORE_OLD = NSCORE_NEW
      ENDIF
C --------------------------------------------
 820  CONTINUE
      IF(ISIGNAL_STOP.GT.0) GO TO 830
      IF(IPEAK.LT.NPROT) GO TO 800
C --------------------------------------------
 830  CONTINUE
c     Summary

C      IF(PRF.EQ.'N') THEN
C        CALL TF_SUMMARY(MDOC,NP_FIN,NMON,NCS,CONTRAST,CORR_MAX
        CALL TF_SUMMARY(MDOC,IPEAK,NMON,NCS,CONTRAST,CORR_MAX
     *   ,INDEX_PRF,IPEAK_NUMBER,PATH_SCR
     *   ,TALPHA,TBETA,TGAMMA,TXSH,TYSH,TZSH,RFAC,CORR,SCORR,IERR)
      IF(CONTRAST.GT.0.01) THEN
        WRITE(LINE,'(''Contrast = '',F8.2)') CONTRAST
        CALL MSGDOC(MDOC,LINE) 
      ELSE
        LINE = 'Contrast is not available'   
        CALL MSGDOC(MDOC,LINE)    
      ENDIF
C      ENDIF
C --------------------------------------------

      IF(NOSPGR.LT.0.OR.SPGR_INP(1:3).EQ.'ALL') THEN
        IF(ICHECK_SG.EQ.ICHECK_INIT) CORR_TOT = CORR_TOT + 0.001      
        CORR_CHECK(ICHECK_SG) = CORR_TOT
        CONTRAST_CHECK(ICHECK_SG) = CONTRAST
        IF(CORR_TOT.GT.CORR_CHECK_SG_BEST) THEN 
          CORR_CHECK_SG_BEST = CORR_TOT
          ICHECK_SG_BEST = ICHECK_SG       
        ENDIF

        IF(ISIGNAL_STOP.GT.0) THEN
          NSG_CHECK = ICHECK_SG
        ENDIF
        IF(ICHECK_SG.LT.NSG_CHECK) GO TO 210
        CALL MSGDOC(MDOC,' ')

        IF(LH_LH.NE.'N') THEN 
          FILE_FOBS_LH = FILE_FOBS_LH_STOR
          NAMET='molrep_fobs_LH_new.dat'
          CALL DELETE_FILE(PATH_SCR,NAMET)
        ENDIF

        CALL MSGDOC(MDOC,
     *'              --- Space Group Checking. ---')
        CALL MSGDOC(MDOC,
     *'+-------------------------------------------------------+')
        CALL MSGDOC(MDOC,
     *'|        Nsg     sg                        Score   Cntr |')
        CALL MSGDOC(MDOC,
     *'+-------------------------------------------------------+ ')

        DO II=1,NSG_CHECK

          WRITE(LINE,'(''|'',2I5,3X,A24,3X,2F7.3,'' |'')')
     *    II,ISG_CHECK(II),SG_CHECK(II)
     *    ,CORR_CHECK(II)
     *    ,CONTRAST_CHECK(II)
          CALL MSGDOC(MDOC,LINE)
        ENDDO
        CALL MSGDOC(MDOC,
     *'+-------------------------------------------------------+ ')
        CALL MSGDOC(MDOC,' ')

        IF(CORR_CHECK_SG_BEST.GT.-1.0) THEN
        IF(ICHECK_SG_BEST.NE.ICHECK_INIT) THEN      
          ISETT   = 0
          NSG     = 0
          NSG_LIB = ISG_CHECK(ICHECK_SG_BEST) 
          SPGR    = ' '
          NAMEF = 'molrep_fobs_new'
          CALL ADD_PATH(PATH_OUT,NAMEF)

          CALL CHANGE_GROUP(MDOC,NAMEF_INP,NAMEF
     *             ,NSG_LIB,SPGR,NSG,ISETT,NSYMLIB
     *             ,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MD,
     *      ' WARNING:  for keyword NOSG: can not change space group')
            IERR = 1
            IERR_XML     = 3
            MESSAGE_XML  = 'can not change space group'  
            RETURN
          ENDIF

          CALL LENSTR_BL(SPGR,L)
          WRITE(LINE,
     *'('' INFO: space group was changed to No ='',I5,'' Sett =''
     *    ,I5,3X,A)')
     *    NSG,ISETT,SPGR(1:L)
          CALL MSGDOC(MDOC,LINE)
          WRITE(LINE,'(33X,''No in symlib ='',I5)') NSYMLIB
          CALL MSGDOC(MDOC,LINE)

          LINE = 'INFO: New_Fobs: molrep_fobs_new.dat'
          CALL MSGDOC(MDOC,LINE)
          IERR = 1
          IERR_XML     = 99
          MESSAGE_XML  = 'new space group is found'
          NSG_SYMLIB_XML = NSYMLIB
          SPACE_GROUP_XML= ' '
        ELSE
          IERR = 1
          IERR_XML     = 4
          MESSAGE_XML  = 'no need to change space group'  
        ENDIF

        ELSE

          IERR = 1
          IERR_XML     = 1
          MESSAGE_XML  = ' '  

        ENDIF
        RETURN
      ENDIF           

      CALL MSGDOC(MDOC,' ')

c      WRITE(*,*) '>>',CORR_TOT,CORR_BEST,CORR_fix
c     *   ,IPK_BEST,IPK_TRANS_BEST

      IF(CORR_TOT.GT.-1.0.AND.IPK_BEST.GT.0.AND.
     *  IPK_TRANS_BEST.GT.0) THEN

c --- 16.02.05
c       IF(DB_LH.EQ.'Y'.AND.PST_LH.NE.'Y'.AND.
c --- 31.05.05
c        IF(SCORE_FLAG.EQ.'Y'.AND.PST_LH.NE.'Y'.AND.
c     *     NMON_FOUND.GT.0.AND.PRF.EQ.'N'.AND.
c     *                         CORR_TOT.GT.CORR_BEST) THEN  

        IF(PST_LH.NE.'U'.AND.PST_LH.NE.'Y'.AND.
     *         PST_LH.NE.'A'.AND.NMON_FOUND.GT.0.AND.
     *                         CORR_TOT.GT.CORR_BEST) THEN  
c-- 29.03.2010 also see below
c          DO IFOUND=1,NMON_FOUND
c            IF(LIST_RF_FOUND(IFOUND).EQ.IPK_BEST) THEN
c              CORR_TOT = -2.0
c              LINE = 'INFO: pseudo-translation was not detected,'//
c     *           ' it is not solution.'          
c              CALL MSGDOC(MDOC,LINE)
c              LINE = '      Turn off this possibility '//
c     *               '(use keyword PST = N) if you like'
c              CALL MSGDOC(MDOC,LINE)
c              WRITE(LINE,   
c     *        '(''          Final number of monomers :'',I5)') 
c     *        NMON_FOUND
c              CALL MSGDOC(MDOC,LINE)
c              GO TO 840
c            ENDIF
c          ENDDO
c-- 29.03.2010 

 840      CONTINUE

        ENDIF    
c ---
c        IF(SCORE_FLAG.EQ.'Y'.AND.CONTRAST.GT.0.01.AND.
c     *              PRF.EQ.'N'.AND.CORR_TOT.GT.CORR_BEST) THEN  

        IF(SCORE_FLAG.EQ.'Y'.AND.CONTRAST.GT.0.01.AND.
     *                           CORR_TOT.GT.CORR_BEST) THEN  
          CALL FINAL_MESSAGE(MDOC,CONTRAST,CORR_TOT)
        ENDIF    

C        IF(IFIRST_RUN_TF_FOR_PKMAX_FIRST.EQ.0) THEN
C          IF(PKMAX_FIRST.LE.0.0001) THEN
C            IFIRST_RUN_TF_FOR_PKMAX_FIRST = 1
C          ELSE
C          ENDIF
C        ENDIF

      ENDIF

      IF(CORR_TOT.GT.-1.0.AND.IPK_BEST.GT.0.AND.
     *  IPK_TRANS_BEST.GT.0) THEN

        IF(NMON.NE.NMONR.OR.MOD2.EQ.'Y') THEN

c          IF(MODE_D.EQ.'D'.AND.MOD2.NE.'Y') THEN
c           CORR_BEST = -0.9 
c          ENDIF

          T    = CORR_BEST+1.0
c          IF(CORR_BEST.LE.0.0) T = 0.0001
          IF(T.LE.0.0001) T = 0.0001
          TEST = (CORR_TOT+1.0)/T

          IF(TEST.LT.0.99999) THEN
            IF(MOD2.EQ.'Y'.AND.CORR_BEST.GT.-1.0) THEN
              WRITE(LINE,'(A,F6.3)')'Corr_for_fixed_model:',CORR_BEST
              CALL MSGDOC(MDOC,LINE)
            ENDIF
            IF(NMONR.EQ.NMON.AND.MOD2.EQ.'Y') THEN
              CALL MSGDOC(MDOC,'Sol_ WARNING: no solution was found')
              IERR = 1
C --XML--
              IERR_XML     = 2
              MESSAGE_XML  = 'no solution was found'
              CONTRAST_XML = 0.0
              NSOL_XML     = 0
C -------
              GO TO 900
            ENDIF

            I = NMONR-NMON
            CALL MSGDOC(MDOC,
     *      'WARNING: program can not improve current model')
            WRITE(LINE,
     *'(''         result is "molrep.crd" with '',I5,'' monomers'')') I
            CALL MSGDOC(MDOC,LINE)
            IF(IDIMER_FIRST.GT.0) THEN
              line = '         Try to use dimer'
              CALL MSGDOC(MDOC,LINE)
            ENDIF
C --XML--
            CONTRAST_XML = CONTRAST_BEST
C -------

            IF(MOD2.EQ.'Y') THEN
              MODE   = 'E'
              ALPHA  = 0.0
              BETA   = 0.0
              GAMMA  = 0.0
              DO I=1,3
                SH2(I) = 0.0
                SH1(I) = 0.0
                DO J=1,3
                  AM(I,J) = 0.0
                ENDDO
              ENDDO
              CALL TRANS(M,NAME2,NAMEO,SH1,SH2
     *        ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
              IF(IERR.NE.0) GO TO 900

c             write(*,*) 'copy-2:',name2
c             write(*,*) 'copy-2:',nameO

            ENDIF
C           cannot improve but solution exist
            GO TO 990
          ENDIF
        ENDIF

        IF(CORR_TOT.GT.CORR_BEST) THEN
          SCORR_BEST=SCORR_TOT
          CORR_BEST =CORR_TOT
          RFAC_BEST =RFAC_TOT
          IF(CONTRAST_BEST.GT.0.000001) THEN
            CONTRAST_BEST = CONTRAST
          ELSE
            CONTRAST_BEST = CONTRAST
          ENDIF
          PREV_CONTRAST_XML = CONTRAST_XML
          CONTRAST_XML = CONTRAST_BEST
          NSOL_XML     = NSOL_XML + 1
          IF(PST.EQ.'Y') THEN
            NSOL_XML     = NSOL_XML + 1
          ENDIF
        ENDIF

        IF(PST.EQ.'Y') THEN
          NMON = NMON-2
        ELSE IF(NCS.GT.100.AND.MODE_D.EQ.'D') THEN
          NMON = NMON-NM_TOTAL
        ELSE
          NMON = NMON-1
        ENDIF

        ALPHA_N = TALPHA_NEW(IPK_BEST)
        BETA_N  = TBETA_NEW (IPK_BEST) 
        GAMMA_N = TGAMMA_NEW(IPK_BEST)
        TXSH_N = TXSH(IPK_BEST) 
        TYSH_N = TYSH(IPK_BEST) 
        TZSH_N = TZSH(IPK_BEST) 

c        write(*,*) 'fast,stick,pst',fast,stick,pst
c        WRITE(*,*) '-11->',NAMET_OUT
c        WRITE(*,*) STICK,MOD1,IPK_BEST,PEAK_TEST(12,1)

        IDIMER  = 0
        IPT_MIN = 0

        CALL LENSTR_BL(NAMET_OUT,LEN)
        IF(MOD1.EQ.'Y') THEN
        IF(LEN.LE.0.OR.(FAST.EQ.'M'.AND.STICK.EQ.'Y')) THEN

          NAMET = NAMEO
          IF(MOD2.EQ.'Y') NAMET = NAMEC2 

          ALPHA  = TALPHA_NEW(IPK_BEST)
          BETA   = TBETA_NEW (IPK_BEST) 
          GAMMA  = TGAMMA_NEW(IPK_BEST)
          SH2(1) = TXSH(IPK_BEST) 
          SH2(2) = TYSH(IPK_BEST) 
          SH2(3) = TZSH(IPK_BEST)

          IF(STICK.EQ.'Y') THEN
            CALL STICK_TEST(MDOC,RAD_MODEL,IS_N
     *         ,ALPHA,BETA,GAMMA,SH2,PEAK_TEST
     *         ,ALPHA_N,BETA_N,GAMMA_N,THETA_N,PHI_N,CHI_N
     *         ,IPT_MIN,IDIMER
     *         ,SH1,NSYM,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900

            TXSH_N = SH1(1)
            TYSH_N = SH1(2)
            TZSH_N = SH1(3)

            CALL STORE_PEAK_FOR_TEST(ALPHA_N,BETA_N,GAMMA_N
     *        ,TXSH_N,TYSH_N,TZSH_N,PEAK_TEST)

          ENDIF

          ALPHA  = ALPHA_N
          BETA   = BETA_N 
          GAMMA  = GAMMA_N
          SH2(1) = TXSH_N
          SH2(2) = TYSH_N
          SH2(3) = TZSH_N

          MODE   = 'E'
          DO I=1,3
            SH1(I) = 0.0
            DO J=1,3
              AM(I,J) = 0.0
            ENDDO
          ENDDO

          NAMET_PST = NAMET
          IF(PST.EQ.'Y') THEN
            NAMET_PST = NAMEO_PST
          ENDIF

c            write(*,*) 'fast,stick,pst',fast,stick,pst
c            write(*,*) '-r-nm:',namem
c            write(*,*) '-r-nt:',namet_PST
c            write(*,*) 'sh:',sh2(1),sh2(2),sh2(3)

          CALL TRANS(M,NAMEM,NAMET_PST,SH1,SH2
     *    ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
c --
          IF(NCS.GT.100.AND.MODE_D.EQ.'D') THEN

            CALL COPY_CRD_NCS(M,NAMET_PST,NAMEC2_PST,NCS
     *        ,NM_TOTAL,NA_TOTAL
     *        ,ANGLES_NCS,ANGLES_NCS_MON,CVECTOR_NCS
     *        ,IPRDOM,NSYM,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900
            IM = 0
            CALL COPY_MODEL(NAMEC2_PST,NAMET_PST,IM
     *             ,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900

          ENDIF
c ---

c//pst///
          IF(PST.EQ.'Y') THEN

cc-            NAMET_PST = NAMEO_PST
cc-            IF(MOD2.EQ.'Y') NAMET_PST = NAMEC2_PST 

            ALPHA_NN = TALPHA_NEW(IPK_BEST)
            BETA_NN  = TBETA_NEW (IPK_BEST) 
            GAMMA_NN = TGAMMA_NEW(IPK_BEST)
            ALPHA    = TALPHA_NEW(IPK_BEST)
            BETA     = TBETA_NEW (IPK_BEST) 
            GAMMA    = TGAMMA_NEW(IPK_BEST)
            SH2(1)   = TXSH(IPK_BEST) 
            SH2(2)   = TYSH(IPK_BEST) 
            SH2(3)   = TZSH(IPK_BEST)
            SPST(1)  = PST_VECTORS(1,IPST_STOR_BEST)
            SPST(2)  = PST_VECTORS(2,IPST_STOR_BEST)
            SPST(3)  = PST_VECTORS(3,IPST_STOR_BEST)

            CALL FTOO(SPST,SH1,IERR)
            SH2(1) = SH1(1) + SH2(1)
            SH2(2) = SH1(2) + SH2(2)
            SH2(3) = SH1(3) + SH2(3)
            TXSH_NN = SH2(1)
            TYSH_NN = SH2(2)
            TZSH_NN = SH2(3)

            IF(STICK.EQ.'Y') THEN
              CALL MSGDOC(MDOC,' --- For second monomer ---')

              CALL STICK_TEST(MDOC,RAD_MODEL,IS_N
     *           ,ALPHA,BETA,GAMMA,SH2,PEAK_TEST
     *           ,ALPHA_NN,BETA_NN,GAMMA_NN,THETA_NN,PHI_NN,CHI_NN
     *           ,IPT_MIN_2,IDIMER_2
     *           ,SH1,NSYM,ISYM,IPRSYM,IERR)
              IF(IERR.NE.0) GO TO 900
              TXSH_NN = SH1(1)
              TYSH_NN = SH1(2)
              TZSH_NN = SH1(3)

              IF(IDIMER_FIRST.LE.0.AND.IDIMER_2.GT.0) THEN
                IDIMER  = IDIMER_2
                IPT_MIN = IPT_MIN_2
              ENDIF

              CALL STORE_PEAK_FOR_TEST(ALPHA_NN,BETA_NN,GAMMA_NN
     *        ,TXSH_NN,TYSH_NN,TZSH_NN,PEAK_TEST)

            ENDIF


            MODE   = 'E'
 
            ALPHA  = ALPHA_NN
            BETA   = BETA_NN 
            GAMMA  = GAMMA_NN
            SH2(1) = TXSH_NN
            SH2(2) = TYSH_NN
            SH2(3) = TZSH_NN
            
            DO I=1,3
              SH1(I) = 0.0
              DO J=1,3
                AM(I,J) = 0.0
              ENDDO
            ENDDO

c            write(*,*) '-IPST_STOR :',IPST_STOR
c            write(*,*) '-pst2-nt :',namet_pst
c            write(*,*) '-pst2-nt_pst:',nameC2_pst
c            write(*,*) 'a,b,g:',ALPHA,BETA,GAMMA
c            write(*,*) 'sh:',sh2(1),sh2(2),sh2(3)

            CALL TRANS(M,NAMEM,NAMEC2_PST,SH1,SH2
     *      ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900


            IERR = NMONR-NMON 

c          write(*,*) '-IERR :',IERR
c          write(*,*) '-JOIN :',namet_PST
c          write(*,*) '-JOIN :',nameC2_PST
c          write(*,*) '-JOIN :',namet

            CALL JOINCRD(M,NAMET_PST,NAMEC2_PST,NAMET
     *                 ,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900

          ENDIF
c//pst//
          IF(STICK.EQ.'Y'.AND.
     *      IDIMER_FIRST.LE.0.AND.IDIMER.GT.0) THEN

            IDIMER_FIRST = 1

            ALPHA  = PEAK_TEST(3,IPT_MIN)
            BETA   = PEAK_TEST(4,IPT_MIN) 
            GAMMA  = PEAK_TEST(5,IPT_MIN) 
            SH2(1) = PEAK_TEST(6,IPT_MIN)
            SH2(2) = PEAK_TEST(7,IPT_MIN) 
            SH2(3) = PEAK_TEST(8,IPT_MIN) 
            MODE   = 'E'
            DO I=1,3
              SH1(I) = 0.0
              DO J=1,3
                AM(I,J) = 0.0
              ENDDO
            ENDDO

            CALL TRANS(M,NAMEM,NAMET1,SH1,SH2
     *      ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900

            IERR = 2
 
            CALL JOINCRD(M,NAMET1,NAMET,NAME_DIMER,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900

            IERR = 20
            CALL WRITEPDB(M,NAME_DIMER,NAME_DIMER,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900

            IF(N_MODEL.GT.1) THEN
cc            for one IMODEL = 1; IMODEL = 0 rerange and chain_ID correction
              IMODEL = 1
              CALL WRITE_NMR_PDB(M,IMODEL
     *                  ,NAME_DIMER,NMODEL,PATH_SCR,IERR)
              IF(IERR.NE.0) GO TO 900
            ENDIF

            LINE = 'INFO:  you can find this dimer'//
     *             ' in molrep_dimer.pdb'
            CALL MSGDOC(MDOC,LINE)
            CALL LENSTR_BL(NAME_DIMER,LEN)
            DIMER_XML = NAME_DIMER(1:LEN)//'.pdb'
          ENDIF

          IF(MOD2.EQ.'Y') THEN
C           + NAME2
            IERR = NMONR-NMON 
            IF(PST.EQ.'Y') IERR = IERR/2 + 1

c            write(*,*) '--1--,nmonr,nmon,ierr:',nmonr,nmon,ierr
c            write(*,*) '-n2:',name2
c            write(*,*) '-nt:',namet
c            write(*,*) '-no:',nameo

            IF(NCS.GT.100.AND.MODE_D.EQ.'D') IERR = -1 

            CALL JOINCRD(M,NAME2,NAMET,NAMEO,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900

          ENDIF

          IF(MOD1.EQ.'D') THEN
C            --> ANGLES,SHIFT,FLAG _BEST
          ENDIF
        ENDIF
        ENDIF

        SH2(1) =TXSH_N 
        SH2(2) =TYSH_N 
        SH2(3) =TZSH_N

        CALL OTOF(SH2,SH1,IERR)

        I = NMONR-NMON

        CALL MSGDOC(MDOC,' ')

        IF(MODE_D.EQ.'D') THEN
          LINE =
     * ' Nmon RF  TF   theta    phi     chi'//
     * '   tx     ty     tz     TFcnt  wRfac  Score'
        ELSE
          LINE =
     * ' Nmon RF  TF   theta    phi     chi'//
     * '   tx     ty     tz     TFcnt  wRfac  Score'
        ENDIF
        CALL MSGDOC(MDOC,LINE)
        RALPHA  = (ALPHA_N*PI)/180.0
        RBETA   = (BETA _N*PI)/180.0
        RGAMMA  = (GAMMA_N*PI)/180.0
        CALL EULERM(RALPHA,RBETA,RGAMMA,AM)
        CALL MTOPOL(AM,THETA,PHI,CHI)
        WRITE(LINE,
     *  '(''  '',I2,I4,I4,3F8.2,3F7.3,F7.2,2F7.3)')
     *  I,IPK_BEST,IPK_TRANS_BEST
     *  ,THETA,PHI,CHI
     *  ,SH1(1),SH1(2),SH1(3),SCORR_BEST,RFAC_BEST,CORR_BEST

c        IF(LINE( 3: 3).EQ.' ') LINE( 3: 3) = '_'
C        IF(LINE(13:13).EQ.' ') LINE(13:13) = '_'
C        IF(LINE(18:18).EQ.' ') LINE(18:18) = '_'
        CALL MSGDOC(MDOC,LINE)
        CALL MSGDOC(MDOC,' ')
        IF(PST.EQ.'Y') THEN
          WRITE(LINE,'(A,I3,A,3F8.3)') 
     *    'PST_vector was used',IPST_STOR_BEST,':'
     *    ,(PST_VECTORS(JJJ,IPST_STOR_BEST),JJJ=1,3)
          CALL MSGDOC(MDOC,LINE)
        ENDIF

        IF(NMON.GT.0) THEN

          IF(MOD1.EQ.'Y') THEN
            MODE   = 'E'
            SH2(1) = 0.0
            SH2(2) = 0.0
            SH2(3) = 0.0
            ALPHA  = 0.0
            BETA   = 0.0
            GAMMA  = 0.0
            DO I=1,3
              SH2(I) = 0.0
              SH1(I) = 0.0
              DO J=1,3
                AM(I,J) = 0.0
              ENDDO
            ENDDO
            NAME2='molrep2'

c            write(*,*) '-c-no:',nameo
c            write(*,*) '-c-n2:',name2

            CALL ADD_PATH(PATH_SCR,NAME2)

            CALL TRANS(M,NAMEO,NAME2,SH1,SH2
     *      ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900

            MOD2 = 'Y'

          ENDIF

          CALL MSGDOC(MDOC,' ')
          I = NMONR-NMON
          WRITE(LINE,
     *    '('' Number of monomers in fixed model_2 :'',I5)') I
          CALL MSGDOC(MDOC,LINE)
          CALL MSGDOC(MDOC,' ')
          CALL MSGDOC(MDOC,' ')
          CALC2 = 'Y'
          NMON_FOUND = NMON_FOUND + 1
          LIST_RF_FOUND(NMON_FOUND) = IPK_BEST

C -------
          IF(PST_LH.NE.'U'.AND.PST_LH.NE.'Y'.AND.PST_LH.NE.'A'.AND.
     *                                               PRF.EQ.'N') THEN
c-- 29.03.2010 also see above
c            LINE = 'INFO: pseudo-translation was not detected, so'
c            CALL MSGDOC(MDOC,LINE)
c            WRITE(LINE,
c     *      '(''      Rotation Peak:'',I3,'' will not be used more'')')
c     *      IPK_BEST 
c            CALL MSGDOC(MDOC,LINE)
c              LINE = '      Turn off this possibility '//
c     *               '(use keyword PST = N) if you like'
c              CALL MSGDOC(MDOC,LINE)
c            INDEX_TF(IPK_BEST) = 1
c            CORR(IPK_BEST) = -3.0
c-- 29.03.2010 

          ENDIF
C -------

          IF(PST_LH.NE.'U'.AND.PST_LH.NE.'Y'.AND.PST_LH.NE.'A'.AND.
     *                                               PRF.NE.'N') THEN
C         IF(PRF.NE.'N') THEN
            INDEX_PRF(IPK_BEST) = 1
            NOUSED_RF = NOUSED_RF + 1
            IF(NOUSED_RF.EQ.NPROT) GO TO 900
            WRITE(LINE,
     *      '('' --- Rotation Peak:'',I3,'' will not be used more'')')
     *      IPK_BEST 
            CALL MSGDOC(MDOC,LINE)
          ENDIF
   
          IF(STICK.EQ.'Y') THEN


C            CALL STORE_PEAK_FOR_TEST(TALPHA_NEW(IPK_BEST)
C     *          ,TBETA_NEW(IPK_BEST),TGAMMA_NEW(IPK_BEST)
C     *        ,TXSH(IPK_BEST),TYSH(IPK_BEST),TZSH(IPK_BEST)
C     *                     ,PEAK_TEST)

C            I = PEAK_TEST(12,1) 
C            IF(I.EQ.1) THEN
C              IF((ABS(PEAK_TEST(6,I)).LT.0.001.AND.
C     *            ABS(PEAK_TEST(7,I)).LT.0.001.AND.
C     *            ABS(PEAK_TEST(8,I)).LT.0.001    ).AND.
C     *           (ABS(PEAK_TEST(9,I)).LT.0.001.AND.
C     *            ABS(PEAK_TEST(10,I)).LT.0.001.AND.
C     *            ABS(PEAK_TEST(11,I)).LT.0.001    )) THEN
C              ELSE
C                I = I + 1
C              ENDIF
C            ELSE
C              I = I + 1
C            ENDIF
C            PEAK_TEST(12,1) = I
C            J = 0 
C            IF(I.GE.2) J = PEAK_TEST( 1,I-1) 
C            J = J + 1
C            PEAK_TEST( 1,I) = J 
C            PEAK_TEST( 2,I) = 1
C            PEAK_TEST( 3,I) = TALPHA_NEW(IPK_BEST)
C            PEAK_TEST( 4,I) = TBETA_NEW (IPK_BEST)
C            PEAK_TEST( 5,I) = TGAMMA_NEW(IPK_BEST)
C            PEAK_TEST( 6,I) = TXSH(IPK_BEST)
C            PEAK_TEST( 7,I) = TYSH(IPK_BEST)
C            PEAK_TEST( 8,I) = TZSH(IPK_BEST)
C            PEAK_TEST( 9,I) = 0
C            PEAK_TEST(10,I) = 0
C            PEAK_TEST(11,I) = 0

          ENDIF
C ---
          CALL WRITE_XML_FILE(IERR,PATH_OUT)
C ---
          IF(ISIGNAL_STOP.GT.0) GO TO 990
          GO TO 200

        ENDIF

C       solution OK
        GO TO 990

      ELSE

c           IF(NOSPGR.LT.0) THEN
C           ENDIF           

        IF(PRF.NE.'N') THEN
          I = NMONR-NMON
          IF(I.GT.0) THEN
            CALL MSGDOC(MDOC,
     *      'Sol_ WARNING: can not find more solution')
            WRITE(LINE,   
     *'(''          Final number of monomers in fixed model_2 :'',I5)') 
     *    I
            CALL MSGDOC(MDOC,LINE)
C --XML--
             CONTRAST_XML = CONTRAST_BEST
C -------
            GO TO 990
          ELSE IF(I.LE.0) THEN
            CALL MSGDOC(MDOC,'Sol_ WARNING: no solution was found')
            IERR = 1
C --XML--
            IERR_XML     = 2
            MESSAGE_XML  = 'no solution was found'
            CONTRAST_XML = 0.0
            NSOL_XML     = 0
C -------
            GO TO 900
          ENDIF
        ELSE
          IF(NMONR.EQ.NMON) THEN
            CALL MSGDOC(MDOC,'Sol_ WARNING: no solution was found')
            IERR = 1
C --XML--
            IERR_XML     = 2
            MESSAGE_XML  = 'no solution was found'
            CONTRAST_XML = 0.0
            NSOL_XML     = 0
C -------
            GO TO 900
          ENDIF
        ENDIF

      ENDIF
C --------------------------------------------
 990  CONTINUE

      MESSAGE_XML  = 'normal termination'  

      IF(MOD1.EQ.'Y') THEN

      ELSE IF(MOD1.EQ.'D') THEN

C       create molrep_fcalc phcalc (MOD1 + MOD2)           

        ALPHA = TALPHA(IPK_BEST)
        BETA  = TBETA (IPK_BEST)
        GAMMA = TGAMMA(IPK_BEST)

        SH2(1) =TXSH(IPK_BEST) 
        SH2(2) =TYSH(IPK_BEST) 
        SH2(3) =TZSH(IPK_BEST) 
        CALL OTOF(SH2,SH1,IERR)

C --
        IERR = NMONR-(NMON-1)

        PARM_TR( 1: 1) = 'F'
        FPAR_TR( 3) = ALPHA
        FPAR_TR( 4) = BETA
        FPAR_TR( 5) = GAMMA

C        FPAR_TR(14) = SH1(1)
C        FPAR_TR(15) = SH1(2)
C        FPAR_TR(16) = SH1(3)

        RESULT(1, 9) = SH1(1)
        RESULT(1,10) = SH1(2)
        RESULT(1,11) = SH1(3)

        RESULT(1,12) = 1


        NAMET_OUT   = ' ' 
        NAMED       = ' '

        NAME_FCALC  = 'molrep_fcalc'
        CALL ADD_PATH(PATH_SCR,NAME_FCALC)
        NAME_PHCALC = 'molrep_phcalc'
        CALL ADD_PATH(PATH_SCR,NAME_PHCALC)

C        LIST     = 'T'
C        PARM_TR(20:20) = 'T'

        MMM = M
        IF(LIST.EQ.'T') MMM = MDOC

c       resmin_out  200 just flag to use max(A,B,C)
        RESMIN_OUT = 200.0
        FPAR_TR(17) = RESMIN_OUT
c       aniso 
        PARM_TR( 7: 7) = 'K' 
c       pack
        PARM_TR( 4: 4) = 'N'
        IFIRST_SCL  = 0
        FPAR_TR(18) = IFIRST_SCL
        IF(MODE_D.EQ.'D') LH_LH = 'N' 

        ncs_test = 0

        CALL TRFUN(MMM,NAMEF,NAMEM,NAME_PH,NAME2,NAMET_OUT
     *  ,NAMED,NAME_FCALC,NAME_PHCALC,PATH_SCR
     *  ,IPK,PRF_SH(1,IPK),NC,NPT,NMR,N_MODEL,NEL2,NCP,NCS_test
     *  ,ANGLES_NCS,CVECTOR_NCS 
     *  ,PARM_TR,FPAR_TR,SPST,PEAK_TEST
     *  ,ISYM,IPRSYM
     *  ,RESULT,RESULT3,IPRMAX,IPRROW,IERR)
        IF(IERR.NE.0) GO TO 900
        LH_LH = LH

        LINE = '         result is "molrep_fcalc.dat"'
        CALL MSGDOC(MDOC,LINE)
c        LINE = '                   "molrep_fcalc_scl.dat"'
c        CALL MSGDOC(MDOC,LINE)
        LINE = '                   "molrep_phcalc.dat"'
        CALL MSGDOC(MDOC,LINE)

c /////
c        NAME_FCALC_SCL = 'molrep_fcalc_scl'
c        CALL ADD_PATH(PATH_SCR,NAME_FCALC_SCL)
c        RESMNI = 0.0
c        RESMXI = 0.0
c        SCALEP = 0.0
c        BSCALE = 0.0
c        ACORR  = 'N' 
c        ANISO_T= 'K'
c
c        CALL MR_SCALING(M,LIST,NAMEF,NAME_FCALC,NAME_FCALC_SCL
c     * ,PATH_SCR
c     * ,ANISO_T,SCALEP,BSCALE,ACORR,BOFF_SCL,BADD_SCL
c     * ,RESMNI,RESMXI
c     * ,SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF
c     * ,RESULTA,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
C ---------------------------------------------------------
C     1. ACORR # N - anisothermal correction of Fmod
c        if ANISO = '-' return
C     2. ANISO = K - FSCALE with SCALEP,BSCALE
C                   if scale = 0 - scaling by Fobs (cell must be the same)
C                      only scale , set BOVER = 0
C                   if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                  no info: rfac, corr
C        else  CALL PSCALE
C      output: SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF and NAMEFM2
C ---------------------------------------------------------
c        IF(IERR.NE.0) GO TO 900
c 
c        WRITE(LINE,'('' scale,B_scale       :'',2F8.3)') 
c     *  SCALEP_NEW,BSCALE_NEW
c        CALL MSGDOC(MDoc,LINE)
c        WRITE(LINE,'('' Rfac,Corr           :'',2F8.3)') 
c     *  RFAC_REF,CORR_REF
c        CALL MSGDOC(MDoc,LINE)
c /////
c        IF(CCP4.EQ.'Y') THEN
          NAMET = 'molrep_fcalc.cif'
          CALL ADD_PATH(PATH_SCR,NAMET)
          CFREE = 'N'
          CSIG  = 'N'
          CFOM  = 'N'

          NAMET1=' '

c          CALL F2CIF(Mdoc,NAMEF,NAME_FCALC,NAME_PHCALC,NAMET

C          CALL F2CIF(M,NAME_FCALC,NAMET1,NAME_PHCALC,NAMET

          CALL F2CIF(M,NAMET1,NAME_FCALC,NAME_PHCALC,NAMET
     *          ,CFOM,CFREE,CSIG
     *          ,RESMIN,RESMAX,ISYM,IPRSYM,RESULT,IPRROW,IERR)
          IF(IERR.NE.0) GO TO 900
          LINE = '         file "molrep_fcalc.cif" was created'
          CALL MSGDOC(MDOC,LINE)
          LINE = '               with Fcalc,Phcalc'
c          LINE = '               with Fobs,Fcalc,Phcalc'
          CALL MSGDOC(MDOC,LINE)
c        ENDIF

      ENDIF
C ---------------
 900  CONTINUE

      NAMET='trfun.crd'
      CALL DELETE_FILE(PATH_SCR,NAMET)
      NAMET='molrp_scr.crd'
      CALL DELETE_FILE(PATH_SCR,NAMET)



      RETURN

      END

      SUBROUTINE STORE_PEAK_FOR_TEST(ALPHA,BETA,GAMMA,TX,TY,TZ
     *                     ,PEAK_TEST)
C -----------------------------------
      REAL PEAK_TEST(12,*)
C -----------------------------------
      I = PEAK_TEST(12,1) 
      IF(I.EQ.1) THEN
        IF((ABS(PEAK_TEST(6,I)).LT.0.001.AND.
     *      ABS(PEAK_TEST(7,I)).LT.0.001.AND.
     *      ABS(PEAK_TEST(8,I)).LT.0.001    ).AND.
     *     (ABS(PEAK_TEST(9,I)).LT.0.001.AND.
     *      ABS(PEAK_TEST(10,I)).LT.0.001.AND.
     *      ABS(PEAK_TEST(11,I)).LT.0.001    )) THEN
        ELSE
          I = I + 1
        ENDIF
      ELSE
        I = I + 1
      ENDIF
      PEAK_TEST(12,1) = I
      J = 0 
      IF(I.GE.2) J = PEAK_TEST( 1,I-1) 
      J = J + 1
      PEAK_TEST( 1,I) = J 
      PEAK_TEST( 2,I) = 1
      PEAK_TEST( 3,I) = ALPHA
      PEAK_TEST( 4,I) = BETA
      PEAK_TEST( 5,I) = GAMMA
      PEAK_TEST( 6,I) = TX
      PEAK_TEST( 7,I) = TY
      PEAK_TEST( 8,I) = TZ
      PEAK_TEST( 9,I) = 0
      PEAK_TEST(10,I) = 0
      PEAK_TEST(11,I) = 0
C ---
      RETURN
      END

      SUBROUTINE TF_SUMMARY(MDOC,NPROT,NMON,NCS,CONTRAST,CORR_MAX
     *   ,INDEX_PRF,IPEAK_NUMBER,PATH_SCR
     *   ,TALPHA,TBETA,TGAMMA,TXSH,TYSH,TZSH,RFAC,CORR,SCORR,IERR)
C --------------------------------
      INTEGER   MDOC,NPROT,IERR
      INTEGER   INDEX_PRF(*),IPEAK_NUMBER(*)
      REAL      TALPHA(*),TBETA(*),TGAMMA(*),TXSH(*),TYSH(*),TZSH(*)
     *         ,RFAC(*),CORR(*),SCORR(*)    
      CHARACTER PATH_SCR*(*)
C ---
      REAL      AM(3,3),SH1(3),SH2(3),SORT(200)
      INTEGER   ISORT(200)
      CHARACTER LINE*256,CH8*8
C --------------------------------------------------------------
      PI   = 4.0*ATAN(1.0)
      M    = 99
      IERR = 0
C ---
C      CONTRAST = -10.0
      CORR_MAX = -10.0
      IF(NPROT.LE.0) RETURN

      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     * '                             --- Summary ---')
      LINE = '+----------------------------------'//
     * '--------------------------------------------+'
      CALL MSGDOC(MDOC,LINE)
      LINE =
     * '|     RF  TF   theta    phi     chi'//
     * '    tx     ty     tz    TFcnt  wRfac  Score |'
      CALL LENSTR_BL(LINE,LEN)
      CALL MSGDOC(MDOC,LINE(1:LEN))    
      LINE = '+----------------------------------'//
     * '--------------------------------------------+'
      CALL MSGDOC(MDOC,LINE)

      DO I=1,NPROT
C        ISORT(I) = I
        ISORT(I) = IPEAK_NUMBER(I)
        SORT(I)  = CORR(IPEAK_NUMBER(I))

C        WRITE(*,*) 'I,IPK:',I,IPEAK_NUMBER(I),SORT(i)

      ENDDO
C
C     sort
      IF(NPROT.GT.1) THEN
        CALL SORT1(SORT,NPROT,ISORT)
      ENDIF
      II = 0
      DO I=NPROT,1,-1
        II = II + 1
        IPEAK_NUMBER(II) = ISORT(I)

C        WRITE(*,*) 'after I,ii,IPK:',I,ii,IPEAK_NUMBER(iI),SORT(i)

      ENDDO
C
      N_MON = NMON
C      IF(NCS.GT.0) THEN
C        IF(NCS.EQ.532) THEN
C          I = 60
C        ELSE IF(NCS.EQ.432) THEN
C          I = 24
C        ELSE IF(NCS.EQ.230) THEN
C          I = 12
C        ELSE
C          N_MAIN = NCS/100
C          N_ADD  = MOD(NCS,100)
C          I = N_MAIN
C          IF(N_ADD.EQ.20.OR.N_ADD.EQ.22) I = I*2
C        ENDIF    
C        IF(I.GT.0) N_MON = N_MON*I
C      ENDIF
C
c      write(*,*) 'ncs,nmon,n_mon:',ncs,nmon,n_mon
C
C      SUMCW = 0.0
C      SUMW  = 0.0
C      NW    = 0

C      III = 0
C      DO II=NPROT,1,-1
C        III = III + 1
C        I = ISORT(II)

      DO II=1,NPROT
        III = NPROT-II+1
        I = IPEAK_NUMBER(II)
        RALPHA  = (TALPHA(I)*PI)/180.0
        RBETA   = (TBETA (I)*PI)/180.0
        RGAMMA  = (TGAMMA(I)*PI)/180.0
        SH2(1) =TXSH(I) 
        SH2(2) =TYSH(I) 
        SH2(3) =TZSH(I) 
        CALL OTOF(SH2,SH1,IERR)

        CALL EULERM(RALPHA,RBETA,RGAMMA,AM)
        CALL MTOPOL(AM,THETA,PHI,CHI)

        WRITE(CH8,'(''|'',I3,I4)') II,I
c        DO J=1,8
c          IF(CH8(J:J).EQ.' ') CH8(J:J) = '_'
c        ENDDO

        WRITE(LINE,300) CH8,INDEX_PRF(I),THETA,PHI,CHI
     *    ,SH1(1),SH1(2),SH1(3),SCORR(I),RFAC(I),CORR(I)
 300    FORMAT(A8,I4,3F8.2,3F7.3,F7.2,2F7.3,' |')

c        WRITE(LINE,300) CH8,II,THETA,PHI,CHI
c     *    ,SH1(1),SH1(2),SH1(3),SCORR(I),RFAC(I),CORR(I)
c 300    FORMAT(A8,I4,3F8.2,3F7.3,F7.2,2F7.3)

        CALL LENSTR_BL(LINE,LEN)
        CALL MSGDOC(MDOC,LINE(1:LEN))    

C        CORRNPROT = CORR(NPROT) + 1.0
C        CORRII = CORR(II) + 1.0
C        IF(III.GT.N_MON.AND.CORRII.GT.0.0.AND.NW.LT.8) THEN
C          W = 1.0/FLOAT(III-N_MON)
C          SUMCW = SUMCW + CORRII*W
C          SUMW  = SUMW  + W
C          NW    = NW    + 1
C        ENDIF

      ENDDO
      LINE = '+----------------------------------'//
     * '--------------------------------------------+'
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' ')

      CORR_MAX = CORR(NPROT)
C      IF(NPROT.GT.N_MON.AND.NW.GT.0) THEN
C        IF(ABS(SUMW).GT.0.0001) THEN
C          T = SUMCW/SUMW
C
C          write(*,*) sumcw,sumw,T,CORR(NPROT),CORR(NPROT-1)
C
C          IF(ABS(T).GT.0.0001) THEN
C            CONTRAST = ABS(CORRNPROT)/ABS(T)
C            WRITE(LINE,'(''Contrast = '',F8.3)') CONTRAST
C            CALL MSGDOC(MDOC,LINE)    
C          ENDIF
C        ENDIF
C      ENDIF
C      CALL MSGDOC(MDOC,' ')

C      DO II=1,NPROT
C        I  = ISORT(II)
C        IT = CORR(II)
C        
C      ENDDO

      RETURN
      END

      SUBROUTINE INIT_INERTIA_MATRIX
C==================================================================
      COMMON/COM_INERTIA_MATRIX/ MOD_FLAG,AMINER    
      INTEGER    MOD_FLAG
      REAL       AMINER(3,3)
C==================================================================
      MOD_FLAG = 0
      RETURN
      END

      SUBROUTINE CALC_INERTIA_MATRIX(MDOC,MOD,NAMEC
     *      ,NSYM,ISYM,IPRSYM,IERR)
C==================================================================
      INTEGER     MDOC,IPRSYM,IERR
      INTEGER*2   ISYM(5,3,IPRSYM)
      CHARACTER   NAMEC*(*),MOD*1
C ---
      COMMON/COM_INERTIA_MATRIX/ MOD_FLAG,AMINER    
      INTEGER    MOD_FLAG
      REAL       AMINER(3,3)
C ---
C==================================================================
      IF(MOD.NE.'Y') THEN
        MOD_FLAG = 0
        RETURN
      ELSE
        MOD_FLAG = 1
      ENDIF
      
      CALL CALC_INERTIA_MATRIX_RUN(MDOC,NAMEC
     *      ,AMINER,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        MOD_FLAG = 0
        IERR     = 0
      ENDIF
C --------------------------------------
      RETURN
      END

      SUBROUTINE CALC_INERTIA_MATRIX_RUN(MDOC,NAMEC
     *      ,AMINER,NSYM,ISYM,IPRSYM,IERR)
C==================================================================
      INTEGER     MDOC,IPRSYM,IERR
      INTEGER*2   ISYM(5,3,IPRSYM)
      REAL        AMINER(3,3)

c     REAL        XYZ(3,NMAX)
      real,        allocatable :: XYZ(:,:)

      CHARACTER   NAMEC*(*)
C --------
      INCLUDE 'mr_crd_com.fh'
C --------
      REAL      XMEAN(3)
      CHARACTER LINE*256
C==================================================================
      IERR = 0
      MD   = -ABS(MDOC)-1
      M    = 99
C --------
      CALL CORR_NAME_BL(NAMEC)
      CALL LENSTR_BL(NAMEC,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong input /crd/ file name')
        IERR = 1
        RETURN
      ENDIF
c ----------------
      IN  = 10
      CALL ORCRD(MD,IN,NAMEC,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN INPUT_FILE/CRD/')
        RETURN
      ENDIF
C --------
      NATOM = 0
      IEND  =-1
C --------------------------------
 200  CONTINUE

      CALL RDCRD(M,IN,MODE,IEND,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: READ INPUT_FILE/CRD/')
        CLOSE(IN)
        RETURN
      ENDIF
      IF(IEND.NE.0) GO TO 300
      IF(MODE.EQ.0) THEN
        IF(CR_OCC.GT.0.001) THEN
          NATOM = NATOM + 1
        ENDIF
      ELSE
C       CR_LINE - string of comments 
      ENDIF      
C ----
      GO TO 200
C --------------------------------------
 300  CONTINUE
      CLOSE(IN)
      IF(NATOM.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: Number of atoms = 0')
        IERR = 1
        RETURN
      ENDIF
      IN  = 10
      CALL ORCRD(MD,IN,NAMEC,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN INPUT_FILE/CRD/')
        RETURN
      ENDIF
C --------
      NMAX = NATOM

      allocate(XYZ(1:3,1:NMAX),STAT=ISTAT)
      IF(ISTAT.NE.0) THEN
        IERR = 1
        CALL MSGERR(MDOC,
     *    ' ERROR: in CALC_INERTIA_MATRIX: ')
        CALL MSGERR(MDOC,
     *    '        problem with memory allocation')
        CALL MSGERR(MDOC,
     *    '        try to change resolution')
        RETURN
      ENDIF

      NATOM = 0
      IEND  =-1
C --------------------------------
 210  CONTINUE

      CALL RDCRD(M,IN,MODE,IEND,IERR)
      IF(IERR.NE.0) THEN
        deallocate(XYZ,STAT=ISTAT)
        CALL MSGERR(MDOC,' ERROR: READ INPUT_FILE/CRD/')
        CLOSE(IN)
        RETURN
      ENDIF
      IF(IEND.NE.0) GO TO 310

      IF(MODE.EQ.0) THEN

        IF(CR_OCC.GT.0.001) THEN
c          IF(NATOM.GE.NMAX) THEN
c            WRITE(LINE,'(''ERROR Number of atoms > limit '',I10)')
c     *      NMAX
c            CALL MSGERR(MDOC,LINE)
c            IERR = 1
c            RETURN
c          ENDIF
          NATOM = NATOM + 1
          XYZ(1,NATOM) = CR_XYZ(1) 
          XYZ(2,NATOM) = CR_XYZ(2) 
          XYZ(3,NATOM) = CR_XYZ(3) 
        ENDIF

      ELSE

C       CR_LINE - string of comments 

      ENDIF      
C ----
      GO TO 210
C --------------------------------------
 310  CONTINUE
      CLOSE(IN)
      IF(NATOM.LE.0) THEN
        deallocate(XYZ,STAT=ISTAT)
        CALL MSGERR(MDOC,' ERROR: Number of atoms = 0')
        IERR = 1
        RETURN
      ENDIF
C --------------------------------------
      DO I=1,3
        XMEAN(I) = 0.0
      ENDDO
      DO IA=1,NATOM
        DO I=1,3
          XMEAN(I) =  XMEAN(I) + XYZ(I,IA)
        ENDDO
      ENDDO
      DO I=1,3
        XMEAN(I) = XMEAN(I)/FLOAT(NATOM)
      ENDDO
      DO IA=1,NATOM
        DO I=1,3
          DO J=1,3
            AMINER(I,J) = AMINER(I,J) + 
     *        (XYZ(I,IA) - XMEAN(I))*(XYZ(J,IA) - XMEAN(J))
          ENDDO
        ENDDO
      ENDDO
      DO I=1,3
        DO J=1,3
          AMINER(I,J) = AMINER(I,J)/FLOAT(NATOM) 
        ENDDO
      ENDDO
      deallocate(XYZ,STAT=ISTAT)
C --------------------------------------
      RETURN
      END

      SUBROUTINE TRFUN_NMR(MDOC,NAMEF,NAMEM,NAME2,NAME_PH,PATH_SCR
     * ,PATH_OUT
     * ,FPAR_TR,PARM_TR
     * ,PEAK_TEST,PRF_SH,INDEX_PRF,TALPHA,TBETA,TGAMMA
     * ,TALPHA_NEW,TBETA_NEW,TGAMMA_NEW
     * ,NPROT,NPT,NMR_INP,N_MODEL,NREF,NREFP,NMONR,NSYM
     * ,SPST,MODE_D,NCS,ANGLES_NCS,CVECTOR_NCS
     * ,ISYM,IPRSYM
     * ,RESULT,RESULT3,IPRMAX,IPRROW,IERR)
C --------------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
C ----
      REAL      RESULT    (IPRMAX,IPRROW)
      REAL      RESULT3   (IPRMAX,IPRROW)

C     PARAMETER ( IPRCYCL=10  )
C     PARAMETER ( IPRCYCL=20  )
C     PARAMETER ( IPRCYCL=50  )
      PARAMETER ( IPRCYCL=200 )

      REAL      CORR(IPRCYCL),RFAC(IPRCYCL),SCORR(IPRCYCL)
      REAL      TXSH(IPRCYCL),TYSH(IPRCYCL),TZSH(IPRCYCL)
      REAL      TALPHA_BEST,TGAMMA_BEST,TBETA_BEST
      REAL      TXSH_BEST,TYSH_BEST,TZSH_BEST
      REAL      OXS(3),FXS(3)

      REAL      TALPHA(*),TGAMMA(*),TBETA(*)
      REAL      TALPHA_NEW(*),TGAMMA_NEW(*),TBETA_NEW(*)
      REAL      PRF_SH(3,*),ANGLES_NCS(3),CVECTOR_NCS(3)
      INTEGER   INDEX_PRF(*)
      REAL      PEAK_TEST(12,*)
      REAL      FPAR_TR(*)
C ---
      CHARACTER NAMEF*(*),NAMEM*(*),NAME2*(*),NAME_PH*(*),PATH_SCR*(*)
      CHARACTER PATH_OUT*(*)

      CHARACTER NAMEO*256,NAMET_OUT*256
      CHARACTER NAMED*256
      CHARACTER NAMEC2*256,NAMET*256
      CHARACTER NAME_FCALC*256,NAME_PHCALC*256
      CHARACTER NAME_FCALC_SCL*256
      CHARACTER NAMEC1*256,NAME_DNS(2)*256


      CHARACTER MODE_D*1
      CHARACTER LINE*256,MODE*1
      CHARACTER MOD2*1,INVER*1
      CHARACTER PACK*1
      CHARACTER REF*1,REFP*1,TFUN*1,LIST*1
      CHARACTER CALC2*1
      CHARACTER ANISO_T*1,MODE_T*1
      CHARACTER PST*1,SURF*1,REF_TEMP*1,CTEST*1,MOD2_INI*1
      CHARACTER PRF*1,FITT*1,FAST*1,STICK*1,SPEC*1
      CHARACTER MOD1*1,CCP4*1,SURFX*1
      CHARACTER CFREE*1,CSIG*1,CFOM*1,DIFF*1,CH10*10,CH14*14

      CHARACTER PARM_TR*30

C ----------------------------------
      CHARACTER TIME_CURRENT*15,TIME_ELAPSED*15,TIME_EXPECTED*15
C ------------------------------------------------------------
      PARAMETER ( NSCORE_MAX = 150)
      REAL      SCORE_STOR(NSCORE_MAX)
      REAL      SCORE_AVER(NSCORE_MAX)
      REAL      SCORE_AVER2(NSCORE_MAX)
      INTEGER   ISCORE_NUMB(NSCORE_MAX)
c --------------------------------------------------------
      REAL      AM(3,3),SH1(3),SH2(3),SPST(3)
C ---------------------------------------
      INCLUDE 'molrep_lh_infor.fh'
C      COMMON/COM_LH_INFOR/ BOFF_LH,BADD_LH,BOFF_FOR_SCAL
C     *   ,CHECK_CONTRAST,CONTRAST_LIM
C     *   ,BCORR_LH,FILE_FOBS_LH,SCORE_FLAG,LH_LH,DB_LH 
CC ---
C      REAL      CHECK_CONTRAST,CONTRAST_LIM
C      REAL      BOFF_FOR_SCAL,BOFF_LH,BADD_LH,BCORR_LH
C      CHARACTER LH_LH*1,SCORE_FLAG*1,DB_LH*1
C      CHARACTER FILE_FOBS_LH*256
C ----------------------------------
C --------------------------------------------------------------------
      COMMON/COM_DPOOL/ IPOOL_MAX,IPOOL_CURR
C ---
      INCLUDE 'molrep_xml.fh'
C -------------------------------------------------------------
      PI     = 4.0*ATAN(1.0)
      MD     =-ABS(MDOC)-1
      M      = 99
      MD0    = 0
      IERR   = 0
      ISIGNAL_STOP = 0
C     LH_LH  = 'N'
C ---
C -------------------------------------------------
      NAMEO       = 'molrep'
      CALL ADD_PATH(PATH_SCR,NAMEO)
      NAMEC2      = 'molrp_scr'
      CALL ADD_PATH(PATH_SCR,NAMEC2)
      NAMEC1      = 'molrp_scr1'
      CALL ADD_PATH(PATH_SCR,NAMEC1)
      NAMED       = 'trfun_dns3'
      CALL ADD_PATH(PATH_SCR,NAMED)
      NAME_DNS(1) = 'trfun_dns1'
      CALL ADD_PATH(PATH_SCR,NAME_DNS(1))
      NAME_DNS(2) = 'trfun_dns2'
      CALL ADD_PATH(PATH_SCR,NAME_DNS(2))
C ----------------------------------
C ---XML--
      JOB_XML = 'MR_TF_NMR'
C  ================================================
      DO I=1,3
        ANGLES_NCS (I) = 0.0
        CVECTOR_NCS(I) = 0.0 
      ENDDO
      TFUN     = PARM_TR( 1: 1) 
      REFP     = PARM_TR( 2: 2)
      REF      = PARM_TR( 3: 3)
      PACK     = PARM_TR( 4: 4)
      PST      = PARM_TR( 5: 5)
      CCP4     = PARM_TR( 6: 6) 
      ANISO_T  = PARM_TR( 7: 7)
      SURF     = PARM_TR( 8: 8)
      REF_TEMP = PARM_TR( 9: 9)
      MOD2_INI = PARM_TR(10:10)
      INVER    = PARM_TR(11:11)  
      PRF      = PARM_TR(12:12)  
      FAST     = PARM_TR(13:13)  
      FITT     = PARM_TR(14:14) 
      MODE_T   = PARM_TR(15:15)  
      CTEST    = PARM_TR(16:16)
      STICK    = PARM_TR(17:17)
      MOD1     = PARM_TR(18:18)
      MOD2     = PARM_TR(19:19)
      LIST     = PARM_TR(20:20)
      DIFF     = PARM_TR(21:21)
      SURFX    = PARM_TR(22:22)


      REF  = 'N'
      REFP = 'N'

      RESMIN   = FPAR_TR( 1)
      RESMAX   = FPAR_TR( 2)
c      FPAR_TR( 3) = ALPHA
c      FPAR_TR( 4) = BETA
c      FPAR_TR( 5) = GAMMA
      BOFF     = FPAR_TR( 6)
c      FPAR_TR( 7) = BOFFP
      BADD     = FPAR_TR( 8)
      BLIM     = FPAR_TR( 9)
c      FPAR_TR(10) = RSMIN_RB
c      FPAR_TR(11) = RSMAX_RB
      BOFF_SCL = FPAR_TR(12)
      BADD_SCL = FPAR_TR(13)
      ARAD     = FPAR_TR(15)
      RAD_MODEL = FPAR_TR(19) 

      NMON = NMONR 
      NOUSED_RF = 0

C ---
      RSMIN_RB  = 20.0
C      RSMAX_RB = 3.0
C !!!!
      RSMAX_RB  = 5.0
C !!!!
C !!!!NCYCL_RB  = 5
      NCYCL_RB  = 5
      NCP       = 0
      IF(NREF .GT.0) NCYCL_RB = NREF 
      IF(NREFP.GT.0) NCP      = NREFP
      NC       = NCYCL_RB
C --
      NC       = 0
      NCP      = 0
      FAST     = 'F'
      BOFF_RB  = 1600.0
      BOFFP    = BOFF_RB
      NEL2     = 0
      CALC2    = 'Y'

      NMR = 0
      IF(N_MODEL.LE.1) THEN
        CALL MSGERR(MDOC,' ERROR: for NMR: N_model =< 1')
        IERR = 1
        GO TO 900
      ENDIF
C --
      CALL MSGDOC(MDOC,'Sol_ ')
      IF(MODE_D.EQ.'D') THEN
        CALL MSGDOC(MDOC,' --- phased translation function ---')
      ELSE
        CALL MSGDOC(MDOC,' --- Translation function (nmr) ---')
      ENDIF
C ----
      WRITE(LINE,'('' Resolution              :'',2F8.2)') 
     * RESMIN,RESMAX
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Boff,Badd               :'',2F8.2)')
     * BOFF,BADD
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,'('' Boff_scl,Badd_scl       :'',2F8.2)')
     * BOFF_SCL,BADD_SCL
      CALL MSGDOC(MD,LINE)

      MMDOC = MDOC
      IRF   = 0
      CORR_BEST      = -1.0
      SCORR_BEST     = -1.0
      RFAC_BEST      =  0.0
      CONTRAST_BEST  = 0.0
      IPK_BEST       = 0
      IPK_TRANS      = 0
      IPK_TRANS_BEST = 0
      MOD_BEST       = 0


      NRUN_TIME_TOTAL = NMON*NPROT*N_MODEL
      IRUN_TIME   = 0
      ITIME_START = 1
      NRUN_TIME   = 0
      CALL EXPECTED_TIME(ITIME_START,NRUN_TIME
     *  ,ITIME_CURR,TIME_CURRENT,TIME_ELAPSED,TIME_EXPECTED)

      WRITE(LINE,*) 'Time:',TIME_CURRENT,' Elapsed:',TIME_ELAPSED
      CALL MSGDOC(MDOC,LINE)
      TIME_ELAPSED_XML  = TIME_ELAPSED
      CALL WRITE_XML_FILE(IERR,PATH_OUT)

C ==================================================

 200  CONTINUE

      IPEAK          = 0
      CONTRAST_TOT   = 0.0
      CORR_TOT       =-1.5
      SCORR_TOT      =-1.5
      CORR_MOD_TOT   =-1.5
      RFAC_TOT       = 0.0
      IPK_TOT        = 0
      IPK_TRANS      = 0
      IPK_TRANS_TOT  = 0
      MOD_TOT        = 0
      IFIRST_SCL     = 0
C ---------------------
      NRUN         = 0
      IF(NMR_INP.LE.2) THEN
        NR_SYM = N_MODEL
        NRUN_LIM = (NMONR + 8)*NR_SYM
      ELSE
        NRUN_LIM = NMONR + 8
      ENDIF
C ----------------------

      SCORE_MAX  =-1.5
      CORR_MAX   =-1.5
      NSCORE     = 0.0
      CONTRAST   = 0.0
      CNTRST     = 0.0
      NP_FIN     = 0
      CALL MSGDOC(MMDOC,' ')

c      LINE =
c     * 'Sol_ RF TF     Tf/sig        sig'//
c     * '     PFmax   PFmin  Rfac  Corr Scor_max Cntrst'
c      CALL MSGDOC(MMDOC,LINE)

      IF(NMR_INP.LE.2) THEN
      LINE =
     *  'Sol_Model RF TF    Tf/sig        PKind'//
     *  '    PKmax   PKmin wRfac  Scor Cntrst'
      CALL MSGDOC(MMDOC,LINE)
      ENDIF

C ==================
 800  CONTINUE
      IPEAK = IPEAK+1
      IPK   = IPEAK

      CALL MSGDOC(MD,'Sol_ ')
      WRITE(LINE,'(''Sol_--- peak number of Rotation Function :'',I5)')
     *  IPK
      CALL MSGDOC(MD,LINE)
      CALL MSGDOC(MD,'Sol_ ')

      IF1           = 1
      IF2           = 2
      MODEL_BEST    = 0
      CORR_MOD_BEST = -2.0
      IFIRST        = 0

      IF(NMR_INP.GT.2) THEN
      LINE =
     *  'Sol_Model RF TF    Tf/sig        PKind'//
     *  '    PKmax   PKmin wRfac  Scor  Cntrst'
      CALL MSGDOC(MMDOC,LINE)
      ENDIF

C!---------
CV
      DO MODEL=1,N_MODEL

        CALL MSGDOC(MD,'Sol_ ')
        WRITE(LINE,'(''Sol_ ---> MNR_model :'',I5)')
     *   MODEL
        CALL MSGDOC(MD,LINE)

        CALL COPY_MODEL(NAMEM,NAMEC1,MODEL,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
     
C -
        ALPHA = TALPHA(IPK)
        BETA  = TBETA (IPK)
        GAMMA = TGAMMA(IPK)
C --
        IERR = NMONR-(NMON-1)

        PARM_TR( 1: 1) = TFUN
        PARM_TR( 2: 2) = REFP
        PARM_TR( 3: 3) = REF
        PARM_TR( 4: 4) = PACK
        PARM_TR( 5: 5) = PST
        PARM_TR( 6: 6) = CALC2
        PARM_TR( 7: 7) = ANISO_T
        PARM_TR( 8: 8) = SURF
        PARM_TR( 9: 9) = REF_TEMP
        PARM_TR(10:10) = MOD2_INI
        PARM_TR(11:11) = INVER  
        PARM_TR(12:12) = PRF  
        PARM_TR(13:13) = FAST  
        PARM_TR(14:14) = FITT  
        PARM_TR(15:15) = MODE_T  
        PARM_TR(16:16) = CTEST
        PARM_TR(17:17) = STICK
        PARM_TR(18:18) = MOD1
        PARM_TR(19:19) = MOD2
        PARM_TR(20:20) = LIST
        PARM_TR(21:21) = DIFF
        PARM_TR(22:22) = SURFX
        IF(LIST.EQ.'S') MD = 99

        FPAR_TR( 1) = RESMIN
        FPAR_TR( 2) = RESMAX
        FPAR_TR( 3) = ALPHA
        FPAR_TR( 4) = BETA
        FPAR_TR( 5) = GAMMA
        FPAR_TR( 6) = BOFF
        FPAR_TR( 7) = BOFFP
        FPAR_TR( 8) = BADD
        FPAR_TR( 9) = BLIM
        FPAR_TR(10) = RSMIN_RB
        FPAR_TR(11) = RSMAX_RB
        FPAR_TR(12) = BOFF_SCL
        FPAR_TR(13) = BADD_SCL
        FPAR_TR(15) = ARAD
        FPAR_TR(17) = 0.0
        IFIRST_SCL  = 0
        FPAR_TR(18) = IFIRST_SCL

        IF(LIST.EQ.'T') THEN
          write(*,*) '--FAST:',FAST
        ENDIF

        NAMET_OUT = 'trfun' 
        CALL ADD_PATH(PATH_SCR,NAMET_OUT)
C       IF(FAST.EQ.'F'.AND.STICK.NE.'Y') NAMET_OUT = ' '
        IF(FAST.EQ.'F'.AND.NCP.LE.0) NAMET_OUT = ' '
        NAMET_OUT   = ' '

        IF(NMR_INP.LE.2) THEN
          NAMED       = ' '
        ENDIF

        NAME_FCALC  = ' '
        NAME_PHCALC = ' ' 
        NCS  = 0
        JERR = 0
 
        MMM = MD
        IF(LIST.EQ.'T') MMM = MDOC

        CALL TRFUN(MMM,NAMEF,NAMEC1,NAME_PH,NAME2,NAMET_OUT
     *  ,NAMED,NAME_FCALC,NAME_PHCALC,PATH_SCR
     *  ,IPK,PRF_SH(1,IPK),NC,NPT,NMR,N_MODEL,NEL2,NCP,NCS
     *  ,ANGLES_NCS,CVECTOR_NCS 
     *  ,PARM_TR,FPAR_TR,SPST,PEAK_TEST
     *  ,ISYM,IPRSYM
     *  ,RESULT,RESULT3,IPRMAX,IPRROW,IERR)

        FAST  = PARM_TR(13:13)
        CALC2 = PARM_TR( 6: 6) 
        IFIRST_SCL = FPAR_TR(18)

        RMAX_PK = RESULT(1,14)
        RMIN_PK = RESULT(1,15)
        SIGMA   = RESULT(1,16)
        PACK_INDEX = RESULT(1,21)
        CORR_FIX = RESULT(2,21)

        IF(IERR.NE.0) THEN
          JERR = IERR
          IF(IERR.EQ.1) GO TO 900
          RESULT(1,12) = 0
          IERR         = 0
        ENDIF

        IRUN_TIME = IRUN_TIME + 1
        NRUN_TIME = NRUN_TIME_TOTAL - IRUN_TIME 
        ITIME_START = 0
        CALL EXPECTED_TIME(ITIME_START,NRUN_TIME
     *    ,ITIME_CURR,TIME_CURRENT,TIME_ELAPSED,TIME_EXPECTED)

        TIME_ELAPSED_XML  = TIME_ELAPSED
        TIME_EXPECTED_XML = TIME_EXPECTED

        IERR_XML     = 0
        MESSAGE_XML  = 'normal run'  
        CALL WRITE_XML_FILE(IERR,PATH_OUT)

C        IF(IPEAK.EQ.1.AND.MODEL.EQ.1) THEN
        IF(MODEL.EQ.1) THEN
          WRITE(LINE,*) 'Time_elapsed:',TIME_ELAPSED
     *              ,' Remained:',TIME_EXPECTED
          CALL MSGDOC(MDOC,LINE)
        ENDIF
C ---
        NPTRANS   = RESULT(1,12)

        IF(NPTRANS.LE.0) THEN
          NP_FIN    = IPK
          IF(NMR_INP.LE.2) THEN
            TXSH(IPK) = RESULT(1,6)
            TYSH(IPK) = RESULT(1,7)
            TZSH(IPK) = RESULT(1,8)
            RFAC(IPK) = 100.0
            CORR(IPK) =-2.0
            SCORR(IPK)=-2.0
          ENDIF
          IPK_TRANS = 0

          WRITE(CH14,'(''Sol'',I4,I4,I3)') MODEL,IPK,IPK_TRANS
          DO J=1,14
            IF(CH14(J:J).EQ.' ') CH14(J:J) = '_'
          ENDDO
          IF(JERR.EQ.10) THEN
            WRITE(LINE,'(A,A)') CH14,
     *      '   ---- all values of Packing Function =< 0 -----'
            CALL MSGDOC(MDOC,LINE)
          ELSE
            WRITE(LINE,'(A,A)') CH14,'     ---------'
            CALL MSGDOC(MDOC,LINE)
          ENDIF
        ELSE
          RFAC_IPK = RESULT(1,1)
          T = RESULT(1,2)
          T = (T+1.0)*SQRT(ABS(PACK_INDEX))
          CORR_IPK = T-1.0
          TXSH_IPK = RESULT(1,6)
          TYSH_IPK = RESULT(1,7)
          TZSH_IPK = RESULT(1,8)
          TFSIG     = RESULT(1,5)  
          TALPHA_NEW_IPK = FPAR_TR( 3)
          TBETA_NEW_IPK  = FPAR_TR( 4)
          TGAMMA_NEW_IPK = FPAR_TR( 5)

          IPK_TRANS = RESULT(1,9)

          IF(NMR_INP.LE.2) THEN
            TC_AVER   = RESULT(1,18) 
            TC_AVER2  = RESULT(1,19) 
            NC_NAVER  = RESULT(1,20) 
            CALL DYAD_STORE_SCORE(CORR_IPK,NSCORE,SCORE_STOR
     *       ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
     *       ,TC_AVER,TC_AVER2,NC_NAVER
     *       ,SCORE_MAX,NSCORE_MAX)
          ENDIF

          CORR_B = CORR_IPK 
          IF(NMR_INP.LE.2) THEN
            IF(CORR_B.LT.CORR_TOT) CORR_B = CORR_TOT 
          ELSE
            IF(CORR_B.LT.CORR_MOD_TOT) CORR_B = CORR_MOD_TOT 
          ENDIF

          IF(NMR_INP.LE.2) THEN

            NUM_MON = NMONR-NMON
            NR_SYM = N_MODEL
            CALL DYAD_CONTRAST(M,NUM_MON,NMONR,NR_SYM,CNTR_NEW
     *                     ,CORR_B,CONTRAST,NSCORE
     *          ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
     *                     ,SCORE_STOR,NSCORE_MAX)
            CNTRST  = CONTRAST
            CNTRST2 = CNTR_NEW
          ENDIF

          WRITE(CH14,'(''Sol'',I4,I4,I3)') MODEL,IPK,IPK_TRANS
          DO J=1,14
            IF(CH14(J:J).EQ.' ') CH14(J:J) = '_'
          ENDDO

          RALPHA  = (TALPHA_NEW_IPK*PI)/180.0
          RBETA   = (TBETA_NEW_IPK *PI)/180.0
          RGAMMA  = (TGAMMA_NEW_IPK*PI)/180.0
          CALL EULERM(RALPHA,RBETA,RGAMMA,AM)
          CALL MTOPOL(AM,THETA,PHI,CHI)
          SH2(1) = TXSH_IPK
          SH2(2) = TYSH_IPK
          SH2(3) = TZSH_IPK
          CALL OTOF(SH2,SH1,IERR)

          WRITE(LINE,310) CH14,TFSIG,PACK_INDEX,RMAX_PK,RMIN_PK
     *    ,RFAC_IPK,CORR_IPK,CNTRST
 310      FORMAT(A14,G14.4,F10.3,2F8.2,3F7.3)
          CALL MSGDOC(MDOC,LINE)

C          WRITE(LINE,300) CH10,TFSIG,SIGMA,RMAX_PK,RMIN_PK
C     *    ,RFAC_IPK,CORR_IPK,CORR_B,CONTRAST
c          CALL MSGDOC(MDOC,LINE)
 300      FORMAT(A10,G14.4,F10.3,2F8.2,3F7.3,F7.2)


          IF(NMR_INP.GT.2.AND.(NSYM.GT.1.OR.MOD2.NE.'N')) THEN
            IF(IFIRST.EQ.0) THEN
              IFIRST = 1
C             copy named --> name_dns(if2)
              MODE   = 'A'
              CONST1 = 1.0
              CONST2 = 0.0 
              NAMET  = ' '
              CALL MODDEN(M,NAMED,NAMET,NAME_DNS(IF2)
     *        ,CONST1,CONST2,MODE
     *        ,RESULT3,IPRMAX,ISYM,IPRSYM,IERR)
              IF(IERR.NE.0) GO TO 900

            ELSE

              MODE   = 'S'
              CONST1 =-1.0
              CONST2 = 0.0 
              CALL MODDEN(M,NAMED,NAME_DNS(IF1),NAME_DNS(IF2)
     *        ,CONST1,CONST2,MODE
     *        ,RESULT3,IPRMAX,ISYM,IPRSYM,IERR)
              IF(IERR.NE.0) GO TO 900

            ENDIF
            IT  = IF1
            IF1 = IF2
            IF2 = IT
          ENDIF

          IF(NMR_INP.LE.2) THEN
            RFAC(IPK) = RFAC_IPK
            CORR(IPK) = CORR_IPK
            TXSH(IPK) = TXSH_IPK
            TYSH(IPK) = TYSH_IPK
            TZSH(IPK) = TYSH_IPK
            TALPHA_NEW(IPK) = TALPHA_NEW_IPK
            TBETA_NEW (IPK) = TBETA_NEW_IPK
            TGAMMA_NEW(IPK) = TGAMMA_NEW_IPK
          ENDIF

          IF(CORR_IPK.GT.CORR_MOD_BEST) THEN
            CORR_MOD_BEST = CORR_IPK
            MODEL_BEST    = MODEL
            TXSH_BESTM    = TXSH_IPK
            TYSH_BESTM    = TYSH_IPK
            TZSH_BESTM    = TZSH_IPK
            RFAC_BESTM    = RFAC_IPK 
            CORR_BESTM    = CORR_IPK
          ENDIF

C          IF(CORR_MOD_BEST.GT.CORR_MOD_TOT) 
C     *    CORR_MOD_TOT = CORR_MOD_BEST
C
C          IF(NMR_INP.LE.2) THEN
C
C            NP_FIN    = IPK
C            NRUN = NRUN + 1 
C            IF(NRUN.GE.NRUN_LIM.AND.
C     *         CONTRAST.GT.CONTRAST_LIM) THEN
C              LINE = 
C     *        'INFO: contrast is good enough. Stop this run'
C              CALL MSGDOC(MDOC,LINE)
C
C              IF(CORR_MOD_BEST.GT.CORR_TOT) THEN
C
C                IF(MODEL_BEST.GT.0) THEN           
C                  TXSH(IPK) = TXSH_BESTM
C                  TYSH(IPK) = TYSH_BESTM
C                  TZSH(IPK) = TZSH_BESTM
C                  RFAC(IPK) = RFAC_BESTM
C                  CORR(IPK) = CORR_BESTM   
C                ENDIF
C                CALL LENSTR_BL(NAMET_OUT,LEN)
C                IF(LEN.GT.0) THEN
C                  IM = 0
C                  CALL COPY_MODEL(NAME_OUT,NAMEO,IM,ISYM,IPRSYM,IERR)
C                  IF(IERR.NE.0) GO TO 900
C                ENDIF
C
C                CORR_TOT       = CORR(IPK)
C                RFAC_TOT       = RFAC(IPK)
C                IPK_BEST       = IPK
C                IPK_TRANS_BEST = IPK_TRANS        
C                MOD_BEST       = MODEL_BEST
C
C              ENDIF
C
C              GO TO 830
C            ENDIF
C
C          ENDIF

        ENDIF

      ENDDO
C^
C!---------model

      IF(NMR_INP.LE.2) THEN

        IF(CORR_MOD_BEST.GT.CORR_TOT) THEN

          IF(MODEL_BEST.GT.0) THEN           
            TXSH(IPK) = TXSH_BESTM
            TYSH(IPK) = TYSH_BESTM
            TZSH(IPK) = TZSH_BESTM
            RFAC(IPK) = RFAC_BESTM
            CORR(IPK) = CORR_BESTM   
          ENDIF
          CALL LENSTR_BL(NAMET_OUT,LEN)
          IF(LEN.GT.0) THEN
            IM = 0
            CALL COPY_MODEL(NAMET_OUT,NAMEO,IM,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900
          ENDIF

          CORR_TOT       = CORR(IPK)
          RFAC_TOT       = RFAC(IPK)
C          IPK_BEST       = IPK
C          IPK_TRANS_BEST = IPK_TRANS        
C          MOD_BEST       = MODEL_BEST
          IPK_TOT        = IPK
          IPK_TRANS_TOT  = IPK_TRANS        
          MOD_TOT        = MODEL_BEST
          MODEL_TOT      = MODEL_BEST

        ENDIF

      ELSE
C       --- NMR = 3
        ALEVEL   = 0.0
        NAMET    = ' '
        NPMAX    = NPT
        DIST_LIM = 0.0
        SPEC     = 'Y'
        MMM      = MDOC
        IF(LIST.EQ.'S') THEN
c          MMM   = MD
        ENDIF

        CALL MSGDOC(MMM,'Sol_ ')
        CALL MSGDOC(MMM,'Sol_ --- Averaged TF ---')

        IF(NSYM.GT.1.OR.MOD2.NE.'N') THEN
          NAMET  = ' '
          CALL PEAKSRCH(MD,NAME_DNS(IF1),NAMET,ALEVEL,DIST_LIM,SPEC
     *     ,NPMAX,ISYM,IPRSYM,RESULT,IPRMAX,IPRROW,IERR)
          IF(IERR.NE.0) GO TO 900
        ELSE
          RESULT(1,12) = 1.0
          RESULT(1, 9) = 0.0
          RESULT(1,10) = 0.0
          RESULT(1,11) = 0.0
        ENDIF

        NP_AVER = RESULT(1,12) 

        IF(NP_AVER.GT.0) THEN

          ALPHA = TALPHA(IPK)
          BETA  = TBETA (IPK)
          GAMMA = TGAMMA(IPK)

C --
          IERR = NMONR-(NMON-1)

          PARM_TR( 1: 1) = 'F'
          FPAR_TR( 3)    = ALPHA
          FPAR_TR( 4)    = BETA
          FPAR_TR( 5)    = GAMMA

C         FPAR_TR(14) = SH1(1)
C         FPAR_TR(15) = SH1(2)
C         FPAR_TR(16) = SH1(3)

C         RESULT(1, 9) = SH1(1)
C         RESULT(1,10) = SH1(2)
C         RESULT(1,11) = SH1(3)

          IF(NP_AVER.GT.NPT) NP_AVER = NPT
          RESULT(1,12) = NP_AVER

          NAMET_OUT   = ' ' 
          NAMET       = ' '
          NAME_FCALC  = ' '
          NAME_PHCALC = ' '
          IFIRST_SCL     = 0
          FPAR_TR(18) = IFIRST_SCL
 
          NCS  = 0
          JERR = 0

C          LINE =
C     *    'Sol_ RF TF     Tf/sig        sig'//
C     *    '     PFmax   PFmin  Rfac  Corr Scor_max Cntrst'
C          CALL MSGDOC(MMDOC,LINE)

          IM = 0
          CALL COPY_MODEL(NAMEM,NAMEC1,IM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900

          IPK_IN = IPK
          CALL TRFUN(MD,NAMEF,NAMEC1,NAME_PH,NAME2,NAMET_OUT
     *    ,NAMET,NAME_FCALC,NAME_PHCALC,PATH_SCR
     *    ,IPK_IN,PRF_SH(1,IPK_IN),NC,NPT,NMR,N_MODEL,NEL2,NCP,NCS
     *    ,ANGLES_NCS,CVECTOR_NCS 
     *    ,PARM_TR,FPAR_TR,SPST,PEAK_TEST
     *    ,ISYM,IPRSYM
     *    ,RESULT,RESULT3,IPRMAX,IPRROW,IERR)
          FAST  = PARM_TR(13:13)
          CALC2 = PARM_TR( 6: 6) 
          IFIRST_SCL = FPAR_TR(18)

          RMAX_PK = RESULT(1,14)
          RMIN_PK = RESULT(1,15)
          SIGMA   = RESULT(1,16)
          PACK_INDEX = RESULT(1,21)
          IF(IERR.NE.0) THEN
            JERR = IERR
            IF(IERR.EQ.1) GO TO 900
            RESULT(1,12) = 0
            IERR         = 0
          ENDIF
        ELSE
          RESULT(1,12) = 0
          JERR = 0
        ENDIF

        NPTRANS   = RESULT(1,12)

        IF(NPTRANS.LE.0) THEN
          NP_FIN    = IPK
          TXSH(IPK) = RESULT(1,6)
          TYSH(IPK) = RESULT(1,7)
          TZSH(IPK) = RESULT(1,8)
          RFAC(IPK) = 100.0
          CORR(IPK) =-2.0
          IPK_TRANS = 0
          WRITE(CH10,'(''Sol'',I4,I3)') IPK,IPK_TRANS
            DO J=1,10
            IF(CH10(J:J).EQ.' ') CH10(J:J) = '_'
          ENDDO
          IF(JERR.EQ.10) THEN
            WRITE(LINE,'(A,A)') CH10,
     *      '   ---- all values of Packing Function =< 0 -----'
            CALL MSGDOC(MDOC,LINE)
          ELSE
            WRITE(LINE,'(A,A)') CH10,'     ---------'
            CALL MSGDOC(MDOC,LINE)
          ENDIF
        ELSE

          RFAC(IPK) = RESULT(1,1)
          T = RESULT(1,2)
          IF(SCORE_FLAG.NE.'C')THEN
            T = (T+1.0)*SQRT(ABS(PACK_INDEX))
            CORR(IPK) = T-1.0
          ELSE
            CORR(IPK) = T
          ENDIF
          TXSH(IPK) = RESULT(1,6)
          TYSH(IPK) = RESULT(1,7)
          TZSH(IPK) = RESULT(1,8)
          TFSIG     = RESULT(1,5)  
          TALPHA_NEW(IPK) = FPAR_TR( 3)
          TBETA_NEW (IPK) = FPAR_TR( 4)
          TGAMMA_NEW(IPK) = FPAR_TR( 5)
          IPK_TRANS = RESULT(1,9)
          TC_AVER   = RESULT(1,18) 
          TC_AVER2  = RESULT(1,19) 
          NC_NAVER  = RESULT(1,20) 

          CALL DYAD_STORE_SCORE(CORR(IPK),NSCORE,SCORE_STOR
     *       ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
     *       ,TC_AVER,TC_AVER2,NC_NAVER
     *       ,SCORE_MAX,NSCORE_MAX)

          CORR_B = CORR_TOT
          IF(CORR(IPK).GT.CORR_TOT) CORR_B = CORR(IPK)
 
          NR_SYM = 1
          NUM_MON = NMONR-NMON
          CALL DYAD_CONTRAST(M,NUM_MON,NMONR,NR_SYM,CNTR_NEW
     *                     ,CORR_B,CONTRAST,NSCORE
     *          ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
     *                     ,SCORE_STOR,NSCORE_MAX)

 
C          WRITE(CH10,'(''Sol'',I4,I3)') IPK,IPK_TRANS
C          DO J=1,10
C            IF(CH10(J:J).EQ.' ') CH10(J:J) = '_'
C          ENDDO

          RALPHA  = (TALPHA_NEW(IPK)*PI)/180.0
          RBETA   = (TBETA _NEW(IPK)*PI)/180.0
          RGAMMA  = (TGAMMA_NEW(IPK)*PI)/180.0
          CALL EULERM(RALPHA,RBETA,RGAMMA,AM)
          CALL MTOPOL(AM,THETA,PHI,CHI)
          SH2(1) = TXSH(IPK)
          SH2(2) = TYSH(IPK)
          SH2(3) = TZSH(IPK)
          CALL OTOF(SH2,SH1,IERR)

c          WRITE(LINE,300) CH10,TFSIG,PACK_INDEX,RMAX_PK,RMIN_PK
c     *    ,RFAC(IPK),CORR(IPK),CORR_B,CONTRAST
cC 300     FORMAT(A10,G14.4,F10.3,2F8.2,4F7.3)
c          CALL MSGDOC(MDOC,LINE)

          IF(CORR(IPK).GT.CORR_TOT) THEN
            CORR_TOT       = CORR(IPK)
            RFAC_TOT       = RFAC(IPK)
C            IPK_BEST       = IPK
C            IPK_TRANS_BEST = IPK_TRANS        
C            MODEL_BEST     = 0
C            MOD_BEST       = 0
            IPK_TOT       = IPK
            IPK_TRANS_TOT = IPK_TRANS        
            MODEL_TOT     = 0
            MOD_TOT       = 0
          ENDIF
          LINE =
     *    'S_    RF TF   theta    phi    chi'//
     *    '    tx     ty     tz    wRfac   Scor  Cntrst'
          CALL MSGDOC(MDOC,LINE)

          WRITE(LINE,
     *    '(''S_ '',I4,I4,3F8.2,3F7.3,3F7.3)')
     *    IPK,IPK_TRANS
     *    ,THETA,PHI,CHI
     *    ,SH1(1),SH1(2),SH1(3),RFAC(IPK),CORR(IPK),CONTRAST
          CALL MSGDOC(MDOC,LINE)
          CALL MSGDOC(MDOC,' ')

C          NP_FIN    = IPK
C          NRUN = NRUN + 1 
C          IF(NRUN.GE.NRUN_LIM.AND.
C     *      CONTRAST.GT.CONTRAST_LIM) THEN
C            LINE = 
C     *      'INFO: contrast is good enough. Stop this run'
C            CALL MSGDOC(MDOC,LINE)
C            GO TO 830
C          ENDIF

        ENDIF

      ENDIF

      CALL CHECK_STOP_SIGNAL(PATH_SCR,ISIGNAL_STOP)

      NP_FIN    = IPK
      NRUN = NRUN + 1 
      IF(NRUN.GT.NRUN_LIM.AND.SCORE_FLAG.EQ.'Y'.AND.
     *  CONTRAST.GT.CONTRAST_LIM) THEN
        LINE = 
     *      'INFO: contrast is good enough. Stop this run'
        CALL MSGDOC(MDOC,LINE)
        GO TO 830
      ENDIF

C --------------------------------------------
 820  CONTINUE

      IF(ISIGNAL_STOP.GT.0) GO TO 830 

      IF(IPEAK.LT.NPROT) GO TO 800
 830  CONTINUE
C --------------------------------------------
      CALL MSGDOC(MDOC,' ')

      IF(CORR_TOT.GT.-1.0.AND.IPK_TOT.GT.0.AND.
     *  IPK_TRANS_TOT.GT.0) THEN
        IF(NMON.NE.NMONR) THEN

          T    = CORR_BEST+1.0
          IF(CORR_BEST.LE.0.0) T = 0.0001
          TEST = (CORR_TOT+1.0)/T

          IF(SCORE_FLAG.EQ.'Y'.AND.CONTRAST.GT.0.01.AND.
     *                                  TEST.GE.0.999999) THEN
            CALL FINAL_MESSAGE(MDOC,CONTRAST,CORR_TOT)
          ENDIF    

          T    = CORR_BEST+1.0
          IF(CORR_BEST.LE.0.0) T = 0.0001
          TEST = (CORR_TOT+1.0)/T

          IF(TEST.LT.0.999999) THEN

            I = NMONR-NMON
            CALL MSGDOC(MDOC,
     *      'WARNING: program can not improve current model')
            WRITE(LINE,
     *'(''         result is "molrep.crd" with '',I5,'' monomers'')') I
             CALL MSGDOC(MDOC,LINE)

            IF(MOD2.EQ.'Y') THEN
              IM = 0
              CALL COPY_MODEL(NAME2,NAMEO,IM,ISYM,IPRSYM,IERR)
              IF(IERR.NE.0) GO TO 900
            ENDIF
C --XML--
            CONTRAST_XML = CONTRAST_BEST       
C           cannot improve but solution exist
            GO TO 990
          ENDIF
        ENDIF

        IF(CORR_TOT.GT.CORR_BEST) THEN
          CORR_BEST=CORR_TOT
          RFAC_BEST=RFAC_TOT
        ENDIF

        IF(PST.EQ.'Y') THEN
          NMON = NMON-2
        ELSE
          NMON = NMON-1
        ENDIF

        SH2(1) =TXSH(IPK_TOT) 
        SH2(2) =TYSH(IPK_TOT) 
        SH2(3) =TZSH(IPK_TOT) 

        CALL LENSTR_BL(NAMET_OUT,LEN)
        IF(LEN.LE.0.AND.MOD1.EQ.'Y') THEN

          NAMET = NAMEO
          IF(MOD2.EQ.'Y') NAMET = NAMEC2 

          ALPHA  = TALPHA_NEW(IPK_TOT)
          BETA   = TBETA_NEW (IPK_TOT) 
          GAMMA  = TGAMMA_NEW(IPK_TOT)
          IF(STICK.EQ.'Y') THEN
            CALL STICK_TEST(MDOC,RAD_MODEL,IS_N
     *         ,ALPHA,BETA,GAMMA,SH2,PEAK_TEST
     *         ,ALPHA_N,BETA_N,GAMMA_N,THETA_N,PHI_N,CHI_N
     *         ,IPT_MIN,IDIMER
     *         ,SH1,NSYM,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900
            TALPHA_NEW(IPK_TOT) = ALPHA_N
            TBETA_NEW (IPK_TOT) = BETA_N 
            TGAMMA_NEW(IPK_TOT) = GAMMA_N
            TXSH(IPK_TOT)  = SH1(1)
            TYSH(IPK_TOT)  = SH1(2)
            TZSH(IPK_TOT)  = SH1(3)
            ALPHA  = ALPHA_N
            BETA   = BETA_N 
            GAMMA  = GAMMA_N
            SH2(1) = SH1(1)
            SH2(2) = SH1(2)
            SH2(3) = SH1(3)
          ENDIF
          MODE   = 'E'
          DO I=1,3
            SH1(I) = 0.0
            DO J=1,3
              AM(I,J) = 0.0
            ENDDO
          ENDDO
          IERR = 0
          IF(NMR_INP.LE.2) IERR =-MOD_TOT
          CALL TRANS(M,NAMEM,NAMET,SH1,SH2
     *    ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
          IF(MOD2.EQ.'Y') THEN
C           + NAME2
            IERR = NMONR-NMON 
            CALL JOINCRD(M,NAME2,NAMET,NAMEO,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900
          ENDIF
          IF(MOD1.EQ.'D') THEN
C            --> ANGLES,SHIFT,FLAG _BEST
          ENDIF
        ENDIF

        I = NMONR-NMON
        IF(NMR_INP.LE.2) THEN
          WRITE(LINE,'(A,I5)') 'Sol_ Best_model:',MOD_TOT
        ELSE
          LINE = 'Sol_ Best'
        ENDIF

        CALL MSGDOC(MDOC,LINE)
        LINE =
     * 'S_  Nmon RF TF   theta    phi    chi'//
     * '    tx     ty     tz    Rfac    Scor Cntrst'
        CALL MSGDOC(MDOC,LINE)
  

        CALL OTOF(SH2,SH1,IERR)
        RALPHA  = (TALPHA_NEW(IPK_TOT)*PI)/180.0
        RBETA   = (TBETA _NEW(IPK_TOT)*PI)/180.0
        RGAMMA  = (TGAMMA_NEW(IPK_TOT)*PI)/180.0
        CALL EULERM(RALPHA,RBETA,RGAMMA,AM)
        CALL MTOPOL(AM,THETA,PHI,CHI)

        SCORR_BEST = CORR_BEST
        CONTRAST_BEST = CONTRAST

        WRITE(LINE,
     *  '(''S_ '',I2,I4,I4,3F8.2,3F7.3,2F7.3,F7.2)')
     *  I,IPK_TOT,IPK_TRANS_TOT
     *  ,THETA,PHI,CHI
     *  ,SH1(1),SH1(2),SH1(3),RFAC_BEST,CORR_BEST,CONTRAST
        IF(LINE( 3: 3).EQ.' ') LINE( 3: 3) = '_'
        CALL MSGDOC(MDOC,LINE)

        IF(CONTRAST.GT.0.001) THEN
          WRITE(LINE,'(''Contrast = '',F8.3)') CONTRAST
          CALL MSGDOC(MDOC,LINE)    
        ELSE
          LINE = 'Contrast is not available'   
          CALL MSGDOC(MDOC,LINE)    
        ENDIF

        IF(NMON.GT.0) THEN

          IF(MOD1.EQ.'Y') THEN
            NAME2='molrep2'
            CALL ADD_PATH(PATH_SCR,NAME2)
            IM = 0
            CALL COPY_MODEL(NAMEO,NAME2,IM,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900
            MOD2 = 'Y'
          ENDIF

          CALL MSGDOC(MDOC,'Sol_ ')
          I = NMONR-NMON
          WRITE(LINE,
     *    '(''Sol_ Number of monomers in fixed model_2 :'',I5)') I
          CALL MSGDOC(MDOC,LINE)
          CALL MSGDOC(MDOC,'Sol_ ')
          CALC2 = 'Y'
   
          IF(STICK.EQ.'Y') THEN
            I = PEAK_TEST(12,1) 
            IF(I.EQ.1) THEN
               IF((ABS(PEAK_TEST(6,I)).LT.0.001.AND.
     *             ABS(PEAK_TEST(7,I)).LT.0.001.AND.
     *             ABS(PEAK_TEST(8,I)).LT.0.001    ).AND.
     *            (ABS(PEAK_TEST(9,I)).LT.0.001.AND.
     *             ABS(PEAK_TEST(10,I)).LT.0.001.AND.
     *             ABS(PEAK_TEST(11,I)).LT.0.001    )) THEN
              ELSE
                I = I + 1
              ENDIF
            ENDIF
            PEAK_TEST(12,1) = I
            J = 0 
            IF(I.GE.2) J = PEAK_TEST( 1,I-1) 
            J = J + 1
            PEAK_TEST( 1,I) = J 
            PEAK_TEST( 2,I) = 1
            PEAK_TEST( 3,I) = TALPHA_NEW(IPK_TOT)
            PEAK_TEST( 4,I) = TBETA_NEW (IPK_TOT)
            PEAK_TEST( 5,I) = TGAMMA_NEW(IPK_TOT)
            PEAK_TEST( 6,I) = TXSH(IPK_TOT)
            PEAK_TEST( 7,I) = TYSH(IPK_TOT)
            PEAK_TEST( 8,I) = TZSH(IPK_TOT)
            PEAK_TEST( 9,I) = 0
            PEAK_TEST(10,I) = 0
            PEAK_TEST(11,I) = 0
          ENDIF
C --XML--
            PREV_CONTRAST_XML = CONTRAST_XML
            CONTRAST_XML = CONTRAST_BEST       

          IF(ISIGNAL_STOP.GT.0) GO TO 990 

          GO TO 200

        ENDIF
C --XML--
        PREV_CONTRAST_XML = CONTRAST_XML
        CONTRAST_XML = CONTRAST_BEST       

C       solution OK
        GO TO 990

      ELSE

c        IF(PRF.NE.'N') THEN
          I = NMONR-NMON
          IF(I.GT.0) THEN
            CALL MSGDOC(MDOC,
     *      'Sol_ WARNING: can not find more solution')
            WRITE(LINE,   
     *'(''          Final number of monomers in fixed model_2 :'',I5)') 
     *    I
            CALL MSGDOC(MDOC,LINE)
C --XML--
            CONTRAST_XML = CONTRAST_BEST       
            GO TO 990
          ELSE IF(I.LE.0) THEN
            CALL MSGDOC(MDOC,'Sol_ WARNING: no solution was found')
            IERR = 1
C --XML--
            IERR_XML     = 2
            MESSAGE_XML  = 'no solution was found'
            CONTRAST_XML = 0.0
            NSOL_XML     = 0
C -------
            GO TO 900
          ENDIF
c        ELSE
c          IF(NMONR.EQ.NMON) THEN
c            CALL MSGDOC(MDOC,'Sol_ WARNING: no solution was found')
c            IERR = 1
c            GO TO 900
c          ENDIF
c        ENDIF

      ENDIF
C --------------------------------------------
 990  CONTINUE
      IF(MOD1.EQ.'Y') THEN
        IF(PST.EQ.'Y'.AND.REF.EQ.'N') THEN
          NAMET_OUT = 'trfun' 
          CALL ADD_PATH(PATH_SCR,NAMET_OUT)
          NAMEC2    = 'molrp_scr'
          CALL ADD_PATH(PATH_SCR,NAMEC2)

          IM = 0
          CALL COPY_MODEL(NAMEO,NAMET_OUT,IM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
C
          MODE   = 'E'
          ALPHA  = 0.0
          BETA   = 0.0
          GAMMA  = 0.0
          CALL FTOO(SPST,SH1,IERR)
          DO I=1,3
            SH2(I) = 0.0
            DO J=1,3
              AM(I,J) = 0.0
            ENDDO
          ENDDO
C --
          CALL TRANS(M,NAMEO,NAMEC2,SH1,SH2
     *      ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
C           + NAME2
          IERR = NMONR-NMON+1 
          CALL JOINCRD(M,NAMET_OUT,NAMEC2,NAMEO,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900

        ENDIF
C      ELSE IF(MOD1.EQ.'D') THEN
C       create molrep_fcalc phcalc (MOD1 + MOD2)           
      ENDIF
C ---------------
 900  CONTINUE

      NAMET='trfun.crd'
      CALL DELETE_FILE(PATH_SCR,NAMET)
      NAMET='molrp_scr.crd'
      CALL DELETE_FILE(PATH_SCR,NAMET)
      NAMET='molrp_scr1.crd'
      CALL DELETE_FILE(PATH_SCR,NAMET)
      NAMET='trfun_dns1.dat'
      CALL DELETE_FILE(PATH_SCR,NAMET)
      NAMET='trfun_dns2.dat'
      CALL DELETE_FILE(PATH_SCR,NAMET)
      NAMET='trfun_dns3.dat'
      CALL DELETE_FILE(PATH_SCR,NAMET)

      RETURN

      END

      SUBROUTINE COPY_MODEL(NAME1,NAME2,IMODEL,ISYM,IPRSYM,IERR)
C --------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(21,21)
      REAL      AM(3,3),SH1(3),SH2(3)
      CHARACTER NAME1*(*),NAME2*(*)
      CHARACTER MODE*1
C --------------------------------------------------------------
      IERR = 0
      MODE = 'E'
      SH2(1) = 0.0
      SH2(2) = 0.0
      SH2(3) = 0.0
      ALPHA  = 0.0
      BETA   = 0.0
      GAMMA  = 0.0
      DO I=1,3
        SH2(I) = 0.0
        SH1(I) = 0.0
        DO J=1,3
          AM(I,J) = 0.0
        ENDDO
      ENDDO
      M    = 99
      IERR =-IMODEL 
      CALL TRANS(M,NAME1,NAME2,SH1,SH2
     *      ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)

      RETURN
      END


      SUBROUTINE READ_TAB(MDOC,NAME,NP_MAX,RESULT,IPRMAX,IPRROW)
C --------------------------------
      REAL      RESULT    (IPRMAX,IPRROW)
      CHARACTER LINE*256,PATH*80,EXT*80,NAME*(*)
C ---
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /FREAD_CIF/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*80
      REAL      AM(3,3)
C --------------------------------------------------------------
      MD0    = MDOC
      MD     =-ABS(MDOC)-1
      M      = 99
      PI   = 4.0*ATAN(1.0)
      NP   = 0
      IERR = 0
      NW   = 0
C ---
      IN   = 11
      PATH = ' '
      EXT  = ' '
      CALL OPENFR(IN,M,PATH,NAME,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 900
      ENDIF
C --- 
C  1    2     3       4       5      6       7       8           9         10
Col_RF  2   108.68  148.44   70.30  105.78  -70.81  179.72     143.9      6.80

      IEND = 0
 200  CONTINUE
      IN_STRING = ' '
      READ(IN,'(A)',END=110) IN_STRING
      GO TO 120
 110  CONTINUE
      IEND = 1
 120  CONTINUE
      CALL LENSTR_BL(IN_STRING,LEN)
      IF(LEN.GT.0.AND.IN_STRING(1:1).NE.'#') THEN
        CALL FRD_PARM_CIF
C       IF(NWORDS.LE.3) GO TO 200
        IF(NWORDS.LE.4) GO TO 200
        IF(WORDS(1)(1:1).EQ.'#') GO TO 200
        IF(NP.GE.IPRMAX) GO TO 100
        NP = NP + 1

        RESULT(NP, 9) = FWORDS(3)
        RESULT(NP,10) = FWORDS(4)
        RESULT(NP,11) = FWORDS(5)
        RESULT(NP,13) = 0.0

        IF(WORDS(1)(1:5).EQ.'Sol_A') THEN
          RESULT(NP,13) = 1.0
        ELSE IF(WORDS(1)(1:7).EQ.'Sol_RFA') THEN
          RESULT(NP,13) = 1.0
        ENDIF

        IF(NWORDS.GE.10) THEN

          RESULT(NP, 6) = FWORDS(6)
          RESULT(NP, 7) = FWORDS(7)
          RESULT(NP, 8) = FWORDS(8)

          RESULT(NP, 4) = FWORDS(9)
          RESULT(NP, 5) = FWORDS(10)
          NW = 1
        ELSE
          RESULT(NP, 6) = 0.0
          RESULT(NP, 7) = 0.0
          RESULT(NP, 8) = 0.0
          RESULT(NP, 4) = 0.0
          RESULT(NP, 5) = 0.0
        ENDIF
      ENDIF
      IF(NP_MAX.GT.0.AND.NP_MAX.EQ.NP) GO TO 100
      IF(IEND.GT.0) GO TO 100
      GO TO 200
C ---
 100  CONTINUE
      CLOSE(IN)
 900  CONTINUE
      IERR = 0
      RESULT(1,12) = NP
      IF(NP.GT.0) THEN
        CALL MSGDOC(MD,' ')    
        CALL MSGDOC(MD,' --- Input peaks of Rotation Function ---')
        CALL MSGDOC(MD,' ')    

        LINE =
     * 'S'//'ol_         theta    phi    chi '//
     * '    alpha   beta  gamma'//'         Rf'//'   Rf/sigma'
c    * '#'//'      alpha   beta   gamma'//'    theta    phi    chi'//
C       LINE = '       alpha   beta   gamma'
        CALL LENSTR_BL(LINE,LEN)
        CALL MSGDOC(MD,LINE(1:LEN))    
        CALL MSGDOC(MD,' ')    
        DO I=1,NP

          IF(RESULT(I,13).GT.0.001) THEN

            ALPHA   = RESULT(I, 9)
            BETA    = RESULT(I,10)
            GAMMA   = RESULT(I,11)
            RALPHA  = (RESULT(I, 9)*PI)/180.0
            RBETA   = (RESULT(I,10)*PI)/180.0
            RGAMMA  = (RESULT(I,11)*PI)/180.0
            RESULT(I,6) = RESULT(I, 9)
            RESULT(I,7) = RESULT(I,10) 
            RESULT(I,8) = RESULT(I,11) 

            CALL EULERM(RALPHA,RBETA,RGAMMA,AM)
            CALL MTOPOL(AM,THETA,PHI,CHI)

            RESULT(I, 9) = THETA
            RESULT(I,10) = PHI  
            RESULT(I,11) = CHI   

          ELSE
            THETA  = (RESULT(I, 9)*PI)/180.0
            PHI    = (RESULT(I,10)*PI)/180.0
            CHI    = (RESULT(I,11)*PI)/180.0

            CALL POLTOM(THETA,PHI,CHI,AM)
            CALL MTOANG(AM,ALPHA,BETA,GAMMA)

            RESULT(I,6) = ALPHA
            RESULT(I,7) = BETA  
            RESULT(I,8) = GAMMA 
          ENDIF
C          IF(NW.LE.0) THEN
C            WRITE(LINE,300) I,ALPHA,BETA,GAMMA
C 300        FORMAT(I3,1X,6F8.2)
C            CALL LENSTR_BL(LINE,LEN)
C            CALL MSGDOC(MDOC,LINE(1:LEN))    
C          ELSE
            WRITE(LINE,310) I
     *      ,RESULT(I,9),RESULT(I,10),RESULT(I,11)
     *      ,ALPHA,BETA,GAMMA
     *      ,RESULT(I,4),RESULT(I,5)
 310        FORMAT('Sol_RF',I3,1X,6F8.2,G14.4,F6.2)
C310        FORMAT(I3,1X,3F8.2,3F8.2,G14.4,G12.4)
            CALL LENSTR_BL(LINE,LEN)
            CALL MSGDOC(MD,LINE(1:LEN))    
C          ENDIF
        ENDDO

        CALL MSGDOC(MD0,' ')    
        CALL MSGDOC(MD0,
     *         '     --- Peaks of Rotation Function ---')
        LINE = '+--------------------------------------------+'
        CALL MSGDOC(MD0,LINE)    
        LINE = '|         theta      phi      chi   Rf/sigma |'
        CALL MSGDOC(MD0,LINE)    
        LINE = '+--------------------------------------------+'
        CALL MSGDOC(MD0,LINE)    
        DO I=1,NP
          WRITE(LINE,'(''|'',I3,2X,3F9.2,''     '',F6.2,'' |'')') I
     *      ,RESULT(I,9),RESULT(I,10),RESULT(I,11),RESULT(I,5)
          CALL MSGDOC(MD0,LINE)    
        ENDDO
        LINE = '+--------------------------------------------+'
        CALL MSGDOC(MD0,LINE)    
        CALL MSGDOC(MD0,' ')    
      ENDIF
      RETURN
      END

      SUBROUTINE READ_TAB_PRF(MDOC,NAME,NP_MAX,RESULT,IPRMAX,IPRROW)
C --------------------------------
      REAL      RESULT    (IPRMAX,IPRROW)
      CHARACTER LINE*256,PATH*80,EXT*80,NAME*(*)
C ---
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /FREAD_CIF/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*80
      REAL      AM(3,3)
C --------------------------------------------------------------
      PI   = 4.0*ATAN(1.0)
      M    = 99
      NP   = 0
      IERR = 0
      NW   = 0
C ---
      IN   = 11
      PATH = ' '
      EXT  = ' '

      CALL OPENFR(IN,M,PATH,NAME,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 900
      ENDIF
C --- 
Col_RF  2   108.68  148.44   70.30  105.78  -70.81  179.72     143.9      6.80

      IEND = 0
 200  CONTINUE
      IN_STRING = ' '
      READ(IN,'(A)',END=110) IN_STRING
      GO TO 120
 110  CONTINUE
      IEND = 1
 120  CONTINUE
      CALL LENSTR_BL(IN_STRING,LEN)
      IF(LEN.GT.0.AND.IN_STRING(1:1).NE.'#') THEN
        CALL FRD_PARM_CIF
C       IF(NWORDS.LE.3) GO TO 200
        IF(NWORDS.LE.7) GO TO 200
        IF(WORDS(1)(1:1).EQ.'#') GO TO 200
        IF(NP.GE.IPRMAX) GO TO 100
        NP = NP + 1

        RESULT(NP,6)  = FWORDS(3)
        RESULT(NP,7)  = FWORDS(4)
        RESULT(NP,8)  = FWORDS(5)
        RESULT(NP, 9) = FWORDS(6)
        RESULT(NP,10) = FWORDS(7)
        RESULT(NP,11) = FWORDS(8)
        RESULT(NP,13) = 0.0

        IF(WORDS(1)(1:5).EQ.'Sol_A') THEN
          RESULT(NP,13) = 1.0
        ELSE IF(WORDS(1)(1:7).EQ.'Sol_RFA') THEN
          RESULT(NP,13) = 1.0
        ENDIF

        IF(NWORDS.GE.10) THEN
          RESULT(NP, 4) = FWORDS(9)
          RESULT(NP, 5) = FWORDS(10)
          NW = 1
        ELSE
          RESULT(NP, 4) = 0.0
          RESULT(NP, 5) = 0.0
        ENDIF
      ENDIF
      IF(NP_MAX.GT.0.AND.NP_MAX.EQ.NP) GO TO 100
      IF(IEND.GT.0) GO TO 100
      GO TO 200
C ---
 100  CONTINUE
      CLOSE(IN)
 900  CONTINUE
      IERR = 0
      NW   = 1
      RESULT(1,12) = NP
      IF(NP.GT.0) THEN
        CALL MSGDOC(MDOC,' --- input peaks of RF and TF. ---')
        LINE =
     * 'S'//'ol_         theta    phi    chi '//
     * '     tx      ty     tz '
C     * '     tx      ty     tz '//'         RF'//'        TF '
C     * 'S'//'ol_         alpha   beta   gamma'//
C     * '    theta    phi    chi'//'         Rf'//'   Rf/sigma'
c    * '#'//'      alpha   beta   gamma'//'    theta    phi    chi'//
C       LINE = '       alpha   beta   gamma'
        CALL LENSTR_BL(LINE,LEN)
        CALL MSGDOC(MDOC,LINE(1:LEN))    
        DO I=1,NP

          IF(RESULT(I,13).GT.0.001) THEN
            ALPHA  = RESULT(I,6)
            BETA   = RESULT(I,7)
            GAMMA  = RESULT(I,8)
            RALPHA = (ALPHA*PI)/180.0
            RBETA  = (BETA *PI)/180.0
            RGAMMA = (GAMMA*PI)/180.0
            CALL EULERM(RALPHA,RBETA,RGAMMA,AM)
            CALL MTOPOL(AM,THETA,PHI,CHI)
          ELSE
            THETA  = RESULT(I,6)
            PHI    = RESULT(I,7)
            CHI    = RESULT(I,8)
            RTHETA = (THETA*PI)/180.0
            RPHI   = (PHI  *PI)/180.0
            RCHI   = (CHI  *PI)/180.0
            CALL POLTOM(RTHETA,RPHI,RCHI,AM)
            CALL MTOANG(AM,ALPHA,BETA,GAMMA)
          ENDIF

          RESULT(I,6) = ALPHA
          RESULT(I,7) = BETA
          RESULT(I,8) = GAMMA 

          IF(NW.LE.0) THEN
            WRITE(LINE,300) I,THETA,PHI,CHI
 300        FORMAT(I3,1X,3F8.2,3F8.3)
            CALL LENSTR_BL(LINE,LEN)
            CALL MSGDOC(MDOC,LINE(1:LEN))    
          ELSE
            WRITE(LINE,310) I,THETA,PHI,CHI
     *      ,RESULT(I,9),RESULT(I,10),RESULT(I,11)
c     *      ,RESULT(I,4),RESULT(I,5)
 310        FORMAT('Sol_  ',I3,1X,3F8.2,3F8.3)
c310        FORMAT('Sol_RT',I3,1X,3F8.2,3F8.3,1X,F9.2,F9.2)
C310        FORMAT(I3,1X,3F8.2,3F8.2,G14.4,G12.4)
            CALL LENSTR_BL(LINE,LEN)
            CALL MSGDOC(MDOC,LINE(1:LEN))    
          ENDIF
        ENDDO
      ENDIF
      RETURN
      END

      SUBROUTINE READ_TAB_TF(MDOC,NAME,NP_MAX,RESULT,IPRMAX,IPRROW)
C --------------------------------
      REAL      RESULT    (IPRMAX,IPRROW)
      CHARACTER LINE*256,PATH*80,EXT*80,NAME*(*)
C ---
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /FREAD_CIF/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*80
      REAL      AM(3,3)
C --------------------------------------------------------------
      PI   = 4.0*ATAN(1.0)
      M    = 99
      NP   = 0
      IERR = 0
      NW   = 0
C ---
      IN   = 11
      PATH = ' '
      EXT  = ' '

      CALL OPENFR(IN,M,PATH,NAME,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 900
      ENDIF
C --- 
Col_RF  2   108.68  148.44   70.30  105.78  -70.81  179.72     143.9      6.80

      IEND = 0
 200  CONTINUE
      IN_STRING = ' '
      READ(IN,'(A)',END=110) IN_STRING
      GO TO 120
 110  CONTINUE
      IEND = 1
 120  CONTINUE
      CALL LENSTR_BL(IN_STRING,LEN)
      IF(LEN.GT.0.AND.IN_STRING(1:1).NE.'#') THEN
        CALL FRD_PARM_CIF
C       IF(NWORDS.LE.3) GO TO 200
        IF(NWORDS.LE.7) GO TO 200
        IF(WORDS(1)(1:1).EQ.'#') GO TO 200
        IF(NP.GE.IPRMAX) GO TO 100
        NP = NP + 1

        RESULT(NP,6)  = FWORDS(3)
        RESULT(NP,7)  = FWORDS(4)
        RESULT(NP,8)  = FWORDS(5)
        RESULT(NP, 9) = FWORDS(6)
        RESULT(NP,10) = FWORDS(7)
        RESULT(NP,11) = FWORDS(8)
        RESULT(NP,13) = 0.0

        IF(WORDS(1)(1:5).EQ.'Sol_A') THEN
          RESULT(NP,13) = 1.0
        ELSE IF(WORDS(1)(1:7).EQ.'Sol_RFA') THEN
          RESULT(NP,13) = 1.0
        ENDIF

        IF(NWORDS.GE.10) THEN
          RESULT(NP, 4) = FWORDS(9)
          RESULT(NP, 5) = FWORDS(10)
          NW = 1
        ELSE
          RESULT(NP, 4) = 0.0
          RESULT(NP, 5) = 0.0
        ENDIF
      ENDIF
      IF(NP_MAX.GT.0.AND.NP_MAX.EQ.NP) GO TO 100
      IF(IEND.GT.0) GO TO 100
      GO TO 200
C ---
 100  CONTINUE
      CLOSE(IN)
 900  CONTINUE
      IERR = 0
      NW   = 1
      RESULT(1,12) = NP
      IF(NP.GT.0) THEN
        CALL MSGDOC(MDOC,' --- input peaks of RF and TF ---')
        LINE =
     * 'Sol_      theta    phi    chi '//
     * '      alpha    beta   gamma   tx      ty     tz '
C     * '     tx      ty     tz '//'         RF'//'        TF '
C     * 'S'//'ol_         alpha   beta   gamma'//
C     * '    theta    phi    chi'//'         Rf'//'   Rf/sigma'
c    * '#'//'      alpha   beta   gamma'//'    theta    phi    chi'//
C       LINE = '       alpha   beta   gamma'
        CALL LENSTR_BL(LINE,LEN)
        CALL MSGDOC(MDOC,LINE(1:LEN))    
        DO I=1,NP

          IF(RESULT(I,13).GT.0.001) THEN

            ALPHA  = RESULT(I,6)
            BETA   = RESULT(I,7)
            GAMMA  = RESULT(I,8)

            RALPHA  = (RESULT(I,6)*PI)/180.0
            RBETA   = (RESULT(I,7)*PI)/180.0
            RGAMMA  = (RESULT(I,8)*PI)/180.0
            CALL EULERM(RALPHA,RBETA,RGAMMA,AM)
            CALL MTOPOL(AM,THETA,PHI,CHI)

            RESULT(I,6) = THETA
            RESULT(I,7) = PHI  
            RESULT(I,8) = CHI  

          ELSE
            THETA  = RESULT(I,6)
            PHI    = RESULT(I,7)
            CHI    = RESULT(I,8)
            RTHETA = (RESULT(I,6)*PI)/180.0
            RPHI   = (RESULT(I,7)*PI)/180.0
            RCHI   = (RESULT(I,8)*PI)/180.0
            CALL POLTOM(RTHETA,RPHI,RCHI,AM)
            CALL MTOANG(AM,ALPHA,BETA,GAMMA)
          ENDIF

          IF(NW.LE.0) THEN
            WRITE(LINE,300) I,THETA,PHI,CHI,ALPHA,BETA,GAMMA
 300        FORMAT(I3,3F8.2,1X,3F8.2)
            CALL LENSTR_BL(LINE,LEN)
            CALL MSGDOC(MDOC,LINE(1:LEN))    
          ELSE
            WRITE(LINE,310) I,THETA,PHI,CHI,ALPHA,BETA,GAMMA
     *      ,RESULT(I,9),RESULT(I,10),RESULT(I,11)
c     *      ,RESULT(I,4),RESULT(I,5)
 310        FORMAT('Sol_ ',I3,3F8.2,1X,3F8.2,3F7.3)
c310        FORMAT('Sol_RT',I3,1X,3F8.2,3F8.3,1X,F9.2,F9.2)
C310        FORMAT(I3,1X,3F8.2,3F8.2,G14.4,G12.4)
            CALL LENSTR_BL(LINE,LEN)
            CALL MSGDOC(MDOC,LINE(1:LEN))    
          ENDIF
        ENDDO
      ENDIF
      RETURN
      END

      SUBROUTINE CROSSROT(MDOC,NAMEF,NAMEM,NAME_DIFF,NAME_TAB
     * ,NAME_TSRF,PATH_OUT,PATH_SCR
     * ,DELTA,RMS_INPUT,DLIM_RF,NCS_MODEL,NMON_EXPECTED
     * ,RESN,RESX,PARM_RF,IPARM_RF,CHI_IN,COEF_IN,BLIM
     * ,BOFF,BADD,BOFF_SCL,BADD_SCL,ARAD
     * ,ISYM,IPRSYM
     * ,RESULT,RESULTA,RESULTB,IPRMAX,IPRROW,IERR)
C --------------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
C ----
C     IPRMAX - MAX. NUMBER OF PEAKS
      REAL      RESULT (IPRMAX,IPRROW)
      REAL      RESULTA(IPRMAX,IPRROW)
      REAL      RESULTB(IPRMAX,IPRROW)
C ---
      CHARACTER NAMEF*(*),NAMEM*(*)
      CHARACTER PATH_OUT*(*),PATH_SCR*(*)
      CHARACTER SUM*1,DIFF*1
      CHARACTER NAME_TAB*(*),NAME_DIFF*(*),NAME_TSRF*(*)

      CHARACTER NAMEA*256,NAMEAM*256,NAMEC*256,NAMES*256,NAMEC2*256
      CHARACTER NAME*256,NAMED*256,NAMEFM*256,NAMEPH*256,NAMEFM2*256
      CHARACTER NAMEA1*256,NAMEA2*256,NAMEA3*256,NAMEA4*256
      CHARACTER NAMEA5*256,NAMEA6*256

      CHARACTER NAMEFFM*256,NAME_RF*256

      CHARACTER LINE*256,TTT*80,ITYPE*4,P1*1,MODE*1,WAT*1,ALT*1,PST*1
      CHARACTER REST*1,SETT*1,HATM*1,NUM*1,NOCC*1,MISS*1,RFAC_FLAG*1
      CHARACTER FUN*1,PATH*80,EXT*80,MODE_GD*1,TEST*1,LIST*1,MOD1*1
      CHARACTER F0*1,LAP*1,MSGA*1,SURF*1,INVER*1,LOCK*1,CH1*1
      REAL      AM(3,3),SH1(3),SH2(3),SHR(3)
      REAL      RLATT(6),RLATT_OBS(6),RF_MAX(4)
      INTEGER*4 NSPGROUP,NOSETT
      CHARACTER CODE*4,NAMET*40,DATE*9,SPGR*24,SOLV*1,PATT*1,SELF*1 
      CHARACTER TITLE*80,MODE_F*1,STOP_T*1,SPEC*1,CONV*1,ANISO*1
      CHARACTER MODE_FFT*1,ACORR*1,ANISO_I*1,PROG*4,ANISO_CORR*1
      CHARACTER ANISO2*1,LH_STOR*1,DB_INPUT*1
      CHARACTER PARM_RF*16
      INTEGER   IPARM_RF(20)
C -------------------------------------------------------------
C ---
      INCLUDE 'molrep_xml.fh'
C ---
      INCLUDE 'molrep_lh_infor.fh'
C      COMMON/COM_LH_INFOR/ BOFF_LH,BADD_LH,BOFF_FOR_SCAL
C     *   ,CHECK_CONTRAST,CONTRAST_LIM
C     *   ,BCORR_LH,FILE_FOBS_LH,SCORE_FLAG,LH_LH,DB_LH
C ---
C      REAL      CHECK_CONTRAST,CONTRAST_LIM
C      REAL      BOFF_FOR_SCAL,BOFF_LH,BADD_LH,BCORR_LH
C      CHARACTER LH_LH*1,SCORE_FLAG*1,DB_LH*1
C      CHARACTER FILE_FOBS_LH*256
C ---
C ----------------------------------
      PI    = 4.0*ATAN(1.0)
      MD    = -ABS(MDOC)-10
      M     = 99
      MD0   =  0
      IF(ABS(MDOC).GE.99) MD0 = 99
      TWOPI = 2.0*PI
C ---
C      IF(ABS(MDOC).EQ.2) THEN
C        MD=99
C      ENDIF
C ---
C ---XML--
      JOB_XML = 'MR_RF'
      CALL WRITE_XML_FILE(IERR,PATH_OUT)
C ---
      LH_STOR = LH_LH
      IF(LH_LH.EQ.'V') LH_LH = '2'
C ---
      SUM     = PARM_RF( 1: 1)
      ANISO_I = PARM_RF( 2: 2) 
      SELF    = PARM_RF( 3: 3)
      PST     = PARM_RF( 4: 4) 
      FUN     = PARM_RF( 5: 5)
      TEST    = PARM_RF( 6: 6) 
      LIST    = PARM_RF( 7: 7) 
      DIFF    = PARM_RF( 8: 8) 
      SURF    = PARM_RF( 9: 9) 
      MOD1    = PARM_RF(11:11) 
      LOCK    = PARM_RF(13:13) 
      ANISO_CORR = PARM_RF(14:14)
      DB_INPUT = PARM_RF(15:15) 
      IF(LIST.EQ.'T') THEN
        M     =  MDOC
        MD    =  MDOC
        MD0   =  0
      ELSE IF(LIST.EQ.'S') THEN
        MD    = 99   
      ENDIF
C ----
      NPEAK    = IPARM_RF(1)
      LMIN_INP = IPARM_RF(2) 
      LMAX_INP = IPARM_RF(3)
      NMR      = IPARM_RF(4) 
      N_MODEL  = IPARM_RF(5) 
      NP_SRF   = IPARM_RF(6) 
      NREFR    = IPARM_RF(7) 
      NPEAK_MAX = IPARM_RF(8) 
C ----
      IF(TEST.EQ.'F') THEN

c        MODE_GD  = 'S'
c        BADD_GD  = BLIM + 0.00001
c        RAD_GD   = 2.8
c        RAD_GD   = 3.5

        MODE_GD = 'S'
        RAD_GD  = 3.5
        BADD_GD = 0.0
        IF(SURF.EQ.'Y'.OR.SURF.EQ.'C') THEN
          BADD_GD  = BLIM + 0.000001
        ENDIF

c       WRITE(*,*) '>MODE,BADD_GD,RAD_GD:',MODE_GD,BADD_GD,RAD_GD        

      ELSE
        MODE_GD  = ' '
        IF(SURF.EQ.'C') MODE_GD = 'C'
        BADD_GD  = 0.0
        RAD_GD   = 0.0
        IF(SURF.EQ.'Y'.OR.SURF.EQ.'C') THEN
          RAD_GD  = BLIM + 0.000001
        ENDIF
      ENDIF
C ---
      CODE     = ' '
      NAMET    = ' '
      DATE     = ' '
      SPGR     = 'P 1'
      NSPGROUP = 1
      NOSETT   = 1
      TITLE    = '-'

      IF(SUM  .EQ.'y')  SUM   = 'Y'
      IF(SUM  .NE.'Y')  SUM   = 'N'
      IF(LIST.EQ.'T') THEN
        LINE = 'ANISO: '//ANISO_I
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      IF(ANISO_I.EQ.'y')  ANISO_I = 'Y'
      IF(ANISO_I.EQ.'k')  ANISO_I = 'K'
      IF(ANISO_I.NE.'Y'.AND.ANISO_I.NE.'K')  ANISO_I = 'N'
      ACORR = 'N' 
      IF(ANISO_CORR.EQ.'Y') ACORR = 'Y'
      ANISO   = ANISO_I
C --------------------------------------------------------------
      IERR  = 0
      MTN   = 10
      ITYPE = 'FF  '

      CALL ORFILE(M,MTN,NAMEF,ITYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN INPUT-FILE-FOBS')
        RETURN
      ENDIF

      CALL C_RD_CR

      CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *  ,F1,F2,RESMIN,RESMAX,IDM,IDM,IDM,IDM,IDM,TTT,IERR)
      CLOSE(MTN)
      RLATT_OBS(1) = A
      RLATT_OBS(2) = B
      RLATT_OBS(3) = C
      RLATT_OBS(4) = AL
      RLATT_OBS(5) = BE
      RLATT_OBS(6) = GA
      CLOSE(MTN)
C -------------------------------------------------------------

      IF(RESX.LT.0.00001) RESX   = 3.0
      IF(RESX.GT.0.00001) RESMAX = RESX
      IF(RESN.GT.0.00001.AND.RESN.LT.RESMIN) RESMIN=RESN
      IF(RESMIN.LT.RESMAX) THEN
        T      = RESMIN
        RESMIN = RESMAX
        RESMAX = T
      ENDIF
      IF(RESMIN.EQ.RESMAX) THEN
        CALL MSGERR(MDOC,' ERR: resmin = resmax')
        IERR=1
        RETURN
      ENDIF
C --------------------------------------------------------------
      NAME    = ' '
      NAMES   = ' '
      NAMEA   = 'crossrot_alo'
      CALL ADD_PATH(PATH_SCR,NAMEA)
      NAMEA1  = 'crossrt_al1'
      CALL ADD_PATH(PATH_SCR,NAMEA1)
      NAMEA2  = 'crossrt_al2'
      CALL ADD_PATH(PATH_SCR,NAMEA2)
      NAMEA3  = 'crossrt_al3'
      CALL ADD_PATH(PATH_SCR,NAMEA3)
      NAMEA4  = 'crossrt_al4'
      CALL ADD_PATH(PATH_SCR,NAMEA4)
      NAMEA5  = 'crossrt_al5'
      CALL ADD_PATH(PATH_SCR,NAMEA5)
      NAMEA6  = 'crossrt_al6'
      CALL ADD_PATH(PATH_SCR,NAMEA6)
      NAMEAM  = 'crossrot_alm'
      CALL ADD_PATH(PATH_SCR,NAMEAM)
      NAMEC   = 'crossrt_scr'
      CALL ADD_PATH(PATH_SCR,NAMEC)
      NAMEC2  = 'crossrt_scr1'
      CALL ADD_PATH(PATH_SCR,NAMEC2)
      NAMED   = 'crossrot_dns'
      CALL ADD_PATH(PATH_SCR,NAMED)
      NAMEFM  = 'crossrt_f'
      CALL ADD_PATH(PATH_SCR,NAMEFM)
      NAMEFM2 = 'crossrt_fsc'
      CALL ADD_PATH(PATH_SCR,NAMEFM2)
      NAMEPH  = 'crossrt_ph'
      CALL ADD_PATH(PATH_SCR,NAMEPH)

      NAMEFFM = 'crossrot_ff'
      CALL ADD_PATH(PATH_SCR,NAMEFFM)
C -----------------
      DO I=1,3
        SHR(I) = 0.0
      ENDDO
C ==========================================
      IF(ACORR.EQ.'Y') THEN
        CALL MSGDOC(MD0,'--- anisothermal correction of Fobs ---')
        BADDD    = BADD_SCL
        BOFFF    = BOFF_SCL
        SCALE    = 1.0
        BOVER    = 0.0
        PATT     = 'Y'
        SOLV     = 'N'
        NCYCL    =  0
C        RESMNI=RESMIN
C        RESMXI=RESMAX
        RESMNI = 0.0
        RESMXI = 0.0
        NAME   = ' '
        ANISO2 = '-'
        CALL MR_SCALING(MDOC,LIST,NAME,NAMEF,NAMEFFM,PATH_SCR
     * ,ANISO2,SCALE,BOVER,ACORR,BOFFF,BADDD,RESMNI,RESMXI
     * ,SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF
     * ,RESULTA,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
C ---------------------------------------------------------
C     1. ACORR # N - anisothermal correction of Fmod
c        if ANISO = '-' return
C     2. ANISO = K - FSCALE with SCALEP,BSCALE
C                   if scale = 0 - scaling by Fobs (cell must be the same)
C                      only scale , set BOVER = 0
C                   if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                  no info: rfac, corr
C        else  CALL PSCALE
C      output: SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF and NAMEFM2
C ---------------------------------------------------------
      ELSE
        NAMEFFM=NAMEF
      ENDIF

C -------------------
C     CALL MSGDOC(MD0,'--- read coordinates of model ---')
C ---
C     difine max. radius and coord limits, centre
      IERR = 0
      CALL DEF_RAD(M,MOD1,NAMEM,RESULT,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C       RADIUS_MAX = RESULT(1,1)
C       ZMIN       = RESULT(6,1) 
C       ZMAX       = RESULT(7,1)
C       XS = RESULT( 8,1) 
C       YS = RESULT( 9,1) in A
C       ZS = RESULT(10,1) 
C       RESULT(11)= RI
C       RESULT(12)= MODEL
C       RESULT(13)= NMODEL
      IF(IERR.NE.0) GO TO 900
      ARADI = RESULT(11,1)


c ////
      CALL CALC_INERTIA_MATRIX(MDOC,MOD1,NAMEM
     *      ,NSYM,ISYM,IPRSYM,IERR)
c ////

C -----------------------------

      IUSER = 1
      IF(ARAD.LT.0.0001) THEN
        ARAD  = ARADI*2.0
        IF(NCS_MODEL.GT.0) THEN
          T = 0.3333*LOG(FLOAT(NCS_MODEL))
          T = EXP(T)
c          WRITE(*,*) '--T:',T
          ARAD = ARAD/T
        ENDIF
        IUSER = 0
      ENDIF

      WRITE(LINE,'('' Radius of gyration      :'',F8.2)') ARADI
      CALL MSGDOC(MDoc,LINE)

      IF(BOFF.LE.0.00001) BOFF=900.0
    
      IF(IUSER.EQ.0.OR.DB_INPUT.EQ.'Y') THEN
c        RCOEF = 0.55
        RCOEF = 0.5
C        IF(ARAD.GT.(A*RCOEF)) ARAD = A*RCOEF
C        IF(ARAD.GT.(B*RCOEF)) ARAD = B*RCOEF
C        IF(ARAD.GT.(C*RCOEF)) ARAD = C*RCOEF
        I=0
        IF(ARAD.GT.(A*RCOEF)) I=1
        IF(ARAD.GT.(B*RCOEF)) I=2
        IF(ARAD.GT.(C*RCOEF)) I=3
        IF(I.NE.0) THEN
          AAA = A*RCOEF
          T   = B*RCOEF
          IF(T.LT.AAA) AAA=T
          T = C*RCOEF
          IF(T.LT.AAA) AAA=T
          WRITE(LINE,
     *    '('' WARNING: Radius of integration  > '',F8.2)') 
     *    AAA
          CALL MSGDOC(MDOC,LINE)
          ARAD = AAA
        ENDIF
      ELSE
c       RCOEF=0.55
        RCOEF=0.5
        I=0
        IF(ARAD.GT.(A*RCOEF)) I=1
        IF(ARAD.GT.(B*RCOEF)) I=2
        IF(ARAD.GT.(C*RCOEF)) I=3
        IF(I.NE.0) THEN
          AAA = A*RCOEF
          T   = B*RCOEF
          IF(T.LT.AAA) AAA=T
          T = C*RCOEF
          IF(T.LT.AAA) AAA=T
          WRITE(LINE,
     *    '('' WARNING: Radius of integration  > '',F8.2)') 
     *    AAA
          CALL MSGDOC(MDOC,LINE)
C         ARAD = AAA
        ENDIF
      ENDIF

      WRITE(LINE,'('' Radius of integration   :'',F8.2)') 
     * ARAD
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Resolution              :'',2F8.2)') 
     * RESMIN,RESMAX
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Boff,Badd               :'',2F8.2)') 
     * BOFF,BADD
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,'('' Boff_scl,Badd_scl       :'',2F8.2)') 
     * BOFF_SCL,BADD_SCL
      CALL MSGDOC(MD,LINE)

      WRITE(LINE,'('' Diff : '',A)') DIFF
      CALL MSGDOC(MD,LINE)
C ---------------
      LMAXR = LMAX_INP
      LMINR = LMIN_INP

C      IF(LMAX_INP.LE.0) THEN
C        ALM = (ARAD/RESMAX-1.0)*TWOPI
C        IF(ALM.GT.30) THEN
C          ALMM = ALM/SQRT(2.0)
C        ENDIF
C        LM = ALM + 0.1
C        LM = (LM/2)*2
C        LMM = ALMM + 0.1
C        LMM = (LMM/2)*2
C        WRITE(LINE,'('' Lmax,Lmax0.7 (new)         :'',2I5)') 
C     *  LM,LMM
C        CALL MSGDOC(MDOC,LINE)
c        LMAXR = LMM
C         RESMXT = (TWOPI*ARAD)/98.0
C         R = ARAD/(60.0/TWOPI+1.0) 
C         WRITE(*,*) '--R,RMXT:',R,RESMXT
C         IF(R.GT.RESMAX) RESMAX = R
C      ENDIF
C
C      IF(LMIN_INP.NE.0.OR.LMAX_INP.NE.0) THEN
C        WRITE(LINE,'('' Lmin,Lmax (input)           :'',2I5)') 
C     *  LMINR,LMAXR
C        CALL MSGDOC(MDOC,LINE)
C      ENDIF

c      IPRBES = 400
      IPRBES = 600
C      RESMXT = (TWOPI*ARAD)/98.0
C      IF(RESMXT.LT.0.1) RESMXT=0.1

c      RESMXT = ARAD/(60.0/TWOPI+1.0) 
c      RESMXT = ARAD/(108.0/TWOPI+1.0) 
      RESMXT = (ARAD*TWOPI)/109.35

      IF(RESMXT.GT.RESMAX) THEN
        RESMAX = RESMXT
        CALL MSGERR(MDOC,
     *' WARNING: For this radius integration program uses data included'
     *)
        WRITE(LINE,
     *'(''          between '',F7.1,'' and '',F7.2,'' (angstrom..)'')')
     *  RESMIN,RESMAX
        CALL MSGERR(MDOC,LINE)
      ENDIF
c
c      write(*,*) ' Lmax=',lmaxr
C ----------------

      RESMAX_FFT=RESMAX*0.9
      WRITE(LINE,'('' Resmax for calc Fmod:'',2F8.2)') RESMAX_FFT
      CALL MSGDOC(MD,LINE)
C ----
c      WRITE(LINE,'(''ARADI,ARAD:'',2F8.2)') ARADI,ARAD
c      CALL MSGDOC(MDOC,LINE)

      T1 = ARADI*2.0
      T2 = ARAD 
c      IF(T2.GE.T1) T2 = T2/1.5

      CELL_P1 = (T1+T2)*1.25
c     CELL_P1 = (ARADI*1.5)*4.0

      WRITE(LINE,'('' CELL (P1) of model a ='',F8.2)') CELL_P1
      CALL MSGDOC(MD,LINE)

      RLATT(1) = CELL_P1
      RLATT(2) = CELL_P1
      RLATT(3) = CELL_P1
      RLATT(4) = 90.0
      RLATT(5) = 90.0
      RLATT(6) = 90.0
      RLATT(4) = (RLATT(4)*PI)/180.
      RLATT(5) = (RLATT(5)*PI)/180.
      RLATT(6) = (RLATT(6)*PI)/180.

c      DO I=1,6
c        RLATT(I) = RLATT_OBS(I)
c        write(*,*) '--1:', RLATT(I)        
c      ENDDO

      AP1      = RLATT(1)
      BP1      = RLATT(2)
      CP1      = RLATT(3)
      ALP1     = RLATT(4)
      BEP1     = RLATT(5)
      GAP1     = RLATT(6)
C ---
      CALL SET_CELL(RLATT,CODE,NAMET,DATE,TITLE
     *    ,NSPGROUP,NOSETT,SPGR,IERR)
      IF(IERR.NE.0) GO TO 900

      CALL LIMHKL(RESMAX_FFT,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)
C ----
      CALL MSGDOC(MD,'Minimal grid spacing for calculation SF:') 
      WRITE(LINE,1000) NXMIN,NYMIN,NZMIN
 1000 FORMAT(' NXmin=',I3,', NYmin=',I3,', NZmin=',I3) 
      CALL MSGDOC(MD,LINE)

      IZMIN    = 0
      IZMAX    =-1

      ALPHA  = 0.0
      BETA   = 0.0
      GAMMA  = 0.0
      SCALEP = 0.0
      BSCALE = 0.0
C      IF(ANISO_I.EQ.'K') ANISO = '0'
      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC  
      IMOD = 1
      
      NAME = NAMED 
      IF(MOD1.EQ.'D'.AND.LIST.EQ.'L') THEN
        NAME   = 'crossrot_dns_model'
        CALL ADD_PATH(PATH_SCR,NAME)
      ENDIF

      ANISO2 = 'N'      
      IF(ANISO.EQ.'K') THEN
        ANISO2 = 'K'      
        SCALEP = 1.0
        BSCALE = 0.0
      ENDIF
      IF(LIST.EQ.'T') THEN
        LINE = 'ANISO for scaling: '//ANISO2
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(2F10.3)') SCALEP,BSCALE 
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      RESMAX_FIRST = RESMAX

      CALL RF_PRECALC_MOD(MMM,LIST,NAMEM,NAMEC,NAME
     * ,NAMEFFM,NAMEFM2,NAMEPH,PATH_SCR
     * ,MOD1,IMOD,ANISO2,NXMIN,NYMIN,NZMIN
     * ,IZMIN,IZMAX,NMR,N_MODEL,TEST,SCALEP,BSCALE,ACORR
     * ,BOFF_SCL,BADD_SCL,RESMIN,RESMAX
     * ,MODE_GD,BADD_GD,RAD_GD,NEL,SURF
     * ,RLATT,ALPHA,BETA,GAMMA 
     * ,RESULT,RESULTA,IPRMAX,IPRROW
     * ,ISYM,IPRSYM,IERR)
C ------------------------------------------------------------
C 1) if MOD1=D DENS2F_DNS else DENS2F_NEW
C 2) if ANISO # 0 MR_SCALING
C                1. ACORR # N - anisothermal correction of Fmod
C                2. ANISO = K - FSCALE with SCALEP,BSCALE
C                     if scale = 0 - scaling by Fobs (cell must be the same)
C                                    only scale , set BOVER = 0
C                     if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                    no info: rfac, corr
C                   else  CALL PSCALE
C                   output: SCALEP_NEW,BSCALE_NEW and NAMEFM2
c     else no scaling
C     output NAMEFM2,NAMEPH and SCALEP,BSCALE (aniso # 0)
C ---------------------------------------------------------
      IF(IERR.NE.0) THEN
         CALL MSGERR(MDOC,' ERR: in RF_PRECALC_MOD')
        GO TO 900
      ENDIF
      IF(ANISO.EQ.'N') ANISO = 'K'
      WRITE(LINE,'(''Scale,Bscale     :'',2F8.2)') 
     * SCALEP,BSCALE
      CALL MSGDOC(MD,LINE)
C ------------
      CALL MSGDOC(MD0,'--- rfcoef for model ---')
 
      IF(SUM.NE.'Y') THEN
        NAME = NAMEAM
      ELSE
        NAME = NAMEA1
      ENDIF

      LMAX  = LMAXR
      LMIN  = LMINR

      NSYMZ = 0
      NAMES = ' '
      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC  

      RESMAX = RESMAX_FIRST 
      RESLIM = 0.0

      CALL RFCOEF_100(MMM,NAMEFM2,NAME,NAMES,BOFF,BADD,LMAX,LMIN,NSYMZ
     *    ,RESMIN,RESMAX,RESLIM,ARAD,SHR,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
         CALL MSGERR(MDOC,' ERR: in  RFCOEF_100')
        GO TO 900
      ENDIF
C ---
      WRITE(LINE,'(''Sol_ Lmin,Lmax               :'',2I5)') 
     * LMINR,LMAX
      CALL MSGDOC(MD,LINE)
C -------------------------------------------------
      IF(SUM.NE.'Y') THEN
        GO TO 500
      ENDIF
C -------------------------------------------------
      CALL MSGDOC(MD0,'--- rotated model / angles: 0,90,0/ ---')
      ALPHA =  0.0
      BETA  = 90.0
      GAMMA =  0.0

      IZMIN    = 0
      IZMAX    =-1
      IMOD = 1

      ANISO2 = 'N'

      RESMAX = RESMAX_FIRST 

      CALL RF_PRECALC_MOD(M,LIST,NAMEM,NAMEC,NAMED
     * ,NAMEFFM,NAMEFM2,NAMEPH,PATH_SCR
     * ,MOD1,IMOD,ANISO2,NXMIN,NYMIN,NZMIN
     * ,IZMIN,IZMAX,NMR,N_MODEL,TEST,SCALEP,BSCALE,ACORR
     * ,BOFF_SCL,BADD_SCL,RESMIN,RESMAX
     * ,MODE_GD,BADD_GD,RAD_GD,NEL,SURF
     * ,RLATT,ALPHA,BETA,GAMMA 
     * ,RESULT,RESULTA,IPRMAX,IPRROW
     * ,ISYM,IPRSYM,IERR)
C ------------------------------------------------------------
C 1) if MOD1=D DENS2F_DNS else DENS2F_NEW
C 2) if ANISO # 0 MR_SCALING
C                1. ACORR # N - anisothermal correction of Fmod
C                2. ANISO = K - FSCALE with SCALEP,BSCALE
C                     if scale = 0 - scaling by Fobs (cell must be the same)
C                                    only scale , set BOVER = 0
C                     if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                    no info: rfac, corr
C                   else  CALL PSCALE
C                   output: SCALEP_NEW,BSCALE_NEW and NAMEFM2
c     else no scaling
C     output NAMEFM2,NAMEPH and SCALEP,BSCALE (aniso # 0)
C ---------------------------------------------------------
      IF(IERR.NE.0) GO TO 900
C ---
      CALL MSGDOC(MD0,'--- rfcoef for model ---')
   
      LMAX  = LMAXR
      LMIN  = LMINR
      NSYMZ = 0
      NAMES = ' '

      RESMAX = RESMAX_FIRST 

      CALL RFCOEF_100(M,NAMEFM2,NAMEA4,NAMES,BOFF,BADD,LMAX,LMIN,NSYMZ
     *    ,RESMIN,RESMAX,RESLIM,ARAD,SHR,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900

C --------------------------------------------
      CALL MSGDOC(MD0,'--- rotated model / angles: 90,90,-90/ ---')

      ALPHA  = 90.0
      BETA   = 90.0
      GAMMA  =-90.0

      IZMIN    = 0
      IZMAX    =-1
      IMOD     = 1

      ANISO2 = 'N'

      RESMAX = RESMAX_FIRST 

      CALL RF_PRECALC_MOD(M,LIST,NAMEM,NAMEC,NAMED
     * ,NAMEFFM,NAMEFM2,NAMEPH,PATH_SCR
     * ,MOD1,IMOD,ANISO2,NXMIN,NYMIN,NZMIN
     * ,IZMIN,IZMAX,NMR,N_MODEL,TEST,SCALEP,BSCALE,ACORR
     * ,BOFF_SCL,BADD_SCL,RESMIN,RESMAX
     * ,MODE_GD,BADD_GD,RAD_GD,NEL,SURF
     * ,RLATT,ALPHA,BETA,GAMMA 
     * ,RESULT,RESULTA,IPRMAX,IPRROW
     * ,ISYM,IPRSYM,IERR)
C ------------------------------------------------------------
C 1) if MOD1=D DENS2F_DNS else DENS2F_NEW
C 2) if ANISO # 0 MR_SCALING
C                1. ACORR # N - anisothermal correction of Fmod
C                2. ANISO = K - FSCALE with SCALEP,BSCALE
C                     if scale = 0 - scaling by Fobs (cell must be the same)
C                                    only scale , set BOVER = 0
C                     if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                    no info: rfac, corr
C                   else  CALL PSCALE
C                   output: SCALEP_NEW,BSCALE_NEW and NAMEFM2
c     else no scaling
C     output NAMEFM2,NAMEPH and SCALEP,BSCALE (aniso # 0)
C ---------------------------------------------------------
      IF(IERR.NE.0) GO TO 900
C ---
C ----
      CALL MSGDOC(MD0,'--- rfcoef for model ---')
   
      LMAX  = LMAXR
      LMIN  = LMINR
      NSYMZ = 0
      NAMES = ' '

      RESMAX = RESMAX_FIRST 

      CALL RFCOEF_100(M,NAMEFM2,NAMEA5,NAMES,BOFF,BADD,LMAX,LMIN,NSYMZ
     *    ,RESMIN,RESMAX,RESLIM,ARAD,SHR,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: in RFCOEF_100')
        GO TO 900
      ENDIF

C -------------------------------------------------

      ALPHA  = 180.0
      BETA   =  90.0
      GAMMA  = 180.0
      LMAXRR = 0
      LMINRR = 0
      CALL RFROT(M,NAMEA4,NAMEA2,ALPHA,BETA,GAMMA
     * ,LMINRR,LMAXRR,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900

      SCALE=1.0
      CALL RFADD(M,NAMEA1,NAMEA2,NAMEA4,SCALE
     * ,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900

      ALPHA  = 270.0
      BETA   =  90.0
      GAMMA  =  90.0
      LMAXRR = 0
      LMINRR = 0
      CALL RFROT(M,NAMEA5,NAMEA3,ALPHA,BETA,GAMMA
     * ,LMINRR,LMAXRR,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900


      SCALE = 1.0
      NAME  = NAMEAM

      CALL RFADD(M,NAMEA3,NAMEA4,NAME,SCALE
     * ,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900

C =======================================================

 500  CONTINUE

      CALL MSGDOC(MD0,'--- rfcoef for Fobs ---')
      LMAX  = LMAXR
      LMIN  = LMINR
      NSYMZ = 0
     
      IF(PST.EQ.'Y'.OR.LOCK.NE.'N') THEN
        NSYMZ = 1
      ENDIF
      NAMES = ' '
      NAME  = NAMEA
      IF(LOCK.NE.'N') NAME = NAMEA6 

      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC 
      NAME_RF = NAMEFFM 
      IF(LH_LH.NE.'N') NAME_RF = FILE_FOBS_LH 

C     fobs_flag
      IERR = 1

      IF(DIFF.EQ.'P'.OR.DIFF.EQ.'M') THEN
        NAME_RF = NAMEFFM 
        IERR = 0
      ENDIF

      RESMAX = RESMAX_FIRST 

      CALL RFCOEF_100(MMM,NAME_RF,NAME,NAMES,BOFF,BADD,LMAX,LMIN,NSYMZ
     *    ,RESMIN,RESMAX,RESLIM,ARAD,SHR,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: in RFCOEF_100')
        GO TO 900
      ENDIF
C ------
      IF(FUN.NE.'R') THEN
        CALL MSGDOC(MD,'--- self rotation function ---')
        MMM =MD
        RMS_INPUT_T = RMS_INPUT
        NPEAK_T = NPEAK
        IF(LOCK.EQ.'G') THEN
          RMS_INPUT_T = 0.1
          NPEAK_T = IPRMAX
        ENDIF
        IRMS = 0
        CALL CALC_SRF(MMM,LIST,NAME,NAMED,NCS,IRMS
     *    ,LMINR,RMS_INPUT_T,NPEAK_T,DLIM_RF,RESMAX,RAD,SIG_SRF
     *    ,RESULTB,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN 
          CALL MSGERR(MDOC,' ERR: in CALC_SRF ')
          GO TO 900
        ENDIF

        CH1 = SELF
        ILOCK = 1
        NP_SRF_IN = NP_SRF
        IF(LOCK.EQ.'G') CH1 = 'N'
        IF(LOCK.EQ.'Y') THEN
          CALL LENSTR_BL(NAME_TSRF,LEN) 
          IF(LEN.LE.0) THEN
            ILOCK = 0
            IF(NP_SRF_IN.LE.0) ILOCK = -1 
            CH1 = 'A'
          ENDIF
        ENDIF
        CALL CALC_NCS_FOR_SELF(MDOC,CH1,NCS
     *   ,NP_SRF,NP_OUT
     *   ,NAME_TSRF,PATH_OUT,PATH_SCR
     *   ,RESULTB,IPRMAX,IPRROW,IERR)
        IERR = 0

        IF(SELF.EQ.'A'.AND.NCS.GT.0) NP_SRF =-NP_OUT
        IF(NCS.LE.0) THEN
          NCS = 1
        ENDIF

C        NP = RESULTB(1,12) 
C        IF(NCS.GE.NP) NCS = 1

        WRITE(LINE,'(A,I6)') 
     *   ' NCS (from Self rotation Function):',NCS
        CALL MSGDOC(MDOC,LINE)
C --
        CALL MSGDOC(MD,'--- model self rotation function ---')
        IRMS = 0
        RMS_INPUT_T = RMS_INPUT
        NPEAK_T = NPEAK
        IF(NPEAK_T.GT.30) NPEAK_T = 30
        CALL CALC_SRF(MD,LIST,NAMEAM,NAMED,NCS,IRMS
     *   ,LMINR,RMS_INPUT_T,NPEAK_T,DLIM_RF,RESMAX,RAD,SIG_SRF
     *   ,RESULTA,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN 
          CALL MSGERR(MDOC,' ERR: in CALC_SRF ')
          GO TO 900
        ENDIF

        CH1 = 'N'

        CALL CALC_NCS_FOR_SELF(MDOC,CH1,NCS
     *   ,NP_SRF_IN,NP_OUT
     *   ,NAME_TSRF,PATH_OUT,PATH_SCR
     *   ,RESULTA,IPRMAX,IPRROW,IERR)
        IERR = 0
        IF(NCS.LE.0) NCS = 1

C        NP = RESULTA(1,12) 
C        IF(NCS.GE.NP) NCS = 1

        WRITE(LINE,'(A,I6)') 
     *   ' NCS_model (from Model Self rotation Function):',NCS
        CALL MSGDOC(MDOC,LINE)

        IF(NCS_MODEL.LE.0) NCS_MODEL = NCS
      
        WRITE(LINE,'(A,I6)') 
     *   ' Program will use NCS_model =:',NCS_MODEL
        CALL MSGDOC(MDOC,LINE)
      ENDIF
c --------
C      CALL MSGDOC(MD0,'--- rfres ---')
      BETMIN = 0.0
      BETMAX = 0.0
      BETDEL = 0.0
      LMAX   = 0

c      LMAX   = 58
c      IF(SUM.EQ.'Y')  LMAX   = 50
      LMAX   = 98
      IF(SUM.EQ.'Y')  LMAX   = 90

      LMIN   = LMINR
C ---
      IF(LOCK.EQ.'Y') THEN
        MMM = MDOC
        IF(ILOCK.LE.0) MMM = M
        IF(LIST.EQ.'T') MMM = MDOC
        NP_SRFA =ABS(NP_SRF)
        CALL CROSSRF_LOCK(MMM,NAMEA6,NAMEA,NP_SRFA,NAME_TSRF,PATH_SCR
     *   ,ILOCK,RESULT,IPRMAX,IPRROW,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: in CROSSRF_LOCK')
          GO TO 900
        ENDIF
      ELSE IF(LOCK.EQ.'G') THEN
        MMM = MD
        IF(LIST.EQ.'T') MMM = MDOC
        MMM = MDOC
        CALL CROSSRF_LOCK_G(Mdoc,NAMEA6,NAMEA,NP_SRF,NAME_TSRF,PATH_SCR
     *   ,RESULTB,IPRMAX,IPRROW,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: in CROSSRF_LOCK')
          GO TO 900
        ENDIF
      ENDIF

      CALL MSGDOC(MD,'--- Cross Rotation Function ---')

      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC  
      CALL RFRES_100_3D(MMM,NAMEA,NAMEAM,NAMED,BETMIN,BETMAX,BETDEL
     *  ,RF_MAX,LMAX,LMIN,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: in RFRES_100')
        GO TO 900
      ENDIF
C ------------
C      CALL MSGDOC(MD0,'--- peaksrch ---')

      ALEVEL   = 0.0
      IF(RMS_INPUT.GT.0.000001) ALEVEL = RMS_INPUT
      NAME     = ' '

      NPMAX  = NPEAK
      NP_LIM = NPEAK 
      IF(NPEAK_MAX.GT.0) THEN
        NCSM = NCS_MODEL
        IF(NCSM.LE.1) NCSM = 0
        NPMAX = NPEAK_MAX + NCSM
        IF(NPMAX.GT.IPRMAX) NPMAX = IPRMAX
        NP_LIM = NPEAK + NCSM 
        IF(NP_LIM.GT.IPRMAX) NP_LIM = IPRMAX
      ENDIF

      NP_RF = NPMAX

      IF(ABS(NREFR).GT.0.AND.ABS(NREFR).GT.NP_RF) THEN
        NP_RF = ABS(NREFR)
      ENDIF

      DIST_LIM = 0.0
      IF(DLIM_RF.GT.0.00001) DIST_LIM = DLIM_RF  

      SPEC     = 'Y'
      PROG     = 'CROS'
c     IF(LIST.EQ.'T'.OR.LIST.EQ.'L') PROG = 'CRSL'
      PROG = 'CRSL'
c     IF(FUN.EQ.'R') SPEC = 'S'
      SPEC = 'S'

      MDOC_PSRCH = MDOC

      CALL PEAKSRCH_RF(MDOC_PSRCH,NAMED,NAME,ALEVEL,DIST_LIM,SPEC
     *  ,NP_RF,NP_LIM,PROG,RESMAX,RAD,NP_SRF,NAME_TSRF,DELTA,NCS
     *  ,ISYM,IPRSYM,RESULT,RESULTA,IPRMAX,IPRROW,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: in  PEAKSRCH_RF')
        GO TO 900
      ENDIF
      NP = RESULT(1,12) 
      IF(NP.LE.0.0) GO TO 900       

      II = 0
      DO I=1,NP
        SG     = RESULT(I,5)
        IF(SG.GE.0.0) THEN
          II = II + 1
          DO K=1,IPRROW
            RESULT(II,K) = RESULT(I,K)
          ENDDO
        ENDIF
      ENDDO
      RESULT(1,12) = II
      NP = II
      IF(NP.LE.0.0) GO TO 900       

      IF(LIST.NE.'T') THEN
        IF(NP.GT.NPEAK.AND.NPEAK_MAX.LE.0) NP = NPEAK
      ENDIF

C ------------------
C  RESULT(i,1) IX 
C  RESULT(i,2) IY
C  RESULT(i,3) IZ
C  RESULT(i,4) Dens
C  RESULT(i,5) sigma
C  RESULT(i,6) alpha      Xort
C  RESULT(i,7) beta   or  Yort
C  RESULT(i,8) gamma      Zort
C  RESULT(i,9)  Xfrac
C  RESULT(i,10) Yfrac
C  RESULT(i,11) Zfrac
C  RESULT(1,12)  number of peaks
C -------------------
      IF(ABS(NREFR).GT.0) THEN
 
        IF(NREFR.LT.0) THEN
          NRRR = 0
        ELSE
          NRRR = ABS(NREFR)
        ENDIF

        CALL TRFUN_R(MDOC_PSRCH,NAMEF,NAMEM,PATH_SCR,NRRR
     * ,RESN,RESX,BOFF,BADD,BOFF_SCL,BADD_SCL,ANISO_I,LIST
     * ,ISYM,IPRSYM
     * ,RESULT,RESULTA,IPRMAX,IPRROW,IERR)
       IF(IERR.NE.0) GO TO 900


      ENDIF
C ----
      IOUT = 11
C     NAME = 'molrep_rf.tab'
      NAME = NAME_TAB
      PATH = ' '
      EXT  = ' '
      CALL OPENFW(IOUT,M,PATH,NAME,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: can not open file NAME_TAB'
        CALL MSGERR(MD,LINE)
        GO TO 900
      ENDIF
C                                                                       
      LINE = '#Sol_         theta    phi    chi'//
     *   '   alpha   beta   gamma'//'         Rf'//'   Rf/sigma'
      CALL LENSTR_BL(LINE,LEN)
C
      WRITE(IOUT,'(A)') LINE(1:LEN)    

      DO I=1,NP
        PK     = RESULT(I,4)
        SG     = RESULT(I,5)
c       SIG    = PK/SG
        ALPHA  = RESULT(I,6)
        BETA   = RESULT(I,7)
        GAMMA  = RESULT(I,8)

        ALP    = (ALPHA*PI)/180.0
        BET    = (BETA *PI)/180.0
        GAM    = (GAMMA*PI)/180.0

        CALL EULERM(ALP,BET,GAM,AM)
        CALL MTOPOL(AM,THETA,PHI,CHI)

        WRITE(LINE,200) I,THETA,PHI,CHI,ALPHA,BETA,GAMMA
     *      ,PK,SG
 200    FORMAT('Sol_RF',1X,I3,1X,6F8.2,G14.4,F6.2)
C                  4     24   1    24      26
C                     29                  50
C     123 123456781234567812345678123456781234567812345678123456789 1234123456
Col_RF  1   163.75    0.00   16.25    0.00    0.00 -180.00     535.0     25.31
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)') LINE(1:LEN)    

      ENDDO
      END FILE IOUT
      CLOSE(IOUT)

      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     *       '    --- Peaks of Rotation Function ---')
      LINE = '+------------------------------------------+'
      CALL MSGDOC(MDOC,LINE)
      LINE = '|         theta    phi      chi   Rf/sigma |'
      CALL MSGDOC(MDOC,LINE)
      LINE = '+------------------------------------------+'
      CALL MSGDOC(MDOC,LINE)

      DO I=1,NP
        PK     = RESULT(I,4)
        SG     = RESULT(I,5)
c       SIG    = PK/SG
        ALPHA  = RESULT(I,6)
        BETA   = RESULT(I,7)
        GAMMA  = RESULT(I,8)

        ALP    = (ALPHA*PI)/180.0
        BET    = (BETA *PI)/180.0
        GAM    = (GAMMA*PI)/180.0

        CALL EULERM(ALP,BET,GAM,AM)
        CALL MTOPOL(AM,THETA,PHI,CHI)

        WRITE(LINE,203) I,THETA,PHI,CHI,SG
 203    FORMAT('| ',1X,I3,1X,3F8.2,3X,F8.2,' |')
        CALL MSGDOC(MDOC,LINE)
      ENDDO
      LINE = '+------------------------------------------+'
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' ')
      LINE = 'INFO:    Relations between peaks see in molrep.doc'
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' ')
C -------------------------------------------------
      IF(NREFR.GT.0) THEN
        LINE = 'INFO:  Peaks will be used'
        CALL MSGDOC(MDOC,LINE)
        LINE = '#Sol_         theta    phi    chi'//
     *  '     alpha   beta   gamma'//'   Rf/sigma'
        CALL MSGDOC(MDOC,LINE)

        DO I=1,NP
          PK     = RESULT(I,4)
          SG     = RESULT(I,5)
c         SIG    = PK/SG
          ALPHA  = RESULT(I,6)
          BETA   = RESULT(I,7)
          GAMMA  = RESULT(I,8)

          ALP    = (ALPHA*PI)/180.0
          BET    = (BETA *PI)/180.0
          GAM    = (GAMMA*PI)/180.0

          CALL EULERM(ALP,BET,GAM,AM)
          CALL MTOPOL(AM,THETA,PHI,CHI)

          IRF = RESULT(I,13)

          WRITE(LINE,201) I,THETA,PHI,CHI
     *      ,SG,IRF
 201      FORMAT('Sol_RF',1X,I3,1X,3F8.2,F6.2,I4)
          CALL MSGDOC(MDOC,LINE)
        ENDDO
      ENDIF
C  ----
      IF(NREFR.LE.0.AND.NPEAK_MAX.GT.0) THEN

        IF(NP.GT.1) THEN
          DO I=1,NP-1
            IRF2 = ABS(RESULT(I,25))
            IF(RESULT(I,25).LE.0.0) THEN
              DO J=I+1,NP
                JRF2 = RESULT(J,25)
                IF(JRF2.EQ.IRF2) RESULT(J,25) = I
              ENDDO
              RESULT(I,25) = 0.0
            ENDIF
          ENDDO
          IF(RESULT(NP,25).LE.0.0) RESULT(NP,25) = 0.0
          NMAX = 0
          IMAX = 0
          DO I=1,NP-1
            IF(RESULT(I,25).LE.0.0) THEN
              N = 0
              DO J=I+1,NP
                JRF2 = RESULT(J,25)
                IF(JRF2.EQ.I) N = N + 1
              ENDDO
              RESULT(I,26) = N
              IF(N.GT.NMAX) THEN
                NMAX = N
                IMAX = I
              ENDIF
            ENDIF
          ENDDO
        ENDIF

        MMM = MD
c        MMM = MDOC

        LINE = 'INFO:  Peaks will be used'
        CALL MSGDOC(MMM,LINE)
        LINE = '#Sol_         theta    phi    chi'//
     *  '   Rf/sigma  similar '
        CALL MSGDOC(MMM,LINE)

        DO I=1,NP
          PK     = RESULT(I,4)
          SG     = RESULT(I,5)
          ALPHA  = RESULT(I,6)
          BETA   = RESULT(I,7)
          GAMMA  = RESULT(I,8)
          ALP    = (ALPHA*PI)/180.0
          BET    = (BETA *PI)/180.0
          GAM    = (GAMMA*PI)/180.0
          CALL EULERM(ALP,BET,GAM,AM)
          CALL MTOPOL(AM,THETA,PHI,CHI)

          IRF  = RESULT(I,22)
          IS   = RESULT(I,23)
          JS   = RESULT(I,24)
          IRF2 = RESULT(I,25)
          IS2  = RESULT(I,26)
          JS2  = RESULT(I,27)
          WRITE(LINE,202) I,THETA,PHI,CHI
     *      ,SG,IRF2,IS2,JS2
 202      FORMAT('Sol_RF',1X,I3,1X,3F8.2,F6.2,5X,I4,5X,2I4)
          CALL MSGDOC(MMM,LINE)
        ENDDO
      ENDIF
C -------------------------------------------------
  900 CONTINUE
C ---

      NAME='crossrt_scr.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_scr1.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_al1.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_al2.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_al3.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_al4.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_al5.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_f.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_fsc.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_ph.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_scr.crd'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_scr1.crd'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_dns1.crd'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_al6.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)

C ---  
      LH_LH = LH_STOR
      RETURN
      END

      SUBROUTINE CALC_NCS_FOR_SELF(MDOC,SELF,NCS
     * ,NP_SRF,NP_OUT
     * ,NAME_TSRF,PATH_OUT,PATH_SCR
     * ,RESULTA,IPRMAX,IPRROW,IERR)
C -------------------------------------------
      CHARACTER PATH_OUT*(*),PATH_SCR*(*)
      CHARACTER NAME_TSRF*(*),SELF*1
      REAL      RESULTA(IPRMAX,IPRROW),AM(3,3)
      CHARACTER LINE*256,PATH*1,EXT*1
C -------------------------------------------
      IERR  = 0
      PI    = 4.0*ATAN(1.0)
      MD    = -ABS(MDOC)-1
      M     = 99
C ----
      NCS = 0
      NP_OUT = 0
      NP  = RESULTA(1,12) 
      IF(NP.LE.2) GO TO 900   
      N   = 0
      SUM = 0.0
      DO I=1,NP
        PK     = RESULTA(I,4)
        SG     = RESULTA(I,5)
        SUM = SUM + SG
        N   = N + 1
      ENDDO
      SUM = SUM/REAL(N)
      SUM = SUM*1.1

      DO I=2,NP
        PK     = RESULTA(I,4)
        SG     = RESULTA(I,5)
        IF(SG.GT.SUM) NCS = NCS + 1
      ENDDO

c      IF(NCS.LE.0) GO TO 900 
      NCS_OUT =  NCS
      IF(NCS.LE.0) THEN
        NCS_OUT = 1
      ENDIF
      IF(SELF.EQ.'A') THEN
        NAME_TSRF = 'molrep_srf.tab'
        CALL ADD_PATH(PATH_SCR,NAME_TSRF)
        PATH = ' '
        EXT  = ' '
        IOUT = 11
        CALL OPENFW(IOUT,M,PATH,NAME_TSRF,EXT,IERR)
        IF(IERR.NE.0) GO TO 900
C      
        NPP = NCS_OUT + 1                                                                *
        IF(ABS(NP_SRF).GT.0.AND.ABS(NP_SRF).LT.NP) THEN
          NPP = ABS(NP_SRF) + 1
        ENDIF
        NP_OUT = NPP - 1
        DO I=2,NPP
          PK     = RESULTA(I,4)
          SG     = RESULTA(I,5)
c         SIG    = PK/SG
          ALPHA  = RESULTA(I,6)
          BETA   = RESULTA(I,7)
          GAMMA  = RESULTA(I,8)
          ALP    = (ALPHA*PI)/180.0
          BET    = (BETA *PI)/180.0
          GAM    = (GAMMA*PI)/180.0

          CALL EULERM(ALP,BET,GAM,AM)
          CALL MTOPOL(AM,THETA,PHI,CHI)
          WRITE(IOUT,200) I,THETA,PHI,CHI,ALPHA,BETA,GAMMA
     *      ,PK,SG
 200      FORMAT('Sol_RF',I4,1X,6F8.2,G14.4,F6.2)

        ENDDO
        END FILE IOUT
        CLOSE(IOUT)
      ENDIF
      RETURN
C ---
  900 CONTINUE
      NCS = 0
      RETURN
      END


      SUBROUTINE CROSSROT_PH(MDOC
     * ,NAMEF,NAMEM,NAME_PH,NAME_DIFF,NAME_TAB
     * ,PATH_SCR,NAME_TAB2,NPEAK2,NCS_ID
     * ,ANGLES_NCS_INP,CENTRE_NCS
     * ,RESN,RESX,PARM_RF,NPEAK,NPT_DM,CHI_IN,COEF_IN,BLIM
     * ,BOFF,BADD,BOFF_SCL,BADD_SCL,ARAD,LMIN_INP,LMAX_INP
     * ,RMS_INPUT,ISYM,IPRSYM
     * ,RESULT,RESULT2,RESULTA,IPRMAX,IPRROW,IERR)
C --------------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
C ----
C                      IPRMAX - MAX. NUMBER OF PEAKS
      REAL      RESULT (IPRMAX,IPRROW)
      REAL      RESULT2(IPRMAX,IPRROW)
C      REAL      RESULTA(21,21)
      REAL      RESULTA(IPRMAX,IPRROW)

C     PARAMETER ( IPRMAX3 =   200 )
      PARAMETER ( IPRMAX3 =  2000 )
      PARAMETER ( IPRROW3 =    21 )
      REAL      RESULT3(IPRMAX3,IPRROW3)
      REAL      RESULT4(IPRMAX3,IPRROW3)
C--
      PARAMETER ( IPRCOEF = 15000 )
      PARAMETER ( IPRIND1 =    61 )
      PARAMETER ( IPRIND2 =    30 )
      PARAMETER ( IPRIND3 =    61 )
      PARAMETER ( IPRNMAX =    61 )
C --
      PARAMETER ( IPRDOM = 300 )
      REAL      ANGLES_NCS(3,IPRDOM)
      REAL      ANGLES_NCS_INP(3),CENTRE_NCS(3)
      REAL      SH3(3),V(3),V1(3),V2(3)      
C ---
      CHARACTER NAMEF*(*),NAMEM*(*),NAME_PH*(*),SUM*1,PRF*1,DIFF*1
      CHARACTER NAME_TAB*(*),NAME_DIFF*(*),PATH_SCR*(*)
      CHARACTER NAME_TAB2*(*)
      CHARACTER NAMEA*256,NAMEAM*256,NAMEC*256,NAMES*256,NAMEC2*256
      CHARACTER NAME*256,NAMED*256,NAMEFM*256,NAMEPH*256,NAMEFM2*256
      CHARACTER NAMEA1*256,NAMEA2*256,NAMEA3*256,NAMEA4*256
      CHARACTER NAMEA5*256

      CHARACTER NAMEFFM*256

      CHARACTER LINE*256,TTT*80,ITYPE*4,P1*1,MODE*1,WAT*1,ALT*1,PST*1
      CHARACTER REST*1,SETT*1,HATM*1,NUM*1,NOCC*1,MISS*1,RFAC_FLAG*1
      CHARACTER FUN*1,PATH*80,EXT*80,MODE_GD*1,TEST*1,LIST*1
      CHARACTER F0*1,LAP*1,MSGA*1,SURF*1,MOD1*1,ACORR*1
      REAL      AM(3,3),SH1(3),SH2(3),SHR(3),FSH_MOD(3),FSH_OBS(3)
      REAL      RLATT(6),RF_MAX(4)
      INTEGER*4 NSPGROUP,NOSETT
      CHARACTER CODE*4,NAMET*40,DATE*9,SPGR*24,SOLV*1,PATT*1,SELF*1 
      CHARACTER TITLE*80,MODE_F*1,STOP_T*1,SPEC*1,CONV*1,ANISO*1
      CHARACTER INVER*1,PARM_RF*16,ANISO_I*1,ANISO_CORR*1,ANISO2*1
C -------------------------------------------------------------
      INCLUDE 'molrep_lh_infor.fh'
C      COMMON/COM_LH_INFOR/ BOFF_LH,BADD_LH,BOFF_FOR_SCAL
C     *   ,CHECK_CONTRAST,CONTRAST_LIM
C     *   ,BCORR_LH,FILE_FOBS_LH,SCORE_FLAG,LH_LH,DB_LH
CC ---
C      REAL      CHECK_CONTRAST,CONTRAST_LIM
C      REAL      BOFF_FOR_SCAL,BOFF_LH,BADD_LH,BCORR_LH
C      CHARACTER LH_LH*1,SCORE_FLAG*1,DB_LH*1
C      CHARACTER FILE_FOBS_LH*256
C ----------------------------------
      CHARACTER TIME_CURRENT*15,TIME_ELAPSED*15,TIME_EXPECTED*15
C -------------------------------------------------------------
      PI    = 4.0*ATAN(1.0)
      MD    = -ABS(MDOC)-1
      M     = 99
      MD0   =  0
      IF(ABS(MDOC).GE.99) MD0 = 99
      TWOPI = 2.0*PI
C ---
      MDOC_PSRCH = MDOC
      NMR        = 0
      N_MODEL    = 1

C ---
      SUM   = PARM_RF( 1: 1)
      ANISO_I = PARM_RF( 2: 2) 
      SELF  = PARM_RF( 3: 3)
      PST   = PARM_RF( 4: 4) 
      FUN   = PARM_RF( 5: 5)
      TEST  = PARM_RF( 6: 6) 
      LIST  = PARM_RF( 7: 7) 
      DIFF  = PARM_RF( 8: 8) 
      SURF  = PARM_RF( 9: 9) 
      PRF   = PARM_RF(10:10) 
      MOD1  = PARM_RF(11:11) 
      INVER = PARM_RF(12:12) 
      ANISO_CORR = PARM_RF(14:14)
C ----
      IF(LIST.EQ.'S') THEN
        MD = 99
      ELSE IF(LIST.EQ.'T') THEN
        MD = MDOC
        M  = MDOC
      ENDIF

      DO I=1,IPRMAX3
      DO J=1,IPRROW3
        RESULT3(I,J) = 0.0
        RESULT4(I,J) = 0.0
      ENDDO
      ENDDO

      IF(TEST.EQ.'F') THEN
        MODE_GD  = 'S'
        BADD_GD  = BLIM + 0.00001
        RAD_GD   = 2.8
      ELSE
        MODE_GD  = ' '
        IF(SURF.EQ.'C') MODE_GD = 'C'
        BADD_GD  = 0.0
        RAD_GD   = 0.0
        IF(SURF.EQ.'Y'.OR.SURF.EQ.'C') THEN
          RAD_GD  = BLIM + 0.000001
        ENDIF
      ENDIF
C ---
      CODE     = ' '
      NAMET    = ' '
      DATE     = ' '
      SPGR     = 'P 1'
      NSPGROUP = 1
      NOSETT   = 1
      TITLE    = ' '

      IF(SUM  .EQ.'y')  SUM   = 'Y'
      IF(SUM  .NE.'Y')  SUM   = 'N'
      IF(ANISO_I.EQ.'y')  ANISO_I = 'Y'
      IF(ANISO_I.EQ.'k')  ANISO_I = 'K'
      IF(ANISO_I.NE.'Y'.AND.ANISO_I.NE.'K')  ANISO_I = 'N'
      ANISO = ANISO_I
      IF(NPT_DM.EQ.0) NPT_DM = 100
      IF(NPT_DM.GT.IPRMAX3) NPT_DM = IPRMAX3
C --------------------------------------------------------------
      IERR  = 0
      MTN   = 10
      ITYPE = 'FF  '
      CALL ORFILE(M,MTN,NAMEF,ITYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN INPUT-FILE-FOBS')
        RETURN
      ENDIF

      CALL C_RD_CR

      CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *  ,F1,F2,RESMIN,RESMAX,IDM,IDM,IDM,IDM,IDM,TTT,IERR)
      CLOSE(MTN)
C -------------------------------------------------------------

      IF(RESX.LT.0.00001) RESX = 3.0
      IF(RESX.GT.0.00001) RESMAX=RESX
      IF(RESN.GT.0.00001.AND.RESN.LT.RESMIN) RESMIN=RESN
      IF(RESMIN.LT.RESMAX) THEN
        T      = RESMIN
        RESMIN = RESMAX
        RESMAX = T
      ENDIF
      IF(RESMIN.EQ.RESMAX) THEN
        CALL MSGERR(MDOC,' ERR: resmin = resmax')
        IERR=1
        RETURN
      ENDIF
C --------------------------------------------------------------
      NAME    = ' '
      NAMES   = ' '
      NAMEA   = 'crossrot_alo'
      CALL ADD_PATH(PATH_SCR,NAMEA)
      NAMEA1  = 'crossrt_al1'
      CALL ADD_PATH(PATH_SCR,NAMEA1)
      NAMEA2  = 'crossrt_al2'
      CALL ADD_PATH(PATH_SCR,NAMEA2)
      NAMEA3  = 'crossrt_al3'
      CALL ADD_PATH(PATH_SCR,NAMEA3)
      NAMEA4  = 'crossrt_al4'
      CALL ADD_PATH(PATH_SCR,NAMEA4)
      NAMEA5  = 'crossrt_al5'
      CALL ADD_PATH(PATH_SCR,NAMEA5)
      NAMEAM  = 'crossrot_alm'
      CALL ADD_PATH(PATH_SCR,NAMEAM)
      NAMEC   = 'crossrt_scr'
      CALL ADD_PATH(PATH_SCR,NAMEC)
      NAMEC2  = 'crossrt_scr1'
      CALL ADD_PATH(PATH_SCR,NAMEC2)
      NAMED   = 'crossrot_dns'
      CALL ADD_PATH(PATH_SCR,NAMED)
      NAMEFM  = 'crossrt_f'
      CALL ADD_PATH(PATH_SCR,NAMEFM)
      NAMEFM2 = 'crossrt_fsc'
      CALL ADD_PATH(PATH_SCR,NAMEFM2)
      NAMEPH  = 'crossrt_ph'
      CALL ADD_PATH(PATH_SCR,NAMEPH)

      NAMEFFM = 'crossrot_ff'
      CALL ADD_PATH(PATH_SCR,NAMEFFM)
C -----------------
      CALL LENSTR_BL(NAME_PH,LEN)
      IF(LEN.GT.0.AND.NAME_PH(1:1).NE.' '.AND.NAME_PH(1:1).NE.',') THEN
        IF(PRF.EQ.'N') THEN
          LINE = ' ERROR: file of phases and PRF:'//PRF
          CALL MSGERR(MDOC,LINE)
          IERR = 1
          RETURN
        ENDIF
      ENDIF
      DO I=1,3
        FSH_MOD(I) = 0.0
        FSH_OBS(I) = 0.0
      ENDDO
C ==========================================
C ----
C     CALL MSGDOC(MD0,'--- read coordinates of model ---')
C ---
C     difine max. radius and coord limits, centre
      IERR = 0
      CALL DEF_RAD(M,MOD1,NAMEM,RESULT,ISYM,IPRSYM,IERR)
C       RADIUS_MAX = RESULT(1,1)
C       ZMIN       = RESULT(6,1) 
C       ZMAX       = RESULT(7,1)
C       XS = RESULT( 8,1) 
C       YS = RESULT( 9,1) in A
C       ZS = RESULT(10,1) 
C       RESULT(11)= RI
C       RESULT(12)= MODEL
C       RESULT(13)= NMODEL
      IF(IERR.NE.0) GO TO 900
      ARADI = RESULT(11,1)
      XS    = RESULT( 8,1) 
      YS    = RESULT( 9,1) 
      ZS    = RESULT(10,1) 
C -----------------------------
      IUSER = 1
      IF(ARAD.LT.0.0001) THEN
        IUSER = 0
        ARAD = ARADI * 1.0
        IF(SURF.EQ.'A') ARAD = ARADI * 1.03   
      ENDIF

      IF(ARAD.GT.A) ARAD = A
      IF(ARAD.GT.B) ARAD = B
      IF(ARAD.GT.C) ARAD = C

      WRITE(LINE,'('' Radius of gyration          :'',F8.2)') ARADI
      CALL MSGDOC(MDOC,LINE)

      IF(FUN.EQ.'T') GO TO 900
c -----
      IF(ANISO_CORR.EQ.'Y') THEN
        CALL MSGDOC(MD0,'--- anisothermal correction of Fobs ---')
        BADDD    = BADD_SCL
        BOFFF    = BOFF_SCL
        SCALE    = 1.0
        BOVER    = 0.0
        PATT     = 'Y'
        SOLV     = 'N'
        NCYCL    =  0

C        RESMNI=RESMIN
C        RESMXI=RESMAX
        RESMNI = 0.0
        RESMXI = 0.0
        
        NAME  = ' '
        ANISO2 = '-'
        CALL MR_SCALING(MDOC,LIST,NAME,NAMEF,NAMEFFM,PATH_SCR
     * ,ANISO2,SCALE,BOVER,ACORR,BOFFF,BADDD,RESMNI,RESMXI
     * ,SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF
     * ,RESULTA,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
C ---------------------------------------------------------
C     1. ACORR # N - anisothermal correction of Fmod
c        if ANISO = '-' return
C     2. ANISO = K - FSCALE with SCALEP,BSCALE
C                   if scale = 0 - scaling by Fobs (cell must be the same)
C                      only scale , set BOVER = 0
C                   if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                  no info: rfac, corr
C        else  CALL PSCALE
C      output: SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF and NAMEFM2
C ---------------------------------------------------------
      ELSE
        NAMEFFM=NAMEF
      ENDIF

c ------
C      IF(BOFF.LE.0.00001) BOFF=256.0
C      IF(BOFF.LE.0.00001) BOFF=400.0
      IF(BOFF.LE.0.00001) BOFF=900.0

      SUM = 'N'

      WRITE(LINE,'(''Sol_ Radius of integration   :'',F8.2)') 
     * ARAD
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(''Sol_ Resolution              :'',2F8.2)') 
     * RESMIN,RESMAX
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(''Sol_ Boff,Badd               :'',2F8.2)') 
     * BOFF,BADD
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,'(''Sol_ Boff_scl,Badd_scl       :'',2F8.2)') 
     * BOFF_SCL,BADD_SCL
      CALL MSGDOC(MD,LINE)

      WRITE(LINE,'('' Diff,PRF,INVER : '',A,A,A)') DIFF,PRF,INVER
      CALL MSGDOC(MD,LINE)
      CALL MSGDOC(MDOC,' ')
C ----------------------------------------------------------

      LMAXR = LMAX_INP
      LMINR = LMIN_INP

C      IF(LMIN_INP.NE.0.OR.LMAX_INP.NE.0) THEN
C        WRITE(LINE,'('' Lmin,Lmax (input)           :'',2I5)') 
C     *  LMINR,LMAXR
C        CALL MSGDOC(MDOC,LINE)
C      ENDIF

c      IPRBES = 400
      IPRBES = 600
c      RESMXT = (TWOPI*ARAD)/98.0
c      IF(RESMXT.LT.0.1) RESMXT=0.1

c      RESMXT = ARAD/(60.0/TWOPI+1.0) 
c      RESMXT = ARAD/(108.0/TWOPI+1.0) 
      RESMXT = (ARAD*TWOPI)/109.35


      IF(RESMXT.GT.RESMAX) THEN
        RESMAX = RESMXT
        CALL MSGERR(MDOC,
     *' WARNING: For this radius integration program uses data included'
     *)
        WRITE(LINE,
     *'(''          between '',F7.1,'' and '',F7.2,'' (angstrom..)'')')
     *  RESMIN,RESMAX
        CALL MSGERR(MDOC,LINE)
      ENDIF

c
c      write(*,*) ' Lmax=',lmaxr
C -----------------------------------------------------------

      RESMAX_FFT=RESMAX*0.9
      WRITE(LINE,'('' Resmax for calc Fmod:'',2F8.2)') RESMAX_FFT
      CALL MSGDOC(MD,LINE)
C ----
      CALL LIMHKL(RESMAX_FFT,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)
C ----
      CALL MSGDOC(MD,'Minimal grid spacing for calculation SF:') 
      WRITE(LINE,1000) NXMIN,NYMIN,NZMIN
 1000 FORMAT(' NXmin=',I3,', NYmin=',I3,', NZmin=',I3) 
      CALL MSGDOC(MD,LINE)

      ALPHA  = 0.0
      BETA   = 0.0
      GAMMA  = 0.0
      SCALEP = 0.0
      BSCALE = 0.0
      IF(ANISO_I.EQ.'K') ANISO = '0'
      ACORR  = 'N'
      IF(ANISO.EQ.'Y')  ACORR = 'Y'
      TEST   = ' '
      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC  

      IF(LIST.EQ.'T') THEN
        TMP1 = (AL*180.0)/PI
        TMP2 = (BE*180.0)/PI
        TMP3 = (GA*180.0)/PI
        write(LINE,'(''Fobs:Nsym:'',i5,6F10.3)') 
     *  NSYM,A,B,C,TMP1,TMP2,TMP3
        CALL MSGDOC(MDoc,LINE)
      ENDIF

      SH1(1) = XS
      SH1(2) = YS
      SH1(3) = ZS 
      CALL OTOF(SH1,SH2,IERR)
      FSH_MOD(1) = SH2(1)
      FSH_MOD(2) = SH2(2)
      FSH_MOD(3) = SH2(3)

      IF(LIST.EQ.'T') THEN
        write(line,*) 'CENTR:',XS,YS,ZS
        CALL MSGDOC(MDoc,LINE)
        write(line,*) 'sh:',sh1(1),sh1(2),sh1(3)
        CALL MSGDOC(MDoc,LINE)
        write(line,*) 'fsh:',sh2(1),sh2(2),sh2(3)
        CALL MSGDOC(MDoc,LINE)
      ENDIF

      SH2(1) = 0.0
      SH2(2) = 0.0
      SH2(3) = 0.0

      DO I=1,6
        RLATT(I) = 0.0
      ENDDO

C      RLATT(1) = A
C      RLATT(1) = B
C      RLATT(1) = C
C      RLATT(1) = AL
C      RLATT(1) = BE
C      RLATT(1) = GA

      IZMIN    = 0
      IZMAX    =-1
      IMOD     = 1
      CALL RF_PRECALC_MOD(MMM,LIST,NAMEM,NAMEC,NAMED
     * ,NAMEFFM,NAMEFM2,NAMEPH,PATH_SCR
     * ,MOD1,IMOD,ANISO,NXMIN,NYMIN,NZMIN
     * ,IZMIN,IZMAX,NMR,N_MODEL,TEST,SCALEP,BSCALE,ACORR
     * ,BOFF_SCL,BADD_SCL,RESMIN,RESMAX
     * ,MODE_GD,BADD_GD,RAD_GD,NEL,SURF
     * ,RLATT,ALPHA,BETA,GAMMA 
     * ,RESULT,RESULTA,IPRMAX,IPRROW
     * ,ISYM,IPRSYM,IERR)
C ------------------------------------------------------------
C 1) if MOD1=D DENS2F_DNS else DENS2F_NEW
C 2) if ANISO # 0 MR_SCALING
C                1. ACORR # N - anisothermal correction of Fmod
C                2. ANISO = K - FSCALE with SCALEP,BSCALE
C                     if scale = 0 - scaling by Fobs (cell must be the same)
C                                    only scale , set BOVER = 0
C                     if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                    no info: rfac, corr
C                   else  CALL PSCALE
C                   output: SCALEP_NEW,BSCALE_NEW and NAMEFM2
c     else no scaling
C     output NAMEFM2,NAMEPH and SCALEP,BSCALE (aniso # 0)
C ---------------------------------------------------------
      IF(IERR.NE.0) GO TO 900
C      IF(ANISO.EQ.'N') ANISO = 'K'

C      IF(LIST.EQ.'T') THEN
        WRITE(LINE,*) 'SCALEP,BSCALE:',SCALEP,BSCALE
        CALL MSGDOC(MD,LINE)
C      ENDIF
C -----------------      
C      CALL MSGDOC(MDOC,
C     *'--- Spherically Averaged Phased Translation Function (SAPTF) ---'
C     *)

      ISIM     = 0
      LAP      = 'N'
      FOMMIN   = 0.0
      MSGA     = 'N'
C     BOFFF    = BOFF_SCL
      BOFFF    = BOFF
      BADDD    = 0.0
      SLIM     = 0.0
      DRMS     = 0.0
      DRMS_A   = 0.0
      DEL_LIM  = 0.0
      DELA_LIM = 0.0
      SCALEF   = 1.0
      NAMES    = ' '

      IF(DIFF.EQ.'N'.OR.DIFF.EQ.'P') THEN
C
C          SCALE * F2 - F1
C                        F1     F2 
C         Fobs                                 crossrt_al3   
       MMM = M
       IF(LIST.EQ.'T') MMM = MDOC  
       CALL COEF_FFT(MMM,NAMEFFM,NAMES,NAME_PH,NAMEA3
     *         ,FOMMIN,RESMIN,RESMAX,BOFFF,SLIM
     *         ,DEL_LIM,DELA_LIM,DRMS,DRMS_A,LAP
     *         ,SCALEF,BADDD,MSGA,ISIM,ISYM,IPRSYM,RESULT,IERR)
       IF(IERR.NE.0) GO TO 900        
      ELSE
        CALL LENSTR_BL(NAME_DIFF,LEN)
        IF(LEN.LE.0.OR.NAME_DIFF(1:1).EQ.' '.OR.
     *    NAME_DIFF(1:1).EQ.',') THEN
          LINE = ' ERROR: keyword DIFF and no file of fixed model'
          CALL MSGERR(MDOC,LINE)
          IERR = 1
          RETURN
        ENDIF
        NAMEA3 = NAME_DIFF
      ENDIF
C ----
      IF(LIST.EQ.'L'.OR.LIST.EQ.'T') THEN
c       F000   = 0.0
        F000   =-1.0
        IZMIN  = 0
        IZMAX  =-1
C       IERR = 1
c       IF(IERR.EQ.1) P1 = 'Y'
        CALL FFT(MMM,NXMIN,NYMIN,NZMIN,IZMIN,IZMAX,F000,NAMEA3
     *    ,NAMED,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
C ---------
        NAME  = 'molrep_dns.ps'  
        CALL ADD_PATH(PATH_SCR,NAME)
        TITLE = '-- MAP --'      
        COEF  = COEF_IN
        IF(COEF.LE.0.0001) COEF = 2
        NLEV  = 3 

        CALL PRINT_DENS_TO_PS(MDOC,NAMED,NAME
     *  ,TITLE,COEF,NLEV,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900

      ENDIF
C ----
      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC  
c                      model                crossrt_al2          
      CALL COEF_FFT(MMM,NAMEFM2,NAMES,NAMEPH,NAMEA2
     *         ,FOMMIN,RESMIN,RESMAX,BOFFF,SLIM
     *         ,DEL_LIM,DELA_LIM,DRMS,DRMS_A,LAP
     *         ,SCALEF,BADDD,MSGA,ISIM,ISYM,IPRSYM,RESULT,IERR)
      IF(IERR.NE.0) GO TO 900

      CALL LENSTR_BL(NAME_TAB2,LEN)
      IF(LEN.GT.0.AND.NAME_TAB2(1:1).NE.','.AND.
     *                NAME_TAB2(1:1).NE.' ')THEN
        N = NPEAK 
        CALL READ_TAB_PRF(MDOC,NAME_TAB2,N,RESULT2,IPRMAX,IPRROW)
        NP_PRF = RESULT2(1,12) 
        IF(NP_PRF.LE.0) THEN
          CALL MSGERR(MDOC,
     *    ' ERROR: number of peaks for PRF = 0')
          IERR = 1
          RETURN
        ENDIF
        CALL MSGDOC(MDOC,
     *'INFO: list of saptf_peaks from tab file (FILE_T2)')

        GO TO 200

      ENDIF
C ----
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     *'-- Spherically Averaged Phased Translation Function (SAPTF) --'
     *)
      CALL MSGDOC(MDOC,' ')
C ----
      F0      = 'N'
      NINDEX  = 0

c        NINDEX  = LMAX_INP/2
c        WRITE(LINE,'('' Lmax (input)           :'',I5)') LMAX_INP 
c        CALL MSGDOC(MDOC,LINE)

      NMIN    = 0
      BOFFF   = BOFF
      BADDD   = BADD
C      NAMEFFM = NAMEA3      
C      NAMEFM2 = NAMEA2      

      LMAX = LMAXR
C     NP   = NPEAK
      NP   = 0
      IF(NPT_DM.LT.NPEAK) NPT_DM = NPEAK
      MMM = MD
      IF(LIST.EQ.'T') MMM = MDOC  

      CALL RFCOEF_00N(MMM,MDOC_PSRCH,LIST,NP,NPT_DM
     *   ,NAMEA3,NAMEA2,PATH_SCR,BOFFF,BADDD,NINDEX,LMAX
     *   ,NMIN,RESMIN,RESMAX,ARAD,FSH_OBS,FSH_MOD,INVER,F0,RMS_INPUT
     *   ,RESULT3,IPRMAX3,IPRROW3,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900

      NP_PRF = RESULT3(1,12) 
      IF(NP_PRF.LE.0) THEN
          CALL MSGERR(MDOC,
     *  ' ERROR: number of peaks of SAPT function = 0')
        IERR = 1
        RETURN
      ENDIF

      WRITE(LINE,'('' Nmax,NP_PRF:'',2I8)') NINDEX,NP_PRF
      CALL MSGDOC(MD,LINE)

C ---------
      IF(LIST.EQ.'L'.OR.LIST.EQ.'T') THEN
        NAMES = 'trfun_saptf'
        CALL ADD_PATH(PATH_SCR,NAMES)
        NAME  = 'molrep_saptf.ps'  
        CALL ADD_PATH(PATH_SCR,NAME)
        TITLE = '-- SAPTF --'
        COEF  = COEF_IN      
        IF(COEF.LE.0.0001) COEF  = 4.0
        NLEV  = 2  
        CALL PRINT_DENS_TO_PS(MDOC,NAMES,NAME
     *  ,TITLE,COEF,NLEV,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
      ENDIF
C ----------
      IF(NCS_ID.GT.0.AND.NP_PRF.GT.1) THEN
        NAME = ' '
        NCS = NCS_ID 
        CALL COPY_CRD_NCS(MDOC,NAMEM,NAME,NCS,NM_TOTAL,NA_TOTAL
     *    ,ANGLES_NCS_INP,ANGLES_NCS,CENTRE_NCS
     *    ,IPRDOM,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
        N = 0

        IF(LIST.EQ.'T') THEN
          write(*,*) '==',NCS,NCS_ID,NM_TOTAL
          write(*,*) '==',ANGLES_NCS_INP(1),ANGLES_NCS_INP(2)
     *                    ,ANGLES_NCS_INP(3)
          write(*,*) '==',CENTRE_NCS(1),CENTRE_NCS(2),CENTRE_NCS(3)
          DO J=1,NM_TOTAL
            write(*,*) '==',J,ANGLES_NCS(1,J),ANGLES_NCS(2,J)
     *                    ,ANGLES_NCS(3,J)
          ENDDO
        ENDIF

        CALL FTOO(CENTRE_NCS,V,IERR)   
        DLIM  = RESMAX/2.0
        CDLIM = ARAD/2.0


        DO I=1,NP_PRF
          IFLAG  = 0
          SH1(1) = RESULT3(I, 9) 
          SH1(2) = RESULT3(I,10)
          SH1(3) = RESULT3(I,11)
          CALL FTOO(SH1,SH2,IERR)
          DO J=1,NM_TOTAL
            V1(1) = (ANGLES_NCS(1,J)*PI)/180.0
            V1(2) = (ANGLES_NCS(2,J)*PI)/180.0
            V1(3) = (ANGLES_NCS(3,J)*PI)/180.0
            CALL POLTOM(V1(1),V1(2),V1(3),AM)
            IF(J.EQ.1) THEN
              DO II=1,3
              DO JJ=1,3
                AM(II,JJ) = 0.0
              ENDDO        
              ENDDO        
              AM(1,1) = 1.0
              AM(2,2) = 1.0
              AM(3,3) = 1.0
            ENDIF
            V1(1) = SH2(1) - V(1) 
            V1(2) = SH2(2) - V(2) 
            V1(3) = SH2(3) - V(3)
            CALL MVMULT(AM,V1,V2)
            V1(1) = V2(1) + V(1) 
            V1(2) = V2(2) + V(2) 
            V1(3) = V2(3) + V(3)
            IF(J.GT.1) THEN
              DX    = V1(1) - SH2(1) 
              DY    = V1(2) - SH2(2) 
              DZ    = V1(3) - SH2(3)
              CDIST = SQRT(DX*DX + DY*DY + DZ*DZ) 
              IF(CDIST.LE.CDLIM) THEN
                IFLAG = 1
                GO TO 300
              ENDIF
            ENDIF
            IF(N.GT.0) THEN
            DO K=1,N
              SH1(1) = RESULT3(K, 9) 
              SH1(2) = RESULT3(K,10)
              SH1(3) = RESULT3(K,11)
              CALL FTOO(SH1,SH3,IERR)
              DX    = V1(1) - SH3(1) 
              DY    = V1(2) - SH3(2) 
              DZ    = V1(3) - SH3(3)
              DIST  = SQRT(DX*DX + DY*DY + DZ*DZ) 
              IF(DIST.LE.DLIM) THEN
                IFLAG = 1
                GO TO 300
              ENDIF
            ENDDO
            ENDIF
          ENDDO
 300      CONTINUE
          IF(IFLAG.LE.0) THEN
            N = N + 1
            DO J=1,IPRROW3
              RESULT3(N,J) = RESULT3(I,J) 
            ENDDO
          ENDIF
        ENDDO
        RESULT3(1,12) = N
        NP_PRF = RESULT3(1,12) 

        WRITE(LINE,'('' NP_PRF_new:'',I8)') NP_PRF
        CALL MSGDOC(MD,LINE)

      ENDIF 

C=======

      IF(NPT_DM.GT.NPEAK) THEN
        NAME = 'molrep_saptf.tab'
        CALL ADD_PATH(PATH_SCR,NAME)

        NP_PRF = RESULT3(1,12) 
        IF(NP_PRF.GT.0) THEN
          DO I=1,NP_PRF
            RESULT3(I,6) = 0.0
            RESULT3(I,7) = 0.0
            RESULT3(I,8) = 0.0
          ENDDO
        ENDIF 
        CALL WRITE_TAB_PRF(MDOC,NAME,
     *                           RESULT3,IPRMAX3,IPRROW3,IERR) 
        IF(IERR.NE.0) GO TO 900

        CALL MSGDOC(MDOC,
     *'INFO: you can find list of saptf_peaks in molrep_saptf.tab')
        CALL MSGDOC(MDOC,
     *'      use keyword FILE_T2 ')

      ENDIF

c      WRITE(LINE,'('' NP_PRF,PRF :'',I5,A)') NP_PRF,PRF
c      CALL MSGDOC(MDOC,LINE)

      IF(NPT_DM.GT.NP_PRF) NPT_DM = NP_PRF
      IF(NPEAK.GT.NP_PRF) NPEAK = NP_PRF

      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,'     --- peaksearch / SAPTF / ---')
      CALL MSGDOC(MDOC,'      (expected model positions)')
      WRITE(LINE,'(A,I5)') 'Number of peaks :',NPEAK
      CALL MSGDOC(MD,LINE)
c                      '    1  0.453  0.477  0.403  0.1458      7.58
      CALL MSGDOC(MDOC,
     * '+--------------------------------------------+')
      LINE = '|       Xfrac  Yfrac  Zfrac '//
     *    ' Dens Dens/sigma |'
      CALL MSGDOC(MDOC,LINE)
c      LINE = '       IX  IY  IZ  Xfrac  Yfrac  Zfrac  Xort'//
c     *    '   Yort    Zort   Dens Dens/sigma'
      CALL MSGDOC(MDOC,
     * '+--------------------------------------------+')

      DO I=1,NPEAK
        IX   = RESULT3(I,1)
        IY   = RESULT3(I,2)
        IZ   = RESULT3(I,3)
        SHX  = RESULT3(I,6)
        SHY  = RESULT3(I,7)
        SHZ  = RESULT3(I,8)
        FSHX = RESULT3(I,9)
        FSHY = RESULT3(I,10)
        FSHZ = RESULT3(I,11)
        DENS = RESULT3(I,4)
        DSIG = RESULT3(I,5)

c        WRITE(LINE,100) I,IX,IY,IZ,FSHX,FSHY,FSHZ,SHX,SHY,SHZ,DENS,DSIG
c 100    FORMAT(4I4,3F7.3,3F7.2,G12.4,F6.2)
        WRITE(LINE,100) I,FSHX,FSHY,FSHZ,DENS,DSIG
 100    FORMAT('|',I4,3F7.3,G12.4,F6.2,' |')
        CALL MSGDOC(MDOC,LINE)
      ENDDO
      CALL MSGDOC(MDOC,
     * '+--------------------------------------------+')
      CALL MSGDOC(MDOC,' ')

      WRITE(LINE,'('' Nmax,Lmax       :'',2I5)') NINDEX,LMAX 
      CALL MSGDOC(MD,LINE)

c      IF(PRF.EQ.'S') NPT_DM = -1

      IF(PRF.EQ.'S'.AND.NPT_DM.LE.0) NPT_DM = -1

C     IF(PRF.EQ.'Y'.AND.NPT_DM.EQ.0) NPT_DM = 30

      NRUN_TIME   = 0
      ITIME_START = 0
      CALL EXPECTED_TIME(ITIME_START,NRUN_TIME
     *    ,ITIME_CURR,TIME_CURRENT,TIME_ELAPSED,TIME_EXPECTED)
      WRITE(LINE,*) 'Time:',TIME_CURRENT,' Elapsed:',TIME_ELAPSED
      CALL MSGDOC(MDOC,LINE)

c     IF(NPT_DM.GT.NPEAK) THEN
      IF(PRF.EQ.'?') THEN
        CALL MSGDOC(MDOC,' ')
        CALL MSGDOC(MDOC,
     *   '        --- Quick search orientation by PRF ---')
        CALL MSGDOC(MDOC,' ')
        LMAX = 20
        LMIN = 2
        MMM  = MDOC
        NP   = NPT_DM 
        WRITE(LINE,'(A,I4,A,I4,A,I4,A)')
     *  '      --- PRF (Lmin=',LMIN,' Lmax=',LMAX,' Nptd=',NP,')'
        CALL MSGDOC(MDOC,LINE)

        DO I=1,IPRMAX3
        DO J=1,IPRROW3
          RESULT4(I,J) = RESULT3(I,J) 
        ENDDO
        ENDDO

        CALL CHECK_PRF(MMM,NAMEA2,NAMEA3,NAMEA,NAMEA4,INVER
     *    ,BOFF,BADD,LMAX,LMIN,NP,LIST
     *    ,FSH_MOD,RESULT4,IPRMAX3,IPRROW3
     *    ,RESMIN,RESMAX,ARAD,ISYM,IPRSYM,IERR)

        IF(IERR.NE.0) GO TO 900

        NP_PRF = RESULT4(1,12) 
        IF(NP_PRF.LE.0) THEN
          CALL MSGERR(MDOC,
     *    ' ERROR: number of peaks of SAPT function = 0')
          IERR = 1
          RETURN
        ENDIF

        NPBY3  = NPEAK/3
        
        II = 0
        DO I=1,NP_PRF
          ISAPTF = RESULT4(I,1)
          IF(ISAPTF.LE.NPBY3) THEN
            II = II + 1
            DO J=1,IPRROW3
              RESULT3(II,J) = RESULT4(I,J) 
            ENDDO
          ENDIF
        ENDDO
        DO I=1,NP_PRF
          ISAPTF = RESULT4(I,1)
          IF(ISAPTF.GT.NPBY3) THEN
            II = II + 1
            DO J=1,IPRROW3
              RESULT3(II,J) = RESULT4(I,J) 
            ENDDO
          ENDIF
        ENDDO
        RESULT3(1,12) = NP_PRF

        NP = NPEAK
        IF(NP.GT.NP_PRF) NP = NP_PRF
        LINE = '+--------------------------------------'//
     *         '---------------------------------------+'
        CALL MSGDOC(MDOC,LINE)
        LINE =
     *    '|   Isaptf theta    phi    chi '//'     shx   shy   shz'//
     *    '       PRf'//'       SAPTF     |'
        CALL MSGDOC(MDOC,LINE)
        LINE = '+--------------------------------------'//
     *         '---------------------------------------+'
        CALL MSGDOC(MDOC,LINE)
        DO I=1,NP
          PK     = RESULT3(I,4)
          SG     = RESULT3(I,5)
          ISAPTF = RESULT3(I,1)
          ALPHA  = RESULT3(I,6)
          BETA   = RESULT3(I,7)
          GAMMA  = RESULT3(I,8)
          SHX    = RESULT3(I, 9)
          SHY    = RESULT3(I,10)
          SHZ    = RESULT3(I,11)

          RALPHA  = (ALPHA*PI)/180.0
          RBETA   = (BETA *PI)/180.0
          RGAMMA  = (GAMMA*PI)/180.0
          CALL EULERM(RALPHA,RBETA,RGAMMA,AM)
          CALL MTOPOL(AM,THETA,PHI,CHI)

          WRITE(LINE,212) I,ISAPTF,THETA,PHI,CHI,SHX,SHY,SHZ
     *        ,PK,SG
 212      FORMAT('|',I3,I4,1X,3F8.2,1X,3F6.3,G14.4,G12.4,'|')
          CALL MSGDOC(MDOC,LINE)
        ENDDO
        LINE = '+--------------------------------------'//
     *         '---------------------------------------+'
        CALL MSGDOC(MDOC,LINE)
        CALL MSGDOC(MDOC,' ')


        IF(NP_PRF.GT.NPEAK) NP_PRF = NPEAK 

        DO I=1,NP_PRF
        DO J=1,IPRROW3
          RESULT2(I,J) = RESULT3(I,J) 
        ENDDO
        ENDDO
        RESULT2(1,12) = NP_PRF

      NRUN_TIME   = 0
      ITIME_START = 0
      CALL EXPECTED_TIME(ITIME_START,NRUN_TIME
     *    ,ITIME_CURR,TIME_CURRENT,TIME_ELAPSED,TIME_EXPECTED)
      WRITE(LINE,*) 'Time:',TIME_CURRENT,' Elapsed:',TIME_ELAPSED
      CALL MSGDOC(MDOC,LINE)

      ELSE

        IF(NP_PRF.GT.NPEAK) NP_PRF = NPEAK 
        DO I=1,NP_PRF
        DO J=1,IPRROW3
          RESULT2(I,J) = RESULT3(I,J) 
        ENDDO
        ENDDO
        RESULT2(1,12) = NP_PRF

      ENDIF
      
 200  CONTINUE

      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,'          --- Search orientation  ---')
      CALL MSGDOC(MDOC,' ')

      IF(PRF.EQ.'Y'.OR.PRF.EQ.'P') THEN
C ---
        CALL CROSSROT_PH_PRF(MDOC,NAMEA3,NAMEA2
     *  ,NAMEA,NAMEAM,NAMED,NAME_TAB,PATH_SCR,FSH_MOD,FSH_OBS
     *  ,RESMIN,RESMAX,NPEAK,NPT_DM,PRF,INVER,LIST
     *  ,BOFF,BADD,ARAD,LMINR,LMAXR,RESLIM
     *  ,ISYM,IPRSYM
     *  ,RESULT,RESULT2,RESULTA,IPRMAX,IPRROW,IERR)
        IF(IERR.NE.0) GO TO 900
C ----
      ELSE IF(PRF.EQ.'S') THEN
C ---
        IF(ANISO.EQ.'Y') ANISO = 'N'
        CALL CROSSROT_PH_RF_NEW(MDOC,NAMEM,NAMEFFM,NAMEFM2
     *   ,NAMEA3,NAMEA2,NAMEA1,NAMEC2,NAMEA5,NAMEA4
     *   ,NAMEA,NAMEAM,NAMED,NAME_TAB,PATH_SCR,FSH_MOD,FSH_OBS
     *   ,A,B,C,AL,BE,GA,NXMIN,NYMIN,NZMIN
     *   ,BOFF_SCL,BADD_SCL,RESMIN,RESMAX
     *   ,NPEAK,NPT_DM,PRF,LIST,ANISO,MOD1
     *   ,BOFF,BADD,ARAD,LMINR,LMAXR,RESLIM,BLIM,SURF
     *   ,ISYM,IPRSYM
     *   ,RESULT,RESULT2,RESULTA,IPRMAX,IPRROW,IERR)
        IF(IERR.NE.0) GO TO 900
C --------------------------------------------------------------------
C ---
      ENDIF
C ----
      NP = RESULT(1,12) 
      IF(NP.LE.0) THEN
        IERR = 0
        RETURN
      ENDIF

      NAME_TAB = 'molrep_rf.tab'
      CALL ADD_PATH(PATH_SCR,NAME_TAB)

      CALL MSGDOC(MDOC,
     *'INFO:   you can find list of peaks in molrep_rf.tab ')
       CALL MSGDOC(MDOC,
     *'        use keywords FILE_T and "FUN T" ')

      CALL WRITE_TAB_PRF(MDOC,NAME_TAB,
     *                         RESULT,IPRMAX,IPRROW,IERR) 
      IF(IERR.NE.0) GO TO 900
C -------------------------------------------------
  900 CONTINUE

      NAME='crossrt_scr.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_scr1.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_al1.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_al2.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_al3.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_al4.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_al5.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_f.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_fsc.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_ph.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_scr.crd'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_scr1.crd'
      CALL DELETE_FILE(PATH_SCR,NAME)

C ---  
      RETURN
      END

      SUBROUTINE WRITE_TAB_PRF(MDOC,NAME_TAB,
     *                         RESULT,IPRMAX,IPRROW,IERR) 
C ---------------------------------------------------
      INTEGER   MDOC,IERR
      REAL      RESULT(IPRMAX,IPRROW),AM(3,3)
      CHARACTER NAME_TAB*(*)
      CHARACTER LINE*256,PATH*80,EXT*80,NAME*256
C ---------------------------------------------------
      IERR = 0
      PI   = 4.0*ATAN(1.0)
      M    = 99
C ---
      NP   = RESULT(1,12) 
      IF(NP.LE.0) THEN
        IERR = 0
        RETURN
      ENDIF
      IOUT = 11
      NAME = NAME_TAB
      PATH = ' '
      EXT  = ' '
      CALL OPENFW(IOUT,M,PATH,NAME,EXT,IERR)
      IF(IERR.NE.0) GO TO 900
      LINE =
     * '#Sol_      theta    phi    chi '//'     shx   shy   shz'//
     * '       PRf'//'      SAPTF'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)') LINE(1:LEN)    

      DO I=1,NP
        PK      = RESULT(I,4)
        SG      = RESULT(I,5)
c        SIG    = PK/SG
        ALPHA   = RESULT(I,6)
        BETA    = RESULT(I,7)
        GAMMA   = RESULT(I,8)

        SHX     = RESULT(I, 9)
        SHY     = RESULT(I,10)
        SHZ     = RESULT(I,11)
        RALPHA  = (ALPHA*PI)/180.0
        RBETA   = (BETA *PI)/180.0
        RGAMMA  = (GAMMA*PI)/180.0
        CALL EULERM(RALPHA,RBETA,RGAMMA,AM)
        CALL MTOPOL(AM,THETA,PHI,CHI)

        WRITE(LINE,210) I,THETA,PHI,CHI,SHX,SHY,SHZ
     *        ,PK,SG
 210    FORMAT('So ',I4,1X,3F8.2,1X,3F6.3,G14.4,G12.4)
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)') LINE(1:LEN)

      ENDDO
      END FILE IOUT
      CLOSE(IOUT)
C -------------------------------------------------
  900 CONTINUE
      RETURN
      END

      SUBROUTINE CROSSROT_PH_PRF(MDOC,NAMEFFM,NAMEFM2
     * ,NAMEA,NAMEAM,NAMED,NAME_TAB,PATH_SCR,FSH_MOD,FSH_OBS
     * ,RESMIN,RESMAX,NPEAK,NPT_DM,PRF,INVER,LIST
     * ,BOFF,BADD,ARAD,LMINR,LMAXR,RESLIM
     * ,ISYM,IPRSYM
     * ,RESULT,RESULT2,RESULTA,IPRMAX,IPRROW,IERR)
C --------------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
C ----
      REAL      RESULT (IPRMAX,IPRROW)
      REAL      RESULT2(IPRMAX,IPRROW)
      REAL      RESULTA(IPRMAX,IPRROW)
C ---
      CHARACTER PRF*1
      CHARACTER NAME_TAB*(*),PATH_SCR*(*)
      CHARACTER NAMEA*(*),NAMEAM*(*),NAMED*(*)
      CHARACTER NAMEFM2*(*),NAMEFFM*(*)
      CHARACTER NAME*256

      CHARACTER LINE*256
      CHARACTER LIST*1,CH4*4
      REAL      AM(3,3),FSH_MOD(3)
      REAL      FSH_OBS(3)

      PARAMETER ( IPRMAX5 =   200 )
      CHARACTER NAMEO(IPRMAX5)*256
      REAL      FSH_OBS_PK(3,IPRMAX5)

      REAL      RF_MAX(4)
      CHARACTER SPEC*1
      CHARACTER INVER*1
C -------------------------------------------------------------
      PI    = 4.0*ATAN(1.0)
      MD    = -ABS(MDOC)-1
      M     = 99
      MD0   =  0
      IF(ABS(MDOC).GE.99) MD0 = 99
      TWOPI = 2.0*PI
C ------------------------------------------------
      NAME  = NAMEAM
      LMAX  = LMAXR
      LMIN  = LMINR
      NSYMZ = 1

      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC  
      CALL RFCOEF_100(MMM,NAMEFM2,NAME,INVER,BOFF,BADD,LMAX,LMIN,NSYMZ
     * ,RESMIN,RESMAX,RESLIM,ARAD,FSH_MOD,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900

C ---
      WRITE(LINE,'('' Lmin,Lmax               :'',2I5)') 
     * LMINR,LMAX
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,'('' Radius of integration   :'',F8.2)') 
     * ARAD
      CALL MSGDOC(MDOC,LINE)
C ---
      LINE = '--- Phased Rotation function ---'
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' ')

      NP_PRF = RESULT2(1,12) 

      IF(NP_PRF.LE.0) THEN
        CALL MSGERR(MDOC,
     *  ' ERROR: number of peaks of SAPT function = 0')
        IERR = 1
        RETURN
      ENDIF

C      WRITE(LINE,'('' NPEAK,NP_PRF,PRF-- :'',2I5,A)') NPEAK,NP_PRF,PRF
C      CALL MSGDOC(MDOC,LINE)

      IF(NPEAK.GT.IPRMAX5) NPEAK = IPRMAX5
      IF(NPEAK.GT.NP_PRF) NPEAK = NP_PRF

      I_PRF        = 0
      RESULT(1,12) = 0.0 

      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC  


      DO I=1,NPEAK

        FSH_OBS(1) = RESULT2(I, 9)
        FSH_OBS(2) = RESULT2(I,10)
        FSH_OBS(3) = RESULT2(I,11)
        FSH_OBS_PK(1,I) = RESULT2(I, 9)
        FSH_OBS_PK(2,I) = RESULT2(I,10)
        FSH_OBS_PK(3,I) = RESULT2(I,11)

        IF(LIST.EQ.'T') THEN
          WRITE(LINE,*)'sh_obs:'
     *    ,FSH_OBS_PK(1,I),FSH_OBS_PK(2,I),FSH_OBS_PK(3,I)
          CALL MSGDOC(MMM,LINE)
        ENDIF 

        WRITE(CH4,'(I4)') I
        IF(CH4(1:1).EQ.' ') CH4(1:1) = '_'
        IF(CH4(2:2).EQ.' ') CH4(2:2) = '_'
        IF(CH4(3:3).EQ.' ') CH4(3:3) = '_'
        CALL LENSTR_BL(NAMEA,LEN)
        NAMEO(I) = NAMEA(1:LEN)//CH4//'.dat'
c       CALL ADD_PATH(PATH_SCR,NAMEO(I))

      ENDDO

c      IF(LIST.EQ.'T'.AND.I.NE.1) MMM = 99
      MMM = 99
      IF(LIST.EQ.'T') MMM = MDOC

      LMAX       = LMAXR
      LMIN       = LMINR
      NSYMZ      = 1

c         MMM = Mdoc
c         MMM = M
c         if(i.eq.1) MMM = Mdoc 
c        CALL RFCOEF_100(MMM,NAMEFFM,NAMEA
c     *  ,INVER,BOFF,BADD,LMAX,LMIN,NSYMZ
c     *  ,RESMIN,RESMAX,RESLIM,ARAD,FSH_OBS
c     *  ,ISYM,IPRSYM,IERR)
c        IF(IERR.NE.0) GO TO 900
c         MMM = Mdoc
c         MMM = M
c         if(i.eq.1) MMM = Mdoc 
         
      CALL RFCOEF_100_SAPTF(MMM
     *   ,NAMEFFM,NAMEO,INVER,BOFF,BADD,LMAX
     *   ,LMIN,NSYMZ
     *   ,RESMIN,RESMAX,RESLIM,ARAD
     *   ,FSH_OBS_PK,NPEAK,IPRMAX5,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C ---

      DO I=1,NPEAK

        BETMIN =   0.0
        BETMAX = 180.0
        BETDEL =   2.0
        LMAX   = 0
        LMIN   = LMINR
        NAME   = ' '

        MMM = 99
        IF(LIST.EQ.'T') MMM = MDOC

        CALL RFRES_100_3D(MMM,NAMEO(I)
     *     ,NAMEAM,NAME,BETMIN,BETMAX,BETDEL
     *     ,RF_MAX,LMAX,LMIN,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
C ---

        IF(LIST.EQ.'T') THEN
          WRITE(LINE,*) 'RF_max:'
     *    ,RF_MAX(1),RF_MAX(2),RF_MAX(3),RF_MAX(4)
          CALL MSGDOC(Mdoc,LINE)
        ENDIF 
            
        RESULTA(1,12) = 1.0
        RESULTA(1, 4) = RF_MAX(4)
        RESULTA(1, 6) = RF_MAX(1)
        RESULTA(1, 7) = RF_MAX(2)
        RESULTA(1, 8) = RF_MAX(3)

        NP = RESULTA(1,12) 
        IF(NP.GT.0.0) THEN       
          I_PRF            = I_PRF + 1
          RESULT(    1,12) = I_PRF 
          RESULT(I_PRF, 4) = RESULTA(1, 4)
          RESULT(I_PRF, 5) = RESULT2(I, 5)
          RESULT(I_PRF, 6) = RESULTA(1, 6)
          RESULT(I_PRF, 7) = RESULTA(1, 7)
          RESULT(I_PRF, 8) = RESULTA(1, 8)
          RESULT(I_PRF, 9) = RESULT2(I, 9)
          RESULT(I_PRF,10) = RESULT2(I,10)
          RESULT(I_PRF,11) = RESULT2(I,11)

c          PK     = RESULT(I_PRF,4)
c          SG     = RESULT(I_PRF,5)
cc         SIG    = PK/SG
c          ALPHA  = RESULT(I_PRF,6)
c          BETA   = RESULT(I_PRF,7)
c          GAMMA  = RESULT(I_PRF,8)
c
c          SHX  = RESULT(I_PRF, 9)
c          SHY  = RESULT(I_PRF,10)
c          SHZ  = RESULT(I_PRF,11)
c          RALPHA  = (ALPHA*PI)/180.0
c          RBETA   = (BETA *PI)/180.0
c          RGAMMA  = (GAMMA*PI)/180.0
c          CALL EULERM(RALPHA,RBETA,RGAMMA,AM)
c          CALL MTOPOL(AM,THETA,PHI,CHI)
c
c          IF(I_PRF.EQ.1) THEN
c            LINE =
c     * '#Sol_    '//'   theta   phi    chi'//'     shx   shy   shz'//
c     * '             Rf'//'   SAPTF'
c            CALL MSGDOC(MDOC,LINE)
c          ENDIF
c
c          WRITE(LINE,210) I,THETA,PHI,CHI,SHX,SHY,SHZ
c     *        ,PK,SG
c          CALL MSGDOC(MDOC,LINE)

        ENDIF

      ENDDO

      N = RESULT(1,12)
      IF(N.GT.0) THEN
        IST = 4
        CALL SORT_PEAK_PRF(MDOC,IST,RESULT,IPRMAX,IPRROW,IERR)
        LINE = '+--------------------------------------'//
     *         '---------------------------------------+'
        CALL MSGDOC(MDOC,LINE)
        DO I=1,N
          IF(I.EQ.1) THEN
            LINE =
     * '|        '//'   theta   phi    chi'//'     shx   shy   shz'//
     * '        Rf     '//'   SAPTF     |'
            CALL MSGDOC(MDOC,LINE)
        LINE = '+--------------------------------------'//
     *         '---------------------------------------+'
        CALL MSGDOC(MDOC,LINE)
          ENDIF
          PK     = RESULT(I, 4)
          SG     = RESULT(I, 5)
          ALPHA  = RESULT(I, 6)
          BETA   = RESULT(I, 7)
          GAMMA  = RESULT(I, 8)
          SHX    = RESULT(I, 9)
          SHY    = RESULT(I,10)
          SHZ    = RESULT(I,11)
          RALPHA  = (ALPHA*PI)/180.0
          RBETA   = (BETA *PI)/180.0
          RGAMMA  = (GAMMA*PI)/180.0
          CALL EULERM(RALPHA,RBETA,RGAMMA,AM)
          CALL MTOPOL(AM,THETA,PHI,CHI)
          WRITE(LINE,210) I,THETA,PHI,CHI,SHX,SHY,SHZ
     *        ,PK,SG
 210      FORMAT('|   ',I4,1X,3F8.2,1X,3F6.3,G14.4,G12.4,'|')
          CALL MSGDOC(MDOC,LINE)
        ENDDO
        LINE = '+--------------------------------------'//
     *         '---------------------------------------+'
        CALL MSGDOC(MDOC,LINE)
      ENDIF
C -------------------------------------------------
  900 CONTINUE
      DO I=1,NPEAK
        CALL DELETE_FILE(PATH_SCR,NAMEO(I))
      ENDDO
C ---  
      RETURN
      END

      SUBROUTINE CROSSROT_PH_RF_NEW(MDOC,NAMEM,NAMEFFM,NAMEFM2
     * ,FOBS_COEF,FMOD_COEF
     * ,NAMEA1,NAMEA2,NAMEA3,NAMEA4
     * ,NAMEA,NAMEAM,NAMED,NAME_TAB,PATH_SCR,FSH_MOD,FSH_OBS
     * ,A,B,C,AL,BE,GA,NX,NY,NZ
     * ,BOFF_SCL,BADD_SCL,RESMIN,RESMAX
     * ,NPEAK,NPT_DM,PRF,LIST,ANISO,MOD1
     * ,BOFF,BADD,ARAD,LMINR,LMAXR,RESLIM,BLIM,SURF
     * ,ISYM,IPRSYM
     * ,RESULT,RESULT2,RESULTA,IPRMAX,IPRROW,IERR)
C --------------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      POOL(10)
C ----
      REAL      RESULT (IPRMAX,IPRROW)
      REAL      RESULT2(IPRMAX,IPRROW)
      REAL      RESULTA(IPRMAX,IPRROW)
C ---
      CHARACTER PRF*1
      CHARACTER FOBS_COEF*(*),FMOD_COEF*(*)
      CHARACTER NAME_TAB*(*),PATH_SCR*(*)
      CHARACTER NAMEA*(*),NAMEAM*(*),NAMED*(*),NAMEM*(*)
      CHARACTER NAMEFM2*(*),NAMEFFM*(*)
      CHARACTER NAMEA1*(*),NAMEA2*(*),NAMEA3*(*),NAMEA4*(*)
      CHARACTER NAME*256

      CHARACTER LINE*256,MODE*1
      CHARACTER LIST*1
      REAL      AM(3,3),SH(3),FSH_MOD(3),FSH_OBS(3),SPST(3)
      REAL      RF_MAX(4),RLATT(6)
      CHARACTER SPEC*1,PST*1,REST*1,RFAC_FLAG*1,MODE_GD*1,SURF*1
      CHARACTER INVER*1,ANISO*1,ACORR*1,MOD1*1,TEST*1

      CHARACTER CODE*4,NAMET*40,DATE*9,SPGR*24,TITLE*80

C -------------------------------------------------------------
      PI    = 4.0*ATAN(1.0)
      MD    = -ABS(MDOC)-1
      M     = 99
      MD0   =  0
      IF(ABS(MDOC).GE.99) MD0 = 99
      TWOPI = 2.0*PI
      MMM   = M
      IF(LIST.EQ.'T') THEN
        MMM = MDOC
        MD  = MDOC
      ENDIF 
C ------------------------------------------------
      ARAD_MOD  = ARAD*1.5
      ARAD_RF   = ARAD*2.0
C ----------
      LINE = '       --- Rotation function (for modified map) ---'
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' ')

      NP_PRF = RESULT2(1,12) 

      IF(NP_PRF.LE.0) THEN
        CALL MSGERR(MDOC,
     *  ' ERROR: number of peaks of SAPT function = 0')
        IERR = 1
        RETURN
      ENDIF

      IF(NPEAK.GT.NP_PRF) NPEAK = NP_PRF

      ZMIN = 1.0
      ZMAX = 0.0 
      DO I=1,NPEAK
        IF(RESULT2(I,11).LT.ZMIN) ZMIN = RESULT2(I,11)
        IF(RESULT2(I,11).GT.ZMAX) ZMAX = RESULT2(I,11)
      ENDDO

      ZDEL = (ARAD_MOD+1.0)/C 
      ZMIN = ZMIN - ZDEL
      ZMAX = ZMAX + ZDEL
      IF(LIST.EQ.'T') THEN
        WRITE(LINE,*)'NX,NY,NZ:',NX,NY,NZ
        CALL MSGDOC(MMM,LINE)
        WRITE(LINE,*)'zlim:',ZMIN,ZMAX 
        CALL MSGDOC(MMM,LINE)
      ENDIF 
      IZMIND = ZMIN*FLOAT(NZ)
      IF(IZMIND.LT.0) IZMIND = 0
      IZMAXD = ZMAX*FLOAT(NZ)
      IF(IZMIND.GE.NZ) IZMAXD = NZ-1
   
c     F000  = 0.0
      F000  =-1.0
C     IZMIN = 0
C     IZMAX =-2
C     NX    = 0
C     NY    = 0
C     NZ    = 0
      IERR  = 1
c     IF(IERR.EQ.1) P1 = 'Y'
      CALL FFT(MMM,NX,NY,NZ,IZMIND,IZMAXD,F000,FOBS_COEF
     *    ,NAMEA1,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C --------------
C ---
      CODE     = ' '
      NAMET    = ' '
      DATE     = ' '
      SPGR     = 'P 1'
      NSPGROUP = 1
      NOSETT   = 1
      TITLE    = '-'
      CELL_P1  = ARAD*4
      RLATT(1) = CELL_P1
      RLATT(2) = CELL_P1
      RLATT(3) = CELL_P1
      RLATT(4) = 90.0
      RLATT(5) = 90.0
      RLATT(6) = 90.0
      RLATT(4) = (RLATT(4)*PI)/180.
      RLATT(5) = (RLATT(5)*PI)/180.
      RLATT(6) = (RLATT(6)*PI)/180.

      CALL SET_CELL(RLATT,CODE,NAMET,DATE,TITLE
     *    ,NSPGROUP,NOSETT,SPGR,IERR)
      IF(IERR.NE.0) GO TO 900

      CALL LIMHKL(RESMAX,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)
C 
      CALL MSGDOC(MD,'Minimal grid spacing for calculation SF:') 
      WRITE(LINE,1000) NXMIN,NYMIN,NZMIN
 1000 FORMAT(' NXmin=',I3,', NYmin=',I3,', NZmin=',I3) 
      CALL MSGDOC(MD,LINE)
C ----
      IMOD    = 1
      IZMIN   = 0
      IZMAX   =-1
      ALPHA   = 0.0
      BETA    = 0.0
      GAMMA   = 0.0
      SCALEP  = 0.0
      BSCALE  = 0.0
      MODE_GD = ' '
      IF(SURF.EQ.'C') MODE_GD = 'C'
      BADD_GD = 0.0
      RAD_GD  = 0.0
      IF(SURF.EQ.'Y'.OR.SURF.EQ.'C') THEN
        RAD_GD  = BLIM + 0.000001
      ENDIF
      NMR     = 0
      N_MODEL = 1
      TEST    = ' '
      ACORR   = 'N'  
      IF(ANISO.EQ.'Y')  ACORR = 'Y'

      CALL RF_PRECALC_MOD(MMM,LIST,NAMEM,NAMEA2,NAMED
     * ,NAMEFFM,NAMEFM2,NAMEAM,PATH_SCR
     * ,MOD1,IMOD,ANISO,NXMIN,NYMIN,NZMIN
     * ,IZMIN,IZMAX,NMR,N_MODEL,TEST,SCALEP,BSCALE,ACORR
     * ,BOFF_SCL,BADD_SCL,RESMIN,RESMAX
     * ,MODE_GD,BADD_GD,RAD_GD,NEL,SURF
     * ,RLATT,ALPHA,BETA,GAMMA 
     * ,RESULT,RESULTA,IPRMAX,IPRROW
     * ,ISYM,IPRSYM,IERR)
C ------------------------------------------------------------
C 1) if MOD1=D DENS2F_DNS else DENS2F_NEW
C 2) if ANISO # 0 MR_SCALING
C                1. ACORR # N - anisothermal correction of Fmod
C                2. ANISO = K - FSCALE with SCALEP,BSCALE
C                     if scale = 0 - scaling by Fobs (cell must be the same)
C                                    only scale , set BOVER = 0
C                     if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                    no info: rfac, corr
C                   else  CALL PSCALE
C                   output: SCALEP_NEW,BSCALE_NEW and NAMEFM2
c     else no scaling
C     output NAMEFM2,NAMEPH and SCALEP,BSCALE (aniso # 0)
C ---------------------------------------------------------
      IF(IERR.NE.0) GO TO 900
C ---
      SH(1)   = 0.0
      SH(2)   = 0.0
      SH(3)   = 0.0
      LMAX     = LMAXR
      LMIN     = LMINR
      NSYMZ    = 1
      INVER    = 'N'
      CALL RFCOEF_100(MMM,NAMEFM2,NAMEAM
     * ,INVER,BOFF,BADD,LMAX,LMIN,NSYMZ
     * ,RESMIN,RESMAX,RESLIM,ARAD_RF,SH
     * ,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C ---
      WRITE(LINE,'('' Lmin,Lmax               :'',2I5)') 
     * LMINR,LMAX
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,'('' Radius of integration   :'',F8.2)') 
     * ARAD_RF
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' ')
C ----------
      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC  
      I_PRF        = 0
      RESULT(1,12) = 0.0 

      DO I=1,NPEAK

        IF(LIST.EQ.'T'.AND.I.NE.1) MMM = 99

C --
        SHX = RESULT2(I, 9)
        SHY = RESULT2(I,10)
        SHZ = RESULT2(I,11)

        IF(LIST.EQ.'T') THEN
          WRITE(LINE,*)'sh:',SHX,SHY,SHZ
          CALL MSGDOC(MMM,LINE)
          WRITE(LINE,*)'ARAD_MOD:',ARAD_MOD
          CALL MSGDOC(MMM,LINE)
        ENDIF 

        XMIN  = SHX
        XMAX  = SHX
        XDEL  = (ARAD_MOD+1.0)/A
        XMIN  = XMIN - XDEL
        XMAX  = XMAX + XDEL 
        IXMIN = XMIN*FLOAT(NX)
        IXMAX = XMAX*FLOAT(NX)
        YMIN  = SHY
        YMAX  = SHY
        YDEL  = (ARAD_MOD+1.0)/B 
        YMIN  = YMIN - YDEL
        YMAX  = YMAX + YDEL 
        IYMIN = YMIN*FLOAT(NY)
        IYMAX = YMAX*FLOAT(NY)
        ZMIN  = SHZ
        ZMAX  = SHZ
        ZDEL  = (ARAD_MOD+1.0)/C 
        ZMIN  = ZMIN - ZDEL
        ZMAX  = ZMAX + ZDEL
        IZMIN = ZMIN*FLOAT(NZ)
        IZMAX = ZMAX*FLOAT(NZ)
        IF(IZMIN.LT.IZMIND) IZMIN = IZMIND
        IF(IZMAX.GT.IZMAXD) IZMAX = IZMAXD

        NXW = IXMAX - IXMIN
        NYW = IYMAX - IYMIN
        NZW = IZMAX - IZMIN

        NXW = NXW + NXW/2
        NYW = NYW + NYW/2
        NZW = NZW + NZW/2

        CALL GET_GRID(NXW,NYW,NZW)
        AW = (A/FLOAT(NX))*FLOAT(NXW)
        BW = (B/FLOAT(NY))*FLOAT(NYW)
        CW = (C/FLOAT(NZ))*FLOAT(NZW)

        IF(LIST.EQ.'T') THEN
          WRITE(LINE,*)'A,B,C:',AW,BW,CW 
          CALL MSGDOC(MMM,LINE)
          WRITE(LINE,*)'grid :',NXW,NYW,NZW 
          CALL MSGDOC(MMM,LINE)
          WRITE(LINE,*)'Ixlim:',IXMIN,IXMAX,XMIN,XMAX  
          CALL MSGDOC(MMM,LINE)
          WRITE(LINE,*)'Iylim:',IYMIN,IYMAX,YMIN,YMAX  
          CALL MSGDOC(MMM,LINE)
          WRITE(LINE,*)'Izlim:',IZMIN,IZMAX,ZMIN,ZMAX  
          CALL MSGDOC(MMM,LINE)
        ENDIF 

        CALL MOD_EXTR(MMM,NAMEA1,NAMEA2,ARAD_MOD
     *    ,SHX,SHY,SHZ,AW,BW,CW,NXW,NYW,NZW,IXMIN,IYMIN,IZMIN
     *    ,IXMAX,IYMAX,IZMAX
     *    ,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900


        INVER     = 'N'
        PST       = 'N'
        SPST(1)   = 0.0
        SPST(2)   = 0.0
        SPST(3)   = 0.0
        IERR      = 0

        IPOOL_MAX = 0
C        IF(IPOOL_MAX.GT.0) THEN
C          I0 = MEMORY - IPOOL_MAX + 1
C        ELSE
C          I0 = 1
C        ENDIF

        CALL RFT_NEW(MMM,LIST,PATH_SCR,RESMAX
     *   ,INVER,PST,SPST
     *   ,NAMEA2,NAMEA3,NAMEA4,ISYM,IPRSYM,RESULTA
     *   ,POOL,IPOOL_MAX,IERR)
        IF(IERR.NE.0) GO TO 900

        LMAX   = LMAXR
        NSYMZ  = 1
        INVER  = 'N'
C  ---
C       scaling  f = NAMEA3 ( model NAMEFM2) --> NAMEA4

        ACORR = 'N'
        IF(ANISO.EQ.'Y')  ACORR = 'Y'
        BOFFF  = BOFF
        BADDD  = BADD
        RESMNI = RESMIN
        RESMXI = RESMAX
        SCALE  = 0.0
        BOVER  = 0.0

        CALL MR_SCALING(MMM,LIST,NAMEFM2,NAMEA3,NAMEA4,PATH_SCR
     *  ,ANISO,SCALE,BOVER,ACORR,BOFFF,BADDD,RESMNI,RESMXI
     *  ,SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF
     *  ,RESULTA,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
C ---------------------------------------------------------
C     1. ACORR # N - anisothermal correction of Fmod
C     2. ANISO = K - FSCALE with SCALEP,BSCALE
C                   if scale = 0 - scaling by Fobs (cell must be the same)
C                      only scale , set BOVER = 0
C                   if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                  no info: rfac, corr
C        else  CALL PSCALE
C      output: SCALEP_NEW,BSCALE_NEW and NAMEFM2
C ---------------------------------------------------------
        IF(IERR.NE.0) GO TO 900


        WRITE(LINE,'('' scale,B_scale       :'',2F8.3)') 
     *  SCALEP_NEW,BSCALE_NEW
        CALL MSGDOC(MMM,LINE)

C  ---
        CALL RFCOEF_100(MMM,NAMEA4,NAMEA
     *  ,INVER,BOFF,BADD,LMAX,LMIN,NSYMZ
     *  ,RESMIN,RESMAX,RESLIM,ARAD_RF,SH
     *  ,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
C ---
        BETMIN =   0.0
        BETMAX = 180.0
        BETDEL =   2.0
        LMAX   = 0
        LMIN   = LMINR
        NAME   = ' '

        IF(LIST.EQ.'T') THEN
          name = named
          write(*,*) 'name:',name
          write(*,*) 'namea1:',namea1
          write(*,*) 'namea2:',namea2
        ENDIF 

        CALL RFRES_100_3D(MMM,NAMEA,NAMEAM,NAME,BETMIN,BETMAX,BETDEL
     *     ,RF_MAX,LMAX,LMIN,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
C ---

        IF(LIST.EQ.'T') THEN
          WRITE(LINE,*) 'RF_max:'
     *    ,RF_MAX(1),RF_MAX(2),RF_MAX(3),RF_MAX(4)
          CALL MSGDOC(MMM,LINE)
        ENDIF 

        RESULTA(1,12) = 1.0
        RESULTA(1, 4) = RF_MAX(4)
        RESULTA(1, 6) = RF_MAX(1)
        RESULTA(1, 7) = RF_MAX(2)
        RESULTA(1, 8) = RF_MAX(3)

        NP = RESULTA(1,12) 
        IF(NP.GT.0.0) THEN       
          I_PRF            = I_PRF + 1
          RESULT(    1,12) = I_PRF 
          RESULT(I_PRF, 4) = RESULTA(1, 4)
          RESULT(I_PRF, 5) = RESULT2(I, 5)
          RESULT(I_PRF, 6) = RESULTA(1, 6)
          RESULT(I_PRF, 7) = RESULTA(1, 7)
          RESULT(I_PRF, 8) = RESULTA(1, 8)
          RESULT(I_PRF, 9) = RESULT2(I, 9)
          RESULT(I_PRF,10) = RESULT2(I,10)
          RESULT(I_PRF,11) = RESULT2(I,11)

          PK     = RESULT(I_PRF,4)
          SG     = RESULT(I_PRF,5)
c         SIG    = PK/SG
          ALPHA  = RESULT(I_PRF,6)
          BETA   = RESULT(I_PRF,7)
          GAMMA  = RESULT(I_PRF,8)

          SHX  = RESULT(I_PRF, 9)
          SHY  = RESULT(I_PRF,10)
          SHZ  = RESULT(I_PRF,11)

          RALPHA  = (ALPHA*PI)/180.0
          RBETA   = (BETA *PI)/180.0
          RGAMMA  = (GAMMA*PI)/180.0
          CALL EULERM(RALPHA,RBETA,RGAMMA,AM)
          CALL MTOPOL(AM,THETA,PHI,CHI)

          IF(I_PRF.EQ.1) THEN
            LINE =
     * '           theta    phi     chi'//'   alpha   beta   gamma'//
     * '        Rf'//'        SAPTF'
            CALL MSGDOC(MDOC,LINE)
          ENDIF

          WRITE(LINE,211) I,THETA,PHI,CHI,ALPHA,BETA,GAMMA
     *        ,PK,SG
          CALL MSGDOC(MDOC,LINE)
 211      FORMAT('  ',I4,1X,3F8.2,1X,3F8.2,G14.4,G12.4)

        ENDIF

      ENDDO
C ----
      N = RESULT(1,12)
      IF(N.GT.0) THEN
        CALL MSGDOC(MDOC,' ')
        CALL MSGDOC(MDOC,' ---  after sort ---')
        CALL MSGDOC(MDOC,' ')
        IST = 4
        CALL SORT_PEAK_PRF(MDOC,IST,RESULT,IPRMAX,IPRROW,IERR)
        DO I=1,N
          IF(I.EQ.1) THEN
        LINE = '+--------------------------------------'//
     *         '------------------------------------+'
        CALL MSGDOC(MDOC,LINE)
            LINE =
     * '|    '//'   theta   phi    chi'//'     shx   shy   shz'//
     * '         Rf     '//'   SAPTF     |'
            CALL MSGDOC(MDOC,LINE)
        LINE = '+--------------------------------------'//
     *         '------------------------------------+'
        CALL MSGDOC(MDOC,LINE)
          ENDIF
          PK     = RESULT(I, 4)
          SG     = RESULT(I, 5)
          ALPHA  = RESULT(I, 6)
          BETA   = RESULT(I, 7)
          GAMMA  = RESULT(I, 8)
          SHX    = RESULT(I, 9)
          SHY    = RESULT(I,10)
          SHZ    = RESULT(I,11)
          RALPHA  = (ALPHA*PI)/180.0
          RBETA   = (BETA *PI)/180.0
          RGAMMA  = (GAMMA*PI)/180.0
          CALL EULERM(RALPHA,RBETA,RGAMMA,AM)
          CALL MTOPOL(AM,THETA,PHI,CHI)
          WRITE(LINE,210) I,THETA,PHI,CHI,SHX,SHY,SHZ
     *        ,PK,SG
 210      FORMAT('|',I4,1X,3F8.2,1X,3F6.3,G14.4,G12.4,'|')
          CALL MSGDOC(MDOC,LINE)
        ENDDO
        LINE = '+--------------------------------------'//
     *         '------------------------------------+'
        CALL MSGDOC(MDOC,LINE)
      ENDIF



      IF(LIST.EQ.'T') THEN
        stop
      ENDIF
C -------------------------------------------------
  900 CONTINUE
C ---  
      RETURN
      END

      SUBROUTINE MOD_EXTR(MDOC,NAME1,NAMEW,RAD
     *    ,SHX,SHY,SHZ,AW,BW,CW,NXW,NYW,NZW,IXMIN,IYMIN,IZMIN
     *    ,IXMAX,IYMAX,IZMAX
     *    ,ISYM,IPRSYM,IERR)
C ---------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)

C      INTEGER*2 IPOOLA(NCRES)
C      REAL      POOLC(NCRES)
      integer*2,   allocatable :: IPOOLA(:)
      real,        allocatable :: POOLC(:)

      REAL      SH(3)
      CHARACTER NAME1*(*),NAMEW*(*)
      CHARACTER TTT1*80
      CHARACTER LINE*256,TYPE*4
C -------------------------------------------------------------
      MD    = -ABS(MDOC)-1
      M     = 99
      SH(1) = SHX
      SH(2) = SHY
      SH(3) = SHZ
      WRITE(LINE,*) ' SET ZERO: RAD:',RAD
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) ' sh :',SH(1),SH(2),SH(3)
      CALL MSGDOC(MDOC,LINE)
C ------------------------------------------------------------
      MTIN1 = 40
      TYPE  = 'RI  '
      CALL ORFILE(M,MTIN1,NAME1,TYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) THEN
        CALL MSGERR(MDOC,' ERR: FILE-DENS-1')
        IERR=1
        RETURN
      ENDIF
      CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *        ,F1,F2,F3,F4,NX1,NY1,NZ1,IZMIN1,IZMAX1,TTT1,IERR)
      CLOSE(MTIN1)
      IF(IERR.GT.0) THEN
        IERR=2
        RETURN
      ENDIF
      NXY1=NX1*NY1
      IT = 0
      allocate(IPOOLA(1:NXY1),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      NXYW=NXW*NYW
      allocate(POOLC(1:NXYW),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      IF(IT.GT.0) THEN
        IERR = 1
        CALL MSGERR(MDOC,
     *    ' ERROR: in MOD_EXTR: problem with memory allocation')
        RETURN
      ENDIF

      CALL MOD_EXTR_RUN(MDOC,NAME1,NAMEW
     *    ,POOLC,IPOOLA,NXY1,RAD,SH
     *    ,AW,BW,CW,NXW,NYW,NZW,IXMIN,IYMIN,IZMIN
     *    ,IXMAX,IYMAX,IZMAX
     *    ,ISYM,IPRSYM,IERR)

      deallocate(POOLC,STAT=ISTAT)
      deallocate(IPOOLA,STAT=ISTAT)

      RETURN
      END

      SUBROUTINE MOD_EXTR_RUN(MDOC,NAME1,NAMEW
     *    ,POOLC,IPOOLA,NCRES,RAD,SH
     *    ,AW,BW,CW,NXW,NYW,NZW,IXMINW,IYMINW,IZMINW
     *    ,IXMAXW,IYMAXW,IZMAXW
     *    ,ISYM,IPRSYM,IERR)
C ------------------------------------------------
      INTEGER*2 IPOOLA(NCRES)
      REAL      POOLC(NCRES)
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER NAME1*(*),NAMEW*(*)
      CHARACTER TTT1*80
      CHARACTER TTTW*80,TYPE*4
      CHARACTER LINE*256
      REAL      XF(3),XC(3),SH(3)
C ----------------------------------------------------------------------
C ---
      COMMON/COMWRF/ A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
     *              ,RN_WR,RX_WR,CF_WR,TF_WR
     *              ,NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
     *              ,NS_WR,IS_WR,IER_WR,IEN_WR
     *              ,TP_WR,T1_WR,T2_WR,TL_WR,DT_WR
     *              ,CD_WR,SG_WR,PT_WR,PD_WR
      REAL A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
      REAL RN_WR,RX_WR,CF_WR,TF_WR
      INTEGER*4 NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
      INTEGER*4 NS_WR,IS_WR,IER_WR,IEN_WR
      CHARACTER TP_WR*4,T1_WR*4,T2_WR*4,TL_WR*80,DT_WR*20     
      CHARACTER CD_WR*4,SG_WR*24,PT_WR*40,PD_WR*9
C ---
C --------------------------------------------------------------------
      IERR=0
      MD=-ABS(MDOC)-1
      M     = 99
C--------------------------------------
      ITYPE  = 0
      MTIN1  = 40
      CALL IRDENS(MTIN1,NAME1,MDOC,ITYPE,ICNTZ1,NX1,NY1,NZ1,IZMAX1,
     * IZMIN1,RMAX1,RMIN1,IPOOLA,SCALE1,A1,B1,C1,AL1,BE1,GA1,DRMS1,
     * RAVER,RESOL1,IX01,IY01,IZ01,ITR1,TTT1,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: FILE-DENS-1')
        IERR=1
        RETURN
      ENDIF
      CALL C_RD_CR
      IX0W   = 0
      IY0W   = 0
      IZ0W   = 0
      TTTW   = TTT1
      ALW    = AL1
      BEW    = BE1
      GAW    = GA1
      IF(IZMAXW.GT.IZMAX1)  IZMAXW = IZMAX1 
C --------------------------------------------------------
      MTS       = 43
      TTTW(1:4) = 'MODI'
      TTTW(5:8) = 'F   '
      TYPE      = 'RI  '
      IPRINT    = 1
      CALL C_CR_WR
      NS_WR = 1
      SG_WR = 'P 1'
      NS1   = 1
      DDM   = 0.0
      IZMNW = 0
      IZMXW = IZMAXW - IZMINW 
  
      CALL SET_TITLE(MDOC,AW,BW,CW,ALW,BEW,GAW
     *  ,DDM,DDM,DDM,DDM,NXW,NYW,NZW,IZMNW,IZMXW,TTTW,IERR)

      CALL LENSTR_BL(NAMEW,LEN)
      IF(LEN.LE.0.OR.NAMEW(1:1).EQ.','.OR.NAMEW.EQ.' ') THEN
        CALL MSGERR(MD,' ERR: OPEN OUTPUT-FILE-DENS')
        CLOSE(MTIN1)
        IERR=1
        RETURN
      ENDIF 
      CALL OWFILE(MDOC,MTS,NAMEW,TYPE,NS1,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CLOSE(MTIN1)
        RETURN
      ENDIF
C---------------------------------------------------------------
      NXYW=NXW*NYW
      ICNTZ3 =-999
      ITYPE1 = 1

      RAD2  = RAD*RAD  

      DO IZ=IZMIN1,IZMAX1
C -----------------------
        CALL IRDENS(MTIN1,NAME1,MDOC,ITYPE1,ICNTZ1,NX1,NY1,NZ1,IZMAX1,
     *  IZMIN1,RMAX1,RMIN1,IPOOLA,SCALE1,A1,B1,C1,AL1,BE1,GA1,DRMS1,
     *  RAVER,RESOL1,IX01,IY01,IZ01,ITR1,TTT1,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: FILE-DENS-1.')
          IERR=1
          CLOSE(MTS)
          RETURN
        ENDIF
C -----------------------
        IF(IZ.LT.IZMINW) GO TO 300 
        IF(IZ.GT.IZMAXW) GO TO 100 

        Z   = IZ/FLOAT(NZ1)

        DO     I=1,NXYW
          POOLC(I)=0.0
        ENDDO

        DO IY=IYMINW,IYMAXW
          IYY   = IY
          IF(IYY.LT.  0) IYY = IYY + NY1
          IF(IYY.GE.NY1) IYY = IYY - NY1
          Y     = IY/FLOAT(NY1)
          IND0  = IYY*NX1
          INDD0 = (IY-IYMINW)*NXW

          DO IX=IXMINW,IXMAXW
            IXX  = IX
            IF(IXX.LT.  0) IXX = IXX + NX1
            IF(IXX.GE.NX1) IXX = IXX - NX1
            X    = IX/FLOAT(NX1)
            IND  = IND0  + IXX + 1
            INDD = INDD0 + (IX-IXMINW) + 1

            D1   = IPOOLA(IND)/SCALE1

            XX=X-SH(1)
            YY=Y-SH(2)
            ZZ=Z-SH(3)

            IF(ABS(XX).GT.0.5) THEN
              IF(XX.LT.0.0) XX=1.0+XX
              IF(XX.GE.0.0) XX=XX-1.0
            ENDIF
            IF(ABS(YY).GT.0.5) THEN
              IF(YY.LT.0.0) YY=1.0+YY
              IF(YY.GE.0.0) YY=YY-1.0
            ENDIF
            IF(ABS(ZZ).GT.0.5) THEN
              IF(ZZ.LT.0.0) ZZ=1.0+ZZ
              IF(ZZ.GE.0.0) ZZ=ZZ-1.0
            ENDIF

            XF(1)=XX
            XF(2)=YY
            XF(3)=ZZ
            CALL FTOO(XF,XC,IERR)

            DIST2=XC(1)*XC(1)+XC(2)*XC(2)+XC(3)*XC(3)   
            IF(DIST2.GT.RAD2) THEN
              DOUT = 0.0
            ELSE
              DOUT = D1
            ENDIF

            POOLC(INDD)=DOUT

C----XXXX---YYYY-------
  500       CONTINUE
          ENDDO

  400     CONTINUE
        ENDDO
C---------------------
        CALL WDENS(MTS,MDOC,ICNTZ3,NXW,NYW,NZW,IZMNW,IZMXW,
     *               RMAXD,RMIND,POOLC,RESOL1,IX0W,IY0W,IZ0W,ITR1)
        IF(MTS.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: OUTPUT-FILE-DENS')
          IERR=1
          CLOSE(MTIN1)
          RETURN
        ENDIF

  300   CONTINUE
C---ZZZZZZZZZ----------
      ENDDO
C----------------------
  100 CONTINUE
C---------------------
      CLOSE(MTIN1)
      CLOSE(MTS)
      RETURN
      END

      SUBROUTINE GET_GRID(NX,NY,NZ)
C ---------------------------------------------------
      INTEGER*2 ID(50)
C              1  2   3   4   5   6   7   8    9  10
c      DATA ID/  4,  6,  8, 10, 12, 16, 20, 24, 30, 32
c     *       , 36, 48, 50, 54, 60, 64, 72, 80, 90, 96
c     *       ,100,108,120,128,132,144,150,160,162,180
c     *       ,192,200,216,240,250,256,264,270,288,300
c     *       ,320,324,360,384,400,432,450,480,500,512/
      DATA ID/  4,  6,  0,  0, 12,  0,  0, 24,  0, 32
     *       , 36, 48,  0,  0, 60,  0, 72,  0,  0, 96
     *       ,  0,108,120,  0,132,144,  0,  0,  0,180
     *       ,192,  0,216,240,  0,  0,264,  0,288,300
     *       ,  0,324,360,384,  0,432,  0,480,  0,600/
      DATA ND/50/
C---------------------------------------------------------------------
      DO   I=1,ND
        NXMIN=ID(I)
        IF(NXMIN.GE.NX) GO TO 100
      ENDDO
  100 CONTINUE
      DO   I=1,ND
        NYMIN=ID(I)
        IF(NYMIN.GE.NY) GO TO 200
      ENDDO
  200 CONTINUE
      DO   I=1,ND
        NZMIN=ID(I)
        IF(NZMIN.GE.NZ) GO TO 300
      ENDDO
  300 CONTINUE

      NX = NXMIN
      NY = NYMIN
      NZ = NZMIN

      RETURN
      END

      SUBROUTINE SELFROT(MDOC,NAMEF,NAME_TSRF,NAME_PS,PATH_SCR
     * ,RESN,RESX,PARM_RF,CHI_IN,COEF_IN,NPEAK,BLIM
     * ,RMS_INPUT,DLIM_RF,RAD_MODEL
     * ,BOFF,BADD,BOFF_SCL,BADD_SCL,ARAD,LMIN_INP,LMAX_INP
     * ,ISYM,IPRSYM
     * ,RESULTA,IPRMAX,IPRROW,IERR)
C --------------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
C ----
      REAL      RESULTA(IPRMAX,IPRROW)
C--
      PARAMETER ( IPRCOEF = 15000 )
      PARAMETER ( IPRIND1 =    61 )
      PARAMETER ( IPRIND2 =    30 )
      PARAMETER ( IPRIND3 =    61 )
      PARAMETER ( IPRNMAX =    61 )
C --
C ---------------------------------------
      INCLUDE 'molrep_lh_infor.fh'
C      COMMON/COM_LH_INFOR/ BOFF_LH,BADD_LH,BOFF_FOR_SCAL
C     *   ,CHECK_CONTRAST,CONTRAST_LIM
C     *   ,BCORR_LH,FILE_FOBS_LH,SCORE_FLAG,LH_LH,DB_LH 
CC ---
C      REAL      CHECK_CONTRAST,CONTRAST_LIM
C      REAL      BOFF_FOR_SCAL,BOFF_LH,BADD_LH,BCORR_LH
C      CHARACTER LH_LH*1,SCORE_FLAG*1,DB_LH*1
C      CHARACTER FILE_FOBS_LH*256
C ----------------------------------
      CHARACTER NAMEF*(*),NAME_TSRF*(*),NAME_PS*(*),PATH_SCR*(*)
      CHARACTER NAMEC*256,NAMEA*256,NAME*256,NAMED*256,NAMEFFM*256
      CHARACTER NAME_RF*256
      CHARACTER LINE*256
      CHARACTER PATH*80,EXT*80,TTT*80,ITYPE*4
      REAL      SH1(3),AM(3,3),RF_MAX(4)
      CHARACTER SOLV*1,PATT*1,LIST*1,SPEC*1,ANISO*1,TEST*1,PROG*4
      CHARACTER PARM_RF*16,MODE_GD*1,ANISO_CORR*1,ANISO2*1,LH_STOR*1
      CHARACTER DB_INPUT*1
C -------------------------------------------------------------
      PI    = 4.0*ATAN(1.0)
      MD    = -ABS(MDOC)-1
      M     = 99
      MD0   =  0
      IF(MDOC.EQ.99) MD0 = 99
      TWOPI = 2.0*PI
C ---
      MDOC_PSRCH = MDOC
C      IF(ABS(MDOC).EQ.2) THEN
C        MD=99
C      ENDIF
C ---
      ANISO = PARM_RF( 2: 2) 
      LIST  = PARM_RF( 7: 7) 
      TEST  = PARM_RF( 6: 6) 
      ANISO_CORR = PARM_RF(14:14)
      DB_INPUT = PARM_RF(15:15) 
C ----
      IF(LIST.EQ.'S') THEN
        MD=99
      ENDIF

      IF(TEST.EQ.'F') THEN
        MODE_GD  = 'S'
        BADD_GD  = BLIM + 0.00001
        RAD_GD   = 2.8
      ELSE
        MODE_GD  = ' '
        BADD_GD  = 0.0
        RAD_GD   = 0.0
      ENDIF
C ---
      IF(ANISO.EQ.'y')  ANISO = 'Y'
      IF(ANISO.EQ.'k')  ANISO = 'K'
      IF(ANISO.NE.'Y'.AND.ANISO.NE.'K')  ANISO = 'N'
C --------------------------------------------------------------
      IERR  = 0
      MTN   = 10
      ITYPE = 'FF  '

      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC

      CALL ORFILE(MMM,MTN,NAMEF,ITYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN INPUT-FILE-FOBS')
        RETURN
      ENDIF

      CALL C_RD_CR

      CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *  ,F1,F2,RESMIN,RESMAX,IDM,IDM,IDM,IDM,IDM,TTT,IERR)
      CLOSE(MTN)
C -------------------------------------------------------------

      IF(RESX.LT.0.00001) RESX = 3.0
      IF(RESX.GT.0.00001.AND.RESX.GT.RESMAX) RESMAX=RESX
C???
      IF(RESX.GT.0.00001.AND.RESX.LT.RESMAX) RESMAX=RESX

      IF(RESN.GT.0.00001.AND.RESN.LT.RESMIN) RESMIN=RESN
      IF(RESMIN.LT.RESMAX) THEN
        T      = RESMIN
        RESMIN = RESMAX
        RESMAX = T
      ENDIF
      IF(RESMIN.EQ.RESMAX) THEN
        CALL MSGERR(MDOC,' ERR: resmin = resmax')
        IERR=1
        RETURN
      ENDIF
      IF(BOFF.LE.0.00001) BOFF=900.0
C --------------------------------------------------------------
      NAMEA   = 'crossrot_alo'
      CALL ADD_PATH(PATH_SCR,NAMEA)
      NAMEC   = 'crossrt_scr'
      CALL ADD_PATH(PATH_SCR,NAMEC)
      NAMEFFM = 'crossrot_ff'
      CALL ADD_PATH(PATH_SCR,NAMEFFM)
C ==========================================
      IF(ANISO_CORR.EQ.'Y') THEN
        CALL MSGDOC(MD0,'--- anisothermal correction of Fobs ---')
        BADDD    = BADD_SCL
        BOFFF    = BOFF_SCL
        SCALE    = 1.0
        BOVER    = 0.0
        PATT     = 'Y'
        SOLV     = 'N'
        NCYCL    =  0

C        RESMNI=RESMIN
C        RESMXI=RESMAX
        RESMNI = 0.0
        RESMXI = 0.0
        
        NAME  = ' '
        ANISO2 = '-'
        CALL MR_SCALING(MDOC,LIST,NAME,NAMEF,NAMEFFM,PATH_SCR
     * ,ANISO2,SCALE,BOVER,ANISO_CORR,BOFFF,BADDD,RESMNI,RESMXI
     * ,SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF
     * ,RESULTA,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
C ---------------------------------------------------------
C     1. ACORR # N - anisothermal correction of Fmod
c        if ANISO = '-' return
C     2. ANISO = K - FSCALE with SCALEP,BSCALE
C                   if scale = 0 - scaling by Fobs (cell must be the same)
C                      only scale , set BOVER = 0
C                   if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                  no info: rfac, corr
C        else  CALL PSCALE
C      output: SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF and NAMEFM2
C ---------------------------------------------------------
      ELSE
        NAMEFFM=NAMEF
      ENDIF
C ---
      INPUT = 1
      IF(ARAD.LT.0.0001) THEN
c       ARAD  = 30.0
        ARAD  = RAD_MODEL*1.75
        ARAD  = RAD_MODEL*1.5
        WRITE(LINE,
     *'('' Default radius of integration'',F8.2)') 
     *    ARAD
        CALL MSGDOC(MDOC,LINE)
        INPUT = 0
      ENDIF

c      RCOEF = 0.55
      RCOEF = 0.5
C      IF(ARAD.GT.(A*RCOEF)) ARAD = A*RCOEF
C      IF(ARAD.GT.(B*RCOEF)) ARAD = B*RCOEF
C      IF(ARAD.GT.(C*RCOEF)) ARAD = C*RCOEF
      I=0
      IF(ARAD.GT.(A*RCOEF)) I=1
      IF(ARAD.GT.(B*RCOEF)) I=2
      IF(ARAD.GT.(C*RCOEF)) I=3
      IF(I.NE.0) THEN
        AAA = A*RCOEF
        T = B*RCOEF
        IF(T.LT.AAA) AAA = T
        T = C*RCOEF
        IF(T.LT.AAA) AAA = T
        WRITE(LINE,
     *'('' WARNING: Radius of integration  > '',F8.2)') 
     *    AAA
        CALL MSGDOC(MDOC,LINE)
        IF(INPUT.EQ.0.OR.DB_INPUT.EQ.'Y') ARAD = AAA
      ENDIF
      WRITE(LINE,'('' Radius of integration       :'',F8.2)') 
     *  ARAD
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Resolution                  :'',2F8.2)') 
     *  RESMIN,RESMAX
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Boff,Badd                   :'',2F8.2)') 
     *  BOFF,BADD
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,'('' Boff_scl,Badd_scl           :'',2F8.2)') 
     *  BOFF_SCL,BADD_SCL
      CALL MSGDOC(MD,LINE)

      LMAXR = LMAX_INP
      LMINR = LMIN_INP

c      IPRBES = 400
c      RESMXT = (TWOPI*ARAD)/98.0
c      IF(RESMXT.LT.0.1) RESMXT=0.1

c      RESMXT = ARAD/(60.0/TWOPI+1.0) 
c      RESMXT = ARAD/(108.0/TWOPI+1.0) 
      RESMXT = (ARAD*TWOPI)/109.35


      IF(RESMXT.GT.RESMAX) THEN
        RESMAX = RESMXT
        CALL MSGERR(MDOC,
     *' WARNING: For this radius integration program uses data included'
     *)
        WRITE(LINE,
     *'(''          between '',F7.1,'' and '',F7.2,'' (angstrom)'')')
     *    RESMIN,RESMAX
        CALL MSGERR(MDOC,LINE)
      ENDIF


      CALL MSGDOC(MD0,'--- rfcoef for Fobs. ---')
  
      LMAX  = LMAXR
      LMIN  = LMINR

      NSYMZ  = 0
      SH1(1) = 0.0
      SH1(2) = 0.0
      SH1(3) = 0.0
      NAME   = ' '
  
      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC
      NAME_RF = NAMEFFM 
      LH_STOR = LH_LH
      IF(LH_LH.EQ.'V') LH_LH = '2'
      IF(LH_LH.NE.'N') NAME_RF = FILE_FOBS_LH 
C     fobs_flag
      IERR = 1
      CALL RFCOEF_100(MMM,NAME_RF,NAMEA,NAME
     * ,BOFF,BADD,LMAX,LMIN,NSYMZ
     * ,RESMIN,RESMAX,RESLIM,ARAD,SH1,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900

      LH_LH = LH_STOR

      WRITE(LINE,'('' Lmin,Lmax                   :'',2I5)') 
     * LMINR,LMAX
      CALL MSGDOC(MD,LINE)

      NAMED  = 'selfrot_srf'
      CALL ADD_PATH(PATH_SCR,NAMED)

C     CALL MSGDOC(MD0,'--- self rotation function ---')

      IRMS = 0

      CALL CALC_SRF(MDOC,LIST,NAMEA,NAMED,NCS,IRMS
     *  ,LMINR,RMS_INPUT,NPEAK,DLIM_RF,RESMAX,RAD,SIG_SRF
     *  ,RESULTA,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        IERR=0
        GO TO 900
      ENDIF

C ---------------------------------------
      NP = RESULTA(1,12) 
      IF(NP.LE.0) GO TO 900       

      CALL LENSTR_BL(NAME_TSRF,LEN) 
      IF(LEN.LE.0) THEN
        NAME = 'molrep_srf.tab'
        CALL ADD_PATH(PATH_SCR,NAME)
      ELSE
        NAME = NAME_TSRF
      ENDIF
      PATH = ' '
      EXT  = ' '
      IOUT = 11
      CALL OPENFW(IOUT,M,PATH,NAME,EXT,IERR)
      IF(IERR.NE.0) GO TO 900
C                                                                       *
      LINE =
     *'#            theta    phi    chi '//'    alpha   beta  gamma'//
     *'         Rf'//'  P(i)/P(0)'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)') LINE(1:LEN)    

      DO I=1,NP
        PK     = RESULTA(I,4)
        SG     = RESULTA(I,5)
        SIG    = PK/RESULTA(1,4)
        ALPHA  = RESULTA(I,6)
        BETA   = RESULTA(I,7)
        GAMMA  = RESULTA(I,8)

        ALP    = (ALPHA*PI)/180.0
        BET    = (BETA *PI)/180.0
        GAM    = (GAMMA*PI)/180.0

        CALL EULERM(ALP,BET,GAM,AM)
        CALL MTOPOL(AM,THETA,PHI,CHI)

        WRITE(IOUT,200) I,THETA,PHI,CHI,ALPHA,BETA,GAMMA
     *      ,PK,SIG
C200    FORMAT(I3,1X,3F8.2,1X,3F8.2,G14.4,G12.4)
 200      FORMAT('Sol_RF',I4,1X,6F8.2,G14.4,F6.2)
C                  4     24   1    24      26
C                     29                  50
C     123 123456781234567812345678123456781234567812345678123456789 1234123456
Col_RF  1   163.75    0.00   16.25    0.00    0.00 -180.00     535.0     25.31

      ENDDO
      END FILE IOUT
      CLOSE(IOUT)

      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     *'+------------------------------------------+')
      LINE =
     *'|       theta     phi     chi     P(i)/P(0)|'
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,
     *'+------------------------------------------+')

      DO I=1,NP
        PK     = RESULTA(I,4)
        SG     = RESULTA(I,5)
        SIG    = PK/RESULTA(1,4)
        ALPHA  = RESULTA(I,6)
        BETA   = RESULTA(I,7)
        GAMMA  = RESULTA(I,8)

        ALP    = (ALPHA*PI)/180.0
        BET    = (BETA *PI)/180.0
        GAM    = (GAMMA*PI)/180.0

        CALL EULERM(ALP,BET,GAM,AM)
        CALL MTOPOL(AM,THETA,PHI,CHI)

        WRITE(LINE,201) I,THETA,PHI,CHI,SIG
 201    FORMAT('|',I4,1X,3F8.2,6X,F6.2,' |')
        CALL MSGDOC(MDOC,LINE)

      ENDDO
      CALL MSGDOC(MDOC,
     *'+------------------------------------------+')
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC
     *,'INFO:  You can find All symmetry related peaks in molrep.doc')
      CALL MSGDOC(MDOC,' ')

c All symmetry related peaks
C ------------

      RFMAX = RESULTA(1,4)
      SG    = RESULTA(1,5)
      SIG   = RFMAX/SG

c          PK     = RESULTA(I,4)
c          SG     = RESULTA(I,5)
c          SIG    = PK/RESULTA(1,4)

C     CHI_IN <30> , COEF_IN <6>
      IF(CHI_IN .LE.0.00001) CHI_IN  = 60.0
      IF(COEF_IN.LE.0.00001) COEF_IN = 6.0


      THETA      = 0.0
      PHI        = 0.0
      RMAX_CROSS = 0.0

      DO I=1,5
C ---
        IMODE  = I
        IF(I.EQ.1) CHI   = 180.0
        IF(I.EQ.2) CHI   =  90.0
        IF(I.EQ.3) CHI   = 120.0
        IF(I.EQ.4) THEN
          CHI   =  CHI_IN
        ENDIF

        IF(I.EQ.5) IMODE  =  -1

        CALL RTRANS(M,NAMED,NAMEC
     *  ,CHI,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          IERR=0
          GO TO 900
        ENDIF
C ---       
        DRMS_IN   = SIG_SRF
        ARAD_IN   = ARAD
        RESMAX_IN = RESMAX
        RMAX_IN   = RFMAX
        COEF      = COEF_IN
        SCALE_R   = 0.5
        IPICT     = 0
        
        CALL RISOLINE(M,IMODE,IPICT,NAMEC,NAME_PS
     * ,THETA,PHI,RMAX_CROSS
     * ,RMAX_IN,DRMS_IN,ARAD_IN,RESMAX_IN,COEF,SCALE_R,IERR)
        IF(IERR.NE.0) THEN
          IERR=0
          GO TO 900
        ENDIF
C ---
      ENDDO
C -------------------------------------------------
  900 CONTINUE

      NAME='crossrt_scr.dat'
      CALL DELETE_FILE(PATH_SCR,NAME) 
      NAME='crossrt_ff.dat'
      CALL DELETE_FILE(PATH_SCR,NAME) 

      RETURN
      END

      SUBROUTINE CALC_SRF(MDOC,LIST,NAMEA,NAMED,NCS,IRMS
     *  ,LMINR,RMS_INPUT,NPEAK,DLIM_RF,RESMAX,RAD,SIG_SRF
     *  ,RESULTA,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
C -----------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
C ----
      REAL      RESULTA(IPRMAX,IPRROW)
      CHARACTER NAMEA*(*),NAMED*(*)
C--
      REAL      RF_MAX(4)
      REAL      AM(3,3)
      CHARACTER NAME*256,LIST*1 
      CHARACTER LINE*256,PROG*4,SPEC*1
C ---
      COMMON/COM_INERTIA_MATRIX/ MOD_FLAG,AMINER    
      INTEGER    MOD_FLAG
      REAL       AMINER(3,3)
C ---
C -------------------------------------------------------------
      PI    = 4.0*ATAN(1.0)
      MMM = 99 
C ---
      NCS    = 1
      BETMIN = 0.0
      BETMAX = 0.0
      BETDEL = 0.0
      LMAX   = 0
      LMIN   = LMINR
      NAME   = ' '
      CALL RFRES_100_3D(MMM,NAMEA,NAME,NAMED,BETMIN,BETMAX,BETDEL
     * ,RF_MAX,LMAX,LMIN,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
C        IERR=0
        GO TO 900
      ENDIF
C ---
      ALEVEL   = 0.0
      IF(RMS_INPUT.GT.0.000001) ALEVEL = RMS_INPUT

      NAME     = ' '
      NPMAX    = NPEAK
      IF(LIST.EQ.'T') NPMAX = 0

      DIST_LIM = 0.0
      IF(DLIM_RF.GT.0.00001) DIST_LIM = DLIM_RF

      PROG     = 'SELF'
      IF(LIST.EQ.'T'.OR.LIST.EQ.'L') PROG = 'SRFL'

      SPEC     = 'S'
C     IF(LIST.EQ.'L'.OR.LIST.EQ.'T') SPEC = 'S'

      THETA      = 0.0
      PHI        = 0.0
      RMAX_CROSS = 0.0
      NP_SRF     = 0
      NAME       = ' '
      DLIM       = 0.0
      NP_LIM     = NPMAX
      MOD_FLAG_SAVE = MOD_FLAG
      IF(IRMS.LE.0) MOD_FLAG = 0
      CALL PEAKSRCH_RF(MDOC,NAMED,NAME,ALEVEL,DIST_LIM,SPEC
     *     ,NPMAX,NP_LIM,PROG,RESMAX,RAD,NP_SRF,NAME,DLIM,NCS
     *     ,ISYM,IPRSYM,RESULTA,RESULTA,IPRMAX,IPRROW,IERR)
      MOD_FLAG = MOD_FLAG_SAVE
      IF(IERR.NE.0) THEN
C        IERR=0
        GO TO 900
      ENDIF

      NP = RESULTA(1,12) 
      IF(NP.LE.1) GO TO 900       
      PK_MAX   = RESULTA(1,4)
      PK_LIM   = PK_MAX*0.66
      SIG_SRF  = RESULTA(1,4)/RESULTA(1,5)
      DO I=2,NP
        PK     = RESULTA(I,4)
        SG     = RESULTA(I,5)
        SIG    = PK/RESULTA(1,4)
        RESULTA(I,5) = SIG
        ALPHA  = RESULTA(I,6)
        BETA   = RESULTA(I,7)
        GAMMA  = RESULTA(I,8)
        ALP    = (ALPHA*PI)/180.0
        BET    = (BETA *PI)/180.0
        GAM    = (GAMMA*PI)/180.0

        CALL EULERM(ALP,BET,GAM,AM)
        CALL MTOPOL(AM,THETA,PHI,CHI)

        IF(PK.GT.PK_LIM) NCS = NCS + 1

      ENDDO
      RESULTA(1,5) = 1.0



 900  CONTINUE
      RETURN
      END

      SUBROUTINE PTF_FIND_DMIN(MDOC,NPT,RESMAX,DIST_LIM_MIN
     *                    ,IPT_MIN,PRF_SH,RESULT,IPRMAX,IPRROW
     *                    ,NSYM,ISYM,IPRSYM,IERR)
C ----------
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER LINE*256
      REAL      PRF_SH(3),X(3),Y(3),SH(3)
      REAL      RESULT(IPRMAX,IPRROW)       
C ----------
      DIST_LIM_MIN = 1.0E30

      DO IPT=1,NPT
      DO IS =1,NSYM
        IF(IS.EQ.1) THEN
          SH(1) = RESULT(IPT, 9)
          SH(2) = RESULT(IPT,10)
          SH(3) = RESULT(IPT,11)
        ELSE
          DO J=1,3
          DO K=1,3
            IF(ISYM(J,K,1).NE.ISYM(J,K,IS)) GO TO 100            
          ENDDO            
          ENDDO
          SH(1) = RESULT(IPT, 9)+REAL(ISYM(4,1,IS))/REAL(ISYM(5,1,IS))
          SH(2) = RESULT(IPT,10)+REAL(ISYM(4,2,IS))/REAL(ISYM(5,2,IS))
          SH(3) = RESULT(IPT,11)+REAL(ISYM(4,3,IS))/REAL(ISYM(5,3,IS))          
        ENDIF
        X(1) = SH(1)-PRF_SH(1)
        X(2) = SH(2)-PRF_SH(2)
        X(3) = SH(3)-PRF_SH(3)

  10    CONTINUE
        IF(ABS(X(1)).GT.0.5) THEN
          IF(X(1).GE.0.0) THEN
            X(1)  = X(1)  - 1.0
            SH(1) = SH(1) - 1.0
          ELSE
            X(1)  = X(1)  + 1.0
            SH(1) = SH(1) + 1.0
          ENDIF
          GO TO 10
        ENDIF

  20    CONTINUE
        IF(ABS(X(2)).GT.0.5) THEN
          IF(X(2).GT.0.0) THEN
            X(2)  = X(2)  - 1.0
            SH(2) = SH(2) - 1.0
          ELSE
            X(2)  = X(2)  + 1.0
            SH(2) = SH(2) + 1.0
          ENDIF
          GO TO 20
        ENDIF

  30    CONTINUE
        IF(ABS(X(3)).GT.0.5) THEN
          IF(X(3).GT.0.0) THEN
            X(3)  = X(3)  - 1.0
            SH(3) = SH(3) - 1.0
          ELSE
            X(3)  = X(3)  + 1.0
            SH(3) = SH(3) + 1.0
          ENDIF
          GO TO 30
        ENDIF

        CALL FTOO(X,Y,IERR)
        DIST_LIM = SQRT(Y(1)*Y(1)+Y(2)*Y(2)+Y(3)*Y(3))

        IF(DIST_LIM.LT.DIST_LIM_MIN) DIST_LIM_MIN = DIST_LIM

        WRITE(LINE,
     *  '(''Distance between TF('',I4,'') and SAPTF:'',G16.4)') 
     *  IPT,DIST_LIM
        CALL MSGDOC(MDOC,LINE)

        IF(DIST_LIM.LE.RESMAX) THEN
          DO J=2,IPRROW
            RESULT(1,J) = RESULT(IPT,J)
          ENDDO
C          X(1) = RESULT(1, 9)
C          X(2) = RESULT(1,10)
C          X(3) = RESULT(1,11)
          RESULT(1, 9) = SH(1)
          RESULT(1,10) = SH(2)
          RESULT(1,11) = SH(3)
          CALL FTOO(SH,Y,IERR)
          RESULT(1, 6) = Y(1)
          RESULT(1, 7) = Y(2)
          RESULT(1, 8) = Y(3)
          IPT_MIN = IPT

          GO TO 830
        ENDIF
 100    CONTINUE

      ENDDO
      ENDDO

      RESULT(1,1)  = 1.0
      RESULT(1,2)  =-1.5
      RESULT(1,12) = 0
      IERR = 2
      GO TO 900
C ---      
 830  CONTINUE
      NPT  = 1
C ----
 900  CONTINUE
      RETURN
      END

      SUBROUTINE DENS2F_NEW(MDOC,LIST
     * ,NAMEC,NAMER,NAMED,NAMEFM,NAMEPH,NAMEFM_PK,NAMEPH_PK,PATH_SCR
     * ,NMR,N_MODEL,NX,NY,NZ,IZMIN,IZMAX,ZFADD
     * ,MODE_F,MODE_GD,BADD_GD,RAD_GD,RESMAX,NEL,H2OBG,ITEST,SURF
     * ,PACK,PST,VPST,ALPHA,BETA,GAMMA,RLATT_I
     * ,RESULT,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
C------------------
      COMMON/COM_DPOOL/ IPOOL_MAX,IPOOL_CURR
C -----------------
      INTEGER*2 ISYM(5,3,IPRSYM)
C ----
      REAL      RESULT (IPRMAX,IPRROW)
C ----
      REAL      VPST(3),RLATT_I(6)
      REAL      AM(3,3),SH1(3),SH2(3)
      CHARACTER NAMEFM*(*),NAMEPH*(*),NAMEC*(*),NAMED*(*)
      CHARACTER NAMEFM_PK*(*),NAMEPH_PK*(*),NAMER*(*),PATH_SCR*(*)

      CHARACTER NAMES*256,NAME*256,NAMEFS(2)*256,NAMET*256
      CHARACTER NAMEPHS(2)*256,NAMEIS(2)*256,NAMES_PH*256,NAMET_PH*256
      CHARACTER NAMET_I*256,NAMES2*256,NAME_TEST*256

      CHARACTER P1*1,TTT*80,MODE_GD*1,MODE_F*1,MODE*1,INVER*1
      CHARACTER PACK*1,PST*1,WAT*1,ALT*1,SETT*1,LIST*1,SURF*1
      CHARACTER REST*1,HATM*1,NUM*1,NOCC*1,CONV*1,CANISO*1,PACK_TEMP*1

      CHARACTER LINE*256

      integer,  allocatable :: IPOOL_MEM(:)

C ----------------
      REAL      RLATT(6)
      INTEGER   NSPGROUP,NOSETT
      CHARACTER CODE*4,DATE*9,SPGR*24
C-----------------
      PI = 4.0*ATAN(1.0)
      MD =-ABS(MDOC)-10
      M  = 99
      IF(LIST.NE.'T') THEN
        MD = 99
      ELSE
        MD = MDOC
        M  = -ABS(MDOC)-10
      ENDIF
C ---
      INVER = ' '
      NAME_TEST      = 'crossrt_scrt'
      CALL ADD_PATH(PATH_SCR,NAME_TEST)  
      NAMET      = 'crossrt_scr9'
      CALL ADD_PATH(PATH_SCR,NAMET)  
      NAMET_PH   = ' ' 
      NAMET_I    = ' ' 
      NAMES      = 'crossrt_scr5' 
      CALL ADD_PATH(PATH_SCR,NAMES)  
      NAMES_PH   = 'crossrt_scr6' 
      CALL ADD_PATH(PATH_SCR,NAMES_PH)  
      NAME       = ' '
      NAMEFS(1)  = 'crossrt_scr1'
      CALL ADD_PATH(PATH_SCR,NAMEFS(1))  
      NAMEFS(2)  = 'crossrt_scr2'
      CALL ADD_PATH(PATH_SCR,NAMEFS(2))  
      NAMEPHS(1) = 'crossrt_scr3'
      CALL ADD_PATH(PATH_SCR,NAMEPHS(1))  
      NAMEPHS(2) = 'crossrt_scr4'     
      CALL ADD_PATH(PATH_SCR,NAMEPHS(2))  
      NAMEIS(1)  = 'crossrt_scr7'
      CALL ADD_PATH(PATH_SCR,NAMEIS(1))  
      NAMEIS(2)  = 'crossrt_scr8'
      CALL ADD_PATH(PATH_SCR,NAMEIS(2))  
C ---
      NM         = 1
      NEL_SUM    = 0
      NEL        = 0
      PACK_INDEX = 1.0
      NDENSP = 0
      NZERO  = 0
      NDENSM = 0
      NTOT   = 0
      NMODEL_FL = 0 
C ------------
      NAMES2 = NAMEC
      IF(RLATT_I(1).GT.0.1) THEN
        NAMES2 = NAMET
        MODE  = 'C'
        WAT   = 'Y'
        P1    = 'Y'
        ALT   = 'Y'
        SETT  = 'N'
        REST  = 'N'
        BOV   = 0.0
        NAME  = ' '
        HATM  = 'Y'
        NUM   = 'N'
        NOCC  = 'R'
        CONV  = 'N'
        A      = RLATT_I(1)
        B      = RLATT_I(2)
        C      = RLATT_I(3)
        CALPHA = (RLATT_I(4)*180.0)/PI
        CBETA  = (RLATT_I(5)*180.0)/PI
        CGAMMA = (RLATT_I(6)*180.0)/PI

        CALL CONCRD(M,MODE,NAMEC,NAMES2,NAME,SETT,REST
     *   ,WAT,P1,HATM,NUM,NOCC,ALT,CONV
     *   ,A,B,C,CALPHA,CBETA,CGAMMA,BOV,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900

      ENDIF
C ------------
      MODE = 'E'
      DO I=1,3
        SH1(I) = 0.0
        SH2(I) = 0.0
        DO J=1,3
          AM(I,J) = 0.0
        ENDDO
      ENDDO
      IERR  = 0

      CALL TRANS(M,NAMES2,NAMER,SH1,SH2
     *  ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C      RESULT(1) = NTOT
C      RESULT(2) = XMIN
C      RESULT(3) = XMAX
C      RESULT(4) = YMIN
C      RESULT(5) = YMAX
C      RESULT(6) = ZMIN
C      RESULT(7) = ZMAX
C      RESULT(8) = XS
C      RESULT(9) = YS      (all in A)
C      RESULT(10)= ZS
C      RESULT(11)= RI
C      RESULT(12)= MODEL
C      RESULT(13)= NMODEL
C
C      MODEL = IERR
C      IF(MODEL.GT.0.AND.CR_MODEL.NE.MODEL) GO TO 200
C

      ZMIN    = RESULT( 6,1) 
      ZMAX    = RESULT( 7,1)
      X0      = RESULT( 8,1)
      Y0      = RESULT( 9,1)
      Z0      = RESULT(10,1)
      NMODEL  = RESULT(13,1) 
      N_MODEL = NMODEL
      NMODEL_FL = NMODEL 
C ---
C     CALL C_AT_CR

      CALL GET_CELL(RLATT,CODE,NAME,DATE,TTT
     *     ,NSPGROUP,NOSETT,SPGR,NSM,IERR)

      IF(LIST.EQ.'T') THEN
        WRITE(*,*) 'RLATT:',RLATT(1),RLATT(2),RLATT(3)      
        WRITE(*,*) 'RESMAX:',RESMAX,NX,NY,NZ
        WRITE(*,*) 'PST:',PST,VPST(1),VPST(2),VPST(3)
        WRITE(*,*) 'RAD_GD:',RAD_GD,PACK
        WRITE(*,*) 'IPOOL_MAX,IPOOL_CURR:',IPOOL_MAX,IPOOL_CURR
      ENDIF
C ---
      ZMIN     = RESULT(6,1) 
      ZMAX     = RESULT(7,1)
      IF(NX.LE.0) THEN
        CALL LIMHKL(RESMAX,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)
C ----
        CALL MSGDOC(MD,'Minimal grid spacing for calculation SF:') 
        WRITE(LINE,1000) NXMIN,NYMIN,NZMIN
 1000   FORMAT(' NXmin=',I3,', NYmin=',I3,', NZmin=',I3) 
        CALL MSGDOC(MD,LINE)
        NX = NXMIN
        NY = NYMIN
        NZ = NZMIN
      ENDIF 
      ZADD     =-ZMIN + 3.5
      ZMAX_NEW = ZMAX + ZADD + 3.5
      IZMIN    = 0
      IZMAX    = (ZMAX_NEW*NZ)/RLATT(3)
      IF(IZMAX.GE.NZ) IZMAX = NZ-1
      ZFADD    = ZADD/RLATT(3)

      WRITE(LINE,1010) IZMIN,IZMAX
 1010 FORMAT(' IZmin=',I3,' IZmax=',I3) 
      CALL MSGDOC(MD,LINE)

C      IPOOL_MAX = 0
       PACK_TEMP = PACK
       IF(PACK.EQ.'N') PACK = 'S'
C --------------
      IF(PACK.EQ.'Y'.OR.PACK.EQ.'P'.OR.PACK.EQ.'S') THEN
c        CALL MSGDOC(MD0,
c     *  '--- generate density for Packing function ---')
C        RAD     = 0.0
        RAD     = RAD_GD
        H2OBG_P = 0.0
        BADDD   = 0.0
        P1      = 'Y' 
        MODE    = 'S'
        IF(PACK.EQ.'S') MODE = 'U'

        MODE = 'U'

C       IF(RAD_GD.GT.0.01) THEN
C         MODE  = 'S'
C         BADDD = RAD_GD
C       ENDIF

        TTT     = ' '
        IERR    = 0
        CANISO = 'N'

c---
        N_SYM = 192
        MEM = (NX * NY * (IZMAX - IZMIN + 1))/2
        MEM = MEM + (N_SYM+4)*20 + (IZMAX - IZMIN + 1)*4 +
     *        20 + 2000      
        I   = MEM/8
        MEM = (I+1)*8
        allocate(IPOOL_MEM(1:MEM),STAT=ISTAT)
        IF(ISTAT.NE.0) THEN
          IERR = 1
          CALL MSGERR(MDOC,
     *      ' ERROR: in DENS2F_NEW : problem with memory allocation')
          CALL MSGERR(MDOC,
     *      '                        try to change resolution')
          RETURN
        ENDIF
        IF(IPOOL_MAX.GT.0) IPOOL_MAX = MEM

C --  14.10.2008 for NMR : for PF only first model
        IF(NMODEL.GT.1) IERR = 1    
c --
        CALL GENDEN_ANISO(MD,NAMER,NAMED,TTT
     *    ,RESMAX,NX,NY,NZ,IZMIN,IZMAX,MODE,RAD,H2OBG_P,BADDD,P1,ZFADD
     *    ,CANISO
     *    ,RESULT,IPRROW,IPOOL_MEM,MEM,ISYM,IPRSYM,IPOOL_MAX,IERR)
        IF(IERR.NE.0) THEN
          deallocate(IPOOL_MEM,STAT=ISTAT)
          CALL MSGERR(MDOC,'ERROR: in GENDEN_ANISO for PF')
          GO TO 900
        ENDIF
C       RESULT(18) = NDENSP
C       RESULT(19) = NZERO
C       RESULT(20) = NDENSM
        NDENSP = RESULT(18,1)
        NZERO  = RESULT(19,1)
        NDENSM = RESULT(20,1)
        NTOT   = NX*NY*(IZMAX-IZMIN+1)
        PACK_INDEX = 1.0
        T = FLOAT(NDENSP+NDENSM)
        IF(T.GT.0.0001) THEN
          PACK_INDEX = FLOAT(NDENSM)/T
          PACK_INDEX = 1.0 - PACK_INDEX
        ENDIF
c        IF(LIST.EQ.'T') THEN
c          WRITE(*,*) 'IP,NP,0,NM:',PACK_INDEX,NDENSP,NZERO,NDENSM    
c        ENDIF
C ----
        IF(PACK.NE.'S') THEN
          IAPPL       = 1
          RESULT(1,1) = 0.0
          RESULT(2,1) = 0.0
          RESULT(3,1) =-ZFADD
          RESULT(4,1) = 0.0
          RESULT(5,1) = 0.0
          RESULT(6,1) = 0.0
          IERR = 0
          IF(IAPPL.GT.  0)  IERR = 1
          IF(P1   .EQ.'Y')  IERR = IERR + 2
C         IF(PACK .EQ.'Y')  IERR = IERR + 4
C         PACK='Y' - 4, P1='Y' - 2 IAPPL>0 - 1

          CALL RFT_NEW(MD,LIST,PATH_SCR
     *     ,RESMAX,INVER,PST,VPST
     *     ,NAMED,NAMEFM_PK,NAMEPH_PK,ISYM,IPRSYM,RESULT
     *     ,IPOOL_MEM,IPOOL_MAX,IERR)

          deallocate(IPOOL_MEM,STAT=ISTAT)
          IF(IERR.NE.0) THEN
            GO TO 900
          ENDIF
C         IF(PACK.EQ.'P') GO TO 900
        ELSE
          deallocate(IPOOL_MEM,STAT=ISTAT)
        ENDIF
      ENDIF
      IF(LIST.EQ.'T') THEN
        WRITE(*,*) 'RESMAX:',RESMAX
        WRITE(*,*) 'IPOOL_MAX:',IPOOL_MAX
      ENDIF
      PACK = PACK_TEMP
      IF(PACK.EQ.'0') PACK = 'N'

      IF(NMODEL.EQ.0) NMODEL = 1
      MODEL1 = 1
      IF(NMR.EQ.0) THEN
        NMODEL = 1
      ENDIF

      IF(ITEST.GT.0) THEN
        MODEL1 = 1
        NMODEL = 300
C        IF(ITEST.EQ.2) NMODEL = 7  
      ENDIF

      IF1 = 1
      IF2 = 2
      NM  = NMODEL - MODEL1 + 1 

      N_MODEL = NM
C -
      WRITE(LINE,'(''NMR,N_MODEL,MODEL1,NMODEL,NM:'',5I4,4a)')
     *  NMR,N_MODEL,MODEL1,NMODEL,NM,';',mode_gd,mode_f,';' 
      CALL MSGDOC(MD,LINE)
C -----------
C +---
C !
C V
      DO MODEL=MODEL1,NMODEL

        IF(NMR.NE.0) THEN
          WRITE(LINE,'(''--- generate density for model:'',I4)') MODEL 
          CALL MSGDOC(MD,LINE)
        ELSE IF(ITEST.NE.0) THEN
c          WRITE(LINE,'(''--- generate density for model:'',I4)') MODEL 
c          CALL MSGDOC(MD,LINE)
          write(*,*) '-->',itest,model,mode_f
        ELSE
          CALL MSGDOC(MD,'--- generate density ---')
        ENDIF

        MODE  = MODE_GD
        IF(MODE.EQ.'B') MODE = 'A'
        BADDD = BADD_GD
        RAD   = RAD_GD

C       RAD   = 0.0

        TTT   = ' '
        IERR  = MODEL
        IF(NMR.EQ.0) IERR  = 0

C        IF(ITEST.GT.0) THEN
C          IERR        =-MODEL
C          RESULT(1,1) = X0
C          RESULT(2,1) = Y0
C          RESULT(3,1) = Z0     
C          WRITE(*,'(''--- generate density for model:'',I4)') MODEL 
Cc          WRITE(*,*) ' X0,:',X0,Y0,Z0
Cc          CALL MSGDOC(MD0,LINE)
C        ENDIF
        IF(ITEST.GT.0) THEN
          CALL PREPARE_COORD_FOR_TEST_RF(MDOC,NAMER,NAME_TEST
     *                        ,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
        ELSE
          NAME_TEST = NAMER
        ENDIF
        P1 = 'Y' 
c---
        N_SYM = 192
        MEM = (NX * NY * (IZMAX - IZMIN + 1))/2
        MEM = MEM + (N_SYM+4)*20 + (IZMAX - IZMIN + 1)*4 +
     *        20 + 2000      
        I   = MEM/8
        MEM = (I+1)*8
        allocate(IPOOL_MEM(1:MEM),STAT=ISTAT)
        IF(ISTAT.NE.0) THEN
          IERR = 1
          CALL MSGERR(MDOC,
     *      ' ERROR: in DENS2F_NEW : problem with memory allocation')
          CALL MSGERR(MDOC,
     *      '                        try to change resolution')
          RETURN
        ENDIF
        IF(IPOOL_MAX.GT.0) IPOOL_MAX = MEM

        CANISO = 'Y'
        IF(SURF.EQ.'Y') CANISO = 'N'         
        IF(SURF.EQ.'C') RAD = 0.0         
        IF(LIST.EQ.'T') THEN
          WRITE(*,*) 'RAD:',RAD
          WRITE(*,*) 'BADDD:',BADDD
          WRITE(*,*) 'H2OBG:',H2OBG
          WRITE(*,*) 'CANISO:',CANISO
          WRITE(*,*) 'MODE:',MODE
        ENDIF

        CALL GENDEN_ANISO(MD,NAME_TEST,NAMED,TTT
     *    ,RESMAX,NX,NY,NZ,IZMIN,IZMAX,MODE,RAD,H2OBG,BADDD,P1,ZFADD
     *    ,CANISO
     *    ,RESULT,IPRROW,IPOOL_MEM,MEM,ISYM,IPRSYM,IPOOL_MAX,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: in GENDEN_ANISO')
          WRITE(*,*) 'MODEL:',MODEL
          deallocate(IPOOL_MEM,STAT=ISTAT)
          GO TO 900
        ENDIF
C -----------------
C   GENDEN:
c      MODEL = IERR
c      IF(MODEL.LT.0) THEN
c        X0 = RESULT(1)
c        Y0 = RESULT(2) before  (+ ZFADD)
c        Z0 = RESULT(3)
C      ENDIF
c      IF(MODEL.GT.0.AND.MODEL.NE.CR_MODEL) --> not use
c      IF(MODEL.LT.0) THEN
C        before  (+ ZFADD) 
c        CALL SET_FLAG_USE(MODEL,XA(1),XA(2),XA(3),X0,Y0,Z0,IUSE)
c        IF(IUSE.LE.0) GO TO 1000
c      ENDIF
C      IF(MODE.EQ.'B') not use atoms with B > BLIB (=RAD)
c      ZFADD -->   Zf_new = Zf + ZFADD
C ----------------
C       RESULT(10,1) = SOLV 
C       RESULT(11,1) = BADD
C       RESULT(12,1) = NMODEL
C       RESULT(13,1) = MODEL
C       RESULT(15,1)   = NANISO
        IRES1 = RESULT(13,1)
        IRES2 = RESULT(12,1)
        NEL   = RESULT(1,1)
        NEL_SUM = NEL_SUM + NEL

        WRITE(LINE,*) 'Naniso:',RESULT(15,1)
        CALL MSGDOC(MD,LINE)
        WRITE(LINE,'('' Model,N of models,Solv,Ne:'',2I5,F8.3,I6)')
     *  IRES1,IRES2,RESULT(10,1),NEL
        CALL MSGDOC(MD,LINE)
C ----
        NAMET    = NAMES
        NAMET_PH = NAMES_PH

        IF(NM.EQ.1) THEN
          NAMET    = NAMEFM
          NAMET_PH = NAMEPH
        ENDIF
        IF(MODEL.EQ.MODEL1.AND.NM.GT.1) THEN
          NAMET    = NAMEFS (IF2)
          NAMET_PH = NAMEPHS(IF2)
          NAMET_I  = NAMEIS (IF2)
        ENDIF
C       CALL MSGDOC(MD0,'--- real fft ---')
C ----
        P1 = 'Y'
C        IF(PACK.EQ.'Y') THEN
C          IAPPL       = 1
C          RESULT(1,1) = 0.0
C          RESULT(2,1) = 0.0
C          RESULT(3,1) =-ZFADD
C          RESULT(4,1) = 0.0
C          RESULT(5,1) = 0.0
C          IERR = 0
C          IF(IAPPL.GT.  0)  IERR = 1
C          IF(P1   .EQ.'Y')  IERR = IERR + 2
C          IF(PACK .EQ.'Y')  IERR = IERR + 4
C         PACK='Y' - 4, P1='Y' - 2 IAPPL>0 - 1
C          CALL RFT_NEW(MDOC,LIST,PATH_SCR,POOL,MEMORY,RESMAX
C      *    ,NAMED,NAMEFM_PK,NAMEPH_PK,ISYM,IPRSYM,RESULT,IERR)
C        ENDIF
C ----
        IAPPL       = 1
        RESULT(1,1) = 0.0
        RESULT(2,1) = 0.0
        RESULT(3,1) =-ZFADD
        RESULT(4,1) = 0.0
        RESULT(5,1) = 0.0
        RESULT(6,1) = 0.0
        IERR = 0
        IF(IAPPL.GT.  0)  IERR = 1
        IF(P1   .EQ.'Y')  IERR = IERR + 2
C       PACK='Y' - 4, P1='Y' - 2 IAPPL>0 - 1
        CALL RFT_NEW(MD,LIST,PATH_SCR
     *   ,RESMAX,INVER,PST,VPST
     *   ,NAMED,NAMET,NAMET_PH,ISYM,IPRSYM,RESULT
     *   ,IPOOL_MEM,IPOOL_MAX,IERR)

        deallocate(IPOOL_MEM,STAT=ISTAT)
        IF(IERR.NE.0) GO TO 900
C ----
        IF(MODEL.EQ.MODEL1.AND.NM.GT.1.AND.MODE_F.NE.'I') THEN
C         NAMET --> NAMET_I  
          THRESH  = 0.0
          TOP     = 0.0
          COEF    = 0.0
          BTEMP   = 0.0 
          SCALER  = 0.0 
          RESMINR = 0.0 
          RESMAXR = 0.0 
          IZMINR  = 0 
          IZMAXR  = 0 
          MODE    = ' ' 
          TTT     = ' '
          NAME    = ' '
          CALL COPYFL(M,NAMET,NAME,NAMET_I,THRESH,TOP,COEF,BTEMP
     *           ,SCALER,RESMINR,RESMAXR,IZMINR,IZMAXR,MODE,TTT
     *           ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900               
        ENDIF

        IF(NM.GT.1)THEN
          IF(MODEL.GT.MODEL1) THEN
            IF(MODEL.EQ.NMODEL) THEN

              IF(MODE_F.EQ.'I') THEN
                NAMEFS (IF2) = NAMEFM        
              ELSE
                NAMEIS (IF2) = NAMEFM        
              ENDIF

              NAMEPHS(IF2) = NAMEPH       
            ENDIF
            
c            WRITE(*,*) '-1',NAMES
c            WRITE(*,*) '-2',IF1,NAMEFS(IF1)
c            WRITE(*,*) '-s',IF2,NAMEFS(IF2)

            IF(MODE_F.EQ.'I') THEN

              IERR    =-1
              SCALER  =-1.0
              CALL MSGDOC(M,'--- I + I ---')
              CALL FMINUSF(M,NAMET,NAMEFS(IF1),NAMEFS(IF2),SCALER
     *            ,ISYM,IPRSYM,RESULT,IPRROW,IERR)
              IF(IERR.NE.0) GO TO 900

            ELSE

              IERR    =-1
              SCALER  =-1.0
              CALL MSGDOC(M,'--- I + I ---')
              CALL FMINUSF(M,NAMET,NAMEIS(IF1),NAMEIS(IF2),SCALER
     *            ,ISYM,IPRSYM,RESULT,IPRROW,IERR)
              IF(IERR.NE.0) GO TO 900

              INVER   = 'N'
              MODE    = 'A'
              SCALER  = 1.0
              BADDD   = 0.0
              BOFFF   = 0.0
              RESMINR = 0.0
              RESMAXR = 0.0
              DO I=1,3
                SH1(I) = 0.0
              ENDDO
              CALL SFVSUM(M,MODE,SCALER,INVER
     *        ,NAMET,NAMET_PH,NAMEFS(IF1),NAMEPHS(IF1)
     *        ,NAMEFS(IF2),NAMEPHS(IF2) 
     *        ,SH1,BOFFF,BADDD,RESMINR,RESMAXR
     *        ,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C SFVSUM   sum two vectors of structure factors: (F1 + scale*F2)
C          or convolution: F1(h)*scale*F2(-h)
C     MODE:  <A>,C   - A: sum (F1 + scale*F2
C                      C: convolution F1(h)*scale*F2(-h)
              IF(IERR.NE.0) GO TO 900
            ENDIF

          ENDIF
          I   = IF1
          IF1 = IF2
          IF2 = I
        ENDIF
      ENDDO
C ^
C !
C ----  
C ---------------

      NEL = NEL_SUM
      IF(N_MODEL.GT.1) NEL = NEL_SUM/N_MODEL
      IF(PST.EQ.'Y') NEL = NEL*2

      RESULT(1,1) = PACK_INDEX
      RESULT(2,1) = NDENSP
      RESULT(3,1) = NZERO
      RESULT(4,1) = NDENSM
      RESULT(5,1) = NTOT
      RESULT(6,1) = NMODEL_FL 

 900  CONTINUE
C ---

      NAME='crossrt_scr1.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_scr2.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_scr3.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_scr4.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_scr5.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_scr6.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_scr7.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_scr8.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_scr9.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_scr9.crd'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='crossrt_scrt.crd'
      CALL DELETE_FILE(PATH_SCR,NAME)
C ---
      RETURN
      END

      SUBROUTINE PREPARE_COORD_FOR_TEST_RF(MDOC,NAMER,NAMEO
     *                         ,NSYM,ISYM,IPRSYM,IERR)
C ----------------------------------------------------------
      INTEGER   MDOC,IERR
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER   NATMX
      PARAMETER ( NATMX = 10000 )
      REAL      X(NATMX),Y(NATMX),Z(NATMX)
      REAL      OCC(NATMX),TEMP(NATMX)
      INTEGER   IRES(NATMX),NUMBER(NATMX)
      INTEGER   IRES_S(NATMX),IRES_F(NATMX)
      CHARACTER ATOM(NATMX)*4,ASYMB(NATMX)*4
      CHARACTER NAMER*(*),NAMEO*(*)
C ------------------------------------------------------------
      INCLUDE 'mr_crd_com.fh'
C -----------------------------------------------------------
      M     = 99
      MD    =-ABS(MDOC)-1
      IERR  = 0
C      
      IVAR = 1
C
C       OMIT
      IVAR = 2 
c
c      ivar 1  by residues
c      IVAR = 3
C ---
      INC   = 10
      IOUT  = 11
      MODE  = 0
      IEND  =-1
      IENDW =-1
      N     = 0
      NRES  = 0
      IRES_OLD =-1000
C -------
      CALL ORCRD(M,INC,NAMER,NSYM,ISYM
     *           ,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: test: can not open input file')
        RETURN
      ENDIF
C ---------
 100  CONTINUE

      CALL RDCRD(M,INC,MOD,IEND,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: test: reading input file')
        RETURN
      ENDIF
      IF(IEND.NE.0) GO TO 110

      IF(MOD.EQ.0) THEN
        IF((CR_ATYPE .EQ.' '.OR.CR_ATYPE .EQ.'.'.OR.
     *      CR_ATYPE .EQ.'y'.OR.CR_ATYPE .EQ.'Y'.OR.
     *      CR_ATYPE .EQ.'r'.OR.CR_ATYPE .EQ.'R').AND.
     *      CR_OCC .GT.0.0001                        ) THEN
             
          IF(CR_ALT.NE.'.'.AND.CR_ALT.NE.' '.AND.
     *       CR_ALT.NE.'A'.AND.CR_ALT.NE.'1') GO TO 100

          IF(CR_ASYMB(1:2).EQ.'H '.OR.CR_ASYMB(1:2).EQ.'D ') GO TO 100
          IF(CR_RNAME.EQ.'HOH') GO TO 100

          N = N + 1
          IF(N.GT.NATMX) THEN
            WRITE(LINE,*) ' ERROR: test: too many atoms > ',NATMX
            CALL MSGERR(MDOC,LINE)
            IERR=1
            RETURN
          ENDIF
          IF(CR_IRES.NE.IRES_OLD) THEN
            NRES = NRES + 1
            IRES_S(NRES) = N
            IRES_OLD = CR_IRES
          ENDIF
          IRES_F(NRES) = N
           
          ATOM  (N) = CR_ANAME
          IRES  (N) = CR_IRES
          X     (N) = CR_XYZ(1)
          Y     (N) = CR_XYZ(2)
          Z     (N) = CR_XYZ(3)
          OCC   (N) = CR_OCC
          TEMP  (N) = CR_BISO
          ASYMB (N) = CR_ASYMB
          NUMBER(N) = N
        ENDIF

      ELSE

      ENDIF
      GO TO 100
C ---------------------------------
  110 CONTINUE
      NATOM = N
      CLOSE (INC)
C ----------------------------------
      IF(NATOM.LE.1) THEN
        WRITE(LINE,*) ' ERROR: test: Natom =< 1 '
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF
C--------------------------------------
      IF(IVAR.EQ.2) THEN
        FRAC_OMIT = 0.1 
        NOMIT = FLOAT(NATOM)*FRAC_OMIT
        IF(NOMIT.LE.0) NOMIT = 1 
        NREST = NATOM - NOMIT
        IF(NREST.LE.0) NREST = 1 
        NH = 0
        INIT = 0
        DO I=1,1000000
        CALL HSRD_TIME(A,NH,INIT)
C          -P- HSRD - gives A - random variable / -0.5 =< A =< 0.5 /
          A = A + 0.5
          K = FLOAT(NATOM)*A + 1.0
          IF(K.LE.    0) K = 1
          IF(K.GT.NATOM) K = NATOM
          IF(NUMBER(K).GT.0) THEN
            NUMBER(K) = 0
            NN = NN + 1
            IF(NN.GE.NOMIT) GO TO 300
          ENDIF
        ENDDO
  300   CONTINUE
      ENDIF
C--------------------------------------
      CALL OWCRD(MD,IOUT,NAMEO,NSYM,ISYM
     *             ,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: test: can not open output file')
        RETURN
      ENDIF
C--------------------------------------
      CALL ORCRD(MD,INC,NAMER,NSYM,ISYM
     *           ,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: test:: can not open input file')
        CLOSE(IOUT) 
        RETURN
      ENDIF
C -------------------------------------
      IEND  =-1
      I = 0
      NA = 0
      NR = 0
      NH = 0
      INIT=0
 200  CONTINUE

      CALL RDCRD(M,INC,MODE,IEND,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: test: reading input file')
        CLOSE(INC) 
        CLOSE(IOUT) 
        RETURN
      ENDIF
      IF(IEND.NE.0) GO TO 210

      IF(MODE.EQ.0) THEN

        IF((CR_ATYPE .EQ.' '.OR.CR_ATYPE .EQ.'.'.OR.
     *      CR_ATYPE .EQ.'y'.OR.CR_ATYPE .EQ.'Y'.OR.
     *      CR_ATYPE .EQ.'r'.OR.CR_ATYPE .EQ.'R').AND.
     *      CR_OCC .GT.0.0001                        ) THEN

          IF(CR_ALT.NE.'.'.AND.CR_ALT.NE.' '.AND.
     *       CR_ALT.NE.'A'.AND.CR_ALT.NE.'1') GO TO 200

          IF(CR_ASYMB(1:2).EQ.'H '.OR.CR_ASYMB(1:2).EQ.'D ') GO TO 200
          IF(CR_RNAME.EQ.'HOH') GO TO 200

          I = I + 1

C ====
          IF(IVAR.EQ.1) THEN
            CALL HSRD_TIME(A,NH,INIT)
CC          -P- HSRD - gives A - random variable / -0.5 =< A =< 0.5 /
            A = A + 0.5
            K = FLOAT(NATOM)*A + 1.0
            IF(K.LE.    0) K = 1
            IF(K.GT.NATOM) K = NATOM
            NA = NA + 1
            CR_BISO   = TEMP(K)
            CR_OCC    = OCC(K)
            CR_ASYMB  = ASYMB(K)
            CR_ANAME  = ATOM(K)
            CR_IRES   = IRES(K)
            CR_XYZ(1) = X(K)
            CR_XYZ(2) = Y(K)
            CR_XYZ(3) = Z(K)
          ENDIF
C ====
          IF(IVAR.EQ.3) THEN
            CALL HSRD_TIME(A,NH,INIT)
CC          -P- HSRD - gives A - random variable / -0.5 =< A =< 0.5 /
            A = A + 0.5
             KK = FLOAT(NRES)*A + 1.0
            IF(KK.LE.    0) KK = 1
            IF(KK.GT.NRES) KK = NRES
            NR = NR + 1
            DO K=IRES_S(KK),IRES_F(KK)
              NA = NA + 1
              CR_BISO   = TEMP(K)
              CR_OCC    = OCC(K)
              CR_ASYMB  = ASYMB(K)
              CR_ANAME  = ATOM(K)
              CR_IRES   = IRES(K)
              CR_XYZ(1) = X(K)
              CR_XYZ(2) = Y(K)
              CR_XYZ(3) = Z(K)
            ENDDO
            IF(NR.GE.NRES) GO TO 210
          ENDIF
C ==
          IF(IVAR.EQ.2) THEN
            IF(NUMBER(I).LE.0) GO TO 200
            K =NUMBER(I)
            NA = NA + 1
            CR_BISO   = TEMP(K)
            CR_OCC    = OCC(K)
            CR_ASYMB  = ASYMB(K)
            CR_ANAME  = ATOM(K)
            CR_IRES   = IRES(K)
            CR_XYZ(1) = X(K)
            CR_XYZ(2) = Y(K)
            CR_XYZ(3) = Z(K)
          ENDIF
C ==
        ENDIF

      ELSE
            
      ENDIF

      CALL WRCRD(M,IOUT,MODE,IENDW,IERR)
      IF(IERR.NE.0) THEN
        CLOSE(INC) 
        RETURN
      ENDIF

      GO TO 200
C -------------------------
 210  CONTINUE
      CLOSE(INC) 
      IENDW = 1
      MODE  = 0
      CALL WRCRD(M,IOUT,MODE,IENDW,IERR)

      WRITE(*,*) '--Natom,Na:',NATOM,NA
      WRITE(*,*) '--Nres,Nr :',NRES,NR

      RETURN
      END

C ******
      SUBROUTINE HSRD_TIME(A,N,INIT)
C -P- HSRD - gives A - random variable / -0.5 =< A =< 0.5 /
C
C ******
      INTEGER IH(7)
      INTEGER INIT,N
C      DATA INIT/0/,N/0/
C -----------------------------------------
      IF(INIT.EQ.0) THEN
C        N    = 1342773
        CALL CLOCK(IH)
        N = IH(2)+(IH(3)+IH(4)*60)*60 
        INIT = 1
      ENDIF

c     N = N*65539 + 2147483647 + 1

      N = N*65539 + 21474836 + 1

      A = ABS(N*.4656613E-9)-.5
      RETURN
      END


      SUBROUTINE RFT1_NEW(MDOC,POOL8,POOLA,POOLB,NCRES,RESMAX
     * ,INVER,PST,VPST
     * ,NAMED,NAMEF,NAMEPH,IPRSYM,ISUM
     * ,P1,IAPPL,SHIFT,CSCALE,BSCALE,FPACK,DSCALE
     * ,LIM,DLIM
     * ,SFA,SFB,SYM,JHS,JKS,JLS,LSYM,ISYM
     * ,RESULT,IPOOL_MEM,JPOOL_MAX,IERR)
C ---------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER   ID(3),IDT(7)
      REAL      RESULT(*),VPST(*)
      COMPLEX   POOL8(*)
      REAL      POOLA(*),POOLB(*)
      REAL      RLATT(6),SHIFT(3),CENTRE(3),SHFT(3)
      REAL      SFA(IPRSYM),SFB(IPRSYM)
      INTEGER   JHS(IPRSYM),JKS(IPRSYM),JLS(IPRSYM),LSYM(IPRSYM)
      REAL      SYM(3,IPRSYM)
      CHARACTER LINE*256
      CHARACTER NAMED*(*),NAMEF*(*),NAMEPH*(*),P1*1,FPACK*1
      CHARACTER TITLE*80,ITYPE*4,PATT*4
      CHARACTER CODE*4,NAMET*40,DATE*9,SPGR*24
      CHARACTER INVER*1,PST*1,LIM*1      
C ----
      INTEGER           IPOOL_MEM(*)
      COMMON/COM_DPOOL/ IPOOL_MAX,IPOOL_CURR
C--------------------------------------------------------------
      TWOPI = 8.0*ATAN(1.0)
      IERR  = 0
C --------------------
      MTIN  = 40
      ITYPE = 'RI  '
      MD    =-ABS(MDOC)-1
      M     = 99
C ------------------------------
      IPOOL_MAX  = JPOOL_MAX
      IPOOL_CURR = 0
      ITYP  = 0
      CALL IRDENS_MEM(MTIN,NAMED,MD,ITYP,ICNTZ,NX,NY,NZ,IZM,
     * IZN,RMAX,RMIN,POOLA,SCALE,A,B,C,AL,BE,GA,DRMS,
     * RAVER,RESOL,IX0,IY0,IZ0,ITR,TITLE
     * ,NSYM,ISYM,IPRSYM,IPOOL_MEM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: FILE--DENS (RFT)')
        IF(IPOOL_MAX.LE.0) CLOSE(MTIN)
        IERR=1
        RETURN
      ENDIF
      CALL C_RD_CR
      NXY = NX*NY
      IF(IZN.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: IZMIN # 0 (in RFT)')
        IERR=1
        RETURN
      ENDIF

      IF(NXY.GT.NCRES) THEN
        WRITE(LINE,
     *  '('' ERROR: RFT: not memory enough'',I4,'' x'',I4,'' >'',I8)')
     *             NX,NY,NCRES
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF
      IF(TITLE(1:4).EQ.'PATT') THEN
        PATT='Y'
      ELSE
        PATT='N'
      ENDIF
      NSYM_OUT = NSYM
      IF(NSYM.EQ.1) P1 = 'N'
      IF(P1.EQ.'Y') NSYM = 1
      NSYM_OUT = NSYM 
C  ------------------------------------
      A = A*DSCALE
      B = B*DSCALE
      C = C*DSCALE
      RLATT(1) = A
      RLATT(2) = B
      RLATT(3) = C
      RLATT(4) = AL
      RLATT(5) = BE
      RLATT(6) = GA
      CALL DSTARF(RLATT,AST,BST,CST,COALST,COBEST,COGAST,VOL)
      CALL ANOMF(M,NSYM,ISYM)
      IF(RESMAX.LT.1.E-4) RESMAX=RESOL
      DO     I=1,NSYM
        IF(ISYM(3,1,I).NE.0.OR.ISYM(3,2,I).NE.0.OR.
     *     (ISYM(3,3,I).NE.1.AND.ISYM(3,3,I).NE.-1)) THEN
          IERR=-1
          IF(IPOOL_MAX.LE.0) CLOSE(MTIN)
          RETURN
        ENDIF
        DO     J=1,3
          SYM(J,I)=(TWOPI*REAL(ISYM(4,J,I)))/REAL(ISYM(5,J,I))
        ENDDO
      ENDDO
C ---------------------------------------------------
      RHMIN = 10.0
      IH    = 1
      IK    = 0
      IL    = 0
      CALL DSTAR(IH,IK,IL,RH)
      RH = SQRT(RH)
      IF(RH.LT.RHMIN) RHMIN=RH
      IH = 0
      IK = 1
      IL = 0
      CALL DSTAR(IH,IK,IL,RH)
      RH = SQRT(RH)
      IF(RH.LT.RHMIN) RHMIN=RH
      IH = 0
      IK = 0
      IL = 1
      CALL DSTAR(IH,IK,IL,RH)
      RH = SQRT(RH)
      IF(RH.LT.RHMIN) RHMIN=RH
      RESMIN = 1./RHMIN
C ------------------------------------------
      IF(P1.EQ.'Y') THEN
        CODE     = 'XXXX'
        NAMET    = '----------------------'
        DATE     = 'XX-XXX-XX'
        SPGR     = 'P 1'
        NSPGROUP = 1
        NOSETT   = 1
        CALL SET_CELL(RLATT,CODE,NAMET,DATE,TITLE
     *    ,NSPGROUP,NOSETT,SPGR,IERR)
      ENDIF
C --
      CALL LENSTR_BL(NAMEPH,LEN)
      IF(LEN.GT.0.AND.NAMEPH(1:1).NE.' '.AND.NAMEPH(1:1).NE.',') THEN
        MTPH = 33
      ELSE
        MTPH = 0
      ENDIF
      IF(ISUM.GT.0) MTPH =-1
      MTF = 30
      IF(MTPH.NE.0) THEN
        TITLE(1:4) = 'F   '
        ITYPE      = 'F   '
      ELSE
        TITLE(1:4) = 'COEF'
        ITYPE      = 'COEF'
      ENDIF
      TITLE(5:8) = 'RFT '
      F1         = 1.0
      F2         = 0.0
      CALL C_CR_WR

c --
      IT = RESMIN*1000.0 
c      IT = IT + 1
      RESMIN = FLOAT(IT)/1000.0
      IT = RESMAX*1000.0 
c      IT = IT - 1
      RESMAX = FLOAT(IT)/1000.0

      RHMIN = 1.0/RESMIN
      RHMAX = 1.0/RESMAX

c --

      CALL SET_TITLE(MDOC,A,B,C,
     *  AL,BE,GA,F1,F2,RESMIN,RESMAX,
     *  IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
      CALL OWFILE(MDOC,MTF,NAMEF,ITYPE,NSYM_OUT,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open FILE-F (in RFT)')
        IF(IPOOL_MAX.LE.0) CLOSE(MTIN)
        RETURN
      ENDIF

      IF(MTPH.GT.0) THEN
        MTPH       = 33
        TITLE(1:4) = 'PH  '
        TITLE(5:8) = 'RFT '
        ITYPE      = 'PH  '
        CALL SET_TITLE(MD,A,B,C,
     *    AL,BE,GA,F1,F2,RESMIN,RESMAX,
     *    IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
        CALL OWFILE(MD,MTPH,NAMEPH,ITYPE,NSYM_OUT,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: open FILE-PH (in RFT)')
          IF(IPOOL_MAX.LE.0) CLOSE(MTIN)
          CLOSE(MTF)
          RETURN
        ENDIF
      ENDIF
C -------------------------------------------------------
      RHMAX=1./RESMAX
      WRITE(LINE,'('' IX0,IY0,IZ0,ITR:'',4I4)') IX0,IY0,IZ0,ITR
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' RESOLUTION:'',F7.3)') RESMAX
      CALL MSGDOC(MDOC,LINE)
      CALL LIMHKL(RESMAX,IHMAX,IKMAX,LMAX,NXMIN,NYMIN,NZMIN)
      WRITE(LINE,'('' Ipool_max :'',I12)') IPOOL_MAX
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' For this resolution:')
      WRITE(LINE,1020) IHMAX,IKMAX,LMAX
 1020 FORMAT(' Hmax,Kmax,Lmax :',3I4)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,1021) NXMIN,NYMIN,NZMIN
 1021 FORMAT(' NXmin,NYmin,NZmin :',3I4)
      CALL MSGDOC(MDOC,LINE)
c      IHMAX  =(NX+2)/2
      LINE = ' P1:'//P1//'; PACK:'//FPACK//';INVER:'//INVER//';'
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' ISUM,IAPPL :'',2I5)') ISUM,IAPPL
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' LIM,DLIM :'',A,F12.4)') LIM,DLIM
      CALL MSGDOC(MDOC,LINE)

c      IKMAX  =(NY+2)/2
c      LMAX   =(NZ+2)/2
c      WRITE(LINE,1022) IHMAX,IKMAX,LMAX
c 1022 FORMAT(
c     * ' From NX,NY,NZ of dens-file Hmax,Kmax,Lmax are :',3I4)
c      CALL MSGDOC(MDOC,LINE)
      LMAX1 = LMAX+1
      NZ1   = IZM+1
      NX1   = NX+1
      NX2   = NX+2
      NXB2  = NX/2
      NYB2  = NY/2
      ZER   = 0.0
      COEF  = (NX*NY*NZ)/(VOL)
      FMIN  = 0.0
C ------
      DELANG = TWOPI/FLOAT(NZ)
      DELSN  = SIN(DELANG)
      DELCS  = COS(DELANG)
      CSAN   = 1.0
      SNAN   = 0.0
      CENTRE(1) = FLOAT(IX0)/FLOAT(NX) 
      CENTRE(2) = FLOAT(IY0)/FLOAT(NY) 
      CENTRE(3) = FLOAT(IZ0)/FLOAT(NZ) 
      SHFT(1)   = SHIFT(1) - CENTRE(1) 
      SHFT(2)   = SHIFT(2) - CENTRE(2) 
      SHFT(3)   = SHIFT(3) - CENTRE(3) 
c      IF(IAPPL.GT.0) THEN
        WRITE(LINE,'('' center:'',3F8.3)') CENTRE(1),CENTRE(2),CENTRE(3)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'('' Shift:'',3F8.3)') SHIFT(1), SHIFT(2), SHIFT(3)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'('' Shft :'',3F8.3)') SHFT(1), SHFT(2), SHFT(3)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'('' Cscale,Bscale:'',2F8.2)') CSCALE,BSCALE
        CALL MSGDOC(MDOC,LINE)
c      ENDIF
C ------
      NBL   = 0
      NBL11 = 0
      IENDN =-1
      IEND  =-1
      IEND1 =-1
      NUMB  = 0
      PST_COEF = 1.0
C ---
      SUMF  = 0.
      SF2C  = 0.
C ---
      ID(1) = NX
      ID(2) = NY
      ID(3) = 0
C ---
      N000 = 0
C -----------------------------------
      CALL RDINDX_NEW(IHN,IKN,ILN,IHMAX,IKMAX,LMAX
     * ,RHMIN,RHMAX,RSQ,NSYM,ISYM,IPRSYM,IENDN)
      IF(IENDN.EQ.1) GO TO 200
C ==============================================
      LINE=' '
      CALL MSGDOC(MDOC,LINE)
      DO     IL=1,LMAX1
C -------------------------------------
        CALL CLOCK(IDT)
        ILR=IL-1
        WRITE(LINE,'(''    L='',I5,10X,I2,''.'',I2,''.'',I2)')
     .           ILR,IDT(4),IDT(3),IDT(2)
        M=99         
        IF(MDOC.GE.0.AND.MDOC.LT.99) M=0
        CALL MSGDOC(M,LINE)
C ----------------------------
        CALL INDENS_NEW(MTIN,NAMED,NSYM,ISYM,IPRSYM
     *    ,NZ,NZ1,NXY,POOLA,POOLB,POOL8,CSAN,SNAN,NP_POS
     *    ,LIM,DLIM,FPACK,COEF,DELCS,DELSN,MDOC,IPOOL_MEM,IERR)
        IF(IERR.GT.0) THEN
          IF(IPOOL_MAX.LE.0) CLOSE(MTIN)
          CLOSE(MTF)
          IF(MTPH.GT.0) CLOSE(MTPH)
          RETURN
        ENDIF
C  ---------------------------
        CALL MDCFT2(POOL8,ID,IERR)
        IF(IERR.GT.0) THEN
          CALL MSGERR(MDOC,' ERRor: IN MDCFT2 (in RFT)')
          IF(IPOOL_MAX.LE.0) CLOSE(MTIN)
          CLOSE(MTF)
          IF(MTPH.GT.0) CLOSE(MTPH)
          RETURN
        ENDIF
C -----------------------------------------------------
        IF(ILR.EQ.0) THEN
          F000 = (POOLA(2)*NSYM)/(COEF)
          IF(PATT.EQ.'Y') F000 =SQRT(ABS(F000))
          IF(IAPPL.GT.0) THEN
            F000 = F000*CSCALE 
          ENDIF
          IF(PST.EQ.'Y') THEN
            F000 = F000*(1.0+PST_COEF)
          ENDIF
C          IF(FPACK.EQ.'Y') THEN
C            F000 = 1.0
C            FMIN = 0.000001
C          ELSE
C            FMIN = F000*0.000001
C          ENDIF
          IF0  = 0
          MH   = 0
          MK   = 0
          ML   = 0
          FA   = 1.
          FB   = 0.
          CALL WRT (MTF ,MH,MK,ML,F000,ZER,NBL,IEND )
          IF(MTPH.GT.0) CALL WRT1(MTPH,MH,MK,ML,FA,FB,NBL11,IEND1)
          N000 = 1
        ENDIF
        SUMF2 = 0.0
C------------------------------------------------------
  500   IF(ILN.LT.ILR) GO TO 400
        IF(ILN.GT.ILR) GO TO 300
        IF(IABS(IHN).GE.NXB2.OR.IABS(IKN).GE.NYB2) GO TO 400
        MH = IHN
        MK = IKN
        ML = ILN
        NS = 0
C---------------
        DO     I=1,NSYM
          IHS = ISYM(1,1,I)*IHN+ISYM(1,2,I)*IKN+ISYM(1,3,I)*ILN
          IKS = ISYM(2,1,I)*IHN+ISYM(2,2,I)*IKN+ISYM(2,3,I)*ILN
          ILS = ISYM(3,1,I)*IHN+ISYM(3,2,I)*IKN+ISYM(3,3,I)*ILN
          LSYM(I) = 1
          IF(ILS.LT.0) THEN
            IHS =-IHS
            IKS =-IKS
            ILS =-ILS
            LSYM(I)=-LSYM(I)
          ENDIF
          IF(IABS(IKS).GE.NYB2) GO TO 400
          IF(IABS(IHS).GE.NXB2) GO TO 400
          NS      = NS+1
          JHS(NS) = IHS
          JKS(NS) = IKS
          JLS(NS) = ILS
        ENDDO
C ---------------------
        IF(NS.EQ.0) GO TO 400
C ---------------------
        FA=0.0
        FB=0.0
        DO     I=1,NS
          IHS = JHS(I)
          IKS = JKS(I)
          ILS = JLS(I)
          IF(IKS.LT.0) IKS=IKS+NY
          IKSS = IKS
          IKS  = IKS*NX
          IF(IHS.LT.0) IHS=IHS+NX
          IND1 = IKS+IHS+1
          IND  = IND1*2
          IF(ABS(ILS).EQ.ML) THEN

            SFA(I) = POOLA(IND)/COEF
            SFB(I) =-POOLB(IND)/COEF

            IF(IAPPL.GT.0) THEN
              ARG    = 
     *          TWOPI*(JHS(I)*SHFT(1)+JKS(I)*SHFT(2)+JLS(I)*SHFT(3))
              COSD   = COS(ARG)
              SIND   = SIN(ARG)
              STOR   = SFA(I)*COSD-SFB(I)*SIND
              SFB(I) = SFB(I)*COSD+SFA(I)*SIND
              SFA(I) = STOR
            ENDIF

            IF(LSYM(I).LT.0) SFB(I)=-SFB(I)
            ARG    = MH*SYM(1,I)+MK*SYM(2,I)+ML*SYM(3,I)
            COSD   = COS(ARG)
            SIND   = SIN(ARG)
            STOR   = SFA(I)*COSD-SFB(I)*SIND
            SFB(I) = SFB(I)*COSD+SFA(I)*SIND
            SFA(I) = STOR
            FA     = FA + SFA(I)
            FB     = FB + SFB(I)
            IF(ISUM.GT.0) THEN
              F2     = SFA(I)*SFA(I)+SFB(I)*SFB(I)
              SUMF2  = SUMF2 + F2
            ENDIF
          ENDIF
        ENDDO
C----------------------------------------
        IF(INVER.EQ.'Y') THEN
          FB = -FB
        ENDIF
        IF(PST.EQ.'Y') THEN
          ARG  = TWOPI*(MH*VPST(1)+MK*VPST(2)+ML*VPST(3))
          COSD = COS(ARG)
          SIND = SIN(ARG)
          FA2  = FA*COSD-FB*SIND 
          FB2  = FB*COSD+FA*SIND 
          FA   = FA + FA2*PST_COEF
          FB   = FB + FB2*PST_COEF
        ENDIF

        FD  = FA*FA+FB*FB
        FD2 = FD
        FD  = SQRT(FD)
        FDD = FD
        IF(ISUM.GT.0) FDD = SQRT(SUMF2)
 
        IF(FDD.GE.FMIN) THEN
          SF2C = SF2C+FD2
          SUMF = SUMF+FDD
          NUMB = NUMB+1
C
          FA  = FA/FD
          FB  = FB/FD

          IF(PATT.EQ.'Y') THEN
            FDD = SQRT(ABS(FDD))
          ENDIF

          IF(IAPPL.GT.0) THEN
            BT  = BSCALE/4.0
            X   = CSCALE*EXP(-BT*RSQ)
            FDD = FDD*X 
          ENDIF

          IF(MTPH.GT.0) THEN
            CALL WRT(MTF  ,MH,MK,ML,FDD,ZER,NBL  ,IEND )
            CALL WRT1(MTPH,MH,MK,ML,FA ,FB ,NBL11,IEND1)
          ELSE IF(MTPH.LT.0) THEN
            CALL WRT(MTF  ,MH,MK,ML,FDD,ZER,NBL  ,IEND )
          ELSE
            FA = FDD*FA
            FB = FDD*FB
            CALL WRT(MTF  ,MH,MK,ML,FA,FB,NBL  ,IEND )
          ENDIF
C
        ENDIF
C --------------------------------
  400   CONTINUE
        CALL RDINDX_NEW(IHN,IKN,ILN,IHMAX,IKMAX,LMAX
     *  ,RHMIN,RHMAX,RSQ,NSYM,ISYM,IPRSYM,IENDN)
        IF(IENDN.GT.0) GO TO 200
        GO TO 500
C ------------------------------------------------
  300   CONTINUE
      ENDDO
C  ===============================================
  200 CONTINUE
      IEND  = 2
      IEND1 = 2
      CALL WRT (MTF ,MH,MK,ML,FD,ZER,NBL  ,IEND )
      IF(MTPH.GT.0) CALL WRT1(MTPH,MH,MK,ML,FA,FB ,NBL11,IEND1)
C      CLOSE(MTF)
C      CLOSE(MTPH)
      IF(IPOOL_MAX.LE.0) CLOSE(MTIN)
C------------------------
      IF(NUMB.GT.0) THEN
        SUMF = SUMF/NUMB
        SF2C = SF2C/NUMB
      ENDIF
      SUMF = SQRT(ABS(SF2C))  
      NUMB = NUMB+N000
      WRITE(LINE,1010) NUMB,SUMF,SF2C
 1010 FORMAT(' WRITE NUMB OF REFLS=',I8,' <F-MOD>=',G15.4,
     * ' <F**2>=',G15.4)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' F000,VOL,C:'',3G15.4)') F000,VOL,COEF
      CALL MSGDOC(MDOC,LINE)
      RESMIN = 1./RHMIN
      WRITE(LINE,'('' RESOLUTION:'',2F7.3)') RESMIN,RESMAX
      CALL MSGDOC(MDOC,LINE)

      T1 = FLOAT(NP_POS)/FLOAT(NZ1*NXY)
      T2 = (VOL *FLOAT(NZ1))/FLOAT(NZ)
      VOL_POS = T1*T2

C -------------------------------------------------
      RESULT(1) = NUMB
      RESULT(2) = RESMIN
      RESULT(3) = RESMAX
      RESULT(4) = F000
      RESULT(5) = SUMF
      RESULT(6) = SF2C
      RESULT(7) = VOL
      RESULT(8) = VOL_POS
      IF(NUMB.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: Number of reflections = 0 (in RFT)')
        IERR=1
      ENDIF
      RETURN
      END

      SUBROUTINE INDENS_NEW(MTIN,NAMED,NSYM,ISYM,IPRSYM
     *  ,NZ,NZ1,NXY,POOLA,POOLB,POOL8,CSAN,SNAN,NP_POS
     *  ,LIM,DLIM,PACK,COEF,DELCS,DELSN,MDOC,IPOOL_MEM,IERR)
C --------------------------------------------------------
      COMPLEX   POOL8(*)
      REAL      POOLA(*),POOLB(*)
      INTEGER*2 ISYM(5,3,IPRSYM)
C ----
      INTEGER           IPOOL_MEM(*)
      COMMON/COM_DPOOL/ IPOOL_MAX,IPOOL_CURR
C --------------------------------
      REAL      RLINE(20)

C      INTEGER*2 IBLOCK(1024)

      INTEGER   IBLOCK(512)
      INTEGER*2 IBLCK2(1024)
      EQUIVALENCE (IBLCK2(1),IBLOCK(1))


      COMPLEX   DM
      CHARACTER NAMED*(*),TYPE*4,PACK*1,LIM*1
      DATA      NRMAX/1024/,NW4/4/,NW20/20/
C -------------------------------------------------------------
      TWOPI = 8.0*ATAN(1.0)
      IERR  = 0
      IF(IPOOL_MAX.LE.0) THEN
        REWIND MTIN
      ELSE
        IPOOL_CURR = 0
      ENDIF
      ZERO     = 0.0
      DM       = CMPLX(ZERO,ZERO)
      POOLA(1) = 0.0
      DO  I=1,NXY
        POOL8(I)=DM
      ENDDO

      CSZL = 1.
      SNZL = 0.
      NP_POS = 0

C-------------
C      CALL RBLOCK(MTIN,RLINE,NW20,IERR)
C      IF(IERR.NE.0) THEN
C        CALL MSGDOC(MDOC,' ERR: READ FILE-DENS')
C        RETURN
C      ENDIF
C      CALL RBLOCK(MTIN,RLINE,NW20,IERR)
C      IF(IERR.NE.0) THEN
C        CALL MSGERR(MDOC,' ERR: READ FILE-DENS')
C        RETURN
C      ENDIF
C ------------
      TYPE = 'RI  '
      MD   = 99
      CALL OPFILE_MEM(MD,MTIN,NAMED,TYPE,NS,ISYM,IPRSYM,IPOOL_MEM,IERR)
      IF(IERR.GT.0) THEN
        IERR=4
        CALL MSGERR(MDOC,' ERROR: READ FILE-DENS (RFT)')
        MTIN=0
        RETURN
      ENDIF
C-------------
      DO     IZ=1,NZ1
        CALL RBLOCK_MEM(MTIN,RLINE,NW4,IPOOL_MEM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: READ FILE-DENS (RFT)')
          RETURN
        ENDIF
C ::::::
C ----- CALL RBLOCK(MTIN,IPOOL,NXY2,IERR)
C ::::::
        IXY = 0
        NR0 = 0
        NR1 = 1
77710   NR2 = NR0+NRMAX
        IF(NR2.GT.NXY) THEN
          NRR=NXY-NR0
        ELSE
          NRR=NRMAX
        ENDIF
        NRR2 = NRR/2

        IF(IPOOL_MAX.LE.0) THEN
          READ(MTIN,ERR=9) (IBLOCK(II),II=1,NRR2)
        ELSE
          IF((IPOOL_CURR + NRR2).GT.IPOOL_MAX) GO TO 9
          DO JR=1,NRR2
            IBLOCK(JR) = IPOOL_MEM(IPOOL_CURR+JR)
          ENDDO
          IPOOL_CURR = IPOOL_CURR + NRR2
        ENDIF

        DO     I=1,NRR
          IXY        = IXY+2
          DNS        = REAL(IBLCK2(I))/RLINE(2)
          
          IF(LIM.EQ.'Y') THEN 
            DNS = DNS - DLIM
            IF(DNS.LT.0.0) DNS = 0.0
          ENDIF
          
          IF(PACK.EQ.'Y') THEN 
            IF(DNS.GT.0.01) THEN
              DNS = 1.0
            ELSE
              DNS = 0.0
            ENDIF 
          ENDIF

          IF(DNS.GT.0.0) NP_POS = NP_POS + 1

          POOLA(IXY) = POOLA(IXY)+DNS*CSZL
          POOLB(IXY) = POOLB(IXY)-DNS*SNZL
        ENDDO
C:::::::::
        NR0 = NR0+NRR
        NR1 = NR1+NRR
        IF(NR1.LE.NXY) GO TO 77710
C:::::::::
        STOR = SNZL*CSAN+CSZL*SNAN
        CSZL = CSZL*CSAN-SNZL*SNAN
        SNZL = STOR
      ENDDO
      STOR = SNAN*DELCS+CSAN*DELSN
      CSAN = CSAN*DELCS-SNAN*DELSN
      SNAN = STOR

      RETURN
C --------------------------------------------------
    9 CALL MSGERR(MDOC,' ERROR: READ INPUT-FILE-DENS (RFT)')
      IERR=1
      RETURN
      END

      SUBROUTINE RDINDX_NEW(IH,IK,IL,IHMAX,IKMAX,ILMAX
     * ,RSMIN,RSMAX,RSQ,NSYM,ISYM,IPRSYM,IEND)
C ----------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
C ----------------------------------------------------
      RSQ = 0.0
 100  CONTINUE
      IF(IEND.EQ.-1) THEN
        IL   = 0
        IK   =-IKMAX
        IH   =-IHMAX-1
        IEND = 0
      ENDIF
      IH = IH+1
      IF(IH.GT.IHMAX) THEN
        IH =-IHMAX
        IK = IK+1
        IF(IK.GT.IKMAX) THEN
          IK =-IKMAX
          IL = IL+1
          IF(IL.GT.ILMAX) THEN
            IEND=1
            RETURN
          ENDIF
        ENDIF
      ENDIF
      IF(IH.EQ.0.AND.IK.EQ.0.AND.IL.EQ.0) GO TO 100
      CALL DSTAR(IH,IK,IL,RSQ)
      RS=SQRT(RSQ)
      IF(RS.GT.RSMAX)      GO TO 100
      CALL SYSABS_BL(IH,IK,IL,NSYM,ISYM,ICND)
      IF(ICND.NE.0) GO TO 100
      NH = IH
      NK = IK
      NL = IL
      CALL ANOMSC(NH,NK,NL,KANOM,JJSYM,NSYM,ISYM)
      IF(JJSYM.NE.1.OR.KANOM.NE.1) GO TO 100
      IF(RS.LT.RSMIN) RSMIN=RS
      RETURN
      END

      SUBROUTINE PEAKSRCH_RF(MDOC,NAME,NAMEO,ALEVEL,DIST_LIM,SPEC
     *   ,NPMAX,NP_LIM,PROG,RESMAX,RAD,NP_SRF,NAME_TSRF,DELTA,NCS
     *   ,ISYM,IPRSYM,RESULT,RESULTA,IPRMAX,IPRROW,IERR)
C ---------------------------------------------------
C ------------------------------
      REAL      RESULT(IPRMAX,IPRROW)
      REAL      RESULTA(IPRMAX,IPRROW)
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER NAME*(*),NAMEO*(*),NAME_TSRF*(*),SPEC*1,PROG*4
      REAL      ALEVEL,DIST_LIM
C --------------------------------------------------------------
      CALL PKSRCH_RF(MDOC,NAME,NAMEO,ALEVEL,DIST_LIM,SPEC
     * ,NPMAX,NP_LIM,PROG,RESMAX,RAD,NP_SRF,NAME_TSRF,DELTA,NCS
     * ,ISYM,IPRSYM,RESULT,RESULTA,IPRMAX,IPRROW,IERR)
C -----
      RETURN
      END

      SUBROUTINE PSTORE_RF(MDOC,IFIN
     *   ,NPEAK,D,RMS,IX,IY,IZ,DIST_LIM
     *   ,DIST_LIM_RMS
     *   ,PROG,FX,FY,FZ
     *   ,IXPEAK,IYPEAK,IZPEAK,PEAK
     *   ,SIGPK,DM1,DM2,DM3,INDPK       
     *   ,DLIM_FLAG,OP_IS,OP_JS
     *   ,DLIM_FLAG2,OP_IS2,OP_JS2
     *   ,IPRMAX,IPRROW
     *   ,NSYM,ISYM,IPRSYM,TYPE,IERR)
C ---------------------------------------------------------------
      INTEGER  IXPEAK(*),IYPEAK(*),IZPEAK(*),INDPK(*)
      REAL     PEAK(*),SIGPK(*),DM1(*),DM2(*),DM3(*)
      REAL     DLIM_FLAG(*),OP_IS(*),OP_JS(*)
      REAL     DLIM_FLAG2(*),OP_IS2(*),OP_JS2(*)
      INTEGER*2 ISYM(5,3,IPRSYM)      
      CHARACTER TYPE*1,PROG*4       
C ---------------------------------------------------------------
      PI   = 4.0*ATAN(1.0)
      IF(IFIN.GT.0) GO TO 500
      IF(NPEAK.GT.0) THEN      

        IF(NPEAK.GE.IPRMAX) THEN
          INDM=INDPK(IPRMAX)
          IF(PEAK(INDM).GE.D) RETURN
        ENDIF

        DO I=1,NPEAK
          IND  = INDPK(I)
C         DIST = 1000.0
          JX   = IXPEAK(IND)
          JY   = IYPEAK(IND)
          JZ   = IZPEAK(IND)
          FJX  = DM1(IND)
          FJY  = DM2(IND)
          FJZ  = DM3(IND)
          SIGI = SIGPK(IND)         
          
          IF(DIST_LIM.GE.0.0) THEN
            CALL CALC_DST_RF(IX,IY,IZ,JX,JY,JZ
     *      ,FX,FY,FZ,FJX,FJY,FJZ,DIST,DRMS,ISMIN,JSMIN
     *      ,PROG,NSYM,ISYM,IPRSYM,IERR)
          ELSE
            DIST = 0.0
          ENDIF
          DIST_LIM_TEST = DIST_LIM
          DIST_TEST     = DIST
          IF(DRMS.LT.1001.0) THEN
             DIST_LIM_TEST = DIST_LIM_RMS
             DIST_TEST     = DRMS
          ENDIF

C          DIST_LIM_TEST2 = DIST_LIM_TEST * 1.5
C          IF(DIST_TEST.LE.DIST_LIM_TEST2) DFLAG = 1.0
            
          IF(DIST_TEST.LE.DIST_LIM_TEST) THEN

c            t=(dist*180.0)/pi
c            tt=(dist_LIM_TEST*180.0)/pi
c            write(*,*) '------>',t,Drms,tt, DIST_LIM_RMS

            IF(PEAK(IND).GE.D) RETURN
            PEAK(IND)   = D
            IXPEAK(IND) = IX
            IYPEAK(IND) = IY
            IZPEAK(IND) = IZ
            DM1   (IND) = FX
            DM2   (IND) = FY
            DM3   (IND) = FZ
            SIGPK (IND) = RMS
            DLIM_FLAG(IND) =-IND
            DLIM_FLAG2(IND)=-IND

            IF(I.EQ.1) RETURN
C           SORT FROM I TO 1           
            DO J=I,2,-1
              IND1 = INDPK(J )
              IND2 = INDPK(J-1)
              IF(PEAK(IND1).GT.PEAK(IND2)) THEN
                IT         = INDPK(J)
                INDPK(J)   = INDPK(J-1)
                INDPK(J-1) = IT
              ELSE
                GO TO 200
              ENDIF
            ENDDO
 200        CONTINUE
            RETURN
          ELSE

C            IF(TYPE.EQ.'H') THEN
C              DEL = ABS(SIGI-RMS)
C              IF(DEL.LT.0.001) RETURN
C            ENDIF

          ENDIF 
        ENDDO
      ENDIF   
 400  CONTINUE
      IF(NPEAK.LT.IPRMAX) THEN
        NPEAK        = NPEAK+1
        INDPK(NPEAK) = NPEAK
        IND          = NPEAK
        PEAK(IND)    = D
        IXPEAK(IND)  = IX
        IYPEAK(IND)  = IY
        IZPEAK(IND)  = IZ
        DM1   (IND)  = FX
        DM2   (IND)  = FY
        DM3   (IND)  = FZ
        SIGPK (IND)  = RMS
        DLIM_FLAG(IND) =-IND
        DLIM_FLAG2(IND)=-IND
      ELSE
        IND = INDPK(IPRMAX)
        IF(PEAK(IND).GE.D) RETURN
        PEAK  (IND) = D
        IXPEAK(IND) = IX
        IYPEAK(IND) = IY
        IZPEAK(IND) = IZ
        DM1   (IND) = FX
        DM2   (IND) = FY
        DM3   (IND) = FZ
        SIGPK (IND) = RMS
        DLIM_FLAG(IND) =-IND
        DLIM_FLAG2(IND)=-IND
      ENDIF
      IF(NPEAK.GT.1) THEN
        DO I=NPEAK,2,-1
          IND1 = INDPK(I )
          IND2 = INDPK(I-1)
          IF(PEAK(IND1).GT.PEAK(IND2)) THEN
            IT         = INDPK(I)
            INDPK(I)   = INDPK(I-1)
            INDPK(I-1) = IT
          ELSE
            GO TO 100
          ENDIF
        ENDDO
 100    CONTINUE
      ENDIF
      RETURN
C ----
 500  CONTINUE
      IF(NPEAK.LE.1) RETURN      
      DO IP=1,NPEAK-1
        INDP = INDPK(IP)
        IX   = IXPEAK(INDP)
        IY   = IYPEAK(INDP)
        IZ   = IZPEAK(INDP)
        FX   = DM1(INDP)
        FY   = DM2(INDP)
        FZ   = DM3(INDP)
        IF(DLIM_FLAG(INDP).LE.0.0) THEN
          DO I=IP+1,NPEAK
            IND  = INDPK(I)
            JX   = IXPEAK(IND)
            JY   = IYPEAK(IND)
            JZ   = IZPEAK(IND)
            FJX  = DM1(IND)
            FJY  = DM2(IND)
            FJZ  = DM3(IND)
            IF(DIST_LIM.GE.0.0) THEN
              CALL CALC_DST_RF(IX,IY,IZ,JX,JY,JZ
     *         ,FX,FY,FZ,FJX,FJY,FJZ,DIST,DRMS,ISMIN,JSMIN
     *         ,PROG,NSYM,ISYM,IPRSYM,IERR)
            ELSE
              DIST  = 0.0
              ISMIN = 0
              JSMIN = 0
            ENDIF
            DIST_LIM_TEST = DIST_LIM
            DIST_TEST     = DIST
            IF(DRMS.LT.1001.0) THEN
              DIST_LIM_TEST = DIST_LIM_RMS
              DIST_TEST     = DRMS
            ENDIF

            DIST_LIM_TEST2 = DIST_LIM_TEST * 1.5
            IF(DIST_TEST.LE.DIST_LIM_TEST2) THEN
              DLIM_FLAG(IND) = INDP
              OP_IS(IND) = ISMIN
              OP_JS(IND) = JSMIN
            ENDIF

          ENDDO
        ENDIF
      ENDDO
      DO IP=1,NPEAK-1
        INDP = INDPK(IP)
        IX   = IXPEAK(INDP)
        IY   = IYPEAK(INDP)
        IZ   = IZPEAK(INDP)
        FX   = DM1(INDP)
        FY   = DM2(INDP)
        FZ   = DM3(INDP)
        IF(DLIM_FLAG2(INDP).LE.0.0) THEN
          DO I=IP+1,NPEAK
            IND  = INDPK(I)
            JX   = IXPEAK(IND)
            JY   = IYPEAK(IND)
            JZ   = IZPEAK(IND)
            FJX  = DM1(IND)
            FJY  = DM2(IND)
            FJZ  = DM3(IND)
            IF(DIST_LIM.GE.0.0) THEN
              CALL CALC_DST_RF(IX,IY,IZ,JX,JY,JZ
     *         ,FX,FY,FZ,FJX,FJY,FJZ,DIST,DRMS,ISMIN,JSMIN
     *         ,PROG,NSYM,ISYM,IPRSYM,IERR)
            ELSE
              DIST  = 0.0
              ISMIN = 0
              JSMIN = 0
            ENDIF
            DIST_LIM_TEST = DIST_LIM
            DIST_TEST     = DIST
            IF(DRMS.LT.1001.0) THEN
              DIST_LIM_TEST = DIST_LIM_RMS
              DIST_TEST     = DRMS
            ENDIF

            DIST_LIM_TEST2 = DIST_LIM_TEST * 4.0
            IF(DIST_TEST.LE.DIST_LIM_TEST2) THEN
              DLIM_FLAG2(IND) = INDP
              OP_IS2(IND) = ISMIN
              OP_JS2(IND) = JSMIN
            ENDIF

          ENDDO
        ENDIF
      ENDDO
      RETURN
      END

      SUBROUTINE RES_PRINT_RF(MDOC,NPEAK,NPMAX
     *  ,NP_SRF_IN,NAME_TSRF,DLIM
     *  ,IXPEAK,IYPEAK,IZPEAK,PEAK
     *  ,SIGPK,DXA,DYB,DZG,INDPK,DM1,DM2,DM3
     *  ,NCS,PROG,SPEC,RESULTA,IPRMAX,IPRROW,NSYM,ISYM,IPRSYM,IERR)
C ---------------------------------------------------------------
      REAL      RESULTA(IPRMAX,IPRROW)
      INTEGER   IXPEAK(*),IYPEAK(*),IZPEAK(*),INDPK(*)
      REAL      PEAK(*),SIGPK(*),DXA(*),DYB(*),DZG(*)
      REAL      DM1(*),DM2(*),DM3(*)
      INTEGER*2 ISYM(5,3,IPRSYM)      
      CHARACTER NAME_TSRF*(*) 
C ---------------------------------------------------------------
C --
      COMMON/COM_SRPK/ FRTOCR,CRTOFR,NX,NY,NZ,IZMIN,IZMAX,
     *                 DELA,DELG,DELB,TYPE
      REAL      FRTOCR(3,3),CRTOFR(3,3)
      CHARACTER TYPE*1,SPEC*1,PROG*4
C ---
      INTEGER INDSYM(192)  
      REAL    AM(3,3),AM1(3,3),AMJ(3,3),AMIJ(3,3),XF(3),XC(3),XC2(3)
      REAL    SM(3,3),SMT(3,3),AM2(3,3),AM3(3,3)
C -------------------------------------------------------------
      CHARACTER LINE*256
C ---------------------------------------------------------------
      MD   =-ABS(MDOC)-10
      PI = 4.0*ATAN(1.0)
C ---
      NCS = 1
      NPEAK_PRT = NPEAK
      IF(NPEAK_PRT.GT.NPMAX.AND.NPMAX.GT.0) NPEAK_PRT = NPMAX

      IF(NPEAK_PRT.LE.0) THEN      
        WRITE(LINE,'('' Number of RF peaks :'',I8)') NPEAK 
        CALL MSGDOC(MD,LINE)
      ENDIF

      IF(NPEAK_PRT.GT.0) THEN      

        CALL GET_CR_MATRIX(FRTOCR,CRTOFR)
        INDSYM(1) = 1

        IF(NSYM.GT.1) THEN           
          DO I=2,NSYM
            INDSYM(I) = 1
            DO J=1,I-1
              DO     L=1,3
              DO     K=1,3
                IF(ISYM(L,K,I).NE.ISYM(L,K,J)) GO TO 300
              ENDDO
              ENDDO
              INDSYM(I) = 0
              GO TO 310
 300          CONTINUE
            ENDDO
 310        CONTINUE
          ENDDO
        ENDIF
        ICHECK = 0
        NPSRF  = 0
       
        IF(PROG.EQ.'CROS'.OR.PROG.EQ.'CRSL') THEN
          NP_SRF = ABS(NP_SRF_IN)
          ICHECK = 1
          IF(NP_SRF_IN.LT.0) ICHECK = 2
          NPSRF = NP_SRF
          CALL LENSTR_BL(NAME_TSRF,LEN)
          IF(LEN.GT.0.AND.NAME_TSRF(1:1).NE.',') THEN
            CALL READ_TAB_SRF(MDOC,NAME_TSRF,NPSRF
     *                   ,RESULTA,IPRMAX,IPRROW
     *                   ,FRTOCR,CRTOFR,NSYM,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) RETURN
            NPSRF = RESULTA(1,12) 
            IF(NPSRF.LE.0) THEN
              CALL MSGERR(MDOC,
     *        ' ERROR: number of peaks of self rotation function = 0')
              IERR = 1
              RETURN
            ENDIF
            D_LIM = (DLIM*PI)/180.0
            IF(NPSRF.GT.NP_SRF) NPSRF = NP_SRF
            WRITE(LINE,
     *      '('' Npeak_selfRF             :'',I4,''   Iremove'',I4)') 
     *      NPSRF,ICHECK
            CALL MSGDOC(MD,LINE)
            WRITE(LINE,
     *      '('' limit D (for SRF) :'',G14.4,'' / deg /'')')
     *      DLIM
            CALL MSGDOC(MD,LINE)
          ELSE
            ICHECK = 0
            NPSRF  = 0
          ENDIF
        ENDIF
C -------
        DO I=1,NPEAK_PRT

          IND = INDPK (I)
          IX  = IXPEAK(IND)
          IY  = IYPEAK(IND)
          IZ  = IZPEAK(IND)
          FX  = DXA   (IND)
          FY  = DYB   (IND)
          FZ  = DZG   (IND)
          PK  = PEAK  (IND)
          SIG = SIGPK (IND)

          A        = FX*DELA
          G        = FY*DELG
          B        = FZ*DELB
          DM1(IND) = FX
          DM2(IND) = FY
          DM3(IND) = FZ
          CALL EULERM(A,B,G,AM)
          CALL MTOPOL(AM,THETA,PHI,CHI)
          A        = (A*180.0)/PI
          B        = (B*180.0)/PI
          G        = (G*180.0)/PI
          DXA(IND) = A
          DYB(IND) = B
          DZG(IND) = G
        ENDDO
c ------
        CALL MSGDOC(MD,' ')
        WRITE(LINE,'('' Number of RF peaks :'',I8)') NPEAK
        CALL MSGDOC(MD,LINE)
        LINE = '            theta    phi     chi    alpha    be'//
     *           'ta   gamma      Rf    Rf/sigma'
        CALL MSGDOC(MD,LINE)
        IREMOVE = 0
        NRM_ADD = 2
        IADD    = 0
        NP_FINAL = 0
        DO I=1,NPEAK_PRT

          IND = INDPK (I)
          IX  = IXPEAK(IND)
          IY  = IYPEAK(IND)
          IZ  = IZPEAK(IND)
          FX  = DM1   (IND)
          FY  = DM2   (IND)
          FZ  = DM3   (IND)
          PK  = PEAK  (IND)
          SIG = SIGPK (IND)
          A        = FX*DELA
          G        = FY*DELG
          B        = FZ*DELB
          CALL EULERM(A,B,G,AM)
          CALL MTOPOL(AM,THETA,PHI,CHI)
          A        = (A*180.0)/PI
          B        = (B*180.0)/PI
          G        = (G*180.0)/PI

          IWRT = 1

          IF(PROG.EQ.'SELF'.OR.PROG.EQ.'SRFL') THEN

            IF(I.GT.1.AND.NSYM.GT.1) THEN
              CALL CHANGE_SEFF_RF_PEAK(MDOC,I,ICH
     *        ,THETA,PHI,CHI,A,B,G
     *        ,IXPEAK,IYPEAK,IZPEAK,INDPK,PEAK,SIGPK,DM1,DM2,DM3
     *        ,FRTOCR,CRTOFR,DELA,DELG,DELB
     *        ,NSYM,ISYM,IPRSYM,INDSYM,IERR)
            ELSE IF(I.EQ.1) THEN
              THETA = 0.0
              PHI   = 0.0
              CHI   = 0.0
              A     = 0.0
              B     = 0.0
              G     = 0.0
              DM1(IND) = 0.0
              DM2(IND) = 0.0 
              DM3(IND) = 0.0
            ENDIF

            NP_FINAL = NP_FINAL + 1

          ELSE

            IF(NPSRF.GT.0.AND.ICHECK.GT.0) THEN
              CALL CHECK_SEFF_RF_PEAK(MDOC,I,ICH,NPEAK_PRT
     *        ,IXPEAK,IYPEAK,IZPEAK,INDPK,PEAK,SIGPK,DM1,DM2,DM3
     *        ,FRTOCR,CRTOFR,DELA,DELG,DELB
     *        ,D_LIM,NPSRF,RESULTA,IPRMAX,IPRROW
     *        ,NSYM,ISYM,IPRSYM,INDSYM,IERR)

              IF(ICH.EQ.0) THEN
                IWRT = -2
                IF(ICHECK.GT.1) THEN
                  IRA = IREMOVE + IADD
                  IF(IRA.LT.NRM_ADD) THEN
                    NP_FINAL = NP_FINAL + 1
                    IADD = IADD + 1
                    IWRT =-1
                  ELSE
                    IREMOVE = IREMOVE + 1
                    IWRT =-3
                  ENDIF
                ENDIF
              ELSE
                NP_FINAL = NP_FINAL + 1
              ENDIF


            ELSE 
              NP_FINAL = NP_FINAL + 1
            ENDIF

          ENDIF

          DXA(IND) = A
          DYB(IND) = B
          DZG(IND) = G

          WRITE(LINE,200) I,THETA,PHI,CHI,A,B,G
     *    ,PK,SIG
C200      FORMAT(I3,6F8.2,G14.4,F6.2)
 200      FORMAT('Sol_RF',1X,I3,1X,6F8.2,G14.4,F6.2)
C         IF(PROG.EQ.'SELF'.AND.I.EQ.1) LINE(1:1) = '#'

          MMM = MDOC
          IF(ICHECK.GT.1) MMM=MD
          IF(ICHECK.GT.1.AND.IWRT.GE.-1) MMM=MDOC

          IF(IWRT.EQ.-1) LINE(6:6) = '+'
          IF(IWRT.LE.-2) LINE(6:6) = '-'
          CALL MSGDOC(MD,LINE)

          IF(IWRT.EQ.-3) SIGPK(IND) =-1.0

        ENDDO

        WRITE(LINE,'('' Final number of peaks :'',I8)') NP_FINAL
        CALL MSGDOC(MD,LINE)

        IF(ICHECK.GT.1) THEN
          WRITE(LINE,'('' Nremove,Nadd          :'',2I8)') 
     *       IREMOVE,IADD
          CALL MSGDOC(MD,LINE)
        ENDIF
C --------------------------


C --------------------------
        IF(SPEC.NE.'S') RETURN
C ---
        NPMAX_PRT = NPMAX
        IF(NPMAX_PRT.LE.0) NPMAX_PRT = 20
        IF(PROG.EQ.'CROS'.OR.PROG.EQ.'SELF') NPMAX_PRT = 20
        IF(NPEAK_PRT.LT.NPMAX_PRT) NPMAX_PRT=NPEAK_PRT

        IF(NPMAX_PRT.GT.1.AND.ABS(MDOC).NE.2) THEN
      

          IF(PROG.EQ.'CROS'.OR.PROG.EQ.'CRSL') THEN

            IF(NPSRF.GT.0) THEN
              CALL MSGDOC(MD,
     *'     I --> J      theta   phi    chi         Iself   Delta')
            ELSE
              CALL MSGDOC(MD,
     *      '     I --> J      theta   phi    chi      RFi         RFj')
            ENDIF

            DO I=1,NPMAX_PRT-1

              CALL PRINT_SEFF_RF_PEAK(MD,I,PROG,NPMAX_PRT
     *        ,IXPEAK,IYPEAK,IZPEAK,INDPK,PEAK,SIGPK,DM1,DM2,DM3
     *        ,FRTOCR,CRTOFR,DELA,DELG,DELB
     *        ,D_LIM,NPSRF,RESULTA,IPRMAX,IPRROW
     *        ,NSYM,ISYM,IPRSYM,INDSYM,IERR)
    

            ENDDO
            
          ELSE

            IF(NSYM.LE.1) RETURN

            CALL MSGDOC(MD,' --- All symmetry related peaks ----')
            LINE = '            theta    phi     chi    alpha    be'//
     *             'ta   gamma     Isym_i    Isym_j'   
            CALL MSGDOC(MD,LINE)

            DO I=1,NPMAX_PRT

              CALL PRINT_SEFF_RF_ALL(MD,I
     *        ,IXPEAK,IYPEAK,IZPEAK,INDPK,PEAK,SIGPK,DM1,DM2,DM3
     *        ,FRTOCR,CRTOFR,DELA,DELG,DELB
     *        ,NSYM,ISYM,IPRSYM,INDSYM,IERR)

            ENDDO

          ENDIF

        ENDIF
      ENDIF
      RETURN
      END
 
      SUBROUTINE PRINT_SEFF_RF_PEAK(MD,I,PROG,NPMAX_PRT
     *  ,IXPEAK,IYPEAK,IZPEAK,INDPK,PEAK,SIGPK,DM1,DM2,DM3
     *  ,FRTOCR,CRTOFR,DELA,DELG,DELB
     *  ,D_LIM,NPSRF,RESULTA,IPRMAX,IPRROW
     *  ,NSYM,ISYM,IPRSYM,INDSYM,IERR)
C -------------------------------------------------------------
      INTEGER   IXPEAK(*),IYPEAK(*),IZPEAK(*),INDPK(*)
      REAL      PEAK(*),SIGPK(*)
      REAL      DM1(*),DM2(*),DM3(*)
      INTEGER*2 ISYM(5,3,IPRSYM)      
      INTEGER   INDSYM(*)  
      REAL      FRTOCR(3,3),CRTOFR(3,3)
C ----
      REAL      AM(3,3),AM1(3,3),AMJ(3,3),AMIJ(3,3)
      REAL      SM(3,3),SMT(3,3),AM2(3,3),AM3(3,3)
      REAL      RESULTA(IPRMAX,IPRROW)
      CHARACTER LINE*256,PROG*4
C -----------------------------------------
      IERR = 0
      PI = 4.0*ATAN(1.0)
C ----
              IND = INDPK(I)
              IX  = IXPEAK(IND)
              IY  = IYPEAK(IND)
              IZ  = IZPEAK(IND)
              FX  = DM1   (IND)
              FY  = DM2   (IND)
              FZ  = DM3   (IND)
              PK  = PEAK  (IND)
              SIG = SIGPK (IND)

C
C             X * R(I) --> R(J) :   X =  R(J) *  R(I)'
C
C             X * Sym * R(I) --> R(J) :   SR = Sym * R(I) 
C                                         X =  R(J) * SR'
C             
              A = FX*DELA
              G = FY*DELG
              B = FZ*DELB
              CALL EULERM(A,B,G,AM)
              CALL INVERT(AM,AM1,IERR)
C
C             AM' = R(I)' 
C
              NS = NSYM
              DO IS=1,NS
                IF(INDSYM(IS).GT.0) THEN
                  SM(1,1) = REAL(ISYM(1,1,IS))
                  SM(2,1) = REAL(ISYM(2,1,IS))
                  SM(3,1) = REAL(ISYM(3,1,IS))
                  SM(1,2) = REAL(ISYM(1,2,IS))
                  SM(2,2) = REAL(ISYM(2,2,IS))
                  SM(3,2) = REAL(ISYM(3,2,IS))
                  SM(1,3) = REAL(ISYM(1,3,IS))
                  SM(2,3) = REAL(ISYM(2,3,IS))
                  SM(3,3) = REAL(ISYM(3,3,IS))
                  CALL MATMLT(SM,CRTOFR,AM3)
                  CALL MATMLT(FRTOCR,AM3,SM)
C
C                 AM2 = SR
C
                  CALL MATMLT(SM,AM,AM2)
                  CALL MTOPOL(AM2,THETA,PHI,CHI)
                  WRITE(LINE,220) IS,THETA,PHI,CHI
 220              FORMAT
     *('     ----> Isym: R(sym) * R(I) :',I4,2X,3F8.2,' (tpc)')
                  CALL MSGDOC(MD,LINE)
                  CALL MTOANG(AM2,A,B,G)
                  WRITE(LINE,221) A,B,G
 221              FORMAT
     *('                                ',6X,3F8.2,' (abg)')
                  CALL MSGDOC(MD,LINE)
                  CALL INVERT(AM2,AM1,IERR)
C                   AM1 = SR'       

c                  DO J=I+1,NPMAX_PRT
                  DO J=1,NPMAX_PRT
                    JND  = INDPK (J)
                    JX   = IXPEAK(JND)
                    JY   = IYPEAK(JND)
                    JZ   = IZPEAK(JND)
                    FX   = DM1   (JND)
                    FY   = DM2   (JND)
                    FZ   = DM3   (JND)
                    PKJ  = PEAK  (JND)
                    SIGJ = SIGPK (JND)
                    AJ    = FX*DELA
                    GJ    = FY*DELG
                    BJ    = FZ*DELB
                    CALL EULERM(AJ,BJ,GJ,AMJ)
                    CALL MATMLT(AMJ,AM1,AMIJ)
                    CALL MTOPOL(AMIJ,THETA,PHI,CHI)

                    IF(NPSRF.GT.0) THEN
                      CALL CHECK_SRF_PEAKS(AM2,AMJ,D_LIM,NPSRF
     *                ,FRTOCR,CRTOFR
     *                ,NSYM,ISYM,IPRSYM,INDSYM
     *                ,RESULTA,IPRMAX,IPRROW,ISRF,DSRF)     
                      DSRF = (DSRF*180.0)/PI

                      IF(PROG.EQ.'CRSL'.OR.ISRF.GT.0) THEN
                        WRITE(LINE,211) I,J,THETA,PHI,CHI,ISRF,DSRF
c211                    FORMAT(2I6,2X,3F8.2,I8,F10.4)
 211                    FORMAT(2I6,2X,3F8.2,' NCS:',I5,' Delta:',F10.4)
                        CALL MSGDOC(MD,LINE)
                      ENDIF

                    ELSE
                      WRITE(LINE,210) I,J,THETA,PHI,CHI,PK,PKJ
 210                  FORMAT(2I6,2X,3F8.2,2G12.4)
                      CALL MSGDOC(MD,LINE)
                    ENDIF
                  ENDDO
                ENDIF
              ENDDO
C ------------------
      RETURN
      END


      SUBROUTINE CHECK_SEFF_RF_PEAK(MDOC,I,ICHECK,NPMAX_PRT
     *  ,IXPEAK,IYPEAK,IZPEAK,INDPK,PEAK,SIGPK,DM1,DM2,DM3
     *  ,FRTOCR,CRTOFR,DELA,DELG,DELB
     *  ,D_LIM,NPSRF,RESULTA,IPRMAX,IPRROW
     *  ,NSYM,ISYM,IPRSYM,INDSYM,IERR)
C -------------------------------------------------------------
      INTEGER   IXPEAK(*),IYPEAK(*),IZPEAK(*),INDPK(*)
      REAL      PEAK(*),SIGPK(*)
      REAL      DM1(*),DM2(*),DM3(*)
      INTEGER*2 ISYM(5,3,IPRSYM)      
      INTEGER   INDSYM(*)  
      REAL      FRTOCR(3,3),CRTOFR(3,3)
C ----
      REAL      AM(3,3),AM1(3,3),AMJ(3,3),AMIJ(3,3)
      REAL      SM(3,3),SMT(3,3),AM2(3,3),AM3(3,3)
      REAL      RESULTA(IPRMAX,IPRROW)
      CHARACTER LINE*256
C -----------------------------------------
      IERR = 0
      PI = 4.0*ATAN(1.0)
      ICHECK = 0
C ----
              IND = INDPK(I)
              IX  = IXPEAK(IND)
              IY  = IYPEAK(IND)
              IZ  = IZPEAK(IND)
              FX  = DM1   (IND)
              FY  = DM2   (IND)
              FZ  = DM3   (IND)
              PK  = PEAK  (IND)
              SIG = SIGPK (IND)

C
C             X * R(I) --> R(J) :   X =  R(J) *  R(I)'
C
C             X * Sym * R(I) --> R(J) :   SR = Sym * R(I) 
C                                         X =  R(J) * SR'
C             
              A = FX*DELA
              G = FY*DELG
              B = FZ*DELB
              CALL EULERM(A,B,G,AM)
              CALL INVERT(AM,AM1,IERR)
C
C             AM' = R(I)' 
C
              NS = NSYM
              DO IS=1,NS
                IF(INDSYM(IS).GT.0) THEN
                  SM(1,1) = REAL(ISYM(1,1,IS))
                  SM(2,1) = REAL(ISYM(2,1,IS))
                  SM(3,1) = REAL(ISYM(3,1,IS))
                  SM(1,2) = REAL(ISYM(1,2,IS))
                  SM(2,2) = REAL(ISYM(2,2,IS))
                  SM(3,2) = REAL(ISYM(3,2,IS))
                  SM(1,3) = REAL(ISYM(1,3,IS))
                  SM(2,3) = REAL(ISYM(2,3,IS))
                  SM(3,3) = REAL(ISYM(3,3,IS))
                  CALL MATMLT(SM,CRTOFR,AM3)
                  CALL MATMLT(FRTOCR,AM3,SM)
C
C                 AM2 = SR
C
                  CALL MATMLT(SM,AM,AM2)
                  CALL MTOPOL(AM2,THETA,PHI,CHI)
                  CALL MTOANG(AM2,A,B,G)
                  CALL INVERT(AM2,AM1,IERR)

C                   AM1 = SR'       

                  DO J=1,NPMAX_PRT
                    JND  = INDPK (J)
                    JX   = IXPEAK(JND)
                    JY   = IYPEAK(JND)
                    JZ   = IZPEAK(JND)
                    FX   = DM1   (JND)
                    FY   = DM2   (JND)
                    FZ   = DM3   (JND)
                    PKJ  = PEAK  (JND)
                    SIGJ = SIGPK (JND)
                    AJ    = FX*DELA
                    GJ    = FY*DELG
                    BJ    = FZ*DELB
                    CALL EULERM(AJ,BJ,GJ,AMJ)
                    CALL MATMLT(AMJ,AM1,AMIJ)
                    CALL MTOPOL(AMIJ,THETA,PHI,CHI)

                    CALL CHECK_SRF_PEAKS(AM2,AMJ,D_LIM,NPSRF
     *              ,FRTOCR,CRTOFR
     *              ,NSYM,ISYM,IPRSYM,INDSYM
     *              ,RESULTA,IPRMAX,IPRROW,ISRF,DSRF)     
                    DSRF = (DSRF*180.0)/PI

c                        WRITE(LINE,211) I,J,THETA,PHI,CHI,ISRF,DSRF
c211                    FORMAT(2I6,2X,3F8.2,I8,F10.4)
c 211                    FORMAT(2I6,2X,3F8.2,' NCS:',I5,' Delta:',F10.4)
c                        CALL MSGDOC(MDOC,LINE)

                    IF(ISRF.GT.0) THEN
                      ICHECK = ISRF
                      GO TO 100
                    ENDIF
                      
                  ENDDO
                ENDIF
              ENDDO
C ------------------
 100  CONTINUE
      RETURN
      END



      SUBROUTINE PRINT_SEFF_RF_ALL(MDOC,I
     *  ,IXPEAK,IYPEAK,IZPEAK,INDPK,PEAK,SIGPK,DM1,DM2,DM3
     *  ,FRTOCR,CRTOFR,DELA,DELG,DELB
     *  ,NSYM,ISYM,IPRSYM,INDSYM,IERR)
C -------------------------------------------------------------
      INTEGER   IXPEAK(*),IYPEAK(*),IZPEAK(*),INDPK(*)
      REAL      PEAK(*),SIGPK(*)
      REAL      DM1(*),DM2(*),DM3(*)
      INTEGER*2 ISYM(5,3,IPRSYM)      
      INTEGER   INDSYM(*)  
      REAL      FRTOCR(3,3),CRTOFR(3,3)
      PARAMETER (NPSMAX=96)
      REAL      ALPHAN(NPSMAX),BETAN(NPSMAX),GAMMAN(NPSMAX)
C ----
      REAL      AM(3,3),AM1(3,3),AMJ(3,3),AMIJ(3,3),AM5(3,3)
      REAL      SM(3,3),SMT(3,3),AM2(3,3),AM3(3,3),AM4(3,3)
      CHARACTER LINE*256
C -------------------------------------------------------------
      PI = 4.0*ATAN(1.0)
      DELTA_ANG = 1.0
      NPS       = 0
      IND = INDPK(I)
      IX  = IXPEAK(IND)
      IY  = IYPEAK(IND)
      IZ  = IZPEAK(IND)
      FX  = DM1   (IND)
      FY  = DM2   (IND)
      FZ  = DM3   (IND)
      PK  = PEAK  (IND)
      SIG = SIGPK (IND)

C
C             X * R(I) --> R(J) :   X =  R(J) *  R(I)'
C
C             X * Sym * R(I) --> R(J) :   SR = Sym * R(I) 
C                                         X =  R(J) * SR'
C             
      A = FX*DELA
      G = FY*DELG
      B = FZ*DELB
      CALL EULERM(A,B,G,AM)
C
c             AM  = R(I)
C
      NS = NSYM
      DO JS=1,NS
        IF(INDSYM(JS).GT.0) THEN

          SM(1,1) = REAL(ISYM(1,1,JS))
          SM(2,1) = REAL(ISYM(2,1,JS))
          SM(3,1) = REAL(ISYM(3,1,JS))
          SM(1,2) = REAL(ISYM(1,2,JS))
          SM(2,2) = REAL(ISYM(2,2,JS))
          SM(3,2) = REAL(ISYM(3,2,JS))
          SM(1,3) = REAL(ISYM(1,3,JS))
          SM(2,3) = REAL(ISYM(2,3,JS))
          SM(3,3) = REAL(ISYM(3,3,JS))
          CALL MATMLT(SM,CRTOFR,AM3)
          CALL MATMLT(FRTOCR,AM3,SM)
C
C                        AM   SM
C                       [Ri] [Js]
c
c                    AMJ = SM * AM = [Js] * [Ri]

          CALL MATMLT(SM,AM,AMJ)

          DO IS=1,NS
            IF(INDSYM(IS).GT.0) THEN

              SMT(1,1) = REAL(ISYM(1,1,IS))
              SMT(2,1) = REAL(ISYM(2,1,IS))
              SMT(3,1) = REAL(ISYM(3,1,IS))
              SMT(1,2) = REAL(ISYM(1,2,IS))
              SMT(2,2) = REAL(ISYM(2,2,IS))
              SMT(3,2) = REAL(ISYM(3,2,IS))
              SMT(1,3) = REAL(ISYM(1,3,IS))
              SMT(2,3) = REAL(ISYM(2,3,IS))
              SMT(3,3) = REAL(ISYM(3,3,IS))
              CALL MATMLT(SMT,CRTOFR,AM3)
              CALL MATMLT(FRTOCR,AM3,SMT)
              CALL INVERT(SMT,AM1,IERR)
             
C
C             SMT = [Is]    AM1 = [Is]'
C
c     AMJ = SM * AM = [Js] * [Ri]

              CALL MATMLT(AMJ,AM1,AMIJ)

c                    AMIJ = [Js] * [Ri] * [Is]'

              CALL MTOPOL(AMIJ,THETA,PHI,CHI)
              CALL MTOANG(AMIJ,A,B,G)

C ----
              ISTORE = 0 
              IF(NPS.GT.0) THEN  
                DO K=1,NPS
                  AA = (ALPHAN(K)*PI)/180.0
                  BB = (BETAN(K)*PI)/180.0
                  GG = (GAMMAN(K)*PI)/180.0
                  CALL EULERM(AA,BB,GG,AM4)
                  CALL INVERT(AM4,AM5,IERR)
                  CALL MATMLT(AM5,AMIJ,AM1)
                  CALL MTOPOL(AM1,T,P,C)
                  IF(ABS(C).LT.DELTA_ANG) THEN
c                    ISTORE = 1
                  ENDIF
                ENDDO
              ENDIF

              IF(ISTORE.LE.0) THEN
                IF(NPS.LT.NPSMAX) THEN
                  NPS = NPS + 1
                  ALPHAN(NPS) = A
                  BETAN(NPS)  = B
                  GAMMAN(NPS) = G
                ENDIF
C            LINE = 'Sol_RF      theta    phi     chi    alpha    be'//
C     *             'ta   gamma     Isym_i    Isym_j'   
                WRITE(LINE,210) 'Sol_RF ',I,THETA,PHI,CHI,A,B,G,JS,IS
 210            FORMAT(A,I3,2X,3F8.2,2X,3F8.2,2I4)
                CALL MSGDOC(MDOC,LINE)
              ENDIF
C ----
            ENDIF
          ENDDO
        ENDIF
      ENDDO
C ------------------------------
      RETURN
      END

      SUBROUTINE CHANGE_SEFF_RF_PEAK(MDOC,I,ICH
     *  ,THETAN,PHIN,CHIN,AN,BN,GN
     *  ,IXPEAK,IYPEAK,IZPEAK,INDPK,PEAK,SIGPK,DM1,DM2,DM3
     *  ,FRTOCR,CRTOFR,DELA,DELG,DELB
     *  ,NSYM,ISYM,IPRSYM,INDSYM,IERR)
C -------------------------------------------------------------
      INTEGER   IXPEAK(*),IYPEAK(*),IZPEAK(*),INDPK(*)
      REAL      PEAK(*),SIGPK(*)
      REAL      DM1(*),DM2(*),DM3(*)
      INTEGER*2 ISYM(5,3,IPRSYM)      
      INTEGER   INDSYM(*)  
      REAL      FRTOCR(3,3),CRTOFR(3,3)
C ----
      REAL      AM(3,3),AM1(3,3),AMJ(3,3),AMIJ(3,3)
      REAL      SM(3,3),SMT(3,3),SM1(3,3),SMT1(3,3)
      REAL      AM2(3,3),AM3(3,3)
      REAL      AM4(3,3),AM5(3,3),AM6(3,3)
      CHARACTER LINE*256
C -------------------------------------------------------------
      PI = 4.0*ATAN(1.0)
      ICH       = 1
      DELTA_ANG = 1.0
      I180      = 0
      I120      = 0
      I90       = 0
      I60       = 0
      I30       = 0
c      IF(ABS(CHIN-180.0).LT.DELTA_ANG) THEN
c        I180   = 1
c      ELSE IF(ABS(CHIN-120.0).LT.DELTA_ANG) THEN
c        I120 = 1
c      ELSE IF(ABS(CHIN-90.0).LT.DELTA_ANG) THEN
c        I90 = 1
c      ELSE IF(ABS(CHIN-60.0).LT.DELTA_ANG) THEN
c        I60 = 1
c      ELSE IF(ABS(CHIN-30.0).LT.DELTA_ANG) THEN
c        I30 = 1
c      ENDIF

      IF(ABS(CHIN-30.0).LT.DELTA_ANG) THEN
        I30   = 1
      ELSE IF(ABS(CHIN-60.0).LT.DELTA_ANG) THEN
        I60 = 1
      ELSE IF(ABS(CHIN-90.0).LT.DELTA_ANG) THEN
        I90 = 1
      ELSE IF(ABS(CHIN-120.0).LT.DELTA_ANG) THEN
        I120 = 1
      ELSE IF(ABS(CHIN-180.0).LT.DELTA_ANG) THEN
        I180 = 1
      ENDIF
c      I180 = 0
C -----------
      IND = INDPK(I)
      IX  = IXPEAK(IND)
      IY  = IYPEAK(IND)
      IZ  = IZPEAK(IND)
      FX  = DM1   (IND)
      FY  = DM2   (IND)
      FZ  = DM3   (IND)
      PK  = PEAK  (IND)
      SIG = SIGPK (IND)

C
C             X * R(I) --> R(J) :   X =  R(J) *  R(I)'
C
C             X * Sym * R(I) --> R(J) :   SR = Sym * R(I) 
C                                         X =  R(J) * SR'
C             
      A = FX*DELA
      G = FY*DELG
      B = FZ*DELB
      AAA = A
      BBB = B
      GGG = G

      CALL EULERM(A,B,G,AM)
      CALL INVERT(AM,AM1,IERR)

C      CALL MTOPOL(AM,T,P,C)
C      CALL MTOANG(AM,AAN,BBN,GGN)
C      write(*,*) '----i',i,t,p,c,aan,bbn,ggn
C
C          AM1 =   AM' = R(I)' 
C
      NS = NSYM
      DO JS=1,NS
        IF(INDSYM(JS).GT.0) THEN

          SM(1,1) = REAL(ISYM(1,1,JS))
          SM(2,1) = REAL(ISYM(2,1,JS))
          SM(3,1) = REAL(ISYM(3,1,JS))
          SM(1,2) = REAL(ISYM(1,2,JS))
          SM(2,2) = REAL(ISYM(2,2,JS))
          SM(3,2) = REAL(ISYM(3,2,JS))
          SM(1,3) = REAL(ISYM(1,3,JS))
          SM(2,3) = REAL(ISYM(2,3,JS))
          SM(3,3) = REAL(ISYM(3,3,JS))
          CALL MATMLT(SM,CRTOFR,AM3)
          CALL MATMLT(FRTOCR,AM3,SM)
          CALL INVERT(SM,SM1,IERR)
C
C             AM = R(I) 
C
C             AMJ =   AM   SM
C                    [Ri] [js]
          CALL MATMLT(AM,SM,AMJ)

          DO IS=1,NS
            IF(INDSYM(IS).GT.0) THEN

              SMT(1,1) = REAL(ISYM(1,1,IS))
              SMT(2,1) = REAL(ISYM(2,1,IS))
              SMT(3,1) = REAL(ISYM(3,1,IS))
              SMT(1,2) = REAL(ISYM(1,2,IS))
              SMT(2,2) = REAL(ISYM(2,2,IS))
              SMT(3,2) = REAL(ISYM(3,2,IS))
              SMT(1,3) = REAL(ISYM(1,3,IS))
              SMT(2,3) = REAL(ISYM(2,3,IS))
              SMT(3,3) = REAL(ISYM(3,3,IS))
              CALL MATMLT(SMT,CRTOFR,AM3)
              CALL MATMLT(FRTOCR,AM3,SMT)
              CALL INVERT(SMT,SMT1,IERR)
C
C              AM = R(I) 
C
C              AMJ =   AM   SM
C                     [Ri] [js]
c
c             AMIJ =   AMJ      SMT
c                    [Ri] [js]  [is]
c
c             AM2  =  SMT1     AMIJ    
c                    [is-] [Ri][js][is]
C
c            
c
              CALL MATMLT(AMJ,SMT,AMIJ)
              CALL MATMLT(SMT1,AMIJ,AM2)
              CALL MTOPOL(AM2,THETA,PHI,CHI)
              CALL MTOANG(AM2,AAA,BBB,GGG)

              ISTORE = 0                       
              ACHI = ABS(CHI)
                 
c      IF(ABS(ACHI-180.0).LT.DELTA_ANG) THEN
c        IF(I180.EQ.0) ISTORE = 1   
c        I180   = 1
c      ELSE IF(ABS(ACHI-120.0).LT.DELTA_ANG) THEN
c        I120 = 1
c        IF(I180.EQ.0) ISTORE = 1
c      ELSE IF(ABS(ACHI-90.0).LT.DELTA_ANG) THEN
c        I90 = 1
c        IF(I180.EQ.0.AND.I120.EQ.0) ISTORE = 1
c      ELSE IF(ABS(ACHI-60.0).LT.DELTA_ANG) THEN
c        I60 = 1
c        IF(I180.EQ.0.AND.I90.EQ.0.AND.I120.EQ.0) ISTORE = 1
c      ELSE IF(ABS(ACHI-30.0).LT.DELTA_ANG) THEN
c        I30 = 1
c        IF(I180.EQ.0.AND.I60.EQ.0.AND.I90.EQ.0.AND.I120.EQ.0) 
c     *  ISTORE = 1
c      ENDIF

      IF(ABS(ACHI-30.0).LT.DELTA_ANG) THEN
        IF(I30.EQ.0) ISTORE = 1   
        I30   = 1
      ELSE IF(ABS(ACHI-60.0).LT.DELTA_ANG) THEN
        I60 = 1
        IF(I30.EQ.0) ISTORE = 1
      ELSE IF(ABS(ACHI-90.0).LT.DELTA_ANG) THEN
        I90 = 1
        IF(I30.EQ.0.AND.I60.EQ.0) ISTORE = 1
      ELSE IF(ABS(ACHI-1200.0).LT.DELTA_ANG) THEN
        I120 = 1
        IF(I30.EQ.0.AND.I60.EQ.0.AND.I90.EQ.0) ISTORE = 1
      ELSE IF(ABS(ACHI-180.0).LT.DELTA_ANG) THEN
        I180 = 1
        IF(I30.EQ.0.AND.I60.EQ.0.AND.I90.EQ.0.AND.I120.EQ.0) 
     *  ISTORE = 1
      ENDIF

            IF(ISTORE.GT.0) THEN
               THETAN = THETA
               PHIN   = PHI
               CHIN   = CHI
               AN     = AAA
               BN     = BBB
               GN     = GGG
C              IF(I180.NE.0) RETURN
             ENDIF
C ----
            ENDIF
          ENDDO
        ENDIF
      ENDDO
C ------------------------------
      RETURN
      END

      SUBROUTINE CHECK_SRF_PEAKS(AM,AMJ,DLIM,NPSRF
     *                     ,FRTOCR,CRTOFR
     *                     ,NSYM,ISYM,IPRSYM,INDSYM
     *                     ,RESULTA,IPRMAX,IPRROW,ISRF,DSRF)     
C ----------------------------------------------------
C [am]=[sym][ami]      [SELF] [AMJ] =?= [AM] 
C                      [SELF] [AM ] =?= [AMJ]
C --
      INTEGER*2 ISYM(5,3,IPRSYM)      
      INTEGER   INDSYM(*)  
      REAL      FRTOCR(3,3),CRTOFR(3,3)
      REAL    RESULTA(IPRMAX,IPRROW)
      REAL    AM(3,3),AMJ(3,3),SYM(3,3),SN(3,3),SNCS(3,3)
      REAL    AM1(3,3),AM2(3,3),AM3(3,3),SM(3,3)
C ----------------------------------------------------
      DIST  = 1.E20
      PI    = 4.0*ATAN(1.0)

      ISRF  = 0
      DSRF  = 0.0
      IDIST = 0

      IF(NPSRF.LE.0) RETURN
      NP = RESULTA(1,12) 
      IF(NP.GT.NPSRF) NP = NPSRF

      DO IP = 1,NP

        A  = (RESULTA(IP,6)*PI)/180.0
        B  = (RESULTA(IP,7)*PI)/180.0
        G  = (RESULTA(IP,8)*PI)/180.0
        CALL EULERM(A,B,G,SNCS)

        NS = NSYM
        DO JS=1,NS
          IF(INDSYM(JS).GT.0) THEN

            SYM(1,1) = REAL(ISYM(1,1,JS))
            SYM(2,1) = REAL(ISYM(2,1,JS))
            SYM(3,1) = REAL(ISYM(3,1,JS))
            SYM(1,2) = REAL(ISYM(1,2,JS))
            SYM(2,2) = REAL(ISYM(2,2,JS))
            SYM(3,2) = REAL(ISYM(3,2,JS))
            SYM(1,3) = REAL(ISYM(1,3,JS))
            SYM(2,3) = REAL(ISYM(2,3,JS))
            SYM(3,3) = REAL(ISYM(3,3,JS))
            CALL MATMLT(SYM,CRTOFR,AM3)
            CALL MATMLT(FRTOCR,AM3,SN)
            CALL MATMLT(SN,SNCS,SM)

            CALL MATMLT(SM,AM,AM1)
            CALL INVERT(AMJ,AM2,IERR)
            CALL MATMLT(AM1,AM2,AM3)
            CALL MTOPOL(AM3,THETA,PHI,CHI)

            CHI = (PI*CHI)/180.0
            DST = ABS(CHI)
            IF(DST.GT.PI  ) DST  = ABS(2.0*PI-DST)
            IF(DST.LE.DIST) THEN
              DIST  = DST
              IDIST = IP
            ENDIF

            CALL MATMLT(SM,AMJ,AM1)
            CALL INVERT(AM,AM2,IERR)
            CALL MATMLT(AM1,AM2,AM3)
            CALL MTOPOL(AM3,THETA,PHI,CHI)

            CHI = (PI*CHI)/180.0
            DST = ABS(CHI)
            IF(DST.GT.PI  ) DST  = ABS(2.0*PI-DST)
            IF(DST.LE.DIST) THEN
              DIST  = DST
              IDIST = IP
            ENDIF

          ENDIF
        ENDDO
      ENDDO
      
      IF(DIST.LE.DLIM) THEN
        ISRF = IDIST
        DSRF = DIST
      ENDIF
      
      RETURN
      END

      SUBROUTINE CALC_DST_RF(IX,IY,IZ,JX,JY,JZ
     *   ,FIX,FIY,FIZ,FJX,FJY,FJZ,DIST,RMS,ISMIN,JSMIN
     *   ,PROG,NSYM,ISYM,IPRSYM,IERR)
C -------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
C --
      COMMON/COM_SRPK/ FRTOCR,CRTOFR,NX,NY,NZ,IZMIN,IZMAX,
     *                 DELA,DELG,DELB,TYPE
      REAL      FRTOCR(3,3),CRTOFR(3,3)
      CHARACTER TYPE*1,PROG*4
C ---
      REAL      TALPHA(2),TGAMMA(2),TBETA(2)
      REAL X(3),Y(3),Z(3),XX(3),AM1(3,3),AM2(3,3),AM3(3,3),SM(3,3)
      REAL AM4(3,3),YY(3),W(3),WW(3),SMM(3,3),AMM2(3,3),AM5(3,3)
C -------------------------------------------------------------
      ISMIN = 0
      JSMIN = 0
      DIST = 1.E20
      PI = 4.0*ATAN(1.0)
      N  = NSYM
      NN = N
      IF(PROG.EQ.'CROS'.OR.PROG.EQ.'CRSL') NN=1
      A  = FIX*DELA
      G  = FIY*DELG
      B  = FIZ*DELB
      AA = FJX*DELA
      GG = FJY*DELG
      BB = FJZ*DELB

      CALL EULERM(A,B,G,AM1)
      CALL EULERM(AA,BB,GG,AM2)

      TALPHA(1) = (A*180.0)/PI
      TBETA(1)  = (B*180.0)/PI
      TGAMMA(1) = (G*180.0)/PI
      TALPHA(2) = (AA*180.0)/PI
      TBETA(2)  = (BB*180.0)/PI
      TGAMMA(2) = (GG*180.0)/PI
      I = 1
      J = 2
      CALL CALC_ORIENTION_RMS(I,J,FRTOCR,CRTOFR
     *      ,TALPHA,TGAMMA,TBETA,NSYM,ISYM,IPRSYM,RMS)

C     IF(RMS.LT.1001.0) RETURN


      DO     IS=1,N
        SM(1,1)=REAL(ISYM(1,1,IS))
        SM(2,1)=REAL(ISYM(2,1,IS))
        SM(3,1)=REAL(ISYM(3,1,IS))
        SM(1,2)=REAL(ISYM(1,2,IS))
        SM(2,2)=REAL(ISYM(2,2,IS))
        SM(3,2)=REAL(ISYM(3,2,IS))
        SM(1,3)=REAL(ISYM(1,3,IS))
        SM(2,3)=REAL(ISYM(2,3,IS))
        SM(3,3)=REAL(ISYM(3,3,IS))

        CALL MATMLT(SM,CRTOFR,AM3)
        CALL MATMLT(FRTOCR,AM3,SM)
        CALL MATMLT(SM,AM1,AM3)
cccc        CALL INVERT(AM3,AM4,IERR)
c       a  - am1
c       aa - am2  
c       am3 = [is][a]
Ccccc       am4 = am3' = [a-][is-]
          
c //////////
  
        DO  JS=1,NN
          SMM(1,1)=REAL(ISYM(1,1,JS))
          SMM(2,1)=REAL(ISYM(2,1,JS))
          SMM(3,1)=REAL(ISYM(3,1,JS))
          SMM(1,2)=REAL(ISYM(1,2,JS))
          SMM(2,2)=REAL(ISYM(2,2,JS))
          SMM(3,2)=REAL(ISYM(3,2,JS))
          SMM(1,3)=REAL(ISYM(1,3,JS))
          SMM(2,3)=REAL(ISYM(2,3,JS))
          SMM(3,3)=REAL(ISYM(3,3,JS))

          CALL MATMLT(SMM,CRTOFR,AM5)
          CALL MATMLT(FRTOCR,AM5,SMM)

c          CALL MATMLT(SMM,AM2,AMM2)

          CALL MATMLT(AM3,SMM,AMM2)
          CALL INVERT(AM2,AM4,IERR)

          CALL MATMLT(AMM2,AM4,AM5)
          CALL MTOPOL(AM5,THETA,PHI,CHI)

c         CALL MATMLT(AMM2,AM4,AM5)
c         CALL MTOPOL(AM5,THETA,PHI,CHI)
C         CALL MATMLT(AM2,AM4,AM5)
C         CALL MTOPOL(AM5,THETA,PHI,CHI)
c         
c       a  - am1
c       aa - am2  
c       am3 = [is][a]
c       amm2 = [is][a][js]
C       am4  = [aa-]
c       am5 =  [is][a][js]   [aa-]
c

          IF(CHI.GT. 180.0) CHI =  180.0 - CHI
          IF(CHI.LT.-180.0) CHI = -180.0 - CHI
         
          CHI = (PI*CHI)/180.0
          DST = ABS(CHI)
          IF(DST.GT.PI  ) DST  = ABS(2.0*PI-DST)
          IF(DST.LT.DIST) THEN
            DIST = DST
            ISMIN = IS
            JSMIN = JS
          ENDIF

c      CALL MTOPOL(AMM2,T,P,C)
c      CALL MTOANG(AMM2,AAN,BBN,GGN)
c      write(*,*) '----i',is,t,p,c,aan,bbn,ggn
c      CALL MTOPOL(AM4,T,P,C)
c      CALL MTOANG(AM4,AAN,BBN,GGN)
c      write(*,*) '----j',js,t,p,c,aan,bbn,ggn
c      CALL MTOPOL(AM5,T,P,C)
c      CALL MTOANG(AM5,AAN,BBN,GGN)
c      write(*,*) '----d',t,p,c,aan,bbn,ggn

          ENDDO
c ////////
        ENDDO

      RETURN
      END

      SUBROUTINE STICK_TEST(MDOC,RAD_MOD,IS
     *         ,ALPHA_I,BETA_I,GAMMA_I,SHC,PEAK_TEST
     *         ,ALPHA,BETA,GAMMA,THETA,PHI,CHI
     *         ,IPT_MIN,IDIMER
     *         ,SHC_NEW,NSYM,ISYM,IPRSYM,IERR)
C ---------------------------------------------------------
c  input: ALPHA_I,BETA_I,GAMMA_I,SHC (ort)
c         PEAK_TEST
c         RAD_MOD
c  output:IS SHC_NEW(frac)
c     
C ---------------------------------------------------------
C  PEAK_TEST( 1,i) Ini 0 or 1,2,3 
C  PEAK_TEST( 2,i) 0 - fract, 1 - ort 
C  PEAK_TEST( 3,i) alpha
C  PEAK_TEST( 4,i) beta
C  PEAK_TEST( 5,i) gamma
C  PEAK_TEST( 6,i)   Xo
C  PEAK_TEST( 7,i)   Yo
C  PEAK_TEST( 8,i)   Zo
C  PEAK_TEST( 9,i)   Xfrac
C  PEAK_TEST(10,i)  Yfrac
C  PEAK_TEST(11,i)  Zfrac
C  
C  PEAK_TEST(12,1) N          
C --------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      SHF(3),SHC(3),W(3),X(3),Z(3),DX(3),SHC_NEW(3)
      REAL      PEAK_TEST(12,*),SHF_NEW(3)
      CHARACTER TEST*1
      CHARACTER LINE*256
C ------------------------------------------------------------
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
C =====================================================================
      PI    = 4.0*ATAN(1.0)
      TWOPI = 2.0*PI
      MD    =-ABS(MDOC)-1
      M     = 99
      IERR  = 0
C -----------------------------------
c///
c            I = PEAK_TEST(12,1) 
c            IF(I.EQ.1) THEN
c              IF(ABS(PEAK_TEST(6,I)).GT.0.001.OR.
c     *           ABS(PEAK_TEST(7,I)).GT.0.001.OR.
c     *           ABS(PEAK_TEST(8,I)).GT.0.001    ) I = I + 1
c            ELSE
c              I = I + 1
c            ENDIF
c            PEAK_TEST(12,1) = I
c            J = 0 
c            IF(I.GE.2) J = PEAK_TEST( 1,I-1) 
c            J = J + 1
c            PEAK_TEST( 1,I) = J 
c            PEAK_TEST( 2,I) = 1
c 
c///
      IORIGIN = 0
      I = PEAK_TEST(12,1) 
      IF(I.EQ.1) THEN
        IF((ABS(PEAK_TEST(6,I)).LT.0.001.AND.
     *      ABS(PEAK_TEST(7,I)).LT.0.001.AND.
     *      ABS(PEAK_TEST(8,I)).LT.0.001    ).AND.
     *     (ABS(PEAK_TEST(9,I)).LT.0.001.AND.
     *      ABS(PEAK_TEST(10,I)).LT.0.001.AND.
     *      ABS(PEAK_TEST(11,I)).LT.0.001    )) THEN
          IORIGIN = 1
        ENDIF
      ENDIF
      IS    = 1
      ALPHA = ALPHA_I
      BETA  = BETA_I
      GAMMA = GAMMA_I
      SHC_NEW(1) = SHC(1)
      SHC_NEW(2) = SHC(2)
      SHC_NEW(3) = SHC(3)
      NPT  = PEAK_TEST(12,1)

C      WRITE(LINE,*) ' ABG:',ALPHA,BETA,GAMMA
C      CALL MSGDOC(MD,LINE)
C      WRITE(LINE,*) ' SH :',SHC_NEW(1),SHC_NEW(2),SHC_NEW(3)
C      CALL MSGDOC(MD,LINE)
C      WRITE(*,*) 'NPT,NSYM:',NPT,NSYM

      IF(NPT.LE.0) RETURN

      TEST = '3'

      CALL OTOF(SHC,SHF,IERR)

      CALL CALC_DIST_TEST(MDOC,SHC,SHF,PEAK_TEST,TEST
     *   ,IS,IPT_MIN,DX,DIST_MIN,SHC_NEW  
     *   ,ALPHA,BETA,GAMMA,THETA,PHI,CHI
     *   ,THETA12,PHI12,CHI12,DORT,DPAR,RAD_MOD,IDIMER
     *   ,CRTOFR,FRTOCR
     *   ,NSYM,ISYM,IPRSYM,IERR)

C     PEAK_TEST(,IPT_MIN)
C      CALL MSGDOC(MD,' ')
C      WRITE(LINE,*) 'Isym,Ipt:',IS,IPT_MIN
C      CALL MSGDOC(MD,LINE)
C      WRITE(LINE,*) ' ABG:',ALPHA,BETA,GAMMA
C      CALL MSGDOC(MD,LINE)
C      WRITE(LINE,*) ' TFC:',THETA,PHI,CHI
C      CALL MSGDOC(MD,LINE)
C      WRITE(LINE,*) ' SH :',SHC_NEW(1),SHC_NEW(2),SHC_NEW(3)
C      CALL MSGDOC(MD,LINE)
C      WRITE(LINE,*) ' TFC(1->2) :',THETA12,PHI12,CHI12
C      CALL MSGDOC(MD,LINE)
C      WRITE(LINE,*) ' d,ort,par :',DIST_MIN,DORT,DPAR
C      CALL MSGDOC(MD,LINE)


      CALL OTOF(SHC_NEW,SHF_NEW,IERR)

c      WRITE(LINE,*) ' ABG:',ALPHA,BETA,GAMMA
c      CALL MSGDOC(MDOC,LINE)
c      WRITE(LINE,*) ' TFC:',THETA,PHI,CHI
c      CALL MSGDOC(MDOC,LINE)
c      WRITE(LINE,*) ' SH :',SHF_NEW(1),SHF_NEW(2),SHF_NEW(3)
c      CALL MSGDOC(MDOC,LINE)
c      WRITE(LINE,
c     *  '(''Sol_ 1->2 Isym,TPC,D,Dort,Dpar'',I3,I3,3F8.2,3F6.1)')
c     *IS,IPT_MIN,THETA12,PHI12,CHI12,DIST_MIN,DORT,DPAR
c      CALL MSGDOC(MDOC,LINE)
      IF(IORIGIN.EQ.1) THEN
        CALL MSGDOC(MDOC,
     *  'After stick correction:')
        CALL MSGDOC(MDOC,' Move closer to origin')
      ELSE
        CALL MSGDOC(MDOC,
     *  'After stick correction (more information in molrep.doc):')
        WRITE(LINE,'(A,I5)') ' Move closer to molecule N :',IPT_MIN
        CALL MSGDOC(MDOC,LINE)
        IF(IDIMER.GT.0) 
     *  CALL MSGDOC(MDOC,' --- Dimer ---')
        WRITE(LINE,'(A,3F8.2)') 
     *   ' Rotation to molecule N (polar angles) :'
     *   ,THETA12,PHI12,CHI12
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(A,F6.1)') 
     *   ' Distance between centres (A) :'
     *   ,DIST_MIN
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(A,2F6.1)') 
     *   ' Ortogonal axis distance and parallel (A) :'
     *   ,DORT,DPAR
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      WRITE(LINE,'(A,I5)') ' I_sym_operator    :',IS
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,3F8.3)') ' new position(frac):'
     * ,SHF_NEW(1),SHF_NEW(2),SHF_NEW(3)
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' ')
 
      RETURN
      END

      SUBROUTINE ROTDNS_RUN(MDOC,LIST,NAMED,NAMEF,NAMEW
     *    ,MODE,POS,RAD,RESMAX_CELL,PACK
     *    ,ANGLES,ORIG_F,SHFT_F_INP,CELL,IDZNCS
     *    ,NX_CELL,NY_CELL,NZ_CELL,NX_REF,NY_REF,NZ_REF,RMAX_REF
     *    ,RMIN_REF,IX0_REF,IY0_REF,IZ0_REF
     *    ,IZMAX_REF,IZMIN_REF,ROLIM,D_RMS,DNS_SCALE,RO_SCALE
     *    ,FTOC_REF,CTOF_REF,FTOC_CELL,CTOF_CELL,TITLE     
     *    ,TEMP_F
     *    ,RESULT,MAP,PLAN,IPRMAP,IPRPLN
     *    ,IPOOL_MEM,MEM_POOL
     *    ,NSYM,ISYM,IPRSYM,IERR)
C ------------------------------------------------------
      COMMON/COM_DPOOL/ IPOOL_MAX,IPOOL_CURR
C ------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      PLAN(IPRPLN)
      INTEGER   IPOOL_MEM(*)
      INTEGER*2 MAP(IPRMAP)      
      CHARACTER NAMED*(*),NAMEF*(*),NAMEW*(*)
      REAL      SHFT_F_INP(3),RESULT(*)
      REAL      ORIG_F(3),SHFT_F(3),CELL(6),ANGLES(3)
      REAL      FTOC_CELL(3,3),CTOF_CELL(3,3)
      REAL      FTOC_REF(3,3),CTOF_REF(3,3)
      REAL      ROT(3,3),TRN(3,27),XCELL(3),XREF_C(3)


      PARAMETER ( IPRNCS = 30 )
      REAL      ROT1(3,3,IPRNCS)

      REAL      XCELL_TRN(3)
      CHARACTER TITLE*80,LINE*256,POS*1,TYPE*4,MODE*1,PACK*1,LIST*1
      CHARACTER CODE*4,NAMET*40,DATE*9,SPGR*24
      INTEGER*2 ISYM_P1(5,3,1)
      REAL      TEMP_C(3),TEMP_F(3)
C ------------------------------------------------------
      PI      = 4.0*ATAN(1.0)
      IERR    = 0
      MD      =-ABS(MDOC)-1
      M       = 99
C ----------------------------------------------------------
      IMODE    = 0
      ZMINTS  = FLOAT(IZMAX_REF)/FLOAT(NZ_REF)
      PERCENT = 100.0
      RSLIM   = 0.0
      PACK_INDEX = 1.0

      MMM = MD
      IF(LIST.EQ.'T') MMM = MDOC

      TEMP_F(1) = 0.0
      TEMP_F(2) = 0.0
      TEMP_F(3) = 0.0

c      write(*,*) '===ZMINTS',ZMINTS

      IPRSYM_P1 = 1
      IF(MODE.EQ.'2') THEN
        CALL BYTARR2(MMM,IMODE,NAMED,PLAN,IPRPLN,MAP,IPRMAP,ZMINTS
     *   ,KX,KY,KZ,KZMIN,KZMAX,AR,BR,CR,ALR,BER,GAR
     *   ,RMAX,ROLIM,R000,SCALE
     *   ,RSLIM,IX_MIN,IX_MAX,IY_MIN,IY_MAX,IZ_MIN,IZ_MAX
     *   ,POS,PERCENT,ISYM_P1,IPRSYM_P1,IERR)
      ELSE
        CALL BYTARR(MMM,IMODE,NAMED,PLAN,IPRPLN,MAP,IPRMAP,ZMINTS
     *   ,KX,KY,KZ,KZMIN,KZMAX,AR,BR,CR,ALR,BER,GAR
     *   ,RMAX,ROLIM,R000,SCALE
     *   ,RSLIM,IX_MIN,IX_MAX,IY_MIN,IY_MAX,IZ_MIN,IZ_MAX
     *   ,POS,PERCENT,ISYM_P1,IPRSYM_P1,IERR)
      ENDIF
      IF(IERR.GT.0) RETURN

      KZMAX = KZ*ZMINTS

      RLIM = ROLIM*RO_SCALE

      RLIM = -1.0E30

      DRMS = D_RMS*RO_SCALE
C      IF(ROLIM.LT.0.00001) THEN
C        RLIM = 1.0*SCALE-R000
C        RLIM = RLIM/2.0
C      ELSE
C        RLIM = ROLIM*DRMS
C      ENDIF
C      output: DENS   = ID/BYTE/ * SCALE - R000
C ----------------------------------------------------------
C      IF(IMODE.EQ.1) THEN
C        NX=KX/2
C        NY=KY-1
C        NZ=KZMAX
C      ELSE IF(IMODE.EQ.2) THEN
C        NX=KX/2
C        NY=KY/2
C        NZ=KZMAX
C      ELSE IF(IMODE.LE.0.OR.IMODE.GT.2) THEN
C        NX=KX-1
C        NY=KY-1
C        NZ=KZMAX
C      ENDIF
C ----------------------------------------------------------
      CALL LENSTR_BL(NAMEF,LEN)
      IF(LEN.GT.0.AND.NAMEF(1:1).NE.','.AND.NAMEF(1:1).NE.' ') THEN
        IERR  = 0
        MTN   = 10
        TYPE = 'FF  '
        CALL ORFILE(M,MTN,NAMEF,TYPE,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: cannot open F_file (ROTDNS)')
          GO TO 900
        ENDIF
        
        CALL C_RD_CR

        CALL GET_TITLE(M
     *  ,CELL(1),CELL(2),CELL(3),CELL(4),CELL(5),CELL(6)
     *  ,F1,F2,RESMIN,RESMAX,IDM,IDM,IDM,IDM,IDM,TITLE,IERR)

        CLOSE(MTN)

      ELSE

        CODE     = 'XXXX'
        NAMET    = '----------------------'
        DATE     = 'XX-XXX-XX'
        SPGR     = 'P 1'
        NSPGROUP = 1
        NOSETT   = 1

c        CELL(4)  = (CELL(4)*PI)/180.
c        CELL(5)  = (CELL(5)*PI)/180.
c        CELL(6)  = (CELL(6)*PI)/180.

        CALL SET_CELL(CELL,CODE,NAMET,DATE,TITLE
     *    ,NSPGROUP,NOSETT,SPGR,IERR)
        IF(IERR.NE.0) GO TO 900
        NSYM = 1

      ENDIF

      CALL DSTARF(CELL,AST,BST,CST,COALST,COBEST,COGAST,VOL)
      NXYZ = NX_CELL*NY_CELL*NZ_CELL
   
      ISTEP = 2
      CALL LENSTR_BL(NAMEW,LEN)
      IF(LEN.LE.0.OR.NAMEW(1:1).EQ.','.OR.NAMEW(1:1).EQ.' ') THEN
        ISTEP = 1
      ENDIF 

      IZMIN_CELL = 0
      IZMAX_CELL = NZ_CELL-1

      SHFT_F(1) = 0.5
      SHFT_F(2) = 0.5
      SHFT_F(3) = 0.5

      IX0   = SHFT_F(1)*NX_CELL
      IY0   = SHFT_F(2)*NY_CELL
      IZ0   = SHFT_F(3)*NZ_CELL
      
      SHFT_F(1) = FLOAT(IX0)/FLOAT(NX_CELL)
      SHFT_F(2) = FLOAT(IY0)/FLOAT(NY_CELL)
      SHFT_F(3) = FLOAT(IZ0)/FLOAT(NZ_CELL)

C ----------------------------------------------------------
       IF(LIST.EQ.'T') MMM = MDOC
C      IF(ISTEP.NE.1) THEN
C        MMM = M
C      ELSE
C        MMM = MD
C        IF(LIST.EQ.'T') MMM = MDOC
C      ENDIF
C
C      XMIN_REF = FLOAT(IX_MIN)/FLOAT(NX_REF)
C      XMAX_REF = FLOAT(IX_MAX)/FLOAT(NX_REF)
C      YMIN_REF = FLOAT(IY_MIN)/FLOAT(NY_REF)
C      YMAX_REF = FLOAT(IY_MAX)/FLOAT(NY_REF)
C      ZMIN_REF = FLOAT(IZ_MIN)/FLOAT(NZ_REF)
C      ZMAX_REF = FLOAT(IZ_MAX)/FLOAT(NZ_REF)
C      CALL MSGDOC(MMM,' --- input file ---')
C      WRITE(LINE,'(''Grig        :'',3i5)') NX_REF,NY_REF,NZ_REF
C      CALL MSGDOC(MMM,LINE)
C      WRITE(LINE,'(''Iz_min,_max :'',2i5)') IZMIN_REF,IZMAX_REF
C      CALL MSGDOC(MMM,LINE)
C      WRITE(LINE,'(''Ix0,Iy0,Iz0 :'',3i5)') IX0_REF,IY0_REF,IZ0_REF
C      CALL MSGDOC(MMM,LINE)
C      WRITE(LINE,'(''x_min,max   :'',2F8.3)') XMIN_REF,XMAX_REF
C      CALL MSGDOC(MMM,LINE)
C      WRITE(LINE,'(''x_min,max   :'',2F8.3)') YMIN_REF,YMAX_REF
C      CALL MSGDOC(MMM,LINE)
C      WRITE(LINE,'(''x_min,max   :'',2F8.3)') ZMIN_REF,ZMAX_REF
C      CALL MSGDOC(MMM,LINE)
c      WRITE(LINE,*) 'rlim,rms    :',RLIM,DRMS
c      CALL MSGDOC(MMM,LINE)
c      WRITE(LINE,*) 'mode        :',MODE
c      CALL MSGDOC(MMM,LINE)
C      WRITE(LINE,*) 'Origin      :',ORIG_F(1),ORIG_F(2),ORIG_F(3)
C      CALL MSGDOC(MMM,LINE)
C      WRITE(LINE,*) 'resol       :',RESMAX_CELL
C      CALL MSGDOC(MMM,LINE)
C      CALL MSGDOC(MMM,' ------------------')
C ---
      IF(LIST.EQ.'T') THEN

      WRITE(LINE,*) '- Origin ->',ORIG_F(1),ORIG_F(2),ORIG_F(3)
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) '- shift  ->',SHFT_F(1),SHFT_F(2),SHFT_F(3)
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) '-angl->',ANGLES(1),ANGLES(2),ANGLES(3)
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) '- I0     ->',IX0,IY0,IZ0
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) '- radius ->',RAD
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) '- zmax   ->',SHFT_F_INP(1)
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) '- mode   ->',MODE
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) '-rlim,rms->',RLIM,DRMS
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) '-vol ->',VOL
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) '- NcelL  ->',NX_CELL,NY_CELL,NZ_CELL
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) '- Izmax  ->',IZMAX_CELL
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) '- resol  ->',RESMAX_CELL
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) '- cell_out ->',CELL(1),CELL(2),CELL(3)
      CALL MSGDOC(MMM,LINE)
      T1 = (CELL(4)*180.0)/PI
      T2 = (CELL(5)*180.0)/PI
      T3 = (CELL(6)*180.0)/PI
      WRITE(LINE,*) '- cell_out ->',T1,T2,T3
      CALL MSGDOC(MMM,LINE)

      ENDIF

      THETA  = (ANGLES(1)*PI)/180.0
      PHI    = (ANGLES(2)*PI)/180.0
      CHI    = (ANGLES(3)*PI)/180.0

      CALL POLTOM(THETA,PHI,CHI,ROT)                                   
      CALL MTOANG(ROT,ALPHA,BETA,GAMMA)
      A1 = (ALPHA*PI)/180.0
      A2 = (BETA *PI)/180.0
      A3 = (GAMMA*PI)/180.0

      IF(IDZNCS.LE.0) IDZNCS = 1
      IF(IDZNCS.GT.IPRNCS) THEN
        CALL MSGERR(MDOC,'WARNING: IDZNCS > limits(30)')
        IDZNCS = 30
      ENDIF

      NCS = IDZNCS
      DANGLE = (2.0*PI)/FLOAT(NCS)

      DO I=1,NCS
        AA3 = A3 + DANGLE*FLOAT(I-1)
        CALL EULERM(A1,A2,AA3,ROT)
        CALL MTRANS(ROT,ROT1(1,1,I))
      ENDDO

      CALL RD_SET_TRN(NTRN,TRN)

      RAD2 = RAD*RAD    

      IF(LIST.EQ.'T') THEN
      WRITE(*,*) '==R',CTOF_REF(1,1),CTOF_REF(1,2),CTOF_REF(1,3)
      WRITE(*,*) '==R',CTOF_REF(2,1),CTOF_REF(2,2),CTOF_REF(2,3)
      WRITE(*,*) '==R',CTOF_REF(3,1),CTOF_REF(3,2),CTOF_REF(3,3)
      WRITE(*,*) '==C',CTOF_CELL(1,1),CTOF_CELL(1,2),CTOF_CELL(1,3)
      WRITE(*,*) '==C',CTOF_CELL(2,1),CTOF_CELL(2,2),CTOF_CELL(2,3)
      WRITE(*,*) '==C',CTOF_CELL(3,1),CTOF_CELL(3,2),CTOF_CELL(3,3)
      WRITE(*,*) '==RAD',RAD
      WRITE(LINE,*) '- shift  ->',SHFT_F(1),SHFT_F(2),SHFT_F(3)
      CALL MSGDOC(MDOC,LINE)
      WRITE(*,*) '==R',FTOC_REF(1,1),FTOC_REF(1,2),FTOC_REF(1,3)
      WRITE(*,*) '==R',FTOC_REF(2,1),FTOC_REF(2,2),FTOC_REF(2,3)
      WRITE(*,*) '==R',FTOC_REF(3,1),FTOC_REF(3,2),FTOC_REF(3,3)
      WRITE(*,*) '==C',FTOC_CELL(1,1),FTOC_CELL(1,2),FTOC_CELL(1,3)
      WRITE(*,*) '==C',FTOC_CELL(2,1),FTOC_CELL(2,2),FTOC_CELL(2,3)
      WRITE(*,*) '==C',FTOC_CELL(3,1),FTOC_CELL(3,2),FTOC_CELL(3,3)
      ENDIF
C ----------------------------------------------------------
      ITR       = 0
      IMODE     =-1
      IX        = 0
      IY        = 0
      IZ        = 0
      ID        = 0
      IFIRST    = 0
      ZMIN      = 0.0
      ZMAX      = 0.0
      NPOINT    = 0
      RAD_MAX   = 0.0
      SUM_DENS  = 0.0
      IZMAX_NEW = 0

      XS   = 0.
      YS   = 0.
      ZS   = 0.
      XS2  = 0.
      YS2  = 0.
      ZS2  = 0.

      IF(MODE.EQ.'2') THEN
        CALL GTDENS2(IMODE,IX,IY,IZ,ID
     *                             ,MAP,KX,KY,KZ,KZMIN,KZMAX,IPRMAP)
      ELSE
        CALL GTDENS(IMODE,IX,IY,IZ,ID,MAP,KX,KY,KZ,KZMIN,KZMAX)
      ENDIF
      IMODE = 0


      IF(LIST.EQ.'T') THEN
      write(*,*) '==1=',KX,KY,KZ,KZMIN,KZMAX
      write(*,*) '==2=',R000,SCALE,RO_SCALE
      ENDIF

      NCS = 1

      IF(ISTEP.NE.1) THEN
        MMM = M
        IF(LIST.EQ.'T') MMM = MDOC
      ELSE
        MMM = MD
        IF(LIST.EQ.'T') MMM = MDOC
      ENDIF

      RMINT = 1.0E30
      RMAXT =-1.0E30

      DO IZ=IZMIN_CELL,IZMAX_CELL
        RMIN = 1.0E30
        RMAX =-1.0E30
        XCELL(3) = FLOAT(IZ)/FLOAT(NZ_CELL)
        DO IY=1,NY_CELL
          XCELL(2) = FLOAT(IY-1)/FLOAT(NY_CELL)
          IND0 = (IY-1)*NX_CELL
          DO IX=1,NX_CELL
            XCELL(1) = FLOAT(IX-1)/FLOAT(NX_CELL)
            IND = IND0+IX
            CALL RD_GETDNS(M,XCELL,ROBS,RAD2,R2,NTRN,TRN,MODE
     *             ,ORIG_F,SHFT_F,FTOC_REF,CTOF_REF 
     *             ,FTOC_CELL,CTOF_CELL,ROT,ROT1  
     *             ,XREF_C,NCS
     *             ,IMODE,MAP,KX,KY,KZ,KZMIN,KZMAX,IPRMAP
     *             ,R000,SCALE,IERR)
            IF(IERR.NE.0) THEN
              CALL MSGERR(MD,' ERROR: in rd_getdns (ROTDNS)')
              GO TO 900 
            ENDIF
  
            ROBS      = ROBS*RO_SCALE
            PLAN(IND) = ROBS

            IF(ROBS.LT.RMIN) RMIN = ROBS
            IF(ROBS.GT.RMAX) RMAX = ROBS
            IF(ROBS.LT.RMINT) RMINT = ROBS
            IF(ROBS.GT.RMAXT) RMAXT = ROBS

c            IF(ROBS.LT.RLIM) THEN
c              ROBS = RLIM
c              PLAN(IND) = ROBS
c            ENDIF

            IF(ROBS.GT.RLIM) THEN
c            IF(ROBS.GE.RLIM) THEN

C              IF(PACK.EQ.'Y')  PLAN(IND) = 1.0
              IF(IFIRST.EQ.0) THEN
                ZMIN   = XCELL(3)
                IFIRST = 1
              ENDIF
              ZMAX = XCELL(3)
              IZMAX_NEW = IZ

C              IF(R2.GT.RAD_MAX) RAD_MAX = R2

              IF(ROBS.GT.0.000001) THEN

                IF(R2.GT.RAD_MAX) RAD_MAX = R2

                NPOINT = NPOINT + 1              
                SUM_DENS = SUM_DENS + ROBS

                XS   = XS  + XREF_C(1)*ROBS
                YS   = YS  + XREF_C(2)*ROBS
                ZS   = ZS  + XREF_C(3)*ROBS
                XS2  = XS2 + XREF_C(1)*XREF_C(1)*ROBS
                YS2  = YS2 + XREF_C(2)*XREF_C(2)*ROBS
                ZS2  = ZS2 + XREF_C(3)*XREF_C(3)*ROBS
              ENDIF
            ELSE
              PLAN(IND) = 0.0
C              IF(PACK.EQ.'Y')  PLAN(IND) = 1.0
            ENDIF

          ENDDO
        ENDDO

        WRITE(LINE,'(''Iz,z,rmax,rmin:'',I4,F8.3,2G16.4)') 
     *  IZ,XCELL(3),RMAX,RMIN
        CALL MSGDOC(MMM,LINE)
      ENDDO
C ----------------------------------------------------------
      RAD_MAX = SQRT(RAD_MAX)
      ZCENTRE = (ZMIN+ZMAX)/2.0

      R_PROT  = 0.245
      IF(SUM_DENS.GT.0.000001.AND.NPOINT.GT.0) THEN
        RO        = SUM_DENS/NPOINT
        DCORR     = R_PROT/RO
        COEF      = VOL/FLOAT(NXYZ)
        VOL_POINT = FLOAT(NPOINT)*COEF
        SUM_EL    = R_PROT * VOL_POINT
 
C        WRITE(LINE,*) 'VOLp,ro',VOL_POINT,ro
C        CALL MSGDOC(MDOC,LINE)

      ELSE
        R0     = 0.0
        VOL_POINT = 0.0
        DCORR  = 1.0
        SUM_EL = 0.0
      ENDIF
      IF(NPOINT.GT.0.AND.SUM_DENS.GT.0.000001) THEN
        XS  = XS/SUM_DENS
        YS  = YS/SUM_DENS
        ZS  = ZS/SUM_DENS
        XS2 = XS2/SUM_DENS
        YS2 = YS2/SUM_DENS
        ZS2 = ZS2/SUM_DENS
      ENDIF
      RX   = XS2-XS*XS
      RY   = YS2-YS*YS
      RZ   = ZS2-ZS*ZS
      RADI = SQRT(ABS(RX+RY+RZ))
C ---
      IF(ISTEP.NE.1) THEN
        MMM = M
        IF(LIST.EQ.'T') MMM = MDOC
      ELSE
        MMM = MD
        IF(LIST.EQ.'T') MMM = MDOC
      ENDIF

        WRITE(LINE,'(''rmax,rmin:'',2G16.4)') 
     *  RMAXT,RMINT
      CALL MSGDOC(MMM,LINE)
        WRITE(LINE,'(''R000,SCALE:'',2G16.4)') 
     *  R000,SCALE
      CALL MSGDOC(MMM,LINE)

      XMIN_REF = FLOAT(IX_MIN)/FLOAT(NX_REF)
      XMAX_REF = FLOAT(IX_MAX)/FLOAT(NX_REF)
      YMIN_REF = FLOAT(IY_MIN)/FLOAT(NY_REF)
      YMAX_REF = FLOAT(IY_MAX)/FLOAT(NY_REF)
      ZMIN_REF = FLOAT(IZ_MIN)/FLOAT(NZ_REF)
      ZMAX_REF = FLOAT(IZ_MAX)/FLOAT(NZ_REF)
      CALL MSGDOC(MMM,' --- input file ---')
      WRITE(LINE,'(''Grig        :'',3i5)') NX_REF,NY_REF,NZ_REF
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,'(''Iz_min,_max :'',2i5)') IZMIN_REF,IZMAX_REF
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,'(''Ix0,Iy0,Iz0 :'',3i5)') IX0_REF,IY0_REF,IZ0_REF
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,'(''x_min,max   :'',2F8.3)') XMIN_REF,XMAX_REF
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,'(''y_min,max   :'',2F8.3)') YMIN_REF,YMAX_REF
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,'(''z_min,max   :'',2F8.3)') ZMIN_REF,ZMAX_REF
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) 'Dscale,Rscl :',DNS_SCALE,RO_SCALE
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) 'N_electrons :',SUM_EL
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) 'rolim       :',ROLIM
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) 'rlim,rms    :',RLIM,DRMS
      CALL MSGDOC(MMM,LINE)
      CALL MSGDOC(MMM,' ------------------')
      WRITE(LINE,*) 'mode,pos    :',MODE,POS
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) 'Origin      :',ORIG_F(1),ORIG_F(2),ORIG_F(3)
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) 'resol       :',RESMAX_CELL
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) 'Drad        :',RAD
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) 'Rad_max     :',RAD_MAX
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) 'Rad_inertia :',RADI
      CALL MSGDOC(MMM,LINE)

      TEMP_C(1) = XS
      TEMP_C(2) = YS
      TEMP_C(3) = ZS
      CALL MVMULT(CTOF_REF,TEMP_C,TEMP_F)
      TEMP_F(1) = ORIG_F(1) + TEMP_F(1)
      TEMP_F(2) = ORIG_F(2) + TEMP_F(2)
      TEMP_F(3) = ORIG_F(3) + TEMP_F(3)

      WRITE(LINE,*) 'Centre      :',TEMP_F(1),TEMP_F(2),TEMP_F(3)
      CALL MSGDOC(MMM,LINE)

c      WRITE(LINE,*) '- cell_out ->',CELL(1),CELL(2),CELL(3)
c      CALL MSGDOC(MMM,LINE)
      CALL MSGDOC(MMM,' ------------------')
C ---
C      MMM = M
C      IF(LIST.EQ.'L') MMM = MD
C      IF(LIST.EQ.'T') MMM = MDOC
C      WRITE(LINE,*) 'sum_dens    : ',SUM_DENS
C      CALL MSGDOC(MMM,LINE)
C      WRITE(LINE,*) 'npoint > 0  : ',NPOINT
C      CALL MSGDOC(MMM,LINE)
C      WRITE(LINE,*) 'zmin,max,cnt: ',ZMIN,ZMAX,ZCENTRE
C      CALL MSGDOC(MMM,LINE)
C      WRITE(LINE,*) 'rad_max     : ',RAD_MAX
C      CALL MSGDOC(MMM,LINE)
C      WRITE(LINE,*) 'dcorr       : ',DCORR
C      CALL MSGDOC(MMM,LINE)
C      WRITE(LINE,*) 'sum_el      : ',SUM_EL
C      CALL MSGDOC(MMM,LINE)
C      WRITE(LINE,*) 'Rad_inertia : ',RADI
C      CALL MSGDOC(MMM,LINE)
C      WRITE(LINE,*) 'VOLp,ro     : ',VOL_POINT,RO
C      CALL MSGDOC(MMM,LINE)
C -------------------
      IF(RADI.LT.0.000001) THEN
        CALL MSGERR(MDOC,' ERROR: Rad_inertia of model = 0 (ROTDNS)')
        IERR = 1
        GO TO 900
      ENDIF
      RESULT( 1) = SHFT_F(1)      
      RESULT( 2) = SHFT_F(2)      
      RESULT( 3) = SHFT_F(3)     
      RESULT( 4) = ANGLES(1)     
      RESULT( 5) = ANGLES(2)     
      RESULT( 6) = ANGLES(3)     
      RESULT( 7) = NPOINT     
      RESULT( 8) = ZMIN      
      RESULT( 9) = ZMAX      
      RESULT(10) = ZCENTRE
      RESULT(11) = RAD_MAX      
      RESULT(12) = DCORR     
      RESULT(13) = SUM_EL     
      RESULT(14) = NX_CELL     
      RESULT(15) = NY_CELL     
      RESULT(16) = NZ_CELL     
      RESULT(17) = RESMAX_CELL     
      RESULT(18) = RADI
      RESULT(19) = 0
      RESULT(20) = IZMAX_NEW

      IF(ISTEP.EQ.1) GO TO 900 
C ----------------------------

      MTW  = 43
      TITLE      = '-----------------------------'
      TITLE(1:4) = 'ROT '
      TITLE(5:8) = 'D   '
      TYPE       = 'RI  '
      IPRINT     = 1

      SHFT_F(1) = 0.5
      SHFT_F(2) = 0.5

      IZMIN_CELL = 0


C      write(*,*) 'z:',zmin,zmax,zcentre
C      write(*,*) 'c:',cell(3)
      
      ZMINC    = ZMIN * CELL(3)
      ZMAXC    = ZMAX * CELL(3)
      ZCENTREC = ZCENTRE * CELL(3)
C      write(*,*) 'zc:',zminc,zmaxc,zcentrec
      IF(ZMINC.GT.3.0) THEN
        DZ       = ZMINC - 3.0
        ZMINC    = ZMINC    - DZ
        ZMAXC    = ZMAXC    - DZ
        ZCENTREC = ZCENTREC - DZ
C      write(*,*) 'zcn:',zminc,zmaxc,zcentrec
        ZMIN     = ZMINC   /CELL(3)
        ZMAX     = ZMAXC   /CELL(3)
        ZCENTRE  = ZCENTREC/CELL(3)
      ENDIF
C      write(*,*) 'z:',zmin,zmax,zcentre

      IZMAX_CELL = FLOAT(NZ_CELL)*ZMAX + 0.5
      IF(IZMAX_CELL.GE.NZ_CELL) THEN
        IZMAX_CELL = NZ_CELL-1
      ENDIF

      SHFT_F(3) = ZCENTRE

      IPOOL_CURR = 0
      MEM = (NX_CELL*NY_CELL*(IZMAX_CELL+1))/2 + (NSYM+4)*20
     *       + (IZMAX_CELL+1)*4 + 20 + 2000
      IF(MEM.LE.MEM_POOL) THEN
        IF(IPOOL_MAX.GT.0) IPOOL_MAX = MEM_POOL
      ELSE
        IPOOL_MAX = 0
      ENDIF

      IPRMAP2 = IPRMAP/2

      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC

      WRITE(LINE,*) 'MAP_byte      :',IPRMAP2 
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) 'MAP_out       :',MEM    
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) 'MAP_out_avalb :',MEM_POOL    
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) 'IPRPLN        :',IPRPLN
      CALL MSGDOC(MMM,LINE)
C      WRITE(LINE,*) 'MEMORY        :',MEMORY
C      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) 'IPOOL_MAX     :',IPOOL_MAX
      CALL MSGDOC(MMM,LINE)
      

C      IF(IPRMAP_NEW.LT.NXY.AND.IPOOL_MAX.NE.0) THEN
C        CALL MSGERR(MDOC,
C     *' WARNING: GENDEN: not enough memory to keep map.')
C        WRITE(LINE,
C     *'(''          MEMORY for map='',I12,'' Available='',I12)') 
C     *  MEM_TOT,IPRMAP
C        CALL MSGERR(MDOC,LINE)
C        LINE = 
C     *'          program will use file_dens'
C        CALL MSGERR(MDOC,LINE)
C      ENDIF

      IX0   = SHFT_F(1)*NX_CELL
      IY0   = SHFT_F(2)*NY_CELL
      IZ0   = SHFT_F(3)*NZ_CELL
      
      SHFT_F(1) = FLOAT(IX0)/FLOAT(NX_CELL)
      SHFT_F(2) = FLOAT(IY0)/FLOAT(NY_CELL)
      SHFT_F(3) = FLOAT(IZ0)/FLOAT(NZ_CELL)

      CALL SET_TITLE(MD
     *  ,CELL(1),CELL(2),CELL(3),CELL(4),CELL(5),CELL(6)
     *  ,DDM,DDM,DDM,DDM
     *  ,NX_CELL,NY_CELL,NZ_CELL,IZMIN_CELL,IZMAX_CELL,TITLE,IERR)

      CALL C_CR_WR

      CALL LENSTR_BL(NAMEW,LEN)
      IF(LEN.LE.0.OR.NAMEW(1:1).EQ.','.OR.NAMEW(1:1).EQ.' ') THEN
        CALL MSGERR(MD,' ERROR: wrong output file name (ROTDNS)')
        IERR = 1
        GO TO 900
      ENDIF 

      CALL OWFILE_MEM(M,MTW,NAMEW,TYPE,NSYM,ISYM,IPRSYM
     * ,IPOOL_MEM,IERR)
      IF(IERR.GT.0) THEN
        CALL MSGERR(MD,' ERROR: cannot open output file (ROTDNS)')
        IERR = 1
        GO TO 900
      ENDIF
C ----------------------------------------------------------
      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC

      mmm=mdoc

      WRITE(LINE,*) '-Orig->',ORIG_F(1),ORIG_F(2),ORIG_F(3)
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) '-shft->',SHFT_F(1),SHFT_F(2),SHFT_F(3)
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) '-angl->',ANGLES(1),ANGLES(2),ANGLES(3)
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) '-I0  ->',IX0,IY0,IZ0
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) '-rad ->',RAD
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) '-zmax->',ZMAX
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) '-mode->',MODE
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) '-rlim->',RLIM
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) '-vol ->',VOL
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) '-Ncel->',NX_CELL,NY_CELL,NZ_CELL
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) '-Izmx->',IZMAX_CELL
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) '-res ->',RESMAX_CELL
      CALL MSGDOC(MMM,LINE)

C      THETA  = (ANGLES(1)*PI)/180.0
C      PHI    = (ANGLES(2)*PI)/180.0
C      CHI    = (ANGLES(3)*PI)/180.0
C
C      CALL POLTOM(THETA,PHI,CHI,ROT)                                   
C      CALL MTRANS(ROT,ROT1)

      CALL RD_SET_TRN(NTRN,TRN)

      RAD2 = RAD*RAD    

C ----------------------------------------------------------
      XS   = 0.
      YS   = 0.
      ZS   = 0.
      XS2  = 0.
      YS2  = 0.
      ZS2  = 0.
      ICNTZ    =-999
      IX       = 0
      IY       = 0
      IZ       = 0
      ID       = 0
      IFIRST   = 0
      ZMIN     = 0.0
      ZMAX     = 0.0
      NPOINT   = 0
      NPOINT_T = 0
      RAD_MAX  = 0.0
      RAD_MAX_T= 0.0
      SUM_DENS = 0.0
      IMODE = 0
      PACK_INDEX = 1.0

      X_MIN = 1.0
      X_MAX = 0.0
      Y_MIN = 1.0
      Y_MAX = 0.0
      Z_MIN = 1.0
      Z_MAX = 0.0

      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC
C ---
      NCS = IDZNCS
C ---
 
      RMINT = 1.0E30
      RMAXT =-1.0E30
 
      DO IZ=IZMIN_CELL,IZMAX_CELL
        RMIN = 1.0E30
        RMAX =-1.0E30
        XCELL(3) = FLOAT(IZ)/FLOAT(NZ_CELL)
        DO IY=1,NY_CELL
          XCELL(2) = FLOAT(IY-1)/FLOAT(NY_CELL)
          IND0 = (IY-1)*NX_CELL
          DO IX=1,NX_CELL
            XCELL(1) = FLOAT(IX-1)/FLOAT(NX_CELL)
            IND = IND0+IX
            CALL RD_GETDNS(M,XCELL,ROBS,RAD2,R2,NTRN,TRN,MODE
     *             ,ORIG_F,SHFT_F,FTOC_REF,CTOF_REF 
     *             ,FTOC_CELL,CTOF_CELL,ROT,ROT1  
     *             ,XREF_C,NCS
     *             ,IMODE,MAP,KX,KY,KZ,KZMIN,KZMAX,IPRMAP
     *             ,R000,SCALE,IERR)
            IF(IERR.NE.0) THEN
              CALL MSGERR(MD,' ERROR: in rd_getdns (ROTDNS)')
              GO TO 900 
            ENDIF

  
            ROBS      = ROBS*RO_SCALE
            PLAN(IND) = ROBS

            IF(ROBS.GT.RLIM) THEN
c            IF(ROBS.GE.RLIM) THEN

              IF(IFIRST.EQ.0) THEN
                ZMIN   = XCELL(3)
                IFIRST = 1
              ENDIF
              ZMAX = XCELL(3)

              IF(ROBS.GT.0.000001) THEN

                IF(PACK.EQ.'Y') THEN
                  ROBS      = 1.0
                  PLAN(IND) = ROBS
                ENDIF
C ////
                  DO ITRN=2,NTRN

                    XCELL_TRN(1) = XCELL(1) + TRN(1,ITRN) 
                    XCELL_TRN(2) = XCELL(2) + TRN(2,ITRN) 
                    XCELL_TRN(3) = XCELL(3) + TRN(3,ITRN) 
                   
                    CALL RD_GETDNS(M,XCELL_TRN,ROBS_T,RAD2,R2_T
     *              ,NTRN,TRN,MODE
     *              ,ORIG_F,SHFT_F,FTOC_REF,CTOF_REF 
     *              ,FTOC_CELL,CTOF_CELL,ROT,ROT1  
     *              ,XREF_C,NCS
     *              ,IMODE,MAP,KX,KY,KZ,KZMIN,KZMAX,IPRMAP
     *              ,R000,SCALE,IERR)
                    IF(IERR.NE.0) THEN
                      CALL MSGERR(MD,' ERROR: in rd_getdns (ROTDNS)')
                      GO TO 900 
                    ENDIF
                    ROBS_T = ROBS_T*RO_SCALE
                    IF(ROBS_T.GT.RLIM.AND.ROBS_T.GT.0.000001) THEN
                      NPOINT_T = NPOINT_T + 1
                      IF(R2_T.GT.RAD_MAX_T) RAD_MAX_T = R2_T
                   ENDIF
                  ENDDO
C ////
                IF(R2.GT.RAD_MAX) RAD_MAX = R2

                NPOINT = NPOINT + 1
                SUM_DENS = SUM_DENS + ROBS

                XS   = XS  + XREF_C(1)*ROBS
                YS   = YS  + XREF_C(2)*ROBS
                ZS   = ZS  + XREF_C(3)*ROBS
                XS2  = XS2 + XREF_C(1)*XREF_C(1)*ROBS
                YS2  = YS2 + XREF_C(2)*XREF_C(2)*ROBS
                ZS2  = ZS2 + XREF_C(3)*XREF_C(3)*ROBS

              ELSE

                IF(PACK.EQ.'Y') THEN
                  ROBS      = 0.0
                  PLAN(IND) = ROBS
                ENDIF

              ENDIF

              IF(XCELL(1).LT.X_MIN) X_MIN = XCELL(1)
              IF(XCELL(1).GT.X_MAX) X_MAX = XCELL(1)
              IF(XCELL(2).LT.Y_MIN) Y_MIN = XCELL(2)
              IF(XCELL(2).GT.Y_MAX) Y_MAX = XCELL(2)
              IF(XCELL(3).LT.Z_MIN) Z_MIN = XCELL(3)
              IF(XCELL(3).GT.Z_MAX) Z_MAX = XCELL(3)

            ELSE
              ROBS = 0.0
              PLAN(IND) = ROBS
              IF(PACK.EQ.'Y')  PLAN(IND) = ROBS
            ENDIF

            IF(ROBS.LT.RMIN) RMIN = ROBS
            IF(ROBS.GT.RMAX) RMAX = ROBS
            IF(ROBS.LT.RMINT) RMINT = ROBS
            IF(ROBS.GT.RMAXT) RMAXT = ROBS

          ENDDO
        ENDDO

          CALL WDENS_MEM(MTW,MMM,ICNTZ
     *        ,NX_CELL,NY_CELL,NZ_CELL,IZMIN_CELL,IZMAX_CELL
     *        ,RMAXD,RMIND,PLAN,RESMAX_CELL,IX0,IY0,IZ0,ITR
     *        ,IPOOL_MEM)

        IF(MTW.LE.0) THEN
          CALL MSGERR(MDOC,' ERROR: write to output file (ROTDNS)')
          IERR = 1
          GO TO 900
        ENDIF
      ENDDO
C ----------------------------------------------------------
      RAD_MAX = SQRT(RAD_MAX)
      ZCENTRE = (ZMIN+ZMAX)/2.0

      R_PROT  = 0.245
      IF(SUM_DENS.GT.0.000001.AND.NPOINT.GT.0) THEN

        RO        = SUM_DENS/NPOINT
        DCORR     = R_PROT/RO 
        COEF      = VOL/FLOAT(NXYZ)
        VOL_POINT = FLOAT(NPOINT)*COEF
        SUM_EL    = R_PROT * VOL_POINT

      ELSE
        DCORR  = 1.0
        SUM_EL = 0.0
      ENDIF

      IF(NPOINT.GT.0.AND.SUM_DENS.GT.0.000001) THEN
        XS  = XS/SUM_DENS
        YS  = YS/SUM_DENS
        ZS  = ZS/SUM_DENS
        XS2 = XS2/SUM_DENS
        YS2 = YS2/SUM_DENS
        ZS2 = ZS2/SUM_DENS
      ENDIF
      RX   = XS2-XS*XS
      RY   = YS2-YS*YS
      RZ   = ZS2-ZS*ZS
      RADI = SQRT(ABS(RX+RY+RZ))

C      IF(PACK.EQ.'Y') THEN
        N = NPOINT + NPOINT_T
        IF(N.GT.0) PACK_INDEX = 1.0 - FLOAT(NPOINT_T)/FLOAT(N)

        IF(LIST.EQ.'T') THEN
          WRITE(*,*) '>>>NT,N,P:',NPOINT_T,N,PACK_INDEX
          RAD_MAX_T = SQRT(RAD_MAX_T)
          WRITE(*,*) '>>>rad_max_t:',RAD_MAX_T
        ENDIF

C      ENDIF

      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC

      mmm=mdoc
        WRITE(LINE,'(''rmax,rmin:'',2G16.4)') 
     *  RMAXT,RMINT
      CALL MSGDOC(MMM,LINE)

      WRITE(LINE,*) 'sum_dens   : ',SUM_DENS
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) 'npoint > 0 : ',NPOINT
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) 'zmin,max,cn: ',ZMIN,ZMAX,ZCENTRE
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) 'rad_max    : ',RAD_MAX
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) 'dcorr      : ',DCORR
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) 'sum_el     : ',SUM_EL
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) 'Rad_inertia: ',RADI
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,*) 'VOLp,ro    : ',VOL_POINT,RO
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,'(''x_min,max   :'',2F8.3)') X_MIN,X_MAX
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,'(''y_min,max   :'',2F8.3)') Y_MIN,Y_MAX
      CALL MSGDOC(MMM,LINE)
      WRITE(LINE,'(''z_min,max   :'',2F8.3)') Z_MIN,Z_MAX
      CALL MSGDOC(MMM,LINE)

      RESULT( 1) = SHFT_F(1)      
      RESULT( 2) = SHFT_F(2)      
      RESULT( 3) = SHFT_F(3)     
      RESULT( 4) = ANGLES(1)     
      RESULT( 5) = ANGLES(2)     
      RESULT( 6) = ANGLES(3)     
      RESULT( 7) = NPOINT     
      RESULT( 8) = ZMIN      
      RESULT( 9) = ZMAX      
      RESULT(10) = ZCENTRE
      RESULT(11) = RAD_MAX      
      RESULT(12) = DCORR     
      RESULT(13) = SUM_EL      
      RESULT(14) = NX_CELL     
      RESULT(15) = NY_CELL     
      RESULT(16) = NZ_CELL     
      RESULT(17) = RESMAX_CELL     
      RESULT(18) = RADI
      RESULT(19) = IZMIN_CELL
      RESULT(20) = IZMAX_CELL
      RESULT(21) = PACK_INDEX
C ------
 900  CONTINUE
      RETURN
      END

      SUBROUTINE RD_SET_TRN(NTRN,TRN)
C ---------------------------
      REAL TRN(3,27)
C ---------------------------
      NTRN = 27
C ---
      TRN(1, 1) = 0.0
      TRN(2, 1) = 0.0
      TRN(1, 2) = 1.0
      TRN(2, 2) = 0.0
      TRN(1, 3) =-1.0
      TRN(2, 3) = 0.0
      TRN(1, 4) = 0.0
      TRN(2, 4) = 1.0
      TRN(1, 5) = 0.0
      TRN(2, 5) =-1.0
      TRN(1, 6) = 1.0
      TRN(2, 6) = 1.0
      TRN(1, 7) =-1.0
      TRN(2, 7) = 1.0
      TRN(1, 8) = 1.0
      TRN(2, 8) =-1.0
      TRN(1, 9) =-1.0
      TRN(2, 9) =-1.0
C
      TRN(1,10) = 0.0
      TRN(2,10) = 0.0
      TRN(1,11) = 1.0
      TRN(2,11) = 0.0
      TRN(1,12) =-1.0
      TRN(2,12) = 0.0
      TRN(1,13) = 0.0
      TRN(2,13) = 1.0
      TRN(1,14) = 0.0
      TRN(2,14) =-1.0
      TRN(1,15) = 1.0
      TRN(2,15) = 1.0
      TRN(1,16) =-1.0
      TRN(2,16) = 1.0
      TRN(1,17) = 1.0
      TRN(2,17) =-1.0
      TRN(1,18) =-1.0
      TRN(2,18) =-1.0
C
      TRN(1,19) = 0.0
      TRN(2,19) = 0.0
      TRN(1,20) = 1.0
      TRN(2,20) = 0.0
      TRN(1,21) =-1.0
      TRN(2,21) = 0.0
      TRN(1,22) = 0.0
      TRN(2,22) = 1.0
      TRN(1,23) = 0.0
      TRN(2,23) =-1.0
      TRN(1,24) = 1.0
      TRN(2,24) = 1.0
      TRN(1,25) =-1.0
      TRN(2,25) = 1.0
      TRN(1,26) = 1.0
      TRN(2,26) =-1.0
      TRN(1,27) =-1.0
      TRN(2,27) =-1.0
C
      TRN(3, 1) = 0.0
      TRN(3, 2) = 0.0
      TRN(3, 3) = 0.0
      TRN(3, 4) = 0.0
      TRN(3, 5) = 0.0
      TRN(3, 6) = 0.0
      TRN(3, 7) = 0.0
      TRN(3, 8) = 0.0
      TRN(3, 9) = 0.0
      TRN(3,10) = 1.0
      TRN(3,11) = 1.0
      TRN(3,12) = 1.0
      TRN(3,13) = 1.0
      TRN(3,14) = 1.0
      TRN(3,15) = 1.0
      TRN(3,16) = 1.0
      TRN(3,17) = 1.0
      TRN(3,18) = 1.0
      TRN(3,19) =-1.0
      TRN(3,20) =-1.0
      TRN(3,21) =-1.0
      TRN(3,22) =-1.0
      TRN(3,23) =-1.0
      TRN(3,24) =-1.0
      TRN(3,25) =-1.0
      TRN(3,26) =-1.0
      TRN(3,27) =-1.0
C ---
      RETURN
      END

      SUBROUTINE RD_GETDNS(MDOC,XCELL,ROBS_SUM,RAD2,R2
     *             ,NTRN_INPUT,TRN,MODE
     *             ,ORIG_F,SHFT_F,FTOC_REF,CTOF_REF
     *             ,FTOC_CELL,CTOF_CELL,ROT,ROT1  
     *             ,XREF_C,NCS
     *             ,IMODE,MAP,KX,KY,KZ,KZMIN,KZMAX,IPRMAP
     *             ,R000,SCALE,IERR)
C --------------------------------------------------
      INTEGER*2 MAP(IPRMAP)      
      REAL      ORIG_F(3),SHFT_F(3),XCELL(3)
      REAL      FTOC_CELL(3,3),CTOF_CELL(3,3)
      REAL      FTOC_REF(3,3),CTOF_REF(3,3)
      REAL      ROT(3,3),ROT1(3,3,*),TRN(3,27)
      CHARACTER LINE*256,MODE*1
      REAL      XTEMP(3),XTEMP_C(3),XREF(3),XREF_C(3),PREF(3)
C --------------------------------------------------
      IERR = 0
      ROBS = 0.0
      ROBS_SUM = 0.0
      NROBS    = 0
      R2   = 0.0
      NTRN = NTRN_INPUT
      NTRN = 1

      DO K=1,NCS

      DO I=1,NTRN

        XTEMP(1) = XCELL(1) - SHFT_F(1) + TRN(1,I) 
        XTEMP(2) = XCELL(2) - SHFT_F(2) + TRN(2,I) 
        XTEMP(3) = XCELL(3) - SHFT_F(3) + TRN(3,I) 

        CALL MVMULT(FTOC_CELL,XTEMP,XTEMP_C)
        CALL MVMULT(ROT1(1,1,K),XTEMP_C,XREF_C)

        R2 = XREF_C(1)*XREF_C(1) + XREF_C(2)*XREF_C(2) +
     *       XREF_C(3)*XREF_C(3) 

        IF(RAD2.GT.0.0001.AND.R2.GT.RAD2) GO TO 100

        CALL MVMULT(CTOF_REF,XREF_C,XREF)

        PREF(1) = XREF(1) + ORIG_F(1) 
        PREF(2) = XREF(2) + ORIG_F(2) 
        PREF(3) = XREF(3) + ORIG_F(3) 

        IF(PREF(1).LT.0.0) GO TO 100
        IF(PREF(2).LT.0.0) GO TO 100
        IF(PREF(3).LT.0.0) GO TO 100
        IF(PREF(1).GT.1.0) GO TO 100
        IF(PREF(2).GT.1.0) GO TO 100
        IF(PREF(3).GT.1.0) GO TO 100


        IF(MODE.EQ.'2') THEN
          CALL GETDNS2(MDOC,IMODE,PREF(1),PREF(2),PREF(3),ROBS
     *    ,MAP,KX,KY,KZ,KZMIN,KZMAX,R000,SCALE,IPRMAP,IERR)
        ELSE
          CALL GETDNS(MDOC,IMODE,PREF(1),PREF(2),PREF(3),ROBS
     *    ,MAP,KX,KY,KZ,KZMIN,KZMAX,R000,SCALE,IERR)
        ENDIF

        IF(IERR.NE.0) THEN
          ROBS = 0.0
          GO TO 200 
        ENDIF

c       IF(ABS(ROBS).LT.0.000001) GO TO 100

        ROBS_SUM = ROBS_SUM + ROBS
        NROBS    = NROBS + 1       
        GO TO 200

 100    CONTINUE
      ENDDO
 200  CONTINUE

      ENDDO

      IF(NROBS.GT.0) THEN
        ROBS_SUM = ROBS_SUM/FLOAT(NROBS) 
      ENDIF

      RETURN
      END

      SUBROUTINE GETDNS2(MDOC,IMODE,X,Y,Z,DENS,IR,NX,NY,NZ,NZMIN,NZMAX,
     *                  R000,SCALE,IPRMAP,IERR)
C ------------------------------------------------------------------
C
C -P- GETDNS - get DENS from array IR-"byte"
C
C      input : X,Y,Z  -  >= 0  /in unit cell/
C                       NX,NY,NZ NZMIN-NZMAX  NZMIN=0
C
C      output: DENS   = ID/BYTE/ * SCALE - R000
C -------------------------------------------------------------------
C
C  IMODE=0
C         input    JX : from: 0 to: NX-1
C                  JY : from: 0 to: NY-1
C                  JZ : from: 0 to: NZMIN - NZMAX
C         output   ID   from byte-array IR 
C                             / dimension NX,NY,NZMAX-NZMIN+1/
C  IMODE=1
C         input    JX : from: 0 to: NX/2
C                  JY : from: 0 to: NY-1
C                  JZ : from: 0 to: NZMAX-NZMIN
C         output   ID   from byte-array IR 
C                             / dimension NX/2+1,NY,NZMAX-NZMIN+1/
C  IMODE=2
C         input    JX : from: 0 to: NX/2
C                  JY : from: 0 to: NY/2
C                  JZ : from: 0 to: NZMAX-NZMIN
C
C         output   DENS   from byte-array IR 
C                             / dimension NX/2+1,NY/2+1,NZMAX-NZMIN+1/
C         output IERR > 0 is signal of error.
C ------------------------------------------------------------------
      INTEGER*2 IR(IPRMAP)
C ------------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      IF(X.LT.0.0) THEN
        CALL MSGERR(MDOC,' ERR0R: IN SUBR "GETDNS2" --> X < 0')
        IERR=1
        RETURN
      ENDIF
      IF(Y.LT.0.0) THEN
        CALL MSGERR(MDOC,' ERROR: IN SUBR "GETDNS2" --> Y < 0')
        IERR=1
        RETURN
      ENDIF
      IF(Z.LT.0.0) THEN
        CALL MSGERR(MDOC,' ERROR: IN SUBR "GETDNS2" --> Z < 0')
        IERR=1
        RETURN
      ENDIF
      NX2 = NX/2
      NY2 = NY/2
      IX  = X*NX
      IY  = Y*NY
      IZ  = Z*NZ
      AX  = X*NX-IX
      AY  = Y*NY-IY
      AZ  = Z*NZ-IZ
      IF(IZ .GT.NZMAX) IZ =NZMAX
      IF(IMODE.EQ.0) THEN
        IF(IX .GE.NX ) IX = 0
        IF(IY .GE.NY ) IY = 0
      ELSE IF(IMODE.EQ.1) THEN
        IF(IX .GT.NX2) IX = NX2
        IF(IY .GE.NY ) IY = 0  
      ELSE IF(IMODE.EQ.2) THEN
        IF(IX .GT.NX2) IX = NX2
        IF(IY .GE.NY2) IY = NY2
      ENDIF
      IXX = IX+1
      IYY = IY+1
      IZZ = IZ+1
      IF(IZZ.GT.NZMAX) IZZ=NZMAX
      IF(IMODE.EQ.0) THEN
        IF(IXX.GE.NX ) IXX = 0
        IF(IYY.GE.NY ) IYY = 0
      ELSE IF(IMODE.EQ.1) THEN
        IF(IXX.GT.NX2) IXX = NX2
        IF(IYY.GE.NY ) IYY = 0  
      ELSE IF(IMODE.EQ.2) THEN
        IF(IXX.GT.NX2) IXX = NX2
        IF(IYY.GE.NY2) IYY = NY2
      ENDIF
      AAX = 1.0-AX
      AAY = 1.0-AY
      AAZ = 1.0-AZ
      CALL GTDENS2(IMODE,IX ,IY ,IZ ,IDEN
     *                              ,IR,NX,NY,NZ,NZMIN,NZMAX,IPRMAP)
      R111=IDEN
      CALL GTDENS2(IMODE,IX ,IY ,IZZ,IDEN
     *                              ,IR,NX,NY,NZ,NZMIN,NZMAX,IPRMAP)
      R112=IDEN
      CALL GTDENS2(IMODE,IXX,IYY,IZ ,IDEN
     *                              ,IR,NX,NY,NZ,NZMIN,NZMAX,IPRMAP)
      R221=IDEN
      CALL GTDENS2(IMODE,IXX,IYY,IZZ,IDEN
     *                              ,IR,NX,NY,NZ,NZMIN,NZMAX,IPRMAP)
      R222=IDEN
      CALL GTDENS2(IMODE,IXX,IY ,IZ ,IDEN
     *                              ,IR,NX,NY,NZ,NZMIN,NZMAX,IPRMAP)
      R211=IDEN
      CALL GTDENS2(IMODE,IXX,IY ,IZZ,IDEN
     *                              ,IR,NX,NY,NZ,NZMIN,NZMAX,IPRMAP)
      R212=IDEN
      CALL GTDENS2(IMODE,IX ,IYY,IZ ,IDEN
     *                              ,IR,NX,NY,NZ,NZMIN,NZMAX,IPRMAP)
      R121=IDEN
      CALL GTDENS2(IMODE,IX ,IYY,IZZ,IDEN
     *                              ,IR,NX,NY,NZ,NZMIN,NZMAX,IPRMAP)
      R122=IDEN
  
      R1 = AAX*R111+AX*R211
      D1 = AAX*R112+AX*R212
      R2 = AAX*R121+AX*R221
      D2 = AAX*R122+AX*R222
      RY = AAY*R1  +AY*R2
      DY = AAY*D1  +AY*D2
      DP = AAZ*RY  +AZ*DY

      DENS = DP*SCALE-R000

      RETURN
      END

      SUBROUTINE GTDENS2(IMODE,JX,JY,JZ,ID
     *                  ,IR,NX,NY,NZ,NZMIN,NZMAX,IPRMAP)
C -------------------------------------------------------------------
C     ==== GTDENS ======
C    !!!!   FIRST CALL SETDEN WITH IMODE=-1
C -----------------------------
C  IMODE=0
C         input    JX : from: 0 to: NX-1
C                  JY : from: 0 to: NY-1
C                  JZ : from: 0 to: NZMIN - NZMAX
C         output   ID   from byte-array IR 
C                             / dimension NX,NY,NZMAX-NZMIN+1/
C  IMODE=1
C         input    JX : from: 0 to: NX/2
C                  JY : from: 0 to: NY-1
C                  JZ : from: 0 to: NZMAX-NZMIN
C         output   ID   from byte-array IR 
C                             / dimension NX/2+1,NY,NZMAX-NZMIN+1/
C  IMODE=2
C         input    JX : from: 0 to: NX/2
C                  JY : from: 0 to: NY/2
C                  JZ : from: 0 to: NZMAX-NZMIN
C
C         output   ID   from byte-array IR 
C                             / dimension NX/2+1,NY/2+1,NZMAX-NZMIN+1/
C
C ---------------------------------------------------------------------
C     ==== SETDEN ======
C -----------------------------
C     ENTRY SETDEN(IMODE,JX,JY,JZ,ID,IR,NX,NY,NZ,NZMIN,NZMAX)
C    !!!!   FIRST CALL SETDEN WITH IMODE=-1
C -P-        GTDENS
C -P-  ENTRY SETDEN
C -----------------------------
C  IMODE=0
C         input    JX : from: 0 to: NX-1
C                  JY : from: 0 to: NY-1
C                  JZ : from: 0 to: NZMAX-NZMIN
C  IMODE=1
C         input    JX : from: 0 to: NX/2
C                  JY : from: 0 to: NY-1
C                  JZ : from: 0 to: NZMAX-NZMIN
C  IMODE=2
C         input    JX : from: 0 to: NX/2
C                  JY : from: 0 to: NY/2
C                  JZ : from: 0 to: NZMAX-NZMIN
C         ID  dens in point JX,JY,JZ move to array IR
C -----------------------------
      INTEGER*2   IR(IPRMAP)
      INTEGER*2   IN2(2),JN2(2)
      INTEGER     IN4,JN4,IT
      EQUIVALENCE (IN4,IN2(1)),(JN4,JN2(1))
      COMMON/COM_BYTE/ IBYTE1,IBYTE2
     *,ISTART_A_CAP,ISTART_A_LOW,ISTART_DIG_0
C ----------------------------------------
      ITYPE=0
      GO TO 10
C ----
      ENTRY SETDEN2(IMODE,JX,JY,JZ,ID,IR,NX,NY,NZ,NZMIN,NZMAX,IPRMAP)
C ----
      ITYPE=1
 10   CONTINUE
      IF(IMODE.EQ.-1) THEN
        IN2(1) = 100
        IN2(2) = 0
        IF(IN4.EQ.100) THEN
C          IN4
C          2 1
          IBYTE1 = 1
          IBYTE2 = 2
        ELSE
C          IN4
C          1 2
          IBYTE1 = 2
          IBYTE2 = 1
        ENDIF
        RETURN
      ENDIF
C -----
      IX = JX
      IY = JY
      IZ = JZ
      IF(IZ.LT.NZMIN) IZ = NZMIN
      IF(IZ.GT.NZMAX) IZ = NZMAX
      IZ  = IZ-NZMIN
      IF(IMODE.EQ.0) THEN
        IND =(NY*IZ+IY)*NX+IX+1
      ELSE IF(IMODE.EQ.1) THEN
        NX2 = NX/2
        IND =(NY*IZ+IY)*(NX2+1)+IX+1
      ELSE IF(IMODE.EQ.2) THEN
        NX2 = NX/2
        NY2 = NY/2
        IND = ((NY2+1)*IZ+IY)*(NX2+1)+IX+1
      ENDIF

      IF(IND.LE.0.OR.IND.GT.IPRMAP) THEN
        write(*,*)itype,imode,ind,iprmap 
        write(*,*)JX,JY,JZ,NX,NY,NZ,NZMIN,NZMAX 
        M = 1
        CALL MSGERR(M,'ERROR: in GTDENS2')
        IERR = 1
        stop
      ENDIF

      IF(ITYPE.EQ.0) THEN
C     --- GET ---
        ID = IR(IND)
      ELSE
C     --- SET ---
        IR(IND) = ID
      ENDIF

      RETURN
      END

      SUBROUTINE RDSORT_F2P1(MT,NUMBT,NFL,IARRH,IARRS,ARRF,ARRS
     *   ,ACELL,BCELL,CCELL,ALCELL,BECELL,GACELL,NSG,NSETT,CODE
     *   ,PDB_CODE,MAXREF,RLATT,RESMIN,RESMAX,RESX,ISYM,NSYM
     *   ,IPRSYM,MSG,FORM,NAME,LINE,SETT,ITEST,IERR)
C -----------------------------------------
      REAL RESMIN,RESMAX
      INTEGER*4 MT,IERR
      INTEGER*4 NUMBT,MAXREF,IARRH(*),IARRS(*)
      REAL      ARRF(*),ARRS(*)
      INTEGER*4 NSYM
      INTEGER*2 ISYM(5,3,*)
      REAL RLATT(6)
      CHARACTER MSG*1,FORM*1,NAME*(*),CODE*4,PDB_CODE*4,DATE*9
      INTEGER*4 IPRSYM
C -------------------------------------
      PARAMETER ( NEQ=200 )
      REAL      FSQ(NEQ),SD(NEQ)

      INTEGER     INBUF(1800)
      INTEGER     IND(200)
      INTEGER*2   IRDATA(9),ITITLE(30)
      CHARACTER   TITLE*60,LINE*256,STR*256
      EQUIVALENCE (INBUF(1),FSQ),(INBUF(201),IND),(INBUF(401),SD)
      EQUIVALENCE (INBUF(1),IRDATA)
      EQUIVALENCE (TITLE,ITITLE)
      CHARACTER   ITPF*4
      CHARACTER   PATH*1,EXT*1,SGNAME*24,SETT*1,STATUS*1
      EXTERNAL    PACK
C------------------------------------------------
      IERR = 0
      MDOC = MT
      MD =-ABS(MDOC)-1
C------------------------------
      PATH  = ' '
      EXT   = ' '
      IHMIN =-511
      IHMAX = 511
      IKMIN =-511
      IKMAX = 511
      ILMIN =-511
      ILMAX = 511
C-------------------------------------
120   CONTINUE
      IERR=0
      IF(FORM.EQ.' ') GO TO 240

c      LINE=' '
      LRECIN = 1600
      MTIN   = 10


        ITPF = '    '
        MD   =-1
        CALL ORFILE(MD,MTIN,NAME,ITPF,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.GT.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE_IN')
          GO TO 240
        ENDIF
        CALL GET_TITLE(MD,ACELL,BCELL,CCELL,ALCELL,BECELL,GACELL
     *  ,F1,F2,RN,RX,IDM,IDM,IDM,IDM,IDM,STR,IERR)
        IF(ITPF.NE.'F   '.AND.ITPF.NE.'FS  ') THEN
          CALL MSGERR(MT,' ERR: WRONG TYPE OF FILE')
          CLOSE(MTIN)
          IERR=2
          GO TO 240
        ENDIF
        IF(MSG.NE.' '.AND.MSG.NE.'B'.AND.MSG.NE.'D') THEN
          CALL MSGERR(MT,' ERR: WRONG TYPE OF FILE')
          CLOSE(MTIN)
          IERR=1
          RETURN
        ENDIF

        RLIM = RX
        IF(RESX.GT.0.00001.AND.RESX.GT.RLIM) RLIM = RESX
        RHX = 1.0/RLIM

C        IF(MSG.EQ.' ') THEN
          CALL C_RD_CR
          RLATT(1) = ACELL
          RLATT(2) = BCELL
          RLATT(3) = CCELL
          RLATT(4) = ALCELL
          RLATT(5) = BECELL
          RLATT(6) = GACELL
          LINE     = STR
C        ENDIF
        MSG = FORM
C ---------------------------------------------
      NS = 1

      CALL DSTARF(RLATT,AST,BST,CST,COALST,COBEST,COGAST,VOL)
      CALL ANOMF(MT,NS,ISYM)

C ---------------------------------------------
      NFL = NFL+1
      MD  = -1
      CALL LENSTR_BL(NAME,LEN)
      IF(LEN.GT.64) LEN=64
      WRITE(STR,'('' INPUT-FILE :'',A)') NAME(1:LEN)
      CALL MSGDOC(MD,STR)
C ---------------------------------------------
      IPRNT = 5000
C================================
      KEY    = 0
      IEND   =-1
      NUMB   = 0
      ICNT   = 0
      NBL    = 0
      RHMIN  = 1.E 30
      RHMAX  = 0.0
      NBAD   = 0
      NBSD   = 0
      NBABS  = 0
      SUMSDT = 0.0
      SUMINT = 0.0
      ISUM1  = 0
      ISUM3  = 0
      ISUM10 = 0
      IF(FORM.EQ.'P') THEN
C        NRECS=400
C        LRDEF=9
      ELSE IF(FORM.EQ.'B') THEN
        NRECS=1
      ELSE IF(FORM.EQ.'H') THEN
        NRECS=1
      ELSE
        NRECS = 200
        LRDEF = 8
      ENDIF
      JRECS = 200
C -----------------------------------------------------
  200 CONTINUE
C ===
        IF(ITPF.EQ.'FS  ') THEN
          CALL RRD1(MTIN,LH,LK,LL,FA,FB,SA,SB,KEY,IEND)
          IF(SA.LT.0.000001) SA = 0.04*FA
          IF(SB.LT.0.000001) SB = 0.04*FB
        ELSE
          CALL RD1(MTIN,LH,LK,LL,FA,FB,KEY,IEND)
          SA = 0.04*FA
          SB = 0.04*FB
        ENDIF
        IF(IEND.EQ.1) GO TO 210
        NBL = NBL+1
        IF(FA.LT.1.E-5.AND.FB.LT.1.E-5) GO TO 220
        IF(FB.LT.1.E-5) THEN
          FB   = 0.0
          SB   = 0.0
          SDL  = 2.0*FA*SA
          FSQL = FA*FA 
          NRECS= 1
          INEG = 0
        ELSE IF(FA.LT.1.E-5) THEN
          FA   = 0.0
          SA   = 0.0
          SDL  = 2.0*FB*SB
          FSQL = FB*FB
          NRECS= 1
          INEG = 1
        ELSE
          NRECS = 1
          SDL   = 0.0
          FSQL  = 0.0
          
          WT1  = 1./(SA*SA)
          WT2  = 1./(SB*SB)
          WT   = WT1+WT2
          FAA  = FA*WT1+FB*WT2
          FAA  = FAA/WT
          SAA  = 1./SQRT(WT)
          SDL  = 2.0*FAA*SAA
          FSQL = FAA*FAA 
          NRECS= 1

          SDL   = 2.0*FA*SA
          FSQL  = FA*FA 
          SDLN  = 2.0*FB*SB
          FSQLN = FB*FB 
          NRECS = 2
          INEG  = 0

        ENDIF
        J=0
C ===

  220 J=J+1
      IF(J.GT.NRECS) GO TO 200

C ===
        IF(J.EQ.1) THEN
          ICNT = ICNT+1
          IF(INEG.EQ.0) THEN
            IHR = LH
            IKR = LK
            ILR = LL
          ELSE
            IHR=-LH
            IKR=-LK
            ILR=-LL
          ENDIF
          FRD  = FSQL
          SDEV = SDL
        ELSE
          ICNT = ICNT+1
          IHR  =-LH
          IKR  =-LK
          ILR  =-LL
          FRD  = FSQLN
          SDEV = SDLN
        ENDIF
C ===


      IF(FRD.LE.0.0)                   GO TO 230
      IF(IHR.LT.IHMIN.OR.IHR.GT.IHMAX) GO TO 230
      IF(IKR.LT.IKMIN.OR.IKR.GT.IKMAX) GO TO 230
      IF(ILR.LT.ILMIN.OR.ILR.GT.ILMAX) GO TO 230
      IF(ILR.EQ.0.AND.IKR.EQ.0.AND.IHR.EQ.0) GO TO 230

      ICND=0
      IF(ICND.NE.0) THEN
        NBABS = NBABS+1
        NBAD  = NBAD+1
        IF (NBAD.LT.100) THEN
          WRITE(STR,'('' -->SYSABS:H,K,L,I,SD:'',6X,3I4,F14.2,F10.2)')
     .                     IHR,IKR,ILR,FRD,SDEV
          CALL MSGDOC(MD,STR)
        ELSE IF (NBAD.EQ.100) THEN
          CALL MSGDOC(MD,' ... more ...')
        ENDIF
        GO TO 200
      ENDIF

      IF(FORM.NE.'H') THEN
        IF(SDEV.LE.0.0.AND.FORM.NE.'A') THEN
          NBAD = NBAD+1
          NBSD = NBSD+1
          IF (NBAD.LT.100) THEN
          WRITE(STR,'('' -->SD_LIM:H,K,L,I,SD:'',6X,3I4,F14.2,F10.2)')
     .                     IHR,IKR,ILR,FRD,SDEV
          CALL MSGDOC(MD,STR)
          ELSE IF (NBAD.LE.100) THEN
          CALL MSGDOC(MD,' ... more ...')
          ENDIF
          GO TO 200 
        ENDIF
        NUMB   = NUMB +1
        SUMSDT = SUMSDT+SDEV
        SUMINT = SUMINT+FRD
        TEST   = FRD/SDEV
        IF(TEST.GT. 1.) ISUM1  = ISUM1 +1
        IF(TEST.GT. 3.) ISUM3  = ISUM3 +1
        IF(TEST.GT.10.) ISUM10 = ISUM10+1
      ENDIF

      CALL DSTAR(IHR,IKR,ILR,RS)
      RH=SQRT(RS)
      IF(RH.GT.RHX) GO TO 200

      DO IS=1,NSYM

        NH=ISYM(1,1,IS)*IHR+ISYM(1,2,IS)*IKR+ISYM(1,3,IS)*ILR
        NK=ISYM(2,1,IS)*IHR+ISYM(2,2,IS)*IKR+ISYM(2,3,IS)*ILR
        NL=ISYM(3,1,IS)*IHR+ISYM(3,2,IS)*IKR+ISYM(3,3,IS)*ILR

        IF(ITEST.LE.0) THEN
        IF(NUMBT+1.GT.MAXREF) THEN
          WRITE(STR,7000) MAXREF
          CALL MSGDOC(MD,STR)
 7000     FORMAT('!!!! NUMBER OF INPUT REFLECTIONS > ',I7,' !!!!!')
          GO TO 7001
        ENDIF
        ENDIF

        NUMBT = NUMBT+1

        NS = 1
        CALL ANOMSC(NH,NK,NL,KANOM,JJSYM,NS,ISYM)
        IF(KANOM.NE.1) JJSYM=-JJSYM
c       JJSYM = 1
 
       CALL PACK(INDEX,NH,NK,NL)
C  ----- IARRH(NUMBT)=((NL+000128)*000256+NK+000128)*000256+NH+000128

        IF(ITEST.LE.0) THEN
          IARRH(NUMBT) = INDEX
          IARRS(NUMBT)= (KEY*256+(JJSYM+128))*256+NFL
          ARRF (NUMBT) = FRD
          ARRS (NUMBT) = SDEV
        ENDIF
      ENDDO


      IF(IPRNT.GT.0) THEN
        IF(MOD(NUMB,IPRNT).EQ.0) THEN
          IF(FORM.NE.'H') THEN
            WRITE(STR,
     *'(''   N,H,K,L,I,SD,ISYM:'',I6,3I4,F14.2,F14.2,I4)')
     *       NUMB,IHR,IKR,ILR,FRD,SDEV,JJSYM
            CALL MSGDOC(MD,STR)
          ELSE
            FOM=SDEV-1.0
            PHI=FRD-1.0
            WRITE(STR,
     *'(''   N,H,K,L,m,PH,ISYM:'',I6,3I4,F14.2,F14.2,I4)')
     *       NUMB,IHR,IKR,ILR,FOM,PHI,JJSYM
            CALL MSGDOC(MD,STR)
          ENDIF
        ENDIF
      ENDIF
      CALL DSTAR(NH,NK,NL,RS)
      RH=SQRT(RS)
      IF(RH.LT.RHMIN) RHMIN=RH
      IF(RH.GT.RHMAX) RHMAX=RH
      GO TO 220
230   NBAD=NBAD+1
      IF (NBAD.LE.100) THEN
        WRITE(STR,'('' --> OUT  :H,K,L,I,SD:'',6X,3I4,F14.2,F10.2)')
     .                     IHR,IKR,ILR,FRD,SDEV
        CALL MSGDOC(MD,STR)
      ELSE IF (NBAD.LE.100) THEN
        CALL MSGDOC(MD,' ... more ...')
      ENDIF
      GO TO 220
C-----------------------------------------------
  210 CONTINUE
7001  CONTINUE
C     WRITE( *,'('' N-REFLS: READ='',I6,'' PASS='',I6)') ICNT,NUMB
      IF(RHMAX.GT.0.000001) THEN
        RHMAX=1./RHMAX
      ELSE
        RHMAX=88888.88
      ENDIF
      IF(RHMIN.GT.0.000001) THEN
        RHMIN=1./RHMIN
      ELSE
        RHMIN=88888.88
      ENDIF
      IF(RESMIN.LT.RHMIN) RESMIN=RHMIN
      IF(RESMAX.GT.RHMAX) RESMAX=RHMAX

c --
      IT = RESMIN*1000.0 
c      IT = IT + 1
      RESMIN = FLOAT(IT)/1000.0
      IT = RESMAX*1000.0 
c      IT = IT - 1
      RESMAX = FLOAT(IT)/1000.0
c --

C      WRITE(*,403) RHMIN,RHMAX
  403 FORMAT(1X,'RESOLUTION OF DATA :',F8.2,' - ',F8.2,' ANGSTR')
      IF(FORM.NE.'A'.AND.FORM.NE.'H') THEN
        IF(SUMINT.NE.0.0) SUMSDT=SUMSDT/SUMINT
      ENDIF
      IF(NUMBT.GT.0) THEN
        TEMP1 = FLOAT(ISUM1 )/NUMB
        TEMP2 = FLOAT(ISUM3 )/NUMB
        TEMP3 = FLOAT(ISUM10)/NUMB
      ELSE
        TEMP1 = 0.0
        TEMP2 = 0.0
        TEMP3 = 0.0
      ENDIF

      CALL MSGDOC(MD,' -----------------------------')
      WRITE(STR,'('' N-REFLS: READ='',I6,'' PASS='',I6)') ICNT,NUMBT
      CALL MSGDOC(MD,STR)
      WRITE(STR,403) RHMIN,RHMAX
      CALL MSGDOC(MD,STR)
      IF(FORM.NE.'H') THEN
        WRITE(STR,'('' R-STAND-OLD :'',F8.4)') SUMSDT
        CALL MSGDOC(MD,STR)
        WRITE(STR,'('' I >SIG,>3SIG,>10SIG:'',3I8)')ISUM1,ISUM3,ISUM10
        CALL MSGDOC(MD,STR)
      ELSE
        WRITE(STR,'('' m >0.1,>0.3 ,>0.9  :'',3I8)')ISUM1,ISUM3,ISUM10
        CALL MSGDOC(MD,STR)
      ENDIF
      WRITE(STR,'(''                     '',3F8.3)') TEMP1,TEMP2,TEMP3
      CALL MSGDOC(MD,STR)
      CALL MSGDOC(MD,' -----------------------------')
      CLOSE(MTIN)

C     RETURN

240   WRITE(STR,'('' TOTAL NUMBER OF REFLS :'',I8)') NUMBT
      CALL MSGDOC(MD,STR)
      IF(NUMBT.LE.1) THEN
        CALL MSGDOC(MT,' ERR: NUMBER OF REFLS < 2')
        IERR=1
        RETURN
      ENDIF
      RETURN
C ------------------------------------------------------------------
 9991 CONTINUE
      CALL MSGDOC(MD,' ERR : END OF FILE')
      CLOSE(MTIN)
      IERR=2
      RETURN
      END

      SUBROUTINE JOINWR_F2P1(MT,NUMBT,IARRH,IARRS,ARRF,ARRS
     *   ,MAXREF,RLATT,RESMIN,RESMAX,ISYM,NSYM
     *   ,NAME_OUT,IANOM,ATOP
     *   ,IPRSYM,FORM,STR,IERR)
C --
      REAL RESMIN,RESMAX
      INTEGER*4 MT,IERR
      INTEGER*4 NUMBT,MAXREF,IARRH(*),IARRS(*)
      REAL      ARRF(*),ARRS(*)
      INTEGER*4 NSYM
      INTEGER*4 IPRSYM
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL RLATT(6)
      CHARACTER FORM*1,NAME_OUT*(*),STR*(*)
C -----------------------------------------
      PARAMETER ( NEQ=200 )
      REAL       FSQ(NEQ),SD(NEQ)
      INTEGER    MRKR(NEQ)
      INTEGER*4  ITYP,IANOM
      REAL       ATOP
      CHARACTER  NAME*256,LINE*256
C ---------------------------------------------------
      IERR=0
      IF(NUMBT.LE.0) THEN
        CALL MSGERR(MT,' ERR: NUMBER OF REFLS < 1')
        IERR=1
        RETURN
      ENDIF
      CALL MSGDOC(MT,' --- SORT ----')
      CALL ISORT3(IARRH,NUMBT,IARRS,ARRF,ARRS)
      CALL MSGDOC(MT,' --- SORT  FINISHED ---')
C-------
      CALL MSGDOC(MT,' -----------------------------')
C ----------------------------------------------------
      NAME=NAME_OUT
      CALL LENSTR_BL(NAME,LEN)
      IF(LEN.LE.0.OR.NAME(1:1).EQ.' '.OR.NAME(1:1).EQ.',') THEN
        CALL MSGERR(MT,' ERR: WRONG FILE-NAME')
        IERR=1
        RETURN
      ENDIF

      ITYP=0
      CALL SORTRF_F2P1(MT,NAME,IANOM,IARRH,IARRS,ARRF,ARRS
     *    ,MAXREF,NUMBT,ATOP,ITYP,NSYM,ISYM,IPRSYM
     *    ,FSQ,SD,MRKR,NEQ,RLATT,FORM,STR,RESMIN,RESMAX,IERR)
      RETURN
      END

      SUBROUTINE SORTRF_F2P1(MT,NAME,IANOM,IARRH,IARRS,ARRF,ARRS
     * ,MAXREF,NUMBT,ATOP,ITYP,NSYM,ISYM,IPRSYM
     * ,FSQ,SD,MRKR,NEQ,RLATT,FORM,LINE,RESMIN,RESMAX,IERR)
C ------------------------------------------------------------------
      INTEGER   IARRH(MAXREF),IARRS(MAXREF)
      REAL      ARRF (MAXREF),ARRS (MAXREF)
      REAL      FSQ(NEQ),SD(NEQ)
      INTEGER   MRKR(NEQ)
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RLATT(6)
      CHARACTER FORM*1
      INTEGER   IFL(200)
      INTEGER   NMGRPR(22),NMGRSM(22),NMGRSA(22),NMGR(22),NMGRRP(22)
      REAL      RFAC11(22),RFAC12(22),RFAC21(22),RFAC22(22)
      REAL      RFAC31(22),RFAC32(22),RFAC41(22),RFAC42(22)
      REAL      RFAC51(22),RFAC52(22),RFAC61(22),RFAC62(22)
      CHARACTER   ITPF*4,NAME*(*),STR*256,LINE*256
      CHARACTER   MSG*1,MSG1*1,MSG2*1,MSG5*1
      EXTERNAL  UNPACK
C==================================================================
      DO     I=1,22
        NMGR  (I)=0
        NMGRPR(I)=0
        NMGRSM(I)=0
        NMGRSA(I)=0
        NMGRRP(I)=0
        RFAC11(I)=0.
        RFAC21(I)=0.
        RFAC31(I)=0.
        RFAC41(I)=0.
        RFAC12(I)=0.
        RFAC22(I)=0.
        RFAC32(I)=0.
        RFAC42(I)=0.
        RFAC51(I)=0
        RFAC52(I)=0
        RFAC61(I)=0
        RFAC62(I)=0
      ENDDO
C ---------------------------------------------------
100   CONTINUE
C      CALL DISPL('RESMIN,RESMAX           :')
C      READ(*,*)   RESMIN,RESMAX
      IF(RESMAX.GT.RESMIN) THEN
        STOR   = RESMIN
        RESMIN = RESMAX
        RESMAX = STOR
      ENDIF
C      RESMIN=RESMIN+0.001
C      RESMAX=RESMAX-0.001
      IF((RESMIN.EQ.RESMAX).OR.
     *   (RESMIN.LE.0.0).OR.(RESMAX.LE.0.0)) THEN
        IERR=1
        RETURN
      ENDIF 
      RHMIN = 1./RESMIN
      RHMAX = 1./RESMAX
C -------------
      MSG2='N'
      IF(IANOM.EQ.1) MSG2='Y'
C --------------
      MSG='N'
      IF(ATOP.GT.0.0) MSG='Y'
      ICOUNT=0
      IPRNT =0
      SUMRFR=0.0
      DELRFR=0.0
      NRFR  =0
      NRFRT =0
      SUMFA =0.0
      DELFA =0.0
      NSMTTA=0
      NSMTA =0
      DELF  =0.0
      NPR   =0
      DSYM  =0.0
      SUMSYM=0.0
      SUMF  =0.0
      NSMTT =0
      NSMT  =0
      NREF  =0
      M     =0
      NBL   =0
      IEND  =-1
      RFAC  =0.0
      FAVER =0
C -------------------------------
      ITPF='FS  '
      MSG1='Y'
      
      CALL WRITET_F2P1(MT,MTOUT,NAME,LINE,ITPF,RLATT,RESMIN,RESMAX
     *   ,NSYM,ISYM,IPRSYM,IERR)
      
      IF(IERR.NE.0) RETURN

C------------------------------------------------------
C     MTOUT =11
      NNNREF=0
      ISUM1 =0
      ISUM3 =0
      ISUM10=0
      SUMST =0.
      SUMIT =0.
      SUMSAT=0.
      SUMIAT=0.
      NBAD  =0
      SUMNCN=0.
      SUMCN =0.
      DELNCN=0.
      DELCN =0.
      NNCN  =0
      NCN   =0
      I     =0
      IN    =0
      IHOLD =-512
      IKOLD =-512
      ILOLD =-512
      KEND  =0
      N     =-1
      ISTTS1=0
      ISTTS =0

C==========================================================================
      DO     IJKLM=1,NUMBT+1
        I=I+1
        IF(I.LE.NUMBT) THEN
          IDBL =IARRH(I)
          CALL UNPACK(IDBL,NH,NK,NL)

          CALL DSTAR(NH,NK,NL,RS)
          RH=SQRT(RS)
          IF(RH.LT.RHMIN.OR.RH.GT.RHMAX) GO TO 430
          IF(RH.GT.1.E-8) THEN
            IRGR=1.0/(RH*0.5)
            IRGR=IRGR+1
            IF(IRGR.GT.22) IRGR=22
          ELSE
            IRGR=22
          ENDIF
          ISTATUS=IARRS(I)/(256*256)
          ITEMP  =IARRS(I)-ISTATUS*(256*256)
          JJSYM  =ITEMP/256
          NFL    =ITEMP-JJSYM*256
          JJSYM  =JJSYM-128
          FFF    =ARRF(I)
          SSS    =ARRS(I)
        ELSE
          NH = -513
          NK = -513
          NL = -513
          KEND=1
        ENDIF
        IF(IHOLD.EQ.NH.AND.IKOLD.EQ.NK.AND.ILOLD.EQ.NL) THEN
          N=N+1
          IF(N.GT.NEQ) THEN
            WRITE(STR,'('' !! NUMB EQUIV OR REPET-REFLS GT:'',I5)')NEQ
            CALL MSGERR(MT,STR)
            IERR=1
            RETURN
          ENDIF
          FSQ (N) = FFF
          IFL (N) = NFL
          SD  (N) = SSS
          MRKR(N) = JJSYM
          ISTTS1  = ISTATUS
          IF(IANOM.NE.1) MRKR(N)=IABS(MRKR(N))
C          IF(I.GE.NUMBT) GO TO 500
          GO TO 430
        ENDIF
C        IF(I.LT.NUMBT) GO TO 510
C -------------------------------------------------------------
C500     KEND=1
510     IF(IHOLD.NE.NH.OR.IKOLD.NE.NK.OR.ILOLD.NE.NL
     .                                    .OR.KEND.EQ.1) THEN
          IF(N.EQ.-1) GO TO 520
          IF(N.EQ. 0) GO TO 560
          IF(N.GT. 1) THEN
            CALL ISORT3(MRKR,N,IFL,FSQ,SD)
2032        CONTINUE
            DO     J=1,N
              NN=0
              IF(J.EQ.N) GO TO 2010
              IF(MRKR(J).EQ.0) GO TO 2010
              MMM = MRKR(J)
              I1  = J+1
              NN  = 1
              WT  = 1./(SD(J)*SD(J))
              SM  = FSQ(J)*WT
              SMW = WT
              DO     L=I1,N
                IF(MRKR(L).NE.MMM) GO TO 2011
                WT  = 1./(SD(L)*SD(L))
                SM  = SM  +FSQ(L)*WT
                SMW = SMW+WT
                NN  = NN+1
 2011           CONTINUE
              ENDDO
 2010         IF(MRKR(J).EQ.0) GO TO 2030
              IF(NN.LE.1) GO TO 2030
C------ANALISYS REPET-REFLS-----
              SSSSM  = SM/SMW
              SSSSMW = 1./SQRT(SMW)
              I1     = J+1
              IBAD   = 0
              DO     L=J,N
                IF(MRKR(L).NE.MMM) GO TO 2031
                DEL   =ABS(SSSSM-FSQ(L))
                TTTT=DEL
                ATOPP=ATOP*SD(L)
                IF(MSG.EQ.'Y'.AND.TTTT.GT.ATOPP) THEN
C                 IF(IBAD.GE.NN-1) GO TO 2031
                  IF(NBAD.LE.500) THEN
                    WRITE(STR,
     *              '('' IFL,<I>,SD:'',I5,2E12.4,A4)')
     *              IFL(L),SSSSM,SSSSMW,' BAD'
                    CALL MSGDOC(MT,STR)
                  ENDIF
                  IH=IHOLD
                  IK=IKOLD
                  IL=ILOLD
                  IF(MSG.EQ.'Y') THEN
                    NBAD=NBAD+1
                    IF(NBAD.LE.500) THEN
                      WRITE(STR,
     *                '('' RPT-H,K,L,I,SD:'',3I5,2E12.4)')
     *                IH,IK,IL,FSQ(L),SD(L)
                      CALL MSGDOC(MT,STR)
                      WRITE(STR,'('' --------'')')
                      CALL MSGDOC(MT,STR)
                      ICOUNT=ICOUNT+3
C                      IF(ICOUNT.GE.18.AND.MT.GE.0.AND.MT.LT.99) THEN
C                        CALL DISPL('FOR CONTINUE TYPE "CR"')
C                        READ(*,'(A)') MSG5
C                        ICOUNT=0
C                      ENDIF
                    ENDIF
                  ENDIF
                  MRKR(L)=0
                  IBAD=IBAD+1
                ENDIF
 2031           CONTINUE
              ENDDO
              IF(IBAD.NE.0) GO TO 2032
C----------------------------------
              SM     = SM/SMW
              SMW    = 1./SQRT(SMW)
              NRFR   = NRFR+1
              NRFRT  = NRFRT+1
              SUMRFR = SUMRFR+FSQ(J)
              DEL    = ABS(SM-FSQ(J))
              DELRFR = DELRFR+DEL
              NMGRRP(IRGR) = NMGRRP(IRGR)+1
              RFAC61(IRGR) = RFAC61(IRGR)+DEL
              RFAC62(IRGR) = RFAC62(IRGR)+FSQ(J)
              FSQ(J) = SM
              SD(J)  = SMW
              I1     = J+1
              DO     L=I1,N
                IF(MRKR(L).NE.MMM) GO TO 2033
                SUMRFR = SUMRFR+FSQ(L)
                DEL    = ABS(SM-FSQ(L))
                DELRFR = DELRFR+DEL
                NMGRRP(IRGR) = NMGRRP(IRGR)+1
                RFAC61(IRGR) = RFAC61(IRGR)+DEL
                RFAC62(IRGR) = RFAC62(IRGR)+FSQ(L)
                NRFRT   = NRFRT+1
                MRKR(L) = 0
 2033           CONTINUE
              ENDDO
 2030         CONTINUE
            ENDDO
          ENDIF
C
C --- CALC <F>-SYMM <FANOM>-SYM ---
C
471       CONTINUE
          ISTTS =ISTTS1
          FSYM  =0.
          SWT   =0.
          NSM   =0
          FSYMA =0.
          SWTA  =0.
          NSMA  =0
          TDEL  =0.
          TSUM  =0.
          SSUMF =0.
          SSUMFA=0.
          SDELF =0.
          SDELFA=0.
          FAVER =0.
          FAVERA=0.
          FMAX  =0.
          DO     L=1,N
            IF(MRKR(L).EQ.0) GO TO 540
            TEMP = ABS(FSQ(L))
            WT   = 1./(SD(L)*SD(L))
            IF(MRKR(L).LE.0) THEN
              FSYMA  = FSYMA+TEMP*WT
              FAVERA = FAVERA+TEMP
              SWTA   = SWTA+WT
              NSMA   = NSMA+1
            ELSE
              FSYM = FSYM+TEMP*WT
              IF(TEMP.GT.FMAX) THEN
                FMAX  = TEMP
                SDMAX = WT
              ENDIF
              FAVER = FAVER+TEMP
              SWT   = SWT+WT
              NSM   = NSM+1
            ENDIF
540         CONTINUE
          ENDDO
          IF(NSM .NE.0) THEN
            FSYM  = FSYM/SWT
            FAVER = FAVER/NSM
            SWT   = 1./SQRT(SWT)
          ENDIF
          IF(NSMA.NE.0) THEN
            FSYMA  = FSYMA/SWTA
            FAVERA = FAVERA/NSMA
            SWTA   = 1./SQRT(SWTA)
          ENDIF
C ---
          IBAD   = 0
          IBADA  = 0
          ITOT   = 0
          ITOTA  = 0
          ATMIN  =-1.E30
          ATMINA =-1.E30
          IF(N.LE.1) GO TO 490
C ---     ANALISYS !F-<F>!/<F>
          DO     L=1,N
            IF(MRKR(L).EQ.0) GO TO 470
            STOR  = ABS(FSQ(L))
            SDTOR = ABS(SD(L))
            IF(MRKR(L).LE.0) THEN
              IF(NSMA.LE.1) GO TO 470
              ITOTA  = ITOTA+1
              SSUMFA = SSUMFA+STOR
              DELTA  = ABS(FSYMA-STOR)
              DDELTA = ABS(FAVERA-STOR)
              SDELFA = SDELFA+DELTA
              IF(MSG.EQ.'Y') THEN
                TATOP = DDELTA
                ATOPP = ATOP*SDTOR
                IF(ATMINA.LT.TATOP) ATMINA=TATOP
                IF(TATOP.GT.ATOPP) THEN
                  IBADA=IBADA+1
                ENDIF
              ENDIF
            ELSE
              IF(NSM.LE.1) GO TO 470
              ITOT  = ITOT+1
              SSUMF = SSUMF+STOR
              TSUM  = TSUM+STOR
              DELTA = ABS(FSYM-STOR)
              DDELT = ABS(FAVER-STOR)
              TDEL  = TDEL+DELTA
              SDELF = SDELF+DELTA
              IF(MSG.EQ.'Y') THEN
                TATOP=DDELT
                ATOPP=ATOP*SDTOR
                IF(ATMIN.LT.TATOP) ATMIN=TATOP
                IF(TATOP.GT.ATOPP) THEN
                  IBAD=IBAD+1
                ENDIF
              ENDIF
            ENDIF
  470       CONTINUE
          ENDDO
C ------ PRINT OF BAD REFLEXION -----
          IF(IBAD.NE.0.OR.IBADA.NE.0) THEN
C          IBADD=0
C          IBADDA=0
          DO     L=1,N
            IF(MRKR(L).EQ.0) GO TO 472
            STOR  = ABS(FSQ(L))
            SDTOR = ABS(SD(L))
            IF(MRKR(L).LE.0) THEN
              IF(NSMA.LE.1) GO TO 472
              DELTA  = ABS(FSYMA-STOR)
              DDELTA = ABS(FAVERA-STOR)
              IF(MSG.EQ.'Y') THEN
C                IF(IBADDA.GE.NSMA-1) GO TO 472
                TATOP=DDELTA
                ATOPP=ATOP*SDTOR
                ATOPP=ATMINA
                IF(IBADA.NE.0.AND.ITOTA.EQ.2) ATOPP=0.
                IF(TATOP.GE.ATOPP) THEN
                  IF(NBAD.LE.500) THEN
                    WRITE(STR,'('' ISYM,I,SD:'',I5,2E12.4,A4)')
     *                       MRKR(L),STOR,SD(L),' BAD'
                    CALL MSGDOC(MT,STR)
                    ICOUNT=ICOUNT+1
C                    IF(ICOUNT.GE.20.AND.MT.GE.0.AND.MT.LT.99) THEN
C                      CALL DISPL('FOR CONTINUE TYPE "CR"')
C                      READ(*,'(A)') MSG5
C                      ICOUNT=0
C                    ENDIF
                  ENDIF
C                  IBADDA=IBADDA+1
                  NBAD=NBAD+1
                  MRKR(L)=0
                ELSE
                  IF(NBAD.LE.500) THEN
                    WRITE(STR,'('' ISYM,I,SD:'',I5,2E12.4)')
     *                           MRKR(L),STOR,SD(L)
                    CALL MSGDOC(MT,STR)
                    ICOUNT=ICOUNT+1
C                    IF(ICOUNT.GE.20.AND.MT.GE.0.AND.MT.LT.99) THEN
C                      CALL DISPL('FOR CONTINUE TYPE "CR"')
C                      READ(*,'(A)') MSG5
C                      ICOUNT=0
C                    ENDIF
                  ENDIF
                ENDIF
              ENDIF
            ELSE
              IF(NSM.LE.1) GO TO 472
              IF(MSG.EQ.'Y') THEN
C                IF(IBADD.GE.NSM-1) GO TO 472
                DELTA=ABS(FSYM-STOR)
                DDELT=ABS(FAVER-STOR)
                TATOP=DDELT
                ATOPP=ATOP*SDTOR
                ATOPP=ATMIN
                IF(TATOP.GE.ATOPP) THEN
                  IF(NBAD.LE.500) THEN
                    WRITE(STR,'('' ISYM,I,SD:'',I5,2E12.4,A4)')
     *                    MRKR(L),STOR,SD(L),' BAD'
                    CALL MSGDOC(MT,STR)
                    ICOUNT=ICOUNT+1
                    IF(ICOUNT.GE.20.AND.MT.GE.0.AND.MT.LT.99) THEN
                      CALL DISPL_BL('FOR CONTINUE TYPE "CR"')
                      READ(*,'(A)') MSG5
                      ICOUNT=0
                    ENDIF
                  ENDIF
C                  IBADD=IBADD+1
                  NBAD=NBAD+1
                  MRKR(L)=0
                ELSE
                  IF(NBAD.LE.500) THEN
                    WRITE(STR,'('' ISYM,I,SD:'',I5,2E12.4)')
     *                     MRKR(L),STOR,SD(L)
                    CALL MSGDOC(MT,STR)
                    ICOUNT=ICOUNT+1
C                    IF(ICOUNT.GE.20.AND.MT.GE.0.AND.MT.LT.99) THEN
C                      CALL DISPL('FOR CONTINUE TYPE "CR"')
C                      READ(*,'(A)') MSG5
C                      ICOUNT=0
C                    ENDIF
                  ENDIF
                ENDIF
              ENDIF
            ENDIF
  472       CONTINUE
          ENDDO
          IH=IHOLD
          IK=IKOLD
          IL=ILOLD
          IF(MSG.EQ.'Y') THEN
            IF(NBAD.LE.500) THEN
              IF(NSM.NE.0) THEN
                WRITE(STR,'(''  H, K, L,I,SD:'',3I5,2E12.4)')
     *                 IH,IK,IL,FAVER,SWT
                CALL MSGDOC(MT,STR)
                ICOUNT=ICOUNT+1
              ENDIF
              IF(NSMA.NE.0) THEN
                WRITE(STR,'('' -H,-K,-L,I,SD:'',3I5,2E12.4)')
     *               IH,IK,IL,FAVERA,SWTA
                CALL MSGDOC(MT,STR)
                ICOUNT=ICOUNT+1
              ENDIF
              WRITE(STR,'('' --------'')')
              CALL MSGDOC(MT,STR)
              ICOUNT=ICOUNT+1
C              IF(ICOUNT.GE.18.AND.MT.GE.0.AND.MT.LT.99) THEN
C                CALL DISPL('FOR CONTINUE TYPE "CR"')
C                READ(*,'(A)') MSG5
C                ICOUNT=0
C              ENDIF
            ENDIF
          ENDIF
          GO TO 471
          ENDIF
C ----------------------------------------------------------------
          IF(NSM.EQ.0.AND.NSMA.EQ.0) GO TO 521
          JPR=0
          IF(NSM.NE.0.AND.NSMA.NE.0) THEN
            SUMSYM=SUMSYM+FSYM+FSYMA
            SUMSMT=       FSYM+FSYMA
            DSYM=DSYM+ABS(FSYM-FSYMA)
            DSYMT=    ABS(FSYM-FSYMA)
            NPR=NPR+1
            JPR=1
          ENDIF
          DELF=DELF+SDELF
          DELFA=DELFA+SDELFA
          SUMF=SUMF+SSUMF
          SUMFA=SUMFA+SSUMFA
  490     CONTINUE
          IF(NSMA.GT.0) NSMTA=NSMTA+1
          IF(NSMA.GT.0) NSMTTA=NSMTTA+NSMA
          IF(NSM .GT.0) NSMT =NSMT +1
          IF(NSM .GT.0) NSMTT=NSMTT+NSM
          SUMST=SUMST+SWT
          SUMIT=SUMIT+FSYM
          FMOD=SQRT(FSYM)
          SSWT=SWT
          IF(FMOD.NE.0.) THEN
            SWT =(.5*SWT)/FMOD
            TEST=FMOD/SWT
            IF(TEST.GT. 1.) ISUM1=ISUM1  +1
            IF(TEST.GT. 3.) ISUM3=ISUM3  +1
            IF(TEST.GT.10.) ISUM10=ISUM10+1
            NNNREF=NNNREF+1
          ENDIF
          SUMSAT=SUMSAT+SWTA
          SUMIAT=SUMIAT+FSYMA
          FMODA=SQRT(FSYMA)
          SSWTA=SWTA
          IF(FMODA.NE.0.) THEN
            SWTA =(.5*SWTA)/FMODA
            TEST=FMODA/SWTA
            IF(TEST.GT. 1.) ISUM1= ISUM1 +1
            IF(TEST.GT. 3.) ISUM3= ISUM3 +1
            IF(TEST.GT.10.) ISUM10=ISUM10+1
            NNNREF=NNNREF+1
          ENDIF
          IH=IHOLD
          IK=IKOLD
          IL=ILOLD
          NREF=NREF+1
          IF(ITYP.NE.0.AND.NSM.GT.1) THEN
            ICENT=0
            IF((ITYP.EQ.1.OR.ITYP.EQ.5).AND.IH.EQ.0) ICENT=1
            IF((ITYP.EQ.2.OR.ITYP.EQ.5).AND.IK.EQ.0) ICENT=1
            IF((ITYP.EQ.3.OR.ITYP.EQ.5).AND.IL.EQ.0) ICENT=1
            IF(ITYP.EQ.4.AND.IH.EQ.IK) ICENT=1
            IF(ICENT.EQ.0) THEN
              SUMNCN=SUMNCN+TSUM
              DELNCN=DELNCN+TDEL
              NNCN=NNCN+1
            ELSE
              SUMCN=SUMCN+TSUM
              DELCN=DELCN+TDEL
              NCN=NCN+1
            ENDIF
          ENDIF
          NMGR(IRGR)=NMGR(IRGR)+1
          IF(JPR .EQ.1) NMGRPR(IRGR)=NMGRPR(IRGR)+1
          IF(NSM .GT.0) NMGRSM(IRGR)=NMGRSM(IRGR)+1
          IF(NSMA.GT.0) NMGRSA(IRGR)=NMGRSA(IRGR)+1
          RFAC11(IRGR)=RFAC11(IRGR)+SDELF
          RFAC12(IRGR)=RFAC12(IRGR)+SSUMF
          RFAC21(IRGR)=RFAC21(IRGR)+SDELFA
          RFAC22(IRGR)=RFAC22(IRGR)+SSUMFA
          RFAC31(IRGR)=RFAC31(IRGR)+SSWT
          RFAC32(IRGR)=RFAC32(IRGR)+FSYM
          RFAC41(IRGR)=RFAC41(IRGR)+SSWTA
          RFAC42(IRGR)=RFAC42(IRGR)+FSYMA
          IF(JPR.EQ.1) THEN
            RFAC51(IRGR)=RFAC51(IRGR)+DSYMT
            RFAC52(IRGR)=RFAC52(IRGR)+SUMSMT
          ENDIF
          IF(IPRNT.GT.0) THEN
          IF(MOD(NREF,IPRNT).EQ.0) THEN
            IF(NSM.NE.0) THEN
              WRITE(STR,'(''  N,H,K,L,F,SD:'',I6,2X,3I5,2E12.4)')
     .             NREF,IH,IK,IL,FMOD ,SWT
              CALL MSGDOC(MT,STR)
            ENDIF
            IF(NSMA.NE.0) THEN
              IHM=-IH
              IKM=-IK
              ILM=-IL
              WRITE(STR,'(''  N,H,K,L,F,SD:'',I6,2X,3I5,2E12.4)')
     .             NREF,IHM,IKM,ILM,FMODA,SWTA
              CALL MSGDOC(MT,STR)
            ENDIF
          ENDIF
          ENDIF
          IF(MTOUT.GT.0) THEN
            KEY=ISTTS
            NBL=NBL+1
            IF(MSG1.NE.'N') THEN
              CALL WWRT(MTOUT,IH,IK,IL,FMOD,FMODA,SWT,SWTA,KEY,IEND)
            ELSE
              CALL WRT(MTOUT,IH,IK,IL,FMOD ,FMODA,KEY,IEND)
            ENDIF
            IF(MTOUT.LE.0) THEN
              IERR=1
              RETURN
            ENDIF
          ENDIF
521       CONTINUE
          IF(KEND.EQ.1) GO TO 560
520       N=1
          FSQ (N)=FFF
          SD  (N)=SSS
          IFL (N)=NFL
          MRKR(N)=JJSYM
          ISTTS1 =ISTATUS
          IF(IANOM.NE.1) MRKR(N)=IABS(MRKR(N))
          IHOLD=NH
          IKOLD=NK
          ILOLD=NL
        ENDIF
  430   CONTINUE
      ENDDO
C--------------------------------------------
560   IEND=2
      IF(MTOUT.GT.0) THEN
        CALL WRT(MTOUT,IH,IK,IL,FMOD,FMODA,NBL,IEND)
      ENDIF
      IF(NRFR.GT.0.AND.SUMRFR.GT.0.0) THEN
        DELRFR=DELRFR/SUMRFR
      ENDIF
      IF(NSMT.GT.0.AND.SUMF.GT.0.0) THEN
        DELF=DELF/SUMF
      ENDIF
      IF(NSMT.GT.0.AND.SUMIT.GT.0.0) THEN
        SUMST=SUMST/SUMIT
      ENDIF
      IF(NSMTA.GT.0.AND.SUMFA.GT.0.0) THEN
        DELFA=DELFA/SUMFA
      ENDIF
      IF(NSMTA.GT.0.AND.SUMIAT.GT.0.0) THEN
        SUMSAT=SUMSAT/SUMIAT
      ENDIF

      WRITE(STR,400) NREF
      CALL MSGDOC(MT,STR)
      IF(MSG.EQ.'Y') THEN
        WRITE(STR,'('' N-BAD-REFLS                :'',I6)') NBAD
        CALL MSGDOC(MT,STR)
      ENDIF
      WRITE(STR,'('' F >SIG,>3SIG,>10SIG:'',3I8)') ISUM1,ISUM3,ISUM10
      CALL MSGDOC(MT,STR)
      IF(NNNREF.GT.0) THEN
        TEMP1=FLOAT(ISUM1 )/NNNREF
        TEMP2=FLOAT(ISUM3 )/NNNREF
        TEMP3=FLOAT(ISUM10)/NNNREF
      ELSE
        TEMP1=0.0
        TEMP2=0.0
        TEMP3=0.0
      ENDIF
      WRITE(STR,'(''                     '',3F8.3)') TEMP1,TEMP2,TEMP3
      CALL MSGDOC(MT,STR)
      IF(NRFR.GT.0) THEN
        WRITE(STR,409) NRFR,NRFRT
        CALL MSGDOC(MT,STR)
        WRITE(STR,1409) DELRFR
        CALL MSGDOC(MT,STR)
      ENDIF
      WRITE(STR,406)  NSMT,NSMTT
      CALL MSGDOC(MT,STR)
      WRITE(STR,1406) DELF
      CALL MSGDOC(MT,STR)
      WRITE(STR,416) SUMST
      CALL MSGDOC(MT,STR)

      IF(ITYP.NE.0) THEN
        IF(NNCN.GT.0) DELNCN=DELNCN/SUMNCN
        IF(NCN .GT.0) DELCN =DELCN/SUMCN
        WRITE(STR,411) NCN
        CALL MSGDOC(MT,STR)
        WRITE(STR,1411) DELCN
        CALL MSGDOC(MT,STR)
        WRITE(STR,410) NNCN
        CALL MSGDOC(MT,STR)
        WRITE(STR,1410) DELNCN
        CALL MSGDOC(MT,STR)
      ENDIF
      IF(IANOM.NE.0) THEN
        RFAC=0.
        WRITE(STR,407) NSMTA,NSMTTA
        CALL MSGDOC(MT,STR)
        WRITE(STR,1407) DELFA
        CALL MSGDOC(MT,STR)
        WRITE(STR,417) SUMSAT
        CALL MSGDOC(MT,STR)
        IF(NPR.NE.0) RFAC=2.0*DSYM/SUMSYM
        WRITE(STR,408) NPR
        CALL MSGDOC(MT,STR)
        WRITE(STR,1408) RFAC
        CALL MSGDOC(MT,STR)
      ENDIF

           
      IF(MT.GE.0.AND.MT.LT.99) MM=0
      MM = 99
      CALL MSGDOC(MM,' ')
      WRITE(STR,730)
  730 FORMAT(' ANGSTR:2.5   3.0   3.5   4.',
     *   '0   4.5   5.0   5.5   6.0   6.5   7.0   7.5   8.0')
      CALL MSGDOC(MM,STR)
      WRITE(STR,740) (NMGR(K),K=6,16)
  740 FORMAT(' N      ',11I6)
      CALL MSGDOC(MM,STR)
      DO     I=1,22
        IF(RFAC12(I).NE.0.) RFAC11(I)=RFAC11(I)/RFAC12(I)
        IF(RFAC22(I).NE.0.) RFAC21(I)=RFAC21(I)/RFAC22(I)
        IF(RFAC32(I).NE.0.) RFAC31(I)=RFAC31(I)/RFAC32(I)
        IF(RFAC42(I).NE.0.) RFAC41(I)=RFAC41(I)/RFAC42(I)
        IF(RFAC52(I).NE.0.) RFAC51(I)=RFAC51(I)/RFAC52(I)
        IF(RFAC62(I).NE.0.) RFAC61(I)=RFAC61(I)/RFAC62(I)
      ENDDO
      IF(NSMT .GT.0) THEN
        CALL MSGDOC(MM,' ')
        WRITE(STR,741) (RFAC11(K),K=6,16)
        CALL MSGDOC(MM,STR)
        WRITE(STR,743) (RFAC31(K),K=6,16)
        CALL MSGDOC(MM,STR)
        WRITE(STR,740) (NMGRSM(K),K=6,16)
        CALL MSGDOC(MM,STR)
      ENDIF
      IF(NSMTA.GT.0) THEN
        CALL MSGDOC(MM,' ')
        WRITE(STR,742) (RFAC21(K),K=6,16)
        CALL MSGDOC(MM,STR)
        WRITE(STR,744) (RFAC41(K),K=6,16)
        CALL MSGDOC(MM,STR)
        WRITE(STR,740) (NMGRSA(K),K=6,16)
        CALL MSGDOC(MM,STR)
      ENDIF
      IF(NPR.GT.0) THEN
        CALL MSGDOC(MM,' ')
        WRITE(STR,747) (RFAC51(K),K=6,16)
        CALL MSGDOC(MM,STR)
        WRITE(STR,740) (NMGRPR(K),K=6,16)
        CALL MSGDOC(MM,STR)
      ENDIF
      IF(NRFR.GT.0) THEN
        CALL MSGDOC(MM,' ')
        WRITE(STR,748) (RFAC61(K),K=6,16)
        CALL MSGDOC(MM,STR)
        WRITE(STR,740) (NMGRRP(K),K=6,16)
        CALL MSGDOC(MM,STR)
      ENDIF
  741 FORMAT(' R-SYM  ',11F6.3)
  742 FORMAT(' R-SYM A',11F6.3)
  743 FORMAT(' R-STAN ',11F6.3)
  744 FORMAT(' R-STANA',11F6.3)
  747 FORMAT(' R-PAIRS',11F6.3)
  748 FORMAT(' R-REPET',11F6.3)
C ------------
      MM=99
      IF(MT.NE.0.AND.MT.LT.99) MM=-1

      WRITE(STR,745)
  745 FORMAT(' ANGSTR:0.0   0.5   1.0   1.',
     *   '5   2.0   2.5   3.0   3.5   4.0   4.5   5.0   5.5')
      CALL MSGDOC(MM,STR)
      WRITE(STR,740) (NMGR(K),K=1,11)
      CALL MSGDOC(MM,STR)
      IF(NSMT.GT.0) THEN
        CALL MSGDOC(MM,' ')
        WRITE(STR,741) (RFAC11(K),K=1,11)
        CALL MSGDOC(MM,STR)
        WRITE(STR,743) (RFAC31(K),K=1,11)
        CALL MSGDOC(MM,STR)
        WRITE(STR,740)  (NMGRSM(K),K=1,11)
        CALL MSGDOC(MM,STR)
      ENDIF
      IF(NSMTA.GT.0) THEN
        CALL MSGDOC(MM,' ')
        WRITE(STR,742) (RFAC21(K),K=1,11)
        CALL MSGDOC(MM,STR)
        WRITE(STR,744) (RFAC41(K),K=1,11)
        CALL MSGDOC(MM,STR)
        WRITE(STR,740)  (NMGRSA(K),K=1,11)
        CALL MSGDOC(MM,STR)
      ENDIF
      IF(NPR.GT.0) THEN
        CALL MSGDOC(MM,' ')
        WRITE(STR,747)  (RFAC51(K),K=1,11)
        CALL MSGDOC(MM,STR)
        WRITE(STR,740)  (NMGRPR(K),K=1,11)
        CALL MSGDOC(MM,STR)
        CALL MSGDOC(MM,' ')
      ENDIF
      IF(NRFR.GT.0) THEN
        CALL MSGDOC(MM,' ')
        WRITE(STR,748) (RFAC61(K),K=1,11)
        CALL MSGDOC(MM,STR)
        WRITE(STR,740) (NMGRRP(K),K=1,11)
        CALL MSGDOC(MM,STR)
      ENDIF
      CALL MSGDOC(MM,' ')
      WRITE(STR,746)
  746 FORMAT(' ANGSTR:5.5   6.0   6.5   7.',
     *   '0   7.5   8.0   8.5   9.0   9.5  10.0  10.5  11.0')
      CALL MSGDOC(MM,STR)
      WRITE(STR,740) (NMGR(K),K=12,22)
      CALL MSGDOC(MM,STR)
      IF(NSMT .GT.0) THEN
        CALL MSGDOC(MM,' ')
        WRITE(STR,741) (RFAC11(K),K=12,22)
        CALL MSGDOC(MM,STR)
        WRITE(STR,743) (RFAC31(K),K=12,22)
        CALL MSGDOC(MM,STR)
        WRITE(STR,740)  (NMGRSM(K),K=12,22)
        CALL MSGDOC(MM,STR)
      ENDIF
      IF(NSMTA.GT.0) THEN
        CALL MSGDOC(MM,' ')
        WRITE(STR,742) (RFAC21(K),K=12,22)
        CALL MSGDOC(MM,STR)
        WRITE(STR,744) (RFAC41(K),K=12,22)
        CALL MSGDOC(MM,STR)
        WRITE(STR,740)  (NMGRSA(K),K=12,22)
        CALL MSGDOC(MM,STR)
      ENDIF
      IF(NPR.GT.0) THEN
        CALL MSGDOC(MM,' ')
        WRITE(STR,747)  (RFAC51(K),K=12,22)
        CALL MSGDOC(MM,STR)
        WRITE(STR,740)  (NMGRPR(K),K=12,22)
        CALL MSGDOC(MM,STR)
        CALL MSGDOC(MM,' ')
      ENDIF
      IF(NRFR.GT.0) THEN
        CALL MSGDOC(MM,' ')
        WRITE(STR,748) (RFAC61(K),K=12,22)
        CALL MSGDOC(MM,STR)
        WRITE(STR,740) (NMGRRP(K),K=12,22)
        CALL MSGDOC(MM,STR)
      ENDIF

C ------------------
      RETURN
C--------
  400 FORMAT(1X,'NUMB REFLS                   =',I6)
  406 FORMAT(1X,'NUMB SYMM REFLS(HKL)         =',I6,' (',I6,')')
 1406 FORMAT(1X,'R-FAC INT(HKL)-SYMM          =',E12.4,
     .          ' S(!I-IAVER!)/S(I)')
  416 FORMAT(1X,'R-FAC-STAND S(SD)/S(I)       =',E12.4)
  417 FORMAT(1X,'R-FAC-STAND S(SD)/S(I)       =',E12.4)
  407 FORMAT(1X,'NUMB SYMM-ANOM-REFLS(-H-K-L) =',I6,' (',I6,')')
 1407 FORMAT(1X,'R-FAC INT(-H-K-L)-SYMM-ANOM  =',E12.4)
  409 FORMAT(1X,'NUMB OF REPEATING REFLS      =',I6,' (',I6,')')
 1409 FORMAT(1X,'R-FAC INT-REPEAT             =',E12.4,
     .       ' S(!I-IAVER!)/S(I)')
  408 FORMAT(1X,'NUMB PAIRS (I(HKL),I(-H-K-L))=',I6)
 1408 FORMAT(1X,'R-FAC                         =',E12.4,
     .      ' 2*S(!I1-I2!)/S(I1+I2)')
  410 FORMAT(1X,'NUMB OF NON-CENTR REFLS      =',I6)
 1410 FORMAT(1X,'R-FAC INT-NON-CENTRS.        =',E12.4,
     .       ' S(!I-IAVER!)/S(I)')
  411 FORMAT(1X,'NUMB OF CENTRSYM. REFLS      =',I6)
 1411 FORMAT(1X,'R-FAC INT-CENTRSYM.          =',E12.4,
     .       ' S(!I-IAVER!)/S(I)')
C ----------------------------------------------
      END

      SUBROUTINE WRITET_F2P1(MT,MTOUT,NAME,LINE,ITPF,RLATT
     *    ,RESMIN,RESMAX
     *    ,NSYM,ISYM,IPRSYM,IERR)
      REAL      RLATT(6),RESMIN,RESMAX
      INTEGER*4 IERR,MT
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER ITPF*4
      CHARACTER NAME*(*),LINE*256
C -----------------------------------------
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
C ---------------------------------------------
C      RESMIN=RESMIN+0.01
C      RESMAX=RESMAX-0.01

      IF(NSYM.EQ.1) THEN
        SP_GROUP  = 'P 1'
        NSP_GROUP = 1
        N_SETT    = 1
      ENDIF

      COEF  = 1.0
      B     = 0.0
      MTOUT = 11
      CALL C_CR_WR
      CALL SET_TITLE(MT,RLATT(1),RLATT(2),
     *  RLATT(3),RLATT(4),RLATT(5),RLATT(6),COEF,B,RESMIN,RESMAX,
     *  IDM,IDM,IDM,IDM,IDM,LINE,IERR)
      CALL OWFILE(MT,MTOUT,NAME,ITPF,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) THEN
        RETURN
      ENDIF

      RETURN
      END

      SUBROUTINE WRITE_NMR_PDB(MDOC,IMODEL
     *      ,FILE_PDB,NMODEL,PATH_SCR,IERR)
C --------------------------------------------------------
      CHARACTER FILE_PDB*(*),PATH_SCR*(*)
      CHARACTER FILES*256,FILET*256
C -----------------------------------------------------------
      PARAMETER (NCHAIN_MAX = 400 )
      CHARACTER SEG_ID(NCHAIN_MAX)*2,NEW_SEG_ID(NCHAIN_MAX)*2  
      CHARACTER CHAIN(NCHAIN_MAX)*2 
      INTEGER   MOL_ID(NCHAIN_MAX),MOD_ID(NCHAIN_MAX)
      CHARACTER LINE*256,REC*256,SEG*4,CH1*1,CH_OLD*1,SEG_OLD*4
      CHARACTER EXT*3,PATH*1,TYPE*1
      CHARACTER LETT*61
C --------------------------------------------------
      NLETT = 61
C              123456789 123456789 123456789 12345
      LETT  = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ123456789'//
     *        'abcdefghijklmnopqrstuvwxyz'
C              6789 123456789 123456789 1
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      IN   = 10
      EXT  = ' '
      PATH = ' '
      CALL LENSTR_BL(FILE_PDB,LEN)
      FILET = FILE_PDB(1:LEN)//'.pdb'  
      CALL OPENFR(IN,M,PATH,FILET,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: open intput file') 
        RETURN
      ENDIF
C ---
      FILES  = 'molrep_nmr_tmp.pdb'
      CALL LENSTR_BL(FILES,LEN)
      CALL LENSTR_BL(PATH_SCR,LT)
      IF(LT.GT.0) THEN
        FILES  = PATH_SCR(1:LT)//FILES(1:LEN)
      ENDIF      
      IOUT   = 11
      EXT    = ' '
      PATH   = ' '
      CALL OPENFW(IOUT,M,PATH,FILES,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: open output file') 
        CLOSE(IN)
        RETURN
      ENDIF
C ------------
      NMOLECULE = 0
      NMODEL  = 0
      IMDL    = 0
      NCHAIN  = 0
      CH_OLD  = '?'
      SEG_OLD = '?'
      NBAD    = 0
      IFIRST  = 0

100   CONTINUE

      READ(IN,'(A)',ERR=900,END=110) LINE

      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.6) GO TO 100

      IF(LINE(1:4).EQ.'CRYS') THEN

      ELSE IF(LINE(1:6).EQ.'HEADER') THEN

      ELSE IF(LINE(1:9).EQ.'#MOLECULE') THEN
        NMOLECULE = NMOLECULE + 1
      ELSE IF(LINE(1:7).EQ.'#DOMAIN') THEN

      ELSE IF(LINE(1:5).EQ.'MODEL') THEN
        CH_OLD  = '?'
        READ(LINE,'(10X,I4)') IMDL
        NMODEL = NMODEL + 1
      ELSE IF(LINE(1:6).EQ.'ATOM  '.OR. 
     *        LINE(1:6).EQ.'HETATM'    ) THEN
        IF(IFIRST.EQ.0) THEN
          IF(NMOLECULE.LE.0) NMOLECULE = NMOLECULE + 1
          IFIRST  = 1
        ENDIF
        CH1 = LINE(22:22)
        CALL CHKSMB(CH1,TYPE)
        IF(TYPE.EQ.'?') THEN
          IL   = NLETT - NBAD
          CH1  = LETT(IL:IL)
          NBAD = NBAD + 1
        ENDIF 

        SEG = '    '
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GE.74) THEN
          SEG(1:2) = LINE(73:74)
        ENDIF
        IF(LEN.GE.75) THEN
          SEG(1:3) = LINE(73:75)
        ENDIF
        IF(LEN.GE.76) THEN
          SEG = LINE(73:76)
        ENDIF

        CALL CHKSMB(SEG(1:1),TYPE)
        IF(TYPE.EQ.'?') SEG(1:1) = CH1
        CALL CHKSMB(SEG(2:2),TYPE)
        IF(TYPE.EQ.'?') SEG(2:2) = CH1
        CALL CHKSMB(SEG(3:3),TYPE)
        IF(TYPE.EQ.'?') SEG(3:3) = '0'
        CALL CHKSMB(SEG(4:4),TYPE)
        IF(TYPE.EQ.'?') SEG(4:4) = '0'

        IF(SEG(1:1).EQ.' ') THEN
          SEG(1:1) = CH1
        ENDIF
        IF(SEG(2:2).EQ.' ') THEN
          SEG(2:2) = SEG(1:1)
        ENDIF
        IF(SEG(3:3).EQ.' ') SEG(3:3) = '-'
        IF(SEG(4:4).EQ.' ') SEG(4:4) = '-'

        LINE(22:22) = CH1
        LINE(73:76)=  SEG

        IF((IMODEL.GT.0.AND.IMDL.EQ.IMODEL).OR.
     *      IMDL.EQ.0.OR.IMODEL.EQ.0           ) THEN
          IF(CH1.NE.CH_OLD) THEN
            NCHAIN = NCHAIN + 1
            IF(NCHAIN.GT.NCHAIN_MAX) NCHAIN = NCHAIN_MAX
            MOD_ID(NCHAIN) = IMDL
            MOL_ID(NCHAIN) = NMOLECULE
            SEG_ID(NCHAIN) = SEG(1:2) 
            CHAIN(NCHAIN)(1:1) = ' ' 
            CHAIN(NCHAIN)(2:2) = CH1 
            CH_OLD = CH1
          ENDIF          
        ENDIF

      ENDIF
           
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN)     

      GO TO 100
110   CONTINUE
      CLOSE(IN)
      END FILE IOUT
      CLOSE(IOUT)
c ---
      IF(NMODEL.LE.1) THEN
        GO TO 800
      ENDIF
C ------------
      WRITE(LINE,*) 'N_model,IM_inp:',NMODEL,IMODEL
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'N_molecue:',NMOLECULE
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'N_chain:',NCHAIN
      CALL MSGDOC(MDOC,LINE)

      DO I=1,NCHAIN
        WRITE(LINE,*) I,'<',CHAIN(I),'>','<',SEG_ID(I),'>'
     *                ,MOL_ID(I),MOD_ID(I)
        CALL MSGDOC(MDOC,LINE)
      ENDDO

      NCHAIN_IN = NCHAIN
C      IF(IMODEL.GT.0.AND.NCHAIN.GT.1) THEN
      IF(NCHAIN.GT.1) THEN
        DO I=1,NCHAIN
          NEW_SEG_ID(I) = SEG_ID(I)
        ENDDO
C        IC = 1
C        DO I=1,NCHAIN
C          NEW_SEG_ID(I) = SEG_ID(I)
C          IF(I.EQ.1) THEN
C            NEW_SEG_ID(I)(2:2) = LETT(IC:IC)
C          ELSE IF(I.GT.1) THEN
C            CH1 = SEG_ID(I)(2:2)
C            DO J=1,I-1
C              IF(CH1.EQ.SEG_ID(J)(2:2)) GO TO 300
C            ENDDO
C            IC = IC + 1
C            IF(IC.GT.NLETT) THEN
C              IT = IC/NLETT
C              IC = IC - IT*NLETT
C            ENDIF
C            NEW_SEG_ID(I)(2:2) = LETT(IC:IC)
C            GO TO 310
C  300       CONTINUE
C            NEW_SEG_ID(I)(2:2) = NEW_SEG_ID(J)(2:2)
C  310       CONTINUE
C          ENDIF
C        ENDDO


c        DO I=1,NCHAIN
c          IF(SEG_ID(I)(1:1).EQ.SEG_ID(I)(2:2)) THEN
c            NEW_SEG_ID(I)(1:1) = NEW_SEG_ID(I)(2:2)
c          ELSE 
c            IC = IC + 1
c            IF(IC.GT.NLETT) IC = NLETT
c            NEW_SEG_ID(I)(1:1) = LETT(IC:IC)
c          ENDIF
c        ENDDO

        INEW = 0
        DO I=1,NCHAIN
          IC = I 
          IF(IC.GT.NLETT) THEN
            IT = IC/NLETT
            IC = IC - IT*NLETT
            INEW = IT
            IF(INEW.GT.NLETT) INEW = NLETT
          ENDIF
          NEW_SEG_ID(I)(1:1) = LETT(IC:IC)
          CHAIN(I)(1:1) = ' ' 
          CHAIN(I)(2:2) = LETT(IC:IC)
          IF(INEW.GT.0) THEN
            CHAIN(I)(1:1) = LETT(INEW:INEW)
          ENDIF 
        ENDDO

        DO I=1,NCHAIN
          SEG_ID(I) = NEW_SEG_ID(I)
        ENDDO

      ENDIF

      DO I=1,NCHAIN
        WRITE(LINE,*) '==',I,'<',CHAIN(I),'>','<',SEG_ID(I),'>'
     *                ,MOL_ID(I),MOD_ID(I)
       CALL MSGDOC(MDOC,LINE)
      ENDDO
C ------------
      IOUT   = 11
      EXT    = ' '
      PATH   = ' '
      CALL OPENFW(IOUT,M,PATH,FILET,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: open output file') 
        GO TO 800
      ENDIF
C ------------
      ISTART = 1
      IFNISH = NMODEL
      IF(IMODEL.GT.0) THEN
        ISTART = IMODEL
        IFNISH = IMODEL
      ENDIF
      IC = 0
      DO IMOD=ISTART,IFNISH
        IN   = 10
        EXT  = ' '
        PATH = ' '
        CALL OPENFR(IN,M,PATH,FILES,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: open intput file.') 
          CLOSE(IOUT)
          GO TO 800
        ENDIF
        NMOL    = 0
        IMDL    = 0
        IFIRST  = 0 
        IFIRST_M= 0 
        REC     = '      '
        IWRT    = 1
        ICHAIN  = 0
        CH_OLD  = '?'
        SEG_OLD = '?'
C --
200     CONTINUE

        READ(IN,'(A)',ERR=900,END=210) LINE

        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.LT.6) GO TO 200

        IF(LINE(1:4).EQ.'CRYS') THEN
          IF(IMOD.GT.1) GO TO 220
        ELSE IF(LINE(1:6).EQ.'HEADER') THEN
          IF(IMOD.GT.1) GO TO 220
        ELSE IF(LINE(1:9).EQ.'#MOLECULE') THEN
          IMOL = IMOL + 1
          GO TO 220
        ELSE IF(LINE(1:7).EQ.'#DOMAIN') THEN

        ELSE IF(LINE(1:6).EQ.'COMPND') THEN
          GO TO 220
        ELSE IF(LINE(1:5).EQ.'SCALE') THEN
          GO TO 220
        ELSE IF(LINE(1:5).EQ.'ORIGX') THEN
          GO TO 220
        ELSE IF(LINE(1:5).EQ.'MODEL') THEN
          CH_OLD  = '?'
          IWRT = 0
          READ(LINE,'(10X,I4)') IMDL
          IF(IMOD.EQ.IMDL) THEN
            IWRT = 1
            IF(REC(1:9).EQ.'#MOLECULE') THEN
              CALL LENSTR_BL(REC,LEN)
              WRITE(IOUT,'(A)',ERR=910) REC(1:LEN)     
            ENDIF
            IF(IMODEL.GT.0.OR.IFIRST.NE.0) THEN
              GO TO 220
            ENDIF
            IFIRST = 1 
          ELSE
            GO TO 220
          ENDIF
        ELSE IF(LINE(1:6).EQ.'ATOM  '.OR. 
     *        LINE(1:6).EQ.'HETATM'    ) THEN
          IF(IFIRST_M.EQ.0) THEN
            IF(IMOL.LE.0) IMOL = IMOL + 1
            IFIRST_M  = 1
          ENDIF

          IF((IMODEL.GT.0.AND.IMDL.EQ.IMODEL).OR.
     *        IMDL.EQ.0.OR.IMODEL.EQ.0           ) THEN

            CH1 = LINE(22:22)

            IF(CH1.NE.CH_OLD) THEN
              ICHAIN = ICHAIN + 1
              IF(ICHAIN.GT.NCHAIN_IN) THEN
                ICHAIN = NCHAIN_IN
                CALL MSGERR(MDOC,
     *    'WARNING: WRITE_NMR_PDB problem with chain_ID') 
              ENDIF
              CH_OLD = CH1
            ENDIF

            LINE(73:74) = SEG_ID(ICHAIN)  
C           LINE(22:22) = SEG_ID(ICHAIN)(1:1)
            LINE(21:21) = CHAIN(ICHAIN)(1:1)
            LINE(22:22) = CHAIN(ICHAIN)(2:2)
          ENDIF

          IF(IMOD.GT.1.AND.IMDL.EQ.0) GO TO 220
          
        ENDIF
        
        IF(IWRT.GT.0) THEN   
          CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN)     
        ENDIF

220     CONTINUE
        REC = LINE
        GO TO 200
210     CONTINUE
C --
        CLOSE(IN)
      ENDDO
C ------------
      END FILE IOUT
      CLOSE(IOUT)
C ---
800   CONTINUE

      FILES  = 'molrep_nmr_tmp.pdb'
c      CALL DELETE_FILE(PATH_SCR,FILES)

      RETURN
C ------------
900   CONTINUE
      CALL MSGERR(MDOC,'ERROR: read input file') 
      CLOSE(IN)
      CLOSE(IOUT)
      IERR = 1
      GO TO 800
C ------------
910   CONTINUE
      CALL MSGERR(MDOC,'ERROR: write output file') 
      CLOSE(IN)
      CLOSE(IOUT)
      IERR = 1
      GO TO 800
      END



