C
C     MOLREP molecular replacement program
C     Copyright (C) 1999-2006 Alexei Vagin
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C

      SUBROUTINE DEF_RAD_DNS(MDOC,RESULT,ISYM,IPRSYM,IERR)
C ------------------------------------------------------------
      INTEGER   MDOC,IERR
      REAL      RESULT(*)
      INTEGER   IPRSYM
      INTEGER*2 ISYM(5,3,IPRSYM)
C ------------------------------------------------------------
C        RESULT(1) = RADIUS
C        RESULT(2) = XMIN
C        RESULT(3) = XMAX
C        RESULT(4) = YMIN
C        RESULT(5) = YMAX
C        RESULT(6) = ZMIN
C        RESULT(7) = ZMAX
C        RESULT(8) = XS
C        RESULT(9) = YS
C        RESULT(10)= ZS
C        RESULT(11)= RI
C        RESULT(12)= MODEL
C        RESULT(13)= NMODEL
C ------------------------
C ---------------------------------
      COMMON/COM_MLR_DENS/ 
     * D_RAD,D_SCALE,D_RADI,D_ORIGIN_F,D_RESOL,DSUM_EL,D_ROLIM
     *,D_SHIFT_BEST,D_ANGLE_BESR,D_RSCALE,D_RAD_PACK
     *,D_NCS
     *,D_MODE,D_POS,D_INVER,D_MOD,D_NAME,D_FLAG_BEST
C -
      INTEGER   D_NCS(2)
      REAL      D_RAD(2),D_SCALE(2),D_RADI(2),D_ORIGIN_F(3,2)
     *         ,D_RESOL(2),DSUM_EL(2),D_ROLIM(2),D_RSCALE(2)
     *         ,D_SHIFT_BEST(3,2),D_ANGLE_BESR(3,2),D_RAD_PACK(2)

      CHARACTER D_MODE*1,D_POS(2)*1,D_INVER(2)*1,D_MOD(2)*1
     *         ,D_NAME(2)*256,D_FLAG_BEST(2)*1
C --------------------------------------------------------------------
      RESULT(8)  = 0.0
      RESULT(9)  = 0.0
      RESULT(10) = 0.0
      RESULT(11) = D_RADI(1)
      RETURN
      END

      SUBROUTINE FNORM(MDOC,F_NAME,FO_NAME
     * ,RESMNIR,RESMXIR,BOFFR,BADDR,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C ------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESMNI,RESMXI
      REAL      RESULT(IPRROW,*)
      INTEGER*4 MDOC,NUMGP,IERR
      CHARACTER F_NAME*(*), FO_NAME*(*),MISS*1,MISSR*1
C ==============================
      INTEGER*4 MTIN
      REAL      RLATT(6),DISTR(41),AVERF(40),SUMF20(40),RHRP2(40)
      REAL      AVERF2(40),SUMN(40),SUMFNT(40),SUMH2F(40)
      REAL      SUMA(40),SUMB(40),SUMC(40),SUMD(40),SUME(40)
      REAL      SUMH2F2T(40),AVERF2T(40),SUMAT(40),AVERFT(40)
      REAL      AVERF2T0(40),SUMSIG2(40),SUMSIG0(40),SUMH2F2(40)
      REAL      RHR(41),SUMF2(40),SUMFN(40),SUMF(40),RHRP(41)
      REAL      SUMR(40),SUMI(40)
      CHARACTER ITYP*4
      CHARACTER LINE*256,TITLE*80,TITLE1*80
C -----------------------------------------------------------
      PI    = 4.0*ATAN(1.0)
      TWOPI = 2.0*PI
      IERR  = 0
      MD    =-ABS(MDOC)-1
      M     = 99
C -----------------------------------------------------------
      MISS   = 'N'
      NUMGP  = 0
      COEF   = 0
      BOFF   = BOFFR
      BADD   = BADDR
      RESMNI = RESMNIR
      RESMXI = RESMXIR
      IF(BOFF.LE.0.0) BOFF=256.0
      IDUMMY_SIG=0
C -------------------------------------------------------------
      MTIN = 20
      ITYP = 'FF  '
      CALL LENSTR_BL(F_NAME,LEN)
      IF(LEN.LE.0.OR.F_NAME(1:1).EQ.' '.OR.F_NAME(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: in FNORM: wrong name of FILE-F')
        IERR=1
        RETURN
      ENDIF
      CALL ORFILE(M,MTIN,F_NAME,ITYP,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: in FNORM: can not open FILE-F')
        RETURN
      ENDIF
      CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *  ,COEF1,BET1,RESMIN,RESMAX,IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
C -------------------------------------------------------------
      IF(RESMNI.LT.1.E-5)  RESMNI=RESMIN
      IF(RESMXI.LT.1.E-5)  RESMXI=RESMAX
      IF(RESMXI.LT.RESMAX) RESMXI=RESMAX
      IF(RESMNI.GT.RESMIN) RESMNI=RESMIN
      WRITE(LINE,
     *'(''Resolution       :'',2F10.2)') RESMNI,RESMXI
      CALL MSGDOC(MDOC,LINE)
C ---
      CALL C_RD_CR
      RLATT(1) = A
      RLATT(2) = B
      RLATT(3) = C
      RLATT(4) = AL
      RLATT(5) = BE
      RLATT(6) = GA
      CALL DSTARF(RLATT,AST,BST,CST,COALST,COBEST,COGAST,VOL)
C ---
      IF(COEF.LE.0.0) COEF=1.5
      WRITE(LINE,
     *'(''Boff,Badd        :'',2F10.2)') BOFF,BADD
      CALL MSGDOC(MDOC,LINE)
C ---
      IF(NUMGP.LE. 0) NUMGP=20
      IF(NUMGP.GT.20) NUMGP=20
      WRITE(LINE,
     *'(''Number of shells :'',I7)') NUMGP
      CALL MSGDOC(MDOC,LINE)
C ---
      CALL ANOMF(M,NSYM,ISYM)
      CALL LIMHKL(RESMXI,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)
C ----------------------------------------------------------------
C --------------------------------------
      CALL MSGDOC(MDOC,' ')
      WRITE(LINE,
     *'('' ---- Scaling by Patterson with Boff ='',F9.0,'' ----'')')
     * BOFF
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' ')
C ---
      RHMIN = 1.0/RESMNI
      RHMAX = 1.0/RESMXI
      DMAX  = (RESMXI/3.0)*2.0*COEF
      B     = 0.0
c      IF(B.LT.0.0) B=0.0

      DMAX1 = SQRT(ABS(B/(8.0*PI*PI)))*2.0*COEF
      IF(DMAX1.GT.DMAX) DMAX=DMAX1
c      WRITE(LINE,1000) DMAX,VOL,DVOL
c 1000 FORMAT('D-max, VOL , 4/3*PI*Rmax^3:'
c     *  ,F7.2,1X,2G14.4)
c      CALL MSGDOC(MDOC,LINE)
C ---
      DELT = DMAX/NUMGP
      DO    K=1,NUMGP
        SUMA    (K) =0.0
        SUMB    (K) =0.0
        SUMC    (K) =0.0
        SUMD    (K) =0.0
        SUME    (K) =0.0
        SUMF2   (K) =0.0
        SUMF20  (K) =0.0
        SUMFN   (K) =0.0
        SUMFNT  (K) =0.0
        SUMF    (K) =0.0
        SUMI    (K) =0.0
        SUMSIG2 (K) =0.0
        SUMSIG0 (K) =0.0
        AVERF   (K) =0.0
        AVERF2  (K) =0.0
        AVERF2T0(K) =0.0
        SUMH2F  (K) =0.0
        SUMH2F2 (K) =0.0
        SUMH2F2T(K) =0.0
      ENDDO
      D = 0
      DO    K=1,NUMGP+1
        DISTR(K) = D
        D        = D+DELT
      ENDDO
      DELTRH  = (RHMAX-RHMIN)/NUMGP
      RHR(1)  = RHMIN
      RHRP(1) = 1./RHMIN
      DO    I=2,NUMGP+1
        RHR(I)  = RHR(I-1)+DELTRH
        RHRP(I) = 1.0/RHR(I)
      ENDDO
      IH     = 0
      IK     = 0
      IL     =-1
      IFIRST = 0
      IEND   =-1
      KEY    = 0
C
      NREF   = 0
      NTOT   = 0
      NREFA  = 0
      NTOTA  = 0
      NREAD  = 0
      NREF0  = 0
      NSIG0  = 0
      NREF_ABS  = 0
      NREF_OUT  = 0
      NREF_MISS = 0
      NADD      = 0
      NABS      = 0
      NF000     = 0
C
      F000  = 0.0
      SSIG  = 0.0
      SF    = 0.0
      SF2   = 0.0
      SF20  = 0.0
      SF4   = 0.0
      SH2F  = 0.0
      SH2S2 = 0.0
      SH2   = 0.0
      MISS  = 'Y'
c ------------------------
      DO     ILP=0,ILMAX
      DO     IKP=-IKMAX,IKMAX
      DO     IHP=-IHMAX,IHMAX
        IF(IHP.EQ.0.AND.IKP.EQ.0.AND.ILP.EQ.0) GO TO 100
        IIHP=IHP
        IIKP=IKP
        IILP=ILP
        CALL ANOMSC(IIHP,IIKP,IILP,IANOM,JJSYM,NSYM,ISYM)
        IF(IANOM.NE.1.OR.JJSYM.NE.1) GO TO 100

        CALL SYSABS_BL(IHP,IKP,ILP,NSYM,ISYM,ICND)
        IF(NSYM.GT.1) THEN
          CALL SYSABS_BL(IHP,IKP,ILP,NSYM,ISYM,ICND)
        ELSE
          ICND=0
        ENDIF
        IF(ICND.NE.0) THEN
           GO TO 100
        ENDIF

        CALL DSTAR(IHP,IKP,ILP,RSQ)
        RH=SQRT(RSQ)
        IF(RH.LT.RHMIN.OR.RH.GT.RHMAX) THEN
          GO TO 100
        ENDIF

        IHT = IHP
        IKT = 0
        ILT = 0
        CALL DSTAR(IHT,IKT,ILT,RSQT)
        RHT=SQRT(RSQT)

        K = (RH-RHMIN)/DELTRH+1.0
        IF(K.GT.NUMGP) K=NUMGP
        IF(K.LT.1) K=1     

        CALL INDMLTT(IHP,IKP,ILP,NGEN,NSYM,ISYM)

 4060   IF(MTIN.LE.0)  THEN
          IERR=1
          RETURN
        ENDIF
        IF(IEND.GT.0) GO TO 4040

c        IF(IL-ILP) 4050,4010,4040
c 4010   IF(IK-IKP) 4050,4020,4040
c 4020   IF(IH-IHP) 4050,4030,4040

        IF((IL-ILP).LT.0) GO TO 4050
        IF((IL-ILP).EQ.0) GO TO 4010
        IF((IL-ILP).GT.0) GO TO 4040
 4010   IF((IK-IKP).LT.0) GO TO 4050
        IF((IK-IKP).EQ.0) GO TO 4020
        IF((IK-IKP).GT.0) GO TO 4040
 4020   IF((IH-IHP).LT.0) GO TO 4050
        IF((IH-IHP).EQ.0) GO TO 4030
        IF((IH-IHP).GT.0) GO TO 4040

 4040   CONTINUE

        CALL DSTAR(IH,IK,IL,RSQI)
        RHI=SQRT(RSQI)
        IF(RHI.LT.RHMIN.OR.RHI.GT.RHMAX) THEN
          NREF_OUT = NREF_OUT + 1
          GO TO 100
        ENDIF
        IF(NSYM.GT.1) THEN
          CALL SYSABS_BL(IHP,IKP,ILP,NSYM,ISYM,ICND)
        ELSE
          ICND=0
        ENDIF
        IF(ICND.NE.0) THEN
          NREF_ABS = NREF_ABS + 1
          GO TO 100
        ENDIF
        IF(MISS.EQ.'Y') THEN
          SUMFNT(K)=SUMFNT(K)+NGEN
          NTOT=NTOT+NGEN
        ENDIF
        NTOTA=NTOTA+1
        NREF_MISS = NREF_MISS + 1
        GO TO 100

 4050   CONTINUE
        IF(IFIRST.EQ.1) THEN
C         ADDITIONAL IL,IK,IL,REFLS
          IF(NSYM.GT.1) THEN
            CALL SYSABS_BL(IH,IK,IL,NSYM,ISYM,ICND)
          ELSE
            ICND=0
          ENDIF
          IF(ICND.NE.0) THEN 
            NABS = NABS + 1
            IFIRST=0
            GO TO 4050 
          ENDIF
          NADD = NADD + 1
          IFIRST=0
          CALL DSTAR(IH,IK,IL,RSQI)
          RHI=SQRT(RSQI)
          IF(RHI.LT.RHMIN.OR.RHI.GT.RHMAX) THEN
            NREF_OUT = NREF_OUT + 1
c            T=1/RHI
c            WRITE(*,*) IH,IK,IL,T,FN,SN
            IFIRST=0
            GO TO 4050 
          ENDIF
          GO TO 4050
        ENDIF
        IFIRST=1
        IF(ITYP.EQ.'FS  ') THEN
          CALL RRD1(MTIN,IH,IK,IL,FN,FNA,SN,SNA,KEY,IEND)
          IDUMMY_SIG=0
          IF(SN .LT.0.000001) SN =0.04*FN
          IF(SNA.LT.0.000001) SNA=0.04*FNA
        ELSE
          CALL RD1(MTIN,IH,IK,IL,FN,FNA,KEY,IEND)
C         SIG-DUMMY
          IDUMMY_SIG = 1
          SN  = 0.04*FN
          SNA = 0.04*FNA
        ENDIF
        IF(MTIN.LE.0) THEN
          CALL MSGERR(MDOC,' ERROR: in FNORM: read FILE_F')
          IERR=1
          RETURN
        ENDIF
        IF(IEND.GT.0)                    GO TO 4040
        NREAD = NREAD+1
        IF(IH.EQ.0.AND.IK.EQ.0.AND.IL.EQ.0) THEN
          NF000  = NF000+1
          F000   = FN
          IFIRST = 0
          GO TO 4060
        ENDIF
        IF(FN.GT.1.E-6.AND.FNA.GT.1.E-6) THEN
          WT1 = 1./(SN*SN)
          WT2 = 1./(SNA*SNA)
          WT  = WT1+WT2
          FN  = FN*WT1+FNA*WT2
          FN  = FN/WT
          SN  = 1./SQRT(WT)
        ELSE IF(FNA.GT.1.E-6) THEN
          FN = FNA
          SN = SNA
        ENDIF
        GO TO 4060

 4030   IFIRST = 0
        IF(NSYM.GT.1) THEN
          CALL SYSABS_BL(IH,IK,IL,NSYM,ISYM,ICND)
        ELSE
          ICND = 0
        ENDIF
        IF(ICND.NE.0) THEN
          NABS = NABS + 1
          IF(IFIRST.EQ.0) GO TO 100
          IFIRST=0
          GO TO 4050 
        ENDIF

        IF(FN.LE.1.E-8) THEN
          NREF0 = NREF0 + 1
          GO TO 100
        ENDIF

        IF(SN.LE.1.E-6) THEN
          NSIG0 = NSIG0 + 1 
          GO TO 100
        ENDIF


        NREF  = NREF+NGEN
        NTOT  = NTOT+NGEN
        NREFA = NREFA+1
        NTOTA = NTOTA+1
        IF(BOFF.GT.0.0) THEN
          BT    = BOFF/4.0
          CBOFF = 1.0-EXP(-BT*RSQ)
        ELSE
          CBOFF = 1.0
        ENDIF
        IF(ABS(BADD).GT.0.01) THEN
          BT    = BADD/4.0
          CBADD = EXP(-BT*RSQ)
        ELSE
          CBADD = 1.0
        ENDIF
        Y = CBOFF*CBADD

        FN2       = FN*FN*CBOFF*CBOFF*CBADD*CBADD
        SN2       = SN*SN*CBOFF*CBOFF*CBADD*CBADD

        SUMF2 (K) = SUMF2(K)   +FN2    *NGEN
        SUMF20(K) = SUMF20(K)  +FN*FN  *NGEN
        SUMI  (K) = SUMI(K)    +FN*FN  *NGEN

        SUMH2F(K) = SUMH2F(K)  +RSQT*FN*NGEN*Y
        SUMSIG2(K)= SUMSIG2(K) +RSQT*SN*SN*NGEN*Y*Y

        SUMH2F2(K)= SUMH2F2(K) +RSQ *FN*NGEN
        SUMFN (K) = SUMFN(K)   +        NGEN
        SUMFNT(K) = SUMFNT(K)  +        NGEN
        SUMSIG0(K)= SUMSIG0(K) +SN     *NGEN
        SSIG      = SSIG       +SN     *NGEN
        SF        = SF         +FN     *NGEN
        SF20      = SF20       +FN*FN  *NGEN
        SF2       = SF2        +FN2    *NGEN
        SF4       = SF4        +FN2*FN2*NGEN

        SH2F      = SH2F       +RSQT*FN*NGEN*Y
        SH2S2     = SH2S2      +RSQT*SN*SN*NGEN*Y*Y

        SH2       = SH2        +RSQT   *NGEN
  100   CONTINUE
      ENDDO
      ENDDO
      ENDDO
C ---
      CLOSE (MTIN)
      IF(NREF.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR:  in FNORM: number of reflections = 0')
        IERR=1
        RETURN
      ENDIF

C      IF(MISS.EQ.'Y'.AND.NTOT.NE.NREF) THEN
C        CALL MSGDOC(MDOC,
C     *  ' ---  Missing reflections will be included with F=0 ---')
C      ELSE
C        NTOT=NREF
C        DO I=1,NUMGP
C          SUMFNT(I)=SUMFN(I)
C        ENDDO
C      ENDIF

      A_CELL = A
      SF2    = (SQRT(ABS(SF2*2.0))        )  /VOL
      SF4    = (SQRT(ABS(SF4*2.0))        )  /VOL
      SH2S2  = (SQRT(ABS(SH2S2*2.0))*TWOPI)  /(VOL*A_CELL)
      SH2    = (SQRT(ABS(SH2  *4.0))*TWOPI)  /(VOL*A_CELL)
      SH2F   = ((SH2F *2.0)*TWOPI*PI)        /(VOL*A_CELL*A_CELL)
      COMPL  = 1.0
      IF(NTOTA.GT.0) COMPL = FLOAT(NREFA)/FLOAT(NTOTA)
      RSTAND = 0.0
      IF(NREF.GT.0) THEN
        SSIG = SSIG/NREF
        SF   = SF  /NREF
        SF20 = SF20/NREF
        IF(SF.GT.0.0.AND.IDUMMY_SIG.LE.0) RSTAND = SSIG/SF
      ENDIF
      DO I=1,NUMGP
        AVERF2  (I) = 0.0
        AVERF2T (I) = 0.0
        AVERF2T0(I) = 0.0
        IF(SUMFNT(I).GT.0.000001) AVERF2T (I) = SUMF2 (I)/SUMFNT(I)
        IF(SUMFNT(I).GT.0.000001) AVERF2T0(I) = SUMF20(I)/SUMFNT(I)
        IF(SUMFN(I) .GT.0.000001) AVERF2  (I) = SUMF2 (I)/SUMFN(I)
        IF(SUMFN(I) .GT.0.000001) THEN
          SUMI(I) = SUMI(I)/SUMFN(I)
        ELSE
          SUMI(I) = 0.0
        ENDIF
        AVERF (I)   = SQRT(ABS(AVERF2 (I)))
        AVERFT(I)   = SQRT(ABS(AVERF2T(I)))
        SUMH2F2T(I) = 0.0
        IF(SUMFN (I).GT.0.0000001) THEN
          SUMH2F2T(I) = (SUMH2F2(I)*SUMFNT(I))/SUMFN(I)
        ENDIF
      ENDDO
C -----------------------
      WRITE(LINE,
     *'(''Number of reflections / & total number/  :'',2I8)') 
     *NREFA,NTOTA
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *'(''Numbers: In file,Sys.abs,Miss,RES_out    :'',4I8)') 
     * NREAD,NREF_ABS,NREF_MISS,NREF_OUT
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *'(''Numbers: With_F=<0,With_sig=<0,Nadd,NF000:'',4I8)') 
     * NREF0,NSIG0,NADD,NF000
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *'(''Resolution                               :'',2F8.3)') 
     *RESMNI,RESMXI
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *'(''Completeness                             :'',F9.3)')COMPL
      CALL MSGDOC(MDOC,LINE)
      IF(NF000.GT.0) THEN
        WRITE(LINE,
     *  '(''F000                                     :'',G14.4)')
     *  F000
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      WRITE(LINE,
     *'(''<F>,<F^2>                                :'',2G14.4)')
     *SF,SF20
      CALL MSGDOC(MDOC,LINE)
      IF(IDUMMY_SIG.LE.0) THEN
        WRITE(LINE,
     *  '(''<sig(F)>,R_stand(F) (<sig(F)>/<F>)       :'',G14.4,F9.3)')
     *  SSIG,RSTAND
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      WRITE(LINE,
     *'(''<Curvature>_of atomic peak               :'',G14.4)') 
     *SH2F 
      CALL MSGDOC(MDOC,LINE)
C -----------------------------------------
C
C ---- PATTERSON ----------------------------------------------------
C
      CALL MSGDOC(MDOC,
     *' ----          Patterson                ----')
      CALL MSGDOC(MDOC,' ')
      NUMGPF=NUMGP

c      WRITE(*,*) ' DELTRH:', F000,DELTRH

      CALL CALC_PATT(MDOC,NUMGP,NUMGPF,DELT,DELTRH,RHR,COMPL
     *     ,AVERF2,AVERF2T,SUMA,SUMC,IERR)

      smin = 1.0e30
      ip = 0
      do i=1,numgp
        if(sumc(i).lt.smin) then
          smin = sumc(i)
          ip = i
          if(smin.le.0.0) go to 111
        endif
      enddo
 111  continue

      if(smin.le.0.0) then
        sc   = float(NUMGP)/float(i)
        DMAX = DMAX * sc
      else
        sc = (sumc(1)-sumc(ip))/sumc(1)
        if(sc.lt.0.05) sc = 0.05
        d  = (dmax*float(ip+1))/float(NUMGP)
        DMAX = d/sc    
      endif 
C ---
      DELT = DMAX/NUMGP
      D = 0
      DO    K=1,NUMGP+1
        DISTR(K) = D
        D        = D+DELT
      ENDDO
      NUMGPF=NUMGP

      CALL CALC_PATT(MDOC,NUMGP,NUMGPF,DELT,DELTRH,RHR,COMPL
     *     ,AVERF2,AVERF2T,SUMA,SUMC,IERR)

      ALIM=0.1
      CALL  TEMP_FLPP(SUMC,NUMGP,DISTR,SCALE,BTP,ALIM)

      IF(BTP.GT.0.0000000001) THEN
        DT2 = 1.0/(2.0*BTP)
      ELSE
        DT2 = 0.0
      ENDIF

      P000 = SCALE
c     DT sig_patt
      DT   = SQRT(ABS(DT2))
      BSUM = 8.0*PI*PI*DT2
C ---
      SIG_PATT = DT

      RESMXI      = RHRP(NUMGP)
      WIDTH_RES   = 0.715 * RESMXI
      B_RES       = 2.0*RESMXI*RESMXI
      SIG_RES     = WIDTH_RES/2.0
      SIG2_RES    = SIG_RES*SIG_RES

      WIDTH_PATT  = SIG_PATT * 2.0
      SIG2_PATT   = SIG_PATT * SIG_PATT
      B_PATT      = 8.0*PI*PI*SIG2_PATT
      B_FOUR      = B_PATT/2.0

      T           = WIDTH_PATT*WIDTH_PATT + WIDTH_RES*WIDTH_RES
      WIDTH_FOUR  = SQRT(T/2.0)
      SIG_FOUR    = WIDTH_FOUR/2.0
      SIG2_FOUR   = SIG_FOUR*SIG_FOUR

      SIG2_PATT_0 = SIG2_PATT - SIG2_RES
      T           = SIG2_PATT_0
      IF(T.LT.0.0) T = 0.0
      SIG_PATT_0  = SQRT(T)
      SIG2_FOUR_0 = SIG2_PATT_0/2.0
      WIDTH_FOUR_0= SQRT(ABS(SIG2_FOUR_0))*2.0
      WIDTH_FOUR  = SQRT(ABS(SIG2_FOUR  ))*2.0

      RES_EFF     = WIDTH_FOUR
      B_EFF       = 8.0*PI*PI*(WIDTH_FOUR/2.0)*(WIDTH_FOUR/2.0)

      BOVERALL    = B_PATT/2.0

      WIDTH_FOUR_0= SQRT(ABS(SIG2_FOUR_0))*2.0
      WIDTH_FOUR  = SQRT(ABS(SIG2_FOUR  ))*2.0

C -----------------------
      WRITE(LINE,
     *'(''Patt_origin_peak,Width_of_peak         :'',2G14.4)') 
     * P000,WIDTH_PATT
      CALL MSGDOC(MDOC,LINE)
      SQR_P000=SQRT(ABS(P000))
      WRITE(LINE,
     *'(''sqrt(P000)                             :'',G14.4)') 
     * SQR_P000
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *'(''Expected width of atomic peaks -res: W_f_0       :'',G14.4)') 
     * WIDTH_FOUR_0
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *'(''Corresponding B_overall = 8pi^2*(W_f_0/2)^2      :'',G14.4)') 
     * BOVERALL
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *'(''W_resol = 0.716*RESmax)                          :'',G14.4)') 
     * WIDTH_RES
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *'(''B_resol = 2*RESmax^2                             :'',G14.4)') 
     * B_RES
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *'(''Optical Resolution =  Opt_res=W_f                :'',G14.4)') 
     * RES_EFF
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,
     *'(''Corresponding thermal factor/8pi^2*(Opt_res/2)^2/:'',G14.4)') 
     * B_EFF
      CALL MSGDOC(MDOC,LINE)

      W_FOUR      = WIDTH_FOUR* 1.01
      SIG2_FOUR   = (W_FOUR/2.0)*(W_FOUR/2.0)
      SIG2_RES    = SIG2_FOUR - SIG2_FOUR_0
      W_RES       = SQRT(SIG2_RES)*2.0
      RESMAX_USED = W_RES/0.715 

      RESULT(1,1)  = BSUM
      RESULT(2,1)  = SCALE

      RESULT( 7,1) = SQR_P000
      RESULT( 8,1) = BOVERALL
      RESULT( 9,1) = RES_EFF
      RESULT(10,1) = RESMXI
      RESULT(11,1) = RESMNI
      RESULT(12,1) = NSYM
      RESULT(13,1) = VOL
      RESULT(14,1) = COMPL
      RESULT(15,1) = RESMAX_USED

c      WRITE(*,*) 'Res_opt_used:',RES_EFF,RESMAX_USED

c ================================

      FMIN= 1.E30
      FMAX=-1.E30   
      DO I=1,16

        NUMGPF = NUMGP-I+1

        CALL CALC_PATT(MDOC,NUMGP,NUMGPF,DELT,DELTRH,RHR,COMPL
     *       ,SUMD,AVERF2T,SUMA,SUMC,IERR)

        ALIM=0.1
        CALL  TEMP_FLPP(SUMC,NUMGP,DISTR,SCALE,BTP,ALIM)
        IF(BTP.NE.0.0) THEN
          DT2=1.0/(2.0*BTP)
        ELSE
          DT2=0.0
        ENDIF

C        BSUM=8.0*PI*PI*DT2
C        BSUMF=BSUM/2.0
C        DTFOUR=SQRT(BSUMF/(8.0*PI*PI))
C        RESEFF=DTFOUR*2.0*SQRT(2.0)

        DT          = SQRT(ABS(DT2))

        WIDTH_RES   = 0.715 * RESMXI
        WIDTH_PATT  = DT*2.0
        T           = WIDTH_PATT*WIDTH_PATT + WIDTH_RES*WIDTH_RES
        WIDTH_FOUR  = SQRT(T/2.0)

        RES_EFF     =  WIDTH_FOUR

        SUMB (NUMGPF) = RES_EFF

        IF(RES_EFF.GT.FMAX)  FMAX=RES_EFF
        IF(RES_EFF.LT.FMIN)  FMIN=RES_EFF

      ENDDO
C --
      CALL MSGDOC(MDOC,' ')
      WRITE(LINE,
     *'('' -- Res_eff and Res_eff for atom with B :'',F8.3,'' --'')'
     *) BTEST
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' ')

      WRITE(LINE,'(''  min,max:'',2G14.4)') 
     *FMIN,FMAX
      CALL MSGDOC(MDOC,LINE)


      DO I=1,NUMGP
        SUME (I) = 0.0
c        WRITE(*,*) I,RHRP(I),SUMB(I),SUME(I)
      ENDDO

      RESEFF = SUMB(NUMGP)
      DRES    = 0.0
      DRESO   = 0.0
      RESEFFN = RESEFF*1.01
C     RESEFFN = RESEFF*1.005
          DO I=20,2,-1
            IF(SUMB(I).GT.RESEFFN.OR.
     *         SUMB(I).LT.0.0001) THEN
              GO TO 700
            ELSE
              R1  = RHRP(I+1)
              R2  = RHRP(I  )
              RO1 = SUMB(I  )
              RO2 = SUMB(I-1)
              DRES  = R2 -R1
              DRESO = RO2 -RO1
            ENDIF
          ENDDO
 700  CONTINUE
      IF(DRESO.GT.0.0001) THEN
        RESMAX_USED = ((RESEFFN - RO1)/DRESO)*DRES + R1
        RESULT(15,1) = RESMAX_USED
      ENDIF

c     WRITE(*,*) 'Res_opt_used:',RESEFF,RESMAX_USED

      NF=2
      FMIN= 1.E30
      FMAX=-1.E30   
      DO I=1,NUMGP
        IF(SUMB(I).GT.FMAX)  FMAX=SUMB(I)
        IF(SUME(I).GT.FMAX)  FMAX=SUME(I)
        IF(SUMB(I).LT.FMIN)  FMIN=SUMB(I)
        IF(SUME(I).LT.FMIN)  FMIN=SUME(I)
      ENDDO
      CALL CORR_MAX(FMAX,FMAXN)
      DO I=1,NUMGP
        IF(SUMB(I).GT.0.0) THEN
          T=0.0
          IF(FMAX.GT.0) T=SUMB(I)/FMAX
          SUMR(I)=T
        ELSE
          SUMR(I)=10000000000.0
        ENDIF
      ENDDO
      IMSG=1
      FMIN=0
      TITLE1='  (*) Res_eff    (+) Res_eff for SC*EXP(-Bover*S^2)'
      CALL GRAPH_PP(MDOC,NUMGP,NF,RHRP,SUMB,SUME,FMIN,FMAXN,SUMR
     *             ,TITLE1,IMSG)
c ================================
      RETURN
      END

      SUBROUTINE TR_TEST(MDOC,LIST
     * ,NAMEF_INP,NAME_PH,NAMEM,NAMET_OUT
     * ,PATH_SCR,RESN,RESX,DIFF
     * ,FAST,ANISO,BOFF,RSMIN_RBI,RSMAX_RBI
     * ,RMAX_PK,RMIN_PK,SIGMA
     * ,BOFFP,BADD,NAME2,ISYM,IPRSYM
     * ,IPK_RF,ALPHA,BETA,GAMMA
     * ,REF,NC,NP,RESULT,IPRMAX,IPRROW,IERR)
C --------------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
C ----
      REAL      RESULT(IPRMAX,IPRROW)
      PARAMETER ( IPRMAXA =51  )
      PARAMETER ( IPRROWA =51  )
      REAL      RESULTA(IPRMAXA,IPRROWA)
      REAL      RESULTB(IPRMAXA,IPRROWA)
C     PARAMETER ( IPRCYCL=50  )
      PARAMETER ( IPRCYCL=200 )
      REAL      CORR(IPRCYCL),RFAC(IPRCYCL),SHIFT(3)
      REAL      SCR_SORT(IPRCYCL)
c ---
C ---------------------------------------
      INCLUDE 'molrep_lh_infor.fh'
C      COMMON/COM_LH_INFOR/ BOFF_LH,BADD_LH,BOFF_FOR_SCAL
C     *   ,CHECK_CONTRAST,CONTRAST_LIM
C     *   ,BCORR_LH,FILE_FOBS_LH,SCORE_FLAG,LH_LH,DB_LH
CC ---
C      REAL      CHECK_CONTRAST,CONTRAST_LIM
C      REAL      BOFF_FOR_SCAL,BOFF_LH,BADD_LH,BCORR_LH
C      CHARACTER LH_LH*1,SCORE_FLAG*1,DB_LH*1
C      CHARACTER FILE_FOBS_LH*256
C ----------------------------------
C ---
      CHARACTER NAMEF_INP*(*),NAMEM*(*),NAME2*(*),NAMET_OUT*(*)
      CHARACTER PATH_SCR*(*),NAME_PH*(*)
      CHARACTER NAMEC*256,NAMEO*256
      CHARACTER NAMEC2*256,NAMES2*256
      CHARACTER NAMES*256,NAMED*256,NAMEFM*256,NAMEPH*256
      CHARACTER NAMEFM2*256,NAMEPH2*256,NAMET*256
      CHARACTER NAME_SCR*256,NAME_SCR1*256,NAMEF*256

      CHARACTER LINE*256,MODE*1,REFP*1,TFUN*1,PACK*1
      REAL      AM(3,3),SH1(3),SH2(3)
      REAL      ANGLES_NCS(3),CVECTOR_NCS(3)

      CHARACTER DOM*1,MOD2*1,TTT*80,P1*1,REST*1,RFAC_FLAG*1
      CHARACTER REF*1,F000*1,DIFF*1,ACORR*1
      CHARACTER REFS*1,REFB*1,REFA*1,REFX*1,CH3*3
      CHARACTER MODE_F*1,STOP_T*1,FAST*1,MODE_D*1,INVER*1
      CHARACTER PATT*1,SOLV*1,ANISO*1,ANISO_RB*1,CH2*2,LIST*1
C -------------------------------------------------------------
      PI     = 4.0*ATAN(1.0)
      RTODEG = 180./PI
      DEGTOR = 1.0/RTODEG
C ---
      MD   = -ABS(MDOC)-1
      M    = 99
      MD0  = 0
      IF(ABS(MDOC).EQ.2) MD=99
   
      IF(LIST.EQ.'T') THEN
        MD = MDOC
      ELSE IF(LIST.EQ.'L') THEN
        MD   = -ABS(MDOC)-1
      ENDIF

      IF(FAST.EQ.'M'.AND.(LIST.NE.'T'.AND.LIST.NE.'L')) THEN
        MD  = M
        MD0 = M
      ENDIF       

      NUM_MON = IERR
      IERR    = 0
C ---
      IF(NC.LE.0) NC=5
      IF(BOFFP.LE.0.0) BOFFP = 1600
      IF(BOFF .LE.0.0) BOFF  =  900
C ---
C      RSMIN_RB = 20.0
C      RSMAX_RB = 3.0

      NCYCL_RB  = NC
      BOFF_RB   = BOFFP
      RSMIN_RB  = RSMIN_RBI
      RSMAX_RB  = RSMAX_RBI
C ---
C --------------------------------------------
      NCYCL_RB = NC

      IF(REF.EQ.'y') REF='Y'
      IF(REF.EQ.'n') REF='N'
      IF(REF.NE.'Y') REF='N'

      IF(NP.LE.0) NP=1
C     IF(NP.EQ.1) GO TO 900
      IF(NP.GT.IPRCYCL) NP=IPRCYCL

      NPTRANS=NP
C      IF(NPTRANS.LE.0) GO TO 900
C      IF(NPTRANS.GT.NP) NPTRANS=NP

      MOD2='N'
      CALL LENSTR_BL(NAME2,LEN)
      IF(LEN.GT.0.AND.NAME2(1:1).NE.' '.AND.NAME2(1:1).NE.',')
     * MOD2='Y'

      MODE_D='N'
      CALL LENSTR_BL(NAME_PH,LEN)
      IF(LEN.GT.0.AND.NAME_PH(1:1).NE.' '.AND.NAME_PH(1:1).NE.',')
     * MODE_D='Y'

      RESMAX=RESX
      RESMIN=RESN
C --------------------
c      WRITE(LINE,'('' Resmin,Resmax               :'',2F8.2)') 
c     * RESMIN,RESMAX
c      CALL MSGDOC(MDOC,LINE)

C      IF(LH_LH.NE.'N') THEN
C        NAMEF = FILE_FOBS_LH       
C      ELSE
         NAMEF = NAMEF_INP
C      ENDIF

      NAMES    = ' '
      NAMES2   = ' '
      NAMEC    = 'trfn_scr3'
      CALL ADD_PATH(PATH_SCR,NAMEC)  
      NAMEC2   = 'trfn_scr2'
      CALL ADD_PATH(PATH_SCR,NAMEC2)  
      NAMED    = 'trfn_scr'
      CALL ADD_PATH(PATH_SCR,NAMED)  
      NAMEFM   = 'trfn_f'
      CALL ADD_PATH(PATH_SCR,NAMEFM)  
      NAMEPH   = 'trfn_ph'
      CALL ADD_PATH(PATH_SCR,NAMEPH)  
      NAMEFM2  = 'trfn_f3'
      CALL ADD_PATH(PATH_SCR,NAMEFM2)  
      NAMEPH2  = 'trfn_ph3'
      CALL ADD_PATH(PATH_SCR,NAMEPH2)  
      NAME_SCR = 'molrp_scratch_rft'
      CALL ADD_PATH(PATH_SCR,NAME_SCR)  
      NAME_SCR1= 'molrp_scratch_rdc'
      CALL ADD_PATH(PATH_SCR,NAME_SCR1)  
      NAMEO    = NAMET_OUT

      IPK      = 0
      CORR_FIX  = -3.0
      CORR_TOT = -1.5
      SCR_SORT_TOT = -1.5
      IPK_BEST = 0
      AVER      = 0.0
      AVER2     = 0.0
      NAVER     = 0

 800  CONTINUE

      IPK = IPK+1

C      CALL MSGDOC(MD,' ')
C      WRITE(LINE,'(''---- peak number :'',I5)') IPK
C      CALL MSGDOC(MD,LINE)
C      CALL MSGDOC(MD,' ')


      SH2(1) = RESULT(IPK,6)
      SH2(2) = RESULT(IPK,7)
      SH2(3) = RESULT(IPK,8)

      MODE='E'
      DO I=1,3
        SH1(I)=0.0
        DO J=1,3
          AM(I,J)=0.0
        ENDDO
      ENDDO
      ALPHA1 =0.0
      BETA1  =0.0
      GAMMA1 =0.0

      WRITE(LINE,'('' Shift :'',3F8.2)') SH2(1),SH2(2),SH2(3)
      CALL MSGDOC(MD,LINE)

      IF(MOD2.EQ.'Y') THEN
        NAMET=NAMEC
      ELSE
        NAMET=NAMEC2
      ENDIF

      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC
      CALL TRANS(MMM,NAMEM,NAMET,SH1,SH2
     *    ,MODE,AM,ALPHA1,BETA1,GAMMA1,RESULTA,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900

      IF(MOD2.EQ.'Y') THEN
        IERR=NUM_MON
C                      old  + new
C                             if(surf.eq.'y') use blim
        CALL JOINCRD(M,NAME2,NAMEC,NAMEC2,ISYM,IPRSYM,IERR)

      ENDIF
C ---- 
C     CALL MSGDOC(MD0,'--- generate density ---')
      RAD   = 0.0

c     H2OBG = 0.35
      H2OBG = 0.0

      BADDD = 0.0
      P1    = 'N' 
      NX    = 0
      NY    = 0
      NZ    = 0
      IZMAX =-1
      IZMIN = 0
      MODE  = ' '
      TTT   = ' '
      IERR  = 0
      ZFADD = 0.0
      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC
      CALL GENDEN(MMM,NAMEC2,NAMED,TTT
     * ,RESMAX,NX,NY,NZ,IZMIN,IZMAX,MODE,RAD,H2OBG,BADDD,P1,ZFADD
     * ,RESULTA,IPRMAXA,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C     NEL - RESULT(1)
      NEL1=RESULTA(1,1)
C ---------------------------------------
C     CALL MSGDOC(MD0,'--- real fft ---')
      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC


C      NAME_SCR = 'molrp_scratch_rft'
C      NAME_SCR1= 'molrp_scratch_rdc'

c      write(*,*) '-fd:',NAMED
c      write(*,*) '-ff:',NAMEC2
c      write(*,*) '-fp:',NAMEPH2

      CALL RFFT(MMM,RESMAX
     * ,NAMED,NAMEC2,NAMEPH2,PATH_SCR,ISYM,IPRSYM,RESULTA,IERR)
      IF(IERR.NE.0) GO TO 900
C ---------------------------------------
c      CALL MSGDOC(MD,'--- scaling ---')
c      IF(IPK.EQ.1) THEN

      BOFFF = BOFF
      BADDD = 0.0
      SOLV  = 'N'
      SCALE = 1.0
      BOVER = 0.0
      NCYCL = 0
      ACORR = 'N'
      RESMNI = RESMIN
      RESMXI = RESMAX
      IF(ANISO.EQ.'K') THEN
        SCALE  = 0.0
        BOVER  = 0.0
      ENDIF
      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC

      CALL MR_SCALING(MMM,LIST,NAMEF,NAMEC2,NAMEFM2,PATH_SCR
     * ,ANISO,SCALE,BOVER,ACORR,BOFFF,BADDD,RESMNI,RESMXI
     * ,SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF
     * ,RESULTA,IPRMAXA,IPRROWA,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C ---------------------------------------------------------
C     1. ACORR # N - anisothermal correction of Fmod
c        if ANISO = '-' return
C     2. ANISO = K - FSCALE with SCALEP,BSCALE
C                   if scale = 0 - scaling by Fobs (cell must be the same)
C                      only scale , set BOVER = 0
C                   if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                  no info: rfac, corr
C        else  CALL PSCALE
C      output: SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF and NAMEFM2
C ---------------------------------------------------------

      COEFP  = SCALEP_NEW  
      BTEMPP = BSCALE_NEW

      WRITE(LINE,'('' TR_TEST: scale,B_scale :'',2F10.5)') 
     * COEFP,BTEMPP
      CALL MSGDOC(MD,LINE)
  
      BSCALE  = BTEMPP
      SCALE_P = COEFP

      IF(MODE_D.EQ.'Y') THEN
        BOFFF  = BOFF
        BADDD  = 0.0
        SCALE  = 1.0
        RESMNI = RESMIN
        RESMXI = RESMAX
        NAMES  = ' '
        NAMES2 = ' '
        MODE   = ' '
        INVER  = 'N'
        SHIFT(1) = 0.0
        SHIFT(2) = 0.0
        SHIFT(3) = 0.0
        CALL SFVSUM(M,MODE,SCALE,INVER
     *    ,NAMEF,NAME_PH,NAMEFM2,NAMEPH2,NAMES,NAMES2 
     *    ,SHIFT,BOFFF,BADDD,RESMNI,RESMXI
     *    ,ISYM,IPRSYM,RESULTA,IPRMAXA,IERR)
        IF(IERR.NE.0) GO TO 900
        CORR_REF = RESULTA(4,1) 
      ENDIF

      IF(REF.EQ.'N') THEN
        MDD=MDOC
        MDD=MD
        IF(FAST.EQ.'M') MDD = MD
      ELSE
        MDD=MD
      ENDIF

      WRITE(LINE,'(I2,'') R-factor,Corr/without refinement/:'',2F8.4)') 
     * IPK,RFAC_REF,CORR_REF
      CALL MSGDOC(MDD,LINE)

c      ENDIF
C ---
      NAMES      = ' '
      THRESH     = 0.0
      TOP        = 0
      SIG_SCALE  = 0.0
      NAMES2     = ' '
      MODE       = ' '
      IZMIN      = 0
      IZMAX      = 0
      CALL COPYFL(M,NAMEC2,NAMES,NAMEFM2,THRESH,TOP,SCALE_P,BSCALE
     *           ,SIG_SCALE,RESMIN,RESMAX,IZMIN,IZMAX,MODE,NAMES2
     *           ,RESULTA,IPRMAXA,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C ---------------------------------------

      RFAC(IPK) = RFAC_REF
      CORR(IPK) = CORR_REF

      IF(REF.EQ.'N') THEN 
        NAMET = NAMEC2
        GO TO 510
      ELSE
        NAMET = NAMEC
      ENDIF
C ---------------------------------------
C      CALL MSGDOC(MD0,'--- rigid body refinement ---')
      FMIN   =  0.0
      SIGMIN =  0.0

      RSMIN = RSMIN_RB
      IF(RSMIN.GT.RESMIN) RSMIN=RESMIN
      RSMAX = RSMAX_RB
      IF(RSMAX.LT.RESMAX) RSMAX=RESMAX
      NCYCL = NCYCL_RB
C      SCALE = COEFP
      BTEMP = 0.0
c      IF(BTEMPP.GT.0.0) BTEMP = BTEMPP
c      SCALE = 0.0
      REFS  = 'Y'
      REFB  = 'N'
      REFA  = 'Y'
      REFX  = 'Y'
      P1    = 'N'
      IPERC =  0
C     BOFF_RB = 900.0
      BOFF_RB = BOFFP
C     BADD_RB = 100.0
      BADD_RB = 0.0
      DOM     = 'Y'
      MODE    = ' '
      F000    = 'N'
      SCALE    = 0.0
      ANISO_RB = 'N'
      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC
c      IF(MOD2.EQ.'Y'.AND.DIFF.EQ.'H') THEN
      IF(DIFF.EQ.'H') THEN
        REFB  = 'Y'
        REFA  = 'N'
        REFX  = 'y'
        MODE  = 'U'
        RSMIN   = RESMIN
        RSMAX   = RESMAX
        BOFF_RB = BOFF
        BADD_RB = BADD
        SCALE   =.01
        MMM     = MDOC
        DOM     = 'N'
      ENDIF
C --- for rotfft
c      BOFF_RB  = 0.0
c      RSMAX    = RESMAX
c      RSMIN    = RESMIN
C
c      SCALE    = 0.5
c      RSMIN    = RESMIN
c      RSMAX    = RESMAX
C -
      NCS_ID         = 0
      ANGLES_NCS(1)  = 0.0
      ANGLES_NCS(2)  = 0.0
      ANGLES_NCS(3)  = 0.0
      CVECTOR_NCS(1) = 0.0
      CVECTOR_NCS(2) = 0.0
      CVECTOR_NCS(3) = 0.0

      CALL ROTFFT(MMM,NAMEC2,NAMEF,NAME_PH,NAMEC,PATH_SCR
     * ,BOFF_RB,BADD_RB,DOM,F000,NCS_ID,ANGLES_NCS,CVECTOR_NCS
     * ,RSMIN,RSMAX,NCYCL,SCALE,REFA,REFX,REFB,MODE,ANISO_RB,P1,LIST
     * ,RESULTA,RESULTB,IPRMAXA,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900      
C --- for rotfft
C
C      CALL ROTLSQ(M,NAMEC2,NAMEF,NAMEC,BOFF_RB,BADD_RB,DOM
C     * ,FMIN,SIGMIN,IPERC
C     * ,RSMIN,RSMAX,NCYCL,SCALE,BTEMP,REFS,REFB,REFA,REFX
C     * ,P1,RESULTA,IPRMAXA,ISYM,IPRSYM,POOL,MEMORY,IERR)
C      IF(IERR.NE.0) GO TO 900
C
C      RESULT(1) - number of cycles
C      RESULT(2) - Scale
C      RESULT(3) - Boverall
C      RESULT(4) - R-factor
C      RESULT(5) - Correlation
C      RESULT(6) - initial R-factor
C      RESULT(7) - initial Correlation
C      RESULT(8) =TX(1,1)
C      RESULT(9) =TX(2,1)
C      RESULT(10)=TX(3,1)
C      RESULT(11)=THETA(1,1)
C      RESULT(12)=THETA(2,1)
C      RESULT(13)=THETA(3,1)
c      RESULT(14) =TX(1,2)
c      RESULT(15) =TX(2,2)
c      RESULT(16) =TX(3,2)
c      RESULT(17) =THETA(1,2)
c      RESULT(18) =THETA(2,2)
c      RESULT(19) =THETA(3,2)
c      RESULT(20) =NDOM
C      RESULT(21) - number of refls /in output file/

C
      NDOM        = RESULTA(20,1)
      NC_FIN      = RESULTA(1,1)
      RFAC(IPK)   = RESULTA(4,1)
      CORR(IPK)   = RESULTA(5,1)
      RFAC0       = RESULTA(6,1)
      CORR0       = RESULTA(7,1)
      WRITE(LINE,'('' Resmin,Resmax/ for RB refinement / :'',2F8.2)') 
     * RSMIN,RSMAX
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,
     *'('' R-factor,Corr /before refinement/:'',2F8.3)') 
     * RFAC0,CORR0
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,
     *'('' R-factor,Corr /after refinement/ :'',2F8.3)') 
     * RFAC(IPK),CORR(IPK)
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,'('' scale,B_scale :'',2F9.3)') 
     * RESULTA(2,1),RESULTA(3,1)
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,'('' Boff :'',F15.3)') 
     * BOFF_RB
      CALL MSGDOC(MD,LINE)

      WRITE(LINE,'(''Number of domains,Ncycles :'',2I8)') 
     * NDOM,NC_FIN
      CALL MSGDOC(MD,LINE)

      NDOM_N = NDOM
      IF(NDOM.GT.4) NDOM_N = 4
      DO I=1,NDOM_N
        II = I*2 + 10
        CHI = RESULTA(II-1,1)
        SH  = RESULTA(II,1) 
        WRITE(LINE,'('' DOMAIN -'',I3)') I
        CALL MSGDOC(MD,LINE)
        WRITE(LINE,'('' polar rotation angle CHI :'',F8.3)') 
     *    CHI
        CALL MSGDOC(MD,LINE)
        WRITE(LINE,'('' !shift!             :'',F8.3)') SH 
        CALL MSGDOC(MD,LINE)
      ENDDO
      MODE   = 'E'
      SH2(1) = 0.0
      SH2(2) = 0.0
      SH2(3) = 0.0
      ALPHA1 = 0.0
      BETA1  = 0.0
      GAMMA1 = 0.0
      DO I=1,3
        SH2(I) = 0.0
        SH1(I) = 0.0
        DO J=1,3
          AM(I,J) = 0.0
        ENDDO
      ENDDO

      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC

      CALL TRANS(MMM,NAMEC,NAMEC2,SH1,SH2
     *    ,MODE,AM,ALPHA1,BETA1,GAMMA1,RESULTA,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900

c      CALL MSGDOC(MD0,'--- generate density ---')
 
      RAD   = 0.0
      H2OBG = 0.0
      BADDD = 0.0
      P1    = 'N' 
      NX    = 0
      NY    = 0
      NZ    = 0
      IZMAX =-1
      IZMIN = 0
      MODE  = ' '
      TTT   = ' '
      IERR  = 0
      ZFADD = 0.0
      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC
      CALL GENDEN(MMM,NAMEC2,NAMED,TTT
     * ,RESMAX,NX,NY,NZ,IZMIN,IZMAX,MODE,RAD,H2OBG,BADDD,P1,ZFADD
     * ,RESULTA,IPRMAXA,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
C ---------------------------------------
C      CALL MSGDOC(MD0,'--- real fft ---')
      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC

c      NAME_SCR = 'molrp_scratch_rft'
c      NAME_SCR1= 'molrp_scratch_rdc'

      CALL RFFT(MMM,RESMAX
     *  ,NAMED,NAMEC2,NAMEPH2,PATH_SCR,ISYM,IPRSYM,RESULTA
     *  ,IERR)
      IF(IERR.NE.0) GO TO 900

C ---------------------------------------
C      CALL MSGDOC(MD0,'--- scaling ---')

C 23.08.99
C       BOFFF = 256.0
C       BADDD = 0.0

        BOFFF = BOFF
        BADDD = BADD

        SOLV  = 'N'
        SCALE = 1.0
        BOVER = 0.0
        NCYCL = 0
        ACORR = 'N'
        IF(ANISO.EQ.'K') THEN
          SCALE = 0.0
          BOVER = 0.0
        ENDIF
        RESMNI = RESMIN
        RESMXI = RESMAX

        CALL MR_SCALING(MMM,LIST,NAMEF,NAMEC2,NAMEFM2,PATH_SCR
     * ,ANISO,SCALE,BOVER,ACORR,BOFFF,BADDD,RESMNI,RESMXI
     * ,SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF
     * ,RESULTA,IPRMAXA,IPRROWA,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900

        COEFP     = SCALEP_NEW  
        BTEMPP    = BSCALE_NEW
        RFAC(IPK) = RFAC_REF
        CORR(IPK) = CORR_REF

        WRITE(LINE,'('' scale,B_scale :'',2F8.3)') 
     *  COEFP,BTEMPP
        CALL MSGDOC(MD,LINE)
C ---------------------------------------
C      WRITE(LINE,'(I2,'') R-factor,Corr :'',2F8.3)') 
C     * IPK,RFAC(IPK),CORR(IPK)
C      CALL MSGDOC(MDOC,LINE)

 510  CONTINUE

C ---sol
      IF(IPK.EQ.1) THEN
C        IF(MODE_D.EQ.'D') THEN
C          LINE = '             alpha   beta    gamma   Xfrac  Y'//
C     *           'frac  Zfrac     TF  TF/sig   Corr'
C          CALL MSGDOC(MDOC,' ')
C        ELSE
C          LINE = '             alpha   beta    gamma   Xfrac  Y'//
C     *           'frac  Zfrac   TF/sig R-fac   Corr'
C          CALL MSGDOC(MDOC,LINE)
C        ENDIF
          WRITE(LINE,
     *    '(''Sol_TF   Pack_max,min:'',2F8.3,''   Sigma:'',F12.3)') 
     *    RMAX_PK,RMIN_PK,SIGMA
          CALL MSGDOC(MD,LINE)
          LINE = '               Xfrac  Yfrac  Zfrac'//
     *           '   TF/sig   Corr   R-fac   PF'
          CALL MSGDOC(MD,LINE)
      ENDIF
C             alpha   beta    gamma  Xfrac  Yfrac  Zfrac  Dens/sig R-fac   Corr
COLUTF25 11 -360.00 -360.00 -360.00  0.232  0.658  0.428    7.43  0.579  0.180
C
      WRITE(CH3,'(I3)') IPK_RF
      IF(CH3(1:1).EQ.' ') CH3(1:1) = '_' 
      IF(CH3(2:2).EQ.' ') CH3(2:2) = '_' 

C      IF(MODE_D.EQ.'D') THEN
C        WRITE(LINE,'(''Sol_TF'',A2,1X,I2,3F8.2,3F7.3,F8.2,2F7.3)') 
C     *  CH2,IPK,ALPHA,BETA,GAMMA
C     *  ,RESULT(IPK,9),RESULT(IPK,10),RESULT(IPK,11),RESULT(IPK,4)
C     *  ,RESULT(IPK,5),CORR(IPK)
C        CALL MSGDOC(MDOC,LINE)
C_corr
C_corr  CORR(IPK) = RESULT(IPK,4)
C_corr
C      ELSE
C        WRITE(LINE,'(''Sol_TF'',A2,1X,I2,3F8.2,3F7.3,F8.2,2F7.3)') 
C     *  CH2,IPK,ALPHA,BETA,GAMMA
C     *  ,RESULT(IPK,9),RESULT(IPK,10),RESULT(IPK,11),RESULT(IPK,5)
C     *  ,RFAC(IPK),CORR(IPK)
C        CALL MSGDOC(MDOC,LINE)
C      ENDIF
C ---sol

        IF(CORR(IPK).LE.-2.0) THEN
           SCORE = CORR(IPK)
        ELSE

          CRR = CORR(IPK)
          IF(CRR.LT.-1.0) CRR =-1.0
          FTS = RESULT(IPK,5)
          IF(FTS.LT.0.0) FTS = 0.0

          SCORE = CRR

          IF(CRR.GT.-1.0) THEN
            AVER      = AVER  + CRR
            AVER2     = AVER2 + CRR*CRR
            NAVER     = NAVER + 1
          ENDIF

        ENDIF
        WRITE(LINE,'(''Sol_TF'',A3,1X,I3,3F7.3,F8.2,F9.3,2F7.3)') 
     *  CH3,IPK
     * ,RESULT(IPK,9),RESULT(IPK,10),RESULT(IPK,11),RESULT(IPK,5)
     * ,SCORE,RFAC(IPK),RESULT(IPK,22)
        CALL MSGDOC(MD,LINE)
        RESULT(IPK,13) = CORR(IPK) 
        CORR(IPK) = SCORE

        SCR_SORT(IPK) = SCORE
        IF(RESULT(IPK,22).GT.0.0) THEN
          SCR_SORT(IPK) = SCR_SORT(IPK)*RESULT(IPK,22)  
        ENDIF
C ---
C 500  CONTINUE

c     IF(CORR(IPK).GT.CORR_TOT) THEN
      IF(SCR_SORT(IPK).GT.SCR_SORT_TOT) THEN

        MODE='E'
C        SH2(1)=TXSH(IPK)
C        SH2(2)=TYSH(IPK)
C        SH2(3)=TZSH(IPK)
        SH2(1) = 0.0
        SH2(2) = 0.0
        SH2(3) = 0.0
        ALPHA1 = 0.0
        BETA1  = 0.0
        GAMMA1 = 0.0
        DO I=1,3
          SH2(I) = 0.0
          SH1(I) = 0.0
          DO J=1,3
            AM(I,J)=0.0
          ENDDO
        ENDDO

        MMM = M
        IF(LIST.EQ.'T') MMM = MDOC
        CALL TRANS(MMM,NAMEC2,NAMEO,SH1,SH2
     *    ,MODE,AM,ALPHA1,BETA1,GAMMA1,RESULTA,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
        CORR_TOT = CORR(IPK)
        SCR_SORT_TOT = SCR_SORT(IPK)        
        IPK_BEST = IPK
      ENDIF

C --------------------------------------------
      IF(IPK.LT.NPTRANS) GO TO 800
C --------------------------------------------
      IF(CORR_TOT.GE.-1.0) THEN
        CALL MSGDOC(MD,' ')
        CALL MSGDOC(MD,
     *   '--- write coordinates of new model to "trfun.crd" ---')
        WRITE(LINE,'('' transformation corresponds to  :'',I2
     *  ,'' peak of translation function '')') IPK_BEST 
        CALL MSGDOC(MD,LINE)
        WRITE(LINE,'('' Shift :'',3F8.2)') 
     *  RESULT(IPK_BEST,6),RESULT(IPK_BEST,7),RESULT(IPK_BEST,8)
        CALL MSGDOC(MD,LINE)
        RESULT(1,12) = 1.0
        RESULT(1,1)  = RFAC(IPK_BEST)
        RESULT(1,2)  = CORR(IPK_BEST)
        RESULT(1,4)  = RESULT(IPK_BEST,4)
        RESULT(1,5)  = RESULT(IPK_BEST,5)
        RESULT(1,6)  = RESULT(IPK_BEST,6)
        RESULT(1,7)  = RESULT(IPK_BEST,7)
        RESULT(1,8)  = RESULT(IPK_BEST,8)
        RESULT(1,9)  = IPK_BEST
        RESULT(1,13) = RESULT(IPK_BEST,13)
        RESULT(1,22) = RESULT(IPK_BEST,22)
        TF_CONTRAST = 0.0
        IF(NAVER.GT.5) THEN
          AVER      = AVER  - CORR(IPK_BEST)
          AVER2     = AVER2 - CORR(IPK_BEST)*CORR(IPK_BEST)
          NAVER     = NAVER - 1
          SAVER      = AVER /FLOAT(NAVER)
          SAVER2     = AVER2/FLOAT(NAVER)
          TSIGMA    = SQRT(ABS(SAVER2-SAVER*SAVER))
          IF(TSIGMA.GT.0.0001) THEN
            TF_CONTRAST = (CORR(IPK_BEST)-SAVER)/TSIGMA 
          ENDIF
        ENDIF
        RESULT(1,17) = TF_CONTRAST
        RESULT(1,18) = AVER
        RESULT(1,19) = AVER2
        RESULT(1,20) = NAVER
        RESULT(2,21) = CORR_FIX
      ENDIF
C --------------------
      CALL MSGDOC(MD,' ')
  900 CONTINUE
C --------------------

      NAMES='trfn_scr3.crd'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_scr2.crd'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_scr.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_f.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_ph.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_f3.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_ph3.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='molrp_scratch_rft'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='molrp_scratch_rdc.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)

C ---
      RETURN
      END
 
      SUBROUTINE CHECK_CIFILE_IN(MDOC,NAME,IERR)
C -----------------------------------------------------------
C     IERR = 0  OK 
C            1  end of file
C            2  reading error
C            3  it is not CIFile
C            4  there is not cell parameters or space group definition
C ------------------------------------------------------------
      CHARACTER NAME*(*),PATH*80,EXT*3,LINE*256,STR*256
C ----------------------
      IERR = 0
      MD   = -ABS(MDOC)-1
      M    = 99
C ---
      PATH = ' '
      EXT  = ' '
      MT   = 10
C ---
      EXT=' '
      CALL OPENFR(MT,M,PATH,NAME,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,
     *  ' ERROR: can not open INPUT_FILE (in check_CIF)')
        GO TO 900
      ENDIF
C ---
      IFLAG_CIF   = 0
      IFLAG_CELL  = 0
      IFLAG_GROUP = 0
c
c _cell.length_a         47.44
c _symmetry.Int_Tables_number          1
C 123456789 123456789 123456789 1
c _symmetry.space_group_name_H-M     'P1'
c
c data_XXXX
c
      DO IR=1,1000

        READ(MT,'(A)',END = 100, ERR = 200) LINE
        CALL LENSTR_BL(LINE,LEN)

        IF(LEN.GT.0.AND.LINE(1:1).NE.'#') THEN
          STR   = ' '
          J     = 0
          DO I=1,LEN
 
            IF(LINE(1:1).EQ.' '.AND.J.EQ.0) THEN
 
            ELSE
              J = J + 1
              STR(J:J)=LINE(I:I)
            ENDIF
 
          ENDDO
          CALL LENSTR_BL(STR,LEN)

          IF(IFLAG_CIF.EQ.1) THEN
            IF(STR(1:5)  .EQ. '_cell'               ) IFLAG_CELL=1

            IF(STR(1:5)  .EQ. '_symm'         .AND.
     *        (STR(15:27).EQ. 'Tables_number' .OR.
     *         STR(23:30).EQ. 'name_H-M'           )) IFLAG_GROUP=1
         
          ELSE 
            IF(STR(1:5).EQ.'data_') IFLAG_CIF=1
          ENDIF
        ELSE IF(IFLAG_CIF.EQ.1.AND.LINE(1:7).EQ.'#CRYST1') THEN
          IFLAG_CELL=1
          IFLAG_GROUP=1
        ENDIF

        IF(IFLAG_CELL.EQ.1.AND.IFLAG_GROUP.EQ.1) THEN
          CLOSE(MT)          
          GO TO 900
        ENDIF

      ENDDO

 100  CONTINUE

      IERR = 1

      CLOSE(MT)    

      IF(IFLAG_CIF.EQ.0) THEN

        IERR = 3
C        CALL MSGERR(MD,
C     *  ' ERROR: it is not CIFfile')

      ELSE 
        IF(IFLAG_CELL.EQ.0) THEN
C          CALL MSGERR(MD,
C     *    ' ERROR: there is not CELL parameters in CIFfile')
          IERR = 4
        ENDIF
        IF(IFLAG_GROUP.EQ.0) THEN
C          CALL MSGERR(MD,
C     *    ' ERROR: there is not space group definition in CIFfile')
          IERR = 4
        ENDIF
      ENDIF
C ---
 900  CONTINUE
      RETURN
C ---
 200  CONTINUE
      CALL MSGERR(MD,
     *  ' ERROR: reading error (in check_CIF)')
      IERR = 2
      RETURN
      END


      SUBROUTINE TEST_MR(MDOC,NAMEF,NAME2,NAME_PH,NAMEF_N,PATH_SCR
     *  ,NAME_DER,FUN,LIST,BOFF,BADD,BADD_SCL
     *  ,RESMIN,RESMAX,DIFF,PRF,ANISO,PERCENT_2,INVER
     *  ,BOFF_SCL
     *  ,ISYM,IPRSYM,RESULT,IPRMAX,IPRROW,IERR)
C ------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRMAX,IPRROW)
      REAL      RESMIN,RESMAX,PERCENT_2,SH1(3)
      CHARACTER NAMEF*(*),NAME2*(*),NAMEF_N*(*),NAME_PH*(*)
      CHARACTER PATH_SCR*(*),NAME_DER*(*)
      CHARACTER DIFF*1,ANISO*1,PRF*1,INVER*1,FUN*1,LIST*1
C --
      CHARACTER SOLV*1,PATT*1,MODE*1,P1*1,WAT*1,ALT*1,SETT*1,DER*1
      CHARACTER REST*1,HATM*1,NUM*1,NOCC*1,CONV*1,LAP*1,MSGA*1,SCL*1
      CHARACTER NAMEC2*256,NAMES*256,NAMED*256,NAMEF2*256,NAMEPH2*256
      CHARACTER NAMEFM2*256,FO_NAME*256,PHO_NAME*256 
      CHARACTER NAME_SCR*256,NAME_SCR1*256
      CHARACTER LINE*256,TTT*80,SPEC*1,ACORR*1
C --------------------------------------
      PI     = 4.0*ATAN(1.0)
      MD     =-ABS(MDOC)-1
      M      = 99
      MD0    = 0
      IERR   = 0
      MMMD   = MD
C --------------------------------------
      NAMES   = ' '
      NAMEC2  = 'molrp_scr'
      CALL ADD_PATH(PATH_SCR,NAMEC2)
      NAMED   = 'molrp_dns'
      CALL ADD_PATH(PATH_SCR,NAMED)
      NAMEF2  = 'molrp_f'
      CALL ADD_PATH(PATH_SCR,NAMEF2)
      NAMEPH2 = 'molrp_ph_mod2'
      CALL ADD_PATH(PATH_SCR,NAMEPH2)
      NAMEFM2 = 'molrp_f2'
      CALL ADD_PATH(PATH_SCR,NAMEFM2)

      DER = 'N'
      CALL LENSTR_BL(NAME_DER,LEN)
      IF(LEN.GT.0.AND.NAME_DER(1:1).NE.' '.AND.NAME_DER(1:1).NE.',') 
     * DER = 'Y'

      IF(DIFF.EQ.'H') THEN
        IF(DER.EQ.'N') THEN
          CALL MSGDOC(MD0,'--- calc !F(+)-F(-)! ---')
        ELSE
          CALL MSGDOC(MD0,'--- calc !Fder-Fobs! ---')
        ENDIF
        WRITE(LINE,'('' Resolution              :'',2F8.2)') 
     *  RESMIN,RESMAX
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'('' Boff,Badd               :'',2F8.2)')
     *  BOFF,BADD
        CALL MSGDOC(MD,LINE)
        WRITE(LINE,'('' Boff_scl,Badd_scl       :'',2F8.2)')
     *  BOFF_SCL,BADD_SCL
        CALL MSGDOC(MD,LINE)

        MMMD = MDOC

      ENDIF
C --------------------------------------
      NEL2 = 0
      SCL  = 'N'
      CALL LENSTR_BL(NAME2,LEN)
      IF(LEN.GT.0.AND.NAME2(1:1).NE.' '.AND.NAME2(1:1).NE.',') THEN
        SCL = 'Y'
        CALL MSGDOC(M,'--- generate density for model_2 ---')
        RAD   = 0.0
        H2OBG = 0.0
        BADDD = 0.0
        P1    = 'N' 
        NX    = 0
        NY    = 0
        NZ    = 0
        IZMAX =-1
        IZMIN = 0
        MODE  = ' '
        TTT   = ' '
        IERR  = 0
        ZFADD = 0.0

        MMM = M
        IF(LIST.EQ.'T') MMM = MDOC

        CALL GENDEN(MMM,NAME2,NAMED,TTT
     *  ,RESMAX,NX,NY,NZ,IZMIN,IZMAX,MODE,RAD,H2OBG,BADDD,P1,ZFADD
     *  ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
C        NEL - RESULT(1)
        NEL2 = RESULT(1,1)
C ---------------------------------------
        CALL MSGDOC(M,'--- real fft for model_2 ---')

        MMM = M
        IF(LIST.EQ.'T') THEN
          MMM = MDOC
          WRITE(*,*) '-DER:',DER           
          WRITE(*,*) '-S:',NAMED
          WRITE(*,*) '-F:',NAMEF2
          WRITE(*,*) '-P:',NAMEPH2
        ENDIF

        CALL RFFT(MMM,RESMAX
     *   ,NAMED,NAMEF2,NAMEPH2,PATH_SCR,ISYM,IPRSYM,RESULT
     *   ,IERR)
        IF(IERR.NE.0) GO TO 900

      ENDIF
C ---------------------------------------
      CALL MSGDOC(M,'--- scaling ---')

      NAMES = NAMEF2
      IF(DIFF.EQ.'H'.AND.DER.EQ.'Y') THEN
         NAMES = NAME_DER
         SCL = 'Y'
      ENDIF

      IF(SCL.EQ.'Y') THEN

        SOLV  = 'N'
        SCALE = 1.0
        BOVER = 0.0
        NCYCL = 0

        MMM = M
        IF(LIST.EQ.'T') THEN
          MMM = MDOC
          WRITE(*,*) '-S:',NAMES
          WRITE(*,*) '-FS:',NAMEFM2
          WRITE(*,*) '-F:',NAMEF
        ENDIF

        RESMNI = RESMIN
        RESMXI = RESMAX

        IF(ANISO.EQ.'K') THEN
          SCALE  = 0.0
          BOVER  = 0.0
        ENDIF
        ACORR = 'N'

        CALL MR_SCALING(MMM,LIST,NAMEF,NAMES,NAMEFM2,PATH_SCR
     * ,ANISO,SCALE,BOVER,ACORR,BOFF_SCL,BADD_SCL,RESMNI,RESMXI
     * ,SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF
     * ,RESULT,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
C ---------------------------------------------------------
C     1. ACORR # N - anisothermal correction of Fmod
c        if ANISO = '-' return
C     2. ANISO = K - FSCALE with SCALEP,BSCALE
C                   if scale = 0 - scaling by Fobs (cell must be the same)
C                      only scale , set BOVER = 0
C                   if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                  no info: rfac, corr
C        else  CALL PSCALE
C      output: SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF and NAMEFM2
C ---------------------------------------------------------

        WRITE(LINE,'('' scale,B_scale :'',2F8.3)') 
     *   SCALEP_NEW,BSCALE_NEW
        CALL MSGDOC(MMM,LINE)

      ENDIF

      IF(DIFF.EQ.'P'.OR.
     *   (DIFF.EQ.'H'.AND.FUN.NE.'D')) THEN
C       Fnew    =  !  F     -   F2   * percent_2 !
C      namef_n      namef    namefm2
C 

        IF(DIFF.EQ.'P') THEN
          CALL MSGDOC(MD0,'---  Inew = ! Iobs - I2* percent_2 ! ---')
        ELSE IF(DER.EQ.'N') THEN
          CALL MSGDOC(MD0,'---  Fnew = !F(+)-F(-)! ---')
        ELSE
          CALL MSGDOC(MD0,'---  Fnew = ! Fobs - F2* percent_2 ! ---')
        ENDIF

        NAMES = NAMEFM2
        IF(DIFF.EQ.'H') THEN
          PERCENT_2 = 1 
          IF(DER.EQ.'N') NAMES = ' '
        ENDIF

        SCALEF   = PERCENT_2
        IERR = 0
        IF(DIFF.EQ.'P') THEN
          IERR =-1
          SCALEF   = PERCENT_2*PERCENT_2
        ENDIF

        CALL FMINUSF(M,NAMEF,NAMES,NAMEF_N,SCALEF
     *        ,ISYM,IPRSYM,RESULT,IPRMAX,IERR)
        IF(IERR.NE.0) GO TO 900

      ELSE IF(DIFF.EQ.'D') THEN
C       Fnew_vector    =    F     -   F2   * percent_2 
C        namef_n           namef    namefm2

        CALL MSGDOC(MD0
     *  ,'--- Fnew_vector = Fobs - F2 * percent_2 ---')

        IF(PRF.NE.'N') NAME_PH = NAMEPH2

        ISIM     = 0
        LAP      = 'N'
        FOMMIN   = 0.0
        MSGA     = 'N'
        BOFFF    = 0.
        BADDD    = 0.0
        SLIM     = 0.0
        DRMS     = 0.0
        DRMS_A   = 0.0
        DEL_LIM  = 0.0
        DELA_LIM = 0.0

C ????
C       SCALEF   = 1.0/PERCENT_2
C
        SCALEF   = PERCENT_2
C
C          SCALE * F2 - F1
C                        F1     F2 
        CALL COEF_FFT2(M,NAMEF,NAMEFM2,NAMEPH2,NAMEF_N
     *         ,FOMMIN,RESMIN,RESMAX,BOFFF,SLIM
     *         ,DEL_LIM,DELA_LIM,DRMS,DRMS_A,LAP
     *         ,SCALEF,BADDD,MSGA,ISIM,ISYM,IPRSYM,RESULT,IERR)
        IF(IERR.NE.0) GO TO 900

      ELSE IF(DIFF.EQ.'F') THEN
C       Fnew_vector    =    F  *Ph   -   F2   * percent_2 *Ph_mod2
C        namef_n         namef name_ph   namefm2           nameph2

        CALL MSGDOC(MD0,
     *  '--- Fnew_vector = Fobs* Phobs - F2*percent_2*Ph_mod2 ---')


        SCALEF   = -PERCENT_2
        BOFFF    = 0.0
        BADDD    = 0.0
        MSGA     = 'A'
        FO_NAME  = 'molrp_scr'
        CALL ADD_PATH(PATH_SCR,FO_NAME)
        PHO_NAME = 'molrp_scr1'
        CALL ADD_PATH(PATH_SCR,PHO_NAME)
       
C  !!!  INVER       
        DO I=1,3
          SH1(I) = 0.0
        ENDDO
        CALL SFVSUM(M,MSGA,SCALEF,INVER
     *    ,NAMEF,NAME_PH,NAMEFM2,NAMEPH2,FO_NAME,PHO_NAME
     *    ,SH1,BOFFF,BADDD,RESMIN,RESMAX,ISYM,IPRSYM,RESULT,IPRMAX,IERR)
        IF(IERR.NE.0) GO TO 900

        ISIM     = 0
        LAP      = 'N'
        FOMMIN   = 0.0
        MSGA     = 'N'
        BOFFF    = 0.0
        BADDD    = 0.0
        SLIM     = 0.0
        DRMS     = 0.0
        DRMS_A   = 0.0
        DEL_LIM  = 0.0
        DELA_LIM = 0.0
        SCALEF   = 1.0
        NAMES    = ' '
C
C          SCALE * F2 - F1
C                        F1     F2 
        CALL COEF_FFT(M,FO_NAME,NAMES,PHO_NAME,NAMEF_N
     *         ,FOMMIN,RESMIN,RESMAX,BOFFF,SLIM
     *         ,DEL_LIM,DELA_LIM,DRMS,DRMS_A,LAP
     *         ,SCALEF,BADDD,MSGA,ISIM,ISYM,IPRSYM,RESULT,IERR)
        IF(IERR.NE.0) GO TO 900

      ELSE IF(DIFF.EQ.'H') THEN

        ISIM     = 0
        LAP      = 'N'
        FOMMIN   = 0.0
        MSGA     = 'N'
        BOFFF    = BOFF
        BADDD    = BADD
        SLIM     = 1.0
        DRMS     = 0.0
        DRMS_A   = 0.0
        DEL_LIM  = 0.0
        DELA_LIM = 0.0
        SCALEF   = 1.0
        NAMES    = ' '
        NAMES    = NAMEFM2
        IF(DER.EQ.'N') THEN
          MSGA  = 'Y'          
          NAMES = ' '
        ENDIF
        
        IF(LIST.EQ.'T') THEN
          WRITE(*,*) '-DER,MSGA:',DER,MSGA
          WRITE(*,*) '-S:',NAMEFM2
          WRITE(*,*) '-P:',NAMEPH2
          WRITE(*,*) '-F:',NAMEF
        ENDIF

        NAME_SCR  = 'molrp_scr'
        CALL ADD_PATH(PATH_SCR,NAME_SCR)
        NAME_SCR1 = 'molrp_scr1'
        CALL ADD_PATH(PATH_SCR,NAME_SCR1)
C
C          SCALE * F2 - F1
C                        F1     F2
        MMM = M
        IF(LIST.EQ.'L'.OR.LIST.EQ.'T') MMM = MD 

        CALL COEF_FFT(MMM,NAMEF,NAMES,NAMEPH2,NAME_SCR
     *         ,FOMMIN,RESMIN,RESMAX,BOFFF,SLIM
     *         ,DEL_LIM,DELA_LIM,DRMS,DRMS_A,LAP
     *         ,SCALEF,BADDD,MSGA,ISIM,ISYM,IPRSYM,RESULT,IERR)
        IF(IERR.NE.0) GO TO 900

        F0     =-1.0
        IZMIN  = 0
        IZMAX  =-1
        NX     = 0
        NY     = 0
        NZ     = 0

        CALL FFT(M,NX,NY,NZ,IZMIN,IZMAX,F0,NAME_SCR
     *  ,NAME_SCR1,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
C ---
        ALEVEL   = 0.0
        NAMES    = ' '
        NPMAX    = 30
        DIST_LIM = 0.0
        SPEC     = 'Y'

        MMM      = MDOC

        CALL PEAKSRCH(MMM,NAME_SCR1,NAMES,ALEVEL,DIST_LIM,SPEC,NPMAX
     *     ,ISYM,IPRSYM,RESULT,IPRMAX,IPRROW,IERR)
        IF(IERR.NE.0) GO TO 900

      ENDIF
C ------------------------------------------------
 900  CONTINUE

      NAMES='trfn_scr.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_scr1.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='molrp_scratch_rft'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='molrp_scratch_rdc.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)

      RETURN
      END

C                                             mod1   mod2  scrF    out      
      SUBROUTINE TR_TEST_2S(MDOC,LIST,MODE_D,NAMEC,NAME2,NAMES
     *  ,NAMET_OUT
     *  ,NAMEF,NAME_FCALC,NAME_PHCALC,PATH_SCR
     *  ,NP,NUM_MON,PST,VPST
     *  ,RMAX_PK,RMIN_PK,SIGMA
     *  ,BOFF_SCL,BADD_SCL
     *  ,RESMIN_OUT,ANISO,SCALE,BOVER
     *  ,IPK_RF,ALPHA,BETA,GAMMA,TEST,PEAK_TEST,IPT_MIN
     *  ,POOL_SCR,MEMORY_SCR
     *  ,RESULT,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
C --------------------------------------------------------------------
      REAL      POOL_SCR(*)
      INTEGER*2 ISYM(5,3,IPRSYM)

      CHARACTER NAMEF*(*),NAME_FCALC*(*),NAME_PHCALC*(*)
      CHARACTER NAMES*(*),NAMEC*(*),NAME2*(*),NAMET_OUT*(*),TEST*1
      CHARACTER PATH_SCR*(*),ANISO*1

c      INTEGER*2 JHS(IPRSYM),JKS(IPRSYM),JLS(IPRSYM),IGSYM(IPRSYM)
c      REAL      SFA(IPRSYM),SFB(IPRSYM)
c      REAL      SFA2(IPRSYM),SFB2(IPRSYM)

      integer*2,   allocatable :: JHS(:)
      integer*2,   allocatable :: JKS(:)
      integer*2,   allocatable :: JLS(:)
      integer*2,   allocatable :: IGSYM(:)
      real,        allocatable :: SFA(:)
      real,        allocatable :: SFB(:)
      real,        allocatable :: SFA2(:)
      real,        allocatable :: SFB2(:)

      REAL      FOBS2,FOBSB,VPST(3)
      REAL      RLATT(6),SH1(3),SH2(3),AM(3,3),SHF(3)
      REAL      RESULT(IPRMAX,IPRROW),PEAK_TEST(12,*)
      CHARACTER LINE*256,PATH*80,EXT*3,MSG2*1,MOD2*1,PACK_GRP*1

      CHARACTER NAMEO*256,NAMET*256,NAMECT*256,TITLE*80

      CHARACTER MODE*1,MODE_D*1,CH2*2,CH3*3,PST*1,CH6*6
      CHARACTER ITYPE*4,ITYPEF*4,ITYPEP*4,LIST*1
C ------------------------------------------------------------
C ----------------------------------
      INCLUDE 'molrep_lh_infor.fh'
C      COMMON/COM_LH_INFOR/ BOFF_LH,BADD_LH,BOFF_FOR_SCAL
C     *   ,CHECK_CONTRAST,CONTRAST_LIM
C     *   ,BCORR_LH,FILE_FOBS_LH,SCORE_FLAG,LH_LH,DB_LH
CC ---
C      REAL      CHECK_CONTRAST,CONTRAST_LIM
C      REAL      BOFF_FOR_SCAL,BOFF_LH,BADD_LH,BCORR_LH
C      CHARACTER LH_LH*1,SCORE_FLAG*1,DB_LH*1
C      CHARACTER FILE_FOBS_LH*256
C ----------------------------------
      COMMON/TRFUN_COM_TMP/ FOBS_000,FMOD1_000,FMOD2_000,NEL2,IERR_PK
     *                     ,SCALEP_STORE,BOVER_STORE,SIGMA_STORE
C ----
      PARAMETER ( IPRROWA =51  )
C ----
      REAL      RESULTA(IPRROWA,51)
C     PARAMETER ( IPRCYCL = 50  )
      PARAMETER ( IPRCYCL = 200 )
      REAL      CORR(IPRCYCL),RFAC(IPRCYCL),SCR_SORT(IPRCYCL)
C =====================================================================
      IFIRST_RUN = 0
      IF(IERR.LT.0) IFIRST_RUN = 1
      PI    = 4.0*ATAN(1.0)
      TWOPI = 2.0*PI
      MD    =-ABS(MDOC)-1
      M     = 99
      IERR  = 0
      IF(LIST.EQ.'T') THEN
        MD = MDOC
      ENDIF
C -----------------------------------
      IT = 0
      allocate(JHS(1:IPRSYM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(JKS(1:IPRSYM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(JLS(1:IPRSYM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(IGSYM(1:IPRSYM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(SFA(1:IPRSYM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(SFB(1:IPRSYM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(SFA2(1:IPRSYM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(SFB2(1:IPRSYM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      IF(IT.GT.0) THEN
        IERR = 1
        CALL MSGERR(MDOC,
     *    ' ERROR: in  TR_TEST_2: problem with memory allocation')
        CALL MSGERR(MDOC,
     *    '                       try to change resolution')
        RETURN
      ENDIF
c -------------------------------
c RSQ.LT.0.0  end of scratch_array
c FLH = RSQ
c MODE.NE.'D'
c  FOBS2  fobs
c  FOBSB   0
c  FOBS2.LT.0.0 missing (-1.0) out_resmin (-2.0)
c  LH.EQ.'Y'.OR.LH.EQ.'V'.OR.LH.EQ.'2' use FLH
c MODE.EQ.'D'
c  FOBS2  cos
c  FOBSB  sin
c  FOBS2 = FOBSB = 0 missing or out_resmin
c  FLH = 0
c -------------------------------
      SHF(1) = 0.0
      SHF(2) = 0.0
      SHF(3) = 0.0
      IF(NP.LE.0) NP=1
      IF(NP.GT.IPRCYCL) NP=IPRCYCL
C ---
      NAMEO = NAMET_OUT
C ---
      MOD2 = 'N'
      CALL LENSTR_BL(NAME2,LEN)
      IF(LEN.GT.0.AND.NAME2(1:1).NE.' '.AND.NAME2(1:1).NE.',')
     * MOD2 = 'Y'
C ---
      CALL LENSTR_BL(NAMES,LEN)
      IF(LEN.LE.0.OR.NAMES(1:1).EQ.' '.OR.NAMES(1:1).EQ.',') THEN
        
      ELSE

        MTS  = 18
        IERR = 0
        PATH = ' '
        EXT  = ' '
        CALL OPENUW(MTS,M,PATH,NAMES,EXT,IERR)
        IF(IERR.GT.0) THEN
          CALL MSGERR(MDOC,
     *    ' ERROR: in TEST_2: can not open SCRATCH-FILE')
          deallocate(JHS,STAT=ISTAT)
          deallocate(JKS,STAT=ISTAT)
          deallocate(JLS,STAT=ISTAT)
          deallocate(IGSYM,STAT=ISTAT)
          deallocate(SFA,STAT=ISTAT)
          deallocate(SFB,STAT=ISTAT)
          deallocate(SFA2,STAT=ISTAT)
          deallocate(SFB2,STAT=ISTAT)
          RETURN
        ENDIF
C --
        READ(MTS,END=120) MODE_WRT,(RLATT(L),L=1,6),RESMIN,RESMAX
     *  ,NSYM,BETMINR,BETMAXR,PERC1,PERC2

        CALL DSTARF(RLATT,AST,BST,CST,COALST,COBEST,COGAST,VOL)

        IND_SCR = 0
        POOL_SCR(IND_SCR + 1) = MODE_WRT + 0.1
        IND_SCR = IND_SCR + 1
        DO L=1,6
          POOL_SCR(IND_SCR + 1) = RLATT(L)  
          IND_SCR = IND_SCR + 1
        ENDDO
        POOL_SCR(IND_SCR + 1) = RESMIN
        IND_SCR = IND_SCR + 1
        POOL_SCR(IND_SCR + 1) = RESMAX
        IND_SCR = IND_SCR + 1
        POOL_SCR(IND_SCR + 1) = NSYM + 0.1
        IND_SCR = IND_SCR + 1
        POOL_SCR(IND_SCR + 1) = BETMINR
        IND_SCR = IND_SCR + 1
        POOL_SCR(IND_SCR + 1) = BETMAXR
        IND_SCR = IND_SCR + 1
        POOL_SCR(IND_SCR + 1) = PERC1
        IND_SCR = IND_SCR + 1
        POOL_SCR(IND_SCR + 1) = PERC2
        IND_SCR = IND_SCR + 1

c        PERC1 = PERC1/100.0
c        PERC2 = PERC2/100.0
  
 130    CONTINUE

        IF(MODE_WRT.EQ.1) THEN
          MTEST = IND_SCR + 3 + NSYM*8 + 1
        ELSE
          MTEST = IND_SCR + 3 + NSYM*6 + 1
        ENDIF

        IF(MTEST.GT.MEMORY_SCR) THEN
          WRITE(LINE,
     *  '('' ERROR: TEST_2: not memory enough for scratch_array: '')')
          CALL MSGERR(MDOC,LINE)
          CALL MSGERR(MDOC,
     *    '                 try to change resolution')
          IERR = 1
          IF(MTS.GT.0)   CLOSE(MTS)
          deallocate(JHS,STAT=ISTAT)
          deallocate(JKS,STAT=ISTAT)
          deallocate(JLS,STAT=ISTAT)
          deallocate(IGSYM,STAT=ISTAT)
          deallocate(SFA,STAT=ISTAT)
          deallocate(SFB,STAT=ISTAT)
          deallocate(SFA2,STAT=ISTAT)
          deallocate(SFB2,STAT=ISTAT)
          RETURN
        ENDIF

        IF(MODE_WRT.EQ.1) THEN

          READ(MTS,END=120)
     *    RSQ,FOBS2,FOBSB,(JHS(L),JKS(L),JLS(L)
     *   ,IGSYM(L),SFA(L),SFB(L),SFA2(L),SFB2(L),L=1,NSYM)

          POOL_SCR(IND_SCR + 1) = RSQ
          IND_SCR = IND_SCR + 1
          POOL_SCR(IND_SCR + 1) = FOBS2
          IND_SCR = IND_SCR + 1
          POOL_SCR(IND_SCR + 1) = FOBSB
          IND_SCR = IND_SCR + 1

          DO L=1,NSYM
            POOL_SCR(IND_SCR + 1) = JHS(L)   + 1000.1 
            IND_SCR = IND_SCR + 1
            POOL_SCR(IND_SCR + 1) = JKS(L)   + 1000.1  
            IND_SCR = IND_SCR + 1
            POOL_SCR(IND_SCR + 1) = JLS(L)   + 1000.1 
            IND_SCR = IND_SCR + 1
            POOL_SCR(IND_SCR + 1) = IGSYM(L) + 1000.1 
            IND_SCR = IND_SCR + 1
            POOL_SCR(IND_SCR + 1) = SFA(L)
            IND_SCR = IND_SCR + 1
            POOL_SCR(IND_SCR + 1) = SFB(L) 
            IND_SCR = IND_SCR + 1
            POOL_SCR(IND_SCR + 1) = SFA2(L)
            IND_SCR = IND_SCR + 1
            POOL_SCR(IND_SCR + 1) = SFB2(L)
            IND_SCR = IND_SCR + 1
          ENDDO

        ELSE
          READ(MTS,END=120)
     *    RSQ,FOBS2,FOBSB,(JHS(L),JKS(L),JLS(L)
     *   ,IGSYM(L),SFA(L),SFB(L),L=1,NSYM)

          POOL_SCR(IND_SCR + 1) = RSQ
          IND_SCR = IND_SCR + 1
          POOL_SCR(IND_SCR + 1) = FOBS2
          IND_SCR = IND_SCR + 1
          POOL_SCR(IND_SCR + 1) = FOBSB
          IND_SCR = IND_SCR + 1
          DO L=1,NSYM
            POOL_SCR(IND_SCR + 1) = JHS(L)   + 1000.1 
            IND_SCR = IND_SCR + 1
            POOL_SCR(IND_SCR + 1) = JKS(L)   + 1000.1 
            IND_SCR = IND_SCR + 1
            POOL_SCR(IND_SCR + 1) = JLS(L)   + 1000.1 
            IND_SCR = IND_SCR + 1
            POOL_SCR(IND_SCR + 1) = IGSYM(L) + 1000.1 
            IND_SCR = IND_SCR + 1
            POOL_SCR(IND_SCR + 1) = SFA(L)
            IND_SCR = IND_SCR + 1
            POOL_SCR(IND_SCR + 1) = SFB(L) 
            IND_SCR = IND_SCR + 1
          ENDDO

        ENDIF

        GO TO 130

 120    CONTINUE

        POOL_SCR(IND_SCR + 1) = -1.0
        IND_SCR               = IND_SCR + 1

        IF(MTS.GT.0)   CLOSE(MTS)
C --
      ENDIF
C -----------------------------------
      IPK       = 0
      SCR_SORT_TOT = -1.5
      CORR_TOT  = -1.5
      SCORE_TOT = CORR_TOT
      IPK_BEST  = 0
      CRRR_BEST = 0.0
      AVER      = 0.0
      AVER2     = 0.0
      NAVER     = 0

c      BOFF_SCL = bBOFF_SCL
c      BOFF_SCL = 0.0
c      BADD_SCL =0.0

      IF(LIST.EQ.'T') THEN
        write(*,*) 'np,MODE_D:',np,MODE_D
        write(*,*) 'BOFF_SCL,BADD_SCL:',BOFF_SCL,BADD_SCL
        write(*,*) 'resmin_out,aniso',resmin_out,aniso
        WRITE(*,*) 'scl,bover:',SCALEP_STORE,BOVER_STORE
        WRITE(*,'('' PERC 1,2 :'',2F8.3)') PERC1,PERC2
      ENDIF

 800  CONTINUE

      IPK = IPK + 1

      IF(LIST.EQ.'T') THEN
C      CALL MSGDOC(MD,' ')
       WRITE(LINE,'(''---- peak number :'',I5)') IPK
       CALL MSGDOC(MD,LINE)
C      CALL MSGDOC(MD,' ')
      ENDIF

      SH1(1) = RESULT(IPK, 9)
      SH1(2) = RESULT(IPK,10)
      SH1(3) = RESULT(IPK,11)

ccccc
      IF(LIST.EQ.'T') THEN
        WRITE(LINE,'('' Shift :'',3F8.3)') SH1(1),SH1(2),SH1(3)
        CALL MSGDOC(MDoc,LINE)
      ENDIF
ccccc

c      WRITE(*,*)RESULT(IPK,2),RESULT(IPK,3),RESULT(IPK,4),RESULT(IPK,5)
c      WRITE(*,*)  RESULT(IPK,9),RESULT(IPK,10),RESULT(IPK,11)

C --- scaling ---

C ---

c      READ(MTS,END=100) MODE_WRT,(RLATT(L),L=1,6),RESMIN,RESMAX
c     * ,NSYM,BETMINR,BETMAXR,PERC1,PERC2

      IND_SCR   = 0
      MODE_WRT  = POOL_SCR(IND_SCR + 1) 
      IND_SCR   = IND_SCR + 1
      DO L=1,6
        RLATT(L)     = POOL_SCR(IND_SCR + 1)   
        IND_SCR      = IND_SCR + 1
      ENDDO
      RESMIN     = POOL_SCR(IND_SCR + 1) 
      IND_SCR    = IND_SCR + 1
      RESMAX     = POOL_SCR(IND_SCR + 1) 
      IND_SCR    = IND_SCR + 1
      NSYM       = POOL_SCR(IND_SCR + 1)
      IND_SCR    = IND_SCR + 1
      BETMINR    = POOL_SCR(IND_SCR + 1) 
      IND_SCR    = IND_SCR + 1
      BETMAXR    = POOL_SCR(IND_SCR + 1) 
      IND_SCR    = IND_SCR + 1
      PERC1      = POOL_SCR(IND_SCR + 1) 
      IND_SCR    = IND_SCR + 1
      PERC2      = POOL_SCR(IND_SCR + 1)
      IND_SCR    = IND_SCR + 1

      CALL DSTARF(RLATT,AST,BST,CST,COALST,COBEST,COGAST,VOL)

c      PERC1 = PERC1/100.0
c      PERC2 = PERC2/100.0

c     REWIND MTS
      IND_SCR    = 0

ccccc
      IF(LIST.EQ.'T') THEN
       WRITE(*,*) '>>>',RESMIN,RESMAX,BETMINR,BETMAXR
     * ,MODE_WRT,RLATT(1),RLATT(2)
     * ,RLATT(3),RLATT(4),RLATT(5),RLATT(6)
     * ,RESMIN,RESMAX,NSYM,BETMINR,BETMAXR,PERC1,PERC2
      ENDIF
cccccc

c      BETMIN = 256.
c      BETMAX = 0.0

      BETMIN = BETMINR
      BETMAX = BETMAXR

      MSG2 = '2'
      IF(MODE_WRT.EQ.0) MSG2 = 'N'

      IF(IPK.EQ.1) THEN

c       version with const scaling
c        IF(IPK_RF.EQ.1) THEN
c          IF(ANISO.NE.'K') THEN
c            SCALEP = SCALEP_STORE
c            BOVER  = BOVER_STORE
c          ELSE
c            SCALEP = 1.0
c            BOVER  = 0.0
c          ENDIF
c        ELSE
c          SCALEP = SCALEP_STORE
c          BOVER  = BOVER_STORE
c        ENDIF

c       version - always scaling
        SCALEP = 1.0
        BOVER  = 0.0
        CALL SCALE_PATT_TR(MDOC,POOL_SCR,MODE_D,MODE_WRT
     *      ,NSYM,MSG2
     *      ,JHS,JKS,JLS,IGSYM,SFA,SFB,SFA2,SFB2,SH1,PERC1,PERC2
     *      ,PST,VPST,BOFF_SCL,BADD_SCL,SCALEP,BOVER
     *      ,RESMIN,RESMAX,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          deallocate(JHS,STAT=ISTAT)
          deallocate(JKS,STAT=ISTAT)
          deallocate(JLS,STAT=ISTAT)
          deallocate(IGSYM,STAT=ISTAT)
          deallocate(SFA,STAT=ISTAT)
          deallocate(SFB,STAT=ISTAT)
          deallocate(SFA2,STAT=ISTAT)
          deallocate(SFB2,STAT=ISTAT)
          GO TO 900
        ENDIF
cccccccc
c        write(*,*) BOFF_SCL,BADD_SCL
c        write(*,*) 'resmin_out',resmin_out
c        WRITE(*,*) 'scl,bover:',ipk,scalep,bover
ccccccc

C --- scaling ---

C ---
c        READ(MTS,END=100) MODE_WRT,(RLATT(L),L=1,6),RESMIN,RESMAX
c     *  ,NSYMR,BETMINR,BETMAXR,PERC1R,PERC2R
        IND_SCR   = 0
        MODE_WRT  = POOL_SCR(IND_SCR + 1) 
        IND_SCR   = IND_SCR + 1
        DO L=1,6
          RLATT(L)     = POOL_SCR(IND_SCR + 1)   
          IND_SCR      = IND_SCR + 1
        ENDDO
        RESMIN     = POOL_SCR(IND_SCR + 1) 
        IND_SCR    = IND_SCR + 1
        RESMAX     = POOL_SCR(IND_SCR + 1) 
        IND_SCR    = IND_SCR + 1
        NSYMR      = POOL_SCR(IND_SCR + 1)
        IND_SCR    = IND_SCR + 1
        BETMINR    = POOL_SCR(IND_SCR + 1) 
        IND_SCR    = IND_SCR + 1
        BETMAXR    = POOL_SCR(IND_SCR + 1) 
        IND_SCR    = IND_SCR + 1
        PERC1R     = POOL_SCR(IND_SCR + 1) 
        IND_SCR    = IND_SCR + 1
        PERC2R     = POOL_SCR(IND_SCR + 1)
        IND_SCR    = IND_SCR + 1

C ---
        SF1   = 0.0
        SF2   = 0.0
        SF12  = 0.0
        SF22  = 0.0
        SF1F2 = 0.0
        SDEL  = 0.0
        NTOT  = 0
C -------
  200   CONTINUE
C --
C       h = (IHN,IKN,ILN), Fobs(h)=FOBS2,FOBSB
C       JHS,JKS,JLS = h[Aj]
C       SFA,SFB   : G1j(h) = Fm1(h[Aj])*EXP[2PIi*h*Dj]
C       SFA2,SFB2 : G2j(h) = Fm2(h[Aj])*EXP[2PIi*h*Dj]
C
C --
        RSQ = POOL_SCR(IND_SCR + 1) 
        IF(RSQ.LT.0.0) GO TO 100

        IF(MODE_WRT.EQ.1) THEN

C          READ(MTS,END=100)
C     *    RSQ,FOBS2,FOBSB,(JHS(L),JKS(L),JLS(L)
C     *   ,IGSYM(L),SFA(L),SFB(L),SFA2(L),SFB2(L),L=1,NSYM)
          RSQ     = POOL_SCR(IND_SCR + 1) 
          IND_SCR = IND_SCR + 1
          FOBS2   = POOL_SCR(IND_SCR + 1)
          IND_SCR = IND_SCR + 1
          FOBSB   = POOL_SCR(IND_SCR + 1)
          IND_SCR = IND_SCR + 1
          DO L=1,NSYM
            JHS(L)   = POOL_SCR(IND_SCR + 1)  
            JHS(L)   = JHS(L) - 1000
            IND_SCR  = IND_SCR + 1
            JKS(L)   = POOL_SCR(IND_SCR + 1) 
            JKS(L)   = JKS(L) - 1000
            IND_SCR  = IND_SCR + 1
            JLS(L)   = POOL_SCR(IND_SCR + 1)  
            JLS(L)   = JLS(L) - 1000
            IND_SCR  = IND_SCR + 1
            IGSYM(L) = POOL_SCR(IND_SCR + 1) 
            IGSYM(L) = IGSYM(L) - 1000
            IND_SCR  = IND_SCR + 1
            SFA(L)   = POOL_SCR(IND_SCR + 1) 
            IND_SCR  = IND_SCR + 1
            SFB(L)   = POOL_SCR(IND_SCR + 1)  
            IND_SCR  = IND_SCR + 1
            SFA2(L)  = POOL_SCR(IND_SCR + 1)
            IND_SCR  = IND_SCR + 1
            SFB2(L)  = POOL_SCR(IND_SCR + 1)
            IND_SCR  = IND_SCR + 1
          ENDDO

        ELSE

C          READ(MTS,END=100)
C     *    RSQ,FOBS2,FOBSB,(JHS(L),JKS(L),JLS(L)
C     *   ,IGSYM(L),SFA(L),SFB(L),L=1,NSYM)
          RSQ     = POOL_SCR(IND_SCR + 1) 
          IND_SCR = IND_SCR + 1
          FOBS2   = POOL_SCR(IND_SCR + 1)
          IND_SCR = IND_SCR + 1
          FOBSB   = POOL_SCR(IND_SCR + 1)
          IND_SCR = IND_SCR + 1
          
          DO L=1,NSYM
            JHS(L)   = POOL_SCR(IND_SCR + 1)
            JHS(L)   = JHS(L) - 1000
            IND_SCR  = IND_SCR + 1
            JKS(L)   = POOL_SCR(IND_SCR + 1)
            JKS(L)   = JKS(L) - 1000
            IND_SCR  = IND_SCR + 1
            JLS(L)   = POOL_SCR(IND_SCR + 1)
            JLS(L)   = JLS(L) - 1000
            IND_SCR  = IND_SCR + 1
            IGSYM(L) = POOL_SCR(IND_SCR + 1) 
            IGSYM(L) = IGSYM(L) - 1000
            IND_SCR  = IND_SCR + 1
            SFA(L)   = POOL_SCR(IND_SCR + 1) 
            IND_SCR  = IND_SCR + 1
            SFB(L)   = POOL_SCR(IND_SCR + 1)  
            IND_SCR  = IND_SCR + 1
          ENDDO

        ENDIF
c
c      write(*,*) '>',ntot,JHS(1),JKS(1),JLS(1),fobs2
c

        IF(MODE_D.EQ.'D') THEN
          FOBS2 = FOBS2*FOBS2+FOBSB*FOBSB
        ENDIF
        
        IF(FOBS2.LT.0.0) GO TO 200

        IHN    = JHS(1)
        IKN    = JKS(1)
        ILN    = JLS(1)
        CALL DSTAR(IHN,IKN,ILN,RSQ)

C ---
c        T = 1.0
c        IF(BETMIN.GT.0.01) THEN
c          T = (1.0- EXP(-BETMIN*0.25*RSQ))
c        ENDIF
c        TEMP = EXP(-BETMAX*0.25*RSQ)*T 
        T = 1.0
        IF(BOFF_SCL.GT.0.01) THEN
          T = (1.0- EXP(-BOFF_SCL*0.25*RSQ))
        ENDIF
        TEMP = EXP(-BADD_SCL*0.25*RSQ)*T 
C ---
        FA1S  = 0.0
        FB1S  = 0.0
        FA2S  = 0.0
        FB2S  = 0.0
        NGEN  = 0

        DO  I=1,NSYM

          IF(IGSYM(I).NE.0) NGEN = NGEN + 1

          IHS  = JHS(I)  
          IKS  = JKS(I) 
          ILS  = JLS(I) 

          FA1  = SFA(I) 
          FB1  = SFB(I)
          ARG  = IHS*SH1(1)+IKS*SH1(2)+ILS*SH1(3)
          ARG  = ARG * TWOPI
          COSD = COS(ARG)
          SIND = SIN(ARG)
          FA11 = FA1*COSD-FB1*SIND
          FB11 = FA1*SIND+FB1*COSD

          FA1S = FA1S + FA11
          FB1S = FB1S + FB11

          IF(PST.EQ.'Y') THEN
            ARG   = TWOPI*(IHs*VPST(1)+IKs*VPST(2)+ILs*VPST(3))
            COSD  = COS(ARG)
            SIND  = SIN(ARG)
            FA1S22 = FA11*COSD-FB11*SIND
            FB1S22 = FB11*COSD+FA11*SIND
            FA1S  = FA1S + FA1S22
            FB1S  = FB1S + FB1S22
          ENDIF

          IF(MSG2.NE.'N') THEN
            FA2  = SFA2(I) 
            FB2  = SFB2(I) 
            FA2S = FA2S + FA2
            FB2S = FB2S + FB2
          ENDIF

        ENDDO

cc-        IF(MSG2.NE.'N') THEN
cc-          FA1S = FA1S*PERC1 + FA2S*PERC2 
cc-          FB1S = FB1S*PERC1 + FB2S*PERC2 
cc-        ENDIF

C ---
c        IF(PST.EQ.'Y') THEN
c          ARG   = TWOPI*(IHN*VPST(1)+IKN*VPST(2)+ILN*VPST(3))
c          COSD  = COS(ARG)
c          SIND  = SIN(ARG)
c          FA1S2 = FA1S*COSD-FB1S*SIND
c          FB1S2 = FB1S*COSD+FA1S*SIND
c          FA1S  = FA1S + FA1S2
c          FB1S  = FB1S + FB1S2
c        ENDIF
C ---
        IF(MSG2.NE.'N') THEN
          FA1S = FA1S*PERC1 + FA2S*PERC2 
          FB1S = FB1S*PERC1 + FB2S*PERC2 
        ENDIF

        IF(FOBS2.LE.0.0) GO TO 200

        FOBS = SQRT(FOBS2)*TEMP

        F22 = FA1S*FA1S + FB1S*FB1S
        F2  = SQRT(F22) * TEMP * EXP(-BOVER*0.25*RSQ) * SCALEP

c        if(ihn.eq.6.and.ikn.eq.4.and.iln.eq.2) then
c        write(*,*) '642>',ngen,fobs2,fobsb,fobs,f2,temp
c        write(*,*) 'rsq:',rsq,boff_scl,badd_scl        
c        endif


        NTOT = NTOT + 1

        SF1   = SF1   + FOBS      
        SF2   = SF2   + F2
        
c        SDEL  = sdel + abs(fobs-f2)

        SF12  = SF12  + FOBS*FOBS  
        SF22  = SF22  + F2*F2      

        GO TO 200
C ---
  100   CONTINUE
C       REWIND MTS
C --------------------------------------------
        SCALE = SCALEP
        IF(NTOT.GT.0) THEN
          SF1A   = SF1  /NTOT
          SF2A   = SF2  /NTOT
          SF12A  = SF12 /NTOT
          SF22A  = SF22 /NTOT
          SCALE_NEW = SQRT(SF12A/SF22A)
          SCALE     = SCALE_NEW * SCALEP
        ENDIF

c        rrr = sdel/sf1
c         WRITE(*,*) 'r:',rrr       
ccccc
c        WRITE(*,*) 'IPK_RF,IPK:',IPK_RF,IPK
c        WRITE(*,*) 'NTOT:',NTOT
c        WRITE(*,*) 's:',sf1a,sf2a,SCALE_NEW
c        WRITE(*,*) 's2', SF12A,SF22A,SCALE  
c --- scaling ---
c        WRITE(*,'('' PERC 1,2 :'',2F8.3)') PERC1,PERC2
      IF(LIST.EQ.'T') THEN
       WRITE(*,*) ' TR_TEST_2:scl_n,bover:',scale,bover
       WRITE(*,'('' F(000): '',3G12.4)') FOBS_000,FMOD1_000,FMOD2_000
      ENDIF
ccccc

      ENDIF

C --- corr ---

C ---
C      READ(MTS,END=110) MODE_WRT,(RLATT(L),L=1,6),RESMIN,RESMAX
C     * ,NSYMR,BETMINR,BETMAXR,PERC1R,PERC2R

      IND_SCR   = 0
      MODE_WRT  = POOL_SCR(IND_SCR + 1) 
      IND_SCR   = IND_SCR + 1
      DO L=1,6
        RLATT(L)     = POOL_SCR(IND_SCR + 1)   
        IND_SCR      = IND_SCR + 1
      ENDDO
      RESMIN     = POOL_SCR(IND_SCR + 1) 
      IND_SCR    = IND_SCR + 1
      RESMAX     = POOL_SCR(IND_SCR + 1) 
      IND_SCR    = IND_SCR + 1
      NSYMR      = POOL_SCR(IND_SCR + 1)
      IND_SCR    = IND_SCR + 1
      BETMINR    = POOL_SCR(IND_SCR + 1) 
      IND_SCR    = IND_SCR + 1
      BETMAXR    = POOL_SCR(IND_SCR + 1) 
      IND_SCR    = IND_SCR + 1
      PERC1R     = POOL_SCR(IND_SCR + 1) 
      IND_SCR    = IND_SCR + 1
      PERC2R     = POOL_SCR(IND_SCR + 1)
      IND_SCR    = IND_SCR + 1

      CALL DSTARF(RLATT,AST,BST,CST,COALST,COBEST,COGAST,VOL)

C ---
      SF1    = 0.0
      SF2    = 0.0
      SF12   = 0.0
      SF22   = 0.0
      SF1F2  = 0.0
c ---
C     for fix_mod
      SF2_FIX   = 0.0                  
      SF22_FIX  = 0.0             
      SF1F2_FIX = 0.0          
      CORR_FIX  = -3.0
      SD12_FIX  = 0.0
      SD2_FIX   = 0.0
c ---

      SI1    = 0.0
      SI2    = 0.0
      SI12   = 0.0
      SI22   = 0.0
      SI1I2  = 0.0

      SD12 = 0.0
      SD1  = 0.0
      SD2  = 0.0

      FM1000  = FMOD1_000
      FM2000  = FMOD2_000
      FOBS000 = FOBS_000
      FM000 = (FM1000*PERC1 + FM2000*PERC2)*SCALE 

      SDEL   = 0.0
      NTOT   = 0
      NBL   = 0
      NBL11 = 0
      IEND  =-1
      IEND1 =-1
      MTF   = 0
      MTPH  = 0

      CALL LENSTR_BL(NAME_FCALC,LEN)
      IF(LEN.GT.0.AND.NAME_FCALC(1:1).NE.' '.AND.
     *                NAME_FCALC(1:1).NE.',') THEN
        MTF   = 10
        ITYPE = '    '
        CALL ORFILE(M,MTF,NAMEF,ITYPE,NSM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          deallocate(JHS,STAT=ISTAT)
          deallocate(JKS,STAT=ISTAT)
          deallocate(JLS,STAT=ISTAT)
          deallocate(IGSYM,STAT=ISTAT)
          deallocate(SFA,STAT=ISTAT)
          deallocate(SFB,STAT=ISTAT)
          deallocate(SFA2,STAT=ISTAT)
          deallocate(SFB2,STAT=ISTAT)
          CALL MSGERR(MD,
     *    ' ERROR: can not open INPUT_Fobs_FILE (in TEST_2)')
          GO TO 900
        ENDIF
        CLOSE(MTF)
        CALL C_RD_CR

        CALL GET_TITLE(M,AAA,BBB,CCC,ALLL,BEEE,GAAA
     *  ,F1,F2,F3,F4,IDM,IDM,IDM,IDM,IDM,TITLE,IERR)

        CALL C_CR_WR
        TITLE(1:4) = 'F   '
        ITYPEF     = 'F   '
        TITLE(5:8) = 'CALC'
        F1         = 1.0
        F2         = 0.0
c        AL         = (RLATT(4)*180.0)/PI
c        BE         = (RLATT(5)*180.0)/PI
c        GA         = (RLATT(6)*180.0)/PI
        AL         = RLATT(4)
        BE         = RLATT(5)
        GA         = RLATT(6)

        NSM = NSYM

        CALL SET_TITLE(MD,RLATT(1),RLATT(2),RLATT(3)
     *    ,AL,BE,GA,F1,F2,RESMIN_OUT,RESMAX
     *    ,IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
        CALL OWFILE(MD,MTF,NAME_FCALC,ITYPEF,NSM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          deallocate(JHS,STAT=ISTAT)
          deallocate(JKS,STAT=ISTAT)
          deallocate(JLS,STAT=ISTAT)
          deallocate(IGSYM,STAT=ISTAT)
          deallocate(SFA,STAT=ISTAT)
          deallocate(SFB,STAT=ISTAT)
          deallocate(SFA2,STAT=ISTAT)
          deallocate(SFB2,STAT=ISTAT)
          CALL MSGERR(MDOC,' ERROR: open FILE-FCALC (in TEST_2)')
          RETURN
        ENDIF
        MTPH       = 11
        TITLE(1:4) = 'PH  '
        TITLE(5:8) = 'CALC'
        ITYPEP     = 'PH  '
        CALL SET_TITLE(MD,RLATT(1),RLATT(2),RLATT(3)
     *    ,AL,BE,GA,F1,F2,RESMIN_OUT,RESMAX
     *    ,IDM,IDM,IDM,IDM,IDM,TITLE,IERR)

        CALL LENSTR_BL(NAME_PHCALC,LEN)
        IF(LEN.LE.0.OR.NAME_PHCALC(1:1).EQ.' '.OR.
     *                  NAME_PHCALC(1:1).EQ.',') THEN
          CALL MSGERR(MDOC,' ERROR: wrong name FILE-PHCALC (in TEST_2)')
          CLOSE(MTF)
          deallocate(JHS,STAT=ISTAT)
          deallocate(JKS,STAT=ISTAT)
          deallocate(JLS,STAT=ISTAT)
          deallocate(IGSYM,STAT=ISTAT)
          deallocate(SFA,STAT=ISTAT)
          deallocate(SFB,STAT=ISTAT)
          deallocate(SFA2,STAT=ISTAT)
          deallocate(SFB2,STAT=ISTAT)
          IERR = 1
          RETURN
        ENDIF
        CALL OWFILE(MD,MTPH,NAME_PHCALC,ITYPEP,NSM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: open FILE-PHCALC (in TEST_2)')
          CLOSE(MTF)
          deallocate(JHS,STAT=ISTAT)
          deallocate(JKS,STAT=ISTAT)
          deallocate(JLS,STAT=ISTAT)
          deallocate(IGSYM,STAT=ISTAT)
          deallocate(SFA,STAT=ISTAT)
          deallocate(SFB,STAT=ISTAT)
          deallocate(SFA2,STAT=ISTAT)
          deallocate(SFB2,STAT=ISTAT)
          RETURN
        ENDIF

      ENDIF  
C --------------
  210   CONTINUE
C --
C       h = (IHN,IKN,ILN), Fobs(h)=FOBS2,FOBSB
C       JHS,JKS,JLS = h[Aj]
C       SFA,SFB   : G1j(h) = Fm1(h[Aj])*EXP[2PIi*h*Dj]
C       SFA2,SFB2 : G2j(h) = Fm2(h[Aj])*EXP[2PIi*h*Dj]
C
C --
        RSQ = POOL_SCR(IND_SCR + 1) 
        IF(RSQ.LT.0.0) GO TO 110

        IF(MODE_WRT.EQ.1) THEN

C          READ(MTS,END=110)
C     *    RSQ,FOBS2,FOBSB,(JHS(L),JKS(L),JLS(L)
C     *   ,IGSYM(L),SFA(L),SFB(L),SFA2(L),SFB2(L),L=1,NSYM)

          RSQ     = POOL_SCR(IND_SCR + 1) 
          IND_SCR = IND_SCR + 1
          FOBS2   = POOL_SCR(IND_SCR + 1)
          IND_SCR = IND_SCR + 1
          FOBSB   = POOL_SCR(IND_SCR + 1)
          IND_SCR = IND_SCR + 1

          DO L=1,NSYM
            JHS(L)   = POOL_SCR(IND_SCR + 1)
            JHS(L)   = JHS(L) - 1000
            IND_SCR  = IND_SCR + 1
            JKS(L)   = POOL_SCR(IND_SCR + 1)
            JKS(L)   = JKS(L) - 1000
            IND_SCR  = IND_SCR + 1
            JLS(L)   = POOL_SCR(IND_SCR + 1)
            JLS(L)   = JLS(L) - 1000
            IND_SCR  = IND_SCR + 1
            IGSYM(L) = POOL_SCR(IND_SCR + 1) 
            IGSYM(L) = IGSYM(L) - 1000
            IND_SCR  = IND_SCR + 1
            SFA(L)   = POOL_SCR(IND_SCR + 1) 
            IND_SCR  = IND_SCR + 1
            SFB(L)   = POOL_SCR(IND_SCR + 1)  
            IND_SCR  = IND_SCR + 1
            SFA2(L)  = POOL_SCR(IND_SCR + 1)
            IND_SCR  = IND_SCR + 1
            SFB2(L)  = POOL_SCR(IND_SCR + 1)
            IND_SCR  = IND_SCR + 1

          ENDDO

        ELSE

C          READ(MTS,END=110)
C     *    RSQ,FOBS2,FOBSB,(JHS(L),JKS(L),JLS(L)
C     *   ,IGSYM(L),SFA(L),SFB(L),L=1,NSYM)

          RSQ     = POOL_SCR(IND_SCR + 1) 
          IND_SCR = IND_SCR + 1
          FOBS2   = POOL_SCR(IND_SCR + 1)
          IND_SCR = IND_SCR + 1
          FOBSB   = POOL_SCR(IND_SCR + 1)
          IND_SCR = IND_SCR + 1
          
          DO L=1,NSYM
            JHS(L)   = POOL_SCR(IND_SCR + 1)
            JHS(L)   = JHS(L) - 1000
            IND_SCR  = IND_SCR + 1
            JKS(L)   = POOL_SCR(IND_SCR + 1)
            JKS(L)   = JKS(L) - 1000
            IND_SCR  = IND_SCR + 1
            JLS(L)   = POOL_SCR(IND_SCR + 1)
            JLS(L)   = JLS(L) - 1000
            IND_SCR  = IND_SCR + 1
            IGSYM(L) = POOL_SCR(IND_SCR + 1) 
            IGSYM(L) = IGSYM(L) - 1000
            IND_SCR  = IND_SCR + 1
            SFA(L)   = POOL_SCR(IND_SCR + 1) 
            IND_SCR  = IND_SCR + 1
            SFB(L)   = POOL_SCR(IND_SCR + 1)  
            IND_SCR  = IND_SCR + 1
          ENDDO

        ENDIF

        FOBSA = FOBS2 
        IF(MODE_D.EQ.'D') THEN
          FOBS2 = FOBS2*FOBS2+FOBSB*FOBSB       
        ENDIF

        IF(FOBS2.LT.0.0)  GO TO 210

        IHN    = JHS(1)
        IKN    = JKS(1)
        ILN    = JLS(1)
        CALL DSTAR(IHN,IKN,ILN,RSQ)

C        IF(NSYM.GT.1) THEN
CC
CC         SYSABS - check systematic absent for h,k,l: 1 - absent, 0 - no.
CC
C          CALL SYSABS_BL(IHN,IKN,ILN,NSYM,ISYM,ICND)
C        ELSE
C          ICND = 0
C        ENDIF
CC
CC ---   ICND NE 0 systematic absent
CC
C        IF(ICND.NE.0) GO TO 210

C ---
C        T = 1.0
C        IF(BETMIN.GT.0.01) THEN
C          T = (1.0- EXP(-BETMIN*0.25*RSQ))
C        ENDIF
C        TEMP = EXP(-BETMAX*0.25*RSQ)*T
        T = 1.0
        IF(BOFF_SCL.GT.0.01) THEN
          T = (1.0- EXP(-BOFF_SCL*0.25*RSQ))
        ENDIF
        TEMP = EXP(-BADD_SCL*0.25*RSQ)*T 
C ---
        FA1S  = 0.0
        FB1S  = 0.0
        FA2S  = 0.0
        FB2S  = 0.0

        NGEN  = 0

        DO  I=1,NSYM

          IF(IGSYM(I).NE.0) NGEN = NGEN + 1

          IHS  = JHS(I)  
          IKS  = JKS(I) 
          ILS  = JLS(I) 

          FA1  = SFA(I) 
          FB1  = SFB(I)
          ARG  = IHS*SH1(1)+IKS*SH1(2)+ILS*SH1(3)
          ARG  = ARG * TWOPI
          COSD = COS(ARG)
          SIND = SIN(ARG)
          FA11 = FA1*COSD-FB1*SIND
          FB11 = FA1*SIND+FB1*COSD

          FA1S = FA1S + FA11
          FB1S = FB1S + FB11

          IF(PST.EQ.'Y') THEN
            ARG   = TWOPI*(IHs*VPST(1)+IKs*VPST(2)+ILs*VPST(3))
            COSD  = COS(ARG)
            SIND  = SIN(ARG)
            FA1S22 = FA11*COSD-FB11*SIND
            FB1S22 = FB11*COSD+FA11*SIND
            FA1S  = FA1S + FA1S22
            FB1S  = FB1S + FB1S22
          ENDIF

          IF(MSG2.NE.'N') THEN
            FA2  = SFA2(I) 
            FB2  = SFB2(I) 
            FA2S = FA2S + FA2
            FB2S = FB2S + FB2
          ENDIF

        ENDDO

        IF(MSG2.NE.'N') THEN
cc-          FA1S = FA1S*PERC1 + FA2S*PERC2 
cc-          FB1S = FB1S*PERC1 + FB2S*PERC2
c -----
C         for fix_mod
          FA1S_FIX = FA2S*PERC2 
          FB1S_FIX = FB2S*PERC2
c ---
        ENDIF
C --
c        IF(PST.EQ.'Y') THEN
c          ARG   = TWOPI*(IHN*VPST(1)+IKN*VPST(2)+ILN*VPST(3))
c          COSD  = COS(ARG)
c          SIND  = SIN(ARG)
c          FA1S2 = FA1S*COSD-FB1S*SIND
c          FB1S2 = FB1S*COSD+FA1S*SIND
c          FA1S  = FA1S + FA1S2
c          FB1S  = FB1S + FB1S2
c          IF(MSG2.NE.'N') THEN
C           for fix_mod
cc-            FA1S2_FIX = FA1S_FIX*COSD-FB1S_FIX*SIND
cc-            FB1S2_FIX = FB1S_FIX*COSD+FA1S_FIX*SIND
cc-            FA1S_FIX  = FA1S_FIX + FA1S2_FIX
cc-            FB1S_FIX  = FB1S_FIX + FB1S2_FIX
c          ENDIF
c        ENDIF

        IF(MSG2.NE.'N') THEN
          FA1S = FA1S*PERC1 + FA2S*PERC2 
          FB1S = FB1S*PERC1 + FB2S*PERC2
        ENDIF

C --
        F22    = FA1S*FA1S + FB1S*FB1S
        F2     = SQRT(F22)


        FMM    = F2
        FM     = F2 * SCALE * EXP(-BOVER*0.25*RSQ)
        FCALC  = FM
        F2     = F2   * SCALE * TEMP * EXP(-BOVER*0.25*RSQ)
        FA1SS  = FA1S * SCALE * TEMP * EXP(-BOVER*0.25*RSQ)
        FB1SS  = FB1S * SCALE * TEMP * EXP(-BOVER*0.25*RSQ)
c -----
        IF(MSG2.NE.'N') THEN
C         for fix_mod
          F22_FIX   = FA1S_FIX*FA1S_FIX + FB1S_FIX*FB1S_FIX
          F2_FIX    = SQRT(F22_FIX)
          F2_FIX    = F2_FIX   * SCALE * TEMP * EXP(-BOVER*0.25*RSQ)
          FA1SS_FIX = FA1S_FIX * SCALE * TEMP * EXP(-BOVER*0.25*RSQ)
          FB1SS_FIX = FB1S_FIX * SCALE * TEMP * EXP(-BOVER*0.25*RSQ)
        ENDIF
C ----

        IF(FOBS2.GE.0.0) THEN

C         if(ihn.eq.3.and.ikn.eq.0.and.iln.eq.0) then
C         write(*,*) '642>',ngen,ihn,ikn,iln,fobs,fobsa,fobsb
C         write(*,*) 'nsym>',nsym
C         endif

          FOBS  = SQRT(FOBS2)*TEMP
          FOBSA = FOBSA*TEMP
          FOBSB = FOBSB*TEMP

C        fcalc=f2

          NTOT = NTOT + 1

          SF1    = SF1    + FOBS               
          SF2    = SF2    + F2                  
          SF12   = SF12   + FOBS*FOBS           
          SF22   = SF22   + F2*F2              
          SF1F2  = SF1F2  + FOBS * F2          
c -----
          IF(MSG2.NE.'N') THEN
C           for fix_mod
            SF2_FIX   = SF2_FIX    + F2_FIX                  
            SF22_FIX  = SF22_FIX   + F2_FIX*F2_FIX              
            SF1F2_FIX = SF1F2_FIX  + FOBS * F2_FIX          
          ENDIF
c -----
          SI1    = SI1    + FOBS * FOBS         
          SI2    = SI2    + F2   * F2           
          SI12   = SI12   + FOBS*FOBS*FOBS*FOBS 
          SI22   = SI22   + F2*F2*F2*F2        
          SI1I2  = SI1I2  + FOBS*F2*FOBS*F2     

          SDEL   = SDEL   + ABS(FOBS - F2)      

          IF(MODE_D.EQ.'D') THEN

            SD12 = SD12 + 2.0*(FOBSA*FA1SS+ FOBSB*FB1SS)
            SD1  = SD1  + 2.0*(FOBS*FOBS)               
            SD2  = SD2  + 2.0*(F2*F2)                   
c -----
            IF(MSG2.NE.'N') THEN
C             for fix_mod
              SD12_FIX = SD12_FIX + 
     *                   2.0*(FOBSA*FA1SS_FIX+ FOBSB*FB1SS_FIX)
              SD2_FIX  = SD2_FIX  + 2.0*(F2_FIX*F2_FIX)                   
            ENDIF
c -----

          ENDIF

        ENDIF

        IF(FMM.GT.0.0000001) THEN
          FA1S = FA1S/FMM 
          FB1S = FB1S/FMM
        ELSE
          FA1S = 1.0
          FB1S = 0.0       
        ENDIF
       
        IF(MTF.GT.0) THEN
          ZER = 0.0
          CALL WRT(MTF  ,IHN,IKN,ILN,FCALC,ZER ,NBL  ,IEND )
          IF(MTF.LE.0) THEN
            IERR = 1
            CALL MSGERR(MDOC,' ERROR: write to FILE-FCALC (in TEST_2)')
            CLOSE(MTPH)
            deallocate(JHS,STAT=ISTAT)
            deallocate(JKS,STAT=ISTAT)
            deallocate(JLS,STAT=ISTAT)
            deallocate(IGSYM,STAT=ISTAT)
            deallocate(SFA,STAT=ISTAT)
            deallocate(SFB,STAT=ISTAT)
            deallocate(SFA2,STAT=ISTAT)
            deallocate(SFB2,STAT=ISTAT)
            RETURN
          ENDIF
          CALL WRT1(MTPH,IHN,IKN,ILN,FA1S ,FB1S,NBL11,IEND1)
          IF(MTPH.LE.0) THEN
            IERR = 1
            CALL MSGERR(MDOC,' ERROR: write to FILE-PHCALC (in TEST_2)')
            CLOSE(MTF)
            deallocate(JHS,STAT=ISTAT)
            deallocate(JKS,STAT=ISTAT)
            deallocate(JLS,STAT=ISTAT)
            deallocate(IGSYM,STAT=ISTAT)
            deallocate(SFA,STAT=ISTAT)
            deallocate(SFB,STAT=ISTAT)
            deallocate(SFA2,STAT=ISTAT)
            deallocate(SFB2,STAT=ISTAT)
            RETURN
          ENDIF
        ENDIF

        GO TO 210
C ---
  110 CONTINUE
C     REWIND MTS
      IF(MTF.GT.0) THEN
        IEND  = 2
        IEND1 = 2
        CALL WRT(MTF  ,IHN,IKN,ILN,CALC,ZER ,NBL  ,IEND )
        CALL WRT1(MTPH,IHN,IKN,ILN,FA1S,FB1S,NBL11,IEND1)
      ENDIF
C ---
      IF(NTOT.GT.0) THEN
        IF(SF1.GE.0.000001) THEN
          RFAC_I = SDEL/SF1
        ELSE
          RFAC_I  =  0.0
        ENDIF
      ELSE
        RFAC_I = 0.0
      ENDIF
      
      IF(NTOT.GT.0) THEN

        SF1A   = SF1   /NTOT
        SF2A   = SF2   /NTOT
        SF12A  = SF12  /NTOT
        SF22A  = SF22  /NTOT
        SF1F2A = SF1F2 /NTOT
c ------
        IF(MSG2.NE.'N') THEN
C         for fix_mod
          SF2A_FIX   = SF2_FIX  /NTOT                  
          SF22A_FIX  = SF22_FIX /NTOT              
          SF1F2A_FIX = SF1F2_FIX/NTOT         
        ENDIF
c ------

        SI1A   = SI1   /NTOT
        SI2A   = SI2   /NTOT
        SI12A  = SI12  /NTOT
        SI22A  = SI22  /NTOT
        SI1I2A = SI1I2 /NTOT

        SDELA  = SDEL /NTOT
        T1     = (SF12A-SF1A*SF1A)
        T2     = (SF22A-SF2A*SF2A)
        T1     = T1*T2
        SDELA  = SDEL /NTOT
        T1I    = (SI12A-SI1A*SI1A)
        T2I    = (SI22A-SI2A*SI2A)
        T1I    = T1I*T2I
C     CC = (<F1*F2>-<F1><F2>)/SQRT((<F1^2>-<F1>^2)(<F2^2>-<F2>^2))
        IF(T1.GE.0.000001) THEN
          CORR_I  = (SF1F2A-SF1A*SF2A)/SQRT(ABS(T1))
          CORR_II = (SI1I2A-SI1A*SI2A)/SQRT(ABS(T1I))
        ELSE
          CORR_I  = -2.0
          CORR_II = -2.0
          RFAC_I  =  0.0
        ENDIF
c ------
        IF(MSG2.NE.'N') THEN
C         for fix_mod
          T1     = (SF12A-SF1A*SF1A)
          T2     = (SF22A_FIX-SF2A_FIX*SF2A_FIX)
          T1     = T1*T2
          IF(T1.GE.0.000001) THEN
            CORR_FIX  = (SF1F2A_FIX-SF1A*SF2A_FIX)/SQRT(ABS(T1))
          ELSE
            CORR_FIX  = -2.0
          ENDIF
        ENDIF
C ------        

        IF(MODE_D.EQ.'D') THEN

          FOBS000 = 0.0
          FM000   = 0.0

          T1 = SD1 - FOBS000*FOBS000
          IF(T1.LT.0.0) T1 = 0.0
          T2 = SD2 - FM000*FM000
          IF(T2.LT.0.0) T2 = 0.0
          T1 = T1*T2
          IF(T1.GE.0.000001) THEN
            DCORR_I  = (SD12-FOBS000*FM000)/SQRT(T1)
            DCORR_II = DCORR_I
          ELSE
            DCORR_I  = -2.0
            DCORR_II = -2.0
C           RFAC_I  =  0.0
          ENDIF

c         write(*,*)'==r,c,d:',ipk,RFAC_I,CORR_I,DCORR_I            
c -----
          IF(MSG2.NE.'N') THEN
C           for fix_mod
            T1 = SD1 - FOBS000*FOBS000
            IF(T1.LT.0.0) T1 = 0.0
            T2 = SD2_FIX - FM000*FM000
            IF(T2.LT.0.0) T2 = 0.0
            T1 = T1*T2
            IF(T1.GE.0.000001) THEN
              DCORR_FIX  = (SD12_FIX-FOBS000*FM000)/SQRT(T1)
            ELSE
              DCORR_FIX = -2.0
            ENDIF
          ENDIF

          CORR_FIX = DCORR_FIX
          CORR_I  = DCORR_I
          CORR_II = DCORR_I

        ENDIF
      ELSE
        CORR_FIX = -3.0
        CORR_I  = -3.0
        CORR_II = -3.0
        RFAC_I  =  0.0
      ENDIF

      RFAC(IPK) = RFAC_I
      CORR(IPK) = CORR_I



C --- packing NCS monomers
      PACK_GRP = 'N'
      PK_GRP =  RESULT(IPK,1)
      IF(PK_GRP.GT.0.09) PACK_GRP = 'Y'
c ---

      IF(IPK.EQ.1) THEN
        CALL MSGDOC(MDOC,' ')
        WRITE(LINE,
     *   '(''Sol_TF   Pack_max,min:'',2F8.3,''   Sigma:'',F12.3)') 
     *   RMAX_PK,RMIN_PK,SIGMA
        CALL MSGDOC(MD,LINE)
        IF(PACK_GRP.EQ.'Y') THEN
          LINE = '               Xfrac  Yfrac  Zfrac'//
     *           '   TF/sig   Score  Pc_GR   Corr'
        ELSE
          LINE = '               Xfrac  Yfrac  Zfrac'//
     *           '   TF/sig   Score  R-fac   PF'
        ENDIF
        CALL MSGDOC(MD,LINE)
      ENDIF

      WRITE(CH3,'(I3)') IPK_RF
      IF(CH3(1:1).EQ.' ') CH3(1:1) = '_' 
      IF(CH3(2:2).EQ.' ') CH3(2:2) = '_' 

      JPK = IPK    
      IF(IPK.EQ.1) JPK = IPT_MIN

C --- packing NCS monomers  0.1 =< PK_GRP =< 1.0
      PK_GRP =  RESULT(IPK,1)
      IF(PK_GRP.LT.0.09) PK_GRP = 1.0
c ---
      IF(CORR(IPK).LE.-2.0) THEN
        SCORE = CORR(IPK)
      ELSE

        CRR  = CORR(IPK)
        CRRR = CORR(IPK)

        IF(CRRR.LT.-1.0) CRRR =-1.0
        IF(CRR .LT.-1.0) CRR  =-1.0

        IF(SCORE_FLAG.NE.'C')THEN
          IF(CRR.LT.-1.0) THEN
            CRR =-1.0
          ELSE
            CRR = ((CRR + 1.0) * PK_GRP ) - 1.0 
          ENDIF
        ENDIF
C ---   CRR with packing NCS monomers
C ---   CRR without

        FTS = RESULT(IPK,5)
        IF(FTS.LT.0.0) FTS = 0.0

        SCORE = CRR

        IF(CRRR.GT.-1.0) THEN
          AVER      = AVER  + CRRR
          AVER2     = AVER2 + CRRR*CRRR
          NAVER     = NAVER + 1
        ENDIF

      ENDIF

      CH6 = 'Sol_TF'
C      IF(MSG2.EQ.'N') THEN
      IF(IFIRST_RUN.EQ.1) THEN
        CH6 = 'GNM_TF'
      ENDIF

      IF(PACK_GRP.EQ.'Y') THEN
        WRITE(LINE,'(A6,A3,1X,I3,3F7.3,F8.2,F9.3,2F7.3)') 
     *  CH6,CH3,JPK
     *  ,RESULT(IPK,9),RESULT(IPK,10),RESULT(IPK,11),RESULT(IPK,5)
     *  ,SCORE,PK_GRP,CORR(IPK)
      ELSE
        WRITE(LINE,'(A6,A3,1X,I3,3F7.3,F8.2,F9.3,2F7.3)') 
     *  CH6,CH3,JPK
     *  ,RESULT(IPK,9),RESULT(IPK,10),RESULT(IPK,11),RESULT(IPK,5)
     *  ,SCORE,RFAC(IPK),RESULT(IPK,22)
      ENDIF

      RESULT(IPK,13) = CORR(IPK) 
      SCR_SORT(IPK) = CORR(IPK)
      IF(RESULT(IPK,22).GT.0.0) THEN
        SCR_SORT(IPK) = SCR_SORT(IPK)*RESULT(IPK,22)  
      ENDIF
      CORR(IPK) = SCORE
      CALL MSGDOC(MD,LINE)
C ---sol
C     IF(CORR(IPK).GT.CORR_TOT) THEN
      IF(SCR_SORT(IPK).GT.SCR_SORT_TOT) THEN
        SCR_SORT_TOT = SCR_SORT(IPK)
        CORR_TOT  = CORR(IPK)
        CRRR_BEST = CRRR
        SCORE_TOT = SCORE
        IPK_BEST  = IPK
      ENDIF

      IF(IPK.LT.NP) GO TO 800
C --------------------------------------------
      IF(CORR_TOT.GE.-1.0) THEN
C        CALL MSGDOC(MD,' ')
C        CALL MSGDOC(MD,
C     *   '--- write coordinates of new model to "trfun.crd" ---')
C        WRITE(LINE,'('' transformation corresponds to  :'',I2
C     *  ,'' peak of translation function '')') IPK_BEST 
C        CALL MSGDOC(MD,LINE)
c        WRITE(LINE,'('' Shift :'',3F8.2)') 
c     *  RESULT(IPK_BEST,6),RESULT(IPK_BEST,7),RESULT(IPK_BEST,8)
c        CALL MSGDOC(MDOC,LINE)
c
c        WRITE(LINE,'('' Shift :'',3F8.2)') 
c     *  RESULT(IPK_BEST,9),RESULT(IPK_BEST,10),RESULT(IPK_BEST,11)
c        CALL MSGDOC(MDOC,LINE)

        SHF(1) = RESULT(IPK_BEST, 9)
        SHF(2) = RESULT(IPK_BEST,10)
        SHF(3) = RESULT(IPK_BEST,11)

        RESULT(1,12) = 1.0
        RESULT(1,1)  = RFAC(IPK_BEST)
        RESULT(1,2)  = CORR(IPK_BEST)
        RESULT(1,4)  = RESULT(IPK_BEST,4)
        RESULT(1,5)  = RESULT(IPK_BEST,5)
        RESULT(1,6)  = RESULT(IPK_BEST,6)
        RESULT(1,7)  = RESULT(IPK_BEST,7)
        RESULT(1,8)  = RESULT(IPK_BEST,8)
        RESULT(1,13) = RESULT(IPK_BEST,13)
        RESULT(1,22) = RESULT(IPK_BEST,22)
        JPK = IPK_BEST    
        IF(IPK_BEST.EQ.1) JPK = IPT_MIN
        RESULT(1,9)  = JPK

        TF_CONTRAST = 0.0

        NAV = NAVER
        IF(NAV.GT.5) THEN
c          write(*,*) '--',IPK_BEST,CORR(IPK_BEST),CRRR_BEST
C          SAVER      = AVER  - CORR(IPK_BEST)
C          SAVER2     = AVER2 - CORR(IPK_BEST)*CORR(IPK_BEST)
          SAVER      = AVER  - CRRR_BEST
          SAVER2     = AVER2 - CRRR_BEST*CRRR_BEST
          NAV     = NAV - 1
          SAVER   = SAVER /FLOAT(NAV)
          SAVER2  = SAVER2/FLOAT(NAV)
          TSIGMA  = SQRT(ABS(SAVER2-SAVER*SAVER))
          IF(TSIGMA.GT.0.0001) THEN
            TF_CONTRAST = (CRRR_BEST-SAVER)/TSIGMA 
c            TF_CONTRAST = (CORR(IPK_BEST)-SAVER)/TSIGMA 
          ENDIF
        ENDIF

        RESULT(1,17) = TF_CONTRAST
        RESULT(1,18) = AVER
        RESULT(1,19) = AVER2
        RESULT(1,20) = NAVER
        RESULT(2,21) = CORR_FIX
        
        CALL LENSTR_BL(NAMEO,LEN)

        IF(LEN.GT.0) THEN
          SH2(1) = RESULT(IPK_BEST,6)
          SH2(2) = RESULT(IPK_BEST,7)
          SH2(3) = RESULT(IPK_BEST,8)
          MODE = 'E'
          DO I=1,3
            SH1(I) = 0.0
            DO J=1,3
              AM(I,J) = 0.0
            ENDDO
          ENDDO
          ALPHA1 = 0.0
          BETA1  = 0.0
          GAMMA1 = 0.0

          NAMECT = NAMEC

          IF(MOD2.EQ.'Y'.OR.TEST.EQ.'4') THEN

            NAMET = 'trfn_scr2'
            CALL ADD_PATH(PATH_SCR,NAMET)

            IF(MOD2.EQ.'N'.AND.TEST.EQ.'4') NAMET = NAMEO
 
            IF(TEST.EQ.'3'.OR.TEST.EQ.'4') THEN

              NAMECT = 'trfn_scr3'
              CALL ADD_PATH(PATH_SCR,NAMECT)

              CALL CHECK_POSITION(Mdoc,NAMEC,NAMECT,TEST
     *         ,ALPHA,BETA,GAMMA,SHF,SH2,PEAK_TEST
     *         ,ISYM,IPRSYM,IERR)
              IF(IERR.NE.0) THEN
                deallocate(JHS,STAT=ISTAT)
                deallocate(JKS,STAT=ISTAT)
                deallocate(JLS,STAT=ISTAT)
                deallocate(IGSYM,STAT=ISTAT)
                deallocate(SFA,STAT=ISTAT)
                deallocate(SFB,STAT=ISTAT)
                deallocate(SFA2,STAT=ISTAT)
                deallocate(SFB2,STAT=ISTAT)
                GO TO 900
              ENDIF
C             ALPHA,BETA,GAMMA - changed            
C             result - new shift
              JPK = IPK_BEST    
              IF(IPK_BEST.EQ.1) JPK = IPT_MIN

              CALL MSGDOC(MDOC,' ')
              WRITE(LINE,
     *        '(''Sol_TF'',A2,1X,I2,3F8.2,3F7.3,F8.2,2F7.3)')
     *        CH2,JPK,ALPHA,BETA,GAMMA
     *        ,SHF(1),SHF(2),SHF(3),RESULT(1,5)
     *        ,RESULT(1,1),RESULT(1,2)
              CALL MSGDOC(MDOC,LINE)

              RESULT(1,6) = SH2(1)
              RESULT(1,7) = SH2(2)
              RESULT(1,8) = SH2(3)

              DO I=1,3
               SH2(I) = 0.0
              ENDDO
            ENDIF
          ELSE
            NAMET = NAMEO
          ENDIF

          CALL TRANS(M,NAMECT,NAMET,SH1,SH2
     *      ,MODE,AM,ALPHA1,BETA1,GAMMA1,RESULTA,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            deallocate(JHS,STAT=ISTAT)
            deallocate(JKS,STAT=ISTAT)
            deallocate(JLS,STAT=ISTAT)
            deallocate(IGSYM,STAT=ISTAT)
            deallocate(SFA,STAT=ISTAT)
            deallocate(SFB,STAT=ISTAT)
            deallocate(SFA2,STAT=ISTAT)
            deallocate(SFB2,STAT=ISTAT)    
            GO TO 900
          ENDIF
          IF(MOD2.EQ.'Y') THEN
            IERR = NUM_MON
C                         old  + new
C                               if(surf.eq.'y') use blim
            CALL JOINCRD(M,NAME2,NAMET,NAMEO,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) THEN
              deallocate(JHS,STAT=ISTAT)
              deallocate(JKS,STAT=ISTAT)
              deallocate(JLS,STAT=ISTAT)
              deallocate(IGSYM,STAT=ISTAT)
              deallocate(SFA,STAT=ISTAT)
              deallocate(SFB,STAT=ISTAT)
              deallocate(SFA2,STAT=ISTAT)
              deallocate(SFB2,STAT=ISTAT)
              GO TO 900
            ENDIF
          ENDIF

        ENDIF

      ENDIF
      deallocate(JHS,STAT=ISTAT)
      deallocate(JKS,STAT=ISTAT)
      deallocate(JLS,STAT=ISTAT)
      deallocate(IGSYM,STAT=ISTAT)
      deallocate(SFA,STAT=ISTAT)
      deallocate(SFB,STAT=ISTAT)
      deallocate(SFA2,STAT=ISTAT)
      deallocate(SFB2,STAT=ISTAT)
C --------------------
      CALL MSGDOC(MD,' ')
  900 CONTINUE
C ----
      NAMET='trfn_scr2.crd'
      CALL DELETE_FILE(PATH_SCR,NAMET)
      NAMET='trfn_scr3.crd'
      CALL DELETE_FILE(PATH_SCR,NAMET)

      RETURN
      END

      SUBROUTINE SCALE_PATT_TR(MDOC,POOL_SCR,MODE,MODE_WRT,NSYM,MSG2
     * ,JHS,JKS,JLS,IGSYM,SFA,SFB,SFA2,SFB2,SH1,PERC1,PERC2
     * ,PST,VPST
     * ,BOFF,BADD,SCALE,BOVER,RESMNI,RESMXI,IPRSYM,IERR)
C ------------------------------
      REAL      POOL_SCR(*)
      INTEGER*2 JHS(IPRSYM),JKS(IPRSYM),JLS(IPRSYM),IGSYM(IPRSYM)
      REAL      SFA(IPRSYM),SFB(IPRSYM)
      REAL      SFA2(IPRSYM),SFB2(IPRSYM)
      REAL      SH1(3),VPST(3)
      CHARACTER MSG2*1,PST*1
      REAL      RESMNI,RESMXI
      INTEGER*4 MDOC,IERR,MODE_WRT,MTS
      CHARACTER MODE*1
C ==============================
      REAL      DISTR(41),RHR(41),RLATT(6)
      REAL      AVERF2(40),SUMFN(40),SUMFNT(40),AVERF2T(40)
      REAL      SUMA(40),SUMC(40),SUMF2(40),SUMF2O(40)
      CHARACTER LINE*256
C -----------------------------------------------------------
      PI    = 4.0*ATAN(1.0)
      TWOPI = 2.0*PI
      IERR  = 0
      MD    =-ABS(MDOC)-1
      M     = 99
C -----------------------------------------------------------
      COEF  = 1.5
      NUMGP = 20
C --------------------------------------
      RHMIN = 1.0/RESMNI
      RHMAX = 1.0/RESMXI

      DMAX = (RESMXI/3.0)*2.0*COEF
      DELT = DMAX/NUMGP
      DO  K=1,NUMGP
        SUMA    (K) =0.0
        SUMC    (K) =0.0
        SUMF2   (K) =0.0
        SUMF2O  (K) =0.0
        SUMFN   (K) =0.0
        SUMFNT  (K) =0.0
        AVERF2  (K) =0.0
        AVERF2T (K) =0.0
      ENDDO
      D = 0
      DO    K=1,NUMGP+1
        DISTR(K) = D
        D = D + DELT
      ENDDO
      DELTRH = (RHMAX-RHMIN)/NUMGP
      RHR(1) = RHMIN
      DO    I=2,NUMGP+1
        RHR(I) = RHR(I-1) + DELTRH
      ENDDO
C
      NREF = 0
C  ------------------------

C      READ(MTS,END=100) MODE_R,(RLATT(L),L=1,6),RESMINR,RESMAXR
C     * ,NSYMR,BETMINR,BETMAXR,PERC1R,PERC2R

      IND_SCR   = 0
      MODE_R    = POOL_SCR(IND_SCR + 1) 
      IND_SCR   = IND_SCR + 1
      DO L=1,6
        RLATT(L)     = POOL_SCR(IND_SCR + 1)   
        IND_SCR      = IND_SCR + 1
      ENDDO
      RESMINR    = POOL_SCR(IND_SCR + 1) 
      IND_SCR    = IND_SCR + 1
      RESMAXR    = POOL_SCR(IND_SCR + 1) 
      IND_SCR    = IND_SCR + 1
      NSYMR      = POOL_SCR(IND_SCR + 1)
      IND_SCR    = IND_SCR + 1
      BETMINR    = POOL_SCR(IND_SCR + 1) 
      IND_SCR    = IND_SCR + 1
      BETMAXR    = POOL_SCR(IND_SCR + 1) 
      IND_SCR    = IND_SCR + 1
      PERC1R     = POOL_SCR(IND_SCR + 1) 
      IND_SCR    = IND_SCR + 1
      PERC2R     = POOL_SCR(IND_SCR + 1)
      IND_SCR    = IND_SCR + 1

      CALL DSTARF(RLATT,AST,BST,CST,COALST,COBEST,COGAST,VOL)

  200   CONTINUE

        RSQ = POOL_SCR(IND_SCR + 1) 
        IF(RSQ.LT.0.0) GO TO 100

        IF(MODE_WRT.EQ.1) THEN

C          READ(MTS,END=100)
C     *    RSQ,FOBS2,FOBSB,(JHS(L),JKS(L),JLS(L)
C     *   ,IGSYM(L),SFA(L),SFB(L),SFA2(L),SFB2(L),L=1,NSYM)

          RSQ     = POOL_SCR(IND_SCR + 1) 
          IND_SCR = IND_SCR + 1
          FOBS2   = POOL_SCR(IND_SCR + 1)
          IND_SCR = IND_SCR + 1
          FOBSB   = POOL_SCR(IND_SCR + 1)
          IND_SCR = IND_SCR + 1
          
          DO L=1,NSYM
            JHS(L)   = POOL_SCR(IND_SCR + 1)
            JHS(L)   = JHS(L) - 1000
            IND_SCR  = IND_SCR + 1
            JKS(L)   = POOL_SCR(IND_SCR + 1)
            JKS(L)   = JKS(L) - 1000
            IND_SCR  = IND_SCR + 1
            JLS(L)   = POOL_SCR(IND_SCR + 1)
            JLS(L)   = JLS(L) - 1000
            IND_SCR  = IND_SCR + 1
            IGSYM(L) = POOL_SCR(IND_SCR + 1) 
            IGSYM(L) = IGSYM(L) - 1000
            IND_SCR  = IND_SCR + 1
            SFA(L)   = POOL_SCR(IND_SCR + 1) 
            IND_SCR  = IND_SCR + 1
            SFB(L)   = POOL_SCR(IND_SCR + 1)  
            IND_SCR  = IND_SCR + 1
            SFA2(L)  = POOL_SCR(IND_SCR + 1)
            IND_SCR  = IND_SCR + 1
            SFB2(L)  = POOL_SCR(IND_SCR + 1)
            IND_SCR  = IND_SCR + 1
         ENDDO

        ELSE

C          READ(MTS,END=100)
C     *    RSQ,FOBS2,FOBSB,(JHS(L),JKS(L),JLS(L)
C     *   ,IGSYM(L),SFA(L),SFB(L),L=1,NSYM)

          RSQ     = POOL_SCR(IND_SCR + 1) 
          IND_SCR = IND_SCR + 1
          FOBS2   = POOL_SCR(IND_SCR + 1)
          IND_SCR = IND_SCR + 1
          FOBSB   = POOL_SCR(IND_SCR + 1)
          IND_SCR = IND_SCR + 1
          
          DO L=1,NSYM
            JHS(L)   = POOL_SCR(IND_SCR + 1)
            JHS(L)   = JHS(L) - 1000
            IND_SCR  = IND_SCR + 1
            JKS(L)   = POOL_SCR(IND_SCR + 1)
            JKS(L)   = JKS(L) - 1000
            IND_SCR  = IND_SCR + 1
            JLS(L)   = POOL_SCR(IND_SCR + 1)
            JLS(L)   = JLS(L) - 1000
            IND_SCR  = IND_SCR + 1
            IGSYM(L) = POOL_SCR(IND_SCR + 1) 
            IGSYM(L) = IGSYM(L) - 1000
            IND_SCR  = IND_SCR + 1
            SFA(L)   = POOL_SCR(IND_SCR + 1) 
            IND_SCR  = IND_SCR + 1
            SFB(L)   = POOL_SCR(IND_SCR + 1)  
            IND_SCR  = IND_SCR + 1
          ENDDO

        ENDIF

        IF(MODE.EQ.'D') THEN
          FOBS2 = FOBS2*FOBS2+FOBSB*FOBSB
        ENDIF

        IF(FOBS2.LT.0.0) GO TO 200

        IHN    = JHS(1)
        IKN    = JKS(1)
        ILN    = JLS(1)
        CALL DSTAR(IHN,IKN,ILN,RSQ)

        RH = SQRT(RSQ)
        IF(RH.LT.RHMIN.OR.RH.GT.RHMAX) GO TO 200
        K = (RH-RHMIN)/DELTRH+1.0
        IF(K.GT.NUMGP) K = NUMGP
        IF(K.LT.1) K = 1     

        FOBS  = SQRT(FOBS2)

        FA1S  = 0.0
        FB1S  = 0.0
        FA2S  = 0.0
        FB2S  = 0.0

        NGEN = 0
        DO  I=1,NSYM

          IF(IGSYM(I).NE.0) NGEN = NGEN + 1

          IHS  = JHS(I)  
          IKS  = JKS(I) 
          ILS  = JLS(I) 

          FA1  = SFA(I) 
          FB1  = SFB(I)
          ARG  = IHS*SH1(1)+IKS*SH1(2)+ILS*SH1(3)
          ARG  = ARG * TWOPI
          COSD = COS(ARG)
          SIND = SIN(ARG)
          FA11 = FA1*COSD-FB1*SIND
          FB11 = FA1*SIND+FB1*COSD

          FA1S = FA1S + FA11
          FB1S = FB1S + FB11

          IF(PST.EQ.'Y') THEN
            ARG   = TWOPI*(IHs*VPST(1)+IKs*VPST(2)+ILs*VPST(3))
            COSD  = COS(ARG)
            SIND  = SIN(ARG)
            FA1S22 = FA11*COSD-FB11*SIND
            FB1S22 = FB11*COSD+FA11*SIND
            FA1S  = FA1S + FA1S22
            FB1S  = FB1S + FB1S22
          ENDIF

          IF(MSG2.NE.'N') THEN
            FA2  = SFA2(I) 
            FB2  = SFB2(I) 
            FA2S = FA2S + FA2
            FB2S = FB2S + FB2
          ENDIF

        ENDDO

cc-        IF(MSG2.NE.'N') THEN
cc-          FA1S = FA1S*PERC1 + FA2S*PERC2  
cc-          FB1S = FB1S*PERC1 + FB2S*PERC2
cc-        ENDIF
C --
c        IF(PST.EQ.'Y') THEN
c          ARG   = TWOPI*(IHN*VPST(1)+IKN*VPST(2)+ILN*VPST(3))
c          COSD  = COS(ARG)
c          SIND  = SIN(ARG)
c          FA1S2 = FA1S*COSD-FB1S*SIND
c          FB1S2 = FB1S*COSD+FA1S*SIND
c          FA1S  = FA1S + FA1S2
c          FB1S  = FB1S + FB1S2
c        ENDIF

        IF(MSG2.NE.'N') THEN
          FA1S = FA1S*PERC1 + FA2S*PERC2  
          FB1S = FB1S*PERC1 + FB2S*PERC2
        ENDIF
C --
        FN = SQRT(FA1S*FA1S + FB1S*FB1S)

        NREF = NREF + 1

        IF(BOFF.GT.0.0) THEN
          BT    = BOFF/4.0
          CBOFF = 1.0-EXP(-BT*RSQ)
        ELSE
          CBOFF = 1.0
        ENDIF
        IF(ABS(BADD).GT.0.00001) THEN
          BT    = BADD/4.0
          CBADD = EXP(-BT*RSQ)
        ELSE
          CBADD = 1.0
        ENDIF

        FN2       = FN*FN * CBOFF*CBOFF*CBADD*CBADD
        FOBS2     = FOBS2 * CBOFF*CBOFF*CBADD*CBADD

        SUMF2 (K) = SUMF2(K)   + FN2   
        SUMF2O(K) = SUMF2O(K)  + FOBS2  
        SUMFN (K) = SUMFN(K)   + 1
        SUMFNT(K) = SUMFNT(K)  + 1
C ---

        GO TO 200
C ---
  100 CONTINUE

c     REWIND MTS

      IF(NREF.LE.0) THEN
        CALL MSGERR(MDOC,
     *  ' ERROR: in SCALE_PATT_TR: number of reflections = 0')
        IERR = 1
        RETURN
      ENDIF
C ---- PATTERSON ----------------------------------------------------

      COMPL = 1.0
      DO I=1,NUMGP
        AVERF2  (I) = 0.0
        AVERF2T (I) = 0.0
        IF(SUMFNT(I).GT.0.000001) AVERF2T (I) = SUMF2 (I)/SUMFNT(I)
        IF(SUMFN(I) .GT.0.000001) AVERF2  (I) = SUMF2 (I)/SUMFN(I)
      ENDDO
C ---
      NUMGPF = NUMGP
      CALL CALC_PATT(MDOC,NUMGP,NUMGPF,DELT,DELTRH,RHR,COMPL
     *     ,AVERF2,AVERF2T,SUMA,SUMC,IERR)
      ALIM = 0.1
      CALL  TEMP_FLPP(SUMC,NUMGP,DISTR,SCALE,BTP,ALIM)
      IF(BTP.GT.0.0000000001) THEN
        DT2 = 1.0/(2.0*BTP)
      ELSE 
        DT2 = 0.0
      ENDIF
      BSUM = 8.0*PI*PI*DT2

      BTEMP2 = BSUM/2.0 
      SCALE2 = SQRT(ABS(SCALE))
      
c      write(*,*) ' 2:',btemp2,scale2

C -------------------------------
      DO I=1,NUMGP
        AVERF2  (I) = 0.0
        AVERF2T (I) = 0.0
        IF(SUMFNT(I).GT.0.000001) AVERF2T (I) = SUMF2O(I)/SUMFNT(I)
        IF(SUMFN(I) .GT.0.000001) AVERF2  (I) = SUMF2O(I)/SUMFN(I)
      ENDDO
C ---
      NUMGPF = NUMGP
      CALL CALC_PATT(MDOC,NUMGP,NUMGPF,DELT,DELTRH,RHR,COMPL
     *     ,AVERF2,AVERF2T,SUMA,SUMC,IERR)
      ALIM = 0.1
      CALL  TEMP_FLPP(SUMC,NUMGP,DISTR,SCALE,BTP,ALIM)
      IF(BTP.GT.0.0000000001) THEN
        DT2 = 1.0/(2.0*BTP)
      ELSE
        DT2 = 0.0
      ENDIF
      BSUM = 8.0*PI*PI*DT2

      BTEMP1 = BSUM/2.0 
      SCALE1 = SQRT(ABS(SCALE))
      
c      write(*,*) ' 1:',btemp1,scale1

C -------------------------------
      BOVER = BTEMP1-BTEMP2
      SCALE = SCALE1/SCALE2
      RETURN
      END

      SUBROUTINE CHANGE_CELL(MDOC,NAMEM,PATH_SCR,RLATT,SPGROUP
     *                                  ,ISYM,IPRSYM,IERR)
C ---------------------------------------------
      INTEGER     MDOC,IPRSYM,IERR
      INTEGER*2   ISYM(5,3,IPRSYM)
      REAL      RLATT(6)
      CHARACTER NAMEM*(*),SPGROUP*24
      CHARACTER PATH_SCR*(*)
      CHARACTER LINE*256,NAMEC*256,NAME*256,P1*24,NUM*1
      CHARACTER MODE*1,WAT*1,ALT*1,SETT*1,REST*1,HATM*1,NOCC*1,CONV*1
C ---------------------------------------------
      IERR = 0
      PI   = 4.0*ATAN(1.0)
      M    = 99
C ---
      MODE  = 'C'
      WAT   = 'N'
      P1    = SPGROUP
      ALT   = 'N'
      SETT  = 'N'
      REST  = 'N'
      BOV   = -999.0
      A     = RLATT(1)
      B     = RLATT(2)
      C     = RLATT(3)
      ALPHA = (RLATT(4)*180.0)/PI
      BETA  = (RLATT(5)*180.0)/PI
      GAMMA = (RLATT(6)*180.0)/PI

      NAME  = ' '
      NAMEC = 'molrp_scr'
      CALL ADD_PATH(PATH_SCR,NAMEC)

      HATM  = 'N'
      NUM   = 'N'
      NOCC  = 'R'
      CONV  = 'N'
      CALL CONCRD(M,MODE,NAMEM,NAMEC,NAME,SETT,REST
     *  ,WAT,P1,HATM,NUM,NOCC,ALT,CONV
     *  ,A,B,C,ALPHA,BETA,GAMMA,BOV,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C ---
      MODE  = 'C'
      WAT   = 'N'
      P1    = 'N'
      ALT   = 'N'
      SETT  = 'N'
      REST  = 'N'
      BOV   = -999.0
      A     = 0.0
      B     = 0.0
      C     = 0.0
      ALPHA = 0.0
      BETA  = 0.0
      GAMMA = 0.0
      NAME  = ' '
      HATM  = 'N'
      NUM   = 'N'
      NOCC  = 'R'
      CONV  = 'N'
      CALL CONCRD(M,MODE,NAMEC,NAMEM,NAME,SETT,REST
     *  ,WAT,P1,HATM,NUM,NOCC,ALT,CONV
     *  ,A,B,C,ALPHA,BETA,GAMMA,BOV,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C ---
 900  CONTINUE

      NAME='molrp_scr.crd'
      CALL DELETE_FILE(PATH_SCR,NAME)

      RETURN
      END

      SUBROUTINE RFCOEF_00N(MDOC,MDOC_PSRCH,LIST,NPEAK,NPEAK2
     * ,NAMEF,NAMEM,PATH_SCR,BOFF,BADD,NINDEX,LINDEX
     * ,NMIN,RESMIN,RESMXFR,ARAD,SHR,SHM,INVER,F000,RMS_INPUT
     * ,RESULT,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
C ----------------------------------
C ----------------------------------
c      PARAMETER ( IPRBES = 400                )
c      PARAMETER ( IPRLM2 = 62                 )
c      PARAMETER ( IPRLMX = 60                 )
c      PARAMETER ( IPRNMX = 30                 )
c      PARAMETER ( IPRALM = 30                 )
c      PARAMETER ( IPRNIN = 30                 )

      PARAMETER ( IPRBES = 600                )
      PARAMETER ( IPRLM2 = 102                 )
      PARAMETER ( IPRLMX = 100                 )
      PARAMETER ( IPRNMX = 50                 )
      PARAMETER ( IPRALM = 50                 )
      PARAMETER ( IPRNIN = 50                 )
C ---------
      REAL      RESULT(IPRMAX,IPRROW)
      REAL      RESMIN,RESMXF,ARAD,BOFF,BADD
      INTEGER   MDOC,IERR

      CHARACTER NAMEF*(*),NAMEM*(*),NAMEO*256
      CHARACTER PATH_SCR*(*)

      CHARACTER NAMEB*256,NAMES*256,NAMET*256,LIST*1
C ---------
      REAL      RLATT(6),SHM(3),SHR(3)
      INTEGER*2 ISYM(5,3,IPRSYM)

      INTEGER   IH(1),IK(1),IL(1)
      REAL      FA(1),FB(1)
      REAL      ALM(IPRALM)
      REAL      ALM1(IPRALM)

      CHARACTER ITP*4,TYPE*4,LINE*256,MSG*1,TITLE*80,FOUR*1
      CHARACTER MODE*1
      CHARACTER LAP*1,MSGA*1,SPEC*1,INVER*1,F000*1
C ------------------------
      INTEGER   NMAX  
      REAL      SBES  (IPRLM2,IPRBES)
      REAL      BZEROS(IPRNMX,IPRLM2)
      CHARACTER PATH*80,EXT*3
C ========================================================================
      IERR  = 0
      MD    =-ABS(MDOC)-1
      M     = 99
      MD0   = 0
      MD0   = MDOC
      IF(LIST.EQ.'T') MD = MDOC
C --
      CALL MSGDOC(MDOC,' --- rfcoef_00n .---')
      
      RESMXF = RESMXFR
      NAMEB  = ' '

      NMAXR = 0

      IF(NMIN.LE.0) NMIN=1
      IF(INVER.EQ.'y') INVER='Y'
      IF(INVER.NE.'Y') INVER='N'
      IF(F000 .EQ.'y') F000='Y'
      IF(F000 .NE.'Y') F000='N'
      IF(ARAD .LE.0.0) ARAD=20.0
C -------------------------------------
C
C     OPEN FILE :  COEF-MOD     NAMEM
C
      CALL LENSTR_BL(NAMEM,LEN)

      IF(LEN.LE.0.OR.NAMEM(1:1).EQ.','.OR.NAMEM(1:1).EQ.' ') THEN
        CALL MSGERR(MD,
     *  ' ERROR: in rfcoef_00n: wrong name of file: COEF_MOD')
        IERR = 1
        RETURN
      ENDIF
      LLL = LEN
      IF(LEN.GT.60) LLL=60
      LINE = 'Input file coef_mod:'//NAMEM(1:LLL)
      CALL MSGDOC(MD,LINE)
      MT    = 10
      ITP   = '    '
      CALL ORFILE(MD,MT,NAMEM,ITP,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,
     *  ' ERROR: in rfcoef_00n: can not open file: COEF_MOD')
        RETURN
      ENDIF
      IF(ITP.NE.'F   '.AND.ITP.NE.'FS  '.AND.ITP.NE.'COEF') THEN
        CALL MSGERR(MD,
     *  ' ERROR: in rfcoef_00n: wrong file type (coef_mod)')
        CLOSE(MT)
        IERR=1
        RETURN
      ENDIF

      CALL GET_TITLE(MD,RLATT(1),RLATT(2),
     . RLATT(3),RLATT(4),RLATT(5),RLATT(6),F1,F2,RN,RX,IDM,IDM
     . ,IDM,IDM,IDM,TITLE,IERR)
      CALL C_RD_CR

      FOUR = 'N'
      IF(ITP.EQ.'COEF') THEN
        IF(TITLE(1:4).EQ.'PATT') THEN
          FOUR = 'P'
          CALL MSGERR(MD,
     *    ' ERROR: in rfcoef_00n: wrong type of coefficients: "PATT"')
          CLOSE(MT)
          IERR=1
          RETURN          
        ELSE
          FOUR = 'F'
        ENDIF
      ENDIF
C -----------------------------------------------------
C
C     RESOLUTION LIMITS
C
      IF(RESMIN.LE.0.0) RESMIN = RN
      IF(RESMXF.LE.0.0) RESMXF = RX
      IF(RESMIN.GT.RN)  RESMIN = RN
      IF(RESMIN.EQ.RESMXF) THEN
        CALL MSGERR(MDOC,' ERR: RESMIN = RESMAX')
        IERR=1
        CLOSE(MT)
        RETURN
      ENDIF
C -----------------------------------------------------
C
C  CALC REPROC-CELL: ASTAR,BSTAR,CSTAR,
C                    COS(ALPHA-STAR),COS(BETA-STAR),COS(GAMMA-STAR)
C
      CALL DSTARF(RLATT,AST,BST,CST,COALST,COBEST,COGAST,VOL)
C ----------------------------------------
      PI    = 4.0*ATAN(1.0)
      PIBY2 = PI/2.
      TWOPI = PI*2.
      PI180 = PI/180.
      SVOL  = (4.0*PI*ARAD*ARAD*ARAD)/3.0
      WRITE(LINE,*) ' VOL(rad),VOL(cell):',SVOL,VOL
      CALL MSGDOC(MDOC,LINE)
C ------------------------------------------------
C
C     CHECK OF RESMAX
C
C     IPRBES=200 --> T2=48.0 ; IPRBES=400 --> T2=98.0
C                    LMAXP=30                 LMAXP=60
C                    NMAXP=15                 NMAXP=30
C
C      IF(LINDEX.EQ.30) THEN
C        ITEMP = 200
C        T2    = ITEMP/4-2
C        LMAXP = 30
C        NMAXP = 15
C        T1    = TWOPI*ARAD/T2
C        ITEMP = 400
C        T2    = ITEMP/4-2
C        LMAXP = 60
C        NMAXP = 30
C        T1    = TWOPI*ARAD/T2
C      ELSE
c      ITEMP = 400
      ITEMP = 600
C      T2    = ITEMP/4-2
c      LMAXP = 60
c      NMAXP = 30
      LMAXP = 100
      NMAXP = 50
C      T1    = TWOPI*ARAD/T2
C      ENDIF
C --------------------------------------------------------------
      CALL GET_BZEROS_100(BZEROS,NMAXP,LMAXP,IERR)
C ----
C      REAL    BZ(30,*)
C      1 =<NMAXP=<30, 0=<LMAXP=<60
C ----
       IF(IERR.NE.0) THEN
         CALL MSGERR(MDOC,
     *' ERROR: rfcoef: wrong index Lmax or Nmax')
         RETURN
       ENDIF
C --------------------------------------------------------------
C --------------------------------------------------------------
c      RESMAX_LIM  = (ARAD*TWOPI)/98.0
      RESMAX_LIM  = (ARAD*TWOPI)/109.35

      LINDEX = 0

      WRITE(LINE,*) ' resmax_lim,lindex:',RESMAX_LIM,lindex
      CALL MSGDOC(MDOC,LINE)

      IF(LINDEX.GT.0.AND.LINDEX.LE.100) THEN
        L = LINDEX
        RMAX   = BZEROS(1,L+2)
        RESMAX = (ARAD*TWOPI)/RMAX
      ELSE
        L      = 30
        RMAX   = BZEROS(1,L+2)
        RESMAX = (ARAD*TWOPI)/RMAX
        IF(RESMAX.GT.RESMXF) THEN      
          RESMAX = RESMXF  
        ENDIF
      ENDIF
      IF(RESMAX.LT.RESMAX_LIM) RESMAX = RESMAX_LIM
C -------
C      RESMAX = 0.1
C      IF(RESMAX.LT.T1) RESMAX = T1
C      IF(RESMAX.LT.RESMXF.AND.ITEMP.EQ.400.AND.LINDEX.NE.60) THEN
c        RESMAX = RESMXF
C      ENDIF
C -------

      RMAX = (ARAD*TWOPI)/RESMAX
      
      IF(RESMAX.GT.RESMXF) THEN
        RESMXF = RESMAX
        CALL MSGERR(MDOC,
     *' WARNING: For this radius integration program uses data included'
     *)
        WRITE(LINE,
     *'(''          between '',F7.1,'' and '',F7.2,'' (angstrom.).'')')
     *  RESMIN,RESMXF
        CALL MSGERR(MDOC,LINE)
      ENDIF

      RHMAX = 1.0/RESMXF
      RHMIN = 1.0/RESMIN

C ----------------------------------------------------------
C     WRITE INPUT INFORMATION
C
      IF(ABS(COALST).GE.1.E-5) THEN
        T = SQRT(ABS(1.-COALST*COALST))/COALST
        T = ATAN(T)
      ELSE
        T = PIBY2
      ENDIF
      TAS = ABS(T)
      IF(ABS(COBEST).GE.1.E-5) THEN
        T = SQRT(ABS(1.-COBEST*COBEST))/COBEST
        T = ATAN(T)
      ELSE
        T = PIBY2
      ENDIF
      TBS = ABS(T)
      IF(ABS(COGAST).GE.1.E-5) THEN
        T = SQRT(ABS(1.-COGAST*COGAST))/COGAST
        T = ATAN(T)
      ELSE
        T = PIBY2
      ENDIF
      TCS = ABS(T)
C ----
      TTAS = TAS/PI180
      TTBS = TBS/PI180
      TTCS = TCS/PI180
      WRITE(LINE,2006) ARAD
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,2007) RESMIN,RESMXF
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(''BOFF,BADD :'',2F8.2)') BOFF,BADD
      CALL MSGDOC(MDOC,LINE)
      IF(FOUR.EQ.'F') THEN
        WRITE(LINE,'(''Shift   :'',3F8.4)') (SHR(I),I=1,3)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(''Shift_m :'',3F8.4)') (SHM(I),I=1,3)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(''INVER,F000 :'',A,'' '',A)') INVER,F000
        CALL MSGDOC(MDOC,LINE)
      ENDIF
 2006 FORMAT('RADIUS OF CUT-OFF SPHERE ',F5.1,' ANGSTROMS')
 2007 FORMAT('DATA INCLUDED BETWEEN',F7.1,' AND ',F7.1,'( ANGSTROMS)')
 2008 FORMAT('ASTAR=',F8.5,' BSTAR=',F8.5,' CSTAR=',F8.5)
 2009 FORMAT('ALPHASTAR=',F8.4,' BETASTAR=',F8.4,' GAMMASTAR=',F8.4
     *      ,' (GRAD)')
 2010 FORMAT('FMOD OBOVE ',F8.1,' INCLUDED')
C --------------------------------------------------------------
      LMAX = 0
      IF(BZEROS(1,2).GT.RMAX) THEN
        WRITE(LINE,*) ' ERROR: RMAX ',RMAX
        CALL MSGDOC(MDOC,LINE)
        CLOSE(MT)
        IERR=1
        RETURN
      ENDIF
      DO     L=2,LMAXP+2
        IF(BZEROS(1,L).GT.RMAX) GO TO 50
        LMAX = L-2
        DO     N=1,NMAXP
          IF(BZEROS(N,L).GT.RMAX) GO TO 60
          IF(L.EQ.2) NMAX = N
        ENDDO
   60   CONTINUE
      ENDDO
   50 LMAX = (LMAX/2)*2
      IF(NMAXR.LE.   0) NMAXR = NMAX
      IF(NMAXR.GT.NMAX) NMAXR = NMAX
      NINDEX = NMAXR
      LINDEX = LMAX
C ---------------------------------------------------------------
      WRITE(LINE,2015) NMAXR,NMAX,NMIN
      CALL MSGDOC(MDOC,LINE)
 2015 FORMAT(5X,' NMAX_R,NMAX,NMIN = ',I5,I5,I5)

c
c      LMAX=30
c
      LMAX2 = LMAX+2
      LMAX1 = LMAX+1
C ---------------------------------------------
      DO  L=2,LMAX2
        DO     N=1,NMAX
          BZEROS(N,L)=BZEROS(N,L)/ARAD
        ENDDO
      ENDDO
C ----------------------------------------------
      A2PI    = TWOPI*ARAD
      A8PI    = 4.0*A2PI
      A42PI   = 2.0*SQRT(2.0*ARAD)*TWOPI
C ------------------
      ARGMAX = RMAX+1.

      WRITE(LINE,*) 'argmax:',ARGMAX,rmax,resmax
      CALL MSGDOC(MDOC,LINE)

      CALL SPHBES_RF(MDOC,LMAX,ARGMAX,SBES,IPRLM2,IPRBES,IERR)
      IF(IERR.GT.0) THEN
        CLOSE(MT)
C        CLOSE(MTOUT)
        IERR=1
        RETURN
      ENDIF
C ------------------
      IF(NMAX.GT.IPRALM) THEN
        WRITE(LINE,*) 
     *  ' ERROR: in rfcoef_00n: INDEX-MAX=',NMAX,' >',IPRALM
        CALL MSGERR(MDOC,LINE)
        CLOSE(MT)
C       CLOSE(MTOUT)
        IERR=1
        RETURN
      ENDIF

      IPRNT = 0
C      IPRNT = 1000

      IF(IPRNT.NE.0) THEN
        WRITE(LINE,1018)
        CALL MSGDOC(MDOC,LINE)
 1018   FORMAT('    N',4X,'H',4X,'K',4X,'L',8X,
     *  'SINTH',4X,'COTTH',6X,'PHI',7X,'   !F!')
      ENDIF
C
C      X --- A
C      Z --- C STAR
C
      SIALST = SIN(ACOS(COALST))
      SIBEST = SIN(ACOS(COBEST))
      SIGAST = SIN(ACOS(COGAST))

      TB11 = AST*SIGAST*SIBEST
      TB12 = AST*COGAST*SIBEST
      TB13 = AST*       COBEST
      TB22 = BST*SIALST
      TB23 = BST*COALST
      TB33 = CST
C ----------------------------------------------
      DO     I=1,IPRALM
        ALM(I) = 0.
      ENDDO
      J1    = 0
      IEND  =-1
      NBL   = 0
      PLM2  = SQRT(0.5)

      SCALE1 = 2.0/VOL

      CALL MSGDOC(MD0,'--- A00n (model)---')

C ---
  100 CONTINUE
C
C     READ H K L F  ; END OF FILE IEND=1
C
      IF(IEND.EQ.1) GO TO 200
      IF(ITP.EQ.'FS  ') THEN
        CALL RRD1(MT,IH(1),IK(1),IL(1),FA(1),FB(1),SDA,SDB
     .           ,NBL,IEND)
      ELSE
        CALL RD1(MT,IH(1),IK(1),IL(1),FA(1),FB(1),NBL,IEND)
      ENDIF
      IF(MT.LE.0) THEN
        CLOSE(MT)
        IERR=1
        RETURN
      ENDIF
CC -------------------------------------
      IF(IEND.GT.0) GO TO 200

      INF =1

      DO  I=1,INF
        IF(IH(1).EQ.0.AND.IK(1).EQ.0.AND.IL(1).EQ.0) THEN 
          RHSQJ = 0.0 
          F2    = FA(1)
          F2B   = FB(1)
          IF(F000.NE.'Y') GO TO 100
          GO TO 120
        ENDIF
        TH = IH(I)
        TK = IK(I)
        TL = IL(I)
        IF(IL(I).LT.0) GO TO 210
C......................
C        XX=TH*AST*SBETA
C        YY=TK*BST+TH*AST*CBETA
C        ZZ=TL*CST
C......MULTIPLY BY TRANSPOSE
        XX = TH*TB11
        YY = TH*TB12+TK*TB22
        ZZ = TH*TB13+TK*TB23+TL*TB33
C ---
        F2  = FA(I)
        F2B = FB(I)

        RSQ = XX*XX+YY*YY+ZZ*ZZ
        RH  = SQRT(RSQ)
        IF(RH.GT.RHMAX) GO TO 210
        IF(RH.LT.RHMIN) GO TO 210

        IF(BOFF.GT.0.0) THEN
          BT    = BOFF/4.0
          CBOFF = 1.0-EXP(-BT*RSQ)
        ELSE
          CBOFF = 1.0
        ENDIF

        IF(ABS(BADD).GT.0.01) THEN
          BT    = BADD/4.0
          CBADD = EXP(-BT*RSQ)
        ELSE
          CBADD = 1.0
        ENDIF

        IF(ITP.EQ.'COEF') THEN
          F2  = F2 *CBADD*CBOFF
          F2B = F2B*CBADD*CBOFF
        ELSE
          F2 = F2*CBADD*CBOFF*CBADD*CBOFF
        ENDIF

        J1 = J1+1

        IF(RH.LT.1.E-7) GO TO 210

  120   CONTINUE

        RHSQJ  = RSQ
        SINTHJ = SQRT(XX*XX+YY*YY)/RH
        COTTHJ = 0.0
        PHIJ   = 0.0
        IF((YY.NE.0.0).OR.(XX.NE.0.0)) THEN
          COTTHJ = ZZ/(RH*SINTHJ)
          PHIJ   = AATAN2(YY,XX)
        ENDIF

        IF(IPRNT.NE.0) THEN
          IF(MOD(J1,IPRNT).EQ.0) THEN
            IF(ITP.NE.'COEF') THEN
              FM = SQRT(ABS(F2))
            ELSE
              IF(FOUR.EQ.'F') THEN
                FM = SQRT(F2*F2 + F2B*F2B)
              ELSE
                FM = SQRT(F2)
              ENDIF
            ENDIF
            WRITE(LINE,1021) J1,TH,TK,TL,SINTHJ,COTTHJ,PHIJ,FM
            CALL MSGDOC(MDOC,LINE)
 1021       FORMAT(I6,3F5.0,4X,3F9.3,G16.4)
          ENDIF
        ENDIF
c ///
C                2*PI*ARAD*R
        ARG    = SQRT(RHSQJ)*A8PI+1.
        IARG   = INT(ARG)
        FRAC   = ARG-FLOAT(IARG)
C                SBES0(2*PI*ARAD*R)
        F2BESJ = ((1.-FRAC)*SBES(1,IARG)+FRAC*SBES(1,IARG+1))
                
        DO     N=NMIN,NMAXR
C         2PI*R0n
          BZ   = BZEROS(N,2)
c         4pi^2*R^2
          FAC3 = TWOPI*TWOPI*RHSQJ
                   
          IF(ABS(FAC3-BZ*BZ).GE.0.000001) THEN
c                  2PI*R0n /(4PI^2*R0n^2- 4pi^2*R^2)         
            FAC1 = BZ/(BZ*BZ-FAC3)
                    
C           FAC4 = PLM2*F2BESJ*FAC1
            FAC4 = (F2BESJ*FAC1*SQRT(2.0))/ARAD

          ELSE
C                  2PI*R0n*ARAD           
            ARG  = BZ*4.0*ARAD+1.000001
            IARG = ARG
            FRAC = ARG-IARG
C                  SBES1(2PI*R0n*ARAD)
            FAC5 = (1.-FRAC)*SBES(2,IARG)+FRAC*SBES(2,IARG+1)
            FAC4 = FAC5/SQRT(2.0)
          ENDIF

          FAC4 = FAC4*2.0*TWOPI

          ARG   = -(IH(I)*SHM(1)+IK(I)*SHM(2)+IL(I)*SHM(3))*TWOPI
          COSA  = COS(ARG)
          SINA  = SIN(ARG)

          T     = F2*COSA - F2B*SINA
          FFBB  = F2*SINA + F2B*COSA
          FFAA  = T

          ALM(N) = ALM(N) + FAC4*FFAA*SCALE1

        ENDDO
  210   CONTINUE
      ENDDO
      GO TO 100
C ------------------------------------
  200 CONTINUE
      CLOSE(MT)
      WRITE(LINE,1022) J1
      CALL MSGDOC(MDOC,LINE)
 1022 FORMAT(1X,' NUMBER OF REFLS=',I6)

C      write(*,*) 'NMIN,NMAXR:',NMIN,NMAXR,nsym
C ---
      AV12 = 0.0
      AV1  = 0.0
      DO  N=NMIN,NMAXR
        AV12 = AV12 + ALM(N)*ALM(N)
        AV1  = AV1  + ALM(N)
      ENDDO
      NN   = NMAXR - (NMIN-1)
      AV12 = SQRT(AV12/NN)
      AV1  = AV1/NN
      WRITE(LINE,'(''N,<A00n>,sqrt(<A00n^2>)'',I4,2F16.3)') NN,AV1,AV12
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' ')
C --------------------------------------

      CALL MSGDOC(MD0,'--- <A00n*B00n> ---')

C
C     OPEN FILE :  COEF_OBS     NAMEF
C
      CALL LENSTR_BL(NAMEF,LEN)
      IF(LEN.LE.0.OR.NAMEF(1:1).EQ.','.OR.NAMEF(1:1).EQ.' ') THEN
        CALL MSGERR(MD,
     *  ' ERROR: in rfcoef_00n: wrong name of file: COEF_OBS')
        IERR = 1
        RETURN
      ENDIF
      LLL = LEN
      IF(LLL.GT.60) LLL = 60
      LINE = 'Input file coef_obs:'//NAMEF(1:LLL)
      CALL MSGDOC(MD,LINE)
      MT    = 10
      ITP   = '    '
      MD    =-ABS(MDOC)-1
      CALL ORFILE(MD,MT,NAMEF,ITP,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,
     *  ' ERROR: in rfcoef_00n: can not open file: COEF_OBS')
        RETURN
      ENDIF
      IF(ITP.NE.'COEF') THEN
        CALL MSGERR(MD,
     *  ' ERROR: in rfcoef_00n: wrong file type (coef_obs)')
        CLOSE(MT)
        IERR=1
        RETURN
      ENDIF
      CALL GET_TITLE(MD,RLATT(1),RLATT(2),
     . RLATT(3),RLATT(4),RLATT(5),RLATT(6),F1,F2,RN,RX,IDM,IDM
     . ,IDM,IDM,IDM,TITLE,IERR)
      CALL C_RD_CR

      FOUR = 'N'
      IF(ITP.EQ.'COEF') THEN
        IF(TITLE(1:4).EQ.'PATT') THEN
          FOUR = 'P'
          CALL MSGERR(MD,
     *    ' ERROR: in rfcoef_00n: wrong type of coefficients: "PATT"')
          CLOSE(MT)
          IERR=1
          RETURN          
        ELSE
          FOUR = 'F'
        ENDIF
      ENDIF
C -------
      NAMEO = 'trfn_scr'
      CALL ADD_PATH(PATH_SCR,NAMEO)
      MTOUT = 12
      TYPE  = 'COEF'
      SCAL  = 1.0
      BTEMP = 0.0

      CALL C_CR_WR

      CALL SET_TITLE(M,RLATT(1),RLATT(2)
     . ,RLATT(3),RLATT(4),RLATT(5),RLATT(6),SCAL,BTEMP,RESMIN,RESMXF
     . ,IDM,IDM,IDM,IDM,IDM,TITLE,IERR)


      CALL OWFILE(M,MTOUT,NAMEO,TYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,
     *  ' ERROR: in rfcoef_00n: can not open output file: rfcoef_00n')
        CLOSE(MT)
        RETURN
      ENDIF
      NUMB3    = 0
      IEND3    =-1

      SCALE  = 2.0/VOL
      SCALE2 = 1.0

C --------------------------------------
      DO     I=1,IPRALM
        ALM1(I) = 0.
      ENDDO
      J1    = 0
      IEND  =-1
      NBL   = 0
      PLM2  = SQRT(0.5)
      IPRNT = 0
C ---------
  300 CONTINUE
C
C     READ H K L F  ; END OF FILE IEND=1
C
      IF(IEND.EQ.1) GO TO 400
      IF(ITP.EQ.'FS  ') THEN
        CALL RRD1(MT,IH(1),IK(1),IL(1),FA(1),FB(1),SDA,SDB
     .           ,NBL,IEND)
      ELSE
        CALL RD1(MT,IH(1),IK(1),IL(1),FA(1),FB(1),NBL,IEND)
      ENDIF
      IF(MT.LE.0) THEN
        CLOSE(MTOUT)
        IERR=1
        RETURN
      ENDIF
C -------------------------------------
      IF(IEND.GT.0) GO TO 400

      IF(INVER.EQ.'Y') FB(1) = -FB(1)

      INF = 1

      DO  I=1,INF
        IF(IH(1).EQ.0.AND.IK(1).EQ.0.AND.IL(1).EQ.0) THEN 

          RHSQJ = 0.0
          F2    = FA(1)
          F2B   = FB(1)
          IF(F000.NE.'Y') GO TO 300
          GO TO 320
        ENDIF
        TH = IH(I)
        TK = IK(I)
        TL = IL(I)
        IF(IL(I).LT.0) GO TO 410
C......................
C        XX=TH*AST*SBETA
C        YY=TK*BST+TH*AST*CBETA
C        ZZ=TL*CST
C......MULTIPLY BY TRANSPOSE
        XX = TH*TB11
        YY = TH*TB12+TK*TB22
        ZZ = TH*TB13+TK*TB23+TL*TB33
C ---
        F2  = FA(I)
        F2B = FB(I)

        RSQ = XX*XX+YY*YY+ZZ*ZZ
        RH  = SQRT(RSQ)
        IF(RH.GT.RHMAX) GO TO 410
        IF(RH.LT.RHMIN) GO TO 410

        IF(BOFF.GT.0.0) THEN
          BT    = BOFF/4.0
          CBOFF = 1.0-EXP(-BT*RSQ)
        ELSE
          CBOFF = 1.0
        ENDIF

        IF(ABS(BADD).GT.0.01) THEN
          BT    = BADD/4.0
          CBADD = EXP(-BT*RSQ)
        ELSE
          CBADD = 1.0
        ENDIF

        IF(ITP.EQ.'COEF') THEN
          F2  = F2 *CBADD*CBOFF
          F2B = F2B*CBADD*CBOFF
        ELSE
          F2 = F2*CBADD*CBOFF*CBADD*CBOFF
        ENDIF

        J1 = J1+1

        IF(RH.LT.1.E-7) GO TO 410

        RHSQJ  = RSQ
        SINTHJ = SQRT(XX*XX+YY*YY)/RH
        COTTHJ = 0.0
        PHIJ   = 0.0
        IF((YY.NE.0.0).OR.(XX.NE.0.0)) THEN
          COTTHJ = ZZ/(RH*SINTHJ)
          PHIJ   = AATAN2(YY,XX)
        ENDIF

        IF(IPRNT.NE.0) THEN
          IF(MOD(J1,IPRNT).EQ.0) THEN
            IF(ITP.NE.'COEF') THEN
              FM = SQRT(ABS(F2))
            ELSE
              IF(FOUR.EQ.'F') THEN
                FM = SQRT(F2*F2 + F2B*F2B)
              ELSE
                FM = SQRT(F2)
              ENDIF
            ENDIF
            WRITE(LINE,1021) J1,TH,TK,TL,SINTHJ,COTTHJ,PHIJ,FM
            CALL MSGDOC(MDOC,LINE)
C 1021       FORMAT(I6,3F5.0,4X,3F9.3,G16.4)
          ENDIF
        ENDIF

  320   CONTINUE

c ///
C                2*PI*ARAD*R
        ARG    = SQRT(RHSQJ)*A8PI+1.
        IARG   = INT(ARG)
        FRAC   = ARG-FLOAT(IARG)
C                SBES0(2*PI*ARAD*R)
        F2BESJ = ((1.-FRAC)*SBES(1,IARG)+FRAC*SBES(1,IARG+1))
                
        FAA = 0.0
        FBB = 0.0

        DO     N=NMIN,NMAXR
C         2PI*R0n
          BZ   = BZEROS(N,2)
c         4pi^2*R^2
          FAC3 = TWOPI*TWOPI*RHSQJ
                   
          IF(ABS(FAC3-BZ*BZ).GE.0.000001) THEN
c                  2PI*R0n /(4PI^2*R0n^2- 4pi^2*R^2)         
            FAC1 = BZ/(BZ*BZ-FAC3)
                    
C           FAC4 = PLM2*F2BESJ*FAC1
            FAC4 = (F2BESJ*FAC1*SQRT(2.0))/ARAD

          ELSE
C                  2PI*R0n*ARAD           
            ARG  = BZ*4.0*ARAD+1.000001
            IARG = ARG
            FRAC = ARG-IARG
C                  SBES1(2PI*R0n*ARAD)
            FAC5 = (1.-FRAC)*SBES(2,IARG)+FRAC*SBES(2,IARG+1)
            FAC4 = FAC5/SQRT(2.0)
          ENDIF

          FAC4 = FAC4*2.0*TWOPI

          FAA  = FAA + ALM(N) * FAC4 * F2  * SCALE2
          FBB  = FBB + ALM(N) * FAC4 * F2B * SCALE2

c          FAA  = FAA + FAC4 * F2  * SCALE
c          FBB  = FBB + FAC4 * F2B * SCALE

          ARG   = -(IH(I)*SHR(1)+IK(I)*SHR(2)+IL(I)*SHR(3))*TWOPI
          COSA  = COS(ARG)
          SINA  = SIN(ARG)

          T     = F2*COSA - F2B*SINA
          FFBB  = F2*SINA + F2B*COSA
          FFAA  = T

          ALM1(N) = ALM1(N) + FAC4*FFAA*SCALE
   
        ENDDO
        CALL WRT(MTOUT,IH(I),IK(I),IL(I),FAA,FBB,NUMB3,IEND3)
        IF(MTOUT.LE.0) THEN
          WRITE(LINE,*) ' ERROR: in rfcoef_00n: write to output file'
          CALL MSGERR(MDOC,LINE)
          CLOSE(MT)
          CLOSE(MTOUT)
          IERR=1
          RETURN
        ENDIF 
  410   CONTINUE
      ENDDO
      GO TO 300
C ==============================================
  400 CONTINUE
      CLOSE(MT)
      WRITE(LINE,1022) J1
      CALL MSGDOC(MDOC,LINE)
C 1022 FORMAT(1X,' NUMBER OF REFLS=',I6)
C ---
      IEND3=2
      CALL WRT(MTOUT,IH(1),IK(1),IL(1),FAA,FBB,NUMB3,IEND3)
      CLOSE(MTOUT)

      AV22 = 0.0
      AV12 = 0.0
      AV1  = 0.0
      AV2  = 0.0
      CO   = 0.0
      NN   = NMAXR - (NMIN-1)
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,' N              B00n     A00n_mod')
      CALL MSGDOC(MDOC,' ')
      DO  N=NMIN,NMAXR
        AV12 = AV12 + ALM(N) *ALM(N)
        AV22 = AV22 + ALM1(N)*ALM1(N)
        CO   = CO   + ALM(N) *ALM1(N)
        AV1  = AV1  + ALM(N)
        AV2  = AV2  + ALM1(N)
        WRITE(LINE,'(I3,1X,2F16.4)') N,ALM1(N),ALM(N)
        CALL MSGDOC(MDOC,LINE)
      ENDDO

      COO   =  CO 
      COOS  =  CO/NN
      AV1S  =  AV1/NN 
      AV2S  =  AV2/NN  
      AV12S =  AV12/NN
      AV22S =  AV22/NN


      CC = (NN*CO-AV1*AV2)/SQRT((NN*AV12-AV1*AV1)*(NN*AV22-AV2*AV2))
      CO = CO/SQRT((AV12)*(AV22))

      CALL MSGDOC(MDOC,' ')
      WRITE(LINE,'(a,2F8.4,F18.4)') ' CO,CC:',CO,CC,COO
      CALL MSGDOC(MDOC,LINE)

      AV12Q = SQRT(AV12)
      WRITE(LINE,'(''<A00n>,sqrt(<A00n^2>)'',2F16.3)') AV1,AV12Q
      CALL MSGDOC(MDOC,LINE)

      AV22Q = SQRT(AV22)
      WRITE(LINE,'(''<B00n>,sqrt(<B00n^2>)'',2F16.3)') AV2,AV22Q
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' ')

C --------------------------------
      F0     =-1.0
      IZMIN  = 0
      IZMAX  =-1
      NX     = 0
      NY     = 0
      NZ     = 0
      NAMET  = 'trfun_saptf'
      CALL ADD_PATH(PATH_SCR,NAMET)

      CALL FFT(M,NX,NY,NZ,IZMIN,IZMAX,F0,NAMEO
     * ,NAMET,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C ---
      MMM      = MDOC_PSRCH
      MMM      = 99
C      CALL MSGDOC(MD0,'--- peaksrch  / <A00n*B00N> / ---')
      CALL MSGDOC(MMM,'--- peaksrch  / SAPTF / ---')
      ALEVEL   = RMS_INPUT
      NAMES    = ' '

C      NPMAX    = 20
C      IF(LIST.EQ.'S') NPMAX = NPEAK
      NPMAX = NPEAK
      NPMAX = 50
      IF(NPEAK2.GT.0) NPMAX = NPEAK2
      IF(NPMAX.GT.IPRMAX) NPMAX = IPRMAX 

      DIST_LIM = 0.0
      SPEC     = 'Y'

      CALL PEAKSRCH(MMM,NAMET,NAMES,ALEVEL,DIST_LIM,SPEC,NPMAX
     *     ,ISYM,IPRSYM,RESULT,IPRMAX,IPRROW,IERR)
      IF(IERR.NE.0) GO TO 900

      SHR(1) = RESULT(1, 9)
      SHR(2) = RESULT(1,10)
      SHR(3) = RESULT(1,11)

      CORR   = RESULT(1, 4)
      SIG    = RESULT(1, 5)

c      WRITE(*,*) SHR(1), SHR(2), SHR(3), CORR , SIG

C --------------------------------
 900  CONTINUE
      RETURN
C ----------------------------
      END

      SUBROUTINE PREFOBS(MDOC,NAMEM,NAMEM2,NAMEF2,NAMEPH2,NAMEC
     * ,PATH_SCR,RESMAX,RESN_SCL,SH_MOD2,SURF,BLIM,NA_TOT
     * ,SH_O_TO_CELL,ISYM,IPRSYM,IERR)
C ----------------------------------
      PARAMETER (IPRROW = 51)
      REAL      RESULT(51),RESULTA(51)
      INTEGER   MDOC,IERR
C ---------
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER NAMEF2*(*),NAMEPH2*(*)
      CHARACTER NAMEM*(*),NAMEM2*(*),NAMEC*(*)
      REAL      AM(3,3),SH1(3),SH2(3),SH_MOD2(3)
      REAL      RLATT(6),SH_O_TO_CELL(3)
      INTEGER   NSPGROUP,NOSETT
      CHARACTER CODE*4,DATE*9,SPGR*24
C ---
      CHARACTER NAMED*256,NAMES*256,NAME*256,NAMET*256,NAME_SCR*256
      CHARACTER PATH_SCR*(*)

      CHARACTER P1*1,MODE*1,TTT*80,SURF*1,MSHIFT*1
      CHARACTER WAT*1,ALT*1,SETT*1,REST*1,HATM*1,NUM*1,NOCC*1,CONV*1
      CHARACTER LINE*256
C ---------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      MD0  = 0
      PI    = 4.0*ATAN(1.0)
      PI180 = PI/180.
C ----
      IF(RESN_SCL.GT.0.00001) THEN
c        BOFF_SCL = 4.0 * RESN_SCL * RESN_SCL
        BOFF_SCL = 2.0 * RESN_SCL * RESN_SCL
      ELSE
        BOFF_SCL = 256.0
      ENDIF
      NMR = 0
      BLIM = 0.0
      NA_TOT = 0

C      CALL MSGDOC(MDOC,'--- PREFOBS. ---')
C ---------------------------------------------
C     CALL MSGDOC(MD0,'--- read coordinates of model_2. ---')
      MODE = 'E'
      DO I=1,3
        SH1(I) = 0.0
        SH2(I) = 0.0
        DO J=1,3
          AM(I,J) = 0.0
        ENDDO
      ENDDO
      ALPHA = 0.0
      BETA  = 0.0
      GAMMA = 0.0
      NAMES = ' '
      CALL TRANS(M,NAMEM2,NAMES,SH1,SH2
     *    ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
       IF(IERR.NE.0) GO TO 900
C      RESULT(1) = NTOT
C      RESULT(2) = XMIN
C      RESULT(3) = XMAX
C      RESULT(4) = YMIN
C      RESULT(5) = YMAX
C      RESULT(6) = ZMIN
C      RESULT(7) = ZMAX
C      RESULT(8) = XS
C      RESULT(9) = YS
C      RESULT(10)= ZS
C      RESULT(11)= RI
      CALL C_AT_CR
      NA_TOT = RESULT(1)
      XC = RESULT(8) 
      YC = RESULT(9) 
      ZC = RESULT(10)

      CALL GET_CELL(RLATT,CODE,NAME,DATE,TTT
     *     ,NSPGROUP,NOSETT,SPGR,NSM,IERR)
C
      A = RLATT(1)
      B = RLATT(2)
      C = RLATT(3)

C      WRITE(line,*) 'CENTR:',XC,YC,ZC
C      call msgdoc(mdoc,line)

      NAMET = NAMEM2
      XS = 0.0 
      YS = 0.0 
      ZS = 0.0 
      NA_INSIDE = 0

C ---------------------------------------------------------
      IF(SURF.EQ.'Y'.OR.SURF.EQ.'C') THEN

        NAMES  = 'molrp_src'
        CALL ADD_PATH(PATH_SCR,NAMES)

        RH2O   = 0.0
        DEL    = 0.0
        IF(BLIM.LE.0.0) BLIM   = 15.0
        CALL SURFACE(M,NAMEM2,NAMES,RH2O,DEL,BLIM,NMR,SURF
     *  ,RESULTA,IPRROW,ISYM,IPRSYM,IERR)
C       RESULT(1) = NR
C       RESULT(2) = SURFA
C       RESULT(3) = SURFC
C       RESULT(4) = XSH
C       RESULT(5) = YSH
C       RESULT(6) = ZSH
CC        SH1(1) = -RESULTA(4)
CC        SH1(2) = -RESULTA(5)
CC        SH1(3) = -RESULTA(6)

        SH1(1) = -XC
        SH1(2) = -YC
        SH1(3) = -ZC

        N_MODEL = RESULTA(7)
        NA_INSIDE = RESULT(8) 

c        WRITE(*,*) 'Natom_inside:',NA_INSIDE
c        WRITE(line,*) 'Natom_inside:',NA_INSIDE
c        call msgdoc(mdoc,line)

        XS = -SH1(1)
        YS = -SH1(2)
        ZS = -SH1(3)

        MODE = 'E'
        DO I=1,3
          SH2(I) = 0.0
          DO J=1,3
            AM(I,J) = 0.0
          ENDDO
        ENDDO
        ALPHA = 0.0
        BETA  = 0.0
        GAMMA = 0.0

        NAMET = 'molrep1'
        CALL ADD_PATH(PATH_SCR,NAMET)

        CALL TRANS(M,NAMES,NAMET,SH1,SH2
     *    ,MODE,AM,ALPHA,BETA,GAMMA,RESULTA,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
C       RESULT(1) = NTOT
C       RESULT(2) = XMIN
C       RESULT(3) = XMAX
C       RESULT(4) = YMIN
C       RESULT(5) = YMAX
C       RESULT(6) = ZMIN
C       RESULT(7) = ZMAX
C       RESULT(8) = XS
C       RESULT(9) = YS
C       RESULT(10)= ZS
C       RESULT(11)= RI

C        WRITE(line,*) 'C_N:',RESULTA(8),RESULTA(9),RESULTA(10)
C        call msgdoc(mdoc,line)

      ELSE IF(SURF.EQ.'O'.OR.SURF.EQ.'A'.OR.SURF.EQ.'2') THEN

        NAMET = 'molrep1'
        CALL SHIFT2O(M,SURF,NAMEM2,NAMET,PATH_SCR,SH1,NMR
     *  ,N_MODEL,NA_TOT,NA_INSIDE
     *  ,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900

        XS = -SH1(1)
        YS = -SH1(2)
        ZS = -SH1(3)

      ENDIF

C      WRITE(line,*) '>>>:',XS,YS,ZS
C      CALL MSGDOC(MDOC,LINE)

C -----------------------------------------------------------
C      RESMAX_FFT = RESMAX*0.9
      RESMAX_FFT = RESMAX
      WRITE(LINE,'('' Resmax for calc Fmod:'',2F8.2)') RESMAX_FFT
      CALL MSGDOC(MD,LINE)

      CALL LIMHKL(RESMAX_FFT,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)

      WRITE(LINE,*) 'NX,NY,NZ:',NXMIN,NYMIN,NZMIN
      CALL MSGDOC(MDOC,LINE)

      WRITE(LINE,'(a,6f8.2)') 'xyz:min,max:'
     * ,RESULT(2),RESULT(3),RESULT(4),RESULT(5),RESULT(6),RESULT(7)
      CALL MSGDOC(MDOC,LINE)

      CELL_ADD = 5.0      

      XMIN     = RESULT(2) 
      XMAX     = RESULT(3)
      DX       =-(XMIN-CELL_ADD)
      XMAX_NEW = XMAX+DX+CELL_ADD
      AP1      = XMAX_NEW
      IXMIN    = 0
      IXMAX    = (XMAX_NEW*NXMIN)/AP1
      IF(IXMAX.GE.NXMIN) IXMAX = NXMIN-1
      WRITE(LINE,'('' IXmin='',I3,'' IXmax='',I3)') IXMIN,IXMAX
      CALL MSGDOC(MDOC,LINE)

      YMIN     = RESULT(4) 
      YMAX     = RESULT(5)
      DY       =-(YMIN-CELL_ADD)
      YMAX_NEW = YMAX+DY+CELL_ADD
      BP1      = YMAX_NEW
      IYMIN    = 0
      IYMAX    = (YMAX_NEW*NYMIN)/BP1
      IF(IYMAX.GE.NYMIN) IYMAX = NYMIN-1
      WRITE(LINE,'('' IYmin='',I3,'' IYmax='',I3)') IYMIN,IYMAX
      CALL MSGDOC(MDOC,LINE)

      ZMIN     = RESULT(6) 
      ZMAX     = RESULT(7)
      DZ       =-(ZMIN-CELL_ADD)
      ZMAX_NEW = ZMAX+DZ+CELL_ADD
      CP1      = ZMAX_NEW
      IZMIN    = 0
      IZMAX    = (ZMAX_NEW*NZMIN)/CP1
      IF(IZMAX.GE.NZMIN) IZMAX = NZMIN-1
      WRITE(LINE,'('' IZmin='',I3,'' IZmax='',I3)') IZMIN,IZMAX
      CALL MSGDOC(MDOC,LINE)
C ---
      SH_MOD2(1) = - DX 
      SH_MOD2(2) = - DY
      SH_MOD2(3) = - DZ

      SH1(1)     = DX + XS
      SH1(2)     = DY + YS
      SH1(3)     = DZ + ZS

      SH_O_TO_CELL(1) = SH1(1)
      SH_O_TO_CELL(2) = SH1(2)
      SH_O_TO_CELL(3) = SH1(3)

C        WRITE(line,*) 'dx:',DX,DY,DZ
C        CALL MSGDOC(MDOC,LINE)
C        WRITE(line,*) 'SH1:', SH1(1),SH1(2),SH1(3)
C        CALL MSGDOC(MDOC,LINE)

      MODE = 'E'
      DO I=1,3
        SH2(I)= 0.0
        DO J=1,3
          AM(I,J) = 0.0
        ENDDO
      ENDDO
      ALPHA  = 0.0
      BETA   = 0.0
      GAMMA  = 0.0

      NAMES  = 'molrp_src'
      CALL ADD_PATH(PATH_SCR,NAMES)
        
      CALL TRANS(M,NAMET,NAMES,SH1,SH2
     *    ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C --------------------------------------------
C     CALL MSGDOC(MD0,'--- concrd ---')
      MODE  = 'C'
      WAT   = 'Y'
      P1    = 'Y'
      ALT   = 'Y'
      SETT  = 'N'
      REST  = 'N'
      BOV   = -999.0
      A     = AP1
      B     = BP1
      C     = CP1
      ALPHA = 90.0
      BETA  = 90.0
      GAMMA = 90.0
      HATM  = 'Y'
      NUM   = 'N'
      NOCC  = 'R'
      CONV  = 'N'

      NAMEC = 'molrep4'
      CALL ADD_PATH(PATH_SCR,NAMEC)

      NAMED = ' '
c      IF(SURF.EQ.'A') THEN
c        MODE  = 'A'
c        BOV   = 20.0
c      ENDIF
      CALL CONCRD(M,MODE,NAMES,NAMEC,NAMED,SETT,REST
     *  ,WAT,P1,HATM,NUM,NOCC,ALT,CONV
     *  ,A,B,C,ALPHA,BETA,GAMMA,BOV,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C -----------
C     CALL MSGDOC(MD0,'--- generate density ---')
      RAD   = 0.0
      IF(SURF.EQ.'Y'.OR.SURF.EQ.'C') THEN
        RAD = BLIM + 0.000001
      ENDIF
      H2OBG = 0.0
      BADDD = 0.0
      P1    = 'Y' 
      NX    = 0
      NY    = 0
      NZ    = 0
c      IZMAX =-1
c      IZMIN = 0
      MODE  = ' '
      IF(SURF.EQ.'C') MODE = 'C'
      TTT   = ' '

      NAMED = 'molrp_scr'
      CALL ADD_PATH(PATH_SCR,NAMED)

      IERR  = 0
      ZFADD = 0.0
      CALL GENDEN(M,NAMEC,NAMED,TTT
     * ,RESMAX_FFT,NX,NY,NZ,IZMIN,IZMAX,MODE,RAD,H2OBG,BADDD,P1,ZFADD
     * ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C     NEL - RESULT(1)
C ---------------------------------------
C     CALL MSGDOC(MD0,'--- real fft ---')

      NAMEF2   = 'molrep_fob'
      CALL ADD_PATH(PATH_SCR,NAMEF2)

      NAMEPH2  = 'molrep_ph'
      CALL ADD_PATH(PATH_SCR,NAMEPH2)

      NAME_SCR = 'molrp_scratch_rft'
      CALL ADD_PATH(PATH_SCR,NAME_SCR)

      CALL RFT(M,RESMAX_FFT
     * ,NAMED,NAMEF2,NAMEPH2,PATH_SCR,ISYM,IPRSYM,RESULT
     * ,IERR)
      IF(IERR.NE.0) GO TO 900
C ------------------------------------------------

C     CALL MSGDOC(MD0,'--- concrd ---')

      NAMEC = 'molrep3'
      CALL ADD_PATH(PATH_SCR,NAMEC)

      MODE  = 'C'
      WAT   = 'Y'
      P1    = 'Y'
      ALT   = 'Y'
      SETT  = 'N'
      REST  = 'N'
      BOV   = -999.0
      A     = AP1
      B     = BP1
      C     = CP1
      ALPHA = 90.0
      BETA  = 90.0
      GAMMA = 90.0
C      A     = RLATT(1)
C      B     = RLATT(2)
C      C     = RLATT(3)
C      ALPHA = RLATT(4)/PI180
C      BETA  = RLATT(5)/PI180
C      GAMMA = RLATT(6)/PI180
      NAMES = ' '
      HATM  = 'Y'
      NUM   = 'N'
      NOCC  = 'R'
      CONV  = 'N'

C      WRITE(line,*) 'a,b,c:',a,b,c
C      call msgdoc(mdoc,line)

      CALL CONCRD(M,MODE,NAMEM,NAMEC,NAMES,SETT,REST
     *  ,WAT,P1,HATM,NUM,NOCC,ALT,CONV
     *  ,A,B,C,ALPHA,BETA,GAMMA,BOV,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C ------------------------------------------------
 900  CONTINUE

      NAMES='molrp_scr.crd'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='molrp_scr.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES = 'molrp_scratch_rft'
      CALL DELETE_FILE(PATH_SCR,NAMES)

      RETURN
      END

      SUBROUTINE SHIFT_BACK(MDOC,NAMEM,PATH_SCR
     *                      ,SH,RESULT,ISYM,IPRSYM,IERR)
C ---------------------------------------------
      INTEGER    MDOC,IPRSYM,IERR
      INTEGER*2  ISYM(5,3,IPRSYM)
      REAL       RESULT(*),SH(3),SH1(3),SH2(3),AM(3,3)
      CHARACTER  NAMEM*(*),PATH_SCR*(*)
      CHARACTER  LINE*256,NAMES*256
      CHARACTER  MODE*1
C ---------------------------------------------
      IERR = 0
      M    = 99
C ---
      WRITE(LINE,*) 'Shift_back:',SH(1),SH(2),SH(3)
      CALL MSGDOC(MDOC,LINE)

      MODE = 'E'
      DO I=1,3
        SH2(I)= 0.0
        DO J=1,3
          AM(I,J) = 0.0
        ENDDO
      ENDDO
      SH1(1) = SH(1)
      SH1(2) = SH(2)
      SH1(3) = SH(3)
      ALPHA  = 0.0
      BETA   = 0.0
      GAMMA  = 0.0

      NAMES  = 'molrp_src'        
      CALL ADD_PATH(PATH_SCR,NAMES)

      CALL TRANS(M,NAMEM,NAMES,SH1,SH2
     *    ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C ---
C ---
      MODE = 'E'
      DO I=1,3
        SH1(I)= 0.0
        SH2(I)= 0.0
        DO J=1,3
          AM(I,J) = 0.0
        ENDDO
      ENDDO
      ALPHA  = 0.0
      BETA   = 0.0
      GAMMA  = 0.0        
      CALL TRANS(M,NAMES,NAMEM,SH1,SH2
     *    ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C ---
 900  CONTINUE

      NAMES='molrp_scr.crd'
      CALL DELETE_FILE(PATH_SCR,NAMES)

      RETURN
      END

      SUBROUTINE SHIFT_MOD1_TO_MOD2(MDOC,NAMEM,PATH_SCR
     *            ,SH_O_TO_CELL,SH,RESULT,ISYM,IPRSYM,IERR)
C ---------------------------------------------
      INTEGER    MDOC,IPRSYM,IERR
      INTEGER*2  ISYM(5,3,IPRSYM)
      REAL       RESULT(*),SH(3),SH1(3),SH2(3),AM(3,3),SH_MOD1(3)
      REAL       SH_O_TO_CELL(3)
      CHARACTER  NAMEM*(*),PATH_SCR*(*)
      CHARACTER  LINE*256,NAMES*256
      CHARACTER  MODE*1
C ---------------------------------------------
      IERR = 0
      M    = 99
C ---
      MODE = 'E'
      DO I=1,3
        SH1(I) = 0.0
        SH2(I) = 0.0
        DO J=1,3
          AM(I,J) = 0.0
        ENDDO
      ENDDO
      ALPHA = 0.0
      BETA  = 0.0
      GAMMA = 0.0
      NAMES = ' '
      CALL TRANS(M,NAMEM,NAMES,SH1,SH2
     *    ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
       IF(IERR.NE.0) GO TO 900
C ---
      SH_MOD1(1) = - RESULT( 8) 
      SH_MOD1(2) = - RESULT( 9)
      SH_MOD1(3) = - RESULT(10)

C      WRITE(LINE,*) 'Shift_to 0:',SH_MOD1(1),SH_MOD1(2),SH_MOD1(3)
C      CALL MSGDOC(MDOC,LINE)
C      WRITE(LINE,*) 'Shift_to cell:'
C     *   ,SH_O_TO_CELL(1),SH_O_TO_CELL(2),SH_O_TO_CELL(3)
C      CALL MSGDOC(MDOC,LINE)

      MODE = 'E'
      DO I=1,3
       SH1(I)= 0.0
       DO J=1,3
          AM(I,J) = 0.0
        ENDDO
      ENDDO

      SH2(1) = SH_MOD1(1)
      SH2(2) = SH_MOD1(2)
      SH2(3) = SH_MOD1(3)

      ALPHA  = 0.0
      BETA   = 0.0
      GAMMA  = 0.0

      NAMES  = 'molrp_src'        
      CALL ADD_PATH(PATH_SCR,NAMES)

      CALL TRANS(M,NAMEM,NAMES,SH1,SH2
     *    ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C ---
C ---
      MODE = 'E'
      DO I=1,3
        SH2(I)= 0.0
        DO J=1,3
          AM(I,J) = 0.0
        ENDDO
      ENDDO
      SH1(1) = SH_O_TO_CELL(1)
      SH1(2) = SH_O_TO_CELL(2)
      SH1(3) = SH_O_TO_CELL(3)
      ALPHA  = 0.0
      BETA   = 0.0
      GAMMA  = 0.0        
      CALL TRANS(M,NAMES,NAMEM,SH1,SH2
     *    ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C ---
 900  CONTINUE

      NAMES='molrp_scr.crd'
      CALL DELETE_FILE(PATH_SCR,NAMES)

      RETURN
      END

      SUBROUTINE SHIFT2O(MDOC,SURF,NAMEM,NAMEC,PATH_SCR
     * ,SH_MOD,NMR,N_MODEL,NA_TOT
     * ,NA_INSIDE,ISYM,IPRSYM,IERR)
C ----------------------------------
      PARAMETER (IPRROW = 51)
      REAL      RESULT(51)
      INTEGER   MDOC,IERR,NA_INSIDE
C ---------
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER NAMEM*(*),NAMEC*(*),PATH_SCR*(*),SURF*1
      REAL      AM(3,3),SH1(3),SH2(3),SH_MOD(3)
C ---
      CHARACTER P1*1
      CHARACTER WAT*1,ALT*1,SETT*1,REST*1,HATM*1,NUM*1,NOCC*1,CONV*1
      CHARACTER MODE*1,NAMES*256,NAMET*256,MODE3*3
      CHARACTER LINE*256
C ---------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      MD0  = 0
      PI    = 4.0*ATAN(1.0)
      PI180 = PI/180.
      NA_INSIDE = 0
C ----
c      CALL MSGDOC(MD0,'--- SHIFT2O. ---')
C ----
      NAMET = NAMEM 

      IF(SURF.EQ.'A'.OR.SURF.EQ.'2') THEN

        NAMET  = 'molrp_scr'
        CALL ADD_PATH(PATH_SCR,NAMET)

C        CALL MSGDOC(MD0,'--- concrd... ---')

        MODE  = ' '
        IF(SURF.EQ.'A') MODE  = 'B'
        WAT   = 'Y'
        P1    = 'N'
        ALT   = 'Y'
        SETT  = 'N'
        REST  = 'N'
        BOV   = 20.0
        A     = 0.0
        B     = 0.0
        C     = 0.0
        ALPHA = 0.0
        BETA  = 0.0
        GAMMA = 0.0
        NAMES = ' '
        HATM  = 'Y'
        NUM   = 'N'
        NOCC  = 'R'
        CONV  = 'N'

        CALL CONCRD(M,MODE,NAMEM,NAMET,NAMES,SETT,REST
     *    ,WAT,P1,HATM,NUM,NOCC,ALT,CONV
     *    ,A,B,C,ALPHA,BETA,GAMMA,BOV,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900

      ENDIF
C ---------------------------------------------
c     CALL MSGDOC(MD0,'--- read coordinates of model. ---')
      MODE = 'E'
      DO I=1,3
        SH1(I) = 0.0
        SH2(I) = 0.0
        DO J=1,3
          AM(I,J) = 0.0
        ENDDO
      ENDDO
      ALPHA = 0.0
      BETA  = 0.0
      GAMMA = 0.0
      NAMES = ' '
      CALL TRANS(M,NAMET,NAMES,SH1,SH2
     *    ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
       IF(IERR.NE.0) GO TO 900
C      RESULT(1) = NTOT
C      RESULT(2) = XMIN
C      RESULT(3) = XMAX
C      RESULT(4) = YMIN
C      RESULT(5) = YMAX
C      RESULT(6) = ZMIN
C      RESULT(7) = ZMAX
C      RESULT(8) = XS
C      RESULT(9) = YS
C      RESULT(10)= ZS
C      RESULT(11)= RI
C -----------------------------------------------------------
C ---
      SH_MOD(1) = - RESULT( 8) 
      SH_MOD(2) = - RESULT( 9)
      SH_MOD(3) = - RESULT(10)

      SH1(1)    = SH_MOD(1)
      SH1(2)    = SH_MOD(2)
      SH1(3)    = SH_MOD(3)
      MODE3 = 'E  '
      DO I=1,3
        SH2(I)= 0.0
        DO J=1,3
          AM(I,J) = 0.0
        ENDDO
      ENDDO
      ALPHA  = 0.0
      BETA   = 0.0
      GAMMA  = 0.0
      IERR   = 0  
      IF(SURF.EQ.'S') MODE3(3:3) = 'S'   
      IF(NMR.LT.0) IERR = ABS(NMR)
      CALL TRANS(M,NAMET,NAMEC,SH1,SH2
     *    ,MODE3,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C      RESULT(1) = NTOT
C      RESULT(12)= MODEL
C      RESULT(13)= NMODEL
      NA_TOT     = RESULT(1) 
      NA_INSIDE  = RESULT(14)
      N_MODEL    = RESULT(13) 
      IF(NMR.LT.0) THEN
        N_MODEL = 1
        NMR = 0
      ENDIF
C ------------------------------------------------
 900  CONTINUE

       NAMET='molrp_scr.crd'
       CALL DELETE_FILE(PATH_SCR,NAMET)

      RETURN
      END

      SUBROUTINE TRFUN_S(MDOC,NAMEF,NAMEM,NAME_TAB,PATH_SCR
     * ,MOD1,ANGLES,SVECTOR,NREFP
     * ,RESN,RESN_SCL,RESX,BOFF,BADD,BADD_SCL
     * ,ANISO,SURF,LIST
     * ,N_RF,N_TF,DA1,DA2,DA3,DX,DY,DZ
     * ,ISYM,IPRSYM
     * ,RESULT,RESULT2,RESULT3,IPRMAX,IPRROW,IERR)
C --------------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
C ----
      REAL      RESULT(IPRMAX,IPRROW),ANGLES(3),SVECTOR(3)
      REAL      RESULT2(IPRMAX,IPRROW)
      REAL      RESULT3(IPRMAX,IPRROW)
C ---
      CHARACTER NAMEF*(*),NAMEM*(*),NAME_TAB*(*)
      CHARACTER PATH_SCR*(*)
     
      CHARACTER NAMEC*256,NAMEC3*256,NAMED*256,NAMES*256
      CHARACTER NAMEFM1*256,NAMEPH1*256
      CHARACTER NAME_SCR*256,NAME_SCR1*256,NAMEF_TEMP*256

      CHARACTER LINE*256,TTT*80,ITYPE*4,P1*1,MODE*1,LIST*1
      REAL      AM(3,3),SH1(3),SH2(3),SHF(3)
      CHARACTER ANISO*1,SOLV*1,PATT*1,SURF*1,MSHIFT*1,TAB*1,ACORR*1
      REAL      SPST(3)
      CHARACTER PST*1,P1_FOR_DNS*1,MOD1*1,CFREE*1,CSIG*1,CFOM*1
C ------------------------------------------------------------
      IERR    = 0
      PI      = 4.0*ATAN(1.0)
C ---
      MD      = -ABS(MDOC)-1
      M       = 99
      MD0     = 0
      IF(MDOC.EQ.99) MD0 = 99
      IF(ABS(MDOC).EQ.2) MD = 99

      IF(LIST.EQ.'T') MD = MDOC
C --------------------------------------------
      CALL MSGDOC(MDOC,' ')
      LINE = '  --- Orientation & Position Check'//
     *       ' (without Packing Function)'
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' ')

      IF(ANISO.EQ.'y') ANISO = 'Y'
      IF(ANISO.EQ.'k') ANISO = 'K'
      IF(ANISO.EQ.'c') ANISO = 'C'
      IF(ANISO.EQ.'s') ANISO = 'S'
      IF(ANISO.NE.'Y'.AND.ANISO.NE.'C'.AND.
     *   ANISO.NE.'K'.AND.ANISO.NE.'S') ANISO='N'
      IF(ANISO.EQ.'S') ANISO = 'Y'

      IF(RESX.LT.0.00001) RESX = 3.0

      IF(RESN_SCL.GT.0.00001) THEN
c        BOFF_SCL = 4.0 * RESN_SCL * RESN_SCL
        BOFF_SCL = 2.0 * RESN_SCL * RESN_SCL
      ELSE
        BOFF_SCL = 256.0
      ENDIF

C ---------------------------------------------
      MTN   = 10
      ITYPE = 'FF  '
      CALL ORFILE(M,MTN,NAMEF,ITYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN INPUT-FILE-FOBS (in TRFUN_C)')
        RETURN
      ENDIF
      CALL GET_TITLE(MD,A,B,C,AL,BE,GA
     *  ,F1,F2,RESMIN,RESMAX,IDM,IDM,IDM,IDM,IDM,TTT,IERR)
      CLOSE(MTN)
C --------------------------------------------------------------
      IF(RESX.GT.0.00001.AND.RESX.GT.RESMAX) RESMAX = RESX
c      IF(RESN.GT.0.00001.AND.RESN.LT.RESMIN) RESMIN = RESN
      IF(RESMIN.LT.RESMAX) THEN
        T      = RESMIN
        RESMIN = RESMAX
        RESMAX = T
      ENDIF
      IF(RESMIN.EQ.RESMAX) THEN
        CALL MSGERR(MDOC,' ERR: resmin = resmax')
        IERR=1
        RETURN
      ENDIF
      IF(BOFF .LE.0.000001) BOFF = 900.0
      IF(RESN.GT.0.00001) THEN
c        BOFF = 4.0 * RESN * RESN
        BOFF = 2.0 * RESN * RESN
      ENDIF
      IF(BOFF .LE.0.000001) BOFF = 900.0
C ------------------------------------------
      NAMES      = ' '
      NAMEC      = 'trfn_scr1'
      CALL ADD_PATH(PATH_SCR,NAMEC)
      NAMEF_TEMP = 'molrep_fp1'
      CALL ADD_PATH(PATH_SCR,NAMEF_TEMP)
      NAMEC3     = 'trfn_scr3'
      CALL ADD_PATH(PATH_SCR,NAMEC3)
      NAMED      = 'trfun_dns'
      CALL ADD_PATH(PATH_SCR,NAMED)
      NAMEFM1    = 'trfn_f1'
      CALL ADD_PATH(PATH_SCR,NAMEFM1)
      NAMEPH1    = 'trfn_ph1'
      CALL ADD_PATH(PATH_SCR,NAMEPH1)
C --------------------------------------------
      WRITE(LINE,'('' Resolution   :'',2F8.2)') 
     * RESMIN,RESMAX
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Boff,Boff_scl:'',2F8.2)') 
     * BOFF,BOFF_SCL
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,'('' Badd,Badd_scl:'',2F8.2)') 
     * BADD,BADD_SCL
      CALL MSGDOC(MD,LINE)
C --------------------------------------------
      IF(NREFP.LE.0) THEN
        NAMEF_TEMP = NAMEF
      ELSE
        WRITE(LINE,'('' Test of RF solution in P1 :'',I4)') 
     *  NREFP
        CALL F2P1(MDOC,NAMEF,NAMEF_TEMP,RESMAX
     * ,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) RETURN        
      ENDIF
C --------------------------------------------

      CALL LENSTR_BL(NAME_TAB,LEN)
      IF(LEN.GT.0.AND.NAME_TAB(1:1).NE.','.AND.NAME_TAB(1:1).NE.' ') 
     *  THEN
        TAB = 'Y'
        N   = 1000

        CALL READ_TAB_TF(MD,NAME_TAB,N,RESULT2,IPRMAX,IPRROW)
        NP_TAB = RESULT2(1,12) 
        IF(NP_TAB.LE.0) THEN
          CALL MSGERR(MDOC,
     *  ' ERROR: number of peaks in the table = 0.')
          IERR = 1
          GO TO 900
        ENDIF

        WRITE(LINE,'('' Npeak_table             :'',I4)') 
     *  NP_TAB
        CALL MSGDOC(MD,LINE)
        SVECTOR(1) = 0.0
        SVECTOR(2) = 0.0
        SVECTOR(3) = 0.0
        ANGLES(1)  = 0.0
        ANGLES(2)  = 0.0
        ANGLES(3)  = 0.0 
        N_RF = 1
        N_TF = 1
      ELSE
        CALL MSGERR(MDOC,
     *  ' ERROR: wrong name of file TAB')
        IERR = 1
        GO TO 900
c        TAB  = 'N'
c        N_RF = 1
c        N_TF = 1
      ENDIF

      IF(N_RF.LE.0) N_RF = 1
      IF(N_TF.LE.0) N_TF = 1

      SV1 = SVECTOR(1) - DX
      SV2 = SVECTOR(2) - DY
      SV3 = SVECTOR(3) - DZ

      A1 = ANGLES(1)   - DA1
      A2 = ANGLES(2)   - DA2
      A3 = ANGLES(3)   - DA3

      IF(TAB.EQ.'Y') THEN
        N_RF = NP_TAB
        N_TF = 1
      ENDIF

      IFIRST    = 0
      CORR_BEST =-2.0
      RFAC_BEST = 0.0
      IR_BEST   = 0
      IT_BEST   = 0
C =====================
      DO I_RF=1,N_RF

        IF(TAB.EQ.'Y') THEN

        ELSE
          A1  = A1 + DA1
          A2  = A2 + DA2
          A3  = A3 + DA3
          SV1 = SVECTOR(1) - DX
          SV2 = SVECTOR(2) - DY
          SV3 = SVECTOR(3) - DZ
        ENDIF

      DO I_TF=1,N_TF

C       MODE = 'E'
        MODE = 'P'
        DO I=1,3
          SH1(I) = 0.0
          SH2(I) = 0.0
          DO J=1,3
            AM(I,J) = 0.0
          ENDDO
        ENDDO

        IF(TAB.EQ.'Y') THEN

          A1     = RESULT2(I_RF,6)
          A2     = RESULT2(I_RF,7)
          A3     = RESULT2(I_RF,8)
          ALPHA  = A1
          BETA   = A2 
          GAMMA  = A3
          IF(NREFP.LE.0) THEN
            SHF(1) = RESULT2(I_RF,9) 
            SHF(2) = RESULT2(I_RF,10)
            SHF(3) = RESULT2(I_RF,11)
          ELSE
            SHF(1) = 0.0
            SHF(2) = 0.0
            SHF(3) = 0.0
          ENDIF
        ELSE

          SV1 = SV1 + DX
          SV2 = SV2 + DY
          SV3 = SV3 + DZ

          ALPHA  = A1
          BETA   = A2 
          GAMMA  = A3
          SHF(1) = SV1
          SHF(2) = SV2
          SHF(3) = SV3

        ENDIF

        CALL FTOO(SHF,SH2,IERR)

        WRITE(LINE,'('' Rotation angles :'',3F8.2)') 
     *    ALPHA,BETA,GAMMA
        CALL MSGDOC(MD,LINE)
        WRITE(LINE,'('' Shift           :'',3F8.3,'' (fract)'')') 
     *    SHF(1),SHF(2),SHF(3)
        CALL MSGDOC(MD,LINE)
        WRITE(LINE,'('' Shift           :'',3F8.3,'' A'')') 
     *    SH2(1),SH2(2),SH2(3)
        CALL MSGDOC(MD,LINE)

        IF(MOD1.EQ.'Y') THEN

          NAMEC = 'molrep'
          CALL ADD_PATH(PATH_SCR,NAMEC)

          CALL TRANS(M,NAMEM,NAMEC,SH1,SH2
     *    ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
C
c        CALL MSGDOC(MD0,'--- generate density for model ---')
C
          RAD   = 0.0
          H2OBG = 0.0
          BADDD = BADD
          P1    = 'N' 

          IF(NREFP.GT.0) P1 = 'Y' 

          NX    = 0
          NY    = 0
          NZ    = 0
          IZMAX =-1
          IZMIN = 0
          MODE  = ' '
          TTT   = ' '
          IERR  = 0
          ZFADD = 0.0
          CALL GENDEN(M,NAMEC,NAMED,TTT
     *     ,RESMAX,NX,NY,NZ,IZMIN,IZMAX,MODE,RAD,H2OBG,BADDD,P1,ZFADD
     *     ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
C ---
c         CALL MSGDOC(MD0,'--- real fft for model ---')

          NAME_SCR  = 'molrp_scratch_rft'
          CALL ADD_PATH(PATH_SCR,NAME_SCR)
          NAME_SCR1 = 'molrp_scratch_rdc'
          CALL ADD_PATH(PATH_SCR,NAME_SCR1)

          CALL RFFT(M,RESMAX
     *    ,NAMED,NAMEC3,NAMEPH1,PATH_SCR,ISYM,IPRSYM,RESULT
     *    ,IERR)
          IF(IERR.NE.0) GO TO 900


C ---
c         CALL MSGDOC(MD0,'--- scaling ---')

          BOFFF = BOFF_SCL
          BADDD = BADD_SCL
          SOLV  = 'N'
          SCALE = 1.0
          BOVER = 0.0
          NCYCL = 0
          ACORR = 'N'
          RESMNI = RESMIN
          RESMXI = RESMAX
          IF(ANISO.EQ.'K') THEN
            SCALE  = 0.0
            BOVER  = 0.0
          ENDIF
          CALL MR_SCALING(MD,LIST,NAMEF,NAMEC3,NAMEFM1,PATH_SCR
     *   ,ANISO,SCALE,BOVER,ACORR,BOFFF,BADDD,RESMNI,RESMXI
     *   ,SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF
     *   ,RESULT,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
C ---------------------------------------------------------
C     1. ACORR # N - anisothermal correction of Fmod
c        if ANISO = '-' return
C     2. ANISO = K - FSCALE with SCALEP,BSCALE
C                   if scale = 0 - scaling by Fobs (cell must be the same)
C                      only scale , set BOVER = 0
C                   if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                  no info: rfac, corr
C        else  CALL PSCALE
C      output: SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF and NAMEFM2
C ---------------------------------------------------------
          IF(IERR.NE.0) GO TO 900
          RFAC   = RFAC_REF 
          CORR   = CORR_REF
          COEFP  = SCALEP_NEW 
          BTEMPP = BSCALE_NEW

        ELSE

          IOUT = 0
          NAMED = ' '

          NAMEFM1  = 'molrep_fcalc'
          CALL ADD_PATH(PATH_SCR,NAMEFM1)
          NAMEPH1 = 'molrep_phcalc'
          CALL ADD_PATH(PATH_SCR,NAMEPH1)


          CALL DENS2F_DNS_TEST2(MDOC,LIST,PATH_SCR
     *    ,NAMEF,NAMEM,NAMED,NAMEFM1,NAMEPH1
     *    ,IOUT,ALPHA,BETA,GAMMA,SHF,RFAC,CORR
     *    ,RESMAX,RESMIN,BOFF,BADD,BOFF_SCL,BADD_SCL,ANISO
     *    ,RESULT,RESULT3,IPRMAX,IPRROW
     *    ,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900

        ENDIF

c        WRITE(LINE,'('' scale,B_scale :'',2F8.3)') 
c     *    COEFP,BTEMPP
c        CALL MSGDOC(MD,LINE)

c       WRITE(LINE,'('' R-factor,Corr :'',2F8.4)') 
c     *   RFAC,CORR
c       CALL MSGDOC(MDOC,LINE)

C       LINE = '             alpha   beta    gamma   Xfrac  Y'//
        IF(IFIRST.LE.0) THEN
          LINE = '+-------------------------------'//
     *           '------------------------------------+'
          CALL MSGDOC(MDOC,LINE)

          LINE = '|         theta    phi     chi    Xfrac  Y'//
     *         'frac  Zfrac  R-fac   Corr |'
          CALL MSGDOC(MDOC,LINE)
          LINE = '+-------------------------------'//
     *           '------------------------------------+'
          CALL MSGDOC(MDOC,LINE)
          IFIRST = 1
        ENDIF
        WRITE(LINE,'(''| '',2I3,3F8.2,3F7.3,2F7.3,'' |'')') 
     *  I_RF,I_TF,A1,A2,A3,SHF(1),SHF(2),SHF(3)
     *  ,RFAC,CORR
        CALL MSGDOC(MDOC,LINE)
        IF(CORR.GT.CORR_BEST) THEN
          RFAC_BEST = RFAC
          CORR_BEST = CORR
          IR_BEST   = I_RF
          IT_BEST   = I_TF
        ENDIF
      ENDDO
      ENDDO
      LINE = '+-------------------------------'//
     *           '------------------------------------+'
      CALL MSGDOC(MDOC,LINE)
C ======

      IF(N_RF.GE.1.OR.N_TF.GE.1.AND.CORR_BEST.GT.-1.0) THEN

        IF(TAB.EQ.'Y') THEN
          A1  = RESULT2(IR_BEST,6)
          A2  = RESULT2(IR_BEST,7)
          A3  = RESULT2(IR_BEST,8)
          SV1 = RESULT2(IR_BEST,9) 
          SV2 = RESULT2(IR_BEST,10)
          SV3 = RESULT2(IR_BEST,11)
        ELSE
          SV1 = SVECTOR(1) - DX + DX*IT_BEST
          SV2 = SVECTOR(2) - DY + DY*IT_BEST
          SV3 = SVECTOR(3) - DZ + DZ*IT_BEST
                      
          A1 = ANGLES(1)   - DA1 + DA1*IR_BEST
          A2 = ANGLES(2)   - DA2 + DA2*IR_BEST
          A3 = ANGLES(3)   - DA3 + DA3*IR_BEST
        ENDIF

        MODE = 'P'
        DO I=1,3
          SH1(I) = 0.0
          SH2(I) = 0.0
          DO J=1,3
            AM(I,J) = 0.0
          ENDDO
        ENDDO

        ALPHA  = A1
        BETA   = A2 
        GAMMA  = A3
        SHF(1) = SV1
        SHF(2) = SV2
        SHF(3) = SV3

        CALL FTOO(SHF,SH2,IERR)

        CALL MSGDOC(MDOC,' --- best ---')

        WRITE(LINE,'(''  '',2I3,3F8.2,3F7.3,2F7.3)') 
     *    IR_BEST,IT_BEST,A1,A2,A3,SHF(1),SHF(2),SHF(3)
     *    ,RFAC_BEST,CORR_BEST
        CALL MSGDOC(MDOC,LINE)

c        WRITE(LINE,'('' Rotation angles :'',3F8.2)') 
c     *    A1,A2,A3
c        CALL MSGDOC(MD,LINE)
c        WRITE(LINE,'('' Shift           :'',3F8.3)') 
c     *    SH2(1),SH2(2),SH2(3)
c        CALL MSGDOC(MD,LINE)

        IF(MOD1.EQ.'Y') THEN

          NAMEC = 'molrep'
          CALL ADD_PATH(PATH_SCR,NAMEC)

          CALL TRANS(M,NAMEM,NAMEC,SH1,SH2
     *    ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
       
        ELSE

          IOUT = 1
          NAMED = ' '

          NAMEFM1  = 'molrep_fcalc'
          CALL ADD_PATH(PATH_SCR,NAMEFM1)
          NAMEPH1 = 'molrep_phcalc'
          CALL ADD_PATH(PATH_SCR,NAMEPH1)


          CALL DENS2F_DNS_TEST2(MDOC,LIST,PATH_SCR
     *    ,NAMEF,NAMEM,NAMED,NAMEFM1,NAMEPH1
     *    ,IOUT,ALPHA,BETA,GAMMA,SHF,RFAC,CORR
     *    ,RESMAX,RESMIN,BOFF,BADD,BOFF_SCL,BADD_SCL,ANISO
     *    ,RESULT,RESULT3,IPRMAX,IPRROW
     *    ,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900

          LINE = '         result is "molrep_fcalc.dat"'
          CALL MSGDOC(MDOC,LINE)
          LINE = '                   "molrep_phcalc.dat"'
          CALL MSGDOC(MDOC,LINE)

          NAMES = 'molrep_fcalc.cif'
          CALL ADD_PATH(PATH_SCR,NAMES)
          CFREE = 'N'
          CSIG  = 'N'
          CFOM  = 'N'

          NAMED=' '

c          CALL F2CIF(Mdoc,NAMEF,NAME_FCALC,NAME_PHCALC,NAMES

          CALL F2CIF(M,NAMED,NAMEFM1,NAMEPH1,NAMES
     *          ,CFOM,CFREE,CSIG
     *          ,RESMIN,RESMAX,ISYM,IPRSYM,RESULT,IPRROW,IERR)
          IF(IERR.NE.0) GO TO 900
          LINE = '         file "molrep_fcalc.cif" was created'
          CALL MSGDOC(MDOC,LINE)
          LINE = '               with Fcalc,Phcalc'
c          LINE = '               with Fobs,Fcalc,Phcalc'
          CALL MSGDOC(MDOC,LINE)

        ENDIF

      ELSE
        CALL MSGDOC(MDOC,'ERROR: no solution')
        IERR = 1
      ENDIF
C ------------------------------------------------
 900  CONTINUE


      NAMES = 'molrp_scratch_rft'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES = 'molrp_scratch_rdc.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)

      RETURN
      END

      SUBROUTINE DENS2F_DNS_TEST2(MDOC,LIST,PATH_SCR
     * ,NAMEF,NAMEM,NAMED,NAMEFM,NAMEPH
     * ,IOUT,THETA,PHI,CHI,SHIFT,RFAC,CORR
     * ,RESMAX,RESMIN,BOFF,BADD,BOFF_SCL,BADD_SCL,ANISO
     * ,RESULT,RESULT2,IPRMAX,IPRROW
     * ,ISYM,IPRSYM,IERR)
C------------------
      COMMON/COM_DPOOL/ IPOOL_MAX,IPOOL_CURR
C -----------------
      INTEGER*2 ISYM(5,3,IPRSYM)
C ----
      REAL      RESULT (IPRMAX,IPRROW)
      REAL      RESULT2(IPRMAX,IPRROW)
C ----
C
      REAL      FPAR2_TR(20)
      CHARACTER PARM2_TR*30
C ---------------------------------------
      INCLUDE 'molrep_lh_infor.fh'
C      COMMON/COM_LH_INFOR/ BOFF_LH,BADD_LH,BOFF_FOR_SCAL
C     *   ,CHECK_CONTRAST,CONTRAST_LIM
C     *   ,BCORR_LH,FILE_FOBS_LH,SCORE_FLAG,LH_LH,DB_LH 
CC ---
C      REAL      CHECK_CONTRAST,CONTRAST_LIM
C      REAL      BOFF_FOR_SCAL,BOFF_LH,BADD_LH,BCORR_LH
C      CHARACTER LH_LH*1,SCORE_FLAG*1,DB_LH*1
C      CHARACTER FILE_FOBS_LH*256
C ------------------------------------------------------------
      COMMON/TRFUN_COM_TMP/ FOBS_000,FMOD1_000,FMOD2_000,NEL2,IERR_PK
     *                     ,SCALEP_STORE,BOVER_STORE,SIGMA_STORE
C ---
C ----------------------------------
C
      REAL      PEAK_TEST(12,200)
      REAL      ANGLES_NCS_INP(3),CENTRE_NCS(3)
      REAL      SPST(3),SHIFT(3),AM(3,3)
      CHARACTER NAMEFM*(*),NAMEPH*(*),NAMEM*(*),NAMED*(*),PATH_SCR*(*)
      CHARACTER NAMEF*(*)
      CHARACTER NAMES*256,NAME2*256,NAME_OUT*256

      CHARACTER INVER*1
      CHARACTER PST*1,LIST*1,ANISO*1
      CHARACTER LINE*256
C ---------------------------------
C --------------------------------------------------------------------
      PI = 4.0*ATAN(1.0)
      MD =-ABS(MDOC)-1
      M  = 99
      IF(LIST.EQ.'T') THEN
        MD = MDOC
        M  = -ABS(MDOC)-1
      ENDIF
c ---
      RTHETA = (THETA*PI)/180.0
      RPHI   = (PHI  *PI)/180.0
      RCHI   = (CHI  *PI)/180.0
      CALL POLTOM(RTHETA,RPHI,RCHI,AM)
      CALL MTOANG(AM,ALPHA,BETA,GAMMA)

      IPOOL_MAX = 1
      PEAK_TEST(12,1) = 0       
 
      LH_LH     = 'N'
      FOBS_000  = 0.0
      FMOD1_000 = 0.0
      FMOD2_000 = 0.0
      NEL2      = 0
      IERR_PK   = 0
      NMR       = 0
      BLIM      = 15.0
      DO I=1,3
        ANGLES_NCS_INP(I) = 0.0
        CENTRE_NCS(3)     = 0.0
      ENDDO
      INVER      = 'N'
      PST        = 'N'
      SPST(1)    = 0.0
      SPST(2)    = 0.0
      SPST(3)    = 0.0
C ------
C      MEMORY_SCR = MEMORY_TOT/2
C      MEMORY_SCR = MEMORY_SCR*4
C      MEMORY     = MEMORY_TOT - MEMORY_SCR 
C ------
C ----------------
          PARM2_TR( 1: 1) = 'F'
C      refp
          PARM2_TR( 2: 2) = 'N'
C      ref
          PARM2_TR( 3: 3) = 'N'
c       pack
          PARM2_TR( 4: 4) = 'N'
          PARM2_TR( 5: 5) = PST
c       calc2
          PARM2_TR( 6: 6) = 'Y'
c       aniso 
          IF(IOUT.NE.0) THEN
            PARM2_TR( 7: 7) = 'K' 
          ELSE
            PARM2_TR( 7: 7) = ANISO
          ENDIF
c       surf
          PARM2_TR( 8: 8) = 'N' 
          PARM2_TR( 9: 9) = 'N'
C       mod2
          PARM2_TR(10:10) = 'N'
          PARM2_TR(11:11) = INVER  
          PARM2_TR(12:12) = 'N' 
c       fast
          PARM2_TR(13:13) = 'F'  
          PARM2_TR(14:14) = 'N'  
C 15 MODE_T
          PARM2_TR(15:15) = 'C'  
C 16 TEST
          PARM2_TR(16:16) = ' '
C 17 STICK
          PARM2_TR(17:17) = 'N'
C    mod1
          PARM2_TR(18:18) = 'D'
c    mod2
          PARM2_TR(19:19) = 'N'
          PARM2_TR(20:20) = LIST
          PARM2_TR(21:21) = 'N'

          FPAR2_TR( 1) = RESMIN
          FPAR2_TR( 2) = RESMAX
          FPAR2_TR( 3) = ALPHA
          FPAR2_TR( 4) = BETA
          FPAR2_TR( 5) = GAMMA
          FPAR2_TR( 6) = BOFF
          FPAR2_TR( 7) = BOFF
          FPAR2_TR( 8) = BADD
          FPAR2_TR( 9) = BLIM
          FPAR2_TR(10) = 20.0
          FPAR2_TR(11) = 5.0
          FPAR2_TR(12) = BOFF_SCL
          FPAR2_TR(13) = BADD_SCL
c       arad
          FPAR2_TR(15) = 0.0
c         resmin_out  200 just flag to use max(A,B,C)
          IF(IOUT.NE.0) THEN
            RESMIN_OUT = 200.0
          ELSE
            RESMIN_OUT = 0.0
          ENDIF
          FPAR2_TR(17) = RESMIN_OUT
          IFIRST_SCL = 0
          FPAR2_TR(18) = IFIRST_SCL
c         RAD_MODEL 
          FPAR2_TR(19) = 0.0 
 
          NMR = 0
          NAMES     = ' '
          NEL2      = 0
          NC        = 0
          NCP       = 0
          NAME_OUT   = ' '
          NAMED      = ' '

          NCS_ID = 0
          N_MODEL = 0

          NAMES   = ' '
          NAME2   = ' '
          IR      = 1
          RESULT(1,12) = 1
          RESULT(1, 9) = SHIFT(1)
          RESULT(1,10) = SHIFT(2)
          RESULT(1,11) = SHIFT(3)
c                                    ph
          CALL TRFUN(MD,NAMEF,NAMEM,NAMES,NAME2,NAME_OUT
     *     ,NAMED,NAMEFM,NAMEPH,PATH_SCR
     *     ,IR,SHIFT,NC,NPT,NMR,N_MODEL,NEL2,NCP,NCS_ID
     *     ,ANGLES_NCS_INP,CENTRE_NCS
     *     ,PARM2_TR,FPAR2_TR,SPST,PEAK_TEST
     *     ,ISYM,IPRSYM
     *     ,RESULT,RESULT2,IPRMAX,IPRROW,IERR)
          NPTRANS = RESULT(1,12)
          RFAC    = RESULT(1,1)
          CORR    = RESULT(1,2)
         IF(IERR.NE.0.OR.NPTRANS.LE.0) THEN
           IERR = 1
           RETURN
         ENDIF
         RETURN
         END

      SUBROUTINE TRFUN_R(MDOC,NAMEF,NAMEM,PATH_SCR,NREFR
     * ,RESN,RESX,BOFF,BADD,BOFF_SCL,BADD_SCL,ANISO,LIST
     * ,ISYM,IPRSYM
     * ,RESULT2,RESULT,IPRMAX,IPRROW,IERR)
C --------------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      POOL(10)
C ----
      REAL      RESULT(IPRMAX,IPRROW),ANGLES(3),SVECTOR(3)
      REAL      RESULT2(IPRMAX,IPRROW)
C ---
      CHARACTER NAMEF*(*),NAMEM*(*)
      CHARACTER PATH_SCR*(*)
     
      CHARACTER NAMEC*256,NAMEC3*256,NAMED*256,NAMES*256
      CHARACTER NAMEFM1*256,NAMEPH1*256
      CHARACTER NAME_SCR*256,NAME_SCR1*256,NAMEF_TEMP*256

      CHARACTER LINE*256,TTT*80,ITYPE*4,P1*1,MODE*1,LIST*1,INVER*1 
      REAL      AM(3,3),SH1(3),SH2(3),SHF(3),SPST(3)
      CHARACTER ANISO*1,SOLV*1,PATT*1,SURF*1,MSHIFT*1,TAB*1,PST*1
      CHARACTER ACORR*1
C ------------------------------------------------------------
      IERR    = 0
      PI      = 4.0*ATAN(1.0)
C ---
      MD      = -ABS(MDOC)-1
      M       = 99
      MD0     = 0
      IF(MDOC.EQ.99) MD0 = 99
      IF(ABS(MDOC).EQ.2) MD = 99

      IF(LIST.EQ.'T') MD = MDOC

      WRITE(LINE,'('' --- Test of RF solution in P1 ---'')') 
      CALL MSGDOC(MDOC,LINE)
C --------------------------------------------
      IF(ANISO.EQ.'y') ANISO = 'Y'
      IF(ANISO.EQ.'k') ANISO = 'K'
      IF(ANISO.EQ.'c') ANISO = 'C'
      IF(ANISO.EQ.'s') ANISO = 'S'
c      IF(ANISO.NE.'Y'.AND.ANISO.NE.'C'.AND.
c     *   ANISO.NE.'K'.AND.ANISO.NE.'S') ANISO='N'
      IF( ANISO.NE.'K') ANISO='N'

      IF(RESX.LT.0.00001) RESX = 3.0
C ---------------------------------------------
      MTN   = 10
      ITYPE = 'FF  '
      CALL ORFILE(M,MTN,NAMEF,ITYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN INPUT-FILE-FOBS (in TRFUN_C)')
        RETURN
      ENDIF
      CALL GET_TITLE(MD,A,B,C,AL,BE,GA
     *  ,F1,F2,RESMIN,RESMAX,IDM,IDM,IDM,IDM,IDM,TTT,IERR)
      CLOSE(MTN)
C --------------------------------------------------------------
      IF(RESX.GT.0.00001.AND.RESX.GT.RESMAX) RESMAX = RESX
c      IF(RESN.GT.0.00001.AND.RESN.LT.RESMIN) RESMIN = RESN
      IF(RESMIN.LT.RESMAX) THEN
        T      = RESMIN
        RESMIN = RESMAX
        RESMAX = T
      ENDIF
      IF(RESMIN.EQ.RESMAX) THEN
        CALL MSGERR(MDOC,' ERR: resmin = resmax')
        IERR=1
        RETURN
      ENDIF
      IF(BOFF .LE.0.000001) BOFF = 900.0
C ------------------------------------------
      NAMES      = ' '
      NAMEC      = 'trfn_scr1'
      CALL ADD_PATH(PATH_SCR,NAMEC)
      NAMEF_TEMP = 'molrep_fp1'
      CALL ADD_PATH(PATH_SCR,NAMEF_TEMP)
      NAMEC3     = 'trfn_scr3'
      CALL ADD_PATH(PATH_SCR,NAMEC3)
      NAMED      = 'trfun_dns'
      CALL ADD_PATH(PATH_SCR,NAMED)
      NAMEFM1    = 'trfn_f1'
      CALL ADD_PATH(PATH_SCR,NAMEFM1)
      NAMEPH1    = 'trfn_ph1'
      CALL ADD_PATH(PATH_SCR,NAMEPH1)
C --------------------------------------------
      WRITE(LINE,'(''Sol_ Resmin,Resmax     :'',2F8.2)') 
     * RESMIN,RESMAX
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,'(''Sol_ Boff,Boff_scl:'',2F8.2)') 
     * BOFF,BOFF_SCL
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,'(''Sol_ Badd,Badd_scl:'',2F8.2)') 
     * BADD,BADD_SCL
      CALL MSGDOC(MD,LINE)
C --------------------------------------------
C      IF(NREFR.LE.0) THEN
        NAMEF_TEMP = NAMEF
C      ELSE
C        CALL F2P1(M,NAMEF,NAMEF_TEMP,RESMAX
C     * ,ISYM,IPRSYM,IERR)
C        IF(IERR.NE.0) RETURN        
C      ENDIF
C --------------------------------------------
      TAB    = 'Y'
      N      = 1000
      NP_TAB = RESULT2(1,12) 
      IF(NP_TAB.LE.0) THEN
        CALL MSGERR(MDOC,
     *  ' ERROR: number of peaks in the table = 0.')
        IERR = 1
        GO TO 900
      ENDIF

      IF(NREFR.GT.0.AND.NREFR.LT.NP_TAB) NP_TAB = NREFR

      WRITE(LINE,'('' Npeak_table             :'',I4)') 
     *NP_TAB
      CALL MSGDOC(MDOC,LINE)

      SVECTOR(1) = 0.0
      SVECTOR(2) = 0.0
      SVECTOR(3) = 0.0
      ANGLES(1)  = 0.0
      ANGLES(2)  = 0.0
      ANGLES(3)  = 0.0 
      N_RF       = NP_TAB

      IFIRST    = 0
      CORR_BEST =-2.0
      IR_BEST   = 0
C =====================
      DO I_RF=1,N_RF
        MODE = 'P'
        DO I=1,3
          SH1(I) = 0.0
          SH2(I) = 0.0
          DO J=1,3
            AM(I,J) = 0.0
          ENDDO
        ENDDO
        A1     = RESULT2(I_RF,6)
        A2     = RESULT2(I_RF,7)
        A3     = RESULT2(I_RF,8)

        ALP    = (A1*PI)/180.0
        BET    = (A2*PI)/180.0
        GAM    = (A3*PI)/180.0

        CALL EULERM(ALP,BET,GAM,AM)
        CALL MTOPOL(AM,THETA,PHI,CHI)

        ALPHA  = THETA
        BETA   = PHI
        GAMMA  = CHI

        SH2(1) = 0.0
        SH2(2) = 0.0
        SH2(3) = 0.0

        WRITE(LINE,'('' Rotation angles :'',3F8.2)') 
     *    ALPHA,BETA,GAMMA
        CALL MSGDOC(MD,LINE)
        WRITE(LINE,'('' Shift           :'',3F8.3,'' A'')') 
     *    SH2(1),SH2(2),SH2(3)
        CALL MSGDOC(MD,LINE)

C        NAMEC = 'molrep'
C        CALL ADD_PATH(PATH_SCR,NAMEC)

        CALL TRANS(M,NAMEM,NAMEC,SH1,SH2
     *    ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
C
c        CALL MSGDOC(MD0,'--- generate density for model ---')
C
        RAD   = 0.0
        H2OBG = 0.0
        BADDD = BADD

        P1    = 'N' 
        IF(NREFR.GT.0) P1 = 'S' 
        P1    = 'S' 

        NX    = 0
        NY    = 0
        NZ    = 0
        IZMAX =-1
        IZMIN = 0
        MODE  = ' '
        TTT   = ' '
        IERR  = 0
        ZFADD = 0.0

        MMM = M
        IF(LIST.EQ.'T') MMM = MDOC

        CALL GENDEN(MMM,NAMEC,NAMED,TTT
     *   ,RESMAX,NX,NY,NZ,IZMIN,IZMAX,MODE,RAD,H2OBG,BADDD,P1,ZFADD
     *   ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
C ---
c       CALL MSGDOC(MD0,'--- real fft for model ---')

        NAME_SCR  = 'molrp_scratch_rft'
        CALL ADD_PATH(PATH_SCR,NAME_SCR)
        NAME_SCR1 = 'molrp_scratch_rdc'
        CALL ADD_PATH(PATH_SCR,NAME_SCR1)

        INVER     = 'N'
        PST       = 'N'
        SPST(1)   = 0.0
        SPST(2)   = 0.0
        SPST(3)   = 0.0

        IERR      = 0
        IF(NREFR.GT.0) THEN
c         IF(P1   .EQ.'Y')  IERR = IERR + 2
C          IERR = IERR + 2
          IERR = IERR + 8
          NAMEPH1   = ' '
        ENDIF

        MMM = M
        IF(LIST.EQ.'T') MMM = MDOC

        IPOOL_MAX = 0
c        IF(IPOOL_MAX.GT.0) THEN
c          I0 = MEMORY - IPOOL_MAX + 1
c        ELSE
c          I0 = 1
c        ENDIF

        CALL RFT_NEW(MMM,LIST,PATH_SCR,RESMAX
     *   ,INVER,PST,SPST
     *   ,NAMED,NAMEC3,NAMEPH1,ISYM,IPRSYM,RESULT
     *   ,POOL,IPOOL_MAX,IERR)

C         CALL RFFT(M,RESMAX
C     *   ,NAMED,NAMEC3,NAMEPH1,PATH_SCR,ISYM,IPRSYM,RESULT
C     *   ,IERR)

       IF(IERR.NE.0) GO TO 900
C ---
c       CALL MSGDOC(MD0,'--- scaling ---')

        BOFFF = BOFF_SCL
        BADDD = BADD_SCL
        SOLV  = 'N'
        SCALE = 1.0
        BOVER = 0.0
        NCYCL = 0
        RFAC_I= 0.0
        CORR_I= 0.0
        RESMNI = RESMIN
        RESMXI = RESMAX

        NAMEFM1 = ' '
        ACORR   = 'N'
        IF(ANISO.EQ.'K') THEN
          SCALE  = 0.0
          BOVER  = 0.0
        ENDIF
        MMM = M
        IF(LIST.EQ.'T') MMM = MDOC
        CALL MR_SCALING(MMM,LIST,NAMEF,NAMEC3,NAMEFM1,PATH_SCR
     * ,ANISO,SCALE,BOVER,ACORR,BOFFF,BADDD,RESMNI,RESMXI
     * ,SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF
     * ,RESULT,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
C ---------------------------------------------------------
C     1. ACORR # N - anisothermal correction of Fmod
c        if ANISO = '-' return
C     2. ANISO = K - FSCALE with SCALEP,BSCALE
C                   if scale = 0 - scaling by Fobs (cell must be the same)
C                      only scale , set BOVER = 0
C                   if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                  no info: rfac, corr
C        else  CALL PSCALE
C      output: SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF and NAMEFM2
C ---------------------------------------------------------
        IF(IERR.NE.0) GO TO 900
        RFAC   = RFAC_REF
        CORR   = CORR_REF
        COEFP  = SCALEP_NEW  
        BTEMPP = BSCALE_NEW
C       RFAC_I = 
C       CORR_I = 

        WRITE(LINE,'('' scale,B_scale :'',2F8.3)') 
     *    COEFP,BTEMPP
        CALL MSGDOC(MD,LINE)

c       WRITE(LINE,'('' R-factor,Corr :'',2F8.4)') 
c     *   RFAC,CORR
c       CALL MSGDOC(MDOC,LINE)

C       LINE = '             alpha   beta    gamma   Xfrac  Y'//
        IF(IFIRST.LE.0) THEN
          LINE = '             theta    phi     chi  '//
     *         '  R-fac  Corr '
C     *         '  R-fac  Corr  R-fac_I Corr_I'
          CALL MSGDOC(MDOC,LINE)
          IFIRST = 1
        ENDIF
        WRITE(LINE,'(''Sol_ '',I3,''   '',3F8.2,2F8.4)') 
     *  I_RF,THETA,PHI,CHI,RFAC,CORR
C     *  I_RF,THETA,PHI,CHI,RFAC,CORR,RFAC_I,CORR_I
        CALL MSGDOC(MDOC,LINE)

        RESULT2(I_RF, 4) = CORR
        RESULT2(I_RF, 5) = RFAC
c        RESULT2(I_RF, 4) = RFAC_I
c        RESULT2(I_RF, 5) = CORR_I
        RESULT2(I_RF,13) = I_RF

        IF(CORR.GT.CORR_BEST) THEN
          CORR_BEST = CORR
          IR_BEST   = I_RF
        ENDIF
      ENDDO
C ======
      IST  = 0
      IORD = 0
      RESULT2(1,12) = N_RF 
      CALL SORT_PEAK(MDOC,IST,IORD,RESULT2,IPRMAX,IPRROW,IERR)
C ------------------------------------------------
 900  CONTINUE

      NAMES = 'molrp_scratch_rft'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES = 'molrp_scratch_rdc.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)

      RETURN
      END

      SUBROUTINE SORT_PEAK(MDOC,IST,IORD,RESULT,IPRMAX,IPRROW,IERR)
C -------------------------------------------------------------------    
      REAL      RESULT(IPRMAX,IPRROW)
      CHARACTER LINE*256
C -------------------------------------------------------------
      MD   =-ABS(MDOC)-1
      M    = 99
      IERR = 0
C ---
      NP = RESULT(1,12)
      IF(NP.LE.1) RETURN
      IF(IST.LE.0) IST = 1
      IF(IST.GE.NP) RETURN
      DO IP=IST+1,NP
        DO JP=IST,NP-1
          IYES = 0
          IF(IORD.LE.0) THEN
            IF(RESULT(IP,4).GT.RESULT(JP,4)) IYES = 1
          ELSE
            IF(RESULT(IP,4).LT.RESULT(JP,4)) IYES = 1
          ENDIF
          IF(IYES.EQ.1) THEN
            DO I=1,IPRROW
              T            = RESULT(IP,I)
              RESULT(IP,I) = RESULT(JP,I)
              RESULT(JP,I) = T
            ENDDO
          ENDIF
        ENDDO
      ENDDO
      RESULT(1,12) = NP
C --------------------------------------------
 900  CONTINUE
      RETURN
      END

      SUBROUTINE CHANGE_GROUP(MDOC,NAME,NAMEO
     *          ,NOSPGR,SGNAME,NOSG,ISETT,NSYMLIB
     *          ,NSYM,ISYM,IPRSYM,IERR)
C ---------------------------------------------
C  
C CHANGE_GROUP -  change space group of file F.
C 
C      Dialogue and batch:
C
C      FILE_I:      - name of input file F.
C      FILE_O:      - name of output file.
C      NOSG:   <0>  - No new space group, 0 means to copy only
C   
C     SUBROUTINE CHANGE_GROUP(MDOC,NAME,NAMEO,NOSPGR
C     *           ,ISYM,IPRSYM,IERR)
C
C      Parameters:
C
C      MDOC   - mode of writing messages to DOC-file
C               0 - only terminal , < - 0 only file, 0 < < 99 - both
C               >= 99 - don't write  
C      NAME   - name of input file F
C      NAMEO  - name of output file.
C      NOSG:   <0>  - No new space group, 0 means to copy only
C      ISYM   - integer*2 array for cryst.symmetry operators 
C      IPRSYM - dimension of integer*2 array ISYM(5,3,IPRSYM)
C      IERR   - signal of error / =1 -error , =o - OK / 
C 
C ---------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER NAME*(*),NAMEO*(*)
C --
      CHARACTER ITYP*4,TTT*80,LINE*256
C ---
      INTEGER*4 NOSPGR,ISETT
      CHARACTER SGNAME*(*)
C ---
      REAL      RLATT_F(6)
      INTEGER   NSPGROUP_F,NOSETT_F
      CHARACTER CODE*4,DATE*9,SPGR_F*24,NAME_F*80
C -----------------------------
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C ----------------------------------------------------------------------
      M       = 99
      PI      = 4.0*ATAN(1.0)
      MTIN    = 20
      NSYMLIB = 0
      ITYP    = '    '
      IPRINT  = 0
      CALL LENSTR_BL(NAME,LEN)
      IF(LEN.LE.0.OR.NAME(1:1).EQ.' '.OR.NAME(1:1).EQ.',') THEN
        IERR=1
        RETURN
      ENDIF
      CALL ORFILE(M,MTIN,NAME,ITYP,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) THEN
        RETURN
      ENDIF

      CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *  ,COEF1,BET1,RESMIN,RESMAX,NX,NY,NZ,IZMNR,IZMXR,TTT,IERR)

      IF(ITYP.NE.'F   '.AND.ITYP.NE.'FS  ') THEN
        CALL MSGERR(MDOC,' ERR: WRONG TYPE OF FILE')
        CLOSE(MTIN)
        IERR=1
        RETURN
      ENDIF
      CALL C_RD_CR

      CALL GET_CELL(RLATT_F,CODE,NAME_F,DATE,TTT
     *   ,NSPGROUP_F,NOSETT_F,SPGR_F,NSM,IERR)

      CALL LENSTR_BL(SGNAME,LEN)
      IF(LEN.GT.0) THEN
        NOSPGR = 0
        IF(SGNAME(1:3).EQ.'ALL') NOSPGR =-1
      ENDIF

      IF(NOSPGR.LT.0) THEN
        CALL NSG_STAND_TO_CCP4(NSPGROUP_F,NOSETT_F,NSYMLIB,IERR)
        NOSG    = NSPGROUP_F
        ISETT   = NOSETT_F
        SGNAME  = SPGR_F
        CLOSE(MTIN)
        RETURN        
      ENDIF

      IF(NOSPGR.GT.0.OR.LEN.GT.0) THEN

      IF(NOSPGR.GT.0) THEN
C        ISETT  = 1
C                sett 2     sett 1
C
C 3  P 2 P2      P 1 2 1   P 1 1 2
C 4  P21 P 21    P 1 21 1  P 1 1 21
C
C 5  B2  B 2               B 1 1 2
C 5  C2  C 2     C 1 2 1
C

        IF(NOSPGR.GE.3.AND.NOSPGR.LE.5) THEN
          T  = PI/2.0
c         ISETT = 2
          IF(ABS(GA-T).GT.0.0001.AND.
     *       ABS(BE-T).LE.0.0001     ) THEN
            IF(ISETT.EQ.2) ISETT = 1
          ELSE
            IF(ISETT.LE.1) ISETT = 2
          ENDIF   
        ENDIF

        NOSG    = NOSPGR
        NSYMLIB = NOSPGR

        IF(NOSPGR.GT.1000) THEN 
          ISETT = NOSPGR/1000
          NOSG  = NOSPGR - ISETT*1000
          ISETT = ISETT + 1

          IF(NOSG.EQ.3.OR.NOSG.EQ.4.OR.NOSG.EQ.146.OR.NOSG.EQ.155) THEN
            IF(ISETT.EQ.1) THEN
              ISETT = 2
            ELSE IF(ISETT.EQ.2) THEN  
              ISETT = 1
C            ELSE IF(ISTT.EQ.4) THEN  
C              ISTT = 3
            ENDIF
          ELSE IF(NOSG.EQ.  5) THEN
            IF(ISETT.EQ.1) THEN
              ISETT = 2
            ELSE IF(ISETT.EQ.2) THEN  
              ISETT = 1
C            ELSE IF(ISETT.EQ.3) THEN  
C              ISETT = 4
C            ELSE IF(ISETT.EQ.4) THEN  
C              ISETT = 3
            ENDIF
          ENDIF

        ENDIF

        IF(ISETT.LE.0) ISETT = 1

        IF(NOSG.EQ.146.OR.NOSG.EQ.155) THEN
            T= (PI*2.0)/3.0
            IF(ABS(GA-T).LE.0.0001) ISETT=2
        ENDIF

        IF(NSPGROUP_F.EQ.NOSG.AND.NOSETT_F.EQ.ISETT) THEN
          IERR = -2
          CLOSE(MTIN)
          RETURN
        ENDIF

        SGNAME = ' '

        ELSE

        IF(SGNAME.EQ.SPGR_F) THEN
          IERR = -2
          CLOSE(MTIN)
          RETURN
        ENDIF

        NOSG = 0

        ENDIF

        CALL GET_SYMM(M,NOSG,ISETT,SGNAME,NSYM,ISYM,IPRSYM,IERR)
C ---
        IF(IERR.NE.0) THEN
          CLOSE(MTIN)
          RETURN
        ENDIF
        NOSPGR = NOSG
        CALL LENSTR_BL(SGNAME,LENR)
        IF(LENR.GT.11) LENR = 11
        SP_GROUP  = SGNAME(1:LENR)
        NSP_GROUP = NOSPGR
        N_SETT    = ISETT

        CALL NSG_STAND_TO_CCP4(NSP_GROUP,N_SETT,NSYMLIB,IERR)

      ENDIF
C -------------------------------------------------------------
      MTOUT=13
      CALL LENSTR_BL(NAMEO,LN)
      IF(LN.LE.0.OR.NAMEO(1:1).EQ.' '.OR.NAMEO(1:1).EQ.',') MTOUT=0    

      IF(MTOUT.GT.0) THEN

        CALL C_CR_WR
        CALL SET_TITLE(M,A,B,C,AL,BE,GA,COEF1,BET1,RESMIN,RESMAX
     *  ,IDM,IDM,IDM,IDM,IDM,TTT,IERR)
        IF(IERR.GT.0) THEN
          IERR=2
          CLOSE(MTIN)
          RETURN
        ENDIF
        CALL OWFILE(M,MTOUT,NAMEO,ITYP,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.GT.0) THEN
          IERR=2
          CLOSE(MTIN)
          RETURN
        ENDIF
      ENDIF
C ----------------------------------------------------------
      NREF    = 0
      IEND    =-1
      IEND1   =-1
      NUMB    = 0
      NUMB1   = 0
      FA      = 0.0
      FB      = 0.0
      SA      = 0.0
      SB      = 0.0
C -------------------------------------------------------------------
  100 CONTINUE
      IF(ITYP.EQ.'FS  ') THEN
        CALL RRD1(MTIN,IH,IK,IL,FA,FB,SA,SB,NUMB,IEND)
      ELSE
        CALL RD1(MTIN,IH,IK,IL,FA,FB,NUMB,IEND)
      ENDIF
      IF(IEND.GT.0)                     GO TO 110

      NREF = NREF +1
      IF(MTOUT.GT.0) THEN
        IF(ITYP.EQ.'FS  ') THEN
          CALL WWRT(MTOUT,IH,IK,IL,FA,FB,SA,SB,NUMB1,IEND1)
        ELSE
          CALL WRT(MTOUT,IH,IK,IL,FA,FB,NUMB1,IEND1)
        ENDIF
      ENDIF
C -----------
      GO TO 100
C -----------------------------------------------------------
  110 CONTINUE
      IEND1 = 2
      IF(MTOUT.GT.0) THEN
        CALL WRT(MTOUT,IH,IK,IL,FNN,FNA,NUMB1,IEND1)
      ENDIF
C ----------------
      WRITE(LINE,'(''Number of reflections'',I8)') NREF
      CALL MSGDOC(M,LINE)
      CLOSE(MTIN)
C ----------------
      RETURN
      END

      SUBROUTINE SEARCH_ALT_SYMM_GROUP(MDOC,NSYMR,ISYMR,MAXNSO
     * ,NOSG,IST,NSG_CHECK,ISG_CHECK,SG_CHECK,IERR)
C -------------------------------------------------------
c     IMPLICIT  NONE
      INTEGER   MDOC,IERR,MAXNSO
      INTEGER   NSG_CHECK,ISG_CHECK(*)
      CHARACTER SG_CHECK(100)*24
C --
      INTEGER*2 ISYMR(5,3,MAXNSO)
      INTEGER   NSYMR
C -----------------------------------
      CHARACTER LINE*256
C -------------------------------------------------------------
      INTEGER   MAXN
      PARAMETER ( MAXN = 196 )
      INTEGER*2 ISYM(5,3,MAXN)
      INTEGER   NOSPGR,ISETT,LEN,IG,NSG,NSS,IFIRST,NOSG,IST
      INTEGER   IS,NO_TAB,NS_TAB,NMAX,NSYM,NNSYM,NSGNSS,N
      INTEGER   I,J,K,II
      CHARACTER SG_TAB*24,SG_TAB1*24,SG_TAB2*24,OP*80
C -------------------------------------------------------------
      IFIRST = 0
      NMAX   = 259
      NSG_CHECK = 1
      ISG_CHECK(NSG_CHECK) = 0
      SG_CHECK(NSG_CHECK)  = ' '
      DO IG=1,NMAX
        IS = 0
        CALL GET_SPACE_GROUP_INFO(IG,IS,NO_TAB,NS_TAB
     *                          ,SG_TAB,SG_TAB1,SG_TAB2,OP,IERR)
        IF(IERR.GT.0) RETURN
C       space group number
        NSG    = NO_TAB
C       number of symmetry operators
        NSYM   = NS_TAB
        NNSYM  = NSYM
        DO  IS=1,NSYM
          CALL GET_SPACE_GROUP_INFO(IG,IS,NO_TAB,NS_TAB
     *                           ,SG_TAB,SG_TAB1,SG_TAB2,OP,IERR)
          IF(IERR.NE.0) RETURN
          NSS   = IS
          CALL SYMFR_NB(MDOC,OP,NSS,NNSYM,ISYM,MAXN,IERR)
          IF(IERR.GT.0) RETURN
        ENDDO 

        CALL NSG_CCP4_TO_STAND(NSG,NOSPGR,ISETT,IERR)
        IF(NOSG.EQ.NOSPGR.AND.IST.EQ.ISETT) THEN

          ISG_CHECK(1) = NSG
          SG_CHECK(1) = SG_TAB

          IF(NSG.GT.999) THEN
            IF(NSG.NE.1003.AND.NSG.NE.1004.AND.NSG.NE.1005.AND.
     *         NSG.NE.1017.AND.NSG.NE.2017.AND.NSG.NE.2018.AND.
     *         NSG.NE.3018                                 ) THEN
              NSG_CHECK = 1
              GO TO 400
            ENDIF
          ENDIF


          GO TO 300
        ENDIF

c        IF(NOSPGR.EQ.5.AND.ISETT.GT.2) GO TO 300
        IF(NOSPGR.EQ.18.AND.ISETT.EQ.2) GO TO 300

        IF(NSG.GT.999) THEN
          IF(NSG.NE.1003.AND.NSG.NE.1004.AND.NSG.NE.1005.AND.
     *       NSG.NE.1017.AND.NSG.NE.2017.AND.NSG.NE.2018.AND.
     *       NSG.NE.3018                                 ) GO TO 300
        ENDIF

        IF(NSYM.EQ.NSYMR) THEN        

          DO I=1,NSYMR
            DO II=1,NSYM
              DO J=1,3
              DO K=1,3
                IF(ISYMR(J,K,I).NE.ISYM(J,K,II)) GO TO 100            
              ENDDO            
              ENDDO
              GO TO 200
 100          CONTINUE
            ENDDO
            GO TO 300            
 200        CONTINUE
          ENDDO

          DO I=1,NSYM
            DO II=1,NSYMR
              DO J=1,3
              DO K=1,3
                IF(ISYM(J,K,I).NE.ISYMR(J,K,II)) GO TO 110            
              ENDDO            
              ENDDO
              GO TO 210
 110          CONTINUE
            ENDDO
            GO TO 300            
 210        CONTINUE
          ENDDO

          CALL LENSTR_BL(SG_TAB,LEN)
          IF(LEN.LE.0) LEN = 1
          IF(LEN.GT.4.AND.SG_TAB(LEN-2:LEN).EQ.'(a)') GO TO 300

          CALL NSG_CCP4_TO_STAND(NSG,NOSPGR,ISETT,IERR)

C          IF(IFIRST.EQ.0) THEN
C            CALL MSGDOC(MDOC,'    You have to check also:')
C            IFIRST = 1
C          ENDIF
C          WRITE(LINE,'(3I5,4X,''"'',A,''"'')') 
C     *    NSG,NOSPGR,ISETT,SG_TAB(1:LEN)
C          CALL MSGDOC(MDOC,LINE)

          NSG_CHECK = NSG_CHECK + 1
          ISG_CHECK(NSG_CHECK) = NSG
          SG_CHECK(NSG_CHECK)  = SG_TAB
 
        ENDIF

300     CONTINUE
      ENDDO
400   CONTINUE
      IF(ISG_CHECK(1).EQ.0) THEN
        NSG_CHECK = 0
      ELSE
        IF(NSG_CHECK.GT.1) THEN
          N = NSG_CHECK
          NSG_CHECK = 1
          DO I=2,N
            NSG    = ISG_CHECK(I)
            SG_TAB = SG_CHECK(I) 
            IF(SG_TAB(1:1).EQ.SG_CHECK(1)(1:1)) THEN
              NSG_CHECK = NSG_CHECK + 1
              ISG_CHECK(NSG_CHECK) = NSG
              SG_CHECK(NSG_CHECK)  = SG_TAB
            ENDIF
          ENDDO
        ENDIF
        IF(NSG_CHECK.GT.1) THEN
          CALL MSGDOC(MDOC,'   You have to check also:')
          LINE = '+---------------------------+'
          CALL MSGDOC(MDOC,LINE)
          DO I=2,NSG_CHECK
            NSG    = ISG_CHECK(I)
            SG_TAB = SG_CHECK(I) 
            WRITE(LINE,'(''|  '',I5,4X,''"'',A,''"     |'')') 
     *      NSG,SG_TAB(1:LEN)
            CALL MSGDOC(MDOC,LINE)
          ENDDO
          LINE = '+---------------------------+'
          CALL MSGDOC(MDOC,LINE)

        ENDIF  
      ENDIF

      RETURN
      END

      SUBROUTINE SHIFT_CORR_MODEL(MDOC,NAMEM,NAME,PATH_SCR
     *   ,DB,SURF,PRF,BLIM,NA_TOT,NA_INSIDE
     *   ,NMR,N_MODEL,ISYM,IPRSYM,IERR)
C -------------------------------
      PARAMETER (IPRROW = 51)
      REAL      RESULT(IPRROW)
C ---------------------------------
      INTEGER   MDOC,IERR,IPRSYM
      REAL      BLIM
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER NAMEM*(*),NAME*(*),PATH_SCR*(*),SURF*1,PRF*1
      CHARACTER DB*1
C ----------------------------------
      REAL      SH1(3),SH2(3),AM(3,3)
      CHARACTER NAMES*256,NAMET*256
      CHARACTER LINE*256,MODE*1,CSURF*1
C --------------------------------
      IERR    = 0
      MD      =-ABS(MDOC)-1
      M       = 99
      N_MODEL = 0 
      NMR_I   = NMR
      NMR_INP = NMR_I 
      NA_INSIDE = 0
      NA_TOT    = 0     

      IF(PRF.NE.'N'.AND.SURF.EQ.'N'.AND.PRF.NE.'P') SURF = 'O'

      CSURF = SURF
      IF(DB.EQ.'Y') THEN
        CSURF = 'O'
        IF(SURF.EQ.'Y') CSURF = 'S' 
      ENDIF
      IF(SURF.EQ.'D') CSURF = 'Y' 

      IF(CSURF.NE.'N') THEN

        IF(CSURF.EQ.'Y'.OR.CSURF.EQ.'C') THEN
C --
          MODE = 'E'
          DO I=1,3
            SH1(I)= 0.0
            SH2(I)= 0.0
            DO J=1,3
              AM(I,J) = 0.0
            ENDDO
          ENDDO
          ALPHA  = 0.0
          BETA   = 0.0
          GAMMA  = 0.0

          NAMET  = 'molrp_scr'
          CALL ADD_PATH(PATH_SCR,NAMET)
          NAMES  = 'molrp_scr1'
          CALL ADD_PATH(PATH_SCR,NAMES)

          IERR   = 0
          IF(NMR_I.LT.0) THEN
            IERR  = ABS(NMR_I)
            NMR_I = 0
          ENDIF
C         IERR   = MODEL   

          CALL TRANS(M,NAMEM,NAMES,SH1,SH2
     *      ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
C         RESULT(12)= MODEL
C         RESULT(13)= NMODEL
          N_MODEL = RESULT(13) 

          RH2O   = 0.0
          DEL    = 0.0
          IF(BLIM.LE.0.0) BLIM   = 15.0

          CALL SURFACE(M,NAMES,NAMET,RH2O,DEL,BLIM,NMR_I,CSURF
     *     ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
C         RESULT(1) = NR
C         RESULT(2) = SURFA
C         RESULT(3) = SURFC
C         RESULT(4) = XSH
C         RESULT(5) = YSH
C         RESULT(6) = ZSH
          SH1(1)   =-RESULT(4)
          SH1(2)   =-RESULT(5)
          SH1(3)   =-RESULT(6)
c         N_MODEL  = RESULT(7)
          NA_INSIDE = RESULT(8) 

c         WRITE(*,*) 'Natom_inside:',NA_INSIDE
          MODE = 'E'
          DO I=1,3
            SH2(I)= 0.0
            DO J=1,3
              AM(I,J) = 0.0
            ENDDO
          ENDDO
          ALPHA  = 0.0
          BETA   = 0.0
          GAMMA  = 0.0
          NAMES  = NAME
          IERR   = 0
          CALL TRANS(M,NAMET,NAMES,SH1,SH2
     *      ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
          NA_TOT = RESULT(1)

        ELSE IF(CSURF.EQ.'O'.OR.SURF.EQ.'A'.OR.CSURF.EQ.'2'
     *                                     .OR.CSURF.EQ.'S') THEN
          NAMES = NAME
          CALL SHIFT2O(MDOC,CSURF,NAMEM,NAMES,PATH_SCR,SH1,NMR_I
     *     ,N_MODEL,NA_TOT,NA_INSIDE
     *     ,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900

        ENDIF

        CALL MSGDOC(MDOC,' ')
        LINE = 'INFO: model was corrected (keyword SURF="'//
     *           SURF//'")'
        CALL MSGDOC(MDOC,LINE)
        CALL MSGDOC(MDOC,
     *'      model was shifted to the origin of coordinate system')
        WRITE(LINE,'(''      shift vector   :'',3F8.2)') 
     *  SH1(1),SH1(2),SH1(3)
        CALL MSGDOC(MDOC,LINE)

        CALL OTOF(SH1,SH2,IERR)
        WRITE(LINE,'(''           /fract/   :'',3F8.3)') 
     *  SH2(1),SH2(2),SH2(3)
        CALL MSGDOC(MDOC,LINE)
        IF(N_MODEL.GT.1) THEN
          WRITE(LINE,
     *'('' Number of models (keyword NMR) :'',I4,'' ('',I2,'')'')') 
     *    N_MODEL,NMR_INP
          CALL MSGDOC(MDOC,LINE)
        ENDIF

      ELSE

        MODE = 'E'
        DO I=1,3
          SH1(I)= 0.0
          SH2(I)= 0.0
          DO J=1,3
            AM(I,J) = 0.0
          ENDDO
        ENDDO
        ALPHA  = 0.0
        BETA   = 0.0
        GAMMA  = 0.0
        NAMES  = NAME
        IERR   = 0
        IF(NMR_I.LT.0) THEN
          IERR  = ABS(NMR_I)
          NMR_I = 0
        ENDIF
C       IERR   = MODEL   
        CALL TRANS(M,NAMEM,NAMES,SH1,SH2
     *    ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
c       RESULT(1) = NTOT
C       RESULT(12)= MODEL
C       RESULT(13)= NMODEL
        NA_TOT  = RESULT(1)
        N_MODEL = RESULT(13) 
        IF(N_MODEL.GT.1) THEN
          WRITE(LINE,
     *'('' Number of models (NMR) :'',I4,'' ('',I3,'')'')') 
     *    N_MODEL,NMR_INP
          CALL MSGDOC(MDOC,LINE)
        ENDIF

      ENDIF

      IF(CSURF.EQ.'Y'.OR.CSURF.EQ.'C') THEN
        WRITE(LINE,
     *  '(''     Number of atoms:'',I8)') NA_TOT 
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(A,I8)') '     Natom_inside   :',NA_INSIDE
        CALL MSGDOC(MDOC,LINE)
      ELSE
        WRITE(LINE,
     *  '(''     Number of atoms:'',I8)') NA_TOT 
        CALL MSGDOC(MDOC,LINE)
      ENDIF     

C ----------------
  900 CONTINUE
       NMR   = NMR_I
       NAMEM = NAMES
       IF(SURF.EQ.'D') SURF = 'Y' 
C ----
       MT = 10
       NAMET='molrp_scr.crd'
       CALL DELETE_FILE(PATH_SCR,NAMET)
       NAMET='molrp_scr1.crd'
       CALL DELETE_FILE(PATH_SCR,NAMET)

      RETURN
      END

      SUBROUTINE CORR_FIXED_MODEL(MDOC,NAMEM,NAME,PATH_SCR
     *   ,SURF,BLIM,NA_INSIDE
     *   ,N_MODEL,ISYM,IPRSYM,IERR)
C -------------------------------
      PARAMETER (IPRROW = 51)
      REAL      RESULT(IPRROW)
C ---------------------------------
      INTEGER   MDOC,IERR,IPRSYM
      REAL      BLIM
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER NAMEM*(*),NAME*(*),PATH_SCR*(*),SURF*1
C ----------------------------------
      REAL      SH1(3),SH2(3),AM(3,3)
      CHARACTER NAMES*256,NAMET*256
      CHARACTER LINE*256,MODE*1
C --------------------------------
      IERR    = 0
      MD      =-ABS(MDOC)-1
      M       = 99
C ----
      NMR     = 0
      N_MODEL = 0 
      NMR_I   = NMR
      NMR_INP = NMR_I 
      NA_INSIDE = 0
      NA_TOT    = 0     

      IF(SURF.EQ.'Y'.OR.SURF.EQ.'C') THEN
C --
        MODE = 'E'
        DO I=1,3
          SH1(I)= 0.0
          SH2(I)= 0.0
          DO J=1,3
            AM(I,J) = 0.0
          ENDDO
        ENDDO
        ALPHA  = 0.0
        BETA   = 0.0
        GAMMA  = 0.0

        NAMET  = 'molrp_scr'
        CALL ADD_PATH(PATH_SCR,NAMET)
        NAMES  = 'molrp_scr1'
        CALL ADD_PATH(PATH_SCR,NAMES)

        IERR   = 0
        IF(NMR_I.LT.0) THEN
          IERR  = ABS(NMR_I)
          NMR_I = 0
        ENDIF
C       IERR   = MODEL   

        CALL TRANS(M,NAMEM,NAMES,SH1,SH2
     *      ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
C         RESULT(12)= MODEL
C         RESULT(13)= NMODEL
        N_MODEL = RESULT(13) 

        RH2O   = 0.0
        DEL    = 0.0
        IF(BLIM.LE.0.0) BLIM   = 15.0

        CALL SURFACE(M,NAMES,NAMET,RH2O,DEL,BLIM,NMR_I,SURF
     *     ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
C       RESULT(1) = NR
C       RESULT(2) = SURFA
C       RESULT(3) = SURFC
C       RESULT(4) = XSH
C       RESULT(5) = YSH
C       RESULT(6) = ZSH
c          SH1(1)   =-RESULT(4)
c          SH1(2)   =-RESULT(5)
c          SH1(3)   =-RESULT(6)
c       N_MODEL  = RESULT(7)
        NA_INSIDE = RESULT(8) 

c       WRITE(*,*) 'Natom_inside:',NA_INSIDE
        MODE = 'E'
        DO I=1,3
          SH1(I)= 0.0
          SH2(I)= 0.0
          DO J=1,3
            AM(I,J) = 0.0
          ENDDO
        ENDDO
        ALPHA  = 0.0
        BETA   = 0.0
        GAMMA  = 0.0
        NAMES  = NAME
        IERR   = 0
        CALL TRANS(M,NAMET,NAMES,SH1,SH2
     *      ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
        NA_TOT = RESULT(1)

        CALL MSGDOC(MDOC,' ')
        LINE = 'INFO: model was corrected (keyword SURFX="'//
     *           SURF//'")'
        CALL MSGDOC(MDOC,LINE)
        IF(N_MODEL.GT.1) THEN
          WRITE(LINE,
     *'(''     Number of models (keyword NMR) :'',I4,'' ('',I2,'')'')') 
     *      N_MODEL,NMR_INP
          CALL MSGDOC(MDOC,LINE)
        ENDIF

      ELSE

        MODE = 'E'
        DO I=1,3
          SH1(I)= 0.0
          SH2(I)= 0.0
          DO J=1,3
            AM(I,J) = 0.0
          ENDDO
        ENDDO
        ALPHA  = 0.0
        BETA   = 0.0
        GAMMA  = 0.0
        NAMES  = NAME
        IERR   = 0
        IF(NMR_I.LT.0) THEN
          IERR  = ABS(NMR_I)
          NMR_I = 0
        ENDIF
C       IERR   = MODEL   
        CALL TRANS(M,NAMEM,NAMES,SH1,SH2
     *    ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
c       RESULT(1) = NTOT
C       RESULT(12)= MODEL
C       RESULT(13)= NMODEL
        NA_TOT  = RESULT(1)
        N_MODEL = RESULT(13) 
        IF(N_MODEL.GT.1) THEN
          WRITE(LINE,
     *'(''     Number of models (NMR) :'',I4,'' ('',I3,'')'')') 
     *    N_MODEL,NMR_INP
          CALL MSGDOC(MDOC,LINE)
        ENDIF

      ENDIF

      IF(SURF.EQ.'Y'.OR.SURF.EQ.'C') THEN
        WRITE(LINE,
     *  '(''     Number of atoms:'',I8)') NA_TOT 
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(A,I8)') '     Natom_inside   :',NA_INSIDE
        CALL MSGDOC(MDOC,LINE)
      ELSE
        WRITE(LINE,
     *  '(''     Number of atoms:'',I8)') NA_TOT 
        CALL MSGDOC(MDOC,LINE)
      ENDIF     

C ----------------
  900 CONTINUE
       NMR   = NMR_I
       NAMEM = NAMES
C ----
       MT = 10
       NAMET='molrp_scr.crd'
       CALL DELETE_FILE(PATH_SCR,NAMET)
       NAMET='molrp_scr1.crd'
       CALL DELETE_FILE(PATH_SCR,NAMET)

      RETURN
      END

      SUBROUTINE CALC_MODEL_VOL(MDOC,NAMEM,PATH_SCR,VOL_M
     *   ,ISYM,IPRSYM,IERR)
C -------------------------------
      PARAMETER (IPRROW = 51)
      REAL      RESULT(IPRROW)
C ---------------------------------
      INTEGER   MDOC,IERR,IPRSYM
      REAL      BLIM
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER NAMEM*(*),PATH_SCR*(*)
C ----------------------------------
      REAL      AM(3,3),SH1(3),SH2(3)
      CHARACTER NAMET*256
      CHARACTER LINE*256,MODE*1,P1*1,TTT*80
C --------------------------------
      IERR    = 0
      MD      =-ABS(MDOC)-1
      M       = 99
      VOL_M   = 0.0
c ---
      MODE  = 'E'
      DO I=1,3
        SH1(I) = 0.0
        SH2(I) = 0.0
        DO J=1,3
          AM(I,J) = 0.0
        ENDDO
      ENDDO
      ALPHA = 0.0
      BETA  = 0.0
      GAMMA = 0.0
      NAMET  = ' '
      CALL TRANS(M,NAMEM,NAMET,SH1,SH2
     *      ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
      N_MODEL = RESULT(13) 

C --- 14.10.2008
        IERR  = 0
        IF(N_MODEL.GT.1) THEN
          IERR  = 1
        ENDIF
C ---
c       CALL MSGDOC(MD0,'--- generate density ---')
        RAD   = 0.0
        H2OBG = 0.0
        BADDD = 0.0
        P1    = 'Y' 
        NX    = 0
        NY    = 0
        NZ    = 0
        IZMAX =-1
        IZMIN = 0
        MODE  = 'S'
        TTT   = ' '
        ZFADD = 0.0
        RESMAX = 5.0
        NAMET  = 'molrp_scr'
        CALL ADD_PATH(PATH_SCR,NAMET)
        CALL GENDEN(M,NAMEM,NAMET,TTT
     *  ,RESMAX,NX,NY,NZ,IZMIN,IZMAX,MODE,RAD,H2OBG,BADDD,P1,ZFADD
     *  ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
C       NEL - RESULT(1)
C       RESULT(10) = SOLV
C       RESULT(14) = NSYM

        SOLV =  RESULT(10)  
        VOL_M = (1.0 - SOLV/100.0)* RESULT(14)
        IF(VOL_M.LT.0.0) VOL_M = 0.0
        IF(VOL_M.GT.1.0) VOL_M = 1.0

C ---
C ----------------
  900 CONTINUE
C ----
       MT = 10
       NAMET='molrp_scr.dat'
       CALL DELETE_FILE(PATH_SCR,NAMET)
      RETURN
      END

      SUBROUTINE CALC_FILE_DIFF(MDOC,NAMEF,NAME2,NAMEF_DIFF,NAME_DER 
     * ,NAME_PH,PATH_SCR,BOFF,BADD,BADD_SCL,ANISO
     * ,MOD2,DIFF,PRF,FUN,LIST,PERCENT_2,INVER,RESN_SCL,RESX
     * ,ISYM,IPRSYM,RESULT,IPRMAX,IPRROW,IERR)
C --------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER NAMEF*(*),NAME2*(*),NAMEF_DIFF*(*),NAME_PH*(*)
      CHARACTER PATH_SCR*(*),NAME_DER*(*)

      REAL      RESULT(IPRMAX,IPRROW),PERCENT_2
      CHARACTER DIFF*1,PRF*1,LIST*1,ANISO*1,INVER*1,MOD2*1,FUN*1
C ---
      CHARACTER NAMEF_N*256,NAMEPH_N*256,NAME_COEF*256
      CHARACTER NAMES*256,NAMET*256,NAMEC2*256
      CHARACTER LINE*256,TTT*80,ITYPE*4,ANISO_R*1
C --------------------------------------------------------------
      IERR   = 0
      MD     =-ABS(MDOC)-1
      M      = 99
      MD0    = 0
      PI     = 4.0*ATAN(1.0)
C ---
C      IF(MDOC.GT.0.AND.MDOC.LT.99) THEN
C        MDOC=1
C        IF(LIST.EQ.'S') MDOC=2
C      ELSE IF(MDOC.LT.0.AND.MDOC.GT.-99) THEN
C        MDOC=-1
C        IF(LIST.EQ.'S') MDOC=-2
C      ENDIF
C      IF(ABS(MDOC).EQ.2) MD=99
C -------------------
      MTN   = 10
      ITYPE = 'FF  '
      CALL ORFILE(M,MTN,NAMEF,ITYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN INPUT-FILE-FOBS')
        RETURN
      ENDIF
      CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *  ,F1,F2,RESMIN,RESMAX,IDM,IDM,IDM,IDM,IDM,TTT,IERR)
      CLOSE(MTN)

      IF(RESX.GT.RESMAX) RESMAX = RESX

      CALL C_RD_CR

      IF(RESN_SCL.GT.0.00001) THEN
c        BOFF_SCL = 4.0 * RESN_SCL * RESN_SCL
        BOFF_SCL = 2.0 * RESN_SCL * RESN_SCL
      ELSE
        BOFF_SCL = 256.0
      ENDIF
C ----------------------
      ANISO_R = 'N'
      IF(ANISO.EQ.'Y'.OR.ANISO.EQ.'C') ANISO_R = 'Y'
C ----------------------
C      IF(PERCENT_2.LT.0.001)  PERCENT_2 = 100.0
C      IF(PERCENT_2.GT.100.0)  PERCENT_2 = 100.0
C      WRITE(LINE,'('' DIFF : '',A)') DIFF
C      CALL MSGDOC(MD,LINE)
C      WRITE(LINE,*) 'PERCENT_2:',PERCENT_2 
C      CALL MSGDOC(MD,LINE)

      PERCENT_2 = PERCENT_2/100.0  

      NAMEF_DIFF = 'molrp_Fobs_diff'
      CALL ADD_PATH(PATH_SCR,NAMEF_DIFF)

      IF(DIFF.EQ.'M') THEN

        CALL REMOVE_MOD2_FROM_FOBS_BY_MASK(MDOC,LIST
     *  ,NAMEF,NAME_PH,NAME2
     *  ,NAMEF_N,NAMEPH_N,NAME_COEF,PATH_SCR
     *  ,RESMIN,RESMAX,BOFF,BADD
     *  ,ISYM,IPRSYM,RESULT,IPRMAX,IPRROW,IERR)
        IF(IERR.NE.0) GO TO 900


c -- var 1 - with mod2
c        NAMEF_DIFF = NAME_COEF
c        DIFF = 'F'

c -- var 2 
        NAMEF   = NAMEF_N
        NAME_PH = NAMEPH_N
c        NAME2   = ' '
c        MOD2 = 'N'
        NAMEF_DIFF = NAME_COEF
c ---

      ELSE

        CALL TEST_MR(MDOC,NAMEF,NAME2,NAME_PH,NAMEF_DIFF,PATH_SCR
     *  ,NAME_DER,FUN,LIST,BOFF,BADD,BADD_SCL
     *  ,RESMIN,RESMAX,DIFF,PRF,ANISO_R,PERCENT_2,INVER,BOFF_SCL
     *  ,ISYM,IPRSYM,RESULT,IPRMAX,IPRROW,IERR)
        IF(IERR.NE.0) GO TO 900

      ENDIF
C -----------------------------------
  900 CONTINUE
      RETURN
      END

      SUBROUTINE REMOVE_MOD2_FROM_FOBS_BY_MASK(MDOC,LIST
     *  ,NAMEF,NAMEPH,NAME2
     *  ,NAMEF_N,NAMEPH_N,NAME_COEF,PATH_SCR
     *  ,RESMIN,RESMAX,BOFF,BADD
     *  ,ISYM,IPRSYM,RESULT,IPRMAX,IPRROW,IERR)
C ------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRMAX,IPRROW)
      REAL      RESMIN,RESMAX
      CHARACTER NAMEF*(*),NAME2*(*),NAMEPH*(*)
      CHARACTER NAMEF_N*(*),NAMEPH_N*(*),NAME_COEF*(*)
      CHARACTER PATH_SCR*(*)
      CHARACTER LIST*1
      CHARACTER NAMED_OBS*256
      CHARACTER NAMED*256,NAMES*256,NAMET*256
      CHARACTER LAP*1,MSGA*1
      CHARACTER LINE*256,TTT*80,P1*1,MODE*1
C --------------------------------------
      PI     = 4.0*ATAN(1.0)
      MD     =-ABS(MDOC)-1
      M      = 99
      MD0    = 0
      IERR   = 0
C --------------------------------------
      CALL MSGDOC(MD0
     *   ,'--- Remove fixed model from Fobs by mask  ---')

      NAMES   = ' '
      NAMET   = 'molrp_dns_mask'
      CALL ADD_PATH(PATH_SCR,NAMET)
      NAMED_OBS = 'molrp_scr1'
      CALL ADD_PATH(PATH_SCR,NAMED_OBS)

      NAMED   = 'molrp_mask'
      CALL ADD_PATH(PATH_SCR,NAMED)

      NAMEPH_N = 'molrp_ph_mask'
      CALL ADD_PATH(PATH_SCR,NAMEPH_N)
      NAMEF_N  = 'molrp_f_mask'
      CALL ADD_PATH(PATH_SCR,NAMEF_N)
      NAME_COEF = 'molrp_coef_mask'
      CALL ADD_PATH(PATH_SCR,NAME_COEF)
C --------------------------------------
      CALL MSGDOC(M,'--- coef (F_obs Ph_obs)  ---')
C ---
      LAP      = 'N'
      FOMMIN   = 0.0
      MSGA     = 'N'
      BOFFF    = 0.0
      BADDD    = 0.0
      SLIM     = 0.0
      DRMS     = 0.0
      DRMS_A   = 0.0
      DEL_LIM  = 0.0
      DELA_LIM = 0.0
      SCALEF   = 1.0

      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC  
      CALL COEF_FFT(MMM,NAMEF,NAMES,NAMEPH,NAMET
     *         ,FOMMIN,RESMIN,RESMAX,BOFFF,SLIM
     *         ,DEL_LIM,DELA_LIM,DRMS,DRMS_A,LAP
     *         ,SCALEF,BADDD,MSGA,ISIM,ISYM,IPRSYM,RESULT,IERR)
      IF(IERR.NE.0) GO TO 900        
C ----
      CALL LIMHKL(RESMAX,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)
C ----

      CALL MSGDOC(M,'--- FFT (F_obs Ph_obs)  ---')
      F0     =-1.0
      IZMIN  = 0
      IZMAX  =-1
      NX     = NXMIN
      NY     = NYMIN
      NZ     = NZMIN
      CALL FFT(M,NX,NY,NZ,IZMIN,IZMAX,F0,NAMET
     * ,NAMED_OBS,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C ---
      CALL LENSTR_BL(NAME2,LEN)
      IF(LEN.GT.0.AND.NAME2(1:1).NE.' '.AND.NAME2(1:1).NE.',') THEN
        CALL MSGDOC(M,'--- generate mask for model_2 ---')
        RAD   = 3.0
        H2OBG = 0.0
        BADDD = 0.0
        P1    = 'N' 
        NX    = NXMIN
        NY    = NYMIN
        NZ    = NZMIN
        IZMAX =-1
        IZMIN = 0
        MODE  = 'S'
        TTT   = ' '
        IERR  = 0
        ZFADD = 0.0

        MMM = M
        IF(LIST.EQ.'T') MMM = MDOC

        CALL GENDEN(MMM,NAME2,NAMED,TTT
     *  ,RESMAX,NX,NY,NZ,IZMIN,IZMAX,MODE,RAD,H2OBG,BADDD,P1,ZFADD
     *  ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900

      ELSE
        IERR = 1
        GO TO 900
      ENDIF
C ---
      MODE   = 'M'
      CONST1 =-1.0
      CONST2 = 0.0 
      CALL MODDEN(M,NAMED,NAMES,NAMET
     *        ,CONST1,CONST2,MODE
     *        ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900

      MODE   = 'A'
      CONST1 = 1.0
      CONST2 = 0.0 
      CALL MODDEN(M,NAMET,NAMES,NAMED
     *        ,CONST1,CONST2,MODE
     *        ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900

      MODE   = '2'
      CONST1 = 1.0
      CONST2 = 0.0 
      CALL MODDEN(M,NAMED_OBS,NAMED,NAMET
     *        ,CONST1,CONST2,MODE
     *        ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C ---
      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC
      CALL RFFT(MMM,RESMAX
     *   ,NAMET,NAMEF_N,NAMEPH_N,PATH_SCR,ISYM,IPRSYM,RESULT
     *   ,IERR)
      IF(IERR.NE.0) GO TO 900
C ---
      LAP      = 'N'
      FOMMIN   = 0.0
      MSGA     = 'N'
      BOFFF    = 0.0
      BADDD    = 0.0
      SLIM     = 0.0
      DRMS     = 0.0
      DRMS_A   = 0.0
      DEL_LIM  = 0.0
      DELA_LIM = 0.0
      SCALEF   = 1.0

      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC  
      CALL COEF_FFT(MMM,NAMEF_N,NAMES,NAMEPH_N,NAME_COEF
     *         ,FOMMIN,RESMIN,RESMAX,BOFFF,SLIM
     *         ,DEL_LIM,DELA_LIM,DRMS,DRMS_A,LAP
     *         ,SCALEF,BADDD,MSGA,ISIM,ISYM,IPRSYM,RESULT,IERR)
      IF(IERR.NE.0) GO TO 900        
C ---
 900  CONTINUE
      RETURN
      END

      SUBROUTINE CHECK_PRF(MDOC,NAMEFM2,NAMEFFM,NAMEA,NAMEA4,INVER
     *  ,BOFF,BADD,LMAXR,LMINR,NPEAK,LIST
     *  ,FSH_MOD,RESULT,IPRMAX,IPRROW
     *  ,RESMIN,RESMAX,ARAD,ISYM,IPRSYM,IERR)
C ------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
C ----
      REAL      RESULT(IPRMAX,IPRROW)
      CHARACTER NAMEFM2*(*),NAMEFFM*(*),NAMEA*(*),NAMEA4*(*),INVER*1
      REAL      FSH_MOD(3),SH(3),RF_MAX(4),AM(3,3)
      CHARACTER LINE*256,NAME*256,LIST*1
C ----------------------------------------------------------
      PI    = 4.0*ATAN(1.0)
      MD    = -ABS(MDOC)-1
      M     = 99
      MD0   = MDOC
      TWOPI = 2.0*PI
      IERR  = 0
      IF(LIST.EQ.'S') MD = 99
C -----
      SH(1) = 0.0
      SH(2) = 0.0
      SH(3) = 0.0

      IF(LIST.EQ.'T') 
     *  CALL MSGDOC(MD0,'--- rfcoef for model ---')
 
      LMAX  = LMAXR
      LMIN  = LMINR
      NSYMZ = 1
     
      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC 
      CALL RFCOEF_100(MMM,NAMEFM2,NAMEA4
     *  ,INVER,BOFF,BADD,LMAX,LMIN,NSYMZ
     *  ,RESMIN,RESMAX,RESLIM,ARAD,FSH_MOD,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900

      NP_PRF = RESULT(1,12) 

      IF(NP_PRF.LE.0) THEN
        CALL MSGERR(MDOC,
     *  ' ERROR: number of peaks of SAPT function = 0')
        IERR = 1
        RETURN
      ENDIF

C      NPEAK = 20
C      IF(NPEAK.GT.NP_PRF) NPEAK = NP_PRF

      NP = NPEAK
      IF(NP.GT.NP_PRF.OR.NP.EQ.0) NP = NP_PRF
      RESULT(1,12) = NP

      DO I=1,NP

        SH(1) = RESULT(I, 9)
        SH(2) = RESULT(I,10)
        SH(3) = RESULT(I,11)
        SAPTF = RESULT(I, 4)

        RESULT(I,1) = I

        LMAX  = LMAXR

        NSYMZ = 1

        MMM = M
        IF(LIST.EQ.'T'.AND.I.EQ.1) MMM = MDOC 
        IF(LIST.EQ.'T') MMM = MDOC 


        CALL RFCOEF_100(MMM,NAMEFFM,NAMEA
     *     ,INVER,BOFF,BADD,LMAX,LMIN,NSYMZ
     *     ,RESMIN,RESMAX,RESLIM,ARAD,SH,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900

        IF(I.EQ.1) THEN
          WRITE(LINE,*) 'Lmin,Lmax,RESlim:',LMIN,LMAX,RESLIM
          CALL MSGDOC(MD,LINE)
          CALL MSGDOC(MD,' ')

          LINE = '--- Phased Rotation function ---'
          CALL MSGDOC(MD,LINE)

          LINE = '       alpha    beta   gamma   theta    ph'//
     *           'i    chi        PRf      SAPTF'   
          CALL MSGDOC(MD,LINE)

        ENDIF 

C ---
        IF(LIST.EQ.'T') CALL MSGDOC(MD0,'--- rfres ---')

        BETMIN =   0.0
        BETMAX = 180.0
        BETDEL =   5.0
        LMAX   = 0
        LMIN   = LMINR
        NAME   = ' '

        CALL RFRES_100_3D(Mmm,NAMEA,NAMEA4,NAME,BETMIN,BETMAX,BETDEL
     *     ,RF_MAX,LMAX,LMIN,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900

        RESULT(I,4) = RF_MAX(4) 
        RESULT(I,5) = SAPTF

        RESULT(I,6) = RF_MAX(1)
        RESULT(I,7) = RF_MAX(2)
        RESULT(I,8) = RF_MAX(3)

C        WRITE(LINE,
C     *'(''->PRF(Lmax=10) for'',I3,''th peak of SAPTF:'',G14.4,G12.4)') 
C     *      I,RESULT(I,4),RESULT(I,5)
C        CALL MSGDOC(MDOC,LINE)

        A = (RF_MAX(1)*PI)/180.0
        B = (RF_MAX(2)*PI)/180.0
        G = (RF_MAX(3)*PI)/180.0
        CALL EULERM(A,B,G,AM)
        CALL MTOPOL(AM,THETA,PHI,CHI)

        WRITE(LINE,200) I,RF_MAX(1),RF_MAX(2),RF_MAX(3)
     *  ,THETA,PHI,CHI,RF_MAX(4),SAPTF
 200    FORMAT(I3,1X,6F8.2,G14.4,G12.4)
C 200   FORMAT('Sol_RF',I3,1X,6F8.2,G14.4,F6.2)
        CALL MSGDOC(MD,LINE)

      ENDDO

      IST = 4
      CALL SORT_PEAK_PRF(MDOC,IST,RESULT,IPRMAX,IPRROW,IERR)

C -----
 900  CONTINUE
      RETURN
      END

      SUBROUTINE SORT_PEAK_PRF(MDOC,IST,RESULT,IPRMAX,IPRROW,IERR)
C -------------------------------------------------------------------    
      REAL      RESULT(IPRMAX,IPRROW)
      CHARACTER LINE*256
C -------------------------------------------------------------
      MD   =-ABS(MDOC)-1
      M    = 99
      IERR = 0
C ---
      NP = RESULT(1,12)
      IF(NP.LE.1) RETURN

c      CORR   = RESULT(1, 4)
c      SIG    = RESULT(1, 5)

      IF(IST.LE.0) IST = 4

      DO IP=1,NP-1
        DO JP=IP+1,NP
          IF(RESULT(IP,IST).LT.RESULT(JP,IST)) THEN
            DO I=1,IPRROW
              T            = RESULT(IP,I)
              RESULT(IP,I) = RESULT(JP,I)
              RESULT(JP,I) = T
            ENDDO
          ENDIF
        ENDDO
      ENDDO
      RESULT(1,12) = NP

C      do ip=1,np
C        write(*,*) '--',ip,RESULT(IP,9),RESULT(IP,10),RESULT(IP,11)
C      enddo
C --------------------------------------------
 900  CONTINUE
      RETURN
      END

      SUBROUTINE CHECK_POSITION(MDOC,NAMEC,NAMET,TEST
     *         ,ALPHA,BETA,GAMMA,SHF,SHC,PEAK_TEST
     *         ,ISYM,IPRSYM,IERR)
C ---------------------------------------------------------
C  PEAK_TEST( 1,i) Ini 0 or 1,2,3 
C  PEAK_TEST( 2,i) 0 - fract, 1 - ort 
C  PEAK_TEST( 3,i) alpha
C  PEAK_TEST( 4,i) beta
C  PEAK_TEST( 5,i) gamma
C  PEAK_TEST( 6,i)   Xo
C  PEAK_TEST( 7,i)   Yo
C  PEAK_TEST( 8,i)   Zo
C  PEAK_TEST( 9,i)   Xfrac
C  PEAK_TEST(10,i)  Yfrac
C  PEAK_TEST(11,i)  Zfrac
C  
C  PEAK_TEST(12,1) N          
C --------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      SHF(3),SHC(3),W(3),X(3),Z(3),DX(3),SHC_NEW(3)
      REAL      PEAK_TEST(12,*)
      CHARACTER NAMEC*(*),NAMET*(*),TEST*1
      CHARACTER LINE*256
C ------------------------------------------------------------
      INCLUDE 'mr_crd_com.fh'
C ---------------------------------------------------------
      PI    = 4.0*ATAN(1.0)
      TWOPI = 2.0*PI
      MD    =-ABS(MDOC)-1
      M     = 99
      IERR  = 0
C ------------
      NPT =  PEAK_TEST(12,1)
      IF(NPT.LE.0) RETURN
C -----------------------------------
      IN = 10
      CALL ORCRD(M,IN,NAMEC,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: OPEN INPUT_FILE')
        CLOSE(IN) 
        RETURN
      ENDIF
      CALL C_AT_CR
C ---
      CALL LENSTR_BL(NAMET,LEN)
      IF(LEN.GT.0.AND.NAMET(1:1).NE.' '.AND.NAMET(1:1).NE.',') THEN
        IOUT=11
        CALL OWCRD(M,IOUT,NAMET,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN OUTPUT_FILE')
          CLOSE(IN) 
          CLOSE(IOUT) 
          RETURN
        ENDIF
      ELSE
        IOUT=0
      ENDIF
      RAD_MOD = 0.0
C ---------------
      CALL CALC_DIST_TEST(MDOC,SHC,SHF,PEAK_TEST,TEST
     *   ,IS,IPT_MIN,DX,DIST_MIN,SHC_NEW  
     *   ,ALPHA,BETA,GAMMA,THETA,PHI,CHI
     *   ,THETA12,PHI12,CHI12,DORT,DPAR,RAD_MOD,IDIMER
     *   ,CR_ORT_TO_FRAC,CR_FRAC_TO_ORT  
     *   ,NSYM,ISYM,IPRSYM,IERR)

C       PEAK_TEST(,IPT_MIN)
        CALL MSGDOC(MD,' ')
        WRITE(LINE,*) 'Isym,Ipt:',IS,IPT_MIN
        CALL MSGDOC(MD,LINE)
        WRITE(LINE,*) ' ABG:',ALPHA,BETA,GAMMA
        CALL MSGDOC(MD,LINE)
        WRITE(LINE,*) ' TFC:',THETA,PHI,CHI
        CALL MSGDOC(MD,LINE)
        WRITE(LINE,*) ' SH :',SHC_NEW(1),SHC_NEW(2),SHC_NEW(3)
        CALL MSGDOC(MD,LINE)
        WRITE(LINE,*) ' TFC(1->2) :',THETA12,PHI12,CHI12
        CALL MSGDOC(MD,LINE)
        WRITE(LINE,*) ' d,ort,par :',DIST_MIN,DORT,DPAR
        CALL MSGDOC(MD,LINE)

        WRITE(LINE,
     *  '(''Sol_ 1->2 Isym,TPC,D,Dort,Dpar'',I3,I3,3F8.2,3F6.1)')
     *  IS,IPT_MIN,THETA12,PHI12,CHI12,DIST_MIN,DORT,DPAR
        CALL MSGDOC(MDOC,LINE)

C ---------------
      XS   = 0.0
      YS   = 0.0
      ZS   = 0.0
C ---
      NTOT  = 0
      IEND  =-1
      IENDW =-1
C ---
 400  CONTINUE
        CALL RDCRD(M,IN,MODE,IEND,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ INPUT_FILE')
          CLOSE(IN)
          CLOSE(IOUT)
          RETURN
        ENDIF
        IF(IEND.NE.0) GO TO 300
        IF(MODE.EQ.0) THEN

          X(1)= CR_XYZ(1) + SHC(1)
          X(2)= CR_XYZ(2) + SHC(2)
          X(3)= CR_XYZ(3) + SHC(3)

          CALL OTOF(X,W,IERR)

          Z(1) = W(1)*ISYM(1,1,IS)+W(2)*ISYM(2,1,IS)+W(3)*ISYM(3,1,IS)
          Z(2) = W(1)*ISYM(1,2,IS)+W(2)*ISYM(2,2,IS)+W(3)*ISYM(3,2,IS)
          Z(3) = W(1)*ISYM(1,3,IS)+W(2)*ISYM(2,3,IS)+W(3)*ISYM(3,3,IS)

          Z(1) = Z(1) + DX(1)
          Z(2) = Z(2) + DX(2)
          Z(3) = Z(3) + DX(3)

          CALL FTOO(Z,X,IERR)

          CR_XYZ(1) = X(1)
          CR_XYZ(2) = X(2)
          CR_XYZ(3) = X(3)

          IF((CR_ATYPE .EQ.' '.OR.CR_ATYPE .EQ.'.'.OR.
     *        CR_ATYPE .EQ.'y'.OR.CR_ATYPE .EQ.'Y'.OR.
     *        CR_ATYPE .EQ.'r'.OR.CR_ATYPE .EQ.'R').AND.
     *        CR_OCC .GT.0.0001                        ) THEN
            XS   = XS+X(1)
            YS   = YS+X(2)
            ZS   = ZS+X(3)
            NTOT = NTOT+1
          ENDIF

          IF(IOUT.GT.0) THEN
            CALL WRCRD(M,IOUT,MODE,IENDW,IERR)
            IF(IERR.NE.0) THEN
              CALL MSGERR(MDOC,' ERR: WRITE OUTPUT_FILE')
              CLOSE(IN) 
              CLOSE(IOUT) 
              RETURN
            ENDIF
          ENDIF

        ENDIF

      GO TO 400
C ---------------------------------------------------------
  300 CONTINUE

      CLOSE(IN)
      IF(IOUT.GT.0) THEN
        IENDW=1
        MODE=0     
        CALL WRCRD(MDOC,IOUT,MODE,IENDW,IERR)
      ENDIF
      IF(NTOT.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: N-ATOMS = 0')
        IERR=1
        RETURN
      ENDIF

      XS  = XS/NTOT
      YS  = YS/NTOT
      ZS  = ZS/NTOT
C      WRITE(LINE,'('' CENTRE OF COORDS :'',3F10.3)') XS,YS,ZS
C      CALL MSGDOC(MDOC,LINE)

      SHC(1) = XS
      SHC(2) = YS
      SHC(3) = ZS
      CALL OTOF(SHC,SHF,IERR)
C ------------
      RETURN
      END


      SUBROUTINE CALC_DIST_TEST(MDOC,SC,SF,PEAK_TEST,TEST
     *   ,IS_MIN,IPT_MIN,DX_MIN,DIST_MIN,SC_NEW  
     *   ,ALPHA,BETA,GAMMA,THETA,PHI,CHI
     *   ,THETA12,PHI12,CHI12,DORT,DPAR,RAD_MOD,IDIMER
     *   ,ORT_TO_FRAC,FRAC_TO_ORT  
     *   ,NSYM,ISYM,IPRSYM,IERR)
C -------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      SC(3),SF(3),SC_NEW(3),PEAK_TEST(12,*),DX_MIN(3)
      REAL      ALPHA,BETA,GAMMA,ORT_TO_FRAC(3,3),FRAC_TO_ORT(3,3)  
      CHARACTER TEST*1,LINE*256
C ---
      REAL ST(3),W(3),Z(3),XX(3),X(3),DX(3),AM(3,3),SM(3,3),BM(3,3)
      REAL CM(3,3),STO(3),DX_MIN_P(3),DX_MIN_D(3)
C -------------------------------------------------------------
      IERR = 0
      MD    =-ABS(MDOC)-1
      M     = 99
      DIST = 1.E20
      DIST_DIMER = 1.E20
      NPT  = PEAK_TEST(12,1)
      PI   = 4.0*ATAN(1.0)
C ----
      IDIMER  = 0
      IORIGIN = 0
      I = PEAK_TEST(12,1) 
      IF(I.EQ.1) THEN
        IF((ABS(PEAK_TEST(6,I)).LT.0.001.AND.
     *      ABS(PEAK_TEST(7,I)).LT.0.001.AND.
     *      ABS(PEAK_TEST(8,I)).LT.0.001    ).AND.
     *     (ABS(PEAK_TEST(9,I)).LT.0.001.AND.
     *      ABS(PEAK_TEST(10,I)).LT.0.001.AND.
     *      ABS(PEAK_TEST(11,I)).LT.0.001    )) THEN
          IORIGIN = 1
        ENDIF
      ENDIF

      IF(TEST.EQ.'4') NPT = 1

C      WRITE(*,*) ' sf :',sf(1),sf(2),sf(3)
C      WRITE(*,*) ' sc :',sc(1),sc(2),sc(3)

      CALL MSGDOC(MD,'Stick correction:')

      DO IPT = 1,NPT

        DIST_P = 1.E20

        I = PEAK_TEST(2,1)
        IF(I.NE.0) THEN
          STO(1) = PEAK_TEST( 6,IPT)    
          STO(2) = PEAK_TEST( 7,IPT)  
          STO(3) = PEAK_TEST( 8,IPT) 
          CALL OTOF(STO,ST,IERR)
        ELSE
          ST(1) = PEAK_TEST( 9,IPT)    
          ST(2) = PEAK_TEST(10,IPT)  
          ST(3) = PEAK_TEST(11,IPT) 
          CALL FTOO(ST,STO,IERR)
        ENDIF

C        WRITE(*,*) ' npt:',ipt,PEAK_TEST(1,IPT),PEAK_TEST(2,IPT)
C        WRITE(*,*) '   f:',st(1),st(2),st(3)   
C        WRITE(*,*) '   o:',STO(1),STO(2),STO(3)   

        A2  = PEAK_TEST(3,IPT)
        B2  = PEAK_TEST(4,IPT)
        G2  = PEAK_TEST(5,IPT)
              
        W(1) = SF(1)
        W(2) = SF(2)
        W(3) = SF(3)

        DO IS=1,NSYM


          Z(1) = W(1)*ISYM(1,1,IS)+W(2)*ISYM(2,1,IS)+W(3)*ISYM(3,1,IS)
          TTX  = REAL(ISYM(4,1,IS))/REAL(ISYM(5,1,IS))
          Z(2) = W(1)*ISYM(1,2,IS)+W(2)*ISYM(2,2,IS)+W(3)*ISYM(3,2,IS)
          TTY  = REAL(ISYM(4,2,IS))/REAL(ISYM(5,2,IS))
          Z(3) = W(1)*ISYM(1,3,IS)+W(2)*ISYM(2,3,IS)+W(3)*ISYM(3,3,IS)
          TTZ  = REAL(ISYM(4,3,IS))/REAL(ISYM(5,3,IS))

          Z(1) = Z(1) + TTX
          Z(2) = Z(2) + TTY
          Z(3) = Z(3) + TTZ

          DX(1) =  TTX
          DX(2) =  TTY
          DX(3) =  TTZ

          XX(1) = Z(1) - ST(1)
          XX(2) = Z(2) - ST(2)
          XX(3) = Z(3) - ST(3)

C ---
 10       CONTINUE
          IF(XX(1).GE.0.5)THEN
            XX(1) = XX(1)-1.0
            DX(1) = DX(1)-1.0
            GO TO 10
          ENDIF
 20       CONTINUE
          IF(XX(1).LT.-0.5)THEN
            XX(1) = XX(1)+1.0
            DX(1) = DX(1)+1.0
            GO TO 20
          ENDIF
 30       CONTINUE
          IF(XX(2).GE.0.5)THEN
            XX(2) = XX(2)-1.0
            DX(2) = DX(2)-1.0
            GO TO 30
          ENDIF
 40       CONTINUE
          IF(XX(2).LT.-0.5)THEN
            XX(2) = XX(2)+1.0
            DX(2) = DX(2)+1.0
            GO TO 40
          ENDIF
 50       CONTINUE
          IF(XX(3).GE.0.5)THEN
            XX(3) = XX(3)-1.0
            DX(3) = DX(3)-1.0
            GO TO 50
          ENDIF
 60       CONTINUE
          IF(XX(3).LT.-0.5)THEN
            XX(3) = XX(3)+1.0
            DX(3) = DX(3)+1.0
            GO TO 60
          ENDIF
C ---
          CALL FTOO(XX,X,IERR)

          D2 = X(1)*X(1)+X(2)*X(2)+X(3)*X(3)
          D  = SQRT(D2)

          IF(D2.LT.DIST) THEN
            IS_MIN    = IS
            IPT_MIN   = IPT
            DX_MIN(1) = DX(1)
            DX_MIN(2) = DX(2)
            DX_MIN(3) = DX(3)
            DIST_MIN  = SQRT(D2)
            DIST      = D2
          ENDIF

          IF(D2.LT.DIST_P) THEN
            IS_MIN_P    = IS
            IPT_MIN_P   = IPT
            DX_MIN_P(1) = DX(1)
            DX_MIN_P(2) = DX(2)
            DX_MIN_P(3) = DX(3)
            DIST_MIN_P  = SQRT(D2)
            DIST_P      = D2
          ENDIF
C ///
          IF(IORIGIN.EQ.0) THEN
            A1 = ALPHA
            B1 = BETA
            G1 = GAMMA
            A2     = PEAK_TEST(3,IPT)
            B2     = PEAK_TEST(4,IPT)
            G2     = PEAK_TEST(5,IPT)
            STO(1) = PEAK_TEST(6,IPT)    
            STO(2) = PEAK_TEST(7,IPT)  
            STO(3) = PEAK_TEST(8,IPT) 
            DDD   = SQRT(D2)
            CALL ONE2TWO(SC,DX,STO,DDD,SC_NEW
     *      ,A1,B1,G1,A2,B2,G2,THETA,PHI,CHI
     *      ,THETA12,PHI12,CHI12,DORT,DPAR
     *      ,ORT_TO_FRAC,FRAC_TO_ORT  
     *      ,IS,NSYM,ISYM,IPRSYM,IERR)

            WRITE(LINE,'(A,2I3,A,3F8.2)') 
     *      '  Mol:',IPT,IS,' Rotation (polar angles) :'
     *      ,THETA12,PHI12,CHI12
            CALL MSGDOC(MD,LINE)
            WRITE(LINE,'(A,F6.1)') 
     *      '         Distance between centres (A) :'
     *      ,DDD
            CALL MSGDOC(MD,LINE)
            WRITE(LINE,'(A,2F6.1)') 
     *      '         Ortogonal axis distance and parallel (A) :'
     *      ,DORT,DPAR
            CALL MSGDOC(MD,LINE)
            
            IF(RAD_MOD.GT.0.001) THEN
              RAD_MOD_LIM = 3.0*RAD_MOD
              IF(DORT.LE.RAD_MOD_LIM.AND.DPAR.LE.2.5.AND.
     *           ABS(ABS(CHI12)-180.0).LE.2.5) THEN
                IDIMER = 1
                IF(DDD.LT.DIST_DIMER) THEN
                   DIST_DIMER = DDD
                   IS_MIN_D    = IS
                   IPT_MIN_D   = IPT
                   DX_MIN_D(1) = DX(1)
                   DX_MIN_D(2) = DX(2)
                   DX_MIN_D(3) = DX(3)
                   DIST_MIN_D  = DDD
                ENDIF
              ENDIF
            ENDIF
          ENDIF  
C///

        ENDDO
C ///
        IF(IORIGIN.EQ.0) THEN
          A1 = ALPHA
          B1 = BETA
          G1 = GAMMA
          A2     = PEAK_TEST(3,IPT_MIN_P)
          B2     = PEAK_TEST(4,IPT_MIN_P)
          G2     = PEAK_TEST(5,IPT_MIN_P)
          STO(1) = PEAK_TEST(6,IPT_MIN_P)    
          STO(2) = PEAK_TEST(7,IPT_MIN_P)  
          STO(3) = PEAK_TEST(8,IPT_MIN_P) 
          CALL ONE2TWO(SC,DX_MIN_P,STO,DIST_MIN_P,SC_NEW
     *    ,A1,B1,G1,A2,B2,G2,THETA,PHI,CHI
     *    ,THETA12,PHI12,CHI12,DORT,DPAR
     *    ,ORT_TO_FRAC,FRAC_TO_ORT  
     *    ,IS_MIN_P,NSYM,ISYM,IPRSYM,IERR)

          WRITE(LINE,'(A,I3,A,3F8.2)') 
     *    '  Mol:',IPT_MIN_P,' Rotation (polar angles) :'
     *    ,THETA12,PHI12,CHI12
C          CALL MSGDOC(MDOC,LINE)
          WRITE(LINE,'(A,F6.1)') 
     *    '         Distance between centres (A) :'
     *    ,DIST_MIN_P
C          CALL MSGDOC(MDOC,LINE)
          WRITE(LINE,'(A,2F6.1)') 
     *    '         Ortogonal axis distance and parallel (A) :'
     *    ,DORT,DPAR
C          CALL MSGDOC(MDOC,LINE)
        ENDIF
C///
      ENDDO

      CALL VCOPY(SC,SC_NEW)

      IF(IDIMER.GT.0) THEN
        IS_MIN    = IS_MIN_D
        IPT_MIN   = IPT_MIN_D 
        DX_MIN(1) = DX_MIN_D(1)
        DX_MIN(2) = DX_MIN_D(2)
        DX_MIN(3) = DX_MIN_D(3)
        DIST_MIN  = DIST_MIN_D
      ENDIF

C      IF(IS_MIN.GT.1) THEN

        A2     = PEAK_TEST(3,IPT_MIN)
        B2     = PEAK_TEST(4,IPT_MIN)
        G2     = PEAK_TEST(5,IPT_MIN)
        STO(1) = PEAK_TEST(6,IPT_MIN)    
        STO(2) = PEAK_TEST(7,IPT_MIN)  
        STO(3) = PEAK_TEST(8,IPT_MIN) 

        CALL ONE2TWO(SC,DX_MIN,STO,DIST_MIN,SC_NEW
     *   ,ALPHA,BETA,GAMMA,A2,B2,G2,THETA,PHI,CHI
     *   ,THETA12,PHI12,CHI12,DORT,DPAR
     *   ,ORT_TO_FRAC,FRAC_TO_ORT  
     *   ,IS_MIN,NSYM,ISYM,IPRSYM,IERR)

C        WRITE(*,*) ' ABG:',ALPHA,BETA,GAMMA
C        WRITE(*,*) ' TFC:',THETA,PHI,CHI
C        WRITE(*,*) ' SH :',SC_NEW(1),SC_NEW(2),SC_NEW(3)
C        WRITE(*,*) ' TFC(1->2) :',ipt,THETA12,PHI12,CHI12
C        WRITE(*,*) ' d,ort,par :',DIST_MIN,DORT,DPAR

C      ENDIF

      RETURN
      END

      SUBROUTINE ONE2TWO(SC,DX,STO,DIST,SC_NEW
     *   ,ALPHA,BETA,GAMMA,A2,B2,G2,THETA,PHI,CHI
     *   ,THETA12,PHI12,CHI12,DORT,DPAR
     *   ,ORT_TO_FRAC,FRAC_TO_ORT  
     *   ,IS,NSYM,ISYM,IPRSYM,IERR)
C -------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      SC(3),SC_NEW(3),DX(3)
      REAL      ORT_TO_FRAC(3,3),FRAC_TO_ORT(3,3)  
C ---
      REAL W(3),Z(3),XX(3),X(3),AM(3,3),SM(3,3),BM(3,3)
      REAL CM(3,3),STO(3)
C -------------------------------------------------------------
      PI   = 4.0*ATAN(1.0)

C     new alpha,beta,gamma
C     [F2O] * [IS] * [O2F]* [alpha,beta,gamma]
      A  = (ALPHA*PI)/180.0
      B  = (BETA *PI)/180.0
      G  = (GAMMA*PI)/180.0
      CALL EULERM(A,B,G,BM)
      SM(1,1) = ISYM(1,1,IS)
      SM(2,1) = ISYM(2,1,IS)
      SM(3,1) = ISYM(3,1,IS)
      SM(1,2) = ISYM(1,2,IS)
      SM(2,2) = ISYM(2,2,IS)
      SM(3,2) = ISYM(3,2,IS)
      SM(1,3) = ISYM(1,3,IS)
      SM(2,3) = ISYM(2,3,IS)
      SM(3,3) = ISYM(3,3,IS)
      CALL MATMLT(SM,ORT_TO_FRAC,AM)
      CALL MATMLT(FRAC_TO_ORT,AM,CM)

      CALL MATMLT(CM,BM,AM)
      CALL MTOPOL(AM,THETA,PHI,CHI)
      CALL MTOANG(AM,ALPHA,BETA,GAMMA)

C       new shift:   [cm] * shc + [f2o] * dx

      CALL MVMULT(CM,SC,X)
      CALL MVMULT(FRAC_TO_ORT,DX,XX)
      CALL VADD(X,XX,SC_NEW)

C        WRITE(*,*) ' ABG:',ALPHA,BETA,GAMMA
C        WRITE(*,*) ' TFC:',THETA,PHI,CHI
C        WRITE(*,*) ' SH :',SC_NEW(1),SC_NEW(2),SC_NEW(3)
       
      CALL MTRANS(AM,SM)
      A  = (A2*PI)/180.0
      B  = (B2*PI)/180.0
      G  = (G2*PI)/180.0
      CALL EULERM(A,B,G,BM)                                   
C       rot 1-->2:  [M]*[abg]*x = [abg2]*x    [M] = [abg2]*[abg]T
      CALL MATMLT(BM,SM,CM)
      CALL MTOPOL(CM,THETA12,PHI12,CHI12)
C        WRITE(*,*) ' TFC(1->2):',THETA12,PHI12,CHI12
      CALL VSUB(STO,SC_NEW,W)
      CALL MVMULT(CM,W,XX)
      CALL VSUB(XX,W,X)
      S = 0.5
      CALL VSCAL(X,S,Z)
      CALL VMOD(Z ,DORT)

      CALL VADD(W ,Z,XX)
      CALL VMOD(XX,DPAR)

c     WRITE(*,*) '  -d,ort,par:',DIST,DORT,DPAR

      TH  = (THETA12*PI)/180.0
      PH  = (PHI12  *PI)/180.0
      CH  = PI
      CALL POLTOM(TH,PH,CH,CM)
      CALL MVMULT(CM,W,XX)
      CALL VSUB(XX,W,X)
      S = 0.5
      CALL VSCAL(X,S,Z)
      CALL VADD(W ,Z,XX)
      CALL VMOD(XX,DPAR)

C     WRITE(*,*) '  d,ort,par:',DIST,DORT,DPAR
      RETURN
      END

      SUBROUTINE TRF_DIMER(MDOC,NAMEF,NAMEM,NAMEM2,NAME2,NAME_TSRF
     * ,PATH_OUT,PATH_SCR
     * ,TALPHA,TGAMMA,TBETA,TALPHA2,TGAMMA2,TBETA2
     * ,IPAR_TR,FPAR_TR,PARM_TR,PEAK_TEST
     * ,ISYM,IPRSYM
     * ,RESULT,RESULT2,RESULTA,IPRMAX,IPRROW,IPRCYCL,IERR)
C -------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      TALPHA(*) ,TGAMMA(*) ,TBETA(*)
      REAL      TALPHA2(*),TGAMMA2(*),TBETA2(*)

      real,     allocatable :: POOL_SCR(:)

C ----
      CHARACTER NAMEF*(*),NAMEM*(*),NAMEM2*(*),NAME2*(*),NAME_TSRF*(*)
      CHARACTER PATH_OUT*(*),PATH_SCR*(*)
      REAL      RESULT (IPRMAX,IPRROW)
      REAL      RESULT2(IPRMAX,IPRROW)
      REAL      RESULTA(IPRMAX,IPRROW)
      REAL      PEAK_TEST(12,*)
      INTEGER   IPAR_TR(*)
C
      REAL      FPAR2_TR(20)
      CHARACTER PARM2_TR*30
C
      CHARACTER NAMEC*256,NAMEC12*256,NAMES1*256,NAMEPH_PK*256
      CHARACTER NAMES*256,NAMED*256,NAMEFM*256,NAMEPH*256,NAMES4*256
      CHARACTER NAMEFM2*256,NAMEPH2*256,NAMET*256,NAMEPH2_PK*256
      CHARACTER NAMEFMO*256,NAMEPHO*256,NAMEFMO_PK*256,NAMEPHO_PK*256
      CHARACTER NAMEFM_PK*256,NAMEFM2_PK*256,NAMEP*256,NAMETR*256
      CHARACTER NAMES2*256,NAMES3*256,NAME_BEST*256,NAME_MON*256
      CHARACTER NAMEFMO_N*256,NAMEFM_N*256,NAMEFM2_N*256
      CHARACTER NAMEFM12*256,NAMEPH12*256,NAMEFM12_PK*256
      CHARACTER NAMEPH12_PK*256
      CHARACTER NAME_TR*256

      CHARACTER COEF_PATT_P1*256,FOBS_P1*256,PHOBS_P1*256

      CHARACTER NAMEC1*256,NAMEC2*256,NAMEO*256,NAMET_OUT*256
      CHARACTER NAMEFMC*256,NAMEPHC*256,NAME_SRF*256
      CHARACTER NAMEDD*256,NAME_DNS(2)*256
      CHARACTER NAME_FCALC*256,NAME_PHCALC*256
C
      CHARACTER LINE*256
      CHARACTER TTT*80,ITYPE*4,MODE*1,INVER*1,TEST_SRF*1,FUNP*1,SURFX*1
      CHARACTER TFUN*1,PACK*1,SURF*1,PST*1,ANISO*1,MOD2*1,LIST*1
      CHARACTER LAP*1,MSGA*1,MODE_D*1,CH2*2,DYAD*1,FAST*1,REF*1,STICK*1
      CHARACTER TEST_T*1,MOD_D2*1,CALC2*1,MOD1*1,MOD2S*1,ANISO_T*1
      CHARACTER PST_T*1,MOD2_INI*1,DIFF*1,TEST*1,LH*1
      CHARACTER ANISO_T1*1,ANISO_T2*1,ANISO_T12*1,CH10*10
      REAL      ANGLES_NCS_INP(3),CENTRE_NCS(3)
      REAL      FRTOCR(3,3),CRTOFR(3,3)
      REAL      AM(3,3),SH1(3),SH2(3),SPST(3),SH12(3),SH12F_CURR(3)
      REAL      RLATT(6),SH1_BEST(3),SH1_CURR(3),SH12F(3),SH12F_BEST(3)
      REAL      FPAR_TR(20)
      CHARACTER PARM_TR*30
      CHARACTER CODEPDB*4,NAMEPDB*40,DATEPDB*9,SPGR*24,TITLEPDB*80 
C ---------------------------------------
      INCLUDE 'molrep_lh_infor.fh'
C      COMMON/COM_LH_INFOR/ BOFF_LH,BADD_LH,BOFF_FOR_SCAL
C     *   ,CHECK_CONTRAST,CONTRAST_LIM
C     *   ,BCORR_LH,FILE_FOBS_LH,SCORE_FLAG,LH_LH,DB_LH 
CC ---
C      REAL      CHECK_CONTRAST,CONTRAST_LIM
C      REAL      BOFF_FOR_SCAL,BOFF_LH,BADD_LH,BCORR_LH
C      CHARACTER LH_LH*1,SCORE_FLAG*1,DB_LH*1
C      CHARACTER FILE_FOBS_LH*256
C ----------------------------------
      CHARACTER TIME_CURRENT*15,TIME_ELAPSED*15,TIME_EXPECTED*15
C ------------------------------------------------------------
      PARAMETER ( NSCORE_MAX = 150)
      REAL      SCORE_STOR(NSCORE_MAX)
      REAL      SCORE_AVER(NSCORE_MAX)
      REAL      SCORE_AVER2(NSCORE_MAX)
      INTEGER   ISCORE_NUMB(NSCORE_MAX)
c --------------------------------------------------------
c     PARAMETER ( NP_SRF_MAX = 50 )
      PARAMETER ( NP_SRF_MAX = 200)
      REAL      SRF_ALPHA(NP_SRF_MAX),SRF_BETA (NP_SRF_MAX) 
     *         ,SRF_GAMMA(NP_SRF_MAX),SRF_THETA(NP_SRF_MAX) 
     *         ,SRF_PHI  (NP_SRF_MAX),SRF_CHI  (NP_SRF_MAX) 
C ------------------------------------------------------------
      COMMON/TRFUN_COM_TMP/ FOBS_000,FMOD1_000,FMOD2_000,NEL2,IERR_PK
     *                     ,SCALEP_STORE,BOVER_STORE,SIGMA_STORE
C ---
      INCLUDE 'molrep_xml.fh'
C -------------------------------------------------------------
C ---XML--
      JOB_XML = 'MR_DYAD_SEARCH'
C  ================================================
C TAB_SRF ?, FAST ='F', REF = 'N', PST = 'N', NMR = 0, STICK = 'N' 
      IERR      = 0
      ISIGNAL_STOP = 0
      LH_LH     = 'N'
      FOBS_000  = 0.0
      FMOD1_000 = 0.0
      FMOD2_000 = 0.0
      NEL2      = 0
      IERR_PK   = 0
      NMR       = 0
      DO I=1,3
        ANGLES_NCS_INP(I) = 0.0
        CENTRE_NCS(3)     = 0.0
      ENDDO
      CONTRAST_BEST = 0.0
      NSCORE        = 0.0
C ------
      PI      = 4.0*ATAN(1.0)
      RTODEG  = 180./PI
      DEGTOR  = 1.0/RTODEG

      MD      = -ABS(MDOC)-1
      M       = 99
      MD0     = 0
      IF(ABS(MDOC).GE.99) MD0 = 99
      MOD2_INI = 'N'
      TEST     = ' '
C ------------------------------
      CALL MSGDOC(MDOC,'Sol_ ')
      CALL MSGDOC(MDOC,'Sol_--- Multi-copy Search ---')
      CALL MSGDOC(MDOC,'Sol_ ')
      DYAD       = PARM_TR(1:1)
      FAST       = PARM_TR(2:2)
      REF        = PARM_TR(3:3)
      MOD2       = PARM_TR(4:4)
      ANISO      = PARM_TR(5:5)
      PACK       = PARM_TR(6:6)
      SURF       = PARM_TR(7:7)
      TEST_SRF   = PARM_TR(8:8)
      LIST       = PARM_TR(9:9)
      MOD1       = PARM_TR(10:10)
      MOD2S      = PARM_TR(11:11)
      STICK      = PARM_TR(12:12)
      DIFF       = PARM_TR(21:21)
      SURFX      = PARM_TR(22:22)

      RESN       = FPAR_TR( 1)
      RESX       = FPAR_TR( 2)
      DLIM_MIN_I = FPAR_TR( 3)
      DLIM_MAX_I = FPAR_TR( 4)
      DPAR_MAX   = FPAR_TR( 5)
      BOFF       = FPAR_TR( 6)
      BADD       = FPAR_TR( 7)
      BLIM_IN    = FPAR_TR( 8)
      CHI_IN     = FPAR_TR( 9)
      SRF_DELTA  = FPAR_TR(10)
      BOFF_SCL   = FPAR_TR(11)
      BADD_SCL   = FPAR_TR(12)
      RAD_MODEL  = FPAR_TR(19) 

      NPROT      = IPAR_TR(1) 
      NPROT2     = IPAR_TR(2)
      NMON       = IPAR_TR(3)
      NMR_INP    = IPAR_TR(4) 
      NPSRF      = IPAR_TR(5)   
      NPT        = IPAR_TR(6)
      NPT_DM     = IPAR_TR(7) 
      ISYM_DYAD  = IPAR_TR(8) 

      IF(ANISO.EQ.'Y') ANISO = 'N'

      NUM_MON    = 0
      NUM_MON_IN = 0
      TFUN       = 'S'
      INVER      = ' '
      PST        = 'N'
      SPST(1)    = 0.0
      SPST(2)    = 0.0
      SPST(3)    = 0.0
      IF(RESX.LT.0.00001) RESX = 3.0
      CORR_TOT   =-1.1
      RFAC_TOT   = 0.0
      MOD2       = 'N'
      REF        = 'N'
C     STICK      = 'N'
      FAST       = 'F'   
      CORR_TOT_MON =-2.5
      RFAC_TOT_MON = 0.0
      IR_TOT_MON   = 0
      IF(NPT_DM.LE.0) NPT_DM = 5
      IF(NPT   .LE.0) NPT    = 10
      NMR_INP    = 0
      IF(LIST.EQ.'S') THEN
        MD = 99
      ELSE IF(LIST.EQ.'T') THEN
        MD  = MDOC
        MD0 = 0
      ENDIF
C -----
      NAMES      = ' '
      NAMES1     = ' '
      NAMES2     = ' '
      NAMES3     = ' '
      NAMES4     = ' '
      NAMEC      = 'trfn_scr'
      CALL ADD_PATH(PATH_SCR,NAMEC)  
      NAMEDD     = 'trfun_dns3'
      CALL ADD_PATH(PATH_SCR,NAMEDD)  
      NAME_DNS(1)= 'trfun_dns1'
      CALL ADD_PATH(PATH_SCR,NAME_DNS(1))  
      NAME_DNS(2)= 'trfun_dns2'
      CALL ADD_PATH(PATH_SCR,NAME_DNS(2))  
  
      NAME_BEST  = 'trfn_best'
      CALL ADD_PATH(PATH_SCR,NAME_BEST)  
      NAMEO      = 'molrep'
      CALL ADD_PATH(PATH_SCR,NAMEO)  
      NAMEC1     = 'trfn_mod1'
      CALL ADD_PATH(PATH_SCR,NAMEC1)  
      NAMEC2     = 'trfn_mod2'
      CALL ADD_PATH(PATH_SCR,NAMEC2)  
      NAMEC12    = 'trfn_mod12'
      CALL ADD_PATH(PATH_SCR,NAMEC12)  
      NAMEFM     = 'trfn_f'
      CALL ADD_PATH(PATH_SCR,NAMEFM)  
      NAMEPH     = 'trfn_ph'
      CALL ADD_PATH(PATH_SCR,NAMEPH)  
      NAMEFM_PK  = 'trfn_f_pk'
      CALL ADD_PATH(PATH_SCR,NAMEFM_PK)  
      NAMEPH_PK  = 'trfn_ph_pk'
      CALL ADD_PATH(PATH_SCR,NAMEPH_PK)  
      NAMEFM2    = 'trfn_f2'
      CALL ADD_PATH(PATH_SCR,NAMEFM2)  
      NAMEPH2    = 'trfn_ph2'
      CALL ADD_PATH(PATH_SCR,NAMEPH2)  
      NAMEFM2_PK = 'trfn_f2_pk'
      CALL ADD_PATH(PATH_SCR,NAMEFM2_PK)  
      NAMEPH2_PK = 'trfn_ph2_pk'
      CALL ADD_PATH(PATH_SCR,NAMEPH2_PK)  
      NAMEFMO    = 'trfn_fo'
      CALL ADD_PATH(PATH_SCR,NAMEFMO)  
      NAMEPHO    = 'trfn_pho'
      CALL ADD_PATH(PATH_SCR,NAMEPHO)  
      NAMEFMO_PK = 'trfn_fo_pk'
      CALL ADD_PATH(PATH_SCR,NAMEFMO_PK)  
      NAMEPHO_PK = 'trfn_pho_pk'
      CALL ADD_PATH(PATH_SCR,NAMEPHO_PK)  
      NAMEP      = 'trfun_pack'
      CALL ADD_PATH(PATH_SCR,NAMEP)  
      NAMETR     = 'trfun_trn'
      CALL ADD_PATH(PATH_SCR,NAMETR)  
      NAMEFMC    = 'trfn_fc'
      CALL ADD_PATH(PATH_SCR,NAMEFMC)  
      NAMEPHC    = 'trfn_phc'
      CALL ADD_PATH(PATH_SCR,NAMEPHC)  
      NAME_MON   = 'trfn_mon'
      CALL ADD_PATH(PATH_SCR,NAME_MON)  
      NAME_SRF   = 'molrep_srf.tab'
      CALL ADD_PATH(PATH_SCR,NAME_SRF)  

      CALL LENSTR_BL(NAME_TSRF,LEN)
      IF(LEN.GT.0) NAME_SRF = NAME_TSRF

      NAMEFMO_N  = 'trfn_fon'
      CALL ADD_PATH(PATH_SCR,NAMEFMO_N)  
      NAMEFM2_N  = 'trfn_f2n'
      CALL ADD_PATH(PATH_SCR,NAMEFM2_N)  
      NAMEFM_N   = 'trfn_fn'
      CALL ADD_PATH(PATH_SCR,NAMEFM_N)  
      NAMEFM12   = 'trfn_f12'
      CALL ADD_PATH(PATH_SCR,NAMEFM12)  
      NAMEPH12   = 'trfn_ph12'
      CALL ADD_PATH(PATH_SCR,NAMEPH12)  
      NAMEFM12_PK= 'trfn_f12_pk'
      CALL ADD_PATH(PATH_SCR,NAMEFM12_PK)  
      NAMEPH12_PK= 'trfn_ph12_pk'
      CALL ADD_PATH(PATH_SCR,NAMEPH12_PK)  
 
      FOBS_P1      = 'trfn_f_p1'
      CALL ADD_PATH(PATH_SCR,FOBS_P1)  
      PHOBS_P1     = 'trfn_ph_p1'
      CALL ADD_PATH(PATH_SCR,PHOBS_P1)  
      COEF_PATT_P1 = 'molrp_diff.dat'
      CALL ADD_PATH(PATH_SCR,COEF_PATT_P1)  

C -------------------------------------------------------
C
      BLIM = BLIM_IN
C     second fixed model
      CALL LENSTR_BL(NAME2,LEN)
      IF(LEN.GT.0.AND.NAME2(1:1).NE.' '.AND.
     *                NAME2(1:1).NE.',') THEN
        MOD2_INI = 'Y'
        MOD2     = 'Y'
        NUM_MON_IN = 1
        BLIM = -1.0
        MODE = 'E'
        DO I=1,3
          SH1(I) = 0.0
          SH2(I) = 0.0
          DO J=1,3
            AM(I,J) = 0.0
          ENDDO
        ENDDO
        AL  = 0.0
        BE  = 0.0
        GA  = 0.0
        CALL TRANS(M,NAME2,NAMEO,SH1,SH2
     *    ,MODE,AM,AL,BE,GA,RESULTA,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
      ENDIF
C ------
      CALL MSGDOC(M,
     *' --- input peaks of Rotation Function ---')
      LINE = 'Sol_         alpha    beta   gamma'
      CALL MSGDOC(M,LINE)    
      DO I=1,NPROT
        WRITE(LINE,'(''Sol_RF '',I3,1X,3F8.2)') 
     *  I,TALPHA(I),TBETA(I),TGAMMA(I)
        CALL MSGDOC(M,LINE)    
      ENDDO
C ---------
      CALL LENSTR_BL(NAMEM2,LEN)
      IF(LEN.GT.0.AND.NAMEM2(1:1).NE.' '.AND.
     *                NAMEM2(1:1).NE.',') THEN
        MOD_D2 = 'Y'
        IF(NMON.LE.1) NMON = 2
        NMON = (NMON/2)*2

        CALL MSGDOC(M,
     *  ' --- input peaks of Rotation Function-2 ---')
        LINE = 'Sol_         alpha    beta   gamma'
        CALL MSGDOC(M,LINE)    
        DO I=1,NPROT2
          WRITE(LINE,'(''Sol_RF2'',I3,1X,3F8.2)') 
     *    I,TALPHA2(I),TBETA2(I),TGAMMA2(I)
          CALL MSGDOC(M,LINE)    
        ENDDO
        NMR_INP = 0
      ELSE
        MOD_D2 = 'N'        
        NAMEM2 = NAMEM
        NPROT2 = NPROT
      ENDIF
C ------
      MTN   = 10
      ITYPE = 'FF  '
      CALL ORFILE(M,MTN,NAMEF,ITYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: OPEN INPUT-FILE-FOBS (in TRFUN)')
        RETURN
      ENDIF
      CALL GET_TITLE(MD,A,B,C,AL,BE,GA
     *  ,F1,F2,RESMIN,RESMAX,IDM,IDM,IDM,IDM,IDM,TTT,IERR)
      CALL C_RD_CR
      CALL GET_CELL(RLATT,CODEPDB,NAMEPDB,DATEPDB,TITLEPDB
     *   ,NSPGR,NSETT,SPGR,NSM,IERR)
      CALL CALC_NREF_FOR_RESMAX_SCR(RESMAX,RLATT,NSYM,ISYM,NTOT_SCR)
      CLOSE(MTN)
C -----
      IF(RESX.GT.0.00001) RESMAX = RESX
      IF(BOFF .LE.0.000001) BOFF  =  900.0
C -----
      WRITE(LINE,'(''Sol_ Resmin,Resmax     :'',2F8.2)') 
     * RESMIN,RESMAX
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(''Sol_ Boff,Badd         :'',2F8.2)') 
     * BOFF,BADD
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,'(''Sol_ Boff_scl,Badd_scl :'',2F8.2)') 
     * BOFF_SCL,BADD_SCL
      CALL MSGDOC(MD,LINE)
C ----
      IF(SRF_DELTA.LE.0.00001) SRF_DELTA = 10.0

C        WRITE(LINE,'('' NPROT,NPT,NPT_DM,NPSRF,ISYM_DYAD :'',5I4)') 
C     *  NPROT,NPT,NPT_DM,NPSRF,ISYN_DYAD
C        CALL MSGDOC(MDOC,LINE)
 
      NP_SRF = 0 
      IF(TEST_SRF.EQ.'Y') THEN
        CALL GET_CR_MATRIX(FRTOCR,CRTOFR)
        CALL READ_TAB_SRF(MDOC,NAME_SRF,NPSRF,RESULT,IPRMAX,IPRROW
     *                  ,FRTOCR,CRTOFR,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
        NP_SRF = RESULT(1,12) 
        IF(NP_SRF.LE.0) THEN
          CALL MSGERR(MDOC,
     *  ' ERROR: number of peaks of self rotation function = 0')
          IERR = 1
          GO TO 900
        ENDIF

        IF(TEST_SRF.EQ.'Y') THEN 
        IF(NP_SRF.GT.NP_SRF_MAX) NP_SRF = NP_SRF_MAX
        IF(ABS(NPSRF).GT.0.AND.NP_SRF.GT.ABS(NPSRF)) NP_SRF = ABS(NPSRF)  
        DO I=1,NP_SRF
          SRF_ALPHA(I) = RESULT(I,6)
          SRF_BETA (I) = RESULT(I,7)
          SRF_GAMMA(I) = RESULT(I,8)
          SRF_THETA(I) = RESULT(I,9)
          SRF_PHI  (I) = RESULT(I,10)
          SRF_CHI  (I) = RESULT(I,11)
        ENDDO
        WRITE(LINE,'('' Npeak_selfRF             :'',I4)') 
     *  NP_SRF
        CALL MSGDOC(MDOC,LINE)
c        DYAD = 'D'
      ENDIF
      ENDIF
C -----
      N_MODEL = 0
      CALL DEF_RAD(M,MOD1,NAMEM,RESULT,ISYM,IPRSYM,IERR)
      N_MODEL   = RESULT(13,1)
      ARADI1    = RESULT(11,1)
      ARADI     = ARADI1
      SIZE_MAX1 = RESULT(1 ,1)
      SIZE_MAX  = SIZE_MAX1*2.0

      IF(MOD_D2.EQ.'Y') THEN
        CALL DEF_RAD(M,MOD2,NAMEM2,RESULT,ISYM,IPRSYM,IERR)
        ARADI2 = RESULT(11,1)
        ARADI = (ARADI1 + ARADI2)/2.0
        SIZE_MAX2 = RESULT(1 ,1)
        SIZE_MAX  = SIZE_MAX1 + SIZE_MAX2
      ENDIF

      IF(DLIM_MIN_I.LE.0.0001) THEN
        DLIM_MIN_I= 1.0
        DLIM_MIN  = ARADI*DLIM_MIN_I
      ELSE
        DLIM_MIN  = DLIM_MIN_I
      ENDIF
      IF(DLIM_MAX_I.LE.0.0001) THEN
c        DLIM_MAX_I= 3.0
c        DLIM_MAX  = ARADI*DLIM_MAX_I
        DLIM_MAX  = 1000.0
      ELSE
        DLIM_MAX = DLIM_MAX_I
      ENDIF
      IF(DPAR_MAX  .LE.0.0001) THEN
C       DPAR_MAX  = (2.0*RESMAX)/3.0
        DPAR_MAX  = 1000.0
      ENDIF
      IF(MOD_D2.EQ.'Y') THEN
        WRITE(LINE,'(''Sol_ Radius_giration M1     :'',F8.3)') 
     *   ARADI1
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(''     Radius_max      M1     :'',F8.3)') 
     *  SIZE_MAX1
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(''Sol_ Radius_giration M2     :'',F8.3)') 
     *   ARADI2
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(''     Radius_max      M2     :'',F8.3)') 
     *  SIZE_MAX2
        CALL MSGDOC(MDOC,LINE)
      ELSE
        WRITE(LINE,'(''Sol_ Radius_giration        :'',F8.3)') 
     *   ARADI
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(''     Radius_max             :'',F8.3)') 
     *  SIZE_MAX1
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      WRITE(LINE,'(''Sol_ Chi,Delta              :'',2F8.3)') 
     * CHI_IN,SRF_DELTA
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(''Sol_ Dist_min,max,Dpar_max  :'',3F10.3)') 
     * DLIM_MIN,DLIM_MAX,DPAR_MAX
      CALL MSGDOC(MDOC,LINE)
C -------------------------------------------------------
C
C      COEFF_PATT_P1 - Patterson for Fobs (sp.gr P1) without origin peak
C
C      CALL MSGDOC(MD0,'---  Patterson for Fobs ---')
      ISIM     = 0
C     without origin peak
      LAP      = '0'
      FOMMIN   = 0.0
      MSGA     = 'N'

C      BOFFF    = BOFF_SCL
C      BADDD    = 0.0

      BOFFF    = BOFF
      BADDD    = BADD

      SLIM     = 0.0
      DRMS     = 0.0
      DRMS_A   = 0.0
      DEL_LIM  = 0.0
      DELA_LIM = 0.0
      SCALEF   = 1.0
      NAMES    = ' '
      NAMES1   = ' '

      IF(LH_LH.EQ.'?') THEN
        BOFFF    = BOFF_LH
        BADDD    = BADD_LH
      ENDIF

      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC

      CALL COEF_FFT(MMM,NAMEF,NAMES,NAMES1,COEF_PATT_P1
     *         ,FOMMIN,RESMIN,RESMAX,BOFFF,SLIM
     *         ,DEL_LIM,DELA_LIM,DRMS,DRMS_A,LAP
     *         ,SCALEF,BADDD,MSGA,ISIM,ISYM,IPRSYM,RESULT,IERR)
      IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,
     *  ' ERROR: DYAD: COEF_FFT: Patterson for Fobs')
        GO TO 900
      ENDIF
      F0     = 0
      IZMIN  = 0
      IZMAX  =-1
      NX     = 0
      NY     = 0
      NZ     = 0
C     output for sp.gr. P1
      IERR   = 1
      CALL FFT(M,NX,NY,NZ,IZMIN,IZMAX,F0,COEF_PATT_P1
     * ,NAMEC,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900

C      NAME_SCR = 'molrp_scratch_rft'
C      CALL ADD_PATH(PATH_SCR,NAME_SCR)  

      CALL RFT(M,RESMAX
     * ,NAMEC,FOBS_P1,PHOBS_P1,PATH_SCR,ISYM,IPRSYM,RESULT
     * ,IERR)
      IF(IERR.NE.0) GO TO 900
      ISIM     = 0
      LAP      = '0'
      FOMMIN   = 0.0
      MSGA     = 'N'

      BOFFF    = 0.0
      BADDD    = 0.0

      SLIM     = 0.0
      DRMS     = 0.0
      DRMS_A   = 0.0
      DEL_LIM  = 0.0
      DELA_LIM = 0.0
      SCALEF   = 1.0
      NAMES      = ' '

      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC

      CALL COEF_FFT(MMM,FOBS_P1,NAMES,PHOBS_P1,COEF_PATT_P1
     *         ,FOMMIN,RESMIN,RESMAX,BOFFF,SLIM
     *         ,DEL_LIM,DELA_LIM,DRMS,DRMS_A,LAP
     *         ,SCALEF,BADDD,MSGA,ISIM,ISYM,IPRSYM,RESULT,IERR)
      IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,
     *  ' ERROR: DYAD: COEF_FFT')
        GO TO 900
      ENDIF
C ----------------------------------------
C ---
 300  CONTINUE
      IR_BEST    = 0
      JR_BEST    = 0
      IS_BEST    = 0
      IANG_BEST  = 0
      CORR_BEST  =-1.5
      SCORR_BEST =-1.5
      RFAC_BEST  = 0.0
      SCORE_MAX  =-1.5
      NSCORE     = 0.0
      CORR_FIX_M =-1.5
     
      IF(CORR_TOT.LT.-1.0.AND.DYAD.NE.'D') THEN
C -                 
        CALC2 = 'Y'

        CALL MSGDOC(MDOC,'Sol_ ')
        WRITE(LINE,'(''Sol_--- First monomer search ---'')') 
        CALL MSGDOC(MDOC,LINE)
        CALL MSGDOC(MDOC,'Sol_ ')

        IFIRST_RUN_TF_FOR_PKMAX_FIRST = 0
        PKMAX_FIRST =  1.0
        PKMAX_CORR  =  1.0
        NRUN         = 0
        NRUN_LIM     = NMON + 8
        SCORE_MAX  =-1.5
        NSCORE     = 0.0
        CONTRAST   = 0.0

        LINE =
c     *  'Sol_ RF TF     Tf/sig        sig'//
c     *  '    TFcntrst PKmax  Rfac  Corr Corr_max Cntrst'
     * 'Sol_ RF TF   Tf/sig '//
     * '   TFcntrst PFind PFmax PFmin  wRfac  Scor Scor_max Cntrst'
        CALL MSGDOC(MDOC,LINE)

        IFIRST_SCL = 0
        DO IR=1,NPROT

          ALPHA = TALPHA(IR)
          BETA  = TBETA (IR)
          GAMMA = TGAMMA(IR)
C --
          IERR = 0

          PARM2_TR( 1: 1) = TFUN
          PARM2_TR( 2: 2) = 'N'
          PARM2_TR( 3: 3) = REF
          PARM2_TR( 4: 4) = PACK
          PARM2_TR( 5: 5) = PST
          PARM2_TR( 6: 6) = CALC2
          ANISO_T = ANISO
          PARM2_TR( 7: 7) = ANISO_T
          PARM2_TR( 8: 8) = SURF
          PARM2_TR( 9: 9) = 'N'
          PARM2_TR(10:10) = MOD2
          PARM2_TR(11:11) = INVER  
          PARM2_TR(12:12) = 'N' 
          PARM2_TR(13:13) = FAST  
          PARM2_TR(14:14) = 'N'  
C 15 MODE_T
          PARM2_TR(15:15) = 'C'  
C 16 TEST
          PARM2_TR(16:16) = ' '
C 17 STICK
          PARM2_TR(17:17) = STICK
          PARM2_TR(18:18) = MOD1
          PARM2_TR(19:19) = MOD2
          PARM2_TR(20:20) = LIST
          PARM2_TR(21:21) = 'N'
          PARM2_TR(22:22) = SURFX

          FPAR2_TR( 1) = RESMIN
          FPAR2_TR( 2) = RESMAX
          FPAR2_TR( 3) = ALPHA
          FPAR2_TR( 4) = BETA
          FPAR2_TR( 5) = GAMMA
          FPAR2_TR( 6) = BOFF
          FPAR2_TR( 7) = BOFF
          FPAR2_TR( 8) = BADD
          FPAR2_TR( 9) = BLIM
          FPAR2_TR(10) = 20.0
          FPAR2_TR(11) = 5.0
          FPAR2_TR(12) = BOFF_SCL
          FPAR2_TR(13) = BADD_SCL
          FPAR2_TR(15) = 0.0
          FPAR2_TR(17) = 0.0

          FPAR2_TR(18) = IFIRST_SCL
c         RAD_MODEL 
          FPAR2_TR(19) = 0.0 
 
          NMR = NMR_INP
          DO I=1,3
            SH1(I) = 0.0
          ENDDO
          NAMES     = ' '
          NEL2      = 0
          NC        = 0
          NCP       = 0
          NAMET_OUT = 'trfun'
          CALL ADD_PATH(PATH_SCR,NAMET_OUT)
          NAMED       = ' '
          NAME_FCALC  = ' '
          NAME_PHCALC = ' '
          NCS_ID = 0
          CALL TRFUN(MD,NAMEF,NAMEM,NAMES,NAME2,NAMET_OUT
     *     ,NAMED,NAME_FCALC,NAME_PHCALC,PATH_SCR
     *     ,IR,SH1,NC,NPT,NMR,N_MODEL,NEL2,NCP,NCS_ID
     *     ,ANGLES_NCS_INP,CENTRE_NCS
     *     ,PARM2_TR,FPAR2_TR,SPST,PEAK_TEST
     *     ,ISYM,IPRSYM
     *     ,RESULT,RESULT2,IPRMAX,IPRROW,IERR)
          FAST  = PARM2_TR(13:13)
          CALC2 = PARM2_TR( 6: 6) 
          IFIRST_SCL = FPAR_TR(18)
          RMAX_PK = RESULT(1,14)
          RMIN_PK = RESULT(1,15)
          SIGMA   = RESULT(1,16)
          TF_CONTRAST = RESULT(1,17)
          PACK_INDEX = RESULT(1,21)

          IF(IERR.NE.0) THEN
            IF(IERR.EQ.1) GO TO 900
            RESULT(1,12) = 0
            IPK_TRANS = 0
            WRITE(CH10,'(''Sol'',I4,I3)') IR,IPK_TRANS
            DO J=1,10
              IF(CH10(J:J).EQ.' ') CH10(J:J) = '_'
            ENDDO
            IF(IERR.EQ.10) THEN
              WRITE(LINE,'(A,A)') CH10,
     *        '   ---- all values of Packing Function =< 0 -----'
              CALL MSGDOC(MDOC,LINE)
            ELSE
              WRITE(LINE,'(A,A)') CH10,'     ---------'
              CALL MSGDOC(MDOC,LINE)
            ENDIF
            IERR         = 0
          ENDIF
C -
          IF(MOD2_INI.EQ.'Y') THEN
            CORR_FIX = RESULT(2,21)
            IF(CORR_FIX.GT.CORR_FIX_M) CORR_FIX_M = CORR_FIX
          ENDIF

          NPTRANS   = RESULT(1,12)
          RFAC      = RESULT(1,1)
          T = RESULT(1,2)
          IF(SCORE_FLAG.NE.'C')THEN
            T = (T+1.0)*SQRT(ABS(PACK_INDEX))
            CORR      = T-1.0
          ELSE
            CORR      = T
          ENDIF

        IF(IFIRST_RUN_TF_FOR_PKMAX_FIRST.EQ.0) THEN
        IF(NSYM.LE.1.AND.PACK_INDEX.GE.0.999.AND.
     *                            SCORE_FLAG.NE.'N')THEN
          IF(RMAX_PK.GT.0.0001) THEN
            PKMAX_FIRST = RMAX_PK
            IFIRST_RUN_TF_FOR_PKMAX_FIRST = 1
          ENDIF
        ENDIF 
        ENDIF
        RMAX_PK = RMAX_PK/PKMAX_FIRST

        IF(SCORE_FLAG.NE.'C'.AND.NSYM.GT.1)THEN
          CORR = (CORR*RMAX_PK)/PKMAX_CORR
        ENDIF

          SCORR     = RESULT(1,13)

          IF(NPTRANS.GT.0) THEN

            IPK_TRANS = RESULT(1,9)
            TC_AVER   = RESULT(1,18) 
            TC_AVER2  = RESULT(1,19) 
            NC_NAVER  = RESULT(1,20) 
            CALL DYAD_STORE_SCORE(CORR,NSCORE,SCORE_STOR
     *      ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
     *      ,TC_AVER,TC_AVER2,NC_NAVER
     *      ,SCORE_MAX,NSCORE_MAX)

            IF(CORR.GT.CORR_TOT_MON) THEN
              SCORR_TOT_MON= SCORR
              CORR_TOT_MON = CORR
              RFAC_TOT_MON = RFAC
              IR_TOT_MON   = IR
              IPK_TRANS_BEST = IPK_TRANS
              TF_CONTRAST_BEST = TF_CONTRAST

              TXSH_MON     = RESULT(1,6)
              TYSH_MON     = RESULT(1,7)
              TZSH_MON     = RESULT(1,8)
              CALL LENSTR_BL(NAMET_OUT,LEN)
              IF(LEN.GT.0) THEN
                MODE = 'E'
                ALP  = 0.0
                BET  = 0.0
                GAM  = 0.0
                DO I=1,3
                  SH1(I) = 0.0
                  SH2(I) = 0.0
                  DO J=1,3
                    AM(I,J) = 0.0
                  ENDDO
                ENDDO
                CALL TRANS(M,NAMET_OUT,NAME_MON,SH1,SH2
     *          ,MODE,AM,ALP,BET,GAM,RESULT,ISYM,IPRSYM,IERR)
                IF(IERR.NE.0) GO TO 900
              ENDIF
            ENDIF
            NMON_1 = 0
            NR_SYM_TEMP = 1
            CALL DYAD_CONTRAST(M,NMON_1,NMON,NR_SYM_TEMP,CNTR_NEW
     *                     ,CORR_TOT_MON,CONTRAST,NSCORE
     *                ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
     *                     ,SCORE_STOR,NSCORE_MAX)
            IPK_TRANS = RESULT(1,9)
            WRITE(CH10,'(''Sol'',I4,I3)') IR,IPK_TRANS
            DO J=1,10
              IF(CH10(J:J).EQ.' ') CH10(J:J) = '_'
            ENDDO
            TFSIG     = RESULT(1,5)  

            WRITE(LINE,1300) CH10,TFSIG,TF_CONTRAST
     *      ,PACK_INDEX,RMAX_PK
     *      ,RMIN_PK,RFAC,CORR,CORR_TOT_MON,CONTRAST
 1300       FORMAT(A10,G12.4,F7.3,F7.2,F6.2,F7.2,3F7.3,F7.2)
C1300       FORMAT(A10,G14.4,F10.3,2F8.2,3F7.3,F7.2)
            CALL MSGDOC(MDOC,LINE)

            NP_FIN    = IR
            NRUN = NRUN + 1 
            IF(NRUN.GT.NRUN_LIM.AND.SCORE_FLAG.EQ.'Y'.AND.
     *        CONTRAST.GT.CONTRAST_LIM) THEN
              LINE = 
     *        'INFO: contrast is good enough. Stop this run'
              CALL MSGDOC(MDOC,LINE)
              GO TO 830
            ENDIF

          ENDIF
        ENDDO
 830    CONTINUE
 
        IF(IR_TOT_MON.GT.0) THEN
          CALL MSGDOC(MDOC,'Sol_best')
          ALPHA   = TALPHA(IR_TOT_MON)
          BETA    = TBETA (IR_TOT_MON)
          GAMMA   = TGAMMA(IR_TOT_MON)
          RALPHA  = (ALPHA*PI)/180.0
          RBETA   = (BETA *PI)/180.0
          RGAMMA  = (GAMMA*PI)/180.0
          CALL EULERM(RALPHA,RBETA,RGAMMA,AM)
          CALL MTOPOL(AM,THETA,PHI,CHI)
          LINE = 'Sol_   RF TF  theta    phi     chi'//
     *    '    tx     ty     tz     TFcnt  wRfac   Scor'
          CALL MSGDOC(MDOC,LINE)

          SH1(1) = TXSH_MON
          SH1(2) = TYSH_MON
          SH1(3) = TZSH_MON
          CALL OTOF(SH1,SH2,IERR)   

          WRITE(LINE,
     *    '(''Sol_'',I4,I4,3F8.2,3F7.3,F7.2,2F7.3)')
     *    IR_TOT_MON,IPK_TRANS_BEST
     *    ,THETA,PHI,CHI
     *    ,SH2(1),SH2(2),SH2(3)
     *    ,TF_CONTRAST_BEST,RFAC_TOT_MON,CORR_TOT_MON
          CALL MSGDOC(MDOC,LINE)
C    *    ,TXSH_MON,TYSH_MON,TZSH_MON

          IF(MOD2_INI.EQ.'Y'.AND.CORR_FIX_M.GT.-1.4) THEN
            WRITE(LINE,'(A,F6.3)')'Corr_for_fixed_model:'
     *      ,CORR_FIX_M
            CALL MSGDOC(MDOC,LINE)
            CALL MSGDOC(MDOC,
     * '  will be used if keyword SCORE = Y and > Corr_first_monomer')
          ENDIF

          IF(CORR_TOT_MON.GT.-1.4) THEN

            IF(CORR_FIX_M.GT.CORR_TOT_MON.AND.
     *                                SCORE_FLAG.EQ.'Y') THEN
              CORR_TOT_MON =-2.0
              CORR_TOT = CORR_FIX_M
              WRITE(LINE,'(A)')
     *        'WARNING: Corr_for_fixed_model > Corr_best'
              CALL MSGDOC(MDOC,LINE)

            ELSE

              CALL LENSTR_BL(NAMET_OUT,LEN)
              IF(LEN.LE.0) THEN
                NAMET = NAMET_OUT
                IF(MOD2.NE.'N') NAMET = NAMEC
                MODE   = 'E'
                SH2(1) = TXSH_MON
                SH2(2) = TYSH_MON
                SH2(3) = TZSH_MON 
                ALPHA  = TALPHA(IR_TOT_MON)
                BETA   = TBETA (IR_TOT_MON) 
                GAMMA  = TGAMMA(IR_TOT_MON)
                DO I=1,3
                  SH1(I) = 0.0
                  DO J=1,3
                    AM(I,J) = 0.0
                  ENDDO
                ENDDO
                CALL TRANS(M,NAMEM,NAMET,SH1,SH2
     *          ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
                IF(IERR.NE.0) GO TO 900
                IF(MOD2.EQ.'Y') THEN
C                 + NAME2
                  IERR = NMON 
                  CALL JOINCRD(M,NAME2,NAMET,NAMEO,ISYM,IPRSYM,IERR)
                  IF(IERR.NE.0) GO TO 900
                ENDIF
              ENDIF
              CORR_TOT = CORR_TOT_MON
              NMON_1 = 0
              NR_SYM_TEMP = 1
              CALL DYAD_CONTRAST(MDOC,NMON_1,NMON,NR_SYM_TEMP,CNTR_NEW
     *             ,CORR_TOT,CONTRAST,NSCORE
     *             ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
     *             ,SCORE_STOR,NSCORE_MAX)
              CONTRAST_BEST = CONTRAST
              CALL MSGDOC(MDOC,'Sol_best')

            ENDIF

          ELSE

            IF(MOD2_INI.EQ.'Y'.AND.CORR_FIX_M.GT.-1.4.AND.
     *                                SCORE_FLAG.EQ.'Y') THEN
              CORR_TOT_MON =-2.0
              CORR_TOT = CORR_FIX_M
            ENDIF
          ENDIF

        ELSE
          CALL MSGDOC(MDOC,'Sol_ WARNING: no solution was found')
          IERR = 1
C --XML--
          IERR_XML     = 2
          MESSAGE_XML  = 'no solution was found'
          CONTRAST_XML = 0.0
          NSOL_XML     = 0
          GO TO 900
        ENDIF
      ENDIF

      IF(MOD2.EQ.'Y') THEN
c        CALL MSGDOC(MD0,'--- read second model ---')
        AL  = 0.0
        BE  = 0.0
        GA  = 0.0
        NMR = 0
        SCALEP = 0.0
        BOVER  = 0.0
        H2OBG  = 0.0
        PST_T  = 'N'
        IMOD   = 2
        CALL TRF_PRECALC_MOD(M,LIST,MOD2,IMOD
     *  ,NAMEF,NAMEO,NAMEC1,NAMEFMO,NAMEPHO,NAMEFMO_PK,NAMEPHO_PK
     *  ,NAMEFMO_N,PATH_SCR,AL,BE,GA,PACK,ANISO,SURFX,PST_T
     *  ,SPST,RESMIN,RESMAX,BOFF,BOFF_SCL,BADD,BADD_SCL,TEST
     *  ,NEL3,NUM_MON,BLIM,NMR,SCALEP,BOVER,H2OBG
     *  ,ISYM,IPRSYM
     *  ,RESULT,RESULTA,IPRMAX,IPRROW,IERR)
C ----------------------------------------------------------------
C 1) if MOD1=D DENS2F_DNS else DENS2F_NEW
C 2) if ANISO = K - FSCALE with SCALEP,BOVER
C                   if scale = 0 - scaling by Fobs (cell must be the same)
C                                  only scale , set BOVER = 0
C                   if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                  no info: rfac, corr
C     else  ANISOSCL
C           if ANISO = Y - pre-isoscaling by Patterson and aniso scaling
C           else  only isoscaling by Patterson
C
C     output NAMEFM2,NAMEPH and SCALEP,BOVER 
C            NAMEFM_PK,NAMEPH_PK (if PACK # N )
C
C ----------------------------------------------------------------
        IF(IERR.NE.0) GO TO 900
      ENDIF
c      CORR_CURR = -1.5
C ----------------------------------------
      NR_SYM = NSYM
      IF(ISYM_DYAD.GT.0) NR_SYM = 1 

      ITIME_START = 1
      NRUN_TIME = 0
      CALL EXPECTED_TIME(ITIME_START,NRUN_TIME
     *  ,ITIME_CURR,TIME_CURRENT,TIME_ELAPSED,TIME_EXPECTED)
      WRITE(LINE,*) 'Time:',TIME_CURRENT,' Elapsed:',TIME_ELAPSED
      CALL MSGDOC(MDOC,LINE)
      TIME_ELAPSED_XML  = TIME_ELAPSED
      CALL WRITE_XML_FILE(IERR,PATH_OUT)

      CALL MSGDOC(MDOC,'Sol_ ')
      CALL MSGDOC(MDOC,'Sol_---  Dyad Search ---')
      CALL MSGDOC(MDOC,'Sol_ ')

C      CALL MSGDOC(MDOC,'Sol_')
C      LINE = 
C     *  'Sol_  R1  R2 Rsym Rslf STF TF '//
C     *  ' PK12 PKmax  PKmin    Rfac Corr Corr_max Cntrst'
C      CALL MSGDOC(MDOC,LINE)

      IDYAD_FIRST = 0
      IFIRST_RUN_TF_FOR_PKMAX_FIRST = 0
      PKMAX_FIRST =  1.0
      PKMAX_CORR  =  1.0

      IF(NPROT.LT.NPROT2) THEN
        ICHANGE = 1
        NNPROT  = NPROT2
        NNPROT2 = NPROT
      ELSE
        ICHANGE = 0
        NNPROT  = NPROT
        NNPROT2 = NPROT2
      ENDIF
      IFIRST1      = 0
      IFIRST1_SCL  = 0
      IFIRST2_SCL  = 0
      IFIRST12_SCL = 0
      IFIRST_CORR_FIX = 0

      NRUN         = 0
      IF(MOD_D2.EQ.'N')  THEN
        NNN1 = (NUM_MON*(NUM_MON-1))/2 
        NNN2 = (NMON*(NMON-1))/2 
        NRUN_LIM = (NNN2 + 8)*NR_SYM
      ELSE
        NNN1 = (NUM_MON*NUM_MON)/4
        NNN2 = (NMON*NMON)/4
        NRUN_LIM = (NNN2 + 8)*NR_SYM*NR_SYM
      ENDIF
      NR_SYM_SCORE = NR_SYM

C      write(*,*)'-nmon,num_mon,nsm:',NMON,NUM_MOn,nr_sym
C      write(*,*)'-n1,n2,nlm:',NNN1,NNN2,NRUN_LIM

      IT2 = (NMON - NUM_MON)/2 
      IT1 =  NNPROT*NPROT2
      IF(MOD_D2.EQ.'N')  THEN
        IT1 = (NNPROT*(NPROT2+1))/2
      ENDIF
      NRUN_TIME_TOT = IT2*IT1*NR_SYM
      IRUN_TIME = 0

      SCALEP1  = 0.0
      BOVER1   = 0.0
      SCALEP2  = 0.0
      BOVER2   = 0.0
      SCALEP12 = 0.0
      BOVER12  = 0.0
      ANISO_T1 = ANISO
      ANISO_T2 = ANISO
      ANISO_T12= ANISO
      SCORE_MAX  =-1.5
      NSCORE     = 0.0
      CORR_FIX_M =-1.5

      DO IIR=1,NNPROT
        JJR = IIR
        IF(JJR.GT.NNPROT2) JJR = NNPROT2

        DO IIR2=1,IIR
        DO JJR2=1,JJR

          IF(IIR2.EQ.IIR.OR.
     *       (JJR2.EQ.IIR.AND.IIR2.NE.IIR.AND.
     *        IIR.LE.NNPROT2.AND.MOD_D2.EQ.'Y')) THEN 

            IF(ICHANGE.EQ.0) THEN
              IR = IIR2
              JR = JJR2
            ELSE
              IR = JJR2
              JR = IIR2
            ENDIF
c ----------------
          IF(LIST.EQ.'T') THEN
            WRITE(LINE,
     *    '(''--- read and rotate of model-1 IR1:'',I4,'' ---'')') IR     
            CALL MSGDOC(MDOC,LINE)
          ENDIF

          ALPHA1 = TALPHA(IR)
          BETA1  = TBETA (IR)
          GAMMA1 = TGAMMA(IR)

C        WRITE(LINE,'('' Rotation angles-1 :'',3F8.2)') 
C     *  ALPHA1,BETA1,GAMMA1
C        CALL MSGDOC(MDOC,LINE)

        NR_SYM_CALC = 0

        DO IS=1,NR_SYM

          MTN   = 10
          ITYPE = 'FF  '
          CALL ORFILE(M,MTN,NAMEF,ITYPE,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,' ERROR: OPEN INPUT-FILE-FOBS (in TRFUN)')
            RETURN
          ENDIF
          CLOSE(MTN)

          ALPHA2 = TALPHA2(JR)
          BETA2  = TBETA2 (JR)
          GAMMA2 = TGAMMA2(JR)

          ISS = IS
          MMM = M
          IF(LIST.EQ.'T') MMM = MDOC
          CALL TRF_CHANGE_ANGLE(MMM,ISS,ALPHA2,BETA2,GAMMA2
     *                         ,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900          
          IF(ISS.EQ.0) GO TO 100
          NR_SYM_CALC = NR_SYM_CALC + 1

          CALL TRF_CHECK_ANGLE(MMM,THETA12,PHI12,CHI12
     *    ,NP_SRF,SRF_THETA,SRF_PHI,SRF_CHI,SRF_DELTA
     *    ,ALPHA1,BETA1,GAMMA1,ALPHA2,BETA2,GAMMA2,CHI_IN,IANG
     *    ,NSYM,ISYM,IPRSYM)
          IF(IANG.EQ.0) GO TO 100          

          IF(LIST.EQ.'T') THEN
            WRITE(LINE,
     *'(''--- read and rotate of model-2 IR2'',I3,'' Is'',I3,''(IR1''
     *,I3,'' Isrf'',I3,'')---'')')    JR,IS,IR,IANG     
            CALL MSGDOC(MDOC,LINE)
          ENDIF

C          SCALEP = 1.0
C          BOVER  = 0.0
          H2OBG  = 0.0
          IF(IFIRST1.EQ.0) THEN
            MMM = M
            IF(LIST.EQ.'T') THEN
              MMM = MDOC
              WRITE(LINE,'('' Rotation angles-1 :'',3F8.2)') 
     *        ALPHA1,BETA1,GAMMA1
              CALL MSGDOC(MMM,LINE)
            ENDIF
c ok     ierr=1
c      go to 900
            IMOD = 1
            CALL TRF_PRECALC_MOD(MMM,LIST,MOD1,IMOD
     *      ,NAMEF,NAMEM,NAMEC1,NAMEFM,NAMEPH,NAMEFM_PK,NAMEPH_PK
     *      ,NAMEFM_N,PATH_SCR,ALPHA1,BETA1,GAMMA1,PACK
     *      ,ANISO_T1,SURF,PST
     *      ,SPST,RESMIN,RESMAX,BOFF,BOFF_SCL,BADD,BADD_SCL,TEST
     *      ,NEL1,NUM_MON,BLIM,NMR,SCALEP1,BOVER1,H2OBG
     *      ,ISYM,IPRSYM
     *      ,RESULT,RESULTA,IPRMAX,IPRROW,IERR)
C ----------------------------------------------------------------
C 1) if MOD1=D DENS2F_DNS else DENS2F_NEW
C 2) if ANISO = K - FSCALE with SCALEP,BOVER
C                   if scale = 0 - scaling by Fobs (cell must be the same)
C                                  only scale , set BOVER = 0
C                   if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                  no info: rfac, corr
C     else  ANISOSCL
C           if ANISO = Y - pre-isoscaling by Patterson and aniso scaling
C           else  only isoscaling by Patterson
C
C     output NAMEFM2,NAMEPH and SCALEP,BOVER 
C            NAMEFM_PK,NAMEPH_PK (if PACK # N )
C
C ----------------------------------------------------------------
            IF(IERR.NE.0) GO TO 900         
            PACK_INDEX1 = RESULT(1,1) 
            NDENSP1 = RESULT(2,1) 
            NZERO1  = RESULT(3,1) 
            NDENSM1 = RESULT(4,1) 
            NTOT1   = RESULT(5,1) 
  
c           WRITE(*,*)'1=PI,NP,N0,NM:',PACK_INDEX,NDENSP,NZERO,NDENSM 

            WRITE(LINE,'('' scale1,B_scale1 :'',2F8.3)') 
     *      SCALEP1,BOVER1       
            CALL MSGDOC(MD,LINE)
            IF(IFIRST1_SCL.EQ.0) THEN
              ANISO_T1 = 'K'
              IFIRST1_SCL = 1
            ENDIF

C            VERSION WITH ICHAGE
C            IFIRST1 = 1

          ENDIF
C -
c          WRITE(LINE,'(''    Rotation angles-2 :'',3F8.2)') 
c     *    ALPHA2,BETA2,GAMMA2
C          CALL MSGDOC(MD0,LINE)

          NPK_TFSUM  = 0

C          IFIRST_SCL = 0
C          SCALEP     = 0.0
C          BOVER      = 0.0
C          ANISO_T    = ANISO

          H2OBG = 0.0
C --
          MMM = M
c          IF(LIST.EQ.'T') THEN
c            MMM = MDOC
c            WRITE(LINE,'(''    Rotation angles-2 :'',3F8.2)') 
c     *      ALPHA2,BETA2,GAMMA2
c            CALL MSGDOC(MMM,LINE)
c          ENDIF

C                                      MOD2S
          IMOD = 1
          CALL TRF_PRECALC_MOD(MMM,LIST,MOD1,IMOD
     *    ,NAMEF,NAMEM2,NAMEC2,NAMEFM2,NAMEPH2,NAMEFM2_PK,NAMEPH2_PK
     *    ,NAMEFM2_N,PATH_SCR,ALPHA2,BETA2,GAMMA2,PACK
     *    ,ANISO_T2,SURF,PST
     *    ,SPST,RESMIN,RESMAX,BOFF,BOFF_SCL,BADD,BADD_SCL,TEST
     *    ,NEL2,NUM_MON,BLIM,NMR,SCALEP2,BOVER2,H2OBG
     *    ,ISYM,IPRSYM
     *    ,RESULT,RESULTA,IPRMAX,IPRROW,IERR)
C ----------------------------------------------------------------
C 1) if MOD1=D DENS2F_DNS else DENS2F_NEW
C 2) if ANISO = K - FSCALE with SCALEP,BOVER
C                   if scale = 0 - scaling by Fobs (cell must be the same)
C                                  only scale , set BOVER = 0
C                   if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                  no info: rfac, corr
C     else  ANISOSCL
C           if ANISO = Y - pre-isoscaling by Patterson and aniso scaling
C           else  only isoscaling by Patterson
C
C     output NAMEFM2,NAMEPH and SCALEP,BOVER 
C            NAMEFM_PK,NAMEPH_PK (if PACK # N )
C
C ----------------------------------------------------------------
          IF(IERR.NE.0) GO TO 900
          PACK_INDEX2 = RESULT(1,1) 
          NDENSP2 = RESULT(2,1) 
          NZERO2  = RESULT(3,1) 
          NDENSM2 = RESULT(4,1) 
          NTOT2   = RESULT(5,1) 
  
c          WRITE(*,*)'2=PI,NP,N0,NM:',PACK_INDEX,NDENSP,NZERO,NDENSM 

          WRITE(LINE,'('' scale2,B_scale2 :'',2F8.3)') 
     *    SCALEP2,BOVER2
          CALL MSGDOC(MD,LINE)
          IF(IFIRST2_SCL.EQ.0) THEN
            ANISO_T2 = 'K'
            IFIRST2_SCL = 1
          ENDIF
C -----------
C           SFVSUM   sum two vectors of structure factors: (F1 + scale*F2)
C            or convolution: F1(h)*scale*F2(-h)
C            
C           CALL MSGDOC(MD0,'--- sfvsum ---')

          MODE  = 'C'
          SCALE = 1.0
          INVER = 'N'
          DO I=1,3
            SH1(I) = 0.0
          ENDDO
          MMM = M
          IF(LIST.EQ.'T') THEN
            MMM = MDOC
            CALL MSGDOC(MMM,'--- sfvsum ---')
          ENDIF
           CALL SFVSUM(MMM,MODE,SCALE,INVER
     *    ,NAMEFM,NAMEPH,NAMEFM2,NAMEPH2,NAMEFMC,NAMEPHC 
     *    ,SH1,BOFF,BADD,RESMIN,RESMAX,ISYM,IPRSYM,RESULT,IPRROW,IERR)
          IF(IERR.NE.0) GO TO 900
C ---

          MODE_D = 'D'
          NAMES  = ' '
          NAMES1 = ' '

          BOFFF  = 0.0
          FUNP   = 'Y'    
          IF(PACK.EQ.'N') FUNP   = 'N'

C         FUNP   = 'N'    

          NAMEDD = ' '
          NAMES4 = ' '
          MMM = M

          IF(LIST.EQ.'T') THEN
            MMM = MDOC
            CALL MSGDOC(MMM,'--- TRF_PACK_TRANS ---')
          ENDIF

          LH = LH_LH
          LH_LH = 'N'
C          IF(LH_LH.NE.'N') NAME_TR = FILE_FOBS_LH

          MEM_SCR = NTOT_SCR*11 + 1000

          IF(LIST.EQ.'T') THEN
            write(*,*) '--MEM_SCR,NTOT_SCR:', MEM_SCR,NTOT_SCR
          ENDIF

          allocate(POOL_SCR(1:MEM_SCR),STAT=ISTAT)
          IF(ISTAT.NE.0) THEN
            IERR = 1
            CALL MSGERR(MDOC,
     *      ' ERROR: in TRF_DIMER: problem with memory allocation')
            CALL MSGERR(MDOC,
     *      '                  try to change resolution')
            GO TO 900
          ENDIF

          CALL TRF_PACK_TRANS(MMM,LIST
     *    ,COEF_PATT_P1,FOBS_P1,NAMEFMC,NAMEPHC,NAMEFM_PK,NAMEPH_PK
     *    ,NAMES,NAMES1,NAMEFM2_PK,NAMEPH2_PK,NAMEDD,NAMES4
     *    ,NEL1,NEL2,MODE_D,FUNP,INVER,TFUN,PST,SPST
     *    ,RESMIN,RESMAX,BOFFF,BADD,RMAX_PK,RMIN_PK
     *    ,POOL_SCR,MEM_SCR
     *    ,ISYM,IPRSYM
     *    ,RESULT,IPRMAX,IPRROW,IERR)
          deallocate(POOL_SCR,STAT=ISTAT)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,
     *      ' ERROR: in TRF_DIMER: subroutine TRF_PACK_TRANS')
            GO TO 900
          ENDIF
          LH_LH = LH

          NPK_TF = RESULT(1,12)
C ---
          NPEAKS = RESULT(1,12)

          IF(NPEAKS.LE.0) THEN
            CALL MSGERR(MDOC,
     *' ERROR: number of peaks of special translation function = 0')
            IERR=1
            GO TO 900 
          ENDIF
C ----         
          CALL STF_CHECK_PEAK(MDOC,MOD_D2,IR,JR,ISS,RESMAX
     *                ,RESULT,IPRMAX,IPRROW
     *                ,NSYM,ISYM,IPRSYM,IERR)
          NPEAKS = RESULT(1,12)
C ----         
          NPTEST = NPT_DM
          IF(NPT_DM.GT.NPEAKS) NPTEST = NPEAKS
          DIST_MIN = 1.0 E30
          IPT_MIN  = 0
            WRITE(LINE,
     *      '('' Packing Function:   '',F6.2,F6.2)') 
     *      RMAX_PK,RMIN_PK
            CALL MSGDOC(M,LINE)
C --
          IF(LIST.EQ.'L'.OR.LIST.EQ.'T') THEN
            NNN = NPTEST
            IF(LIST.EQ.'T') NNN = NPEAKS 
            MMM = MD
            IF(LIST.EQ.'T') MMM = MDOC

            WRITE(LINE,
     *      '('' Packing Function:   '',F6.2,F6.2)') 
     *      RMAX_PK,RMIN_PK
            CALL MSGDOC(MMM,LINE)

            CALL MSGDOC(MMM,
     *      ' --- peaks of Special-Translation Function ---')
            LINE =
     *      'Sol_STF              vector 1->2 '
     *      //'          f'//'    f/sigma'
            CALL MSGDOC(MMM,LINE)

            DO IPT=1,NNN
              WRITE(LINE,'(''Sol_STF'',I3,1X,3F8.3,G14.4,F6.2)')
     *        IPT,RESULT(IPT,9),RESULT(IPT,10),RESULT(IPT,11)
     *       ,RESULT(IPT,4),RESULT(IPT,5)
              CALL MSGDOC(MMM,LINE)
            ENDDO
          ENDIF
C --
          IFIRST12_SCL = 0
          SCALEP12     = 0.0
          BOVER12      = 0.0
          ANISO_T12    = ANISO
          CORR_CURR    = -2.0
          SCORR_CURR   = -2.0
          IPACK        = 0
          IDIST        = 0

          DO IPT=1,NPTEST

            MMM = M
            IF(LIST.EQ.'T') MMM = MDOC
      
            CALL TRF_CHECK_DIST(MMM,NPTEST,IPT,RESULT,IPRMAX,IPRROW
     *                ,ALPHA1,BETA1,GAMMA1,ALPHA2,BETA2,GAMMA2,SH12
     *                ,DLIM_MIN,DLIM_MAX,DPAR_MAX
     *                ,ARADI,CHI_IN,IPT_MIN,DIST_MIN,DORT,DPAR)
            IF(IPT_MIN.EQ.0) THEN
              IDIST = 1
              GO TO 200
            ENDIF
            NMR   = 0
            H2OBG = 0.0
C           NAMES = NAMEC12
            NAMES = ' '

            MMM = M
            IF(LIST.EQ.'T') THEN
              MMM = MDOC
              CALL MSGDOC(MMM,'-- TRF_PRECALC_MOD2 ---')
            ENDIF

            CALL TRF_PRECALC_MOD12(MMM
     *      ,NAMEF,NAMEM,NAMEM2,NAMEC12
     *      ,NAMEFM_N,NAMEPH,NAMEFM_PK,NAMEPH_PK
     *      ,NAMEFM2_N,NAMEPH2,NAMEFM2_PK,NAMEPH2_PK
     *      ,NAMEFM12,NAMEPH12,NAMEFM12_PK,NAMEPH12_PK
     *      ,PATH_SCR,SH12,LIST,PST
     *      ,ALPHA1,BETA1,GAMMA1,ALPHA2,BETA2,GAMMA2
     *      ,PACK,ANISO_T12,SURF
     *      ,RESMIN,RESMAX,BOFF,BOFF_SCL,BADD,BADD_SCL
     *      ,NEL,NUM_MON,BLIM,NMR,SCALEP12,BOVER12,H2OBG
     *      ,ISYM,IPRSYM
     *      ,RESULT2,RESULTA,IPRMAX,IPRROW,IERR)

C            CALL TRF_PRECALC_MOD2(MMM
C     *      ,NAMEF,NAMEM,NAMEM2,NAMES
C     *      ,NAMEFM_N,NAMEPH,NAMEFM_PK,NAMEPH_PK
C     *      ,NAMEFM2_N,NAMEPH2,NAMEFM2_PK,NAMEPH2_PK
C     *      ,NAMEFM12,NAMEPH12,NAMEFM12_PK,NAMEPH12_PK
C     *      ,PATH_SCR,SH12,LIST
C     *      ,ALPHA1,BETA1,GAMMA1,ALPHA2,BETA2,GAMMA2
C     *      ,PACK,ANISO_T12,SURF
C     *      ,RESMIN,RESMAX,BOFF,BOFF_SCL,BADD,BADD_SCL
C     *      ,NEL,NUM_MON,BLIM,NMR,SCALEP12,BOVER12,H2OBG
C     *      ,ISYM,IPRSYM
C     *      ,RESULT2,RESULTA,IPRMAX,IPRROW,IERR)
C ----------------------------------------------------------------
C 1) NAMEM + NAMEC = NAMEC12      
C 2) SFVSUM  and  SFVSUM for paking functon (PACK # N)
C 3) if ANISO = K - FSCALE with SCALEP,BOVER
C                   if scale = 0 - scaling by Fobs (cell must be the same)
C                                  only scale , set BOVER = 0
C                   if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                  no info: rfac, corr
C     else  ANISOSCL
C           if ANISO = Y - pre-isoscaling by Patterson and aniso scaling
C           else  only isoscaling by Patterson
C
C     output NAMEFM12,NAMEPH12 and SCALEP,BOVER 
C            NAMEFM12_PK,NAMEPH12_PK(if PACK # N )
C ----------------------------------------------------------------
            IF(IERR.NE.0) GO TO 900
            PACK_INDEX = RESULT2(1,1) 
            NDENSP = RESULT2(2,1) 
            NZERO  = RESULT2(3,1) 
            NDENSM = RESULT2(4,1) 
            NTOT   = RESULT2(5,1) 
  
C      WRITE(*,*)'1 =PI,NP,N0,NM:',PACK_INDEX1,NDENSP1,NZERO1,NDENSM1 
C     * ,NTOT1
C      WRITE(*,*)'2 =PI,NP,N0,NM:',PACK_INDEX2,NDENSP2,NZERO2,NDENSM2 
C     * ,NTOT2
C      WRITE(*,*)'12=PI,NP,N0,NM:',PACK_INDEX,NDENSP,NZERO,NDENSM 
C     * ,NTOT

            
            PACK_INDEX12 = 1.0
            T1  = FLOAT(NDENSP1+NDENSM1)
            T2  = FLOAT(NDENSP2+NDENSM2)
            T12 = FLOAT(NDENSP+NDENSM)
            T   = T1 + T2 - T12
            IF(T.LT.0.0) T = 0.0
            IF(T12.GT.0.0001) THEN
              PACK_INDEX12 = T/T12
              PACK_INDEX12 = 1.0 - PACK_INDEX12
            ENDIF
            PACK_INDEX = PACK_INDEX12*PACK_INDEX

C      WRITE(*,*)'=P12,PNEW,T,T12:',PACK_INDEX12,PACK_INDEX,T,T12 

            NEL = NEL1 + NEL2

            WRITE(LINE,'('' scale12,B_scale12 :'',2F8.3)') 
     *      SCALEP12,BOVER12
            CALL MSGDOC(MD,LINE)
            IF(IFIRST12_SCL.EQ.0) THEN
              ANISO_T12 = 'K'
              IFIRST12_SCL = 1
            ENDIF
C
C              ENDIF
C            ENDIF

            SCALEP_STORE = SCALEP12
            BOVER_STORE  = BOVER12

            MODE_D = ' '
            NAMES  = ' '
            NAMES1 = ' '
            NAMES2 = ' '
            NAMES3 = ' '
            NEL2   = 0.0

            IF(MOD2.EQ.'Y') THEN
              NAMES  = NAMEFMO
              NAMES1 = NAMEPHO
              NAMES2 = NAMEFMO_PK
              NAMES3 = NAMEPHO_PK
              NEL2   = NEL3
            ENDIF

            BOFFF = BOFF

            IF(NSYM.EQ.1) THEN
              IF(MOD2.EQ.'N') THEN
                IERR = 1              
              ENDIF
            ENDIF
    
            FUNP = PACK
            NAMES4 = ' '
            NAMEDD = ' '
            MMM = M
            IF(LIST.EQ.'T') THEN
              MMM = MDOC
              CALL MSGDOC(MMM,'-- TRF_PACK_TRANS ---')
            ENDIF

            NAME_TR = NAMEF
            IF(LH_LH.NE.'N') NAME_TR = FILE_FOBS_LH

c            NAMEFM12_pk = 'f_pk'
c            NAMEPH12_PK = 'ph_pk'

            IF(MOD2.NE.'N') THEN
              MEM_SCR = NTOT_SCR*11 + 1000
            ELSE
              MEM_SCR = NTOT_SCR*9 + 1000
            ENDIF
            allocate(POOL_SCR(1:MEM_SCR),STAT=ISTAT)
            IF(ISTAT.NE.0) THEN
              IERR = 1
              CALL MSGERR(MDOC,
     *        ' ERROR: in TRF_DIMER: problem with memory allocation')
              CALL MSGERR(MDOC,
     *        '                  try to change resolution')
              GO TO 900
            ENDIF

            CALL TRF_PACK_TRANS(MMM,LIST
     *       ,NAME_TR,NAMEF,NAMEFM12,NAMEPH12
     *       ,NAMEFM12_PK,NAMEPH12_PK
     *       ,NAMES,NAMES1,NAMES2,NAMES3,NAMEDD,NAMES4
     *       ,NEL,NEL2,MODE_D,FUNP,INVER,TFUN,PST,SPST
     *       ,RESMIN,RESMAX,BOFFF,BADD,RMAX_PK,RMIN_PK
     *       ,POOL_SCR,MEM_SCR
     *       ,ISYM,IPRSYM
     *       ,RESULT2,IPRMAX,IPRROW,IERR)

            IF(IERR.EQ.1) THEN
              deallocate(POOL_SCR,STAT=ISTAT)
              GO TO 900
            ENDIF
            IF(IERR.EQ.10) IPACK = 1
            IERR = 0
            NPK = RESULT2(1,12)

            IF(NPK.LE.0) THEN
              deallocate(POOL_SCR,STAT=ISTAT)
              IERR=0
              GO TO 200 
            ENDIF

            IF(RMAX_PK   .GT.1.0) RMAX_PK    = 1.0
            IF(RMIN_PK   .GT.1.0) RMIN_PK    = 1.0
            IF(PACK_INDEX.GT.1.0) PACK_INDEX = 1.0

            IF(ABS(RESULT2(1,5)).GT.0.000001) THEN
              SIGMA = RESULT2(1,4)/RESULT2(1,5)
              WRITE(LINE,'('' Sigma :'',G16.4)') SIGMA
              CALL MSGDOC(MMM,LINE)
              IF(IDYAD_FIRST.EQ.0) THEN
                SIGMA_STORE = SIGMA
                IDYAD_FIRST = 1
              ELSE
                NNN = RESULT2(1,12) 
                IF(NNN.GT.0.AND.SIGMA_STORE.GT.0.00001) THEN
                  DO I=1,NNN
                    RESULT2(I,5) = (RESULT2(I,5)*SIGMA)/SIGMA_STORE
                  ENDDO
                ENDIF
              ENDIF
            ENDIF

 400        CONTINUE

            IF(NPT.LT.NPK) NPK = NPT
            IPT_MIN = 1

            MMM     = M
            IF(LIST.EQ.'L') MMM = MD
            IF(LIST.EQ.'T') MMM = MDOC

            NAMES   = ' '
            NAMES1  = ' '
            IF(MOD2.EQ.'Y') NAMES = NAMEO
            TEST_T  = ' '
            IPK_RF  = IR 

            NAMES4 = ' '
            NAMET  = ' '       

            IF(LIST.EQ.'T') THEN
              MMM = MDOC
              CALL MSGDOC(MMM,'-- TR_TEST_2 ---')
            ENDIF

            NAME_FCALC  = ' '
            NAME_PHCALC = ' '

            SCALE = SCALEP_STORE
            BOVER = BOVER_STORE
            ANISO_T = 'K'

            DO I=1,IPRMAX
              RESULT2(I,1)  =  0.0
            ENDDO

            CALL TR_TEST_2(MMM,LIST
     *      ,MODE_D,NAMEC12,NAMES,NAMES4,NAMET
     *      ,NAMEF,NAME_FCALC,NAME_PHCALC,PATH_SCR
     *      ,NPK,NUM_MON,PST,SPST
     *      ,RMAX_PK,RMIN_PK,SIGMA
     *      ,BOFF_SCL,BADD_SCL
     *      ,RESMIN,ANISO_T,SCALE,BOVER
     *      ,IPK_RF,ALPHA1,BETA1,GAMMA1,TEST_T,PEAK_TEST,IPT_MIN
     *      ,POOL_SCR,MEM_SCR
     *      ,RESULT2,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)

            deallocate(POOL_SCR,STAT=ISTAT)

C             NAME_output  ='trfun'   model + model_2
            IF(IERR.NE.0) GO TO 900

            CORR_FIX = RESULT2(2,21)
            IF(MOD2_INI.EQ.'Y'.AND.CORR_FIX.GT.-1.4.AND.
     *           IFIRST_CORR_FIX.LE.0.AND.DYAD.EQ.'D'.AND.
     *                                   SCORE_FLAG.EQ.'Y') THEN
              CORR_FIX_M = CORR_FIX
              CORR_BEST  = CORR_FIX_M
              IFIRST_CORR_FIX = IFIRST_CORR_FIX + 1
            ENDIF
            RFAC   = RESULT2(1,1)  
            T = RESULT2(1,2)
            IF(SCORE_FLAG.NE.'C')THEN
              T = (T+1.0)*SQRT(ABS(PACK_INDEX))
              CORR   = T-1.0
            ELSE
              CORR   = T
            ENDIF

        IF(IFIRST_RUN_TF_FOR_PKMAX_FIRST.EQ.0) THEN
        IF(NSYM.LE.1.AND.PACK_INDEX.GE.0.999.AND.
     *                            SCORE_FLAG.NE.'N')THEN
          IF(RMAX_PK.GT.0.0001) THEN
            PKMAX_FIRST = RMAX_PK
            IFIRST_RUN_TF_FOR_PKMAX_FIRST = 1
          ENDIF
        ENDIF 
        ENDIF

        RMAX_PK = RMAX_PK/PKMAX_FIRST

        IF(SCORE_FLAG.NE.'C')THEN
          CORR = (CORR*RMAX_PK)/PKMAX_CORR
        ENDIF


c           SCORR  = RESULT2(1,13)  
            SCORR  = CORR  
            SH2(1) = RESULT2(1,6)
            SH2(2) = RESULT2(1,7)
            SH2(3) = RESULT2(1,8)
            JPT    = RESULT2(1,9)
            TF_CONTRAST = RESULT2(1,17)
            TC_AVER   = RESULT2(1,18) 
            TC_ AVER2 = RESULT2(1,19) 
            NC_NAVER  = RESULT2(1,20) 

            IF(TEST_SRF.NE.'Y') IANG = 0

C            WRITE(LINE,'(''Sol_1_2_Is2'',4I3,3F8.2,3F8.2)') 
C     *         IR,JR,IS,IANG,ALPHA1,BETA1,GAMMA1,ALPHA2,BETA2,GAMMA2
C            CALL MSGDOC(MDOC,LINE)

            CALL OTOF(SH12,SH12F,IERR)   

C            WRITE(LINE,'(''Sol_1->2'',3F8.2,3F7.3,'' dop'',3F6.1)')
C     *         THETA12,PHI12,CHI12,SH12F(1),SH12F(2),SH12F(3)
C     *        ,DIST_MIN,DORT,DPAR
C            CALL MSGDOC(MD,LINE)

            CALL OTOF(SH2,SH1,IERR)   

C            WRITE(CH2,'(I2)') IPT
C            IF(CH2(1:1).EQ.' ') CH2(1:1) = '_' 
C            WRITE(LINE,1000)
C     *        CH2,JPT,IR,JR,IS,IANG,SH1(1),SH1(2),SH1(3),RFAC,CORR
C 1000       FORMAT('Sol_TF',A2,1X,I2,1X,'R1',I3,' R2',I3,' Is',I3,' SR'
C     *                ,I3,1X,'SH1',3F6.3,1X,'Rf',F7.3,' Cc',F7.3)
C            CALL MSGDOC(MD,LINE)
 
            IF(CORR.GT.CORR_CURR) THEN
              SCORR_CURR    = SCORR
              CORR_CURR     = CORR
              RFAC_CURR     = RFAC
              IR_CURR       = IR
              JR_CURR       = JR
              IS_CURR       = IS
              IANG_CURR     = IANG
              JPT_CURR      = JPT
              IPT_CURR      = IPT
              RMAX_PK_CURR  = RMAX_PK
              RMIN_PK_CURR  = RMIN_PK
              THETA12_CURR  = THETA12
              PHI12_CURR    = PHI12
              CHI12_CURR    = CHI12
              DIST_MIN_CURR = DIST_MIN
              DORT_CURR     = DORT
              DPAR_CURR     = DPAR
              SH12F_CURR(1) = SH12F(1)
              SH12F_CURR(2) = SH12F(2)
              SH12F_CURR(3) = SH12F(3)
              SH1_CURR(1)   = SH1(1)
              SH1_CURR(2)   = SH1(2)
              SH1_CURR(3)   = SH1(3)
              TF_CONTRAST_CURR = TF_CONTRAST
              PACK_INDEX12_CURR = PACK_INDEX12
              TC_AVER_CURR   = TC_AVER 
              TC_ AVER2_CURR = TC_ AVER2
              NC_NAVER_CURR  = NC_NAVER
           
            ENDIF
           
            IF(CORR.GT.CORR_BEST) THEN
              SCORR_BEST    = SCORR
              CORR_BEST     = CORR
              RFAC_BEST     = RFAC
              IR_BEST       = IR
              JR_BEST       = JR
              IS_BEST       = IS
              IANG_BEST     = IANG
              JPT_BEST      = JPT
              IPT_BEST      = IPT
              RMAX_PK_BEST  = RMAX_PK
              RMIN_PK_BEST  = RMIN_PK
              THETA12_BEST  = THETA12
              PHI12_BEST    = PHI12
              CHI12_BEST    = CHI12
              DIST_MIN_BEST = DIST_MIN
              DORT_BEST     = DORT
              DPAR_BEST     = DPAR
              SH12F_BEST(1) = SH12F(1)
              SH12F_BEST(2) = SH12F(2)
              SH12F_BEST(3) = SH12F(3)
              SH1_BEST(1)   = SH1(1)
              SH1_BEST(2)   = SH1(2)
              SH1_BEST(3)   = SH1(3)
              TF_CONTRAST_BEST = TF_CONTRAST
              PACK_INDEX12_BEST = PACK_INDEX12
              TC_AVER_BEST   = TC_AVER 
              TC_AVER2_BEST = TC_ AVER2
              NC_NAVER_BEST  = NC_NAVER

c              MODE = 'E'
c              DO I=1,3
c                SH1(I) = 0.0
c                SH2(I) = 0.0
c                DO J=1,3
c                  AM(I,J) = 0.0
c                ENDDO
c              ENDDO
c              AL    = 0.0
c              BE    = 0.0
c              GA    = 0.0
c              NAMES = 'trfun'
c              CALL TRANS(M,NAMES,NAME_BEST,SH1,SH2
c     *        ,MODE,AM,AL,BE,GA,RESULTA,ISYM,IPRSYM,IERR)
c              IF(IERR.NE.0) GO TO 900

            ENDIF

c            WRITE(LINE,
c     *      '(''Sol_    '',6I4,1X,3F6.3,F6.2,F6.2,1X,2F7.3)') 
c     *      IR_CURR,JR_CURR,IS_CURR,IANG_CURR,IPT_CURR,JPT_CURR
c     *      ,SH1_CURR(1),SH1_CURR(2),SH1_CURR(3)
c     *      ,RMAX_PK_CURR,RMIN_PK_CURR,RFAC_CURR,CORR_CURR
c            CALL MSGDOC(MDOC,LINE)

 200        CONTINUE

          ENDDO

          IT2 = (NMON - NUM_MON)/2 
          IT1 =  NNPROT*NPROT2
          IF(MOD_D2.EQ.'N')  THEN
            IT1 = (NNPROT*(NPROT2+1))/2
          ENDIF
          NRUN_TIME_TOT = IT2*IT1*NR_SYM_SCORE

          IRUN_TIME = IRUN_TIME + 1
          NRUN_TIME = NRUN_TIME_TOT - IRUN_TIME
          ITIME_START = 0
          CALL EXPECTED_TIME(ITIME_START,NRUN_TIME
     *      ,ITIME_CURR,TIME_CURRENT,TIME_ELAPSED,TIME_EXPECTED)
 
          TIME_ELAPSED_XML  = TIME_ELAPSED
          TIME_EXPECTED_XML = TIME_EXPECTED

          IERR_XML     = 0
          MESSAGE_XML  = 'normal run'  
          CALL WRITE_XML_FILE(IERR,PATH_OUT)
 
          IF(IRUN_TIME.LE.1) THEN          
            WRITE(LINE,*) 'Time_elapsed:',TIME_ELAPSED
     *                   ,' Remained:',TIME_EXPECTED
            CALL MSGDOC(MDOC,LINE)
            CALL MSGDOC(MDOC,'Sol_')

            IF(MOD2_INI.EQ.'Y'.AND.CORR_FIX_M.GT.-1.4.AND.
     *                           IFIRST_CORR_FIX.LE.1.AND.
     *                   DYAD.EQ.'D'.AND.SCORE_FLAG.EQ.'Y') THEN
              WRITE(LINE,'(A,F6.3)')'Corr_for_fixed_model:'
     *        ,CORR_FIX_M
              CALL MSGDOC(MDOC,LINE)
              CALL MSGDOC(MDOC,
     *        '   will be used if keyword SCORE = Y')
              IFIRST_CORR_FIX = IFIRST_CORR_FIX + 1
            ENDIF

            CALL MSGDOC(MDOC,'Sol_')
            LINE = 
     *      'Sol_  R1  R2 Rsym Rslf STF TF '//
     *      ' PF12 PFmax  PFmin   wRfac Scor Scor_max Cntrst'
            CALL MSGDOC(MDOC,LINE)
          ENDIF
C ===
          CALL CHECK_STOP_SIGNAL(PATH_SCR,ISIGNAL_STOP)

          IF(CORR_CURR.GT.-1.4) THEN

            CALL DYAD_STORE_SCORE(CORR_CURR,NSCORE,SCORE_STOR
     *       ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
     *       ,TC_AVER_CURR,TC_AVER2_CURR,NC_NAVER_CURR
     *       ,SCORE_MAX,NSCORE_MAX)

            IF(MOD_D2.EQ.'N')  THEN
              NNN1 = (NUM_MON*(NUM_MON-1))/2 
              NNN2 = (NMON*(NMON-1))/2 
              NSSS = NR_SYM_SCORE
            ELSE
              NNN1 = (NUM_MON*NUM_MON)/4
              NNN2 = (NMON*NMON)/4
              NSSS = NR_SYM_SCORE*NR_SYM_SCORE
            ENDIF

            CALL DYAD_CONTRAST(M,NNN1,NNN2,NSSS,CNTR_NEW
     *                     ,CORR_BEST,CONTRAST,NSCORE
     *             ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
     *                     ,SCORE_STOR,NSCORE_MAX)

            WRITE(LINE,
     *      '(''Sol_'',6I4,F7.2,F6.2,1X,F6.2,1X,3F7.3,F7.2)') 
     *      IR_CURR,JR_CURR,IS_CURR,IANG_CURR,IPT_CURR,JPT_CURR
     *      ,PACK_INDEX12_CURR,RMAX_PK_CURR,RMIN_PK_CURR
     *      ,RFAC_CURR,SCORR_CURR,SCORE_MAX,CONTRAST


C            WRITE(LINE,
C     *      '(''Sol_'',6I4,5X,F6.2,3X,F6.2,1X,4F7.3)') 
C     *      IR_CURR,JR_CURR,IS_CURR,IANG_CURR,IPT_CURR,JPT_CURR
C     *      ,RMAX_PK_CURR,RMIN_PK_CURR
C     *      ,CORR_CURR,RFAC_CURR,SCORR_CURR,SCORE_MAX

            CALL MSGDOC(MDOC,LINE)

            IF(LIST.EQ.'L'.OR.LIST.EQ.'T') THEN
              MMM = MD
              A1  = (ALPHA1*PI)/180.0
              B1  = (BETA1 *PI)/180.0
              G1  = (GAMMA1*PI)/180.0
              CALL EULERM(A1,B1,G1,AM)                                   
              CALL MTOPOL(AM,A1,B1,G1)
              A2  = (ALPHA2*PI)/180.0
              B2  = (BETA2 *PI)/180.0
              G2  = (GAMMA2*PI)/180.0
              CALL EULERM(A2,B2,G2,AM)                                   
              CALL MTOPOL(AM,A2,B2,G2)
              T1  = SH1_CURR(1) + SH12F_CURR(1)
              T2  = SH1_CURR(2) + SH12F_CURR(2)
              T3  = SH1_CURR(3) + SH12F_CURR(3)
              LINE = 
     *        'Sol           angles_1             angles_2 '
              CALL MSGDOC(MMM,LINE)
              WRITE(LINE,'(''Sol '',3F8.2,3F8.2)') 
     *        A1,B1,G1,A2,B2,G2
              CALL MSGDOC(MMM,LINE)
              LINE = 
     *        'Sol         Shift_1                  Shift_2'
              CALL MSGDOC(MMM,LINE)
              WRITE(LINE,'(''Sol '',3F7.3,4X,3F7.3)') 
     *        SH1_CURR(1),SH1_CURR(2),SH1_CURR(3),T1,T2,T3
              CALL MSGDOC(MMM,LINE)
              LINE = 
     *        'Sol        Rot1->2               Dyad_vector'//
     *        '       dist d_ort d_par'
              CALL MSGDOC(MMM,LINE)
              WRITE(LINE,'(''Sol '',3F7.1,2X,3F7.3,1X,3F6.1)') 
     *        THETA12_CURR,PHI12_CURR,CHI12_CURR
     *        ,SH12F_CURR(1),SH12F_CURR(2),SH12F_CURR(3)
     *        ,DIST_MIN_CURR,DORT_CURR,DPAR_CURR
              CALL MSGDOC(MMM,LINE)
            ENDIF

            NRUN = NRUN + 1 
            IF(NRUN.GT.NRUN_LIM.AND.SCORE_FLAG.EQ.'Y'.AND.
     *         CORR_BEST.GT.CORR_TOT.AND.
     *         CONTRAST.GT.CONTRAST_LIM) THEN
              LINE = 
     *        'INFO: contrast is good enough. Stop this run'
              CALL MSGDOC(MDOC,LINE)
              GO TO 500
            ENDIF

            IF(ISIGNAL_STOP.GT.0) GO TO 500

          ELSE
c  all values of Packing Function =< 0
            IF(IPACK.NE.0.OR.IDIST.NE.0) THEN
              IF(IPACK.EQ.0) THEN
                WRITE(LINE,
     *    '(''Sol_'',4I4,''          dist/rot limits      -   -'')') 
     *          IR,JR,IS,IANG
                CALL MSGDOC(MDOC,LINE)
              ELSE IF(IDIST.EQ.0) THEN
                WRITE(LINE,
     *    '(''Sol_'',4I4,''        all values of PackF =< 0  -   -'')') 
     *          IR,JR,IS,IANG
                CALL MSGDOC(MDOC,LINE)
              ELSE
                WRITE(LINE,
     *    '(''Sol_'',4I4,''  dist/rot limits and PackF =< 0  -   -'')') 
     *          IR,JR,IS,IANG
                CALL MSGDOC(MDOC,LINE)
              ENDIF
            ELSE
              WRITE(LINE,
     *    '(''Sol_'',4I4,''                               -   -'')') 
     *        IR,JR,IS,IANG
              CALL MSGDOC(MDOC,LINE)
            ENDIF
          ENDIF

 100      CONTINUE
c       -- is --

          IF(ISIGNAL_STOP.GT.0) GO TO 500

        ENDDO

        NR_SYM_SCORE = NR_SYM_CALC
        IF(MOD_D2.EQ.'N')  THEN
          NNN2 = (NMON*(NMON-1))/2 
          NRUN_LIM = (NNN2 + 7)*NR_SYM_SCORE
        ELSE
          NNN2 = (NMON*NMON)/4
          NRUN_LIM = (NNN2 + 7)*NR_SYM_SCORE*NR_SYM_SCORE
        ENDIF

C ----------------------------------
C         --  --
          ENDIF
C       -- jjr2 --
        ENDDO
C       -- iir2 --
        ENDDO
C     -- iir --
      ENDDO

C ----------------
 500  CONTINUE
      IF(IR_BEST.EQ.0) THEN
C        IERR = 1

C        IF(ISYM_DYAD.LE.0) THEN
C          IERR =1
C          CALL MSGERR(MDOC,' ERROR: no NCS related peaks')
C          GO TO 900
C        ENDIF

      ELSE


CSol_Rot1  1 Rot2  3 Rot_sym  1 Rot_self  0 Rot_1->2:  11.43  -57.56  179.66
CSol_STF 1 dyad_vec:  -0.478 -0.195 -0.125 ,dist: 59.3 d_par: 58.4 d_ort: 10.5
CSol_TF 2 Sh_1: 0.230 0.000 0.297 ,Pack_max,min: 1.01  0.71 Rf  0.619 Cc 0.192

        CALL MSGDOC(MDOC,'Sol_best')
        LINE = 
     *  'Sol_best  R1  R2  Rs Rslf STF TF    '//
     *  'PFmax   PFmin    TFcntr   Rfac    Scor'
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,
     * '(''Sol_best'',6I4,2X,F6.2,3X,F6.2,2X,3F8.3)') 
     *  IR_BEST,JR_BEST,IS_BEST,IANG_BEST,IPT_BEST,JPT_BEST
     * ,RMAX_PK_BEST,RMIN_PK_BEST,TF_CONTRAST_BEST
     * ,RFAC_BEST,CORR_BEST
        CALL MSGDOC(MDOC,LINE)
        LINE = 
     *  'Sol_best         Rot1->2               Dyad_vector'//
     *  '       dist d_ort d_par'
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(''Sol_best'',3F7.1,3X,3F7.3,2X,3F6.1)') 
     *  THETA12_BEST,PHI12_BEST,CHI12_BEST
     * ,SH12F_BEST(1),SH12F_BEST(2),SH12F_BEST(3)
     * ,DIST_MIN_BEST,DORT_BEST,DPAR_BEST
        CALL MSGDOC(MDOC,LINE)
        T1  = SH1_BEST(1) + SH12F_BEST(1)
        T2  = SH1_BEST(2) + SH12F_BEST(2)
        T3  = SH1_BEST(3) + SH12F_BEST(3)
        LINE = 
     *  'Sol_best                 Shift_1          Shift_2'
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(''Sol_best '',3F7.3,4X,3F7.3)') 
     *  SH1_BEST(1),SH1_BEST(2),SH1_BEST(3),T1,T2,T3
        CALL MSGDOC(MDOC,LINE)
        CALL MSGDOC(MDOC,'Sol_best')

C        CALL MSGDOC(MDOC,'Sol_')
C        WRITE(LINE,'(''Sol_best_Rot1_Rot2_Isym2 '',4I4,2F7.3)') 
C     *    IR_BEST,JR_BEST,IS_BEST,IANG_BEST,RFAC_BEST,CORR_BEST
C        CALL MSGDOC(MDOC,LINE)
C        CALL MSGDOC(MDOC,'Sol_')


        IF(MOD_D2.EQ.'N')  THEN
           NNN1 = (NUM_MON*(NUM_MON-1))/2 
           NNN2 = (NMON*(NMON-1))/2 
           NSSS = NR_SYM_SCORE
         ELSE
           NNN1 = (NUM_MON*NUM_MON)/4
           NNN2 = (NMON*NMON)/4
           NSSS = NR_SYM_SCORE*NR_SYM_SCORE
         ENDIF


         CALL DYAD_CONTRAST(MDOC,NNN1,NNN2,NSSS,CNTR_NEW
     *                  ,CORR_BEST,CONTRAST,NSCORE
     *          ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
     *                  ,SCORE_STOR,NSCORE_MAX)

          NRUN_LIM = (NNN2 + 7)*NR_SYM_SCORE
          IF(NRUN.LT.NRUN_LIM) CONTRAST = 0.0

         CONTRAST_BEST = CONTRAST

      ENDIF
C ----------------
      IF(SCORE_FLAG.EQ.'Y'.AND.CONTRAST_BEST.GT.0.01.AND.
     *                              CORR_BEST.GT.CORR_TOT) THEN
        CALL FINAL_MESSAGE(MDOC,CONTRAST_BEST,CORR_BEST)
      ENDIF    

      IF(CORR_BEST.GT.CORR_TOT) THEN
C       NAME_BEST 
        IFOUND = 1
        IR     = IR_BEST 
        ALPHA1 = TALPHA(IR)
        BETA1  = TBETA (IR)
        GAMMA1 = TGAMMA(IR)
        JR     = JR_BEST
        IS     = IS_BEST
        ALPHA2 = TALPHA2(JR)
        BETA2  = TBETA2 (JR)
        GAMMA2 = TGAMMA2(JR)


c        write(*,*) '--1:',ir,ALPHA1,BETA1,GAMMA1
c        write(*,*) '--1:',sh1_best(1),sh1_best(2),sh1_best(3)
c        write(*,*) '--2:',jr,ALPHA2,BETA2,GAMMA2
c        write(*,*) '--2:',sh12f_best(1),sh12f_best(2),sh12f_best(3)

        CALL TRF_CHANGE_ANGLE(M,IS,ALPHA2,BETA2,GAMMA2
     *                         ,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900          

        CALL FTOO(SH1_BEST,SH2,IERR)   

c        write(*,*) '--3:',sh2(1),sh2(2),sh2(3)

        IF(STICK.EQ.'Y') THEN

          CALL FTOO(SH1_BEST,SH2,IERR)   

          LINE = '  --- Model-1 ---'
          CALL MSGDOC(MDOC,LINE)

          CALL STICK_TEST(MDOC,RAD_MODEL,IS_N
     *         ,ALPHA1,BETA1,GAMMA1,SH2,PEAK_TEST
     *         ,ALPHA_N,BETA_N,GAMMA_N,THETA_N,PHI_N,CHI_N
     *         ,IPT_MIN,IDIMER
     *         ,SH1,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
          ALPHA1 = ALPHA_N
          BETA1  = BETA_N 
          GAMMA1 = GAMMA_N
          SH2(1) = SH1(1)
          SH2(2) = SH1(2)
          SH2(3) = SH1(3)

          CALL OTOF(SH2,SH1_BEST,IERR)   

        ENDIF


c        write(*,*) '--4:',ALPHA1,BETA1,GAMMA1
c        write(*,*) '--4:',sh2(1),sh2(2),sh2(3)
c        write(*,*) '--1:',sh1_best(1),sh1_best(2),sh1_best(3)

        MODE = 'E'
        DO I=1,3
          SH1(I) = 0.0
          DO J=1,3
            AM(I,J) = 0.0
          ENDDO
        ENDDO
        NAMES = 'trfn_scr1'
        CALL ADD_PATH(PATH_SCR,NAMES)  
        CALL TRANS(M,NAMEM,NAMES,SH1,SH2
     *    ,MODE,AM,ALPHA1,BETA1,GAMMA1,RESULTA,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900


        IF(STICK.EQ.'Y') THEN
          I = PEAK_TEST(12,1) 
          I = I + 1
          PEAK_TEST(12,1) = I
          J = 0 
          IF(I.GE.2) J = PEAK_TEST( 1,I-1) 
          J = J + 1
          PEAK_TEST( 1,I) = J 
          PEAK_TEST( 2,I) = 1
          PEAK_TEST( 3,I) = ALPHA1
          PEAK_TEST( 4,I) = BETA1
          PEAK_TEST( 5,I) = GAMMA1
          PEAK_TEST( 6,I) = SH2(1)
          PEAK_TEST( 7,I) = SH2(2)
          PEAK_TEST( 8,I) = SH2(3)
          PEAK_TEST( 9,I) = 0
          PEAK_TEST(10,I) = 0
          PEAK_TEST(11,I) = 0
        ENDIF

        SH1(1) = SH12F_BEST(1) + SH1_BEST(1)
        SH1(2) = SH12F_BEST(2) + SH1_BEST(2)
        SH1(3) = SH12F_BEST(3) + SH1_BEST(3)

        CALL FTOO(SH1,SH2,IERR)   

C        write(*,*) '--5:',ALPHA2,BETA2,GAMMA2
C        write(*,*) '--5:',sh1(1),sh1(2),sh1(3)
C        write(*,*) '--5:',sh2(1),sh2(2),sh2(3)

        IF(STICK.EQ.'Y') THEN

          LINE = '  --- Model-2 ---'
          CALL MSGDOC(MDOC,LINE)

          CALL STICK_TEST(MDOC,RAD_MODEL,IS_N
     *         ,ALPHA2,BETA2,GAMMA2,SH2,PEAK_TEST
     *         ,ALPHA_N,BETA_N,GAMMA_N,THETA_N,PHI_N,CHI_N
     *         ,IPT_MIN,IDIMER
     *         ,SH1,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
          ALPHA2 = ALPHA_N
          BETA2  = BETA_N 
          GAMMA2 = GAMMA_N
          SH2(1) = SH1(1)
          SH2(2) = SH1(2)
          SH2(3) = SH1(3)

          CALL OTOF(SH2,SH12F_BEST,IERR)   

        ENDIF

c        write(*,*) '--6:',ALPHA2,BETA2,GAMMA2
c        write(*,*) '--6:',sh12f_best(1),sh12f_best(2),sh12f_best(3)
c        write(*,*) '--6:',sh2(1),sh2(2),sh2(3)

C        SH2(1) = SH12F_BEST(1) 
C        SH2(2) = SH12F_BEST(2) 
C        SH2(3) = SH12F_BEST(3)   

        MODE = 'E'
        DO I=1,3
          SH1(I) = 0.0
          DO J=1,3
            AM(I,J) = 0.0
          ENDDO
        ENDDO
        NAMES = 'trfn_scr2'
        CALL ADD_PATH(PATH_SCR,NAMES)  
        CALL TRANS(M,NAMEM2,NAMES,SH1,SH2
     *    ,MODE,AM,ALPHA2,BETA2,GAMMA2,RESULTA,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900


        IF(STICK.EQ.'Y') THEN
          I = PEAK_TEST(12,1) 
          I = I + 1
          PEAK_TEST(12,1) = I
          J = 0 
          IF(I.GE.2) J = PEAK_TEST( 1,I-1) 
          J = J + 1
          PEAK_TEST( 1,I) = J 
          PEAK_TEST( 2,I) = 1
          PEAK_TEST( 3,I) = ALPHA2
          PEAK_TEST( 4,I) = BETA2
          PEAK_TEST( 5,I) = GAMMA2
          PEAK_TEST( 6,I) = SH2(1)
          PEAK_TEST( 7,I) = SH2(2)
          PEAK_TEST( 8,I) = SH2(3)
          PEAK_TEST( 9,I) = 0
          PEAK_TEST(10,I) = 0
          PEAK_TEST(11,I) = 0
        ENDIF



        NAMES3 = 'trfn_scr2'
        CALL ADD_PATH(PATH_SCR,NAMES3)  
        NAMES4 = 'trfn_scr1'
        CALL ADD_PATH(PATH_SCR,NAMES4)  
        I = 0
        IF(MOD2.EQ.'Y') THEN
          NAMES  = 'trfn_scr1'          
          CALL ADD_PATH(PATH_SCR,NAMES)  
          NAMES4 = 'trfn_scr3'
          CALL ADD_PATH(PATH_SCR,NAMES4)  
          IERR = NMON + 1
          I    = 1
          CALL JOINCRD(M,NAMEO,NAMES,NAMES4,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
        ENDIF  
        IERR = NMON + I + 1
        CALL JOINCRD(M,NAMES4,NAMES3,NAME_BEST,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900

        SCORR_TOT= SCORR_BEST
        CORR_TOT = CORR_BEST
        RFAC_TOT = RFAC_BEST        
        NUM_MON  = NUM_MON + 2

        NSOL_XML     = NUM_MON
        PREV_CONTRAST_XML = CONTRAST_XML
        CONTRAST_XML = CONTRAST_BEST       


        IF(DYAD.NE.'D'.AND.(NUM_MON+2).GT.NMON.AND.
     *                     (NUM_MON+1).LE.NMON     ) IFOUND = 0

        MOD2     = 'Y'
C       NAME_BEST --> NAMEO
        MODE = 'E'
        DO I=1,3
          SH1(I) = 0.0
          SH2(I) = 0.0
          DO J=1,3
            AM(I,J) = 0.0
          ENDDO
        ENDDO
        AL  = 0.0
        BE  = 0.0
        GA  = 0.0
        CALL TRANS(M,NAME_BEST,NAMEO,SH1,SH2
     *    ,MODE,AM,AL,BE,GA,RESULTA,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900

        WRITE(LINE,   
     *  '(''Sol_'',11X,''now number of found monomers:'',I5)') NUM_MON
        CALL MSGDOC(MDOC,LINE)

      ELSE 
        IFOUND = 0
      ENDIF

      IF(IFOUND.EQ.0) THEN
         
        IF(NUM_MON.LE.0) THEN
C         no solution          
          IF(CORR_TOT_MON.GT.-1.4) THEN
            MODE = 'E'
            ALP  = 0.0
            BET  = 0.0
            GAM  = 0.0
            DO I=1,3
              SH1(I) = 0.0
              SH2(I) = 0.0
              DO J=1,3
                AM(I,J) = 0.0
              ENDDO
            ENDDO
            CALL TRANS(M,NAME_MON,NAMEO,SH1,SH2
     *      ,MODE,AM,ALP,BET,GAM,RESULT,ISYM,IPRSYM,IERR)
            IF(IERR.NE.0) GO TO 900
            NUM_MON = 1

            CALL MSGDOC(MDOC,'Sol_ WARNING: can not find more solution')
            WRITE(LINE,   
     *      '(''Sol_'',11X,''Final number of monomers:'',I5)') NUM_MON
            CALL MSGDOC(MDOC,LINE)
            IF(MOD2_INI.EQ.'Y') THEN
              WRITE(LINE,   
     *        '(''Sol_'',11X,'' + second fixed model'')') 
              CALL MSGDOC(MDOC,LINE)
            ENDIF
C --XML--
            NSOL_XML     = NUM_MON

            GO TO 900
          ENDIF

          CALL MSGDOC(MDOC,'Sol_ WARNING: no solution was found')
          IERR = 1
C --XML--
          IERR_XML     = 2
          MESSAGE_XML  = 'no solution was found'
          CONTRAST_XML = 0.0
          NSOL_XML     = 0
C -------
          GO TO 900

        ELSE
C         no more
c         IF(MOD2_D2.ne.'N') THEN

          IF(ISIGNAL_STOP.GT.0) GO TO 900

          IF(DYAD.NE.'D') THEN
            CALC2 = 'Y'
            IADD  = 0
            CALL MSGDOC(MDOC,'Sol_ ')
            WRITE(LINE,
     *      '(''Sol_--- Last monomer search ---'')') 
            CALL MSGDOC(MDOC,LINE)
            CALL MSGDOC(MDOC,'Sol_ ')

            NSCORE     = 0.0
            NRUN         = 0
            NRUN_LIM     = 10

            SCORE_MAX  =-1.5
            CORR_MAX   =-1.5
            NSCORE     = 0.0
            CONTRAST   = 0.0
            CONTRAST_MAX = 0.0

            LINE =
     * 'Sol_ RF TF   Tf/sig '//
     * '   TFcntrst PFind PFmax PFmin  wRfac  Scor Scor_max Cntrst'
            CALL MSGDOC(MDOC,LINE)

            IFIRST_SCL = 0
            DO IR=1,NPROT

              ALPHA = TALPHA(IR)
              BETA  = TBETA (IR)
              GAMMA = TGAMMA(IR)
C --
              IERR = NUM_MON

              PARM2_TR( 1: 1) = TFUN
              PARM2_TR( 2: 2) = 'N'
              PARM2_TR( 3: 3) = REF
              PARM2_TR( 4: 4) = PACK
              PARM2_TR( 5: 5) = PST
              PARM2_TR( 6: 6) = CALC2
              ANISO_T = ANISO
              PARM2_TR( 7: 7) = ANISO_T
              PARM2_TR( 8: 8) = SURF
              PARM2_TR( 9: 9) = 'N'
              PARM2_TR(10:10) = MOD2
              PARM2_TR(11:11) = INVER  
              PARM2_TR(12:12) = 'N' 
              PARM2_TR(13:13) = FAST  
              PARM2_TR(14:14) = 'N'  
              PARM2_TR(15:15) = 'C'  
              PARM2_TR(16:16) = ' '
              PARM2_TR(17:17) = STICK
              PARM2_TR(18:18) = MOD1
              PARM2_TR(19:19) = MOD2
              PARM2_TR(20:20) = LIST
              PARM2_TR(22:22) = SURFX

              FPAR2_TR( 1) = RESMIN
              FPAR2_TR( 2) = RESMAX
              FPAR2_TR( 3) = ALPHA
              FPAR2_TR( 4) = BETA
              FPAR2_TR( 5) = GAMMA
              FPAR2_TR( 6) = BOFF
              FPAR2_TR( 7) = BOFF
              FPAR2_TR( 8) = BADD
              FPAR2_TR( 9) = BLIM
              FPAR2_TR(10) = 20.0
              FPAR2_TR(11) = 5.0
              FPAR2_TR(12) = BOFF_SCL
              FPAR2_TR(13) = BADD_SCL
              FPAR2_TR(17) = 0.0
              FPAR_TR(18) = IFIRST_SCL
 
              NMR = NMR_INP
              DO I=1,3
                SH1(I) = 0.0
              ENDDO
              NAMES = ' '
              NEL2  = 0
              NC    = 0
              NCP   = 0
              NAMET_OUT   = 'trfun'
              CALL ADD_PATH(PATH_SCR,NAMET_OUT)
              NAMED       = ' '
              NAME_FCALC  = ' '
              NAME_PHCALC = ' '
              NCS_ID = 0
              CALL TRFUN(M,NAMEF,NAMEM,NAMES,NAME_BEST,NAMET_OUT
     *        ,NAMED,NAME_FCALC,NAME_PHCALC,PATH_SCR
     *        ,IR,SH1,NC,NPT,NMR,N_MODEL,NEL2,NCP,NCS_ID
     *        ,ANGLES_NCS_INP,CENTRE_NCS
     *        ,PARM2_TR,FPAR2_TR,SPST,PEAK_TEST
     *        ,ISYM,IPRSYM
     *        ,RESULT,RESULT2,IPRMAX,IPRROW,IERR)

              FAST  = PARM2_TR(13:13)
              CALC2 = PARM2_TR( 6: 6) 
              IFIRST_SCL = FPAR_TR(18) 
              RMAX_PK = RESULT(1,14)
              RMIN_PK = RESULT(1,15)
              SIGMA   = RESULT(1,16)
              TF_CONTRAST = RESULT(1,17)
              PACK_INDEX = RESULT(1,21)

              IF(IERR.NE.0) THEN
                IF(IERR.EQ.1) GO TO 900
                RESULT(1,12) = 0
                IPK_TRANS = 0
                WRITE(CH10,'(''Sol'',I4,I3)') IR,IPK_TRANS
                DO J=1,10
                 IF(CH10(J:J).EQ.' ') CH10(J:J) = '_'
                ENDDO
                IF(IERR.EQ.10) THEN
                  WRITE(LINE,'(A,A)') CH10,
     *            '   ---- all values of Packing Function =< 0 -----'
                  CALL MSGDOC(MDOC,LINE)
                ELSE
                  WRITE(LINE,'(A,A)') CH10,'     ---------'
                  CALL MSGDOC(MDOC,LINE)
                ENDIF
                IERR         = 0
              ENDIF
C -
              NPTRANS = RESULT(1,12)
              RFAC    = RESULT(1,1)
              T = RESULT(1,2)
              IF(SCORE_FLAG.NE.'C')THEN
                T = (T+1.0)*SQRT(ABS(PACK_INDEX))
                CORR    = T-1.0
              ELSE
                CORR    = T
              ENDIF
              SCORR   = RESULT(1,13)
              TXSH_C  = RESULT(1,6)
              TYSH_C  = RESULT(1,7)
              TZSH_C  = RESULT(1,8)

              IF(NPTRANS.GT.0) THEN
                TC_AVER   = RESULT(1,18) 
                TC_ AVER2 = RESULT(1,19) 
                NC_NAVER  = RESULT(1,20) 
                CALL DYAD_STORE_SCORE(CORR,NSCORE,SCORE_STOR
     *          ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
     *          ,TC_AVER,TC_AVER2,NC_NAVER
     *          ,SCORE_MAX,NSCORE_MAX)
                IPK_TRANS = RESULT(1,9)


                CORRB = CORR_MAX 
                IF(CORR.GT.CORR_MAX) CORRB = CORR
  
                NNN1 = NUM_MON
                NR_SYM_TEMP = 1
                CALL DYAD_CONTRAST(M,NNN1,NMON,NR_SYM_TEMP,CNTR_NEW
     *                     ,CORRB,CONTRAST,NSCORE
     *                ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
     *                     ,SCORE_STOR,NSCORE_MAX)


                IF(CORR.GT.CORR_MAX) THEN
                  MODE = 'E'
                  ALP  = 0.0
                  BET  = 0.0
                  GAM  = 0.0
                  DO I=1,3
                    SH1(I) = 0.0
                    SH2(I) = 0.0
                    DO J=1,3
                      AM(I,J) = 0.0
                    ENDDO
                  ENDDO
                  NAMES = 'trfun'
                  CALL ADD_PATH(PATH_SCR,NAMES)
                  CALL TRANS(M,NAMES,NAMEO,SH1,SH2
     *            ,MODE,AM,ALP,BET,GAM,RESULT,ISYM,IPRSYM,IERR)
                  IF(IERR.NE.0) GO TO 900
                  IADD      = IR
                  TXSH_MON  = TXSH_C
                  TYSH_MON  = TYSH_C
                  TZSH_MON  = TZSH_C
                  CORR_MAX  = CORR
                  SCORR_MAX = SCORR
                  RFAC_MAX  = RFAC
                  IPK_TRANS_MAX   = IPK_TRANS
                  TF_CONTRAST_MAX = TF_CONTRAST
                  CONTRAST_MAX = CONTRAST
                ENDIF

                WRITE(CH10,'(''Sol'',I4,I3)') IR,IPK_TRANS
                DO J=1,10
                  IF(CH10(J:J).EQ.' ') CH10(J:J) = '_'
                ENDDO
                TFSIG     = RESULT(1,5)  

                WRITE(LINE,1300) CH10,TFSIG,TF_CONTRAST
     *          ,PACK_INDEX,RMAX_PK
     *          ,RMIN_PK,RFAC,CORR,CORR_MAX,CONTRAST
                CALL MSGDOC(MDOC,LINE)

                NP_FIN    = IR
                NRUN = NRUN + 1 
                IF(NRUN.GT.NRUN_LIM.AND.SCORE_FLAG.EQ.'Y'.AND.
     *            CORR_BEST.GT.CORR_TOT.AND.
     *            CONTRAST.GT.CONTRAST_LIM) THEN
                  LINE = 
     *            'INFO: contrast is good enough. Stop this run'
                  CALL MSGDOC(MDOC,LINE)
                  GO TO 831
                ENDIF

              ENDIF

              CALL CHECK_STOP_SIGNAL(PATH_SCR,ISIGNAL_STOP)
              IF(ISIGNAL_STOP.GT.0) GO TO 831

            ENDDO
 831        CONTINUE

            IF(IADD.GT.0) THEN
              IF(SCORE_FLAG.EQ.'Y'.AND.CONTRAST_MAX.GT.0.01.AND.
     *                                     CORR_MAX.GT.CORR_TOT) THEN
                CALL FINAL_MESSAGE(MDOC,CONTRAST_MAX,CORR_MAX)

              ENDIF    

              IF(CORR_MAX.GT.CORR_TOT) THEN
                CORR_TOT = CORR_MAX
                CALL MSGDOC(MDOC,'Sol_best')

                ALPHA   = TALPHA(IADD)
                BETA    = TBETA (IADD)
                GAMMA   = TGAMMA(IADD)
                RALPHA  = (ALPHA*PI)/180.0
                RBETA   = (BETA *PI)/180.0
                RGAMMA  = (GAMMA*PI)/180.0
                CALL EULERM(RALPHA,RBETA,RGAMMA,AM)
                CALL MTOPOL(AM,THETA,PHI,CHI)
                LINE = 'Sol_   RF TF  theta    phi     chi'//
     *          '    tx     ty     tz   TFcntr   wRfac   Scor'
                CALL MSGDOC(MDOC,LINE)

                SH1(1) = TXSH_MON
                SH1(2) = TYSH_MON
                SH1(3) = TZSH_MON
                CALL OTOF(SH1,SH2,IERR)   

                WRITE(LINE,
     *          '(''Sol_'',I4,I4,3F8.2,3F7.3,F7.2,2F7.3)')
     *          IADD,IPK_TRANS_MAX
     *          ,THETA,PHI,CHI
     *          ,SH2(1),SH2(2),SH2(3)
     *          ,TF_CONTRAST_MAX,RFAC_MAX,CORR_TOT
                CALL MSGDOC(MDOC,LINE)
c     *          ,TXSH_MON,TYSH_MON,TZSH_MON

                CALL MSGDOC(MDOC,'Sol_best')

                NUM_MON = NUM_MON + 1

                WRITE(LINE,   
     *        '(''Sol_'',11X,''Final number of monomers:'',I5)') NUM_MON
                CALL MSGDOC(MDOC,LINE)
                IF(MOD2_INI.EQ.'Y') THEN
                  WRITE(LINE,   
     *            '(''Sol_'',11X,'' + second fixed model'')') 
                  CALL MSGDOC(MDOC,LINE)
                ENDIF
                NRSM = 1
                CALL DYAD_CONTRAST(MDOC,NUM_MON,NMON,NRSM,CNTR_NEW
     *             ,CORR_TOT,CONTRAST,NSCORE
     *             ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
     *                     ,SCORE_STOR,NSCORE_MAX)
                CONTRAST_BEST = CONTRAST
                NUM_MON = NUM_MON + 1

C --XML--
                NSOL_XML     = NUM_MON
                PREV_CONTRAST_XML = CONTRAST_XML
                CONTRAST_XML = CONTRAST_BEST       
                GO TO 900
              ELSE

              ENDIF
            ENDIF

          ENDIF

          CALL MSGDOC(MDOC,'Sol_ WARNING: can not find more solution')
          WRITE(LINE,   
     *    '(''Sol_'',11X,''Final number of monomers:'',I5)') NUM_MON
          CALL MSGDOC(MDOC,LINE)
          IF(MOD2_INI.EQ.'Y') THEN
            WRITE(LINE,   
     *      '(''Sol_'',11X,'' + second fixed model'')') 
            CALL MSGDOC(MDOC,LINE)
          ENDIF
C --XML--
          NSOL_XML     = NUM_MON
          CONTRAST_XML = CONTRAST_BEST       
          GO TO 900
        ENDIF
      ENDIF

      IF(NUM_MON.LT.NMON.AND.(NUM_MON+1.LT.NMON)) THEN
        PREV_CONTRAST_XML = CONTRAST_XML
        CONTRAST_XML = CONTRAST_BEST       
        GO TO 300
      ENDIF
      WRITE(LINE,   
     *'(''Sol_'',11X,''Final number of monomers:'',I5)') NUM_MON
      CALL MSGDOC(MDOC,LINE)
      IF(MOD2_INI.EQ.'Y') THEN
        WRITE(LINE,   
     *  '(''Sol_'',11X,'' + second fixed model'')') 
        CALL MSGDOC(MDOC,LINE)
      ENDIF
C --XML--
      NSOL_XML     = NUM_MON
c        PREV_CONTRAST_XML = CONTRAST_XML
c        CONTRAST_XML = CONTRAST_BEST       
C ----------------
 900  CONTINUE

      IF(IERR.EQ.0) MESSAGE_XML  = 'normal termination'  

c      NAME_BEST  = 'trfn_best'
c      NAMEC1     = 'trfn_mod1'
c      NAMEC2     = 'trfn_mod2'
c      NAMEC12    = 'trfn_mod12'
c      NAMEFM     = 'trfn_f'
c      NAMEPH     = 'trfn_ph'
c      NAMEFM_PK  = 'trfn_f_pk'
c      NAMEPH_PK  = 'trfn_ph_pk'
c      NAMEFM2    = 'trfn_f2'
c      NAMEPH2    = 'trfn_ph2'
c      NAMEFM2_PK = 'trfn_f2_pk'
c      NAMEPH2_PK = 'trfn_ph2_pk'
c      NAMEFMO    = 'trfn_fo'
c      NAMEPHO    = 'trfn_pho'
c      NAMEFMO_PK = 'trfn_fo_pk'
c      NAMEPHO_PK = 'trfn_pho_pk'
c      NAMEFMC    = 'trfn_fc'
c      NAMEPHC    = 'trfn_phc'
c      NAME_MON   = 'trfn_mon'  
C ----

      NAMES='trfn_best.crd'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_mod1.crd'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_mod2.crd'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_mod12.crd'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_f.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_ph.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_f_pk.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_ph_pk.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
C ---
      NAMES='trfun_dns1.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfun_dns2.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfun_dns3.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_scr.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
C ---
      NAMES='trfn_f2.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_ph2.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_f2_pk.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_ph2_pk.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_fo.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_pho.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_fo_pk.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_pho_pk.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)

      NAMES='trfn_fc.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_phc.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_mon.crd'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_scr.crd'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_scr1.crd'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_scr2.crd'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_scr3.crd'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_fon.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_f2n.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_fn.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_fon.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_f2n.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_fn.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_f12.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_ph12.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_f12_pk.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_ph12_pk.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='molrp_scratch_rft'
      CALL DELETE_FILE(PATH_SCR,NAMES)
C --
      RETURN
      END

      SUBROUTINE TRFUN_STORE_SCORE(IPK,CORR,NSCORE,SCORE_STOR
     *     ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
     *     ,IPEAK_NUMB_STOR
     *     ,TC_AVER,TC_AVER2,NC_NAVER
     *     ,SCORE_MAX,NSCORE_MAX)
C -------------------------
      REAL      SCORE_STOR(NSCORE_MAX)
      REAL      SCORE_AVER(NSCORE_MAX)
      REAL      SCORE_AVER2(NSCORE_MAX)
      INTEGER   ISCORE_NUMB(NSCORE_MAX)
      INTEGER   IPEAK_NUMB_STOR(NSCORE_MAX)
C -------------------------
C         WRITE(*,*) '///',CORR,ipk,NC_NAVER

      IF(CORR.LE.-1.0) RETURN
      IF(NC_NAVER.LE.0) RETURN

      CORRS = CORR + 1.0
      IF(NSCORE.LE.0) THEN
        NSCORE              = NSCORE + 1
        SCORE_STOR(NSCORE)  = CORRS
        SCORE_AVER (NSCORE) = TC_AVER
        SCORE_AVER2(NSCORE) = TC_AVER2
        ISCORE_NUMB(NSCORE) = NC_NAVER
        IPEAK_NUMB_STOR(NSCORE) = IPK
        SCORE_MAX           = CORR
        RETURN
      ELSE

        IF(NSCORE.GE.NSCORE_MAX) THEN 
          IF(CORRS.LE.SCORE_STOR(1)) THEN
            SCORE_MAX     = SCORE_STOR(NSCORE) -1.0
            RETURN
          ENDIF
          SCORE_STOR(1)  = CORRS
          SCORE_AVER (1) = TC_AVER
          SCORE_AVER2(1) = TC_AVER2
          ISCORE_NUMB(1) = NC_NAVER
          IPEAK_NUMB_STOR(1) = IPK
        ELSE  
          NSCORE        = NSCORE + 1
          SCORE_STOR(NSCORE)  = CORRS
          SCORE_AVER (NSCORE) = TC_AVER
          SCORE_AVER2(NSCORE) = TC_AVER2
          ISCORE_NUMB(NSCORE) = NC_NAVER
          IPEAK_NUMB_STOR(NSCORE) = IPK
          IF(SCORE_STOR(NSCORE-1).LE.CORRS) THEN
            SCORE_MAX     = SCORE_STOR(NSCORE) -1.0
            RETURN
          ENDIF
        ENDIF
        CALL SORT4(SCORE_STOR,NSCORE
     *          ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
     *          ,IPEAK_NUMB_STOR)
        SCORE_MAX  = SCORE_STOR(NSCORE) - 1.0
      ENDIF

C      if(nscore.gt.0) then
C      write(*,*) '////////////'
C      DO I=NSCORE,1,-1
C        IPK_I = IPEAK_NUMB_STOR(I)
C        WRITE(*,*) I,') ',IPK_I,SCORE_STOR(I),ISCORE_NUMB(I)
C      ENDDO     
C      write(*,*) '////////////'
C      endif
C ---
      RETURN
      END

      SUBROUTINE TRFUN_STORE_SCORE_o(IPK,CORR,NSCORE,SCORE_STOR
     *     ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
     *     ,IPEAK_NUMB_STOR
     *     ,TC_AVER,TC_AVER2,NC_NAVER
     *     ,SCORE_MAX,NSCORE_MAX)
C -------------------------
      REAL      SCORE_STOR(NSCORE_MAX)
      REAL      SCORE_AVER(NSCORE_MAX)
      REAL      SCORE_AVER2(NSCORE_MAX)
      INTEGER   ISCORE_NUMB(NSCORE_MAX)
      INTEGER   IPEAK_NUMB_STOR(NSCORE_MAX)
C -------------------------
c      IF(NSCORE.GE.10) THEN
c       DO I=1,10
c         WRITE(*,*) '==',I,SCORE_STOR(I),score_max
c       ENDDO
c      ENDIF

      IF(CORR.LE.-1.0) RETURN

      IF(NSCORE.LE.0) THEN
        NSCORE              = NSCORE + 1
        SCORE_STOR(NSCORE)  = CORR
        SCORE_AVER (NSCORE) = TC_AVER
        SCORE_AVER2(NSCORE) = TC_AVER2
        ISCORE_NUMB(NSCORE) = NC_NAVER
        IPEAK_NUMB_STOR(NSCORE) = IPK
        SCORE_MAX           = CORR
        RETURN
      ELSE

        IF(NSCORE.GE.NSCORE_MAX) THEN 
          IF(CORR.LE.SCORE_STOR(1)) THEN
            SCORE_MAX     = SCORE_STOR(NSCORE)
            RETURN
          ENDIF
          SCORE_STOR(1)  = CORR
          SCORE_AVER (1) = TC_AVER
          SCORE_AVER2(1) = TC_AVER2
          ISCORE_NUMB(1) = NC_NAVER
          IPEAK_NUMB_STOR(1) = IPK
        ELSE  
          NSCORE        = NSCORE + 1
          SCORE_STOR(NSCORE)  = CORR
          SCORE_AVER (NSCORE) = TC_AVER
          SCORE_AVER2(NSCORE) = TC_AVER2
          ISCORE_NUMB(NSCORE) = NC_NAVER
          IPEAK_NUMB_STOR(NSCORE) = IPK
          IF(SCORE_STOR(NSCORE-1).LE.CORR) THEN
            SCORE_MAX     = SCORE_STOR(NSCORE)
            RETURN
          ENDIF
        ENDIF
        CALL SORT4(SCORE_STOR,NSCORE
     *          ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
     *          ,IPEAK_NUMB_STOR)
        SCORE_MAX  = SCORE_STOR(NSCORE)
      ENDIF

C ---
      RETURN
      END

      SUBROUTINE DYAD_STORE_SCORE(CORR,NSCORE,SCORE_STOR
     *     ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
     *     ,TC_AVER,TC_AVER2,NC_NAVER
     *     ,SCORE_MAX,NSCORE_MAX)
C -------------------------
      REAL      SCORE_STOR(NSCORE_MAX)
      REAL      SCORE_AVER(NSCORE_MAX)
      REAL      SCORE_AVER2(NSCORE_MAX)
      INTEGER   ISCORE_NUMB(NSCORE_MAX)
C -------------------------
c      IF(NSCORE.GE.10) THEN
c       DO I=1,10
c         WRITE(*,*) '==',I,SCORE_STOR(I),score_max
c       ENDDO
c      ENDIF

      IF(CORR.LE.-1.0) RETURN

      IF(NSCORE.LE.0) THEN
        NSCORE              = NSCORE + 1
        SCORE_STOR(NSCORE)  = CORR + 1.0
        SCORE_AVER (NSCORE) = TC_AVER
        SCORE_AVER2(NSCORE) = TC_AVER2
        ISCORE_NUMB(NSCORE) = NC_NAVER
        SCORE_MAX           = CORR
        RETURN
      ELSE

        IF(NSCORE.GE.NSCORE_MAX) THEN 
          IF((CORR+1.0).LE.SCORE_STOR(1)) THEN
            SCORE_MAX     = SCORE_STOR(NSCORE) -1.0
            RETURN
          ENDIF
          SCORE_STOR(1)  = CORR + 1.0
          SCORE_AVER (1) = TC_AVER
          SCORE_AVER2(1) = TC_AVER2
          ISCORE_NUMB(1) = NC_NAVER
        ELSE  
          NSCORE        = NSCORE + 1
          SCORE_STOR(NSCORE)  = CORR + 1.0
          SCORE_AVER (NSCORE) = TC_AVER
          SCORE_AVER2(NSCORE) = TC_AVER2
          ISCORE_NUMB(NSCORE) = NC_NAVER
          IF(SCORE_STOR(NSCORE-1).LE.(CORR+1.0)) THEN
            SCORE_MAX     = SCORE_STOR(NSCORE) -1.0
            RETURN
          ENDIF
        ENDIF
        CALL SORT3(SCORE_STOR,NSCORE
     *          ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB)
        SCORE_MAX  = SCORE_STOR(NSCORE) - 1.0
      ENDIF

      RETURN

c      IF(NSCORE.LE.0) THEN
c        NSCORE        = NSCORE + 1
c        SCORE_STOR(NSCORE)  = CORR
c        SCORE_AVER (NSCORE) = TC_AVER
c        SCORE_AVER2(NSCORE) = TC_AVER2
c        ISCORE_NUMB(NSCORE) = NC_NAVER
c        SCORE_MAX     = CORR
c        RETURN
c      ELSE

c        IF(CORR.LT.SCORE_STOR(NSCORE)) THEN
c          IF(NSCORE.LT.NSCORE_MAX) THEN
c            NSCORE = NSCORE + 1
c            SCORE_STOR(NSCORE) = CORR
c            SCORE_AVER (NSCORE) = TC_AVER
c            SCORE_AVER2(NSCORE) = TC_AVER2
c            ISCORE_NUMB(NSCORE) = NC_NAVER
c          ENDIF
c          RETURN
c        ENDIF

c        IF(CORR.GT.SCORE_STOR(NSCORE)) THEN
c          IADD = 1
c          IF(NSCORE.GE.NSCORE_MAX) IADD = 0 
c          DO I=NSCORE,1,-1
c            IF(CORR.GT.SCORE_STOR(I)) THEN
c              IF(I.LT.NSCORE_MAX) THEN
c                SCORE_STOR (I+1) = SCORE_STOR(I)
c                SCORE_AVER (I+1) = SCORE_AVER (I)
c                SCORE_AVER2(I+1) = SCORE_AVER2(I)
c                ISCORE_NUMB(I+1) = ISCORE_NUMB(I)
c              ENDIF
c            ELSE
c              IF(I.LT.NSCORE_MAX) THEN
c                SCORE_STOR (I+1) = CORR
c                SCORE_AVER (I+1) = TC_AVER
c                SCORE_AVER2(I+1) = TC_AVER2
c                ISCORE_NUMB(I+1) = NC_NAVER
c                GO TO 100
c              ENDIF
c            ENDIF           
c          ENDDO
c          SCORE_STOR (1) = CORR
c          SCORE_AVER (1) = TC_AVER
c          SCORE_AVER2(1) = TC_AVER2
c          ISCORE_NUMB(1) = NC_NAVER
c          SCORE_MAX     = CORR
c 100      CONTINUE
c          NSCORE = NSCORE + IADD
c        ENDIF
c      ENDIF
C ---
      RETURN
      END
                    
      SUBROUTINE FINAL_MESSAGE(MDOC,CONTRAST,CORR_MAX)
C -------------------------
      INCLUDE 'molrep_lh_infor.fh'
C      COMMON/COM_LH_INFOR/ BOFF_LH,BADD_LH,BOFF_FOR_SCAL
C     *   ,CHECK_CONTRAST,CONTRAST_LIM
C     *   ,BCORR_LH,FILE_FOBS_LH,SCORE_FLAG,LH_LH,DB_LH 
CC ---
C      REAL      CHECK_CONTRAST,CONTRAST_LIM
C      REAL      BOFF_FOR_SCAL,BOFF_LH,BADD_LH,BCORR_LH
C      CHARACTER LH_LH*1,SCORE_FLAG*1,DB_LH*1
C      CHARACTER FILE_FOBS_LH*256
C ----------------------------------
C ---
      INTEGER   MDOC
      REAL      CORR_MAX,CONTRAST
      CHARACTER LINE*256
C -------------------------
      CHECK_CONTRAST2 = CHECK_CONTRAST*1.16
      IF(CONTRAST.LT.CHECK_CONTRAST2.AND.
     *   CONTRAST.GE.CHECK_CONTRAST      ) THEN
        LINE = 'INFO: maybe it is solution, but maybe not'
        CALL MSGDOC(MDOC,LINE)
      ELSE IF(CONTRAST.LT.CHECK_CONTRAST) THEN
        CORR_MAX = -2.0
        LINE = 'INFO: contrast < contrast_limit, probably'//
     *           ' it is not solution.'          
        CALL MSGDOC(MDOC,LINE)
        LINE = '      Turn off scoring system,'//
     *         ' if you like (keyword SCORE N)'
        CALL MSGDOC(MDOC,LINE)
      ENDIF
C ---
      RETURN
      END

      SUBROUTINE TRFUN_CONTRAST(MDOC,NUM_MON,NMON,NR_SYM,CNTR_NEW
     *   ,CORR,CONTRAST,NSCORE,NSCORE_NEW
     *   ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
     *   ,IPEAK_NUMB_STOR,IPEAK_INDEX_STOR
     *   ,SCORE_STOR,NSCORE_MAX
     *   ,DIST_LIM,RMS_LIM
     *   ,TALPHA,TGAMMA,TBETA,NSYM,ISYM,IPRSYM)
C -------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      TALPHA(*),TGAMMA(*),TBETA(*)
      REAL      SCORE_STOR(NSCORE_MAX)
      REAL      SCORE_AVER(NSCORE_MAX)
      REAL      SCORE_AVER2(NSCORE_MAX)
      INTEGER   ISCORE_NUMB(NSCORE_MAX)
      INTEGER   IPEAK_NUMB_STOR(NSCORE_MAX)
      INTEGER   IPEAK_INDEX_STOR(NSCORE_MAX)
      CHARACTER LINE*256,CHECK_RMS*1
      REAL      FRTOCR(3,3),CRTOFR(3,3)
C -------------------------
      INCLUDE 'molrep_lh_infor.fh'
C      COMMON/COM_LH_INFOR/ BOFF_LH,BADD_LH,BOFF_FOR_SCAL
C     *   ,CHECK_CONTRAST,CONTRAST_LIM
C     *   ,BCORR_LH,FILE_FOBS_LH,SCORE_FLAG,LH_LH,DB_LH 
CC ---
CC ---
C      REAL      CHECK_CONTRAST,CONTRAST_LIM
C      REAL      BOFF_FOR_SCAL,BOFF_LH,BADD_LH,BCORR_LH
C      CHARACTER LH_LH*1,SCORE_FLAG*1,DB_LH*1
C      CHARACTER FILE_FOBS_LH*256
C ----------------------------------
c///
c       REAL DIST_STOR(1000)
c       REAL RMS_STOR(1000)
c///      
C -------------------------
      CHECK_RMS = ' '
      CONTRAST = 0.0
      CNTR_NEW = 0.0
      DLIM     = DIST_LIM
      NSCORE_NEW = NSCORE
      IF(NSCORE.LE.1) RETURN

      CALL GET_CR_MATRIX(FRTOCR,CRTOFR)

      NSCORE_NEW = 1
      IPEAK_INDEX_STOR(1) = NSCORE

C///
c      WRITE(*,*) '--- MAX:',IPEAK_NUMB_STOR(NSCORE),CORR,NSCORE  
c      DO I=NSCORE,1,-1
c        IPK_I = IPEAK_NUMB_STOR(I)
c        WRITE(*,*) I,') ',IPK_I,SCORE_STOR(I)
c      ENDDO     
c      WRITE(*,*) '--- '
C ///

      IF(NSCORE.GE.2) THEN
      DO I=NSCORE-1,1,-1
        IPK_I = IPEAK_NUMB_STOR(I)
c///
c        DIST_MIN = 1001.0
c        RMS_MIN  = 1000.1
c        I_MIN    = 0
c///
        DO J=1,NSCORE_NEW
          JJ = IPEAK_INDEX_STOR(J)
          IPK_J = IPEAK_NUMB_STOR(JJ)
C         check distance 
          IF(CHECK_RMS.NE.'Y') THEN
            CALL CALC_ORIENTION_DIST(IPK_I,IPK_J,FRTOCR,CRTOFR
     *       ,TALPHA,TGAMMA,TBETA,NSYM,ISYM,IPRSYM,DIST)
          ENDIF
          IF(CHECK_RMS.NE.'N') THEN
            CALL CALC_ORIENTION_RMS(IPK_I,IPK_J,FRTOCR,CRTOFR
     *      ,TALPHA,TGAMMA,TBETA,NSYM,ISYM,IPRSYM,RMS)
            IF(RMS.GT.1000.0) THEN
              CHECK_RMS = 'N'
            ELSE
              CHECK_RMS = 'Y'
              DLIM      = RMS_LIM
              DIST      = RMS
            ENDIF
          ENDIF

cc          WRITE(*,*) IPK_I,IPK_J,DIST,RMS,CHECK_RMS

c///
c          IF(DIST.LT.DIST_MIN) THEN
c            DIST_MIN = DIST
c            RMS_MIN = RMS
c            I_MIN = JJ
c          ENDIF
c///

          IF(DIST.LE.DLIM) THEN

CCC        WRITE(*,*) 'OUT-->:',IPK_I,IPK_J,DIST,RMS

            GO TO 200
          ENDIF
        ENDDO
        NSCORE_NEW =  NSCORE_NEW + 1
        IPEAK_INDEX_STOR(NSCORE_NEW) = I
c///
c        DIST_STOR(NSCORE_NEW) = DIST_MIN
c        RMS_STOR(NSCORE_NEW) = RMS_MIN
c///
CCC      WRITE(*,*) NSCORE_NEW,'-->:',IPK_I,DIST_MIN,RMS_MIN,I_MIN


 200    CONTINUE

c        WRITE(*,*) NSCORE_NEW,'-->:',IPK_I,DIST_MIN,RMS_MIN,I_MIN

      ENDDO

      IF(NSCORE_NEW.LE.1) RETURN

      ENDIF

      CORRB  = CORR 
      NP     = (NMON - NUM_MON) * NR_SYM 

C ///
c      WRITE(*,*) '--- ',CHECK_RMS,RMS_LIM
c      WRITE(*,*) '===NSCORE_NEW,NP:',NSCORE_NEW,NP,NR_SYM
c      DO II=1,NSCORE_NEW
c        JJ = IPEAK_INDEX_STOR(II)
c        IPK_J = IPEAK_NUMB_STOR(JJ)
c        SCOREI = SCORE_STOR(JJ) 
c        WRITE(*,*) II,') ',IPK_J,SCOREI
c      ENDDO
c      WRITE(*,*) '--- '
C ///

c      NW_TEST = 3*NR_SYM
c      NW_TEST = 2*NR_SYM
      NW_TEST = 5
      NW_TEST = 3
      NW_TEST = 2
      NW_TEST = 1

c      NW_LIM  = NP + NW_TEST
      NW_LIM  = NP + NR_SYM*3
      NW_LIM  = NP + NR_SYM*2

      IF(NW_LIM.GT.20.AND.NP.LT.18) THEN
        NW_LIM = 20
      ENDIF

      NW_TEST_MAX = NW_TEST*8

      IF(NSCORE_NEW.LT.NW_LIM) RETURN

      AVER  = 0.0
      AVER2 = 0.0
      SIGMA = 0.0
      NN    = 0

      NN_MAX = NP*NR_SYM*2
      IF(NN_MAX.LT.10) NN_MAX = 10
      ILAST = NP + NN_MAX     
      IF(ILAST.GT.NSCORE_NEW) ILAST = NSCORE_NEW

C     ILAST = NSCORE_NEW
C     DO I=1,NSCORE-NP
C     DO II=NP+1,NSCORE_NEW

      DO II=NP+1,ILAST

        I = IPEAK_INDEX_STOR(II)

c       WRITE(*,*) '--',I,SCORE_STOR(I),SCORE_AVER(I),ISCORE_NUMB(I)

        AVER  = AVER  + SCORE_AVER(I) 
        AVER2 = AVER2 + SCORE_AVER2(I)
        NN    = NN    + ISCORE_NUMB(I)
      ENDDO

      IF(NN.GT.0) THEN
        AVER   = AVER /FLOAT(NN)
        AVER2  = AVER2/FLOAT(NN)
        SIGMA  = SQRT(ABS(AVER2-AVER*AVER))
      ENDIF

      IF(SIGMA.GT.0.0001) THEN
        CNTR_NEW = ABS(CORRB-AVER)/SIGMA
C        WRITE(LINE,'(''ContrastN = '',F8.2)') CNTR_NEW
c        CALL MSGDOC(MDOC,LINE)    
      ENDIF
C ----
      SUMCW  = 0.0
      SUMW   = 0.0 
      NW     = 0
      III    = 0
C      DO I=NSCORE-NP,1,-1
      DO II=NP+1,NSCORE_NEW
          I = IPEAK_INDEX_STOR(II)
          SCOREI = SCORE_STOR(I)  - 1.0 - AVER 
          IF(SCOREI.GT.0.0) THEN
            III = III + 1
            IT  = (III-1)/NR_SYM + 1
            W = 1.0/FLOAT(IT)
            SUMCW = SUMCW + SCOREI*W
            SUMW  = SUMW  + W
            NW    = NW    + 1
            IF(NW.GE.NW_TEST_MAX) GO TO 100
          ENDIF
      ENDDO
 100  CONTINUE

      IF(NW.GE.NW_TEST.AND.ABS(SUMW).GT.0.0001) THEN
        T  = ABS(SUMCW/SUMW)
        TT = ABS(CORRB-AVER)
        
c ////
c        j = IPEAK_INDEX_STOR(NP+1)
c        ttt =  SCORE_STOR(j) -1.0
c        write(*,*) '==',NW,TT,T,CORRB,AVER
c        write(*,*) '==',NP,SUMCW,SUMW,ttt
c /// 

        IF(T.GT.0.0001) THEN
          CONTRAST = TT/T
          WRITE(LINE,'(''Contrast = '',F8.3)') CONTRAST
          CALL MSGDOC(MDOC,LINE)    
        ENDIF
      ENDIF

C ---
      RETURN
      END

      SUBROUTINE TRFUN_CONTRAST_o(MDOC,NUM_MON,NMON,NR_SYM,CNTR_NEW
     *   ,CORR,CONTRAST,NSCORE,NSCORE_NEW
     *   ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
     *   ,IPEAK_NUMB_STOR,IPEAK_INDEX_STOR
     *   ,SCORE_STOR,NSCORE_MAX
     *   ,DIST_LIM,RMS_LIM
     *   ,TALPHA,TGAMMA,TBETA,NSYM,ISYM,IPRSYM)
C -------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      TALPHA(*),TGAMMA(*),TBETA(*)
      REAL      SCORE_STOR(NSCORE_MAX)
      REAL      SCORE_AVER(NSCORE_MAX)
      REAL      SCORE_AVER2(NSCORE_MAX)
      INTEGER   ISCORE_NUMB(NSCORE_MAX)
      INTEGER   IPEAK_NUMB_STOR(NSCORE_MAX)
      INTEGER   IPEAK_INDEX_STOR(NSCORE_MAX)
      CHARACTER LINE*256,CHECK_RMS*1
      REAL      FRTOCR(3,3),CRTOFR(3,3)
C -------------------------
      INCLUDE 'molrep_lh_infor.fh'
C      COMMON/COM_LH_INFOR/ BOFF_LH,BADD_LH,BOFF_FOR_SCAL
C     *   ,CHECK_CONTRAST,CONTRAST_LIM
C     *   ,BCORR_LH,FILE_FOBS_LH,SCORE_FLAG,LH_LH,DB_LH 
CC ---
CC ---
C      REAL      CHECK_CONTRAST,CONTRAST_LIM
C      REAL      BOFF_FOR_SCAL,BOFF_LH,BADD_LH,BCORR_LH
C      CHARACTER LH_LH*1,SCORE_FLAG*1,DB_LH*1
C      CHARACTER FILE_FOBS_LH*256
C ----------------------------------
c///
c       REAL DIST_STOR(1000)
c       REAL RMS_STOR(1000)
c///      
C -------------------------
      CHECK_RMS = ' '
      CONTRAST = 0.0
      CNTR_NEW = 0.0
      DLIM     = DIST_LIM
      NSCORE_NEW = NSCORE
      IF(NSCORE.LE.1) RETURN

      CALL GET_CR_MATRIX(FRTOCR,CRTOFR)

      NSCORE_NEW = 1
      IPEAK_INDEX_STOR(1) = NSCORE

C///
c      WRITE(*,*) '--- MAX:',IPEAK_NUMB_STOR(NSCORE),CORR,NSCORE  
c      DO I=NSCORE,1,-1
c        IPK_I = IPEAK_NUMB_STOR(I)
c        WRITE(*,*) I,') ',IPK_I,SCORE_STOR(I)
c      ENDDO     
c      WRITE(*,*) '--- '
C ///

      IF(NSCORE.GE.2) THEN
      DO I=NSCORE-1,1,-1
        IPK_I = IPEAK_NUMB_STOR(I)
c///
c        DIST_MIN = 1001.0
c        RMS_MIN  = 1000.1
c        I_MIN    = 0
c///
        DO J=1,NSCORE_NEW
          JJ = IPEAK_INDEX_STOR(J)
          IPK_J = IPEAK_NUMB_STOR(JJ)
C         check distance 
          IF(CHECK_RMS.NE.'Y') THEN
            CALL CALC_ORIENTION_DIST(IPK_I,IPK_J,FRTOCR,CRTOFR
     *       ,TALPHA,TGAMMA,TBETA,NSYM,ISYM,IPRSYM,DIST)
          ENDIF
          IF(CHECK_RMS.NE.'N') THEN
            CALL CALC_ORIENTION_RMS(IPK_I,IPK_J,FRTOCR,CRTOFR
     *      ,TALPHA,TGAMMA,TBETA,NSYM,ISYM,IPRSYM,RMS)
            IF(RMS.GT.1000.0) THEN
              CHECK_RMS = 'N'
            ELSE
              CHECK_RMS = 'Y'
              DLIM      = RMS_LIM
              DIST      = RMS
            ENDIF
          ENDIF

cc          WRITE(*,*) IPK_I,IPK_J,DIST,RMS,CHECK_RMS

c///
c          IF(DIST.LT.DIST_MIN) THEN
c            DIST_MIN = DIST
c            RMS_MIN = RMS
c            I_MIN = JJ
c          ENDIF
c///

          IF(DIST.LE.DLIM) THEN

CCC        WRITE(*,*) 'OUT-->:',IPK_I,IPK_J,DIST,RMS

            GO TO 200
          ENDIF
        ENDDO
        NSCORE_NEW =  NSCORE_NEW + 1
        IPEAK_INDEX_STOR(NSCORE_NEW) = I
c///
c        DIST_STOR(NSCORE_NEW) = DIST_MIN
c        RMS_STOR(NSCORE_NEW) = RMS_MIN
c///
CCC      WRITE(*,*) NSCORE_NEW,'-->:',IPK_I,DIST_MIN,RMS_MIN,I_MIN


 200    CONTINUE

c        WRITE(*,*) NSCORE_NEW,'-->:',IPK_I,DIST_MIN,RMS_MIN,I_MIN

      ENDDO

      IF(NSCORE_NEW.LE.1) RETURN

      ENDIF

      CORRB  = CORR 
      NP     = (NMON - NUM_MON) * NR_SYM 

C ///
c      WRITE(*,*) '--- ',CHECK_RMS,RMS_LIM
c      WRITE(*,*) '===NSCORE_NEW,NP:',NSCORE_NEW,NP,NR_SYM
c      DO II=1,NSCORE_NEW
c        JJ = IPEAK_INDEX_STOR(II)
c        IPK_J = IPEAK_NUMB_STOR(JJ)
c        SCOREI = SCORE_STOR(JJ) 
c        WRITE(*,*) II,') ',IPK_J,DIST_STOR(II),SCOREI
c      ENDDO
c      WRITE(*,*) '--- '
C ///

c      NW_TEST = 3*NR_SYM
c      NW_TEST = 2*NR_SYM
      NW_TEST = 5
      NW_TEST = 3
      NW_TEST = 2
      NW_TEST = 1

c      NW_LIM  = NP + NW_TEST
      NW_LIM  = NP + NR_SYM*3
      NW_LIM  = NP + NR_SYM*2

      IF(NW_LIM.GT.20.AND.NP.LT.18) THEN
        NW_LIM = 20
      ENDIF

      NW_TEST_MAX = NW_TEST*8

C      write(*,*) 'np,NW_TEST,NW_LIM,nsc:',np,NW_TEST,NW_LIM,NSCORE

      IF(NSCORE_NEW.LT.NW_LIM) RETURN

      AVER  = 0.0
      AVER2 = 0.0
      SIGMA = 0.0
      NN    = 0

C     DO I=1,NSCORE-NP
      DO II=NP+1,NSCORE_NEW
        I = IPEAK_INDEX_STOR(II)

C      WRITE(*,*) '--',I,SCORE_STOR(I),SCORE_AVER(I),ISCORE_NUMB(I)

        AVER  = AVER  + SCORE_AVER(I)
        AVER2 = AVER2 + SCORE_AVER2(I)
        NN    = NN    + ISCORE_NUMB(I)
      ENDDO

      IF(NN.GT.0) THEN
        AVER   = AVER /FLOAT(NN)
        AVER2  = AVER2/FLOAT(NN)
        SIGMA  = SQRT(ABS(AVER2-AVER*AVER))
C        WRITE(*,*) '-->nn,AVER',NN,AVER
      ENDIF

      IF(SIGMA.GT.0.0001) THEN
        CNTR_NEW = ABS(CORRB-AVER)/SIGMA
c        WRITE(LINE,'(''ContrastN = '',F8.2)') CNTR_NEW
c        CALL MSGDOC(MDOC,LINE)    
      ENDIF
C ----
      SUMCW  = 0.0
      SUMW   = 0.0 
      NW     = 0
      III    = 0
C      DO I=NSCORE-NP,1,-1
      DO II=NP+1,NSCORE_NEW
          I = IPEAK_INDEX_STOR(II)
          SCOREI = SCORE_STOR(I) - AVER 
          IF(SCOREI.GT.0.0) THEN
c            SCOREI = SCORE_STOR(I) - AVER 
            III = III + 1
            IT  = (III-1)/NR_SYM + 1
            W = 1.0/FLOAT(IT)
            SUMCW = SUMCW + SCOREI*W
            SUMW  = SUMW  + W
            NW    = NW    + 1
            IF(NW.GE.NW_TEST_MAX) GO TO 100
          ENDIF
      ENDDO
 100  CONTINUE

      IF(NW.GE.NW_TEST.AND.ABS(SUMW).GT.0.0001) THEN
        T = SUMCW/SUMW
        IF(ABS(T).GT.0.0001) THEN
          CONTRAST = ABS(CORRB-AVER)/ABS(T)
          WRITE(LINE,'(''Contrast = '',F8.3)') CONTRAST
          CALL MSGDOC(MDOC,LINE)    
        ENDIF
      ENDIF

C      write(*,*) 'NW,NW_TEST,CNTR:',nW,NW_TEST,nscore,CONTRAST
C      write(*,*) 'AVER,CORRB:',aver,corrb
C ---
      RETURN
      END

      SUBROUTINE TRFUN_CONTRAST_new(MDOC,NUM_MON,NMON,NR_SYM,CNTR_NEW
     *   ,CORR,CONTRAST,NSCORE,NSCORE_NEW
     *   ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
     *   ,IPEAK_NUMB_STOR,IPEAK_INDEX_STOR
     *   ,SCORE_STOR,NSCORE_MAX
     *   ,DIST_LIM,RMS_LIM
     *   ,TALPHA,TGAMMA,TBETA,NSYM,ISYM,IPRSYM)
C -------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      TALPHA(*),TGAMMA(*),TBETA(*)
      REAL      SCORE_STOR(NSCORE_MAX)
      REAL      SCORE_AVER(NSCORE_MAX)
      REAL      SCORE_AVER2(NSCORE_MAX)
      INTEGER   ISCORE_NUMB(NSCORE_MAX)
      INTEGER   IPEAK_NUMB_STOR(NSCORE_MAX)
      INTEGER   IPEAK_INDEX_STOR(NSCORE_MAX)
      CHARACTER LINE*256,CHECK_RMS*1
      REAL      FRTOCR(3,3),CRTOFR(3,3)
C -------------------------
      INCLUDE 'molrep_lh_infor.fh'
C      COMMON/COM_LH_INFOR/ BOFF_LH,BADD_LH,BOFF_FOR_SCAL
C     *   ,CHECK_CONTRAST,CONTRAST_LIM
C     *   ,BCORR_LH,FILE_FOBS_LH,SCORE_FLAG,LH_LH,DB_LH 
CC ---
CC ---
C      REAL      CHECK_CONTRAST,CONTRAST_LIM
C      REAL      BOFF_FOR_SCAL,BOFF_LH,BADD_LH,BCORR_LH
C      CHARACTER LH_LH*1,SCORE_FLAG*1,DB_LH*1
C      CHARACTER FILE_FOBS_LH*256
C ----------------------------------
c///
c       REAL DIST_STOR(1000)
c       REAL RMS_STOR(1000)
c///      
C -------------------------
      CHECK_RMS = ' '
      CONTRAST = 0.0
      CNTR_NEW = 0.0
      DLIM     = DIST_LIM
      NSCORE_NEW = NSCORE
      IF(NSCORE.LE.1) RETURN

      CALL GET_CR_MATRIX(FRTOCR,CRTOFR)

      NSCORE_NEW = 1
      IPEAK_INDEX_STOR(1) = NSCORE

C///
      WRITE(*,*) '--- MAX:',IPEAK_NUMB_STOR(NSCORE),CORR,NSCORE  
      DO I=NSCORE,1,-1
        IPK_I = IPEAK_NUMB_STOR(I)
        WRITE(*,*) I,') ',IPK_I,SCORE_STOR(I),ISCORE_NUMB(I)
      ENDDO     
      WRITE(*,*) '--- '
C ///

      IF(NSCORE.GE.2) THEN
      DO I=NSCORE-1,1,-1
        IPK_I = IPEAK_NUMB_STOR(I)
c///
c        DIST_MIN = 1001.0
c        RMS_MIN  = 1000.1
c        I_MIN    = 0
c///
        DO J=1,NSCORE_NEW
          JJ = IPEAK_INDEX_STOR(J)
          IPK_J = IPEAK_NUMB_STOR(JJ)
C         check distance 
          IF(CHECK_RMS.NE.'Y') THEN
            CALL CALC_ORIENTION_DIST(IPK_I,IPK_J,FRTOCR,CRTOFR
     *       ,TALPHA,TGAMMA,TBETA,NSYM,ISYM,IPRSYM,DIST)
          ENDIF
          IF(CHECK_RMS.NE.'N') THEN
            CALL CALC_ORIENTION_RMS(IPK_I,IPK_J,FRTOCR,CRTOFR
     *      ,TALPHA,TGAMMA,TBETA,NSYM,ISYM,IPRSYM,RMS)
            IF(RMS.GT.1000.0) THEN
              CHECK_RMS = 'N'
            ELSE
              CHECK_RMS = 'Y'
              DLIM      = RMS_LIM
              DIST      = RMS
            ENDIF
          ENDIF

cc          WRITE(*,*) IPK_I,IPK_J,DIST,RMS,CHECK_RMS

c///
c          IF(DIST.LT.DIST_MIN) THEN
c            DIST_MIN = DIST
c            RMS_MIN = RMS
c            I_MIN = JJ
c          ENDIF
c///

          IF(DIST.LE.DLIM) THEN

CCC        WRITE(*,*) 'OUT-->:',IPK_I,IPK_J,DIST,RMS

            GO TO 200
          ENDIF
        ENDDO
        NSCORE_NEW =  NSCORE_NEW + 1
        IPEAK_INDEX_STOR(NSCORE_NEW) = I

c///
c        DIST_STOR(NSCORE_NEW) = DIST_MIN
c        RMS_STOR(NSCORE_NEW) = RMS_MIN
c///
CCC      WRITE(*,*) NSCORE_NEW,'-->:',IPK_I,DIST_MIN,RMS_MIN,I_MIN


 200    CONTINUE

c        WRITE(*,*) NSCORE_NEW,'-->:',IPK_I,DIST_MIN,RMS_MIN,I_MIN

      ENDDO

      IF(NSCORE_NEW.LE.1) RETURN

      ENDIF

      CORRB  = CORR 
      NP     = (NMON - NUM_MON) * NR_SYM 

C ///
c      WRITE(*,*) '--- ',CHECK_RMS,RMS_LIM
       WRITE(*,*) '===NSCORE_NEW,NP,nr_sym:',NSCORE_NEW,NP,NR_SYM
      DO II=1,NSCORE_NEW
        JJ = IPEAK_INDEX_STOR(II)
        IPK_J = IPEAK_NUMB_STOR(JJ)
        SCOREI = SCORE_STOR(JJ) 
        WRITE(*,*) II,') ',jj,IPK_J,SCOREI
      ENDDO
      WRITE(*,*) '--- '
C ///

c      NW_TEST = 3*NR_SYM
c      NW_TEST = 2*NR_SYM
      NW_TEST = 5
      NW_TEST = 3
      NW_TEST = 2
      NW_TEST = 1

c      NW_LIM  = NP + NW_TEST
      NW_LIM  = NP + NR_SYM*3
      NW_LIM  = NP + NR_SYM*2

      IF(NW_LIM.GT.20.AND.NP.LT.18) THEN
        NW_LIM = 20
      ENDIF

      NW_TEST_MAX = NW_TEST*8

C      write(*,*) 'np,NW_TEST,NW_LIM,nsc:',np,NW_TEST,NW_LIM,NSCORE

      IF(NSCORE_NEW.LT.NW_LIM) RETURN
      IF((NSCORE_NEW - NP).LT.5) RETURN

      AVERS = 0.0
      AVER  = 0.0
      AVER2S= 0.0
      AVER2 = 0.0
      SIGMA = 0.0
      SIGMAS= 0.0
      NN    = 0
      NNN   = 0
C     DO I=1,NSCORE-NP
      DO II=NP+1,NSCORE_NEW

        I = IPEAK_INDEX_STOR(II)

      WRITE(*,*)'-s,a,i:',I
     *  ,SCORE_STOR(I),SCORE_AVER(I),SCORE_AVER2(I),ISCORE_NUMB(I)

        AVERS = AVERS  + SCORE_STOR(I) - 1.0  
C        AVER  = AVER  + SCORE_AVER(I)*ISCORE_NUMB(I)  
        AVER  = AVER  + SCORE_AVER(I)  
        AVER2S= AVER2S + 
     *          (SCORE_STOR(I) - 1.0)*(SCORE_STOR(I) - 1.0)
C        AVER2 = AVER2 + SCORE_AVER2(I)*ISCORE_NUMB(I)
c        AVER2 = AVER2 + SCORE_AVER2(I)
        AVER2 = AVER2 + SCORE_AVER(I)*SCORE_AVER(I)
C        NN    = NN    + ISCORE_NUMB(I)
        NN    = NN    + 1
        NNN   = NNN    + 1
C        AVER  = AVER  + SCORE_AVER(I)  
C        AVER2 = AVER2 + SCORE_AVER2(I)
C        NN    = NN    + ISCORE_NUMB(I)
      ENDDO

      IF(NN.GT.0) THEN
        AVERS  = AVERS/FLOAT(NNN)
        AVER   = AVER /FLOAT(NN)
        AVER2S = AVER2S/FLOAT(NNN)
        AVER2  = AVER2/FLOAT(NN)
        SIGMA  = SQRT(ABS(AVER2-AVER*AVER))
        SIGMAS  = SQRT(ABS(AVER2S-AVERS*AVERS))

        WRITE(*,*) '-->nn,AVER,S,sigma,S',NN,AVER,AVERS,SIGMA,SIGMAS

      ENDIF

      IF(SIGMA.GT.0.0001) THEN

        CNTR_NEW = ABS(CORRB-AVER)/SIGMA

        WRITE(*,'(''ContrastN = '',F8.2)') CNTR_NEW

c        WRITE(LINE,'(''ContrastN = '',F8.2)') CNTR_NEW
c        CALL MSGDOC(MDOC,LINE)    
      ENDIF
C ----
      SUMCW  = 0.0
      SUMW   = 0.0 
      NW     = 0
      III    = 0
C     DO I=NSCORE-NP,1,-1
      DO II=NP+1,NSCORE_NEW
          I = IPEAK_INDEX_STOR(II)

          SCOREI = SCORE_STOR(I) - 1.0  - AVER
c         SCOREI = SCORE_STOR(I) - 1.0  - AVERS
          IF(SCOREI.GT.0.0) THEN
            III = III + 1
            IT  = (III-1)/NR_SYM + 1
            W = 1.0/FLOAT(IT)
            SUMCW = SUMCW + SCOREI*W
            SUMW  = SUMW  + W
            NW    = NW    + 1

           write(*,*) '>>',ii,')',nw,i,SCORE_STOR(I),aver

            IF(NW.GE.NW_TEST_MAX) GO TO 100
          ENDIF
      ENDDO
 100  CONTINUE

      write(*,*) '>>nw,sumw,SUMCW,nw_test',nw,sumw,SUMCW,nw_test

      IF(NW.GE.NW_TEST.AND.ABS(SUMW).GT.0.0001) THEN

        T  = ABS(SUMCW/SUMW)
        TT = ABS(CORRB-AVERS)

        write(*,*) '>>t,avers,corrb',t,avers,corrb,tt

        IF(T.GT.0.0001.AND.TT.GE.T) THEN
          CONTRAST_O = TT/T

        WRITE(*,'(''ContrastO = '',F8.3)') CONTRAST_O

c          WRITE(LINE,'(''Contrast = '',F8.3)') CONTRAST
c          CALL MSGDOC(MDOC,LINE)    

        ENDIF
      ENDIF

C      write(*,*) 'NW,NW_TEST,CNTR:',nW,NW_TEST,nscore,CONTRAST
C      write(*,*) 'AVER,CORRB,CONTRAST:',avers,corrb,CONTRAST

C ---
C ----
      SUMCW  = 0.0
      SUMW   = 0.0 
      NW     = 0
      III    = 0
      DO II=NP+1,NSCORE_NEW
          I = IPEAK_INDEX_STOR(II)
          SCOREI = CORRB - (SCORE_STOR(I) - 1.0)
          IF(SCOREI.GT.0.0) THEN
            III = III + 1
            IT  = (III-1)/NR_SYM + 1
            W = 1.0/FLOAT(IT)
            SUMCW = SUMCW + SCOREI*W
            SUMW  = SUMW  + W
            NW    = NW    + 1

           
           write(*,*) '>>',ii,')',nw,i,SCOREI,SCORE_STOR(I),CORRB

            IF(NW.GE.NW_TEST_MAX) GO TO 110
          ENDIF
      ENDDO
 110  CONTINUE

      write(*,*) '>>nw,sumw,SUMCW,nw_test',nw,sumw,SUMCW,nw_test

      IF(NW.GE.NW_TEST.AND.ABS(SUMW).GT.0.0001) THEN

        TT = ABS(SUMCW/SUMW)
        T = ABS(SIGMA)

        write(*,*) '>>tt/t,corrb',tt,t,corrb

        IF(T.GT.0.0001.AND.TT.GE.T) THEN
          CONTRAST = TT/T
        ELSE
          CONTRAST = 0.0
        ENDIF

        WRITE(*,'(''ContrastNN = '',F8.3)') CONTRAST

C          WRITE(LINE,'(''Contrast = '',F8.3)') CONTRAST
C          CALL MSGDOC(MDOC,LINE)    

      ENDIF

C      write(*,*) 'NW,NW_TEST,CNTR:',nW,NW_TEST,nscore,CONTRAST
C      write(*,*) 'AVER,CORRB,CONTRAST:',avers,corrb,CONTRAST

C ---
      RETURN
      END

      SUBROUTINE CALC_ORIENTION_DIST(I,J,FRTOCR,CRTOFR
     *       ,TALPHA,TGAMMA,TBETA,NSYM,ISYM,IPRSYM,DIST)
C -------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      TALPHA(*),TGAMMA(*),TBETA(*)
      REAL      AM1(3,3),AM2(3,3)
      REAL      FRTOCR(3,3),CRTOFR(3,3)
      REAL      AM3(3,3),AM4(3,3),AM5(3,3),SN(3,3),SYM(3,3)
C -------------------------
      PI    = 4.0*ATAN(1.0)
      A1 = (TALPHA(I)*PI)/180.0
      A2 = (TBETA(I)*PI)/180.0
      A3 = (TGAMMA(I)*PI)/180.0
C      WRITE(*,*) ' ANG1:',TALPHA(I),TBETA(I),TGAMMA(I) 
      B1 = (TALPHA(J)*PI)/180.0
      B2 = (TBETA(J)*PI)/180.0
      B3 = (TGAMMA(J)*PI)/180.0
C      WRITE(*,*) ' ANG2:',TALPHA(J),TBETA(J),TGAMMA(J)

      DIST = 1000.0
      CALL EULERM(A1,A2,A3,AM1)
      CALL EULERM(B1,B2,B3,AM2)
      DO JS=1,NSYM
        SYM(1,1) = ISYM(1,1,JS)
        SYM(2,1) = ISYM(2,1,JS)
        SYM(3,1) = ISYM(3,1,JS)
        SYM(1,2) = ISYM(1,2,JS)
        SYM(2,2) = ISYM(2,2,JS)
        SYM(3,2) = ISYM(3,2,JS)
        SYM(1,3) = ISYM(1,3,JS)
        SYM(2,3) = ISYM(2,3,JS)
        SYM(3,3) = ISYM(3,3,JS)
        CALL MATMLT(SYM,CRTOFR,AM3)
        CALL MATMLT(FRTOCR,AM3,SN)
        CALL MATMLT(SN,AM1,AM3)
        CALL INVERT(AM2,AM4,IERR)
        CALL MATMLT(AM3,AM4,AM5)
        CALL MTOPOL(AM5,THETA,PHI,CHI)
        IF(CHI.LT.DIST) DIST = CHI
      ENDDO
C ---
      RETURN
      END

      SUBROUTINE CALC_ORIENTION_RMS(I,J,FRTOCR,CRTOFR
     *      ,TALPHA,TGAMMA,TBETA,NSYM,ISYM,IPRSYM,RMS)
C -------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      TALPHA(*),TGAMMA(*),TBETA(*)
      REAL      AM1(3,3),AM2(3,3)
      REAL      FRTOCR(3,3),CRTOFR(3,3)
      REAL      AM3(3,3),AM4(3,3),SN(3,3),SYM(3,3)
      REAL      AMT(3,3)
C ---
      COMMON/COM_INERTIA_MATRIX/ MOD_FLAG,AMINER    
      INTEGER    MOD_FLAG
      REAL       AMINER(3,3)
C ---
C -------------------------
      RMS = 1001.0
      IF(MOD_FLAG.LE.0) RETURN

      PI    = 4.0*ATAN(1.0)
      A1 = (TALPHA(I)*PI)/180.0
      A2 = (TBETA(I)*PI)/180.0
      A3 = (TGAMMA(I)*PI)/180.0
c      WRITE(*,*) ' ANG1:',TALPHA(I),TBETA(I),TGAMMA(I) 
      B1 = (TALPHA(J)*PI)/180.0
      B2 = (TBETA(J)*PI)/180.0
      B3 = (TGAMMA(J)*PI)/180.0
c      WRITE(*,*) ' ANG2:',TALPHA(J),TBETA(J),TGAMMA(J)

      RMS = 1000.0

      CALL EULERM(A1,A2,A3,AM1)
      CALL EULERM(B1,B2,B3,AM2)
      DO JS=1,NSYM
        SYM(1,1) = ISYM(1,1,JS)
        SYM(2,1) = ISYM(2,1,JS)
        SYM(3,1) = ISYM(3,1,JS)
        SYM(1,2) = ISYM(1,2,JS)
        SYM(2,2) = ISYM(2,2,JS)
        SYM(3,2) = ISYM(3,2,JS)
        SYM(1,3) = ISYM(1,3,JS)
        SYM(2,3) = ISYM(2,3,JS)
        SYM(3,3) = ISYM(3,3,JS)
        CALL MATMLT(SYM,CRTOFR,AM3)
        CALL MATMLT(FRTOCR,AM3,SN)
        CALL MATMLT(SN,AM2,AM3)
        CALL MTRANS(AM1,AMT)
        CALL MATMLT(AMT,AM3,AM4)
        AM4(1,1) = 1.0 - AM4(1,1)
        AM4(2,2) = 1.0 - AM4(2,2)
        AM4(3,3) = 1.0 - AM4(3,3)
        CALL MATMLT(AM4,AMINER,AM3)
        TR = 0.0
        DO II=1,3
          TR = TR + AM3(II,II)
        ENDDO
        IF(TR.LT.0.0) TR = 0.0
        R = SQRT(2.0*TR)
        IF(R.LT.RMS) RMS = R
      ENDDO
C ---
      RETURN
      END

      SUBROUTINE CALC_ORIENTION_RMS_FOR_MAT(AM1,AM2,RMS)
C -------------------------
      REAL      AM1(3,3),AM2(3,3)
      REAL      AM3(3,3),AM4(3,3)
      REAL      AMT(3,3)
C ---
      COMMON/COM_INERTIA_MATRIX/ MOD_FLAG,AMINER    
      INTEGER    MOD_FLAG
      REAL       AMINER(3,3)
C ---
C -------------------------
      PI    = 4.0*ATAN(1.0)

      RMS = 1000.0
      IF(MOD_FLAG.LE.0) RETURN

      CALL MTRANS(AM1,AMT)
      CALL MATMLT(AMT,AM2,AM4)
      AM4(1,1) = 1.0 - AM4(1,1)
      AM4(2,2) = 1.0 - AM4(2,2)
      AM4(3,3) = 1.0 - AM4(3,3)
      CALL MATMLT(AM4,AMINER,AM3)
      TR = 0.0
      DO II=1,3
        TR = TR + AM3(II,II)
      ENDDO
      IF(TR.LT.0.0) TR = 0.0
      R = SQRT(2.0*TR)
      RMS = R
C ---
      RETURN
      END

      SUBROUTINE DYAD_CONTRAST(MDOC,NUM_MON,NMON,NR_SYM,CNTR_NEW
     *   ,CORR,CONTRAST,NSCORE
     *   ,SCORE_AVER,SCORE_AVER2,ISCORE_NUMB
     *   ,SCORE_STOR,NSCORE_MAX)
C -------------------------
      REAL       SCORE_STOR(NSCORE_MAX)
      REAL       SCORE_AVER(NSCORE_MAX)
      REAL       SCORE_AVER2(NSCORE_MAX)
      INTEGER    ISCORE_NUMB(NSCORE_MAX)
      CHARACTER LINE*256
C -------------------------
      INCLUDE 'molrep_lh_infor.fh'
C      COMMON/COM_LH_INFOR/ BOFF_LH,BADD_LH,BOFF_FOR_SCAL
C     *   ,CHECK_CONTRAST,CONTRAST_LIM
C     *   ,BCORR_LH,FILE_FOBS_LH,SCORE_FLAG,LH_LH,DB_LH 
CC ---
CC ---
C      REAL      CHECK_CONTRAST,CONTRAST_LIM
C      REAL      BOFF_FOR_SCAL,BOFF_LH,BADD_LH,BCORR_LH
C      CHARACTER LH_LH*1,SCORE_FLAG*1,DB_LH*1
C      CHARACTER FILE_FOBS_LH*256
C ----------------------------------
C -------------------------
      CONTRAST = 0.0
      CNTR_NEW = 0.0
      IF(NSCORE.LE.1) RETURN

      CORRB  = CORR 
      NP     = (NMON - NUM_MON) * NR_SYM 

c      NW_TEST = 3*NR_SYM
c      NW_TEST = 2*NR_SYM
      NW_TEST = 5
      NW_TEST = 3
      NW_TEST = 2
      NW_TEST = 1

c      NW_LIM  = NP + NW_TEST
      NW_LIM  = NP + NR_SYM*3
      NW_LIM  = NP + NR_SYM*2

      IF(NW_LIM.GT.20.AND.NP.LT.18) THEN
        NW_LIM = 20
      ENDIF

      NW_TEST_MAX = NW_TEST*8


c      write(*,*) 'np,NW_TEST,NW_LIM,nsc:',np,NW_TEST,NW_LIM,NSCORE

      IF(NSCORE.LT.NW_LIM) RETURN

      AVER  = 0.0
      AVER2 = 0.0
      SIGMA = 0.0
      NN    = 0

      NN_MAX = NP*NR_SYM*2
      IF(NN_MAX.LT.10) NN_MAX = 10
      
      ISTART = (NSCORE-NP) - NN_MAX + 1     
      IF(ISTART.LE.0) ISTART = 1


       DO I=ISTART,NSCORE-NP
C      DO I=1,NSCORE-NP

c      WRITE(*,*) '--',I,SCORE_STOR(I),SCORE_AVER(I),ISCORE_NUMB(I)

        AVER  = AVER  + SCORE_AVER(I)  
        AVER2 = AVER2 + SCORE_AVER2(I)
        NN    = NN    + ISCORE_NUMB(I)
    
      ENDDO

      IF(NN.GT.0) THEN
        AVER   = AVER /FLOAT(NN)
        AVER2  = AVER2/FLOAT(NN)
        SIGMA  = SQRT(ABS(AVER2-AVER*AVER))
C        WRITE(*,*) '-->nn,AVER',NN,AVER
      ENDIF

      IF(SIGMA.GT.0.0001) THEN
        CNTR_NEW = ABS(CORRB-AVER)/SIGMA
c        WRITE(LINE,'(''ContrastN = '',F8.2)') CNTR_NEW
c        CALL MSGDOC(MDOC,LINE)    
      ENDIF
C ----
      SUMCW  = 0.0
      SUMW   = 0.0 
      NW     = 0
      III    = 0
      DO I=NSCORE-NP,1,-1
C        IF(I.GT.NP) THEN
          SCOREI = SCORE_STOR(I) -1.0 - AVER 
          IF(SCOREI.GT.0.0) THEN
            III = III + 1
            IT  = (III-1)/NR_SYM + 1
            W = 1.0/FLOAT(IT)
            SUMCW = SUMCW + SCOREI*W
            SUMW  = SUMW  + W
            NW    = NW    + 1
            IF(NW.GE.NW_TEST_MAX) GO TO 100
          ENDIF
C        ENDIF
      ENDDO
 100  CONTINUE

      IF(NW.GE.NW_TEST.AND.ABS(SUMW).GT.0.0001) THEN
        T = ABS(SUMCW/SUMW)
        TT = ABS(CORRB-AVER)
        IF(T.GT.0.0001.AND.TT.GE.T) THEN
          CONTRAST = TT/T
          WRITE(LINE,'(''Contrast = '',F8.3)') CONTRAST
          CALL MSGDOC(MDOC,LINE)    
        ENDIF
      ENDIF

c      write(*,*) 'NW,NW_TEST,CNTR:',nW,NW_TEST,nscore,CONTRAST
c      write(*,*) 'AVER,CORRB:',aver,corrb
C ---
      RETURN
      END

      SUBROUTINE TRF_PRECALC_MOD(MDOC,LIST,MOD1,IMOD
     * ,NAMEF,NAMEM,NAMER,NAMEFM,NAMEPH,NAMEFM_PK,NAMEPH_PK
     * ,NAMEFM_N,PATH_SCR
     * ,ALPHA,BETA,GAMMA,PACK,ANISO,SURF,PST
     * ,SPST,RESMIN,RESMAX,BOFF,BOFF_SCL,BADD,BADD_SCL,TEST
     * ,NEL,NUM_MON,BLIM,NMR_INP,SCALEP,BOVER,H2OBG
     * ,ISYM,IPRSYM
     * ,RESULT,RESULTA,IPRMAX,IPRROW,IERR)
C ----------------------------------------------------------------
C 1) if MOD1=D DENS2F_DNS else DENS2F_NEW
C 2) if ANISO = K - FSCALE with SCALEP,BOVER
C                   if scale = 0 - scaling by Fobs (cell must be the same)
C                                  only scale , set BOVER = 0
C                   if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                  no info: rfac, corr
C     else  ANISOSCL
C           if ANISO = Y - pre-isoscaling by Patterson and aniso scaling
C           else  only isoscaling by Patterson PSCALE
C
C     output NAMEFM2,NAMEPH and SCALEP,BOVER 
C            NAMEFM_PK,NAMEPH_PK (if PACK # N )
C
C ----------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER NAMEF*(*),NAMEM*(*),NAMER*(*),NAMEFM_N*(*)
      CHARACTER NAMEFM*(*),NAMEFM_PK*(*),PATH_SCR*(*)
      CHARACTER NAMEPH*(*),NAMEPH_PK*(*)
      REAL      RESULT (IPRMAX,IPRROW)
      REAL      RESULTA(IPRMAX,IPRROW)
      CHARACTER NAMET*256,NAMET1*256,NAMET2*256,NAMES*256,NAMES1*256
      CHARACTER LINE*256,ANISO*1,PACK*1,SURF*1,PST*1,LIST*1
      CHARACTER REST*1,SETT*1,HATM*1,NUM*1,NOCC*1,CONV*1
     *         ,MODE*1,WAT*1,ALT*1,P1*1,TTT*80,MODE_FFT*1
      CHARACTER SOLV*1,PATT*1,NAME*256,CHAR1*1,MOD1*1,TEST*1
      REAL      SPST(3),SH1(3),SH2(3),AM(3,3),RLATT(6)
      CHARACTER ACORR*1,RFAC_FLAG*1,P1_FOR_DNS*1
      CHARACTER ANISO_TMP*1
C ----------------------------------------------------------
      IERR    = 0
      PI      = 4.0*ATAN(1.0)
      MD      = -ABS(MDOC)-1
      M       = 99
      MD0     = 0
      IF(MDOC.EQ.99) MD0 = 99
c      IF(ABS(MDOC).EQ.2) MD = 99
      IF(LIST.NE.'T') MD = 99
C ------------------------------
      NAMET  = 'trfn_dns9'
      CALL ADD_PATH(PATH_SCR,NAMET)
      NAMES  = 'trfn_scr9'
      CALL ADD_PATH(PATH_SCR,NAMES)
      RESULT(1,1) = 1.0 
      RESULT(2,1) = 0.0 
      RESULT(3,1) = 0.0 
      RESULT(4,1) = 0.0 
      NMODEL_FL = 0
C ---
      DO I=1,6
        RLATT(I) = 0.0
      ENDDO

      CALL LENSTR_BL(NAMEFM,LEN)
      IF(LEN .LE.0.OR.NAMEFM(1:1).EQ.' '.OR.NAMEFM(1:1).EQ.',') THEN
        LINE = ' ERROR: in TRF_PRECALC_MOD: wrong file name F' 
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF
      CALL LENSTR_BL(NAMEPH,LENP)
      IF(LENP.LE.0.OR.NAMEPH(1:1).EQ.' '.OR.NAMEPH(1:1).EQ.',') THEN
        LINE = ' ERROR: in TRF_PRECALC_MOD: wrong file name PH' 
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF

      CALL LENSTR_BL(NAMEFM_PK,LEN)
      CALL LENSTR_BL(NAMEPH_PK,LENP)
      IF(PACK.NE.'N'.AND.PACK.NE.'S') THEN
      IF((LEN .LE.0.OR.NAMEFM_PK(1:1).EQ.' '.OR.NAMEFM_PK(1:1).EQ.',')
     *.OR.(LENP.LE.0.OR.NAMEPH_PK(1:1).EQ.' '.OR.NAMEPH_PK(1:1).EQ.','))
     * THEN
        LINE = ' ERROR: in TRF_PRECALC_MOD: wrong file name F_PK'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF
      ENDIF
C --
      RAD     = 0.0
      BADDD   = 0.0
      NX      = 0
      NY      = 0
      NZ      = 0
      IZMAX   =-1
      IZMIN   = 0
      MODE    = 'A'
      IF(SURF.EQ.'C') MODE = 'C'
      MODE_FFT= ' '
      NMR     = NMR_INP
      N_MODEL = 0
      H2OBG   = 0.0
      ITEST   = 0
C ---      
      IF(SURF.EQ.'Y'.OR.SURF.EQ.'C') THEN
        RAD = BLIM + 0.000001
      ENDIF

C ---
      IF(TEST.EQ.'F') THEN      
        MODE  = 'S'
        RAD   = 3.5
        BADDD = 0.0
        IF(SURF.EQ.'Y') THEN
          BADDD  = BLIM + 0.000001
        ENDIF
        PACK = 'N'
      ENDIF
C ---

      CALL LENSTR_BL(NAMEFM_N,LEN)
      IF(LEN.GT.0) NAMES = NAMEFM_N 

      IF(LIST.EQ.'T') THEN
        CALL MSGDOC(MD0,'---  DENS2F_NEW ---')
        WRITE(*,*)  'NMR,NMR_INP:',NMR,NMR_INP,mod1
      ENDIF
C --      
      CHAR1 = PST
      IF(MOD1.EQ.'D') THEN
        P1_FOR_DNS = 'Y'
        CALL DENS2F_DNS(MDOC,LIST,PATH_SCR,NAMEF
     *   ,NAMEM,NAMER,NAMET,NAMES,NAMEPH,NAMEFM_PK,NAMEPH_PK
     *   ,IMOD,NX,NY,NZ,IZMIN,IZMAX,ZFADD
     *   ,RESMAX,NEL,P1_FOR_DNS
     *   ,PACK,CHAR1,SPST,ALPHA,BETA,GAMMA,RLATT
     *   ,RESULT,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: in  TRF_PRECALC_MOD( DENS2F_DNS)')
          GO TO 900
        ENDIF
C        PACK_INDEX = 1.0
C        NDENSP = 1 
C        NZERO  = 0 
C        NDENSM = 0
C        RESULT(1,1) = PACK_INDEX
C        RESULT(2,1) = NDENSP 
C        RESULT(3,1) = NZERO 
C        RESULT(4,1) = NDENSM
        PACK_INDEX = RESULT(1,1) 
        NDENSP = RESULT(2,1) 
        NZERO  = RESULT(3,1) 
        NDENSM = RESULT(4,1) 
      ELSE
        CALL DENS2F_NEW(MDOC,LIST
     *   ,NAMEM,NAMER,NAMET,NAMES,NAMEPH,NAMEFM_PK,NAMEPH_PK,PATH_SCR
     *   ,NMR,N_MODEL,NX,NY,NZ,IZMIN,IZMAX,ZFADD
     *   ,MODE_FFT,MODE,BADDD,RAD,RESMAX,NEL,H2OBG,ITEST,SURF
     *   ,PACK,CHAR1,SPST,ALPHA,BETA,GAMMA,RLATT
     *   ,RESULT,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: in  TRF_PRECALC_MOD( DENS2F_NEW)')
          GO TO 900
        ENDIF
        PACK_INDEX = RESULT(1,1) 
        NDENSP = RESULT(2,1) 
        NZERO  = RESULT(3,1) 
        NDENSM = RESULT(4,1)
        NMODEL_FL = RESULT(6,1)
      ENDIF

      ANISO_TMP = ANISO
      IF(IMOD.EQ.2) THEN
        IF(NMODEL_FL.GE.2.AND.ANISO.EQ.'Y') ANISO_TMP = 'N'
      ENDIF

C ---
      IF(LIST.EQ.'T') CALL MSGDOC(MD0,'--- scaling ---')
      MMM = M
      IF(LIST.EQ.'T') THEN
        CALL MSGDOC(MD0,'--- scaling ---')
        MMM = MDOC
      ENDIF

      ACORR = 'N'
      CALL MR_SCALING(MMM,LIST,NAMEF,NAMES,NAMEFM,PATH_SCR
     * ,ANISO_TMP,SCALEP,BOVER,ACORR,BOFF_SCL,BADD_SCL,RESMIN,RESMAX
     * ,SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF
     * ,RESULTA,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
C ---------------------------------------------------------
C     1. ACORR # N - anisothermal correction of Fmod
c        if ANISO = '-' return
C     2. ANISO = K - FSCALE with SCALEP,BSCALE
C                   if scale = 0 - scaling by Fobs (cell must be the same)
C                      only scale , set BOVER = 0
C                   if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                  no info: rfac, corr
C        else  CALL PSCALE
C      output: SCALEP_NEW,BSCALE_NEW and NAMEFM2
C ---------------------------------------------------------
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: in  TRF_PRECALC_MOD (scaling)')
        GO TO 900
      ENDIF

      SCALEP = SCALEP_NEW
      BOVER  = BSCALE_NEW

  900 CONTINUE
C ----

      NAME='trfn_dns9.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
      NAME='trfn_scr9.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)
C ----
      RETURN
      END

      SUBROUTINE TRF_CHECK_ANGLE(MDOC,THETA12,PHI12,CHI12
     *    ,NP_SRF,SRF_THETA,SRF_PHI,SRF_CHI,SRF_DELTA
     *    ,ALPHA1,BETA1,GAMMA1,ALPHA2,BETA2,GAMMA2,CHI_IN,IANG
     *    ,NSYM,ISYM,IPRSYM)
C -------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      SRF_THETA(*),SRF_PHI(*),SRF_CHI(*)
      CHARACTER LINE*256
      REAL      AM(3,3),BM(3,3),CM(3,3),SM(3,3),DM(3,3)
      REAL      SYM(3,3),AM1(3,3),AM2(3,3),AM3(3,3),AMT(3,3)
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
C -------------------------------
      PI   = 4.0*ATAN(1.0)
      IANG = 1

      WRITE(LINE,*) ' ABG1:',ALPHA1,BETA1,GAMMA1
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) ' ABG2:',ALPHA2,BETA2,GAMMA2
      CALL MSGDOC(MDOC,LINE)

C ---
      A1  = (ALPHA1*PI)/180.0
      B1  = (BETA1 *PI)/180.0
      G1  = (GAMMA1*PI)/180.0
      A2  = (ALPHA2*PI)/180.0
      B2  = (BETA2 *PI)/180.0
      G2  = (GAMMA2*PI)/180.0
      CALL EULERM(A1,B1,G1,AM)                                   
      CALL EULERM(A2,B2,G2,BM)                                   
C     rot 1-->2:  [M]*[abg]*x = [abg2]*x    [M] = [abg2]*[abg]T
      CALL MTRANS(AM,AMT)
      CALL MATMLT(BM,AMT,CM)
      CALL MTOPOL(CM,THETA12,PHI12,CHI12)

      WRITE(LINE,*) ' TFC12:',THETA12,PHI12,CHI12
      CALL MSGDOC(MDOC,LINE)

C
      IF(NP_SRF.GT.0) THEN
        DO I=1,NP_SRF
          IANG = I
          TH = SRF_THETA(I)
          PH = SRF_PHI  (I)
          CH = SRF_CHI  (I)
          
          IF(CHI_IN.GT.0.000001) THEN
            IF(ABS(CH-CHI_IN).GT.SRF_DELTA) GO TO 100
          ENDIF

          DO IS=1,NSYM

            IF(IS.GT.1) THEN
              DO JS=1,IS-1
                DO II=1,3
                DO JJ=1,3
                  IF(ISYM(II,JJ,JS).NE.ISYM(II,JJ,IS)) GO TO 111
                ENDDO
                ENDDO
                GO TO 120
 111            CONTINUE
              ENDDO
            ENDIF
            SYM(1,1) = REAL(ISYM(1,1,IS))
            SYM(2,1) = REAL(ISYM(2,1,IS))
            SYM(3,1) = REAL(ISYM(3,1,IS))
            SYM(1,2) = REAL(ISYM(1,2,IS))
            SYM(2,2) = REAL(ISYM(2,2,IS))
            SYM(3,2) = REAL(ISYM(3,2,IS))
            SYM(1,3) = REAL(ISYM(1,3,IS))
            SYM(2,3) = REAL(ISYM(2,3,IS))
            SYM(3,3) = REAL(ISYM(3,3,IS))
            CALL MATMLT(SYM,CRTOFR,AM3)
            CALL MATMLT(FRTOCR,AM3,SYM)

            THH = (TH*PI)/180.0
            PHH = (PH*PI)/180.0
            CHH = (CH*PI)/180.0
            CALL POLTOM(THH,PHH,CHH,AM1)                                   
            CALL MATMLT(AM1,SYM,AM)

            CALL MTRANS(AM,SM)
            CALL MATMLT(CM,SM,DM)

            CALL MTOPOL(DM,THETA13,PHI13,DELTA)

            IF(ABS(DELTA).GT.SRF_DELTA) GO TO 120           
            GO TO 200

 120        CONTINUE

          ENDDO

 100      CONTINUE

        ENDDO
        IANG = 0
      ELSE
        IF(ABS(CHI_IN).LE.0) GO TO 200
        IF(ABS(CHI12 - CHI_IN).GT.SRF_DELTA) IANG = 0
      ENDIF
C ---
 200  CONTINUE
      WRITE(LINE,*) '  TFC(1->2):',THETA12,PHI12,CHI12,IANG
      CALL MSGDOC(MDOC,LINE)
      RETURN
      END

      SUBROUTINE TRF_CHECK_DIST(MDOC,NPTEST,IPT,RESULT,IPRMAX,IPRROW
     *                ,ALPHA1,BETA1,GAMMA1,ALPHA2,BETA2,GAMMA2,SH12
     *                ,DLIM_MIN,DLIM_MAX,DPAR_MAX
     *                ,ARADI,CHI_IN,IPT_MIN,DIST_MIN,DORT,DPAR)
C -------------------------------
      CHARACTER LINE*256
      REAL      RESULT(IPRMAX,IPRROW),SH12(3)
      REAL      X(3),Y(3),Z(3),AM(3,3),BM(3,3),CM(3,3),SM(3,3)
C -------------------------------
      PI   = 4.0*ATAN(1.0)
C      DIST_MIN = 1.0 E30
C ---
      A1  = (ALPHA1*PI)/180.0
      B1  = (BETA1 *PI)/180.0
      G1  = (GAMMA1*PI)/180.0
      A2  = (ALPHA2*PI)/180.0
      B2  = (BETA2 *PI)/180.0
      G2  = (GAMMA2*PI)/180.0
      CALL EULERM(A1,B1,G1,AM)                                   
      CALL EULERM(A2,B2,G2,BM)                                   
C     rot 1-->2:  [M]*[abg]*x = [abg2]*x    [M] = [abg2]*[abg]T
      CALL MTRANS(AM,SM)
      CALL MATMLT(BM,SM,CM)
      CALL MTOPOL(CM,THETA12,PHI12,CHI12)

c      WRITE(LINE,*) 'TFC(1-->2):',THETA12,PHI12,CHI12
c      CALL MSGDOC(MDOC,LINE)
C ---
      IPT_MIN  = 0

C      DO IPT=1,NPTEST
        X(1) = RESULT(IPT, 9)
        X(2) = RESULT(IPT,10)
        X(3) = RESULT(IPT,11)
        IF(X(1).GT.0.5) THEN
          X(1) = X(1)-1.0
          RESULT(IPT, 9) = RESULT(IPT, 9) - 1.0
        ENDIF
        IF(X(2).GT.0.5) THEN
          X(2) = X(2)-1.0
          RESULT(IPT,10) = RESULT(IPT,10) - 1.0
        ENDIF
        IF(X(3).GT.0.5) THEN
          X(3) = X(3)-1.0
          RESULT(IPT,11) = RESULT(IPT,11) - 1.0
        ENDIF
        IF(X(1).LT.-0.5) THEN
          X(1) = X(1)+1.0
          RESULT(IPT, 9) = RESULT(IPT, 9) + 1.0
        ENDIF
        IF(X(2).LT.-0.5) THEN
          X(2) = X(2)+1.0
          RESULT(IPT,10) = RESULT(IPT,10) + 1.0
        ENDIF
        IF(X(3).LT.-0.5) THEN
          X(3) = X(3)+1.0
          RESULT(IPT,11) = RESULT(IPT,11) + 1.0
        ENDIF
        CALL FTOO(X,Y,IERR)

        
        DIST_LIM = SQRT(Y(1)*Y(1)+Y(2)*Y(2)+Y(3)*Y(3))
C ----
        TH  = (THETA12*PI)/180.0
        PH  = (PHI12  *PI)/180.0
        CH  = PI
        CALL POLTOM(TH,PH,CH,CM)
        CALL MVMULT(CM,Y,X)
        CALL VSUB(X,Y,Z)
        S = 0.5
        CALL VSCAL(Z,S,X)
        CALL VMOD(X,DORT)
        CALL VADD(Y,X,Z)
        CALL VMOD(Z,DPAR)

c        WRITE(LINE,*) 
c     *  'DLIM_MIN DLIM_MAX PAR_MAX:',DLIM_MIN,DLIM_MAX,PAR_MAX
c            CALL MSGDOC(MDOC,LINE)

            WRITE(LINE,
     *      '(''Dist for peak '',I4,'' :'',3G16.4)') 
     *      IPT,DIST_LIM,DORT,DPAR
            CALL MSGDOC(MDOC,LINE)
C ---- 
        IF(DIST_LIM.GT.DLIM_MIN.AND.DIST_LIM.LT.DLIM_MAX) THEN        
          IF(DPAR.LT.DPAR_MAX) THEN
            WRITE(LINE,
     *      '(''Dist for peak '',I4,'' :'',3G16.4)') 
     *      IPT,DIST_LIM,DORT,DPAR
            CALL MSGDOC(MDOC,LINE)
            SH12(1) =-Y(1)
            SH12(2) =-Y(2)
            SH12(3) =-Y(3)
C            IF(DIST_LIM.LE.DIST_MIN) THEN
              DIST_MIN = DIST_LIM
              IPT_MIN  = IPT
C            ENDIF
          ENDIF
        ENDIF
C      ENDDO

      RETURN
      END


      SUBROUTINE STF_CHECK_PEAK(MDOC,MOD_D2,IR,JR,ISS,DLIM
     *                ,RESULT,IPRMAX,IPRROW
     *                ,NSYM,ISYM,IPRSYM,IERR)
C -------------------------------
      CHARACTER LINE*256,MOD_D2*1
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRMAX,IPRROW)
      REAL      X1(3),X2(3),X11(3)
C -------------------------------
      PI   = 4.0*ATAN(1.0)
C ---
      NP = RESULT(1,12)
      IF(NP.LE.1) RETURN
      
      DO IP=1,NP-1
        X1(1) = RESULT(IP, 9)
        X1(2) = RESULT(IP,10)
        X1(3) = RESULT(IP,11)

        DO JP=IP+1,NP
          D     = RESULT(JP, 4)
          X2(1) = RESULT(JP, 9)
          X2(2) = RESULT(JP,10)
          X2(3) = RESULT(JP,11)

          IF(D.GE.0.0) THEN
            CALL STF_CHECK_DIST(MDOC,X1,X2,DLIM,IPEAK,D
     *                           ,NSYM,ISYM,IPRSYM,IERR)
            IF(IPEAK.EQ.1) THEN
              RESULT(JP, 4) = -1.0
            ENDIF
            IF(MOD_D2.EQ.'N'.AND.IR.EQ.JR.AND.ISS.EQ.1) THEN
              X11(1) = -RESULT(IP, 9)
              X11(2) = -RESULT(IP,10)
              X11(3) = -RESULT(IP,11)

              CALL STF_CHECK_DIST(MDOC,X11,X2,DLIM,IPEAK,D
     *                           ,NSYM,ISYM,IPRSYM,IERR)
              IF(IPEAK.EQ.1) THEN
                RESULT(JP, 4) = -1.0
              ENDIF
            ENDIF
          ENDIF
        ENDDO
      ENDDO

      IP = 0
      DO JP=1,NP
        D = RESULT(JP,4)
        IF(D.GE.0.0) THEN
          IP = IP + 1
          DO K=1,IPRROW
            RESULT(IP,K)=  RESULT(JP,K)
          ENDDO
        ENDIF
      ENDDO
      RESULT(1,12) = IP
c ---
      RETURN
      END

      SUBROUTINE STF_CHECK_DIST(MDOC,W,ST,DLIM,IPEAK,D
     *                           ,NSYM,ISYM,IPRSYM,IERR)
C -------------------------------
      CHARACTER LINE*256
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      W(3),ST(3),Z(3),XX(3),X(3)
C -------------------------------
      IPEAK = 0

      DO IS=1,NSYM

        ISS = 1
        IF(IS.GT.1) THEN
          DO I=1,3
          DO J=1,3
            IF(ISYM(I,J,1).NE.ISYM(I,J,IS)) ISS = 0
          ENDDO
          ENDDO
        ENDIF

        IF(ISS.EQ.0) GO TO 100

        Z(1) = W(1)*ISYM(1,1,IS)+W(2)*ISYM(2,1,IS)+W(3)*ISYM(3,1,IS)
        TTX  = REAL(ISYM(4,1,IS))/REAL(ISYM(5,1,IS))
        Z(2) = W(1)*ISYM(1,2,IS)+W(2)*ISYM(2,2,IS)+W(3)*ISYM(3,2,IS)
        TTY  = REAL(ISYM(4,2,IS))/REAL(ISYM(5,2,IS))
        Z(3) = W(1)*ISYM(1,3,IS)+W(2)*ISYM(2,3,IS)+W(3)*ISYM(3,3,IS)
        TTZ  = REAL(ISYM(4,3,IS))/REAL(ISYM(5,3,IS))

        Z(1) = Z(1) + TTX
        Z(2) = Z(2) + TTY
        Z(3) = Z(3) + TTZ


        XX(1) = Z(1) - ST(1)
        XX(2) = Z(2) - ST(2)
        XX(3) = Z(3) - ST(3)

C ---
 10     CONTINUE
        IF(XX(1).GE.0.5)THEN
          XX(1) = XX(1)-1.0
          GO TO 10
        ENDIF
 20     CONTINUE
        IF(XX(1).LT.-0.5)THEN
          XX(1) = XX(1)+1.0
          GO TO 20
        ENDIF
 30     CONTINUE
        IF(XX(2).GE.0.5)THEN
          XX(2) = XX(2)-1.0
          GO TO 30
        ENDIF
 40     CONTINUE
        IF(XX(2).LT.-0.5)THEN
          XX(2) = XX(2)+1.0
          GO TO 40
        ENDIF
 50     CONTINUE
        IF(XX(3).GE.0.5)THEN
          XX(3) = XX(3)-1.0
          GO TO 50
        ENDIF
 60     CONTINUE
        IF(XX(3).LT.-0.5)THEN
          XX(3) = XX(3)+1.0
          GO TO 60
        ENDIF
C ---
        CALL FTOO(XX,X,IERR)

        D2 = X(1)*X(1)+X(2)*X(2)+X(3)*X(3)
        D  = SQRT(D2)

        IF(D.LT.DLIM) THEN
          IPEAK = 1
          GO TO 200
        ENDIF

 100    CONTINUE

      ENDDO
 200  CONTINUE

      RETURN
      END

      SUBROUTINE TRF_CHANGE_ANGLE(MDOC,IS,ALPHA,BETA,GAMMA
     *                         ,NSYM,ISYM,IPRSYM,IERR)
C ------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER LINE*256
      REAL      SM(3,3),AM(3,3),BM(3,3),CM(3,3)
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
C ------------------------------------------
      PI   = 4.0*ATAN(1.0)
      IERR = 0
C ---
      IF(IS.GT.1) THEN
        DO JS=1,IS-1
          DO I=1,3
          DO J=1,3
            IF(ISYM(I,J,JS).NE.ISYM(I,J,IS)) GO TO 100
          ENDDO
          ENDDO
          IS = 0
          RETURN
 100      CONTINUE
        ENDDO
      ENDIF
C     new alpha,beta,gamma
C     [F2O] * [IS] * [O2F]* [alpha,beta,gamma]
      A  = (ALPHA*PI)/180.0
      B  = (BETA *PI)/180.0
      G  = (GAMMA*PI)/180.0
      CALL EULERM(A,B,G,BM)
      SM(1,1) = ISYM(1,1,IS)
      SM(2,1) = ISYM(2,1,IS)
      SM(3,1) = ISYM(3,1,IS)
      SM(1,2) = ISYM(1,2,IS)
      SM(2,2) = ISYM(2,2,IS)
      SM(3,2) = ISYM(3,2,IS)
      SM(1,3) = ISYM(1,3,IS)
      SM(2,3) = ISYM(2,3,IS)
      SM(3,3) = ISYM(3,3,IS)
      CALL MATMLT(SM,CRTOFR,AM)
      CALL MATMLT(FRTOCR,AM,CM)
      CALL MATMLT(CM,BM,AM)
      CALL MTOPOL(AM,THETA,PHI,CHI)
      CALL MTOANG(AM,ALPHA,BETA,GAMMA)

      WRITE(LINE,*) ' ABG:',ALPHA,BETA,GAMMA
      CALL MSGDOC(MDOC,LINE)

      WRITE(LINE,*) ' TFC:',THETA,PHI,CHI
      CALL MSGDOC(MDOC,LINE)

      RETURN
      END


      SUBROUTINE TRF_PRECALC_MOD2(MDOC
     * ,NAMEF,NAMEM,NAMEC,NAMEC12
     * ,NAMEFM1_N,NAMEPH1,NAMEFM1_PK,NAMEPH1_PK
     * ,NAMEFM2_N,NAMEPH2,NAMEFM2_PK,NAMEPH2_PK
     * ,NAMEFM12,NAMEPH12,NAMEFM12_PK,NAMEPH12_PK
     * ,PATH_SCR,SH12,LIST
     * ,ALPHA1,BETA1,GAMMA1,ALPHA,BETA,GAMMA,PACK,ANISO,SURF
     * ,RESMIN,RESMAX,BOFF,BOFF_SCL,BADD,BADD_SCL
     * ,NEL,NUM_MON,BLIM,NMR,SCALEP,BOVER,H2OBG
     * ,ISYM,IPRSYM
     * ,RESULT,RESULTA,IPRMAX,IPRROW,IERR)
C ----------------------------------------------------------------
C 1) NAMEM + NAMEC = NAMEC12      
C 2) SFVSUM  and  SFVSUM forpaking functon (PACK # N)
C 3) if ANISO = K - FSCALE with SCALEP,BOVER
C                   if scale = 0 - scaling by Fobs (cell must be the same)
C                                  only scale , set BOVER = 0
C                   if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                  no info: rfac, corr
C     else  ANISOSCL
C           if ANISO = Y - pre-isoscaling by Patterson and aniso scaling
C           else  only isoscaling by Patterson
C
C     output NAMEFM12,NAMEPH12 and SCALEP,BOVER 
C            NAMEFM12_PK,NAMEPH12_PK(if PACK # N )
C ----------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER NAMEF*(*),NAMEM*(*) ,NAMEC12*(*),NAMEC*(*),PATH_SCR*(*)
      CHARACTER NAMEFM1_N*(*),NAMEFM1_PK*(*)
      CHARACTER NAMEPH1*(*)  ,NAMEPH1_PK*(*)
      CHARACTER NAMEFM2_N*(*),NAMEFM2_PK*(*)
      CHARACTER NAMEPH2*(*)  ,NAMEPH2_PK*(*)
      CHARACTER NAMEFM12*(*) ,NAMEFM12_PK*(*)
      CHARACTER NAMEPH12*(*) ,NAMEPH12_PK*(*)
      REAL      RESULT (IPRMAX,IPRROW)
      REAL      RESULTA(IPRMAX,IPRROW)
      CHARACTER NAMET*256,NAMET1*256,NAMET2*256,NAMES*256,NAMES1*256
      CHARACTER LINE*256,ANISO*1,PACK*1,SURF*1,LIST*1,INVER*1,ACORR*1
      CHARACTER REST*1,SETT*1,HATM*1,NUM*1,NOCC*1,CONV*1
     *         ,MODE*1,WAT*1,ALT*1,P1*1,TTT*80
      CHARACTER SOLV*1,PATT*1
      REAL      SH1(3),SH2(3),AM(3,3),SH12(3),SH12F(3),RLATT(6)
C ----------------------------------------------------------
      IERR    = 0
      PI      = 4.0*ATAN(1.0)
      MD      = -ABS(MDOC)-1
      M       = 99
      MD0     = 0
      IF(MDOC.EQ.99) MD0 = 99
      IF(ABS(MDOC).EQ.2) MD = 99
      IF(LIST.EQ.'T') THEN
        MD = MDOC
      ENDIF
C ------------------------------
      RESULT(1,1) = 1.0 
      RESULT(2,1) = 0.0 
      RESULT(3,1) = 0.0 
      RESULT(4,1) = 0.0 
      NAMET      = 'trfn_scr2'
      CALL ADD_PATH(PATH_SCR,NAMET)
      NAMET1     = 'trfn_scr1'
      CALL ADD_PATH(PATH_SCR,NAMET1)
      NAMET2     = 'trfn_scr3'
      CALL ADD_PATH(PATH_SCR,NAMET2)
      DO I=1,6
        RLATT(I) = 0.0
      ENDDO
C ---
      CALL LENSTR_BL(NAMEC12,LEN)
      IF(LEN.GT.0) THEN
        MODE   = 'E'
        DO I=1,3
          SH1(I) = 0.0
          SH2(I) = 0.0
          DO J=1,3
            AM(I,J) = 0.0
          ENDDO
        ENDDO
        CALL TRANS(M,NAMEM,NAMET2,SH1,SH2
     *  ,MODE,AM,ALPHA1,BETA1,GAMMA1,RESULT,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
        MODE   = 'E'
        DO I=1,3
          SH1(I) = 0.0
          SH2(I) = SH12(I)
          DO J=1,3
            AM(I,J) = 0.0
          ENDDO
        ENDDO
        CALL TRANS(M,NAMEC,NAMET,SH1,SH2
     *    ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
C ---
        IERR = NUM_MON + 1
        CALL JOINCRD(M,NAMET2,NAMET,NAMEC12,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
      ENDIF
C --------------------------------------------
      CALL LENSTR_BL(NAMEFM1_N,LEN)
      CALL LENSTR_BL(NAMEPH1,LENP)
      IF((LEN .LE.0.OR.NAMEFM1_N(1:1).EQ.' '.OR.NAMEFM1_N(1:1).EQ.',')
     *   .OR.
     *   (LENP.LE.0.OR.NAMEPH1(1:1).EQ.' '.OR.NAMEPH1(1:1).EQ.','))THEN
        LINE = ' ERROR: in TRF_PRECALC_MOD2: wrong file name F1'
        CALL MSGDOC(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF

      CALL LENSTR_BL(NAMEFM1_PK,LEN)
      CALL LENSTR_BL(NAMEPH1_PK,LENP)
      IF(PACK.NE.'N'.AND.PACK.NE.'S') THEN
      IF((LEN .LE.0.OR.NAMEFM1_PK(1:1).EQ.' '.OR.NAMEFM1_PK(1:1).EQ.',')
     * .OR.
     * (LENP.LE.0.OR.NAMEPH1_PK(1:1).EQ.' '.OR.NAMEPH1_PK(1:1).EQ.','))
     * THEN
        LINE = ' ERROR: in TRF_PRECALC_MOD2: wrong file name F1_PK' 
        CALL MSGDOC(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF
      ENDIF

      CALL LENSTR_BL(NAMEFM2_N,LEN)
      CALL LENSTR_BL(NAMEPH2,LENP)
      IF((LEN .LE.0.OR.NAMEFM2_N(1:1).EQ.' '.OR.NAMEFM2_N(1:1).EQ.',')
     *    .OR.
     *   (LENP.LE.0.OR.NAMEPH2(1:1).EQ.' '.OR.NAMEPH2(1:1).EQ.','))THEN
        LINE = ' ERROR: in TRF_PRECALC_MOD2: wrong file name F2'
        CALL MSGDOC(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF

      CALL LENSTR_BL(NAMEFM2_PK,LEN)
      CALL LENSTR_BL(NAMEPH2_PK,LENP)
      IF(PACK.NE.'N'.AND.PACK.NE.'S') THEN
      IF((LEN .LE.0.OR.NAMEFM2_PK(1:1).EQ.' '.OR.NAMEFM2_PK(1:1).EQ.',')
     * .OR.
     * (LENP.LE.0.OR.NAMEPH2_PK(1:1).EQ.' '.OR.NAMEPH2_PK(1:1).EQ.','))
     * THEN
        LINE = ' ERROR: in TRF_PRECALC_MOD2: wrong file name F2_PK' 
        CALL MSGDOC(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF
      ENDIF

      CALL LENSTR_BL(NAMEFM12,LEN)
      CALL LENSTR_BL(NAMEPH12,LENP)
      IF((LEN .LE.0.OR.NAMEFM12(1:1).EQ.' '.OR.NAMEFM12(1:1).EQ.',').OR.
     *   (LENP.LE.0.OR.NAMEPH12(1:1).EQ.' '.OR.NAMEPH12(1:1).EQ.','))
     *   THEN
        LINE = ' ERROR: in TRF_PRECALC_MOD2: wrong file name F12'
        CALL MSGDOC(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF

      CALL LENSTR_BL(NAMEFM12_PK,LEN)
      CALL LENSTR_BL(NAMEPH12_PK,LENP)
      IF(PACK.NE.'N'.AND.PACK.NE.'N') THEN
      IF((LEN .LE.0.OR.NAMEFM12_PK(1:1).EQ.' '.OR.
     *    NAMEFM12_PK(1:1).EQ.',').OR.
     *   (LENP.LE.0.OR.NAMEPH12_PK(1:1).EQ.' '.OR.
     *  NAMEPH12_PK(1:1).EQ.',')) THEN
        LINE = ' ERROR: in TRF_PRECALC_MOD2: wrong file name F12_PK'
        CALL MSGDOC(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF
      ENDIF

C ---
      CALL OTOF(SH12,SH12F,IERR)
C ---
      INVER   = 'N'
      MODE    = 'A'
      BOFFF   = 0.0

      MMM = M
      IF(LIST.EQ.'T') THEN
        MMM = MDOC
        CALL MSGDOC(MMM,'--- SFVSUM ---')
      ENDIF

      RESMIN_I = 0.0
      RESMAX_I = 0.0
      BADDD    = 0.0
      BOFFF    = 0.0
      SCALER   = 0.0
      CALL SFVSUM(MMM,MODE,SCALER,INVER
     * ,NAMEFM1_N,NAMEPH1,NAMEFM2_N,NAMEPH2,NAMET1,NAMEPH12 
     * ,SH12F,BOFFF,BADDD,RESMIN_I,RESMAX_I
     * ,ISYM,IPRSYM,RESULT,IPRROW,IERR)
      IF(IERR.NE.0) GO TO 900

      IF(PACK.NE.'N'.AND.PACK.NE.'S') THEN
        MMM = M
        IF(LIST.EQ.'T') THEN
          MMM = MDOC
          CALL MSGDOC(MMM,'--- SFVSUM(pack) ---')
        ENDIF

        RESMIN_I = 0.0
        RESMAX_I = 0.0
        BADDD    = 0.0
        BOFFF    = 0.0
        SCALER   = 0.0
        CALL SFVSUM(MMM,MODE,SCALER,INVER
     *   ,NAMEFM1_PK,NAMEPH1_PK,NAMEFM2_PK,NAMEPH2_PK
     *   ,NAMEFM12_PK,NAMEPH12_PK 
     *   ,SH12F,BOFFF,BADDD,RESMIN_I,RESMAX_I
     *   ,ISYM,IPRSYM,RESULT,IPRROW,IERR)
        IF(IERR.NE.0) GO TO 900

      ENDIF
C ---
      CALL MSGDOC(MD0,'--- scaling ---')

      IF(LIST.EQ.'T') THEN
        M = MDOC
      ENDIF

c      SCALEP= 1.0
c      BOVER = 0.0
      BSCALE = BOVER
      ACORR = 'N'
      CALL MR_SCALING(M,LIST,NAMEF,NAMET1,NAMEFM12,PATH_SCR
     * ,ANISO,SCALEP,BSCALE,ACORR,BOFF_SCL,BADD_SCL,RESMIN,RESMAX
     * ,SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF
     * ,RESULTA,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
C ---------------------------------------------------------
C     1. ACORR # N - anisothermal correction of Fmod
c        if ANISO = '-' return
C     2. ANISO = K - FSCALE with SCALEP,BSCALE
C                   if scale = 0 - scaling by Fobs (cell must be the same)
C                      only scale , set BOVER = 0
C                   if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                  no info: rfac, corr
C        else  CALL PSCALE
C      output: SCALEP_NEW,BSCALE_NEW and NAMEFM2
C ---------------------------------------------------------
      IF(IERR.NE.0) GO TO 900

      SCALEP = SCALEP_NEW 
      BOVER  = BSCALE_NEW 
C ----
  900 CONTINUE

      NAMES='trfn_scr1.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trf_scr2.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_scr1.crd'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_scr2.crd'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_scr3.crd'
      CALL DELETE_FILE(PATH_SCR,NAMES)

      RETURN
      END

      SUBROUTINE READ_TAB_SRF(MDOC,NAME,NP_MAX_INP
     *            ,RESULT,IPRMAX,IPRROW
     *            ,FRTOCR,CRTOFR,NSYM,ISYM,IPRSYM,IERR)
C --------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
C ---
      REAL      RESULT    (IPRMAX,IPRROW)
      CHARACTER LINE*256,PATH*80,EXT*80,NAME*(*)
C ---
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /FREAD_CIF/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*256
C ------
      REAL      FRTOCR(3,3),CRTOFR(3,3)
      REAL      AM(3,3),BM(3,3),CM(3,3),SM(3,3),DM(3,3),AM3(3,3)
C --------------------------------------------------------------
      MD0  = 0
      MD   = -ABS(MDOC)-1
      M    = 99
      NP   = 0
      IERR = 0
      PI   = 4.0*ATAN(1.0)
C ---
      IN   = 11
      PATH = ' '
      EXT  = ' '
      CALL OPENFR(IN,M,PATH,NAME,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 900
      ENDIF
      NW = 0
      NP_MAX = ABS(NP_MAX_INP)
      NSS    = 1
      IF(NP_MAX_INP.LT.0)  NSS  = NSYM      
C --- 
Col_RF  2   108.68  148.44   70.30  105.78  -70.81  179.72     143.9      6.80
      IEND = 0
 200  CONTINUE
      IN_STRING = ' '
      READ(IN,'(A)',END=110) IN_STRING
      GO TO 120
 110  CONTINUE
      IEND = 1
 120  CONTINUE
      CALL LENSTR_BL(IN_STRING,LEN)
      IF(LEN.GT.0.AND.IN_STRING(1:1).NE.'#') THEN
        CALL FRD_PARM_CIF
C       IF(NWORDS.LE.3) GO TO 200
        IF(NWORDS.LE.4) GO TO 200
        IF(WORDS(1)(1:1).EQ.'#') GO TO 200
        IF(NP.GE.IPRMAX) GO TO 100
        IEULER = 0
        IF(WORDS(1)(1:5).EQ.'Sol_A') IEULER = 1

        DO IS=1,NSS

           IF(IEULER.EQ.1) THEN
             ALPHA = FWORDS(3)
             BETA  = FWORDS(4)
             GAMMA = FWORDS(5)
             A  = (ALPHA*PI)/180.0
             B  = (BETA *PI)/180.0
             G  = (GAMMA*PI)/180.0
             CALL EULERM(A,B,G,AM)
             CALL MTOPOL(AM,THETA,PHI,CHI)
           ELSE
            THETA = FWORDS(3) 
            PHI   = FWORDS(4) 
            CHI   = FWORDS(5)
          ENDIF

          TH = (THETA*PI)/180.0
          PH = (PHI  *PI)/180.0
          CH = (CHI  *PI)/180.0

          CALL POLTOM(TH,PH,CH,AM)                                   
          CALL MTOANG(AM,ALPHA,BETA,GAMMA)

          IF(IS.GT.1) THEN
            DO JS=1,IS-1
              DO I=1,3
              DO J=1,3
                IF(ISYM(I,J,JS).NE.ISYM(I,J,IS)) GO TO 500
              ENDDO
              ENDDO
              GO TO 400
 500          CONTINUE
            ENDDO

C           new alpha,beta,gamma
C           [alpha,beta,gamma] * [IS]

            SM(1,1) = REAL(ISYM(1,1,IS))
            SM(2,1) = REAL(ISYM(2,1,IS))
            SM(3,1) = REAL(ISYM(3,1,IS))
            SM(1,2) = REAL(ISYM(1,2,IS))
            SM(2,2) = REAL(ISYM(2,2,IS))
            SM(3,2) = REAL(ISYM(3,2,IS))
            SM(1,3) = REAL(ISYM(1,3,IS))
            SM(2,3) = REAL(ISYM(2,3,IS))
            SM(3,3) = REAL(ISYM(3,3,IS))
            CALL MATMLT(SM,CRTOFR,AM3)
            CALL MATMLT(FRTOCR,AM3,SM)

            CALL MTRANS(SM,CM)
            CALL MATMLT(BM,CM,DM)
            CALL MATMLT(SM,DM,AM)
            CALL MTOPOL(AM,THETA,PHI,CHI)
            CALL MTOANG(AM,ALPHA,BETA,GAMMA)

          ENDIF
        
          IF(NP.GE.IPRMAX) GO TO 100
          NP = NP + 1

          RESULT(NP,6)  = ALPHA
          RESULT(NP,7)  = BETA
          RESULT(NP,8)  = GAMMA

          RESULT(NP, 9) = THETA
          RESULT(NP,10) = PHI
          RESULT(NP,11) = CHI

          IF(NWORDS.GE.10) THEN
            RESULT(NP, 4) = FWORDS(9)
            RESULT(NP, 5) = FWORDS(10)
            NW = 1
          ELSE
            RESULT(NP, 4) = 0.0
            RESULT(NP, 5) = 0.0
          ENDIF

 400      CONTINUE

        ENDDO

      ENDIF
      
      IF(NP_MAX.GT.0.AND.NP_MAX.EQ.NP) GO TO 100
      IF(IEND.GT.0) GO TO 100
      GO TO 200
C ---
 100  CONTINUE
      CLOSE(IN)
 900  CONTINUE
      IERR = 0

      RESULT(1,12) = NP
      IF(NP.GT.0) THEN
        CALL MSGDOC(MDOC,' ')
        CALL MSGDOC(MDOC,
     *  '    - peaks of Self-Rotation Function -')
        CALL MSGDOC(MDOC,
     *  '+-----------------------------------------+')
        LINE =
     *  '|       theta    phi     chi     P(i)/P(0)|'
        CALL MSGDOC(MDOC,LINE)
        CALL MSGDOC(MDOC,
     *  '+-----------------------------------------+')
        LINE =
     * 'S'//'ol_         theta    phi    chi '//
     * '    alpha   beta  gamma'//'         Rf'//'  P(i)/P(0)'
        CALL MSGDOC(MD,LINE)
        IF(NP_MAX.GT.0.AND.NP_MAX.LT.NP) NP = NP_MAX
        DO I=1,NP
          ALPHA  = RESULT(I,6)
          BETA   = RESULT(I,7)
          GAMMA  = RESULT(I,8)
          IF(NW.LE.0) THEN
            WRITE(LINE,300) I,ALPHA,BETA,GAMMA
 300        FORMAT(I3,1X,6F8.2)
            CALL LENSTR_BL(LINE,LEN)
            CALL MSGDOC(MD,LINE(1:LEN))    
            WRITE(LINE,'(''|'',I3,1X,3F8.2,'' |'')')
     *       I,ALPHA,BETA,GAMMA
            CALL MSGDOC(MDOC,LINE)    
          ELSE
            WRITE(LINE,310) I
     *      ,RESULT(I,9),RESULT(I,10),RESULT(I,11)
     *      ,ALPHA,BETA,GAMMA
     *      ,RESULT(I,4),RESULT(I,5)
 310        FORMAT('Sol_RF',I3,1X,6F8.2,G14.4,F6.2)
            CALL MSGDOC(MD,LINE)    
            WRITE(LINE,'(''|'',I3,1X,3F8.2,6X,F6.2,'' |'')') I
     *      ,RESULT(I,9),RESULT(I,10),RESULT(I,11),RESULT(I,5)
            CALL MSGDOC(MDOC,LINE)    
          ENDIF
        ENDDO
        CALL MSGDOC(MDOC,
     *  '+-----------------------------------------+')
          CALL MSGDOC(MDOC,' ')
      ENDIF
      RETURN
      END

      SUBROUTINE SET_FLAG_USE(IMODE,X,Y,Z,X0,Y0,Z0,IUSE)
C ------------------------------------------
C MODE   =  1 2   3 4   5 6
C MODE-1    0 1   2 3   4 5
C angle      0     1     2
C sign      + -   + -   + -
C
C ----
C  1 angle (tpc)  90  90  90
C MATRIX :       0.0000      0.0000      1.0000
C                0.0000      1.0000      0.0000
C               -1.0000      0.0000      0.0000
C ----
C  2 angle (tpc)  90  0  90
CMATRIX :        1.0000      0.0000      0.0000
C                0.0000      0.0000     -1.0000
C                0.0000      1.0000      0.0000
C ----
C IUSE = 1 use ; = 0 not
C --------------------------------------------
      MODE = ABS(IMODE)
      IF(MODE.LT.1) MODE = 1
      IF(MODE.GT.7) MODE = 7
      IF(MODE.EQ.7) THEN
        IUSE = 1
        RETURN
      ENDIF

      IA = (MODE-1)/2 
C     - IS = 0 ; + IS = 1
      IS = MOD(MODE,2)
C
      IUSE = 0
C ---
      XX = X - X0
      YY = Y - Y0
      ZZ = Z - Z0
      IF(IA.EQ.0) THEN
        IF(ZZ.GT.0.0.AND.IS.EQ.1) IUSE = 1
        IF(ZZ.LT.0.0.AND.IS.EQ.0) IUSE = 1
      ELSE IF(IA.EQ.1) THEN
        ZZ = -XX
        IF(ZZ.GT.0.0.AND.IS.EQ.1) IUSE = 1
        IF(ZZ.LT.0.0.AND.IS.EQ.0) IUSE = 1
      ELSE IF(IA.EQ.2) THEN
        ZZ = YY
        IF(ZZ.GT.0.0.AND.IS.EQ.1) IUSE = 1
        IF(ZZ.LT.0.0.AND.IS.EQ.0) IUSE = 1
      ENDIF
C ---
      RETURN
      END

      SUBROUTINE RF_PRECALC_MOD(MDOC,LIST
     * ,NAMEM,NAMEC,NAMED
     * ,NAMEF,NAMEFM2,NAMEPH,PATH_SCR
     * ,MOD1,IMOD,ANISO,NXMIN,NYMIN,NZMIN
     * ,IZMIN,IZMAX,NMR,N_MODEL,TEST,SCALEP,BSCALE,ACORR
     * ,BOFF_SCL,BADD_SCL,RESMIN,RESMAX
     * ,MODE_GD,BADD_GD,RAD_GD,NEL,SURF
     * ,RLATT,ALPHA,BETA,GAMMA
     * ,RESULT,RESULTA,IPRMAX,IPRROW
     * ,ISYM,IPRSYM,IERR)
C ------------------------------------------------------------
C 1) if MOD1=D DENS2F_DNS else DENS2F_NEW
C 2) if ANISO # 0 MR_SCALING
C                1. ACORR # N - anisothermal correction of Fmod
c                   if ANISO = '-' return
C                2. ANISO = K - FSCALE with SCALEP,BSCALE
C                     if scale = 0 - scaling by Fobs (cell must be the same)
C                                    only scale , set BOVER = 0
C                     if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                    no info: rfac, corr
C                   else  CALL PSCALE
C                   output: SCALEP_NEW,BSCALE_NEW and NAMEFM2
c     else no scaling
C     output NAMEFM2,NAMEPH and SCALEP,BSCALE (aniso # 0)
C ---------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRMAX,IPRROW),RESULTA(IPRMAX,IPRROW)
      REAL      RLATT(6),VPST(3)
      CHARACTER NAMEC*(*),NAMED*(*),NAMEFM2*(*),NAMEPH*(*)
      CHARACTER NAMEM*(*),NAMEF*(*),PATH_SCR*(*)
      CHARACTER NAMEFM*256,NAMES*256,NAMES1*256,NAMET*256,NAME*256

      CHARACTER MOD1*1,LIST*1,TEST*1,ACORR*1,ANISO2*1
      CHARACTER MODE_FFT*1,MODE_GD*1,PACK*1,PST*1,SURF*1
      CHARACTER REST*1,HATM*1,NUM*1,NOCC*1,CONV*1,ANISO*1
      CHARACTER LINE*256,P1_FOR_DNS*1
C ------------------
      MD    = -ABS(MDOC)-1
      M     = 99
      MD0   =  0
      IF(ABS(MDOC).GE.99) MD0 = 99
C ---
      IF(LIST.EQ.'S') THEN
        MD=99
      ELSE IF(LIST.EQ.'T') THEN
        MD = MDOC
      ENDIF
      NAMEFM = 'crossrt_f'
      CALL ADD_PATH(PATH_SCR,NAMEFM)
C ---
C ---------------------------------------------
      NX       = NXMIN
      NY       = NYMIN
      NZ       = NZMIN
      MODE_FFT = 'I'
c        MODE_GD  = 'B'
c        BADD_GD  = 0.0
c        RAD_GD   = BLIM 
c        WRITE(LINE,*) 'RAD_GD:',RAD_GD
c        CALL MSGDOC(MDOC,LINE)
      H2OBG = 0.0
      ITEST = 0
C      IF(TEST.EQ.'5') ITEST = 1
C      IF(TEST.EQ.'6') ITEST = 2
      IF(TEST.EQ.'1') ITEST = 1

      NAME = NAMEFM
      IF(ANISO.EQ.'0') NAME = NAMEFM2

      NAMES   = ' '
      NAMES1  = ' '
      NAMET   = ' '
      PACK    = '0'
      PST     = 'N'
      VPST(1) = 0.0
      VPST(2) = 0.0
      VPST(3) = 0.0

      IF(MOD1.EQ.'D') THEN
        P1_FOR_DNS = 'Y'
        CALL DENS2F_DNS(MDOC,LIST,PATH_SCR,NAMET
     *  ,NAMEM,NAMEC,NAMED,NAME,NAMEPH,NAMES,NAMES1
     *  ,IMOD,NX,NY,NZ,IZMIN,IZMAX,ZFADD
     *  ,RESMAX,NEL,P1_FOR_DNS
     *  ,PACK,PST,VPST,ALPHA,BETA,GAMMA,RLATT
     *  ,RESULT,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: in DENS2F_DNS ')
          GO TO 900
        ENDIF
      ELSE
        CALL DENS2F_NEW(MDOC,LIST
     *  ,NAMEM,NAMEC,NAMED,NAME,NAMEPH,NAMES,NAMES1,PATH_SCR
     *  ,NMR,N_MODEL,NX,NY,NZ,IZMIN,IZMAX,ZFADD
     *  ,MODE_FFT,MODE_GD,BADD_GD,RAD_GD,RESMAX,NEL,H2OBG,ITEST,SURF
     *  ,PACK,PST,VPST,ALPHA,BETA,GAMMA,RLATT
     *  ,RESULT,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: in DENS2F_NEW ')
          GO TO 900
        ENDIF
      ENDIF
C -----
      IF(ANISO.NE.'0'.OR.ACORR.NE.'N') THEN
        ANISO2 = ANISO
        IF(ANISO.EQ.'0') ANISO2 = '-'
        CALL MR_SCALING(MDOC,LIST,NAMEF,NAMEFM,NAMEFM2,PATH_SCR,ANISO2
     *  ,SCALEP,BSCALE,ACORR,BOFF_SCL,BADD_SCL,RESMIN,RESMAX
     *  ,SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF
     *  ,RESULTA,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
C ---------------------------------------------------------
C     1. ACORR # N - anisothermal correction of Fmod
c        if ANISO = '-' return
C     2. ANISO = K - FSCALE with SCALEP,BSCALE
C                   if scale = 0 - scaling by Fobs (cell must be the same)
C                      only scale , set BOVER = 0
C                   if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                  no info: rfac, corr
C        else  CALL PSCALE
C      output: SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF and NAMEFM2
C ---------------------------------------------------------
        IF(IERR.NE.0) GO TO 900
      ELSE
        SCALEP_NEW = SCALEP
        BSCALE_NEW = BSCALE
      ENDIF

      SCALEP = SCALEP_NEW
      BSCALE = BSCALE_NEW

C -----
 900  CONTINUE

      NAME='crossrt_f.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)

      RETURN
      END

      SUBROUTINE MR_SCALING(MDOC,LIST,NAMEF,NAMEFM,NAMEFM2,PATH_SCR
     * ,ANISO,SCALEP,BSCALE,ACORR,BOFF_SCL,BADD_SCL,RESMIN,RESMAX
     * ,SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF
     * ,RESULTA,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
C ---------------------------------------------------------
C     1. ACORR # N - anisothermal correction of Fmod
c        if ANISO = '-' return
C     2. ANISO = K - FSCALE with SCALEP,BSCALE
C                   if scale = 0 - scaling by Fobs (cell must be the same)
C                      only scale , set BOVER = 0
C                   if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                  no info: rfac, corr
C        else  CALL PSCALE
C      output: SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF and NAMEFM2
C ---------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULTA(IPRMAX,IPRROW)
      CHARACTER NAMEF*(*),NAMEFM*(*),NAMEFM2*(*),PATH_SCR*(*)
      CHARACTER LIST*1,ACORR*1,ANISO*1
      CHARACTER SOLV*1,PATT*1,MODE*1,REST*1
      CHARACTER RFAC_FLAG*1
      CHARACTER LINE*256,NAME*256,NAMES*256
C ------------------
      MD    = -ABS(MDOC)-1
      M     = 99
      MD0   =  0
      IF(ABS(MDOC).GE.99) MD0 = 99
      IF(LIST.EQ.'T') THEN
        M   = MDOC
        MD  = MDOC
        MD0 = MDOC
      ENDIF
C ------------------
      IF(LIST.EQ.'T') THEN
        WRITE(*,*) 'SCALING:ACORR,ANISO:',ACORR,ANISO
        WRITE(LINE,'('' before:scalep,Bover :'',2F12.3)') 
     *  SCALEP,BSCALE
        CALL MSGDOC(MDOC,LINE)
        WRITE(*,*) ' boff_scl,badd_scl:',BOFF_SCL,BADD_SCL
        write(*,*) '-fm:',NAMEFM
      ENDIF
      SCALEP_NEW = 1.0
      BSCALE_NEW = 0.0 
      RFAC_REF = 0.0 
      CORR_REF = 0.0
      RESULTA(11,1) = 0.0
      RESULTA(12,1) = 0.0
      RESULTA(13,1) = 0.0   
      IF(ACORR.NE.'N') THEN
        NAMES  = 'molrp_scr9'
        CALL ADD_PATH(PATH_SCR,NAMES)
        IF(ANISO.EQ.'-') NAMES = NAMEFM2
        IF(LIST.EQ.'T') 
     *  CALL MSGDOC(MD0,'--- anisothermal correction ---')
        BOFFF  = BOFF_SCL
        BADDD  = BADD_SCL
        SOLV   = 'N'
        PATT   = 'Y'
        SCALE  = 1.0
        BOVER  = 0.0
        NCYCL  = 0
        NAME   = ' '
        RESMNI = 0.0
        RESMXI = 0.0
        CALL ANISOSCL(M,NAMEFM,NAME,NAMES
     *   ,RESMNI,RESMXI,SCALE,BOVER,NCYCL,BOFFF,BADDD,SOLV,PATT
     *  ,ISYM,IPRSYM,RESULTA,IPRMAX,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: in ANISOSCL (correction)')
          GO TO 900
        ENDIF
        CALL MSGDOC(MD,
     *  ' Anisotropic distribution of Structure Factors:')
        WRITE(LINE,'('' Ratio of Eigen values :'',3F8.4)')
     *  RESULTA(11,1),RESULTA(12,1),RESULTA(13,1)    
        CALL MSGDOC(MD,LINE)
      ELSE
        NAMES=NAMEFM
      ENDIF
      IF(ANISO.EQ.'-') RETURN
C -------------------
C     CALL MSGDOC(MD0,'--- scaling ---')
      MM     = 999
      IF(LIST.EQ.'T') MM = MDOC

      IF(ANISO.EQ.'K') THEN
        IF(LIST.EQ.'T') CALL MSGDOC(MD0,'--- FSCALE ---')
        BOFFF  = BOFF_SCL
        BADDD  = BADD_SCL
        RESMNI = RESMIN
        RESMXI = RESMAX
        SCALE  = SCALEP
        BOVER  = BSCALE
        RESMAX_USED = 0.0
        RESMIN_USED = 0.0
        CALL FSCALE(MM,NAMES,NAMEF,NAMEFM2,SCALE,BOVER
     *        ,BOFFF,BADDD,RESMNI,RESMXI
     *        ,RESMIN_USED,RESMAX_USED
     *        ,ISYM,IPRSYM,RESULTA,IERR)
C    if scale = 0 - scaling by F2 (space group must be the same),
C                   only scale , set BOVER = 0
C    if scalei>0  - scaling by SCALEI,BOVERI without FN file, no info
c      output all or by RESMIN_USED,RESMAX_USED
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: in FSCALE')
          GO TO 900
        ENDIF
C       RESULT(4) = SCALE
C       RESULT(5) = RFAC
C       RESULT(6) = RCORR
        RFAC_REF = RESULTA(5,1) 
        CORR_REF = RESULTA(6,1) 
        COEFP  = RESULTA(4,1)  
        BTEMPP = RESULTA(7,1)
      ELSE IF(ANISO.EQ.'Y') THEN
        IF(LIST.EQ.'T') CALL MSGDOC(MD0,'--- ANISOSC ---')
        BOFFF  = BOFF_SCL       
        BADDD  = BADD_SCL
        SOLV   = 'N'
        PATT   = 'Y'
C       - Y means pre-isoscaling by Patterson
        SCALEP = 1.0
        BOVER  = 0.0
        NCYCL  = 0
        RESMNI = RESMIN
        RESMXI = RESMAX
        CALL ANISOSCL(MM,NAMEF,NAMES,NAMEFM2
     *    ,RESMNI,RESMXI,SCALEP,BOVER,NCYCL,BOFFF,BADDD,SOLV,PATT
     *    ,ISYM,IPRSYM,RESULTA,IPRMAX,IERR)
C        RESULT(14,1)=RFACTOR
C        RESULT(15,1)=CC
C        RESULT(20,1)=RFACTOR_I
C        RESULT(21,1)=CC_I
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: in ANISOSCL (scaling)')
          GO TO 900
        ENDIF
        COEFP    = RESULTA(2,3)
        BTEMPP   = RESULTA(1,3)
        RFAC_REF = RESULTA(14,1) 
        CORR_REF = RESULTA(15,1) 
        CALL MSGDOC(MD,
     *  ' Anisotropic scaling , Beta:')
        WRITE(LINE,'(6F8.4)')
     *  RESULTA(5,1),RESULTA(6,1),RESULTA(7,1)    
     *  ,RESULTA(8,1),RESULTA(9,1),RESULTA(10,1)    
        CALL MSGDOC(MD,LINE)
      ELSE
        IF(LIST.EQ.'T') CALL MSGDOC(MD0,'--- PSCALE ---')

        BOFFF = BOFF_SCL
        BADDD = BADD_SCL
        MODE  = 'P'
        REST  = 'N'

        RESMNI = RESMIN
        RESMXI = RESMAX

c       RESMNI = 0.0
c       RESMXI = 0.0

        RFAC_FLAG = 'Y'

        CALL PSCALE(MM,NAMES,NAMEF,NAMEFM2
     *  ,BOFFF,BADDD,MODE,REST,RFAC_FLAG
     *  ,RESMNI,RESMXI,ISYM,IPRSYM,RESULTA,IPRMAX,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: in PSCALE')
          GO TO 900
        ENDIF
        
C      RESULT(17,3) =RCORR  - correlation factor   
C      RESULT(18,3) =CSCALE - Scaling F_out = F_2*cscale*exp(-bscale*S^2/4)
C      RESULT(19,3) =BSCALE
C      RESULT(20,3) =R-FAC  - R-factor

        SCALE1 = SQRT(RESULTA(21,1))
        BOVER1 = RESULTA(6,1)/2.0
        SCALE2 = SQRT(RESULTA(21,2))
        BOVER2 = RESULTA(6,2)/2.0
        COEFP  = SCALE2/SCALE1  
        BTEMPP = BOVER2-BOVER1
        COEFP  = RESULTA(18,3)  
        BTEMPP = RESULTA(19,3)
        RFAC_REF = RESULTA(20,3) 
        CORR_REF = RESULTA(17,3) 

      ENDIF
      WRITE(LINE,'('' scale,B_scale :'',2F12.3)') 
     * COEFP,BTEMPP
      CALL MSGDOC(MDoc,LINE)
C -------------------
      SCALEP_NEW = COEFP
      BSCALE_NEW = BTEMPP 
C -------------------
 900  CONTINUE

      NAME='molrp_scr9.dat'
      CALL DELETE_FILE(PATH_SCR,NAME)

      RETURN
      END

      SUBROUTINE CROSSRF_LOCK(MDOC,NAMEA,NAME_SUM,NP_SRF,NAME_TSRF
     *   ,PATH_SCR,ILOCK,RESULT,IPRMAX,IPRROW
     *   ,NSYM,ISYM,IPRSYM,IERR)
C -------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT (IPRMAX,IPRROW)
      REAL      FRTOCR(3,3),CRTOFR(3,3)
      CHARACTER NAMEA*(*),NAME_SUM*(*),NAME_TSRF*(*),PATH_SCR*(*)
      CHARACTER LINE*256,NAME*256,NAME_A(2)*256,NAMES*256
C -------------------
      MD    =-ABS(MDOC)-1
      M     = 99
      MD0   =  0
      PI    = 4.0*ATAN(1.0)
C ----
      NAME_A(1) = 'crossrt_al1'
      CALL ADD_PATH(PATH_SCR,NAME_A(1))
      NAME_A(2) = 'crossrt_al2'
      CALL ADD_PATH(PATH_SCR,NAME_A(2))
      NAMES     = 'crossrt_al3' 
      CALL ADD_PATH(PATH_SCR,NAMES)
C ---
      CALL GET_CR_MATRIX(FRTOCR,CRTOFR)

      CALL READ_TAB_SRF(MDOC,NAME_TSRF,NP_SRF,RESULT,IPRMAX,IPRROW
     *              ,FRTOCR,CRTOFR,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900

      NP = RESULT(1,12)
 
      IF(NP.LE.0) THEN
        CALL MSGERR(MDOC,
     *  ' ERROR: number of peaks of self rotation function = 0')
        IERR = 1
        GO TO 900
      ENDIF

      IF(ILOCK.LT.0.AND.NP_SRF.LE.0) NP_SRF = NP
      IF(NP.GT.NP_SRF) NP = NP_SRF
      WRITE(LINE,'('' Npeak_selfRF             :'',I4)') NP
      CALL MSGDOC(MD,LINE)
C ---
      IF1 = 1
      IF2 = 2
      IST = 1
      IFN = NP
      IF(NP.LE.1) THEN
        IST = 0
        IFN = 0
      ENDIF

      DO IP=IST,IFN
        IF(IP.EQ.0) THEN
          NAME = NAME_SUM
        ELSE IF(IP.NE.IFN) THEN
          NAME = NAME_A(IF2)
        ELSE IF(IP.EQ.IFN) THEN
          NAME = NAME_SUM
        ENDIF

        IPP = IP
        IF(IP.LE.0) IPP = 1   

        SCALE  = 1.0

        ALPHA  = RESULT(IPP,6)
        BETA   = RESULT(IPP,7)
        GAMMA  = RESULT(IPP,8)

        RF     = RESULT(IPP,5) 
        IF(ILOCK.LT.0) SCALE = RF

C        sg     = RESULT(IPP,4) 
c        scale=rf/34.05
C        write(*,'(i4,5f10.3)') ip,alpha,beta,gamma,rf,sg
c        write(*,'(i4,5f10.3,i5)') ip,alpha,beta,gamma,rf,scale,ilock

        LMAXRR = 0
        LMINRR = 0
     
        IF(IP.EQ.IST) THEN
          CALL RFROT(MDOC,NAMEA,NAMES,ALPHA,BETA,GAMMA
     *    ,LMINRR,LMAXRR,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
c          SCALE=1.0
C   SCALE  - <1.0>   ALMN_new = ALMN_1 + SCALE * ALMN_2
          CALL RFADD(M,NAMEA,NAMES,NAME,SCALE
     *    ,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
        ELSE
          CALL RFROT(MDOC,NAMEA,NAMES,ALPHA,BETA,GAMMA
     *    ,LMINRR,LMAXRR,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
c          SCALE=1.0
          CALL RFADD(M,NAME_A(IF1),NAMES,NAME,SCALE
     *    ,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
        ENDIF
        IT  = IF1
        IF1 = IF2
        IF2 = IT
      ENDDO
C -------------------
 900  CONTINUE
      RETURN
      END

      SUBROUTINE CROSSRF_LOCK_G(MDOC,NAMEA,NAME_SUM,NP_SRF,NAME_TSRF
     *   ,PATH_SCR,RESULT,IPRMAX,IPRROW
     *   ,NSYM,ISYM,IPRSYM,IERR)
C -------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT (IPRMAX,IPRROW)
      REAL      FRTOCR(3,3),CRTOFR(3,3),AM(3,3)
      CHARACTER NAMEA*(*),NAME_SUM*(*),NAME_TSRF*(*),PATH_SCR*(*)
      CHARACTER LINE*256,NAME*256,NAME_A(2)*256,NAMES*256
C -------------------
      MD    =-ABS(MDOC)-1
      M     = 99
      MD0   =  0
      PI    = 4.0*ATAN(1.0)
C ----
      NAME_A(1) = 'crossrt_al1'
      CALL ADD_PATH(PATH_SCR,NAME_A(1))
      NAME_A(2) = 'crossrt_al2'
      CALL ADD_PATH(PATH_SCR,NAME_A(2))
      NAMES     = 'crossrt_al3' 
      CALL ADD_PATH(PATH_SCR,NAMES)
C ---
      CALL LENSTR_BL(NAME_TSRF,LEN)
      IF(LEN.GT.0.AND.
     *   NAME_TSRF(1:1).NE.' '.AND.NAME_TSRF(1:1).NE.',') THEN
        CALL GET_CR_MATRIX(FRTOCR,CRTOFR)

        CALL READ_TAB_SRF(MDOC,NAME_TSRF,NP_SRF,RESULT,IPRMAX,IPRROW
     *              ,FRTOCR,CRTOFR,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
      ENDIF

      NP = RESULT(1,12)
      NP = NP -1
 
      IF(NP.LE.0) THEN
        CALL MSGERR(MDOC,
     *  ' ERROR: number of peaks of self rotation function = 0')
        IERR = 1
        GO TO 900
      ENDIF
   
      IF(NP_SRF.LE.0) NP_SRF = NP

      IF(NP.GT.NP_SRF) NP = NP_SRF
      WRITE(LINE,'('' Npeak_selfRF             :'',I4)') NP
      CALL MSGDOC(MDOC,LINE)

      AVER = 0.0
      IF(NP.GT.1) THEN
        AVER = RESULT(1,5)
        DO I=2,NP+1
          AVER = AVER + RESULT(I,5)
        ENDDO
        AVER = AVER/REAL(NP)
        N = 0
        DO I=2,NP+1
          IF(RESULT(I,5).GT.AVER) N = N + 1
        ENDDO
        NP = N
      ENDIF

      NP1 = NP + 1
      RF1 = RESULT(1,5) 
      RFN = RESULT(NP1,5) 

      WRITE(LINE,'(A,I5,2F10.3)') 'Np,Rf1,RfN:',NP1,RF1,RFN
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,F10.3)') '<Rf>:',AVER
      CALL MSGDOC(MDOC,LINE)
C ---
      IF1 = 1
      IF2 = 2
      IST = 1
      IFN = NP
      IF(NP.LE.1) THEN
        IST = 0
        IFN = 0
      ENDIF

      DO IP=IST,IFN

        IF(IP.EQ.0) THEN
          NAME = NAME_SUM
        ELSE IF(IP.NE.IFN) THEN
          NAME = NAME_A(IF2)
        ELSE IF(IP.EQ.IFN) THEN
          NAME = NAME_SUM
        ENDIF

        IPP = IP
        IF(IP.LE.0) IPP = 1   
        IPP1 = IPP + 1

        SCALE  = 1.0

        ALPHA  = RESULT(IPP1,6)
        BETA   = RESULT(IPP1,7)
        GAMMA  = RESULT(IPP1,8)


        ALP    = (ALPHA*PI)/180.0
        BET    = (BETA *PI)/180.0
        GAM    = (GAMMA*PI)/180.0

        CALL EULERM(ALP,BET,GAM,AM)
        CALL MTOPOL(AM,THETA,PHI,CHI)

        RF     = RESULT(IPP1,5) 
        SCALE = RF/RF1
C       SCALE = (RF-AVER)/(RF1-AVER) 
C       SCALE = (RF-RFN)/(RF1-RFN)
C       IF(SCALE.LT.0.0) SCALE = 0.0 

C        WRITE(LINE,'(i4,5f10.3)') ip,alpha,beta,gamma,rf,scale
        WRITE(LINE,'(i4,5f10.3)') ip,theta,phi,chi,rf,scale
        CALL MSGDOC(MDOC,LINE)

        LMAXRR = 0
        LMINRR = 0
     
        IF(IP.EQ.IST) THEN
          IF(IP.EQ.IFN) NAME = NAME_SUM
          CALL RFROT(M,NAMEA,NAMES,ALPHA,BETA,GAMMA
     *    ,LMINRR,LMAXRR,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
c          SCALE=1.0
C   SCALE  - <1.0>   ALMN_new = ALMN_1 + SCALE * ALMN_2
          CALL RFADD(M,NAMEA,NAMES,NAME,SCALE
     *    ,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900

        ELSE
          CALL RFROT(M,NAMEA,NAMES,ALPHA,BETA,GAMMA
     *    ,LMINRR,LMAXRR,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900
c          SCALE=1.0
          CALL RFADD(M,NAME_A(IF1),NAMES,NAME,SCALE
     *    ,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 900

        ENDIF
        IT  = IF1
        IF1 = IF2
        IF2 = IT
      ENDDO
C -------------------
 900  CONTINUE
      RETURN
      END

      SUBROUTINE DENS2F_DNS(MDOC,LIST,PATH_SCR,NAMEF
     * ,NAMEC,NAMER,NAMED,NAMEFM,NAMEPH,NAMEFM_PK,NAMEPH_PK
     * ,IMOD,NX,NY,NZ,IZMIN,IZMAX,ZFADD
     * ,RESMAX,NEL,P1_FOR_DNS
     * ,PACK,PST,VPST,ALPHA,BETA,GAMMA,RLATT_I
     * ,RESULT,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
C------------------
      COMMON/COM_DPOOL/ IPOOL_MAX,IPOOL_CURR
C -----------------
      INTEGER*2 ISYM(5,3,IPRSYM)
C ----
      REAL      RESULT (IPRMAX,IPRROW)
C ----
      REAL      VPST(3),RLATT_I(6)
      REAL      AM(3,3),SH1(3),SH2(3),CELL(6),ANGLES(3)
      CHARACTER NAMEFM*(*),NAMEPH*(*),NAMEC*(*),NAMED*(*),PATH_SCR*(*)
      CHARACTER NAMEFM_PK*(*),NAMEPH_PK*(*),NAMER*(*),NAMEF*(*)

      CHARACTER P1*1,MODE*1,INVER*1,P1_FOR_DNS*1
      CHARACTER PACK*1,PST*1,LIST*1,POS*1
      CHARACTER PACK_T*1

      REAL      TEMP_F(3)

      CHARACTER LINE*256,TITLE*80,NAME*256
C ---------------------------------
      COMMON/COM_MLR_DENS/ 
     * D_RAD,D_SCALE,D_RADI,D_ORIGIN_F,D_RESOL,DSUM_EL,D_ROLIM
     *,D_SHIFT_BEST,D_ANGLE_BESR,D_RSCALE,D_RAD_PACK
     *,D_NCS
     *,D_MODE,D_POS,D_INVER,D_MOD,D_NAME,D_FLAG_BEST
C -
      INTEGER   D_NCS(2)
      REAL      D_RAD(2),D_SCALE(2),D_RADI(2),D_ORIGIN_F(3,2)
     *         ,D_RESOL(2),DSUM_EL(2),D_ROLIM(2),D_RSCALE(2)
     *         ,D_SHIFT_BEST(3,2),D_ANGLE_BESR(3,2),D_RAD_PACK(2)

      CHARACTER D_MODE*1,D_POS(2)*1,D_INVER(2)*1,D_MOD(2)*1
     *         ,D_NAME(2)*256,D_FLAG_BEST(2)*1
C --------------------------------------------------------------------
      integer,   allocatable :: IPOOLD(:)
C --------------------------------------------------------------------
      PI = 4.0*ATAN(1.0)
      MD =-ABS(MDOC)-10
      M  = 99
      IF(LIST.NE.'T') THEN
        MD = 99
      ELSE
        MD = MDOC
        M  = -ABS(MDOC)-10
      ENDIF
C ----------------
      IF(PACK.EQ.'0') PACK = 'N'
      PACK_INDEX = 1.0 
      NDENSP = 0
      NZERO  = 0
      NDENSM = 0
      NTOT   = 0
      NEL        = 0
C      IVAR       = 1
      IVAR       = 0
      P1 = P1_FOR_DNS
C ------------
      DO I=1,6
        CELL(1) = 0.0
      ENDDO
      IF(RLATT_I(1).GT.0.1) THEN
        CELL(1) = RLATT_I(1)
        CELL(2) = RLATT_I(2)
        CELL(3) = RLATT_I(3)
        CELL(4) = (RLATT_I(4)*180.0)/PI
        CELL(5) = (RLATT_I(5)*180.0)/PI
        CELL(6) = (RLATT_I(6)*180.0)/PI
      ENDIF
C ----
      IF(NX.LE.0) THEN
        CALL LIMHKL(RESMAX,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)
C ----
        CALL MSGDOC(MD,'Minimal grid spacing for calculation SF:') 
        WRITE(LINE,1000) NXMIN,NYMIN,NZMIN
 1000   FORMAT(' NXmin=',I3,', NYmin=',I3,', NZmin=',I3) 
        CALL MSGDOC(MD,LINE)
        NX = NXMIN
        NY = NYMIN
        NZ = NZMIN
      ENDIF 

      IPOOL_MAX = 1
c test
c      IPOOL_MAX = 0
c test

      A  = (ALPHA*PI)/180.0
      B  = (BETA *PI)/180.0
      G  = (GAMMA*PI)/180.0
      CALL EULERM(A,B,G,AM)
      CALL MTOPOL(AM,ANGLES(1),ANGLES(2),ANGLES(3))
C --------------
      IF((PACK.EQ.'Y'.OR.PACK.EQ.'P').AND.IVAR.EQ.0) THEN
        IF(LIST.EQ.'T') THEN
          CALL MSGDOC(MDOC,
     *    '--- generate density for Packing function ---')
          write(*,*) '--rad_p:',D_RAD_PACK(IMOD)
        ENDIF
        DNS_SCALE = D_SCALE(IMOD)
        RAD       = D_RAD_PACK(IMOD) 
        PACK_T    = 'Y'
        MODE      = D_MODE
        POS       = D_POS(IMOD)
        ROLIM     = D_ROLIM(IMOD)
        RO_SCALE  = D_RSCALE(IMOD)
        SH1(1)    = D_ORIGIN_F(1,IMOD)
        SH1(2)    = D_ORIGIN_F(2,IMOD)
        SH1(3)    = D_ORIGIN_F(3,IMOD)
        DO I=1,3
          SH2(I) = 0.0
        ENDDO

        RESMAXI = RESMAX
        CALL GET_OUTPUT_MAP_PARAM(MDOC
     *    ,NAMEC,NAMEF,RESMAXI,CELL,NX,NY,NZ
     *    ,NX_CELL,NY_CELL,NZ_CELL,MEM_POOLD
     *    ,NSM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900

        IF(IPOOL_MAX.LE.0) THEN
          MEM_POOLD = 1
        ELSE
          IPOOL_MAX = MEM_POOLD
        ENDIF

        allocate(IPOOLD(1:MEM_POOLD),STAT=ISTAT)

        IF(ISTAT.NE.0) THEN
          IERR = 1
          CALL MSGERR(MDOC,
     *    ' ERROR: in DENS2F_DNS: problem with memory allocation')
          CALL MSGERR(MDOC,
     *    '                     try to change resolution')
          GO TO 900
        ENDIF
     
        CALL ROTDNS(MDOC,LIST,NAMEC,NAMEF,NAMED
     *    ,MODE,POS,PACK_T,RAD,RESMAX,DNS_SCALE,ROLIM,RO_SCALE
     *    ,ANGLES,SH1,SH2,CELL,NX,NY,NZ,TEMP_F    
     *    ,RESULT,IPOOLD,MEM_POOLD,ISYM,IPRSYM,IERR)
C ---
        IF(IERR.NE.0) THEN
          deallocate(IPOOLD,STAT=ISTAT)
          GO TO 900
        ENDIF
        ZCENTRE = RESULT(10,1) 

        PACK_INDEX = RESULT(21,1) 
        NTOT   = 100
        NDENSP = NTOT
        NZERO  = 0
        NDENSM = 100.0 - FLOAT(NDENSP)*PACK_INDEX


C        P1 = 'Y'
        IAPPL       = 1
c ---
C       --- shift --
        RESULT(1,1) = 0.0
        RESULT(2,1) = 0.0
c        RESULT(3,1) =-ZCENTRE
c ---
        RESULT(3,1) = 0.0
        RESULT(4,1) = 0.0
        RESULT(5,1) = 0.0
        RESULT(6,1) = 0.0
        IERR  = 0
        INVER = D_INVER(IMOD)
        IF(IAPPL.GT.  0)  IERR = 1
        IF(P1   .EQ.'Y')  IERR = IERR + 2
C       IF(PACK .EQ.'Y')  IERR = IERR + 4
C       PACK='Y' - 4, P1='Y' - 2 IAPPL>0 - 1

        MMM = MD
        IF(LIST.EQ.'T') MMM = MDOC
        CALL RFT_NEW(MMM,LIST,PATH_SCR
     *  ,RESMAX,INVER,PST,VPST
     *  ,NAMED,NAMEFM_PK,NAMEPH_PK,ISYM,IPRSYM,RESULT
     *  ,IPOOLD,IPOOL_MAX,IERR)
        deallocate(IPOOLD,STAT=ISTAT)
        IF(IERR.NE.0) GO TO 900
        IF(PACK.EQ.'P') GO TO 900
      ENDIF
c ----
c        write(*,*) 'd:',named
c        write(*,*) 'f:',NAMEFM_PK
c        write(*,*) 'p:',NAMEPH_PK
c
c        NAME  = 'molrep_mod_dns_rot.ps'  
c        CALL ADD_PATH(PATH_SCR,NAME)
c        TITLE = '-- MAP of rot_mod --'      
c        COEF_PS  = 4.0
c        NLEV_PS  = 6 
c        CALL PRINT_DENS_TO_PS(MDOC,NAMED,NAME
c     *      ,TITLE,COEF_PS,NLEV_PS,ISYM,IPRSYM,IERR)
c        IF(IERR.NE.0) RETURN
c        stop
C ----

      IF(LIST.EQ.'T') THEN
        CALL MSGDOC(MDOC,'--- generate density ---')
        write(*,*) '--rad:',D_RAD(IMOD) 
      ENDIF

      DNS_SCALE = D_SCALE(IMOD)
      RAD       = D_RAD(IMOD) 
      PACK_T    = 'N'
      MODE      = D_MODE
      POS       = D_POS(IMOD)
      ROLIM     = D_ROLIM(IMOD)
      RO_SCALE  = D_RSCALE(IMOD)
      SH1(1)    = D_ORIGIN_F(1,IMOD)
      SH1(2)    = D_ORIGIN_F(2,IMOD)
      SH1(3)    = D_ORIGIN_F(3,IMOD)
      DO I=1,3
        SH2(I) = 0.0   
      ENDDO

      RESMAXI = RESMAX
      CALL GET_OUTPUT_MAP_PARAM(MDOC
     *    ,NAMEC,NAMEF,RESMAXI,CELL,NX,NY,NZ
     *    ,NX_CELL,NY_CELL,NZ_CELL,MEM_POOLD
     *    ,NSM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900

      IF(IPOOL_MAX.LE.0) THEN
        MEM_POOLD = 1
      ELSE
        IPOOL_MAX = MEM_POOLD
      ENDIF

      allocate(IPOOLD(1:MEM_POOLD),STAT=ISTAT)

      IF(ISTAT.NE.0) THEN
        IERR = 1
        CALL MSGERR(MDOC,
     *    ' ERROR: in DENS2F_DNS: problem with memory allocation')
          CALL MSGERR(MDOC,
     *    '                     try to change resolution')
        GO TO 900
      ENDIF

      CALL ROTDNS(MD,LIST,NAMEC,NAMEF,NAMED
     *  ,MODE,POS,PACK_T,RAD,RESMAX,DNS_SCALE,ROLIM,RO_SCALE
     *  ,ANGLES,SH1,SH2,CELL,NX,NY,NZ,TEMP_F 
     *  ,RESULT,IPOOLD,MEM_POOLD,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        deallocate(IPOOLD,STAT=ISTAT)
        GO TO 900
      ENDIF
      ZCENTRE = RESULT(10,1)
      SUM_EL  = RESULT(13,1) 

c      PACK_INDEX = RESULT(21,1) 
c      NTOT   = 100
c      NDENSP = NTOT
c      NZERO  = 0
c      NDENSM = 100.0 - FLOAT(NDENSP)*PACK_INDEX
C -----------------
      NEL   = DSUM_EL(IMOD)
 
      IF(PACK.NE.'P') THEN

C        P1 = 'Y'
        IAPPL       = 1
        RESULT(1,1) = 0.0
        RESULT(2,1) = 0.0
c        RESULT(3,1) =-ZCENTRE
        RESULT(3,1) = 0.0
        RESULT(4,1) = 0.0
        RESULT(5,1) = 0.0
        RESULT(6,1) = 0.0
        INVER = D_INVER(IMOD)
        IERR = 0
        IF(IAPPL.GT.  0)  IERR = 1
        IF(P1   .EQ.'Y')  IERR = IERR + 2

        IF(LIST.EQ.'T') THEN
          WRITE(LINE,*) ' SUM_EL,ZCENTRE,INVER:',SUM_EL,ZCENTRE,INVER
          CALL MSGDOC(MDOC,LINE)      
          WRITE(LINE,*) ' IVAR:',IVAR
          CALL MSGDOC(MDOC,LINE)      
        ENDIF
        
C       PACK='Y' - 4, P1='Y' - 2 IAPPL>0 - 1
        CALL RFT_NEW(MD,LIST,PATH_SCR
     *  ,RESMAX,INVER,PST,VPST
     *  ,NAMED,NAMEFM,NAMEPH,ISYM,IPRSYM,RESULT
     *  ,IPOOLD,IPOOL_MAX,IERR)
        IF(IERR.NE.0) THEN
          GO TO 900
        ENDIF
c      IF((LIST.EQ.'L'.OR.LIST.EQ.'T').AND.IPOOL_MAX.EQ.0) THEN
c
c        write(*,*) 'd:',named
c        write(*,*) 'f:',NAMEFM
c        write(*,*) 'p:',NAMEPH
c
c        NAME  = 'molrep_mod_dns_rot.ps'  
c        CALL ADD_PATH(PATH_SCR,NAME)
c        TITLE = '-- MAP of rot_mod --'      
c        COEF_PS  = 4.0
c        NLEV_PS  = 6 
c        CALL PRINT_DENS_TO_PS(MDOC,NAMED,NAME
c     *      ,TITLE,COEF_PS,NLEV_PS,ISYM,IPRSYM,IERR)
c        IF(IERR.NE.0) RETURN
c
c        stop
c
c      ENDIF
        
      ENDIF
 
 
      IF((PACK.EQ.'Y'.OR.PACK.EQ.'P').AND.IVAR.EQ.1) THEN

        IF(LIST.EQ.'T') THEN
          CALL MSGDOC(MD0,'--- Packing function ---')
        ENDIF
C        P1 = 'Y'
        IAPPL       = 1
        RESULT(1,1) = 0.0
        RESULT(2,1) = 0.0
c        RESULT(3,1) =-ZCENTRE
        RESULT(3,1) = 0.0
        RESULT(4,1) = 0.0
        RESULT(5,1) = 0.0
        RESULT(6,1) = 0.0
        INVER = D_INVER(IMOD)
        IERR = 0
        IF(IAPPL.GT.  0)  IERR = 1
        IF(P1   .EQ.'Y')  IERR = IERR + 2
        IERR = IERR + 4

C       PACK='Y' - 4, P1='Y' - 2 IAPPL>0 - 1
c
c       isum  - 8 , lim - 16 DLIM = RESULT(7,1)
C        IF(ISUM.GT.0) IERR = IERR + 8 (intensity sum)
C        IF(LIM.EQ.'Y')IERR = IERR + 16 (DENSITY limit)
c
        IERR = IERR + 16
        RESULT(7,1) = 0.0

        CALL RFT_NEW(MD,LIST,PATH_SCR
     *  ,RESMAX,INVER,PST,VPST
     *  ,NAMED,NAMEFM_PK,NAMEPH_PK,ISYM,IPRSYM,RESULT
     *  ,IPOOLD,IPOOL_MAX,IERR)
        IF(IERR.NE.0) THEN
          deallocate(IPOOLD,STAT=ISTAT)
          GO TO 900
        ENDIF
c      IF(LIST.EQ.'L'.OR.LIST.EQ.'T') THEN
c        write(*,*) 'd:',named
c        write(*,*) 'd:',NAMEFM_PK
c        write(*,*) 'd:',NAMEPH_Pk
c        NAME  = 'molrep_mod_pack_rot.ps'  
c        CALL ADD_PATH(PATH_SCR,NAME)
c        TITLE = '-- MAP of rot_mod --'      
c        COEF_PS  = 4.0
c        NLEV_PS  = 6 
c        CALL PRINT_DENS_TO_PS(MDOC,NAMED,NAME
c     *      ,TITLE,COEF_PS,NLEV_PS,ISYM,IPRSYM,IERR)
c        IF(IERR.NE.0) RETURN
c      ENDIF

      ENDIF

      deallocate(IPOOLD,STAT=ISTAT)

C ----
      IF(PST.EQ.'Y') NEL = NEL*2

      RESULT(1,1) = PACK_INDEX
      RESULT(2,1) = NDENSP
      RESULT(3,1) = NZERO
      RESULT(4,1) = NDENSM
      RESULT(5,1) = NTOT

 900  CONTINUE
      RETURN
      END

      SUBROUTINE F2CIF(MDOC,F_NAME_I,F2_NAME_I,PH_NAME,FO_NAME
     *        ,CFOM,CFREE,CSIG
     *        ,RESMINR,RESMAXR,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C ----------------------------------------------------
C -P- 
C F2CIF    writes a contents of internal BLANC files: Fobs, Fcalc, Phases 
C          to one output formatted CIFile. The exit from program suite BLANC.
C -S-
C          This program reads contents of files: 
C                 Fobs              or  
C                 Fobs and Fcalc    or
C                 Fobs and Phases   or  
C                 Fobs and Fcalc and Phases
C          and writes to one formatted output file ( format CIF). 
C
C   Dialogue and Batch:
C  
C     FILE_F:  - input file_Fobs  of the modules of structure factors.
C     FILE_C:  - input file_Fcalc of the modules of structure factors.
C     FILE_PH: - input file_Phases.
C     RESOL: MIN,MAX - resolution <default from files>
C     FOM:   <Y>,N   - Y means to write FOM'
C     FREE:  <Y>,N   - Y means to write FREE-flag'
C     SIG:   <Y>,N   - Y means to write sigmas of F'
C     FILE_O: <f2cif.cif> - output_file 
C
C  Parameters of subroutine F2CIF: 
C
C      SUBROUTINE F2CIF(MDOC,F_NAME,F2_NAME,PH_NAME,FO_NAME
C     *        ,CFOM,CFREE,CSIG
C     *        ,RESMINR,RESMAXR,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C
C    MDOC   - mode of writing messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C    F_NAME:  - input file_Fobs  of the modules of structure factors.
C    F2_NAME: - input file_Fcalc of the modules of structure factors.
C    PH_NAME: - input file_Phases.
C    RESMINR: - resolution <default from files>
C    RESMAXR:  
C    CFOM:  /character*1/ <Y>,N   - Y means to write FOM'
C    CFREE: /character*1/ <Y>,N   - Y means to write FREE-flag'
C    CSIG:  /character*1/ <Y>,N   - Y means to write sigmas of F'
C    FO_NAME:        - output_file /" " means without output/
C    ISYM     - integer*2 array for cryst.symmetry operators.
C    IPRSYM   - dimension of integer*2 array ISYM(5,3,IPRSYM),
C               number of cryst. symm. operators.
C    IERR     - output signal of error / = 1 -error , = 0 - OK / 
C
C    RESULT /real RESULT(IPRROW)/ - array for output information:
C
C    RESULT(1) - 
C    RESULT(2) - 
C -I-
C ------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW)
      INTEGER*4 MDOC,IERR
      CHARACTER F_NAME_I*(*),F2_NAME_I*(*)
      CHARACTER PH_NAME*(*),FO_NAME*(*)
      CHARACTER STAT*1,CFREE*1,CSIG*1,CFOM*1,CALC*1
C ==============================
      CHARACTER F_NAME*256,F2_NAME*256
      INTEGER*4 MTIN,MTNAT,MTOUT
      CHARACTER ITYPE*4,ITYP*4,ITF1*4,ITF2*4,ITF3*4,ITFW*4
      CHARACTER LINE*256,TTT*80,TTT1*80,TITLE*80,PATH*80,EXT*80
      CHARACTER LINE1*256,STR*256
C -----------------------------------------------------------
      M    = 99
      MD   =-ABS(MDOC)-1

      md = mdoc

      IERR = 0
C
C     ITYP  ='FF  '  means 'F   ' or 'FS  '
C     ITYP  ='F   '
C     ITYP  ='FS  '
C     ITYP  ='    '  means ALL  
C     ITYP  ='ABCD'
C     ITYP  ='COEF'
C     ITYP  ='PH  '
C     ITYP  ='RI  '
C
C     Subroutine ORFILE returns actual type by ITYP
C
      CALC = 'N'
      F_NAME  = F_NAME_I
      F2_NAME = F2_NAME_I

      CALL LENSTR_BL(F_NAME,LEN)
      IF(LEN.LE.0.OR.F_NAME(1:1).EQ.' '.OR.F_NAME(1:1).EQ.',') THEN
        F_NAME  = F2_NAME_I 
        F2_NAME = ' '
        CALC = 'Y'
      ENDIF


      MT1 = 20
      CALL LENSTR_BL(F_NAME,LEN)
      IF(LEN.LE.0.OR.F_NAME(1:1).EQ.' '.OR.F_NAME(1:1).EQ.',') THEN
        IERR=1
        RETURN
      ENDIF
      ITYP = 'FF  '
C
C     ORFILE - 1.open file FNAME 
C              2.reads title of file,return file parameters,fill /COMRDF/.
C                copy file_parameters to /COMRDF/.
C
      CALL ORFILE(MD,MT1,F_NAME,ITYP,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERR: OPEN FILE-F-1')
        RETURN
      ENDIF
C
C     GET_TITLE - gets information from /COMRDF/
C
      CALL GET_TITLE(MD,A,B,C,AL,BE,GA
     *  ,COEF1,BET1,RN,RX,IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
      ITF1 = ITYP
C
C     for 'COEF':   TITLE(1:4)='FOUR' or 'PATT'
C
C -------------------------------------------------------------
C
C     C_RD_CR - copy parameters from common/COMRDF/ to common/CRYSTL/
C               also using CELL parameters from common/CRYSTL/ calculates
C               reciprocal cell parameters and volume and put its 
C               to common/CRYSTL/
C               
      CALL C_RD_CR
C -------------------------------------------------------------
      MT2   = 21
      ITYPE = 'FF  '
      CALL LENSTR_BL(F2_NAME,LEN)
      IF(LEN.LE.0.OR.F2_NAME(1:1).EQ.' '.OR.F2_NAME(1:1).EQ.',') THEN
        MT2=0
      ELSE
        CALL ORFILE(MD,MT2,F2_NAME,ITYPE,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE-2')
          CLOSE(MT1)
          RETURN
        ENDIF
        CALL GET_TITLE(MD,A1,B1,C1,AL1,BE1,GA1
     *  ,DM1,DM2,RN1,RX1,IDM,IDM,IDM,IDM,IDM,TTT,IERR)
        ITF2=ITYPE
      ENDIF
C ------------------
      MT3   = 22
      ITYPE = 'PH  '
      CALL LENSTR_BL(PH_NAME,LEN)
      IF(LEN.LE.0.OR.PH_NAME(1:1).EQ.' '.OR.PH_NAME(1:1).EQ.',') THEN
        MT3=0
      ELSE
        CALL ORFILE(MD,MT3,PH_NAME,ITYPE,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE-PH')
          CLOSE(MT1)
          IF(MT2.GT.0) CLOSE(MT2)
          RETURN
        ENDIF
        CALL GET_TITLE(MD,A2,B2,C2,AL2,BE2,GA2
     *  ,DM1,DM2,RN2,RX2,IDM,IDM,IDM,IDM,IDM,TTT1,IERR)
        ITF3=ITYPE
      ENDIF
C -----------------
      IF(CFOM .EQ.'n') CFOM  = 'N'
      IF(CFOM .NE.'N') CFOM  = 'Y'
      IF(CFREE.EQ.'n') CFREE = 'N'
      IF(CFREE.NE.'N') CFREE = 'Y'
      IF(CSIG .EQ.'n') CSIG  = 'N'
      IF(CSIG .NE.'N') CSIG  = 'Y'
C ---
      RESMIN = RESMINR
      RESMAX = RESMAXR
      IF(RESMIN.LE.0.0)   RESMIN = RN
      IF(RESMAX.LE.0.0)   RESMAX = RX
      IF(RN .LT.RESMIN)   RESMIN = RN
      IF(RX .GT.RESMAX)   RESMAX = RX
      IF(MT2.GT.0) THEN
        IF(RN1.LT.RESMIN)   RESMIN = RN1
        IF(RX1.GT.RESMAX)   RESMAX = RX1
      ENDIF
      IF(MT3.GT.0) THEN
        IF(RN2.LT.RESMIN)   RESMIN = RN2
        IF(RX2.GT.RESMAX)   RESMAX = RX2
      ENDIF
      WRITE(LINE,'(''RESOLUTION MIN,MAX '',2F7.2)') RESMIN,RESMAX
      CALL MSGDOC(MD,LINE)
      RESMIN = RESMIN + 0.0001
      RESMAX = RESMAX - 0.0001
      RHMIN = 1.0/(RESMIN)
      RHMAX = 1.0/(RESMAX)
C ---------------
      MTOUT = 0
      CALL LENSTR_BL(FO_NAME,LEN)
      IF(LEN.GT.0.AND.FO_NAME(1:1).NE.' '.AND.FO_NAME(1:1).NE.',') THEN
        MTOUT=30
        CALL C_CR_WR
C ---
C       C_CR_WR - copy parameters from common/CRYSTL/ to common/COMWRF/
C
C        CALL C_CR_WR
C ---
C       SET_TITLE - sets information to  /COMWRF/
C 
C        CALL SET_TITLE(MD,A,B,C,
C     *  AL,BE,GA,COEF1,BET1,RESMIN,RESMAX,
C     *  IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
C        ITFW = 'F   '
C
C       OWFILE - 1.open file 
C                2.writes title to file, parameters from common /COMRDF/
C
C        CALL OWFILE(MD,MTOUT,FO_NAME,ITFW,NSYM,ISYM,IPRSYM,IERR)
        PATH  = ' '
        EXT   = ' '      
        CALL OPENFW(MTOUT,MD,PATH,FO_NAME,EXT,IERR)
        IF(IERR.NE.0) THEN
          CLOSE (MT1)
          IF(MT2.GT.0) CLOSE (MT2)
          IF(MT3.GT.0) CLOSE (MT3)
          CALL MSGERR(MDOC,' ERR: OPEN FILE-OUTPUT')
          IERR=1
          RETURN
        ENDIF

        CALL WR_TITLE_CIF(M,MTOUT,ITYP,TITLE
     *   ,MT2,MT3,CSIG,CFOM,CFREE,CALC
     *   ,NSYM,ISYM,IPRSYM,IERR)

      ENDIF

C ----------------------------------------------------------
C ---
C 
C     initialization for CENTR_BL and ANOMSC
C
      CALL INIT_CENTR(NSYM,ISYM)
      CALL ANOMF(M,NSYM,ISYM)
C
C     calc limits H,k,l and grid for RESMAX
C
      RES = RESMAX

      CALL LIMHKL(RES,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)
      
      SUMA   = 0.0
      SUMB   = 0.0
      SUMFOM = 0.0
      NTOT   = 0
C ----
      IEND1 =-1
      IEND2 =-1
      IEND3 =-1
      IENDW =-1
      JH    =-200
      JK    =-200
      JL    =-200
      KH    =-200
      KK    =-200
      KL    =-200
      LH    =-200
      LK    =-200
      LL    =-200
C -----------------------------------------
      DO     IL=0,ILMAX
      DO     IK=-IKMAX,IKMAX
      DO     IH=-IHMAX,IHMAX
        IF(IH.EQ.0.AND.IK.EQ.0.AND.IL.EQ.0) GO TO 100
        IHP = IH
        IKP = IK
        ILP = IL
C
C        ANOMSC - transforms h,k,l to asymmetrycal part of reciprocal space.
C        output : IH,IK,IL -   indices h,k,l from asymmetrycal part
C                 IANOM    - 0   +h,+k,+l
C                            1   -h,-k,-l
C                 JJSYM    - number operator of symmetry :
C                                 in(h,k,l) -- JJSYM --> out(h,k,l)
C
        CALL ANOMSC(IHP,IKP,ILP,IANOM,JJSYM,NSYM,ISYM)
        IF(IANOM.NE.1.OR.JJSYM.NE.1) GO TO 100

        IF(NSYM.GT.1) THEN
C
C         SYSABS - check systematic absent for h,k,l: 1 - absent, 0 - no.
C
          CALL SYSABS_BL(IH,IK,IL,NSYM,ISYM,ICND)
        ELSE
          ICND = 0
        ENDIF
C
C ---   ICND NE 0 systematic absent
C
        IF(ICND.NE.0) GO TO 100
C 
C       DSTAR - gives value of (4pi*sin(theta))/lambda for H,K,L
C
        CALL DSTAR(IH,IK,IL,RSQ)
        RH = SQRT(RSQ)
c        IF(RH.LT.RHMIN.OR.RH.GT.RHMAX) GO TO 100
C ---
C       CENTR_BL - Determine whether a reflection (IH,IK,IL) is centric or not

        CALL CENTR_BL(IH,IK,IL,JCENT)
C
C ---   JCENT = 1 centric reflection, JCENT = 0 acentric reflection
C ---
C ------
  200   CONTINUE
        IMISS1 = 1
        IF(IEND1.GT.0)                    GO TO 110

C        IF(JL-IL) 240,210,300
C  210   IF(JK-IK) 240,220,300
C  220   IF(JH-IH) 240,230,300

        IF((JL-IL).LT.0) THEN
          GO TO 240
        ELSE IF((JL-IL).EQ.0) THEN
          GO TO 210
        ELSE 
          GO TO 100
        ENDIF

 210    IF((JK-IK).LT.0) THEN
          GO TO 240
        ELSE IF((JK-IK).EQ.0) THEN
          GO TO 220
        ELSE 
          GO TO 100
        ENDIF

 220    IF((JH-IH).LT.0) THEN
          GO TO 240
        ELSE IF((JH-IH).EQ.0) THEN
          GO TO 230
        ELSE 
          GO TO 100
        ENDIF

C ------
  240   CONTINUE
C
C        RD1 - read from MT1 ; type of file :"F   ","PH  ","COEF","ALMN"
C        RRD1- read from MT1 ; type of file :"FS  "
C 
        IF(ITF1.EQ.'FS  ') THEN
          CALL RRD1(MT1,JH,JK,JL,FN,FNA,SN,SNA,KEY1,IEND1)
        ELSE
          CALL RD1(MT1,JH,JK,JL,FN,FNA,KEY1,IEND1)
C
C        IF(ITF2.EQ.'COEF') THEN
C          CALL RD1(MT1,JH,JK,JL,FA,FB,KEY1,IEND1)
C        IF(ITF2.EQ.'ABCD') THEN
c          CALL RABCD(MT1,JH,JK,JL,AC,BC,CC,DC,KEY1,IEND1)
C        IF(ITF2.EQ.'PH  ') THEN
c          CALL RD1(MT1,JH,JK,JL,COSFOM,SINFOM,KEY1,IEND1)
C
C Possible to use:
C          CALL RD(MT1,JH,JK,JL,FN,FNA,KEY1,IEND1)
C          CALL RRD(MT1,JH,JK,JL,FN,FNA,SN,SNA,KEY1,IEND1)
C          CALL RD2(MT1,JH,JK,JL,FN,FNA,KEY1,IEND1)
C          CALL RRD2(MT1,JH,JK,JL,FN,FNA,SN,SNA,KEY1,IEND1)
C          CALL RD3(MT1,JH,JK,JL,FN,FNA,NUMB,IEND)
C          CALL RRD3(MT1,JH,JK,JL,FN,FNA,SN,SNA,KEY1,IEND1)
C          CALL RD4(MT1,JH,JK,JL,FN,FNA,KEY1,IEND1)
C          CALL RRD4(MT1,JH,JK,JL,FN,FNA,SN,SNA,KEY1,IEND1)
C          CALL RABCD1(MT1,JH,JK,JL,AC,BC,CC,DC,KEY1,IEND1)
C

C         SIG-DUMMY
          SN  = 0.04*FN
          SNA = 0.04*FNA
        ENDIF

        IT1 = KEY1/2        
        IFLAG_FREE = KEY1 - IT1*2 
        IT3  = IT1/2
        IT3  = IT3-IT1*2
C       if IFLAG_FREE = 1 - free reflection
C       use program COPYFL to set "free flag".
        STAT = 'o'
        IF(IFLAG_FREE.EQ.1) STAT = 'f'
        IF(IT3       .EQ.1) STAT = 'r'


 
        IF(MT1.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE_1')
          IF(MT2.GT.0)   CLOSE (MT2)
          IF(MT3.GT.0)   CLOSE (MT3)
          IF(MTOUT.GT.0) CLOSE (MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(IEND1.GT.0)                   GO TO 110
        IF(FN.LE.1.E-6.AND.FNA.LE.1.E-6) GO TO 100
        IF(FN.GT.1.E-6.AND.FNA.GT.1.E-6) THEN
          WT1 = 1./(SN*SN)
          WT2 = 1./(SNA*SNA)
          WT  = WT1+WT2
          FN  = FN*WT1+FNA*WT2
          FN  = FN/WT
          SN  = 1./SQRT(WT)
        ELSE IF(FNA.GT.1.E-6) THEN
          FN = FNA
          SN = SNA
        ENDIF
        GO TO 200

  230   IMISS1 = 0
C ------
  300   CONTINUE
        IMISS2=1
        IF(IEND2.LT.0.AND.MT2.LE.0)                   GO TO 400
        IF(IEND2.GT.0.OR.MT2.LE.0)                    GO TO 110

C        IF(KL-IL) 340,310,400
C  310   IF(KK-IK) 340,320,400
C  320   IF(KH-IH) 340,330,400

        IF((KL-IL).LT.0) THEN
          GO TO 340
        ELSE IF((KL-IL).EQ.0) THEN
          GO TO 310
        ELSE 
          GO TO 100
        ENDIF

 310    IF((KK-IK).LT.0) THEN
          GO TO 340
        ELSE IF((KK-IK).EQ.0) THEN
          GO TO 320
        ELSE 
          GO TO 100
        ENDIF

 320    IF((KH-IH).LT.0) THEN
          GO TO 340
        ELSE IF((KH-IH).EQ.0) THEN
          GO TO 330
        ELSE 
          GO TO 100
        ENDIF

C ------
  340   CONTINUE
        IF(ITF2.EQ.'FS  ') THEN
          CALL RRD2(MT2,KH,KK,KL,FD,FDA,SF,SFA,KEY2,IEND2)
        ELSE
          CALL RD2(MT2,KH,KK,KL,FD,FDA,KEY2,IEND2)
C         SIG-DUMMY
          SF  = 0.04*FD
          SFA = 0.04*FDA
        ENDIF
        IF(MT2.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE_2')
          IF(MT1.GT.0)   CLOSE (MT1)
          IF(MT3.GT.0)   CLOSE (MT3)
          IF(MTOUT.GT.0) CLOSE (MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(IEND2.GT.0)                   GO TO 110
        IF(FD.LE.1.E-6.AND.FDA.LE.1.E-6) GO TO 100
        IF(FD.GT.1.E-6.AND.FDA.GT.1.E-6) THEN
          WT1 = 1./(SF*SF)
          WT2 = 1./(SFA*SFA)
          WT  = WT1+WT2
          FD  = FD*WT1+FDA*WT2
          FD  = FD/WT
          SF  = 1./SQRT(WT)
        ELSE IF(FDA.GT.1.E-6) THEN
          FD = FDA
          SF = SFA
        ENDIF
        GO TO 300

  330   IMISS2 = 0
C --------------------------------------------
  400   CONTINUE

        IMISS3 = 1
        IF(IEND3.LT.0.AND.MT3.LE.0)                   GO TO 500
        IF(IEND3.GT.0.OR.MT3.LE.0)                    GO TO 110

        IF((LL-IL).LT.0) THEN
          GO TO 440
        ELSE IF((LL-IL).EQ.0) THEN
          GO TO 410
        ELSE 
          GO TO 100
        ENDIF

 410    IF((LK-IK).LT.0) THEN
          GO TO 440
        ELSE IF((LK-IK).EQ.0) THEN
          GO TO 420
        ELSE 
          GO TO 100
        ENDIF

 420    IF((LH-IH).LT.0) THEN
          GO TO 440
        ELSE IF((LH-IH).EQ.0) THEN
          GO TO 430
        ELSE 
          GO TO 100
        ENDIF
C ------
  440   CONTINUE
        CALL RD3(MT3,LH,LK,LL,COSFOM,SINFOM,KEY3,IEND3)
        IF(MT3.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE_PH')
          IF(MT1.GT.0)   CLOSE (MT1)
          IF(MT2.GT.0)   CLOSE (MT2)
          IF(MTOUT.GT.0) CLOSE (MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(IEND3.GT.0)                   GO TO 110

        TEMP = (COSFOM*COSFOM+SINFOM*SINFOM)
        FOM  = SQRT(TEMP)
C       WRITE(*,*) FOM,TEMP
        IF(FOM.LE.0.00001) GO TO 440
        COPH = COSFOM/FOM
        SIPH = SINFOM/FOM
        IF(ABS(COPH).LT.1.E-5) THEN
          PHI = 90.
          IF(SIPH.LT.0.) PHI = PHI+180.
        ELSE
          PHI = (ATAN(SIPH/COPH))*57.29578
          IF(PHI.LT.0.) THEN
            IF(SIPH.LE.0.) THEN
              PHI = PHI + 360.
            ELSE
              PHI = PHI + 180.
            ENDIF
          ELSE IF(PHI.EQ.0.) THEN
            IF(COPH.LT.0.) PHI = PHI + 180.
          ELSE
            IF(SIPH.LE.0.) PHI = PHI + 180.
          ENDIF
        ENDIF
        IF(ABS(PHI-360.0).LT.0.0001) PHI = 0.0
C       SUMFOM = SUMFOM+FOM

        GO TO 400


  430   IMISS3 = 0
C --------------------------------------------
  500   CONTINUE
C -----------------------------------------------------
C       SUMFOM = SUMFOM+FOM

        NTOT = NTOT+1

C ---
        IF(MTOUT.GT.0) THEN
c          IF(CSIG.EQ.'Y'.AND.CALC.EQ.'N') THEN
          IF(CSIG.EQ.'Y') THEN
            WRITE(LINE1,
     *      '(3I6,1X,F14.3,1X,F12.3)') 
     *      IH,IK,IL,FN,SN
          ELSE
            WRITE(LINE1,
     *      '(3I6,1X,F14.3)') 
     *      IH,IK,IL,FN
          ENDIF
          LINE = LINE1
          IF(MT2.GT.0) THEN
c            IF(CSIG.EQ.'Y') THEN
c              WRITE(LINE,
c     *        '(F12.4,1X,F10.4)') 
c     *        FD,SF
c            ELSE
              WRITE(LINE1,
     *        '(F14.3)') 
     *        FD
c            ENDIF
            CALL LENSTR_BL(LINE ,LEN)
            CALL LENSTR_BL(LINE1,LEN1)
            STR  = LINE(1:LEN)//' '//LINE1(1:LEN1)
            LINE = STR
          ENDIF
          IF(MT3.GT.0) THEN
            IF(CFOM.EQ.'Y') THEN
              WRITE(LINE1,
     *        '(F8.3,1X,F6.3)') 
     *        PHI,FOM
            ELSE
              WRITE(LINE1,
     *        '(F8.3)') 
     *        PHI
            ENDIF
            CALL LENSTR_BL(LINE ,LEN)
            CALL LENSTR_BL(LINE1,LEN1)
            STR  = LINE(1:LEN)//' '//LINE1(1:LEN1)
            LINE = STR
          ENDIF
          IF(CFREE.EQ.'Y') THEN
            CALL LENSTR_BL(LINE ,LEN)
            STR  = LINE(1:LEN)//' '//STAT
            LINE = STR
          ENDIF
          CALL WRTSTR(MTOUT,M,LINE,IERR)
        ENDIF
C ----
 100  CONTINUE
      ENDDO
      ENDDO
      ENDDO
C ---------------------------------------
  110 CONTINUE
      CLOSE (MT1)
      IF(MT2.GT.0) CLOSE (MT2)
      IF(MT3.GT.0) CLOSE (MT3)

      IF(MTOUT.GT.0) THEN
        IF(NTOT.LE.0) THEN
          CALL MSGERR(MDOC,' ERROR: number of reflections = 0')
          CLOSE(MTOUT)
          IERR=1
          RETURN
        ENDIF
C ---
        END FILE MTOUT
        CLOSE(MTOUT)
      ENDIF
C ----------------------------------------------
      RESULT(1) = NTOT
      RESULT(2) = RESMIN
      RESULT(3) = RESMAX
C -----------------------------------------------------------
      WRITE(LINE,1000) NTOT
 1000 FORMAT('Number or refletions = ',I9)
      CALL MSGDOC(M,LINE)
      RETURN
      END

      SUBROUTINE WR_TITLE_CIF(MDOC,IOUT,TYPE,STR
     * ,MT2,MT3,CSIG,CFOM,CFREE,CALC
     * ,NSYM,ISYM,NSMAX,IERR)
C ----------------------------------------------------------
      INTEGER   NSYM,MDOC,IOUT,IERR
      INTEGER   NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER TYPE*4,STR*(*)
C ------------------------------------------------------------
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
      CHARACTER LINE*256,CHAR20*20,CH1*1,CH2*2,CH3*3
      CHARACTER ICS_CATEGORY*40,ICS_CELL(6)*40
     *         ,ICS_SCALE(9)*40,ICS_U(3)*40
     *         ,ICS_ORIGX(9)*40,ICS_T(3)*40
     *         ,ICS_A(4)*40,ICS_B(4)*40,ICS_C*40,ICS_FI*40,ICS_FII*40
     *         ,ICS_RADIUS*40,ICS_NSPGR*40,ICS_SETT*40
     *         ,ICS_CD_PDB*40,ICS_NAME_PDB*40,ICS_DATE_PDB*40
     *         ,ICS_TITLE*40,ICS_RESL_PDB*40,ICS_RFAC_PDB*40
     *         ,ICS_MODEL*40,ICS_SPGR*40,ICS_SYMOP*40,ICS_ATYPE*40
C ---
      CHARACTER SYMOP*24,CH10*10,CODE*8,TEMPER*5,WAVE*5,CODE_NDB*8
      CHARACTER TITLE*80,CSIG*1,CFOM*1,CFREE*1,CALC*1
C -------------------------------------------------------------------
      PI=4.0*ATAN(1.0)
      PI180=PI/180.0
      IERR=0
C --------------------------------
       ICS_CATEGORY   = '_database_PDB.'
       ICS_CD_PDB     = 'code'
       ICS_NAME_PDB   = 'name'
       ICS_DATE_PDB   = 'date'
       ICS_TITLE      = 'compnd'
       ICS_RESL_PDB   = 'remark_resolution'
       ICS_RFAC_PDB   = 'remark_R_factor'
       ICS_MODEL      = 'model'
C
       ICS_CELL(1)    = '_cell.length_a'
       ICS_CELL(2)    = '_cell.length_b'
       ICS_CELL(3)    = '_cell.length_c'
       ICS_CELL(4)    = '_cell.angle_alpha'
       ICS_CELL(5)    = '_cell.angle_beta'
       ICS_CELL(6)    = '_cell.angle_gamma'
C
       ICS_SPGR       = '_symmetry.space_group_name_H-M'
       ICS_NSPGR      = '_symmetry.Int_Tables_number'
       ICS_SETT       = '_symmetry.cell_setting_number'
       ICS_SYMOP      = '_symmetry_equiv.pos_as_xyz'
C
C --------------------------------
c      CALL LENSTR_BL(USER_TITLE,LEN)
c      IF(LEN.LT.9) THEN 
c        TITLE = '?'
c        WAVE  = '?'
c        TEMPER= '?'
c      ELSE IF(LEN.LT.69) THEN 
c        TITLE = USER_TITLE(9:68)
c        WAVE  = '?'
c        TEMPER= '?'
c      ELSE IF(LEN.LT.74) THEN 
c        TITLE = USER_TITLE(9:68)
c        WAVE  = USER_TITLE(69:73)
c        TEMPER= '?'
c      ELSE
c        TITLE = USER_TITLE(9:68)
c        WAVE  = USER_TITLE(69:73)
c        TEMPER= USER_TITLE(74:78)
c      ENDIF
c
c      CALL LENSTR_BL(PDB_NAME,LEN)
c      IF(LEN.LE.4) THEN
c        CODE         ='XXXX    '
c        CODE_NDB     ='?'
c      ELSE
c        IF(LEN.GT.12) LEN=12   
c        CODE=PDB_NAME(5:LEN)
c        CODE_NDB     = CODE
c      ENDIF
c
c      IF(CODE_NDB(1:4).EQ.PDB_CODE.AND.CODE_NDB(5:8).EQ.'    ')
c     *  CODE_NDB='?'
c
c      IF(CODE(1:1).EQ.'?'.OR.CODE(1:1).EQ.' '.OR.CODE(1:1).EQ.'.'.OR.
c     *   CODE(1:4).EQ.'XXXX') THEN
c        CODE    = PDB_CODE//'    '    
c        CODE_NDB= '?'
c      ENDIF

      CODE         ='XXXX    '
      CALL LENSTR_BL(CODE,LENCD)

      WRITE(LINE,'(''data_structure_'',A)') CODE(1:LENCD)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
c        CALL LENSTR_BL(ICS_CATEGORY,LENC)
C ---
c      WRITE(LINE,
c     *'(''_database_2.database_id'',2X,A)') CODE(1:LENCD)
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c      CALL LENSTR_BL(PDB_CODE,LEN)
c      WRITE(LINE,
c     *'(''_database_2.code_PDB   '',2X,A)') PDB_CODE(1:LEN)
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c      IF(CODE_NDB(1:1).NE.'?') THEN
c        WRITE(LINE,
c     *'(''_database_2.code_NDB   '',2X,A)') CODE(1:LENCD)
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c      ENDIF
C ---
c      WRITE(LINE,'(''_struct_keywords.entry_id'',2X,A)') CODE(1:LENCD)
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c      CALL LENSTR_BL(PDB_NAME,LEN)
c      IF(LEN.LE.12) THEN
c        PDB_NAME(13:13)='?'
c        LEN=13
c      ENDIF
c      IF(LEN.GT.32) LEN=32
c      WRITE(LINE,110) PDB_NAME(13:LEN)
c  110 FORMAT(       
c     * '_struct_keywords.text  ',2X,'''',A,'''')
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
c      WRITE(LINE,'(''_struct.entry_id'',2X,A)') CODE(1:LENCD)
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c      CALL LENSTR_BL(TITLE,LEN)
c      IF(LEN.GT.60) LEN=60
c      WRITE(LINE,200) TITLE(1:LEN)
c  200 FORMAT(       '_struct.title   ',2X,'''',A,'''')
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
c      WRITE(LINE,'(''_database_PDB_rev.num 1'')') 
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c
c      CALL CHNG_DATE(PDB_DATE,CH10)
c
c      WRITE(LINE,'(''_database_PDB_rev.date_original'',2X,A)') 
c     * CH10(1:10)
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
c      CALL CHCLOCK(CHAR20)
c      WRITE(LINE,210) CHAR20
c  210 FORMAT(       '_file_creation_date ',2X,'''',A,'''')
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
c      CALL LENSTR_BL(TEMPER,LEN)
c      IF(LEN.GT.0.AND.TEMPER(1:1).NE.'.'.AND.TEMPER(1:1).NE.' '.AND.
c     *   TEMPER(1:1).NE.'?') THEN
c        WRITE(LINE,'(''_diffrn.entry_id             '',2X,A)') 
c     *  CODE(1:LENCD)
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c        IF(LEN.GT.5) LEN=5
c        WRITE(LINE,340) TEMPER(1:LEN)
c  340   FORMAT('_diffrn.ambient_temperature    ',A)
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c      ENDIF
C ---
c      CALL LENSTR_BL(WAVE,LEN)
c      IF(LEN.GT.0.AND.WAVE(1:1).NE.'.'.AND.WAVE(1:1).NE.' '.AND.
c     *   WAVE(1:1).NE.'?') THEN
c        WRITE(LINE,'(''_diffrn_radiation.entry_id  '',2X,A)') 
c     *  CODE(1:LENCD)
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c        IF(LEN.GT.5) LEN=5
c        WRITE(LINE,350) WAVE(1:LEN)
c  350   FORMAT('_diffrn_radiation.wavelength  ',A)
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c      ENDIF
C ---
        AL_CELL=AL_CELL/PI180
        BE_CELL=BE_CELL/PI180
        GA_CELL=GA_CELL/PI180
        WRITE(LINE,'(''_cell.entry_id  '',2X,A)') CODE(1:LENCD) 
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.length_a   '',2X,F8.3)') A_CELL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.length_b   '',2X,F8.3)') B_CELL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.length_c   '',2X,F8.3)') C_CELL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.angle_alpha'',2X,F8.3)') AL_CELL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.angle_beta '',2X,F8.3)') BE_CELL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.angle_gamma'',2X,F8.3)') GA_CELL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.formula_units_Z  ?'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
        WRITE(LINE,'(''_symmetry.entry_id  '',2X,A)') CODE(1:LENCD) 
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        CALL LENSTR_BL(SP_GROUP,LEN)
        WRITE(LINE,100)  SP_GROUP(1:LEN)
  100   FORMAT('_symmetry.space_group_name_H-M',2X,'''',A,'''')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)

c        WRITE(LINE,400)  NSP_GROUP
c  400   FORMAT('_symmetry.Int_Tables_number   ',2X,I5)
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c        WRITE(LINE,500)  N_SETT
c  500   FORMAT('_symmetry.cell_setting_number ',2X,I5)
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c        WRITE(LINE,'(''loop_'')')
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c        WRITE(LINE,'(''_symmetry_equiv.id'')')
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c        WRITE(LINE,'(''_symmetry_equiv.pos_as_xyz'')')
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ----------------------------------------
C --- SYM ---
c      DO     I=1,NSYM
c        LINE=' '
cC        LINE(1:3)='SYM'
cC        WRITE(CH3,'(I3)') I
cC        LINE(4:4)=CH3(3:3)
cC        LINE(5:5)=' '
c        L=0
c        DO J=1,3
c          IF(ISYM(5,J,I).EQ.0) ISYM(5,J,I)=1
c          TR=REAL(ISYM(4,J,I))/REAL(ISYM(5,J,I))
c          IF(TR.LT.0) THEN
c            L=L+1
c            LINE(L:L)='-'
c            NEG=1
c          ELSE
c            NEG=0
c          ENDIF
c          TR=ABS(TR)
c          IF(TR.GT.0.49.AND.TR.LT.0.51) THEN
c            L=L+1
c            LINE(L:L+2)='1/2'
c            L=L+2
c          ELSE IF(TR.GT.0.24.AND.TR.LT.0.26) THEN
c            L=L+1
c            LINE(L:L+2)='1/4'
c            L=L+2
c          ELSE IF(TR.GT.0.32.AND.TR.LT.0.34) THEN
c            L=L+1
c            LINE(L:L+2)='1/3'
c            L=L+2
c          ELSE IF(TR.GT.0.74.AND.TR.LT.0.76) THEN
c            L=L+1
c            LINE(L:L+2)='3/4'
c            L=L+2
c          ELSE IF(TR.GT.0.165.AND.TR.LT.0.167) THEN
c            L=L+1
c            LINE(L:L+2)='1/6'
c            L=L+2
c          ELSE IF(TR.GT.0.66.AND.TR.LT.0.67) THEN
c            L=L+1
c            LINE(L:L+2)='2/3'
c            L=L+2
c          ELSE IF(TR.GT.0.833.AND.TR.LT.0.835) THEN
c            L=L+1
c            LINE(L:L+2)='5/6'
c            L=L+2
c          ELSE
c            IF(NEG.GT.0) L=L-1
c          ENDIF
c          DO  K=1,3
c            IDG=ISYM(K,J,I)
c            IF(IDG.LT.0) THEN
c              L=L+1
c              LINE(L:L)='-'
c            ELSE IF(IDG.GT.0) THEN
c              L=L+1
c              LINE(L:L)='+'
c            ENDIF
c            IDG=ABS(IDG)
c            IF(IDG.GT.1.AND.IDG.LT.10) THEN
c              WRITE(CH1,'(I1)') IDG
c              L=L+1
c              LINE(L:L)=CH1
c            ELSE IF(IDG.GT.9.AND.IDG.LT.100) THEN
c              WRITE(CH2,'(I2)') IDG
c              L=L+1
c              LINE(L:L+1)=CH2
c              L=L+1
c            ELSE IF(IDG.GT.99.AND.IDG.LT.1000) THEN
c              WRITE(CH3,'(I3)') IDG
c              L=L+1
c              LINE(L:L+2)=CH3
c              L=L+2
c            ENDIF
c            IF(IDG.NE.0) THEN
c              L=L+1
c              IF(K.EQ.1) THEN
c                LINE(L:L)='X'
c              ELSE IF(K.EQ.2) THEN
c                LINE(L:L)='Y'
c              ELSE
c                LINE(L:L)='Z'
c              ENDIF
c            ENDIF
c          ENDDO
c          LINE(L+1:L+3)=' , '
c          L=L+3
c        ENDDO
c        CALL LENSTR_BL(LINE,LEN)
c        JL=0
c        DO IL=1,LEN
c          IF(LINE(IL:IL).NE.' ') THEN
c            JL=JL+1
c            LINE(JL:JL)=LINE(IL:IL)
c          ENDIF
c        ENDDO
c        LEN=JL
c        SYMOP = LINE(1:LEN)
c        WRITE(LINE,510)  I,SYMOP(1:LEN)
c  510   FORMAT('    ',I3,2X,A)
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c      ENDDO
C -------------------------
      WRITE(LINE,'(''loop_'')')
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      LINE='_refln.index_h'
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      LINE='_refln.index_k'
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      LINE='_refln.index_l'
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C -------------------------
      IF(CALC.EQ.'N') THEN
        LINE='_refln.F_meas_au'
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        IF(CSIG.EQ.'Y') THEN
          LINE='_refln.F_meas_sigma_au'
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDIF
      ENDIF
      IF(MT2.GT.0.OR.CALC.EQ.'Y') THEN
        LINE='_refln.F_calc'
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        IF(CSIG.EQ.'Y') THEN
          LINE='_refln.F_sigma'
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDIF
      ENDIF
      IF(MT3.GT.0) THEN
        LINE='_refln.phase_calc'
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        IF(CFOM.EQ.'Y') THEN
          LINE='_refln.fom'
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDIF
      ENDIF
      IF(CFREE.EQ.'Y') THEN
        LINE='_refln.status'
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C -----------------------------------------
      RETURN
      END

      SUBROUTINE TRF_PRECALC_MOD12(MDOC
     * ,NAMEF,NAMEM,NAMEC,NAMEC12
     * ,NAMEFM1_N,NAMEPH1,NAMEFM1_PK,NAMEPH1_PK
     * ,NAMEFM2_N,NAMEPH2,NAMEFM2_PK,NAMEPH2_PK
     * ,NAMEFM12,NAMEPH12,NAMEFM12_PK,NAMEPH12_PK
     * ,PATH_SCR,SH12,LIST,PST
     * ,ALPHA1,BETA1,GAMMA1,ALPHA2,BETA2,GAMMA2,PACK,ANISO,SURF
     * ,RESMIN,RESMAX,BOFF,BOFF_SCL,BADD,BADD_SCL
     * ,NEL,NUM_MON,BLIM,NMR,SCALEP,BOVER,H2OBG
     * ,ISYM,IPRSYM
     * ,RESULT,RESULTA,IPRMAX,IPRROW,IERR)
C ----------------------------------------------------------------
C 1) NAMEM + NAMEC = NAMEC12      
C 2) SFVSUM  and  SFVSUM forpaking functon (PACK # N)
C 3) if ANISO = K - FSCALE with SCALEP,BOVER
C                   if scale = 0 - scaling by Fobs (cell must be the same)
C                                  only scale , set BOVER = 0
C                   if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                  no info: rfac, corr
C     else  ANISOSCL
C           if ANISO = Y - pre-isoscaling by Patterson and aniso scaling
C           else  only isoscaling by Patterson
C
C     output NAMEFM12,NAMEPH12 and SCALEP,BOVER 
C            NAMEFM12_PK,NAMEPH12_PK(if PACK # N )
C ----------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER NAMEF*(*),NAMEM*(*) ,NAMEC12*(*),NAMEC*(*),PATH_SCR*(*)
      CHARACTER NAMEFM1_N*(*),NAMEFM1_PK*(*)
      CHARACTER NAMEPH1*(*)  ,NAMEPH1_PK*(*)
      CHARACTER NAMEFM2_N*(*),NAMEFM2_PK*(*)
      CHARACTER NAMEPH2*(*)  ,NAMEPH2_PK*(*)
      CHARACTER NAMEFM12*(*) ,NAMEFM12_PK*(*)
      CHARACTER NAMEPH12*(*) ,NAMEPH12_PK*(*)
      REAL      RESULT (IPRMAX,IPRROW)
      REAL      RESULTA(IPRMAX,IPRROW)
      CHARACTER NAMET*256,NAMET1*256,NAMET2*256,NAMES*256,NAMES1*256
      CHARACTER NAMER*256
      CHARACTER LINE*256,ANISO*1,PACK*1,SURF*1,LIST*1,INVER*1,ACORR*1
      CHARACTER REST*1,SETT*1,HATM*1,NUM*1,NOCC*1,CONV*1
     *         ,MODE*1,WAT*1,ALT*1,P1*1,TTT*80,PST*1
      CHARACTER SOLV*1,PATT*1,CHAR1*1,MODE_FFT*1
      REAL      SH1(3),SH2(3),AM(3,3),SH12(3),SH12F(3),RLATT(6)
      REAL      SPST(3)
C ----------------------------------------------------------
      IERR    = 0
      PI      = 4.0*ATAN(1.0)
      MD      = -ABS(MDOC)-1
      M       = 99
      MMM     = 99
      MD0     = 0
      IF(MDOC.EQ.99) MD0 = 99
      IF(ABS(MDOC).EQ.2) MD = 99
      IF(LIST.EQ.'T') THEN
        MD  = MDOC
        MMM = MDOC
      ENDIF
C ------------------------------
      RESULT(1,1) = 1.0 
      RESULT(2,1) = 0.0 
      RESULT(3,1) = 0.0 
      RESULT(4,1) = 0.0 
      RESULT(5,1) = 0.0 

      NAMET      = 'trfn_scr2'
      CALL ADD_PATH(PATH_SCR,NAMET)
      NAMET1     = 'trfn_scr1'
      CALL ADD_PATH(PATH_SCR,NAMET1)
      NAMET2     = 'trfn_scr3'
      CALL ADD_PATH(PATH_SCR,NAMET2)
      NAMES  = 'trfn_scr9'
      CALL ADD_PATH(PATH_SCR,NAMES)
      DO I=1,6
        RLATT(I) = 0.0
      ENDDO
      DO I=1,3
        SPST(I) = 0.0
      ENDDO
C ---
      CALL LENSTR_BL(NAMEC12,LEN)
      IF(LEN.GT.0) THEN
        MODE   = 'E'
        DO I=1,3
          SH1(I) = 0.0
          SH2(I) = 0.0
          DO J=1,3
            AM(I,J) = 0.0
          ENDDO
        ENDDO
        CALL TRANS(MMM,NAMEM,NAMET2,SH1,SH2
     *  ,MODE,AM,ALPHA1,BETA1,GAMMA1,RESULT,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
        MODE   = 'E'
        DO I=1,3
          SH1(I) = 0.0
          SH2(I) = SH12(I)
          DO J=1,3
            AM(I,J) = 0.0
          ENDDO
        ENDDO
        CALL TRANS(MMM,NAMEC,NAMET,SH1,SH2
     *    ,MODE,AM,ALPHA2,BETA2,GAMMA2,RESULT,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
C ---
        IERR = NUM_MON + 1
        CALL JOINCRD(MMM,NAMET2,NAMET,NAMEC12,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
      ELSE
        LINE = ' ERROR: in TRF_PRECALC_MOD12: wrong file name C12'
        CALL MSGDOC(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF
C --------------------------------------------
      CALL LENSTR_BL(NAMEFM12,LEN)
      CALL LENSTR_BL(NAMEPH12,LENP)
      IF((LEN .LE.0.OR.NAMEFM12(1:1).EQ.' '.OR.NAMEFM12(1:1).EQ.',').OR.
     *   (LENP.LE.0.OR.NAMEPH12(1:1).EQ.' '.OR.NAMEPH12(1:1).EQ.','))
     *   THEN
        LINE = ' ERROR: in TRF_PRECALC_MOD12: wrong file name F12'
        CALL MSGDOC(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF

      CALL LENSTR_BL(NAMEFM12_PK,LEN)
      CALL LENSTR_BL(NAMEPH12_PK,LENP)
      IF(PACK.NE.'N') THEN
      IF((LEN .LE.0.OR.NAMEFM12_PK(1:1).EQ.' '.OR.
     *    NAMEFM12_PK(1:1).EQ.',').OR.
     *   (LENP.LE.0.OR.NAMEPH12_PK(1:1).EQ.' '.OR.
     *  NAMEPH12_PK(1:1).EQ.',')) THEN
        LINE = ' ERROR: in TRF_PRECALC_MOD12: wrong file name F12_PK'
        CALL MSGDOC(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF
      ENDIF
C ------------------------
      RAD     = 0.0
      BADDD   = 0.0
      NX      = 0
      NY      = 0
      NZ      = 0
      IZMAX   =-1
      IZMIN   = 0
      MODE    = 'A'
      IF(SURF.EQ.'C') MODE = 'C'
      MODE_FFT= ' '
      N_MODEL = 0
      H2OBG   = 0.0
      ITEST   = 0
C ---      
      IF(SURF.EQ.'Y'.OR.SURF.EQ.'C') THEN
        RAD = BLIM + 0.000001
      ENDIF
C ---
      IF(LIST.EQ.'T') THEN
        CALL MSGDOC(MD0,'---  DENS2F_NEW ---')
        WRITE(*,*)  'NMR,NMR_INP:',NMR,NMR_INP
      ENDIF
C --      
      CHAR1 = PST
      NAMER = ' '
      ALPHA = 0.0
      BETA  = 0.0
      GAMMA = 0.0
      CALL DENS2F_NEW(MDOC,LIST
     *   ,NAMEC12,NAMET,NAMET1,NAMES,NAMEPH12
     *   ,NAMEFM12_PK,NAMEPH12_PK,PATH_SCR
     *   ,NMR,N_MODEL,NX,NY,NZ,IZMIN,IZMAX,ZFADD
     *   ,MODE_FFT,MODE,BADDD,RAD,RESMAX,NEL,H2OBG,ITEST,SURF
     *   ,PACK,CHAR1,SPST,ALPHA,BETA,GAMMA,RLATT
     *   ,RESULT,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
      PACK_INDEX = RESULT(1,1) 
      NDENSP = RESULT(2,1) 
      NZERO  = RESULT(3,1) 
      NDENSM = RESULT(4,1) 
C================================================== 
      CALL MSGDOC(MD0,'--- scaling ---')

      IF(LIST.EQ.'T') THEN
        M = MDOC
      ENDIF

c      SCALEP= 1.0
c      BOVER = 0.0
      BSCALE = BOVER
      ACORR = 'N'
      CALL MR_SCALING(M,LIST,NAMEF,NAMES,NAMEFM12,PATH_SCR
     * ,ANISO,SCALEP,BSCALE,ACORR,BOFF_SCL,BADD_SCL,RESMIN,RESMAX
     * ,SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF
     * ,RESULTA,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
C ---------------------------------------------------------
C     1. ACORR # N - anisothermal correction of Fmod
c        if ANISO = '-' return
C     2. ANISO = K - FSCALE with SCALEP,BSCALE
C                   if scale = 0 - scaling by Fobs (cell must be the same)
C                      only scale , set BOVER = 0
C                   if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                  no info: rfac, corr
C        else  CALL PSCALE
C      output: SCALEP_NEW,BSCALE_NEW and NAMEFM2
C ---------------------------------------------------------
      IF(IERR.NE.0) GO TO 900

      SCALEP = SCALEP_NEW 
      BOVER  = BSCALE_NEW 
C ----
  900 CONTINUE

      NAMES='trfn_scr1.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trf_scr2.dat'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_scr1.crd'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_scr2.crd'
      CALL DELETE_FILE(PATH_SCR,NAMES)
      NAMES='trfn_scr3.crd'
      CALL DELETE_FILE(PATH_SCR,NAMES)

      RETURN
      END
