C
C     MOLREP molecular replacement program
C     Copyright (C) 1999-2006 Alexei Vagin
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C

      SUBROUTINE RFT_NEW(MDOC,LIST,PATH_SCR
     * ,RESMAX,INVER,PST,VPST
     * ,NAMED,NAMEF,NAMEPH,ISYM,IPRSYM,RESULT
     * ,POOLD,JPOOL_MAX,IERR)
C ---------------------------------------------
C -P- 
C RFT      fast fourie transform: real --> complex.
C          Program transforms contents of DENS-file to F and PH files.
C          For all space groups.
C          Density file has to contain asymm. part of unit cell.
C          You neet to use REDUCT before or program RFFT.
C -S-
c        IERR = 0
c        IF(IAPPL.GT.  0)  IERR = 1
c        IF(P1   .EQ.'Y')  IERR = IERR + 2
C        IF(PACK .EQ.'Y')  IERR = IERR + 4
C        PACK='Y' - 4, P1='Y' - 2 IAPPL>0 - 1
C
C        IF(ISUM.GT.0) IERR = IERR + 8 (intensity sum)
C        IF(LIM.EQ.'Y')IERR = IERR + 16 (DENSITY limit)
C
C        /IERR/ = 1
C        IAPPL    = 1
C        SHIFT(1) = RESULT(1) 
C        SHIFT(2) = RESULT(2)
C        SHIFT(3) = RESULT(3)
C        CSCALE   = RESULT(4)
C        BSCALE   = RESULT(5)
C        DSCALE   = RESULT(6)
C        /IERR/ = 2 (
C        P1   = 'Y'
C        /IERR/ = 4
C        FPACK = 'Y' 
C
C      RESULT /real RESULT(11)/ - array for output information:
C
C      RESULT(1) - number of refls
C      RESULT(2) - min resolution
C      RESULT(3) - max resolution
C      RESULT(4) - F(0,0,0)
C      RESULT(5) - <!F!> = sqrt(<I>)
C      RESULT(6) - < I > 
C -I-
C ---------------------------------------------
      REAL      POOLD(*)

C      REAL      SFA(IPRSYM),SFB(IPRSYM)
C      REAL      SYM(3,IPRSYM)
C      INTEGER   JHS(IPRSYM),JKS(IPRSYM),JLS(IPRSYM),LSYM(IPRSYM)
      real,        allocatable :: POOL(:)
      real,        allocatable :: SFA(:)
      real,        allocatable :: SFB(:)
      real,        allocatable :: SYM(:,:)
      integer,     allocatable :: JHS(:)
      integer,     allocatable :: JKS(:)
      integer,     allocatable :: JLS(:)
      integer,     allocatable :: LSYM(:)

      REAL      RESULT(*),VPST(*)
      REAL      SHIFT(3)
      INTEGER*2 ISYM(5,3,IPRSYM)
c      CHARACTER NAME*256
      CHARACTER NAMED*(*),NAMEF*(*),NAMEPH*(*),P1*1,FPACK*1
      CHARACTER PATH_SCR*(*)
      CHARACTER INVER*1,PST*1,LIST*1,LIM*1,ITYPE*4,TITLE*80
C -------------------------------------------------------------
      COMMON/COM_DPOOL/ IPOOL_MAX,IPOOL_CURR
C--------------------------------------------------------------
      FPACK = 'N'
      P1    = 'N'
      ISUM  = 0
      LIM   = 'N'
      DLIM  = 0.0
C --
      IE = IERR/16
      IF(IE.GT.0) THEN
        LIM  = 'Y'
        DLIM = RESULT(7)
        IERR = IERR - IE*16
      ENDIF
      IE = IERR/8
      IF(IE.GT.0) THEN
        ISUM = 1
        IERR = IERR - IE*8
      ENDIF
       IE = IERR/4
      IF(IE.GT.0) THEN
        FPACK = 'Y' 
        IERR  = IERR - IE*4
      ENDIF
      IE = IERR/2 
      IF(IE.GT.0) THEN
        P1   = 'Y'
        IERR = IERR - IE*2
      ENDIF
      IAPPL    = 0
      SHIFT(1) = 0.0
      SHIFT(2) = 0.0
      SHIFT(3) = 0.0
      CSCALE   = 0.0
      BSCALE   = 0.0
      DSCALE   = 0.0
      IF(IERR.EQ.1) THEN
        SHIFT(1) = RESULT(1) 
        SHIFT(2) = RESULT(2)
        SHIFT(3) = RESULT(3)
        CSCALE   = RESULT(4)
        BSCALE   = RESULT(5)
        DSCALE   = RESULT(6)
        IAPPL    = 1
      ENDIF
      IF(ABS(CSCALE).LT.0.000001) CSCALE = 1.0 
      IF(ABS(DSCALE).LT.0.000001) DSCALE = 1.0 
      IERR = 0
      MD    =-ABS(MDOC)-1
      M     = 99
C ---
      RESULT(1) = 0.0
      RESULT(2) = 0.0
      RESULT(3) = 0.0
      RESULT(4) = 0.0
      RESULT(5) = 0.0
      RESULT(6) = 0.0
      RESULT(7) = 0.0
      RESULT(8) = 0.0
C ----
c      IF(JPOOL_MAX.GT.0) THEN
cc        MEMORY = MEMORY_TOT - IPOOL_MAX
c        I0     = MEMORY + 1
c        MEMORY = MEMORY_TOT
c      ELSE
c        I0     = 1
c        MEMORY = MEMORY_TOT
c      ENDIF
C ----
      MTIN  = 40
      ITYPE = 'RI  '
      IPOOL_MAX  = JPOOL_MAX
      IPOOL_CURR = 0
      CALL ORFILE_MEM(M,MTIN,NAMED,ITYPE,NSYM,ISYM,IPRSYM
     *  ,POOLD,IERR)
      IF(IERR.GT.0) THEN
        IERR=1
        RETURN
      ENDIF
      CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *        ,F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TITLE,IERR)
      IF(IPOOL_MAX.LE.0) CLOSE(MTIN)
      IF(IERR.GT.0) THEN
        IERR=2
        RETURN
      ENDIF
c ----
      NCRES = NX*NY*2
      ITEMP = NCRES + 1000
      IT = 0
      allocate(POOL(1:ITEMP),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(SFA(1:IPRSYM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(SFB(1:IPRSYM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(SYM(1:3,1:IPRSYM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(JHS(1:IPRSYM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(JKS(1:IPRSYM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(JLS(1:IPRSYM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(LSYM(1:IPRSYM),STAT=ISTAT)
      IF(IT.GT.0) THEN
        IERR = 1
        CALL MSGERR(MDOC,
     *    ' ERROR: in RFT_NEW: problem with memory allocation')
        CALL MSGERR(MDOC,
     *    '                    try to change resolution')
        RETURN
      ENDIF

C     CALL ADD_PATH(PATH_SCR,NAMES)

c      IF(JPOOL_MAX.GT.0) THEN
        CALL RFT1_NEW(MDOC,POOL(2),POOL(1),POOL(2),NCRES,RESMAX
     *   ,INVER,PST,VPST
     *   ,NAMED,NAMEF,NAMEPH,IPRSYM,ISUM
     *   ,P1,IAPPL,SHIFT,CSCALE,BSCALE,FPACK,DSCALE
     *   ,LIM,DLIM
     *   ,SFA,SFB,SYM,JHS,JKS,JLS,LSYM,ISYM
     *   ,RESULT,POOLD,JPOOL_MAX,IERR)

c      ELSE
c        CALL RFT1_NEW(MDOC,POOL(2),POOL(1),POOL(2),NCRES,RESMAX
c     *   ,INVER,PST,VPST
c     *   ,NAMED,NAMEF,NAMEPH,IPRSYM,ISUM
c     *   ,P1,IAPPL,SHIFT,CSCALE,BSCALE,FPACK,DSCALE
c     *   ,LIM,DLIM
c     *   ,POOL(IPRSM0),POOL(IPRSM0+IPRSYM),POOL(IPRSM0+IPRSYM*2)
c     *   ,POOL(IPRSM0+IPRSYM*5),POOL(IPRSM0+IPRSYM*6)
c     *   ,POOL(IPRSM0+IPRSYM*7),POOL(IPRSM0+IPRSYM*8),ISYM
c     *   ,RESULT,POOL(I0),JPOOL_MAX,IERR)
c      ENDIF

      deallocate(POOL,STAT=ISTAT)
      deallocate(SFA,STAT=ISTAT)
      deallocate(SFB,STAT=ISTAT)
      deallocate(SYM,STAT=ISTAT)
      deallocate(JHS,STAT=ISTAT)
      deallocate(JKS,STAT=ISTAT)
      deallocate(JLS,STAT=ISTAT)
      deallocate(LSYM,STAT=ISTAT)

c       MT=10
c       NAME='molrp_scratch_rft'
c       OPEN(UNIT=MT,FILE=NAME,ACCESS='SEQUENTIAL',ERR=16)
c       CLOSE(MT,STATUS='DELETE',ERR=16)
c 16    CONTINUE

      RETURN
      END

      SUBROUTINE TRFUN(MDOC,NAMEF,NAMEM,NAME_PH,NAME2,NAMET_OUT
     * ,NAMED,NAME_FCALC,NAME_PHCALC,PATH_SCR
     * ,IPK_RF,PRF_SH,NC,NPTR,NMR_INP,N_MODEL,NEL2_INP,NCP,NCS_ID
     * ,ANGLES_NCS_INP,CENTRE_NCS
     * ,PARM_TR,FPAR_TR,SPST,PEAK_TEST
     * ,ISYM,IPRSYM
     * ,RESULT,RESULTA,IPRMAX,IPRROW,IERR)
C --------------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
C ----
      REAL      RESULT(IPRMAX,IPRROW)
C     REAL      RESULTA(51,51)
      REAL      RESULTA(IPRMAX,IPRROW)
      CHARACTER PARM_TR*30
      REAL      PEAK_TEST(12,*)
      REAL      FPAR_TR(20)
C ---
      CHARACTER NAMEF*(*),NAMEM*(*),NAME2*(*),NAME_PH*(*),NAMET_OUT*(*)
      CHARACTER NAME_FCALC*(*),NAME_PHCALC*(*),NAMED*(*),PATH_SCR*(*)

      real,    allocatable ::  POOL_SCR(:)

C --------
      COMMON/TRFUN_STOR_INFOR/ 
     *  PACK_INDEX_STOR,NEL1_STOR,IFILE_STOR,IFILE_PK_STOR
     * ,NAMEFM_STOR,NAMEPH_STOR,NAMEFM_PK_STOR,NAMEPH_PK_STOR
C ---
      CHARACTER NAMEFM_STOR(200)*256
      CHARACTER NAMEPH_STOR(200)*256
      CHARACTER NAMEFM_PK_STOR(200)*256
      CHARACTER NAMEPH_PK_STOR(200)*256
      REAL      PACK_INDEX_STOR(200)
      INTEGER   NEL1_STOR(200) 
      INTEGER   IFILE_STOR(200) 
      INTEGER   IFILE_PK_STOR(200) 
C --------
      CHARACTER NAMEFM_PK*256,NAMEPH_PK*256
      CHARACTER NAMEFM*256,NAMEPH*256
      CHARACTER NAMEFM2*256,NAMEPH2*256
      CHARACTER NAMEFM2_PK*256,NAMEPH2_PK*256
      CHARACTER NAME_TR*256,NAMEF_TMP*256
      CHARACTER NAME_COEFF*256
      CHARACTER NAMEC*256,NAMEC1*256,NAMEC2*256,NAMEC3*256,NAMEC4*256
      CHARACTER NAMES*256,NAMES2*256,NAMET*256
      CHARACTER NAME_MOD2*256,NAME_MOD1*256,NAMEDD*256
      CHARACTER NAME(10)*256,NAME_DNS(2)*256,NAME_CRD(2)*256

      CHARACTER LINE*256,TTT*80,ITYPE*4,P1*1,MODE*1,WAT*1,ALT*1
      CHARACTER REST*1,SETT*1,HATM*1,NUM*1,NOCC*1,MISS*1,GAUSS*1
      CHARACTER MOD2*1,FUNC*1,ACCUM*1,REMOV*1,INVER_R*1,RFAC_FLAG*1
      CHARACTER SPEC*1,CONV*1,REFP*1,TFUN*1,PACK*1,SURF*1,SURFX*1
      CHARACTER REFS*1,REFB*1,REFA*1,REFX*1,DOM*1,PACK_T*1,PST*1
      CHARACTER ANISO*1,SOLV*1,PATT*1,REF*1,PACKR*1,CALC2*1,INVERT*1
      CHARACTER ANISO_RB,MODE_RB*1,REF_TEMP*1,MOD2_INI*1,MODE_D*1
      CHARACTER LAP*1,MSGA*1,MOD22*1,PRF*1,FAST*1,FIT*1,TEST*1,LIST*1
      CHARACTER MODE_T*1,STICK*1,TTEST*1,PST_T*1,SURF_T*1,MOD1*1
      CHARACTER MODE_FFT*1,ANISO_T*1,FCALC*1,F000*1,DIFF*1,MODE2*2
      CHARACTER CH3*3,CH6*6

      INTEGER   NPK_TFUN(2)
      REAL      AM(3,3),SH1(3),SH2(3),SHH2(3,10),SPST(3),PRF_SH(3)
      REAL      X(3),Y(3),RLATT(6),SH_CALC(3,50)
      CHARACTER CODEPDB*4,NAMEPDB*40,DATEPDB*9,SPGR*24,TITLEPDB*80 
C ---
      PARAMETER (IPRDOM = 300)
      REAL      ANGLES_NCS(3,IPRDOM)
      REAL      ANGLES_NCS_INP(3),CENTRE_NCS(3)
C ---------------------------------------
      INCLUDE 'molrep_lh_infor.fh'
C      COMMON/COM_LH_INFOR/ BOFF_LH,BADD_LH,BOFF_FOR_SCAL
C     *   ,CHECK_CONTRAST,CONTRAST_LIM
C     *   ,BCORR_LH,FILE_FOBS_LH,SCORE_FLAG,LH_LH,DB_LH 
CC ---
C      REAL      CHECK_CONTRAST,CONTRAST_LIM
C      REAL      BOFF_FOR_SCAL,BOFF_LH,BADD_LH,BCORR_LH
C      CHARACTER LH_LH*1,SCORE_FLAG*1,DB_LH*1
C      CHARACTER FILE_FOBS_LH*256
C ----------------------------------
      CHARACTER TIME_CURRENT*15,TIME_ELAPSED*15,TIME_EXPECTED*15
C ------------------------------------------------------------
      COMMON/TRFUN_COM_TMP/ FOBS_000,FMOD1_000,FMOD2_000,NEL2,IERR_PK
     *                     ,SCALEP_STORE,BOVER_STORE,SIGMA_STORE
C ---
      INTEGER  IFIRST_RUN
      DATA IFIRST_RUN/0/ 
C -------------------------------------------------------------
      NUM_MON   = IERR
      IERR      = 0
C ------
      PI      = 4.0*ATAN(1.0)
      RTODEG  = 180./PI
      DEGTOR  = 1.0/RTODEG

      MD      = -ABS(MDOC)-1
      M       = 99
      MD0     = MDOC
      IF(ABS(MDOC).GE.99) MD0 = 99
c -------------------------
c      NRUN_TIME   = 0
c      ITIME_START = 0
c      CALL EXPECTED_TIME(ITIME_START,NRUN_TIME
c     *    ,ITIME_CURR,TIME_CURRENT,TIME_ELAPSED,TIME_EXPECTED)
c      WRITE(LINE,*) 'Time:',TIME_CURRENT,' Elapsed:',TIME_ELAPSED
c      CALL MSGDOC(MDOC,LINE)
c      WRITE(*,*) 'Time:',TIME_CURRENT,' Elapsed:',TIME_ELAPSED
C -------------------------
      TFUN     = PARM_TR( 1: 1)
      REFP     = PARM_TR( 2: 2) 
      REF      = PARM_TR( 3: 3) 
      PACKR    = PARM_TR( 4: 4) 
      PST      = PARM_TR( 5: 5) 
      CALC2    = PARM_TR( 6: 6) 
      ANISO    = PARM_TR( 7: 7) 
      SURF     = PARM_TR( 8: 8) 
      REF_TEMP = PARM_TR( 9: 9) 
      MOD2_INI = PARM_TR(10:10) 
      INVER_R  = PARM_TR(11:11) 
      PRF      = PARM_TR(12:12) 
      FAST     = PARM_TR(13:13) 
      FIT      = PARM_TR(14:14) 
      MODE_T   = PARM_TR(15:15) 
      TEST     = PARM_TR(16:16) 
      STICK    = PARM_TR(17:17) 
      MOD1     = PARM_TR(18:18) 
      MOD2     = PARM_TR(19:19) 
      LIST     = PARM_TR(20:20)
      DIFF     = PARM_TR(21:21)
      SURFX    = PARM_TR(22:22)

      TTEST    = TEST
      IF(STICK.EQ.'Y') TTEST = '3'
      IF(LIST.EQ.'S') MD = 99
      IF(LIST.EQ.'L') MD = -ABS(MDOC)-1
      IF(LIST.EQ.'T') MD = MDOC
C ---
      RESN     = FPAR_TR( 1) 
      RESX     = FPAR_TR( 2) 
      ALPHA    = FPAR_TR( 3) 
      BETA     = FPAR_TR( 4) 
      GAMMA    = FPAR_TR( 5) 
      BOFF     = FPAR_TR( 6) 
      BOFFP    = FPAR_TR( 7) 
      BADD     = FPAR_TR( 8) 
      BLIM     = FPAR_TR( 9) 
      RSMIN_RB = FPAR_TR(10) 
      RSMAX_RB = FPAR_TR(11) 
      BOFF_SCL = FPAR_TR(12)
      BADD_SCL = FPAR_TR(13)
      ARAD     = FPAR_TR(15) 
      RESMIN_OUT = FPAR_TR(17) 
      IFIRST_SCL = FPAR_TR(18)

      IF(LIST.EQ.'T') THEN
        WRITE(*,*) '-1-IFIRST_SCL:',IFIRST_SCL,IFIRST_RUN
      ENDIF

      IF(IFIRST_SCL.LT.0) THEN
        IFIRST_RUN =-1
        IFIRST_SCL = 0
        DO I=1,200
          IFILE_STOR(I) = 0
          IFILE_PK_STOR(I) = 0
        ENDDO
      ELSE IF(IFIRST_SCL.EQ.0) THEN
        IF(IFIRST_RUN.LT.0) IFIRST_RUN = 1
      ENDIF

      IF(LIST.EQ.'T') THEN
        WRITE(*,*) '-2-IFIRST_SCL:',IFIRST_SCL,IFIRST_RUN
      ENDIF

      FCALC      = 'N'
      NP_CALC    = 0
      RMAX_PK = 0.0
      RMIN_PK = 0.0
      SIGMA   = 0.0

      IF(TFUN.EQ.'F') THEN
        TFUN = 'S'
        PARM_TR(1:1) = TFUN
        PACKR = 'N'
        PARM_TR( 4: 4) = PACKR
        FCALC      = 'Y'
        NP_CALC    =  RESULT(1,12)
        IF(NP_CALC.GT.0) THEN
          DO I=1,NP_CALC
            SH_CALC(1,I) = RESULT(I, 9)
            SH_CALC(2,I) = RESULT(I,10)
            SH_CALC(3,I) = RESULT(I,11)
          ENDDO
C        SH_CALC(1) = FPAR_TR(14)
C        SH_CALC(2) = FPAR_TR(15)
C        SH_CALC(3) = FPAR_TR(16)
       
        ELSE
          CALL MSGERR(MD,
     *    'ERROR: number of peaks = 0 in TRFUN (for TFUN = F )')
          IERR = 1
          GO TO 900
        ENDIF
      ENDIF

C ---

      NPT  = NPTR
      PACK = PACKR

c      IF(PACK.EQ.'n') PACK = 'N'
c      IF(PACK.EQ.'p') PACK = 'P'
c      IF(PACK.NE.'N'.AND.PACK.NE.'P') PACK = 'Y'

      IF(RESX.LT.0.00001) RESX = 3.0

      IF(NC.LE.0) NC = 5

C ----------------------
C     -- fobs --
      MTN   = 10
      ITYPE = 'FF  '
      CALL ORFILE(M,MTN,NAMEF,ITYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: OPEN INPUT-FILE-FOBS (in TRFUN)')
        GO TO 900
      ENDIF

      CALL GET_TITLE(MD,A,B,C,AL,BE,GA
     *  ,F1,F2,RESMIN,RESMAX,IDM,IDM,IDM,IDM,IDM,TTT,IERR)

      CALL C_RD_CR
      CALL GET_CELL(RLATT,CODEPDB,NAMEPDB,DATEPDB,TITLEPDB
     *   ,NSPGR,NSETT,SPGR,NSM,IERR)

      CALL CALC_NREF_FOR_RESMAX_SCR(RESMAX,RLATT,NSYM,ISYM,NTOT_SCR)

      IF(LIST.EQ.'T') THEN
        WRITE(*,*) '-4-:',NTOT_SCR,RESMAX,NSYM
      ENDIF


      CLOSE(MTN)
C -----------------------
      IF(MOD2.EQ.'N'.AND.NSYM.EQ.1.AND.PACK.NE.'N') THEN
        CALL MSGDOC(MD,
     *  'WARNING: program will not compute Packing function for P1')
        PACK='N'
      ENDIF
C -------------------------
      IF(RESX.GT.0.00001) RESMAX = RESX
      IF(RESN.GT.0.00001.AND.RESN.LT.RESMIN) RESMIN = RESN
      IF(RESMIN.LT.RESMAX) THEN
        T      = RESMIN
        RESMIN = RESMAX
        RESMAX = T
      ENDIF
      IF(RESMIN.EQ.RESMAX) THEN
        CALL MSGERR(MDOC,' ERROR: resmin = resmax')
        IERR=1
        GO TO 900
      ENDIF
      IF(BOFF .LE.0.000001) BOFF  =  900.0
      IF(BOFFP.LE.0.000001) BOFFP = 1600.0
C -------------------------
      NAME_MOD1 = ' '
      NAME_MOD2 = ' '
      NAMET      = ' '
      NAMES      = ' '
      NAMES2     = ' '
      NAMEC      = 'trfn_scr'
      CALL ADD_PATH(PATH_SCR,NAMEC)  
      NAMEC1     = 'trfn_scr4'
      CALL ADD_PATH(PATH_SCR,NAMEC1)  
      NAMEC2     = 'trfn_scr5'
      CALL ADD_PATH(PATH_SCR,NAMEC2)  
      NAMEC3     = 'trfn_scr6'
      CALL ADD_PATH(PATH_SCR,NAMEC3)  
c      NAMEC4     = 'trfn_scr7'

c      NAMEDD     = 'trfun_dns3'
c      NAME_DNS(1)= 'trfun_dns1'
c      NAME_DNS(2)= 'trfun_dns2'

      NAMEFM     = 'trfn_f'
      CALL ADD_PATH(PATH_SCR,NAMEFM)  
      NAMEPH     = 'trfn_ph'
      CALL ADD_PATH(PATH_SCR,NAMEPH)  
      NAMEFM_PK  = 'trfn_f_pk'
      CALL ADD_PATH(PATH_SCR,NAMEFM_PK)  
      NAMEPH_PK  = 'trfn_ph_pk'
      CALL ADD_PATH(PATH_SCR,NAMEPH_PK)  

      IF(MOD2.EQ.'Y') THEN 
        NAMEFM2    = 'trfn_f2'
        CALL ADD_PATH(PATH_SCR,NAMEFM2)  
        NAMEPH2    = 'trfn_ph2'
        CALL ADD_PATH(PATH_SCR,NAMEPH2)  
        NAMEFM2_PK = 'trfn_f2_pk'
        CALL ADD_PATH(PATH_SCR,NAMEFM2_PK)  
        NAMEPH2_PK = 'trfn_ph2_pk'
        CALL ADD_PATH(PATH_SCR,NAMEPH2_PK)  
      ELSE
        NAMEFM2    = ' '
        NAMEPH2    = ' '
        NAMEFM2_PK = ' '
        NAMEPH2_PK = ' '
      ENDIF

      NAME_COEFF = 'molrp_fdiff.dat'
      CALL ADD_PATH(PATH_SCR,NAME_COEFF)  
C --------------------------------------------
C     for Phased TF  F,Ph --> COEF: NAME_COEFF = 'molrp_diff.dat'
C
      MODE_D  = 'N'
      NAME_TR = NAMEF   

      IF(FCALC.NE.'Y') THEN
      CALL LENSTR_BL(NAME_PH,LEN)
      IF(LEN.GT.0.AND.NAME_PH(1:1).NE.' '.AND.NAME_PH(1:1).NE.',') THEN
        MODE_D = 'D'
        NAME_COEFF = 'molrp_diff.dat'
        CALL ADD_PATH(PATH_SCR,NAME_COEFF)  
        ISIM     = 0
        LAP      = 'N'
        FOMMIN   = 0.0
        MSGA     = 'N'

c        BOFFF    = BOFF_SCL
        BOFFF    = 0.0

        BADDD    = 0.0
        SLIM     = 0.0
        DRMS     = 0.0
        DRMS_A   = 0.0
        DEL_LIM  = 0.0
        DELA_LIM = 0.0
        SCALEF   = 1.0
        NAMES    = ' '
C
C          SCALE * F2 - F1
C                        F1     F2 
        CALL COEF_FFT(M,NAMEF,NAMES,NAME_PH,NAME_COEFF
     *         ,FOMMIN,RESMIN,RESMAX,BOFFF,SLIM
     *         ,DEL_LIM,DELA_LIM,DRMS,DRMS_A,LAP
     *         ,SCALEF,BADDD,MSGA,ISIM,ISYM,IPRSYM,RESULT,IERR)
        IF(IERR.NE.0) GO TO 900
        NAME_TR = NAME_COEFF
      ENDIF
      ENDIF
C ---
C --- fast --
      IF(FAST.EQ.'F') THEN
C        IF(REF.EQ.'Y'.OR.NMR_INP.GT.0.OR.
C     *     (NSYM.EQ.1.AND.MOD2.EQ.'N'.AND.MODE_D.NE.'D')) THEN
        IF(REF.EQ.'Y'.OR.NMR_INP.GT.0) THEN
          FAST = 'M'
          PARM_TR(13:13) = FAST  
        ENDIF
      ENDIF

C ---
      CH6 = 'Sol_TF'
C      IF(MOD1.NE.'D'.AND.MOD2.EQ.'N') THEN
      IF(MOD1.NE.'D'.AND.IFIRST_RUN.LE.0) THEN
        CH6 = 'GNM_EA'
C       IF(IPK_RF.LE.1) THEN
        IF(IFIRST_SCL.LE.0) THEN
          IERR = 20
          NAMES = 'molrep_model_start'
          CALL ADD_PATH(PATH_SCR,NAMES)

          CALL WRITEPDB(M,NAMEM,NAMES,ISYM,IPRSYM,IERR)

          CALL LENSTR_BL(NAMES,LEN)
          NAMES = NAMES(1:LEN)//'.pdb'
          CALL LENSTR_BL(NAMES,LEN)

          LINE = 'GNM_MODEL: '//NAMES(1:LEN)
          CALL MSGDOC(MD,LINE)
          NAMES = ' '
          IERR = 0
        ENDIF

      ENDIF

      WRITE(LINE,'(A6,'' Rotation angles :'',3F8.2)') 
     *  CH6,ALPHA,BETA,GAMMA
      CALL MSGDOC(MD,LINE)


      WRITE(LINE,'('' Resmin,Resmax     :'',2F8.2)') 
     * RESMIN,RESMAX
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,'('' Boff,Badd         :'',2F8.2)') 
     * BOFF,BADD
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,'('' Boff_scl,Badd_scl :'',2F8.2)') 
     * BOFF_SCL,BADD_SCL
      CALL MSGDOC(MD,LINE)
C --------------------------------------------
C     IF(IPK_RF.LE.1) THEN
      IF(IFIRST_SCL.LE.0) THEN
        CALC2 = 'Y'
        PARM_TR(6:6) = CALC2   
      ENDIF
C ---------------------------------------------  
      SCALEP     = 0.0
      BOVER      = 0.0
      ANISO_T    = ANISO
      IF(ANISO_T.EQ.'Y') ANISO_T = 'N'
C --------------------------
      ALP       = ALPHA
      BET       = BETA
      GAM       = GAMMA
      NAME_MOD1 = NAMEC
      NAMEC2    = NAMEM
C -----------------------------
      IF(MOD1.NE.'D') THEN
        MODE2 = 'EF'
        DO I=1,3
          SH1(I) = 0.0
          SH2(I) = 0.0
          DO J=1,3
            AM(I,J) = 0.0
          ENDDO
        ENDDO
        IERR = 0  
        CALL TRANS(M,NAMEM,NAME_MOD1,SH1,SH2
     *    ,MODE2,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
      ENDIF

      NCS_ID_test = 0
      IF(NCS_ID_test.GT.0) THEN
        NCP = 0
        MMM = 99
        IF(LIST.EQ.'T') MMM = MDOC

        NAMEC2 = 'trfn_scr5'
        CALL ADD_PATH(PATH_SCR,NAMEC2)  
        NAMET_OUT = 'trfun'
        CALL ADD_PATH(PATH_SCR,NAMET_OUT)  
        NAME_MOD1 = NAMEC2
C       ALP,BET,GAM,(grad),PRF_SH(3)(frac)

        MODE2 = 'EF'
        DO I=1,3
          SH1(I) = 0.0
C         SH2(I) = 0.0
          DO J=1,3
            AM(I,J) = 0.0
          ENDDO
        ENDDO
        SH2(1) = PRF_SH(1)
        SH2(2) = PRF_SH(2)
        SH2(3) = PRF_SH(3)
        IERR = 0  
        CALL TRANS(M,NAMEM,NAMEC1,SH1,SH2
     *    ,MODE2,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900

        CALL COPY_CRD_NCS(M,NAMEC1,NAMEC2
     *        ,NCS_ID_test,NM_TOTAL,NA_TOTAL
     *        ,ANGLES_NCS_INP,ANGLES_NCS,CENTRE_NCS
     *        ,IPRDOM,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900

        ALP = 0.0
        BET = 0.0
        GAM = 0.0

      ENDIF

C     --- Rigid body refinement
      IF(REFP.EQ.'Y'.AND.NCP.GT.0) THEN

        NAMEC2 = 'trfn_scr5'
        CALL ADD_PATH(PATH_SCR,NAMEC2)  

        MODE = 'E'
        DO I=1,3
          SH1(I) = 0.0
          SH2(I) = 0.0
          DO J=1,3
            AM(I,J) = 0.0
          ENDDO
        ENDDO
        IERR = 0  
        CALL TRANS(M,NAMEM,NAMEC1,SH1,SH2
     *    ,MODE,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900

        MMM =-ABS(MDOC)-2
        IF(LIST.EQ.'T') MMM = MDOC

        CALL MSGDOC(MMM,'--- rigid body refinement (P1) ---')

        FMIN   = 0.0
        SIGMIN = 0.0

        RSMIN = RSMIN_RB
        IF(RSMIN.GT.RESMIN) RSMIN=RESMIN
        RSMAX = RSMAX_RB
        IF(RSMAX.LT.RESMAX) RSMAX=RESMAX

C///
c        RSMIN=RESMIN
c        RSMAX=RESMAX
C///
        IF(RSMIN.LE.RSMAX) THEN
          WRITE(LINE,
     *    '(''ERROR: Resmin,Resmax/ for RB refinement / :'',2F8.2)') 
     *    RSMIN,RSMAX
          CALL MSGERR(MDOC,LINE)
          IERR = 1
          GO TO 900
        ENDIF
C
C   --- for Boris ---
C       RSMAX = 9.0
C ---
        NCYCL   = NCP
        SCALE   = 1.0
        BTEMP   = 0.0
        REFS    = 'Y'
        REFB    = 'N'
        REFA    = 'Y'
        REFX    = 'Y'
        P1      = 'y'
        BOFF_RB = BOFFP
        BADD_RB = 0.0
        DOM     = 'Y'
        IPERC   = 100
C --- for rotfft
c       BOFF_RB  = 0.0
        SCALE    = 0.0
        ANISO_RB = 'N'
        MODE_RB  = ' ' 
        F000     = 'N'

c        SCALE    = 0.5
c        RSMIN    = RESMIN
c        RSMAX    = RESMAX

        MMMM = M
        IF(LIST.EQ.'T') MMMM = MDOC

        NCS_ID_rb    = 0

C        ANGLES_NCS(1)  = 0.0
C        ANGLES_NCS(2)  = 0.0
C        ANGLES_NCS(3)  = 0.0
C        CVECTOR_NCS(1) = 0.0
C        CVECTOR_NCS(2) = 0.0
C        CVECTOR_NCS(3) = 0.0
C -  
        CALL ROTFFT(MMMM,NAMEC1,NAMEF,NAME_PH,NAMEC2,PATH_SCR
     * ,BOFF_RB,BADD_RB,DOM,F000
     * ,NCS_ID_rb,ANGLES_NCS_INP,CVECTOR_NCS
     * ,RSMIN,RSMAX,NCYCL,SCALE,REFA,REFX,REFB,MODE_RB,ANISO_RB,P1,LIST
     * ,RESULT,RESULTA,IPRROW,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900

C --- for rotfft

C        CALL ROTLSQ(M,NAMET,NAMEF,NAMES,BOFF_RB,BADD_RB,DOM
C     *  ,FMIN,SIGMIN,IPERC
C     *  ,RSMIN,RSMAX,NCYCL,SCALE,BTEMP,REFS,REFB,REFA,REFX
C     *  ,P1,RESULT,IPRROW,ISYM,IPRSYM,POOL,MEMORY_TOT,IERR)
C        IF(IERR.NE.0) GO TO 900

C      RESULT(1) - number of cycles 
C      RESULT(3) - Boverall
C      RESULT(4) - R-factor
C      RESULT(5) - Correlation
C      RESULT(6) - initial R-factor
C      RESULT(7) - initial Correlation
C      RESULT(8) =TX(1,1)
C      RESULT(9) =TX(2,1)
C      RESULT(10)=TX(3,1)
C      RESULT(11)=THETA(1,1)
C      RESULT(12)=THETA(2,1)
C      RESULT(13)=THETA(3,1)
c      RESULT(14) =TX(1,2)
c      RESULT(15) =TX(2,2)
c      RESULT(16) =TX(3,2)
c      RESULT(17) =THETA(1,2)
c      RESULT(18) =THETA(2,2)
c      RESULT(19) =THETA(3,2)
c      RESULT(20) =NDOM
C      RESULT(21) - number of refls 
C
        WRITE(LINE,
     *  '('' Resmin,Resmax/ for RB refinement / :'',2F8.2)') 
     *  RSMIN,RSMAX
        CALL MSGDOC(MMM,LINE)

        NDOM   = RESULT(20,1)
        NC_FIN = RESULT(1,1)
        WRITE(LINE,*) 'Number of domains,Ncycles :',NDOM,NC_FIN
        CALL MSGDOC(MMM,LINE)

        RFAC0       = RESULT(6,1)
        CORR0       = RESULT(7,1)

        WRITE(LINE,
     *  '('' R-factor,Corr /before RB refinement/ :'',2F8.3)') 
     *  RFAC0,CORR0
        CALL MSGDOC(MMM,LINE)
        RFAC       = RESULT(4,1)
        CORR       = RESULT(5,1)
        WRITE(LINE,
     *  '('' R-factor,Corr /after RB refinement / :'',2F8.3)') 
     *  RFAC,CORR
        CALL MSGDOC(MMM,LINE)
        WRITE(LINE,'('' scale,B_scale :'',2F8.3)') 
     *  RESULT(2,1),RESULT(3,1)
        CALL MSGDOC(MMM,LINE)
        WRITE(LINE,'('' Boff_rb :'',F10.2)') 
     *  BOFF_RB
        CALL MSGDOC(MMM,LINE)
        
        NDOM_N = NDOM
        IF(NDOM.GT.4) NDOM_N = 4
        DO I=1,NDOM_N
          II = I*2 + 10
          CHI = RESULT(II-1,1)
          SH  = RESULT(II,1) 
          WRITE(LINE,'('' DOMAIN -'',I3)') I
          CALL MSGDOC(MMM,LINE)
          WRITE(LINE,'('' polar rotation angle CHI :'',F8.3)') 
     *    CHI
          CALL MSGDOC(MMM,LINE)
          WRITE(LINE,'('' !shift2!             :'',F8.3)') SH 
          CALL MSGDOC(MMM,LINE)
        ENDDO

        ALP = 0.0
        BET = 0.0
        GAM = 0.0

      ENDIF
C
C     --- end of rigid body
C -------------------------
        IF(PACK.EQ.'N') THEN
          NAMEFM_PK = ' '
          NAMEPH_PK = ' '
        ENDIF

        IF(LIST.EQ.'T') THEN
          WRITE(*,*) 'IPK_RF,IFIRST_SCL,ANISO_T:'
     *    ,IPK_RF,IFIRST_SCL,ANISO_T
        ENDIF

        NMR    = 0
c        IF(IPK_RF.EQ.1) THEN
        IF(IFIRST_SCL.LE.0) THEN
          SCALEP = 0.0
          BOVER  = 0.0
          SCALEP_STORE = 0.0
          BOVER_STORE  = 0.0
          SIGMA_STORE  = 0.0
c          IFIRST_SCL = 1
c          FPAR_TR(18)= IFIRST_SCL
        ELSE
          SCALEP = SCALEP_STORE
          BOVER  = BOVER_STORE
          ANISO_T = 'K'
        ENDIF
        IF(FCALC.EQ.'Y') THEN
          IPK_RF = 1
          SCALEP = 0.0
          BOVER  = 0.0
          SCALEP_STORE = 0.0
          BOVER_STORE  = 0.0
          SIGMA_STORE  = 0.0
          ANISO_T    = ANISO
          IF(ANISO_T.EQ.'Y') ANISO_T = 'N'
        ENDIF


c
        H2OBG  = 0.0

C       IF(MODE_D.NE.'D') H2OBG = 0.35 

        NAMET = ' '

        RESMIN_TMP = RESMIN
        IF(RESMIN_OUT.GT.0.001.AND.TFUN.EQ.'S') THEN
          RESMIN_OUT = A
          IF(RESMIN_OUT.LT.B) RESMIN_OUT = B
          IF(RESMIN_OUT.LT.C) RESMIN_OUT = C
          RESMIN_TMP = RESMIN_OUT
          SCALEP = 1.0
          BSCALE = 0.0
          ANISO_T= 'K'
        ENDIF

        WRITE(CH3,'(I3)') IPK_RF
        IF(CH3(1:1).EQ.' ') CH3(1:1)= '_'
        IF(CH3(2:2).EQ.' ') CH3(2:2)= '_'
        NAMEFM_STOR(IPK_RF)    = 'trfn_f'//'_'//CH3//'.dat'
        CALL ADD_PATH(PATH_SCR,NAMEFM_STOR(IPK_RF))  
        NAMEPH_STOR(IPK_RF)    = 'trfn_ph'//'_'//CH3//'.dat'
        CALL ADD_PATH(PATH_SCR,NAMEPH_STOR(IPK_RF))  
        NAMEFM_PK_STOR(IPK_RF) = 'trfn_f_pk'//'_'//CH3//'.dat'
        CALL ADD_PATH(PATH_SCR,NAMEFM_PK_STOR(IPK_RF))  
        NAMEPH_PK_STOR(IPK_RF) = 'trfn_ph_pk'//'_'//CH3//'.dat'
        CALL ADD_PATH(PATH_SCR,NAMEPH_PK_STOR(IPK_RF))  

        NAMEFM    = NAMEFM_STOR(IPK_RF) 
        NAMEPH    = NAMEPH_STOR(IPK_RF)
        NAMEFM_PK = NAMEFM_PK_STOR(IPK_RF)
        NAMEPH_PK = NAMEPH_PK_STOR(IPK_RF)

        IF(PACK.EQ.'N') THEN
          NAMEFM_PK = ' '
          NAMEPH_PK = ' '
        ENDIF

        IF(LIST.EQ.'T') THEN
          WRITE(*,*) '==1==',IPK_RF,IFIRST_SCL,FCALC,IFIRST_RUN
     *             ,IFILE_STOR(IPK_RF),IFILE_PK_STOR(IPK_RF)
        ENDIF

        IF(IFIRST_RUN.EQ.1.AND.FCALC.NE.'Y'.AND.
     *     IFILE_STOR(IPK_RF).GT.0.AND.
     *     IFILE_PK_STOR(IPK_RF).GT.0  ) THEN
          PACK_INDEX = PACK_INDEX_STOR(IPK_RF) 
          NEL1 = NEL1_STOR(IPK_RF) 
          IFIRST_SCL = 1
          FPAR_TR(18)= IFIRST_SCL
          GO TO 777
        ELSE
          PACK_INDEX_STOR(IPK_RF) = 1.0
          NEL1_STOR(IPK_RF) = 1 
        ENDIF

        IF(LIST.EQ.'T') THEN
          CALL MSGDOC(MDOC,'--- TRF_PRECALC_MOD---')

          WRITE(*,*) 'MOD1,MOD2:',MOD1,MOD2
          WRITE(*,*) '-F:'  ,NAMEF
          WRITE(*,*) '-C:'  ,NAMEC2
          WRITE(*,*) '-M1:' ,NAME_MOD1
          WRITE(*,*) '-FM:' ,NAMEFM
          WRITE(*,*) '-PM:' ,NAMEPH
          WRITE(*,*) '-FMP:',NAMEFM_Pk
          WRITE(*,*) '-PMP:',NAMEPH_PK
          WRITE(*,*) '-TEST:',TEST
          WRITE(*,*) '-ANISO_T:',ANISO_T,IPK_RF
          WRITE(*,*) '-S,B:',SCALEP,BOVER
          WRITE(*,*) '-FCALC:',FCALC
          WRITE(*,*) '-RESMIN:',RESMIN_TMP
        ENDIF
        PST_T = 'N'
        MMM  = M
        IMOD = 1
        IF(LIST.EQ.'T') MMM = MDOC
        CALL TRF_PRECALC_MOD(MMM,LIST,MOD1,IMOD
     *   ,NAMEF,NAMEC2,NAME_MOD1,NAMEFM,NAMEPH,NAMEFM_PK,NAMEPH_PK
     *   ,NAMET,PATH_SCR,ALP,BET,GAM,PACK,ANISO_T,SURF,PST_T
     *   ,SPST,RESMIN_TMP,RESMAX,BOFF,BOFF_SCL,BADD,BADD_SCL,TEST
     *   ,NEL1,NUM_MON,BLIM,NMR,SCALEP,BOVER,H2OBG 
     *   ,ISYM,IPRSYM
     *   ,RESULT,RESULTA,IPRMAX,IPRROW,IERR)
C ----------------------------------------------------------------
C 1) if MOD1=D DENS2F_DNS else DENS2F_NEW
C 2) if ANISO = K - FSCALE with SCALEP,BOVER
C                   if scale = 0 - scaling by Fobs (cell must be the same)
C                                  only scale , set BOVER = 0
C                   if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                  no info: rfac, corr
C     else  ANISOSCL
C           if ANISO = Y - pre-isoscaling by Patterson and aniso scaling
C           else  only isoscaling by Patterson
C
C     output NAMEFM2,NAMEPH and SCALEP,BOVER 
C            NAMEFM_PK,NAMEPH_PK (if PACK # N )
C
C ----------------------------------------------------------------
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: in TRFUN: TRF_PRE...(MOD1)')
          GO TO 900
        ENDIF

        PACK_INDEX = RESULT(1,1) 
        PACK_INDEX_STOR(IPK_RF) = 1.0
        NEL1_STOR(IPK_RF) = NEL1 
        IFILE_STOR(IPK_RF) = 1
        IFILE_PK_STOR(IPK_RF) = 1
        IF(PACK.EQ.'N') THEN
          IFILE_PK_STOR(IPK_RF) = 0
        ENDIF

        NDENSP = RESULT(2,1) 
        NZERO  = RESULT(3,1) 
        NDENSM = RESULT(4,1)

        WRITE(LINE,'('' scale,B_scale :'',2F8.3)') 
     *  SCALEP,BOVER
        CALL MSGDOC(MD,LINE)

C        IF(IPK_RF.EQ.1) THEN
        IF(IFIRST_SCL.LE.0) THEN
C          SCALEP = 0.0
C          BOVER  = 0.0
          SCALEP_STORE = SCALEP
          BOVER_STORE  = BOVER 
          SCALEP = 0.0
          BOVER  = 0.0
          IFIRST_SCL = 1
          FPAR_TR(18)= IFIRST_SCL
        ENDIF

  777   CONTINUE

C       WRITE(*,*) '==2==',CALC2,MOD2

        NAME_MOD2 = NAME2 
        IF(CALC2.NE.'N'.AND.MOD2.NE.'N') THEN
C         ------------
C         model_2
          IF(PACK.EQ.'N') THEN
            NAMEFM2_PK = ' '
            NAMEPH2_PK = ' '
c          ELSE IF(PACK.EQ.'P') THEN
c            NAMEFM2 = ' '  
c            NAMEPH2 = ' '
          ENDIF
          ALP2   = 0.0
          BET2   = 0.0
          GAM2   = 0.0
          NAME_MOD2 = NAMEC3

          PST_T  = 'N'

          SURF_T = SURF
          IF(MOD2_INI.EQ.'Y') SURF_T = SURFX

          NMR     = 0
          SCALEP2 = 0.0
          BOVER2  = 0.0
          H2OBG   = 0.0

C         IF(MODE_D.NE.'D') H2OBG = 0.35 

          NAMET = ' '

          MMM = M
          IF(LIST.EQ.'T') MMM = MDOC
          IMOD = 2
          CALL TRF_PRECALC_MOD(MMM,LIST,MOD2,IMOD
     *    ,NAMEF,NAME2,NAME_MOD2,NAMEFM2,NAMEPH2,NAMEFM2_PK,NAMEPH2_PK
     *    ,NAMET,PATH_SCR,ALP2,BET2,GAM2,PACK,ANISO,SURF_T,PST_T
     *    ,SPST,RESMIN,RESMAX,BOFF,BOFF_SCL,BADD,BADD_SCL,TEST
     *    ,NEL2,NUM_MON,BLIM,NMR,SCALEP2,BOVER2,H2OBG
     *    ,ISYM,IPRSYM
     *    ,RESULT,RESULTA,IPRMAX,IPRROW,IERR)
C ----------------------------------------------------------------
C 1) if MOD1=D DENS2F_DNS else DENS2F_NEW
C 2) if ANISO = K - FSCALE with SCALEP,BOVER
C                   if scale = 0 - scaling by Fobs (cell must be the same)
C                                  only scale , set BOVER = 0
C                   if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                  no info: rfac, corr
C     else  ANISOSCL
C           if ANISO = Y - pre-isoscaling by Patterson and aniso scaling
C           else  only isoscaling by Patterson
C
C     output NAMEFM2,NAMEPH and SCALEP,BOVER 
C            NAMEFM_PK,NAMEPH_PK (if PACK # N )
C
C ----------------------------------------------------------------
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,' ERROR: in TRFUN: TRF_PRE...(MOD2)')
            GO TO 900
          ENDIF

          CALC2 = 'N'
          PARM_TR(6:6) = CALC2     

          WRITE(LINE,'('' scale2,B_scale2 :'',2F8.3)') 
     *    SCALEP2,BOVER2
          CALL MSGDOC(MD,LINE)

        ENDIF
C        ----------

c --->


c        CALL MSGDOC(MD0,'--- trpack ---')

        RESMIN_TMP = RESMIN
        NAMEF_TMP  = NAMEF
        IF(RESMIN_OUT.GT.0.001.AND.TFUN.EQ.'S') THEN
          RESMIN_OUT = A
          IF(RESMIN_OUT.LT.B) RESMIN_OUT = B
          IF(RESMIN_OUT.LT.C) RESMIN_OUT = C
          RESMIN_TMP = RESMIN_OUT
C ---
          NAMES      = ' '
          THRESH     = 0.0
          TOP        = 0
          SIG_SCALE  = 0.0
          SCALE_P    = 0.0
          BSCALE_P   = 0.0  
          MODE       = ' '
          IZMIN      = 0
          IZMAX      = 0

          NAMES      =  NAMEF

          CALL COPYFL(Mdoc,NAMEFM,NAMES,NAMEC3
     *           ,THRESH,TOP,SCALE_P,BSCALE
     *           ,SIG_SCALE,RESMIN_TMP,RESMAX
     *           ,IZMIN,IZMAX,MODE,NAMES
     *           ,RESULTA,IPRMAX,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,' ERROR: in TRFUN: COPYFL ')
            GO TO 900
          ENDIF

          NAMEF_TMP  = NAMEC3

        ENDIF

        IF(LIST.EQ.'T') THEN
          WRITE(LINE,'('' nel1,nel2 :'',2I8)') nel1,nel2 
          CALL MSGDOC(MDoc,LINE)
          write(*,*) 'trfun:named:',named
          write(*,*) 'tfun:',tfun
        ENDIF

        NAMEDD = NAMED   
        NAMES  = ' '
        IERR   = 0
        IF(NSYM.EQ.1.AND.MOD2.EQ.'N'.AND.MODE_D.NE.'D') IERR=1
        IF(FCALC.EQ.'Y') IERR = 1

        MMM = M
        IF(LIST.EQ.'T') MMM = MDOC
        MMM = MDOC

        PST_T = PST
        IF(LH_LH.NE.'N') NAME_TR = FILE_FOBS_LH
        IF(RESMIN_OUT.GT.0.001.AND.TFUN.EQ.'S') THEN
          NAME_TR = NAMEF_TMP  

c          NAME_TR  = NAMEF

        ENDIF

        IF(MOD2.NE.'N') THEN
          MEM_SCR = NTOT_SCR*11 + 1000
        ELSE
          MEM_SCR = NTOT_SCR*9 + 1000  
        ENDIF
        IF(LIST.EQ.'T') THEN
          write(*,*) 'MOD2:',MOD2
          write(*,*) 'NTOT_SCR:',NTOT_SCR
          write(*,*) 'MEM_SCR:',MEM_SCR
        ENDIF

        allocate(POOL_SCR(1:MEM_SCR),STAT=ISTAT)
        IF(ISTAT.NE.0) THEN
          IERR = 1
          CALL MSGERR(MDOC,
     *    ' ERROR: in TRFUN: problem with memory allocation')
          CALL MSGERR(MDOC,
     *    '                  try to change resolution')
          GO TO 900
        ENDIF
c --
c      NRUN_TIME   = 0
c      ITIME_START = 0
c      CALL EXPECTED_TIME(ITIME_START,NRUN_TIME
c     *    ,ITIME_CURR,TIME_CURRENT,TIME_ELAPSED,TIME_EXPECTED)
c      WRITE(LINE,*) 'Time:',TIME_CURRENT,' Elapsed:',TIME_ELAPSED
c      CALL MSGDOC(MDOC,LINE)
c      WRITE(*,*) 'Time2:',TIME_CURRENT,' Elapsed:',TIME_ELAPSED
c ---

        CALL TRF_PACK_TRANS(MMM,LIST
     *   ,NAME_TR,NAMEF_TMP,NAMEFM,NAMEPH,NAMEFM_PK,NAMEPH_PK
     *   ,NAMEFM2,NAMEPH2,NAMEFM2_PK,NAMEPH2_PK,NAMEDD,NAMES
     *   ,NEL1,NEL2,MODE_D,PACK,INVER_R,TFUN,PST_T,SPST
     *   ,RESMIN_TMP,RESMAX,BOFF,BADD,RMAX_PK,RMIN_PK
     *   ,POOL_SCR,MEM_SCR
     *   ,ISYM,IPRSYM
     *   ,RESULT,IPRMAX,IPRROW,IERR) 

c --
c      NRUN_TIME   = 0
c      ITIME_START = 0
c      CALL EXPECTED_TIME(ITIME_START,NRUN_TIME
c     *    ,ITIME_CURR,TIME_CURRENT,TIME_ELAPSED,TIME_EXPECTED)
c      WRITE(LINE,*) 'Time:',TIME_CURRENT,' Elapsed:',TIME_ELAPSED
c      CALL MSGDOC(MDOC,LINE)
c      WRITE(*,*) 'Time5:',TIME_CURRENT,' Elapsed:',TIME_ELAPSED
c ---
        RESULT(1,14) =  RMAX_PK
        DO I=1,IPRMAX
          RESULT(I,1)  =  0.0
        ENDDO
        RESULT(1,2)  =  0.0
        RESULT(1,15) =  RMIN_PK
        RESULT(1,16) =  0.0
        RESULT(1,21) =  PACK_INDEX

        IF(IERR.EQ.10) THEN
          CALL MSGDOC(MD,
     *    ' WARNING: trpack: all values of Packing Function =< 0')
          WRITE(LINE,'('' Packing function: max,min :'',2G16.4)') 
     *    RMAX_PK,RMIN_PK
          CALL MSGDOC(MD,LINE)
        ELSE IF(IERR.EQ.0) THEN
          MMM =-ABS(MDOC)-1 
          IF(LIST.EQ.'T') MMM = MDOC
          WRITE(LINE,'('' Packing function:'',2G16.4)') 
     *    RMAX_PK,RMIN_PK
          CALL MSGDOC(MD,LINE)
          WRITE(LINE,'('' Packing index:'',G16.4)') 
     *    PACK_INDEX
          CALL MSGDOC(MD,LINE)
          RESULT(1,16) =  0.0
          IF(ABS(RESULT(1,5)).GT.0.000001) THEN
            SIGMA = RESULT(1,4)/RESULT(1,5)
            RESULT(1,16) = SIGMA
            WRITE(LINE,'('' Sigma :'',G16.4)') SIGMA
            CALL MSGDOC(MD,LINE)
            IF(IPK_RF.EQ.1) THEN
              SIGMA_STORE = SIGMA
            ELSE
              NNN = RESULT(1,12) 
              IF(NNN.GT.0.AND.SIGMA_STORE.GT.0.00001) THEN
                DO I=1,NNN
                  RESULT(I,5) = (RESULT(I,5)*SIGMA)/SIGMA_STORE
                ENDDO
              ENDIF
            ENDIF
          ENDIF
        ENDIF

        IF(RMAX_PK   .GT.1.0) RMAX_PK    = 1.0
        IF(RMIN_PK   .GT.1.0) RMIN_PK    = 1.0
        IF(PACK_INDEX.GT.1.0) PACK_INDEX = 1.0

        RESULT(1,14) =  RMAX_PK
        RESULT(1,15) =  RMIN_PK
        RESULT(1,21) =  PACK_INDEX

        IF(IERR.NE.0) THEN
          deallocate(POOL_SCR,STAT=ISTAT)
          GO TO 900
        ENDIF

        IF(FCALC.EQ.'Y') THEN
          RESULT(1,12) = NP_CALC
          DO I=1,NP_CALC
            CALL FTOO(SH_CALC(1,I),SH1,IERR)
            RESULT(I, 4) = 0.0
            RESULT(I, 5) = 0.0
            RESULT(I, 6) = SH1(1)
            RESULT(I, 7) = SH1(2)
            RESULT(I, 8) = SH1(3)
            RESULT(I, 9) = SH_CALC(1,I)
            RESULT(I,10) = SH_CALC(2,I)
            RESULT(I,11) = SH_CALC(3,I)          
          ENDDO
          NPT     = NP_CALC
          IPT_MIN = 1
          GO TO 600
        ENDIF

        NPK_TF = RESULT(1,12)
        IF(NSYM.EQ.1.AND.MOD2.EQ.'N'.AND.MODE_D.NE.'D'.AND.
     *     NPK_TF.GT.0) THEN
          DO I=1,NPK_TF
            RESULT(I, 8) = 0.01
          ENDDO
        ENDIF
         
C 600    CONTINUE

C -------------------------------------------------
      IF(NPK_TF.LE.0) THEN
        RESULT(1,12) = 0
C        RESULT(1, 4) = 0.0
C        RESULT(1, 5) = 0.0
        RESULT(1, 6) = 0.0
        RESULT(1, 7) = 0.0
        RESULT(1, 8) = 0.0
        RESULT(1, 9) = 0.0
        RESULT(1,10) = 0.0
        RESULT(1,11) = 0.0          
        GO TO 700
      ENDIF

C --------------------------------------------

 700  CONTINUE

      NPEAKS = RESULT(1,12)
      IF(NPEAKS.LE.0) THEN
        WRITE(LINE,'(A,I4,A)') ' WARNING: RF:',IPK_RF
     *  ,' TRFUN: number of peaks of translation function = 0'
        CALL MSGDOC(MDOC,LINE)
        IERR = 0
        deallocate(POOL_SCR,STAT=ISTAT)
        GO TO 900 
      ENDIF
C -----------------------
      IF(NPT.GT.NPEAKS) NPT = NPEAKS
      IPT_MIN = 1
C ---------------------
      IF(MODE_D.EQ.'D') THEN
C       NPT         = 1
C        IF(PRF.NE.'N'.AND.NCS_ID.LE.0) THEN
        IF(PRF.NE.'N') THEN
          MMM = MD
          IF(PRF.EQ.'Y') DCHECK = RESMAX*2.0
          IF(PRF.EQ.'P') DCHECK = RESMAX
          IF(PRF.EQ.'S') DCHECK = ARAD

          IF(LIST.EQ.'T') THEN
            WRITE(LINE,'(A,A,3F8.3,A)')
     *      'sh:',
     *      ' (',RESULT(1,9),RESULT(1,10),RESULT(1,11),')'
            CALL MSGDOC(MDOC,LINE)
          ENDIF

          CALL PTF_FIND_DMIN(MMM,NPT,DCHECK,DIST_LIM
     *              ,IPT_MIN,PRF_SH,RESULT,IPRMAX,IPRROW
     *              ,NSYM,ISYM,IPRSYM,IERR)

          IF(LIST.EQ.'T') THEN
            WRITE(LINE,'(A,I5,2F10.3)') 'DLIM:',IERR,DCHECK,DIST_LIM
            CALL MSGDOC(MDOC,LINE)
            WRITE(LINE,'(A,3F10.3)') 'PRF:'
     *      ,PRF_SH(1),PRF_SH(2),PRF_SH(3)
            CALL MSGDOC(MDOC,LINE)
          ENDIF

          IF(IERR.NE.0) THEN
            WRITE(LINE,'(A,2F8.2,A,3F8.3,A)')
     *      'No peaks Dlim<Dist:',DCHECK,DIST_LIM,
     *      ' (',RESULT(1,9),RESULT(1,10),RESULT(1,11),')'
            CALL MSGDOC(MDOC,LINE)
            IERR = 11
            deallocate(POOL_SCR,STAT=ISTAT)
c           corr_for_fixed_model
            RESULT(2,21) = -3.0
            GO TO 900
          ENDIF
          RESULT(1,14) =  RMAX_PK
          RESULT(1,15) =  RMIN_PK
          RESULT(1,21) =  PACK_INDEX
        ELSE
C          IF(NSPGR.EQ.1)  NPT = 1
        ENDIF

        IF(NCS_ID.GT.100) THEN
          CALL CHECK_NCS_PACK(MDOC,LIST,NPT
     *    ,NCS_ID,CENTRE_NCS,ANGLES_NCS_INP,ANGLES_NCS,IPRDOM
     *    ,NAME_MOD1,PATH_SCR
     *    ,RESULT,IPRMAX,IPRROW,IERR)
          IF(IERR.NE.0) THEN
            LINE = 'ERROR: in CHECK_NCS_PACK'
            CALL MSGERR(MDOC,LINE)
            deallocate(POOL_SCR,STAT=ISTAT)
            GO TO 900 
          ENDIF
        ENDIF

      ENDIF
C ---------------------
 600  CONTINUE

      MMM = MDOC 
C     IF(MODE_D.EQ.'D') MMM = Mm 
C
C     space group ?
C     NAME_MOD1 = NAMEC

      IF(FAST.EQ.'F') THEN

        NAMES  = ' '
        NAMET  = NAMET_OUT
        IF(MOD1.NE.'Y') NAMET = ' '
        IF(RESMIN_OUT.LE.0.001) THEN
          RESMIN_OUT = RESMIN
        ELSE
          RESMIN_OUT = A
          IF(RESMIN_OUT.LT.B) RESMIN_OUT = B
          IF(RESMIN_OUT.LT.C) RESMIN_OUT = C
        ENDIF
        SCALE = SCALEP_STORE
        BOVER = BOVER_STORE

        IF(LIST.EQ.'T') THEN
          write(*,*) '--TR_TEST_2--',SCALE,BOVER,BOFF_SCL,BADD_SCL
        ENDIF


        PST_T = PST
C                                        mod1     mod2  scrF    out 
        IERR = 0
        IF(MOD1.NE.'D'.AND.IFIRST_RUN.LE.0) IERR = -1

        CALL TR_TEST_2(MMM,LIST,MODE_D,NAME_MOD1,NAME2,NAMES,NAMET
     *    ,NAMEF,NAME_FCALC,NAME_PHCALC,PATH_SCR
     *    ,NPT,NUM_MON,PST_T,SPST
     *    ,RMAX_PK,RMIN_PK,SIGMA
     *    ,BOFF_SCL,BADD_SCL
     *    ,RESMIN_OUT,ANISO_T,SCALE,BOVER
     *    ,IPK_RF,ALPHA,BETA,GAMMA,TTEST,PEAK_TEST,IPT_MIN
     *    ,POOL_SCR,MEM_SCR
     *    ,RESULT,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          deallocate(POOL_SCR,STAT=ISTAT)
          GO TO 900
        ENDIF
C        FPAR_TR( 3) = ALPHA 
C        FPAR_TR( 4) = BETA  
C        FPAR_TR( 5) = GAMMA  

      ELSE

        RESMNI = RESMIN
        RESMXI = RESMAX
C  23.08.99
C        BOFFF  = 0.0
C        BADDD  = 0.0
        IERR   = NUM_MON 

        BOFFF  = BOFF_SCL
        BADDD  = BADD_SCL

C        IF(REFP.EQ.'Y'.AND.NCP.GT.0) THEN
C          ALP = ALPHA
C          BET = BETA
C          GAM = GAMMA
C        ENDIF

c      RMAX_PK,RMIN_PK,SIGMA
        IF(LIST.EQ.'T') THEN
          write(*,*) '--TR_TEST--'
        ENDIF

        CALL TR_TEST(MMM,LIST,NAMEF,NAME_PH,NAME_MOD1,NAMET_OUT
     *    ,PATH_SCR,RESMNI,RESMXI,DIFF
     *    ,FAST,ANISO,BOFFF,RSMIN_RB,RSMAX_RB
     *    ,RMAX_PK,RMIN_PK,SIGMA
     *    ,BOFFP,BADDD,NAME2,ISYM,IPRSYM
     *    ,IPK_RF,ALPHA,BETA,GAMMA
     *    ,REF,NC,NPT,RESULT,IPRMAX,IPRROW,IERR)
        IF(IERR.NE.0) THEN
          deallocate(POOL_SCR,STAT=ISTAT)
          GO TO 900
        ENDIF
      ENDIF

      deallocate(POOL_SCR,STAT=ISTAT)

      IF(PACK.EQ.'N') THEN
        RESULT(1,14) = 1.0
        RESULT(1,15) = 1.0
        RESULT(1,21) = 1.0
        RESULT(1,22) = 1.0
      ENDIF

C ---

C ---

      IF(LIST.EQ.'T') THEN
        write(*,*) 'test:RFAC,corr,pk_i:'
     *  ,RESULT(1,1),RESULT(1,2),RESULT(1,21)
      ENDIF


c     IF(MODE_D.EQ.'D'.AND.MODE_T.EQ.'D') THEN
      IF(MODE_D.EQ.'D') THEN
C       RESULT(1,1) = 1.0
C        RESULT(1,1) = RESULT(1,5)
c        RESULT(1,2) = RESULT(1,4)
        GO TO 900
      ENDIF

      IF(FIT.EQ.'Y') THEN
C       RESULT(1,1) = 1.0
C        RESULT(1,1) = RESULT(1,5)
c        RESULT(1,2) = RESULT(1,4)
        GO TO 900
      ENDIF
C --------------------------------------------
  900 CONTINUE

C ----
      NAMET='trfn_scr4.dat'
      CALL DELETE_FILE(PATH_SCR,NAMET)
      NAMET='trfn_scr5.dat'
      CALL DELETE_FILE(PATH_SCR,NAMET)
      NAMET='trfn_scr4.crd'
      CALL DELETE_FILE(PATH_SCR,NAMET)
      NAMET='trfn_scr5.crd'
      CALL DELETE_FILE(PATH_SCR,NAMET)
      NAMET='trfn_scr.crd'
      CALL DELETE_FILE(PATH_SCR,NAMET)
      NAMET='trfn_scr.dat'
      CALL DELETE_FILE(PATH_SCR,NAMET)
      NAMET='trfn_scr6.dat'
      CALL DELETE_FILE(PATH_SCR,NAMET)
      NAMET='trfn_scr6.dat'
      CALL DELETE_FILE(PATH_SCR,NAMET)
C ---
c      NAMET='trfun_dns1.dat'
c      OPEN(UNIT=MT,FILE=NAMET,ACCESS='SEQUENTIAL',ERR=19)
c      CLOSE(MT,STATUS='DELETE',ERR=19)
c 19   CONTINUE
c      NAMET='trfun_dns2.dat'
c      OPEN(UNIT=MT,FILE=NAMET,ACCESS='SEQUENTIAL',ERR=20)
c      CLOSE(MT,STATUS='DELETE',ERR=20)
c 20   CONTINUE
c      NAMET='trfun_dns3.dat'
c      OPEN(UNIT=MT,FILE=NAMET,ACCESS='SEQUENTIAL',ERR=21)
c      CLOSE(MT,STATUS='DELETE',ERR=21)
c 21   CONTINUE
      NAMET='trfn_scr7.crd'
      CALL DELETE_FILE(PATH_SCR,NAMET)
      NAMET='trfn_scr6.crd'
      CALL DELETE_FILE(PATH_SCR,NAMET)
C ---
      RETURN
      END

      SUBROUTINE PKSRCH_RF(MDOC,NAME,NAMEO,ALEVEL,DIST_LIM_R,SPEC
     *  ,NPMAX,NP_LIM,PROG,RESMAX,RAD,NP_SRF,NAME_TSRF,DELTA,NCS
     *  ,ISYM,IPRSYM,RESULT,RESULTA,IPRMAX,IPRROW,IERR)
C -------------------------------------------------------
      REAL      RESULT(IPRMAX,IPRROW)
      REAL      RESULTA(IPRMAX,IPRROW)

c      INTEGER*2 IPOOL(NCRES,3)
      integer*2,   allocatable :: IPOOL(:,:)

      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER NAME*(*),NAMEO*(*),NAME_TSRF*(*),SPEC*1,PROG*4
      REAL      ALEVEL,DIST_LIM_R
C -------------------------------------------------------------
      COMMON/COM_SRPK/ FRTOCR,CRTOFR,NX,NY,NZ,IZMIN,IZMAX,
     *                 DELA,DELG,DELB,TYPE
      REAL      FRTOCR(3,3),CRTOFR(3,3)
      CHARACTER TYPE*1,TYPE_S*1,TYPE2*1
C --------------------------------------------------------------
      REAL        SCL (3),XF(3),XC(3),RINDEX
      INTEGER     ISECT(3),INDEX
      CHARACTER   TTT*80,LINE*256,CH4*4
      EQUIVALENCE (RINDEX,INDEX)
C --------------------------------------------------------------
      PI   = 4.0*ATAN(1.0)
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99

      IF(SPEC.EQ.'s') SPEC='S'
      IF(SPEC.NE.'S') SPEC='Y'
C --------------------------------
      CH4   = 'RI  '
      MT    = 10
      CALL ORFILE(M,MT,NAME,CH4,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) THEN
        IERR=1
        RETURN
      ENDIF
      CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *        ,F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TTT,IERR)
      CLOSE(MT)
      IF(IERR.GT.0) THEN
        IERR=2
        RETURN
      ENDIF

      NXY = NX*NY
      allocate(IPOOL(1:NXY,1:3),STAT=ISTAT)
      IF(ISTAT.GT.0) THEN
        IERR = 1
        CALL MSGERR(MDOC,
     *    ' ERROR: in PEAKSRCH_RF: problem with memory allocation')
        CALL MSGERR(MDOC,
     *    '                        try to change resolon')
        RETURN
      ENDIF
      ITYPE = 0
      MT    = 10
      CALL IRDENS(MT,NAME,M,ITYPE,ICNTZ,NX,NY,NZ,IZMAX,
     *   IZMIN,RMAX,RMIN,IPOOL(1,1),SCALE,A,B,C,AL,BE,GA,RMS
     *   ,AVER,RESOL,IX0,IY0,IZ0,ITR,TTT
     *   ,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        deallocate(IPOOL,STAT=ISTAT)
        CALL MSGERR(MD,' ERR: OPEN FILE-DENS')
        RETURN
      ENDIF
c      NXY = NX*NY
c      IF(NXY.GT.NCRES) THEN
c        CALL MSGERR(MD,' ERR: NOT MEMORY FOR 3 SECTIONS X-Y ')
c        CLOSE(MT)
c        IERR = 1
c        RETURN
c      ENDIF

      CALL GET_CR_MATRIX(FRTOCR,CRTOFR)

C ------------------------------------------------------------
      DIST_LIM = DIST_LIM_R
        DELA = (AL*4.0)/NX
        DELG = (BE*4.0)/NY
        DELB = PI/(NZ-1)
C        A=ARAD*10.
C        B=RN  *10.
C        C=RX  *10.
C        AL=PI/(2.*FLOAT(NSYM1))
C        BE=PI/(2.*FLOAT(NSYM2))
C        GA=PI/2.
C        NX=IPRGAM
C        NY=IPRGAM
C        NZ=180./BETDEL+1.
C        DELALP=360.0/NX
C        IZMIN=BETMIN/BETDEL
C        IZMAX=BETMAX/BETDEL
        TYPE  = 'R'
        TYPE2 = 'R'
        IF(DIST_LIM_R.LE.0.00001) THEN          
c          T = RESOL*1.5
          T = RESOL/2.0
          IF(T.GT.6.0) T=6.0
          DIST_LIM = (PI*T)/180.0
        ELSE
          T        = DIST_LIM_R
          DIST_LIM = (PI*T)/180.0
        ENDIF
c       DIST_LIM_RMS = 0.25*RESOL
        DIST_LIM_RMS = 0.25*T
C ----------------------
      IF(ALEVEL.LE.0.0) ALEVEL=1.0
      DLIM = RMS*ALEVEL
      WRITE(LINE,'('' limit Dens-MIN,D-RMS :'',2G14.4)') DLIM,RMS     
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,'('' SPEC : '',A1)') SPEC     
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,'('' PROG : '',A)') PROG     
      CALL MSGDOC(MD,LINE)

      T = (180.0*DIST_LIM)/PI
      WRITE(LINE,'('' distance limit :'',G14.4,'' / deg /'')') T     
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,'('' rms limit      :'',G14.4,'' / A /'')')  
     *                DIST_LIM_RMS     
      CALL MSGDOC(MD,LINE)

      ITYPE=-1
C -----------------
      JPRMAX = IPRMAX
      IF(NPMAX.GT.0.AND.NPMAX.LT.JPRMAX) JPRMAX = NPMAX 
      NPEAK = 0
      IDEL  = 1
      DO I=1,3
      DO J=1,NXY
        IPOOL(J,I)=-32766
      ENDDO
      ENDDO
      ISECT(1) = 1
      ISECT(2) = 2
      ISECT(3) = 3
      SCL(1)   = 1.0
      SCL(2)   = 1.0
      SCL(3)   = 1.0
      CALL IRDENS(MT,NAME,M,ITYPE,ICNTZ,NX,NY,NZ,IZMAX,
     *   IZMIN,RMAX,RMIN,IPOOL(1,2),SCL(2),A,B,C,AL,BE,GA,RMS
     *   ,AVER,RESOL,IX0,IY0,IZ0,ITR,TTT
     *   ,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        deallocate(IPOOL,STAT=ISTAT)
        CALL MSGERR(MD,' ERR: READ FILE-DENS')
        RETURN
      ENDIF
      IPP = ISECT(1)        
      IP  = ISECT(2)        
      IPN = ISECT(3)
C -------------------------------------------------------------
      NNX = NX
      NNY = NY
      DO     IZ=IZMIN+1,IZMAX+1
        IPP = ISECT(1)        
        IP  = ISECT(2)        
        IPN = ISECT(3)
        IZ1 = IZ-1
        Z   = IZ1/FLOAT(NZ)
        IF(IZ.LE.IZMAX) THEN        
          CALL IRDENS(MT,NAME,M,ITYPE,ICNTZ,NX,NY,NZ,IZMAX,
     *     IZMIN,RMAX,RMIN,IPOOL(1,IPN),SCL(IPN),A,B,C,AL,BE,GA,RMS
     *     ,AVER,RESOL,IX0,IY0,IZ0,ITR,TTT
     *     ,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            deallocate(IPOOL,STAT=ISTAT)
            CALL MSGERR(MDOC,' ERR: READ FILE-DENS')
            RETURN
          ENDIF
        ELSE
          SCL(IPN)=1.0
          DO J=1,NXY
            IPOOL(J,IPN)=-32766
          ENDDO
        ENDIF

        IXCONST=0
        DO     IY=1,NNY
          IND0 = (IY-1)*NX
          DO     IX=1,NNX
            IND = IND0+IX
            D  = IPOOL(IND,IP )/SCL(IP )
            ID = IPOOL(IND,IP )
            IF(IX.EQ.1) THEN
              DOLD =D
              IDOLD=ID
            ELSE
              IF(ID.NE.IDOLD) THEN
                IXCONST=0
                GO TO 400
              ENDIF
            ENDIF
          ENDDO
          IXCONST=1
        ENDDO
  400   CONTINUE

        IYCONST=0
        DO     IX=1,NNX
          DO     IY=1,NNY
            IND0 = (IY-1)*NX
            IND  = IND0+IX
            D    = IPOOL(IND,IP )/SCL(IP )
            ID   = IPOOL(IND,IP )
            IF(IY.EQ.1) THEN
              DOLD =D
              IDOLD=ID
            ELSE
              IF(ID.NE.IDOLD) THEN
                IYCONST=0
                GO TO 410
              ENDIF
            ENDIF
          ENDDO
          IYCONST=1
        ENDDO
  410   CONTINUE

        NNNY=NNY
        IF(IYCONST.EQ.1) NNNY=1
        DO     IY=1,NNNY
          Y    = (IY-1)/FLOAT(NY)
          IND0 = (IY-1)*NX

          NNNX=NNX
          IF(IXCONST.EQ.1) NNNX=1
          DO     IX=1,NNNX
            X   = (IX-1)/FLOAT(NX)
            IND = IND0+IX

            D  = IPOOL(IND,IP )/SCL(IP )
            ID = IPOOL(IND,IP )
            DP = IPOOL(IND,IPP)/SCL(IPP)
            DN = IPOOL(IND,IPN)/SCL(IPN)

            IF(D.GT.DLIM) THEN
              IF(D.GT.DP) THEN
                IF(D.GE.DN) THEN

                  DO JY=-IDEL,IDEL
                    JYY=IY+JY
                    IF(JYY.LT.1) THEN
                      IF(ITR.EQ.0) THEN
                        JYY=JYY+NY
                      ELSE
                        GO TO 300
                      ENDIF
                    ENDIF
                    IF(JYY.GT.NY) THEN
                      IF(ITR.EQ.0) THEN
                        JYY=JYY-NY
                      ELSE
                        GO TO 300
                      ENDIF
                    ENDIF
                    JND0=(JYY-1)*NX
                    DO JX=-IDEL,IDEL
                      JXX=IX+JX
                      IF(JXX.LT.1) THEN
                        IF(ITR.EQ.0) THEN
                          JXX=JXX+NX
                        ELSE
                          GO TO 200
                        ENDIF
                      ENDIF
                      IF(JXX.GT.NX) THEN
                        IF(ITR.EQ.0) THEN
                          JXX=JXX-NX
                        ELSE
                          GO TO 200
                        ENDIF
                      ENDIF
                      IF(JXX.NE.IX.OR.JYY.NE.IY) THEN
                        IF(TYPE.NE.'R'.OR.
     *                    ((IZ1.NE.0   .OR.JX.NE.-JY).AND.
     *                     (IZ1.NE.NZ-1.OR.JX.NE. JY)     ))THEN 
                        JND=JND0+JXX

                        DD =IPOOL(JND,IP)/SCL(IP)
                        IDD=IPOOL(JND,IP)

                        IF(IDD.GT.ID) GO TO 100

                        ENDIF
                      ENDIF
 200                  CONTINUE
                    ENDDO
 300                CONTINUE
                  ENDDO
                  DRMS = D/RMS
                  IX1  = IX-1
                  IY1  = IY-1

                  TYPE_S = TYPE

                  IF(IX.GT.1.AND.IX.LT.NX) THEN
                    KIND0 = IY1*NX
                    KIND  = KIND0+IX1
                    D1    = IPOOL(KIND,IP)/SCL(IP)
                    D2    = D
                    KIND0 = IY1*NX
                    KIND  = KIND0+(IX+1)
                    D3    = IPOOL(KIND,IP)/SCL(IP)
                    CALL PARAB(D1,D2,D3,X_PR,C_PR,D_PR)
                  ELSE
                    X_PR = 0.0
                    C_PR = 0.0
                    D_PR = D
                  ENDIF
                  FX = FLOAT(IX1)+X_PR

                  IF(IY.GT.1.AND.IY.LT.NY) THEN
                    KIND = (IY1-1)*NX+IX
                    D1   = IPOOL(KIND,IP)/SCL(IP)
                    D2   = D
                    KIND = (IY1+1)*NX+IX
                    D3   = IPOOL(KIND,IP)/SCL(IP)
                    CALL PARAB(D1,D2,D3,X_PR,C_PR,D_PR)
                  ELSE
                    X_PR = 0.0
                    C_PR = 0.0
                    D_PR = D
                  ENDIF
                  FY = FLOAT(IY1)+X_PR


                  IF(IZ1.GT.IZMIN.AND.IZ1.LT.IZMAX) THEN
                    D1 = DP
                    D2 = D
                    D3 = DN
                    CALL PARAB(D1,D2,D3,X_PR,C_PR,D_PR)
                  ELSE
                    X_PR = 0.0
                    C_PR = 0.0
                    D_PR = D
                  ENDIF
                  FZ = FLOAT(IZ1)+X_PR

                  T_DIST_LIM = DIST_LIM

                  IFIN = 0
                  CALL PSTORE_RF(MDOC,IFIN
     *            ,NPEAK,D,DRMS,IX1,IY1,IZ1,T_DIST_LIM,DIST_LIM_RMS
     *            ,PROG,FX,FY,FZ
     *            ,RESULTA(1,1),RESULTA(1,2),RESULTA(1,3),RESULTA(1,4)       
     *            ,RESULTA(1,5),RESULTA(1,6),RESULTA(1,7),RESULTA(1,8)       
     *            ,RESULTA(1,9)
     *            ,RESULTA(1,22),RESULTA(1,23),RESULTA(1,24)
     *            ,RESULTA(1,25),RESULTA(1,26),RESULTA(1,27)
     *            ,JPRMAX,IPRROW
     *            ,NSYM,ISYM,IPRSYM,TYPE,IERR)
 100              CONTINUE
                ENDIF
              ENDIF
            ENDIF
          ENDDO
        ENDDO

        ITEMP    = ISECT(1)
        ISECT(1) = ISECT(2)
        ISECT(2) = ISECT(3)
        ISECT(3) = ITEMP

      ENDDO
C ----------------------
      IFIN = 1
      T_DIST_LIM = DIST_LIM
      CALL PSTORE_RF(MDOC,IFIN
     *  ,NPEAK,D,DRMS,IX1,IY1,IZ1,T_DIST_LIM,DIST_LIM_RMS
     *  ,PROG,FX,FY,FZ
     *  ,RESULTA(1,1),RESULTA(1,2),RESULTA(1,3),RESULTA(1,4)       
     *  ,RESULTA(1,5),RESULTA(1,6),RESULTA(1,7),RESULTA(1,8)       
     *  ,RESULTA(1,9)
     *  ,RESULTA(1,22),RESULTA(1,23),RESULTA(1,24)
     *  ,RESULTA(1,25),RESULTA(1,26),RESULTA(1,27)
     *  ,JPRMAX,IPRROW
     *  ,NSYM,ISYM,IPRSYM,TYPE,IERR)
C ---
      IF(NPEAK.GT.0) THEN
        II  = 0
        III = 0
        DO I=1,NPEAK
          RINDEX   = RESULTA(I,9)
          DFLAG    = RESULTA(INDEX,22)
          III = III + 1
          IF(DFLAG.LE.0.0) II = II + 1
          IF(II.GE.NP_LIM) GO TO 500
        ENDDO
  500   CONTINUE
        NPEAK = III
        NPMAX = NPEAK
      ENDIF
C ---
      NPMAXW = NPMAX
      NPMAXP = NPMAX
      IF(NPMAXP.LE.0) NPMAX = 20
      IF(DELTA.LT.0.00001)  DELTA = 10.0 
      CALL RES_PRINT_RF(MDOC,NPEAK,NPMAXP,NP_SRF,NAME_TSRF,DELTA
     *       ,RESULTA(1,1),RESULTA(1,2),RESULTA(1,3),RESULTA(1,4)       
     *       ,RESULTA(1,5),RESULTA(1,6),RESULTA(1,7),RESULTA(1,8)       
     *       ,RESULTA(1,9),RESULTA(1,10),RESULTA(1,11),RESULTA(1,12)    
     *       ,NCS,PROG,SPEC,RESULT,IPRMAX,IPRROW
     *       ,NSYM,ISYM,IPRSYM,IERR)
C ----------------------
c                                        1      2     3      4
c      SUBROUTINE RES_PRINT(MDOC,NPEAK,IXPEAK,IYPEAK,IZPEAK,PEAK
c           5    6   7   8   9
c     *  ,SIGPK,DXA,DYB,DZG,INDPK
      IF(NPEAK.GT.0) THEN
        DO I=1,NPEAK
          RINDEX       = RESULTA(I,9)
          RESULT(I,10) = RESULTA(INDEX,1)
          RESULT(I,11) = RESULTA(INDEX,2)
          RESULT(I,12) = RESULTA(INDEX,3)
          RESULT(I,22) = RESULTA(INDEX,22)
          RESULT(I,23) = RESULTA(INDEX,23)
          RESULT(I,24) = RESULTA(INDEX,24)
          RESULT(I,25) = RESULTA(INDEX,25)
          RESULT(I,26) = RESULTA(INDEX,26)
          RESULT(I,27) = RESULTA(INDEX,27)
        ENDDO
        DO I=1,NPEAK
          RINDEX      = RESULT(I,10)
          RESULT(I,1) = INDEX
          RINDEX      = RESULT(I,11)
          RESULT(I,2) = INDEX
          RINDEX      = RESULT(I,12)
          RESULT(I,3) = INDEX
        ENDDO

        DO I=1,NPEAK
          RINDEX       = RESULTA(I,9)
          RESULT(I,10) = RESULTA(INDEX,4)
          RESULT(I,11) = RESULTA(INDEX,5)
        ENDDO
        DO I=1,NPEAK
          RESULT(I,4) = RESULT(I,10)
          RESULT(I,5) = RESULT(I,11)
        ENDDO

        DO I=1,NPEAK
          RINDEX       = RESULTA(I,9)
          RESULT(I,10) = RESULTA(INDEX,6)
          RESULT(I,11) = RESULTA(INDEX,7)
          RESULT(I,12) = RESULTA(INDEX,8)
        ENDDO
        DO I=1,NPEAK
          RESULT(I,6)  = RESULT(I,10)
          RESULT(I,7)  = RESULT(I,11)
          RESULT(I,8)  = RESULT(I,12)
        ENDDO

        RESULT(1,12) = NPEAK

      ELSE
        RESULT(1,12) = 0
        IERR = 0
      ENDIF
      CLOSE(MT)
      NPMAX = NPMAXW

      deallocate(IPOOL,STAT=ISTAT)

      RETURN
      END

      SUBROUTINE BYTARR2(MDOC,IMODE,FNAME,POOL,IPRPLN,IR,IPRMAP,ZMINTS
     *   ,KX,KY,KZ,KZMIN,KZMAX,AR,BR,CR,ALR,BER,GAR
     *   ,RMAX,RMIN_INP,R000,SCALE
     *   ,RLIM,IX_MIN,IX_MAX,IY_MIN,IY_MAX,IZ_MIN,IZ_MAX
     *   ,POSITIV,PERCENT,ISYM,IPRSYM,IERR)
C ----------------------------------------------------------------------
C
C -P- BYTARR - reads electron-dens-file into byte-array IR
C
C input:
C  FNAME - file name. If FNAME = ' ' - FNAME,MSG,PERCENT will be
C                                            taken from terminal.
C  MDOC  - mode of writting messages to DOC-file
C                0 - only term, < - 0 only file, 0 < < 99 - both
C                >= 99 - not write  
C  IMODE=0
C
C         input    JX : from: 0 to: KX-1
C                  JY : from: 0 to: KY-1
C                  JZ : from: 0 to: KZMIN - KZMAX
C         output   ID        byte-array IR 
C                             / dimension KX,KY,KZMAX-KZMIN+1/
C
C  IMODE=1
C
C         KX - EVEN
C
C         input    JX : from: 0 to: KX/2
C                  JY : from: 0 to: KY-1
C                  JZ : from: 0 to: KZMAX-KZMIN
C         output   ID        byte-array IR 
C                             / dimension KX/2+1,KY,KZMAX-KZMIN+1/
C
C  IMODE=2
C
C         KX - EVEN
C         KY - EVEN
C
C         input    JX : from: 0 to: KX/2
C                  JY : from: 0 to: KY/2
C                  JZ : from: 0 to: KZMAX-KZMIN
C
C         output   ID        byte-array IR 
C
C   POSITIV /<'Y'>/ - using positive value only 
C
C   PERCENT        percent of R-MAX, if =0 take value from 
C                       title of file   
C                   RMAX - max value of dens in array IR
C
C      input file-DENS  cell : KX,KY,KZ, KZMIN=0 , KZMAX >= ZMINTS * KZ
C                             AR,BR,CR /angstroms/,ALR,BER,GAR /radians/
C
C ---------
C            DENS(JX,JY,JZ) --> ID/byte/ = (DENS-R000)/SCALE
C
C         output IERR > 0 is signal of error.
C ---------------------------------------------------------------------
      INTEGER*2 IR  (IPRMAP)
      INTEGER*2 POOL(IPRPLN)
      CHARACTER MSG*1,POSITIV*1

      INTEGER*2 ISYM(5,3,IPRSYM)
C ---
      CHARACTER TITLE*160,FNAME*(*),LINE*256,TTT*80
C ---------------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      MSG  = POSITIV
      MTIN = 31
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.0.AND.(FNAME(1:1).NE.','.OR.FNAME(1:1).NE.',')) THEN
        ITYPE  =0
        CALL IRDENS(MTIN,FNAME,MD,ITYPE,ICNTZ,KX,KY,KZ,KZMAX,
     *  KZMIN,RMAX,RMIN,POOL,SCALER,AR,BR,CR,ALR,BER,GAR,DRMS,
     *  RAVER,RESOL,JX0,JY0,JZ0,JTR,TTT,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: cannot open input DENS file')
          RETURN
        ENDIF
        KXY=KX*KY
        IF(KXY.GT.IPRPLN) THEN
          WRITE(LINE,
     *    '('' ERROR: not memory enough '',I4,'' x'',I4,'' >'',I8)')
     *             KX,KY,IPRPLN
          CALL MSGERR(MDOC,LINE)
          IERR = 1
          CLOSE(MTIN)
          RETURN
        ENDIF
      ELSE
        IERR=1
        CALL MSGERR(MDOC,' ERROR: cannot open input DENS file')
        RETURN
      ENDIF
C ---------------------------------------------------------------------
      ITESTZ = KZ*ZMINTS
      IF(KZMAX.LT.ITESTZ) THEN
        WRITE(TITLE,10) ITESTZ
 10     FORMAT(' ERROR: Z-MAX < ',I6,' (in BYTARR2)')
        CALL MSGERR(MDOC,TITLE)
        CLOSE (MTIN)
        IERR=1
        RETURN
      ENDIF
      IF(KZMIN.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: Z-MIN N# 0 (in BYTARR2)')
        CLOSE (MTIN)
        IERR=1
        RETURN
      ENDIF
C ---------------------------------------------------------------------
      IF(IMODE.EQ.0) THEN
        KXYZ = (KXY*ITESTZ)+1
      ELSE IF(IMODE.EQ.1) THEN
        IT = MOD(KX,2)
        IF(IT.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: NX is not even (in BYTARR2)')
          CLOSE (MTIN)
          IERR=1
          RETURN
        ENDIF
        KX2  = KX/2
        KXYZ = ((KX2+1)*KY*ITESTZ)+1
      ELSE IF(IMODE.EQ.2) THEN
        IT = MOD(KX,2)
        IF(IT.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: NX is not even (in BYTARR2)')
          CLOSE (MTIN)
          IERR=1
          RETURN
        ENDIF
        IT = MOD(KY,2)
        IF(IT.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: NY is not even (in BYTARR2)')
          CLOSE (MTIN)
          IERR=1
          RETURN
        ENDIF
        KY2  = KY/2
        KX2  = KX/2
        KXYZ = ((KX2+1)*(KY2+1)*ITESTZ)+1
      ENDIF
      IF(KXYZ.GT.IPRMAP) THEN
        WRITE(TITLE,30) IPRMAP
 30     FORMAT(
     *  ' ERROR: not memory enough to keep DENSITY (in BYTARR2):',I6)
        CALL MSGERR(MDOC,TITLE)
        CLOSE (MTIN)
        IERR=1
        RETURN
      ENDIF
C --------------------------------------------
      R000 =-RMIN          
      IF(RMIN_INP.GT.-1.0 E20) R000 = -RMIN_INP
      IF(MSG.EQ.'n') MSG  = 'N'
      IF(MSG.NE.'N') R000 = 0.0             
C ---------------------------
      RRMAX = 0.0
      IF(PERCENT.LE.0.0) PERCENT = 100.0
      RRMAX = RMAX*(PERCENT/100.)
      WRITE(TITLE,40) PERCENT
 40   FORMAT(' PERCENT OF R-MAX :',F10.5)
      CALL MSGDOC(MDOC,TITLE)
      WRITE(TITLE,50) RRMAX
 50   FORMAT(' R-MAX NOW :',F18.6)
      CALL MSGDOC(MDOC,TITLE)
      SCALE = (RRMAX+R000)/32666.0
C --------------------------------------------
      IF(RLIM.LT.0.00001) THEN
C       RLIM = 1.0*SCALE-R000
        RLIM = SCALE 

        RLIM = DRMS/2.0

c        RLIM = RLIM/2.0
      ELSE
        RLIM = RLIM*DRMS
      ENDIF
C --------------------------------------------
      IF(IMODE.EQ.0) THEN
        NX = KX
        NY = KY
      ELSE IF(IMODE.EQ.1) THEN
        NX = KX2+1
        NY = KY
      ELSE IF(IMODE.EQ.2) THEN
        NX = KX2+1
        NY = KY2+1
      ENDIF
C -------------------------------------------
      ITYPE = 1
      IM    =-1

      IX_MIN = KX
      IX_MAX = 0      
      IY_MIN = KY
      IY_MAX = 0      
      IZ_MIN = KZ
      IZ_MAX = 0      

      CALL SETDEN2(IM,IX,IY,IZZ,ID,IR,KX,KY,KZ,KZMIN,KZMAX,IPRMAP)

      DO     IZ=KZMIN,ITESTZ
        IZZ=IZ-KZMIN
        CALL IRDENS(MTIN,FNAME,MD,ITYPE,ICNTZ,KX,KY,KZ,KZMAX,
     *  KZMIN,RMAX,RMIN,POOL,SCALER,AR,BR,CR,ALR,BER,GAR,DRMS,
     *  RAVER,RESOL,JX0,JY0,JZ0,JTR,TTT,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE-DENS')
          CLOSE(MTIN)
          RETURN
        ENDIF
        DO IY=0,NY-1
          IND = IY*KX
          DO IX=0,NX-1
            JND = IND+IX+1
            D   = POOL(JND)/SCALER
            IF(ABS(D).GT.RLIM) THEN
              IF(IX.LT.IX_MIN) IX_MIN = IX
              IF(IX.GT.IX_MAX) IX_MAX = IX
              IF(IY.LT.IY_MIN) IY_MIN = IY
              IF(IY.GT.IY_MAX) IY_MAX = IY
              IF(IZ.LT.IZ_MIN) IZ_MIN = IZ
              IF(IZ.GT.IZ_MAX) IZ_MAX = IZ
            ENDIF
            ID  = (D+R000)/SCALE
            IF(ID.LT.    0) ID= 0
            IF(ID.GT.32666) ID= 32666
            CALL SETDEN2(IMODE,IX,IY,IZZ,ID
     *                  ,IR,KX,KY,KZ,KZMIN,KZMAX,IPRMAP)
          ENDDO
        ENDDO
      ENDDO 
           
      CLOSE (MTIN)

      RETURN
      END

      SUBROUTINE F2P1(MDOC,NAME_IN,NAME_OUT,RESX
     * ,ISYM,IPRSYM,IERR)
C ---------------------------------------------------

c      INTEGER*4 IARRH(*),IARRS(*)
c      REAL      ARRF(*),ARRS(*)

      integer,   allocatable :: IARRH(:)
      integer,   allocatable :: IARRS(:)
      real,      allocatable :: ARRF(:)
      real,      allocatable :: ARRS(:)

      INTEGER*2 ISYM(5,3,IPRSYM)

      COMMON/COM_SRTMRG/ RESMIN,RESMAX,NSYM,RLATT,NUMBT,NFL,LINE
     *                  ,MSG
      REAL RLATT(6)
      CHARACTER LINE*256

      INTEGER*4 MDOC,IERR,NUMBT
      CHARACTER FORM*1,NAME_IN*(*),NAME_OUT*(*)
      CHARACTER CODE*4,PDB_CODE*4,ANOM*1,MSG*1,SETT*1
C ------------------------------------------------------------
      IERR   = 0

      SETT  = 'N'
      FORM  = 'B'
C     MAXREF = MEMORY/4

C      IANOM  = 0
C      IF(ANOM.EQ.'y') ANOM='Y'
C      IF(ANOM.EQ.'Y') IANOM=1
      IANOM = 0

      MSG    = ' '
      NUMBT  = 0
      NFL    = 0
      RESMIN = 0.0
      RESMAX = 1.0E30
      MODE   = 1
      ACELL  = 0.0
      BCELL  = 0.0
      CCELL  = 0.0
      ALCELL = 0.0
      BECELL = 0.0
      GACELL = 0.0
      NSG    = 0
      NSETT  = 0
      CODE   = ' '
      PDB_CODE = ' ' 
      ANOM   = ' '
      ATOP   = 0.0
C ---
      ITEST  = 1
      NUMBT  = 0
      IF(NUMBT.EQ.0) MSG=' '

      MAXREF = 10
      allocate(IARRH(1: MAXREF),STAT=ISTAT)
      allocate(IARRS(1: MAXREF),STAT=ISTAT)
      allocate(ARRF(1: MAXREF),STAT=ISTAT)
      allocate(ARRS(1: MAXREF),STAT=ISTAT)

      CALL RDSORT_F2P1(MDOC,NUMBT,NFL
     *   ,IARRH,IARRS,ARRF,ARRS
     *   ,ACELL,BCELL,CCELL,ALCELL,BECELL,GACELL,NSG,NSETT,CODE
     *   ,PDB_CODE,MAXREF,RLATT,RESMIN,RESMAX,RESX,ISYM,NSYM
     *   ,IPRSYM,MSG,FORM,NAME_IN,LINE,SETT,ITEST,IERR)
      deallocate(IARRH,STAT=ISTAT)
      deallocate(IARRS,STAT=ISTAT)
      deallocate(ARRF,STAT=ISTAT)
      deallocate(ARRS,STAT=ISTAT)

      IF(IERR.NE.0) RETURN

      MAXREF = NUMBT

      IT = 0
      allocate(IARRH(1: MAXREF),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(IARRS(1: MAXREF),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(ARRF(1: MAXREF),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(ARRS(1: MAXREF),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      IF(IT.GT.0) THEN
        IERR = 1
        CALL MSGERR(MDOC,
     *    ' ERROR: in F2P1: problem with memory allocation')
        CALL MSGERR(MDOC,
     *    '                 try to change resolution')
        RETURN
      ENDIF
      ITEST = 0
      NUMBT  = 0
      IF(NUMBT.EQ.0) MSG=' '
      CALL RDSORT_F2P1(MDOC,NUMBT,NFL
     *   ,IARRH,IARRS,ARRF,ARRS
     *   ,ACELL,BCELL,CCELL,ALCELL,BECELL,GACELL,NSG,NSETT,CODE
     *   ,PDB_CODE,MAXREF,RLATT,RESMIN,RESMAX,RESX,ISYM,NSYM
     *   ,IPRSYM,MSG,FORM,NAME_IN,LINE,SETT,ITEST,IERR)
      IF(IERR.NE.0) GO TO 900
C ---
      NSYM = 1

      CALL JOINWR_F2P1(MDOC,NUMBT
     *   ,IARRH,IARRS,ARRF,ARRS
     *   ,MAXREF,RLATT,RESMIN,RESMAX,ISYM,NSYM
     *   ,NAME_OUT,IANOM,ATOP
     *   ,IPRSYM,FORM,LINE,IERR)
      IF(IERR.NE.0) GO TO 900
C ---
  900 CONTINUE
      deallocate(IARRH,STAT=ISTAT)
      deallocate(IARRS,STAT=ISTAT)
      deallocate(ARRF,STAT=ISTAT)
      deallocate(ARRS,STAT=ISTAT)

      RETURN
      END
C --------
C -I-
      SUBROUTINE DEF_RAD(MDOC,MOD1,NAME1,RESULT,ISYM,IPRSYM,IERR)
C --------------------------------------
C  for output:
CC    real RESULT(11):
C
C      RESULT(1) = NTOT
C      RESULT(2) = XMIN
C      RESULT(3) = XMAX
C      RESULT(4) = YMIN
C      RESULT(5) = YMAX
C      RESULT(6) = ZMIN
C      RESULT(7) = ZMAX
C      RESULT(8) = XS
C      RESULT(9) = YS
C      RESULT(10)= ZS
C      RESULT(11)= RADIUS
C
C        NTOT       - number of atoms
C        XMIN,XMAX  - MIN and MAX value of X,Y,Z
C        YMIN,YMAX
C        ZMIN,ZMAX
C        XS,YS,ZS   - center of atoms: XS = Sum(X)/N
C        Radius     - Radius of molecule
C -I-
C --------------------------------------
      INTEGER   MDOC,IERR
      REAL      RESULT(*)
      CHARACTER NAME1*(*),MOD1*1
      INTEGER   IPRSYM
      INTEGER*2 ISYM(5,3,IPRSYM)
C ------------------------------------------------------------
      INCLUDE 'mr_crd_com.fh'
C -------------------------------------------------------------------
      INTEGER   MODE,NSYM
      REAL      X(3)
      CHARACTER LINE*256
C=====================================================================
      MODEL= IERR
      IERR = 0
      PI   = 4.0*ATAN(1.0)
      XS   = 0.0
      YS   = 0.0
      ZS   = 0.0
      XS2  = 0.0
      YS2  = 0.0
      ZS2  = 0.0
      XMAX =-1.E 30
      YMAX =-1.E 30
      ZMAX =-1.E 30
      XMIN = 1.E 30
      YMIN = 1.E 30
      ZMIN = 1.E 30
C -----------------------------------------------------------------
      MD =-ABS(MDOC)-1
      M  = 99
      IN = 10
C --------------
      IF(MOD1.EQ.'D') THEN
        CALL DEF_RAD_DNS(MDOC,RESULT,ISYM,IPRSYM,IERR)
C        RESULT(1) = RADIUS
C        RESULT(2) = XMIN
C        RESULT(3) = XMAX
C        RESULT(4) = YMIN
C        RESULT(5) = YMAX
C        RESULT(6) = ZMIN
C        RESULT(7) = ZMAX
C        RESULT(8) = XS
C        RESULT(9) = YS
C        RESULT(10)= ZS
C        RESULT(11)= RI
C        RESULT(12)= MODEL
C        RESULT(13)= NMODEL
        RETURN
      ENDIF
C --------------
      CALL ORCRD(MD,IN,NAME1,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: can not open INPUT_FILE')
        CLOSE(IN) 
        RETURN
      ENDIF
C -------------------------------------------
      NA   = 0
      NTOT = 0
      IEND =-1
C ----------------------
 200  CONTINUE
        CALL RDCRD(M,IN,MODE,IEND,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: READ INPUT_FILE')
          CLOSE(IN)
          RETURN
        ENDIF
        IF(IEND.NE.0) GO TO 300
        IF(MODE.EQ.0) THEN
          IF(MODEL.GT.0.AND.CR_MODEL.NE.MODEL) GO TO 200
          NA = NA+1
          IF((CR_ATYPE .EQ.' '.OR.CR_ATYPE .EQ.'.'.OR.
     *        CR_ATYPE .EQ.'y'.OR.CR_ATYPE .EQ.'Y'.OR.
     *        CR_ATYPE .EQ.'r'.OR.CR_ATYPE .EQ.'R').AND.
     *        CR_OCC .GT.0.0001                        ) THEN

            X(1) = CR_XYZ(1)
            X(2) = CR_XYZ(2)
            X(3) = CR_XYZ(3)
            IF(X(1).GT.XMAX) XMAX=X(1)
            IF(X(2).GT.YMAX) YMAX=X(2)
            IF(X(3).GT.ZMAX) ZMAX=X(3)
            IF(X(1).LT.XMIN) XMIN=X(1)
            IF(X(2).LT.YMIN) YMIN=X(2)
            IF(X(3).LT.ZMIN) ZMIN=X(3)
            XS   = XS+X(1)
            YS   = YS+X(2)
            ZS   = ZS+X(3)
            XS2  = XS2+X(1)*X(1)
            YS2  = YS2+X(2)*X(2)
            ZS2  = ZS2+X(3)*X(3)
            NTOT = NTOT+1
          ENDIF

        ELSE

        ENDIF

      GO TO 200
C ---------------------------------------------------------
  300 CONTINUE
      WRITE(LINE,'('' NUMBER OF COORDS :'',I6)') NA
      CALL MSGDOC(MDOC,LINE)
      CLOSE(IN)
      IF(NA.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: in DEF_RAD: number of atoms = 0')
        IERR=1
        RETURN
      ENDIF
      IF(NTOT.GT.0) THEN
        XS  = XS/NTOT
        YS  = YS/NTOT
        ZS  = ZS/NTOT
        XS2 = XS2/NTOT
        YS2 = YS2/NTOT
        ZS2 = ZS2/NTOT
        WRITE(LINE,'('' X :'',2F10.3)') XMIN,XMAX
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'('' Y :'',2F10.3)') YMIN,YMAX
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'('' Z :'',2F10.3)') ZMIN,ZMAX
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'('' CENTRE OF COORDS :'',3F10.3)') XS,YS,ZS
        CALL MSGDOC(MDOC,LINE)
        RX = XS2-XS*XS
        RY = YS2-YS*YS
        RZ = ZS2-ZS*ZS
        RI = SQRT(RX+RY+RZ)
        WRITE(LINE,'('' Radius of inertia :'',F10.3)') RI
        CALL MSGDOC(MDOC,LINE)
      ELSE
        CALL MSGERR(MDOC,' ERROR: N-ATOMS = 0')
        IERR=1
        RETURN
      ENDIF
C -----------------------------------------------------------
      CALL ORCRD(MD,IN,NAME1,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN INPUT_FILE')
        CLOSE(IN) 
        RETURN
      ENDIF

C ------------------------------
      NA     = 0
      NTOT   = 0
      IEND   =-1
      RADIUS = 0.0
C ----------------------
 400  CONTINUE
        CALL RDCRD(M,IN,MODE,IEND,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: READ INPUT_FILE')
          CLOSE(IN)
          RETURN
        ENDIF
        IF(IEND.NE.0) GO TO 500
        IF(MODE.EQ.0) THEN
          IF(MODEL.GT.0.AND.CR_MODEL.NE.MODEL) GO TO 400
          NA = NA+1
          IF((CR_ATYPE .EQ.' '.OR.CR_ATYPE .EQ.'.'.OR.
     *        CR_ATYPE .EQ.'y'.OR.CR_ATYPE .EQ.'Y'.OR.
     *        CR_ATYPE .EQ.'r'.OR.CR_ATYPE .EQ.'R').AND.
     *        CR_OCC .GT.0.0001                        ) THEN

            X(1) = CR_XYZ(1)-XS
            X(2) = CR_XYZ(2)-YS
            X(3) = CR_XYZ(3)-ZS

c            XS=XS+X(1)
c            YS=YS+X(2)
c            ZS=ZS+X(3)

            T1   = X(1)*X(1)
            T2   = X(2)*X(2)
            T3   = X(3)*X(3)
            RAD2 = T1+T2+T3
            IF(RAD2.GT.RADIUS) RADIUS=RAD2
            NTOT = NTOT+1
          ENDIF

        ELSE

        ENDIF

      GO TO 400
C ---------------------------------------------------------
  500 CONTINUE
      CLOSE(IN)
      NMODEL = CR_MODEL
      RADIUS=SQRT(RADIUS)
      WRITE(LINE,'('' RADIUS_MAX:'',F10.3)') RADIUS
      CALL MSGDOC(MDOC,LINE)
C ---------------------------------------------------------
      RESULT(1) = RADIUS
      RESULT(2) = XMIN
      RESULT(3) = XMAX
      RESULT(4) = YMIN
      RESULT(5) = YMAX
      RESULT(6) = ZMIN
      RESULT(7) = ZMAX
      RESULT(8) = XS
      RESULT(9) = YS
      RESULT(10)= ZS
      RESULT(11)= RI
      RESULT(12)= MODEL
      RESULT(13)= NMODEL
C -------------------------------------------
      RETURN
      END

      SUBROUTINE COPY_CRD_NCS(MDOC,NAMEC,NAMEO
     * ,NCS_ID,NM_TOTAL,NA_TOTAL
     * ,ANGLES_NCS_INP,ANGLES_RESTR,CENTRE_COM
     * ,IPRDOM,NSYM,ISYM,IPRSYM,IERR)
C ----------------------------------------------------------
      REAL      ANGLES_NCS_INP(3),CENTRE_COM(3)
      REAL      ANGLES_RESTR(3,IPRDOM)
C ===
      INTEGER     MDOC,IPRSYM,IERR
      INTEGER*2   ISYM(5,3,IPRSYM)
      CHARACTER   NAMEC*(*),NAMEO*(*)
C ----------------------------------------------------------------
C ------
C BLANC -common
C
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
C !!!!
      CHARACTER SP_GROUP*24,USER_TITLE*80
C !!!!
C --------------
      INCLUDE 'mr_crd_com.fh'
C ----------------------------------------------------------------
      REAL      ANGLES(3),TRMAT(3,3),TR(3),V(3),C_INP(3),C(3)
      REAL      V1(3),V2(3)
      CHARACTER LINE*256
      CHARACTER NCSF*1,GID*4
C==================================================================
      IMODEL = IERR
      IERR = 0
      PI   = 4.0*ATAN(1.0)
      MD   = -ABS(MDOC)-1
      M    = 99
C --------
      IN  = 10
      CALL ORCRD(M,IN,NAMEC,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: in rotfft: OPEN INPUT_FILE/CRD/')
        RETURN
      ENDIF

      CALL C_AT_CR

C --------
      NCS_INP = NCS_ID
      IF(NCS_ID.GT.100) THEN
        C_INP(1) = CENTRE_COM(1)
        C_INP(2) = CENTRE_COM(2)
        C_INP(3) = CENTRE_COM(3)

c            ANGLES_RESTR(1,IMOL) = ANGLES_NCS_INP(1)
c            ANGLES_RESTR(2,IMOL) = ANGLES_NCS_INP(2)
c            ANGLES_RESTR(3,IMOL) = ANGLES_NCS_INP(3)

      ENDIF
      IMOL     = 1
      NM_TOTAL = 0
      NA_TOTAL = 0
      DO I=1,IPRDOM
        ANGLES_RESTR(1,I) = 0.0
        ANGLES_RESTR(2,I) = 0.0
        ANGLES_RESTR(3,I) = 0.0
        CENTRE_COM(1)     = 0.0
        CENTRE_COM(2)     = 0.0
        CENTRE_COM(3)     = 0.0
      ENDDO   
C -------------------------------------------------
      NATOM  = 0
      IEND   =-1
C -------------------------------------------------
 200  CONTINUE
      CALL RDCRD(M,IN,MODE,IEND,IERR)
      IF(IERR.NE.0) THEN
        RETURN
      ENDIF
      IF(IEND.NE.0) GO TO 300
      IF(MODE.NE.0) THEN


        IF(CR_LINE(1:7).EQ.'#DOMAIN'.OR.CR_LINE(1:9).EQ.'#MOLECULE')THEN

          CALL RD_LINE_ROTFFT(CR_LINE,NW,NUMB_INP,ANGLES,C)

          IF(CR_LINE(1:9).EQ.'#MOLECULE') THEN

            IF(NATOM.GT.0) IMOL = IMOL + 1 
            IF(IMOL.GT.1) GO TO 300

            IF(IMOL.GT.IPRDOM) THEN
              WRITE(LINE,*) 
     *        ' ERROR: in rotfft: number of domains >',IPRDOM
              CALL MSGERR(MDOC,LINE)
              CLOSE(IN)
              IERR=1
              RETURN
            ENDIF

            ANGLES_RESTR(1,IMOL) = ANGLES(1)
            ANGLES_RESTR(2,IMOL) = ANGLES(2)
            ANGLES_RESTR(3,IMOL) = ANGLES(3)

            IF(IMOL.EQ.1.AND.NW.GE.8) THEN
              NCS_ID        = NUMB_INP
              CENTRE_COM(1) = C(1)
              CENTRE_COM(2) = C(2)
              CENTRE_COM(3) = C(3)
            ENDIF



          ELSE IF(CR_LINE(1:7).EQ.'#DOMAIN') THEN

          ENDIF

        ENDIF
        GO TO 200
      ENDIF

      IF((CR_ATYPE.NE.'.'.AND.CR_ATYPE.NE.' '.AND.
     *    CR_ATYPE.NE.'y'.AND.CR_ATYPE.NE.'Y'.AND.
     *    CR_ATYPE.NE.'r'.AND.CR_ATYPE.NE.'R').OR.
     *    CR_OCC .LT.0.0001                       ) GO TO 100
C ----
      NATOM = NATOM+1

 100   CONTINUE
      GO TO 200
C ------------------------------------------------------
 300  CONTINUE
      CLOSE(IN)

      IF(NATOM.LE.0) THEN
        IERR = 1
        RETURN
      ENDIF
      IF(NCS_INP.GT.100) THEN
        NCS_ID = NCS_INP
        CENTRE_COM(1) = C_INP(1)
        CENTRE_COM(2) = C_INP(2)
        CENTRE_COM(3) = C_INP(3)
      ELSE
        ANGLES_NCS_INP(1) = ANGLES_RESTR(1,1)
        ANGLES_NCS_INP(2) = ANGLES_RESTR(2,1)
        ANGLES_NCS_INP(3) = ANGLES_RESTR(3,1)
        ANGLES_RESTR(1,1) = 0.0
        ANGLES_RESTR(2,1) = 0.0
        ANGLES_RESTR(3,1) = 0.0
      ENDIF
C ---
      CALL GENERATE_NCS(MDOC,NCS_ID
     *  ,ANGLES_NCS_INP,ANGLES_RESTR,CENTRE_COM,NM_TOTAL,IERR)
      IF(IERR.NE.0) RETURN  
C ---
      CALL MSGDOC(MDOC
     *       ,'--------------------------------------------------')
      WRITE(LINE,'('' Number of atoms   :'',I8)') NATOM
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Number of molecules:'',I4)') NM_TOTAL
      CALL MSGDOC(MDOC,LINE)   
      NA_TOTAL = NATOM*NM_TOTAL
      WRITE(LINE,'('' New number of atoms :'',I8)') NA_TOTAL
      CALL MSGDOC(MDOC,LINE)

      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.LE.0.OR.NAMEO(1:1).EQ.','.OR.
     *               NAMEO(1:1).EQ.' '     ) RETURN
C ---
      IGR    = 0
      CALL SET_ASYMM(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *                    ,NCSF,GID,IERR)
      DO IM=1,NM_TOTAL
        IF(IM.LE.NMAX) THEN
          IGR      = IM
          ICH      = IGR
          IGOLD    = IGR
          ICHOLD   = IGR
          INC      = 0
          MLT      = 0
          IATM     = 0
          NCSF     = 'Y'
          GID      = '    '
          GID(1:2) = 'AA'
          CALL SET_ASYMM(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                 ,IGOLD,NCSF,GID,IERR)
          IF(IERR.NE.0) RETURN
        ENDIF
      ENDDO
      CALL CHECK_CHAIN_ID(INEW)
C --------------------------------------
      IOUT = 32
      CALL OWCRD(M,IOUT,NAMEO,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,
     *  ' ERROR: (rotfft_rb) OPEN OUTPUT FILE-CRD-TMP')
        CLOSE(IN)
        RETURN
      ENDIF
C --------
      NWORDS = 8
      IENDW  =-1
C -------------------------------------------------
      DO IM=1,NM_TOTAL

      IN  = 10
      CALL ORCRD(M,IN,NAMEC,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,
     *          ' ERROR: (rotfft_rb): open input file(crd)')
        RETURN
      ENDIF
      IEND   =-1
      IMOL   = 1
      NATOM  = 0

      IF(IM.EQ.1) THEN
        CR_LINE2 = ' '
        WRITE(CR_LINE,'(A,I6,2X,3(F9.4,1X),3F8.3)') 
     *        '#MOLECULE',NCS_ID
     *   ,ANGLES_NCS_INP(1),ANGLES_NCS_INP(2),ANGLES_NCS_INP(3)
     *   ,CENTRE_COM(1),CENTRE_COM(2),CENTRE_COM(3)
      ELSE
        WRITE(CR_LINE,'(A,I6,2X,3(F9.4,1X))') '#MOLECULE',IM
     *   ,ANGLES_RESTR(1,IM),ANGLES_RESTR(2,IM),ANGLES_RESTR(3,IM)
        V1(1) = (ANGLES_RESTR(1,IM)*PI)/180.0
        V1(2) = (ANGLES_RESTR(2,IM)*PI)/180.0
        V1(3) = (ANGLES_RESTR(3,IM)*PI)/180.0
        CALL POLTOM(V1(1),V1(2),V1(3),TRMAT)
        CALL FTOO(CENTRE_COM,V,IERR)   
      ENDIF
      MODE = 1

      IF(IMODEL.EQ.0) THEN
        CALL WRCRD(M,IOUT,MODE,IENDW,IERR)
      ENDIF

 1200 CONTINUE

      CALL RDCRD(M,IN,MODE,IEND,IERR)
      IF(IERR.NE.0) THEN
        CLOSE(IOUT)
        RETURN
      ENDIF
      IF(IEND.NE.0) GO TO 1300

      IF(MODE.NE.0) THEN
        IF(CR_LINE(1:7).EQ.'#DOMAIN'.OR.
     *     CR_LINE(1:9).EQ.'#MOLECULE') THEN

          IF(CR_LINE(1:9).EQ.'#MOLECULE') THEN

            IF(NATOM.GT.0) IMOL = IMOL + 1
            IF(IMOL.GT.1) GO TO 1300

              GO TO 1200

          ELSE IF(CR_LINE(1:7).EQ.'#DOMAIN') THEN

          ENDIF

        ENDIF

        IF(IMODEL.EQ.0) THEN
          CALL WRCRD(M,IOUT,MODE,IENDW,IERR)
        ENDIF

        GO TO 1200
      ENDIF

      IF((CR_ATYPE.NE.'.'.AND.CR_ATYPE.NE.' '.AND.
     *    CR_ATYPE.NE.'y'.AND.CR_ATYPE.NE.'Y'.AND.
     *    CR_ATYPE.NE.'r'.AND.CR_ATYPE.NE.'R').OR.
     *    CR_OCC .LT.0.0001                       ) GO TO 1100
C ----
      NATOM     = NATOM + 1
      CR_IGROUP = IM

      IF(IM.GT.1) THEN
        V1(1) = CR_XYZ(1) - V(1)
        V1(2) = CR_XYZ(2) - V(2)
        V1(3) = CR_XYZ(3) - V(3)
        CALL MVMULT(TRMAT,V1,V2)
        CR_XYZ(1) = V2(1) + V(1)
        CR_XYZ(2) = V2(2) + V(2)
        CR_XYZ(3) = V2(3) + V(3)
      ENDIF

      IF(IMODEL.EQ.0.OR.(IMODEL.EQ.IM)) THEN
        CALL WRCRD(M,IOUT,MODE,IENDW,IERR)
      ENDIF

 1100 CONTINUE
      GO TO 1200
C ------------------------------------------------------
 1300  CONTINUE
       CLOSE(IN) 

      ENDDO

      IENDW = 1
      MODE  = 0
      CALL WRCRD(M,IOUT,MODE,IENDW,IERR)
C --------------------------------------
      RETURN
      END

      SUBROUTINE GENERATE_NCS(MDOC,NCS_ID
     *  ,ANGLES_INP,ANGLES_NCS,CENTRE_NCS,NMOL,IERR)
C --------------------------------------
      REAL ANGLES_INP(3),ANGLES_NCS(3,*),CENTRE_NCS(3)
      REAL AM(3,3),AM1(3,3),RNCS(3,3),ROT(3,3),SM(3,3),A(3)
      REAL RM(3,3),RM1(3,3)
C --------------------------------------
      IERR = 0
C --
      PI     = 4.0*ATAN(1.0)
      RTODEG = 180./PI
      DEGTOR = 1.0/RTODEG
C --

c      write(*,*) '==',NCS_ID
c      write(*,*) '==',ANGLES_INP(1),ANGLES_INP(2),ANGLES_INP(3)
c      write(*,*) '==',CENTRE_NCS(1),CENTRE_NCS(2),CENTRE_NCS(3)

      A(1) = ANGLES_INP(1)*DEGTOR
      A(2) = ANGLES_INP(2)*DEGTOR
      A(3) = ANGLES_INP(3)*DEGTOR
      ANGLES_NCS(1,1) = 0.0
      ANGLES_NCS(2,1) = 0.0
      ANGLES_NCS(3,1) = 0.0
C     CALL EULERM(A(1),A(2),A(3),AM)
      CALL POLTOM(A(1),A(2),A(3),AM)
      CALL MTRANS(AM,AM1)
      N_MAIN = NCS_ID/100
      N_ADD  = MOD(NCS_ID,100)
      IF(N_MAIN.LE.1.OR.N_MAIN.GT.99.OR.N_ADD.EQ.10.OR.N_ADD.GT.32.OR.
     *   (N_ADD.GE.30.AND.
     *    (N_MAIN.NE.2.AND.N_MAIN.NE.4.AND.N_MAIN.NE.5))) THEN
        CALL MSGERR(MDOC,
     *  ' ERROR: "generate NCS": check NCS definition in PDB file')
        IERR = 1
        RETURN
      ENDIF
      
      NMOL  = 1
      DELTA = (2.0*PI)/FLOAT(N_MAIN)
      ANGLE = 0.0

      DO I=2,N_MAIN
        NMOL  = NMOL + 1
        ANGLE = ANGLE + DELTA
        A(1) = 0.0
        A(2) = 0.0

      A(1) = ANGLES_INP(1)*DEGTOR
      A(2) = ANGLES_INP(2)*DEGTOR

        A(3) = ANGLE
        CALL POLTOM(A(1),A(2),A(3),RNCS)
        CALL MATMLT(RNCS,AM1,SM)
        CALL MATMLT(AM,SM,ROT)
        CALL MTOPOL(ROT,THETA,PHI,CHI)
        ANGLES_NCS(1,I) = THETA
        ANGLES_NCS(2,I) = PHI
        ANGLES_NCS(3,I) = CHI
      ENDDO
C -------------
      IF(N_ADD.EQ.20.OR.N_ADD.EQ.22.OR.
     *   NCS_ID.EQ.230.OR.NCS_ID.EQ.432.OR.NCS_ID.EQ.532) THEN
        IF(NCS_ID.EQ.432) THEN
          A(1) = PI/2.0
          A(2) = PI/4.0
          A(3) = PI
        ELSE IF(NCS_ID.EQ.532) THEN
          A(1) = 31.7174*DEGTOR
          A(2) = 36.0*DEGTOR
          A(3) = PI
        ELSE
          A(1) = PI/2.0
          A(2) = 0.0
          A(3) = PI
        ENDIF
        CALL POLTOM(A(1),A(2),A(3),RNCS)
        NM = NMOL
        DO I=1,NM
          NMOL  = NMOL + 1
          A(1) = ANGLES_NCS(1,I)*DEGTOR
          A(2) = ANGLES_NCS(2,I)*DEGTOR
          A(3) = ANGLES_NCS(3,I)*DEGTOR
          CALL POLTOM(A(1),A(2),A(3),RM)
          CALL MTRANS(RM,RM1)
          CALL MATMLT(AM1,RM,SM)
          CALL MATMLT(RNCS,SM,RM)
          CALL MATMLT(AM,RM,ROT)
          CALL MTOPOL(ROT,THETA,PHI,CHI)
          ANGLES_NCS(1,NMOL) = THETA
          ANGLES_NCS(2,NMOL) = PHI
          ANGLES_NCS(3,NMOL) = CHI
        ENDDO
      ENDIF
C -------------
      IF(NCS_ID.EQ.532) THEN
        A(1) = 58.2826*DEGTOR
        A(2) = 0.0
        A(3) = PI
        CALL POLTOM(A(1),A(2),A(3),RNCS)
        NM = NMOL
        DO I=1,NM
          NMOL  = NMOL + 1
          A(1) = ANGLES_NCS(1,I)*DEGTOR
          A(2) = ANGLES_NCS(2,I)*DEGTOR
          A(3) = ANGLES_NCS(3,I)*DEGTOR
          CALL POLTOM(A(1),A(2),A(3),RM)
          CALL MTRANS(RM,RM1)
          CALL MATMLT(AM1,RM,SM)
          CALL MATMLT(RNCS,SM,RM)
          CALL MATMLT(AM,RM,ROT)
          CALL MTOPOL(ROT,THETA,PHI,CHI)
          ANGLES_NCS(1,NMOL) = THETA
          ANGLES_NCS(2,NMOL) = PHI
          ANGLES_NCS(3,NMOL) = CHI
        ENDDO
      ENDIF
C ---
      IF(NCS_ID.EQ.230.OR.NCS_ID.EQ.432.OR.NCS_ID.EQ.532) THEN
        NM = NMOL
        DO IR=1,2
          ANG =((2.0*PI)/3.0)*FLOAT(IR) 
          IF(NCS_ID.EQ.532) THEN
            A(1) = 37.3774*DEGTOR
            A(2) = 144.0*DEGTOR
            A(3) = ANG
          ELSE
            A(1) = 54.733*DEGTOR
            A(2) = PI/4.0
            A(3) = ANG
          ENDIF
          CALL POLTOM(A(1),A(2),A(3),RNCS)
          DO I=1,NM
            NMOL  = NMOL + 1
            A(1) = ANGLES_NCS(1,I)*DEGTOR
            A(2) = ANGLES_NCS(2,I)*DEGTOR
            A(3) = ANGLES_NCS(3,I)*DEGTOR
            CALL POLTOM(A(1),A(2),A(3),RM)
            CALL MTRANS(RM,RM1)
            CALL MATMLT(AM1,RM,SM)
            CALL MATMLT(RNCS,SM,RM)
            CALL MATMLT(AM,RM,ROT)
            CALL MTOPOL(ROT,THETA,PHI,CHI)
            ANGLES_NCS(1,NMOL) = THETA
            ANGLES_NCS(2,NMOL) = PHI
            ANGLES_NCS(3,NMOL) = CHI
          ENDDO
        ENDDO
      ENDIF
C --------------------------------------
      RETURN
      END

      SUBROUTINE DENS_PS(MDOC,NAMER,NAMEO,TITLE,COEF,NLEV
     *         ,R,IR,IRM,INDXY,INDXY44,ISYM,IPRSYM,IERR)
C ---------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM),IR(INDXY),IRM(INDXY44)     
      REAL      R(INDXY)
      CHARACTER NAMER*(*),NAMEO*(*),TITLE*(*)
C --
      COMMON /COM_STEREO/ IZORG,IZO,IZ0,IZDEL,IXCENTR,IYCENTR
     *                ,IBASE,IVIEW,ISIZEP,IZSIZEP2,ISITE,STER
C --
      CHARACTER     STER*1
C -----------------
      CHARACTER TTT*80
      CHARACTER LINE*256
C ====================================================================
      IERR   = 0
      MD     = -ABS(MDOC)-1
      M      = 99
C ------------------------------------------------
C      IF(MODE.LT.0) THEN
C        CALL ENDTX
C        RETURN
C      ENDIF
C ---
      CALL INIT_TX
C ---
      IBOXXI = 650
      IBOXYI = 500
      ISHXI  = 60
      ISHYI  = 10
      CALL SET_BOX_TX(IBOXXI,IBOXYI,ISHXI,ISHYI)
C -------------------------------------------------------------------
C     OPEN AND READ OF TITLE OF FILE-DENS
C
      ITYPE  =  0
      MT1    = 10
C ---
      CALL IRDENS(MT1,NAMER,M,ITYPE,ICNTZ1,NXR,NYR,NZR,NZX
     * ,NZN,RMAX1,RMIN,IR,SCALE,ACELL,BCELL,CCELL,ALPHA,BETA,GAMMA
     * ,DRMS,RAVER,RESOL,NX0,NY0,NZ0,ITR,TTT
     * ,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 999
C ---
      IPICT   = 3       
      IF(COEF.LE.0.0001) COEF = 6.0
      RMAX    = DRMS * COEF
      SCALE_R = 0.25
      IF(NLEV.LE. 0) NLEV = 10
      IF(NLEV.GT.20) NLEV = 20
C ---------------------------------
      NXYR = NXR*NYR
      IF(NXYR.GT.INDXY) THEN
        CALL MSGERR(MDOC,' ERROR: not memory enough ')
        IERR=1
        GO TO 999
      ENDIF
C -- blanc -- 
      NX = NXR-2
      NY = NYR-2
C ---
      NX1 = NX+1
      NX4 = NX/4+2
      NY1 = NY+1
      NY4 = NY/4+2
      NXY4= NX4*NY4
      IF(NXY4.GT.INDXY44) THEN
        CALL MSGERR(MDOC,' ERROR : not memory enough')
        IERR=1
        GO TO 999
      ENDIF
C ---------------------------------------------------------
      NPAGE =  1
      MT2   = 12
C ---
      CALL OPENTX(NAMEO,NPAGE,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: can not open output file')
        RETURN
      ENDIF

      CALL GET_BOX_TX(IBOXX,IBOXY,ISHX_PS,ISHY_PS,IX0_PS,IY0_PS
     *   ,LIM_XMIN,LIM_XMAX,LIM_YMIN,LIM_YMAX)

      CALL SET_BOX_TX(IBOXXI,IBOXYI,ISHXI,ISHYI)
      CALL GET_BOX_TX(IBOXX,IBOXY,ISHX_PS,ISHY_PS,IX0_PS,IY0_PS
     *   ,LIM_XMIN,LIM_XMAX,LIM_YMIN,LIM_YMAX)
C ---
      ITYPE = 1
      IT    = 2
      CALL NEWPEN(IT)
      NSECT = NZX - NZN + 1
      NPROJ = (NSECT-1)/16 + 1
      IF(NPROJ.LE.0) NPROJ = 1
      NPICT = NSECT/NPROJ + 1

      CALL PSTEXT (440.0 ,760.0 ,10.0 , 'MOLREP')
      CALL LENSTR_BL(TITLE,LEN)
      IF(LEN.GT.0) THEN
        CALL PSCTXT (280.0,730.0, 20.0,TITLE(1:LEN))
      ENDIF 
C ---
      LINE='--> Y'
      IDEL  =  0
      ISIZE = 10
      IXL1  = 0
      IYL   = 2
      CALL TXSYMB(LINE,ISIZE,IXL1,IYL,IROT)

      LINE='!'
      IDEL  =  -2
      IXL2=IXL1+IDEL+ISIZE
      CALL TXSYMB(LINE,ISIZE,IXL2,IYL,IROT)

      LINE='V'
      IDEL  =  -2
      IXL3=IXL2+IDEL+ISIZE
      IYL = 0
      CALL TXSYMB(LINE,ISIZE,IXL3,IYL,IROT)

      IDEL=0
      LINE='X'
      IXL4=IXL3+IDEL+ISIZE
      CALL TXSYMB(LINE,ISIZE,IXL4,IYL,IROT)
C -----------------------------------------
      IZ = NZN - 1
      IF(NPICT.GT.16) NPICT = 16 
      DO IP=1,NPICT

        DO I=1,NXYR
          R(I) = 0.0
        ENDDO

C        IZMIN = IZ
C        IZMAX = IZ
        RN = 1.E 30
        RM =-1.E 30
        NP = 0
        DO IPROJ=1,NPROJ
          CALL IRDENS(MT1,NAMER,M,ITYPE,ICNTZ1,NXR,NYR,NZR,NZX
     *     ,NZN,RMAX1,RMIN,IR,RSCAL
     *     ,ACELL,BCELL,CCELL,ALPHA,BETA,GAMMA
     *     ,DRMS,RAVER,RESOL,NX0,NY0,NZ0,ITR,TTT
     *     ,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 998
          
          IZ    = IZ + 1
          IF(IPROJ.EQ.1) IZMIN = IZ
          IZMAX = IZ
          NP    = NP + 1 

          DO I=1,NXYR
            T = IR(I)/RSCAL
            IF(T.LT.0.0) T = 0.0
            IF(T.GT.RM) RM = T
            IF(T.LT.RN) RN = T
            R(I) = R(I) + T
          ENDDO  

          IF(IZMAX.GE.NZX) GO TO 100 
        ENDDO
 100    CONTINUE

        RRMAX = RMAX1  

        IF(ABS(RMAX1).GT.1.E-7) THEN
          SCAL = 32766.0/RMAX1
        ELSE
          SCAL = 1.0
        ENDIF
        DO I=1,NXYR
          PL = (R(I)*SCAL)/FLOAT(NP)
          IF(ABS(PL).GT.32766.) PL=SIGN(32766.,PL)
          IR(I) = PL
        ENDDO

        MODE = IP + 10
        ZMIN = FLOAT(IZMIN)/FLOAT(NZR)
        ZMAX = FLOAT(IZMAX)/FLOAT(NZR)
        
        RRMAX = RMAX*SCAL
 
        CALL PICTURE_DNS(MODE,IPICT,NX,NY,IRM,NX4,NY4,IR,NXR,NYR
     *   ,ZMIN,ZMAX,ACELL,BCELL,GAMMA,RRMAX,RM
     *   ,NLEV,SCALE_R,IERR)
        IF(IERR.NE.0) GO TO 998

        IF(IZMAX.GE.NZX) GO TO 200 

      ENDDO 
 200  CONTINUE
C ----
      CALL ENDTX
      CLOSE(MT1)
      RETURN
C -----------------------------------------------
 998  CONTINUE
      CALL ENDTX
 999  CONTINUE
      CLOSE(MT1)
      IERR = 1
      RETURN
      END

      SUBROUTINE PICTURE_DNS(MODE,IPICT,NX,NY
     * ,IRM,NX4,NY4,IR,NXR,NYR
     * ,ZMIN,ZMAX,A,B,ANG,RMAX,RMAX_SECT,NLEV,SCALE_R,IERR)
C=====================================================================
C     drawing of isolines in array IR(NX,NY)
C---------------------------------------------------------------------
C     IPICT =0 SELF     
C     IPICT =1 CROSS(T,P,C)
C     IPICT =2 CROSS(A,B,G)
C     IPICT =3 TRANS(X,Y,Z)      
C
C
C
C                  <........A........>
C        NYR-1  NY+-------------------+  -
C          +======================+   !  !
C          I      !               I   !  B
C          I    0 !               I   !  !
C     IY0C I......+---------------I---+  -
C          I      . 0             I  NX 
C          I      .               I
C        0 +======================+
C          0     IX0C           NXR-1
C
C                                                         
C     MTOUT - output file (G-P or TEKTRONIX)  
C     IR(NXR,NYR) -  array /INTEGER*2/ data  
C     IRM(NX4,NY4) - array /INTEGER*2/ labels   
C                    NX4=NX/4+2            
C                    NY4=NY/4+2       
C     A     - size along axiz X from 0 to NX  (angstroms)
C     B     - size along axiz Y from 0 to NY  (angstroms)
C     ANG   - angle beetwin X and Y (in rad.)   
C     SCALE - scaling from unit cell to plotter 
C                         (angstroms)   (0.1 mm)
C              frame (approx)  X: (A+B*COS(ANG))*SCALE < 1022
C                              Y: (  B*SIN(ANG))*SCALE <  767
C     NLEV - number of isolines for range ( 0 --> RMAX   )  and
C                                         ( - RMAX --> 0 ) (NEG.EQ.1)
C     JLEV - array label of isoline  (1-draw,0-no)
C     NPEN - number of pen   
C     ISHX,ISHY - shift (IN 0.1 mm) 
C     IFRM - /input/  - draw of frame & title (0-no,1-yes,2-frame only)
C            /output/ - normal >=0; abend -1
C     IAP - not used
C     MSG1 =0 no question for list, =1 yes
C     MSG2 - not used
C     MSG3 = 'N'
C---------------------------------------------------------------------
C             IYCP.......................................
C              ^               Y --------------------/  .
C              !               /  O        OO      /  T .
C              !             /     O O      O    /    I .<--FRAME
C              !           /     O   OO  O   O /      T .
C              !         /            O      /        L .
C              !........+------------------->X        E .
C              ^ISHY    .                               .
C              !    ISHX.                               .
C              +------->-----------------------------------> IXCP
C =====================================================================
C --
      COMMON /COM_STEREO/ IZORG,IZOOO,IZ000,IZDEL,IXCENTR,IYCENTR
     *                ,IBASE,IVIEW,ISIZEP,IZSIZEP2,ISITE,STER
C
C     ISITE - 1= L 2 = R
C     STER    N/P/S
C
      CHARACTER     STER*1
C ----
      INTEGER*2 IR(NXR,NYR)
C ---
C case REAL IRR(INDXY) INTEGER*2 IRM(INDXY4)
C     REAL      IR(NXR,NYR)
C ---
      INTEGER*2 IRM(NX4,NY4)
C     
C ---
      INTEGER   JLEV(20),ICOL(20)
      CHARACTER LINE*256,LEV*20
C                 1 2 3 4 5 6 7 8 9 . 1 2 3 4 5 6 7 8 9 . 
      DATA  ICOL /4,4,4,4,5,5,5,5,6,6,6,6,7,7,7,7,8,8,8,8/
C                 n y n y n y n y n y n y n y n y n y n y
      DATA  LEV /'NYNYNYNYNYNYNYNYNYNY'/
C                 123456789 123456789 
C --------------------------------------------------------------------
      IERR = 0
C -----------------------
      CALL SET_BT
      CALL GET_BOX_TX(IBOXX,IBOXY,ISHX_PS,ISHY_PS,IX0_PS,IY0_PS
     *   ,LIM_XMIN,LIM_XMAX,LIM_YMIN,LIM_YMAX)
C --
      SCALE = 1.0
      ISITE = 0
      STER  = 'N'
C ----
      IF(NLEV.LE.0) NLEV  =20
      DO      I=1,NLEV
        IF(LEV(I:I).EQ.'Y') THEN
          JLEV(I)=1
        ELSE
          JLEV(I)=0
        ENDIF
      ENDDO
C -------------------------
      COSA  = COS(ANG)
      SINA  = SIN(ANG)
      FLENX = A + ABS(B*COSA)
      FLENY = B*SINA
      ORGX  = 0.0
      ORGY  = 0.0
C -------------------------
C --- size of picture ---
C input SCALE_R

      IF(SCALE_R.LT.1.0E-4) SCALE_R = 1.0
      IF(SCALE_R.GT.1.0   ) SCALE_R = 1.0

      TSCALEX = IBOXX   /(FLENX)
      TSCALEY = (IBOXY-5)/(FLENY)
      IF(TSCALEX.GT.TSCALEY) TSCALEX=TSCALEY
      TSCALEX = TSCALEX*0.99
      SCALE   = TSCALEX
      SCALE   = SCALE*SCALE_R

      IBC = B*COSA*SCALE + 0.5  
      IFX = A*SCALE      + 0.5  
      IFY = B*SINA*SCALE + 0.5  
      DX  = IBC
      IF(DX.LT.0) DX = 0.0
C ------------------------
      IM  = MODE - 10
      IMX = (IM-1)/4
      IMY = (IM-1) - IMX*4

      DELX_TITLE = 50.0
      PSHFTX = IMX*(FLENX*SCALE + 40.0) + DX + DELX_TITLE
      PSHFTY = IMY*(FLENY*SCALE + 5.0)
C --
      ISHX = ORGX * SCALE + 0.5 + PSHFTX
      ISHY = ORGY * SCALE + 0.5 + PSHFTY
C -------------------------
      IX0 = ISHX
      IY0 = ISHY
      IZ0 = 0
      CALL ORITXZ(IX0,IY0,IZ0)

C ---
      ICL = 5
      CALL NEWPEN(ICL)
      IT  = 0                        
      IT1 = 0                        
      CALL MOVTXXZ(IT,IT1,IZ0)           
      IT  = IBC                     
      IT1 = IFY                        
      CALL VECTXXZ(IT,IT1,IZ0)           
      IT  = IT + IFX                        
      CALL VECTXXZ(IT,IT1,IZ0)           
      IT  = IFX                     
      IT1 = 0                      
      CALL VECTXXZ(IT,IT1,IZ0)           
      IT  = 0                     
      IT1 = 0                        
      CALL VECTXXZ(IT,IT1,IZ0)
C -------------
      ICL = 1
      CALL NEWPEN(ICL)
C ---
      IROT  = 0
      WRITE(LINE,'('' z:'',F6.3,'' - '',F6.3)') ZMIN,ZMAX
      ISIZEX = 8
      IX     = -DX - 17
      IY     = 0
      CALL LENSTR_BL(LINE,LEN)
      CALL TXSYMB(LINE(1:LEN),ISIZEX,IX,IY,IROT)
      WRITE(LINE,'('' rmax:'',G12.4)') RMAX_SECT
      ISIZEX = 8
      IX     = -DX - 9
      IY     = 0
      CALL LENSTR_BL(LINE,LEN)
      CALL TXSYMB(LINE(1:LEN),ISIZEX,IX,IY,IROT)
C --------------------------------------------------
      IT =0
      IT1=0
      IZ =0
      CALL MOVTXXZ(IT,IT1,IZ)
      DO      I=1,NLEV
        IF(JLEV(I).EQ.0) GO TO 700
        IT = ICOL(I)
        CALL NEWPEN(IT)
        FLV = (RMAX/FLOAT(NLEV+1))*FLOAT(I)
        IZ  = 0
        NX0 = 0
        NY0 = 0
        IX0C= 0
        IY0C= 0

        CALL ISOL(MTOUT,NX,NY,NX4,NY4,A,B,ANG,SCALE,FLV,IR,IRM,IPICT,
     *  IX0C,IY0C,NX0,NY0,NXR,NYR,IZ)

        IT  = 0
        IT1 = 0
        IZ0 = 0
        CALL MOVTXXZ(IT,IT1,IZ0)
700     CONTINUE

      ENDDO

      RETURN
      END

      SUBROUTINE REMOVE_NCS_PEAKS_FROM_RF(MDOC
     * ,NAMEM,NCS,ANGLES_NCS,CVECTOR_NCS,DELTA_ANG,IPRDOM
     * ,NPROT,TALPHA,TGAMMA,TBETA,ISYM,IPRSYM,IERR)
C -------------------------------------------------------------
      CHARACTER NAMEM*(*)
      REAL      TALPHA(*),TGAMMA(*),TBETA(*)
      REAL      ANGLES_NCS(3),CVECTOR_NCS(3)
      REAL      ANGLES_NCS_MON(3,IPRDOM)

      REAL      AM2(3,3),AM2I(3,3),SM(3,3),AM1(3,3),AM3(3,3)
      REAL      S(3),AM(3,3)
      CHARACTER LINE*256,NAME*256
C -------------------------------------------------------------
      MD     =-ABS(MDOC)-1
      M      = 99
      IERR   = 0
      PI = 4.0*ATAN(1.0)
C ---
      NAME = ' '
      CALL COPY_CRD_NCS(M,NAMEM,NAME,NCS
     *   ,NM_TOTAL,NA_TOTAL
     *   ,ANGLES_NCS,ANGLES_NCS_MON,CVECTOR_NCS
     *   ,IPRDOM,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900

      NP = 1

      DO IP=2,NPROT

C       X * R2 --> R1*S :   X =  R1 * S *  R2'

        A2  = (TALPHA(IP)*PI)/180.0
        B2  = (TBETA (IP)*PI)/180.0
        G2  = (TGAMMA(IP)*PI)/180.0
        CALL EULERM(A2,B2,G2,AM2)
        CALL INVERT(AM2,AM2I,IERR)

        DO IP1=1,NP

          A1  = (TALPHA(IP1)*PI)/180.0
          B1  = (TBETA (IP1)*PI)/180.0
          G1  = (TGAMMA(IP1)*PI)/180.0
          CALL EULERM(A1,B1,G1,AM1)

          DO IS=1,NM_TOTAL

            S(1) = (ANGLES_NCS_MON(1,IS)*PI)/180.0
            S(2) = (ANGLES_NCS_MON(2,IS)*PI)/180.0
            S(3) = (ANGLES_NCS_MON(3,IS)*PI)/180.0
            CALL POLTOM(S(1),S(2),S(3),SM)

            CALL MATMLT(SM,AM1,AM)
            CALL MATMLT(AM2I,AM,AM3)
            CALL MTOPOL(AM3,THETA,PHI,CHI)

            IF(ABS(CHI).LE.DELTA_ANG) GO TO 100

          ENDDO

        ENDDO
     
        NP = NP + 1
        TALPHA(NP) = TALPHA(IP)
        TBETA (NP) = TBETA (IP)
        TGAMMA(NP) = TGAMMA(IP)

 100    CONTINUE

      ENDDO

      CALL MSGDOC(MDOC,' ')    
      CALL MSGDOC(MDOC,
     * ' --- New list of peaks of Rotation Function ---')
      LINE =
     * 'S'//'ol_         theta    phi    chi '//
     * '    alpha   beta  gamma'
      CALL LENSTR_BL(LINE,LEN)
      CALL MSGDOC(MDOC,LINE(1:LEN))    

      DO I=1,NP
        A2  = (TALPHA(I)*PI)/180.0
        B2  = (TBETA (I)*PI)/180.0
        G2  = (TGAMMA(I)*PI)/180.0
        CALL EULERM(A2,B2,G2,AM2)
        CALL MTOPOL(AM2,THETA,PHI,CHI)

        WRITE(LINE,310) I
     *      ,THETA,PHI,CHI
     *      ,TALPHA(I),TBETA(I),TGAMMA(I)
  310   FORMAT('Sol_RF',I3,1X,6F8.2)
        CALL LENSTR_BL(LINE,LEN)
        CALL MSGDOC(MDOC,LINE(1:LEN))    

      ENDDO
      CALL MSGDOC(MDOC,' ')    
      NPROT = NP
C ---------
 900  CONTINUE
      RETURN
      END

      SUBROUTINE BALBES_ALIGN(MDOC,FILE_1,FILE_2,FILE_OUT
     *    ,PATH_SCR,PATH_OUT
     *    ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C------------         
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT (IPRROW)
      INTEGER   MDOC,IERR
      CHARACTER FILE_1*(*),FILE_2*(*),FILE_OUT*(*)
      CHARACTER FILE_S*256,FILE_O*256
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
      CHARACTER LINE*256
C --------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
c ---
      FILE_S = FILE_2
      CALL LENSTR_BL(FILE_S,LEN)
      LLL = LEN
      IF(LLL.LT.4) LLL=4
      IF(LEN.GT.4.AND.FILE_S(LLL-3:LLL).EQ.'.crd') THEN
        FILE_O = 'align_input_2.pdb'
        CALL ADD_PATH(PATH_SCR,FILE_O)
        IERR = 0
        CALL WRITEPDB(M,FILE_S,FILE_O,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: ALIGN: crd --> pdb')
          RETURN
        ENDIF
        FILE_S = FILE_O
      ENDIF
      CALL LENSTR_BL(FILE_OUT,LEN)
      IF(LEN.LE.0) THEN
        FILE_OUT = 'align.pdb' 
        CALL ADD_PATH(PATH_OUT,FILE_OUT)
      ENDIF
      IPRINT = 1
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,'  --- Alignment -- ')
      CALL MSGDOC(MDOC,' ')
      CALL MAKE_ALIGN(MDOC,IPRINT,FILE_1,FILE_S,FILE_OUT
     *                ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)    
C ---
      RETURN
      END

      SUBROUTINE MAKE_ALIGN(MDOC,IPRINT,FILE_1,FILE_2,FILE_OUT
     *                      ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
C -----------------------------------
C IERR =  0 CORR = N output file(pdb) 
c                    (FILE_OUT) aligned file_2 (not rotated)
C IERR = -1 CORR = 2 output fileS(pdb) (FILE_OUT name +_1, +_2)
c                    --> aligned FILE_OUT_1, FILE_OUT_2 (rotated)
C IERR = -2 CORR = Y output file(pdb)  
c                    (FILE_OUT) rotated full file_2 (without alignment)
C -----------------------------------
      INTEGER   MDOC,IERR
C     PARAMETER ( IPRROW = 51 )
      REAL      RESULT(IPRROW)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
      CHARACTER FILE_1*(*),FILE_2*(*),FILE_OUT*(*)
C --
c     for alignment
      CHARACTER CHAIN*1,DIST*1,CORR*1
      CHARACTER PAR_ALIGN*16 
C -----------------------------------
      CORR = 'N'
      IF(IERR.EQ.-1) CORR = '2'
      IF(IERR.EQ.-2) CORR = 'Y'
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---
c          mode
c          PAR_ALIGN(1:1) = ' '
c ---
C       2: IERR =  0 CORR = N output file(pdb) 
c                    (FILE_OUT) aligned file_2 (not rotated)
C          IERR = -2 CORR --> Y output file(pdb) (FILE_OUT) rotated full file_2 (without alignment)
c          PAR_ALIGN(2:2) = 'Y'
C          IERR = -1 ,CORR --> 2 output fileS(pdb) (FILE_OUT name +_1, +_2)--> FILE_OUT_1, FILE_OUT_2
c          PAR_ALIGN(2:2) = '2'

c molrep   IF(SEQ.EQ.'N') PAR_ALIGN(2:2) = 'N'
c molrep   IF(FOBS.EQ.'N'.AND.MOD2.EQ.'N') PAR_ALIGN(2:2) = 'Y'
c ---
cC       3: D3_FLAG (n,c,y) --> ALIGN_with SURF
c          PAR_ALIGN(3:3) = 'N'
c molrep  IF(SURF.EQ.'Y'.OR.SURF.EQ.'C') PAR_ALIGN(3:3) = SURF
c ---
cC       4: SS_FLAG  use SS
c          PAR_ALIGN(4:4) = 'Y'
c ---
cc       5: remove surf from output
c          PAR_ALIGN(5:5) = 'N'
c ---
cc       6: OCC_FLAG
c          PAR_ALIGN(6:6) = 'N'
      PAR_ALIGN(1:1) = 'G' 
      PAR_ALIGN(1:1) = 'B'
      PAR_ALIGN(2:2) = 'N' 
      IF(CORR.EQ.'2') PAR_ALIGN(2:2) = CORR
      PAR_ALIGN(3:3) = 'Y' 
      PAR_ALIGN(4:4) = 'Y' 
      PAR_ALIGN(5:5) = 'Y' 
      PAR_ALIGN(6:6) = 'N' 
      DIST = 'N'
      IF(DIST.EQ.'d') DIST = 'D'
      IF(DIST.NE.'D') DIST = 'N'
      IF(DIST.EQ.'D') THEN
        PAR_ALIGN(4:4) = 'N' 
      ENDIF
      PAR_ALIGN(7:7) = DIST  
      OPENR   = 0.462
      DPENR   = 0.350
      PENEXR  = 0.077

      IF(PAR_ALIGN(1:1).EQ.'G') THEN 
c       'G'
        DPENR   = 0.346
      ELSE
c       'B'
        DPENR   = 0.312
      ENDIF

      OPENR   = 0.462
      PENEXR  = 0.077
      OPENR   = 0.750
      PENEXR  = 0.125

      MODEL   = 1
      CHAIN   = ' '
      CALL ALIGN_3(MDOC,FILE_1,FILE_2,FILE_OUT,PATH_SCR
     *      ,OPENR,DPENR,PENEXR,PAR_ALIGN,MODEL,CHAIN,IPRINT
     *      ,RESULT,IPRROW,IERR)
C     RESULT(1) = NC   Naa_1
C     RESULT(2) = KC   Naa_2
C     RESULT(3) = NN   Naa aligned
C     RESULT(4) = NHOM Naa identical
C     RESULT(5) = HOM  identity
C     RESULT(6) = SUM  score
C     RESULT(7) = NAT  Natom output
C     RESULT(8) = NRES Nres output
C     RESULT(9) = NAT  Natom1 output
C     RESULT(10)= NRES Nres1 output
C     RESULT(11)= NAT  Natom2 output
C     RESULT(12)= NRES Nres2 output
C     RESULT(13) = SCORE1_MAX 
C     RESULT(14) = SCORE_MIN 
C     RESULT(15) = Q_FIN
C     RESULT(16) = DRMS_BEST 
C     RESULT(17) = NPAIR_BEST 
C     RESULT(18) = SCORE_NEW
C     RESULT(19) = FIDENT_NEW
C     RESULT(20) = NGAP
c      IF(IPRROW.GE.41) THEN
C        RESULT(21) = CHI_INI
C        RESULT(22) = DIST_INI
C        RESULT(23) = DRMS_INI
C        RESULT(24) = CHI_BEST
C        RESULT(25) = DIST_BEST
c        RESULT(30) = TR(1)
c        RESULT(31) = TR(2)
c        RESULT(32) = TR(3)
c        RESULT(33) = TRMAT(1,1)
c        RESULT(34) = TRMAT(1,2)
c        RESULT(35) = TRMAT(1,3)
c        RESULT(36) = TRMAT(2,1)
c        RESULT(37) = TRMAT(2,2)
c        RESULT(38) = TRMAT(2,3)
c        RESULT(39) = TRMAT(3,1)
c        RESULT(40) = TRMAT(3,2)
c        RESULT(41) = TRMAT(3,3)
c      ENDIF
      RETURN
      END

      SUBROUTINE ALIGN_3(MDOC,FILE_11,FILE_22,FILE_OUT,PATH_SCR
     * ,OPENR,DPENR,PENEXR,PAR_ALIGN,MODEL,CHAIN,IPRINT
     * ,RESULT,IPRROW,IERR)
C ------------------------------------------------------------
C -P- 
C ALIGN   alignes optimally 2 aminoacid sequences. 
C -S-
C         File with sequence is ASCII file:
C
C        !>prot_id
C        !# sequence 
C        !SVIGSDDRTRVTNTTAYPYRAIVHISSSIGSCTGWMIGPKTVATAGHCIY
C        !# this is comment
C        !    DTSSG--SFAGTATVSP   GRNGTSYPYG
C        !NRGTRITKEVFDNLTNWKNSAQ
C
C         If first symbol in the line is "#" it means the line is comments
C         Blancs are ignored.
C         
C      
C      Dialogue and Batch:
C
C   FILE_1:           - Input coordinate file-1 (sequence)
C   FILE_2:           - Input coordinate file-2 (sequence)
C   MODE: <G>,1,H,S,K - matrix of comparison which will be used
C                   G - gomology
C                   1 - unit
C                   H - hydrophobic
C                   S - structure
C                   K - kodon
C   PEN:     <0>      - gap-penalty factor. From 0 to 1
C
C      Parameters of subroutine:
C
C      MDOC  - mode of writing messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C
C      IERR   - signal of error / =1 -error , =o - OK / 
C      RESULT /real RESULT(21)/ - array for output information:
C     RESULT(1) = NC   Naa_1
C     RESULT(2) = KC   Naa_2
C     RESULT(3) = NN   Naa aligned
C     RESULT(4) = NHOM Naa identical
C     RESULT(5) = HOM  identity
C     RESULT(6) = SUM  score
C     RESULT(7) = NAT  Natom output
C     RESULT(8) = NRES Nres output
C     RESULT(9) = NAT  Natom1 output
C     RESULT(10)= NRES Nres1 output
C     RESULT(11)= NAT  Natom2 output
C     RESULT(12)= NRES Nres2 output
C     RESULT(13) = SCORE1_MAX 
C     RESULT(14) = SCORE_MIN 
C     RESULT(15) = Q_FIN
C     RESULT(16) = DRMS_BEST 
C     RESULT(17) = NPAIR_BEST 
C     RESULT(18) = SCORE_NEW
C     RESULT(19) = FIDENT_NEW
C     RESULT(20) = NGAP
C -I-
C ---------------------------------------------------------------
      REAL      RESULT (IPRROW)
      REAL      RESULT2(51)    
      INTEGER   MDOC,IERR
      CHARACTER PAR_ALIGN*16,CHAIN*1
      REAL      OPENR,DPENR,PENEXR
      CHARACTER PATH_SCR*(*)
      CHARACTER FILE_11*(*),FILE_22*(*),FILE_OUT*(*)
C ---
C      REAL      COORD1(NMAX1,3)
C      REAL      COORD2(NMAX1,3)
C      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX1),ISS1(NMAX1),ISS2(NMAX1)
C      INTEGER   ICHAIN1(NMAX1),ICHAIN2(NMAX1)
C      INTEGER   IRES1(NMAX1),IRES2(NMAX1)


      real,      allocatable :: COORD1(:,:)
      integer,   allocatable :: NSEQ1(:)
      integer,   allocatable :: IRES1(:)
      integer,   allocatable :: SURF1(:)
      integer,   allocatable :: ICHAIN1(:)
      integer,   allocatable :: IDOMAIN1(:)
      integer,   allocatable :: SS1(:)
      integer,   allocatable :: ISS1(:)
      character(LEN=6), allocatable :: PNUM1(:)

      real,      allocatable :: COORD2(:,:)
      integer,   allocatable :: NSEQ2(:)
      integer,   allocatable :: IRES2(:)
      integer,   allocatable :: SURF2(:)
      integer,   allocatable :: ICHAIN2(:)
      integer,   allocatable :: IDOMAIN2(:)
      integer,   allocatable :: SS2(:)
      integer,   allocatable :: ISS2(:)
      character(LEN=6), allocatable :: PNUM2(:)

C      REAL      AMATRIX(NMAX1,NMAX2)
c      REAL      SCORE(NMAX12,3)
c      INTEGER   IPAIR(2,NMAX12)

      real,      allocatable :: AMATRIX(:,:)
      real,      allocatable :: SCORE(:,:)
      integer,   allocatable :: IPAIR(:,:)

C ---
      CHARACTER MODE*1,CORR*1
      CHARACTER SS_FLAG*1,D3_FLAG*1,WS_FLAG*1,OCC_FLAG*1,DIST*1
      CHARACTER FILE_OUT1*256,FILE_OUT2*256
      CHARACTER FILE_1*256,FILE_2*256
C -----
      CHARACTER ATOM_NAME(9)*2
      INTEGER   ATOM_INDEX(4,25)
C -----
C ---------------------------------------
      CHARACTER NAM1*4,NAM2*4,CODE8*8
      CHARACTER PATH*1,EXT*1
C ----
      REAL AMAT(25,25)
C ----
      CHARACTER LINE*256
C --------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --
      DO I=1,IPRROW
        RESULT(I) = 0.0
      ENDDO
      MODE    = PAR_ALIGN(1:1) 
      CORR    = PAR_ALIGN(2:2) 
      D3_FLAG = PAR_ALIGN(3:3)
      SS_FLAG = PAR_ALIGN(4:4)
      WS_FLAG = PAR_ALIGN(5:5)
C     if y remove surf
c ---
      OCC_FLAG = PAR_ALIGN(6:6)
      DIST     = PAR_ALIGN(7:7)
      IF(DIST.EQ.'D') THEN
        SS_FLAG = 'N'
        D3_FLAG = 'N'
      ENDIF

      WRITE(LINE,'(''Flag D3,SS,OCC,CORR,DIST:'',A,A,A,A,A)') 
     * D3_FLAG,SS_FLAG,OCC_FLAG,CORR,DIST
      CALL MSGDOC(MDOC,LINE)

      FILE_1 = FILE_11
      CALL CORR_NAME_ALL(FILE_1)
      CALL LENSTR_BL(FILE_1,LEN1)

      FILE_2 = FILE_22
      CALL CORR_NAME_ALL(FILE_2)
      CALL LENSTR_BL(FILE_2,LEN2)

      NO_COORD=0
      IF(LEN1.GT.4.AND.(FILE_1(LEN1-3:LEN1).EQ.'.seq'.OR.
     *                  FILE_1(LEN1-3:LEN1).EQ.'.sqb')   ) NO_COORD=1 
      IF(LEN2.GT.4.AND.(FILE_2(LEN2-3:LEN2).EQ.'.seq'.OR.
     *                  FILE_2(LEN2-3:LEN2).EQ.'.sqb')   ) NO_COORD=1 
C ---------------------------------------------------------------
      CALL MSGDOC(MDoc,'read file protein-1')

      IPDB1 = 0

      CALL LENSTR_BL(FILE_1,LEN)
      IF(LEN.GT.4.AND.FILE_1(LEN-3:LEN).EQ.'.pdb') THEN

        IF(D3_FLAG.EQ.'Y') THEN
          FILE_1 = 'align_1_scr.pdb'
          CALL LENSTR_BL(PATH_SCR,LEN)
          IF(LEN.GT.0) THEN
            FILE_1 = PATH_SCR(1:LEN)//'align_1_scr.pdb' 
          ENDIF
          CALL SURFACE_DB_ALLOC(M,FILE_11,FILE_1
     *       ,RESULT,IPRROW,IERR)   
          NATOM    =  RESULT(1)
          IF(IERR.NE.0.OR.NATOM.LE.0) THEN
            CALL MSGERR(MDOC,'ERROR: in SURFACE PDB-1')
            GO TO 900
          ENDIF
          NATOM_IN =  RESULT(8)
          NRES     =  RESULT(9)
          WRITE(LINE,'('' Number of atoms, N_inside,Nres :'',3I6)') 
     *      NATOM,NATOM_IN,NRES
          CALL MSGDOC(MDOC,LINE)
          FINSIDE = FLOAT(NATOM_IN)/FLOAT(NATOM)
          IF(FINSIDE.LT.0.10) THEN
            FILE_1 = FILE_11  
            D3_FLAG = 'N'
          ENDIF
        ENDIF

        ITEST = 1
        NMAX1 = 100

        allocate(COORD1(1:NMAX1,1:3),STAT=ISTAT)
        allocate(NSEQ1(1:NMAX1),STAT=ISTAT)
        allocate(IRES1(1:NMAX1),STAT=ISTAT)
        allocate(SURF1(1:NMAX1),STAT=ISTAT)
        allocate(ICHAIN1(1:NMAX1),STAT=ISTAT)
        allocate(IDOMAIN1(1:NMAX1),STAT=ISTAT)
        allocate(SS1(1:NMAX1),STAT=ISTAT)
        allocate(ISS1(1:NMAX1),STAT=ISTAT)
        allocate(PNUM1(1:NMAX1),STAT=ISTAT)

        CALL READ_PDB_SEQ_AND_COORD_CA(M,FILE_1
     *      ,NSEQ1,IRES1,PNUM1,COORD1,SURF1,ICHAIN1,IDOMAIN1
     *      ,NMAX1,NC,NAM1,NCHAIN1,ITEST,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_PDB_SEQ-1')
          GO TO 800
        ENDIF
        IF(NC.LE.0) THEN
          CALL MSGERR(MDOC,'ERROR: Naa in SEQ-1 = 0')
          IERR = 1
          GO TO 800
        ENDIF

        deallocate(COORD1,STAT=ISTAT)
        deallocate(NSEQ1,STAT=ISTAT)
        deallocate(IRES1,STAT=ISTAT)
        deallocate(SURF1,STAT=ISTAT)
        deallocate(ICHAIN1,STAT=ISTAT)
        deallocate(IDOMAIN1,STAT=ISTAT)
        deallocate(SS1,STAT=ISTAT)
        deallocate(ISS1,STAT=ISTAT)
        deallocate(PNUM1,STAT=ISTAT)

        NMAX1 = NC
        ITEST = 0

        allocate(COORD1(1:NMAX1,1:3),STAT=ISTAT)
        allocate(NSEQ1(1:NMAX1),STAT=ISTAT)
        allocate(IRES1(1:NMAX1),STAT=ISTAT)
        allocate(SURF1(1:NMAX1),STAT=ISTAT)
        allocate(ICHAIN1(1:NMAX1),STAT=ISTAT)
        allocate(IDOMAIN1(1:NMAX1),STAT=ISTAT)
        allocate(SS1(1:NMAX1),STAT=ISTAT)
        allocate(ISS1(1:NMAX1),STAT=ISTAT)
        allocate(PNUM1(1:NMAX1),STAT=ISTAT)

        CALL READ_PDB_SEQ_AND_COORD_CA(M,FILE_1
     *      ,NSEQ1,IRES1,PNUM1,COORD1,SURF1,ICHAIN1,IDOMAIN1
     *      ,NMAX1,NC,NAM1,NCHAIN1,ITEST,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_PDB_SEQ-1')
          GO TO 800
        ENDIF
        IF(NC.LE.0) THEN
          CALL MSGERR(MDOC,'ERROR: Naa in SEQ-1 = 0')
          IERR = 1
          GO TO 800
        ENDIF

        IPDB1 = 1
        IF(SS_FLAG.EQ.'Y') THEN    
          CALL ALIGN_SS_DEFINITION_ALLOC(M,NC
     *     ,COORD1(1,1),COORD1(1,2),COORD1(1,3),SS1,SURF1
     *     ,PSS,PH,PB,NMAX1,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,'ERROR:  ALIGN_SS_DEFINITION-1(pdb)')
            GO TO 800
          ENDIF
          WRITE(LINE,'(''Percent SS,H,B :'',3F6.1)') PSS,PH,PB
          CALL MSGDOC(MDOC,LINE)
        ENDIF

      ELSE

        ITEST = 1
        NMAX1 = 100

        allocate(COORD1(1:NMAX1,1:3),STAT=ISTAT)
        allocate(NSEQ1(1:NMAX1),STAT=ISTAT)
        allocate(IRES1(1:NMAX1),STAT=ISTAT)
        allocate(SURF1(1:NMAX1),STAT=ISTAT)
        allocate(ICHAIN1(1:NMAX1),STAT=ISTAT)
        allocate(IDOMAIN1(1:NMAX1),STAT=ISTAT)
        allocate(SS1(1:NMAX1),STAT=ISTAT)
        allocate(ISS1(1:NMAX1),STAT=ISTAT)
        allocate(PNUM1(1:NMAX1),STAT=ISTAT)

        CALL READ_FASTA_SEQ_NEW(M,NAM1,FILE_1
     *       ,ITEST,NC,NMAX1,NCHAIN1,PNUM1
     *       ,NSEQ1,IRES1,SS1,ISS1,SURF1,ICHAIN1,IDOMAIN1,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_FASTA_SEQ-1 test')
          GO TO 800
        ENDIF
        IF(NC.LE.0) THEN
          IERR = 1
          CALL MSGERR(MDOC,'ERROR: Naa in SEQ-1 = 0.')
          GO TO 800
        ENDIF

        deallocate(COORD1,STAT=ISTAT)
        deallocate(NSEQ1,STAT=ISTAT)
        deallocate(IRES1,STAT=ISTAT)
        deallocate(SURF1,STAT=ISTAT)
        deallocate(ICHAIN1,STAT=ISTAT)
        deallocate(IDOMAIN1,STAT=ISTAT)
        deallocate(SS1,STAT=ISTAT)
        deallocate(ISS1,STAT=ISTAT)
        deallocate(PNUM1,STAT=ISTAT)

        NMAX1 = NC

        allocate(COORD1(1:NMAX1,1:3),STAT=ISTAT)
        allocate(NSEQ1(1:NMAX1),STAT=ISTAT)
        allocate(IRES1(1:NMAX1),STAT=ISTAT)
        allocate(SURF1(1:NMAX1),STAT=ISTAT)
        allocate(ICHAIN1(1:NMAX1),STAT=ISTAT)
        allocate(IDOMAIN1(1:NMAX1),STAT=ISTAT)
        allocate(SS1(1:NMAX1),STAT=ISTAT)
        allocate(ISS1(1:NMAX1),STAT=ISTAT)
        allocate(PNUM1(1:NMAX1),STAT=ISTAT)

        ITEST = 0
        CALL READ_FASTA_SEQ_NEW(M,NAM1,FILE_1
     *       ,ITEST,NC,NMAX1,NCHAIN1,PNUM1
     *       ,NSEQ1,IRES1,SS1,ISS1,SURF1,ICHAIN1,IDOMAIN1,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_FASTA_SEQ-1')
          GO TO 800
        ENDIF

      ENDIF
      
      CALL MSGDOC(MDoc,'read file protein-2')

      IPDB2 = 0

      CALL LENSTR_BL(FILE_2,LEN)
      IF(LEN.GT.4.AND.FILE_2(LEN-3:LEN).EQ.'.pdb') THEN

        IF(D3_FLAG.EQ.'Y') THEN
          FILE_2 = 'align_2_scr.pdb'
          CALL LENSTR_BL(PATH_SCR,LEN)
          IF(LEN.GT.0) THEN
            FILE_2 = PATH_SCR(1:LEN)//'align_2_scr.pdb' 
          ENDIF
          CALL SURFACE_DB_ALLOC(M,FILE_22,FILE_2
     *       ,RESULT,IPRROW,IERR)   
          NATOM    =  RESULT(1)
          IF(IERR.NE.0.OR.NATOM.LE.0) THEN
            CALL MSGERR(MDOC,'ERROR: in SURFACE PDB-2')
            GO TO 800
          ENDIF
          NATOM_IN =  RESULT(8)
          NRES     =  RESULT(9)
          WRITE(LINE,'('' Number of atoms, N_inside,Nres :'',3I6)') 
     *      NATOM,NATOM_IN,NRES
          CALL MSGDOC(MDOC,LINE)
          FINSIDE = FLOAT(NATOM_IN)/FLOAT(NATOM)
          IF(FINSIDE.LT.0.10) THEN
            FILE_2 = FILE_22  
            D3_FLAG = 'N'
          ENDIF
        ENDIF

        ITEST = 1
        NMAX2 = 100

        allocate(COORD2(1:NMAX2,1:3),STAT=ISTAT)
        allocate(NSEQ2(1:NMAX2),STAT=ISTAT)
        allocate(IRES2(1:NMAX2),STAT=ISTAT)
        allocate(SURF2(1:NMAX2),STAT=ISTAT)
        allocate(ICHAIN2(1:NMAX2),STAT=ISTAT)
        allocate(IDOMAIN2(1:NMAX2),STAT=ISTAT)
        allocate(SS2(1:NMAX2),STAT=ISTAT)
        allocate(ISS2(1:NMAX2),STAT=ISTAT)
        allocate(PNUM2(1:NMAX2),STAT=ISTAT)

        CALL READ_PDB_SEQ_AND_COORD_CA(M,FILE_2
     *      ,NSEQ2,IRES2,PNUM2,COORD2,SURF2,ICHAIN2,IDOMAIN2
     *      ,NMAX2,KC,NAM2,NCHAIN2,ITEST,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_PDB_SEQ-2')
          GO TO 700
        ENDIF
        IF(KC.LE.0) THEN
          CALL MSGERR(MDOC,'ERROR: Naa in SEQ-2 = 0')
          IERR = 1
          GO TO 700
        ENDIF

        deallocate(COORD2,STAT=ISTAT)
        deallocate(NSEQ2,STAT=ISTAT)
        deallocate(IRES2,STAT=ISTAT)
        deallocate(SURF2,STAT=ISTAT)
        deallocate(ICHAIN2,STAT=ISTAT)
        deallocate(IDOMAIN2,STAT=ISTAT)
        deallocate(SS2,STAT=ISTAT)
        deallocate(ISS2,STAT=ISTAT)
        deallocate(PNUM2,STAT=ISTAT)

        NMAX2 = KC
        ITEST = 0

        allocate(COORD2(1:NMAX2,1:3),STAT=ISTAT)
        allocate(NSEQ2(1:NMAX2),STAT=ISTAT)
        allocate(IRES2(1:NMAX2),STAT=ISTAT)
        allocate(SURF2(1:NMAX2),STAT=ISTAT)
        allocate(ICHAIN2(1:NMAX2),STAT=ISTAT)
        allocate(IDOMAIN2(1:NMAX2),STAT=ISTAT)
        allocate(SS2(1:NMAX2),STAT=ISTAT)
        allocate(ISS2(1:NMAX2),STAT=ISTAT)
        allocate(PNUM2(1:NMAX2),STAT=ISTAT)

        CALL READ_PDB_SEQ_AND_COORD_CA(M,FILE_2
     *      ,NSEQ2,IRES2,PNUM2,COORD2,SURF2,ICHAIN2,IDOMAIN2
     *      ,NMAX2,KC,NAM2,NCHAIN2,ITEST,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_PDB_SEQ-2')
          GO TO 700
        ENDIF
        IF(KC.LE.0) THEN
          CALL MSGERR(MDOC,'ERROR: Naa in SEQ-2 = 0')
          IERR = 1
          GO TO 700
        ENDIF

        IPDB2 = 1
        IF(SS_FLAG.EQ.'Y') THEN    
          CALL ALIGN_SS_DEFINITION_ALLOC(M,KC
     *     ,COORD2(1,1),COORD2(1,2),COORD2(1,3),SS2,SURF2
     *     ,PSS,PH,PB,NMAX2,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,'ERROR:  ALIGN_SS_DEFINITION-2(pdb)')
            GO TO 700
          ENDIF
          WRITE(LINE,'(''Percent SS,H,B :'',3F6.1)') PSS,PH,PB
          CALL MSGDOC(MDOC,LINE)
        ENDIF

      ELSE

        ITEST = 1
        NMAX2 = 100

        allocate(COORD2(1:NMAX2,1:3),STAT=ISTAT)
        allocate(NSEQ2(1:NMAX2),STAT=ISTAT)
        allocate(IRES2(1:NMAX2),STAT=ISTAT)
        allocate(SURF2(1:NMAX2),STAT=ISTAT)
        allocate(ICHAIN2(1:NMAX2),STAT=ISTAT)
        allocate(IDOMAIN2(1:NMAX2),STAT=ISTAT)
        allocate(SS2(1:NMAX2),STAT=ISTAT)
        allocate(ISS2(1:NMAX2),STAT=ISTAT)
        allocate(PNUM2(1:NMAX2),STAT=ISTAT)

        CALL READ_FASTA_SEQ_NEW(M,NAM2,FILE_2
     *       ,ITEST,KC,NMAX2,NCHAIN2,PNUM2
     *       ,NSEQ2,IRES2,SS2,ISS2,SURF2,ICHAIN2,IDOMAIN2,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_FASTA_SEQ-2_test')
          GO TO 700
        ENDIF
        IF(KC.LE.0) THEN
          IERR = 1
          CALL MSGERR(MDOC,'ERROR: Naa in SEQ-2 = 0.')
          GO TO 700
        ENDIF

        deallocate(COORD2,STAT=ISTAT)
        deallocate(NSEQ2,STAT=ISTAT)
        deallocate(IRES2,STAT=ISTAT)
        deallocate(SURF2,STAT=ISTAT)
        deallocate(ICHAIN2,STAT=ISTAT)
        deallocate(IDOMAIN2,STAT=ISTAT)
        deallocate(SS2,STAT=ISTAT)
        deallocate(ISS2,STAT=ISTAT)
        deallocate(PNUM2,STAT=ISTAT)

        NMAX2 = KC

        allocate(COORD2(1:NMAX2,1:3),STAT=ISTAT)
        allocate(NSEQ2(1:NMAX2),STAT=ISTAT)
        allocate(IRES2(1:NMAX2),STAT=ISTAT)
        allocate(SURF2(1:NMAX2),STAT=ISTAT)
        allocate(ICHAIN2(1:NMAX2),STAT=ISTAT)
        allocate(IDOMAIN2(1:NMAX2),STAT=ISTAT)
        allocate(SS2(1:NMAX2),STAT=ISTAT)
        allocate(ISS2(1:NMAX2),STAT=ISTAT)
        allocate(PNUM2(1:NMAX2),STAT=ISTAT)

        ITEST = 0
        CALL READ_FASTA_SEQ_NEW(M,NAM2,FILE_2
     *       ,ITEST,KC,NMAX2,NCHAIN2,PNUM2
     *       ,NSEQ2,IRES2,SS2,ISS2,SURF2,ICHAIN2,IDOMAIN2,IERR)
        IF(IERR.NE.0.OR.KC.LE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_FASTA_SEQ-2')
          GO TO 700
        ENDIF

      ENDIF
C -----------------------------------------------
      CALL ALIGN_INIT_3(MDOC,MODE,SS_FLAG,D3_FLAG
     * ,OPENR,DPENR,PENEXR
     * ,ATOM_INDEX,ATOM_NAME     
     * ,NC,KC,SS1,ISS1,SS2,ISS2,SURF1,SURF2
     * ,NSEQ1,NSEQ2,NMAX1,NMAX2,AMAT)
  
      NMAX12 = NMAX1
      IF(NMAX2.GT.NMAX1) NMAX12 = NMAX2

      allocate(AMATRIX(1:NMAX1,1:NMAX2),STAT=ISTAT)
      allocate(SCORE(1:NMAX12,1:3),STAT=ISTAT)
      allocate(IPAIR(1:2,1:NMAX12),STAT=ISTAT)

      CALL SET_AMATRIX(MDOC,DIST,AMATRIX,AMAT
     *  ,NC,NSEQ1,COORD1,SURF1,KC,NSEQ2,COORD2,SURF2
     *  ,NMAX1,NMAX2,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: in SET_AMATRIX')
        GO TO 600
      ENDIF
      IF(DIST.EQ.'D') THEN
        OPENR  = 0.0
C       DPENR  =
        PENEXR = 0.0
      ENDIF
C ---------------------------------------------
      CALL ALIGNMENT3(MDOC
     *  ,AMATRIX,AMAT,D3_FLAG,SS_FLAG
     *  ,OPENR,DPENR,PENEXR
     *  ,NC,KC
     *  ,ISS1,ISS2,SURF1,SURF2,NSEQ1,NSEQ2
     *  ,IRES1,IRES2,ICHAIN1,ICHAIN2
     *  ,NPAIR,IPAIR,SCORE(1,1),SCORE(1,2)
     *  ,NMAX1,NMAX2,NMAX12,RESULT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: in ALIGNMENT3')
        GO TO 600
      ENDIF

      IF(IPRINT.GT.0) THEN 
        CALL ALIGN_PRINT3(MDOC,NSEQ1,NSEQ2
     *  ,IRES1,IRES2,SCORE(1,1),SCORE(1,2)
     *  ,SS1,SS2,SURF1,SURF2,NAM1,NAM2,NC,KC
     *  ,ICHAIN1,ICHAIN2,D3_FLAG
     *  ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,AMAT,DPENR,RESULT)
      ENDIF
      IF(NPAIR.LE.3) THEN
        CALL MSGERR(MDOC,'ERROR: NPAIR < 4')
        IERR = 1
        GO TO 600
      ENDIF
  
      ITRANS = 0
      IF(CORR.EQ.'Y') ITRANS = 1
 

      IF(CORR.EQ.'N') THEN

        CALL CORR_NAME_BL(FILE_OUT)
        CALL LENSTR_BL(FILE_OUT,LEN)
        IF(LEN.GT.4.AND.IPDB2.EQ.1) THEN
C         output - corrected PDB file_2
          CALL ALIGN_3_WRITE_PDB2_ALIGN(MDOC,FILE_2,FILE_OUT
     *    ,NSEQ1,IRES1,IRES2,NSEQ2,PNUM1,PNUM2,NC,KC,WS_FLAG
     *    ,ATOM_INDEX,ATOM_NAME     
     *    ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR
     *    ,CHAIN,NAT,NRES,NAT_OCC,NRES_OCC
     *    ,ITRANS,RESULT,IPRROW,IERR)
          IF(IERR.EQ.0) THEN
            RESULT(7)  = NAT
            RESULT(8)  = NRES
            RESULT(9)  = NAT_OCC
            RESULT(10) = NRES_OCC
          ENDIF
        ENDIF

      ENDIF

 600  CONTINUE

      deallocate(AMATRIX,STAT=ISTAT)
      deallocate(SCORE,STAT=ISTAT)
      deallocate(IPAIR,STAT=ISTAT)

 700  CONTINUE

      deallocate(COORD2,STAT=ISTAT)
      deallocate(NSEQ2,STAT=ISTAT)
      deallocate(IRES2,STAT=ISTAT)
      deallocate(SURF2,STAT=ISTAT)
      deallocate(ICHAIN2,STAT=ISTAT)
      deallocate(IDOMAIN2,STAT=ISTAT)
      deallocate(SS2,STAT=ISTAT)
      deallocate(ISS2,STAT=ISTAT)
      deallocate(PNUM2,STAT=ISTAT)

 800  CONTINUE

      deallocate(COORD1,STAT=ISTAT)
      deallocate(NSEQ1,STAT=ISTAT)
      deallocate(IRES1,STAT=ISTAT)
      deallocate(SURF1,STAT=ISTAT)
      deallocate(ICHAIN1,STAT=ISTAT)
      deallocate(IDOMAIN1,STAT=ISTAT)
      deallocate(SS1,STAT=ISTAT)
      deallocate(ISS1,STAT=ISTAT)
      deallocate(PNUM1,STAT=ISTAT)

 900  CONTINUE
      RETURN
 910  CONTINUE
      CALL MSGERR(MDOC,'ERROR: read input file (bin)')
      IERR = 1
      RETURN
      END

      SUBROUTINE ALIGN_INIT_3(MDOC,MODE,SS_FLAG,D3_FLAG
     * ,OPENR,DPENR,PENEXR
     * ,ATOM_INDEX,ATOM_NAME     
     * ,NC,KC,SS1,ISS1,SS2,ISS2,SURF1,SURF2
     * ,NSEQ1,NSEQ2,NMAX1,NMAX2,AMAT)
C ---------------------------------------------------------------
      INTEGER   MDOC
      CHARACTER MODE*1
C ---------------------------------------
C -----
C     N CA CB CG CD CE CZ C O
      CHARACTER ATOM_NAME(9)*2
C                      g d e z
      INTEGER   ATOM_INDEX(4,25)
C -----
      INTEGER   ISS1(NMAX1),ISS2(NMAX2)
      INTEGER   SS1(NMAX1),SS2(NMAX2)
      INTEGER   SURF1(NMAX1),SURF2(NMAX2)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
C     CHARACTER PNUM1(NMAX1)*6,PNUM2(NMAX2)*6
      CHARACTER SS_FLAG*1,D3_FLAG*1
      REAL      AMAT(25,25)
C -----
      INTEGER ITABB(20,20)
      INTEGER ITABB1(200),ITABB2(200)
      EQUIVALENCE (ITABB1(1),ITABB(1,1))
      EQUIVALENCE (ITABB2(1),ITABB(1,11))
      INTEGER ITABG(20,20)
      INTEGER ITABG1(200),ITABG2(200)
      EQUIVALENCE (ITABG1(1),ITABG(1,1))
      EQUIVALENCE (ITABG2(1),ITABG(1,11))
      INTEGER ITABU(20,20),ITABS(20,20),ITABE(20,20),INDD(20)
      INTEGER ITABU1(200),ITABU2(200)
      EQUIVALENCE (ITABU1(1),ITABU(1,1))
      EQUIVALENCE (ITABU2(1),ITABU(1,11))
      INTEGER ITABS1(200),ITABS2(200)
      EQUIVALENCE (ITABS1(1),ITABS(1,1))
      EQUIVALENCE (ITABS2(1),ITABS(1,11))
      REAL ITABH(20,20)
      REAL HYDRO(20)

      CHARACTER LINE*256
C --------------------------------------------------------
C ============================================================
C
C         C    S    T    P    A    G    N    D    E    Q
C         1    2    3    4    5    6    7    8    9   10
C         H    R    K    M    I    L    V    F    Y    W
C        11   12   13   14   15   16   17   18   19   20
      DATA  HYDRO /
     . -0.4,-0.8,-0.7,-1.6, 1.8,-0.4,-3.5,-3.5,-3.5,-3.5,
     . -3.2,-4.5,-3.9, 1.9, 4.5, 3.8, 4.2, 2.5,-1.3,-0.9/
C    . -0.4,-0.8,-0.7,-1.6, 1.8,-0.4,-3.5,-3.5,-3.5,-3.5,
C    . -3.2,-4.5,-3.9, 1.9, 4.5, 3.8, 4.2, 2.5,-1.3,-0.9/
C
C  PAM-250
C      C  S  T  P  A  G  N  D  E  Q  H  R  K  M  I  L  V  F  Y  W
C      1  2  3  4  5  6  7  8  9     1  2  3  4  5  6  7  8  9
      DATA ITABG1 /
     .12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     . 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-2, 1, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-3, 1, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-2, 1, 1, 1, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-3, 1, 0,-1, 1, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-4, 1, 0,-1, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-5, 0, 0,-1, 0, 1, 2, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-5, 0, 0,-1, 0, 0, 1, 3, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-5,-1,-1, 0, 0,-1, 1, 2, 2, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     . /
      DATA ITABG2 /
     .-3,-1,-1, 0,-1,-2, 2, 1, 1, 3, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-4, 0,-1, 0,-2,-3, 0,-1,-1, 1, 2, 6, 0, 0, 0, 0, 0, 0, 0, 0,
     .-5, 0, 0,-1,-1,-2, 1, 0, 0, 1, 0, 3, 5, 0, 0, 0, 0, 0, 0, 0,
     .-5,-2,-1,-2,-1,-3,-2,-3,-2,-1,-2, 0, 0, 6, 0, 0, 0, 0, 0, 0,
     .-2,-1, 0,-2,-1,-3,-2,-2,-2,-2,-2,-2,-2, 2, 5, 0, 0, 0, 0, 0,
     .-6,-3,-2,-3,-2,-4,-3,-4,-3,-2,-2,-3,-3, 4, 2, 6, 0, 0, 0, 0,
     .-2,-1, 0,-1, 0,-1,-2,-2,-2,-2,-2,-2,-2, 2, 4, 2, 4, 0, 0, 0,
     .-4,-3,-3,-5,-4,-5,-4,-6,-5,-5,-2,-4,-5, 0, 1, 2,-1, 9, 0, 0,
     . 0,-3,-3,-5,-3,-5,-2,-4,-4,-4, 0,-4,-4,-2,-1,-1,-2, 7,10, 0,
     .-8,-2,-5,-6,-6,-7,-4,-7,-7,-5,-3,-2,-3,-4,-5,-2,-6, 0, 0,17
     . /
c    
C  BLOSUM62
C      C  S  T  P  A  G  N  D  E  Q  H  R  K  M  I  L  V  F  Y  W
C      1  2  3  4  5  6  7  8  9     1  2  3  4  5  6  7  8  9
      DATA ITABB1 /
     . 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-1, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-1, 1, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-3,-1,-1, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     . 0, 1, 0,-1, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-3, 0,-2,-2, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-3, 1, 0,-2,-2, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-3, 0,-1,-1,-2,-1, 1, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-4, 0,-1,-1,-1,-2, 0, 2, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-3, 0,-1,-1,-1,-2, 0, 0, 2, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     . /
      DATA ITABB2 /
     .-3,-1,-2,-2,-2,-2, 1,-1, 0, 0, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-3,-1,-1,-2,-1,-2, 0,-2, 0, 1, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0,
     .-3, 0,-1,-1,-1,-2, 0,-1, 1, 1,-1, 2, 5, 0, 0, 0, 0, 0, 0, 0,
     .-1,-1,-1,-2,-1,-3,-2,-3,-2, 0,-2,-1,-1, 5, 0, 0, 0, 0, 0, 0,
     .-1,-2,-1,-3,-1,-4,-3,-3,-3,-3,-3,-3,-3, 1, 4, 0, 0, 0, 0, 0,
     .-1,-2,-1,-3,-1,-4,-3,-4,-3,-2,-3,-2,-2, 2, 2, 4, 0, 0, 0, 0,
     .-1,-2, 0,-2, 0,-3,-3,-3,-2,-2,-3,-3,-2, 1, 3, 1, 4, 0, 0, 0,
     .-2,-2,-2,-4,-2,-3,-3,-3,-3,-3,-1,-3,-3, 0, 0, 0,-1, 6, 0, 0,
     .-2,-2,-2,-3,-2,-3,-2,-3,-2,-1, 2,-2,-2,-1,-1,-1,-1, 3, 7, 0,
     .-2,-3,-2,-4,-3,-2,-4,-4,-3,-2,-2,-3,-3,-1,-3,-2,-3, 1, 2,11
     . /
C
C       C  S  T  P  A  G  N  D  E  Q  H  R  K  M  I  L  V  F  Y  W
C       1  2  3  4  5  6  7  8  9     1  2  3  4  5  6  7  8  9
      DATA ITABU1/
     .  5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     . /
      DATA ITABU2/
     .  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0,
     .  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0,
     .  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/
C
C       C  S  T  P  A  G  N  D  E  Q  H  R  K  M  I  L  V  F  Y  W
C       1  2  3  4  5  6  7  8  9     1  2  3  4  5  6  7  8  9
      DATA ITABS1/
     .  5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 3, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 1, 1, 2, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 2, 2, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 3, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 3, 3, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 3, 3, 3, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     . /
      DATA ITABS2/
     .  0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 2, 2, 2, 2, 2, 5, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 2, 2, 2, 2, 2, 4, 5, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 2, 1, 0, 0, 0, 0, 2, 0, 0, 5, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 2, 1, 0, 0, 0, 0, 1, 0, 0, 4, 5, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 2, 1, 0, 0, 0, 0, 1, 0, 0, 4, 4, 5, 0, 0, 0, 0,
     .  0, 0, 0, 0, 2, 1, 0, 0, 0, 0, 1, 0, 0, 4, 4, 4, 5, 0, 0, 0,
     .  0, 0, 0, 0, 2, 1, 0, 0, 0, 0, 2, 0, 0, 4, 4, 4, 4, 5, 0, 0,
     .  0, 0, 0, 0, 2, 1, 0, 0, 0, 0, 2, 0, 0, 4, 4, 4, 4, 5, 5, 0,
     .  0, 0, 0, 0, 2, 1, 0, 0, 0, 0, 2, 0, 0, 4, 4, 4, 4, 5, 5, 5/
C       C  S  T  P  A  G  N  D  E  Q  H  R  K  M  I  L  V  F  Y  W
C       1  2  3  4  5  6  7  8  9     1  2  3  4  5  6  7  8  9
C
C -------------------------------------
      MD   =-ABS(MDOC)-1
      M    = 99
C---------------------------------------------------------------
C -----
      ATOM_NAME(1) = 'N '
      ATOM_NAME(2) = 'CA'
      ATOM_NAME(3) = 'CB'
      ATOM_NAME(4) = 'CG'
      ATOM_NAME(5) = 'CD'
      ATOM_NAME(6) = 'CE'
      ATOM_NAME(7) = 'CZ'
      ATOM_NAME(8) = 'C '
      ATOM_NAME(9) = 'O '
      DO I=1,4
      DO J=1,25
        ATOM_INDEX(I,J) = 0
      ENDDO
      ENDDO
      ATOM_INDEX( 1, 1) = 1
      ATOM_INDEX( 2, 1) = 0 
      ATOM_INDEX( 1, 2) = 1
      ATOM_INDEX( 2, 2) = 0 
      ATOM_INDEX( 1, 3) = 2
      ATOM_INDEX( 2, 3) = 0 
      ATOM_INDEX( 1, 4) = 1
      ATOM_INDEX( 2, 4) = 1 
      ATOM_INDEX( 1, 7) = 1
      ATOM_INDEX( 2, 7) = 2
      ATOM_INDEX( 1, 8) = 1
      ATOM_INDEX( 2, 8) = 2
      ATOM_INDEX( 1, 9) = 1
      ATOM_INDEX( 2, 9) = 1
      ATOM_INDEX( 3, 9) = 2
      ATOM_INDEX( 1,10) = 1
      ATOM_INDEX( 2,10) = 1
      ATOM_INDEX( 3,10) = 2
      ATOM_INDEX( 1,11) = 1
      ATOM_INDEX( 2,11) = 2
      ATOM_INDEX( 3,11) = 2
      ATOM_INDEX( 1,12) = 1
      ATOM_INDEX( 2,12) = 1
      ATOM_INDEX( 3,12) = 1
      ATOM_INDEX( 4,12) = 1
      ATOM_INDEX( 1,13) = 1
      ATOM_INDEX( 2,13) = 1
      ATOM_INDEX( 3,13) = 1
      ATOM_INDEX( 4,13) = 1
      ATOM_INDEX( 1,14) = 1
      ATOM_INDEX( 2,14) = 1
      ATOM_INDEX( 1,15) = 2
      ATOM_INDEX( 2,15) = 1
      ATOM_INDEX( 1,16) = 1
      ATOM_INDEX( 2,16) = 2
      ATOM_INDEX( 1,17) = 2
      ATOM_INDEX( 2,17) = 0
      ATOM_INDEX( 1,18) = 1
      ATOM_INDEX( 2,18) = 2
      ATOM_INDEX( 3,18) = 2
      ATOM_INDEX( 4,18) = 1
      ATOM_INDEX( 1,19) = 1
      ATOM_INDEX( 2,19) = 2
      ATOM_INDEX( 3,19) = 2
      ATOM_INDEX( 4,19) = 1
      ATOM_INDEX( 1,20) = 1
      ATOM_INDEX( 2,20) = 2
      ATOM_INDEX( 3,20) = 2
C-------
      DO I=1,25
      DO J=1,25
        AMAT(I,J) = 0.0
      ENDDO
      ENDDO
C-------
C ---
      IF(SS_FLAG.EQ.'Y') THEN
        NSS = 0
        DO L=1,NC
          IF(SS1(L).EQ.0) THEN
            ISS1(L) = 0
          ELSE
            IF(L.LE.1) THEN
              IF(SS1(L).NE.0) NSS = 1
              ISS1(L) = NSS
            ELSE
              IF(SS1(L).NE.SS1(L-1)) NSS = NSS + 1 
            ENDIF
            ISS1(L) = NSS
          ENDIF
        ENDDO
        NSS = 0
        DO L=1,KC
          IF(SS2(L).EQ.0) THEN
            ISS2(L) = 0
          ELSE
            IF(L.LE.1) THEN
              IF(SS2(L).NE.0) NSS = 1
              ISS2(L) = NSS
            ELSE
              IF(SS2(L).NE.SS2(L-1)) NSS = NSS + 1 
            ENDIF
            ISS2(L) = NSS
          ENDIF
        ENDDO
      ELSE
        DO L=1,NC
          SS1(L)  = 0
          ISS1(L) = 0
        ENDDO
        DO L=1,KC
          SS2(L)  = 0
          ISS2(L) = 0
        ENDDO
      ENDIF
      IF(D3_FLAG.EQ.'N') THEN
        DO L=1,NC
          IF(SURF1(L).GE.0) SURF1(L) = 1 
        ENDDO
        DO L=1,KC
          IF(SURF2(L).GE.0) SURF2(L) = 1 
        ENDDO
      ENDIF
C---------------READING AND PREPARETION OF SEQUENCES------------
C      PREPARETION OTHER FACTORS; F.E. PENALTY FACTORS
C----------------------------------------------------------------
      IF(MODE.EQ.'h') MODE='H'
      IF(MODE.EQ.'s') MODE='S'
      IF(MODE.EQ.'k') MODE='K'
      IF(MODE.NE.'1'.AND.MODE.NE.'H'.AND.MODE.NE.'B'.AND.
     *   MODE.NE.'S'.AND.MODE.NE.'K') MODE='G'
      WRITE(LINE,'('' MATRIX (UNIT-1,GOMOLOGY-<G>,HYDROPHOB-H '')')
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(''         STRUCTURE-S,KODON-K          ) :'',A)')
     * MODE
      CALL MSGDOC(MDOC,LINE)
C ----
      IF(MODE.EQ.'H') THEN
        DO     I=1,20
        DO     J=1,20
          ITABH(I,J) = 4.-ABS(HYDRO(I)-HYDRO(J))
     .                   +   (HYDRO(I)+HYDRO(J))/2.
        ENDDO
        ENDDO
      ENDIF  
C -----------------------
      TMXN = 1.E 30
      DO     I=1,20
      DO     J=1,20
        IF(MODE.EQ.'1') THEN
          AMAT(I,J)=FLOAT(ITABU(I,J))
        ELSE IF(MODE.EQ.'H') THEN
          AMAT(I,J)=ITABH(I,J)
        ELSE IF(MODE.EQ.'S') THEN
          AMAT(I,J)=FLOAT(ITABS(I,J))
        ELSE IF(MODE.EQ.'B') THEN
          AMAT(I,J)=FLOAT(ITABB(I,J)) + 0.01
        ELSE
          AMAT(I,J)=FLOAT(ITABG(I,J)) + 0.01
        ENDIF
        IF(TMXN.GT.AMAT(I,J))TMXN=AMAT(I,J)
      ENDDO
      ENDDO
C ----------
      TMAX =-1.E 30
      TMIN = 1.E 30
      DO      I=1,20
      DO      J=1,I
        IF(I.NE.J)            AMAT(I,J) = AMAT(J,I)
        IF(AMAT(I,J).GT.TMAX) TMAX      = AMAT(I,J)
        IF(AMAT(I,J).LT.TMIN) TMIN      = AMAT(I,J)
      ENDDO
      ENDDO
      TX =-1.E 30
      TN = 1.E 30
      DO      I=1,20
      DO      J=1,20
C       AMAT(I,J) = (AMAT(I,J)- TMIN)/TMN + 0.0001
        AMAT(I,J) = (AMAT(I,J) - TMIN + 1.0)/(TMAX - TMIN + 1.0)
        IF(AMAT(I,J).GT.TX) TX = AMAT(I,J)
        IF(AMAT(I,J).LT.TN) TN = AMAT(I,J)
      ENDDO
      ENDDO
      WRITE(LINE,'('' MATCH MAX,MIN :'',2F8.3)') TX,TN
      CALL MSGDOC(MDOC,LINE)
      AMAT0 = (1.0 - TMIN)/(TMAX - TMIN + 1.0)
      WRITE(LINE,'('' "0" :'',F8.3)') AMAT0
      CALL MSGDOC(MDOC,LINE)
      AMAT12 = (12.0 + 1.0 - TMIN)/(TMAX - TMIN + 1.0)
      AMAT2  = (2.0  + 1.0 - TMIN)/(TMAX - TMIN + 1.0)
      WRITE(LINE,'('' "12,2" :'',2F8.3)') AMAT12,AMAT2
      CALL MSGDOC(MDOC,LINE)

c      AMAT_1  = (-1.0  + 1.0 - TMIN)/(TMAX - TMIN + 1.0)
c      AMAT_2  = (-2.0  + 1.0 - TMIN)/(TMAX - TMIN + 1.0)
c      WRITE(LINE,'('' "-1,-2" :'',2F8.3)') AMAT_1,AMAT_2
c      CALL MSGDOC(MDOC,LINE)
c      AMAT_3  = (-3.0  + 1.0 - TMIN)/(TMAX - TMIN + 1.0)
c      AMAT_4  = (-4.0  + 1.0 - TMIN)/(TMAX - TMIN + 1.0)
c      WRITE(LINE,'('' "-3,-4" :'',2F8.3)') AMAT_3,AMAT_4
c      CALL MSGDOC(MDOC,LINE)
c      DO      I=1,20
c      DO      J=1,20
c        IF(AMAT(I,J).LT.AMAT_1) AMAT(I,J) = 0.0
c      ENDDO
c      write(*,'(20(f4.3,1x))') (AMAT(I,J),j=1,20)
c      ENDDO

c      OPENR  = OPENR*TX
c      DPENR  = DPENR*TX
c      PENEXR = PENEXR*TX
c      WRITE(LINE,'('' OPEN,PENEX,DPEN :'',3F8.3)') 
c     *  OPENR,PENEXR,DPENR
c      CALL MSGDOC(MDOC,LINE)
C--------------------------------------------------------------
      RETURN
      END

      SUBROUTINE SET_AMATRIX(MDOC,MODE,AMATRIX,AMAT
     *  ,NC,NSEQ1,COORD1,SURF1,KC,NSEQ2,COORD2,SURF2
     *  ,NMAX1,NMAX2,IERR)
C ---------------------------------------------------------------
      INTEGER   MDOC
      CHARACTER MODE*1
      REAL      AMATRIX(NMAX1,NMAX2)
      REAL      AMAT(25,25)
      REAL      COORD1(NMAX1,3)
      REAL      COORD2(NMAX2,3)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   SURF1(NMAX1),SURF2(NMAX2)
C ---------------------------------------
      MD   =-ABS(MDOC)-1
      M    = 99
      IERR = 0
C ----
      IF(MODE.NE.'D') THEN

        DO I=1,NC
          N1  = NSEQ1(I)
          DO J=1,KC
            N2  = NSEQ2(J)
            T = AMAT(N1,N2)
            AMATRIX(I,J) = T
          ENDDO
        ENDDO

      ELSE
        TMAX = -1.0E30
        TMIN =  1.0E30
        DO I=1,NC
          DO J=1,KC
            IF(SURF1(I).LT.0.OR.SURF2(J).LT.0) THEN
              AMATRIX(I,J) = 0.0
            ELSE
              DX = COORD1(I,1) - COORD2(J,1)
              DY = COORD1(I,2) - COORD2(J,2)
              DZ = COORD1(I,3) - COORD2(J,3)
              D2 = DX*DX + DY*DY + DZ*DZ
              N  = 1
              IF(I.GT.1.AND.J.GT.1) THEN
                II = I - 1
                JJ = J - 1
                IF(SURF1(II).GE.0.AND.SURF2(JJ).GE.0) THEN
                  DX = COORD1(II,1) - COORD2(JJ,1)
                  DY = COORD1(II,2) - COORD2(JJ,2)
                  DZ = COORD1(II,3) - COORD2(JJ,3)
                  D = DX*DX + DY*DY + DZ*DZ
                  D2 = D2 + D
                  N  = N + 1
                ENDIF
              ENDIF
              IF(I.LT.NC.AND.J.LT.KC) THEN
                II = I + 1
                JJ = J + 1
                IF(SURF1(II).GE.0.AND.SURF2(JJ).GE.0) THEN
                  DX = COORD1(II,1) - COORD2(JJ,1)
                  DY = COORD1(II,2) - COORD2(JJ,2)
                  DZ = COORD1(II,3) - COORD2(JJ,3)
                  D = DX*DX + DY*DY + DZ*DZ
                  D2 = D2 + D
                  N  = N + 1
                ENDIF
              ENDIF
              IF(I.GT.2.AND.J.GT.2) THEN
                II = I - 2
                JJ = J - 2
                IF(SURF1(II).GE.0.AND.SURF2(JJ).GE.0) THEN
                  DX = COORD1(II,1) - COORD2(JJ,1)
                  DY = COORD1(II,2) - COORD2(JJ,2)
                  DZ = COORD1(II,3) - COORD2(JJ,3)
                  D = DX*DX + DY*DY + DZ*DZ
                  D2 = D2 + D
                  N  = N + 1
                ENDIF
              ENDIF
              IF(I.LT.NC-1.AND.J.LT.KC-1) THEN
                II = I + 2
                JJ = J + 2
                IF(SURF1(II).GE.0.AND.SURF2(JJ).GE.0) THEN
                  DX = COORD1(II,1) - COORD2(JJ,1)
                  DY = COORD1(II,2) - COORD2(JJ,2)
                  DZ = COORD1(II,3) - COORD2(JJ,3)
                  D = DX*DX + DY*DY + DZ*DZ
                  D2 = D2 + D
                  N  = N + 1
                ENDIF
              ENDIF
              D2   = D2/FLOAT(N)
              SIG2 = 25.0
              SIG2 = 9.0
              TT   = D2/(2.0*SIG2)
              T    = EXP(-TT)
              AMATRIX(I,J) = T
              IF(T.GT.TMAX) TMAX = T
              IF(T.LT.TMIN) TMIN = T
            ENDIF
          ENDDO
        ENDDO

      ENDIF
C ----
      RETURN
      END

      SUBROUTINE ALIGN_PRINT3(MDOC,NSEQ1,NSEQ2
     *  ,IRES1,IRES2,SCORE1,SCORE2
     *  ,SS1,SS2,SURF1,SURF2,NAM1,NAM2,NC,KC
     *  ,ICHAIN1,ICHAIN2,D3_FLAG
     *  ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,AMAT,DPENR,RESULT)
C -------------------------------------
      CHARACTER  AMIN(25)*1,LINE*50,LINE2*50,NAM1*4,NAM2*4,LINE3*50
      CHARACTER  LINE1*50,LINE_SS1*50,LINE_SS2*50,LINE_SURF1*50
      CHARACTER  LINE_1N1*50,LINE_1N2*50,LINE_1N3*50,LINE_1N4*50
      CHARACTER  LINE_2N1*50,LINE_2N2*50,LINE_2N3*50,LINE_2N4*50
      CHARACTER  LS1*50,LS2*50,LS3*50,LS4*50,LS5*50,LINE_SURF2*50
C ----
      REAL      SCORE1(NMAX12), SCORE2(NMAX12),RESULT(*)
      REAL      AMAT(25,25)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IPAIR(2,NMAX12),ICHAIN1(NMAX1),ICHAIN2(NMAX2)
      INTEGER   IRES1(NMAX1),IRES2(NMAX2)

      INTEGER   SS1(NMAX1),SS2(NMAX2)
      INTEGER   SURF1(NMAX1),SURF2(NMAX2)

C      alloc
C      INTEGER   STR1(NMAX1),STR2(NMAX2)

      CHARACTER DLINE*256,CHAR*4,SS*1,D3_FLAG*1

      INTEGER*2 ICHS
      CHARACTER CHS*2
      EQUIVALENCE (ICHS,CHS)

      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','=','-'/
C ================================================================

      IF(NPAIR.EQ.0) RETURN

C      CALL CALC_SCORE(NC,KC,NSEQ1,NSEQ2,SCORE1,SCORE2
C     * ,NPAIR,IPAIR
C     * ,NMAX1,NMAX2,NMAX12,AMAT
C     * ,NC1,KC1,NN,NHOM,HOM
C     * ,SUM_SCORE,SCORE1_MAX,SCORE_MIN,SCORE_SIGMA
C     * ,FIDENT_NEW,DPENR)

      CALL SMOOTH_SCORE_DB(MDOC,DPENR
     *  ,NC,KC,NSEQ1,NSEQ2,SCORE1,SCORE2,NPAIR,IPAIR
     *  ,NMAX1,NMAX2,NMAX12,IERR)

      SMAX = -1.0E30
      SMIN =  1.0E30
      DO I=1,NC
        IF(SCORE1(I).GE.0.0) THEN
          T = SCORE1(I)- DPENR
          IF(T.GT.SMAX) SMAX = T
          IF(T.LT.SMIN) SMIN = T
        ENDIF
      ENDDO

      SLIM = ABS(SMIN)
      IF(ABS(SMAX).GT.SLIM) SLIM = ABS(SMAX)
      SLIM = SLIM/2.0


      IPR   = 0
      IC    = 0
      ICC   = 0

      IPR = IPR+1

      ISE = IPAIR(1,IPR) 
      JSE = IPAIR(2,IPR)
      
      LINE     = ' '
      LINE1    = ' '
      LINE2    = ' '
      LINE3    = ' '
      LINE_1N1 = ' '
      LINE_1N2 = ' '
      LINE_1N3 = ' '
      LINE_1N4 = ' '
      LINE_SS1 = ' '
      LINE_2N1 = ' '
      LINE_2N2 = ' '
      LINE_2N3 = ' '
      LINE_2N4 = ' '
      LINE_SS2 = ' '
      LINE_SURF1= ' '
      LINE_SURF2= ' '
      LS1=      ' '
      LS2=      ' '
      LS3=      ' '
      LS4=      ' '
      LS5=      ' '

      CALL MSGDOC(MDOC,' ')
      IF(ISE.EQ.1)THEN
        IF(JSE.GT.1)THEN
          DO     II=1,JSE-1
            IF(ICC.GE.50)THEN
              CALL WRIT3(MDOC,LINE,NAM1,NAM2,LINE1,LINE2,LINE3
     *        ,LINE_1N1,LINE_1N2,LINE_1N3,LINE_1N4,LINE_SS1,LINE_SURF1
     *        ,LS1,LS2,LS3,LS4,LS5
     *        ,LINE_2N1,LINE_2N2,LINE_2N3,LINE_2N4,LINE_SS2,LINE_SURF2)
              ICC=0
            ENDIF
            ICC              = ICC+1
            IC               = IC+1

            LINE(ICC:ICC)    =' '
            LINE1(ICC:ICC)   =' '
            LINE_1N1(ICC:ICC)=' '
            LINE_1N2(ICC:ICC)=' '
            LINE_1N3(ICC:ICC)=' '
            LINE_1N4(ICC:ICC)=' '
            LINE_SS1(ICC:ICC)=' '
            LINE_SURF1(ICC:ICC)=' '
            LS1(ICC:ICC)=      ' '
            LS2(ICC:ICC)=      ' '
            LS3(ICC:ICC)=      ' '
            LS4(ICC:ICC)=      ' '
            LS5(ICC:ICC)=      ' '

            N2               = NSEQ2(II)
            LINE_2N1(ICC:ICC)=' '
            LINE_2N2(ICC:ICC)=' '
            LINE_2N3(ICC:ICC)=' '
            LINE_2N4(ICC:ICC)=' '
            LINE2(ICC:ICC)   = AMIN(N2)
            IF(N2.LT.24) THEN
              WRITE(CHAR,'(I4)') IRES2(II)
              LINE_2N1(ICC:ICC)= CHAR(1:1)
              LINE_2N2(ICC:ICC)= CHAR(2:2)
              LINE_2N3(ICC:ICC)= CHAR(3:3)
              LINE_2N4(ICC:ICC)= CHAR(4:4)
            ENDIF

C           LINE_SS2(ICC:ICC)= SS2(II)
            IF(SS2(II).EQ.1) THEN
              SS = 'H'
            ELSE IF(SS2(II).EQ.2) THEN
              SS = 'h'
            ELSE IF(SS2(II).EQ.3) THEN
              SS = 'B'
            ELSE IF(SS2(II).EQ.4) THEN
              SS = 'b'
            ELSE
              SS = ' '
            ENDIF
            LINE_SS2(ICC:ICC)= SS

            SS = ' '
            IF(SURF2(II).GT.0) THEN
              WRITE(SS,'(I1)') SURF2(II)
            ENDIF
            LINE_SURF2(ICC:ICC)= SS


          ENDDO
        ENDIF
      ELSE IF(JSE.EQ.1) THEN
        IF(ISE.GT.1)THEN
          DO     II=1,ISE-1
            IF(ICC.GE.50)THEN
              CALL WRIT3(MDOC,LINE,NAM1,NAM2,LINE1,LINE2,LINE3
     *        ,LINE_1N1,LINE_1N2,LINE_1N3,LINE_1N4,LINE_SS1,LINE_SURF1
     *        ,LS1,LS2,LS3,LS4,LS5
     *        ,LINE_2N1,LINE_2N2,LINE_2N3,LINE_2N4,LINE_SS2,LINE_SURF2)
              ICC=0
            ENDIF
            ICC              = ICC+1
            IC               = IC+1

            LINE2(ICC:ICC)    =' '
            LINE_2N1(ICC:ICC) =' '
            LINE_2N2(ICC:ICC) =' '
            LINE_2N3(ICC:ICC) =' '
            LINE_2N4(ICC:ICC) =' '
            LINE_SS2(ICC:ICC) =' '
            LINE_SURF2(ICC:ICC)= ' '

            N1               = NSEQ1(II)
            LINE(ICC:ICC)    = AMIN(N1)

C            ICHS             = STR1(II)
C            LINE1(ICC:ICC)   = CHS(2:2)
             LINE1(ICC:ICC)   = ' '
            LINE_1N1(ICC:ICC) =' '
            LINE_1N2(ICC:ICC) =' '
            LINE_1N3(ICC:ICC) =' '
            LINE_1N4(ICC:ICC) =' '
            IF(N1.LT.24) THEN
              WRITE(CHAR,'(I4)') IRES1(II)
              LINE_1N1(ICC:ICC)= CHAR(1:1)
              LINE_1N2(ICC:ICC)= CHAR(2:2)
              LINE_1N3(ICC:ICC)= CHAR(3:3)
              LINE_1N4(ICC:ICC)= CHAR(4:4)
            ENDIF
C            LINE_SS1(ICC:ICC)= SS1(II)
            IF(SS1(II).EQ.1) THEN
              SS = 'H'
            ELSE IF(SS1(II).EQ.2) THEN
              SS = 'h'
            ELSE IF(SS1(II).EQ.3) THEN
              SS = 'B'
            ELSE IF(SS1(II).EQ.4) THEN
              SS = 'b'
            ELSE
              SS = ' '
            ENDIF
            LINE_SS1(ICC:ICC)= SS
            SS = ' '
            IF(SURF1(II).GT.0) THEN
              WRITE(SS,'(I1)') SURF1(II)
            ENDIF
            LINE_SURF1(ICC:ICC)= SS
            LS1(ICC:ICC)=      ' '
            LS2(ICC:ICC)=      ' '
            LS3(ICC:ICC)=      ' '
            LS4(ICC:ICC)=      ' '
            LS5(ICC:ICC)=      ' '

          ENDDO
        ENDIF
      ELSE

      ENDIF

      IF(ICC.GE.50)THEN
        CALL WRIT3(MDOC,LINE,NAM1,NAM2,LINE1,LINE2,LINE3
     *  ,LINE_1N1,LINE_1N2,LINE_1N3,LINE_1N4,LINE_SS1,LINE_SURF1
     *        ,LS1,LS2,LS3,LS4,LS5
     *  ,LINE_2N1,LINE_2N2,LINE_2N3,LINE_2N4,LINE_SS2,LINE_SURF2)
        ICC = 0
      ENDIF
      ICC = ICC + 1
      IC  = IC  + 1

      N1               = NSEQ1(ISE)
      LINE(ICC:ICC)    = AMIN(N1)

C      ICHS             = STR1(ISE)
C      LINE1(ICC:ICC)   = CHS(2:2)
      LINE1(ICC:ICC)   = ' '

      LINE_1N1(ICC:ICC) =' '
      LINE_1N2(ICC:ICC) =' '
      LINE_1N3(ICC:ICC) =' '
      LINE_1N4(ICC:ICC) =' '
      IF(N1.LT.24) THEN
        WRITE(CHAR,'(I4)') IRES1(ISE)
        LINE_1N1(ICC:ICC)= CHAR(1:1)
        LINE_1N2(ICC:ICC)= CHAR(2:2)
        LINE_1N3(ICC:ICC)= CHAR(3:3)
        LINE_1N4(ICC:ICC)= CHAR(4:4)
      ENDIF
C      LINE_SS1(ICC:ICC)= SS1(ISE)
      IF(SS1(ISE).EQ.1) THEN
        SS = 'H'
      ELSE IF(SS1(ISE).EQ.2) THEN
        SS = 'h'
      ELSE IF(SS1(ISE).EQ.3) THEN
        SS = 'B'
      ELSE IF(SS1(ISE).EQ.4) THEN
        SS = 'b'
      ELSE
        SS = ' '
      ENDIF
      LINE_SS1(ICC:ICC)= SS
      SS = ' '
      IF(SURF1(ISE).GT.0) THEN
        WRITE(SS,'(I1)') SURF1(ISE)
      ENDIF
      LINE_SURF1(ICC:ICC)= SS

      SCR = SCORE1(ISE) - DPENR
      IF(SCR.GE.0) THEN
        ISC = (SCR/SLIM)*2.0 + 3.0
        IF(ISC.LT.4) THEN
          ISC = 1
        ELSE IF(ISC.GT.5) THEN
          ISC = 5
        ENDIF
      ELSE IF(SCR.LT.0) THEN
        ISC = (ABS(SCR)/SLIM)*2.0 + 1.0
        IF(ISC.LT.2) THEN
          ISC = 6
        ELSE IF(ISC.GT.3) THEN
          ISC = 3
        ENDIF
      ELSE 
        ISC =-1
      ENDIF
      IF(ISC.LT.0) THEN
        ISC =-1
      ENDIF
      IF(ISC.LT.0) LS3(ICC:ICC) = '.'
      IF(ISC.EQ.0) LS3(ICC:ICC) = '0'
      IF(ISC.EQ.1) LS3(ICC:ICC) = '+'
      IF(ISC.EQ.6) LS3(ICC:ICC) = '-'
      IF(ISC.EQ.2) LS2(ICC:ICC) = '-'
      IF(ISC.EQ.2) LS3(ICC:ICC) = '-'
      IF(ISC.EQ.3) LS1(ICC:ICC) = '-'
      IF(ISC.EQ.3) LS2(ICC:ICC) = '-'
      IF(ISC.EQ.3) LS3(ICC:ICC) = '-'
      IF(ISC.EQ.4) LS4(ICC:ICC) = '+'
      IF(ISC.EQ.4) LS3(ICC:ICC) = '+'
      IF(ISC.EQ.5) LS5(ICC:ICC) = '+'
      IF(ISC.EQ.5) LS4(ICC:ICC) = '+'
      IF(ISC.EQ.5) LS3(ICC:ICC) = '+'

      N2               = NSEQ2(JSE)
      LINE2(ICC:ICC)   = AMIN(N2)

      LINE_2N1(ICC:ICC) =' '
      LINE_2N2(ICC:ICC) =' '
      LINE_2N3(ICC:ICC) =' '
      LINE_2N4(ICC:ICC) =' '
      IF(N2.LT.24) THEN
        WRITE(CHAR,'(I4)') IRES2(JSE)
        LINE_2N1(ICC:ICC)= CHAR(1:1)
        LINE_2N2(ICC:ICC)= CHAR(2:2)
        LINE_2N3(ICC:ICC)= CHAR(3:3)
        LINE_2N4(ICC:ICC)= CHAR(4:4)
      ENDIF
C      LINE_SS2(ICC:ICC)= SS2(JSE)
      IF(SS2(JSE).EQ.1) THEN
        SS = 'H'
      ELSE IF(SS2(JSE).EQ.2) THEN
        SS = 'h'
      ELSE IF(SS2(JSE).EQ.3) THEN
        SS = 'B'
      ELSE IF(SS2(JSE).EQ.4) THEN
        SS = 'b'
      ELSE
        SS = ' '
      ENDIF
      LINE_SS2(ICC:ICC)= SS

      SS = ' '
      IF(SURF2(JSE).GT.0) THEN
        WRITE(SS,'(I1)') SURF2(JSE)
      ENDIF
      LINE_SURF2(ICC:ICC)= SS


      IF(N1.EQ.N2.AND.N1.LT.24)THEN
        LINE3(ICC:ICC) = '*'
      ENDIF

C ---
 20   IPR = IPR + 1

      I1 = IPAIR(1,IPR)
      J1 = IPAIR(2,IPR)

      IF(I1-ISE.GT.1)THEN

        DO     II=ISE+1,I1-1
         IF(ICC.GE.50)THEN
            CALL WRIT3(MDOC,LINE,NAM1,NAM2,LINE1,LINE2,LINE3
     *      ,LINE_1N1,LINE_1N2,LINE_1N3,LINE_1N4,LINE_SS1,LINE_SURF1
     *        ,LS1,LS2,LS3,LS4,LS5
     *      ,LINE_2N1,LINE_2N2,LINE_2N3,LINE_2N4,LINE_SS2,LINE_SURF2)
            ICC = 0
          ENDIF
          ICC = ICC + 1
          IC  = IC + 1
          N1  = NSEQ1(II)

          LINE(ICC:ICC)     = AMIN(N1)

C          ICHS             = STR1(II)
C          LINE1(ICC:ICC)   = CHS(2:2)
          LINE1(ICC:ICC)   = ' '

          LINE_1N1(ICC:ICC) =' '
          LINE_1N2(ICC:ICC) =' '
          LINE_1N3(ICC:ICC) =' '
          LINE_1N4(ICC:ICC) =' '
          IF(N1.LT.24) THEN
            WRITE(CHAR,'(I4)') IRES1(II)
            LINE_1N1(ICC:ICC) = CHAR(1:1)
            LINE_1N2(ICC:ICC) = CHAR(2:2)
            LINE_1N3(ICC:ICC) = CHAR(3:3)
            LINE_1N4(ICC:ICC) = CHAR(4:4)
          ENDIF
C          LINE_SS1(ICC:ICC) = SS1(II)
          IF(SS1(II).EQ.1) THEN
            SS = 'H'
          ELSE IF(SS1(II).EQ.2) THEN
            SS = 'h'
          ELSE IF(SS1(II).EQ.3) THEN
            SS = 'B'
          ELSE IF(SS1(II).EQ.4) THEN
            SS = 'b'
          ELSE
            SS = ' '
          ENDIF
          LINE_SS1(ICC:ICC)= SS
          SS = ' '
          IF(SURF1(II).GT.0) THEN
            WRITE(SS,'(I1)') SURF1(II)
          ENDIF
          LINE_SURF1(ICC:ICC)= SS
          LS1(ICC:ICC)=      ' '
          LS2(ICC:ICC)=      ' '
          LS3(ICC:ICC)=      ' '
          LS4(ICC:ICC)=      ' '
          LS5(ICC:ICC)=      ' '

          LINE2(ICC:ICC)    = '_'
          IF(J1-JSE.GT.1)THEN
            DO III=JSE+1,J1-1
              N2 = NSEQ2(III)
              IF(N2.GE.24) THEN
                LINE2(ICC:ICC) = AMIN(N2)
              ENDIF
            ENDDO
          ENDIF
          LINE_2N1(ICC:ICC) = ' '
          LINE_2N2(ICC:ICC) = ' '
          LINE_2N3(ICC:ICC) = ' '
          LINE_2N4(ICC:ICC) = ' '
          LINE_SS2(ICC:ICC) = ' ' 
          LINE_SURF2(ICC:ICC)= ' '
        ENDDO

      ELSE IF(J1-JSE.GT.1)THEN

        DO     II=JSE+1,J1-1
          IF(ICC.GE.50)THEN
            CALL WRIT3(MDOC,LINE,NAM1,NAM2,LINE1,LINE2,LINE3
     *      ,LINE_1N1,LINE_1N2,LINE_1N3,LINE_1N4,LINE_SS1,LINE_SURF1
     *        ,LS1,LS2,LS3,LS4,LS5
     *      ,LINE_2N1,LINE_2N2,LINE_2N3,LINE_2N4,LINE_SS2,LINE_SURF2)
            ICC = 0
          ENDIF
          ICC = ICC + 1
          IC = IC + 1
          N2               = NSEQ2(II)
          LINE2(ICC:ICC)   = AMIN(N2)

          LINE_2N1(ICC:ICC) =' '
          LINE_2N2(ICC:ICC) =' '
          LINE_2N3(ICC:ICC) =' '
          LINE_2N4(ICC:ICC) =' '
          IF(N2.LT.24) THEN
            WRITE(CHAR,'(I4)') IRES2(II)
            LINE_2N1(ICC:ICC)= CHAR(1:1)
            LINE_2N2(ICC:ICC)= CHAR(2:2)
            LINE_2N3(ICC:ICC)= CHAR(3:3)
            LINE_2N4(ICC:ICC)= CHAR(4:4)
          ENDIF
C          LINE_SS2(ICC:ICC)= SS2(II)
          IF(SS2(II).EQ.1) THEN
            SS = 'H'
          ELSE IF(SS2(II).EQ.2) THEN
            SS = 'h'
          ELSE IF(SS2(II).EQ.3) THEN
            SS = 'B'
          ELSE IF(SS2(II).EQ.4) THEN
            SS = 'b'
          ELSE
            SS = ' '
          ENDIF
          LINE_SS2(ICC:ICC)= SS

          SS = ' '
          IF(SURF2(II).GT.0) THEN
            WRITE(SS,'(I1)') SURF2(II)
          ENDIF
          LINE_SURF2(ICC:ICC)= SS

          LINE(ICC:ICC)    ='_'
          IF(I1-ISE.GT.1)THEN
            DO III=ISE+1,I1-1
              N1 = NSEQ1(III)
              IF(N1.GE.24) THEN
                LINE(ICC:ICC) = AMIN(N1)
              ENDIF
            ENDDO
          ENDIF
          LINE1(ICC:ICC)   =' '
          LINE_1N1(ICC:ICC)=' '
          LINE_1N2(ICC:ICC)=' '
          LINE_1N3(ICC:ICC)=' '
          LINE_1N4(ICC:ICC)=' '
          LINE_SS1(ICC:ICC)=' '
          LINE_SURF1(ICC:ICC)=' '
          LS1(ICC:ICC)=      ' '
          LS2(ICC:ICC)=      ' '
          LS3(ICC:ICC)=      ' '
          LS4(ICC:ICC)=      ' '
          LS5(ICC:ICC)=      ' '
        ENDDO
      ENDIF

      JSE = J1
      ISE = I1
C----
      IF(ICC.GE.50)THEN
        CALL WRIT3(MDOC,LINE,NAM1,NAM2,LINE1,LINE2,LINE3
     *  ,LINE_1N1,LINE_1N2,LINE_1N3,LINE_1N4,LINE_SS1,LINE_SURF1
     *        ,LS1,LS2,LS3,LS4,LS5
     *  ,LINE_2N1,LINE_2N2,LINE_2N3,LINE_2N4,LINE_SS2,LINE_SURF2)
        ICC=0
      ENDIF
      ICC = ICC + 1
      IC  = IC  + 1

      N1               = NSEQ1(ISE)
      LINE(ICC:ICC)    = AMIN(N1)

C      ICHS             = STR1(ISE)
C      LINE1(ICC:ICC)   = CHS(2:2)
      LINE1(ICC:ICC)   = ' '

      LINE_1N1(ICC:ICC) =' '
      LINE_1N2(ICC:ICC) =' '
      LINE_1N3(ICC:ICC) =' '
      LINE_1N4(ICC:ICC) =' '
      IF(N1.LT.24) THEN
        WRITE(CHAR,'(I4)') IRES1(ISE)
        LINE_1N1(ICC:ICC)= CHAR(1:1)
        LINE_1N2(ICC:ICC)= CHAR(2:2)
        LINE_1N3(ICC:ICC)= CHAR(3:3)
        LINE_1N4(ICC:ICC)= CHAR(4:4)
      ENDIF
C      LINE_SS1(ICC:ICC)= SS1(ISE)
      IF(SS1(ISE).EQ.1) THEN
        SS = 'H'
      ELSE IF(SS1(ISE).EQ.2) THEN
        SS = 'h'
      ELSE IF(SS1(ISE).EQ.3) THEN
        SS = 'B'
      ELSE IF(SS1(ISE).EQ.4) THEN
        SS = 'b'
      ELSE
        SS = ' '
      ENDIF
      LINE_SS1(ICC:ICC)= SS
      SS = ' '
      IF(SURF1(ISE).GT.0) THEN
        WRITE(SS,'(I1)') SURF1(ISE)
      ENDIF
      LINE_SURF1(ICC:ICC)= SS

      SCR = SCORE1(ISE) - DPENR
      IF(SCR.GE.0) THEN
        ISC = (SCR/SLIM)*2.0 + 3.0
        IF(ISC.LT.4) THEN
          ISC = 1
        ELSE IF(ISC.GT.5) THEN
          ISC = 5
        ENDIF
      ELSE IF(SCR.LT.0) THEN
        ISC = (ABS(SCR)/SLIM)*2.0 + 1.0
        IF(ISC.LT.2) THEN
          ISC = 6
        ELSE IF(ISC.GT.3) THEN
          ISC = 3
        ENDIF
      ELSE 
        ISC =-1
      ENDIF
      IF(ISC.LT.0) THEN
        ISC =-1
      ENDIF
      IF(ISC.LT.0) LS3(ICC:ICC) = '.'
      IF(ISC.EQ.0) LS3(ICC:ICC) = '0'
      IF(ISC.EQ.1) LS3(ICC:ICC) = '+'
      IF(ISC.EQ.6) LS3(ICC:ICC) = '-'
      IF(ISC.EQ.2) LS2(ICC:ICC) = '-'
      IF(ISC.EQ.2) LS3(ICC:ICC) = '-'
      IF(ISC.EQ.3) LS1(ICC:ICC) = '-'
      IF(ISC.EQ.3) LS2(ICC:ICC) = '-'
      IF(ISC.EQ.3) LS3(ICC:ICC) = '-'
      IF(ISC.EQ.4) LS4(ICC:ICC) = '+'
      IF(ISC.EQ.4) LS3(ICC:ICC) = '+'
      IF(ISC.EQ.5) LS5(ICC:ICC) = '+'
      IF(ISC.EQ.5) LS4(ICC:ICC) = '+'
      IF(ISC.EQ.5) LS3(ICC:ICC) = '+'

      N2               = NSEQ2(JSE)
      LINE2(ICC:ICC)   = AMIN(N2)

      LINE_2N1(ICC:ICC) =' '
      LINE_2N2(ICC:ICC) =' '
      LINE_2N3(ICC:ICC) =' '
      LINE_2N4(ICC:ICC) =' '
      IF(N2.LT.24) THEN
        WRITE(CHAR,'(I4)') IRES2(JSE)
        LINE_2N1(ICC:ICC)= CHAR(1:1)
        LINE_2N2(ICC:ICC)= CHAR(2:2)
        LINE_2N3(ICC:ICC)= CHAR(3:3)
        LINE_2N4(ICC:ICC)= CHAR(4:4)
      ENDIF
C      LINE_SS2(ICC:ICC)= SS2(JSE)
      IF(SS2(JSE).EQ.1) THEN
        SS = 'H'
      ELSE IF(SS2(JSE).EQ.2) THEN
        SS = 'h'
      ELSE IF(SS2(JSE).EQ.3) THEN
        SS = 'B'
      ELSE IF(SS2(JSE).EQ.4) THEN
        SS = 'b'
      ELSE
        SS = ' '
      ENDIF
      LINE_SS2(ICC:ICC)= SS

      SS = ' '
      IF(SURF2(JSE).GT.0) THEN
        WRITE(SS,'(I1)') SURF2(JSE)
      ENDIF
      LINE_SURF2(ICC:ICC)= SS

      IF(N1.EQ.N2.AND.N1.LT.24)THEN
        LINE3(ICC:ICC) = '*'
      ENDIF

      IF(IPR.LT.NPAIR) GO TO 20
C ------------------------
100   IF(ISE.EQ.NC)THEN
        IF(JSE.LT.KC)THEN
          DO     II=JSE+1,KC
            IF(ICC.GE.50)THEN
              CALL WRIT3(MDOC,LINE,NAM1,NAM2,LINE1,LINE2,LINE3
     *        ,LINE_1N1,LINE_1N2,LINE_1N3,LINE_1N4,LINE_SS1,LINE_SURF1
     *        ,LS1,LS2,LS3,LS4,LS5
     *        ,LINE_2N1,LINE_2N2,LINE_2N3,LINE_2N4,LINE_SS2,LINE_SURF2)
             ICC = 0
            ENDIF
            ICC = ICC + 1
            IC  = IC  + 1

            LINE(ICC:ICC)    =' '
            LINE1(ICC:ICC)   =' '
            LINE_1N1(ICC:ICC)=' '
            LINE_1N2(ICC:ICC)=' '
            LINE_1N3(ICC:ICC)=' '
            LINE_1N4(ICC:ICC)=' '
            LINE_SS1(ICC:ICC)=' '
            LINE_SURF1(ICC:ICC)=' '
            LS1(ICC:ICC)=      ' '
            LS2(ICC:ICC)=      ' '
            LS3(ICC:ICC)=      ' '
            LS4(ICC:ICC)=      ' '
            LS5(ICC:ICC)=      ' '

            N2               = NSEQ2(II)
            LINE2(ICC:ICC)   = AMIN(N2)

            LINE_2N1(ICC:ICC) =' '
            LINE_2N2(ICC:ICC) =' '
            LINE_2N3(ICC:ICC) =' '
            LINE_2N4(ICC:ICC) =' '
            IF(N2.LT.24) THEN
              WRITE(CHAR,'(I4)') IRES2(II)
              LINE_2N1(ICC:ICC)= CHAR(1:1)
              LINE_2N2(ICC:ICC)= CHAR(2:2)
              LINE_2N3(ICC:ICC)= CHAR(3:3)
              LINE_2N4(ICC:ICC)= CHAR(4:4)
            ENDIF
C            LINE_SS2(ICC:ICC)= SS2(II)
            IF(SS2(II).EQ.1) THEN
              SS = 'H'
            ELSE IF(SS2(II).EQ.2) THEN
              SS = 'h'
            ELSE IF(SS2(II).EQ.3) THEN
              SS = 'B'
            ELSE IF(SS2(II).EQ.4) THEN
              SS = 'b'
            ELSE
              SS = ' '
            ENDIF
            LINE_SS2(ICC:ICC)= SS

            SS = ' '
            IF(SURF2(II).GT.0) THEN
              WRITE(SS,'(I1)') SURF2(II)
            ENDIF
            LINE_SURF2(ICC:ICC)= SS

          ENDDO
        ENDIF
      ELSE IF(JSE.EQ.KC) THEN
        IF(ISE.LT.NC)THEN
            DO     II=ISE+1,NC
            IF(ICC.GE.50)THEN
              CALL WRIT3(MDOC,LINE,NAM1,NAM2,LINE1,LINE2,LINE3
     *        ,LINE_1N1,LINE_1N2,LINE_1N3,LINE_1N4,LINE_SS1,LINE_SURF1
     *        ,LS1,LS2,LS3,LS4,LS5
     *        ,LINE_2N1,LINE_2N2,LINE_2N3,LINE_2N4,LINE_SS2,LINE_SURF2)
              ICC=0
            ENDIF
            ICC = ICC + 1
            IC  = IC  + 1

            LINE2(ICC:ICC)    =' '
            LINE_2N1(ICC:ICC) =' '
            LINE_2N2(ICC:ICC) =' '
            LINE_2N3(ICC:ICC) =' '
            LINE_2N4(ICC:ICC) =' '
            LINE_SS2(ICC:ICC) =' '
            LINE_SURF2(ICC:ICC)= ' '

            N1               = NSEQ1(II)
            LINE(ICC:ICC)    = AMIN(N1)

C            ICHS             = STR1(II)
C            LINE1(ICC:ICC)   = CHS(2:2)
            LINE1(ICC:ICC)   = ' '

            LINE_1N1(ICC:ICC) =' '
            LINE_1N2(ICC:ICC) =' '
            LINE_1N3(ICC:ICC) =' '
            LINE_1N4(ICC:ICC) =' '
            IF(N1.LT.24) THEN
              WRITE(CHAR,'(I4)') IRES1(II)
              LINE_1N1(ICC:ICC)= CHAR(1:1)
              LINE_1N2(ICC:ICC)= CHAR(2:2)
              LINE_1N3(ICC:ICC)= CHAR(3:3)
              LINE_1N4(ICC:ICC)= CHAR(4:4)
            ENDIF
C            LINE_SS1(ICC:ICC)= SS1(II)
            IF(SS1(II).EQ.1) THEN
              SS = 'H'
            ELSE IF(SS1(II).EQ.2) THEN
              SS = 'h'
            ELSE IF(SS1(II).EQ.3) THEN
              SS = 'B'
            ELSE IF(SS1(II).EQ.4) THEN
              SS = 'b'
            ELSE
              SS = ' '
            ENDIF
            LINE_SS1(ICC:ICC)= SS
            SS = ' '
            IF(SURF1(II).GT.0) THEN
              WRITE(SS,'(I1)') SURF1(II)
            ENDIF
            LINE_SURF1(ICC:ICC)= SS

            LS1(ICC:ICC)=      ' '
            LS2(ICC:ICC)=      ' '
            LS3(ICC:ICC)=      ' '
            LS4(ICC:ICC)=      ' '
            LS5(ICC:ICC)=      ' '

          ENDDO
        ENDIF
      ELSE
      ENDIF

      CALL WRIT3(MDOC,LINE,NAM1,NAM2,LINE1,LINE2,LINE3
     *  ,LINE_1N1,LINE_1N2,LINE_1N3,LINE_1N4,LINE_SS1,LINE_SURF1
     *        ,LS1,LS2,LS3,LS4,LS5
     *  ,LINE_2N1,LINE_2N2,LINE_2N3,LINE_2N4,LINE_SS2,LINE_SURF2)

      WRITE(DLINE,
     *'('' ------------------------------------------------'')')
      CALL MSGDOC(MDOC,DLINE)
      NC1 = RESULT(1)
      WRITE(DLINE,'('' NUMBER OF AMINO ACIDS IN 1-ST SEQ='',I5)')NC1
      CALL MSGDOC(MDOC,DLINE)
      KC1 = RESULT(2)
      WRITE(DLINE,'('' NUMBER OF AMINO ACIDS IN 2-ND SEQ='',I5)')KC1
      CALL MSGDOC(MDOC,DLINE)
      NN = RESULT(3)
      WRITE(DLINE,'('' NUMBER OF ALIGNED AMINO ACIDS    ='',I5)')NN
      CALL MSGDOC(MDOC,DLINE)
      NHOM = RESULT(4)
      WRITE(DLINE,'('' NUMBER OF IDENTICAL AMINO ACIDS  ='',I5)')NHOM
      CALL MSGDOC(MDOC,DLINE)
      HOM = RESULT(5)
      WRITE(DLINE,'('' IDENTITY                         ='',F8.3)')HOM
      CALL MSGDOC(MDOC,DLINE)
      SUM_SCORE = RESULT(6)
      WRITE(DLINE,'('' <SCORE>                          ='',F8.3)') 
     * SUM_SCORE 
      CALL MSGDOC(MDOC,DLINE)
      SCORE1_MAX = RESULT(13)
      WRITE(DLINE,'('' <SCORE_MAX> (for 1-st seq)       ='',F8.3)') 
     * SCORE1_MAX
      CALL MSGDOC(MDOC,DLINE)
      SCORE_MIN   = RESULT(14)
      WRITE(DLINE,'('' <SCORE_MIN> (for 1-st seq)       ='',F8.4)') 
     * SCORE_MIN
      CALL MSGDOC(MDOC,DLINE)
      SCORE_NEW = RESULT(18)
      WRITE(DLINE,'('' <SCORE_NEW>                      ='',F8.3)') 
     * SCORE_NEW
      CALL MSGDOC(MDOC,DLINE)
      FIDENT_NEW = RESULT(19)
      WRITE(DLINE,'('' IDENT_NEW                        ='',F8.3)') 
     * FIDENT_NEW
      CALL MSGDOC(MDOC,DLINE)
      NGAP = RESULT(20) 
      WRITE(DLINE,'('' N_gap                            ='',I6)') 
     * NGAP
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,
     *'('' ------------------------------------------------'')')
      CALL MSGDOC(MDOC,DLINE)
C
      RETURN
      END

      SUBROUTINE READ_FASTA_SEQ_NEW(MDOC,CODE,NAME_IN
     *       ,ITEST,N,NMAX,ICH,PNUM
     *       ,NSEQ,IRES,ISS,ISSN,SURF,ICHAIN,IDOMAIN,IERR)
C --------------------------------------------------------
      CHARACTER CODE*4
      INTEGER NSEQ(NMAX),IRES(NMAX),ICHAIN(NMAX),IDOMAIN(NMAX)
      INTEGER ISS(NMAX),ISSN(NMAX),SURF(NMAX)
      CHARACTER PNUM(NMAX)*6
C  
C READ_FASTA_SEQ   read sequence which can be used for ALIGN.
C 
C      File with sequence is ASCII file:
C
C      !>prot_id
C      !# sequence 
C      !SVIGSDDRTRVTNTTAYPYRAIVHISSSIGSCTGWMIGPKTVATAGHCIY
C      !# this is comment
C      !    DTSSG--SFAGTATVSP   GRNGTSYPYG
C      !NRGTRITKEVFDNLTNWKNSAQ
C
C      If first symbol in the line is "#" it means the line is comments
C
C --------------------------------------------------------
      CHARACTER NAME_IN*(*)
      CHARACTER SS_FLAG*1,D3_FLAG*1 
c ----
      CHARACTER NAME*256,PATH*80,EXT*80,STR*256
      CHARACTER LINE*256,LINE_SS*256,LINE_SR*256
      CHARACTER STR_IN*256
      CHARACTER DB_FLAG*1,SS*1,SS_OLD*1,CHAIN*1
C      CHARACTER ACODE3(25)*3
      CHARACTER AMIN(25)*1
      CHARACTER CH1*1
C      CHARACTER CH3*3
C --
C      DATA ACODE3/'CYS','SER','THR','PRO','ALA','GLY','ASN','ASP' 
C     *           ,'GLU','GLN','HIS','ARG','LYS','MET','ILE','LEU' 
C     *           ,'VAL','PHE','TYR','TRP','UNK','ASX','GLX','===' 
C     *           ,'---'/
C  
c                1   2   3   4   5   6   7   8   9  10  11  12  13
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','=','-'/
c             14  15  16  17  18  19  20  21  22  23  24  25
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      CALL LENSTR_BL(NAME_IN,LEN)
      IF(LEN.LE.0.OR.NAME_IN(1:1).EQ.' '.OR.NAME_IN(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 200
      ENDIF
C -------------------------------
      DB_FLAG = 'N'
      DO I=1,10000 
        READ(IU,'(A)',ERR=500,END=800) STR_IN
        CALL LENSTR_BL(STR_IN,LENS)
        IF(LENS.GE.4.AND.STR_IN(1:4).EQ.'#SS:') THEN
          DB_FLAG = 'Y'
          GO TO 800
        ELSE IF(LENS.GE.4.AND.STR_IN(1:4).EQ.'#SR:') THEN
          DB_FLAG = 'y'
          GO TO 800
        ENDIF
      ENDDO
 800  CONTINUE
      CLOSE(IU)
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 200
      ENDIF
C --------------------------------
      ICH= 0
      IC = 0
      NC =-1
      N  = 0 
      NR = 0 
      NBAD = 0
      NX   = 0
      CODE = 'XXXX'
      CHAIN= 'A'
      IEND = 0
      LINE_SS = ' '
      LINE_SR = ' '
      SS_OLD  = ' '
      NSS     = 0
C ----------------
 400  CONTINUE

      IF(IC.GT.NC) THEN
        IF(IEND.GT.0) GO TO 600
        LINE = ' '
        READ(IU,'(A)',ERR=500,END=620) LINE
        GO TO 610
 620    CONTINUE
        IEND = 1
 610    CONTINUE
        IMODE = 1
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.LE.0) GO TO 400        
        CALL CHECK_LINE(IMODE,LINE)
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GT.0.AND.LINE(1:1).EQ.'>') THEN
          ICH = ICH + 1
          NR  = 0
          IF(ICH.EQ.1) THEN
            CODE = '?   '
            CHAIN = 'A'
            IF(LEN.GT.1) THEN
              DO L=2,LEN
                CODE(L-1:L-1) = LINE(L:L)
                IF(L.EQ.5) CHAIN = LINE(L:L)
                IF(L.GE.5) GO TO 400
              ENDDO
            ENDIF
          ENDIF
          GO TO 400
        ENDIF        
        IF(LEN.LE.0.OR.LINE(1:1).EQ.'#') GO TO 400        
        IC = 1
        NC = LEN
        IF(DB_FLAG.EQ.'Y') THEN
          LINE_SS = ' '
          READ(IU,'(A)',ERR=500,END=620) LINE_SS
          LINE_SR = ' '
          READ(IU,'(A)',ERR=500,END=620) LINE_SR
          IC = 5
        ENDIF
      ENDIF
      CH1 = LINE(IC:IC)
      IF(CH1.EQ.' ') THEN
        IC = IC + 1
        GO TO 400
      ENDIF

      DO  J=1,25
        IF(CH1.EQ.AMIN(J)) THEN
          GO TO 700
        ENDIF
      ENDDO
      J   = 26
 700  CONTINUE
      IF(J.EQ.22) J = 7
      IF(J.EQ.23) J = 8
      IF(J.EQ.21) J = 25
      IF(J.GE.1.AND.J.LE.25) THEN
        N  = N  + 1
        IF(ITEST.LE.0) THEN
          IF(N.GT.NMAX) THEN
            WRITE(STR,'('' ERR: NUMBER OF RESIDUES >'',I8)') NMAX
            CALL MSGDOC(MDOC,STR) 
            IERR=1
            CLOSE(IU)
            RETURN
          ENDIF
C         IF(J.LE.21) NR = NR + 1
          NR = NR + 1
          NSEQ(N) = J
          IRES(N) = NR
          PNUM(N)(1:1) = CHAIN
          WRITE(PNUM(N)(2:5),'(I4)') NR
          PNUM(N)(6:6) = ' '
          IF(J.GE.24) IRES(N) = 0
          IF(ICH.LE.0) ICH = 1
          ICHAIN(N) = ICH
          SURF(N) = 0
          ISSN(N) = 0
          ISS (N) = 0
          IDOMAIN(N) = 0
          IF(J.EQ.21) THEN
            NX = NX + 1
          ENDIF
        ENDIF
      ELSE
        NBAD = NBAD + 1
        WRITE(STR,
     *  '('' WARNING: bad residue <'',A,''>'')') CH1
        CALL MSGDOC(MDOC,STR)
      ENDIF
      IF(DB_FLAG.EQ.'Y') THEN
        IF(J.GE.1.AND.J.LE.25) THEN
          SS  = LINE_SS(IC:IC) 
          CH1 = LINE_SR(IC:IC)
          READ(CH1,'(I1)') ISURF_N
          IF(SS.NE.' '.AND.SS.NE.SS_OLD) NSS = NSS + 1
          IF(SS.NE.' ') THEN 
            ISSN_N = NSS
            ISS_N = 0
            IF(SS.EQ.'H') THEN
              ISS_N = 1
            ELSE IF(SS.EQ.'h') THEN
              ISS_N = 2
            ELSE IF(SS.EQ.'B') THEN
              ISS_N = 3
            ELSE IF(SS.EQ.'b') THEN
              ISS_N = 4
            ENDIF
          ELSE
            ISS_N  = 0
            ISSN_N = 0
          ENDIF
          IF(ITEST.LE.0) THEN
            SURF(N) = ISURF_N
            ISSN(N) = ISSN_N
            ISS (N) = ISS_N
          ENDIF
          SS_OLD = SS
        ENDIF
      ENDIF
      IC = IC + 1
      GO TO 400
C --------------
 600  CONTINUE
      CLOSE(IU)
      WRITE(LINE,'('' Number of residues     :'',I8)') N
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Number of bad residues :'',I8)') NBAD
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Number of X residues   :'',I8)') NX
      CALL MSGDOC(MDOC,LINE)
      IF(N.LE.0) THEN
        CALL MSGERR(MDOC,' Number of residues in sequence = 0')
        IERR = 1
      ENDIF
      RETURN
C ----------------
 200  CONTINUE
      LINE = ' ERROR: cannot open file sequence'
      CALL MSGERR(MDOC,LINE)
      GO TO 900
 300  CONTINUE
      LINE = ' ERROR: DB: end of input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU) 
      GO TO 900
 500  CONTINUE
      LINE = ' ERROR: reading input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU) 
      GO TO 900
C ----------------
 900  CONTINUE
      IERR = 1
      RETURN
      END

      SUBROUTINE ALIGNMENT3(MDOC
     *  ,AMATRIX,AMAT,D3_FLAG,SS_FLAG
     *  ,OPENI,DPENI,PENEXI
     *  ,NC,KC
     *  ,ISS1,ISS2,SURF1,SURF2,NSEQ1,NSEQ2
     *  ,IRES1,IRES2,ICHAIN1,ICHAIN2
     *  ,NPAIR,IPAIR,SCORE1,SCORE2
     *  ,NMAX1,NMAX2,NMAX12,RESULT,IERR)
C -------------------------------------
      REAL      RESULT(*)
      CHARACTER D3_FLAG*1,SS_FLAG*1
      REAL      AMATRIX(NMAX1,NMAX2)
      REAL      AMAT(25,25)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IPAIR(2,NMAX12),ICHAIN1(NMAX1),ICHAIN2(NMAX2)
      INTEGER   IRES1(NMAX1),IRES2(NMAX2),ISS1(NMAX1),ISS2(NMAX2)
      REAL      SCORE1(NMAX12),SCORE2(NMAX12)
      INTEGER   SURF1(NMAX1),SURF2(NMAX2)
C     INTEGER   ITRACE(2,NMAX1,NMAX2)
C     REAL      AMAX_K(NMAX1)
C     INTEGER   KK_MAX(NMAX1)

      integer,   allocatable :: ITRACE(:,:,:)
      real,      allocatable :: AMAX_K(:)
      integer,   allocatable :: KK_MAX(:)

      CHARACTER LINE*256
C ================================================================
      IERR   = 0
      NPAIR  = 0
      WRITE(LINE,'('' PENALTY O,E :'',2F8.3)') OPENI,PENEXI
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' "0"         :'',F8.3)') DPENI
      CALL MSGDOC(MDOC,LINE)

      allocate(ITRACE(1:2,1:NMAX1,1:NMAX2),STAT=ISTAT)
      allocate(AMAX_K(1:NMAX1),STAT=ISTAT)
      allocate(KK_MAX(1:NMAX1),STAT=ISTAT)

C ------------
c     weight by surf 
      DO N=1,NC
      DO K=1,KC
        T = AMATRIX(N,K)
C        IF(ICHAIN1(N).EQ.ICHAIN2(K)) THEN
          W = 1.0
          IF(D3_FLAG.EQ.'Y') THEN
            SRF1 = SURF1(N)
            IF(SRF1.LT.0) SRF1 = 9
            IF(SRF1.GT.0) THEN
              TT = SQRT(REAL(SRF1))
              TT = SQRT(TT)
              W = 1.0/SQRT(TT)
              T = T*W
            ENDIF   
            SRF2 = SURF2(K)
            IF(SRF2.LT.0) SRF2 = 9
            IF(SRF2.GT.0) THEN
              TT = SQRT(REAL(SRF2))
              TT = SQRT(TT)
              W = 1.0/SQRT(TT)
              T = T*W
            ENDIF   
          ENDIF
C        ELSE
C          T = 0.0
C        ENDIF
        AMATRIX(N,K) = T
      ENDDO
      ENDDO
C ----
      CALL ALIGN_NW(MDOC,AMATRIX,SS_FLAG
     *  ,OPENI,PENEXI,DPENI
     *  ,NC,KC,ISS1,ISS2,NSEQ1,NSEQ2
     *  ,AMAX_K,KK_MAX
     *  ,NPAIR,IPAIR,ITRACE,NMAX1,NMAX2,NMAX12)
C      CALL ALIGN_2_NW(MDOC,AMATRIX,SS_FLAG
C     *  ,OPENI,PENEXI,DPENI
C     *  ,NC,KC,ISS1,ISS2,NSEQ1,NSEQ2
C     *  ,NPAIR,IPAIR,ITRACE,NMAX1,NMAX2,NMAX12)
      IF(NPAIR.LE.0) THEN
        CALL MSGERR(MDOC,'ERROR: NPAIR = 0')
        IERR = 1
        GO TO 900
      ENDIF
C ----

      CALL CALC_SCORE(NC,KC,NSEQ1,NSEQ2,SCORE1,SCORE2
     * ,NPAIR,IPAIR
     * ,NMAX1,NMAX2,NMAX12,AMAT
     * ,NC1,KC1,NN,NHOM,HOM
     * ,SUM_SCORE,SCORE1_MAX,SCORE_MIN,SCORE_SIGMA
     * ,FIDENT_NEW,DPENI)

      NGAP   = 0
      DO IPR=2,NPAIR 
        ISE = IPAIR(1,IPR-1) 
        JSE = IPAIR(2,IPR-1)
        I1  = IPAIR(1,IPR)
        J1  = IPAIR(2,IPR)
        IF(I1-ISE.GT.1.OR.J1-JSE.GT.1) THEN
          IGAP = 0
          IF(I1-ISE.LE.1.AND.J1-JSE.GT.1) THEN
            DO II=JSE+1,J1-1
              IN2 = NSEQ2(II)
C                      '=' '-'
              IF(IN2.LT.24) IGAP = 1
            ENDDO
          ELSE IF(I1-ISE.GT.1.AND.J1-JSE.LE.1) THEN
            DO II=ISE+1,I1-1
              IN1 = NSEQ1(II)
C                      '=' '-'
              IF(IN1.LT.24) IGAP = 1
            ENDDO
          ELSE
          ENDIF

          IF(IGAP.GT.0) NGAP = NGAP + 1 

        ENDIF
      ENDDO

      WRITE(LINE,
     *'('' ------------------------------------------------'')')
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' NUMBER OF AMINO ACIDS IN 1-ST SEQ='',I5)')NC1
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' NUMBER OF AMINO ACIDS IN 2-ND SEQ='',I5)')KC1
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' NUMBER OF ALIGNED AMINO ACIDS    ='',I5)')NN
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' NUMBER OF IDENTICAL AMINO ACIDS  ='',I5)')NHOM
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' IDENTITY                         ='',F8.3)')HOM
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' <SCORE>                          ='',F8.3)') 
     * SUM_SCORE
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' <SCORE_MAX> (for 1-st seq)       ='',F8.3)') 
     * SCORE1_MAX
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' <SCORE_MIN> (for 1-st seq),sig   ='',2F8.4)') 
     * SCORE_MIN,SCORE_SIGMA
      CALL MSGDOC(MDOC,LINE)

      SCORE1_MIN = SCORE_MIN       
      IF(SUM_SCORE.LT.SCORE1_MIN) SCORE1_MIN = SUM_SCORE 
      D = SCORE1_MAX - SCORE1_MIN
      SCR = 1.0
      IF(D.GT.0.01) THEN
        SCR = (SUM_SCORE-SCORE1_MIN)/(SCORE1_MAX-SCORE1_MIN)
      ENDIF
      WRITE(LINE,'('' <SCORE_NEW>                      ='',F8.3)') 
     * SCR
      CALL MSGDOC(MDOC,LINE)
      SCORE_NEW = SCR
      WRITE(LINE,'('' IDENT_NEW                        ='',F8.3)') 
     * FIDENT_NEW
      WRITE(LINE,'('' N_gap                            ='',I6)') 
     * NGAP
      CALL MSGDOC(MDOC,LINE)

      WRITE(LINE,
     *'('' ------------------------------------------------'')')
      CALL MSGDOC(MDOC,LINE)
C ---
      RESULT(1) = NC1
      RESULT(2) = KC1
      RESULT(3) = NN
      RESULT(4) = NHOM
      RESULT(5) = HOM
      RESULT(6) = SUM_SCORE 
      RESULT(13) = SCORE1_MAX 
      RESULT(14) = SCORE_MIN 
      RESULT(18) = SCORE_NEW
      RESULT(19) = FIDENT_NEW
      RESULT(20) = NGAP
C ---

 900  CONTINUE

      deallocate(ITRACE,STAT=ISTAT)
      deallocate(AMAX_K,STAT=ISTAT)
      deallocate(KK_MAX,STAT=ISTAT)

      RETURN
      END

      SUBROUTINE ALIGN_NW(MDOC,AMATRIX,SS_FLAG
     *  ,OPENI,PENEXI,DPENI
     *  ,NC,KC,ISS1,ISS2,NSEQ1,NSEQ2
     *  ,AMAX_K,KK_MAX
     *  ,NPAIR,IPAIR,ITRACE,NMAX1,NMAX2,NMAX12)
C -------------------------------------
      CHARACTER SS_FLAG*1
      REAL      AMATRIX(NMAX1,NMAX2)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IPAIR(2,NMAX12)
      INTEGER   IRES1(NMAX1),IRES2(NMAX2),ISS1(NMAX1),ISS2(NMAX2)
      INTEGER   ITRACE(2,NMAX1,NMAX2)
      REAL      AMAX_K(NMAX1)
      INTEGER   KK_MAX(NMAX1)
C ================================================================

C -------
C  1   -----------
C      !          !
C  K   !     *    !        A_NK
C      !          !             A_K1N1 --> NN (N+2..NC)
C  KC  -----------                 !
C      1     N    NC               V
C                                 KK
C ----------------------       (K+2,KC)
      AM_MAX = -1000.0
      NMAX = 0
      KMAX = 0
      NP   = 0
      DO N=1,NC
      DO K=1,KC
        ITRACE(1,N,K) = 0
        ITRACE(2,N,K) = 0
      ENDDO
      ENDDO
      
C      WRITE(*,*)'SS_FLAG',SS_FLAG
C      write(*,'(''SS1'',100(2x,i2,1x))') (ISS1(i),i=1,nc)
C      write(*,'(''SS2'',100(2x,i2,1x))') (ISS2(i),i=1,KC)
C      write(*,'(3x,100(2x,i2,1x))') (nseq1(i),i=1,nc)
C      do i=1,kc
C        write(*,'(i2,a,100(f5.2))')
C     *  NSEQ2(i),':',(amatrix(j,i),j=1,nc)
C      enddo

      IF(ABS(PENEXI).LT.0.001) THEN

        DO I=1,NC
          KK_MAX(I) = 0
        ENDDO

        DO K=KC-1,1,-1

          IF(NSEQ2(K).GE.24) GO TO 300  
          K1 = K + 1
          DO L=K1,KC
            IF(NSEQ2(L).LT.24) GO TO 310            
          ENDDO
          GO TO 300
  310     CONTINUE
          NOPEN_K = 1
          IF(K1.EQ.L) NOPEN_K = 0
          K1 = L

          NN_MAX = 0
          DO N=NC-1,1,-1

            IF(NSEQ1(N).GE.24) GO TO 400  
            N1 = N + 1
            DO L=N1,NC
              IF(NSEQ1(L).LT.24) GO TO 410            
            ENDDO
            GO TO 400
  410       CONTINUE
            NOPEN_N = 1
            IF(N1.EQ.L) NOPEN_N = 0
            N1 = L

            AMAX = AMATRIX(N1,K1)
            NT   = N1
            KT   = K1

            OPENI_N  = OPENI 
            IUSE = 1
            IF((SS_FLAG.EQ.'Y').AND.
     *         (ISS2(K).NE.0.AND.ISS2(K1).NE.0.AND.
     *          ISS2(K).EQ.ISS2(K1))) IUSE = 0
            IF(NOPEN_K.GT.0) THEN
              OPENI_N  = 0.0 
              IUSE = 1
            ENDIF
            IF(IUSE.GT.0) THEN  
              IF(N1.LT.NC) THEN
                AMAX_N = -2000.0
                DO NN=N1+1,NC
                  IF(NSEQ1(NN).LT.24) THEN
                    PEN = OPENI_N 
                    A = AMATRIX(NN,K1) - PEN
                    IF(NN_MAX.GT.0) THEN
                      IF(A.GT.AMAX_N) THEN
                        AMAX_N = A
                        NN_MAX = NN
                      ENDIF        
                    ELSE
                      AMAX_N  = A
                      NN_MAX  = NN
                    ENDIF
                    GO TO 320
                  ENDIF
                ENDDO
  320           CONTINUE
                IF(AMAX_N.GT.AMAX) THEN
                  AMAX = AMAX_N
                  NT   = NN_MAX
                  KT   = K1
                ENDIF

              ENDIF
            ENDIF

            OPENI_K  = OPENI 
            IUSE = 1
            IF((SS_FLAG.EQ.'Y').AND.
     *         (ISS1(N).NE.0.AND.ISS1(N1).NE.0.AND.
     *          ISS1(N).EQ.ISS1(N1))) IUSE = 0
            IF(NOPEN_N.GT.0) THEN
              OPENI_K  = 0.0 
              IUSE = 1
            ENDIF

            IF(IUSE.GT.0) THEN  
              IF(K1.LT.KC) THEN
                AMAX_K(N1) = -2000.0
                DO KK=K1+1,KC
                  IF(NSEQ2(KK).LT.24) THEN
                    PEN = OPENI_K 
                    A = AMATRIX(N1,KK) - PEN
                    IF(KK_MAX(N1).GT.0) THEN
                      IF(A.GT.AMAX_K(N1)) THEN
                        AMAX_K(N1) = A
                        KK_MAX(N1) = KK
                      ENDIF        
                    ELSE
                      AMAX_K(N1) = A
                      KK_MAX(N1) = KK
                    ENDIF
                    GO TO 330 
                  ENDIF
                ENDDO
  330           CONTINUE
                IF(AMAX_K(N1).GT.AMAX) THEN
                  NT   = N1
                  AMAX = AMAX_K(N1)
                  KT   = KK_MAX(N1)
                ENDIF
              ENDIF
            ENDIF

            AMATRIX(N,K)  = AMATRIX(N,K) + AMAX
            ITRACE(1,N,K) = NT
            ITRACE(2,N,K) = KT
            IF(AMATRIX(N,K).GT.AM_MAX) THEN
              AM_MAX = AMATRIX(N,K)
              NMAX = N
              KMAX = K
              NP = NP + 1
            ENDIF

  400       CONTINUE
          ENDDO

  300     CONTINUE
        ENDDO

      ELSE

        DO I=1,NC
          KK_MAX(I) = KC
        ENDDO

        DO K=KC-1,1,-1

          IF(NSEQ2(K).GE.24) GO TO 1300  
          K1 = K + 1
          NEXTN_K = 0
          DO L=K1,KC
            IF(NSEQ2(L).EQ.24) NEXTN_K = 1
            IF(NSEQ2(L).LT.24) GO TO 1310            
          ENDDO
          GO TO 1300
 1310     CONTINUE
          NOPEN_K = 1

          IF(K1.EQ.L) NOPEN_K = 0
          K1 = L

          NN_MAX = NC
          DO N=NC-1,1,-1

            IF(NSEQ1(N).GE.24) GO TO 1400  
            N1 = N + 1
            NEXTN_N = 0
            DO L=N1,NC
              IF(NSEQ1(L).EQ.24) NEXTN_N = 1
              IF(NSEQ1(L).LT.24) GO TO 1410            
            ENDDO
            GO TO 1400
 1410       CONTINUE
            NOPEN_N = 1
            IF(N1.EQ.L) NOPEN_N = 0
            N1 = L

            AMAX = AMATRIX(N1,K1)
            NT   = N1
            KT   = K1

            OPENI_N  = OPENI 
            PENEXI_N = PENEXI
            IUSE = 1
            IF((SS_FLAG.EQ.'Y').AND.
     *         (ISS2(K).NE.0.AND.ISS2(K1).NE.0.AND.
     *          ISS2(K).EQ.ISS2(K1))) IUSE = 0
            IF(NOPEN_K.GT.0) THEN
              OPENI_N  = 0.0 
              PENEXI_N = 0.0
              IF(NEXTN_K.GT.0) PENEXI_N = 0.0
              IUSE = 1
            ENDIF
            IF(IUSE.GT.0) THEN  
              IF(N1.LT.NC) THEN
                IDN    = 0
                AMAX_N = -2000.0
                N_MAX  = NN_MAX
                DO NN=N1+1,N_MAX
                  IF(NSEQ1(NN).LT.24) THEN
                    IDN = IDN + 1
                    PEN = OPENI_N + REAL(IDN)*PENEXI_N
                    A   = AMATRIX(NN,K1) - PEN
                    IF(A.GT.AMAX_N) THEN
                      AMAX_N    = A
                      NN_MAX    = NN
                    ENDIF        
                  ENDIF
                ENDDO
                IF(AMAX_N.GT.AMAX) THEN
                  AMAX = AMAX_N
                  NT   = NN_MAX
                  KT   = K1
                ENDIF

              ENDIF
            ENDIF

            OPENI_K  = OPENI 
            PENEXI_K = PENEXI
            IUSE = 1
            IF((SS_FLAG.EQ.'Y').AND.
     *         (ISS1(N).NE.0.AND.ISS1(N1).NE.0.AND.
     *          ISS1(N).EQ.ISS1(N1))) IUSE = 0
            IF(NOPEN_N.GT.0) THEN
              OPENI_K  = 0.0 
              IF(NEXTN_N.GT.0) PENEXI_K = 0.0
              IUSE = 1
            ENDIF

            IF(IUSE.GT.0) THEN  
              IF(K1.LT.KC) THEN
                IDK   = 0
                K_MAX      = KK_MAX(N1)
                AMAX_K(N1) = -2000.0
                DO KK=K1+1,K_MAX
                  IF(NSEQ2(KK).LT.24) THEN
                    IDK  = IDK + 1
                    PEN = OPENI_K + REAL(IDK)*PENEXI_K
                    A   = AMATRIX(N1,KK) - PEN
                    IF(A.GT.AMAX_K(N1)) THEN
                      AMAX_K(N1)    = A
                      KK_MAX(N1)    = KK
                    ENDIF        
                  ENDIF
                ENDDO
                IF(AMAX_K(N1).GT.AMAX) THEN
                  NT   = N1
                  AMAX = AMAX_K(N1)
                  KT   = KK_MAX(N1)
                ENDIF
              ENDIF
            ENDIF

            AMATRIX(N,K)  = AMATRIX(N,K) + AMAX
            ITRACE(1,N,K) = NT
            ITRACE(2,N,K) = KT
            IF(AMATRIX(N,K).GT.AM_MAX) THEN
              AM_MAX = AMATRIX(N,K)
              NMAX = N
              KMAX = K
              NP = NP + 1
            ENDIF

 1400       CONTINUE
          ENDDO

 1300     CONTINUE
        ENDDO

      ENDIF
C ----------------------
C     trace back
      NPAIR = 0
      IF(NP.LE.0) RETURN
      NPAIR = 1
      IPAIR(1,NPAIR) = NMAX
      IPAIR(2,NPAIR) = KMAX
      K = KMAX
      N = NMAX

C      write(*,*) '--nmax,kmax:',nmax,kmax
C      write(*,'(3x,100(2x,i2,1x))') (nseq1(i),i=1,nc)
C      do i=1,kc
C        write(*,'(i2,a,100(f5.2))')
C     *  NSEQ2(i),':',(amatrix(j,i),j=1,nc)
C      enddo
C      write(*,*) '--trace:'
C      write(*,'(3x,100(2x,i2,1x))') (nseq1(i),i=1,nc)
C      do i=1,kc
C        write(*,'(i2,a,100(1X,2I2))')
C     *  NSEQ2(i),':',(ITRACE(1,j,i),ITRACE(2,j,i),j=1,nc)
C      enddo

C ----
 100  CONTINUE
      NT = ITRACE(1,N,K)
      KT = ITRACE(2,N,K) 
      IF(NT.LE.0.OR.KT.LE.0) GO TO 200
      NPAIR = NPAIR + 1
      IPAIR(1,NPAIR) = NT
      IPAIR(2,NPAIR) = KT
      N = NT
      K = KT
      GO TO 100
C ----
 200  CONTINUE
C ----
      RETURN
      END

      SUBROUTINE DEF_SCORE_MIN(NN,NPAIR,NC,KC
     *  ,NSEQ1,NSEQ2,IPAIR,AMAT,NMAX1,NMAX2,NMAX12
     *  ,SCORE_MIN,SCORE_SIGMA)
C -------------------------------
      REAL      AMAT(25,25)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IPAIR(2,NMAX12)
      integer,   allocatable :: ICOPY(:)
C -------------------------------

      allocate(ICOPY(1:NMAX12),STAT=ISTAT)


      SCORE_MIN   = 0.0
      SCORE_SIGMA = 0.0
      IF(NN.LE.0) RETURN
      NCYCLE    = 30
      S  = 0.0
      S2 = 0.0
      NH = 0
      INIT = 0
      DO IC=1,NCYCLE
        S_MIN = 0.0
        NP    = 0
        DO I=1,NPAIR 
          ICOPY(I) = IPAIR(2,I) 
        ENDDO
        N2 = NPAIR           
        DO I=1,NPAIR             
          N = IPAIR(1,I)
          NAA1 = NSEQ1(N)
          IF(NAA1.LT.24) THEN
            III = 0
  100       CONTINUE
c           CALL HSRD(A)
            CALL HSRD_TIME(A,NH,INIT)
C -P- HSRD - gives A - random variable / -0.5 =< A =< 0.5 /
            III = III + 1
            IF(III.GT.100) GO TO 200
            A = A + 0.5
            AK = A*REAL(NPAIR) + 1.0         
            K  = AK
            IF(K.LT. 1) K = 1
            IF(K.GT.NPAIR) K = NPAIR
            KK = ICOPY(K)
            NAA2 = NSEQ2(KK)
            IF(NAA2.GE.24) GO TO 100
            S_MIN = S_MIN + AMAT(NAA1,NAA2)
            NP = NP + 1
            IF(K.LT.N2) THEN
              DO J=K,N2-1
                ICOPY(J) = ICOPY(J+1)
              ENDDO
            ENDIF
            N2 = N2 - 1
            IF(N2.LE.0) GO TO 300
  200       CONTINUE
          ENDIF
        ENDDO
  300   CONTINUE
        IF(NP.GT.0) THEN
          S_MIN = S_MIN/REAL(NP)
        ENDIF
        S  = S +  S_MIN
        S2 = S2 + S_MIN*S_MIN
      ENDDO
      S  = S/REAL(NCYCLE)
      S2 = S2/REAL(NCYCLE)
      SCORE_SIGMA = SQRT(ABS(S2-S*S))
      SCORE_MIN   = S

      deallocate(ICOPY,STAT=ISTAT)

      RETURN
      END

      SUBROUTINE CALC_SCORE(NC,KC,NSEQ1,NSEQ2,SCORE1,SCORE2
     * ,NPAIR,IPAIR
     * ,NMAX1,NMAX2,NMAX12,AMAT
     * ,NC1,KC1,NN,NHOM,HOM
     * ,SUM_SCORE,SCORE1_MAX,SCORE_MIN,SCORE_SIGMA
     * ,FIDENT_NEW,DPENI)
C -------------------------------------------------------------
      REAL      AMAT(25,25)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IPAIR(2,NMAX12)
      REAL      SCORE1(*),SCORE2(*)
C ================================================================
      SUM_SCORE = 0.0
      NHOM      = 0
      NN        = 0
      NC1       = 0
      KC1       = 0
      SCORE1_MAX= 0.0
      SCORE_MIN = 0.0
      SUM_F     = 0.0
      SUM_F_MAX = 0.0
      FIDENT_NEW = 0.0 
      DO I=1,NC
        IF(NSEQ1(I).LT.24) NC1 = NC1 + 1
        SCORE1(I) = 0.0
      ENDDO             
      DO I=1,KC
        IF(NSEQ2(I).LT.24) KC1 = KC1 + 1
        SCORE2(I) = 0.0
      ENDDO             
      DO I=1,NPAIR             
        N = IPAIR(1,I)
        K = IPAIR(2,I)
        NAA1 = NSEQ1(N)
        NAA2 = NSEQ2(K)
        IF(NAA1.LT.24.AND.NAA2.LT.24) THEN
          NN  = NN+1
          IF(NAA1.EQ.NAA2)THEN
            NHOM = NHOM + 1
          ENDIF
          S = AMAT(NAA1,NAA2)
          SCORE1(N) = S
          SCORE2(K) = S
          SUM_SCORE = SUM_SCORE + S
          T = S - DPENI
          IF(T.GT.0) THEN
            SUM_F = SUM_F + T
          ENDIF 
          S = AMAT(NAA1,NAA1)
          SCORE1_MAX = SCORE1_MAX + S
          T = S - DPENI
          IF(T.GT.0) THEN
            SUM_F_MAX = SUM_F_MAX + T
          ENDIF 
        ENDIF
      ENDDO
C ----
      HOM = 0.0    
      IF(NN.GT.0) THEN
        SUM_SCORE  = SUM_SCORE/REAL(NN)
        HOM        = (REAL(NHOM)/REAL(NN))*100.0
        SCORE1_MAX = SCORE1_MAX/REAL(NN)
        SUM_F      = SUM_F/REAL(NN)
        SUM_F_MAX  = SUM_F_MAX/REAL(NN)
        FIDENT_NEW = (SUM_F/SUM_F_MAX)*100.0
      ENDIF
      CALL DEF_SCORE_MIN(NN,NPAIR,NC,KC
     *  ,NSEQ1,NSEQ2,IPAIR,AMAT,NMAX1,NMAX2,NMAX12
     *  ,SCORE_MIN,SCORE_SIGMA)

      IF(SUM_SCORE.LT.SCORE_MIN) SCORE_MIN = SUM_SCORE 
C ---
      RETURN
      END

      SUBROUTINE SMOOTH_SCORE_DB(MDOC,DPENI
     *  ,NC,KC,NSEQ1,NSEQ2,SCORE1,SCORE2,NPAIR,IPAIR
     *  ,NMAX1,NMAX2,NMAX12,IERR)
C -----------------------------------------------
      INTEGER   MDOC,IERR
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IPAIR(2,NMAX12)
      REAL      SCORE1(NMAX12),SCORE2(NMAX12)
C ----------------------------------------------------------------
      DO I=1,NC
        SCORE2(I) = SCORE1(I)
      ENDDO
      DO IPR=1,NPAIR 
        I   = IPAIR(1,IPR) 
        J   = IPAIR(2,IPR)
        IN1 = NSEQ1(I)
        IN2 = NSEQ2(J)
        IF(IN1.LT.24.AND.IN2.LT.24) THEN
          NS  = 1
          SUM = SCORE2(I)
        ELSE
          SUM = 0.0
          NS  = 0
        ENDIF
        IF(IPR.GT.1) THEN
          IM1 = IPAIR(1,IPR-1)
          JM1 = IPAIR(2,IPR-1)
          IF(I-IM1.EQ.1.AND.J-JM1.EQ.1) THEN
            IN1 = NSEQ1(IM1)
            IN2 = NSEQ2(JM1)
            IF(IN1.LT.24.AND.IN2.LT.24) THEN
              NS  = NS + 1
              SUM = SUM + SCORE2(IM1)
            ENDIF
            IF(IPR.GT.2) THEN
              IM2 = IPAIR(1,IPR-2)
              JM2 = IPAIR(2,IPR-2)
              IF(IM1-IM2.EQ.1.AND.JM1-JM2.EQ.1) THEN
                IN1 = NSEQ1(IM2)
                IN2 = NSEQ2(JM2)
                IF(IN1.LT.24.AND.IN2.LT.24) THEN
                  NS  = NS + 1
                  SUM = SUM + SCORE2(IM2)
                ENDIF
              ENDIF
            ENDIF
          ENDIF
        ENDIF
        IF(IPR.LT.NPAIR) THEN
          IP1 = IPAIR(1,IPR+1)
          JP1 = IPAIR(2,IPR+1)
          IF(IP1-I.EQ.1.AND.JP1-J.EQ.1) THEN
            IN1 = NSEQ1(IP1)
            IN2 = NSEQ2(JP1)
            IF(IN1.LT.24.AND.IN2.LT.24) THEN
              NS  = NS + 1
              SUM = SUM + SCORE2(IP1)
            ENDIF
            IF(IPR.LT.NPAIR-1) THEN
              IP2 = IPAIR(1,IPR+2)
              JP2 = IPAIR(2,IPR+2)
              IF(IP2-IP1.EQ.1.AND.JP2-JP1.EQ.1) THEN
                IN1 = NSEQ1(IP2)
                IN2 = NSEQ2(JP2)
                IF(IN1.LT.24.AND.IN2.LT.24) THEN
                  NS  = NS + 1
                  SUM = SUM + SCORE2(IP2)
                ENDIF
              ENDIF
            ENDIF
          ENDIF
        ENDIF
        IF(NS.GT.0) THEN
          SUM = SUM/REAL(NS)
          SCORE1(I) = SUM
        ELSE
          SCORE1(I) = DPENI
        ENDIF
      ENDDO
      RETURN
      END

c==============================================================
      SUBROUTINE ALIGN_2_NW(MDOC,AMATRIX,SS_FLAG
     *  ,OPENI,PENEXI,DPENI
     *  ,NC,KC,ISS1,ISS2,NSEQ1,NSEQ2
     *  ,NPAIR,IPAIR,ITRACE,NMAX1,NMAX2,NMAX12)
C -------------------------------------
      REAL      AMATRIX(NMAX1,NMAX2)
      INTEGER   ITRACE(2,NMAX1,NMAX2)
      INTEGER   IPAIR(2,NMAX12)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   ISS1(NMAX1),ISS2(NMAX2)
      CHARACTER SS_FLAG*1
      INTEGER   NJO(2000)
      INTEGER   NTRAC(2000,2000)
      REAL      AMXOLD(2000),ACUR(2000)
     *         ,ACOL(2000),ACROLD(2000)
C ================================================================
      IERR  = 0
C ------------
      PENJJ = OPENI
      DPENI = 0.0
      PENEXI= 0.0
      DPENJ = 0.0
      PENEXJ= 0.0
      N2    = NSEQ2(KC)
      DO I=1,NC
        N1          = NSEQ1(I)
        AMXOLD(I)   = -1.0E30
        T = AMATRIX(I,KC)
        ACROLD(I)   = T
        ACUR(I)     = T
        NTRAC(I,KC) = 0
        NJO(I)      = KC
      ENDDO
      ACOL(KC) = ACUR(1)
      K1       = KC-1
      DO     I=1,KC
       NTRAC(NC,I) = 0
      ENDDO
C------------------------------------------------------------------
C     COMPARISON ROW-BY-ROW
C------------------------------------------------------------------
22    N1      = NSEQ1(NC)
      N2      = NSEQ2(K1)

      PENII   = OPENI

      T = AMATRIX(NC,K1)
      ACUR(NC)= T
      AMAX1   = -1.0E30
      IOLD    = NC
      IOLD1   = NC
      K11     = K1+1
      JOLD    = K11
      DO      I=NC-1,1,-1
        I11     = I+1
        N1      = NSEQ1(I)
        AOLD    = ACROLD(I11)
        AMXOLD1 = AMXOLD(I11)

        IF(SS_FLAG.EQ.'Y') THEN

        IF((ISS1(I ).EQ.0.OR.ISS1( I).NE.ISS1(I11)).AND. 
     *     (ISS2(K1).EQ.0.OR.ISS2(K1).NE.ISS2(K11))     ) THEN
          IF(AOLD.GE.AMAX1.AND.AOLD.GE.AMXOLD1) THEN
            AMX  = AOLD
            IOLD = I11
            JOLD = K11
          ELSEIF(AMAX1.GE.AMXOLD1)THEN
            AMX  = AMAX1
            JOLD = K11
            IOLD = IOLD1
          ELSE
            AMX  = AMXOLD1
            IOLD = I11
            JOLD = NJO(I11)
          ENDIF
        ELSE
          AMX  = AOLD
          IOLD = I11
          JOLD = K11
        ENDIF

        ELSE

          IF(AOLD.GE.AMAX1.AND.AOLD.GE.AMXOLD1) THEN
            AMX  = AOLD
            IOLD = I11
            JOLD = K11
          ELSEIF(AMAX1.GE.AMXOLD1)THEN
            AMX  = AMAX1
            JOLD = K11
            IOLD = IOLD1
          ELSE
            AMX  = AMXOLD1
            IOLD = I11
            JOLD = NJO(I11)
          ENDIF

        ENDIF

        III = IOLD-I
        JJJ = JOLD-K1
        IF(III.EQ.1)THEN
           NTRAC(I,K1) = 10000+JJJ
        ELSE
          NTRAC(I,K1) = III
        ENDIF

        T = AMATRIX(I,K1)

        ACUR(I) = T + AMX

        AMAX1   = AMAX1-PENEXI
        AOLD    = AOLD -PENII
        IF(AMAX1.LT.AOLD)THEN
          AMAX1 = AOLD
          IOLD1 = I11
          PENII = PENII+DPENI
        ENDIF
        AMXOLD1 = AMXOLD1-PENEXJ
        AOLD    = ACROLD(I11)-PENJJ
C        IF(AOLD.GT.AMXOLD1)THEN
        IF(AOLD.GE.AMXOLD1)THEN
          NJO(I11)    = K11
          AMXOLD(I11) = AOLD
          PENJJ       = PENJJ + DPENJ
        ELSE
          AMXOLD(I11) = AMXOLD1
        ENDIF
        ACROLD(I11) = ACUR(I11)
      ENDDO
      ACOL(K1) = ACUR(1)
      K1       = K1-1
      IF(K1.GE.1) GO TO 22
C ------------------------------

      IC  = 0
      ICC = 0
      JSE = 1
      ISE = 1
      AMX = ACOL(1)
      DO      I=1,KC
        IF(AMX.LT.ACOL(I)) THEN
          AMX = ACOL(I)
          JSE = I
          ISE = 1
        ENDIF
      ENDDO
      DO     I=2,NC
        IF(AMX.LT.ACUR(I)) THEN
          ISE = I
          JSE = 1
          AMX = ACUR(I)
        ENDIF
      ENDDO

C ------------------------------
      NN    = 0
      NPAIR = 0
C ---
      NN = NN+1
      IPAIR(1,NPAIR) = ISE
      IPAIR(2,NPAIR) = JSE
C----
  20  IF(NTRAC(ISE,JSE).LT.10000)THEN
        I1 = ISE + NTRAC(ISE,JSE)
        J1 = JSE + 1
      ELSE
        I1 = ISE + 1
        J1 = JSE + NTRAC(ISE,JSE)-10000
      ENDIF
      IF(NTRAC(ISE,JSE).EQ.0) GO TO 100

      JSE = J1
      ISE = I1
C ---
      NN    = NN  + 1
      NPAIR = NPAIR+1
      IPAIR(1,NPAIR)=ISE
      IPAIR(2,NPAIR)=JSE
      GO TO 20
C-----------------
100   CONTINUE
      RETURN
      END

      SUBROUTINE ALIGN_3_WRITE_PDB2_ALIGN(MDOC,NAMER,NAMEO
     *  ,NSEQ1,IRES1,IRES2,NSEQ2,PNUM1,PNUM2,NC,KC,WS_FLAG
     *  ,ATOM_INDEX,ATOM_NAME     
     *  ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR
     *  ,CHAIN,NAT,NRES,NAT_OCC,NRES_OCC
     *  ,ITRANS,RESULT,IPRROW,IERR)
C ------------------------------------------------
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IRES1(NMAX1),IRES2(NMAX2)
      INTEGER   IPAIR(2,NMAX12)
      CHARACTER PNUM1(NMAX2)*6,PNUM2(NMAX2)*6,WS_FLAG*1
      REAL      RESULT(IPRROW)
C -----
      CHARACTER ATOM_NAME(9)*2
      INTEGER   ATOM_INDEX(4,25)
C ---
      REAL      TR(3),TRMAT(3,3),X(3),Y(3)
      INTEGER   MDOC,IERR
      CHARACTER ANAME*4,CP_PNUM*6,PNUM22*6,PNUM_OLD*6
      CHARACTER ASYMB*4,CTYPE*4,RNAME*3
      CHARACTER ANAME_OLD*4,CP_ALT*1,CP_SEG*4
      CHARACTER NAMER*(*),NAMEO*(*)
      CHARACTER LINE*256,PATH*1,EXT*1,CH7*7,CH4*4,CH1*1
      CHARACTER CNAME*20,REC*4,CHAIN*1
      DATA CNAME/'ABCDEFGHIJKLMNOPRSTU'/
C                 123456789 123456789 
C ------------------------------------------------------------
      M     = 99
      MD    =-ABS(MDOC)-1
      IERR  = 0
C -------------------------------------------------------------------
      CALL CORR_NAME_BLC(NAMEO)
      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong output file name')
        IERR = 1
        RETURN
      ENDIF
      IOUT = 11
      EXT  = ' '
      PATH = ' '
      CALL OPENFW(IOUT,M,PATH,NAMEO,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open output file')
        RETURN
      ENDIF
c--------------------------------------
      CALL CORR_NAME_BLC(NAMER)
      CALL LENSTR_BL(NAMER,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        CLOSE(IOUT) 
        IERR = 1
        RETURN
      ENDIF
      INC  = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(INC,M,PATH,NAMER,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open input file')
        CLOSE(IOUT) 
        RETURN
      ENDIF
C -------------------------------------
      IF(ITRANS.GT.0.AND.IPRROW.GE.41) THEN
        TR(1)      = RESULT(30)
        TR(2)      = RESULT(31) 
        TR(3)      = RESULT(32) 
        TRMAT(1,1) = RESULT(33) 
        TRMAT(1,2) = RESULT(34) 
        TRMAT(1,3) = RESULT(35) 
        TRMAT(2,1) = RESULT(36) 
        TRMAT(2,2) = RESULT(37) 
        TRMAT(2,3) = RESULT(38) 
        TRMAT(3,1) = RESULT(39) 
        TRMAT(3,2) = RESULT(40) 
        TRMAT(3,3) = RESULT(41) 
        IF(ABS(TRMAT(1,1)).GT.0.0001.OR.
     *     ABS(TRMAT(2,2)).GT.0.0001.OR.
     *     ABS(TRMAT(3,3)).GT.0.0001    ) ITRANS = 1
        ITRANS = 0
      ENDIF
C -------------------------------------
      IF(CHAIN.EQ.' ') CHAIN = 'A'
      NCH    = 0
      CH1    = CHAIN
      IRES_OLD   = 100000
      IRES_2_OLD = 100000
      IPR    = 1
      IPR1   = IPAIR(1,IPR)
      IPR2   = IPAIR(2,IPR)
      ISEQ1  = NSEQ1(IPR1)
      IRES   = IRES1(IPR1)
c      CHAIN  = PNUM1(IPR1)(1:1)
      IRES_2 = IRES2(IPR2)
      ISEQ2  = NSEQ2(IPR2)
      PNUM22 = PNUM2(IPR2)
      IPR1_C = 1
      IFIRST = 0
      PNUM_OLD    = '?'
      ANAME_OLD   = '?'
      REC         = '?'
      NAT_OCC     = 0
      NAT         = 0   
      NRES        = 0   
      NRES_OCC    = 0   
      IEND        = 0

 200  CONTINUE

      READ(INC,'(A)',ERR=500,END=600) LINE
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.54) GO TO 200

      IF(REC.EQ.'ATOM'.AND.LINE(1:4).EQ.'ANIS') THEN
        GO TO 200
      ELSE IF(LINE(1:4).EQ.'ANIS') THEN
        GO TO 200
      ENDIF

      REC = '?'

      IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) GO TO 400

C       CH1 = LINE(22:22)
      CH1 = CHAIN       

 10   CONTINUE
      IF(IPR1_C.LT.IPR1.AND.IFIRST.EQ.0) THEN
        IRES_C   = IRES1(IPR1_C)
        ISEQ1_C  = NSEQ1(IPR1_C)
C        NAT = NAT + 1   
C        NRES = NRES + 1
        
c      write(*,*) '===',ipr1_c,ipr,NAT,ISEQ1_C,IRES_C

C        CALL ADD_ATOM_OCC_0(IOUT,NAT,ISEQ1_C,IRES_C,CH1,IERR)        
C        IF(IERR.NE.0) GO TO 500

c        IF(IRES_C.LT.IRES_OLD) THEN
c          NCH = NCH + 1
c          IF(NCH.GT.20) NCH = 20
c          CH1 = CNAME(NCH:NCH)
c        ENDIF
c        IRES_OLD = IRES_C
        IPR1_C = IPR1_C + 1        
        GO TO 10
      ENDIF


C           FRMT/'(6X,I5,A1,A4,A1,A3,A7,3X,3F8.3,2F6.2,10X,A4)'/
      READ(LINE,'(12X,A4,A1,A3,A7,27X,2F6.2)',ERR=500) 
     *    ANAME,CP_ALT,RNAME,CH7,CP_OCC,CP_BISO
      
      CP_SEG = '    '
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.GE.75) THEN
        CP_SEG(1:3) = LINE(73:75)
        CP_SEG(4:4) = ' '
        CP_SEG(1:2) = CHAIN//CHAIN
      ENDIF
      IF(LEN.GE.76) THEN
        CP_SEG = LINE(73:76)
        CP_SEG(1:2) = CHAIN//CHAIN
      ENDIF
      IF(CP_ALT.NE.' '.AND.CP_ALT.NE.'A'.AND.CP_ALT.NE.'1') GO TO 200
      ASYMB='    '
      CALL CORR_ANAME_PDB(ANAME,RNAME,ASYMB,CTYPE)
      CP_PNUM(1:1) = CH7(2:2)
      CP_PNUM(2:6) = CH7(3:7)
      IF(ASYMB(1:1).EQ.'H') GO TO 200

      IF(CP_OCC.LT.0.001) GO TO 200

      IF(ANAME.EQ.ANAME_OLD.AND.CP_PNUM.EQ.PNUM_OLD) GO TO 200
      PNUM_OLD  = CP_PNUM
      ANAME_OLD = ANAME     

      IF(CP_PNUM.NE.PNUM22) THEN
        IF(IFIRST.EQ.1) THEN
          IFIRST = 0
          IF(IPR.EQ.NPAIR) THEN
            GO TO 610
          ENDIF
          IPR1_C = IPR1_C + 1        
          IPR   = IPR + 1     
          IPR1  = IPAIR(1,IPR)
          IPR2  = IPAIR(2,IPR)
          ISEQ1 = NSEQ1(IPR1)
          IRES  = IRES1(IPR1)
c         CHAIN = PNUM1(IPR1)(1:1)

          CH1 = CHAIN       

          IRES_2= IRES2(IPR2)
          ISEQ2 = NSEQ2(IPR2)
          PNUM22= PNUM2(IPR2)

 11       CONTINUE
          IF(IPR1_C.LT.IPR1) THEN
            IRES_C   = IRES1(IPR1_C)
            ISEQ1_C  = NSEQ1(IPR1_C)
C            NAT = NAT + 1   
C             NRES = NRES + 1
        

c      write(*,*) '===',ipr1_c,ipr,NAT,ISEQ1_C,IRES_C
        
CC            CALL ADD_ATOM_OCC_0(IOUT,NAT,ISEQ1_C,IRES_C,CH1,IERR)        
CC            IF(IERR.NE.0) GO TO 500

c            IF(IRES_C.LT.IRES_OLD) THEN
c              NCH = NCH + 1
c              IF(NCH.GT.20) NCH = 20
c              CH1 = CNAME(NCH:NCH)
c            ENDIF

c            IRES_OLD = IRES_C
            IPR1_C = IPR1_C + 1        
            GO TO 11
          ENDIF

        ENDIF
        IF(CP_PNUM.NE.PNUM22) THEN
          GO TO 200
        ENDIF 
      ENDIF

      IFIRST = 1
      CALL CHAINGE_ATOME_ALIGN2(ANAME,ISEQ1,ISEQ2,RNAME,IWRT
     * ,ATOM_INDEX,ATOM_NAME)     

      CALL CORR_ATOME_NAME_AFTER_ALIGN(
     *                         ANAME,RNAME,ASYMB,IWRT)
      IF(RNAME.EQ.'---') IWRT = 0
      IF(IWRT.EQ.1.AND.ANAME(1:3).EQ.'N  ') THEN
        IDRES   = IRES - IRES_OLD
        IDRES_2 = IRES_2 - IRES_2_OLD
        IF(IDRES.EQ.1.AND.IDRES_2.GT.1) IWRT = 0
      ENDIF
      IF(IWRT.EQ.1) THEN
        IF(CP_OCC.GT.0.001) NAT_OCC = NAT_OCC + 1
        NAT = NAT + 1

c        IF(IRES.LT.IRES_OLD) THEN
c          NCH = NCH + 1
c          IF(NCH.GT.20) NCH = 20
c          CH1 = CNAME(NCH:NCH)
c        ENDIF

        IF(IRES.NE.IRES_OLD) 
     *    NRES = NRES + 1
        IF(IRES.NE.IRES_OLD.AND.CP_OCC.GT.0.001) 
     *    NRES_OCC = NRES_OCC + 1
        IRES_OLD = IRES
        IRES_2_OLD = IRES_2

C       FRMT/'(6X,I5,A1,A4,A1,A3,A7,3X,3F8.3,2F6.2,10X,A4)'/

        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GE.78) LINE(77:78) =' '//ANAME(1:1)      

        WRITE(CH4,'(I4)') IRES
        LINE(13:27) = ' '//ANAME(1:3)//' '//RNAME//' '//CH1//CH4//' '
c -
        IF(WS_FLAG.EQ.'Y') LINE(67:72) = '      '
C       if y remove surf
c -
        LINE(77:80) = '    '
        LINE(73:76) = CP_SEG

        IF(ITRANS.GT.0) THEN
          READ(LINE(31:54),'(3F8.3)') X(1),X(2),X(3)
          DO II=1,3
            Y(II) =   TRMAT(1,II)*X(1)
     *              + TRMAT(2,II)*X(2)
     *              + TRMAT(3,II)*X(3)
          ENDDO
          DO II=1,3
            Y(II) = Y(II) +  TR(II)
          ENDDO
          CALL LENSTR_BL(LINE,LEN)
          WRITE(LINE(31:54),'(3F8.3)') Y(1),Y(2),Y(3)          
        ENDIF
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)

        REC = 'ATOM'

      ENDIF

      GO TO 200

 400  CONTINUE

      IF(LINE(1:4).EQ.'ANIS') GO TO 200

      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)

      GO TO 200
C -------------------------
 600  CONTINUE
      IEND = 1
 610  CONTINUE

      IF(IPR.EQ.NPAIR) THEN

c      write(*,*) '>>end==',ipr1_c,nc,ipr

        IPR1_C = IPR1_C + 1        
 13     CONTINUE
        IF(IPR1_C.LE.NC) THEN
          IRES_C   = IRES1(IPR1_C)
          ISEQ1_C  = NSEQ1(IPR1_C)
C         NAT = NAT + 1   
C         NRES = NRES + 1
  
c      write(*,*) '=end==',ipr1_c,nc,NAT,ISEQ1_C,IRES_C
        
C         CALL ADD_ATOM_OCC_0(IOUT,NAT,ISEQ1_C,IRES_C,CH1,IERR)        
C         IF(IERR.NE.0) GO TO 500

c         IF(IRES_C.LT.IRES_OLD) THEN
c           NCH = NCH + 1
c           IF(NCH.GT.20) NCH = 20
c           CH1 = CNAME(NCH:NCH)
c         ENDIF

c         IRES_OLD = IRES_C
          IPR1_C = IPR1_C + 1        
          GO TO 13
        ENDIF
      ENDIF

      IF(IEND.EQ.0) THEN
 210    CONTINUE
        READ(INC,'(A)',ERR=500,END=600) LINE
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.LT.54) GO TO 210
        IF(REC.EQ.'ATOM'.AND.LINE(1:4).EQ.'ANIS') THEN
          GO TO 210
        ELSE IF(LINE(1:4).EQ.'ANIS') THEN
          GO TO 210
        ENDIF
        REC = '?'
        IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) GO TO 210

        READ(LINE,'(12X,A4,A1,A3,A7,27X,2F6.2)',ERR=500) 
     *    ANAME,CP_ALT,RNAME,CH7,CP_OCC,CP_BISO

        CP_SEG = '    '
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GE.75) THEN
          CP_SEG(1:3) = LINE(73:75)
          CP_SEG(4:4) = ' '
          CP_SEG(1:2) = CHAIN//CHAIN
        ENDIF
        IF(LEN.GE.76) THEN
          CP_SEG = LINE(73:76)
          CP_SEG(1:2) = CHAIN//CHAIN
        ENDIF

      
        IF(CP_ALT.NE.' '.AND.CP_ALT.NE.'A'.AND.CP_ALT.NE.'1')GOTO 210
        ASYMB='    '
        CALL CORR_ANAME_PDB(ANAME,RNAME,ASYMB,CTYPE)
        IF(ASYMB(1:1).EQ.'H') GO TO 210
        IF(CP_OCC.LT.0.001) GO TO 210
        IF(RNAME.EQ.'HEM'.OR.RNAME.EQ.'HMD'.OR.RNAME.EQ.'HEC'.OR.
     *     RNAME.EQ.'SRM'.OR.RNAME.EQ.'DHE'.OR.RNAME.EQ.'HEA'.OR.
     *     RNAME.EQ.'BCB'.OR.RNAME.EQ.'BPB'                      ) THEN
          CALL LENSTR_BL(LINE,LEN)

          LINE(22:22) = CH1
          IF(LEN.GE.74) THEN
            LINE(73:74) = CH1//CH1
          ENDIF

          IF(LINE(1:4).NE.'ANIS') THEN
            IF(ITRANS.GT.0) THEN
              READ(LINE(31:54),'(3F8.3)') X(1),X(2),X(3)
              DO II=1,3
                Y(II) = TRMAT(1,II)*X(1)
     *                + TRMAT(2,II)*X(2)
     *                + TRMAT(3,II)*X(3)
              ENDDO
              DO II=1,3
                Y(II) = Y(II) +  TR(II)
              ENDDO
              WRITE(LINE(31:54),'(3F8.3)') Y(1),Y(2),Y(3)
            ENDIF
            WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
          ENDIF

        ENDIF
        REC = 'ATOM'
        GO TO 210
      ENDIF

      END FILE IOUT
      CLOSE(IOUT)
      CLOSE(INC) 
      IF(NAT.LE.0) THEN
        CALL MSGERR(MDOC,' Number of atoms = 0')
        IERR = 1
      ENDIF
      RETURN
 500  CONTINUE
      CALL MSGERR(MDOC,' ERROR: in ALIGN_WRITE_PDB2')
      IERR = 1
      CLOSE(IOUT)
      CLOSE(INC) 
      RETURN
      END

      SUBROUTINE READ_PDB_SEQ_AND_COORD_CA(MDOC,NAME_IN
     *         ,NSEQ,IRES,PNUM,COORD,SURF,ICHAIN,IDOMAIN
     *         ,NMAX,N,CODE_PDB,NCHAIN,ITEST,IERR)
C --------------------------------------------------------
      CHARACTER CODE_PDB*4
      INTEGER   NSEQ(NMAX),IRES(NMAX)
      INTEGER   SURF(NMAX),ICHAIN(NMAX),IDOMAIN(NMAX)
      REAL      COORD(NMAX,3)
      CHARACTER PNUM(NMAX)*6
C --------------------------------------------------------
      CHARACTER NAME_IN*(*)
C ----
      CHARACTER LINE*256,NAME*256,PATH*80,EXT*80,STR*80
      CHARACTER ACODE3(25)*3
      CHARACTER AMIN(25)*1
      CHARACTER CH1*1,CH3*3,CH4*4,CH6*6
      REAL      CP_XYZ(3),CP_OCC,CP_BISO
      CHARACTER ANAME*4,RNAME*3,CP_PNUM*7,CP_CORR*1,CP_ALT*1
      CHARACTER ASYMB*4,CTYPE*4,TYPE1*1,TYPE2*1,CSURF*6
      CHARACTER FRMT*80,ACODE*4,CP_PNUM_OLD*7,ANAME_OLD*4
      CHARACTER CP_PNUM_CA*7,CP_PNUM_CA_OLD*7
      CHARACTER CP_SEG*4,CP_SEG_OLD*4
      PARAMETER ( NRNAMED = 38 )
      CHARACTER RNAMED(38)*3
      PARAMETER ( NRNAMES = 14 )
      CHARACTER RNAMES(14)*3
      DATA FRMT
     * /'(6X,I5,A1,A4,A1,A3,A7,3X,3F8.3,2F6.2,A6,4X,A4)'/
C --
      DATA ACODE3/'CYS','SER','THR','PRO','ALA','GLY','ASN','ASP' 
     *           ,'GLU','GLN','HIS','ARG','LYS','MET','ILE','LEU' 
     *           ,'VAL','PHE','TYR','TRP','UNK','ASX','GLX','---' 
     *           ,'---'/
C  
c                1   2   3   4   5   6   7   8   9  10  11  12  13
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','=','-'/
c             14  15  16  17  18  19  20  21  22  23  24  25
C
      DATA RNAMED/'A  ','C  ','G  ','T  ','U  ','I  ','+A ','+C ' 
     *           ,'+G ','+T ','+U ','1MA','1MG','2MG','5MC','5MU'
     *           ,'7MG','H2U','M2G','OMC','OMG','OMU','PSU','YG '
     *           ,'Ad ','Ar ','Cd ','Cr ','Gd ','Gr ','Td ','Ur '
     *           ,'Ir ','DA ','DC ','DT ','DG ','DI '/
      DATA RNAMES/'MAN','NAG','FUC','GAL','GLC','GCU','GSA','XYS' 
     *           ,'ARB','RIP','ABE','RAM','MAG','MMA'            /
      INTEGER   NLETT,NLETTD
      CHARACTER LETT*26,LETTD*10
c                 01234567890123456789012345
      DATA LETT /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      DATA LETTD/'0123456789'/
      DATA NLETT/26/,NLETTD/10/
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      CALL LENSTR_BL(NAME_IN,LEN)
      IF(LEN.LE.0.OR.NAME_IN(1:1).EQ.' '.OR.NAME_IN(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      IU   = 10
      EXT  = ' '
      PATH = ' '
c      OPEN(IU,FILE=NAME_IN(1:LEN),ACCESS='SEQUENTIAL',ERR=200
c     *  ,FORM='FORMATTED',STATUS='OLD')
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 200
      ENDIF
C --------------------------------
      IADD   = 0
      INEW   = 0
      N      = 0 
      N_OLD  = 0 
      CODE_PDB = 'XXXX'
      CP_PNUM_OLD    = '?'
      CP_PNUM_CA_OLD = '?'
      ANAME_OLD      = '?'
      CP_SEG_OLD     = '?'
      ICH     = 0
      ICH_OLD =-1
      ICH_CA  = 0
      NCHAIN  = 0
      IEND    = 0
      NDNA    = 0
      IDOM    = 0
      IDOM_OLD= 0
      IF(ITEST.EQ.0) THEN
        DO I=1,NMAX
          SURF(I) = 0
        ENDDO         
      ENDIF
C ----------------
 400  CONTINUE
      IF(IEND.GT.0) GO TO 600
      LINE = ' '
      READ(IU,'(A)',ERR=500,END=620) LINE
      GO TO 610
 620  CONTINUE
      IEND = 1
 610  CONTINUE

      CALL LENSTR_BL(LINE,LEN)

      IF(LEN.GE.66.AND.LINE(1:6).EQ.'HEADER') THEN
        CODE_PDB = LINE(63:66)
        GO TO 400
      ENDIF        

      IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) GO TO 400

      READ(LINE,FRMT)
     *  IA,CP_CORR,ANAME,CP_ALT,RNAME,CP_PNUM
     * ,CP_XYZ(1),CP_XYZ(2),CP_XYZ(3),CP_OCC,CP_BISO,CSURF,ACODE

      CP_SEG = LINE(73:76)
      
      IF(CP_ALT.NE.' '.AND.CP_ALT.NE.'A'.AND.CP_ALT.NE.'1') GO TO 400
 
      ASYMB='    '
      CALL CORR_ANAME_PDB(ANAME,RNAME,ASYMB,CTYPE)
      CALL CHKSMB(ACODE(1:1),TYPE1)
      CALL CHKSMB(ACODE(2:2),TYPE2)
      IF(TYPE1.NE.'D'.AND.TYPE2.NE.'D'.AND.TYPE2.NE.'B'.AND.
     *  LEN.GE.77) THEN
        IF(ACODE(1:1).EQ.' ') THEN
          ACODE = ACODE(2:4)//' '
        ENDIF
        IF(ACODE(2:2).EQ.' ') THEN
          ACODE(2:4) = ACODE(3:4)//' '
          IF(ACODE(2:2).EQ.' ') ACODE(2:4) = ACODE(3:4)//' '
        ENDIF
        ASYMB = ACODE
      ENDIF

      IWD = 6
      II  = 0
      CH6 = '      '
      DO I=1,IWD
        IF(CSURF(I:I).NE.' ') THEN
          II = II + 1
          CH6(II:II) = CSURF(I:I)
        ENDIF
      ENDDO
      IWD = II
      IF(II.GT.0) THEN 
        CALL WTODIG(CH6,IWD,FDIG,IDIG)
        CP_SURF = FDIG 
      ELSE
        CP_SURF = 0
      ENDIF

c ----
      CALL CORR_RESNAME_BY_SYNONYM(RNAME)
c ----
      CH3 = RNAME
      DO  J=1,23
        IF(CH3.EQ.ACODE3(J)) THEN
          GO TO 700
        ENDIF
      ENDDO

      DO  J=1,NRNAMED
        IF(CH3.EQ.RNAMED(J)) THEN
          NDNA = NDNA + 1
          GO TO 400
        ENDIF
      ENDDO
      DO  J=1,NRNAMES
        IF(CH3.EQ.RNAMES(J)) THEN
          GO TO 400
        ENDIF
      ENDDO

      J   = 26
 700  CONTINUE
      IF(J.EQ.22) J = 7
      IF(J.EQ.23) J = 8
      IF(J.EQ.21) J = 25
      IF(J.GE.1.AND.J.LE.21) THEN
C ===
      IF(ASYMB(1:1).EQ.'H') GO TO 400
      IF(ANAME.EQ.ANAME_OLD.AND.CP_PNUM.EQ.CP_PNUM_OLD) GO TO 400
        ANAME_OLD = ANAME 
        IF(CP_PNUM_OLD.NE.CP_PNUM) THEN
c         new residue
          IF(CP_PNUM_OLD(2:2).NE.CP_PNUM(2:2)) THEN
c           new chain
            ICH = ICH + 1
          ENDIF
C //     IF(INEW.EQ.1) THEN
          N_OLD = N     
          IF(N_OLD.GT.0) THEN
C //
            ITM  = 0
            IF(NRA.GT.0) THEN
              T = SUM_SURF/FLOAT(NRA) + 10.00001
              ITM = T/20.0
              IF(ITM.GT.8) ITM = 8   
              IF(ITM.LE.0) ITM = 1   
            ENDIF   
            IF(ITEST.EQ.0) THEN  
              IF(SURF(N_OLD).GE.0) SURF(N_OLD) = ITM
            ENDIF
          ENDIF
          INEW     = 0
          SUM_SURF = 0.0
          NRA      = 0

          IF(CP_PNUM_OLD(2:6).EQ.CP_PNUM(2:6)) IADD = IADD + 1

          CP_PNUM_OLD  = CP_PNUM

          IDOM_OLD = IDOM
          IF(CP_SEG_OLD(3:3).NE.CP_SEG(3:3)) IDOM = IDOM + 1
          CP_SEG_OLD = CP_SEG

        ENDIF
        IF(CP_OCC.GT.0.001) THEN
          T        = CP_SURF - 15.1
          IF(T.LT.0.0) T = 0.0
          SUM_SURF = SUM_SURF + T
          NRA      = NRA + 1
        ENDIF
        IF(ANAME.EQ.'CA  ') THEN

          CP_PNUM_CA = CP_PNUM

          IF(CP_PNUM_CA_OLD.EQ.CP_PNUM_CA) THEN
            LINE = ' ERR: CA ?  '// RNAME//'  '//CP_PNUM
     *             //' '//CODE_PDB   
            CALL MSGERR(MDOC,LINE)
          ENDIF
          IF(CP_PNUM_CA_OLD.NE.'?') THEN
            READ(CP_PNUM_CA_OLD(3:6),'(I4)') IR_OLD
            READ(CP_PNUM(3:6),'(I4)') IR
            ID = IR -IR_OLD
C           IF(ID.NE.1) THEN
            IF(ID.NE.1.OR.IDOM.NE.IDOM_OLD) THEN
              IF(N.GE.NMAX.AND.ITEST.EQ.0) THEN
                WRITE(LINE,'('' ERR: NUMBER OF RESIDUES >'',I8)')NMAX
                CALL MSGERR(MDOC,LINE) 
                IERR=1
                CLOSE(IU)
                RETURN
              ENDIF
              N = N +  1
              IF(ITEST.EQ.0) THEN
                IRES(N) = 0          
                NSEQ(N) = 25
                IDOMAIN(N) =-1 
                SURF(N)    =-1
C               IF(N.GT.1.AND.IDOM.NE.IDOM_OLD) THEN
                IF(IDOM.NE.IDOM_OLD) THEN
                  NSEQ(N)= 24 
                  IDOMAIN(N) =-2
                  SURF(N)    =-2
                ENDIF
                PNUM(N)(1:1) = CP_PNUM(2:2)
                PNUM(N)(2:6) = CP_PNUM(3:7)
                ICHAIN(N)  = ICH_CA
                COORD(N,1) = 1000.0 
                COORD(N,2) = 1000.0 
                COORD(N,3) = 1000.0 
              ENDIF
            ENDIF
          ENDIF

          CP_PNUM_CA_OLD = CP_PNUM_CA
          SEG_OLD        = SEG

          IF(N.GE.NMAX.AND.ITEST.EQ.0) THEN
            WRITE(LINE,'('' ERR: NUMBER OF RESIDUES >'',I8)')NMAX
            CALL MSGERR(MDOC,LINE) 
            IERR=1
            CLOSE(IU)
            RETURN
          ENDIF
          INEW  = 1
C //      N_OLD = N
          N = N + 1
          READ(CP_PNUM(3:6),'(I4)') IR
C ??? NCHAIN
          IF(ICH_OLD.NE.ICH) THEN
            ICH_CA  = ICH_CA + 1
            ICH_OLD = ICH
          ENDIF          
          IF(ICH_CA.LE.0) ICH_CA = 1

          IF(ITEST.EQ.0) THEN
            IRES(N) = IR          
            NSEQ(N) = J
            PNUM(N)(1:1) = CP_PNUM(2:2)
            PNUM(N)(2:6) = CP_PNUM(3:7)
            ICHAIN(N)  = ICH_CA
            IDOM =-1
            DO LL=1,NLETT
              IF(LETT(LL:LL).EQ.CP_SEG(3:3)) THEN
                IDOM = LL + 9
                GO TO 111
              ENDIF
            ENDDO
            DO LL=1,NLETTD
              IF(LETTD(LL:LL).EQ.CP_SEG(3:3)) THEN
                READ(CP_SEG(3:3),'(I1)') IDOM
                GO TO 111
              ENDIF
            ENDDO
  111       CONTINUE
            IDOMAIN(N) = IDOM
            IF(CP_OCC.GT.0.001) THEN
              COORD(N,1) = CP_XYZ(1) 
              COORD(N,2) = CP_XYZ(2) 
              COORD(N,3) = CP_XYZ(3) 
            ELSE
              COORD(N,1) = 1000.0 
              COORD(N,2) = 1000.0 
              COORD(N,3) = 1000.0 
              SURF(N)    =-1
            ENDIF
          ENDIF

        ENDIF

      ENDIF
      GO TO 400
C --------------
 600  CONTINUE
      CLOSE(IU)

C //
      IF(N_OLD.GE.1.AND.N_OLD.LT.N) THEN
        N_OLD = N
C //
        ITM   = 0
        IF(NRA.GT.0) THEN
          T = SUM_SURF/FLOAT(NRA) + 10.00001
          ITM = T/20.0
          IF(ITM.GT.8) ITM = 8   
          IF(ITM.LE.0) ITM = 1   
        ENDIF 
        IF(ITEST.EQ.0) THEN  
          IF(SURF(N_OLD).GE.0) SURF(N_OLD) = ITM
        ENDIF

      ENDIF

      NCHAIN = ICH_CA

      WRITE(LINE,'('' Number of residues :'',I8)') N
      CALL MSGDOC(MDOC,LINE)
      IF(N.LE.0) THEN
        CALL MSGERR(MDOC,' Number of residues for sequence = 0')
        IERR = 1
      ENDIF
      RETURN
C ----------------
 200  CONTINUE
      LINE = ' ERROR: cannot open file'
      CALL MSGERR(MDOC,LINE)
      GO TO 900
 500  CONTINUE
      LINE = ' ERROR: reading input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU)
      GO TO 900
C ----------------
 900  CONTINUE
      IERR = 1
      RETURN
      END

      SUBROUTINE SURFACE_DB_ALLOC(MDOC,NAMER,NAMEO
     * ,RESULT,IPRROW,IERR)   
C ---------------------------------------
C ---
C      CHARACTER PNUM(NATMX)*6,ATOM(NATMX)*4
C      REAL      XR(NATMX),YR(NATMX),ZR(NATMX)
C      REAL      OCCR(NATMX),TEMPR(NATMX),SURFR(NATMX),RADVDW(NATMX)
C      REAL      ELPOT(NATMX)
c--allocatable
      real,      allocatable :: XR(:)
      real,      allocatable :: YR(:)
      real,      allocatable :: ZR(:)
      real,      allocatable :: OCCR(:)
      real,      allocatable :: TEMPR(:)
      real,      allocatable :: SURFR(:)
      real,      allocatable :: RADVDW(:)
      real,      allocatable :: ELPOT(:)
      character(LEN=6), allocatable :: PNUM(:)
      character(LEN=4), allocatable :: ATOM(:)
      character(LEN=4), allocatable :: SEG(:)
      character(LEN=4), allocatable :: ACODE(:)
C ---
      REAL      RESULT(IPRROW)
C ---------------------------------------
      CHARACTER LINE*256,NAMER*(*),NAMEO*(*),SURF_KEY*1
C ---------------------------------------
      IERR = 0
      DO I=1,IPRROW
        RESULT(I) = 0.0
      ENDDO
      BLIM = 15.0
      DEL  = 0.1
      RH2O = 1.4
C -----------
      ITEST = 1
      NATMX = 100
      
      allocate(XR(1:NATMX),STAT=ISTAT)
      allocate(YR(1:NATMX),STAT=ISTAT)
      allocate(ZR(1:NATMX),STAT=ISTAT)
      allocate(OCCR(1:NATMX),STAT=ISTAT)
      allocate(TEMPR(1:NATMX),STAT=ISTAT)
      allocate(SURFR(1:NATMX),STAT=ISTAT)
      allocate(RADVDW(1:NATMX),STAT=ISTAT)
      allocate(ELPOT(1:NATMX),STAT=ISTAT)
      allocate(ATOM(1:NATMX),STAT=ISTAT)
      allocate(PNUM(1:NATMX),STAT=ISTAT)
      allocate(SEG(1:NATMX),STAT=ISTAT)
      allocate(ACODE(1:NATMX),STAT=ISTAT)

      CALL RDCOOR_SR_DB_ALLOC(MDOC,NAMER,NR,XR,YR,ZR,OCCR,TEMPR,SURFR
     *     ,SEG,ACODE
     *     ,RADVDW,ELPOT,PNUM,ATOM,NATMX,NRES,ITEST,IERR)
      IF(IERR.NE.0) GO TO 100
C -----------
      IF(NR.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: surface: number of atoms = 0')
        IERR=1
        GO TO 100
      ENDIF
C -----------

      deallocate(XR,STAT=ISTAT)
      deallocate(XR,STAT=ISTAT)
      deallocate(YR,STAT=ISTAT)
      deallocate(ZR,STAT=ISTAT)
      deallocate(OCCR,STAT=ISTAT)
      deallocate(TEMPR,STAT=ISTAT)
      deallocate(SURFR,STAT=ISTAT)
      deallocate(RADVDW,STAT=ISTAT)
      deallocate(ELPOT,STAT=ISTAT)
      deallocate(ATOM,STAT=ISTAT)
      deallocate(PNUM,STAT=ISTAT)
      deallocate(SEG,STAT=ISTAT)
      deallocate(ACODE,STAT=ISTAT)

      ITEST = 0
      NATMX = NR
      
      allocate(XR(1:NATMX),STAT=ISTAT)
      allocate(YR(1:NATMX),STAT=ISTAT)
      allocate(ZR(1:NATMX),STAT=ISTAT)
      allocate(OCCR(1:NATMX),STAT=ISTAT)
      allocate(TEMPR(1:NATMX),STAT=ISTAT)
      allocate(SURFR(1:NATMX),STAT=ISTAT)
      allocate(RADVDW(1:NATMX),STAT=ISTAT)
      allocate(ELPOT(1:NATMX),STAT=ISTAT)
      allocate(ATOM(1:NATMX),STAT=ISTAT)
      allocate(PNUM(1:NATMX),STAT=ISTAT)
      allocate(SEG(1:NATMX),STAT=ISTAT)
      allocate(ACODE(1:NATMX),STAT=ISTAT)


      CALL RDCOOR_SR_DB_ALLOC(MDOC,NAMER,NR,XR,YR,ZR,OCCR,TEMPR,SURFR
     *     ,SEG,ACODE
     *     ,RADVDW,ELPOT,PNUM,ATOM,NATMX,NRES,ITEST,IERR)
      IF(IERR.NE.0) GO TO 100
C -----------
      WRITE(LINE,'('' Number of atoms :'',I6)') NR
      CALL MSGDOC(MDOC,LINE)
C -----------

      CALL CALC_RAD_INERTIA(MDOC,NR,XR,YR,ZR,OCCR,TEMPR
     *    ,NATMX,RAD_INER,IERR)

C ------------
      CALL AREA_SR_DB_ALLOC(MDOC,NR,XR,YR,ZR,RADVDW,SURFR,ELPOT,OCCR
     *    ,NATMX,RH2O,DEL,SURFA,SURFC,IERR)
C IERR
C  1   - CALL MSGERR(MDOC,' ERROR: surface: area_sr: N_atoms = 0')
C  2   - CALL MSGERR(MDOC,' ERROR: surface: table_sr: STOP NZ < 2')
C  3   - CALL MSGERR(MDOC,' ERROR: surface: table_sr: STOP M < 1')
C  4   - CALL MSGERR(MDOC,' ERROR: surface: table_sr: J > NPMAX')
C  5   - CALL MSGERR(MDOC,' ERROR: surface: area_sr: N-neighbors > LIMIT') 
      IF(IERR.NE.0) THEN
        IF(IERR.EQ.1) CALL MSGERR(MDOC,
     *    ' ERROR: surface: area_sr: N_atoms = 0')
        IF(IERR.EQ.2) CALL MSGERR(MDOC,
     *    ' ERROR: surface: table_sr: STOP NZ < 2')
        IF(IERR.EQ.3) CALL MSGERR(MDOC,
     *    ' ERROR: surface: table_sr: STOP M < 1')
        IF(IERR.EQ.4) CALL MSGERR(MDOC,
     *    ' ERROR: surface: table_sr: J > NPMAX')
        IF(IERR.EQ.5) CALL MSGERR(MDOC,
     *    ' ERROR: surface: area_sr: N-neighbors > LIMIT') 
        GO TO 100
      ENDIF
      WRITE(LINE,9999) SURFC
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,9997) SURFA
      CALL MSGDOC(MDOC,LINE)
 9999 FORMAT(' Total Contact    Surface Area =',F10.3)
 9997 FORMAT(' Total Accessible Surface Area =',F10.3)
      CALL MSGDOC(MDOC,' ')
C ------------------------------------------------------------------

      CALL WRCOOR_SR_DB_ALLOC(MDOC,NAMER,NAMEO
     *   ,OCCR,SURF_KEY,BLIM,SURFR,PNUM,ATOM,NATMX
     *   ,SEG,ACODE
     *   ,NTOT,NAT,IERR)
      IF(IERR.NE.0) GO TO 100

C ---------------------------------------
      RESULT(1) = NAT
      RESULT(2) = SURFA
      RESULT(3) = SURFC
      RESULT(8) = NTOT
      RESULT(9) = NRES
      RESULT(10)= RAD_INER

 100  CONTINUE

      deallocate(XR,STAT=ISTAT)
      deallocate(XR,STAT=ISTAT)
      deallocate(YR,STAT=ISTAT)
      deallocate(ZR,STAT=ISTAT)
      deallocate(OCCR,STAT=ISTAT)
      deallocate(TEMPR,STAT=ISTAT)
      deallocate(SURFR,STAT=ISTAT)
      deallocate(RADVDW,STAT=ISTAT)
      deallocate(ELPOT,STAT=ISTAT)
      deallocate(ATOM,STAT=ISTAT)
      deallocate(PNUM,STAT=ISTAT)
      deallocate(SEG,STAT=ISTAT)
      deallocate(ACODE,STAT=ISTAT)

 900  CONTINUE

C --------------------------------
      RETURN
      END

      SUBROUTINE CALC_RAD_INERTIA(MDOC,NR,X,Y,Z,OCC,TEMP
     *    ,NATMX,RAD_INER,IERR)
C ---------------------------------------
      REAL      X(NATMX),Y(NATMX),Z(NATMX)
      REAL      OCC(NATMX),TEMP(NATMX)
C --------------------------------
      RAD_INER = 0.0
      N   = 0
      XS  = 0.0
      YS  = 0.0
      ZS  = 0.0
      XS2 = 0.0
      YS2 = 0.0
      ZS2 = 0.0
      DO I=1,NR
        IF(OCC(I).GT.0.001) THEN
          XS  = XS  + X(I)
          YS  = YS  + Y(I)
          ZS  = ZS  + Z(I)
          XS2 = XS2 + X(I)*X(I)
          YS2 = YS2 + Y(I)*Y(I)
          ZS2 = ZS2 + Z(I)*Z(I)
          N   = N + 1
        ENDIF
      ENDDO
      IF(N.LE.0) RETURN      
      XS  = XS/REAL(N)
      YS  = YS/REAL(N)
      ZS  = ZS/REAL(N)
      XS2 = XS2/REAL(N)
      YS2 = YS2/REAL(N)
      ZS2 = ZS2/REAL(N)
      RX  = XS2-XS*XS
      RY  = YS2-YS*YS
      RZ  = ZS2-ZS*ZS
      RAD_INER = SQRT(ABS(RX+RY+RZ))
C --------------------------------
      RETURN
      END

      SUBROUTINE RDCOOR_SR_DB_ALLOC(MDOC
     *     ,NAME_IN,NCRDR,X,Y,Z,OCC,TEMP,SURF
     *     ,SEG,ACODEA
     *     ,RADVDW,ELPOT,PNUM,ATOM,NATMX,NR
     *     ,ITEST,IERR)
C ---------------------------------------
      CHARACTER PNUM(NATMX)*6,ATOM(NATMX)*4
      REAL      X(NATMX),Y(NATMX),Z(NATMX)
      REAL      OCC(NATMX),TEMP(NATMX),SURF(NATMX),RADVDW(NATMX)
      REAL      ELPOT(NATMX)
      CHARACTER SEG(NATMX)*4,ACODEA(NATMX)*4
C ------------------------------------------------------------
      CHARACTER CHAR2*2
C ----------------------------------------------
      PARAMETER (N_NAME = 9)
      REAL      TAB_RVDW(N_NAME)
      CHARACTER NAME(N_NAME)*2
      DATA NAME    /'C ','O ','N ','S ','P ','H ','FE','CA','ZN'/
      DATA TAB_RVDW/1.8 ,1.7 ,1.6 ,1.9 ,2.1 ,0.8 ,0.65,1.18,0.88/
C B       10.82000  N     0.650      .
C F       19.00000  N     1.330      .
C NA      22.99000  N      .         .
C MG      24.32000  N     0.820      .
C P       30.97380  N     2.100      .
C PS      30.97380  N     2.100      .
C S       32.06400  A     1.900      .
C SH1     32.06400  B     1.900     1.950
C CL      35.45700  N     1.810      .
C CA      40.08000  N     1.180      .
C V       50.95000  N     0.880      .
C MN      54.94000  N     0.800      .
C FE      55.84700  N     0.650      .
C CO      58.94000  N     0.720      .
C CU      63.54600  N     0.740      .
C ZN      65.37000  N     0.880      .
C BR      79.91600  N     1.960      .
C CD     112.40000  N     1.140      .
C I      126.90450  A     2.200      .
C PB     207.21000  N     1.200      .
C HG     200.61000  N     1.270      .
C -------------------------------------------------------------------
      CHARACTER CODE_PDB*4
C --------------------------------------------------------
      CHARACTER NAME_IN*(*)
C ----
      CHARACTER LINE*256,PATH*80,EXT*80,STR*80
      CHARACTER ACODE3(25)*3
      CHARACTER AMIN(25)*1
      CHARACTER CH1*1
      CHARACTER CH3*3
      CHARACTER CH4*4
      REAL      CP_XYZ(3),CP_OCC,CP_BISO
      CHARACTER ANAME*4,RNAME*3,CP_PNUM*7,CP_CORR*1,CP_ALT*1
      CHARACTER ASYMB*4,CTYPE*4,TYPE1*1,TYPE2*1
      CHARACTER FRMT*80,ACODE*4,CP_PNUM_OLD*7,ANAME_OLD*4
      CHARACTER CP_SEG*4
      DATA FRMT/'(6X,I5,A1,A4,A1,A3,A7,3X,3F8.3,2F6.2,6X,A4,A4)'/
c123456123451123411231234567
cATOM      4  O   THR     1      -5.209  15.501  13.516  1.00 32.45      2PIA 
cATOM      6  OG1 THR     1      -2.234  12.957  13.779  1.00 42.29      2PIA
C --
      DATA ACODE3/'CYS','SER','THR','PRO','ALA','GLY','ASN','ASP' 
     *           ,'GLU','GLN','HIS','ARG','LYS','MET','ILE','LEU' 
     *           ,'VAL','PHE','TYR','TRP','UNK','ASX','GLX','---' 
     *           ,'---'/
C  
c                1   2   3   4   5   6   7   8   9  10  11  12  13
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','=','-'/
c             14  15  16  17  18  19  20  21  22  23  24  25
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      CALL CORR_NAME_BLC(NAME_IN)
      CALL LENSTR_BL(NAME_IN,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 200
      ENDIF
C --------------------------------
      NCRDR = 0
      N     = 0 
      NR    = 0
      CODE_PDB = 'XXXX'
      CP_PNUM_OLD = '?'
      ANAME_OLD   = '?'
C ----------------
 400  CONTINUE
      READ(IU,'(A)',ERR=500,END=600) LINE

      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.54) GO TO 400
      IF(LEN.GE.66.AND.LINE(1:6).EQ.'HEADER') THEN
        CODE_PDB = LINE(63:66)
        GO TO 400
      ENDIF        

      IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) GO TO 400

       READ(LINE,FRMT)
     *  IA,CP_CORR,ANAME,CP_ALT,RNAME,CP_PNUM
     * ,CP_XYZ(1),CP_XYZ(2),CP_XYZ(3),CP_OCC,CP_BISO,CP_SEG,ACODE

      IF(CP_ALT.NE.' '.AND.CP_ALT.NE.'A'.AND.CP_ALT.NE.'1') GO TO 400
 
      ASYMB='    '
      CALL CORR_NAME(ANAME,RNAME,ASYMB,CTYPE)
      CALL CHKSMB(ACODE(1:1),TYPE1)
      CALL CHKSMB(ACODE(2:2),TYPE2)

      IF(ANAME.EQ.ANAME_OLD.AND.CP_PNUM.EQ.CP_PNUM_OLD)GO TO 400
      IF(CP_PNUM.NE.CP_PNUM_OLD) THEN
        IF(CP_OCC.GT.0.001) NR = NR + 1
      ENDIF
      CP_PNUM_OLD  = CP_PNUM

      CH4 = ACODE
      IF(TYPE1.NE.'D'.AND.TYPE2.NE.'D'.AND.TYPE2.NE.'B'.AND.
     *  LEN.GE.77) THEN
        IF(ACODE(1:1).EQ.' ') THEN
          ACODE = ACODE(2:4)//' '
        ENDIF
        IF(ACODE(2:2).EQ.' ') THEN
          ACODE(2:4) = ACODE(3:4)//' '
          IF(ACODE(2:2).EQ.' ') ACODE(2:4) = ACODE(3:4)//' '
        ENDIF
        ASYMB = ACODE
      ENDIF
      ACODE = CH4

      CALL CORR_RESNAME_BY_SYNONYM(RNAME)

      CH3 = RNAME
      DO  J=1,23
        IF(CH3.EQ.ACODE3(J)) THEN
          GO TO 700
        ENDIF
      ENDDO
      J   = 26
 700  CONTINUE
      IF(J.GE.1.AND.J.LE.23) THEN
        IF(N.GE.NATMX.AND.ITEST.EQ.0) THEN
          WRITE(LINE,'('' ERR: NUMBER OF ATOMS >'',I8)') NATMX
          CALL MSGDOC(MDOC,LINE) 
          IERR=1
          CLOSE(IN)
          RETURN
        ENDIF

C        IF(CP_OCC.GT.0.001) THEN
          N = N + 1
          IF(J.EQ.22) J = 7
          IF(J.EQ.23) J = 8

          IF(ITEST.EQ.0) THEN
            PNUM(N)(1:1) = CP_PNUM(2:2)
            PNUM(N)(2:6) = CP_PNUM(3:7)
            ATOM(N)      = ANAME
            ANAME_OLD    = ANAME
            X     (N) = CP_XYZ(1)
            Y     (N) = CP_XYZ(2)
            Z     (N) = CP_XYZ(3)
            OCC   (N) = CP_OCC
            TEMP  (N) = CP_BISO
            SURF  (N) = 0.0
            ELPOT (N) = 0.0
            SEG   (N) = CP_SEG
            ACODEA(N) = ACODE
          ENDIF

          CHAR2     = ASYMB(1:2)

          RVDW      = 1.4
          DO I=1,N_NAME
            IF(CHAR2.EQ.NAME(I)) THEN
              RVDW = TAB_RVDW(I)
              GO TO 100
            ENDIF
          ENDDO
 100      CONTINUE
          IF(ITEST.EQ.0) THEN
            RADVDW(N) = RVDW
          ENDIF

C        ENDIF

      ENDIF
      GO TO 400
C --------------
 600  CONTINUE
      CLOSE(IU)
      NCRDR = N
      IF(N.LE.0) THEN
        CALL MSGERR(MDOC,' Number of atoms for surface calc = 0')
        IERR = 1
      ENDIF
      RETURN
C ----------------
 200  CONTINUE
      LINE = ' ERROR: cannot open file'
      CALL MSGERR(MDOC,LINE)
      GO TO 900
 500  CONTINUE
      LINE = ' ERROR: reading input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU)
      GO TO 900
C ----------------
 900  CONTINUE
      IERR = 1
      RETURN
      END

      SUBROUTINE AREA_SR_DB_ALLOC(MDOC,NR,XR,YR,ZR,RADVDW,SURFR,ELPOT
     *       ,OCCR,NATMX,RH2O,DEL,SURFA,SURFC,IERR)
C ---------------------------------------
      REAL      XR(NATMX),YR(NATMX),ZR(NATMX)
      REAL      SURFR(NATMX),RADVDW(NATMX)
      REAL      ELPOT(NATMX),OCCR(NATMX)
C ---------------------------------------
      PARAMETER (NSMAX=500)
      PARAMETER (NPMAX=20000)
      PARAMETER (MAXPO=10000)
C      REAL XPNT(MAXPO),YPNT(MAXPO),ZPNT(MAXPO)
C      REAL XSOSED(NSMAX),YSOSED(NSMAX),ZSOSED(NSMAX),RSOSED(NSMAX)
C      REAL XKPOIN(NPMAX),YKPOIN(NPMAX),ZKPOIN(NPMAX)
C      REAL XPOINT(NPMAX),YPOINT(NPMAX),ZPOINT(NPMAX),ITYPE(NPMAX)
c--allocatable
      real,      allocatable :: XPNT(:)
      real,      allocatable :: YPNT(:)
      real,      allocatable :: ZPNT(:)
      real,      allocatable :: XSOSED(:)
      real,      allocatable :: YSOSED(:)
      real,      allocatable :: ZSOSED(:)
      real,      allocatable :: RSOSED(:)
      real,      allocatable :: XKPOIN(:)
      real,      allocatable :: YKPOIN(:)
      real,      allocatable :: ZKPOIN(:)
      real,      allocatable :: XPOINT(:)
      real,      allocatable :: YPOINT(:)
      real,      allocatable :: ZPOINT(:)
      real,      allocatable :: ITYPE(:)

      CHARACTER LINE*256
C ----------------------------------------------------
      NGLOB = 0
      SURFC = 0.0
      SURFA = 0.0

      allocate(XPNT(1:MAXPO),STAT=ISTAT)
      allocate(YPNT(1:MAXPO),STAT=ISTAT)
      allocate(ZPNT(1:MAXPO),STAT=ISTAT)
      allocate(XSOSED(1:NSMAX),STAT=ISTAT)
      allocate(YSOSED(1:NSMAX),STAT=ISTAT)
      allocate(ZSOSED(1:NSMAX),STAT=ISTAT)
      allocate(RSOSED(1:NSMAX),STAT=ISTAT)
      allocate(XKPOIN(1:NPMAX),STAT=ISTAT)
      allocate(YKPOIN(1:NPMAX),STAT=ISTAT)
      allocate(ZKPOIN(1:NPMAX),STAT=ISTAT)
      allocate(XPOINT(1:NPMAX),STAT=ISTAT)
      allocate(YPOINT(1:NPMAX),STAT=ISTAT)
      allocate(ZPOINT(1:NPMAX),STAT=ISTAT)
      allocate(ITYPE(1:NPMAX),STAT=ISTAT)

      RUNIT = 1.0
      CALL TABLE_SR_DB(RUNIT,DEL,NPOINT,XPOINT,YPOINT,ZPOINT,SDELK
     *          ,NPMAX,IERR)
      IF(IERR.NE.0) GO TO 900

C -------- START OF CYCLE K-ATOM --------------------

      DO     K=1,NR

C        IF( MOD(K,100).EQ.0) THEN
C          WRITE(LINE,'('' I-ATOM,N-POINTS :'',I6,I8)') K,NGLOB
C          CALL MSGDOC(MDOC,LINE)
C        ENDIF

        IF(OCCR(K).LT.0.001) GO TO 100

        XK = XR(K)
        YK = YR(K)
        ZK = ZR(K)
        RK = RADVDW(K)+RH2O
        L  = 0
        DO     I1=1,NPOINT
          XKPOIN(I1) = XK+(XPOINT(I1)*RK)/RUNIT
          YKPOIN(I1) = YK+(YPOINT(I1)*RK)/RUNIT
          ZKPOIN(I1) = ZK+(ZPOINT(I1)*RK)/RUNIT
          ITYPE (I1) = 0
        ENDDO
        SDEL = (SDELK*RK*RK)/(RUNIT*RUNIT)
C ----------- SOSEDI ----------------
        DO     J=1,NR

          IF(OCCR(J).LT.0.001) GO TO 200

          IF(J.NE.K) THEN
            XJ    = XR(J)
            YJ    = YR(J)
            ZJ    = ZR(J)
            RJ    = RADVDW(J)+RH2O
            R1    = RK+RJ
            RLIM2 = R1*R1
            S1    = (XJ-XK)*(XJ-XK)
            S2    = (YJ-YK)*(YJ-YK)
            S3    = (ZJ-ZK)*(ZJ-ZK)
            DIS2  = S1+S2+S3
            IF(DIS2.LE.RLIM2) THEN
              L = L+1
              IF(L.GT.NSMAX) THEN
                WRITE(LINE,'('' ERROR: surface: N-SOSED >'',I8)') NSMAX
                CALL MSGERR(MDOC,LINE)
                IERR=1
                GO TO 900
              ENDIF
              XSOSED(L) = XJ
              YSOSED(L) = YJ
              ZSOSED(L) = ZJ
              RSOSED(L) = RJ
              NSOSED    = L
            ENDIF
          ENDIF

 200      CONTINUE

        ENDDO
C -------------
        IF(NSOSED.GT.0) THEN
          DO     IP=1,NPOINT
            XP = XKPOIN(IP)
            YP = YKPOIN(IP)
            ZP = ZKPOIN(IP)
            DO     IS=1,NSOSED
              XS = XSOSED(IS)
              YS = YSOSED(IS)
              ZS = ZSOSED(IS)
              RS = RSOSED(IS)
              DX = XS-XP
              IF(ABS(DX).GT.RS) GO TO 350
              DY = YS-YP
              IF(ABS(DY).GT.RS) GO TO 350
              DZ = ZS-ZP
              IF(ABS(DZ).GT.RS) GO TO 350
              D2  = DX*DX+DY*DY+DZ*DZ
              RS2 = RS*RS
              IF(D2.LT.RS2) THEN
                ITYPE(IP) = 1
                GO TO 352
              ENDIF
 350          CONTINUE
            ENDDO
 352        CONTINUE
          ENDDO
        ENDIF
C --------------------------------------
        MS=0
C   ---
        DO     IP=1,NPOINT
          IF(ITYPE(IP).EQ.0) THEN
            MS = MS+1
          ENDIF
        ENDDO
C   ---
        NGLOB = NGLOB+MS
        SUA   = MS*SDEL
C  --   SCALE AREA TO VDW SHELL ---
        SUC      = (SUA*(RK-RH2O)*(RK-RH2O))/(RK*RK)
        SURFR(K) = SUC
        SURFA    = SURFA+SUA
        SURFC    = SURFC+SUC

 100    CONTINUE

      ENDDO
C ---------------- END OF CYCLE K-ATOM -----------------

 900    CONTINUE

      deallocate(XPNT,STAT=ISTAT)
      deallocate(YPNT,STAT=ISTAT)
      deallocate(ZPNT,STAT=ISTAT)
      deallocate(XSOSED,STAT=ISTAT)
      deallocate(YSOSED,STAT=ISTAT)
      deallocate(ZSOSED,STAT=ISTAT)
      deallocate(RSOSED,STAT=ISTAT)
      deallocate(XKPOIN,STAT=ISTAT)
      deallocate(YKPOIN,STAT=ISTAT)
      deallocate(ZKPOIN,STAT=ISTAT)
      deallocate(XPOINT,STAT=ISTAT)
      deallocate(YPOINT,STAT=ISTAT)
      deallocate(ZPOINT,STAT=ISTAT)
      deallocate(ITYPE,STAT=ISTAT)

      RETURN
      END

      SUBROUTINE ALIGN_SS_DEFINITION_ALLOC(MDOC,NR
     * ,XR,YR,ZR,ISS,SURF
     * ,PSS,PH,PB,NATMX,IERR)
C ---------------------------------
c     SS definition by CA-CA distances
c  input:
c     integer:
c       NATMX max number of atoms (size of arraies)
C       NR    actual number of atoms
c     real: 
c       XR(NATMX),YR(NATMX),ZR(NATMX) coordinates of i_atom
c       SURF(NATMX) :       >=0 means CA atom ; else < 0  OCC=0 or dummy
c     scratch array
c       real      TEMPR(NATMX) 
c       integer   ID_DOM(NATMX)
c     output:
c       PSS    SS percent
c       PH     helix percent   
c       PB     beta  percent
c       integer  ISS(NATMX) 1 or 2  helix
c                            3 or 4  beta sheet
c                           or 0
C ---------------------------------------
      REAL      XR(NATMX),YR(NATMX),ZR(NATMX)
      INTEGER   ISS(NATMX)
      INTEGER   SURF(NATMX)

c allocatable
c      REAL      TEMPR(NATMX)
c      INTEGER   ID_DOM(NATMX)
      real,      allocatable :: TEMPR(:)
      integer,   allocatable :: ID_DOM(:)

C ---------------------------------------
      CHARACTER LINE*256
C ---------------------------------------
      PI    = 4.0*ATAN(1.0)
      IERR  = 0
      M     = 99
      MD    =-ABS(MDOC)-1
C ---------------------------------------
      IFIRST = 1
      IF(SURF(1).LT.0) THEN
        DO I=2,NR
          IF(SURF(I-1).LT.0.AND.SURF(I).GT.0) THEN
            IFIRST = I
            GO TO 100
          ENDIF
        ENDDO
      ENDIF
  100 CONTINUE
      ILAST = NR
      IF(SURF(NR).LT.0) THEN
        DO I=NR-1,1,-1
          IF(SURF(I+1).LT.0.AND.SURF(I).GT.0) THEN
            ILAST = I
            GO TO 200
          ENDIF
        ENDDO
      ENDIF
  200 CONTINUE
      IF(IFIRST.LE.ILAST) THEN
        DO I=IFIRST,ILAST
          IF(SURF(I).LT.0) THEN
C            write(LINE,'(a,3i5)') 
C     *      '-ss_def-:',ifirst,ilast,i
C            CALL MSGDOC(MDOC,LINE)
C            RETURN
          ENDIF
        ENDDO
      ENDIF
C -----
      PSS = 0.0
      PH  = 0.0
      PB  = 0.0
      DO I=1,NR
        ISS(I)    = 0
      ENDDO
C --
      IF(NR.LE.3) RETURN

      allocate(TEMPR(1:NATMX),STAT=ISTAT)
      allocate(ID_DOM(1:NATMX),STAT=ISTAT)

      DO I=1,NR
        ID_DOM(I) = 0 
        TEMPR(I)  = 0.0
      ENDDO

      H_MIN  = 5.1
      H_MAX  = 5.75
      HH_MIN  = 4.5
      HH_MAX  = 5.8
C      H_MAX  = 5.9
c      B_MIN  = 6.4
c      B_MAX  = 7.5
c      H_MIN  = 5.1
c      H_MAX  = 5.8
      B_MIN  = 6.2
      B_MAX  = 7.55
      BB_MIN  =  9.0
      BB_MAX  = 10.9
      D1     =-1.0
      D2     =-1.0
      NSS    = 0
      IFLAG  = 0
      NH     = 0
      NB     = 0
      ICA3   = 0
      ICA2   = 0
      ICA1   = 0
      DO IA = 1,NR

        IF(SURF(IA).GE.0) THEN
C//
        ICA = IA
        IF(ICA2.GT.0) THEN
          DX = XR(ICA) - XR(ICA2)
          DY = YR(ICA) - YR(ICA2)
          DZ = ZR(ICA) - ZR(ICA2)
          D  = SQRT(DX*DX+DY*DY+DZ*DZ)
          IF(ICA3.GT.0) THEN
            DX = XR(ICA) - XR(ICA3)
            DY = YR(ICA) - YR(ICA3)
            DZ = ZR(ICA) - ZR(ICA3)
            DD = SQRT(DX*DX+DY*DY+DZ*DZ)
          ELSE
            DD = 0.0
          ENDIF
          IF((ICA+1).LE.NR) THEN
            DX = XR(ICA2) - XR(ICA+1)
            DY = YR(ICA2) - YR(ICA+1)
            DZ = ZR(ICA2) - ZR(ICA+1)
            DDD = SQRT(DX*DX+DY*DY+DZ*DZ)
            DX = XR(ICA1) - XR(ICA+1)
            DY = YR(ICA1) - YR(ICA+1)
            DZ = ZR(ICA1) - ZR(ICA+1)
            D3 = SQRT(DX*DX+DY*DY+DZ*DZ)
          ELSE
            DDD = 0.0
          ENDIF

          IHEL   = 0
          IBET   = 0
          IF(D1.GT.0.0.AND.D.GT.0.0) THEN

          
            IF(D .GE.B_MIN.AND.D .LE.B_MAX.AND.
     *         D1.GE.B_MIN.AND.D1.LE.B_MAX     ) THEN
              IBET     = 1
             
              IF(((DD.LT.BB_MIN.OR.DD.GT.BB_MAX).AND.DD.GT.0.001).OR. 
     *          ((DDD.LT.BB_MIN.OR.DDD.GT.BB_MAX).AND.DDD.GT.0.001)) 
     *          IBET=0
            ENDIF

            IF(D2.GT.0.0) THEN
              IF(D .GE.H_MIN.AND.D .LE.H_MAX.AND.
     *           D1.GE.H_MIN.AND.D1.LE.H_MAX.AND.
     *           D3.GE.H_MIN.AND.D3.LE.H_MAX     ) THEN
                IHEL     = 1
                IF((DD.LT.HH_MIN.OR.DD.GT.HH_MAX).AND.DD.GT.0.001) 
     *          IHEL=0
              ENDIF
            ENDIF


c            write(LINE,'(a,i5,5f8.3,2i5)') 
c     *      '-ss-:',ia,d,d1,d3,DD,ddd,ihel,ibet
c            CALL MSGDOC(MDOC,LINE)
 

            IF(IHEL.NE.0.OR.IBET.NE.0) THEN
              IF(IHEL.NE.0) THEN
                IF(IFLAG.NE.1) THEN
                  NSS      = NSS + 1
                  NH       = NH  + 1
                  IFLAG    = 1
                ENDIF
                ISS(ICA ) = NSS
                ISS(ICA1) = NSS
                ISS(ICA2) = NSS
C                IF(ICA3.GT.0) ISS(ICA3) = NSS
              ELSE
                IF(IFLAG.NE.2) THEN
                  NSS      = NSS + 1
                  NB       = NB  + 1
                  IFLAG    = 2
                ENDIF
                ISS(ICA ) = -NSS
                ISS(ICA1) = -NSS
                ISS(ICA2) = -NSS
c               IF(ICA3.GT.0) ISS(ICA3) = -NSS
              ENDIF
            ELSE
              IFLAG = 0
            ENDIF

          ENDIF
   
          D2 = D1
          D1 = D

        ENDIF

        ICA3 = ICA2
        ICA2 = ICA1
        ICA1 = ICA

C// 
        ENDIF
      ENDDO
C --- beta-sheet
      DIST_LIM = 5.25
      DO IA=1,NR
        IF(SURF(IA).GE.0.AND.IA.LE.NR-2) THEN
C//
          IF(ISS(IA).LT.0.AND.SURF(IA+1).GE.0) THEN
            DO JA=IA+2,NR
              IF(SURF(JA).GE.0) THEN
C//
                IF(ISS(IA).NE.ISS(JA).AND.ISS(JA).LT.0) THEN
                  DX = XR(IA) - XR(JA)
                  DY = YR(IA) - YR(JA)
                  DZ = ZR(IA) - ZR(JA)
                  D  = SQRT(DX*DX+DY*DY+DZ*DZ)

                  IF(D.LT.TEMPR(IA).OR.TEMPR(IA).LT.0.0001) THEN
                    TEMPR(IA) = D
                  ENDIF

                  IF(D.LT.TEMPR(JA).OR.TEMPR(JA).LT.0.0001) THEN
                    TEMPR(JA) = D
                  ENDIF

                  IF(D.LT.DIST_LIM) THEN
                    ID_DOM(IA) = ID_DOM(IA) + 1
                    ID_DOM(JA) = ID_DOM(JA) + 1
                  ENDIF 
                ENDIF
C//
              ENDIF 
            ENDDO
          ENDIF
C//
        ENDIF 
      ENDDO

c      DO IA = 1,NR
c       IF(IRESR(IA).LT.0) THEN         
c          WRITE(line,*) '>beta>:'
c     *   ,ia,ABS(IRESR(IA)),ISS(IA),ID_DOM(IA),TEMPR(IA)
c      CALL MSGDOC(MDOC,LINE)
c        ENDIF
c      ENDDO

      IS   = 0
      IF   = 0
      ISEG = 0
      NSEG = 0
      DO IA=1,NR
        IF(SURF(IA).GE.0) THEN             
C//
          IF(ISS(IA).NE.0) THEN
            IF(ISEG.GT.0.AND.NSEG.EQ.ISS(IA)) THEN
              IF = IA
            ELSE
c             star new segment 
              IF(ISEG.GT.0) THEN
                N     = 0
                IFLAG = 1
                IF(IS+1.LE.IF.AND.NSEG.LT.0) THEN
                IFLAG = 0

                NNN = IF-IS+1
            
                DO JA=IS,IF
                  IF(SURF(JA).GE.0) THEN
C//
                    IF(ID_DOM(JA).GT.0) THEN
C                      IF(N.LE.0) THEN
C                        N = N + 1
C                        IF(N.GE.2) IFLAG = 1
C                      ENDIF
C                    ELSE
C                      N = 0
c                      N = ID_DOM(JA-1)+ID_DOM(JA)
                       N = N + ID_DOM(JA)
c                      IF(N.GE.2) IFLAG = 1
                    ENDIF           
C//
                  ENDIF
                ENDDO
                  IF(N.GE.2.AND.NNN.GT.3) IFLAG = 1
                  IF(N.GE.1.AND.NNN.EQ.3) IFLAG = 1
                ENDIF
                N = IF-IS+1
                IF(N.LE.2.AND.NSEG.LT.0) IFLAG = 0
                IF(N.LE.4.AND.NSEG.GT.0) IFLAG = 0
                IF(IFLAG.EQ.0) THEN
                  DO JA=IS,IF
                    IF(SURF(JA).GE.0) THEN
C//
                      ISS(JA) = 0
C//
                    ENDIF
                  ENDDO            
                ENDIF
              ENDIF
              IS   = IA
              IF   = IA
              NSEG = ISS(IA)
              ISEG = 1 
            ENDIF   
          ELSE
C           end segment
C           ISEG = 0 
          ENDIF
C//
        ENDIF 
      ENDDO
c ---------------- last segment 
              IF(IS.GT.0.AND.IF.GT.IS) THEN
                N     = 0

                NNN = IF-IS+1

                IFLAG = 1
                IF(IS+1.LE.IF.AND.NSEG.LT.0) THEN
                IFLAG = 0
                DO JA=IS,IF
                  IF(SURF(JA).GE.0) THEN
C//
                    IF(ID_DOM(JA).GT.0) THEN
C                      IF(N.LE.0) THEN
C                        N = N + 1
C                        IF(N.GE.2) IFLAG = 1
C                      ENDIF
C                    ELSE
C                      N = 0
C                      N = ID_DOM(JA-1)+ID_DOM(JA)
                       N = N + ID_DOM(JA)
C                      IF(N.GE.2) IFLAG = 1
                    ENDIF           
C//
                  ENDIF
                ENDDO
                  IF(N.GE.2.AND.NNN.GT.3) IFLAG = 1
                  IF(N.GE.1.AND.NNN.EQ.3) IFLAG = 1
               ENDIF
                N = IF-IS+1
                IF(N.LE.3.AND.NSEG.LT.0) IFLAG = 0
                IF(N.LE.4.AND.NSEG.GT.0) IFLAG = 0
                IF(IFLAG.EQ.0) THEN
                  DO JA=IS,IF
                    IF(SURF(JA).GE.0) THEN
C//
                      ISS(JA) = 0
C//
                    ENDIF
                  ENDDO            
                ENDIF
              ENDIF
C  ---------------
      NH = 0
      NB = 0
      ID_H = 1
      ID_B = 3
      DO I=1,NR
        IF(ISS(I).LT.0) THEN
          NB = NB + 1
          ID_DOM(I) = ABS(ISS(I))
          IF(I.GT.1) THEN
            IF(ID_DOM(I).NE.ID_DOM(I-1).AND.
     *         ISS(I-1).EQ.ID_B             ) THEN
              IF(ID_B.EQ.3) THEN
                ID_B = 4
              ELSE
                ID_B = 3
              ENDIF
            ENDIF
          ENDIF
          ISS(I) = ID_B
        ELSE IF(ISS(I).GT.0) THEN
          NH = NH + 1
          ID_DOM(I) = ABS(ISS(I))
          IF(I.GT.1) THEN
            IF(ID_DOM(I).NE.ID_DOM(I-1).AND.
     *         ISS(I-1).EQ.ID_H             ) THEN
              IF(ID_H.EQ.1) THEN
                ID_H = 2
              ELSE
                ID_H = 1
              ENDIF
            ENDIF
          ENDIF
          ISS(I) = ID_H
        ELSE
          ID_DOM(I) = 0
        ENDIF 

C          WRITE(*,*) '>SS>:',i,ISS(I),ID_DOM(I)

      ENDDO
      NHB = NB + NH
      PH  = (FLOAT(NH)/FLOAT(NR))*100.0
      PB  = (FLOAT(NB)/FLOAT(NR))*100.0
      PSS = (FLOAT(NHB)/FLOAT(NR))*100.0
C ---
      deallocate(TEMPR,STAT=ISTAT)
      deallocate(ID_DOM,STAT=ISTAT)

      RETURN
      END

      SUBROUTINE WRCOOR_SR_DB_ALLOC(MDOC,NAMER,NAMEO
     *     ,OCCR,SURF_KEY,BLIM,SURFR,PNUM,ATOM,NATMX
     *     ,SEG,ACODEA
     *     ,NTOT,NAT,IERR)
C ----------------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER PNUM(NATMX)*6,ATOM(NATMX)*4
      CHARACTER SEG(NATMX)*4,ACODEA(NATMX)*4
      REAL      SURFR(NATMX),OCCR(NATMX)
      CHARACTER ANAME*4,CP_PNUM*6,CP_PNUM_OLD*6
      CHARACTER ASYMB*4,CTYPE*4,RNAME*3,CP_ALT*1
      CHARACTER ANAME_OLD*4,CSURF*6,REC*4
      CHARACTER NAMER*(*),NAMEO*(*),SURF_KEY*1
      CHARACTER LINE*256,PATH*1,EXT*1,CH7*7
C ------------------------------------------------------------
      M     = 99
      MD    =-ABS(MDOC)-1 
      IERR  = 0
C -------------------------------------------------------------------
      CALL CORR_NAME_BLC(NAMEO)
      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.LT.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong output file name')
        IERR = 1
        RETURN
      ENDIF
      IOUT = 11
      EXT  = ' '
      PATH = ' '
      CALL OPENFW(IOUT,M,PATH,NAMEO,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: surface: open output file')
        RETURN
      ENDIF
c--------------------------------------
      CALL CORR_NAME_BLC(NAMER)
      CALL LENSTR_BL(NAMER,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      INC  = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(INC,M,PATH,NAMER,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: surface: open input file')
        CLOSE(IOUT) 
        RETURN
      ENDIF
C -------------------------------------
      ANAME_OLD   = '?'
      CP_PNUM_OLD = '?'
      REC         = '?'
      I           = 1
      NTOT        = 0
      NAT         = 0   
 200  CONTINUE

      READ(INC,'(A)',ERR=500,END=600) LINE
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.54) GO TO 200

      IF(REC.EQ.'ATOM'.AND.LINE(1:4).EQ.'ANIS') THEN
        GO TO 400
      ELSE IF(LINE(1:4).EQ.'ANIS') THEN
        GO TO 200
      ENDIF

      REC = '?'

      IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) GO TO 400

      READ(LINE,'(12X,A4,A1,A3,A7)',ERR=500) ANAME,CP_ALT,RNAME,CH7

      IF(CP_ALT.NE.' '.AND.CP_ALT.NE.'A'.AND.CP_ALT.NE.'1') GO TO 400

      ASYMB='    '
      CALL CORR_NAME(ANAME,RNAME,ASYMB,CTYPE)

      CP_PNUM(1:1) = CH7(2:2)
      CP_PNUM(2:6) = CH7(3:7)
      IF(ANAME.EQ.ANAME_OLD.AND.CP_PNUM.EQ.CP_PNUM_OLD)GO TO 400
      CP_PNUM_OLD  = CP_PNUM
      ANAME_OLD    = ANAME     
      
      IF(ATOM(I).NE.ANAME.OR.CP_PNUM.NE.PNUM(I)) GO TO 210 

      SF = SURFR(I)*20.0 + BLIM
      IF(SF.GT.999.99) SF = 999.99
      IF(OCCR(I).GT.0.001) NAT = NAT + 1
      IF(SF.LE.BLIM) THEN
        IF(OCCR(I).GT.0.001) NTOT = NTOT + 1
      ENDIF
      OCC = 1.0
      IF(OCCR(I).LT.0.001) OCC = 0.0

      WRITE(LINE(55:60),'(F6.2)',ERR=500) OCC

      WRITE(CSURF,'(F6.2)') SF
      LINE(67:72) = CSURF

      LINE(17:17) = ' '
      WRITE(LINE(73:80),'(A4,A4)',ERR=500) SEG(I),ACODEA(I)
      REC = 'ATOM'

      I = I + 1     

 400  CONTINUE

      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
      GO TO 200

 210  CONTINUE

      IF(RNAME.EQ.'HEM'.OR.RNAME.EQ.'HMD'.OR.RNAME.EQ.'HEC'.OR.
     *   RNAME.EQ.'SRM'.OR.RNAME.EQ.'DHE'.OR.RNAME.EQ.'HEA'.OR.
     *   RNAME.EQ.'BCB'.OR.RNAME.EQ.'BPB'                  ) THEN
        SF = BLIM
        WRITE(CSURF,'(F6.2)') SF
        LINE(67:72) = CSURF
        LINE(17:17) = ' '
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
      ENDIF

      GO TO 200
C -------------------------
 600  CONTINUE
      END FILE IOUT
      CLOSE(IOUT)
      CLOSE(INC) 
      RETURN
 500  CONTINUE
      CALL MSGERR(MDOC,' ERROR: in WRCOOR_SR_DB')
      IERR = 1
      CLOSE(IOUT)
      CLOSE(INC) 
      RETURN
      END
      SUBROUTINE CORR_ANAME_PDB(ANAME,RNAME,ASYMB,CTYPE)
C ----------------------------------------------
      PARAMETER (N_NAME = 33)
      CHARACTER ANAME*4,RNAME*3,ASYMB*4,CTYPE*4
C -----------------------------------------------
      CHARACTER TYPE*1,CH1*1,CH2*2,CH4*4
      CHARACTER NAME(N_NAME)*2
      DATA NAME/'CO','MG','CA','ZN','CU','FE','CL','BR','MN','PB',
     *          'HG','AL','GD','NA','CD','NI','SR','IN','HO','YB',
     *          'TE','LI','RB','BA','CS','SM','TL','PT','BE','SE',
     *          'MO','SI','AS'/
c      DATA NAME/'CO','MG','CA','ZN','CU','FE','CL','BR','MN','PB',
c     *          'HG','AL','GD','NA','CD','NI','SR'/
C ??? more
C ---------------------------------------------
      IF(ANAME(1:1).NE.' ') THEN
        CH1=ANAME(1:1)
        CALL CHKSMB(CH1,TYPE)
        IF(TYPE.EQ.'D') THEN
          CALL LENSTR_BL(ANAME,LN)
          IF(LN.LE.1) THEN
            LN=2
            ANAME(2:2)='H'
          ENDIF
          ASYMB = ANAME(2:2)//'   '
          CH4='    '
          CH4(1:LN)=ANAME(2:LN)//CH1
          ANAME=CH4
C         CTYPE='H   '
          IF(ASYMB(1:1).EQ.'H') CTYPE='H   '
        ELSE IF(ANAME(4:4).EQ.' ') THEN
          CH2=ANAME(1:2)
          DO  I=1,N_NAME
            IF(NAME(I).EQ.CH2) THEN
              ASYMB=ANAME(1:2)//'  '
              CTYPE='$   '
              GO TO 100
            ENDIF
          ENDDO
          ASYMB=ANAME(2:2)//'   '
          CTYPE='C   '
          IF(ASYMB(1:1).EQ.'H') CTYPE='H   '
  100     CONTINUE
        ELSE
          ASYMB=ANAME(2:2)//'   '
          CTYPE='C   '
          IF(ASYMB(1:1).EQ.'H') CTYPE='H   '
        ENDIF  
      ELSE
        ASYMB=ANAME(2:2)//'   '
        IF(ASYMB(1:1).EQ.'M') ASYMB='C   '
        IF(ASYMB(1:1).EQ.'C'.OR.ASYMB(1:1).EQ.'N'.OR.
     *     ASYMB(1:1).EQ.'O'.OR.ASYMB(1:1).EQ.'B'.OR.
     *     ASYMB(1:1).EQ.'F'                         ) THEN
          CTYPE='C   '
        ELSE
          CTYPE='$   '
        ENDIF
        IF(ASYMB(1:1).EQ.'H') CTYPE='H   '
      ENDIF
      
      IF(ANAME(1:1).EQ.' ') THEN
        ANAME=ANAME(2:4)//' '
      ENDIF
      IF(ANAME(2:2).EQ.' ') THEN
        ANAME(2:4)=ANAME(3:4)//' '
        IF(ANAME(2:2).EQ.' ') ANAME(2:4)=ANAME(3:4)//' '
      ENDIF
C ---
      IF(RNAME(1:1).EQ.' ') THEN
        RNAME=RNAME(2:3)//' '
        IF(RNAME(1:1).EQ.' ') RNAME=RNAME(2:3)//' '
      ENDIF
      IF(RNAME.EQ.'WAT') RNAME='HOH'
      IF(RNAME.EQ.'DOD') RNAME='HOH'
      IF(RNAME.EQ.'CYT') RNAME='C'
      IF(RNAME.EQ.'ADE') RNAME='A'
      IF(RNAME.EQ.'THY') RNAME='T'
      IF(RNAME.EQ.'GUA') RNAME='G'
      IF(RNAME.EQ.'URI') RNAME='U'

      IF(RNAME(1:1).EQ.'''') RNAME(1:1)='*'
      IF(RNAME(2:2).EQ.'''') RNAME(2:2)='*'
      IF(RNAME(3:3).EQ.'''') RNAME(3:3)='*'
      IF(ANAME(1:1).EQ.'''') ANAME(1:1)='*'
      IF(ANAME(2:2).EQ.'''') ANAME(2:2)='*'
      IF(ANAME(3:3).EQ.'''') ANAME(3:3)='*'
      IF(ANAME(4:4).EQ.'''') ANAME(4:4)='*'

      IF(ANAME.EQ.'H0  ') THEN
        ANAME    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ASYMB.EQ.'D  ') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HE21') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HE22') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HD21') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HD22') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HH11') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HH12') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HH21') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HH22') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HT1 ') THEN
        ANAME    = 'H1  '
        ASYMB    = 'H   '
        CTYPE    = 'H   '
      ENDIF
      IF(ANAME.EQ.'HT2 ') THEN
        ANAME    = 'H2  '
        ASYMB    = 'H   '
        CTYPE    = 'H   '
      ENDIF
      IF(ANAME.EQ.'HT3 ') THEN
        ANAME    = 'H3  '
        ASYMB    = 'H   '
        CTYPE    = 'H   '
      ENDIF

      IF(RNAME.EQ.'HOH') THEN
        IF(ASYMB(1:1).EQ.'O') THEN
          ANAME = 'O   '
          ASYMB = 'O   '
          CTYPE = 'C   '
        ELSE IF(ASYMB(1:1).EQ.'H'.OR.ASYMB(1:1).EQ.'D') THEN
          ASYMB = 'H   '
          CTYPE = 'H   '
        ENDIF
      ENDIF
C ---  special cases ---
      IF(RNAME.EQ.'IUM'.AND.CTYPE.EQ.'$   ') THEN
        RNAME = ANAME(1:2)
      ENDIF

      RETURN
      END

      SUBROUTINE WRIT3(MDOC,LINE,NAM1,NAM2,LINE1,LINE2,LINE3
     *  ,LINE_1N1,LINE_1N2,LINE_1N3,LINE_1N4,LINE_SS1,LINE_SURF1
     *  ,LS1,LS2,LS3,LS4,LS5
     *  ,LINE_2N1,LINE_2N2,LINE_2N3,LINE_2N4,LINE_SS2,LINE_SURF2)
C -------------------------------------------------------- 
      CHARACTER NAM1*4,NAM2*4,LINE*50,LINE1*50,LINE2*50,LINE3*50
      CHARACTER DLINE*80,LINE_SS1*50,LINE_SS2*50
      CHARACTER LINE_SURF1*50,LINE_SURF2*50
      CHARACTER LINE_1N1*50,LINE_1N2*50,LINE_1N3*50,LINE_1N4*50
      CHARACTER LINE_2N1*50,LINE_2N2*50,LINE_2N3*50,LINE_2N4*50
      CHARACTER LS1*50,LS2*50,LS3*50,LS4*50,LS5*50
C =========================================================
      WRITE(DLINE,'(1X,55A)') ('-',I=1,54)
      CALL MSGDOC(MDOC,DLINE)

      WRITE(DLINE,2) LINE_1N1
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,2) LINE_1N2
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,2) LINE_1N3
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,2) LINE_1N4
      CALL MSGDOC(MDOC,DLINE)

C      chain
C      WRITE(DLINE,2) LINE1
C      CALL MSGDOC(MDOC,DLINE)

      WRITE(DLINE,3) LINE_SS1
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,4) LINE_SURF1
      CALL MSGDOC(MDOC,DLINE)
      CALL MSGDOC(MDOC,' ')
      WRITE(DLINE,1) NAM1,LINE
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,1) NAM2,LINE2
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,2) LINE3
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,3) LINE_SS2
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,4) LINE_SURF2
      CALL MSGDOC(MDOC,DLINE)
    1 FORMAT(1X,A4,':',A)
    2 FORMAT(6X,A)
    3 FORMAT('ss',4X,A)
    4 FORMAT('surf',2X,A)

      WRITE(DLINE,2) LINE_2N1
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,2) LINE_2N2
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,2) LINE_2N3
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,2) LINE_2N4
      CALL MSGDOC(MDOC,DLINE)

c --
      WRITE(DLINE,'(1X,55A)') ('-',I=1,54)
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,2) LS5
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,2) LS4
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,2) LS3
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,2) LS2
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,2) LS1
      CALL MSGDOC(MDOC,DLINE)
C --

      WRITE(DLINE,'(1X,55A)') ('-',I=1,54)
      CALL MSGDOC(MDOC,DLINE)
      LINE     = ' '
      LINE1    = ' '
      LINE2    = ' '
      LINE3    = ' '
      LINE_1N1 = ' '
      LINE_1N2 = ' '
      LINE_1N3 = ' '
      LINE_1N4 = ' '
      LINE_2N1 = ' '
      LINE_2N2 = ' '
      LINE_2N3 = ' '
      LINE_2N4 = ' '
      LINE_SS1 = ' '
      LINE_SS2 = ' '
      LINE_SURF1 = ' '
      LINE_SURF2 = ' '
      LS1=      ' '
      LS2=      ' '
      LS3=      ' '
      LS4=      ' '
      LS5=      ' '
      CALL MSGDOC(MDOC,' ')
      RETURN

      END
