C
C     MOLREP molecular replacement program
C     Copyright (C) 1999-2006 Alexei Vagin
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
      SUBROUTINE RFT1(MDOC,POOL8,POOLA,POOLB,NCRES,RESMAX
     * ,NAMED,NAMEF,NAMEPH,IPRSYM
     * ,SFA,SFB,SYM,JHS,JKS,JLS,LSYM,ISYM
     * ,RESULT,IERR)
C ---------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER   ID(3),IDT(7)
CMS      : POOL8,POOLA,POOLB
      REAL      RESULT(11)
      COMPLEX   POOL8(*)
      REAL      POOLA(*),POOLB(*)
      REAL      RLATT(6)
      REAL      SFA(IPRSYM),SFB(IPRSYM)
      INTEGER   JHS(IPRSYM),JKS(IPRSYM),JLS(IPRSYM),LSYM(IPRSYM)
      REAL      SYM(3,IPRSYM)
      CHARACTER LINE*80
      CHARACTER NAMED*(*),NAMEF*(*),NAMEPH*(*)
      CHARACTER TITLE*80,ITYPE*4,PATT*4
C--------------------------------------------------------------
      TWOPI =8.0*ATAN(1.0)
      IERR=0
C --------------------
      MTIN  =40
      ITYPE ='RI  '
      MD=-ABS(MDOC)-1
C     WRITE(*,*) '       INPUT-FILE /DENS/'
      ITYP  =0
      CALL IRDENS(MTIN,NAMED,MD,ITYP,ICNTZ,NX,NY,NZ,IZM,
     * IZN,RMAX,RMIN,POOLA,SCALE,A,B,C,AL,BE,GA,DRMS,
     * RAVER,RESOL,IX0,IY0,IZ0,ITR,TITLE
     * ,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: RFT: FILE--DENS')
        CLOSE(MTIN)
        IERR=1
        RETURN
      ENDIF
C      CALL ORFILE(MD,MTIN,NAMED,ITYPE,NSYM,ISYM,IPRSYM,IERR)
C      IF(IERR.NE.0) THEN
C        CALL MSGERR(MDOC,' ERR: RFT: OPEN FILE--DENS')
C        RETURN
C      ENDIF
C      CALL GET_TITLE(MD,A,B,C,AL,BE,GA
C     *  ,F1,F2,F3,F4,NX,NY,NZ,IZN,IZM,TITLE,IERR)
      CALL C_RD_CR
      NXY=NX*NY
      IF(IZN.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: RFT: IZMIN # 0')
        IERR=1
        RETURN
      ENDIF
      IF(NXY.GT.NCRES) THEN
        WRITE(LINE,
     *  '('' ERR: RFT: not memory '',I4,'' x'',I4,'' >'',I8)')
     *             NX,NY,NCRES
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF
      IF(TITLE(1:4).EQ.'PATT') THEN
        PATT='Y'
      ELSE
        PATT='N'
      ENDIF
C  ------------------------------------
      RLATT(1)=A
      RLATT(2)=B
      RLATT(3)=C
      RLATT(4)=AL
      RLATT(5)=BE
      RLATT(6)=GA
      CALL DSTARF(RLATT,AST,BST,CST,COALST,COBEST,COGAST,VOL)
      M=99
      CALL ANOMF(M,NSYM,ISYM)
      IF(RESMAX.LT.1.E-4) RESMAX=RESOL
      DO     I=1,NSYM
        IF(ISYM(3,1,I).NE.0.OR.ISYM(3,2,I).NE.0.OR.
     *     (ISYM(3,3,I).NE.1.AND.ISYM(3,3,I).NE.-1)) THEN
C    *    IABS(INT(ISYM(3,3,I))).NE.1) THEN
          IERR=-1
          CLOSE(MTIN)
          RETURN
        ENDIF
        DO     J=1,3
          SYM(J,I)=(TWOPI*ISYM(4,J,I))/REAL(ISYM(5,J,I))
        ENDDO
      ENDDO
C ---------------------------------------------------
      RHMIN=10.0
      IH=1
      IK=0
      IL=0
      CALL DSTAR(IH,IK,IL,RH)
      RH=SQRT(RH)
      IF(RH.LT.RHMIN) RHMIN=RH
      IH=0
      IK=1
      IL=0
      CALL DSTAR(IH,IK,IL,RH)
      RH=SQRT(RH)
      IF(RH.LT.RHMIN) RHMIN=RH
      IH=0
      IK=0
      IL=1
      CALL DSTAR(IH,IK,IL,RH)
      RH=SQRT(RH)
      IF(RH.LT.RHMIN) RHMIN=RH
      RESMIN=1./RHMIN
C     WRITE(*,*) '      OUTPUT FILE-FMOD'
      MTF=30
      TITLE(1:4)='F   '
      ITYPE='F   '
      TITLE(5:8)='RFT '
      F1   =1.0
      F2   =0.0
      MD=MDOC
      CALL C_CR_WR
      CALL SET_TITLE(MD,A,B,C,
     *  AL,BE,GA,F1,F2,RESMIN,RESMAX,
     *  IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
      CALL OWFILE(MD,MTF,NAMEF,ITYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: RFT: FILE-F')
        CLOSE(MTIN)
        RETURN
      ENDIF
C      WRITE(*,*) '      OUTPUT FILE-PHAS'
      MTPH=33
      TITLE(1:4)='PH  '
      TITLE(5:8)='RFT '
      ITYPE='PH  '
      MD=-ABS(MDOC)-1
      CALL SET_TITLE(MD,A,B,C,
     *  AL,BE,GA,F1,F2,RESMIN,RESMAX,
     *  IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
      CALL OWFILE(MD,MTPH,NAMEPH,ITYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: RFT: FILE-PH')
        CLOSE(MTIN)
        CLOSE(MTF)
        RETURN
      ENDIF
C -------------------------------------------------------

      RHMAX=1./RESMAX
      WRITE(LINE,'('' RESOLUTION:'',F7.3)') RESMAX
      CALL MSGDOC(MDOC,LINE)
      CALL LIMHKL(RESMAX,IHMAX,IKMAX,LMAX,NXMIN,NYMIN,NZMIN)
      CALL MSGDOC(MDOC,' For this resolution:')
      WRITE(LINE,1020) IHMAX,IKMAX,LMAX
 1020 FORMAT(' Hmax,Kmax,Lmax :',3I4)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,1021) NXMIN,NYMIN,NZMIN
 1021 FORMAT(' NXmin,NYmin,NZmin :',3I4)
      CALL MSGDOC(MDOC,LINE)
c      IHMAX  =(NX+2)/2
c      IKMAX  =(NY+2)/2
c      LMAX   =(NZ+2)/2
c      WRITE(LINE,1022) IHMAX,IKMAX,LMAX
c 1022 FORMAT(
c     * ' From NX,NY,NZ of dens-file Hmax,Kmax,Lmax are :',3I4)
c      CALL MSGDOC(MDOC,LINE)


      LMAX1 =LMAX+1
      NZ1   =IZM+1
      NX1   =NX+1
      NX2   =NX+2
      NXB2  =NX/2
      NYB2  =NY/2
      ZER   =0.0
      COEF  =(NX*NY*NZ)/(VOL)
      FMIN =0.0
C ------
      DELANG=TWOPI/FLOAT(NZ)
      DELSN =SIN(DELANG)
      DELCS =COS(DELANG)
      CSAN  =1.0
      SNAN  =0.0
C ------
      NBL  =0
      NBL11=0
      IENDN=-1
      IEND =-1
      IEND1=-1
      NUMB =0
C ---
      SUMF =0.
      SF2C =0.
C ---
      ID(1)=NX
      ID(2)=NY
      ID(3)=0
C ---
      N000 =0
C -----------------------------------
      CALL RDINDX(IHN,IKN,ILN,IHMAX,IKMAX,LMAX
     * ,RHMIN,RHMAX,NSYM,ISYM,IPRSYM,IENDN)
      IF(IENDN.EQ.1) GO TO 200
C ==============================================
      LINE=' '
      CALL MSGDOC(MDOC,LINE)
      DO     IL=1,LMAX1
C -------------------------------------
        CALL CLOCK(IDT)
        ILR=IL-1
        WRITE(LINE,'(''    L='',I5,10X,I2,''.'',I2,''.'',I2)')
     .           ILR,IDT(4),IDT(3),IDT(2)
        M=99         
        IF(MDOC.GE.0.AND.MDOC.LT.99) M=0
        CALL MSGDOC(M,LINE)
C ----------------------------
        CALL INDENS(MTIN,NAMED,NSYM,ISYM,IPRSYM
     *    ,NZ1,NXY,POOLA,POOLB,POOL8,CSAN,SNAN,
     *             DELCS,DELSN,MDOC,IERR)
        IF(IERR.GT.0) THEN
          CLOSE(MTIN)
          CLOSE(MTF)
          CLOSE(MTPH)
          RETURN
        ENDIF
C  ---------------------------
        CALL MDCFT2(POOL8,ID,IERR)
        IF(IERR.GT.0) THEN
          CALL MSGERR(MDOC,' ERR: IN MDCFT2')
          CLOSE(MTIN)
          CLOSE(MTF)
          CLOSE(MTPH)
          RETURN
        ENDIF
C -----------------------------------------------------
        IF(ILR.EQ.0) THEN
          F000=(POOLA(2)*NSYM)/(COEF)
          FMIN=F000*0.000001
          IF0=0
          MH=0
          MK=0
          ML=0
          FA=1.
          FB=0.
          CALL WRT (MTF ,MH,MK,ML,F000,ZER,NBL  ,IEND )
          CALL WRT1(MTPH,MH,MK,ML,FA  ,FB ,NBL11,IEND1)
          N000=1
       ENDIF
C------------------------------------------------------
  500   IF(ILN.LT.ILR) GO TO 400
        IF(ILN.GT.ILR) GO TO 300
        IF(IABS(IHN).GE.NXB2.OR.IABS(IKN).GE.NYB2) GO TO 400
        MH=IHN
        MK=IKN
        ML=ILN
        NS =0
C---------------
        DO     I=1,NSYM
          IHS=ISYM(1,1,I)*IHN+ISYM(1,2,I)*IKN+ISYM(1,3,I)*ILN
          IKS=ISYM(2,1,I)*IHN+ISYM(2,2,I)*IKN+ISYM(2,3,I)*ILN
          ILS=ISYM(3,1,I)*IHN+ISYM(3,2,I)*IKN+ISYM(3,3,I)*ILN
          LSYM(I)=1
          IF(ILS.LT.0) THEN
            IHS=-IHS
            IKS=-IKS
            ILS=-ILS
            LSYM(I)=-LSYM(I)
          ENDIF
C
          IF(IABS(IKS).GE.NYB2) GO TO 400
          IF(IABS(IHS).GE.NXB2) GO TO 400
C
c          IF(NS.GT.0) THEN
c            IF(ILS.EQ.0.AND.IKS.LT.0) THEN
c              IKS=-IKS
c              IHS=-IHS
c              LSYM(I)=-LSYM(I)
c            ENDIF
c            IF(ILS.EQ.0.AND.IKS.EQ.0.AND.IHS.LT.0) THEN
c              IHS=-IHS
c              LSYM(I)=-LSYM(I)
c            ENDIF
C
c            IF(IKS.GE.0.AND.MK.GE.0) THEN
c              IF(MH.LT.IHS) THEN
c                MH=IHS
c                MK=IKS
c                GO TO 400
c              ENDIF
c            ELSE
c              IF((IKS.GT.MK).OR.(IKS.EQ.MK.AND.MH.LT.IHS)) THEN
c                MH=IHS
c                MK=IKS
c                GO TO 400
c              ENDIF
c            ENDIF
c          ENDIF
          NS=NS+1
          JHS(NS)=IHS
          JKS(NS)=IKS
          JLS(NS)=ILS
        ENDDO
C ---------------------
        IF(NS.EQ.0) GO TO 400
C ---------------------
        FA=0.
        FB=0.
        DO     I=1,NS
          IHS =JHS(I)
          IKS =JKS(I)
          ILS =JLS(I)
          IF(IKS.LT.0) IKS=IKS+NY
          IKSS=IKS
          IKS =IKS*NX
          IF(IHS.LT.0) IHS=IHS+NX
          IND1=IKS+IHS+1
          IND =IND1*2
          IF(ABS(ILS).EQ.ML) THEN
            SFA(I)= POOLA(IND)/COEF
            SFB(I)=-POOLB(IND)/COEF
            IF(LSYM(I).LT.0) SFB(I)=-SFB(I)
            ARG   =MH*SYM(1,I)+MK*SYM(2,I)+ML*SYM(3,I)
            COSD  =COS(ARG)
            SIND  =SIN(ARG)
            STOR  =SFA(I)*COSD-SFB(I)*SIND
            SFB(I)=SFB(I)*COSD+SFA(I)*SIND
            SFA(I)=STOR
            FA    =FA+SFA(I)
            FB    =FB+SFB(I)
          ENDIF
        ENDDO
C----------------------------------------
        FD =FA*FA+FB*FB
        FD2=FD
        FD =SQRT(FD)
        FDD=FD
        IF(FDD.GE.FMIN) THEN
          SF2C=SF2C+FD2
          SUMF=SUMF+FDD
          NUMB=NUMB+1
C
          FA  =FA/FD
          FB  =FB/FD
          IF(PATT.EQ.'Y') THEN
            FDD=SQRT(FDD)
          ENDIF
          CALL WRT(MTF  ,MH,MK,ML,FDD,ZER,NBL  ,IEND )
          CALL WRT1(MTPH,MH,MK,ML,FA ,FB ,NBL11,IEND1)
C
        ENDIF
C --------------------------------
  400   CONTINUE
        CALL RDINDX(IHN,IKN,ILN,IHMAX,IKMAX,LMAX
     *  ,RHMIN,RHMAX,NSYM,ISYM,IPRSYM,IENDN)
        IF(IENDN.GT.0) GO TO 200
        GO TO 500
C ------------------------------------------------
  300   CONTINUE
      ENDDO
C  ===============================================
  200 CONTINUE
      IEND =2
      IEND1=2
      CALL WRT (MTF ,MH,MK,ML,FD,ZER,NBL  ,IEND )
      CALL WRT1(MTPH,MH,MK,ML,FA,FB ,NBL11,IEND1)
      CLOSE(MTF)
      CLOSE(MTPH)
      CLOSE(MTIN)
C------------------------
      IF(NUMB.GT.0) THEN
        SUMF=SUMF/NUMB
        SF2C=SF2C/NUMB
      ENDIF
      SUMF=SQRT(SF2C)  
      NUMB=NUMB+N000
      WRITE(LINE,1010) NUMB,SUMF,SF2C
 1010 FORMAT(' WRITE NUMB OF REFLS=',I8,' <F-MOD>=',G15.4,
     * ' <F**2>=',G15.4)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' F000,VOL :'',2G15.4)') F000,VOL
      CALL MSGDOC(MDOC,LINE)
      RESMIN=1./RHMIN
      WRITE(LINE,'('' RESOLUTION:'',2F7.3)') RESMIN,RESMAX
      CALL MSGDOC(MDOC,LINE)
C -------------------------------------------------
      RESULT(1)=NUMB
      RESULT(2)=RESMIN
      RESULT(3)=RESMAX
      RESULT(4)=F000
      RESULT(5)=SUMF
      RESULT(6)=SF2C
      IF(NUMB.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: RFT: Number of reflections = 0')
        IERR=1
      ENDIF
      RETURN
      END

      SUBROUTINE RTRANS(MDOC
     *  ,NAMER,NAMEO,CHI,NSYM,ISYM,IPRSYM,IERR)
C -------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER NAMER*(*),LINE*80,NAMEO*(*),TITLE*80,TYPE*4
C ---
      real,       allocatable :: POOL(:)
      integer*2,  allocatable :: IPOOL(:)
C ========================================================================
      IERR  = 0
      MD    = -ABS(MDOC)-1
      M     = 99
C ---
      MT    = 10
      TYPE  = 'RI  '
      CALL ORFILE(M,MT,NAMER,TYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE-ROT-RES')
        RETURN
      ENDIF
      CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *        ,F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TITLE,IERR)
      CLOSE(MT)
      IF(IERR.GT.0) RETURN
      NXY=NX*NY
      IT = 0
      allocate(POOL(1:NXY),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      IF(IT.GT.0) THEN
        IERR = 1
        CALL MSGERR(MDOC,
     *    ' ERROR: in RTRANS: problem with memory allocation')
        CALL MSGERR(MDOC,
     *    '                   try to change resolution')
        RETURN
      ENDIF
      MT    = 10
      ITYPE = 0
      CALL IRDENS(MT,NAMER,MD,ITYPE,ICNTZ,NX,NY,NZ,IZMAX,IZMIN,RMAX,
     *  RMIN,POOL,SCALE,A,B,C,AL,BE,GA,DRMS,RAVER,RESOL,IX0,IY0,IZ0
     *  ,ITR,TITLE,NSYM,ISYM,IPRSYM,IERR)
      deallocate(POOL,STAT=ISTAT)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE-ROT-RES')
        RETURN
      ENDIF
      CLOSE(MT)
C ---
      NX2    = 72+2
      NZ2    = 36+2
      NXY2   = NX2*NZ2
      NXY    = NX*NY
      NZ     = IZMAX-IZMIN+1
      NXYZ   = NXY*NZ
      IT = 0
      allocate(POOL(1:NXY2),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(IPOOL(1:NXYZ),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      IF(IT.GT.0) THEN
        IERR = 1
        CALL MSGERR(MDOC,
     *    ' ERROR: in RTRANS: problem with memory allocation')
        CALL MSGERR(MDOC,
     *    '                   try to change resolution')
        RETURN
      ENDIF
C --
      NSYMF = 1
      CALL SRTRANS(MDOC
     *  ,NAMER,NAMEO,CHI,NSYMF,IPOOL,NXYZ,POOL,NXY2
     *  ,NSYM,ISYM,IPRSYM,IERR)

      deallocate(POOL,STAT=ISTAT)
      deallocate(IPOOL,STAT=ISTAT)

      RETURN
      END

      SUBROUTINE CFFTS(MDOC,LAP,NX,NY,NZ,IZMIN,IZMAX,F000,NAMEF1
     * ,NAMEF2,NAMED,RESULT,IPRROW,ISYM,IH,IK,IL,FA,FB
     * ,RESMIN,RESMAX,IPRSYM,NAMEPH,BADD,BOFF,ASYM,SCALE,IERR)
C ---------------------------------------------
C      COMPLEX   POOL(*)
      complex,  allocatable :: POOL(:)

      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER   IH(IPRSYM),IK(IPRSYM),IL(IPRSYM)
      INTEGER   NX,NY,NZ,IZMIN,IZMAX
      INTEGER   MDOC,NCRES2,IPRSYM,IERR
      REAL      F000,FA(IPRSYM),FB(IPRSYM)
      CHARACTER NAMEF1*(*),NAMEF2*(*),NAMED*(*),NAMEPH*(*)
     *         ,LAP*1,ASYM*1
      REAL      RESULT(IPRROW,51)
C ----------------------------------------------------------------------
      COMMON/COM_VLD/ DMAX1T,DMIN1T,SUM1,SUM21,NUMB1,NPOS,NNEG,NZER
     * ,SUMP,SUMN,SUMP2,SUMN2,SUM31,SUM41,P000
C ----------------------------------------------------------------------
      INTEGER   IDIM(3)
      COMPLEX   CDM,SM
      REAL      RLATT(6)
      REAL      CZL(512),SZL(512)
      CHARACTER TITLE*80,ITP*4,ITPH*4,LINE*80,MSG*1,ITP2*4
C ==============================================================
      IERR    = 0
      PI      = 4.0*ATAN(1.0)
      TWOPI   = 2.0*PI
      FOURPI2 = -4.0*PI*PI
C ---
      M       = 99
      MD      = -ABS(MDOC)-1
C -------------------------------
      IF(LAP .EQ.'y') LAP  = 'Y'
      IF(LAP .NE.'Y') LAP  = 'N'
      IF(ASYM.EQ.'y') ASYM = 'Y'
      IF(ASYM.NE.'Y') ASYM = 'N'
      IF(ABS(SCALE).LT.0.0001) SCALE=1.0
C -------------------------------   
      MTIN  =25
      ITP   ='FF  '
      CALL ORFILE(MD,MTIN,NAMEF1,ITP,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: CFFT: OPEN FILE-F')
        RETURN
      ENDIF
      CALL GET_TITLE(MD,RLATT(1),RLATT(2),RLATT(3),RLATT(4),RLATT(5)
     * ,RLATT(6),F1,F2,RN,RX,IDM,IDM,IDM,IDM,IDM,TITLE,IERR)

C      CALL RTITLE(MTIN,NAMEF1,MDOC,ITP,IPRINT,DM,DM,DM,DM,DM,DM,
C     *            F1,F2,F3,RX,IDM,IDM,IDM,IDM,IDM,TITLE)

       CALL C_RD_CR
C ----
      A    =RLATT(1)
      B    =RLATT(2)
      C    =RLATT(3)
      ALPHA=RLATT(4)
      BETA =RLATT(5)
      GAMMA=RLATT(6)
      CALL DSTARF(RLATT,AS,BS,CS,ALS,BES,GAS,VOL)
C ----
C     VOLUME OF CELL
C
      S=(ALPHA+BETA+GAMMA)*0.5
      VOL=2.0*A*B*C*
     *    SQRT(SIN(S)*SIN(S-ALPHA)*SIN(S-BETA)*SIN(S-GAMMA))
C -----------------------------------------------
      CALL LENSTR_BL(NAMEPH,LEN)
      IF(LEN.LE.0.OR.NAMEPH(1:1).EQ.' '.OR.NAMEPH(1:1).EQ.',') THEN
        MTPH=0
      ELSE
        ITPH='PH  '
        MTPH=26
        CALL ORFILE(MD,MTPH,NAMEPH,ITPH,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: CFFT: OPEN FILE-PH')
          CLOSE(MTIN)
          IF(MTPH.GT.0) CLOSE(MTPH)
          RETURN
        ENDIF
        CALL GET_TITLE(MD,RLATT(1),RLATT(2),RLATT(3),RLATT(4),RLATT(5)
     *  ,RLATT(6),CF,BT,RN3,RX3,IDM,IDM,IDM,IDM,IDM,LINE,IERR)
      ENDIF
C ----
      CALL LENSTR_BL(NAMEF2,LEN)
      IF(LEN.LE.0.OR.NAMEF2(1:1).EQ.' '.OR.NAMEF2(1:1).EQ.',') THEN
        MTF=0
      ELSE
        MTF=24
        ITP2='FF  '
        CALL ORFILE(MD,MTF,NAMEF2,ITP2,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: CFFT: OPEN FILE-F_2')
          CLOSE(MTIN)
          IF(MTPH.GT.0) CLOSE(MTPH)
          RETURN
        ENDIF
        CALL GET_TITLE(MD,RLATT(1),RLATT(2),RLATT(3),RLATT(4),RLATT(5)
     *  ,RLATT(6),CF,BT,RN2,RX2,IDM,IDM,IDM,IDM,IDM,LINE,IERR)
      ENDIF
C ---------------------------------------
      IF(RESMIN.LE.0.0) RESMIN=RN
      IF(RESMAX.LE.0.0) RESMAX=RX
      IF(MTF.GT.0) THEN
        IF(RESMIN.GT.RN2) RESMIN=RN2
      ENDIF
      IF(MTPH.GT.0) THEN
        IF(RESMIN.GT.RN3) RESMIN=RN3
      ENDIF
      IF(MTF.GT.0) THEN
        IF(RESMAX.LT.RX2) RESMAX=RX2
      ENDIF
      IF(MTPH.GT.0) THEN
        IF(RESMAX.LT.RX3) RESMAX=RX3
      ENDIF
      WRITE(LINE,'(''RESOLUTIOM: MIN,MAX '',2F7.2)') 
     *  RESMIN,RESMAX
      CALL MSGDOC(MD,LINE)
      IF(RESMAX.GT.RESMIN) THEN
        STOR=RESMIN
        RESMIN=RESMAX
        RESMAX=STOR
      ELSE IF(RESMAX.EQ.RESMIN) THEN
        IERR=1
        RETURN
      ENDIF
      RSMIN=1./RESMIN
      RSMAX=1./RESMAX
C ----
      CALL LIMHKL(RESMAX,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)
C ----
      CALL MSGDOC(MD,'Minimal grid spacing for calculation SF:') 
      WRITE(LINE,1000) NXMIN,NYMIN,NZMIN
 1000 FORMAT(' NXmin=',I3,', NYmin=',I3,', NZmin=',I3) 
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,1020) IHMAX,IKMAX,ILMAX
 1020 FORMAT(' Hmax,Kmax,Lmax :',3I4)
      CALL MSGDOC(MD,LINE)
      IF(NX.LE.0) NX=NXMIN
      IF(NY.LE.0) NY=NYMIN
      IF(NZ.LE.0) NZ=NZMIN
      NX   =(NX/2)*2
      NY   =(NY/2)*2
      NZ   =(NZ/2)*2
      IF(NX.LT.2*IHMAX+1) 
     * CALL MSGDOC(MD,' !!! Warning : Nx < 2Hmax+1')
      IF(NY.LT.2*IKMAX+1) 
     * CALL MSGDOC(MD,' !!! Warning : Ny < 2Kmax+1')
      IF(NZ.LT.2*ILMAX+1) 
     * CALL MSGDOC(MD,' !!! Warning : Nz < 2Lmax+1')
      WRITE(LINE,1030) NX,NY,NZ
 1030 FORMAT('GRID: NX=',I3,', NY=',I3,', NZ=',I3) 
      CALL MSGDOC(MD,LINE)

      IF(ILMAX.LT.0)  ILMAX=0

      IF(ILMAX.GT.511) ILMAX=511

      NX2  =NX/2
      NXY=NX*NY
c      NCRES=NCRES2*2
c      IF(NXY.GT.NCRES) THEN
c        WRITE(LINE,
c     * '('' ERR: not enough memory for one section of dens.'')')
c        CALL MSGERR(MDOC,LINE)
c        WRITE(LINE,'('' NX='',I4,'' NY='',I4,'' MEMORY-SIZE='',I6)')
c     *                  NX,NY,NCRES
c        CALL MSGERR(MDOC,LINE)
c        WRITE(LINE,'('' must by: NX x NY < '',I6)') NCRES
c        CALL MSGERR(MDOC,LINE)
c        IERR=1
c        CLOSE(MTIN)
c        IF(MTF.GT.0) CLOSE(MTF)
c        RETURN
c      ENDIF
      NXY=NXY/2

      allocate(POOL(1:NXY),STAT=ISTAT)
      IF(ISTAT.NE.0) THEN
        IERR = 1
        CALL MSGERR(MDOC,
     *    ' ERROR: in CFFT : problem with memory allocation')
        CALL MSGERR(MDOC,
     *    '                  try to change resolution')
        CLOSE(MTIN)
        IF(MTF.GT.0) CLOSE(MTF)
        RETURN
      ENDIF


      IIZMIN=0
      IIZMAX=0
      CALL SET_LIMZ(NSYM,ISYM,NZ,IZMAXD)
      IF(IZMIN.EQ.0.AND.IZMAX.LT.0) THEN
        IIZMIN=0
        IIZMAX=IZMAXD
        IF(NSYM.EQ.2) THEN
          IF(ISYM(1,2,2).EQ.0.AND.
     *       ISYM(2,2,2).EQ.1.AND.
     *       ISYM(3,2,2).EQ.0     ) IIZMAX = NZ - 1
        ENDIF
        IF(MTPH.EQ.0) IIZMAX=NZ/2
      ELSE
        IIZMAX=IZMAX
        IIZMIN=IZMIN
        IF(IIZMAX.LT.IIZMIN) THEN
          T=IIZMAX
          IIZMAX=IIZMIN
          IIZMIN=T
        ENDIF
      ENDIF
      IZMIN=IIZMIN
      IZMAX=IIZMAX

      IF(F000.EQ.0.0) THEN
        MSG='N'
      ELSE IF(F000.GT.0.0) THEN
        MSG='I'
      ELSE
        MSG='Y'
      ENDIF

      IF(MTPH.EQ.0) THEN
        IPATT=1
        ITP  ='PATT'
      ELSE
        IPATT=0
        ITP  ='FOUR'
      ENDIF

      TITLE(1:4)=ITP
      IF(MTF.LE.0) THEN
        IF(LAP.EQ.'Y') THEN
          TITLE(5:8)='LAPL'
        ELSE
          TITLE(5:8)='    '
        ENDIF
      ELSE
        IF(LAP.EQ.'Y') THEN
          TITLE(5:8)='LDIF'
        ELSE
          TITLE(5:8)=' DIF'
        ENDIF
      ENDIF
C ----
      MTOUT=0
      CALL LENSTR_BL(NAMED,LEN)
      IF(LEN.GT.0.AND.NAMED(1:1).NE.' '.AND.NAMED(1:1).NE.',') THEN
        MTOUT = 43
        ITP   = 'RI  '
        CALL C_CR_WR
        CALL SET_TITLE(MD,RLATT(1),RLATT(2),RLATT(3),RLATT(4),RLATT(5)
     * ,RLATT(6),F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TITLE,IERR)
        CALL OWFILE(MD,MTOUT,NAMED,ITP,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          deallocate(POOL,STAT=ISTAT)
          CALL MSGERR(MDOC,' ERR: CFFT: OPEN FILE-DENS')
          CLOSE(MTIN)
          IF(MTF .GT.0) CLOSE(MTF)
          IF(MTPH.GT.0) CLOSE(MTPH)
          CLOSE(MTOUT)
          RETURN
        ENDIF
      ELSE
        WRITE(LINE,'(''Resolution:'',2F8.3)') RESMIN,RESMAX
        CALL MSGDOC(MD,LINE)
        CALL LENSTR_BL(TITLE,LEN)
        IF(LEN.GT.0) THEN
          IF(LEN.GT.80) LEN=80
          CALL MSGDOC(MD,TITLE(1:LEN))
        ENDIF
      ENDIF
C ----
c      ICPU=0
c      CALL CPU(ICPU)
C ----
      ZERO    = 0.0
      CDM     = CMPLX(ZERO,ZERO)
      ITP     = '    '
      IPRINT  = 0
      IX0     = 0
      IY0     = 0
      IZ0     = IZMIN
      ITR     = 0
      ICNTZ   = -999
      IDIM(1) = NX2
      IDIM(2) = NY
      IDIM(3) = 0
      IFIRST  = 0
C -------------------------------------------------
      DMAX1T = -1.E30
      DMIN1T =  1.E30
      SUM1   = 0.0
      SUM21  = 0.0
      NUMB1  = 0
      NPOS   = 0
      NNEG   = 0
      NZER   = 0
      SUMP   = 0.0
      SUMN   = 0.0
      SUMP2  = 0.0
      SUMN2  = 0.0
      SUM31  = 0.0
      SUM41  = 0.0      
C =================================================
      DO     IZ=IZMIN,IZMAX

        Z   = FLOAT(IZ)/FLOAT(NZ)
        ANG = TWOPI*Z
        CSZ = COS(ANG)
        SNZ = SIN(ANG)

        CZL(1) = 1.0
        SZL(1) = 0.0
        DO     I=2,512
          CZL(I) = CZL(I-1)*CSZ - SZL(I-1)*SNZ
          SZL(I) = SZL(I-1)*CSZ + CZL(I-1)*SNZ
        ENDDO

        DO     I=1,NXY
          POOL(I) = CDM
        ENDDO

        IF(MSG.EQ.'I') THEN
          TEMP   = F000
          SM     = CMPLX(TEMP,ZERO)
          POOL(1)= SM
C ---
          IF(IFIRST.EQ.0) THEN
            WRITE(LINE,'(''input F000 ='',G16.4)') F000
            CALL MSGDOC(MDOC,LINE)
            IFIRST=1
          ENDIF
C -----
        ENDIF
C---------------
        REWIND MTIN
        IF(MTF .GT.0) REWIND MTF
        IF(MTPH.GT.0) REWIND MTPH
        CALL OPFILE(M,MTIN,NAMEF1,ITP,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          deallocate(POOL,STAT=ISTAT)
          CALL MSGERR(MDOC,' ERR: CFFT: FILE-F_1')
          CLOSE(MTIN)
          IF(MTF  .GT.0) CLOSE(MTF)
          IF(MTPH .GT.0) CLOSE(MTPH)
          IF(MTOUT.GT.0) CLOSE(MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(MTF.GT.0) THEN
          CALL OPFILE(M,MTF,NAMEF2,ITP2,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            deallocate(POOL,STAT=ISTAT)
            CALL MSGERR(MDOC,' ERR: CFFT: FILE-F_2')
            CLOSE(MTIN)
            IF(MTF  .GT.0) CLOSE(MTF)
            IF(MTPH .GT.0) CLOSE(MTPH)
            IF(MTOUT.GT.0) CLOSE(MTOUT)
            IERR=1
            RETURN
          ENDIF
        ENDIF
        IF(MTPH.GT.0) THEN
          CALL OPFILE(M,MTPH,NAMEPH,ITPH,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            deallocate(POOL,STAT=ISTAT)
            CALL MSGERR(MDOC,' ERR: CFFT: FILE-PH')
            CLOSE(MTIN)
            IF(MTF  .GT.0) CLOSE(MTF)
            IF(MTPH .GT.0) CLOSE(MTPH)
            IF(MTOUT.GT.0) CLOSE(MTOUT)
            IERR=1
            RETURN
          ENDIF
        ENDIF
        IEND  = -1
        IENDF = -1
        IENDP = -1
        NUMBF = 0
        NUMBP = 0
        NUMB  = 0
        LL    = -1
        LK    = 0
        LH    = 0
        LLF   = -1
        LKF   = 0
        LHF   = 0
C----------------------------------------------------------------
  300   CONTINUE

        IF(IEND.GT.0) GO TO 200
        IF(ITP.EQ.'F   ') THEN
          CALL RD1(MTIN,IH(1),IK(1),IL(1),AP,BP,NUMB,IEND)
C         SIG-DUMMY
          SAP = 0.04*AP
          SBP = 0.04*BP
        ELSE
          CALL RRD1(MTIN,IH(1),IK(1),IL(1),AP,BP,SAP,SBP
     *   ,NUMB,IEND)
        ENDIF
        IF(AP.GT.1.E-6.AND.BP.GT.1.E-6) THEN
          IF(SAP.LT.0.000001) SAP=1.0
          IF(SBP.LT.0.000001) SBP=1.0
          WT1 = 1./(SAP*SAP)
          WT2 = 1./(SBP*SBP)
          WT  = WT1+WT2
          AP  = AP*WT1+BP*WT2
          AP  = AP/WT
          SAP = 1./SQRT(WT)
        ELSE IF(BP.GT.1.E-6) THEN
          AP  = BP
          SAP = SBP
        ENDIF
        IF(MTIN.LE.0) THEN
          deallocate(POOL,STAT=ISTAT)
          CALL MSGERR(MDOC,' ERR: CFFT: FILE-F_1')
          CLOSE(MTIN)
          IF(MTF  .GT.0) CLOSE(MTF)
          IF(MTPH .GT.0) CLOSE(MTPH)
          IF(MTOUT.GT.0) CLOSE(MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(IEND.GT.0) GO TO 200
C ----------------------------------
C       USE F000
C
        IF(IH(1).EQ.0.AND.IK(1).EQ.0.AND.IL(1).EQ.0) THEN

          IF(MSG.EQ.'Y')THEN
            IF(LAP.EQ.'Y') GO TO 300
            IF(MTF.GT.0)   GO TO 300
            TEMP = AP*SCALE
            IF(MTPH.LE.0) THEN
              TEMP = TEMP*TEMP
            ENDIF
            F000    = TEMP/(VOL)
            TEMP    = F000
            SM      = CMPLX(TEMP,ZERO)
            POOL(1) = SM
C ---
            IF(IFIRST.EQ.0) THEN
              WRITE(LINE,'('' F000 ='',G16.4)') F000
              CALL MSGDOC(MDOC,LINE)
              IFIRST=1
            ENDIF
          ENDIF
          GO TO 300
        ENDIF
        CALL DSTAR(IH(1),IK(1),IL(1),RSQ)
        RH = SQRT(RSQ)
        IF(RH.LT.RSMIN.OR.RH.GT.RSMAX) GO TO 300        

        IF(BOFF.GT.0.0) THEN
          BT    = BOFF/4.0
          CBOFF = 1.0-EXP(-BT*RSQ)
        ELSE
          CBOFF = 1.0
        ENDIF

        IF(ABS(BADD).GT.0.000001) THEN
          BT    = BADD/4.0
          CBADD = EXP(-BT*RSQ)
        ELSE
          CBADD = 1.0
        ENDIF
C

  550   IF(IEND.GT.0.OR.IENDF.GT.0) GO TO 200
        IF(MTF.LE.0) GO TO 360

c        IF(LLF-IL(1)) 370,340,300
c  340   IF(LKF-IK(1)) 370,350,300
c  350   IF(LHF-IH(1)) 370,360,300

        IF((LLF-IL(1)).LT.0) GO TO 370
        IF((LLF-IL(1)).EQ.0) GO TO 340
        IF((LLF-IL(1)).GT.0) GO TO 300
  340   IF((LKF-IK(1)).LT.0) GO TO 370
        IF((LKF-IK(1)).EQ.0) GO TO 350
        IF((LKF-IK(1)).GT.0) GO TO 300
  350   IF((LHF-IH(1)).LT.0) GO TO 370
        IF((LHF-IH(1)).EQ.0) GO TO 360
        IF((LHF-IH(1)).GT.0) GO TO 300

  370   IF(IENDF.GT.0) GO TO 200
        IF(ITP2.EQ.'F   ') THEN
          CALL RD2(MTF,LHF,LKF,LLF,AD,BD,NUMBF,IENDF)
C         SIG-DUMMY
          SAD = 0.04*AD
          SBD = 0.04*BD
        ELSE
          CALL RRD2(MTF,LHF,LKF,LLF,AD,BD,SAD,SBD,NUMBF,IENDF)
        ENDIF
        IF(AD.LE.1.E-6.AND.BD.LE.1.E-6) GO TO 370
        IF(AD.GT.1.E-6.AND.BD.GT.1.E-6) THEN
          IF(SAD.LT.0.000001) SAD = 1.0
          IF(SBD.LT.0.000001) SBD = 1.0
          WT1 = 1./(SAD*SAD)
          WT2 = 1./(SBD*SBD)
          WT  = WT1+WT2
          AD  = AD*WT1+BD*WT2
          AD  = AD/WT
          SAD = 1./SQRT(WT)
        ELSE IF(BD.GT.1.E-6) THEN
          AD  = BD
          SAD = SBD
        ENDIF
        IF(MTF.LE.0) THEN
          deallocate(POOL,STAT=ISTAT)
          CALL MSGERR(MDOC,' ERR: CFFT: FILE-F_2')
          CLOSE(MTIN)
          IF(MTF  .GT.0) CLOSE(MTF)
          IF(MTPH .GT.0) CLOSE(MTPH)
          IF(MTOUT.GT.0) CLOSE(MTOUT)
          IERR=1
          RETURN
        ENDIF

        AD =AD *CBOFF*CBADD
        SAD=SAD*CBOFF*CBADD

        GO TO 550

 360    CONTINUE
C ---------------------------
        AP =AP *CBOFF*CBADD
        SAP=SAP*CBOFF*CBADD
C ----------------------
  
        IF(MTPH.GT.0) THEN
C         READ PHASE FOR THIS REFL.
C
  500     CONTINUE
          IF(IENDP.GT.0) GO TO 200

C          IF(LL-IL(1)) 2030,2010, 300
C 2010     IF(LK-IK(1)) 2030,2020, 300
C 2020     IF(LH-IH(1)) 2030,2000, 300

          IF((LL-IL(1)).LT.0) GO TO 2030
          IF((LL-IL(1)).EQ.0) GO TO 2010
          IF((LL-IL(1)).GT.0) GO TO 300
 2010     IF((LK-IK(1)).LT.0) GO TO 2030
          IF((LK-IK(1)).EQ.0) GO TO 2020
          IF((LK-IK(1)).GT.0) GO TO 300
 2020     IF((LH-IH(1)).LT.0) GO TO 2030
          IF((LH-IH(1)).EQ.0) GO TO 2000
          IF((LH-IH(1)).GT.0) GO TO 300

 2030     CONTINUE
          CALL RD3(MTPH,LH,LK,LL,COPH,SIPH,NUMBPH,IENDP)
          GO TO 500
        ENDIF
 2000   CONTINUE
C ------------------------
        IF(MTF.GT.0) THEN
          AP =AD*SCALE-AP
          SAP=SQRT(SAP*SAP+SAD*SAD*SCALE*SCALE)
        ENDIF
        IF(LAP.EQ.'Y') THEN
          IF(MTPH.GT.0) THEN
            FAA  = AP  *(RSQ)*FOURPI2
            FA(1)= FAA*COPH
            FB(1)= FAA*SIPH
          ELSE
            FA(1)= (AP*AP)      *(RSQ)*FOURPI2
            FB(1)= (2.0*AP*SAP) *(RSQ)*FOURPI2
          ENDIF
        ELSE
          IF(MTPH.GT.0) THEN
            FA(1)= AP*COPH
            FB(1)= AP*SIPH
          ELSE
            FA(1)=AP*AP
            FB(1)=2.0*AP*SAP
          ENDIF
        ENDIF
        FA(1)=FA(1)/(VOL)
        FB(1)=FB(1)/(VOL)
C ----------------------
        CALL GENER(IPATT,N,IH,IK,IL,FA,FB,NSYM,ISYM,IPRSYM)
C ------------------------
        DO     I=1,N
          JH  = IH(I)
          JK  = IK(I)
          JL  = IL(I)
          FAA = FA(I)
          FBB = FB(I)
C
C          WRITE(*,'('' H,K,L,A,B:'',3I5,2F12.4)') JH,JK,JL,FAA,FBB
C
          IF(IABS(JL).LE.ILMAX.AND.
     *       IABS(JK).LE.IKMAX.AND.
     *       IABS(JH).LT.IHMAX     ) THEN
            IHD = JH+1
            IF(JK.LT.0) JK = NY + JK
            IKD = JK+1
            ILD = IABS(JL) + 1
            IF(ILD.LE.512) THEN
              PCOS = CZL(ILD)
              PSIN = SZL(ILD)
              IF(JL.LT.0 ) PSIN = -PSIN
              AP  = FAA * PCOS + FBB * PSIN
              BP  = FBB * PCOS - FAA * PSIN
              SM  = CMPLX(AP,BP)
              IND = (IKD-1)*NX2+IHD
              POOL(IND) = POOL(IND)+SM
            ENDIF
          ENDIF
        ENDDO

        GO TO 300
C--------------------------------------------
  200   CONTINUE
        CALL MDHFT(POOL,IDIM,IERR)
        IF(IERR.NE.0) THEN
          deallocate(POOL,STAT=ISTAT)
          CALL MSGERR(MDOC,' ERR: CFFT: IN KERNEL-FFT')
          CLOSE(MTIN)
          IF(MTF  .GT.0) CLOSE(MTF)
          IF(MTPH .GT.0) CLOSE(MTPH)
          IF(MTOUT.GT.0) CLOSE(MTOUT)
          IERR=1
          RETURN
        ENDIF
        CALL VLD_SECT(MDOC,MTOUT
     *               ,IPATT,ASYM,POOL,NX,NY,NZ,IZ,NSYM,ISYM,IERR)
C--------------------------------------------------------------
        IF(MTOUT.GT.0) THEN
          
          CALL WDENS(MTOUT,MDOC,ICNTZ,NX,NY,NZ,IZMIN,IZMAX,RMAX,RMIN
     *             ,POOL,RESMAX,IX0,IY0,IZ0,ITR)
          IF(MTOUT.LE.0) THEN
            deallocate(POOL,STAT=ISTAT)
            CALL MSGERR(MDOC,' ERR: FILE-DENS')
            CLOSE(MTIN)
            IF(MTF  .GT.0) CLOSE(MTF)
            IF(MTPH .GT.0) CLOSE(MTPH)
            IF(MTOUT.GT.0) CLOSE(MTOUT)
            IERR=1
            RETURN
          ENDIF
        ENDIF

      ENDDO
      CALL SET_DINF(MDOC,IPATT,VOL,NX,NY,NZ,RESULT,IPRROW,IERR)
C------------------------------------------------------------------
C      ICPU=1
C      CALL CPU(ICPU)
C ------------------------------------
      CLOSE(MTIN)
      deallocate(POOL,STAT=ISTAT)
      IF(MTF  .GT.0) CLOSE(MTF)
      IF(MTPH .GT.0) CLOSE(MTPH)
      IF(MTOUT.GT.0) CLOSE(MTOUT)
      RETURN
      END

      SUBROUTINE ROTFFT(MDOC,NAMEC,NAMEF,NAME_PH,NAMEO,PATH_SCR
     * ,BOFF,BADD,DOM,F000I,NCS_ID,ANGLES_NCS_INP,CENTRE_NCS
     * ,RESN,RESX,NCYCL,SCALEG,REFA,REFX,REFB,MODE,ANISOI,P1,LIST
     * ,RESULT,RESULTA,IPRROW,ISYM,IPRSYM,IERR)
C -------------------------------------------------------------------
C -P- ROTFFT - rigid body or multiple domains refinement.
C -S-
C      Dialog:
C
C  FILE_C:  - input COORD_file /without extention "crd"/
C  FILE_F:  - input file F_obs.
C  BOFF:    <0> , 256 corresponds to RESmin=8 
C  BADD:    <0> , BOFF and BADD mean :
C                  !F!new = !F!old *EXP(-BADD*RSQ)*(1-EXP(-BOFF*RSQ)
C  DOM:    <N>/Y - Y means multy domains refinement.
C                  Put between domains in coordinates fail the string "#DOMAIN"
C                  or "#MOLECULE"
C  RESOL:   - MIN,MAX <from file> - resolution 
C  SCALE:  <1>   
C  NC:     - number of cycles of refinement.
C  REFA:   - <Y>/N , Y - refine ANGLES of rotation, N - no
C  REFX:   - <Y>/N , Y - refine SHIFTS, N - no
C  FILE_O:  <rotfft> - outpit file of refined coords /without extention "crd"/
C                      Default file name is 'rotfft.crd'            
C
C  Parameters of subroutine ROTFFT: 
C
C      SUBROUTINE ROTFFT(MDOC,NAMEC,NAMEF,NAMEO,BOFF,BADD,DOM
C     * ,RSMIN,RSMAX,NCYCL,SCALE,REFS,REFB,REFA,REFX
C     * ,P1,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C
C  MDOC    - mode of writting messages to DOC-file
C              0 - only terminal , < - 0 only file, 0 < < 99 - both
C              >= 99 - don't write  
C  NAMEC:  - input COORD_file /without extention "crd"/
C  NAMEF:  - input file F_obs.
C  BOFF:   
C  RSMIN:   - MIN,MAX <from file> - resolution 
C  RSMAX:
C  SCALE:  <1>   
C  NCYCL:     - number of cycles of refinement.
C  REFA:   - <Y>/N , Y - refine ANGLES of rotation, N - no
C  REFX:   - <Y>/N , Y - refine SHIFTS, N - no
C  FILE_O:  <rotFFT.crd> - outpit file of refined coords 
C                                            /without extention "crd"/
C                      Default file name is 'rotFFT.crd'            
C  ISYM    - integer*2 array for cryst.symmetry operators.
C  IPRSYM  - dimension of integer*2 array ISYM(5,3,IPRSYM),
C              number of cryst. symm. operators.
C  IERR    - output signal of error / = 1 -error , = 0 - OK / 
C
C
C        output information :
C 
C      REAL RESULT(IPRROW)
C
C      RESULT(1) - number of cycles of refinement
C      RESULT(2) - Scale
C      RESULT(3) - Boverall
C      RESULT(4) - R-factor
C      RESULT(5) - Correlation
C      RESULT(6) - initial R-factor
C      RESULT(7) - initial Correlation
C      RESULT(8) =TX(1,1)
C      RESULT(9) =TX(2,1)
C      RESULT(10)=TX(3,1)
C      RESULT(11)=THETA(1,1)
C      RESULT(12)=THETA(2,1)
C      RESULT(13)=THETA(3,1)
C      RESULT(14) =TX(1,2)
C      RESULT(15) =TX(2,2)
C      RESULT(16) =TX(3,2)
C      RESULT(17) =THETA(1,2)
C      RESULT(18) =THETA(2,2)
C      RESULT(19) =THETA(3,2)
C      RESULT(20)- number of domains
C
C -I-
C ----------------------------------------------------------
C ===
      PARAMETER ( IPRDOM = 300    )
      PARAMETER ( IPRVAR =IPRDOM*6     )
      PARAMETER ( IPRVR2 =IPRVAR*IPRVAR)

      COMMON /VITALS_FFT/ NATOM,FUNCT,NDOM,NP,NV,DFDA,DFDT,INDX
     *               ,AM,BV,DV,P,KI,THETA,TX,R,Q,SCALES
C ---
      REAL      THETA(3,IPRDOM),TX(3,IPRDOM)
      REAL      AM(IPRVR2),BV(IPRVAR),DV(IPRVAR),P(IPRVAR)
      REAL      P_OLD(IPRVAR)

      INTEGER   KI(IPRVAR),INDX(IPRVAR,3)
      REAL      R(3,3,IPRDOM),Q(3,3,3,IPRDOM)
      REAL      DFDA(3,IPRDOM),DFDT(3,IPRDOM)
      COMMON /DOMAIN_ROTFFT/ NA_TOTAL,NM_TOTAL,NA_MOL,ANGLES_RESTR
     *                      ,ND_TOTAL,NA_DOM,ID_MOL,ID_DOM,CENTRE,RADI
     *                      ,NP_TOTAL,NMD_TOTAL,ANGLES_OBS,CENTRE_COM
     *                      ,CENTRE_MOL,SHIFT_MOL
      INTEGER   NP_TOTAL,NA_TOTAL,NM_TOTAL,NA_MOL(IPRDOM),NMD_TOTAL
      INTEGER   ND_TOTAL
      REAL      ANGLES_RESTR(3,IPRDOM),ANGLES_OBS(3,IPRDOM)
      INTEGER   NA_DOM(IPRDOM),ID_MOL(IPRDOM),ID_DOM(IPRDOM)    
      REAL      CENTRE(3,IPRDOM),RADI(IPRDOM),CENTRE_COM(3)
      REAL      CENTRE_MOL(3,IPRDOM),SHIFT_MOL(3,IPRDOM)
      REAL      ANGLES_NCS_INP(3),CENTRE_NCS(3)
C ===
      real,    allocatable :: X0(:,:)
      real,    allocatable :: GRADX(:,:)
      real,    allocatable :: X(:,:)
      real,    allocatable :: DXDA(:,:,:)
      real,    allocatable :: DIAG(:)
      real,    allocatable :: BFAC0(:)
      real,    allocatable :: BFAC(:)
      real,    allocatable :: BSHFT(:)
      integer, allocatable :: NUMDOM(:)
C ------------------------------------------------------------
      CHARACTER NAMEC*(*),NAMEF*(*),NAMEO*(*),PATH_SCR*(*)
      CHARACTER NAME_PH*(*)
      CHARACTER REFA*1,REFX*1,REFB*1,DOM*1,MODE*1,ANISO*1,ANISOI*1
      CHARACTER LIST*1
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW,51),RESULTA(IPRROW,51),RESULTB(51,51)
      REAL      RM(3,3),SH1(3),SH2(3)
C ----------------------
      REAL      RLATT(6)
      INTEGER   NSPGROUP,NOSETT
C ---
C !!!!
      CHARACTER CODE*4,DATE*9,SPGR*24,SPGROUP*24,NAME_MOD*80
C !!!!
C ---
      CHARACTER LINE*80,TTT*80,ITYPE*4,SOLV*1,PATT*1,MOD*1,P1*1,F000I*1
      CHARACTER ACORR*1,ANISO2*1,RB*1
C
      CHARACTER NAME*256,NAMEFF*256,NAMES*256,NAMEG*256,NAMET*256
      CHARACTER NAMEFS*256,NAMECC*256
C ======================================================================
      MD   = -ABS(MDOC)-1
      M    = 99
      RB = 'N'
      IF(IERR.EQ.1) RB = 'Y' 
      IERR = 0
      ISIGNAL_STOP = 0
C ---
      DO I=1,IPRROW
        RESULT (I,1) = 0.0
        RESULTA(I,1) = 0.0
      ENDDO
      DO I=1,IPRVAR
        P_OLD(I) = 0.0
      ENDDO
C ---
      NDOM  = 0
      ANISO = ANISOI
      IF(P1   .EQ.'y') P1    = 'Y'
      IF(P1   .NE.'Y') P1    = 'N'

      IF(F000I.EQ.'y') F000I = 'Y'
      IF(F000I.NE.'Y') F000I = 'N'

      IF(DOM  .EQ.'y') DOM   = 'Y'
      IF(DOM  .EQ.'s') DOM   = 'S'
      IF(DOM  .EQ.'c') DOM   = 'C'
      IF(DOM  .EQ.'i') DOM   = 'I'
      IF(DOM  .NE.'Y'.AND.DOM.NE.'S'.AND.
     *   DOM  .NE.'I'.AND.DOM.NE.'C') DOM   = 'N'

      IF(REFA .EQ.'n') REFA  = 'N'
      IF(REFA .NE.'N') REFA  = 'Y'
      IF(REFX .EQ.'n') REFX  = 'N'
      IF(REFX .NE.'N') REFX  = 'Y'
      IF(REFB .EQ.'y') REFB  = 'Y'
      IF(REFB .NE.'Y') REFB  = 'N'

      IVAR = 0
      IF(NCYCL.LT. 0 ) IVAR = 1
      NCYCL = ABS(NCYCL) 
      IF(NCYCL.LE. 0 ) NCYCL = 5

      IF(MODE .EQ.'u') MODE  = 'U'
      IF(MODE .NE.'U') MODE  = 'R'
      IF(MODE .EQ.'U') DOM = 'N'

      IF(ANISO.EQ.'k') ANISO = 'K'
      IF(ANISO.EQ.'s') ANISO = 'S'
      IF(ANISO.EQ.'c') ANISO = 'C'
      IF(ANISO.EQ.'y') ANISO = 'Y'
      IF(ANISO.EQ.'a') ANISO = 'A'
      IF(ANISO.NE.'S'.AND.ANISO.NE.'C'.AND.ANISO.NE.'K'.AND.
     *   ANISO.NE.'A'.AND.ANISO.NE.'Y') ANISO = 'N'
      IF(ANISO.EQ.'S') ANISO = 'Y'

      IF(SCALEG.LE.0.000001) SCALEG = 0.5
      IF(BOFF  .LE.0.000001) BOFF   = 1600.0
      IF(MODE.EQ.'U') SCALEG = SCALEG*0.5
      SCALES = SCALEG*1.0
C     IF(P1.EQ.'Y') REFX = 'N'
C ---------------------------------------------------
      NAMECC  = 'rotfft_scr2'
      CALL ADD_PATH(PATH_SCR,NAMECC)
      MOD = 'E'
      DO I=1,3
        SH1(I) = 0.0
        SH2(I) = 0.0
        DO J=1,3
          RM(I,J) = 0.0
        ENDDO
      ENDDO
      ALPHA = 0.0
      BETA  = 0.0
      GAMMA = 0.0
      MMM   = M
      IF(LIST.EQ.'T') MMM = MDOC

      IF(DOM.EQ.'C') THEN

        CALL COPY_CRD_NCS(MDOC,NAMEC,NAMECC
     *  ,NCS_ID,NM_TOTAL,NTOT
     *  ,ANGLES_NCS_INP,ANGLES_RESTR,CENTRE_NCS
     *  ,IPRDOM,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) RETURN
        CENTRE_COM(1) = CENTRE_NCS(1)
        CENTRE_COM(2) = CENTRE_NCS(2)
        CENTRE_COM(3) = CENTRE_NCS(3)

c        CALL COPY_CRD_RTFFT(MMM,NAMEC,NAMECC,DOM
c     *                     ,NSYM,ISYM,IPRSYM,IERR)
c        IF(IERR.NE.0) RETURN
c        NTOT = NA_TOTAL
      ELSE 
        CALL TRANS(MMM,NAMEC,NAMECC,SH1,SH2
     *     ,MOD,RM,ALPHA,BETA,GAMMA,RESULTB,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) RETURN
        NTOT = RESULTB(1,1) 
      ENDIF

C      write(*,*) '--ntot:',ntot

      IF(P1.EQ.'Y') THEN
        CALL GET_CELL(RLATT,CODE,NAME_MOD,DATE,TTT
     *       ,NSPGROUP,NOSETT,SPGR,NSM,IERR)
        SPGROUP = 'P 1' 
        CALL CHANGE_CELL(MDOC,NAMECC,PATH_SCR,RLATT,SPGROUP
     *                                  ,ISYM,IPRSYM,IERR)
      ENDIF
C ----------------------------
      IF(P1.EQ.'Y') THEN
        NAMEFS   = 'rotfft_scr1'
        CALL ADD_PATH(PATH_SCR,NAMEFS)
        CALL F2P1(M,NAMEF,NAMEFS,RESX
     * ,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) RETURN
      ELSE
        NAMEFS = NAMEF
      ENDIF
      MTN   = 10
      ITYPE = 'FF  '
      CALL ORFILE(M,MTN,NAMEFS,ITYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN INPUT-FILE-FOBS')
        RETURN
      ENDIF
      CALL GET_TITLE(MD,A,B,C,AL,BE,GA
     *  ,F1,F2,RESMIN,RESMAX,IDM,IDM,IDM,IDM,IDM,TTT,IERR)
      CLOSE(MTN)
      CALL C_RD_CR
C -------------------------------------------------------------

C     1        2        7      3        4          5         6     8    9
C X0(M,3),NUMDOM(M),BFAC0(M),GRADX(M,3),DIAG(M),DXDA(M,3,3),X(M,3),
C                                                              BFAC(M),BSHFT(M)
C  
      MEM = NTOT*8 + 100
      IT = 0
      allocate(X0(1:MEM,1:3),STAT=ISTAT)
      allocate(X(1:MEM,1:3),STAT=ISTAT)
      allocate(GRADX(1:MEM,1:3),STAT=ISTAT)
      allocate(DXDA(1:MEM,1:3,1:3),STAT=ISTAT)
      allocate(DIAG(1:MEM),STAT=ISTAT)
      allocate(BFAC0(1:MEM),STAT=ISTAT)
      allocate(BFAC(1:MEM),STAT=ISTAT)
      allocate(BSHFT(1:MEM),STAT=ISTAT)
      allocate(NUMDOM(1:MEM),STAT=ISTAT)
                                                               
C      I1  =       1
C      I2  = 3*MEM+1
C      I7  = 4*MEM+1
C      I3  = 5*MEM+1
C      I4  = 8*MEM+1
C      I5  = 9*MEM+1
C      I6  =18*MEM+1
C      I8  =21*MEM+1
C      I9  =22*MEM+1
C      IM  =23*MEM
C      IF(IM.GT.MEMORY) THEN
C
C      ENDIF

C      MEM_FFT = MEMORY - MEM*5
      MEM_FFT = MEMORY 

C --------------------------------------------
      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.LE.0.OR.NAMEO(1:1).EQ.','.OR.NAMEO(1:1).EQ.' ') THEN
        NAMEO='rotfft'
        CALL ADD_PATH(PATH_SCR,NAMEO)
      ENDIF

      CALL RD_INI_CRD_RTFFT(MDOC,NAMECC,DOM
     * ,X0,X,GRADX,NUMDOM,BFAC0,BFAC,BSHFT
     * ,MEM,MEM
     * ,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
      NAMET = NAMECC

c       write(*,*) '--na_tot:',NA_TOTAL,NTOT

      IF(NTOT.NE.NA_TOTAL) THEN
        IF(LIST.EQ.'T') THEN
          WRITE(*,*) '!!!--> NTOT,NA_TOTAL:', NTOT,NA_TOTAL
        ENDIF
        IF(NTOT.LT.NA_TOTAL) THEN
          CALL MSGERR(MDOC,' WARNING: (rotfft) Ntot < Na_total')
        ENDIF
      ENDIF 

      IF(DOM.NE.'N'.AND.DOM.NE.'Y') THEN
        NAMET = 'rotfft_scr1'
        CALL ADD_PATH(PATH_SCR,NAMET)
        IF(DOM.EQ.'I'.OR.DOM.EQ.'C') NAMET = NAMEO

        CALL WR_CRD_RTFFT(M,NAMECC,NAMET
     * ,X0,DOM,NUMDOM,BFAC0
     * ,NATOM,MEM,MEM,P1,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
        IF(DOM.EQ.'I'.OR.DOM.EQ.'C') GO TO 900
      ENDIF
C -------------------------------
      IF(RESX.GT.0.00001.AND.RESX.GT.RESMAX) RESMAX=RESX
      IF(RESN.GT.0.00001.AND.RESN.LT.RESMIN) RESMIN=RESN
      IF(RESMIN.LT.RESMAX) THEN
        T      = RESMIN
        RESMIN = RESMAX
        RESMAX = T
      ENDIF
      IF(RESMIN.EQ.RESMAX) THEN
        CALL MSGERR(MDOC,' ERROR: resmin = resmax')
        IERR=1
        GO TO 900
      ENDIF
      WRITE(LINE,'('' Resolution                  :'',2F8.2)') 
     * RESMIN,RESMAX
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Boff,Badd                   :'',2F8.2)') 
     * BOFF,BADD
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,'('' P1,DOM,F000,ANISO           :'',A,A,A,A)') 
     * P1,DOM,F000I,ANISO
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' grad_scale                  :'',F8.2)') 
     * SCALEG
      CALL MSGDOC(MD,LINE)
C ------------------------------------------
      IF(ANISO.EQ.'A'.OR.ANISO.EQ.'C') THEN
        CALL MSGDOC(MDOC,'--- anisothermal correction of Fobs ---')
        BADDD    = 0.0
C        BOFFF    = 256.0
        BOFFF    = BOFF
        SCALE    = 1.0
        BOVER    = 0.0
        PATT     = 'Y'
        SOLV     = 'N'
        NC       =  0
        RESMNI   = 0.0
        RESMXI   = 0.0
        
        NAME   = ' '
        NAMEFF = 'rotfft_cor'
        CALL ADD_PATH(PATH_SCR,NAMEFF)
        ACORR  = 'Y'
        ANISO2 = '-'
        CALL MR_SCALING(M,LIST,NAME,NAMEFS,NAMEFF,PATH_SCR
     * ,ANISO2,SCALE,BOVER,ACORR,BOFFF,BADDD,RESMNI,RESMXI
     * ,SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF
     * ,RESULTA,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
C ---------------------------------------------------------
C     1. ACORR # N - anisothermal correction of Fmod
c        if ANISO = '-' return
C     2. ANISO = K - FSCALE with SCALEP,BSCALE
C                   if scale = 0 - scaling by Fobs (cell must be the same)
C                      only scale , set BOVER = 0
C                   if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                  no info: rfac, corr
C        else  CALL PSCALE
C      output: SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF and NAMEFM2
C ---------------------------------------------------------
       
C        CALL ANISOSCL(M,NAMEFS,NAME,NAMEFF
C     *   ,RESMNI,RESMXI,SCALE,BOVER
C     *   ,NC,BOFFF,BADDD,SOLV,PATT
C     *   ,ISYM,IPRSYM,RESULTA,IPRROW,IERR)
C        IF(IERR.NE.0) GO TO 900
C
C
C        RESULT(11,1)=EVAL(1) Ratio of Eigen values 
C        RESULT(12,1)=EVAL(2)
C        RESULT(13,1)=EVAL(3)
C        RESULT( 3,3)  = SQR_P000 - sqrt(P000_patt) for file_1 (test)
C        RESULT( 4,3)  = B_OVER     B_overall
C        RESULT( 5,3)  = RESEFF     Res_optical
C        RESULT( 6,3)  = RESMXI     Res_max
C
C        CALL MSGDOC(MDOC,
C     *  ' Anisotropic distribution of Structure Factors:')
C        WRITE(LINE,'('' Ratio of Eigen values :'',3F8.4)')
C     *  RESULTA(11,1),RESULTA(12,1),RESULTA(13,1)    
C        CALL MSGDOC(MDOC,LINE)
      ELSE
        NAMEFF = NAMEFS
      ENDIF
C ---
      CC_INIT = -1000.0
      RF_INIT =  1000.0
      RF_OLD =  1000.0
      CC_OLD = -1000.0
      IFIRST_CC = 0
      NAMES  = NAMET
      NAMEG  = 'rotfft_grd'
      CALL ADD_PATH(PATH_SCR,NAMEG)
      NCR    = 0
      IFIRST = 0

      LINE =  'INFO: information about model/domain'//
     *        ' movement see in molrep.doc'
      CALL MSGDOC(MDOC,LINE)
      LINE = '+------------------------------------'//
     *       '-----------------------------------------+'
      CALL MSGDOC(MDOC,LINE)
      LINE = '|     Nc             wRfac   Corr  '//
     *       '   Chi-1  Sh-1 Chi-2  Sh-2 Chi-3  Sh-3 ...|'
      CALL MSGDOC(MDOC,LINE)
c --------------------------------------------

 100  CONTINUE
      ITEST = 0

c      write(*,*) '===CALCGRD_RTFFT'

      CALL CALCGRD_RTFFT(MDOC,LIST,NAMES,NAMEFF,NAME_PH,NAMEG
     * ,PATH_SCR,BOFF,BADD,F000I
     * ,RESMIN,RESMAX,SCALEG,ANISO,NCR,NCYCL,P1,IVAR,ITEST
     * ,RF_NEW,CC_NEW,RF_OLD,CC_OLD
     * ,RESULTA,IPRROW,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C ---------------------------------------------
      IF(CC_NEW.GE.CC_OLD) THEN

        RESULTA(1,1) = NCR
        DO I=1,IPRROW
          RESULT(I,1) = RESULTA(I,1)
        ENDDO
        RESULT(7,1) = CC_INIT
        RESULT(6,1) = RF_INIT

        IF(NCR.LE.0.AND.IFIRST_CC.EQ.0) THEN
          CC_INIT = CC_NEW 
          RF_INIT = RF_NEW 
          IFIRST_CC = 1
        ENDIF

        MOD = 'E'
        DO I=1,3
          SH1(I) = 0.0
          SH2(I) = 0.0
          DO J=1,3
            RM(I,J) = 0.0
          ENDDO
        ENDDO
        ALPHA = 0.0
        BETA  = 0.0
        GAMMA = 0.0
        MMM = M
        IF(LIST.EQ.'T') MMM = MDOC
        CALL TRANS(MMM,NAMES,NAMEO,SH1,SH2
     *    ,MOD,RM,ALPHA,BETA,GAMMA,RESULTB,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900

      ELSE

        CALL CHECK_STOP_SIGNAL(PATH_SCR,ISIGNAL_STOP)
        IF(ISIGNAL_STOP.GT.0) GO TO 200

        IF(IVAR.EQ.0) GO TO 200

      ENDIF

      CALL CHECK_STOP_SIGNAL(PATH_SCR,ISIGNAL_STOP)
      IF(ISIGNAL_STOP.GT.0) GO TO 200

      IF(NCR.GE.NCYCL) GO TO 200
C ---------------------------------------------
      IF(MODE.EQ.'R') THEN
        NAME=NAMET
C -VAR  
C       NAME=NAMES
C -VAR
      ELSE
        NAME=NAMES
      ENDIF


      CALL RB_REFINE_FFT(MDOC,LIST,NAME,NAMEG,NAMEFF,NAME_PH
     * ,PATH_SCR
     * ,BOFF,BADD,DOM,NCR,MODE,P1,SCALEG,REFA,REFX,REFB
     * ,RESMIN,RESMAX,ANISO,F000I  
     * ,IFIRST,CC_NEW,P_OLD,MEM  
     * ,X0,NUMDOM,GRADX,DIAG,DXDA,X
     * ,BFAC0,BFAC,BSHFT
     * ,MEM,RESULTA,IPRROW,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        IF(NCR.GT.0) IERR=0
        IF(IERR.EQ.2) IERR = 0
        GO TO 900
      ENDIF
C ----------------------------------------------------
      NAMES  = 'rotfft_scr'
      CALL ADD_PATH(PATH_SCR,NAMES)
      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC
      CALL WR_CRD_RTFFT(MMM,NAMET,NAMES,X,DOM,NUMDOM,BFAC
     * ,NATOM,MEM,MEM,P1,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C -------------------------------------------------------
      NCR    = NCR + 1

      IF(CC_NEW.GT.CC_OLD) THEN
        CC_OLD = CC_NEW
        RF_OLD = RF_NEW
      ENDIF
      GO TO 100
C ---------------
 200  CONTINUE

      IF(P1.EQ.'Y') THEN

        SPGROUP = SPGR 
        CALL CHANGE_CELL(MDOC,NAMEO,PATH_SCR,RLATT,SPGROUP
     *                                  ,ISYM,IPRSYM,IERR)
      ENDIF

      RESULT(7,1) = CC_INIT
      RESULT(6,1) = RF_INIT
      IF(IPRROW.GE.13) THEN
        RESULT(20,1) = NDOM
      ENDIF      
C ---
 900  CONTINUE
      deallocate(X0,STAT=ISTAT)
      deallocate(X,STAT=ISTAT)
      deallocate(GRADX,STAT=ISTAT)
      deallocate(DXDA,STAT=ISTAT)
      deallocate(DIAG,STAT=ISTAT)
      deallocate(BFAC0,STAT=ISTAT)
      deallocate(BFAC,STAT=ISTAT)
      deallocate(BSHFT,STAT=ISTAT)
      deallocate(NUMDOM,STAT=ISTAT)
      RETURN
      END


      SUBROUTINE ROTFFT_NEW(MDOC,NAMEC,NAMEF,NAME_PH,NAMEO,PATH_SCR
     * ,BOFF,BADD,DOM,F000I,NCS_ID,ANGLES_NCS_INP,CENTRE_NCS
     * ,RESN,RESX,NCYCL,SCALEG,REFA,REFX,REFB,MODE,ANISOI,P1,LIST
     * ,RESULT,RESULTA,IPRROW,ISYM,IPRSYM,IERR)
C -------------------------------------------------------------------
C -P- ROTFFT - rigid body or multiple domains refinement.
C -S-
C      Dialog:
C
C  FILE_C:  - input COORD_file /without extention "crd"/
C  FILE_F:  - input file F_obs.
C  BOFF:    <0> , 256 corresponds to RESmin=8 
C  BADD:    <0> , BOFF and BADD mean :
C                  !F!new = !F!old *EXP(-BADD*RSQ)*(1-EXP(-BOFF*RSQ)
C  DOM:    <N>/Y - Y means multy domains refinement.
C                  Put between domains in coordinates fail the string "#DOMAIN"
C                  or "#MOLECULE"
C  RESOL:   - MIN,MAX <from file> - resolution 
C  SCALE:  <1>   
C  NC:     - number of cycles of refinement.
C  REFA:   - <Y>/N , Y - refine ANGLES of rotation, N - no
C  REFX:   - <Y>/N , Y - refine SHIFTS, N - no
C  FILE_O:  <rotfft> - outpit file of refined coords /without extention "crd"/
C                      Default file name is 'rotfft.crd'            
C
C  Parameters of subroutine ROTFFT: 
C
C      SUBROUTINE ROTFFT(MDOC,NAMEC,NAMEF,NAMEO,BOFF,BADD,DOM
C     * ,RSMIN,RSMAX,NCYCL,SCALE,REFS,REFB,REFA,REFX
C     * ,P1,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C
C  MDOC    - mode of writting messages to DOC-file
C              0 - only terminal , < - 0 only file, 0 < < 99 - both
C              >= 99 - don't write  
C  NAMEC:  - input COORD_file /without extention "crd"/
C  NAMEF:  - input file F_obs.
C  BOFF:   
C  RSMIN:   - MIN,MAX <from file> - resolution 
C  RSMAX:
C  SCALE:  <1>   
C  NCYCL:     - number of cycles of refinement.
C  REFA:   - <Y>/N , Y - refine ANGLES of rotation, N - no
C  REFX:   - <Y>/N , Y - refine SHIFTS, N - no
C  FILE_O:  <rotFFT.crd> - outpit file of refined coords 
C                                            /without extention "crd"/
C                      Default file name is 'rotFFT.crd'            
C  ISYM    - integer*2 array for cryst.symmetry operators.
C  IPRSYM  - dimension of integer*2 array ISYM(5,3,IPRSYM),
C              number of cryst. symm. operators.
C  IERR    - output signal of error / = 1 -error , = 0 - OK / 
C
C
C        output information :
C 
C      REAL RESULT(IPRROW)
C
C      RESULT(1) - number of cycles of refinement
C      RESULT(2) - Scale
C      RESULT(3) - Boverall
C      RESULT(4) - R-factor
C      RESULT(5) - Correlation
C      RESULT(6) - initial R-factor
C      RESULT(7) - initial Correlation
C      RESULT(8) =TX(1,1)
C      RESULT(9) =TX(2,1)
C      RESULT(10)=TX(3,1)
C      RESULT(11)=THETA(1,1)
C      RESULT(12)=THETA(2,1)
C      RESULT(13)=THETA(3,1)
C      RESULT(14) =TX(1,2)
C      RESULT(15) =TX(2,2)
C      RESULT(16) =TX(3,2)
C      RESULT(17) =THETA(1,2)
C      RESULT(18) =THETA(2,2)
C      RESULT(19) =THETA(3,2)
C      RESULT(20)- number of domains
C
C -I-
C ----------------------------------------------------------
C ===
      PARAMETER ( IPRDOM = 300    )
      PARAMETER ( IPRVAR =IPRDOM*6     )
      PARAMETER ( IPRVR2 =IPRVAR*IPRVAR)

      COMMON /VITALS_FFT/ NATOM,FUNCT,NDOM,NP,NV,DFDA,DFDT,INDX
     *               ,AM,BV,DV,P,KI,THETA,TX,R,Q,SCALES
C ---
      REAL      THETA(3,IPRDOM),TX(3,IPRDOM)
      REAL      AM(IPRVR2),BV(IPRVAR),DV(IPRVAR),P(IPRVAR)
      REAL      P_OLD(IPRVAR)

      INTEGER   KI(IPRVAR),INDX(IPRVAR,3)
      REAL      R(3,3,IPRDOM),Q(3,3,3,IPRDOM)
      REAL      DFDA(3,IPRDOM),DFDT(3,IPRDOM)
C ==========


C ==========
      PARAMETER ( IGRDOM = 300    )
      COMMON /DOMAIN_ROTFFT_NEW/ 
     *                       NG_TOTAL
     *                      ,NA_TOTAL,NM_TOTAL,NA_MOL,ANGLES_RESTR
     *                      ,ND_TOTAL,NA_DOM
     *                      ,ID_GRP,ID_MOL,ID_DOM,CENTRE,RADI
     *                      ,NP_TOTAL,NMD_TOTAL,ANGLES_OBS,CENTRE_COM
     *                      ,CENTRE_MOL,SHIFT_MOL
      INTEGER   NG_TOTAL,NP_TOTAL,NA_TOTAL
     *         ,NM_TOTAL(IGRDOM),NA_MOL(IPRDOM,IGRDOM)
     *         ,NMD_TOTAL(IGRDOM)
      INTEGER   ND_TOTAL
      REAL      ANGLES_RESTR(3,IPRDOM,IGRDOM)
     *         ,ANGLES_OBS(3,IPRDOM,IGRDOM)
      INTEGER   NA_DOM(IPRDOM)
     *         ,ID_GRP(IPRDOM),ID_MOL(IPRDOM),ID_DOM(IPRDOM)    
      REAL      CENTRE(3,IPRDOM),RADI(IPRDOM),CENTRE_COM(3,IGRDOM)
      REAL      CENTRE_MOL(3,IPRDOM,IGRDOM),SHIFT_MOL(3,IPRDOM,IGRDOM)
C ==========
c      COMMON /DOMAIN_ROTFFT_NEW/ NA_TOTAL,NM_TOTAL,NA_MOL,ANGLES_RESTR
c     *                      ,ND_TOTAL,NA_DOM,ID_MOL,ID_DOM,CENTRE,RADI
c     *                      ,NP_TOTAL,NMD_TOTAL,ANGLES_OBS,CENTRE_COM
c     *                      ,CENTRE_MOL,SHIFT_MOL
c      INTEGER   NP_TOTAL,NA_TOTAL,NM_TOTAL,NA_MOL(IPRDOM),NMD_TOTAL
c      INTEGER   ND_TOTAL
c      REAL      ANGLES_RESTR(3,IPRDOM),ANGLES_OBS(3,IPRDOM)
c      INTEGER   NA_DOM(IPRDOM),ID_MOL(IPRDOM),ID_DOM(IPRDOM)    
c      REAL      CENTRE(3,IPRDOM),RADI(IPRDOM),CENTRE_COM(3)
c      REAL      CENTRE_MOL(3,IPRDOM),SHIFT_MOL(3,IPRDOM)
c ====
      REAL      ANGLES_NCS_INP(3),CENTRE_NCS(3)
C ==========
      real,    allocatable :: X0(:,:)
      real,    allocatable :: GRADX(:,:)
      real,    allocatable :: X(:,:)
      real,    allocatable :: DXDA(:,:,:)
      real,    allocatable :: DIAG(:)
      real,    allocatable :: BFAC0(:)
      real,    allocatable :: BFAC(:)
      real,    allocatable :: BSHFT(:)
      integer, allocatable :: NUMDOM(:)
C ------------------------------------------------------------
      CHARACTER NAMEC*(*),NAMEF*(*),NAMEO*(*),PATH_SCR*(*)
      CHARACTER NAME_PH*(*)
      CHARACTER REFA*1,REFX*1,REFB*1,DOM*1,MODE*1,ANISO*1,ANISOI*1
      CHARACTER LIST*1
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW,51),RESULTA(IPRROW,51),RESULTB(51,51)
      REAL      RM(3,3),SH1(3),SH2(3)
C ----------------------
      REAL      RLATT(6)
      INTEGER   NSPGROUP,NOSETT
C ---
C !!!!
      CHARACTER CODE*4,DATE*9,SPGR*24,SPGROUP*24,NAME_MOD*80
C !!!!
C ---
      CHARACTER LINE*80,TTT*80,ITYPE*4,SOLV*1,PATT*1,MOD*1,P1*1,F000I*1
      CHARACTER ACORR*1,ANISO2*1,RB*1
C
      CHARACTER NAME*256,NAMEFF*256,NAMES*256,NAMEG*256,NAMET*256
      CHARACTER NAMEFS*256,NAMECC*256
C ======================================================================
      MD   = -ABS(MDOC)-1
      M    = 99
      RB = 'N'
      IF(IERR.EQ.1) RB = 'Y' 
      IERR = 0
      ISIGNAL_STOP = 0
C ---
      DO I=1,IPRROW
        RESULT (I,1) = 0.0
        RESULTA(I,1) = 0.0
      ENDDO
      DO I=1,IPRVAR
        P_OLD(I) = 0.0
      ENDDO
C ---
      NDOM  = 0
      ANISO = ANISOI
      IF(P1   .EQ.'y') P1    = 'Y'
      IF(P1   .NE.'Y') P1    = 'N'

      IF(F000I.EQ.'y') F000I = 'Y'
      IF(F000I.NE.'Y') F000I = 'N'

      IF(DOM  .EQ.'y') DOM   = 'Y'
      IF(DOM  .EQ.'s') DOM   = 'S'
      IF(DOM  .EQ.'c') DOM   = 'C'
      IF(DOM  .EQ.'i') DOM   = 'I'
      IF(DOM  .NE.'Y'.AND.DOM.NE.'S'.AND.
     *   DOM  .NE.'I'.AND.DOM.NE.'C') DOM   = 'N'

      IF(REFA .EQ.'n') REFA  = 'N'
      IF(REFA .NE.'N') REFA  = 'Y'
      IF(REFX .EQ.'n') REFX  = 'N'
      IF(REFX .NE.'N') REFX  = 'Y'
      IF(REFB .EQ.'y') REFB  = 'Y'
      IF(REFB .NE.'Y') REFB  = 'N'

      IVAR = 0
      IF(NCYCL.LT. 0 ) IVAR = 1
      NCYCL = ABS(NCYCL) 
      IF(NCYCL.LE. 0 ) NCYCL = 5

      IF(MODE .EQ.'u') MODE = 'U'
      IF(MODE .NE.'U') MODE = 'R'
c      IF(MODE .EQ.'U') MODE = 'N'

      IF(ANISO.EQ.'k') ANISO = 'K'
      IF(ANISO.EQ.'s') ANISO = 'S'
      IF(ANISO.EQ.'c') ANISO = 'C'
      IF(ANISO.EQ.'y') ANISO = 'Y'
      IF(ANISO.EQ.'a') ANISO = 'A'
      IF(ANISO.NE.'S'.AND.ANISO.NE.'C'.AND.ANISO.NE.'K'.AND.
     *   ANISO.NE.'A'.AND.ANISO.NE.'Y') ANISO = 'N'
      IF(ANISO.EQ.'S') ANISO = 'Y'

      IF(SCALEG.LE.0.000001) SCALEG = 0.5
      IF(BOFF  .LE.0.000001) BOFF   = 1600.0
      IF(MODE.EQ.'U') SCALEG = SCALEG*0.5
      SCALES = SCALEG*1.0

C     IF(P1.EQ.'Y') REFX = 'N'
C ---------------------------------------------------
      NAMECC  = 'rotfft_scr2'
      CALL ADD_PATH(PATH_SCR,NAMECC)
      MOD = 'E'
      DO I=1,3
        SH1(I) = 0.0
        SH2(I) = 0.0
        DO J=1,3
          RM(I,J) = 0.0
        ENDDO
      ENDDO
      ALPHA = 0.0
      BETA  = 0.0
      GAMMA = 0.0
      MMM   = M
      IF(LIST.EQ.'T') MMM = MDOC

      IF(DOM.EQ.'C') THEN

        CALL COPY_CRD_NCS_NEW(MDOC,NAMEC,NAMECC
     *   ,NTOT,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) RETURN

C        CALL COPY_CRD_NCS_NEW(MDOC,NAMEC,NAMECC
C     *  ,NCS_ID,NM_TOTAL,NTOT
C     *  ,ANGLES_NCS_INP,ANGLES_RESTR,CENTRE_NCS
C     *  ,IPRDOM,NSYM,ISYM,IPRSYM,IERR)
C        IF(IERR.NE.0) RETURN
C        CENTRE_COM(1) = CENTRE_NCS(1)
C        CENTRE_COM(2) = CENTRE_NCS(2)
C        CENTRE_COM(3) = CENTRE_NCS(3)

      ELSE 
        CALL TRANS(MMM,NAMEC,NAMECC,SH1,SH2
     *     ,MOD,RM,ALPHA,BETA,GAMMA,RESULTB,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) RETURN
        NTOT = RESULTB(1,1) 
      ENDIF

C      write(*,*) '--ntot:',ntot

      IF(P1.EQ.'Y') THEN
        CALL GET_CELL(RLATT,CODE,NAME_MOD,DATE,TTT
     *       ,NSPGROUP,NOSETT,SPGR,NSM,IERR)
        SPGROUP = 'P 1' 
        CALL CHANGE_CELL(MDOC,NAMECC,PATH_SCR,RLATT,SPGROUP
     *                                  ,ISYM,IPRSYM,IERR)
      ENDIF
C ----------------------------

      IF(P1.EQ.'Y') THEN
        NAMEFS   = 'rotfft_scr1'
        CALL ADD_PATH(PATH_SCR,NAMEFS)
        CALL F2P1(M,NAMEF,NAMEFS,RESX
     * ,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) RETURN
      ELSE
        NAMEFS = NAMEF
      ENDIF
      MTN   = 10
      ITYPE = 'FF  '
      CALL ORFILE(M,MTN,NAMEFS,ITYPE,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN INPUT-FILE-FOBS')
        RETURN
      ENDIF
      CALL GET_TITLE(MD,A,B,C,AL,BE,GA
     *  ,F1,F2,RESMIN,RESMAX,IDM,IDM,IDM,IDM,IDM,TTT,IERR)
      CLOSE(MTN)
      CALL C_RD_CR
C -------------------------------------------------------------

C     1        2        7      3        4          5         6     8    9
C X0(M,3),NUMDOM(M),BFAC0(M),GRADX(M,3),DIAG(M),DXDA(M,3,3),X(M,3),
C                                                              BFAC(M),BSHFT(M)
C  
      MEM = NTOT*8 + 100
      IT = 0
      allocate(X0(1:MEM,1:3),STAT=ISTAT)
      allocate(X(1:MEM,1:3),STAT=ISTAT)
      allocate(GRADX(1:MEM,1:3),STAT=ISTAT)
      allocate(DXDA(1:MEM,1:3,1:3),STAT=ISTAT)
      allocate(DIAG(1:MEM),STAT=ISTAT)
      allocate(BFAC0(1:MEM),STAT=ISTAT)
      allocate(BFAC(1:MEM),STAT=ISTAT)
      allocate(BSHFT(1:MEM),STAT=ISTAT)
      allocate(NUMDOM(1:MEM),STAT=ISTAT)
                                                              
C      I1  =       1
C      I2  = 3*MEM+1
C      I7  = 4*MEM+1
C      I3  = 5*MEM+1
C      I4  = 8*MEM+1
C      I5  = 9*MEM+1
C      I6  =18*MEM+1
C      I8  =21*MEM+1
C      I9  =22*MEM+1
C      IM  =23*MEM
C      IF(IM.GT.MEMORY) THEN
C
C      ENDIF

C      MEM_FFT = MEMORY - MEM*5
      MEM_FFT = MEMORY 

C --------------------------------------------
      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.LE.0.OR.NAMEO(1:1).EQ.','.OR.NAMEO(1:1).EQ.' ') THEN
        NAMEO='rotfft'
        CALL ADD_PATH(PATH_SCR,NAMEO)
      ENDIF

      CALL RD_INI_CRD_RTFFT_NEW(MDOC,NAMECC,DOM
     * ,X0,X,GRADX,NUMDOM,BFAC0,BFAC,BSHFT
     * ,MEM,MEM
     * ,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
      NAMET = NAMECC

c       write(*,*) '--na_tot:',NA_TOTAL,NTOT

      IF(NTOT.NE.NA_TOTAL) THEN
        IF(LIST.EQ.'T') THEN
          WRITE(*,*) '!!!--> NTOT,NA_TOTAL:', NTOT,NA_TOTAL
        ENDIF
        IF(NTOT.LT.NA_TOTAL) THEN
          CALL MSGERR(MDOC,' WARNING: (rotfft) Ntot < Na_total')
        ENDIF
      ENDIF 

      IF(DOM.NE.'N'.AND.DOM.NE.'Y') THEN
        NAMET = 'rotfft_scr1'
        CALL ADD_PATH(PATH_SCR,NAMET)
        IF(DOM.EQ.'I'.OR.DOM.EQ.'C') NAMET = NAMEO

        CALL WR_CRD_RTFFT_NEW(M,NAMECC,NAMET
     * ,X0,DOM,NUMDOM,BFAC0
     * ,NATOM,MEM,MEM,P1,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
        IF(DOM.EQ.'I'.OR.DOM.EQ.'C') GO TO 900
      ENDIF
C -------------------------------
      IF(RESX.GT.0.00001.AND.RESX.GT.RESMAX) RESMAX=RESX
      IF(RESN.GT.0.00001.AND.RESN.LT.RESMIN) RESMIN=RESN
      IF(RESMIN.LT.RESMAX) THEN
        T      = RESMIN
        RESMIN = RESMAX
        RESMAX = T
      ENDIF
      IF(RESMIN.EQ.RESMAX) THEN
        CALL MSGERR(MDOC,' ERROR: resmin = resmax')
        IERR=1
        GO TO 900
      ENDIF
      WRITE(LINE,'('' Resolution                  :'',2F8.2)') 
     * RESMIN,RESMAX
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Boff,Badd                   :'',2F8.2)') 
     * BOFF,BADD
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,'('' P1,DOM,F000,ANISO           :'',A,A,A,A)') 
     * P1,DOM,F000I,ANISO
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' grad_scale                  :'',F8.2)') 
     * SCALEG
      CALL MSGDOC(MD,LINE)
C ------------------------------------------
      IF(ANISO.EQ.'A'.OR.ANISO.EQ.'C') THEN
        CALL MSGDOC(MDOC,'--- anisothermal correction of Fobs ---')
        BADDD    = 0.0
C        BOFFF    = 256.0
        BOFFF    = BOFF
        SCALE    = 1.0
        BOVER    = 0.0
        PATT     = 'Y'
        SOLV     = 'N'
        NC       =  0
        RESMNI   = 0.0
        RESMXI   = 0.0
        
        NAME   = ' '
        NAMEFF = 'rotfft_cor'
        CALL ADD_PATH(PATH_SCR,NAMEFF)
        ACORR  = 'Y'
        ANISO2 = '-'
        CALL MR_SCALING(M,LIST,NAME,NAMEFS,NAMEFF,PATH_SCR
     * ,ANISO2,SCALE,BOVER,ACORR,BOFFF,BADDD,RESMNI,RESMXI
     * ,SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF
     * ,RESULTA,IPRMAX,IPRROW,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900
C ---------------------------------------------------------
C     1. ACORR # N - anisothermal correction of Fmod
c        if ANISO = '-' return
C     2. ANISO = K - FSCALE with SCALEP,BSCALE
C                   if scale = 0 - scaling by Fobs (cell must be the same)
C                      only scale , set BOVER = 0
C                   if scalei>0  - scaling by SCALEI,BOVERI without FN file,
C                                  no info: rfac, corr
C        else  CALL PSCALE
C      output: SCALEP_NEW,BSCALE_NEW,RFAC_REF,CORR_REF and NAMEFM2
C ---------------------------------------------------------
       
C        CALL ANISOSCL(M,NAMEFS,NAME,NAMEFF
C     *   ,RESMNI,RESMXI,SCALE,BOVER
C     *   ,NC,BOFFF,BADDD,SOLV,PATT
C     *   ,ISYM,IPRSYM,RESULTA,IPRROW,IERR)
C        IF(IERR.NE.0) GO TO 900
C
C
C        RESULT(11,1)=EVAL(1) Ratio of Eigen values 
C        RESULT(12,1)=EVAL(2)
C        RESULT(13,1)=EVAL(3)
C        RESULT( 3,3)  = SQR_P000 - sqrt(P000_patt) for file_1 (test)
C        RESULT( 4,3)  = B_OVER     B_overall
C        RESULT( 5,3)  = RESEFF     Res_optical
C        RESULT( 6,3)  = RESMXI     Res_max
C
C        CALL MSGDOC(MDOC,
C     *  ' Anisotropic distribution of Structure Factors:')
C        WRITE(LINE,'('' Ratio of Eigen values :'',3F8.4)')
C     *  RESULTA(11,1),RESULTA(12,1),RESULTA(13,1)    
C        CALL MSGDOC(MDOC,LINE)
      ELSE
        NAMEFF = NAMEFS
      ENDIF
C ---
      CC_INIT = -1000.0
      RF_INIT =  1000.0
      RF_OLD =  1000.0
      CC_OLD = -1000.0
      IFIRST_CC = 0
      NAMES  = NAMET
      NAMEG  = 'rotfft_grd'
      CALL ADD_PATH(PATH_SCR,NAMEG)
      NCR    = 0
      IFIRST = 0
      LINE =  'INFO: information about model/domain'//
     *        ' movement see in molrep.doc'
      CALL MSGDOC(MDOC,LINE)

      LINE = '+--------------------------------------'//
     *       '--------------------------------------+'
      CALL MSGDOC(MDOC,LINE)
      LINE = '|     Nc             wRfac   Corr  '//
     *       '   Chi-1  Sh-1 Chi-2  Sh-2 Chi-3  Sh-3 ...|'
      CALL MSGDOC(MDOC,LINE)
      LINE = '+--------------------------------------'//
     *       '--------------------------------------+'
      CALL MSGDOC(MDOC,LINE)
c --------------------------------------------

 100  CONTINUE
      ITEST = 0
      CALL CALCGRD_RTFFT(MDOC,LIST,NAMES,NAMEFF,NAME_PH,NAMEG
     * ,PATH_SCR,BOFF,BADD,F000I
     * ,RESMIN,RESMAX,SCALEG,ANISO,NCR,NCYCL,P1,IVAR,ITEST
     * ,RF_NEW,CC_NEW,RF_OLD,CC_OLD
     * ,RESULTA,IPRROW,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C ---------------------------------------------
      IF(CC_NEW.GE.CC_OLD) THEN

        RESULTA(1,1) = NCR
        DO I=1,IPRROW
          RESULT(I,1) = RESULTA(I,1)
        ENDDO
        RESULT(7,1) = CC_INIT
        RESULT(6,1) = RF_INIT

        IF(NCR.LE.0.AND.IFIRST_CC.EQ.0) THEN
          CC_INIT = CC_NEW 
          RF_INIT = RF_NEW 
          IFIRST_CC = 1
        ENDIF

        MOD = 'E'
        DO I=1,3
          SH1(I) = 0.0
          SH2(I) = 0.0
          DO J=1,3
            RM(I,J) = 0.0
          ENDDO
        ENDDO
        ALPHA = 0.0
        BETA  = 0.0
        GAMMA = 0.0
        MMM = M
        IF(LIST.EQ.'T') MMM = MDOC
        CALL TRANS(MMM,NAMES,NAMEO,SH1,SH2
     *    ,MOD,RM,ALPHA,BETA,GAMMA,RESULTB,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 900

      ELSE

        CALL CHECK_STOP_SIGNAL(PATH_SCR,ISIGNAL_STOP)
        IF(ISIGNAL_STOP.GT.0) GO TO 200

        IF(IVAR.EQ.0) GO TO 200

      ENDIF

      CALL CHECK_STOP_SIGNAL(PATH_SCR,ISIGNAL_STOP)
      IF(ISIGNAL_STOP.GT.0) GO TO 200

      IF(NCR.GE.NCYCL) GO TO 200
C ---------------------------------------------
      IF(MODE.EQ.'R') THEN
        NAME=NAMET
C -VAR  
C       NAME=NAMES
C -VAR
      ELSE
        NAME=NAMES
      ENDIF
      CALL RB_REFINE_FFT_NEW(MDOC,LIST,NAME,NAMEG,NAMEFF,NAME_PH
     * ,PATH_SCR
     * ,BOFF,BADD,DOM,NCR,MODE,P1,SCALEG,REFA,REFX,REFB
     * ,RESMIN,RESMAX,ANISO,F000I  
     * ,IFIRST,CC_NEW,P_OLD,MEM  
     * ,X0,NUMDOM,GRADX,DIAG,DXDA,X
     * ,BFAC0,BFAC,BSHFT
     * ,MEM,RESULTA,IPRROW,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        IF(NCR.GT.0) IERR=0
        IF(IERR.EQ.2) IERR = 0
        GO TO 900
      ENDIF
C ----------------------------------------------------
      NAMES  = 'rotfft_scr'
      CALL ADD_PATH(PATH_SCR,NAMES)
      MMM = M
      IF(LIST.EQ.'T') MMM = MDOC
      CALL WR_CRD_RTFFT_NEW(MMM,NAMET,NAMES,X,DOM,NUMDOM,BFAC
     * ,NATOM,MEM,MEM,P1,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C -------------------------------------------------------
      NCR    = NCR + 1
      IF(CC_NEW.GT.CC_OLD) THEN
        CC_OLD = CC_NEW
        RF_OLD = RF_NEW
      ENDIF
      GO TO 100
C ---------------
 200  CONTINUE
      LINE = '+--------------------------------------'//
     *       '--------------------------------------+'
      CALL MSGDOC(MDOC,LINE)

      IF(P1.EQ.'Y') THEN

        SPGROUP = SPGR 
        CALL CHANGE_CELL(MDOC,NAMEO,PATH_SCR,RLATT,SPGROUP
     *                                  ,ISYM,IPRSYM,IERR)
      ENDIF

      RESULT(7,1) = CC_INIT
      RESULT(6,1) = RF_INIT
      IF(IPRROW.GE.13) THEN
        RESULT(20,1) = NDOM
      ENDIF      
C ---
 900  CONTINUE
      deallocate(X0,STAT=ISTAT)
      deallocate(X,STAT=ISTAT)
      deallocate(GRADX,STAT=ISTAT)
      deallocate(DXDA,STAT=ISTAT)
      deallocate(DIAG,STAT=ISTAT)
      deallocate(BFAC0,STAT=ISTAT)
      deallocate(BFAC,STAT=ISTAT)
      deallocate(BSHFT,STAT=ISTAT)
      deallocate(NUMDOM,STAT=ISTAT)
      RETURN
      END


      SUBROUTINE RB_REFINE_FFT_NEW(MDOC,LIST
     *  ,NAMEC,NAMEG,NAMEFF,NAME_PH
     * ,PATH_SCR
     * ,BOFF,BADD,DOM,NCR,MODE,P1,SCALEG,REFA,REFX,REFB
     * ,RESMIN,RESMAX,ANISO,F000I  
     * ,IFIRST,CC_CUR,P_OLD,MEM  
     * ,X0,NUMDOM,GRADX,DIAG,DXDA,X
     * ,BFAC0,BFAC,BSHFT
     * ,NCRDMAX,RESULT,IPRROW,NSYM,ISYM,IPRSYM,IERR)
C ----------------------------------------------------------
      REAL    X0(MEM,3),GRADX(MEM,3),DIAG(MEM)
      REAL    X(MEM,3),DXDA(MEM,3,3)
      REAL    BFAC0(MEM),BFAC(MEM),BSHFT(MEM)
      INTEGER NUMDOM(MEM)
C ----------------------------------------------------------
C ===
      PARAMETER ( IPRDOM = 300    )
      PARAMETER ( IPRVAR =IPRDOM*6     )
      PARAMETER ( IPRVR2 =IPRVAR*IPRVAR)

      COMMON /VITALS_FFT/ NATOM,FUNCT,NDOM,NP,NV,DFDA,DFDT,INDX
     *               ,AM,BV,DV,P,KI,THETA,TX,R,Q,SCALES
C ---
      REAL      THETA(3,IPRDOM),TX(3,IPRDOM)
      REAL      AM(IPRVR2),BV(IPRVAR),DV(IPRVAR),P(IPRVAR)
      REAL      P_OLD(IPRVAR)
      INTEGER   KI(IPRVAR),INDX(IPRVAR,3)
      REAL      R(3,3,IPRDOM),Q(3,3,3,IPRDOM)
      REAL      DFDA(3,IPRDOM),DFDT(3,IPRDOM),DXDV(3,6)
C ===
C ==========
      PARAMETER ( IGRDOM = 300    )
      COMMON /DOMAIN_ROTFFT_NEW/ 
     *                       NG_TOTAL
     *                      ,NA_TOTAL,NM_TOTAL,NA_MOL,ANGLES_RESTR
     *                      ,ND_TOTAL,NA_DOM
     *                      ,ID_GRP,ID_MOL,ID_DOM,CENTRE,RADI
     *                      ,NP_TOTAL,NMD_TOTAL,ANGLES_OBS,CENTRE_COM
     *                      ,CENTRE_MOL,SHIFT_MOL
      INTEGER   NG_TOTAL,NP_TOTAL,NA_TOTAL
     *         ,NM_TOTAL(IGRDOM),NA_MOL(IPRDOM,IGRDOM)
     *         ,NMD_TOTAL(IGRDOM)
      INTEGER   ND_TOTAL
      REAL      ANGLES_RESTR(3,IPRDOM,IGRDOM)
     *         ,ANGLES_OBS(3,IPRDOM,IGRDOM)
      INTEGER   NA_DOM(IPRDOM)
     *         ,ID_GRP(IPRDOM),ID_MOL(IPRDOM),ID_DOM(IPRDOM)    
      REAL      CENTRE(3,IPRDOM),RADI(IPRDOM),CENTRE_COM(3,IGRDOM)
      REAL      CENTRE_MOL(3,IPRDOM,IGRDOM),SHIFT_MOL(3,IPRDOM,IGRDOM)
C ==========
C ------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW,51)
      CHARACTER NAMEC*(*),NAMEG*(*),P1*1,DOM*1,REFA*1,REFX*1,MODE*1
      CHARACTER NAMES*256,NAMEFF*(*),PATH_SCR*(*),NAME_PH*(*)
      CHARACTER LIST*1,ANISO*1,F000I*1,REFB*1    
C ----------------------
      REAL      SMAT1(3,3),SMAT2(3,3)
      REAL      ANG(3),RM(3,3),RM1(3,3),V1(3),V2(3)
      CHARACTER LINE*80
C ======================================================================
      MD     = -ABS(MDOC)-1
      M      = 99
      IERR   = 0
C --
      PI     = 4.0*ATAN(1.0)
      RTODEG = 180./PI
      DEGTOR = 1.0/RTODEG
C --------------------------------------------

      CALL RD_CRD_RTFFT(M,NAMEC,NAMEG,DOM,SCALEG
     *               ,X0,GRADX,DIAG,NUMDOM,BFAC0,BSHFT
     *               ,NCRDMAX,MEM
     *               ,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) RETURN

C ----------------------------------------------
      NA = NATOM      
C     NA_TOTAL
      IF(NA.NE.NA_TOTAL) THEN
        IF(LIST.EQ.'T') THEN
          WRITE(*,*) '!!!--> NA,NA_TOTAL:', NA,NA_TOTAL
        ENDIF
        CALL MSGERR(MDOC,' WARNING: (rotfft) Na # Na_total')
      ENDIF 

      SHIFT_AVER = 0.0
      DIAG_AVER = 0.0
      COEF = SCALEG * 1.0
      DO IA=1,NA
        BFAC(IA) = BFAC0(IA)
        IF(DIAG(IA).LT.0.000001) THEN
          GRADX(IA,1)=0.0
          GRADX(IA,2)=0.0
          GRADX(IA,3)=0.0
          BSHFT(IA)  =0.0
          DIAG(IA)   =0.0
        ELSE
          GRADX(IA,1)=GRADX(IA,1)*COEF
          GRADX(IA,2)=GRADX(IA,2)*COEF
          GRADX(IA,3)=GRADX(IA,3)*COEF
          BSHFT(IA)  =BSHFT(IA)  *COEF
          DIAG(IA)   =DIAG(IA)   
          SHFTX = GRADX(IA,1)/DIAG(IA)
          SHFTY = GRADX(IA,2)/DIAG(IA)
          SHFTZ = GRADX(IA,3)/DIAG(IA)
          DS2   = SHFTX*SHFTX+SHFTY*SHFTY+SHFTZ*SHFTZ
          SHIFT_AVER = SHIFT_AVER + SQRT(ABS(DS2))
          DIAG_AVER  = DIAG_AVER  + DIAG(IA)
        ENDIF
      ENDDO
      SHIFT_AVER = SHIFT_AVER/FLOAT(NA)
      DIAG_AVER = DIAG_AVER/FLOAT(NA)

      IF(LIST.EQ.'T') THEN
        write(*,*)'--c:',NAMEC
        write(*,*)'--g:',NAMEG
        write(*,*) '<s>,<d>,coef:',SHIFT_AVER,DIAG_AVER,coef
      ENDIF
C ---------------

      IF(DOM.EQ.'S') THEN
        DO IG=1,NG_TOTAL
          DO IA=1,NA
            ID   = NUMDOM(IA)
            IMOL = ID_MOL(ID)
            IGR  = ID_GRP(ID)
            IF(IMOL.EQ.1.AND.IGR.EQ.IG) THEN
              X(IA,1) = 0.0
              X(IA,2) = 0.0
              X(IA,3) = 0.0
              DXDA(IA,1,1) = 0.0
            ENDIF
          ENDDO        
          NDOM_M = 0
          DO IM=1,NM_TOTAL(IG)
            A1 = ANGLES_RESTR(1,IM,IG)*DEGTOR
            A2 = ANGLES_RESTR(2,IM,IG)*DEGTOR
            A3 = ANGLES_RESTR(3,IM,IG)*DEGTOR
            CALL POLTOM(A1,A2,A3,RM)
            IF(IM.EQ.1) THEN
              DO I=1,3
              DO J=1,3
                RM(I,J) = 0.0
              ENDDO        
              ENDDO        
              RM(1,1) = 1.0
              RM(2,2) = 1.0
              RM(3,3) = 1.0
            ENDIF
            CALL MTRANS(RM,RM1)
            IA1    = 0
            NMA    = 0
            IFIRST = 0
            DO IA=1,NA
              ID   = NUMDOM(IA)
              IMOL = ID_MOL(ID)
              IGR  = ID_GRP(ID)
              IF(IMOL.EQ.1.AND.IG.EQ.IGR) THEN
                NMA    = IA
                IF(NDOM_M.LT.ID) NDOM_M = ID
              ENDIF
              IF(IM.EQ.IMOL.AND.IG.EQ.IGR) THEN
                IF(IFIRST.EQ.0) THEN
                  IAM    = IA - 1
                  IFIRST = 1
                ENDIF
                IA1 = IA - IAM
                IF(IA1.GT.0) THEN
                  V1(1) = GRADX(IA,1)
                  V1(2) = GRADX(IA,2)
                  V1(3) = GRADX(IA,3)
                  CALL MVMULT(RM1,V1,V2)
                  X(IA1,1) = X(IA1,1) + V2(1)
                  X(IA1,2) = X(IA1,2) + V2(2)
                  X(IA1,3) = X(IA1,3) + V2(3)
                  DXDA(IA1,1,1) = DXDA(IA1,1,1) + DIAG(IA)

C        IF(IA1.EQ.8) THEN
C        WRITE(*,*) '----0:'
C     *  ,IMOL,V1(1),V1(2),V1(3),DIAG(IA)
C        WRITE(*,*) '-----:'
C     *  ,IMOL,V2(1),V2(2),V2(3),DIAG(IA)
C        ENDIF

                ENDIF
              ENDIF
            ENDDO
          ENDDO

          DO IA=1,NMA
            X(IA,1) = X(IA,1)/FLOAT(NM_TOTAL(IG))
            X(IA,2) = X(IA,2)/FLOAT(NM_TOTAL(IG)) 
            X(IA,3) = X(IA,3)/FLOAT(NM_TOTAL(IG))
            DXDA(IA,1,1) = DXDA(IA,1,1)/FLOAT(NM_TOTAL(IG))

C          IF(IA.EQ.8)
C     *    WRITE(*,*) '-0000:'
C     *    ,X(IA,1),X(IA,2),X(IA,3),DXDA(IA,1,1)

          ENDDO

c         WRITE(*,*) 'NDOM,NDOM_M,NA,NMA:',NDOM,NDOM_M,NA,NMA

        ENDDO
      ENDIF
C ----------------------------------------------------
C ---
      NSYM_R = NSYM
      IF(P1.EQ.'Y') NSYM_R=1

      CALL CHECK_REF(NSYM_R,ISYM,IFX,IFY,IFZ)             
      DO I=1,IPRVAR
        KI(I)=1
      ENDDO

      DO I=1,IPRDOM
        IND=(I-1)*6
        IF(REFA.EQ.'N') THEN
          KI(IND+1)=0
          KI(IND+2)=0
          KI(IND+3)=0
        ENDIF
        IF(REFX.EQ.'N') THEN
          KI(IND+4)=0
          KI(IND+5)=0
          KI(IND+6)=0
        ENDIF
      ENDDO
      CALL LENSTR_BL(NAME_PH,LEN)
      IF(LEN.GT.0.AND.NAME_PH(1:1).NE.'.'.AND.NAME_PH(1:1).NE.' ') THEN
      ELSE  
        IF(IFX.EQ.0) KI(4)=0
        IF(IFY.EQ.0) KI(5)=0
        IF(IFZ.EQ.0) KI(6)=0
        IF(P1.EQ.'Y') THEN
          KI(4)=0
          KI(5)=0
          KI(6)=0
        ENDIF
      ENDIF
C ---------------------------------------------------
      EULSIG = 5.0
      NP     = NDOM*6
      NV     = NP
C -----------------------
C --VAR - 
      IF(NCR.EQ.0) THEN

        DO     J=1,NDOM
          DO     I=1,3
            THETA(I,J)=0.0
            TX   (I,J)=0.0
          ENDDO
          A1 = THETA(1,J)*DEGTOR
          A2 = THETA(2,J)*DEGTOR
          A3 = THETA(3,J)*DEGTOR
          CALL EUL_RTFFT(A1,A2,A3,R(1,1,J),Q(1,1,1,J))
        ENDDO

      ENDIF
C --VAR -
C---
      IF(NCR.EQ.0) THEN
        DO     I=1,NP
          P(I)=0.0
        ENDDO
      ENDIF

      IF(MODE.EQ.'U') THEN

        COEF      = 0.5*SCALEG
        SHIFT_LIM = 0.5

        DO IA=1,NA

          IF(DIAG(IA).GT.0.000001) THEN

             SHFTX = GRADX(IA,1)/DIAG(IA)
             SHFTY = GRADX(IA,2)/DIAG(IA)
             SHFTZ = GRADX(IA,3)/DIAG(IA)
             DS2 = SHFTX*SHFTX+SHFTY*SHFTY+SHFTZ*SHFTZ
             DS=SQRT(ABS(DS2))
             SHFTB = BSHFT(IA)         
           
             IF(DS.GT.SHIFT_LIM) THEN
               SHFTX=(SHFTX*SHIFT_LIM)/DS
               SHFTY=(SHFTY*SHIFT_LIM)/DS
               SHFTZ=(SHFTZ*SHIFT_LIM)/DS
             ENDIF

          ELSE

           SHFTX = 0.0
           SHFTY = 0.0
           SHFTZ = 0.0
           SHFTB = 0.0
           DS2   = 0.0
           DS    = 0.0

          ENDIF

          IF(REFX.EQ.'Y') THEN
            X(IA,1) = X0(IA,1) + SHFTX
            X(IA,2) = X0(IA,2) + SHFTY
            X(IA,3) = X0(IA,3) + SHFTZ
          ELSE
            X(IA,1) = X0(IA,1) 
            X(IA,2) = X0(IA,2) 
            X(IA,3) = X0(IA,3) 
          ENDIF
          IF(REFB.EQ.'Y') THEN
            BF       = BFAC0(IA) + SHFTB
            IF(BF.LT. 2) BF = 2.0
            IF(BF.GT.99) BF = 99.0
            BFAC(IA) = BF
          ELSE
            BFAC(IA) = BFAC0(IA)
          ENDIF

        ENDDO
        GO TO 900
      ENDIF
C
C     EVALUATE THE ROTATION AND DERIVATIVE MATRICES
C
C      DO     I=1,NDOM_M
C        A1 = THETA(1,I)*DEGTOR
C        A2 = THETA(2,I)*DEGTOR
C        A3 = THETA(3,I)*DEGTOR
C        CALL EUL_RTFFT(A1,A2,A3,R(1,1,I),Q(1,1,1,I))
C      ENDDO
C
C     INITIALIZATION THE NORMAL EQUATIONS MATRIX AND RHS VECTOR
C
      DO     I=1,NP
        BV(I) = 0.0
        DO     J=1,NP
          IND     = (J-1)*NP+I
          AM(IND) = 0.0
        ENDDO
      ENDDO
C
C     PRE-CONDITION THETA+ AND THETA- REFINEMENT
C
      IF(EULSIG.GT.0.0) THEN
        DO     I=1,NDOM
          J       = (I-1)*6
          IND     = (J+1-1)*NP+J+1
          AM(IND) = 1.0/(EULSIG*DEGTOR)**2
          IND     = (J+3-1)*NP+J+3
          AM(IND) = 1.0/(EULSIG*DEGTOR)**2
        ENDDO
      ENDIF
C
C     EVALUATE POSITIONAL DERIVATIVES WRT EULER ANGLES
C

      DO     KA=1,3
      DO     IX=1,3
      DO     IA=1,NA
        ID             = NUMDOM(IA)
        DXDA(IA,IX,KA) = 0.0
        DO     JX=1,3
c          DXDA(IA,IX,KA) = DXDA(IA,IX,KA) + 
c     *                     Q(IX,JX,KA,ID)*X0(IA,JX) 
          DXDA(IA,IX,KA) = DXDA(IA,IX,KA) + 
     *                     Q(IX,JX,KA,ID)*(X0(IA,JX) - CENTRE(JX,ID))
        ENDDO
      ENDDO
      ENDDO
      ENDDO

C --------------
        DO  IA=1,NA

          DO  KA=1,3

            DO  ID=1,NDOM
              DFDA(KA,ID) = 0.0
            ENDDO
 
            DO  JX=1,3
              ID = NUMDOM(IA)
              DFDA(KA,ID) = DFDA(KA,ID) + GRADX(IA,JX)*DXDA(IA,JX,KA)
            ENDDO
          ENDDO

C         TRANSLATION VECTOR DERIVATIVES
C
          DO  LT=1,3

            DO  ID=1,NDOM
              DFDT(LT,ID) = 0.0
            ENDDO

            ID = NUMDOM(IA)
            DFDT(LT,ID) =  DFDT(LT,ID) + GRADX(IA,LT)

          ENDDO
C
C       TRANSFORM TO LATTMAN'S THETA+/THETA- SYSTEM
C
          DO  ID=1,NDOM
            J = (ID-1)*6
            DV(J+1) = 0.5*(DFDA(1,ID)+DFDA(3,ID))
            DV(J+2) =      DFDA(2,ID)            
            DV(J+3) = 0.5*(DFDA(1,ID)-DFDA(3,ID))
            DO     I=1,3
              IJ=I+J
              DV(IJ+3) = DFDT(I,ID)
            ENDDO
          ENDDO
C
C       INCREMENT MATRIX AND VECTOR ELEMENTS
C

C          DO   I=1,NV
C            IDOM  = (I-1)/6+1
C            DO   J=1,NV
C              JDOM  = (J-1)/6+1
C              IF(IDOM.EQ.JDOM) THEN
C                IND     =(J-1)*NP+I
C                AM(IND) = AM(IND) + DV(I)*DV(J)
C              ENDIF
C            ENDDO
C          ENDDO

          DO   I=1,NV
            BV(I) = BV(I) + DV(I)
          ENDDO

        ENDDO

C ====
        DO  IA=1,NA
          ID = NUMDOM(IA)

          DO  IV=1,6
            DO  IX=1,3
              IF(IV.LE.3) THEN
                DXDV(IX,IV) = DXDA(IA,IX,IV)
              ELSE
                DXDV(IX,IV) = 0.0
                IF(IX.EQ.(IV-3)) DXDV(IX,IV) = 1.0
              ENDIF
            ENDDO
          ENDDO

          DO IX=1,3
            T          = (DXDV(IX,1)+DXDV(IX,3))*0.5
            DXDV(IX,3) = (DXDV(IX,1)-DXDV(IX,3))*0.5
            DXDV(IX,1) =  T
          ENDDO

          DO  I=1,6
          DO  J=1,6

            IND = ((ID-1)*6+(I-1))*NP + (ID-1)*6 + J

            DO IX=1,3
              AM(IND) = AM(IND) + DXDV(IX,I)*DXDV(IX,J)*DIAG(IA)
            ENDDO

          ENDDO
          ENDDO

        ENDDO
C --------------
C
C     APPLY THE VARIABLE FREEZE OPERATOR TO THE NORMAL EQUATIONS
C
      DO  I=1,NP
        BV(I) = KI(I)*BV(I)
        DO  J=1,NP
          IND     = (J-1)*NP+I
          AM(IND) = KI(I)*KI(J)*AM(IND)
        ENDDO
        IND = (I-1)*NP+I
C
C ??        IF(AM(IND).EQ.0.0) AM(IND)=1.0
C
      ENDDO
C
C     INVERT THE MATRIX AND OBTAIN NEW PARAMETERS
C

      DMAX=-1.0E30          
      DO I=1,NP
        IND=(I-1)*NP+I
        IF(ABS(AM(IND)).GT.DMAX) DMAX=AM(IND)
      ENDDO

      TOL=1.0E-7
      DO   I=1,NP
        IND=(I-1)*NP         
        IF(ABS(AM(IND+I))/DMAX.LE.TOL) THEN
          BV(I) = 0.0
          DO    J=1,NP
            AM(IND+J) = 0.0
            INDJ=(J-1)*NP 
            AM(INDJ+I) = 0.0
          ENDDO
        ENDIF  
      ENDDO

      CALL SVSOLV_RBFFT(AM,NP,NP,NP,NP,BV,DV,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,
     *  ' WARNING: subroutine: "rotfft" is terminated')
        RETURN
      ENDIF

C --- DV -- SHIFTS

      NSTEP  = 8
      CC_OLD = CC_CUR
      RESULT(20,1) = NDOM

      DO ISTEP=1,NSTEP

        SCALE = FLOAT(ISTEP)*SCALES

C ---
        DO IM=1,NV
          P(IM) = P_OLD(IM) + DV(IM)*SCALE
        ENDDO
C
C
C     LIST THE REVISED PARAMETERS AFTER CONVERSION BACK TO THETA1/THETA3
C
        DO     ID=1,NDOM
          J=(ID-1)*6
          ANG(1)      = 0.5*(P(J+1)+P(J+3))
          ANG(2)      =      P(J+2)        
          ANG(3)      = 0.5*(P(J+1)-P(J+3))
          THETA(1,ID) = ANG(1) * RTODEG
          THETA(2,ID) = ANG(2) * RTODEG
          THETA(3,ID) = ANG(3) * RTODEG
          DO     I=1,3
            IJ=I+J
            TX(I,ID) = P(IJ+3)
          ENDDO

          CALL EUL_RTFFT(ANG(1),ANG(2),ANG(3),R(1,1,ID),Q(1,1,1,ID))

        ENDDO
C ---
        IF(DOM.EQ.'S') THEN

          DO IG=1,NG_TOTAL

C           DO ID=NDOM_M+1,NDOM
            DO ID=1,NDOM
              IM  = ID_MOL(ID)
              IMD = ID_DOM(ID)
              IGR = ID_GRP(ID)
            
              IF(IGR.EQ.IG) THEN

                DO JD=1,NDOM
                  JM  = ID_MOL(JD)
                  JMD = ID_DOM(JD)
                  JGR = ID_GRP(JD)
                  IF(IMD.EQ.JMD.AND.JM.EQ.1.AND.IG.EQ.JGR) THEN
                    IDR = JD
                    GO TO 100
                  ENDIF
                ENDDO      
                IERR = 1
                CALL MSGERR(MDOC,' ERR: in RB_REFINE_FFT')
                RETURN
 100            CONTINUE

C                DO JD=1,NDOM_M
C                  JMD = ID_DOM(JD)
C                 IF(IMD.EQ.JMD) THEN
C                   IDR = JD
C                   GO TO 100
C                 ENDIF    
C               ENDDO      
C 100           CONTINUE

                ANG(1) = ANGLES_RESTR(1,IM,IG)*DEGTOR
                ANG(2) = ANGLES_RESTR(2,IM,IG)*DEGTOR
                ANG(3) = ANGLES_RESTR(3,IM,IG)*DEGTOR
                CALL POLTOM(ANG(1),ANG(2),ANG(3),RM)
                IF(IM.EQ.1) THEN
                  DO I=1,3
                  DO J=1,3
                    RM(I,J) = 0.0
                  ENDDO        
                  ENDDO        
                  RM(1,1) = 1.0
                  RM(2,2) = 1.0
                  RM(3,3) = 1.0
                ENDIF
                CALL MTRANS(RM,RM1)

C               ANG(1) = THETA(1,IDR)*DEGTOR
C               ANG(2) = THETA(2,IDR)*DEGTOR
C               ANG(3) = THETA(3,IDR)*DEGTOR
C               CALL EULERM(ANG(1),ANG(2),ANG(3),SMAT1)

                CALL MTRANS(R(1,1,IDR),SMAT1)
                CALL MATMLT(SMAT1,RM1,SMAT2)
                CALL MATMLT(RM,SMAT2,SMAT1)

C               CALL MTOANG(SMAT1,ANG(1),ANG(2),ANG(3))
C               THETA(1,ID) = ANG(1)
C               THETA(2,ID) = ANG(2)
C               THETA(3,ID) = ANG(3) 

                CALL MTRANS(SMAT1,R(1,1,ID))

                V1(1) = TX(1,IDR)
                V1(2) = TX(2,IDR)
                V1(3) = TX(3,IDR)
                CALL MVMULT(RM,V1,V2)
                TX(1,ID) = V2(1) 
                TX(2,ID) = V2(2) 
                TX(3,ID) = V2(3)
 
              ENDIF

            ENDDO

          ENDDO
        ENDIF
C ---
                
        CALL MSGDOC(MD,
     *   '  Idom    Theta     Phi      Chi       Tx       Ty       Tz')
        DO     ID=1,NDOM

C          ANG(1) = THETA(1,ID) * DEGTOR
C          ANG(2) = THETA(2,ID) * DEGTOR
C          ANG(3) = THETA(3,ID) * DEGTOR
C          CALL EULERM(ANG(1),ANG(2),ANG(3),RM)
C          CALL MTOPOL(RM,ANG(1),ANG(2),ANG(3))

          CALL MTRANS(R(1,1,ID),RM)
          CALL MTOPOL(RM,ANG(1),ANG(2),ANG(3))
          THETA(1,ID) = ANG(1)
          THETA(2,ID) = ANG(2)
          THETA(3,ID) = ANG(3)

          WRITE(LINE,'(I4,'') '',6F9.3)') 
     *    ID,(ANG(I),I=1,3),(TX(I,ID),I=1,3)
          CALL MSGDOC(MD,LINE)
          
          IF(ID.LE.4) THEN

            TSHIFT = SQRT(ABS(TX(1,ID)*TX(1,ID)+TX(2,I)*TX(2,ID)
     *                         +TX(3,ID)*TX(3,ID)))
            II = ID*2 + 10
            RESULT(II-1,1) = ANG(3)
            RESULT(II,1)   = TSHIFT

          ENDIF

        ENDDO
C
C     TRANSFORM COORDINATES TO THE CURRENT POSITION
C

C        WRITE(*,*) '--istep:',istep,scale
C        WRITE(*,*) '--x0   :',X0(1,1),X0(1,2),X0(1,3)
C        WRITE(*,*) '--tx   :',tx(1,1),tx(2,1),tx(3,1)

        DO IA=1,NA
          ID     = NUMDOM(IA)

C          ANG(1) = THETA(1,ID) * DEGTOR
C          ANG(2) = THETA(2,ID) * DEGTOR
C          ANG(3) = THETA(3,ID) * DEGTOR
C          CALL EULERM(ANG(1),ANG(2),ANG(3),RM)

          CALL MTRANS(R(1,1,ID),RM)
          V1(1) = X0(IA,1) - CENTRE(1,ID)
          V1(2) = X0(IA,2) - CENTRE(2,ID)
          V1(3) = X0(IA,3) - CENTRE(3,ID)
          CALL MVMULT(RM,V1,V2)
          X(IA,1) = V2(1) + TX(1,ID) + CENTRE(1,ID) 
          X(IA,2) = V2(2) + TX(2,ID) + CENTRE(2,ID) 
          X(IA,3) = V2(3) + TX(3,ID) + CENTRE(3,ID) 
        ENDDO

C        WRITE(*,*) '--x   :',X(1,1),X(1,2),X(1,3)
C
C          WRITE(LINE,'(''centre1:'',3F10.3)') 
C     *    CENTRE(1,1), CENTRE(2,1),CENTRE(3,1)    
C          CALL MSGDOC(MDOC,LINE)
C
C          WRITE(LINE,'(''centre2:'',3F10.3)') 
C     *    CENTRE(1,2), CENTRE(2,2),CENTRE(3,2)    
C          CALL MSGDOC(MDOC,LINE)


        NAMES  = 'rotfft_scr'
        CALL ADD_PATH(PATH_SCR,NAMES)
        CALL WR_CRD_RTFFT_NEW(M,NAMEC,NAMES,X,DOM,NUMDOM,BFAC0
     *   ,NATOM,NCRDMAX,MEM,P1,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) RETURN
        NCYCL = 0
        IVAR  = 0
        ITEST = ISTEP

        CALL CALCGRD_RTFFT(MDOC,LIST,NAMES,NAMEFF,NAME_PH,NAMEG
     *   ,PATH_SCR,BOFF,BADD,F000I
     *   ,RESMIN,RESMAX,SCALEG,ANISO,NCR,NCYCL,P1,IVAR,ITEST
     *   ,RF_NEW,CC_NEW,RF_OLD,CC_OLD
     *   ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) RETURN
   
        IF(CC_NEW.LT.CC_OLD) THEN
          SCALE = (FLOAT(ISTEP-1) + 0.5)*SCALES
          GO TO 800  
        ELSE
          CC_OLD = CC_NEW
        ENDIF
        
      ENDDO

 800  CONTINUE

        DO IM=1,NV
          P(IM) = P_OLD(IM) + DV(IM)*SCALE
        ENDDO

        DO     ID=1,NDOM
          J=(ID-1)*6
          ANG(1)      = 0.5*(P(J+1)+P(J+3))
          ANG(2)      =      P(J+2)        
          ANG(3)      = 0.5*(P(J+1)-P(J+3))
          THETA(1,ID) = ANG(1) * RTODEG
          THETA(2,ID) = ANG(2) * RTODEG
          THETA(3,ID) = ANG(3) * RTODEG
          DO     I=1,3
            IJ=I+J
            TX(I,ID) = P(IJ+3)
          ENDDO

          CALL EUL_RTFFT(ANG(1),ANG(2),ANG(3),R(1,1,ID),Q(1,1,1,ID))
 
        ENDDO

C ---
        IF(DOM.EQ.'S') THEN

          DO IG=1,NG_TOTAL

C           DO ID=NDOM_M+1,NDOM
            DO ID=1,NDOM
              IM  = ID_MOL(ID)
              IMD = ID_DOM(ID)
              IGR = ID_GRP(ID)
            
              IF(IGR.EQ.IG) THEN

                DO JD=1,NDOM
                  JM  = ID_MOL(JD)
                  JMD = ID_DOM(JD)
                  JGR = ID_GRP(JD)
                  IF(IMD.EQ.JMD.AND.JM.EQ.1.AND.IG.EQ.JGR) THEN
                    IDR = JD
                    GO TO 200
                  ENDIF
                ENDDO      
                IERR = 1
                CALL MSGERR(MDOC,' ERR: in RB_REFINE_FFT.')
                RETURN
 200            CONTINUE

                ANG(1) = ANGLES_RESTR(1,IM,IG)*DEGTOR
                ANG(2) = ANGLES_RESTR(2,IM,IG)*DEGTOR
                ANG(3) = ANGLES_RESTR(3,IM,IG)*DEGTOR
                CALL POLTOM(ANG(1),ANG(2),ANG(3),RM)
                IF(IM.EQ.1) THEN
                  DO I=1,3
                  DO J=1,3
                    RM(I,J) = 0.0
                  ENDDO        
                  ENDDO        
                  RM(1,1) = 1.0
                  RM(2,2) = 1.0
                  RM(3,3) = 1.0
                ENDIF
                CALL MTRANS(RM,RM1)

C               ANG(1) = THETA(1,IDR)*DEGTOR
C               ANG(2) = THETA(2,IDR)*DEGTOR
C               ANG(3) = THETA(3,IDR)*DEGTOR
C               CALL EULERM(ANG(1),ANG(2),ANG(3),SMAT1)

                CALL MTRANS(R(1,1,IDR),SMAT1)
                CALL MATMLT(SMAT1,RM1,SMAT2)
                CALL MATMLT(RM,SMAT2,SMAT1)

C               CALL MTOANG(SMAT1,ANG(1),ANG(2),ANG(3))
C               THETA(1,ID) = ANG(1)
C               THETA(2,ID) = ANG(2)
C               THETA(3,ID) = ANG(3) 

                CALL MTRANS(SMAT1,R(1,1,ID))

                V1(1) = TX(1,IDR)
                V1(2) = TX(2,IDR)
                V1(3) = TX(3,IDR)
                CALL MVMULT(RM,V1,V2)
                TX(1,ID) = V2(1) 
                TX(2,ID) = V2(2) 
                TX(3,ID) = V2(3)
              ENDIF
            ENDDO
          ENDDO
        ENDIF
C ---
        DO IA=1,NA
          ID     = NUMDOM(IA)

C          ANG(1) = THETA(1,ID) * DEGTOR
C          ANG(2) = THETA(2,ID) * DEGTOR
C          ANG(3) = THETA(3,ID) * DEGTOR
C          CALL EULERM(ANG(1),ANG(2),ANG(3),RM)

          CALL MTRANS(R(1,1,ID),RM)
          V1(1) = X0(IA,1) - CENTRE(1,ID)
          V1(2) = X0(IA,2) - CENTRE(2,ID)
          V1(3) = X0(IA,3) - CENTRE(3,ID)
          CALL MVMULT(RM,V1,V2)
          X(IA,1) = V2(1) + TX(1,ID) + CENTRE(1,ID) 
          X(IA,2) = V2(2) + TX(2,ID) + CENTRE(2,ID) 
          X(IA,3) = V2(3) + TX(3,ID) + CENTRE(3,ID) 
          BFAC(IA) = BFAC0(IA)
        ENDDO


      DO IM=1,NV
        P_OLD(IM) = P(IM)
      ENDDO


 900  CONTINUE

      RESULT( 8,1) = TX(1,1)
      RESULT( 9,1) = TX(2,1)
      RESULT(10,1) = TX(3,1)
      IF(IPRROW.GE.13) THEN
        RESULT(11,1) = THETA(1,1)
        RESULT(12,1) = THETA(2,1)
        RESULT(13,1) = THETA(3,1)
        RESULT(14,1) = TX(1,2)
        RESULT(15,1) = TX(2,2)
        RESULT(16,1) = TX(3,2)
        RESULT(17,1) = THETA(1,2)
        RESULT(18,1) = THETA(2,2)
        RESULT(19,1) = THETA(3,2)
        RESULT(20,1) = NDOM
        NDOM_N = NDOM
        IF(NDOM_N.GT.4) NDOM_N = 4 
        DO I=1,NDOM_N
          TH = DEGTOR*THETA(1,I)
          PH = DEGTOR*THETA(2,I)
          CH = DEGTOR*THETA(3,I)
          CALL EULERM(TH,PH,CH,RM)
          CALL MTOPOL(RM,TH,PH,CH)
          TSHIFT = SQRT(ABS(TX(1,I)*TX(1,I)+TX(2,I)*TX(2,I)
     *                         +TX(3,I)*TX(3,I)))
          II = I*2 + 10
          RESULT(II-1,1) = CH
          RESULT(II,1)   = TSHIFT
        ENDDO
        RESULT(19,1) = 0.0
      ENDIF

      RETURN
      END

      SUBROUTINE COPY_CRD_NCS_NEW(MDOC,NAMEC,NAMEO
     * ,NATOM,NSYM,ISYM,IPRSYM,IERR)
C ----------------------------------------------------------
C ==========
      PARAMETER ( IPRDOM = 300    )
      PARAMETER ( IGRDOM = 300    )
      COMMON /DOMAIN_ROTFFT_NEW/ 
     *                       NG_TOTAL
     *                      ,NA_TOTAL,NM_TOTAL,NA_MOL,ANGLES_RESTR
     *                      ,ND_TOTAL,NA_DOM
     *                      ,ID_GRP,ID_MOL,ID_DOM,CENTRE,RADI
     *                      ,NP_TOTAL,NMD_TOTAL,ANGLES_OBS,CENTRE_COM
     *                      ,CENTRE_MOL,SHIFT_MOL
      INTEGER   NG_TOTAL,NP_TOTAL,NA_TOTAL
     *         ,NM_TOTAL(IGRDOM),NA_MOL(IPRDOM,IGRDOM)
     *         ,NMD_TOTAL(IGRDOM)
      INTEGER   ND_TOTAL
      REAL      ANGLES_RESTR(3,IPRDOM,IGRDOM)
     *         ,ANGLES_OBS(3,IPRDOM,IGRDOM)
      INTEGER   NA_DOM(IPRDOM)
     *         ,ID_GRP(IPRDOM),ID_MOL(IPRDOM),ID_DOM(IPRDOM)    
      REAL      CENTRE(3,IPRDOM),RADI(IPRDOM),CENTRE_COM(3,IGRDOM)
      REAL      CENTRE_MOL(3,IPRDOM,IGRDOM),SHIFT_MOL(3,IPRDOM,IGRDOM)
C ==========
      INTEGER   NCS_ID(IGRDOM)
C ===
      INTEGER     MDOC,IPRSYM,IERR
      INTEGER*2   ISYM(5,3,IPRSYM)
      CHARACTER   NAMEC*(*),NAMEO*(*)
C ----------------------------------------------------------------
C ------
C BLANC -common
C
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
C !!!!
      CHARACTER SP_GROUP*24,USER_TITLE*80
C !!!!
C --------------
      INCLUDE 'mr_crd_com.fh'
C ----------------------------------------------------------------
      REAL      ANGLES(3),TRMAT(3,3),TR(3),V(3),C(3)
      REAL      V1(3),V2(3)
      CHARACTER LINE*80
      CHARACTER NCSF*1,GID*4
C==================================================================
      IERR = 0
      PI   = 4.0*ATAN(1.0)
      MD   = -ABS(MDOC)-1
      M    = 99
C --------
      IN  = 10
      CALL ORCRD(M,IN,NAMEC,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,
     *  ' ERROR: in COPY_CRD_NCS_NEW: OPEN INPUT_FILE/CRD/')
        RETURN
      ENDIF

      CALL C_AT_CR

C --------
      IMOL     = 0
      IGROUP   = 0
      DO I=1,IPRDOM
        NM_TOTAL(I) = 0
        CENTRE_COM(1,I)   = 0.0
        CENTRE_COM(2,I)   = 0.0
        CENTRE_COM(3,I)   = 0.0
        DO IG=1,IGRDOM
          ANGLES_RESTR(1,I,IG) = 0.0
          ANGLES_RESTR(2,I,IG) = 0.0
          ANGLES_RESTR(3,I,IG) = 0.0
          ANGLES_OBS(1,I,IG)   = 0.0
          ANGLES_OBS(2,I,IG)   = 0.0
          ANGLES_OBS(3,I,IG)   = 0.0
        ENDDO   
      ENDDO   
C -------------------------------------------------
      NATOM  = 0
      IEND   =-1
C -------------------------------------------------
 200  CONTINUE
      CALL RDCRD(M,IN,MODE,IEND,IERR)
      IF(IERR.NE.0) THEN
        RETURN
      ENDIF
      IF(IEND.NE.0) GO TO 300
      IF(MODE.NE.0) THEN


        IF(CR_LINE(1:7).EQ.'#DOMAIN'.OR.CR_LINE(1:9).EQ.'#MOLECULE')THEN

          CALL RD_LINE_ROTFFT(CR_LINE,NW,NUMB_INP,ANGLES,C)

          IF(CR_LINE(1:9).EQ.'#MOLECULE') THEN
            IF(NUMB_INP.GE.100) THEN
              IGROUP = IGROUP + 1
              IMOL   = 1  
              NM_TOTAL(IGROUP) = 1
              NCS_ID(IGROUP) = NUMB_INP
            ELSE 
              IMOL = IMOL + 1
              NM_TOTAL(IGROUP) = IMOL
            ENDIF
            IF(IGROUP.GT.IGRDOM) THEN
              WRITE(LINE,*) 
     *        ' ERROR: in NCS_NEW: number of groups >',IGRDOM
              CALL MSGERR(MDOC,LINE)
              CLOSE(IN)
              IERR=1
              RETURN
            ENDIF
            IF(IMOL.GT.IPRDOM) THEN
              WRITE(LINE,*) 
     *        ' ERROR: in NCS_NEW: number of domains >',IPRDOM
              CALL MSGERR(MDOC,LINE)
              CLOSE(IN)
              IERR=1
              RETURN
            ENDIF
            IF(NW.LT.NWORDS) NWORDS = NW
            ANGLES_OBS(1,IMOL,IGROUP) = ANGLES(1)
            ANGLES_OBS(2,IMOL,IGROUP) = ANGLES(2)
            ANGLES_OBS(3,IMOL,IGROUP) = ANGLES(3)
            IF(IMOL.EQ.1.AND.NW.GE.8) THEN
              CENTRE_COM(1,IGROUP) = C(1)
              CENTRE_COM(2,IGROUP) = C(2)
              CENTRE_COM(3,IGROUP) = C(3)
              ICNTR    = 1
            ENDIF

          ELSE IF(CR_LINE(1:7).EQ.'#DOMAIN') THEN

          ENDIF


        ENDIF
        GO TO 200
      ENDIF

      IF((CR_ATYPE.NE.'.'.AND.CR_ATYPE.NE.' '.AND.
     *    CR_ATYPE.NE.'y'.AND.CR_ATYPE.NE.'Y'.AND.
     *    CR_ATYPE.NE.'r'.AND.CR_ATYPE.NE.'R').OR.
     *    CR_OCC .LT.0.0001                       ) GO TO 100
C ----
      NATOM = NATOM+1

 100   CONTINUE
      GO TO 200
C ------------------------------------------------------
 300  CONTINUE
      CLOSE(IN)

      IF(NATOM.LE.0.OR.IGROUP.LE.0) THEN
        IERR = 1
        RETURN
      ENDIF

      DO IG=1,IGROUP
        CALL GENERATE_NCS(MDOC,NCS_ID(IG)
     *  ,ANGLES_OBS(1,1,IG),ANGLES_RESTR(1,1,IG),CENTRE_COM(1,IG)
     *  ,NM_TOTAL(IG),IERR)
        IF(IERR.NE.0) RETURN
      ENDDO  
C ---
      CALL MSGDOC(MDOC
     *       ,'--------------------------------------------------')
      WRITE(LINE,'('' Number of atoms   :'',I8)') NATOM
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Number of groups:'',I4)') IGROUP
      CALL MSGDOC(MDOC,LINE) 
      DO IG=1,IGROUP
        WRITE(LINE,'(''Group:'',I4,'' Number of molecules:'',I4)') 
     *  IG,NM_TOTAL(IG)
        CALL MSGDOC(MDOC,LINE) 
      ENDDO
      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.LE.0.OR.NAMEO(1:1).EQ.','.OR.
     *               NAMEO(1:1).EQ.' '     ) RETURN
C ---
      IGR    = 0
      CALL SET_ASYMM(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *                    ,NCSF,GID,IERR)
      IM_SUM = 0
      DO IG=1,IGROUP
        DO IM=1,NM_TOTAL(IG)
          IM_SUM = IM_SUM + 1
          IF(IM_SUM.LE.NMAX) THEN
            IGR      = IM_SUM 
            ICH      = IGR
            IGOLD    = IGR
            ICHOLD   = IGR
            INC      = 0
            MLT      = 0
            IATM     = 0
            NCSF     = 'Y'
            GID      = '    '
            GID(1:2) = 'AA'
            CALL SET_ASYMM(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                 ,IGOLD,NCSF,GID,IERR)
            IF(IERR.NE.0) RETURN
          ENDIF
        ENDDO
      ENDDO
      CALL CHECK_CHAIN_ID(INEW)
C --------------------------------------
      IOUT = 32
      CALL OWCRD(M,IOUT,NAMEO,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,
     *  ' ERROR: (NCS_NEW) OPEN OUTPUT FILE-CRD-TMP')
        CLOSE(IN)
        RETURN
      ENDIF
C --------
      NWORDS = 8
      IENDW  =-1
C -------------------------------------------------
      NATOM  = 0

      DO IG=1,IGROUP
      DO IM=1,NM_TOTAL(IG)

      IN  = 10
      CALL ORCRD(M,IN,NAMEC,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,
     *          ' ERROR: (NCS_NEW): open input file(crd)')
        RETURN
      ENDIF
      IEND   =-1
      IMOL   = 0
      IGR    = 0

 1200 CONTINUE

      CALL RDCRD(M,IN,MODE,IEND,IERR)
      IF(IERR.NE.0) THEN
        CLOSE(IOUT)
        RETURN
      ENDIF
      IF(IEND.NE.0) GO TO 1300

      IF(MODE.NE.0) THEN
        IF(CR_LINE(1:7).EQ.'#DOMAIN'.OR.
     *     CR_LINE(1:9).EQ.'#MOLECULE') THEN

          IF(CR_LINE(1:9).EQ.'#MOLECULE') THEN

            CALL RD_LINE_ROTFFT(CR_LINE,NW,NUMB_INP,ANGLES,C)

            IF(NUMB_INP.GE.100) THEN
              IGR  = IGR + 1
              IMOL = 1
            ELSE
              IMOL = IMOL + 1
            ENDIF

            IF(IGR.EQ.IG) THEN
              IF(IM.EQ.1) THEN
                CR_LINE2 = ' '
                WRITE(CR_LINE,'(A,I6,2X,3(F9.4,1X),3F8.3)') 
     *                 '#MOLECULE',NCS_ID(IG)
     *          ,ANGLES_OBS(1,1,IG),ANGLES_OBS(2,1,IG)
     *          ,ANGLES_OBS(3,1,IG)
     *          ,CENTRE_COM(1,IG),CENTRE_COM(2,IG),CENTRE_COM(3,IG)
              ELSE
                WRITE(CR_LINE,'(A,I6,2X,3(F9.4,1X))') '#MOLECULE',IM
     *          ,ANGLES_RESTR(1,IM,IG),ANGLES_RESTR(2,IM,IG)
     *          ,ANGLES_RESTR(3,IM,IG)

                V1(1) = (ANGLES_RESTR(1,IM,IG)*PI)/180.0
                V1(2) = (ANGLES_RESTR(2,IM,IG)*PI)/180.0
                V1(3) = (ANGLES_RESTR(3,IM,IG)*PI)/180.0
                CALL POLTOM(V1(1),V1(2),V1(3),TRMAT)
                CALL FTOO(CENTRE_COM(1,IG),V,IERR)   
              ENDIF

              IF(IMOL.EQ.1) THEN
                CALL WRCRD(M,IOUT,MODE,IENDW,IERR)
              ENDIF

            ENDIF

          ELSE IF(CR_LINE(1:7).EQ.'#DOMAIN') THEN

            CALL WRCRD(M,IOUT,MODE,IENDW,IERR)

          ENDIF

        ELSE

          CALL WRCRD(M,IOUT,MODE,IENDW,IERR)

        ENDIF

        GO TO 1200

      ENDIF

      IF((CR_ATYPE.NE.'.'.AND.CR_ATYPE.NE.' '.AND.
     *    CR_ATYPE.NE.'y'.AND.CR_ATYPE.NE.'Y'.AND.
     *    CR_ATYPE.NE.'r'.AND.CR_ATYPE.NE.'R').OR.
     *    CR_OCC .LT.0.0001                       ) GO TO 1100
C ----
      IF(IG.EQ.IGR.AND.IMOL.EQ.1) THEN

        NATOM     = NATOM + 1
        CR_IGROUP = IM

        IF(IM.GT.1) THEN
          V1(1) = CR_XYZ(1) - V(1)
          V1(2) = CR_XYZ(2) - V(2)
          V1(3) = CR_XYZ(3) - V(3)
          CALL MVMULT(TRMAT,V1,V2)
          CR_XYZ(1) = V2(1) + V(1)
          CR_XYZ(2) = V2(2) + V(2)
          CR_XYZ(3) = V2(3) + V(3)
        ENDIF

        CALL WRCRD(M,IOUT,MODE,IENDW,IERR)

      ENDIF
 1100 CONTINUE
      GO TO 1200
C ------------------------------------------------------
 1300 CONTINUE
      CLOSE(IN) 

      ENDDO
      ENDDO

      IENDW = 1
      MODE  = 0
      CALL WRCRD(M,IOUT,MODE,IENDW,IERR)

      WRITE(LINE,'('' Number of atoms   :'',I8)') NATOM
      CALL MSGDOC(MDOC,LINE)
C --------------------------------------
      RETURN
      END

      SUBROUTINE RD_INI_CRD_RTFFT_NEW(MDOC,NAMEC,DOM
     * ,X0,X,GRADX,NUMDOM,BFAC0,BFAC,BSHFT
     * ,MEM,NCRDMAX
     * ,NSYM,ISYM,IPRSYM,IERR)
C ----------------------------------------------------------
      REAL    X0(MEM,3),GRADX(MEM,3),X(MEM,3)
     *       ,BFAC0(MEM),BFAC(MEM),BSHFT(MEM)
      INTEGER NUMDOM(MEM)
C ----------------------------------------------------------
C ===
      PARAMETER ( IPRDOM = 300    )
      PARAMETER ( IPRVAR =IPRDOM*6     )
      PARAMETER ( IPRVR2 =IPRVAR*IPRVAR)

      COMMON /VITALS_FFT/ NATOM,FUNCT,NDOM,NP,NV,DFDA,DFDT,INDX
     *               ,AM,BV,DV,P,KI,THETA,TX,R,Q,SCALES
C ---
      REAL      THETA(3,IPRDOM),TX(3,IPRDOM)
      REAL      AM(IPRVR2),BV(IPRVAR),DV(IPRVAR),P(IPRVAR)

      INTEGER   KI(IPRVAR),INDX(IPRVAR,3)
      REAL      R(3,3,IPRDOM),Q(3,3,3,IPRDOM)
      REAL      DFDA(3,IPRDOM),DFDT(3,IPRDOM)
C ---
C ==========
      PARAMETER ( IGRDOM = 300    )
      COMMON /DOMAIN_ROTFFT_NEW/ 
     *                       NG_TOTAL
     *                      ,NA_TOTAL,NM_TOTAL,NA_MOL,ANGLES_RESTR
     *                      ,ND_TOTAL,NA_DOM
     *                      ,ID_GRP,ID_MOL,ID_DOM,CENTRE,RADI
     *                      ,NP_TOTAL,NMD_TOTAL,ANGLES_OBS,CENTRE_COM
     *                      ,CENTRE_MOL,SHIFT_MOL
      INTEGER   NG_TOTAL,NP_TOTAL,NA_TOTAL
     *         ,NM_TOTAL(IGRDOM),NA_MOL(IPRDOM,IGRDOM)
     *         ,NMD_TOTAL(IGRDOM)
      INTEGER   ND_TOTAL
      REAL      ANGLES_RESTR(3,IPRDOM,IGRDOM)
     *         ,ANGLES_OBS(3,IPRDOM,IGRDOM)
      INTEGER   NA_DOM(IPRDOM)
     *         ,ID_GRP(IPRDOM),ID_MOL(IPRDOM),ID_DOM(IPRDOM)    
      REAL      CENTRE(3,IPRDOM),RADI(IPRDOM),CENTRE_COM(3,IGRDOM)
      REAL      CENTRE_MOL(3,IPRDOM,IGRDOM),SHIFT_MOL(3,IPRDOM,IGRDOM)
C ==========
C ===
      REAL      C_INP(3,IPRDOM)
C ----
      INTEGER     MDOC,IPRSYM,IERR
      INTEGER*2   ISYM(5,3,IPRSYM)
      CHARACTER   NAMEC*(*),DOM*1
C ----------------------------------------------------------------
C ------
C BLANC -common
C
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
C !!!!
      CHARACTER SP_GROUP*24,USER_TITLE*80
C !!!!
C --------------
C ---
      INCLUDE 'mr_crd_com.fh'
C ----------------------------------------------------------------
      REAL      ANGLES(3),TRMAT(3,3),TR(3),V(3),C(3)
      REAL      V1(3),V2(3)
      CHARACTER LINE*80
C==================================================================
      IERR = 0
      PI   = 4.0*ATAN(1.0)
      MD   = -ABS(MDOC)-1
      M    = 99
C --------
      IN  = 10
      CALL ORCRD(M,IN,NAMEC,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: in rotfft: OPEN INPUT_FILE/CRD/')
        RETURN
      ENDIF
C --------
      NWORDS   = 8
      ICNTR    = 0
      ISET     = 1
      IDOM     = 1
      IDOM_OLD = 1
      NDOM     = 0
      IMOL     = 1
      IGROUP   = 1
      IM_DOM   = 1
      IR0      = 0
      IRES     = 0
      NA_TOTAL = 0
      ND_TOTAL = 1
      NP_TOTAL = 0
      DO I=1,IPRDOM
        NM_TOTAL(I) = 0
        NMD_TOTAL(I)= 0
        NA_DOM(I) = 0 
        CENTRE(1,I)       = 0.0
        CENTRE(2,I)       = 0.0
        CENTRE(3,I)       = 0.0
        RADI(I)           = 0.0
        CENTRE_COM(1,I)   = 0.0
        CENTRE_COM(2,I)   = 0.0
        CENTRE_COM(3,I)   = 0.0
        C_INP(1,I)        = 0.0
        C_INP(2,I)        = 0.0
        C_INP(3,I)        = 0.0
        ID_MOL(I) = 0
        ID_DOM(I) = 0 
        ID_GRP(I) = 0 
        DO IG=1,IGRDOM
          NA_MOL(I,IG) = 0
          CENTRE_MOL(1,I,IG)   = 0.0
          CENTRE_MOL(2,I,IG)   = 0.0
          CENTRE_MOL(3,I,IG)   = 0.0
          SHIFT_MOL(1,I,IG)    = 0.0
          SHIFT_MOL(2,I,IG)    = 0.0
          SHIFT_MOL(3,I,IG)    = 0.0
          ANGLES_RESTR(1,I,IG) = 0.0
          ANGLES_RESTR(2,I,IG) = 0.0
          ANGLES_RESTR(3,I,IG) = 0.0
          ANGLES_OBS(1,I,IG)   = 0.0
          ANGLES_OBS(2,I,IG)   = 0.0
          ANGLES_OBS(3,I,IG)   = 0.0
        ENDDO
      ENDDO   
      ID_MOL(1) = 1
      ID_DOM(1) = 1 
      ID_GRP(1) = 1 
      NM_TOTAL(1) = 1
      NMD_TOTAL(1) = 1
C -------------------------------------------------
      NATOM  = 0
      IEND   =-1
C -------------------------------------------------
 200  CONTINUE
      CALL RDCRD(M,IN,MODE,IEND,IERR)
      IF(IERR.NE.0) THEN
        RETURN
      ENDIF
      IF(IEND.NE.0) GO TO 300
      IF(MODE.NE.0) THEN


        IF((CR_LINE(1:7).EQ.'#DOMAIN'.OR.CR_LINE(1:9).EQ.'#MOLECULE')
     *    .AND.DOM.NE.'N') THEN

          IDOM_OLD = IDOM

          CALL RD_LINE_ROTFFT(CR_LINE,NW,NUMB_INP,ANGLES,C)

          IF(CR_LINE(1:9).EQ.'#MOLECULE') THEN
            IF(NATOM.GT.0.AND.NUMB_INP.GE.100) THEN
              IGROUP = IGROUP + 1
              IMOL   = 1  
              NM_TOTAL(IGROUP) = 1
            ELSE IF(NATOM.GT.0) THEN
              IMOL = IMOL + 1
              NM_TOTAL(IGROUP) = IMOL
            ENDIF
            IM_DOM = 1
            IF(IGROUP.GT.IGRDOM) THEN
              WRITE(LINE,*) 
     *        ' ERROR: in rotfft: number of groups >',IGRDOM
              CALL MSGERR(MDOC,LINE)
              CLOSE(IN)
              IERR=1
              RETURN
            ENDIF
            IF(IMOL.GT.IPRDOM) THEN
              WRITE(LINE,*) 
     *        ' ERROR: in rotfft: number of domains >',IPRDOM
              CALL MSGERR(MDOC,LINE)
              CLOSE(IN)
              IERR=1
              RETURN
            ENDIF
            IF(NATOM.GT.0) THEN
              IDOM = ND_TOTAL + 1              
              IF(IDOM.GT.IPRDOM) THEN
                WRITE(LINE,*) 
     *          ' ERROR: in rotfft: number of domains >',IPRDOM
                CALL MSGERR(MDOC,LINE)
                CLOSE(IN)
                IERR=1
                RETURN
              ENDIF
              ND_TOTAL     = IDOM
              ID_MOL(IDOM) = IMOL
              ID_DOM(IDOM) = IM_DOM
              ID_GRP(IDOM) = IGROUP
            ENDIF
            IF(NW.LT.NWORDS) NWORDS = NW
            ANGLES_RESTR(1,IMOL,IGROUP) = ANGLES(1)
            ANGLES_RESTR(2,IMOL,IGROUP) = ANGLES(2)
            ANGLES_RESTR(3,IMOL,IGROUP) = ANGLES(3)
            IF(IMOL.EQ.1.AND.NW.GE.8) THEN
              C_INP(1,IGROUP) = C(1)
              C_INP(2,IGROUP) = C(2)
              C_INP(3,IGROUP) = C(3)
              ICNTR    = 1
            ENDIF
            ANGLES_OBS(1,IMOL,IGROUP)  = 0.0
            ANGLES_OBS(2,IMOL,IGROUP)  = 0.0
            ANGLES_OBS(3,IMOL,IGROUP)  = 0.0
          ELSE IF(CR_LINE(1:7).EQ.'#DOMAIN') THEN
            IF(NUMB_INP.GT.IPRDOM) NUMB_INP = 0
            IF(NATOM.GT.0) THEN
              IF(NUMB_INP.LE.0) THEN
                IM_DOM = IM_DOM + 1
              ELSE
                IM_DOM = NUMB_INP             
              ENDIF
              IF(IM_DOM.GT.IPRDOM) THEN
                WRITE(LINE,*) 
     *          ' ERROR: in rotfft: number of domains >',IPRDOM
                CALL MSGERR(MDOC,LINE)
                CLOSE(IN)
                IERR=1
                RETURN
              ENDIF
              DO ID=1,ND_TOTAL
                IF(ID_MOL(ID).EQ.IMOL.AND.ID_DOM(ID).EQ.IM_DOM.AND.
     *             ID_GRP(ID).EQ.IGROUP) THEN 
                  IDOM = ID
                  GO TO 140           
                ENDIF
              ENDDO
              IDOM = ND_TOTAL + 1
              IF(IDOM.GT.IPRDOM) THEN
                WRITE(LINE,*) 
     *          ' ERROR: (in rotfft) number of domains >',IPRDOM
                CALL MSGERR(MDOC,LINE)
                CLOSE(IN)
                IERR=1
                RETURN
              ENDIF
              ND_TOTAL     = IDOM
              ID_MOL(IDOM) = IMOL
              ID_DOM(IDOM) = IM_DOM
              ID_GRP(IDOM) = IGROUP
 140          CONTINUE
            ENDIF
          ENDIF

          IF(NATOM.GT.0) THEN
            IM_OLD  = ID_MOL(IDOM_OLD)
            IMD_OLD = ID_DOM(IDOM_OLD)
            IG_OLD  = ID_GRP(IDOM_OLD)
            WRITE(LINE,
     *      '(I3,A,I3,A,I3,''('',I2,'') RES:'',I4,'' - '',I4)')
     *       ISET,') DOM',IDOM_OLD,' MOL:',IM_OLD,IMD_OLD,IR0,IRES
            CALL MSGDOC(MDOC,LINE)   
            ISET=ISET+1
          ENDIF
          IR0          = 0
        ENDIF
        GO TO 200
      ENDIF

      IF((CR_ATYPE.NE.'.'.AND.CR_ATYPE.NE.' '.AND.
     *    CR_ATYPE.NE.'y'.AND.CR_ATYPE.NE.'Y'.AND.
     *    CR_ATYPE.NE.'r'.AND.CR_ATYPE.NE.'R').OR.
     *    CR_OCC .LT.0.0001                       ) GO TO 1000
C ----
C         CHECK STORAGE REQUIREMENTS
C

        IRES  = CR_IRES
          
        NATOM = NATOM+1
        IF(IR0.EQ.0) IR0=CR_IRES

        X0(NATOM,1)   = CR_XYZ(1)
        X0(NATOM,2)   = CR_XYZ(2)
        X0(NATOM,3)   = CR_XYZ(3)
        BFAC0(NATOM)  = CR_BISO
        NUMDOM(NATOM) = IDOM
        IF(IMOL.GT.0.AND.IGROUP.GT.0) 
     *       NA_MOL(IMOL,IGROUP)  = NA_MOL(IMOL,IGROUP) + 1
        NA_DOM(IDOM)  = NA_DOM(IDOM) + 1

 1000   CONTINUE
C      ENDIF
      GO TO 200
C ------------------------------------------------------
 300  CONTINUE
      IDOM_OLD = IDOM
      NA_TOTAL = NATOM
      NG_TOTAL = IGROUP
      NP_TOTAL = ISET
      NDOM     = ND_TOTAL
      IF(DOM.NE.'N'.AND.NATOM.GT.0) THEN
        IM_OLD  = ID_MOL(IDOM_OLD)
        IMD_OLD = ID_DOM(IDOM_OLD)
        IG_OLD  = ID_GRP(IDOM_OLD)
        WRITE(LINE,
     *      '(I3,A,I3,A,I3,''('',I2,'') RES:'',I4,'' - '',I4)')
     *       ISET,') DOM',IDOM_OLD,' MOL:',IM_OLD,IMD_OLD,IR0,IRES
         CALL MSGDOC(MDOC,LINE)   
         CALL MSGDOC(MDOC,' ')   
      ENDIF

      CALL MSGDOC(MDOC
     *       ,'--------------------------------------------------')
      WRITE(LINE,'('' Number of atoms   :'',I8)') NA_TOTAL
      CALL MSGDOC(MDOC,LINE)

      IF(DOM.NE.'N') THEN
        WRITE(LINE,'('' Number of domains :'',I4)') ND_TOTAL
        CALL MSGDOC(MDOC,LINE)   
      ENDIF

      CLOSE(IN) 
C --------------------------------------
      CALL MSGDOC(MDOC,'--- Domains ---')
      DO  JD=1,NDOM
        XS  = 0.0
        YS  = 0.0
        ZS  = 0.0
        XS2 = 0.0
        YS2 = 0.0
        ZS2 = 0.0
        N  = 0
        DO  IA=1,NA_TOTAL
          ID = NUMDOM(IA)
          IF(JD.EQ.ID) THEN
            XS  = XS + X0(IA,1)
            YS  = YS + X0(IA,2)
            ZS  = ZS + X0(IA,3)
            N   = N  + 1
            XS2 = XS2 + X0(IA,1)*X0(IA,1)
            YS2 = YS2 + X0(IA,2)*X0(IA,2)
            ZS2 = ZS2 + X0(IA,3)*X0(IA,3)
          ENDIF
        ENDDO
        IF(N.GT.0) THEN
          XS           = XS/FLOAT(N)
          YS           = YS/FLOAT(N)
          ZS           = ZS/FLOAT(N)
          CENTRE(1,JD) = XS
          CENTRE(2,JD) = YS
          CENTRE(3,JD) = ZS
          XS2          = XS2/FLOAT(N)
          YS2          = YS2/FLOAT(N)
          ZS2          = ZS2/FLOAT(N)
          RX           = XS2-XS*XS
          RY           = YS2-YS*YS
          RZ           = ZS2-ZS*ZS
          RADI(JD)     = SQRT(ABS(RX+RY+RZ))
          IM  = ID_MOL(JD)
          IG  = ID_GRP(JD)
          IDM = ID_DOM(JD)
          WRITE(LINE,'(I4,'') Radius of inertia :'',F10.3,A,I8)') 
     *            JD,RADI(JD),' Na_dom:',NA_DOM(JD) 
          CALL MSGDOC(MDOC,LINE)
        ELSE
          CENTRE(1,JD) = 0.0
          CENTRE(2,JD) = 0.0
          CENTRE(3,JD) = 0.0
          RADI(JD)     = 100.0
        ENDIF
      ENDDO
C --------------------------------------
      IF(DOM.EQ.'Y'.OR.DOM.EQ.'N') RETURN

      WRITE(LINE,'('' Number of groups   :'',I8)') NG_TOTAL
      CALL MSGDOC(MDOC,LINE)

C --------------------------------------
      DO IG=1,NG_TOTAL
        WRITE(LINE,'(''--- Group   :'',I8)') IG
        CALL MSGDOC(MDOC,LINE)
        DO IM=1,NM_TOTAL(IG)
          NMD = 0
          DO ID=1,ND_TOTAL
            IF(ID_MOL(ID).EQ.IM.AND.ID_GRP(ID).EQ.IG) NMD = NMD + 1
          ENDDO
          IF(IM.EQ.1) THEN
            NMD_TOTAL(IG) = NMD
          ELSE
            IF(NMD.NE.NMD_TOTAL(IG)) THEN
              LINE = ' ERROR: (in rotfft) diff. molecules'//
     *        ' have diff. number of domains'
              CALL MSGERR(MDOC,LINE)
              IERR = 1
              RETURN
            ENDIF
          ENDIF
        ENDDO
C --
        IF(NM_TOTAL(IG).GT.1) THEN
          NMA = NA_MOL(1,IG)
          DO IM=2,NM_TOTAL(IG)
            IF(NMA.NE.NA_MOL(IM,IG)) THEN
              LINE = ' ERROR: (in rotfft) diff. molecules'//
     *        ' have diff. number of atoms'
              CALL MSGERR(MDOC,LINE)
              IERR = 1
              RETURN
            ENDIF
          ENDDO
        ENDIF
C ---
        IF(NMD_TOTAL(IG).GT.1) THEN
          DO IM=1,NM_TOTAL(IG)
            DO ID=1,NMD_TOTAL(IG)

              DO IR=1,ND_TOTAL
                IMOLR = ID_MOL(IR)
                IMDR  = ID_DOM(IR)
                IGRR  = ID_GRP(IR)
                IF(IMOLR.EQ.1.AND.IMDR.EQ.ID.AND.IGRR.EQ.IG) THEN                  
                  NAD = NA_DOM(IR)                  
                ENDIF
              ENDDO

              DO IS=1,ND_TOTAL
                IMOL = ID_MOL(IS)
                IMD  = ID_DOM(IS)
                IGR  = ID_GRP(IS)
                IF(IM.EQ.IMOL.AND.ID.EQ.IMD.AND.IG.EQ.IGR) THEN
                  IF(NAD.NE.NA_DOM(IS)) THEN
                    LINE = ' ERROR: (in rotfft) domains'//
     *              ' have diff. number of atoms'
                    CALL MSGERR(MDOC,LINE)
                    IERR = 1
                    RETURN
                  ENDIF
                ENDIF  
              ENDDO

            ENDDO
          ENDDO
        ENDIF
C ---
        XS_COM  = 0.0
        YS_COM  = 0.0
        ZS_COM  = 0.0
        XS2_COM = 0.0
        YS2_COM = 0.0
        ZS2_COM = 0.0
        N_COM   = 0
        CALL MSGDOC(MDOC,'--- Molecules ---')
        DO  JM=1,NM_TOTAL(IG)
          XS  = 0.0
          YS  = 0.0
          ZS  = 0.0
          XS2 = 0.0
          YS2 = 0.0
          ZS2 = 0.0
          N  = 0
          DO  IA=1,NA_TOTAL
            ID  = NUMDOM(IA)
            IM  = ID_MOL(ID)
            IGR = ID_GRP(ID)
            IF(IG.EQ.IGR) THEN
              XS_COM  = XS_COM + X0(IA,1)
              YS_COM  = YS_COM + X0(IA,2)
              ZS_COM  = ZS_COM + X0(IA,3)
              N_COM   = N_COM  + 1
              XS2_COM = XS2_COM + X0(IA,1)*X0(IA,1)
              YS2_COM = YS2_COM + X0(IA,2)*X0(IA,2)
              ZS2_COM = ZS2_COM + X0(IA,3)*X0(IA,3)
              IF(JM.EQ.IM) THEN
                XS  = XS + X0(IA,1)
                YS  = YS + X0(IA,2)
                ZS  = ZS + X0(IA,3)
                N   = N  + 1
                XS2 = XS2 + X0(IA,1)*X0(IA,1)
                YS2 = YS2 + X0(IA,2)*X0(IA,2)
                ZS2 = ZS2 + X0(IA,3)*X0(IA,3)
              ENDIF
            ENDIF
          ENDDO
          IF(N.GT.0) THEN
            XS   = XS/FLOAT(N)
            YS   = YS/FLOAT(N)
            ZS   = ZS/FLOAT(N)
            V(1) = XS
            V(2) = YS
            V(3) = ZS
            CALL OTOF(V,CENTRE_MOL(1,JM,IG),IERR)
            XS2          = XS2/FLOAT(N)
            YS2          = YS2/FLOAT(N)
            ZS2          = ZS2/FLOAT(N)
            RX           = XS2-XS*XS
            RY           = YS2-YS*YS
            RZ           = ZS2-ZS*ZS
            RADI_MOL     = SQRT(ABS(RX+RY+RZ))
            WRITE(LINE,'(I4,'') Radius of inertia :'',F10.3,A,I8)') 
     *            JM,RADI_MOL,' Na_mol:',NA_MOL(JM,IG) 
            CALL MSGDOC(MDOC,LINE)
          ENDIF
        ENDDO

        IF(N_COM.GT.0) THEN
          XS_COM  = XS_COM/FLOAT(N_COM)
          YS_COM  = YS_COM/FLOAT(N_COM)
          ZS_COM  = ZS_COM/FLOAT(N_COM)
          V(1)    = XS_COM
          V(2)    = YS_COM
          V(3)    = ZS_COM
          CALL OTOF(V,CENTRE_COM(1,IG),IERR)
          XS2_COM      = XS2_COM/FLOAT(N_COM)
          YS2_COM      = YS2_COM/FLOAT(N_COM)
          ZS2_COM      = ZS2_COM/FLOAT(N_COM)
          RX           = XS2_COM-XS_COM*XS_COM
          RY           = YS2_COM-YS_COM*YS_COM
          RZ           = ZS2_COM-ZS_COM*ZS_COM
          RADI_COM     = SQRT(ABS(RX+RY+RZ))
        ENDIF
C ----
        WRITE(LINE,'(''Nmol:'',I5,'' centre:'',3F8.3,'' Radi:'',F8.2)') 
     *   NM_TOTAL(IG),CENTRE_COM(1,IG),CENTRE_COM(2,IG)
     *               ,CENTRE_COM(3,IG),RADI_COM
        CALL MSGDOC(MDOC,LINE)

        IF(NM_TOTAL(IG).GT.1) THEN
          CALL MSGDOC(MDOC,'---------------------')

          IAA = 0
          DO IA=1,NA_TOTAL
            ID = NUMDOM(IA)
            JM = ID_MOL(ID)
            IGR = ID_GRP(ID)
            IF(JM.EQ.1.AND.IG.EQ.IGR) THEN
              IAA = IAA + 1
              X(IAA,1) = X0(IA,1)
              X(IAA,2) = X0(IA,2)
              X(IAA,3) = X0(IA,3)
            ENDIF
          ENDDO
 
          IF(ICNTR.EQ.1.AND.DOM.EQ.'C') THEN
            CENTRE_COM(1,IG) = C_INP(1,IG)
            CENTRE_COM(2,IG) = C_INP(2,IG)
            CENTRE_COM(3,IG) = C_INP(3,IG)
          ENDIF

          NN = NA_MOL(1,IG)
          IM = 1
C    
          V(1) = CENTRE_MOL(1,IM,IG) - CENTRE_COM(1,IG)
          V(2) = CENTRE_MOL(2,IM,IG) - CENTRE_COM(2,IG)
          V(3) = CENTRE_MOL(3,IM,IG) - CENTRE_COM(3,IG)

          CALL FTOO(V,V1,IERR)

          DIST = SQRT(V1(1)*V1(1)+V1(2)*V1(2)+V1(3)*V1(3))
          WRITE(LINE,'(I4,A,3F8.2,3X,3F8.2)') IM,' Angl_rest,obs:'
     *    ,ANGLES_RESTR(1,IM,IG),ANGLES_RESTR(2,IM,IG)
     *    ,ANGLES_RESTR(3,IM,IG)
     *    ,ANGLES_OBS(1,IM,IG),ANGLES_OBS(2,IM,IG),ANGLES_OBS(3,IM,IG)
          CALL MSGDOC(MDOC,LINE)
          WRITE(LINE,'(4X,A,3F8.3)') ' Centre:' 
     *    ,CENTRE_MOL(1,IM,IG),CENTRE_MOL(2,IM,IG),CENTRE_MOL(3,IM,IG)
          CALL MSGDOC(MDOC,LINE)
          WRITE(LINE,'(4X,A,4F8.3)') 
     *    ' VectorC,Dist:',V(1),V(2),V(3),DIST
          CALL MSGDOC(MDOC,LINE)
C
          DO IM=2,NM_TOTAL(IG)

            IAA = 0
            DO IA=1,NA_TOTAL
              ID = NUMDOM(IA)
              JM = ID_MOL(ID)
              IGR = ID_GRP(ID)
              IF(JM.EQ.1.AND.IG.EQ.IGR) THEN
                IAA = IAA + 1
                X(IAA,1) = X0(IA,1)
                X(IAA,2) = X0(IA,2)
                X(IAA,3) = X0(IA,3)
              ENDIF
            ENDDO

            IF(DOM.EQ.'C') THEN
              V1(1) = (ANGLES_RESTR(1,IM,IG)*PI)/180.0
              V1(2) = (ANGLES_RESTR(2,IM,IG)*PI)/180.0
              V1(3) = (ANGLES_RESTR(3,IM,IG)*PI)/180.0
              CALL POLTOM(V1(1),V1(2),V1(3),TRMAT)
              IAA = 0
              DO IA=1,NA_TOTAL
                ID  = NUMDOM(IA)
                JM  = ID_MOL(ID)
                IGR = ID_GRP(ID)
                IF(IM.EQ.JM.AND.IG.EQ.IGR) THEN
                  IAA = IAA + 1
                  CALL FTOO(CENTRE_COM(1,IG),V,IERR)   
                  V1(1) = X(IAA,1) - V(1)
                  V1(2) = X(IAA,2) - V(2)
                  V1(3) = X(IAA,3) - V(3)
                  CALL MVMULT(TRMAT,V1,V2)
                  X0(IA,1) = V2(1) + V(1)
                  X0(IA,2) = V2(2) + V(2)
                  X0(IA,3) = V2(3) + V(3)
                ENDIF
              ENDDO

              V(1) = CENTRE_MOL(1,1,IG) - CENTRE_COM(1,IG)
              V(2) = CENTRE_MOL(2,1,IG) - CENTRE_COM(2,IG)
              V(3) = CENTRE_MOL(3,1,IG) - CENTRE_COM(3,IG)
              CALL FTOO(V,V1,IERR)
              CALL MVMULT(TRMAT,V1,V2)
              CALL OTOF(V2,V1,IERR)
              CENTRE_MOL(1,IM,IG) = V1(1) + CENTRE_COM(1,IG)
              CENTRE_MOL(2,IM,IG) = V1(2) + CENTRE_COM(2,IG)
              CENTRE_MOL(3,IM,IG) = V1(3) + CENTRE_COM(3,IG)
            ENDIF

            IAA = 0
            DO IA=1,NA_TOTAL
              ID = NUMDOM(IA)
              JM = ID_MOL(ID)
              IGR = ID_GRP(ID)
              IF(IM.EQ.JM.AND.IG.EQ.IGR) THEN
                IAA = IAA + 1
                GRADX(IAA,1) = X0(IA,1)
                GRADX(IAA,2) = X0(IA,2)
                GRADX(IAA,3) = X0(IA,3)
              ENDIF
            ENDDO

            CALL LSKAB_FIT(M,X,GRADX,NN,TRMAT,TR,DRMS,DISMAX
     *                ,MEM,IERR)
C ---------------------------------------------------------
C     X      CONTAINS THE NX COORD. OF THE WORKING MOLECULE.
C     GRADX  CONTAINS THE NY COORD. OF THE REFERENCE MOLECULE.
C     NN     THE NUMBER OF CRESTS TO BE USED TO GENERATE THE ROTATION MATRIX
C --------------------------------------------------------
            IF(IERR.NE.0) THEN
              RETURN
            ENDIF        

            CALL MTOPOL(TRMAT,ANGLES_OBS(1,IM,IG),ANGLES_OBS(2,IM,IG)
     *      ,ANGLES_OBS(3,IM,IG))
C
            V(1) = CENTRE_MOL(1,IM,IG) - CENTRE_COM(1,IG)
            V(2) = CENTRE_MOL(2,IM,IG) - CENTRE_COM(2,IG)
            V(3) = CENTRE_MOL(3,IM,IG) - CENTRE_COM(3,IG)

            CALL FTOO(V,V1,IERR)

          DIST = SQRT(V1(1)*V1(1)+V1(2)*V1(2)+V1(3)*V1(3))
          WRITE(LINE,'(I4,A,3F8.2,3X,3F8.2)') IM,' Angl_rest,obs:'
     *    ,ANGLES_RESTR(1,IM,IG),ANGLES_RESTR(2,IM,IG)
     *    ,ANGLES_RESTR(3,IM,IG)
     *    ,ANGLES_OBS(1,IM,IG),ANGLES_OBS(2,IM,IG),ANGLES_OBS(3,IM,IG)
          CALL MSGDOC(MDOC,LINE)
          WRITE(LINE,'(4X,A,3F8.3,A,2F8.3)') ' Centre:' 
     *    ,CENTRE_MOL(1,IM,IG),CENTRE_MOL(2,IM,IG),CENTRE_MOL(3,IM,IG)
     *    ,' Rms,Dmax:',DRMS,DISMAX
          CALL MSGDOC(MDOC,LINE)
          WRITE(LINE,'(4X,A,4F8.3)') 
     *    ' VectorC,Dist:',V(1),V(2),V(3),DIST
          CALL MSGDOC(MDOC,LINE)
C
          ENDDO
          CALL MSGDOC(MDOC,'---------------------')
          IF(NWORDS.LE.4) THEN
            DO IM=1,NM_TOTAL(IG)
              ANGLES_RESTR(1,IM,IG) = ANGLES_OBS(1,IM,IG)
              ANGLES_RESTR(2,IM,IG) = ANGLES_OBS(2,IM,IG)
              ANGLES_RESTR(3,IM,IG) = ANGLES_OBS(3,IM,IG)
            ENDDO
          ENDIF
        ENDIF
      ENDDO
C --------------------------------------
      RETURN
      END

      SUBROUTINE WR_CRD_RTFFT_NEW(MDOC,NAMEC,NAMEO,X0,DOM,NUMDOM,BFAC0
     *           ,NATOM,NCRDMAX,MEM,P1,NSYM,ISYM,IPRSYM,IERR)
C ---
C ------------------------------------------
      REAL      X0(MEM,3),BFAC0(MEM)
      INTEGER   NUMDOM(MEM)
      CHARACTER P1*1,DOM*1
C ---
      PARAMETER ( IPRDOM = 300    )
      PARAMETER ( IPRVAR =IPRDOM*6     )
      PARAMETER ( IPRVR2 =IPRVAR*IPRVAR)
C ==========
      PARAMETER ( IGRDOM = 300    )
      COMMON /DOMAIN_ROTFFT_NEW/ 
     *                       NG_TOTAL
     *                      ,NA_TOTAL,NM_TOTAL,NA_MOL,ANGLES_RESTR
     *                      ,ND_TOTAL,NA_DOM
     *                      ,ID_GRP,ID_MOL,ID_DOM,CENTRE,RADI
     *                      ,NP_TOTAL,NMD_TOTAL,ANGLES_OBS,CENTRE_COM
     *                      ,CENTRE_MOL,SHIFT_MOL
      INTEGER   NG_TOTAL,NP_TOTAL,NA_TOTAL
     *         ,NM_TOTAL(IGRDOM),NA_MOL(IPRDOM,IGRDOM)
     *         ,NMD_TOTAL(IGRDOM)
      INTEGER   ND_TOTAL
      REAL      ANGLES_RESTR(3,IPRDOM,IGRDOM)
     *         ,ANGLES_OBS(3,IPRDOM,IGRDOM)
      INTEGER   NA_DOM(IPRDOM)
     *         ,ID_GRP(IPRDOM),ID_MOL(IPRDOM),ID_DOM(IPRDOM)    
      REAL      CENTRE(3,IPRDOM),RADI(IPRDOM),CENTRE_COM(3,IGRDOM)
      REAL      CENTRE_MOL(3,IPRDOM,IGRDOM),SHIFT_MOL(3,IPRDOM,IGRDOM)
C ==========
C ===
C ----------------------------------------------------------
      INCLUDE 'mr_crd_com.fh'
C -------------------------------------------------
      REAL      ANGLES(3),C(3)
      CHARACTER NAMEC*(*),NAMEO*(*),LINE*80,LINE2*80
      INTEGER*2 ISYM(5,3,IPRSYM)
C ----------------------
      IERR =0
      M    =99
      IATMR=10
      CALL ORCRD(M,IATMR,NAMEC,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN INPUT COORD_FILE')
        RETURN
      ENDIF

      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.LE.0.OR.NAMEO(1:1).EQ.','.OR.NAMEO(1:1).EQ.' ') THEN
        NAMEO='rotfft'
      ENDIF

      IF(P1.EQ.'Y') NSYM = 1

c      CALL CHECK_CHAIN_ID(INEW)

      IXYZB = 32
      CALL OWCRD(M,IXYZB,NAMEO,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        WRITE(LINE,*) ' ERR: OPEN OUTPUT FILE-CRD'
        CALL MSGERR(MDOC,LINE)
        CLOSE(IATMR)
        RETURN
      ENDIF
C -----------------------------------------
      IDOM   = 0
      I      = 0
      M      = 99
      IEND   =-1
      IENDW  =-1
      NAMAX  = NCRDMAX*2
      NCS_ID = 1
      IM_OLD =-1
      IG_OLG =-1
      IM_SUM = 0
      DO     IARD=1,NAMAX

        CALL RDCRD(M,IATMR,MODE,IEND,IERR)
        IF(IERR.NE.0) THEN
          CLOSE(IXYZB)
          RETURN
        ENDIF
        IF(IEND.NE.0) GO TO 300

        IF(MODE.NE.0) THEN
          IW = 1
          IF(DOM.NE.'N'.AND.DOM.NE.'Y') THEN
            IF(CR_LINE(1:9).EQ.'#MOLECULE'.OR.
     *         CR_LINE(1:7).EQ.'#DOMAIN') THEN
              CALL RD_LINE_ROTFFT(CR_LINE,NW,NUMB_INP,ANGLES,C)
              IF(NUMB_INP.GE.100) NCS_ID = NUMB_INP
              IW = 0
            ENDIF
          ENDIF
          IF(IW.EQ.1) CALL WRCRD(M,IXYZB,MODE,IENDW,IERR)

        ELSE

          IF((CR_ATYPE .EQ.' '.OR.CR_ATYPE .EQ.'.'.OR.
     *        CR_ATYPE .EQ.'y'.OR.CR_ATYPE .EQ.'Y'.OR.
     *        CR_ATYPE .EQ.'r'.OR.CR_ATYPE .EQ.'R').AND.
     *        CR_OCC .GT.0.0001                        ) THEN

            I=I+1
            IF(DOM.NE.'N'.AND.DOM.NE.'Y') THEN
              ID = NUMDOM(I)
              IF(ID.NE.IDOM) THEN
                IDOM = ID
                IM   = ID_MOL(ID)
                IMD  = ID_DOM(ID)
                IGR  = ID_GRP(ID)
                MODE = 1
                LINE = CR_LINE
                LINE2= CR_LINE2
                IF(IM.NE.IM_OLD.OR.IGR.NE.IG_OLD) IM_SUM = IM_SUM + 1

                IF(IGR.NE.IG_OLD) THEN

                  WRITE(CR_LINE,'(A,I6,2X,3(F9.4,1X),3F8.3)') 
     *              '#MOLECULE',NCS_ID
     *       ,ANGLES_RESTR(1,IM,IGR),ANGLES_RESTR(2,IM,IGR)
     *       ,ANGLES_RESTR(3,IM,IGR)
     *       ,CENTRE_COM(1,IGR),CENTRE_COM(2,IGR),CENTRE_COM(3,IGR)

                ELSE IF(IM.NE.IM_OLD) THEN

              WRITE(CR_LINE,'(A,I6,2X,3(F9.4,1X))') '#MOLECULE',IM
     *       ,ANGLES_RESTR(1,IM,IGR),ANGLES_RESTR(2,IM,IGR)
     *       ,ANGLES_RESTR(3,IM,IGR)

                ELSE

                  WRITE(CR_LINE,'(A,I5)') '#DOMAIN',IMD

                ENDIF

                CR_LINE2 = ' '
                CALL WRCRD(M,IXYZB,MODE,IENDW,IERR)

              ENDIF

              CR_IGROUP = IM_SUM
              IM_OLD = IM
              IG_OLD = IGR

            ENDIF
            MODE = 0
            CR_XYZ(1) = X0(I,1)
            CR_XYZ(2) = X0(I,2)
            CR_XYZ(3) = X0(I,3)
            CR_BISO   = BFAC0(I)

            CALL WRCRD(M,IXYZB,MODE,IENDW,IERR)

          ELSE

            MODE = 1
            CALL WRCRD(M,IXYZB,MODE,IENDW,IERR)

          ENDIF
        ENDIF
      ENDDO
  300 CONTINUE

      IENDW = 1
      MODE  = 0
      CALL WRCRD(M,IXYZB,MODE,IENDW,IERR)
      CLOSE(IATMR)

      RETURN
      END

      SUBROUTINE GENDEN_ANISO(MDOC,NAMEC,NAMED,TITLE
     * ,RX,NX,NY,NZ,IZMIN,IZMAX,MODE,RAD,H2OBG,BADD,P1,ZFADD,ANISO
     * ,RESULT,IPRROW,IPOOL_MEM,MEMORY,ISYM,IPRSYM,IPOOL_MAX,IERR)
C ------------------------------------------------------------
C -P- GENDEN  :  generates electron density for the atomic model. 
C                (aniso version of program GENDEN )
C -S-
C
C  Dialog and Batch: 
C
C    FILE_C -  input file of coordinates.
C    FILE_D -  output file of density
C    RESOL  -  <3.0> resolution
C    GRID   -  NX NY NZ /defaults are minimal grid spacing for SF calculation/
C    LIMZ:  -  MIN MAX numbers of Z-section /default are for SF calculation/
C    BADD:  -  <0.0> additional B-factor /default Badd_calc for SF calculation/
C              0 means Badd_calc will used
C    H2O:   -  <0.0> density of solvent
C    ANISO  -  <Y>/N   - N - Biso will used for all atoms')
C    TITLE    - title of output file
C
C  Parameters of subroutine GENDEN: 
C
C      SUBROUTINE GENDEN_ANISO(MDOC,NAMEC,NAMED,TITLE
C     * ,RX,NX,NY,NZ,IZMIN,IZMAX,H2OBG,BADD,ANISO
C     * ,RESULT,IPRROW,POOL,MEMORY,NCRDMAX,ISYM,IPRSYM,IERR)
C
C    MDOC   - mode of writting messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C    MODE   - see above. / character*1 /
C    NAMEC  - name of input file without extention "crd".
C    NAMED  - name of output file of density.
C    RX     -  <3.0> resolution
C    NX,NY,NZ - grid /defaults are minimal grid spacing for SF calculation/
C    BADD    -  <0.0> additional B-factor /default are for SF calculation/
C    H2OBG   -  <0.0> density of solvent
C    ANISO  -  <Y>/N   - N - Biso will used for all atoms')
C    TITLE  -  title of output file, /character*80/
C    IZMIN,IZMAX  -  MIN MAX numbers of Z-section. /if IZMIN=0,IZMAX=-1 
C                    default values for SF calculation will be taken /
C    NCRDMAX - maximal number of atoms.
C    POOL    - real array POOL(MEMORY)
C    MEMORY  - dimension array POOL. 
C              MEMORY = MAPMAX + (NCRDMAX/2)*5 , where MAPMAX - maximal
C                                                size of XY-section ( NX*NY)
C    ISYM   - integer*2 array for cryst.symmetry operators.
C    IPRSYM - dimension of integer*2 array ISYM(5,3,IPRSYM),
C             number of cryst. symm. operators.
C    IERR   - output signal of error / = 1 -error , = 0 - OK / 
C
C        output information 
C
C      real RESULT(IPRROW)
C
C      NEL   = RESULT(1)  number of electrons
C      SUMFI2= RESULT(2)  sum(Nelectrons**2)
C      BAVER = RESULT(3)  <B>   in the file
C      BMAX  = RESULT(4)   Bmax in the file
C      BMIN  = RESULT(5)   Bmin in the file
C      BAVERW= RESULT(6)   B_water in the file
C      BAVERF= RESULT(7)  <B> / including B from atomic scatt. factor /  
C      SUMDEN= RESULT(8)  sum(DENSITY) =  (sum(D)*volume)/(nx*ny*nz)
C      HH2OBG= RESULT(9)  density in the solvent region which was added.
C      SOLV  = RESULT(10) % of the solvent.
C      BADD  = RESULT(11) additional B-factor which was used.
C -I-
C ----------------------------------------------------------
      INTEGER          IPOOL_MEM(*)
      INTEGER*2        ISYM(5,3,IPRSYM)
C---------------------------------------------------------------
      CHARACTER NAMEC*(*),NAMED*(*),TITLE*(*),ANISO*1,P1*1,MODE*1
      CHARACTER LINE*80
C==================================================================
      REAL RESULT(IPRROW)
C ----------------------------------------
      CALL SGENDEN_ANISO(MDOC,NAMEC,NAMED,TITLE
     * ,RX,NX,NY,NZ,IZMIN,IZMAX,MODE,RAD,H2OBG,BADD,P1,ZFADD,ANISO
     * ,RESULT,IPRROW,ISYM,IPRSYM
     * ,IPOOL_MEM,MEMORY,IERR)
c     * ,IPOOL_MEM,IPOOL_MAX,IERR)
C ---
      RETURN
      END

      SUBROUTINE SGENDEN_ANISO(MDOC,NAMEC,NAMED,TITLE
     * ,RX,NX,NY,NZ,IZMIN,IZMAX,MODE,RADR,H2OBG,BADDR,P1,ZFADD,ANISO
     * ,RESULT,IPRROW,ISYM,IPRSYM
     * ,IPOOL_MEM,MEMORY,IERR)
C     * ,IPOOL_MEM,IPOOL_MAX,IERR)
C ----------------------------------------------------------
      REAL RESULT(IPRROW)
C ----------------------------------------------------------

      COMMON/CELLL/ A,B,C,ALPHA,BETA,GAMMA,ISPHR,DLIM,HH2OBG,ICELL
C ---
C     28.11.04
      COMMON/COMINFF/ NDENSP,NDENSM,NZERO,SUMRP,SUMRM

      COMMON/DIMM/  DMAX,NNX,NNY,NNZ,IIZMIN,IIZMAX,IHMAX,IKMAX,ILMAX
      COMMON/COM_VOL/ VOL
      COMMON/GENDEN_LIM/ BTEMP_LIM 
C ---------------------------------------
       INTEGER  IPOOL_MEM(*)

C      INTEGER        IBFACT(NCOORM),IZMOCC(NCOORM)
C     *                ,IXC(NCOORM),IYC(NCOORM),IZC(NCOORM)
C     *                ,ISCODE(NCOORM),IANUMB(NCOORM),IRECRD(NCOORM)        
C      REAL            U_ANISO(6,NCOORM)

      integer    , allocatable :: IBFACT(:)
      integer    , allocatable :: IZMOCC(:)
      integer    , allocatable :: IXC(:)
      integer    , allocatable :: IYC(:)
      integer    , allocatable :: IZC(:)
      integer    , allocatable :: ISCODE(:)
      integer    , allocatable :: IANUMB(:)
      integer    , allocatable :: IRECRD(:)
      real,        allocatable :: U_ANISO(:,:)

C      REAL             X(*)
      real,        allocatable :: X(:,:)
C --
      INTEGER*2        ISYM(5,3,IPRSYM)
C --------------------------------------------------------------
      CHARACTER NAMEC*(*),NAMED*(*),TITLE*(*),MODE*1,P1*1,ANISO*1
      CHARACTER LINE*80,STR*80,PATH*1,EXT*3
C==================================================================
      MODEL = IERR
      X0 = 0.0
      Y0 = 0.0
      Z0 = 0.0
      IF(MODEL.LT.0) THEN
        X0 = RESULT(1)
        Y0 = RESULT(2)
        Z0 = RESULT(3)
        RESULT(1) = 0.0
        RESULT(2) = 0.0
        RESULT(3) = 0.0
      ENDIF
      IERR = 0
      MD   =-ABS(MDOC)-1
C ---
      IF(ANISO.EQ.'n') ANISO='N'
      IF(ANISO.NE.'N') ANISO='Y'
C ---
      MT  =10
      CALL ORCRD(MD,MT,NAMEC,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,
     *  ' ERROR: GENDEN_ANISO: can not open COORD_FILE')
        GO TO 500
      ENDIF
      CALL C_AT_CR
      CLOSE(MT)
C -------------------------------------------
      BTEMP_LIM = 0.0
      NMODEL = 0
      STR=TITLE
      CALL LENSTR_BL(STR,LEN)
      IF(LEN.LE.0) THEN
        LEN=1
        STR=' '
      ENDIF
      IF(STR(1:3).EQ.',,,') THEN
        STR=' ---'
        LEN=4
      ENDIF
      IF(LEN.GT.60) LEN=60
      TITLE = 'GEN-DEN '//STR(1:LEN)
      LEN=LEN+8
      IF(LEN.LT.68) THEN
        DO I=LEN+1,68
          TITLE(I:I)=' '
        ENDDO
      ENDIF
      IF(P1.EQ.'y') P1='Y'
      IF(P1.NE.'Y') P1='N'
C ---------------------------------------------
      IF(RX.LE.0.0) RX=3.0 
      DMAX=RX
C ----
      CALL LIMHKL(RX,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)
      WRITE(LINE,1020) IHMAX,IKMAX,ILMAX
 1020 FORMAT(' Hmax,Kmax,Lmax :',3I4)
      CALL MSGDOC(MD,LINE)
      CALL MSGDOC(MD,
     * 'Defaults are minimal grid spacing for calculation SF')
C ----
      WRITE(LINE,1030) NXMIN,NYMIN,NZMIN
 1030 FORMAT('DEFAULT_GRID: NX,NY,NZ <',I3,',',I3,',',I3,'>') 
      CALL MSGDOC(MD,LINE)
      NNX=NX
      NNY=NY
      NNZ=NZ
      IF(NX.LE.0) NNX=NXMIN
      IF(NY.LE.0) NNY=NYMIN
      IF(NZ.LE.0) NNZ=NZMIN
      NNX   =(NNX/2)*2
      NNY   =(NNY/2)*2
      NNZ   =(NNZ/2)*2
      
      IF(NNX.LT.2*IHMAX+1) 
     * CALL MSGDOC(MDOC,'!!! Warning : Nx < 2Hmax+1')
      IF(NNY.LT.2*IKMAX+1) 
     * CALL MSGDOC(MDOC,'!!! Warning : Ny < 2Kmax+1')
      IF(NNZ.LT.2*ILMAX+1) 
     * CALL MSGDOC(MDOC,'!!! Warning : Nz < 2Lmax+1')
      NXY=NNX*NNY


c      IF(NXY.GT.IPRMAP) THEN
c        CALL MSGERR(MDOC,
c     * ' ERR: not enough memory for one section of dens.')
c        WRITE(LINE,'('' NX='',I4,'' NY='',I4,'' MEMORY-SIZE='',I6)')
c     *                  NNX,NNY,IPRMAP
c        CALL MSGERR(MDOC,LINE)
c        WRITE(LINE,'('' must by: NX x NY < '',I6)') IPRMAP
c        CALL MSGERR(MDOC,LINE)
c        GO TO 500
c      ENDIF
C ---
      IIZMIN=0
      IIZMAX=0
      N_SYM=NSYM
      IF(P1.EQ.'Y') N_SYM=1
      CALL SET_LIMZ(N_SYM,ISYM,NNZ,IZMAXD)
      IF(IZMIN.EQ.0.AND.IZMAX.LT.0) THEN
        IIZMIN=0
        IIZMAX=IZMAXD
        IF(NSYM.EQ.2) THEN
          IF(ISYM(1,2,2).EQ.0.AND.
     *       ISYM(2,2,2).EQ.1.AND.
     *       ISYM(3,2,2).EQ.0     ) IIZMAX = NNZ - 1
        ENDIF
      ELSE
        IIZMAX=IZMAX
        IIZMIN=IZMIN
        IF(IIZMAX.LT.IIZMIN) THEN
          T=IIZMAX
          IIZMAX=IIZMIN
          IIZMIN=T
        ENDIF
      ENDIF
C ----
      NNXY = NNX * NNY 
      NNZZ = IIZMAX - IIZMIN + 1

      allocate(X(1:NNXY,1:NNZZ),STAT=ISTAT)
      IF(ISTAT.NE.0) THEN
        IERR = 1
        CALL MSGERR(MDOC,
     *    ' ERROR: in GENDEN_ANISO : problem with memory allocation')
        CALL MSGERR(MDOC,
     *    '                          try to change resolution')
        RETURN
      ENDIF
      IPRMAP = NNXY * NNZZ
C ------------------------------------------------
      BADD  = BADDR
      RAD   = RADR
      ISPHR = 0
      ICELL = 0

      IF(MODE.EQ.'u') MODE  = 'U'
      IF(MODE.EQ.'s') MODE  = 'S'
      IF(MODE.EQ.'c') MODE  = 'C'
      IF(MODE.EQ.'b') MODE  = 'B'

      IF(MODE.EQ.'U') ISPHR = 3
      IF(MODE.EQ.'S') ISPHR = 2
C     IF(MODE.EQ.'C') ISPHR = 1

C      IF(MODE.EQ.'C') THEN
C        MODE = 'S'        
C      ENDIF
C      IF(MODE.EQ.'B') THEN
C        BTEMP_LIM = RAD              
C      ENDIF

      IF(MODE.EQ.'S'.OR.MODE.EQ.'C'.OR.MODE.EQ.'U') THEN
        BTEMP_LIM = RAD              
      ENDIF

      IF(ISPHR.GE.2) THEN
        DLIM   = 0.0
        RAD    = 0.0
        BADD   = 0.0
        HH2OBG = 0.0
        IF(ISPHR.GT.2) THEN
          ICELL = 1
          ISPHR = 2
          BADD  = 0.0
        ENDIF
        IF(DLIM.EQ.0.0) THEN
          DLIM  = 2.8
          ISPHR = 3
C 28.11.04
c          ICELL = 1

        ELSE IF(DLIM.LT.0.0) THEN
          DLIM = ABS(DLIM)
          IF(DLIM.GT.32.0) DLIM=32.0
          ISPHR = 4
        ELSE
          ISPHR = 2
          IF(DLIM.GT.32.0) DLIM=32.0
        ENDIF
      ELSE IF(ISPHR.EQ.1) THEN
        DLIM   = 2.8
        BADD   = 0.0
        HH2OBG = 0.0
      ELSE
        DLIM   = 2.8
        HH2OBG = H2OBG
        BADD   = 0.0
        RAD    = 0.0
      ENDIF

C     IF(MDOC.GT.0) THEN
        MD =-ABS(MDOC)-1
        IF(ISPHR.EQ.0) WRITE(LINE,*) ' --- GENERATE ATOM  -DENS ---'
        IF(ISPHR.EQ.1) WRITE(LINE,*) ' --- GENERATE CHARGE-DENS ---'
        IF(ISPHR.GE.2) WRITE(LINE,*) ' --- GENERATE SPHERE-DENS ---'
        CALL MSGDOC(MD,LINE)
        WRITE(LINE,*) ' NX,NY,NZ   :',NNX,NNY,NNZ
        CALL MSGDOC(MD,LINE)
        WRITE(LINE,*) ' IZMIN,IZMAX:',IIZMIN,IIZMAX
        CALL MSGDOC(MD,LINE)
        IF(ISPHR.EQ.2) THEN
          WRITE(LINE,*) ' RADIUS OF SPHERE  :',DLIM
          CALL MSGDOC(MD,LINE)
        ELSE IF(ISPHR.EQ.3) THEN
          WRITE(LINE,*) ' RADIUS OF SPHERE = RAD-Van-der-Waals'
          CALL MSGDOC(MD,LINE)
        ELSE IF(ISPHR.EQ.4) THEN
          WRITE(LINE,*) ' IF SURFACE-AREA=0 THEN RAD :',DLIM
          CALL MSGDOC(MD,LINE)
          WRITE(LINE,*) '             ELSE       RAD =R-Van-der-Waals'
          CALL MSGDOC(MD,LINE)
        ELSE
C          WRITE(LINE,*) ' ADDITIONAL B-FACTOR :',BADD
C          CALL MSGDOC(MD,LINE)
        ENDIF
        IF(ISPHR.EQ.0) THEN
          WRITE(LINE,*) ' DENSITY OF SOLVENT :',HH2OBG
          CALL MSGDOC(MD,LINE)
        ENDIF
C      ENDIF
C --------------------------------------
      NCOORM = 10 
      NMODEL = 0
      IF(MODE.EQ.'U') NMODEL =-1
      allocate(U_ANISO(1:6,1:NCOORM),STAT=ISTAT)
      allocate(IBFACT(1:NCOORM),STAT=ISTAT)
      allocate(IZMOCC(1:NCOORM),STAT=ISTAT)
      allocate(IXC(1:NCOORM),STAT=ISTAT)
      allocate(IYC(1:NCOORM),STAT=ISTAT)
      allocate(IZC(1:NCOORM),STAT=ISTAT)
      allocate(ISCODE(1:NCOORM),STAT=ISTAT)
      allocate(IANUMB(1:NCOORM),STAT=ISTAT)
      allocate(IRECRD(1:NCOORM),STAT=ISTAT)
      IMEM_TEST = 1
      CALL ATSORT_A(MDOC,NAMEC,BAVER,BMAX,BMIN,BAVERW,BAVERF,BADD
     *  ,SIGMAB,NEL,SUMFI2,NANISO,X0,Y0,Z0,ZFADD
     *  ,NCOORD,NCOORM,IBFACT,IZMOCC,IXC,IYC,IZC
     *  ,ISCODE,IANUMB,IRECRD,U_ANISO
     *  ,MODEL,NMODEL,P1,ANISO,NSYM,ISYM,IPRSYM,IMEM_TEST,IERR)
    
      deallocate(U_ANISO,STAT=ISTAT)
      deallocate(IBFACT,STAT=ISTAT)
      deallocate(IZMOCC,STAT=ISTAT)
      deallocate(IXC,STAT=ISTAT)
      deallocate(IYC,STAT=ISTAT)
      deallocate(IZC,STAT=ISTAT)
      deallocate(ISCODE,STAT=ISTAT)
      deallocate(IANUMB,STAT=ISTAT)
      deallocate(IRECRD,STAT=ISTAT)

      IF(IERR.GT.0) THEN
        deallocate(X,STAT=ISTAT)
        RETURN
      ENDIF

      NCOORM = NCOORD

      IT = 0
      allocate(U_ANISO(1:6,1:NCOORM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(IBFACT(1:NCOORM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(IZMOCC(1:NCOORM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(IXC(1:NCOORM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(IYC(1:NCOORM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(IZC(1:NCOORM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(ISCODE(1:NCOORM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(IANUMB(1:NCOORM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      allocate(IRECRD(1:NCOORM),STAT=ISTAT)
      IT = IT + ABS(ISTAT)
      IF(IT.GT.0) THEN
        deallocate(X,STAT=ISTAT)
        IERR = 1
        CALL MSGERR(MDOC,
     *    ' ERROR: in GENDEN_ANISO: problem with memory allocation')
        CALL MSGERR(MDOC,
     *    '                         try to change resolution')
        RETURN
      ENDIF
      IMEM_TEST = 0
      NMODEL = 0
      IF(MODE.EQ.'U') NMODEL =-1
      CALL ATSORT_A(MDOC,NAMEC,BAVER,BMAX,BMIN,BAVERW,BAVERF,BADD
     *  ,SIGMAB,NEL,SUMFI2,NANISO,X0,Y0,Z0,ZFADD
     *  ,NCOORD,NCOORM,IBFACT,IZMOCC,IXC,IYC,IZC
     *  ,ISCODE,IANUMB,IRECRD,U_ANISO
     *  ,MODEL,NMODEL,P1,ANISO,NSYM,ISYM,IPRSYM,IMEM_TEST,IERR)
      IF(IERR.GT.0) GO TO 500
      WRITE(LINE,*) 'ADDITIONAL B-FACTOR :',BADD
      CALL MSGDOC(MDOC,LINE)
C ---------------------------------------
      NXY=NNX*NNY
      CALL ATMDEN_A(MDOC,NAMED,TITLE,BADD,SOLV,X,NXY,IPRMAP
     *  ,NCOORD,NCOORM
     *  ,IBFACT,IZMOCC,IXC,IYC,IZC,ISCODE,IANUMB,IRECRD,U_ANISO
     *  ,SUMDEN,P1,NSYM,ISYM,IPRSYM,IPOOL_MEM,MEMORY,IERR)
      IF(IERR.NE.0) GO TO 500
C ---------------------------------------
      IF(ISPHR.EQ.0) THEN
        WRITE(LINE,*) ' DENSITY OF SOLVENT :',HH2OBG
        CALL MSGDOC(MD,LINE)
      ENDIF

      NX    = NNX
      NX    = NNY
      NZ    = NNZ
      IZMAX = IIZMAX
      IZMIN = IIZMIN
C     H2OBG = HH2OBG
      RAD   = DLIM

      RESULT(1)  = NEL
      RESULT(2)  = SUMFI2
      RESULT(3)  = BAVER
      RESULT(4)  = BMAX
      RESULT(5)  = BMIN
      RESULT(6)  = BAVERW
      RESULT(7)  = BAVERF
      RESULT(8)  = SUMDEN
      RESULT(9)  = HH2OBG
      RESULT(10) = SOLV
      RESULT(11) = BADD
      RESULT(12) = NMODEL
      RESULT(13) = MODEL

      RESULT(14) = SIGMAB
      RESULT(15) = NANISO
      RESULT(16) = VOL
      RESULT(17) = NSYM

      RESULT(18) = NDENSP
      RESULT(19) = NZERO
      RESULT(20) = NDENSM

C      WRITE(LINE,*) ' Model,N of models,NANO:',MODEL,NMODEL,NANISO
C      CALL MSGDOC(MDOC,LINE)

      deallocate(X,STAT=ISTAT)

      deallocate(U_ANISO,STAT=ISTAT)
      deallocate(IBFACT,STAT=ISTAT)
      deallocate(IZMOCC,STAT=ISTAT)
      deallocate(IXC,STAT=ISTAT)
      deallocate(IYC,STAT=ISTAT)
      deallocate(IZC,STAT=ISTAT)
      deallocate(ISCODE,STAT=ISTAT)
      deallocate(IANUMB,STAT=ISTAT)
      deallocate(IRECRD,STAT=ISTAT)

      RETURN
C --------------------
 500  CONTINUE

      deallocate(X,STAT=ISTAT)

      deallocate(U_ANISO,STAT=ISTAT)
      deallocate(IBFACT,STAT=ISTAT)
      deallocate(IZMOCC,STAT=ISTAT)
      deallocate(IXC,STAT=ISTAT)
      deallocate(IYC,STAT=ISTAT)
      deallocate(IZC,STAT=ISTAT)
      deallocate(ISCODE,STAT=ISTAT)
      deallocate(IANUMB,STAT=ISTAT)
      deallocate(IRECRD,STAT=ISTAT)

      IERR=1
      RETURN
      END

      SUBROUTINE ATMDEN_A(MDOC,NAME,TITLE,BADD,SOLV,X,NXY,ISIZE
     *  ,NCOORD,NCOORM,IBFACT,IZMOCC,IXC,IYC,IZC
     *  ,ISCODE,IANUMB,IRECRD,U_ANISO
     *  ,SUMD,P1,NSYM,ISYM,IPRSYM,IPOOL_MEM,JPOOL_MAX,IERR)
C -----------------------------------------------------
      INTEGER           IPOOL_MEM(*)
      COMMON/COM_DPOOL/ IPOOL_MAX,IPOOL_CURR
C ---
      REAL             X(NXY,*)
      INTEGER          IBFACT(NCOORM),IZMOCC(NCOORM)
     *                 ,IXC(NCOORM),IYC(NCOORM),IZC(NCOORM)
     *                 ,ISCODE(NCOORM),IANUMB(NCOORM),IRECRD(NCOORM)        
      REAL             U_ANISO(6,NCOORM)
C ---
      INTEGER          NCOORD,NCOORM
      CHARACTER        NAME*(*),TITLE*(*),P1*1
      INTEGER*2        ISYM(5,3,IPRSYM)
      INTEGER*4        NSYM,IPRSYM
C --------------------------------------
      COMMON/COMINFF/ NDENSP,NDENSM,NZERO,SUMRP,SUMRM
      COMMON/CELLL/   A,B,C,ALPHA,BETA,GAMMA,ISPHR,DLIM,H2OBG,ICELL
      COMMON/DIMM/    DMAX,NX,NY,NZ,IZMIN,IZMAX,IHMAX,IKMAX,ILMAX
      COMMON/COM_VOL/ VOL   
C --------------------------------------
      CHARACTER LINE*80
      CHARACTER TYPE*4
      REAL      RLATT(6)
      CHARACTER CODEPDB*4,NAMEPDB*40,DATEPDB*9,SPGR*24,TITLEPDB*80 
C-----------------------------------------------
      IERR = 0
      M    = 99
      MD   = -ABS(MDOC)-1
C ---
      IPOOL_MAX   = JPOOL_MAX
      IPOOL_CURR = 0
C ---
      MT     = 11
      TYPE   = 'RI  '
      IPRINT = 1
      CALL C_CR_WR
      CALL SET_TITLE(MD,A,B,C,ALPHA,BETA,GAMMA
     *        ,F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TITLE,IERR)

C      CALL OWFILE(MD,MT,NAME,TYPE,NSYM,ISYM,IPRSYM,IERR)
C      IF(IERR.GT.0) RETURN

      N_SYM=NSYM

      IF(P1.EQ.'Y') THEN

        N_SYM=1

        CALL GET_CELL(RLATT,CODEPDB,NAMEPDB,DATEPDB,TITLEPDB
     *   ,NSPGR,NSETT,SPGR,NSM,IERR)

        SPGR  = 'P 1'
        NSPGR = 1
        NSETT = 1

        CALL SET_WRF(NSPGR,NSETT,SPGR,CODEPDB
     *                  ,NAMEPDB,DATEPDB,TITLEPDB)

      ENDIF

      CALL OWFILE_MEM(MD,MT,NAME,TYPE,NSYM,ISYM,IPRSYM,IPOOL_MEM,IERR)
      IF(IERR.GT.0) RETURN

C ----------------------------------------------
      IZCNT =-999
      IX0   = 0
      IY0   = 0
      IZ0   = 0
      ITR   = 0
C ----
      SUMRP  = 0.0
      SUMRM  = 0.0
      NDENSP = 0
      NDENSM = 0
      NZERO  = 0
      IZ000  = 0
      SOLV   = 0.0
C ---
      S = (ALPHA+BETA+GAMMA)*0.5
      VOL = 2.0*A*B*C*
     *    SQRT(SIN(S)*SIN(S-ALPHA)*SIN(S-BETA)*SIN(S-GAMMA))
C     COEF  = COEF/VOL
      COEF  = VOL/(NX*NY*NZ)
      H2OBG = (H2OBG*COEF)
C -----------------------------------------------------
      IP1   = ISIZE/NXY
      IR    = IZMIN
      IREND = IZMAX
C -----------------------------------------------------
      RESOL = DMAX
      N1    = NX
      N2    = NY
100   CONTINUE

      IF(IR+IP1.GT.IREND) IP1 = IREND-IR+1
      N3 = IP1

      CALL GENDENA(MDOC,X,N1,N2,N3,IR,IZ000,BADD
     *   ,NCOORD,NCOORM,IBFACT,IZMOCC,IXC,IYC,IZC
     *   ,ISCODE,IANUMB,IRECRD,U_ANISO
     *   ,VOL,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.GT.0) RETURN

      DO     K=1,N3
        ISEC=IR+K-1
        CALL WDENS_MEM(MT,MDOC,IZCNT,NX,NY,NZ,IZMIN,IZMAX,RMAX,RMIN,
     *             X(1,K),RESOL,IX0,IY0,IZ0,ITR,IPOOL_MEM)
        IF(MT.LE.0) THEN
          IERR = 1
          RETURN
        ENDIF

C        CALL WDENS(MT,MDOC,IZCNT,NX,NY,NZ,IZMIN,IZMAX,RMAX,RMIN,
C     *             X(1,K),RESOL,IX0,IY0,IZ0,ITR)
C
C        IF(MT.LE.0) RETURN

      ENDDO
      IR=IR+IP1
      IF(IR.LE.IREND) GO TO 100
C-----------------------------------------------------
      SUMR  = SUMRP+SUMRM
      NDENS = NZERO+NDENSP+NDENSM
      SUMD  = (SUMR*VOL)/(NX*NY*NZ)
      IF(ISPHR.GE.2) THEN
        WRITE(LINE,*) ' SUM-DENS       :',SUMR
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,*) ' N-POINT-DENS =1:',NDENSP
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,*) ' N-POINT-ZERO =0:',NZERO
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,*) ' N-POINT-DENS <0:',NDENSM
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,*) ' N-POINT-DENS   :',NDENS
        CALL MSGDOC(MDOC,LINE)
      ELSE IF(ISPHR.LE.1) THEN
        WRITE(LINE,200) NDENS,SUMR,SUMD
        CALL MSGDOC(MDOC,LINE)
        IF(NDENS.GT.0) SOLV=(FLOAT(NZERO)*100.)/FLOAT(NDENS)
        WRITE(LINE,201) NZERO,SOLV
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,202) NDENSP,SUMRP
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,203) NDENSM,SUMRM
        CALL MSGDOC(MDOC,LINE)
 200    FORMAT(
     *    ' N-POINT-DENS         :',I8,' ; SUM-R,SUM_DENS :',2F12.4)
 201    FORMAT(
     *    ' N-POINT-SOLV-DENS, % :',I8,F8.3)
 202    FORMAT(
     *    ' N-POINT-POSITIV-DENS :',I8,' ; SUM-POSITIV-DENS :',F12.4)
 203    FORMAT(
     *    ' N-POINT-NEGATIV-DENS :',I8,' ; SUM-NEGATIV-DENS :',F12.4)
      ENDIF
      RETURN
      END

      SUBROUTINE ATSORT_A(MDOC,NAME,BAVER,BPEAK,BMIN,BAVERW,BAVERF
     *  ,BADD,SIGMAB,NEL,SUMFI2,NANISO,X0,Y0,Z0,ZFADD
     *  ,NCOORD,NCOORM,IBFACT,IZMOCC,IXC,IYC,IZC
     *  ,ISCODE,IANUMB,IRECRD,U_ANISO
     *  ,MODEL,NMODEL,P1,ANISO,NSYM,ISYM,IPRSYM,IMEM_TEST,IERR)
C -------------------------
      INTEGER   MDOC,IERR
      CHARACTER NAME*(*),NCS_FLAG*1,P1*1,ANISO*1
      INTEGER   IPRSYM
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER        IBFACT(NCOORM),IZMOCC(NCOORM)
     *                ,IXC(NCOORM),IYC(NCOORM),IZC(NCOORM)
     *                ,ISCODE(NCOORM),IANUMB(NCOORM),IRECRD(NCOORM)        
      REAL            U_ANISO(6,NCOORM)
C ---
      INTEGER          NCOORD,NCOORM
C ---
      INCLUDE 'mr_crd_com.fh'
C ------------------------------------------------------------
      PARAMETER (NFMMAX=15)
      COMMON/FORMSS/   NFMFC,IZFMFC(15),FMFCA(5,15),
     *                FMFCB(5,15),FMRAD(15),CATOM
      CHARACTER       CATOM(15)*2
C ---
      COMMON/DIMM/    DMAX,NX,NY,NZ,IZMIN,IZMAX,IHMAX,IKMAX,ILMAX
      COMMON/CELLL/    A,B,C,ALPHA,BETA,GAMMA,ISPHR,DLIM,H2OBG,ICELL
      COMMON/COM_MAT/  ACELL,BCELL,CCELL,AANGL,BANGL,GANGL
     *                ,AST,BST,CST,COALST,COBEST,COGAST
     *                ,FRTOCR,CRTOFR
C ---------------------------------------
      COMMON/GENDEN_LIM/ BTEMP_LIM 
C -----------------------------------------------------------------
      INTEGER     NCSOP
      REAL        AMNCS(3,3),TRNCS(3)
C------------------------------------------------------------------
      REAL        XA(3),YA(3),XSU(3),XFU(3)
      REAL        TRNS(3,2),XS(3),XF(3),Y(3)
      INTEGER     IPOINT(3)
c     INTEGER     JXXX(200),JYYY(200),JZZZ(200)
C----------------------------------------------------------------
      INTEGER     MODE
      REAL        TTT(3)
      REAL        FRTOCR(3,3),CRTOFR(3,3)
      REAL        RLATT(6)
      REAL        ROT(9),TR(3),U(6),UR(6)
      CHARACTER   ATOM*4,CHAR4*4,CHAR2*2,RES3*3
      CHARACTER   STR*80,NCSF*1,GID*4,PACK*1
C==================================================================
      ICOUNT= 0
      NONH  = 0
      NEL   = 0
      SUMFI2= 0
      NFMFC = 0
C --- integer*2 version
C     IPACK =10000
C --- integer*4 version
      IPACK =100000
C ---
      IERR  = 0
      NIN   = 10
      M     = 99
      MD    = -ABS(MDOC)-1
C --------
      CR_MODEL_OLD =-1
      PACK = 'N' 
      IF(NMODEL.LT.0) PACK = 'Y'
      NMODEL = 0
      CALL ORCRD(MD,NIN,NAME,NSYM_R,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) RETURN
      A     = CR_CELL(1)
      B     = CR_CELL(2)
      C     = CR_CELL(3)
      ALPHA = CR_CELL(4)
      BETA  = CR_CELL(5)
      GAMMA = CR_CELL(6)
      CALL FRORTH(CR_CELL(1),CR_CELL(2),CR_CELL(3)
     *           ,CR_CELL(4),CR_CELL(5),CR_CELL(6)
     *                            ,FRTOCR,CRTOFR,IERR)
      ACELL    =  A
      BCELL    = B
      CCELL    = C
      AANGL    = ALPHA
      BANGL    = BETA
      GANGL    = GAMMA
      RLATT(1) = ACELL
      RLATT(2) = BCELL
      RLATT(3) = CCELL
      RLATT(4) = AANGL
      RLATT(5) = BANGL
      RLATT(6) = GANGL
      CALL DSTARF(RLATT,AST,BST,CST,COALST,COBEST,COGAST,VOL)
C -----------------------------------------
      NCRSYM   = 0
      NCS_FLAG = 'N'
      NCSOP    = 0
      CALL GET_NCS(MDOC,NCMAX,NCSOP,AMNCS,TRNCS,IERR)
      IF(IERR.NE.0) THEN
        WRITE(STR,
     *  '('' ERR: wrong NCS description'')') 
        CALL MSGERR(MDOC,STR)
        RETURN
      ENDIF
      IF(NCSOP.GT.0) THEN
        IGR=0
        CALL GET_ASYMM(MDOC,NASMAX,NGR,NCH,IGR,ICH,INC,MLT,I_ATM
     *                 ,NCSF,GID,IERR)
        IF(IERR.NE.0) THEN
          WRITE(STR,
     *    '('' ERR:  genden_aniso:  wrong NCS description'')') 
          CALL MSGERR(MDOC,STR)
          RETURN
        ENDIF
        IF(NGR.GT.0) THEN
          DO IGR=1,NGR
            CALL GET_ASYMM(MDOC,NASMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                    ,IGOLD,NCSF,GID,IERR)
            IF(IERR.NE.0) THEN
              WRITE(STR,
     *        '('' ERR:  genden_aniso: wrong NCS description'')') 
              CALL MSGERR(MDOC,STR)
              RETURN
            ENDIF
            IF(NCSF.EQ.'N'.OR.NCSF.EQ.'n') THEN
              NCS_FLAG='Y'
              GO TO 520
            ENDIF
          ENDDO
        ENDIF
      ENDIF
 520  CONTINUE
      IF(NCS_FLAG.EQ.'Y') THEN
        WRITE(STR,
     *  '(''NUMBER OPERATORS OF NON-CRYST.SYMMETRY:'',I5)') NCSOP
        CALL MSGDOC(MDOC,STR)
        IF(NCSOP.GT.0) THEN
          CALL MSGDOC(MD,' ')
          CALL MSGDOC(MD,'  X-NEW           X-0      TX')
          CALL MSGDOC(MD,'  Y-NEW  = [M] *  Y-0  +   TY')
          CALL MSGDOC(MD,'  Z-NEW           Z-0      TZ')
          CALL MSGDOC(MD,' ')
          CALL MSGDOC(MD,' ORTOGONAL COORDINATE SYSTEM')
          CALL MSGDOC(MD,'  COORDINATES IN ANGSTROMS')
          CALL MSGDOC(MD,' ')
          DO     I=1,NCSOP
            CALL GET_NCS(MD,NCMAX,I,AMNCS,TRNCS,IERR)
            IF(IERR.NE.0) THEN
              WRITE(STR,
     *        '('' ERR:   genden_aniso: wrong NCS description'')') 
              CALL MSGERR(MDOC,STR)
              RETURN
            ENDIF
            WRITE(STR,500) I
            CALL MSGDOC(MD,STR)
  500       FORMAT('  OPERATORS OF NON-CRYST.SYMMETRY :',I5)
            CALL ANGFIX(MD,AMNCS,ALPH,BET,GAMM)
            WRITE(STR,510) (TRNCS(L),L=1,3)
            CALL MSGDOC(MD,STR)
  510       FORMAT(' TRANSLATION VECTOR :',3F10.5,' /ANGSTROM/')
          ENDDO
        ELSE
          WRITE(STR,
     *    '('' ERR: NUMBER OF NCS-OPERATORS:'',I5)') NCSOP
          CALL MSGERR(MDOC,STR)
          IERR=1
          RETURN
        ENDIF
      ENDIF
C--------------------------------------------------
      DLM   = DLIM+0.5
      XS(1) = 0.0
      XS(2) = 0.0
      XS(3) = 0.0
      XF(1) = 1.0
      XF(2) = 1.0
      XF(3) = 1.0

      ZFFS  = FLOAT(IZMIN)/FLOAT(NZ)-DLM/C
      ZFFF  = FLOAT(IZMAX)/FLOAT(NZ)+DLM/C

      XSU(1) = DLM/A
      XSU(2) = DLM/B
      XSU(3) = DLM/C
      XFU(1) = 1.0-DLM/A
      XFU(2) = 1.0-DLM/B
      XFU(3) = 1.0-DLM/C
C
      BAVER  = 0.0
      BMIN   = 1.E30
      BPEAK  =-1.E30
      BAVERW = 0.0 
      BAVERF = 0.0
      MATOMW = 0
      SIGMAB = 0.0
      NBATOM = 0
      NANISO = 0
      NINALL = 0
      IATT   = 0
      IAT_IN = 0
      I      = 0
      NSUME  = 0
      NCRSYM = 0
      SCHRG  = 0.0
      CHRGP  = 0.0
      CHRGM  = 0.0
      D1     = 0.0
      D2     = 0.0
      D3     = 0.25/(DMAX*DMAX)
C ===========================================
      IEND=-1

C      write(*,*) '-atsort_A-ISPHR,BTEMP_LIM',ISPHR,BTEMP_LIM

1100  CONTINUE
        IF(NCS_FLAG.EQ.'Y'.AND.NCRSYM.GT.NCSOP) NCRSYM=0
        IF(NCRSYM.NE.0) THEN

        ELSE

          MODE = 0
          CALL RDCRD(M,NIN,MODE,IEND,IERR)
          IF(IERR.EQ.1) RETURN
          IF(IEND.NE.0) GO TO 2000
          IF(MODE.GT.0) GO TO 1000    

          IF(PACK.EQ.'Y') THEN
            IF(MODEL.GT.0.AND.MODEL.NE.CR_MODEL) GO TO 1000
          ELSE
            IF(CR_MODEL.NE.CR_MODEL_OLD) THEN
              NMODEL = NMODEL + 1
            ENDIF
            CR_MODEL_OLD = CR_MODEL 
            IF(MODEL.GT.0.AND.MODEL.NE.NMODEL) GO TO 1000
          ENDIF
          IF(CR_ATYPE.NE.'.'.AND.CR_ATYPE.NE.' '.AND.
     *       CR_ATYPE.NE.'y'.AND.CR_ATYPE.NE.'Y'.AND.
     *       CR_ATYPE.NE.'r'.AND.CR_ATYPE.NE.'R')
     *    GO TO 1000
          IAT_IN=IAT_IN+1
        ENDIF
C--------------------------------------------------------
        ATOM = CR_ANAME
        IRES = CR_IRES
        RES3 = CR_RNAME
        OCC  = CR_OCC
        BT   = CR_BISO

        ISERIAL=CR_IATOM
        IF(CR_MULT_FACTOR.GT.1) THEN
          OCC = OCC / FLOAT(CR_MULT_FACTOR)
        ENDIF

        U(1)=CR_BISO
        U(2)=-1.0
        U(3)=0.0
        U(4)=0.0
        U(5)=0.0
        U(6)=0.0

        IF(ANISO.EQ.'N') CR_BTYPE='I'

        IF(CR_BTYPE.EQ.'A') THEN

          NANISO=NANISO+1

          U(1)=CR_ANIS(1)
          U(2)=CR_ANIS(2)
          U(3)=CR_ANIS(3)
          U(4)=CR_ANIS(4)
          U(5)=CR_ANIS(5)
          U(6)=CR_ANIS(6)

          CALL MDET2(U,DET)
     
          IF(DET.LT.0.0000001) THEN

            WRITE(STR,*) ' WARNING: Determinant(U) =< 0 :',DET
            CALL MSGERR(MDOC,STR)
            WRITE(STR,*) 
     *'          for atom: ',ATOM,', res:',IRES,', CHAIN:',CR_IGROUP
            CALL MSGERR(MDOC,STR)
            WRITE(STR,'(''          U:'',6F9.5)')
     *      U(1),U(2),U(3),U(4),U(5),U(6)
            CALL MSGERR(MDOC,STR)
            WRITE(STR,*) 
     *'          atom will not be used'
            CALL MSGERR(MDOC,STR)

            GO TO 1100

          ENDIF

          CALL UO_TO_B(U,U)

        ENDIF 

c       SURF   = CR_BISO
        SURF   = CR_SURF
        CHARGE = CR_BISO

        IF(CR_MULT_FACTOR.GT.1) THEN
          OCC = OCC / FLOAT(CR_MULT_FACTOR)
        ENDIF

        RVDW = 1.5
        IF(ISPHR.EQ.1.OR.ISPHR.EQ.4) THEN
          SURF   = CR_OCC
          CHARGE = CR_OCC
          OCC    = 1.0
        ENDIF

        IF(ISPHR.EQ.1.AND.CHARGE.EQ.0.0) GO TO 1000
C--------------------------------------------------------
        XA(1) = CR_XYZ(1)
        XA(2) = CR_XYZ(2)
        XA(3) = CR_XYZ(3)

        IF(MODEL.LT.0) THEN
          CALL SET_FLAG_USE(MODEL,XA(1),XA(2),XA(3),X0,Y0,Z0,IUSE)
          IF(IUSE.LE.0) GO TO 1000
        ENDIF

c        WRITE(STR,400) ATOM,IRES,RES3,ICHAIN,
c     *           XA(1),XA(2),XA(3),OCC,BT
c 400    FORMAT(6X,A4,I4,1X,A3,I3,3F10.5,F6.3,F6.1)
c        CALL MSGERR(MDOC,STR)

        IF(NCS_FLAG.EQ.'Y') THEN
          IF(NCRSYM.EQ.0) THEN
            IGR_OLD = CR_IGROUP
            DO IGR=1,NGR
              CALL GET_ASYMM(MDOC,NASMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                     ,IGOLD,NCSF,GID,IERR)
              IF(IERR.NE.0) THEN
                WRITE(STR,
     *          '('' ERR: wrong NCS description for chain :'',I5)') 
     *          IGR_OLD
                CALL MSGERR(MDOC,STR)
                RETURN
              ENDIF
              IF(IGOLD.EQ.IGR_OLD.AND.INC.EQ.0) THEN
                ICHAIN=ICHOLD
                NCRSYM=1
                GO TO 410
              ENDIF
            ENDDO
            WRITE(STR,
     *      '('' ERR: wrong NCS description for chain :'',I5)') 
     *      IGR_OLD
            CALL MSGERR(MDOC,STR)
            IERR=1
            RETURN
  410       CONTINUE
          ELSE
            DO IGR=1,NGR
              CALL GET_ASYMM(MDOC,NASMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                      ,IGOLD,NCSF,GID,IERR)
              IF(IERR.NE.0) THEN
                WRITE(STR,
     *          '('' ERR: wrong NCS description'')') 
                CALL MSGERR(MDOC,STR)
                RETURN
              ENDIF
c            write(*,*) NCSF,NCRSYM,GID(1:2),CHAIN
              IF((NCSF.EQ.'N'.OR.NCSF.EQ.'n').AND.
     *           INC.EQ.NCRSYM.AND.ICHOLD.EQ.ICHAIN) GO TO 530
            ENDDO
            NCRSYM=NCRSYM+1
            GO TO 1000  
 530        CONTINUE
            CALL GET_NCS(MDOC,NCMAX,INC,AMNCS,TRNCS,IERR)
            IF(IERR.NE.0) THEN
              WRITE(STR,
     *        '('' ERR: wrong NCS description'')') 
              CALL MSGERR(MDOC,STR)
              RETURN
            ENDIF
            CALL MVMULT(AMNCS,CR_XYZ,XA)
            XA(1)=XA(1)+TRNCS(1)
            XA(2)=XA(2)+TRNCS(2)
            XA(3)=XA(3)+TRNCS(3)
            NCRSYM=NCRSYM+1
          ENDIF
        ENDIF

        CALL MVMULT(CRTOFR,XA,YA)

c        XA(1)=AMOD(YA(1)/1.,1.)
c        XA(2)=AMOD(YA(2)/1.,1.)
c        XA(3)=AMOD(YA(3)/1.,1.)

        XA(1) = YA(1)
        XA(2) = YA(2)
        XA(3) = YA(3)+ ZFADD

C --------------------------------------------------------
        IZZ   = 1
        CHAR2 = CR_ASYMB(1:2)
        CHAR4 = CR_ASYMB
 610    CONTINUE
        IF(NFMFC.GT.0) THEN
          DO IM=1,NFMFC
            IF(CHAR2.EQ.CATOM(IM)) THEN
              IZZ  = IM
              IZE  = IZFMFC(IZZ)
              RVDW = FMRAD(IM)  
              GO TO 600
            ENDIF
          ENDDO
        ENDIF
        CALL GET_SFA(CHAR4
     *      ,N,NELC,A1,A2,A3,A4,B1,B2,B3,B4,CC,FI,FII,RAD,IERR)
        IF(IERR.NE.0.OR.NFMFC.GE.NFMMAX) THEN
          IF(IERR.NE.0) THEN
            IF(ICOUNT.LT.4) THEN
      WRITE(STR,*)' WARNING: GENDENA: atom"s type"',CHAR4,'" not found'
              CALL MSGERR(MDOC,STR)
              WRITE(STR,
     *'('' WARNING: GENDENA: for atom'',I6,'' name:'',A4,I5,'' '',A3)')
     *        I+1,ATOM,IRES,RES3
              CALL MSGERR(MDOC,STR)
              ICOUNT=ICOUNT+1
            ELSE IF(ICOUNT.EQ.4) THEN
              CALL MSGERR(MDOC,'   ... more ...')
              ICOUNT=ICOUNT+1
            ENDIF
            IERR=0
          ELSE IF(NFMFC.GE.NFMMAX) THEN
            IF(ICOUNT.LT.4) THEN
              WRITE(STR,*) 
     *' ERR: GENDENA: too many atom"s type > ',NFMMAX
              CALL MSGERR(MDOC,STR)
              ICOUNT=ICOUNT+1
            ELSE IF(ICOUNT.EQ.4) THEN
              CALL MSGERR(MDOC,'   ... more ...')
              ICOUNT=ICOUNT+1
            ENDIF
          ENDIF
          IF(ICOUNT.LE.4) THEN
            WRITE(STR,*) ' WARNING: GENDENA: default type  is "N   "'
            CALL MSGERR(MDOC,STR)
          ENDIF
          CHAR2='N '
          CHAR4='N   '
          GO TO 610
        ENDIF
        NFMFC = NFMFC+1
        IZFMFC(NFMFC)  = NELC
        FMFCA(1,NFMFC) = A1
        FMFCB(1,NFMFC) = B1
        FMFCA(2,NFMFC) = A2
        FMFCB(2,NFMFC) = B2
        FMFCA(3,NFMFC) = A3
        FMFCB(3,NFMFC) = B3
        FMFCA(4,NFMFC) = A4
        FMFCB(4,NFMFC) = B4
        FMFCA(5,NFMFC) = CC
        FMFCB(5,NFMFC) = 0.0
        FMRAD(NFMFC)   = RAD
        CATOM(NFMFC)   = CHAR2
        IZZ  = NFMFC
        IZE  = NELC
        RVDW = RAD
 600    CONTINUE
C ----------------------------------------
        I=I+1
        IF(CR_ASYMB(1:2).NE.'H '.AND.CR_ASYMB(1:2).NE.'D ') THEN
          NONH = NONH +1
        ENDIF
        NEL    = NEL+IZE*OCC
        SUMFI2 = SUMFI2+IZE*IZE*OCC*OCC

        IF(ISPHR.EQ.3) THEN

C         IF(BT.GT.BADD.AND.BADD.GT.0.000001) GO TO 1000
          IF(SURF.GT.BTEMP_LIM.AND.
     *             BTEMP_LIM.GT.0.000001) GO TO 1000
          RVDW = RVDW + 1.0
          IZR = RVDW*1000.0
          IF(OCC.GT.99.9) OCC = 99.9
          IOCC   = OCC*10.0
          INEOCC = IZZ*1000+IOCC

        ELSE IF(ISPHR.EQ.4) THEN

          IF(SURF.GT.0.0) THEN
            IZR = RVDW*1000.0
          ELSE
            IZR = DLIM *1000.0
          ENDIF
          IF(OCC.GT.99.9) OCC=99.9
          IOCC   = OCC*10.0
          INEOCC = IZZ*1000+IOCC

        ELSE IF(ISPHR.EQ.2) THEN

C         IF(BT.GT.BADD.AND.BADD.GT.0.000001) GO TO 1000
          IF(BT.GT.BTEMP_LIM.AND.
     *             BTEMP_LIM.GT.0.000001) GO TO 1000

          IZR = DLIM *1000.0
          IF(OCC.GT.99.9) OCC = 99.9
          IOCC   = OCC*10.0
          INEOCC = IZZ*1000+IOCC

        ELSE IF(ISPHR.EQ.1) THEN
          BB = BT
          IF(BB.GT.99.0) BB = 99.0
          IBB = BB
          IF(ABS(CHARGE).GT.1.50) CHARGE=(ABS(CHARGE)/CHARGE)*1.50
          ICHRG = CHARGE*100.0+160.0
          IZR   = ICHRG*100.0+IBB
          SCHRG = SCHRG+CHARGE
          IF(CHARGE.GT.0.0) CHRGP=CHRGP+CHARGE
          IF(CHARGE.LT.0.0) CHRGM=CHRGM+CHARGE
          IF(OCC.GT.99.9) OCC=99.9
          IOCC   = OCC*10.0
          INEOCC = IZZ*1000+IOCC
        ELSE
C         IF(BT.GT.BTEMP_LIM.AND.BTEMP_LIM.GT.0.01) GO TO 1000
          IF(BTEMP_LIM.GT.0.01) THEN
            BT = BT + (SURF-BTEMP_LIM)
          ENDIF

          IF(BT.GT.99.0) BT =99.0

c          IF(BT.GT.99.0) GO TO 1000

          IF(BT.LT.2.0) BT = 2.0
          IZR = BT*10.0
          D2  = D2+IZE*IZE*OCC*OCC
          D4  = 0.0
          DO IGS=1,5
            D4 = D4+FMFCA(IGS,IZZ)*EXP(-(BT+FMFCB(IGS,IZZ))*D3)
          ENDDO
          D4 = OCC * D4
          D1 = D1+D4*D4
          IF(OCC.GT.99.9) OCC=99.9
          IOCC   = OCC*10.0
          INEOCC = IZZ*1000+IOCC
        ENDIF
        IF(ABS(INEOCC).GT.32766.0) 
     *  INEOCC = (ABS(INEOCC)/INEOCC)*32766.0
        IF(ABS(IZR).GT.32600.0) IZR = (ABS(IZR)/IZR)*32600.0
C -----
        BAVER = BAVER+BT
        IF(CR_RNAME.NE.'HOH') THEN
          BAVERW = BAVERW +BT 
          MATOMW = MATOMW +1
        ENDIF
        IF(BMIN .GT.BT ) BMIN  = BT
        IF(BPEAK.LT.BT ) BPEAK = BT
C ------------------------------

C -----
C ??
        IF(OCC.GT.0.0000001) THEN
          BAVER   = BAVER+BT
          SIGMAB  = SIGMAB + BT*BT
          IF(CR_RNAME.NE.'HOH') THEN
            BAVERW = BAVERW +BT 
            MATOMW = MATOMW +1
          ENDIF
          IF(BMIN .GT.BT ) BMIN =BT
          IF(BPEAK.LT.BT ) BPEAK=BT
          NBATOM=NBATOM+1
        ENDIF
c ??
C ------------------------------
        JJNS  = 0
        N_SYM = NSYM
        IF(P1.EQ.'Y'.OR.P1.EQ.'S') N_SYM = 1
        DO     ISM=1,N_SYM
          ROT(1) = ISYM(1,1,ISM)
          ROT(2) = ISYM(2,1,ISM)
          ROT(3) = ISYM(3,1,ISM)
          ROT(4) = ISYM(1,2,ISM)
          ROT(5) = ISYM(2,2,ISM)
          ROT(6) = ISYM(3,2,ISM)
          ROT(7) = ISYM(1,3,ISM)
          ROT(8) = ISYM(2,3,ISM)
          ROT(9) = ISYM(3,3,ISM)
          TR(1)  = ISYM(4,1,ISM)/REAL(ISYM(5,1,ISM))
          TR(2)  = ISYM(4,2,ISM)/REAL(ISYM(5,2,ISM))
          TR(3)  = ISYM(4,3,ISM)/REAL(ISYM(5,3,ISM))

          X =ROT(1)*XA(1 ) +ROT(2)*XA(2) +ROT(3)*XA(3)
     .       + TR(1)
          YY=ROT(4)*XA(1 ) +ROT(5)*XA(2) +ROT(6)*XA(3)
     .       + TR(2)
          Z =ROT(7)*XA(1 ) +ROT(8)*XA(2) +ROT(9)*XA(3)
     .       + TR(3)

          Y(1)=X
          Y(2)=YY
          Y(3)=Z

          DO     J=1,3
            TTT(J) = 0.0
21          IF(Y(J).LT.XS(J)) THEN
              Y(J)=Y(J)+1.
              TTT(J) = 1.0
              GO TO 21
            ENDIF
22          IF(Y(J).GE.XF(J)) THEN
              Y(J)=Y(J)-1.
              TTT(J) =-1.0
              GO TO 22
            ENDIF
            IPOINT(J)=1
            TRNS(J,1)=0.
            IF(Y(J).LE.XSU(J)) THEN
              IPOINT(J)=IPOINT(J)+1
              TRNS(J,2)=1.
            ELSE IF(Y(J).GE.XFU(J)) THEN
              IPOINT(J)=IPOINT(J)+1
              TRNS(J,2)=-1.
            ENDIF
            IF(ICELL.EQ.1) THEN
              IPOINT(J)=1
            ENDIF
          ENDDO

          INALL=0

          DO     IX=1,IPOINT(1)
            DO     IY=1,IPOINT(2)
              DO     IZ=1,IPOINT(3)
c                DO     JZ=1,3
                  JZ=2
                  ZZZ =Y(3)+TRNS(3,IZ)+FLOAT(JZ-2)

                  IF(ZZZ.GE.ZFFS.AND.ZZZ.LE.ZFFF) THEN

                    IXXX=(Y(1)+TRNS(1,IX))*FLOAT(IPACK)
                    IYYY=(Y(2)+TRNS(2,IY))*FLOAT(IPACK)
                    IZZZ= ZZZ             *FLOAT(IPACK)
                    IF(IX.EQ.1.AND.IY.EQ.1.AND.IZ.EQ.1) INALL=1
                    IATT=IATT+1
                    IF(IMEM_TEST.LE.0) THEN
                    IF(IATT.GT.NCOORM ) THEN
                      WRITE(STR,*) ' ERR: too many atoms > ',NCOORM
                      CALL MSGERR(MDOC,STR)
                      IERR=1
                      RETURN
                    ENDIF
                    NSUME         = NSUME+IZE
                    IBFACT(IATT)  = IZR
                    IZMOCC(IATT)  = INEOCC
                    IXC(IATT)   =IXXX
                    IYC(IATT)   =IYYY
                    IZC(IATT)   =IZZZ
                    ITRX=TRNS(1,IX)+1.001
                    ITRY=TRNS(2,IY)+1.001
                    ITRZ=TRNS(3,IZ)+1.001
c                   ISCODE(IATT)=ISM*100+INC
                    ISCODE(IATT)=0
                    IANUMB(IATT)=0
                    IF(ICELL.EQ.1) THEN
                      ITRX=TTT(1)+1.001
                      ITRY=TTT(2)+1.001
                      ITRZ=TTT(3)+1.001
                      INEOCC = ISM*27+ITRX+ITRY*3+ITRZ*9
                      IF(OCC.LE.0.0001) INEOCC =-1
                      IZMOCC(IATT) = INEOCC
                    ENDIF

                    IF(CR_BTYPE.EQ.'A') THEN

                      IANUMB(IATT)=1

                      IF(ISM.GT.1) THEN
                        CALL B_SYM(U,UR,ROT)
                      ELSE
                        CALL MCOPY(U,UR)
                      ENDIF

                      CALL B_TO_UO(Ur,Ur)

                      U_ANISO(1,IATT)=Ur(1)
                      U_ANISO(2,IATT)=Ur(2)
                      U_ANISO(3,IATT)=Ur(3)
                      U_ANISO(4,IATT)=Ur(4)
                      U_ANISO(5,IATT)=Ur(5)
                      U_ANISO(6,IATT)=Ur(6)
                    ENDIF

                    IRECRD(IATT)=IATT        

                    ENDIF
                  ENDIF

c                ENDDO
              ENDDO
            ENDDO
          ENDDO
        ENDDO
C ------------------------
        NINALL=NINALL+INALL
1000    CONTINUE
      GO TO 1100
C==================================================
 2000 MATOMS =I
      NATOMS =IATT
      IF(NBATOM.GT.0) THEN
        BAVER =BAVER /NBATOM
        SIGMAB=SIGMAB/NBATOM
        SIGMAB=SQRT(ABS(SIGMAB-BAVER*BAVER))
      ELSE
        SIGMAB=0.0
      ENDIF
      IF(MATOMW.GT.0) THEN
        BAVERW=BAVERW/MATOMW
      ENDIF
C ------------------------------------------------------
      M=99
      IF(IATT.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: N-ATOMS = 0 in ATSORT_A')
        IERR=1
        CLOSE(NIN)
        RETURN
      ENDIF
      IF(PACK.EQ.'Y') NMODEL = CR_MODEL
      IF(IMEM_TEST.GT.0) THEN
        NCOORD=IATT
        RETURN
      ENDIF

      CALL MSGDOC(M,' --- START SORT ---')
C     CALL SORT4(IZC,IATT,IBFACT,IZMOCC,IXC,IYC)
      CALL ISORT1(IZC,IATT,IRECRD)
      CALL MSGDOC(M,' --- END   SORT ---')
C ------------------------------------------------------
      IF(ISPHR.EQ.0) THEN
        D1     = SQRT(D1)
        D2     = SQRT(D2)
        BAVE   = ALOG(D2/D1)/D3
        BAVERF = BAVE
        CALL SETBADD(DMAX,BAVE,NX,NY,NZ,BCALC)

        WRITE(STR,'('' Baver/include SF/ :'',F8.3)') BAVERF
        CALL MSGDOC(MDOC,STR)
        WRITE(STR,'('' Badd_in,Badd_calc:'',2F8.3)') BADD,BCALC
        CALL MSGDOC(MDOC,STR)

        BADD_IN = BADD
        IF(BADD.LE.0.000001) BADD=BCALC        

c        IF(BMIN.GT.10.0) THEN
c
c          BADD= - BMIN+5.0
c
c          BAVE_NEW=BAVE+BADD
c
c          CALL SETBADD(DMAX,BAVE_NEW,NX,NY,NZ,BCALC_NEW)
c
c          WRITE(STR,'('' Baver/include SF/_NEW :'',F8.3)') BAVE_NEW
c          CALL MSGDOC(MDOC,STR)
c          WRITE(STR,'('' Badd_calc/NEW/:'',F8.3)') BCALC_NEW
c          CALL MSGDOC(MDOC,STR)
c
c          IF(BADD_IN.LT.0.0) BADD=BCALC_NEW        
c  
c        ENDIF

      ENDIF
      WRITE(STR,430) IAT_IN
      CALL MSGDOC(MDOC,STR)
      IF(NCS_FLAG.EQ.'Y') THEN
        WRITE(STR,434) MATOMS
        CALL MSGDOC(MDOC,STR)
      ENDIF
      IF(MATOMS.NE.NONH) THEN
        WRITE(STR,433) NONH
        CALL MSGDOC(MDOC,STR)
      ENDIF
      WRITE(STR,431) NATOMS
      CALL MSGDOC(MDOC,STR)
      WRITE(STR,432) NINALL
      CALL MSGDOC(MDOC,STR)
 430  FORMAT('ATOMS INPUT                       :',I6)
 433  FORMAT('ATOMS INPUT/non H /               :',I6)
 431  FORMAT('ATOMS INCLUDED IN SORT            :',I6)
 432  FORMAT('ATOMS IN ONCE ONLY                :',I6)
 434  FORMAT('ATOMS INPUT/including NCS-atoms / :',I6)

      IF(ISPHR.EQ.0) THEN
        WRITE(STR,440) BMIN,BPEAK,BAVER
        CALL MSGDOC(MDOC,STR)
 440    FORMAT('MINIMUM B - MAXIMUM B - AVERAGE B:',3F10.4)

        WRITE(STR,'('' B_AVER /without water/:'',F8.3)') BAVERW
        CALL MSGDOC(MDOC,STR)

c        WRITE(STR,442) NSUME
c 442    FORMAT('SUM-ELECTRONS :',I10)
c        CALL MSGDOC(MDOC,STR)
        FAVER=SQRT(SUMFI2*NSYM)
        WRITE(STR,441) NEL,FAVER
 441    FORMAT('SUM-ELECTRONS /IN MODEL/ :',I10,' <!F!> :',F12.0)
        CALL MSGDOC(MDOC,STR)
        AVERI=SUMFI2*NSYM
        WRITE(STR,443) AVERI
 443    FORMAT('                                  <I> :',F12.0)
        CALL MSGDOC(MDOC,STR)
      ELSE IF(ISPHR.EQ.1) THEN
        WRITE(STR,450) BMIN,BPEAK,BAVE
        CALL MSGDOC(MDOC,STR)
        WRITE(STR,451) SCHRG
        CALL MSGDOC(MDOC,STR)
        WRITE(STR,452) CHRGP
        CALL MSGDOC(MDOC,STR)
        WRITE(STR,453) CHRGM
        CALL MSGDOC(MDOC,STR)
 450    FORMAT('MINIMUM B - MAXIMUM B - AVERAGE B:',3F10.4)
 451    FORMAT('SUM-CHARGES           :',F10.4)
 452    FORMAT('SUM-POSITIV-CHARGES   :',F10.4)
 453    FORMAT('SUM-NEGATIV-CHARGES   :',F10.4)
      ENDIF
      NCOORD=IATT
      IF(NCOORD.EQ.0) THEN
        CALL MSGERR(MDOC,' ERR: GENDEN: N-ATOMS =0')
        IERR=1
      ENDIF
      CLOSE(NIN)
      RETURN
      END

      SUBROUTINE GENDENA(MDOC,DEN,N1,N2,N3,R,IATRC1,BADD
     * ,NCOORD,NCOORM,IBFACT,IZMOCC,IXCC,IYCC,IZCC
     * ,ISCODE,IANUMB,IRECRD,U_ANISO
     * ,VOL,NSYM,ISYM,IPRSYM,IERR)
C------------------------------------------------------
      REAL      DEN(N1,N2,N3)
      INTEGER   R,IATRC1
      INTEGER         IBFACT(NCOORM),IZMOCC(NCOORM)
     *                ,IXCC(NCOORM),IYCC(NCOORM),IZCC(NCOORM)
     *                ,ISCODE(NCOORM),IANUMB(NCOORM),IRECRD(NCOORM)
      REAL            U_ANISO(6,NCOORM)
C ---
      INTEGER          NCOORD,NCOORM
      INTEGER*2        ISYM(5,3,IPRSYM)
      INTEGER*4        NSYM,IPRSYM
C------------------------------------------------------
      COMMON/COMINFF/ NDENSP,NDENSM,NZERO,SUMRP,SUMRM
C------------------------------------------------------
      COMMON/CELLL/    A,B,C,ALPHA,BETA,GAMMA,ISPHR,DLIM,H2OBG,ICELL
      COMMON/DIMM/    DMAX,NX,NY,NZ,IZMIN,IZMAX,IHMAX,IKMAX,ILMAX
C --------------------------
      PARAMETER (NFMMAX=15)
      COMMON/FORMSs/   NFMFC,IZFMFC(15),FMFCA(5,15),
     *                FMFCB(5,15),FMRAD(15),CATOM
      CHARACTER       CATOM(15)*2
C-------------------------------------------------------------
      REAL            BLL(5),CLL(5)
      CHARACTER       BFLAG*1,LINE*80
      REAL            UO(6),UA(6),U(3,3,5),RM(3,3),DXF(3),DXC(3)
      REAL            BA(6),BO(6)
C------------------------------------------------------------------
      IERR=0
C --- integer*2 version
C     IPACK=10000
C --- integer*4 version
      IPACK=100000
C --- 
      NATREC = NCOORD
      COEF   = FLOAT(NX)*FLOAT(NY)*FLOAT(NZ)
      IF(R.EQ.IZMIN) IATRC1=0
C
      DLIMIT = DLIM*DLIM
      SX = A/NX
      SY = B/NY
      SZ = C/NZ
C
      PI     = 4.0*ATAN(1.0)
      TWOPI  = 2.0*PI
      TWOPI2 = TWOPI*PI
      PISQ4  = 4.0*PI*PI
      COSA   = COS(ALPHA)
      SINA   = SIN(ALPHA)
      COSG   = COS(GAMMA)
      SING   = SIN(GAMMA)
      COSB   = COS(BETA)
      SINB   = SIN(BETA)
      CSA2   = COSA*2.
      CSB2   = COSB*2.
      CSG2   = COSG*2
C      COSZ  DEFINES THE ANGLE BETWEEN C AND CSTAR
      SYCOSG = SY*COSG
      SXSING = SX*SING
      SYSING = SY*SING
      SZCOSB = SZ*COSB
      SZCOSA = SZ*COSA
      COSZ   = 
     *  SQRT(ABS((1.-COSA**2-COSB**2-COSG**2+2.*COSA*COSB*COSG)))/SING
      DV     = 8.0*SX*SY*SZ*COSZ*SING*PI**1.5
C
C  CELL VOLUME
C
      S = (ALPHA+BETA+GAMMA)*0.5
      VOL  = 2.0*A*B*C*
     *       SQRT(ABS(SIN(S)*SIN(S-ALPHA)*SIN(S-BETA)*SIN(S-GAMMA)))
      COEF = COEF/VOL
      DO     I3=1,N3
      DO     I2=1,N2
      DO     I1=1,N1
        DEN(I1,I2,I3)=-32001.0
      ENDDO
      ENDDO
      ENDDO
      ITETR  = 0
      ANGSUM = ABS(ALPHA+BETA+GAMMA-(3.0*PI)/2.)
      IF(ANGSUM.GT.0.01) ITETR=1
      IMON   = 0
C
C  BEWARE - MONOCLINIC SPACE GROUPS MUST BE TREATED AS HAVING C UNIQUE.
C
      ANGSUM = ABS(BETA+ALPHA-PI/2.)
      IF(ANGSUM.GT.0.01) IMON=1
      DLM = SQRT(DLIMIT)
      IF(IMON.EQ.1) DLM = DLM+0.5

      ZSFG   = FLOAT(R)/NZ     -DLM/C
      ZFFG   = FLOAT(R+N3-1)/NZ+DLM/C
      ZSFNXT = ZFFG-2.*DLM/C
C
      IATREC = IATRC1
C==========================================
1     IATREC = IATREC+1
      IF(IATREC.GT.NATREC) GO TO 400
C-------
C      IATM_P=IATREC
      IATM_P = IRECRD(IATREC)
      IAN    = IANUMB(IATM_P)
      BFLAG  = 'I'
      IF(IAN.GT.0) BFLAG='A'
      IBOCC = IZMOCC(IATM_P)
      IXIN  = IXCC  (IATM_P)
      IYIN  = IYCC  (IATM_P)
      IZIN  = IZCC  (IATREC)
      Z     = IZIN/FLOAT(IPACK)
      ISCD  = ISCODE(IATM_P)
      BAT   = IBFACT(IATM_P)/10.0


      IF(BFLAG.EQ.'A') THEN

        UA(1)=U_ANISO(1,IATM_P)
        UA(2)=U_ANISO(2,IATM_P)
        UA(3)=U_ANISO(3,IATM_P)
        UA(4)=U_ANISO(4,IATM_P)
        UA(5)=U_ANISO(5,IATM_P)
        UA(6)=U_ANISO(6,IATM_P)

        CALL UO_TO_B(UA,BA)

      ENDIF
C
      IF(Z.LT.ZSFNXT) IATRC1=IATREC
      IF(Z.LT.ZSFG)   GO TO 1
      IF(Z.GT.ZFFG)   GO TO 400
C
      SCALE = 1.0
      BT    = 1.0

      IF(ISPHR.GE.2) THEN
        DLIMIT = IBFACT(IATM_P)/1000.0
        DLIMIT = DLIMIT*DLIMIT
        IF(ICELL.EQ.1) THEN
          IF(IBOCC.LT.0) THEN
            OCC = 0.0
          ELSE
            OCC = 1.0
          ENDIF
          IDNS = ABS(IBOCC)
          IZZ  = 1
        ELSE  
          IZZ = IBOCC/1000
          IT  = IBOCC-IZZ*1000
          OCC = IT/10.
        ENDIF
      ELSE IF(ISPHR.EQ.1) THEN
        ICHRG  = IBFACT(IATM_P)/100.0
        BT     = IBFACT(IATM_P)-ICHRG*100.0
        CHARGE = (ICHRG-160.0)/100.0
        SCALE  = CHARGE/IZFMFC(IZZ)
        IZZ    = IBOCC/1000
        IT     = IBOCC-IZZ*1000
        OCC    = IT/10.
      ELSE IF(ISPHR.EQ.0) THEN
        BT  = IBFACT(IATM_P)/10.0
        BT  = BT+BADD
        IZZ = IBOCC/1000
        IT  = IBOCC-IZZ*1000
        OCC = IT/10.
      ENDIF
      IF(OCC.LT.0.0001) GO TO 1
      X  = IXIN/FLOAT(IPACK)
      Y  = IYIN/FLOAT(IPACK)
      X1 = X *A
      Y1 = Y *B
      Z1 = Z *C
      IF(BT.LT.0.0) THEN
        CALL MSGERR(MDOC,' ERR: GENDEN: B-FACTOR < 0.0 ')
        IERR=1
        RETURN
      ENDIF
      IF(ISPHR.LE.1) THEN
        IF(IZZ.LE.0.OR.IZZ.GT.NFMFC) THEN 
          CALL MSGERR(MDOC,' ERR: GENDEN: IDENTIFY FORMFACTORS = ?')
          IERR=1
          RETURN
        ENDIF
      ENDIF
      IF(ISPHR.EQ.1) THEN
        SCALE=CHARGE/IZFMFC(IZZ)
      ENDIF
      DVOCC  = OCC*DV*SCALE
      DMAXSQ = DLIMIT
      IF(ISPHR.LE.1) THEN
        IM = IZZ
        DO     J=1,5
          BLL(J) = PISQ4/(FMFCB(J,IM)+BT )
          CLL(J) = DVOCC*FMFCA(J,IM)*(FMFCB(J,IM)+BT )**(-1.5)
        ENDDO
      ENDIF
      IF(BFLAG.EQ.'A') THEN

        DO J=1,5
          B_EQUIV = FMFCB(J,IM)+BADD
          CALL BISO_TO_B(B_EQUIV,BO)
          CALL ADD_B(BO,BA,BO)
          CALL B_TO_UOM(BO,RM)
          CALL MDET(RM,DET)
          IF(DET.LE.0.00001.OR.B_EQUIV.LT.0.0) THEN
            BFLAG='I'
            DO  JJJ=1,5
              BLL(JJJ)=PISQ4/(FMFCB(JJJ,IM)+BT )
              CLL(JJJ)=DVOCC*FMFCA(JJJ,IM)*(FMFCB(JJJ,IM)+BT )**(-1.5)
            ENDDO
            GO TO 2
          ELSE
            t1=(TWOPI2)**(-1.5)
            t2=1./SQRT(DET) 
            CLL(J)=(DVOCC*FMFCA(J,IM)*t1*t2)/8.0 
          ENDIF
          CALL INVERT(RM,U(1,1,J),IERR)
        ENDDO
      ENDIF

 2    CONTINUE
C
      XC=X1/SX
      IXC=NINT(XC)
      YC=Y1/SY
      IYC=NINT(YC)
      ZC=Z1/SZ
      IZC=NINT(ZC)
C
      RRADZ=SQRT(DMAXSQ)/(SZ*COSZ)
      SZL=ZC-RRADZ
      SZU=ZC+RRADZ
      ISZL=INT(SZL+501.)
      ISZU=INT(SZU+500.)
C
C     CALCULATE THE DENSITY AT ALL POINTS TO WHICH ATOM CONTRIBUTES
C     (IE IN SPHERE OF RADIUS RRADZ)
C
      DO     IZ1=ISZL,ISZU
        IZ=IZ1-500
C
C     TEST WHETHER THIS ATOM LIES IN REQUIRED BLOCK OF FOURIER SECTIONS
C
        IZ2=IZ+1-R
        IF(IZ2.GT.N3 .OR. IZ2.LE.0)       GO TO 301
        ZF=FLOAT(IZ)/FLOAT(NZ)
        DZ=IZ*SZ-Z1
        D2=DZ*DZ
        IF(D2.GT.DMAXSQ .AND. ITETR.EQ.1) GO TO 301
        D3=DMAXSQ-DZ*DZ*SINA*SINA
        IF(D3.LE.0.)                      GO TO 301
        RRADY=SQRT(ABS(D3))/SYSING
        ZCOSA=DZ*COSA/SY
        SYL=YC-RRADY-ZCOSA
        SYU=YC+RRADY-ZCOSA
        ISYL=INT(SYL+501.)
        ISYU=INT(SYU+500.)
        DELZ1=2.*DZ
        DZCSA2=DZ*CSA2
        DZCOSB=DZ*COSB
        DO     IY1=ISYL,ISYU
          IY=IY1 - 500
          YF=FLOAT(IY)/FLOAT(NY)
          IY2=IY+1
          IF(IY2.LE.N2.AND.IY2.GE.1) THEN
            DY=IY*SY-Y1
            DYZ=D2+DY*(DZCSA2+DY)
            IF(DYZ.LE.DMAXSQ.OR.IMON.EQ.0) THEN
C
C             FOR GIVEN X AND Y  THE MINIMUM DSQ IS GIVEN
C             FOR DX=-DY*COSG-DZCOSB
C
              DXMIN=-DY*COSG-DZCOSB
              DSQMIN=DYZ-DXMIN**2
              IF(DSQMIN.LT.DMAXSQ) THEN
                DFACT2=-2.*DXMIN
                D4=DMAXSQ-DSQMIN
                DELZ2=DELZ1+DY*CSA2
                DELY1=2.*DY+DZCSA2
                DELY=2.*DY
                RRADX=SQRT(ABS(D4))/SXSING
                XDELTA=DXMIN/SX
                SXL=XC-RRADX + XDELTA
                SXU=XC+RRADX + XDELTA
                ISXL=INT(SXL+501.)
                ISXU=INT(SXU+500.)
                DO     IX1=ISXL,ISXU
                  IX=IX1-500
                  IX2=IX+1
                  XF=FLOAT(IX)/FLOAT(NX)
                  IF(IX2.LE.N1.AND.IX2.GE.1) THEN
                    DX=IX*SX-X1
                    DSQ=DX*(DX+DFACT2) + DYZ
                    IF(DSQ.LE.DMAXSQ) THEN

                      IF(BFLAG.EQ.'I') THEN

                        IF(ISPHR.GE.2) THEN
                          IF(ICELL.EQ.0) THEN
                            IF(DEN(IX2,IY2,IZ2).LE.-32000.0)
     *                      DEN(IX2,IY2,IZ2) = 0.0
                            DEN(IX2,IY2,IZ2) = 1.0
                          ELSE
                            IDOLD = DEN(IX2,IY2,IZ2)+0.001
                            IF(IDOLD.LT.-31000.0.OR.IDOLD.EQ.IDNS) THEN
                              DEN(IX2,IY2,IZ2) = IDNS+0.0001
                            ELSE
                              DEN(IX2,IY2,IZ2) = -27.0
                            ENDIF
                          ENDIF
                        ELSE
                          IF(DEN(IX2,IY2,IZ2).LE.-32000.0)
     *                    DEN(IX2,IY2,IZ2) = 0.0
                          FAC = 0.0
                          DO     J=1,5
                            DSQ1 =-DSQ*BLL(J)
                            FAC  = FAC+CLL(J)*EXP(DSQ1)
                          ENDDO
                          TEMP = FAC*COEF
                          DEN(IX2,IY2,IZ2) = DEN(IX2,IY2,IZ2) + TEMP
                        ENDIF

                      ELSE

                        IF(DEN(IX2,IY2,IZ2).LE.-32000.0)
     *                  DEN(IX2,IY2,IZ2)=0.0
C
C                       X,Y,Z    - fract.cords of atom
C                       XF,YF,XF - fract.coords of point (IX2,IY2,IZ2)   
C
C  TEMP = 1/8*(TWOPI^2)^(-3/2) * (DETU)^(-1/2) * EXP(-1/2*(DX' * U^(-1) * DX))
C 
C                                              
                        DXF(1)=XF-X
                        DXF(2)=YF-Y
                        DXF(3)=ZF-Z
                        CALL FTOO(DXF,DXC,IERR)
                        FAC=0.0
                        DO     J=1,5
                          QF= U(1,1,J)*DXC(1)*DXC(1)
     *                       +U(2,2,J)*DXC(2)*DXC(2)
     *                       +U(3,3,J)*DXC(3)*DXC(3)
     *                       +2.0*U(1,2,J)*DXC(1)*DXC(2)
     *                       +2.0*U(1,3,J)*DXC(1)*DXC(3)
     *                       +2.0*U(2,3,J)*DXC(2)*DXC(3)
                          TEMP=-QF/2.0
                          FAC=FAC+CLL(J)*EXP(TEMP)
                        ENDDO
                        TEMP=FAC*COEF
                     
c                    if(temp.gt.1.e8) then
c                      write(*,*) '-->',B_EQUIV,temp
c                    endif

                        DEN(IX2,IY2,IZ2)=DEN(IX2,IY2,IZ2)+TEMP

                      ENDIF

                    ENDIF
                  ENDIF
                ENDDO
              ENDIF
            ENDIF
          ENDIF
        ENDDO
301     CONTINUE
300     CONTINUE
      ENDDO
      GO TO 1
C -----------------------------------------------
400   CONTINUE

      SUMM=0.0
      SUMP=0.0
      DO     I3=1,N3
        DO     I2=1,N2
        DO     I1=1,N1
          IF(DEN(I1,I2,I3).LE.-32000.0) THEN
            DEN(I1,I2,I3)=H2OBG
            NZERO=NZERO+1
          ELSE IF(DEN(I1,I2,I3).GT.0.0) THEN
            NDENSP=NDENSP+1
            SUMP=SUMP+DEN(I1,I2,I3)

c  28.11.04
            IF(ICELL.EQ.1) DEN(I1,I2,I3) = 1.0

          ELSE IF(DEN(I1,I2,I3).LT.0.0.AND.
     *            DEN(I1,I2,I3).GT.-32000.0) THEN
            NDENSM=NDENSM+1
            SUMM=SUMM+DEN(I1,I2,I3)

c  28.11.04
            IF(ICELL.EQ.1) DEN(I1,I2,I3) = 1.0


          ENDIF
        ENDDO
        ENDDO
      ENDDO
      SUMRP=SUMRP+SUMP
      SUMRM=SUMRM+SUMM
      RETURN
      END

      SUBROUTINE CHAINGE_ATOME_ALIGN2(ANAME,IR1,IR2
     *  ,RNAME1,IWRT,ATOM_INDEX,ATOM_NAME)     
C -----------------------------------------------------
C -----
C     N CA CB CG CD CE CZ C O
      CHARACTER ATOM_NAME(9)*2
C                      g d e z
      INTEGER   ATOM_INDEX(4,25)
C ---
      CHARACTER ACODE3(25)*3
      CHARACTER AMIN(25)*1
      CHARACTER CH1*1
      CHARACTER CH3*3,RNAME1_OLD*3
      CHARACTER ANAME*4,RNAME1*3,RNAME2*3,ATOM1*4
C --
      DATA ACODE3/'CYS','SER','THR','PRO','ALA','GLY','ASN','ASP' 
     *           ,'GLU','GLN','HIS','ARG','LYS','MET','ILE','LEU' 
     *           ,'VAL','PHE','TYR','TRP','UNK','ASX','GLX','ACD' 
     *           ,'---'/
C  
c                1   2   3   4   5   6   7   8   9  10  11  12  13
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','X','-'/
c             14  15  16  17  18  19  20  21  22  23  24  25
C -------------------------------------------------------------
C---------------------------------------------------------------
      RNAME1_OLD = RNAME1
C-------
      IWRT = 0
      RNAME1 = ACODE3(IR1)
      RNAME2 = ACODE3(IR2)
      IF(IR1.EQ.IR2) THEN
        IF(RNAME1.EQ.'CYS'.AND.ANAME.EQ.'SE  ') ANAME = 'SG  '
        IF(RNAME1.EQ.'MET'.AND.ANAME.EQ.'SE  ') ANAME = 'SD  '
        IF(RNAME1.EQ.'MET'.AND.ANAME.EQ.'S   ') ANAME = 'SD  '
        IWRT = 1
        IF(RNAME1.EQ.'CYS'.AND.ANAME.EQ.'SD  ') IWRT = 0
        RETURN
      ELSE IF(ANAME.EQ.'N   '.OR.ANAME.EQ.'N   '.OR.ANAME.EQ.'O   '
     *    .OR.ANAME.EQ.'CA  '.OR.ANAME.EQ.'C   '.OR.ANAME.EQ.'OXT '
     *                         ) THEN
        IWRT = 1
        RETURN
      ENDIF
      IF(IR1.NE.IR2) THEN
        IF(RNAME1_OLD.EQ.'MET'.AND.ANAME.EQ.'CE  ') THEN
          IWRT = 0
          RETURN
        ENDIF
      ENDIF
      IF(RNAME1.EQ.'GLY'.OR.RNAME2.EQ.'GLY') RETURN
      IF(ANAME.EQ.'CB  ') THEN
C     -- CB --
        IWRT = 1
        RETURN
      ENDIF

      IA = 0
      IF(ANAME(2:2).EQ.'G') IA=1
      IF(ANAME(2:2).EQ.'D') IA=2
      IF(ANAME(2:2).EQ.'E') IA=3
      IF(ANAME(2:2).EQ.'Z') IA=4
C                      g d e z
C     INTEGER   ATOM_INDEX(4,25)

      IND1 = ATOM_INDEX(1,IR1)
      IND2 = ATOM_INDEX(2,IR1)
      JND1 = ATOM_INDEX(1,IR2)
      JND2 = ATOM_INDEX(2,IR2)

      IF(IND1.GT.0.AND.JND1.GT.0) THEN
        IF(IA.EQ.1) THEN
          ATOM1 = 'CG  '
C                 1   2   3   4   5   6   7   8   9   10  11  12  13
C      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
C     *         ,'M','I','L','V','F','Y','W','B','Z','X','-',' '/
C                 14  15  16  17  18  19  20

          IF(IR1 .EQ.1) ATOM1 = 'SG  '
          IF(IR1 .EQ.2) ATOM1 = 'OG  '
          IF(IR1 .EQ.3) ATOM1 = 'OG  '
          IF(IND1.EQ.2) ATOM1(3:3) = '1'
          IF(IND1.EQ.2.AND.ANAME(3:3).EQ.'2') ATOM1 = 'CG2 '
          IWRT = 1
          IF(IND1.EQ.1.AND.ANAME(3:3).EQ.'2') IWRT = 0
          ANAME = ATOM1
          RETURN
        ELSE IF(IA.EQ.2.AND.IND2.GT.0) THEN
C       -- CD --
          ATOM1 = 'CD  '
C                 1   2   3   4   5   6   7   8   9   10  11  12  13
C      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
C     *         ,'M','I','L','V','F','Y','W','B','Z','X','-',' '/
C                 14  15  16  17  18  19  20

          IF(IR1 .EQ. 7) ATOM1 = 'OD  '
          IF(IR1 .EQ. 8) ATOM1 = 'OD  '
          IF(IR1 .EQ.14) ATOM1 = 'SD  '
          IF(IR1 .EQ.11) ATOM1 = 'ND  '
          IF(IR1 .EQ.15) ATOM1 = 'CD1 '
          IF(IR1 .EQ.16) ATOM1 = 'CD1 '
          IF(IND2.EQ.2) ATOM1(3:3) = '1'
C         -- CD2 --
          IF(IND2.EQ.2.AND.ANAME(3:3).EQ.'2') THEN
            ATOM1 = 'CD2 '
            IF(IR1 .EQ.7) ATOM1 = 'ND2 '
            IF(IR1 .EQ.8) ATOM1 = 'OD2 '
          ENDIF
          IWRT = 1
          IF(IND2.EQ.1.AND.ANAME(3:3).EQ.'2') IWRT = 0
          IF(IR1 .EQ. 4) IWRT = 0
          ANAME = ATOM1
          RETURN
        ELSE IF(IA.EQ.3) THEN           
          IND1 = ATOM_INDEX(3,IR1)
          JND1 = ATOM_INDEX(3,IR2)
C         -- CE --
          IF(IND1.GT.0.AND.JND1.GT.0) THEN
            IF((IR1.EQ.IR2)             .OR.
     *        (IR1.EQ. 9.AND.IR2.EQ.10).OR.
     *        (IR1.EQ.10.AND.IR2.EQ. 9).OR.
     *        (IR1.EQ.20.AND.IR2.EQ.11).OR.
     *        (IR1.EQ.11.AND.IR2.EQ.20).OR.
     *        (IR1.EQ.12.AND.IR2.EQ.13).OR.
     *        (IR1.EQ.13.AND.IR2.EQ.12).OR.
     *        (IR1.EQ.18.AND.IR2.EQ.19).OR.
     *        (IR1.EQ.19.AND.IR2.EQ.18)    )THEN
              ATOM1 = 'CE  '
C                 1   2   3   4   5   6   7   8   9   10  11  12  13
C      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
C     *         ,'M','I','L','V','F','Y','W','B','Z','X','-',' '/
C                 14  15  16  17  18  19  20

              IF(IR1 .EQ. 9) ATOM1 = 'OE  '
              IF(IR1 .EQ.10) ATOM1 = 'OE  '
              IF(IR1 .EQ.12) ATOM1 = 'NE  '
              IF(IR1 .EQ.20) ATOM1 = 'NE  '
              IF(IND1.EQ.2) ATOM1(3:3) = '1'
              IF(IND1.EQ.2.AND.ANAME(3:3).EQ.'2') THEN
                ATOM1 = 'CE2 '
                IF(IR1 .EQ.10) ATOM1 = 'NE2 '
                IF(IR1 .EQ.11) ATOM1 = 'NE2 '
                IF(IR1 .EQ. 9) ATOM1 = 'OE2 '
              ENDIF
              IWRT = 1
              IF(IND1.EQ.1.AND.ANAME(3:3).EQ.'2') IWRT = 0
              IF(ANAME(3:3).EQ.'3') IWRT = 0
              ANAME = ATOM1
              RETURN
            ENDIF
          ENDIF
        ELSE IF(IA.EQ.4) THEN           
          IND1 = ATOM_INDEX(4,IR1)
          JND1 = ATOM_INDEX(4,IR2)
C     -- CZ --
          IF(IND1.GT.0.AND.JND1.GT.0) THEN
            IF((IR1.EQ.IR2)             .OR.
     *        (IR1.EQ.12.AND.IR2.EQ.13).OR.
     *        (IR1.EQ.13.AND.IR2.EQ.12).OR.
     *        (IR1.EQ.18.AND.IR2.EQ.19).OR.
     *        (IR1.EQ.19.AND.IR2.EQ.18)    )THEN
              ATOM1 = 'CZ  '
C                 1   2   3   4   5   6   7   8   9   10  11  12  13
C      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
C     *         ,'M','I','L','V','F','Y','W','B','Z','X','-',' '/
C                 14  15  16  17  18  19  20

              IF(IR1 .EQ.13) ATOM1 = 'NZ  '
              IF(IND1.EQ.2) ATOM1(3:3) = '1'
              IWRT  = 1
              IF(IND1.EQ.1.AND.ANAME(3:3).EQ.'2') IWRT = 0
              ANAME = ATOM1
              RETURN
            ENDIF
          ENDIF
        ENDIF
      ENDIF
C ---------------------------
      RETURN
      END

      SUBROUTINE CORR_ATOME_NAME_AFTER_ALIGN(
     *                         ANAME,RNAME,ASYMB,IWRT)
C -----------------------------------------------------
      CHARACTER ANAME*4,ASYMB*4,RNAME*3
C -----------------------------------------------------
      IF(ANAME.EQ.'CA  '.AND.ASYMB.NE.'C   ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(ASYMB.EQ.'SE  ') ASYMB = 'S   '

      IF(ASYMB.NE.'C   '.AND.ASYMB.NE.'N   '.AND.
     *   ASYMB.NE.'O   '.AND.ASYMB.NE.'S   ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(ANAME.EQ.'N   '.OR.ANAME.EQ.'C   '.OR.ANAME.EQ.'O   '.OR.
     *   ANAME.EQ.'CA  '.OR.ANAME.EQ.'CB  '.OR.ANAME.EQ.'OXT ')THEN
        IF(RNAME.EQ.'GLY'.AND.ANAME.EQ.'CB  ') IWRT = 0 
        RETURN
      ENDIF

      IF(RNAME.EQ.'CYS'.AND.ANAME.EQ.'SE  ') ANAME = 'SG  '
      IF(RNAME.EQ.'MET'.AND.ANAME.EQ.'SE  ') ANAME = 'SD  '
      IF(RNAME.EQ.'MET'.AND.ANAME.EQ.'S   ') ANAME = 'SD  '

      IF(RNAME.EQ.'ALA') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'ARG'.AND.ANAME.NE.'CD  '.AND.
     *  ANAME.NE.'CG  '.AND.ANAME.NE.'NE  '.AND.
     *  ANAME.NE.'NH2 '.AND.
     *  ANAME.NE.'CZ  '.AND.ANAME.NE.'NH1 ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'ASN'.AND.ANAME.NE.'CG  '.AND.
     *  ANAME.NE.'OD1 '.AND.ANAME.NE.'ND2 ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'ASP'.AND.ANAME.NE.'CG  '.AND.
     *  ANAME.NE.'OD1 '.AND.ANAME.NE.'OD2 ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'CYS'.AND.ANAME.NE.'SG  ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'GLN'.AND.ANAME.NE.'CG  '.AND.
     *  ANAME.NE.'CD  '.AND.
     *  ANAME.NE.'OE1 '.AND.ANAME.NE.'NE2 ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'GLU'.AND.ANAME.NE.'CG  '.AND.
     *  ANAME.NE.'CD  '.AND.
     *  ANAME.NE.'OE1 '.AND.ANAME.NE.'OE2 ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'GLY') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'HIS'.AND.ANAME.NE.'CG  '.AND.
     *  ANAME.NE.'ND1 '.AND.ANAME.NE.'CD2 '.AND.
     *  ANAME.NE.'CE1 '.AND.ANAME.NE.'NE2 ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'ILE'.AND.ANAME.NE.'CG1 '.AND.
     *  ANAME.NE.'CD1 '.AND.ANAME.NE.'CG2 ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'LEU'.AND.ANAME.NE.'CG  '.AND.
     *  ANAME.NE.'CD1 '.AND.ANAME.NE.'CD2 ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'LYS'.AND.ANAME.NE.'CG  '.AND.
     *  ANAME.NE.'CD  '.AND.ANAME.NE.'CE  '.AND.
     *  ANAME.NE.'NZ  ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'MET'.AND.ANAME.NE.'SD  '.AND.
     *  ANAME.NE.'CG  '.AND.ANAME.NE.'CE  ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'PHE'.AND.ANAME.NE.'CG  '.AND.
     *  ANAME.NE.'CD1 '.AND.ANAME.NE.'CD2 '.AND.
     *  ANAME.NE.'CZ  '.AND.
     *  ANAME.NE.'CE1 '.AND.ANAME.NE.'CE2 ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'PRO'.AND.ANAME.NE.'CG  '.AND.
     *                      ANAME.NE.'CD  ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'SER'.AND.ANAME.NE.'OG  ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'THR'.AND.ANAME.NE.'OG1 '.AND.
     *  ANAME.NE.'CG2 ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'TRP'.AND.ANAME.NE.'CG  '.AND.
     *  ANAME.NE.'CD1 '.AND.ANAME.NE.'CD2 '.AND.
     *  ANAME.NE.'NE1 '.AND.ANAME.NE.'CE2 '.AND.
     *  ANAME.NE.'CH2 '.AND.ANAME.NE.'CZ2 '.AND.
     *  ANAME.NE.'CE3 '.AND.ANAME.NE.'CZ3 ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'TYR'.AND.ANAME.NE.'CG  '.AND.
     *  ANAME.NE.'CD1 '.AND.ANAME.NE.'CD2 '.AND.
     *  ANAME.NE.'CZ  '.AND.ANAME.NE.'OH  '.AND.
     *  ANAME.NE.'CE1 '.AND.ANAME.NE.'CE2 ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'VAL'.AND.ANAME.NE.'CG1 '.AND.
     *  ANAME.NE.'CG2 ') THEN
        IWRT = 0
        RETURN
      ENDIF
C ----
      RETURN
      END

      SUBROUTINE CORR_RESNAME_BY_SYNONYM(CH3)
C --------------------------------------------
      CHARACTER CH3*3
      PARAMETER ( NRNAMEU = 24 )
      CHARACTER RNAMEU(NRNAMEU)*3
      PARAMETER ( NRNAME = 185 )
      CHARACTER RNAME(NRNAME)*7
C --
      DATA RNAMEU/'TPQ','AIB','CRQ','SNN','ACY','CRG','SUI','ALS' 
     *           ,'ABA','SIN','175','TA4','NRQ','MDO','CH6','EXC'
     *           ,'GLQ','   ','   ','   ','   ','   ','   ','   '/
C --
      DATA RNAME /'CYG CYS','DTY TYR','SCY CYS','TRQ TRP','PHL PHE'
     *           ,'       ','NEM HIS','IAS ASP','MSO MET','AYA ALA' 
     *           ,'GL3 GLY','GLH GLU','ASI GLY','PN2 SER','ARO ARG'
     *           ,'CSZ CYS','SEC SER','CMH CYS','FGL SER','BFD ASP'
     *           ,'CZZ CYS','143 CYS','YCM MET','CXM MET','LCX LYS' 
     *           ,'MCL LYS','LEF LEU','CSR CYS','LAL ALA','AR4 GLU' 
     *           ,'CSH CYS','MSE MET','BMT THR','MLE LEU','MVA VAL' 
     *           ,'PTR TYR','HYP PRO','INI LYS','NLE LEU','TYS TYR'
     *           ,'CGU GLU','OCS CYS','KCX LYS','SAH CYS','SAM MET' 
     *           ,'SEP SER','LLP LYS','5HP PRO','CSO CYS','1PA ALA' 
     *           ,'2AS ASP','3GA ALA','AEI THR','AGM ARG','AHB ASN' 
     *           ,'ALO THR','APH ALA','ASL ASP','ASM ASP','BCS CYS'
     *           ,'BHD ASP','BTA LEU','BTC CYS','BTR TRP','BUC CYS'
     *           ,'C5C CYS','C6C CYS','CAS CYS','CAY CYS','CCS CYS'
     *           ,'CEA CYS','CHP GLY','CME CYS','CSB CYS','CSD ALA'
     *           ,'CSE CYS','CSP CYS','CSS CYS','CSW CYS','CSX CYS'
     *           ,'CTH THR','CYM CYS','DBY TYR','DHN VAL','DNP ALA'
     *           ,'DOH ASP','DSE SER','EFC CYS','EHP PHE','FLA ALA'
     *           ,'FME MET','FTR TRP','FTY TYR','GAM GLU','GHP GLY'
     *           ,'GSC GLY','GT9 CYS','H5M PRO','HAR ARG','HIC HIS'
     *           ,'HIP HIS','HTR TRP','HV5 ALA','IIL ILE','IML ILE'
     *           ,'ITR TRP','IYR TYR','LLY LYS','LTR TRP','LYZ LYS'
     *           ,'M3L LYS','MCY CYS','MEN ASN','MGN GLN','MGY GLY'
     *           ,'MHL LEU','MHO MET','MHS HIS','MIS SER','MLY LYS'
     *           ,'MLZ LYS','MTY TYR','NEP HIS','NMC GLY','NPH CYS'
     *           ,'NVA VAL','OCY CYS','OMT MET','ONL LEU','PBB CYS'
     *           ,'PEC CYS','PGY GLY','PHI PHE','POM PRO','PPN PHE'
     *           ,'PRR ALA','PRS PRO','PTH TYR','PYA ALA','PYX CYS'
     *           ,'RON VAL','SCH CYS','SEB SER','SEG ALA','SLZ LYS'
     *           ,'SMC CYS','SME MET','SNC CYS','SOC CYS','STY TYR'
     *           ,'SVA SER','TBG GLY','THC THR','TIH ALA','TNB CYS'
     *           ,'TPO THR','TRF TRP','TRG LYS','TRN TRP','TRO TRP'
     *           ,'TYI TYR','TYN TYR','TYQ TYR','YOF TYR','TRY TRP'
     *           ,'DSN SER','DAL ALA','DVA VAL','DPN PHE','DPR PRO' 
     *           ,'DTR TRP','DTH THR','DLE LEU','DAR ARG','DAS ASP' 
     *           ,'DCY CYS','DGL GLU','DGN GLN','DHI HIS','DTY TYR' 
     *           ,'DLY LYS','DIL ILE','DIV VAL','       ','       '/
C --------------------------------------------
      DO I=1,NRNAMEU
        IF(CH3.EQ.RNAMEU(I)) THEN
          CH3 = 'UNK'
          GO TO 100
        ENDIF
      ENDDO
C --
      DO I=1,NRNAME
        IF(CH3.EQ.RNAME(I)(1:3)) THEN
          CH3 = RNAME(I)(5:7)
          GO TO 100
        ENDIF
      ENDDO
 100  CONTINUE
      RETURN
      END

      SUBROUTINE TABLE_SR_DB(R,DEL,N,XP,YP,ZP,SD,NPMAX,IERR)
C --------------------------------
C IERR
C  2   - CALL MSGERR(MDOC,' ERROR: surface: table_sr: STOP NZ < 2')
C  3   - CALL MSGERR(MDOC,' ERROR: surface: table_sr: STOP M < 1')
C  4   - CALL MSGERR(MDOC,' ERROR: surface: table_sr: J > NPMAX')
C --------------------------------
      REAL XP(NPMAX),YP(NPMAX),ZP(NPMAX)
C --------------------------------
      PI    = 4.0*ATAN(1.0)
      XP(1) = 0.0
      YP(1) = 0.0
      ZP(1) = R
      J     = 1
      NZ    = (PI*R)/DEL
      IF(NZ.LE.2) THEN
        IERR=2
        RETURN
      ENDIF
      ANGLZ = PI/NZ
      DO K=1,NZ-1
        Z1 = K*ANGLZ
        Z  = R*COS(Z1)
        RS = SIN(Z1)*R
        M  = 2*PI*RS/DEL
        IF(M.LE.1) THEN
          IERR=3
          RETURN
        ENDIF
        BANGL = 2*PI/M
        DO I=1,M
          BI = BANGL*I
          X  = RS*COS(BI)
          Y  = RS*SIN(BI)
          J  = J+1
          IF(J.GT.NPMAX) THEN
            IERR=4
            RETURN
          ENDIF
          XP(J) = X
          YP(J) = Y
          ZP(J) = Z
        ENDDO
      ENDDO
      XP(J+1) = 0
      YP(J+1) = 0
      ZP(J+1) =-R
      N       = J+1
      SD      = (4.0*PI*R*R)/FLOAT(N)
      RETURN
      END
