C
C     MOLREP molecular replacement program
C     Copyright (C) 1999-2006 Alexei Vagin
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C --- LIBUTILS.FTN ---
C ******
C ---------------------------------------------------------------------------
C
C
C     --- LIBRARY OF KERNEL SUBROUTINES OF "BLANC-SYSTEM" ---
C                                 /V. ??.09.1978 - 29.03.1991   A.A.VAGIN/
C                                   - 21.06.1992 - 29.09.1992
C                                   - 16.12.1994 - 15.07.1995
C  -------------------------------------------------------------------
C
C ******

C ******
C -P-
C -P- ----   SUBROUTINES INDEPENDED ON SYSTEM --------------------
C -P-
C -P------ subroutines for all programs  --------------------
C -P-
C ******


C ******
      SUBROUTINE SET_DEFAULT(LINE)
C
C -P- SET_DEFAULT - write info about the defaults, get the defaults and go to 
C -P-               batch mode.  
C
      CHARACTER LINE*(*)
C ******
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*512
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ---
      PARAMETER ( KEY_MAX = 150 )
      COMMON/COMASK/ IEND,NKEY,FLAG,STOR,STOR_KEY 
     *              ,VCCP4,FILE_KEY_INP,KEY_INF
      CHARACTER VCCP4*1,FILE_KEY_INP*256,KEY_INF*1
      INTEGER*4 FLAG(KEY_MAX),IEND,NKEY
      CHARACTER STOR(KEY_MAX)*256,STOR_KEY(KEY_MAX)*11
      COMMON/COMASK2/ NKEY_TEST,KEY_TEST
      INTEGER*4 NKEY_TEST
      CHARACTER KEY_TEST(KEY_MAX)*11
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMFREAD_KEYWORDS/ 
     *                  FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*256
      CHARACTER IN_STRING*256
C --------------------------------------------------------------
C ---
      INTEGER*4 NL,NLK
      CHARACTER STR*256,KEY*256,K_TEST*11,CHAR1*1,IN_STRING2*256
      CHARACTER STR1*256,S_END*256,FILE_KEY*256,STR2*256
C ---------------------------------------------------------
      IPRINT = 0
      IF(IBATCH.NE.0) THEN
C       It is not interactive mode 
        RETURN
      ENDIF

C      M=1
C      IF(VCCP4.EQ.'C'.AND.KEY_INF.NE.'Y') M = 99
C      IF(VCCP4.EQ.'I'.AND.KEY_INF.NE.'Y') M = 99

      CALL LENSTR_BL(LINE,NL)
      IF(NL.GT.255) NL=255
      IF(NL.LE.0) THEN
        STR(1:1)=' '
        NL      =1
      ELSE
        STR=LINE(1:NL)
      ENDIF

      IWD = 0
      IWB = 0

      IF(STR(1:1).EQ.'?') THEN

C       first call of dialogue

c        IF(NL.GT.2) THEN
c          S_END=STR(3:NL)
c          NL_END=NL-2
c        ELSE
c          S_END =' '
c          NL_END=0
c        ENDIF

        NKEY=0
        DO I=1,KEY_MAX
          FLAG(I)=0
        ENDDO

        M=0
        IF(VCCP4.EQ.'C'.AND.KEY_INF.NE.'Y') M = 99
        IF(VCCP4.EQ.'Y') M = 99
        CALL MSGDOC(M,'# ---  type "keyword   parameters" and/or  ---')
        CALL MSGDOC(M,'# ---  press key "CR" to run program       ---')

        KFIRST    = 0
        IUNIT_KEY = 0
C       FILE_KEY  = ' '

        CALL LENSTR_BL(FILE_KEY_INP,LEN)
        IF(LEN.GT.0.AND.
     *     FILE_KEY_INP(1:1).NE.'.') THEN
          IUNIT_KEY = 10
          M         = 99
          CALL OPENFR(IUNIT_KEY,M,' ',FILE_KEY_INP,' ',IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(M,' ERROR: can not open KEYWORD_FILE')
            STOP
          ELSE
            KFIRST    = 1
          ENDIF             
        ELSE
          KFIRST = 2
          IF(VCCP4.EQ.'C') KFIRST = 3
        ENDIF

 200    CONTINUE

C       start loop of dialogue

        IF(BAT_MODE.EQ.0.AND.KFIRST.NE.1) CALL DISPL_BL('-->')

C       read input line

        IN_STRING = ' '
        IF(KFIRST.NE.1) THEN

          IF(KFIRST.EQ.3) GO TO 100
C         finish of dialogue

C          IF(VCCP4.EQ.'C') THEN
c          IF(VCCP4.EQ.'C'.OR.VCCP4.EQ.'I') THEN
C            IF(KFIRST.GE.2) THEN
C              IN_STRING = '_STOP'
C              GO TO 1000
C            ELSE
C              CALL LENSTR_BL(FILE_KEY_INP,L)
C              IF(L.GT.0) THEN          
C                IN_STRING = '_ADD: '//FILE_KEY_INP(1:L)
C                GO TO 1000
C              ELSE
C                IN_STRING = '_STOP'
C                GO TO 1000
C              ENDIF
C            ENDIF
C          ENDIF

C         READ(*,'(A)',END=1040,ERR=1030) IN_STRING
          READ(*,'(A)',END=1041,ERR=1030) IN_STRING
          GO TO 1000
 1041     CONTINUE
          KFIRST    = 3         

        ELSE IF(KFIRST.EQ.1) THEN

          IF(IUNIT_KEY.LE.0) GO TO 1020
          READ(IUNIT_KEY,'(A)',END=1010,ERR=1020) IN_STRING
          GO TO 1001
 1010     CONTINUE
          CLOSE(IUNIT_KEY)
          IUNIT_KEY = 0
          KFIRST    = 2
          IF(KEY_INF.EQ.'Y') KFIRST = 3
          IF(VCCP4.EQ.'C')   KFIRST = 3

 1001     CONTINUE

          IF(VCCP4.EQ.'I') THEN
            CALL LENSTR_BL(IN_STRING,L)
            IF(L.GT.1) THEN
              M=0
              CALL MSGDOC(M,IN_STRING(1:L))
            ENDIF
          ENDIF

        ENDIF

 1000   CONTINUE
        CALL LENSTR_BL(IN_STRING,L)
        IF(L.GT.1) THEN
          IFIRST     = 0
          II         = 0
          IN_STRING2 = ' '
          DO I=1,L
            IF(IFIRST.EQ.0.AND.IN_STRING(I:I).EQ.' ') THEN
            ELSE
              IFIRST=1
              II=II+1
              IN_STRING2(II:II)=IN_STRING(I:I)
            ENDIF
          ENDDO
          IN_STRING=IN_STRING2
          CALL LENSTR_BL(IN_STRING,L)
          IF(L.GT.0.AND.IN_STRING(1:1).EQ.'#') GO TO 200
C         comments
          IF(IN_STRING(1:4).EQ.'_END'.OR.
     *       IN_STRING(1:4).EQ.'_end'    ) GO TO 200 
        ELSE
C         empty line
          IF(IBATCH.NE.0) THEN
            IF(L.LE.0.OR.IN_STRING(1:1).EQ.' ') GO TO 200
          ELSE
C           finish of dialogue
            IF(L.LE.0.OR.IN_STRING(1:1).EQ.' ') GO TO 100  
          ENDIF
        ENDIF
C        IF(L.LE.0.OR.IN_STRING(1:1).EQ.' '.OR.
C     *               IN_STRING(1:5).EQ.'_STOP') GO TO 100
C ----
        CALL FRD_PARM_KEYWORDS
        IF(NWORDS.LE.0) GO TO 200

C       get key_word:  'word  <...> ' or '_word <...> '    
        KEY = WORDS(1)
        NLK = LEN_WORDS(1)
        IF(NLK.GE.1) THEN
          IF(KEY(1:1).NE.'_') THEN
C           first symbol must be '_' if not add it
            KEY = '_'//KEY(1:NLK)
            NLK = NLK + 1
          ELSE
            KEY = KEY(1:NLK)
          ENDIF
        ELSE
          KEY = ' '
          NLK = 1
        ENDIF
        
        IF(NLK.GT.12) NLK=12
        IF(NLK.LE.1) GO TO 200 
C       check keyword KEY and convert to uppercase
        CALL CHECK_LINE(1,KEY(1:NLK))

C       create string of parameters STR without keyword 
        DO I=1,L
          J = I+LEN_WORDS(1)-1
          IF(IN_STRING(I:J).EQ.WORDS(1)(1:LEN_WORDS(1))) THEN
            JJ = J+1
            IF(JJ.EQ.L) GO TO 200 
            STR = IN_STRING(JJ:L)
            NL  = L-J
            GO TO 300
          ENDIF
        ENDDO
        GO TO 200

 300    CONTINUE
C       remove last symbol ':' from keywords 
        IF(KEY(NLK:NLK).EQ.':') THEN
          KEY(NLK:NLK) = ' '
          NLK          = NLK-1
        ENDIF

C       creat correct string STR : 'keyword <parameters>'


        IF(NLK.EQ.4.AND.KEY(1:NLK).EQ.'_DOC') IPRINT = 1
        IF(NL.LE.0) THEN
          STR=KEY(1:NLK)//' ' 
        ELSE
          STR=KEY(1:NLK)//' '//STR(1:NL) 
        ENDIF
        CALL LENSTR_BL(STR,NL)
        IF(NL.GT.256) NL=256
        IF(NLK.GT.1) THEN
          IF(NKEY_TEST.GT.0) THEN
C           check with possible keywords / KEY_TEST(NKEY_TEST) /               
            IMODE  = 1
            K_TEST = KEY(2:NLK)
            NLKK   = NLK-1
            CALL CHECK_LINE(IMODE,K_TEST)
            DO I=1,NKEY_TEST
              CALL LENSTR_BL(KEY_TEST(I),LEN)
              IF(LEN.EQ.NLKK) THEN
                IF(KEY_TEST(I)(1:LEN).EQ.K_TEST(1:LEN)) GO TO 310
              ENDIF
            ENDDO

            CALL LENSTR_BL(K_TEST,LEN)
            L = LEN
            IF(L.GT.11) L = 11
            STR1=' WARNING: no such keyword :'//K_TEST(1:L)
            IF(L.GT.0) THEN
              IF(K_TEST(1:1).NE.'#') THEN
                M = 0
                CALL MSGERR(M,STR1)
              ENDIF
            ELSE
              M = 0
              CALL MSGERR(M,' WARNING: no such keyword')
            ENDIF

            GO TO 200

 310        CONTINUE

            IF(KEY(1:NLK).EQ.'_LABIN') THEN

              IF(STR(NL-1:NL).EQ.' -') THEN
 330            CONTINUE
                READ(*,'(A)',END=1040,ERR=1030) IN_STRING
                CALL LENSTR_BL(IN_STRING,L)
                IF(L.GT.1) THEN
                  IFIRST     = 0
                  II         = 0
                  IN_STRING2 = ' '
                  DO I=1,L
                    IF(IFIRST.EQ.0.AND.IN_STRING(I:I).EQ.' ') THEN
                    ELSE
                      IFIRST=1
                      II=II+1
                      IN_STRING2(II:II)=IN_STRING(I:I)
                    ENDIF
                  ENDDO
                  IN_STRING=IN_STRING2
                  CALL LENSTR_BL(IN_STRING,L)
                  IF(L.GT.0) THEN
                    CALL LENSTR_BL(STR,NL)
                    STR = STR(1:NL-1)//IN_STRING(1:L)
                    CALL LENSTR_BL(STR,NL)
                    IF(STR(NL-1:NL).EQ.' -') GO TO 330
                  ENDIF
                ENDIF
              ENDIF
            ENDIF
       
          ENDIF

        ENDIF

        IF(IPRINT.GT.0) BAT_MODE = 1
c        IF(BAT_MODE.EQ.1) THEN
          M=-1
          IF(IPRINT.GT.0) M = 0
c////          IF(NL.GT.0) CALL MSGDOC(M,STR(1:NL))
c        ENDIF

        IF(NKEY.GT.0) THEN
C         check with previous keywords 
C         if there is such keywords replace stored string STOR
          DO I=1,NKEY
            CALL LENSTR_BL(STOR_KEY(I),NLSK)
            IF(NLSK.EQ.NLK.AND.KEY(1:NLK).EQ.STOR_KEY(I)(1:NLK))THEN
              STOR(I)     = STR(1:NL)
              STOR_KEY(I) = KEY(1:NLK)
            ENDIF 
          ENDDO
        ENDIF

        IF(NKEY.LT.KEY_MAX) THEN
C         store new keyword in STOR_KEY and string STR in STOR
          NKEY           = NKEY+1
          FLAG(NKEY)     = 1
          STOR(NKEY)     = STR(1:NL)
          STOR_KEY(NKEY) = KEY(1:NLK)
        ENDIF

C        IF(KEY(1:NLK).EQ.'_ADD') THEN
C          FILE_KEY = WORDS(2)
C          CALL CORR_NAME_BL(FILE_KEY)
C          CALL LENSTR_BL(FILE_KEY,LEN)
C          IF(NWORDS.GT.1.AND.LEN.GT.0.AND.
C     *       FILE_KEY(1:1).NE.'.'.AND.FILE_KEY(1:1).NE.' ') THEN
C            IUNIT_KEY = 10
C            MM         = 99
C            CALL OPENFR(IUNIT_KEY,MM,' ',FILE_KEY,' ',IERR)
C            IF(IERR.NE.0) THEN
C              CALL MSGERR(M,' ERROR: can not open KEYWORD_FILE')
C              IERR      = 0
C              IUNIT_KEY = 0
C              KFIRST    = 2             
C              STOP
C            ELSE
C              KFIRST    = 1
C            ENDIF             
C          ELSE
C            CALL MSGERR(M,' WARNING: keyword ADD without parameter')
C          ENDIF
C        ENDIF

        GO TO 200

C       end loop of dialogue
C ---
 100    CONTINUE

C       finish of dialogue

        IF(BATCH_FILE.GT.0.AND.NKEY.GT.0) THEN
C         write to batch file
          M = 1
          CALL MSGDOC(M,' ')
          CALL MSGDOC(M,' ')
          CALL MSGDOC(M,
     *'+===== Input keywords ============================+')
          DO I=1,NKEY
            STR=STOR(I)
            CALL LENSTR_BL(STR,NL)
            IF(NL.LE.0) THEN
              NL=1
              STR=' '
            ELSE
              IF(NL.GT.250) NL=250
            ENDIF
            STR2 = 
     *'|                                                 |'
            IF(NL.LE.45 ) THEN
              STR2(5:NL+4) = STR(1:NL) 
            ELSE
              STR2 = '|   '//STR(1:NL)
            ENDIF
            CALL MSGDOC(M,STR2) 
            WRITE(BATCH_FILE,'(A)',ERR=10) STR(1:NL)
          ENDDO
          CALL MSGDOC(M,
     *'+=================================================+')
        ENDIF

        IBATCH = 1
        IEND   = 1
        IWB    = 1
        IWD    = 0

C        IF(NL_END.EQ.0) THEN
C          STR   = '_END'
C          NL    = 4
C        ELSE
C          STR = '_END'//S_END(1:NL_END)
C          NL  = NL_END+4
C        ENDIF

      ELSE
C ----------------------------------
C
C       it is possible keyword if string is : 'keyword: <....>'
C         or comment string
C   
        IPRINT = 0
        IF(STR(1:1).NE.' ') THEN
          N  = NL
          NK = 0
          IF(NL.GT.12) N = 12
          DO I=1,N
            IF(STR(I:I).EQ.':') THEN
              IF(NK.GT.0.AND.NKEY_TEST.LT.KEY_MAX) THEN
                IF(NKEY_TEST.GT.0) THEN
                  DO J=1,NKEY_TEST
                    CALL LENSTR_BL(KEY_TEST(J),L)
                    IF(KEY_TEST(J)(1:L).EQ.STR(1:NK)) GO TO 320
                  ENDDO
                ENDIF
                NKEY_TEST           = NKEY_TEST + 1
                KEY_TEST(NKEY_TEST) = STR(1:NK)
              ENDIF
              GO TO 320 
            ENDIF
            NK=NK+1
          ENDDO
        ENDIF
 320    CONTINUE       

        STR    = '#'//STR(1:NL)
        NL     = NL+1
        IWB    = 1
        IWD    = 1

c       list of keywords

        IF(IWD.GT.0.AND.KEY_INF.EQ.'Y') THEN
          CALL LENSTR_BL(STR,NL)
          IF(NL.LE.0) THEN
            NL  = 1
            STR = ' '
          ELSE
            IF(NL.GT.256) NL = 256
          ENDIF
          M = 0
          CALL MSGDOC(M,STR(1:NL))
        ENDIF

      ENDIF

C      IF(BATCH_FILE.GT.0.AND.IWB.GT.0) THEN
C       write to batch file
C        CALL LENSTR_BL(STR,NL)
C        IF(NL.LE.0) THEN
C          NL  = 1
C          STR = '#'
C        ELSE
C          IF(NL.GT.256) NL = 256
C        ENDIF
c        WRITE(BATCH_FILE,'(A)',ERR=10) STR(1:NL)
C      ENDIF
C
C      IF(IWD.GT.0) THEN
C        CALL LENSTR_BL(STR,NL)
C        IF(NL.LE.0) THEN
C          NL  = 1
C          STR = ' '
C        ELSE
C          IF(NL.GT.256) NL = 256
C        ENDIF
C        CALL MSGDOC(M,STR(1:NL))
C      ENDIF
C ---
      RETURN
 10   CONTINUE
      CALL MSGERR(M,' ERROR: writing to batch file')
C      CALL FINISH
      STOP
 1020 CONTINUE
      CLOSE(IUNIT_KEY) 
      CALL MSGERR(M,' ERROR: reading keyword file')
C      CALL FINISH
      STOP
 1030 CONTINUE 
      CALL MSGERR(M,' ERROR: reading input stream')
C      CALL FINISH
      STOP
 1040 CONTINUE 
      CALL MSGERR(M,' ERROR: end of input stream')
C      CALL FINISH
      STOP
      END

C ******
      SUBROUTINE ASK(LINE)
C
C -P- ASK - write key_word (input LINE) and get the default (output LINE).
C
      CHARACTER LINE*(*)
C ******
C ---
      PARAMETER ( KEY_MAX = 150 )
      COMMON/COMASK/ IEND,NKEY,FLAG,STOR,STOR_KEY 
     *              ,VCCP4,FILE_KEY_INP,KEY_INF
      CHARACTER VCCP4*1,FILE_KEY_INP*256,KEY_INF*1
      INTEGER*4 FLAG(KEY_MAX),IEND,NKEY
      CHARACTER STOR(KEY_MAX)*256,STOR_KEY(KEY_MAX)*11
      COMMON/COMASK2/ NKEY_TEST,KEY_TEST
      INTEGER*4 NKEY_TEST
      CHARACTER KEY_TEST(KEY_MAX)*11
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*512
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ---
      
      INTEGER*4 NL,NLA,NLK
      CHARACTER STR*256,KEYR*12,KEY*12,ANS*256
C ---------------------------------------------------------
      MDOC=0
      IF(VCCP4.EQ.'C'.AND.KEY_INF.NE.'Y') MDOC = 99
      IF(VCCP4.EQ.'I') MDOC = 99

      CALL LENSTR_BL(LINE,NLK)
      IF(NLK.GT.11) NLK=11
      
C     get keyword from input line
      IF(NLK.GE.1) THEN
        IF(LINE(NLK:NLK).EQ.':') THEN
          LINE(NLK:NLK)=' '
          NLK = NLK-1
        ENDIF
      ENDIF

      IF(NLK.GE.1) THEN
        KEY = '_'//LINE(1:NLK)
        NLK = NLK+1
      ELSE
        KEY = ' '
        NLK = 1
      ENDIF

      CALL CHECK_LINE(1,KEY)
C     now KEY is keyword      

      CALL LENSTR_BL(LINE,NL)
      IF(NL.GT.254) NL = 254
      IF(NL.LE.0) THEN
        LINE(1:1) = ' '
        NL        = 1
      ENDIF

      NL          = NL + 1
      LINE(NL:NL) = ':'

      IF(IBATCH.EQ.0) THEN
C       display keyword and ask parameters in iteractive mode

        IF(BAT_MODE.EQ.0) CALL DISPL_BL(LINE(1:NL))

      ENDIF
C ---
      IF(NLK.GT.1.AND.IBATCH.GT.0) THEN
C       not iterractive mode
C       search KEY in array of stored kewords STOR_KEY

        DO K=1,KEY_MAX
          IF(FLAG(K).GT.0) THEN
            CALL LENSTR_BL(STOR_KEY(K),NLSK)
            IF(NLSK.EQ.NLK.AND.KEY(1:NLK).EQ.STOR_KEY(K)(1:NLK))THEN
              ANS = STOR(K)
              CALL LENSTR_BL(ANS,NLA)
C             FLAG(K) = 0
              FLAG(K) = -1
              NKEY    = NKEY-1
              GO TO 200
            ENDIF
          ENDIF
        ENDDO

      ENDIF

            
 100  CONTINUE
      IF(IEND.GT.0) THEN
        IT = 2*KEY_MAX 
        IF(IEND.GT.IT) GO TO 20
        ANS(1:12) = ',,,,,,,,,,,,'
        NLA       = 12
        LINE      = ANS(1:NLA)
        IEND      = IEND + 1
        RETURN
      ENDIF

      LINE=' '
      READ(*,'(A)',ERR=10,END=20) LINE
      CALL LENSTR_BL(LINE,NLA)
      IF(NLA.GT.255) NLA = 255
      IF(NLA.LE.0) THEN
        LINE(1:12) = ',,,,,,,,,,,,'
        NLA        = 12
      ENDIF

      ANS=LINE(1:NLA)

      IF(ANS(1:4).EQ.'_END'.OR.ANS(1:4).EQ.'_end') THEN
        IEND = IEND + 1
        GO TO 100
      ENDIF

      IF(BAT_MODE.EQ.1) THEN
c       M = 1
        IF(VCCP4.EQ.'C'.AND.KEY_INF.NE.'Y') M = 99
        IF(VCCP4.EQ.'I') M = 99
        IF(NLA.GT.0) CALL MSGDOC(M,LINE(1:NLA))
      ENDIF

 200  CONTINUE

      IF(ANS(1:1).EQ.'#') THEN
C       write to batch file
        IF(BATCH_FILE.GT.0) THEN
          WRITE(BATCH_FILE,'(A)') ANS(1:NLA)
        ENDIF
        GO TO 100
      ENDIF

      IF(NLK.GT.1.AND.ANS(1:1).EQ.'_') THEN
C       IBATCH = 1
        NLKR   = 0
        IF(NLA.GT.0) THEN
          DO I=1,NLA
            IF(ANS(I:I).NE.' ') THEN
              KEYR(I:I) = ANS(I:I)
              NLKR      = NLKR + 1
            ELSE
              GO TO 300
            ENDIF
          ENDDO
        ENDIF
 300    CONTINUE

C       IF(NLA.GE.NLK) THEN
C       KEYR = ANS(1:NLK)
          CALL CHECK_LINE(1,KEYR)
          IF(KEY(1:NLK).NE.KEYR(1:NLKR)) THEN
            DO K=1,KEY_MAX
              IF(FLAG(K).EQ.0) THEN
                IF(NLA.GT.NLKR) THEN
                  STOR(K)     = KEYR(1:NLKR)//' '//ANS(NLKR+2:NLA)
                  STOR_KEY(K) = KEYR(1:NLKR)
                ELSE
                  STOR(K)     = KEYR(1:NLKR)//'   '
                  STOR_KEY(K) = KEYR(1:NLKR)
                ENDIF
                FLAG(K) = 1
                NKEY    = NKEY + 1
                GO TO 100  
              ENDIF
            ENDDO
            GO TO 100
          ENDIF
C       ENDIF
        N= NLA - (NLKR+1)
        IF(N.LE.0) THEN
          ANS(1:12) = ',,,,,,,,,,'
          N         = 12
        ELSE
          K1       = NLKR+2
          K2       = K1 +N - 1
          ANS(1:N) = ANS(K1:K2)
        ENDIF
        NLA = N
      ENDIF
      
C -----
C     remove first blancs from answer string      
      J   = 0
      IFL = 0
      DO I=1,NLA
        IF(IFL.NE.0.OR.ANS(I:I).NE.' ') THEN
          J        = J+1
          IFL      = 1
          ANS(J:J) = ANS(I:I)
        ENDIF            
      ENDDO
      NLA     = J
      NLA_ANS = NLA
C ---
C     put several symbols ',' in the end of answer string 
      LINE    = ANS(1:NLA)
      IF(NLA.LE.245) THEN
        NLA               = NLA+6
        LINE(NLA+1:NLA+6) = ',,,,,,'
      ENDIF
      IF(BATCH_FILE.GT.0.AND.IEND.EQ.0) THEN
C       write to batch file
        IF(NLK.GT.1) THEN
          WRITE(BATCH_FILE,'(A)',ERR=30)
     *     KEY(1:NLK)//' '//ANS(1:NLA_ANS)
        ELSE
          WRITE(BATCH_FILE,'(A)',ERR=30) ANS(1:NLA_ANS)
        ENDIF
      ENDIF
C ---
      RETURN
C ---------------------------------------------------------
 10   CALL MSGERR(MDOC,' ERROR: read input stream')
      GO TO 1000
 20   CALL MSGERR(MDOC,' ERROR: end of input stream')
      GO TO 1000
 30   CALL MSGERR(MDOC,' ERROR: write to batch file')
 1000 CALL FINISH
      END

      SUBROUTINE INIT_DEFAULTS
C -----------------------------------------------------
      PARAMETER ( KEY_MAX = 150 )
C -----
      COMMON/COMASK/ IEND,NKEY,FLAG,STOR,STOR_KEY 
     *              ,VCCP4,FILE_KEY_INP,KEY_INF
      CHARACTER VCCP4*1,FILE_KEY_INP*256,KEY_INF*1
      INTEGER*4 FLAG(KEY_MAX),IEND,NKEY
      CHARACTER STOR(KEY_MAX)*256,STOR_KEY(KEY_MAX)*11
C --
      COMMON/COMASK2/ NKEY_TEST,KEY_TEST
      INTEGER*4 NKEY_TEST
      CHARACTER KEY_TEST(KEY_MAX)*11
C ---
C ------------------------------------------------------
      CALL SET_BYTE
C --
      IEND           = 0
      NKEY           = 0
      NKEY_TEST      = 0
      FILE_KEY_INP   = ' '
      KEY_INF        = ' '
      VCCP4          = ' '
C --
      DO I=1,KEY_MAX
        FLAG(I) = 0
      ENDDO
C -----------------------
      RETURN
      END

      SUBROUTINE SET_VCCP4_TO_COMASK(VCCP4_INP,FILE_KEY,KEY_INF_INP)
C -----------------------------------------------------
      PARAMETER ( KEY_MAX = 150 )
C -----
      COMMON/COMASK/ IEND,NKEY,FLAG,STOR,STOR_KEY 
     *              ,VCCP4,FILE_KEY_INP,KEY_INF
      CHARACTER VCCP4*1,FILE_KEY_INP*256,KEY_INF*1
      INTEGER*4 FLAG(KEY_MAX),IEND,NKEY
      CHARACTER STOR(KEY_MAX)*256,STOR_KEY(KEY_MAX)*11
C --
      CHARACTER FILE_KEY*(*),VCCP4_INP*1,KEY_INF_INP*1
C ------------------------------------------------------
      FILE_KEY_INP   = FILE_KEY
      VCCP4          = VCCP4_INP
      KEY_INF        = KEY_INF_INP
C -----------------------
      RETURN
      END

C ******
      SUBROUTINE START(IG,MDOC,PROG,PATH_OUT)
C
C -P- START - initialization common/COMLIB/,/CRYSTL/,.., open DOC-file.
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*512
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ------
      PARAMETER ( KEY_MAX = 150 )
      COMMON/COMASK/ IEND,NKEY,FLAG,STOR,STOR_KEY 
     *              ,VCCP4,FILE_KEY_INP,KEY_INF  
      CHARACTER VCCP4*1,FILE_KEY_INP*256,KEY_INF*1
      INTEGER*4 FLAG(KEY_MAX),IEND,NKEY
      CHARACTER STOR(KEY_MAX)*256,STOR_KEY(KEY_MAX)*11
      COMMON/COMASK2/ NKEY_TEST,KEY_TEST
      INTEGER*4 NKEY_TEST
      CHARACTER KEY_TEST(KEY_MAX)*11
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
C ------------------------------------------------------------------------
C ------------------------------------------------------------
C ---
      COMMON/COMWRF/ A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
     *              ,RN_WR,RX_WR,CF_WR,TF_WR
     *              ,NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
     *              ,NS_WR,IS_WR,IER_WR,IEN_WR
     *              ,TP_WR,T1_WR,T2_WR,TL_WR,DT_WR
     *              ,CD_WR,SG_WR,PT_WR,PD_WR
      REAL A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
      REAL RN_WR,RX_WR,CF_WR,TF_WR
      INTEGER*4 NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
      INTEGER*4 NS_WR,IS_WR,IER_WR,IEN_WR
      CHARACTER TP_WR*4,T1_WR*4,T2_WR*4,TL_WR*80,DT_WR*20     
      CHARACTER CD_WR*4,SG_WR*24,PT_WR*40,PD_WR*9
C ---
      COMMON/COMRDF/ A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
     *              ,RN_RD,RX_RD,CF_RD,TF_RD
     *              ,NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
     *              ,NS_RD,IS_RD,IER_RD,IEN_RD
     *              ,TP_RD,T1_RD,T2_RD,TL_RD,DT_RD
     *              ,CD_RD,SG_RD,PT_RD,PD_RD
      REAL A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
      REAL RN_RD,RX_RD,CF_RD,TF_RD
      INTEGER*4 NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
      INTEGER*4 NS_RD,IS_RD,IER_RD,IEN_RD
      CHARACTER TP_RD*4,T1_RD*4,T2_RD*4,TL_RD*80,DT_RD*20     
      CHARACTER CD_RD*4,SG_RD*24,PT_RD*40,PD_RD*9
C ---
C ---
      INCLUDE 'mr_crd_com.fh'
C ---
      INCLUDE 'mr_crd2_com.fh'
C ------------------------------------------------------------
C -------------------------------------------------
      REAL AM(3,3),TRN(3)
      INTEGER NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
      CHARACTER NCSF*1,GID*4
C -------------------------------------------------
C ---
      INTEGER*4  MDOC,IG
      CHARACTER  PROG*(*),PATH_OUT*(*)
C ******
      INTEGER*4  M,IERR
      CHARACTER  LINE*512,PATH*80
C --------------
c     INCLUDE "temp_molrep_path.fh"
C -------------------------------------------
      PI     = 4.0*ATAN(1.0)
      IGRAPH = IG
      IFIRST = 0
C ---
C -----------------------
      CALL SET_BYTE
      IEND      = 0
      IBATCH    = 0
      NKEY      = 0
      NKEY_TEST = 0
      DO I=1,KEY_MAX
        FLAG(I)=0
      ENDDO
C ---
      CALL LENSTR_BL(PROG,LEN_PROG)
      IF(LEN_PROG.LE.0) THEN
        LEN_PROG=1
        PROG(1:1)=' '
c      ELSE IF(LEN_PROG.GT.20) THEN
c        LEN_PROG=20
      ENDIF
      PROGRAMM=PROG(1:LEN_PROG)
      IF(MDOC.GE.997) THEN
c        LINEL  =  PROG(1:LEN_PROG)
        LINEL  = 'molrep'
C        M      = -ABS(MDOC)
      ENDIF
C -------------------------------
      IF(MDOC.EQ.0) THEN
        M=0
      ELSE IF(MDOC.GE.997) THEN
C       M=999       
        M=MDOC       
      ELSE IF(MDOC.LE.-997) THEN
        M=0
      ELSE IF(MDOC.LT.0) THEN
        M=-48
        IF(MDOC.LE.-99) M=-99
      ELSE IF(MDOC.GT.0) THEN
        M= 48
        IF(MDOC.GE.99) M=99
      ENDIF
      CALL OPENDOC(M,PATH_OUT)

      IF(M.EQ.0) MDOC=0

      MDOC=ABS(MDOC)
      IF(MDOC.GE.997) THEN
        MDOC=1
      ENDIF
C ---
      A_CELL=1.0
      B_CELL=1.0
      C_CELL=1.0
      AL_CELL   = PI/2.0
      BE_CELL   = PI/2.0
      GA_CELL   = PI/2.0
      DO I=1,80
        USER_TITLE(I:I)  = ' '
      ENDDO
      DO I=1,40
        PDB_NAME(I:I)       = ' '
      ENDDO
      PDB_NAME(1:13)  = 'XXXXXXXX    ?'
      PDB_DATE  = 'XX-XXX-XX'
      PDB_CODE  = 'XXXX'
      PDB_RESL  = '.'
      PDB_RFAC  = '.'
      USER_TITLE(1:9)  = '?   ?   ?'
      USER_TITLE(69:78)= '?   ?   '
      NSP_GROUP = 1
      N_SETT   = 1
      SP_GROUP = 'P 1        '
      CR_TITLE    = USER_TITLE
      CR2_TITLE   = USER_TITLE
      CR3_TITLE   = USER_TITLE
      TL_WR       = USER_TITLE
      TL_RD       = USER_TITLE
      CR_NAME_PDB  = PDB_NAME
      CR2_NAME_PDB = PDB_NAME
      CR3_NAME_PDB = PDB_NAME
      PT_WR        = PDB_NAME
      PT_RD        = PDB_NAME
      NCS=0
      CALL SET_NCS(MDOC,NMAX,NCS,AM,TRN,IERR)
      IGR=0
      CALL SET_ASYMM(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *                    ,NCSF,GID,IERR)
      NCS=0
      CALL SET_NCS2(MDOC,NMAX,NCS,AM,TRN,IERR)
      IGR=0
      CALL SET_ASYM2(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *                    ,NCSF,GID,IERR)
      NCS=0
      CALL SET_NCS3(MDOC,NMAX,NCS,AM,TRN,IERR)
      IGR=0
      CALL SET_ASYM3(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *                    ,NCSF,GID,IERR)
      NCSOP    = 0
      N_GROUP  = 0   
      N_CHAIN  = 0
C --- 
      A_WR   = 1.0
      B_WR   = 1.0
      C_WR   = 1.0
      AL_WR  = PI/2.0
      BE_WR  = PI/2.0
      GA_WR  = PI/2.0
      RN_WR  = 0.0
      RX_WR  = 0.0
      CF_WR  = 1.0
      TF_WR  = 0.0
      NX_WR  = 0
      NY_WR  = 0
      NZ_WR  = 0
      IN_WR  = 0
      IM_WR  = 0
      NS_WR  = 1
      IS_WR  = 1
      IER_WR = 0
      IEN_WR = 0
      TP_WR  =' '
      T1_WR  ='?   '
      T2_WR  ='?   '
      NS_WR  = NSP_GROUP
      IS_WR  = N_SETT
      IER_WR = 0
      IEN_WR = 0
      CD_WR  = PDB_CODE
      SG_WR  = SP_GROUP
      PD_WR  = PDB_DATE
C --------------------
C -----------------------------------------------
C ----- PDB --------------------
      CR_TEMPER     = 0.0
      CR_WAVEL      = 0.0
      CR_RES_MIN    = 0.0
      CR_RES_MAX    = 0.0
      CR_RFAC_ALL   = 0.0
      CR_RFAC_OBS   = 0.0
      CR_SIGMA_I    = 0.0
      CR_SIGMA_F    = 0.0
      CR_CD_NDB     = '?'
      CR_CD_CSD     = '?'
      CR_DATE_NDB   = '?'
      CR_DATE_CREAT = '?'
      CR_PROGRAM    = '?'
      CR_METHOD     = '?'
C -----------------------------------------------
C ----- PDB 2 --------------------
      CR_RFAC_CUT     = 0.0
      CR_NMODEL       = 0
      CR_RMEGR_ALL    = 0.0
      CR_RMERG_OBS    = 0.0
      CR_RMERG_IOBS   = 0.0
      CR_RES_RMIN     = 0.0
      CR_RES_RMAX     = 0.0
      CR_SIGMAR_I     = 0.0
      CR_SIGMAR_F     = 0.0
      CR_RFREE_ALL    = 0.0
      CR_RFREE_OBS    = 0.0
      CR_RFREE_CUT    = 0.0
      CR_DPI          = 0.0
      CR_ERR_CRD_MIN  = 0.0
      CR_ERR_CRD_MAX  = 0.0
      CR_NDB_TITLE    = '?'
      CR_NDB_NAME     = '?'
      CR_INFO_FLAG    = '?'
C------------------------------------------
C------------------------------------------
C ---
      CR_CELL(1)=1.0
      CR_CELL(2)=1.0
      CR_CELL(3)=1.0
      CR_CELL(4)=PI/2.0
      CR_CELL(5)=PI/2.0
      CR_CELL(6)=PI/2.0
      CR_SCALE(1,1)=1.0
      CR_SCALE(1,2)=0.0
      CR_SCALE(1,3)=0.0
      CR_SCALE(2,1)=0.0
      CR_SCALE(2,2)=1.0
      CR_SCALE(2,3)=0.0
      CR_SCALE(3,1)=0.0
      CR_SCALE(3,2)=0.0
      CR_SCALE(3,3)=1.0
      CR_U(1)      =0.0
      CR_U(2)      =0.0
      CR_U(3)      =0.0
      CR_CF1 = 0.0
      CR_CF2 = 0.0
      CR_TOV = 0.0
      CR_ORT_TO_FRAC(1,1)=1.0
      CR_ORT_TO_FRAC(1,2)=0.0
      CR_ORT_TO_FRAC(1,3)=0.0
      CR_ORT_TO_FRAC(2,1)=0.0
      CR_ORT_TO_FRAC(2,2)=1.0
      CR_ORT_TO_FRAC(2,3)=0.0
      CR_ORT_TO_FRAC(3,1)=0.0
      CR_ORT_TO_FRAC(3,2)=0.0
      CR_ORT_TO_FRAC(3,3)=1.0
      CR_FRAC_TO_ORT(1,1)=1.0
      CR_FRAC_TO_ORT(1,2)=0.0
      CR_FRAC_TO_ORT(1,3)=0.0
      CR_FRAC_TO_ORT(2,1)=0.0
      CR_FRAC_TO_ORT(2,2)=1.0
      CR_FRAC_TO_ORT(2,3)=0.0
      CR_FRAC_TO_ORT(3,1)=0.0
      CR_FRAC_TO_ORT(3,2)=0.0
      CR_FRAC_TO_ORT(3,3)=1.0
      CR_DATE_PDB = PDB_DATE
      CR_CD_PDB   = PDB_CODE
      CR_RFAC_PDB = '.'
      CR_RESL_PDB = '.'
      CR_TIME     = ' '
      CR_FLAG_HA  = 'N'
      CR_FLAG_USER= 'N'
      CR_MODEL    = 0
      CR_NSPGR    = 1
      CR_SETT     = 1
      CR_SPGR     = SP_GROUP
      CR_PDB_REC  ='.'
      CR_NSYM     = 1
      CR_NCS      = 0
      CR_SYMOP    = 'X,Y,Z'
      CR_IATOM    =0
      CR_IRES     =0
      CR_IATOLD   =0
      CR_IGROUP   =0
      CR_MULT_FLAG=0
      CR_MULT_FACTOR=1
      CR_RTYPE    = '.'
      CR_ATYPE    = '.'
      CR_TERM     = '.'
      CR_RNAME    = '.'
      CR_ANAME    = '.'
      CR_CHAIN    = '. '
      CR_GROUP    = '.   '
      CR_BTYPE    = 'I'
      CR_FSC      ='.'
      CR_FSA      ='.'
      CR_SURF     = 0.0
      CR_SEG      = '.'
      CR_LINE     = ' '
      CR_LINE2    = ' '
C -CR2-
C ---
      CR2_CELL(1)=1.0
      CR2_CELL(2)=1.0
      CR2_CELL(3)=1.0
      CR2_CELL(4)=PI/2.0
      CR2_CELL(5)=PI/2.0
      CR2_CELL(6)=PI/2.0
      CR2_SCALE(1,1)=1.0
      CR2_SCALE(1,2)=0.0
      CR2_SCALE(1,3)=0.0
      CR2_SCALE(2,1)=0.0
      CR2_SCALE(2,2)=1.0
      CR2_SCALE(2,3)=0.0
      CR2_SCALE(3,1)=0.0
      CR2_SCALE(3,2)=0.0
      CR2_SCALE(3,3)=1.0
      CR2_U(1)      =0.0
      CR2_U(2)      =0.0
      CR2_U(3)      =0.0
      CR2_CF1 = 0.0
      CR2_CF2 = 0.0
      CR2_TOV = 0.0
      CR2_ORT_TO_FRAC(1,1)=1.0
      CR2_ORT_TO_FRAC(1,2)=0.0
      CR2_ORT_TO_FRAC(1,3)=0.0
      CR2_ORT_TO_FRAC(2,1)=0.0
      CR2_ORT_TO_FRAC(2,2)=1.0
      CR2_ORT_TO_FRAC(2,3)=0.0
      CR2_ORT_TO_FRAC(3,1)=0.0
      CR2_ORT_TO_FRAC(3,2)=0.0
      CR2_ORT_TO_FRAC(3,3)=1.0
      CR2_FRAC_TO_ORT(1,1)=1.0
      CR2_FRAC_TO_ORT(1,2)=0.0
      CR2_FRAC_TO_ORT(1,3)=0.0
      CR2_FRAC_TO_ORT(2,1)=0.0
      CR2_FRAC_TO_ORT(2,2)=1.0
      CR2_FRAC_TO_ORT(2,3)=0.0
      CR2_FRAC_TO_ORT(3,1)=0.0
      CR2_FRAC_TO_ORT(3,2)=0.0
      CR2_FRAC_TO_ORT(3,3)=1.0
      CR2_DATE_PDB = PDB_DATE
      CR2_CD_PDB   = PDB_CODE
      CR2_RFAC_PDB = '.'
      CR2_RESL_PDB = '.'
      CR2_TIME     = ' '
      CR2_FLAG_HA  = 'N'
      CR2_FLAG_USER= 'N'
      CR2_MODEL    = 0
      CR2_NSPGR    = 1
      CR2_SETT     = 1
      CR2_SPGR     = SP_GROUP
      CR2_PDB_REC  ='.'
      CR2_NSYM     = 1
      CR2_NCS      = 0
      CR2_SYMOP    = 'X,Y,Z'
      CR2_IATOM    =0
      CR2_IRES     =0
      CR2_IATOLD   =0
      CR2_IGROUP   =0
      CR2_MULT_FLAG=0
      CR2_MULT_FACTOR=1
      CR2_RTYPE    = '.'
      CR2_ATYPE    = '.'
      CR2_TERM     = '.'
      CR2_RNAME    = '.'
      CR2_ANAME    = '.'
      CR2_CHAIN    = '. '
      CR2_GROUP    = '.   '
      CR2_BTYPE    = 'I'
      CR2_FSC      ='.'
      CR2_FSA      ='.'
      CR2_SURF     = 0.0
      CR2_SEG      = '.'
      CR2_LINE     = ' '
      CR2_LINE2    = ' '
C --------------------------------
C -CR3-
C ---
      CR3_CELL(1)=1.0
      CR3_CELL(2)=1.0
      CR3_CELL(3)=1.0
      CR3_CELL(4)=PI/2.0
      CR3_CELL(5)=PI/2.0
      CR3_CELL(6)=PI/2.0
      CR3_SCALE(1,1)=1.0
      CR3_SCALE(1,2)=0.0
      CR3_SCALE(1,3)=0.0
      CR3_SCALE(2,1)=0.0
      CR3_SCALE(2,2)=1.0
      CR3_SCALE(2,3)=0.0
      CR3_SCALE(3,1)=0.0
      CR3_SCALE(3,2)=0.0
      CR3_SCALE(3,3)=1.0
      CR3_U(1)      =0.0
      CR3_U(2)      =0.0
      CR3_U(3)      =0.0
      CR3_CF1 = 0.0
      CR3_CF2 = 0.0
      CR3_TOV = 0.0
      CR3_ORT_TO_FRAC(1,1)=1.0
      CR3_ORT_TO_FRAC(1,2)=0.0
      CR3_ORT_TO_FRAC(1,3)=0.0
      CR3_ORT_TO_FRAC(2,1)=0.0
      CR3_ORT_TO_FRAC(2,2)=1.0
      CR3_ORT_TO_FRAC(2,3)=0.0
      CR3_ORT_TO_FRAC(3,1)=0.0
      CR3_ORT_TO_FRAC(3,2)=0.0
      CR3_ORT_TO_FRAC(3,3)=1.0
      CR3_FRAC_TO_ORT(1,1)=1.0
      CR3_FRAC_TO_ORT(1,2)=0.0
      CR3_FRAC_TO_ORT(1,3)=0.0
      CR3_FRAC_TO_ORT(2,1)=0.0
      CR3_FRAC_TO_ORT(2,2)=1.0
      CR3_FRAC_TO_ORT(2,3)=0.0
      CR3_FRAC_TO_ORT(3,1)=0.0
      CR3_FRAC_TO_ORT(3,2)=0.0
      CR3_FRAC_TO_ORT(3,3)=1.0
      CR3_DATE_PDB = PDB_DATE
      CR3_CD_PDB   = PDB_CODE
      CR3_RFAC_PDB = '.'
      CR3_RESL_PDB = '.'
      CR3_TIME     = ' '
      CR3_FLAG_HA  = 'N'
      CR3_FLAG_USER= 'N'
      CR3_MODEL    = 0
      CR3_NSPGR    = 1
      CR3_SETT     = 1
      CR3_SPGR     = SP_GROUP
      CR3_PDB_REC  ='.'
      CR3_NSYM     = 1
      CR3_NCS      = 0
      CR3_SYMOP    = 'X,Y,Z'
      CR3_IATOM    =0
      CR3_IRES     =0
      CR3_IATOLD   =0
      CR3_IGROUP   =0
      CR3_MULT_FLAG=0
      CR3_MULT_FACTOR=1
      CR3_RTYPE    = '.'
      CR3_ATYPE    = '.'
      CR3_TERM     = '.'
      CR3_RNAME    = '.'
      CR3_ANAME    = '.'
      CR3_CHAIN    = '. '
      CR3_GROUP    = '.   '
      CR3_BTYPE    = 'I'
      CR3_FSC      ='.'
      CR3_FSA      ='.'
      CR3_SURF     = 0.0
      CR3_SEG      = '.'
      CR3_LINE     = ' '
      CR3_LINE2    = ' '
C --------------------------------
      A_RD   = 1.0
      B_RD   = 1.0
      C_RD   = 1.0
      AL_RD  = PI/2.0
      BE_RD  = PI/2.0
      GA_RD  = PI/2.0
      RN_RD  = 0.0
      RX_RD  = 0.0
      CF_RD  = 1.0
      TF_RD  = 0.0
      NX_RD  = 0
      NY_RD  = 0
      NZ_RD  = 0
      IN_RD  = 0
      IM_RD  = 0
      NS_RD  = 1
      IS_RD  = 1
      IER_RD = 0
      IEN_RD = 0
      TP_RD  =' '
      T1_RD  ='?   '
      T2_RD  ='?   '
      NS_RD  = NSP_GROUP
      IS_RD  = N_SETT
      IER_RD = 0
      IEN_RD = 0
      CD_RD  = PDB_CODE
      SG_RD  = SP_GROUP
      PT_RD  = PDB_NAME
      PD_RD  = PDB_DATE
C ---
      CALL REPCELL(IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,
     * ' WARNING: determinant of matrix "Frac-to-Orth" = 0')
      ENDIF
C ---
C ================================================================
      CALL WRT_BATCH('# --------------------------------')

c      CALL LENSTR_BL(MOLREPLIB,LEN_P)
c      PATH  = MOLREPLIB
c      PATH  = PATH(1:LEN_P)//'/bin/'
c      LEN_P = LEN_P+5
C      LINE  = PATH(1:LEN_P)//PROGRAMM(1:LEN_PROG)//' <<stop'

      CALL LENSTR_BL(PROG,LEN_PROG)
      LINE  = PROG(1:LEN_PROG)//' <<stop'

c      LINE  = PROGRAMM(1:LEN_PROG)//' <<stop'

C
C      LINE='$BLANC/exe/'//PROGRAMM(1:LEN_PROG)//' <<stop'
C
      CALL WRT_BATCH(LINE)
      CALL WRT_BATCH('# --------------------------------')
c      CALL WRT_BATCH('# first line must be :   "_DOC "')
c      LINE=
c     *'#   N - means without DOC-file: "molrep.doc"'
c      CALL WRT_BATCH(LINE)
c      CALL WRT_BATCH(
c     *'#   Y - create new file or rewrite if it is old file')
c      CALL WRT_BATCH(
c     *'#   A - means to keep old contents and add new information')
c      CALL WRT_BATCH('#  ')
c      CALL WRT_BATCH('_DOC  Y')
c      CALL WRT_BATCH('#  ')
C ================================================================
      RETURN
      END          

C ******
      SUBROUTINE OPENDOC(MMDOC,PATH_OUT)
C
C -P- OPENDOC   open file-document iunit=DOC_FILE  =48
C                and file-inbatch  iunit=BATCH_FILE=47
C 
C     input :    MMDOC > 0  open, get name from terminal 
C                MMDOC < 0  open, get name from /COMLIB/..,LINEL,..  
C     output:    MMDOC , =0 don't open
C
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*512
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ---
      INTEGER*4  MMDOC,MDOC
C ******
      CHARACTER  PATH_OUT*(*)
      CHARACTER  NAME1*256,MSG*1,MSG4*1,FNAME*256,CH1*1,TYPE*1
      CHARACTER  NAMEB*256,NAME*256,PATH*1,EXT*1
      CHARACTER  LINE*256

CMS   LOGICAL*2  EXI

      LOGICAL    EXI
C ---------------------------------------------------------------------
      M          = 99
      IERR       = 0
      PATH       = ' '
      EXT        = ' '
C ---
      DOC_FILE   = 0
      BATCH_FILE = 0
      BAT_MODE   = 0
  10  CONTINUE
      MDOC = MMDOC      
      IF(MDOC.GE.997) THEN
        NAME1 = LINEL
        IF(MDOC.EQ.997) NAME1='#'
      ELSE
        IF(MDOC.EQ.0.OR.ABS(MDOC).GE.99) RETURN
        DOC_FILE=ABS(MDOC)
        NAME1=' '
        IF(MDOC.GT.0) THEN
          WRITE(*,*) 
          CALL DISPL_BL(
     *    'FILE-DOCUMENT / tape name or CR / :')
          READ(*,'(A)')  NAME1
        ELSE
          NAME1=LINEL
        ENDIF
      ENDIF
  11  CH1=NAME1(1:1)

      CALL LENSTR_BL(NAME1,LEN)

      CALL CHKSMB(CH1,TYPE)
      IF(TYPE.EQ.'?'.OR.CH1.EQ.' '.OR.CH1.EQ.',') THEN
        NAME1(1:1)=' '
      ENDIF
      CALL LENSTR_BL(NAME1,LEN)
      IF(NAME1(1:1).EQ.'#') THEN
        IF(MDOC.GT.0) THEN
          READ(*,'(A)')  NAME1
          GO TO 11           
        ELSE
          DOC_FILE   = 0
          MDOC       = 0
          BATCH_FILE = 0
          MMDOC      = MDOC
          RETURN
        ENDIF
      ENDIF

      IF(NAME1(1:1).EQ.'_') THEN
        IF(NAME1(1:4).EQ.'_DOC') THEN
C
C         IBATCH  =1
C
          BAT_MODE=1
          CALL LENSTR_BL(NAME1,LEN)

          LLL = 0
          IF(LEN.GE.6) THEN
            J   =0
            LINE=' '
            DO I=6,LEN
              IF(NAME1(I:I).NE.' ') THEN
                LLL = I
                GO TO 40
              ENDIF
            ENDDO
  40        CONTINUE
            IF(LLL.GT.0) THEN
              NAME1 = NAME1(LLL:LEN)
              LEN   = LEN - LLL + 1
              LINE  = NAME1
              IF(LINE(1:1).NE.'>'.AND.LEN.GT.1) THEN
                LINE = LINE(2:LEN)
                LEN  = LEN - 1
              ENDIF
              CALL GET_PATH_OUT(LINE,PATH_OUT)
            ELSE
              NAME1(1:1) = ' '
            ENDIF

            IF(MDOC.EQ.997) THEN
            IF(NAME1(1:1).EQ.'N'.OR.NAME1(1:1).EQ.'n') THEN
              MMDOC=0
              RETURN
            ELSE IF(NAME1(1:1).EQ.'Y'.OR.NAME1(1:1).EQ.'y') THEN
              MDOC =999
              MMDOC=999
c              NAME1=PROGRAMM
              NAME1='molrep'
            ELSE IF(NAME1(1:1).EQ.'A'.OR.NAME1(1:1).EQ.'a') THEN
              MDOC =998
              MMDOC=998
c              NAME1=PROGRAMM
              NAME1='molrep'
            ENDIF
            ENDIF
          ELSE
            NAME1=' '
          ENDIF
        ENDIF
      ENDIF

      IF(NAME1(1:1).NE.' ') THEN
C --
        CALL LENSTR_BL(NAME1,LEN)
        IF(LEN.GT.0.AND.NAME1(1:1).NE.','.AND.NAME1(1:1).NE.' ') THEN
          NAME=NAME1(1:LEN)
          DO I=LEN,1,-1
            IF(NAME(I:I).EQ.',') THEN
              NAME(I:I)=' '
            ELSE
              IF(NAME(I:I).NE.' ') GO TO 800
            ENDIF 
          ENDDO
 800      CONTINUE
          LINE = NAME
          CALL LENSTR_BL(LINE,LEN)
          IF(LEN.GT.4.AND.LINE(LEN-3:LEN).EQ.'.doc') THEN
            NAME1=LINE(1:LEN-4)
          ENDIF
        ENDIF
C -------

        CALL LENSTR_BL(NAME1,NL)

        FNAME=NAME1(1:NL)//'.doc'
        CALL ADD_PATH(PATH_OUT,FNAME)
        NAMEB=NAME1(1:NL)//'.btc'
        CALL ADD_PATH(PATH_OUT,NAMEB)

        IF(MDOC.GT.0) THEN   

        INQUIRE(FILE=FNAME,EXIST=EXI)
        IF(EXI) THEN
          DOC_FILE=48

C          OPEN(UNIT=DOC_FILE,FILE=FNAME,ACCESS='SEQUENTIAL',ERR=20,
C     *         STATUS='OLD',FORM='FORMATTED') 

          CALL OPENFW(DOC_FILE,M,PATH,FNAME,EXT,IERR)
          IF(IERR.NE.0) GO TO 20

 50       CONTINUE
          IF(MMDOC.GE.998) THEN
C do not keep old contents : LINE(1:1)='N'
            LINE(1:1)='N'
            IF(MMDOC.EQ.998) LINE(1:1)='Y'
          ELSE
            CALL DISPL_BL(
     *      'Do you want to keep old contents (<Y>,N) ? :')
            READ(*,'(A)') LINE
          ENDIF
          IF(LINE(1:1).EQ.'_') THEN
            IF(LINE(1:5).EQ.'_KEEP') THEN
              CALL LENSTR_BL(LINE,LEN)
              IF(LEN.GE.7) THEN
                J=0
                DO I=7,LEN
                 IF(LINE(I:I).NE.' ') THEN
                   J=J+1
                   LINE(J:J)=LINE(I:I)
                   GO TO 100 
                 ENDIF
                ENDDO
              ENDIF
            ENDIF
          ENDIF
 100      CONTINUE
          MSG=LINE(1:1)
          IF(MSG.EQ.'#') GO TO 50
          IF(MSG.EQ.'n') MSG='N'
          IF(MSG.EQ.'N') THEN
            REWIND DOC_FILE
          ELSE
C            DO   I=1,32767
            DO   I=1,1000000
              READ(DOC_FILE,'(A)',END=45) LINE
            ENDDO
   45       CONTINUE             
            BACKSPACE DOC_FILE
          ENDIF 
        ELSE
   30     CONTINUE
          IF(MDOC.GE.998) THEN
            LINE(1:1)='Y'
          ELSE
            CALL DISPL_BL(
     *'Do you really want to have DOC-file (<Y>,N) ?:')
            READ(*,'(A)') LINE
          ENDIF
          IF(LINE(1:1).EQ.'_') THEN
            IF(LINE(1:5).EQ.'_KEEP') THEN
              CALL LENSTR_BL(LINE,LEN)
              IF(LEN.GE.7) THEN
                J=0
                DO I=7,LEN
                 IF(LINE(I:I).NE.' ') THEN
                   J=J+1
                   LINE(J:J)=LINE(I:I)
                   GO TO 101 
                 ENDIF
                ENDDO
              ENDIF
            ENDIF
          ENDIF
 101      CONTINUE
          MSG4=LINE(1:1)
          IF(MSG4.EQ.'#') GO TO 30
          IF(MSG4.EQ.'n') MSG4='N'
          IF(MSG4.NE.'N') THEN
            DOC_FILE=48

C            OPEN(UNIT=DOC_FILE,FILE=FNAME,ACCESS='SEQUENTIAL',ERR=20,
C     *          STATUS='UNKNOWN',FORM='FORMATTED')           

            CALL OPENFW(DOC_FILE,M,PATH,FNAME,EXT,IERR)
            IF(IERR.NE.0) GO TO 20

          ELSE 
            DOC_FILE   = 0
            MDOC       = 0
            BATCH_FILE = 0
          ENDIF 
        ENDIF

        ENDIF

      ELSE
        DOC_FILE   = 0
        MDOC       = 0
        BATCH_FILE = 0
      ENDIF

c     IF(DOC_FILE.NE.0.AND.MMDOC.NE.999) THEN

      IF(DOC_FILE.NE.0) THEN
        BATCH_FILE=47
        INQUIRE(FILE=NAMEB,EXIST=EXI)
        IF(EXI) THEN

C          OPEN(UNIT=BATCH_FILE,FILE=NAMEB,ACCESS='SEQUENTIAL',ERR=20,
C     *         STATUS='OLD',FORM='FORMATTED')           

          CALL OPENFW(BATCH_FILE,M,PATH,NAMEB,EXT,IERR)
          IF(IERR.NE.0) GO TO 20

          IF(MSG.EQ.'N') THEN
            REWIND BATCH_FILE
          ELSE  
            DO   I=1,32767
              READ(BATCH_FILE,'(A)',END=46) LINE
            ENDDO
   46       CONTINUE             
            BACKSPACE BATCH_FILE
          ENDIF
        ELSE

C          OPEN(UNIT=BATCH_FILE,FILE=NAMEB,ACCESS='SEQUENTIAL',ERR=20,
C     *         STATUS='UNKNOWN',FORM='FORMATTED')           

          CALL OPENFW(BATCH_FILE,M,PATH,NAMEB,EXT,IERR)
          IF(IERR.NE.0) GO TO 20

        ENDIF 
      ENDIF
      WRITE(*,*)
      MDOC  = ABS(MDOC)
      MMDOC = MDOC
      RETURN

   20 WRITE(*,*) ' ERROR: OPEN DOC_FILE or BATCH_FILE'
      IF(MMDOC.LT.997) GO TO 10
      RETURN
      END

C ******
      SUBROUTINE RD_INF(MDOC,NAME,RLATT,NSYM,ISYM,IPRSYM,IERR)
C
C -P- RD_INF - read information from inform-file ( UNIT=49)
C -P-          and put into common/CRYSTL/
C
C   input  : MDOC  =    0 - write messages only to termimal
C                > 0, < 99  write messages to termimal and to file-document
C                > = 99     don't write any messages 
C                < 0        write messages only to file-document
C
C            NSYM  >= 0  -  input name of inf_file from terminal.
C                 else if  < 0     get from common/COMLIB/...LINEL...      
C
C
C   output : RLATT - unit cell parameters
C            NSYM  - symmetry operators number
C                  = 0 is a signal of error. 
C            ISYM  - symmetry operators
C
C ******
C -----------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   MDOC,NSYM,IPRSYM,IERR
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RLATT(6)
C ------------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMCIF/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
      REAL      FDATA
      INTEGER*4 IDATA
      CHARACTER DATA*80,ITEM*80
C ---
      CHARACTER   TITLE*80,LINE*256,FNAME*256
      CHARACTER   PATH*1,EXT*3,SGNAME*24
      CHARACTER   CODE_PDB*4,DATE_PDB*9,NAME_PDB*40
C ---
      REAL AMR(3,3),TR(3)
C------------------------------------------------
      IERR  = 0
      PI    = 4.0*ATAN(1.0)
      TWOPI = 2.0*PI
      PI180 = PI/180.0
C------------------------------
      IS     = 0
      SGNAME = ' '
      NSG    = 0
      NSETT  = 0
      ACELL  = 0.0
      BCELL  = 0.0
      CCELL  = 0.0
      ALCELL = 0.0
      BECELL = 0.0
      GACELL = 0.0
      CODE_PDB = 'XXXX'
      DATE_PDB = 'XX-XXX-XX'
      NAME_PDB = '---'
      TITLE    = '---'
C-------------------------------------
      MTIN = 49
      M    = 99
      PATH = ' '
C --
      CALL LENSTR_BL(NAME,LEN)
      IF(LEN.GT.0.AND.NAME(1:1).NE.','.AND.NAME(1:1).NE.' ') THEN
        FNAME=NAME(1:LEN)
        DO I=LEN,1,-1
          IF(FNAME(I:I).EQ.',') THEN
            FNAME(I:I)=' '
          ELSE
            IF(FNAME(I:I).NE.' ') GO TO 800
          ENDIF 
        ENDDO
 800    CONTINUE
        LINE = FNAME
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GT.4.AND.LINE(LEN-3:LEN).EQ.'.inf') THEN
          FNAME=LINE(1:LEN-4)
        ENDIF
      ELSE
        FNAME=NAME
      ENDIF
C -------
      EXT='inf'
      CALL OPENFR(MTIN,M,PATH,FNAME,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: can''t open input INF_file')
        RETURN
      ENDIF
      MD=-1
      CALL LENSTR_BL(NAME,LEN)
      IF(LEN.GT.64) LEN=64
      WRITE(LINE,'('' INPUT-INF_FILE:'',A)') NAME(1:LEN)
      CALL MSGDOC(MD,LINE)
      IEND=-1
 100  CONTINUE
      CALL GETCIF(MTIN,MDOC,IERR,IEND)
      IF(IERR.NE.0) THEN
        CLOSE(MTIN)
        RETURN
      ENDIF
      IF(IEND.NE.0) THEN
        GO TO 200
      ENDIF

      DO I=1,N_CIF
        CALL LENSTR_BL(ITM_CIF(I),LENI) 
        ITEM = ITM_CIF(I)(1:LENI)
        CALL LENSTR_BL(DT_CIF(I),LEND) 
        DATA = DT_CIF(I)(1:LEND)
        CALL LENSTR_BL(BLK_CIF,LENB) 
        IDATA=IDT_CIF(I)
        FDATA=FDT_CIF(I)

        IF((ITEM(1:18).EQ.'_database_PDB_code').OR.         
     *     (ITEM(1:9).EQ.'_entry.id')) THEN         
          LN=LEND
          IF(LN.GT.4) LN=4
          CODE_PDB=DATA(1:LN)
        ELSE IF((ITEM(1:18).EQ.'_database_PDB_name').OR.
     *          (ITEM(1:16).EQ.'_struct.keywords')) THEN
          LN=LEND
          IF(LN.GT.40) LN=40
          NAME_PDB=DATA(1:LN)
        ELSE IF((ITEM(1:18).EQ.'_database_PDB_date').OR.
     *          (ITEM(1:20).EQ.'_audit.creation_date')) THEN         
          DATE_PDB=DATA(1:LEND)
        ELSE IF((ITEM(1:13).EQ.'_struct_title').OR.
     *          (ITEM(1:13).EQ.'_struct.title')) THEN     
          TITLE=DATA(1:LEND)
          LN=LEND
          IF(LN.GT.40) LN=40
          NAME_PDB=DATA(1:LN)
        ELSE IF((ITEM(1:12) .EQ.'_cell_length').OR.         
     *          (ITEM(1:12) .EQ.'_cell_angle_').OR.         
     *          (ITEM(1:12) .EQ.'_cell.length').OR.         
     *          (ITEM(1:12) .EQ.'_cell.angle_')) THEN         

          IF(ITEM(7:14).EQ.'length_a') THEN         
            ACELL=FDATA
          ELSE IF(ITEM(7:14).EQ.'length_b') THEN         
            BCELL=FDATA
          ELSE IF(ITEM(7:14).EQ.'length_c') THEN         
            CCELL=FDATA
          ELSE IF(ITEM(7:17).EQ.'angle_alpha') THEN     
            ALCELL=FDATA
            ALCELL=ALCELL*PI180
          ELSE IF(ITEM(7:16).EQ.'angle_beta') THEN         
            BECELL=FDATA
            BECELL=BECELL*PI180
          ELSE IF(ITEM(7:17).EQ.'angle_gamma') THEN
            GACELL=FDATA
            GACELL=GACELL*PI180
          ENDIF

        ELSE IF(ITEM(1:9).EQ.'_symmetry') THEN

          IF     (ITEM(11:30).EQ.'space_group_name_H-M') THEN         
            SGNAME=DATA
          ELSE IF(ITEM(11:21).EQ.'Int_Tables_') THEN         
            NSG=IDATA
          ELSE IF(ITEM(11:21).EQ.'cell_settin') THEN         
            NSETT=IDATA
          ELSE IF(ITEM(11:21).EQ.'equiv_pos_a') THEN     

          ENDIF
C --
        ELSE IF(ITEM(1:12).EQ.'_nc_symmetry') THEN

          IF(ITEM(14:18).EQ.'alpha') THEN
            ALPHA=FDATA
          ELSE IF(ITEM(14:17).EQ.'beta') THEN
            BETA=FDATA
          ELSE IF(ITEM(14:18).EQ.'gamma') THEN
            GAMMA=FDATA
          ELSE IF(ITEM(14:21).EQ.'vector_1') THEN
            TR(1)=FDATA
          ELSE IF(ITEM(14:21).EQ.'vector_2') THEN
            TR(2)=FDATA
          ELSE IF(ITEM(14:21).EQ.'vector_3') THEN
            TR(3)=FDATA
          ENDIF

          IF(I.EQ.N_CIF) THEN     
            IS=IS+1
            ALPHA=ALPHA*PI180
            BETA =BETA *PI180
            GAMMA=GAMMA*PI180
            CALL EULERM(ALPHA,BETA,GAMMA,AMR)
            CALL SET_NCS(MDOC,NCMAX,IS,AMR,TR,IERR)
            IF(IERR.NE.0) RETURN
            II=0
            CALL GET_NCS(MDOC,NCMAX,II,AMR,TR,IERR)
            IF(IERR.NE.0) RETURN
          ENDIF

        ELSE IF(ITEM(1:5).EQ.'_stop') THEN
          CLOSE(MTIN)
          GO TO 200
        ENDIF
      ENDDO
      GO TO 100
 200  CONTINUE
      RLATT(1)=ACELL
      RLATT(2)=BCELL
      RLATT(3)=CCELL
      RLATT(4)=ALCELL
      RLATT(5)=BECELL
      RLATT(6)=GACELL
C      IF(NSG.LT.1.OR.NSG.GT.230) NSG=1
      IF(NSG.LT.1.OR.NSG.GT.9999) NSG=1
C      IF(NSETT.LT.1.OR.NSETT.GT.2) NSETT=1
      IF(ACELL.LE.0.5.OR.BCELL.LE.0.5.OR.CCELL.LE.0.5.OR.
     *     ALCELL.LE.0.001.OR.BECELL.LE.0.001.OR.GACELL.LE.0.001) 
     *THEN
        CALL MSGERR(MDOC,' ERROR: rd_inf: there is not CELL parameters')
        IERR=3
        RETURN
      ENDIF
      IF(SGNAME(1:1).EQ.' '.AND.NSG.EQ.0) THEN
        CALL MSGERR(MDOC,
     *  ' ERROR: rd_inf: there is not a symmetry information')
        IERR=3
        RETURN
      ENDIF
      CALL GET_SYMM(MDOC,NSG,NSETT,SGNAME,NSYM,ISYM
     *                                            ,IPRSYM,IERR)
      IF(IERR.GT.0) RETURN
      IERR=0
      CALL LENSTR_BL(TITLE,LEN)
      IF(LEN.LE.0) THEN
        LINE=CODE_PDB//'    '// '---'
        LEN=10
      ELSE
        IF(LEN.GT.60) LEN=60
        LINE=TITLE(1:LEN)             
      ENDIF
      CALL SET_CELL(RLATT,CODE_PDB,NAME_PDB,DATE_PDB,LINE,NSG
     *        ,NSETT,SGNAME,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: rd_inf: wrong title')
        RETURN
      ENDIF
C --------------------------------------------------
      RETURN
      END

C ******
      SUBROUTINE CHECK_BATCH(IBAT)
C
C -P- CHECK_BAT - return info about mode / dialogue (0) or batch (1)/.
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*512
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ******
      INTEGER*4 IBAT
C ------
      IBAT=BAT_MODE
      RETURN
      END

C ******
      SUBROUTINE SET_BATCH(IBAT)
C
C -P- CHECK_BAT - return info about mode / dialogue (0) or batch (1)/.
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*512
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ******
      INTEGER*4 IBAT
C ------
      BAT_MODE=IBAT
      RETURN
      END

C ******


C ******
      SUBROUTINE CLEAR_DEF
C
C -P- CLEAR_DEF - return dialogue mode.  
C
C ******
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*512
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ---
      PARAMETER ( KEY_MAX = 150 )
      COMMON/COMASK/ IEND,NKEY,FLAG,STOR,STOR_KEY 
     *              ,VCCP4,FILE_KEY_INP,KEY_INF
      CHARACTER VCCP4*1,FILE_KEY_INP*256,KEY_INF*1
      INTEGER*4 FLAG(KEY_MAX),IEND,NKEY
      CHARACTER STOR(KEY_MAX)*256,STOR_KEY(KEY_MAX)*11
      COMMON/COMASK2/ NKEY_TEST,KEY_TEST
      INTEGER*4 NKEY_TEST
      CHARACTER KEY_TEST(KEY_MAX)*11
C -----------------------------------------------------------
C     IF(BAT_MODE.GT.0) RETURN
      IEND      = 0
      IBATCH    = 0
      NKEY      = 0
      NKEY_TEST = 0
      DO I=1,KEY_MAX
        FLAG(I) = 0
      ENDDO
      RETURN
      END

C ******
      SUBROUTINE WRT_BATCH(LINE)
C
C -P- WRT_BATCH - write message to BATCH-FILE.
C
      CHARACTER LINE*(*)
C ******
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*512
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ---
      INTEGER*4 NL
      CHARACTER STR*512
C ---------------------------------------------------------
      IF(BATCH_FILE.GT.0) THEN
        CALL LENSTR_BL(LINE,NL)
        IF(NL.LE.0) THEN
          NL=1
          STR=' '
        ELSE
C         IF(NL.GT.79) NL=79
          IF(NL.GT.512) NL=512
          STR = LINE(1:NL)
        ENDIF
        WRITE(BATCH_FILE,'(A)',ERR=10) STR(1:NL)
      ENDIF
C ---
      RETURN
 10   CONTINUE
      MDOC=0
      CALL MSGERR(MDOC,' ERROR: write to BATCH_file')
      CALL FINISH
      END

C ******
      SUBROUTINE C_CR_AT
C     
C -P- C_CR_AT - copy parameters from common/CRYSTL/ to common/CRDINF/
C 
C --------------------------------------------------
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C ------------------------------------------------------------
      INCLUDE 'mr_crd_com.fh'
C --------------------------------------------------------------------
      DO I=1,80
        CR_TITLE(I:I)   = ' '
      ENDDO
      CR_CELL(1) = A_CELL    
      CR_CELL(2) = B_CELL    
      CR_CELL(3) = C_CELL    
      CR_CELL(4) = AL_CELL   
      CR_CELL(5) = BE_CELL   
      CR_CELL(6) = GA_CELL
      CR_NAME_PDB= PDB_NAME   
      CR_DATE_PDB= PDB_DATE
      CR_CD_PDB  = PDB_CODE  
      CR_TITLE   = USER_TITLE
      CR_NSPGR   = NSP_GROUP 
      CR_SETT    = N_SETT   
      CR_SPGR    = SP_GROUP 
      CR_RESL_PDB= PDB_RESL
      CR_RFAC_PDB= PDB_RFAC
      CR_MODEL   = PDB_MODEL
      DO I=1,3
        CR_U(I)=PDB_U(I)
        DO J=1,3
          CR_SCALE(I,J)=PDB_SCALE(I,J)
        ENDDO
      ENDDO
      DO I=1,3
        DO J=1,3
          CR_FRAC_TO_ORT(I,J)=FRTOCR(I,J)
          CR_ORT_TO_FRAC(I,J)=CRTOFR(I,J)
        ENDDO
      ENDDO
      RETURN
      END

C ******
      SUBROUTINE C_AT_CR
C     
C -P- C_AT_CR - copy parameters from common/CRDINF/ to common/CRYSTL/
C 
C --------------------------------------------------
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
C ------------------------------------------------------------
      INCLUDE 'mr_crd_com.fh'
C --------------------------------------------------------------------
      DO I=1,80
        USER_TITLE(I:I)   = ' '
      ENDDO
      A_CELL    = CR_CELL(1) 
      B_CELL    = CR_CELL(2)
      C_CELL    = CR_CELL(3)
      AL_CELL   = CR_CELL(4)
      BE_CELL   = CR_CELL(5)
      GA_CELL   = CR_CELL(6)
      PDB_NAME  = CR_NAME_PDB 
      PDB_DATE  = CR_DATE_PDB 
      PDB_CODE  = CR_CD_PDB 
      USER_TITLE= CR_TITLE 
      NSP_GROUP = CR_NSPGR 
      N_SETT    = CR_SETT
      SP_GROUP  = CR_SPGR
      PDB_RESL  = CR_RESL_PDB
      PDB_RFAC  = CR_RFAC_PDB
      PDB_MODEL = CR_MODEL
      DO I=1,3
        PDB_U(I)=CR_U(I)
        DO J=1,3
          PDB_SCALE(I,J)=CR_SCALE(I,J)
        ENDDO
      ENDDO
C ---
      CALL REPCELL(IERR)
      IF(IERR.NE.0) THEN
        MDOC=0
        CALL MSGERR(MDOC,
     * ' WARNING: determinant of matrix "Frac-to-Orth" = 0')
      ENDIF
C ---
      DO I=1,3
        DO J=1,3
          CR_FRAC_TO_ORT(I,J)=FRTOCR(I,J)
          CR_ORT_TO_FRAC(I,J)=CRTOFR(I,J)
        ENDDO
      ENDDO
      RETURN
      END

c --cr2--

C ******
      SUBROUTINE C_CR2_AT
C     
C -P- C_CR2_AT - copy parameters from common/CRYSTL/ to common/CRD2INF/
C 
C --------------------------------------------------
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C ------------------------------------------------------------
      INCLUDE 'mr_crd2_com.fh'
C --------------------------------------------------------------------
      DO I=1,80
        CR2_TITLE(I:I)   = ' '
      ENDDO
      CR2_CELL(1) = A_CELL    
      CR2_CELL(2) = B_CELL    
      CR2_CELL(3) = C_CELL    
      CR2_CELL(4) = AL_CELL   
      CR2_CELL(5) = BE_CELL   
      CR2_CELL(6) = GA_CELL
      CR2_NAME_PDB= PDB_NAME   
      CR2_DATE_PDB= PDB_DATE
      CR2_CD_PDB  = PDB_CODE  
      CR2_TITLE   = USER_TITLE
      CR2_NSPGR   = NSP_GROUP 
      CR2_SETT    = N_SETT   
      CR2_SPGR    = SP_GROUP 
      CR2_RESL_PDB= PDB_RESL
      CR2_RFAC_PDB= PDB_RFAC
      CR2_MODEL   = PDB_MODEL
      DO I=1,3
        CR2_U(I)=PDB_U(I)
        DO J=1,3
          CR2_SCALE(I,J)=PDB_SCALE(I,J)
        ENDDO
      ENDDO
      DO I=1,3
        DO J=1,3
          CR2_FRAC_TO_ORT(I,J)=FRTOCR(I,J)
          CR2_ORT_TO_FRAC(I,J)=CRTOFR(I,J)
        ENDDO
      ENDDO
      RETURN
      END

C ******
      SUBROUTINE C_AT_CR2
C     
C -P- C_AT_CR2 - copy parameters from common/CRD2INF/ to common/CRYSTL/
C 
C --------------------------------------------------
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
C ------------------------------------------------------------
      INCLUDE 'mr_crd2_com.fh'
C --------------------------------------------------------------------
      DO I=1,80
        USER_TITLE(I:I)   = ' '
      ENDDO
      A_CELL    = CR2_CELL(1) 
      B_CELL    = CR2_CELL(2)
      C_CELL    = CR2_CELL(3)
      AL_CELL   = CR2_CELL(4)
      BE_CELL   = CR2_CELL(5)
      GA_CELL   = CR2_CELL(6)
      PDB_NAME  = CR2_NAME_PDB 
      PDB_DATE  = CR2_DATE_PDB 
      PDB_CODE  = CR2_CD_PDB 
      USER_TITLE= CR2_TITLE 
      NSP_GROUP = CR2_NSPGR 
      N_SETT    = CR2_SETT
      SP_GROUP  = CR2_SPGR
      PDB_RESL  = CR2_RESL_PDB
      PDB_RFAC  = CR2_RFAC_PDB
      PDB_MODEL = CR2_MODEL
      DO I=1,3
        PDB_U(I)=CR2_U(I)
        DO J=1,3
          PDB_SCALE(I,J)=CR2_SCALE(I,J)
        ENDDO
      ENDDO
C ---
      CALL REPCELL(IERR)
      IF(IERR.NE.0) THEN
        MDOC=0
        CALL MSGERR(MDOC,
     * ' WARNING: determinant of matrix "Frac-to-Orth" = 0')
      ENDIF
C ---
      DO I=1,3
        DO J=1,3
          CR2_FRAC_TO_ORT(I,J)=FRTOCR(I,J)
          CR2_ORT_TO_FRAC(I,J)=CRTOFR(I,J)
        ENDDO
      ENDDO
      RETURN
      END

C ******
      SUBROUTINE FINISH
C
C -P- FINISH - close DOC-file and EXIT.
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*512
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ---
C ******
      INTEGER*4 M
      CHARACTER LINE*80
C -------------------------
      M=-1
      CALL LENSTR_BL(PROGRAMM,LEN)
      IF(LEN.LE.0) THEN
c        LEN=1
c        PROGRAMM(1:1)=' '
      ELSE IF(LEN.GT.20) THEN
        LEN=20
      ENDIF
c      WRITE(LINE,10) PROGRAMM(1:LEN)      
      WRITE(LINE,10) 'molrep'      
  10  FORMAT(' **** END //////// ',A,' ///////// END ****')
      CALL MSGDOC(M,LINE)
      IF(DOC_FILE.GT.0) THEN
        END FILE DOC_FILE
        CLOSE(DOC_FILE)
      ENDIF
      IF(BATCH_FILE.GT.0) THEN
C        WRITE(LINE,20) PROGRAMM(1:LEN)      
C  20    FORMAT('_END   ',A)
C        CALL WRT_BATCH(LINE)
        LINE='stop'
        CALL WRT_BATCH(LINE)
        END FILE BATCH_FILE
        CLOSE(BATCH_FILE)
      ENDIF
C     CALL EXIT
      END          

C ******
      SUBROUTINE CLOSE_DOC(M)
C
C -P- CLOSE_DOC - close DOC-file.
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*512
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ---
C ******
      INTEGER*4 M
C -------------------------
      IF(DOC_FILE.GT.0) THEN
        END FILE DOC_FILE
        CLOSE(DOC_FILE)
      ENDIF
      RETURN
      END          

      SUBROUTINE CLOSE_BATCH(M)
C
C -P- CLOSE_BATCH - close BATCH-file.
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*512
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ---
C ******
      INTEGER*4 M
      CHARACTER LINE*80
C -------------------------
      IF(BATCH_FILE.GT.0) THEN
        LINE='stop'
        CALL WRT_BATCH(LINE)
        END FILE BATCH_FILE
        CLOSE(BATCH_FILE)
        BATCH_FILE=0
      ENDIF
      RETURN
      END          

C ******
      SUBROUTINE MSGDOC(MDOC,STRING)
C ---
C -P- MSGDOC - writes message to terminal or/and DOC_FILE
C        MDOC   < 0  write to DOC_FILE only ( if DOC_FILE > 0 )
C               = 0  write to terminal only
C      0 < MDOC < 99 write to terminal and to DOC_FILE ( if DOC_FILE > 0 )
C       !MDOC! >= 99 don't write 
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*512
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ---
      INTEGER*4 MDOC
      CHARACTER STRING*(*)
C ******
C -----------------------------------
      IF(IGRAPH.EQ.0) THEN
        IF(ABS(MDOC).GE.99) RETURN
        CALL LENSTR_BL(STRING,NL)
        IF(NL.GE.256) NL=255
        IF(MDOC.GE.0) THEN
          IF(NL.LE.0) THEN
            IF(MDOC.GE.0) WRITE(*,*) 
            IF(MDOC.NE.0.AND.DOC_FILE.GT.0) WRITE(DOC_FILE,*) 
          ELSE
            IF(MDOC.GE.0) WRITE(*,100) STRING(1:NL)
            IF(MDOC.NE.0.AND.DOC_FILE.GT.0) 
     *      WRITE(DOC_FILE,101) STRING(1:NL)
 100        FORMAT(' ',A)
 101        FORMAT(A)
          ENDIF
        ELSE
          IF(NL.LE.0) THEN
            IF(DOC_FILE.GT.0) WRITE(DOC_FILE,*) 
          ELSE
            IF(DOC_FILE.GT.0) WRITE(DOC_FILE,101) STRING(1:NL)
          ENDIF
        ENDIF
      ELSE
        CALL MSGDOG(MDOC,STRING)
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE MSGERR(MDOC,STRING)
C ---
C -P- MSGERR - writes message about error to terminal or/and DOC_FILE
C        MDOC   # 0  write to terminal and DOC_FILE only ( if DOC_FILE > 0 )
C               = 0  write to terminal only
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*512
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ---
      INTEGER*4 MDOC
      CHARACTER STRING*(*)
C ******
C -----------------------------------
      IF(IGRAPH.EQ.0) THEN
C       IF(MDOC.GE.99) RETURN
        CALL LENSTR_BL(STRING,NL)
        IF(NL.GE.256) NL=255
        IF(NL.LE.0) THEN
          WRITE(*,*) 
          IF(MDOC.NE.0.AND.DOC_FILE.GT.0) WRITE(DOC_FILE,*) 
        ELSE
          WRITE(*,100) STRING(1:NL)
          IF(MDOC.NE.0.AND.DOC_FILE.GT.0) 
     *    WRITE(DOC_FILE,101) STRING(1:NL)
 100      FORMAT(' ',A)
 101      FORMAT(A)
        ENDIF
      ELSE
        CALL MSGERG(MDOC,STRING)
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE MSGERG(MDOC,STRING)
      CHARACTER STRING*(*)
      RETURN
      END
C ******

C ******
      SUBROUTINE MSGDOG(MDOC,STRING)
      CHARACTER STRING*(*)
      RETURN
      END
C ******

C -P-
C -P------ control information in the internal common blocks  ---
C -P-
C ******
      SUBROUTINE SET_CELL(RLATT,CODE,NAME,DATE,TITLE
     *   ,NSPGROUP,NOSETT,SPGR,IERR)
C     
C -P- SET_CELL - put parameters to common/CRYSTL/
C 
C               calc reciprocal cell parameters and volume
C               and put its to common/CRYSTL/
C               calc matrix FRTOCR and CRTOFR
C
C --------------------------------------------------
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
C ---
      REAL      RLATT(6)
      INTEGER*4 NSPGROUP,NOSETT,IERR
      CHARACTER CODE*4,NAME*(*),DATE*9,SPGR*24 
      CHARACTER TITLE*(*)
C ******
C --------------------------------------------------------------------
      DO I=1,80
        USER_TITLE(I:I)   = ' '
      ENDDO
      A_CELL    = RLATT(1)
      B_CELL    = RLATT(2)
      C_CELL    = RLATT(3)
      AL_CELL   = RLATT(4)
      BE_CELL   = RLATT(5)
      GA_CELL   = RLATT(6)
      CALL LENSTR_BL(NAME,LEN)
      IF(LEN.GT.40) LEN=40
      IF(LEN.LE.0) LEN=1
      PDB_NAME  = NAME(1:LEN)
      PDB_DATE  = DATE
      PDB_CODE  = CODE
      CALL LENSTR_BL(TITLE,LEN)
      IF(LEN.GT.80) LEN=80
      IF(LEN.LE.0) THEN
        USER_TITLE=' '
      ELSE
        USER_TITLE=TITLE(1:LEN)
      ENDIF
      NSP_GROUP = NSPGROUP
      N_SETT    = NOSETT
      SP_GROUP  = SPGR
      CALL REPCELL(IERR)
      IF(IERR.NE.0) THEN
        MDOC=0
        CALL MSGERR(MDOC,
     * ' WARNING: determinant of matrix "Frac-to-Orth" = 0')
      ENDIF
C ---
      CALL REPCELL(IERR)
      IF(IERR.NE.0) THEN
        MDOC=0
        CALL MSGERR(MDOC,
     * ' WARNING: determinant of matrix "Frac-to-Orth" = 0')
      ENDIF
C ---
      RETURN
      END

      SUBROUTINE GET_CELL(RLATT,CODE,NAME,DATE,TITLE
     *   ,NSPGROUP,NOSETT,SPGR,NSM,IERR)
C     
C -P- GET_CELL - get parameters from common/CRYSTL/
C 
C               calc reciprocal cell parameters and volume
C               and put its to common/CRYSTL/
C               calc matrix FRTOCR and CRTOFR
C
C --------------------------------------------------
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
C ------------------------------------------------------------
      INCLUDE 'mr_crd_com.fh'
C ---
      REAL      RLATT(6)
      INTEGER*4 NSPGROUP,NOSETT,IERR
      CHARACTER CODE*4,NAME*(*),DATE*9,SPGR*24 
      CHARACTER TITLE*(*)
C ******
C --------------------------------------------------------------------
      RLATT(1) = A_CELL    
      RLATT(2) = B_CELL    
      RLATT(3) = C_CELL    
      RLATT(4) = AL_CELL    
      RLATT(5) = BE_CELL
      RLATT(6) = GA_CELL    
      NAME     = PDB_NAME
      DATE     = PDB_DATE 
      CODE     = PDB_CODE  
      TITLE    = USER_TITLE
      NSPGROUP = NSP_GROUP
      NOSETT   = N_SETT    
      SPGR     = SP_GROUP  
      NSM      = CR_NSYM
C ---
      RETURN
      END

C ******
      SUBROUTINE SETLNL(NAME)
C ---
C -P- SETLNL - /old, don't use now /put NAME to --> common/COMLIB/..,LINEL,..
C ---
C ******
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*512
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ---
      INTEGER*4 LEN
      CHARACTER NAME*(*)
C -------------------------------------
      CALL LENSTR_BL(NAME,LEN)
      IF(LEN.GT.0.AND.LEN.LE.80) THEN
        LINEL=NAME(1:LEN)
      ELSE
        LINEL=' '
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE C_CR_WR
C     
C -P- C_CR_WR - copy parameters from common/CRYSTL/ to common/COMWRF/
C 
C --------------------------------------------------
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
C ---
      COMMON/COMWRF/ A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
     *              ,RN_WR,RX_WR,CF_WR,TF_WR
     *              ,NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
     *              ,NS_WR,IS_WR,IER_WR,IEN_WR
     *              ,TP_WR,T1_WR,T2_WR,TL_WR,DT_WR
     *              ,CD_WR,SG_WR,PT_WR,PD_WR
      REAL A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
      REAL RN_WR,RX_WR,CF_WR,TF_WR
      INTEGER*4 NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
      INTEGER*4 NS_WR,IS_WR,IER_WR,IEN_WR
      CHARACTER TP_WR*4,T1_WR*4,T2_WR*4,TL_WR*80,DT_WR*20     
      CHARACTER CD_WR*4,SG_WR*24,PT_WR*40,PD_WR*9
C ---
C ******
C --------------------------------------------------------------------
      DO I=1,80
        TL_WR(I:I) = ' '
      ENDDO
      DO I=1,40
        PT_WR(I:I) = ' '
      ENDDO
      A_WR  = A_CELL    
      B_WR  = B_CELL    
      C_WR  = C_CELL    
      AL_WR = AL_CELL   
      BE_WR = BE_CELL   
      GA_WR = GA_CELL   
      PT_WR = PDB_NAME 
      PD_WR = PDB_DATE  
      CD_WR = PDB_CODE  
      TL_WR = USER_TITLE
      T1_WR = USER_TITLE(1:4)
      T2_WR = USER_TITLE(5:8)
      NS_WR = NSP_GROUP 
      IS_WR = N_SETT   
      SG_WR = SP_GROUP 
      RETURN
      END

C ******
      SUBROUTINE SET_WRF(NSPGR,NSETT,CODESG,CODEPDB
     *                  ,NAMEPDB,DATEPDB,TITLE)
C     
C -P- SET_WRF - put N_SpGr, N_SETT, CODE_SpGr, CODE_PDB to common/COMWRF/
C -P-               NAME_PDB, DATE_PDB , TITLE_PDB
C --------------------------------------------------
      INTEGER*4 NSPGR,NSETT
      CHARACTER CODEPDB*4,NAMEPDB*40,TITLE*(*)
      CHARACTER CODESG*24,DATEPDB*9
C ---
      COMMON/COMWRF/ A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
     *              ,RN_WR,RX_WR,CF_WR,TF_WR
     *              ,NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
     *              ,NS_WR,IS_WR,IER_WR,IEN_WR
     *              ,TP_WR,T1_WR,T2_WR,TL_WR,DT_WR
     *              ,CD_WR,SG_WR,PT_WR,PD_WR
      REAL A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
      REAL RN_WR,RX_WR,CF_WR,TF_WR
      INTEGER*4 NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
      INTEGER*4 NS_WR,IS_WR,IER_WR,IEN_WR
      CHARACTER TP_WR*4,T1_WR*4,T2_WR*4,TL_WR*80,DT_WR*20     
      CHARACTER CD_WR*4,SG_WR*24,PT_WR*40,PD_WR*9
C ---
C ******
C --------------------------------------------------------------------
      DO I=1,80
        TL_WR(I:I) = ' '
      ENDDO
      DO I=1,40
        PT_WR(I:I) = ' '
      ENDDO
      T1_WR = '?   '
      T2_WR = '?   '
      TL_WR(9:9) = '?'
      CD_WR = CODEPDB  
      NS_WR = NSPGR 
      IS_WR = NSETT   
      SG_WR = CODESG 
      PT_WR = NAMEPDB
      PD_WR = DATEPDB
      CALL LENSTR_BL(TITLE,LEN)
      IF(LEN.GT.80) LEN=80
      IF(LEN.GE.8) THEN
        TL_WR(1:LEN) = TITLE(1:LEN)
        T1_WR = TITLE(1:4)
        T2_WR = TITLE(5:8)
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE C_RD_WR
C     
C -P- C_RD_WR - copy parameters from common/COMRDF/ to common/COMWRF/
C 
C --------------------------------------------------
      COMMON/COMWRF/ A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
     *              ,RN_WR,RX_WR,CF_WR,TF_WR
     *              ,NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
     *              ,NS_WR,IS_WR,IER_WR,IEN_WR
     *              ,TP_WR,T1_WR,T2_WR,TL_WR,DT_WR
     *              ,CD_WR,SG_WR,PT_WR,PD_WR
      REAL A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
      REAL RN_WR,RX_WR,CF_WR,TF_WR
      INTEGER*4 NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
      INTEGER*4 NS_WR,IS_WR,IER_WR,IEN_WR
      CHARACTER TP_WR*4,T1_WR*4,T2_WR*4,TL_WR*80,DT_WR*20     
      CHARACTER CD_WR*4,SG_WR*24,PT_WR*40,PD_WR*9
C ---
      COMMON/COMRDF/ A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
     *              ,RN_RD,RX_RD,CF_RD,TF_RD
     *              ,NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
     *              ,NS_RD,IS_RD,IER_RD,IEN_RD
     *              ,TP_RD,T1_RD,T2_RD,TL_RD,DT_RD
     *              ,CD_RD,SG_RD,PT_RD,PD_RD
      REAL A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
      REAL RN_RD,RX_RD,CF_RD,TF_RD
      INTEGER*4 NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
      INTEGER*4 NS_RD,IS_RD,IER_RD,IEN_RD
      CHARACTER TP_RD*4,T1_RD*4,T2_RD*4,TL_RD*80,DT_RD*20     
      CHARACTER CD_RD*4,SG_RD*24,PT_RD*40,PD_RD*9
C ******
C --------------------------------------------------------------------
      DO I=1,80
        TL_WR(I:I) = ' '
      ENDDO
      DO I=1,40
        PT_WR(I:I) = ' '
      ENDDO
      A_WR  = A_RD    
      B_WR  = B_RD    
      C_WR  = C_RD    
      AL_WR = AL_RD   
      BE_WR = BE_RD   
      GA_WR = GA_RD   
      CD_WR = CD_RD  
      T1_WR = T1_RD
      T2_WR = T2_RD
      TL_WR = TL_RD
      NS_WR = NS_RD 
      IS_WR = IS_RD   
      SG_WR = SG_RD 
      PT_WR = PT_RD
      PD_WR = PD_RD
      RETURN
      END

C ******
      SUBROUTINE C_RD_CR
C     
C -P- C_RD_CR - copy parameters from common/COMRDF/ to common/CRYSTL/
C 
C --------------------------------------------------
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
C ---
      COMMON/COMRDF/ A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
     *              ,RN_RD,RX_RD,CF_RD,TF_RD
     *              ,NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
     *              ,NS_RD,IS_RD,IER_RD,IEN_RD
     *              ,TP_RD,T1_RD,T2_RD,TL_RD,DT_RD
     *              ,CD_RD,SG_RD,PT_RD,PD_RD
      REAL A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
      REAL RN_RD,RX_RD,CF_RD,TF_RD
      INTEGER*4 NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
      INTEGER*4 NS_RD,IS_RD,IER_RD,IEN_RD
      CHARACTER TP_RD*4,T1_RD*4,T2_RD*4,TL_RD*80,DT_RD*20     
      CHARACTER CD_RD*4,SG_RD*24,PT_RD*40,PD_RD*9
C ******
C --------------------------------------------------------------------
      DO I=1,80
        USER_TITLE(I:I) = ' '
      ENDDO
      DO I=1,40
        PDB_NAME(I:I) = ' '
      ENDDO
      A_CELL    = A_RD    
      B_CELL    = B_RD   
      C_CELL    = C_RD
      AL_CELL   = AL_RD
      BE_CELL   = BE_RD
      GA_CELL   = GA_RD
      PDB_CODE  = CD_RD
      USER_TITLE= TL_RD
      NSP_GROUP = NS_RD
      N_SETT    = IS_RD
      SP_GROUP  = SG_RD
      PDB_NAME  = PT_RD
      PDB_DATE  = PD_RD
      CALL REPCELL(IERR)
      IF(IERR.NE.0) THEN
        MDOC=0
        CALL MSGERR(MDOC,
     * ' WARNING: determinant of matrix "Frac-to-Orth" = 0')
      ENDIF
      RETURN
      END


C ******
      SUBROUTINE SET_ASYMM(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                    ,IGOLD,NCSF,GID,IERR)
C -----------------------------------------------
C   input IGR = 0 - INIT/return NMAX, 1,2,.......  NMAX
C         IGR > 0  input IGR,IGOLD,INC,MLT,NCSF,GID(1:2),ICH,ICHOLD
C                 
C                  use IGOLD /number in the file/, if IGOLD=0 use IGOLD=IGR 
C                     if ( INC = 0) or
C                  1. if ICHOLD and ICH = 0 --> IG_CHAIN  =  IGR 
C                     if ( INC . ne. 0)
C                  2.    ICH    > 0         --> IG_CHAIN  =  ICH
C                  3.    ICHOLD > 0         --> IG_CHAIN  = -ICHOLD
C                      and check ICHOLD: if ICHOLD = IG_OLD(IG) then
C                                             IG_CHAIN  = IG 
C                  return new value NGR
C NGR     - number of groups in the structure. 
C IGR     - No of group.
C ICH     - pointer to initial group.      /for initial = IGR/
C ICHOLD  - pointer/ODL/ to initial group. /for initial = IGROLD/
C INC     - pointer to NCS matrix. 0 - initial group.
C MLT_    - 0,1,2,3,......
C IGOLD   - group number in the file.
C NCSF    - Y,N,C
C GID     -  "A102" = PDB_chain + add_chain_number
      INTEGER MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IGOLD,IERR
      CHARACTER NCSF*1,GID*4
C ------------------------------------------------------------------------
      PARAMETER (MAXCHAIN=999)
      COMMON /COM_ASYMM/  N_GROUP,N_CHAIN,IG_CHAIN,I_NCS,IG_OLD
     *                   ,MULT_FLAG,NCS_FLAG,GROUP_ID
      INTEGER*4 N_GROUP,N_CHAIN
      INTEGER*4 IG_CHAIN    (MAXCHAIN)   
      INTEGER*4 I_NCS       (MAXCHAIN)   
      INTEGER*4 MULT_FLAG   (MAXCHAIN)
      INTEGER*4 IG_OLD      (MAXCHAIN)   
      CHARACTER NCS_FLAG    (MAXCHAIN)*1
      CHARACTER GROUP_ID    (MAXCHAIN)*4
C ---
C N_GROUP      - number of groups in the structure. 
C IG_CHAIN     - pointer to chain.
C I_NCS        - pointer to NCS matrix.
C MULT_FLAG    -
C IG_OLD       - number of group in the file.
C NCS_FLAG     - 
C GROUP_ID     -  "A102" = PDB_chain + add_chain_number+I_NCS
C ******
C --------------------------------------------------------------------------
      CHARACTER CH4*4,LINE*80
C --------------------------------------------------------------------
      IERR=0
      NMAX=MAXCHAIN

      IF(IGR.GT.NMAX) THEN
        WRITE(LINE,'('' WARNING: Too many chains > '',I6)') NMAX
        CALL MSGERR(MDOC,LINE)
        IGR=NMAX
      ENDIF
      IF(IGR.LE.0) THEN
        N_GROUP=0
        N_CHAIN=0
        RETURN
      ENDIF

      IF(IGR.GT.N_GROUP+1) THEN
        WRITE(LINE,'('' ERR: wrong number of chain > '',I6)')N_GROUP
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF

      IF(IGR.GT.N_GROUP) THEN
        N_GROUP=N_GROUP+1
        N_CHAIN=N_GROUP
      ENDIF

      IF(IGOLD.LE.0) IGOLD=IGR

      IF(INC.LE.0) THEN
        INC=0
        IG_CHAIN    (IGR) = IGR   
      ELSE IF(ICH.LE.0.AND.ICHOLD.LE.0) THEN
          INC=0
          IG_CHAIN    (IGR) = IGR   
      ELSE IF(ICH.GT.0.AND.ICHOLD.LE.0) THEN
        IF(ICH.EQ.IGR) THEN
          INC=0
        ENDIF
        IG_CHAIN    (IGR) = ICH
      ELSE
        IF(ICHOLD.EQ.IGOLD) THEN
          INC=0
          IG_CHAIN    (IGR) = IGR   
        ELSE
          IG_CHAIN    (IGR) = -ICHOLD   
        ENDIF
      ENDIF

      I_NCS       (IGR) = INC   
      MULT_FLAG   (IGR) = MLT   
      IG_OLD      (IGR) = IGOLD   
      NCS_FLAG    (IGR) = NCSF

      IF(INC.GT.99) THEN
        WRITE(LINE,'('' ERR: wrong number of NCS operator > 99 '')')
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF

      WRITE(CH4,'(I2)') INC
      CH4(1:2)=GID(1:2)
      IF(CH4(2:2).EQ.' ') CH4(2:2)='.'
      IF(CH4(3:3).EQ.' ') CH4(3:3)='.'
      GROUP_ID    (IGR) = CH4

      IF(N_GROUP.GT.0) THEN
        DO I=1,N_GROUP
          IF(IG_CHAIN(I).LT.0) THEN
            IGO = -IG_CHAIN(I)
            DO J=1,N_GROUP
              IF(IGO.EQ.IG_OLD(J)) THEN
                IG_CHAIN(I) = IG_CHAIN(J)
                GO TO 100
              ENDIF
            ENDDO
          ENDIF
  100     CONTINUE
        ENDDO
      ENDIF

      NGR=N_GROUP

      RETURN
      END

C ******
      SUBROUTINE GET_ASYMM(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                    ,IGOLD,NCSF,GID,IERR)
C -----------------------------------------------
C   input - IGR   0/GET ONLY NMAX,NGR/, 1,2,....NGR
C
C NGR     - number of groups in the structure. 
C IGR     - group number.
C ICH     - pointer to initial group. /for initial = IGR/
C ICHOLD  - pointer/ODL/ to initial group. /for initial = IGROLD/
C INC     - pointer to NCS matrix. 0 - initial group.
C MLT_    - 0,1,2,3,......
C IGOLD   - number of group in the file.
C NCSF    - Y,N,C
C GID     -  "A102" = PDB_chain + + add_chain_number+I_NCS
      INTEGER MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IGOLD,IERR
      CHARACTER NCSF*1,GID*4
C ------------------------------------------------------------------------
      PARAMETER (MAXCHAIN=999)
      COMMON /COM_ASYMM/  N_GROUP,N_CHAIN,IG_CHAIN,I_NCS,IG_OLD
     *                   ,MULT_FLAG,NCS_FLAG,GROUP_ID
      INTEGER*4 N_GROUP,N_CHAIN
      INTEGER*4 IG_CHAIN    (MAXCHAIN)   
      INTEGER*4 I_NCS       (MAXCHAIN)   
      INTEGER*4 MULT_FLAG   (MAXCHAIN)
      INTEGER*4 IG_OLD      (MAXCHAIN)   
      CHARACTER NCS_FLAG    (MAXCHAIN)*1
      CHARACTER GROUP_ID    (MAXCHAIN)*4
C ---
C N_GROUP      - number of groups in the structure. 
C IG_CHAIN     - pointer to initial group.
C I_NCS        - pointer to NCS matrix.
C MULT_FLAG    -
C IG_OLD       - group number in the file.
C NCS_FLAG     - Y,N,C
C GROUP_ID     -  "A102" = PDB_chain + add_chain_number+I_NCS
C --------------------------------------------------------------------------
C ******
      CHARACTER LINE*80
C --------------------------------------------------------------------
      IERR=0
      NMAX=MAXCHAIN
      NGR =N_GROUP

      IF(IGR.GT.NGR) THEN
        WRITE(LINE,'('' ERROR: number of chain > '',I6)') NGR
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF

      IF(IGR.EQ.0) RETURN

      IF(NGR.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: number of chain = 0 ')
        IERR=1
        RETURN
      ENDIF

      IF(IGR.LT.0) THEN
        DO I=1,NGR
          IF(IGOLD.EQ.IG_OLD(I)) THEN
            IGR=I
            GO TO 100
          ENDIF 
        ENDDO
        CALL MSGERR(MDOC,' ERR: wrong description of asym. part')
        IERR=1
        RETURN
      ENDIF
 100  CONTINUE
      ICH    = IG_CHAIN    (IGR)   
      INC    = I_NCS       (IGR)   
      MLT    = MULT_FLAG   (IGR)    
      IGOLD  = IG_OLD      (IGR)   
      NCSF   = NCS_FLAG    (IGR)
      GID    = GROUP_ID    (IGR) 

      IF(ICH.LE.0.OR.ICH.GT.NGR) THEN
        WRITE(LINE,'('' WARNING: wrong description asymm. part.'')')
        CALL MSGERR(MDOC,LINE)
        ICH=IGR
      ENDIF

      ICHOLD = IG_OLD      (ICH)   

      RETURN
      END

      SUBROUTINE SET_ASYM2(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                    ,IGOLD,NCSF,GID,IERR)
C -----------------------------------------------
C   input IGR = 0 - INIT/return NMAX, 1,2,.......  NMAX
C         IGR > 0  input IGR,IGOLD,INC,MLT,NCSF,GID(1:2),ICH,ICHOLD
C                 
C                  use IGOLD /number in the file/, if IGOLD=0 use IGOLD=IGR 
C                     if ( INC = 0) or
C                  1. if ICHOLD and ICH = 0 --> IG_CHAIN  =  IGR 
C                     if ( INC . ne. 0)
C                  2.    ICH    > 0         --> IG_CHAIN  =  ICH
C                  3.    ICHOLD > 0         --> IG_CHAIN  = -ICHOLD
C                      and check ICHOLD: if ICHOLD = IG_OLD(IG) then
C                                             IG_CHAIN  = IG 
C                  return new value NGR
C NGR     - number of groups in the structure. 
C IGR     - No of group.
C ICH     - pointer to initial group.      /for initial = IGR/
C ICHOLD  - pointer/ODL/ to initial group. /for initial = IGROLD/
C INC     - pointer to NCS matrix. 0 - initial group.
C MLT_    - 0,1,2,3,......
C IGOLD   - group number in the file.
C NCSF    - Y,N,C
C GID     -  "A102" = PDB_chain + add_chain_number
      INTEGER MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IGOLD,IERR
      CHARACTER NCSF*1,GID*4
C ------------------------------------------------------------------------
      PARAMETER (MAXCHAIN=999)
      COMMON /COM_ASYM2/  N_GROUP,N_CHAIN,IG_CHAIN,I_NCS,IG_OLD
     *                   ,MULT_FLAG,NCS_FLAG,GROUP_ID
      INTEGER*4 N_GROUP,N_CHAIN
      INTEGER*4 IG_CHAIN    (MAXCHAIN)   
      INTEGER*4 I_NCS       (MAXCHAIN)   
      INTEGER*4 MULT_FLAG   (MAXCHAIN)
      INTEGER*4 IG_OLD      (MAXCHAIN)   
      CHARACTER NCS_FLAG    (MAXCHAIN)*1
      CHARACTER GROUP_ID    (MAXCHAIN)*4
C ---
C N_GROUP      - number of groups in the structure. 
C IG_CHAIN     - pointer to chain.
C I_NCS        - pointer to NCS matrix.
C MULT_FLAG    -
C IG_OLD       - number of group in the file.
C NCS_FLAG     - 
C GROUP_ID     -  "A102" = PDB_chain + add_chain_number+I_NCS
C --------------------------------------------------------------------------
      CHARACTER CH4*4,LINE*80
C --------------------------------------------------------------------
      IERR=0
      NMAX=MAXCHAIN

      IF(IGR.GT.NMAX) THEN
        WRITE(LINE,'('' WARNING: Too many chains > '',I6)') NMAX
        CALL MSGERR(MDOC,LINE)
        IGR=NMAX
      ENDIF
      IF(IGR.LE.0) THEN
        N_GROUP=0
        N_CHAIN=0
        RETURN
      ENDIF

      IF(IGR.GT.N_GROUP+1) THEN
        WRITE(LINE,'('' ERR: wrong number of chain > '',I6)')N_GROUP
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF

      IF(IGR.GT.N_GROUP) THEN
        N_GROUP=N_GROUP+1
        N_CHAIN=N_GROUP
      ENDIF

      IF(IGOLD.LE.0) IGOLD=IGR

      IF(INC.LE.0) THEN
        INC=0
        IG_CHAIN    (IGR) = IGR   
      ELSE IF(ICH.LE.0.AND.ICHOLD.LE.0) THEN
          INC=0
          IG_CHAIN    (IGR) = IGR   
      ELSE IF(ICH.GT.0.AND.ICHOLD.LE.0) THEN
        IF(ICH.EQ.IGR) THEN
          INC=0
        ENDIF
        IG_CHAIN    (IGR) = ICH
      ELSE
        IF(ICHOLD.EQ.IGOLD) THEN
          INC=0
          IG_CHAIN    (IGR) = IGR   
        ELSE
          IG_CHAIN    (IGR) = -ICHOLD   
        ENDIF
      ENDIF

      I_NCS       (IGR) = INC   
      MULT_FLAG   (IGR) = MLT   
      IG_OLD      (IGR) = IGOLD   
      NCS_FLAG    (IGR) = NCSF

      IF(INC.GT.99) THEN
        WRITE(LINE,'('' ERR: wrong number of NCS operator > 99 '')')
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF

      WRITE(CH4,'(I2)') INC
      CH4(1:2)=GID(1:2)
      IF(CH4(2:2).EQ.' ') CH4(2:2)='.'
      IF(CH4(3:3).EQ.' ') CH4(3:3)='.'
      GROUP_ID    (IGR) = CH4

      IF(N_GROUP.GT.0) THEN
        DO I=1,N_GROUP
          IF(IG_CHAIN(I).LT.0) THEN
            IGO = -IG_CHAIN(I)
            DO J=1,N_GROUP
              IF(IGO.EQ.IG_OLD(J)) THEN
                IG_CHAIN(I) = IG_CHAIN(J)
                GO TO 100
              ENDIF
            ENDDO
          ENDIF
  100     CONTINUE
        ENDDO
      ENDIF

      NGR=N_GROUP

      RETURN
      END

      SUBROUTINE GET_ASYM2(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                    ,IGOLD,NCSF,GID,IERR)
C -----------------------------------------------
C   input - IGR   0/GET ONLY NMAX,NGR/, 1,2,....NGR
C
C NGR     - number of groups in the structure. 
C IGR     - group number.
C ICH     - pointer to initial group. /for initial = IGR/
C ICHOLD  - pointer/ODL/ to initial group. /for initial = IGROLD/
C INC     - pointer to NCS matrix. 0 - initial group.
C MLT_    - 0,1,2,3,......
C IGOLD   - number of group in the file.
C NCSF    - Y,N,C
C GID     -  "A102" = PDB_chain + + add_chain_number+I_NCS
      INTEGER MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IGOLD,IERR
      CHARACTER NCSF*1,GID*4
C ------------------------------------------------------------------------
      PARAMETER (MAXCHAIN=999)
      COMMON /COM_ASYM2/  N_GROUP,N_CHAIN,IG_CHAIN,I_NCS,IG_OLD
     *                   ,MULT_FLAG,NCS_FLAG,GROUP_ID
      INTEGER*4 N_GROUP,N_CHAIN
      INTEGER*4 IG_CHAIN    (MAXCHAIN)   
      INTEGER*4 I_NCS       (MAXCHAIN)   
      INTEGER*4 MULT_FLAG   (MAXCHAIN)
      INTEGER*4 IG_OLD      (MAXCHAIN)   
      CHARACTER NCS_FLAG    (MAXCHAIN)*1
      CHARACTER GROUP_ID    (MAXCHAIN)*4
C ---
C N_GROUP      - number of groups in the structure. 
C IG_CHAIN     - pointer to initial group.
C I_NCS        - pointer to NCS matrix.
C MULT_FLAG    -
C IG_OLD       - group number in the file.
C NCS_FLAG     - Y,N,C
C GROUP_ID     -  "A102" = PDB_chain + add_chain_number+I_NCS
C --------------------------------------------------------------------------
      CHARACTER LINE*80
C --------------------------------------------------------------------
      IERR=0
      NMAX=MAXCHAIN
      NGR =N_GROUP


      IF(IGR.GT.NGR) THEN
        WRITE(LINE,'('' ERR: number of chain > '',I6)') NGR
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF

      IF(IGR.EQ.0) RETURN

      IF(NGR.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: number of chain = 0 ')
        IERR=1
        RETURN
      ENDIF

      IF(IGR.LT.0) THEN
        DO I=1,NGR
          IF(IGOLD.EQ.IG_OLD(I)) THEN
            IGR=I
            GO TO 100
          ENDIF 
        ENDDO
        CALL MSGERR(MDOC,' ERR: wrong description of asym. part')
        IERR=1
        RETURN
      ENDIF
 100  CONTINUE
      ICH    = IG_CHAIN    (IGR)   
      INC    = I_NCS       (IGR)   
      MLT    = MULT_FLAG   (IGR)    
      IGOLD  = IG_OLD      (IGR)   
      NCSF   = NCS_FLAG    (IGR)
      GID    = GROUP_ID    (IGR) 

      IF(ICH.LE.0.OR.ICH.GT.NGR) THEN
        WRITE(LINE,'('' WARNING: wrong description asymm. part.'')')
        CALL MSGERR(MDOC,LINE)
        ICH=IGR
      ENDIF

      ICHOLD = IG_OLD      (ICH)   

      RETURN
      END
      

      SUBROUTINE SET_ASYM3(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                    ,IGOLD,NCSF,GID,IERR)
C -----------------------------------------------
C   input IGR = 0 - INIT/return NMAX, 1,2,.......  NMAX
C         IGR > 0  input IGR,IGOLD,INC,MLT,NCSF,GID(1:2),ICH,ICHOLD
C                 
C                  use IGOLD /number in the file/, if IGOLD=0 use IGOLD=IGR 
C                     if ( INC = 0) or
C                  1. if ICHOLD and ICH = 0 --> IG_CHAIN  =  IGR 
C                     if ( INC . ne. 0)
C                  2.    ICH    > 0         --> IG_CHAIN  =  ICH
C                  3.    ICHOLD > 0         --> IG_CHAIN  = -ICHOLD
C                      and check ICHOLD: if ICHOLD = IG_OLD(IG) then
C                                             IG_CHAIN  = IG 
C                  return new value NGR
C NGR     - number of groups in the structure. 
C IGR     - No of group.
C ICH     - pointer to initial group.      /for initial = IGR/
C ICHOLD  - pointer/ODL/ to initial group. /for initial = IGROLD/
C INC     - pointer to NCS matrix. 0 - initial group.
C MLT_    - 0,1,2,3,......
C IGOLD   - group number in the file.
C NCSF    - Y,N,C
C GID     -  "A102" = PDB_chain + add_chain_number
      INTEGER MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IGOLD,IERR
      CHARACTER NCSF*1,GID*4
C ------------------------------------------------------------------------
      PARAMETER (MAXCHAIN=999)
      COMMON /COM_ASYM3/  N_GROUP,N_CHAIN,IG_CHAIN,I_NCS,IG_OLD
     *                   ,MULT_FLAG,NCS_FLAG,GROUP_ID
      INTEGER*4 N_GROUP,N_CHAIN
      INTEGER*4 IG_CHAIN    (MAXCHAIN)   
      INTEGER*4 I_NCS       (MAXCHAIN)   
      INTEGER*4 MULT_FLAG   (MAXCHAIN)
      INTEGER*4 IG_OLD      (MAXCHAIN)   
      CHARACTER NCS_FLAG    (MAXCHAIN)*1
      CHARACTER GROUP_ID    (MAXCHAIN)*4
C ---
C N_GROUP      - number of groups in the structure. 
C IG_CHAIN     - pointer to chain.
C I_NCS        - pointer to NCS matrix.
C MULT_FLAG    -
C IG_OLD       - number of group in the file.
C NCS_FLAG     - 
C GROUP_ID     -  "A102" = PDB_chain + add_chain_number+I_NCS
C --------------------------------------------------------------------------
      CHARACTER CH4*4,LINE*80
C --------------------------------------------------------------------
      IERR=0
      NMAX=MAXCHAIN

      IF(IGR.GT.NMAX) THEN
        WRITE(LINE,'('' WARNING: Too many chains > '',I6)') NMAX
        CALL MSGERR(MDOC,LINE)
        IGR=NMAX
      ENDIF
      IF(IGR.LE.0) THEN
        N_GROUP=0
        N_CHAIN=0
        RETURN
      ENDIF

      IF(IGR.GT.N_GROUP+1) THEN
        WRITE(LINE,'('' ERR: wrong number of chain > '',I6)')N_GROUP
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF

      IF(IGR.GT.N_GROUP) THEN
        N_GROUP=N_GROUP+1
        N_CHAIN=N_GROUP
      ENDIF

      IF(IGOLD.LE.0) IGOLD=IGR

      IF(INC.LE.0) THEN
        INC=0
        IG_CHAIN    (IGR) = IGR   
      ELSE IF(ICH.LE.0.AND.ICHOLD.LE.0) THEN
          INC=0
          IG_CHAIN    (IGR) = IGR   
      ELSE IF(ICH.GT.0.AND.ICHOLD.LE.0) THEN
        IF(ICH.EQ.IGR) THEN
          INC=0
        ENDIF
        IG_CHAIN    (IGR) = ICH
      ELSE
        IF(ICHOLD.EQ.IGOLD) THEN
          INC=0
          IG_CHAIN    (IGR) = IGR   
        ELSE
          IG_CHAIN    (IGR) = -ICHOLD   
        ENDIF
      ENDIF

      I_NCS       (IGR) = INC   
      MULT_FLAG   (IGR) = MLT   
      IG_OLD      (IGR) = IGOLD   
      NCS_FLAG    (IGR) = NCSF

      IF(INC.GT.99) THEN
        WRITE(LINE,'('' ERR: wrong number of NCS operator > 99 '')')
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF

      WRITE(CH4,'(I2)') INC
      CH4(1:2)=GID(1:2)
      IF(CH4(2:2).EQ.' ') CH4(2:2)='.'
      IF(CH4(3:3).EQ.' ') CH4(3:3)='.'
      GROUP_ID    (IGR) = CH4

      IF(N_GROUP.GT.0) THEN
        DO I=1,N_GROUP
          IF(IG_CHAIN(I).LT.0) THEN
            IGO = -IG_CHAIN(I)
            DO J=1,N_GROUP
              IF(IGO.EQ.IG_OLD(J)) THEN
                IG_CHAIN(I) = IG_CHAIN(J)
                GO TO 100
              ENDIF
            ENDDO
          ENDIF
  100     CONTINUE
        ENDDO
      ENDIF

      NGR=N_GROUP

      RETURN
      END

      SUBROUTINE GET_ASYM3(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                    ,IGOLD,NCSF,GID,IERR)
C -----------------------------------------------
C   input - IGR   0/GET ONLY NMAX,NGR/, 1,2,....NGR
C
C NGR     - number of groups in the structure. 
C IGR     - group number.
C ICH     - pointer to initial group. /for initial = IGR/
C ICHOLD  - pointer/ODL/ to initial group. /for initial = IGROLD/
C INC     - pointer to NCS matrix. 0 - initial group.
C MLT_    - 0,1,2,3,......
C IGOLD   - number of group in the file.
C NCSF    - Y,N,C
C GID     -  "A102" = PDB_chain + + add_chain_number+I_NCS
      INTEGER MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IGOLD,IERR
      CHARACTER NCSF*1,GID*4
C ------------------------------------------------------------------------
      PARAMETER (MAXCHAIN=999)
      COMMON /COM_ASYM3/  N_GROUP,N_CHAIN,IG_CHAIN,I_NCS,IG_OLD
     *                   ,MULT_FLAG,NCS_FLAG,GROUP_ID
      INTEGER*4 N_GROUP,N_CHAIN
      INTEGER*4 IG_CHAIN    (MAXCHAIN)   
      INTEGER*4 I_NCS       (MAXCHAIN)   
      INTEGER*4 MULT_FLAG   (MAXCHAIN)
      INTEGER*4 IG_OLD      (MAXCHAIN)   
      CHARACTER NCS_FLAG    (MAXCHAIN)*1
      CHARACTER GROUP_ID    (MAXCHAIN)*4
C ---
C N_GROUP      - number of groups in the structure. 
C IG_CHAIN     - pointer to initial group.
C I_NCS        - pointer to NCS matrix.
C MULT_FLAG    -
C IG_OLD       - group number in the file.
C NCS_FLAG     - Y,N,C
C GROUP_ID     -  "A102" = PDB_chain + add_chain_number+I_NCS
C --------------------------------------------------------------------------
      CHARACTER LINE*80
C --------------------------------------------------------------------
      IERR=0
      NMAX=MAXCHAIN
      NGR =N_GROUP


      IF(IGR.GT.NGR) THEN
        WRITE(LINE,'('' ERR: number of chain > '',I6)') NGR
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF

      IF(IGR.EQ.0) RETURN

      IF(NGR.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: number of chain = 0 ')
        IERR=1
        RETURN
      ENDIF

      IF(IGR.LT.0) THEN
        DO I=1,NGR
          IF(IGOLD.EQ.IG_OLD(I)) THEN
            IGR=I
            GO TO 100
          ENDIF 
        ENDDO
        CALL MSGERR(MDOC,' ERR: wrong description of asym. part')
        IERR=1
        RETURN
      ENDIF
 100  CONTINUE
      ICH    = IG_CHAIN    (IGR)   
      INC    = I_NCS       (IGR)   
      MLT    = MULT_FLAG   (IGR)    
      IGOLD  = IG_OLD      (IGR)   
      NCSF   = NCS_FLAG    (IGR)
      GID    = GROUP_ID    (IGR) 

      IF(ICH.LE.0.OR.ICH.GT.NGR) THEN
        WRITE(LINE,'('' WARNING: wrong description asymm. part.'')')
        CALL MSGERR(MDOC,LINE)
        ICH=IGR
      ENDIF

      ICHOLD = IG_OLD      (ICH)   

      RETURN
      END

C ******
      SUBROUTINE SET_NCS(MDOC,NMAX,NCS,AM,TR,IERR)
C -----------------------------------------------
      INTEGER NCS,MDOC,IERR
      REAL    AM(3,3),TR(3)
C -------
      PARAMETER (NCSMAX=150)
      COMMON/COMNCS/ NCSOP,AMNCS(3,3,NCSMAX),TRNCS(3,NCSMAX)
C -------------------------------
C ******
      CHARACTER LINE*80
C --------------------------------------
      IERR=0
      NMAX=NCSMAX
      IF(NCS.GT.NCSMAX) THEN
        WRITE(LINE,
     *'('' ERR: Too many non_cr_symm. operators > '',I6)') NCSMAX
        CALL MSGERR(MDOC,LINE)
        NCS=NCSMAX
        IERR=1
        RETURN
      ENDIF
      IF(NCS.LT.1) THEN
        NCSOP=0
        RETURN
      ENDIF
      IF(NCS.GT.NCSOP+1) THEN
        WRITE(LINE,
     *'('' ERR: wrong number of NCS-operator > '',I6)') NCSOP
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF
      IF(NCS.GT.NCSOP) NCSOP=NCSOP+1
      DO I=1,3
        TRNCS(I,NCS)=TR(I)
        DO J=1,3
          AMNCS(I,J,NCS)=AM(I,J)
        ENDDO
      ENDDO
      RETURN
      END

C ******
      SUBROUTINE GET_NCS(MDOC,NMAX,NCS,AM,TR,IERR)
C -----------------------------------------------
      INTEGER NCS,MDOC,IERR
      REAL    AM(3,3),TR(3)
C -------
      PARAMETER (NCSMAX=150)
      COMMON/COMNCS/ NCSOP,AMNCS(3,3,NCSMAX),TRNCS(3,NCSMAX)
C -------------------------------
C ******
      CHARACTER LINE*80
C --------------------------------
      IERR=0
      NMAX=NCSMAX
      IF(NCS.GT.NCSMAX) THEN
        WRITE(LINE,
     *'('' ERR: number of non_cr_symm. operator > '',I6)') NCSMAX
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF
      IF(NCS.LT.1) THEN
        NCS=NCSOP
        RETURN
      ENDIF
      DO I=1,3
        TR(I)=TRNCS(I,NCS)
        DO J=1,3
          AM(I,J)=AMNCS(I,J,NCS)
        ENDDO
      ENDDO
      RETURN
      END
      
      SUBROUTINE SET_NCS2(MDOC,NMAX,NCS,AM,TR,IERR)
C -----------------------------------------------
      INTEGER NCS,MDOC,IERR
      REAL    AM(3,3),TR(3)
C -------
      PARAMETER (NCSMAX=150)
      COMMON/COMNCS2/ NCSOP,AMNCS(3,3,NCSMAX),TRNCS(3,NCSMAX)
C -------------------------------
      CHARACTER LINE*80
C --------------------------------------
      IERR=0
      NMAX=NCSMAX
      IF(NCS.GT.NCSMAX) THEN
        WRITE(LINE,
     *'('' ERR: Too many non_cr_symm. operators > '',I6)') NCSMAX
        CALL MSGERR(MDOC,LINE)
        NCS=NCSMAX
        IERR=1
        RETURN
      ENDIF
      IF(NCS.LT.1) THEN
        NCSOP=0
        RETURN
      ENDIF
      IF(NCS.GT.NCSOP+1) THEN
        WRITE(LINE,
     *'('' ERR: wrong number of NCS-operator > '',I6)') NCSOP
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF
      IF(NCS.GT.NCSOP) NCSOP=NCSOP+1
      DO I=1,3
        TRNCS(I,NCS)=TR(I)
        DO J=1,3
          AMNCS(I,J,NCS)=AM(I,J)
        ENDDO
      ENDDO
      RETURN
      END

      SUBROUTINE GET_NCS2(MDOC,NMAX,NCS,AM,TR,IERR)
C -----------------------------------------------
      INTEGER NCS,MDOC,IERR
      REAL    AM(3,3),TR(3)
C -------
      PARAMETER (NCSMAX=150)
      COMMON/COMNCS2/ NCSOP,AMNCS(3,3,NCSMAX),TRNCS(3,NCSMAX)
C -------------------------------
      CHARACTER LINE*80
C --------------------------------
      IERR=0
      NMAX=NCSMAX
      IF(NCS.GT.NCSMAX) THEN
        WRITE(LINE,
     *'('' ERR: number of non_cr_symm. operator > '',I6)') NCSMAX
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF
      IF(NCS.LT.1) THEN
        NCS=NCSOP
        RETURN
      ENDIF
      DO I=1,3
        TR(I)=TRNCS(I,NCS)
        DO J=1,3
          AM(I,J)=AMNCS(I,J,NCS)
        ENDDO
      ENDDO
      RETURN
      END
      
      SUBROUTINE SET_NCS3(MDOC,NMAX,NCS,AM,TR,IERR)
C -----------------------------------------------
      INTEGER NCS,MDOC,IERR
      REAL    AM(3,3),TR(3)
C -------
      PARAMETER (NCSMAX=150)
      COMMON/COMNCS3/ NCSOP,AMNCS(3,3,NCSMAX),TRNCS(3,NCSMAX)
C -------------------------------
      CHARACTER LINE*80
C --------------------------------------
      IERR=0
      NMAX=NCSMAX
      IF(NCS.GT.NCSMAX) THEN
        WRITE(LINE,
     *'('' ERR: Too many non_cr_symm. operators > '',I6)') NCSMAX
        CALL MSGERR(MDOC,LINE)
        NCS=NCSMAX
        IERR=1
        RETURN
      ENDIF
      IF(NCS.LT.1) THEN
        NCSOP=0
        RETURN
      ENDIF
      IF(NCS.GT.NCSOP+1) THEN
        WRITE(LINE,
     *'('' ERR: wrong number of NCS-operator > '',I6)') NCSOP
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF
      IF(NCS.GT.NCSOP) NCSOP=NCSOP+1
      DO I=1,3
        TRNCS(I,NCS)=TR(I)
        DO J=1,3
          AMNCS(I,J,NCS)=AM(I,J)
        ENDDO
      ENDDO
      RETURN
      END

      SUBROUTINE GET_NCS3(MDOC,NMAX,NCS,AM,TR,IERR)
C -----------------------------------------------
      INTEGER NCS,MDOC,IERR
      REAL    AM(3,3),TR(3)
C -------
      PARAMETER (NCSMAX=150)
      COMMON/COMNCS3/ NCSOP,AMNCS(3,3,NCSMAX),TRNCS(3,NCSMAX)
C -------------------------------
      CHARACTER LINE*80
C --------------------------------
      IERR=0
      NMAX=NCSMAX
      IF(NCS.GT.NCSMAX) THEN
        WRITE(LINE,
     *'('' ERR: number of non_cr_symm. operator > '',I6)') NCSMAX
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF
      IF(NCS.LT.1) THEN
        NCS=NCSOP
        RETURN
      ENDIF
      DO I=1,3
        TR(I)=TRNCS(I,NCS)
        DO J=1,3
          AM(I,J)=AMNCS(I,J,NCS)
        ENDDO
      ENDDO
      RETURN
      END

C ******
      SUBROUTINE REPCELL(IERR)
C
C -P- REPCELL - using CELL parameters from common/CRYSTL/ calc reciprocal
C -P-           cell parameters and volume and put its to common/CRYSTL/
C -P-           calc matrix FRTOCR and CRTOFR
C
C --------------------------------------------------
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
C ---------------------------------------------------
      COMMON/DST_SCR/  QQ_1,QQ_2,QQ_3,QQ_4,QQ_5,QQ_6
      INTEGER IERR
C ******
C---------------------------------------------------------------------
      COAL=COS(AL_CELL)
      COBE=COS(BE_CELL)
      COGA=COS(GA_CELL)

      VOLUME=A_CELL*B_CELL*C_CELL*SQRT(1.-COAL**2-COBE**2-COGA**2
     *    +2.*COAL*COBE*COGA)

      SINAL=SQRT(1.-COAL*COAL)
      SINBE=SQRT(1.-COBE*COBE)
      SINGA=SQRT(1.-COGA*COGA)
      A_STAR=B_CELL*C_CELL*SINAL/VOLUME
      B_STAR=A_CELL*C_CELL*SINBE/VOLUME
      C_STAR=A_CELL*B_CELL*SINGA/VOLUME
      COALST=(COBE*COGA-COAL)/(SINBE*SINGA)
      COBEST=(COAL*COGA-COBE)/(SINAL*SINGA)
      COGAST=(COAL*COBE-COGA)/(SINAL*SINBE)
      SIBEST=SQRT(1.-COBEST*COBEST)
      SIALST=SQRT(1.-COALST*COALST)
      SIGAST=SQRT(1.-COGAST*COGAST)
      QQ_1=A_STAR*A_STAR
      QQ_2=B_STAR*B_STAR
      QQ_3=C_STAR*C_STAR
      QQ_4=2.*A_STAR*B_STAR*COGAST
      QQ_5=2.*A_STAR*C_STAR*COBEST
      QQ_6=2.*B_STAR*C_STAR*COALST
      CALL FRORTH(A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *            ,FRTOCR,CRTOFR,IERR)
      RETURN
      END


C ******
      SUBROUTINE DSTARF(RLATT,AST,BST,CST,COALS,COBES,COGAS,VOL)
C
C -P- DSTARF - calculate reciprocal cell parameters and volume
C -P-          old version, now use REPCELL.
C     input:  RLATT    - unit cell parameters 
C                        angles in radian
C     output:
C             AST,BST,CST   ! recyprocal cell parameters and volume cell
C             COALS,COBES   !  
C             COGAS,VOL     !
C --------------------------------------------------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
      COMMON/DST_SCR/  QQ_1,QQ_2,QQ_3,QQ_4,QQ_5,QQ_6
C ---------
      REAL RLATT(6),VOL
      REAL AST,BST,CST,COALST,COBEST,COGAST
C ******
C---------------------------------------------------------------------
      A_CELL =RLATT(1)
      B_CELL =RLATT(2)
      C_CELL =RLATT(3)
      AL_CELL=RLATT(4)
      BE_CELL=RLATT(5)
      GA_CELL=RLATT(6)

      COAL=COS(AL_CELL)
      COBE=COS(BE_CELL)
      COGA=COS(GA_CELL)

      VOL=A_CELL*B_CELL*C_CELL*SQRT(1.-COAL**2-COBE**2-COGA**2
     *    +2.*COAL*COBE*COGA)
      VOLUME=VOL

      SINAL=SQRT(1.-COAL*COAL)
      SINBE=SQRT(1.-COBE*COBE)
      SINGA=SQRT(1.-COGA*COGA)

      A_STAR=B_CELL*C_CELL*SINAL/VOLUME
      B_STAR=A_CELL*C_CELL*SINBE/VOLUME
      C_STAR=A_CELL*B_CELL*SINGA/VOLUME
      AST=A_STAR
      BST=B_STAR
      CST=C_STAR
      COALST=(COBE*COGA-COAL)/(SINBE*SINGA)
      COBEST=(COAL*COGA-COBE)/(SINAL*SINGA)
      COGAST=(COAL*COBE-COGA)/(SINAL*SINBE)
      COALS=COALST
      COBES=COBEST
      COGAS=COGAST
      SIBEST=SQRT(1.-COBEST*COBEST)
      SIALST=SQRT(1.-COALST*COALST)
      SIGAST=SQRT(1.-COGAST*COGAST)
      QQ_1=AST*AST
      QQ_2=BST*BST
      QQ_3=CST*CST
      QQ_4=2.*AST*BST*COGAS
      QQ_5=2.*AST*CST*COBES
      QQ_6=2.*BST*CST*COALS
      CALL FRORTH(A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *            ,FRTOCR,CRTOFR,IERR)
      RETURN
      END

C ******
      SUBROUTINE FRORTH(A,B,C,ALPHA,BETA,GAMMA,FRTOCR,CRTOFR,IERR)
C
C -P- FRORTH - calc transformation to orthogonal angstroms from fractional
C -P-          cell FRTOCR and back - CRTOFR 
C
C       ALPHA,BETA,GAMMA - in radian
C
C       orthog axes are defined to have 
C       A parallel to XO   Cstar parallel to ZO 
C
C                                 ! 11 21 31 !
C            Xo=[FRTOCR] Xf    RO=! 12 22 32 !
C                                 ! 13 23 33 !
C
C            Xf=[CRTOFR] Xo
C
      REAL FRTOCR(3,3),CRTOFR(3,3)      
      INTEGER IERR
C ******
      IERR=0
      SINA=SIN(ALPHA)
      COSA=COS(ALPHA)
      SINB=SIN(BETA)
      COSB=COS(BETA)
      SING=SIN(GAMMA)
      COSG=COS(GAMMA)
      COSBS=(COSA*COSG-COSB)/(SINA*SING)
      SINBS=SQRT(1.-COSBS*COSBS)
      COSAS=(COSG*COSB-COSA)/(SINB*SING)
      SINAS=SQRT(1.-COSAS*COSAS)
      COSGS=(COSA*COSB-COSG)/(SINA*SINB)
      SINGS=SQRT(1.-COSGS*COSGS)
C
      DO     I=1,3
      DO     J=1,3
        FRTOCR(I,J)=0.
      ENDDO
      ENDDO
C
      FRTOCR(1,1)=A
      FRTOCR(2,1)=B*COSG
      FRTOCR(3,1)=C*COSB
      FRTOCR(1,2)=0.
      FRTOCR(2,2)=B*SING
      FRTOCR(3,2)=-C*SINB*COSAS
      FRTOCR(1,3)=0.
      FRTOCR(2,3)=0.
      FRTOCR(3,3)=C*SINB*SINAS
      CALL INVERT(FRTOCR,CRTOFR,IERR)
      RETURN
      END

      SUBROUTINE GET_CR_MATRIX(F2O,O2F)
C
C --------------------------------------------------
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
C ---------------------------------------------------
      REAL O2F(3,3),F2O(3,3)
C ******
C---------------------------------------------------------------------
      DO I=1,3
      DO J=1,3
        F2O(I,J) = FRTOCR(I,J)
        O2F(I,J) = CRTOFR(I,J)
      ENDDO
      ENDDO
C ---
      RETURN
      END


C -P-
C -P------  subroutines of rotation matrix  --------------------
C -P-
C ******
      SUBROUTINE EULERM(A,B,G,AM)
C
C -P- EULERM - calc euleran matrix AM[] <-- from euleran angles A,B,G /rad/
C
C     euleran angles : 1. A( Z) - alpha around axis Z
C                      2. B(Y') - beta  around new axis Y
C                      3. G(Z') - gamma around new axis Z
C
C                ! 11 21 31 !      Rotation of coord-system.
C           X' = ! 12 22 32 ! X
C                ! 13 23 33 !
C
      REAL AM(3,3)
C ******
      SINA=SIN(A)
      SINB=SIN(B)
      SING=SIN(G)
      COSA=COS(A)
      COSB=COS(B)
      COSG=COS(G)
      AM(1,1)= COSA*COSB*COSG-SINA*SING
      AM(1,2)= SINA*COSB*COSG+COSA*SING
      AM(1,3)=-SINB*COSG
      AM(2,1)=-COSA*COSB*SING-SINA*COSG
      AM(2,2)=-SINA*COSB*SING+COSA*COSG
      AM(2,3)= SINB*SING
      AM(3,1)= COSA*SINB
      AM(3,2)= SINA*SINB
      AM(3,3)= COSB
      RETURN
      END

C ******
      SUBROUTINE FTPMAT(PHI,THETA,PSI,AM)
C
C -P- FTPMAT - calc transform matrix AM[] <-- from angles PHI,THETA,PSI/rad/
C
C       PHI       -  rotation angle around  axis - X
C       THETA     -  rotation angle around  axis - Y
C       PSI       -  rotation angle around  axis - Z
C
C       PHI,THETA,PSI -in radian
C
C            ! 11 21 31 !
C       X' = ! 12 22 32 ! X
C            ! 13 23 33 !
C
      REAL AM(3,3)
C ******
        COSA=COS(PHI)
        SINA=SIN(PHI)  
        COSB=COS(THETA)
        SINB=SIN(THETA)
        COSG=COS(PSI)
        SING=SIN(PSI)
        AM(1,1)= COSB*COSG
        AM(1,2)= SINA*SINB*COSG-COSA*SING
        AM(1,3)=-COSA*SINB*COSG+SINA*SING
        AM(2,1)=-COSB*SING
        AM(2,2)=-SINA*SINB*SING+COSA*COSG
        AM(2,3)= COSA*SINB*SING+SINA*COSG
        AM(3,1)= SINB
        AM(3,2)=-SINA*COSB
        AM(3,3)= COSA*COSB
        RETURN
        END

C ******
      SUBROUTINE MTOANG(AMAT,ALPHA,BETA,GAMMA)
      REAL AMAT(3,3)
C
C -P- MTOANG - calc from rotation matrix AMAT[] --> Eiler angles /degree/ 
C -P-          ALPHA,BETA,GAMMA 
C
C ******
C ------------------------------------------------
      ALPHA = 0.0
      BETA  = 0.0
      GAMMA = 0.0
      PI    = 4.0*ATAN(1.0)
      CONV  = 180./PI
      TRACE = AMAT(1,1)+AMAT(2,2)+AMAT(3,3)
      IF(TRACE.LT.2.9999999) THEN
        IF(AMAT(3,3).LT. 0.999999.AND.AMAT(3,3).GT.-0.999999) THEN
          BETA = CONV*ACOS(AMAT(3,3))
          TEMP = SQRT(1-AMAT(3,3)*AMAT(3,3))
          BETA = CONV*AATAN2(TEMP,AMAT(3,3))
          R13  = AMAT(3,1)
          R23  = AMAT(3,2)
          R31  = AMAT(1,3)
          R32  = AMAT(2,3)
          IF(R23.LT.-0.0000001) THEN
            R13  =-R13
            R23  =-R23
            R31  =-R31
            R32  =-R32
            BETA =-BETA
          ENDIF
          ALPHA = CONV*AATAN2(R23, R13)
          GAMMA = CONV*AATAN2(R32,-R31)
        ELSE
C   ----  BETA = 0 OR 180  CAN ONLY FIND ALPHA + OR - GAMMA.
          BETA = 0.0
          IF(AMAT(3,3).LT.0.0) BETA=180.
          GAMMA = CONV*AATAN2(AMAT(1,2),AMAT(2,2))
          ALPHA = 0.0
        ENDIF
      ENDIF
C -----------------------------------
      RETURN
      END

C ******
      SUBROUTINE POLTOM(THETA,PHI,CHI,AM)
C
C -P- POLTOM - calc transform matrix AM[] <-- from  polars - THETA PHI CHI /rad/
C
C                    polar coordinates of rotate axis 
C       THETA     -  angle between  rotate axis and Z
C       PHI       -  angle in plan XY between X and projection rotate axis
C
C       CHI       -  rotation angle 
C
C       THETA,PHI,CHI -in radian
C
C            ! 11 21 31 !
C       X' = ! 12 22 32 ! X
C            ! 13 23 33 !
C
      REAL AM(3,3)
C ******
      PI=4.0*ATAN(1.0)
      SF= SIN(PHI)
      CF= COS(PHI)  
      CT= COS(THETA)
      ST= SIN(THETA)
      CH= COS(CHI)
      SH= SIN(CHI)

      AM(1,1)=( CH         +(1.0-CH)*ST*ST*CF*CF )
      AM(1,2)=( CT*SH      +(1.0-CH)*ST*ST*SF*CF )
      AM(1,3)=(-ST*SF*SH   +(1.0-CH)*CT*ST*CF    )

      AM(2,1)=(-CT*SH      +(1.0-CH)*ST*ST*CF*SF )
      AM(2,2)=( CH         +(1.0-CH)*ST*ST*SF*SF )
      AM(2,3)=( ST*CF*SH   +(1.0-CH)*CT*ST*SF    )

      AM(3,1)=( ST*SF*SH   +(1.0-CH)*CT*ST*CF    )
      AM(3,2)=(-ST*CF*SH   +(1.0-CH)*CT*ST*SF    )
      AM(3,3)=( CH         +(1.0-CH)*CT*CT       )


      RETURN
      END
C 
      SUBROUTINE MTOPOL(TRMAT,THETA,PHI,CHI)
      REAL TRMAT(3,3)
C
C -P- MTOPOL - from rotation matrix TRMAT[] --> polars - THETA PHI CHI /degree/
C
C ******
C ------------------------------------------------
      REAL DC(3)
C ------------------------------------------------
      PI=4.0*ATAN(1.0)
      CONV=180./PI

      THETA=0.0
      PHI  =0.0
      CHI  =0.0

      TRACE=TRMAT(1,1)+TRMAT(2,2)+TRMAT(3,3)
      IF(TRACE.GE.2.999999) GO TO 200

      
      COSCHI = TRACE/2. -0.5
      SINCHI = SQRT(ABS(1.-COSCHI*COSCHI))
      CHI    = CONV*AATAN2(SINCHI,COSCHI)
      CHK = ABS(CHI)

      IF(CHK.LE.179.5.AND.ABS(TRMAT(3,3)).LT.0.99999) THEN

        DC(1) = (TRMAT(2,3)-TRMAT(3,2))/(2.*SINCHI)
        DC(2) = (TRMAT(3,1)-TRMAT(1,3))/(2.*SINCHI)
        DC(3) = (TRMAT(1,2)-TRMAT(2,1))/(2.*SINCHI)

        CHK = DC(1)**2 +DC(2)**2 +DC(3)**2

        IF(CHK.GT.0.8) THEN
          STHETA = SQRT(ABS(1.-DC(3)*DC(3)))
          THETA  = CONV*AATAN2(STHETA,DC(3))
          PHI = CONV*AATAN2(DC(2),DC(1))
          GO TO 200
        ENDIF

      ENDIF
C
      CTHETA = (TRMAT(3,3)-COSCHI)/(1.0-COSCHI)
      CTHETA = SQRT(ABS(CTHETA))
      STHETA = SQRT(ABS(1.0-CTHETA*CTHETA))
      D = TRMAT(1,2)-TRMAT(2,1)
      CTHETA = CTHETA*SIGN(1.0,D)
      THETA  = CONV*AATAN2(STHETA,CTHETA)

      IF(TRMAT(3,3).GE.TRMAT(2,2).AND.TRMAT(3,3).GE.TRMAT(1,1)) THEN

        DC(1) = TRMAT(3,1)+TRMAT(1,3)
        DC(2) = TRMAT(2,3)+TRMAT(3,2)
        DC(3) = 2.0*(TRMAT(3,3)-COSCHI)

        DC(1) = DC(1)*SIGN(1.0,CTHETA)
        DC(2) = DC(2)*SIGN(1.0,CTHETA)
        PHI   = CONV*AATAN2(DC(2),DC(1))

      ELSE IF(TRMAT(2,2).GE.TRMAT(1,1)) THEN
        DC(1) = TRMAT(1,2)+TRMAT(2,1)
        DC(2) = 2.0*(TRMAT(2,2)-COSCHI)
        DC(3) = TRMAT(2,3)+TRMAT(3,2)

        D = TRMAT(3,1)-TRMAT(1,3)
c           2 st sf sh  --> sign sf
        DC(1) = DC(1)*SIGN(1.0,D)     
        DC(2) = DC(2)*SIGN(1.0,D)     

        PHI   = CONV*AATAN2(DC(2),DC(1))

      ELSE 
c         max  cf^2 st^2
c               2 (1-ch) st^2 cf^2
        DC(1) = 2.0*(TRMAT(1,1)-COSCHI)
c               2 (1-ch) st^2 sf cf
        DC(2) = TRMAT(1,2)+TRMAT(2,1)
        DC(3) = TRMAT(3,1)+TRMAT(1,3)

        D = TRMAT(2,3)-TRMAT(3,2)
c           2 st cf sh         --> sign cf
        D3 = TRMAT(3,1)+TRMAT(1,3)
c           2 (1-ch) ct st cf  --> sign cf
        
        IF(ABS(D3).GT.1.0E-3) THEN
          DC(1) = DC(1)*SIGN(1.0,CTHETA)
          DC(2) = DC(2)*SIGN(1.0,CTHETA)
          D = D3
        ENDIF         

        DC(1) = DC(1)*SIGN(1.0,D)     
        DC(2) = DC(2)*SIGN(1.0,D)  
        PHI   = CONV*AATAN2(DC(2),DC(1))

      ENDIF
C
 200  CONTINUE

      RETURN
      END

C ******
      SUBROUTINE MTOPOL_old(TRMAT,THETA,PHI,CHI)
      REAL TRMAT(3,3)
C
C -P- MTOPOL - from rotation matrix TRMAT[] --> polars - THETA PHI CHI /degree/
C
C ******
C ------------------------------------------------
      REAL DC(5)
C ------------------------------------------------
      OMEGA=0.0
      DC(1)=0.0
      DC(2)=0.0
      DC(3)=1.0
      THETA=0.0
      THETA=0.0
      PHI  =0.0
      CHI  =0.0
      PI=4.0*ATAN(1.0)
      CONV=180./PI
      TRACE=TRMAT(1,1)+TRMAT(2,2)+TRMAT(3,3)
      IF(TRACE.GE.2.999999)       GO TO 100
      IF(TRMAT(3,3).GE. 0.999999) GO TO 13
      IF(TRMAT(3,3).LE.-0.999999) GO TO 13
      THETA2=CONV*ACOS(TRMAT(3,3))
C
      R13=TRMAT(3,1)
      R23=TRMAT(3,2)
      R31=TRMAT(1,3)
      R32=TRMAT(2,3)
      IF(R23.GE.0.) GO TO 9
      R13=-R13
      R23=-R23
      R31=-R31
      R32=-R32
      THETA2=-THETA2
9     CONTINUE
      THETA3=CONV*AATAN2(R32,-R31)
      THETA1=CONV*AATAN2(R23,R13)
      GO TO 18
C  BETA =0 OR 180  CAN ONLY FIND ALPHA + OR - GAMMA.
13    THETA2=0.
      IF(TRMAT(3,3).LT.0.) THETA2=180.
      THETA3=CONV*AATAN2(TRMAT(1,2),TRMAT(2,2))
      THETA1=0.
      IF(THETA2.EQ.0)    CHI=THETA3
      IF(THETA2.EQ.180.) CHI=180.
      GO TO 10
C   SPHERICAL POLARS REF PATTERSON INT TAB VOL2 P59
18    CHI  =0.0
      DC(1)=0.0
      DC(2)=0.0
      DC(3)=0.0
      OMEGA=0.0
      PHI  =0.0
      COSCHI=TRACE/2. -0.5
      SINCHI=SQRT(ABS(1.-COSCHI*COSCHI))
      CHI=CONV*AATAN2(SINCHI,COSCHI)
      CHK=ABS(CHI)
      IF(CHK.GT.179.5) GO TO 10
      DC(1)=(TRMAT(2,3)-TRMAT(3,2))/(2.*SINCHI)
      DC(2)=(TRMAT(3,1)-TRMAT(1,3))/(2.*SINCHI)
      DC(3)=(TRMAT(1,2)-TRMAT(2,1))/(2.*SINCHI)
      CHK=DC(1)**2 +DC(2)**2 +DC(3)**2
      IF(CHK.GT.0.8) GO TO 11
C
10    DC(1)=SQRT(ABS(0.5*TRMAT(1,1)+0.5))
      DC(2)=SQRT(ABS(0.5*TRMAT(2,2)+0.5))
      DC(3)=SQRT(ABS(0.5*TRMAT(3,3)+0.5))
C
C   ASSUME DC(1) POSITIVE
      IF(DC(1).EQ.0.0) GO TO 17
      IF(DC(2).NE.0.0)DC(2)=DC(2)*SIGN(1.0,TRMAT(2,1))
      IF(DC(3).NE.0.0)DC(3)=DC(3)*SIGN(1.0,TRMAT(3,1))
      GO TO 11
17    IF(DC(2).EQ.0.0) GO TO 11
      IF(DC(3).EQ.0.0) GO TO 11
      DC(3)=DC(3)*SIGN(1.0,TRMAT(3,2))
11    DC(4)=DC(1)
      DC(5)=DC(2)
C
12    SOMEGA=SQRT(ABS(1.-DC(3)*DC(3)))
      OMEGA=CONV*AATAN2(SOMEGA,DC(3))
      PHI=CONV*AATAN2(DC(2),DC(1))
100   CONTINUE
      THETA=OMEGA
      RETURN
      END

      SUBROUTINE ANGFIX(MDOC,TRMAT,THETA1,THETA2,THETA3)
C
C calc from rotation matrix TRMAT[] --> Eiler angles - THETA1,THETA2,THETA3 
C                                  spherical polars  - OMEGA PHI CHI /degree/
C                                  direction cosinus - DC(1),DC(2),DC(3)
C     
C
      REAL TRMAT(3,3),DC(5)
      CHARACTER LINE*80
C 
C ------------------------------------------------
      OMEGA=0.0
      DC(1)=0.0
      DC(2)=0.0
      DC(3)=1.0
      THETA1=0.0
      THETA2=0.0
      THETA3=0.0
      PHI=0.0
      CHI=0.0
C      IF(ABS(MDOC).LT.99) THEN
        CALL MSGDOC(MDOC,'  ROTATION MATRIX ')
        WRITE(LINE,'(1X,3F10.3)') (TRMAT(J,1),J=1,3)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(1X,3F10.3)') (TRMAT(J,2),J=1,3)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(1X,3F10.3)') (TRMAT(J,3),J=1,3)
        CALL MSGDOC(MDOC,LINE)
C      ENDIF
      PI=4.0*ATAN(1.0)
      CONV=180./PI
      TRACE=TRMAT(1,1)+TRMAT(2,2)+TRMAT(3,3)
      IF(TRACE.GE.2.999999)       GO TO 100
      IF(TRMAT(3,3).GE. 0.999999) GO TO 13
      IF(TRMAT(3,3).LE.-0.999999) GO TO 13
      THETA2=CONV*ACOS(TRMAT(3,3))
C
      R13=TRMAT(3,1)
      R23=TRMAT(3,2)
      R31=TRMAT(1,3)
      R32=TRMAT(2,3)
      IF(R23.GE.0.) GO TO 9
      R13=-R13
      R23=-R23
      R31=-R31
      R32=-R32
      THETA2=-THETA2
9     CONTINUE
      THETA3=CONV*AATAN2(R32,-R31)
      THETA1=CONV*AATAN2(R23,R13)
      GO TO 18
C  BETA =0 OR 180  CAN ONLY FIND ALPHA + OR - GAMMA.
13    THETA2=0.
      IF(TRMAT(3,3).LT.0.) THETA2=180.
      THETA3=CONV*AATAN2(TRMAT(1,2),TRMAT(2,2))
      THETA1=0.
      IF(THETA2.EQ.0)    CHI=THETA3
      IF(THETA2.EQ.180.) CHI=180.
      GO TO 10
C   SPHERICAL POLARS REF PATTERSON INT TAB VOL2 P59
18    CHI  =0.0
      DC(1)=0.0
      DC(2)=0.0
      DC(3)=0.0
      OMEGA=0.0
      PHI  =0.0
      COSCHI=TRACE/2. -0.5
      SINCHI=SQRT(ABS(1.-COSCHI*COSCHI))
      CHI=CONV*AATAN2(SINCHI,COSCHI)
      CHK=ABS(CHI)
      IF(CHK.GT.179.5) GO TO 10
      DC(1)=(TRMAT(2,3)-TRMAT(3,2))/(2.*SINCHI)
      DC(2)=(TRMAT(3,1)-TRMAT(1,3))/(2.*SINCHI)
      DC(3)=(TRMAT(1,2)-TRMAT(2,1))/(2.*SINCHI)
      CHK=DC(1)**2 +DC(2)**2 +DC(3)**2
      IF(CHK.GT.0.8) GO TO 11
C
10    DC(1)=SQRT(ABS(0.5*TRMAT(1,1)+0.5))
      DC(2)=SQRT(ABS(0.5*TRMAT(2,2)+0.5))
      DC(3)=SQRT(ABS(0.5*TRMAT(3,3)+0.5))
C
C   ASSUME DC(1) POSITIVE
      IF(DC(1).EQ.0.0) GO TO 17
      IF(DC(2).NE.0.0)DC(2)=DC(2)*SIGN(1.0,TRMAT(2,1))
      IF(DC(3).NE.0.0)DC(3)=DC(3)*SIGN(1.0,TRMAT(3,1))
      GO TO 11
17    IF(DC(2).EQ.0.0) GO TO 11
      IF(DC(3).EQ.0.0) GO TO 11
      DC(3)=DC(3)*SIGN(1.0,TRMAT(3,2))
11    DC(4)=DC(1)
      DC(5)=DC(2)
C
12    SOMEGA=SQRT(ABS(1.-DC(3)*DC(3)))
      OMEGA=CONV*AATAN2(SOMEGA,DC(3))
      PHI=CONV*AATAN2(DC(2),DC(1))
100   CONTINUE

      WRITE(LINE,101) THETA1,THETA2,THETA3
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,102) OMEGA,PHI,CHI
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,103) (DC(I),I=1,3)
      CALL MSGDOC(MDOC,LINE)
101   FORMAT(' EILER             - ALPHA BETA GAMMA :',3F10.5)
102   FORMAT(' SPHERICAL POLARS  - OMEGA PHI CHI    :',3F10.5)
103   FORMAT(' DIRECTION COSINES OF ROTATION AXIS   :',3F10.5)
      RETURN
      END

C -P-
C -P------ useful crystallographical subroutines  --------------------
C -P-

C ******
      SUBROUTINE FTOO(X,Y,IERR)
C
C -P- FTOO - transform fractional coords X(3) to orthoganal Y(3).
C --------------------------------------------------
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
C ---------------------------------------------------
      REAL X(3),Y(3)
C ******
C---------------------------------------------------------------------
      CALL MVMULT(FRTOCR,X,Y)
      RETURN
      END

C ******
      SUBROUTINE OTOF(X,Y,IERR)
C
C -P- OTOF - transform orthogonal coords X(3) to fractional Y(3).
C --------------------------------------------------
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
C ---------------------------------------------------
      REAL X(3),Y(3)
C ******
C---------------------------------------------------------------------
      CALL MVMULT(CRTOFR,X,Y)
      RETURN
      END

C ******
      SUBROUTINE DSTAR(IH,IK,IL,RSQ)
C
C -P- DSTAR - give value of (4pi*sin(theta))/lambda for H,K,L
C             using information calculated by DSTARF or REPCELL.
C
C     input : IH,IK,IL - indeces h,k,l
C     output: RSQ      - in 1/Angstrom  (4pi*sin(theta))/lambda
C -------------------------------------------------------------------
      COMMON/DST_SCR/  QQ_1,QQ_2,QQ_3,QQ_4,QQ_5,QQ_6
C ******
C---------------------------------------------------------------------
      AH=IH
      AK=IK
      AL=IL
      RSQ=AH*(QQ_1*AH+QQ_4*AK+QQ_5*AL)+QQ_2*AK*AK+(QQ_3*AL+QQ_6*AK)*AL
      RETURN
      END

C ******
      SUBROUTINE LIMHKL(RESMAX,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)
C -------------------------------------------------
C -P- LIMHKL - using CELL parameters from common/CRYSTL/
C -P-          and information about resolution RESMAX defines
C -P-          IHMAX,IKMAX,ILMAX - maximal values of indeces and    
C -P-          NXMIN,NYMIN,NZMIN - minimal grid spasing acceptable
C -P-          for calculation structure factors 
C --------------------------------------------------
C ******
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
C ---------------------------------------------------
      INTEGER*2 ID(50)
C              1  2   3   4   5   6   7   8    9  10
c      DATA ID/  4,  6,  8, 10, 12, 16, 20, 24, 30, 32
c     *       , 36, 48, 50, 54, 60, 64, 72, 80, 90, 96
c     *       ,100,108,120,128,132,144,150,160,162,180
c     *       ,192,200,216,240,250,256,264,270,288,300
c     *       ,320,324,360,384,400,432,450,480,500,512/
      DATA ID/  4,  6,  0,  0, 12,  0,  0, 24,  0, 32
     *       , 36, 48,  0,  0, 60,  0, 72,  0,  0, 96
     *       ,  0,108,120,  0,132,144,  0,  0,  0,180
     *       ,192,  0,216,240,  0,  0,264,  0,288,300
     *       ,  0,324,360,384,  0,432,  0,480,  0,600/
      DATA ND/50/
C---------------------------------------------------------------------
      RES = RESMAX
      IF(RES.LE.0.0) RES = 0.01
      CA=COS(AL_CELL)
      CB=COS(BE_CELL)
      CG=COS(GA_CELL)
      SA=SQRT(ABS(1.-CA*CA))
      SB=SQRT(ABS(1.-CB*CB))
      SG=SQRT(ABS(1.-CG*CG))

      IHMAX = INT(SIALST/(A_STAR*RES*SQRT(SIALST**2+(SIBEST*CG)**2
     .  + (SIGAST*CB)**2 + 2.0*COALST*(2.0*COBEST*COGAST + SIBEST*CB
     .  *SIGAST*CG) - 2.0*(COGAST**2 + COBEST**2))))
      IKMAX = INT(SIBEST/(B_STAR*RES*SQRT(SIBEST**2+(SIALST*CG)**2
     .  + (SIGAST*CA)**2 + 2.0*COBEST*(2.0*COALST*COGAST + SIALST*CA
     .  *SIGAST*CG) - 2.0*(COALST**2 + COGAST**2))))
      ILMAX = INT(SIGAST/(C_STAR*RES*SQRT(SIGAST**2+(SIALST*CB)**2
     .  + (SIBEST*CA)**2 + 2.0*COGAST*(2.0*COALST*COBEST + SIALST*CA
     .  *SIBEST*CB) - 2.0*(COALST**2 + COBEST**2))))
C      IHMAX=(IHMAX+1)/2
C      IKMAX=(IKMAX+1)/2
C      ILMAX=(ILMAX+1)/2
      IH2=IHMAX*2+1
      IK2=IKMAX*2+1
      IL2=ILMAX*2+1

      RES=RES*0.75      

      RH = 1.0/(RES * A_STAR)
      RK = 1.0/(RES * B_STAR)
      RL = 1.0/(RES * C_STAR)
      SH = A_STAR * A_STAR
      SK = B_STAR * B_STAR
      SL = C_STAR * C_STAR
      NX=INT(RH+SQRT(.25/SH+RH**2))+1
      NY=INT(RK+SQRT(.25/SK+RK**2))+1
      NZ=INT(RL+SQRT(.25/SL+RL**2))+1

      IF(MOD(NX,2).NE.0) NX=NX+1
      IF(MOD(NY,2).NE.0) NY=NY+1
      IF(MOD(NZ,2).NE.0) NZ=NZ+1
      DO   I=1,ND
        NXMIN=ID(I)
        IF(NXMIN.GE.NX.AND.NXMIN.GE.IH2) GO TO 100
      ENDDO
  100 CONTINUE
      DO   I=1,ND
        NYMIN=ID(I)
        IF(NYMIN.GE.NY.AND.NYMIN.GE.IK2) GO TO 200
      ENDDO
  200 CONTINUE
      DO   I=1,ND
        NZMIN=ID(I)
        IF(NZMIN.GE.NZ.AND.NZMIN.GE.IL2) GO TO 300
      ENDDO
  300 CONTINUE
      IF(IHMAX.GT.511) IHMAX=511
      IF(IKMAX.GT.511) IKMAX=511
      IF(ILMAX.GT.511) ILMAX=511
      RETURN
      END

      SUBROUTINE RESOLUTION_LIMIT_FOR_TF(RESMAX)
C -------------------------------------------------
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
      IHMAX = 255
      IKMAX = 255
      ILMAX = 255
      RES = SIALST/(A_STAR*REAL(IHMAX)*SQRT(SIALST**2+(SIBEST*CG)**2
     .  + (SIGAST*CB)**2 + 2.0*COALST*(2.0*COBEST*COGAST + SIBEST*CB
     .  *SIGAST*CG) - 2.0*(COGAST**2 + COBEST**2)))
      RES1 = SIBEST/(B_STAR*REAL(IKMAX)*SQRT(SIBEST**2+(SIALST*CG)**2
     .  + (SIGAST*CA)**2 + 2.0*COBEST*(2.0*COALST*COGAST + SIALST*CA
     .  *SIGAST*CG) - 2.0*(COALST**2 + COGAST**2)))
      RES2 = SIGAST/(C_STAR*REAL(ILMAX)*SQRT(SIGAST**2+(SIALST*CB)**2
     .  + (SIBEST*CA)**2 + 2.0*COGAST*(2.0*COALST*COBEST + SIALST*CA
     .  *SIBEST*CB) - 2.0*(COALST**2 + COBEST**2)))
      IF(RES1.GT.RES) RES = RES1      
      IF(RES2.GT.RES) RES = RES2
      RESMAX = RES  
      RETURN
      END

C ******
      SUBROUTINE SETBADD(DMAX,BAVE,NX,NY,NZ,BADD)        
C ----------------------------------
C -P- SETBADD - give Badd.
C ------
C ******
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3)
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
C---------------------------------------------------------------------
      RH = 1.0/(DMAX * A_STAR)
      RK = 1.0/(DMAX * B_STAR)
      RL = 1.0/(DMAX * C_STAR)
      SHH = A_STAR * A_STAR
      SKK = B_STAR * B_STAR
      SLL = C_STAR * C_STAR
      D1=SHH*NX*(NX-2.0*RH)
      D2=SKK*NY*(NY-2.0*RK)
      D3=SLL*NZ*(NZ-2.0*RL)
      D1=AMIN1(D1,D2,D3)
      D2=ALOG(0.35*(15.0+10.0*DMAX))
      BTOT=4.0*D2/D1
c      write(*,*) ' bav,bt:',BAVE,BTOT
      IF(BTOT.GT.35.0) BTOT=35.0
      BADD=BTOT-BAVE
c      write(*,*) ' badd:',BADD
      IF(BADD.LT.0.0) BADD=0.0
      RETURN
      END

C ******
      SUBROUTINE SET_LIMZ(NSYM,ISYM,NZ,IZMAX)
C --------------------------------------------
C -P- SET_LIMZ - return limit of Z (IZmax) for given NZ. 
C --------------------------------------------
      INTEGER NSYM,NZ,IZMAX
      INTEGER*2 ISYM(5,3,NSYM)
C ******
C ---------------------------------------------
      INEG=0
      ITM =1
      IZMAX=NZ-1
      IF(NSYM.GT.1) THEN
        DO I=1,NSYM
          IF(ISYM(1,3,I).EQ.0.AND.ISYM(2,3,I).EQ.0) THEN
            IF(ISYM(3,3,I).LT.0) INEG=1
            TR=REAL(ISYM(4,3,I))/REAL(ISYM(5,3,I))
            IF(ABS(TR-0.5).LT.0.001) THEN
              IT=2 
              IF(ITM.LT.IT) ITM=IT
            ELSE IF(ABS(TR-0.25).LT.0.001) THEN
              IT=4 
              IF(ITM.LT.IT) ITM=IT
            ELSE IF(ABS(TR-0.3333).LT.0.001) THEN
              IT=3 
              IF(ITM.LT.IT) ITM=IT
            ELSE IF(ABS(TR-0.1666).LT.0.001) THEN
              IT=6 
              IF(ITM.LT.IT) ITM=IT
            ELSE IF(ABS(TR-0.125).LT.0.001) THEN
              IT=8 
              IF(ITM.LT.IT) ITM=IT
            ENDIF
          ENDIF
        ENDDO
        IF(INEG.EQ.1) ITM=ITM*2
        IZMAX=FLOAT(NZ)/FLOAT(ITM)+0.001
        IF(IZMAX.GE.NZ) IZMAX= NZ-1

        IF(NSYM.EQ.2) THEN
          IF(ISYM(1,2,2).EQ.0.AND.
     *       ISYM(2,2,2).EQ.1.AND.
     *       ISYM(3,2,2).EQ.0     ) IZMAX = NZ - 1
        ENDIF

      ENDIF

      RETURN
      END


C ******
      SUBROUTINE SYSABS_BL(IH,IK,IL,NSYM,ISYM,JABS)
C
C -P- SYSABS - check systematic absent for h,k,l: 1 - absent, 0 - no.
C  
C -----------------------------------------------
      INTEGER   IH,IK,IL,NSYM,JABS
      INTEGER*2 ISYM(5,3,NSYM)
C ******
      INTEGER JH,JK,JL
C -----------------------------------------------
      JABS=0
      IF(NSYM.GT.1) THEN
        DO I=2,NSYM
          JH= ISYM(1,1,I)*IH + ISYM(1,2,I)*IK + ISYM(1,3,I)*IL
          IF(IH.EQ.JH) THEN
            JK= ISYM(2,1,I)*IH + ISYM(2,2,I)*IK + ISYM(2,3,I)*IL
            IF(IK.EQ.JK) THEN
              JL= ISYM(3,1,I)*IH + ISYM(3,2,I)*IK + ISYM(3,3,I)*IL
              IF(IL.EQ.JL) THEN
                PH= IH*(REAL(ISYM(4,1,I))/REAL(ISYM(5,1,I))) + 
     *              IK*(REAL(ISYM(4,2,I))/REAL(ISYM(5,2,I))) + 
     *              IL*(REAL(ISYM(4,3,I))/REAL(ISYM(5,3,I)))  
                DEL= ABS(PH-NINT(PH))
                IF(DEL.GT.0.05) JABS=1
              ENDIF
            ENDIF
          ENDIF
        ENDDO
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE SPEC_POS(NSYM,ISYM,XF,YF,ZF
     *  ,DLIMX,DLIMY,DLIMZ,MULT)
C -----------------------
C -P- SPEC_POS - check spec.position. Return MULT = 1 or 2,3,..(i.e 1,1/2,1/3) 
C -----------------------
      REAL      XF,YF,ZF
      REAL      DLIMX,DLIMY,DLIMZ
      INTEGER   NSYM,MULT
      INTEGER*2 ISYM(5,3,NSYM)
C ******
C -----------------------
      MULT  = 1
      NSP   = 1
      IF (NSYM.GT.1) THEN
        DO    I=2,NSYM
          X= ISYM(1,1,I)*XF + ISYM(2,1,I)*YF + ISYM(3,1,I)*ZF +
     *       REAL(ISYM(4,1,I))/REAL(ISYM(5,1,I))
          DELX = ABS(X-XF)
          DELX = MOD(DELX,1.0)
          IF(DELX.LE.DLIMX) THEN
            Y= ISYM(1,2,I)*XF + ISYM(2,2,I)*YF + ISYM(3,2,I)*ZF +
     *         REAL(ISYM(4,2,I))/REAL(ISYM(5,2,I))
            DELY = ABS(Y-YF)
            DELY = MOD(DELY,1.0)
            IF(DELY.LE.DLIMY) THEN
              Z= ISYM(1,3,I)*XF + ISYM(2,3,I)*YF + ISYM(3,3,I)*ZF +
     *           REAL(ISYM(4,3,I))/REAL(ISYM(5,3,I))
              DELZ = ABS(Z-ZF)
              DELZ = MOD(DELZ,1.0)
              IF(DELZ.LE.DLIMZ) NSP=NSP+1
            ENDIF
          ENDIF
        ENDDO
        MULT=FLOAT(NSYM)/FLOAT(NSP)+0.01  
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE INIT_CENTR(NSYM,ISYM)
C -----------------------
C -P- INIT_CENTR - initialization for subroutine CENTR_BL.
C -----------------------
C ******
C ----------------------------------------------------
      INTEGER*4 NSYM
      INTEGER*2 ISYM(5,3,*)
C ---
      COMMON /COM_CENTR/ CPROJ,NCENT
      INTEGER NCENT
      REAL CPROJ(3,20)
C ---
      INTEGER IH,IK,IL,J,NC
      REAL CPRJ(3,12)
      INTEGER IHKL(3,12),IN(3)
C
C---- set up tests for 0kl h0l hk0 hhl hkh hkk h-hl hk-h hk-k
C      -h2hl   2h-hl  hkl
C
      DATA IHKL/0,1,2, 1,0,2, 1,2,0, 1,1,10, 1,10,1, 10,1,1, 1,-1,10,
     +          1,10,-1, 10,1,-1, -1,2,10, 2,-1,10, 1,4,8/
      DATA CPRJ/1.0,0.0, 0.0, 0.0,1.0, 0.0, 0.0,0.0,1.0, 1.0,-1.0,0.0,
     +          1.0,0.0,-1.0, 0.0,1.0,-1.0, 1.0,1.0,0.0, 1.0, 0.0,1.0, 
     +          0.0,1.0, 1.0, 2.0,1.0, 0.0, 1.0,2.0,0.0, 0.0, 0.0,0.0/
C --------------------------------------------------------------
      NCENT = 0
      DO    NC = 1,10
        IN(1) = IHKL(1,NC)
        IN(2) = IHKL(2,NC)
        IN(3) = IHKL(3,NC)
C
C ----  Generate symm equivs
C
C ----  test whether h' k' l' equals -h -k -l
C
        DO   J = 1,NSYM
          IH=IN(1)*ISYM(1,1,J)+IN(2)*ISYM(1,2,J)+IN(3)*ISYM(1,3,J)
          IF(IH.EQ.-IN(1)) THEN
            IK=IN(1)*ISYM(2,1,J)+IN(2)*ISYM(2,2,J)+IN(3)*ISYM(2,3,J)
            IF(IK.EQ.-IN(2)) THEN
              IL=IN(1)*ISYM(3,1,J)+IN(2)*ISYM(3,2,J)+IN(3)*ISYM(3,3,J)
              IF(IL.EQ.-IN(3)) THEN
                NCENT = NCENT + 1
                CPROJ(1,NCENT) = CPRJ(1,NC)
                CPROJ(2,NCENT) = CPRJ(2,NC)
                CPROJ(3,NCENT) = CPRJ(3,NC)
                GO TO 30
              ENDIF
            ENDIF
          ENDIF
        ENDDO
C
C---- next symm opn
C
   30   CONTINUE
      ENDDO
      RETURN
      END

C ******
      SUBROUTINE CENTR_BL(IH,IK,IL,ICENT)
C
C -P- CENTR - Determine whether a reflection (IH,IK,IL) is centric (ICENT=1)
C -P-         or not (ICENT=0)
C ******
C ---
      COMMON /COM_CENTR/ CPROJ,NCENT
      INTEGER NCENT
      REAL CPROJ(3,20)
C ---
C     INTEGER IH,IK,IL
C -----------------------------------------------------
      ICENT = 0
      IF(NCENT.GT.0) THEN
        DO    I = 1,NCENT
          IF((CPROJ(1,I)*IH+CPROJ(2,I)*IK+CPROJ(3,I)*IL).EQ.0.0)
     *    GO TO 10
        ENDDO
        RETURN
C ---
   10   ICENT = 1
      ENDIF
      RETURN
      END

      SUBROUTINE CALC_EPS(N,IH,IK,IL,NSYM,ISYM)
C
C    
C
      INTEGER*2 ISYM(5,3,NSYM)
      INTEGER   IHH(192),IKK(192),ILL(192)
C --------------------------------------------
      N=1
      IHH(1)=IH
      IKK(1)=IK
      ILL(1)=IL
      IH1=IHH(1)
      IK1=IKK(1)
      IL1=ILL(1)
      IF(NSYM.LE.1) RETURN

      DO     I=2,NSYM
        JH=ISYM(1,1,I)*IH1 +ISYM(1,2,I)*IK1 +ISYM(1,3,I)*IL1
        JK=ISYM(2,1,I)*IH1 +ISYM(2,2,I)*IK1 +ISYM(2,3,I)*IL1
        JL=ISYM(3,1,I)*IH1 +ISYM(3,2,I)*IK1 +ISYM(3,3,I)*IL1
        IF(JL.LT.0) THEN
          JH=-JH
          JK=-JK
          JL=-JL
        ELSE IF(JL.EQ.0) THEN
          IF(JK.LT.0) THEN
            JH=-JH
            JK=-JK
          ELSE IF(JK.EQ.0) THEN
            IF(JH.LT.0) THEN
              JH=-JH
            ENDIF
          ENDIF
        ENDIF
        IF(N.GT.0) THEN
          DO  L=1,N
            IF(IHH(L).EQ.JH.AND.IKK(L).EQ.JK.AND.ILL(L).EQ.JL)GOTO 10
          ENDDO
        ENDIF
        N = N+1
        IHH(N)=JH
        IKK(N)=JK
        ILL(N)=JL
   10   CONTINUE
      ENDDO
      RETURN
      END

      SUBROUTINE INDMLTT(IHN,IKN,ILN,NGEN,NSYM,ISYM)
C
C -------------------------------------------
      INTEGER*2 ISYM(5,3,*)
      INTEGER   IHH(96),IKK(96),ILL(96)
C -------------------------------------------
      NGEN=0
      DO     I=1,NSYM
        IHS=ISYM(1,1,I)*IHN+ISYM(1,2,I)*IKN+ISYM(1,3,I)*ILN
        IKS=ISYM(2,1,I)*IHN+ISYM(2,2,I)*IKN+ISYM(2,3,I)*ILN
        ILS=ISYM(3,1,I)*IHN+ISYM(3,2,I)*IKN+ISYM(3,3,I)*ILN
        IF(NGEN.GT.0) THEN
          DO     J=1,NGEN
            IF(IHS.EQ.IHH(J).AND.IKS.EQ.IKK(J).AND.
     *         ILS.EQ.ILL(J)) GO TO 1000
          ENDDO
        ENDIF
        NGEN=NGEN+1
        IHH(NGEN)=IHS
        IKK(NGEN)=IKS
        ILL(NGEN)=ILS
 1000   CONTINUE
      ENDDO
      RETURN
      END

C ******
      SUBROUTINE ANOMSC(IH,IK,IL,IANOM,JJSYM,NSYM,ISYM)
C
C     ENTRY ANOMF(MDOC,NSYM,ISYM)
C                 MDOC  - mode of writting messages to DOC-file
C                        0 - only term, < - 0 only file, 0 < < 99 - both
C                        =< 99 - not write
C
C -P- ANOMSC - transforms h,k,l to asymmetrycal part of reciprocal space.
C -P-          before used ANOMF - make the firts call :
C -P-          CALL ANOMF(MDOC,NSYM,ISYM)
C
C     input  : IH,IK,IL - indices h,k,l
C              NSYM     - number operators of symmetry
C              ISYM (5,3,NSYM) - array of operators of symmetry
C     output : IH,IK,IL -   indices h,k,l from asymmetrycal part
C                           of reciprocal space
C              IANOM    - 0   +h,+k,+l
C                         1   -h,-k,-l
C              JJSYM    - number operator of symmetry :
C                              in(h,k,l) -- JJSYM --> out(h,k,l)
C ******
      COMMON/COM_ANOM/ NSEL,ICASE,ISEL(96),IHKL(3)
      INTEGER*2   ISYM(5,3,*)
      INTEGER     IHKL,HKLT(3),HKL(3),ISEL
      INTEGER     HH,HK,HL,HHS,HKS,HLS,H
      INTEGER     HKLS(3)
      CHARACTER   SYM(24)*1,LHKL(3)*1,LP*1,LM*1,LK*1,LB*1,LINE*80
      EQUIVALENCE (HKL(1),HH),(HKL(2),HK),(HKL(3),HL)
      EQUIVALENCE (HKLS(1),HHS),(HKLS(2),HKS),(HKLS(3),HLS)
      DATA LHKL/'H','K','L'/,LP/'+'/,LM/'-'/,LK/','/,LB/' '/
C ------------------------------------------------------------------
      IHKL(1)=IH
      IHKL(2)=IK
      IHKL(3)=IL
      MINNEG=4
      HHS=-10000
      DO   K=1,3
        HKLT(K)=IHKL(K)
      ENDDO
      JCASE=ICASE
      DO    I=1,NSEL
        JSYM=ISEL(I)
        NEG=0
        NZERO=0
        DO   J=1,3
          H=0
          DO    K=1,3
            H=H+ISYM(J,K,JSYM)*HKLT(K)
          ENDDO
          IF(H.LT.0) THEN 
            NEG=NEG+1
          ELSE IF(H.EQ.0) THEN
            JCASE=1
            NZERO=NZERO+1
          ENDIF 
          HKL(J)=H
        ENDDO
        IANO=1
        IF(HL.EQ.0) THEN
          IF((NEG-1).EQ.0) THEN 
            IF(HK.LE.0 ) THEN
              IANO=-1
              NEG=3-NEG-NZERO
              DO    K=1,3
                HKL(K)=-HKL(K)
              ENDDO
            ENDIF
          ELSE IF((NEG-1).GT.0) THEN
            IANO=-1
            NEG=3-NEG-NZERO
            DO    K=1,3
              HKL(K)=-HKL(K)
            ENDDO
          ENDIF
        ELSE IF(HL.LT.0) THEN 
          IANO=-1
          NEG=3-NEG-NZERO
          DO    K=1,3
            HKL(K)=-HKL(K)
          ENDDO
        ENDIF

c        IF(NEG-MINNEG) 30,40,10

        IF((NEG-MINNEG).LT.0) GO TO 30
        IF((NEG-MINNEG).EQ.0) GO TO 40
        IF((NEG-MINNEG).GT.0) GO TO 10

   30   MINNEG=NEG
        IF(NEG.NE.0) GO TO 60
          DO    K=1,3
            HKLS(K)=HKL(K)
          ENDDO
          JJSYM=JSYM
          IANOM=IANO
C
C          IF(JCASE) 100,100,10
C
          IF(JCASE.LT.0) GO TO 100
          IF(JCASE.EQ.0) GO TO 100
          IF(JCASE.GT.0) GO TO 10

   40     IF(HKS.GE.0 .AND.HK.GE.0 ) GO TO 50

c          IF(HK-HKS) 10,50,60
c   50     IF(HH-HHS) 10,68,60
c   68     IF(HL-HLS) 60,67,10

          IF((HK-HKS).LT.0) GO TO 10
          IF((HK-HKS).EQ.0) GO TO 50
          IF((HK-HKS).GT.0) GO TO 60
   50     IF((HH-HHS).LT.0) GO TO 10
          IF((HH-HHS).EQ.0) GO TO 68
          IF((HH-HHS).GT.0) GO TO 60
   68     IF((HL-HLS).LT.0) GO TO 60
          IF((HL-HLS).EQ.0) GO TO 67
          IF((HL-HLS).GT.0) GO TO 10

   67     IF(IANOM.GT.0) GO TO 10
   60   CONTINUE
        DO    K=1,3
          HKLS(K)=HKL(K)
        ENDDO
        JJSYM=JSYM
        IANOM=IANO
   10   CONTINUE
      ENDDO
  100 CONTINUE
      DO    K=1,3
        IHKL(K)=HKLS(K)
      ENDDO
      IH=IHKL(1)
      IK=IHKL(2)
      IL=IHKL(3)
      RETURN
C ------------------------------
      ENTRY ANOMF(MDOC,NSYM,ISYM)
C ------------------------------
      IP=0
      CALL MSGDOC(MDOC
     .    ,'     EQUIVALENT REFLEXS (WITHOUT FRIDEL-SYMMETRY)')
      ICASE=0
      NSEL=0
      DO    I=1,NSYM
        IF(I.GT.1) THEN
          DO    J=1,NSEL
            ISL=ISEL(J)
            DO     II=1,3
              DO     KK=1,3
                IF(ISYM(II,KK,ISL).NE.ISYM(II,KK,I)) GO TO 230
              ENDDO
            ENDDO
            GO TO 200
  230       CONTINUE
          ENDDO
        ENDIF
        NSEL=NSEL+1
        ISEL(NSEL)=I
        NEG=0
        IZ=0
        ICL=-4
        DO  K=1,24
          SYM(K)=LB
        ENDDO
        SYM(8)=LK
        SYM(17)=LK
        DO    J=1,3
          ICL=ICL+3
          DO    K=1,3
            ICL=ICL+2
            H=ISYM(J,K,I)
            IF(H.LT.0) THEN  
              NEG=NEG+1
              SYM(ICL)=LM
              SYM(ICL+1)=LHKL(K)
              IZ=IZ+1
            ELSE IF(H.GT.0) THEN
              SYM(ICL)=LP
              SYM(ICL+1)=LHKL(K)
              IZ=IZ+1
            ENDIF
          ENDDO
        ENDDO
        WRITE(LINE,1005) NSEL,SYM
 1005   FORMAT(5X,' ',I2,' ) ',24A1)
        CALL MSGDOC(MDOC,LINE)
        IF(NEG.EQ.IZ.OR.NEG.EQ.0) IP=IP+1
  200   CONTINUE
      ENDDO
      IF(IP.EQ.1) RETURN
      ICASE=1
      RETURN
      END


C ******
      SUBROUTINE ASCELL(ITYPE,XI,YI,ZI,NSYM,ISYM,ZMAX,XO,YO,ZO,
     .                   JSYM,TRANS,IERR)
C                                                                  
C -P- ASCELL - transforms:  XI,YI,ZI  /in frac. units/
C -P-          to asymmetric part of cell -->  XO,YO,ZO,
C
C      ITYPE = 0   0 =< XO  < 1     0 =< YO  < 1     0 =< ZO =< ZMAX
C            = 1   0 =< XO  < 1     0 =< YO =< 1/2   0 =< ZO =< ZMAX
C            = 2   0 =< XO =< 1/2   0 =< YO =< 1/2   0 =< ZO =< ZMAX
C                                                                  
C      NSYM  -  no op. symm.                      
C      ISYM - sym-matrix from space group
C  X'=ISYM(1,1,J)*X+ISYM(2,1,J)*Y+ISYM(3,1,J)*Z+ISYM(4,1,J)/ISYM(5,1,J)
C  Y'=ISYM(1,2,J)*X+ISYM(2,2,J)*Y+ISYM(3,2,J)*Z+ISYM(4,2,J)/ISYM(5,2,J)
C  Z'=ISYM(1,3,J)*X+ISYM(2,3,J)*Y+ISYM(3,3,J)*Z+ISYM(4,3,J)/ISYM(5,3,J)
C
C      JSYM     - number of operator of symmetry
C      TRANS(3) - translations
C
C            XO = [Rjsym]*XI + TRANS(1)
C            YO = [Rjsym]*YI + TRANS(2)
C            ZO = [Rjsym]*ZI + TRANS(3)
C      
C      IERR = 0   OK
C           = 1   NO SUCH POINT
C --------------------------------------------------------------
      INTEGER*2 ISYM(5,3,NSYM)
      REAL      TRANS(3)
C ---------------------------------------
C ******
      IERR=0
      DO     IS=1,NSYM
        JSYM=IS
        XO=ISYM(1,1,IS)*XI + ISYM(2,1,IS)*YI + ISYM(3,1,IS)*ZI
     .     + REAL(ISYM(4,1,IS))/REAL(ISYM(5,1,IS))
        YO=ISYM(1,2,IS)*XI + ISYM(2,2,IS)*YI + ISYM(3,2,IS)*ZI
     .     + REAL(ISYM(4,2,IS))/REAL(ISYM(5,2,IS))
        ZO=ISYM(1,3,IS)*XI + ISYM(2,3,IS)*YI + ISYM(3,3,IS)*ZI
     .     + REAL(ISYM(4,3,IS))/REAL(ISYM(5,3,IS))
        TRANS(3)=0.0
31      IF(ZO.LT.0.0) THEN
          ZO=ZO+1.0
          TRANS(3)=TRANS(3)+1.0
          GO TO 31
        ENDIF
32      IF(ZO.GE.1.0) THEN
          ZO=ZO-1.0                                             
          TRANS(3)=TRANS(3)-1.0
          GO TO 32
        ENDIF

        IF(ZO.GT.ZMAX) GO TO 200

        TRANS(1)=0.0
11      IF(XO.LT.0.0) THEN
          XO=XO+1.0
          TRANS(1)=TRANS(1)+1.0
          GO TO 11
        ENDIF
12      IF(XO.GE.1.0) THEN
          XO=XO-1.0
          TRANS(1)=TRANS(1)-1.0
          GO TO 12
        ENDIF

        TRANS(2)=0.0
21      IF(YO.LT.0.0) THEN
          YO=YO+1.0
          TRANS(2)=TRANS(2)+1.0
          GO TO 21
        ENDIF
22      IF(YO.GE.1.0) THEN
          YO=YO-1.0
          TRANS(2)=TRANS(2)-1.0
          GO TO 22
        ENDIF

        IF(ITYPE.EQ.0)         GO TO 100

        IF(YO.LE.0.5)   THEN
          IF(ITYPE.EQ.1)       GO TO 100
          IF(XO.LE.0.5) THEN
            IF(ITYPE.EQ.2)     GO TO 100
          ENDIF
        ENDIF

  200   CONTINUE
      ENDDO
C -------------------
      IERR=1
  100 CONTINUE
      RETURN
      END

C ******
      SUBROUTINE GENER(ITYPE,NGEN,IH,IK,IL,FA,FB
     *                 ,NSYM,ISYM,IPRSYM)
C
C     This subroutine used only in program "FFT"( calculate El. Dens).
C -------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER   IH(IPRSYM),IK(IPRSYM),IL(IPRSYM)
      REAL      FA(IPRSYM),FB(IPRSYM)
      COMMON/COM_FFT/ COSD,SIND
      REAL      COSD(25),SIND(25)
C ******
      REAL      TWOPI
      INTEGER   IFIRST
      DATA      IFIRST/0/
C     DATA      TWOPI/6.2831852/
C -------------------------------------------
      IF(IFIRST.EQ.0) THEN
        TWOPI=8.0*ATAN(1.0)
        AN=TWOPI/24.
        CS=COS(AN)
        SS=SIN(AN)
        COSD(1)=1.
        SIND(1)=0.
        DO     I=2,25
          COSD(I)=COSD(I-1)*CS-SIND(I-1)*SS
          SIND(I)=SIND(I-1)*CS+COSD(I-1)*SS
        ENDDO
        IFIRST=1
      ENDIF

      NGEN=0
      IH1=IH(1)     
      IK1=IK(1)     
      IL1=IL(1)     
      FB1=FB(1)     
      FAA=FA(1)     
      IF(ITYPE.EQ.1) FB1=0.
      DO     I=1,NSYM
        JH=ISYM(1,1,I)*IH1 +ISYM(1,2,I)*IK1 +ISYM(1,3,I)*IL1
        JK=ISYM(2,1,I)*IH1 +ISYM(2,2,I)*IK1 +ISYM(2,3,I)*IL1
        JL=ISYM(3,1,I)*IH1 +ISYM(3,2,I)*IK1 +ISYM(3,3,I)*IL1
        FBB=FB1      
        IT=ISYM(4,1,I)*IH1 +ISYM(4,2,I)*IK1 +ISYM(4,3,I)*IL1
        IF(JH.LT.0) THEN              
          JH=-JH        
          JK=-JK        
          JL=-JL        
          IT=-IT        
          FBB=-FBB      
        ENDIF
        IF(NGEN.GT.0) THEN                   
          DO     L=1,NGEN   
            IF(IH(L).EQ.JH.AND.IK(L).EQ.JK.AND.IL(L).EQ.JL) GO TO 100
          ENDDO
        ENDIF
        NGEN=NGEN+1
        IH(NGEN)=JH
        IK(NGEN)=JK
        IL(NGEN)=JL
        IF(ITYPE.EQ.1.OR.I.EQ.1) THEN
          FA(NGEN)=FAA
          FB(NGEN)=FBB
        ELSE
          IF(IT.LT.0) THEN              
            IT=IABS(IT)   
            IT=24-MOD(IT,24)                  
          ELSE
            IT=MOD(IT,24) 
          ENDIF
          IT=IT+1       
          FA(NGEN)=FAA*COSD(IT)+FBB*SIND(IT)
          FB(NGEN)=FBB*COSD(IT)-FAA*SIND(IT)
        ENDIF
        IF(JH.EQ.0) THEN
          IF(NGEN.GT.1) THEN
            DO     K=1,NGEN-1
              IF(JH.EQ.IH(K).AND.-JK.EQ.IK(K).AND.-JL.EQ.IL(K))
     .        GO TO 100
            ENDDO
          ENDIF
          NGEN=NGEN+1
          IH(NGEN)= JH
          IK(NGEN)=-JK
          IL(NGEN)=-JL
          FA(NGEN)= FA(NGEN-1)
          FB(NGEN)=-FB(NGEN-1)
        ENDIF
  100   CONTINUE      
      ENDDO
      RETURN
      END

C ******
      SUBROUTINE ASYM(JS,JH,JK,JL,IS,IH,IK,IL)
C
C -P- ASYM - convert indeces to asymm. part reciprocal space
C     JH,JK,JL --> IH,IK,IL , IL >= 0; if IL=0 - IK>=0; if IL=IK=0 - H > 0
C     IS = -JS if for IH,IK,IL was used  FRIDEL-SYMMETRY-OPERATION 
C
C ******
      IH=JH
      IK=JK
      IL=JL
      IS=JS
      IF(IL.LT.0) THEN
        IH=-IH
        IK=-IK
        IL=-IL
        IS=-IS
      ELSE IF(IL.EQ.0) THEN
        IF(IK.LT.0) THEN
          IH=-IH
          IK=-IK
          IS=-IS
        ELSE IF(IK.EQ.0) THEN
          IF(IH.LT.0) THEN
            IH=-IH
            IS=-IS
          ENDIF
        ENDIF
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE INDGEN(IHN,IKN,ILN,IHH,IKK,ILL,NGEN,IH,IK,IL,LSYM,
     *                  NSYM,ISYM,IPRSYM)
C
C -P- INDGEN - generates symmetry related indeces: 
C                                               IHH,IKK,ILL and IH,IK,IL 
C       input: IHN,IKN,ILN - index of reflection.
C              NSYM        - number od op. cryst. symmetry.
C              ISYM()      - op. cryst symmetry
C              IPRSYM      - dimension of array ISYM(5,3,.),IHH()..,IH().. 
C   IH(NSYM),IK(NSYM),IL(NSYM) - indeces from IHN,IKN,ILN by matrix ISYM 
C                    converted indeces to asymm. part reciprocal space
C   IL(NSYM) >= 0; if IL=0 - IK>=0; if IL=IK=0 - H > 0
C   LSYM(NSYM) = -1 if for IH,IK,IL was used  FRIDEL-SYMMETRY-OPERATION 
C   NGEN - number of different indeces IH,IK,IL 
C   IHH(NGEN),IKK(NGEN),ILL(NGEN) only different IH,IK,IL indeces.
C
C -------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER   IH(IPRSYM),IK(IPRSYM),IL(IPRSYM),LSYM(IPRSYM)
      INTEGER   IHH(IPRSYM),IKK(IPRSYM),ILL(IPRSYM)
C -------------------------------------------
C ******
      NGEN=0
      DO     I=1,NSYM
        IHS=ISYM(1,1,I)*IHN+ISYM(1,2,I)*IKN+ISYM(1,3,I)*ILN
        IKS=ISYM(2,1,I)*IHN+ISYM(2,2,I)*IKN+ISYM(2,3,I)*ILN
        ILS=ISYM(3,1,I)*IHN+ISYM(3,2,I)*IKN+ISYM(3,3,I)*ILN
        LS =1
        IF(ILS.LT.0) THEN
          IHS=-IHS
          IKS=-IKS
          ILS=-ILS
          LS =-LS
        ELSE IF(ILS.EQ.0) THEN
          IF(IKS.LT.0) THEN
            IHS=-IHS
            IKS=-IKS
            LS =-LS
          ELSE IF(IKS.EQ.0) THEN
            IF(IHS.LT.0) THEN
              IHS=-IHS
              LS =-LS
            ENDIF
          ENDIF
        ENDIF
        IH(I)  =IHS
        IK(I)  =IKS
        IL(I)  =ILS
        LSYM(I)=LS
        IF(NGEN.GT.0) THEN
          DO     J=1,NGEN
            IF(IHS.EQ.IHH(J).AND.IKS.EQ.IKK(J).AND.
     *         ILS.EQ.ILL(J)) GO TO 1000
          ENDDO
        ENDIF
        NGEN=NGEN+1
        IHH(NGEN)=IHS
        IKK(NGEN)=IKS
        ILL(NGEN)=ILS
 1000   CONTINUE
      ENDDO
      END


      SUBROUTINE GET_NSYMP(MDOC,NSYM,NSYMP,ISYM,IPRSYM,IERR)
C --------------------------------
      INTEGER   MDOC,IERR
      INTEGER   NSYM,NSYMP,IPRSYM
      INTEGER*2 ISYM(5,3,IPRSYM)
C ---
      CHARACTER LINE*80
C --------------------------------------------
      INTEGER*2 IHT(200),IKT(200),ILT(200)
C ---------------------------------------------
      IERR = 0
      NGEN = 0
      IHP  = 1
      IKP  = 5
      ILP  = 7
      DO     I=1,NSYM
        IHS=ISYM(1,1,I)*IHP+ISYM(1,2,I)*IKP+ISYM(1,3,I)*ILP
        IKS=ISYM(2,1,I)*IHP+ISYM(2,2,I)*IKP+ISYM(2,3,I)*ILP
        ILS=ISYM(3,1,I)*IHP+ISYM(3,2,I)*IKP+ISYM(3,3,I)*ILP
        ISS=1
        CALL ASYM(ISS,IHS,IKS,ILS,JSS,JHH,JKK,JLL)
        IF(NGEN.GT.0) THEN
          DO     J=1,NGEN
            IF(JHH.EQ.IHT(J).AND.JKK.EQ.IKT(J).AND.
     *         JLL.EQ.ILT(J)) THEN
              GO TO 100
            ENDIF
          ENDDO
        ENDIF
        NGEN=NGEN+1
        IHT(NGEN)=JHH
        IKT(NGEN)=JKK
        ILT(NGEN)=JLL
 100   CONTINUE
      ENDDO
      NSYMP=NGEN
      RETURN
      END

      SUBROUTINE GET_TWOFOLD_PATT(NSYM,ISYM,ITWOX,ITWOY)
C --------------------------------------------
C --------------------------------------------
      INTEGER   NSYM,NZ,IZMAX
      INTEGER*2 ISYM(5,3,NSYM)
C ******
C ---------------------------------------------
      ITWOX = 0
      ITWOY = 0

      IF(NSYM.GT.1) THEN
        DO I=2,NSYM
          IF(ISYM(2,1,I).EQ.0.AND.
     *       ISYM(3,1,I).EQ.0.AND.ISYM(1,2,I).EQ.0.AND.
     *       ISYM(3,2,I).EQ.0.AND.ISYM(1,3,I).EQ.0.AND.
     *       ISYM(2,3,I).EQ.0                          ) THEN

            IF(ISYM(1,1,I).EQ. 1.AND.ISYM(2,2,I).EQ.-1.AND.
     *         ISYM(3,3,I).EQ.-1) THEN
               ITWOX = 1
            ENDIF

            IF(ISYM(1,1,I).EQ.-1.AND.ISYM(2,2,I).EQ.1.AND.
     *         ISYM(3,3,I).EQ.-1) THEN
               ITWOY = 1
            ENDIF

          ENDIF
        ENDDO
      ENDIF

      RETURN
      END



C ******
      SUBROUTINE GET_NSYMZ(NSYM,ISYM,NSYMZ)
C -P- GET_NSYMZ computes symmetry Z-axis in Patterson 
      INTEGER*2 ISYM(5,3,*)
C ******
C --------------------------
      NSYMZ=1
      IF(NSYM.GT.1) THEN
        DO I=2,NSYM
          IF(ISYM(1,1,I).EQ.-1.AND.ISYM(2,1,I).EQ. 0.AND.
     *       ISYM(3,1,I).EQ. 0.AND.
     *       ISYM(1,2,I).EQ. 0.AND.ISYM(2,2,I).EQ.-1.AND.
     *       ISYM(3,2,I).EQ. 0.AND.
     *       ISYM(1,3,I).EQ. 0.AND.ISYM(2,3,I).EQ. 0.AND.
     *       ISYM(3,3,I).EQ. 1) THEN
            IF(NSYMZ.EQ.1) THEN 
              NSYMZ=2
            ELSE IF(NSYMZ.EQ.3) THEN
              NSYMZ=6
            ELSE IF(NSYMZ.EQ.4) THEN

            ENDIF 
          ENDIF 
          IF(ISYM(1,1,I).EQ. 0.AND.ISYM(2,1,I).EQ.-1.AND.
     *       ISYM(3,1,I).EQ. 0.AND.
     *       ISYM(1,2,I).EQ. 1.AND.ISYM(2,2,I).EQ. 0.AND.
     *       ISYM(3,2,I).EQ. 0.AND.
     *       ISYM(1,3,I).EQ. 0.AND.ISYM(2,3,I).EQ. 0.AND.
     *       ISYM(3,3,I).EQ. 1) THEN
            IF(NSYMZ.EQ.1) THEN 
              NSYMZ=4
            ELSE IF(NSYMZ.EQ.2) THEN 
              NSYMZ=4
            ELSE IF(NSYMZ.EQ.3) THEN
              NSYMZ=12
            ELSE IF(NSYMZ.EQ.6) THEN
              NSYMZ=12
            ENDIF 
          ENDIF 
          IF(ISYM(1,1,I).EQ. 0.AND.ISYM(2,1,I).EQ.-1.AND.
     *       ISYM(3,1,I).EQ. 0.AND.
     *       ISYM(1,2,I).EQ. 1.AND.ISYM(2,2,I).EQ.-1.AND.
     *       ISYM(3,2,I).EQ. 0.AND.
     *       ISYM(1,3,I).EQ. 0.AND.ISYM(2,3,I).EQ. 0.AND.
     *       ISYM(3,3,I).EQ. 1) THEN
            IF(NSYMZ.EQ.1) THEN 
              NSYMZ=3
            ELSE IF(NSYMZ.EQ.2) THEN
              NSYMZ=6
            ELSE IF(NSYMZ.EQ.4) THEN
              NSYMZ=12
            ENDIF 
          ENDIF 
        ENDDO
      ENDIF
      RETURN
      END


C ******
      SUBROUTINE CHECK_REF(NSYM,ISYM,IFX,IFY,IFZ)             
C -P- CHECK_REF check possibility to refine coords: for x IFX = 1 - yes, 0 - no
      INTEGER*2 ISYM(5,3,*)
C ******
C ------------------------------------------------
      IFX=0
      IFY=0
      IFZ=0
      IF(NSYM.LE.1) RETURN
      IX=13
      IY=17
      IZ=19
      DO I=2,NSYM
        IXX=ISYM(1,1,I)*IX+ISYM(2,1,I)*IY+ISYM(3,1,I)*IZ
        IYY=ISYM(1,2,I)*IX+ISYM(2,2,I)*IY+ISYM(3,2,I)*IZ
        IZZ=ISYM(1,3,I)*IX+ISYM(2,3,I)*IY+ISYM(3,3,I)*IZ
        IF((IX-IXX).NE.0) IFX=1
        IF((IY-IYY).NE.0) IFY=1
        IF((IZ-IZZ).NE.0) IFZ=1
      ENDDO
      RETURN
      END

C ******
      SUBROUTINE GEE(RH,RAD,GGG)
C
C -P- GEE - calc structure factor of scattering from Sphere 
C           with radius=RAD
C     RH      - in 1/Angstrom  (4pi*sin(theta))/lambda
C
      REAL RH,RAD,GGG
C ******
      REAL TWOPI
      DATA TWOPI/6.2831832/
C -------------------------------------
C     TWOPI=8.0*ATAN(1.0)
      T=RH*RAD*TWOPI
      COST=COS(T)
      SINT=SIN(T)
      T3=T*T*T
      GGG=(2.0*TWOPI*RAD*RAD*RAD*(SINT-T*COST))/T3
      RETURN
      END

C ******
      SUBROUTINE GAUSS_TRP(RH,RAD,GGG)
C
C -P- GAUSS_TRP - calc structure factor of scattering for Gaussian  
C                 with width = RAD
C     RH      - in 1/Angstrom  (4pi*sin(theta))/lambda
C
      REAL RH,RAD,GGG
C ******
      RSQ= RH*RH
      B  = RAD*RAD
      GGG=EXP(-B*RSQ)*1000.0
      RETURN
      END

C ******
      SUBROUTINE CALC_ORIG_AV(MDOC,NORIG,SOR,IPRORG
     *   ,NSYM,ISYM,IPRSYM,IERR)
C
C -P- CALC_ORIG_AV - creats list of equivalent origins.
C                    NORIG - number of origins. 
C                    SOR(3,i) - vector of origin (for example : 0.5,0.0,0.5)  
C                               only positive components.
C                               include vector: (0,0,0)
C -------------------------------------------------------------
      REAL      SOR(3,IPRORG)
C ******
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER   M(3,3),IS(3),JS,ID(6)
      CHARACTER LINE*80
      DATA      ID/0,6,4,8,3,9/
C                   1/2 1/3 2/3 1/4 3/4 
C -------------------------------------------------------------
      NORIG=1
      SOR(1,1)=0.0  
      SOR(2,1)=0.0
      SOR(3,1)=0.0
      CALL CHECK_REF(NSYM,ISYM,IFX,IFY,IFZ)
      IF(NSYM.LE.1) GO TO 100
      DO K1=1,6
      DO K2=1,6
      DO K3=1,6
        IF(K1.NE.1.OR.K2.NE.1.OR.K3.NE.1) THEN
          IS(1)=ID(K1)
          IS(2)=ID(K2)
          IS(3)=ID(K3)

          IF(IFX.EQ.0.AND.IS(1).NE.0) GO TO 200
          IF(IFY.EQ.0.AND.IS(2).NE.0) GO TO 200
          IF(IFZ.EQ.0.AND.IS(3).NE.0) GO TO 200

          DO I=1,NSYM-1
          DO J=I+1,NSYM
            DO K=1,3
            DO L=1,3
              M(K,L)=ISYM(K,L,I)-ISYM(K,L,J)
            ENDDO
            ENDDO
            DO K=1,3
              JS=M(1,K)*IS(1)+M(2,K)*IS(2)+M(3,K)*IS(3)
              IF(MOD(JS,12).NE.0) GO TO 200 
            ENDDO
          ENDDO
          ENDDO
          IF(NORIG.GE.IPRORG) GO TO 100
          NORIG=NORIG+1
          SOR(1,NORIG)=IS(1)/12.0
          SOR(2,NORIG)=IS(2)/12.0
          SOR(3,NORIG)=IS(3)/12.0
 200      CONTINUE
        ENDIF
      ENDDO
      ENDDO
      ENDDO
 100  CONTINUE

c      WRITE(*,*) ' NOR=',NORIG
c      DO I=1,NORIG
c        WRITE(*,*) SOR(1,I),SOR(2,I),SOR(3,I)
c      ENDDO

      RETURN
      END

C ******
      SUBROUTINE PACK(IND,IH,IK,IL)
C
C -P- PACK - pack indices h,k,l --> IND
C
      INTEGER*4 IH,IK,IL,IND

C ******
      IND=((IL+512)*1024+IK+512)*1024+IH+512
      RETURN
      END  

C ******
      SUBROUTINE UNPACK(IND,IH,IK,IL)
C
C -P- UNPACK - unpack IND --> indices h,k,l 
C
      INTEGER*4 IH,IK,IL,IND
C ******
      ITEMP1 = IND/(1024*1024)                                       
      IL     = ITEMP1-512   
      ITEMP1 = ITEMP1*1024*1024                                  
      ITEMP1 = IND-ITEMP1
      ITEMP2 = ITEMP1/1024                       
      IK     = ITEMP2-512                                                      
      ITEMP2 = ITEMP2*1024                                     
      ITEMP2 = ITEMP1-ITEMP2                     
      IH     = ITEMP2-512              
      RETURN
      END

C -P-
C -P------ others useful subroutines  --------------------
C -P-

      SUBROUTINE SET_BYTE
      COMMON/COM_BYTE/ IBYTE1,IBYTE2
     *,ISTART_A_CAP,ISTART_A_LOW,ISTART_DIG_0
C --------------------------
      INTEGER   IN4
      INTEGER*2 IN2(2)
      EQUIVALENCE (IN4,IN2(1))
C -----------------------
      CHARACTER CHAR*1
      INTEGER*2 ICH
      CHARACTER CH2*2
      EQUIVALENCE (CH2,ICH)
C -----
      IN2(1)=100
      IN2(2)=0
      IF(IN4.EQ.100) THEN
C          IN4
C          2 1
        IBYTE1=1
        IBYTE2=2
      ELSE
C          IN4
C          1 2
        IBYTE1=2
        IBYTE2=1
      ENDIF
C -----------------------------------------
      CHAR='0'
      ICH=0
      CH2(IBYTE1:IBYTE1)=CHAR
      ISTART_DIG_0=ICH
      CHAR='A'
      ICH=0
      CH2(IBYTE1:IBYTE1)=CHAR
      ISTART_A_CAP=ICH
      CHAR='a'
      ICH=0
      CH2(IBYTE1:IBYTE1)=CHAR
      ISTART_A_LOW=ICH
      RETURN
      END

C ******
      SUBROUTINE CHECK_LINE(IMODE,LINE)
C ------------------------------------------
C -P- CHECK_LINE - check and convert symbols of line.
C               MODE  0  only check
C                    -1  convert symbols to low case.
C                     1  to upper
C ---------------------------------------------
      CHARACTER LINE*(*)
      COMMON/COM_BYTE/ IBYTE1,IBYTE2
     *,ISTART_A_CAP,ISTART_A_LOW,ISTART_DIG_0
C ******
      INTEGER   ICH4
      CHARACTER CHAR*1,TYPE*1
C -----------------------------------------
      CALL LENSTR_BL(LINE,LEN)
C     IF(LEN.GT.256) LEN=256
      IF(LEN.GT.0) THEN
        DO I=1,LEN       
          ICH4=0
          CHAR=LINE(I:I) 
          CALL CHKSMB(CHAR,TYPE)
          IF(TYPE.EQ.'l'.AND.IMODE.EQ.1) THEN
            CALL CHTOINT(CHAR,ICH4)
C           ICH4=ICH4 - 32
            ICH4=ICH4 - (ISTART_A_LOW - ISTART_A_CAP)
            CALL INTTOCH(CHAR,ICH4)
          ELSE IF(TYPE.EQ.'L'.AND.IMODE.EQ.-1) THEN
            CALL CHTOINT(CHAR,ICH4)
C           ICH4=ICH4 + 32
            ICH4=ICH4 + (ISTART_A_LOW - ISTART_A_CAP)
            CALL INTTOCH(CHAR,ICH4)
          ELSE IF(TYPE.EQ.'?') THEN
            CHAR = ' '
          ENDIF
          LINE(I:I)=CHAR
        ENDDO
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE CHKSMB(CHAR,TYPE)
C ------------------------------------------
C -P- CHKSMB - check symbol.
C
C  input: CHAR - one symbol.   
C  output TYPE - one symbol
C
C  if   CHAR = 'A' -- 'Z'           TYPE = 'L'    
C       CHAR = 'a' -- 'z'           TYPE = 'l'    
C       CHAR = '0' -- '9'           TYPE = 'D'    
C       CHAR = '+' or '-'           TYPE = 'S'
C       CHAR = '*' or '/' or
C              '=' or '.'           TYPE = 'O'
C       CHAR = ' '                  TYPE = 'B'
C       CHAR = any printed symbol   TYPE = 'C'
C  else             Type = '?'
C ---------------------------------------------
      CHARACTER CHAR*1,TYPE*1
      COMMON/COM_BYTE/ IBYTE1,IBYTE2
     *,ISTART_A_CAP,ISTART_A_LOW,ISTART_DIG_0
C ******
      INTEGER   ICH
      CHARACTER CH*1,CH1*1,CH2*2
C -----------------------------------------
      CH2 = '\\'
      TYPE='?'
      ICH=0
      CH=CHAR
      CALL LENSTR_BL(CH,LEN)
      IF(CH.EQ.' '.AND.LEN.LE.0) LEN=1
      IF(LEN.LE.0) THEN
        TYPE='?'
        RETURN
      ENDIF

      CALL CHTOINT(CH,ICH)

C      IF(ICH.GE. 65 .AND.ICH.LE. 90 ) THEN
C        TYPE='L'
C      ELSE IF(ICH.GE. 97 .AND.ICH.LE.122 ) THEN
C        TYPE='l'
C      ELSE IF(ICH.GE. 48 .AND.ICH.LE. 57 ) THEN
C        TYPE='D'

      ISF_CAP=ISTART_A_CAP+25
      ISF_LOW=ISTART_A_LOW+25
      ISF_DIG=ISTART_DIG_0+9
      
      IF(ICH.GE.ISTART_A_CAP.AND.ICH.LE.ISF_CAP ) THEN
        TYPE='L'
      ELSE IF(ICH.GE.ISTART_A_LOW.AND.ICH.LE.ISF_LOW ) THEN
        TYPE='l'
      ELSE IF(ICH.GE.ISTART_DIG_0.AND.ICH.LE.ISF_DIG ) THEN
        TYPE='D'
      ELSE IF(CH.EQ.'+'.OR.CH.EQ.'-') THEN
        TYPE='S'
      ELSE IF(CH.EQ.'*'.OR.CH.EQ.'/'.OR.CH.EQ.'.'.OR.CH.EQ.'=') THEN
        TYPE='O'
      ELSE IF(CH.EQ.' ') THEN
        TYPE='B'
      ELSE IF(CH.EQ.'''') THEN
C             '
        TYPE='C'
      ELSE IF(CH.EQ.'_') THEN
        TYPE='U'
C      ELSE IF(CH.EQ.'\\') THEN
      ELSE IF(CH.EQ.CH2(1:1)) THEN
C             \
        TYPE='C'
      ELSE 
        IF(CH.EQ.'!'.OR.CH.EQ.'@'.OR.CH.EQ.'#'.OR.CH.EQ.'$'
     * .OR.CH.EQ.'"'.OR.CH.EQ.'>'.OR.CH.EQ.'%'.OR.CH.EQ.'^'
     * .OR.CH.EQ.'`'.OR.CH.EQ.'?'.OR.CH.EQ.'('.OR.CH.EQ.'['
     * .OR.CH.EQ.'&'.OR.CH.EQ.'<'.OR.CH.EQ.')'.OR.CH.EQ.'~'
     * .OR.CH.EQ.']'.OR.CH.EQ.'{'.OR.CH.EQ.'}'.OR.CH.EQ.'|'
     * .OR.CH.EQ.';'.OR.CH.EQ.':'.OR.CH.EQ.',') THEN
          TYPE='C'
        ENDIF
      ENDIF
      RETURN
      END



C ******
      SUBROUTINE CHTOINT(CHAR,ICHAR)
C ------------------------------------------
C -P- CHTOINT - convert a character to integer
C ---------------------------------------------
      CHARACTER CHAR*1
      INTEGER*4 ICHAR
C ----------------------------------------
      COMMON/COM_BYTE/ IBYTE1,IBYTE2
     *,ISTART_A_CAP,ISTART_A_LOW,ISTART_DIG_0
C ******
      INTEGER*2 ICH
      CHARACTER CH2*2
      EQUIVALENCE (CH2,ICH)
C -----------------------------------------
      ICH=0
      CH2(IBYTE1:IBYTE1)=CHAR
      ICHAR=ICH
      RETURN
      END

C ******
      SUBROUTINE INTTOCH(CHAR,ICHAR)
C ------------------------------------------
C -P- CHTOINT - convert a character to integer
C ---------------------------------------------
      CHARACTER CHAR*1
      INTEGER*4 ICHAR
C ----------------------------------------
      COMMON/COM_BYTE/ IBYTE1,IBYTE2
     *,ISTART_A_CAP,ISTART_A_LOW,ISTART_DIG_0
C ******
      INTEGER*2 ICH
      CHARACTER CH2*2
      EQUIVALENCE (CH2,ICH)
C -----------------------------------------
      ICH=ICHAR
      CHAR=CH2(IBYTE1:IBYTE1)
      RETURN
      END

C ******
      SUBROUTINE HSRD(A)
C -P- HSRD - gives A - random variable / -0.5 =< A =< 0.5 /
C
C ******
      INTEGER INIT,N
      DATA INIT/0/,N/0/
C -----------------------------------------
      IF(INIT.EQ.0) THEN
        N    = 1342773
        INIT = 1
      ENDIF

c     N = N*65539 + 2147483647 + 1

      N = N*65539 + 21474836 + 1

      A = ABS(N*.4656613E-9)-.5
      RETURN
      END

C ******
      SUBROUTINE CHCLOCK(LINE)
C
C -P- CHCLOCK - converts clock and data to characters string /LINE*20/
C     example out string : 'D: 2.04.05/ 5.03.86 '
C
C ******
      CHARACTER LINE*20
      INTEGER IH(7)
C ----------------------------------------------------------------------
      CALL CLOCK(IH)
      ITEMP=IH(7)/100
      IH(7)=IH(7)-ITEMP*100
      WRITE(LINE,1) IH(4),IH(3),IH(2),IH(5),IH(6),IH(7) 
   1  FORMAT('D:',I2,'.',I2,'.',I2,'/',I2,'.',I2,'.',I2,1X)
      RETURN
      END

C ******
      SUBROUTINE LENSTR_BL(STRING,NL)
C -P- LENSTR_BL - gives length of string.
      INTEGER*4 NL
      CHARACTER STRING*(*)
C -------------------------------------
      N=LEN(STRING)
      NL=N
      DO 10 I=N,1,-1
        IF(STRING(NL:NL).NE.' ') GO TO 20      
        NL=NL-1
   10 CONTINUE
   20 RETURN
      END

      SUBROUTINE REMOVE_PATH(STRING)
C -------------------------------------
      CHARACTER STRING*(*),TEMP*256,CH2*2
C -------------------------------------
      CH2 = '\\'
      CALL LENSTR_BL(STRING,LEN)
      IF(LEN.LE.1) RETURN
      NL = LEN
      DO I=LEN,1,-1
C       IF(STRING(NL:NL).EQ.'/'.OR.STRING(NL:NL).EQ.'\\') GO TO 20      
        IF(STRING(NL:NL).EQ.'/'.OR.STRING(NL:NL).EQ.CH2(1:1)) GO TO 20      
        NL = NL-1
      ENDDO
   20 CONTINUE
      IF(NL.GE.1.AND.NL.LT.LEN) THEN
        TEMP = STRING(NL+1:LEN)
        STRING = TEMP
      ENDIF
      RETURN
      END

C ******

C -P-
C -P------ vector-matrix subroutines --------------------
C -P-

C ******
      SUBROUTINE VMOD(X,D)
C -P- VMOD - D=!X!  X(3) - vector     
      REAL X(3)
C ******
      X2=X(1)*X(1)
      Y2=X(2)*X(2)
      Z2=X(3)*X(3)
      D=SQRT(X2+Y2+Z2)
      RETURN
      END

C ******
      SUBROUTINE VUNIT(X,Y,IERR)
C -P- VUNIT -  Y=X/!X!    if !X!=0 then Y=(1,0,0) and IERR=1       
      REAL X(3),Y(3)
C ******
      IERR=0
      CALL VMOD(X,D)
      IF(D.GT.0.0) THEN
        D=1./D
        Y(1)=X(1)*D
        Y(2)=X(2)*D
        Y(3)=X(3)*D
      ELSE
        IERR=1
        Y(1)=1.0
        Y(2)=0.0
        Y(3)=0.0
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE VSCAL(X,S,Y)
C -P- VSCALE - Y=S*X  S - coefficient
      REAL X(3),Y(3)
C ******
      Y(1)=X(1)*S
      Y(2)=X(2)*S
      Y(3)=X(3)*S
      RETURN
      END

C ******
      SUBROUTINE VADD(X,Y,Z)
C -P- VADD - Z=X+Y
      REAL X(3),Y(3),Z(3)
C ******
      Z(1)=X(1)+Y(1)
      Z(2)=X(2)+Y(2)
      Z(3)=X(3)+Y(3)
      RETURN
      END

C ******
      SUBROUTINE VSUB(X,Y,Z)
C -P- VSUB - Z=X-Y
      REAL X(3),Y(3),Z(3)
C ******
      Z(1)=X(1)-Y(1)
      Z(2)=X(2)-Y(2)
      Z(3)=X(3)-Y(3)
      RETURN
      END

C ******
      SUBROUTINE VPROD(X,Y,S)
C -P- VPROD - S = (X.Y)  S=X(1)*Y(1)+X(2)*Y(2)+X(3)*Y(3)
      REAL X(3),Y(3)
C ******
      S=X(1)*Y(1)+X(2)*Y(2)+X(3)*Y(3)
      RETURN
      END

C ******
      SUBROUTINE VCOPY(X,Y)
C -P- VCOPY - Y <= X
      REAL X(3),Y(3)
C ******
      Y(1)=X(1)
      Y(2)=X(2)
      Y(3)=X(3)
      RETURN
      END

C ******
      SUBROUTINE VMULT(X,Y,Z)
C -P- VMULT Z = X*Y    
      REAL X(3),Y(3),Z(3)
C ******
      VX  =X(2)*Y(3)-X(3)*Y(2)
      VY  =X(3)*Y(1)-X(1)*Y(3)
      Z(3)=X(1)*Y(2)-X(2)*Y(1)
      Z(1)=VX
      Z(2)=VY
      RETURN
      END

C ******
      SUBROUTINE MCOPY(X,Y)      
      REAL X(9),Y(9)
C -P- MCOPY - [Y] <= [X]
C                             ! 11 21 31 !
C            [Y] =[X]     X = ! 12 22 32 !
C                             ! 13 23 33 !
C ******
      DO     I=1,9    
        Y(I)=X(I) 
      ENDDO
      RETURN        
      END           

C ******
      SUBROUTINE MATMLT(X,Y,Z)
      REAL X(3,3),Y(3,3),Z(3,3)
C -P- MATMLT - [Z] =[X] [Y]
C                               ! 11 21 31 !
C           [Z] =[X] [Y]    X = ! 12 22 32 !
C                               ! 13 23 33 !
C ******
      DO     I=1,3
      DO     J=1,3
        Z(I,J)=0.0
        DO     K=1,3
          Z(I,J)=Z(I,J)+X(K,J)*Y(I,K)
        ENDDO
      ENDDO
      ENDDO
      RETURN
      END

C ******
      SUBROUTINE MVMULT(AM,X,Y)
      REAL X(3),Y(3),AM(3,3)
C -P- MVMULT -  Y =[AM] X
C                             !1!   ! 11 21 31 !    !1!
C           Y =[AM] X       Y !2! = ! 12 22 32 !  X !2!
C                             !3!   ! 13 23 33 !    !3!
C ******
      Y(1)=AM(1,1)*X(1)+AM(2,1)*X(2)+AM(3,1)*X(3)
      Y(2)=AM(1,2)*X(1)+AM(2,2)*X(2)+AM(3,2)*X(3)
      Y(3)=AM(1,3)*X(1)+AM(2,3)*X(2)+AM(3,3)*X(3)
      RETURN
      END

C ******
      SUBROUTINE MTRANS(AM,BM)
      REAL AM(3,3),BM(3,3)
C -P- MTRANS - matrix transposition
C           ! 11 21 31 !            ! 11 12 13 !  
C     AM  = ! 12 22 32 !  --> BM =  ! 21 22 33 !
C           ! 13 23 33 !            ! 31 32 33 !    
C     It is posible to use CALL MTRANS(AM,AM)
C ******
      BM(1,1)=AM(1,1)
      BM(2,2)=AM(2,2)
      BM(3,3)=AM(3,3)
      T      =AM(1,2)
      BM(1,2)=AM(2,1)
      BM(2,1)=T
      T      =AM(1,3)
      BM(1,3)=AM(3,1)
      BM(3,1)=T
      T      =AM(3,2)
      BM(3,2)=AM(2,3)
      BM(2,3)=T
      RETURN
      END


      SUBROUTINE UO_TO_B(UO_ANIS,B_ANIS)
C --------------------------------------------
      COMMON/COM_MAT/  ACELL,BCELL,CCELL,AANGL,BANGL,GANGL
     *                ,AST,BST,CST,COALST,COBEST,COGAST
     *                ,FRTOCR,CRTOFR
      REAL FRTOCR(3,3),CRTOFR(3,3)
C ----------------------------
      REAL UO_ANIS(6),B_ANIS(6)
      REAL A(3,3),R(3,3),S(3,3),G(3,3),GS(3,3)
      REAL FRTOCRT(3,3)
C --------------------------------------------
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
      CONST=TWOPI*PI
C -----------------------------------
      G(1,1)=ACELL*ACELL
      G(2,2)=BCELL*BCELL
      G(3,3)=CCELL*CCELL
      G(1,2)=ACELL*BCELL*COS(GANGL)
      G(2,1)=G(1,2)
      G(1,3)=ACELL*CCELL*COS(BANGL)
      G(3,1)=G(1,3)
      G(2,3)=BCELL*CCELL*COS(AANGL)
      G(3,2)=G(2,3)
C ---
      GS(1,1)=AST*AST
      GS(2,2)=BST*BST
      GS(3,3)=CST*CST
      GS(1,2)=AST*BST*COGAST
      GS(2,1)=GS(1,2)
      GS(1,3)=AST*CST*COBEST
      GS(3,1)=GS(1,3)
      GS(2,3)=BST*CST*COALST
      GS(3,2)=GS(2,3)
C ---
      A(1,1)=UO_ANIS(1)
      A(2,2)=UO_ANIS(2)
      A(3,3)=UO_ANIS(3)
      A(1,2)=UO_ANIS(4)
      A(1,3)=UO_ANIS(5)
      A(2,3)=UO_ANIS(6)
      A(2,1)=A(1,2)
      A(3,1)=A(1,3)
      A(3,2)=A(2,3)

C ---
      CALL  MTRANS(FRTOCR,FRTOCRT)

      CALL  MATMLT(A,FRTOCR,S)
      CALL  MATMLT(FRTOCRT,S,R)
C ---
C     U* = G* U G*
C     B  = 2PI^2 U*    
C --
      CALL MATMLT(R,GS,S)
      CALL MATMLT(GS,S,R)


C -----
      B_ANIS(1)=R(1,1)*CONST
      B_ANIS(2)=R(2,2)*CONST
      B_ANIS(3)=R(3,3)*CONST
      B_ANIS(4)=R(1,2)*CONST
      B_ANIS(5)=R(1,3)*CONST
      B_ANIS(6)=R(2,3)*CONST
C ---
      RETURN
      END

      SUBROUTINE ADD_U(UO,UA,S)
      REAL UO(6),UA(6),S(3,3)
C ---------------------------------
      S(1,1)=UO(1)+UA(1)
      S(2,2)=UO(2)+UA(2)
      S(3,3)=UO(3)+UA(3)
      S(1,2)=UO(4)+UA(4)
      S(1,3)=UO(5)+UA(5)
      S(2,3)=UO(6)+UA(6)
      S(2,1)=S(1,2)
      S(3,1)=S(1,3)
      S(3,2)=S(2,3)
      RETURN
      END

      SUBROUTINE ADD_B(UO,UA,S)
      REAL UO(6),UA(6),S(6)
C ---------------------------------
      S(1)=UO(1)+UA(1)
      S(2)=UO(2)+UA(2)
      S(3)=UO(3)+UA(3)
      S(4)=UO(4)+UA(4)
      S(5)=UO(5)+UA(5)
      S(6)=UO(6)+UA(6)
      RETURN
      END

      SUBROUTINE B_TO_UO(B_ANIS,UO_ANIS)
C --------------------------------------------
      COMMON/COM_MAT/  ACELL,BCELL,CCELL,AANGL,BANGL,GANGL
     *                ,AST,BST,CST,COALST,COBEST,COGAST
     *                ,FRTOCR,CRTOFR
      REAL FRTOCR(3,3),CRTOFR(3,3)
C ----------------------------
      REAL UO_ANIS(6),B_ANIS(6)
      REAL A(3,3),R(3,3),S(3,3),G(3,3),GS(3,3)
      REAL CRTOFRT(3,3)
C --------------------------------------------
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
      CONST=TWOPI*PI
C -----------------------------------
      G(1,1)=ACELL*ACELL
      G(2,2)=BCELL*BCELL
      G(3,3)=CCELL*CCELL
      G(1,2)=ACELL*BCELL*COS(GANGL)
      G(2,1)=G(1,2)
      G(1,3)=ACELL*CCELL*COS(BANGL)
      G(3,1)=G(1,3)
      G(2,3)=BCELL*CCELL*COS(AANGL)
      G(3,2)=G(2,3)
C ---
      GS(1,1)=AST*AST
      GS(2,2)=BST*BST
      GS(3,3)=CST*CST
      GS(1,2)=AST*BST*COGAST
      GS(2,1)=GS(1,2)
      GS(1,3)=AST*CST*COBEST
      GS(3,1)=GS(1,3)
      GS(2,3)=BST*CST*COALST
      GS(3,2)=GS(2,3)
C ---
      A(1,1)=B_ANIS(1)/CONST
      A(2,2)=B_ANIS(2)/CONST
      A(3,3)=B_ANIS(3)/CONST
      A(1,2)=B_ANIS(4)/CONST
      A(1,3)=B_ANIS(5)/CONST
      A(2,3)=B_ANIS(6)/CONST
      A(2,1)=A(1,2)
      A(3,1)=A(1,3)
      A(3,2)=A(2,3)

C ---
C     U* = B/2PI^2    
C     U  = G  U* G
C --
      CALL MATMLT(A,G,S)
      CALL MATMLT(G,S,R)

      CALL  MTRANS(CRTOFR,CRTOFRT)

      CALL  MATMLT(R,CRTOFR,S)
      CALL  MATMLT(CRTOFRT,S,R)
C ---
      UO_ANIS(1)=R(1,1)
      UO_ANIS(2)=R(2,2)
      UO_ANIS(3)=R(3,3)
      UO_ANIS(4)=R(1,2)
      UO_ANIS(5)=R(1,3)
      UO_ANIS(6)=R(2,3)
C ---
      RETURN
      END

      SUBROUTINE B_TO_UOM(B_ANIS,R)
C --------------------------------------------
      COMMON/COM_MAT/  ACELL,BCELL,CCELL,AANGL,BANGL,GANGL
     *                ,AST,BST,CST,COALST,COBEST,COGAST
     *                ,FRTOCR,CRTOFR
      REAL FRTOCR(3,3),CRTOFR(3,3)
C ----------------------------
      REAL UO_ANIS(6),B_ANIS(6)
      REAL A(3,3),R(3,3),S(3,3),G(3,3),GS(3,3)
      REAL CRTOFRT(3,3)
C --------------------------------------------
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
      CONST=TWOPI*PI
C -----------------------------------
      G(1,1)=ACELL*ACELL
      G(2,2)=BCELL*BCELL
      G(3,3)=CCELL*CCELL
      G(1,2)=ACELL*BCELL*COS(GANGL)
      G(2,1)=G(1,2)
      G(1,3)=ACELL*CCELL*COS(BANGL)
      G(3,1)=G(1,3)
      G(2,3)=BCELL*CCELL*COS(AANGL)
      G(3,2)=G(2,3)
C ---
      GS(1,1)=AST*AST
      GS(2,2)=BST*BST
      GS(3,3)=CST*CST
      GS(1,2)=AST*BST*COGAST
      GS(2,1)=GS(1,2)
      GS(1,3)=AST*CST*COBEST
      GS(3,1)=GS(1,3)
      GS(2,3)=BST*CST*COALST
      GS(3,2)=GS(2,3)
C ---
      A(1,1)=B_ANIS(1)/CONST
      A(2,2)=B_ANIS(2)/CONST
      A(3,3)=B_ANIS(3)/CONST
      A(1,2)=B_ANIS(4)/CONST
      A(1,3)=B_ANIS(5)/CONST
      A(2,3)=B_ANIS(6)/CONST
      A(2,1)=A(1,2)
      A(3,1)=A(1,3)
      A(3,2)=A(2,3)

C ---
C     U* = B/2PI^2    
C     U  = G  U* G
C --
      CALL MATMLT(A,G,S)
      CALL MATMLT(G,S,R)

      CALL  MTRANS(CRTOFR,CRTOFRT)

      CALL  MATMLT(R,CRTOFR,S)
      CALL  MATMLT(CRTOFRT,S,R)
C ---
      RETURN
      END

      SUBROUTINE BISO_TO_U(BISO,U_ANIS)
C ------------------------
      COMMON/COM_MAT/  ACELL,BCELL,CCELL,AANGL,BANGL,GANGL
     *                ,AST,BST,CST,COALST,COBEST,COGAST
     *                ,FRTOCR,CRTOFR
      REAL FRTOCR(3,3),CRTOFR(3,3)
C ----------------------------
      REAL BETA(6),U_ANIS(6),CRTOFRT(3,3)
      REAL G(3,3),GS(3,3),BT(3,3),S(3,3),U(3,3),UO(3,3)
C ------------------------
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
      CONST=TWOPI*PI
C ------------------------
      G(1,1)=ACELL*ACELL
      G(2,2)=BCELL*BCELL
      G(3,3)=CCELL*CCELL
      G(1,2)=ACELL*BCELL*COS(GANGL)
      G(2,1)=G(1,2)
      G(1,3)=ACELL*CCELL*COS(BANGL)
      G(3,1)=G(1,3)
      G(2,3)=BCELL*CCELL*COS(AANGL)
      G(3,2)=G(2,3)
C ---
      GS(1,1)=AST*AST
      GS(2,2)=BST*BST
      GS(3,3)=CST*CST
      GS(1,2)=AST*BST*COGAST
      GS(2,1)=GS(1,2)
      GS(1,3)=AST*CST*COBEST
      GS(3,1)=GS(1,3)
      GS(2,3)=BST*CST*COALST
      GS(3,2)=GS(2,3)
C ---
C -----------------
      BETA(1)=(GS(1,1)*BISO)/4.0
      BETA(2)=(GS(2,2)*BISO)/4.0
      BETA(3)=(GS(3,3)*BISO)/4.0
      BETA(4)=(GS(1,2)*BISO)/4.0
      BETA(5)=(GS(1,3)*BISO)/4.0
      BETA(6)=(GS(2,3)*BISO)/4.0
C          WRITE(*,*) '  Beta  :',BETA(1),BETA(2),BETA(3)
C     *    ,BETA(4),BETA(5),BETA(6)
C -----------------
      BT(1,1)=BETA(1)/CONST
      BT(2,2)=BETA(2)/CONST
      BT(3,3)=BETA(3)/CONST
      BT(1,2)=BETA(4)/CONST
      BT(1,3)=BETA(5)/CONST
      BT(2,3)=BETA(6)/CONST
      BT(2,1)=BT(1,2)
      BT(3,1)=BT(1,3)
      BT(3,2)=BT(2,3)
C ---
C     U* = B/2PI^2    
C     U  = G  U* G
C --
      CALL MATMLT(BT,G,S)
      CALL MATMLT(G,S,U)
C
C     tensor in cartesian. system Uo = [CtoF]' U [CtoF]
C  
      CALL  MTRANS(CRTOFR,CRTOFRT)

      CALL  MATMLT(U,CRTOFR,S)
      CALL  MATMLT(CRTOFRT,S,UO)
C -----------------------------------------
      U_ANIS(1)=UO(1,1)
      U_ANIS(2)=UO(2,2)
      U_ANIS(3)=UO(3,3)
      U_ANIS(4)=UO(1,2)
      U_ANIS(5)=UO(1,3)
      U_ANIS(6)=UO(2,3)
C ---
      RETURN
      END

      SUBROUTINE BISO_TO_B(BISO,BETA)
C ------------------------
      COMMON/COM_MAT/  ACELL,BCELL,CCELL,AANGL,BANGL,GANGL
     *                ,AST,BST,CST,COALST,COBEST,COGAST
     *                ,FRTOCR,CRTOFR
      REAL FRTOCR(3,3),CRTOFR(3,3)
C ----------------------------
      REAL BETA(6)
      REAL G(3,3),GS(3,3)
C ------------------------
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
      CONST=TWOPI*PI
C ------------------------
      G(1,1)=ACELL*ACELL
      G(2,2)=BCELL*BCELL
      G(3,3)=CCELL*CCELL
      G(1,2)=ACELL*BCELL*COS(GANGL)
      G(2,1)=G(1,2)
      G(1,3)=ACELL*CCELL*COS(BANGL)
      G(3,1)=G(1,3)
      G(2,3)=BCELL*CCELL*COS(AANGL)
      G(3,2)=G(2,3)
C ---
      GS(1,1)=AST*AST
      GS(2,2)=BST*BST
      GS(3,3)=CST*CST
      GS(1,2)=AST*BST*COGAST
      GS(2,1)=GS(1,2)
      GS(1,3)=AST*CST*COBEST
      GS(3,1)=GS(1,3)
      GS(2,3)=BST*CST*COALST
      GS(3,2)=GS(2,3)
C ---
C -----------------
      BETA(1)=(GS(1,1)*BISO)/4.0
      BETA(2)=(GS(2,2)*BISO)/4.0
      BETA(3)=(GS(3,3)*BISO)/4.0
      BETA(4)=(GS(1,2)*BISO)/4.0
      BETA(5)=(GS(1,3)*BISO)/4.0
      BETA(6)=(GS(2,3)*BISO)/4.0
C ---    
      RETURN
      END

      SUBROUTINE B_SYM(B,BR,ROT)
      REAL B(6),BR(6),ROT(3,3)
      REAL S(3,3),R(3,3),RT(3,3)
C ---------------------
      S(1,1)=B(1)
      S(2,2)=B(2)
      S(3,3)=B(3)
      S(1,2)=B(4)
      S(1,3)=B(5)
      S(2,3)=B(6)
      S(2,1)=S(1,2)
      S(3,1)=S(1,3)
      S(3,2)=S(2,3)
C -----------------
      CALL  MTRANS(ROT,RT)

      CALL  MATMLT(S,RT,R)
      CALL  MATMLT(ROT,R,S)
C -----------------------------------------
      BR(1)=S(1,1)
      BR(2)=S(2,2)
      BR(3)=S(3,3)
      BR(4)=S(1,2)
      BR(5)=S(1,3)
      BR(6)=S(2,3)
C ------------------
      RETURN
      END

      SUBROUTINE MDET2(A,DET)
C ------------------------------
      REAL A(6)
C ------------------------------
      DET  =  A(1)*(A(2)*A(3) - A(6)*A(6))
     *      - A(4)*(A(4)*A(3) - A(6)*A(5))
     *      + A(5)*(A(4)*A(6) - A(2)*A(5))
C ---
      RETURN
      END


      SUBROUTINE MDET(A,DET)
C ------------------------------
      REAL A(3,3)
C ------------------------------
      DET  =  A(1,1)*(A(2,2)*A(3,3) - A(3,2)*A(2,3))
     *      - A(2,1)*(A(1,2)*A(3,3) - A(3,2)*A(1,3))
     *      + A(3,1)*(A(1,2)*A(2,3) - A(2,2)*A(1,3))
C ---
      RETURN
      END

C ******
      SUBROUTINE INVERT(S,SS,IERR)
C
C -P- INVERT - invertion matrix S(3,3) , result marix SS(3,3)
C
C -------------
      REAL S(3,3),SS(3,3)
      INTEGER IERR
C ******
C -------------------------------
      IERR=0
      DO    I=1,3
      DO    J=1,3
        SS(I,J)=0.
      ENDDO
      ENDDO
C
      DET=0.0

      DO    J=1,3
      DO    I=1,3
        IF(I.EQ.1) THEN
          I1=2
          I2=3
        ELSE IF(I.EQ.2) THEN
          I1=1
          I2=3
        ELSE
          I1=1
          I2=2
        ENDIF
        IF(J.EQ.1) THEN
          J1=2
          J2=3
        ELSE IF(J.EQ.2) THEN
          J1=1
          J2=3
        ELSE
          J1=1
          J2=2
        ENDIF
        SS(I,J)=(-1)**(I+J)*(S(J1,I1)*S(J2,I2)-
     *           S(J2,I1)*S(J1,I2))
      ENDDO
      ENDDO

      DET=S(1,1)*SS(1,1)+S(1,2)*SS(2,1)+S(1,3)*SS(3,1)

      IF(ABS(DET).LT.1.0E-8) THEN
        IERR=1
        DET=0.0
      ELSE
        DET=1./DET
      ENDIF
      DO    I=1,3
      DO    J=1,3
        SS(I,J)=DET*SS(I,J)
      ENDDO
      ENDDO

      RETURN
      END


C ******
      SUBROUTINE POLTOC(AM,VECT1,VECT2,R)
C     R =[AM}* VECT , where VECT=(VECT1*cos(VECT2),VECT1*sin(VECT2),0)
      REAL AM(3,3),R(3)
C ******
      X=VECT1*COS(VECT2)
      Y=VECT1*SIN(VECT2)
      R(1)=AM(1,1)*X+AM(2,1)*Y
      R(2)=AM(1,2)*X+AM(2,2)*Y
      R(3)=AM(1,3)*X+AM(2,3)*Y
      RETURN
      END

C ******
      SUBROUTINE CTOMAT(X,F,T,Z)
C                               ! cosT -sinT*cosF  sinT*sinF !
C           [Z] =[X] [Y]    X = ! sinT  cosT*cosF -cosT*sinF !
C                               !  0       sinF     cosF     !
      REAL X(3,3),Y(3,3),Z(3,3)
C ******
      COST=COS(T)
      SINT=SIN(T)
      COSF=COS(F)
      SINF=SIN(F)
      Y(1,1)= COST
      Y(2,1)=-SINT*COSF
      Y(3,1)= SINT*SINF
      Y(1,2)= SINT
      Y(2,2)= COST*COSF
      Y(3,2)=-COST*SINF
      Y(1,3)= 0.
      Y(2,3)= SINF
      Y(3,3)= COSF
      CALL MATMLT(X,Y,Z)
      RETURN
      END
C -P-
C -P------ read/write subroutines  --------------------
C -P-
C ******
      SUBROUTINE ORCRD(MDOC,IN,FNAME,NSYM,ISYM,NSMAX,IERR)
C
C -P- ORCRD - OPEN OF FILE-CRD FOR READ
C
C
      INTEGER   IN,MDOC,IERR
      INTEGER   NSYM,NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER FNAME*(*)
C ******
C ----------
      CHARACTER EXT*3,PATH*1,LINE*256
C -------------------------------------------------------------
      IERR=0
      EXT ='crd'
      PATH=' '
      CALL OPENFR(IN,MDOC,PATH,FNAME,EXT,IERR)
      IF(IERR.NE.0) THEN
        IERR=1
        RETURN
      ENDIF
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.65) LEN=65
      WRITE(LINE,10) FNAME(1:LEN)
 10   FORMAT('Input file :',A)
      CALL MSGDOC(MDOC,LINE)
      CALL RD_TTL_CRD(MDOC,IN,NSYM,ISYM,NSMAX,IERR)
      IF(IERR.EQ.2) GO TO 9200
      IF(IERR.EQ.3) GO TO 9000
      IF(IERR.GT.0) THEN
        IERR=4
        CLOSE(IN)
      ENDIF
      RETURN
9000  CONTINUE
      CALL MSGERR(MDOC,' ERROR: READ OF FILE /.CRD/')
      CLOSE(IN)
      IERR=3
      RETURN
9200  CONTINUE
      CALL MSGERR(MDOC,' ERROR: END OF FILE /.CRD/')
      IERR=2
      RETURN
      END



C ******
      SUBROUTINE OPEN_CRD(MDOC,IN,FNAME,IERR)
C
C -P- ORCRD - OPEN OF FILE-CRD FOR READ
C
C
      INTEGER   IN,MDOC,IERR
      CHARACTER FNAME*(*)
C ******
C ----------
      CHARACTER EXT*3,PATH*1,LINE*256,NAME*256,STR*256
C -------------------------------------------------------------
      IERR=0
C --
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.0.AND.FNAME(1:1).NE.','.AND.FNAME(1:1).NE.' ') THEN
        NAME=FNAME(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 110
          ENDIF 
        ENDDO
 110    CONTINUE
        LINE = NAME
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GT.4.AND.LINE(LEN-3:LEN).EQ.'.cif') THEN
          NAME=LINE(1:LEN-4)
        ENDIF
      ELSE
        NAME=FNAME
      ENDIF
C -------
      EXT='crd'
      PATH=' '
      CALL OPENFR(IN,MDOC,PATH,NAME,EXT,IERR)
      IF(IERR.NE.0) THEN
        IERR=1
        RETURN
      ENDIF
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.65) LEN=65
      WRITE(STR,10) FNAME(1:LEN)
 10   FORMAT('Input file :',A)
      CALL MSGDOC(MDOC,STR)
      RETURN
      END

C ******
      SUBROUTINE OWCRD(MDOC,IOUT,FNAME,NSYM,ISYM,NSMAX,IERR)
C
C -P-  OWCRD - OPEN OF FILE-CRD FOR WRITE
C
      INTEGER   IOUT,MDOC,ILINE,IERR
      INTEGER   NSYM,NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER FNAME*(*)
C ******
      CHARACTER EXT*3,PATH*1,LINE*256
C -------------------------------------------------------------
      IERR=0
      EXT ='crd'
      PATH=' '
      CALL OPENFW(IOUT,MDOC,PATH,FNAME,EXT,IERR)
      IF(IERR.NE.0) GO TO 9100
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.65) LEN=65
      WRITE(LINE,10) FNAME(1:LEN)
 10   FORMAT('Output file :',A)
      CALL MSGDOC(MDOC,LINE)
      CALL WR_TTL_CRD(MDOC,IOUT,NSYM,ISYM,NSMAX,IERR)
      IF(IERR.GT.0) GO TO 9000
      RETURN
9100  CONTINUE
      CALL MSGERR(MDOC,' ERROR: OPEN OF FILE /.CRD/')
      IERR=1
      RETURN
9000  CONTINUE
      CALL MSGERR(MDOC,' ERROR: WRITE OF FILE /.CRD/')
      CLOSE(IOUT)
      IERR=2
      RETURN
      END

C ******
      SUBROUTINE RD_TTL_CRD(MDOC,IN,NSYM,ISYM,NSMAX,IERR)
C
C -P- RD_TTL_CRD - reads title of file to common/CRDINF/
C ----------------------------------------------------------------------------
C ---
      INTEGER   NSYM,MDOC,IN,IERR
      INTEGER   NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
C ---
C ******
C ------------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMCIF_CRD/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ---
C -------------------------------------------------
      PARAMETER (IPRAT_SF =15)
      COMMON/CRDFRM/ NCRD_CSF,CSF_NE,CSF_RAD
     *               ,CSF_A1,CSF_B1,CSF_A2,CSF_B2
     *               ,CSF_A3,CSF_B3,CSF_A4,CSF_B4
     *               ,CSF_C,CSF_FI,CSF_FII,CSF_ATOM
      CHARACTER       CSF_ATOM(IPRAT_SF)*4
      REAL            CSF_A1(IPRAT_SF),CSF_B1(IPRAT_SF)
      REAL            CSF_A2(IPRAT_SF),CSF_B2(IPRAT_SF)
      REAL            CSF_A3(IPRAT_SF),CSF_B3(IPRAT_SF)
      REAL            CSF_A4(IPRAT_SF),CSF_B4(IPRAT_SF)
      REAL            CSF_C (IPRAT_SF),CSF_RAD(IPRAT_SF)
      REAL            CSF_FI(IPRAT_SF),CSF_FII(IPRAT_SF)
      REAL            CSF_NE(IPRAT_SF)
C ---------------------------------------------------------
      COMMON /CRST_PDB/ CS_SCALE,CS_U
     *                 ,CS_TEMPER,CS_WAVEL
     *                 ,CS_RES_MIN,CS_RES_MAX 
     *                 ,CS_RFAC_ALL,CS_RFAC_OBS
     *                 ,CS_SIGMA_I,CS_SIGMA_F 
     *                 ,CS_MODEL_PDB
     *                 ,CS_CD_PDB,CS_CD_NDB,CS_CD_CSD
     *                 ,CS_NAME_PDB
     *                 ,CS_DATE_PDB,CS_DATE_NDB
     *                 ,CS_DATE_CREAT,CS_TITLE
     *                 ,CS_RESL_PDB,CS_RFAC_PDB
     *                 ,CS_PROGRAM,CS_METHOD
      REAL  CS_SCALE(3,3)
      REAL  CS_U(3)
      REAL  CS_TEMPER
      REAL  CS_WAVEL
      REAL  CS_RES_MIN
      REAL  CS_RES_MAX 
      REAL  CS_RFAC_ALL
      REAL  CS_RFAC_OBS
      REAL  CS_SIGMA_I
      REAL  CS_SIGMA_F 
      INTEGER*4 CS_MODEL_PDB
      CHARACTER CS_CD_PDB    *8
      CHARACTER CS_CD_NDB    *8
      CHARACTER CS_CD_CSD    *8
      CHARACTER CS_NAME_PDB  *40
      CHARACTER CS_DATE_PDB  *9
      CHARACTER CS_DATE_NDB  *9
      CHARACTER CS_DATE_CREAT*20
      CHARACTER CS_TITLE     *80
      CHARACTER CS_RESL_PDB  *40
      CHARACTER CS_RFAC_PDB  *40
      CHARACTER CS_PROGRAM   *40
      CHARACTER CS_METHOD    *40
C ---
C       Fractional coord. system.        Ortogonal coord system of data_PDB
C
C        X                     | 11  12  13 |    X                  U(1)
C        Y  (fract)   =  SCALE | 21  22  23 |    Y  (Cartesian)  +  U(2)
C        Z                     | 31  32  33 |    Z                  U(3)
C
C  CS_SCALE 
C  CS_U
C ---
C  CS_MODEL_PDB -
C  CS_CD_PDB    -  PDB code /_database_2.code_PDB/
C  CS_CD_NDB    -  NDB code /_database_2.code_NDB/
C  CS_CD_CSD    -  NDB code /_database_2.code_CSD/
C  CS_NAME_PDB  -  PDB name /_struct_keywords.text/  (PROTEIN,DNA,RNA,...)
C  CS_DATE_PDB  -  PDB creating date /_database_PDB_rev.data_original /
C  CS_DATE_NDB  -  NDB creating date 
C  CS_DATE_CREAT-  file creation date /_audit.creation_date /
C  CS_TITLE     -  title /_struct.title '5"-D(*CP*GP*CP*G)-3",SPERMIN' /
C  CS_RESL_PDB  -  resolution from PDB_remark
C  CS_RFAC_PDB  -  R-factor   from PDB_remark
C  CS_PROGRAM   -  refinement program name / _computing.structure_refinement / 
C  CS_METHOD    -   /_expt.method 'X_RAY DIFFRACTION'/ 
C  CS_TEMPER    -   /_diffrn.ambient_temp 293 /
C  CS_WAVEL     -   /_diffrn_radiation.wavelength  1.5418 /
C  CS_RES_MIN   -   /_refine.ls_d_res_low  /
C  CS_RES_MAX   -   /_refine.ls_d_res_high /
C  CS_RFAC_ALL  -   /_refine.ls_R_factor_all/
C  CS_RFAC_OBS  -  t.e. with cutoff /_refine.ls_R_factor_obs/
C  CS_SIGMA_I   -   / ? _reflns.observed_criterion  '>2sigma(I)' /
C  CS_SIGMA_F   -
C ------------------------------------------------------------
      INCLUDE 'mr_crd_com.fh'
C --------------------------------------------------------------
      INTEGER   IDATA
      REAL      FDATA
      CHARACTER DATA*80,ITEM*80
C ---
      REAL        AM(3,3)
      CHARACTER   FL(6)*40
      REAL        FN(40)
C ----
      INTEGER   NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
      CHARACTER NCSF*1,GID*4,CH2*2
      REAL      RLATT(6),AMR(3,3),TR(3)
      INTEGER*4 NSPGROUP,NOSETT
      CHARACTER CODE*4,NAME*20,DATE*9,SPGR*24

      CHARACTER TITLE*80,TIME*20,NAME_NDB*8,TEMPER*5,WAVE*5
      CHARACTER LINE*256,CH10*10
C -------------------------------------------------------------------
      PI=4.0*ATAN(1.0)
      PI180=PI/180.0
      IERR=0
C -------------------------------------------------------------------
      DO I=1,80
        CR_TITLE(I:I)   = ' '
        TITLE(I:I)   = ' '
      ENDDO
      DO I=1,40
        CR_NAME_PDB(I:I) = ' '
      ENDDO
      NCRD_CSF=0
      CR_CELL(1)=1.0
      CR_CELL(2)=1.0
      CR_CELL(3)=1.0
      CR_CELL(4)=PI/2.0
      CR_CELL(5)=PI/2.0
      CR_CELL(6)=PI/2.0
      CR_SCALE(1,1)=1.0
      CR_SCALE(1,2)=0.0
      CR_SCALE(1,3)=0.0
      CR_SCALE(2,1)=0.0
      CR_SCALE(2,2)=1.0
      CR_SCALE(2,3)=0.0
      CR_SCALE(3,1)=0.0
      CR_SCALE(3,2)=0.0
      CR_SCALE(3,3)=1.0
      CR_U(1)      =0.0
      CR_U(2)      =0.0
      CR_U(3)      =0.0
      CR_FLAG_HA='N'
      CR_CF1 = 0.0
      CR_CF2 = 0.0
      CR_TOV = 0.0
      CR_ORT_TO_FRAC(1,1)=1.0
      CR_ORT_TO_FRAC(1,2)=0.0
      CR_ORT_TO_FRAC(1,3)=0.0
      CR_ORT_TO_FRAC(2,1)=0.0
      CR_ORT_TO_FRAC(2,2)=1.0
      CR_ORT_TO_FRAC(2,3)=0.0
      CR_ORT_TO_FRAC(3,1)=0.0
      CR_ORT_TO_FRAC(3,2)=0.0
      CR_ORT_TO_FRAC(3,3)=1.0
      CR_FRAC_TO_ORT(1,1)=1.0
      CR_FRAC_TO_ORT(1,2)=0.0
      CR_FRAC_TO_ORT(1,3)=0.0
      CR_FRAC_TO_ORT(2,1)=0.0
      CR_FRAC_TO_ORT(2,2)=1.0
      CR_FRAC_TO_ORT(2,3)=0.0
      CR_FRAC_TO_ORT(3,1)=0.0
      CR_FRAC_TO_ORT(3,2)=0.0
      CR_FRAC_TO_ORT(3,3)=1.0
      CR_NAME_PDB(1:13) = 'XXXXXXXX    ?'
      CR_DATE_PDB   = 'XX-XXX-XX'
      CR_CD_PDB     = 'XXXX'
      CR_TITLE(1:9)   = '?   ?   ?'
      CR_TITLE(69:78) = '?    ?    '
      CR_RFAC_PDB = '.'
      CR_RESL_PDB = '.'
      CR_TIME     = '.'
      CR_FLAG_HA  = 'N'
      CR_FLAG_USER= 'N'
      CR_MODEL    = 0
      CR_NSPGR    = 1
      CR_SETT     = 1
      CR_SPGR     = 'P 1        '
      CR_PDB_REC  ='.'
      CR_NSYM     = 1
      CR_NCS      = 0
      CR_SYMOP    = 'X,Y,Z'
      CR_IATOM    =0
      CR_IRES     =0
      CR_IATOLD   =0
      CR_IGROUP   =0
      CR_MULT_FLAG  =0
      CR_MULT_FACTOR=1
      CR_RTYPE    = '.'
      CR_ATYPE    = '.'
      CR_TERM     = '.'
      CR_RNAME    = '.'
      CR_ANAME    = '.'
      CR_CHAIN    = '. '
      CR_GROUP    = '.   '
      CR_BTYPE    = 'I'
      CR_FSC      = '.'
      CR_FSA      = '.'
      NAME_NDB    = 'XXXX    '
      TITLE(1:1)  = '?'
      TEMPER      = '?    '
      WAVE        = '?    '
      NAME(1:1)   = '?'
C --------------------
      CS_TEMPER     = 0.0
      CS_WAVEL      = 0.0
      CS_RES_MIN    = 0.0
      CS_RES_MAX    = 0.0
      CS_RFAC_ALL   = 0.0
      CS_RFAC_OBS   = 0.0
      CS_SIGMA_I    = 0.0
      CS_SIGMA_F    = 0.0
      CS_CD_NDB     = '?'
      CS_CD_CSD     = '?'
      CS_DATE_NDB   = '?'
      CS_DATE_CREAT = '?'
      CS_PROGRAM    = '?'
      CS_METHOD     = '?'
C ------------------------------------------
      INCS=0
      CALL SET_NCS(MDOC,NCMAX,INCS,AMR,TR,IERR)
      IF(IERR.NE.0) RETURN
      IGRP=0
      CALL SET_ASYMM(MDOC,NMAX,NGR,NCH,IGRP,ICH,INC,MLT,IATM
     *                    ,NCSF,GID,IERR)
      IF(IERR.NE.0) RETURN
C --
      IEND = -1
      ISOP =  0
C -------
  300 CONTINUE   
      CALL GETCIF_CRD(IN,MDOC,IERR,IEND)
      IF(IERR.NE.0) THEN
        IERR=3
        RETURN
      ENDIF
      IF(IEND.EQ.-2) THEN
C
C       This string / DT_CIF (NWORDSMAX) / is a comment
C   
        GO TO 300
      ELSE IF(IEND.NE.0) THEN
        IERR=2
        RETURN
      ENDIF
      IF(N_CIF.LE.0) GO TO 300

      DO I=1,N_CIF
        CALL LENSTR_BL(ITM_CIF(I),LENI) 
        ITEM = ITM_CIF(I)(1:LENI)
        CALL LENSTR_BL(DT_CIF(I),LEND) 
        DATA = DT_CIF(I)(1:LEND)
        CALL LENSTR_BL(BLK_CIF,LENB) 
        IDATA=IDT_CIF(I)
        FDATA=FDT_CIF(I)

        IF((ITEM(1:18).EQ.'_database_PDB_code').OR.
     *     (ITEM(1:18).EQ.'_database_PDB.code').OR.
     *     (ITEM(1:20).EQ.'_database_2.code_PDB').OR.
     *     (ITEM(1:9).EQ.'_entry.id')) THEN
          CR_CD_PDB = '    '
          IF(LEND.GT.4) LEND=4
          CR_CD_PDB = DATA(1:LEND)
          IF(LEND.LT.4) THEN
            DO II=LEND+1,4
              CR_CD_PDB(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:20).EQ.'_database_2.code_NDB')) THEN
          NAME_NDB = '?'
          IF(LEND.GT.8) LEND=8
          NAME_NDB = DATA(1:LEND)
          IF(LEND.LT.8) THEN
            DO II=LEND+1,8
              NAME_NDB(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:18).EQ.'_database_PDB_name').OR.
     *          (ITEM(1:21).EQ.'_struct_keywords.text').OR.
     *          (ITEM(1:16).EQ.'_struct.keywords')) THEN
          CR_NAME_PDB = ' '
          IF(LEND.GT.20) LEND=20
          NAME = DATA(1:LEND)
          IF(LEND.LT.20) THEN
            DO II=LEND+1,20
              NAME(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:18).EQ.'_database_PDB_date').OR.
     *          (ITEM(1:18).EQ.'_database_PDB.date').OR.
     *          (ITEM(1:20).EQ.'_audit.creation_date')) THEN         
          CR_DATE_PDB = '         '
          IF(LEND.GT.10) LEND=10
          CH10 = DATA(1:LEND)
          IF(CH10(5:5).EQ.'-') THEN
            CALL CHNG_DATE_BACK(CH10,CR_DATE_PDB)         
          ELSE
            CR_DATE_PDB = CH10(1:9)
          ENDIF
        ELSE IF((ITEM(1:31).EQ.'_database_PDB_rev.date_original').OR.        
     *    (ITEM(1:31).EQ.'_database_NDB_rev.date_original')) THEN         
          CR_DATE_PDB = '         '
          IF(LEND.GT.10) LEND=10
          CH10 = DATA(1:LEND)
          IF(CH10(5:5).EQ.'-') THEN
            CALL CHNG_DATE_BACK(CH10,CR_DATE_PDB)         
          ELSE
            CR_DATE_PDB = CH10(1:9)
          ENDIF
        ELSE IF((ITEM(1:13).EQ.'_struct_title').OR.
     *          (ITEM(1:13).EQ.'_struct.title')) THEN     
          IF(LEND.GT.60) LEND=60
          TITLE = DATA(1:LEND)
          IF(LEND.LT.60) THEN
            DO II=LEND+1,60
              TITLE(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF(ITEM(1:19).EQ.'_file_creation_date') THEN
          IF(LEND.GT.20) LEND=20
          CR_TIME = DATA(1:LEND)
        ELSE IF((ITEM(1:19).EQ.'_database_PDB_model').OR.
     *          (ITEM(1:19).EQ.'_database_PDB.model')) THEN
C          CR_MODEL = IDATA
        ELSE IF((ITEM(1:31).EQ.'_database_PDB_remark_resolution').OR.
     *          (ITEM(1:31).EQ.'_database_PDB.remark_resolution')) 
     *       THEN
          IF(LEND.GT.40) LEND=40
          CR_RESL_PDB = DATA(1:LEND)              
          IF(LEND.LT.40) THEN
            DO II=LEND+1,40
              CR_RESL_PDB(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:29).EQ.'_database_PDB_remark_R_factor').OR.
     *          (ITEM(1:29).EQ.'_database_PDB.remark_R_factor')) THEN
          IF(LEND.GT.40) LEND=40
          CR_RFAC_PDB = DATA(1:LEND)
          IF(LEND.LT.40) THEN
            DO II=LEND+1,40
              CR_RFAC_PDB(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF(ITEM(1:27).EQ.'_diffrn.ambient_temperature') THEN
          IF(LEND.GT.5) LEND=5
          TEMPER = DATA(1:LEND)
          IF(LEND.LT.5) THEN
            DO II=LEND+1,5
              TEMPER(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF(ITEM(1:28).EQ.'_diffrn_radiation.wavelength') THEN
          IF(LEND.GT.5) LEND=5
          WAVE = DATA(1:LEND)
          IF(LEND.LT.5) THEN
            DO II=LEND+1,5
              WAVE(II:II)=' '
            ENDDO
          ENDIF

        ELSE IF((ITEM(1:12) .EQ.'_cell_length').OR.         
     *          (ITEM(1:12) .EQ.'_cell_angle_').OR.         
     *          (ITEM(1:12) .EQ.'_cell.length').OR.         
     *          (ITEM(1:12) .EQ.'_cell.angle_')) THEN         
          IF(ITEM(7:14).EQ.'length_a'.AND.LENI.EQ.14) THEN
            CR_CELL(1) = FDATA
          ELSE IF(ITEM(7:14).EQ.'length_b'.AND.LENI.EQ.14) THEN
            CR_CELL(2) = FDATA
          ELSE IF(ITEM(7:14).EQ.'length_c'.AND.LENI.EQ.14) THEN
            CR_CELL(3) = FDATA
          ELSE IF(ITEM(7:17).EQ.'angle_alpha'.AND.LENI.EQ.17) THEN
            CR_CELL(4) = FDATA
            CR_CELL(4) = CR_CELL(4)*PI180
          ELSE IF(ITEM(7:16).EQ.'angle_beta'.AND.LENI.EQ.16) THEN
            CR_CELL(5) = FDATA
            CR_CELL(5) = CR_CELL(5)*PI180
          ELSE IF(ITEM(7:17).EQ.'angle_gamma'.AND.LENI.EQ.17) THEN
            CR_CELL(6) = FDATA
            CR_CELL(6) = CR_CELL(6)*PI180
          ENDIF
        ELSE IF(ITEM(1:9).EQ.'_symmetry') THEN
          IF(ITEM(11:30).EQ.'space_group_name_H-M') THEN
            IF(LEND.GT.11) LEND=11
            CR_SPGR = DATA(1:LEND)
            IF(LEND.LT.11) THEN
              DO II=LEND+1,11
                CR_SPGR(II:II)=' '
              ENDDO
            ENDIF
          ELSE IF(ITEM(11:15).EQ.'Int_T') THEN
            CR_NSPGR = IDATA
          ELSE IF(ITEM(11:19).EQ.'cell_sett') THEN
            CR_SETT = IDATA
          ELSE IF((ITEM(11:19).EQ.'equiv_pos').OR.
     *            (ITEM(11:19).EQ.'equiv.pos')) THEN
c            IF(I.EQ.N_CIF) THEN
              LINE=DATA(1:LEND)
              ISOP=ISOP+1
              CALL SYMFR2_BL(MDOC,LINE,ISOP,NSYMR,ISYM,NSMAX,IERR)
              IF(IERR.GT.0) THEN
                CALL MSGERR(MDOC
     *          ,' ERR: WRONG NUMBER OF "_symmetry_equiv"-STRING')
                IERR=1
                RETURN
              ENDIF
              NSYM   =ISOP
              CR_NSYM=ISOP
c            ENDIF
          ENDIF
        ELSE IF(ITEM(1:12).EQ.'_nc_symmetry') THEN
          IF(ITEM(14:18).EQ.'alpha') THEN
            ALPHA=FDATA
          ELSE IF(ITEM(14:17).EQ.'beta') THEN
            BETA =FDATA
          ELSE IF(ITEM(14:18).EQ.'gamma') THEN
            GAMMA=FDATA
          ELSE IF(ITEM(14:21).EQ.'vector_1') THEN
            TR(1)=FDATA
          ELSE IF(ITEM(14:21).EQ.'vector_2') THEN
            TR(2)=FDATA
          ELSE IF(ITEM(14:21).EQ.'vector_3') THEN
            TR(3)=FDATA
          ENDIF
          IF(I.EQ.N_CIF) THEN
            INCS=INCS+1
            ALPHA=ALPHA*PI180
            BETA =BETA *PI180
            GAMMA=GAMMA*PI180
            CALL EULERM(ALPHA,BETA,GAMMA,AMR)
            CALL SET_NCS(MDOC,NCMAX,INCS,AMR,TR,IERR)
            IF(IERR.NE.0) RETURN
            II=0
            CALL GET_NCS(MDOC,NCMAX,II,AMR,TR,IERR)
            IF(IERR.NE.0) RETURN
          ENDIF
        ELSE IF(ITEM(1:12).EQ.'_struct_asym') THEN
          IF(I.EQ.1) THEN
            IGOLD  = 0
            ICHOLD = 0
            INC    = 0
            NCSF   = '.'
            MULT   = 1
            GID    = '.   '            
          ENDIF
          IF(ITEM(14:15).EQ.'id') THEN
            IGOLD  =IDATA
          ELSE IF(ITEM(14:22).EQ.'entity_id') THEN
            ICHOLD =IDATA
          ELSE IF(ITEM(14:27).EQ.'nc_symmetry_id') THEN
            CH2 = DATA(1:2)
            CALL LENSTR_BL(CH2,LEN)
            IF(CH2(1:1).EQ.'.') THEN
              INC=0
            ELSE
              IF(LEN.LE.1) THEN
                CH2(2:2)=CH2(1:1)
                CH2(1:1)=' '
              ENDIF
              READ(CH2,'(I2)')INC
            ENDIF
          ELSE IF(ITEM(14:29).EQ.'nc_symmetry_flag') THEN
            NCSF =DATA(1:1)
          ELSE IF(ITEM(14:25).EQ.'multiplicity') THEN
            CH2 = DATA(1:2)
            CALL LENSTR_BL(CH2,LEN)
            IF(CH2(1:1).EQ.'.') THEN
              MLT=1
            ELSE
              IF(LEN.LE.1) THEN
                CH2(2:2)=CH2(1:1)
                CH2(1:1)=' '
              ENDIF
              READ(CH2,'(I2)') MLT
            ENDIF
          ELSE IF(ITEM(14:28).EQ.'PDB_chain_label') THEN
            CH2 = DATA(1:2)
            GID = CH2//'  '
          ENDIF
          IF(I.EQ.N_CIF) THEN
            IGRP  = IGRP+1
            NGR   = IGRP
            ICH   = 0
            IF(IGOLD .LE.0) IGOLD =IGRP 
            IF(ICHOLD.LE.0) ICHOLD=IGRP 
            CALL SET_ASYMM(MDOC,NMAX,NGR,ICHOLD,IGRP,ICH,INC,MLT
     *                      ,IGOLD,NCSF,GID,IERR)
            IF(IERR.NE.0) RETURN
          ENDIF
        ELSE IF((ITEM(1:18).EQ.'_derivative_scale1').OR.
     *          (ITEM(1:18).EQ.'_derivative.scale1')) THEN
         CR_FLAG_HA='Y'
         CR_CF1 = FDATA
        ELSE IF((ITEM(1:18).EQ.'_derivative_scale2').OR.
     *          (ITEM(1:18).EQ.'_derivative.scale2')) THEN
         CR_FLAG_HA='Y'
         CR_CF2 = FDATA
        ELSE IF((ITEM(1:20).EQ.'_derivative_Toverall').OR.
     *          (ITEM(1:20).EQ.'_derivative.Toverall')) THEN
         CR_FLAG_HA='Y'
         CR_TOV = FDATA
        ELSE IF((ITEM(1:11).EQ.'_atom_type_').OR.
     *          (ITEM(1:11).EQ.'_atom_type.')) THEN
          IF(NCRD_CSF.GE.IPRAT_SF) THEN
            GO TO 410
          ENDIF
          IF(I.EQ.1) THEN
            CSF_RAD (NCRD_CSF+1)=0.0
            CSF_NE  (NCRD_CSF+1)=0.0
            CSF_ATOM(NCRD_CSF+1)='.   '
          ENDIF
          IF(ITEM(12:17).EQ.'symbol') THEN
            CSF_ATOM(NCRD_CSF+1) = DATA(1:4)
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_a1') THEN
            CSF_A1(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_a2') THEN
            CSF_A2(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_a3') THEN
            CSF_A3(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_a4') THEN
            CSF_A4(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_b1') THEN
            CSF_B1(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_b2') THEN
            CSF_B2(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_b3') THEN
            CSF_B3(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:29).EQ.'scat_Cromer_Mann_c') THEN
            CSF_C(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:31).EQ.'scat_dispersion_real') THEN
            CSF_FI(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:31).EQ.'scat_dispersion_imag') THEN
            CSF_FII(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:17).EQ.'radius') THEN
            CSF_RAD(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:16).EQ.'nelec') THEN
            CSF_NE(NCRD_CSF+1)  =FDATA
          ENDIF
          IF(I.EQ.N_CIF) THEN
            NCRD_CSF   = NCRD_CSF + 1
          ENDIF

        ELSE IF((ITEM(1:11).EQ.'_atom_site_').OR.
     *          (ITEM(1:11).EQ.'_atom_site.')) THEN
          GO TO 400
        ENDIF
 410    CONTINUE
      ENDDO
      GO TO 300
 400  CONTINUE

      IF(NAME_NDB(1:1).NE.'?'.AND.NAME_NDB(1:4).NE.'XXXX') THEN
        CR_NAME_PDB(5:12)=NAME_NDB
      ELSE
        CR_NAME_PDB(5:12)=CR_CD_PDB//'    '
      ENDIF
      CR_NAME_PDB(1:4)   = CR_CD_PDB
      CR_NAME_PDB(13:32) = NAME(1:20)

      CR_TITLE(9:68) = TITLE
      CR_TITLE(69:73)= WAVE
      CR_TITLE(74:78)= TEMPER

      RETURN
      END

C ******
      SUBROUTINE WR_TTL_CRD(MDOC,IOUT,NSYM,ISYM,NSMAX,IERR)
C -P- WR_TTL_CRD - writes title from common/CRDINF/,/CRDATM/ to file
C ---
      INTEGER   NSYM,MDOC,IOUT,IERR
      INTEGER   NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
C ******
C -------------------------------------------------
      PARAMETER (IPRAT_SF =15)
      COMMON/CRDFRM/ NCRD_CSF,CSF_NE,CSF_RAD
     *               ,CSF_A1,CSF_B1,CSF_A2,CSF_B2
     *               ,CSF_A3,CSF_B3,CSF_A4,CSF_B4
     *               ,CSF_C,CSF_FI,CSF_FII,CSF_ATOM
      CHARACTER       CSF_ATOM(IPRAT_SF)*4
      REAL            CSF_A1(IPRAT_SF),CSF_B1(IPRAT_SF)
      REAL            CSF_A2(IPRAT_SF),CSF_B2(IPRAT_SF)
      REAL            CSF_A3(IPRAT_SF),CSF_B3(IPRAT_SF)
      REAL            CSF_A4(IPRAT_SF),CSF_B4(IPRAT_SF)
      REAL            CSF_C (IPRAT_SF),CSF_RAD(IPRAT_SF)
      REAL            CSF_FI(IPRAT_SF),CSF_FII(IPRAT_SF)
      REAL            CSF_NE(IPRAT_SF)
C -----------------------------------------------------------
      INCLUDE 'mr_crd_com.fh'
C -------------------------------------------------
C ---
C      REAL        AM(3,3)
C      CHARACTER   FL(6)*40
C      REAL        FN(40)
C ----
C      REAL      RLATT(6)
      INTEGER   NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
      CHARACTER NCSF*1,GID*4,CID*1,CH2M*2,CODE*8,TEMPER*5,WAVE*5
      CHARACTER TITLE*80,CH10*10,CODE_NDB*8
C ------------------------------------------------------------------------
      REAL      AMR(3,3),TRN(3)
      CHARACTER LINE*256,CHAR20*20,CH1*1,CH2*2,CH3*3
      CHARACTER ICS_CATEGORY*40,ICS_CELL(6)*40
     *         ,ICS_SCALE(9)*40,ICS_U(3)*40
     *         ,ICS_ORIGX(9)*40,ICS_T(3)*40
     *         ,ICS_A(4)*40,ICS_B(4)*40,ICS_C*40,ICS_FI*40,ICS_FII*40
     *         ,ICS_RADIUS*40,ICS_NSPGR*40,ICS_SETT*40
     *         ,ICS_CD_PDB*40,ICS_NAME_PDB*40,ICS_DATE_PDB*40
     *         ,ICS_TITLE*40,ICS_RESL_PDB*40,ICS_RFAC_PDB*40
     *         ,ICS_MODEL*40,ICS_SPGR*40,ICS_SYMOP*40,ICS_ATYPE*40
C -------------------------------------------------------------------
      PI=4.0*ATAN(1.0)
      PI180=PI/180.0
      IERR=0
      IF(IOUT.LE.0) RETURN
C --------------------------------
       ICS_CATEGORY   = '_database_PDB.'
       ICS_CD_PDB     = 'code'
       ICS_NAME_PDB   = 'name'
       ICS_DATE_PDB   = 'date'
       ICS_TITLE      = 'compnd'
       ICS_RESL_PDB   = 'remark_resolution'
       ICS_RFAC_PDB   = 'remark_R_factor'
       ICS_MODEL      = 'model'
C
       ICS_CELL(1)    = '_cell.length_a'
       ICS_CELL(2)    = '_cell.length_b'
       ICS_CELL(3)    = '_cell.length_c'
       ICS_CELL(4)    = '_cell.angle_alpha'
       ICS_CELL(5)    = '_cell.angle_beta'
       ICS_CELL(6)    = '_cell.angle_gamma'
C
       ICS_SPGR       = '_symmetry.space_group_name_H-M'
       ICS_NSPGR      = '_symmetry.Int_Tables_number'
       ICS_SETT       = '_symmetry.cell_setting_number'
       ICS_SYMOP      = '_symmetry_equiv.pos_as_xyz'
C
C --------------------------------
      CALL LENSTR_BL(CR_TITLE,LEN)
      IF(LEN.LT.9) THEN 
        TITLE = '?'
        WAVE  = '?'
        TEMPER= '?'
      ELSE IF(LEN.LT.69) THEN 
        TITLE = CR_TITLE(9:68)
        WAVE  = '?'
        TEMPER= '?'
      ELSE IF(LEN.LT.74) THEN 
        TITLE = CR_TITLE(9:68)
        WAVE  = CR_TITLE(69:73)
        TEMPER= '?'
      ELSE
        TITLE = CR_TITLE(9:68)
        WAVE  = CR_TITLE(69:73)
        TEMPER= CR_TITLE(74:78)
      ENDIF

      CALL LENSTR_BL(CR_NAME_PDB,LEN)
      IF(LEN.LE.4) THEN
        CODE         ='XXXX    '
        CODE_NDB     ='?'
      ELSE
        IF(LEN.GT.12) LEN=12   
        CODE=CR_NAME_PDB(5:LEN)
        CODE_NDB     = CODE
      ENDIF

      IF(CODE_NDB(1:4).EQ.CR_CD_PDB.AND.CODE_NDB(5:8).EQ.'    ')
     *  CODE_NDB='?'

      IF(CODE(1:1).EQ.'?'.OR.CODE(1:1).EQ.' '.OR.CODE(1:1).EQ.'.'.OR.
     *   CODE(1:4).EQ.'XXXX') THEN
        CODE    = CR_CD_PDB//'    '    
        CODE_NDB= '?'
      ENDIF

      CALL LENSTR_BL(CODE,LENCD)
      WRITE(LINE,'(''data_structure_'',A)') CODE(1:LENCD)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)

      CALL LENSTR_BL(ICS_CATEGORY,LENC)

C ---
      WRITE(LINE,
     *'(''_database_2.database_id'',2X,A)') CODE(1:LENCD)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      CALL LENSTR_BL(CR_CD_PDB,LEN)
      WRITE(LINE,
     *'(''_database_2.code_PDB   '',2X,A)') CR_CD_PDB(1:LEN)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      IF(CODE_NDB(1:1).NE.'?') THEN
        WRITE(LINE,
     *'(''_database_2.code_NDB   '',2X,A)') CODE(1:LENCD)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
      WRITE(LINE,'(''_struct_keywords.entry_id'',2X,A)') CODE(1:LENCD)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      CALL LENSTR_BL(CR_NAME_PDB,LEN)
      IF(LEN.LE.12) THEN
        CR_NAME_PDB(13:13)='?'
        LEN=13
      ENDIF
      IF(LEN.GT.32) LEN=32
      WRITE(LINE,110) CR_NAME_PDB(13:LEN)
  110 FORMAT(       
     * '_struct_keywords.text  ',2X,'''',A,'''')
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
      WRITE(LINE,'(''_struct.entry_id'',2X,A)') CODE(1:LENCD)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      CALL LENSTR_BL(TITLE,LEN)
      IF(LEN.GT.60) LEN=60
      WRITE(LINE,200) TITLE(1:LEN)
  200 FORMAT(       '_struct.title   ',2X,'''',A,'''')
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
      WRITE(LINE,'(''_database_PDB_rev.num 1'')') 
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)

      CALL CHNG_DATE(CR_DATE_PDB,CH10)

      WRITE(LINE,'(''_database_PDB_rev.date_original'',2X,A)') 
     * CH10(1:10)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
      CALL CHCLOCK(CHAR20)
      WRITE(LINE,210) CHAR20
  210 FORMAT(       '_file_creation_date ',2X,'''',A,'''')
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
      IF(CR_MODEL.GT.0) THEN
        CALL LENSTR_BL(ICS_MODEL,LEN)
        WRITE(LINE,'(A,A,2X,I4)')
     *  ICS_CATEGORY(1:LENC),ICS_MODEL(1:LEN),CR_MODEL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
      IF(CR_RESL_PDB(1:1).NE.'.'.AND.CR_RESL_PDB(1:1).NE.' ') THEN
        CALL LENSTR_BL(ICS_RESL_PDB,LEN)
        LINE= ICS_CATEGORY(1:LENC)//ICS_RESL_PDB(1:LEN)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        CALL LENSTR_BL(CR_RESL_PDB,LEN)
        WRITE(LINE,310) CR_RESL_PDB(1:LEN)
  310   FORMAT(2X,'''',A,'''')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
      IF(CR_RFAC_PDB(1:1).NE.'.'.AND.CR_RFAC_PDB(1:1).NE.'   ')THEN
        CALL LENSTR_BL(ICS_RFAC_PDB,LEN)
        LINE= ICS_CATEGORY(1:LENC)//ICS_RFAC_PDB(1:LEN)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        CALL LENSTR_BL(CR_RFAC_PDB,LEN)
        WRITE(LINE,330) CR_RFAC_PDB(1:LEN)
  330   FORMAT(2X,'''',A,'''')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
      CALL LENSTR_BL(TEMPER,LEN)
      IF(LEN.GT.0.AND.TEMPER(1:1).NE.'.'.AND.TEMPER(1:1).NE.' '.AND.
     *   TEMPER(1:1).NE.'?') THEN
        WRITE(LINE,'(''_diffrn.entry_id             '',2X,A)') 
     *  CODE(1:LENCD)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        IF(LEN.GT.5) LEN=5
        WRITE(LINE,340) TEMPER(1:LEN)
  340   FORMAT(2X,'_diffrn.ambient_temperature    ',A)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
      CALL LENSTR_BL(WAVE,LEN)
      IF(LEN.GT.0.AND.WAVE(1:1).NE.'.'.AND.WAVE(1:1).NE.' '.AND.
     *   WAVE(1:1).NE.'?') THEN
        WRITE(LINE,'(''_diffrn_radiation.entry_id  '',2X,A)') 
     *  CODE(1:LENCD)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        IF(LEN.GT.5) LEN=5
        WRITE(LINE,350) WAVE(1:LEN)
  350   FORMAT(2X,'_diffrn_radiation.wavelength  ',A)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
        CR_CELL(4)=CR_CELL(4)/PI180
        CR_CELL(5)=CR_CELL(5)/PI180
        CR_CELL(6)=CR_CELL(6)/PI180
        WRITE(LINE,'(''_cell.entry_id  '',2X,A)') CODE(1:LENCD) 
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.length_a   '',2X,F8.3)') CR_CELL(1)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell_length_b   '',2X,F8.3)') CR_CELL(2)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.length_c   '',2X,F8.3)') CR_CELL(3)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.angle_alpha'',2X,F8.3)') CR_CELL(4)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.angle_beta '',2X,F8.3)') CR_CELL(5)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.angle_gamma'',2X,F8.3)') CR_CELL(6)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.formula_units_Z  ?'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
        WRITE(LINE,'(''_symmetry.entry_id  '',2X,A)') CODE(1:LENCD) 
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        CALL LENSTR_BL(CR_SPGR,LEN)
        WRITE(LINE,100)  CR_SPGR(1:LEN)
  100   FORMAT('_symmetry.space_group_name_H-M',2X,'''',A,'''')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,400)  CR_NSPGR
  400   FORMAT('_symmetry.Int_Tables_number   ',2X,I5)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c       IF(CR_SETT.EQ.2) THEN
          WRITE(LINE,500)  CR_SETT
  500     FORMAT('_symmetry.cell_setting_number ',2X,I5)
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c       ENDIF
        WRITE(LINE,'(''loop_'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_symmetry_equiv.id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_symmetry_equiv.pos_as_xyz'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)

C ----------------------------------------
C --- SYM ---
      DO     I=1,NSYM
        LINE=' '
C        LINE(1:3)='SYM'
C        WRITE(CH3,'(I3)') I
C        LINE(4:4)=CH3(3:3)
C        LINE(5:5)=' '
        L=0
        DO J=1,3
          TR=REAL(ISYM(4,J,I))/REAL(ISYM(5,J,I))
          IF(TR.LT.0) THEN
            L=L+1
            LINE(L:L)='-'
            NEG=1
          ELSE
            NEG=0
          ENDIF
          IF(ISYM(5,J,I).EQ.0) ISYM(5,J,I)=1
          TR=REAL(ISYM(4,J,I))/REAL(ISYM(5,J,I))
          TR=ABS(TR)
          IF(TR.GT.0.49.AND.TR.LT.0.51) THEN
            L=L+1
            LINE(L:L+2)='1/2'
            L=L+2
          ELSE IF(TR.GT.0.24.AND.TR.LT.0.26) THEN
            L=L+1
            LINE(L:L+2)='1/4'
            L=L+2
          ELSE IF(TR.GT.0.32.AND.TR.LT.0.34) THEN
            L=L+1
            LINE(L:L+2)='1/3'
            L=L+2
          ELSE IF(TR.GT.0.74.AND.TR.LT.0.76) THEN
            L=L+1
            LINE(L:L+2)='3/4'
            L=L+2
          ELSE IF(TR.GT.0.165.AND.TR.LT.0.167) THEN
            L=L+1
            LINE(L:L+2)='1/6'
            L=L+2
          ELSE IF(TR.GT.0.66.AND.TR.LT.0.67) THEN
            L=L+1
            LINE(L:L+2)='2/3'
            L=L+2
          ELSE IF(TR.GT.0.833.AND.TR.LT.0.835) THEN
            L=L+1
            LINE(L:L+2)='5/6'
            L=L+2
          ELSE
            IF(NEG.GT.0) L=L-1
          ENDIF
          DO  K=1,3
            IDG=ISYM(K,J,I)
            IF(IDG.LT.0) THEN
              L=L+1
              LINE(L:L)='-'
            ELSE IF(IDG.GT.0) THEN
              L=L+1
              LINE(L:L)='+'
            ENDIF
            IDG=ABS(IDG)
            IF(IDG.GT.1.AND.IDG.LT.10) THEN
              WRITE(CH1,'(I1)') IDG
              L=L+1
              LINE(L:L)=CH1
            ELSE IF(IDG.GT.9.AND.IDG.LT.100) THEN
              WRITE(CH2,'(I2)') IDG
              L=L+1
              LINE(L:L+1)=CH2
              L=L+1
            ELSE IF(IDG.GT.99.AND.IDG.LT.1000) THEN
              WRITE(CH3,'(I3)') IDG
              L=L+1
              LINE(L:L+2)=CH3
              L=L+2
            ENDIF
            IF(IDG.NE.0) THEN
              L=L+1
              IF(K.EQ.1) THEN
                LINE(L:L)='X'
              ELSE IF(K.EQ.2) THEN
                LINE(L:L)='Y'
              ELSE
                LINE(L:L)='Z'
              ENDIF
            ENDIF
          ENDDO
          LINE(L+1:L+3)=' , '
          L=L+3
        ENDDO
        CALL LENSTR_BL(LINE,LEN)
        JL=0
        DO IL=1,LEN
          IF(LINE(IL:IL).NE.' ') THEN
            JL=JL+1
            LINE(JL:JL)=LINE(IL:IL)
          ENDIF
        ENDDO
        LEN=JL
        CR_SYMOP = LINE(1:LEN)
        WRITE(LINE,510)  I,CR_SYMOP(1:LEN)
  510   FORMAT('    ',I3,2X,A)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDDO
C -------
C --- NCS ---
      NCS=0
      CALL GET_NCS(MDOC,NMAX,NCS,AMR,TRN,IERR)
      IF(NCS.GT.0) THEN
        WRITE(LINE,'(''loop_'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_nc_symmetry.alpha'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_nc_symmetry.beta'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_nc_symmetry.gamma'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_nc_symmetry.vector_1'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_nc_symmetry.vector_2'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_nc_symmetry.vector_3'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        DO I=1,NCS
          CALL GET_NCS(MDOC,NMAX,I,AMR,TRN,IERR)
          IF(IERR.NE.0) RETURN
          CALL MTOANG(AMR,ALPHA,BETA,GAMMA)
          WRITE(LINE,700) ALPHA,BETA,GAMMA,TRN(1),TRN(2),TRN(3)
  700     FORMAT(2X,6F12.5)
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDDO
      ENDIF
C --------------------------------------------------------------
C --- ASYMM. PART ---
      IGR=0
      CALL GET_ASYMM(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *               ,NCSF,GID,IERR)
      IF(IERR.NE.0) RETURN
      IF(NGR.GT.0) THEN

        WRITE(LINE,'(''loop_'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_struct_asym.id'')')  
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_struct_asym.entity_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_struct_asym.nc_symmetry_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_struct_asym.nc_symmetry_flag'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_struct_asym.multiplicity'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_struct_asym.PDB_chain_label'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)

        DO IGR=1,NGR

          CALL GET_ASYMM(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT,IGOLD
     *                    ,NCSF,GID,IERR)
          IF(IERR.NE.0) RETURN

          IF(INC.LE.0) THEN
            CH2='. '
          ELSE
            WRITE(CH2,'(I2)') INC
          ENDIF
          IF(NCSF.EQ.' '.OR.NCSF.EQ.'Y') NCSF='.'
          IF(MLT.LE.1) THEN
            CH2M='. '
          ELSE
            WRITE(CH2M,'(I2)') MLT
          ENDIF
          IF(CH2M(1:1).EQ.' ') THEN
            CH2M(1:1)=CH2M(2:2)
            CH2M(2:2)=' '
          ENDIF
          CID=GID(1:1)
          IF(CID.EQ.' ') CID = '.'
          IF(ICHOLD.LT.0) ICHOLD = ABS(ICHOLD)
          WRITE(LINE,800) IGOLD,ICHOLD,CH2,NCSF,CH2M,CID
  800     FORMAT(2X,I4,2X,I4,2X,A2,2X,A1,2X,A2,2X,A1)
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDDO

      ENDIF
C -----------------------------------------------------------
      IF(NCRD_CSF.GT.0) THEN
        WRITE(LINE,'(''loop_'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.symbol'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_a1'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_a2'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_a3'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_a4'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_b1'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_b2'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_b3'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_b4'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_c'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_dispersion_real'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_dispersion_imag'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.radius_contact'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.nelec'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        DO ICSF=1,NCRD_CSF
          WRITE(LINE,900) CSF_ATOM(ICSF)
     *    ,CSF_A1(ICSF),CSF_A2(ICSF),CSF_A3(ICSF),CSF_A4(ICSF)
  900     FORMAT(2X,A4,2X,4(1X,F9.5))
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,910) 
     *    CSF_B1(ICSF),CSF_B2(ICSF),CSF_B3(ICSF),CSF_B4(ICSF)
  910     FORMAT(8X,4(1X,F9.5))
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,920) 
     *    CSF_C(ICSF),CSF_FI(ICSF),CSF_FII(ICSF),CSF_NE(ICSF)
     *    ,CSF_RAD(ICSF)
  920     FORMAT(8X,5(1X,F9.5))
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDDO
      ENDIF
C -----------------------------------------------------------
C --- DERI ---
      IF(CR_FLAG_HA.EQ.'Y') THEN
        WRITE(LINE,600) CR_CF1
  600   FORMAT('_derivative.scale1',2X,F10.5)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,610) CR_CF2
  610   FORMAT('_derivative.scale2',2X,F10.5)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,620) CR_TOV
  620   FORMAT('_derivative.Toverall',2X,F10.5)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C --------------------------
      RETURN
      END

C ******
      SUBROUTINE RDCRD(MDOC,IN,MODE,IEND,IERR)
C
C -P- RDCRD - reads coordinates to common/CRDATM/
C
      INTEGER IN,MDOC,IERR,IEND,MODE
C ******
C ------------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMCIF_CRD/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ------------------------------------------------------------
      INCLUDE 'mr_crd_com.fh'
C -------------------------------------------------
      COMMON/COM_CRD_CIF/ IEND_CIF      
      INTEGER   IDATA
      REAL      FDATA
      CHARACTER DATA*80,ITEM*80
C --
      CHARACTER LINE*256,BFLAG*1,MULT*2,ASYMB*4
C      CHARACTER CODE*4,ALT*2,CH2*2
C --------------------------------------------------------------
      IERR=0
      
      IF(IEND.EQ.-1) THEN
        REWIND IN
        IEND_CIF = -1
        CR_IATOM=0
        IEND=0
      ENDIF

  300 CONTINUE   
      CALL GETCIF_CRD(IN,MDOC,IERR,IEND_CIF)
      IF(IERR.NE.0) THEN
        GO TO 1200
      ENDIF
      CR_LINE2 = ' '
      IF(IEND_CIF.EQ.-2) THEN
C
C       This string / DT_CIF (NWORDSMAX) / is a comment
C   
        LINE=DT_CIF (NWORDSMAX)
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.LE.0.OR.LINE(1:1).EQ.'#'.OR.LINE(1:1).EQ.'C'.OR.
     *     LINE(1:1).EQ.'d'.OR.LINE(1:1).EQ.'c'.OR.
     *     LINE(1:1).EQ.'_') THEN
          MODE=1
          IF(LEN.LE.0) THEN
            LEN=1
            LINE(1:1)='#'
          ENDIF
          CR_LINE=LINE(1:LEN)
          IF(LINE(1:6).EQ.'#MODEL') THEN
C           CR_MODEL = CR_MODEL + 1
            READ(LINE,'(6X,I5)') CR_MODEL
C12345678910
C#MODEL    2
          ENDIF
          GO TO 500
        ENDIF
        GO TO 300 
      ELSE IF(IEND_CIF.NE.0) THEN
        GO TO 1300
      ENDIF

      IF(N_CIF.LE.0) GO TO 300
      IF((ITM_CIF(1)(1:11).NE.'_atom_site_').AND.
     *   (ITM_CIF(1)(1:11).NE.'_atom_site.'))  GO TO 300

      CR_ANAME = '    '
      CR_ASYMB = '    '
      CR_RNAME = '   '
      CR_CORR  = '.'
      CR_SURF  = 0.0
      IFLAG=0
      CR_SEG   = '.'

      IF(CR_MODEL.LE.0) CR_MODEL = 1

      DO I=1,N_CIF
        CALL LENSTR_BL(ITM_CIF(I),LENI) 
        ITEM = ITM_CIF(I)(1:LENI)
        CALL LENSTR_BL(DT_CIF(I),LEND) 
        DATA = DT_CIF(I)(1:LEND)
        CALL LENSTR_BL(BLK_CIF,LENB) 
        IDATA=IDT_CIF(I)
        FDATA=FDT_CIF(I)

        IF(ITEM(1:10).EQ.'_atom_site') THEN

        IF((ITEM(12:22).EQ.'atom_number').OR.
     *     (ITEM(12:13).EQ.'id')) THEN
          CR_IATOLD=IDATA
        ELSE IF(ITEM(12:24).EQ.'label_atom_id') THEN
          CR_ANAME(1:LEND)=DATA(1:LEND)
        ELSE IF(ITEM(12:22).EQ.'type_symbol') THEN
          CR_ASYMB(1:LEND) = DATA(1:LEND)
        ELSE IF((ITEM(12:20).EQ.'atom_type').OR.
     *          (ITEM(12:20).EQ.'calc_flag')) THEN
          CR_ATYPE=DATA(1:1)
        ELSE IF(ITEM(12:23).EQ.'label_alt_id') THEN
          CR_ALT=DATA(1:1)
        ELSE IF((ITEM(12:24).EQ.'label_corr_id').OR.
     *          (ITEM(12:22).EQ.'footnote_id')) THEN
          CR_CORR=DATA(1:1)
        ELSE IF((ITEM(12:23).EQ.'label_res_id').OR.
     *          (ITEM(12:24).EQ.'label_comp_id')) THEN
          CR_RNAME(1:LEND)=DATA(1:LEND)
        ELSE IF((ITEM(12:23).EQ.'label_seq_id').OR.
     *          (ITEM(12:22).EQ.'auth_seq_id')) THEN
          CR_IRES=IDATA
        ELSE IF((ITEM(12:26).EQ.'label_entity_id').OR.
     *          (ITEM(12:24).EQ.'label_asym_id')) THEN
          CR_IGROUP=IDATA
          IF(CR_IGROUP.LE.0.OR.CR_IGROUP.GT.999) CR_IGROUP = 1

        ELSE IF(ITEM(13:18).EQ.'artn_x') THEN
          CR_XYZ(1)=FDATA
          CR_PDB_REC(1:1)='C'
        ELSE IF(ITEM(13:18).EQ.'artn_y') THEN
          CR_XYZ(2)=FDATA
          CR_PDB_REC(1:1)='C'
        ELSE IF(ITEM(13:18).EQ.'artn_z') THEN
          CR_XYZ(3)=FDATA
          CR_PDB_REC(1:1)='C'

        ELSE IF(ITEM(12:18).EQ.'fract_x') THEN
          CR_XYZ(1)=FDATA
          CR_PDB_REC(1:1)='F'
        ELSE IF(ITEM(12:18).EQ.'fract_y') THEN
          CR_XYZ(2)=FDATA
          CR_PDB_REC(1:1)='F'
        ELSE IF(ITEM(12:18).EQ.'fract_z') THEN
          CR_XYZ(3)=FDATA
          CR_PDB_REC(1:1)='F'

        ELSE IF(ITEM(12:18).EQ.'segment') THEN
          CR_SEG=DATA
        ELSE IF(ITEM(12:18).EQ.'surface') THEN
          CR_SURF=FDATA
        ELSE IF(ITEM(12:20).EQ.'occupancy') THEN
          CR_OCC=FDATA
        ELSE IF((ITEM(12:25).EQ.'B_iso_or_equiv').OR.
     *          (ITEM(12:25).EQ.'B_isi_or_equiv')) THEN
          CR_BISO=FDATA
        ELSE IF(ITEM(12:32).EQ.'thermal_displace_type') THEN
          CR_BTYPE=DATA(1:1)
        ELSE IF(ITEM(12:32).EQ.'symmetry_multiplicity') THEN
          IF(DATA(1:1).EQ.'.') THEN
            CR_MULT_FACTOR=1
          ELSE
            CR_MULT_FACTOR=IDATA
          ENDIF
        ELSE IF(ITEM(12:24).EQ.'aniso_U[1][1]') THEN
          CR_FLAG_USER='A'
          CR_ANIS(1)=FDATA
        ELSE IF(ITEM(12:24).EQ.'aniso_U[2][2]') THEN
          CR_FLAG_USER='A'
          CR_ANIS(2)=FDATA
        ELSE IF(ITEM(12:24).EQ.'aniso_U[3][3]') THEN
          CR_FLAG_USER='A'
          CR_ANIS(3)=FDATA
        ELSE IF(ITEM(12:24).EQ.'aniso_U[1][2]') THEN
          CR_FLAG_USER='A'
          CR_ANIS(4)=FDATA
        ELSE IF(ITEM(12:24).EQ.'aniso_U[1][3]') THEN
          CR_FLAG_USER='A'
          CR_ANIS(5)=FDATA
        ELSE IF(ITEM(12:24).EQ.'aniso_U[2][3]') THEN
          CR_FLAG_USER='A'
          CR_ANIS(6)=FDATA
        ENDIF

        ENDIF
      ENDDO


      MODE=0
      CR_IATOM =CR_IATOM+1
      BFLAG='.'
      IF(CR_BTYPE.EQ.'A') BFLAG='A'
      IF(CR_MULT_FACTOR.GT.1) THEN
        WRITE(MULT,'(I2)') CR_MULT_FACTOR
      ELSE
        MULT='. '
      ENDIF
      ASYMB=CR_ASYMB
      ASYMB(3:4)='  '          
      WRITE(LINE,100)
     *    CR_IATOLD,CR_ANAME,ASYMB,CR_ATYPE
     *   ,CR_ALT,CR_CORR
     *   ,CR_RNAME,CR_IRES,CR_IGROUP
     *   ,CR_XYZ(1),CR_XYZ(2),CR_XYZ(3)
     *   ,CR_OCC,CR_BISO
c ,BFLAG,MULT

  100     FORMAT(I5,1X,A4,1X,A4,1X,A1,1X,A1,1X,A1,1X,A3,1X 
     *    ,I4,1X,I3,1X,F8.3,1X,F8.3,1X,F8.3,1X,F6.2,1X,F6.2)
c     *    ,1X,A1,1X,A2)
      CR_LINE=LINE

          IF(CR_FLAG_USER.EQ.'A') THEN
            WRITE(LINE,400) BFLAG,MULT,CR_SURF,CR_SEG
     *      ,(CR_ANIS(IAN),IAN=1,6)
 400        FORMAT(1X,A1,1X,A2,1X,F6.2,1X,A4,1X,6F9.4)
          ELSE
            WRITE(LINE,401) BFLAG,MULT,CR_SURF,CR_SEG
 401        FORMAT(1X,A1,1X,A2,1X,F6.2,1X,A4)
          ENDIF
      CR_LINE2=LINE

 500  CONTINUE
      CALL MSGDOC(MDOC,LINE)
C ---
      RETURN
1200  CONTINUE 
      CALL MSGERR(MDOC,' ERR: READ OF FILE /.CRD/')
      CLOSE(IN)
      IERR=1
      RETURN
1300  CONTINUE 
      CLOSE(IN)
      IEND=1
      RETURN
      END

C ******
      SUBROUTINE WRCRD(MDOC,IOUT,MODE,IEND,IERR)
C
C -P- WRCRD - writes coordinates from common/CRDATM/ to file.
C
      INTEGER IOUT,MDOC,IERR,IEND,MODE
C ******
C ------------------------------------------------------------
      INCLUDE 'mr_crd_com.fh'
C -------------------------------------------------
      CHARACTER LINE*256,MULT*2,BFLAG*1,ALT*2,ASYMB*4
C --------------------------------------------------------------
      IERR=0
      
      IF(IEND.LE.0) THEN
        IF(IEND.LT.0) THEN
        IF(IOUT.GT.0) THEN

        WRITE(LINE,'(''loop_'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.label_atom_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.type_symbol'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.calc_flag'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.label_alt_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.footnote_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.label_comp_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.label_seq_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.label_asym_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)

        IF(CR_PDB_REC(1:1).EQ.'F') THEN
          WRITE(LINE,'(''_atom_site.fract_x'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.fract_y'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.fract_z'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ELSE
          WRITE(LINE,'(''_atom_site.cartn_x'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.cartn_y'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.cartn_z'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDIF

        WRITE(LINE,'(''_atom_site.occupancy'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.B_iso_or_equiv'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.thermal_displace_type'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.symmetry_multiplicity'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.surface'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.segment'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        IF(CR_FLAG_USER.EQ.'A') THEN
          WRITE(LINE,'(''_atom_site.aniso_U[1][1]'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.aniso_U[2][2]'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.aniso_U[3][3]'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.aniso_U[1][2]'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.aniso_U[1][3]'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.aniso_U[2][3]'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDIF
        ENDIF
        IEND=0
        ENDIF
C      ELSE IF(IEND.EQ.0) THEN
        IF(MODE.EQ.0) THEN

       
          BFLAG='.'
          IF(CR_BTYPE.EQ.'A') BFLAG='A'

          IF(CR_MULT_FACTOR.GT.1.AND.CR_MULT_FACTOR.LT.100) THEN
            WRITE(MULT,'(I2)') CR_MULT_FACTOR
          ELSE
            MULT='. '
          ENDIF
          ASYMB=CR_ASYMB
          ASYMB(3:4)='  '          
          IATOM=CR_IATOLD
          IF(CR_ATYPE.EQ.' ') CR_ATYPE='.'
          IF(CR_ALT  .EQ.' ') CR_ALT  ='.'
          IF(CR_CORR .EQ.' ') CR_CORR ='.'
          IF(CR_SEG  .EQ.' ') CR_SEG  ='.'
          IF(CR_BISO.GT.999.99) CR_BISO=999.99
          IF(CR_OCC .GT.999.99) CR_OCC =999.99
          IF(CR_BISO.LT.-99.99) CR_BISO=-99.99
          IF(CR_OCC .LT.-99.99) CR_OCC =-99.99
          IF(CR_SURF.GT.999.99) CR_SURF=999.99

        IF(CR_PDB_REC(1:1).EQ.'F') THEN


            WRITE(LINE,110)
     *      IATOM,CR_ANAME,ASYMB,CR_ATYPE
     *     ,CR_ALT,CR_CORR
     *     ,CR_RNAME,CR_IRES,CR_IGROUP
     *     ,CR_XYZ(1),CR_XYZ(2),CR_XYZ(3)
     *     ,CR_OCC,CR_BISO

  110     FORMAT(I5,1X,A4,1X,A4,1X,A1,1X,A1,1X,A1,1X,A3,1X 
     *    ,I4,1X,I3,1X,F8.5,1X,F8.5,1X,F8.5,1X,F6.2,1X,F6.2)

          ELSE 

          WRITE(LINE,100)
     *    IATOM,CR_ANAME,ASYMB,CR_ATYPE
     *   ,CR_ALT,CR_CORR
     *   ,CR_RNAME,CR_IRES,CR_IGROUP
     *   ,CR_XYZ(1),CR_XYZ(2),CR_XYZ(3)
     *   ,CR_OCC,CR_BISO

  100     FORMAT(I5,1X,A4,1X,A4,1X,A1,1X,A1,1X,A1,1X,A3,1X 
     *    ,I4,1X,I3,1X,F9.4,1X,F9.4,1X,F9.4,1X,F6.2,1X,F6.2)

          ENDIF

          IF(IOUT.GT.0) THEN
            CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          ENDIF

          IF(CR_FLAG_USER.EQ.'A') THEN
            WRITE(LINE,300) BFLAG,MULT,CR_SURF,CR_SEG
     *     ,(CR_ANIS(IAN),IAN=1,6)
 300        FORMAT(1X,A1,1X,A2,1X,F6.2,1X,A4,1X,6F9.4)
          ELSE
            WRITE(LINE,301) BFLAG,MULT,CR_SURF,CR_SEG
 301        FORMAT(1X,A1,1X,A2,1X,F6.2,1X,A4)
          ENDIF

          IF(IOUT.GT.0) THEN
            CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          ENDIF

        ELSE
          IF(IOUT.GT.0) THEN
            CALL LENSTR_BL(CR_LINE,LEN)
            LINE = CR_LINE        
            CALL WRTSTR(IOUT,MDOC,LINE,IERR)
            CALL LENSTR_BL(CR_LINE2,LEN)
            IF(LEN.GT.0) THEN
              LINE = CR_LINE2        
              CALL WRTSTR(IOUT,MDOC,LINE,IERR)
            ENDIF
          ENDIF

        ENDIF

        IF(IERR.GT.0) GO TO 200
C ---
      ELSE
        IF(IOUT.GT.0) THEN
          END FILE IOUT
          CLOSE(IOUT)
        ENDIF
      ENDIF
      RETURN
 200  CONTINUE 
      CALL MSGERR(MDOC,' ERR: WRITE OF FILE /.CRD/')
      CLOSE(IOUT)
      IERR=1
      RETURN
      END

C -------

C ******
      SUBROUTINE ORCRD2(MDOC,IN,FNAME,NSYM,ISYM,NSMAX,IERR)
C
C -P- ORCRD2 - OPEN OF FILE-CRD-2 FOR READ
C
C
      INTEGER   IN,MDOC,IERR
      INTEGER   NSYM,NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER FNAME*(*)
C ******
C ----------
      CHARACTER EXT*3,PATH*1,LINE*256
C -------------------------------------------------------------
      IERR=0
      EXT ='crd'
      PATH=' '
      CALL OPENFR(IN,MDOC,PATH,FNAME,EXT,IERR)
      IF(IERR.NE.0) THEN
        IERR=1
        RETURN
      ENDIF
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.65) LEN=65
      WRITE(LINE,10) FNAME(1:LEN)
 10   FORMAT('Input file :',A)
      CALL MSGDOC(MDOC,LINE)
      CALL RD2_TTL_CRD(MDOC,IN,NSYM,ISYM,NSMAX,IERR)
      IF(IERR.EQ.2) GO TO 9200
      IF(IERR.EQ.3) GO TO 9000
      IF(IERR.GT.0) IERR=4
      RETURN
9000  CONTINUE
      CALL MSGERR(MDOC,' ERROR: READ OF FILE-2 /.CRD/')
      CLOSE(IN)
      IERR=3
      RETURN
9200  CONTINUE
      CALL MSGERR(MDOC,' ERROR: END OF FILE-2 /.CRD/')
      IERR=2
      CLOSE(IN)
      RETURN
      END

C ******
      SUBROUTINE OWCRD2(MDOC,IOUT,FNAME,NSYM,ISYM,NSMAX,IERR)
C
C -P-  OWCRD2 - OPEN OF FILE-CRD-2 FOR WRITE
C
      INTEGER   IOUT,MDOC,ILINE,IERR
      INTEGER   NSYM,NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER FNAME*(*)
C ******
      CHARACTER EXT*3,PATH*1,LINE*256
C -------------------------------------------------------------
      IERR=0
      EXT='crd'
      PATH=' '
      CALL OPENFW(IOUT,MDOC,PATH,FNAME,EXT,IERR)
      IF(IERR.NE.0) GO TO 9100
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.65) LEN=65
      WRITE(LINE,10) FNAME(1:LEN)
 10   FORMAT('Output file :',A)
      CALL MSGDOC(MDOC,LINE)
      CALL WR2_TTL_CRD(MDOC,IOUT,NSYM,ISYM,NSMAX,IERR)
      IF(IERR.GT.0) GO TO 9000
      RETURN
9100  CONTINUE
      CALL MSGERR(MDOC,' ERROR: OPEN OF FILE-2 /.CRD/')
      IERR=1
      RETURN
9000  CONTINUE
      CALL MSGERR(MDOC,' ERROR: WRITE OF FILE-2 /.CRD/')
      CLOSE(IOUT)
      IERR=2
      RETURN
      END

      SUBROUTINE RD2_TTL_CRD(MDOC,IN,NSYM,ISYM,NSMAX,IERR)
C
C -P- RD2_TTL_CRD - reads title of file to common/CRD2INF/
C ----------------------------------------------------------------------------
C ---
      INTEGER   NSYM,MDOC,IN,IERR
      INTEGER   NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
C ---
C ******
C ------------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMCIF_2CRD/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ---
C -------------------------------------------------
      PARAMETER (IPRAT_SF =15)
      COMMON/CRD2FRM/ NCRD2_CSF,CSF2_NE,CSF2_RAD
     *               ,CSF2_A1,CSF2_B1,CSF2_A2,CSF2_B2
     *               ,CSF2_A3,CSF2_B3,CSF2_A4,CSF2_B4
     *               ,CSF2_C,CSF2_FI,CSF2_FII,CSF2_ATOM
      CHARACTER       CSF2_ATOM(IPRAT_SF)*4
      REAL            CSF2_A1(IPRAT_SF),CSF2_B1(IPRAT_SF)
      REAL            CSF2_A2(IPRAT_SF),CSF2_B2(IPRAT_SF)
      REAL            CSF2_A3(IPRAT_SF),CSF2_B3(IPRAT_SF)
      REAL            CSF2_A4(IPRAT_SF),CSF2_B4(IPRAT_SF)
      REAL            CSF2_C (IPRAT_SF),CSF2_RAD(IPRAT_SF)
      REAL            CSF2_FI(IPRAT_SF),CSF2_FII(IPRAT_SF)
      REAL            CSF2_NE(IPRAT_SF)
C -----------------------------------
      INCLUDE 'mr_crd2_com.fh'
C --------------------------------------------------------------
      INTEGER   IDATA
      REAL      FDATA
      CHARACTER DATA*80,ITEM*80
C ---
      REAL        AM(3,3)
      CHARACTER   FL(6)*40
      REAL        FN(40)
C ----
      INTEGER   NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
      CHARACTER NCSF*1,GID*4,CH2*2
      REAL      RLATT(6),AMR(3,3),TR(3)
      INTEGER*4 NSPGROUP,NOSETT
      CHARACTER CODE*4,NAME*20,DATE*9,SPGR*24


      CHARACTER TITLE*80,TIME*20,NAME_NDB*8,TEMPER*5,WAVE*5
      CHARACTER LINE*256,CH10*10
C -------------------------------------------------------------------
      PI=4.0*ATAN(1.0)
      PI180=PI/180.0
      IERR=0
C -------------------------------------------------------------------
      DO I=1,80
        CR2_TITLE(I:I)   = ' '
        TITLE(I:I)   = ' '
      ENDDO
      DO I=1,40
        CR2_NAME_PDB(I:I) = ' '
      ENDDO
      NCRD_CSF=0
      CR2_CELL(1)=1.0
      CR2_CELL(2)=1.0
      CR2_CELL(3)=1.0
      CR2_CELL(4)=PI/2.0
      CR2_CELL(5)=PI/2.0
      CR2_CELL(6)=PI/2.0
      CR2_SCALE(1,1)=1.0
      CR2_SCALE(1,2)=0.0
      CR2_SCALE(1,3)=0.0
      CR2_SCALE(2,1)=0.0
      CR2_SCALE(2,2)=1.0
      CR2_SCALE(2,3)=0.0
      CR2_SCALE(3,1)=0.0
      CR2_SCALE(3,2)=0.0
      CR2_SCALE(3,3)=1.0
      CR2_U(1)      =0.0
      CR2_U(2)      =0.0
      CR2_U(3)      =0.0
      CR2_FLAG_HA='N'
      CR2_CF1 = 0.0
      CR2_CF2 = 0.0
      CR2_TOV = 0.0
      CR2_ORT_TO_FRAC(1,1)=1.0
      CR2_ORT_TO_FRAC(1,2)=0.0
      CR2_ORT_TO_FRAC(1,3)=0.0
      CR2_ORT_TO_FRAC(2,1)=0.0
      CR2_ORT_TO_FRAC(2,2)=1.0
      CR2_ORT_TO_FRAC(2,3)=0.0
      CR2_ORT_TO_FRAC(3,1)=0.0
      CR2_ORT_TO_FRAC(3,2)=0.0
      CR2_ORT_TO_FRAC(3,3)=1.0
      CR2_FRAC_TO_ORT(1,1)=1.0
      CR2_FRAC_TO_ORT(1,2)=0.0
      CR2_FRAC_TO_ORT(1,3)=0.0
      CR2_FRAC_TO_ORT(2,1)=0.0
      CR2_FRAC_TO_ORT(2,2)=1.0
      CR2_FRAC_TO_ORT(2,3)=0.0
      CR2_FRAC_TO_ORT(3,1)=0.0
      CR2_FRAC_TO_ORT(3,2)=0.0
      CR2_FRAC_TO_ORT(3,3)=1.0
      CR2_NAME_PDB(1:13) = 'XXXXXXXX    ?'
      CR2_DATE_PDB   = 'XX-XXX-XX'
      CR2_CD_PDB     = 'XXXX'
      CR2_TITLE(1:9)   = '?   ?   ?'
      CR2_TITLE(69:78) = '?    ?    '
      CR2_RFAC_PDB = '.'
      CR2_RESL_PDB = '.'
      CR2_TIME     = '.'
      CR2_FLAG_HA  = 'N'
      CR2_FLAG_USER= 'N'
      CR2_MODEL    = 0
      CR2_NSPGR    = 1
      CR2_SETT     = 1
      CR2_SPGR     = 'P 1        '
      CR2_PDB_REC  ='.'
      CR2_NSYM     = 1
      CR2_NCS      = 0
      CR2_SYMOP    = 'X,Y,Z'
      CR2_IATOM    =0
      CR2_IRES     =0
      CR2_IATOLD   =0
      CR2_IGROUP   =0
      CR2_MULT_FLAG  =0
      CR2_MULT_FACTOR=1
      CR2_RTYPE    = '.'
      CR2_ATYPE    = '.'
      CR2_TERM     = '.'
      CR2_RNAME    = '.'
      CR2_ANAME    = '.'
      CR2_CHAIN    = '. '
      CR2_GROUP    = '.   '
      CR2_BTYPE    = 'I'
      CR2_FSC      = '.'
      CR2_FSA      = '.'
      NAME_NDB    = 'XXXX    '
      TITLE(1:1)  = '?'
      TEMPER      = '?    '
      WAVE        = '?    '
      NAME(1:1)   = '?'
C ------------------------------------------
      INCS=0
      CALL SET_NCS2(MDOC,NCMAX,INCS,AMR,TR,IERR)
      IF(IERR.NE.0) RETURN
      IGRP=0
      CALL SET_ASYM2(MDOC,NMAX,NGR,NCH,IGRP,ICH,INC,MLT,IATM
     *                    ,NCSF,GID,IERR)
      IF(IERR.NE.0) RETURN
C --
      IEND = -1
      ISOP =  0
C -------
  300 CONTINUE   
      CALL GETCIF_2CRD(IN,MDOC,IERR,IEND)
      IF(IERR.NE.0) THEN
        IERR=3
        RETURN
      ENDIF
      IF(IEND.EQ.-2) THEN
C
C       This string / DT_CIF (NWORDSMAX) / is a comment
C   
        GO TO 300
      ELSE IF(IEND.NE.0) THEN
        IERR=2
        RETURN
      ENDIF
      IF(N_CIF.LE.0) GO TO 300

      DO I=1,N_CIF
        CALL LENSTR_BL(ITM_CIF(I),LENI) 
        ITEM = ITM_CIF(I)(1:LENI)
        CALL LENSTR_BL(DT_CIF(I),LEND) 
        DATA = DT_CIF(I)(1:LEND)
        CALL LENSTR_BL(BLK_CIF,LENB) 
        IDATA=IDT_CIF(I)
        FDATA=FDT_CIF(I)

        IF((ITEM(1:18).EQ.'_database_PDB_code').OR.
     *     (ITEM(1:18).EQ.'_database_PDB.code').OR.
     *     (ITEM(1:20).EQ.'_database_2.code_PDB').OR.
     *     (ITEM(1:9).EQ.'_entry.id')) THEN
          CR2_CD_PDB = '    '
          IF(LEND.GT.4) LEND=4
          CR2_CD_PDB = DATA(1:LEND)
          IF(LEND.LT.4) THEN
            DO II=LEND+1,4
              CR2_CD_PDB(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:20).EQ.'_database_2.code_NDB')) THEN
          NAME_NDB = '?'
          IF(LEND.GT.8) LEND=8
          NAME_NDB = DATA(1:LEND)
          IF(LEND.LT.8) THEN
            DO II=LEND+1,8
              NAME_NDB(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:18).EQ.'_database_PDB_name').OR.
     *          (ITEM(1:18).EQ.'_database_PDB.name').OR.
     *          (ITEM(1:21).EQ.'_struct_keywords.text').OR.
     *          (ITEM(1:16).EQ.'_struct.keywords')) THEN
          CR2_NAME_PDB = ' '
          IF(LEND.GT.20) LEND=20
          NAME = DATA(1:LEND)
          IF(LEND.LT.20) THEN
            DO II=LEND+1,20
              NAME(II:II)=' '
            ENDDO
          ENDIF
       ELSE IF((ITEM(1:31).EQ.'_database_PDB_rev.date_original').OR.        
     *    (ITEM(1:31).EQ.'_database_NDB_rev.date_original')) THEN         
          CR2_DATE_PDB = '         '
          IF(LEND.GT.10) LEND=10
          CH10 = DATA(1:LEND)

          IF(CH10(5:5).EQ.'-') THEN
            CALL CHNG_DATE_BACK(CH10,CR2_DATE_PDB)         
          ENDIF

        ELSE IF((ITEM(1:18).EQ.'_database_PDB_date').OR.
     *          (ITEM(1:18).EQ.'_database_PDB.date').OR.
     *          (ITEM(1:20).EQ.'_audit.creation_date')) THEN         
          CR2_DATE_PDB = '         '
          IF(LEND.GT.10) LEND=10
          CH10 = DATA(1:LEND)
          IF(CH10(5:5).EQ.'-') THEN
            CALL CHNG_DATE_BACK(CH10,CR2_DATE_PDB)         
          ELSE
            CR2_DATE_PDB = CH10(1:9)
          ENDIF
        ELSE IF((ITEM(1:13).EQ.'_struct_title').OR.
     *          (ITEM(1:13).EQ.'_struct.title')) THEN     
          IF(LEND.GT.60) LEND=60
          TITLE = DATA(1:LEND)
          IF(LEND.LT.60) THEN
            DO II=LEND+1,60
              TITLE(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF(ITEM(1:19).EQ.'_file_creation_date') THEN
          IF(LEND.GT.20) LEND=20
          CR2_TIME = DATA(1:LEND)
        ELSE IF((ITEM(1:19).EQ.'_database_PDB_model').OR.
     *          (ITEM(1:19).EQ.'_database_PDB.model')) THEN
C          CR2_MODEL = IDATA
        ELSE IF((ITEM(1:31).EQ.'_database_PDB_remark_resolution').OR.
     *          (ITEM(1:31).EQ.'_database_PDB.remark_resolution')) 
     *       THEN
          IF(LEND.GT.40) LEND=40
          CR2_RESL_PDB = DATA(1:LEND)              
          IF(LEND.LT.40) THEN
            DO II=LEND+1,40
              CR2_RESL_PDB(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:29).EQ.'_database_PDB_remark_R_factor').OR.
     *          (ITEM(1:29).EQ.'_database_PDB.remark_R_factor')) THEN
          IF(LEND.GT.40) LEND=40
          CR2_RFAC_PDB = DATA(1:LEND)
          IF(LEND.LT.40) THEN
            DO II=LEND+1,40
              CR2_RFAC_PDB(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:27).EQ.'_diffrn.ambient_temperature')) THEN
          IF(LEND.GT.5) LEND=5
          TEMPER = DATA(1:LEND)
          IF(LEND.LT.5) THEN
            DO II=LEND+1,5
              TEMPER(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:28).EQ.'_diffrn_radiation.wavelength')) THEN
          IF(LEND.GT.5) LEND=5
          WAVE = DATA(1:LEND)
          IF(LEND.LT.5) THEN
            DO II=LEND+1,5
              WAVE(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:12) .EQ.'_cell_length').OR.         
     *          (ITEM(1:12) .EQ.'_cell_angle_').OR.         
     *          (ITEM(1:12) .EQ.'_cell.length').OR.         
     *          (ITEM(1:12) .EQ.'_cell.angle_')) THEN         
          IF(ITEM(7:14).EQ.'length_a') THEN
            CR2_CELL(1) = FDATA
          ELSE IF(ITEM(7:14).EQ.'length_b') THEN
            CR2_CELL(2) = FDATA
          ELSE IF(ITEM(7:14).EQ.'length_c') THEN
            CR2_CELL(3) = FDATA
          ELSE IF(ITEM(7:17).EQ.'angle_alpha') THEN
            CR2_CELL(4) = FDATA
            CR2_CELL(4) = CR2_CELL(4)*PI180
          ELSE IF(ITEM(7:16).EQ.'angle_beta') THEN
            CR2_CELL(5) = FDATA
            CR2_CELL(5) = CR2_CELL(5)*PI180
          ELSE IF(ITEM(7:17).EQ.'angle_gamma') THEN
            CR2_CELL(6) = FDATA
            CR2_CELL(6) = CR2_CELL(6)*PI180
          ENDIF
        ELSE IF(ITEM(1:9).EQ.'_symmetry') THEN
          IF(ITEM(11:30).EQ.'space_group_name_H-M') THEN
            IF(LEND.GT.11) LEND=11
            CR2_SPGR = DATA(1:LEND)
            IF(LEND.LT.11) THEN
              DO II=LEND+1,11
                CR2_SPGR(II:II)=' '
              ENDDO
            ENDIF
          ELSE IF(ITEM(11:15).EQ.'Int_T') THEN
            CR2_NSPGR = IDATA
          ELSE IF(ITEM(11:19).EQ.'cell_sett') THEN
            CR2_SETT = IDATA
          ELSE IF(ITEM(11:18).EQ.'equiv.id') THEN
          ELSE IF(ITEM(11:15).EQ.'equiv') THEN
c            IF(I.EQ.N_CIF) THEN
              LINE=DATA(1:LEND)
              ISOP=ISOP+1
              CALL SYMFR2_BL(MDOC,LINE,ISOP,NSYMR,ISYM,NSMAX,IERR)
              IF(IERR.GT.0) THEN
                CALL MSGERR(MDOC
     *          ,' ERR: WRONG NUMBER OF "_symmetry_equiv"-STRING')
                IERR=1
                RETURN
              ENDIF
              NSYM   =ISOP
              CR2_NSYM=ISOP
c            ENDIF
          ENDIF
        ELSE IF(ITEM(1:12).EQ.'_nc_symmetry') THEN
          IF(ITEM(14:18).EQ.'alpha') THEN
            ALPHA=FDATA
          ELSE IF(ITEM(14:17).EQ.'beta') THEN
            BETA =FDATA
          ELSE IF(ITEM(14:18).EQ.'gamma') THEN
            GAMMA=FDATA
          ELSE IF(ITEM(14:21).EQ.'vector_1') THEN
            TR(1)=FDATA
          ELSE IF(ITEM(14:21).EQ.'vector_2') THEN
            TR(2)=FDATA
          ELSE IF(ITEM(14:21).EQ.'vector_3') THEN
            TR(3)=FDATA
          ENDIF
          IF(I.EQ.N_CIF) THEN
            INCS=INCS+1
            ALPHA=ALPHA*PI180
            BETA =BETA *PI180
            GAMMA=GAMMA*PI180
            CALL EULERM(ALPHA,BETA,GAMMA,AMR)
            CALL SET_NCS2(MDOC,NCMAX,INCS,AMR,TR,IERR)
            IF(IERR.NE.0) RETURN
            II=0
            CALL GET_NCS2(MDOC,NCMAX,II,AMR,TR,IERR)
            IF(IERR.NE.0) RETURN
          ENDIF
        ELSE IF(ITEM(1:12).EQ.'_struct_asym') THEN
          IF(I.EQ.1) THEN
            IGOLD  = 0
            ICHOLD = 0
            INC    = 0
            NCSF   = '.'
            MULT   = 1
            GID    = '.   '            
          ENDIF
          IF(ITEM(14:15).EQ.'id') THEN
            IGOLD  =IDATA
          ELSE IF(ITEM(14:22).EQ.'entity_id') THEN
            ICHOLD =IDATA
          ELSE IF(ITEM(14:27).EQ.'nc_symmetry_id') THEN
            CH2 = DATA(1:2)
            CALL LENSTR_BL(CH2,LEN)
            IF(CH2(1:1).EQ.'.') THEN
              INC=0
            ELSE
              IF(LEN.LE.1) THEN
                CH2(2:2)=CH2(1:1)
                CH2(1:1)=' '
              ENDIF
              READ(CH2,'(I2)')INC
            ENDIF
          ELSE IF(ITEM(14:29).EQ.'nc_symmetry_flag') THEN
            NCSF =DATA(1:1)
          ELSE IF(ITEM(14:25).EQ.'multiplicity') THEN
            CH2 = DATA(1:2)
            CALL LENSTR_BL(CH2,LEN)
            IF(CH2(1:1).EQ.'.') THEN
              MLT=1
            ELSE
              IF(LEN.LE.1) THEN
                CH2(2:2)=CH2(1:1)
                CH2(1:1)=' '
              ENDIF
              READ(CH2,'(I2)') MLT
            ENDIF
          ELSE IF(ITEM(14:28).EQ.'PDB_chain_label') THEN
            CH2 = DATA(1:2)
            GID = CH2//'  '
          ENDIF
          IF(I.EQ.N_CIF) THEN
            IGRP  = IGRP+1
            NGR   = IGRP
            ICH   = 0
            IF(IGOLD .LE.0) IGOLD =IGRP 
            IF(ICHOLD.LE.0) ICHOLD=IGRP 
            CALL SET_ASYM2(MDOC,NMAX,NGR,ICHOLD,IGRP,ICH,INC,MLT
     *                      ,IGOLD,NCSF,GID,IERR)
            IF(IERR.NE.0) RETURN
          ENDIF
        ELSE IF((ITEM(1:18).EQ.'_derivative_scale1').OR.
     *          (ITEM(1:18).EQ.'_derivative.scale1')) THEN
         CR2_FLAG_HA='Y'
         CR2_CF1 = FDATA
        ELSE IF((ITEM(1:18).EQ.'_derivative_scale2').OR.
     *          (ITEM(1:18).EQ.'_derivative.scale2')) THEN
         CR2_FLAG_HA='Y'
         CR2_CF2 = FDATA
        ELSE IF((ITEM(1:20).EQ.'_derivative_Toverall').OR.
     *          (ITEM(1:20).EQ.'_derivative.Toverall')) THEN
         CR2_FLAG_HA='Y'
         CR2_TOV = FDATA
        ELSE IF((ITEM(1:11).EQ.'_atom_type_').OR.
     *          (ITEM(1:11).EQ.'_atom_type.')) THEN
          IF(NCRD2_CSF.GE.IPRAT_SF) THEN
            GO TO 410
          ENDIF
          IF(I.EQ.1) THEN
            CSF2_RAD (NCRD2_CSF+1)=0.0
            CSF2_NE  (NCRD2_CSF+1)=0.0
            CSF2_ATOM(NCRD2_CSF+1)='.   '
          ENDIF
          IF(ITEM(12:17).EQ.'symbol') THEN
            CSF2_ATOM(NCRD2_CSF+1) = DATA(1:4)
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_a1') THEN
            CSF2_A1(NCRD2_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_a2') THEN
            CSF2_A2(NCRD2_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_a3') THEN
            CSF2_A3(NCRD2_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_a4') THEN
            CSF2_A4(NCRD2_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_b1') THEN
            CSF2_B1(NCRD2_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_b2') THEN
            CSF2_B2(NCRD2_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_b3') THEN
            CSF2_B3(NCRD2_CSF+1) =FDATA
          ELSE IF(ITEM(12:29).EQ.'scat_Cromer_Mann_c') THEN
            CSF2_C(NCRD2_CSF+1) =FDATA
          ELSE IF(ITEM(12:31).EQ.'scat_dispersion_real') THEN
            CSF2_FI(NCRD2_CSF+1) =FDATA
          ELSE IF(ITEM(12:31).EQ.'scat_dispersion_imag') THEN
            CSF2_FII(NCRD2_CSF+1) =FDATA
          ELSE IF(ITEM(12:17).EQ.'radius') THEN
            CSF2_RAD(NCRD2_CSF+1) =FDATA
          ELSE IF(ITEM(12:16).EQ.'nelec') THEN
            CSF2_NE(NCRD2_CSF+1)  =FDATA
          ENDIF
          IF(I.EQ.N_CIF) THEN
            NCRD2_CSF   = NCRD2_CSF + 1
          ENDIF

        ELSE IF((ITEM(1:11).EQ.'_atom_site_').OR.
     *          (ITEM(1:11).EQ.'_atom_site.')) THEN

          GO TO 400
        ENDIF
 410    CONTINUE
      ENDDO
      GO TO 300
 400  CONTINUE

      IF(NAME_NDB(1:1).NE.'?'.AND.NAME_NDB(1:4).NE.'XXXX') THEN
        CR2_NAME_PDB(5:12)=NAME_NDB
      ELSE
        CR2_NAME_PDB(5:12)=CR2_CD_PDB//'    '
      ENDIF
      CR2_NAME_PDB(1:4)   = CR2_CD_PDB
      CR2_NAME_PDB(13:32) = NAME(1:20)

      CR2_TITLE(9:68) = TITLE
      CR2_TITLE(69:73)= WAVE
      CR2_TITLE(74:78)= TEMPER

      RETURN
      END

C ******
      SUBROUTINE WR2_TTL_CRD(MDOC,IOUT,NSYM,ISYM,NSMAX,IERR)
C -P- WR2_TTL_CRD - writes title from common/CRD2INF/,/CRD2ATM/ to file
C ---
      INTEGER   NSYM,MDOC,IOUT,IERR
      INTEGER   NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
C ******
C -------------------------------------------------
      PARAMETER (IPRAT_SF =15)
      COMMON/CRD2FRM/ NCRD2_CSF,CSF2_NE,CSF2_RAD
     *               ,CSF2_A1,CSF2_B1,CSF2_A2,CSF2_B2
     *               ,CSF2_A3,CSF2_B3,CSF2_A4,CSF2_B4
     *               ,CSF2_C,CSF2_FI,CSF2_FII,CSF2_ATOM
      CHARACTER       CSF2_ATOM(IPRAT_SF)*4
      REAL            CSF2_A1(IPRAT_SF),CSF2_B1(IPRAT_SF)
      REAL            CSF2_A2(IPRAT_SF),CSF2_B2(IPRAT_SF)
      REAL            CSF2_A3(IPRAT_SF),CSF2_B3(IPRAT_SF)
      REAL            CSF2_A4(IPRAT_SF),CSF2_B4(IPRAT_SF)
      REAL            CSF2_C (IPRAT_SF),CSF2_RAD(IPRAT_SF)
      REAL            CSF2_FI(IPRAT_SF),CSF2_FII(IPRAT_SF)
      REAL            CSF2_NE(IPRAT_SF)
C -----------------------------------
      INCLUDE 'mr_crd2_com.fh'
C -------------------------------------------------
C ---
C      REAL        AM(3,3)
C      CHARACTER   FL(6)*40
C      REAL        FN(40)
C ----
C      REAL      RLATT(6)
      INTEGER   NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
      CHARACTER NCSF*1,GID*4,CID*1,CH2M*2,CODE*8,TEMPER*5,WAVE*5
      CHARACTER TITLE*80,CH10*10,CODE_NDB*8
C ------------------------------------------------------------------------
      REAL      AMR(3,3),TRN(3)
      CHARACTER LINE*256,CHAR20*20,CH1*1,CH2*2,CH3*3
      CHARACTER ICS_CATEGORY*40,ICS_CELL(6)*40
     *         ,ICS_SCALE(9)*40,ICS_U(3)*40
     *         ,ICS_ORIGX(9)*40,ICS_T(3)*40
     *         ,ICS_A(4)*40,ICS_B(4)*40,ICS_C*40,ICS_FI*40,ICS_FII*40
     *         ,ICS_RADIUS*40,ICS_NSPGR*40,ICS_SETT*40
     *         ,ICS_CD_PDB*40,ICS_NAME_PDB*40,ICS_DATE_PDB*40
     *         ,ICS_TITLE*40,ICS_RESL_PDB*40,ICS_RFAC_PDB*40
     *         ,ICS_MODEL*40,ICS_SPGR*40,ICS_SYMOP*40,ICS_ATYPE*40
C -------------------------------------------------------------------
      PI=4.0*ATAN(1.0)
      PI180=PI/180.0
      IERR=0
      IF(IOUT.LE.0) RETURN
C --------------------------------
       ICS_CATEGORY   = '_database_PDB.'
       ICS_CD_PDB     = 'code'
       ICS_NAME_PDB   = 'name'
       ICS_DATE_PDB   = 'date'
       ICS_TITLE      = 'compnd'
       ICS_RESL_PDB   = 'remark_resolution'
       ICS_RFAC_PDB   = 'remark_R_factor'
       ICS_MODEL      = 'model'
C
       ICS_CELL(1)    = '_cell.length_a'
       ICS_CELL(2)    = '_cell.length_b'
       ICS_CELL(3)    = '_cell.length_c'
       ICS_CELL(4)    = '_cell.angle_alpha'
       ICS_CELL(5)    = '_cell.angle_beta'
       ICS_CELL(6)    = '_cell.angle_gamma'
C
       ICS_SPGR       = '_symmetry.space_group_name_H-M'
       ICS_NSPGR      = '_symmetry.Int_Tables_number'
       ICS_SETT       = '_symmetry.cell_setting_number'
       ICS_SYMOP      = '_symmetry_equiv.pos_as_xyz'
C
C --------------------------------
      CALL LENSTR_BL(CR2_TITLE,LEN)
      IF(LEN.LT.9) THEN 
        TITLE = '?'
        WAVE  = '?'
        TEMPER= '?'
      ELSE IF(LEN.LT.69) THEN 
        TITLE = CR2_TITLE(9:68)
        WAVE  = '?'
        TEMPER= '?'
      ELSE IF(LEN.LT.74) THEN 
        TITLE = CR2_TITLE(9:68)
        WAVE  = CR2_TITLE(69:73)
        TEMPER= '?'
      ELSE
        TITLE = CR2_TITLE(9:68)
        WAVE  = CR2_TITLE(69:73)
        TEMPER= CR2_TITLE(74:78)
      ENDIF

      CALL LENSTR_BL(CR2_NAME_PDB,LEN)
      IF(LEN.LE.4) THEN
        CODE         ='XXXX    '
        CODE_NDB     ='?'
      ELSE
        IF(LEN.GT.12) LEN=12   
        CODE=CR2_NAME_PDB(5:LEN)
        CODE_NDB     = CODE
      ENDIF

      IF(CODE_NDB(1:4).EQ.CR2_CD_PDB.AND.CODE_NDB(5:8).EQ.'    ')
     *  CODE_NDB='?'

      IF(CODE(1:1).EQ.'?'.OR.CODE(1:1).EQ.' '.OR.CODE(1:1).EQ.'.'.OR.
     *   CODE(1:4).EQ.'XXXX') THEN
        CODE    = CR2_CD_PDB//'    '    
        CODE_NDB= '?'
      ENDIF

      CALL LENSTR_BL(CODE,LENCD)
      WRITE(LINE,'(''data_structure_'',A)') CODE(1:LENCD)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)

      CALL LENSTR_BL(ICS_CATEGORY,LENC)

C ---
      WRITE(LINE,
     *'(''_database_2.database_id'',2X,A)') CODE
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      CALL LENSTR_BL(CR2_CD_PDB,LEN)
      WRITE(LINE,
     *'(''_database_2.code_PDB   '',2X,A)') CR2_CD_PDB(1:LEN)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      IF(CODE_NDB(1:1).NE.'?') THEN
        WRITE(LINE,
     *'(''_database_2.code_NDB   '',2X,A)') CODE(1:LENCD)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
      WRITE(LINE,'(''_struct_keywords.entry_id'',2X,A)') CODE(1:LENCD)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      CALL LENSTR_BL(CR2_NAME_PDB,LEN)
      IF(LEN.LE.12) THEN
        CR2_NAME_PDB(13:13)='?'
        LEN=13
      ENDIF
      IF(LEN.GT.32) LEN=32
      WRITE(LINE,110) CR2_NAME_PDB(13:LEN)

  110 FORMAT(       
     * '_struct_keywords.text  ',2X,'''',A,'''')
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
      WRITE(LINE,'(''_struct.entry_id'',2X,A)') CODE(1:LENCD)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      CALL LENSTR_BL(TITLE,LEN)
      IF(LEN.GT.60) LEN=60
      WRITE(LINE,200) TITLE(1:LEN)
  200 FORMAT(       '_struct.title   ',2X,'''',A,'''')
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
      WRITE(LINE,'(''_database_PDB_rev.num 1'')') 
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)

      CALL CHNG_DATE(CR2_DATE_PDB,CH10)

      WRITE(LINE,'(''_database_PDB_rev.date_original'',2X,A)') 
     * CH10(1:10)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
      CALL CHCLOCK(CHAR20)
      WRITE(LINE,210) CHAR20
  210 FORMAT(       '_file_creation_date ',2X,'''',A,'''')
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
      IF(CR2_MODEL.GT.0) THEN
        CALL LENSTR_BL(ICS_MODEL,LEN)
        WRITE(LINE,'(A,A,2X,I4)')
     *  ICS_CATEGORY(1:LENC),ICS_MODEL(1:LEN),CR2_MODEL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
      IF(CR2_RESL_PDB(1:1).NE.'.'.AND.CR2_RESL_PDB(1:1).NE.' ')THEN
        CALL LENSTR_BL(ICS_RESL_PDB,LEN)
        LINE= ICS_CATEGORY(1:LENC)//ICS_RESL_PDB(1:LEN)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        CALL LENSTR_BL(CR2_RESL_PDB,LEN)
        WRITE(LINE,310) CR2_RESL_PDB(1:LEN)
  310   FORMAT('''',A,'''')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
      IF(CR2_RFAC_PDB(1:1).NE.'.'.AND.CR2_RFAC_PDB(1:1).NE.'   ')THEN
        CALL LENSTR_BL(ICS_RFAC_PDB,LEN)
        LINE= ICS_CATEGORY(1:LENC)//ICS_RFAC_PDB(1:LEN)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        CALL LENSTR_BL(CR2_RFAC_PDB,LEN)
        WRITE(LINE,330) CR2_RFAC_PDB(1:LEN)
  330   FORMAT('''',A,'''')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
      CALL LENSTR_BL(TEMPER,LEN)
      IF(LEN.GT.0.AND.TEMPER(1:1).NE.'.'.AND.TEMPER(1:1).NE.' '.AND.
     *   TEMPER(1:1).NE.'?') THEN
        WRITE(LINE,'(''_diffrn.entry_id             '',2X,A)') 
     *  CODE(1:LENCD)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        IF(LEN.GT.5) LEN=5
        WRITE(LINE,340) TEMPER(1:LEN)
  340   FORMAT('_diffrn.ambient_temperature    ',A)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
      CALL LENSTR_BL(WAVE,LEN)
      IF(LEN.GT.0.AND.WAVE(1:1).NE.'.'.AND.WAVE(1:1).NE.' '.AND.
     *   WAVE(1:1).NE.'?') THEN
        WRITE(LINE,'(''_diffrn_radiation.entry_id  '',2X,A)') 
     *  CODE(1:LENCD)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        IF(LEN.GT.5) LEN=5
        WRITE(LINE,350) WAVE(1:LEN)
  350   FORMAT('_diffrn_radiation.wavelength  ',A)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
        CR2_CELL(4)=CR2_CELL(4)/PI180
        CR2_CELL(5)=CR2_CELL(5)/PI180
        CR2_CELL(6)=CR2_CELL(6)/PI180
        WRITE(LINE,'(''_cell.entry_id  '',2X,A)') CODE(1:LENCD) 
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.length_a   '',2X,F8.3)') CR2_CELL(1)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell_length_b   '',2X,F8.3)') CR2_CELL(2)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.length_c   '',2X,F8.3)') CR2_CELL(3)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.angle_alpha'',2X,F8.3)') CR2_CELL(4)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.angle_beta '',2X,F8.3)') CR2_CELL(5)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.angle_gamma'',2X,F8.3)') CR2_CELL(6)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.formula_units_Z  ?'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
        WRITE(LINE,'(''_symmetry.entry_id  '',2X,A)') CODE(1:LENCD) 
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        CALL LENSTR_BL(CR2_SPGR,LEN)
        WRITE(LINE,100)  CR2_SPGR(1:LEN)
  100   FORMAT('_symmetry.space_group_name_H-M',2X,'''',A,'''')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,400)  CR2_NSPGR
  400   FORMAT('_symmetry.Int_Tables_number   ',2X,I5)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c        IF(CR2_SETT.EQ.2) THEN
          WRITE(LINE,500)  CR2_SETT
  500     FORMAT('_symmetry.cell_setting_number ',2X,I5)
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c        ENDIF
        WRITE(LINE,'(''loop_'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_symmetry_equiv.id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_symmetry_equiv.pos_as_xyz'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ----------------------------------------
C --- SYM ---
      DO     I=1,NSYM
        LINE=' '
C        LINE(1:3)='SYM'
C        WRITE(CH3,'(I3)') I
C        LINE(4:4)=CH3(3:3)
C        LINE(5:5)=' '
        L=0
        DO J=1,3
          TR=REAL(ISYM(4,J,I))/REAL(ISYM(5,J,I))
          IF(TR.LT.0) THEN
            L=L+1
            LINE(L:L)='-'
            NEG=1
          ELSE
            NEG=0
          ENDIF
          IF(ISYM(5,J,I).EQ.0) ISYM(5,J,I)=1.0
          TR=REAL(ISYM(4,J,I))/REAL(ISYM(5,J,I))
          TR=ABS(TR)
          IF(TR.GT.0.49.AND.TR.LT.0.51) THEN
            L=L+1
            LINE(L:L+2)='1/2'
            L=L+2
          ELSE IF(TR.GT.0.24.AND.TR.LT.0.26) THEN
            L=L+1
            LINE(L:L+2)='1/4'
            L=L+2
          ELSE IF(TR.GT.0.32.AND.TR.LT.0.34) THEN
            L=L+1
            LINE(L:L+2)='1/3'
            L=L+2
          ELSE IF(TR.GT.0.74.AND.TR.LT.0.76) THEN
            L=L+1
            LINE(L:L+2)='3/4'
            L=L+2
          ELSE IF(TR.GT.0.165.AND.TR.LT.0.167) THEN
            L=L+1
            LINE(L:L+2)='1/6'
            L=L+2
          ELSE IF(TR.GT.0.66.AND.TR.LT.0.67) THEN
            L=L+1
            LINE(L:L+2)='2/3'
            L=L+2
          ELSE IF(TR.GT.0.833.AND.TR.LT.0.835) THEN
            L=L+1
            LINE(L:L+2)='5/6'
            L=L+2
          ELSE
            IF(NEG.GT.0) L=L-1
          ENDIF
          DO  K=1,3
            IDG=ISYM(K,J,I)
            IF(IDG.LT.0) THEN
              L=L+1
              LINE(L:L)='-'
            ELSE IF(IDG.GT.0) THEN
              L=L+1
              LINE(L:L)='+'
            ENDIF
            IDG=ABS(IDG)
            IF(IDG.GT.1.AND.IDG.LT.10) THEN
              WRITE(CH1,'(I1)') IDG
              L=L+1
              LINE(L:L)=CH1
            ELSE IF(IDG.GT.9.AND.IDG.LT.100) THEN
              WRITE(CH2,'(I2)') IDG
              L=L+1
              LINE(L:L+1)=CH2
              L=L+1
            ELSE IF(IDG.GT.99.AND.IDG.LT.1000) THEN
              WRITE(CH3,'(I3)') IDG
              L=L+1
              LINE(L:L+2)=CH3
              L=L+2
            ENDIF
            IF(IDG.NE.0) THEN
              L=L+1
              IF(K.EQ.1) THEN
                LINE(L:L)='X'
              ELSE IF(K.EQ.2) THEN
                LINE(L:L)='Y'
              ELSE
                LINE(L:L)='Z'
              ENDIF
            ENDIF
          ENDDO
          LINE(L+1:L+3)=' , '
          L=L+3
        ENDDO
        CALL LENSTR_BL(LINE,LEN)
        JL=0
        DO IL=1,LEN
          IF(LINE(IL:IL).NE.' ') THEN
            JL=JL+1
            LINE(JL:JL)=LINE(IL:IL)
          ENDIF
        ENDDO
        LEN=JL
        CR2_SYMOP = LINE(1:LEN)
        WRITE(LINE,510)  I,CR2_SYMOP(1:LEN)
  510   FORMAT('    ',I3,2X,A)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDDO
C -------
C --- NCS ---
      NCS=0
      CALL GET_NCS2(MDOC,NMAX,NCS,AMR,TRN,IERR)
      IF(NCS.GT.0) THEN
        WRITE(LINE,'(''loop_'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_nc_symmetry.alpha'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_nc_symmetry.beta'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_nc_symmetry.gamma'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_nc_symmetry.vector_1'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_nc_symmetry.vector_2'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_nc_symmetry.vector_3'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        DO I=1,NCS
          CALL GET_NCS2(MDOC,NMAX,I,AMR,TRN,IERR)
          IF(IERR.NE.0) RETURN
          CALL MTOANG(AMR,ALPHA,BETA,GAMMA)
          WRITE(LINE,700) ALPHA,BETA,GAMMA,TRN(1),TRN(2),TRN(3)
  700     FORMAT(2X,6F12.5)
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDDO
      ENDIF
C --------------------------------------------------------------
C --- ASYMM. PART ---
      IGR=0
      CALL GET_ASYM2(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *               ,NCSF,GID,IERR)
      IF(IERR.NE.0) RETURN
      IF(NGR.GT.0) THEN

        WRITE(LINE,'(''loop_'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_struct_asym.id'')')  
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_struct_asym.entity_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_struct_asym.nc_symmetry_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_struct_asym.nc_symmetry_flag'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_struct_asym.multiplicity'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_struct_asym.PDB_chain_label'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)

        DO IGR=1,NGR

          CALL GET_ASYM2(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT,IGOLD
     *                    ,NCSF,GID,IERR)
          IF(IERR.NE.0) RETURN
          IF(INC.LE.0) THEN
            CH2='. '
          ELSE
            WRITE(CH2,'(I2)') INC
          ENDIF
          IF(NCSF.EQ.' '.OR.NCSF.EQ.'Y') NCSF='.'
          IF(MLT.LE.1) THEN
            CH2M='. '
          ELSE
            WRITE(CH2M,'(I2)') MLT
          ENDIF
          IF(CH2M(1:1).EQ.' ') THEN
            CH2M(1:1)=CH2M(2:2)
            CH2M(2:2)=' '
          ENDIF
          CID=GID(1:1)
          IF(CID.EQ.' ') CID = '.'
          IF(ICHOLD.LT.0) ICHOLD = ABS(ICHOLD)
          WRITE(LINE,800) IGOLD,ICHOLD,CH2,NCSF,CH2M,CID
  800     FORMAT(2X,I4,2X,I4,2X,A2,2X,A1,2X,A2,2X,A1)
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDDO

      ENDIF
C -----------------------------------------------------------
      IF(NCRD2_CSF.GT.0) THEN
        WRITE(LINE,'(''loop_'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.symbol'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_a1'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_a2'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_a3'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_a4'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_b1'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_b2'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_b3'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_b4'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_c'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_dispersion_real'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_dispersion_imag'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.radius_contact'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.nelec'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        DO ICSF=1,NCRD2_CSF
          WRITE(LINE,900) CSF2_ATOM(ICSF)
     *    ,CSF2_A1(ICSF),CSF2_A2(ICSF),CSF2_A3(ICSF),CSF2_A4(ICSF)
  900     FORMAT(2X,A4,2X,4(1X,F9.5))
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,910) 
     *    CSF2_B1(ICSF),CSF2_B2(ICSF),CSF2_B3(ICSF),CSF2_B4(ICSF)
  910     FORMAT(8X,4(1X,F9.5))
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,920) 
     *    CSF2_C(ICSF),CSF2_FI(ICSF),CSF2_FII(ICSF),CSF2_NE(ICSF)
     *    ,CSF2_RAD(ICSF)
  920     FORMAT(8X,5(1X,F9.5))
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDDO
      ENDIF
C -----------------------------------------------------------
C -----------------------------------------------------------
C --- DERI ---
      IF(CR2_FLAG_HA.EQ.'Y') THEN
        WRITE(LINE,600) CR2_CF1
  600   FORMAT('_derivative.scale1',2X,F10.5)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,610) CR2_CF2
  610   FORMAT('_derivative.scale2',2X,F10.5)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,620) CR2_TOV
  620   FORMAT('_derivative.Toverall',2X,F10.5)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C --------------------------
      RETURN
      END


C ******
      SUBROUTINE RDCRD2(MDOC,IN,MODE,IEND,IERR)
C
C -P- RDCRD - reads coordinates to common/CRD2ATM/
C
      INTEGER IN,MDOC,IERR,IEND,MODE
C ******
C ------------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMCIF_2CRD/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ------------------------------------------------------------
      INCLUDE 'mr_crd2_com.fh'
C -------------------------------------------------
      COMMON/COM_2CRD_CIF/ IEND_CIF      
      INTEGER   IDATA
      REAL      FDATA
      CHARACTER DATA*80,ITEM*80
C --
      CHARACTER LINE*256,BFLAG*1,MULT*2,ASYMB*4
C      CHARACTER CODE*4,ALT*2,CH2*2
C --------------------------------------------------------------
      IERR=0
      
      IF(IEND.EQ.-1) THEN
        REWIND IN
        IEND_CIF = -1
        CR2_IATOM=0
        IEND=0
      ENDIF

  300 CONTINUE   
      CALL GETCIF_2CRD(IN,MDOC,IERR,IEND_CIF)
      IF(IERR.NE.0) THEN
        GO TO 1200
      ENDIF
      CR2_LINE2 = ' '
      IF(IEND_CIF.EQ.-2) THEN
C
C       This string / DT_CIF (NWORDSMAX) / is a comment
C   
        LINE=DT_CIF (NWORDSMAX)
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.LE.0.OR.LINE(1:1).EQ.'#'.OR.LINE(1:1).EQ.'C'.OR.
     *     LINE(1:1).EQ.'d'.OR.LINE(1:1).EQ.'c'.OR.
     *     LINE(1:1).EQ.'_') THEN
          MODE=1
          IF(LEN.LE.0) THEN
            LEN=1
            LINE(1:1)='#'
          ENDIF
          CR2_LINE=LINE(1:LEN)
          IF(LINE(1:6).EQ.'#MODEL') THEN
C           CR2_MODEL = CR2_MODEL + 1
            READ(LINE,'(6X,I5)') CR2_MODEL
C12345678910
C#MODEL    2
          ENDIF
          GO TO 500
        ENDIF
        GO TO 300 
      ELSE IF(IEND_CIF.NE.0) THEN
        GO TO 1300
      ENDIF

      IF(N_CIF.LE.0) GO TO 300
      IF((ITM_CIF(1)(1:11).NE.'_atom_site_').AND.
     *   (ITM_CIF(1)(1:11).NE.'_atom_site.'))  GO TO 300

      CR2_ANAME = '    '
      CR2_ASYMB = '    '
      CR2_RNAME = '   '
      CR2_SURF  = 0.0
      CR2_CORR  = '.'
      CR2_SEG   = '.'

      IFLAG=0

      IF(CR2_MODEL.LE.0) CR2_MODEL = 1

      DO I=1,N_CIF
        CALL LENSTR_BL(ITM_CIF(I),LENI) 
        ITEM = ITM_CIF(I)(1:LENI)
        CALL LENSTR_BL(DT_CIF(I),LEND) 
        DATA = DT_CIF(I)(1:LEND)
        CALL LENSTR_BL(BLK_CIF,LENB) 
        IDATA=IDT_CIF(I)
        FDATA=FDT_CIF(I)

        IF(ITEM(1:10).EQ.'_atom_site') THEN

        IF((ITEM(12:22).EQ.'atom_number').OR.
     *     (ITEM(12:13).EQ.'id')) THEN
          CR2_IATOLD=IDATA
        ELSE IF(ITEM(12:24).EQ.'label_atom_id') THEN
          CR2_ANAME(1:LEND)=DATA(1:LEND)
        ELSE IF(ITEM(12:22).EQ.'type_symbol') THEN
          CR2_ASYMB(1:LEND) = DATA(1:LEND)
        ELSE IF((ITEM(12:20).EQ.'atom_type').OR.
     *          (ITEM(12:20).EQ.'calc_flag')) THEN
          CR2_ATYPE=DATA(1:1)
        ELSE IF(ITEM(12:23).EQ.'label_alt_id') THEN
          CR2_ALT=DATA(1:1)
        ELSE IF((ITEM(12:24).EQ.'label_corr_id').OR.
     *          (ITEM(12:22).EQ.'footnote_id')) THEN
          CR2_CORR=DATA(1:1)
        ELSE IF((ITEM(12:23).EQ.'label_res_id').OR.
     *          (ITEM(12:24).EQ.'label_comp_id')) THEN
          CR2_RNAME(1:LEND)=DATA(1:LEND)
        ELSE IF((ITEM(12:23).EQ.'label_seq_id').OR.
     *          (ITEM(12:22).EQ.'auth_seq_id')) THEN
          CR2_IRES=IDATA
        ELSE IF((ITEM(12:26).EQ.'label_entity_id').OR.
     *          (ITEM(12:24).EQ.'label_asym_id')) THEN
          CR2_IGROUP=IDATA
          IF(CR2_IGROUP.LE.0.OR.CR2_IGROUP.GT.999) CR2_IGROUP = 1

        ELSE IF(ITEM(13:18).EQ.'artn_x') THEN
          CR2_XYZ(1)=FDATA
          CR2_PDB_REC(1:1)='C'
        ELSE IF(ITEM(13:18).EQ.'artn_y') THEN
          CR2_XYZ(2)=FDATA
          CR2_PDB_REC(1:1)='C'
        ELSE IF(ITEM(13:18).EQ.'artn_z') THEN
          CR2_XYZ(3)=FDATA
          CR2_PDB_REC(1:1)='C'

        ELSE IF(ITEM(12:18).EQ.'fract_x') THEN
          CR2_XYZ(1)=FDATA
          CR2_PDB_REC(1:1)='F'
        ELSE IF(ITEM(12:18).EQ.'fract_y') THEN
          CR2_XYZ(2)=FDATA
          CR2_PDB_REC(1:1)='F'
        ELSE IF(ITEM(12:18).EQ.'fract_z') THEN
          CR2_XYZ(3)=FDATA
          CR2_PDB_REC(1:1)='F'

        ELSE IF(ITEM(12:18).EQ.'surface') THEN
          CR2_SURF=FDATA
        ELSE IF(ITEM(12:18).EQ.'segment') THEN
          CR2_SEG=DATA
        ELSE IF(ITEM(12:20).EQ.'occupancy') THEN
          CR2_OCC=FDATA
        ELSE IF((ITEM(12:25).EQ.'B_iso_or_equiv').OR.
     *          (ITEM(12:25).EQ.'B_isi_or_equiv')) THEN
          CR2_BISO=FDATA
        ELSE IF(ITEM(12:32).EQ.'thermal_displace_type') THEN
          CR2_BTYPE=DATA(1:1)
        ELSE IF(ITEM(12:32).EQ.'symmetry_multiplicity') THEN
          IF(DATA(1:1).EQ.'.') THEN
            CR2_MULT_FACTOR=1
          ELSE
            CR2_MULT_FACTOR=IDATA
          ENDIF
        ELSE IF(ITEM(12:24).EQ.'aniso_U[1][1]') THEN
          CR2_FLAG_USER='A'
          CR2_ANIS(1)=FDATA
        ELSE IF(ITEM(12:24).EQ.'aniso_U[2][2]') THEN
          CR2_FLAG_USER='A'
          CR2_ANIS(2)=FDATA
        ELSE IF(ITEM(12:24).EQ.'aniso_U[3][3]') THEN
          CR2_FLAG_USER='A'
          CR2_ANIS(3)=FDATA
        ELSE IF(ITEM(12:24).EQ.'aniso_U[1][2]') THEN
          CR2_FLAG_USER='A'
          CR2_ANIS(4)=FDATA
        ELSE IF(ITEM(12:24).EQ.'aniso_U[1][3]') THEN
          CR2_FLAG_USER='A'
          CR2_ANIS(5)=FDATA
        ELSE IF(ITEM(12:24).EQ.'aniso_U[2][3]') THEN
          CR2_FLAG_USER='A'
          CR2_ANIS(6)=FDATA
        ENDIF

        ENDIF

      ENDDO


      MODE=0
      CR2_IATOM =CR2_IATOM+1
      BFLAG='.'
      IF(CR2_BTYPE.EQ.'A') BFLAG='A'
      IF(CR2_MULT_FACTOR.GT.1) THEN
        WRITE(MULT,'(I2)') CR2_MULT_FACTOR
      ELSE
        MULT='. '
      ENDIF
      ASYMB=CR2_ASYMB
      ASYMB(3:4)='  '          
      IATOM=CR2_IATOLD
      WRITE(LINE,100)
     *   IATOM,CR2_ANAME,ASYMB,CR2_ATYPE
     *   ,CR2_ALT,CR2_CORR
     *   ,CR2_RNAME,CR2_IRES,CR2_IGROUP
     *   ,CR2_XYZ(1),CR2_XYZ(2),CR2_XYZ(3)
     *   ,CR2_OCC,CR2_BISO
c  ,BFLAG,MULT

  100     FORMAT(I5,1X,A4,1X,A4,1X,A1,1X,A1,1X,A1,1X,A3,1X 
     *    ,I4,1X,I3,1X,F8.3,1X,F8.3,1X,F8.3,1X,F6.2,1X,F6.2)
c      *    ,1X,A1,1X,A2)
      CR2_LINE=LINE
          IF(CR2_FLAG_USER.EQ.'A') THEN
            WRITE(LINE,400) BFLAG,MULT,CR2_SURF,CR2_SEG
     *                      ,(CR2_ANIS(IAN),IAN=1,6)
 400        FORMAT(1X,A1,1X,A2,1X,F6.2,1X,A4,1X,6F9.4)
          ELSE
            WRITE(LINE,401) BFLAG,MULT,CR2_SURF,CR2_SEG
 401        FORMAT(1X,A1,1X,A2,1X,F6.2,1X,A4)
          ENDIF
      CR2_LINE2=LINE

 500  CONTINUE
      CALL MSGDOC(MDOC,LINE)
C ---
      RETURN
1200  CONTINUE 
      CALL MSGERR(MDOC,' ERR: READ OF FILE /.CRD_2/')
      CLOSE(IN)
      IERR=1
      RETURN
1300  CONTINUE 
      CLOSE(IN)
      IEND=1
      RETURN
      END

C ******
      SUBROUTINE WRCRD2(MDOC,IOUT,MODE,IEND,IERR)
C
C -P- WRCRD2 - writes coordinates from common/CRD2ATM/ to file.
C
      INTEGER IOUT,MDOC,IERR,IEND,MODE
C ******
C ------------------------------------------------------------
      INCLUDE 'mr_crd2_com.fh'
C -------------------------------------------------
      CHARACTER LINE*256,MULT*2,BFLAG*1,ALT*2,ASYMB*4
C --------------------------------------------------------------
      IERR=0
      
      IF(IEND.LE.0) THEN
        IF(IEND.LT.0) THEN
        IF(IOUT.GT.0) THEN


        WRITE(LINE,'(''loop_'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.label_atom_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.type_symbol'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.calc_flag'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.label_alt_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.footnote_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.label_comp_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.label_seq_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.label_asym_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)

        IF(CR2_PDB_REC(1:1).EQ.'F') THEN
          WRITE(LINE,'(''_atom_site.fract_x'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.fract_y'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.fract_z'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ELSE
          WRITE(LINE,'(''_atom_site.cartn_x'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.cartn_y'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.cartn_z'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDIF

        WRITE(LINE,'(''_atom_site.occupancy'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.B_iso_or_equiv'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.thermal_displace_type'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.symmetry_multiplicity'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.surface'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.segment'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        IF(CR2_FLAG_USER.EQ.'A') THEN
          WRITE(LINE,'(''_atom_site.aniso_U[1][1]'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.aniso_U[2][2]'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.aniso_U[3][3]'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.aniso_U[1][2]'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.aniso_U[1][3]'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.aniso_U[2][3]'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDIF

        ENDIF
        IEND=0
        ENDIF
C      ELSE IF(IEND.EQ.0) THEN
        IF(MODE.EQ.0) THEN

       
          BFLAG='.'
          IF(CR2_BTYPE.EQ.'A') BFLAG='A'

          IF(CR2_MULT_FACTOR.GT.1) THEN
            WRITE(MULT,'(I2)') CR2_MULT_FACTOR
          ELSE
            MULT='. '
          ENDIF
          ASYMB=CR2_ASYMB
          ASYMB(3:4)='  '          
          IATOM=CR2_IATOLD
      
          IF(CR2_ATYPE.EQ.' ') CR2_ATYPE='.'
          IF(CR2_ALT  .EQ.' ') CR2_ALT  ='.'
          IF(CR2_CORR .EQ.' ') CR2_CORR ='.'
          IF(CR2_BISO.GT.999.99) CR2_BISO=999.99
          IF(CR2_OCC .GT.999.99) CR2_OCC =999.99
          IF(CR2_BISO.LT.-99.99) CR2_BISO=-99.99
          IF(CR2_OCC .LT.-99.99) CR2_OCC =-99.99
          IF(CR2_SURF.GT.999.99) CR2_SURF=999.99



        IF(CR2_PDB_REC(1:1).EQ.'F') THEN

            WRITE(LINE,110)
     *      IATOM,CR2_ANAME,ASYMB,CR2_ATYPE
     *     ,CR2_ALT,CR2_CORR
     *     ,CR2_RNAME,CR2_IRES,CR2_IGROUP
     *     ,CR2_XYZ(1),CR2_XYZ(2),CR2_XYZ(3)
     *     ,CR2_OCC,CR2_BISO

  110     FORMAT(I5,1X,A4,1X,A4,1X,A1,1X,A1,1X,A1,1X,A3,1X 
     *    ,I4,1X,I3,1X,F8.5,1X,F8.5,1X,F8.5,1X,F6.2,1X,F6.2)

          ELSE 

          WRITE(LINE,100)
     *    IATOM,CR2_ANAME,ASYMB,CR2_ATYPE
     *   ,CR2_ALT,CR2_CORR
     *   ,CR2_RNAME,CR2_IRES,CR2_IGROUP
     *   ,CR2_XYZ(1),CR2_XYZ(2),CR2_XYZ(3)
     *   ,CR2_OCC,CR2_BISO

  100     FORMAT(I5,1X,A4,1X,A4,1X,A1,1X,A1,1X,A1,1X,A3,1X 
     *    ,I4,1X,I3,1X,F8.3,1X,F8.3,1X,F8.3,1X,F6.2,1X,F6.2)

          ENDIF

          IF(IOUT.GT.0) THEN
            CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          ENDIF

          IF(CR2_FLAG_USER.EQ.'A') THEN

            WRITE(LINE,300)  BFLAG,MULT,CR2_SURF,CR2_SEG
     *                       ,(CR2_ANIS(IAN),IAN=1,6)
 300        FORMAT(1X,A1,1X,A2,1X,F6.2,1X,A4,1X,6F9.4)
          ELSE
            WRITE(LINE,301) BFLAG,MULT,CR2_SURF,CR2_SEG
 301        FORMAT(1X,A1,1X,A2,1X,F6.2,1X,A4)
          ENDIF

          IF(IOUT.GT.0) THEN
            CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          ENDIF

        ELSE
          IF(IOUT.GT.0) THEN
            CALL LENSTR_BL(CR2_LINE,LEN)
            LINE = CR2_LINE        
            CALL WRTSTR(IOUT,MDOC,LINE,IERR)
            CALL LENSTR_BL(CR2_LINE2,LEN)
            IF(LEN.GT.0) THEN
              LINE = CR2_LINE2        
              CALL WRTSTR(IOUT,MDOC,LINE,IERR)
            ENDIF
          ENDIF

        ENDIF

        IF(IERR.GT.0) GO TO 200
C ---
      ELSE
        IF(IOUT.GT.0) THEN
          END FILE IOUT
          CLOSE(IOUT)
        ENDIF
      ENDIF
      RETURN
 200  CONTINUE 
      CALL MSGERR(MDOC,' ERR: WRITE OF FILE /.CRD2/')
      CLOSE(IOUT)
      IERR=1
      RETURN
      END

      SUBROUTINE WRSTR(MDOC,IOUT,IEND,IERR)
C ---
      COMMON/COM_STR/ DIST,THETA,PSI,RVDW,CHARGE,IDUMMY
     *              ,IGRP,LC,NC,LB,NB,NF1,NF2,NFS,LFS,IRT,IRP
     *              ,LA,HR
      INTEGER*2 IGRP,LC,NC,LB,NB,NF1,NF2,NFS,LFS,IRT,IRP,IDUMMY
      CHARACTER LA*1,HR*1
      REAL      DIST,PSI,THETA,RVDW,CHARGE
C ---
      COMMON/COM_OLD/ NA,IRES,ICHAIN,ITYPE
     *              ,XA,YA,ZA,OCC,BETA,SURF,CTEMP
     *              ,ATOM,ALT,RES1,CYS,RES3
      INTEGER*2 NA,IRES,ICHAIN,ITYPE
      REAL      X,Y,Z,OCC,BETA,SURF,CTEMP
      CHARACTER ATOM*4,RES1*1,RES3*3,CYS*1
C ---
      INTEGER IOUT,MDOC,IERR,IEND
      CHARACTER CLC*1,CLB*1,CLF*1,LINE*256
      DATA PI180/0.0174533/,TWOPI/6.2831852/
C --------------------------------------------------------------
      IERR=0
      WRITE(CLC,10) LC
      WRITE(CLB,10) LB
      WRITE(CLF,10) LFS
 10   FORMAT(I1)
      IF(CLC.EQ.'0') CLC=' '
      IF(CLB.EQ.'0') CLB=' '
      IF(CLF.EQ.'0') CLF=' '
C ---
      IF(IEND.EQ.0) THEN
        IF(THETA.GT.TWOPI) THETA=THETA-TWOPI
        IF(THETA.LT. 0.0 ) THETA=THETA+TWOPI
        THETA=THETA/PI180
        IF(PSI.GT.TWOPI) PSI=PSI-TWOPI
        IF(PSI.LT. 0.0 ) PSI=PSI+TWOPI
        PSI  =PSI/PI180
        WRITE(IOUT,500,ERR=510)
     *  NA,ATOM,IRES,RES1,RES3,IGRP,HR,IDUMMY,CLC,NC,
     *  NB,CLB,NF1,NF2,NFS,CLF,IRT,IRP,LA,DIST,THETA,PSI,RVDW,CHARGE
C
C               I     A IR    R1    R3 IG HR ID LC NC NB LB F1 F2 FS
 500    FORMAT(I5,1X,A4,I4,1X,A1,1X,A3,I3,A1,I1,A1,I1,I4,A1,I4,I4,I4
     *        ,A1,I1,I1,A1,F7.3,F7.3,F7.3,F5.2,F5.2)
C              LF RT RP LA  D   TET  PSI  RVDW CHARGE
C
C ---
C        IF(MDOC.GT.0.AND.MDOC.LT.99) THEN

          WRITE(LINE,500)
     *    NA,ATOM,IRES,RES1,RES3,IGRP,HR,IDUMMY,CLC,NC,
     *  NB,CLB,NF1,NF2,NFS,CLF,IRT,IRP,LA,DIST,THETA,PSI,RVDW,CHARGE
          CALL MSGDOC(MDOC,LINE)
C        ENDIF
      ELSE
        END FILE IOUT
        CLOSE(IOUT)
      ENDIF
      RETURN
 510  CONTINUE 
      CALL MSGERR(MDOC,' ERR: WRITE OF FILE /.STR/')
      CLOSE(IOUT)
      IERR=1
      RETURN
      END


      SUBROUTINE RDSTR(MDOC,IN,IEND,IERR)
C ---
      COMMON/COM_STR/ DIST,THETA,PSI,RVDW,CHARGE,IDUMMY
     *              ,IGRP,LC,NC,LB,NB,NF1,NF2,NFS,LFS,IRT,IRP
     *              ,LA,HR
      INTEGER*2 IGRP,LC,NC,LB,NB,NF1,NF2,NFS,LFS,IRT,IRP,IDUMMY
      CHARACTER LA*1,HR*1
      REAL      DIST,PSI,THETA,RVDW,CHARGE
C ---
      COMMON/COM_OLD/ NA,IRES,ICHAIN,ITYPE
     *              ,XA,YA,ZA,OCC,BETA,SURF,CTEMP
     *              ,ATOM,ALT,RES1,CYS,RES3
      INTEGER*2 NA,IRES,ICHAIN,ITYPE
      REAL      X,Y,Z,OCC,BETA,SURF,CTEMP
      CHARACTER ATOM*4,RES1*1,RES3*3,CYS*1
C ---
      INTEGER IN,MDOC,IERR,IEND
C ---
      CHARACTER CLC*1,CLB*1,CLF*1,LINE*256
      DATA PI180/0.0174533/
C --------------------------------------------------------------
      IEND=0
      IERR=0
C ---
      READ(IN,501,ERR=510,END=520)
     *  NA,ATOM,IRES,RES1,RES3,IGRP,HR,IDUMMY,LC,NC,
     *  NB,LB,NF1,NF2,NFS,LFS,IRT,IRP,LA,DIST,THETA,PSI,RVDW,CHARGE
C
C             I     A IR    R1    R3 IG HR ID LC NC NB LB F1 F2 FS
 501  FORMAT(I5,1X,A4,I4,1X,A1,1X,A3,I3,A1,I1,I1,I1,I4,I1,I4,I4,I4
     *        ,I1,I1,I1,A1,F7.3,F7.3,F7.3,F5.2,F5.2)
C              LF RT RP LA  D   TET  PSI  RVDW CHARGE
C
C ---
      WRITE(CLC,10) LC
      WRITE(CLB,10) LB
      WRITE(CLF,10) LFS
 10   FORMAT(I1)
      IF(CLC.EQ.'0') CLC=' '
      IF(CLB.EQ.'0') CLB=' '
      IF(CLF.EQ.'0') CLF=' '
      WRITE(LINE,500)
     *    NA,ATOM,IRES,RES1,RES3,IGRP,HR,IDUMMY,CLC,NC,
     *  NB,CLB,NF1,NF2,NFS,CLF,IRT,IRP,LA,DIST,THETA,PSI,RVDW,CHARGE
 500  FORMAT(I5,1X,A4,I4,1X,A1,1X,A3,I3,A1,I1,A1,I1,I4,A1,I4,I4,I4
     *        ,A1,I1,I1,A1,F7.3,F7.3,F7.3,F5.2,F5.2)
      CALL MSGDOC(MDOC,LINE)
      THETA=THETA*PI180
      PSI  =PSI  *PI180
      RETURN
 510  CONTINUE 
      CALL MSGERR(MDOC,' ERR: READ OF FILE /.STR/')
      CLOSE(IN)
      IERR=1
      RETURN
 520  CONTINUE 
      CLOSE(IN)
      IEND=1
      RETURN
      END


C ******
      SUBROUTINE WBLOCK(MT,IBLOCK,NW,IERR)
C
C -P- WBLOCK - writes (unformatted) data block to file 
C
C     input : NW - number of wolds(4-bytes) that they will be written to MT
C                  from IBLOCK
C             IBLOCK - integer array
C     output : IERR - 0  normal end
C                     1  error
CMS      : IBLOCK
      PARAMETER ( NWMAX= 512 )
      INTEGER*4 MT,NW,IBLOCK(*),IERR
C ******
C ---------------------------------------------------------------------
      MDOC=0
      IERR=0
      IF(MT.EQ.0) RETURN
      IF(NW.LE.0) THEN
        CALL MSGERR(MDOC,' ERR IN WBLOCK: WRONG NUMBER WORDS')
        IERR=1
        RETURN
      ENDIF
      NW0=0
      NW1=1
10    NW2=NW0+NWMAX
      IF(NW2.GT.NW) THEN
        NWW=NW-NW0
      ELSE
        NWW=NWMAX
      ENDIF
      NW0=NW0+NWW
C N    CALL WFILE(MT,0,IBLOCK(NW1),-1,NWW)
C N    IF(ERRCODE.NE.0) GO TO 9
C 
      II0=NW1-1
      WRITE(MT,ERR=9) (IBLOCK(II0+II),II=1,NWW)
C
      NW1=NW1+NWW
      IF(NW1.LE.NW) GO TO 10
      RETURN
C -------------------------
    9 CONTINUE
      CALL MSGERR(MDOC,' ERR: WRITE TO OUTPUT-FILE')
      IERR=1
      RETURN
      END

C ******
      SUBROUTINE WBLOCK_I2(MT,IBLOCK,NW_R,IERR)
C
C -P- WBLOCK_I2 - writes (unformatted) data block(integer*2) to file 
C
C     input : NW_R - number of wolds(4-bytes) that they will be written to MT
C                  from IBLOCK
C             IBLOCK - integer*2 array
C     output : IERR - 0  normal end
C                     1  error
CMS      : IBLOCK
      PARAMETER ( NWMAX_R = 512 )
      INTEGER*4 MT,NW,IERR
      INTEGER*2 IBLOCK(*)
C ******
C ---------------------------------------------------------------------
      MDOC     = 0
      IERR     = 0
      NW       = NW_R   *2
      NWMAX    = NWMAX_R*2
      IF(MT.EQ.0) RETURN
      IF(NW.LE.0) THEN
        CALL MSGERR(MDOC,' ERR IN WBLOCK_I2: WRONG NUMBER WORDS')
        IERR=1
        RETURN
      ENDIF

      NW0 = 0
      NW1 = 1
10    NW2 = NW0 + NWMAX
      IF(NW2.GT.NW) THEN
        NWW = NW-NW0
      ELSE
        NWW = NWMAX
      ENDIF
      NW0 = NW0+NWW
C N    CALL WFILE(MT,0,IBLOCK(NW1),-1,NWW)
C N    IF(ERRCODE.NE.0) GO TO 9
C 
      II0 = NW1-1
      WRITE(MT,ERR=9) (IBLOCK(II0+II),II=1,NWW)
C
      NW1 = NW1+NWW
      IF(NW1.LE.NW) GO TO 10
      RETURN
C -------------------------
    9 CONTINUE
      CALL MSGERR(MDOC,' ERR: WRITE TO OUTPUT-FILE / in wblock_i2 /')
      IERR=1
      RETURN
      END


C ******
      SUBROUTINE RBLOCK(MT,IBLOCK,NR,IERR)
C
C -P- RBLOCK - reads (unformatted) data block from file  
C
C     input  : NR - number of words(4-bytes) that will be read from MT 
C                   to array IBLOCK
C     output : IBLOCK - integer*4 array
C              IERR - 0  normal end
C                     1  error
CMS      : IBLOCK
      PARAMETER ( NRMAX= 512 )
      INTEGER*4 MT,NR,IBLOCK(*),IERR
C ******
C -------------------------------------------------------------------
      MDOC=0
      IERR=0
      NR0=0
      NR1=1
10    NR2=NR0+NRMAX
      IF(NR2.GT.NR) THEN
        NRR=NR-NR0
      ELSE
        NRR=NRMAX
      ENDIF
      NR0=NR0+NRR
C N    CALL RFILE(MT,0,IBLOCK(NR1),-1,NRR)
C N    IF(ERRCODE.NE.0) GO TO 9
C 
      II0=NR1-1
      READ(MT,ERR=9) (IBLOCK(II0+II),II=1,NRR)
C 
      NR1=NR1+NRR
      IF(NR1.LE.NR) GO TO 10
      RETURN
C ----------------
    9 CONTINUE
      CALL MSGERR(MDOC,' ERR IN RBLOCK: READ INPUT-FILE')
      IERR=1
      RETURN
      END


C ******
      SUBROUTINE RBLOCK_MEM(MT,IBLOCK,NR,IPOOL,IERR)
C
C -P- RBLOCK - reads (unformatted) data block from file  
C
C     input  : NR - number of words(4-bytes) that will be read from MT 
C                   to array IBLOCK
C     output : IBLOCK - integer*4 array
C              IERR - 0  normal end
C                     1  error
CMS      : IBLOCK
      PARAMETER ( NRMAX= 512 )
      INTEGER*4 MT,NR,IBLOCK(*),IERR
C ******
      INTEGER*4         IPOOL(*)
      COMMON/COM_DPOOL/ IPOOL_MAX,IPOOL_CURR
C -------------------------------------------------------------------
      MDOC=0
      IERR=0
      NR0=0
      NR1=1
10    NR2=NR0+NRMAX
      IF(NR2.GT.NR) THEN
        NRR=NR-NR0
      ELSE
        NRR=NRMAX
      ENDIF
      NR0=NR0+NRR
C N    CALL RFILE(MT,0,IBLOCK(NR1),-1,NRR)
C N    IF(ERRCODE.NE.0) GO TO 9
C 
      II0=NR1-1
      IF(IPOOL_MAX.GT.0) THEN
        IF((IPOOL_CURR + NRR).GT.IPOOL_MAX) GO TO 8  
        DO II=1,NRR
          IBLOCK(II0+II) = IPOOL(IPOOL_CURR + II)
        ENDDO
        IPOOL_CURR = IPOOL_CURR + NRR
      ELSE
        READ(MT,ERR=9) (IBLOCK(II0+II),II=1,NRR)
      ENDIF
C 
      NR1=NR1+NRR
      IF(NR1.LE.NR) GO TO 10
      RETURN
C ----------------
    9 CONTINUE
      CALL MSGERR(MDOC,' ERR IN RBLOCK_MEM: READ INPUT-FILE')
      IERR=1
      RETURN
    8 CONTINUE
      CALL MSGERR(MDOC,' ERR IN RBLOCK_MEM: out of range')
      IERR=1
      RETURN
      END



C ******
      SUBROUTINE ORFILE(MDOC,MT,FNAME,TYPE,NSYM,ISYM,NSMAX,IERR)

C     *          ,A,B,C,AL,BE,GA,F1,F2,F3,F4,NX,NY,NZ,IZN,IZM,TTT)
C -P- ORFILE - 1.open file FNAME 
C -P-          2.reads title of file,return file parameters,fill /COMRDF/.
C                copy file_parameters to /COMRDF/.
C
C     ENTRY OPFILE(MDOC,MT,FNAME,TYPE,NSYM,ISYM,NSMAX,IERR)
C
C -P- OPFILE - 1.don't open file, rewind file 
C -P-          2.reads title of file,return file parameters,fill /COMRDF/.
C ----------
C     CHARACTER / TTT*80,TYPE*4,FNAME*(*) /
C ----------
C     input :  MT     - unit of file
C              FNAME  - file name or " "./if " " - name will be taken
C                                                  from terminal  /
C              MDOC   - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       >= 99 - not write  
C              TYPE   = '    '  don't check type of file
C                     = 'F   ' or 'FS  ' or 'COEF' or 'ABCD'
C                       'ALMN' or 'RI  ' - check type of file
C                       return if file has different type
C                     = 'FF  ' means both 'F   ' and 'FS  '.  
C     output : MT =0  - signal of error.
C              TYPE   - type of file
C              FNAME  - name of file
C              TTT    - title; for file type 'COEF' :
C                                          TTT(1:4)='PATT'  for Patterson
C                                          TTT(1:4)='FOUR'  for Fourie
C              A,B,C  -                   init cell
C              AL,BE,GA  / in radian /    parameters
C
C              for file type 'RI  ' :
C                NX,NY,NZ  - number point of grid for axis x,y,z
C                IZN,IZM   - numbers of first and last z-section.
C              else
C                F1,F2     - scale,beta
C                F3,F4     - resmin,resmax
C ---
      COMMON/COMRDF/ A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
     *              ,RN_RD,RX_RD,CF_RD,TF_RD
     *              ,NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
     *              ,NS_RD,IS_RD,IER_RD,IEN_RD
     *              ,TP_RD,T1_RD,T2_RD,TL_RD,DT_RD
     *              ,CD_RD,SG_RD,PT_RD,PD_RD
      REAL A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
      REAL RN_RD,RX_RD,CF_RD,TF_RD
      INTEGER*4 NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
      INTEGER*4 NS_RD,IS_RD,IER_RD,IEN_RD
      CHARACTER TP_RD*4,T1_RD*4,T2_RD*4,TL_RD*80,DT_RD*20     
      CHARACTER CD_RD*4,SG_RD*24,PT_RD*40,PD_RD*9
C ---
      INTEGER*4 MT,MDOC,NSYM
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER FNAME*(*)
      CHARACTER TYPE*4
C ******
C ---
      REAL A,B,C,AL,BE,GA,F1,F2,F3,F4
      CHARACTER TTT*80,TTT2*80,NAME*256,FLINE*256 
      INTEGER*4 NX,NY,NZ,IZN,IZM
      CHARACTER CH1*1,TPSYMB*1,SYMOP*60,WAVE*5,TEMPER*5,CHAR1*1
      CHARACTER CH15*15,CH4*4
      INTEGER*4 NW40,ILINE(20)
      CHARACTER LINE*80,TYP*4,STR*80,PATH*1,EXT*3,CDATE*20,MSG*1
      EQUIVALENCE (ILINE(1),LINE)
      DATA NW40/20/
C ----------------------------------------------------------------------
      IERR  = 0
      PI    = 4.0*ATAN(1.0)
      PI180 = PI/180.
C ---
      DO I=1,80
        TL_RD(I:I)= ' '
        TTT(I:I)  = ' '
        TTT2(I:I) = ' '
      ENDDO
      TL_RD(1:9) = '?   ?   ?'
      DO I=1,40
        PT_RD(I:I) = ' '
      ENDDO
      PT_RD(1:13) = 'XXXXXXXX    ?'
      CD_RD  = 'XXXX'
      T1_RD  = '?   '
      T2_RD  = '?   '
      PD_RD  = 'XX-XXX-XX'
      TEMPER = '?    '
      WAVE   = '?    '
C ---
      MSG='N'
      CH1=FNAME(1:1)
      CALL CHKSMB(CH1,TPSYMB)
      CALL LENSTR_BL(FNAME,NLN)
      IF(NLN.LE.0.OR.FNAME(1:1).EQ.' '.OR.FNAME(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERR: WRONG FILE_NAME')
        IERR=1
        RETURN
      ENDIF

      IF(MT.LE.0.OR.MT.GT.99) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE: UNIT = 0')
        IERR=1      
        IER_RD=1
        RETURN
      ENDIF
C --
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.0.AND.FNAME(1:1).NE.','.AND.FNAME(1:1).NE.' ') THEN
        NAME=FNAME(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 800
          ENDIF 
        ENDDO
 800    CONTINUE
        FLINE = NAME
        CALL LENSTR_BL(FLINE,LEN)
        IF(LEN.GT.4.AND.FLINE(LEN-3:LEN).EQ.'.dat') THEN
          NAME=FLINE(1:LEN-4)
        ENDIF
      ELSE
        NAME=FNAME
      ENDIF
C -------

      PATH = ' '
C?    EXT  = ' '
      EXT  = 'dat'
      MD   = MDOC

      CALL OPENUR(MT,MD,PATH,NAME,EXT,IERR)

      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE')
        IERR=1      
        IER_RD=1
        RETURN
      ENDIF
      GO TO 1010
C ======================================================================
      ENTRY OPFILE(MDOC,MT,FNAME,TYPE,NSYM,ISYM,NSMAX,IERR)
C ======================================================================
      REWIND MT
      IERR  = 0
      PI    = 4.0*ATAN(1.0)
      PI180 = PI/180.
C ---
      DO I=1,80
        TL_RD(I:I)= ' '
        TTT(I:I)  = ' '
        TTT2(I:I) = ' '
      ENDDO
      TL_RD(1:9) = '?   ?   ?'
      DO I=1,40
        PT_RD(I:I) = ' '
      ENDDO
      PT_RD(1:13) = 'XXXXXXXX    ?'
      CD_RD  = 'XXXX'
      T1_RD  = '?   '
      T2_RD  = '?   '
      PD_RD  = 'XX-XXX-XX'
      TEMPER = '?    '
      WAVE   = '?    '
      MSG    = 'N'

 1010 CONTINUE
      CALL RBLOCK(MT,ILINE,NW40,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: READ TITLE1 OF FILE')
        CLOSE(MT)        
        IERR=2      
        IER_RD=2
        RETURN
      ENDIF
      CDATE=LINE(60:79)
      WRITE(STR,20) LINE(2:5),LINE(7:9),LINE(11:58)
   20 FORMAT('Type:',A,'; OS:',A,'; CELL:',A)
      CALL MSGDOC(MDOC,STR)
      READ(LINE,90) TYP,A,B,C,AL,BE,GA
   90 FORMAT(1X,A4,5X,6F8.3)
      IF(TYPE.NE.'    ') THEN
        IF(TYPE.EQ.'FF  ')THEN
          IF(TYP.NE.'F   '.AND.TYP.NE.'FS  ') THEN
            CALL MSGERR(MDOC,' ERR: WRONG FILE TYPE ')
            CLOSE(MT)
            IERR=2        
            IER_RD=2
            RETURN 
          ENDIF
        ELSE IF(TYPE.NE.TYP) THEN
          CALL MSGERR(MDOC,' ERR: WRONG FILE TYPE ')
          CLOSE(MT)
          IERR=2    
          IER_RD=2
          RETURN
        ENDIF
      ENDIF
      TYPE  = TYP
      AL    = AL*PI180
      BE    = BE*PI180
      GA    = GA*PI180
      TP_RD = TYP
      A_RD  = A
      B_RD  = B
      C_RD  = C
      AL_RD = AL
      BE_RD = BE
      GA_RD = GA
      DT_RD = LINE(60:79)

 2000 CONTINUE

      CALL RBLOCK(MT,ILINE,NW40,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: READ TITLE2 OF FILE')
        CLOSE(MT)
        IERR=2    
        IER_RD=2
        RETURN
      ENDIF


      IF(LINE(1:4).EQ.'PDB:') THEN
C
C       FORMAT('PDB:',A40,1X,A9)
C       TL_RD(9:48),PD_RD
C              
        READ(LINE,'(4X,A40,1X,A9,A5,A5)') TTT2(1:40),PD_RD,WAVE,TEMPER
        

        GO TO 2000
      ELSE IF(LINE(1:4).EQ.'NSYM') THEN
C 
C       FORMAT('NSYM',1X,I5) NSYM
C
        READ(LINE,'(4X,1X,I5)') NSYM

        IF(NSYM.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ TITLE: NSYM=0')
          CLOSE(MT)
          IERR=2        
          IER_RD=2
          RETURN
        ENDIF
        IF(NSYM.GT.NSMAX) THEN
          WRITE(STR,'('' ERR: READ TITLE: NSYM >'',I5)') NSMAX
          CALL MSGERR(MDOC,STR) 
          CLOSE(MT)
          IERR=2      
          IER_RD=2
          RETURN
        ENDIF
        DO ISS=1,NSYM
          CALL RBLOCK(MT,ILINE,NW40,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,' ERR: READ SYM_TITLE OF FILE')
            CLOSE(MT)
            IERR=2        
            IER_RD=2
            RETURN
          ENDIF
          
C
C
          READ(LINE,'(4X,1X,A)') SYMOP
          CALL LENSTR_BL(SYMOP,LEN)
          IF(LEN.LE.4) THEN
            WRITE(STR,'('' ERR: READ TITLE: SYM_OP'')') 
            CALL MSGERR(MDOC,STR) 
            CLOSE(MT)
            IERR=2      
            IER_RD=2
            RETURN
          ENDIF  
          NS=ISS
          CALL SYMFR2_BL(MDOC,SYMOP,NS,NSYMR,ISYM,NSMAX,IERR)
C
        ENDDO
        GO TO 2000    
      ELSE IF(LINE(1:3).EQ.'SYM') THEN
        GO TO 2000
      ENDIF

      IF(TYP.EQ.'RI  ') THEN

        CHAR1 = LINE(46:46)
        CALL CHKSMB(CHAR1,TPSYMB)
        IF(TPSYMB.NE.'D') THEN
          LINE(44:46)='   '
        ELSE
          CHAR1 = LINE(45:45)
          CALL CHKSMB(CHAR1,TPSYMB)
          IF(TPSYMB.NE.'D') THEN
            LINE(44:45)='  '
          ELSE
            CHAR1 = LINE(44:44)
            CALL CHKSMB(CHAR1,TPSYMB)
            IF(TPSYMB.NE.'D') LINE(44:44)=' '
          ENDIF
        ENDIF
        CHAR1 = LINE(48:48)
        CALL CHKSMB(CHAR1,TPSYMB)
        IF(TPSYMB.NE.'D') LINE(48:48)=' '
        READ(LINE,100,ERR=999) TTT(1:48),NX,NY,NZ,IZN,IZM
C ---
        READ(LINE,'(28X,A4,A15,I1)',ERR=999) 
     *  CD_RD,CH15,IS_RD
        SG_RD  = CH15(1:11)
        CH4    = CH15(15:15)//CH15(12:14)         
        READ(CH4,'(I4)') NS_RD
C ---
C        IF(NS_RD.LE.0.OR.NS_RD.GT.230) NS_RD=1
        IF(NS_RD.LE.0.OR.NS_RD.GT.9999) NS_RD=1
        IF(IS_RD.LE.0.OR.IS_RD.GT.9) IS_RD=1

c        DO I=1,80
c          TTT(I:I)=' '
c        ENDDO
  100   FORMAT(A48,12X,5I4)

        CALL LENSTR_BL(SG_RD,L)
        IF(L.GT.11) L=11
        WRITE(STR,30) CD_RD,SG_RD(1:L),NS_RD,IS_RD,CDATE
   30   FORMAT('CodePDB:',A4,' Sp.Gr:',A11,' No Sp.Gr:',I4
     *           ,'Sett:',I1,' Date:',A)
        CALL MSGDOC(MDOC,STR)

C        WRITE(STR,50) LINE(1:4),LINE(5:8),LINE(9:28)
        WRITE(STR,50) LINE(1:4),LINE(5:8),TTT2(1:40)
   50   FORMAT('Code1:',A4,'; Code2:',A4,'; Title:',A40)
        CALL MSGDOC(MDOC,STR)
        WRITE(STR,60) NX,NY,NZ,IZN,IZM
   60   FORMAT('Grid:  NX=',I5,' NY=',I5,' NZ=',I5,' IZmin=',I5,
     *    ' IZmax=',I5)
        CALL MSGDOC(MDOC,STR)

        F1=0.0
        F2=0.0
        F3=0.0
        F4=0.0
      ELSE
        CHAR1 = LINE(46:46)
        CALL CHKSMB(CHAR1,TPSYMB)
        IF(TPSYMB.NE.'D') THEN
          LINE(44:46)='   '
        ELSE
          CHAR1 = LINE(45:45)
          CALL CHKSMB(CHAR1,TPSYMB)
          IF(TPSYMB.NE.'D') THEN
            LINE(44:45)='  '
          ELSE
            CHAR1 = LINE(44:44)
            CALL CHKSMB(CHAR1,TPSYMB)
            IF(TPSYMB.NE.'D') LINE(44:44)=' '
          ENDIF
        ENDIF
        CHAR1 = LINE(48:48)
        CALL CHKSMB(CHAR1,TPSYMB)
        IF(TPSYMB.NE.'D') LINE(48:48)=' '

        READ(LINE,110,ERR=999) TTT(1:48),F1,F2,F3,F4
C ---
        READ(LINE,'(28X,A4,A15,I1)',ERR=999) 
     *  CD_RD,CH15,IS_RD
        SG_RD  = CH15(1:11)
        CH4    = CH15(15:15)//CH15(12:14)         
        READ(CH4,'(I4)') NS_RD
C ---
c        IF(NS_RD.LE.0.OR.NS_RD.GT.230) NS_RD=1
        IF(NS_RD.LE.0.OR.NS_RD.GT.9999) NS_RD=1
        IF(IS_RD.LE.0.OR.IS_RD.GT.9)   IS_RD=1
c        DO I=1,80
c          TTT(I:I)=' '
c        ENDDO
  110   FORMAT(A48,2F8.2,2F8.3)


        CALL LENSTR_BL(SG_RD,L)
        IF(L.GT.11) L=11
            WRITE(STR,30) CD_RD,SG_RD(1:L),NS_RD,IS_RD,CDATE
            CALL MSGDOC(MDOC,STR)


C            WRITE(STR,50) LINE(1:4),LINE(5:8),LINE(9:28)
            WRITE(STR,50) LINE(1:4),LINE(5:8),TTT2(1:40)
            CALL MSGDOC(MDOC,STR)
            IF(TYP.EQ.'ALMN'.OR.TYP.EQ.'ALMS') THEN
              WRITE(STR,81) F1,F2,F3,F4
              CALL MSGDOC(MDOC,STR)
   81         FORMAT('Rad:',F8.2,' Zsymm:',F8.2,' RESmin:',F8.3,
     *               ' RESmax:',F8.3)
            ELSE
              WRITE(STR,80) F1,F2,F3,F4
              CALL MSGDOC(MDOC,STR)
   80         FORMAT('Scale:',F8.2,' Bfactor:',F8.2,' RESmin:',F8.3,
     *               ' RESmax:',F8.3)
            ENDIF


        NX=0
        NY=0
        NZ=0
        IZN=0
        IZM=0
      ENDIF


      PT_RD(5:24)=TTT(9:28)
      PT_RD(1:4) =CD_RD
      DO II=25,40
        PT_RD(II:II)=' '
      ENDDO

      T1_RD=TTT(1:4)
      T2_RD=TTT(5:8)

      TL_RD(1:4)  = T1_RD
      TL_RD(5:8)  = T2_RD
      TL_RD(9:48) = TTT2(1:40)
      TL_RD(69:73)= WAVE
      TL_RD(74:78)= TEMPER

      WRITE(STR,700)
     * PT_RD(5:12),PT_RD(13:24),PD_RD,TL_RD(69:73),TL_RD(74:78)
 700  FORMAT('DB_code:',A,';key:',A,';Date:',A,
     * ';Lambda:',A,';Temp:',A) 
      CALL MSGDOC(MDOC,STR)

      RN_RD=F3
      RX_RD=F4
      CF_RD=F1
      TF_RD=F2
      NX_RD=NX
      NY_RD=NY
      NZ_RD=NZ
      IN_RD=IZN
      IM_RD=IZM
      IER_RD=0
      IEN_RD=-1
      RETURN

 999  CONTINUE
      CALL MSGERR(MDOC,' ERR: problem with title2 of input file')
      CLOSE(MT)        
      IERR=3      
      IER_RD=3
      RETURN
      END

C ******
      SUBROUTINE OWFILE(MDOC,MT,FNAME,TYP,NSYM,ISYM,NSMAX,IERR)

C     *          ,A,B,C,AL,BE,GA,F1,F2,F3,F4,NX,NY,NZ,IZN,IZM,TTT)
C
C -P- OWFILE - 1.open file FNAME  
C -P-            2.writes title to file, parameters from common /COMRDF/
C ---------
C   CHARACTER TYPE*4,FNAME*(*)
C ---------
C     input :  MT     - unit of file. If MT=0 - return without error signal.
C              FNAME  - file name or " ".   /if " " - name will be taken
C                                                      from terminal  /
C              MDOC   - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       =< 99 - not write  
C              IPRINT = 1 print all information
C                     = 0 don't print
C              TYP    = type of file.
C                       'F   ' or 'FS  ' or 'COEF' or 'ABCD'
C                       'ALMN' or 'RI  '
C
C      output :  FNAME     - name of file
C                MT = 0    - signal of error.
C ---
C ---
      COMMON/COMWRF/ A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
     *              ,RN_WR,RX_WR,CF_WR,TF_WR
     *              ,NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
     *              ,NS_WR,IS_WR,IER_WR,IEN_WR
     *              ,TP_WR,T1_WR,T2_WR,TL_WR,DT_WR
     *              ,CD_WR,SG_WR,PT_WR,PD_WR
      REAL A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
      REAL RN_WR,RX_WR,CF_WR,TF_WR
      INTEGER*4 NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
      INTEGER*4 NS_WR,IS_WR,IER_WR,IEN_WR
      CHARACTER TP_WR*4,T1_WR*4,T2_WR*4,TL_WR*80,DT_WR*20     
      CHARACTER CD_WR*4,SG_WR*24,PT_WR*40,PD_WR*9
C ---
      INTEGER*4 MT,MDOC,NSYM,NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER FNAME*(*)
      CHARACTER TTT*80
      CHARACTER TTT2*80
      CHARACTER TYP*4
C ******
C -------
      REAL A,B,C,AL,BE,GA,F1,F2,F3,F4
      INTEGER*4 NX,NY,NZ,IZN,IZM
      CHARACTER CH1*1,TPSYMB*1,NAME*256,FLINE*256
      INTEGER*4 NW40,ILINE(20)
      INTEGER*4 IH(7)
      CHARACTER STR*80,CDATE*20,SYMOP*60,WAVE*5,TEMPER*5
      CHARACTER LINE*80,CH2*2,CH3*3,PATH*1,EXT*3,CH15*15,CH4*4
      EQUIVALENCE (ILINE(1),LINE)
      DATA NW40/20/
C ----------------------------------------------------------------------
      IF(MT.EQ.0) RETURN
      IERR=0
      CALL LENSTR_BL(FNAME,NLN)
      IF(NLN.LE.0.OR.FNAME(1:1).EQ.','.OR.FNAME(1:1).EQ.' ') THEN
        CALL MSGERR(MDOC,' ERR: WRONG FILE_NAME')
        IERR=1
        IER_WR=1
        RETURN
      ENDIF
C -----------        
      DO I=1,80
        TTT(I:I)  = ' '
        TTT2(I:I) = ' '
      ENDDO
      TEMPER='?    '
      WAVE  ='?    '
C ------------     
C --
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.0.AND.FNAME(1:1).NE.','.AND.FNAME(1:1).NE.' ') THEN
        NAME=FNAME(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 800
          ENDIF 
        ENDDO
 800    CONTINUE
        FLINE = NAME
        CALL LENSTR_BL(FLINE,LEN)
        IF(LEN.GT.4.AND.FLINE(LEN-3:LEN).EQ.'.dat') THEN
          NAME=FLINE(1:LEN-4)
        ENDIF
      ELSE
        NAME=FNAME
      ENDIF
C -------
      PATH = ' '
C?    EXT  = ' '
      EXT  = 'dat'
      MD   = MDOC
      CALL OPENUW(MT,MD,PATH,NAME,EXT,IERR)

      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE')
        IERR=1
        IER_WR=1
        RETURN
      ENDIF

      PI    = 4.0*ATAN(1.0)
      PI180 = PI/180.0
      ALW   = AL_WR/PI180
      BEW   = BE_WR/PI180
      GAW   = GA_WR/PI180
      CALL CLOCK(IH)
      TP_WR = TYP      
      IMODE = 0
      CALL CHECK_LINE(IMODE,TP_WR)
      IF(A_WR.LT.-999.999) A_WR=-999.999
      IF(A_WR.GT.9999.999) A_WR=9999.999
      IF(B_WR.LT.-999.999) B_WR=-999.999
      IF(B_WR.GT.9999.999) B_WR=9999.999
      IF(C_WR.LT.-999.999) C_WR=-999.999
      IF(C_WR.GT.9999.999) C_WR=9999.999
      IF(ALW.LT.-999.999) ALW=-999.999
      IF(ALW.GT.9999.999) ALW=9999.999
      IF(BEW.LT.-999.999) BEW=-999.999
      IF(BEW.GT.9999.999) BEW=9999.999
      IF(GAW.LT.-999.999) GAW=-999.999
      IF(GAW.GT.9999.999) GAW=9999.999
      IF(IH(2).LT.0.OR.IH(2).GT.99) IH(2)=0
      IF(IH(3).LT.0.OR.IH(3).GT.99) IH(3)=0
      IF(IH(4).LT.0.OR.IH(4).GT.99) IH(4)=0
      IF(IH(5).LT.0.OR.IH(5).GT.99) IH(5)=0
      IF(IH(6).LT.0.OR.IH(6).GT.99) IH(6)=0
      IF(IH(7).LT.0.OR.IH(7).GT.9999) IH(7)=0
       
      WRITE(LINE,10) TP_WR,A_WR,B_WR,C_WR,ALW,BEW,GAW
     * ,IH(4),IH(3),IH(2),IH(5),IH(6),IH(7)
   10   FORMAT(' ',A4,'     ',6F8.3,';',I2,'.',I2,'.',I2,'/'
     *   ,I2,'.',I2,'.',I4)
      CDATE = LINE(60:79)
      DT_WR = CDATE
      CALL GETNOS(CH3)
      LINE(7:9)=CH3

      CALL WBLOCK(MT,ILINE,NW40,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE TITLE OF FILE')
        CLOSE(MT)
        IER_WR = 2
        IERR   = 2
        RETURN
      ENDIF

      WRITE(STR,20) LINE(2:5),LINE(7:9),LINE(11:58)
   20 FORMAT('Type:',A,'; OS:',A,'; CELL:',A)
      CALL MSGDOC(MDOC,STR)

C ---------
      IMODE=0
      T1_WR      = TL_WR(1:4)
      T2_WR      = TL_WR(5:8)
      TTT(1:20)  = PT_WR(5:24)

      TTT2(1:40) = TL_WR(9:48)
      WAVE       = TL_WR(69:73)
      TEMPER     = TL_WR(74:78)

C     READ(LINE,'(4X,A40,1X,A9,A5,A5)') TTT2(1:40),PD_RD,WAVE,TEMPER

      CALL CHECK_LINE(IMODE,PT_WR)
      CALL CHECK_LINE(IMODE,PD_WR)
      WRITE(LINE,'(''PDB:'',A40,1X,A9,A5,A5)') 
     *  TTT2(1:40),PD_WR,WAVE,TEMPER
      CALL WBLOCK(MT,ILINE,NW40,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE TITLE OF FILE')
        CLOSE(MT)
        IERR   = 2
        IER_WR = 2
        RETURN
      ENDIF
      CALL MSGDOC(MDOC,LINE)

C 
C     FORMAT('NSYM',1X,I5) NSYM
C
      IF(NSYM.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE TITLE: NSYM=0')
        CLOSE(MT)
        IERR=2        
        IER_WR=2
        RETURN
      ENDIF
      IF(NSYM.GT.NSMAX) THEN
        WRITE(STR,'('' ERR: WRITE TITLE: NSYM >'',I5)') NSMAX
        CALL MSGERR(MDOC,STR) 
        CLOSE(MT)
        IERR=2      
        IER_WR=2
        RETURN
      ENDIF

c      IF(NSYM.LT.0.OR.NSYM.GT.230) NSYM=1
      IF(NSYM.LT.0.OR.NSYM.GT.9999) NSYM=1
      WRITE(LINE,'(''NSYM:'',I5)') NSYM
      CALL WBLOCK(MT,ILINE,NW40,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE TITLE OF FILE')
        CLOSE(MT)
        IERR   = 2
        IER_WR = 2
        RETURN
      ENDIF
      CALL MSGDOC(MDOC,LINE)

C
C         FORMAT('ISYM',1X,A) SYMOP
C

      DO     I=1,NSYM
        LINE=' ' 
        LINE(1:3)='SYM'
        WRITE(CH3,'(I3)') I
        LINE(4:4)=CH3(3:3)
        LINE(5:5)=' '
        L=5
        DO J=1,3
          TR=REAL(ISYM(4,J,I))/REAL(ISYM(5,J,I)) 
          IF(TR.LT.0) THEN
            L=L+1
            LINE(L:L)='-'
            NEG=1
          ELSE
            NEG=0
          ENDIF
          IF(ISYM(5,J,I).EQ.0) ISYM(5,J,I)=1.0
          TR=REAL(ISYM(4,J,I))/REAL(ISYM(5,J,I)) 
          TR=ABS(TR) 
          IF(TR.GT.0.49.AND.TR.LT.0.51) THEN
            L=L+1
            LINE(L:L+2)='1/2'
            L=L+2
          ELSE IF(TR.GT.0.24.AND.TR.LT.0.26) THEN
            L=L+1
            LINE(L:L+2)='1/4'  
            L=L+2 
          ELSE IF(TR.GT.0.32.AND.TR.LT.0.34) THEN
            L=L+1
            LINE(L:L+2)='1/3' 
            L=L+2 
          ELSE IF(TR.GT.0.74.AND.TR.LT.0.76) THEN
            L=L+1
            LINE(L:L+2)='3/4'
            L=L+2 
          ELSE IF(TR.GT.0.165.AND.TR.LT.0.167) THEN
            L=L+1
            LINE(L:L+2)='1/6'  
            L=L+2 
          ELSE IF(TR.GT.0.66.AND.TR.LT.0.67) THEN
            L=L+1
            LINE(L:L+2)='2/3'
            L=L+2 
          ELSE IF(TR.GT.0.833.AND.TR.LT.0.835) THEN
            L=L+1
            LINE(L:L+2)='5/6'
            L=L+2 
          ELSE
            IF(NEG.GT.0) L=L-1
          ENDIF

          DO  K=1,3
            IDG=ISYM(K,J,I) 
            IF(IDG.LT.0) THEN
              L=L+1
              LINE(L:L)='-'
            ELSE IF(IDG.GT.0) THEN
              L=L+1
              LINE(L:L)='+'
            ENDIF  
            IDG=ABS(IDG)
            IF(IDG.GT.1.AND.IDG.LT.10) THEN
              WRITE(CH1,'(I1)') IDG
              L=L+1
              LINE(L:L)=CH1  
            ELSE IF(IDG.GT.9.AND.IDG.LT.100) THEN
              WRITE(CH2,'(I2)') IDG
              L=L+1
              LINE(L:L+1)=CH2  
              L=L+1
            ELSE IF(IDG.GT.99.AND.IDG.LT.1000) THEN
              WRITE(CH3,'(I3)') IDG
              L=L+1
              LINE(L:L+2)=CH3  
              L=L+2
            ENDIF
            IF(IDG.NE.0) THEN
              L=L+1
              IF(K.EQ.1) THEN
                LINE(L:L)='X'
              ELSE IF(K.EQ.2) THEN
                LINE(L:L)='Y'
              ELSE
                LINE(L:L)='Z'
              ENDIF
            ENDIF
          ENDDO

          LINE(L+1:L+3)=' , '
          L=L+3
        ENDDO

        IMODE=0
        CALL CHECK_LINE(IMODE,LINE)
        CALL WBLOCK(MT,ILINE,NW40,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: WRITE TITLE OF FILE')
          CLOSE(MT)
          IERR=2
          IER_WR=2
          RETURN
        ENDIF
        CALL MSGDOC(MDOC,LINE)
      ENDDO
C ---------
      DO I=1,80
        LINE(I:I)=' '
      ENDDO
      IMODE=0
      CALL CHECK_LINE(IMODE,T1_WR)
      CALL CHECK_LINE(IMODE,T2_WR)

      CALL CHECK_LINE(IMODE,TL_WR(1:20))
      CALL CHECK_LINE(IMODE,CD_WR)
      
      IF(NSYM.EQ.1) THEN
        SG_WR = 'P 1'
        NS_WR=1
        IS_WR=1
      ENDIF

      CALL CHECK_LINE(IMODE,SG_WR)
C     IF(NS_WR.LE.0.OR.NS_WR.GT.230) NS_WR=1
      IF(NS_WR.LE.0.OR.NS_WR.GT.9999) NS_WR=1
      IF(IS_WR.LE.0.OR.IS_WR.GT.9)   IS_WR=1
      IF(TYP.EQ.'RI  ') THEN
        IF(NX_WR.LE.0.OR.NX_WR.GT.9999) NX_WR=1
        IF(NY_WR.LE.0.OR.NY_WR.GT.9999) NY_WR=1
        IF(NZ_WR.LE.0.OR.NZ_WR.GT.9999) NZ_WR=1
        IF(IN_WR.LT.-999.OR.IN_WR.GT.9999) IN_WR=0
        IF(IM_WR.LT.-999.OR.IM_WR.GT.9999) IM_WR=0
        IF(NX_WR.LE.0.OR.NX_WR.GT.9999) NX_WR=1

        CALL LENSTR_BL(SG_WR,L)
        IF(L.GT.11) L=11
C ---
        CH15 = SG_WR(1:L)
        IF(L.LT.11) THEN
          DO I=L+1,11
            CH15(I:I) = ' '
          ENDDO
        ENDIF
        WRITE(CH4,'(I4)') NS_WR
        CH15(15:15) = CH4(1:1)         
        CH15(12:14) = CH4(2:4)         
C ---
        WRITE(LINE,40,ERR=999) 
     *         T1_WR,T2_WR,TTT(1:20),CD_WR,CH15
     *                ,IS_WR,NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
   40   FORMAT(A4,A4,A20,A4,A15,I1
     *  ,'            ', 5I4)
        WRITE(STR,30) CD_WR,SG_WR(1:L),NS_WR,IS_WR,DT_WR
   30   FORMAT('CodePDB:',A4,' Sp.Gr:',A11,' No Sp.Gr:',I4
     *             ,'Sett:',I1,' Date:',A)
        CALL MSGDOC(MDOC,STR)

c        WRITE(LINE,40,ERR=999) 
c     *         T1_WR,T2_WR,TTT(1:20),CD_WR,SG_WR,NS_WR
c     *                ,IS_WR,NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
c   40   FORMAT(A4,A4,A20,A4,A11,I3,' ',I1
c     *  ,'            ', 5I4)
c        WRITE(STR,30) CD_WR,SG_WR,NS_WR,IS_WR,DT_WR
c   30   FORMAT('CodePDB:',A4,' Sp.Gr:',A11,' No Sp.Gr:',I3
c     *             ,' Sett:',I1,' Date:',A)
c        CALL MSGDOC(MDOC,STR)

C        WRITE(STR,50) LINE(1:4),LINE(5:8),LINE(9:28)
        WRITE(STR,50) LINE(1:4),LINE(5:8),TTT2(1:40)
   50   FORMAT('Code1:',A4,'; Code2:',A4,'; Title:',A40)
        CALL MSGDOC(MDOC,STR)
        WRITE(STR,60) NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
   60   FORMAT('Grid:  NX=',I5,' NY=',I5,' NZ=',I5,' IZmin=',I5,
     *   ' IZmax=',I5)
        CALL MSGDOC(MDOC,STR)
      ELSE
        IF(CF_WR.GT.99999.9) CF_WR=99999.9
        IF(TF_WR.GT.99999.9) TF_WR=99999.9
        IF(CF_WR.LT.-9999.9) CF_WR=-9999.9
        IF(TF_WR.LT.-9999.9) TF_WR=-9999.9
        IF(RN_WR.LE.0.0)     RN_WR=0.01
        IF(RN_WR.GT.9999.9)  RN_WR=9999.9
        IF(RX_WR.LE.0.0)     RX_WR=0.01
        IF(RX_WR.GT.9999.9)  RX_WR=9999.9

        CALL LENSTR_BL(SG_WR,L)
        IF(L.GT.11) L=11
C ---
        CH15 = SG_WR(1:L)
        IF(L.LT.11) THEN
          DO I=L+1,11
            CH15(I:I) = ' '
          ENDDO
        ENDIF
        WRITE(CH4,'(I4)') NS_WR
        CH15(15:15) = CH4(1:1)         
        CH15(12:14) = CH4(2:4)         
C ---
        WRITE(LINE,70,ERR=999) 
     *   T1_WR,T2_WR,TTT(1:20),CD_WR,CH15
     *                ,IS_WR,CF_WR,TF_WR,RN_WR,RX_WR
   70   FORMAT(A4,A4,A20,A4,A15,I1,2F8.2,2F8.3)

        WRITE(STR,30) CD_WR,SG_WR(1:L),NS_WR,IS_WR,CDATE
        CALL MSGDOC(MDOC,STR)

C        WRITE(LINE,70,ERR=999) 
C     *   T1_WR,T2_WR,TTT(1:20),CD_WR,SG_WR,NS_WR
C     *                ,IS_WR,CF_WR,TF_WR,RN_WR,RX_WR
C   70   FORMAT(A4,A4,A20,A4,A11,I3,' ',I1,2F8.2,2F8.3)
C        WRITE(STR,30) CD_WR,SG_WR,NS_WR,IS_WR,CDATE
C        CALL MSGDOC(MDOC,STR)

C        WRITE(STR,50) LINE(1:4),LINE(5:8),LINE(9:28)
        WRITE(STR,50) LINE(1:4),LINE(5:8),TTT2(1:40)
        CALL MSGDOC(MDOC,STR)
        IF(TYP.EQ.'ALMN'.OR.TYP.EQ.'ALMS') THEN
          WRITE(STR,81) CF_WR,TF_WR,RN_WR,RX_WR
          CALL MSGDOC(MDOC,STR)
   81     FORMAT('Rad:',F8.2,' Zsymm:',F8.2,' RESmin:',F8.3,
     *               ' RESmax:',F8.3)
        ELSE
          WRITE(STR,80)  CF_WR,TF_WR,RN_WR,RX_WR
          CALL MSGDOC(MDOC,STR)
   80     FORMAT('Scale:',F8.2,' Bfactor:',F8.2,' RESmin:',F8.3,
     *               ' RESmax:',F8.3)
        ENDIF
      ENDIF
      CALL WBLOCK(MT,ILINE,NW40,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE TITLE OF FILE')
        CLOSE(MT)
        IERR=2
        IER_WR=2
        RETURN
      ENDIF
      RETURN
 999  CONTINUE
      CALL MSGERR(MDOC,' ERR: problem to write TITLE2')
      CLOSE(MT)
      IERR=3
      IER_WR=3
      RETURN
      END

      SUBROUTINE ORFILE_MEM(MDOC
     *      ,MT,FNAME,TYPE,NSYM,ISYM,NSMAX,IPOOL,IERR)

C     *          ,A,B,C,AL,BE,GA,F1,F2,F3,F4,NX,NY,NZ,IZN,IZM,TTT)
C -P- ORFILE - 1.open file FNAME 
C -P-          2.reads title of file,return file parameters,fill /COMRDF/.
C                copy file_parameters to /COMRDF/.
C
C     ENTRY OPFILE(MDOC,MT,FNAME,TYPE,NSYM,ISYM,NSMAX,IERR)
C
C -P- OPFILE - 1.don't open file, rewind file 
C -P-          2.reads title of file,return file parameters,fill /COMRDF/.
C ----------
C     CHARACTER / TTT*80,TYPE*4,FNAME*(*) /
C ----------
C     input :  MT     - unit of file
C              FNAME  - file name or " "./if " " - name will be taken
C                                                  from terminal  /
C              MDOC   - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       >= 99 - not write  
C              TYPE   = '    '  don't check type of file
C                     = 'F   ' or 'FS  ' or 'COEF' or 'ABCD'
C                       'ALMN' or 'RI  ' - check type of file
C                       return if file has different type
C                     = 'FF  ' means both 'F   ' and 'FS  '.  
C     output : MT =0  - signal of error.
C              TYPE   - type of file
C              FNAME  - name of file
C              TTT    - title; for file type 'COEF' :
C                                          TTT(1:4)='PATT'  for Patterson
C                                          TTT(1:4)='FOUR'  for Fourie
C              A,B,C  -                   init cell
C              AL,BE,GA  / in radian /    parameters
C
C              for file type 'RI  ' :
C                NX,NY,NZ  - number point of grid for axis x,y,z
C                IZN,IZM   - numbers of first and last z-section.
C              else
C                F1,F2     - scale,beta
C                F3,F4     - resmin,resmax
C ---
      COMMON/COMRDF/ A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
     *              ,RN_RD,RX_RD,CF_RD,TF_RD
     *              ,NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
     *              ,NS_RD,IS_RD,IER_RD,IEN_RD
     *              ,TP_RD,T1_RD,T2_RD,TL_RD,DT_RD
     *              ,CD_RD,SG_RD,PT_RD,PD_RD
      REAL A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
      REAL RN_RD,RX_RD,CF_RD,TF_RD
      INTEGER*4 NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
      INTEGER*4 NS_RD,IS_RD,IER_RD,IEN_RD
      CHARACTER TP_RD*4,T1_RD*4,T2_RD*4,TL_RD*80,DT_RD*20     
      CHARACTER CD_RD*4,SG_RD*24,PT_RD*40,PD_RD*9
C ---
      INTEGER*4 MT,MDOC,NSYM
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER FNAME*(*)
      CHARACTER TYPE*4
C ******
      INTEGER*4         IPOOL(*)
      COMMON/COM_DPOOL/ IPOOL_MAX,IPOOL_CURR
C ---
      REAL A,B,C,AL,BE,GA,F1,F2,F3,F4
      CHARACTER TTT*80,TTT2*80,NAME*256,FLINE*256
      INTEGER*4 NX,NY,NZ,IZN,IZM
      CHARACTER CH1*1,TPSYMB*1,SYMOP*60,WAVE*5,TEMPER*5,CHAR1*1
      CHARACTER CH15*15,CH4*4
      INTEGER*4 NW40,ILINE(20)
      CHARACTER LINE*80,TYP*4,STR*80,PATH*1,EXT*3,CDATE*20,MSG*1
      EQUIVALENCE (ILINE(1),LINE)
      DATA NW40/20/
C ----------------------------------------------------------------------
      IERR  = 0
      PI    = 4.0*ATAN(1.0)
      PI180 = PI/180.
C ---
      DO I=1,80
        TL_RD(I:I)= ' '
        TTT(I:I)  = ' '
        TTT2(I:I) = ' '
      ENDDO
      TL_RD(1:9) = '?   ?   ?'
      DO I=1,40
        PT_RD(I:I) = ' '
      ENDDO
      PT_RD(1:13) = 'XXXXXXXX    ?'
      CD_RD  = 'XXXX'
      T1_RD  = '?   '
      T2_RD  = '?   '
      PD_RD  = 'XX-XXX-XX'
      TEMPER = '?    '
      WAVE   = '?    '
C ---
      MSG='N'

      IF(IPOOL_MAX.LE.0) THEN

        CH1=FNAME(1:1)
        CALL CHKSMB(CH1,TPSYMB)
        CALL LENSTR_BL(FNAME,NLN)
        IF(NLN.LE.0.OR.FNAME(1:1).EQ.' '.OR.FNAME(1:1).EQ.',') THEN
          CALL MSGERR(MDOC,' ERR: WRONG FILE_NAME (rblock_mem)')
          IERR=1
          RETURN
        ENDIF

        IF(MT.LE.0.OR.MT.GT.99) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE: UNIT = 0 (rblock_mem)')
          IERR=1      
          IER_RD=1
          RETURN
        ENDIF
C --
        CALL LENSTR_BL(FNAME,LEN)
        IF(LEN.GT.0.AND.FNAME(1:1).NE.','.AND.FNAME(1:1).NE.' ') THEN
          NAME=FNAME(1:LEN)
          DO I=LEN,1,-1
            IF(NAME(I:I).EQ.',') THEN
              NAME(I:I)=' '
            ELSE
              IF(NAME(I:I).NE.' ') GO TO 800
            ENDIF 
          ENDDO
 800      CONTINUE
          FLINE = NAME
          CALL LENSTR_BL(FLINE,LEN)
          IF(LEN.GT.4.AND.FLINE(LEN-3:LEN).EQ.'.dat') THEN
            NAME=FLINE(1:LEN-4)
          ENDIF
        ELSE
          NAME=FNAME
        ENDIF
C -------

        PATH = ' '
C?      EXT  = ' '
        EXT  = 'dat'
        MD   = MDOC

        CALL OPENUR(MT,MD,PATH,NAME,EXT,IERR)

        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE (rblock_mem)')
          IERR=1      
          IER_RD=1
          RETURN
        ENDIF
      ELSE
        IPOOL_CURR = 0
      ENDIF
      GO TO 1010
C ======================================================================
      ENTRY OPFILE_MEM(MDOC,MT,FNAME,TYPE,NSYM,ISYM,NSMAX,IPOOL,IERR)
C ======================================================================
      IF(IPOOL_MAX.GT.0) THEN
        IPOOL_CURR = 0
      ELSE
        REWIND MT
      ENDIF
      IERR  = 0
      PI    = 4.0*ATAN(1.0)
      PI180 = PI/180.
C ---
      DO I=1,80
        TL_RD(I:I)= ' '
        TTT(I:I)  = ' '
        TTT2(I:I) = ' '
      ENDDO
      TL_RD(1:9) = '?   ?   ?'
      DO I=1,40
        PT_RD(I:I) = ' '
      ENDDO
      PT_RD(1:13) = 'XXXXXXXX    ?'
      CD_RD  = 'XXXX'
      T1_RD  = '?   '
      T2_RD  = '?   '
      PD_RD  = 'XX-XXX-XX'
      TEMPER = '?    '
      WAVE   = '?    '
      MSG    = 'N'

 1010 CONTINUE
      CALL RBLOCK_MEM(MT,ILINE,NW40,IPOOL,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: READ TITLE1 OF FILE (rblock_mem)')
        IF(IPOOL_MAX.LE.0) CLOSE(MT)        
        IERR=2      
        IER_RD=2
        RETURN
      ENDIF
      CDATE=LINE(60:79)
      WRITE(STR,20) LINE(2:5),LINE(7:9),LINE(11:58)
   20 FORMAT('Type:',A,'; OS:',A,'; CELL:',A)
      CALL MSGDOC(MDOC,STR)
      READ(LINE,90) TYP,A,B,C,AL,BE,GA
   90 FORMAT(1X,A4,5X,6F8.3)
      IF(TYPE.NE.'    ') THEN
        IF(TYPE.EQ.'FF  ')THEN
          IF(TYP.NE.'F   '.AND.TYP.NE.'FS  ') THEN
            CALL MSGERR(MDOC,' ERR: WRONG FILE TYPE (rblock_mem) ')
            IF(IPOOL_MAX.LE.0) CLOSE(MT)
            IERR=2        
            IER_RD=2
            RETURN 
          ENDIF
        ELSE IF(TYPE.NE.TYP) THEN
          CALL MSGERR(MDOC,' ERR: WRONG FILE TYPE (rblock_mem)')
          IF(IPOOL_MAX.LE.0) CLOSE(MT)
          IERR=2    
          IER_RD=2
          RETURN
        ENDIF
      ENDIF
      TYPE  = TYP
      AL    = AL*PI180
      BE    = BE*PI180
      GA    = GA*PI180
      TP_RD = TYP
      A_RD  = A
      B_RD  = B
      C_RD  = C
      AL_RD = AL
      BE_RD = BE
      GA_RD = GA
      DT_RD = LINE(60:79)

 2000 CONTINUE

      CALL RBLOCK_MEM(MT,ILINE,NW40,IPOOL,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: READ TITLE2 OF FILE (rblock_mem)')
        IF(IPOOL_MAX.LE.0) CLOSE(MT)
        IERR=2    
        IER_RD=2
        RETURN
      ENDIF


      IF(LINE(1:4).EQ.'PDB:') THEN
C
C       FORMAT('PDB:',A40,1X,A9)
C       TL_RD(9:48),PD_RD
C              
        READ(LINE,'(4X,A40,1X,A9,A5,A5)') TTT2(1:40),PD_RD,WAVE,TEMPER
        

        GO TO 2000
      ELSE IF(LINE(1:4).EQ.'NSYM') THEN
C 
C       FORMAT('NSYM',1X,I5) NSYM
C
        READ(LINE,'(4X,1X,I5)') NSYM

        IF(NSYM.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ TITLE: NSYM=0 (rblock_mem)')
          IF(IPOOL_MAX.LE.0) CLOSE(MT)
          IERR=2        
          IER_RD=2
          RETURN
        ENDIF
        IF(NSYM.GT.NSMAX) THEN
          WRITE(STR,
     *    '('' ERR: READ TITLE: NSYM >'',I5,''(rblock_mem)'')') NSMAX
          CALL MSGERR(MDOC,STR) 
          IF(IPOOL_MAX.LE.0) CLOSE(MT)
          IERR=2      
          IER_RD=2
          RETURN
        ENDIF
        DO ISS=1,NSYM
          CALL RBLOCK_MEM(MT,ILINE,NW40,IPOOL,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,
     *      ' ERR: READ SYM_TITLE OF FILE (rblock_mem)')
            IF(IPOOL_MAX.LE.0) CLOSE(MT)
            IERR=2        
            IER_RD=2
            RETURN
          ENDIF
          
C
C
          READ(LINE,'(4X,1X,A)') SYMOP
          CALL LENSTR_BL(SYMOP,LEN)
          IF(LEN.LE.4) THEN
            WRITE(STR,'('' ERR: READ TITLE: SYM_OP (rblock_mem)'')') 
            CALL MSGERR(MDOC,STR) 
            IF(IPOOL_MAX.LE.0) CLOSE(MT)
            IERR=2      
            IER_RD=2
            RETURN
          ENDIF  
          NS=ISS
          CALL SYMFR2_BL(MDOC,SYMOP,NS,NSYMR,ISYM,NSMAX,IERR)
C
        ENDDO
        GO TO 2000    
      ELSE IF(LINE(1:3).EQ.'SYM') THEN
        GO TO 2000
      ENDIF

      IF(TYP.EQ.'RI  ') THEN

        CHAR1 = LINE(46:46)
        CALL CHKSMB(CHAR1,TPSYMB)
        IF(TPSYMB.NE.'D') THEN
          LINE(44:46)='   '
        ELSE
          CHAR1 = LINE(45:45)
          CALL CHKSMB(CHAR1,TPSYMB)
          IF(TPSYMB.NE.'D') THEN
            LINE(44:45)='  '
          ELSE
            CHAR1 = LINE(44:44)
            CALL CHKSMB(CHAR1,TPSYMB)
            IF(TPSYMB.NE.'D') LINE(44:44)=' '
          ENDIF
        ENDIF
        CHAR1 = LINE(48:48)
        CALL CHKSMB(CHAR1,TPSYMB)
        IF(TPSYMB.NE.'D') LINE(48:48)=' '
        READ(LINE,100,ERR=999) TTT(1:48),NX,NY,NZ,IZN,IZM
C ---
        READ(LINE,'(28X,A4,A15,I1)',ERR=999) 
     *  CD_RD,CH15,IS_RD
        SG_RD  = CH15(1:11)
        CH4    = CH15(15:15)//CH15(12:14)         
        READ(CH4,'(I4)') NS_RD
C ---
C        IF(NS_RD.LE.0.OR.NS_RD.GT.230) NS_RD=1
        IF(NS_RD.LE.0.OR.NS_RD.GT.9999) NS_RD=1
        IF(IS_RD.LE.0.OR.IS_RD.GT.9) IS_RD=1

c        DO I=1,80
c          TTT(I:I)=' '
c        ENDDO
  100   FORMAT(A48,12X,5I4)

        CALL LENSTR_BL(SG_RD,L)
        IF(L.GT.11) L=11
        WRITE(STR,30) CD_RD,SG_RD(1:L),NS_RD,IS_RD,CDATE
   30   FORMAT('CodePDB:',A4,' Sp.Gr:',A11,' No Sp.Gr:',I4
     *           ,'Sett:',I1,' Date:',A)
        CALL MSGDOC(MDOC,STR)

C        WRITE(STR,50) LINE(1:4),LINE(5:8),LINE(9:28)
        WRITE(STR,50) LINE(1:4),LINE(5:8),TTT2(1:40)
   50   FORMAT('Code1:',A4,'; Code2:',A4,'; Title:',A40)
        CALL MSGDOC(MDOC,STR)
        WRITE(STR,60) NX,NY,NZ,IZN,IZM
   60   FORMAT('Grid:  NX=',I5,' NY=',I5,' NZ=',I5,' IZmin=',I5,
     *    ' IZmax=',I5)
        CALL MSGDOC(MDOC,STR)

        F1=0.0
        F2=0.0
        F3=0.0
        F4=0.0
      ELSE
        CHAR1 = LINE(46:46)
        CALL CHKSMB(CHAR1,TPSYMB)
        IF(TPSYMB.NE.'D') THEN
          LINE(44:46)='   '
        ELSE
          CHAR1 = LINE(45:45)
          CALL CHKSMB(CHAR1,TPSYMB)
          IF(TPSYMB.NE.'D') THEN
            LINE(44:45)='  '
          ELSE
            CHAR1 = LINE(44:44)
            CALL CHKSMB(CHAR1,TPSYMB)
            IF(TPSYMB.NE.'D') LINE(44:44)=' '
          ENDIF
        ENDIF
        CHAR1 = LINE(48:48)
        CALL CHKSMB(CHAR1,TPSYMB)
        IF(TPSYMB.NE.'D') LINE(48:48)=' '

        READ(LINE,110,ERR=999) TTT(1:48),F1,F2,F3,F4
C ---
        READ(LINE,'(28X,A4,A15,I1)',ERR=999) 
     *  CD_RD,CH15,IS_RD
        SG_RD  = CH15(1:11)
        CH4    = CH15(15:15)//CH15(12:14)         
        READ(CH4,'(I4)') NS_RD
C ---
c        IF(NS_RD.LE.0.OR.NS_RD.GT.230) NS_RD=1
        IF(NS_RD.LE.0.OR.NS_RD.GT.9999) NS_RD=1
        IF(IS_RD.LE.0.OR.IS_RD.GT.9)   IS_RD=1
c        DO I=1,80
c          TTT(I:I)=' '
c        ENDDO
  110   FORMAT(A48,2F8.2,2F8.3)


        CALL LENSTR_BL(SG_RD,L)
        IF(L.GT.11) L=11
            WRITE(STR,30) CD_RD,SG_RD(1:L),NS_RD,IS_RD,CDATE
            CALL MSGDOC(MDOC,STR)


C            WRITE(STR,50) LINE(1:4),LINE(5:8),LINE(9:28)
            WRITE(STR,50) LINE(1:4),LINE(5:8),TTT2(1:40)
            CALL MSGDOC(MDOC,STR)
            IF(TYP.EQ.'ALMN'.OR.TYP.EQ.'ALMS') THEN
              WRITE(STR,81) F1,F2,F3,F4
              CALL MSGDOC(MDOC,STR)
   81         FORMAT('Rad:',F8.2,' Zsymm:',F8.2,' RESmin:',F8.3,
     *               ' RESmax:',F8.3)
            ELSE
              WRITE(STR,80) F1,F2,F3,F4
              CALL MSGDOC(MDOC,STR)
   80         FORMAT('Scale:',F8.2,' Bfactor:',F8.2,' RESmin:',F8.3,
     *               ' RESmax:',F8.3)
            ENDIF


        NX=0
        NY=0
        NZ=0
        IZN=0
        IZM=0
      ENDIF


      PT_RD(5:24)=TTT(9:28)
      PT_RD(1:4) =CD_RD
      DO II=25,40
        PT_RD(II:II)=' '
      ENDDO

      T1_RD=TTT(1:4)
      T2_RD=TTT(5:8)

      TL_RD(1:4)  = T1_RD
      TL_RD(5:8)  = T2_RD
      TL_RD(9:48) = TTT2(1:40)
      TL_RD(69:73)= WAVE
      TL_RD(74:78)= TEMPER

      WRITE(STR,700)
     * PT_RD(5:12),PT_RD(13:24),PD_RD,TL_RD(69:73),TL_RD(74:78)
 700  FORMAT('DB_code:',A,';key:',A,';Date:',A,
     * ';Lambda:',A,';Temp:',A) 
      CALL MSGDOC(MDOC,STR)

      RN_RD=F3
      RX_RD=F4
      CF_RD=F1
      TF_RD=F2
      NX_RD=NX
      NY_RD=NY
      NZ_RD=NZ
      IN_RD=IZN
      IM_RD=IZM
      IER_RD=0
      IEN_RD=-1
      RETURN

 999  CONTINUE
      CALL MSGERR(MDOC,
     * ' ERR: problem with title2 of input file (rblock_mem)')
      IF(IPOOL_MAX.LE.0) THEN
        CLOSE(MT)        
      ENDIF
      IERR=3      
      IER_RD=3
      RETURN
      END


C ******
      SUBROUTINE OWFILE_MEM(MDOC,MT
     *                           ,FNAME,TYP,NSYM,ISYM,NSMAX,IPOOL,IERR)

C     *          ,A,B,C,AL,BE,GA,F1,F2,F3,F4,NX,NY,NZ,IZN,IZM,TTT)
C
C -P- OWFILE - 1.open file FNAME  
C -P-            2.writes title to file, parameters from common /COMRDF/
C ---------
C   CHARACTER TYPE*4,FNAME*(*)
C ---------
C     input :  MT     - unit of file. If MT=0 - return without error signal.
C              FNAME  - file name or " ".   /if " " - name will be taken
C                                                      from terminal  /
C              MDOC   - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       =< 99 - not write  
C              IPRINT = 1 print all information
C                     = 0 don't print
C              TYP    = type of file.
C                       'F   ' or 'FS  ' or 'COEF' or 'ABCD'
C                       'ALMN' or 'RI  '
C
C      output :  FNAME     - name of file
C                MT = 0    - signal of error.
C ---
      INTEGER*4         IPOOL(*)
      COMMON/COM_DPOOL/ IPOOL_MAX,IPOOL_CURR
C ---
      COMMON/COMWRF/ A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
     *              ,RN_WR,RX_WR,CF_WR,TF_WR
     *              ,NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
     *              ,NS_WR,IS_WR,IER_WR,IEN_WR
     *              ,TP_WR,T1_WR,T2_WR,TL_WR,DT_WR
     *              ,CD_WR,SG_WR,PT_WR,PD_WR
      REAL A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
      REAL RN_WR,RX_WR,CF_WR,TF_WR
      INTEGER*4 NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
      INTEGER*4 NS_WR,IS_WR,IER_WR,IEN_WR
      CHARACTER TP_WR*4,T1_WR*4,T2_WR*4,TL_WR*80,DT_WR*20     
      CHARACTER CD_WR*4,SG_WR*24,PT_WR*40,PD_WR*9
C ---
      INTEGER*4 MT,MDOC,NSYM,NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER FNAME*(*)
      CHARACTER TTT*80
      CHARACTER TTT2*80
      CHARACTER TYP*4
C ******
C -------
      REAL A,B,C,AL,BE,GA,F1,F2,F3,F4
      INTEGER*4 NX,NY,NZ,IZN,IZM
      CHARACTER CH1*1,TPSYMB*1,NAME*256,FLINE*256
      INTEGER*4 NW40,ILINE(20)
      INTEGER*4 IH(7)
      CHARACTER STR*80,CDATE*20,SYMOP*60,WAVE*5,TEMPER*5
      CHARACTER LINE*80,CH2*2,CH3*3,PATH*1,EXT*3,CH15*15,CH4*4
      EQUIVALENCE (ILINE(1),LINE)
      DATA NW40/20/
C ----------------------------------------------------------------------
      IF(MT.EQ.0) RETURN
      IERR=0
      CALL LENSTR_BL(FNAME,NLN)
      IF(NLN.LE.0.OR.FNAME(1:1).EQ.','.OR.FNAME(1:1).EQ.' ') THEN
        CALL MSGERR(MDOC,' ERR: WRONG FILE_NAME (in wblock_mem)')
        IERR=1
        IER_WR=1
        RETURN
      ENDIF
C -----------        
      DO I=1,80
        TTT(I:I)  = ' '
        TTT2(I:I) = ' '
      ENDDO
      TEMPER='?    '
      WAVE  ='?    '
C ------------     
      IF(IPOOL_MAX.LE.0) THEN
C --
        CALL LENSTR_BL(FNAME,LEN)
        IF(LEN.GT.0.AND.FNAME(1:1).NE.','.AND.FNAME(1:1).NE.' ') THEN
          NAME=FNAME(1:LEN)
          DO I=LEN,1,-1
            IF(NAME(I:I).EQ.',') THEN
              NAME(I:I)=' '
            ELSE
              IF(NAME(I:I).NE.' ') GO TO 800
            ENDIF 
          ENDDO
 800      CONTINUE
          FLINE = NAME
          CALL LENSTR_BL(FLINE,LEN)
          IF(LEN.GT.4.AND.FLINE(LEN-3:LEN).EQ.'.dat') THEN
            NAME=FLINE(1:LEN-4)
          ENDIF
        ELSE
          NAME=FNAME
        ENDIF
C -------
        PATH = ' '
C?      EXT  = ' '
        EXT  = 'dat'
        MD   = MDOC
        CALL OPENUW(MT,MD,PATH,NAME,EXT,IERR)

        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE (in wblock_mem)')
          IERR=1
          IER_WR=1
          RETURN
        ENDIF
      ELSE
        IPOOL_CURR = 0
      ENDIF
C----
      PI    = 4.0*ATAN(1.0)
      PI180 = PI/180.0
      ALW   = AL_WR/PI180
      BEW   = BE_WR/PI180
      GAW   = GA_WR/PI180
      CALL CLOCK(IH)
      TP_WR = TYP      
      IMODE = 0
      CALL CHECK_LINE(IMODE,TP_WR)
      IF(A_WR.LT.-999.999) A_WR=-999.999
      IF(A_WR.GT.9999.999) A_WR=9999.999
      IF(B_WR.LT.-999.999) B_WR=-999.999
      IF(B_WR.GT.9999.999) B_WR=9999.999
      IF(C_WR.LT.-999.999) C_WR=-999.999
      IF(C_WR.GT.9999.999) C_WR=9999.999
      IF(ALW.LT.-999.999) ALW=-999.999
      IF(ALW.GT.9999.999) ALW=9999.999
      IF(BEW.LT.-999.999) BEW=-999.999
      IF(BEW.GT.9999.999) BEW=9999.999
      IF(GAW.LT.-999.999) GAW=-999.999
      IF(GAW.GT.9999.999) GAW=9999.999
      IF(IH(2).LT.0.OR.IH(2).GT.99) IH(2)=0
      IF(IH(3).LT.0.OR.IH(3).GT.99) IH(3)=0
      IF(IH(4).LT.0.OR.IH(4).GT.99) IH(4)=0
      IF(IH(5).LT.0.OR.IH(5).GT.99) IH(5)=0
      IF(IH(6).LT.0.OR.IH(6).GT.99) IH(6)=0
      IF(IH(7).LT.0.OR.IH(7).GT.9999) IH(7)=0
       
      WRITE(LINE,10) TP_WR,A_WR,B_WR,C_WR,ALW,BEW,GAW
     * ,IH(4),IH(3),IH(2),IH(5),IH(6),IH(7)
   10   FORMAT(' ',A4,'     ',6F8.3,';',I2,'.',I2,'.',I2,'/'
     *   ,I2,'.',I2,'.',I4)
      CDATE = LINE(60:79)
      DT_WR = CDATE
      CALL GETNOS(CH3)
      LINE(7:9)=CH3

      CALL WBLOCK_MEM(MT,ILINE,NW40,IPOOL,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE TITLE OF FILE (in wblock_mem)')
        IF(IPOOL_MAX.LE.0) CLOSE(MT)
        IER_WR = 2
        IERR   = 2
        RETURN
      ENDIF

      WRITE(STR,20) LINE(2:5),LINE(7:9),LINE(11:58)
   20 FORMAT('Type:',A,'; OS:',A,'; CELL:',A)
      CALL MSGDOC(MDOC,STR)

C ---------
      IMODE=0
      T1_WR      = TL_WR(1:4)
      T2_WR      = TL_WR(5:8)
      TTT(1:20)  = PT_WR(5:24)

      TTT2(1:40) = TL_WR(9:48)
      WAVE       = TL_WR(69:73)
      TEMPER     = TL_WR(74:78)

C     READ(LINE,'(4X,A40,1X,A9,A5,A5)') TTT2(1:40),PD_RD,WAVE,TEMPER

      CALL CHECK_LINE(IMODE,PT_WR)
      CALL CHECK_LINE(IMODE,PD_WR)
      WRITE(LINE,'(''PDB:'',A40,1X,A9,A5,A5)') 
     *  TTT2(1:40),PD_WR,WAVE,TEMPER
      CALL WBLOCK_MEM(MT,ILINE,NW40,IPOOL,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE TITLE OF FILE (in wblock_mem)')
        IF(IPOOL_MAX.LE.0) CLOSE(MT)
        IERR   = 2
        IER_WR = 2
        RETURN
      ENDIF
      CALL MSGDOC(MDOC,LINE)

C 
C     FORMAT('NSYM',1X,I5) NSYM
C
      IF(NSYM.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE TITLE: NSYM=0 (in wblock_mem)')
        IF(IPOOL_MAX.LE.0) CLOSE(MT)
        IERR=2        
        IER_WR=2
        RETURN
      ENDIF
      IF(NSYM.GT.NSMAX) THEN
        WRITE(STR,
     *  '('' ERR:  (in wblock_mem) WRITE TITLE: NSYM >'',I5)') NSMAX
        CALL MSGERR(MDOC,STR) 
        IF(IPOOL_MAX.LE.0) CLOSE(MT)
        IERR=2      
        IER_WR=2
        RETURN
      ENDIF

c      IF(NSYM.LT.0.OR.NSYM.GT.230) NSYM=1
      IF(NSYM.LT.0.OR.NSYM.GT.9999) NSYM=1
      WRITE(LINE,'(''NSYM:'',I5)') NSYM
      CALL WBLOCK_MEM(MT,ILINE,NW40,IPOOL,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE TITLE OF FILE (in wblock_mem)')
        IF(IPOOL_MAX.LE.0) CLOSE(MT)
        IERR   = 2
        IER_WR = 2
        RETURN
      ENDIF
      CALL MSGDOC(MDOC,LINE)

C
C         FORMAT('ISYM',1X,A) SYMOP
C

      DO     I=1,NSYM
        LINE=' ' 
        LINE(1:3)='SYM'
        WRITE(CH3,'(I3)') I
        LINE(4:4)=CH3(3:3)
        LINE(5:5)=' '
        L=5
        DO J=1,3
          TR=REAL(ISYM(4,J,I))/REAL(ISYM(5,J,I)) 
          IF(TR.LT.0) THEN
            L=L+1
            LINE(L:L)='-'
            NEG=1
          ELSE
            NEG=0
          ENDIF
          IF(ISYM(5,J,I).EQ.0) ISYM(5,J,I)=1.0
          TR=REAL(ISYM(4,J,I))/REAL(ISYM(5,J,I)) 
          TR=ABS(TR) 
          IF(TR.GT.0.49.AND.TR.LT.0.51) THEN
            L=L+1
            LINE(L:L+2)='1/2'
            L=L+2
          ELSE IF(TR.GT.0.24.AND.TR.LT.0.26) THEN
            L=L+1
            LINE(L:L+2)='1/4'  
            L=L+2 
          ELSE IF(TR.GT.0.32.AND.TR.LT.0.34) THEN
            L=L+1
            LINE(L:L+2)='1/3' 
            L=L+2 
          ELSE IF(TR.GT.0.74.AND.TR.LT.0.76) THEN
            L=L+1
            LINE(L:L+2)='3/4'
            L=L+2 
          ELSE IF(TR.GT.0.165.AND.TR.LT.0.167) THEN
            L=L+1
            LINE(L:L+2)='1/6'  
            L=L+2 
          ELSE IF(TR.GT.0.66.AND.TR.LT.0.67) THEN
            L=L+1
            LINE(L:L+2)='2/3'
            L=L+2 
          ELSE IF(TR.GT.0.833.AND.TR.LT.0.835) THEN
            L=L+1
            LINE(L:L+2)='5/6'
            L=L+2 
          ELSE
            IF(NEG.GT.0) L=L-1
          ENDIF

          DO  K=1,3
            IDG=ISYM(K,J,I) 
            IF(IDG.LT.0) THEN
              L=L+1
              LINE(L:L)='-'
            ELSE IF(IDG.GT.0) THEN
              L=L+1
              LINE(L:L)='+'
            ENDIF  
            IDG=ABS(IDG)
            IF(IDG.GT.1.AND.IDG.LT.10) THEN
              WRITE(CH1,'(I1)') IDG
              L=L+1
              LINE(L:L)=CH1  
            ELSE IF(IDG.GT.9.AND.IDG.LT.100) THEN
              WRITE(CH2,'(I2)') IDG
              L=L+1
              LINE(L:L+1)=CH2  
              L=L+1
            ELSE IF(IDG.GT.99.AND.IDG.LT.1000) THEN
              WRITE(CH3,'(I3)') IDG
              L=L+1
              LINE(L:L+2)=CH3  
              L=L+2
            ENDIF
            IF(IDG.NE.0) THEN
              L=L+1
              IF(K.EQ.1) THEN
                LINE(L:L)='X'
              ELSE IF(K.EQ.2) THEN
                LINE(L:L)='Y'
              ELSE
                LINE(L:L)='Z'
              ENDIF
            ENDIF
          ENDDO

          LINE(L+1:L+3)=' , '
          L=L+3
        ENDDO

        IMODE=0
        CALL CHECK_LINE(IMODE,LINE)
        CALL WBLOCK_MEM(MT,ILINE,NW40,IPOOL,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: WRITE TITLE OF FILE (in wblock_mem)')
          IF(IPOOL_MAX.LE.0) CLOSE(MT)
          IERR=2
          IER_WR=2
          RETURN
        ENDIF
        CALL MSGDOC(MDOC,LINE)
      ENDDO
C ---------
      DO I=1,80
        LINE(I:I)=' '
      ENDDO
      IMODE=0
      CALL CHECK_LINE(IMODE,T1_WR)
      CALL CHECK_LINE(IMODE,T2_WR)

      CALL CHECK_LINE(IMODE,TL_WR(1:20))
      CALL CHECK_LINE(IMODE,CD_WR)

      IF(NSYM.EQ.1) THEN
        SG_WR = 'P 1'
        NS_WR=1
        IS_WR=1
      ENDIF

      CALL CHECK_LINE(IMODE,SG_WR)
C     IF(NS_WR.LE.0.OR.NS_WR.GT.230) NS_WR=1
      IF(NS_WR.LE.0.OR.NS_WR.GT.9999) NS_WR=1
      IF(IS_WR.LE.0.OR.IS_WR.GT.9)   IS_WR=1
      IF(TYP.EQ.'RI  ') THEN
        IF(NX_WR.LE.0.OR.NX_WR.GT.9999) NX_WR=1
        IF(NY_WR.LE.0.OR.NY_WR.GT.9999) NY_WR=1
        IF(NZ_WR.LE.0.OR.NZ_WR.GT.9999) NZ_WR=1
        IF(IN_WR.LT.-999.OR.IN_WR.GT.9999) IN_WR=0
        IF(IM_WR.LT.-999.OR.IM_WR.GT.9999) IM_WR=0
        IF(NX_WR.LE.0.OR.NX_WR.GT.9999) NX_WR=1

        CALL LENSTR_BL(SG_WR,L)
        IF(L.GT.11) L=11
C ---
        CH15 = SG_WR(1:L)
        IF(L.LT.11) THEN
          DO I=L+1,11
            CH15(I:I) = ' '
          ENDDO
        ENDIF
        WRITE(CH4,'(I4)') NS_WR
        CH15(15:15) = CH4(1:1)         
        CH15(12:14) = CH4(2:4)         
C ---
        WRITE(LINE,40,ERR=999) 
     *         T1_WR,T2_WR,TTT(1:20),CD_WR,CH15
     *                ,IS_WR,NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
   40   FORMAT(A4,A4,A20,A4,A15,I1
     *  ,'            ', 5I4)
        WRITE(STR,30) CD_WR,SG_WR(1:L),NS_WR,IS_WR,DT_WR
   30   FORMAT('CodePDB:',A4,' Sp.Gr:',A11,' No Sp.Gr:',I4
     *             ,'Sett:',I1,' Date:',A)
        CALL MSGDOC(MDOC,STR)

c        WRITE(LINE,40,ERR=999) 
c     *         T1_WR,T2_WR,TTT(1:20),CD_WR,SG_WR,NS_WR
c     *                ,IS_WR,NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
c   40   FORMAT(A4,A4,A20,A4,A11,I3,' ',I1
c     *  ,'            ', 5I4)
c        WRITE(STR,30) CD_WR,SG_WR,NS_WR,IS_WR,DT_WR
c   30   FORMAT('CodePDB:',A4,' Sp.Gr:',A11,' No Sp.Gr:',I3
c     *             ,' Sett:',I1,' Date:',A)
c        CALL MSGDOC(MDOC,STR)

C        WRITE(STR,50) LINE(1:4),LINE(5:8),LINE(9:28)
        WRITE(STR,50) LINE(1:4),LINE(5:8),TTT2(1:40)
   50   FORMAT('Code1:',A4,'; Code2:',A4,'; Title:',A40)
        CALL MSGDOC(MDOC,STR)
        WRITE(STR,60) NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
   60   FORMAT('Grid:  NX=',I5,' NY=',I5,' NZ=',I5,' IZmin=',I5,
     *   ' IZmax=',I5)
        CALL MSGDOC(MDOC,STR)
      ELSE
        IF(CF_WR.GT.99999.9) CF_WR=99999.9
        IF(TF_WR.GT.99999.9) TF_WR=99999.9
        IF(CF_WR.LT.-9999.9) CF_WR=-9999.9
        IF(TF_WR.LT.-9999.9) TF_WR=-9999.9
        IF(RN_WR.LE.0.0)     RN_WR=0.01
        IF(RN_WR.GT.9999.9)  RN_WR=9999.9
        IF(RX_WR.LE.0.0)     RX_WR=0.01
        IF(RX_WR.GT.9999.9)  RX_WR=9999.9

        CALL LENSTR_BL(SG_WR,L)
        IF(L.GT.11) L=11
C ---
        CH15 = SG_WR(1:L)
        IF(L.LT.11) THEN
          DO I=L+1,11
            CH15(I:I) = ' '
          ENDDO
        ENDIF
        WRITE(CH4,'(I4)') NS_WR
        CH15(15:15) = CH4(1:1)         
        CH15(12:14) = CH4(2:4)         
C ---
        WRITE(LINE,70,ERR=999) 
     *   T1_WR,T2_WR,TTT(1:20),CD_WR,CH15
     *                ,IS_WR,CF_WR,TF_WR,RN_WR,RX_WR
   70   FORMAT(A4,A4,A20,A4,A15,I1,2F8.2,2F8.3)

        WRITE(STR,30) CD_WR,SG_WR(1:L),NS_WR,IS_WR,CDATE
        CALL MSGDOC(MDOC,STR)

C        WRITE(LINE,70,ERR=999) 
C     *   T1_WR,T2_WR,TTT(1:20),CD_WR,SG_WR,NS_WR
C     *                ,IS_WR,CF_WR,TF_WR,RN_WR,RX_WR
C   70   FORMAT(A4,A4,A20,A4,A11,I3,' ',I1,2F8.2,2F8.3)
C        WRITE(STR,30) CD_WR,SG_WR,NS_WR,IS_WR,CDATE
C        CALL MSGDOC(MDOC,STR)

C        WRITE(STR,50) LINE(1:4),LINE(5:8),LINE(9:28)
        WRITE(STR,50) LINE(1:4),LINE(5:8),TTT2(1:40)
        CALL MSGDOC(MDOC,STR)
        IF(TYP.EQ.'ALMN'.OR.TYP.EQ.'ALMS') THEN
          WRITE(STR,81) CF_WR,TF_WR,RN_WR,RX_WR
          CALL MSGDOC(MDOC,STR)
   81     FORMAT('Rad:',F8.2,' Zsymm:',F8.2,' RESmin:',F8.3,
     *               ' RESmax:',F8.3)
        ELSE
          WRITE(STR,80)  CF_WR,TF_WR,RN_WR,RX_WR
          CALL MSGDOC(MDOC,STR)
   80     FORMAT('Scale:',F8.2,' Bfactor:',F8.2,' RESmin:',F8.3,
     *               ' RESmax:',F8.3)
        ENDIF
      ENDIF
      CALL WBLOCK_MEM(MT,ILINE,NW40,IPOOL,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE TITLE OF FILE (in wblock_mem)')
        IF(IPOOL_MAX.LE.0) CLOSE(MT)
        IERR=2
        IER_WR=2
        RETURN
      ENDIF
      RETURN
 999  CONTINUE
      CALL MSGERR(MDOC,' ERR: problem to write TITLE2 (in wblock_mem)')
      IF(IPOOL_MAX.LE.0) CLOSE(MT)
      IERR=3
      IER_WR=3
      RETURN
      END

C ******
      SUBROUTINE GET_TITLE(MDOC,A,B,C,AL,BE,GA
     *        ,F1,F2,F3,F4,NX,NY,NZ,IZN,IZM,TTT,IERR)
C
C -P-  GET_TITLE
C -P-
C ---------
C ---
      COMMON/COMRDF/ A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
     *              ,RN_RD,RX_RD,CF_RD,TF_RD
     *              ,NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
     *              ,NS_RD,IS_RD,IER_RD,IEN_RD
     *              ,TP_RD,T1_RD,T2_RD,TL_RD,DT_RD
     *              ,CD_RD,SG_RD,PT_RD,PD_RD
      REAL A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
      REAL RN_RD,RX_RD,CF_RD,TF_RD
      INTEGER*4 NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
      INTEGER*4 NS_RD,IS_RD,IER_RD,IEN_RD
      CHARACTER TP_RD*4,T1_RD*4,T2_RD*4,TL_RD*80,DT_RD*20     
      CHARACTER CD_RD*4,SG_RD*24,PT_RD*40,PD_RD*9
C ---
C ******
C -------
      CHARACTER TTT*(*)
      REAL A,B,C,AL,BE,GA,F1,F2,F3,F4
      INTEGER*4 NX,NY,NZ,IZN,IZM
C -------------------------------------------
      IERR=0
      CALL CLEAR_STR(TTT)
      A   = A_RD 
      B   = B_RD 
      C   = C_RD 
      AL  = AL_RD
      BE  = BE_RD
      GA  = GA_RD
      F1  = CF_RD
      F2  = TF_RD
      F3  = RN_RD
      F4  = RX_RD
      NX  = NX_RD
      NY  = NY_RD
      NZ  = NZ_RD
      IZN = IN_RD
      IZM = IM_RD
      CALL LENSTR_BL(TL_RD,LN)
      IF(LN.GT.78) LN=78
      IF(LN.LT.9) THEN
        TTT(1:4)     = T1_RD
        TTT(5:8)     = T2_RD
        TTT(9:9)     = '?'
        RETURN
      ENDIF
      TTT(1:4)     = T1_RD
      TTT(5:8)     = T2_RD
      TTT(9:LN)    = TL_RD(9:LN)
      N=LEN(TTT)
      IF(N.GE.84) THEN
        TTT(81:84)=CD_RD  
        CALL LENSTR_BL(PT_RD,LN)
        IF(LN.GT.0) THEN
          LLIM=N-80
          IF(LN.GT.LLIM) LN=LLIM
          L1=81
          L2=80+LN
          IF(LN.GE.1) TTT(L1:L2)=PT_RD(1:LN)
        ELSE
          IF(N.GE.85) TTT(85:85)='?'
        ENDIF
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE SET_TITLE(MDOC,A,B,C,AL,BE,GA
     *        ,F1,F2,F3,F4,NX,NY,NZ,IZN,IZM,TITLE,IERR)
C
C -P- SET_TITLE
C -P-
C ---------
C ---
      COMMON/COMWRF/ A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
     *              ,RN_WR,RX_WR,CF_WR,TF_WR
     *              ,NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
     *              ,NS_WR,IS_WR,IER_WR,IEN_WR
     *              ,TP_WR,T1_WR,T2_WR,TL_WR,DT_WR
     *              ,CD_WR,SG_WR,PT_WR,PD_WR
      REAL A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
      REAL RN_WR,RX_WR,CF_WR,TF_WR
      INTEGER*4 NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
      INTEGER*4 NS_WR,IS_WR,IER_WR,IEN_WR
      CHARACTER TP_WR*4,T1_WR*4,T2_WR*4,TL_WR*80,DT_WR*20     
      CHARACTER CD_WR*4,SG_WR*24,PT_WR*40,PD_WR*9
C ---
C ******
C -------
      CHARACTER TITLE*(*),CHAR9*9,TTT*256
      REAL A,B,C,AL,BE,GA,F1,F2,F3,F4
      INTEGER*4 NX,NY,NZ,IZN,IZM
C -------------------------------------------
      TTT = TITLE
      IERR=0
      DO I=1,80
        TL_WR(I:I)   = ' '
      ENDDO
      DO I=1,40
        PT_WR(I:I)   = ' '
      ENDDO
      PT_WR(1:13)   = 'XXXXXXXX    ?'
      T1_WR='?   '
      T2_WR='?   '
      TL_WR(1:9)   = '?   ?   ?'
      CD_WR='XXXX'
      A_WR = A
      B_WR = B
      C_WR = C
      AL_WR= AL
      BE_WR= BE
      GA_WR= GA
      CF_WR= F1
      TF_WR= F2
      RN_WR= F3
      RX_WR= F4
      NX_WR= NX
      NY_WR= NY
      NZ_WR= NZ
      IN_WR= IZN
      IM_WR= IZM

      CALL LENSTR_BL(TTT,LN)

      CHAR9 = '---------'
      IF(LN.LE.0) THEN
        LN = 1
        TTT(1:1) = '-'
      ENDIF
      IF(LN.LT.9) THEN
        TTT(LN+1:9) = CHAR9(LN+1:9)
      ENDIF

      CALL LENSTR_BL(TTT,LN)
      IF(LN.GT.78) LN=78

      T1_WR=TTT(1:4)
      T2_WR=TTT(5:8)
      TL_WR(1:LN)=TTT(1:LN)

      N=LEN(TTT)
      CALL LENSTR_BL(TTT,LN)

      IF(N.GE.84.AND.LN.GE.81) THEN
        CD_WR=TTT(81:84)
        PT_WR=TTT(81:LN)
      ENDIF

      RETURN
      END

C ******
      SUBROUTINE WRT (MT,IHH,IKK,ILL,FAA,FBB,NUMB,IEND)
C
C     ENTRY WWRT (MT,IHH,IKK,ILL,FAA,FBB,SD1,SD2,NUMB,IEND)
C
C -P- WRT  - write to MT ; file of type:"F   ","PH  ","COEF","ALMN"
C -P- WWRT - write to MT ; file of type:"FS  "
C
C     input  : IHH,IKK,ILL - indices h, k, l
C              for type 'F   ' and 'FS  '
C                FAA         - structure factors F( h, k, l)
C                FBB         -                   F(-h,-k,-l)
C              only for type 'FS  '
C                SD1         - sigma F( h, k, l)
C                SD2                 F(-h,-k,-l)
C              for type 'PH  '
C                FAA         - M*cos(Phi)  M -figure of merit
C                FBB         - M*sin(Phi)
C              for type 'COEF'
C                for Patterson:/TTT(1:4)='PATT',
C                             see subroutine CTITLE or WTITLE/
C                FAA         - (Fmod)**2
C                FBB           sigma (Fmod)**2
C                for Fourie   : / TTT(1:4)='FOUR' /
C                FAA         - Fmod*M*cos(Phi)
C                FBB         - Fmod*M*sin(Phi)
C              for type 'ALMN'
C                FAA         - Almn
C                FBB         - Blmn
C              IEND        = -1  first call, subroutine ser IEND=0, NUMB=0
C                          =  0  normal next indices
C                          =  1  last record;IHH,IKK,ILL,FAA,FBB - don't used
C                          =  2  last record; write indices: 100,100,100,0,0,
C                                and close file
C              NUMB        -  reflex counter
C                            /  in the first call (IEND=-1) subroutine 
C                               set NUMB = 0 /
C              MT = 0      - means the error.
C ******
C  CMS      : FA,FB,IH,IK,IL,IBUF,IBUF4
      PARAMETER ( NWMX2= 512  )
      PARAMETER ( NWMAX=1024  )
      PARAMETER ( IND=146     )
      PARAMETER ( INDA=      1)
      PARAMETER ( INDB=IND*2+1)
      PARAMETER ( INDH=IND*4+1)
      PARAMETER ( INDK=IND*5+1)
      PARAMETER ( INDL=IND*6+1)
      PARAMETER ( INDM=IND*7+1)
      INTEGER   NUMB,ILLL
      REAL      FA(IND),FB(IND),FAA,FBB,SD1,SD2,SSD1,SSD2
      INTEGER*2 IH(IND),IK(IND),IL(IND)
      INTEGER*2 IBUF(NWMAX),M
      COMMON/COM_WRT/IBUF4(NWMX2),I,FIRST
      INTEGER*4 IBUF4
      LOGICAL   FIRST
      EQUIVALENCE (IBUF(INDM),M),(IBUF(INDH),IH(1)),(IBUF(INDK),IK(1))
      EQUIVALENCE (IBUF(INDL),IL(1)),(IBUF(INDA),FA(1))
      EQUIVALENCE (IBUF(INDB),FB(1))
      EQUIVALENCE (IBUF(1),IBUF4(1))
C -----------------------------------------------
      ITYP=0
      SD1=0.
      SD2=0.
      GO TO 1000
C ===============================================================
      ENTRY WWRT (MT,IHH,IKK,ILL,FAA,FBB,SSD1,SSD2,NUMB,IEND)
C ===============================================================
      SD1=SSD1
      SD2=SSD2
      ITYP=1
1000  CONTINUE
      MDOC=0
      IERR=0
      IF(MT.EQ.0) RETURN
      IF((ABS(IHH).GT.511.OR.ABS(IKK).GT.511.OR.ABS(ILL).GT.511). 
     * AND.IEND.LE.0) GO TO 77777
      IF(IEND.GT.0) THEN
        IHH=512
        IKK=512
        ILL=512
        NUMB=0
        FAA=0.
        FBB=0.
        SD1=0.
        SD2=0.
      ENDIF
      JTYP=0
      IF(IEND.LT.0) FIRST=.TRUE.
      IF(.NOT.FIRST) GO TO 10
      M   =IND
C     NUMB=0
      IEND=0
      I=0
      FIRST=.FALSE.
10    I=I+1
      IF(I.GT.M.OR.I.LE.0) GO TO 99999
      IF(NUMB.GE.0.AND.NUMB.LE.31) THEN
        ILLL=NUMB*1024+ILL
      ELSE
        ILLL=ILL
      ENDIF
      IH(I)=IHH
      IK(I)=IKK
      IL(I)=ILLL
      IF(ITYP.EQ.0) THEN
        FA(I)=FAA
        FB(I)=FBB
      ELSE
        IF(FAA.GT.1.E-6) THEN
          FA(I)=FAA
          IF(FBB.GT.1.E-6) THEN
            JTYP=1
            FB(I)=-SD1-3.0
          ELSE
            FB(I)= SD1+3.0
          ENDIF
        ELSE
          IF(FBB.GT.1.E-6) THEN
            FA(I)=-FBB
            FB(I)= SD2+3.0
          ELSE
            I=I-1
            GO TO 300
          ENDIF
        ENDIF
      ENDIF
      IF(IEND.GT.0) THEN
        M=I
      ELSE
C        NUMB=NUMB+1
        IF(I.LT.M) GO TO 2000
      ENDIF
C N    CALL WFILE(MT,0,IBUF4,-1, 512)
C N    IF(ERRCODE.NE.0) THEN
C N      CALL ERMSG(ERRCODE)
C N      GO TO 88888
C N    ENDIF
      WRITE(MT,ERR=88888) IBUF4
      I=0
2000  IF(ITYP.EQ.0) THEN
        IF(IEND.EQ.2) THEN
          END FILE MT
          CLOSE(MT)
        ENDIF
        RETURN
      ENDIF
      IF(JTYP.EQ.0) THEN
        IF(IEND.EQ.2) THEN
          END FILE MT
          CLOSE(MT)
        ENDIF
        RETURN
      ENDIF
      I=I+1
      IF(I.GT.M.OR.I.LE.0) GO TO 99999
      IH(I)=IHH
      IK(I)=IKK
      IL(I)=ILLL
      FA(I)=-FBB
      FB(I)= SD2+3.0
      IF(IEND.GT.0) THEN
        M=I
      ELSE
        IF(I.LT.M) GO TO 300
      ENDIF
C N    CALL WFILE(MT,0,IBUF4,-1, 512)
C N    IF(ERRCODE.NE.0) THEN
C N      CALL ERMSG(ERRCODE)
C N      GO TO 88888
C N    ENDIF
      WRITE(MT,ERR=88888) IBUF4
      I=0
300   IF(IEND.EQ.2) THEN
        END FILE MT
        CLOSE(MT)
      ENDIF
      RETURN
C ---------------------------------------
99999 CONTINUE
88888 CONTINUE
      CALL MSGERR(MDOC,' ERR: SUBROUTINE WRT')
      CLOSE(MT)
      MT=0
      RETURN
77777 CONTINUE
      CALL MSGERR(MDOC,' WARNING: indeses > 511, will be ignored')
      RETURN
      END

C ******
      SUBROUTINE WRT1(MT,IHH,IKK,ILL,FAA,FBB,NUMB,IEND)
C
C     ENTRY WWRT1(MT,IHH,IKK,ILL,FAA,FBB,SD1,SD2,NUMB,IEND)
C
C -P- WRT1  - write to MT ; file of type:"F   ","PH  ","COEF","ALMN"
C -P- WWRT1 - write to MT ; file of type:"FS  "
C ******
      PARAMETER ( NWMX2= 512  )
      PARAMETER ( NWMAX=1024  )
      PARAMETER ( IND=146     )
      PARAMETER ( INDA=      1)
      PARAMETER ( INDB=IND*2+1)
      PARAMETER ( INDH=IND*4+1)
      PARAMETER ( INDK=IND*5+1)
      PARAMETER ( INDL=IND*6+1)
      PARAMETER ( INDM=IND*7+1)
      INTEGER   NUMB,ILLL
      REAL      FA(IND),FB(IND),FAA,FBB,SD1,SD2,SSD1,SSD2
      INTEGER*2 IH(IND),IK(IND),IL(IND)
      INTEGER*2 IBUF(NWMAX),M
      COMMON/COM_WRT1/IBUF4(NWMX2),I,FIRST
      INTEGER*4 IBUF4
      LOGICAL   FIRST
      EQUIVALENCE (IBUF(INDM),M),(IBUF(INDH),IH(1)),(IBUF(INDK),IK(1))
      EQUIVALENCE (IBUF(INDL),IL(1)),(IBUF(INDA),FA(1))
      EQUIVALENCE (IBUF(INDB),FB(1))
      EQUIVALENCE (IBUF(1),IBUF4(1))
C -----------------------------------------
      ITYP=0
      SD1=0.
      SD2=0.
      GO TO 1000
C ===============================================================
      ENTRY WWRT1(MT,IHH,IKK,ILL,FAA,FBB,SSD1,SSD2,NUMB,IEND)
C ===============================================================
      SD1=SSD1
      SD2=SSD2
      ITYP=1
1000  CONTINUE
      MDOC=0
      IERR=0
      IF(MT.EQ.0) RETURN
      IF((ABS(IHH).GT.511.OR.ABS(IKK).GT.511.OR.ABS(ILL).GT.511). 
     * AND.IEND.LE.0) GO TO 77777
      IF(IEND.GT.0) THEN
        IHH=512
        IKK=512
        ILL=512
        NUMB=0
        FAA=0.
        FBB=0.
        SD1=0.
        SD2=0.
      ENDIF
      JTYP=0
      IF(IEND.LT.0) FIRST=.TRUE.
      IF(.NOT.FIRST) GO TO 10
      M=IND
C      NUMB=0
      IEND=0
      I=0
      FIRST=.FALSE.
10    I=I+1
      IF(I.GT.M.OR.I.LE.0) GO TO 99999
      IF(NUMB.GE.0.AND.NUMB.LE.31) THEN
        ILLL=NUMB*1024+ILL
      ELSE
        ILLL=ILL
      ENDIF
      IH(I)=IHH
      IK(I)=IKK
      IL(I)=ILLL
      IF(ITYP.EQ.0) THEN
        FA(I)=FAA
        FB(I)=FBB
      ELSE
        IF(FAA.GT.1.E-6) THEN
          FA(I)=FAA
          IF(FBB.GT.1.E-6) THEN
            JTYP=1
            FB(I)=-SD1-3.0
          ELSE
            FB(I)= SD1+3.0
          ENDIF
        ELSE
          IF(FBB.GT.1.E-6) THEN
            FA(I)=-FBB
            FB(I)= SD2+3.0
          ELSE
            I=I-1
            GO TO 300
          ENDIF
        ENDIF
      ENDIF
      IF(IEND.GT.0) THEN
        M=I
      ELSE
C        NUMB=NUMB+1
        IF(I.LT.M) GO TO 2000
      ENDIF
C N    CALL WFILE(MT,0,IBUF4,-1, 512)
C N    IF(ERRCODE.NE.0) THEN
C N      CALL ERMSG(ERRCODE)
C N      GO TO 88888
C N    ENDIF
      WRITE(MT,ERR=88888) IBUF4
      I=0
2000  IF(ITYP.EQ.0) THEN
        IF(IEND.EQ.2) THEN
          END FILE MT
          CLOSE(MT)
        ENDIF
        RETURN
      ENDIF
      IF(JTYP.EQ.0) THEN
        IF(IEND.EQ.2) THEN
          END FILE MT
          CLOSE(MT)
        ENDIF
        RETURN
      ENDIF
      I=I+1
      IF(I.GT.M.OR.I.LE.0) GO TO 99999
      IH(I)=IHH
      IK(I)=IKK
      IL(I)=ILLL
      FA(I)=-FBB
      FB(I)= SD2+3.0
      IF(IEND.GT.0) THEN
        M=I
      ELSE
        IF(I.LT.M) GO TO 300
      ENDIF
C N    CALL WFILE(MT,0,IBUF4,-1, 512)
C N    IF(ERRCODE.NE.0) THEN
C N      CALL ERMSG(ERRCODE)
C N      GO TO 88888
C N    ENDIF
      WRITE(MT,ERR=88888) IBUF4
      I=0
300   IF(IEND.EQ.2) THEN
        END FILE MT
        CLOSE(MT)
      ENDIF
      RETURN
C ---------------------------------------
99999 CONTINUE
88888 CONTINUE
      CALL MSGERR(MDOC,' ERR: SUBROUTINE WRT1')
      CLOSE(MT)
      MT=0
      RETURN
77777 CONTINUE
      CALL MSGERR(MDOC,' WARNING: indeses > 511, will be ignored')
      RETURN
      END

C ******
      SUBROUTINE RD(MT,IHH,IKK,ILL,FAA,FBB,NUMB,IEND)
C
C     ENTRY RRD(MT,IHH,IKK,ILL,FAA,FBB,SD1,SD2,NUMB,IEND)
C
C -P- RD  - read from MT ;file of type:"F   ","PH  ","COEF","ALMN"
C -P- RRD - read from MT ;file of type:"FS  "
C
C     input    MT          - unit of file
C              IEND        = -1  initialization with first indices,
C                                then subroutine set IEND=0, NUMB=0
C     output : IHH,IKK,ILL - indices h, k, l
C              for type 'F   ' and 'FS  '
C                FAA         - structure factors F( h, k, l)
C                FBB         -                   F(-h,-k,-l)
C              only for type 'FS  '
C                SD1         - sigma F( h, k, l)
C                SD2                 F(-h,-k,-l)
C              for type 'PH  '
C                FAA         - M*cos(Phi)  M -figure of merit
C                FBB         - M*sin(Phi)
C              for type 'COEF'
C                for Patterson::
C                FAA         - (Fmod)**2
C                FBB           sigma (Fmod)**2
C                for Fourie
C                FAA         - Fmod*M*cos(Phi)
C                FBB         - Fmod*M*sin(Phi)
C              for type 'ALMN'
C                FAA         - Almn
C                FBB         - Blmn
C              IEND        =  0  normal, next indices
C                          =  1  last record.  
C                             indices IHH,IKK,ILL,FAA,FBB - can not be used.
C              NUMB        -  reflex counter
C                            in the first call /IEND=-1/ subroutine set = 0
C             output MT = 0 - means the error.
C ******
      PARAMETER ( NRMX2=512    )
      PARAMETER ( NRMAX=1024   )
      PARAMETER ( IND=146      )
      PARAMETER ( INDA=      1)
      PARAMETER ( INDB=IND*2+1)
      PARAMETER ( INDH=IND*4+1)
      PARAMETER ( INDK=IND*5+1)
      PARAMETER ( INDL=IND*6+1)
      PARAMETER ( INDM=IND*7+1)
      INTEGER*4 NUMB,ILLL
      REAL      FA(IND),FB(IND),FAA,FBB,SD1,SD2
      INTEGER*2 IH(IND),IK(IND),IL(IND)
      INTEGER*2 IBUF(NRMAX),M
      COMMON/COM_RD/IBUF4(NRMX2),I,FIRST
      INTEGER*4 IBUF4
      LOGICAL   FIRST
      EQUIVALENCE (IBUF(INDM),M),(IBUF(INDH),IH(1)),(IBUF(INDK),IK(1))
      EQUIVALENCE (IBUF(INDL),IL(1)),(IBUF(INDA),FA(1))
      EQUIVALENCE (IBUF(INDB),FB(1))
      EQUIVALENCE (IBUF(1),IBUF4(1))
C --------------------------------------
      ITYP=0
      GO TO 1000
C ====================================================================
      ENTRY RRD(MT,IHH,IKK,ILL,FAA,FBB,SD1,SD2,NUMB,IEND)
C ====================================================================
      ITYP=1
1000  JTYP=0
      MDOC=0
      IF(IEND.GT.0) RETURN
      IF(IEND.LT.0) FIRST=.TRUE.
      IF(.NOT.FIRST) GO TO 10
      M=0
      NUMB=0
      IEND=0
      I=0
      FIRST=.FALSE.
10    IF(I.LT.M) GO TO 20

      READ(MT,ERR=99999,END=88888) IBUF4

      I=0
20    I=I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH=IH(I)
      IF(IHH.LT.512) GO TO 30
      IEND=1
      RETURN

30    IKK=IK(I)
      ILLL=IL(I)
      NUMB=ILLL/1024
      ILL=ILLL-NUMB*1024

      IF(ITYP.EQ.0) THEN
        FAA=FA(I)
        FBB=FB(I)
      ELSE
        IF(FA(I).GT.0.) THEN
          FAA=FA(I)
          IF(FB(I).GT.0.) THEN
            SD1=FB(I)-3.
            FBB=0.
            SD2=0.
          ELSE
            JTYP=1
            SD1=ABS(FB(I))-3.
          ENDIF
        ELSE
          FAA=0.
          SD1=0.
          FBB=ABS(FA(I))
          SD2=ABS(FB(I))-3.
        ENDIF
      ENDIF
C      NUMB=NUMB+1
      IF(JTYP.EQ.0) RETURN
      IF(I.LT.M) GO TO 40

      READ(MT,ERR=99999,END=88888) IBUF4

      I=0
40    I=I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH=IH(I)
      IF(IHH.LT.512) GO TO 50
      IEND=1
      RETURN

50    CONTINUE
      IKK =IK(I)
      ILLL=IL(I)
      NUMB=ILLL/1024
      ILL=ILLL-NUMB*1024
      FBB=ABS(FA(I))
      SD2=ABS(FB(I))-3.
      RETURN
C ---------------------------------------
99999 CONTINUE
      CALL MSGERR(MDOC,' ERR: SUBROUTINE RD')
      CLOSE(MT)
      MT=0
88888 CONTINUE      
      IEND=1
      RETURN
      END

C ******
      SUBROUTINE RD1(MT,IHH,IKK,ILL,FAA,FBB,NUMB,IEND)
C
C     ENTRY RRD1(MT,IHH,IKK,ILL,FAA,FBB,SD1,SD2,NUMB,IEND)
C
C -P- RD1 - read from MT ;file of type:"F   ","PH  ","COEF","ALMN"
C -P- RRD1- read from MT ;file of type:"FS  "
C ******
      PARAMETER ( NRMX2=512    )
      PARAMETER ( NRMAX=1024   )
      PARAMETER ( IND=146      )
      PARAMETER ( INDA=      1)
      PARAMETER ( INDB=IND*2+1)
      PARAMETER ( INDH=IND*4+1)
      PARAMETER ( INDK=IND*5+1)
      PARAMETER ( INDL=IND*6+1)
      PARAMETER ( INDM=IND*7+1)
      INTEGER*4 NUMB,ILLL
      REAL      FA(IND),FB(IND),FAA,FBB,SD1,SD2
      INTEGER*2 IH(IND),IK(IND),IL(IND)
      INTEGER*2 IBUF(NRMAX),M
      COMMON/COM_RD1/IBUF4(NRMX2),I,FIRST
      INTEGER*4 IBUF4
      LOGICAL   FIRST
      EQUIVALENCE (IBUF(INDM),M),(IBUF(INDH),IH(1)),(IBUF(INDK),IK(1))
      EQUIVALENCE (IBUF(INDL),IL(1)),(IBUF(INDA),FA(1))
      EQUIVALENCE (IBUF(INDB),FB(1))
      EQUIVALENCE (IBUF(1),IBUF4(1))
C ---------------------------------------------------
      ITYP=0
      GO TO 1000
C ====================================================================
      ENTRY RRD1(MT,IHH,IKK,ILL,FAA,FBB,SD1,SD2,NUMB,IEND)
C ====================================================================
      ITYP=1
1000  JTYP=0
      MDOC=0
      IF(IEND.GT.0) RETURN
      IF(IEND.LT.0) FIRST=.TRUE.
      IF(.NOT.FIRST) GO TO 10
      M=0
      NUMB=0
      IEND=0
      I=0
      FIRST=.FALSE.
10    IF(I.LT.M) GO TO 20

      READ(MT,ERR=99999,END=88888) IBUF4

      I=0
20    I=I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH=IH(I)
      IF(IHH.LT.512) GO TO 30
      IEND=1
      RETURN

30    IKK =IK(I)
      ILLL=IL(I)
      NUMB=ILLL/1024
      ILL=ILLL-NUMB*1024
      IF(ITYP.EQ.0) THEN
        FAA=FA(I)
        FBB=FB(I)
      ELSE
        IF(FA(I).GT.0.) THEN
          FAA=FA(I)
          IF(FB(I).GT.0.) THEN
            SD1=FB(I)-3.
            FBB=0.
            SD2=0.
          ELSE
            JTYP=1
            SD1=ABS(FB(I))-3.
          ENDIF
        ELSE
          FAA=0.
          SD1=0.
          FBB=ABS(FA(I))
          SD2=ABS(FB(I))-3.
        ENDIF
      ENDIF
C      NUMB=NUMB+1
      IF(JTYP.EQ.0) RETURN
      IF(I.LT.M) GO TO 40

      READ(MT,ERR=99999,END=88888) IBUF4

      I=0
40    I=I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH=IH(I)
      IF(IHH.LT.512) GO TO 50
      IEND=1
      RETURN

50    CONTINUE
      IKK=IK(I)
      ILLL=IL(I)
      NUMB=ILLL/1024
      ILL=ILLL-NUMB*1024
      FBB=ABS(FA(I))
      SD2=ABS(FB(I))-3.
      RETURN
C ---------------------------------------
99999 CONTINUE
      CALL MSGERR(MDOC,' ERR: SUBROUTINE RD1')
      CLOSE(MT)
      MT=0
88888 CONTINUE      
      IEND=1
      RETURN
      END

C ******
      SUBROUTINE RD2(MT,IHH,IKK,ILL,FAA,FBB,NUMB,IEND)
C
C     ENTRY RRD2(MT,IHH,IKK,ILL,FAA,FBB,SD1,SD2,NUMB,IEND)
C
C -P- RD2 - read from MT ;file of type:"F   ","PH  ","COEF","ALMN"
C -P- RRD2- read from MT ;file of type:"FS  "
C ******
      PARAMETER ( NRMX2=512    )
      PARAMETER ( NRMAX=1024   )
      PARAMETER ( IND=146      )
      PARAMETER ( INDA=      1)
      PARAMETER ( INDB=IND*2+1)
      PARAMETER ( INDH=IND*4+1)
      PARAMETER ( INDK=IND*5+1)
      PARAMETER ( INDL=IND*6+1)
      PARAMETER ( INDM=IND*7+1)
      INTEGER*4 NUMB,ILLL
      REAL      FA(IND),FB(IND),FAA,FBB,SD1,SD2
      INTEGER*2 IH(IND),IK(IND),IL(IND)
      INTEGER*2 IBUF(NRMAX),M
      COMMON/COM_RD2/IBUF4(NRMX2),I,FIRST
      INTEGER*4 IBUF4
      LOGICAL   FIRST
      EQUIVALENCE (IBUF(INDM),M),(IBUF(INDH),IH(1)),(IBUF(INDK),IK(1))
      EQUIVALENCE (IBUF(INDL),IL(1)),(IBUF(INDA),FA(1))
      EQUIVALENCE (IBUF(INDB),FB(1))
      EQUIVALENCE (IBUF(1),IBUF4(1))
C --------------------------------------------------------
      ITYP=0
      GO TO 1000
C ====================================================================
      ENTRY RRD2(MT,IHH,IKK,ILL,FAA,FBB,SD1,SD2,NUMB,IEND)
C ====================================================================
      ITYP=1
1000  JTYP=0
      MDOC=0
      IF(IEND.GT.0) RETURN
      IF(IEND.LT.0) FIRST=.TRUE.
      IF(.NOT.FIRST) GO TO 10
      M=0
      NUMB=0
      IEND=0
      I=0
      FIRST=.FALSE.
10    IF(I.LT.M) GO TO 20

      READ(MT,ERR=99999,END=88888) IBUF4

      I=0
20    I=I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH=IH(I)
      IF(IHH.LT.512) GO TO 30
      IEND=1
      RETURN
30    IKK=IK(I)
      ILLL=IL(I)
      NUMB=ILLL/1024
      ILL=ILLL-NUMB*1024
      IF(ITYP.EQ.0) THEN
        FAA=FA(I)
        FBB=FB(I)
      ELSE
        IF(FA(I).GT.0.) THEN
          FAA=FA(I)
          IF(FB(I).GT.0.) THEN
            SD1=FB(I)-3.
            FBB=0.
            SD2=0.
          ELSE
            JTYP=1
            SD1=ABS(FB(I))-3.
          ENDIF
        ELSE
          FAA=0.
          SD1=0.
          FBB=ABS(FA(I))
          SD2=ABS(FB(I))-3.
        ENDIF
      ENDIF
C      NUMB=NUMB+1
      IF(JTYP.EQ.0) RETURN
      IF(I.LT.M) GO TO 40

      READ(MT,ERR=99999,END=88888) IBUF4

      I=0
40    I=I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH=IH(I)
      IF(IHH.LT.512) GO TO 50
      IEND=1
      RETURN
50    CONTINUE
      IKK=IK(I)
      ILLL=IL(I)
      NUMB=ILLL/1024
      ILL=ILLL-NUMB*1024
      FBB=ABS(FA(I))
      SD2=ABS(FB(I))-3.
      RETURN
C ---------------------------------------
99999 CONTINUE
      CALL MSGERR(MDOC,' ERR: SUBROUTINE RD2')
      CLOSE(MT)
      MT=0
88888 CONTINUE      
      IEND=1
      RETURN
      END

C ******
      SUBROUTINE RD3(MT,IHH,IKK,ILL,FAA,FBB,NUMB,IEND)
C
C     ENTRY RRD3(MT,IHH,IKK,ILL,FAA,FBB,SD1,SD2,NUMB,IEND)
C
C -P- RD3 - read from MT ;file of type:"F   ","PH  ","COEF","ALMN"
C -P- RRD3- read from MT ;file of type:"FS  "
C ******
      PARAMETER ( NRMX2=512    )
      PARAMETER ( NRMAX=1024   )
      PARAMETER ( IND=146      )
      PARAMETER ( INDA=      1)
      PARAMETER ( INDB=IND*2+1)
      PARAMETER ( INDH=IND*4+1)
      PARAMETER ( INDK=IND*5+1)
      PARAMETER ( INDL=IND*6+1)
      PARAMETER ( INDM=IND*7+1)
      INTEGER*4 NUMB,ILLL
      REAL      FA(IND),FB(IND),FAA,FBB,SD1,SD2
      INTEGER*2 IH(IND),IK(IND),IL(IND)
      INTEGER*2 IBUF(NRMAX),M
      COMMON/COM_RD3/IBUF4(NRMX2),I,FIRST
      INTEGER*4 IBUF4
      LOGICAL    FIRST
      EQUIVALENCE (IBUF(INDM),M),(IBUF(INDH),IH(1)),(IBUF(INDK),IK(1))
      EQUIVALENCE (IBUF(INDL),IL(1)),(IBUF(INDA),FA(1))
      EQUIVALENCE (IBUF(INDB),FB(1))
      EQUIVALENCE (IBUF(1),IBUF4(1))
C ------------------------------------------------------------
      ITYP=0
      GO TO 1000
C ====================================================================
      ENTRY RRD3(MT,IHH,IKK,ILL,FAA,FBB,SD1,SD2,NUMB,IEND)
C ====================================================================
      ITYP=1
1000  JTYP=0
      MDOC=0
      IF(IEND.GT.0) RETURN
      IF(IEND.LT.0) FIRST=.TRUE.
      IF(.NOT.FIRST) GO TO 10
      M=0
      NUMB=0
      IEND=0
      I=0
      FIRST=.FALSE.
10    IF(I.LT.M) GO TO 20

      READ(MT,ERR=99999,END=88888) IBUF4

      I=0
20    I=I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH=IH(I)
      IF(IHH.LT.512) GO TO 30
      IEND=1
      RETURN
30    IKK=IK(I)
      ILLL=IL(I)
      NUMB=ILLL/1024
      ILL=ILLL-NUMB*1024
      IF(ITYP.EQ.0) THEN
        FAA=FA(I)
        FBB=FB(I)
      ELSE
        IF(FA(I).GT.0.) THEN
          FAA=FA(I)
          IF(FB(I).GT.0.) THEN
            SD1=FB(I)-3.
            FBB=0.
            SD2=0.
          ELSE
            JTYP=1
            SD1=ABS(FB(I))-3.
          ENDIF
        ELSE
          FAA=0.
          SD1=0.
          FBB=ABS(FA(I))
          SD2=ABS(FB(I))-3.
        ENDIF
      ENDIF
C      NUMB=NUMB+1
      IF(JTYP.EQ.0) RETURN
      IF(I.LT.M) GO TO 40

      READ(MT,ERR=99999,END=88888) IBUF4

      I=0
40    I=I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH=IH(I)
      IF(IHH.LT.512) GO TO 50
      IEND=1
      RETURN
50    CONTINUE
      IKK=IK(I)
      ILLL=IL(I)
      NUMB=ILLL/1024
      ILL=ILLL-NUMB*1024
      FBB=ABS(FA(I))
      SD2=ABS(FB(I))-3.
      RETURN
C ---------------------------------------
99999 CONTINUE
      CALL MSGERR(MDOC,' ERR: SUBROUTINE RD3')
      CLOSE(MT)
      MT=0

88888 CONTINUE      
      IEND=1
      RETURN
      END
C ******
      SUBROUTINE RD4(MT,IHH,IKK,ILL,FAA,FBB,NUMB,IEND)
C
C     ENTRY RRD4(MT,IHH,IKK,ILL,FAA,FBB,SD1,SD2,NUMB,IEND)
C
C -P- RD4 - read from MT ;file of type:"F   ","PH  ","COEF","ALMN"
C -P- RRD4- read from MT ;file of type:"FS  "
C ******
      PARAMETER ( NRMX2=512    )
      PARAMETER ( NRMAX=1024   )
      PARAMETER ( IND=146      )
      PARAMETER ( INDA=      1)
      PARAMETER ( INDB=IND*2+1)
      PARAMETER ( INDH=IND*4+1)
      PARAMETER ( INDK=IND*5+1)
      PARAMETER ( INDL=IND*6+1)
      PARAMETER ( INDM=IND*7+1)
      INTEGER*4 NUMB,ILLL
      REAL      FA(IND),FB(IND),FAA,FBB,SD1,SD2
      INTEGER*2 IH(IND),IK(IND),IL(IND)
      INTEGER*2 IBUF(NRMAX),M
      COMMON/COM_RD4/IBUF4(NRMX2),I,FIRST
      INTEGER*4 IBUF4
      LOGICAL    FIRST
      EQUIVALENCE (IBUF(INDM),M),(IBUF(INDH),IH(1)),(IBUF(INDK),IK(1))
      EQUIVALENCE (IBUF(INDL),IL(1)),(IBUF(INDA),FA(1))
      EQUIVALENCE (IBUF(INDB),FB(1))
      EQUIVALENCE (IBUF(1),IBUF4(1))
C ------------------------------------------------------------
      ITYP=0
      GO TO 1000
C ====================================================================
      ENTRY RRD4(MT,IHH,IKK,ILL,FAA,FBB,SD1,SD2,NUMB,IEND)
C ====================================================================
      ITYP=1
1000  JTYP=0
      MDOC=0
      IF(IEND.GT.0) RETURN
      IF(IEND.LT.0) FIRST=.TRUE.
      IF(.NOT.FIRST) GO TO 10
      M=0
      NUMB=0
      IEND=0
      I=0
      FIRST=.FALSE.
10    IF(I.LT.M) GO TO 20

      READ(MT,ERR=99999,END=88888) IBUF4

      I=0
20    I=I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH=IH(I)
      IF(IHH.LT.512) GO TO 30
      IEND=1
      RETURN
30    IKK=IK(I)
      ILLL=IL(I)
      NUMB=ILLL/1024
      ILL=ILLL-NUMB*1024
      IF(ITYP.EQ.0) THEN
        FAA=FA(I)
        FBB=FB(I)
      ELSE
        IF(FA(I).GT.0.) THEN
          FAA=FA(I)
          IF(FB(I).GT.0.) THEN
            SD1=FB(I)-3.
            FBB=0.
            SD2=0.
          ELSE
            JTYP=1
            SD1=ABS(FB(I))-3.
          ENDIF
        ELSE
          FAA=0.
          SD1=0.
          FBB=ABS(FA(I))
          SD2=ABS(FB(I))-3.
        ENDIF
      ENDIF
C      NUMB=NUMB+1
      IF(JTYP.EQ.0) RETURN
      IF(I.LT.M) GO TO 40

      READ(MT,ERR=99999,END=88888) IBUF4

      I=0
40    I=I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH=IH(I)
      IF(IHH.LT.512) GO TO 50
      IEND=1
      RETURN
50    CONTINUE
      IKK=IK(I)
      ILLL=IL(I)
      NUMB=ILLL/1024
      ILL=ILLL-NUMB*1024
      FBB=ABS(FA(I))
      SD2=ABS(FB(I))-3.
      RETURN
C ---------------------------------------
99999 CONTINUE
      CALL MSGERR(MDOC,' ERR: SUBROUTINE RD3')
      CLOSE(MT)
      MT=0
88888 CONTINUE      
      IEND=1
      RETURN
      END

C ******
      SUBROUTINE WABCD(MT,IHH,IKK,ILL,FAA,FBB,FCC,FDD,NUMB,IEND)
C
C -P- WABCD -  writes to MT file of type:"ABCD"
C
C      input : IHH,IKK,ILL - indices h, k, l
C                FAA         -  A  coefficients Hendrickson-Lattman
C                FBB         -  B                             
C                FCC         -  C                             
C                FDD         -  D                             
C              IEND    = -1 first indices, then subroutine set IEND=0
C                      =  0 normal write next indices
C                      =  1 last indices, IHH,IKK,ILL,FAA,FBB,FCC,FDD-not used
C                      =  2 last indices and close file.
C   output :   NUMB    -  reflex counter
C                         in the first call subroutine set NUMB = 0
C              MT = 0 - error
C ******
C------------------------------------------------------------------
      PARAMETER ( NWMX2=512    )
      PARAMETER ( NWMAX=1024   )
      PARAMETER ( IND=146      )
      PARAMETER ( INDA=      1)
      PARAMETER ( INDB=IND*2+1)
      PARAMETER ( INDH=IND*4+1)
      PARAMETER ( INDK=IND*5+1)
      PARAMETER ( INDL=IND*6+1)
      PARAMETER ( INDM=IND*7+1)
      INTEGER*4 NUMB,ILLL
      REAL      FA(IND),FB(IND),FAA,FBB,FCC,FDD
      INTEGER*2 IH(IND),IK(IND),IL(IND)
      INTEGER*2 IBUF(NWMAX),M
      COMMON/COM_WAB/IBUF4(NWMX2),I,FIRST
      INTEGER*4 IBUF4
      LOGICAL   FIRST
      EQUIVALENCE (IBUF(INDM),M),(IBUF(INDH),IH(1)),(IBUF(INDK),IK(1))
      EQUIVALENCE (IBUF(INDL),IL(1)),(IBUF(INDA),FA(1))
      EQUIVALENCE (IBUF(INDB),FB(1))
      EQUIVALENCE (IBUF(1),IBUF4(1))
C ---------------------------------------------------------------------
      MDOC=0
      IF(MT.EQ.0) RETURN
      IF((ABS(IHH).GT.511.OR.ABS(IKK).GT.511.OR.ABS(ILL).GT.511). 
     * AND.IEND.LE.0) GO TO 77777
      IF(IEND.GT.0) THEN
        IHH=512
        IKK=512
        ILL=512
        NUMB=0
        FAA=0.
        FBB=0.
        FCC=0.
        FDD=0.
      ENDIF
      IF(IEND.LT.0) FIRST=.TRUE.
      IF(.NOT.FIRST) GO TO 10
      M=IND
C      NUMB=0
      IEND=0
      I=0
      FIRST=.FALSE.
10    I=I+1       
      IF(I.GT.M.OR.I.LE.0) GO TO 99999
      IF(NUMB.GE.0.AND.NUMB.LE.31) THEN
        ILLL=NUMB*1024+ILL
      ELSE
        ILLL=ILL
      ENDIF
      IH(I)=IHH     
      IK(I)=IKK
      IL(I)=ILLL
      FA(I)=FAA
      FB(I)=FBB
      IF(IEND.GT.0) THEN        
        M=I         
      ELSE
C        NUMB=NUMB+1
        IF(I.LT.M) GO TO 2000
      ENDIF
C N    CALL WFILE(MT,0,IBUF4,-1, 512)
C N      IF(ERRCODE.NE.0) THEN
C N      CALL ERMSG(ERRCODE)
C N      GO TO 88888
C N    ENDIF
      WRITE(MT,ERR=88888) IBUF4
      I=0
2000  CONTINUE 
      I=I+1       
      IF(I.GT.M.OR.I.LE.0) GO TO 99999
      IH(I)=IHH     
      IK(I)=IKK
      IL(I)=ILLL
      FA(I)=FCC
      FB(I)=FDD
      IF(IEND.GT.0) THEN        
        M=I         
      ELSE
        IF(I.LT.M) THEN
          IF(IEND.EQ.2) THEN
            END FILE MT
            CLOSE(MT)
          ENDIF
          RETURN
        ENDIF     
      ENDIF
C N    CALL WFILE(MT,0,IBUF4,-1, 512)
C N      IF(ERRCODE.NE.0) THEN
C N      CALL ERMSG(ERRCODE)
C N      GO TO 88888
C N    ENDIF
      WRITE(MT,ERR=88888) IBUF4
      I=0
      IF(IEND.EQ.2) THEN
        END FILE MT
        ITM=1
        CLOSE(MT)
      ENDIF
      RETURN
C -----------------------------------
99999 CONTINUE
88888 CONTINUE
      CALL MSGERR(MDOC,' ERR: SUBROUTINE WABCD')
      CLOSE(MT)
      MT=0
      RETURN
77777 CONTINUE
      CALL MSGERR(MDOC,' WARNING: indeses > 511, will be ignored')
      RETURN
      END

C ******
      SUBROUTINE WABCD1(MT,IHH,IKK,ILL,FAA,FBB,FCC,FDD,NUMB,IEND)
C
C -P- WABCD1 - writes to MT_file /type:"ABCD"/
C ******
C------------------------------------------------------------------
      PARAMETER ( NWMX2=512    )
      PARAMETER ( NWMAX=1024   )
      PARAMETER ( IND=146      )
      PARAMETER ( INDA=      1)
      PARAMETER ( INDB=IND*2+1)
      PARAMETER ( INDH=IND*4+1)
      PARAMETER ( INDK=IND*5+1)
      PARAMETER ( INDL=IND*6+1)
      PARAMETER ( INDM=IND*7+1)
      INTEGER*4 NUMB,ILLL
      REAL      FA(IND),FB(IND),FAA,FBB,FCC,FDD
      INTEGER*2 IH(IND),IK(IND),IL(IND)
      INTEGER*2 IBUF(NWMAX),M
      COMMON/COM_WA1/IBUF4(NWMX2),I,FIRST
      INTEGER*4 IBUF4
      LOGICAL   FIRST
      EQUIVALENCE (IBUF(INDM),M),(IBUF(INDH),IH(1)),(IBUF(INDK),IK(1))
      EQUIVALENCE (IBUF(INDL),IL(1)),(IBUF(INDA),FA(1))
      EQUIVALENCE (IBUF(INDB),FB(1))
      EQUIVALENCE (IBUF(1),IBUF4(1))
C ---------------------------------------------------------------------
      MDOC=0
      IF(MT.EQ.0) RETURN
      IF((ABS(IHH).GT.511.OR.ABS(IKK).GT.511.OR.ABS(ILL).GT.511). 
     * AND.IEND.LE.0) GO TO 77777
      IF(IEND.GT.0) THEN
        IHH=512
        IKK=512
        ILL=512
        NUMB=0
        FAA=0.
        FBB=0.
        FCC=0.
        FDD=0.
      ENDIF
      IF(IEND.LT.0) FIRST=.TRUE.
      IF(.NOT.FIRST) GO TO 10
      M=IND
C      NUMB=0
      IEND=0
      I=0
      FIRST=.FALSE.
10    I=I+1       
      IF(I.GT.M.OR.I.LE.0) GO TO 99999
      IF(NUMB.GE.0.AND.NUMB.LE.31) THEN
        ILLL=NUMB*1024+ILL
      ELSE
        ILLL=ILL
      ENDIF
      IH(I)=IHH     
      IK(I)=IKK
      IL(I)=ILLL
      FA(I)=FAA
      FB(I)=FBB
      IF(IEND.GT.0) THEN        
        M=I         
      ELSE
C        NUMB=NUMB+1
        IF(I.LT.M) GO TO 2000
      ENDIF
C N    CALL WFILE(MT,0,IBUF4,-1, 512)
C N      IF(ERRCODE.NE.0) THEN
C N      CALL ERMSG(ERRCODE)
C N      GO TO 88888
C N    ENDIF
      WRITE(MT,ERR=88888) IBUF4
      I=0
2000  CONTINUE 
      I=I+1       
      IF(I.GT.M.OR.I.LE.0) GO TO 99999
      IH(I)=IHH     
      IK(I)=IKK
      IL(I)=ILLL
      FA(I)=FCC
      FB(I)=FDD
      IF(IEND.GT.0) THEN        
        M=I         
      ELSE
        IF(I.LT.M) THEN
          IF(IEND.EQ.2) THEN
            END FILE MT
            CLOSE(MT)
          ENDIF
          RETURN
        ENDIF     
      ENDIF
C N    CALL WFILE(MT,0,IBUF4,-1, 512)
C N      IF(ERRCODE.NE.0) THEN
C N      CALL ERMSG(ERRCODE)
C N      GO TO 88888
C N    ENDIF
      WRITE(MT,ERR=88888) IBUF4
      I=0
      IF(IEND.EQ.2) THEN
        END FILE MT
        CLOSE(MT)
      ENDIF
      RETURN
C -----------------------------------
99999 CONTINUE
88888 CONTINUE
      CALL MSGERR(MDOC,' ERR: SUBROUTINE WABCD1')
      CLOSE(MT)
      MT=0
      RETURN
77777 CONTINUE
      CALL MSGERR(MDOC,' WARNING: indeses > 511, will be ignored')
      RETURN
      END

C ******
      SUBROUTINE RABCD(MT,IHH,IKK,ILL,FAA,FBB,FCC,FDD,NUMB,IEND)
C
C -P- RABCD - reads coef ABCD from MT_file /type:"ABCD"/
C
C     output : IHH,IKK,ILL - indices h, k, l
C                FAA         -  A  coefficients Hendrickson-Lattman
C                FBB         -  B                             
C                FCC         -  C                             
C                FDD         -  D                             
C              IEND  = -1  first read, then subroutine set IEND = 0
C                    =  0  normal read next indices IHH,IKK,ILL 
C                    =  1 last indices, IHH,IKK,ILL,FAA,FBB,FCC,FDD -not used
C    output :  NUMB  -  reflex counter
C                       in the first call set = 0
C              MT = 0 - error. 
C ******
C------------------------------------------------------------------
      PARAMETER (NRMX2=512    )
      PARAMETER (NRMAX=1024   )
      PARAMETER (IND=146      )
      PARAMETER ( INDA=      1)
      PARAMETER ( INDB=IND*2+1)
      PARAMETER ( INDH=IND*4+1)
      PARAMETER ( INDK=IND*5+1)
      PARAMETER ( INDL=IND*6+1)
      PARAMETER ( INDM=IND*7+1)
      INTEGER*4 NUMB,ILLL
      REAL      FA(IND),FB(IND),FAA,FBB,FCC,FDD
      INTEGER*2 IH(IND),IK(IND),IL(IND)
      INTEGER*2 IBUF(NRMAX),M
      COMMON/COM_RAB/IBUF4(NRMX2),I,FIRST
      INTEGER*4 IBUF4
      LOGICAL   FIRST
      EQUIVALENCE (IBUF(INDM),M),(IBUF(INDH),IH(1)),(IBUF(INDK),IK(1))
      EQUIVALENCE (IBUF(INDL),IL(1)),(IBUF(INDA),FA(1))
      EQUIVALENCE (IBUF(INDB),FB(1))
      EQUIVALENCE (IBUF(1),IBUF4(1))
C ---------------------------------------------------------------------
      MDOC=0
      IF(IEND.GT.0) RETURN
      IF(IEND.LT.0) FIRST=.TRUE.
      IF(.NOT.FIRST) GO TO 10
      M=0
      NUMB=0
      IEND=0
      I=0
      FIRST=.FALSE.
10    IF(I.LT.M) GO TO 20

      READ(MT,ERR=99999,END=88888) IBUF4

      I=0
20    I=I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH=IH(I)
      IF(IHH.LT.512) GO TO 30
      IEND=1
      RETURN
30    IKK=IK(I)
      ILLL=IL(I)
      NUMB=ILLL/1024
      ILL=ILLL-NUMB*1024
      FAA=FA(I)
      FBB=FB(I)
C      NUMB=NUMB+1
      IF(I.LT.M) GO TO 40

      READ(MT,ERR=99999,END=88888) IBUF4

      I=0
40    I=I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH=IH(I)
      IF(IHH.LT.512) GO TO 50
      IEND=1
      RETURN
50    CONTINUE 
      FCC=FA(I)
      FDD=FB(I)
      RETURN
C ---------------------------
99999 CONTINUE
      CALL MSGERR(MDOC,' ERR: SUBROUTINE RABCD')
      CLOSE(MT)
      MT=0
88888 CONTINUE
      IEND=1
      RETURN
      END

C ******
      SUBROUTINE RABCD1(MT,IHH,IKK,ILL,FAA,FBB,FCC,FDD,NUMB,IEND)
C
C -P- RABCD1 - read ABCD from MT_file /type:"ABCD"/
C ******
C------------------------------------------------------------------
      PARAMETER (NRMX2=512    )
      PARAMETER (NRMAX=1024   )
      PARAMETER (IND=146      )
      PARAMETER ( INDA=      1)
      PARAMETER ( INDB=IND*2+1)
      PARAMETER ( INDH=IND*4+1)
      PARAMETER ( INDK=IND*5+1)
      PARAMETER ( INDL=IND*6+1)
      PARAMETER ( INDM=IND*7+1)
      INTEGER*4 NUMB,ILLL
      REAL      FA(IND),FB(IND),FAA,FBB,FCC,FDD
      INTEGER*2 IH(IND),IK(IND),IL(IND)
      INTEGER*2 IBUF(NRMAX),M
      COMMON/COM_RA1/IBUF4(NRMX2),I,FIRST
      INTEGER*4 IBUF4
      LOGICAL   FIRST
      EQUIVALENCE (IBUF(INDM),M),(IBUF(INDH),IH(1)),(IBUF(INDK),IK(1))
      EQUIVALENCE (IBUF(INDL),IL(1)),(IBUF(INDA),FA(1))
      EQUIVALENCE (IBUF(INDB),FB(1))
      EQUIVALENCE (IBUF(1),IBUF4(1))
C ---------------------------------------------------------------------
      MDOC=0
      IF(IEND.GT.0) RETURN
      IF(IEND.LT.0) FIRST=.TRUE.
      IF(.NOT.FIRST) GO TO 10
      M=0
      NUMB=0
      IEND=0
      I=0
      FIRST=.FALSE.
10    IF(I.LT.M) GO TO 20

      READ(MT,ERR=99999,END=88888) IBUF4

      I=0
20    I=I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH=IH(I)
      IF(IHH.LT.512) GO TO 30
      IEND=1
      RETURN
30    IKK=IK(I)
      ILLL=IL(I)
      NUMB=ILLL/1024
      ILL=ILLL-NUMB*1024
      FAA=FA(I)
      FBB=FB(I)
C      NUMB=NUMB+1
      IF(I.LT.M) GO TO 40

      READ(MT,ERR=99999,END=88888) IBUF4

      I=0
40    I=I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH=IH(I)
      IF(IHH.LT.512) GO TO 50
      IEND=1
      RETURN
50    CONTINUE 
      FCC=FA(I)
      FDD=FB(I)
      RETURN
C ---------------------------
99999 CONTINUE
      CALL MSGERR(MDOC,' ERR: SUBROUTINE RABCD1')
      CLOSE(MT)
      MT=0
88888 CONTINUE
      IEND=1
      RETURN
      END

C ******
      SUBROUTINE BYTARR(MDOC,IMODE,FNAME,POOL,IPRPLN,IR,IPRMEM,ZMINTS
     *   ,KX,KY,KZ,KZMIN,KZMAX,AR,BR,CR,ALR,BER,GAR
     *   ,RMAX,RMIN_INP,R000,SCALE
     *   ,RLIM,IX_MIN,IX_MAX,IY_MIN,IY_MAX,IZ_MIN,IZ_MAX
     *   ,POSITIV,PERCENT,ISYM,IPRSYM,IERR)
C ----------------------------------------------------------------------
C
C -P- BYTARR - reads electron-dens-file into byte-array IR
C
C input:
C  FNAME - file name. If FNAME = ' ' - FNAME,MSG,PERCENT will be
C                                            taken from terminal.
C  MDOC  - mode of writting messages to DOC-file
C                0 - only term, < - 0 only file, 0 < < 99 - both
C                >= 99 - not write  
C  IMODE=0
C
C         input    JX : from: 0 to: KX-1
C                  JY : from: 0 to: KY-1
C                  JZ : from: 0 to: KZMIN - KZMAX
C         output   ID        byte-array IR 
C                             / dimension KX,KY,KZMAX-KZMIN+1/
C
C  IMODE=1
C
C         KX - EVEN
C
C         input    JX : from: 0 to: KX/2
C                  JY : from: 0 to: KY-1
C                  JZ : from: 0 to: KZMAX-KZMIN
C         output   ID        byte-array IR 
C                             / dimension KX/2+1,KY,KZMAX-KZMIN+1/
C
C  IMODE=2
C
C         KX - EVEN
C         KY - EVEN
C
C         input    JX : from: 0 to: KX/2
C                  JY : from: 0 to: KY/2
C                  JZ : from: 0 to: KZMAX-KZMIN
C
C         output   ID        byte-array IR 
C
C   POSITIV /<'Y'>/ - using positive value only 
C
C   PERCENT        percent of R-MAX, if =0 take value from 
C                       title of file   
C                   RMAX - max value of dens in array IR
C
C      input file-DENS  cell : KX,KY,KZ, KZMIN=0 , KZMAX >= ZMINTS * KZ
C                             AR,BR,CR /angstroms/,ALR,BER,GAR /radians/
C
C ---------
C            DENS(JX,JY,JZ) --> ID/byte/ = (DENS-R000)/SCALE
C
C         output IERR > 0 is signal of error.
C ---------------------------------------------------------------------
CMS      : IR,POOL
      INTEGER*2 IR  (IPRMEM)
      INTEGER*2 POOL(IPRPLN)
      CHARACTER MSG*1,POSITIV*1
C ---
C ******
      CHARACTER TITLE*160,FNAME*(*),LINE*80
C ---------------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      MSG  = POSITIV
      MTIN = 31
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.0.AND.(FNAME(1:1).NE.','.OR.FNAME(1:1).NE.',')) THEN
        ITYPE  =0
        CALL IRDENS(MTIN,FNAME,MD,ITYPE,ICNTZ,KX,KY,KZ,KZMAX,
     *  KZMIN,RMAX,RMIN,POOL,SCALER,AR,BR,CR,ALR,BER,GAR,DRMS,
     *  RAVER,RESOL,JX0,JY0,JZ0,JTR,TITLE,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE-DENS')
          RETURN
        ENDIF
        KXY=KX*KY
        IF(KXY.GT.IPRPLN) THEN
        WRITE(LINE,'('' ERR: not memory '',I4,'' x'',I4,'' >'',I8)')
     *             KX,KY,IPRPLN
          CALL MSGERR(MDOC,LINE)
          CALL MSGERR(MDOC,
     *    '                  try to change resolution')
          CLOSE(MTIN)
          RETURN
        ENDIF
      ELSE
        IERR=1
        CALL MSGERR(MDOC,' ERR: OPEN FILE-DENS')
        RETURN
      ENDIF
C ---------------------------------------------------------------------
      ITESTZ=KZ*ZMINTS
      IF(KZMAX.LT.ITESTZ) THEN
        WRITE(TITLE,10) ITESTZ
 10     FORMAT(' ERR:   Z-MAX < ',I6)
        CALL MSGERR(MDOC,TITLE)
        CLOSE (MTIN)
        IERR=1
        RETURN
      ENDIF
      IF(KZMIN.NE.0) THEN
        CALL MSGERR(MDOC,' ERR:   Z-MIN NE 0')
        CLOSE (MTIN)
        IERR=1
        RETURN
      ENDIF
C ---------------------------------------------------------------------
      IF(IMODE.EQ.0) THEN
        KXYZ=(KXY*ITESTZ)/2+1
      ELSE IF(IMODE.EQ.1) THEN
        IT=MOD(KX,2)
        IF(IT.NE.0) THEN
          CALL MSGERR(MDOC,' ERR:  NX IS NOT EVEN')
          CLOSE (MTIN)
          IERR=1
          RETURN
        ENDIF
        KX2=KX/2
        KXYZ=((KX2+1)*KY*ITESTZ)/2+1
      ELSE IF(IMODE.EQ.2) THEN
        IT=MOD(KX,2)
        IF(IT.NE.0) THEN
          CALL MSGERR(MDOC,' ERR:  NX IS NOT EVEN')
          CLOSE (MTIN)
          IERR=1
          RETURN
        ENDIF
        IT=MOD(KY,2)
        IF(IT.NE.0) THEN
C          WRITE(*,*) ' ERR: NY IS NOT EVEN'
          CALL MSGERR(MDOC,' ERR: NY IS NOT EVEN')
          CLOSE (MTIN)
          IERR=1
          RETURN
        ENDIF
        KY2=KY/2
        KX2=KX/2
        KXYZ=((KX2+1)*(KY2+1)*ITESTZ)/2+1
      ENDIF
      IF(KXYZ.GT.IPRMEM) THEN
        WRITE(TITLE,30) IPRMEM
 30     FORMAT(' ERR:   NOT MEMORY FOR BYTE-ARRAY :',I6)
        CALL MSGERR(MDOC,TITLE)
        CLOSE (MTIN)
        IERR=1
        RETURN
      ENDIF
C --------------------------------------------
      R000=-RMIN          
      IF(RMIN_INP.GT.-1.0 E20) R000 = -RMIN_INP
      IF(MSG.EQ.'n') MSG='N'
      IF(MSG.NE.'N') R000=0.0             
C ---------------------------
      RRMAX=0.0
      IF(PERCENT.LE.0.0) PERCENT=100.
      RRMAX=RMAX*(PERCENT/100.)
      WRITE(TITLE,40) PERCENT
 40   FORMAT(' PERCENT OF R-MAX :',F10.5)
      CALL MSGDOC(MDOC,TITLE)
      WRITE(TITLE,50) RRMAX
 50   FORMAT(' R-MAX NOW :',F18.6)
      CALL MSGDOC(MDOC,TITLE)
      SCALE=(RRMAX+R000)/254.9
C --------------------------------------------
      IF(RLIM.LT.0.00001) THEN
c        RLIM = 1.0*SCALE-R000
        RLIM = SCALE

        RLIM = DRMS/2.0

c        RLIM = RLIM/2.0
      ELSE
        RLIM = RLIM*DRMS
      ENDIF
C --------------------------------------------
      IF(IMODE.EQ.0) THEN
        NX=KX
        NY=KY
      ELSE IF(IMODE.EQ.1) THEN
        NX=KX2+1
        NY=KY
      ELSE IF(IMODE.EQ.2) THEN
        NX=KX2+1
        NY=KY2+1
      ENDIF
C -------------------------------------------
      ITYPE=1
      IM=-1

      IX_MIN = KX
      IX_MAX = 0      
      IY_MIN = KY
      IY_MAX = 0      
      IZ_MIN = KZ
      IZ_MAX = 0      

      CALL SETDEN(IM,IX,IY,IZZ,ID,IR,KX,KY,KZ,KZMIN,KZMAX)
      DO     IZ=KZMIN,ITESTZ
        IZZ=IZ-KZMIN
        CALL IRDENS(MTIN,FNAME,MD,ITYPE,ICNTZ,KX,KY,KZ,KZMAX,
     *  KZMIN,RMAX,RMIN,POOL,SCALER,AR,BR,CR,ALR,BER,GAR,DRMS,
     *  RAVER,RESOL,JX0,JY0,JZ0,JTR,TITLE,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE-DENS')
          CLOSE(MTIN)
          RETURN
        ENDIF
        DO     IY=0,NY-1
          IND=IY*KX
          DO     IX=0,NX-1
            JND=IND+IX+1
            D =POOL(JND)/SCALER

            IF(D.GT.RLIM) THEN
              IF(IX.LT.IX_MIN) IX_MIN = IX
              IF(IX.GT.IX_MAX) IX_MAX = IX
              IF(IY.LT.IY_MIN) IY_MIN = IY
              IF(IY.GT.IY_MAX) IY_MAX = IY
              IF(IZ.LT.IZ_MIN) IZ_MIN = IZ
              IF(IZ.GT.IZ_MAX) IZ_MAX = IZ
            ENDIF


            ID=(D+R000)/SCALE
            IF(ID.LT.  0) ID=  0
            IF(ID.GT.255) ID=255
            CALL SETDEN(IMODE,IX,IY,IZZ,ID,IR,KX,KY,KZ,KZMIN,KZMAX)
          ENDDO
        ENDDO
      ENDDO            
      CLOSE (MTIN)
      RETURN
      END

C ******
      SUBROUTINE GETDNS(MDOC,IMODE,X,Y,Z,DENS,IR,NX,NY,NZ,NZMIN,NZMAX,
     *                  R000,SCALE,IERR)
C ------------------------------------------------------------------
C
C -P- GETDNS - get DENS from array IR-"byte"
C
C      input : X,Y,Z  -  >= 0  /in unit cell/
C                       NX,NY,NZ NZMIN-NZMAX  NZMIN=0
C
C      output: DENS   = ID/BYTE/ * SCALE - R000
C -------------------------------------------------------------------
C
C  IMODE=0
C         input    JX : from: 0 to: NX-1
C                  JY : from: 0 to: NY-1
C                  JZ : from: 0 to: NZMIN - NZMAX
C         output   ID   from byte-array IR 
C                             / dimension NX,NY,NZMAX-NZMIN+1/
C  IMODE=1
C         input    JX : from: 0 to: NX/2
C                  JY : from: 0 to: NY-1
C                  JZ : from: 0 to: NZMAX-NZMIN
C         output   ID   from byte-array IR 
C                             / dimension NX/2+1,NY,NZMAX-NZMIN+1/
C  IMODE=2
C         input    JX : from: 0 to: NX/2
C                  JY : from: 0 to: NY/2
C                  JZ : from: 0 to: NZMAX-NZMIN
C
C         output   DENS   from byte-array IR 
C                             / dimension NX/2+1,NY/2+1,NZMAX-NZMIN+1/
C         output IERR > 0 is signal of error.
C ------------------------------------------------------------------
CMS      : IR
      INTEGER*2 IR(*)
C ------------------------------------------------------------------
C ******
      IERR= 0
      MD  =-ABS(MDOC)-1
      IF(X.LT.0.0) THEN
        CALL MSGERR(MDOC,' ERR: IN SUBR "GETDNS" --> X < 0')
        IERR=1
        RETURN
      ENDIF
      IF(Y.LT.0.0) THEN
        CALL MSGERR(MDOC,' ERR: IN SUBR "GETDNS" --> Y < 0')
        IERR=1
        RETURN
      ENDIF
      IF(Z.LT.0.0) THEN
        CALL MSGERR(MDOC,' ERR: IN SUBR "GETDNS" --> Z < 0')
        IERR=1
        RETURN
      ENDIF
      NX2 = NX/2
      NY2 = NY/2
      IX  = X*NX
      IY  = Y*NY
      IZ  = Z*NZ
      AX  = X*NX-IX
      AY  = Y*NY-IY
      AZ  = Z*NZ-IZ
      IF(IZ .GT.NZMAX) IZ =NZMAX
      IF(IMODE.EQ.0) THEN
        IF(IX .GE.NX ) IX =0
        IF(IY .GE.NY ) IY =0
      ELSE IF(IMODE.EQ.1) THEN
        IF(IX .GT.NX2) IX =NX2
        IF(IY .GE.NY ) IY =0  
      ELSE IF(IMODE.EQ.2) THEN
        IF(IX .GT.NX2) IX =NX2
        IF(IY .GE.NY2) IY =NY2
      ENDIF
      IXX=IX+1
      IYY=IY+1
      IZZ=IZ+1
      IF(IZZ.GT.NZMAX) IZZ=NZMAX
      IF(IMODE.EQ.0) THEN
        IF(IXX.GE.NX ) IXX=0
        IF(IYY.GE.NY ) IYY=0
      ELSE IF(IMODE.EQ.1) THEN
        IF(IXX.GT.NX2) IXX=NX2
        IF(IYY.GE.NY ) IYY=0  
      ELSE IF(IMODE.EQ.2) THEN
        IF(IXX.GT.NX2) IXX=NX2
        IF(IYY.GE.NY2) IYY=NY2
      ENDIF
      AAX=1.0-AX
      AAY=1.0-AY
      AAZ=1.0-AZ
      CALL GTDENS(IMODE,IX ,IY ,IZ ,IDEN,IR,NX,NY,NZ,NZMIN,NZMAX)
      R111=IDEN
      CALL GTDENS(IMODE,IX ,IY ,IZZ,IDEN,IR,NX,NY,NZ,NZMIN,NZMAX)
      R112=IDEN
      CALL GTDENS(IMODE,IXX,IYY,IZ ,IDEN,IR,NX,NY,NZ,NZMIN,NZMAX)
      R221=IDEN
      CALL GTDENS(IMODE,IXX,IYY,IZZ,IDEN,IR,NX,NY,NZ,NZMIN,NZMAX)
      R222=IDEN
      CALL GTDENS(IMODE,IXX,IY ,IZ ,IDEN,IR,NX,NY,NZ,NZMIN,NZMAX)
      R211=IDEN
      CALL GTDENS(IMODE,IXX,IY ,IZZ,IDEN,IR,NX,NY,NZ,NZMIN,NZMAX)
      R212=IDEN
      CALL GTDENS(IMODE,IX ,IYY,IZ ,IDEN,IR,NX,NY,NZ,NZMIN,NZMAX)
      R121=IDEN
      CALL GTDENS(IMODE,IX ,IYY,IZZ,IDEN,IR,NX,NY,NZ,NZMIN,NZMAX)
      R122=IDEN
  
      R1=AAX*R111+AX*R211
      D1=AAX*R112+AX*R212
      R2=AAX*R121+AX*R221
      D2=AAX*R122+AX*R222
      RY=AAY*R1  +AY*R2
      DY=AAY*D1  +AY*D2
      DP=AAZ*RY  +AZ*DY

      DENS=DP*SCALE-R000

      RETURN
      END

C ******
      SUBROUTINE GTDENS(IMODE,JX,JY,JZ,ID,IR,NX,NY,NZ,NZMIN,NZMAX)
C -------------------------------------------------------------------
C     ==== GTDENS ======
C    !!!!   FIRST CALL SETDEN WITH IMODE=-1
C -----------------------------
C  IMODE=0
C         input    JX : from: 0 to: NX-1
C                  JY : from: 0 to: NY-1
C                  JZ : from: 0 to: NZMIN - NZMAX
C         output   ID   from byte-array IR 
C                             / dimension NX,NY,NZMAX-NZMIN+1/
C  IMODE=1
C         input    JX : from: 0 to: NX/2
C                  JY : from: 0 to: NY-1
C                  JZ : from: 0 to: NZMAX-NZMIN
C         output   ID   from byte-array IR 
C                             / dimension NX/2+1,NY,NZMAX-NZMIN+1/
C  IMODE=2
C         input    JX : from: 0 to: NX/2
C                  JY : from: 0 to: NY/2
C                  JZ : from: 0 to: NZMAX-NZMIN
C
C         output   ID   from byte-array IR 
C                             / dimension NX/2+1,NY/2+1,NZMAX-NZMIN+1/
C
C ---------------------------------------------------------------------
C     ==== SETDEN ======
C -----------------------------
C     ENTRY SETDEN(IMODE,JX,JY,JZ,ID,IR,NX,NY,NZ,NZMIN,NZMAX)
C    !!!!   FIRST CALL SETDEN WITH IMODE=-1
C -P-        GTDENS
C -P-  ENTRY SETDEN
C -----------------------------
C  IMODE=0
C         input    JX : from: 0 to: NX-1
C                  JY : from: 0 to: NY-1
C                  JZ : from: 0 to: NZMAX-NZMIN
C  IMODE=1
C         input    JX : from: 0 to: NX/2
C                  JY : from: 0 to: NY-1
C                  JZ : from: 0 to: NZMAX-NZMIN
C  IMODE=2
C         input    JX : from: 0 to: NX/2
C                  JY : from: 0 to: NY/2
C                  JZ : from: 0 to: NZMAX-NZMIN
C         ID  dens in point JX,JY,JZ move to array IR
C -----------------------------
C ******
CMS      : IR
      INTEGER*2   IR(*)
      INTEGER*2   IN2(2),JN2(2)
      INTEGER     IN4,JN4,IT
      EQUIVALENCE (IN4,IN2(1)),(JN4,JN2(1))
      COMMON/COM_BYTE/ IBYTE1,IBYTE2
     *,ISTART_A_CAP,ISTART_A_LOW,ISTART_DIG_0
C ----------------------------------------
      ITYPE=0
      GO TO 10
C ----
      ENTRY SETDEN(IMODE,JX,JY,JZ,ID,IR,NX,NY,NZ,NZMIN,NZMAX)
C ----
      ITYPE=1
 10   CONTINUE
      IF(IMODE.EQ.-1) THEN
        IN2(1)=100
        IN2(2)=0
        IF(IN4.EQ.100) THEN
C          IN4
C          2 1
          IBYTE1=1
          IBYTE2=2
        ELSE
C          IN4
C          1 2
          IBYTE1=2
          IBYTE2=1
        ENDIF
        RETURN
      ENDIF
      IX=JX
      IY=JY
      IZ=JZ
      IF(IZ.LT.NZMIN) IZ=NZMIN
      IF(IZ.GT.NZMAX) IZ=NZMAX
      IZ  =IZ-NZMIN
C     IF(IX.LT.0) IX=0
C     IF(IY.LT.0) IY=0
      IF(IMODE.EQ.0) THEN
C       IF(IX.GE.NX) IX=NX-1
C       IF(IY.GE.NY) IY=NY-1
        IND =(NY*IZ+IY)*NX+IX+1
      ELSE IF(IMODE.EQ.1) THEN
        NX2=NX/2
C       IF(IX.GT.NX2) IX=NX2
C       IF(IY.GE.NY ) IY=NY-1
        IND =(NY*IZ+IY)*(NX2+1)+IX+1
      ELSE IF(IMODE.EQ.2) THEN
        NX2=NX/2
        NY2=NY/2
C       IF(IX.GT.NX2) IX=NX2
C       IF(IY.GT.NY2) IY=NY2
        IND =((NY2+1)*IZ+IY)*(NX2+1)+IX+1
      ENDIF
      INDD=(IND+1)/2
      IND =MOD(IND,2)
      JN4 =0
      IN4 =0
      IF(ITYPE.EQ.0) THEN
C     --- GET ---
        IN2(IBYTE1)=IR(INDD)
        IF(IND.EQ.0) THEN
          IT =IN4/256
          ID =IN4-IT*256
        ELSE
         ID =IN4/256
        ENDIF
      ELSE
C     --- SET ---
        IN4 =ID
        IT  =ID/256
        IN4 =ID-IT*256
        IN2(IBYTE2)=0
        JN2(IBYTE1)=IR(INDD)
        IF(IND.EQ.0) THEN
          JN4=JN4/256
          JN4=JN4*256
          IN4=IN4+JN4
        ELSE
          IN4=IN4*256
          IT =JN4/256
          JN4=JN4-IT*256
          IN4=IN4+JN4
        ENDIF
        IR(INDD)=IN2(IBYTE1)
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE RDENS(MTIN,FNAME,MDOC,ITYPE,ICNTZ,NX,NY,NZ,IZMAX,
     * IZMIN,RMAX,RMIN,POOL,A,B,C,AL,BE,GA,RMS,AVER,RESOL,IX0,IY0,IZ0
     * ,ITR,TITLE,NSYM,ISYM,NSMAX,IERR)
C
C -P- RDENS - reads file-dens to --> array POOL (real)
C
C   input :
C       MT    - unit number
C       FNAME  - file name or " ".   /if " " - name will be taken
C                                                      from terminal  /
C       MDOC  - mode of writting messages to DOC-file
C               0 - only term, < - 0 only file, 0 < < 99 - both
C               =< 99 - don't write  
C       ITYPE - 0 open file & read title & read last record (RMAX,RMIN ...)
C                                   & rewind ( don't close )
C              -1 not open , rewind , read titles ( don't print )
C               1 read next plan(x,y) from file to array POOL(real) 
C   output:
C       MTIN =0       - signal of error.
C       FNAME         - name of file 
C       NX,NY,NZ      - number points for axis X,Y,Z
C       IZMIN,IZMAX   - min and max section Z
C       ICNTZ         - number of z-section / for ITYPE = 1/
C       RMAX,RMIN     - max and min value of density
C       POOL          - real array of density (NX,NY)
C       A,B,C         -  cell parameters
C       AL,BE,GA      -  / in radian /
C       RMS           -  RMS(!R!) = SQRT(<R**2>-<ABS(R)>*<ABS(R)>)
C       IX0,IY0,IZ0   -  origin of coord. system /first point=0/
C       ITR           =  0 translation may be applied ,=1 no.
C       TITLE         -  general title / CHARACTER*80 /
C---------------------------------------------------------------------
CMS      : POOL
      COMMON/COM_RDNS/ LZ
      INTEGER*4 ICNTZ,LZ
      REAL RMAX,RMIN,A,B,C,AL,BE,GA,VOL
      REAL POOL(*)
      INTEGER*4 MTIN,MDOC,ITYPE,NX,NY,NZ,IZMAX,IZMIN
      INTEGER*4 IX0,IY0,IZ0,ITR
      INTEGER*4 NSYM,NSMAX,IERR
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER FNAME*(*)
      CHARACTER TITLE*(*)
C ******
C ------------------------------------
      CHARACTER CH1*1,TPSYMB*1
      INTEGER*4 ILINE(20)
      REAL      RLINE(20)
      INTEGER*4 IBLOCK(512)
      INTEGER*2 IBLCK2(1024)
      INTEGER*4 NRMAX,NR8,NR40,NR
      CHARACTER LINE*80,TYPE*4,MSG*1
      EQUIVALENCE (IBLCK2(1),IBLOCK(1))
      EQUIVALENCE (ILINE(1),RLINE(1)),(ILINE(1),LINE)
      DATA NRMAX/1024/
      DATA NR8/4/
      DATA NR40/20/
C ---------------------------------------------------------------------
      IERR=0
      MSG='N'
      CH1=FNAME(1:1)
      CALL CHKSMB(CH1,TPSYMB)
      IF(TPSYMB.EQ.'?'.OR.CH1.EQ.' '.OR.CH1.EQ.',') THEN
        FNAME(1:1)=' '
      ENDIF
      IPRINT = 0
      IF(ITYPE.EQ.-2) THEN
        ITYPE=0
        IPRINT=0
        CALL LENSTR_BL(FNAME,LEN)
        IF(LEN.LE.0.OR.FNAME(1:1).EQ.' ') MSG='Y'
      ELSE IF(ITYPE.EQ.0) THEN
        IPRINT=1
        CALL LENSTR_BL(FNAME,LEN)
        IF(LEN.LE.0.OR.FNAME(1:1).EQ.' ') MSG='Y'
      ENDIF
      IF(ITYPE.EQ.-1) THEN
        LZ=IZMIN
        REWIND MTIN
        ICNTZ=IZMIN-1
        ITYPE=1
        IPRINT=0
      ENDIF
      IF(ITYPE.EQ.0) THEN
  10    TYPE='    '
        M=MDOC
        IF(IPRINT.EQ.0) M=99
        CALL ORFILE(M,MTIN,FNAME,TYPE,NSYM,ISYM,NSMAX,IERR)
        IF(IERR.GT.0) THEN
          IERR=1
C         MTIN=0
          RETURN
        ENDIF
        CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *        ,F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TITLE,IERR)
        IF(IERR.GT.0) THEN
          IERR=2
          RETURN
        ENDIF

C        CALL RTITLE(MTIN,FNAME,MDOC,TYPE,IPRINT,
C     *  A,B,C,AL,BE,GA,DDM,DDM,DDM,DDM,NX,NY,NZ,IZMIN,IZMAX,TITLE)
C        IF(MTIN.LE.0) RETURN

        IF(TYPE.NE.'RI  ') THEN
          CALL MSGERR(MDOC,' ERR: WRONG TYPE FILE ')
          CLOSE(MTIN)
          IF(MDOC.GE.0.AND.MDOC.LT.99.AND.MSG.EQ.'Y') GO TO 10
          MTIN=0
          IERR=3
          RETURN
        ENDIF

        IF(TITLE(1:3).NE.'RF:') THEN
C
C         CELL VOLUME
C
          S=(AL+BE+GA)*0.5
          VOL=2.0*A*B*C*
     *        SQRT(SIN(S)*SIN(S-AL)*SIN(S-BE)*SIN(S-GA))
          IF(IPRINT.EQ.1) THEN
            IF(MDOC.GT.0.AND.MDOC.LT.99) THEN
              WRITE(LINE,40) VOL
 40           FORMAT(' VOL :',G12.4)
              CALL MSGDOC(MDOC,LINE)
            ENDIF
          ENDIF
        ELSE
          VOL=1.0
        ENDIF
        NXY=NX*NY
        LZ=IZMIN
      ELSE
        IF(LZ.EQ.IZMIN) THEN

C          CALL RBLOCK(MTIN,ILINE,NR40,IERR)
C          CALL RBLOCK(MTIN,ILINE,NR40,IERR)

          IF(IPRINT.EQ.0) M=99
          TYPE='RI  '
          CALL OPFILE(M,MTIN,FNAME,TYPE,NSYM,ISYM,NSMAX,IERR)
          IF(IERR.GT.0) THEN
            IERR=4  
            MTIN=0
            RETURN
          ENDIF

C        IPR=0
C        CALL PTITLE(MTIN,FNAME,MDOC,TYPE,IPR,
C     *  A,B,C,AL,BE,GA,DDM,DDM,DDM,DDM,NX,NY,NZ,IZMIN,IZMAX,TITLE)


        ENDIF
        NXY=NX*NY
      ENDIF
      IF(ITYPE.EQ.0) THEN
        JZMIN=IZMIN
        JZMAX=IZMAX
        ICNTZ=IZMIN-1
      ELSE
        JZMIN=1
        JZMAX=1
        ICNTZ=ICNTZ+1
      ENDIF
      DO     JZ=JZMIN,JZMAX
        CALL RBLOCK(MTIN,ILINE,NR8,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE-IN')
          MTIN=0
          IERR=5
          RETURN
        ENDIF
        SCALE=RLINE(2)
        IXY=0
        NR0=0
        NR1=1
   20   NR2=NR0+NRMAX
        IF(NR2.GT.NXY) THEN
          NRR=NXY-NR0
        ELSE
          NRR=NRMAX
        ENDIF
        NRR2=NRR/2

C N      CALL RFILE(MTIN,0,IBLOCK(1),-1,NRR2)
C N      IF(ERRCODE.NE.0) THEN
C N        CALL ERMSG(ERRCODE)
C N        CALL MSGERR(MDOC,' ERR:  READ DENS-FILE')
C N        CLOSE(MTIN)
C N        MTIN=0
C N        RETURN
C N      ENDIF

        READ(MTIN,ERR=2) (IBLOCK(JR),JR=1,NRR2)
        GO TO 1
    2   CALL MSGERR(MDOC,' ERR:  READ DENS-FILE')
        CLOSE(MTIN)
        MTIN=0
        IERR=6
        RETURN
    1   CONTINUE

        IF(ITYPE.NE.0) THEN
          DO     I=1,NRR
            IXY=IXY+1
            POOL(IXY)=IBLCK2(I)/SCALE
          ENDDO
        ENDIF
        NR0=NR0+NRR
        NR1=NR1+NRR
        IF(NR1.LE.NXY) GO TO 20
      ENDDO
      IF(ITYPE.EQ.0) THEN
        CALL RBLOCK(MTIN,ILINE,NR40,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE-IN.')
          CLOSE(MTIN)
          MTIN=0
          IERR=7
          RETURN
        ENDIF

        READ(LINE,30) NR,RMAX,RMIN,IX0,IY0,IZ0,DELX,DELY,DELZ,ITR
 30     FORMAT(I10,2G12.4,3I4,G12.4,F7.4,G12.4,I1)
        RMS  =DELX
        RESOL=DELY
        AVER =DELZ
        IF(IPRINT.EQ.1) THEN
          IF(MDOC.GE.0.AND.MDOC.LT.99) THEN   
            WRITE(LINE,25) RMAX,RMIN,RMS,AVER
 25         FORMAT('Rmax:',G12.4,' Rmin:',G12.4,' RMS(R):',G12.4
     *      ,' <R>:',G12.4)
            CALL MSGDOC(MDOC,LINE)
            WRITE(LINE,'('' Resolution :'',F10.3)') RESOL
            CALL MSGDOC(MDOC,LINE)
          ENDIF
        ENDIF
        REWIND MTIN

      ELSE
        LZ=LZ+1
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE IRDENS(MTIN,FNAME,MDOC,ITYPE,ICNTZ,NX,NY,NZ,IZMAX,
     * IZMIN,RMAX,RMIN,IPOOL,SCALE,A,B,C,AL,BE,GA,RMS,AVER,RESOL,IX0,IY0
     *,IZ0,ITR,TITLE
     * ,NSYM,ISYM,NSMAX,IERR)
C
C -P- IRDENS - reads of file-dens --> array IPOOL /integer*2/
C       for i-section: RDENSi=IRDENSi/SCALEi
C
C   input :
C       MT    - unit number
C       FNAME  - file name or " ".   /if " " - name will be taken
C                                                      from terminal  /
C       MDOC  - unit number file-document , may be =0
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       =< 99 - not write  
C       ITYPE - 0 open file & read title & read last record (RMAX,RMIN ...)
C                                   & rewind ( not close )
C              -1 not open , rewind , read titles ( not print )
C               1 read from file to IPOOL (integer*2) next plan(x,y)
C
C   output:
C       MTIN =0       - error.
C       FNAME         - name of file 
C       ICNTZ         - number of z-section / for ITYPE = 1/
C       NX,NY,NZ      - number points for axis X,Y,Z
C       IZMIN,IZMAX   - min and max section Z
C       RMAX,RMIN     - max and min value of density
C       IPOOL         - integer*2 array of density (NX,NY)
C       SCALE         - scale for this section DENS(i,j)=IPOOL(i,j)/SCALE
C       A,B,C         -  cell parameters
C       AL,BE,GA      -  / in radian /
C       RMS           -  RMS = SQRT(<R**2>-<ABS(R)>*<ABS(R)>)
C       RESOL
C       IX0,IY0,IZ0   -  origin of coord. system /first point=0/
C       ITR           =  0 translation may by appled ,=1 no.
C       TITLE         -  general title / CHARACTER*80 /
C ******
C---------------------------------------------------------------------
CMS      : IPOOL
      INTEGER*2 IPOOL(*)
      COMMON/COM_RIDNS/ LZ
      INTEGER*4 ICNTZ,LZ
      REAL RMAX,RMIN,A,B,C,AL,BE,GA,VOL
      INTEGER*4 MTIN,MDOC,ITYPE,NX,NY,NZ,IZMAX,IZMIN
      INTEGER*4 NSYM,NSMAX,IERR
      INTEGER*2 ISYM(5,3,NSMAX)
      INTEGER*4 IX0,IY0,IZ0,ITR
      CHARACTER FNAME*(*)
      CHARACTER TITLE*(*)
C ------------------------------------
      CHARACTER CH1*1,TPSYMB*1
      INTEGER*4 ILINE(20)
      REAL      RLINE(20)
      INTEGER*4 IBLOCK(512)
      INTEGER*2 IBLCK2(1024)
      INTEGER*4 NRMAX,NR8,NR40,NR
      CHARACTER LINE*80,TYPE*4,MSG*1
      EQUIVALENCE (IBLCK2(1),IBLOCK(1))
      EQUIVALENCE (ILINE(1),RLINE(1)),(ILINE(1),LINE)
      DATA NRMAX/1024/
      DATA NR8/4/
      DATA NR40/20/
C ---------------------------------------------------------------------
      IERR=0
      M = 99
      MSG='N'
      CH1=FNAME(1:1)
      CALL CHKSMB(CH1,TPSYMB)
      IF(TPSYMB.EQ.'?'.OR.CH1.EQ.' '.OR.CH1.EQ.',') THEN
        FNAME(1:1)=' '
      ENDIF
      IPRINT = 0
      IF(ITYPE.EQ.-2) THEN
        ITYPE=0
        IPRINT=0
        CALL LENSTR_BL(FNAME,LEN)
        IF(LEN.LE.0.OR.FNAME(1:1).EQ.' ') MSG='Y'
      ELSE IF(ITYPE.EQ.0) THEN
        IPRINT=1
        CALL LENSTR_BL(FNAME,LEN)
        IF(LEN.LE.0.OR.FNAME(1:1).EQ.' ') MSG='Y'
      ENDIF
      IF(ITYPE.EQ.-1) THEN
        LZ=IZMIN
        REWIND MTIN
        ICNTZ=IZMIN-1
        ITYPE=1
        IPRINT=0
      ENDIF
      IF(ITYPE.EQ.0) THEN
  10    TYPE='    '
        M=MDOC
        IF(IPRINT.EQ.0) M=99
        CALL ORFILE(M,MTIN,FNAME,TYPE,NSYM,ISYM,NSMAX,IERR)
        IF(IERR.GT.0) THEN
          IERR=1
C         MTIN=0
          RETURN
        ENDIF
        CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *        ,F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TITLE,IERR)
        IF(IERR.GT.0) THEN
          IERR=2
          RETURN
        ENDIF
C        CALL RTITLE(MTIN,FNAME,MDOC,TYPE,IPRINT,
C     *  A,B,C,AL,BE,GA,DDM,DDM,DDM,DDM,NX,NY,NZ,IZMIN,IZMAX,TITLE)
C        IF(MTIN.LE.0) RETURN
        IF(TYPE.NE.'RI  ') THEN
          CALL MSGERR(MDOC,' ERR: WRONG TYPE FILE ')
          CLOSE(MTIN)
          IF(MDOC.GE.0.AND.MDOC.LT.99.AND.MSG.EQ.'Y') GO TO 10
          MTIN=0
          IERR=3
          RETURN
        ENDIF
        IF(TITLE(1:3).NE.'RF:') THEN
C
C         CELL VOLUME
C
          S=(AL+BE+GA)*0.5
          VOL=2.0*A*B*C*
     *        SQRT(SIN(S)*SIN(S-AL)*SIN(S-BE)*SIN(S-GA))
          IF(IPRINT.EQ.1) THEN
            IF(MDOC.GT.0.AND.MDOC.LT.99) THEN
              WRITE(LINE,40) VOL
 40           FORMAT(' VOL :',G12.4)
              CALL MSGDOC(MDOC,LINE)
            ENDIF
          ENDIF
        ELSE
          VOL=1.0
        ENDIF
        NXY=NX*NY
        LZ=IZMIN
      ELSE
        IF(LZ.EQ.IZMIN) THEN

C          CALL RBLOCK(MTIN,ILINE,NR40,IERR)
C          CALL RBLOCK(MTIN,ILINE,NR40,IERR)

          IF(IPRINT.EQ.0) M=99
          TYPE='RI  '
          CALL OPFILE(M,MTIN,FNAME,TYPE,NSYM,ISYM,NSMAX,IERR)
          IF(IERR.GT.0) THEN
            MTIN=0
            IERR=4
            RETURN
          ENDIF

C        IPR=0
C        CALL PTITLE(MTIN,FNAME,MDOC,TYPE,IPR,
C     *  A,B,C,AL,BE,GA,DDM,DDM,DDM,DDM,NX,NY,NZ,IZMIN,IZMAX,TITLE)
C         IF(IERR.NE.0) THEN
C           CALL MSGERR(MDOC,' ERR: READ FILE-IN')
C           CLOSE(MTIN)
C           MTIN=0
C           RETURN
C         ENDIF
        ENDIF
        NXY=NX*NY
      ENDIF
      IF(ITYPE.EQ.0) THEN
        JZMIN=IZMIN
        JZMAX=IZMAX
        ICNTZ=IZMIN-1
      ELSE
        JZMIN=1
        JZMAX=1
        ICNTZ=ICNTZ+1
      ENDIF
      DO     JZ=JZMIN,JZMAX
        CALL RBLOCK(MTIN,ILINE,NR8,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE-IN')
          CLOSE(MTIN)
          MTIN=0
          IERR=5
          RETURN
        ENDIF
        SCALE=RLINE(2)
        IXY=0
        NR0=0
        NR1=1
   20   NR2=NR0+NRMAX
        IF(NR2.GT.NXY) THEN
          NRR=NXY-NR0
        ELSE
          NRR=NRMAX
        ENDIF
        NRR2=NRR/2
C N      CALL RFILE(MTIN,0,IBLOCK(1),-1,NRR2)
C N      IF(ERRCODE.NE.0) THEN
C N        CALL ERMSG(ERRCODE)
C N        CALL MSGERR(MDOC,' ERR:  READ DENS-FILE')
C N        CLOSE(MTIN)
C N        MTIN=0
C N        RETURN
C N      ENDIF
C 
        READ(MTIN,ERR=2) (IBLOCK(JR),JR=1,NRR2)
        GO TO 1
    2   CALL MSGERR(MDOC,' ERR:  READ DENS-FILE')
        CLOSE(MTIN)
        MTIN=0
        IERR=6
        RETURN
    1   CONTINUE

        IF(ITYPE.NE.0) THEN
          DO     I=1,NRR
            IXY=IXY+1
            IPOOL(IXY)=IBLCK2(I)
          ENDDO
        ENDIF
        NR0=NR0+NRR
        NR1=NR1+NRR
        IF(NR1.LE.NXY) GO TO 20
      ENDDO
      IF(ITYPE.EQ.0) THEN
        CALL RBLOCK(MTIN,ILINE,NR40,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE-IN.')
          CLOSE(MTIN)
          MTIN=0
          IERR=7
          RETURN
        ENDIF
        READ(LINE,30) NR,RMAX,RMIN,IX0,IY0,IZ0,DELX,DELY,DELZ,ITR
 30     FORMAT(I10,2G12.4,3I4,G12.4,F7.4,G12.4,I1)
        RMS  =DELX
        RESOL=DELY
        AVER =DELZ
        IF(IPRINT.EQ.1) THEN
          IF(MDOC.GE.0.AND.MDOC.LT.99) THEN   
            WRITE(LINE,25) RMAX,RMIN,RMS,AVER
 25         FORMAT('Rmax:',G12.4,' Rmin:',G12.4,' RMS(R):',G12.4
     *      ,' <R>:',G12.4)
            CALL MSGDOC(MDOC,LINE)
            WRITE(LINE,'('' Resolution :'',F10.3)') RESOL
            CALL MSGDOC(MDOC,LINE)
          ENDIF
        ENDIF
        REWIND MTIN
      ELSE
        LZ=LZ+1
      ENDIF
      RETURN
      END


C ******
      SUBROUTINE IRDNS2(MTIN,FNAME,MDOC,ITYPE,ICNTZ,NX,NY,NZ,IZMAX,
     * IZMIN,RMAX,RMIN,IPOOL,SCALE,A,B,C,AL,BE,GA,RMS,AVER,RESOL,IX0,IY0
     *,IZ0,ITR,TITLE
     * ,NSYM,ISYM,NSMAX,IERR)
C
C -P- IRDENS - reads of file-dens --> array IPOOL /integer*2/
C       for i-section: RDENSi=IRDENSi/SCALEi
C
C   input :
C       MT    - unit number
C       FNAME  - file name or " ".   /if " " - name will be taken
C                                                      from terminal  /
C       MDOC  - unit number file-document , may be =0
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       =< 99 - not write  
C       ITYPE - 0 open file & read title & read last record (RMAX,RMIN ...)
C                                   & rewind ( not close )
C              -1 not open , rewind , read titles ( not print )
C               1 read from file to IPOOL (integer*2) next plan(x,y)
C
C   output:
C       MTIN =0       - error.
C       FNAME         - name of file 
C       ICNTZ         - number of z-section / for ITYPE = 1/
C       NX,NY,NZ      - number points for axis X,Y,Z
C       IZMIN,IZMAX   - min and max section Z
C       RMAX,RMIN     - max and min value of density
C       IPOOL         - integer*2 array of density (NX,NY)
C       SCALE         - scale for this section DENS(i,j)=IPOOL(i,j)/SCALE
C       A,B,C         -  cell parameters
C       AL,BE,GA      -  / in radian /
C       RMS           -  RMS = SQRT(<R**2>-<ABS(R)>*<ABS(R)>)
C       RESOL
C       IX0,IY0,IZ0   -  origin of coord. system /first point=0/
C       ITR           =  0 translation may by appled ,=1 no.
C       TITLE         -  general title / CHARACTER*80 /
C ******
C---------------------------------------------------------------------
CMS      : IPOOL
      INTEGER*2 IPOOL(*)
      COMMON/COM_2RIDNS/ LZ
      INTEGER*4 ICNTZ,LZ
      REAL RMAX,RMIN,A,B,C,AL,BE,GA,VOL
      INTEGER*4 MTIN,MDOC,ITYPE,NX,NY,NZ,IZMAX,IZMIN
      INTEGER*4 NSYM,NSMAX,IERR
      INTEGER*2 ISYM(5,3,NSMAX)
      INTEGER*4 IX0,IY0,IZ0,ITR
      CHARACTER FNAME*(*)
      CHARACTER TITLE*(*)
C ------------------------------------
      CHARACTER CH1*1,TPSYMB*1
      INTEGER*4 ILINE(20)
      REAL      RLINE(20)
      INTEGER*4 IBLOCK(512)
      INTEGER*2 IBLCK2(1024)
      INTEGER*4 NRMAX,NR8,NR40,NR
      CHARACTER LINE*80,TYPE*4,MSG*1
      EQUIVALENCE (IBLCK2(1),IBLOCK(1))
      EQUIVALENCE (ILINE(1),RLINE(1)),(ILINE(1),LINE)
      DATA NRMAX/1024/
      DATA NR8/4/
      DATA NR40/20/
C ---------------------------------------------------------------------
      IERR=0
      MSG='N'
      CH1=FNAME(1:1)
      CALL CHKSMB(CH1,TPSYMB)
      IF(TPSYMB.EQ.'?'.OR.CH1.EQ.' '.OR.CH1.EQ.',') THEN
        FNAME(1:1)=' '
      ENDIF
      IPRINT = 0
      IF(ITYPE.EQ.-2) THEN
        ITYPE  = 0
        IPRINT = 0
        CALL LENSTR_BL(FNAME,LEN)
        IF(LEN.LE.0.OR.FNAME(1:1).EQ.' ') MSG='Y'
      ELSE IF(ITYPE.EQ.0) THEN
        IPRINT=1
        CALL LENSTR_BL(FNAME,LEN)
        IF(LEN.LE.0.OR.FNAME(1:1).EQ.' ') MSG='Y'
      ENDIF
      IF(ITYPE.EQ.-1) THEN
        LZ=IZMIN
        REWIND MTIN
        ICNTZ=IZMIN-1
        ITYPE=1
        IPRINT=0
      ENDIF
      IF(ITYPE.EQ.0) THEN
  10    TYPE='    '
        M=MDOC
        IF(IPRINT.EQ.0) M=99
        CALL ORFILE(M,MTIN,FNAME,TYPE,NSYM,ISYM,NSMAX,IERR)
        IF(IERR.GT.0) THEN
          IERR=1
C         MTIN=0
          RETURN
        ENDIF
        CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *        ,F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TITLE,IERR)
        IF(IERR.GT.0) THEN
          IERR=2
          RETURN
        ENDIF
C        CALL RTITLE(MTIN,FNAME,MDOC,TYPE,IPRINT,
C     *  A,B,C,AL,BE,GA,DDM,DDM,DDM,DDM,NX,NY,NZ,IZMIN,IZMAX,TITLE)
C        IF(MTIN.LE.0) RETURN
        IF(TYPE.NE.'RI  ') THEN
          CALL MSGERR(MDOC,' ERR: WRONG TYPE FILE ')
          CLOSE(MTIN)
          IF(MDOC.GE.0.AND.MDOC.LT.99.AND.MSG.EQ.'Y') GO TO 10
          MTIN=0
          IERR=3
          RETURN
        ENDIF
        IF(TITLE(1:3).NE.'RF:') THEN
C
C         CELL VOLUME
C
          S=(AL+BE+GA)*0.5
          VOL=2.0*A*B*C*
     *        SQRT(SIN(S)*SIN(S-AL)*SIN(S-BE)*SIN(S-GA))
          IF(IPRINT.EQ.1) THEN
            IF(MDOC.GT.0.AND.MDOC.LT.99) THEN
              WRITE(LINE,40) VOL
 40           FORMAT(' VOL :',G12.4)
              CALL MSGDOC(MDOC,LINE)
            ENDIF
          ENDIF
        ELSE
          VOL=1.0
        ENDIF
        NXY=NX*NY
        LZ=IZMIN
      ELSE
        IF(LZ.EQ.IZMIN) THEN

C          CALL RBLOCK(MTIN,ILINE,NR40,IERR)
C          CALL RBLOCK(MTIN,ILINE,NR40,IERR)

          IF(IPRINT.EQ.0) M=99
          TYPE='RI  '

          CALL OPFILE(M,MTIN,FNAME,TYPE,NSYM,ISYM,NSMAX,IERR)
          IF(IERR.GT.0) THEN
            MTIN=0
            IERR=4
            RETURN
          ENDIF

C        IPR=0
C        CALL PTITLE(MTIN,FNAME,MDOC,TYPE,IPR,
C     *  A,B,C,AL,BE,GA,DDM,DDM,DDM,DDM,NX,NY,NZ,IZMIN,IZMAX,TITLE)
C         IF(IERR.NE.0) THEN
C           CALL MSGERR(MDOC,' ERR: READ FILE-IN')
C           CLOSE(MTIN)
C           MTIN=0
C           RETURN
C         ENDIF
        ENDIF
        NXY=NX*NY
      ENDIF
      IF(ITYPE.EQ.0) THEN
        JZMIN=IZMIN
        JZMAX=IZMAX
        ICNTZ=IZMIN-1
      ELSE
        JZMIN=1
        JZMAX=1
        ICNTZ=ICNTZ+1
      ENDIF
      DO     JZ=JZMIN,JZMAX
        CALL RBLOCK(MTIN,ILINE,NR8,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE-IN')
          CLOSE(MTIN)
          MTIN=0
          IERR=5
          RETURN
        ENDIF
        SCALE=RLINE(2)
        IXY=0
        NR0=0
        NR1=1
   20   NR2=NR0+NRMAX
        IF(NR2.GT.NXY) THEN
          NRR=NXY-NR0
        ELSE
          NRR=NRMAX
        ENDIF
        NRR2=NRR/2
C N      CALL RFILE(MTIN,0,IBLOCK(1),-1,NRR2)
C N      IF(ERRCODE.NE.0) THEN
C N        CALL ERMSG(ERRCODE)
C N        CALL MSGERR(MDOC,' ERR:  READ DENS-FILE')
C N        CLOSE(MTIN)
C N        MTIN=0
C N        RETURN
C N      ENDIF
C 
        READ(MTIN,ERR=2) (IBLOCK(JR),JR=1,NRR2)
        GO TO 1
    2   CALL MSGERR(MDOC,' ERR:  READ DENS-FILE')
        CLOSE(MTIN)
        MTIN=0
        IERR=6
        RETURN

    1   CONTINUE

        IF(ITYPE.NE.0) THEN
          DO     I=1,NRR
            IXY=IXY+1
            IPOOL(IXY)=IBLCK2(I)
          ENDDO
        ENDIF
        NR0=NR0+NRR
        NR1=NR1+NRR
        IF(NR1.LE.NXY) GO TO 20
      ENDDO
      IF(ITYPE.EQ.0) THEN
        CALL RBLOCK(MTIN,ILINE,NR40,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE-IN.')
          CLOSE(MTIN)
          MTIN=0
          IERR=7
          RETURN
        ENDIF
        READ(LINE,30) NR,RMAX,RMIN,IX0,IY0,IZ0,DELX,DELY,DELZ,ITR
 30     FORMAT(I10,2G12.4,3I4,G12.4,F7.4,G12.4,I1)
        RMS  =DELX
        RESOL=DELY
        AVER =DELZ
        IF(IPRINT.EQ.1) THEN
          IF(MDOC.GE.0.AND.MDOC.LT.99) THEN   
            WRITE(LINE,25) RMAX,RMIN,RMS,AVER
 25         FORMAT('Rmax:',G12.4,' Rmin:',G12.4,' RMS(R):',G12.4
     *      ,' <R>:',G12.4)
            CALL MSGDOC(MDOC,LINE)
            WRITE(LINE,'('' Resolution :'',F10.3)') RESOL
            CALL MSGDOC(MDOC,LINE)
          ENDIF
        ENDIF
        REWIND MTIN
      ELSE
        LZ=LZ+1
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE RDENS2(MTIN,FNAME,MDOC,ITYPE,ICNTZ,NX,NY,NZ,IZMAX,
     * IZMIN,RMAX,RMIN,POOL,A,B,C,AL,BE,GA,RMS,AVER,RESOL,IX0,IY0,IZ0
     * ,ITR,TITLE,NSYM,ISYM,NSMAX,IERR)
C
C -P- RDENS2 - reads file-dens to --> array POOL (real)
C
C ******
C---------------------------------------------------------------------
CMS      : POOL
      COMMON/COM_2RDNS/ LZ
      INTEGER*4 ICNTZ,LZ
      REAL RMAX,RMIN,A,B,C,AL,BE,GA,VOL
      REAL POOL(*)
      INTEGER*4 MTIN,MDOC,ITYPE,NX,NY,NZ,IZMAX,IZMIN
      INTEGER*4 IX0,IY0,IZ0,ITR
      INTEGER*4 NSYM,NSMAX,IERR
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER FNAME*(*)
      CHARACTER TITLE*(*)
C ******
C ------------------------------------
      CHARACTER CH1*1,TPSYMB*1
      INTEGER*4 ILINE(20)
      REAL      RLINE(20)
      INTEGER*4 IBLOCK(512)
      INTEGER*2 IBLCK2(1024)
      INTEGER*4 NRMAX,NR8,NR40,NR
      CHARACTER LINE*80,TYPE*4,MSG*1
      EQUIVALENCE (IBLCK2(1),IBLOCK(1))
      EQUIVALENCE (ILINE(1),RLINE(1)),(ILINE(1),LINE)
      DATA NRMAX/1024/
      DATA NR8/4/
      DATA NR40/20/
C ---------------------------------------------------------------------
      IERR=0
      MSG='N'
      CH1=FNAME(1:1)
      CALL CHKSMB(CH1,TPSYMB)
      IF(TPSYMB.EQ.'?'.OR.CH1.EQ.' '.OR.CH1.EQ.',') THEN
        FNAME(1:1)=' '
      ENDIF
      IPRINT = 0
      IF(ITYPE.EQ.-2) THEN
        ITYPE=0
        IPRINT=0
        CALL LENSTR_BL(FNAME,LEN)
        IF(LEN.LE.0.OR.FNAME(1:1).EQ.' ') MSG='Y'
      ELSE IF(ITYPE.EQ.0) THEN
        IPRINT=1
        CALL LENSTR_BL(FNAME,LEN)
        IF(LEN.LE.0.OR.FNAME(1:1).EQ.' ') MSG='Y'
      ENDIF
      IF(ITYPE.EQ.-1) THEN
        LZ=IZMIN
        REWIND MTIN
        ICNTZ=IZMIN-1
        ITYPE=1
        IPRINT=0
      ENDIF
      IF(ITYPE.EQ.0) THEN
  10    TYPE='    '
        M=MDOC
        IF(IPRINT.EQ.0) M=99
        CALL ORFILE(M,MTIN,FNAME,TYPE,NSYM,ISYM,NSMAX,IERR)
        IF(IERR.GT.0) THEN
          IERR=1
C         MTIN=0
          RETURN
        ENDIF
        CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *        ,F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TITLE,IERR)
        IF(IERR.GT.0) THEN
          IERR=2
          RETURN
        ENDIF

C        CALL RTITLE(MTIN,FNAME,MDOC,TYPE,IPRINT,
C     *  A,B,C,AL,BE,GA,DDM,DDM,DDM,DDM,NX,NY,NZ,IZMIN,IZMAX,TITLE)
C        IF(MTIN.LE.0) RETURN

        IF(TYPE.NE.'RI  ') THEN
          CALL MSGERR(MDOC,' ERR: WRONG TYPE FILE ')
          CLOSE(MTIN)
          IF(MDOC.GE.0.AND.MDOC.LT.99.AND.MSG.EQ.'Y') GO TO 10
          MTIN=0
          IERR=3
          RETURN
        ENDIF

        IF(TITLE(1:3).NE.'RF:') THEN
C
C         CELL VOLUME
C
          S=(AL+BE+GA)*0.5
          VOL=2.0*A*B*C*
     *        SQRT(SIN(S)*SIN(S-AL)*SIN(S-BE)*SIN(S-GA))
          IF(IPRINT.EQ.1) THEN
            IF(MDOC.GT.0.AND.MDOC.LT.99) THEN
              WRITE(LINE,40) VOL
 40           FORMAT(' VOL :',G12.4)
              CALL MSGDOC(MDOC,LINE)
            ENDIF
          ENDIF
        ELSE
          VOL=1.0
        ENDIF
        NXY=NX*NY
        LZ=IZMIN
      ELSE
        IF(LZ.EQ.IZMIN) THEN

C          CALL RBLOCK(MTIN,ILINE,NR40,IERR)
C          CALL RBLOCK(MTIN,ILINE,NR40,IERR)

          IF(IPRINT.EQ.0) M=99
          TYPE='RI  '
          CALL OPFILE(M,MTIN,FNAME,TYPE,NSYM,ISYM,NSMAX,IERR)
          IF(IERR.GT.0) THEN
            IERR=4  
            MTIN=0
            RETURN
          ENDIF

C        IPR=0
C        CALL PTITLE(MTIN,FNAME,MDOC,TYPE,IPR,
C     *  A,B,C,AL,BE,GA,DDM,DDM,DDM,DDM,NX,NY,NZ,IZMIN,IZMAX,TITLE)


        ENDIF
        NXY=NX*NY
      ENDIF
      IF(ITYPE.EQ.0) THEN
        JZMIN=IZMIN
        JZMAX=IZMAX
        ICNTZ=IZMIN-1
      ELSE
        JZMIN=1
        JZMAX=1
        ICNTZ=ICNTZ+1
      ENDIF
      DO     JZ=JZMIN,JZMAX
        CALL RBLOCK(MTIN,ILINE,NR8,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE-IN')
          MTIN=0
          IERR=5
          RETURN
        ENDIF
        SCALE=RLINE(2)
        IXY=0
        NR0=0
        NR1=1
   20   NR2=NR0+NRMAX
        IF(NR2.GT.NXY) THEN
          NRR=NXY-NR0
        ELSE
          NRR=NRMAX
        ENDIF
        NRR2=NRR/2

C N      CALL RFILE(MTIN,0,IBLOCK(1),-1,NRR2)
C N      IF(ERRCODE.NE.0) THEN
C N        CALL ERMSG(ERRCODE)
C N        CALL MSGERR(MDOC,' ERR:  READ DENS-FILE')
C N        CLOSE(MTIN)
C N        MTIN=0
C N        RETURN
C N      ENDIF

        READ(MTIN,ERR=2) (IBLOCK(JR),JR=1,NRR2)
        GO TO 1
    2   CALL MSGERR(MDOC,' ERR:  READ DENS-FILE')
        CLOSE(MTIN)
        MTIN=0
        IERR=6
        RETURN
    1   CONTINUE

        IF(ITYPE.NE.0) THEN
          DO     I=1,NRR
            IXY=IXY+1
            POOL(IXY)=IBLCK2(I)/SCALE
          ENDDO
        ENDIF
        NR0=NR0+NRR
        NR1=NR1+NRR
        IF(NR1.LE.NXY) GO TO 20
      ENDDO
      IF(ITYPE.EQ.0) THEN
        CALL RBLOCK(MTIN,ILINE,NR40,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE-IN.')
          CLOSE(MTIN)
          MTIN=0
          IERR=7
          RETURN
        ENDIF

        READ(LINE,30) NR,RMAX,RMIN,IX0,IY0,IZ0,DELX,DELY,DELZ,ITR
 30     FORMAT(I10,2G12.4,3I4,G12.4,F7.4,G12.4,I1)
        RMS  =DELX
        RESOL=DELY
        AVER =DELZ
        IF(IPRINT.EQ.1) THEN
          IF(MDOC.GE.0.AND.MDOC.LT.99) THEN   
            WRITE(LINE,25) RMAX,RMIN,RMS,AVER
 25         FORMAT('Rmax:',G12.4,' Rmin:',G12.4,' RMS(R):',G12.4
     *      ,' <R>:',G12.4)
            CALL MSGDOC(MDOC,LINE)
            WRITE(LINE,'('' Resolution :'',F10.3)') RESOL
            CALL MSGDOC(MDOC,LINE)
          ENDIF
        ENDIF
        REWIND MTIN

      ELSE
        LZ=LZ+1
      ENDIF
      RETURN
      END


C ******
      SUBROUTINE WDENS(MTOUT,MDOC,ICNTZ,NX,NY,NZ,IZMIN,IZMAX,RMAX,RMIN
     .                ,POOL,RESOL,IX0,IY0,IZ0,ITR)
C
C -P- WDENS - writes next plan(x,y) 
C             /z=ICNTZ POOL(real)/ to file MTOUT
C
C     if ICNTZ.eq.-999 then set RMAX=-1.E 30 and RMIN= 1.E 30
C     if ICNTZ.eq.IZMAX then write last record (RMAX,RMIN,IX0,IY0,IZ0,ITR)
C                         and write EOF & close file MTOUT
C     !!!!  subroutine destroyed array POOL
C           ICNTZ = -999 for first call / after call WTITLE /
C    output ICNTZ - z-section number
C
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       =< 99 - not write  
C     output: MTOUT = 0 - error.
C ******
CMS      : POOL
      REAL POOL(*)
      COMMON/COM_WDNS/ AVER,AVER2
      REAL*8 AVER,AVER2 
C ----------------------------------------------------------------
      MT=ABS(MTOUT)
      CALL WSECT(MTOUT,MDOC,ICNTZ,IZMIN,IZMAX,NX,NY,RMAX,RMIN,POOL
     *          ,POOL,AVER,AVER2)
      IF(MTOUT.EQ.0) RETURN
      IF(ICNTZ.GE.IZMAX) THEN
        CALL WTITL2(MTOUT,MDOC,NX,NY,NZ,IZMIN,IZMAX,RMAX,RMIN
     .                ,IX0,IY0,IZ0,ITR,AVER,AVER2,RESOL)
        IF(MTOUT.EQ.0) RETURN
        END FILE MT
        CLOSE(MT)
      ENDIF
      RETURN
      END


C ******
      SUBROUTINE WTITL2(MTOUT,MDOC,NX,NY,NZ,IZMIN,IZMAX,RMAX,RMIN
     .                ,IX0,IY0,IZ0,ITR,DAVER,DAVER2,RESOL)
C
C    WTITL2 - writes of last record to file (dens)
C
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       =< 99 - not write  
C     output: MTOUT = 0 - error.
C ******
      REAL*8    DAVER,DAVER2,DNUMB,DRMS 
      INTEGER*4 NR
      INTEGER*4 ILINE(20)
      CHARACTER LINE*80
      EQUIVALENCE (LINE,ILINE(1))
      DATA NWW/20/
C------------------------------------
      MT=ABS(MTOUT)
      NR=NX*NY
      NR=NR*(IZMAX-IZMIN+1)
C     --------------
      DNUMB = NR
      DAVER =DAVER /DNUMB
      DAVER2=DAVER2/DNUMB
      DRMS  =DAVER2-DAVER*DAVER
      RMS   = DRMS
      AVER  = DAVER
      IF(RMS.LT.0.0) RMS=0.0
      IF(RMS.GT.0.0) RMS=SQRT(RMS)

      IF(ABS(RMS ).GT.1.E30) RMS =0.0
      IF(ABS(AVER).GT.1.E30) AVER=0.0

      DELX = RMS
      DELY = RESOL
      DELZ = AVER
      IF(NR.LT.0.OR.NR.GT.999999999) NR=0
      IF(IX0.GT.9999) IX0=9999
      IF(IY0.GT.9999) IY0=9999
      IF(IZ0.GT.9999) IZ0=9999
      IF(IX0.LT.-999) IX0=-999
      IF(IY0.LT.-999) IY0=-999
      IF(IZ0.LT.-999) IZ0=-999
      IF(DELX.GT. 1.0E31)  DELX= 1.0E31
      IF(DELZ.GT. 1.0E31)  DELZ= 1.0E31
      IF(DELZ.LT.-1.0E31)  DELZ=-1.0E31
      IF(RMAX.GT. 1.0E31)  RMAX= 1.0E31
      IF(RMAX.LT.-1.0E31)  RMAX=-1.0E31
      IF(RMIN.GT. 1.0E31)  RMIN= 1.0E31
      IF(RMIN.LT.-1.0E31)  RMIN=-1.0E31
      IF(DELY.GT.99.9999) DELY=99.9999
      IF(DELY.LT.-9.9999) DELY=-9.9999
      IF(ITR.LT.0.OR.ITR.GT.9) ITR=0
      WRITE(LINE,32) NR,RMAX,RMIN,IX0,IY0,IZ0,DELX,DELY,DELZ,ITR
 32   FORMAT(I10,2G12.4,3I4,G12.4,F7.4,G12.4,I1)
      CALL WBLOCK(MT,ILINE,NWW,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE FILE-OUT')
        CLOSE(MT)
        MTOUT=0
        RETURN
      ENDIF
      IF(MTOUT.GT.0) THEN
        WRITE(LINE,20)
 20     FORMAT(' ------------------------------------ -')
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,10) RMAX,RMIN,RMS,AVER
 10     FORMAT('Rmax:',G12.4,' Rmin:',G12.4
     *  ,' RMS(R):',G12.4,' <R>:',G12.4)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      RETURN
      END

C ////////////////////////////////////////////////////////////////////

      SUBROUTINE WSECT(MTOUT,MDOC,IZ,IZMIN,IZMAX,NX,NY,RMAX,RMIN
     *                  ,POOL,IPOOL,AVER,AVER2)
C
C    WSECT writes of next plan(x,y) to file (dens)
C
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       >= 99 - not write  
C     output: MTOUT = 0 - error.
C ******
CMS      : POOL,IPOOL
      REAL POOL(*)
      REAL*8 AVER,AVER2 
      INTEGER*4 IDATE(7),NW8
      INTEGER*2 IPOOL(*),IDAT(8)
      CHARACTER LINE*80
      EQUIVALENCE (IDAT(1),SCAL1),(IDAT(3),SCAL),(IDAT(5),RM)
      EQUIVALENCE (IDAT(7),RN)
      DATA NW8/4/
C ----------------------------------------
      MT=ABS(MTOUT)

      IF(IZ.EQ.-999) THEN
        IF(MTOUT.GT.0) THEN
          WRITE(LINE,201)
          CALL MSGDOC(MDOC,LINE)
          WRITE(LINE,200)
          CALL MSGDOC(MDOC,LINE)
          WRITE(LINE,201)
          CALL MSGDOC(MDOC,LINE)
 201      FORMAT(' ')
 200      FORMAT('   X',3X,'Y',3X,'Z',6X,'R-MAX',7X,'X',3X,'Y',
     *         3X,'Z',6X,'R-MIN',8X,'TIME')
        ENDIF 
        RMAX=-1.E 30
        RMIN= 1.E 30
        AVER =0.0
        AVER2=0.0
        IZ=IZMIN
      ELSE
        IZ=IZ+1
      ENDIF
      SCAL1=1.
      RN= 1.E 30
      RM=-1.E 30
      NXY=NX*NY
      DO     J=1,NY
        IY=J-1
        IND=IY*NX
        DO     I=1,NX
          IX=I-1
          INDX=IND+I
          R=POOL(INDX)
          AVER =AVER +R
          AVER2=AVER2+R*R
          IF(R.GE.RMAX) RMAX=R
          IF(R.LE.RMIN) RMIN=R
          IF(R.GE.RM) THEN
            RM=R
            IXM=IX
            IYM=IY
          ENDIF
          IF(R.LE.RN) THEN
            RN=R
            IXN=IX
            IYN=IY
          ENDIF
        ENDDO
      ENDDO
      RRMAX=MAX(ABS(RM),ABS(RN))
      IF(ABS(RRMAX).GT.1.E-7) THEN
        SCAL=(32 766.)/RRMAX
      ELSE
        SCAL=1.
      ENDIF
      DO     J=1,NY
        IND=(J-1)*NX
        DO     I=1,NX
          INDX=IND+I
          PL=POOL(INDX)*SCAL
          IF(ABS(PL).GT.32766.) PL=SIGN(32766.,PL)
          IPOOL(INDX)=PL
        ENDDO
      ENDDO

      CALL WBLOCK_I2(MT,IDAT,NW8,IERR)

      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE DATA TO FILE-OUT')
        CLOSE(MT)
        MTOUT=0
        RETURN
      ENDIF
      NXY2=NXY/2

      CALL WBLOCK_I2(MT,IPOOL,NXY2,IERR)

      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE DATA TO FILE-OUT')
        CLOSE(MT)
        MTOUT=0
        RETURN
      ENDIF
      CALL CLOCK(IDATE)
C --------
      IF(MTOUT.GT.0) THEN
        WRITE(LINE,1) IXM,IYM,IZ,RM,IXN,IYN,IZ,RN,IDATE(4),IDATE(3)
     *               ,IDATE(2)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
C N 1 FORMAT(1X,3I4,1X,G12.4,' , ',3I4,1X,G12.4,' ; ',I2,'.',J2,'.',J2)
    1 FORMAT(1X,3I4,1X,G12.4,' , ',3I4,1X,G12.4,' ; ',I2,'.',I2,'.',I2)
      RETURN
      END

C ------------------
C -- MEM --

      SUBROUTINE IRDENS_MEM(MTIN,FNAME,MDOC,ITYPE,ICNTZ,NX,NY,NZ,IZMAX,
     * IZMIN,RMAX,RMIN,IPOOL,SCALE,A,B,C,AL,BE,GA,RMS,AVER,RESOL
     * ,IX0,IY0,IZ0,ITR,TITLE
     * ,NSYM,ISYM,NSMAX,IPOOL_MEM,IERR)
C
C -P- IRDENS - reads of file-dens --> array IPOOL /integer*2/
C       for i-section: RDENSi=IRDENSi/SCALEi
C
C   input :
C       MT    - unit number
C       FNAME  - file name or " ".   /if " " - name will be taken
C                                                      from terminal  /
C       MDOC  - unit number file-document , may be =0
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       =< 99 - not write  
C       ITYPE - 0 open file & read title & read last record (RMAX,RMIN ...)
C                                   & rewind ( not close )
C              -1 not open , rewind , read titles ( not print )
C               1 read from file to IPOOL (integer*2) next plan(x,y)
C
C   output:
C       MTIN =0       - error.
C       FNAME         - name of file 
C       ICNTZ         - number of z-section / for ITYPE = 1/
C       NX,NY,NZ      - number points for axis X,Y,Z
C       IZMIN,IZMAX   - min and max section Z
C       RMAX,RMIN     - max and min value of density
C       IPOOL         - integer*2 array of density (NX,NY)
C       SCALE         - scale for this section DENS(i,j)=IPOOL(i,j)/SCALE
C       A,B,C         -  cell parameters
C       AL,BE,GA      -  / in radian /
C       RMS           -  RMS = SQRT(<R**2>-<ABS(R)>*<ABS(R)>)
C       RESOL
C       IX0,IY0,IZ0   -  origin of coord. system /first point=0/
C       ITR           =  0 translation may by appled ,=1 no.
C       TITLE         -  general title / CHARACTER*80 /
C ******
C---------------------------------------------------------------------
      INTEGER           IPOOL_MEM(*)
      COMMON/COM_DPOOL/ IPOOL_MAX,IPOOL_CURR
C ---
      INTEGER*2 IPOOL(*)
      COMMON/COM_RIDNS/ LZ
      INTEGER*4 ICNTZ,LZ
      REAL RMAX,RMIN,A,B,C,AL,BE,GA,VOL
      INTEGER*4 MTIN,MDOC,ITYPE,NX,NY,NZ,IZMAX,IZMIN
      INTEGER*4 NSYM,NSMAX,IERR
      INTEGER*2 ISYM(5,3,NSMAX)
      INTEGER*4 IX0,IY0,IZ0,ITR
      CHARACTER FNAME*(*)
      CHARACTER TITLE*(*)
C ------------------------------------
      CHARACTER CH1*1,TPSYMB*1
      INTEGER*4 ILINE(20)
      REAL      RLINE(20)
      INTEGER*4 IBLOCK(512)
      INTEGER*2 IBLCK2(1024)
      INTEGER*4 NRMAX,NR8,NR40,NR
      CHARACTER LINE*80,TYPE*4,MSG*1
      EQUIVALENCE (IBLCK2(1),IBLOCK(1))
      EQUIVALENCE (ILINE(1),RLINE(1)),(ILINE(1),LINE)
      DATA NRMAX/1024/
      DATA NR8/4/
      DATA NR40/20/
C ---------------------------------------------------------------------
      IERR = 0
      M    = 99
      MSG  = 'N'
      CH1  = FNAME(1:1)
      CALL CHKSMB(CH1,TPSYMB)
      IF(TPSYMB.EQ.'?'.OR.CH1.EQ.' '.OR.CH1.EQ.',') THEN
        FNAME(1:1)=' '
      ENDIF
      IPRINT = 0
      IF(ITYPE.EQ.-2) THEN
        ITYPE  = 0
        IPRINT = 0
        CALL LENSTR_BL(FNAME,LEN)
        IF(LEN.LE.0.OR.FNAME(1:1).EQ.' ') MSG='Y'
      ELSE IF(ITYPE.EQ.0) THEN
        IPRINT=1
        CALL LENSTR_BL(FNAME,LEN)
        IF(LEN.LE.0.OR.FNAME(1:1).EQ.' ') MSG='Y'
      ENDIF
      IF(ITYPE.EQ.-1) THEN
        LZ=IZMIN
        IF(IPOOL_MAX.LE.0) THEN
          REWIND MTIN
        ELSE
          IPOOL_CURR = 0
        ENDIF
        ICNTZ  = IZMIN-1
        ITYPE  = 1
        IPRINT = 0
      ENDIF
      IF(ITYPE.EQ.0) THEN
  10    TYPE = '    '
        M   = MDOC
        IF(IPRINT.EQ.0) M=99
        CALL ORFILE_MEM(M,MTIN,FNAME,TYPE,NSYM,ISYM,NSMAX
     *  ,IPOOL_MEM,IERR)
        IF(IERR.GT.0) THEN
          IERR=1
C         MTIN=0
          RETURN
        ENDIF
        CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *        ,F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TITLE,IERR)
        IF(IERR.GT.0) THEN
          IERR=2
          RETURN
        ENDIF
C        CALL RTITLE(MTIN,FNAME,MDOC,TYPE,IPRINT,
C     *  A,B,C,AL,BE,GA,DDM,DDM,DDM,DDM,NX,NY,NZ,IZMIN,IZMAX,TITLE)
C        IF(MTIN.LE.0) RETURN
        IF(TYPE.NE.'RI  ') THEN
          CALL MSGERR(MDOC,' ERR: WRONG TYPE FILE (in irdens_mem)')
          IF(IPOOL_MAX.LE.0) CLOSE(MTIN)
          IF(MDOC.GE.0.AND.MDOC.LT.99.AND.MSG.EQ.'Y') GO TO 10
          MTIN=0
          IERR=3
          RETURN
        ENDIF

        IF(TITLE(1:3).NE.'RF:') THEN
C
C         CELL VOLUME
C
          S=(AL+BE+GA)*0.5
          VOL=2.0*A*B*C*
     *        SQRT(SIN(S)*SIN(S-AL)*SIN(S-BE)*SIN(S-GA))
          IF(IPRINT.EQ.1) THEN
            IF(MDOC.GT.0.AND.MDOC.LT.99) THEN
              WRITE(LINE,40) VOL
 40           FORMAT(' VOL :',G12.4)
              CALL MSGDOC(MDOC,LINE)
            ENDIF
          ENDIF
        ELSE
          VOL=1.0
        ENDIF
        NXY = NX*NY
        LZ  = IZMIN
      ELSE

        IF(LZ.EQ.IZMIN) THEN

C          CALL RBLOCK(MTIN,ILINE,NR40,IERR)
C          CALL RBLOCK(MTIN,ILINE,NR40,IERR)

          IF(IPRINT.EQ.0) M=99
          TYPE='RI  '
          CALL OPFILE_MEM(M,MTIN,FNAME,TYPE,NSYM,ISYM,NSMAX
     *    ,IPOOL_MEM,IERR)
          IF(IERR.GT.0) THEN
            MTIN=0
            IERR=4
            RETURN
          ENDIF

C        IPR=0
C        CALL PTITLE(MTIN,FNAME,MDOC,TYPE,IPR,
C     *  A,B,C,AL,BE,GA,DDM,DDM,DDM,DDM,NX,NY,NZ,IZMIN,IZMAX,TITLE)
C         IF(IERR.NE.0) THEN
C           CALL MSGERR(MDOC,' ERR: READ FILE-IN')
C           CLOSE(MTIN)
C           MTIN=0
C           RETURN
C         ENDIF
        ENDIF
        NXY=NX*NY
      ENDIF
      IF(ITYPE.EQ.0) THEN
        JZMIN=IZMIN
        JZMAX=IZMAX
        ICNTZ=IZMIN-1
      ELSE
        JZMIN=1
        JZMAX=1
        ICNTZ=ICNTZ+1
      ENDIF
      DO     JZ=JZMIN,JZMAX

        CALL RBLOCK_MEM(MTIN,ILINE,NR8,IPOOL_MEM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE-IN (in irdens_mem)')
          IF(IPOOL_MAX.LE.0) CLOSE(MTIN)
          MTIN=0
          IERR=5
          RETURN
        ENDIF

        SCALE=RLINE(2)
        IXY=0
        NR0=0
        NR1=1
   20   NR2=NR0+NRMAX
        IF(NR2.GT.NXY) THEN
          NRR=NXY-NR0
        ELSE
          NRR=NRMAX
        ENDIF
        NRR2=NRR/2
C N      CALL RFILE(MTIN,0,IBLOCK(1),-1,NRR2)
C N      IF(ERRCODE.NE.0) THEN
C N        CALL ERMSG(ERRCODE)
C N        CALL MSGERR(MDOC,' ERR:  READ DENS-FILE')
C N        CLOSE(MTIN)
C N        MTIN=0
C N        RETURN
C N      ENDIF
C 
        IF(IPOOL_MAX.LE.0) THEN
          READ(MTIN,ERR=2) (IBLOCK(JR),JR=1,NRR2)
        ELSE
          IF((IPOOL_CURR + NRR2).GT.IPOOL_MAX) GO TO 2
          DO JR=1,NRR2
            IBLOCK(JR) = IPOOL_MEM(IPOOL_CURR+JR)
          ENDDO
          IPOOL_CURR = IPOOL_CURR + NRR2
        ENDIF
        GO TO 1
    2   CALL MSGERR(MDOC,' ERR:  READ DENS-FILE (in irdens_mem)')
        IF(IPOOL_MAX.LE.0) CLOSE(MTIN)
        MTIN=0
        IERR=6
        RETURN
    1   CONTINUE

        IF(ITYPE.NE.0) THEN
          DO     I=1,NRR
            IXY=IXY+1
            IPOOL(IXY)=IBLCK2(I)
          ENDDO
        ENDIF
        NR0=NR0+NRR
        NR1=NR1+NRR
        IF(NR1.LE.NXY) GO TO 20
      ENDDO
      IF(ITYPE.EQ.0) THEN
        CALL RBLOCK_MEM(MTIN,ILINE,NR40,IPOOL_MEM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE-IN.(in irdens_mem)')
          IF(IPOOL_MAX.LE.0) CLOSE(MTIN)
          MTIN=0
          IERR=7
          RETURN
        ENDIF
        READ(LINE,30) NR,RMAX,RMIN,IX0,IY0,IZ0,DELX,DELY,DELZ,ITR
 30     FORMAT(I10,2G12.4,3I4,G12.4,F7.4,G12.4,I1)
        RMS  =DELX
        RESOL=DELY
        AVER =DELZ
        IF(IPRINT.EQ.1) THEN
          IF(MDOC.GE.0.AND.MDOC.LT.99) THEN   
            WRITE(LINE,25) RMAX,RMIN,RMS,AVER
 25         FORMAT('Rmax:',G12.4,' Rmin:',G12.4,' RMS(R):',G12.4
     *      ,' <R>:',G12.4)
            CALL MSGDOC(MDOC,LINE)
            WRITE(LINE,'('' Resolution :'',F10.3)') RESOL
            CALL MSGDOC(MDOC,LINE)
          ENDIF
        ENDIF
        IF(IPOOL_MAX.LE.0) THEN
          REWIND MTIN
        ELSE
          IPOOL_CURR = 0
        ENDIF
      ELSE
        LZ=LZ+1
      ENDIF
      RETURN
      END


      SUBROUTINE WDENS_MEM(MTOUT,MDOC,ICNTZ,NX,NY,NZ,IZMIN,IZMAX
     .                ,RMAX,RMIN,POOL,RESOL,IX0,IY0,IZ0,ITR,IPOOL_MEM)
C
C    WDENS - writes next plan(x,y) 
C             /z=ICNTZ POOL(real)/ to file MTOUT
C
C     if ICNTZ.eq.-999 then set RMAX=-1.E 30 and RMIN= 1.E 30
C     if ICNTZ.eq.IZMAX then write last record (RMAX,RMIN,IX0,IY0,IZ0,ITR)
C                         and write EOF & close file MTOUT
C     !!!!  subroutine destroyed array POOL
C           ICNTZ = -999 for first call / after call WTITLE /
C    output ICNTZ - z-section number
C
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       =< 99 - not write  
C     output: MTOUT = 0 - error.
C 
      INTEGER*4         IPOOL_MEM(*)
      COMMON/COM_DPOOL/ IPOOL_MAX,IPOOL_CURR
C ---
      REAL POOL(*)
      COMMON/COM_WDNS/ AVER,AVER2
      REAL*8 AVER,AVER2 
C ----------------------------------------------------------------
      MT=ABS(MTOUT)
      CALL WSECT_MEM(MTOUT,MDOC,ICNTZ,IZMIN,IZMAX,NX,NY,RMAX,RMIN,POOL
     *          ,POOL,AVER,AVER2,IPOOL_MEM)
      IF(MTOUT.EQ.0) RETURN
      IF(ICNTZ.GE.IZMAX) THEN
        CALL WTITL2_MEM(MTOUT,MDOC,NX,NY,NZ,IZMIN,IZMAX,RMAX,RMIN
     .                ,IX0,IY0,IZ0,ITR,AVER,AVER2,RESOL,IPOOL_MEM)
        IF(MTOUT.EQ.0) RETURN
        IF(IPOOL_MAX.LE.0.AND.MT.GT.0) THEN
          END FILE MT
          CLOSE(MT)
        ENDIF
      ENDIF
      RETURN
      END

      SUBROUTINE WTITL2_MEM(MTOUT,MDOC,NX,NY,NZ,IZMIN,IZMAX,RMAX,RMIN
     .                ,IX0,IY0,IZ0,ITR,DAVER,DAVER2,RESOL,IPOOL_MEM)
C
C    WTITL2 - writes of last record to file (dens)
C
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       =< 99 - not write  
C     output: MTOUT = 0 - error.
C 
      INTEGER*4         IPOOL_MEM(*)
      COMMON/COM_DPOOL/ IPOOL_MAX,IPOOL_CURR
C --
      REAL*8    DAVER,DAVER2,DNUMB,DRMS 
      INTEGER*4 NR
      INTEGER*4 ILINE(20)
      CHARACTER LINE*80
      EQUIVALENCE (LINE,ILINE(1))
      DATA NWW/20/
C------------------------------------
      MT = ABS(MTOUT)
      NR = NX*NY
      NR = NR*(IZMAX-IZMIN+1)
C     --------------
      DNUMB  = NR
      DAVER  = DAVER /DNUMB
      DAVER2 = DAVER2/DNUMB
      DRMS   = DAVER2-DAVER*DAVER
      RMS    = DRMS
      AVER   = DAVER
      IF(RMS.LT.0.0) RMS=0.0
      IF(RMS.GT.0.0) RMS=SQRT(RMS)

      IF(ABS(RMS ).GT.1.E30) RMS  = 0.0
      IF(ABS(AVER).GT.1.E30) AVER = 0.0

      DELX = RMS
      DELY = RESOL
      DELZ = AVER
      IF(NR.LT.0.OR.NR.GT.999999999) NR=0
      IF(IX0.GT.9999) IX0=9999
      IF(IY0.GT.9999) IY0=9999
      IF(IZ0.GT.9999) IZ0=9999
      IF(IX0.LT.-999) IX0=-999
      IF(IY0.LT.-999) IY0=-999
      IF(IZ0.LT.-999) IZ0=-999
      IF(DELX.GT. 1.0E31)  DELX= 1.0E31
      IF(DELZ.GT. 1.0E31)  DELZ= 1.0E31
      IF(DELZ.LT.-1.0E31)  DELZ=-1.0E31
      IF(RMAX.GT. 1.0E31)  RMAX= 1.0E31
      IF(RMAX.LT.-1.0E31)  RMAX=-1.0E31
      IF(RMIN.GT. 1.0E31)  RMIN= 1.0E31
      IF(RMIN.LT.-1.0E31)  RMIN=-1.0E31
      IF(DELY.GT.99.9999) DELY=99.9999
      IF(DELY.LT.-9.9999) DELY=-9.9999
      IF(ITR.LT.0.OR.ITR.GT.9) ITR=0
      WRITE(LINE,32) NR,RMAX,RMIN,IX0,IY0,IZ0,DELX,DELY,DELZ,ITR
 32   FORMAT(I10,2G12.4,3I4,G12.4,F7.4,G12.4,I1)
      CALL WBLOCK_MEM(MT,ILINE,NWW,IPOOL_MEM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE FILE-OUT (in WTITL2_MEM)')
        IF(IPOOL_MAX.LE.0) CLOSE(MT)
        MTOUT=0
        RETURN
      ENDIF
      IF(MTOUT.GT.0) THEN
        WRITE(LINE,20)
 20     FORMAT(' ------------------------------------ -')
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,10) RMAX,RMIN,RMS,AVER
 10     FORMAT('Rmax:',G12.4,' Rmin:',G12.4
     *  ,' RMS(R):',G12.4,' <R>:',G12.4)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      RETURN
      END

      SUBROUTINE WSECT_MEM(MTOUT,MDOC,IZ,IZMIN,IZMAX,NX,NY,RMAX,RMIN
     *                  ,POOL,IPOOL,AVER,AVER2,IPOOL_MEM)
C
C    WSECT writes of next plan(x,y) to file (dens)
C
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       >= 99 - not write  
C     output: MTOUT = 0 - error.
C ******
CMS      : POOL,IPOOL
      INTEGER*4         IPOOL_MEM(*)
      COMMON/COM_DPOOL/ IPOOL_MAX,IPOOL_CURR
C ----
      REAL POOL(*)
      REAL*8 AVER,AVER2 
      INTEGER*4 IDATE(7),NW8
      INTEGER*2 IPOOL(*),IDAT(8)
      CHARACTER LINE*80
      EQUIVALENCE (IDAT(1),SCAL1),(IDAT(3),SCAL),(IDAT(5),RM)
      EQUIVALENCE (IDAT(7),RN)
      DATA NW8/4/
C ----------------------------------------
      MT=ABS(MTOUT)
      IF(IZ.EQ.-999) THEN
        IF(MTOUT.GT.0) THEN
          WRITE(LINE,201)
          CALL MSGDOC(MDOC,LINE)
          WRITE(LINE,200)
          CALL MSGDOC(MDOC,LINE)
          WRITE(LINE,201)
          CALL MSGDOC(MDOC,LINE)
 201      FORMAT(' ')
 200      FORMAT('   X',3X,'Y',3X,'Z',6X,'R-MAX',7X,'X',3X,'Y',
     *         3X,'Z',6X,'R-MIN',8X,'TIME')
        ENDIF 
        RMAX=-1.E 30
        RMIN= 1.E 30
        AVER =0.0
        AVER2=0.0
        IZ=IZMIN
      ELSE
        IZ=IZ+1
      ENDIF
      SCAL1=1.
      RN= 1.E 30
      RM=-1.E 30
      NXY=NX*NY
      DO     J=1,NY
        IY=J-1
        IND=IY*NX
        DO     I=1,NX
          IX=I-1
          INDX=IND+I
          R=POOL(INDX)
          AVER =AVER +R
          AVER2=AVER2+R*R
          IF(R.GE.RMAX) RMAX=R
          IF(R.LE.RMIN) RMIN=R
          IF(R.GE.RM) THEN
            RM=R
            IXM=IX
            IYM=IY
          ENDIF
          IF(R.LE.RN) THEN
            RN=R
            IXN=IX
            IYN=IY
          ENDIF
        ENDDO
      ENDDO
      RRMAX=MAX(ABS(RM),ABS(RN))
      IF(ABS(RRMAX).GT.1.E-7) THEN
        SCAL=(32 766.)/RRMAX
      ELSE
        SCAL=1.
      ENDIF
      DO     J=1,NY
        IND=(J-1)*NX
        DO     I=1,NX
          INDX=IND+I
          PL=POOL(INDX)*SCAL
          IF(ABS(PL).GT.32766.) PL=SIGN(32766.,PL)
          IPOOL(INDX)=PL
        ENDDO
      ENDDO

c     CALL WBLOCK_I2(MT,IDAT,NW8,IPOOL_MEM,IERR)
      CALL WBLOCK_MEM(MT,IDAT,NW8,IPOOL_MEM,IERR)

      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE DATA TO FILE-OUT (in WSECT_MEM)')
        IF(IPOOL_MAX.LE.0) CLOSE(MT)
        MTOUT=0
        RETURN
      ENDIF

      NXY2=NXY/2

C      CALL WBLOCK_I2(MT,IPOOL,NXY2,IPOOL_MEM,IERR)
      CALL WBLOCK_MEM(MT,IPOOL,NXY2,IPOOL_MEM,IERR)

      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE DATA TO FILE-OUT (in WSECT_MEM)')
        IF(IPOOL_MAX.LE.0) CLOSE(MT)
        MTOUT=0
        RETURN
      ENDIF
      CALL CLOCK(IDATE)
C --------
      IF(MTOUT.GT.0) THEN
        WRITE(LINE,1) IXM,IYM,IZ,RM,IXN,IYN,IZ,RN,IDATE(4),IDATE(3)
     *               ,IDATE(2)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
C N 1 FORMAT(1X,3I4,1X,G12.4,' , ',3I4,1X,G12.4,' ; ',I2,'.',J2,'.',J2)
    1 FORMAT(1X,3I4,1X,G12.4,' , ',3I4,1X,G12.4,' ; ',I2,'.',I2,'.',I2)

      RETURN
      END

C -P-
C -P------ sort subroutines  --------------------
C -P-

C ******
      SUBROUTINE I2SORT1(A,N,TAG)
C
C -P- I2SORT1 - sorts array A(integer*4) with aray TAG(integer*2)
C     N = element number in A 
C ******
CMS      : A,TAG 
      INTEGER*4 N
      INTEGER*2 A(*),T,TT
      INTEGER*2 TAG(*),TG
      DIMENSION IU(24),IL(24)
C===========================================================
      M=1
      I=1
      J=N
    5 IF(I.GE.J) GO TO 70
   10 K=I
      IJ=(J+I)/2
      T=A(IJ)
      IF(A(I).LE.T) GO TO 20
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG
   20 L=J
      IF(A(J).GE.T) GO TO 40
      A(IJ)=A(J)
      A(J)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(J)
      TAG(J)=TG
      IF(A(I).LE.T) GO TO 40
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG
      GO TO 40
   30 A(L)=A(K)
      A(K)=TT
      TG=TAG(L)
      TAG(L)=TAG(K)
      TAG(K)=TG
   40 L=L-1
      IF(A(L).GT.T) GO TO 40
      TT=A(L)
   50 K=K+1
      IF(A(K).LT.T) GO TO 50
      IF(K.LE.L) GO TO 30
      IF((L-I).LE.(J-K)) GO TO 60
      IL(M)=I
      IU(M)=L
      I=K
      M=M+1
      GO TO 80
   60 IL(M)=K
      IU(M)=J
      J=L
      M=M+1
      GO TO 80
   70 M=M-1
      IF(M.EQ.0) RETURN
      I=IL(M)
      J=IU(M)
   80 IF((J-I).GE.1) GO TO 10
      IF(I.EQ.1) GO TO 5
      I=I-1
   90 I=I+1
      IF(I.EQ.J) GO TO 70
      T=A(I+1)
      IF(A(I).LE.T) GO TO 90
      TG=TAG(I+1)
      K=I
  100 A(K+1)=A(K)
      TAG(K+1)=TAG(K)
      K=K-1
      IF(T.LT.A(K)) GO TO 100
      A(K+1)=T
      TAG(K+1)=TG
      GO TO 90
      END

C ******
      SUBROUTINE ISORT1(A,N,TAG)
C
C -P- ISORT1 - sorts array A(integer*4) with aray TAG(real or integer*4)
C     N = element number in A 
C ******
CMS      : A,TAG 
      INTEGER*4 N
      INTEGER*4 A(*),T,TT
      DIMENSION TAG(*)
      DIMENSION IU(24),IL(24)
C===========================================================
      M=1
      I=1
      J=N
    5 IF(I.GE.J) GO TO 70
   10 K=I
      IJ=(J+I)/2
      T=A(IJ)
      IF(A(I).LE.T) GO TO 20
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG
   20 L=J
      IF(A(J).GE.T) GO TO 40
      A(IJ)=A(J)
      A(J)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(J)
      TAG(J)=TG
      IF(A(I).LE.T) GO TO 40
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG
      GO TO 40
   30 A(L)=A(K)
      A(K)=TT
      TG=TAG(L)
      TAG(L)=TAG(K)
      TAG(K)=TG
   40 L=L-1
      IF(A(L).GT.T) GO TO 40
      TT=A(L)
   50 K=K+1
      IF(A(K).LT.T) GO TO 50
      IF(K.LE.L) GO TO 30
      IF((L-I).LE.(J-K)) GO TO 60
      IL(M)=I
      IU(M)=L
      I=K
      M=M+1
      GO TO 80
   60 IL(M)=K
      IU(M)=J
      J=L
      M=M+1
      GO TO 80
   70 M=M-1
      IF(M.EQ.0) RETURN
      I=IL(M)
      J=IU(M)
   80 IF((J-I).GE.1) GO TO 10
      IF(I.EQ.1) GO TO 5
      I=I-1
   90 I=I+1
      IF(I.EQ.J) GO TO 70
      T=A(I+1)
      IF(A(I).LE.T) GO TO 90
      TG=TAG(I+1)
      K=I
  100 A(K+1)=A(K)
      TAG(K+1)=TAG(K)
      K=K-1
      IF(T.LT.A(K)) GO TO 100
      A(K+1)=T
      TAG(K+1)=TG
      GO TO 90
      END

C ******
      SUBROUTINE ISORT0(A,N)
C
C -P- ISORT0 - sorts array A (integer*4)
C     N = element number in A
C ******
CMS      : A
      INTEGER*4  N
      INTEGER*4  A(*),T,TT
      DIMENSION  IU(24),IL(24)
C===========================================================
      M=1
      I=1
      J=N
    5 IF(I.GE.J) GO TO 70
   10 K=I
      IJ=(J+I)/2
      T=A(IJ)
      IF(A(I).LE.T) GO TO 20
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
   20 L=J
      IF(A(J).GE.T) GO TO 40
      A(IJ)=A(J)
      A(J)=T
      T=A(IJ)
      IF(A(I).LE.T) GO TO 40
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
      GO TO 40
   30 A(L)=A(K)
      A(K)=TT
   40 L=L-1
      IF(A(L).GT.T) GO TO 40
      TT=A(L)
   50 K=K+1
      IF(A(K).LT.T) GO TO 50
      IF(K.LE.L) GO TO 30
      IF((L-I).LE.(J-K)) GO TO 60
      IL(M)=I
      IU(M)=L
      I=K
      M=M+1
      GO TO 80
   60 IL(M)=K
      IU(M)=J
      J=L
      M=M+1
      GO TO 80
   70 M=M-1
      IF(M.EQ.0) RETURN
      I=IL(M)
      J=IU(M)
   80 IF((J-I).GE.1) GO TO 10
      IF(I.EQ.1) GO TO 5
      I=I-1
   90 I=I+1
      IF(I.EQ.J) GO TO 70
      T=A(I+1)
      IF(A(I).LE.T) GO TO 90
      K=I
  100 A(K+1)=A(K)
      K=K-1
      IF(T.LT.A(K)) GO TO 100
      A(K+1)=T
      GO TO 90
      END

C ******
      SUBROUTINE ISORT3(A,N,TAG,TAG1,TAG2)
C
C -P- ISORT3 - sort array A(integer*4) with aray TAG,TAG1,TAG2 
C                                     (real or integer*4)
C     N = element number in A
C ******
CMS      : A,TAG,TAG1,TAG2
      INTEGER*4  N
      INTEGER*4  A(*),T,TT
      DIMENSION  IU(24),IL(24),TAG(*),TAG1(*),TAG2(*)
C===========================================================
      M=1
      I=1
      J=N
    5 IF(I.GE.J) GO TO 70
   10 K=I
      IJ=(J+I)/2
      T=A(IJ)
      IF(A(I).LE.T) GO TO 20
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)

      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG

      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(I)
      TAG1(I)=TG1

      TG2=TAG2(IJ)
      TAG2(IJ)=TAG2(I)
      TAG2(I)=TG2

   20 L=J
      IF(A(J).GE.T) GO TO 40
      A(IJ)=A(J)
      A(J)=T
      T=A(IJ)

      TG=TAG(IJ)
      TAG(IJ)=TAG(J)
      TAG(J)=TG

      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(J)
      TAG1(J)=TG1

      TG2=TAG2(IJ)
      TAG2(IJ)=TAG2(J)
      TAG2(J)=TG2

      IF(A(I).LE.T) GO TO 40
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)

      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG

      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(I)
      TAG1(I)=TG1

      TG2=TAG2(IJ)
      TAG2(IJ)=TAG2(I)
      TAG2(I)=TG2

      GO TO 40
   30 A(L)=A(K)
      A(K)=TT

      TG=TAG(L)
      TAG(L)=TAG(K)
      TAG(K)=TG

      TG1=TAG1(L)
      TAG1(L)=TAG1(K)
      TAG1(K)=TG1

      TG2=TAG2(L)
      TAG2(L)=TAG2(K)
      TAG2(K)=TG2

   40 L=L-1
      IF(A(L).GT.T) GO TO 40
      TT=A(L)
   50 K=K+1
      IF(A(K).LT.T) GO TO 50
      IF(K.LE.L) GO TO 30
      IF((L-I).LE.(J-K)) GO TO 60
      IL(M)=I
      IU(M)=L
      I=K
      M=M+1
      GO TO 80
   60 IL(M)=K
      IU(M)=J
      J=L
      M=M+1
      GO TO 80
   70 M=M-1
      IF(M.EQ.0) RETURN
      I=IL(M)
      J=IU(M)
   80 IF((J-I).GE.1) GO TO 10
      IF(I.EQ.1) GO TO 5
      I=I-1
   90 I=I+1
      IF(I.EQ.J) GO TO 70
      T=A(I+1)
      IF(A(I).LE.T) GO TO 90

      TG =TAG(I+1)
      TG1=TAG1(I+1)
      TG2=TAG2(I+1)

      K=I
  100 A(K+1)=A(K)

      TAG (K+1)=TAG(K)
      TAG1(K+1)=TAG1(K)
      TAG2(K+1)=TAG2(K)

      K=K-1
      IF(T.LT.A(K)) GO TO 100
      A(K+1)=T

      TAG (K+1)=TG
      TAG1(K+1)=TG1
      TAG2(K+1)=TG2

      GO TO 90
      END

C ******
      SUBROUTINE ISORT2(A,N,TAG,TAG1)
C
C -P- ISORT2 - sort array A (integer*4) with aray TAG,TAG1
C                                     (real or integer*4)
C     N = element number in A
C ******
CMS      : A,TAG,TAG1
      INTEGER*4  N
      INTEGER*4  A(*),T,TT
      DIMENSION  IU(24),IL(24),TAG(*),TAG1(*)
C===========================================================
      M=1
      I=1
      J=N
    5 IF(I.GE.J) GO TO 70
   10 K=I
      IJ=(J+I)/2
      T=A(IJ)
      IF(A(I).LE.T) GO TO 20
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)

      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG

      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(I)
      TAG1(I)=TG1

   20 L=J
      IF(A(J).GE.T) GO TO 40
      A(IJ)=A(J)
      A(J)=T
      T=A(IJ)

      TG=TAG(IJ)
      TAG(IJ)=TAG(J)
      TAG(J)=TG

      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(J)
      TAG1(J)=TG1

      IF(A(I).LE.T) GO TO 40
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)

      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG

      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(I)
      TAG1(I)=TG1

      GO TO 40
   30 A(L)=A(K)
      A(K)=TT

      TG=TAG(L)
      TAG(L)=TAG(K)
      TAG(K)=TG

      TG1=TAG1(L)
      TAG1(L)=TAG1(K)
      TAG1(K)=TG1

   40 L=L-1
      IF(A(L).GT.T) GO TO 40
      TT=A(L)
   50 K=K+1
      IF(A(K).LT.T) GO TO 50
      IF(K.LE.L) GO TO 30
      IF((L-I).LE.(J-K)) GO TO 60
      IL(M)=I
      IU(M)=L
      I=K
      M=M+1
      GO TO 80
   60 IL(M)=K
      IU(M)=J
      J=L
      M=M+1
      GO TO 80
   70 M=M-1
      IF(M.EQ.0) RETURN
      I=IL(M)
      J=IU(M)
   80 IF((J-I).GE.1) GO TO 10
      IF(I.EQ.1) GO TO 5
      I=I-1
   90 I=I+1
      IF(I.EQ.J) GO TO 70
      T=A(I+1)
      IF(A(I).LE.T) GO TO 90

      TG=TAG(I+1)
      TG1=TAG1(I+1)

      K=I
  100 A(K+1)=A(K)

      TAG(K+1)=TAG(K)
      TAG1(K+1)=TAG1(K)

      K=K-1
      IF(T.LT.A(K)) GO TO 100
      A(K+1)=T

      TAG(K+1)=TG
      TAG1(K+1)=TG1

      GO TO 90
      END

C ******
      SUBROUTINE SORT1(A,N,TAG)
C
C -P- SORT1 - sort array A (real) with aray TAG
C                              (real or integer*4)
C     N = element number in A
C ******
CMS      : A,TAG
      INTEGER*4 N
      REAL      A(*),T,TT
      DIMENSION TAG(*)
      DIMENSION IU(24),IL(24)
C===========================================================
      M=1
      I=1
      J=N
    5 IF(I.GE.J) GO TO 70
   10 K=I
      IJ=(J+I)/2
      T=A(IJ)
      IF(A(I).LE.T) GO TO 20
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG
   20 L=J
      IF(A(J).GE.T) GO TO 40
      A(IJ)=A(J)
      A(J)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(J)
      TAG(J)=TG
      IF(A(I).LE.T) GO TO 40
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG
      GO TO 40
   30 A(L)=A(K)
      A(K)=TT
      TG=TAG(L)
      TAG(L)=TAG(K)
      TAG(K)=TG
   40 L=L-1
      IF(A(L).GT.T) GO TO 40
      TT=A(L)
   50 K=K+1
      IF(A(K).LT.T) GO TO 50
      IF(K.LE.L) GO TO 30
      IF((L-I).LE.(J-K)) GO TO 60
      IL(M)=I
      IU(M)=L
      I=K
      M=M+1
      GO TO 80
   60 IL(M)=K
      IU(M)=J
      J=L
      M=M+1
      GO TO 80
   70 M=M-1
      IF(M.EQ.0) RETURN
      I=IL(M)
      J=IU(M)
   80 IF((J-I).GE.1) GO TO 10
      IF(I.EQ.1) GO TO 5
      I=I-1
   90 I=I+1
      IF(I.EQ.J) GO TO 70
      T=A(I+1)
      IF(A(I).LE.T) GO TO 90
      TG=TAG(I+1)
      K=I
  100 A(K+1)=A(K)
      TAG(K+1)=TAG(K)
      K=K-1
      IF(T.LT.A(K)) GO TO 100
      A(K+1)=T
      TAG(K+1)=TG
      GO TO 90
      END
C ******
      SUBROUTINE SORT0(A,N)
C
C -P- SORT0 - sort array A (real)
C     N = element number in A
C ******
CMS      : A
      INTEGER*4  N
      REAL       A(*),T,TT
      DIMENSION  IU(24),IL(24)
C===========================================================
      M=1
      I=1
      J=N
    5 IF(I.GE.J) GO TO 70
   10 K=I
      IJ=(J+I)/2
      T=A(IJ)
      IF(A(I).LE.T) GO TO 20
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
   20 L=J
      IF(A(J).GE.T) GO TO 40
      A(IJ)=A(J)
      A(J)=T
      T=A(IJ)
      IF(A(I).LE.T) GO TO 40
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
      GO TO 40
   30 A(L)=A(K)
      A(K)=TT
   40 L=L-1
      IF(A(L).GT.T) GO TO 40
      TT=A(L)
   50 K=K+1
      IF(A(K).LT.T) GO TO 50
      IF(K.LE.L) GO TO 30
      IF((L-I).LE.(J-K)) GO TO 60
      IL(M)=I
      IU(M)=L
      I=K
      M=M+1
      GO TO 80
   60 IL(M)=K
      IU(M)=J
      J=L
      M=M+1
      GO TO 80
   70 M=M-1
      IF(M.EQ.0) RETURN
      I=IL(M)
      J=IU(M)
   80 IF((J-I).GE.1) GO TO 10
      IF(I.EQ.1) GO TO 5
      I=I-1
   90 I=I+1
      IF(I.EQ.J) GO TO 70
      T=A(I+1)
      IF(A(I).LE.T) GO TO 90
      K=I
  100 A(K+1)=A(K)
      K=K-1
      IF(T.LT.A(K)) GO TO 100
      A(K+1)=T
      GO TO 90
      END

C ******
      SUBROUTINE SORT3(A,N,TAG,TAG1,TAG2)
C
C -P- SORT3 - sort array A (real) with aray TAG,TAG1,TAG2
C                              (real or integer*4)
C     N = element number in A
C ******
CMS      : A,TAG,TAG1,TAG2
      INTEGER*4  N
      REAL       A(*),T,TT
      DIMENSION  IU(24),IL(24),TAG(*),TAG1(*),TAG2(*)
C===========================================================
      M=1
      I=1
      J=N
    5 IF(I.GE.J) GO TO 70
   10 K=I
      IJ=(J+I)/2
      T=A(IJ)
      IF(A(I).LE.T) GO TO 20
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)

      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG

      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(I)
      TAG1(I)=TG1

      TG2=TAG2(IJ)
      TAG2(IJ)=TAG2(I)
      TAG2(I)=TG2

   20 L=J
      IF(A(J).GE.T) GO TO 40
      A(IJ)=A(J)
      A(J)=T
      T=A(IJ)

      TG=TAG(IJ)
      TAG(IJ)=TAG(J)
      TAG(J)=TG

      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(J)
      TAG1(J)=TG1

      TG2=TAG2(IJ)
      TAG2(IJ)=TAG2(J)
      TAG2(J)=TG2

      IF(A(I).LE.T) GO TO 40
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)

      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG

      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(I)
      TAG1(I)=TG1

      TG2=TAG2(IJ)
      TAG2(IJ)=TAG2(I)
      TAG2(I)=TG2

      GO TO 40
   30 A(L)=A(K)
      A(K)=TT

      TG=TAG(L)
      TAG(L)=TAG(K)
      TAG(K)=TG

      TG1=TAG1(L)
      TAG1(L)=TAG1(K)
      TAG1(K)=TG1

      TG2=TAG2(L)
      TAG2(L)=TAG2(K)
      TAG2(K)=TG2

   40 L=L-1
      IF(A(L).GT.T) GO TO 40
      TT=A(L)
   50 K=K+1
      IF(A(K).LT.T) GO TO 50
      IF(K.LE.L) GO TO 30
      IF((L-I).LE.(J-K)) GO TO 60
      IL(M)=I
      IU(M)=L
      I=K
      M=M+1
      GO TO 80
   60 IL(M)=K
      IU(M)=J
      J=L
      M=M+1
      GO TO 80
   70 M=M-1
      IF(M.EQ.0) RETURN
      I=IL(M)
      J=IU(M)
   80 IF((J-I).GE.1) GO TO 10
      IF(I.EQ.1) GO TO 5
      I=I-1
   90 I=I+1
      IF(I.EQ.J) GO TO 70
      T=A(I+1)
      IF(A(I).LE.T) GO TO 90
      TG=TAG(I+1)
      TG1=TAG1(I+1)
      TG2=TAG2(I+1)
      K=I
  100 A(K+1)=A(K)
      TAG(K+1)=TAG(K)
      TAG1(K+1)=TAG1(K)
      TAG2(K+1)=TAG2(K)
      K=K-1
      IF(T.LT.A(K)) GO TO 100
      A(K+1)=T
      TAG(K+1)=TG
      TAG1(K+1)=TG1
      TAG2(K+1)=TG2
      GO TO 90
      END

C ******
      SUBROUTINE SORT2(A,N,TAG,TAG1)
C
C -P- SORT2 - sort array A (real) with aray TAG,TAG1
C                              (real or integer*4)
C     N = element number in A
C ******
CMS      : A,TAG,TAG1
      INTEGER*4  N
      REAL       A(*),T,TT
      DIMENSION  IU(24),IL(24),TAG(*),TAG1(*)
C===========================================================
      M=1
      I=1
      J=N
    5 IF(I.GE.J) GO TO 70
   10 K=I
      IJ=(J+I)/2
      T=A(IJ)
      IF(A(I).LE.T) GO TO 20
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG
      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(I)
      TAG1(I)=TG1
   20 L=J
      IF(A(J).GE.T) GO TO 40
      A(IJ)=A(J)
      A(J)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(J)
      TAG(J)=TG
      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(J)
      TAG1(J)=TG1
      IF(A(I).LE.T) GO TO 40
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG
      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(I)
      TAG1(I)=TG1
      GO TO 40
   30 A(L)=A(K)
      A(K)=TT
      TG=TAG(L)
      TAG(L)=TAG(K)
      TAG(K)=TG
      TG1=TAG1(L)
      TAG1(L)=TAG1(K)
      TAG1(K)=TG1
   40 L=L-1
      IF(A(L).GT.T) GO TO 40
      TT=A(L)
   50 K=K+1
      IF(A(K).LT.T) GO TO 50
      IF(K.LE.L) GO TO 30
      IF((L-I).LE.(J-K)) GO TO 60
      IL(M)=I
      IU(M)=L
      I=K
      M=M+1
      GO TO 80
   60 IL(M)=K
      IU(M)=J
      J=L
      M=M+1
      GO TO 80
   70 M=M-1
      IF(M.EQ.0) RETURN
      I=IL(M)
      J=IU(M)
   80 IF((J-I).GE.1) GO TO 10
      IF(I.EQ.1) GO TO 5
      I=I-1
   90 I=I+1
      IF(I.EQ.J) GO TO 70
      T=A(I+1)
      IF(A(I).LE.T) GO TO 90
      TG=TAG(I+1)
      TG1=TAG1(I+1)
      K=I
  100 A(K+1)=A(K)
      TAG(K+1)=TAG(K)
      TAG1(K+1)=TAG1(K)
      K=K-1
      IF(T.LT.A(K)) GO TO 100
      A(K+1)=T
      TAG(K+1)=TG
      TAG1(K+1)=TG1
      GO TO 90
      END
C -P-
C -P- ------------ FFT ----------------------
C -P-
C ******
      SUBROUTINE MDHFT(X,DD,IERR)
C -P- MDHFT -
C     COMPLEX FINITE DISCRETE FOURIER TRANSFORM     
C     TRANSFORMS ONE DIMENSION OF MULTI-DIMENSIONAL DATA      
C     MODIFIED BY L. F. TEN EYCK FROM A ONE-DIMENSIONAL VERSION WRITTEN
C     BY G. T. SANDE, 1969.      
C   
C     THIS PROGRAM CALCULATES THE TRANSFORM         
C     (X(T) + I*Y(T))*(COS(2*PI*T/N) - I*SIN(2*PI*T/N))     
C   
C     INDEXING -- THE ARRANGEMENT OF THE MULTI-DIMENSIONAL DATA IS    
C     SPECIFIED BY THE INTEGER ARRAY D, THE VALUES OF WHICH ARE USED AS
C     CONTROL PARAMETERS IN DO LOOPS.  WHEN IT IS DESIRED TO COVER ALL
C     ELEMENTS OF THE DATA FOR WHICH THE SUBSCRIPT BEING TRANSFORMED HAS
C     THE VALUE I0, THE FOLLOWING IS USED.
C   
C     I1 = (I0 - 1)*D(2) + 1    
C     DO 100 I2 = I1, D(1), D(3)
C     I3 = I2 + D(4) - 1        
C     DO 100 I = I2, I3, D(5)   
C        .   
C        .   
C 100 CONTINUE         
C   
C     WITH THIS INDEXING IT IS POSSIBLE TO USE A NUMBER OF ARRANGEMENTS 
C     OF THE DATA, INCLUDING NORMAL FORTRAN COMPLEX NUMBERS (D(5) = 2)
C     OR SEPARATE STORAGE OF REAL AND IMAGINARY PARTS.        
C----------------------------------------------------------
CMS      :X,DD
      REAL    X(*)
      INTEGER DD(*),IERR
C ******
      INTEGER PTS,I,J,K,KK,LL,NT,ND
      REAL    A,B,C,D,E,F,ANGLE,TWOPI,TWON
      INTEGER DIM(10)
C---------------------------------------------------------
      MDOC=0
      IERR=0
      TWOPI=8.0*ATAN(1.0)
      NT=2
      DO     I=1,10
        DIM(I)=DD(I)
        IF(DIM(I).EQ.0) GO TO 200
        NT=NT*DIM(I)
      ENDDO
      GO TO 700
  200 CONTINUE
      ND=I
      NT=IABS(NT)
      DIM(1)=-IABS(DIM(1))

      CALL MDCFT2(X,DIM,IERR)
      IF(IERR.NE.0) RETURN

      PTS=-DIM(1)
      DIM(1)=PTS
      I=2*PTS
      TWON=FLOAT(I)
      DO     J=1,NT,I
        X(J+1)=X(J)
      ENDDO
      PTS=PTS+1
      DO     J=3,PTS,2
        ANGLE=TWOPI*FLOAT(J/2)/TWON
        CO=COS(ANGLE)
        SI=SIN(ANGLE)
        K=2*(PTS-J)
        DO     KK=J,NT,I
          LL=KK+K
          A=X(KK)+X(LL)
          B=X(KK)-X(LL)
          C=X(KK+1)+X(LL+1)
          D=X(KK+1)-X(LL+1)
          E=B*CO+C*SI
          F=B*SI-C*CO
          X(KK)=A+F
          X(LL)=A-F
          X(KK+1)=E+D
          X(LL+1)=E-D
        ENDDO
      ENDDO
      DO     J=2,ND
        DIM(J)=-IABS(DIM(J))
      ENDDO

      CALL MDCFT2(X,DIM,IERR)
      IF(IERR.NE.0) RETURN

      RETURN
  700 CONTINUE 
C
C     CALL MSGERR(???,' ERR: -- MDHFT -- : MORE THAN NINE DIMENSION')
C
      IERR=1
      RETURN
      END

C ******
      SUBROUTINE CMPLFT (X, Y, N, D,IERR)     
      INTEGER N        
      INTEGER D(*)     
CMS      : X,Y
      REAL X(*), Y(*)  
C   
C     COMPLEX FINITE DISCRETE FOURIER TRANSFORM     
C     TRANSFORMS ONE DIMENSION OF MULTI-DIMENSIONAL DATA      
C     MODIFIED BY L. F. TEN EYCK FROM A ONE-DIMENSIONAL VERSION WRITTEN
C     BY G. T. SANDE, 1969.      
C   
C     THIS PROGRAM CALCULATES THE TRANSFORM         
C     (X(T) + I*Y(T))*(COS(2*PI*T/N) - I*SIN(2*PI*T/N))     
C   
C     INDEXING -- THE ARRANGEMENT OF THE MULTI-DIMENSIONAL DATA IS    
C     SPECIFIED BY THE INTEGER ARRAY D, THE VALUES OF WHICH ARE USED AS
C     CONTROL PARAMETERS IN DO LOOPS.  WHEN IT IS DESIRED TO COVER ALL
C     ELEMENTS OF THE DATA FOR WHICH THE SUBSCRIPT BEING TRANSFORMED HAS
C     THE VALUE I0, THE FOLLOWING IS USED.
C   
C     I1 = (I0 - 1)*D(2) + 1    
C     DO 100 I2 = I1, D(1), D(3)
C     I3 = I2 + D(4) - 1        
C     DO 100 I = I2, I3, D(5)   
C        .   
C        .   
C 100 CONTINUE         
C   
C     WITH THIS INDEXING IT IS POSSIBLE TO USE A NUMBER OF ARRANGEMENTS 
C     OF THE DATA, INCLUDING NORMAL FORTRAN COMPLEX NUMBERS (D(5) = 2)
C     OR SEPARATE STORAGE OF REAL AND IMAGINARY PARTS.        
C   
C ******
C     CHARACTER LINE*80
      LOGICAL ERROR    
      INTEGER P MAX, P SYM, TWO GRP       
      INTEGER FACTOR(15), SYM(15), UN SYM(15)       
C   
C     P MAX IS THE LARGEST PRIME FACTOR THAT WILL BE TOLERATED BY THIS
C     PROGRAM.         
C     TWO GRP IS THE LARGEST POWER OF TWO THAT IS TREATED AS A SPECIAL
C     CASE.  
C   
C -----------------------
      IERR=0
      P MAX = 19       
      TWO GRP = 8      
    
      IF (N .LE. 1) GO TO 100    
      CALL S R FP (N, P MAX, TWO GRP, FACTOR, SYM, P SYM, UN SYM, ERROR)
      IF (ERROR) GO TO 200       
    
      CALL MD FT KD (N, FACTOR, D, X, Y,IERR)  
      IF(IERR.GT.0) GO TO 200
      CALL D IP RP (N, SYM, P SYM, UN SYM, D, X, Y) 
    
  100 CONTINUE         
      RETURN 
    
  200 CONTINUE         
C      WRITE (*, 300) N
C      WRITE (LINE, 300) N
C      CALL MSGERR(MDOC,LINE)
      IERR=1
      CALL EXITB
    
C  300 FORMAT(' ERR: INVALID NUMBER OF POINTS FOR CMPL FT. N =',I10)
    
      END    

      SUBROUTINE DIPRP(PTS,SYM,P SYM,UN SYM,DIM,X,Y)       
C     DOUBLE IN PLACE REORDERING PROGRAMME
C   
      INTEGER PTS,P SYM
CMS      : X,Y
      REAL X (*), Y (*)        
      INTEGER SYM(*), UN SYM(*), DIM(*) 
C   
      REAL T 
      LOGICAL ONE MOD  
      INTEGER MODULO (14)        
      INTEGER DK,JJ,KK,LK,MODS,MULT,NEST,P UN SYM,TEST        
      INTEGER NT, SEP, DELTA, P, P0, P1, P2, P3, P4, P5, SIZE 
C   
      INTEGER S (14), U (14)     
      INTEGER A,B,C,D,E,F,G,H,I,J,K,L,M,N 
      INTEGER BS,CS,DS,ES,FS,GS,HS,IS,JS,KS,LS,MS,NS
      INTEGER AL,BL,CL,DL,EL,FL,GL,HL,IL,JL,KL,LL,ML,NL       
      EQUIVALENCE (AL,U(1)),(BS,S(2)),(BL,U(2))     
      EQUIVALENCE (CS,S(3)),(CL,U(3)),(DS,S(4)),(DL,U(4))     
      EQUIVALENCE (ES,S(5)),(EL,U(5)),(FS,S(6)),(FL,U(6))     
      EQUIVALENCE (GS,S(7)),(GL,U(7)),(HS,S(8)),(HL,U(8))     
      EQUIVALENCE (IS,S(9)),(IL,U(9)),(JS,S(10)),(JL,U(10))   
      EQUIVALENCE (KS,S(11)),(KL,U(11)),(LS,S(12)),(LL,U(12)) 
      EQUIVALENCE (MS,S(13)),(ML,U(13)),(NS,S(14)),(NL,U(14)) 
C   
      NEST=14
C   
      NT = DIM(1)      
      SEP = DIM(2)     
      P2 = DIM(3)      
      SIZE = DIM(4) - 1
      P4 = DIM(5)      
      IF (SYM(1).EQ.0) GO TO 500 

      DO  J=1,NEST  
        U(J)=1 
        S(J)=1 
      ENDDO

      N=PTS  
      DO  J=1,NEST  
        IF (SYM(J).EQ.0) GO TO 300 
        JJ=NEST+1-J      
        U(JJ)=N
        S(JJ)=N/SYM(J)   
        N=N/SYM(J)       
      ENDDO         

  300 CONTINUE         
C   
      JJ=0   
C ======================
      A=0    
  410 A=A+1  
      IF(A.GT.AL) GO TO 420      
C ==========DO 400 A=1,AL

      DO  B=A,BL,BS 
      DO  C=B,CL,CS 
      DO  D=C,DL,DS 
      DO  E=D,EL,ES 
      DO  F=E,FL,FS 
      DO  G=F,GL,GS 
      DO  H=G,HL,HS 
      DO  I=H,IL,IS 
      DO  J=I,JL,JS 
      DO  K=J,KL,KS 
      DO  L=K,LL,LS 
      DO  M=L,ML,MS 
      DO  N=M,NL,NS 
        JJ=JJ+1
        IF (JJ.GE.N) GO TO 400     
        DELTA = (N-JJ)*SEP         
        P1 = (JJ-1)*SEP + 1        
        DO  P0 = P1, NT, P2     
          P3 = P0 + SIZE   
          DO  P = P0, P3, P4      
            P5 = P + DELTA   
            T = X(P)         
            X(P) = X(P5)     
            X(P5) = T        
            T = Y(P)         
            Y(P) = Y(P5)     
            Y(P5) = T        
          ENDDO
        ENDDO 
  400   CONTINUE
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C ---         
      GO TO 410        
  420 CONTINUE         
C   
  500 CONTINUE         
      IF (UN SYM(1).EQ.0) GO TO 1900      
      P UN SYM=PTS/P SYM**2      
      MULT=P UN SYM/UN SYM(1)    
      TEST=(UN SYM(1)*UN SYM(2)-1)*MULT*P SYM       
      LK=MULT
      DK=MULT

      DO K=2,NEST  
        IF (UN SYM(K).EQ.0) GO TO 700       
        LK=LK*UN SYM(K-1)
        DK=DK/UN SYM(K)  
        U(K)=(LK-DK)*P SYM         
        MODS=K 
      ENDDO
  700 CONTINUE         
      ONE MOD=MODS.LT.3
      IF (ONE MOD) GO TO 900     
      DO  J=3,MODS  
        JJ=MODS+3-J      
        MODULO(JJ)=U(J)  
      ENDDO
  900 CONTINUE         
      MODULO(2)=U(2)   
      JL=(P UN SYM-3)*P SYM      
      MS=P UN SYM*P SYM
C   
    
      DO J=P SYM,JL,P SYM   
        K=J    
C   
 1000   CONTINUE         
        K=K*MULT         
        IF (ONE MOD) GO TO 1200    

        DO  I=3,MODS 
          K=K-(K/MODULO(I))*MODULO(I)
        ENDDO

 1200   CONTINUE         
        IF (K.GE.TEST) GO TO 1300  
        K=K-(K/MODULO(2))*MODULO(2)
        GO TO 1400       
 1300   CONTINUE         
        K=K-(K/MODULO(2))*MODULO(2)+MODULO(2)         
 1400   CONTINUE         
        IF (K.LT.J) GO TO 1000     
C   
        IF (K.EQ.J) GO TO 1700     
        DELTA = (K-J)*SEP
        DO  L=1,P SYM
          DO  M=L,PTS,MS         
            P1 = (M+J-1)*SEP + 1       
            DO  P0 = P1, NT, P2    
              P3 = P0 + SIZE   
              DO  JJ = P0, P3, P4    
                KK = JJ + DELTA  
                T=X(JJ)
                X(JJ)=X(KK)      
                X(KK)=T
                T=Y(JJ)
                Y(JJ)=Y(KK)      
                Y(KK)=T
              ENDDO
            ENDDO
          ENDDO
        ENDDO                 
 1700   CONTINUE         
      ENDDO
C   
 1900 CONTINUE         
      RETURN 
      END    
C ******
      SUBROUTINE HERMFT (X, Y, N, DIM,IERR)   
      INTEGER N        
      INTEGER DIM(*)   
CMS      : X,Y
      REAL X(*), Y(*)  
C   
C     HERMITIAN SYMMETRIC FOURIER TRANSFORM         
C   
C     GIVEN THE UNIQUE TERMS OF A HERMITIAN SYMMETRIC SEQUENCE OF LENGTH
C     2N THIS SUBROUTINE CALCULATES THE 2N REAL NUMBERS WHICH ARE ITS 
C     FOURIER TRANSFORM.  THE EVEN NUMBERED ELEMENTS OF THE TRANSFORM 
C     (0, 2, 4, . . ., 2N-2) ARE RETURNED IN X AND THE ODD NUMBERED   
C     ELEMENTS (1, 3, 5, . . ., 2N-1) IN Y.         
C   
C     A FINITE HERMITIAN SEQUENCE OF LENGTH 2N CONTAINS N + 1 UNIQUE  
C     REAL NUMBERS AND N - 1 UNIQUE IMAGINARY NUMBERS.  FOR CONVENIENCE 
C     THE REAL VALUE FOR X(N) IS STORED AT Y(0).    
C   
C ******
      REAL A, B, C, D, E, F, ANGLE, CO, SI, TWO N, TWO PI     
      INTEGER NT, D2, D3, D4, D5 
      INTEGER I, J, K, N OVER 2, I0, I1, I2         
      INTEGER K1       
C -------------------------    
      TWO PI = 6.283185
      TWO N = FLOAT(2*N)         
      IERR=0
      NT = DIM(1)      
      D2 = DIM(2)      
      D3 = DIM(3)      
      D4 = DIM(4) - 1  
      D5 = DIM(5)      
    
      DO  I0 = 1, NT, D3      
        I1 = I0 + D4     
        DO  I = I0, I1, D5      
          A = X(I)         
          B = Y(I)         
          X(I) = A + B     
          Y(I) = A - B     
        ENDDO
      ENDDO    
      N OVER 2 = N/2 + 1         
      IF (N OVER 2 .LT. 2) GO TO 500      

      DO  I0 = 2, N OVER 2    
        ANGLE = TWO PI*FLOAT(I0-1)/TWO N    
        CO = COS(ANGLE)  
        SI = SIN(ANGLE)  
        K = (N + 2 - 2*I0)*D2      
        K1 = (I0 - 1)*D2 + 1       
        DO  I1 = K1, NT, D3     
          I2 = I1 + D4     
          DO  I = I1, I2, D5      
            J = I + K        
            A = X(I) + X(J)  
            B = X(I) - X(J)  
            C = Y(I) + Y(J)  
            D = Y(I) - Y(J)  
            E = B*CO + C*SI  
            F = B*SI - C*CO  
            X(I) = A + F     
            X(J) = A - F     
            Y(I) = E + D     
            Y(J) = E - D     
          ENDDO
        ENDDO
      ENDDO
    
      CALL CMPLFT (X, Y, N, DIM,IERR)
    
  500 CONTINUE         
      RETURN 
    
      END    
      SUBROUTINE MDFTKD(N, FACTOR, DIM, X, Y,IERR)    
C     MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL DRIVER       
C   
      INTEGER N        
      INTEGER FACTOR (*), DIM(*)
CMS      : X,Y
      REAL X(*), Y(*)
C   
      INTEGER F, M, P, R, S      
C ----------------------------   
      IERR=0
      S = DIM(2)       
      F = 0  
      M = N  
  100 CONTINUE         
      F = F + 1        
      P = FACTOR(F)    
      IF(P.EQ.0) RETURN         
      M = M/P
      R = M*S

      IF (P.GT.8) GO TO 700      
C      GO TO (100, 200, 300, 400, 500, 800, 700, 600), P       

      IF(P.EQ.1) GO TO 100 
      IF(P.EQ.2) GO TO 200
      IF(P.EQ.3) GO TO 300 
      IF(P.EQ.4) GO TO 400 
      IF(P.EQ.5) GO TO 500
      IF(P.EQ.6) GO TO 800 
      IF(P.EQ.7) GO TO 700 
      IF(P.EQ.8) GO TO 600       

      GO TO 800        
C   
  200 CONTINUE         
      CALL R2 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), DIM)    
      GO TO 100        
C   
  300 CONTINUE         
      CALL R3 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), X(2*R+1), Y(2*R+1)
     ., DIM) 
      GO TO 100        
C   
  400 CONTINUE         
      CALL R4 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), X(2*R+1), Y(2*R+1)
     ., X(3*R+1), Y(3*R+1), DIM) 
      GO TO 100        
C   
  500 CONTINUE         
      CALL R5 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), X(2*R+1), Y(2*R+1)
     ., X(3*R+1), Y(3*R+1), X(4*R+1), Y(4*R+1), DIM)
      GO TO 100        
C   
  600 CONTINUE         
      CALL R8 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), X(2*R+1), Y(2*R+1)
     ., X(3*R+1), Y(3*R+1), X(4*R+1), Y(4*R+1), X(5*R+1), Y(5*R+1),   
     .X(6*R+1), Y(6*R+1), X(7*R+1), Y(7*R+1), DIM)  
      GO TO 100        
C   
  700 CONTINUE         
      CALL RP CFTK (N, M, P, R, X, Y, DIM)
      GO TO 100        
C   
  800 CONTINUE         
C      WRITE(*,900)
C  900 FORMAT (' ERR: TRANSFER ERROR DETECTED IN MDFTKD',//)
C      CALL MSGERR(MDOC,' ERR: TRANSFER ERROR DETECTED IN MDFTKD')
      IERR=1
      RETURN 
      END    
C ******
      SUBROUTINE REALFT (EVEN, ODD, N, DIM,IERR)        
      INTEGER N        
      INTEGER DIM(*)   
CMS      : EVEN,ODD
      REAL EVEN(*), ODD(*)       
C   
C     REAL FOURIER TRANSFORM     
C   
C     GIVEN A REAL SEQUENCE OF LENGTH 2N THIS SUBROUTINE CALCULATES THE 
C     UNIQUE PART OF THE FOURIER TRANSFORM.  THE FOURIER TRANSFORM HAS
C     N + 1 UNIQUE REAL PARTS AND N - 1 UNIQUE IMAGINARY PARTS.  SINCE
C     THE REAL PART AT X(N) IS FREQUENTLY OF INTEREST, THIS SUBROUTINE
C     STORES IT AT X(N) RATHER THAN IN Y(0).  THEREFORE X AND Y MUST BE 
C     OF LENGTH N + 1 INSTEAD OF N.  NOTE THAT THIS STORAGE ARRANGEMENT
C     IS DIFFERENT FROM THAT EMPLOYED BY THE HERMITIAN FOURIER TRANSFORM
C     SUBROUTINE.      
C   
C     FOR CONVENIENCE THE DATA IS PRESENTED IN TWO PARTS, THE FIRST   
C     CONTAINING THE EVEN NUMBERED REAL TERMS AND THE SECOND CONTAINING 
C     THE ODD NUMBERED TERMS (NUMBERING STARTING AT 0).  ON RETURN THE
C     REAL PART OF THE TRANSFORM REPLACES THE EVEN TERMS AND THE      
C     IMAGINARY PART OF THE TRANSFORM REPLACES THE ODD TERMS. 
C   
C ******
      REAL A, B, C, D, E, F, ANGLE, CO, SI, TWO PI, TWO N     
      INTEGER NT, D2, D3, D4, D5 
      INTEGER I, J, K, L, N OVER 2, I0, I1, I2      
    
      TWO PI = 6.283185
      TWO N = FLOAT(2*N)         
      IERR=0    
      CALL CMPL FT (EVEN, ODD, N, DIM,IERR)    
      IF(IERR.GT.0) GO TO 600   
      NT = DIM(1)      
      D2 = DIM(2)      
      D3 = DIM(3)      
      D4 = DIM(4) - 1  
      D5 = DIM(5)      
      N OVER 2 = N/2 + 1         
    
      IF (N OVER 2 .LT. 2) GO TO 400      
      DO  I = 2, N OVER 2     
        ANGLE = TWO PI*FLOAT(I-1)/TWO N     
        CO = COS(ANGLE)  
        SI = SIN(ANGLE)  
        I0 = (I - 1)*D2 + 1        
        J = (N + 2 - 2*I)*D2       
        DO  I1 = I0, NT, D3     
          I2 = I1 + D4     
          DO  K = I1, I2, D5      
            L = K + J        
            A = (EVEN(L) + EVEN(K))/2.0
            C = (EVEN(L) - EVEN(K))/2.0
            B = (ODD(L) + ODD(K))/2.0  
            D = (ODD(L) - ODD(K))/2.0  
            E = C*SI + B*CO  
            F = C*CO - B*SI  
            EVEN(K) = A + E  
            EVEN(L) = A - E  
            ODD(K) = F - D   
            ODD(L) = F + D   
          ENDDO
        ENDDO
      ENDDO
    
  400 CONTINUE         
      IF (N .LT. 1) GO TO 600    
      J = N*D2         

      DO  I1 = 1, NT, D3      
        I2 = I1 + D4     
        DO  K = I1, I2, D5      
          L = K + J        
          EVEN(L) = EVEN(K) - ODD(K) 
          ODD(L) = 0.0     
          EVEN(K) = EVEN(K) + ODD(K) 
          ODD(K) = 0.0     
        ENDDO
      ENDDO
    
  600 CONTINUE         
      RETURN 
      END
    
      SUBROUTINE RPCFTK (N, M, P, R, X, Y, DIM)    
C     RADIX PRIME MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL  
C   
      INTEGER N, M, P, R, DIM(*) 
CMS      : X,Y
C      REAL X(R,P), Y(R,P)        
C      REAL X(R,*), Y(R,*)        
      REAL X(*), Y(*)        
C   
      LOGICAL FOLD,ZERO
      REAL ANGLE,IS,IU,RS,RU,T,TWOPI,XT,YT
      REAL FU, FP, FJM1, FMP     
      INTEGER J,JJ,K0,K,M OVER 2,MP,PM,PP,U,V       
      INTEGER K1, K2, KK, L, L1, MMP, NT, SIZE, SEP 
      INTEGER NS, KKK1, KKK2      
C   
      REAL AA (9,9), BB (9,9)    
      REAL A (18), B (18), C (18), S (18) 
      REAL IA (9), IB (9), RA (9), RB (9) 
      DATA TWO PI/6.283185/      
C   
      NT  = DIM(1)      
      SEP = DIM(2)     
      L1  = DIM(3)      
      SIZE = DIM(4) - 1
      K2 = DIM(5)      
      NS = N*SEP       
      M OVER 2=M/2+1   
      MP  = M*P 
      FMP = FLOAT(MP)  
      MMP = SEP*MP     
      PP = P/2 
      PM = P-1 
      FP = FLOAT(P)    
      FU = 0.0         
      DO 100 U=1,PP    
      FU = FU + 1.0    
      ANGLE = TWO PI*FU/FP       
      JJ=P-U 
      A(U)=COS(ANGLE)  
      B(U)=SIN(ANGLE)  
      A(JJ)=A(U)       
      B(JJ)=-B(U)      
  100 CONTINUE         
      DO 300 U=1,PP    
      DO 200 V=1,PP    
      JJ=U*V-U*V/P*P   
      AA(V,U)=A(JJ)    
      BB(V,U)=B(JJ)    
  200 CONTINUE         
  300 CONTINUE         
C   
      FJM1 = -1.0      
      DO 1500 J=1,M OVER 2       
      FOLD=J.GT.1 .AND. 2*J.LT.M+2        
      K0 = (J-1)*SEP + 1         
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FMP    
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 700        
      C(1)=COS(ANGLE)  
      S(1)=SIN(ANGLE)  
      DO 400 U=2,PM    
      C(U)=C(U-1)*C(1)-S(U-1)*S(1)        
      S(U)=S(U-1)*C(1)+C(U-1)*S(1)        
  400 CONTINUE         
      GO TO 700        
  500 CONTINUE         
      FOLD=.FALSE.     
      K0 = (M+1-J)*SEP + 1       
      DO 600 U=1,PM    
      T=C(U)*A(U)+S(U)*B(U)      
      S(U)=-S(U)*A(U)+C(U)*B(U)  
      C(U)=T 
  600 CONTINUE         
  700 CONTINUE         
C   
      DO 1400 KK = K0, NS, MMP  
      DO 1340 L = KK, NT, L1    
      K1 = L + SIZE    
      DO 1320 K = L, K1, K2     
        
        XT=X(K)        
        YT=Y(K)

        KKK1 = R + K
        KKK2 = R*(P-1) + K        
        RS=X(KKK1)+X(KKK2) 
        IS=Y(KKK1)+Y(KKK2) 
        RU=X(KKK1)-X(KKK2) 
        IU=Y(KKK1)-Y(KKK2) 

C      XT=X(K,1)        
C      YT=Y(K,1)        
C      RS=X(K,2)+X(K,P) 
C      IS=Y(K,2)+Y(K,P) 
C      RU=X(K,2)-X(K,P) 
C      IU=Y(K,2)-Y(K,P) 

      DO 800 U=1,PP    
      RA(U)=XT+RS*AA(U,1)       
      IA(U)=YT+IS*AA(U,1)       
      RB(U)=RU*BB(U,1) 
      IB(U)=IU*BB(U,1) 
  800 CONTINUE         
      XT=XT+RS         
      YT=YT+IS         
      DO 1000 U=2,PP   
      JJ=P-U 

        KKK1 = R*U  + K
        KKK2 = R*JJ + K        

        RS=X(KKK1)+X(KKK2)     
        IS=Y(KKK1)+Y(KKK2)     
        RU=X(KKK1)-X(KKK2)     
        IU=Y(KKK1)-Y(KKK2)     

C      RS=X(K,U+1)+X(K,JJ+1)     
C      IS=Y(K,U+1)+Y(K,JJ+1)     
C      RU=X(K,U+1)-X(K,JJ+1)     
C      IU=Y(K,U+1)-Y(K,JJ+1)     

      XT=XT+RS         
      YT=YT+IS         
      DO 900 V=1,PP    
      RA(V)=RA(V)+RS*AA(V,U)    
      IA(V)=IA(V)+IS*AA(V,U)    
      RB(V)=RB(V)+RU*BB(V,U)    
      IB(V)=IB(V)+IU*BB(V,U)    
  900 CONTINUE         
 1000 CONTINUE         

      X(K)=XT        
      Y(K)=YT        
C      X(K,1)=XT        
C      Y(K,1)=YT        

      DO 1300 U=1,PP   
      JJ=P-U 
      IF (ZERO) GO TO 1100      
      XT=RA(U)+IB(U)   
      YT=IA(U)-RB(U)   

      KKK1 = R*U  + K
      X(KKK1)=XT*C(U)+YT*S(U)  
      Y(KKK1)=YT*C(U)-XT*S(U)  

C      X(K,U+1)=XT*C(U)+YT*S(U)  
C      Y(K,U+1)=YT*C(U)-XT*S(U)  

      XT=RA(U)-IB(U)   
      YT=IA(U)+RB(U)   

      KKK1 = R*JJ  + K
      X(KKK1)=XT*C(JJ)+YT*S(JJ)         
      Y(KKK1)=YT*C(JJ)-XT*S(JJ)         

C      X(K,JJ+1)=XT*C(JJ)+YT*S(JJ)         
C      Y(K,JJ+1)=YT*C(JJ)-XT*S(JJ)         

      GO TO 1200       
 1100 CONTINUE         

      KKK1 = R*U  + K
      KKK2 = R*JJ + K        
      X(KKK1)=RA(U)+IB(U)      
      Y(KKK1)=IA(U)-RB(U)      
      X(KKK2)=RA(U)-IB(U)     
      Y(KKK2)=IA(U)+RB(U)     

C      X(K,U+1)=RA(U)+IB(U)      
C      Y(K,U+1)=IA(U)-RB(U)      
C      X(K,JJ+1)=RA(U)-IB(U)     
C      Y(K,JJ+1)=IA(U)+RB(U)     

 1200 CONTINUE         
 1300 CONTINUE         
 1320 CONTINUE         
 1340 CONTINUE         
 1400 CONTINUE         
      IF (FOLD) GO TO 500       
 1500 CONTINUE         
C  
      RETURN 
      END    
      SUBROUTINE R2CFTK (N, M, X0, Y0, X1, Y1, DIM)
C     RADIX 2 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL      
C  
      INTEGER N, M, DIM(*)      
CMS      : X0,Y0,X1,Y1
      REAL X0 (*), Y0 (*), X1 (*), Y1 (*)       
C  
      LOGICAL FOLD,ZERO
      INTEGER J,K,K0,M2,M OVER 2
      INTEGER K1, K2, KK, L, L1, MM2, NT, SIZE, SEP 
      INTEGER NS       
      REAL ANGLE,C,IS,IU,RS,RU,S,TWOPI    
      REAL FJM1, FM2   
      DATA TWO PI/6.283185/     
C  
      NT = DIM(1)      
      SEP = DIM(2)     
      L1 = DIM(3)      
      SIZE = DIM(4) - 1
      K2 = DIM(5)      
      NS = N*SEP       
      M2=M*2 
      FM2 = FLOAT(M2)  
      M OVER 2=M/2+1   
      MM2 = SEP*M2     
C  
      FJM1 = -1.0      
      DO 600 J=1,M OVER 2       
      FOLD=J.GT.1 .AND. 2*J.LT.M+2        
      K0 = (J-1)*SEP + 1        
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FM2   
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 200       
      C=COS(ANGLE)     
      S=SIN(ANGLE)     
      GO TO 200        
  100 CONTINUE         
      FOLD=.FALSE.     
      K0 = (M+1-J)*SEP + 1      
      C=-C   
  200 CONTINUE         
C  
      DO 500 KK = K0, NS, MM2   
      DO 440 L = KK, NT, L1     
      K1 = L + SIZE    
      DO 420 K = L, K1, K2      
      RS=X0(K)+X1(K)   
      IS=Y0(K)+Y1(K)   
      RU=X0(K)-X1(K)   
      IU=Y0(K)-Y1(K)   
      X0(K)=RS         
      Y0(K)=IS         
      IF (ZERO) GO TO 300       
      X1(K)=RU*C+IU*S  
      Y1(K)=IU*C-RU*S  
      GO TO 400        
  300 CONTINUE         
      X1(K)=RU         
      Y1(K)=IU         
  400 CONTINUE         
  420 CONTINUE         
  440 CONTINUE         
  500 CONTINUE         
      IF (FOLD) GO TO 100       
  600 CONTINUE         
C  
      RETURN 
      END    
      SUBROUTINE R3CFTK (N, M, X0, Y0, X1, Y1, X2, Y2, DIM)
C     RADIX 3 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL      
C  
      INTEGER N, M, DIM(*)      
CMS      : X0,Y0,X1,Y1,X2,Y2
      REAL X0 (*), Y0 (*), X1 (*), Y1 (*), X2 (*), Y2 (*)       
C  
      LOGICAL FOLD,ZERO
      INTEGER J,K,K0,M3,M OVER 2
      INTEGER K1, K2, KK, L, L1, MM3, NT, SIZE, SEP 
      INTEGER NS       
      REAL ANGLE,A,B,C1,C2,S1,S2,T,TWOPI  
      REAL I0,I1,I2,IA,IB,IS,R0,R1,R2,RA,RB,RS      
      REAL FJM1, FM3   
      DATA TWO PI/6.283185/, A/-0.5/, B/0.86602540/ 
C  
      NT = DIM(1)      
      SEP = DIM(2)     
      L1 = DIM(3)      
      SIZE = DIM(4) - 1
      K2 = DIM(5)      
      NS = N*SEP       
      M3=M*3 
      FM3 = FLOAT(M3)  
      MM3 = SEP*M3     
      M OVER 2=M/2+1   
C  
      FJM1 = -1.0      
      DO 600 J=1,M OVER 2       
      FOLD=J.GT.1 .AND. 2*J.LT.M+2        
      K0 = (J-1)*SEP + 1        
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FM3   
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 200       
      C1=COS(ANGLE)    
      S1=SIN(ANGLE)    
      C2=C1*C1-S1*S1   
      S2=S1*C1+C1*S1   
      GO TO 200        
  100 CONTINUE         
      FOLD=.FALSE.     
      K0 = (M+1-J)*SEP + 1      
      T=C1*A+S1*B      
      S1=C1*B-S1*A     
      C1=T   
      T=C2*A-S2*B      
      S2=-C2*B-S2*A    
      C2=T   
  200 CONTINUE         
C  
      DO 500 KK = K0, NS, MM3   
      DO 440 L = KK, NT, L1     
      K1 = L + SIZE    
      DO 420 K = L, K1, K2      
      R0=X0(K)         
      I0=Y0(K)         
      RS=X1(K)+X2(K)   
      IS=Y1(K)+Y2(K)   
      X0(K)=R0+RS      
      Y0(K)=I0+IS      
      RA=R0+RS*A       
      IA=I0+IS*A       
      RB=(X1(K)-X2(K))*B        
      IB=(Y1(K)-Y2(K))*B        
      IF (ZERO) GO TO 300       
      R1=RA+IB         
      I1=IA-RB         
      R2=RA-IB         
      I2=IA+RB         
      X1(K)=R1*C1+I1*S1
      Y1(K)=I1*C1-R1*S1
      X2(K)=R2*C2+I2*S2
      Y2(K)=I2*C2-R2*S2
      GO TO 400        
  300 CONTINUE         
      X1(K)=RA+IB      
      Y1(K)=IA-RB      
      X2(K)=RA-IB      
      Y2(K)=IA+RB      
  400 CONTINUE         
  420 CONTINUE         
  440 CONTINUE         
  500 CONTINUE         
      IF (FOLD) GO TO 100       
  600 CONTINUE         
C  
      RETURN 
      END    
      SUBROUTINE R4CFTK (N, M, X0, Y0, X1, Y1, X2, Y2, X3, Y3, DIM)  
C     RADIX 4 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL      
C  
      INTEGER N, M, DIM(*)      
CMS      : X0,Y0,X1,Y1,X2,Y2,X3,Y3
      REAL X0 (*), Y0 (*), X1 (*), Y1 (*)       
      REAL X2 (*), Y2 (*), X3 (*), Y3 (*)       
C  
      LOGICAL FOLD,ZERO
      INTEGER J,K,K0,M4,M OVER 2
      INTEGER K1, K2, KK, L, L1, MM4, NT, SIZE, SEP 
      INTEGER NS       
      REAL ANGLE,C1,C2,C3,S1,S2,S3,T,TWOPI
      REAL I1,I2,I3,IS0,IS1,IU0,IU1,R1,R2,R3,RS0,RS1,RU0,RU1
      REAL FJM1, FM4   
      DATA TWO PI/6.283185/     
C  
      NT = DIM(1)      
      SEP = DIM(2)     
      L1 = DIM(3)      
      SIZE = DIM(4) - 1
      K2 = DIM(5)      
      NS = N*SEP       
      M4=M*4 
      FM4 = FLOAT(M4)  
      MM4 = SEP*M4     
      M OVER 2=M/2+1   
C  
      FJM1 = -1.0      
      DO 600 J=1,M OVER 2       
      FOLD=J.GT.1 .AND. 2*J.LT.M+2        
      K0 = (J-1)*SEP + 1        
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FM4   
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 200       
      C1=COS(ANGLE)    
      S1=SIN(ANGLE)    
      C2=C1*C1-S1*S1   
      S2=S1*C1+C1*S1   
      C3=C2*C1-S2*S1   
      S3=S2*C1+C2*S1   
      GO TO 200        
  100 CONTINUE         
      FOLD=.FALSE.     
      K0 = (M+1-J)*SEP + 1      
      T=C1   
      C1=S1  
      S1=T   
      C2=-C2 
      T=C3   
      C3=-S3 
      S3=-T  
  200 CONTINUE         
C  
      DO 500 KK = K0, NS, MM4   
      DO 440 L = KK, NT, L1     
      K1 = L + SIZE    
      DO 420 K = L, K1, K2      
      RS0=X0(K)+X2(K)  
      IS0=Y0(K)+Y2(K)  
      RU0=X0(K)-X2(K)  
      IU0=Y0(K)-Y2(K)  
      RS1=X1(K)+X3(K)  
      IS1=Y1(K)+Y3(K)  
      RU1=X1(K)-X3(K)  
      IU1=Y1(K)-Y3(K)  
      X0(K)=RS0+RS1    
      Y0(K)=IS0+IS1    
      IF (ZERO) GO TO 300       
      R1=RU0+IU1       
      I1=IU0-RU1       
      R2=RS0-RS1       
      I2=IS0-IS1       
      R3=RU0-IU1       
      I3=IU0+RU1       
      X2(K)=R1*C1+I1*S1
      Y2(K)=I1*C1-R1*S1
      X1(K)=R2*C2+I2*S2
      Y1(K)=I2*C2-R2*S2
      X3(K)=R3*C3+I3*S3
      Y3(K)=I3*C3-R3*S3
      GO TO 400        
  300 CONTINUE         
      X2(K)=RU0+IU1    
      Y2(K)=IU0-RU1    
      X1(K)=RS0-RS1    
      Y1(K)=IS0-IS1    
      X3(K)=RU0-IU1    
      Y3(K)=IU0+RU1    
  400 CONTINUE         
  420 CONTINUE         
  440 CONTINUE         
  500 CONTINUE         
      IF (FOLD) GO TO 100       
  600 CONTINUE         
C  
      RETURN 
      END    
      SUBROUTINE R5CFTK (N, M, X0, Y0, X1, Y1, X2, Y2, X3, Y3, X4, Y4, 
     . DIM)  
C     RADIX 5 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL      
C  
      INTEGER N, M, DIM(*)      
CMS      : X0,Y0,X1,Y1,X2,Y2,X3,Y3,X4,Y4
      REAL X0 (*), Y0 (*), X1 (*), Y1 (*), X2 (*), Y2 (*)       
      REAL X3 (*), Y3 (*), X4 (*), Y4 (*)       
C  
      LOGICAL FOLD,ZERO
      INTEGER J,K,K0,M5,M OVER 2
      INTEGER K1, K2, KK, L, L1, MM5, NT, SIZE, SEP 
      INTEGER NS       
      REAL ANGLE,A1,A2,B1,B2,C1,C2,C3,C4,S1,S2,S3,S4,T,TWOPI
      REAL R0,R1,R2,R3,R4,RA1,RA2,RB1,RB2,RS1,RS2,RU1,RU2   
      REAL I0,I1,I2,I3,I4,IA1,IA2,IB1,IB2,IS1,IS2,IU1,IU2   
      REAL FJM1, FM5   
      DATA TWO PI/6.283185/, A1/0.30901699/, B1/0.95105652/,
     .      A2/-0.80901699/, B2/0.58778525/         
C  
      NT = DIM(1)      
      SEP = DIM(2)     
      L1 = DIM(3)      
      SIZE = DIM(4) - 1
      K2 = DIM(5)      
      NS = N*SEP       
      M5=M*5 
      FM5 = FLOAT(M5)  
      MM5 = SEP*M5     
      M OVER 2=M/2+1   
C  
      FJM1 = -1.0      
      DO 600 J=1,M OVER 2       
      FOLD=J.GT.1 .AND. 2*J.LT.M+2        
      K0 = (J-1)*SEP + 1        
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FM5   
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 200       
      C1=COS(ANGLE)    
      S1=SIN(ANGLE)    
      C2=C1*C1-S1*S1   
      S2=S1*C1+C1*S1   
      C3=C2*C1-S2*S1   
      S3=S2*C1+C2*S1   
      C4=C2*C2-S2*S2   
      S4=S2*C2+C2*S2   
      GO TO 200        
  100 CONTINUE         
      FOLD=.FALSE.     
      K0 = (M+1-J)*SEP + 1      
      T=C1*A1+S1*B1    
      S1=C1*B1-S1*A1   
      C1=T   
      T=C2*A2+S2*B2    
      S2=C2*B2-S2*A2   
      C2=T   
      T=C3*A2-S3*B2    
      S3=-C3*B2-S3*A2  
      C3=T   
      T=C4*A1-S4*B1    
      S4=-C4*B1-S4*A1  
      C4=T   
  200 CONTINUE         
C  
      DO 500 KK = K0, NS, MM5   
      DO 440 L = KK, NT, L1     
      K1 = L + SIZE    
      DO 420 K = L, K1, K2      
      R0=X0(K)         
      I0=Y0(K)         
      RS1=X1(K)+X4(K)  
      IS1=Y1(K)+Y4(K)  
      RU1=X1(K)-X4(K)  
      IU1=Y1(K)-Y4(K)  
      RS2=X2(K)+X3(K)  
      IS2=Y2(K)+Y3(K)  
      RU2=X2(K)-X3(K)  
      IU2=Y2(K)-Y3(K)  
      X0(K)=R0+RS1+RS2 
      Y0(K)=I0+IS1+IS2 
      RA1=R0+RS1*A1+RS2*A2      
      IA1=I0+IS1*A1+IS2*A2      
      RA2=R0+RS1*A2+RS2*A1      
      IA2=I0+IS1*A2+IS2*A1      
      RB1=RU1*B1+RU2*B2
      IB1=IU1*B1+IU2*B2
      RB2=RU1*B2-RU2*B1
      IB2=IU1*B2-IU2*B1
      IF (ZERO) GO TO 300       
      R1=RA1+IB1       
      I1=IA1-RB1       
      R2=RA2+IB2       
      I2=IA2-RB2       
      R3=RA2-IB2       
      I3=IA2+RB2       
      R4=RA1-IB1       
      I4=IA1+RB1       
      X1(K)=R1*C1+I1*S1
      Y1(K)=I1*C1-R1*S1
      X2(K)=R2*C2+I2*S2
      Y2(K)=I2*C2-R2*S2
      X3(K)=R3*C3+I3*S3
      Y3(K)=I3*C3-R3*S3
      X4(K)=R4*C4+I4*S4
      Y4(K)=I4*C4-R4*S4
      GO TO 400        
  300 CONTINUE         
      X1(K)=RA1+IB1    
      Y1(K)=IA1-RB1    
      X2(K)=RA2+IB2    
      Y2(K)=IA2-RB2    
      X3(K)=RA2-IB2    
      Y3(K)=IA2+RB2    
      X4(K)=RA1-IB1    
      Y4(K)=IA1+RB1    
  400 CONTINUE         
  420 CONTINUE         
  440 CONTINUE         
  500 CONTINUE         
      IF (FOLD) GO TO 100       
  600 CONTINUE         
C  
      RETURN 
      END    
      SUBROUTINE R8CFTK (N, M, X0, Y0, X1, Y1, X2, Y2, X3, Y3, X4, Y4, 
     . X5, Y5, X6, Y6, X7, Y7, DIM)       
C     RADIX 8 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL      
C  
      INTEGER N, M, DIM(*)      
CMS      : X0,Y0,X1,Y1,X2,Y2,X3,Y3,X4,Y4,X5,Y5,X6,Y6,X7,Y7
      REAL X0 (*), Y0 (*), X1 (*), Y1 (*), X2 (*), Y2 (*)       
      REAL X3 (*), Y3 (*), X4 (*), Y4 (*), X5 (*), Y5 (*)       
      REAL X6 (*), Y6 (*), X7 (*), Y7 (*)       
C  
      LOGICAL FOLD,ZERO
      INTEGER J,K,K0,M8,M OVER 2
      INTEGER K1, K2, KK, L, L1, MM8, NT, SIZE, SEP 
      INTEGER NS       
      REAL ANGLE,C1,C2,C3,C4,C5,C6,C7,E,S1,S2,S3,S4,S5,S6,S7,T,TWOPI  
      REAL R1,R2,R3,R4,R5,R6,R7,RS0,RS1,RS2,RS3,RU0,RU1,RU2,RU3       
      REAL I1,I2,I3,I4,I5,I6,I7,IS0,IS1,IS2,IS3,IU0,IU1,IU2,IU3       
      REAL RSS0,RSS1,RSU0,RSU1,RUS0,RUS1,RUU0,RUU1  
      REAL ISS0,ISS1,ISU0,ISU1,IUS0,IUS1,IUU0,IUU1  
      REAL FJM1, FM8   
      DATA TWO PI/6.283185/, E/0.70710678/
C  
      NT = DIM(1)      
      SEP = DIM(2)     
      L1 = DIM(3)      
      SIZE = DIM(4) - 1
      K2 = DIM(5)      
      NS = N*SEP       
      M8=M*8 
      FM8 = FLOAT(M8)  
      MM8 = SEP*M8     
      M OVER 2=M/2+1   
C  
      FJM1 = -1.0      
      DO 600 J=1,M OVER 2       
      FOLD=J.GT.1 .AND. 2*J.LT.M+2        
      K0 = (J-1)*SEP + 1        
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FM8   
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 200       
      C1=COS(ANGLE)    
      S1=SIN(ANGLE)    
      C2=C1*C1-S1*S1   
      S2=S1*C1+C1*S1   
      C3=C2*C1-S2*S1   
      S3=S2*C1+C2*S1   
      C4=C2*C2-S2*S2   
      S4=S2*C2+C2*S2   
      C5=C4*C1-S4*S1   
      S5=S4*C1+C4*S1   
      C6=C4*C2-S4*S2   
      S6=S4*C2+C4*S2   
      C7=C4*C3-S4*S3   
      S7=S4*C3+C4*S3   
      GO TO 200        
  100 CONTINUE         
      FOLD=.FALSE.     
      K0 = (M+1-J)*SEP + 1      
      T=(C1+S1)*E      
      S1=(C1-S1)*E     
      C1=T   
      T=S2   
      S2=C2  
      C2=T   
      T=(-C3+S3)*E     
      S3=(C3+S3)*E     
      C3=T   
      C4=-C4 
      T=-(C5+S5)*E     
      S5=(-C5+S5)*E    
      C5=T   
      T=-S6  
      S6=-C6 
      C6=T   
      T=(C7-S7)*E      
      S7=-(C7+S7)*E    
      C7=T   
  200 CONTINUE         
C  
      DO 500 KK = K0, NS, MM8   
      DO 440 L = KK, NT, L1     
      K1 = L + SIZE    
      DO 420 K = L, K1, K2      
      RS0=X0(K)+X4(K)  
      IS0=Y0(K)+Y4(K)  
      RU0=X0(K)-X4(K)  
      IU0=Y0(K)-Y4(K)  
      RS1=X1(K)+X5(K)  
      IS1=Y1(K)+Y5(K)  
      RU1=X1(K)-X5(K)  
      IU1=Y1(K)-Y5(K)  
      RS2=X2(K)+X6(K)  
      IS2=Y2(K)+Y6(K)  
      RU2=X2(K)-X6(K)  
      IU2=Y2(K)-Y6(K)  
      RS3=X3(K)+X7(K)  
      IS3=Y3(K)+Y7(K)  
      RU3=X3(K)-X7(K)  
      IU3=Y3(K)-Y7(K)  
      RSS0=RS0+RS2     
      ISS0=IS0+IS2     
      RSU0=RS0-RS2     
      ISU0=IS0-IS2     
      RSS1=RS1+RS3     
      ISS1=IS1+IS3     
      RSU1=RS1-RS3     
      ISU1=IS1-IS3     
      RUS0=RU0-IU2     
      IUS0=IU0+RU2     
      RUU0=RU0+IU2     
      IUU0=IU0-RU2     
      RUS1=RU1-IU3     
      IUS1=IU1+RU3     
      RUU1=RU1+IU3     
      IUU1=IU1-RU3     
      T=(RUS1+IUS1)*E  
      IUS1=(IUS1-RUS1)*E        
      RUS1=T 
      T=(RUU1+IUU1)*E  
      IUU1=(IUU1-RUU1)*E        
      RUU1=T 
      X0(K)=RSS0+RSS1  
      Y0(K)=ISS0+ISS1  
      IF (ZERO) GO TO 300       
      R1=RUU0+RUU1     
      I1=IUU0+IUU1     
      R2=RSU0+ISU1     
      I2=ISU0-RSU1     
      R3=RUS0+IUS1     
      I3=IUS0-RUS1     
      R4=RSS0-RSS1     
      I4=ISS0-ISS1     
      R5=RUU0-RUU1     
      I5=IUU0-IUU1     
      R6=RSU0-ISU1     
      I6=ISU0+RSU1     
      R7=RUS0-IUS1     
      I7=IUS0+RUS1     
      X4(K)=R1*C1+I1*S1
      Y4(K)=I1*C1-R1*S1
      X2(K)=R2*C2+I2*S2
      Y2(K)=I2*C2-R2*S2
      X6(K)=R3*C3+I3*S3
      Y6(K)=I3*C3-R3*S3
      X1(K)=R4*C4+I4*S4
      Y1(K)=I4*C4-R4*S4
      X5(K)=R5*C5+I5*S5
      Y5(K)=I5*C5-R5*S5
      X3(K)=R6*C6+I6*S6
      Y3(K)=I6*C6-R6*S6
      X7(K)=R7*C7+I7*S7
      Y7(K)=I7*C7-R7*S7
      GO TO 400        
  300 CONTINUE         
      X4(K)=RUU0+RUU1  
      Y4(K)=IUU0+IUU1  
      X2(K)=RSU0+ISU1  
      Y2(K)=ISU0-RSU1  
      X6(K)=RUS0+IUS1  
      Y6(K)=IUS0-RUS1  
      X1(K)=RSS0-RSS1  
      Y1(K)=ISS0-ISS1  
      X5(K)=RUU0-RUU1  
      Y5(K)=IUU0-IUU1  
      X3(K)=RSU0-ISU1  
      Y3(K)=ISU0+RSU1  
      X7(K)=RUS0-IUS1  
      Y7(K)=IUS0+RUS1  
  400 CONTINUE         
  420 CONTINUE         
  440 CONTINUE         
  500 CONTINUE         
      IF (FOLD) GO TO 100       
  600 CONTINUE         
C  
      RETURN 
      END    

      SUBROUTINE SRFP (PTS,PMAX,TWO GRP,FACTOR,SYM,P SYM,UN SYM,ERROR)
C     SYMMETRIZED REORDERING FACTORING PROGRAMME    
C  
      LOGICAL ERROR    
      INTEGER PTS,PMAX,TWO GRP,P SYM      
      INTEGER FACTOR (*), SYM (*), UN SYM (*)    
C  
      INTEGER PP(14), QQ (7)    
      INTEGER F,J,JJ,N,NEST,P,P TWO,Q,R   
C     CHARACTER LINE*80
C --------------------------
      MDOC=0
      NEST=14
C  
      N=PTS  
      P SYM=1
      F=2    
      P=0    
      Q=0    
  100 CONTINUE         
      IF (N.LE.1) GO TO 500     
      DO 200 J=F,PMAX  
      IF (N.EQ.(N/J)*J) GO TO 300         
  200 CONTINUE         
      GO TO 1400       
  300 CONTINUE         
      IF (2*P+Q.GE.NEST) GO TO 1600       
      F=J    
      N=N/F  
      IF (N.EQ.(N/F)*F) GO TO 400         
      Q=Q+1  
      QQ(Q)=F
      GO TO 100        
  400 CONTINUE         
      N=N/F  
      P=P+1  
      PP(P)=F
      P SYM=P SYM*F    
      GO TO 100        
C  
  500 CONTINUE         
      R=1    
      IF (Q.EQ.0) R=0  
      IF (P.LT.1) GO TO 700     
      DO 600 J=1,P     
      JJ=P+1-J         
      SYM(J)=PP(JJ)    
      FACTOR(J)=PP(JJ) 
      JJ=P+Q+J         
      FACTOR(JJ)=PP(J) 
      JJ=P+R+J         
      SYM(JJ)=PP(J)    
   
  600 CONTINUE         
  700 CONTINUE         
      IF (Q.LT.1) GO TO 900     
      DO 800 J=1,Q     
      JJ=P+J 
      UN SYM(J)=QQ(J)  
      FACTOR(JJ)=QQ(J) 
  800 CONTINUE         
      SYM(P+1)=PTS/P SYM**2     
  900 CONTINUE         
      JJ=2*P+Q         
      FACTOR(JJ+1)=0   
      P TWO=1
      J=0    
 1000 CONTINUE         
      J=J+1  
      IF (FACTOR(J).EQ.0) GO TO 1200      
      IF (FACTOR(J).NE.2) GO TO 1000      
      P TWO=P TWO*2    
      FACTOR(J)=1      
      IF (P TWO.GE.TWO GRP) GO TO 1100    
      IF (FACTOR(J+1).EQ.2) GO TO 1000    
 1100 CONTINUE         
      FACTOR(J)=P TWO  
      P TWO=1
      GO TO 1000       
 1200 CONTINUE         
      IF (P.EQ.0) R=0  
      JJ=2*P+R         
      SYM(JJ+1)=0      
      IF (Q.LE.1) Q=0  
      UN SYM(Q+1)=0    
      ERROR=.FALSE.    
C  
 1300 CONTINUE         
      RETURN 
C  
 1400 CONTINUE         
C      WRITE(*,1500) PMAX,PTS
C      WRITE(LINE,1500) PMAX,PTS
C      CALL MSGERR(MDOC,LINE)
      ERROR=.TRUE.     
      GO TO 1300       
C 1500 FORMAT (' ERR: LARGEST FACTOR EXCEEDS ',I3,'  N = ',I6)
C  
 1600 CONTINUE         
C      WRITE(*,1700) NEST,PTS
C      WRITE(LINE,1700) NEST,PTS
C      CALL MSGERR(MDOC,LINE)
      ERROR=.TRUE.     
      GO TO 1300       
C 1700 FORMAT (' ERR: FACTOR COUNT EXCEEDS ',I3,'  N = ',I6)
C  
      END    

C ******
      SUBROUTINE MDCFT2(X,D,IERR)
C -P- MDCFT2 -
CMS      : X,D
      REAL    X(*)         
      INTEGER D(*),IERR
C ******
      LOGICAL ERROR     
      INTEGER I,INC,NT,SPACE,PTS,PMAX,PSYM,TWOGRP    
      INTEGER DIM(5),FACTOR(15),SYM(15),UNSYM(15)    
C -----------------------------
C     MDOC=0
      IF(D(1).EQ.0) RETURN        
      PMAX=19
      TWOGRP=8         
      I=2    
      NT=D(1)
  100 IF(D(I).EQ.0) GOTO 200       
      NT=NT*D(I)       
      I=I+1  
      GOTO100
  200 CONTINUE         
      NT=IABS(2*NT)    
      DIM(1)=NT        
      SPACE=NT         
      INC=NT/D(I-1)    
  300 CONTINUE         
      I=I-1  
      IF(I.EQ.0) RETURN 
      IF(D(I).LE.1) GOTO 600       
      PTS=D(I)         
      CALL SRFP(PTS,PMAX,TWOGRP,FACTOR,SYM,PSYM,UNSYM,ERROR)   
      IF(ERROR) GOTO 700 
      IF(I.EQ.1) GOTO 400
      DIM(2)=IABS(INC) 
      DIM(3)=IABS(SPACE)         
      DIM(4)=DIM(2)    
      DIM(5)=2         
      GOTO 500
  400 CONTINUE         
      DIM(2)=2         
      DIM(3)=NT        
      DIM(4)=NT        
      DIM(5)=2*PTS     
  500 CONTINUE         

      CALL MDFTKD(PTS,FACTOR,DIM,X(1),X(2),IERR)
      IF(IERR.GT.0) GO TO 700
      CALL DIPRP(PTS,SYM,PSYM,UNSYM,DIM,X(1),X(2))   
  600 CONTINUE         
      IF(I.LE.2) GOTO 300
      INC=INC/D(I-1)   
      SPACE=SPACE/D(I) 
      GOTO 300
  700 CONTINUE         
C      WRITE(*,800)
C  800 FORMAT(' ERR:  FACTORING ERROR IN MDCFT2'//)
C      CALL MSGERR(MDOC,' ERR:  FACTORING ERROR IN MDCFT2')
      IERR=1
      RETURN 
      END    


C -P-
C -P------ others useful subroutines  --------------------
C -P-
      SUBROUTINE CORR_NAME_BL(NAMEF)
C -------------------------------------------
      CHARACTER NAMEF*(*),NAME*256
C -------------------------------------------
      CALL LENSTR_BL(NAMEF,LEN)
      IF(LEN.GT.0.AND.NAMEF(1:1).NE.','.AND.NAMEF(1:1).NE.' ') THEN
        NAME = NAMEF(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 100
          ENDIF 
        ENDDO
 100    CONTINUE
      ELSE
        NAME = ' '
      ENDIF
      CALL LENSTR_BL(NAME,LEN)
      IF(LEN.GT.4.AND.NAMEF(LEN-3:LEN).EQ.'.dat') THEN
        NAMEF = NAME(1:LEN-4)
      ELSE
        NAMEF = NAME
      ENDIF
      RETURN 
      END

      SUBROUTINE CORR_NAME_BLC(NAMEF)
C -------------------------------------------
      CHARACTER NAMEF*(*),NAME*256
C -------------------------------------------
      CALL LENSTR_BL(NAMEF,LEN)
      IF(LEN.GT.0.AND.NAMEF(1:1).NE.','.AND.NAMEF(1:1).NE.' ') THEN
        NAME = NAMEF(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 100
          ENDIF 
        ENDDO
 100    CONTINUE
      ELSE
        NAME = ' '
      ENDIF
      CALL LENSTR_BL(NAME,LEN)
      IF(LEN.GT.4.AND.NAMEF(LEN-3:LEN).EQ.'.crd') THEN
        NAMEF = NAME(1:LEN-4)
      ELSE
        NAMEF = NAME
      ENDIF
      RETURN 
      END

      SUBROUTINE CORR_NAME_ALL(NAMEF)
C -------------------------------------------
      CHARACTER NAMEF*(*),NAME*256
C -------------------------------------------
      CALL LENSTR_BL(NAMEF,LEN)
      IF(LEN.GT.0.AND.NAMEF(1:1).NE.','.AND.NAMEF(1:1).NE.' ') THEN
        NAME = NAMEF(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 100
          ENDIF 
        ENDDO
 100    CONTINUE
      ELSE
        NAME = ' '
      ENDIF
      NAMEF = NAME
      RETURN 
      END

      SUBROUTINE REMOVE_FIRST_BLANC(LINE)
C -------------------------------------------
      CHARACTER LINE*(*),STR*512
C -------------------------------------------
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.GT.0.AND.LEN.LE.512) THEN
        STR = LINE(1:LEN)
        DO I=1,LEN
          IL = I
          IF(STR(I:I).NE.' ') THEN
            GO TO 100
          ENDIF 
        ENDDO
 100    CONTINUE
        LINE = STR(IL:LEN)
      ENDIF
      RETURN 
      END

      SUBROUTINE CHECK_SF_FILE(MDOC,FILE,MESSAGE,IERR)
C ------------------------------
      INTEGER   MDOC,IERR
      CHARACTER FILE*(*)
      CHARACTER PATH*1,EXT*1
C ------------------------------
      CHARACTER LINE*256
      CHARACTER MESSAGE*(*),CIF*1,SPGR*11,MAP*1,MTZ*1,BLANC*1
      INTEGER   ID(10)
C -----------------------------------------------------------
      M    = 99
      MD   =-ABS(MDOC)-1
      IERR = 0
C ---
      MESSAGE = ' '
      CIF  = 'N'
      MAP  = 'N'
      MTZ  = 'N'
      BLANC = 'N'
      IFIRST = 0
      ISCIP  = 0
      EXT  = ' '
      PATH = ' '
      IN   = 10
      CALL CORR_NAME_ALL(FILE)
      CALL LENSTR_BL(FILE,IFLEN)
      IF(IFLEN.LT.5) THEN 
        LINE = ' ERROR: wrong file name'
        CALL MSGERR(MD,LINE)
        MESSAGE = 'wrong file name'
        IERR = 1
        RETURN
      ENDIF
      CALL OPENFR(IN,M,PATH,FILE,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open input file SF'
        CALL MSGERR(MD,LINE)
        MESSAGE = 'cannot open input file SF'
        IERR = 1
        RETURN
      ENDIF

      DO I=1,2000

        LINE = ' '

        READ(IN,'(A)',END=110,ERR=200) LINE(1:14)

        IMODE = 0
C               MODE  0  only check
C                    -1  convert symbols to low case.
C                     1  to upper
        CALL CHECK_LINE(IMODE,LINE)

        IF(I.EQ.1) THEN
          IF(LINE(1:6).EQ.'HEADER'.OR.LINE(1:6).EQ.'REMARK'.OR.
     *       LINE(1:6).EQ.'CRYST1'.OR.LINE(1:6).EQ.'ATOM  ') THEN
            MESSAGE = 'PDB coordinate file'
            LINE = 'ERROR: it is PDB file of coordinates, not SF'
            CALL MSGERR(MD,LINE)
            CLOSE(IN)
            IERR = 1
            GO TO 300
          ENDIF
          IF(LINE(1:3).EQ.'MTZ') THEN
            MESSAGE = 'MTZ file'
            MTZ = 'Y'
            CLOSE(IN)
            IF(FILE(IFLEN-3:IFLEN).NE.'.mtz') THEN
              LINE = 'ERROR: MTZ_file must has extension ".mtz"'
              CALL MSGERR(MD,LINE)
              IERR = 1
            ENDIF
            GO TO 300
          ELSE IF((LINE( 6: 9).EQ.'F   ').OR.
     *            (LINE(10:13).EQ.'F   ')    ) THEN
            MESSAGE = 'BLANC F_file'
            BLANC = 'F'
            CLOSE(IN)
            IF(FILE(IFLEN-3:IFLEN).NE.'.dat') THEN
              LINE = 'ERROR: BLANC_file must has extension ".dat"'
              CALL MSGERR(MD,LINE)
              IERR = 1
            ENDIF
            GO TO 300
          ELSE IF((LINE( 6: 9).EQ.'FS  ').OR.
     *            (LINE(10:13).EQ.'FS  ')    ) THEN
            MESSAGE = 'BLANC FS_file'
            BLANC = 'F'
            CLOSE(IN)
            IF(FILE(IFLEN-3:IFLEN).NE.'.dat') THEN
              LINE = 'ERROR: BLANC_file must has extension ".dat"'
              CALL MSGERR(MD,LINE)
              IERR = 1
            ENDIF
            GO TO 300
          ELSE IF((LINE( 6: 9).EQ.'RI  ').OR.
     *            (LINE(10:13).EQ.'RI  ')    ) THEN
            MESSAGE = 'MAP BLANC file'
            BLANC = 'D'
            CLOSE(IN)
            IF(FILE(IFLEN-3:IFLEN).NE.'.dat') THEN
              LINE = 'ERROR: BLANC_file must has extension ".dat"'
              CALL MSGERR(MD,LINE)
              IERR = 1
            ENDIF
            GO TO 300
          ENDIF

        ENDIF
        ISCIP = ISCIP + 1
        IF(LINE(1:1).EQ.'#') GO TO 400
        CALL REMOVE_FIRST_BLANC(LINE)
        IF(IFIRST.EQ.0.AND.LINE(1:5).EQ.'data_') CIF = 'I'
        IFIRST = IFIRST + 1
        IF(CIF.EQ.'I'.AND.LINE(1:7).EQ.'_refln.') THEN
          MESSAGE = 'CIF SF File'
          CIF = 'Y'
          CLOSE(IN)
          IF(FILE(IFLEN-3:IFLEN).NE.'.cif'.AND.
     *       FILE(IFLEN-3:IFLEN).NE.'.ent') THEN
         LINE = 'ERROR: CIF_file must has extension ".cif" or ".ent"'
            CALL MSGERR(MD,LINE)
            IERR = 1
          ENDIF
          GO TO 300
        ELSE IF(CIF.EQ.'I'.AND.LINE(1:11).EQ.'_atom_site.') THEN
          MESSAGE = 'CIF coordinate file'
          LINE = 'ERROR: it is CIFile of coordinates, not SF'
          CALL MSGERR(MD,LINE)
          CLOSE(IN)
          IERR = 1
          GO TO 300
        ENDIF

 400    CONTINUE

      ENDDO

 110  CONTINUE

C ---
c ===
c      CLOSE(IN)
c      CALL OPENUR(IN,M,PATH,FILE,EXT,IERR)
c      IF(IERR.NE.0) THEN
c        LINE = ' ERROR: cannot open input file SF'
c        CALL MSGERR(MD,LINE)
c        MESSAGE = 'cannot open input file SF'
c        IERR = 1
c        RETURN
c      ENDIF
c
c      READ(IN,END=100,ERR=200) (ID(J),J=1,9)
c
cc      WRITE(*,*) '>>>I:',(ID(J),J=1,9)
c ===


      MAP = 'Y'
      MESSAGE = 'MAP CCP4 file'
      IF(FILE(IFLEN-3:IFLEN).NE.'.map'.AND.
     *   FILE(IFLEN-4:IFLEN).NE.'.ccp4') THEN
        LINE = 'ERROR: MAP_file must has extension ".map" or ".ccp4"'
        CALL MSGERR(MD,LINE)
        LINE = '       or it is a file with unknown format'
        CALL MSGERR(MD,LINE)
        IERR = 1
      ENDIF
      CLOSE(IN)
      GO TO 300
C ---
 500  CIF = 'N'
      IERR = 1
      MESSAGE = 'unknown file'
      CLOSE(IN)
      RETURN
C ---
 300  CONTINUE
      RETURN
C ---
 100  CONTINUE
      CLOSE(IN)
      LINE = ' ERROR: end of input file SF'
      CALL MSGERR(MD,LINE)
      MESSAGE = 'end of input file SF'
      IERR = 1
      RETURN
 200  CONTINUE
      CLOSE(IN)
      LINE = ' ERROR: read error of input file SF'
      CALL MSGERR(MD,LINE)
      MESSAGE = 'read error of input file SF'
      IERR = 1
      RETURN
      END

      SUBROUTINE CHECK_SEQ_FILE(MDOC,FILE,MESSAGE,IERR)
C ------------------------------
      INTEGER   MDOC,IERR
      CHARACTER FILE*(*)
      CHARACTER PATH*1,EXT*1
C ------------------------------
      CHARACTER AMIN(25)*1
      CHARACTER CH1*1
      CHARACTER LINE*256
      CHARACTER MESSAGE*(*)
c                1   2   3   4   5   6   7   8   9  10  11  12  13
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','X','-'/
c             14  15  16  17  18  19  20  21  22  23  24  25
C -----------------------------------------------------------
      M    = 99
      MD   =-ABS(MDOC)-1
      IERR = 0
C ---
      MESSAGE = ' '
      EXT  = ' '
      PATH = ' '
      IN   = 10
      CALL CORR_NAME_ALL(FILE)
      CALL OPENFR(IN,M,PATH,FILE,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open input sequence file'
        CALL MSGERR(MD,LINE)
        MESSAGE = 'cannot open input sequence file'
        IERR = 1
        RETURN
      ENDIF

      IEND   = 0
      IFIRST = 0
      NBAD   = 0
      NAA    = 0

      DO I=1,1000

        IF(IEND.GT.0) GO TO 600
        LINE = ' '
        READ(IN,'(A)',END=620,ERR=200) LINE
        GO TO 610
 620    CONTINUE
        IEND = 1
 610    CONTINUE

        IMODE = 1
C               MODE  0  only check
C                    -1  convert symbols to low case.
C                     1  to upper
        CALL CHECK_LINE(IMODE,LINE)

        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GT.0.AND.LINE(1:1).EQ.'>') THEN
          IFIRST = IFIRST + 1
          IF(IFIRST.GE.2) THEN
            LINE = ' ERROR: more then one sequence'
            CALL MSGERR(MD,LINE)
            MESSAGE = 'more then one sequence'
            IERR = 1
          ENDIF
          GO TO 630
        ENDIF
        IF(LEN.LE.0.OR.LINE(1:1).EQ.'#') GO TO 630        

        DO K=1,LEN
          CH1 = LINE(K:K)
          IF(CH1.EQ.' '.OR.CH1.EQ.'-') GO TO 700

          DO  J=1,25
            IF(CH1.EQ.AMIN(J)) THEN
              GO TO 710
            ENDIF
          ENDDO
          J   = 26
 710      CONTINUE

          IF(J.GE.1.AND.J.LE.20) THEN
            NAA = NAA + 1
          ELSE
            NBAD = NBAD + 1
          ENDIF

 700      CONTINUE
        ENDDO

 630    CONTINUE
      ENDDO

 600  CONTINUE
      CLOSE(IN)
      IF(NBAD.GT.10) THEN
        LINE = ' ERROR: number of bad symbols more then 10'
        CALL MSGERR(MD,LINE)
        MESSAGE = 'number of bad symbols more then 10'
        IERR = 1
      ENDIF
      IF(NAA.LE.5) THEN
        LINE = ' ERROR: number of amino acids less 5'
        CALL MSGERR(MD,LINE)
        MESSAGE = 'number of amino acids less 5'
        IERR = 1
      ENDIF
C ---
      RETURN
C ---
 200  CONTINUE
      CLOSE(IN)
      LINE = ' ERROR: read error of input sequence file'
      CALL MSGERR(MD,LINE)
      MESSAGE = 'read error of input sequence file'
      IERR = 1
      RETURN
      END

      SUBROUTINE CHECK_COORD_FILE(MDOC,FILE,MESSAGE,IERR)
C ------------------------------
      INTEGER   MDOC,IERR
      CHARACTER FILE*(*)
      CHARACTER PATH*1,EXT*1
C ------------------------------
      CHARACTER LINE*256,PDB*1,CIF*1
      CHARACTER MESSAGE*(*)
C -----------------------------------------------------------
      M    = 99
      MD   =-ABS(MDOC)-1
      IERR = 0
C ---
      MESSAGE = ' '
      EXT  = ' '
      PATH = ' '
      IN   = 10
      CALL CORR_NAME_ALL(FILE)
      CALL LENSTR_BL(FILE,IFLEN)
      IF(IFLEN.LT.5) THEN 
        LINE = ' ERROR: wrong file name'
        CALL MSGERR(MD,LINE)
        MESSAGE = 'wrong file name'
        IERR = 1
        RETURN
      ENDIF
      IF(FILE(IFLEN-3:IFLEN).EQ.'.map'.OR.
     *   FILE(IFLEN-4:IFLEN).EQ.'.ccp4'.OR.
     *   FILE(IFLEN-3:IFLEN).EQ.'.dat') THEN
        MESSAGE = 'MAP File'
        RETURN
      ENDIF
      CALL OPENFR(IN,M,PATH,FILE,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open input coord file'
        CALL MSGERR(MD,LINE)
        MESSAGE = 'cannot open input coord file'
        IERR = 1
        RETURN
      ENDIF

      IFIRST = 0
      IEND = 0
      PDB  = 'N'
      CIF  = 'N'

      DO I=1,5000

        LINE = ' '

        IF(IEND.GT.0) GO TO 600
        LINE = ' '
        READ(IN,'(A)',END=620,ERR=200) LINE(1:12)
        GO TO 610
 620    CONTINUE
        IEND = 1
 610    CONTINUE

c        write(*,*) '-->',LINE(1:12),';',i,iend

        IMODE = 0
C               MODE  0  only check
C                    -1  convert symbols to low case.
C                     1  to upper
        CALL CHECK_LINE(IMODE,LINE)
c        write(*,*) '-->',LINE(1:12),';',i,iend
 
        IF(LINE(1:1).EQ.'#') GO TO 700
        IF(LINE(1:6).EQ.'ATOM  '.OR.LINE(1:6).EQ.'HETATM') THEN
          PDB = 'Y'
          GO TO 600
        ENDIF
        CALL REMOVE_FIRST_BLANC(LINE)
        IF(IFIRST.EQ.0.AND.LINE(1:5).EQ.'data_') CIF = 'I'
        IFIRST = IFIRST + 1     
        IF(CIF.EQ.'I'.AND.LINE(1:11).EQ.'_atom_site.') THEN
          CIF = 'Y'
          GO TO 600
        ENDIF

 700    CONTINUE
      ENDDO

 600  CONTINUE

c      WRITE(*,*) '==',PDB,CIF

      CLOSE(IN)
      IF(CIF.EQ.'Y'.AND.PDB.EQ.'N') THEN
        MESSAGE = 'CIF COORD File'
        IF(FILE(IFLEN-3:IFLEN).NE.'.crd' .AND.
     *       FILE(IFLEN-3:IFLEN).NE.'.cif') THEN
          LINE = 'ERROR: CIF_file must has extension ".crd" or ".cif"'
          CALL MSGERR(MD,LINE)
          IERR = 1
        ENDIF
        RETURN
      ELSE IF(CIF.NE.'Y'.AND.PDB.EQ.'Y') THEN
        MESSAGE = 'PDB COORD File'
        IF(FILE(IFLEN-3:IFLEN).NE.'.pdb') THEN
          LINE = 'ERROR: PDB_file must has extension ".pdb"'
          CALL MSGERR(MD,LINE)
          IERR = 1
        ENDIF
        RETURN
      ENDIF
      LINE = ' ERROR: unknown coord file'
      CALL MSGERR(MD,LINE)
      MESSAGE = 'unknown coord file'
      IERR = 1
      RETURN
C ---
 100  CONTINUE
      CLOSE(IN)
      LINE = ' ERROR: end of input coord file'
      CALL MSGERR(MD,LINE)
      MESSAGE = 'end of input coord file'
      IERR = 1
      RETURN
 200  CONTINUE
      CLOSE(IN)
      LINE = ' ERROR: read error of input coord file'
      CALL MSGERR(MD,LINE)
      MESSAGE = 'read error of input coord file'
      IERR = 1
      RETURN
      END

      SUBROUTINE CHECK_CHAIN_ID(INEW)
C -----------------------------------------------
C  
C 
C -----------------------------------------------
      INTEGER*4 IERR,MDOC
      CHARACTER LINE*256
      INTEGER   NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
      CHARACTER NCSF*1,GID*4
C -----------------------------------
C ---
      CHARACTER CH1*1,CH2*2
      INTEGER   NLETT
      CHARACTER LETT*76,GROUP_ID(999)*4
C     DATA NLETT /66/
C     DATA LETT/
C     *'ABCDEFGHIJKLMNOPRSTUVWXYZ123456789abcdefghijklmnop'/
C     *'qrstuvwxyz<>{}[]'/
C       123456789 123456789 123456789 123456789 123456789       
C ------------------------------------
C     PARAMETER (MAXCHAIN=50)
C     NLETT = 66
      NLETT = 61
c             123456789 123456789 123456789 123456789 123456789 1 
      LETT = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ123456789abcdefghijklmnop'//
     *       'qrstuvwxyz<>{}[]RSTUVWXYZ'
c             23456789 123456789 123456
      MDOC = 0
      IERR = 0
      INEW = 0
      LNEW = 0
      IGR  = 0
      CALL GET_ASYMM(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *               ,NCSF,GID,IERR)
      IF(IERR.NE.0.OR.NGR.LE.0) THEN
        GO TO 900
      ENDIF
      IF(NGR.EQ.1) THEN
        IGR = 1
        CALL GET_ASYMM(MDOC,NMAX,NG,ICHOLD,IGR,ICH,INC,MLT,IGOLD
     *                    ,NCSF,GID,IERR)
        IF(IERR.NE.0) GO TO 900
        IF(GID(1:1).EQ.' '.OR.GID(1:1).EQ.'.') THEN
          GID(1:1) = 'A'
          CALL SET_ASYMM(MDOC,NMAX,NG,ICHOLD,IGR,ICH,INC,MLT
     *                   ,IGOLD,NCSF,GID,IERR)
          IF(IERR.NE.0) GO TO 900
        ENDIF
        RETURN
      ENDIF

c      IF(NGR.GT.NLETT) GO TO 900

      DO IGR=1,NGR
        CALL GET_ASYMM(MDOC,NMAX,NG,ICHOLD,IGR,ICH,INC,MLT,IGOLD
     *                    ,NCSF,GID,IERR)
        IF(IERR.NE.0) GO TO 900
        GROUP_ID(IGR) = GID
      ENDDO

      DO I=2,NGR
        CH2 = GROUP_ID(I)(1:2) 
        DO J=1,I-1
          IF(CH2.EQ.GROUP_ID(J)(1:2)) GO TO 500
        ENDDO
      ENDDO
      RETURN

 500  CONTINUE

      DO I=1,NGR
        IF(GROUP_ID(I)(1:1).EQ.' ') GROUP_ID(I)(1:1) = '.' 
        GROUP_ID(I)(3:3) = GROUP_ID(I)(1:1) 
      ENDDO

      DO I=1,NGR

        CH1 = GROUP_ID(I)(1:1) 
         
        IF(NGR.LE.1) THEN
          IF(CH1.EQ.'.') CH1='A'
          GO TO 400
        ENDIF
        
        IF(I.EQ.1.AND.CH1.NE.'.') GO TO 200
        IF(I.GT.1.AND.CH1.NE.'.') THEN
          DO J=1,I-1
            IF(CH1.EQ.GROUP_ID(J)(1:1)) GO TO 100
          ENDDO
          GO TO 200
        ENDIF

 100    CONTINUE

        DO K=1,NLETT
          CH1 = LETT(K:K)
          DO J=1,NGR
            IF(J.NE.I) THEN
              IF(CH1.EQ.GROUP_ID(J)(1:1)) GO TO 300
            ENDIF
          ENDDO
          GO TO 400
 300      CONTINUE
        ENDDO

        LNEW = LNEW + 1
        IF(LNEW.GT.NLETT) LNEW = LNEW - NLETT
        CH1 =  LETT(LNEW:LNEW)        

 400    CONTINUE

        GROUP_ID(I)(1:1) = CH1

 200    CONTINUE

      ENDDO

      DO I=1,NGR
        CH1 = GROUP_ID(I)(3:3)
        IF(CH1.NE.GROUP_ID(I)(1:1)) INEW = 1

c        GROUP_ID(I)(2:2) = GROUP_ID(I)(1:1) 
c        GROUP_ID(I)(1:1) = CH1 

        GROUP_ID(I)(3:3) = ' '
        GROUP_ID(I)(4:4) = ' ' 
      ENDDO
C ----------------------
      IF(INEW.EQ.1) THEN
        DO IGR=1,NGR
          CALL GET_ASYMM(MDOC,NMAX,NG,ICHOLD,IGR,ICH,INC,MLT,IGOLD
     *                      ,NCSF,GID,IERR)
          IF(IERR.NE.0) GO TO 900
          GID = GROUP_ID(IGR)
          CALL SET_ASYMM(MDOC,NMAX,NG,ICHOLD,IGR,ICH,INC,MLT
     *                     ,IGOLD,NCSF,GID,IERR)
          IF(IERR.NE.0) GO TO 900
        ENDDO
      ENDIF
      RETURN
C ----------------------
900   CONTINUE
      NCHAIN = 1
      IGR    = NCHAIN
      ICH    = IGR
      IGOLD  = IGR
      ICHOLD = IGR
      INC    = 0
      MLT    = 0
      IATM   = 0
      NCSF   = '.'
      GID    = 'AA  '
      INEW   = 1
      CALL SET_ASYMM(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                   ,IGOLD,NCSF,GID,IERR)
      RETURN
      END

      SUBROUTINE CHECK_CHAIN_ID2(INEW)
C -----------------------------------------------
C  
C 
C -----------------------------------------------
      INTEGER*4 IERR,MDOC
      CHARACTER LINE*80
      INTEGER   NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
      CHARACTER NCSF*1,GID*4
C -----------------------------------
C ---
      CHARACTER CH1*1,CH2*2
      INTEGER   NLETT
      CHARACTER LETT*76,GROUP_ID(999)*4
C     DATA NLETT /66/
C     DATA LETT/
C     *'ABCDEFGHIJKLMNOPRSTUVWXYZ123456789abcdefghijklmnop'/
C     *'qrstuvwxyz<>{}[]'/
C       123456789 123456789 123456789 123456789 123456789       
C ------------------------------------
C     PARAMETER (MAXCHAIN=50)
C     NLETT = 66
      NLETT = 61
      LETT = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ123456789abcdefghijklmnop'//
     *       'qrstuvwxyz<>{}[]RSTUVWXYZ'
      MDOC = 0
      IERR = 0
      INEW = 0
      LNEW = 0
      IGR  = 0
      CALL GET_ASYM2(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *               ,NCSF,GID,IERR)
      IF(IERR.NE.0.OR.NGR.LE.0) THEN
        GO TO 900
      ENDIF
      IF(NGR.EQ.1) THEN
        IGR = 1
        CALL GET_ASYM2(MDOC,NMAX,NG,ICHOLD,IGR,ICH,INC,MLT,IGOLD
     *                    ,NCSF,GID,IERR)
        IF(IERR.NE.0) GO TO 900
        IF(GID(1:1).EQ.' '.OR.GID(1:1).EQ.'.') THEN
          GID(1:1) = 'A'
          CALL SET_ASYM2(MDOC,NMAX,NG,ICHOLD,IGR,ICH,INC,MLT
     *                   ,IGOLD,NCSF,GID,IERR)
          IF(IERR.NE.0) GO TO 900
        ENDIF
        RETURN
      ENDIF

c      IF(NGR.GT.NLETT) GO TO 900

      DO IGR=1,NGR
        CALL GET_ASYM2(MDOC,NMAX,NG,ICHOLD,IGR,ICH,INC,MLT,IGOLD
     *                    ,NCSF,GID,IERR)
        IF(IERR.NE.0) GO TO 900
        GROUP_ID(IGR) = GID
      ENDDO

      DO I=2,NGR
        CH2 = GROUP_ID(I)(1:2) 
        DO J=1,I-1
          IF(CH2.EQ.GROUP_ID(J)(1:2)) GO TO 500
        ENDDO
      ENDDO
      RETURN

 500  CONTINUE

      DO I=1,NGR
        IF(GROUP_ID(I)(1:1).EQ.' ') GROUP_ID(I)(1:1) = '.' 
        GROUP_ID(I)(3:3) = GROUP_ID(I)(1:1) 
      ENDDO

      DO I=1,NGR

        CH1 = GROUP_ID(I)(1:1) 
         
        IF(NGR.LE.1) THEN
          IF(CH1.EQ.'.') CH1='A'
          GO TO 400
        ENDIF
        
        IF(I.EQ.1.AND.CH1.NE.'.') GO TO 200
        IF(I.GT.1.AND.CH1.NE.'.') THEN
          DO J=1,I-1
            IF(CH1.EQ.GROUP_ID(J)(1:1)) GO TO 100
          ENDDO
          GO TO 200
        ENDIF

 100    CONTINUE

        DO K=1,NLETT
          CH1 = LETT(K:K)
          DO J=1,NGR
            IF(J.NE.I) THEN
              IF(CH1.EQ.GROUP_ID(J)(1:1)) GO TO 300
            ENDIF
          ENDDO
          GO TO 400
 300      CONTINUE
        ENDDO

        LNEW = LNEW + 1
        IF(LNEW.GT.NLETT) LNEW = LNEW - NLETT
        CH1 =  LETT(LNEW:LNEW)        

 400    CONTINUE

        GROUP_ID(I)(1:1) = CH1

 200    CONTINUE

      ENDDO

      DO I=1,NGR
        CH1 = GROUP_ID(I)(3:3)
        IF(CH1.NE.GROUP_ID(I)(1:1)) INEW = 1

C        GROUP_ID(I)(2:2) = GROUP_ID(I)(1:1) 
C        GROUP_ID(I)(1:1) = CH1 

        GROUP_ID(I)(3:3) = ' '
        GROUP_ID(I)(4:4) = ' ' 
      ENDDO
C ----------------------
      IF(INEW.EQ.1) THEN
        DO IGR=1,NGR
          CALL GET_ASYM2(MDOC,NMAX,NG,ICHOLD,IGR,ICH,INC,MLT,IGOLD
     *                      ,NCSF,GID,IERR)
          IF(IERR.NE.0) GO TO 900
          GID = GROUP_ID(IGR)
          CALL SET_ASYM2(MDOC,NMAX,NG,ICHOLD,IGR,ICH,INC,MLT
     *                     ,IGOLD,NCSF,GID,IERR)
          IF(IERR.NE.0) GO TO 900
        ENDDO
      ENDIF
      RETURN
C ----------------------
900   CONTINUE
      NCHAIN = 1
      IGR    = NCHAIN
      ICH    = IGR
      IGOLD  = IGR
      ICHOLD = IGR
      INC    = 0
      MLT    = 0
      IATM   = 0
      NCSF   = '.'
      GID    = 'AA  '
      INEW   = 1
      CALL SET_ASYM2(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                   ,IGOLD,NCSF,GID,IERR)
      RETURN
      END

      SUBROUTINE JOIN_LIST_CHAIN(NGR1,NGR2,NGR_SUM)
C ----------------------------------------
      INTEGER   NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
      INTEGER   NMAX2,NGR2,NCH2,IGR2,ICH2,INC2,MLT2,IATM2
      CHARACTER NCSF*1,GID*4,NCSF2*1,GID2*4
C ----------------------------------------
      MDOC    = 0
      IERR    = 0
      NGR1    = 0
      NGR2    = 0
      NGR_SUM = 0
C ---
      CALL CHECK_CHAIN_ID(INEW)
      CALL CHECK_CHAIN_ID2(INEW)

      IGR  = 0
      CALL GET_ASYMM(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *               ,NCSF,GID,IERR)
      IF(IERR.NE.0.OR.NGR.LE.0) GO TO 900
      NGR1 = NGR
       
      IGR2  = 0
      CALL GET_ASYM2(MDOC,NMAX2,NGR2,NCH2,IGR2,ICH2,INC2,MLT2,IATM2
     *               ,NCSF2,GID2,IERR)
      IF(IERR.NE.0.OR.NGR2.LE.0) GO TO 900

C ---
      IGR = NGR
      DO IGR2=1,NGR2
        I2 = IGR2
        CALL GET_ASYM2(MDOC,NMAX2,NGR2,ICHOLD2,I2,ICH2,INC2
     *    ,MLT2,IGOLD2,NCSF2,GID2,IERR)

        IF(IERR.NE.0) GO TO 900
        IGR = IGR + 1
        IF(IGR.GT.NMAX) GO TO 900
        ICHOLD = IGR 
        ICH    = IGR
        INC    = INC2
        MLT    = MLT2
        IGOLD  = IGR  
        NCSF   = NCSF2 
        GID    = GID2
        CALL SET_ASYMM(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                     ,IGOLD,NCSF,GID,IERR)
        I  = 0
        CALL GET_ASYMM(MDOC,NMAX,NGR,NCH,I,ICH,INC,MLT,IATM
     *               ,NCSF,GID,IERR)

        IF(IERR.NE.0) GO TO 900
      ENDDO
      NGR_SUM = IGR

      CALL CHECK_CHAIN_ID(INEW)

      IGR  = 0
      CALL GET_ASYMM(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *               ,NCSF,GID,IERR)

C ---
  900 CONTINUE
      IERR = 0
      RETURN
      END

C ******
      SUBROUTINE CHNG_DATE(CH9,CH10)
C -------------------------------------------------------
C -P- CHNG_DATE - 
C -------------------------------------------------------
      CHARACTER CH9*9,CH10*10
C ******
      CHARACTER MONTH(12)*3
      DATA MONTH/'JAN','FEB','MAR','APR','MAY','JUN','JUL','AUG','SEP'
     *           ,'OCT','NOV','DEC'/
C ---------------------------------
      IF(CH9(1:1).EQ.'X') THEN
        CH10='XXXX-XX-XX'
        RETURN
      ENDIF
      CH10(1:2) = '19'
      CH10(3:4) = CH9(8:9)
      IF(CH10(3:3).EQ.'0') THEN
        CH10(1:2) = '20'
      ENDIF
      CH10(5:5) = '-'
      CH10(8:8) = '-'
      CH10(9:10)= CH9(1:2)
      IM=0
      DO I=1,12
        IF(CH9(4:6).EQ.MONTH(I)) THEN
          IM=I
          GO TO 100
        ENDIF
      ENDDO
 100  CONTINUE
      IF(IM.LE.0) IM=1
      WRITE(CH10(6:7),'(I2)') IM
      IF(CH10(6:6).EQ.' ') CH10(6:6)='0'
      RETURN
      END

C ******
      SUBROUTINE CHNG_DATE_BACK(CH10,CH9)
C -------------------------------------------------------
C -P- CHNG_DATE_BACK - 
C -------------------------------------------------------
      CHARACTER CH9*9,CH10*10
C ******
      CHARACTER MONTH(12)*3
      DATA MONTH/'JAN','FEB','MAR','APR','MAY','JUN','JUL','AUG','SEP'
     *           ,'OCT','NOV','DEC'/
C ---------------------------------
      IF(CH10(1:1).EQ.'X') THEN
        CH9='XX-XXX-XX'
        RETURN
      ENDIF
      CH9(8:9) =CH10(3:4)
      CH9(3:3) = '-'
      CH9(7:7) = '-'
      CH9(1:2) = CH10(9:10)
      READ(CH10(6:7),'(I2)') IM
      IF(IM.LE.0)  IM=1
      IF(IM.GT.12) IM=12
      CH9(4:6)=MONTH(IM)
      RETURN
      END

      SUBROUTINE NSG_CCP4_TO_STAND(NO_CCP4,NO_STAND,IS_STAND,IERR)
C -----------------------------------------------------------
      INTEGER NO_STAND,IS_STAND,NO_CCP4
C -----------------------------------------------------------
      IERR     = 0
      NO_STAND = 0
      IS_STAND = 0
C ----------------------
      NSG  = NO_CCP4
      ISTT = NSG/1000
      NOSG = NSG - ISTT*1000
      ISTT = ISTT + 1

      IF(NOSG.EQ.3.OR.NOSG.EQ.4.OR.NOSG.EQ.146.OR.NOSG.EQ.155) THEN
        IF(ISTT.EQ.1) THEN
          ISTT = 2
        ELSE IF(ISTT.EQ.2) THEN  
          ISTT = 1
c        ELSE IF(ISTT.EQ.3) THEN  
c          ISTT = 4
c        ELSE IF(ISTT.EQ.4) THEN  
c          ISTT = 3
        ENDIF
      ELSE IF(NOSG.EQ.  5) THEN
        IF(ISTT.EQ.1) THEN
          ISTT = 2
        ELSE IF(ISTT.EQ.2) THEN  
          ISTT = 1
c        ELSE IF(ISTT.EQ.3) THEN  
c          ISTT = 4
c        ELSE IF(ISTT.EQ.4) THEN  
c          ISTT = 3
        ENDIF
      ENDIF
      NO_STAND = NOSG
      IS_STAND = ISTT 
C ---
      RETURN
      END

      SUBROUTINE NSG_STAND_TO_CCP4(NO_STAND,IS_STAND,NO_CCP4,IERR)
C -----------------------------------------------------------
      INTEGER NO_STAND,IS_STAND,NO_CCP4
C -----------------------------------------------------------
      IERR    = 0
      NO_CCP4 = 0
      NOSPGR  = NO_STAND
      IF(NOSPGR.LE.0.OR.NOSPGR.GT.230) THEN
        IERR = 1
        RETURN
      ENDIF      
      ISETT  = IS_STAND      
      IF(ISETT.LE.0.OR.ISETT.GT.9) ISETT = 1
C -------
      NOSG = NOSPGR
      ISTT = ISETT
C ----
      IF(NOSG.EQ.  3.OR.NOSG.EQ.  4.OR.NOSG.EQ.146.OR.NOSG.EQ.155) THEN
        IF(ISTT.EQ.1) THEN
          ISTT = 2
        ELSE IF(ISTT.EQ.2) THEN  
          ISTT = 1
c        ELSE IF(ISTT.EQ.3) THEN  
c          ISTT = 4
c        ELSE IF(ISTT.EQ.4) THEN  
c          ISTT = 3
        ENDIF
      ELSE IF(NOSG.EQ.  5) THEN
        IF(ISTT.EQ.1) THEN
          ISTT = 2
        ELSE IF(ISTT.EQ.2) THEN  
          ISTT = 1
c        ELSE IF(ISTT.EQ.3) THEN  
c          ISTT = 4
c        ELSE IF(ISTT.EQ.4) THEN  
c          ISTT = 3
        ENDIF
      ENDIF
C ---
      IF(ISTT.GT.1) NOSG = (ISTT-1)*1000 + NOSG
      NO_CCP4 = NOSG
C ---
      RETURN
      END 

      SUBROUTINE SYMFR_NB(MDOC,LINE,NS,NSYM,ISYM,IPRSYM,IERR)
C -------------------------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER   NSYM

      CHARACTER LINE*(*),STR*80
C 
      REAL      ROT(3,3),TR(3)
      INTEGER   NUM(10)      
      CHARACTER INUM(10)*1,ICH*1,S_OP*24
      DATA NUM / 1,  2,  3,  4,  5,  6,  7,  8,  9,  0 /
      DATA INUM/'1','2','3','4','5','6','7','8','9','0'/
C ---------------------------------------------------------------
      IERR = 0
      I1   = 1
      IF(LINE(1:1).EQ.'S') I1=6
      ISTR = I1
      CALL LENSTR_BL(LINE,LEN)
      IFN = LEN
      IF(LEN.LE.4) THEN
        IERR=1
      ENDIF

      L = IFN-ISTR+1
      IF(L.GT.24) L = 24
      IFN  = ISTR+L-1
      S_OP = LINE(ISTR:IFN)

      IMAX = LEN
      I    = I1-1
      NOP  = 1
      DO     J=1,3
        TR(J) = 0.0
        DO     K=1,3
          ROT(J,K) = 0.0
        ENDDO
      ENDDO
  117 S      = 1.0
      T      = 0.0
      IP     = 0
      J      = 0
      NP     = 0
      ISL    = 0
      IFOUND = 0

  100 I = I + 1
      IF(I.GT.IMAX)                 GO TO 110
      ICH  = LINE(I:I)
      IF(ICH.EQ.' ')                GO TO 100
      IF(ICH.EQ.','.OR. ICH.EQ.'*') GO TO 110
      IFOUND = 1

      IF(ICH.EQ.'X')  GO TO 105
      IF(ICH.EQ.'Y')  GO TO 106
      IF(ICH.EQ.'Z')  GO TO 107

      IF(ICH.EQ.'+')  GO TO 121
      IF(ICH.EQ.'-')  GO TO 122
      IF(ICH.EQ.'/')  GO TO 123
      IF(ICH.EQ.'.')  GO TO 124

      DO     K=1,10
        IF(ICH.EQ.INUM(K))  GO TO 102
      ENDDO

      WRITE(STR,9101) ICH
9101  FORMAT(' ERR: INVALID CHARACTER...',A1)
      CALL MSGERR(MDOC,STR)
      IERR=1
      GO TO 100
C ---- DIGIT
  102 A = NUM(K)
      IF(ISL.EQ.1)  GO TO 103
      IF(IP .EQ.1)  GO TO 104
      T = A*S
      GO TO 120
  103 T = T/A
      GO TO 120
  104 NP = NP + 1
      T  = T + A/10**NP
  120 TR(NOP) = T
      GO TO 100
C --- LETTER
  105 J = 1
      GO TO 108
  106 J = 2
      GO TO 108
 107  J = 3
 108  IF(T.NE.0.0) S = T
      ROT(J,NOP) = S
      T   = 0.0
      S   = 1.0
      ISL = 0
      IP  = 0
      NP  = 0
      GO TO 100
C ----------------------
C --- + ---
  121 S = 1.0
      GO TO 130
C --- - ---
  122 S = -1.0
  130 IF(T.NE.0.0.AND.J.EQ.0) THEN
        T = 0.0
      ENDIF
      GO TO 100
C --- / ---
  123 ISL = 1
      GO TO 100
C --- . ---
  124 IP = 1
      GO TO 100

  110 CONTINUE
      IF(J.NE.0.AND.T.NE.0.0) TR(NOP) = T
      J = 0     
      IF(IFOUND.EQ.0 .AND. I.LE.IMAX) THEN
        CALL MSGERR(MDOC,' ERR: BLANK OPERATOR FIELD')
      ENDIF
      NOP = NOP + 1
      IF(NOP.LE.3.AND.I.LE.IMAX) GO TO 117
      IF(NOP.EQ.4 .AND. IFOUND.EQ.0) THEN
        CALL MSGERR(MDOC,' ERR: LAST GENERAL POSITION IS INCOMPLETE')
        IERR=1
      ENDIF
      NSYM = NS

C     CALL LENSTR_BL(S_OP,LEN)
C     SYMOP(NS) = S_OP(1:LEN)

      ISYM(1,1,NS)=ROT(1,1)
      ISYM(2,1,NS)=ROT(2,1)
      ISYM(3,1,NS)=ROT(3,1)
      ISYM(1,2,NS)=ROT(1,2)
      ISYM(2,2,NS)=ROT(2,2)
      ISYM(3,2,NS)=ROT(3,2)
      ISYM(1,3,NS)=ROT(1,3)
      ISYM(2,3,NS)=ROT(2,3)
      ISYM(3,3,NS)=ROT(3,3)
      ISYM(4,1,NS)=INT((TR(1)*24.+0.1))
      ISYM(4,2,NS)=INT((TR(2)*24.+0.1))
      ISYM(4,3,NS)=INT((TR(3)*24.+0.1))
      ISYM(5,1,NS)=24
      ISYM(5,2,NS)=24
      ISYM(5,3,NS)=24

      RETURN
      END

      SUBROUTINE SYMFR2_BL(MDOC,LINE,NS,NSYM,ISYM,IPRSYM,IERR)
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER   NSYM
      CHARACTER LINE*(*),STR*80
C 
      REAL      ROT(3,3),TR(3)
      INTEGER   NUM(10)      
      CHARACTER INUM(10)*1,ICH*1
      DATA NUM / 1,  2,  3,  4,  5,  6,  7,  8,  9,  0 /
      DATA INUM/'1','2','3','4','5','6','7','8','9','0'/
C ---------------------------------------------------------------
      IERR=0
      I1=1
      IF(LINE(1:1).EQ.'S') I1=6
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LE.4) THEN
        IERR=1
      ENDIF
      IMAX=LEN
      I=I1-1
      NOP=1
      DO     J=1,3
        TR(J)=0.
        DO     K=1,3
          ROT(J,K)=0.
        ENDDO
      ENDDO
  117 S=1.0
      T=0.0
      IP=0
      J=0
      NP=0
      ISL=0
      IFOUND=0

  100 I=I+1
      IF(I.GT.IMAX)                 GO TO 110
      ICH =LINE(I:I)
      IF(ICH.EQ.' ')                GO TO 100
      IF(ICH.EQ.','.OR. ICH.EQ.'*') GO TO 110
      IFOUND=1

      IF(ICH.EQ.'X')  GO TO 105
      IF(ICH.EQ.'Y')  GO TO 106
      IF(ICH.EQ.'Z')  GO TO 107

      IF(ICH.EQ.'+')  GO TO 121
      IF(ICH.EQ.'-')  GO TO 122
      IF(ICH.EQ.'/')  GO TO 123
      IF(ICH.EQ.'.')  GO TO 124

      DO     K=1,10
        IF(ICH.EQ.INUM(K))  GO TO 102
      ENDDO

      WRITE(STR,9101) ICH
9101  FORMAT(' ERR: INVALID CHARACTER...',A1)
      CALL MSGERR(MDOC,STR)
      IERR=1
      GO TO 100
C ---- DIGIT
  102 A = NUM(K)
      IF(ISL.EQ.1)  GO TO 103
      IF(IP .EQ.1)  GO TO 104
      T = A*S
      GO TO 120
  103 T = T/A
      GO TO 120
  104 NP=NP+1
      T = T + A/10**NP
  120 TR(NOP)=T
      GO TO 100
C --- LETTER
  105 J=1
      GO TO 108
  106 J=2
      GO TO 108
 107  J=3
 108  IF(T.NE.0.0) S=T
      ROT(J,NOP)=S
      T  =0.0
      S  =1.0
      ISL=0
      IP =0
      NP =0
      GO TO 100
C ----------------------
C --- + ---
  121 S=1.0
      GO TO 130
C --- - ---
  122 S=-1.0
  130 IF(T.NE.0.0.AND.J.EQ.0) THEN
        T=0.0
      ENDIF
      GO TO 100
C --- / ---
  123 ISL=1
      GO TO 100
C --- . ---
  124 IP=1
      GO TO 100

  110 CONTINUE
      IF(J.NE.0.AND.T.NE.0.0) TR(NOP) = T
      J=0     
      IF(IFOUND.EQ.0 .AND. I.LE.IMAX) THEN
        CALL MSGERR(MDOC,' ERR: BLANK OPERATOR FIELD')
      ENDIF
      NOP=NOP+1
      IF(NOP.LE.3.AND.I.LE.IMAX) GO TO 117
      IF(NOP.EQ.4 .AND. IFOUND.EQ.0) THEN
        CALL MSGERR(MDOC,' ERR: LAST GENERAL POSITION IS INCOMPLETE')
        IERR=1
      ENDIF
      NSYM=NS
      ISYM(1,1,NS)=ROT(1,1)
      ISYM(2,1,NS)=ROT(2,1)
      ISYM(3,1,NS)=ROT(3,1)
      ISYM(1,2,NS)=ROT(1,2)
      ISYM(2,2,NS)=ROT(2,2)
      ISYM(3,2,NS)=ROT(3,2)
      ISYM(1,3,NS)=ROT(1,3)
      ISYM(2,3,NS)=ROT(2,3)
      ISYM(3,3,NS)=ROT(3,3)
      ISYM(4,1,NS)=INT((TR(1)*24.+0.1))
      ISYM(4,2,NS)=INT((TR(2)*24.+0.1))
      ISYM(4,3,NS)=INT((TR(3)*24.+0.1))
      ISYM(5,1,NS)=24
      ISYM(5,2,NS)=24
      ISYM(5,3,NS)=24
      RETURN
      END

C ******
      SUBROUTINE GETLINE(IUN,MDOC,STR,IERR,IEND)
C -----------------------------------------------
C -P- GETLINE - reads one record of file to string STR (80 chars maximum).
C               Checks two last characters of STR and put ' ' if they
C               are not good. 
C               If lenght of STR = 0  set STR(1:1)=' '.
C               Fills to the rest of string by ' '.
C      input:
C         IUN  - logical unit_number.
C         MDOC - mode of writting messages to DOC-file /See subr. OPENDOC/
C                0 - only terminal , < - 0 only file, 0 < < 99 - both
C                >= 99 - don't write  
C      output:
C         STR  - output string
C         IERR - "1" means read_error,  "0" - OK.
C         IEND - "1" means end-of-file, "0" - STR was reading.
C -----------------------------------------------
      INTEGER*4 MDOC,IUN,IERR,IEND
      CHARACTER STR*(*)
C ******
C -----------------------------------------------
      INTEGER*4 NL
      CHARACTER CH1*1,CHAR1*1
C -----------------------------------------------
      IERR=0
      IEND=0
      READ(IUN,'(A)',ERR=1000,END=1010) STR
      NL=LEN(STR)
      IF(NL.LE.0) THEN
        STR=' '
        NL=1
      ELSE
        IF(NL.GE.1) THEN
          CHAR1 = STR(NL:NL)
          CALL CHKSMB(CHAR1,CH1)
          IF(CH1.EQ.'?') STR(NL:NL)=' '
          IF(NL.GT.1) THEN
            CHAR1 = STR(NL-1:NL-1)
            CALL CHKSMB(CHAR1,CH1)
            IF(CH1.EQ.'?') STR(NL-1:NL-1)=' '
          ENDIF
        ENDIF       
      ENDIF
c      IF(NL.LT.80) THEN
c        DO I=NL,80
c          STR(I:I)=' '
c        ENDDO
c      ENDIF
      RETURN
C ----------------------------------
 1000 CALL MSGDOC(MDOC,' ERR: read error.')     
      IERR=1
      RETURN
 1010 IEND=1
      RETURN
C -----------------------------------
      END     


C ******
      SUBROUTINE GETCIF(IUN,MDOC,IERR,IEND)
C -------------------------------------------------------
C -P- GETCIF - reads the records from file and get information from records
C -P-          by CIF_style. 
C     Each call of subroutine returns set of loop (or only one)
C     item_names and corresponding data, also its data_block_name.
C     Returned information are in common /COMCIF/
C     
C     input:
C           IUN  - log. unit number.
C           MDOC - mode of writting messages to DOC-file /See subr. OPENDOC/
C                   0 - only terminal , < - 0 only file, 0 < < 99 - both
C                   >= 99 - don't write  
C           IEND - for first call must be equal = -1; for others = 0.
C     output:
C           IEND  = 0 - OK, = 1 - end of file.
C           IERR  - signal of error. 0 means OK.               
C
C           Returned information are in common /COMCIF/:
C
C           N_CIF     - number of returned data.
C           ITM_CIF() - array of item_name
C           DT_CIF () - array of data as string of characters.
C           FDT_CIF() - array of data as integer.
C           IDT_CIF() - array of data as real.
C           BLK_CIF   - data_block_name.
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMCIF/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ---
      COMMON /COMFREAD/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*256
C --------------------------------------------------------------
      INTEGER*4 MDOC,IUN,IERR,IEND
C ******
      CHARACTER LINE*80
C --------------------------------------------------------------
      IF(IEND.EQ.-1) THEN
        N_DATA =0
        N_CIF =0
        N_ITEM =0
        I_CIF  =0
        NWORDS =0
        BLK_CIF=' '
        BLK_FLAG='N'
        IEND   =0
      ENDIF
      IERR=0
      IEND=0
      LOOP_FLAG='N'
  300 CONTINUE
        IF(I_CIF.EQ.NWORDS) THEN
  200     CALL GETLINE(IUN,MDOC,IN_STRING,IERR,IEND)

          IF(IERR.NE.0.OR.IEND.NE.0) RETURN

          IF(IN_STRING(1:5).NE.'data_'.AND.
     *       IN_STRING(1:7).NE.'global_'.AND.BLK_FLAG.EQ.'N') 
     *    GO TO 200

          IF(IN_STRING(1:1).EQ.';') THEN
            DO I=1,32000
              CALL GETLINE(IUN,MDOC,IN_STRING,IERR,IEND)
              IF(IERR.NE.0.OR.IEND.NE.0) RETURN
              IF(IN_STRING(1:1).EQ.';') GO TO 100
            ENDDO
  100       CONTINUE
          ENDIF
          CALL FRD_PARM
          IF(NWORDS.LE.0) GO TO 200
          IF(WORDS(1) (1:1).EQ.'#') GO TO 200    
          I_CIF=0
        ENDIF      
        I_CIF=I_CIF+1
        IF((WORDS(I_CIF)(1:5).EQ.'data_'  ).OR. 
     *     (WORDS(I_CIF)(1:7).EQ.'global_')) THEN
          BLK_CIF=WORDS(I_CIF)(1:LEN_WORDS(I_CIF))
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          N_DATA=0
          N_ITEM=0
          LOOP_FLAG='N' 
          BLK_FLAG='Y'
          IF(WORDS(I_CIF)(1:5).EQ.'data_'  ) THEN 
            NWORDS=0
            I_CIF=0
            N_CIF=0
            RETURN
          ENDIF

        ELSE IF(BLK_FLAG.EQ.'Y') THEN
       
        IF(WORDS(I_CIF)(1:5).EQ.'loop_'  ) THEN 
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          LOOP_FLAG='Y'
          N_DATA=0
          N_ITEM=0
        ELSE IF(WORDS(I_CIF)(1:1).EQ.'_'  ) THEN 
          IF(LOOP_FLAG.EQ.'N') N_ITEM=0
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          N_DATA=0        
          N_ITEM=N_ITEM+1
          IF(N_ITEM.GT.NWORDSMAX) THEN
            WRITE(LINE,
     *      '('' ERR: CIF_read: too many items in the loop >'',I5)')
     *      NWORDSMAX
            CALL MSGERR(MDOC,LINE)
          ENDIF
          ITM_CIF(N_ITEM)=WORDS(I_CIF) (1:LEN_WORDS(I_CIF))
        ELSE
          IF(N_ITEM.LE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of items =0 / before the data /')
          ENDIF
          LOOP_FLAG='N'
          N_DATA=N_DATA+1
          N_CIF=N_DATA
          DT_CIF(N_CIF) =WORDS(I_CIF)(1:LEN_WORDS(I_CIF))
          IDT_CIF(N_CIF)=IWORDS(I_CIF)
          FDT_CIF(N_CIF)=FWORDS(I_CIF)
          IF(N_DATA.EQ.N_ITEM) THEN
            N_DATA=0
            RETURN
          ENDIF
        ENDIF

        ELSE
          I_CIF=NWORDS
        ENDIF   

      GO TO 300

      END


C ******
      SUBROUTINE GETCIF_CRD(IUN,MDOC,IERR,IEND)
C -------------------------------------------------------
C -P- GETCIF_CRD - reads the records from file and get information from records
C -P-          by CIF_style. 
C     Each call of subroutine returns set of loop (or only one)
C     item_names and corresponding data, also its data_block_name.
C     Returned information are in common /COMCIF_CRD/
C     
C     input:
C           IUN  - log. unit number.
C           MDOC - mode of writting messages to DOC-file /See subr. OPENDOC/
C                   0 - only terminal , < - 0 only file, 0 < < 99 - both
C                   >= 99 - don't write  
C           IEND - for first call must be equal = -1; for others = 0.(or -2)
C     output:
C           IEND  = 0 - OK, = 1 - end of file, = -2  commets string
C                                                    DT_CIF (NWORDSMAX)
C           IERR  - signal of error. 0 means OK.               
C
C           Returned information are in common /COMCIF/:
C
C           N_CIF     - number of returned data.
C           ITM_CIF() - array of item_name
C           DT_CIF () - array of data as string of characters.
C           FDT_CIF() - array of data as integer.
C           IDT_CIF() - array of data as real.
C           BLK_CIF   - data_block_name.
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMCIF_CRD/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ---
      COMMON /FREAD_CIF/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*256
C --------------------------------------------------------------
      INTEGER*4 MDOC,IUN,IERR,IEND
C ******
      CHARACTER LINE*80
C --------------------------------------------------------------
      IERR=0
      IF(IEND.EQ.-1) THEN
        N_DATA =0
        N_CIF =0
        N_ITEM =0
        I_CIF  =0
        NWORDS =0
        BLK_CIF=' '
        BLK_FLAG='N'
        LOOP_FLAG='N'
        IEND=0
      ELSE IF(IEND.EQ.-2) THEN
        IEND=0
      ELSE
        IEND=0
        LOOP_FLAG='N'
      ENDIF
  300 CONTINUE
        IF(I_CIF.EQ.NWORDS) THEN
  200     CALL GETLINE(IUN,MDOC,IN_STRING,IERR,IEND)

          IF(IERR.NE.0.OR.IEND.NE.0) RETURN

          IF(IN_STRING(1:5).NE.'data_'.AND.
     *       IN_STRING(1:7).NE.'global_'.AND.BLK_FLAG.EQ.'N') 
     *    GO TO 200

          IF(IN_STRING(1:1).EQ.';') THEN
            DO I=1,32000
              CALL GETLINE(IUN,MDOC,IN_STRING,IERR,IEND)
              IF(IERR.NE.0.OR.IEND.NE.0) RETURN
              IF(IN_STRING(1:1).EQ.';') GO TO 100
            ENDDO
  100       CONTINUE
          ENDIF
          CALL FRD_PARM_CIF
          IF(NWORDS.LE.0) GO TO 200
          IF(WORDS(1) (1:1).EQ.'#') THEN
            DT_CIF(NWORDSMAX)=IN_STRING
            IEND=-2
            NWORDS=I_CIF
            RETURN 
          ENDIF
          I_CIF=0
        ENDIF      
        I_CIF=I_CIF+1
        IF((WORDS(I_CIF)(1:5).EQ.'data_'  ).OR. 
     *     (WORDS(I_CIF)(1:7).EQ.'global_')) THEN
          BLK_CIF=WORDS(I_CIF)(1:LEN_WORDS(I_CIF))
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          N_DATA=0
          N_ITEM=0
          LOOP_FLAG='N' 
          BLK_FLAG='Y'
          IF(WORDS(I_CIF)(1:5).EQ.'data_'  ) THEN 
            NWORDS=0
            I_CIF=0
            N_CIF=0
            RETURN
          ENDIF

        ELSE IF(BLK_FLAG.EQ.'Y') THEN
       
        IF(WORDS(I_CIF)(1:5).EQ.'loop_'  ) THEN 
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          LOOP_FLAG='Y'
          N_DATA=0
          N_ITEM=0
        ELSE IF(WORDS(I_CIF)(1:1).EQ.'_'  ) THEN 
          IF(LOOP_FLAG.EQ.'N') N_ITEM=0
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          N_DATA=0        
          N_ITEM=N_ITEM+1
          IF(N_ITEM.GT.NWORDSMAX) THEN
            WRITE(LINE,
     *      '('' ERR: CIF_read: too many items in the loop >'',I5)')
     *      NWORDSMAX
            CALL MSGERR(MDOC,LINE)
          ENDIF
          ITM_CIF(N_ITEM)=WORDS(I_CIF) (1:LEN_WORDS(I_CIF))
        ELSE
          IF(N_ITEM.LE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of items =0 / before the data /')
          ENDIF
          LOOP_FLAG='N'
          N_DATA=N_DATA+1
          N_CIF=N_DATA
          DT_CIF(N_CIF) =WORDS(I_CIF)(1:LEN_WORDS(I_CIF))
          IDT_CIF(N_CIF)=IWORDS(I_CIF)
          FDT_CIF(N_CIF)=FWORDS(I_CIF)
          IF(N_DATA.EQ.N_ITEM) THEN
            N_DATA=0
            RETURN
          ENDIF
        ENDIF

        ELSE
          I_CIF=NWORDS
        ENDIF   

      GO TO 300

      END

C ******
      SUBROUTINE FRD_PARM_CIF
C -------------------------------------------------------
C -P- FRD_PARM_CIF - free format reading of the string of characters.
C                See common /FREAD_CIF/
C
C     input:     IN_STRING - input string; a word is the part of the string
C                            between two blancs or two "'".
C     output:    NWORDS    - number of words of the string
C                IWORDS    - array of integer value of each word.
C                FWORDS    - array of real value of each word.
C                WORDS     - array of words
C                LEN_WORDS - array of lengths of the words
C                IFRD_ERR  - signal of error. 
C                            0  means OK.
C                            1 - number of words > NWORDSMAX = 40
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /FREAD_CIF/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*256
C --------------------------------------------------------------
C ******
      REAL      FA
      INTEGER*4 NW,IS,IW,IAP,LEN,IP,IA
      CHARACTER CH*1,CK*1,STR*256
C --------------------------------------------------------------
      IFRD_ERR=0
      NWORDS=0
      NW=0
      IW=0
      IS=0
      IAP=0
      CALL LENSTR_BL(IN_STRING,LEN)
      IF(LEN.LE.0) RETURN
      IF(LEN.GT.256) LEN=256
C -----------------
      DO   IP=1,LEN
        CH=IN_STRING(IP:IP)
        CALL CHKSMB(CH,CK)
        IF(CK.EQ.'?') CH=' '
        IF(CH.EQ.'''') THEN
          IAP=IAP+1
          IF(IAP.GE.2) IAP=0
        ENDIF
        IF(CH.NE.' '.OR.IAP.EQ.1) THEN
C         start of a word
          IF(IS.EQ.0) THEN
            IS=1
            NW=NW+1
            IF(NW.GT.NWORDSMAX) THEN
              IFRD_ERR=1
              RETURN
            ENDIF
          ENDIF
          IF(CH.NE.'''') THEN
            IW=IW+1
            STR(IW:IW)=CH       
          ELSE
            IF(IW.GT.0) THEN
            ENDIF
          ENDIF
        ENDIF
        IF((CH.EQ.' '.AND.IS.EQ.1.AND.IAP.EQ.0).OR.
     *       (IP.EQ.LEN.AND.IW.NE.0)) THEN
          IF(IW.LE.0) THEN
            WORDS(NW)='?'
            LEN_WORDS(NW)=1
          ELSE
            WORDS(NW)=STR(1:IW)
            LEN_WORDS(NW)=IW
          ENDIF
          NWORDS=NW
          CALL WTODIG(STR,IW,FA,IA)
          IWORDS(NW)=IA
          FWORDS(NW)=FA
          IS=0
          IW=0
          IAP=0
        ENDIF
      ENDDO
C -----------------
      RETURN
      END      

C ******
      SUBROUTINE GETCIF_2CRD(IUN,MDOC,IERR,IEND)
C -------------------------------------------------------
C -P- GETCIF_2CRD - reads the records from file and get information from records
C -P-          by CIF_style. 
C     Each call of subroutine returns set of loop (or only one)
C     item_names and corresponding data, also its data_block_name.
C     Returned information are in common /COMCIF_2CRD/
C     
C     input:
C           IUN  - log. unit number.
C           MDOC - mode of writting messages to DOC-file /See subr. OPENDOC/
C                   0 - only terminal , < - 0 only file, 0 < < 99 - both
C                   >= 99 - don't write  
C           IEND - for first call must be equal = -1; for others = 0.(or -2)
C     output:
C           IEND  = 0 - OK, = 1 - end of file, = -2  commets string
C                                                    DT_CIF (NWORDSMAX)
C           IERR  - signal of error. 0 means OK.               
C
C           Returned information are in common /COMCIF_2CRD/:
C
C           N_CIF     - number of returned data.
C           ITM_CIF() - array of item_name
C           DT_CIF () - array of data as string of characters.
C           FDT_CIF() - array of data as integer.
C           IDT_CIF() - array of data as real.
C           BLK_CIF   - data_block_name.
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMCIF_2CRD/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ---
      COMMON /FREAD_2CIF/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*256
C --------------------------------------------------------------
      INTEGER*4 MDOC,IUN,IERR,IEND
C ******
      CHARACTER LINE*80
C --------------------------------------------------------------
      IERR=0
      IF(IEND.EQ.-1) THEN
        N_DATA =0
        N_CIF =0
        N_ITEM =0
        I_CIF  =0
        NWORDS =0
        BLK_CIF=' '
        BLK_FLAG='N'
        LOOP_FLAG='N'
        IEND=0
      ELSE IF(IEND.EQ.-2) THEN
        IEND=0
      ELSE
        IEND=0
        LOOP_FLAG='N'
      ENDIF
  300 CONTINUE
        IF(I_CIF.EQ.NWORDS) THEN
  200     CALL GETLINE(IUN,MDOC,IN_STRING,IERR,IEND)

          IF(IERR.NE.0.OR.IEND.NE.0) RETURN

          IF(IN_STRING(1:5).NE.'data_'.AND.
     *       IN_STRING(1:7).NE.'global_'.AND.BLK_FLAG.EQ.'N') 
     *    GO TO 200

          IF(IN_STRING(1:1).EQ.';') THEN
            DO I=1,32000
              CALL GETLINE(IUN,MDOC,IN_STRING,IERR,IEND)
              IF(IERR.NE.0.OR.IEND.NE.0) RETURN
              IF(IN_STRING(1:1).EQ.';') GO TO 100
            ENDDO
  100       CONTINUE
          ENDIF
          CALL FRD_PARM_2CIF
          IF(NWORDS.LE.0) GO TO 200
          IF(WORDS(1) (1:1).EQ.'#') THEN
            DT_CIF(NWORDSMAX)=IN_STRING
            IEND=-2
            NWORDS=I_CIF
            RETURN 
          ENDIF
          I_CIF=0
        ENDIF      
        I_CIF=I_CIF+1
        IF((WORDS(I_CIF)(1:5).EQ.'data_'  ).OR. 
     *     (WORDS(I_CIF)(1:7).EQ.'global_')) THEN
          BLK_CIF=WORDS(I_CIF)(1:LEN_WORDS(I_CIF))
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          N_DATA=0
          N_ITEM=0
          LOOP_FLAG='N' 
          BLK_FLAG='Y'
          IF(WORDS(I_CIF)(1:5).EQ.'data_'  ) THEN 
            NWORDS=0
            I_CIF=0
            N_CIF=0
            RETURN
          ENDIF

        ELSE IF(BLK_FLAG.EQ.'Y') THEN
       
        IF(WORDS(I_CIF)(1:5).EQ.'loop_'  ) THEN 
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          LOOP_FLAG='Y'
          N_DATA=0
          N_ITEM=0
        ELSE IF(WORDS(I_CIF)(1:1).EQ.'_'  ) THEN 
          IF(LOOP_FLAG.EQ.'N') N_ITEM=0
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          N_DATA=0        
          N_ITEM=N_ITEM+1
          IF(N_ITEM.GT.NWORDSMAX) THEN
            WRITE(LINE,
     *      '('' ERR: CIF_read: too many items in the loop >'',I5)')
     *      NWORDSMAX
            CALL MSGERR(MDOC,LINE)
          ENDIF
          ITM_CIF(N_ITEM)=WORDS(I_CIF) (1:LEN_WORDS(I_CIF))
        ELSE
          IF(N_ITEM.LE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of items =0 / before the data /')
          ENDIF
          LOOP_FLAG='N'
          N_DATA=N_DATA+1
          N_CIF=N_DATA
          DT_CIF(N_CIF) =WORDS(I_CIF)(1:LEN_WORDS(I_CIF))
          IDT_CIF(N_CIF)=IWORDS(I_CIF)
          FDT_CIF(N_CIF)=FWORDS(I_CIF)
          IF(N_DATA.EQ.N_ITEM) THEN
            N_DATA=0
            RETURN
          ENDIF
        ENDIF

        ELSE
          I_CIF=NWORDS
        ENDIF   

      GO TO 300

      END

C ******
      SUBROUTINE FRD_PARM_2CIF
C -------------------------------------------------------
C -P- FRD_PARM_2CIF - free format reading of the string of characters.
C                     See common /FREAD_2CIF/
C
C     input:     IN_STRING - input string; a word is the part of the string
C                            between two blancs or two "'".
C     output:    NWORDS    - number of words of the string
C                IWORDS    - array of integer value of each word.
C                FWORDS    - array of real value of each word.
C                WORDS     - array of words
C                LEN_WORDS - array of lengths of the words
C                IFRD_ERR  - signal of error. 
C                            0  means OK.
C                            1 - number of words > NWORDSMAX = 40
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /FREAD_2CIF/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*256
C --------------------------------------------------------------
C ******
      REAL      FA
      INTEGER*4 NW,IS,IW,IAP,LEN,IP,IA
      CHARACTER CH*1,CK*1,STR*256
C --------------------------------------------------------------
      IFRD_ERR=0
      NWORDS=0
      NW=0
      IW=0
      IS=0
      IAP=0
      CALL LENSTR_BL(IN_STRING,LEN)
      IF(LEN.LE.0) RETURN
      IF(LEN.GT.256) LEN=256
C -----------------
      DO   IP=1,LEN
        CH=IN_STRING(IP:IP)
        CALL CHKSMB(CH,CK)
        IF(CK.EQ.'?') CH=' '
        IF(CH.EQ.'''') THEN
          IAP=IAP+1
          IF(IAP.GE.2) IAP=0
        ENDIF
        IF(CH.NE.' '.OR.IAP.EQ.1) THEN
C         start of a word
          IF(IS.EQ.0) THEN
            IS=1
            NW=NW+1
            IF(NW.GT.NWORDSMAX) THEN
              IFRD_ERR=1
              RETURN
            ENDIF
          ENDIF
          IF(CH.NE.'''') THEN
            IW=IW+1
            STR(IW:IW)=CH       
          ELSE
            IF(IW.GT.0) THEN
            ENDIF
          ENDIF
        ENDIF
        IF((CH.EQ.' '.AND.IS.EQ.1.AND.IAP.EQ.0).OR.
     *       (IP.EQ.LEN.AND.IW.NE.0)) THEN
          IF(IW.LE.0) THEN
            WORDS(NW)='?'
            LEN_WORDS(NW)=1
          ELSE
            WORDS(NW)=STR(1:IW)
            LEN_WORDS(NW)=IW
          ENDIF
          NWORDS=NW
          CALL WTODIG(STR,IW,FA,IA)
          IWORDS(NW)=IA
          FWORDS(NW)=FA
          IS=0
          IW=0
          IAP=0
        ENDIF
      ENDDO
C -----------------
      RETURN
      END      

C ******
      SUBROUTINE GETCIF_3CRD(IUN,MDOC,IERR,IEND)
C -------------------------------------------------------
C -P- GETCIF_3CRD - reads the records from file and get information from 
C -P-          records by CIF_style. 
C     Each call of subroutine returns set of loop (or only one)
C     item_names and corresponding data, also its data_block_name.
C     Returned information are in common /COMCIF_3CRD/
C     
C     input:
C           IUN  - log. unit number.
C           MDOC - mode of writting messages to DOC-file /See subr. OPENDOC/
C                   0 - only terminal , < - 0 only file, 0 < < 99 - both
C                   >= 99 - don't write  
C           IEND - for first call must be equal = -1; for others = 0.(or -2)
C     output:
C           IEND  = 0 - OK, = 1 - end of file, = -2  commets string
C                                                    DT_CIF (NWORDSMAX)
C           IERR  - signal of error. 0 means OK.               
C
C           Returned information are in common /COMCIF_2CRD/:
C
C           N_CIF     - number of returned data.
C           ITM_CIF() - array of item_name
C           DT_CIF () - array of data as string of characters.
C           FDT_CIF() - array of data as integer.
C           IDT_CIF() - array of data as real.
C           BLK_CIF   - data_block_name.
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMCIF_3CRD/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ---
      COMMON /FREAD_3CIF/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*256
C --------------------------------------------------------------
      INTEGER*4 MDOC,IUN,IERR,IEND
C ******
      CHARACTER LINE*80
C --------------------------------------------------------------
      IERR=0
      IF(IEND.EQ.-1) THEN
        N_DATA =0
        N_CIF =0
        N_ITEM =0
        I_CIF  =0
        NWORDS =0
        BLK_CIF=' '
        BLK_FLAG='N'
        LOOP_FLAG='N'
        IEND=0
      ELSE IF(IEND.EQ.-2) THEN
        IEND=0
      ELSE
        IEND=0
        LOOP_FLAG='N'
      ENDIF
  300 CONTINUE
        IF(I_CIF.EQ.NWORDS) THEN
  200     CALL GETLINE(IUN,MDOC,IN_STRING,IERR,IEND)

          IF(IERR.NE.0.OR.IEND.NE.0) RETURN

          IF(IN_STRING(1:5).NE.'data_'.AND.
     *       IN_STRING(1:7).NE.'global_'.AND.BLK_FLAG.EQ.'N') 
     *    GO TO 200

          IF(IN_STRING(1:1).EQ.';') THEN
            DO I=1,32000
              CALL GETLINE(IUN,MDOC,IN_STRING,IERR,IEND)
              IF(IERR.NE.0.OR.IEND.NE.0) RETURN
              IF(IN_STRING(1:1).EQ.';') GO TO 100
            ENDDO
  100       CONTINUE
          ENDIF
          CALL FRD_PARM_3CIF
          IF(NWORDS.LE.0) GO TO 200
          IF(WORDS(1) (1:1).EQ.'#') THEN
            DT_CIF(NWORDSMAX)=IN_STRING
            IEND=-2
            NWORDS=I_CIF
            RETURN 
          ENDIF
          I_CIF=0
        ENDIF      
        I_CIF=I_CIF+1
        IF((WORDS(I_CIF)(1:5).EQ.'data_'  ).OR. 
     *     (WORDS(I_CIF)(1:7).EQ.'global_')) THEN
          BLK_CIF=WORDS(I_CIF)(1:LEN_WORDS(I_CIF))
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          N_DATA=0
          N_ITEM=0
          LOOP_FLAG='N' 
          BLK_FLAG='Y'
          IF(WORDS(I_CIF)(1:5).EQ.'data_'  ) THEN 
            NWORDS=0
            I_CIF=0
            N_CIF=0
            RETURN
          ENDIF

        ELSE IF(BLK_FLAG.EQ.'Y') THEN
       
        IF(WORDS(I_CIF)(1:5).EQ.'loop_'  ) THEN 
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          LOOP_FLAG='Y'
          N_DATA=0
          N_ITEM=0
        ELSE IF(WORDS(I_CIF)(1:1).EQ.'_'  ) THEN 
          IF(LOOP_FLAG.EQ.'N') N_ITEM=0
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          N_DATA=0        
          N_ITEM=N_ITEM+1
          IF(N_ITEM.GT.NWORDSMAX) THEN
            WRITE(LINE,
     *      '('' ERR: CIF_read: too many items in the loop >'',I5)')
     *      NWORDSMAX
            CALL MSGERR(MDOC,LINE)
          ENDIF
          ITM_CIF(N_ITEM)=WORDS(I_CIF) (1:LEN_WORDS(I_CIF))
        ELSE
          IF(N_ITEM.LE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of items =0 / before the data /')
          ENDIF
          LOOP_FLAG='N'
          N_DATA=N_DATA+1
          N_CIF=N_DATA
          DT_CIF(N_CIF) =WORDS(I_CIF)(1:LEN_WORDS(I_CIF))
          IDT_CIF(N_CIF)=IWORDS(I_CIF)
          FDT_CIF(N_CIF)=FWORDS(I_CIF)
          IF(N_DATA.EQ.N_ITEM) THEN
            N_DATA=0
            RETURN
          ENDIF
        ENDIF

        ELSE
          I_CIF=NWORDS
        ENDIF   

      GO TO 300

      END

C ******
      SUBROUTINE FRD_PARM_3CIF
C -------------------------------------------------------
C -P- FRD_PARM_3CIF - free format reading of the string of characters.
C                     See common /FREAD_3CIF/
C
C     input:     IN_STRING - input string; a word is the part of the string
C                            between two blancs or two "'".
C     output:    NWORDS    - number of words of the string
C                IWORDS    - array of integer value of each word.
C                FWORDS    - array of real value of each word.
C                WORDS     - array of words
C                LEN_WORDS - array of lengths of the words
C                IFRD_ERR  - signal of error. 
C                            0  means OK.
C                            1 - number of words > NWORDSMAX = 40
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /FREAD_3CIF/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*256
C --------------------------------------------------------------
C ******
      REAL      FA
      INTEGER*4 NW,IS,IW,IAP,LEN,IP,IA
      CHARACTER CH*1,CK*1,STR*256
C --------------------------------------------------------------
      IFRD_ERR=0
      NWORDS=0
      NW=0
      IW=0
      IS=0
      IAP=0
      CALL LENSTR_BL(IN_STRING,LEN)
      IF(LEN.LE.0) RETURN
      IF(LEN.GT.256) LEN=256
C -----------------
      DO   IP=1,LEN
        CH=IN_STRING(IP:IP)
        CALL CHKSMB(CH,CK)
        IF(CK.EQ.'?') CH=' '
        IF(CH.EQ.'''') THEN
          IAP=IAP+1
          IF(IAP.GE.2) IAP=0
        ENDIF
        IF(CH.NE.' '.OR.IAP.EQ.1) THEN
C         start of a word
          IF(IS.EQ.0) THEN
            IS=1
            NW=NW+1
            IF(NW.GT.NWORDSMAX) THEN
              IFRD_ERR=1
              RETURN
            ENDIF
          ENDIF
          IF(CH.NE.'''') THEN
            IW=IW+1
            STR(IW:IW)=CH       
          ELSE
            IF(IW.GT.0) THEN
            ENDIF
          ENDIF
        ENDIF
        IF((CH.EQ.' '.AND.IS.EQ.1.AND.IAP.EQ.0).OR.
     *       (IP.EQ.LEN.AND.IW.NE.0)) THEN
          IF(IW.LE.0) THEN
            WORDS(NW)='?'
            LEN_WORDS(NW)=1
          ELSE
            WORDS(NW)=STR(1:IW)
            LEN_WORDS(NW)=IW
          ENDIF
          NWORDS=NW
          CALL WTODIG(STR,IW,FA,IA)
          IWORDS(NW)=IA
          FWORDS(NW)=FA
          IS=0
          IW=0
          IAP=0
        ENDIF
      ENDDO
C -----------------
      RETURN
      END      

C ******
      SUBROUTINE FRD_PARM
C -------------------------------------------------------
C -P- FRD_PARM - free format reading of the string of characters.
C                See common /COMFREAD/
C
C     input:     IN_STRING - input string; a word is the part of the string
C                            between two blancs or two "'".
C     output:    NWORDS    - number of words of the string
C                IWORDS    - array of integer value of each word.
C                FWORDS    - array of real value of each word.
C                WORDS     - array of words
C                LEN_WORDS - array of lengths of the words
C                IFRD_ERR  - signal of error. 
C                            0  means OK.
C                            1 - number of words > NWORDSMAX = 40
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMFREAD/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*256
C --------------------------------------------------------------
C ******
      REAL      FA
      INTEGER*4 NW,IS,IW,IAP,LEN,IP,IA
      CHARACTER CH*1,CK*1,STR*256
C --------------------------------------------------------------
      IFRD_ERR=0
      NWORDS=0
      NW=0
      IW=0
      IS=0
      IAP=0
      CALL LENSTR_BL(IN_STRING,LEN)
      IF(LEN.LE.0) RETURN
      IF(LEN.GT.256) LEN=256
C -----------------
      DO   IP=1,LEN
        CH=IN_STRING(IP:IP)
        CALL CHKSMB(CH,CK)
        IF(CK.EQ.'?') CH=' '
        IF(CH.EQ.'''') THEN
          IAP=IAP+1
          IF(IAP.GE.2) IAP=0
        ENDIF
        IF(CH.NE.' '.OR.IAP.EQ.1) THEN
C         start of a word
          IF(IS.EQ.0) THEN
            IS=1
            NW=NW+1
            IF(NW.GT.NWORDSMAX) THEN
              IFRD_ERR=1
              RETURN
            ENDIF
          ENDIF
          IF(CH.NE.'''') THEN
            IW=IW+1
            STR(IW:IW)=CH       
          ELSE
            IF(IW.GT.0) THEN
            ENDIF
          ENDIF
        ENDIF
        IF((CH.EQ.' '.AND.IS.EQ.1.AND.IAP.EQ.0).OR.
     *       (IP.EQ.LEN.AND.IW.NE.0)) THEN
          IF(IW.LE.0) THEN
            WORDS(NW)='?'
            LEN_WORDS(NW)=1
          ELSE
            WORDS(NW)=STR(1:IW)
            LEN_WORDS(NW)=IW
          ENDIF
          NWORDS=NW
          CALL WTODIG(STR,IW,FA,IA)
          IWORDS(NW)=IA
          FWORDS(NW)=FA
          IS=0
          IW=0
          IAP=0
        ENDIF
      ENDDO
C -----------------
      RETURN
      END      

C ******
      SUBROUTINE FRD_PARM_KEYWORDS
C -------------------------------------------------------
C -P- FRD_PARM - free format reading of the string of characters.
C                See common /COMFREAD/
C
C     input:     IN_STRING - input string; a word is the part of the string
C                            between two blancs or two "'".
C     output:    NWORDS    - number of words of the string
C                IWORDS    - array of integer value of each word.
C                FWORDS    - array of real value of each word.
C                WORDS     - array of words
C                LEN_WORDS - array of lengths of the words
C                IFRD_ERR  - signal of error. 
C                            0  means OK.
C                            1 - number of words > NWORDSMAX = 40
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMFREAD_KEYWORDS/ 
     *                  FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*256
      CHARACTER IN_STRING*256
C --------------------------------------------------------------
C ******
      REAL      FA
      INTEGER*4 NW,IS,IW,IAP,LEN,IP,IA
      CHARACTER CH*1,CK*1,STR*256
C --------------------------------------------------------------
      IFRD_ERR=0
      NWORDS  =0
      NW      =0
      IW      =0
      IS      =0
      IAP     =0
      CALL LENSTR_BL(IN_STRING,LEN)
      IF(LEN.LE.0) RETURN
      IF(LEN.GT.256) LEN=256
C -----------------
      DO   IP=1,LEN
        CH=IN_STRING(IP:IP)
        CALL CHKSMB(CH,CK)
        IF(CK.EQ.'?') CH=' '
        IF(CH.EQ.'''') THEN
          IAP=IAP+1
          IF(IAP.GE.2) IAP=0
        ENDIF
        IF(CH.NE.' '.OR.IAP.EQ.1) THEN
C         start of a word
          IF(IS.EQ.0) THEN
            IS=1
            NW=NW+1
            IF(NW.GT.20) THEN
              IFRD_ERR=1
              RETURN
            ENDIF
          ENDIF
          IF(CH.NE.'''') THEN
            IW=IW+1
            STR(IW:IW)=CH       
          ELSE
            IF(IW.GT.0) THEN
            ENDIF
          ENDIF
        ENDIF
        IF((CH.EQ.' '.AND.IS.EQ.1.AND.IAP.EQ.0).OR.
     *       (IP.EQ.LEN.AND.IW.NE.0)) THEN
          IF(IW.LE.0) THEN
            WORDS(NW)='?'
            LEN_WORDS(NW)=1
          ELSE
            WORDS(NW)=STR(1:IW)
            LEN_WORDS(NW)=IW
          ENDIF
          NWORDS=NW
          CALL WTODIG(STR,IW,FA,IA)
          IWORDS(NW)=IA
          FWORDS(NW)=FA
          IS=0
          IW=0
          IAP=0
        ENDIF
      ENDDO
C -----------------
      RETURN
      END      

      SUBROUTINE FRD_2PARM
C -------------------------------------------------------
C -P- FRD_PARM - free format reading of the string of characters.
C                See common /COM2FREAD/
C
C     input:     IN_STRING - input string; a word is the part of the string
C                            between two blancs or two "'".
C     output:    NWORDS    - number of words of the string
C                IWORDS    - array of integer value of each word.
C                FWORDS    - array of real value of each word.
C                WORDS     - array of words
C                LEN_WORDS - array of lengths of the words
C                IFRD_ERR  - signal of error. 
C                            0  means OK.
C                            1 - number of words > NWORDSMAX = 40
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COM2FREAD/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*256
C --------------------------------------------------------------
      REAL      FA
      INTEGER*4 NW,IS,IW,IAP,LEN,IP,IA
      CHARACTER CH*1,CK*1,STR*256
C --------------------------------------------------------------
      IFRD_ERR=0
      NWORDS=0
      NW=0
      IW=0
      IS=0
      IAP=0
      CALL LENSTR_BL(IN_STRING,LEN)
      IF(LEN.LE.0) RETURN
      IF(LEN.GT.256) LEN=256
C -----------------
      DO   IP=1,LEN
        CH=IN_STRING(IP:IP)
        CALL CHKSMB(CH,CK)
        IF(CK.EQ.'?') CH=' '
        IF(CH.EQ.'''') THEN
          IAP=IAP+1
          IF(IAP.GE.2) IAP=0
        ENDIF
        IF(CH.NE.' '.OR.IAP.EQ.1) THEN
C         start of a word
          IF(IS.EQ.0) THEN
            IS=1
            NW=NW+1
            IF(NW.GT.NWORDSMAX) THEN
              IFRD_ERR=1
              RETURN
            ENDIF
          ENDIF
          IF(CH.NE.'''') THEN
            IW=IW+1
            STR(IW:IW)=CH       
          ELSE
            IF(IW.GT.0) THEN
            ENDIF
          ENDIF
        ENDIF
        IF((CH.EQ.' '.AND.IS.EQ.1.AND.IAP.EQ.0).OR.
     *       (IP.EQ.LEN.AND.IW.NE.0)) THEN
          IF(IW.LE.0) THEN
            WORDS(NW)='?'
            LEN_WORDS(NW)=1
          ELSE
            WORDS(NW)=STR(1:IW)
            LEN_WORDS(NW)=IW
          ENDIF
          NWORDS=NW
          CALL WTODIG(STR,IW,FA,IA)
          IWORDS(NW)=IA
          FWORDS(NW)=FA
          IS=0
          IW=0
          IAP=0
        ENDIF
      ENDDO
C -----------------
      RETURN
      END      


C ******
      SUBROUTINE GETCIF_C(IUN,MDOC,IERR,IEND)
C -------------------------------------------------------
C -P- GETCIF - reads the records from file and get information from records
C -P-          by CIF_style. 
C     Each call of subroutine returns set of loop (or only one) 
C     item_names and corresponding data, also its data_block_name or
C     comment string.
C     Returned information are in common /COMCIF/
C     
C     input:
C           IUN  - log. unit number.
C           MDOC - mode of writing messages to DOC-file. 
C                   0 - only terminal , < - 0 only file, 0 < < 99 - both
C                   >= 99 - don't write  
C           IEND - for first call must be equal = -1; for others = 0 (or -2)
C
C     output:
C           IEND  = 0  - OK 
C                 = 1  - end of file 
C                 = -2 - OK, comment string was reading, puts comment string
C                            into DT_CIF.
C                                                   
C           IERR  - signal of error. 0 means OK.               
C
C           Returned information are in common /COMCIF/:
C
C           N_CIF     - number of returned data.
C           ITM_CIF() - array of item_name
C           DT_CIF () - array of data as string of characters.
C           FDT_CIF() - array of data as integer.
C           IDT_CIF() - array of data as real.
C           BLK_CIF   - data_block_name.
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMCIF_CRD_C/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ---
      COMMON /COMFREAD_C/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*256
C --------------------------------------------------------------
      INTEGER*4 MDOC,IUN,IERR,IEND
C ******
      CHARACTER LINE*80
C --------------------------------------------------------------
      IERR=0
      IF(IEND.EQ.-1) THEN
        N_DATA =0
        N_CIF =0
        N_ITEM =0
        I_CIF  =0
        NWORDS =0
        BLK_CIF=' '
        BLK_FLAG='N'
        LOOP_FLAG='N'
        IEND=0
      ELSE IF(IEND.EQ.-2) THEN
        IEND=0
      ELSE
        IEND=0
        LOOP_FLAG='N'
      ENDIF

  300 CONTINUE

        IF(I_CIF.EQ.NWORDS) THEN

  200     CALL GETLINE(IUN,MDOC,IN_STRING,IERR,IEND)

          IF(IERR.NE.0.OR.IEND.NE.0) RETURN
C ===          
          CALL LENSTR_BL(IN_STRING,LEN_IN)

          IF(LEN_IN.GT.1.AND.IN_STRING(1:1).NE.';'.AND.
     *                       IN_STRING(1:1).NE.'#') THEN
            IFLAG=0
            II=1
            DO I=1,LEN_IN
              IF(IFLAG.EQ.0) THEN
                IF(IN_STRING(I:I).EQ.'''') II=II*(-1)
                IF(II.GT.0) THEN
                  IF(IN_STRING(I:I).EQ.'#') THEN
                    IFLAG=1
                    IN_STRING(I:I)=' '
                  ENDIF
                ENDIF
              ELSE
                IN_STRING(I:I)=' '
              ENDIF
            ENDDO
          ENDIF
C ===        
          IF(IN_STRING(1:5).NE.'data_'.AND.
     *       IN_STRING(1:7).NE.'global_'.AND.BLK_FLAG.EQ.'N') 
     *    GO TO 200
C ===
          IF(IN_STRING(1:1).EQ.';') THEN
            LLN=0
            IFLAG=0
            CALL LENSTR_BL(IN_STRING,LEN_IN)
            LN=LEN_IN
            IF(LN.GT.78) LN=78
            LINE(2:LN+1)=IN_STRING(1:LN)
            LINE(1:1)  =''''
            LINE(2:2)  =' '
            LINE(LN+2:LN+2)=''''
            IF(LEN_IN.GT.1) THEN
              IFLAG=1
              LLN=LN+2
            ENDIF
            DO I=1,32000
              CALL GETLINE(IUN,MDOC,IN_STRING,IERR,IEND)
              IF(IERR.NE.0.OR.IEND.NE.0) RETURN
              CALL LENSTR_BL(IN_STRING,LEN_IN)
              LN=LEN_IN
              IF(LN.GT.78) LN=78
              IF(IFLAG.EQ.0) THEN
                CALL LENSTR_BL(IN_STRING,LEN_IN)
                IF(LEN_IN.GT.1) THEN
c                  LINE=IN_STRING
                  LN=LEN_IN
                  IF(LN.GT.78) LN=78
                  LINE(2:LN+1)=IN_STRING(1:LN)
                  LINE(1:1)  = ''''
                  IF(LINE(2:2).EQ.';') LINE(2:2)  =' '
                  LINE(LN+2:LN+2)= ''''
                  IFLAG=1
                  LLN=LN+2
                ENDIF
              ENDIF
              IF(IN_STRING(1:1).EQ.';') GO TO 100
            ENDDO
  100       CONTINUE
            LNN=LLN
            IF(LNN.GT.2) THEN
              LN=1
              IFLAG=0
              DO I=2,LNN-1
                IF(LINE(I:I).EQ.'''') LINE(I:I)='"'

                IF(LINE(I:I).EQ.' '.AND.IFLAG.EQ.0) THEN

                ELSE
                  IFLAG=1
                  LN=LN+1
                  LINE(LN:LN)=LINE(I:I)
                ENDIF

              ENDDO
              LINE(1:1)    =''''
              LINE(LN+1:LN+1)  =''''
            ELSE
              LN=3
              LINE(1:1)    =''''
              LINE(2:2)    ='.'
              LINE(LN:LN)  =''''
            ENDIF
            IN_STRING=LINE(1:LN)

          ENDIF
C ===
          CALL FRD_PARM_C

          IF(NWORDS.LE.0) GO TO 200
C ==
          IF(WORDS(1) (1:1).EQ.'#') THEN
            DT_CIF(NWORDSMAX)=IN_STRING
            IEND=-2
            NWORDS=I_CIF
            RETURN 
          ENDIF
C ==
          I_CIF=0

        ENDIF
      
        I_CIF=I_CIF+1
        IF((WORDS(I_CIF)(1:5).EQ.'data_'  ).OR. 
     *     (WORDS(I_CIF)(1:7).EQ.'global_')) THEN
          BLK_CIF=WORDS(I_CIF)(1:LEN_WORDS(I_CIF))
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          N_DATA=0
          N_ITEM=0
          LOOP_FLAG='N' 
          BLK_FLAG='Y'
          IF(WORDS(I_CIF)(1:5).EQ.'data_'  ) THEN 
            NWORDS=0
            I_CIF=0
            N_CIF=0
            RETURN
          ENDIF

        ELSE IF(BLK_FLAG.EQ.'Y') THEN
       
        IF(WORDS(I_CIF)(1:5).EQ.'loop_'  ) THEN 
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          LOOP_FLAG='Y'
          N_DATA=0
          N_ITEM=0
        ELSE IF(WORDS(I_CIF)(1:1).EQ.'_'  ) THEN 
          IF(LOOP_FLAG.EQ.'N') N_ITEM=0
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          N_DATA=0        
          N_ITEM=N_ITEM+1
          IF(N_ITEM.GT.NWORDSMAX) THEN
            WRITE(LINE,
     *      '('' ERR: CIF_read: too many items in the loop >'',I5)')
     *      NWORDSMAX
            CALL MSGERR(MDOC,LINE)
          ENDIF
          ITM_CIF(N_ITEM)=WORDS(I_CIF) (1:LEN_WORDS(I_CIF))
        ELSE
          IF(N_ITEM.LE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of items =0 / before the data /')
            CALL MSGERR(MDOC,IN_STRING)
           
          ENDIF
          LOOP_FLAG='N'
          N_DATA=N_DATA+1
          N_CIF=N_DATA
          DT_CIF(N_CIF) =WORDS(I_CIF)(1:LEN_WORDS(I_CIF))
          IDT_CIF(N_CIF)=IWORDS(I_CIF)
          FDT_CIF(N_CIF)=FWORDS(I_CIF)
          IF(N_DATA.EQ.N_ITEM) THEN
            N_DATA=0
            RETURN
          ENDIF
        ENDIF

        ELSE
          I_CIF=NWORDS
        ENDIF   

      GO TO 300

      END

C ******
      SUBROUTINE FRD_PARM_C
C -------------------------------------------------------
C -P- FRD_PARM - free format reading of the string of characters.
C                See common /COMFREAD/
C
C     input:     IN_STRING - input string; a word is the part of the string
C                            between two blancs or two "'".
C     output:    NWORDS    - number of words of the string
C                IWORDS    - array of integer value of each word.
C                FWORDS    - array of real value of each word.
C                WORDS     - array of words
C                LEN_WORDS - array of lengths of the words
C                IFRD_ERR  - signal of error. 
C                            0  means OK.
C                            1 - number of words > NWORDSMAX = 40
C -S-
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMFREAD_C/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*256
C --------------------------------------------------------------
C ******
      REAL      FA
      INTEGER*4 NW,IS,IW,IAP,LEN,IP,IA
      CHARACTER CH*1,CK*1,STR*256
C --------------------------------------------------------------
      IFRD_ERR=0
      NWORDS=0
      NW=0
      IW=0
      IS=0
      IAP=0
      CALL LENSTR_BL(IN_STRING,LEN)
      IF(LEN.LE.0) RETURN
      IF(LEN.GT.256) LEN=256
C -----------------
      DO   IP=1,LEN
        CH=IN_STRING(IP:IP)
        CALL CHKSMB(CH,CK)
        IF(CK.EQ.'?') CH=' '
        IF(CH.EQ.'''') THEN
          IAP=IAP+1
          IF(IAP.GE.2) IAP=0
        ENDIF
        IF(CH.NE.' '.OR.IAP.EQ.1) THEN
C         start of a word
          IF(IS.EQ.0) THEN
            IS=1
            NW=NW+1
            IF(NW.GT.NWORDSMAX) THEN
              IFRD_ERR=1
              RETURN
            ENDIF
          ENDIF
          IF(CH.NE.'''') THEN
            IW=IW+1
            STR(IW:IW)=CH       
          ELSE
            IF(IW.GT.0) THEN
            ENDIF
          ENDIF
        ENDIF
        IF((CH.EQ.' '.AND.IS.EQ.1.AND.IAP.EQ.0).OR.
     *       (IP.EQ.LEN.AND.IW.NE.0)) THEN
          IF(IW.LE.0) THEN
            WORDS(NW)='?'
            LEN_WORDS(NW)=1
          ELSE
            WORDS(NW)=STR(1:IW)
            LEN_WORDS(NW)=IW
          ENDIF
          NWORDS=NW
          CALL WTODIG(STR,IW,FA,IA)
          IWORDS(NW)=IA
          FWORDS(NW)=FA
          IS=0
          IW=0
          IAP=0
        ENDIF
      ENDDO
C -----------------
      RETURN
      END      

C ******
      SUBROUTINE WTODIG(STR,IW,F,I)
C -------------------------------------------------------
C -P- WTODIG - convert string to integer and real.
C              
C              STR  - input string of characters (without blancs).
C              IW   - number of characters in the string.
C              I    - output integer value of string.
C              F    - output real value of string.
C      Subroutine returns I=0 and F=0.0 if it can't convert the string 
C      to the digits.
C      Examples right strings: "+23", "324", "-123", "-1.0", "0.23",
C                              "+2.00", "-1.2E-2", "0.3e+2", "-3E4".
C -------------------------------------------------------
      REAL F
      INTEGER*4 I,IW
      CHARACTER STR*(*)
C ******
C ---
      REAL A,SIGN
      INTEGER*4 IA,INTGR,IPOINT,NP,K,J
      CHARACTER CH*1,NUM(10)*1
      DATA NUM /'0','1','2','3','4','5','6','7','8','9'/
C ---------------------------------
      INTGR=0
      SIGN=1.0
      IPOINT=0
      NP=0
      F=0.0
      I=0
      A=0.0
      IA=0
      IE=0
      IF(IW.GT.16) RETURN
C --------------------------------
      DO   J=1,IW
        CH=STR(J:J)
        DO    K=1,10
          IF(CH.EQ.NUM(K)) GO TO 100
        ENDDO  
        IF((CH.EQ.'-'.OR.CH.EQ.'+').AND.J.EQ.1) THEN
          IF(CH.EQ.'-') SIGN=-1.0
          GO TO 200
        ENDIF
        IF(CH.EQ.'.'.AND.IPOINT.EQ.0) THEN
          IPOINT=1
          GO TO 200
        ENDIF
        IF(CH.EQ.'e'.OR.CH.EQ.'E') THEN
          IF(A.EQ.0.0) RETURN
          IE=1
          GO TO 300
        ENDIF
        RETURN
  100   CONTINUE
        K=K-1
        IF(IPOINT.EQ.1) NP=NP+1
        A=A*10.0+K
        IF(IPOINT.EQ.0) IA=IA*10+K
 200    CONTINUE
      ENDDO
 300  F=SIGN*A/10.0**NP
      I=IA
      IF(SIGN.LT.0.0) I=-I
C --- 
      J=J+1
      IF(IE.EQ.0.OR.J.GT.IW) RETURN
      I=0
      IA=0
      A=F
      F=0.0
      ISIGN=1
C --------------------------------
      JJ=J
      DO   J=JJ,IW
        CH=STR(J:J)
        DO    K=1,10
          IF(CH.EQ.NUM(K)) GO TO 400
        ENDDO  
        IF((CH.EQ.'-'.OR.CH.EQ.'+').AND.J.EQ.JJ) THEN
          IF(CH.EQ.'-') ISIGN=-1
          GO TO 500
        ENDIF
        RETURN
  400   CONTINUE
        K=K-1
        IA=IA*10+K
  500   CONTINUE
      ENDDO
      IF(IA.GT.31) IA=31
      IF(ISIGN.LT.0) IA=-IA
      F= A * 10.0**IA
C ---------------------------------
      RETURN
      END

C ******
      SUBROUTINE CLEAR_STR(STR)
C
C -P- CLEAR_STR - put blancs to the string.
C ******
C -------
      CHARACTER STR*(*)
      INTEGER*4 NL
C -------------------------------------------
      NL=LEN(STR)
      IF(NL.LE.0) THEN
        STR=' '
        NL=1
      ELSE
        DO I=1,NL
          STR(I:I)=' '
        ENDDO
      ENDIF
      RETURN
      END

      SUBROUTINE CLEAR_LINE(LINE)
C
      CHARACTER LINE*(*)
C ******
      INTEGER*4 L
C -------------------------------------------------------------
      CALL LENSTR_BL(LINE,L)
      IF(L.GT.0) THEN
        DO I=L,1,-1
          IF(LINE(I:I).EQ.',') THEN
            LINE(I:I)=' '
          ELSE
            IF(LINE(I:I).NE.' ') GO TO 100
          ENDIF 
        ENDDO
 100    CONTINUE
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE WRTSTR(IUN,MDOC,LINE,IERR)
C -------------------------------------------------------
C -P- WRTSTR - writes a string to file. /max 80 chars/
C -------------------------------------------------------
      INTEGER*4 MDOC,IUN,IERR
      CHARACTER LINE*(*)
C ******
C ----------------------------------
      IERR=0
      IF(IUN.LE.0) RETURN
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LE.0) RETURN
      WRITE(IUN,'(A)',ERR=100) LINE(1:LEN)
      IF(LEN.GT.256) LEN=256
      CALL MSGDOC(MDOC,LINE(1:LEN))
      RETURN
  100 CONTINUE
      IERR=1
      RETURN
      END      

C 
      SUBROUTINE FREDA(LINE,IMIN,IMAX,NCHAR,KN,KL,FN,FL)
      CHARACTER   LINE*(*)
C ----
      CHARACTER   FL(6)*40
      REAL        FN(40)
C 
C ----
      INTEGER NUM(10)
      CHARACTER INUM(10)*1,ICH*1
      DATA  NCHLIM/6/
      DATA  NUM / 1,  2,  3,  4,  5,  6,  7,  8,  9,  0 /
      DATA  INUM/'1','2','3','4','5','6','7','8','9','0'/
C -----------------------------------------------------------
      IF(NCHAR.GT.NCHLIM) NCHAR=NCHLIM
      DO     KN=1,40
        FN(KN)=0.0
        IF(NCHAR.GT.0) THEN
          DO     KL=1,NCHAR
            FL(KL)=' '
          ENDDO
        ENDIF
      ENDDO
C ------
      KN=0
      KL=0
      I=IMIN-1
C
C ---- START OF A NEW FIELD
C ---- LOOK FOR A NON-BLANK COLUMN
C
  109 A =0.0
      IP=0
      NP=0
      L=0
      S=1.0
  110 I=I+1
      IF(I.GT.IMAX)  GO TO 108
  111   ICH=LINE(I:I)
        IF(L.EQ.0  .AND.  ICH.EQ.' ')  GO TO 110
C ----  START OF A FIELD
        L=L+1
        DO 100 J=1,10
        IF(ICH.EQ.INUM(J)) GO TO 101
  100   CONTINUE
        IF(ICH.EQ.'.')  GO TO 102
        IF(ICH.EQ.'+')  GO TO 103
        IF(ICH.EQ.'-')  GO TO 104
        IF(L.GT.1)  GO TO 105
        GO TO 150
C ---- START OF A LITERAL FIELD BY A CHARACTER WHICH IS OTHER THAN 0-9+-.
C
C ---- NUMERIC FIELD FOUND
C
  101   IF(J.EQ.10)  J=0
        IF(IP.EQ.1)  NP=NP+1
  106   A=10.0*A + J
        GO TO 110
  102   IP=1
        GO TO 110
  103   IF(L.GT.1)  GO TO 105
        S=1.0
        GO TO 110
  104   IF(L.GT.1)  GO TO 105
        S=-1.0
        GO TO 110

  108   IF(L.GT.0)  GO TO 105
        GO TO 120

C ----  END OF NUMERIC FIELD
  105   A = S*A/10.0**NP
        KN=KN+1
        FN(KN)=A
        IF(ICH.EQ.'+' .OR. ICH.EQ.'-')   I=I-1
        GO TO 109
C
C --- LITERAL FIELD
C
  150  KL=KL+1
  151  FL(L)(KL:KL) = ICH
       L=L+1
       IF(L.GT.NCHAR)  GO TO 109
       I=I+1
       IF(I.GT.IMAX)  GO TO 152
       ICH=LINE(I:I)
       IF(ICH.EQ.' ')  GO TO 152
       GO TO 151
C ---- END OF LITERAL FIELD DEFINED BY BLANK
  152  DO  J=L,NCHAR
         FL(J)(KL:KL) = ' '
       ENDDO
       GO TO 109
C
C    FINISHED
C
  120 RETURN
      END

C 
      SUBROUTINE ABSFR2(MDOC,LINE,NA,NABS,JABS,IPRABS,IERR)
C
C            MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       =< 99 - not write  
C            NABS  - condition of absence number
C            JABS  - conditions of absences
C                    type indices:
C     h**2*JABS(1)+k**2*JABS(2)+l**2*JABS(3)+
C      +(h*JABS(4)+k*ABS(5)+l*JABS(6))**2 +JABS(7)=0
C                    condition   :
C    MOD [ h*JABS(8)+k*ABS(9)+l*JABS(10)+JABS(11) , JABS(12) ] = JABS(13)
C
      INTEGER*2 JABS(13,IPRABS)
      INTEGER   NABS,NA
      CHARACTER LINE*(*),STR*80
C 
      REAL      RABS(13)
      INTEGER   NUM(10),JIND(13)
      CHARACTER INUM(10)*1,ICH*1
      DATA NUM / 1,  2,  3,  4,  5,  6,  7,  8,  9,  0 /
      DATA INUM/'1','2','3','4','5','6','7','8','9','0'/
C ---------------------------------------------------------------
      IERR=0
      I1=1
      IF(LINE(1:1).EQ.'A') I1=6
      IMAX=80
      I=I1-1
      DO     J=1,13
        JABS(J,NA)=0.
        JIND(J)=0
        RABS(J)=0.0
      ENDDO
      S=1.0
      T=0.0
      IP=0
      NP=0
      ISL=0
      IFOUND=0
      JJ=0
      J=0
  100 I=I+1
      IF(I.GT.IMAX)      GO TO 110
      ICH =LINE(I:I)
      IF(ICH.EQ.' ')  GO TO 100
      IF(IFOUND.GT.0)    GO TO 109
      IF(ICH.EQ.','.OR.ICH.EQ.':') THEN
        JJ=JJ+1
        IF(JJ.GT.3) GO TO 108
        JIND(JJ)=J
        IF(T.NE.0.0) S=T
        RABS(JJ) = S*S
        IF(J.EQ.0) THEN
          JABS(JJ,NA)=1
        ELSE
          JABS(JJ,NA)=0
          IF(JJ.GT.1) THEN
            DO     L=1,JJ-1
              IF(JIND(L).EQ.JIND(JJ)) THEN
                JABS(L ,NA)= 0
                JABS(JJ,NA)= 0
                JABS(L+3 ,NA)= 1
                JABS(JJ+3,NA)=-1
                IF(RABS(L) .NE.0.0) JABS(L +3,NA)= RABS(L)
                IF(RABS(JJ).NE.0.0) JABS(JJ+3,NA)=-RABS(JJ)
              ENDIF
            ENDDO
          ENDIF
        ENDIF
 108    IF(ICH.EQ.':') GO TO 109
        IF(JJ.GT.3)    IFOUND=1
        S=1.0
        T=0.0
        J=0
        IP=0
        NP=0
        ISL=0
        GO TO 100
      ENDIF

      IF(ICH.EQ.'H') THEN
        J  =1
        GO TO 100
      ENDIF
      IF(ICH.EQ.'K') THEN
        J  =2
        GO TO 100
      ENDIF
      IF(ICH.EQ.'L') THEN
        J  =3
        GO TO 100
      ENDIF
      IF(ICH.EQ.'+') THEN
        S  = 1.0
        GO TO 100
      ENDIF
      IF(ICH.EQ.'-') THEN
        S  =-1.0
        GO TO 100
      ENDIF
      IF(ICH.EQ.'/') THEN
        ISL=1
        GO TO 100
      ENDIF
      IF(ICH.EQ.'.') THEN
        IP =1
        GO TO 100
      ENDIF

      DO     K=1,10
        IF(ICH.EQ.INUM(K))  GO TO 102
      ENDDO

      WRITE(STR,9101) ICH
 9101 FORMAT(' ERR: INVALID CHARACTER...',A1)
      CALL MSGERR(MDOC,STR)
      IERR=1
      GO TO 100

  102 A = NUM(K)
      IF(ISL.EQ.1)  GO TO 103
      IF(IP .EQ.1)  GO TO 104
      T = A*S
      GO TO 100

  103 T = T/A
      GO TO 100
  104 NP=NP+1
      T = T + A/10**NP
      GO TO 100
C -------- AFTER : ------------------------
  109 CONTINUE
      JJ=7
      IF1=0
      S=1.0
      T=0.0
      IP=0
      NP=0
      ISL=0
  200 I=I+1
      J=0
      IF(I.GT.IMAX)      GO TO 110
      ICH =LINE(I:I)
      IF(ICH.EQ.' ')  GO TO 200
      IF(ICH.EQ.'=') THEN
C       IF(T.NE.0) S=T
C       JABS(11,NA)=S
        IF1=IF1+1
        T=0.0
        S=1.0
        IP=0
        NP=0
        ISL=0
        GO TO 200
      ENDIF
      IF(ICH.EQ.'N') THEN
        IF(T.NE.0) S=T
        JABS(12,NA)=S
        ITEMP=S
        IF1=IF1+1
        T=0.0
        S=1.0
        IP=0
        NP=0
        ISL=0
        GO TO 200
      ENDIF

      IF(ICH.EQ.'H') THEN
        J  =1
        IF(T.NE.0) S=T
        JABS(JJ+J,NA)=S
        T=0.0
        S=1.0
        IP=0
        NP=0
        ISL=0
        GO TO 200
      ENDIF
      IF(ICH.EQ.'K') THEN
        J  =2
        IF(T.NE.0) S=T
        JABS(JJ+J,NA)=S
        T=0.0
        S=1.0
        IP=0
        NP=0
        ISL=0
        GO TO 200
      ENDIF
      IF(ICH.EQ.'L') THEN
        J  =3
        IF(T.NE.0) S=T
        JABS(JJ+J,NA)=S
        T=0.0
        S=1.0
        IP=0
        NP=0
        ISL=0
        GO TO 200
      ENDIF
      IF(ICH.EQ.'+') THEN
        S  = 1.0
        GO TO 200
      ENDIF
      IF(ICH.EQ.'-') THEN
        S  =-1.0
        GO TO 200
      ENDIF
      IF(ICH.EQ.'/') THEN
        ISL=1
        GO TO 200
      ENDIF
      IF(ICH.EQ.'.') THEN
        IP =1
        GO TO 200
      ENDIF

      DO     K=1,10
        IF(ICH.EQ.INUM(K))  GO TO 202
      ENDDO

      WRITE(STR,9101) ICH
      IERR=1
      CALL MSGERR(MDOC,STR)
      GO TO 200

  202 A = NUM(K)
      IF(ISL.EQ.1)  GO TO 203
      IF(IP .EQ.1)  GO TO 204
      T = A*S
      GO TO 200

  203 T = T/A
      GO TO 200
  204 NP=NP+1
      T = T + A/10**NP
      GO TO 200
C --------------------
  110 IF(T.NE.0) THEN
        IF(T.LT.0.0) T=ITEMP+T
        JABS(13,NA) = T
      ENDIF

      IF(IF1.NE.2) THEN
        CALL MSGERR(MDOC,' ERR: WRONG OPERATOR FIELD')
        IERR=1
      ENDIF
      NABS=NA
      RETURN
      END

      SUBROUTINE EXITB 
C      CALL EXIT
      RETURN
      END


C ******
      SUBROUTINE GET_SFA(ASYMB
     *      ,N,NEL,A1,A2,A3,A4,B1,B2,B3,B4,C,FI,FII,RAD,IERR)
C -----------------------------------------------
C -P- GET_SFA - gets atomic scatt.factor coefficients for atomic type.
C -S-
      REAL      A1,A2,A3,A4,B1,B2,B3,B4,C,FI,FII,RAD
      INTEGER*4 N,NEL,IERR
      CHARACTER ASYMB*4
C ******
C ---
      REAL      TSF_A1(94),TSF_A2(94),TSF_A3 (94),TSF_A4 (94)
      REAL      TSF_B1(94),TSF_B2(94),TSF_B3 (94),TSF_B4 (94)
      REAL      TSF_C (94),TSF_FI(94),TSF_FII(94),TSF_RAD(94)
      INTEGER*4 TSF_N,TSF_NE(94)
      CHARACTER TSF_ATOM(94)*4
C ---
      DATA TSF_N /94/
      DATA TSF_ATOM( 1)/'H   '/,TSF_NE( 1)/ 1/,TSF_RAD( 1)/1.50/
     * ,TSF_A1( 1)/  0.49300/,TSF_B1( 1)/ 10.51091/
     * ,TSF_A2( 1)/  0.32291/,TSF_B2( 1)/ 26.12573/
     * ,TSF_A3( 1)/  0.14019/,TSF_B3( 1)/  3.14236/
     * ,TSF_A4( 1)/  0.04081/,TSF_B4( 1)/ 57.79977/
     * ,TSF_C ( 1)/  0.00304/
     * ,TSF_FI( 1)/  0.00000/,TSF_FII( 1)/  0.00000/
      DATA TSF_ATOM( 2)/'HE  '/,TSF_NE( 2)/ 2/,TSF_RAD( 2)/1.50/
     * ,TSF_A1( 2)/  0.87340/,TSF_B1( 2)/  9.10371/
     * ,TSF_A2( 2)/  0.63090/,TSF_B2( 2)/  3.35680/
     * ,TSF_A3( 2)/  0.31120/,TSF_B3( 2)/ 22.92763/
     * ,TSF_A4( 2)/  0.17800/,TSF_B4( 2)/  0.98210/
     * ,TSF_C ( 2)/  0.00640/
     * ,TSF_FI( 2)/  0.00000/,TSF_FII( 2)/  0.00000/
      DATA TSF_ATOM( 3)/'LI  '/,TSF_NE( 3)/ 3/,TSF_RAD( 3)/1.50/
     * ,TSF_A1( 3)/  1.12820/,TSF_B1( 3)/  3.95460/
     * ,TSF_A2( 3)/  0.75080/,TSF_B2( 3)/  1.05240/
     * ,TSF_A3( 3)/  0.61750/,TSF_B3( 3)/ 85.39058/
     * ,TSF_A4( 3)/  0.46530/,TSF_B4( 3)/168.26120/
     * ,TSF_C ( 3)/  0.03770/
     * ,TSF_FI( 3)/  0.00080/,TSF_FII( 3)/  0.00030/
      DATA TSF_ATOM( 4)/'BE  '/,TSF_NE( 4)/ 4/,TSF_RAD( 4)/1.50/
     * ,TSF_A1( 4)/  1.59190/,TSF_B1( 4)/ 43.64275/
     * ,TSF_A2( 4)/  1.12780/,TSF_B2( 4)/  1.86230/
     * ,TSF_A3( 4)/  0.53910/,TSF_B3( 4)/103.48310/
     * ,TSF_A4( 4)/  0.70290/,TSF_B4( 4)/  0.54200/
     * ,TSF_C ( 4)/  0.03850/
     * ,TSF_FI( 4)/  0.00380/,TSF_FII( 4)/  0.00140/
      DATA TSF_ATOM( 5)/'B   '/,TSF_NE( 5)/ 5/,TSF_RAD( 5)/1.50/
     * ,TSF_A1( 5)/  2.05450/,TSF_B1( 5)/ 23.21852/
     * ,TSF_A2( 5)/  1.33260/,TSF_B2( 5)/  1.02100/
     * ,TSF_A3( 5)/  1.09790/,TSF_B3( 5)/ 60.34987/
     * ,TSF_A4( 5)/  0.70680/,TSF_B4( 5)/  0.14030/
     * ,TSF_C ( 5)/ -0.19320/
     * ,TSF_FI( 5)/  0.00900/,TSF_FII( 5)/  0.00390/
      DATA TSF_ATOM( 6)/'C   '/,TSF_NE( 6)/ 6/,TSF_RAD( 6)/1.90/
     * ,TSF_A1( 6)/  2.31000/,TSF_B1( 6)/ 20.84392/
     * ,TSF_A2( 6)/  1.02000/,TSF_B2( 6)/ 10.20751/
     * ,TSF_A3( 6)/  1.58860/,TSF_B3( 6)/  0.56870/
     * ,TSF_A4( 6)/  0.86500/,TSF_B4( 6)/ 51.65125/
     * ,TSF_C ( 6)/  0.21560/
     * ,TSF_FI( 6)/  0.01810/,TSF_FII( 6)/  0.00910/
      DATA TSF_ATOM( 7)/'N   '/,TSF_NE( 7)/ 7/,TSF_RAD( 7)/1.70/
     * ,TSF_A1( 7)/ 12.21261/,TSF_B1( 7)/  0.00570/
     * ,TSF_A2( 7)/  3.13220/,TSF_B2( 7)/  9.89331/
     * ,TSF_A3( 7)/  2.01250/,TSF_B3( 7)/ 28.99754/
     * ,TSF_A4( 7)/  1.16630/,TSF_B4( 7)/  0.58260/
     * ,TSF_C ( 7)/-11.52901/
     * ,TSF_FI( 7)/  0.03110/,TSF_FII( 7)/  0.01800/
      DATA TSF_ATOM( 8)/'O   '/,TSF_NE( 8)/ 8/,TSF_RAD( 8)/1.40/
     * ,TSF_A1( 8)/  3.04850/,TSF_B1( 8)/ 13.27711/
     * ,TSF_A2( 8)/  2.28680/,TSF_B2( 8)/  5.70111/
     * ,TSF_A3( 8)/  1.54630/,TSF_B3( 8)/  0.32390/
     * ,TSF_A4( 8)/  0.86700/,TSF_B4( 8)/ 32.90894/
     * ,TSF_C ( 8)/  0.25080/
     * ,TSF_FI( 8)/  0.04920/,TSF_FII( 8)/  0.03220/
      DATA TSF_ATOM( 9)/'F   '/,TSF_NE( 9)/ 9/,TSF_RAD( 9)/1.50/
     * ,TSF_A1( 9)/  3.53920/,TSF_B1( 9)/ 10.28251/
     * ,TSF_A2( 9)/  2.64120/,TSF_B2( 9)/  4.29440/
     * ,TSF_A3( 9)/  1.51700/,TSF_B3( 9)/  0.26150/
     * ,TSF_A4( 9)/  1.02430/,TSF_B4( 9)/ 26.14763/
     * ,TSF_C ( 9)/  0.27760/
     * ,TSF_FI( 9)/  0.07270/,TSF_FII( 9)/  0.05340/
      DATA TSF_ATOM(10)/'NE  '/,TSF_NE( 10)/10/,TSF_RAD(10)/1.50/
     * ,TSF_A1(10)/  3.95530/,TSF_B1(10)/  8.40421/
     * ,TSF_A2(10)/  3.11250/,TSF_B2(10)/  3.42620/
     * ,TSF_A3(10)/  1.45460/,TSF_B3(10)/  0.23060/
     * ,TSF_A4(10)/  1.12510/,TSF_B4(10)/ 21.71841/
     * ,TSF_C (10)/  0.35150/
     * ,TSF_FI(10)/  0.10190/,TSF_FII(10)/  0.08330/
      DATA TSF_ATOM(11)/'NA  '/,TSF_NE(11)/11/,TSF_RAD(11)/1.50/
     * ,TSF_A1(11)/  4.76260/,TSF_B1(11)/  3.28500/
     * ,TSF_A2(11)/  3.17360/,TSF_B2(11)/  8.84221/
     * ,TSF_A3(11)/  1.26740/,TSF_B3(11)/  0.31360/
     * ,TSF_A4(11)/  1.11280/,TSF_B4(11)/129.42410/
     * ,TSF_C (11)/  0.67600/
     * ,TSF_FI(11)/  0.13530/,TSF_FII(11)/  0.12390/
      DATA TSF_ATOM(12)/'MG  '/,TSF_NE(12)/12/,TSF_RAD(12)/1.50/
     * ,TSF_A1(12)/  5.42041/,TSF_B1(12)/  2.82750/
     * ,TSF_A2(12)/  2.17350/,TSF_B2(12)/ 79.26118/
     * ,TSF_A3(12)/  1.22690/,TSF_B3(12)/  0.38080/
     * ,TSF_A4(12)/  2.30730/,TSF_B4(12)/  7.19371/
     * ,TSF_C (12)/  0.85840/
     * ,TSF_FI(12)/  0.17190/,TSF_FII(12)/  0.17710/
      DATA TSF_ATOM(13)/'AL  '/,TSF_NE(13)/13/,TSF_RAD(13)/1.50/
     * ,TSF_A1(13)/  6.42021/,TSF_B1(13)/  3.03870/
     * ,TSF_A2(13)/  1.90020/,TSF_B2(13)/  0.74260/
     * ,TSF_A3(13)/  1.59360/,TSF_B3(13)/ 31.54724/
     * ,TSF_A4(13)/  1.96460/,TSF_B4(13)/ 85.08868/
     * ,TSF_C (13)/  1.11510/
     * ,TSF_FI(13)/  0.21300/,TSF_FII(13)/  0.24550/
      DATA TSF_ATOM(14)/'SI  '/,TSF_NE(14)/14/,TSF_RAD(14)/1.50/
     * ,TSF_A1(14)/  6.29151/,TSF_B1(14)/  2.43860/
     * ,TSF_A2(14)/  3.03530/,TSF_B2(14)/ 32.33374/
     * ,TSF_A3(14)/  1.98910/,TSF_B3(14)/  0.67850/
     * ,TSF_A4(14)/  1.54100/,TSF_B4(14)/ 81.69379/
     * ,TSF_C (14)/  1.14070/
     * ,TSF_FI(14)/  0.25410/,TSF_FII(14)/  0.33020/
      DATA TSF_ATOM(15)/'P   '/,TSF_NE(15)/15/,TSF_RAD(15)/1.80/
     * ,TSF_A1(15)/  6.43451/,TSF_B1(15)/  1.90670/
     * ,TSF_A2(15)/  4.17910/,TSF_B2(15)/ 27.15704/
     * ,TSF_A3(15)/  1.78000/,TSF_B3(15)/  0.52600/
     * ,TSF_A4(15)/  1.49080/,TSF_B4(15)/ 68.16457/
     * ,TSF_C (15)/  1.11490/
     * ,TSF_FI(15)/  0.29550/,TSF_FII(15)/  0.43350/
      DATA TSF_ATOM(16)/'S   '/,TSF_NE(16)/16/,TSF_RAD(16)/1.80/
     * ,TSF_A1(16)/  6.90531/,TSF_B1(16)/  1.46790/
     * ,TSF_A2(16)/  5.20341/,TSF_B2(16)/ 22.21512/
     * ,TSF_A3(16)/  1.43790/,TSF_B3(16)/  0.25360/
     * ,TSF_A4(16)/  1.58630/,TSF_B4(16)/ 56.17207/
     * ,TSF_C (16)/  0.86690/
     * ,TSF_FI(16)/  0.33310/,TSF_FII(16)/  0.55670/
      DATA TSF_ATOM(17)/'CL  '/,TSF_NE(17)/17/,TSF_RAD(17)/1.50/
     * ,TSF_A1(17)/ 11.46041/,TSF_B1(17)/  0.01040/
     * ,TSF_A2(17)/  7.19641/,TSF_B2(17)/  1.16620/
     * ,TSF_A3(17)/  6.25561/,TSF_B3(17)/ 18.51942/
     * ,TSF_A4(17)/  1.64550/,TSF_B4(17)/ 47.77846/
     * ,TSF_C (17)/ -9.55741/
     * ,TSF_FI(17)/  0.36390/,TSF_FII(17)/  0.70180/
      DATA TSF_ATOM(18)/'AR  '/,TSF_NE(18)/18/,TSF_RAD(18)/1.50/
     * ,TSF_A1(18)/  7.48451/,TSF_B1(18)/  0.90720/
     * ,TSF_A2(18)/  6.77231/,TSF_B2(18)/ 14.84071/
     * ,TSF_A3(18)/  0.65390/,TSF_B3(18)/ 43.89835/
     * ,TSF_A4(18)/  1.64420/,TSF_B4(18)/ 33.39293/
     * ,TSF_C (18)/  1.44450/
     * ,TSF_FI(18)/  0.38430/,TSF_FII(18)/  0.87170/
      DATA TSF_ATOM(19)/'K   '/,TSF_NE(19)/19/,TSF_RAD(19)/1.50/
     * ,TSF_A1(19)/  8.21861/,TSF_B1(19)/ 12.79491/
     * ,TSF_A2(19)/  7.43981/,TSF_B2(19)/  0.77480/
     * ,TSF_A3(19)/  1.05190/,TSF_B3(19)/213.18719/
     * ,TSF_A4(19)/  0.86590/,TSF_B4(19)/ 41.68416/
     * ,TSF_C (19)/  1.42280/
     * ,TSF_FI(19)/  0.38680/,TSF_FII(19)/  1.06570/
      DATA TSF_ATOM(20)/'CA  '/,TSF_NE(20)/20/,TSF_RAD(20)/1.50/
     * ,TSF_A1(20)/  8.62661/,TSF_B1(20)/ 10.44211/
     * ,TSF_A2(20)/  7.38731/,TSF_B2(20)/  0.65990/
     * ,TSF_A3(20)/  1.58990/,TSF_B3(20)/ 85.74849/
     * ,TSF_A4(20)/  1.02110/,TSF_B4(20)/178.43719/
     * ,TSF_C (20)/  1.37510/
     * ,TSF_FI(20)/  0.36410/,TSF_FII(20)/  1.28550/
      DATA TSF_ATOM(21)/'SC  '/,TSF_NE(21)/21/,TSF_RAD(21)/1.50/
     * ,TSF_A1(21)/  9.18901/,TSF_B1(21)/  9.02131/
     * ,TSF_A2(21)/  7.36791/,TSF_B2(21)/  0.57290/
     * ,TSF_A3(21)/  1.64090/,TSF_B3(21)/136.10809/
     * ,TSF_A4(21)/  1.46800/,TSF_B4(21)/ 51.35315/
     * ,TSF_C (21)/  1.33290/
     * ,TSF_FI(21)/  0.31190/,TSF_FII(21)/  1.53310/
      DATA TSF_ATOM(22)/'TI  '/,TSF_NE(22)/22/,TSF_RAD(22)/1.50/
     * ,TSF_A1(22)/  9.75951/,TSF_B1(22)/  7.85081/
     * ,TSF_A2(22)/  7.35581/,TSF_B2(22)/  0.50000/
     * ,TSF_A3(22)/  1.69910/,TSF_B3(22)/ 35.63383/
     * ,TSF_A4(22)/  1.90210/,TSF_B4(22)/116.10510/
     * ,TSF_C (22)/  1.28070/
     * ,TSF_FI(22)/  0.21910/,TSF_FII(22)/  1.80690/
      DATA TSF_ATOM(23)/'V   '/,TSF_NE(23)/23/,TSF_RAD(23)/1.50/
     * ,TSF_A1(23)/ 10.29711/,TSF_B1(23)/  6.86571/
     * ,TSF_A2(23)/  7.35111/,TSF_B2(23)/  0.43850/
     * ,TSF_A3(23)/  2.07030/,TSF_B3(23)/ 26.89383/
     * ,TSF_A4(23)/  2.05710/,TSF_B4(23)/102.47810/
     * ,TSF_C (23)/  1.21990/
     * ,TSF_FI(23)/  0.06870/,TSF_FII(23)/  2.10970/
      DATA TSF_ATOM(24)/'CR  '/,TSF_NE(24)/24/,TSF_RAD(24)/1.50/
     * ,TSF_A1(24)/ 10.64061/,TSF_B1(24)/  6.10381/
     * ,TSF_A2(24)/  7.35371/,TSF_B2(24)/  0.39200/
     * ,TSF_A3(24)/  3.32400/,TSF_B3(24)/ 20.26262/
     * ,TSF_A4(24)/  1.49220/,TSF_B4(24)/ 98.73999/
     * ,TSF_C (24)/  1.18320/
     * ,TSF_FI(24)/ -0.16350/,TSF_FII(24)/  2.44390/
      DATA TSF_ATOM(25)/'MN  '/,TSF_NE(25)/25/,TSF_RAD(25)/1.50/
     * ,TSF_A1(25)/ 11.28191/,TSF_B1(25)/  5.34091/
     * ,TSF_A2(25)/  7.35731/,TSF_B2(25)/  0.34320/
     * ,TSF_A3(25)/  3.01930/,TSF_B3(25)/ 17.86742/
     * ,TSF_A4(25)/  2.24410/,TSF_B4(25)/ 83.75438/
     * ,TSF_C (25)/  1.08960/
     * ,TSF_FI(25)/ -0.52990/,TSF_FII(25)/  2.80520/
      DATA TSF_ATOM(26)/'FE  '/,TSF_NE(26)/26/,TSF_RAD(26)/1.50/
     * ,TSF_A1(26)/ 11.76951/,TSF_B1(26)/  4.76111/
     * ,TSF_A2(26)/  7.35731/,TSF_B2(26)/  0.30720/
     * ,TSF_A3(26)/  3.52220/,TSF_B3(26)/ 15.35351/
     * ,TSF_A4(26)/  2.30450/,TSF_B4(26)/ 76.88058/
     * ,TSF_C (26)/  1.03690/
     * ,TSF_FI(26)/ -1.13360/,TSF_FII(26)/  3.19740/
      DATA TSF_ATOM(27)/'CO  '/,TSF_NE(27)/27/,TSF_RAD(27)/1.50/
     * ,TSF_A1(27)/ 12.28411/,TSF_B1(27)/  4.27910/
     * ,TSF_A2(27)/  7.34091/,TSF_B2(27)/  0.27840/
     * ,TSF_A3(27)/  4.00340/,TSF_B3(27)/ 13.53591/
     * ,TSF_A4(27)/  2.34880/,TSF_B4(27)/ 71.16927/
     * ,TSF_C (27)/  1.01180/
     * ,TSF_FI(27)/ -2.36530/,TSF_FII(27)/  3.61430/
      DATA TSF_ATOM(28)/'NI  '/,TSF_NE(28)/28/,TSF_RAD(28)/1.50/
     * ,TSF_A1(28)/ 12.83761/,TSF_B1(28)/  3.87850/
     * ,TSF_A2(28)/  7.29201/,TSF_B2(28)/  0.25650/
     * ,TSF_A3(28)/  4.44380/,TSF_B3(28)/ 12.17631/
     * ,TSF_A4(28)/  2.38000/,TSF_B4(28)/ 66.34216/
     * ,TSF_C (28)/  1.03410/
     * ,TSF_FI(28)/ -3.00290/,TSF_FII(28)/  0.50910/
      DATA TSF_ATOM(29)/'CU  '/,TSF_NE(29)/29/,TSF_RAD(29)/1.50/
     * ,TSF_A1(29)/ 13.33801/,TSF_B1(29)/  3.58280/
     * ,TSF_A2(29)/  7.16761/,TSF_B2(29)/  0.24700/
     * ,TSF_A3(29)/  5.61581/,TSF_B3(29)/ 11.39661/
     * ,TSF_A4(29)/  1.67350/,TSF_B4(29)/ 64.81267/
     * ,TSF_C (29)/  1.19100/
     * ,TSF_FI(29)/ -1.96460/,TSF_FII(29)/  0.58880/
      DATA TSF_ATOM(30)/'ZN  '/,TSF_NE(30)/30/,TSF_RAD(30)/1.50/
     * ,TSF_A1(30)/ 14.07431/,TSF_B1(30)/  3.26550/
     * ,TSF_A2(30)/  7.03181/,TSF_B2(30)/  0.23330/
     * ,TSF_A3(30)/  5.16521/,TSF_B3(30)/ 10.31631/
     * ,TSF_A4(30)/  2.41000/,TSF_B4(30)/ 58.70976/
     * ,TSF_C (30)/  1.30410/
     * ,TSF_FI(30)/ -1.54910/,TSF_FII(30)/  0.67780/
      DATA TSF_ATOM(31)/'GA  '/,TSF_NE(31)/31/,TSF_RAD(31)/1.50/
     * ,TSF_A1(31)/ 15.23541/,TSF_B1(31)/  3.06690/
     * ,TSF_A2(31)/  6.70061/,TSF_B2(31)/  0.24120/
     * ,TSF_A3(31)/  4.35910/,TSF_B3(31)/ 10.78051/
     * ,TSF_A4(31)/  2.96230/,TSF_B4(31)/ 61.41357/
     * ,TSF_C (31)/  1.71890/
     * ,TSF_FI(31)/ -1.28460/,TSF_FII(31)/  0.77630/
      DATA TSF_ATOM(32)/'GE  '/,TSF_NE(32)/32/,TSF_RAD(32)/1.50/
     * ,TSF_A1(32)/ 16.08162/,TSF_B1(32)/  2.85090/
     * ,TSF_A2(32)/  6.37471/,TSF_B2(32)/  0.25160/
     * ,TSF_A3(32)/  3.70680/,TSF_B3(32)/ 11.44681/
     * ,TSF_A4(32)/  3.68300/,TSF_B4(32)/ 54.76256/
     * ,TSF_C (32)/  2.13130/
     * ,TSF_FI(32)/ -1.08850/,TSF_FII(32)/  0.88550/
      DATA TSF_ATOM(33)/'AS  '/,TSF_NE(33)/33/,TSF_RAD(33)/1.50/
     * ,TSF_A1(33)/ 16.67232/,TSF_B1(33)/  2.63450/
     * ,TSF_A2(33)/  6.07011/,TSF_B2(33)/  0.26470/
     * ,TSF_A3(33)/  3.43130/,TSF_B3(33)/ 12.94791/
     * ,TSF_A4(33)/  4.27790/,TSF_B4(33)/ 47.79726/
     * ,TSF_C (33)/  2.53100/
     * ,TSF_FI(33)/ -0.93000/,TSF_FII(33)/  1.00510/
      DATA TSF_ATOM(34)/'SE  '/,TSF_NE(34)/34/,TSF_RAD(34)/1.50/
     * ,TSF_A1(34)/ 17.00063/,TSF_B1(34)/  2.40980/
     * ,TSF_A2(34)/  5.81961/,TSF_B2(34)/  0.27260/
     * ,TSF_A3(34)/  3.97310/,TSF_B3(34)/ 15.23721/
     * ,TSF_A4(34)/  4.35430/,TSF_B4(34)/ 43.81635/
     * ,TSF_C (34)/  2.84090/
     * ,TSF_FI(34)/ -0.79430/,TSF_FII(34)/  1.13720/
      DATA TSF_ATOM(35)/'BR  '/,TSF_NE(35)/35/,TSF_RAD(35)/1.50/
     * ,TSF_A1(35)/ 17.17892/,TSF_B1(35)/  2.17230/
     * ,TSF_A2(35)/  5.23581/,TSF_B2(35)/ 16.57962/
     * ,TSF_A3(35)/  5.63771/,TSF_B3(35)/  0.26090/
     * ,TSF_A4(35)/  3.98510/,TSF_B4(35)/ 41.43285/
     * ,TSF_C (35)/  2.95570/
     * ,TSF_FI(35)/ -0.67630/,TSF_FII(35)/  1.28050/
      DATA TSF_ATOM(36)/'KR  '/,TSF_NE(36)/36/,TSF_RAD(36)/1.50/
     * ,TSF_A1(36)/ 17.35551/,TSF_B1(36)/  1.93840/
     * ,TSF_A2(36)/  6.72861/,TSF_B2(36)/ 16.56232/
     * ,TSF_A3(36)/  5.54931/,TSF_B3(36)/  0.22610/
     * ,TSF_A4(36)/  3.53750/,TSF_B4(36)/ 39.39723/
     * ,TSF_C (36)/  2.82500/
     * ,TSF_FI(36)/ -0.56570/,TSF_FII(36)/  1.43850/
      DATA TSF_ATOM(37)/'RB  '/,TSF_NE(37)/37/,TSF_RAD(37)/1.50/
     * ,TSF_A1(37)/ 17.17842/,TSF_B1(37)/  1.78880/
     * ,TSF_A2(37)/  9.64351/,TSF_B2(37)/ 17.31512/
     * ,TSF_A3(37)/  5.13990/,TSF_B3(37)/  0.27480/
     * ,TSF_A4(37)/  1.52920/,TSF_B4(37)/164.93420/
     * ,TSF_C (37)/  3.48730/
     * ,TSF_FI(37)/ -0.46880/,TSF_FII(37)/  1.60790/
      DATA TSF_ATOM(38)/'SR  '/,TSF_NE(38)/38/,TSF_RAD(38)/1.50/
     * ,TSF_A1(38)/ 17.56631/,TSF_B1(38)/  1.55640/
     * ,TSF_A2(38)/  9.81841/,TSF_B2(38)/ 14.09881/
     * ,TSF_A3(38)/  5.42200/,TSF_B3(38)/  0.16640/
     * ,TSF_A4(38)/  2.66940/,TSF_B4(38)/132.37610/
     * ,TSF_C (38)/  2.50640/
     * ,TSF_FI(38)/ -0.35280/,TSF_FII(38)/  1.82000/
      DATA TSF_ATOM(39)/'Y   '/,TSF_NE(39)/39/,TSF_RAD(39)/1.50/
     * ,TSF_A1(39)/ 17.77602/,TSF_B1(39)/  1.40290/
     * ,TSF_A2(39)/ 10.29461/,TSF_B2(39)/ 12.80061/
     * ,TSF_A3(39)/  5.72630/,TSF_B3(39)/  0.12560/
     * ,TSF_A4(39)/  3.26588/,TSF_B4(39)/104.35410/
     * ,TSF_C (39)/  1.91213/
     * ,TSF_FI(39)/ -0.26700/,TSF_FII(39)/  2.02440/
      DATA TSF_ATOM(40)/'ZR  '/,TSF_NE(40)/40/,TSF_RAD(40)/1.50/
     * ,TSF_A1(40)/ 17.87653/,TSF_B1(40)/  1.27618/
     * ,TSF_A2(40)/ 10.94801/,TSF_B2(40)/ 11.91601/
     * ,TSF_A3(40)/  5.41733/,TSF_B3(40)/  0.11762/
     * ,TSF_A4(40)/  3.65721/,TSF_B4(40)/ 87.66278/
     * ,TSF_C (40)/  2.06929/
     * ,TSF_FI(40)/ -0.18620/,TSF_FII(40)/  2.24490/
      DATA TSF_ATOM(41)/'NB  '/,TSF_NE(41)/41/,TSF_RAD(41)/1.50/
     * ,TSF_A1(41)/ 17.61423/,TSF_B1(41)/  1.18865/
     * ,TSF_A2(41)/ 12.01441/,TSF_B2(41)/ 11.76601/
     * ,TSF_A3(41)/  4.04183/,TSF_B3(41)/  0.20479/
     * ,TSF_A4(41)/  3.53346/,TSF_B4(41)/ 69.79576/
     * ,TSF_C (41)/  3.75591/
     * ,TSF_FI(41)/ -0.11210/,TSF_FII(41)/  2.48260/
      DATA TSF_ATOM(42)/'MO  '/,TSF_NE(42)/42/,TSF_RAD(42)/1.50/
     * ,TSF_A1(42)/  3.70250/,TSF_B1(42)/  0.27720/
     * ,TSF_A2(42)/ 17.23563/,TSF_B2(42)/  1.09580/
     * ,TSF_A3(42)/ 12.88761/,TSF_B3(42)/ 11.00401/
     * ,TSF_A4(42)/  3.74290/,TSF_B4(42)/ 61.65846/
     * ,TSF_C (42)/  4.38750/
     * ,TSF_FI(42)/ -0.04830/,TSF_FII(42)/  2.73390/
      DATA TSF_ATOM(43)/'TC  '/,TSF_NE(43)/43/,TSF_RAD(43)/1.50/
     * ,TSF_A1(43)/ 19.13013/,TSF_B1(43)/  0.86413/
     * ,TSF_A2(43)/ 11.09481/,TSF_B2(43)/  8.14488/
     * ,TSF_A3(43)/  4.64902/,TSF_B3(43)/ 21.57072/
     * ,TSF_A4(43)/  2.71263/,TSF_B4(43)/ 86.84727/
     * ,TSF_C (43)/  5.40429/
     * ,TSF_FI(43)/  0.00570/,TSF_FII(43)/  3.00490/
      DATA TSF_ATOM(44)/'RU  '/,TSF_NE(44)/44/,TSF_RAD(44)/1.50/
     * ,TSF_A1(44)/ 19.26743/,TSF_B1(44)/  0.80852/
     * ,TSF_A2(44)/ 12.91821/,TSF_B2(44)/  8.43468/
     * ,TSF_A3(44)/  4.86337/,TSF_B3(44)/ 24.79974/
     * ,TSF_A4(44)/  1.56756/,TSF_B4(44)/ 94.29289/
     * ,TSF_C (44)/  5.37875/
     * ,TSF_FI(44)/  0.05520/,TSF_FII(44)/  3.29600/
      DATA TSF_ATOM(45)/'RH  '/,TSF_NE(45)/45/,TSF_RAD(45)/1.50/
     * ,TSF_A1(45)/ 19.29572/,TSF_B1(45)/  0.75154/
     * ,TSF_A2(45)/ 14.35011/,TSF_B2(45)/  8.21759/
     * ,TSF_A3(45)/  4.73425/,TSF_B3(45)/ 25.87494/
     * ,TSF_A4(45)/  1.28918/,TSF_B4(45)/ 98.60629/
     * ,TSF_C (45)/  5.32800/
     * ,TSF_FI(45)/  0.09270/,TSF_FII(45)/  3.60450/
      DATA TSF_ATOM(46)/'PD  '/,TSF_NE(46)/46/,TSF_RAD(46)/1.50/
     * ,TSF_A1(46)/ 19.33192/,TSF_B1(46)/  0.69866/
     * ,TSF_A2(46)/ 15.50172/,TSF_B2(46)/  7.98930/
     * ,TSF_A3(46)/  5.29537/,TSF_B3(46)/ 25.20523/
     * ,TSF_A4(46)/  0.60584/,TSF_B4(46)/ 76.89868/
     * ,TSF_C (46)/  5.26593/
     * ,TSF_FI(46)/  0.12150/,TSF_FII(46)/  3.93370/
      DATA TSF_ATOM(47)/'AG  '/,TSF_NE(47)/47/,TSF_RAD(47)/1.50/
     * ,TSF_A1(47)/ 19.28082/,TSF_B1(47)/  0.64460/
     * ,TSF_A2(47)/ 16.68852/,TSF_B2(47)/  7.47261/
     * ,TSF_A3(47)/  4.80451/,TSF_B3(47)/ 24.66054/
     * ,TSF_A4(47)/  1.04630/,TSF_B4(47)/ 99.81570/
     * ,TSF_C (47)/  5.17900/
     * ,TSF_FI(47)/  0.13060/,TSF_FII(47)/  4.28200/
      DATA TSF_ATOM(48)/'CD  '/,TSF_NE(48)/48/,TSF_RAD(48)/1.50/
     * ,TSF_A1(48)/ 19.22142/,TSF_B1(48)/  0.59460/
     * ,TSF_A2(48)/ 17.64442/,TSF_B2(48)/  6.90891/
     * ,TSF_A3(48)/  4.46100/,TSF_B3(48)/ 24.70084/
     * ,TSF_A4(48)/  1.60290/,TSF_B4(48)/ 87.48257/
     * ,TSF_C (48)/  5.06941/
     * ,TSF_FI(48)/  0.11850/,TSF_FII(48)/  4.65330/
      DATA TSF_ATOM(49)/'IN  '/,TSF_NE(49)/49/,TSF_RAD(49)/1.50/
     * ,TSF_A1(49)/ 19.16241/,TSF_B1(49)/  0.54760/
     * ,TSF_A2(49)/ 18.55962/,TSF_B2(49)/  6.37761/
     * ,TSF_A3(49)/  4.29480/,TSF_B3(49)/ 25.84993/
     * ,TSF_A4(49)/  2.03960/,TSF_B4(49)/ 92.80299/
     * ,TSF_C (49)/  4.93911/
     * ,TSF_FI(49)/  0.08220/,TSF_FII(49)/  5.04490/
      DATA TSF_ATOM(50)/'SN  '/,TSF_NE(50)/50/,TSF_RAD(50)/1.50/
     * ,TSF_A1(50)/ 19.18892/,TSF_B1(50)/  5.83031/
     * ,TSF_A2(50)/ 19.10052/,TSF_B2(50)/  0.50310/
     * ,TSF_A3(50)/  4.45850/,TSF_B3(50)/ 26.89093/
     * ,TSF_A4(50)/  2.46630/,TSF_B4(50)/ 83.95718/
     * ,TSF_C (50)/  4.78211/
     * ,TSF_FI(50)/  0.02590/,TSF_FII(50)/  5.45910/
      DATA TSF_ATOM(51)/'SB  '/,TSF_NE(51)/51/,TSF_RAD(51)/1.50/
     * ,TSF_A1(51)/ 19.64182/,TSF_B1(51)/  5.30340/
     * ,TSF_A2(51)/ 19.04552/,TSF_B2(51)/  0.46070/
     * ,TSF_A3(51)/  5.03711/,TSF_B3(51)/ 27.90744/
     * ,TSF_A4(51)/  2.68270/,TSF_B4(51)/ 75.28258/
     * ,TSF_C (51)/  4.59091/
     * ,TSF_FI(51)/ -0.05620/,TSF_FII(51)/  5.89460/
      DATA TSF_ATOM(52)/'TE  '/,TSF_NE(52)/52/,TSF_RAD(52)/1.50/
     * ,TSF_A1(52)/ 19.96442/,TSF_B1(52)/  4.81742/
     * ,TSF_A2(52)/ 19.01382/,TSF_B2(52)/  0.42089/
     * ,TSF_A3(52)/  6.14488/,TSF_B3(52)/ 28.52844/
     * ,TSF_A4(52)/  2.52390/,TSF_B4(52)/ 70.84036/
     * ,TSF_C (52)/  4.35200/
     * ,TSF_FI(52)/ -0.17590/,TSF_FII(52)/  6.35310/
      DATA TSF_ATOM(53)/'I   '/,TSF_NE(53)/53/,TSF_RAD(53)/1.50/
     * ,TSF_A1(53)/ 20.14722/,TSF_B1(53)/  4.34700/
     * ,TSF_A2(53)/ 18.99492/,TSF_B2(53)/  0.38140/
     * ,TSF_A3(53)/  7.51381/,TSF_B3(53)/ 27.76604/
     * ,TSF_A4(53)/  2.27350/,TSF_B4(53)/ 66.87767/
     * ,TSF_C (53)/  4.07120/
     * ,TSF_FI(53)/ -0.32570/,TSF_FII(53)/  6.83620/
      DATA TSF_ATOM(54)/'XE  '/,TSF_NE(54)/54/,TSF_RAD(54)/1.50/
     * ,TSF_A1(54)/ 20.29332/,TSF_B1(54)/  3.92820/
     * ,TSF_A2(54)/ 19.02982/,TSF_B2(54)/  0.34400/
     * ,TSF_A3(54)/  8.97671/,TSF_B3(54)/ 26.46594/
     * ,TSF_A4(54)/  1.99000/,TSF_B4(54)/ 64.26587/
     * ,TSF_C (54)/  3.71180/
     * ,TSF_FI(54)/ -0.51790/,TSF_FII(54)/  7.35000/
      DATA TSF_ATOM(55)/'CS  '/,TSF_NE(55)/55/,TSF_RAD(55)/1.50/
     * ,TSF_A1(55)/ 20.38922/,TSF_B1(55)/  3.56900/
     * ,TSF_A2(55)/ 19.10622/,TSF_B2(55)/  0.31070/
     * ,TSF_A3(55)/ 10.66201/,TSF_B3(55)/ 24.38794/
     * ,TSF_A4(55)/  1.49530/,TSF_B4(55)/213.90421/
     * ,TSF_C (55)/  3.33520/
     * ,TSF_FI(55)/ -0.74570/,TSF_FII(55)/  7.90520/
      DATA TSF_ATOM(56)/'BA  '/,TSF_NE(56)/56/,TSF_RAD(56)/1.50/
     * ,TSF_A1(56)/ 20.33612/,TSF_B1(56)/  3.21600/
     * ,TSF_A2(56)/ 19.29703/,TSF_B2(56)/  0.27560/
     * ,TSF_A3(56)/ 10.88801/,TSF_B3(56)/ 20.20732/
     * ,TSF_A4(56)/  2.69590/,TSF_B4(56)/167.20219/
     * ,TSF_C (56)/  2.77310/
     * ,TSF_FI(56)/ -1.04560/,TSF_FII(56)/  8.46170/
      DATA TSF_ATOM(57)/'LA  '/,TSF_NE(57)/57/,TSF_RAD(57)/1.50/
     * ,TSF_A1(57)/ 20.57802/,TSF_B1(57)/  2.94817/
     * ,TSF_A2(57)/ 19.59901/,TSF_B2(57)/  0.24448/
     * ,TSF_A3(57)/ 11.37271/,TSF_B3(57)/ 18.77261/
     * ,TSF_A4(57)/  3.28719/,TSF_B4(57)/133.12410/
     * ,TSF_C (57)/  2.14678/
     * ,TSF_FI(57)/ -1.40940/,TSF_FII(57)/  9.03760/
      DATA TSF_ATOM(58)/'CE  '/,TSF_NE(58)/58/,TSF_RAD(58)/1.50/
     * ,TSF_A1(58)/ 21.16711/,TSF_B1(58)/  2.81219/
     * ,TSF_A2(58)/ 19.76952/,TSF_B2(58)/  0.22684/
     * ,TSF_A3(58)/ 11.85131/,TSF_B3(58)/ 17.60832/
     * ,TSF_A4(58)/  3.33049/,TSF_B4(58)/127.11310/
     * ,TSF_C (58)/  1.86264/
     * ,TSF_FI(58)/ -1.84820/,TSF_FII(58)/  9.65960/
      DATA TSF_ATOM(59)/'PR  '/,TSF_NE(59)/59/,TSF_RAD(59)/1.50/
     * ,TSF_A1(59)/ 22.04402/,TSF_B1(59)/  2.77393/
     * ,TSF_A2(59)/ 19.66972/,TSF_B2(59)/  0.22209/
     * ,TSF_A3(59)/ 12.38561/,TSF_B3(59)/ 16.76692/
     * ,TSF_A4(59)/  2.82428/,TSF_B4(59)/143.64410/
     * ,TSF_C (59)/  2.05830/
     * ,TSF_FI(59)/ -2.41640/,TSF_FII(59)/ 10.28200/
      DATA TSF_ATOM(60)/'ND  '/,TSF_NE(60)/60/,TSF_RAD(60)/1.50/
     * ,TSF_A1(60)/ 22.68452/,TSF_B1(60)/  2.66248/
     * ,TSF_A2(60)/ 19.68472/,TSF_B2(60)/  0.21063/
     * ,TSF_A3(60)/ 12.77401/,TSF_B3(60)/ 15.88502/
     * ,TSF_A4(60)/  2.85137/,TSF_B4(60)/137.90311/
     * ,TSF_C (60)/  1.98486/
     * ,TSF_FI(60)/ -3.18070/,TSF_FII(60)/ 10.90790/
      DATA TSF_ATOM(61)/'PM  '/,TSF_NE(61)/61/,TSF_RAD(61)/1.50/
     * ,TSF_A1(61)/ 23.34052/,TSF_B1(61)/  2.56270/
     * ,TSF_A2(61)/ 19.60953/,TSF_B2(61)/  0.20209/
     * ,TSF_A3(61)/ 13.12351/,TSF_B3(61)/ 15.10091/
     * ,TSF_A4(61)/  2.87516/,TSF_B4(61)/132.72110/
     * ,TSF_C (61)/  2.02876/
     * ,TSF_FI(61)/ -4.05980/,TSF_FII(61)/ 11.55230/
      DATA TSF_ATOM(62)/'SM  '/,TSF_NE(62)/62/,TSF_RAD(62)/1.50/
     * ,TSF_A1(62)/ 24.00424/,TSF_B1(62)/  2.47274/
     * ,TSF_A2(62)/ 19.42583/,TSF_B2(62)/  0.19645/
     * ,TSF_A3(62)/ 13.43961/,TSF_B3(62)/ 14.39961/
     * ,TSF_A4(62)/  2.89604/,TSF_B4(62)/128.00710/
     * ,TSF_C (62)/  2.20963/
     * ,TSF_FI(62)/ -5.32360/,TSF_FII(62)/ 12.21780/
      DATA TSF_ATOM(63)/'EU  '/,TSF_NE(63)/63/,TSF_RAD(63)/1.50/
     * ,TSF_A1(63)/ 24.62744/,TSF_B1(63)/  2.38790/
     * ,TSF_A2(63)/ 19.08862/,TSF_B2(63)/  0.19420/
     * ,TSF_A3(63)/ 13.76031/,TSF_B3(63)/ 13.75461/
     * ,TSF_A4(63)/  2.92270/,TSF_B4(63)/123.17410/
     * ,TSF_C (63)/  2.57450/
     * ,TSF_FI(63)/ -8.92940/,TSF_FII(63)/ 11.18570/
      DATA TSF_ATOM(64)/'GD  '/,TSF_NE(64)/64/,TSF_RAD(64)/1.50/
     * ,TSF_A1(64)/ 25.07094/,TSF_B1(64)/  2.25341/
     * ,TSF_A2(64)/ 19.07982/,TSF_B2(64)/  0.18195/
     * ,TSF_A3(64)/ 13.85181/,TSF_B3(64)/ 12.93311/
     * ,TSF_A4(64)/  3.54545/,TSF_B4(64)/101.39810/
     * ,TSF_C (64)/  2.41960/
     * ,TSF_FI(64)/ -8.83800/,TSF_FII(64)/ 11.91570/
      DATA TSF_ATOM(65)/'TB  '/,TSF_NE(65)/65/,TSF_RAD(65)/1.50/
     * ,TSF_A1(65)/ 25.89763/,TSF_B1(65)/  2.24256/
     * ,TSF_A2(65)/ 18.21852/,TSF_B2(65)/  0.19614/
     * ,TSF_A3(65)/ 14.31671/,TSF_B3(65)/ 12.66481/
     * ,TSF_A4(65)/  2.95354/,TSF_B4(65)/115.36210/
     * ,TSF_C (65)/  3.58324/
     * ,TSF_FI(65)/ -9.14720/,TSF_FII(65)/  9.18910/
      DATA TSF_ATOM(66)/'DY  '/,TSF_NE(66)/66/,TSF_RAD(66)/1.50/
     * ,TSF_A1(66)/ 26.50703/,TSF_B1(66)/  2.18020/
     * ,TSF_A2(66)/ 17.63832/,TSF_B2(66)/  0.20217/
     * ,TSF_A3(66)/ 14.55962/,TSF_B3(66)/ 12.18991/
     * ,TSF_A4(66)/  2.96577/,TSF_B4(66)/111.87410/
     * ,TSF_C (66)/  4.29728/
     * ,TSF_FI(66)/ -9.80460/,TSF_FII(66)/  9.84770/
      DATA TSF_ATOM(67)/'HO  '/,TSF_NE(67)/67/,TSF_RAD(67)/1.50/
     * ,TSF_A1(67)/ 26.90494/,TSF_B1(67)/  2.07051/
     * ,TSF_A2(67)/ 17.29402/,TSF_B2(67)/  0.19794/
     * ,TSF_A3(67)/ 14.55831/,TSF_B3(67)/ 11.44071/
     * ,TSF_A4(67)/  3.63837/,TSF_B4(67)/ 92.65669/
     * ,TSF_C (67)/  4.56797/
     * ,TSF_FI(67)/-14.97340/,TSF_FII(67)/  3.70460/
      DATA TSF_ATOM(68)/'ER  '/,TSF_NE(68)/68/,TSF_RAD(68)/1.50/
     * ,TSF_A1(68)/ 27.65634/,TSF_B1(68)/  2.07356/
     * ,TSF_A2(68)/ 16.42853/,TSF_B2(68)/  0.22355/
     * ,TSF_A3(68)/ 14.97791/,TSF_B3(68)/ 11.36041/
     * ,TSF_A4(68)/  2.98233/,TSF_B4(68)/105.70310/
     * ,TSF_C (68)/  5.92047/
     * ,TSF_FI(68)/ -9.43670/,TSF_FII(68)/  3.93800/
      DATA TSF_ATOM(69)/'TM  '/,TSF_NE(69)/69/,TSF_RAD(69)/1.50/
     * ,TSF_A1(69)/ 28.18193/,TSF_B1(69)/  2.02859/
     * ,TSF_A2(69)/ 15.88512/,TSF_B2(69)/  0.23885/
     * ,TSF_A3(69)/ 15.15421/,TSF_B3(69)/ 10.99751/
     * ,TSF_A4(69)/  2.98706/,TSF_B4(69)/102.96110/
     * ,TSF_C (69)/  6.75622/
     * ,TSF_FI(69)/ -8.03930/,TSF_FII(69)/  4.18210/
      DATA TSF_ATOM(70)/'YB  '/,TSF_NE(70)/70/,TSF_RAD(70)/1.50/
     * ,TSF_A1(70)/ 28.66414/,TSF_B1(70)/  1.98890/
     * ,TSF_A2(70)/ 15.43451/,TSF_B2(70)/  0.25712/
     * ,TSF_A3(70)/ 15.30871/,TSF_B3(70)/ 10.66471/
     * ,TSF_A4(70)/  2.98963/,TSF_B4(70)/100.41710/
     * ,TSF_C (70)/  7.56673/
     * ,TSF_FI(70)/ -7.21080/,TSF_FII(70)/  4.43290/
      DATA TSF_ATOM(71)/'LU  '/,TSF_NE(71)/71/,TSF_RAD(71)/1.50/
     * ,TSF_A1(71)/ 28.94763/,TSF_B1(71)/  1.90182/
     * ,TSF_A2(71)/ 15.22081/,TSF_B2(71)/  9.98520/
     * ,TSF_A3(71)/ 15.10001/,TSF_B3(71)/  0.26103/
     * ,TSF_A4(71)/  3.71601/,TSF_B4(71)/ 84.32988/
     * ,TSF_C (71)/  7.97629/
     * ,TSF_FI(71)/ -6.61790/,TSF_FII(71)/  4.69370/
      DATA TSF_ATOM(72)/'HF  '/,TSF_NE(72)/72/,TSF_RAD(72)/1.50/
     * ,TSF_A1(72)/ 29.14404/,TSF_B1(72)/  1.83262/
     * ,TSF_A2(72)/ 15.17261/,TSF_B2(72)/  9.59991/
     * ,TSF_A3(72)/ 14.75861/,TSF_B3(72)/  0.27512/
     * ,TSF_A4(72)/  4.30013/,TSF_B4(72)/ 72.02908/
     * ,TSF_C (72)/  8.58155/
     * ,TSF_FI(72)/ -6.17940/,TSF_FII(72)/  4.97760/
      DATA TSF_ATOM(73)/'TA  '/,TSF_NE(73)/73/,TSF_RAD(73)/1.50/
     * ,TSF_A1(73)/ 29.20244/,TSF_B1(73)/  1.77333/
     * ,TSF_A2(73)/ 15.22931/,TSF_B2(73)/  9.37047/
     * ,TSF_A3(73)/ 14.51351/,TSF_B3(73)/  0.29598/
     * ,TSF_A4(73)/  4.76492/,TSF_B4(73)/ 63.36447/
     * ,TSF_C (73)/  9.24355/
     * ,TSF_FI(73)/ -5.79590/,TSF_FII(73)/  5.27180/
      DATA TSF_ATOM(74)/'W   '/,TSF_NE(74)/74/,TSF_RAD(74)/1.50/
     * ,TSF_A1(74)/ 29.08183/,TSF_B1(74)/  1.72029/
     * ,TSF_A2(74)/ 15.43001/,TSF_B2(74)/  9.22591/
     * ,TSF_A3(74)/ 14.43271/,TSF_B3(74)/  0.32170/
     * ,TSF_A4(74)/  5.11983/,TSF_B4(74)/ 57.05606/
     * ,TSF_C (74)/  9.88751/
     * ,TSF_FI(74)/ -5.47340/,TSF_FII(74)/  5.57740/
      DATA TSF_ATOM(75)/'RE  '/,TSF_NE(75)/75/,TSF_RAD(75)/1.50/
     * ,TSF_A1(75)/ 28.76213/,TSF_B1(75)/  1.67191/
     * ,TSF_A2(75)/ 15.71892/,TSF_B2(75)/  9.09228/
     * ,TSF_A3(75)/ 14.55641/,TSF_B3(75)/  0.35050/
     * ,TSF_A4(75)/  5.44174/,TSF_B4(75)/ 52.08615/
     * ,TSF_C (75)/ 10.47201/
     * ,TSF_FI(75)/ -5.20830/,TSF_FII(75)/  5.89230/
      DATA TSF_ATOM(76)/'OS  '/,TSF_NE(76)/76/,TSF_RAD(76)/1.50/
     * ,TSF_A1(76)/ 28.18944/,TSF_B1(76)/  1.62903/
     * ,TSF_A2(76)/ 16.15501/,TSF_B2(76)/  8.97949/
     * ,TSF_A3(76)/ 14.93051/,TSF_B3(76)/  0.38266/
     * ,TSF_A4(76)/  5.67590/,TSF_B4(76)/ 48.16475/
     * ,TSF_C (76)/ 11.00051/
     * ,TSF_FI(76)/ -4.98010/,TSF_FII(76)/  6.22160/
      DATA TSF_ATOM(77)/'IR  '/,TSF_NE(77)/77/,TSF_RAD(77)/1.50/
     * ,TSF_A1(77)/ 27.30493/,TSF_B1(77)/  1.59279/
     * ,TSF_A2(77)/ 16.72961/,TSF_B2(77)/  8.86554/
     * ,TSF_A3(77)/ 15.61152/,TSF_B3(77)/  0.41792/
     * ,TSF_A4(77)/  5.83378/,TSF_B4(77)/ 45.00114/
     * ,TSF_C (77)/ 11.47221/
     * ,TSF_FI(77)/ -4.77100/,TSF_FII(77)/  6.56670/
      DATA TSF_ATOM(78)/'PT  '/,TSF_NE(78)/78/,TSF_RAD(78)/1.50/
     * ,TSF_A1(78)/ 27.00594/,TSF_B1(78)/  1.51293/
     * ,TSF_A2(78)/ 17.76392/,TSF_B2(78)/  8.81175/
     * ,TSF_A3(78)/ 15.71312/,TSF_B3(78)/  0.42459/
     * ,TSF_A4(78)/  5.78371/,TSF_B4(78)/ 38.61034/
     * ,TSF_C (78)/ 11.68831/
     * ,TSF_FI(78)/ -4.59320/,TSF_FII(78)/  6.92640/
      DATA TSF_ATOM(79)/'AU  '/,TSF_NE(79)/79/,TSF_RAD(79)/1.50/
     * ,TSF_A1(79)/ 16.88193/,TSF_B1(79)/  0.46110/
     * ,TSF_A2(79)/ 18.59132/,TSF_B2(79)/  8.62161/
     * ,TSF_A3(79)/ 25.55824/,TSF_B3(79)/  1.48260/
     * ,TSF_A4(79)/  5.86001/,TSF_B4(79)/ 36.39563/
     * ,TSF_C (79)/ 12.06581/
     * ,TSF_FI(79)/ -4.41970/,TSF_FII(79)/  7.29800/
      DATA TSF_ATOM(80)/'HG  '/,TSF_NE(80)/80/,TSF_RAD(80)/1.50/
     * ,TSF_A1(80)/ 20.68092/,TSF_B1(80)/  0.54500/
     * ,TSF_A2(80)/ 19.04172/,TSF_B2(80)/  8.44841/
     * ,TSF_A3(80)/ 21.65752/,TSF_B3(80)/  1.57290/
     * ,TSF_A4(80)/  5.96761/,TSF_B4(80)/ 38.32463/
     * ,TSF_C (80)/ 12.60891/
     * ,TSF_FI(80)/ -4.29230/,TSF_FII(80)/  7.68490/
      DATA TSF_ATOM(81)/'TL  '/,TSF_NE(81)/81/,TSF_RAD(81)/1.50/
     * ,TSF_A1(81)/ 27.54463/,TSF_B1(81)/  0.65515/
     * ,TSF_A2(81)/ 19.15842/,TSF_B2(81)/  8.70752/
     * ,TSF_A3(81)/ 15.53802/,TSF_B3(81)/  1.96347/
     * ,TSF_A4(81)/  5.52594/,TSF_B4(81)/ 45.81496/
     * ,TSF_C (81)/ 13.17461/
     * ,TSF_FI(81)/ -4.16270/,TSF_FII(81)/  8.09000/
      DATA TSF_ATOM(82)/'PB  '/,TSF_NE(82)/82/,TSF_RAD(82)/1.50/
     * ,TSF_A1(82)/ 31.06174/,TSF_B1(82)/  0.69020/
     * ,TSF_A2(82)/ 13.06371/,TSF_B2(82)/  2.35760/
     * ,TSF_A3(82)/ 18.44202/,TSF_B3(82)/  8.61801/
     * ,TSF_A4(82)/  5.96961/,TSF_B4(82)/ 47.25795/
     * ,TSF_C (82)/ 13.41181/
     * ,TSF_FI(82)/ -4.07530/,TSF_FII(82)/  8.50600/
      DATA TSF_ATOM(83)/'BI  '/,TSF_NE(83)/83/,TSF_RAD(83)/1.50/
     * ,TSF_A1(83)/ 33.36894/,TSF_B1(83)/  0.70400/
     * ,TSF_A2(83)/ 12.95101/,TSF_B2(83)/  2.92380/
     * ,TSF_A3(83)/ 16.58772/,TSF_B3(83)/  8.79371/
     * ,TSF_A4(83)/  6.46921/,TSF_B4(83)/ 48.00935/
     * ,TSF_C (83)/ 13.57821/
     * ,TSF_FI(83)/ -4.01110/,TSF_FII(83)/  8.93100/
      DATA TSF_ATOM(84)/'PO  '/,TSF_NE(84)/84/,TSF_RAD(84)/1.50/
     * ,TSF_A1(84)/ 34.67264/,TSF_B1(84)/  0.70100/
     * ,TSF_A2(84)/ 15.47331/,TSF_B2(84)/  3.55078/
     * ,TSF_A3(84)/ 13.11381/,TSF_B3(84)/  9.55643/
     * ,TSF_A4(84)/  7.02589/,TSF_B4(84)/ 47.00455/
     * ,TSF_C (84)/ 13.67701/
     * ,TSF_FI(84)/ -3.96700/,TSF_FII(84)/  9.38340/
      DATA TSF_ATOM(85)/'AT  '/,TSF_NE(85)/85/,TSF_RAD(85)/1.50/
     * ,TSF_A1(85)/ 35.31633/,TSF_B1(85)/  0.68587/
     * ,TSF_A2(85)/ 19.02112/,TSF_B2(85)/  3.97458/
     * ,TSF_A3(85)/  9.49888/,TSF_B3(85)/ 11.38241/
     * ,TSF_A4(85)/  7.42519/,TSF_B4(85)/ 45.47156/
     * ,TSF_C (85)/ 13.71081/
     * ,TSF_FI(85)/ -3.95880/,TSF_FII(85)/  9.84330/
      DATA TSF_ATOM(86)/'RN  '/,TSF_NE(86)/86/,TSF_RAD(86)/1.50/
     * ,TSF_A1(86)/ 35.56314/,TSF_B1(86)/  0.66310/
     * ,TSF_A2(86)/ 21.28162/,TSF_B2(86)/  4.06910/
     * ,TSF_A3(86)/  8.00371/,TSF_B3(86)/ 14.04221/
     * ,TSF_A4(86)/  7.44331/,TSF_B4(86)/ 44.24734/
     * ,TSF_C (86)/ 13.69051/
     * ,TSF_FI(86)/ -3.94870/,TSF_FII(86)/ 10.31810/
      DATA TSF_ATOM(87)/'FR  '/,TSF_NE(87)/87/,TSF_RAD(87)/1.50/
     * ,TSF_A1(87)/ 35.92993/,TSF_B1(87)/  0.64645/
     * ,TSF_A2(87)/ 23.05472/,TSF_B2(87)/  4.17619/
     * ,TSF_A3(87)/ 12.14391/,TSF_B3(87)/ 23.10522/
     * ,TSF_A4(87)/  2.11253/,TSF_B4(87)/150.64510/
     * ,TSF_C (87)/ 13.72471/
     * ,TSF_FI(87)/ -3.96890/,TSF_FII(87)/ 10.80380/
      DATA TSF_ATOM(88)/'RA  '/,TSF_NE(88)/88/,TSF_RAD(88)/1.50/
     * ,TSF_A1(88)/ 35.76303/,TSF_B1(88)/  0.61634/
     * ,TSF_A2(88)/ 22.90642/,TSF_B2(88)/  3.87135/
     * ,TSF_A3(88)/ 12.47391/,TSF_B3(88)/ 19.98872/
     * ,TSF_A4(88)/  3.21097/,TSF_B4(88)/142.32510/
     * ,TSF_C (88)/ 13.62111/
     * ,TSF_FI(88)/ -4.00880/,TSF_FII(88)/ 11.29690/
      DATA TSF_ATOM(89)/'AC  '/,TSF_NE(89)/89/,TSF_RAD(89)/1.50/
     * ,TSF_A1(89)/ 35.65973/,TSF_B1(89)/  0.58909/
     * ,TSF_A2(89)/ 23.10323/,TSF_B2(89)/  3.65155/
     * ,TSF_A3(89)/ 12.59771/,TSF_B3(89)/ 18.59901/
     * ,TSF_A4(89)/  4.08655/,TSF_B4(89)/117.02010/
     * ,TSF_C (89)/ 13.52661/
     * ,TSF_FI(89)/ -4.07940/,TSF_FII(89)/ 11.79940/
      DATA TSF_ATOM(90)/'TH  '/,TSF_NE(90)/90/,TSF_RAD(90)/1.50/
     * ,TSF_A1(90)/ 35.56453/,TSF_B1(90)/  0.56336/
     * ,TSF_A2(90)/ 23.42192/,TSF_B2(90)/  3.46204/
     * ,TSF_A3(90)/ 12.74731/,TSF_B3(90)/ 17.83092/
     * ,TSF_A4(90)/  4.80704/,TSF_B4(90)/ 99.17230/
     * ,TSF_C (90)/ 13.43141/
     * ,TSF_FI(90)/ -4.14910/,TSF_FII(90)/ 12.32960/
      DATA TSF_ATOM(91)/'PA  '/,TSF_NE(91)/91/,TSF_RAD(91)/1.50/
     * ,TSF_A1(91)/ 35.88474/,TSF_B1(91)/  0.54775/
     * ,TSF_A2(91)/ 23.29482/,TSF_B2(91)/  3.41519/
     * ,TSF_A3(91)/ 14.18911/,TSF_B3(91)/ 16.92352/
     * ,TSF_A4(91)/  4.17287/,TSF_B4(91)/105.25110/
     * ,TSF_C (91)/ 13.42871/
     * ,TSF_FI(91)/ -4.24730/,TSF_FII(91)/ 12.86810/
      DATA TSF_ATOM(92)/'U   '/,TSF_NE(92)/92/,TSF_RAD(92)/1.50/
     * ,TSF_A1(92)/ 36.02284/,TSF_B1(92)/  0.52930/
     * ,TSF_A2(92)/ 23.41283/,TSF_B2(92)/  3.32530/
     * ,TSF_A3(92)/ 14.94911/,TSF_B3(92)/ 16.09273/
     * ,TSF_A4(92)/  4.18800/,TSF_B4(92)/100.61310/
     * ,TSF_C (92)/ 13.39661/
     * ,TSF_FI(92)/ -4.36380/,TSF_FII(92)/ 13.40900/
      DATA TSF_ATOM(93)/'NP  '/,TSF_NE(93)/93/,TSF_RAD(93)/1.50/
     * ,TSF_A1(93)/ 36.18744/,TSF_B1(93)/  0.51193/
     * ,TSF_A2(93)/ 23.59642/,TSF_B2(93)/  3.25396/
     * ,TSF_A3(93)/ 15.64022/,TSF_B3(93)/ 15.36222/
     * ,TSF_A4(93)/  4.18550/,TSF_B4(93)/ 97.49089/
     * ,TSF_C (93)/ 13.35731/
     * ,TSF_FI(93)/ -4.50530/,TSF_FII(93)/ 13.96660/
      DATA TSF_ATOM(94)/'PU  '/,TSF_NE(94)/94/,TSF_RAD(94)/1.50/
     * ,TSF_A1(94)/ 36.52544/,TSF_B1(94)/  0.49938/
     * ,TSF_A2(94)/ 23.80832/,TSF_B2(94)/  3.26371/
     * ,TSF_A3(94)/ 16.77072/,TSF_B3(94)/ 14.94551/
     * ,TSF_A4(94)/  3.47947/,TSF_B4(94)/105.98010/
     * ,TSF_C (94)/ 13.38121/
     * ,TSF_FI(94)/ -4.65630/,TSF_FII(94)/ 14.37290/
C -----------------------------------------------------
      IERR=0
      DO I=1,TSF_N
        IF(ASYMB(1:2).EQ.TSF_ATOM(I)(1:2)) GO TO 100
      ENDDO
      IERR=1
      I = 7
  100 CONTINUE
      N   = I
      NEL = TSF_NE (I)
      A1  = TSF_A1 (I)
      A2  = TSF_A2 (I)
      A3  = TSF_A3 (I)
      A4  = TSF_A4 (I)
      B1  = TSF_B1 (I)
      B2  = TSF_B2 (I)
      B3  = TSF_B3 (I)
      B4  = TSF_B4 (I)
      C   = TSF_C  (I)
      FI  = TSF_FI (I)
      FII = TSF_FII(I)
      RAD = TSF_RAD(I)
      RETURN
      END

c      FUNCTION AATAN2(A,B)
c      REAL A,B,C,T,PIBY2
C --------------------------------------
calpha  IF(ABS(B).GT.0.0000001) THEN
c          AATAN2=ATAN2(A,B)
calpha  ELSE
calpha    IF(ABS(A).GT.0.00001) THEN
calpha      PIBY2=2.0*ATAN(1.0)
calpha      C=PIBY2
calpha      IF(A.LT.0.0) C=-C
calpha      AATAN2=C
calpha    ELSE
calpha      C=0.0
calpha      T=A*B
calpha      IF(T.LT.0.0) THEN
calpha        C= PIBY2*2.0
calpha      ENDIF         
calpha      AATAN2=C
calpha    ENDIF
calpha  ENDIF
c      RETURN
c      END

      FUNCTION AATAN2(A,B)
      REAL A,B,C,T,PIBY2
C --------------------------------------
        IF(ABS(B).GT.0.0000001) THEN
          AATAN2 = ATAN2(A,B)
        ELSE
          PIBY2 = 2.0*ATAN(1.0)
          IF(ABS(A).GT.0.00001) THEN
            C     = PIBY2
            IF(A.LT.0.0) C = -C
            AATAN2 = C
          ELSE
            C = 0.0
            T = A*B
            IF(T.LT.0.0) THEN
              C = PIBY2*2.0
            ENDIF         
            AATAN2 = C
          ENDIF
        ENDIF
      RETURN
      END

c      FUNCTION SNGL_MR(A)
c      REAL     A(1)
C --------------------------------------
c      SNGL_MR = A(1)
c      RETURN
c      END

C ==========================================================
C ============================================================
C --- BLGRAPH ---
C
      SUBROUTINE MOVTXX(IX,IY)
      COMMON /COMORG/ ITYPE,SLEN,IXORG,IYORG
C -----------------------------------------
      IXORG = IX
      IYORG = IY
      SLEN  = 0.0
      CALL MOVTX(IX,IY)
      RETURN
      END

      SUBROUTINE VECTXX(IX,IY)
      COMMON /COMORG/ ITYPE,SLEN,IXORG,IYORG
CN    DATA DLEN/ 7.0 /
CVX   DATA DLEN/ 7.0 /
CMS   DATA DLEN/ 1.0 /
      DATA DLEN/ 2.0 /
C -------------------------------------------
      IF(ITYPE.EQ.0) THEN
        CALL VECTX(IX,IY)
      ELSE
        IXC = IX
        IYC = IY
        ALLL = FLOAT(IXORG-IX)*FLOAT(IXORG-IX)+
     *         FLOAT(IYORG-IY)*FLOAT(IYORG-IY)
        ALLL = SQRT(ABS(ALLL))
        IF(ALLL.GT.0.) THEN     
          STOT = SLEN+ALLL
          N2   = STOT/DLEN
          AN2  = STOT-N2*DLEN
          IF(AN2.GT.0.0) THEN
            N2 = N2+1
          ELSE
            AN2 = DLEN
          ENDIF
          N1  = SLEN/DLEN
          AN1 = SLEN-N1*DLEN
          N1  = N1+1
          IF(N1.EQ.N2) AN2=AN2-AN1
          COSA = (IX-IXORG)/ALLL
          SINA = (IY-IYORG)/ALLL
          IF(N2.GE.N1) THEN
            DO      I=N1,N2
              IF(I.EQ.N1.AND.I.NE.N2) THEN
                D  = DLEN-AN1
                SX = D*COSA
                SY = D*SINA
              ELSE IF(I.EQ.N2) THEN
                D  = AN2
                SX = D*COSA
                SY = D*SINA
              ELSE
                SX = DLEN*COSA
                SY = DLEN*SINA
              ENDIF
              IX    = IXORG+SX
              IY    = IYORG+SY
              IXORG = IX
              IYORG = IY
              IF(MOD(I,2).EQ.1) THEN
                CALL VECTX(IX,IY)
              ELSE
                CALL MOVTX(IX,IY)
              ENDIF
            ENDDO
          ENDIF
          SLEN = STOT
        ENDIF

        CALL MOVTX(IXC,IYC)
         
      ENDIF
      RETURN
      END


      SUBROUTINE SET_BOX_TX(IBX,IBY,ISHXI,ISHYI)
C ---
      COMMON /TX_BOX/ IBOXX,IBOXY,ISHX,ISHY
      INTEGER IBOXX,IBOXY,ISHX,ISHY
C ----
      COMMON/TX_ORIG/  IXO,IYO,IX0,IY0
C ----
      COMMON /TX_SLCT/   IPAGE
      INTEGER            IPAGE
C
      COMMON /PS_BOX/ BBOXX1,BBOXX2,BBOXY1,BBOXY2
      INTEGER  BBOXX1,BBOXX2,BBOXY1,BBOXY2
C -------------------------------
C     ISHX >= BOXY1
C     IBOXX + ISHX =< BOXY2
C     ISHY >= BOXY1
C     IBOXY + ISHY =< BOXX2
C

      LIM_XMIN = BBOXY1
      LIM_XMAX = BBOXY2
      LIM_YMIN = BBOXX1
      LIM_YMAX = BBOXX2

      ISHX  = ISHXI
      ISHY  = ISHYI
      ITX   = LIM_XMAX-LIM_XMIN
      IF(ISHX.GT.ITX) ISHX=ITX
      ITY = LIM_YMAX-LIM_YMIN
      IF(ISHY.GT.ITY) ISHY = ITY
      IF(ISHX.LT.0)   ISHX = 0
      IF(ISHY.LT.0)   ISHY = 0
      IBOXX    = IBX
      IBOXY    = IBY
      IF((IBOXX+ISHX).GT.ITX) IBOXX = ITX-ISHX
      IF((IBOXY+ISHY).GT.ITY) IBOXY = ITY-ISHY
      IF((IBOXX).LT.0) IBOXX = 0
      IF((IBOXY).LT.0) IBOXY = 0

      RETURN
      END

      SUBROUTINE GET_BOX_TX(IBX,IBY,ISHX_PS,ISHY_PS,IX0_PS,IY0_PS
     *   ,LIM_XMIN,LIM_XMAX,LIM_YMIN,LIM_YMAX)
C ---
      COMMON /TX_BOX/ IBOXX,IBOXY,ISHX,ISHY
      INTEGER IBOXX,IBOXY,ISHX,ISHY
C ----
      COMMON/TX_ORIG/  IXO,IYO,IX0,IY0
C ----
      COMMON /TX_SLCT/   IPAGE
      INTEGER            IPAGE
C
      COMMON /PS_BOX/ BBOXX1,BBOXX2,BBOXY1,BBOXY2
      INTEGER  BBOXX1,BBOXX2,BBOXY1,BBOXY2
C -------------------------------

C      BBOXX1 =  30
C      BBOXX2 = 550
C      BBOXY1 =  50
C      BBOXY2 = 780

      LIM_XMIN = BBOXY1
      LIM_XMAX = BBOXY2
      LIM_YMIN = BBOXX1
      LIM_YMAX = BBOXX2


      IBX      = IBOXX
      IBY      = IBOXY
      ISHX_PS  = ISHX
      ISHY_PS  = ISHY
      IX0_PS   = IX0
      IY0_PS   = IY0

C     ISHX >= BOXY1
C     IBOXX + ISHX =< BOXY2
C     ISHY >= BOXY1
C     IBOXY + ISHY =< BOXX2
C
      RETURN
      END

      SUBROUTINE OPENTX(NAME,NPAGE,IERR)
C ----
      COMMON /TX_BOX/ IBOXX,IBOXY,ISHX,ISHY
      INTEGER IBOXX,IBOXY,ISHX,ISHY
C ----
      COMMON /COM_PS/ IOPEN
      INTEGER         IOPEN
C --------------------------------                 
      CHARACTER       NAME*(*)
C ---------------------------------------------------
      PARAMETER ( MXCOLR = 19 )
      CHARACTER*12 COLNAM(MXCOLR)
      REAL         RGB(3,MXCOLR)
      INTEGER      NPAGE,IPLOT
      INTEGER      PLTYPE, COLPLT(3,13)
      CHARACTER    FILPS*256
C ----------------
      COMMON /PS_BOX/ BBOXX1,BBOXX2,BBOXY1,BBOXY2
      INTEGER  BBOXX1,BBOXX2,BBOXY1,BBOXY2
C ---------------------------------------
      LOGICAL        INCOL
      INTEGER        BAKCOL
      INTEGER   IERR
      CHARACTER LINE*80
C -------------------------------
      IERR =  0
      M    = 99
      MDOC = 0
      
      CALL INIT_TX_PAR(RGB,COLNAM)

      CALL PSSETPG(NPAGE)

      FILPS = NAME

      CALL LENSTR_BL(FILPS,LN)
      IF(LN.LE.0.OR.FILPS(1:1).EQ.' '.OR.FILPS(1:1).EQ.',') THEN
        WRITE(LINE,*) ' ERROR: wrong name of ps_file'  
        CALL MSGERR(MDOC,LINE)
        IERR=1
        GO TO 100
      ENDIF

      LNN = LN
      IF(LNN.GT.68 ) LNN = 68 
      WRITE(LINE,'(''* Plotfile: '',A)') FILPS(1:LNN)
      CALL MSGDOC(MDOC,LINE)

      IPLOT = 0
      INCOL  = .FALSE.
      BAKCOL = 1

C  --- Open and Initialize the PostScript file
      CALL PSOPEN (FILPS,BBOXX1,BBOXX2,BBOXY1,BBOXY2,MXCOLR,
     +     RGB,INCOL,BAKCOL,IERR)
      IF(IERR.NE.0) GO TO 100
      IOPEN=1
 100  CONTINUE
      RETURN
      END
 
      SUBROUTINE NEWPEN(IPEN)
      COMMON /TX_SLCT/ IPAGE
      INTEGER   IPAGE
      INTEGER IPEN
      REAL    WPEN(10)
      DATA    WPEN/0.10,0.20,0.40,0.60,0.80,1.00,1.25,1.50,2.00,2.00/
C                    1    2    3    4    5    6    7    8    9    10
C --------------------------------------------------
      IF(IPEN.LE. 0) IPEN=1
      IF(IPEN.GT.10) IPEN=10

      WIDTH = WPEN(IPEN)
      CALL PSLWID(WIDTH)
      RETURN
      END
 
      SUBROUTINE PNTTX(IX,IY)
      CALL MOVTX(IX,IY)
      CALL VECTX(IX,IY)
      END
 
      SUBROUTINE MOVTX(IX,IY)
C ---
      COMMON/TX_ORIG/ IXO,IYO,IX0,IY0
C -----------------------------------------

      IXO=IX
      IYO=IY

      RETURN
      END
 
      SUBROUTINE VECTX(IX,IY)
C ---
      COMMON /TX_BOX/ IBOXX,IBOXY,ISHX,ISHY
      INTEGER         IBOXX,IBOXY,ISHX,ISHY
C ----
      COMMON/TX_ORIG/  IXO,IYO,IX0,IY0
C ----
      COMMON /TX_SLCT/ IPAGE
      INTEGER          IPAGE
C ----------------
      COMMON /PS_BOX/ BBOXX1,BBOXX2,BBOXY1,BBOXY2
      INTEGER         BBOXX1,BBOXX2,BBOXY1,BBOXY2
C ---------------------------------------
      CALL MOVTX(IXO,IYO)

      IXT=IX+IX0
      IYT=IY+IY0

      IF(IXT.LT.0) IXT=0
      IF(IYT.LT.0) IYT=0
      IF(IXT.GT.IBOXX) IXT=IBOXX
      IF(IYT.GT.IBOXY) IYT=IBOXY

      IXT=IXT+ISHX
      IYT=IYT+ISHY

      IXTT=IYT+BBOXX1
      IYTT=BBOXY2-IXT

      IF(IXTT.LT.BBOXX1) IXTT=BBOXX1
      IF(IYTT.LT.BBOXY1) IYTT=BBOXY1
      IF(IXTT.GT.BBOXX2) IXTT=BBOXX2
      IF(IYTT.GT.BBOXY2) IYTT=BBOXY2

      X2=IXTT
      Y2=IYTT

      IXT=IXO+IX0
      IYT=IYO+IY0
 
      IF(IXT.LT.0) IXT=0
      IF(IYT.LT.0) IYT=0
      IF(IXT.GT.IBOXX) IXT=IBOXX
      IF(IYT.GT.IBOXY) IYT=IBOXY

      IXT=IXT+ISHX
      IYT=IYT+ISHY

      IXTT=IYT+BBOXX1
      IYTT=BBOXY2-IXT

      IF(IXTT.LT.BBOXX1) IXTT=BBOXX1
      IF(IYTT.LT.BBOXY1) IYTT=BBOXY1
      IF(IXTT.GT.BBOXX2) IXTT=BBOXX2
      IF(IYTT.GT.BBOXY2) IYTT=BBOXY2

      X1=IXTT
      Y1=IYTT

      IF(ABS(X1).GT.999.0) X1=0.0
      IF(ABS(X2).GT.999.0) X2=0.0
      IF(ABS(Y1).GT.999.0) Y1=0.0
      IF(ABS(Y2).GT.999.0) Y2=0.0

      CALL PSLINE (X1, Y1, X2, Y2)

      IXO=IX
      IYO=IY 
 
      RETURN
C ---------------
      ENTRY  ORITX(IX,IY)
      IX0=IX
      IY0=IY
      RETURN
      END

      SUBROUTINE ENDTX
C ------------------------------------
      COMMON /COM_PS/ IOPEN
      INTEGER         IOPEN
C ------------------------------------
C ----------------
      COMMON /PS_BOX/ BBOXX1,BBOXX2,BBOXY1,BBOXY2
      INTEGER  BBOXX1,BBOXX2,BBOXY1,BBOXY2
C ---------------------------------------

C  --- Write out end of PostScript file
      CALL PSCLOS(BBOXX1,BBOXX2,BBOXY1,BBOXY2)

      IOPEN=0
      RETURN
      END

      SUBROUTINE TXSYMB (SYM,ISIZEX,IX,IY,IMOD)
C -----------------------------------------
      CHARACTER SYM *(*)
C ---- IMOD = 1 absolute coord. system
C --------------------------
      CALL GET_BOX_TX(IBX,IBY,ISHX,ISHY,IX0_PS,IY0_PS
     *   ,LIM_XMIN,LIM_XMAX,LIM_YMIN,LIM_YMAX)

      IF(IMOD.LE.0) THEN

        IXT=IX+IX0_PS
        IYT=IY+IY0_PS

        IF(IXT.LT.0) IXT=0
        IF(IYT.LT.0) IYT=0
        IF(IXT.GT.IBX) IXT=IBX
        IF(IYT.GT.IBY) IYT=IBY

        IXT=IXT+ISHX
        IYT=IYT+ISHY


C      LIM_XMIN=BBOXY1
C      LIM_XMAX=BBOXY2
C      LIM_YMIN=BBOXX1
C      LIM_YMAX=BBOXX2
C        IXTT=IYT+BBOXX1
C        IYTT=BBOXY2-IXT
C      IF(IXTT.LT.BBOXX1) IXTT=BBOXX1
C      IF(IYTT.LT.BBOXY1) IYTT=BBOXY1
C      IF(IXTT.GT.BBOXX2) IXTT=BBOXX2
C      IF(IYTT.GT.BBOXY2) IYTT=BBOXY2

        IXTT=IYT+LIM_YMIN
        IYTT=LIM_XMAX-IXT

        IF(IXTT.LT.LIM_YMIN) IXTT=LIM_YMIN
        IF(IYTT.LT.LIM_XMIN) IYTT=LIM_XMIN
        IF(IXTT.GT.LIM_YMAX) IXTT=LIM_YMAX
        IF(IYTT.GT.LIM_XMAX) IYTT=LIM_XMAX

        XL=IXTT
        YL=IYTT

      ELSE
C
C       LIM_XMIN=BBOXY1 50
C       LIM_XMAX=BBOXY2 780

C       LIM_YMIN=BBOXX1 30
C       LIM_YMAX=BBOXX2 550
C       IBX = 650
C       IBY = 500
C       ISHX_PS  = 80
C       ISHY_PS  = 50
C
        IXTT=IX
        IYTT=IY

        IXT=IYTT+LIM_YMIN
        IYT=LIM_XMAX-IXTT

        IF(IXT.LT.LIM_YMIN) IXT=LIM_YMIN
        IF(IYT.LT.LIM_XMIN) IYT=LIM_XMIN
        IF(IXT.GT.LIM_YMAX) IXT=LIM_YMAX
        IF(IYT.GT.LIM_XMAX) IYT=LIM_XMAX

        XL=IXT
        YL=IYT

      ENDIF

      SIZE=ISIZEX
      CALL PSTEXT(XL,YL,SIZE,SYM)
      RETURN
      END

      SUBROUTINE TXTEXT(SYM,ISIZEX,IX,IY,IMOD)
C -----------------------------------------
      CHARACTER SYM *(*)
C ---- IMOD = 1 absolute coord. system
C --------------------------
      CALL GET_BOX_TX(IBX,IBY,ISHX,ISHY,IX0_PS,IY0_PS
     *   ,LIM_XMIN,LIM_XMAX,LIM_YMIN,LIM_YMAX)

      IF(IMOD.LE.0) THEN

        IXT=IX+IX0_PS
        IYT=IY+IY0_PS

        IF(IXT.LT.0) IXT=0
        IF(IYT.LT.0) IYT=0
        IF(IXT.GT.IBX) IXT=IBX
        IF(IYT.GT.IBY) IYT=IBY

        IXT=IXT+ISHX
        IYT=IYT+ISHY


C      LIM_XMIN=BBOXY1
C      LIM_XMAX=BBOXY2
C      LIM_YMIN=BBOXX1
C      LIM_YMAX=BBOXX2
C        IXTT=IYT+BBOXX1
C        IYTT=BBOXY2-IXT
C      IF(IXTT.LT.BBOXX1) IXTT=BBOXX1
C      IF(IYTT.LT.BBOXY1) IYTT=BBOXY1
C      IF(IXTT.GT.BBOXX2) IXTT=BBOXX2
C      IF(IYTT.GT.BBOXY2) IYTT=BBOXY2

        IXTT=IYT+LIM_YMIN
        IYTT=LIM_XMAX-IXT

        IF(IXTT.LT.LIM_YMIN) IXTT=LIM_YMIN
        IF(IYTT.LT.LIM_XMIN) IYTT=LIM_XMIN
        IF(IXTT.GT.LIM_YMAX) IXTT=LIM_YMAX
        IF(IYTT.GT.LIM_XMAX) IYTT=LIM_XMAX

        XL=IXTT
        YL=IYTT

      ELSE
C
C       LIM_XMIN=BBOXY1 50
C       LIM_XMAX=BBOXY2 780

C       LIM_YMIN=BBOXX1 30
C       LIM_YMAX=BBOXX2 550
C       IBX = 650
C       IBY = 500
C       ISHX_PS  = 80
C       ISHY_PS  = 50
C
        IXTT=IX
        IYTT=IY

        IXT=IYTT+LIM_YMIN
        IYT=LIM_XMAX-IXTT

        IF(IXT.LT.LIM_YMIN) IXT=LIM_YMIN
        IF(IYT.LT.LIM_XMIN) IYT=LIM_XMIN
        IF(IXT.GT.LIM_YMAX) IXT=LIM_YMAX
        IF(IYT.GT.LIM_XMAX) IYT=LIM_XMAX

        XL=IXT
        YL=IYT

      ENDIF

      SIZE=ISIZEX
      CALL PSPRINT(XL,YL,SIZE,SYM)
      RETURN
      END

      SUBROUTINE PSPRINT(X,Y,SIZE,TEXT)
C ---------------------------------------
      COMMON /PS_BOX/ BBOXX1,BBOXX2,BBOXY1,BBOXY2
      INTEGER  BBOXX1,BBOXX2,BBOXY1,BBOXY2
      COMMON /ISPS/ TOTPAG, CURPAG, IUNIT_PS
      INTEGER TOTPAG, CURPAG

C ---------------------------------------
      CHARACTER TEXT*(*)
      CHARACTER CH*1,FLAGB*1,SYMB*1,STR*80
      REAL          SIZE,X,Y,XX,YY
      INTEGER       N,LEN,I
C --------------------------------------------
      COEF  = 0.72
      YY    = Y-SIZE/4.0
      XX    = X
      FLAGB = 'N'
      STR   = ' '
      N     = 0
      CALL LENSTR_BL(TEXT,LEN)
      IF(LEN.LE.0) RETURN
      IF(LEN.GT.78) LEN=78
      LEN=LEN+1

      DO I=1,LEN
        IF(I.LT.LEN) THEN
          CH=TEXT(I:I)
          CALL CHKSMB(CH,SYMB)
          IF(SYMB.EQ.'?') CH='^'
          IF(CH.EQ.'(') CH='{'
          IF(CH.EQ.')') CH='}'
        ELSE
          CH=' '
        ENDIF
        IF(CH.EQ.' '.AND.FLAGB.EQ.'N') THEN
          IF(XX.GT.BBOXX2) XX=BBOXX2          
          WRITE(IUNIT_PS,'(2F7.2,'' moveto'')') XX,YY
          IF(N.GT.0) THEN
            WRITE(IUNIT_PS,'(''('',A,'')'')') STR(1:N)
            SZ=SIZE
            IF(SZ.LT.0.5.OR.SZ.GT.99.9) SZ=1.0
            WRITE(IUNIT_PS,'(F4.1,'' Print'')') SZ
            XX=XX+SIZE*N*COEF
            N=0
          ENDIF
        ENDIF
        IF(CH.NE.' ') THEN
          N=N+1        
          STR(N:N)=CH
          FLAGB='N'  
        ELSE
          FLAGB='Y'  
          XX=XX+SIZE*COEF
        ENDIF
      ENDDO
      RETURN
      END

      SUBROUTINE PSPRINTS(X,Y,SIZE,TEXT)
C ---------------------------------------
      COMMON /PS_BOX/ BBOXX1,BBOXX2,BBOXY1,BBOXY2
      INTEGER  BBOXX1,BBOXX2,BBOXY1,BBOXY2
      COMMON /ISPS/ TOTPAG, CURPAG, IUNIT_PS
      INTEGER TOTPAG, CURPAG
C ---------------------------------------
      CHARACTER TEXT*(*)
      CHARACTER CH*1,FLAGB*1,SYMB*1,STR*80
      REAL          SIZE,X,Y,XX,YY
      INTEGER       N,LEN,I
C --------------------------------------------
      COEF  = 0.72
      YY    = Y-SIZE/4.0
      XX    = X
      FLAGB = 'N'
      STR   = ' '
      N     = 0
      CALL LENSTR_BL(TEXT,LEN)
      IF(LEN.LE.0) RETURN
      IF(LEN.GT.78) LEN=78
      LEN=LEN+1

      DO I=1,LEN
        IF(I.LT.LEN) THEN
          CH=TEXT(I:I)
          CALL CHKSMB(CH,SYMB)
          IF(SYMB.EQ.'?') CH='^'
          IF(CH.EQ.'(') CH='{'
          IF(CH.EQ.')') CH='}'
        ELSE
          CH=' '
        ENDIF
        IF(CH.EQ.' '.AND.FLAGB.EQ.'N') THEN
          IF(XX.GT.BBOXX2) XX=BBOXX2          
          WRITE(IUNIT_PS,'(2F7.2,'' moveto'')') XX,YY
          IF(N.GT.0) THEN
C            WRITE(51,'(''('',A,'')'')') STR(1:N)
C            WRITE(51,'(F4.1,'' Print'')') SIZE
C            XX=XX+SIZE*N*COEF
            XXX=XX
            DO J=1,N
              WRITE(IUNIT_PS,'(''('',A,'')'')') STR(J:J)
              IF(SIZE.LT.0.5.OR.SIZE.GT.99.9) SIZE=1.0
              WRITE(IUNIT_PS,'(F4.1,'' Print'')') SIZE
              XXX=XXX+SIZE*COEF
              WRITE(IUNIT_PS,'(2F7.2,'' moveto'')') XXX,YY
            ENDDO
            XX=XX+SIZE*N*COEF
            N=0
          ENDIF
        ENDIF
        IF(CH.NE.' ') THEN
          N=N+1        
          STR(N:N)=CH
          FLAGB='N'  
        ELSE
          FLAGB='Y'  
          XX=XX+SIZE*COEF
        ENDIF
      ENDDO
      RETURN
      END
C*
      SUBROUTINE NPAC1 (IWORD, IX1, IY1, IX2, IY2)
      PARAMETER  (IPX=7,IPY=9)
      INTEGER IW1, IW2
      IW1 = IWORD/100
      IW2 = IWORD - IW1*100
      CALL NPAC2 (IW1 ,IX1, IY1, IPX)
      CALL NPAC2 (IW2 ,IX2, IY2, IPX)
      END
C*
      SUBROUTINE NPAC2 (IW, IX, IY, K)
      IY = IW/K
      IF (MOD(IW,K) .EQ. 0) IY = IY - 1
      IX = IW -IY*K - 1
      END
C*
      SUBROUTINE SCALE0 (IX1, IY1, IX2, IY2, SIZEX, SIZEY)
      IX1=IX1*SIZEX
      IX2=IX2*SIZEX
      IY1=IY1*SIZEY
      IY2=IY2*SIZEY
      END
C*
      SUBROUTINE SYMROT (IX1, IY1, IX2, IY2, IROT)
      DATA PI180 /1.74533E-2/
      SINROT = SIN (PI180*IROT)
      COSROT = COS (PI180*IROT)
      KX1 = IX1*COSROT - IY1*SINROT +0.5
      KY1 = IX1*SINROT + IY1*COSROT +0.5
      KX2 = IX2*COSROT - IY2*SINROT +0.5
      KY2 = IX2*SINROT + IY2*COSROT +0.5
      IX1 = KX1
      IX2 = KX2
      IY1 = KY1
      IY2 = KY2
      END
C*
      SUBROUTINE SYMSL (IX1, IY1, IX2, IY2)
      DATA TAN15 / 0.2679491 /
      IDX1 = TAN15*IY1
      IDX2 = TAN15*IY2
      IX1 = IX1 + IDX1
      IX2 = IX2 + IDX2
      END
C*
      SUBROUTINE SYMTRN (IX1,IY1,IX2,IY2,IX0,IY0,SIZEX,SIZEY)
      IX1=IX1+IX0
      IX2=IX2+IX0
      IY1=IY1+IY0
      IY2=IY2+IY0
      END
C*
      SUBROUTINE FINXY (IFINX, IFINY , IX0, IY0, SZ, IROT)
      IFINX=SZ
      IFINY=0
      CALL SYMROT (0, 0, IFINX, IFINY, IROT)
      CALL SYMTRN (0, 0, IFINX, IFINY, IX0, IY0,SCLX,SCLY)
      RETURN
      END

      SUBROUTINE INIT_TX_PAR(RGB,COLNAM)
C-----------------------------------------------------------------------
C
C Initialization of common variables 
C
C-----------------------------------------------------------------------
      PARAMETER ( MXCOLR = 19 )
      CHARACTER*12 COLNAM(MXCOLR)
      REAL         RGB(3,MXCOLR)

C ---
      COMMON /TX_BOX/ IBOXX,IBOXY,ISHX,ISHY
      INTEGER IBOXX,IBOXY,ISHX,ISHY
C ----
      COMMON/TX_ORIG/  IXO,IYO,IX0,IY0
C ----
      COMMON /TX_SLCT/   IPAGE
      INTEGER            IPAGE
C ----
      COMMON /COM_PS/ IOPEN
      INTEGER         IOPEN
C -------------
      COMMON /COMORG/ ITYPE,SLEN,IXORG,IYORG
C ----
C
      COMMON /PS_BOX/ BBOXX1,BBOXX2,BBOXY1,BBOXY2
      INTEGER  BBOXX1,BBOXX2,BBOXY1,BBOXY2
C ---
      CHARACTER*12 COLNAM_D(MXCOLR)
      REAL         RGB_D(3,MXCOLR)
C ----
      INTEGER ICOL,ILINE
C ----
      DATA 
     + ((RGB_D(ILINE,ICOL),ILINE=1,3),COLNAM_D(ICOL),ICOL=1,MXCOLR) /
     +     0.0000, 0.0000, 0.0000, 'BLACK',
     +     1.0000, 1.0000, 1.0000, 'WHITE',
     +     1.0000, 0.0000, 0.0000, 'RED',
     +     0.0000, 1.0000, 0.0000, 'GREEN',
     +     0.0000, 0.0000, 1.0000, 'BLUE',
     +     1.0000, 1.0000, 0.0000, 'YELLOW',
     +     0.8000, 0.5000, 0.0000, 'ORANGE',
     +     0.5000, 1.0000, 0.0000, 'LIME GREEN',
     +     0.5000, 0.0000, 1.0000, 'PURPLE',
     +     0.5000, 1.0000, 1.0000, 'CYAN',
     +     1.0000, 0.5000, 1.0000, 'PINK',
     +     0.3000, 0.8000, 1.0000, 'SKY BLUE',
     +     1.0000, 1.0000, 0.7000, 'CREAM',
     +     0.0000, 1.0000, 1.0000, 'TURQUOISE',
     +     1.0000, 0.0000, 1.0000, 'LILAC',
     +     0.8000, 0.0000, 0.0000, 'BRICK RED',
     +     0.5000, 0.0000, 0.0000, 'BROWN',
     +     0.9700, 0.9700, 0.9700, 'LIGHT GREY',
     +     1.0000, 1.0000, 1.0000, 'WHITE' /
c     +     1.0000, 1.0000, 1.0000, 'WHITE' /
C ------------------------------------------------------
      DO ICOL=1,MXCOLR
        DO ILINE=1,3
          RGB(ILINE,ICOL)=RGB_D(ILINE,ICOL)
        ENDDO
        COLNAM(ICOL)=COLNAM_D(ICOL)
      ENDDO

      CALL INIT_TX

      RETURN
      END

      SUBROUTINE INIT_TX
C-----------------------------------------------------------------------
C
C Initialization of common variables 
C
C-----------------------------------------------------------------------
C ---
      COMMON /TX_BOX/ IBOXX,IBOXY,ISHX,ISHY
      INTEGER IBOXX,IBOXY,ISHX,ISHY
C ----
      COMMON/TX_ORIG/  IXO,IYO,IX0,IY0
C ----
      COMMON /TX_SLCT/   IPAGE
      INTEGER            IPAGE
C ----
      COMMON /COM_PS/ IOPEN
      INTEGER         IOPEN
C -------------
      COMMON /COMORG/ ITYPE,SLEN,IXORG,IYORG
C ----
C
      COMMON /PS_BOX/ BBOXX1,BBOXX2,BBOXY1,BBOXY2
      INTEGER  BBOXX1,BBOXX2,BBOXY1,BBOXY2
C ---
C ------------------------------------------------------

      BBOXX1 =  30
      BBOXX2 = 550
      BBOXY1 =  50
      BBOXY2 = 780

      IBOXX = 650
      IBOXY = 500

      IXO   = 0
      IYO   = 0
      IX0   = 0
      IY0   = 0
      IPAGE = 0
      IOPEN =0
      ISHX_PS  = 30
      ISHY_PS  = 20
      IXORG = 0
      IYORG = 0
      SLEN  = 0.0
      ITYPE = 0

      RETURN
      END
C =========================
C**************************************************************************
C
C  PS.F    - PostScript subroutines
C
C            Written by Roman Laskowski, University College, London,
C            November 1993.
C
C            Original version was part of v.3.0 of the PROCHECK suite
C            of programs. (Previously the routines were incorporated in
C            pplot.f).
C
C            Subsequent amendments will be labelled by CHECK v.m.n-->
C            and CHECK v.m.n<-- where m.n is the version number
C            corresponding to the change
C
C  v.3.0.1 - Change of plot-file names. All plot-file names now have the
C            form: <filename>_nn.ps  where <filename> is the name of the
C            input data file, and nn is a sequential number 01, 02, ...
C                                             Roman Laskowski (29 Mar 1994)
C            (a little changed. 21.09.96 Vagin)
C
C            !!! PSOPEN( ....,IERR) !!!
C--------------------------------------------------------------------------
C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSSETPG  -  Set page specifications
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSSETPG(TOTALNBPAGES)

C ---

      INTEGER TOTPAG, CURPAG

      COMMON /ISPS/ TOTPAG, CURPAG, IUNIT_PS
C ---
      INTEGER TOTALNBPAGES

      TOTPAG = TOTALNBPAGES
      CURPAG = 1

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSOPEN  -  Open PostScript file and write out header records
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSOPEN(FNAME,BBOXX1,BBOXX2,BBOXY1,BBOXY2,MXCOLR,RGB,
     -    INCOL,BAKCOL,IERR)

C -------------------------------------
      INTEGER TOTPAG, CURPAG, IUNIT_PS

      COMMON /ISPS/ TOTPAG, CURPAG, IUNIT_PS
C ---

      CHARACTER*(*)  FNAME
      CHARACTER*2    COLNO
      INTEGER        BAKCOL, BBOXX1, BBOXX2, BBOXY1, BBOXY2, I, ICOL,
     -               MXCOLR,MDOC,IERR
      LOGICAL        INCOL
      REAL           RGB(3,MXCOLR)
      CHARACTER      PATH*1,EXT*1
C -------------------------------------------------------------
C---- Open output file
      IERR     = 0
      IUNIT_PS = 51
      MDOC     = 99
      PATH     = ' '
      EXT      = ' '      
      CALL OPENFW(IUNIT_PS,MDOC,PATH,FNAME,EXT,IERR)
      IF(IERR.NE.0) GO TO 900
      
C      OPEN(UNIT=51, FILE=FNAME, STATUS='UNKNOWN',
C     -     FORM='FORMATTED', ACCESS='SEQUENTIAL',
C     -     ERR=900)
CCVAX     -     CARRIAGECONTROL = 'LIST',
C

C---- Write out headings to PostScript file
      WRITE(IUNIT_PS,10) TOTPAG
 10   FORMAT(
     -    '%!PS-Adobe-3.0',/,
     -    '%%Creator: Molrep',/,
     -'%%DocumentNeededResources: font Times-Roman Symbol Times-Bold',/,
     -    '%%BoundingBox: (atend)',/,
     -    '%%Pages:',I3,/,
     -    '%%EndComments',/,
     -    '%%BeginProlog')

      CALL PSRESOURCE_NEW (IUNIT_PS)

      WRITE(IUNIT_PS,20)
 20   FORMAT(
     -    '/L { moveto lineto stroke } bind def',/,
     -    '/Col { setrgbcolor } bind def')

C---- Loop to define the colours
      IF (INCOL) THEN
          DO 100, ICOL = 1, MXCOLR
              WRITE(COLNO,40) ICOL
 40           FORMAT(I2)
              IF (COLNO(1:1).EQ.' ') COLNO(1:1) = '0'
              WRITE(IUNIT_PS,60) COLNO, (RGB(I,ICOL), I = 1, 3)
 60           FORMAT('/Col',A2,' {gsave ',3F8.4,' setrgbcolor } def')
 100      CONTINUE
      ENDIF

      WRITE(IUNIT_PS,120)
 120  FORMAT(
     -    '/Poly3 { moveto lineto lineto fill grestore } bind ',
     -    'def',/,
     -    '/Pl3 { 6 copy Poly3 moveto moveto moveto closepath ',
     -    'stroke } bind def',/,
     -    '/Pline3 { 6 copy Poly3 moveto lineto lineto closepa',
     -    'th stroke } bind def')
      WRITE(IUNIT_PS,250)
 250  FORMAT(
     -    '/Poly4 { moveto lineto lineto lineto fill grestore } bind ',
     -    'def',/,
     -    '/Pl4 { 8 copy Poly4 moveto moveto moveto moveto closepath ',
     -    'stroke } bind def',/,
     -    '/Pline4 { 8 copy Poly4 moveto lineto lineto lineto closepa',
     -    'th stroke } bind def',/,
     -    '/Circle { gsave newpath 0.0 setgray 3 copy 0 360 arc fill ',
     -    'stroke grestore }',/
     -    'bind def',/,
     -    '/Circleu { gsave newpath 0.0 setgray 3 copy 0 360 arc ',
     -    'stroke grestore }',/
     -    'bind def')
      WRITE(IUNIT_PS,300)
 300  FORMAT(
     - '/Print { /Times-Roman-Extd findfont exch scalefont setfont show'
     -    ,' } bind def',/,
     -    '/Bprint { /Times-Bold findfont exch scalefont setfont show',
     -    ' } bind def',/,
     -    '/Gprint { /Symbol findfont exch scalefont setfont show } b',
     -    'ind def',/,
     -    '/Center {',/,
     -    '  dup /Times-Roman-Extd findfont exch scalefont setfont',/,
     -    '  exch stringwidth pop -2 div exch -3 div rmoveto',/,
     -    ' } bind def',/,
     -    '/CenterRot90 {',/,
     -    '  dup /Times-Roman-Extd findfont exch scalefont setfont',/,
     -    '  exch stringwidth pop -2 div exch 3 div exch rmoveto',/,
     -    ' } bind def',/,
     -    '/UncenterRot90 {',/,
     -    '  dup /Times-Roman-Extd findfont exch scalefont setfont',/,
     -    '  exch stringwidth } bind def',/,
     -    '/Rot90 { gsave currentpoint translate 90 rotate } bind def'
     -    ,/,'%%EndProlog')
      WRITE(IUNIT_PS,400) CURPAG, TOTPAG
 400  FORMAT(
     -    '%%BeginSetup',/,
     -    '1 setlinecap 1 setlinejoin 1 setlinewidth 0 setgray [ ] 0 ',
     -    'setdash newpath',/,
     -    '/Times-Roman /Times-Roman-Extd encode_vector ReEncodeSmall'
     -    ,/,'%%EndSetup',/,
     -    '%%Page:',I5,I5)
      WRITE(IUNIT_PS,500) REAL(BBOXX1), REAL(BBOXY1), REAL(BBOXX2),
     -     REAL(BBOXY1), REAL(BBOXX2), REAL(BBOXY2), REAL(BBOXX1),
     -     REAL(BBOXY2)
 500  FORMAT(
     -    '/ProcheckSave save def',/,
     -    2F6.2,' moveto',2(2F7.2,' lineto'),/,
     -    2F7.2,' lineto closepath gsave',/,
     -    'gsave 1.0000 setgray fill grestore',/,
     -    'clip newpath')

C---- Draw in the background colour
      IF (INCOL) THEN
          CALL PSHADE(0.0,BAKCOL,RGB,MXCOLR,INCOL)
          CALL PSUBOX(REAL(BBOXX1), REAL(BBOXY1), REAL(BBOXX2),
     -        REAL(BBOXY1), REAL(BBOXX2), REAL(BBOXY2), REAL(BBOXX1),
     -        REAL(BBOXY2))
      ENDIF

      GO TO 999

C---- Errors on parameter file
 900  CONTINUE
      MDOC=0
      CALL MSGERR(MDOC,'WARNING: Unable to open Postscript file')
      IERR=1
      GO TO 999

 999  CONTINUE
      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSRESOURCE  -  Write resource to PostScript file
C
C----------------------------------------------------------------------+---

C--------------------------------------------------------------------------

      SUBROUTINE PSRESOURCE_NEW(UN)
C --------------------------------------
      INTEGER       UN
      CHARACTER LINE*80
C --------------------------------------
      WRITE(UN,'(A)')
     *'%%BeginResource: latin1_prolog'
      WRITE(UN,'(A)')
     *' '
      WRITE(UN,'(A)')
     *'% ReEncodeSmall from Adobe Postscript Tutorial and Cookbook'
      WRITE(UN,'(A)')
     *'/reencsmalldict 12 dict def'
      WRITE(UN,'(A)')
     *'/ReEncodeSmall'
      WRITE(UN,'(A)')
     *' {reencsmalldict begin'
      WRITE(UN,'(A)')
     *'  /newcodesandnames exch def'
      WRITE(UN,'(A)')
     *'  /newfontname exch def'
      WRITE(UN,'(A)')
     *'  /basefontname exch def'
      WRITE(UN,'(A)')
     *' '
      WRITE(UN,'(A)')
     *'  /basefontdict basefontname findfont def'
      WRITE(UN,'(A)')
     *'  /newfont basefontdict maxlength dict def'
      WRITE(UN,'(A)')
     *' '
      WRITE(UN,'(A)')
     *'  basefontdict'
      WRITE(UN,'(A)')
     *'   {exch dup /FID ne'
      WRITE(UN,'(A)')
     *'     {dup /Encoding eq'
      WRITE(UN,'(A)')
     *'       {exch dup length array copy'
      WRITE(UN,'(A)')
     *'	 newfont 3 1 roll put}'
      WRITE(UN,'(A)')
     *'       {exch newfont 3 1 roll put}'
      WRITE(UN,'(A)')
     *'       ifelse'
      WRITE(UN,'(A)')
     *'     }'
      WRITE(UN,'(A)')
     *'     {pop pop}'
      WRITE(UN,'(A)')
     *'     ifelse'
      WRITE(UN,'(A)')
     *'   }forall'
      WRITE(UN,'(A)')
     *' '
      WRITE(UN,'(A)')
     *'  newfont /FontName newfontname put'
      WRITE(UN,'(A)')
     *'  newcodesandnames aload pop'
      WRITE(UN,'(A)')
     *' '
      WRITE(UN,'(A)')
     *'  newcodesandnames length 2 idiv'
      WRITE(UN,'(A)')
     *'   {newfont /Encoding get 3 1 roll put}'
      WRITE(UN,'(A)')
     *'   repeat'
      WRITE(UN,'(A)')
     *' '
      WRITE(UN,'(A)')
     *'  newfontname newfont definefont pop'
      WRITE(UN,'(A)')
     *'  end'
      WRITE(UN,'(A)')
     *'}def'
      WRITE(UN,'(A)')
     *'%%EndResource'
      WRITE(UN,'(A)')
     *'%%BeginResource: latin1_encoding'
      WRITE(UN,'(A)')
     *'/encode_vector ['
      WRITE(UN,'(A)')
     *'8#040  /space        8#041  /exclam       8#042  /quotedbl     '
      WRITE(UN,'(A)')
     *'8#043  /numbersign   8#044  /dollar       8#045  /percent      '
      WRITE(UN,'(A)')
     *'8#046  /ampersand    8#047  /quoteright   8#050  /parenleft    '
      WRITE(UN,'(A)')
     *'8#051  /parenright   8#052  /asterisk     8#053  /plus         '
      WRITE(UN,'(A)')
     *'8#054  /comma        8#055  /minus        8#056  /period       '
      WRITE(UN,'(A)')
     *'8#057  /slash        8#060  /zero         8#061  /one          '
      WRITE(UN,'(A)')
     *'8#062  /two          8#063  /three        8#064  /four         '
      WRITE(UN,'(A)')
     *'8#065  /five         8#066  /six          8#067  /seven        '
      WRITE(UN,'(A)')
     *'8#070  /eight        8#071  /nine         8#072  /colon        '
      WRITE(UN,'(A)')
     *'8#073  /semicolon    8#074  /less         8#075  /equal        '
      WRITE(UN,'(A)')
     *'8#076  /greater      8#077  /question     8#100  /at           '
      WRITE(UN,'(A)')
     *'8#101  /A            8#102  /B            8#103  /C            '
      WRITE(UN,'(A)')
     *'8#104  /D            8#105  /E            8#106  /F            '
      WRITE(UN,'(A)')
     *'8#107  /G            8#110  /H            8#111  /I            '
      WRITE(UN,'(A)')
     *'8#112  /J            8#113  /K            8#114  /L            '
      WRITE(UN,'(A)')
     *'8#115  /M            8#116  /N            8#117  /O            '
      WRITE(UN,'(A)')
     *'8#120  /P            8#121  /Q            8#122  /R            '
      WRITE(UN,'(A)')
     *'8#123  /S            8#124  /T            8#125  /U            '
      WRITE(UN,'(A)')
     *'8#126  /V            8#127  /W            8#130  /X            '
      WRITE(UN,'(A)')
     *'8#131  /Y            8#132  /Z            8#133  /bracketleft  '
      WRITE(UN,'(A)')
     *'8#134  /backslash    8#135  /bracketright 8#136  /asciicircum  '
      WRITE(UN,'(A)')
     *'8#137  /underscore   8#140  /quoteleft    8#141  /a            '
      WRITE(UN,'(A)')
     *'8#142  /b            8#143  /c            8#144  /d            '
      WRITE(UN,'(A)')
     *'8#145  /e            8#146  /f            8#147  /g            '
      WRITE(UN,'(A)')
     *'8#150  /h            8#151  /i            8#152  /j            '
      WRITE(UN,'(A)')
     *'8#153  /k            8#154  /l            8#155  /m            '
      WRITE(UN,'(A)')
     *'8#156  /n            8#157  /o            8#160  /p            '
      WRITE(UN,'(A)')
     *'8#161  /q            8#162  /r            8#163  /s            '
      WRITE(UN,'(A)')
     *'8#164  /t            8#165  /u            8#166  /v            '
      WRITE(UN,'(A)')
     *'8#167  /w            8#170  /x            8#171  /y            '
      WRITE(UN,'(A)')
     *'8#172  /z            8#173  /braceleft    8#174  /bar          '
      WRITE(UN,'(A)')
     *'8#175  /braceright   8#176  /tilde        8#240  /space        '
      WRITE(UN,'(A)')
     *'8#241  /exclamdown   8#242  /cent         8#243  /sterling     '
      WRITE(UN,'(A)')
     *'8#244  /currency     8#245  /yen          8#246  /brokenbar    '
      WRITE(UN,'(A)')
     *'8#247  /section      8#250  /dieresis     8#251  /copyright    '
      WRITE(UN,'(A)')
     *'8#252  /ordfeminine  8#253  /guillemotleft 8#254  /logicalnot  '
      WRITE(UN,'(A)')
     *'8#255  /hyphen       8#256  /registered   8#257  /macron       '
      WRITE(UN,'(A)')
     *'8#260  /degree       8#261  /plusminus    8#262  /twosuperior  '
      WRITE(UN,'(A)')
     *'8#263  /threesuperior 8#264  /acute       8#265  /mu           '
      WRITE(UN,'(A)')
     *'8#266  /paragraph    8#267  /bullet       8#270  /cedilla      '
      WRITE(UN,'(A)')
     *'8#271  /dotlessi    8#272  /ordmasculine 8#273  /guillemotright'
      WRITE(UN,'(A)')
     *'8#274  /onequarter   8#275  /onehalf      8#276  /threequarters'
      WRITE(UN,'(A)')
     *'8#277  /questiondown 8#300  /Agrave       8#301  /Aacute       '
      WRITE(UN,'(A)')
     *'8#302  /Acircumflex  8#303  /Atilde       8#304  /Adieresis    '
      WRITE(UN,'(A)')
     *'8#305  /Aring        8#306  /AE           8#307  /Ccedilla     '
      WRITE(UN,'(A)')
     *'8#310  /Egrave       8#311  /Eacute       8#312  /Ecircumflex  '
      WRITE(UN,'(A)')
     *'8#313  /Edieresis    8#314  /Igrave       8#315  /Iacute       '
      WRITE(UN,'(A)')
     *'8#316  /Icircumflex  8#317  /Idieresis    8#320  /Eth          '
      WRITE(UN,'(A)')
     *'8#321  /Ntilde       8#322  /Ograve       8#323  /Oacute       '
      WRITE(UN,'(A)')
     *'8#324  /Ocircumflex  8#325  /Otilde       8#326  /Odieresis    '
      WRITE(UN,'(A)')
     *'8#327  /multiply     8#330  /Oslash       8#331  /Ugrave       '
      WRITE(UN,'(A)')
     *'8#332  /Uacute       8#333  /Ucircumflex  8#334  /Udieresis    '
      WRITE(UN,'(A)')
     *'8#335  /Yacute       8#336  /Thorn        8#337  /germandbls   '
      WRITE(UN,'(A)')
     *'8#340  /agrave       8#341  /aacute       8#342  /acircumflex  '
      WRITE(UN,'(A)')
     *'8#343  /atilde       8#344  /adieresis    8#345  /aring        '
      WRITE(UN,'(A)')
     *'8#346  /ae           8#347  /ccedilla     8#350  /egrave       '
      WRITE(UN,'(A)')
     *'8#351  /eacute       8#352  /ecircumflex  8#353  /edieresis    '
      WRITE(UN,'(A)')
     *'8#354  /igrave       8#355  /iacute       8#356  /icircumflex  '
      WRITE(UN,'(A)')
     *'8#357  /idieresis    8#360  /eth          8#361  /ntilde       '
      WRITE(UN,'(A)')
     *'8#362  /ograve       8#363  /oacute       8#364  /ocircumflex  '
      WRITE(UN,'(A)')
     *'8#365  /otilde       8#366  /odieresis    8#367  /divide       '
      WRITE(UN,'(A)')
     *'8#370  /oslash       8#371  /ugrave       8#372  /uacute       '
      WRITE(UN,'(A)')
     *'8#373  /ucircumflex  8#374  /udieresis    8#375  /yacute       '
      WRITE(UN,'(A)')
     *'8#376  /thorn        8#377  /ydieresis    	'
      WRITE(UN,'(A)')
     *'] def'
      WRITE(UN,'(A)')
     *'%%EndResource'
C -----------------------
      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSNWPAG  -  Write new page lines to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSNWPAG(BBOXX1,BBOXX2,BBOXY1,BBOXY2,INCOL)

      INTEGER TOTPAG, CURPAG

      COMMON /ISPS/ TOTPAG, CURPAG, IUNIT_PS
C ---
      REAL          RGB(3,19), SHADE

      INTEGER       BBOXX1, BBOXX2, BBOXY1, BBOXY2, BAKCOL, MXCOLR
      LOGICAL        INCOL

C---- Write out new page lines to PostScript file
      BAKCOL = 1 
      MXCOLR = 19 
      CURPAG = CURPAG + 1

      WRITE(IUNIT_PS,500) CURPAG, TOTPAG,
     -     REAL(BBOXX1), REAL(BBOXY1), REAL(BBOXX2),
     -     REAL(BBOXY1), REAL(BBOXX2), REAL(BBOXY2), REAL(BBOXX1),
     -     REAL(BBOXY2)
 500  FORMAT(
     -    'grestore stroke',/,
     -    'ProcheckSave restore',/,
     -    'showpage',/,
     -    '%%Page:',I3,I3,/,
     -    '/ProcheckSave save def',/,
     -    2F6.2,' moveto',2(2F7.2,' lineto'),/,
     -    2F7.2,' lineto closepath gsave',/,
     -    'gsave 1.0000 setgray fill grestore',/,
     -    'clip newpath')

C---- Draw in the background colour
      IF (INCOL) THEN
          CALL PSHADE(0.0,BAKCOL,RGB,MXCOLR,INCOL)
          CALL PSUBOX(REAL(BBOXX1), REAL(BBOXY1), REAL(BBOXX2),
     -        REAL(BBOXY1), REAL(BBOXX2), REAL(BBOXY2), REAL(BBOXX1),
     -        REAL(BBOXY2))
      ENDIF

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSCLOS  -  Write final lines to PostScript file and close
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSCLOS(BBOXX1,BBOXX2,BBOXY1,BBOXY2)

      COMMON /ISPS/ TOTPAG, CURPAG, IUNIT_PS
      INTEGER TOTPAG, CURPAG
      INTEGER       BBOXX1, BBOXX2, BBOXY1, BBOXY2

C---- Write out closing lines to PostScript file
      WRITE(IUNIT_PS,100) BBOXX1 - 1, BBOXY1 - 1, BBOXX2 + 1, BBOXY2 + 1
 100  FORMAT(
     -    'grestore stroke',/,
     -    'ProcheckSave restore',/,
     -    'showpage',/,
     -    '%%Trailer',/,
     -    '%%BoundingBox:',4I4,/,
     -    '%%EOF')


C---- Close the file
      CLOSE(IUNIT_PS)

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSBBOX  -  Write out bounded box to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSBBOX(X1,Y1,X2,Y2,X3,Y3,X4,Y4)
      COMMON /ISPS/ TOTPAG, CURPAG, IUNIT_PS
      INTEGER TOTPAG, CURPAG

      REAL          X1, X2, Y1, Y2, X3, Y3, X4, Y4

      WRITE(IUNIT_PS,100) X1, Y1, X2, Y2, X3, Y3, X4, Y4
 100  FORMAT(8F7.2,' Pline4')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSCOLB  -  Write background colour level
C
C----------------------------------------------------------------------+--- 

      SUBROUTINE PSCOLB(R,G,B)
      COMMON /ISPS/ TOTPAG, CURPAG, IUNIT_PS
      INTEGER TOTPAG, CURPAG

      REAL          R, G, B

      WRITE(IUNIT_PS,100) R, G, B
 100  FORMAT(3F8.4,' Col')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSCOLR  -  Write colour level
C
C----------------------------------------------------------------------+--- 

      SUBROUTINE PSCOLR(R,G,B)
      COMMON /ISPS/ TOTPAG, CURPAG, IUNIT_PS
      INTEGER TOTPAG, CURPAG

      REAL          R, G, B

      WRITE(IUNIT_PS,100) R, G, B
 100  FORMAT('gsave ',3F8.4,' Col')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSCIRC  -  Write out a black circle to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSCIRC(X,Y,RADIUS)
      COMMON /ISPS/ TOTPAG, CURPAG, IUNIT_PS
      INTEGER TOTPAG, CURPAG

      REAL          X, Y, RADIUS, R

      R=RADIUS
      IF(R.LT.0.5.OR.R.GT.999.9) R=1.0

      IF(ABS(X).GT.999.9) X=1.0
      IF(ABS(Y).GT.999.9) Y=1.0
      WRITE(IUNIT_PS,100) X, Y, R
 100  FORMAT(3F7.2,' Circle')

      RETURN
      END


      SUBROUTINE PSCIRCLE(X,Y,RADIUS)
      COMMON /ISPS/ TOTPAG, CURPAG, IUNIT_PS
      INTEGER TOTPAG, CURPAG

      REAL          X, Y, RADIUS, R

      R=RADIUS
      IF(R.LT.0.5.OR.R.GT.999.9) R=1.0

      IF(ABS(X).GT.999.9) X=1.0
      IF(ABS(Y).GT.999.9) Y=1.0
      WRITE(IUNIT_PS,100) X, Y, R
 100  FORMAT(3F7.2,' Circleu')

      RETURN
      END
C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSCTXT  -  Write out centred text to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSCTXT(X,Y,SIZE,TEXT)
      COMMON /ISPS/ TOTPAG, CURPAG, IUNIT_PS
      INTEGER TOTPAG, CURPAG

      CHARACTER*(*) TEXT
      REAL          SIZE, X, Y

      WRITE(IUNIT_PS,100) X, Y
 100  FORMAT(2F7.2,' moveto')
      CALL LENSTR_BL(TEXT,LEN)
      SZ=SIZE
      IF(SZ.LT.0.0.OR.SZ.GT.99.9) SZ=0.0
      WRITE(IUNIT_PS,200) TEXT(1:LEN), SZ
 200  FORMAT('(',A,')',/,F4.1,' Center')
      WRITE(IUNIT_PS,300) TEXT(1:LEN), SZ
 300  FORMAT('(',A,')',/,F4.1,' Print')
      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSLINE  -  Write line out to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSLINE(X1,Y1,X2,Y2)
      COMMON /ISPS/ TOTPAG, CURPAG, IUNIT_PS
      INTEGER TOTPAG, CURPAG

      REAL          X1, X2, Y1, Y2

      IF(ABS(X1).GT.999.0) X1=0.0
      IF(ABS(X2).GT.999.0) X2=0.0
      IF(ABS(Y1).GT.999.0) Y1=0.0
      IF(ABS(Y2).GT.999.0) Y2=0.0

      WRITE(IUNIT_PS,100) X1, Y1, X2, Y2
 100  FORMAT(4F7.2,' L')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSLWID  -  Write line-width out to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSLWID(LWIDTH)
      COMMON /ISPS/ TOTPAG, CURPAG, IUNIT_PS
      INTEGER TOTPAG, CURPAG

      REAL          LWIDTH

      T = LWIDTH
      IF(T.LT.0.01) T=0.01
      IF(T.GT.2.0)  T=2.0
      WRITE(IUNIT_PS,100) T
 100  FORMAT(F5.2,' setlinewidth')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSMARK  -  Write point-marker to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSMARK(X,Y,MARKER,HWIDX,HWIDY)

      INTEGER       MARKER
      REAL          HWIDX, HWIDY, X, Y

C---- Print appropriate marker

C---- Oridnary residue
      IF (MARKER.EQ.1) THEN
           CALL PSBBOX(X - HWIDX,Y - HWIDY,X - HWIDX,Y + HWIDY,
     -                 X + HWIDX,Y + HWIDY,X + HWIDX,Y - HWIDY)

C---- Glycine
      ELSE IF (MARKER.EQ.2) THEN
          CALL PSTRIA(X - HWIDX,Y - 0.6 * HWIDY,X + HWIDX,
     -        Y - 0.6 * HWIDY,X,Y + 1.2 * HWIDY)

C---- Residue in disallowed region
      ELSE IF (MARKER.EQ.3) THEN
           CALL PSBBOX(X - HWIDX,Y - HWIDY,X - HWIDX,Y + HWIDY,
     -                 X + HWIDX,Y + HWIDY,X + HWIDX,Y - HWIDY)
      ENDIF

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSRCTX  -  Write out text centred and rotated through 90
C                        degrees to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSRCTX(X,Y,SIZE,TEXT)
      COMMON /ISPS/ TOTPAG, CURPAG, IUNIT_PS
      INTEGER TOTPAG, CURPAG

      CHARACTER*(*) TEXT
      REAL          SIZE, X, Y

      WRITE(IUNIT_PS,100) X, Y
 100  FORMAT(2F7.2,' moveto')
      CALL LENSTR_BL(TEXT,LEN)
      WRITE(IUNIT_PS,200) TEXT(1:LEN), SIZE
 200  FORMAT('(',A,') ',F4.1,' CenterRot90 Rot90')
      WRITE(IUNIT_PS,300) TEXT(1:LEN), SIZE
 300  FORMAT('(',A,') ',F4.1,' Print')
      WRITE(IUNIT_PS,400)
 400  FORMAT('grestore')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSRTXT  -  Write out text rotated through 90 degrees to
C                        PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSRTXT(X,Y,SIZE,TEXT)
      COMMON /ISPS/ TOTPAG, CURPAG, IUNIT_PS
      INTEGER TOTPAG, CURPAG

      CHARACTER*(*) TEXT
      REAL          SIZE, X, Y

      WRITE(IUNIT_PS,100) X, Y
 100  FORMAT(2F7.2,' moveto')
      CALL LENSTR_BL(TEXT,LEN)
      WRITE(IUNIT_PS,200) TEXT(1:LEN), SIZE
 200  FORMAT('(',A,') ',F4.1,' UncenterRot90 Rot90')
      WRITE(IUNIT_PS,300) TEXT(1:LEN), SIZE
 300  FORMAT('(',A,') ',F4.1,' Print')
      WRITE(IUNIT_PS,400)
 400  FORMAT('grestore')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSDASH  -  Switch dashed lines on/off
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSDASH(ONOFF)
      COMMON /ISPS/ TOTPAG, CURPAG, IUNIT_PS
      INTEGER TOTPAG, CURPAG

      INTEGER       ONOFF

      IF (ONOFF.EQ.0) THEN
          WRITE(IUNIT_PS,100)
 100      FORMAT('[]  0 setdash')
      ELSE
          WRITE(IUNIT_PS,120) ONOFF, ONOFF
 120      FORMAT('[ ', I2, ' ', I2, ' ]  0 setdash')
      ENDIF

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PS_CALE  -  Write out colour or black-and-white shading
C                        level to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PS_CALE(SHADE,INCOL,MXCOLR,RGB,MINCOL,MAXCOL)
      COMMON /ISPS/ TOTPAG, CURPAG, IUNIT_PS
      INTEGER TOTPAG, CURPAG

      INTEGER       ICOL, MAXCOL, MINCOL, MXCOLR
      LOGICAL       INCOL
      REAL          COLOUR(3), RGB(3,MXCOLR), SHADE

C---- If black-and-white PostScript file, then write out grey-level
      IF (.NOT.INCOL) THEN
          WRITE(IUNIT_PS,100) SHADE
 100      FORMAT('gsave',F7.4,' setgray')

C---- Otherwise, if in colour, determine the right mix of colours
      ELSE
          DO 200, ICOL = 1, 3
              COLOUR(ICOL) = RGB(ICOL,MINCOL) + (1.0 - SHADE)
     -            * (RGB(ICOL,MAXCOL) - RGB(ICOL,MINCOL))
 200      CONTINUE

C----     Write out the 3 RGB values
          WRITE(IUNIT_PS,220) (COLOUR(ICOL), ICOL = 1, 3)
 220      FORMAT('gsave ',3F8.4,' Col')
      ENDIF

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSHADE  -  Write shading level out to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSHADE(SHADE,COLOUR,RGB,MXCOLR,INCOL)
      COMMON /ISPS/ TOTPAG, CURPAG, IUNIT_PS
      INTEGER TOTPAG, CURPAG

      CHARACTER*2   COLNO
      INTEGER       COLOUR, MXCOLR
      LOGICAL       INCOL
      REAL          RGB(3,*), SHADE

      IF (.NOT.INCOL) THEN
          WRITE(IUNIT_PS,100) SHADE
 100      FORMAT('gsave',F7.4,' setgray')
      ELSE
          WRITE(COLNO,140) COLOUR
 140      FORMAT(I2)
          IF (COLNO(1:1).EQ.' ') COLNO(1:1) = '0'
          WRITE(IUNIT_PS,200) COLNO
 200      FORMAT('Col',A2)
      ENDIF

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSTEXT  -  Write out text to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSTEXT(X,Y,SIZE,TEXT)
      COMMON /ISPS/ TOTPAG, CURPAG, IUNIT_PS
      INTEGER TOTPAG, CURPAG

      CHARACTER*(*) TEXT
      REAL          SIZE, X, Y

      T1=X
      T2=Y - SIZE / 4.0
      IF(ABS(T1).GT.999.0) T1=1.0
      IF(ABS(T2).GT.999.0) T2=1.0
      WRITE(IUNIT_PS,100) T1,T2 
 100  FORMAT(2F7.2,' moveto')
      CALL LENSTR_BL(TEXT,LEN)
      SZ=SIZE
      IF(SZ.LT.0.5.OR.SZ.GT.99.9) SZ=1.0
      WRITE(IUNIT_PS,300) TEXT(1:LEN), SZ
 300  FORMAT('(',A,')',/,F4.1,' Print')
      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSBTEXT  -  Write out text to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSBTEXT(X,Y,SIZE,TEXT)
      COMMON /ISPS/ TOTPAG, CURPAG, IUNIT_PS
      INTEGER TOTPAG, CURPAG

      CHARACTER*(*) TEXT
      REAL          SIZE, X, Y

      T1=X
      T2=Y - SIZE / 4.0
      IF(ABS(T1).GT.999.0) T1=1.0
      IF(ABS(T2).GT.999.0) T2=1.0
      WRITE(IUNIT_PS,100) T1,T2 
 100  FORMAT(2F7.2,' moveto')
      CALL LENSTR_BL(TEXT,LEN)
      SZ=SIZE
      IF(SZ.LT.0.5.OR.SZ.GT.99.9) SZ=1.0
      WRITE(IUNIT_PS,300) TEXT(1:LEN), SZ
 300  FORMAT('(',A,')',/,F4.1,' Bprint')
      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSSYMB  -  Write out symbol text to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSSYMB(X,Y,SIZE,TEXT)
      COMMON /ISPS/ TOTPAG, CURPAG, IUNIT_PS
      INTEGER TOTPAG, CURPAG

      CHARACTER*(*) TEXT
      REAL          SIZE, X, Y

      T1=X
      T2=Y - SIZE / 4.0
      IF(ABS(T1).GT.999.0) T1=1.0
      IF(ABS(T2).GT.999.0) T2=1.0
      WRITE(IUNIT_PS,100) T1,T2 
 100  FORMAT(2F7.2,' moveto')
      CALL LENSTR_BL(TEXT,LEN)
      SZ=SIZE
      IF(SZ.LT.0.5.OR.SZ.GT.99.9) SZ=1.0
      WRITE(IUNIT_PS,300) TEXT(1:LEN), SZ
 300  FORMAT('(',A,')',/,F4.1,' Gprint')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSTRIA  -  Write out bounded triangle to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSTRIA(X1,Y1,X2,Y2,X3,Y3)
      COMMON /ISPS/ TOTPAG, CURPAG, IUNIT_PS
      INTEGER TOTPAG, CURPAG

      REAL          X1, X2, Y1, Y2, X3, Y3


      IF(ABS(X1).GT.999.0) X1=0.0
      IF(ABS(X2).GT.999.0) X2=0.0
      IF(ABS(Y1).GT.999.0) Y1=0.0
      IF(ABS(Y2).GT.999.0) Y2=0.0

      IF(ABS(X3).GT.999.0) X3=0.0
      IF(ABS(Y3).GT.999.0) Y3=0.0

      WRITE(IUNIT_PS,100) X1, Y1, X2, Y2, X3, Y3
 100  FORMAT(6F7.2,' Pline3')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSUBOX  -  Write out unbounded box to PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE PSUBOX(X1,Y1,X2,Y2,X3,Y3,X4,Y4)
      COMMON /ISPS/ TOTPAG, CURPAG, IUNIT_PS
      INTEGER TOTPAG, CURPAG

      REAL          X1, X2, Y1, Y2, X3, Y3, X4, Y4


      IF(ABS(X1).GT.999.0) X1=0.0
      IF(ABS(X2).GT.999.0) X2=0.0
      IF(ABS(Y1).GT.999.0) Y1=0.0
      IF(ABS(Y2).GT.999.0) Y2=0.0

      IF(ABS(X3).GT.999.0) X3=0.0
      IF(ABS(X4).GT.999.0) X4=0.0
      IF(ABS(Y3).GT.999.0) Y3=0.0
      IF(ABS(Y4).GT.999.0) Y4=0.0

      WRITE(IUNIT_PS,100) X1, Y1, X2, Y2, X3, Y3, X4, Y4
 100  FORMAT(8F7.2,' Pl4')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE PSUTRI  -  Write out unbounded triangle to PostScript file
C
C----------------------------------------------------------------------+--- 

      SUBROUTINE PSUTRI(X1,Y1,X2,Y2,X3,Y3)
      COMMON /ISPS/ TOTPAG, CURPAG, IUNIT_PS
      INTEGER TOTPAG, CURPAG

      REAL          X1, X2, X3, Y1, Y2, Y3

      WRITE(IUNIT_PS,100) X1, Y1, X2, Y2, X3, Y3
 100  FORMAT(6F7.2,' Pl3')

      RETURN
      END

C--------------------------------------------------------------------------
C**************************************************************************
C
C  SUBROUTINE AXES  -  Draw graph axes and axis-labels, writing out to
C                      PostScript file
C
C----------------------------------------------------------------------+---

      SUBROUTINE AXES(XLIM1,XLIM2,YLIM1,YLIM2,NPTSX,NPTSY,XMIN,XMAX,
     -    YMIN,YMAX,SIZLAB,INTRLX,INTRLY,TSIZE,NUMBEX,NUMBEY,ZEROS,
     -    NOENDX,NOENDY,FULTIC)

      CHARACTER*5    LABEL
      INTEGER        IFROM, IMARK, INTRLX, INTRLY, IVALUE, NPTSX, NPTSY
      LOGICAL        FULTIC, NOENDX, NOENDY, NUMBEX, NUMBEY, ZEROS
      REAL           SIZLAB, TSIZE, UGAP, VALUE, VGAP, X, XCENTR, XGAP,
     -               XLIM1, XLIM2, XMAX, XMIN, X1, X2, Y, YCENTR, YGAP,
     -               YLIM1, YLIM2, YMAX, YMIN, Y1, Y2

C Routine parameters:-
C ------------------
C XLIM1, XLIM2, YLIM1, YLIM2 - x- and y-extent of graph area (ie coords
C          of graph-box). In PostScript coords.
C NPTSX, NPTSY - Numbers of ticks along x- and y-axes
C XMIN, XMAX, YMIN, YMAX - Minimum and maximum x- and y-values on plotted
C          axes
C SIZLAB - Label-size for numbers on the axis (in PostScript coords).
C INTRLX, INTRLY - Integer values indicating how the numbers on the axes
C          are to be formatted. (O=format as integer,1=format as real with
C          1 number after decimal point,2=real with 2 numbers after decimal
C          point.
C TSIZE  - A measure of the distance of axis labels from the axis (in
C          PostScript coords).
C NUMBEX, NUMBEY - Flags indicating whether numbers are actually required
C          on the x- and y-axes
C ZEROS  - Flag indicating whether zero value on the y-axis is required
C NOEND  - Flag indicating whether the last numbers on the x- and y-axes
C          are required
C FULTIC - Flag indicating whether axis ticks are to be full-ticks,
C          extending a little to the other side of the axis, or half-ticks
C          only.

C---- Initialise variables
      IF (NPTSX.GT.0) THEN
          XGAP = (XLIM2 - XLIM1) / NPTSX
          UGAP = (XMAX - XMIN) / NPTSX
      ENDIF
      IF (NPTSY.GT.0) THEN
          YGAP = (YLIM2 - YLIM1) / NPTSY
          VGAP = (YMAX - YMIN) / NPTSY
      ENDIF
      XCENTR = (XLIM1 + XLIM2) / 2.0
      YCENTR = (YLIM1 + YLIM2) / 2.0

C---- Draw box round graph
      CALL PSLWID(0.6)
      CALL PSLINE(XLIM1,YLIM1,XLIM1,YLIM2)
      CALL PSLINE(XLIM1,YLIM2,XLIM2,YLIM2)
      CALL PSLINE(XLIM2,YLIM2,XLIM2,YLIM1)
      CALL PSLINE(XLIM2,YLIM1,XLIM1,YLIM1)

C---- x-axis point markers and labels
      X = XLIM1
      Y = YLIM1 - TSIZE / 2.0
      IF (NPTSX.GT.0) THEN
          DO 100, IMARK = 1, NPTSX + 1
              VALUE = XMIN + (IMARK - 1) * UGAP
              IF (VALUE.GE.0.0) THEN
                  IVALUE = VALUE + 0.5
              ELSE
                  IVALUE = VALUE - 0.5
              ENDIF
              IF (INTRLX.EQ.0) THEN
                  WRITE(LABEL,20) IVALUE
 20               FORMAT(I5)
              ELSE IF (INTRLX.EQ.1) THEN
                  WRITE(LABEL,40) VALUE
 40               FORMAT(F5.1)
              ELSE IF (INTRLX.EQ.2) THEN
                  WRITE(LABEL,60) VALUE
 60               FORMAT(F5.2)
              ENDIF
              IFROM = 1
              IF (LABEL(1:1).EQ.' ') IFROM = 2
              IF (LABEL(2:2).EQ.' ') IFROM = 3
              IF (LABEL(3:3).EQ.' ') IFROM = 4
              IF (LABEL(4:4).EQ.' ') IFROM = 5
              IF (NUMBEX) THEN
                  IF (.NOT.(NOENDX .AND. IMARK.EQ.NPTSX + 1)) THEN
                      Y1 = YLIM1
                      Y2 = YLIM1 - SIZLAB / 3.0
                      IF (FULTIC) Y1 = Y1 + SIZLAB / 6.0
                      CALL PSCTXT(X,Y,SIZLAB,LABEL(IFROM:5))
                      CALL PSLINE(X,Y1,X,Y2)
                  ENDIF
              ENDIF
              X = X + XGAP
 100      CONTINUE
      ENDIF

C---- y-axis point markers and labels
      X = XLIM1 - TSIZE
      Y = YLIM1
      IF (NPTSY.GT.0) THEN
          DO 200, IMARK = 1, NPTSY + 1
              VALUE = YMIN + (IMARK - 1) * VGAP
              IF (VALUE.GE.0.0) THEN
                  IVALUE = VALUE + 0.5
              ELSE
                  IVALUE = VALUE - 0.5
              ENDIF
              IF (INTRLY.EQ.0) THEN
                  WRITE(LABEL,20) IVALUE
              ELSE IF (INTRLY.EQ.1) THEN
                  WRITE(LABEL,40) VALUE
              ELSE
                  WRITE(LABEL,60) VALUE
              ENDIF
              IFROM = 1
              IF (NUMBEY .AND. (ZEROS .OR. IMARK.GT.1)) THEN
                  IF (.NOT.(NOENDY .AND. IMARK.EQ.NPTSY + 1)) THEN
                      X1 = XLIM1 - SIZLAB / 3.0
                      X2 = XLIM1
                      IF (FULTIC) X2 = X2 + SIZLAB / 6.0
                      CALL PSCTXT(X,Y,SIZLAB,LABEL(1:5))
                      CALL PSLINE(X1,Y,X2,Y)
                  ENDIF
              ENDIF
              Y = Y + YGAP
 200      CONTINUE
      ENDIF

      RETURN
      END

C==========================================================================
C-----------------------------------------------------------------------
C
C      SUBROUTINE PSBOX
C
C-----------------------------------------------------------------------
      SUBROUTINE PSBOX (XL,XR,YL,YH)
      REAL*4 XL,XR,YL,YH

      CALL PSLINE (XL,YH,XR,YH)
      CALL PSLINE (XR,YH,XR,YL)
      CALL PSLINE (XR,YL,XL,YL)
      CALL PSLINE (XL,YL,XL,YH)
      RETURN
      END
