C ******
      SUBROUTINE WBLOCK_MEM(MT,IBLOCK,NW,IPOOL,IERR)
C
C -P- WBLOCK - writes (unformatted) data block to file 
C
C     input : NW - number of wolds(4-bytes) that they will be written to MT
C                  from IBLOCK
C             IBLOCK - integer array
C     output : IERR - 0  normal end
C                     1  error
CMS    : IBLOCK
      PARAMETER ( NWMAX= 512 )
      INTEGER*4 MT,NW,IBLOCK(*),IERR
C ******
      INTEGER*4         IPOOL(*)
      COMMON/COM_DPOOL/ IPOOL_MAX,IPOOL_CURR
C ---------------------------------------------------------------------
      MDOC=0
      IERR=0
      IF(MT.EQ.0) RETURN
      IF(NW.LE.0) THEN
        CALL MSGERR(MDOC,' ERR IN WBLOCK_MEM: WRONG NUMBER WORDS')
        IERR=1
        RETURN
      ENDIF
      NW0=0
      NW1=1
10    NW2=NW0+NWMAX
      IF(NW2.GT.NW) THEN
        NWW=NW-NW0
      ELSE
        NWW=NWMAX
      ENDIF
      NW0=NW0+NWW
C N    CALL WFILE(MT,0,IBLOCK(NW1),-1,NWW)
C N    IF(ERRCODE.NE.0) GO TO 9
C 
      II0=NW1-1
      IF(IPOOL_MAX.GT.0) THEN
        IF((IPOOL_CURR + NWW).GT.IPOOL_MAX) GO TO 8  
        DO II=1,NWW
          IPOOL(IPOOL_CURR + II) = IBLOCK(II0+II) 
        ENDDO
        IPOOL_CURR = IPOOL_CURR + NWW
      ELSE    
        WRITE(MT,ERR=9) (IBLOCK(II0+II),II=1,NWW)
      ENDIF
      NW1=NW1+NWW
      IF(NW1.LE.NW) GO TO 10
      RETURN
C -------------------------
    9 CONTINUE
      CALL MSGERR(MDOC,' ERROR:  in WBLOCK_MEM: WRITE TO OUTPUT-FILE')
      IERR=1
      RETURN
   8  CONTINUE
      CALL MSGERR(MDOC,' ERROR: in WBLOCK_MEM: not memory enough')
      WRITE(*,*) 'IPOOL_CURR,IPOOL_MAX:',IPOOL_CURR,IPOOL_MAX
      WRITE(*,*) NW,NWW
      IERR=1
      RETURN
      END


      SUBROUTINE GET_SYMM(MDOC,NOSPGR,ISETT,SGNAME,NSYM,ISYM
     *                              ,MAXNSO,IERR)
C -------------------------------------------------------
C -P- GET_SYMM - generate cryst.symm. oparators from space group name or space
C -P-            group number.
C -------------------------------------------------------
      INTEGER   MDOC,IERR,MAXNSO
C --
      INTEGER*2 ISYM(5,3,MAXNSO)
      INTEGER   NOSPGR,ISETT,NSYM
      CHARACTER SGNAME*(*)
C -----------------------------------
      CHARACTER LINE*80
C -----------------------------------
      CHARACTER SG_TAB*24,SG_TAB1*24,SG_TAB2*24,OP*80
      INTEGER   III,I,IS,NSS,NSYMR,N,LENS,LEN
      INTEGER   NO_CCP4,NO_TAB,NS_TAB,NSG,L
C -------------------------------------------------------
      IERR = 0
      M    = 99
C ------------------------------------
      NSYM = 0
C ------------------------------------
      CALL LENSTR_BL(SGNAME,LENS)
      IF(LENS.LE.0) THEN
        IF(NOSPGR.LE.0) THEN
C         default P1
          GO TO 100
        ELSE
C         --> use space group number
          GO TO 400
        ENDIF
      ENDIF
C ------------------------------------------
C     use space group name
C
      N = 0
      DO I=1,LENS
        IF(SGNAME(I:I).NE.' ') GO TO 600
        N = N + 1 
      ENDDO
  600 CONTINUE

      IF(N.GT.0) THEN
        DO I=1,LENS-N
          SGNAME(I:I) = SGNAME(I+N:I+N)
        ENDDO
        CALL LENSTR_BL(SGNAME,LENS)
      ENDIF
      IF(LENS.LT.2) GO TO 400

      IF(SGNAME.EQ.'A2')  SGNAME = 'A121'
      IF(SGNAME.EQ.'I2')  SGNAME = 'I121'
      IF(SGNAME.EQ.'P2')  SGNAME = 'P121'
      IF(SGNAME.EQ.'P21') SGNAME = 'P1211'
      IF(SGNAME.EQ.'I21') SGNAME = 'I1211'
      IF(SGNAME.EQ.'C21') SGNAME = 'C1211'
      IF(SGNAME.EQ.'C2')  SGNAME = 'C121'
      IF(SGNAME.EQ.'B2')  SGNAME = 'B112'

      CALL LENSTR_BL(SGNAME,LENS)
C -----------------------------------------
      III = 0
  300 CONTINUE

      III = III + 1
      IS  = 0
      CALL GET_SPACE_GROUP_INFO(III,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB,SG_TAB1,SG_TAB2,OP,IERR)
      IF(IERR.NE.0) GO TO 400

C     space group number
      NO_CCP4 = NO_TAB 
C     number of symmetry operators
      NSYM    = NS_TAB
C     space group name

      CALL LENSTR_BL(SG_TAB,LEN)
      IF(LEN.GT.0) THEN
        IF(LENS.EQ.LEN.AND.SG_TAB(1:LENS).EQ.SGNAME(1:LENS)) GO TO 500
      ENDIF
      CALL LENSTR_BL(SG_TAB1,LEN)
      IF(LEN.GT.0) THEN
        IF(LENS.EQ.LEN.AND.SG_TAB1(1:LENS).EQ.SGNAME(1:LENS)) THEN
          CALL LENSTR_BL(SG_TAB,LEN)
          IF(LEN.GT.0) SGNAME = SG_TAB(1:LEN)
          GO TO 500
        ENDIF
      ENDIF
      CALL LENSTR_BL(SG_TAB2,LEN)
      IF(LEN.GT.0) THEN
        IF(LENS.EQ.LEN.AND.SG_TAB2(1:LENS).EQ.SGNAME(1:LENS)) THEN
          CALL LENSTR_BL(SG_TAB,LEN)
          IF(LEN.GT.0) SGNAME = SG_TAB(1:LEN)
          GO TO 500
        ENDIF
      ENDIF
      GO TO 300

C ----------------------------------------------------------
C     use space group number
C
  400 CONTINUE

C ----
      CALL NSG_STAND_TO_CCP4(NOSPGR,ISETT,NO_CCP4,IERR)
      IF(IERR.NE.0) GO TO 100      
      III = 0
  410 CONTINUE

      III = III + 1
      IS  = 0
      CALL GET_SPACE_GROUP_INFO(III,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB,SG_TAB1,SG_TAB2,OP,IERR)
      IF(IERR.NE.0) GO TO 100

C     space group number
      NSG    = NO_TAB
C     number of symmetry operators
      NSYM   = NS_TAB

      IF(NSG.EQ.NO_CCP4) THEN
        CALL LENSTR_BL(SG_TAB,LENR)
        SGNAME = SG_TAB(1:LENR)
        GO TO 500
      ENDIF  

      GO TO 410
C --------------------------------
 500  CONTINUE

      IF(NSYM.GT.MAXNSO) THEN
        WRITE(LINE,
     *  '('' ERROR: number of cryst. symmetry operators >'',I6)') 
     *  MAXNSO
        CALL MSGERR(MDOC,LINE)
        IERR=1
        GO TO 100
      ELSE IF(NSYM.LE.0) THEN
        WRITE(LINE,
     *  '('' ERROR: number of cryst. symmetry operators =< 0'')')
        CALL MSGERR(MDOC,LINE)
        IERR=1
        GO TO 100
      ENDIF

      NSYMR = NSYM   
      DO  IS=1,NSYM
        CALL GET_SPACE_GROUP_INFO(III,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB,SG_TAB1,SG_TAB2,OP,IERR)
        IF(IERR.NE.0) GO TO 100
        NSS   = IS
        CALL SYMFR_NB(MDOC,OP,NSS,NSYMR,ISYM,MAXNSO,IERR)
        IF(IERR.GT.0) RETURN
      ENDDO 

c      write(*,*) '--no_ccp4:',NO_CCP4,iii

      CALL NSG_CCP4_TO_STAND(NO_CCP4,NOSPGR,ISETT,IERR)

c      write(*,*) '-- No sg :',NOSPGR,ISETT
c      call LENSTR_BL(SGNAME,L)
c      write(*,*) '-sgname  :',SGNAME(1:L),'>'

      RETURN
C -----------------------------
 100  CONTINUE
      NOSPGR      = 1
      ISETT       = 1
      NSYM        = 1
      ISYM(1,1,1) = 1
      ISYM(2,1,1) = 0
      ISYM(3,1,1) = 0
      ISYM(4,1,1) = 0
      ISYM(5,1,1) = 1
      ISYM(1,2,1) = 0
      ISYM(2,2,1) = 1
      ISYM(3,2,1) = 0
      ISYM(4,2,1) = 0
      ISYM(5,2,1) = 1
      ISYM(1,3,1) = 0
      ISYM(2,3,1) = 0
      ISYM(3,3,1) = 1
      ISYM(4,3,1) = 0
      ISYM(5,3,1) = 1

      LINE = ' WARNING: can''t find space group name'
      CALL MSGERR(MDOC,LINE)
      CALL LENSTR_BL(SGNAME,L)
      IF(L.GT.0) THEN
        IF(L.GT.12) L = 12
      ELSE
        L      = 1
        SGNAME = ' '
      ENDIF 
      LINE = '              -->'//SGNAME(1:L)//'<--'
      CALL MSGERR(MDOC,LINE)
      CALL MSGERR(MDOC,'        default space group is "P 1"')

      SGNAME     = 'P 1'
      IERR=-1
      RETURN
      END


      SUBROUTINE GET_SPACE_GROUP_INFO(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IERR    = 0
      NO_TAB  =   0
      NS_TAB  =   0
      SG_TAB1 = ' '
      SG_TAB2 = ' '
      SG_TAB3 = ' '
      OP      = ' '
C ----
      IF(I.GE.  1.AND.I.LE.30) THEN
        CALL GET_SPACE_GROUP_INFO_1(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.31.AND.I.LE.62) THEN
        CALL GET_SPACE_GROUP_INFO_11(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.63.AND.I.LE.86) THEN
        CALL GET_SPACE_GROUP_INFO_12(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.87.AND.I.LE.114) THEN
        CALL GET_SPACE_GROUP_INFO_13(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.115.AND.I.LE.130) THEN
        CALL GET_SPACE_GROUP_INFO_14(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.131.AND.I.LE.145) THEN
        CALL GET_SPACE_GROUP_INFO_2(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.146.AND.I.LE.162) THEN
        CALL GET_SPACE_GROUP_INFO_21(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.163.AND.I.LE.188) THEN
        CALL GET_SPACE_GROUP_INFO_22(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.189.AND.I.LE.202) THEN
        CALL GET_SPACE_GROUP_INFO_23(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.203.AND.I.LE.215) THEN
        CALL GET_SPACE_GROUP_INFO_24(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.216.AND.I.LE.221) THEN
        CALL GET_SPACE_GROUP_INFO_3(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.222.AND.I.LE.226) THEN
        CALL GET_SPACE_GROUP_INFO_31(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.227.AND.I.LE.230) THEN
        CALL GET_SPACE_GROUP_INFO_32(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.231.AND.I.LE.235) THEN
        CALL GET_SPACE_GROUP_INFO_33(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.236.AND.I.LE.239) THEN
        CALL GET_SPACE_GROUP_INFO_34(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.240.AND.I.LE.243) THEN
        CALL GET_SPACE_GROUP_INFO_35(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.244.AND.I.LE.245) THEN
        CALL GET_SPACE_GROUP_INFO_4(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.246.AND.I.LE.246) THEN
        CALL GET_SPACE_GROUP_INFO_41(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.247.AND.I.LE.247) THEN
        CALL GET_SPACE_GROUP_INFO_42(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.248.AND.I.LE.248) THEN
        CALL GET_SPACE_GROUP_INFO_43(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.249.AND.I.LE.259) THEN
        CALL GET_SPACE_GROUP_INFO_44(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE
        NO_TAB  =    1
        NS_TAB  =    1
        SG_TAB1 = 'P 1'
        SG_TAB2 = 'P1'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IERR = 1
      ENDIF
C ----
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_1(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IERR    = 0
      NO_TAB  =   0
      NS_TAB  =   0
      SG_TAB1 = ' '
      SG_TAB2 = ' '
      SG_TAB3 = ' '
      OP      = ' '
C ----
      IF(I.EQ.  1) THEN
        NO_TAB  =    1
        NS_TAB  =    1
        SG_TAB1 = 'P 1'
        SG_TAB2 = 'P1'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        RETURN
      ENDIF
      IF(I.EQ.  2) THEN
        NO_TAB  =    2
        NS_TAB  =    2
        SG_TAB1 = 'P -1'
        SG_TAB2 = 'P-1'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ.  3) THEN
        NO_TAB  =    3
        NS_TAB  =    2
        SG_TAB1 = 'P 1 2 1'
        SG_TAB2 = 'P121'
        SG_TAB3 = 'P 2'
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,Y,-Z'
        RETURN
      ENDIF 
      IF(I.EQ.  4) THEN
        NO_TAB  = 1003
        NS_TAB  =    2
        SG_TAB1 = 'P 1 1 2'
        SG_TAB2 = 'P112'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        RETURN
      ENDIF
      IF(I.EQ.  5) THEN
        NO_TAB  =    4
        NS_TAB  =    2
        SG_TAB1 = 'P 1 21 1'
        SG_TAB2 = 'P1211'
        SG_TAB3 = 'P 21'
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,Y+1/2,-Z'
        RETURN
      ENDIF
      IF(I.EQ.  6) THEN
        NO_TAB  = 3004
        NS_TAB  =    4
        SG_TAB1 = 'I 1 21 1'
        SG_TAB2 = 'I1211'
        SG_TAB3 = 'I 21'
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,1/2+Y,-Z'
        IF(IS.EQ.  3) OP =' X+1/2,Y+1/2,Z+1/2'
        IF(IS.EQ.  4) OP =' -X+1/2,Y,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.  7) THEN
        NO_TAB  = 1004
        NS_TAB  =    2
        SG_TAB1 = 'P 1 1 21'
        SG_TAB2 = 'P1121'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.  8) THEN
        NO_TAB  = 2005
        NS_TAB  =    4
        SG_TAB1 = 'A 2 1 1'
        SG_TAB2 = 'A211'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X, Y, Z'
        IF(IS.EQ.  2) OP =' X,-Y,-Z'
        IF(IS.EQ.  3) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ.  4) OP =' X,1/2-Y,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.  9) THEN
        NO_TAB  =    5
        NS_TAB  =    4
        SG_TAB1 = 'C 1 2 1'
        SG_TAB2 = 'C121'
        SG_TAB3 = 'C 2'
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,Y,-Z'
        IF(IS.EQ.  3) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.  4) OP =' 1/2-X,1/2+Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 10) THEN
        NO_TAB  = 4004
        NS_TAB  =    4
        SG_TAB1 = 'C 1 21 1'
        SG_TAB2 = 'C1211'
        SG_TAB3 = 'C 21'
        IF(IS.EQ.  1) OP =' X, Y, Z'
        IF(IS.EQ.  2) OP =' -X,1/2+Y,-Z'
        IF(IS.EQ.  3) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.  4) OP =' 1/2-X, Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 11) THEN
        NO_TAB  = 1005
        NS_TAB  =    4
        SG_TAB1 = 'B 1 1 2'
        SG_TAB2 = 'B112'
        SG_TAB3 = 'B 2'
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2+X,+Y,1/2+Z'
        IF(IS.EQ.  4) OP =' 1/2-X,-Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 12) THEN
        NO_TAB  =    6
        NS_TAB  =    2
        SG_TAB1 = 'P 1 m 1'
        SG_TAB2 = 'Pm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X,-Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 13) THEN
        NO_TAB  =    7
        NS_TAB  =    2
        SG_TAB1 = 'P 1 c 1'
        SG_TAB2 = 'Pc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X,-Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 14) THEN
        NO_TAB  =    8
        NS_TAB  =    4
        SG_TAB1 = 'C 1 m 1'
        SG_TAB2 = 'Cm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 15) THEN
        NO_TAB  =    9
        NS_TAB  =    4
        SG_TAB1 = 'C 1 c 1'
        SG_TAB2 = 'Cc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 16) THEN
        NO_TAB  =   10
        NS_TAB  =    4
        SG_TAB1 = 'P 1 2/m 1'
        SG_TAB2 = 'P2/m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' -X,-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 17) THEN
        NO_TAB  =   11
        NS_TAB  =    4
        SG_TAB1 = 'P 1 21/m 1'
        SG_TAB2 = 'P21/m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,1/2+Y,-Z'
        IF(IS.EQ.  3) OP =' -X,-Y,-Z'
        IF(IS.EQ.  4) OP =' X,1/2-Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 18) THEN
        NO_TAB  =   12
        NS_TAB  =    8
        SG_TAB1 = 'C 1 2/m 1'
        SG_TAB2 = 'C2/m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' -X,-Y,-Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.  7) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 19) THEN
        NO_TAB  =   13
        NS_TAB  =    4
        SG_TAB1 = 'P 1 2/c 1'
        SG_TAB2 = 'P2/c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  3) OP =' -X,-Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 20) THEN
        NO_TAB  =   14
        NS_TAB  =    4
        SG_TAB1 = 'P 1 21/c 1'
        SG_TAB2 = 'P21/c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,-Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' X,1/2-Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 21) THEN
        NO_TAB  =   15
        NS_TAB  =    8
        SG_TAB1 = 'C 1 2/c 1'
        SG_TAB2 = 'C2/c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  3) OP =' -X,-Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ.  7) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ.  8) OP =' 1/2+X,1/2-Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 22) THEN
        NO_TAB  =   16
        NS_TAB  =    4
        SG_TAB1 = 'P 2 2 2'
        SG_TAB2 = 'P222'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 23) THEN
        NO_TAB  =   17
        NS_TAB  =    4
        SG_TAB1 = 'P 2 2 21'
        SG_TAB2 = 'P2221'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 24) THEN
        NO_TAB  = 1017
        NS_TAB  =    4
        SG_TAB1 = 'P 21 2 2'
        SG_TAB2 = 'P2122'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,Y,-Z'
        IF(IS.EQ.  3) OP =' 1/2+X,-Y,-Z'
        IF(IS.EQ.  4) OP =' 1/2-X,-Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 25) THEN
        NO_TAB  = 2017
        NS_TAB  =    4
        SG_TAB1 = 'P 2 21 2'
        SG_TAB2 = 'P2212'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X,1/2-Y,-Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,-Z'
        IF(IS.EQ.  4) OP =' -X,-Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 26) THEN
        NO_TAB  =   18
        NS_TAB  =    4
        SG_TAB1 = 'P 21 21 2'
        SG_TAB2 = 'P21212'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 27) THEN
        NO_TAB  = 1018
        NS_TAB  =    4
        SG_TAB1 = 'P 21 21 2 (a)'
        SG_TAB2 = 'P21212a'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.  3) OP =' X+1/2,-Y,-Z'
        IF(IS.EQ.  4) OP =' -X,Y+1/2,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 28) THEN
        NO_TAB  = 2018
        NS_TAB  =    4
        SG_TAB1 = 'P 21 2 21'
        SG_TAB2 = 'P21221'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,Y,-Z'
        IF(IS.EQ.  3) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2-X,-Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 29) THEN
        NO_TAB  = 3018
        NS_TAB  =    4
        SG_TAB1 = 'P 2 21 21'
        SG_TAB2 = 'P22121'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X,-Y,-Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' -X,1/2-Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 30) THEN
        NO_TAB  =   19
        NS_TAB  =    4
        SG_TAB1 = 'P 21 21 21'
        SG_TAB2 = 'P212121'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        RETURN
      ENDIF
      RETURN
      END


      SUBROUTINE GET_SPACE_GROUP_INFO_11(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ. 31) THEN
        NO_TAB  =   20
        NS_TAB  =    8
        SG_TAB1 = 'C 2 2 21'
        SG_TAB2 = 'C2221'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ.  8) OP =' 1/2+X,1/2-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 32) THEN
        NO_TAB  = 1020
        NS_TAB  =    8
        SG_TAB1 = 'C 2 2 21 (a)'
        SG_TAB2 = 'C2221a'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  4) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.  6) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' X,-Y,-Z'
        IF(IS.EQ.  8) OP =' 1/2-X,Y,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ. 33) THEN
        NO_TAB  =   21
        NS_TAB  =    8
        SG_TAB1 = 'C 2 2 2'
        SG_TAB2 = 'C222'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.  7) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  8) OP =' 1/2+X,1/2-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 34) THEN
        NO_TAB  = 1021
        NS_TAB  =    8
        SG_TAB1 = 'C 2 2 2 (a)'
        SG_TAB2 = 'C222a'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.  3) OP =' X+1/2,-Y,-Z'
        IF(IS.EQ.  4) OP =' -X,Y+1/2,-Z'
        IF(IS.EQ.  5) OP =' 1/2+ X,1/2+Y,Z'
        IF(IS.EQ.  6) OP =' -X,-Y,Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,-Z'
        IF(IS.EQ.  8) OP =' 1/2-X,Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 35) THEN
        NO_TAB  =   22
        NS_TAB  =   16
        SG_TAB1 = 'F 2 2 2'
        SG_TAB2 = 'F222'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  8) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ.  9) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 12) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 15) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ. 16) OP =' 1/2+X,1/2-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 36) THEN
        NO_TAB  = 1022
        NS_TAB  =   16
        SG_TAB1 = 'F 2 2 2 (a)'
        SG_TAB2 = 'F222a'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.  3) OP =' X+1/2,-Y,-Z'
        IF(IS.EQ.  4) OP =' -X,Y+1/2,-Z'
        IF(IS.EQ.  5) OP =' X,Y+1/2,Z+1/2'
        IF(IS.EQ.  6) OP =' 1/2-X,-Y,Z+1/2'
        IF(IS.EQ.  7) OP =' X+1/2,-Y+1/2,-Z+1/2'
        IF(IS.EQ.  8) OP =' -X,Y,-Z+1/2'
        IF(IS.EQ.  9) OP =' X+1/2,Y,Z+1/2'
        IF(IS.EQ. 10) OP =' -X,1/2-Y,Z+1/2'
        IF(IS.EQ. 11) OP =' X,-Y,-Z+1/2'
        IF(IS.EQ. 12) OP =' -X+1/2,Y+1/2,-Z+1/2'
        IF(IS.EQ. 13) OP =' X+1/2,Y+1/2,Z'
        IF(IS.EQ. 14) OP =' -X,-Y,Z'
        IF(IS.EQ. 15) OP =' X,-Y+1/2,-Z'
        IF(IS.EQ. 16) OP =' -X+1/2,Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 37) THEN
        NO_TAB  =   23
        NS_TAB  =    8
        SG_TAB1 = 'I 2 2 2'
        SG_TAB2 = 'I222'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' X,-Y,-Z'
        IF(IS.EQ.  4) OP =' -X,Y,-Z'
        IF(IS.EQ.  5) OP =' X+1/2,Y+1/2,Z+1/2'
        IF(IS.EQ.  6) OP =' -X+1/2,-Y+1/2,Z+1/2'
        IF(IS.EQ.  7) OP =' X+1/2,-Y+1/2,-Z+1/2'
        IF(IS.EQ.  8) OP =' -X+1/2,Y+1/2,-Z+1/2'
        RETURN
      ENDIF
      IF(I.EQ. 38) THEN
        NO_TAB  = 1023
        NS_TAB  =    8
        SG_TAB1 = 'I 2 2 2 (a)'
        SG_TAB2 = 'I222a'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.  3) OP =' X+1/2,-Y,-Z'
        IF(IS.EQ.  4) OP =' -X,Y+1/2,-Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP ='  -X,-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ.  8) OP ='  X,1/2-Y,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ. 39) THEN
        NO_TAB  =   24
        NS_TAB  =    8
        SG_TAB1 = 'I 21 21 21'
        SG_TAB2 = 'I212121'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,1/2-Y,Z'
        IF(IS.EQ.  7) OP =' 1/2-X,Y,-Z'
        IF(IS.EQ.  8) OP =' X,-Y,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ. 40) THEN
        NO_TAB  =   25
        NS_TAB  =    4
        SG_TAB1 = 'P m m 2'
        SG_TAB2 = 'Pmm2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' X,-Y,Z'
        IF(IS.EQ.  4) OP =' -X,Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 41) THEN
        NO_TAB  =   26
        NS_TAB  =    4
        SG_TAB1 = 'P m c 21'
        SG_TAB2 = 'Pmc21'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  4) OP =' -X,Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 42) THEN
        NO_TAB  =   27
        NS_TAB  =    4
        SG_TAB1 = 'P c c 2'
        SG_TAB2 = 'Pcc2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  4) OP =' -X,Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 43) THEN
        NO_TAB  =   28
        NS_TAB  =    4
        SG_TAB1 = 'P m a 2'
        SG_TAB2 = 'Pma2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2+X,-Y,Z'
        IF(IS.EQ.  4) OP =' 1/2-X,Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 44) THEN
        NO_TAB  =   29
        NS_TAB  =    4
        SG_TAB1 = 'P c a 21'
        SG_TAB2 = 'Pca21'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' 1/2+X,-Y,Z'
        IF(IS.EQ.  4) OP =' 1/2-X,Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 45) THEN
        NO_TAB  =   30
        NS_TAB  =    4
        SG_TAB1 = 'P n c 2'
        SG_TAB2 = 'Pnc2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ.  4) OP =' -X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 46) THEN
        NO_TAB  =   31
        NS_TAB  =    4
        SG_TAB1 = 'P m n 21'
        SG_TAB2 = 'Pmn21'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' 1/2+X,-Y,1/2+Z'
        IF(IS.EQ.  4) OP =' -X,Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 47) THEN
        NO_TAB  =   32
        NS_TAB  =    4
        SG_TAB1 = 'P b a 2'
        SG_TAB2 = 'Pba2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.  4) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 48) THEN
        NO_TAB  =   33
        NS_TAB  =    4
        SG_TAB1 = 'P n a 21'
        SG_TAB2 = 'Pna21'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.  4) OP =' 1/2-X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 49) THEN
        NO_TAB  =   34
        NS_TAB  =    4
        SG_TAB1 = 'P n n 2'
        SG_TAB2 = 'Pnn2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ.  4) OP =' 1/2-X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 50) THEN
        NO_TAB  =   35
        NS_TAB  =    8
        SG_TAB1 = 'C m m 2'
        SG_TAB2 = 'Cmm2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' X,-Y,Z'
        IF(IS.EQ.  4) OP =' -X,Y,Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.  7) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 51) THEN
        NO_TAB  =   36
        NS_TAB  =    8
        SG_TAB1 = 'C m c 21'
        SG_TAB2 = 'Cmc21'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  4) OP =' -X,Y,Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 52) THEN
        NO_TAB  =   37
        NS_TAB  =    8
        SG_TAB1 = 'C c c 2'
        SG_TAB2 = 'Ccc2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  4) OP =' -X,Y,1/2+Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.  7) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 53) THEN
        NO_TAB  =   38
        NS_TAB  =    8
        SG_TAB1 = 'A m m 2'
        SG_TAB2 = 'Amm2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' X,-Y,Z'
        IF(IS.EQ.  4) OP =' -X,Y,Z'
        IF(IS.EQ.  5) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' -X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 54) THEN
        NO_TAB  =   39
        NS_TAB  =    8
        SG_TAB1 = 'A b m 2'
        SG_TAB2 = 'Abm2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' X,1/2-Y,Z'
        IF(IS.EQ.  4) OP =' -X,1/2+Y,Z'
        IF(IS.EQ.  5) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' -X,Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 55) THEN
        NO_TAB  =   40
        NS_TAB  =    8
        SG_TAB1 = 'A m a 2'
        SG_TAB2 = 'Ama2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2+X,-Y,Z'
        IF(IS.EQ.  4) OP =' 1/2-X,Y,Z'
        IF(IS.EQ.  5) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 56) THEN
        NO_TAB  =   41
        NS_TAB  =    8
        SG_TAB1 = 'A b a 2'
        SG_TAB2 = 'Aba2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.  4) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ.  5) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' 1/2+X,-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 57) THEN
        NO_TAB  =   42
        NS_TAB  =   16
        SG_TAB1 = 'F m m 2'
        SG_TAB2 = 'Fmm2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' X,-Y,Z'
        IF(IS.EQ.  4) OP =' -X,Y,Z'
        IF(IS.EQ.  5) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' -X,1/2+Y,1/2+Z'
        IF(IS.EQ.  9) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2+X,-Y,1/2+Z'
        IF(IS.EQ. 12) OP =' 1/2-X,Y,1/2+Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 15) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 16) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 58) THEN
        NO_TAB  =   43
        NS_TAB  =   16
        SG_TAB1 = 'F d d 2'
        SG_TAB2 = 'Fdd2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/4+X,1/4-Y,1/4+Z'
        IF(IS.EQ.  4) OP =' 1/4-X,1/4+Y,1/4+Z'
        IF(IS.EQ.  5) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' 1/4+X,3/4-Y,3/4+Z'
        IF(IS.EQ.  8) OP =' 1/4-X,3/4+Y,3/4+Z'
        IF(IS.EQ.  9) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 3/4+X,1/4-Y,3/4+Z'
        IF(IS.EQ. 12) OP =' 3/4-X,1/4+Y,3/4+Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 15) OP =' 3/4+X,3/4-Y,1/4+Z'
        IF(IS.EQ. 16) OP =' 3/4-X,3/4+Y,1/4+Z'
        RETURN
      ENDIF
      IF(I.EQ. 59) THEN
        NO_TAB  =   44
        NS_TAB  =    8
        SG_TAB1 = 'I m m 2'
        SG_TAB2 = 'Imm2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' X,-Y,Z'
        IF(IS.EQ.  4) OP =' -X,Y,Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 60) THEN
        NO_TAB  =   45
        NS_TAB  =    8
        SG_TAB1 = 'I b a 2'
        SG_TAB2 = 'Iba2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.  4) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' -X,Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 61) THEN
        NO_TAB  =   46
        NS_TAB  =    8
        SG_TAB1 = 'I m a 2'
        SG_TAB2 = 'Ima2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2+X,-Y,Z'
        IF(IS.EQ.  4) OP =' 1/2-X,Y,Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' -X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 62) THEN
        NO_TAB  =   47
        NS_TAB  =    8
        SG_TAB1 = 'P 2/m 2/m 2/m'
        SG_TAB2 = 'Pmmm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,-Z'
        IF(IS.EQ.  7) OP =' X,-Y,Z'
        IF(IS.EQ.  8) OP =' -X,Y,Z'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_12(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ. 63) THEN
        NO_TAB  =   48
        NS_TAB  =    8
        SG_TAB1 = 'P 2/n 2/n 2/n'
        SG_TAB2 = 'Pnnn'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ.  7) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 64) THEN
        NO_TAB  =   49
        NS_TAB  =    8
        SG_TAB1 = 'P 2/c 2/c 2/m'
        SG_TAB2 = 'Pccm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  4) OP =' X,-Y,1/2-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,-Z'
        IF(IS.EQ.  7) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' -X,Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 65) THEN
        NO_TAB  =   50
        NS_TAB  =    8
        SG_TAB1 = 'P 2/b 2/a 2/n'
        SG_TAB2 = 'Pban'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2+Y,-Z'
        IF(IS.EQ.  7) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 66) THEN
        NO_TAB  =   51
        NS_TAB  =    8
        SG_TAB1 = 'P 21/m 2/m 2/a'
        SG_TAB2 = 'Pmma'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,Y,-Z'
        IF(IS.EQ.  7) OP =' X,-Y,Z'
        IF(IS.EQ.  8) OP =' 1/2-X,Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 67) THEN
        NO_TAB  =   52
        NS_TAB  =    8
        SG_TAB1 = 'P 2/n 21/n 2/a'
        SG_TAB2 = 'Pnna'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,Y,-Z'
        IF(IS.EQ.  7) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' -X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 68) THEN
        NO_TAB  =   53
        NS_TAB  =    8
        SG_TAB1 = 'P 2/m 2/n 21/a'
        SG_TAB2 = 'Pmna'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ.  7) OP =' 1/2+X,-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' -X,Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 69) THEN
        NO_TAB  =   54
        NS_TAB  =    8
        SG_TAB1 = 'P 21/c 2/c 2/a'
        SG_TAB2 = 'Pcca'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,Y,-Z'
        IF(IS.EQ.  7) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 70) THEN
        NO_TAB  =   55
        NS_TAB  =    8
        SG_TAB1 = 'P 21/b 21/a 2/m'
        SG_TAB2 = 'Pbam'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,-Z'
        IF(IS.EQ.  7) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 71) THEN
        NO_TAB  =   56
        NS_TAB  =    8
        SG_TAB1 = 'P 21/c 21/c 2/n'
        SG_TAB2 = 'Pccn'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2+Y,-Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 72) THEN
        NO_TAB  =   57
        NS_TAB  =    8
        SG_TAB1 = 'P 2/b 21/c 21/m'
        SG_TAB2 = 'Pbcm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,1/2-Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' -X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 73) THEN
        NO_TAB  =   58
        NS_TAB  =    8
        SG_TAB1 = 'P 21/n 21/n 2/m'
        SG_TAB2 = 'Pnnm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,-Z'
        IF(IS.EQ.  7) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 74) THEN
        NO_TAB  =   59
        NS_TAB  =    8
        SG_TAB1 = 'P 21/m 21/m 2/n'
        SG_TAB2 = 'Pmmn'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-X,Y+1/2,-Z'
        IF(IS.EQ.  4) OP =' X+1/2,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ.  6) OP =' X+1/2,Y+1/2,-Z'
        IF(IS.EQ.  7) OP =' X,-Y,Z'
        IF(IS.EQ.  8) OP =' -X,Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 75) THEN
        NO_TAB  = 1059
        NS_TAB  =    8
        SG_TAB1 = 'P 21/m 21/m 2/n (2)'
        SG_TAB2 = 'Pmmn2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X+1/2,Y+1/2,-Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,Z'
        IF(IS.EQ.  8) OP =' 1/2-X,Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 76) THEN
        NO_TAB  =   60
        NS_TAB  =    8
        SG_TAB1 = 'P 21/b 2/c 21/n'
        SG_TAB2 = 'Pbcn'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ.  7) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 77) THEN
        NO_TAB  =   61
        NS_TAB  =    8
        SG_TAB1 = 'P 21/b 21/c 21/a'
        SG_TAB2 = 'Pbca'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 78) THEN
        NO_TAB  =   62
        NS_TAB  =    8
        SG_TAB1 = 'P 21/n 21/m 21/a'
        SG_TAB2 = 'Pnma'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X+1/2,-Y,Z+1/2'
        IF(IS.EQ.  3) OP =' -X,Y+1/2,-Z'
        IF(IS.EQ.  4) OP =' X+1/2,-Y+1/2,-Z+1/2'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X+1/2,Y,-Z+1/2'
        IF(IS.EQ.  7) OP =' X,-Y+1/2,Z'
        IF(IS.EQ.  8) OP =' -X+1/2,Y+1/2,Z+1/2'
        RETURN
      ENDIF
      IF(I.EQ. 79) THEN
        NO_TAB  =   63
        NS_TAB  =   16
        SG_TAB1 = 'C 2/m 2/c 21/m'
        SG_TAB2 = 'Cmcm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,1/2-Z'
        IF(IS.EQ.  7) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' -X,Y,Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ. 12) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 80) THEN
        NO_TAB  =   64
        NS_TAB  =   16
        SG_TAB1 = 'C 2/m 2/c 21/a'
        SG_TAB2 = 'Cmca'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,1/2+Y,1/2-Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' -X,Y,Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 10) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 12) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2+X,-Y,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 81) THEN
        NO_TAB  =   65
        NS_TAB  =   16
        SG_TAB1 = 'C 2/m 2/m 2/m'
        SG_TAB2 = 'Cmmm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,-Z'
        IF(IS.EQ.  7) OP =' X,-Y,Z'
        IF(IS.EQ.  8) OP =' -X,Y,Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 11) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ. 12) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,1/2+Y,-Z'
        IF(IS.EQ. 15) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 16) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 82) THEN
        NO_TAB  =   66
        NS_TAB  =   16
        SG_TAB1 = 'C 2/c 2/c 2/m'
        SG_TAB2 = 'Cccm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  4) OP =' X,-Y,1/2-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,-Z'
        IF(IS.EQ.  7) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' -X,Y,1/2+Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 11) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ. 12) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,1/2+Y,-Z'
        IF(IS.EQ. 15) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2-X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 83) THEN
        NO_TAB  =   67
        NS_TAB  =   16
        SG_TAB1 = 'C 2/m 2/m 2/a'
        SG_TAB2 = 'Cmma'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,1/2-Y,Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,1/2+Y,-Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,Z'
        IF(IS.EQ.  8) OP =' -X,Y,Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 10) OP =' 1/2-X,-Y,Z'
        IF(IS.EQ. 11) OP =' 1/2-X,Y,-Z'
        IF(IS.EQ. 12) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,Y,-Z'
        IF(IS.EQ. 15) OP =' 1/2+X,-Y,Z'
        IF(IS.EQ. 16) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 84) THEN
        NO_TAB  =   68
        NS_TAB  =   16
        SG_TAB1 = 'C 2/c 2/c 2/a'
        SG_TAB2 = 'Ccca'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,1/2-Y,1/2-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,Y,1/2+Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 10) OP =' -X,-Y,Z'
        IF(IS.EQ. 11) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ. 12) OP =' X,-Y,-Z'
        IF(IS.EQ. 13) OP =' 1/2-X,-Y,1/2-Z'
        IF(IS.EQ. 14) OP =' X,1/2+Y,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2+X,-Y,1/2+Z'
        IF(IS.EQ. 16) OP =' -X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 85) THEN
        NO_TAB  =   69
        NS_TAB  =   32
        SG_TAB1 = 'F 2/m 2/m 2/m'
        SG_TAB2 = 'Fmmm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,-Z'
        IF(IS.EQ.  7) OP =' X,-Y,Z'
        IF(IS.EQ.  8) OP =' -X,Y,Z'
        IF(IS.EQ.  9) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ. 12) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ. 13) OP =' -X,1/2-Y,1/2-Z'
        IF(IS.EQ. 14) OP =' X,1/2+Y,1/2-Z'
        IF(IS.EQ. 15) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ. 16) OP =' -X,1/2+Y,1/2+Z'
        IF(IS.EQ. 17) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 18) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 19) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 20) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ. 21) OP =' 1/2-X,-Y,1/2-Z'
        IF(IS.EQ. 22) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ. 23) OP =' 1/2+X,-Y,1/2+Z'
        IF(IS.EQ. 24) OP =' 1/2-X,Y,1/2+Z'
        IF(IS.EQ. 25) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 26) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 27) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ. 28) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 29) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ. 30) OP =' 1/2+X,1/2+Y,-Z'
        IF(IS.EQ. 31) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 32) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 86) THEN
        NO_TAB  =   70
        NS_TAB  =   32
        SG_TAB1 = 'F 2/d 2/d 2/d'
        SG_TAB2 = 'Fddd'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' 1/4-X,1/4-Y,1/4-Z'
        IF(IS.EQ.  6) OP =' 1/4+X,1/4+Y,1/4-Z'
        IF(IS.EQ.  7) OP =' 1/4+X,1/4-Y,1/4+Z'
        IF(IS.EQ.  8) OP =' 1/4-X,1/4+Y,1/4+Z'
        IF(IS.EQ.  9) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ. 12) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/4-X,3/4-Y,3/4-Z'
        IF(IS.EQ. 14) OP =' 1/4+X,3/4+Y,3/4-Z'
        IF(IS.EQ. 15) OP =' 1/4+X,3/4-Y,3/4+Z'
        IF(IS.EQ. 16) OP =' 1/4-X,3/4+Y,3/4+Z'
        IF(IS.EQ. 17) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 18) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 19) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 20) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ. 21) OP =' 3/4-X,1/4-Y,3/4-Z'
        IF(IS.EQ. 22) OP =' 3/4+X,1/4+Y,3/4-Z'
        IF(IS.EQ. 23) OP =' 3/4+X,1/4-Y,3/4+Z'
        IF(IS.EQ. 24) OP =' 3/4-X,1/4+Y,3/4+Z'
        IF(IS.EQ. 25) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 26) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 27) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ. 28) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 29) OP =' 3/4-X,3/4-Y,1/4-Z'
        IF(IS.EQ. 30) OP =' 3/4+X,3/4+Y,1/4-Z'
        IF(IS.EQ. 31) OP =' 3/4+X,3/4-Y,1/4+Z'
        IF(IS.EQ. 32) OP =' 3/4-X,3/4+Y,1/4+Z'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_13(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ. 87) THEN
        NO_TAB  =   71
        NS_TAB  =   16
        SG_TAB1 = 'I 2/m 2/m 2/m'
        SG_TAB2 = 'Immm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,-Z'
        IF(IS.EQ.  7) OP =' X,-Y,Z'
        IF(IS.EQ.  8) OP =' -X,Y,Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ. 12) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2-X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 88) THEN
        NO_TAB  =   72
        NS_TAB  =   16
        SG_TAB1 = 'I 2/b 2/a 2/m'
        SG_TAB2 = 'Ibam'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,-Z'
        IF(IS.EQ.  7) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' -X,Y,1/2-Z'
        IF(IS.EQ. 12) OP =' X,-Y,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 15) OP =' X,-Y,1/2+Z'
        IF(IS.EQ. 16) OP =' -X,Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 89) THEN
        NO_TAB  =   73
        NS_TAB  =   16
        SG_TAB1 = 'I 21/b 21/c 21/a'
        SG_TAB2 = 'Ibca'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' -X,1/2-Y,Z'
        IF(IS.EQ. 11) OP =' 1/2-X,Y,-Z'
        IF(IS.EQ. 12) OP =' X,-Y,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 14) OP =' X,1/2+Y,-Z'
        IF(IS.EQ. 15) OP =' 1/2+X,-Y,Z'
        IF(IS.EQ. 16) OP =' -X,Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 90) THEN
        NO_TAB  =   74
        NS_TAB  =   16
        SG_TAB1 = 'I 21/m 21/m 21/a'
        SG_TAB2 = 'Imma'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,1/2-Y,Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,1/2+Y,-Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,Z'
        IF(IS.EQ.  8) OP =' -X,Y,Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 12) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2+X,-Y,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2-X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 91) THEN
        NO_TAB  =   75
        NS_TAB  =    4
        SG_TAB1 = 'P 4'
        SG_TAB2 = 'P4'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        RETURN
      ENDIF
      IF(I.EQ. 92) THEN
        NO_TAB  =   76
        NS_TAB  =    4
        SG_TAB1 = 'P 41'
        SG_TAB2 = 'P41'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -Y,X,1/4+Z'
        IF(IS.EQ.  4) OP =' Y,-X,3/4+Z'
        RETURN
      ENDIF
      IF(I.EQ. 93) THEN
        NO_TAB  =   77
        NS_TAB  =    4
        SG_TAB1 = 'P 42'
        SG_TAB2 = 'P42'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,1/2+Z'
        IF(IS.EQ.  4) OP =' Y,-X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 94) THEN
        NO_TAB  =   78
        NS_TAB  =    4
        SG_TAB1 = 'P 43'
        SG_TAB2 = 'P43'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -Y,X,3/4+Z'
        IF(IS.EQ.  4) OP =' Y,-X,1/4+Z'
        RETURN
      ENDIF
      IF(I.EQ. 95) THEN
        NO_TAB  =   79
        NS_TAB  =    8
        SG_TAB1 = 'I 4'
        SG_TAB2 = 'I4'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2+Y,1/2-X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 96) THEN
        NO_TAB  =   80
        NS_TAB  =    8
        SG_TAB1 = 'I 41'
        SG_TAB2 = 'I41'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -Y,1/2+X,1/4+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,-X,3/4+Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,-Y,Z'
        IF(IS.EQ.  7) OP =' 1/2-Y,X,3/4+Z'
        IF(IS.EQ.  8) OP =' Y,1/2-X,1/4+Z'
        RETURN
      ENDIF
      IF(I.EQ. 97) THEN
        NO_TAB  =   81
        NS_TAB  =    4
        SG_TAB1 = 'P -4'
        SG_TAB2 = 'P-4'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' Y,-X,-Z'
        IF(IS.EQ.  4) OP =' -Y,X,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 98) THEN
        NO_TAB  =   82
        NS_TAB  =    8
        SG_TAB1 = 'I -4'
        SG_TAB2 = 'I-4'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' Y,-X,-Z'
        IF(IS.EQ.  4) OP =' -Y,X,-Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ.  8) OP =' 1/2-Y,1/2+X,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ. 99) THEN
        NO_TAB  =   83
        NS_TAB  =    8
        SG_TAB1 = 'P 4/m'
        SG_TAB2 = 'P4/m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,-Z'
        IF(IS.EQ.  7) OP =' Y,-X,-Z'
        IF(IS.EQ.  8) OP =' -Y,X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.100) THEN
        NO_TAB  =   84
        NS_TAB  =    8
        SG_TAB1 = 'P 42/m'
        SG_TAB2 = 'P42/m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,1/2+Z'
        IF(IS.EQ.  4) OP =' Y,-X,1/2+Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,-Z'
        IF(IS.EQ.  7) OP =' Y,-X,1/2-Z'
        IF(IS.EQ.  8) OP =' -Y,X,1/2-Z'
        RETURN
      ENDIF   
      IF(I.EQ.101) THEN
        NO_TAB  =   85
        NS_TAB  =    8
        SG_TAB1 = 'P 4/n'
        SG_TAB2 = 'P4/n'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2+Y,-Z'
        IF(IS.EQ.  7) OP =' Y,-X,-Z'
        IF(IS.EQ.  8) OP =' -Y,X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.102) THEN
        NO_TAB  =   86
        NS_TAB  =    8
        SG_TAB1 = 'P 42/n'
        SG_TAB2 = 'P42/n'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ.  7) OP =' Y,-X,-Z'
        IF(IS.EQ.  8) OP =' -Y,X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.103) THEN
        NO_TAB  =   87
        NS_TAB  =   16
        SG_TAB1 = 'I 4/m'
        SG_TAB2 = 'I4/m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,-Z'
        IF(IS.EQ.  7) OP =' Y,-X,-Z'
        IF(IS.EQ.  8) OP =' -Y,X,-Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ. 12) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 16) OP =' 1/2-Y,1/2+X,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.104) THEN
        NO_TAB  =   88
        NS_TAB  =   16
        SG_TAB1 = 'I 41/a'
        SG_TAB2 = 'I41/a'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -Y,1/2+X,1/4+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,-X,3/4+Z'
        IF(IS.EQ.  5) OP =' -X,1/2-Y,1/4-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,Y,3/4-Z'
        IF(IS.EQ.  7) OP =' Y,-X,-Z'
        IF(IS.EQ.  8) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' -X,-Y,Z'
        IF(IS.EQ. 11) OP =' 1/2-Y,X,3/4+Z'
        IF(IS.EQ. 12) OP =' Y,1/2-X,1/4+Z'
        IF(IS.EQ. 13) OP =' 1/2-X,-Y,3/4-Z'
        IF(IS.EQ. 14) OP =' X,1/2+Y,1/4-Z'
        IF(IS.EQ. 15) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 16) OP =' -Y,X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.105) THEN
        NO_TAB  =   89
        NS_TAB  =    8
        SG_TAB1 = 'P 4 2 2'
        SG_TAB2 = 'P422'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.106) THEN
        NO_TAB  =   90
        NS_TAB  =    8
        SG_TAB1 = 'P 4 21 2'
        SG_TAB2 = 'P4212'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.107) THEN
        NO_TAB  =   91
        NS_TAB  =    8
        SG_TAB1 = 'P 41 2 2'
        SG_TAB2 = 'P4122'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -Y,X,1/4+Z'
        IF(IS.EQ.  4) OP =' Y,-X,3/4+Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' Y,X,3/4-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,1/4-Z'
        RETURN
      ENDIF
      IF(I.EQ.108) THEN
        NO_TAB  =   92
        NS_TAB  =    8
        SG_TAB1 = 'P 41 21 2'
        SG_TAB2 = 'P41212'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,1/4+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,3/4+Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,1/4-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,3/4-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.109) THEN
        NO_TAB  =   93
        NS_TAB  =    8
        SG_TAB1 = 'P 42 2 2'
        SG_TAB2 = 'P4222'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,1/2+Z'
        IF(IS.EQ.  4) OP =' Y,-X,1/2+Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,-Z'
        IF(IS.EQ.  7) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.110) THEN
        NO_TAB  =   94
        NS_TAB  =    8
        SG_TAB1 = 'P 42 21 2'
        SG_TAB2 = 'P42212'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.111) THEN
        NO_TAB  = 1094
        NS_TAB  =    8
        SG_TAB1 = 'P 42 21 2 (a)'
        SG_TAB2 = 'P42212a'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X+1/2,1/2+Z'
        IF(IS.EQ.  4) OP =' Y+1/2,-X,1/2+Z'
        IF(IS.EQ.  5) OP =' -X,Y+1/2,-Z'
        IF(IS.EQ.  6) OP =' X+1/2,-Y,-Z'
        IF(IS.EQ.  7) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  8) OP =' 1/2-Y,1/2-X,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.112) THEN
        NO_TAB  =   95
        NS_TAB  =    8
        SG_TAB1 = 'P 43 2 2'
        SG_TAB2 = 'P4322'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -Y,X,3/4+Z'
        IF(IS.EQ.  4) OP =' Y,-X,1/4+Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' Y,X,1/4-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,3/4-Z'
        RETURN
      ENDIF
      IF(I.EQ.113) THEN
        NO_TAB  =   96
        NS_TAB  =    8
        SG_TAB1 = 'P 43 21 2'
        SG_TAB2 = 'P43212'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,3/4+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,1/4+Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,3/4-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,1/4-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.114) THEN
        NO_TAB  =   97
        NS_TAB  =   16
        SG_TAB1 = 'I 4 2 2'
        SG_TAB2 = 'I422'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ. 12) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ. 16) OP =' 1/2-Y,1/2-X,1/2-Z'
        RETURN
      ENDIF
      RETURN
      END


      SUBROUTINE GET_SPACE_GROUP_INFO_14(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.115) THEN
        NO_TAB  =   98
        NS_TAB  =   16
        SG_TAB1 = 'I 41 2 2'
        SG_TAB2 = 'I4122'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -Y,1/2+X,1/4+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,-X,3/4+Z'
        IF(IS.EQ.  5) OP =' 1/2-X,Y,3/4-Z'
        IF(IS.EQ.  6) OP =' X,1/2-Y,1/4-Z'
        IF(IS.EQ.  7) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' -X,-Y,Z'
        IF(IS.EQ. 11) OP =' 1/2-Y,X,3/4+Z'
        IF(IS.EQ. 12) OP =' Y,1/2-X,1/4+Z'
        IF(IS.EQ. 13) OP =' -X,1/2+Y,1/4-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,-Y,3/4-Z'
        IF(IS.EQ. 15) OP =' Y,X,-Z'
        IF(IS.EQ. 16) OP =' 1/2-Y,1/2-X,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.116) THEN
        NO_TAB  =   99
        NS_TAB  =    8
        SG_TAB1 = 'P 4 m m'
        SG_TAB2 = 'P4mm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' X,-Y,Z'
        IF(IS.EQ.  6) OP =' -X,Y,Z'
        IF(IS.EQ.  7) OP =' -Y,-X,Z'
        IF(IS.EQ.  8) OP =' Y,X,Z'
        RETURN
      ENDIF
      IF(I.EQ.117) THEN
        NO_TAB  =  100
        NS_TAB  =    8
        SG_TAB1 = 'P 4 b m'
        SG_TAB2 = 'P4bm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ.  7) OP =' 1/2-Y,1/2-X,Z'
        IF(IS.EQ.  8) OP =' 1/2+Y,1/2+X,Z'
        RETURN
      ENDIF
      IF(I.EQ.118) THEN
        NO_TAB  =  101
        NS_TAB  =    8
        SG_TAB1 = 'P 42 c m'
        SG_TAB2 = 'P42cm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,1/2+Z'
        IF(IS.EQ.  4) OP =' Y,-X,1/2+Z'
        IF(IS.EQ.  5) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,Y,1/2+Z'
        IF(IS.EQ.  7) OP =' -Y,-X,Z'
        IF(IS.EQ.  8) OP =' Y,X,Z'
        RETURN
      ENDIF
      IF(I.EQ.119) THEN
        NO_TAB  =  102
        NS_TAB  =    8
        SG_TAB1 = 'P 42 n m'
        SG_TAB2 = 'P42nm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ.  7) OP =' -Y,-X,Z'
        IF(IS.EQ.  8) OP =' Y,X,Z'
        RETURN
      ENDIF
      IF(I.EQ.120) THEN
        NO_TAB  =  103
        NS_TAB  =    8
        SG_TAB1 = 'P 4 c c'
        SG_TAB2 = 'P4cc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,Y,1/2+Z'
        IF(IS.EQ.  7) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ.  8) OP =' Y,X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.121) THEN
        NO_TAB  =  104
        NS_TAB  =    8
        SG_TAB1 = 'P 4 n c'
        SG_TAB2 = 'P4nc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ.  7) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2+Y,1/2+X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.122) THEN
        NO_TAB  =  105
        NS_TAB  =    8
        SG_TAB1 = 'P 42 m c'
        SG_TAB2 = 'P42mc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,1/2+Z'
        IF(IS.EQ.  4) OP =' Y,-X,1/2+Z'
        IF(IS.EQ.  5) OP =' X,-Y,Z'
        IF(IS.EQ.  6) OP =' -X,Y,Z'
        IF(IS.EQ.  7) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ.  8) OP =' Y,X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.123) THEN
        NO_TAB  =  106
        NS_TAB  =    8
        SG_TAB1 = 'P 42 b c'
        SG_TAB2 = 'P42bc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,1/2+Z'
        IF(IS.EQ.  4) OP =' Y,-X,1/2+Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ.  7) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2+Y,1/2+X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.124) THEN
        NO_TAB  =  107
        NS_TAB  =   16
        SG_TAB1 = 'I 4 m m'
        SG_TAB2 = 'I4mm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' X,-Y,Z'
        IF(IS.EQ.  6) OP =' -X,Y,Z'
        IF(IS.EQ.  7) OP =' -Y,-X,Z'
        IF(IS.EQ.  8) OP =' Y,X,Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ. 12) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2+Y,1/2+X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.125) THEN
        NO_TAB  =  108
        NS_TAB  =   16
        SG_TAB1 = 'I 4 c m'
        SG_TAB2 = 'I4cm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,Y,1/2+Z'
        IF(IS.EQ.  7) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ.  8) OP =' Y,X,1/2+Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ. 12) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,1/2-X,Z'
        IF(IS.EQ. 16) OP =' 1/2+Y,1/2+X,Z'
        RETURN
      ENDIF
      IF(I.EQ.126) THEN
        NO_TAB  =  109
        NS_TAB  =   16
        SG_TAB1 = 'I 41 m d'
        SG_TAB2 = 'I41md'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -Y,1/2+X,1/4+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,-X,3/4+Z'
        IF(IS.EQ.  5) OP =' X,-Y,Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ.  7) OP =' -Y,1/2-X,1/4+Z'
        IF(IS.EQ.  8) OP =' 1/2+Y,X,3/4+Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' -X,-Y,Z'
        IF(IS.EQ. 11) OP =' 1/2-Y,X,3/4+Z'
        IF(IS.EQ. 12) OP =' Y,1/2-X,1/4+Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 14) OP =' -X,Y,Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,-X,3/4+Z'
        IF(IS.EQ. 16) OP =' Y,1/2+X,1/4+Z'
        RETURN
      ENDIF
      IF(I.EQ.127) THEN
        NO_TAB  =  110
        NS_TAB  =   16
        SG_TAB1 = 'I 41 c d'
        SG_TAB2 = 'I41cd'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -Y,1/2+X,1/4+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,-X,3/4+Z'
        IF(IS.EQ.  5) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ.  7) OP =' -Y,1/2-X,3/4+Z'
        IF(IS.EQ.  8) OP =' 1/2+Y,X,1/4+Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' -X,-Y,Z'
        IF(IS.EQ. 11) OP =' 1/2-Y,X,3/4+Z'
        IF(IS.EQ. 12) OP =' Y,1/2-X,1/4+Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 14) OP =' -X,Y,1/2+Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,-X,1/4+Z'
        IF(IS.EQ. 16) OP =' Y,1/2+X,3/4+Z'
        RETURN
      ENDIF
      IF(I.EQ.128) THEN
        NO_TAB  =  111
        NS_TAB  =    8
        SG_TAB1 = 'P -4 2 m'
        SG_TAB2 = 'P-42m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,-Z'
        IF(IS.EQ.  4) OP =' Y,-X,-Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,-Z'
        IF(IS.EQ.  7) OP =' -Y,-X,Z'
        IF(IS.EQ.  8) OP =' Y,X,Z'
        RETURN
      ENDIF
      IF(I.EQ.129) THEN
        NO_TAB  =  112
        NS_TAB  =    8
        SG_TAB1 = 'P -4 2 c'
        SG_TAB2 = 'P-42c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,-Z'
        IF(IS.EQ.  4) OP =' Y,-X,-Z'
        IF(IS.EQ.  5) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  6) OP =' X,-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ.  8) OP =' Y,X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.130) THEN
        NO_TAB  =  113
        NS_TAB  =    8
        SG_TAB1 = 'P -4 21 m'
        SG_TAB2 = 'P-421m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,-Z'
        IF(IS.EQ.  4) OP =' Y,-X,-Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  7) OP =' 1/2-Y,1/2-X,Z'
        IF(IS.EQ.  8) OP =' 1/2+Y,1/2+X,Z'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_2(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.131) THEN
        NO_TAB  =  114
        NS_TAB  =    8
        SG_TAB1 = 'P -4 21 c'
        SG_TAB2 = 'P-421c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,-Z'
        IF(IS.EQ.  4) OP =' Y,-X,-Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2+Y,1/2+X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.132) THEN
        NO_TAB  =  115
        NS_TAB  =    8
        SG_TAB1 = 'P -4 m 2'
        SG_TAB2 = 'P-4m2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' Y,-X,-Z'
        IF(IS.EQ.  4) OP =' -Y,X,-Z'
        IF(IS.EQ.  5) OP =' X,-Y,Z'
        IF(IS.EQ.  6) OP =' -X,Y,Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.133) THEN
        NO_TAB  =  116
        NS_TAB  =    8
        SG_TAB1 = 'P -4 c 2'
        SG_TAB2 = 'P-4c2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,-Z'
        IF(IS.EQ.  4) OP =' Y,-X,-Z'
        IF(IS.EQ.  5) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,Y,1/2+Z'
        IF(IS.EQ.  7) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.134) THEN
        NO_TAB  =  117
        NS_TAB  =    8
        SG_TAB1 = 'P -4 b 2'
        SG_TAB2 = 'P-4b2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,-Z'
        IF(IS.EQ.  4) OP =' Y,-X,-Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ.  7) OP =' 1/2+Y,1/2+X,-Z'
        IF(IS.EQ.  8) OP =' 1/2-Y,1/2-X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.135) THEN
        NO_TAB  =  118
        NS_TAB  =    8
        SG_TAB1 = 'P -4 n 2'
        SG_TAB2 = 'P-4n2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,-Z'
        IF(IS.EQ.  4) OP =' Y,-X,-Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ.  7) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ.  8) OP =' 1/2-Y,1/2-X,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.136) THEN
        NO_TAB  =  119
        NS_TAB  =   16
        SG_TAB1 = 'I -4 m 2'
        SG_TAB2 = 'I-4m2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,-Z'
        IF(IS.EQ.  4) OP =' Y,-X,-Z'
        IF(IS.EQ.  5) OP =' X,-Y,Z'
        IF(IS.EQ.  6) OP =' -X,Y,Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 12) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ. 15) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ. 16) OP =' 1/2-Y,1/2-X,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.137) THEN
        NO_TAB  =  120
        NS_TAB  =   16
        SG_TAB1 = 'I -4 c 2'
        SG_TAB2 = 'I-4c2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,-Z'
        IF(IS.EQ.  4) OP =' Y,-X,-Z'
        IF(IS.EQ.  5) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,Y,1/2+Z'
        IF(IS.EQ.  7) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,1/2-Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 12) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ. 15) OP =' 1/2+Y,1/2+X,-Z'
        IF(IS.EQ. 16) OP =' 1/2-Y,1/2-X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.138) THEN
        NO_TAB  =  121
        NS_TAB  =   16
        SG_TAB1 = 'I -4 2 m'
        SG_TAB2 = 'I-42m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,-Z'
        IF(IS.EQ.  4) OP =' Y,-X,-Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,-Z'
        IF(IS.EQ.  7) OP =' -Y,-X,Z'
        IF(IS.EQ.  8) OP =' Y,X,Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 12) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2+Y,1/2+X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.139) THEN
        NO_TAB  =  122
        NS_TAB  =   16
        SG_TAB1 = 'I -4 2 d'
        SG_TAB2 = 'I-42d'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,-Z'
        IF(IS.EQ.  4) OP =' Y,-X,-Z'
        IF(IS.EQ.  5) OP =' 1/2-X,Y,3/4-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,-Y,3/4-Z'
        IF(IS.EQ.  7) OP =' 1/2-Y,-X,3/4+Z'
        IF(IS.EQ.  8) OP =' 1/2+Y,X,3/4+Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 12) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 13) OP =' -X,1/2+Y,1/4-Z'
        IF(IS.EQ. 14) OP =' X,1/2-Y,1/4-Z'
        IF(IS.EQ. 15) OP =' -Y,1/2-X,1/4+Z'
        IF(IS.EQ. 16) OP =' Y,1/2+X,1/4+Z'
        RETURN
      ENDIF
      IF(I.EQ.140) THEN
        NO_TAB  =  123
        NS_TAB  =   16
        SG_TAB1 = 'P 4/m 2/m 2/m'
        SG_TAB2 = 'P4/mmm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        IF(IS.EQ.  9) OP =' -X,-Y,-Z'
        IF(IS.EQ. 10) OP =' X,Y,-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' -Y,X,-Z'
        IF(IS.EQ. 13) OP =' X,-Y,Z'
        IF(IS.EQ. 14) OP =' -X,Y,Z'
        IF(IS.EQ. 15) OP =' -Y,-X,Z'
        IF(IS.EQ. 16) OP =' Y,X,Z'
        RETURN
      ENDIF
      IF(I.EQ.141) THEN
        NO_TAB  =  124
        NS_TAB  =   16
        SG_TAB1 = 'P 4/m 2/c 2/c'
        SG_TAB2 = 'P4/mcc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  6) OP =' X,-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,1/2-Z'
        IF(IS.EQ.  9) OP =' -X,-Y,-Z'
        IF(IS.EQ. 10) OP =' X,Y,-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' -Y,X,-Z'
        IF(IS.EQ. 13) OP =' X,-Y,1/2+Z'
        IF(IS.EQ. 14) OP =' -X,Y,1/2+Z'
        IF(IS.EQ. 15) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ. 16) OP =' Y,X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.142) THEN
        NO_TAB  =  125
        NS_TAB  =   16
        SG_TAB1 = 'P 4/n 2/b 2/m'
        SG_TAB2 = 'P4/nbm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        IF(IS.EQ.  9) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ. 10) OP =' 1/2+X,1/2+Y,-Z'
        IF(IS.EQ. 11) OP =' 1/2+Y,1/2-X,-Z'
        IF(IS.EQ. 12) OP =' 1/2-Y,1/2+X,-Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,1/2-X,Z'
        IF(IS.EQ. 16) OP =' 1/2+Y,1/2+X,Z'
        RETURN
      ENDIF
      IF(I.EQ.143) THEN
        NO_TAB  =  126
        NS_TAB  =   16
        SG_TAB1 = 'P 4/n 2/n 2/c'
        SG_TAB2 = 'P4/nnc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        IF(IS.EQ.  9) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 10) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 11) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 12) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2+Y,1/2+X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.144) THEN
        NO_TAB  =  127
        NS_TAB  =   16
        SG_TAB1 = 'P 4/m 21/b 2/m'
        SG_TAB2 = 'P4/mbm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  7) OP =' 1/2+Y,1/2+X,-Z'
        IF(IS.EQ.  8) OP =' 1/2-Y,1/2-X,-Z'
        IF(IS.EQ.  9) OP =' -X,-Y,-Z'
        IF(IS.EQ. 10) OP =' X,Y,-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' -Y,X,-Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,1/2-X,Z'
        IF(IS.EQ. 16) OP =' 1/2+Y,1/2+X,Z'
        RETURN
      ENDIF
      IF(I.EQ.145) THEN
        NO_TAB  =  128
        NS_TAB  =   16
        SG_TAB1 = 'P 4/m 21/n 2/c'
        SG_TAB2 = 'P4/mnc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ.  8) OP =' 1/2-Y,1/2-X,1/2-Z'
        IF(IS.EQ.  9) OP =' -X,-Y,-Z'
        IF(IS.EQ. 10) OP =' X,Y,-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' -Y,X,-Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2+Y,1/2+X,1/2+Z'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_21(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.146) THEN
        NO_TAB  =  129
        NS_TAB  =   16
        SG_TAB1 = 'P 4/n 21/m 2/m'
        SG_TAB2 = 'P4/nmm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        IF(IS.EQ.  9) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ. 10) OP =' 1/2+X,1/2+Y,-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' -Y,X,-Z'
        IF(IS.EQ. 13) OP =' X,-Y,Z'
        IF(IS.EQ. 14) OP =' -X,Y,Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,1/2-X,Z'
        IF(IS.EQ. 16) OP =' 1/2+Y,1/2+X,Z'
        RETURN
      ENDIF
      IF(I.EQ.147) THEN
        NO_TAB  =  130
        NS_TAB  =   16
        SG_TAB1 = 'P 4/n 2/c 2/c'
        SG_TAB2 = 'P4/ncc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,1/2-Z'
        IF(IS.EQ.  9) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ. 10) OP =' 1/2+X,1/2+Y,-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' -Y,X,-Z'
        IF(IS.EQ. 13) OP =' X,-Y,1/2+Z'
        IF(IS.EQ. 14) OP =' -X,Y,1/2+Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2+Y,1/2+X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.148) THEN
        NO_TAB  =  131
        NS_TAB  =   16
        SG_TAB1 = 'P 42/m 2/m 2/c'
        SG_TAB2 = 'P42/mmc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,1/2+Z'
        IF(IS.EQ.  4) OP =' Y,-X,1/2+Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,-Z'
        IF(IS.EQ.  7) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,1/2-Z'
        IF(IS.EQ.  9) OP =' -X,-Y,-Z'
        IF(IS.EQ. 10) OP =' X,Y,-Z'
        IF(IS.EQ. 11) OP =' Y,-X,1/2-Z'
        IF(IS.EQ. 12) OP =' -Y,X,1/2-Z'
        IF(IS.EQ. 13) OP =' X,-Y,Z'
        IF(IS.EQ. 14) OP =' -X,Y,Z'
        IF(IS.EQ. 15) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ. 16) OP =' Y,X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.149) THEN
        NO_TAB  =  132
        NS_TAB  =   16
        SG_TAB1 = 'P 42/m 2/c 2/m'
        SG_TAB2 = 'P42/mcm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,1/2+Z'
        IF(IS.EQ.  4) OP =' Y,-X,1/2+Z'
        IF(IS.EQ.  5) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  6) OP =' X,-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        IF(IS.EQ.  9) OP =' -X,-Y,-Z'
        IF(IS.EQ. 10) OP =' X,Y,-Z'
        IF(IS.EQ. 11) OP =' Y,-X,1/2-Z'
        IF(IS.EQ. 12) OP =' -Y,X,1/2-Z'
        IF(IS.EQ. 13) OP =' X,-Y,1/2+Z'
        IF(IS.EQ. 14) OP =' -X,Y,1/2+Z'
        IF(IS.EQ. 15) OP =' -Y,-X,Z'
        IF(IS.EQ. 16) OP =' Y,X,Z'
        RETURN
      ENDIF
      IF(I.EQ.150) THEN
        NO_TAB  =  133
        NS_TAB  =   16
        SG_TAB1 = 'P 42/n 2/b 2/c'
        SG_TAB2 = 'P42/nbc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ.  5) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  6) OP =' X,-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' 1/2+Y,1/2+X,-Z'
        IF(IS.EQ.  8) OP =' 1/2-Y,1/2-X,-Z'
        IF(IS.EQ.  9) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 10) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' -Y,X,-Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ. 15) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ. 16) OP =' Y,X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.151) THEN
        NO_TAB  =  134
        NS_TAB  =   16
        SG_TAB1 = 'P 42/n 2/n 2/m'
        SG_TAB2 = 'P42/nnm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,-Z'
        IF(IS.EQ.  7) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ.  8) OP =' 1/2-Y,1/2-X,1/2-Z'
        IF(IS.EQ.  9) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 10) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' -Y,X,-Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ. 15) OP =' -Y,-X,Z'
        IF(IS.EQ. 16) OP =' Y,X,Z'
        RETURN
      ENDIF
      IF(I.EQ.152) THEN
        NO_TAB  =  135
        NS_TAB  =   16
        SG_TAB1 = 'P 42/m 21/b 2/c'
        SG_TAB2 = 'P42/mbc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,1/2+Z'
        IF(IS.EQ.  4) OP =' Y,-X,1/2+Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  7) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ.  8) OP =' 1/2-Y,1/2-X,1/2-Z'
        IF(IS.EQ.  9) OP =' -X,-Y,-Z'
        IF(IS.EQ. 10) OP =' X,Y,-Z'
        IF(IS.EQ. 11) OP =' Y,-X,1/2-Z'
        IF(IS.EQ. 12) OP =' -Y,X,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2+Y,1/2+X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.153) THEN
        NO_TAB  =  136
        NS_TAB  =   16
        SG_TAB1 = 'P 42/m 21/n 2/m'
        SG_TAB2 = 'P42/mnm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,X+1/2,Z+1/2'
        IF(IS.EQ.  4) OP =' Y+1/2,1/2-X,Z+1/2'
        IF(IS.EQ.  5) OP =' 1/2-X,Y+1/2,1/2-Z'
        IF(IS.EQ.  6) OP =' X+1/2,1/2-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        IF(IS.EQ.  9) OP =' -X,-Y,-Z'
        IF(IS.EQ. 10) OP =' X,Y,-Z'
        IF(IS.EQ. 11) OP =' Y+1/2,1/2-X,1/2-Z'
        IF(IS.EQ. 12) OP =' 1/2-Y,X+1/2,1/2-Z'
        IF(IS.EQ. 13) OP =' X+1/2,1/2-Y,Z+1/2'
        IF(IS.EQ. 14) OP =' 1/2-X,Y+1/2,Z+1/2'
        IF(IS.EQ. 15) OP =' -Y,-X,Z'
        IF(IS.EQ. 16) OP =' Y,X,Z'
        RETURN
      ENDIF
      IF(I.EQ.154) THEN
        NO_TAB  =  137
        NS_TAB  =   16
        SG_TAB1 = 'P 42/n 21/m 2/c'
        SG_TAB2 = 'P42/nmc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        IF(IS.EQ.  9) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 10) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' -Y,X,-Z'
        IF(IS.EQ. 13) OP =' X,-Y,Z'
        IF(IS.EQ. 14) OP =' -X,Y,Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2+Y,1/2+X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.155) THEN
        NO_TAB  =  138
        NS_TAB  =   16
        SG_TAB1 = 'P 42/n 21/c 2/m'
        SG_TAB2 = 'P42/ncm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  7) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,1/2-Z'
        IF(IS.EQ.  9) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 10) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' -Y,X,-Z'
        IF(IS.EQ. 13) OP =' X,-Y,1/2+Z'
        IF(IS.EQ. 14) OP =' -X,Y,1/2+Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,1/2-X,Z'
        IF(IS.EQ. 16) OP =' 1/2+Y,1/2+X,Z'
        RETURN
      ENDIF
      IF(I.EQ.156) THEN
        NO_TAB  =  139
        NS_TAB  =   32
        SG_TAB1 = 'I 4/m 2/m 2/m'
        SG_TAB2 = 'I4/mmm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        IF(IS.EQ.  9) OP =' -X,-Y,-Z'
        IF(IS.EQ. 10) OP =' X,Y,-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' -Y,X,-Z'
        IF(IS.EQ. 13) OP =' X,-Y,Z'
        IF(IS.EQ. 14) OP =' -X,Y,Z'
        IF(IS.EQ. 15) OP =' -Y,-X,Z'
        IF(IS.EQ. 16) OP =' Y,X,Z'
        IF(IS.EQ. 17) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 18) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 19) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ. 20) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ. 21) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ. 22) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ. 23) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ. 24) OP =' 1/2-Y,1/2-X,1/2-Z'
        IF(IS.EQ. 25) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 26) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 27) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 28) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 29) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 30) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ. 31) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 32) OP =' 1/2+Y,1/2+X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.157) THEN
        NO_TAB  =  140
        NS_TAB  =   32
        SG_TAB1 = 'I 4/m 2/c 2/m'
        SG_TAB2 = 'I4/mcm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  6) OP =' X,-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,1/2-Z'
        IF(IS.EQ.  9) OP =' -X,-Y,-Z'
        IF(IS.EQ. 10) OP =' X,Y,-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' -Y,X,-Z'
        IF(IS.EQ. 13) OP =' X,-Y,1/2+Z'
        IF(IS.EQ. 14) OP =' -X,Y,1/2+Z'
        IF(IS.EQ. 15) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ. 16) OP =' Y,X,1/2+Z'
        IF(IS.EQ. 17) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 18) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 19) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ. 20) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ. 21) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ. 22) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 23) OP =' 1/2+Y,1/2+X,-Z'
        IF(IS.EQ. 24) OP =' 1/2-Y,1/2-X,-Z'
        IF(IS.EQ. 25) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 26) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 27) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 28) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 29) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 30) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ. 31) OP =' 1/2-Y,1/2-X,Z'
        IF(IS.EQ. 32) OP =' 1/2+Y,1/2+X,Z'
        RETURN
      ENDIF
      IF(I.EQ.158) THEN
        NO_TAB  =  141
        NS_TAB  =   32
        SG_TAB1 = 'I 41/a 2/m 2/d'
        SG_TAB2 = 'I41/amd'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -Y,1/2+X,1/4+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,-X,3/4+Z'
        IF(IS.EQ.  5) OP =' 1/2-X,Y,3/4-Z'
        IF(IS.EQ.  6) OP =' X,1/2-Y,1/4-Z'
        IF(IS.EQ.  7) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        IF(IS.EQ.  9) OP =' -X,1/2-Y,1/4-Z'
        IF(IS.EQ. 10) OP =' 1/2+X,Y,3/4-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 14) OP =' -X,Y,Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,-X,3/4+Z'
        IF(IS.EQ. 16) OP =' Y,1/2+X,1/4+Z'
        IF(IS.EQ. 17) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 18) OP =' -X,-Y,Z'
        IF(IS.EQ. 19) OP =' 1/2-Y,X,3/4+Z'
        IF(IS.EQ. 20) OP =' Y,1/2-X,1/4+Z'
        IF(IS.EQ. 21) OP =' -X,1/2+Y,1/4-Z'
        IF(IS.EQ. 22) OP =' 1/2+X,-Y,3/4-Z'
        IF(IS.EQ. 23) OP =' Y,X,-Z'
        IF(IS.EQ. 24) OP =' 1/2-Y,1/2-X,1/2-Z'
        IF(IS.EQ. 25) OP =' 1/2-X,-Y,3/4-Z'
        IF(IS.EQ. 26) OP =' X,1/2+Y,1/4-Z'
        IF(IS.EQ. 27) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 28) OP =' -Y,X,-Z'
        IF(IS.EQ. 29) OP =' X,-Y,Z'
        IF(IS.EQ. 30) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ. 31) OP =' -Y,1/2-X,1/4+Z'
        IF(IS.EQ. 32) OP =' 1/2+Y,X,3/4+Z'
        RETURN
      ENDIF
      IF(I.EQ.159) THEN
        NO_TAB  =  142
        NS_TAB  =   32
        SG_TAB1 = 'I 41/a 2/c 2/d'
        SG_TAB2 = 'I41/acd'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -Y,1/2+X,1/4+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,-X,3/4+Z'
        IF(IS.EQ.  5) OP =' 1/2-X,Y,1/4-Z'
        IF(IS.EQ.  6) OP =' X,1/2-Y,3/4-Z'
        IF(IS.EQ.  7) OP =' 1/2+Y,1/2+X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,1/2-Z'
        IF(IS.EQ.  9) OP =' -X,1/2-Y,1/4-Z'
        IF(IS.EQ. 10) OP =' 1/2+X,Y,3/4-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 14) OP =' -X,Y,1/2+Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,-X,1/4+Z'
        IF(IS.EQ. 16) OP =' Y,1/2+X,3/4+Z'
        IF(IS.EQ. 17) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 18) OP =' -X,-Y,Z'
        IF(IS.EQ. 19) OP =' 1/2-Y,X,3/4+Z'
        IF(IS.EQ. 20) OP =' Y,1/2-X,1/4+Z'
        IF(IS.EQ. 21) OP =' -X,1/2+Y,3/4-Z'
        IF(IS.EQ. 22) OP =' 1/2+X,-Y,1/4-Z'
        IF(IS.EQ. 23) OP =' Y,X,1/2-Z'
        IF(IS.EQ. 24) OP =' 1/2-Y,1/2-X,-Z'
        IF(IS.EQ. 25) OP =' 1/2-X,-Y,3/4-Z'
        IF(IS.EQ. 26) OP =' X,1/2+Y,1/4-Z'
        IF(IS.EQ. 27) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 28) OP =' -Y,X,-Z'
        IF(IS.EQ. 29) OP =' X,-Y,1/2+Z'
        IF(IS.EQ. 30) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ. 31) OP =' -Y,1/2-X,3/4+Z'
        IF(IS.EQ. 32) OP =' 1/2+Y,X,1/4+Z'
        RETURN
      ENDIF
      IF(I.EQ.160) THEN
        NO_TAB  =  143
        NS_TAB  =    3
        SG_TAB1 = 'P 3'
        SG_TAB2 = 'P3'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        RETURN
      ENDIF
      IF(I.EQ.161) THEN
        NO_TAB  =  144
        NS_TAB  =    3
        SG_TAB1 = 'P 31'
        SG_TAB2 = 'P31'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z+1/3'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z+2/3'
        RETURN
      ENDIF
      IF(I.EQ.162) THEN
        NO_TAB  =  145
        NS_TAB  =    3
        SG_TAB1 = 'P 32'
        SG_TAB2 = 'P32'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z+2/3'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z+1/3'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_22(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.163) THEN
        NO_TAB  =  146
        NS_TAB  =    9
        SG_TAB1 = 'H 3'
        SG_TAB2 = 'H3'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' X+2/3,Y+1/3,Z+1/3'
        IF(IS.EQ.  5) OP =' -Y+2/3,X-Y+1/3,Z+1/3'
        IF(IS.EQ.  6) OP =' Y-X+2/3,-X+1/3,Z+1/3'
        IF(IS.EQ.  7) OP =' X+1/3,Y+2/3,Z+2/3'
        IF(IS.EQ.  8) OP =' -Y+1/3,X-Y+2/3,Z+2/3'
        IF(IS.EQ.  9) OP =' Y-X+1/3,-X+2/3,Z+2/3'
        RETURN
      ENDIF
      IF(I.EQ.164) THEN
        NO_TAB  = 1146
        NS_TAB  =    3
        SG_TAB1 = 'R 3'
        SG_TAB2 = 'R3'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' Z,X,Y'
        IF(IS.EQ.  3) OP =' Y,Z,X'
        RETURN
      ENDIF
      IF(I.EQ.165) THEN
        NO_TAB  =  147
        NS_TAB  =    6
        SG_TAB1 = 'P -3'
        SG_TAB2 = 'P-3'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,-Z'
        IF(IS.EQ.  6) OP =' X-Y,X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.166) THEN
        NO_TAB  =  148
        NS_TAB  =   18
        SG_TAB1 = 'R -3'
        SG_TAB2 = 'R-3'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,-Z'
        IF(IS.EQ.  6) OP =' X-Y,X,-Z'
        IF(IS.EQ.  7) OP =' 2/3+X,1/3+Y,1/3+Z'
        IF(IS.EQ.  8) OP =' 2/3-Y,1/3+X-Y,1/3+Z'
        IF(IS.EQ.  9) OP =' 2/3+Y-X,1/3-X,1/3+Z'
        IF(IS.EQ. 10) OP =' 2/3-X,1/3-Y,1/3-Z'
        IF(IS.EQ. 11) OP =' 2/3+Y,1/3+Y-X,1/3-Z'
        IF(IS.EQ. 12) OP =' 2/3+X-Y,1/3+X,1/3-Z'
        IF(IS.EQ. 13) OP =' 1/3+X,2/3+Y,2/3+Z'
        IF(IS.EQ. 14) OP =' 1/3-Y,2/3+X-Y,2/3+Z'
        IF(IS.EQ. 15) OP =' 1/3+Y-X,2/3-X,2/3+Z'
        IF(IS.EQ. 16) OP =' 1/3-X,2/3-Y,2/3-Z'
        IF(IS.EQ. 17) OP =' 1/3+Y,2/3+Y-X,2/3-Z'
        IF(IS.EQ. 18) OP =' 1/3+X-Y,2/3+X,2/3-Z'
        RETURN
      ENDIF
      IF(I.EQ.167) THEN
        NO_TAB  =  149
        NS_TAB  =    6
        SG_TAB1 = 'P 3 1 2'
        SG_TAB2 = 'P312'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -Y,-X,-Z'
        IF(IS.EQ.  5) OP =' Y-X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,X-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ.168) THEN
        NO_TAB  =  150
        NS_TAB  =    6
        SG_TAB1 = 'P 3 2 1'
        SG_TAB2 = 'P321'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' Y,X,-Z'
        IF(IS.EQ.  5) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  6) OP =' -X,Y-X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.169) THEN
        NO_TAB  =  151
        NS_TAB  =    6
        SG_TAB1 = 'P 31 1 2'
        SG_TAB2 = 'P3112'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,1/3+Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,2/3+Z'
        IF(IS.EQ.  4) OP =' -Y,-X,2/3-Z'
        IF(IS.EQ.  5) OP =' Y-X,Y,1/3-Z'
        IF(IS.EQ.  6) OP =' X,X-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ.170) THEN
        NO_TAB  =  152
        NS_TAB  =    6
        SG_TAB1 = 'P 31 2 1'
        SG_TAB2 = 'P3121'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z+1/3'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z+2/3'
        IF(IS.EQ.  4) OP =' Y,X,-Z'
        IF(IS.EQ.  5) OP =' X-Y,-Y,2/3-Z'
        IF(IS.EQ.  6) OP =' -X,Y-X,1/3-Z'
        RETURN
      ENDIF
      IF(I.EQ.171) THEN
        NO_TAB  =  153
        NS_TAB  =    6
        SG_TAB1 = 'P 32 1 2'
        SG_TAB2 = 'P3212'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,2/3+Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,1/3+Z'
        IF(IS.EQ.  4) OP =' -Y,-X,1/3-Z'
        IF(IS.EQ.  5) OP =' Y-X,Y,2/3-Z'
        IF(IS.EQ.  6) OP =' X,X-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ.172) THEN
        NO_TAB  =  154
        NS_TAB  =    6
        SG_TAB1 = 'P 32 2 1'
        SG_TAB2 = 'P3221'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z+2/3'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z+1/3'
        IF(IS.EQ.  4) OP =' Y,X,-Z'
        IF(IS.EQ.  5) OP =' X-Y,-Y,1/3-Z'
        IF(IS.EQ.  6) OP =' -X,Y-X,2/3-Z'
        RETURN
      ENDIF
      IF(I.EQ.173) THEN
        NO_TAB  =  155
        NS_TAB  =   18
        SG_TAB1 = 'H 3 2'
        SG_TAB2 = 'H32'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' Y,X,-Z'
        IF(IS.EQ.  5) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  6) OP =' -X,Y-X,-Z'
        IF(IS.EQ.  7) OP =' 2/3+X,1/3+Y,1/3+Z'
        IF(IS.EQ.  8) OP =' 2/3-Y,1/3+X-Y,1/3+Z'
        IF(IS.EQ.  9) OP =' 2/3+Y-X,1/3-X,1/3+Z'
        IF(IS.EQ. 10) OP =' 2/3+Y,1/3+X,1/3-Z'
        IF(IS.EQ. 11) OP =' 2/3+X-Y,1/3-Y,1/3-Z'
        IF(IS.EQ. 12) OP =' 2/3-X,1/3+Y-X,1/3-Z'
        IF(IS.EQ. 13) OP =' 1/3+X,2/3+Y,2/3+Z'
        IF(IS.EQ. 14) OP =' 1/3-Y,2/3+X-Y,2/3+Z'
        IF(IS.EQ. 15) OP =' 1/3+Y-X,2/3-X,2/3+Z'
        IF(IS.EQ. 16) OP =' 1/3+Y,2/3+X,2/3-Z'
        IF(IS.EQ. 17) OP =' 1/3+X-Y,2/3-Y,2/3-Z'
        IF(IS.EQ. 18) OP =' 1/3-X,2/3+Y-X,2/3-Z'
        RETURN
      ENDIF
      IF(I.EQ.174) THEN
        NO_TAB  = 1155
        NS_TAB  =    6
        SG_TAB1 = 'R 3 2'
        SG_TAB2 = 'R32'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' Z,X,Y'
        IF(IS.EQ.  3) OP =' Y,Z,X'
        IF(IS.EQ.  4) OP =' -Y,-X,-Z'
        IF(IS.EQ.  5) OP =' -Z,-Y,-X'
        IF(IS.EQ.  6) OP =' -X,-Z,-Y'
        RETURN
      ENDIF
      IF(I.EQ.175) THEN
        NO_TAB  =  156
        NS_TAB  =    6
        SG_TAB1 = 'P 3 m 1'
        SG_TAB2 = 'P3m1'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -Y,-X,Z'
        IF(IS.EQ.  5) OP =' Y-X,Y,Z'
        IF(IS.EQ.  6) OP =' X,X-Y,Z'
        RETURN
      ENDIF
      IF(I.EQ.176) THEN
        NO_TAB  =  157
        NS_TAB  =    6
        SG_TAB1 = 'P 3 1 m'
        SG_TAB2 = 'P31m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' Y,X,Z'
        IF(IS.EQ.  5) OP =' X-Y,-Y,Z'
        IF(IS.EQ.  6) OP =' -X,Y-X,Z'
        RETURN
      ENDIF
      IF(I.EQ.177) THEN
        NO_TAB  =  158
        NS_TAB  =    6
        SG_TAB1 = 'P 3 c 1'
        SG_TAB2 = 'P3c1'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ.  5) OP =' Y-X,Y,1/2+Z'
        IF(IS.EQ.  6) OP =' X,X-Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.178) THEN
        NO_TAB  =  159
        NS_TAB  =    6
        SG_TAB1 = 'P 3 1 c'
        SG_TAB2 = 'P31c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' Y,X,1/2+Z'
        IF(IS.EQ.  5) OP =' X-Y,-Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,Y-X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.179) THEN
        NO_TAB  =  160
        NS_TAB  =   18
        SG_TAB1 = 'R 3 m'
        SG_TAB2 = 'R3m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -Y,-X,Z'
        IF(IS.EQ.  5) OP =' Y-X,Y,Z'
        IF(IS.EQ.  6) OP =' X,X-Y,Z'
        IF(IS.EQ.  7) OP =' 2/3+X,1/3+Y,1/3+Z'
        IF(IS.EQ.  8) OP =' 2/3-Y,1/3+X-Y,1/3+Z'
        IF(IS.EQ.  9) OP =' 2/3+Y-X,1/3-X,1/3+Z'
        IF(IS.EQ. 10) OP =' 2/3-Y,1/3-X,1/3+Z'
        IF(IS.EQ. 11) OP =' 2/3+Y-X,1/3+Y,1/3+Z'
        IF(IS.EQ. 12) OP =' 2/3+X,1/3+X-Y,1/3+Z'
        IF(IS.EQ. 13) OP =' 1/3+X,2/3+Y,2/3+Z'
        IF(IS.EQ. 14) OP =' 1/3-Y,2/3+X-Y,2/3+Z'
        IF(IS.EQ. 15) OP =' 1/3+Y-X,2/3-X,2/3+Z'
        IF(IS.EQ. 16) OP =' 1/3-Y,2/3-X,2/3+Z'
        IF(IS.EQ. 17) OP =' 1/3+Y-X,2/3+Y,2/3+Z'
        IF(IS.EQ. 18) OP =' 1/3+X,2/3+X-Y,2/3+Z'
        RETURN
      ENDIF
      IF(I.EQ.180) THEN
        NO_TAB  =  161
        NS_TAB  =   18
        SG_TAB1 = 'R 3 c'
        SG_TAB2 = 'R3c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ.  5) OP =' Y-X,Y,1/2+Z'
        IF(IS.EQ.  6) OP =' X,X-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' 2/3+X,1/3+Y,1/3+Z'
        IF(IS.EQ.  8) OP =' 2/3-Y,1/3+X-Y,1/3+Z'
        IF(IS.EQ.  9) OP =' 2/3+Y-X,1/3-X,1/3+Z'
        IF(IS.EQ. 10) OP =' 2/3-Y,1/3-X,5/6+Z'
        IF(IS.EQ. 11) OP =' 2/3+Y-X,1/3+Y,5/6+Z'
        IF(IS.EQ. 12) OP =' 2/3+X,1/3+X-Y,5/6+Z'
        IF(IS.EQ. 13) OP =' 1/3+X,2/3+Y,2/3+Z'
        IF(IS.EQ. 14) OP =' 1/3-Y,2/3+X-Y,2/3+Z'
        IF(IS.EQ. 15) OP =' 1/3+Y-X,2/3-X,2/3+Z'
        IF(IS.EQ. 16) OP =' 1/3-Y,2/3-X,1/6+Z'
        IF(IS.EQ. 17) OP =' 1/3+Y-X,2/3+Y,1/6+Z'
        IF(IS.EQ. 18) OP =' 1/3+X,2/3+X-Y,1/6+Z'
        RETURN
      ENDIF
      IF(I.EQ.181) THEN
        NO_TAB  =  162
        NS_TAB  =   12
        SG_TAB1 = 'P -31 2/m'
        SG_TAB2 = 'P-31m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -Y,-X,-Z'
        IF(IS.EQ.  5) OP =' Y-X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,X-Y,-Z'
        IF(IS.EQ.  7) OP =' -X,-Y,-Z'
        IF(IS.EQ.  8) OP =' Y,Y-X,-Z'
        IF(IS.EQ.  9) OP =' X-Y,X,-Z'
        IF(IS.EQ. 10) OP =' Y,X,Z'
        IF(IS.EQ. 11) OP =' X-Y,-Y,Z'
        IF(IS.EQ. 12) OP =' -X,Y-X,Z'
        RETURN
      ENDIF
      IF(I.EQ.182) THEN
        NO_TAB  =  163
        NS_TAB  =   12
        SG_TAB1 = 'P -31 2/c'
        SG_TAB2 = 'P-31c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -Y,-X,1/2-Z'
        IF(IS.EQ.  5) OP =' Y-X,Y,1/2-Z'
        IF(IS.EQ.  6) OP =' X,X-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' -X,-Y,-Z'
        IF(IS.EQ.  8) OP =' Y,Y-X,-Z'
        IF(IS.EQ.  9) OP =' X-Y,X,-Z'
        IF(IS.EQ. 10) OP =' Y,X,1/2+Z'
        IF(IS.EQ. 11) OP =' X-Y,-Y,1/2+Z'
        IF(IS.EQ. 12) OP =' -X,Y-X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.183) THEN
        NO_TAB  =  164
        NS_TAB  =   12
        SG_TAB1 = 'P -3 2/m 1'
        SG_TAB2 = 'P-3m1'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' Y,X,-Z'
        IF(IS.EQ.  5) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  6) OP =' -X,Y-X,-Z'
        IF(IS.EQ.  7) OP =' -X,-Y,-Z'
        IF(IS.EQ.  8) OP =' Y,Y-X,-Z'
        IF(IS.EQ.  9) OP =' X-Y,X,-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,Z'
        IF(IS.EQ. 12) OP =' X,X-Y,Z'
        RETURN
      ENDIF
      IF(I.EQ.184) THEN
        NO_TAB  =  165
        NS_TAB  =   12
        SG_TAB1 = 'P -3 2/c 1'
        SG_TAB2 = 'P-3c1'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  5) OP =' X-Y,-Y,1/2-Z'
        IF(IS.EQ.  6) OP =' -X,Y-X,1/2-Z'
        IF(IS.EQ.  7) OP =' -X,-Y,-Z'
        IF(IS.EQ.  8) OP =' Y,Y-X,-Z'
        IF(IS.EQ.  9) OP =' X-Y,X,-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,1/2+Z'
        IF(IS.EQ. 12) OP =' X,X-Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.185) THEN
        NO_TAB  =  166
        NS_TAB  =   36
        SG_TAB1 = 'R -3 2/m'
        SG_TAB2 = 'R-3m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' Y,X,-Z'
        IF(IS.EQ.  5) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  6) OP =' -X,Y-X,-Z'
        IF(IS.EQ.  7) OP =' -X,-Y,-Z'
        IF(IS.EQ.  8) OP =' Y,Y-X,-Z'
        IF(IS.EQ.  9) OP =' X-Y,X,-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,Z'
        IF(IS.EQ. 12) OP =' X,X-Y,Z'
        IF(IS.EQ. 13) OP =' 2/3+X,1/3+Y,1/3+Z'
        IF(IS.EQ. 14) OP =' 2/3-Y,1/3+X-Y,1/3+Z'
        IF(IS.EQ. 15) OP =' 2/3+Y-X,1/3-X,1/3+Z'
        IF(IS.EQ. 16) OP =' 2/3+Y,1/3+X,1/3-Z'
        IF(IS.EQ. 17) OP =' 2/3+X-Y,1/3-Y,1/3-Z'
        IF(IS.EQ. 18) OP =' 2/3-X,1/3+Y-X,1/3-Z'
        IF(IS.EQ. 19) OP =' 2/3-X,1/3-Y,1/3-Z'
        IF(IS.EQ. 20) OP =' 2/3+Y,1/3+Y-X,1/3-Z'
        IF(IS.EQ. 21) OP =' 2/3+X-Y,1/3+X,1/3-Z'
        IF(IS.EQ. 22) OP =' 2/3-Y,1/3-X,1/3+Z'
        IF(IS.EQ. 23) OP =' 2/3+Y-X,1/3+Y,1/3+Z'
        IF(IS.EQ. 24) OP =' 2/3+X,1/3+X-Y,1/3+Z'
        IF(IS.EQ. 25) OP =' 1/3+X,2/3+Y,2/3+Z'
        IF(IS.EQ. 26) OP =' 1/3-Y,2/3+X-Y,2/3+Z'
        IF(IS.EQ. 27) OP =' 1/3+Y-X,2/3-X,2/3+Z'
        IF(IS.EQ. 28) OP =' 1/3+Y,2/3+X,2/3-Z'
        IF(IS.EQ. 29) OP =' 1/3+X-Y,2/3-Y,2/3-Z'
        IF(IS.EQ. 30) OP =' 1/3-X,2/3+Y-X,2/3-Z'
        IF(IS.EQ. 31) OP =' 1/3-X,2/3-Y,2/3-Z'
        IF(IS.EQ. 32) OP =' 1/3+Y,2/3+Y-X,2/3-Z'
        IF(IS.EQ. 33) OP =' 1/3+X-Y,2/3+X,2/3-Z'
        IF(IS.EQ. 34) OP =' 1/3-Y,2/3-X,2/3+Z'
        IF(IS.EQ. 35) OP =' 1/3+Y-X,2/3+Y,2/3+Z'
        IF(IS.EQ. 36) OP =' 1/3+X,2/3+X-Y,2/3+Z'
        RETURN
      ENDIF
      IF(I.EQ.186) THEN
        NO_TAB  =  167
        NS_TAB  =   36
        SG_TAB1 = 'R -3 2/c'
        SG_TAB2 = 'R-3c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  5) OP =' X-Y,-Y,1/2-Z'
        IF(IS.EQ.  6) OP =' -X,Y-X,1/2-Z'
        IF(IS.EQ.  7) OP =' -X,-Y,-Z'
        IF(IS.EQ.  8) OP =' Y,Y-X,-Z'
        IF(IS.EQ.  9) OP =' X-Y,X,-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,1/2+Z'
        IF(IS.EQ. 12) OP =' X,X-Y,1/2+Z'
        IF(IS.EQ. 13) OP =' 2/3+X,1/3+Y,1/3+Z'
        IF(IS.EQ. 14) OP =' 2/3-Y,1/3+X-Y,1/3+Z'
        IF(IS.EQ. 15) OP =' 2/3+Y-X,1/3-X,1/3+Z'
        IF(IS.EQ. 16) OP =' 2/3+Y,1/3+X,5/6-Z'
        IF(IS.EQ. 17) OP =' 2/3+X-Y,1/3-Y,5/6-Z'
        IF(IS.EQ. 18) OP =' 2/3-X,1/3+Y-X,5/6-Z'
        IF(IS.EQ. 19) OP =' 2/3-X,1/3-Y,1/3-Z'
        IF(IS.EQ. 20) OP =' 2/3+Y,1/3+Y-X,1/3-Z'
        IF(IS.EQ. 21) OP =' 2/3+X-Y,1/3+X,1/3-Z'
        IF(IS.EQ. 22) OP =' 2/3-Y,1/3-X,5/6+Z'
        IF(IS.EQ. 23) OP =' 2/3+Y-X,1/3+Y,5/6+Z'
        IF(IS.EQ. 24) OP =' 2/3+X,1/3+X-Y,5/6+Z'
        IF(IS.EQ. 25) OP =' 1/3+X,2/3+Y,2/3+Z'
        IF(IS.EQ. 26) OP =' 1/3-Y,2/3+X-Y,2/3+Z'
        IF(IS.EQ. 27) OP =' 1/3+Y-X,2/3-X,2/3+Z'
        IF(IS.EQ. 28) OP =' 1/3+Y,2/3+X,1/6-Z'
        IF(IS.EQ. 29) OP =' 1/3+X-Y,2/3-Y,1/6-Z'
        IF(IS.EQ. 30) OP =' 1/3-X,2/3+Y-X,1/6-Z'
        IF(IS.EQ. 31) OP =' 1/3-X,2/3-Y,2/3-Z'
        IF(IS.EQ. 32) OP =' 1/3+Y,2/3+Y-X,2/3-Z'
        IF(IS.EQ. 33) OP =' 1/3+X-Y,2/3+X,2/3-Z'
        IF(IS.EQ. 34) OP =' 1/3-Y,2/3-X,1/6+Z'
        IF(IS.EQ. 35) OP =' 1/3+Y-X,2/3+Y,1/6+Z'
        IF(IS.EQ. 36) OP =' 1/3+X,2/3+X-Y,1/6+Z'
        RETURN
      ENDIF
      IF(I.EQ.187) THEN
        NO_TAB  =  168
        NS_TAB  =    6
        SG_TAB1 = 'P 6'
        SG_TAB2 = 'P6'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,Z'
        IF(IS.EQ.  6) OP =' X-Y,X,Z'
        RETURN
      ENDIF
      IF(I.EQ.188) THEN
        NO_TAB  =  169
        NS_TAB  =    6
        SG_TAB1 = 'P 61'
        SG_TAB2 = 'P61'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z+1/3'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z+2/3'
        IF(IS.EQ.  4) OP =' -X,-Y,Z+1/2'
        IF(IS.EQ.  5) OP =' Y,Y-X,Z+5/6'
        IF(IS.EQ.  6) OP =' X-Y,X,Z+1/6'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_23(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.189) THEN
        NO_TAB  =  170
        NS_TAB  =    6
        SG_TAB1 = 'P 65'
        SG_TAB2 = 'P65'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z+2/3'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z+1/3'
        IF(IS.EQ.  4) OP =' -X,-Y,Z+1/2'
        IF(IS.EQ.  5) OP =' Y,Y-X,Z+1/6'
        IF(IS.EQ.  6) OP =' X-Y,X,Z+5/6'
        RETURN
      ENDIF
      IF(I.EQ.190) THEN
        NO_TAB  =  171
        NS_TAB  =    6
        SG_TAB1 = 'P 62'
        SG_TAB2 = 'P62'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,2/3+Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,1/3+Z'
        IF(IS.EQ.  4) OP =' -X,-Y,Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,2/3+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,1/3+Z'
        RETURN
      ENDIF
      IF(I.EQ.191) THEN
        NO_TAB  =  172
        NS_TAB  =    6
        SG_TAB1 = 'P 64'
        SG_TAB2 = 'P64'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,1/3+Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,2/3+Z'
        IF(IS.EQ.  4) OP =' -X,-Y,Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,1/3+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,2/3+Z'
        RETURN
      ENDIF
      IF(I.EQ.192) THEN
        NO_TAB  =  173
        NS_TAB  =    6
        SG_TAB1 = 'P 63'
        SG_TAB2 = 'P63'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,1/2+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.193) THEN
        NO_TAB  =  174
        NS_TAB  =    6
        SG_TAB1 = 'P -6'
        SG_TAB2 = 'P-6'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' X,Y,-Z'
        IF(IS.EQ.  5) OP =' -Y,X-Y,-Z'
        IF(IS.EQ.  6) OP =' Y-X,-X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.194) THEN
        NO_TAB  =  175
        NS_TAB  =   12
        SG_TAB1 = 'P 6/m'
        SG_TAB2 = 'P6/m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,Z'
        IF(IS.EQ.  6) OP =' X-Y,X,Z'
        IF(IS.EQ.  7) OP =' -X,-Y,-Z'
        IF(IS.EQ.  8) OP =' Y,Y-X,-Z'
        IF(IS.EQ.  9) OP =' X-Y,X,-Z'
        IF(IS.EQ. 10) OP =' X,Y,-Z'
        IF(IS.EQ. 11) OP =' -Y,X-Y,-Z'
        IF(IS.EQ. 12) OP =' Y-X,-X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.195) THEN
        NO_TAB  =  176
        NS_TAB  =   12
        SG_TAB1 = 'P 63/m'
        SG_TAB2 = 'P63/m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,1/2+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,1/2+Z'
        IF(IS.EQ.  7) OP =' -X,-Y,-Z'
        IF(IS.EQ.  8) OP =' Y,Y-X,-Z'
        IF(IS.EQ.  9) OP =' X-Y,X,-Z'
        IF(IS.EQ. 10) OP =' X,Y,1/2-Z'
        IF(IS.EQ. 11) OP =' -Y,X-Y,1/2-Z'
        IF(IS.EQ. 12) OP =' Y-X,-X,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.196) THEN
        NO_TAB  =  177
        NS_TAB  =   12
        SG_TAB1 = 'P 6 2 2'
        SG_TAB2 = 'P622'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,Z'
        IF(IS.EQ.  6) OP =' X-Y,X,Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  9) OP =' -X,Y-X,-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,-Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,-Z'
        IF(IS.EQ. 12) OP =' X,X-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ.197) THEN
        NO_TAB  =  178
        NS_TAB  =   12
        SG_TAB1 = 'P 61 2 2'
        SG_TAB2 = 'P6122'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,1/3+Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,2/3+Z'
        IF(IS.EQ.  4) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,5/6+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,1/6+Z'
        IF(IS.EQ.  7) OP =' Y,X,1/3-Z'
        IF(IS.EQ.  8) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  9) OP =' -X,Y-X,2/3-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,5/6-Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,1/2-Z'
        IF(IS.EQ. 12) OP =' X,X-Y,1/6-Z'
        RETURN
      ENDIF
      IF(I.EQ.198) THEN
        NO_TAB  =  179
        NS_TAB  =   12
        SG_TAB1 = 'P 65 2 2'
        SG_TAB2 = 'P6522'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,2/3+Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,1/3+Z'
        IF(IS.EQ.  4) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,1/6+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,5/6+Z'
        IF(IS.EQ.  7) OP =' Y,X,2/3-Z'
        IF(IS.EQ.  8) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  9) OP =' -X,Y-X,1/3-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,1/6-Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,1/2-Z'
        IF(IS.EQ. 12) OP =' X,X-Y,5/6-Z'
        RETURN
      ENDIF
      IF(I.EQ.199) THEN
        NO_TAB  =  180
        NS_TAB  =   12
        SG_TAB1 = 'P 62 2 2'
        SG_TAB2 = 'P6222'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,2/3+Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,1/3+Z'
        IF(IS.EQ.  4) OP =' -X,-Y,Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,2/3+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,1/3+Z'
        IF(IS.EQ.  7) OP =' Y,X,2/3-Z'
        IF(IS.EQ.  8) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  9) OP =' -X,Y-X,1/3-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,2/3-Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,-Z'
        IF(IS.EQ. 12) OP =' X,X-Y,1/3-Z'
        RETURN
      ENDIF
      IF(I.EQ.200) THEN
        NO_TAB  =  181
        NS_TAB  =   12
        SG_TAB1 = 'P 64 2 2'
        SG_TAB2 = 'P6422'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,1/3+Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,2/3+Z'
        IF(IS.EQ.  4) OP =' -X,-Y,Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,1/3+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,2/3+Z'
        IF(IS.EQ.  7) OP =' Y,X,1/3-Z'
        IF(IS.EQ.  8) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  9) OP =' -X,Y-X,2/3-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,1/3-Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,-Z'
        IF(IS.EQ. 12) OP =' X,X-Y,2/3-Z'
        RETURN
      ENDIF
      IF(I.EQ.201) THEN
        NO_TAB  =  182
        NS_TAB  =   12
        SG_TAB1 = 'P 63 2 2'
        SG_TAB2 = 'P6322'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,1/2+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,1/2+Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  9) OP =' -X,Y-X,-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,1/2-Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,1/2-Z'
        IF(IS.EQ. 12) OP =' X,X-Y,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.202) THEN
        NO_TAB  =  183
        NS_TAB  =   12
        SG_TAB1 = 'P 6 m m'
        SG_TAB2 = 'P6mm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,Z'
        IF(IS.EQ.  6) OP =' X-Y,X,Z'
        IF(IS.EQ.  7) OP =' -Y,-X,Z'
        IF(IS.EQ.  8) OP =' Y-X,Y,Z'
        IF(IS.EQ.  9) OP =' X,X-Y,Z'
        IF(IS.EQ. 10) OP =' Y,X,Z'
        IF(IS.EQ. 11) OP =' X-Y,-Y,Z'
        IF(IS.EQ. 12) OP =' -X,Y-X,Z'
        RETURN
      ENDIF
      RETURN
      END


      SUBROUTINE GET_SPACE_GROUP_INFO_24(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.203) THEN
        NO_TAB  =  184
        NS_TAB  =   12
        SG_TAB1 = 'P 6 c c'
        SG_TAB2 = 'P6cc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,Z'
        IF(IS.EQ.  6) OP =' X-Y,X,Z'
        IF(IS.EQ.  7) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ.  8) OP =' Y-X,Y,1/2+Z'
        IF(IS.EQ.  9) OP =' X,X-Y,1/2+Z'
        IF(IS.EQ. 10) OP =' Y,X,1/2+Z'
        IF(IS.EQ. 11) OP =' X-Y,-Y,1/2+Z'
        IF(IS.EQ. 12) OP =' -X,Y-X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.204) THEN
        NO_TAB  =  185
        NS_TAB  =   12
        SG_TAB1 = 'P 63 c m'
        SG_TAB2 = 'P63cm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,1/2+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,1/2+Z'
        IF(IS.EQ.  7) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ.  8) OP =' Y-X,Y,1/2+Z'
        IF(IS.EQ.  9) OP =' X,X-Y,1/2+Z'
        IF(IS.EQ. 10) OP =' Y,X,Z'
        IF(IS.EQ. 11) OP =' X-Y,-Y,Z'
        IF(IS.EQ. 12) OP =' -X,Y-X,Z'
        RETURN
      ENDIF
      IF(I.EQ.205) THEN
        NO_TAB  =  186
        NS_TAB  =   12
        SG_TAB1 = 'P 63 m c'
        SG_TAB2 = 'P63mc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,1/2+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,1/2+Z'
        IF(IS.EQ.  7) OP =' -Y,-X,Z'
        IF(IS.EQ.  8) OP =' Y-X,Y,Z'
        IF(IS.EQ.  9) OP =' X,X-Y,Z'
        IF(IS.EQ. 10) OP =' Y,X,1/2+Z'
        IF(IS.EQ. 11) OP =' X-Y,-Y,1/2+Z'
        IF(IS.EQ. 12) OP =' -X,Y-X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.206) THEN
        NO_TAB  =  187
        NS_TAB  =   12
        SG_TAB1 = 'P -6 m 2'
        SG_TAB2 = 'P-6m2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' X,Y,-Z'
        IF(IS.EQ.  5) OP =' -Y,X-Y,-Z'
        IF(IS.EQ.  6) OP =' Y-X,-X,-Z'
        IF(IS.EQ.  7) OP =' -Y,-X,Z'
        IF(IS.EQ.  8) OP =' Y-X,Y,Z'
        IF(IS.EQ.  9) OP =' X,X-Y,Z'
        IF(IS.EQ. 10) OP =' -Y,-X,-Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,-Z'
        IF(IS.EQ. 12) OP =' X,X-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ.207) THEN
        NO_TAB  =  188
        NS_TAB  =   12
        SG_TAB1 = 'P -6 c 2'
        SG_TAB2 = 'P-6c2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' X,Y,1/2-Z'
        IF(IS.EQ.  5) OP =' -Y,X-Y,1/2-Z'
        IF(IS.EQ.  6) OP =' Y-X,-X,1/2-Z'
        IF(IS.EQ.  7) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ.  8) OP =' Y-X,Y,1/2+Z'
        IF(IS.EQ.  9) OP =' X,X-Y,1/2+Z'
        IF(IS.EQ. 10) OP =' -Y,-X,-Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,-Z'
        IF(IS.EQ. 12) OP =' X,X-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ.208) THEN
        NO_TAB  =  189
        NS_TAB  =   12
        SG_TAB1 = 'P -6 2 m'
        SG_TAB2 = 'P-62m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' X,Y,-Z'
        IF(IS.EQ.  5) OP =' -Y,X-Y,-Z'
        IF(IS.EQ.  6) OP =' Y-X,-X,-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  9) OP =' -X,Y-X,-Z'
        IF(IS.EQ. 10) OP =' Y,X,Z'
        IF(IS.EQ. 11) OP =' X-Y,-Y,Z'
        IF(IS.EQ. 12) OP =' -X,Y-X,Z'
        RETURN
      ENDIF
      IF(I.EQ.209) THEN
        NO_TAB  =  190
        NS_TAB  =   12
        SG_TAB1 = 'P -6 2 c'
        SG_TAB2 = 'P-62c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' X,Y,1/2-Z'
        IF(IS.EQ.  5) OP =' -Y,X-Y,1/2-Z'
        IF(IS.EQ.  6) OP =' Y-X,-X,1/2-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  9) OP =' -X,Y-X,-Z'
        IF(IS.EQ. 10) OP =' Y,X,1/2+Z'
        IF(IS.EQ. 11) OP =' X-Y,-Y,1/2+Z'
        IF(IS.EQ. 12) OP =' -X,Y-X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.210) THEN
        NO_TAB  =  191
        NS_TAB  =   24
        SG_TAB1 = 'P 6/m 2/m 2/m'
        SG_TAB2 = 'P6/mmm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,Z'
        IF(IS.EQ.  6) OP =' X-Y,X,Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  9) OP =' -X,Y-X,-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,-Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,-Z'
        IF(IS.EQ. 12) OP =' X,X-Y,-Z'
        IF(IS.EQ. 13) OP =' -X,-Y,-Z'
        IF(IS.EQ. 14) OP =' Y,Y-X,-Z'
        IF(IS.EQ. 15) OP =' X-Y,X,-Z'
        IF(IS.EQ. 16) OP =' X,Y,-Z'
        IF(IS.EQ. 17) OP =' Y-X,-X,-Z'
        IF(IS.EQ. 18) OP =' -Y,X-Y,-Z'
        IF(IS.EQ. 19) OP =' -Y,-X,Z'
        IF(IS.EQ. 20) OP =' Y-X,Y,Z'
        IF(IS.EQ. 21) OP =' X,X-Y,Z'
        IF(IS.EQ. 22) OP =' Y,X,Z'
        IF(IS.EQ. 23) OP =' X-Y,-Y,Z'
        IF(IS.EQ. 24) OP =' -X,Y-X,Z'
        RETURN
      ENDIF
      IF(I.EQ.211) THEN
        NO_TAB  =  192
        NS_TAB  =   24
        SG_TAB1 = 'P 6/m 2/c 2/c'
        SG_TAB2 = 'P6/mcc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,Z'
        IF(IS.EQ.  6) OP =' X-Y,X,Z'
        IF(IS.EQ.  7) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  8) OP =' X-Y,-Y,1/2-Z'
        IF(IS.EQ.  9) OP =' -X,Y-X,1/2-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,1/2-Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,1/2-Z'
        IF(IS.EQ. 12) OP =' X,X-Y,1/2-Z'
        IF(IS.EQ. 13) OP =' -X,-Y,-Z'
        IF(IS.EQ. 14) OP =' Y,Y-X,-Z'
        IF(IS.EQ. 15) OP =' X-Y,X,-Z'
        IF(IS.EQ. 16) OP =' X,Y,-Z'
        IF(IS.EQ. 17) OP =' Y-X,-X,-Z'
        IF(IS.EQ. 18) OP =' -Y,X-Y,-Z'
        IF(IS.EQ. 19) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ. 20) OP =' Y-X,Y,1/2+Z'
        IF(IS.EQ. 21) OP =' X,X-Y,1/2+Z'
        IF(IS.EQ. 22) OP =' Y,X,1/2+Z'
        IF(IS.EQ. 23) OP =' X-Y,-Y,1/2+Z'
        IF(IS.EQ. 24) OP =' -X,Y-X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.212) THEN
        NO_TAB  =  193
        NS_TAB  =   24
        SG_TAB1 = 'P 63/m 2/c 2/m'
        SG_TAB2 = 'P63/mcm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,1/2+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,1/2+Z'
        IF(IS.EQ.  7) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  8) OP =' X-Y,-Y,1/2-Z'
        IF(IS.EQ.  9) OP =' -X,Y-X,1/2-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,-Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,-Z'
        IF(IS.EQ. 12) OP =' X,X-Y,-Z'
        IF(IS.EQ. 13) OP =' -X,-Y,-Z'
        IF(IS.EQ. 14) OP =' Y,Y-X,-Z'
        IF(IS.EQ. 15) OP =' X-Y,X,-Z'
        IF(IS.EQ. 16) OP =' X,Y,1/2-Z'
        IF(IS.EQ. 17) OP =' Y-X,-X,1/2-Z'
        IF(IS.EQ. 18) OP =' -Y,X-Y,1/2-Z'
        IF(IS.EQ. 19) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ. 20) OP =' Y-X,Y,1/2+Z'
        IF(IS.EQ. 21) OP =' X,X-Y,1/2+Z'
        IF(IS.EQ. 22) OP =' Y,X,Z'
        IF(IS.EQ. 23) OP =' X-Y,-Y,Z'
        IF(IS.EQ. 24) OP =' -X,Y-X,Z'
        RETURN
      ENDIF
      IF(I.EQ.213) THEN
        NO_TAB  =  194
        NS_TAB  =   24
        SG_TAB1 = 'P 63/m 2/m 2/c'
        SG_TAB2 = 'P63/mmc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,1/2+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,1/2+Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  9) OP =' -X,Y-X,-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,1/2-Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,1/2-Z'
        IF(IS.EQ. 12) OP =' X,X-Y,1/2-Z'
        IF(IS.EQ. 13) OP =' -X,-Y,-Z'
        IF(IS.EQ. 14) OP =' Y,Y-X,-Z'
        IF(IS.EQ. 15) OP =' X-Y,X,-Z'
        IF(IS.EQ. 16) OP =' X,Y,1/2-Z'
        IF(IS.EQ. 17) OP =' Y-X,-X,1/2-Z'
        IF(IS.EQ. 18) OP =' -Y,X-Y,1/2-Z'
        IF(IS.EQ. 19) OP =' -Y,-X,Z'
        IF(IS.EQ. 20) OP =' Y-X,Y,Z'
        IF(IS.EQ. 21) OP =' X,X-Y,Z'
        IF(IS.EQ. 22) OP =' Y,X,1/2+Z'
        IF(IS.EQ. 23) OP =' X-Y,-Y,1/2+Z'
        IF(IS.EQ. 24) OP =' -X,Y-X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.214) THEN
        NO_TAB  =  195
        NS_TAB  =   12
        SG_TAB1 = 'P 2 3'
        SG_TAB2 = 'P23'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        RETURN
      ENDIF
      IF(I.EQ.215) THEN
        NO_TAB  =  196
        NS_TAB  =   48
        SG_TAB1 = 'F 2 3'
        SG_TAB2 = 'F23'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 14) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ. 15) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ. 16) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ. 17) OP =' Z,1/2+X,1/2+Y'
        IF(IS.EQ. 18) OP =' Z,1/2-X,1/2-Y'
        IF(IS.EQ. 19) OP =' -Z,1/2-X,1/2+Y'
        IF(IS.EQ. 20) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ. 21) OP =' Y,1/2+Z,1/2+X'
        IF(IS.EQ. 22) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 23) OP =' Y,1/2-Z,1/2-X'
        IF(IS.EQ. 24) OP =' -Y,1/2-Z,1/2+X'
        IF(IS.EQ. 25) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 26) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 27) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 28) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ. 29) OP =' 1/2+Z,X,1/2+Y'
        IF(IS.EQ. 30) OP =' 1/2+Z,-X,1/2-Y'
        IF(IS.EQ. 31) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ. 32) OP =' 1/2-Z,X,1/2-Y'
        IF(IS.EQ. 33) OP =' 1/2+Y,Z,1/2+X'
        IF(IS.EQ. 34) OP =' 1/2-Y,Z,1/2-X'
        IF(IS.EQ. 35) OP =' 1/2+Y,-Z,1/2-X'
        IF(IS.EQ. 36) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 37) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 38) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 39) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ. 40) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 41) OP =' 1/2+Z,1/2+X,Y'
        IF(IS.EQ. 42) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ. 43) OP =' 1/2-Z,1/2-X,Y'
        IF(IS.EQ. 44) OP =' 1/2-Z,1/2+X,-Y'
        IF(IS.EQ. 45) OP =' 1/2+Y,1/2+Z,X'
        IF(IS.EQ. 46) OP =' 1/2-Y,1/2+Z,-X'
        IF(IS.EQ. 47) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 48) OP =' 1/2-Y,1/2-Z,X'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_3(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.216) THEN
        NO_TAB  =  197
        NS_TAB  =   24
        SG_TAB1 = 'I 2 3'
        SG_TAB2 = 'I23'
        SG_TAB3 = 'I 23'
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 15) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ. 16) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ. 17) OP =' 1/2+Z,1/2+X,1/2+Y'
        IF(IS.EQ. 18) OP =' 1/2+Z,1/2-X,1/2-Y'
        IF(IS.EQ. 19) OP =' 1/2-Z,1/2-X,1/2+Y'
        IF(IS.EQ. 20) OP =' 1/2-Z,1/2+X,1/2-Y'
        IF(IS.EQ. 21) OP =' 1/2+Y,1/2+Z,1/2+X'
        IF(IS.EQ. 22) OP =' 1/2-Y,1/2+Z,1/2-X'
        IF(IS.EQ. 23) OP =' 1/2+Y,1/2-Z,1/2-X'
        IF(IS.EQ. 24) OP =' 1/2-Y,1/2-Z,1/2+X'
        RETURN
      ENDIF
      IF(I.EQ.217) THEN
        NO_TAB  = 1197
        NS_TAB  =   24
        SG_TAB1 = 'I 2 3 (a)'
        SG_TAB2 = 'I23a'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.  3) OP =' X+1/2,-Y,-Z'
        IF(IS.EQ.  4) OP =' -X,Y+1/2,-Z'
        IF(IS.EQ.  5) OP =' Y,Z,X'
        IF(IS.EQ.  6) OP =' 1/2-Y,1/2-Z,X'
        IF(IS.EQ.  7) OP =' Y+1/2,-Z,-X'
        IF(IS.EQ.  8) OP =' -Y,Z+1/2,-X'
        IF(IS.EQ.  9) OP =' Z,X,Y'
        IF(IS.EQ. 10) OP =' 1/2-Z,1/2-X,Y'
        IF(IS.EQ. 11) OP =' Z+1/2,-X,-Y'
        IF(IS.EQ. 12) OP =' -Z,X+1/2,-Y'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 14) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ. 15) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ. 16) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 17) OP =' 1/2+Y,1/2+Z,1/2+X'
        IF(IS.EQ. 18) OP =' -Y,-Z,1/2+X'
        IF(IS.EQ. 19) OP =' Y,1/2-Z,1/2-X'
        IF(IS.EQ. 20) OP =' 1/2-Y,Z,1/2-X'
        IF(IS.EQ. 21) OP =' 1/2+Z,1/2+X,1/2+Y'
        IF(IS.EQ. 22) OP =' -Z,-X,1/2+Y'
        IF(IS.EQ. 23) OP =' Z,1/2-X,1/2-Y'
        IF(IS.EQ. 24) OP =' 1/2-Z,X,1/2-Y'
        RETURN
      ENDIF
      IF(I.EQ.218) THEN
        NO_TAB  =  198
        NS_TAB  =   12
        SG_TAB1 = 'P 21 3'
        SG_TAB2 = 'P213'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ.  7) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.  8) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 11) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 12) OP =' 1/2-Y,-Z,1/2+X'
        RETURN
      ENDIF
      IF(I.EQ.219) THEN
        NO_TAB  =  199
        NS_TAB  =   24
        SG_TAB1 = 'I 21 3'
        SG_TAB2 = 'I213'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ.  7) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.  8) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 11) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 12) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 14) OP =' -X,1/2-Y,Z'
        IF(IS.EQ. 15) OP =' 1/2-X,Y,-Z'
        IF(IS.EQ. 16) OP =' X,-Y,1/2-Z'
        IF(IS.EQ. 17) OP =' 1/2+Z,1/2+X,1/2+Y'
        IF(IS.EQ. 18) OP =' Z,-X,1/2-Y'
        IF(IS.EQ. 19) OP =' -Z,1/2-X,Y'
        IF(IS.EQ. 20) OP =' 1/2-Z,X,-Y'
        IF(IS.EQ. 21) OP =' 1/2+Y,1/2+Z,1/2+X'
        IF(IS.EQ. 22) OP =' 1/2-Y,Z,-X'
        IF(IS.EQ. 23) OP =' Y,-Z,1/2-X'
        IF(IS.EQ. 24) OP =' -Y,1/2-Z,X'
        RETURN
      ENDIF
      IF(I.EQ.220) THEN
        NO_TAB  =  200
        NS_TAB  =   24
        SG_TAB1 = 'P 2/m -3'
        SG_TAB2 = 'Pm-3'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' -X,-Y,-Z'
        IF(IS.EQ. 14) OP =' X,Y,-Z'
        IF(IS.EQ. 15) OP =' X,-Y,Z'
        IF(IS.EQ. 16) OP =' -X,Y,Z'
        IF(IS.EQ. 17) OP =' -Z,-X,-Y'
        IF(IS.EQ. 18) OP =' -Z,X,Y'
        IF(IS.EQ. 19) OP =' Z,X,-Y'
        IF(IS.EQ. 20) OP =' Z,-X,Y'
        IF(IS.EQ. 21) OP =' -Y,-Z,-X'
        IF(IS.EQ. 22) OP =' Y,-Z,X'
        IF(IS.EQ. 23) OP =' -Y,Z,X'
        IF(IS.EQ. 24) OP =' Y,Z,-X'
        RETURN
      ENDIF
      IF(I.EQ.221) THEN
        NO_TAB  =  201
        NS_TAB  =   24
        SG_TAB1 = 'P 2/n -3'
        SG_TAB2 = 'Pn-3'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ. 17) OP =' 1/2-Z,1/2-X,1/2-Y'
        IF(IS.EQ. 18) OP =' 1/2-Z,1/2+X,1/2+Y'
        IF(IS.EQ. 19) OP =' 1/2+Z,1/2+X,1/2-Y'
        IF(IS.EQ. 20) OP =' 1/2+Z,1/2-X,1/2+Y'
        IF(IS.EQ. 21) OP =' 1/2-Y,1/2-Z,1/2-X'
        IF(IS.EQ. 22) OP =' 1/2+Y,1/2-Z,1/2+X'
        IF(IS.EQ. 23) OP =' 1/2-Y,1/2+Z,1/2+X'
        IF(IS.EQ. 24) OP =' 1/2+Y,1/2+Z,1/2-X'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_31(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.222) THEN
        NO_TAB  =  202
        NS_TAB  =   96
        SG_TAB1 = 'F 2/m -3'
        SG_TAB2 = 'Fm-3'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' -X,-Y,-Z'
        IF(IS.EQ. 14) OP =' X,Y,-Z'
        IF(IS.EQ. 15) OP =' X,-Y,Z'
        IF(IS.EQ. 16) OP =' -X,Y,Z'
        IF(IS.EQ. 17) OP =' -Z,-X,-Y'
        IF(IS.EQ. 18) OP =' -Z,X,Y'
        IF(IS.EQ. 19) OP =' Z,X,-Y'
        IF(IS.EQ. 20) OP =' Z,-X,Y'
        IF(IS.EQ. 21) OP =' -Y,-Z,-X'
        IF(IS.EQ. 22) OP =' Y,-Z,X'
        IF(IS.EQ. 23) OP =' -Y,Z,X'
        IF(IS.EQ. 24) OP =' Y,Z,-X'
        IF(IS.EQ. 25) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 26) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ. 27) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ. 28) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ. 29) OP =' Z,1/2+X,1/2+Y'
        IF(IS.EQ. 30) OP =' Z,1/2-X,1/2-Y'
        IF(IS.EQ. 31) OP =' -Z,1/2-X,1/2+Y'
        IF(IS.EQ. 32) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ. 33) OP =' Y,1/2+Z,1/2+X'
        IF(IS.EQ. 34) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 35) OP =' Y,1/2-Z,1/2-X'
        IF(IS.EQ. 36) OP =' -Y,1/2-Z,1/2+X'
        IF(IS.EQ. 37) OP =' -X,1/2-Y,1/2-Z'
        IF(IS.EQ. 38) OP =' X,1/2+Y,1/2-Z'
        IF(IS.EQ. 39) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ. 40) OP =' -X,1/2+Y,1/2+Z'
        IF(IS.EQ. 41) OP =' -Z,1/2-X,1/2-Y'
        IF(IS.EQ. 42) OP =' -Z,1/2+X,1/2+Y'
        IF(IS.EQ. 43) OP =' Z,1/2+X,1/2-Y'
        IF(IS.EQ. 44) OP =' Z,1/2-X,1/2+Y'
        IF(IS.EQ. 45) OP =' -Y,1/2-Z,1/2-X'
        IF(IS.EQ. 46) OP =' Y,1/2-Z,1/2+X'
        IF(IS.EQ. 47) OP =' -Y,1/2+Z,1/2+X'
        IF(IS.EQ. 48) OP =' Y,1/2+Z,1/2-X'
        IF(IS.EQ. 49) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 50) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 51) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 52) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ. 53) OP =' 1/2+Z,X,1/2+Y'
        IF(IS.EQ. 54) OP =' 1/2+Z,-X,1/2-Y'
        IF(IS.EQ. 55) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ. 56) OP =' 1/2-Z,X,1/2-Y'
        IF(IS.EQ. 57) OP =' 1/2+Y,Z,1/2+X'
        IF(IS.EQ. 58) OP =' 1/2-Y,Z,1/2-X'
        IF(IS.EQ. 59) OP =' 1/2+Y,-Z,1/2-X'
        IF(IS.EQ. 60) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 61) OP =' 1/2-X,-Y,1/2-Z'
        IF(IS.EQ. 62) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ. 63) OP =' 1/2+X,-Y,1/2+Z'
        IF(IS.EQ. 64) OP =' 1/2-X,Y,1/2+Z'
        IF(IS.EQ. 65) OP =' 1/2-Z,-X,1/2-Y'
        IF(IS.EQ. 66) OP =' 1/2-Z,X,1/2+Y'
        IF(IS.EQ. 67) OP =' 1/2+Z,X,1/2-Y'
        IF(IS.EQ. 68) OP =' 1/2+Z,-X,1/2+Y'
        IF(IS.EQ. 69) OP =' 1/2-Y,-Z,1/2-X'
        IF(IS.EQ. 70) OP =' 1/2+Y,-Z,1/2+X'
        IF(IS.EQ. 71) OP =' 1/2-Y,Z,1/2+X'
        IF(IS.EQ. 72) OP =' 1/2+Y,Z,1/2-X'
        IF(IS.EQ. 73) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 74) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 75) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ. 76) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 77) OP =' 1/2+Z,1/2+X,Y'
        IF(IS.EQ. 78) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ. 79) OP =' 1/2-Z,1/2-X,Y'
        IF(IS.EQ. 80) OP =' 1/2-Z,1/2+X,-Y'
        IF(IS.EQ. 81) OP =' 1/2+Y,1/2+Z,X'
        IF(IS.EQ. 82) OP =' 1/2-Y,1/2+Z,-X'
        IF(IS.EQ. 83) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 84) OP =' 1/2-Y,1/2-Z,X'
        IF(IS.EQ. 85) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ. 86) OP =' 1/2+X,1/2+Y,-Z'
        IF(IS.EQ. 87) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 88) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ. 89) OP =' 1/2-Z,1/2-X,-Y'
        IF(IS.EQ. 90) OP =' 1/2-Z,1/2+X,Y'
        IF(IS.EQ. 91) OP =' 1/2+Z,1/2+X,-Y'
        IF(IS.EQ. 92) OP =' 1/2+Z,1/2-X,Y'
        IF(IS.EQ. 93) OP =' 1/2-Y,1/2-Z,-X'
        IF(IS.EQ. 94) OP =' 1/2+Y,1/2-Z,X'
        IF(IS.EQ. 95) OP =' 1/2-Y,1/2+Z,X'
        IF(IS.EQ. 96) OP =' 1/2+Y,1/2+Z,-X'
        RETURN
      ENDIF
      IF(I.EQ.223) THEN
        NO_TAB  =  203
        NS_TAB  =   96
        SG_TAB1 = 'F 2/d -3'
        SG_TAB2 = 'Fd-3'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' 1/4-X,1/4-Y,1/4-Z'
        IF(IS.EQ. 14) OP =' 1/4+X,1/4+Y,1/4-Z'
        IF(IS.EQ. 15) OP =' 1/4+X,1/4-Y,1/4+Z'
        IF(IS.EQ. 16) OP =' 1/4-X,1/4+Y,1/4+Z'
        IF(IS.EQ. 17) OP =' 1/4-Z,1/4-X,1/4-Y'
        IF(IS.EQ. 18) OP =' 1/4-Z,1/4+X,1/4+Y'
        IF(IS.EQ. 19) OP =' 1/4+Z,1/4+X,1/4-Y'
        IF(IS.EQ. 20) OP =' 1/4+Z,1/4-X,1/4+Y'
        IF(IS.EQ. 21) OP =' 1/4-Y,1/4-Z,1/4-X'
        IF(IS.EQ. 22) OP =' 1/4+Y,1/4-Z,1/4+X'
        IF(IS.EQ. 23) OP =' 1/4-Y,1/4+Z,1/4+X'
        IF(IS.EQ. 24) OP =' 1/4+Y,1/4+Z,1/4-X'
        IF(IS.EQ. 25) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 26) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ. 27) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ. 28) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ. 29) OP =' Z,1/2+X,1/2+Y'
        IF(IS.EQ. 30) OP =' Z,1/2-X,1/2-Y'
        IF(IS.EQ. 31) OP =' -Z,1/2-X,1/2+Y'
        IF(IS.EQ. 32) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ. 33) OP =' Y,1/2+Z,1/2+X'
        IF(IS.EQ. 34) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 35) OP =' Y,1/2-Z,1/2-X'
        IF(IS.EQ. 36) OP =' -Y,1/2-Z,1/2+X'
        IF(IS.EQ. 37) OP =' 1/4-X,3/4-Y,3/4-Z'
        IF(IS.EQ. 38) OP =' 1/4+X,3/4+Y,3/4-Z'
        IF(IS.EQ. 39) OP =' 1/4+X,3/4-Y,3/4+Z'
        IF(IS.EQ. 40) OP =' 1/4-X,3/4+Y,3/4+Z'
        IF(IS.EQ. 41) OP =' 1/4-Z,3/4-X,3/4-Y'
        IF(IS.EQ. 42) OP =' 1/4-Z,3/4+X,3/4+Y'
        IF(IS.EQ. 43) OP =' 1/4+Z,3/4+X,3/4-Y'
        IF(IS.EQ. 44) OP =' 1/4+Z,3/4-X,3/4+Y'
        IF(IS.EQ. 45) OP =' 1/4-Y,3/4-Z,3/4-X'
        IF(IS.EQ. 46) OP =' 1/4+Y,3/4-Z,3/4+X'
        IF(IS.EQ. 47) OP =' 1/4-Y,3/4+Z,3/4+X'
        IF(IS.EQ. 48) OP =' 1/4+Y,3/4+Z,3/4-X'
        IF(IS.EQ. 49) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 50) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 51) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 52) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ. 53) OP =' 1/2+Z,X,1/2+Y'
        IF(IS.EQ. 54) OP =' 1/2+Z,-X,1/2-Y'
        IF(IS.EQ. 55) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ. 56) OP =' 1/2-Z,X,1/2-Y'
        IF(IS.EQ. 57) OP =' 1/2+Y,Z,1/2+X'
        IF(IS.EQ. 58) OP =' 1/2-Y,Z,1/2-X'
        IF(IS.EQ. 59) OP =' 1/2+Y,-Z,1/2-X'
        IF(IS.EQ. 60) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 61) OP =' 3/4-X,1/4-Y,3/4-Z'
        IF(IS.EQ. 62) OP =' 3/4+X,1/4+Y,3/4-Z'
        IF(IS.EQ. 63) OP =' 3/4+X,1/4-Y,3/4+Z'
        IF(IS.EQ. 64) OP =' 3/4-X,1/4+Y,3/4+Z'
        IF(IS.EQ. 65) OP =' 3/4-Z,1/4-X,3/4-Y'
        IF(IS.EQ. 66) OP =' 3/4-Z,1/4+X,3/4+Y'
        IF(IS.EQ. 67) OP =' 3/4+Z,1/4+X,3/4-Y'
        IF(IS.EQ. 68) OP =' 3/4+Z,1/4-X,3/4+Y'
        IF(IS.EQ. 69) OP =' 3/4-Y,1/4-Z,3/4-X'
        IF(IS.EQ. 70) OP =' 3/4+Y,1/4-Z,3/4+X'
        IF(IS.EQ. 71) OP =' 3/4-Y,1/4+Z,3/4+X'
        IF(IS.EQ. 72) OP =' 3/4+Y,1/4+Z,3/4-X'
        IF(IS.EQ. 73) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 74) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 75) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ. 76) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 77) OP =' 1/2+Z,1/2+X,Y'
        IF(IS.EQ. 78) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ. 79) OP =' 1/2-Z,1/2-X,Y'
        IF(IS.EQ. 80) OP =' 1/2-Z,1/2+X,-Y'
        IF(IS.EQ. 81) OP =' 1/2+Y,1/2+Z,X'
        IF(IS.EQ. 82) OP =' 1/2-Y,1/2+Z,-X'
        IF(IS.EQ. 83) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 84) OP =' 1/2-Y,1/2-Z,X'
        IF(IS.EQ. 85) OP =' 3/4-X,3/4-Y,1/4-Z'
        IF(IS.EQ. 86) OP =' 3/4+X,3/4+Y,1/4-Z'
        IF(IS.EQ. 87) OP =' 3/4+X,3/4-Y,Z+1/4'
        IF(IS.EQ. 88) OP =' 3/4-X,3/4+Y,Z+1/4'
        IF(IS.EQ. 89) OP =' 3/4-Z,3/4-X,1/4-Y'
        IF(IS.EQ. 90) OP =' 3/4-Z,3/4+X,1/4+Y'
        IF(IS.EQ. 91) OP =' 3/4+Z,3/4+X,1/4-Y'
        IF(IS.EQ. 92) OP =' 3/4+Z,3/4-X,1/4+Y'
        IF(IS.EQ. 93) OP =' 3/4-Y,3/4-Z,1/4-X'
        IF(IS.EQ. 94) OP =' 3/4+Y,3/4-Z,1/4+X'
        IF(IS.EQ. 95) OP =' 3/4-Y,3/4+Z,1/4+X'
        IF(IS.EQ. 96) OP =' 3/4+Y,3/4+Z,1/4-X'
        RETURN
      ENDIF
      IF(I.EQ.224) THEN
        NO_TAB  =  204
        NS_TAB  =   48
        SG_TAB1 = 'I 2/m -3'
        SG_TAB2 = 'Im-3'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' -X,-Y,-Z'
        IF(IS.EQ. 14) OP =' X,Y,-Z'
        IF(IS.EQ. 15) OP =' X,-Y,Z'
        IF(IS.EQ. 16) OP =' -X,Y,Z'
        IF(IS.EQ. 17) OP =' -Z,-X,-Y'
        IF(IS.EQ. 18) OP =' -Z,X,Y'
        IF(IS.EQ. 19) OP =' Z,X,-Y'
        IF(IS.EQ. 20) OP =' Z,-X,Y'
        IF(IS.EQ. 21) OP =' -Y,-Z,-X'
        IF(IS.EQ. 22) OP =' Y,-Z,X'
        IF(IS.EQ. 23) OP =' -Y,Z,X'
        IF(IS.EQ. 24) OP =' Y,Z,-X'
        IF(IS.EQ. 25) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 26) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 27) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ. 28) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ. 29) OP =' 1/2+Z,1/2+X,1/2+Y'
        IF(IS.EQ. 30) OP =' 1/2+Z,1/2-X,1/2-Y'
        IF(IS.EQ. 31) OP =' 1/2-Z,1/2-X,1/2+Y'
        IF(IS.EQ. 32) OP =' 1/2-Z,1/2+X,1/2-Y'
        IF(IS.EQ. 33) OP =' 1/2+Y,1/2+Z,1/2+X'
        IF(IS.EQ. 34) OP =' 1/2-Y,1/2+Z,1/2-X'
        IF(IS.EQ. 35) OP =' 1/2+Y,1/2-Z,1/2-X'
        IF(IS.EQ. 36) OP =' 1/2-Y,1/2-Z,1/2+X'
        IF(IS.EQ. 37) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 38) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 39) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 40) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ. 41) OP =' 1/2-Z,1/2-X,1/2-Y'
        IF(IS.EQ. 42) OP =' 1/2-Z,1/2+X,1/2+Y'
        IF(IS.EQ. 43) OP =' 1/2+Z,1/2+X,1/2-Y'
        IF(IS.EQ. 44) OP =' 1/2+Z,1/2-X,1/2+Y'
        IF(IS.EQ. 45) OP =' 1/2-Y,1/2-Z,1/2-X'
        IF(IS.EQ. 46) OP =' 1/2+Y,1/2-Z,1/2+X'
        IF(IS.EQ. 47) OP =' 1/2-Y,1/2+Z,1/2+X'
        IF(IS.EQ. 48) OP =' 1/2+Y,1/2+Z,1/2-X'
        RETURN
      ENDIF
      IF(I.EQ.225) THEN
        NO_TAB  =  205
        NS_TAB  =   24
        SG_TAB1 = 'P 21/a -3'
        SG_TAB2 = 'Pa-3'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ.  7) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.  8) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 11) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 12) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 13) OP =' -X,-Y,-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ. 15) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ. 17) OP =' -Z,-X,-Y'
        IF(IS.EQ. 18) OP =' 1/2-Z,1/2+X,Y'
        IF(IS.EQ. 19) OP =' 1/2+Z,X,1/2-Y'
        IF(IS.EQ. 20) OP =' Z,1/2-X,1/2+Y'
        IF(IS.EQ. 21) OP =' -Y,-Z,-X'
        IF(IS.EQ. 22) OP =' Y,1/2-Z,1/2+X'
        IF(IS.EQ. 23) OP =' 1/2-Y,1/2+Z,X'
        IF(IS.EQ. 24) OP =' 1/2+Y,Z,1/2-X'
        RETURN
      ENDIF
      IF(I.EQ.226) THEN
        NO_TAB  =  206
        NS_TAB  =   48
        SG_TAB1 = 'I 21/a -3'
        SG_TAB2 = 'Ia-3'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ.  7) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.  8) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 11) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 12) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 13) OP =' -X,-Y,-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ. 15) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ. 17) OP =' -Z,-X,-Y'
        IF(IS.EQ. 18) OP =' 1/2-Z,1/2+X,Y'
        IF(IS.EQ. 19) OP =' 1/2+Z,X,1/2-Y'
        IF(IS.EQ. 20) OP =' Z,1/2-X,1/2+Y'
        IF(IS.EQ. 21) OP =' -Y,-Z,-X'
        IF(IS.EQ. 22) OP =' Y,1/2-Z,1/2+X'
        IF(IS.EQ. 23) OP =' 1/2-Y,1/2+Z,X'
        IF(IS.EQ. 24) OP =' 1/2+Y,Z,1/2-X'
        IF(IS.EQ. 25) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 26) OP =' -X,1/2-Y,Z'
        IF(IS.EQ. 27) OP =' 1/2-X,+Y,-Z'
        IF(IS.EQ. 28) OP =' X,-Y,1/2-Z'
        IF(IS.EQ. 29) OP =' 1/2+Z,1/2+X,1/2+Y'
        IF(IS.EQ. 30) OP =' Z,-X,1/2-Y'
        IF(IS.EQ. 31) OP =' -Z,1/2-X,Y'
        IF(IS.EQ. 32) OP =' 1/2-Z,X,-Y'
        IF(IS.EQ. 33) OP =' 1/2+Y,1/2+Z,1/2+X'
        IF(IS.EQ. 34) OP =' 1/2-Y,Z,-X'
        IF(IS.EQ. 35) OP =' Y,-Z,1/2-X'
        IF(IS.EQ. 36) OP =' -Y,1/2-Z,X'
        IF(IS.EQ. 37) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 38) OP =' X,1/2+Y,-Z'
        IF(IS.EQ. 39) OP =' 1/2+X,-Y,Z'
        IF(IS.EQ. 40) OP =' -X,Y,1/2+Z'
        IF(IS.EQ. 41) OP =' 1/2-Z,1/2-X,1/2-Y'
        IF(IS.EQ. 42) OP =' -Z,X,1/2+Y'
        IF(IS.EQ. 43) OP =' Z,1/2+X,-Y'
        IF(IS.EQ. 44) OP =' 1/2+Z,-X,Y'
        IF(IS.EQ. 45) OP =' 1/2-Y,1/2-Z,1/2-X'
        IF(IS.EQ. 46) OP =' 1/2+Y,-Z,X'
        IF(IS.EQ. 47) OP =' -Y,Z,1/2+X'
        IF(IS.EQ. 48) OP =' Y,1/2+Z,-X'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_32(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.227) THEN
        NO_TAB  =  207
        NS_TAB  =   24
        SG_TAB1 = 'P 4 3 2'
        SG_TAB2 = 'P432'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' Y,X,-Z'
        IF(IS.EQ. 14) OP =' -Y,-X,-Z'
        IF(IS.EQ. 15) OP =' Y,-X,Z'
        IF(IS.EQ. 16) OP =' -Y,X,Z'
        IF(IS.EQ. 17) OP =' X,Z,-Y'
        IF(IS.EQ. 18) OP =' -X,Z,Y'
        IF(IS.EQ. 19) OP =' -X,-Z,-Y'
        IF(IS.EQ. 20) OP =' X,-Z,Y'
        IF(IS.EQ. 21) OP =' Z,Y,-X'
        IF(IS.EQ. 22) OP =' Z,-Y,X'
        IF(IS.EQ. 23) OP =' -Z,Y,X'
        IF(IS.EQ. 24) OP =' -Z,-Y,-X'
        RETURN
      ENDIF
      IF(I.EQ.228) THEN
        NO_TAB  =  208
        NS_TAB  =   24
        SG_TAB1 = 'P 42 3 2'
        SG_TAB2 = 'P4232'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ. 14) OP =' 1/2-Y,1/2-X,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ. 17) OP =' 1/2+X,1/2+Z,1/2-Y'
        IF(IS.EQ. 18) OP =' 1/2-X,1/2+Z,1/2+Y'
        IF(IS.EQ. 19) OP =' 1/2-X,1/2-Z,1/2-Y'
        IF(IS.EQ. 20) OP =' 1/2+X,1/2-Z,1/2+Y'
        IF(IS.EQ. 21) OP =' 1/2+Z,1/2+Y,1/2-X'
        IF(IS.EQ. 22) OP =' 1/2+Z,1/2-Y,1/2+X'
        IF(IS.EQ. 23) OP =' 1/2-Z,1/2+Y,1/2+X'
        IF(IS.EQ. 24) OP =' 1/2-Z,1/2-Y,1/2-X'
        RETURN
      ENDIF
      IF(I.EQ.229) THEN
        NO_TAB  =  209
        NS_TAB  =   96
        SG_TAB1 = 'F 4 3 2'
        SG_TAB2 = 'F432'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' Y,X,-Z'
        IF(IS.EQ. 14) OP =' -Y,-X,-Z'
        IF(IS.EQ. 15) OP =' Y,-X,Z'
        IF(IS.EQ. 16) OP =' -Y,X,Z'
        IF(IS.EQ. 17) OP =' X,Z,-Y'
        IF(IS.EQ. 18) OP =' -X,Z,Y'
        IF(IS.EQ. 19) OP =' -X,-Z,-Y'
        IF(IS.EQ. 20) OP =' X,-Z,Y'
        IF(IS.EQ. 21) OP =' Z,Y,-X'
        IF(IS.EQ. 22) OP =' Z,-Y,X'
        IF(IS.EQ. 23) OP =' -Z,Y,X'
        IF(IS.EQ. 24) OP =' -Z,-Y,-X'
        IF(IS.EQ. 25) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 26) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ. 27) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ. 28) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ. 29) OP =' Z,1/2+X,1/2+Y'
        IF(IS.EQ. 30) OP =' Z,1/2-X,1/2-Y'
        IF(IS.EQ. 31) OP =' -Z,1/2-X,1/2+Y'
        IF(IS.EQ. 32) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ. 33) OP =' Y,1/2+Z,1/2+X'
        IF(IS.EQ. 34) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 35) OP =' Y,1/2-Z,1/2-X'
        IF(IS.EQ. 36) OP =' -Y,1/2-Z,1/2+X'
        IF(IS.EQ. 37) OP =' Y,1/2+X,1/2-Z'
        IF(IS.EQ. 38) OP =' -Y,1/2-X,1/2-Z'
        IF(IS.EQ. 39) OP =' Y,1/2-X,1/2+Z'
        IF(IS.EQ. 40) OP =' -Y,1/2+X,1/2+Z'
        IF(IS.EQ. 41) OP =' X,1/2+Z,1/2-Y'
        IF(IS.EQ. 42) OP =' -X,1/2+Z,1/2+Y'
        IF(IS.EQ. 43) OP =' -X,1/2-Z,1/2-Y'
        IF(IS.EQ. 44) OP =' X,1/2-Z,1/2+Y'
        IF(IS.EQ. 45) OP =' Z,1/2+Y,1/2-X'
        IF(IS.EQ. 46) OP =' Z,1/2-Y,1/2+X'
        IF(IS.EQ. 47) OP =' -Z,1/2+Y,1/2+X'
        IF(IS.EQ. 48) OP =' -Z,1/2-Y,1/2-X'
        IF(IS.EQ. 49) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 50) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 51) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 52) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ. 53) OP =' 1/2+Z,X,1/2+Y'
        IF(IS.EQ. 54) OP =' 1/2+Z,-X,1/2-Y'
        IF(IS.EQ. 55) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ. 56) OP =' 1/2-Z,X,1/2-Y'
        IF(IS.EQ. 57) OP =' 1/2+Y,Z,1/2+X'
        IF(IS.EQ. 58) OP =' 1/2-Y,Z,1/2-X'
        IF(IS.EQ. 59) OP =' 1/2+Y,-Z,1/2-X'
        IF(IS.EQ. 60) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 61) OP =' 1/2+Y,X,1/2-Z'
        IF(IS.EQ. 62) OP =' 1/2-Y,-X,1/2-Z'
        IF(IS.EQ. 63) OP =' 1/2+Y,-X,1/2+Z'
        IF(IS.EQ. 64) OP =' 1/2-Y,X,1/2+Z'
        IF(IS.EQ. 65) OP =' 1/2+X,Z,1/2-Y'
        IF(IS.EQ. 66) OP =' 1/2-X,Z,1/2+Y'
        IF(IS.EQ. 67) OP =' 1/2-X,-Z,1/2-Y'
        IF(IS.EQ. 68) OP =' 1/2+X,-Z,1/2+Y'
        IF(IS.EQ. 69) OP =' 1/2+Z,Y,1/2-X'
        IF(IS.EQ. 70) OP =' 1/2+Z,-Y,1/2+X'
        IF(IS.EQ. 71) OP =' 1/2-Z,Y,1/2+X'
        IF(IS.EQ. 72) OP =' 1/2-Z,-Y,1/2-X'
        IF(IS.EQ. 73) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 74) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 75) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ. 76) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 77) OP =' 1/2+Z,1/2+X,Y'
        IF(IS.EQ. 78) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ. 79) OP =' 1/2-Z,1/2-X,Y'
        IF(IS.EQ. 80) OP =' 1/2-Z,1/2+X,-Y'
        IF(IS.EQ. 81) OP =' 1/2+Y,1/2+Z,X'
        IF(IS.EQ. 82) OP =' 1/2-Y,1/2+Z,-X'
        IF(IS.EQ. 83) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 84) OP =' 1/2-Y,1/2-Z,X'
        IF(IS.EQ. 85) OP =' 1/2+Y,1/2+X,-Z'
        IF(IS.EQ. 86) OP =' 1/2-Y,1/2-X,-Z'
        IF(IS.EQ. 87) OP =' 1/2+Y,1/2-X,Z'
        IF(IS.EQ. 88) OP =' 1/2-Y,1/2+X,Z'
        IF(IS.EQ. 89) OP =' 1/2+X,1/2+Z,-Y'
        IF(IS.EQ. 90) OP =' 1/2-X,1/2+Z,Y'
        IF(IS.EQ. 91) OP =' 1/2-X,1/2-Z,-Y'
        IF(IS.EQ. 92) OP =' 1/2+X,1/2-Z,Y'
        IF(IS.EQ. 93) OP =' 1/2+Z,1/2+Y,-X'
        IF(IS.EQ. 94) OP =' 1/2+Z,1/2-Y,X'
        IF(IS.EQ. 95) OP =' 1/2-Z,1/2+Y,X'
        IF(IS.EQ. 96) OP =' 1/2-Z,1/2-Y,-X'
        RETURN
      ENDIF
      IF(I.EQ.230) THEN
        NO_TAB  =  210
        NS_TAB  =   96
        SG_TAB1 = 'F 41 3 2'
        SG_TAB2 = 'F4132'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' 1/2+Z,-X,1/2-Y'
        IF(IS.EQ.  7) OP =' -Z,1/2-X,1/2+Y'
        IF(IS.EQ.  8) OP =' 1/2-Z,1/2+X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' 1/2-Y,1/2+Z,-X'
        IF(IS.EQ. 11) OP =' 1/2+Y,-Z,1/2-X'
        IF(IS.EQ. 12) OP =' -Y,1/2-Z,1/2+X'
        IF(IS.EQ. 13) OP =' 3/4+Y,1/4+X,3/4-Z'
        IF(IS.EQ. 14) OP =' 1/4-Y,1/4-X,1/4-Z'
        IF(IS.EQ. 15) OP =' 1/4+Y,3/4-X,3/4+Z'
        IF(IS.EQ. 16) OP =' 3/4-Y,3/4+X,1/4+Z'
        IF(IS.EQ. 17) OP =' 3/4+X,1/4+Z,3/4-Y'
        IF(IS.EQ. 18) OP =' 3/4-X,3/4+Z,1/4+Y'
        IF(IS.EQ. 19) OP =' 1/4-X,1/4-Z,1/4-Y'
        IF(IS.EQ. 20) OP =' 1/4+X,3/4-Z,3/4+Y'
        IF(IS.EQ. 21) OP =' 3/4+Z,1/4+Y,3/4-X'
        IF(IS.EQ. 22) OP =' 1/4+Z,3/4-Y,3/4+X'
        IF(IS.EQ. 23) OP =' 3/4-Z,3/4+Y,1/4+X'
        IF(IS.EQ. 24) OP =' 1/4-Z,1/4-Y,1/4-X'
        IF(IS.EQ. 25) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 26) OP =' -X,-Y,Z'
        IF(IS.EQ. 27) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 28) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 29) OP =' Z,1/2+X,1/2+Y'
        IF(IS.EQ. 30) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ. 31) OP =' -Z,-X,Y'
        IF(IS.EQ. 32) OP =' 1/2-Z,X,1/2-Y'
        IF(IS.EQ. 33) OP =' Y,1/2+Z,1/2+X'
        IF(IS.EQ. 34) OP =' 1/2-Y,Z,1/2-X'
        IF(IS.EQ. 35) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 36) OP =' -Y,-Z,X'
        IF(IS.EQ. 37) OP =' 3/4+Y,3/4+X,1/4-Z'
        IF(IS.EQ. 38) OP =' 1/4-Y,3/4-X,3/4-Z'
        IF(IS.EQ. 39) OP =' 1/4+Y,1/4-X,1/4+Z'
        IF(IS.EQ. 40) OP =' 3/4-Y,1/4+X,3/4+Z'
        IF(IS.EQ. 41) OP =' 3/4+X,3/4+Z,1/4-Y'
        IF(IS.EQ. 42) OP =' 3/4-X,1/4+Z,3/4+Y'
        IF(IS.EQ. 43) OP =' 1/4-X,3/4-Z,3/4-Y'
        IF(IS.EQ. 44) OP =' 1/4+X,1/4-Z,1/4+Y'
        IF(IS.EQ. 45) OP =' 3/4+Z,3/4+Y,1/4-X'
        IF(IS.EQ. 46) OP =' 1/4+Z,1/4-Y,1/4+X'
        IF(IS.EQ. 47) OP =' 3/4-Z,1/4+Y,3/4+X'
        IF(IS.EQ. 48) OP =' 1/4-Z,3/4-Y,3/4-X'
        IF(IS.EQ. 49) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 50) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 51) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ. 52) OP =' X,-Y,-Z'
        IF(IS.EQ. 53) OP =' 1/2+Z,X,1/2+Y'
        IF(IS.EQ. 54) OP =' Z,-X,-Y'
        IF(IS.EQ. 55) OP =' 1/2-Z,1/2-X,Y'
        IF(IS.EQ. 56) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ. 57) OP =' 1/2+Y,Z,1/2+X'
        IF(IS.EQ. 58) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 59) OP =' Y,-Z,-X'
        IF(IS.EQ. 60) OP =' 1/2-Y,1/2-Z,X'
        IF(IS.EQ. 61) OP =' 1/4+Y,1/4+X,1/4-Z'
        IF(IS.EQ. 62) OP =' 3/4-Y,1/4-X,3/4-Z'
        IF(IS.EQ. 63) OP =' 3/4+Y,3/4-X,1/4+Z'
        IF(IS.EQ. 64) OP =' 1/4-Y,3/4+X,3/4+Z'
        IF(IS.EQ. 65) OP =' 1/4+X,1/4+Z,1/4-Y'
        IF(IS.EQ. 66) OP =' 1/4-X,3/4+Z,3/4+Y'
        IF(IS.EQ. 67) OP =' 3/4-X,1/4-Z,3/4-Y'
        IF(IS.EQ. 68) OP =' 3/4+X,3/4-Z,1/4+Y'
        IF(IS.EQ. 69) OP =' 1/4+Z,1/4+Y,1/4-X'
        IF(IS.EQ. 70) OP =' 3/4+Z,3/4-Y,1/4+X'
        IF(IS.EQ. 71) OP =' 1/4-Z,3/4+Y,3/4+X'
        IF(IS.EQ. 72) OP =' 3/4-Z,1/4-Y,3/4-X'
        IF(IS.EQ. 73) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 74) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 75) OP =' -X,Y,-Z'
        IF(IS.EQ. 76) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ. 77) OP =' 1/2+Z,1/2+X,Y'
        IF(IS.EQ. 78) OP =' Z,1/2-X,1/2-Y'
        IF(IS.EQ. 79) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ. 80) OP =' -Z,X,-Y'
        IF(IS.EQ. 81) OP =' 1/2+Y,1/2+Z,X'
        IF(IS.EQ. 82) OP =' -Y,Z,-X'
        IF(IS.EQ. 83) OP =' Y,1/2-Z,1/2-X'
        IF(IS.EQ. 84) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 85) OP =' 1/4+Y,3/4+X,3/4-Z'
        IF(IS.EQ. 86) OP =' 3/4-Y,3/4-X,1/4-Z'
        IF(IS.EQ. 87) OP =' 3/4+Y,1/4-X,3/4+Z'
        IF(IS.EQ. 88) OP =' 1/4-Y,1/4+X,1/4+Z'
        IF(IS.EQ. 89) OP =' 1/4+X,3/4+Z,3/4-Y'
        IF(IS.EQ. 90) OP =' 1/4-X,1/4+Z,1/4+Y'
        IF(IS.EQ. 91) OP =' 3/4-X,3/4-Z,1/4-Y'
        IF(IS.EQ. 92) OP =' 3/4+X,1/4-Z,3/4+Y'
        IF(IS.EQ. 93) OP =' 1/4+Z,3/4+Y,3/4-X'
        IF(IS.EQ. 94) OP =' 3/4+Z,1/4-Y,3/4+X'
        IF(IS.EQ. 95) OP =' 1/4-Z,1/4+Y,1/4+X'
        IF(IS.EQ. 96) OP =' 3/4-Z,3/4-Y,1/4-X'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_33(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.231) THEN
        NO_TAB  =  211
        NS_TAB  =   48
        SG_TAB1 = 'I 4 3 2'
        SG_TAB2 = 'I432'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' Y,X,-Z'
        IF(IS.EQ. 14) OP =' -Y,-X,-Z'
        IF(IS.EQ. 15) OP =' Y,-X,Z'
        IF(IS.EQ. 16) OP =' -Y,X,Z'
        IF(IS.EQ. 17) OP =' X,Z,-Y'
        IF(IS.EQ. 18) OP =' -X,Z,Y'
        IF(IS.EQ. 19) OP =' -X,-Z,-Y'
        IF(IS.EQ. 20) OP =' X,-Z,Y'
        IF(IS.EQ. 21) OP =' Z,Y,-X'
        IF(IS.EQ. 22) OP =' Z,-Y,X'
        IF(IS.EQ. 23) OP =' -Z,Y,X'
        IF(IS.EQ. 24) OP =' -Z,-Y,-X'
        IF(IS.EQ. 25) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 26) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 27) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ. 28) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ. 29) OP =' 1/2+Z,1/2+X,1/2+Y'
        IF(IS.EQ. 30) OP =' 1/2+Z,1/2-X,1/2-Y'
        IF(IS.EQ. 31) OP =' 1/2-Z,1/2-X,1/2+Y'
        IF(IS.EQ. 32) OP =' 1/2-Z,1/2+X,1/2-Y'
        IF(IS.EQ. 33) OP =' 1/2+Y,1/2+Z,1/2+X'
        IF(IS.EQ. 34) OP =' 1/2-Y,1/2+Z,1/2-X'
        IF(IS.EQ. 35) OP =' 1/2+Y,1/2-Z,1/2-X'
        IF(IS.EQ. 36) OP =' 1/2-Y,1/2-Z,1/2+X'
        IF(IS.EQ. 37) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ. 38) OP =' 1/2-Y,1/2-X,1/2-Z'
        IF(IS.EQ. 39) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ. 40) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ. 41) OP =' 1/2+X,1/2+Z,1/2-Y'
        IF(IS.EQ. 42) OP =' 1/2-X,1/2+Z,1/2+Y'
        IF(IS.EQ. 43) OP =' 1/2-X,1/2-Z,1/2-Y'
        IF(IS.EQ. 44) OP =' 1/2+X,1/2-Z,1/2+Y'
        IF(IS.EQ. 45) OP =' 1/2+Z,1/2+Y,1/2-X'
        IF(IS.EQ. 46) OP =' 1/2+Z,1/2-Y,1/2+X'
        IF(IS.EQ. 47) OP =' 1/2-Z,1/2+Y,1/2+X'
        IF(IS.EQ. 48) OP =' 1/2-Z,1/2-Y,1/2-X'
        RETURN
      ENDIF
      IF(I.EQ.232) THEN
        NO_TAB  =  212
        NS_TAB  =   24
        SG_TAB1 = 'P 43 3 2'
        SG_TAB2 = 'P4332'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ.  7) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.  8) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 11) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 12) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 13) OP =' 1/4+Y,3/4+X,3/4-Z'
        IF(IS.EQ. 14) OP =' 1/4-Y,1/4-X,1/4-Z'
        IF(IS.EQ. 15) OP =' 3/4+Y,3/4-X,1/4+Z'
        IF(IS.EQ. 16) OP =' 3/4-Y,1/4+X,3/4+Z'
        IF(IS.EQ. 17) OP =' 1/4+X,3/4+Z,3/4-Y'
        IF(IS.EQ. 18) OP =' 3/4-X,1/4+Z,3/4+Y'
        IF(IS.EQ. 19) OP =' 1/4-X,1/4-Z,1/4-Y'
        IF(IS.EQ. 20) OP =' 3/4+X,3/4-Z,1/4+Y'
        IF(IS.EQ. 21) OP =' 1/4+Z,3/4+Y,3/4-X'
        IF(IS.EQ. 22) OP =' 3/4+Z,3/4-Y,1/4+X'
        IF(IS.EQ. 23) OP =' 3/4-Z,1/4+Y,3/4+X'
        IF(IS.EQ. 24) OP =' 1/4-Z,1/4-Y,1/4-X'
        RETURN
      ENDIF
      IF(I.EQ.233) THEN
        NO_TAB  =  213
        NS_TAB  =   24
        SG_TAB1 = 'P 41 3 2'
        SG_TAB2 = 'P4132'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ.  7) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.  8) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 11) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 12) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 13) OP =' 3/4+Y,1/4+X,1/4-Z'
        IF(IS.EQ. 14) OP =' 3/4-Y,3/4-X,3/4-Z'
        IF(IS.EQ. 15) OP =' 1/4+Y,1/4-X,3/4+Z'
        IF(IS.EQ. 16) OP =' 1/4-Y,3/4+X,1/4+Z'
        IF(IS.EQ. 17) OP =' 3/4+X,1/4+Z,1/4-Y'
        IF(IS.EQ. 18) OP =' 1/4-X,3/4+Z,1/4+Y'
        IF(IS.EQ. 19) OP =' 3/4-X,3/4-Z,3/4-Y'
        IF(IS.EQ. 20) OP =' 1/4+X,1/4-Z,3/4+Y'
        IF(IS.EQ. 21) OP =' 3/4+Z,1/4+Y,1/4-X'
        IF(IS.EQ. 22) OP =' 1/4+Z,1/4-Y,3/4+X'
        IF(IS.EQ. 23) OP =' 1/4-Z,3/4+Y,1/4+X'
        IF(IS.EQ. 24) OP =' 3/4-Z,3/4-Y,3/4-X'
        RETURN
      ENDIF
      IF(I.EQ.234) THEN
        NO_TAB  =  214
        NS_TAB  =   48
        SG_TAB1 = 'I 41 3 2'
        SG_TAB2 = 'I4132'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ.  7) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.  8) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 11) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 12) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 13) OP =' 3/4+Y,1/4+X,1/4-Z'
        IF(IS.EQ. 14) OP =' 3/4-Y,3/4-X,3/4-Z'
        IF(IS.EQ. 15) OP =' 1/4+Y,1/4-X,3/4+Z'
        IF(IS.EQ. 16) OP =' 1/4-Y,3/4+X,1/4+Z'
        IF(IS.EQ. 17) OP =' 3/4+X,1/4+Z,1/4-Y'
        IF(IS.EQ. 18) OP =' 1/4-X,3/4+Z,1/4+Y'
        IF(IS.EQ. 19) OP =' 3/4-X,3/4-Z,3/4-Y'
        IF(IS.EQ. 20) OP =' 1/4+X,1/4-Z,3/4+Y'
        IF(IS.EQ. 21) OP =' 3/4+Z,1/4+Y,1/4-X'
        IF(IS.EQ. 22) OP =' 1/4+Z,1/4-Y,3/4+X'
        IF(IS.EQ. 23) OP =' 1/4-Z,3/4+Y,1/4+X'
        IF(IS.EQ. 24) OP =' 3/4-Z,3/4-Y,3/4-X'
        IF(IS.EQ. 25) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 26) OP =' -X,1/2-Y,Z'
        IF(IS.EQ. 27) OP =' 1/2-X,Y,-Z'
        IF(IS.EQ. 28) OP =' X,-Y,1/2-Z'
        IF(IS.EQ. 29) OP =' 1/2+Z,1/2+X,1/2+Y'
        IF(IS.EQ. 30) OP =' Z,-X,1/2-Y'
        IF(IS.EQ. 31) OP =' -Z,1/2-X,Y'
        IF(IS.EQ. 32) OP =' 1/2-Z,X,-Y'
        IF(IS.EQ. 33) OP =' 1/2+Y,1/2+Z,1/2+X'
        IF(IS.EQ. 34) OP =' 1/2-Y,Z,-X'
        IF(IS.EQ. 35) OP =' Y,-Z,1/2-X'
        IF(IS.EQ. 36) OP =' -Y,1/2-Z,X'
        IF(IS.EQ. 37) OP =' 1/4+Y,3/4+X,3/4-Z'
        IF(IS.EQ. 38) OP =' 1/4-Y,1/4-X,1/4-Z'
        IF(IS.EQ. 39) OP =' 3/4+Y,3/4-X,1/4+Z'
        IF(IS.EQ. 40) OP =' 3/4-Y,1/4+X,3/4+Z'
        IF(IS.EQ. 41) OP =' 1/4+X,3/4+Z,3/4-Y'
        IF(IS.EQ. 42) OP =' 3/4-X,1/4+Z,3/4+Y'
        IF(IS.EQ. 43) OP =' 1/4-X,1/4-Z,1/4-Y'
        IF(IS.EQ. 44) OP =' 3/4+X,3/4-Z,1/4+Y'
        IF(IS.EQ. 45) OP =' 1/4+Z,3/4+Y,3/4-X'
        IF(IS.EQ. 46) OP =' 3/4+Z,3/4-Y,1/4+X'
        IF(IS.EQ. 47) OP =' 3/4-Z,1/4+Y,3/4+X'
        IF(IS.EQ. 48) OP =' 1/4-Z,1/4-Y,1/4-X'
        RETURN
      ENDIF
      IF(I.EQ.235) THEN
        NO_TAB  =  215
        NS_TAB  =   24
        SG_TAB1 = 'P -4 3 m'
        SG_TAB2 = 'P-43m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' Y,X,Z'
        IF(IS.EQ. 14) OP =' -Y,-X,Z'
        IF(IS.EQ. 15) OP =' Y,-X,-Z'
        IF(IS.EQ. 16) OP =' -Y,X,-Z'
        IF(IS.EQ. 17) OP =' X,Z,Y'
        IF(IS.EQ. 18) OP =' -X,Z,-Y'
        IF(IS.EQ. 19) OP =' -X,-Z,Y'
        IF(IS.EQ. 20) OP =' X,-Z,-Y'
        IF(IS.EQ. 21) OP =' Z,Y,X'
        IF(IS.EQ. 22) OP =' Z,-Y,-X'
        IF(IS.EQ. 23) OP =' -Z,Y,-X'
        IF(IS.EQ. 24) OP =' -Z,-Y,X'
        RETURN
      ENDIF
      RETURN
      END


      SUBROUTINE GET_SPACE_GROUP_INFO_34(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.236) THEN
        NO_TAB  =  216
        NS_TAB  =   96
        SG_TAB1 = 'F -4 3 m'
        SG_TAB2 = 'F-43m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' Y,X,Z'
        IF(IS.EQ. 14) OP =' -Y,-X,Z'
        IF(IS.EQ. 15) OP =' Y,-X,-Z'
        IF(IS.EQ. 16) OP =' -Y,X,-Z'
        IF(IS.EQ. 17) OP =' X,Z,Y'
        IF(IS.EQ. 18) OP =' -X,Z,-Y'
        IF(IS.EQ. 19) OP =' -X,-Z,Y'
        IF(IS.EQ. 20) OP =' X,-Z,-Y'
        IF(IS.EQ. 21) OP =' Z,Y,X'
        IF(IS.EQ. 22) OP =' Z,-Y,-X'
        IF(IS.EQ. 23) OP =' -Z,Y,-X'
        IF(IS.EQ. 24) OP =' -Z,-Y,X'
        IF(IS.EQ. 25) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 26) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ. 27) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ. 28) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ. 29) OP =' Z,1/2+X,1/2+Y'
        IF(IS.EQ. 30) OP =' Z,1/2-X,1/2-Y'
        IF(IS.EQ. 31) OP =' -Z,1/2-X,1/2+Y'
        IF(IS.EQ. 32) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ. 33) OP =' Y,1/2+Z,1/2+X'
        IF(IS.EQ. 34) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 35) OP =' Y,1/2-Z,1/2-X'
        IF(IS.EQ. 36) OP =' -Y,1/2-Z,1/2+X'
        IF(IS.EQ. 37) OP =' Y,1/2+X,1/2+Z'
        IF(IS.EQ. 38) OP =' -Y,1/2-X,1/2+Z'
        IF(IS.EQ. 39) OP =' Y,1/2-X,1/2-Z'
        IF(IS.EQ. 40) OP =' -Y,1/2+X,1/2-Z'
        IF(IS.EQ. 41) OP =' X,1/2+Z,1/2+Y'
        IF(IS.EQ. 42) OP =' -X,1/2+Z,1/2-Y'
        IF(IS.EQ. 43) OP =' -X,1/2-Z,1/2+Y'
        IF(IS.EQ. 44) OP =' X,1/2-Z,1/2-Y'
        IF(IS.EQ. 45) OP =' Z,1/2+Y,1/2+X'
        IF(IS.EQ. 46) OP =' Z,1/2-Y,1/2-X'
        IF(IS.EQ. 47) OP =' -Z,1/2+Y,1/2-X'
        IF(IS.EQ. 48) OP =' -Z,1/2-Y,1/2+X'
        IF(IS.EQ. 49) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 50) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 51) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 52) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ. 53) OP =' 1/2+Z,X,1/2+Y'
        IF(IS.EQ. 54) OP =' 1/2+Z,-X,1/2-Y'
        IF(IS.EQ. 55) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ. 56) OP =' 1/2-Z,X,1/2-Y'
        IF(IS.EQ. 57) OP =' 1/2+Y,Z,1/2+X'
        IF(IS.EQ. 58) OP =' 1/2-Y,Z,1/2-X'
        IF(IS.EQ. 59) OP =' 1/2+Y,-Z,1/2-X'
        IF(IS.EQ. 60) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 61) OP =' 1/2+Y,X,1/2+Z'
        IF(IS.EQ. 62) OP =' 1/2-Y,-X,1/2+Z'
        IF(IS.EQ. 63) OP =' 1/2+Y,-X,1/2-Z'
        IF(IS.EQ. 64) OP =' 1/2-Y,X,1/2-Z'
        IF(IS.EQ. 65) OP =' 1/2+X,Z,1/2+Y'
        IF(IS.EQ. 66) OP =' 1/2-X,Z,1/2-Y'
        IF(IS.EQ. 67) OP =' 1/2-X,-Z,1/2+Y'
        IF(IS.EQ. 68) OP =' 1/2+X,-Z,1/2-Y'
        IF(IS.EQ. 69) OP =' 1/2+Z,Y,1/2+X'
        IF(IS.EQ. 70) OP =' 1/2+Z,-Y,1/2-X'
        IF(IS.EQ. 71) OP =' 1/2-Z,Y,1/2-X'
        IF(IS.EQ. 72) OP =' 1/2-Z,-Y,1/2+X'
        IF(IS.EQ. 73) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 74) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 75) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ. 76) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 77) OP =' 1/2+Z,1/2+X,Y'
        IF(IS.EQ. 78) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ. 79) OP =' 1/2-Z,1/2-X,Y'
        IF(IS.EQ. 80) OP =' 1/2-Z,1/2+X,-Y'
        IF(IS.EQ. 81) OP =' 1/2+Y,1/2+Z,X'
        IF(IS.EQ. 82) OP =' 1/2-Y,1/2+Z,-X'
        IF(IS.EQ. 83) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 84) OP =' 1/2-Y,1/2-Z,X'
        IF(IS.EQ. 85) OP =' 1/2+Y,1/2+X,Z'
        IF(IS.EQ. 86) OP =' 1/2-Y,1/2-X,Z'
        IF(IS.EQ. 87) OP =' 1/2+Y,1/2-X,-Z'
        IF(IS.EQ. 88) OP =' 1/2-Y,1/2+X,-Z'
        IF(IS.EQ. 89) OP =' 1/2+X,1/2+Z,Y'
        IF(IS.EQ. 90) OP =' 1/2-X,1/2+Z,-Y'
        IF(IS.EQ. 91) OP =' 1/2-X,1/2-Z,Y'
        IF(IS.EQ. 92) OP =' 1/2+X,1/2-Z,-Y'
        IF(IS.EQ. 93) OP =' 1/2+Z,1/2+Y,X'
        IF(IS.EQ. 94) OP =' 1/2+Z,1/2-Y,-X'
        IF(IS.EQ. 95) OP =' 1/2-Z,1/2+Y,-X'
        IF(IS.EQ. 96) OP =' 1/2-Z,1/2-Y,X'
        RETURN
      ENDIF
      IF(I.EQ.237) THEN
        NO_TAB  =  217
        NS_TAB  =   48
        SG_TAB1 = 'I -4 3 m'
        SG_TAB2 = 'I-43m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' Y,X,Z'
        IF(IS.EQ. 14) OP =' -Y,-X,Z'
        IF(IS.EQ. 15) OP =' Y,-X,-Z'
        IF(IS.EQ. 16) OP =' -Y,X,-Z'
        IF(IS.EQ. 17) OP =' X,Z,Y'
        IF(IS.EQ. 18) OP =' -X,Z,-Y'
        IF(IS.EQ. 19) OP =' -X,-Z,Y'
        IF(IS.EQ. 20) OP =' X,-Z,-Y'
        IF(IS.EQ. 21) OP =' Z,Y,X'
        IF(IS.EQ. 22) OP =' Z,-Y,-X'
        IF(IS.EQ. 23) OP =' -Z,Y,-X'
        IF(IS.EQ. 24) OP =' -Z,-Y,X'
        IF(IS.EQ. 25) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 26) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 27) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ. 28) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ. 29) OP =' 1/2+Z,1/2+X,1/2+Y'
        IF(IS.EQ. 30) OP =' 1/2+Z,1/2-X,1/2-Y'
        IF(IS.EQ. 31) OP =' 1/2-Z,1/2-X,1/2+Y'
        IF(IS.EQ. 32) OP =' 1/2-Z,1/2+X,1/2-Y'
        IF(IS.EQ. 33) OP =' 1/2+Y,1/2+Z,1/2+X'
        IF(IS.EQ. 34) OP =' 1/2-Y,1/2+Z,1/2-X'
        IF(IS.EQ. 35) OP =' 1/2+Y,1/2-Z,1/2-X'
        IF(IS.EQ. 36) OP =' 1/2-Y,1/2-Z,1/2+X'
        IF(IS.EQ. 37) OP =' 1/2+Y,1/2+X,1/2+Z'
        IF(IS.EQ. 38) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 39) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 40) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 41) OP =' 1/2+X,1/2+Z,1/2+Y'
        IF(IS.EQ. 42) OP =' 1/2-X,1/2+Z,1/2-Y'
        IF(IS.EQ. 43) OP =' 1/2-X,1/2-Z,1/2+Y'
        IF(IS.EQ. 44) OP =' 1/2+X,1/2-Z,1/2-Y'
        IF(IS.EQ. 45) OP =' 1/2+Z,1/2+Y,1/2+X'
        IF(IS.EQ. 46) OP =' 1/2+Z,1/2-Y,1/2-X'
        IF(IS.EQ. 47) OP =' 1/2-Z,1/2+Y,1/2-X'
        IF(IS.EQ. 48) OP =' 1/2-Z,1/2-Y,1/2+X'
        RETURN
      ENDIF
      IF(I.EQ.238) THEN
        NO_TAB  =  218
        NS_TAB  =   24
        SG_TAB1 = 'P -4 3 n'
        SG_TAB2 = 'P-43n'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' 1/2+Y,1/2+X,1/2+Z'
        IF(IS.EQ. 14) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 15) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 16) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 17) OP =' 1/2+X,1/2+Z,1/2+Y'
        IF(IS.EQ. 18) OP =' 1/2-X,1/2+Z,1/2-Y'
        IF(IS.EQ. 19) OP =' 1/2-X,1/2-Z,1/2+Y'
        IF(IS.EQ. 20) OP =' 1/2+X,1/2-Z,1/2-Y'
        IF(IS.EQ. 21) OP =' 1/2+Z,1/2+Y,1/2+X'
        IF(IS.EQ. 22) OP =' 1/2+Z,1/2-Y,1/2-X'
        IF(IS.EQ. 23) OP =' 1/2-Z,1/2+Y,1/2-X'
        IF(IS.EQ. 24) OP =' 1/2-Z,1/2-Y,1/2+X'
        RETURN
      ENDIF
      IF(I.EQ.239) THEN
        NO_TAB  =  219
        NS_TAB  =   96
        SG_TAB1 = 'F -4 3 c'
        SG_TAB2 = 'F-43c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' 1/2+Y,1/2+X,1/2+Z'
        IF(IS.EQ. 14) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 15) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 16) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 17) OP =' 1/2+X,1/2+Z,1/2+Y'
        IF(IS.EQ. 18) OP =' 1/2-X,1/2+Z,1/2-Y'
        IF(IS.EQ. 19) OP =' 1/2-X,1/2-Z,1/2+Y'
        IF(IS.EQ. 20) OP =' 1/2+X,1/2-Z,1/2-Y'
        IF(IS.EQ. 21) OP =' 1/2+Z,1/2+Y,1/2+X'
        IF(IS.EQ. 22) OP =' 1/2+Z,1/2-Y,1/2-X'
        IF(IS.EQ. 23) OP =' 1/2-Z,1/2+Y,1/2-X'
        IF(IS.EQ. 24) OP =' 1/2-Z,1/2-Y,1/2+X'
        IF(IS.EQ. 25) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 26) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ. 27) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ. 28) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ. 29) OP =' Z,1/2+X,1/2+Y'
        IF(IS.EQ. 30) OP =' Z,1/2-X,1/2-Y'
        IF(IS.EQ. 31) OP =' -Z,1/2-X,1/2+Y'
        IF(IS.EQ. 32) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ. 33) OP =' Y,1/2+Z,1/2+X'
        IF(IS.EQ. 34) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 35) OP =' Y,1/2-Z,1/2-X'
        IF(IS.EQ. 36) OP =' -Y,1/2-Z,1/2+X'
        IF(IS.EQ. 37) OP =' 1/2+Y,X,Z'
        IF(IS.EQ. 38) OP =' 1/2-Y,-X,Z'
        IF(IS.EQ. 39) OP =' 1/2+Y,-X,-Z'
        IF(IS.EQ. 40) OP =' 1/2-Y,X,-Z'
        IF(IS.EQ. 41) OP =' 1/2+X,Z,Y'
        IF(IS.EQ. 42) OP =' 1/2-X,Z,-Y'
        IF(IS.EQ. 43) OP =' 1/2-X,-Z,Y'
        IF(IS.EQ. 44) OP =' 1/2+X,-Z,-Y'
        IF(IS.EQ. 45) OP =' 1/2+Z,Y,X'
        IF(IS.EQ. 46) OP =' 1/2+Z,-Y,-X'
        IF(IS.EQ. 47) OP =' 1/2-Z,Y,-X'
        IF(IS.EQ. 48) OP =' 1/2-Z,-Y,X'
        IF(IS.EQ. 49) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 50) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 51) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 52) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ. 53) OP =' 1/2+Z,X,1/2+Y'
        IF(IS.EQ. 54) OP =' 1/2+Z,-X,1/2-Y'
        IF(IS.EQ. 55) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ. 56) OP =' 1/2-Z,X,1/2-Y'
        IF(IS.EQ. 57) OP =' 1/2+Y,Z,1/2+X'
        IF(IS.EQ. 58) OP =' 1/2-Y,Z,1/2-X'
        IF(IS.EQ. 59) OP =' 1/2+Y,-Z,1/2-X'
        IF(IS.EQ. 60) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 61) OP =' Y,1/2+X,Z'
        IF(IS.EQ. 62) OP =' -Y,1/2-X,Z'
        IF(IS.EQ. 63) OP =' Y,1/2-X,-Z'
        IF(IS.EQ. 64) OP =' -Y,1/2+X,-Z'
        IF(IS.EQ. 65) OP =' X,1/2+Z,Y'
        IF(IS.EQ. 66) OP =' -X,1/2+Z,-Y'
        IF(IS.EQ. 67) OP =' -X,1/2-Z,Y'
        IF(IS.EQ. 68) OP =' X,1/2-Z,-Y'
        IF(IS.EQ. 69) OP =' Z,1/2+Y,X'
        IF(IS.EQ. 70) OP =' Z,1/2-Y,-X'
        IF(IS.EQ. 71) OP =' -Z,1/2+Y,-X'
        IF(IS.EQ. 72) OP =' -Z,1/2-Y,X'
        IF(IS.EQ. 73) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 74) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 75) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ. 76) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 77) OP =' 1/2+Z,1/2+X,Y'
        IF(IS.EQ. 78) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ. 79) OP =' 1/2-Z,1/2-X,Y'
        IF(IS.EQ. 80) OP =' 1/2-Z,1/2+X,-Y'
        IF(IS.EQ. 81) OP =' 1/2+Y,1/2+Z,X'
        IF(IS.EQ. 82) OP =' 1/2-Y,1/2+Z,-X'
        IF(IS.EQ. 83) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 84) OP =' 1/2-Y,1/2-Z,X'
        IF(IS.EQ. 85) OP =' Y,X,1/2+Z'
        IF(IS.EQ. 86) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ. 87) OP =' Y,-X,1/2-Z'
        IF(IS.EQ. 88) OP =' -Y,X,1/2-Z'
        IF(IS.EQ. 89) OP =' X,Z,1/2+Y'
        IF(IS.EQ. 90) OP =' -X,Z,1/2-Y'
        IF(IS.EQ. 91) OP =' -X,-Z,1/2+Y'
        IF(IS.EQ. 92) OP =' X,-Z,1/2-Y'
        IF(IS.EQ. 93) OP =' Z,Y,1/2+X'
        IF(IS.EQ. 94) OP =' Z,-Y,1/2-X'
        IF(IS.EQ. 95) OP =' -Z,Y,1/2-X'
        IF(IS.EQ. 96) OP =' -Z,-Y,1/2+X'
        RETURN
      ENDIF
      RETURN
      END


      SUBROUTINE GET_SPACE_GROUP_INFO_35(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.240) THEN
        NO_TAB  =  220
        NS_TAB  =   48
        SG_TAB1 = 'I -4 3 d'
        SG_TAB2 = 'I-43d'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ.  7) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.  8) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 11) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 12) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 13) OP =' 1/4+Y,1/4+X,1/4+Z'
        IF(IS.EQ. 14) OP =' 1/4-Y,3/4-X,3/4+Z'
        IF(IS.EQ. 15) OP =' 3/4+Y,1/4-X,3/4-Z'
        IF(IS.EQ. 16) OP =' 3/4-Y,3/4+X,1/4-Z'
        IF(IS.EQ. 17) OP =' 1/4+X,1/4+Z,1/4+Y'
        IF(IS.EQ. 18) OP =' 3/4-X,3/4+Z,1/4-Y'
        IF(IS.EQ. 19) OP =' 1/4-X,3/4-Z,3/4+Y'
        IF(IS.EQ. 20) OP =' 3/4+X,1/4-Z,3/4-Y'
        IF(IS.EQ. 21) OP =' 1/4+Z,1/4+Y,1/4+X'
        IF(IS.EQ. 22) OP =' 3/4+Z,1/4-Y,3/4-X'
        IF(IS.EQ. 23) OP =' 3/4-Z,3/4+Y,1/4-X'
        IF(IS.EQ. 24) OP =' 1/4-Z,3/4-Y,3/4+X'
        IF(IS.EQ. 25) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 26) OP =' -X,1/2-Y,Z'
        IF(IS.EQ. 27) OP =' 1/2-X,Y,-Z'
        IF(IS.EQ. 28) OP =' X,-Y,1/2-Z'
        IF(IS.EQ. 29) OP =' 1/2+Z,1/2+X,1/2+Y'
        IF(IS.EQ. 30) OP =' Z,-X,1/2-Y'
        IF(IS.EQ. 31) OP =' -Z,1/2-X,Y'
        IF(IS.EQ. 32) OP =' 1/2-Z,X,-Y'
        IF(IS.EQ. 33) OP =' 1/2+Y,1/2+Z,1/2+X'
        IF(IS.EQ. 34) OP =' 1/2-Y,Z,-X'
        IF(IS.EQ. 35) OP =' Y,-Z,1/2-X'
        IF(IS.EQ. 36) OP =' -Y,1/2-Z,X'
        IF(IS.EQ. 37) OP =' 3/4+Y,3/4+X,3/4+Z'
        IF(IS.EQ. 38) OP =' 3/4-Y,1/4-X,1/4+Z'
        IF(IS.EQ. 39) OP =' 1/4+Y,3/4-X,1/4-Z'
        IF(IS.EQ. 40) OP =' 1/4-Y,1/4+X,3/4-Z'
        IF(IS.EQ. 41) OP =' 3/4+X,3/4+Z,3/4+Y'
        IF(IS.EQ. 42) OP =' 1/4-X,1/4+Z,3/4-Y'
        IF(IS.EQ. 43) OP =' 3/4-X,1/4-Z,1/4+Y'
        IF(IS.EQ. 44) OP =' 1/4+X,3/4-Z,1/4-Y'
        IF(IS.EQ. 45) OP =' 3/4+Z,3/4+Y,3/4+X'
        IF(IS.EQ. 46) OP =' 1/4+Z,3/4-Y,1/4-X'
        IF(IS.EQ. 47) OP =' 1/4-Z,1/4+Y,3/4-X'
        IF(IS.EQ. 48) OP =' 3/4-Z,1/4-Y,1/4+X'
        RETURN
      ENDIF
      IF(I.EQ.241) THEN
        NO_TAB  =  221
        NS_TAB  =   48
        SG_TAB1 = 'P 4/m -3 2/m'
        SG_TAB2 = 'Pm-3m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' Y,X,-Z'
        IF(IS.EQ. 14) OP =' -Y,-X,-Z'
        IF(IS.EQ. 15) OP =' Y,-X,Z'
        IF(IS.EQ. 16) OP =' -Y,X,Z'
        IF(IS.EQ. 17) OP =' X,Z,-Y'
        IF(IS.EQ. 18) OP =' -X,Z,Y'
        IF(IS.EQ. 19) OP =' -X,-Z,-Y'
        IF(IS.EQ. 20) OP =' X,-Z,Y'
        IF(IS.EQ. 21) OP =' Z,Y,-X'
        IF(IS.EQ. 22) OP =' Z,-Y,X'
        IF(IS.EQ. 23) OP =' -Z,Y,X'
        IF(IS.EQ. 24) OP =' -Z,-Y,-X'
        IF(IS.EQ. 25) OP =' -X,-Y,-Z'
        IF(IS.EQ. 26) OP =' X,Y,-Z'
        IF(IS.EQ. 27) OP =' X,-Y,Z'
        IF(IS.EQ. 28) OP =' -X,Y,Z'
        IF(IS.EQ. 29) OP =' -Z,-X,-Y'
        IF(IS.EQ. 30) OP =' -Z,X,Y'
        IF(IS.EQ. 31) OP =' Z,X,-Y'
        IF(IS.EQ. 32) OP =' Z,-X,Y'
        IF(IS.EQ. 33) OP =' -Y,-Z,-X'
        IF(IS.EQ. 34) OP =' Y,-Z,X'
        IF(IS.EQ. 35) OP =' -Y,Z,X'
        IF(IS.EQ. 36) OP =' Y,Z,-X'
        IF(IS.EQ. 37) OP =' -Y,-X,Z'
        IF(IS.EQ. 38) OP =' Y,X,Z'
        IF(IS.EQ. 39) OP =' -Y,X,-Z'
        IF(IS.EQ. 40) OP =' Y,-X,-Z'
        IF(IS.EQ. 41) OP =' -X,-Z,Y'
        IF(IS.EQ. 42) OP =' X,-Z,-Y'
        IF(IS.EQ. 43) OP =' X,Z,Y'
        IF(IS.EQ. 44) OP =' -X,Z,-Y'
        IF(IS.EQ. 45) OP =' -Z,-Y,X'
        IF(IS.EQ. 46) OP =' -Z,Y,-X'
        IF(IS.EQ. 47) OP =' Z,-Y,-X'
        IF(IS.EQ. 48) OP =' Z,Y,X'
        RETURN
      ENDIF
      IF(I.EQ.242) THEN
        NO_TAB  =  222
        NS_TAB  =   48
        SG_TAB1 = 'P 4/n -3 2/n'
        SG_TAB2 = 'Pn-3n'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' Y,X,-Z'
        IF(IS.EQ. 14) OP =' -Y,-X,-Z'
        IF(IS.EQ. 15) OP =' Y,-X,Z'
        IF(IS.EQ. 16) OP =' -Y,X,Z'
        IF(IS.EQ. 17) OP =' X,Z,-Y'
        IF(IS.EQ. 18) OP =' -X,Z,Y'
        IF(IS.EQ. 19) OP =' -X,-Z,-Y'
        IF(IS.EQ. 20) OP =' X,-Z,Y'
        IF(IS.EQ. 21) OP =' Z,Y,-X'
        IF(IS.EQ. 22) OP =' Z,-Y,X'
        IF(IS.EQ. 23) OP =' -Z,Y,X'
        IF(IS.EQ. 24) OP =' -Z,-Y,-X'
        IF(IS.EQ. 25) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 26) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 27) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 28) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ. 29) OP =' 1/2-Z,1/2-X,1/2-Y'
        IF(IS.EQ. 30) OP =' 1/2-Z,1/2+X,1/2+Y'
        IF(IS.EQ. 31) OP =' 1/2+Z,1/2+X,1/2-Y'
        IF(IS.EQ. 32) OP =' 1/2+Z,1/2-X,1/2+Y'
        IF(IS.EQ. 33) OP =' 1/2-Y,1/2-Z,1/2-X'
        IF(IS.EQ. 34) OP =' 1/2+Y,1/2-Z,1/2+X'
        IF(IS.EQ. 35) OP =' 1/2-Y,1/2+Z,1/2+X'
        IF(IS.EQ. 36) OP =' 1/2+Y,1/2+Z,1/2-X'
        IF(IS.EQ. 37) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 38) OP =' 1/2+Y,1/2+X,1/2+Z'
        IF(IS.EQ. 39) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 40) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 41) OP =' 1/2-X,1/2-Z,1/2+Y'
        IF(IS.EQ. 42) OP =' 1/2+X,1/2-Z,1/2-Y'
        IF(IS.EQ. 43) OP =' 1/2+X,1/2+Z,1/2+Y'
        IF(IS.EQ. 44) OP =' 1/2-X,1/2+Z,1/2-Y'
        IF(IS.EQ. 45) OP =' 1/2-Z,1/2-Y,1/2+X'
        IF(IS.EQ. 46) OP =' 1/2-Z,1/2+Y,1/2-X'
        IF(IS.EQ. 47) OP =' 1/2+Z,1/2-Y,1/2-X'
        IF(IS.EQ. 48) OP =' 1/2+Z,1/2+Y,1/2+X'
        RETURN
      ENDIF
      IF(I.EQ.243) THEN
        NO_TAB  =  223
        NS_TAB  =   48
        SG_TAB1 = 'P 42/m -3 2/n'
        SG_TAB2 = 'Pm-3n'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ. 14) OP =' 1/2-Y,1/2-X,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ. 17) OP =' 1/2+X,1/2+Z,1/2-Y'
        IF(IS.EQ. 18) OP =' 1/2-X,1/2+Z,1/2+Y'
        IF(IS.EQ. 19) OP =' 1/2-X,1/2-Z,1/2-Y'
        IF(IS.EQ. 20) OP =' 1/2+X,1/2-Z,1/2+Y'
        IF(IS.EQ. 21) OP =' 1/2+Z,1/2+Y,1/2-X'
        IF(IS.EQ. 22) OP =' 1/2+Z,1/2-Y,1/2+X'
        IF(IS.EQ. 23) OP =' 1/2-Z,1/2+Y,1/2+X'
        IF(IS.EQ. 24) OP =' 1/2-Z,1/2-Y,1/2-X'
        IF(IS.EQ. 25) OP =' -X,-Y,-Z'
        IF(IS.EQ. 26) OP =' X,Y,-Z'
        IF(IS.EQ. 27) OP =' X,-Y,Z'
        IF(IS.EQ. 28) OP =' -X,Y,Z'
        IF(IS.EQ. 29) OP =' -Z,-X,-Y'
        IF(IS.EQ. 30) OP =' -Z,X,Y'
        IF(IS.EQ. 31) OP =' Z,X,-Y'
        IF(IS.EQ. 32) OP =' Z,-X,Y'
        IF(IS.EQ. 33) OP =' -Y,-Z,-X'
        IF(IS.EQ. 34) OP =' Y,-Z,X'
        IF(IS.EQ. 35) OP =' -Y,Z,X'
        IF(IS.EQ. 36) OP =' Y,Z,-X'
        IF(IS.EQ. 37) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 38) OP =' 1/2+Y,1/2+X,1/2+Z'
        IF(IS.EQ. 39) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 40) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 41) OP =' 1/2-X,1/2-Z,1/2+Y'
        IF(IS.EQ. 42) OP =' 1/2+X,1/2-Z,1/2-Y'
        IF(IS.EQ. 43) OP =' 1/2+X,1/2+Z,1/2+Y'
        IF(IS.EQ. 44) OP =' 1/2-X,1/2+Z,1/2-Y'
        IF(IS.EQ. 45) OP =' 1/2-Z,1/2-Y,1/2+X'
        IF(IS.EQ. 46) OP =' 1/2-Z,1/2+Y,1/2-X'
        IF(IS.EQ. 47) OP =' 1/2+Z,1/2-Y,1/2-X'
        IF(IS.EQ. 48) OP =' 1/2+Z,1/2+Y,1/2+X'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_4(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.244) THEN
        NO_TAB  =  224
        NS_TAB  =   48
        SG_TAB1 = 'P 42/n -3 2/m'
        SG_TAB2 = 'Pn-3m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ. 14) OP =' 1/2-Y,1/2-X,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ. 17) OP =' 1/2+X,1/2+Z,1/2-Y'
        IF(IS.EQ. 18) OP =' 1/2-X,1/2+Z,1/2+Y'
        IF(IS.EQ. 19) OP =' 1/2-X,1/2-Z,1/2-Y'
        IF(IS.EQ. 20) OP =' 1/2+X,1/2-Z,1/2+Y'
        IF(IS.EQ. 21) OP =' 1/2+Z,1/2+Y,1/2-X'
        IF(IS.EQ. 22) OP =' 1/2+Z,1/2-Y,1/2+X'
        IF(IS.EQ. 23) OP =' 1/2-Z,1/2+Y,1/2+X'
        IF(IS.EQ. 24) OP =' 1/2-Z,1/2-Y,1/2-X'
        IF(IS.EQ. 25) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 26) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 27) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 28) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ. 29) OP =' 1/2-Z,1/2-X,1/2-Y'
        IF(IS.EQ. 30) OP =' 1/2-Z,1/2+X,1/2+Y'
        IF(IS.EQ. 31) OP =' 1/2+Z,1/2+X,1/2-Y'
        IF(IS.EQ. 32) OP =' 1/2+Z,1/2-X,1/2+Y'
        IF(IS.EQ. 33) OP =' 1/2-Y,1/2-Z,1/2-X'
        IF(IS.EQ. 34) OP =' 1/2+Y,1/2-Z,1/2+X'
        IF(IS.EQ. 35) OP =' 1/2-Y,1/2+Z,1/2+X'
        IF(IS.EQ. 36) OP =' 1/2+Y,1/2+Z,1/2-X'
        IF(IS.EQ. 37) OP =' -Y,-X,Z'
        IF(IS.EQ. 38) OP =' Y,X,Z'
        IF(IS.EQ. 39) OP =' -Y,X,-Z'
        IF(IS.EQ. 40) OP =' Y,-X,-Z'
        IF(IS.EQ. 41) OP =' -X,-Z,Y'
        IF(IS.EQ. 42) OP =' X,-Z,-Y'
        IF(IS.EQ. 43) OP =' X,Z,Y'
        IF(IS.EQ. 44) OP =' -X,Z,-Y'
        IF(IS.EQ. 45) OP =' -Z,-Y,X'
        IF(IS.EQ. 46) OP =' -Z,Y,-X'
        IF(IS.EQ. 47) OP =' Z,-Y,-X'
        IF(IS.EQ. 48) OP =' Z,Y,X'
        RETURN
      ENDIF
      IF(I.EQ.245) THEN
        NO_TAB  =  225
        NS_TAB  =  192
        SG_TAB1 = 'F 4/m -3 2/m'
        SG_TAB2 = 'Fm-3m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' Y,X,-Z'
        IF(IS.EQ. 14) OP =' -Y,-X,-Z'
        IF(IS.EQ. 15) OP =' Y,-X,Z'
        IF(IS.EQ. 16) OP =' -Y,X,Z'
        IF(IS.EQ. 17) OP =' X,Z,-Y'
        IF(IS.EQ. 18) OP =' -X,Z,Y'
        IF(IS.EQ. 19) OP =' -X,-Z,-Y'
        IF(IS.EQ. 20) OP =' X,-Z,Y'
        IF(IS.EQ. 21) OP =' Z,Y,-X'
        IF(IS.EQ. 22) OP =' Z,-Y,X'
        IF(IS.EQ. 23) OP =' -Z,Y,X'
        IF(IS.EQ. 24) OP =' -Z,-Y,-X'
        IF(IS.EQ. 25) OP =' -X,-Y,-Z'
        IF(IS.EQ. 26) OP =' X,Y,-Z'
        IF(IS.EQ. 27) OP =' X,-Y,Z'
        IF(IS.EQ. 28) OP =' -X,Y,Z'
        IF(IS.EQ. 29) OP =' -Z,-X,-Y'
        IF(IS.EQ. 30) OP =' -Z,X,Y'
        IF(IS.EQ. 31) OP =' Z,X,-Y'
        IF(IS.EQ. 32) OP =' Z,-X,Y'
        IF(IS.EQ. 33) OP =' -Y,-Z,-X'
        IF(IS.EQ. 34) OP =' Y,-Z,X'
        IF(IS.EQ. 35) OP =' -Y,Z,X'
        IF(IS.EQ. 36) OP =' Y,Z,-X'
        IF(IS.EQ. 37) OP =' -Y,-X,Z'
        IF(IS.EQ. 38) OP =' Y,X,Z'
        IF(IS.EQ. 39) OP =' -Y,X,-Z'
        IF(IS.EQ. 40) OP =' Y,-X,-Z'
        IF(IS.EQ. 41) OP =' -X,-Z,Y'
        IF(IS.EQ. 42) OP =' X,-Z,-Y'
        IF(IS.EQ. 43) OP =' X,Z,Y'
        IF(IS.EQ. 44) OP =' -X,Z,-Y'
        IF(IS.EQ. 45) OP =' -Z,-Y,X'
        IF(IS.EQ. 46) OP =' -Z,Y,-X'
        IF(IS.EQ. 47) OP =' Z,-Y,-X'
        IF(IS.EQ. 48) OP =' Z,Y,X'
        IF(IS.EQ. 49) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 50) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ. 51) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ. 52) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ. 53) OP =' Z,1/2+X,1/2+Y'
        IF(IS.EQ. 54) OP =' Z,1/2-X,1/2-Y'
        IF(IS.EQ. 55) OP =' -Z,1/2-X,1/2+Y'
        IF(IS.EQ. 56) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ. 57) OP =' Y,1/2+Z,1/2+X'
        IF(IS.EQ. 58) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 59) OP =' Y,1/2-Z,1/2-X'
        IF(IS.EQ. 60) OP =' -Y,1/2-Z,1/2+X'
        IF(IS.EQ. 61) OP =' Y,1/2+X,1/2-Z'
        IF(IS.EQ. 62) OP =' -Y,1/2-X,1/2-Z'
        IF(IS.EQ. 63) OP =' Y,1/2-X,1/2+Z'
        IF(IS.EQ. 64) OP =' -Y,1/2+X,1/2+Z'
        IF(IS.EQ. 65) OP =' X,1/2+Z,1/2-Y'
        IF(IS.EQ. 66) OP =' -X,1/2+Z,1/2+Y'
        IF(IS.EQ. 67) OP =' -X,1/2-Z,1/2-Y'
        IF(IS.EQ. 68) OP =' X,1/2-Z,1/2+Y'
        IF(IS.EQ. 69) OP =' Z,1/2+Y,1/2-X'
        IF(IS.EQ. 70) OP =' Z,1/2-Y,1/2+X'
        IF(IS.EQ. 71) OP =' -Z,1/2+Y,1/2+X'
        IF(IS.EQ. 72) OP =' -Z,1/2-Y,1/2-X'
        IF(IS.EQ. 73) OP =' -X,1/2-Y,1/2-Z'
        IF(IS.EQ. 74) OP =' X,1/2+Y,1/2-Z'
        IF(IS.EQ. 75) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ. 76) OP =' -X,1/2+Y,1/2+Z'
        IF(IS.EQ. 77) OP =' -Z,1/2-X,1/2-Y'
        IF(IS.EQ. 78) OP =' -Z,1/2+X,1/2+Y'
        IF(IS.EQ. 79) OP =' Z,1/2+X,1/2-Y'
        IF(IS.EQ. 80) OP =' Z,1/2-X,1/2+Y'
        IF(IS.EQ. 81) OP =' -Y,1/2-Z,1/2-X'
        IF(IS.EQ. 82) OP =' Y,1/2-Z,1/2+X'
        IF(IS.EQ. 83) OP =' -Y,1/2+Z,1/2+X'
        IF(IS.EQ. 84) OP =' Y,1/2+Z,1/2-X'
        IF(IS.EQ. 85) OP =' -Y,1/2-X,1/2+Z'
        IF(IS.EQ. 86) OP =' Y,1/2+X,1/2+Z'
        IF(IS.EQ. 87) OP =' -Y,1/2+X,1/2-Z'
        IF(IS.EQ. 88) OP =' Y,1/2-X,1/2-Z'
        IF(IS.EQ. 89) OP =' -X,1/2-Z,1/2+Y'
        IF(IS.EQ. 90) OP =' X,1/2-Z,1/2-Y'
        IF(IS.EQ. 91) OP =' X,1/2+Z,1/2+Y'
        IF(IS.EQ. 92) OP =' -X,1/2+Z,1/2-Y'
        IF(IS.EQ. 93) OP =' -Z,1/2-Y,1/2+X'
        IF(IS.EQ. 94) OP =' -Z,1/2+Y,1/2-X'
        IF(IS.EQ. 95) OP =' Z,1/2-Y,1/2-X'
        IF(IS.EQ. 96) OP =' Z,1/2+Y,1/2+X'
        IF(IS.EQ. 97) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 98) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 99) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ.100) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ.101) OP =' 1/2+Z,X,1/2+Y'
        IF(IS.EQ.102) OP =' 1/2+Z,-X,1/2-Y'
        IF(IS.EQ.103) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.104) OP =' 1/2-Z,X,1/2-Y'
        IF(IS.EQ.105) OP =' 1/2+Y,Z,1/2+X'
        IF(IS.EQ.106) OP =' 1/2-Y,Z,1/2-X'
        IF(IS.EQ.107) OP =' 1/2+Y,-Z,1/2-X'
        IF(IS.EQ.108) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ.109) OP =' 1/2+Y,X,1/2-Z'
        IF(IS.EQ.110) OP =' 1/2-Y,-X,1/2-Z'
        IF(IS.EQ.111) OP =' 1/2+Y,-X,1/2+Z'
        IF(IS.EQ.112) OP =' 1/2-Y,X,1/2+Z'
        IF(IS.EQ.113) OP =' 1/2+X,Z,1/2-Y'
        IF(IS.EQ.114) OP =' 1/2-X,Z,1/2+Y'
        IF(IS.EQ.115) OP =' 1/2-X,-Z,1/2-Y'
        IF(IS.EQ.116) OP =' 1/2+X,-Z,1/2+Y'
        IF(IS.EQ.117) OP =' 1/2+Z,Y,1/2-X'
        IF(IS.EQ.118) OP =' 1/2+Z,-Y,1/2+X'
        IF(IS.EQ.119) OP =' 1/2-Z,Y,1/2+X'
        IF(IS.EQ.120) OP =' 1/2-Z,-Y,1/2-X'
        IF(IS.EQ.121) OP =' 1/2-X,-Y,1/2-Z'
        IF(IS.EQ.122) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ.123) OP =' 1/2+X,-Y,1/2+Z'
        IF(IS.EQ.124) OP =' 1/2-X,Y,1/2+Z'
        IF(IS.EQ.125) OP =' 1/2-Z,-X,1/2-Y'
        IF(IS.EQ.126) OP =' 1/2-Z,X,1/2+Y'
        IF(IS.EQ.127) OP =' 1/2+Z,X,1/2-Y'
        IF(IS.EQ.128) OP =' 1/2+Z,-X,1/2+Y'
        IF(IS.EQ.129) OP =' 1/2-Y,-Z,1/2-X'
        IF(IS.EQ.130) OP =' 1/2+Y,-Z,1/2+X'
        IF(IS.EQ.131) OP =' 1/2-Y,Z,1/2+X'
        IF(IS.EQ.132) OP =' 1/2+Y,Z,1/2-X'
        IF(IS.EQ.133) OP =' 1/2-Y,-X,1/2+Z'
        IF(IS.EQ.134) OP =' 1/2+Y,X,1/2+Z'
        IF(IS.EQ.135) OP =' 1/2-Y,X,1/2-Z'
        IF(IS.EQ.136) OP =' 1/2+Y,-X,1/2-Z'
        IF(IS.EQ.137) OP =' 1/2-X,-Z,1/2+Y'
        IF(IS.EQ.138) OP =' 1/2+X,-Z,1/2-Y'
        IF(IS.EQ.139) OP =' 1/2+X,Z,1/2+Y'
        IF(IS.EQ.140) OP =' 1/2-X,Z,1/2-Y'
        IF(IS.EQ.141) OP =' 1/2-Z,-Y,1/2+X'
        IF(IS.EQ.142) OP =' 1/2-Z,Y,1/2-X'
        IF(IS.EQ.143) OP =' 1/2+Z,-Y,1/2-X'
        IF(IS.EQ.144) OP =' 1/2+Z,Y,1/2+X'
        IF(IS.EQ.145) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.146) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.147) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.148) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.149) OP =' 1/2+Z,1/2+X,Y'
        IF(IS.EQ.150) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ.151) OP =' 1/2-Z,1/2-X,Y'
        IF(IS.EQ.152) OP =' 1/2-Z,1/2+X,-Y'
        IF(IS.EQ.153) OP =' 1/2+Y,1/2+Z,X'
        IF(IS.EQ.154) OP =' 1/2-Y,1/2+Z,-X'
        IF(IS.EQ.155) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ.156) OP =' 1/2-Y,1/2-Z,X'
        IF(IS.EQ.157) OP =' 1/2+Y,1/2+X,-Z'
        IF(IS.EQ.158) OP =' 1/2-Y,1/2-X,-Z'
        IF(IS.EQ.159) OP =' 1/2+Y,1/2-X,Z'
        IF(IS.EQ.160) OP =' 1/2-Y,1/2+X,Z'
        IF(IS.EQ.161) OP =' 1/2+X,1/2+Z,-Y'
        IF(IS.EQ.162) OP =' 1/2-X,1/2+Z,Y'
        IF(IS.EQ.163) OP =' 1/2-X,1/2-Z,-Y'
        IF(IS.EQ.164) OP =' 1/2+X,1/2-Z,Y'
        IF(IS.EQ.165) OP =' 1/2+Z,1/2+Y,-X'
        IF(IS.EQ.166) OP =' 1/2+Z,1/2-Y,X'
        IF(IS.EQ.167) OP =' 1/2-Z,1/2+Y,X'
        IF(IS.EQ.168) OP =' 1/2-Z,1/2-Y,-X'
        IF(IS.EQ.169) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ.170) OP =' 1/2+X,1/2+Y,-Z'
        IF(IS.EQ.171) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.172) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ.173) OP =' 1/2-Z,1/2-X,-Y'
        IF(IS.EQ.174) OP =' 1/2-Z,1/2+X,Y'
        IF(IS.EQ.175) OP =' 1/2+Z,1/2+X,-Y'
        IF(IS.EQ.176) OP =' 1/2+Z,1/2-X,Y'
        IF(IS.EQ.177) OP =' 1/2-Y,1/2-Z,-X'
        IF(IS.EQ.178) OP =' 1/2+Y,1/2-Z,X'
        IF(IS.EQ.179) OP =' 1/2-Y,1/2+Z,X'
        IF(IS.EQ.180) OP =' 1/2+Y,1/2+Z,-X'
        IF(IS.EQ.181) OP =' 1/2-Y,1/2-X,Z'
        IF(IS.EQ.182) OP =' 1/2+Y,1/2+X,Z'
        IF(IS.EQ.183) OP =' 1/2-Y,1/2+X,-Z'
        IF(IS.EQ.184) OP =' 1/2+Y,1/2-X,-Z'
        IF(IS.EQ.185) OP =' 1/2-X,1/2-Z,Y'
        IF(IS.EQ.186) OP =' 1/2+X,1/2-Z,-Y'
        IF(IS.EQ.187) OP =' 1/2+X,1/2+Z,Y'
        IF(IS.EQ.188) OP =' 1/2-X,1/2+Z,-Y'
        IF(IS.EQ.189) OP =' 1/2-Z,1/2-Y,X'
        IF(IS.EQ.190) OP =' 1/2-Z,1/2+Y,-X'
        IF(IS.EQ.191) OP =' 1/2+Z,1/2-Y,-X'
        IF(IS.EQ.192) OP =' 1/2+Z,1/2+Y,X'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_41(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.246) THEN
        NO_TAB  =  226
        NS_TAB  =  192
        SG_TAB1 = 'F 4/m -3 2/c'
        SG_TAB2 = 'Fm-3c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ. 14) OP =' 1/2-Y,1/2-X,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ. 17) OP =' 1/2+X,1/2+Z,1/2-Y'
        IF(IS.EQ. 18) OP =' 1/2-X,1/2+Z,1/2+Y'
        IF(IS.EQ. 19) OP =' 1/2-X,1/2-Z,1/2-Y'
        IF(IS.EQ. 20) OP =' 1/2+X,1/2-Z,1/2+Y'
        IF(IS.EQ. 21) OP =' 1/2+Z,1/2+Y,1/2-X'
        IF(IS.EQ. 22) OP =' 1/2+Z,1/2-Y,1/2+X'
        IF(IS.EQ. 23) OP =' 1/2-Z,1/2+Y,1/2+X'
        IF(IS.EQ. 24) OP =' 1/2-Z,1/2-Y,1/2-X'
        IF(IS.EQ. 25) OP =' -X,-Y,-Z'
        IF(IS.EQ. 26) OP =' X,Y,-Z'
        IF(IS.EQ. 27) OP =' X,-Y,Z'
        IF(IS.EQ. 28) OP =' -X,Y,Z'
        IF(IS.EQ. 29) OP =' -Z,-X,-Y'
        IF(IS.EQ. 30) OP =' -Z,X,Y'
        IF(IS.EQ. 31) OP =' Z,X,-Y'
        IF(IS.EQ. 32) OP =' Z,-X,Y'
        IF(IS.EQ. 33) OP =' -Y,-Z,-X'
        IF(IS.EQ. 34) OP =' Y,-Z,X'
        IF(IS.EQ. 35) OP =' -Y,Z,X'
        IF(IS.EQ. 36) OP =' Y,Z,-X'
        IF(IS.EQ. 37) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 38) OP =' 1/2+Y,1/2+X,1/2+Z'
        IF(IS.EQ. 39) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 40) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 41) OP =' 1/2-X,1/2-Z,1/2+Y'
        IF(IS.EQ. 42) OP =' 1/2+X,1/2-Z,1/2-Y'
        IF(IS.EQ. 43) OP =' 1/2+X,1/2+Z,1/2+Y'
        IF(IS.EQ. 44) OP =' 1/2-X,1/2+Z,1/2-Y'
        IF(IS.EQ. 45) OP =' 1/2-Z,1/2-Y,1/2+X'
        IF(IS.EQ. 46) OP =' 1/2-Z,1/2+Y,1/2-X'
        IF(IS.EQ. 47) OP =' 1/2+Z,1/2-Y,1/2-X'
        IF(IS.EQ. 48) OP =' 1/2+Z,1/2+Y,1/2+X'
        IF(IS.EQ. 49) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 50) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ. 51) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ. 52) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ. 53) OP =' Z,1/2+X,1/2+Y'
        IF(IS.EQ. 54) OP =' Z,1/2-X,1/2-Y'
        IF(IS.EQ. 55) OP =' -Z,1/2-X,1/2+Y'
        IF(IS.EQ. 56) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ. 57) OP =' Y,1/2+Z,1/2+X'
        IF(IS.EQ. 58) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 59) OP =' Y,1/2-Z,1/2-X'
        IF(IS.EQ. 60) OP =' -Y,1/2-Z,1/2+X'
        IF(IS.EQ. 61) OP =' 1/2+Y,X,-Z'
        IF(IS.EQ. 62) OP =' 1/2-Y,-X,-Z'
        IF(IS.EQ. 63) OP =' 1/2+Y,-X,Z'
        IF(IS.EQ. 64) OP =' 1/2-Y,X,Z'
        IF(IS.EQ. 65) OP =' 1/2+X,Z,-Y'
        IF(IS.EQ. 66) OP =' 1/2-X,Z,Y'
        IF(IS.EQ. 67) OP =' 1/2-X,-Z,-Y'
        IF(IS.EQ. 68) OP =' 1/2+X,-Z,Y'
        IF(IS.EQ. 69) OP =' 1/2+Z,Y,-X'
        IF(IS.EQ. 70) OP =' 1/2+Z,-Y,X'
        IF(IS.EQ. 71) OP =' 1/2-Z,Y,X'
        IF(IS.EQ. 72) OP =' 1/2-Z,-Y,-X'
        IF(IS.EQ. 73) OP =' -X,1/2-Y,1/2-Z'
        IF(IS.EQ. 74) OP =' X,1/2+Y,1/2-Z'
        IF(IS.EQ. 75) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ. 76) OP =' -X,1/2+Y,1/2+Z'
        IF(IS.EQ. 77) OP =' -Z,1/2-X,1/2-Y'
        IF(IS.EQ. 78) OP =' -Z,1/2+X,1/2+Y'
        IF(IS.EQ. 79) OP =' Z,1/2+X,1/2-Y'
        IF(IS.EQ. 80) OP =' Z,1/2-X,1/2+Y'
        IF(IS.EQ. 81) OP =' -Y,1/2-Z,1/2-X'
        IF(IS.EQ. 82) OP =' Y,1/2-Z,1/2+X'
        IF(IS.EQ. 83) OP =' -Y,1/2+Z,1/2+X'
        IF(IS.EQ. 84) OP =' Y,1/2+Z,1/2-X'
        IF(IS.EQ. 85) OP =' 1/2-Y,-X,Z'
        IF(IS.EQ. 86) OP =' 1/2+Y,X,Z'
        IF(IS.EQ. 87) OP =' 1/2-Y,X,-Z'
        IF(IS.EQ. 88) OP =' 1/2+Y,-X,-Z'
        IF(IS.EQ. 89) OP =' 1/2-X,-Z,Y'
        IF(IS.EQ. 90) OP =' 1/2+X,-Z,-Y'
        IF(IS.EQ. 91) OP =' 1/2+X,Z,Y'
        IF(IS.EQ. 92) OP =' 1/2-X,Z,-Y'
        IF(IS.EQ. 93) OP =' 1/2-Z,-Y,X'
        IF(IS.EQ. 94) OP =' 1/2-Z,Y,-X'
        IF(IS.EQ. 95) OP =' 1/2+Z,-Y,-X'
        IF(IS.EQ. 96) OP =' 1/2+Z,Y,X'
        IF(IS.EQ. 97) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 98) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 99) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ.100) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ.101) OP =' 1/2+Z,X,1/2+Y'
        IF(IS.EQ.102) OP =' 1/2+Z,-X,1/2-Y'
        IF(IS.EQ.103) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.104) OP =' 1/2-Z,X,1/2-Y'
        IF(IS.EQ.105) OP =' 1/2+Y,Z,1/2+X'
        IF(IS.EQ.106) OP =' 1/2-Y,Z,1/2-X'
        IF(IS.EQ.107) OP =' 1/2+Y,-Z,1/2-X'
        IF(IS.EQ.108) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ.109) OP =' Y,1/2+X,-Z'
        IF(IS.EQ.110) OP =' -Y,1/2-X,-Z'
        IF(IS.EQ.111) OP =' Y,1/2-X,Z'
        IF(IS.EQ.112) OP =' -Y,1/2+X,Z'
        IF(IS.EQ.113) OP =' X,1/2+Z,-Y'
        IF(IS.EQ.114) OP =' -X,1/2+Z,Y'
        IF(IS.EQ.115) OP =' -X,1/2-Z,-Y'
        IF(IS.EQ.116) OP =' X,1/2-Z,Y'
        IF(IS.EQ.117) OP =' Z,1/2+Y,-X'
        IF(IS.EQ.118) OP =' Z,1/2-Y,X'
        IF(IS.EQ.119) OP =' -Z,1/2+Y,X'
        IF(IS.EQ.120) OP =' -Z,1/2-Y,-X'
        IF(IS.EQ.121) OP =' 1/2-X,-Y,1/2-Z'
        IF(IS.EQ.122) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ.123) OP =' 1/2+X,-Y,1/2+Z'
        IF(IS.EQ.124) OP =' 1/2-X,Y,1/2+Z'
        IF(IS.EQ.125) OP =' 1/2-Z,-X,1/2-Y'
        IF(IS.EQ.126) OP =' 1/2-Z,X,1/2+Y'
        IF(IS.EQ.127) OP =' 1/2+Z,X,1/2-Y'
        IF(IS.EQ.128) OP =' 1/2+Z,-X,1/2+Y'
        IF(IS.EQ.129) OP =' 1/2-Y,-Z,1/2-X'
        IF(IS.EQ.130) OP =' 1/2+Y,-Z,1/2+X'
        IF(IS.EQ.131) OP =' 1/2-Y,Z,1/2+X'
        IF(IS.EQ.132) OP =' 1/2+Y,Z,1/2-X'
        IF(IS.EQ.133) OP =' -Y,1/2-X,Z'
        IF(IS.EQ.134) OP =' Y,1/2+X,Z'
        IF(IS.EQ.135) OP =' -Y,1/2+X,-Z'
        IF(IS.EQ.136) OP =' Y,1/2-X,-Z'
        IF(IS.EQ.137) OP =' -X,1/2-Z,Y'
        IF(IS.EQ.138) OP =' X,1/2-Z,-Y'
        IF(IS.EQ.139) OP =' X,1/2+Z,Y'
        IF(IS.EQ.140) OP =' -X,1/2+Z,-Y'
        IF(IS.EQ.141) OP =' -Z,1/2-Y,X'
        IF(IS.EQ.142) OP =' -Z,1/2+Y,-X'
        IF(IS.EQ.143) OP =' Z,1/2-Y,-X'
        IF(IS.EQ.144) OP =' Z,1/2+Y,X'
        IF(IS.EQ.145) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.146) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.147) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.148) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.149) OP =' 1/2+Z,1/2+X,Y'
        IF(IS.EQ.150) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ.151) OP =' 1/2-Z,1/2-X,Y'
        IF(IS.EQ.152) OP =' 1/2-Z,1/2+X,-Y'
        IF(IS.EQ.153) OP =' 1/2+Y,1/2+Z,X'
        IF(IS.EQ.154) OP =' 1/2-Y,1/2+Z,-X'
        IF(IS.EQ.155) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ.156) OP =' 1/2-Y,1/2-Z,X'
        IF(IS.EQ.157) OP =' Y,X,1/2-Z'
        IF(IS.EQ.158) OP =' -Y,-X,1/2-Z'
        IF(IS.EQ.159) OP =' Y,-X,1/2+Z'
        IF(IS.EQ.160) OP =' -Y,X,1/2+Z'
        IF(IS.EQ.161) OP =' X,Z,1/2-Y'
        IF(IS.EQ.162) OP =' -X,Z,1/2+Y'
        IF(IS.EQ.163) OP =' -X,-Z,1/2-Y'
        IF(IS.EQ.164) OP =' X,-Z,1/2+Y'
        IF(IS.EQ.165) OP =' Z,Y,1/2-X'
        IF(IS.EQ.166) OP =' Z,-Y,1/2+X'
        IF(IS.EQ.167) OP =' -Z,Y,1/2+X'
        IF(IS.EQ.168) OP =' -Z,-Y,1/2-X'
        IF(IS.EQ.169) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ.170) OP =' 1/2+X,1/2+Y,-Z'
        IF(IS.EQ.171) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.172) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ.173) OP =' 1/2-Z,1/2-X,-Y'
        IF(IS.EQ.174) OP =' 1/2-Z,1/2+X,Y'
        IF(IS.EQ.175) OP =' 1/2+Z,1/2+X,-Y'
        IF(IS.EQ.176) OP =' 1/2+Z,1/2-X,Y'
        IF(IS.EQ.177) OP =' 1/2-Y,1/2-Z,-X'
        IF(IS.EQ.178) OP =' 1/2+Y,1/2-Z,X'
        IF(IS.EQ.179) OP =' 1/2-Y,1/2+Z,X'
        IF(IS.EQ.180) OP =' 1/2+Y,1/2+Z,-X'
        IF(IS.EQ.181) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ.182) OP =' Y,X,1/2+Z'
        IF(IS.EQ.183) OP =' -Y,X,1/2-Z'
        IF(IS.EQ.184) OP =' Y,-X,1/2-Z'
        IF(IS.EQ.185) OP =' -X,-Z,1/2+Y'
        IF(IS.EQ.186) OP =' X,-Z,1/2-Y'
        IF(IS.EQ.187) OP =' X,Z,1/2+Y'
        IF(IS.EQ.188) OP =' -X,Z,1/2-Y'
        IF(IS.EQ.189) OP =' -Z,-Y,1/2+X'
        IF(IS.EQ.190) OP =' -Z,Y,1/2-X'
        IF(IS.EQ.191) OP =' Z,-Y,1/2-X'
        IF(IS.EQ.192) OP =' Z,Y,1/2+X'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_42(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.247) THEN
        NO_TAB  =  227
        NS_TAB  =  192
        SG_TAB1 = 'F 41/d -3 2/m'
        SG_TAB2 = 'Fd-3m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' 1/2+Z,-X,1/2-Y'
        IF(IS.EQ.  7) OP =' -Z,1/2-X,1/2+Y'
        IF(IS.EQ.  8) OP =' 1/2-Z,1/2+X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' 1/2-Y,1/2+Z,-X'
        IF(IS.EQ. 11) OP =' 1/2+Y,-Z,1/2-X'
        IF(IS.EQ. 12) OP =' -Y,1/2-Z,1/2+X'
        IF(IS.EQ. 13) OP =' 3/4+Y,1/4+X,3/4-Z'
        IF(IS.EQ. 14) OP =' 1/4-Y,1/4-X,1/4-Z'
        IF(IS.EQ. 15) OP =' 1/4+Y,3/4-X,3/4+Z'
        IF(IS.EQ. 16) OP =' 3/4-Y,3/4+X,1/4+Z'
        IF(IS.EQ. 17) OP =' 3/4+X,1/4+Z,3/4-Y'
        IF(IS.EQ. 18) OP =' 3/4-X,3/4+Z,1/4+Y'
        IF(IS.EQ. 19) OP =' 1/4-X,1/4-Z,1/4-Y'
        IF(IS.EQ. 20) OP =' 1/4+X,3/4-Z,3/4+Y'
        IF(IS.EQ. 21) OP =' 3/4+Z,1/4+Y,3/4-X'
        IF(IS.EQ. 22) OP =' 1/4+Z,3/4-Y,3/4+X'
        IF(IS.EQ. 23) OP =' 3/4-Z,3/4+Y,1/4+X'
        IF(IS.EQ. 24) OP =' 1/4-Z,1/4-Y,1/4-X'
        IF(IS.EQ. 25) OP =' 1/4-X,1/4-Y,1/4-Z'
        IF(IS.EQ. 26) OP =' 1/4+X,3/4+Y,3/4-Z'
        IF(IS.EQ. 27) OP =' 3/4+X,3/4-Y,1/4+Z'
        IF(IS.EQ. 28) OP =' 3/4-X,1/4+Y,3/4+Z'
        IF(IS.EQ. 29) OP =' 1/4-Z,1/4-X,1/4-Y'
        IF(IS.EQ. 30) OP =' 3/4-Z,1/4+X,3/4+Y'
        IF(IS.EQ. 31) OP =' 1/4+Z,3/4+X,3/4-Y'
        IF(IS.EQ. 32) OP =' 3/4+Z,3/4-X,1/4+Y'
        IF(IS.EQ. 33) OP =' 1/4-Y,1/4-Z,1/4-X'
        IF(IS.EQ. 34) OP =' 3/4+Y,3/4-Z,1/4+X'
        IF(IS.EQ. 35) OP =' 3/4-Y,1/4+Z,3/4+X'
        IF(IS.EQ. 36) OP =' 1/4+Y,3/4+Z,3/4-X'
        IF(IS.EQ. 37) OP =' 1/2-Y,-X,1/2+Z'
        IF(IS.EQ. 38) OP =' Y,X,Z'
        IF(IS.EQ. 39) OP =' -Y,1/2+X,1/2-Z'
        IF(IS.EQ. 40) OP =' 1/2+Y,1/2-X,-Z'
        IF(IS.EQ. 41) OP =' 1/2-X,-Z,1/2+Y'
        IF(IS.EQ. 42) OP =' 1/2+X,1/2-Z,-Y'
        IF(IS.EQ. 43) OP =' X,Z,Y'
        IF(IS.EQ. 44) OP =' -X,1/2+Z,1/2-Y'
        IF(IS.EQ. 45) OP =' 1/2-Z,-Y,1/2+X'
        IF(IS.EQ. 46) OP =' -Z,1/2+Y,1/2-X'
        IF(IS.EQ. 47) OP =' 1/2+Z,1/2-Y,-X'
        IF(IS.EQ. 48) OP =' Z,Y,X'
        IF(IS.EQ. 49) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 50) OP =' -X,-Y,Z'
        IF(IS.EQ. 51) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 52) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 53) OP =' Z,1/2+X,1/2+Y'
        IF(IS.EQ. 54) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ. 55) OP =' -Z,-X,Y'
        IF(IS.EQ. 56) OP =' 1/2-Z,X,1/2-Y'
        IF(IS.EQ. 57) OP =' Y,1/2+Z,1/2+X'
        IF(IS.EQ. 58) OP =' 1/2-Y,Z,1/2-X'
        IF(IS.EQ. 59) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 60) OP =' -Y,-Z,X'
        IF(IS.EQ. 61) OP =' 3/4+Y,3/4+X,1/4-Z'
        IF(IS.EQ. 62) OP =' 1/4-Y,3/4-X,3/4-Z'
        IF(IS.EQ. 63) OP =' 1/4+Y,1/4-X,1/4+Z'
        IF(IS.EQ. 64) OP =' 3/4-Y,1/4+X,3/4+Z'
        IF(IS.EQ. 65) OP =' 3/4+X,3/4+Z,1/4-Y'
        IF(IS.EQ. 66) OP =' 3/4-X,1/4+Z,3/4+Y'
        IF(IS.EQ. 67) OP =' 1/4-X,3/4-Z,3/4-Y'
        IF(IS.EQ. 68) OP =' 1/4+X,1/4-Z,1/4+Y'
        IF(IS.EQ. 69) OP =' 3/4+Z,3/4+Y,1/4-X'
        IF(IS.EQ. 70) OP =' 1/4+Z,1/4-Y,1/4+X'
        IF(IS.EQ. 71) OP =' 3/4-Z,1/4+Y,3/4+X'
        IF(IS.EQ. 72) OP =' 1/4-Z,3/4-Y,3/4-X'
        IF(IS.EQ. 73) OP =' 1/4-X,3/4-Y,3/4-Z'
        IF(IS.EQ. 74) OP =' 1/4+X,1/4+Y,1/4-Z'
        IF(IS.EQ. 75) OP =' 3/4+X,1/4-Y,3/4+Z'
        IF(IS.EQ. 76) OP =' 3/4-X,3/4+Y,1/4+Z'
        IF(IS.EQ. 77) OP =' 1/4-Z,3/4-X,3/4-Y'
        IF(IS.EQ. 78) OP =' 3/4-Z,3/4+X,1/4+Y'
        IF(IS.EQ. 79) OP =' 1/4+Z,1/4+X,1/4-Y'
        IF(IS.EQ. 80) OP =' 3/4+Z,1/4-X,3/4+Y'
        IF(IS.EQ. 81) OP =' 1/4-Y,3/4-Z,3/4-X'
        IF(IS.EQ. 82) OP =' 3/4+Y,1/4-Z,3/4+X'
        IF(IS.EQ. 83) OP =' 3/4-Y,3/4+Z,1/4+X'
        IF(IS.EQ. 84) OP =' 1/4+Y,1/4+Z,1/4-X'
        IF(IS.EQ. 85) OP =' 1/2-Y,1/2-X,Z'
        IF(IS.EQ. 86) OP =' Y,1/2+X,1/2+Z'
        IF(IS.EQ. 87) OP =' -Y,X,-Z'
        IF(IS.EQ. 88) OP =' 1/2+Y,-X,1/2-Z'
        IF(IS.EQ. 89) OP =' 1/2-X,1/2-Z,Y'
        IF(IS.EQ. 90) OP =' 1/2+X,-Z,1/2-Y'
        IF(IS.EQ. 91) OP =' X,1/2+Z,1/2+Y'
        IF(IS.EQ. 92) OP =' -X,Z,-Y'
        IF(IS.EQ. 93) OP =' 1/2-Z,1/2-Y,X'
        IF(IS.EQ. 94) OP =' -Z,Y,-X'
        IF(IS.EQ. 95) OP =' 1/2+Z,-Y,1/2-X'
        IF(IS.EQ. 96) OP =' Z,1/2+Y,1/2+X'
        IF(IS.EQ. 97) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 98) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 99) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.100) OP =' X,-Y,-Z'
        IF(IS.EQ.101) OP =' 1/2+Z,X,1/2+Y'
        IF(IS.EQ.102) OP =' Z,-X,-Y'
        IF(IS.EQ.103) OP =' 1/2-Z,1/2-X,Y'
        IF(IS.EQ.104) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ.105) OP =' 1/2+Y,Z,1/2+X'
        IF(IS.EQ.106) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ.107) OP =' Y,-Z,-X'
        IF(IS.EQ.108) OP =' 1/2-Y,1/2-Z,X'
        IF(IS.EQ.109) OP =' 1/4+Y,1/4+X,1/4-Z'
        IF(IS.EQ.110) OP =' 3/4-Y,1/4-X,3/4-Z'
        IF(IS.EQ.111) OP =' 3/4+Y,3/4-X,1/4+Z'
        IF(IS.EQ.112) OP =' 1/4-Y,3/4+X,3/4+Z'
        IF(IS.EQ.113) OP =' 1/4+X,1/4+Z,1/4-Y'
        IF(IS.EQ.114) OP =' 1/4-X,3/4+Z,3/4+Y'
        IF(IS.EQ.115) OP =' 3/4-X,1/4-Z,3/4-Y'
        IF(IS.EQ.116) OP =' 3/4+X,3/4-Z,1/4+Y'
        IF(IS.EQ.117) OP =' 1/4+Z,1/4+Y,1/4-X'
        IF(IS.EQ.118) OP =' 3/4+Z,3/4-Y,1/4+X'
        IF(IS.EQ.119) OP =' 1/4-Z,3/4+Y,3/4+X'
        IF(IS.EQ.120) OP =' 3/4-Z,1/4-Y,3/4-X'
        IF(IS.EQ.121) OP =' 3/4-X,1/4-Y,3/4-Z'
        IF(IS.EQ.122) OP =' 3/4+X,3/4+Y,1/4-Z'
        IF(IS.EQ.123) OP =' 1/4+X,3/4-Y,3/4+Z'
        IF(IS.EQ.124) OP =' 1/4-X,1/4+Y,1/4+Z'
        IF(IS.EQ.125) OP =' 3/4-Z,1/4-X,3/4-Y'
        IF(IS.EQ.126) OP =' 1/4-Z,1/4+X,1/4+Y'
        IF(IS.EQ.127) OP =' 3/4+Z,3/4+X,1/4-Y'
        IF(IS.EQ.128) OP =' 1/4+Z,3/4-X,3/4+Y'
        IF(IS.EQ.129) OP =' 3/4-Y,1/4-Z,3/4-X'
        IF(IS.EQ.130) OP =' 1/4+Y,3/4-Z,3/4+X'
        IF(IS.EQ.131) OP =' 1/4-Y,1/4+Z,1/4+X'
        IF(IS.EQ.132) OP =' 3/4+Y,3/4+Z,1/4-X'
        IF(IS.EQ.133) OP =' -Y,-X,Z'
        IF(IS.EQ.134) OP =' 1/2+Y,X,1/2+Z'
        IF(IS.EQ.135) OP =' 1/2-Y,1/2+X,-Z'
        IF(IS.EQ.136) OP =' Y,1/2-X,1/2-Z'
        IF(IS.EQ.137) OP =' -X,-Z,Y'
        IF(IS.EQ.138) OP =' X,1/2-Z,1/2-Y'
        IF(IS.EQ.139) OP =' 1/2+X,Z,1/2+Y'
        IF(IS.EQ.140) OP =' 1/2-X,1/2+Z,-Y'
        IF(IS.EQ.141) OP =' -Z,-Y,X'
        IF(IS.EQ.142) OP =' 1/2-Z,1/2+Y,-X'
        IF(IS.EQ.143) OP =' Z,1/2-Y,1/2-X'
        IF(IS.EQ.144) OP =' 1/2+Z,Y,1/2+X'
        IF(IS.EQ.145) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.146) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.147) OP =' -X,Y,-Z'
        IF(IS.EQ.148) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ.149) OP =' 1/2+Z,1/2+X,Y'
        IF(IS.EQ.150) OP =' Z,1/2-X,1/2-Y'
        IF(IS.EQ.151) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.152) OP =' -Z,X,-Y'
        IF(IS.EQ.153) OP =' 1/2+Y,1/2+Z,X'
        IF(IS.EQ.154) OP =' -Y,Z,-X'
        IF(IS.EQ.155) OP =' Y,1/2-Z,1/2-X'
        IF(IS.EQ.156) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ.157) OP =' 1/4+Y,3/4+X,3/4-Z'
        IF(IS.EQ.158) OP =' 3/4-Y,3/4-X,1/4-Z'
        IF(IS.EQ.159) OP =' 3/4+Y,1/4-X,3/4+Z'
        IF(IS.EQ.160) OP =' 1/4-Y,1/4+X,1/4+Z'
        IF(IS.EQ.161) OP =' 1/4+X,3/4+Z,3/4-Y'
        IF(IS.EQ.162) OP =' 1/4-X,1/4+Z,1/4+Y'
        IF(IS.EQ.163) OP =' 3/4-X,3/4-Z,1/4-Y'
        IF(IS.EQ.164) OP =' 3/4+X,1/4-Z,3/4+Y'
        IF(IS.EQ.165) OP =' 1/4+Z,3/4+Y,3/4-X'
        IF(IS.EQ.166) OP =' 3/4+Z,1/4-Y,3/4+X'
        IF(IS.EQ.167) OP =' 1/4-Z,1/4+Y,1/4+X'
        IF(IS.EQ.168) OP =' 3/4-Z,3/4-Y,1/4-X'
        IF(IS.EQ.169) OP =' 3/4-X,3/4-Y,1/4-Z'
        IF(IS.EQ.170) OP =' 3/4+X,1/4+Y,3/4-Z'
        IF(IS.EQ.171) OP =' 1/4+X,1/4-Y,1/4+Z'
        IF(IS.EQ.172) OP =' 1/4-X,3/4+Y,3/4+Z'
        IF(IS.EQ.173) OP =' 3/4-Z,3/4-X,1/4-Y'
        IF(IS.EQ.174) OP =' 1/4-Z,3/4+X,3/4+Y'
        IF(IS.EQ.175) OP =' 3/4+Z,1/4+X,3/4-Y'
        IF(IS.EQ.176) OP =' 1/4+Z,1/4-X,1/4+Y'
        IF(IS.EQ.177) OP =' 3/4-Y,3/4-Z,1/4-X'
        IF(IS.EQ.178) OP =' 1/4+Y,1/4-Z,1/4+X'
        IF(IS.EQ.179) OP =' 1/4-Y,3/4+Z,3/4+X'
        IF(IS.EQ.180) OP =' 3/4+Y,1/4+Z,3/4-X'
        IF(IS.EQ.181) OP =' -Y,1/2-X,1/2+Z'
        IF(IS.EQ.182) OP =' 1/2+Y,1/2+X,Z'
        IF(IS.EQ.183) OP =' 1/2-Y,X,1/2-Z'
        IF(IS.EQ.184) OP =' Y,-X,-Z'
        IF(IS.EQ.185) OP =' -X,1/2-Z,1/2+Y'
        IF(IS.EQ.186) OP =' X,-Z,-Y'
        IF(IS.EQ.187) OP =' 1/2+X,1/2+Z,Y'
        IF(IS.EQ.188) OP =' 1/2-X,Z,1/2-Y'
        IF(IS.EQ.189) OP =' -Z,1/2-Y,1/2+X'
        IF(IS.EQ.190) OP =' 1/2-Z,Y,1/2-X'
        IF(IS.EQ.191) OP =' Z,-Y,-X'
        IF(IS.EQ.192) OP =' 1/2+Z,1/2+Y,X'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_43(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.248) THEN
        NO_TAB  =  228
        NS_TAB  =  192
        SG_TAB1 = 'F 41/d -3 2/c'
        SG_TAB2 = 'Fd-3c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' 1/2+Z,-X,1/2-Y'
        IF(IS.EQ.  7) OP =' -Z,1/2-X,1/2+Y'
        IF(IS.EQ.  8) OP =' 1/2-Z,1/2+X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' 1/2-Y,1/2+Z,-X'
        IF(IS.EQ. 11) OP =' 1/2+Y,-Z,1/2-X'
        IF(IS.EQ. 12) OP =' -Y,1/2-Z,1/2+X'
        IF(IS.EQ. 13) OP =' 3/4+Y,1/4+X,3/4-Z'
        IF(IS.EQ. 14) OP =' 1/4-Y,1/4-X,1/4-Z'
        IF(IS.EQ. 15) OP =' 1/4+Y,3/4-X,3/4+Z'
        IF(IS.EQ. 16) OP =' 3/4-Y,3/4+X,1/4+Z'
        IF(IS.EQ. 17) OP =' 3/4+X,1/4+Z,3/4-Y'
        IF(IS.EQ. 18) OP =' 3/4-X,3/4+Z,1/4+Y'
        IF(IS.EQ. 19) OP =' 1/4-X,1/4-Z,1/4-Y'
        IF(IS.EQ. 20) OP =' 1/4+X,3/4-Z,3/4+Y'
        IF(IS.EQ. 21) OP =' 3/4+Z,1/4+Y,3/4-X'
        IF(IS.EQ. 22) OP =' 1/4+Z,3/4-Y,3/4+X'
        IF(IS.EQ. 23) OP =' 3/4-Z,3/4+Y,1/4+X'
        IF(IS.EQ. 24) OP =' 1/4-Z,1/4-Y,1/4-X'
        IF(IS.EQ. 25) OP =' 3/4-X,3/4-Y,3/4-Z'
        IF(IS.EQ. 26) OP =' 3/4+X,1/4+Y,1/4-Z'
        IF(IS.EQ. 27) OP =' 1/4+X,1/4-Y,3/4+Z'
        IF(IS.EQ. 28) OP =' 1/4-X,3/4+Y,1/4+Z'
        IF(IS.EQ. 29) OP =' 3/4-Z,3/4-X,3/4-Y'
        IF(IS.EQ. 30) OP =' 1/4-Z,3/4+X,1/4+Y'
        IF(IS.EQ. 31) OP =' 3/4+Z,1/4+X,1/4-Y'
        IF(IS.EQ. 32) OP =' 1/4+Z,1/4-X,3/4+Y'
        IF(IS.EQ. 33) OP =' 3/4-Y,3/4-Z,3/4-X'
        IF(IS.EQ. 34) OP =' 1/4+Y,1/4-Z,3/4+X'
        IF(IS.EQ. 35) OP =' 1/4-Y,3/4+Z,1/4+X'
        IF(IS.EQ. 36) OP =' 3/4+Y,1/4+Z,1/4-X'
        IF(IS.EQ. 37) OP =' -Y,1/2-X,Z'
        IF(IS.EQ. 38) OP =' 1/2+Y,1/2+X,1/2+Z'
        IF(IS.EQ. 39) OP =' 1/2-Y,X,-Z'
        IF(IS.EQ. 40) OP =' Y,-X,1/2-Z'
        IF(IS.EQ. 41) OP =' -X,1/2-Z,Y'
        IF(IS.EQ. 42) OP =' X,-Z,1/2-Y'
        IF(IS.EQ. 43) OP =' 1/2+X,1/2+Z,1/2+Y'
        IF(IS.EQ. 44) OP =' 1/2-X,Z,-Y'
        IF(IS.EQ. 45) OP =' -Z,1/2-Y,X'
        IF(IS.EQ. 46) OP =' 1/2-Z,Y,-X'
        IF(IS.EQ. 47) OP =' Z,-Y,1/2-X'
        IF(IS.EQ. 48) OP =' 1/2+Z,1/2+Y,1/2+X'
        IF(IS.EQ. 49) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 50) OP =' -X,-Y,Z'
        IF(IS.EQ. 51) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 52) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 53) OP =' Z,1/2+X,1/2+Y'
        IF(IS.EQ. 54) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ. 55) OP =' -Z,-X,Y'
        IF(IS.EQ. 56) OP =' 1/2-Z,X,1/2-Y'
        IF(IS.EQ. 57) OP =' Y,1/2+Z,1/2+X'
        IF(IS.EQ. 58) OP =' 1/2-Y,Z,1/2-X'
        IF(IS.EQ. 59) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 60) OP =' -Y,-Z,X'
        IF(IS.EQ. 61) OP =' 3/4+Y,3/4+X,1/4-Z'
        IF(IS.EQ. 62) OP =' 1/4-Y,3/4-X,3/4-Z'
        IF(IS.EQ. 63) OP =' 1/4+Y,1/4-X,1/4+Z'
        IF(IS.EQ. 64) OP =' 3/4-Y,1/4+X,3/4+Z'
        IF(IS.EQ. 65) OP =' 3/4+X,3/4+Z,1/4-Y'
        IF(IS.EQ. 66) OP =' 3/4-X,1/4+Z,3/4+Y'
        IF(IS.EQ. 67) OP =' 1/4-X,3/4-Z,3/4-Y'
        IF(IS.EQ. 68) OP =' 1/4+X,1/4-Z,1/4+Y'
        IF(IS.EQ. 69) OP =' 3/4+Z,3/4+Y,1/4-X'
        IF(IS.EQ. 70) OP =' 1/4+Z,1/4-Y,1/4+X'
        IF(IS.EQ. 71) OP =' 3/4-Z,1/4+Y,3/4+X'
        IF(IS.EQ. 72) OP =' 1/4-Z,3/4-Y,3/4-X'
        IF(IS.EQ. 73) OP =' 3/4-X,1/4-Y,1/4-Z'
        IF(IS.EQ. 74) OP =' 3/4+X,3/4+Y,3/4-Z'
        IF(IS.EQ. 75) OP =' 1/4+X,3/4-Y,1/4+Z'
        IF(IS.EQ. 76) OP =' 1/4-X,1/4+Y,3/4+Z'
        IF(IS.EQ. 77) OP =' 3/4-Z,1/4-X,1/4-Y'
        IF(IS.EQ. 78) OP =' 1/4-Z,1/4+X,3/4+Y'
        IF(IS.EQ. 79) OP =' 3/4+Z,3/4+X,3/4-Y'
        IF(IS.EQ. 80) OP =' 1/4+Z,3/4-X,1/4+Y'
        IF(IS.EQ. 81) OP =' 3/4-Y,1/4-Z,1/4-X'
        IF(IS.EQ. 82) OP =' 1/4+Y,3/4-Z,1/4+X'
        IF(IS.EQ. 83) OP =' 1/4-Y,1/4+Z,3/4+X'
        IF(IS.EQ. 84) OP =' 3/4+Y,3/4+Z,3/4-X'
        IF(IS.EQ. 85) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ. 86) OP =' 1/2+Y,X,Z'
        IF(IS.EQ. 87) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 88) OP =' Y,1/2-X,-Z'
        IF(IS.EQ. 89) OP =' -X,-Z,1/2+Y'
        IF(IS.EQ. 90) OP =' X,1/2-Z,-Y'
        IF(IS.EQ. 91) OP =' 1/2+X,Z,Y'
        IF(IS.EQ. 92) OP =' 1/2-X,1/2+Z,1/2-Y'
        IF(IS.EQ. 93) OP =' -Z,-Y,1/2+X'
        IF(IS.EQ. 94) OP =' 1/2-Z,1/2+Y,1/2-X'
        IF(IS.EQ. 95) OP =' Z,1/2-Y,-X'
        IF(IS.EQ. 96) OP =' 1/2+Z,Y,X'
        IF(IS.EQ. 97) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 98) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 99) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.100) OP =' X,-Y,-Z'
        IF(IS.EQ.101) OP =' 1/2+Z,X,1/2+Y'
        IF(IS.EQ.102) OP =' Z,-X,-Y'
        IF(IS.EQ.103) OP =' 1/2-Z,1/2-X,Y'
        IF(IS.EQ.104) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ.105) OP =' 1/2+Y,Z,1/2+X'
        IF(IS.EQ.106) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ.107) OP =' Y,-Z,-X'
        IF(IS.EQ.108) OP =' 1/2-Y,1/2-Z,X'
        IF(IS.EQ.109) OP =' 1/4+Y,1/4+X,1/4-Z'
        IF(IS.EQ.110) OP =' 3/4-Y,1/4-X,3/4-Z'
        IF(IS.EQ.111) OP =' 3/4+Y,3/4-X,1/4+Z'
        IF(IS.EQ.112) OP =' 1/4-Y,3/4+X,3/4+Z'
        IF(IS.EQ.113) OP =' 1/4+X,1/4+Z,1/4-Y'
        IF(IS.EQ.114) OP =' 1/4-X,3/4+Z,3/4+Y'
        IF(IS.EQ.115) OP =' 3/4-X,1/4-Z,3/4-Y'
        IF(IS.EQ.116) OP =' 3/4+X,3/4-Z,1/4+Y'
        IF(IS.EQ.117) OP =' 1/4+Z,1/4+Y,1/4-X'
        IF(IS.EQ.118) OP =' 3/4+Z,3/4-Y,1/4+X'
        IF(IS.EQ.119) OP =' 1/4-Z,3/4+Y,3/4+X'
        IF(IS.EQ.120) OP =' 3/4-Z,1/4-Y,3/4-X'
        IF(IS.EQ.121) OP =' 1/4-X,3/4-Y,1/4-Z'
        IF(IS.EQ.122) OP =' 1/4+X,1/4+Y,3/4-Z'
        IF(IS.EQ.123) OP =' 3/4+X,1/4-Y,1/4+Z'
        IF(IS.EQ.124) OP =' 3/4-X,3/4+Y,3/4+Z'
        IF(IS.EQ.125) OP =' 1/4-Z,3/4-X,1/4-Y'
        IF(IS.EQ.126) OP =' 3/4-Z,3/4+X,3/4+Y'
        IF(IS.EQ.127) OP =' 1/4+Z,1/4+X,3/4-Y'
        IF(IS.EQ.128) OP =' 3/4+Z,1/4-X,1/4+Y'
        IF(IS.EQ.129) OP =' 1/4-Y,3/4-Z,1/4-X'
        IF(IS.EQ.130) OP =' 3/4+Y,1/4-Z,1/4+X'
        IF(IS.EQ.131) OP =' 3/4-Y,3/4+Z,3/4+X'
        IF(IS.EQ.132) OP =' 1/4+Y,1/4+Z,3/4-X'
        IF(IS.EQ.133) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ.134) OP =' Y,1/2+X,Z'
        IF(IS.EQ.135) OP =' -Y,X,1/2-Z'
        IF(IS.EQ.136) OP =' 1/2+Y,-X,-Z'
        IF(IS.EQ.137) OP =' 1/2-X,1/2-Z,1/2+Y'
        IF(IS.EQ.138) OP =' 1/2+X,-Z,-Y'
        IF(IS.EQ.139) OP =' X,1/2+Z,Y'
        IF(IS.EQ.140) OP =' -X,Z,1/2-Y'
        IF(IS.EQ.141) OP =' 1/2-Z,1/2-Y,1/2+X'
        IF(IS.EQ.142) OP =' -Z,Y,1/2-X'
        IF(IS.EQ.143) OP =' 1/2+Z,-Y,-X'
        IF(IS.EQ.144) OP =' Z,1/2+Y,X'
        IF(IS.EQ.145) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.146) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.147) OP =' -X,Y,-Z'
        IF(IS.EQ.148) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ.149) OP =' 1/2+Z,1/2+X,Y'
        IF(IS.EQ.150) OP =' Z,1/2-X,1/2-Y'
        IF(IS.EQ.151) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.152) OP =' -Z,X,-Y'
        IF(IS.EQ.153) OP =' 1/2+Y,1/2+Z,X'
        IF(IS.EQ.154) OP =' -Y,Z,-X'
        IF(IS.EQ.155) OP =' Y,1/2-Z,1/2-X'
        IF(IS.EQ.156) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ.157) OP =' 1/4+Y,3/4+X,3/4-Z'
        IF(IS.EQ.158) OP =' 3/4-Y,3/4-X,1/4-Z'
        IF(IS.EQ.159) OP =' 3/4+Y,1/4-X,3/4+Z'
        IF(IS.EQ.160) OP =' 1/4-Y,1/4+X,1/4+Z'
        IF(IS.EQ.161) OP =' 1/4+X,3/4+Z,3/4-Y'
        IF(IS.EQ.162) OP =' 1/4-X,1/4+Z,1/4+Y'
        IF(IS.EQ.163) OP =' 3/4-X,3/4-Z,1/4-Y'
        IF(IS.EQ.164) OP =' 3/4+X,1/4-Z,3/4+Y'
        IF(IS.EQ.165) OP =' 1/4+Z,3/4+Y,3/4-X'
        IF(IS.EQ.166) OP =' 3/4+Z,1/4-Y,3/4+X'
        IF(IS.EQ.167) OP =' 1/4-Z,1/4+Y,1/4+X'
        IF(IS.EQ.168) OP =' 3/4-Z,3/4-Y,1/4-X'
        IF(IS.EQ.169) OP =' 1/4-X,1/4-Y,3/4-Z'
        IF(IS.EQ.170) OP =' 1/4+X,3/4+Y,1/4-Z'
        IF(IS.EQ.171) OP =' 3/4+X,3/4-Y,3/4+Z'
        IF(IS.EQ.172) OP =' 3/4-X,1/4+Y,1/4+Z'
        IF(IS.EQ.173) OP =' 1/4-Z,1/4-X,3/4-Y'
        IF(IS.EQ.174) OP =' 3/4-Z,1/4+X,1/4+Y'
        IF(IS.EQ.175) OP =' 1/4+Z,3/4+X,1/4-Y'
        IF(IS.EQ.176) OP =' 3/4+Z,3/4-X,3/4+Y'
        IF(IS.EQ.177) OP =' 1/4-Y,1/4-Z,3/4-X'
        IF(IS.EQ.178) OP =' 3/4+Y,3/4-Z,3/4+X'
        IF(IS.EQ.179) OP =' 3/4-Y,1/4+Z,1/4+X'
        IF(IS.EQ.180) OP =' 1/4+Y,3/4+Z,1/4-X'
        IF(IS.EQ.181) OP =' 1/2-Y,-X,Z'
        IF(IS.EQ.182) OP =' Y,X,1/2+Z'
        IF(IS.EQ.183) OP =' -Y,1/2+X,-Z'
        IF(IS.EQ.184) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ.185) OP =' 1/2-X,-Z,Y'
        IF(IS.EQ.186) OP =' 1/2+X,1/2-Z,1/2-Y'
        IF(IS.EQ.187) OP =' X,Z,1/2+Y'
        IF(IS.EQ.188) OP =' -X,1/2+Z,-Y'
        IF(IS.EQ.189) OP =' 1/2-Z,-Y,X'
        IF(IS.EQ.190) OP =' -Z,1/2+Y,-X'
        IF(IS.EQ.191) OP =' 1/2+Z,1/2-Y,1/2-X'
        IF(IS.EQ.192) OP =' Z,Y,1/2+X'
        RETURN
      ENDIF
      RETURN
      END
 
      SUBROUTINE GET_SPACE_GROUP_INFO_44(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.249) THEN
        NO_TAB  =  229
        NS_TAB  =   96
        SG_TAB1 = 'I 4/m -3 2/m'
        SG_TAB2 = 'Im-3m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' Y,X,-Z'
        IF(IS.EQ. 14) OP =' -Y,-X,-Z'
        IF(IS.EQ. 15) OP =' Y,-X,Z'
        IF(IS.EQ. 16) OP =' -Y,X,Z'
        IF(IS.EQ. 17) OP =' X,Z,-Y'
        IF(IS.EQ. 18) OP =' -X,Z,Y'
        IF(IS.EQ. 19) OP =' -X,-Z,-Y'
        IF(IS.EQ. 20) OP =' X,-Z,Y'
        IF(IS.EQ. 21) OP =' Z,Y,-X'
        IF(IS.EQ. 22) OP =' Z,-Y,X'
        IF(IS.EQ. 23) OP =' -Z,Y,X'
        IF(IS.EQ. 24) OP =' -Z,-Y,-X'
        IF(IS.EQ. 25) OP =' -X,-Y,-Z'
        IF(IS.EQ. 26) OP =' X,Y,-Z'
        IF(IS.EQ. 27) OP =' X,-Y,Z'
        IF(IS.EQ. 28) OP =' -X,Y,Z'
        IF(IS.EQ. 29) OP =' -Z,-X,-Y'
        IF(IS.EQ. 30) OP =' -Z,X,Y'
        IF(IS.EQ. 31) OP =' Z,X,-Y'
        IF(IS.EQ. 32) OP =' Z,-X,Y'
        IF(IS.EQ. 33) OP =' -Y,-Z,-X'
        IF(IS.EQ. 34) OP =' Y,-Z,X'
        IF(IS.EQ. 35) OP =' -Y,Z,X'
        IF(IS.EQ. 36) OP =' Y,Z,-X'
        IF(IS.EQ. 37) OP =' -Y,-X,Z'
        IF(IS.EQ. 38) OP =' Y,X,Z'
        IF(IS.EQ. 39) OP =' -Y,X,-Z'
        IF(IS.EQ. 40) OP =' Y,-X,-Z'
        IF(IS.EQ. 41) OP =' -X,-Z,Y'
        IF(IS.EQ. 42) OP =' X,-Z,-Y'
        IF(IS.EQ. 43) OP =' X,Z,Y'
        IF(IS.EQ. 44) OP =' -X,Z,-Y'
        IF(IS.EQ. 45) OP =' -Z,-Y,X'
        IF(IS.EQ. 46) OP =' -Z,Y,-X'
        IF(IS.EQ. 47) OP =' Z,-Y,-X'
        IF(IS.EQ. 48) OP =' Z,Y,X'
        IF(IS.EQ. 49) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 50) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 51) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ. 52) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ. 53) OP =' 1/2+Z,1/2+X,1/2+Y'
        IF(IS.EQ. 54) OP =' 1/2+Z,1/2-X,1/2-Y'
        IF(IS.EQ. 55) OP =' 1/2-Z,1/2-X,1/2+Y'
        IF(IS.EQ. 56) OP =' 1/2-Z,1/2+X,1/2-Y'
        IF(IS.EQ. 57) OP =' 1/2+Y,1/2+Z,1/2+X'
        IF(IS.EQ. 58) OP =' 1/2-Y,1/2+Z,1/2-X'
        IF(IS.EQ. 59) OP =' 1/2+Y,1/2-Z,1/2-X'
        IF(IS.EQ. 60) OP =' 1/2-Y,1/2-Z,1/2+X'
        IF(IS.EQ. 61) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ. 62) OP =' 1/2-Y,1/2-X,1/2-Z'
        IF(IS.EQ. 63) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ. 64) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ. 65) OP =' 1/2+X,1/2+Z,1/2-Y'
        IF(IS.EQ. 66) OP =' 1/2-X,1/2+Z,1/2+Y'
        IF(IS.EQ. 67) OP =' 1/2-X,1/2-Z,1/2-Y'
        IF(IS.EQ. 68) OP =' 1/2+X,1/2-Z,1/2+Y'
        IF(IS.EQ. 69) OP =' 1/2+Z,1/2+Y,1/2-X'
        IF(IS.EQ. 70) OP =' 1/2+Z,1/2-Y,1/2+X'
        IF(IS.EQ. 71) OP =' 1/2-Z,1/2+Y,1/2+X'
        IF(IS.EQ. 72) OP =' 1/2-Z,1/2-Y,1/2-X'
        IF(IS.EQ. 73) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 74) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 75) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 76) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ. 77) OP =' 1/2-Z,1/2-X,1/2-Y'
        IF(IS.EQ. 78) OP =' 1/2-Z,1/2+X,1/2+Y'
        IF(IS.EQ. 79) OP =' 1/2+Z,1/2+X,1/2-Y'
        IF(IS.EQ. 80) OP =' 1/2+Z,1/2-X,1/2+Y'
        IF(IS.EQ. 81) OP =' 1/2-Y,1/2-Z,1/2-X'
        IF(IS.EQ. 82) OP =' 1/2+Y,1/2-Z,1/2+X'
        IF(IS.EQ. 83) OP =' 1/2-Y,1/2+Z,1/2+X'
        IF(IS.EQ. 84) OP =' 1/2+Y,1/2+Z,1/2-X'
        IF(IS.EQ. 85) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 86) OP =' 1/2+Y,1/2+X,1/2+Z'
        IF(IS.EQ. 87) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 88) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 89) OP =' 1/2-X,1/2-Z,1/2+Y'
        IF(IS.EQ. 90) OP =' 1/2+X,1/2-Z,1/2-Y'
        IF(IS.EQ. 91) OP =' 1/2+X,1/2+Z,1/2+Y'
        IF(IS.EQ. 92) OP =' 1/2-X,1/2+Z,1/2-Y'
        IF(IS.EQ. 93) OP =' 1/2-Z,1/2-Y,1/2+X'
        IF(IS.EQ. 94) OP =' 1/2-Z,1/2+Y,1/2-X'
        IF(IS.EQ. 95) OP =' 1/2+Z,1/2-Y,1/2-X'
        IF(IS.EQ. 96) OP =' 1/2+Z,1/2+Y,1/2+X'
        RETURN
      ENDIF
      IF(I.EQ.250) THEN
        NO_TAB  =  230
        NS_TAB  =   96
        SG_TAB1 = 'I 41/a -3 2/d'
        SG_TAB2 = 'Ia-3d'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ.  7) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.  8) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 11) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 12) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 13) OP =' 3/4+Y,1/4+X,1/4-Z'
        IF(IS.EQ. 14) OP =' 3/4-Y,3/4-X,3/4-Z'
        IF(IS.EQ. 15) OP =' 1/4+Y,1/4-X,3/4+Z'
        IF(IS.EQ. 16) OP =' 1/4-Y,3/4+X,1/4+Z'
        IF(IS.EQ. 17) OP =' 3/4+X,1/4+Z,1/4-Y'
        IF(IS.EQ. 18) OP =' 1/4-X,3/4+Z,1/4+Y'
        IF(IS.EQ. 19) OP =' 3/4-X,3/4-Z,3/4-Y'
        IF(IS.EQ. 20) OP =' 1/4+X,1/4-Z,3/4+Y'
        IF(IS.EQ. 21) OP =' 3/4+Z,1/4+Y,1/4-X'
        IF(IS.EQ. 22) OP =' 1/4+Z,1/4-Y,3/4+X'
        IF(IS.EQ. 23) OP =' 1/4-Z,3/4+Y,1/4+X'
        IF(IS.EQ. 24) OP =' 3/4-Z,3/4-Y,3/4-X'
        IF(IS.EQ. 25) OP =' -X,-Y,-Z'
        IF(IS.EQ. 26) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ. 27) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ. 28) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ. 29) OP =' -Z,-X,-Y'
        IF(IS.EQ. 30) OP =' 1/2-Z,1/2+X,Y'
        IF(IS.EQ. 31) OP =' 1/2+Z,X,1/2-Y'
        IF(IS.EQ. 32) OP =' Z,1/2-X,1/2+Y'
        IF(IS.EQ. 33) OP =' -Y,-Z,-X'
        IF(IS.EQ. 34) OP =' Y,1/2-Z,1/2+X'
        IF(IS.EQ. 35) OP =' 1/2-Y,1/2+Z,X'
        IF(IS.EQ. 36) OP =' 1/2+Y,Z,1/2-X'
        IF(IS.EQ. 37) OP =' 1/4-Y,3/4-X,3/4+Z'
        IF(IS.EQ. 38) OP =' 1/4+Y,1/4+X,1/4+Z'
        IF(IS.EQ. 39) OP =' 3/4-Y,3/4+X,1/4-Z'
        IF(IS.EQ. 40) OP =' 3/4+Y,1/4-X,3/4-Z'
        IF(IS.EQ. 41) OP =' 1/4-X,3/4-Z,3/4+Y'
        IF(IS.EQ. 42) OP =' 3/4+X,1/4-Z,3/4-Y'
        IF(IS.EQ. 43) OP =' 1/4+X,1/4+Z,1/4+Y'
        IF(IS.EQ. 44) OP =' 3/4-X,3/4+Z,1/4-Y'
        IF(IS.EQ. 45) OP =' 1/4-Z,3/4-Y,3/4+X'
        IF(IS.EQ. 46) OP =' 3/4-Z,3/4+Y,1/4-X'
        IF(IS.EQ. 47) OP =' 3/4+Z,1/4-Y,3/4-X'
        IF(IS.EQ. 48) OP =' 1/4+Z,1/4+Y,1/4+X'
        IF(IS.EQ. 49) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 50) OP =' -X,1/2-Y,Z'
        IF(IS.EQ. 51) OP =' 1/2-X,Y,-Z'
        IF(IS.EQ. 52) OP =' X,-Y,1/2-Z'
        IF(IS.EQ. 53) OP =' 1/2+Z,1/2+X,1/2+Y'
        IF(IS.EQ. 54) OP =' Z,-X,1/2-Y'
        IF(IS.EQ. 55) OP =' -Z,1/2-X,Y'
        IF(IS.EQ. 56) OP =' 1/2-Z,X,-Y'
        IF(IS.EQ. 57) OP =' 1/2+Y,1/2+Z,1/2+X'
        IF(IS.EQ. 58) OP =' 1/2-Y,Z,-X'
        IF(IS.EQ. 59) OP =' Y,-Z,1/2-X'
        IF(IS.EQ. 60) OP =' -Y,1/2-Z,X'
        IF(IS.EQ. 61) OP =' 1/4+Y,3/4+X,3/4-Z'
        IF(IS.EQ. 62) OP =' 1/4-Y,1/4-X,1/4-Z'
        IF(IS.EQ. 63) OP =' 3/4+Y,3/4-X,1/4+Z'
        IF(IS.EQ. 64) OP =' 3/4-Y,1/4+X,3/4+Z'
        IF(IS.EQ. 65) OP =' 1/4+X,3/4+Z,3/4-Y'
        IF(IS.EQ. 66) OP =' 3/4-X,1/4+Z,3/4+Y'
        IF(IS.EQ. 67) OP =' 1/4-X,1/4-Z,1/4-Y'
        IF(IS.EQ. 68) OP =' 3/4+X,3/4-Z,1/4+Y'
        IF(IS.EQ. 69) OP =' 1/4+Z,3/4+Y,3/4-X'
        IF(IS.EQ. 70) OP =' 3/4+Z,3/4-Y,1/4+X'
        IF(IS.EQ. 71) OP =' 3/4-Z,1/4+Y,3/4+X'
        IF(IS.EQ. 72) OP =' 1/4-Z,1/4-Y,1/4-X'
        IF(IS.EQ. 73) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 74) OP =' X,1/2+Y,-Z'
        IF(IS.EQ. 75) OP =' 1/2+X,-Y,Z'
        IF(IS.EQ. 76) OP =' -X,Y,1/2+Z'
        IF(IS.EQ. 77) OP =' 1/2-Z,1/2-X,1/2-Y'
        IF(IS.EQ. 78) OP =' -Z,X,1/2+Y'
        IF(IS.EQ. 79) OP =' Z,1/2+X,-Y'
        IF(IS.EQ. 80) OP =' 1/2+Z,-X,Y'
        IF(IS.EQ. 81) OP =' 1/2-Y,1/2-Z,1/2-X'
        IF(IS.EQ. 82) OP =' 1/2+Y,-Z,X'
        IF(IS.EQ. 83) OP =' -Y,Z,1/2+X'
        IF(IS.EQ. 84) OP =' Y,1/2+Z,-X'
        IF(IS.EQ. 85) OP =' 3/4-Y,1/4-X,1/4+Z'
        IF(IS.EQ. 86) OP =' 3/4+Y,3/4+X,3/4+Z'
        IF(IS.EQ. 87) OP =' 1/4-Y,1/4+X,3/4-Z'
        IF(IS.EQ. 88) OP =' 1/4+Y,3/4-X,1/4-Z'
        IF(IS.EQ. 89) OP =' 3/4-X,1/4-Z,1/4+Y'
        IF(IS.EQ. 90) OP =' 1/4+X,3/4-Z,1/4-Y'
        IF(IS.EQ. 91) OP =' 3/4+X,3/4+Z,3/4+Y'
        IF(IS.EQ. 92) OP =' 1/4-X,1/4+Z,3/4-Y'
        IF(IS.EQ. 93) OP =' 3/4-Z,1/4-Y,1/4+X'
        IF(IS.EQ. 94) OP =' 1/4-Z,1/4+Y,3/4-X'
        IF(IS.EQ. 95) OP =' 1/4+Z,3/4-Y,1/4-X'
        IF(IS.EQ. 96) OP =' 3/4+Z,3/4+Y,3/4+X'
        RETURN
      ENDIF     
      IF(I.EQ.251) THEN
        NO_TAB  = 4005
        NS_TAB  =    4
        SG_TAB1 = 'I 1 2 1'
        SG_TAB2 = 'I121'
        SG_TAB3 = 'I 2'
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,Y,-Z'
        IF(IS.EQ.  3) OP =' X+1/2,Y+1/2,Z+1/2'
        IF(IS.EQ.  4) OP =' -X+1/2,Y+1/2,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.252) THEN
        NO_TAB  = 3005
        NS_TAB  =    4
        SG_TAB1 = 'A 1 2 1'
        SG_TAB2 = 'A121'
        SG_TAB3 = 'A 2'
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,Y,-Z'
        IF(IS.EQ.  3) OP =' X,Y+1/2,Z+1/2'
        IF(IS.EQ.  4) OP =' -X,Y+1/2,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.253) THEN
        NO_TAB  = 9005
        NS_TAB  =    4
        SG_TAB1 = 'A 1 1 2'
        SG_TAB2 = 'A112'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' X,Y+1/2,Z+1/2'
        IF(IS.EQ.  4) OP =' -X,1/2-Y,Z+1/2'
        RETURN
      ENDIF
      IF(I.EQ.254) THEN
        NO_TAB  = 5005
        NS_TAB  =    4
        SG_TAB1 = 'I 1 1 2'
        SG_TAB2 = 'I112'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' X+1/2,Y+1/2,Z+1/2'
        IF(IS.EQ.  4) OP =' 1/2-X,1/2-Y,Z+1/2'
        RETURN
      ENDIF
      IF(I.EQ.255) THEN
        NO_TAB  = 7005
        NS_TAB  =    4
        SG_TAB1 = 'I 2 1 1'
        SG_TAB2 = 'I211'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X,-Y,-Z'
        IF(IS.EQ.  3) OP =' X+1/2,Y+1/2,Z+1/2'
        IF(IS.EQ.  4) OP =' X+1/2,1/2-Y,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.256) THEN
        NO_TAB  = 6005
        NS_TAB  =    4
        SG_TAB1 = 'B 2 1 1'
        SG_TAB2 = 'B211'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X,-Y,-Z'
        IF(IS.EQ.  3) OP =' X+1/2,Y,Z+1/2'
        IF(IS.EQ.  4) OP =' X+1/2,-Y,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.257) THEN
        NO_TAB  = 8005
        NS_TAB  =    4
        SG_TAB1 = 'C 2 1 1'
        SG_TAB2 = 'C211'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X,-Y,-Z'
        IF(IS.EQ.  3) OP =' X+1/2,Y+1/2,Z'
        IF(IS.EQ.  4) OP =' X+1/2,1/2-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ.258) THEN
        NO_TAB  = 2003
        NS_TAB  =    2
        SG_TAB1 = 'P 2 1 1'
        SG_TAB2 = 'P211'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X,-Y,-Z'
        RETURN
      ENDIF 
      IF(I.EQ.259) THEN
        NO_TAB  = 2004
        NS_TAB  =    2
        SG_TAB1 = 'P 21 1 1'
        SG_TAB2 = 'P2111'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X+1/2,-Y,-Z'
        RETURN
      ENDIF
      RETURN
      END

